/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var $e=["exports","require","vs/base/common/lifecycle","vs/base/browser/dom","vs/base/common/event","vs/base/common/platform","vs/base/common/errors","vs/base/common/types","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/async","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/arrays","vs/base/common/strings","vs/nls","vs/base/browser/window","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/browser/browser","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/mouseEvent","vs/base/browser/ui/widget","vs/base/browser/event","vs/base/common/path","vs/base/browser/touch","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/cancellation","vs/base/common/network","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/common/map","vs/base/common/buffer","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/actions","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/range","vs/base/common/scrollable","vs/base/common/hash","vs/base/common/symbols","vs/base/common/objects","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/common/htmlContent","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/browser/iframe","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/assert","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/marked/marked","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/iconLabel/iconLabelHover","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/browser/canIUse","vs/base/common/process","vs/base/common/extpath","vs/base/common/mime","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/markdownRenderer","vs/base/browser/ui/iconLabel/iconLabelHover","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/common/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],we=function(le){for(var t=[],y=0,L=le.length;y<L;y++)t[y]=$e[le[y]];return t};/*! @license DOMPurify 3.0.5 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/3.0.5/LICENSE */const{entries:jt,setPrototypeOf:Ht,isFrozen:ei,getPrototypeOf:ti,getOwnPropertyDescriptor:ii}=Object;let{freeze:it,seal:ht,create:ni}=Object,{apply:Ft,construct:Ot}=typeof Reflect<"u"&&Reflect;Ft||(Ft=function(t,y,L){return t.apply(y,L)}),it||(it=function(t){return t}),ht||(ht=function(t){return t}),Ot||(Ot=function(t,y){return new t(...y)});const si=lt(Array.prototype.forEach),Ut=lt(Array.prototype.pop),$t=lt(Array.prototype.push),Et=lt(String.prototype.toLowerCase),Lt=lt(String.prototype.toString),ri=lt(String.prototype.match),ut=lt(String.prototype.replace),oi=lt(String.prototype.indexOf),li=lt(String.prototype.trim),ot=lt(RegExp.prototype.test),pt=ai(TypeError);function lt(le){return function(t){for(var y=arguments.length,L=new Array(y>1?y-1:0),i=1;i<y;i++)L[i-1]=arguments[i];return Ft(le,t,L)}}function ai(le){return function(){for(var t=arguments.length,y=new Array(t),L=0;L<t;L++)y[L]=arguments[L];return Ot(le,y)}}function je(le,t,y){var L;y=(L=y)!==null&&L!==void 0?L:Et,Ht&&Ht(le,null);let i=t.length;for(;i--;){let U=t[i];if(typeof U=="string"){const D=y(U);D!==U&&(ei(t)||(t[i]=D),U=D)}le[U]=!0}return le}function mt(le){const t=ni(null);for(const[y,L]of jt(le))t[y]=L;return t}function At(le,t){for(;le!==null;){const L=ii(le,t);if(L){if(L.get)return lt(L.get);if(typeof L.value=="function")return lt(L.value)}le=ti(le)}function y(L){return console.warn("fallback value for",L),null}return y}const Wt=it(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),Tt=it(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),Rt=it(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feDropShadow","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feImage","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),hi=it(["animate","color-profile","cursor","discard","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),It=it(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover","mprescripts"]),ui=it(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Vt=it(["#text"]),qt=it(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","nonce","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),Mt=it(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","transform-origin","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),_t=it(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),kt=it(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),ci=ht(/\{\{[\w\W]*|[\w\W]*\}\}/gm),fi=ht(/<%[\w\W]*|[\w\W]*%>/gm),di=ht(/\${[\w\W]*}/gm),gi=ht(/^data-[\-\w.\u00B7-\uFFFF]/),mi=ht(/^aria-[\-\w]+$/),Qt=ht(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|sms|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),bi=ht(/^(?:\w+script|data):/i),$i=ht(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),Kt=ht(/^html$/i);var xt=Object.freeze({__proto__:null,MUSTACHE_EXPR:ci,ERB_EXPR:fi,TMPLIT_EXPR:di,DATA_ATTR:gi,ARIA_ATTR:mi,IS_ALLOWED_URI:Qt,IS_SCRIPT_OR_DATA:bi,ATTR_WHITESPACE:$i,DOCTYPE_NAME:Kt});const pi=()=>typeof window>"u"?null:window,wi=function(t,y){if(typeof t!="object"||typeof t.createPolicy!="function")return null;let L=null;const i="data-tt-policy-suffix";y&&y.hasAttribute(i)&&(L=y.getAttribute(i));const U="dompurify"+(L?"#"+L:"");try{return t.createPolicy(U,{createHTML(D){return D},createScriptURL(D){return D}})}catch{return console.warn("TrustedTypes policy "+U+" could not be created."),null}};function Yt(){let le=arguments.length>0&&arguments[0]!==void 0?arguments[0]:pi();const t=Te=>Yt(Te);if(t.version="3.0.5",t.removed=[],!le||!le.document||le.document.nodeType!==9)return t.isSupported=!1,t;const y=le.document,L=y.currentScript;let{document:i}=le;const{DocumentFragment:U,HTMLTemplateElement:D,Node:A,Element:c,NodeFilter:g,NamedNodeMap:f=le.NamedNodeMap||le.MozNamedAttrMap,HTMLFormElement:T,DOMParser:s,trustedTypes:a}=le,e=c.prototype,h=At(e,"cloneNode"),l=At(e,"nextSibling"),m=At(e,"childNodes"),n=At(e,"parentNode");if(typeof D=="function"){const Te=i.createElement("template");Te.content&&Te.content.ownerDocument&&(i=Te.content.ownerDocument)}let r,b="";const{implementation:u,createNodeIterator:o,createDocumentFragment:N,getElementsByTagName:z}=i,{importNode:R}=y;let d={};t.isSupported=typeof jt=="function"&&typeof n=="function"&&u&&u.createHTMLDocument!==void 0;const{MUSTACHE_EXPR:E,ERB_EXPR:B,TMPLIT_EXPR:H,DATA_ATTR:x,ARIA_ATTR:C,IS_SCRIPT_OR_DATA:F,ATTR_WHITESPACE:Q}=xt;let{IS_ALLOWED_URI:te}=xt,re=null;const fe=je({},[...Wt,...Tt,...Rt,...It,...Vt]);let ie=null;const oe=je({},[...qt,...Mt,..._t,...kt]);let be=Object.seal(Object.create(null,{tagNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},attributeNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},allowCustomizedBuiltInElements:{writable:!0,configurable:!1,enumerable:!0,value:!1}})),Se=null,Le=null,Fe=!0,de=!0,ne=!1,ce=!0,X=!1,q=!1,G=!1,P=!1,V=!1,p=!1,W=!1,J=!0,M=!1;const $="user-content-";let w=!0,I=!1,v={},O=null;const k=je({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]);let S=null;const j=je({},["audio","video","img","source","image","track"]);let K=null;const ee=je({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),se="http://www.w3.org/1998/Math/MathML",ge="http://www.w3.org/2000/svg",pe="http://www.w3.org/1999/xhtml";let Pe=pe,Ae=!1,De=null;const Ie=je({},[se,ge,pe],Lt);let Oe;const _e=["application/xhtml+xml","text/html"],He="text/html";let Me,Qe=null;const Z=i.createElement("form"),he=function(ue){return ue instanceof RegExp||ue instanceof Function},ve=function(ue){if(!(Qe&&Qe===ue)){if((!ue||typeof ue!="object")&&(ue={}),ue=mt(ue),Oe=_e.indexOf(ue.PARSER_MEDIA_TYPE)===-1?Oe=He:Oe=ue.PARSER_MEDIA_TYPE,Me=Oe==="application/xhtml+xml"?Lt:Et,re="ALLOWED_TAGS"in ue?je({},ue.ALLOWED_TAGS,Me):fe,ie="ALLOWED_ATTR"in ue?je({},ue.ALLOWED_ATTR,Me):oe,De="ALLOWED_NAMESPACES"in ue?je({},ue.ALLOWED_NAMESPACES,Lt):Ie,K="ADD_URI_SAFE_ATTR"in ue?je(mt(ee),ue.ADD_URI_SAFE_ATTR,Me):ee,S="ADD_DATA_URI_TAGS"in ue?je(mt(j),ue.ADD_DATA_URI_TAGS,Me):j,O="FORBID_CONTENTS"in ue?je({},ue.FORBID_CONTENTS,Me):k,Se="FORBID_TAGS"in ue?je({},ue.FORBID_TAGS,Me):{},Le="FORBID_ATTR"in ue?je({},ue.FORBID_ATTR,Me):{},v="USE_PROFILES"in ue?ue.USE_PROFILES:!1,Fe=ue.ALLOW_ARIA_ATTR!==!1,de=ue.ALLOW_DATA_ATTR!==!1,ne=ue.ALLOW_UNKNOWN_PROTOCOLS||!1,ce=ue.ALLOW_SELF_CLOSE_IN_ATTR!==!1,X=ue.SAFE_FOR_TEMPLATES||!1,q=ue.WHOLE_DOCUMENT||!1,V=ue.RETURN_DOM||!1,p=ue.RETURN_DOM_FRAGMENT||!1,W=ue.RETURN_TRUSTED_TYPE||!1,P=ue.FORCE_BODY||!1,J=ue.SANITIZE_DOM!==!1,M=ue.SANITIZE_NAMED_PROPS||!1,w=ue.KEEP_CONTENT!==!1,I=ue.IN_PLACE||!1,te=ue.ALLOWED_URI_REGEXP||Qt,Pe=ue.NAMESPACE||pe,be=ue.CUSTOM_ELEMENT_HANDLING||{},ue.CUSTOM_ELEMENT_HANDLING&&he(ue.CUSTOM_ELEMENT_HANDLING.tagNameCheck)&&(be.tagNameCheck=ue.CUSTOM_ELEMENT_HANDLING.tagNameCheck),ue.CUSTOM_ELEMENT_HANDLING&&he(ue.CUSTOM_ELEMENT_HANDLING.attributeNameCheck)&&(be.attributeNameCheck=ue.CUSTOM_ELEMENT_HANDLING.attributeNameCheck),ue.CUSTOM_ELEMENT_HANDLING&&typeof ue.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements=="boolean"&&(be.allowCustomizedBuiltInElements=ue.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements),X&&(de=!1),p&&(V=!0),v&&(re=je({},[...Vt]),ie=[],v.html===!0&&(je(re,Wt),je(ie,qt)),v.svg===!0&&(je(re,Tt),je(ie,Mt),je(ie,kt)),v.svgFilters===!0&&(je(re,Rt),je(ie,Mt),je(ie,kt)),v.mathMl===!0&&(je(re,It),je(ie,_t),je(ie,kt))),ue.ADD_TAGS&&(re===fe&&(re=mt(re)),je(re,ue.ADD_TAGS,Me)),ue.ADD_ATTR&&(ie===oe&&(ie=mt(ie)),je(ie,ue.ADD_ATTR,Me)),ue.ADD_URI_SAFE_ATTR&&je(K,ue.ADD_URI_SAFE_ATTR,Me),ue.FORBID_CONTENTS&&(O===k&&(O=mt(O)),je(O,ue.FORBID_CONTENTS,Me)),w&&(re["#text"]=!0),q&&je(re,["html","head","body"]),re.table&&(je(re,["tbody"]),delete Se.tbody),ue.TRUSTED_TYPES_POLICY){if(typeof ue.TRUSTED_TYPES_POLICY.createHTML!="function")throw pt('TRUSTED_TYPES_POLICY configuration option must provide a "createHTML" hook.');if(typeof ue.TRUSTED_TYPES_POLICY.createScriptURL!="function")throw pt('TRUSTED_TYPES_POLICY configuration option must provide a "createScriptURL" hook.');r=ue.TRUSTED_TYPES_POLICY,b=r.createHTML("")}else r===void 0&&(r=wi(a,L)),r!==null&&typeof b=="string"&&(b=r.createHTML(""));it&&it(ue),Qe=ue}},Ee=je({},["mi","mo","mn","ms","mtext"]),Ce=je({},["foreignobject","desc","title","annotation-xml"]),Be=je({},["title","style","font","a","script"]),Ue=je({},Tt);je(Ue,Rt),je(Ue,hi);const Ze=je({},It);je(Ze,ui);const Je=function(ue){let ke=n(ue);(!ke||!ke.tagName)&&(ke={namespaceURI:Pe,tagName:"template"});const Ne=Et(ue.tagName),We=Et(ke.tagName);return De[ue.namespaceURI]?ue.namespaceURI===ge?ke.namespaceURI===pe?Ne==="svg":ke.namespaceURI===se?Ne==="svg"&&(We==="annotation-xml"||Ee[We]):!!Ue[Ne]:ue.namespaceURI===se?ke.namespaceURI===pe?Ne==="math":ke.namespaceURI===ge?Ne==="math"&&Ce[We]:!!Ze[Ne]:ue.namespaceURI===pe?ke.namespaceURI===ge&&!Ce[We]||ke.namespaceURI===se&&!Ee[We]?!1:!Ze[Ne]&&(Be[Ne]||!Ue[Ne]):!!(Oe==="application/xhtml+xml"&&De[ue.namespaceURI]):!1},Ke=function(ue){$t(t.removed,{element:ue});try{ue.parentNode.removeChild(ue)}catch{ue.remove()}},Ve=function(ue,ke){try{$t(t.removed,{attribute:ke.getAttributeNode(ue),from:ke})}catch{$t(t.removed,{attribute:null,from:ke})}if(ke.removeAttribute(ue),ue==="is"&&!ie[ue])if(V||p)try{Ke(ke)}catch{}else try{ke.setAttribute(ue,"")}catch{}},tt=function(ue){let ke,Ne;if(P)ue="<remove></remove>"+ue;else{const rt=ri(ue,/^[\r\n\t ]+/);Ne=rt&&rt[0]}Oe==="application/xhtml+xml"&&Pe===pe&&(ue='<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>'+ue+"</body></html>");const We=r?r.createHTML(ue):ue;if(Pe===pe)try{ke=new s().parseFromString(We,Oe)}catch{}if(!ke||!ke.documentElement){ke=u.createDocument(Pe,"template",null);try{ke.documentElement.innerHTML=Ae?b:We}catch{}}const et=ke.body||ke.documentElement;return ue&&Ne&&et.insertBefore(i.createTextNode(Ne),et.childNodes[0]||null),Pe===pe?z.call(ke,q?"html":"body")[0]:q?ke.documentElement:et},nt=function(ue){return o.call(ue.ownerDocument||ue,ue,g.SHOW_ELEMENT|g.SHOW_COMMENT|g.SHOW_TEXT,null,!1)},dt=function(ue){return ue instanceof T&&(typeof ue.nodeName!="string"||typeof ue.textContent!="string"||typeof ue.removeChild!="function"||!(ue.attributes instanceof f)||typeof ue.removeAttribute!="function"||typeof ue.setAttribute!="function"||typeof ue.namespaceURI!="string"||typeof ue.insertBefore!="function"||typeof ue.hasChildNodes!="function")},ct=function(ue){return typeof A=="object"?ue instanceof A:ue&&typeof ue=="object"&&typeof ue.nodeType=="number"&&typeof ue.nodeName=="string"},ft=function(ue,ke,Ne){d[ue]&&si(d[ue],We=>{We.call(t,ke,Ne,Qe)})},St=function(ue){let ke;if(ft("beforeSanitizeElements",ue,null),dt(ue))return Ke(ue),!0;const Ne=Me(ue.nodeName);if(ft("uponSanitizeElement",ue,{tagName:Ne,allowedTags:re}),ue.hasChildNodes()&&!ct(ue.firstElementChild)&&(!ct(ue.content)||!ct(ue.content.firstElementChild))&&ot(/<[/\w]/g,ue.innerHTML)&&ot(/<[/\w]/g,ue.textContent))return Ke(ue),!0;if(!re[Ne]||Se[Ne]){if(!Se[Ne]&&gt(Ne)&&(be.tagNameCheck instanceof RegExp&&ot(be.tagNameCheck,Ne)||be.tagNameCheck instanceof Function&&be.tagNameCheck(Ne)))return!1;if(w&&!O[Ne]){const We=n(ue)||ue.parentNode,et=m(ue)||ue.childNodes;if(et&&We){const rt=et.length;for(let xe=rt-1;xe>=0;--xe)We.insertBefore(h(et[xe],!0),l(ue))}}return Ke(ue),!0}return ue instanceof c&&!Je(ue)||(Ne==="noscript"||Ne==="noembed"||Ne==="noframes")&&ot(/<\/no(script|embed|frames)/i,ue.innerHTML)?(Ke(ue),!0):(X&&ue.nodeType===3&&(ke=ue.textContent,ke=ut(ke,E," "),ke=ut(ke,B," "),ke=ut(ke,H," "),ue.textContent!==ke&&($t(t.removed,{element:ue.cloneNode()}),ue.textContent=ke)),ft("afterSanitizeElements",ue,null),!1)},Ct=function(ue,ke,Ne){if(J&&(ke==="id"||ke==="name")&&(Ne in i||Ne in Z))return!1;if(!(de&&!Le[ke]&&ot(x,ke))){if(!(Fe&&ot(C,ke))){if(!ie[ke]||Le[ke]){if(!(gt(ue)&&(be.tagNameCheck instanceof RegExp&&ot(be.tagNameCheck,ue)||be.tagNameCheck instanceof Function&&be.tagNameCheck(ue))&&(be.attributeNameCheck instanceof RegExp&&ot(be.attributeNameCheck,ke)||be.attributeNameCheck instanceof Function&&be.attributeNameCheck(ke))||ke==="is"&&be.allowCustomizedBuiltInElements&&(be.tagNameCheck instanceof RegExp&&ot(be.tagNameCheck,Ne)||be.tagNameCheck instanceof Function&&be.tagNameCheck(Ne))))return!1}else if(!K[ke]){if(!ot(te,ut(Ne,Q,""))){if(!((ke==="src"||ke==="xlink:href"||ke==="href")&&ue!=="script"&&oi(Ne,"data:")===0&&S[ue])){if(!(ne&&!ot(F,ut(Ne,Q,"")))){if(Ne)return!1}}}}}}return!0},gt=function(ue){return ue.indexOf("-")>0},wt=function(ue){let ke,Ne,We,et;ft("beforeSanitizeAttributes",ue,null);const{attributes:rt}=ue;if(!rt)return;const xe={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:ie};for(et=rt.length;et--;){ke=rt[et];const{name:at,namespaceURI:vt}=ke;if(Ne=at==="value"?ke.value:li(ke.value),We=Me(at),xe.attrName=We,xe.attrValue=Ne,xe.keepAttr=!0,xe.forceKeepAttr=void 0,ft("uponSanitizeAttribute",ue,xe),Ne=xe.attrValue,xe.forceKeepAttr||(Ve(at,ue),!xe.keepAttr))continue;if(!ce&&ot(/\/>/i,Ne)){Ve(at,ue);continue}X&&(Ne=ut(Ne,E," "),Ne=ut(Ne,B," "),Ne=ut(Ne,H," "));const Dt=Me(ue.nodeName);if(Ct(Dt,We,Ne)){if(M&&(We==="id"||We==="name")&&(Ve(at,ue),Ne=$+Ne),r&&typeof a=="object"&&typeof a.getAttributeType=="function"&&!vt)switch(a.getAttributeType(Dt,We)){case"TrustedHTML":{Ne=r.createHTML(Ne);break}case"TrustedScriptURL":{Ne=r.createScriptURL(Ne);break}}try{vt?ue.setAttributeNS(vt,at,Ne):ue.setAttribute(at,Ne),Ut(t.removed)}catch{}}}ft("afterSanitizeAttributes",ue,null)},Pt=function Te(ue){let ke;const Ne=nt(ue);for(ft("beforeSanitizeShadowDOM",ue,null);ke=Ne.nextNode();)ft("uponSanitizeShadowNode",ke,null),!St(ke)&&(ke.content instanceof U&&Te(ke.content),wt(ke));ft("afterSanitizeShadowDOM",ue,null)};return t.sanitize=function(Te){let ue=arguments.length>1&&arguments[1]!==void 0?arguments[1]:{},ke,Ne,We,et;if(Ae=!Te,Ae&&(Te="<!-->"),typeof Te!="string"&&!ct(Te))if(typeof Te.toString=="function"){if(Te=Te.toString(),typeof Te!="string")throw pt("dirty is not a string, aborting")}else throw pt("toString is not a function");if(!t.isSupported)return Te;if(G||ve(ue),t.removed=[],typeof Te=="string"&&(I=!1),I){if(Te.nodeName){const at=Me(Te.nodeName);if(!re[at]||Se[at])throw pt("root node is forbidden and cannot be sanitized in-place")}}else if(Te instanceof A)ke=tt("<!---->"),Ne=ke.ownerDocument.importNode(Te,!0),Ne.nodeType===1&&Ne.nodeName==="BODY"||Ne.nodeName==="HTML"?ke=Ne:ke.appendChild(Ne);else{if(!V&&!X&&!q&&Te.indexOf("<")===-1)return r&&W?r.createHTML(Te):Te;if(ke=tt(Te),!ke)return V?null:W?b:""}ke&&P&&Ke(ke.firstChild);const rt=nt(I?Te:ke);for(;We=rt.nextNode();)St(We)||(We.content instanceof U&&Pt(We.content),wt(We));if(I)return Te;if(V){if(p)for(et=N.call(ke.ownerDocument);ke.firstChild;)et.appendChild(ke.firstChild);else et=ke;return(ie.shadowroot||ie.shadowrootmode)&&(et=R.call(y,et,!0)),et}let xe=q?ke.outerHTML:ke.innerHTML;return q&&re["!doctype"]&&ke.ownerDocument&&ke.ownerDocument.doctype&&ke.ownerDocument.doctype.name&&ot(Kt,ke.ownerDocument.doctype.name)&&(xe="<!DOCTYPE "+ke.ownerDocument.doctype.name+`>
`+xe),X&&(xe=ut(xe,E," "),xe=ut(xe,B," "),xe=ut(xe,H," ")),r&&W?r.createHTML(xe):xe},t.setConfig=function(Te){ve(Te),G=!0},t.clearConfig=function(){Qe=null,G=!1},t.isValidAttribute=function(Te,ue,ke){Qe||ve({});const Ne=Me(Te),We=Me(ue);return Ct(Ne,We,ke)},t.addHook=function(Te,ue){typeof ue=="function"&&(d[Te]=d[Te]||[],$t(d[Te],ue))},t.removeHook=function(Te){if(d[Te])return Ut(d[Te])},t.removeHooks=function(Te){d[Te]&&(d[Te]=[])},t.removeAllHooks=function(){d={}},t}var vi=Yt();define("vs/base/browser/dompurify/dompurify",function(){return vi}),define($e[41],we([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tQ=t.$sQ=void 0;class y{constructor(D){this.domNode=D,this.a="",this.b="",this.c="",this.d="",this.e="",this.f="",this.g="",this.h="",this.i="",this.j="",this.k="",this.l="",this.m="",this.n="",this.o="",this.p="",this.q="",this.r="",this.s="",this.t="",this.u="",this.v="",this.w="",this.x="",this.y="",this.z="",this.A=!1,this.B="none",this.C=""}setMaxWidth(D){const A=L(D);this.a!==A&&(this.a=A,this.domNode.style.maxWidth=this.a)}setWidth(D){const A=L(D);this.b!==A&&(this.b=A,this.domNode.style.width=this.b)}setHeight(D){const A=L(D);this.c!==A&&(this.c=A,this.domNode.style.height=this.c)}setTop(D){const A=L(D);this.d!==A&&(this.d=A,this.domNode.style.top=this.d)}setLeft(D){const A=L(D);this.e!==A&&(this.e=A,this.domNode.style.left=this.e)}setBottom(D){const A=L(D);this.f!==A&&(this.f=A,this.domNode.style.bottom=this.f)}setRight(D){const A=L(D);this.g!==A&&(this.g=A,this.domNode.style.right=this.g)}setPaddingTop(D){const A=L(D);this.h!==A&&(this.h=A,this.domNode.style.paddingTop=this.h)}setPaddingLeft(D){const A=L(D);this.i!==A&&(this.i=A,this.domNode.style.paddingLeft=this.i)}setPaddingBottom(D){const A=L(D);this.j!==A&&(this.j=A,this.domNode.style.paddingBottom=this.j)}setPaddingRight(D){const A=L(D);this.k!==A&&(this.k=A,this.domNode.style.paddingRight=this.k)}setFontFamily(D){this.l!==D&&(this.l=D,this.domNode.style.fontFamily=this.l)}setFontWeight(D){this.m!==D&&(this.m=D,this.domNode.style.fontWeight=this.m)}setFontSize(D){const A=L(D);this.n!==A&&(this.n=A,this.domNode.style.fontSize=this.n)}setFontStyle(D){this.o!==D&&(this.o=D,this.domNode.style.fontStyle=this.o)}setFontFeatureSettings(D){this.p!==D&&(this.p=D,this.domNode.style.fontFeatureSettings=this.p)}setFontVariationSettings(D){this.q!==D&&(this.q=D,this.domNode.style.fontVariationSettings=this.q)}setTextDecoration(D){this.r!==D&&(this.r=D,this.domNode.style.textDecoration=this.r)}setLineHeight(D){const A=L(D);this.s!==A&&(this.s=A,this.domNode.style.lineHeight=this.s)}setLetterSpacing(D){const A=L(D);this.t!==A&&(this.t=A,this.domNode.style.letterSpacing=this.t)}setClassName(D){this.u!==D&&(this.u=D,this.domNode.className=this.u)}toggleClassName(D,A){this.domNode.classList.toggle(D,A),this.u=this.domNode.className}setDisplay(D){this.v!==D&&(this.v=D,this.domNode.style.display=this.v)}setPosition(D){this.w!==D&&(this.w=D,this.domNode.style.position=this.w)}setVisibility(D){this.x!==D&&(this.x=D,this.domNode.style.visibility=this.x)}setColor(D){this.y!==D&&(this.y=D,this.domNode.style.color=this.y)}setBackgroundColor(D){this.z!==D&&(this.z=D,this.domNode.style.backgroundColor=this.z)}setLayerHinting(D){this.A!==D&&(this.A=D,this.domNode.style.transform=this.A?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(D){this.C!==D&&(this.C=D,this.domNode.style.boxShadow=D)}setContain(D){this.B!==D&&(this.B=D,this.domNode.style.contain=this.B)}setAttribute(D,A){this.domNode.setAttribute(D,A)}removeAttribute(D){this.domNode.removeAttribute(D)}appendChild(D){this.domNode.appendChild(D.domNode)}removeChild(D){this.domNode.removeChild(D.domNode)}}t.$sQ=y;function L(U){return typeof U=="number"?`${U}px`:U}function i(U){return new y(U)}t.$tQ=i}),define($e[69],we([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3Q=t.$2Q=t.$1Q=t.ListDragOverEffect=void 0;var y;(function(U){U[U.Copy=0]="Copy",U[U.Move=1]="Move"})(y||(t.ListDragOverEffect=y={})),t.$1Q={reject(){return{accept:!1}},accept(){return{accept:!0}}};class L extends Error{constructor(D,A){super(`ListError [${D}] ${A}`)}}t.$2Q=L;class i{constructor(){this.c=new WeakMap}getHeight(D){return this.c.get(D)??this.d(D)}setDynamicHeight(D,A){A>0&&this.c.set(D,A)}}t.$3Q=i}),define($e[70],we([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ZQ=void 0;class y{constructor(i){this.a=i}splice(i,U,D){this.a.forEach(A=>A.splice(i,U,D))}}t.$ZQ=y}),define($e[42],we([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yQ=void 0;const y=20;class L{constructor(U,D,A,c,g,f){this.a=Math.round(D),this.b=Math.round(A),this.c=Math.round(U),this.d=c,this.e=g,this.f=f,this.g=0,this.h=!1,this.i=0,this.j=0,this.k=0,this.m()}clone(){return new L(this.c,this.a,this.b,this.d,this.e,this.f)}setVisibleSize(U){const D=Math.round(U);return this.d!==D?(this.d=D,this.m(),!0):!1}setScrollSize(U){const D=Math.round(U);return this.e!==D?(this.e=D,this.m(),!0):!1}setScrollPosition(U){const D=Math.round(U);return this.f!==D?(this.f=D,this.m(),!0):!1}setScrollbarSize(U){this.a=Math.round(U)}setOppositeScrollbarSize(U){this.b=Math.round(U)}static l(U,D,A,c,g){const f=Math.max(0,A-U),T=Math.max(0,f-2*D),s=c>0&&c>A;if(!s)return{computedAvailableSize:Math.round(f),computedIsNeeded:s,computedSliderSize:Math.round(T),computedSliderRatio:0,computedSliderPosition:0};const a=Math.round(Math.max(y,Math.floor(A*T/c))),e=(T-a)/(c-A),h=g*e;return{computedAvailableSize:Math.round(f),computedIsNeeded:s,computedSliderSize:Math.round(a),computedSliderRatio:e,computedSliderPosition:Math.round(h)}}m(){const U=L.l(this.b,this.c,this.d,this.e,this.f);this.g=U.computedAvailableSize,this.h=U.computedIsNeeded,this.i=U.computedSliderSize,this.j=U.computedSliderRatio,this.k=U.computedSliderPosition}getArrowSize(){return this.c}getScrollPosition(){return this.f}getRectangleLargeSize(){return this.g}getRectangleSmallSize(){return this.a}isNeeded(){return this.h}getSliderSize(){return this.i}getSliderPosition(){return this.k}getDesiredScrollPositionFromOffset(U){if(!this.h)return 0;const D=U-this.c-this.i/2;return Math.round(D/this.j)}getDesiredScrollPositionFromOffsetPaged(U){if(!this.h)return 0;const D=U-this.c;let A=this.f;return D<this.k?A-=this.d:A+=this.d,A}getDesiredScrollPositionFromDelta(U){if(!this.h)return 0;const D=this.k+U;return Math.round(D/this.j)}}t.$yQ=L}),define($e[25],we([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$WS=t.$VS=t.$US=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.ObjectTreeElementCollapseState=t.TreeVisibility=void 0;var y;(function(c){c[c.Hidden=0]="Hidden",c[c.Visible=1]="Visible",c[c.Recurse=2]="Recurse"})(y||(t.TreeVisibility=y={}));var L;(function(c){c[c.Expanded=0]="Expanded",c[c.Collapsed=1]="Collapsed",c[c.PreserveOrExpanded=2]="PreserveOrExpanded",c[c.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(L||(t.ObjectTreeElementCollapseState=L={}));var i;(function(c){c[c.Unknown=0]="Unknown",c[c.Twistie=1]="Twistie",c[c.Element=2]="Element",c[c.Filter=3]="Filter"})(i||(t.TreeMouseEventTarget=i={}));var U;(function(c){c[c.Down=0]="Down",c[c.Up=1]="Up"})(U||(t.TreeDragOverBubble=U={})),t.$US={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(c=!1){return{accept:!0,bubble:0,autoExpand:c}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:0}},acceptCopyBubbleDown(c=!1){return{accept:!0,bubble:0,effect:0,autoExpand:c}}};class D extends Error{constructor(g,f){super(`TreeError [${g}] ${f}`)}}t.$VS=D;class A{constructor(g){this.a=g,this.b=new WeakMap}map(g){let f=this.b.get(g);return f||(f=this.a(g),this.b.set(g,f)),f}}t.$WS=A}),define($e[14],we([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$window=t.$sO=void 0,t.$sO=window,t.$window=t.$sO}),define($e[71],we([1,0,14]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$PO=t.$OO=void 0;let L=!1,i=null;function U(g){if(!g.parent||g.parent===g)return null;try{const f=g.location,T=g.parent.location;if(f.origin!=="null"&&T.origin!=="null"&&f.origin!==T.origin)return L=!0,null}catch{return L=!0,null}return g.parent}class D{static getSameOriginWindowChain(){if(!i){i=[];let f=y.$window,T;do T=U(f),T?i.push({window:f,iframeElement:f.frameElement||null}):i.push({window:f,iframeElement:null}),f=T;while(f)}return i.slice(0)}static hasDifferentOriginAncestor(){return i||this.getSameOriginWindowChain(),L}static getPositionOfChildWindowRelativeToAncestorWindow(f,T){if(!T||f===T)return{top:0,left:0};let s=0,a=0;const e=this.getSameOriginWindowChain();for(const h of e){if(s+=h.window.scrollY,a+=h.window.scrollX,h.window===T||!h.iframeElement)break;const l=h.iframeElement.getBoundingClientRect();s+=l.top,a+=l.left}return{top:s,left:a}}}t.$OO=D;async function A(g,f){if(!crypto.subtle)throw new Error("'crypto.subtle' is not available so webviews will not work. This is likely because the editor is not running in a secure context (https://developer.mozilla.org/en-US/docs/Web/Security/Secure_Contexts).");const T=JSON.stringify({parentOrigin:g,salt:f}),a=new TextEncoder().encode(T),e=await crypto.subtle.digest("sha-256",a);return c(e)}t.$PO=A;function c(g){const T=Array.from(new Uint8Array(g)).map(s=>s.toString(16).padStart(2,"0")).join("");return BigInt(`0x${T}`).toString(32).padStart(52,"0")}}),define($e[72],we([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qb=t.$pb=t.$ob=t.$nb=t.$mb=t.$lb=t.$kb=t.$jb=t.$ib=t.$hb=t.$gb=t.$fb=t.$eb=void 0;function y(h,l,m){const n=L(h,l);if(n!==-1)return h[n]}t.$eb=y;function L(h,l,m=h.length-1){for(let n=m;n>=0;n--){const r=h[n];if(l(r))return n}return-1}t.$fb=L;function i(h,l){const m=U(h,l);return m===-1?void 0:h[m]}t.$gb=i;function U(h,l,m=0,n=h.length){let r=m,b=n;for(;r<b;){const u=Math.floor((r+b)/2);l(h[u])?r=u+1:b=u}return r-1}t.$hb=U;function D(h,l){const m=A(h,l);return m===h.length?void 0:h[m]}t.$ib=D;function A(h,l,m=0,n=h.length){let r=m,b=n;for(;r<b;){const u=Math.floor((r+b)/2);l(h[u])?b=u:r=u+1}return r}t.$jb=A;function c(h,l,m=0,n=h.length){const r=A(h,l,m,n);return r===h.length?-1:r}t.$kb=c;class g{static{this.assertInvariants=!1}constructor(l){this.e=l,this.c=0}findLastMonotonous(l){if(g.assertInvariants){if(this.d){for(const n of this.e)if(this.d(n)&&!l(n))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=l}const m=U(this.e,l,this.c);return this.c=m+1,m===-1?void 0:this.e[m]}}t.$lb=g;function f(h,l){if(h.length===0)return;let m=h[0];for(let n=1;n<h.length;n++){const r=h[n];l(r,m)>0&&(m=r)}return m}t.$mb=f;function T(h,l){if(h.length===0)return;let m=h[0];for(let n=1;n<h.length;n++){const r=h[n];l(r,m)>=0&&(m=r)}return m}t.$nb=T;function s(h,l){return f(h,(m,n)=>-l(m,n))}t.$ob=s;function a(h,l){if(h.length===0)return-1;let m=0;for(let n=1;n<h.length;n++){const r=h[n];l(r,h[m])>0&&(m=n)}return m}t.$pb=a;function e(h,l){for(const m of h){const n=l(m);if(n!==void 0)return n}}t.$qb=e}),define($e[73],we([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$M=t.$L=t.$K=t.$J=void 0;function y(D,A){const c=Object.create(null);for(const g of D){const f=A(g);let T=c[f];T||(T=c[f]=[]),T.push(g)}return c}t.$J=y;function L(D,A){const c=[],g=[];for(const f of D)A.has(f)||c.push(f);for(const f of A)D.has(f)||g.push(f);return{removed:c,added:g}}t.$K=L;function i(D,A){const c=[],g=[];for(const[f,T]of D)A.has(f)||c.push(T);for(const[f,T]of A)D.has(f)||g.push(T);return{removed:c,added:g}}t.$L=i;function U(D,A){const c=new Set;for(const g of A)D.has(g)&&c.add(g);return c}t.$M=U}),define($e[74],we([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2s=t.$1s=t.$Zs=t.$Ys=void 0;function y(A,c){const g=Math.pow(10,c);return Math.round(A*g)/g}class L{constructor(c,g,f,T=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,c))|0,this.g=Math.min(255,Math.max(0,g))|0,this.b=Math.min(255,Math.max(0,f))|0,this.a=y(Math.max(Math.min(1,T),0),3)}static equals(c,g){return c.r===g.r&&c.g===g.g&&c.b===g.b&&c.a===g.a}}t.$Ys=L;class i{constructor(c,g,f,T){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,c),0)|0,this.s=y(Math.max(Math.min(1,g),0),3),this.l=y(Math.max(Math.min(1,f),0),3),this.a=y(Math.max(Math.min(1,T),0),3)}static equals(c,g){return c.h===g.h&&c.s===g.s&&c.l===g.l&&c.a===g.a}static fromRGBA(c){const g=c.r/255,f=c.g/255,T=c.b/255,s=c.a,a=Math.max(g,f,T),e=Math.min(g,f,T);let h=0,l=0;const m=(e+a)/2,n=a-e;if(n>0){switch(l=Math.min(m<=.5?n/(2*m):n/(2-2*m),1),a){case g:h=(f-T)/n+(f<T?6:0);break;case f:h=(T-g)/n+2;break;case T:h=(g-f)/n+4;break}h*=60,h=Math.round(h)}return new i(h,l,m,s)}static i(c,g,f){return f<0&&(f+=1),f>1&&(f-=1),f<1/6?c+(g-c)*6*f:f<1/2?g:f<2/3?c+(g-c)*(2/3-f)*6:c}static toRGBA(c){const g=c.h/360,{s:f,l:T,a:s}=c;let a,e,h;if(f===0)a=e=h=T;else{const l=T<.5?T*(1+f):T+f-T*f,m=2*T-l;a=i.i(m,l,g+1/3),e=i.i(m,l,g),h=i.i(m,l,g-1/3)}return new L(Math.round(a*255),Math.round(e*255),Math.round(h*255),s)}}t.$Zs=i;class U{constructor(c,g,f,T){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,c),0)|0,this.s=y(Math.max(Math.min(1,g),0),3),this.v=y(Math.max(Math.min(1,f),0),3),this.a=y(Math.max(Math.min(1,T),0),3)}static equals(c,g){return c.h===g.h&&c.s===g.s&&c.v===g.v&&c.a===g.a}static fromRGBA(c){const g=c.r/255,f=c.g/255,T=c.b/255,s=Math.max(g,f,T),a=Math.min(g,f,T),e=s-a,h=s===0?0:e/s;let l;return e===0?l=0:s===g?l=((f-T)/e%6+6)%6:s===f?l=(T-g)/e+2:l=(g-f)/e+4,new U(Math.round(l*60),h,s,c.a)}static toRGBA(c){const{h:g,s:f,v:T,a:s}=c,a=T*f,e=a*(1-Math.abs(g/60%2-1)),h=T-a;let[l,m,n]=[0,0,0];return g<60?(l=a,m=e):g<120?(l=e,m=a):g<180?(m=a,n=e):g<240?(m=e,n=a):g<300?(l=e,n=a):g<=360&&(l=a,n=e),l=Math.round((l+h)*255),m=Math.round((m+h)*255),n=Math.round((n+h)*255),new L(l,m,n,s)}}t.$1s=U;class D{static fromHex(c){return D.Format.CSS.parseHex(c)||D.red}static equals(c,g){return!c&&!g?!0:!c||!g?!1:c.equals(g)}get hsla(){return this.i?this.i:i.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:U.fromRGBA(this.rgba)}constructor(c){if(c)if(c instanceof L)this.rgba=c;else if(c instanceof i)this.i=c,this.rgba=i.toRGBA(c);else if(c instanceof U)this.j=c,this.rgba=U.toRGBA(c);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(c){return!!c&&L.equals(this.rgba,c.rgba)&&i.equals(this.hsla,c.hsla)&&U.equals(this.hsva,c.hsva)}getRelativeLuminance(){const c=D.k(this.rgba.r),g=D.k(this.rgba.g),f=D.k(this.rgba.b),T=.2126*c+.7152*g+.0722*f;return y(T,4)}static k(c){const g=c/255;return g<=.03928?g/12.92:Math.pow((g+.055)/1.055,2.4)}getContrastRatio(c){const g=this.getRelativeLuminance(),f=c.getRelativeLuminance();return g>f?(g+.05)/(f+.05):(f+.05)/(g+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(c){const g=this.getRelativeLuminance(),f=c.getRelativeLuminance();return g>f}isDarkerThan(c){const g=this.getRelativeLuminance(),f=c.getRelativeLuminance();return g<f}lighten(c){return new D(new i(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*c,this.hsla.a))}darken(c){return new D(new i(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*c,this.hsla.a))}transparent(c){const{r:g,g:f,b:T,a:s}=this.rgba;return new D(new L(g,f,T,s*c))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new D(new L(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(c){const g=c.rgba,f=this.rgba.a,T=g.a,s=f+T*(1-f);if(s<1e-6)return D.transparent;const a=this.rgba.r*f/s+g.r*T*(1-f)/s,e=this.rgba.g*f/s+g.g*T*(1-f)/s,h=this.rgba.b*f/s+g.b*T*(1-f)/s;return new D(new L(a,e,h,s))}makeOpaque(c){if(this.isOpaque()||c.rgba.a!==1)return this;const{r:g,g:f,b:T,a:s}=this.rgba;return new D(new L(c.rgba.r-s*(c.rgba.r-g),c.rgba.g-s*(c.rgba.g-f),c.rgba.b-s*(c.rgba.b-T),1))}flatten(...c){const g=c.reduceRight((f,T)=>D.o(T,f));return D.o(this,g)}static o(c,g){const f=1-c.rgba.a;return new D(new L(f*g.rgba.r+c.rgba.a*c.rgba.r,f*g.rgba.g+c.rgba.a*c.rgba.g,f*g.rgba.b+c.rgba.a*c.rgba.b))}toString(){return this.u||(this.u=D.Format.CSS.format(this)),this.u}static getLighterColor(c,g,f){if(c.isLighterThan(g))return c;f=f||.5;const T=c.getRelativeLuminance(),s=g.getRelativeLuminance();return f=f*(s-T)/s,c.lighten(f)}static getDarkerColor(c,g,f){if(c.isDarkerThan(g))return c;f=f||.5;const T=c.getRelativeLuminance(),s=g.getRelativeLuminance();return f=f*(T-s)/T,c.darken(f)}static{this.white=new D(new L(255,255,255,1))}static{this.black=new D(new L(0,0,0,1))}static{this.red=new D(new L(255,0,0,1))}static{this.blue=new D(new L(0,0,255,1))}static{this.green=new D(new L(0,255,0,1))}static{this.cyan=new D(new L(0,255,255,1))}static{this.lightgrey=new D(new L(211,211,211,1))}static{this.transparent=new D(new L(0,0,0,0))}}t.$2s=D,function(A){let c;(function(g){let f;(function(T){function s(o){return o.rgba.a===1?`rgb(${o.rgba.r}, ${o.rgba.g}, ${o.rgba.b})`:A.Format.CSS.formatRGBA(o)}T.formatRGB=s;function a(o){return`rgba(${o.rgba.r}, ${o.rgba.g}, ${o.rgba.b}, ${+o.rgba.a.toFixed(2)})`}T.formatRGBA=a;function e(o){return o.hsla.a===1?`hsl(${o.hsla.h}, ${(o.hsla.s*100).toFixed(2)}%, ${(o.hsla.l*100).toFixed(2)}%)`:A.Format.CSS.formatHSLA(o)}T.formatHSL=e;function h(o){return`hsla(${o.hsla.h}, ${(o.hsla.s*100).toFixed(2)}%, ${(o.hsla.l*100).toFixed(2)}%, ${o.hsla.a.toFixed(2)})`}T.formatHSLA=h;function l(o){const N=o.toString(16);return N.length!==2?"0"+N:N}function m(o){return`#${l(o.rgba.r)}${l(o.rgba.g)}${l(o.rgba.b)}`}T.formatHex=m;function n(o,N=!1){return N&&o.rgba.a===1?A.Format.CSS.formatHex(o):`#${l(o.rgba.r)}${l(o.rgba.g)}${l(o.rgba.b)}${l(Math.round(o.rgba.a*255))}`}T.formatHexA=n;function r(o){return o.isOpaque()?A.Format.CSS.formatHex(o):A.Format.CSS.formatRGBA(o)}T.format=r;function b(o){const N=o.length;if(N===0||o.charCodeAt(0)!==35)return null;if(N===7){const z=16*u(o.charCodeAt(1))+u(o.charCodeAt(2)),R=16*u(o.charCodeAt(3))+u(o.charCodeAt(4)),d=16*u(o.charCodeAt(5))+u(o.charCodeAt(6));return new A(new L(z,R,d,1))}if(N===9){const z=16*u(o.charCodeAt(1))+u(o.charCodeAt(2)),R=16*u(o.charCodeAt(3))+u(o.charCodeAt(4)),d=16*u(o.charCodeAt(5))+u(o.charCodeAt(6)),E=16*u(o.charCodeAt(7))+u(o.charCodeAt(8));return new A(new L(z,R,d,E/255))}if(N===4){const z=u(o.charCodeAt(1)),R=u(o.charCodeAt(2)),d=u(o.charCodeAt(3));return new A(new L(16*z+z,16*R+R,16*d+d))}if(N===5){const z=u(o.charCodeAt(1)),R=u(o.charCodeAt(2)),d=u(o.charCodeAt(3)),E=u(o.charCodeAt(4));return new A(new L(16*z+z,16*R+R,16*d+d,(16*E+E)/255))}return null}T.parseHex=b;function u(o){switch(o){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(f=g.CSS||(g.CSS={}))})(c=A.Format||(A.Format={}))}(D||(t.$2s=D={}))}),define($e[26],we([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nh=t.$mh=t.$lh=void 0;function y(D){return(A,c,g)=>{let f=null,T=null;if(typeof g.value=="function"?(f="value",T=g.value):typeof g.get=="function"&&(f="get",T=g.get),!T)throw new Error("not supported");g[f]=D(T,c)}}function L(D,A,c){let g=null,f=null;if(typeof c.value=="function"?(g="value",f=c.value,f.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof c.get=="function"&&(g="get",f=c.get),!f)throw new Error("not supported");const T=`$memoize$${A}`;c[g]=function(...s){return this.hasOwnProperty(T)||Object.defineProperty(this,T,{configurable:!1,enumerable:!1,writable:!1,value:f.apply(this,s)}),this[T]}}t.$lh=L;function i(D,A,c){return y((g,f)=>{const T=`$debounce$${f}`,s=`$debounce$result$${f}`;return function(...a){this[s]||(this[s]=c?c():void 0),clearTimeout(this[T]),A&&(this[s]=A(this[s],...a),a=[this[s]]),this[T]=setTimeout(()=>{g.apply(this,a),this[s]=c?c():void 0},D)}})}t.$mh=i;function U(D,A,c){return y((g,f)=>{const T=`$throttle$timer$${f}`,s=`$throttle$result$${f}`,a=`$throttle$lastRun$${f}`,e=`$throttle$pending$${f}`;return function(...h){if(this[s]||(this[s]=c?c():void 0),(this[a]===null||this[a]===void 0)&&(this[a]=-Number.MAX_VALUE),A&&(this[s]=A(this[s],...h)),this[e])return;const l=this[a]+D;l<=Date.now()?(this[a]=Date.now(),g.apply(this,[this[s]]),this[s]=c?c():void 0):(this[e]=!0,this[T]=setTimeout(()=>{this[e]=!1,this[a]=Date.now(),g.apply(this,[this[s]]),this[s]=c?c():void 0},l-Date.now()))}})}t.$nh=U}),define($e[75],we([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$As=void 0;class y{constructor(i,U,D,A){this.originalStart=i,this.originalLength=U,this.modifiedStart=D,this.modifiedLength=A}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$As=y}),define($e[6],we([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bb=t.$ab=t.$_=t.$$=t.$0=t.$9=t.$8=t.$7=t.$6=t.$5=t.$4=t.$3=t.$2=t.$1=t.$Z=t.$Y=t.setUnexpectedErrorHandler=t.$W=t.$V=void 0;class y{constructor(){this.b=[],this.a=function(o){setTimeout(()=>{throw o.stack?r.isErrorNoTelemetry(o)?new r(o.message+`

`+o.stack):new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.b.push(o),()=>{this.d(o)}}c(o){this.b.forEach(N=>{N(o)})}d(o){this.b.splice(this.b.indexOf(o),1)}setUnexpectedErrorHandler(o){this.a=o}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(o){this.a(o),this.c(o)}onUnexpectedExternalError(o){this.a(o)}}t.$V=y,t.$W=new y;function L(u){t.$W.setUnexpectedErrorHandler(u)}t.setUnexpectedErrorHandler=L;function i(u){if(!u||typeof u!="object")return!1;const o=u;return o.code==="EPIPE"&&o.syscall?.toUpperCase()==="WRITE"}t.$Y=i;function U(u){g(u)||t.$W.onUnexpectedError(u)}t.$Z=U;function D(u){g(u)||t.$W.onUnexpectedExternalError(u)}t.$1=D;function A(u){if(u instanceof Error){const{name:o,message:N}=u,z=u.stacktrace||u.stack;return{$isError:!0,name:o,message:N,stack:z,noTelemetry:r.isErrorNoTelemetry(u)}}return u}t.$2=A;const c="Canceled";function g(u){return u instanceof f?!0:u instanceof Error&&u.name===c&&u.message===c}t.$3=g;class f extends Error{constructor(){super(c),this.name=this.message}}t.$4=f;function T(){const u=new Error(c);return u.name=u.message,u}t.$5=T;function s(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}t.$6=s;function a(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}t.$7=a;class e extends TypeError{constructor(o){super(o?`${o} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$8=e;function h(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}t.$9=h;class l extends Error{constructor(o){super("NotImplemented"),o&&(this.message=o)}}t.$0=l;class m extends Error{constructor(o){super("NotSupported"),o&&(this.message=o)}}t.$$=m;class n extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$_=n;class r extends Error{constructor(o){super(o),this.name="CodeExpectedError"}static fromError(o){if(o instanceof r)return o;const N=new r;return N.message=o.message,N.stack=o.stack,N}static isErrorNoTelemetry(o){return o.name==="CodeExpectedError"}}t.$ab=r;class b extends Error{constructor(o){super(o||"An unexpected bug occurred."),Object.setPrototypeOf(this,b.prototype)}}t.$bb=b}),define($e[11],we([1,0,6,72]),function(le,t,y,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_b=t.$$b=t.$0b=t.$9b=t.$8b=t.$7b=t.$6b=t.CompareResult=t.$5b=t.$4b=t.$3b=t.$2b=t.$1b=t.$Zb=t.$Yb=t.$Xb=t.$Wb=t.$Vb=t.$Ub=t.$Tb=t.$Sb=t.$Rb=t.$Qb=t.$Pb=t.$Ob=t.$Nb=t.$Mb=t.$Lb=t.$Kb=t.$Jb=t.$Ib=t.$Hb=t.$Gb=t.$Fb=t.top=t.$Db=t.$Cb=t.$Bb=t.$Ab=t.$zb=t.$yb=t.$xb=t.$wb=t.$vb=t.$ub=t.$tb=t.$sb=t.$rb=void 0;function i(M,$=0){return M[M.length-(1+$)]}t.$rb=i;function U(M){if(M.length===0)throw new Error("Invalid tail call");return[M.slice(0,M.length-1),M[M.length-1]]}t.$sb=U;function D(M,$,w=(I,v)=>I===v){if(M===$)return!0;if(!M||!$||M.length!==$.length)return!1;for(let I=0,v=M.length;I<v;I++)if(!w(M[I],$[I]))return!1;return!0}t.$tb=D;function A(M,$){const w=M.length-1;$<w&&(M[$]=M[w]),M.pop()}t.$ub=A;function c(M,$,w){return g(M.length,I=>w(M[I],$))}t.$vb=c;function g(M,$){let w=0,I=M-1;for(;w<=I;){const v=(w+I)/2|0,O=$(v);if(O<0)w=v+1;else if(O>0)I=v-1;else return v}return-(w+1)}t.$wb=g;function f(M,$,w){if(M=M|0,M>=$.length)throw new TypeError("invalid index");const I=$[Math.floor($.length*Math.random())],v=[],O=[],k=[];for(const S of $){const j=w(S,I);j<0?v.push(S):j>0?O.push(S):k.push(S)}return M<v.length?f(M,v,w):M<v.length+k.length?k[0]:f(M-(v.length+k.length),O,w)}t.$xb=f;function T(M,$){const w=[];let I;for(const v of M.slice(0).sort($))!I||$(I[0],v)!==0?(I=[v],w.push(I)):I.push(v);return w}t.$yb=T;function*s(M,$){let w,I;for(const v of M)I!==void 0&&$(I,v)?w.push(v):(w&&(yield w),w=[v]),I=v;w&&(yield w)}t.$zb=s;function a(M,$){for(let w=0;w<=M.length;w++)$(w===0?void 0:M[w-1],w===M.length?void 0:M[w])}t.$Ab=a;function e(M,$){for(let w=0;w<M.length;w++)$(w===0?void 0:M[w-1],M[w],w+1===M.length?void 0:M[w+1])}t.$Bb=e;function h(M,$,w){const I=[];function v(S,j,K){if(j===0&&K.length===0)return;const ee=I[I.length-1];ee&&ee.start+ee.deleteCount===S?(ee.deleteCount+=j,ee.toInsert.push(...K)):I.push({start:S,deleteCount:j,toInsert:K})}let O=0,k=0;for(;;){if(O===M.length){v(O,0,$.slice(k));break}if(k===$.length){v(O,M.length-O,[]);break}const S=M[O],j=$[k],K=w(S,j);K===0?(O+=1,k+=1):K<0?(v(O,1,[]),O+=1):K>0&&(v(O,0,[j]),k+=1)}return I}t.$Cb=h;function l(M,$,w){const I=h(M,$,w),v=[],O=[];for(const k of I)v.push(...M.slice(k.start,k.start+k.deleteCount)),O.push(...k.toInsert);return{removed:v,added:O}}t.$Db=l;function m(M,$,w){if(w===0)return[];const I=M.slice(0,w).sort($);return r(M,$,I,w,M.length),I}t.top=m;function n(M,$,w,I,v){return w===0?Promise.resolve([]):new Promise((O,k)=>{(async()=>{const S=M.length,j=M.slice(0,w).sort($);for(let K=w,ee=Math.min(w+I,S);K<S;K=ee,ee=Math.min(ee+I,S)){if(K>w&&await new Promise(se=>setTimeout(se)),v&&v.isCancellationRequested)throw new y.$4;r(M,$,j,K,ee)}return j})().then(O,k)})}t.$Fb=n;function r(M,$,w,I,v){for(const O=w.length;I<v;I++){const k=M[I];if($(k,w[O-1])<0){w.pop();const S=(0,L.$jb)(w,j=>$(k,j)<0);w.splice(S,0,k)}}}function b(M){return M.filter($=>!!$)}t.$Gb=b;function u(M){let $=0;for(let w=0;w<M.length;w++)M[w]&&(M[$]=M[w],$+=1);M.length=$}t.$Hb=u;function o(M,$,w){M.splice(w,0,M.splice($,1)[0])}t.$Ib=o;function N(M){return!Array.isArray(M)||M.length===0}t.$Jb=N;function z(M){return Array.isArray(M)&&M.length>0}t.$Kb=z;function R(M,$=w=>w){const w=new Set;return M.filter(I=>{const v=$(I);return w.has(v)?!1:(w.add(v),!0)})}t.$Lb=R;function d(M){const $=new Set;return w=>{const I=M(w);return $.has(I)?!1:($.add(I),!0)}}t.$Mb=d;function E(M,$){return M.length>0?M[0]:$}t.$Nb=E;function B(M,$){return M.length>0?M[M.length-1]:$}t.$Ob=B;function H(M,$,w=(I,v)=>I===v){let I=0;for(let v=0,O=Math.min(M.length,$.length);v<O&&w(M[v],$[v]);v++)I++;return I}t.$Pb=H;function x(M){return[].concat(...M)}t.$Qb=x;function C(M,$){let w=typeof $=="number"?M:0;typeof $=="number"?w=M:(w=0,$=M);const I=[];if(w<=$)for(let v=w;v<$;v++)I.push(v);else for(let v=w;v>$;v--)I.push(v);return I}t.$Rb=C;function F(M,$,w){return M.reduce((I,v)=>(I[$(v)]=w?w(v):v,I),Object.create(null))}t.$Sb=F;function Q(M,$){return M.push($),()=>te(M,$)}t.$Tb=Q;function te(M,$){const w=M.indexOf($);if(w>-1)return M.splice(w,1),$}t.$Ub=te;function re(M,$,w){const I=M.slice(0,$),v=M.slice($);return I.concat(w,v)}t.$Vb=re;function fe(M,$){let w;if(typeof $=="number"){let I=$;w=()=>{const v=Math.sin(I++)*179426549;return v-Math.floor(v)}}else w=Math.random;for(let I=M.length-1;I>0;I-=1){const v=Math.floor(w()*(I+1)),O=M[I];M[I]=M[v],M[v]=O}}t.$Wb=fe;function ie(M,$){const w=M.indexOf($);w>-1&&(M.splice(w,1),M.unshift($))}t.$Xb=ie;function oe(M,$){const w=M.indexOf($);w>-1&&(M.splice(w,1),M.push($))}t.$Yb=oe;function be(M,$){for(const w of $)M.push(w)}t.$Zb=be;function Se(M,$){return Array.isArray(M)?M.map($):$(M)}t.$1b=Se;function Le(M){return Array.isArray(M)?M:[M]}t.$2b=Le;function Fe(M){return M[Math.floor(Math.random()*M.length)]}t.$3b=Fe;function de(M,$,w){const I=ce(M,$),v=M.length,O=w.length;M.length=v+O;for(let k=v-1;k>=I;k--)M[k+O]=M[k];for(let k=0;k<O;k++)M[k+I]=w[k]}t.$4b=de;function ne(M,$,w,I){const v=ce(M,$);let O=M.splice(v,w);return O===void 0&&(O=[]),de(M,v,I),O}t.$5b=ne;function ce(M,$){return $<0?Math.max($+M.length,0):Math.min($,M.length)}var X;(function(M){function $(O){return O<0}M.isLessThan=$;function w(O){return O<=0}M.isLessThanOrEqual=w;function I(O){return O>0}M.isGreaterThan=I;function v(O){return O===0}M.isNeitherLessOrGreaterThan=v,M.greaterThan=1,M.lessThan=-1,M.neitherLessOrGreaterThan=0})(X||(t.CompareResult=X={}));function q(M,$){return(w,I)=>$(M(w),M(I))}t.$6b=q;function G(...M){return($,w)=>{for(const I of M){const v=I($,w);if(!X.isNeitherLessOrGreaterThan(v))return v}return X.neitherLessOrGreaterThan}}t.$7b=G;const P=(M,$)=>M-$;t.$8b=P;const V=(M,$)=>(0,t.$8b)(M?1:0,$?1:0);t.$9b=V;function p(M){return($,w)=>-M($,w)}t.$0b=p;class W{constructor($){this.g=$,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile($){let w=this.c;for(;w<this.g.length&&$(this.g[w]);)w++;const I=w===this.c?null:this.g.slice(this.c,w);return this.c=w,I}takeFromEndWhile($){let w=this.d;for(;w>=0&&$(this.g[w]);)w--;const I=w===this.d?null:this.g.slice(w+1,this.d+1);return this.d=w,I}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const $=this.g[this.c];return this.c++,$}removeLast(){const $=this.g[this.d];return this.d--,$}takeCount($){const w=this.g.slice(this.c,this.c+$);return this.c+=$,w}}t.$$b=W;class J{static{this.empty=new J($=>{})}constructor($){this.iterate=$}forEach($){this.iterate(w=>($(w),!0))}toArray(){const $=[];return this.iterate(w=>($.push(w),!0)),$}filter($){return new J(w=>this.iterate(I=>$(I)?w(I):!0))}map($){return new J(w=>this.iterate(I=>w($(I))))}some($){let w=!1;return this.iterate(I=>(w=$(I),!w)),w}findFirst($){let w;return this.iterate(I=>$(I)?(w=I,!1):!0),w}findLast($){let w;return this.iterate(I=>($(I)&&(w=I),!0)),w}findLastMaxBy($){let w,I=!0;return this.iterate(v=>((I||X.isGreaterThan($(v,w)))&&(I=!1,w=v),!0)),w}}t.$_b=J}),define($e[76],we([1,0,6]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6c=t.$5c=t.$4c=t.$3c=t.ok=void 0;function L(c,g){if(!c)throw new Error(g?`Assertion failed (${g})`:"Assertion Failed")}t.ok=L;function i(c,g="Unreachable"){throw new Error(g)}t.$3c=i;function U(c){if(!c)throw new y.$bb("Assertion Failed")}t.$4c=U;function D(c){if(!c()){debugger;c(),(0,y.$Z)(new y.$bb("Assertion Failed"))}}t.$5c=D;function A(c,g){let f=0;for(;f<c.length-1;){const T=c[f],s=c[f+1];if(!g(T,s))return!1;f++}return!0}t.$6c=A}),define($e[43],we([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=void 0;function y(L){const i=this;let U=!1,D;return function(){return U||(U=!0,D=L.apply(i,arguments)),D}}t.$cb=y}),define($e[77],we([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$DM=t.$CM=void 0;class y{constructor(i){this.a=i,this.b=0}nextId(){return this.a+ ++this.b}}t.$CM=y,t.$DM=new y("id#")}),define($e[27],we([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var y;(function(L){function i(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}L.is=i;const U=Object.freeze([]);function D(){return U}L.empty=D;function*A(u){yield u}L.single=A;function c(u){return i(u)?u:A(u)}L.wrap=c;function g(u){return u||U}L.from=g;function*f(u){for(let o=u.length-1;o>=0;o--)yield u[o]}L.reverse=f;function T(u){return!u||u[Symbol.iterator]().next().done===!0}L.isEmpty=T;function s(u){return u[Symbol.iterator]().next().value}L.first=s;function a(u,o){for(const N of u)if(o(N))return!0;return!1}L.some=a;function e(u,o){for(const N of u)if(o(N))return N}L.find=e;function*h(u,o){for(const N of u)o(N)&&(yield N)}L.filter=h;function*l(u,o){let N=0;for(const z of u)yield o(z,N++)}L.map=l;function*m(...u){for(const o of u)for(const N of o)yield N}L.concat=m;function n(u,o,N){let z=N;for(const R of u)z=o(z,R);return z}L.reduce=n;function*r(u,o,N=u.length){for(o<0&&(o+=u.length),N<0?N+=u.length:N>u.length&&(N=u.length);o<N;o++)yield u[o]}L.slice=r;function b(u,o=Number.POSITIVE_INFINITY){const N=[];if(o===0)return[N,u];const z=u[Symbol.iterator]();for(let R=0;R<o;R++){const d=z.next();if(d.done)return[N,L.empty()];N.push(d.value)}return[N,{[Symbol.iterator](){return z}}]}L.consume=b})(y||(t.Iterable=y={}))}),define($e[44],we([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Jq=t.KeyMod=t.KeyCodeUtils=t.$Iq=t.$Hq=t.$Gq=t.$Fq=t.$Eq=t.ScanCode=t.KeyCode=void 0;var y;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(y||(t.KeyCode=y={}));var L;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(L||(t.ScanCode=L={}));class i{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(h,l){this._keyCodeToStr[h]=l,this._strToKeyCode[l.toLowerCase()]=h}keyCodeToStr(h){return this._keyCodeToStr[h]}strToKeyCode(h){return this._strToKeyCode[h.toLowerCase()]||0}}const U=new i,D=new i,A=new i;t.$Eq=new Array(230),t.$Fq={};const c=[],g=Object.create(null),f=Object.create(null);t.$Gq={lowerCaseToEnum:e=>f[e]||0,toEnum:e=>g[e]||0,toString:e=>c[e]||"None"},t.$Hq=[],t.$Iq=[];for(let e=0;e<=193;e++)t.$Hq[e]=-1;for(let e=0;e<=132;e++)t.$Iq[e]=-1;(function(){const e="",h=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],l=[],m=[];for(const n of h){const[r,b,u,o,N,z,R,d,E]=n;if(m[b]||(m[b]=!0,c[b]=u,g[u]=b,f[u.toLowerCase()]=b,r&&(t.$Hq[b]=o,o!==0&&o!==3&&o!==5&&o!==4&&o!==6&&o!==57&&(t.$Iq[o]=b))),!l[o]){if(l[o]=!0,!N)throw new Error(`String representation missing for key code ${o} around scan code ${u}`);U.define(o,N),D.define(o,d||N),A.define(o,E||d||N)}z&&(t.$Eq[z]=o),R&&(t.$Fq[R]=o)}t.$Iq[3]=46})();var T;(function(e){function h(u){return U.keyCodeToStr(u)}e.toString=h;function l(u){return U.strToKeyCode(u)}e.fromString=l;function m(u){return D.keyCodeToStr(u)}e.toUserSettingsUS=m;function n(u){return A.keyCodeToStr(u)}e.toUserSettingsGeneral=n;function r(u){return D.strToKeyCode(u)||A.strToKeyCode(u)}e.fromUserSettings=r;function b(u){if(u>=98&&u<=113)return null;switch(u){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return U.keyCodeToStr(u)}e.toElectronAccelerator=b})(T||(t.KeyCodeUtils=T={}));var s;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(s||(t.KeyMod=s={}));function a(e,h){const l=(h&65535)<<16>>>0;return(e|l)>>>0}t.$Jq=a}),define($e[78],we([1,0,6]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Qq=t.$Pq=t.$Oq=t.$Nq=t.$Mq=t.$Lq=t.$Kq=void 0;var L;(function(T){T[T.CtrlCmd=2048]="CtrlCmd",T[T.Shift=1024]="Shift",T[T.Alt=512]="Alt",T[T.WinCtrl=256]="WinCtrl",T[T.KeyCode=255]="KeyCode"})(L||(L={}));function i(T,s){if(typeof T=="number"){if(T===0)return null;const a=(T&65535)>>>0,e=(T&4294901760)>>>16;return e!==0?new c([U(a,s),U(e,s)]):new c([U(a,s)])}else{const a=[];for(let e=0;e<T.length;e++)a.push(U(T[e],s));return new c(a)}}t.$Kq=i;function U(T,s){const a=!!(T&2048),e=!!(T&256),h=s===2?e:a,l=!!(T&1024),m=!!(T&512),n=s===2?a:e,r=T&255;return new D(h,l,m,n,r)}t.$Lq=U;class D{constructor(s,a,e,h,l){this.ctrlKey=s,this.shiftKey=a,this.altKey=e,this.metaKey=h,this.keyCode=l}equals(s){return s instanceof D&&this.ctrlKey===s.ctrlKey&&this.shiftKey===s.shiftKey&&this.altKey===s.altKey&&this.metaKey===s.metaKey&&this.keyCode===s.keyCode}getHashCode(){const s=this.ctrlKey?"1":"0",a=this.shiftKey?"1":"0",e=this.altKey?"1":"0",h=this.metaKey?"1":"0";return`K${s}${a}${e}${h}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toKeybinding(){return new c([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.$Mq=D;class A{constructor(s,a,e,h,l){this.ctrlKey=s,this.shiftKey=a,this.altKey=e,this.metaKey=h,this.scanCode=l}equals(s){return s instanceof A&&this.ctrlKey===s.ctrlKey&&this.shiftKey===s.shiftKey&&this.altKey===s.altKey&&this.metaKey===s.metaKey&&this.scanCode===s.scanCode}getHashCode(){const s=this.ctrlKey?"1":"0",a=this.shiftKey?"1":"0",e=this.altKey?"1":"0",h=this.metaKey?"1":"0";return`S${s}${a}${e}${h}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.$Nq=A;class c{constructor(s){if(s.length===0)throw(0,y.$6)("chords");this.chords=s}getHashCode(){let s="";for(let a=0,e=this.chords.length;a<e;a++)a!==0&&(s+=";"),s+=this.chords[a].getHashCode();return s}equals(s){if(s===null||this.chords.length!==s.chords.length)return!1;for(let a=0;a<this.chords.length;a++)if(!this.chords[a].equals(s.chords[a]))return!1;return!0}}t.$Oq=c;class g{constructor(s,a,e,h,l,m){this.ctrlKey=s,this.shiftKey=a,this.altKey=e,this.metaKey=h,this.keyLabel=l,this.keyAriaLabel=m}}t.$Pq=g;class f{}t.$Qq=f}),define($e[28],we([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$U=void 0;class y{constructor(i){this.d=i,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(i){this.c=i}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$U=y}),define($e[45],we([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1c=void 0;class y{static{this.Undefined=new y(void 0)}constructor(U){this.element=U,this.next=y.Undefined,this.prev=y.Undefined}}class L{constructor(){this.a=y.Undefined,this.b=y.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===y.Undefined}clear(){let U=this.a;for(;U!==y.Undefined;){const D=U.next;U.prev=y.Undefined,U.next=y.Undefined,U=D}this.a=y.Undefined,this.b=y.Undefined,this.c=0}unshift(U){return this.d(U,!1)}push(U){return this.d(U,!0)}d(U,D){const A=new y(U);if(this.a===y.Undefined)this.a=A,this.b=A;else if(D){const g=this.b;this.b=A,A.prev=g,g.next=A}else{const g=this.a;this.a=A,A.next=g,g.prev=A}this.c+=1;let c=!1;return()=>{c||(c=!0,this.e(A))}}shift(){if(this.a!==y.Undefined){const U=this.a.element;return this.e(this.a),U}}pop(){if(this.b!==y.Undefined){const U=this.b.element;return this.e(this.b),U}}e(U){if(U.prev!==y.Undefined&&U.next!==y.Undefined){const D=U.prev;D.next=U.next,U.next.prev=D}else U.prev===y.Undefined&&U.next===y.Undefined?(this.a=y.Undefined,this.b=y.Undefined):U.next===y.Undefined?(this.b=this.b.prev,this.b.next=y.Undefined):U.prev===y.Undefined&&(this.a=this.a.next,this.a.prev=y.Undefined);this.c-=1}*[Symbol.iterator](){let U=this.a;for(;U!==y.Undefined;)yield U.element,U=U.next}}t.$1c=L}),define($e[32],we([1,0]),function(le,t){"use strict";var y,L,i;Object.defineProperty(t,"__esModule",{value:!0}),t.$Fc=t.$Ec=t.$Dc=t.$Cc=t.$Bc=t.Touch=t.$Ac=t.$zc=t.$yc=t.$xc=t.$wc=void 0;function U(n,r,b){let u=n.get(r);return u===void 0&&(u=b,n.set(r,u)),u}t.$wc=U;function D(n){const r=[];return n.forEach((b,u)=>{r.push(`${u} => ${b}`)}),`Map(${n.size}) {${r.join(", ")}}`}t.$xc=D;function A(n){const r=[];return n.forEach(b=>{r.push(b)}),`Set(${n.size}) {${r.join(", ")}}`}t.$yc=A;class c{constructor(r,b){this.uri=r,this.value=b}}function g(n){return Array.isArray(n)}class f{static{this.a=r=>r.toString()}constructor(r,b){if(this[y]="ResourceMap",r instanceof f)this.b=new Map(r.b),this.c=b??f.a;else if(g(r)){this.b=new Map,this.c=b??f.a;for(const[u,o]of r)this.set(u,o)}else this.b=new Map,this.c=r??f.a}set(r,b){return this.b.set(this.c(r),new c(r,b)),this}get(r){return this.b.get(this.c(r))?.value}has(r){return this.b.has(this.c(r))}get size(){return this.b.size}clear(){this.b.clear()}delete(r){return this.b.delete(this.c(r))}forEach(r,b){typeof b<"u"&&(r=r.bind(b));for(const[u,o]of this.b)r(o.value,o.uri,this)}*values(){for(const r of this.b.values())yield r.value}*keys(){for(const r of this.b.values())yield r.uri}*entries(){for(const r of this.b.values())yield[r.uri,r.value]}*[(y=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.b)yield[r.uri,r.value]}}t.$zc=f;class T{constructor(r,b){this[L]="ResourceSet",!r||typeof r=="function"?this.a=new f(r):(this.a=new f(b),r.forEach(this.add,this))}get size(){return this.a.size}add(r){return this.a.set(r,r),this}clear(){this.a.clear()}delete(r){return this.a.delete(r)}forEach(r,b){this.a.forEach((u,o)=>r.call(b,o,o,this))}has(r){return this.a.has(r)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Ac=T;var s;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(s||(t.Touch=s={}));class a{constructor(){this[i]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(r){return this.a.has(r)}get(r,b=0){const u=this.a.get(r);if(u)return b!==0&&this.j(u,b),u.value}set(r,b,u=0){let o=this.a.get(r);if(o)o.value=b,u!==0&&this.j(o,u);else{switch(o={key:r,value:b,next:void 0,previous:void 0},u){case 0:this.h(o);break;case 1:this.g(o);break;case 2:this.h(o);break;default:this.h(o);break}this.a.set(r,o),this.d++}return this}delete(r){return!!this.remove(r)}remove(r){const b=this.a.get(r);if(b)return this.a.delete(r),this.i(b),this.d--,b.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const r=this.b;return this.a.delete(r.key),this.i(r),this.d--,r.value}forEach(r,b){const u=this.e;let o=this.b;for(;o;){if(b?r.bind(b)(o.value,o.key,this):r(o.value,o.key,this),this.e!==u)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const r=this,b=this.e;let u=this.b;const o={[Symbol.iterator](){return o},next(){if(r.e!==b)throw new Error("LinkedMap got modified during iteration.");if(u){const N={value:u.key,done:!1};return u=u.next,N}else return{value:void 0,done:!0}}};return o}values(){const r=this,b=this.e;let u=this.b;const o={[Symbol.iterator](){return o},next(){if(r.e!==b)throw new Error("LinkedMap got modified during iteration.");if(u){const N={value:u.value,done:!1};return u=u.next,N}else return{value:void 0,done:!0}}};return o}entries(){const r=this,b=this.e;let u=this.b;const o={[Symbol.iterator](){return o},next(){if(r.e!==b)throw new Error("LinkedMap got modified during iteration.");if(u){const N={value:[u.key,u.value],done:!1};return u=u.next,N}else return{value:void 0,done:!0}}};return o}[(i=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(r){if(r>=this.size)return;if(r===0){this.clear();return}let b=this.b,u=this.size;for(;b&&u>r;)this.a.delete(b.key),b=b.next,u--;this.b=b,this.d=u,b&&(b.previous=void 0),this.e++}g(r){if(!this.b&&!this.c)this.c=r;else if(this.b)r.next=this.b,this.b.previous=r;else throw new Error("Invalid list");this.b=r,this.e++}h(r){if(!this.b&&!this.c)this.b=r;else if(this.c)r.previous=this.c,this.c.next=r;else throw new Error("Invalid list");this.c=r,this.e++}i(r){if(r===this.b&&r===this.c)this.b=void 0,this.c=void 0;else if(r===this.b){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this.b=r.next}else if(r===this.c){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this.c=r.previous}else{const b=r.next,u=r.previous;if(!b||!u)throw new Error("Invalid list");b.previous=u,u.next=b}r.next=void 0,r.previous=void 0,this.e++}j(r,b){if(!this.b||!this.c)throw new Error("Invalid list");if(!(b!==1&&b!==2)){if(b===1){if(r===this.b)return;const u=r.next,o=r.previous;r===this.c?(o.next=void 0,this.c=o):(u.previous=o,o.next=u),r.previous=void 0,r.next=this.b,this.b.previous=r,this.b=r,this.e++}else if(b===2){if(r===this.c)return;const u=r.next,o=r.previous;r===this.b?(u.previous=void 0,this.b=u):(u.previous=o,o.next=u),r.next=void 0,r.previous=this.c,this.c.next=r,this.c=r,this.e++}}}toJSON(){const r=[];return this.forEach((b,u)=>{r.push([u,b])}),r}fromJSON(r){this.clear();for(const[b,u]of r)this.set(b,u)}}t.$Bc=a;class e extends a{constructor(r,b=1){super(),this.k=r,this.l=Math.min(Math.max(0,b),1)}get limit(){return this.k}set limit(r){this.k=r,this.m()}get ratio(){return this.l}set ratio(r){this.l=Math.min(Math.max(0,r),1),this.m()}get(r,b=2){return super.get(r,b)}peek(r){return super.get(r,0)}set(r,b){return super.set(r,b,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}t.$Cc=e;class h{constructor(){this.a=new Map}add(r){return this.a.set(r,(this.a.get(r)||0)+1),this}delete(r){let b=this.a.get(r)||0;return b===0?!1:(b--,b===0?this.a.delete(r):this.a.set(r,b),!0)}has(r){return this.a.has(r)}}t.$Dc=h;class l{constructor(r){if(this.a=new Map,this.b=new Map,r)for(const[b,u]of r)this.set(b,u)}clear(){this.a.clear(),this.b.clear()}set(r,b){this.a.set(r,b),this.b.set(b,r)}get(r){return this.a.get(r)}getKey(r){return this.b.get(r)}delete(r){const b=this.a.get(r);return b===void 0?!1:(this.a.delete(r),this.b.delete(b),!0)}forEach(r,b){this.a.forEach((u,o)=>{r.call(b,u,o,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}t.$Ec=l;class m{constructor(){this.a=new Map}add(r,b){let u=this.a.get(r);u||(u=new Set,this.a.set(r,u)),u.add(b)}delete(r,b){const u=this.a.get(r);u&&(u.delete(b),u.size===0&&this.a.delete(r))}forEach(r,b){const u=this.a.get(r);u&&u.forEach(b)}get(r){const b=this.a.get(r);return b||new Set}}t.$Fc=m}),define($e[2],we([1,0,11,73,32,43,27]),function(le,t,y,L,i,U,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Tc=t.$Sc=t.$Rc=t.$Qc=t.$Pc=t.$Oc=t.$Nc=t.$Mc=t.$Lc=t.$Kc=t.$Jc=t.$Ic=t.$Hc=t.$Gc=void 0;const A=!1;let c=null;class g{constructor(){this.b=new Map}static{this.a=0}c(F){let Q=this.b.get(F);return Q||(Q={parent:null,source:null,isSingleton:!1,value:F,idx:g.a++},this.b.set(F,Q)),Q}trackDisposable(F){const Q=this.c(F);Q.source||(Q.source=new Error().stack)}setParent(F,Q){const te=this.c(F);te.parent=Q}markAsDisposed(F){this.b.delete(F)}markAsSingleton(F){this.c(F).isSingleton=!0}f(F,Q){const te=Q.get(F);if(te)return te;const re=F.parent?this.f(this.c(F.parent),Q):F;return Q.set(F,re),re}getTrackedDisposables(){const F=new Map;return[...this.b.entries()].filter(([,te])=>te.source!==null&&!this.f(te,F).isSingleton).flatMap(([te])=>te)}computeLeakingDisposables(F=10,Q){let te;if(Q)te=Q;else{const be=new Map,Se=[...this.b.values()].filter(Fe=>Fe.source!==null&&!this.f(Fe,be).isSingleton);if(Se.length===0)return;const Le=new Set(Se.map(Fe=>Fe.value));if(te=Se.filter(Fe=>!(Fe.parent&&Le.has(Fe.parent))),te.length===0)throw new Error("There are cyclic diposable chains!")}if(!te)return;function re(be){function Se(Fe,de){for(;Fe.length>0&&de.some(ne=>typeof ne=="string"?ne===Fe[0]:Fe[0].match(ne));)Fe.shift()}const Le=be.source.split(`
`).map(Fe=>Fe.trim().replace("at ","")).filter(Fe=>Fe!=="");return Se(Le,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Le.reverse()}const fe=new i.$Fc;for(const be of te){const Se=re(be);for(let Le=0;Le<=Se.length;Le++)fe.add(Se.slice(0,Le).join(`
`),be)}te.sort((0,y.$6b)(be=>be.idx,y.$8b));let ie="",oe=0;for(const be of te.slice(0,F)){oe++;const Se=re(be),Le=[];for(let Fe=0;Fe<Se.length;Fe++){let de=Se[Fe];de=`(shared with ${fe.get(Se.slice(0,Fe+1).join(`
`)).size}/${te.length} leaks) at ${de}`;const ce=fe.get(Se.slice(0,Fe).join(`
`)),X=(0,L.$J)([...ce].map(q=>re(q)[Fe]),q=>q);delete X[Se[Fe]];for(const[q,G]of Object.entries(X))Le.unshift(`    - stacktraces of ${G.length} other leaks continue with ${q}`);Le.unshift(de)}ie+=`


==================== Leaking disposable ${oe}/${te.length}: ${be.value.constructor.name} ====================
${Le.join(`
`)}
============================================================

`}return te.length>F&&(ie+=`


... and ${te.length-F} more leaking disposables

`),{leaks:te,details:ie}}}t.$Gc=g;function f(C){c=C}if(t.$Hc=f,A){const C="__is_disposable_tracked__";f(new class{trackDisposable(F){const Q=new Error("Potentially leaked disposable").stack;setTimeout(()=>{F[C]||console.log(Q)},3e3)}setParent(F,Q){if(F&&F!==o.None)try{F[C]=!0}catch{}}markAsDisposed(F){if(F&&F!==o.None)try{F[C]=!0}catch{}}markAsSingleton(F){}})}function T(C){return c?.trackDisposable(C),C}t.$Ic=T;function s(C){c?.markAsDisposed(C)}t.$Jc=s;function a(C,F){c?.setParent(C,F)}function e(C,F){if(c)for(const Q of C)c.setParent(Q,F)}function h(C){return c?.markAsSingleton(C),C}t.$Kc=h;function l(C){return typeof C.dispose=="function"&&C.dispose.length===0}t.$Lc=l;function m(C){if(D.Iterable.is(C)){const F=[];for(const Q of C)if(Q)try{Q.dispose()}catch(te){F.push(te)}if(F.length===1)throw F[0];if(F.length>1)throw new AggregateError(F,"Encountered errors while disposing of store");return Array.isArray(C)?[]:C}else if(C)return C.dispose(),C}t.$Mc=m;function n(C){for(const F of C)l(F)&&F.dispose();return[]}t.$Nc=n;function r(...C){const F=b(()=>m(C));return e(C,F),F}t.$Oc=r;function b(C){const F=T({dispose:(0,U.$cb)(()=>{s(F),C()})});return F}t.$Pc=b;class u{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,T(this)}dispose(){this.g||(s(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{m(this.f)}finally{this.f.clear()}}add(F){if(!F)return F;if(F===this)throw new Error("Cannot register a disposable on itself!");return a(F,this),this.g?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(F),F}delete(F){if(F){if(F===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(F),F.dispose()}}deleteAndLeak(F){F&&this.f.has(F)&&(this.f.delete(F),a(F,null))}}t.$Qc=u;class o{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new u,T(this),a(this.q,this)}dispose(){s(this),this.q.dispose()}B(F){if(F===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(F)}}t.$Rc=o;class N{constructor(){this.b=!1,T(this)}get value(){return this.b?void 0:this.a}set value(F){this.b||F===this.a||(this.a?.dispose(),F&&a(F,this),this.a=F)}clear(){this.value=void 0}dispose(){this.b=!0,s(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const F=this.a;return this.a=void 0,F&&a(F,null),F}}t.$Sc=N;class z{constructor(F){this.b=F,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Tc=z;class R{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,T(this)}set(F){let Q=F;return this.unset=()=>Q=void 0,this.isset=()=>Q!==void 0,this.dispose=()=>{Q&&(Q(),Q=void 0,s(this))},this}}t.$Uc=R;class d{constructor(){this.a=new Map}acquire(F,...Q){let te=this.a.get(F);te||(te={counter:0,object:this.b(F,...Q)},this.a.set(F,te));const{object:re}=te,fe=(0,U.$cb)(()=>{--te.counter===0&&(this.c(F,te.object),this.a.delete(F))});return te.counter++,{object:re,dispose:fe}}}t.$Vc=d;class E{constructor(F){this.a=F}async acquire(F,...Q){const te=this.a.acquire(F,...Q);try{return{object:await te.object,dispose:()=>te.dispose()}}catch(re){throw te.dispose(),re}}}t.$Wc=E;class B{constructor(F){this.object=F}dispose(){}}t.$Xc=B;function H(C){const F=new u;try{C(F)}finally{F.dispose()}}t.$Yc=H;class x{constructor(){this.a=new Map,this.b=!1,T(this)}dispose(){s(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{m(this.a.values())}finally{this.a.clear()}}has(F){return this.a.has(F)}get size(){return this.a.size}get(F){return this.a.get(F)}set(F,Q,te=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),te||this.a.get(F)?.dispose(),this.a.set(F,Q)}deleteAndDispose(F){this.a.get(F)?.dispose(),this.a.delete(F)}keys(){return this.a.keys()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$Zc=x}),function(le,t){typeof define=="function"&&define.amd?define($e[79],we([0]),t):typeof exports=="object"&&typeof module<"u"?t(exports):(le=typeof globalThis<"u"?globalThis:le||self,t(le.marked={}))}(this,function(le){"use strict";function t($,w){for(var I=0;I<w.length;I++){var v=w[I];v.enumerable=v.enumerable||!1,v.configurable=!0,"value"in v&&(v.writable=!0),Object.defineProperty($,v.key,v)}}function y($,w,I){return w&&t($.prototype,w),I&&t($,I),Object.defineProperty($,"prototype",{writable:!1}),$}function L($,w){if($){if(typeof $=="string")return i($,w);var I=Object.prototype.toString.call($).slice(8,-1);if(I==="Object"&&$.constructor&&(I=$.constructor.name),I==="Map"||I==="Set")return Array.from($);if(I==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(I))return i($,w)}}function i($,w){(w==null||w>$.length)&&(w=$.length);for(var I=0,v=new Array(w);I<w;I++)v[I]=$[I];return v}function U($,w){var I=typeof Symbol<"u"&&$[Symbol.iterator]||$["@@iterator"];if(I)return(I=I.call($)).next.bind(I);if(Array.isArray($)||(I=L($))||w&&$&&typeof $.length=="number"){I&&($=I);var v=0;return function(){return v>=$.length?{done:!0}:{done:!1,value:$[v++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function D(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}le.defaults=D();function A($){le.defaults=$}var c=/[&<>"']/,g=/[&<>"']/g,f=/[<>"']|&(?!#?\w+;)/,T=/[<>"']|&(?!#?\w+;)/g,s={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},a=function(w){return s[w]};function e($,w){if(w){if(c.test($))return $.replace(g,a)}else if(f.test($))return $.replace(T,a);return $}var h=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function l($){return $.replace(h,function(w,I){return I=I.toLowerCase(),I==="colon"?":":I.charAt(0)==="#"?I.charAt(1)==="x"?String.fromCharCode(parseInt(I.substring(2),16)):String.fromCharCode(+I.substring(1)):""})}var m=/(^|[^\[])\^/g;function n($,w){$=typeof $=="string"?$:$.source,w=w||"";var I={replace:function(O,k){return k=k.source||k,k=k.replace(m,"$1"),$=$.replace(O,k),I},getRegex:function(){return new RegExp($,w)}};return I}var r=/[^\w:]/g,b=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function u($,w,I){if($){var v;try{v=decodeURIComponent(l(I)).replace(r,"").toLowerCase()}catch{return null}if(v.indexOf("javascript:")===0||v.indexOf("vbscript:")===0||v.indexOf("data:")===0)return null}w&&!b.test(I)&&(I=d(w,I));try{I=encodeURI(I).replace(/%25/g,"%")}catch{return null}return I}var o={},N=/^[^:]+:\/*[^/]*$/,z=/^([^:]+:)[\s\S]*$/,R=/^([^:]+:\/*[^/]*)[\s\S]*$/;function d($,w){o[" "+$]||(N.test($)?o[" "+$]=$+"/":o[" "+$]=x($,"/",!0)),$=o[" "+$];var I=$.indexOf(":")===-1;return w.substring(0,2)==="//"?I?w:$.replace(z,"$1")+w:w.charAt(0)==="/"?I?w:$.replace(R,"$1")+w:$+w}var E={exec:function(){}};function B($){for(var w=1,I,v;w<arguments.length;w++){I=arguments[w];for(v in I)Object.prototype.hasOwnProperty.call(I,v)&&($[v]=I[v])}return $}function H($,w){var I=$.replace(/\|/g,function(k,S,j){for(var K=!1,ee=S;--ee>=0&&j[ee]==="\\";)K=!K;return K?"|":" |"}),v=I.split(/ \|/),O=0;if(v[0].trim()||v.shift(),v.length>0&&!v[v.length-1].trim()&&v.pop(),v.length>w)v.splice(w);else for(;v.length<w;)v.push("");for(;O<v.length;O++)v[O]=v[O].trim().replace(/\\\|/g,"|");return v}function x($,w,I){var v=$.length;if(v===0)return"";for(var O=0;O<v;){var k=$.charAt(v-O-1);if(k===w&&!I)O++;else if(k!==w&&I)O++;else break}return $.slice(0,v-O)}function C($,w){if($.indexOf(w[1])===-1)return-1;for(var I=$.length,v=0,O=0;O<I;O++)if($[O]==="\\")O++;else if($[O]===w[0])v++;else if($[O]===w[1]&&(v--,v<0))return O;return-1}function F($){$&&$.sanitize&&!$.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function Q($,w){if(w<1)return"";for(var I="";w>1;)w&1&&(I+=$),w>>=1,$+=$;return I+$}function te($,w,I,v){var O=w.href,k=w.title?e(w.title):null,S=$[1].replace(/\\([\[\]])/g,"$1");if($[0].charAt(0)!=="!"){v.state.inLink=!0;var j={type:"link",raw:I,href:O,title:k,text:S,tokens:v.inlineTokens(S)};return v.state.inLink=!1,j}return{type:"image",raw:I,href:O,title:k,text:e(S)}}function re($,w){var I=$.match(/^(\s+)(?:```)/);if(I===null)return w;var v=I[1];return w.split(`
`).map(function(O){var k=O.match(/^\s+/);if(k===null)return O;var S=k[0];return S.length>=v.length?O.slice(v.length):O}).join(`
`)}var fe=function(){function $(I){this.options=I||le.defaults}var w=$.prototype;return w.space=function(v){var O=this.rules.block.newline.exec(v);if(O&&O[0].length>0)return{type:"space",raw:O[0]}},w.code=function(v){var O=this.rules.block.code.exec(v);if(O){var k=O[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:O[0],codeBlockStyle:"indented",text:this.options.pedantic?k:x(k,`
`)}}},w.fences=function(v){var O=this.rules.block.fences.exec(v);if(O){var k=O[0],S=re(k,O[3]||"");return{type:"code",raw:k,lang:O[2]?O[2].trim():O[2],text:S}}},w.heading=function(v){var O=this.rules.block.heading.exec(v);if(O){var k=O[2].trim();if(/#$/.test(k)){var S=x(k,"#");(this.options.pedantic||!S||/ $/.test(S))&&(k=S.trim())}return{type:"heading",raw:O[0],depth:O[1].length,text:k,tokens:this.lexer.inline(k)}}},w.hr=function(v){var O=this.rules.block.hr.exec(v);if(O)return{type:"hr",raw:O[0]}},w.blockquote=function(v){var O=this.rules.block.blockquote.exec(v);if(O){var k=O[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:O[0],tokens:this.lexer.blockTokens(k,[]),text:k}}},w.list=function(v){var O=this.rules.block.list.exec(v);if(O){var k,S,j,K,ee,se,ge,pe,Pe,Ae,De,Ie,Oe=O[1].trim(),_e=Oe.length>1,He={type:"list",raw:"",ordered:_e,start:_e?+Oe.slice(0,-1):"",loose:!1,items:[]};Oe=_e?"\\d{1,9}\\"+Oe.slice(-1):"\\"+Oe,this.options.pedantic&&(Oe=_e?Oe:"[*+-]");for(var Me=new RegExp("^( {0,3}"+Oe+")((?:[	 ][^\\n]*)?(?:\\n|$))");v&&(Ie=!1,!(!(O=Me.exec(v))||this.rules.block.hr.test(v)));){if(k=O[0],v=v.substring(k.length),pe=O[2].split(`
`,1)[0],Pe=v.split(`
`,1)[0],this.options.pedantic?(K=2,De=pe.trimLeft()):(K=O[2].search(/[^ ]/),K=K>4?1:K,De=pe.slice(K),K+=O[1].length),se=!1,!pe&&/^ *$/.test(Pe)&&(k+=Pe+`
`,v=v.substring(Pe.length+1),Ie=!0),!Ie)for(var Qe=new RegExp("^ {0,"+Math.min(3,K-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Z=new RegExp("^ {0,"+Math.min(3,K-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),he=new RegExp("^ {0,"+Math.min(3,K-1)+"}(?:```|~~~)"),ve=new RegExp("^ {0,"+Math.min(3,K-1)+"}#");v&&(Ae=v.split(`
`,1)[0],pe=Ae,this.options.pedantic&&(pe=pe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(he.test(pe)||ve.test(pe)||Qe.test(pe)||Z.test(v)));){if(pe.search(/[^ ]/)>=K||!pe.trim())De+=`
`+pe.slice(K);else if(!se)De+=`
`+pe;else break;!se&&!pe.trim()&&(se=!0),k+=Ae+`
`,v=v.substring(Ae.length+1)}He.loose||(ge?He.loose=!0:/\n *\n *$/.test(k)&&(ge=!0)),this.options.gfm&&(S=/^\[[ xX]\] /.exec(De),S&&(j=S[0]!=="[ ] ",De=De.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:k,task:!!S,checked:j,loose:!1,text:De}),He.raw+=k}He.items[He.items.length-1].raw=k.trimRight(),He.items[He.items.length-1].text=De.trimRight(),He.raw=He.raw.trimRight();var Ee=He.items.length;for(ee=0;ee<Ee;ee++){this.lexer.state.top=!1,He.items[ee].tokens=this.lexer.blockTokens(He.items[ee].text,[]);var Ce=He.items[ee].tokens.filter(function(Ue){return Ue.type==="space"}),Be=Ce.every(function(Ue){for(var Ze=Ue.raw.split(""),Je=0,Ke=U(Ze),Ve;!(Ve=Ke()).done;){var tt=Ve.value;if(tt===`
`&&(Je+=1),Je>1)return!0}return!1});!He.loose&&Ce.length&&Be&&(He.loose=!0,He.items[ee].loose=!0)}return He}},w.html=function(v){var O=this.rules.block.html.exec(v);if(O){var k={type:"html",raw:O[0],pre:!this.options.sanitizer&&(O[1]==="pre"||O[1]==="script"||O[1]==="style"),text:O[0]};if(this.options.sanitize){var S=this.options.sanitizer?this.options.sanitizer(O[0]):e(O[0]);k.type="paragraph",k.text=S,k.tokens=this.lexer.inline(S)}return k}},w.def=function(v){var O=this.rules.block.def.exec(v);if(O){O[3]&&(O[3]=O[3].substring(1,O[3].length-1));var k=O[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:k,raw:O[0],href:O[2],title:O[3]}}},w.table=function(v){var O=this.rules.block.table.exec(v);if(O){var k={type:"table",header:H(O[1]).map(function(ge){return{text:ge}}),align:O[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:O[3]&&O[3].trim()?O[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(k.header.length===k.align.length){k.raw=O[0];var S=k.align.length,j,K,ee,se;for(j=0;j<S;j++)/^ *-+: *$/.test(k.align[j])?k.align[j]="right":/^ *:-+: *$/.test(k.align[j])?k.align[j]="center":/^ *:-+ *$/.test(k.align[j])?k.align[j]="left":k.align[j]=null;for(S=k.rows.length,j=0;j<S;j++)k.rows[j]=H(k.rows[j],k.header.length).map(function(ge){return{text:ge}});for(S=k.header.length,K=0;K<S;K++)k.header[K].tokens=this.lexer.inline(k.header[K].text);for(S=k.rows.length,K=0;K<S;K++)for(se=k.rows[K],ee=0;ee<se.length;ee++)se[ee].tokens=this.lexer.inline(se[ee].text);return k}}},w.lheading=function(v){var O=this.rules.block.lheading.exec(v);if(O)return{type:"heading",raw:O[0],depth:O[2].charAt(0)==="="?1:2,text:O[1],tokens:this.lexer.inline(O[1])}},w.paragraph=function(v){var O=this.rules.block.paragraph.exec(v);if(O){var k=O[1].charAt(O[1].length-1)===`
`?O[1].slice(0,-1):O[1];return{type:"paragraph",raw:O[0],text:k,tokens:this.lexer.inline(k)}}},w.text=function(v){var O=this.rules.block.text.exec(v);if(O)return{type:"text",raw:O[0],text:O[0],tokens:this.lexer.inline(O[0])}},w.escape=function(v){var O=this.rules.inline.escape.exec(v);if(O)return{type:"escape",raw:O[0],text:e(O[1])}},w.tag=function(v){var O=this.rules.inline.tag.exec(v);if(O)return!this.lexer.state.inLink&&/^<a /i.test(O[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(O[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(O[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(O[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:O[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(O[0]):e(O[0]):O[0]}},w.link=function(v){var O=this.rules.inline.link.exec(v);if(O){var k=O[2].trim();if(!this.options.pedantic&&/^</.test(k)){if(!/>$/.test(k))return;var S=x(k.slice(0,-1),"\\");if((k.length-S.length)%2===0)return}else{var j=C(O[2],"()");if(j>-1){var K=O[0].indexOf("!")===0?5:4,ee=K+O[1].length+j;O[2]=O[2].substring(0,j),O[0]=O[0].substring(0,ee).trim(),O[3]=""}}var se=O[2],ge="";if(this.options.pedantic){var pe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(se);pe&&(se=pe[1],ge=pe[3])}else ge=O[3]?O[3].slice(1,-1):"";return se=se.trim(),/^</.test(se)&&(this.options.pedantic&&!/>$/.test(k)?se=se.slice(1):se=se.slice(1,-1)),te(O,{href:se&&se.replace(this.rules.inline._escapes,"$1"),title:ge&&ge.replace(this.rules.inline._escapes,"$1")},O[0],this.lexer)}},w.reflink=function(v,O){var k;if((k=this.rules.inline.reflink.exec(v))||(k=this.rules.inline.nolink.exec(v))){var S=(k[2]||k[1]).replace(/\s+/g," ");if(S=O[S.toLowerCase()],!S||!S.href){var j=k[0].charAt(0);return{type:"text",raw:j,text:j}}return te(k,S,k[0],this.lexer)}},w.emStrong=function(v,O,k){k===void 0&&(k="");var S=this.rules.inline.emStrong.lDelim.exec(v);if(S&&!(S[3]&&k.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var j=S[1]||S[2]||"";if(!j||j&&(k===""||this.rules.inline.punctuation.exec(k))){var K=S[0].length-1,ee,se,ge=K,pe=0,Pe=S[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Pe.lastIndex=0,O=O.slice(-1*v.length+K);(S=Pe.exec(O))!=null;)if(ee=S[1]||S[2]||S[3]||S[4]||S[5]||S[6],!!ee){if(se=ee.length,S[3]||S[4]){ge+=se;continue}else if((S[5]||S[6])&&K%3&&!((K+se)%3)){pe+=se;continue}if(ge-=se,!(ge>0)){if(se=Math.min(se,se+ge+pe),Math.min(K,se)%2){var Ae=v.slice(1,K+S.index+se);return{type:"em",raw:v.slice(0,K+S.index+se+1),text:Ae,tokens:this.lexer.inlineTokens(Ae)}}var De=v.slice(2,K+S.index+se-1);return{type:"strong",raw:v.slice(0,K+S.index+se+1),text:De,tokens:this.lexer.inlineTokens(De)}}}}}},w.codespan=function(v){var O=this.rules.inline.code.exec(v);if(O){var k=O[2].replace(/\n/g," "),S=/[^ ]/.test(k),j=/^ /.test(k)&&/ $/.test(k);return S&&j&&(k=k.substring(1,k.length-1)),k=e(k,!0),{type:"codespan",raw:O[0],text:k}}},w.br=function(v){var O=this.rules.inline.br.exec(v);if(O)return{type:"br",raw:O[0]}},w.del=function(v){var O=this.rules.inline.del.exec(v);if(O)return{type:"del",raw:O[0],text:O[2],tokens:this.lexer.inlineTokens(O[2])}},w.autolink=function(v,O){var k=this.rules.inline.autolink.exec(v);if(k){var S,j;return k[2]==="@"?(S=e(this.options.mangle?O(k[1]):k[1]),j="mailto:"+S):(S=e(k[1]),j=S),{type:"link",raw:k[0],text:S,href:j,tokens:[{type:"text",raw:S,text:S}]}}},w.url=function(v,O){var k;if(k=this.rules.inline.url.exec(v)){var S,j;if(k[2]==="@")S=e(this.options.mangle?O(k[0]):k[0]),j="mailto:"+S;else{var K;do K=k[0],k[0]=this.rules.inline._backpedal.exec(k[0])[0];while(K!==k[0]);S=e(k[0]),k[1]==="www."?j="http://"+S:j=S}return{type:"link",raw:k[0],text:S,href:j,tokens:[{type:"text",raw:S,text:S}]}}},w.inlineText=function(v,O){var k=this.rules.inline.text.exec(v);if(k){var S;return this.lexer.state.inRawBlock?S=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(k[0]):e(k[0]):k[0]:S=e(this.options.smartypants?O(k[0]):k[0]),{type:"text",raw:k[0],text:S}}},$}(),ie={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:E,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};ie._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,ie._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ie.def=n(ie.def).replace("label",ie._label).replace("title",ie._title).getRegex(),ie.bullet=/(?:[*+-]|\d{1,9}[.)])/,ie.listItemStart=n(/^( *)(bull) */).replace("bull",ie.bullet).getRegex(),ie.list=n(ie.list).replace(/bull/g,ie.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ie.def.source+")").getRegex(),ie._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ie._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ie.html=n(ie.html,"i").replace("comment",ie._comment).replace("tag",ie._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ie.paragraph=n(ie._paragraph).replace("hr",ie.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ie._tag).getRegex(),ie.blockquote=n(ie.blockquote).replace("paragraph",ie.paragraph).getRegex(),ie.normal=B({},ie),ie.gfm=B({},ie.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ie.gfm.table=n(ie.gfm.table).replace("hr",ie.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ie._tag).getRegex(),ie.gfm.paragraph=n(ie._paragraph).replace("hr",ie.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",ie.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ie._tag).getRegex(),ie.pedantic=B({},ie.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ie._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:E,paragraph:n(ie.normal._paragraph).replace("hr",ie.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ie.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var oe={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:E,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:E,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};oe._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",oe.punctuation=n(oe.punctuation).replace(/punctuation/g,oe._punctuation).getRegex(),oe.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,oe.escapedEmSt=/\\\*|\\_/g,oe._comment=n(ie._comment).replace("(?:-->|$)","-->").getRegex(),oe.emStrong.lDelim=n(oe.emStrong.lDelim).replace(/punct/g,oe._punctuation).getRegex(),oe.emStrong.rDelimAst=n(oe.emStrong.rDelimAst,"g").replace(/punct/g,oe._punctuation).getRegex(),oe.emStrong.rDelimUnd=n(oe.emStrong.rDelimUnd,"g").replace(/punct/g,oe._punctuation).getRegex(),oe._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,oe._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,oe._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,oe.autolink=n(oe.autolink).replace("scheme",oe._scheme).replace("email",oe._email).getRegex(),oe._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,oe.tag=n(oe.tag).replace("comment",oe._comment).replace("attribute",oe._attribute).getRegex(),oe._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,oe._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,oe._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,oe.link=n(oe.link).replace("label",oe._label).replace("href",oe._href).replace("title",oe._title).getRegex(),oe.reflink=n(oe.reflink).replace("label",oe._label).replace("ref",ie._label).getRegex(),oe.nolink=n(oe.nolink).replace("ref",ie._label).getRegex(),oe.reflinkSearch=n(oe.reflinkSearch,"g").replace("reflink",oe.reflink).replace("nolink",oe.nolink).getRegex(),oe.normal=B({},oe),oe.pedantic=B({},oe.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",oe._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",oe._label).getRegex()}),oe.gfm=B({},oe.normal,{escape:n(oe.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),oe.gfm.url=n(oe.gfm.url,"i").replace("email",oe.gfm._extended_email).getRegex(),oe.breaks=B({},oe.gfm,{br:n(oe.br).replace("{2,}","*").getRegex(),text:n(oe.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function be($){return $.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Se($){var w="",I,v,O=$.length;for(I=0;I<O;I++)v=$.charCodeAt(I),Math.random()>.5&&(v="x"+v.toString(16)),w+="&#"+v+";";return w}var Le=function(){function $(I){this.tokens=[],this.tokens.links=Object.create(null),this.options=I||le.defaults,this.options.tokenizer=this.options.tokenizer||new fe,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var v={block:ie.normal,inline:oe.normal};this.options.pedantic?(v.block=ie.pedantic,v.inline=oe.pedantic):this.options.gfm&&(v.block=ie.gfm,this.options.breaks?v.inline=oe.breaks:v.inline=oe.gfm),this.tokenizer.rules=v}$.lex=function(v,O){var k=new $(O);return k.lex(v)},$.lexInline=function(v,O){var k=new $(O);return k.inlineTokens(v)};var w=$.prototype;return w.lex=function(v){v=v.replace(/\r\n|\r/g,`
`),this.blockTokens(v,this.tokens);for(var O;O=this.inlineQueue.shift();)this.inlineTokens(O.src,O.tokens);return this.tokens},w.blockTokens=function(v,O){var k=this;O===void 0&&(O=[]),this.options.pedantic?v=v.replace(/\t/g,"    ").replace(/^ +$/gm,""):v=v.replace(/^( *)(\t+)/gm,function(ge,pe,Pe){return pe+"    ".repeat(Pe.length)});for(var S,j,K,ee;v;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ge){return(S=ge.call({lexer:k},v,O))?(v=v.substring(S.raw.length),O.push(S),!0):!1}))){if(S=this.tokenizer.space(v)){v=v.substring(S.raw.length),S.raw.length===1&&O.length>0?O[O.length-1].raw+=`
`:O.push(S);continue}if(S=this.tokenizer.code(v)){v=v.substring(S.raw.length),j=O[O.length-1],j&&(j.type==="paragraph"||j.type==="text")?(j.raw+=`
`+S.raw,j.text+=`
`+S.text,this.inlineQueue[this.inlineQueue.length-1].src=j.text):O.push(S);continue}if(S=this.tokenizer.fences(v)){v=v.substring(S.raw.length),O.push(S);continue}if(S=this.tokenizer.heading(v)){v=v.substring(S.raw.length),O.push(S);continue}if(S=this.tokenizer.hr(v)){v=v.substring(S.raw.length),O.push(S);continue}if(S=this.tokenizer.blockquote(v)){v=v.substring(S.raw.length),O.push(S);continue}if(S=this.tokenizer.list(v)){v=v.substring(S.raw.length),O.push(S);continue}if(S=this.tokenizer.html(v)){v=v.substring(S.raw.length),O.push(S);continue}if(S=this.tokenizer.def(v)){v=v.substring(S.raw.length),j=O[O.length-1],j&&(j.type==="paragraph"||j.type==="text")?(j.raw+=`
`+S.raw,j.text+=`
`+S.raw,this.inlineQueue[this.inlineQueue.length-1].src=j.text):this.tokens.links[S.tag]||(this.tokens.links[S.tag]={href:S.href,title:S.title});continue}if(S=this.tokenizer.table(v)){v=v.substring(S.raw.length),O.push(S);continue}if(S=this.tokenizer.lheading(v)){v=v.substring(S.raw.length),O.push(S);continue}if(K=v,this.options.extensions&&this.options.extensions.startBlock&&function(){var ge=1/0,pe=v.slice(1),Pe=void 0;k.options.extensions.startBlock.forEach(function(Ae){Pe=Ae.call({lexer:this},pe),typeof Pe=="number"&&Pe>=0&&(ge=Math.min(ge,Pe))}),ge<1/0&&ge>=0&&(K=v.substring(0,ge+1))}(),this.state.top&&(S=this.tokenizer.paragraph(K))){j=O[O.length-1],ee&&j.type==="paragraph"?(j.raw+=`
`+S.raw,j.text+=`
`+S.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=j.text):O.push(S),ee=K.length!==v.length,v=v.substring(S.raw.length);continue}if(S=this.tokenizer.text(v)){v=v.substring(S.raw.length),j=O[O.length-1],j&&j.type==="text"?(j.raw+=`
`+S.raw,j.text+=`
`+S.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=j.text):O.push(S);continue}if(v){var se="Infinite loop on byte: "+v.charCodeAt(0);if(this.options.silent){console.error(se);break}else throw new Error(se)}}return this.state.top=!0,O},w.inline=function(v,O){return O===void 0&&(O=[]),this.inlineQueue.push({src:v,tokens:O}),O},w.inlineTokens=function(v,O){var k=this;O===void 0&&(O=[]);var S,j,K,ee=v,se,ge,pe;if(this.tokens.links){var Pe=Object.keys(this.tokens.links);if(Pe.length>0)for(;(se=this.tokenizer.rules.inline.reflinkSearch.exec(ee))!=null;)Pe.includes(se[0].slice(se[0].lastIndexOf("[")+1,-1))&&(ee=ee.slice(0,se.index)+"["+Q("a",se[0].length-2)+"]"+ee.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(se=this.tokenizer.rules.inline.blockSkip.exec(ee))!=null;)ee=ee.slice(0,se.index)+"["+Q("a",se[0].length-2)+"]"+ee.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(se=this.tokenizer.rules.inline.escapedEmSt.exec(ee))!=null;)ee=ee.slice(0,se.index)+"++"+ee.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;v;)if(ge||(pe=""),ge=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(De){return(S=De.call({lexer:k},v,O))?(v=v.substring(S.raw.length),O.push(S),!0):!1}))){if(S=this.tokenizer.escape(v)){v=v.substring(S.raw.length),O.push(S);continue}if(S=this.tokenizer.tag(v)){v=v.substring(S.raw.length),j=O[O.length-1],j&&S.type==="text"&&j.type==="text"?(j.raw+=S.raw,j.text+=S.text):O.push(S);continue}if(S=this.tokenizer.link(v)){v=v.substring(S.raw.length),O.push(S);continue}if(S=this.tokenizer.reflink(v,this.tokens.links)){v=v.substring(S.raw.length),j=O[O.length-1],j&&S.type==="text"&&j.type==="text"?(j.raw+=S.raw,j.text+=S.text):O.push(S);continue}if(S=this.tokenizer.emStrong(v,ee,pe)){v=v.substring(S.raw.length),O.push(S);continue}if(S=this.tokenizer.codespan(v)){v=v.substring(S.raw.length),O.push(S);continue}if(S=this.tokenizer.br(v)){v=v.substring(S.raw.length),O.push(S);continue}if(S=this.tokenizer.del(v)){v=v.substring(S.raw.length),O.push(S);continue}if(S=this.tokenizer.autolink(v,Se)){v=v.substring(S.raw.length),O.push(S);continue}if(!this.state.inLink&&(S=this.tokenizer.url(v,Se))){v=v.substring(S.raw.length),O.push(S);continue}if(K=v,this.options.extensions&&this.options.extensions.startInline&&function(){var De=1/0,Ie=v.slice(1),Oe=void 0;k.options.extensions.startInline.forEach(function(_e){Oe=_e.call({lexer:this},Ie),typeof Oe=="number"&&Oe>=0&&(De=Math.min(De,Oe))}),De<1/0&&De>=0&&(K=v.substring(0,De+1))}(),S=this.tokenizer.inlineText(K,be)){v=v.substring(S.raw.length),S.raw.slice(-1)!=="_"&&(pe=S.raw.slice(-1)),ge=!0,j=O[O.length-1],j&&j.type==="text"?(j.raw+=S.raw,j.text+=S.text):O.push(S);continue}if(v){var Ae="Infinite loop on byte: "+v.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return O},y($,null,[{key:"rules",get:function(){return{block:ie,inline:oe}}}]),$}(),Fe=function(){function $(I){this.options=I||le.defaults}var w=$.prototype;return w.code=function(v,O,k){var S=(O||"").match(/\S*/)[0];if(this.options.highlight){var j=this.options.highlight(v,S);j!=null&&j!==v&&(k=!0,v=j)}return v=v.replace(/\n$/,"")+`
`,S?'<pre><code class="'+this.options.langPrefix+e(S,!0)+'">'+(k?v:e(v,!0))+`</code></pre>
`:"<pre><code>"+(k?v:e(v,!0))+`</code></pre>
`},w.blockquote=function(v){return`<blockquote>
`+v+`</blockquote>
`},w.html=function(v){return v},w.heading=function(v,O,k,S){if(this.options.headerIds){var j=this.options.headerPrefix+S.slug(k);return"<h"+O+' id="'+j+'">'+v+"</h"+O+`>
`}return"<h"+O+">"+v+"</h"+O+`>
`},w.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},w.list=function(v,O,k){var S=O?"ol":"ul",j=O&&k!==1?' start="'+k+'"':"";return"<"+S+j+`>
`+v+"</"+S+`>
`},w.listitem=function(v){return"<li>"+v+`</li>
`},w.checkbox=function(v){return"<input "+(v?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},w.paragraph=function(v){return"<p>"+v+`</p>
`},w.table=function(v,O){return O&&(O="<tbody>"+O+"</tbody>"),`<table>
<thead>
`+v+`</thead>
`+O+`</table>
`},w.tablerow=function(v){return`<tr>
`+v+`</tr>
`},w.tablecell=function(v,O){var k=O.header?"th":"td",S=O.align?"<"+k+' align="'+O.align+'">':"<"+k+">";return S+v+("</"+k+`>
`)},w.strong=function(v){return"<strong>"+v+"</strong>"},w.em=function(v){return"<em>"+v+"</em>"},w.codespan=function(v){return"<code>"+v+"</code>"},w.br=function(){return this.options.xhtml?"<br/>":"<br>"},w.del=function(v){return"<del>"+v+"</del>"},w.link=function(v,O,k){if(v=u(this.options.sanitize,this.options.baseUrl,v),v===null)return k;var S='<a href="'+e(v)+'"';return O&&(S+=' title="'+O+'"'),S+=">"+k+"</a>",S},w.image=function(v,O,k){if(v=u(this.options.sanitize,this.options.baseUrl,v),v===null)return k;var S='<img src="'+v+'" alt="'+k+'"';return O&&(S+=' title="'+O+'"'),S+=this.options.xhtml?"/>":">",S},w.text=function(v){return v},$}(),de=function(){function $(){}var w=$.prototype;return w.strong=function(v){return v},w.em=function(v){return v},w.codespan=function(v){return v},w.del=function(v){return v},w.html=function(v){return v},w.text=function(v){return v},w.link=function(v,O,k){return""+k},w.image=function(v,O,k){return""+k},w.br=function(){return""},$}(),ne=function(){function $(){this.seen={}}var w=$.prototype;return w.serialize=function(v){return v.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},w.getNextSafeSlug=function(v,O){var k=v,S=0;if(this.seen.hasOwnProperty(k)){S=this.seen[v];do S++,k=v+"-"+S;while(this.seen.hasOwnProperty(k))}return O||(this.seen[v]=S,this.seen[k]=0),k},w.slug=function(v,O){O===void 0&&(O={});var k=this.serialize(v);return this.getNextSafeSlug(k,O.dryrun)},$}(),ce=function(){function $(I){this.options=I||le.defaults,this.options.renderer=this.options.renderer||new Fe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new de,this.slugger=new ne}$.parse=function(v,O){var k=new $(O);return k.parse(v)},$.parseInline=function(v,O){var k=new $(O);return k.parseInline(v)};var w=$.prototype;return w.parse=function(v,O){O===void 0&&(O=!0);var k="",S,j,K,ee,se,ge,pe,Pe,Ae,De,Ie,Oe,_e,He,Me,Qe,Z,he,ve,Ee=v.length;for(S=0;S<Ee;S++){if(De=v[S],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[De.type]&&(ve=this.options.extensions.renderers[De.type].call({parser:this},De),ve!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(De.type))){k+=ve||"";continue}switch(De.type){case"space":continue;case"hr":{k+=this.renderer.hr();continue}case"heading":{k+=this.renderer.heading(this.parseInline(De.tokens),De.depth,l(this.parseInline(De.tokens,this.textRenderer)),this.slugger);continue}case"code":{k+=this.renderer.code(De.text,De.lang,De.escaped);continue}case"table":{for(Pe="",pe="",ee=De.header.length,j=0;j<ee;j++)pe+=this.renderer.tablecell(this.parseInline(De.header[j].tokens),{header:!0,align:De.align[j]});for(Pe+=this.renderer.tablerow(pe),Ae="",ee=De.rows.length,j=0;j<ee;j++){for(ge=De.rows[j],pe="",se=ge.length,K=0;K<se;K++)pe+=this.renderer.tablecell(this.parseInline(ge[K].tokens),{header:!1,align:De.align[K]});Ae+=this.renderer.tablerow(pe)}k+=this.renderer.table(Pe,Ae);continue}case"blockquote":{Ae=this.parse(De.tokens),k+=this.renderer.blockquote(Ae);continue}case"list":{for(Ie=De.ordered,Oe=De.start,_e=De.loose,ee=De.items.length,Ae="",j=0;j<ee;j++)Me=De.items[j],Qe=Me.checked,Z=Me.task,He="",Me.task&&(he=this.renderer.checkbox(Qe),_e?Me.tokens.length>0&&Me.tokens[0].type==="paragraph"?(Me.tokens[0].text=he+" "+Me.tokens[0].text,Me.tokens[0].tokens&&Me.tokens[0].tokens.length>0&&Me.tokens[0].tokens[0].type==="text"&&(Me.tokens[0].tokens[0].text=he+" "+Me.tokens[0].tokens[0].text)):Me.tokens.unshift({type:"text",text:he}):He+=he),He+=this.parse(Me.tokens,_e),Ae+=this.renderer.listitem(He,Z,Qe);k+=this.renderer.list(Ae,Ie,Oe);continue}case"html":{k+=this.renderer.html(De.text);continue}case"paragraph":{k+=this.renderer.paragraph(this.parseInline(De.tokens));continue}case"text":{for(Ae=De.tokens?this.parseInline(De.tokens):De.text;S+1<Ee&&v[S+1].type==="text";)De=v[++S],Ae+=`
`+(De.tokens?this.parseInline(De.tokens):De.text);k+=O?this.renderer.paragraph(Ae):Ae;continue}default:{var Ce='Token with "'+De.type+'" type was not found.';if(this.options.silent){console.error(Ce);return}else throw new Error(Ce)}}}return k},w.parseInline=function(v,O){O=O||this.renderer;var k="",S,j,K,ee=v.length;for(S=0;S<ee;S++){if(j=v[S],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[j.type]&&(K=this.options.extensions.renderers[j.type].call({parser:this},j),K!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(j.type))){k+=K||"";continue}switch(j.type){case"escape":{k+=O.text(j.text);break}case"html":{k+=O.html(j.text);break}case"link":{k+=O.link(j.href,j.title,this.parseInline(j.tokens,O));break}case"image":{k+=O.image(j.href,j.title,j.text);break}case"strong":{k+=O.strong(this.parseInline(j.tokens,O));break}case"em":{k+=O.em(this.parseInline(j.tokens,O));break}case"codespan":{k+=O.codespan(j.text);break}case"br":{k+=O.br();break}case"del":{k+=O.del(this.parseInline(j.tokens,O));break}case"text":{k+=O.text(j.text);break}default:{var se='Token with "'+j.type+'" type was not found.';if(this.options.silent){console.error(se);return}else throw new Error(se)}}}return k},$}();function X($,w,I){if(typeof $>"u"||$===null)throw new Error("marked(): input parameter is undefined or null");if(typeof $!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call($)+", string expected");if(typeof w=="function"&&(I=w,w=null),w=B({},X.defaults,w||{}),F(w),I){var v=w.highlight,O;try{O=Le.lex($,w)}catch(ee){return I(ee)}var k=function(se){var ge;if(!se)try{w.walkTokens&&X.walkTokens(O,w.walkTokens),ge=ce.parse(O,w)}catch(pe){se=pe}return w.highlight=v,se?I(se):I(null,ge)};if(!v||v.length<3||(delete w.highlight,!O.length))return k();var S=0;X.walkTokens(O,function(ee){ee.type==="code"&&(S++,setTimeout(function(){v(ee.text,ee.lang,function(se,ge){if(se)return k(se);ge!=null&&ge!==ee.text&&(ee.text=ge,ee.escaped=!0),S--,S===0&&k()})},0))}),S===0&&k();return}function j(ee){if(ee.message+=`
Please report this to https://github.com/markedjs/marked.`,w.silent)return"<p>An error occurred:</p><pre>"+e(ee.message+"",!0)+"</pre>";throw ee}try{var K=Le.lex($,w);if(w.walkTokens){if(w.async)return Promise.all(X.walkTokens(K,w.walkTokens)).then(function(){return ce.parse(K,w)}).catch(j);X.walkTokens(K,w.walkTokens)}return ce.parse(K,w)}catch(ee){j(ee)}}X.options=X.setOptions=function($){return B(X.defaults,$),A(X.defaults),X},X.getDefaults=D,X.defaults=le.defaults,X.use=function(){for(var $=arguments.length,w=new Array($),I=0;I<$;I++)w[I]=arguments[I];var v=B.apply(void 0,[{}].concat(w)),O=X.defaults.extensions||{renderers:{},childTokens:{}},k;w.forEach(function(S){if(S.extensions&&(k=!0,S.extensions.forEach(function(K){if(!K.name)throw new Error("extension name required");if(K.renderer){var ee=O.renderers?O.renderers[K.name]:null;ee?O.renderers[K.name]=function(){for(var se=arguments.length,ge=new Array(se),pe=0;pe<se;pe++)ge[pe]=arguments[pe];var Pe=K.renderer.apply(this,ge);return Pe===!1&&(Pe=ee.apply(this,ge)),Pe}:O.renderers[K.name]=K.renderer}if(K.tokenizer){if(!K.level||K.level!=="block"&&K.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");O[K.level]?O[K.level].unshift(K.tokenizer):O[K.level]=[K.tokenizer],K.start&&(K.level==="block"?O.startBlock?O.startBlock.push(K.start):O.startBlock=[K.start]:K.level==="inline"&&(O.startInline?O.startInline.push(K.start):O.startInline=[K.start]))}K.childTokens&&(O.childTokens[K.name]=K.childTokens)})),S.renderer&&function(){var K=X.defaults.renderer||new Fe,ee=function(pe){var Pe=K[pe];K[pe]=function(){for(var Ae=arguments.length,De=new Array(Ae),Ie=0;Ie<Ae;Ie++)De[Ie]=arguments[Ie];var Oe=S.renderer[pe].apply(K,De);return Oe===!1&&(Oe=Pe.apply(K,De)),Oe}};for(var se in S.renderer)ee(se);v.renderer=K}(),S.tokenizer&&function(){var K=X.defaults.tokenizer||new fe,ee=function(pe){var Pe=K[pe];K[pe]=function(){for(var Ae=arguments.length,De=new Array(Ae),Ie=0;Ie<Ae;Ie++)De[Ie]=arguments[Ie];var Oe=S.tokenizer[pe].apply(K,De);return Oe===!1&&(Oe=Pe.apply(K,De)),Oe}};for(var se in S.tokenizer)ee(se);v.tokenizer=K}(),S.walkTokens){var j=X.defaults.walkTokens;v.walkTokens=function(K){var ee=[];return ee.push(S.walkTokens.call(this,K)),j&&(ee=ee.concat(j.call(this,K))),ee}}k&&(v.extensions=O),X.setOptions(v)})},X.walkTokens=function($,w){for(var I=[],v=function(){var j=k.value;switch(I=I.concat(w.call(X,j)),j.type){case"table":{for(var K=U(j.header),ee;!(ee=K()).done;){var se=ee.value;I=I.concat(X.walkTokens(se.tokens,w))}for(var ge=U(j.rows),pe;!(pe=ge()).done;)for(var Pe=pe.value,Ae=U(Pe),De;!(De=Ae()).done;){var Ie=De.value;I=I.concat(X.walkTokens(Ie.tokens,w))}break}case"list":{I=I.concat(X.walkTokens(j.items,w));break}default:X.defaults.extensions&&X.defaults.extensions.childTokens&&X.defaults.extensions.childTokens[j.type]?X.defaults.extensions.childTokens[j.type].forEach(function(Oe){I=I.concat(X.walkTokens(j[Oe],w))}):j.tokens&&(I=I.concat(X.walkTokens(j.tokens,w)))}},O=U($),k;!(k=O()).done;)v();return I},X.parseInline=function($,w){if(typeof $>"u"||$===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof $!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call($)+", string expected");w=B({},X.defaults,w||{}),F(w);try{var I=Le.lexInline($,w);return w.walkTokens&&X.walkTokens(I,w.walkTokens),ce.parseInline(I,w)}catch(v){if(v.message+=`
Please report this to https://github.com/markedjs/marked.`,w.silent)return"<p>An error occurred:</p><pre>"+e(v.message+"",!0)+"</pre>";throw v}},X.Parser=ce,X.parser=ce.parse,X.Renderer=Fe,X.TextRenderer=de,X.Lexer=Le,X.lexer=Le.lex,X.Tokenizer=fe,X.Slugger=ne,X.parse=X;var q=X.options,G=X.setOptions,P=X.use,V=X.walkTokens,p=X.parseInline,W=X,J=ce.parse,M=Le.lex;le.Lexer=Le,le.Parser=ce,le.Renderer=Fe,le.Slugger=ne,le.TextRenderer=de,le.Tokenizer=fe,le.getDefaults=D,le.lexer=M,le.marked=X,le.options=q,le.parse=W,le.parseInline=p,le.parser=J,le.setOptions=G,le.use=P,le.walkTokens=V,Object.defineProperty(le,"__esModule",{value:!0})}),define($e[80],we([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bS=void 0;class y{constructor(i,U=0,D=i.length,A=U-1){this.a=i,this.b=U,this.c=D,this.d=A}current(){return this.d===this.b-1||this.d===this.c?null:this.a[this.d]}next(){return this.d=Math.min(this.d+1,this.c),this.current()}previous(){return this.d=Math.max(this.d-1,this.b-1),this.current()}first(){return this.d=this.b,this.current()}last(){return this.d=this.c-1,this.current()}}t.$bS=y}),define($e[81],we([1,0,80]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dS=t.$cS=void 0;class L{constructor(D=[],A=10){this.h(D),this.b=A,this.d()}getHistory(){return this.j}add(D){this.a.delete(D),this.a.add(D),this.d()}next(){return this.c.next()}previous(){return this.g()!==0?this.c.previous():null}current(){return this.c.current()}first(){return this.c.first()}last(){return this.c.last()}isFirst(){return this.g()===0}isLast(){return this.g()>=this.j.length-1}isNowhere(){return this.c.current()===null}has(D){return this.a.has(D)}clear(){this.h([]),this.d()}d(){this.f();const D=this.j;this.c=new y.$bS(D,0,D.length,D.length)}f(){const D=this.j;D.length>this.b&&this.h(D.slice(D.length-this.b))}g(){const D=this.c.current();return D?this.j.indexOf(D):-1}h(D){this.a=new Set;for(const A of D)this.a.add(A)}get j(){const D=[];return this.a.forEach(A=>D.push(A)),D}}t.$cS=L;class i{get size(){return this.f}constructor(D,A=10){if(this.g=A,D.length<1)throw new Error("not supported");this.f=1,this.b=this.c=this.d={value:D[0],previous:void 0,next:void 0},this.a=new Set([D[0]]);for(let c=1;c<D.length;c++)this.add(D[c])}add(D){const A={value:D,previous:this.c,next:void 0};for(this.c.next=A,this.c=A,this.d=this.c,this.f++,this.a.has(D)?this.h(D):this.a.add(D);this.f>this.g;)this.a.delete(this.b.value),this.b=this.b.next,this.b.previous=void 0,this.f--}replaceLast(D){if(this.c.value===D)return D;const A=this.c.value;return this.a.delete(A),this.c.value=D,this.a.has(D)?this.h(D):this.a.add(D),A}prepend(D){if(this.f===this.g||this.a.has(D))return;const A={value:D,previous:void 0,next:this.b};this.b.previous=A,this.b=A,this.f++,this.a.add(D)}isAtEnd(){return this.d===this.c}current(){return this.d.value}previous(){return this.d.previous&&(this.d=this.d.previous),this.d.value}next(){return this.d.next&&(this.d=this.d.next),this.d.value}has(D){return this.a.has(D)}resetCursor(){return this.d=this.c,this.d.value}*[Symbol.iterator](){let D=this.b;for(;D;)yield D.value,D=D.next}h(D){let A=this.b;for(;A!==this.c;)A.value===D&&(A===this.b?(this.b=this.b.next,this.b.previous=void 0):(A.previous.next=A.next,A.next.previous=A.previous),this.f--),A=A.next}}t.$dS=i}),define($e[46],we([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Wl=t.$Vl=t.$Ul=t.rot=t.$Sl=void 0;function y(A,c,g){return Math.min(Math.max(A,c),g)}t.$Sl=y;function L(A,c){return(c+A%c)%c}t.rot=L;class i{constructor(){this.a=0}getNext(){return this.a++}}t.$Ul=i;class U{constructor(){this.a=1,this.b=0}update(c){return this.b=this.b+(c-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}t.$Vl=U;class D{constructor(c){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(c),this.c.fill(0,0,c)}update(c){const g=this.c[this.d];return this.c[this.d]=c,this.d=(this.d+1)%this.c.length,this.e-=g,this.e+=c,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}t.$Wl=D}),define($e[47],we([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var y;(function(L){function i(c,g){if(c.start>=g.end||g.start>=c.end)return{start:0,end:0};const f=Math.max(c.start,g.start),T=Math.min(c.end,g.end);return T-f<=0?{start:0,end:0}:{start:f,end:T}}L.intersect=i;function U(c){return c.end-c.start<=0}L.isEmpty=U;function D(c,g){return!U(i(c,g))}L.intersects=D;function A(c,g){const f=[],T={start:c.start,end:Math.min(g.start,c.end)},s={start:Math.max(g.end,c.start),end:c.end};return U(T)||f.push(T),U(s)||f.push(s),f}L.relativeComplement=A})(y||(t.Range=y={}))}),define($e[82],we([1,0,47]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7Q=t.$6Q=t.$5Q=t.$4Q=void 0;function L(c,g){const f=[];for(const T of g){if(c.start>=T.range.end)continue;if(c.end<T.range.start)break;const s=y.Range.intersect(c,T.range);y.Range.isEmpty(s)||f.push({range:s,size:T.size})}return f}t.$4Q=L;function i({start:c,end:g},f){return{start:c+f,end:g+f}}t.$5Q=i;function U(c){const g=[];let f=null;for(const T of c){const s=T.range.start,a=T.range.end,e=T.size;if(f&&e===f.size){f.range.end=a;continue}f={range:{start:s,end:a},size:e},g.push(f)}return g}t.$6Q=U;function D(...c){return U(c.reduce((g,f)=>g.concat(f),[]))}class A{get paddingTop(){return this.c}set paddingTop(g){this.b=this.b+g-this.c,this.c=g}constructor(g){this.a=[],this.b=0,this.c=0,this.c=g??0,this.b=this.c}splice(g,f,T=[]){const s=T.length-f,a=L({start:0,end:g},this.a),e=L({start:g+f,end:Number.POSITIVE_INFINITY},this.a).map(l=>({range:i(l.range,s),size:l.size})),h=T.map((l,m)=>({range:{start:g+m,end:g+m+1},size:l.size}));this.a=D(a,h,e),this.b=this.c+this.a.reduce((l,m)=>l+m.size*(m.range.end-m.range.start),0)}get count(){const g=this.a.length;return g?this.a[g-1].range.end:0}get size(){return this.b}indexAt(g){if(g<0)return-1;if(g<this.c)return 0;let f=0,T=this.c;for(const s of this.a){const a=s.range.end-s.range.start,e=T+a*s.size;if(g<e)return f+Math.floor((g-T)/s.size);f+=a,T=e}return f}indexAfter(g){return Math.min(this.indexAt(g)+1,this.count)}positionAt(g){if(g<0)return-1;let f=0,T=0;for(const s of this.a){const a=s.range.end-s.range.start,e=T+a;if(g<e)return this.c+f+(g-T)*s.size;f+=a*s.size,T=e}return-1}}t.$7Q=A}),define($e[83],we([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Kd=void 0;const y=globalThis.performance&&typeof globalThis.performance.now=="function";class L{static create(U){return new L(U)}constructor(U){this.c=y&&U===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$Kd=L}),define($e[4],we([1,0,6,43,2,45,83]),function(le,t,y,L,i,U,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Xd=t.$Wd=t.$Vd=t.$Ud=t.$Td=t.$Sd=t.$Rd=t.$Qd=t.$Pd=t.$Od=t.$Nd=t.$Md=t.Event=void 0;const A=!1,c=!1;var g;(function(x){x.None=()=>i.$Rc.None;function C(O){if(c){const{onDidAddListener:k}=O,S=e.create();let j=0;O.onDidAddListener=()=>{++j===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),S.print()),k?.()}}}function F(O,k){return Fe(O,()=>{},0,void 0,!0,void 0,k)}x.defer=F;function Q(O){return(k,S=null,j)=>{let K=!1,ee;return ee=O(se=>{if(!K)return ee?ee.dispose():K=!0,k.call(S,se)},null,j),K&&ee.dispose(),ee}}x.once=Q;function te(O,k,S){return Se((j,K=null,ee)=>O(se=>j.call(K,k(se)),null,ee),S)}x.map=te;function re(O,k,S){return Se((j,K=null,ee)=>O(se=>{k(se),j.call(K,se)},null,ee),S)}x.forEach=re;function fe(O,k,S){return Se((j,K=null,ee)=>O(se=>k(se)&&j.call(K,se),null,ee),S)}x.filter=fe;function ie(O){return O}x.signal=ie;function oe(...O){return(k,S=null,j)=>{const K=(0,i.$Oc)(...O.map(ee=>ee(se=>k.call(S,se))));return Le(K,j)}}x.any=oe;function be(O,k,S,j){let K=S;return te(O,ee=>(K=k(K,ee),K),j)}x.reduce=be;function Se(O,k){let S;const j={onWillAddFirstListener(){S=O(K.fire,K)},onDidRemoveLastListener(){S?.dispose()}};k||C(j);const K=new r(j);return k?.add(K),K.event}function Le(O,k){return k instanceof Array?k.push(O):k&&k.add(O),O}function Fe(O,k,S=100,j=!1,K=!1,ee,se){let ge,pe,Pe,Ae=0,De;const Ie={leakWarningThreshold:ee,onWillAddFirstListener(){ge=O(_e=>{Ae++,pe=k(pe,_e),j&&!Pe&&(Oe.fire(pe),pe=void 0),De=()=>{const He=pe;pe=void 0,Pe=void 0,(!j||Ae>1)&&Oe.fire(He),Ae=0},typeof S=="number"?(clearTimeout(Pe),Pe=setTimeout(De,S)):Pe===void 0&&(Pe=0,queueMicrotask(De))})},onWillRemoveListener(){K&&Ae>0&&De?.()},onDidRemoveLastListener(){De=void 0,ge.dispose()}};se||C(Ie);const Oe=new r(Ie);return se?.add(Oe),Oe.event}x.debounce=Fe;function de(O,k=0,S){return x.debounce(O,(j,K)=>j?(j.push(K),j):[K],k,void 0,!0,void 0,S)}x.accumulate=de;function ne(O,k=(j,K)=>j===K,S){let j=!0,K;return fe(O,ee=>{const se=j||!k(ee,K);return j=!1,K=ee,se},S)}x.latch=ne;function ce(O,k,S){return[x.filter(O,k,S),x.filter(O,j=>!k(j),S)]}x.split=ce;function X(O,k=!1,S=[],j){let K=S.slice(),ee=O(pe=>{K?K.push(pe):ge.fire(pe)});j&&j.add(ee);const se=()=>{K?.forEach(pe=>ge.fire(pe)),K=null},ge=new r({onWillAddFirstListener(){ee||(ee=O(pe=>ge.fire(pe)),j&&j.add(ee))},onDidAddFirstListener(){K&&(k?setTimeout(se):se())},onDidRemoveLastListener(){ee&&ee.dispose(),ee=null}});return j&&j.add(ge),ge.event}x.buffer=X;function q(O,k){return(j,K,ee)=>{const se=k(new P);return O(function(ge){const pe=se.evaluate(ge);pe!==G&&j.call(K,pe)},void 0,ee)}}x.chain=q;const G=Symbol("HaltChainable");class P{constructor(){this.f=[]}map(k){return this.f.push(k),this}forEach(k){return this.f.push(S=>(k(S),S)),this}filter(k){return this.f.push(S=>k(S)?S:G),this}reduce(k,S){let j=S;return this.f.push(K=>(j=k(j,K),j)),this}latch(k=(S,j)=>S===j){let S=!0,j;return this.f.push(K=>{const ee=S||!k(K,j);return S=!1,j=K,ee?K:G}),this}evaluate(k){for(const S of this.f)if(k=S(k),k===G)break;return k}}function V(O,k,S=j=>j){const j=(...ge)=>se.fire(S(...ge)),K=()=>O.on(k,j),ee=()=>O.removeListener(k,j),se=new r({onWillAddFirstListener:K,onDidRemoveLastListener:ee});return se.event}x.fromNodeEventEmitter=V;function p(O,k,S=j=>j){const j=(...ge)=>se.fire(S(...ge)),K=()=>O.addEventListener(k,j),ee=()=>O.removeEventListener(k,j),se=new r({onWillAddFirstListener:K,onDidRemoveLastListener:ee});return se.event}x.fromDOMEventEmitter=p;function W(O){return new Promise(k=>Q(O)(k))}x.toPromise=W;function J(O){const k=new r;return O.then(S=>{k.fire(S)},()=>{k.fire(void 0)}).finally(()=>{k.dispose()}),k.event}x.fromPromise=J;function M(O,k,S){return k(S),O(j=>k(j))}x.runAndSubscribe=M;function $(O,k){let S=null;function j(ee){S?.dispose(),S=new i.$Qc,k(ee,S)}j(void 0);const K=O(ee=>j(ee));return(0,i.$Pc)(()=>{K.dispose(),S?.dispose()})}x.runAndSubscribeWithStore=$;class w{constructor(k,S){this._observable=k,this.f=0,this.g=!1;const j={onWillAddFirstListener:()=>{k.addObserver(this)},onDidRemoveLastListener:()=>{k.removeObserver(this)}};S||C(j),this.emitter=new r(j),S&&S.add(this.emitter)}beginUpdate(k){this.f++}handlePossibleChange(k){}handleChange(k,S){this.g=!0}endUpdate(k){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function I(O,k){return new w(O,k).emitter.event}x.fromObservable=I;function v(O){return k=>{let S=0,j=!1;const K={beginUpdate(){S++},endUpdate(){S--,S===0&&(O.reportChanges(),j&&(j=!1,k()))},handlePossibleChange(){},handleChange(){j=!0}};return O.addObserver(K),O.reportChanges(),{dispose(){O.removeObserver(K)}}}}x.fromObservableLight=v})(g||(t.Event=g={}));class f{static{this.all=new Set}static{this.f=0}constructor(C){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${C}_${f.f++}`,f.all.add(this)}start(C){this.g=new D.$Kd,this.listenerCount=C}stop(){if(this.g){const C=this.g.elapsed();this.durations.push(C),this.elapsedOverall+=C,this.invocationCount+=1,this.g=void 0}}}t.$Md=f;let T=-1;function s(x){const C=T;return T=x,{dispose(){T=C}}}t.$Nd=s;class a{constructor(C,F=Math.random().toString(18).slice(2,5)){this.threshold=C,this.name=F,this.g=0}dispose(){this.f?.clear()}check(C,F){const Q=this.threshold;if(Q<=0||F<Q)return;this.f||(this.f=new Map);const te=this.f.get(C.value)||0;if(this.f.set(C.value,te+1),this.g-=1,this.g<=0){this.g=Q*.5;let re,fe=0;for(const[ie,oe]of this.f)(!re||fe<oe)&&(re=ie,fe=oe);console.warn(`[${this.name}] potential listener LEAK detected, having ${F} listeners already. MOST frequent listener (${fe}):`),console.warn(re)}return()=>{const re=this.f.get(C.value)||0;this.f.set(C.value,re-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(C){this.value=C}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let h=0;class l{constructor(C){this.value=C,this.id=h++}}const m=2,n=(x,C)=>{if(x instanceof l)C(x);else for(let F=0;F<x.length;F++){const Q=x[F];Q&&C(Q)}};class r{constructor(C){this.w=0,this.f=C,this.g=T>0||this.f?.leakWarningThreshold?new a(this.f?.leakWarningThreshold??T):void 0,this.j=this.f?._profName?new f(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(A){const C=this.t;queueMicrotask(()=>{n(C,F=>F.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(C,F,Q)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),i.$Rc.None;if(this.m)return i.$Rc.None;F&&(C=C.bind(F));const te=new l(C);let re,fe;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(te.stack=e.create(),re=this.g.check(te.stack,this.w+1)),A&&(te.stack=fe??e.create()),this.t?this.t instanceof l?(this.u??=new u,this.t=[this.t,te]):this.t.push(te):(this.f?.onWillAddFirstListener?.(this),this.t=te,this.f?.onDidAddFirstListener?.(this)),this.w++;const ie=(0,i.$Pc)(()=>{re?.(),this.x(te)});return Q instanceof i.$Qc?Q.add(ie):Array.isArray(Q)&&Q.push(ie),ie},this.q}x(C){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const F=this.t,Q=F.indexOf(C);if(Q===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,F[Q]=void 0;const te=this.u.current===this;if(this.w*m<=F.length){let re=0;for(let fe=0;fe<F.length;fe++)F[fe]?F[re++]=F[fe]:te&&(this.u.end--,re<this.u.i&&this.u.i--);F.length=re}}y(C,F){if(!C)return;const Q=this.f?.onListenerError||y.$Z;if(!Q){C.value(F);return}try{C.value(F)}catch(te){Q(te)}}z(C){const F=C.current.t;for(;C.i<C.end;)this.y(F[C.i++],C.value);C.reset()}fire(C){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof l)this.y(this.t,C);else{const F=this.u;F.enqueue(this,C,this.t.length),this.z(F)}this.j?.stop()}hasListeners(){return this.w>0}}t.$Od=r;const b=()=>new u;t.$Pd=b;class u{constructor(){this.i=-1,this.end=0}enqueue(C,F,Q){this.i=0,this.end=Q,this.current=C,this.value=F}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class o extends r{async fireAsync(C,F,Q){if(this.t)for(this.h||(this.h=new U.$1c),n(this.t,te=>this.h.push([te.value,C]));this.h.size>0&&!F.isCancellationRequested;){const[te,re]=this.h.shift(),fe=[],ie={...re,token:F,waitUntil:oe=>{if(Object.isFrozen(fe))throw new Error("waitUntil can NOT be called asynchronous");Q&&(oe=Q(oe,te)),fe.push(oe)}};try{te(ie)}catch(oe){(0,y.$Z)(oe);continue}Object.freeze(fe),await Promise.allSettled(fe).then(oe=>{for(const be of oe)be.status==="rejected"&&(0,y.$Z)(be.reason)})}}}t.$Qd=o;class N extends r{get isPaused(){return this.h!==0}constructor(C){super(C),this.h=0,this.s=new U.$1c,this.A=C?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const C=Array.from(this.s);this.s.clear(),super.fire(this.A(C))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(C){this.w&&(this.h!==0?this.s.push(C):super.fire(C))}}t.$Rd=N;class z extends N{constructor(C){super(C),this.k=C.delay??100}fire(C){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(C)}}t.$Sd=z;class R extends r{constructor(C){super(C),this.h=[],this.k=C?.merge}fire(C){this.hasListeners()&&(this.h.push(C),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(F=>super.fire(F)),this.h=[]}))}}t.$Td=R;class d{constructor(){this.g=!1,this.h=[],this.f=new r({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(C){const F={event:C,listener:null};this.h.push(F),this.g&&this.m(F);const Q=()=>{this.g&&this.o(F);const te=this.h.indexOf(F);this.h.splice(te,1)};return(0,i.$Pc)((0,L.$cb)(Q))}j(){this.g=!0,this.h.forEach(C=>this.m(C))}k(){this.g=!1,this.h.forEach(C=>this.o(C))}m(C){C.listener=C.event(F=>this.f.fire(F))}o(C){C.listener&&C.listener.dispose(),C.listener=null}dispose(){this.f.dispose()}}t.$Ud=d;class E{constructor(C,F,Q,te){this.f=new i.$Qc;const re=this.f.add(new d),fe=this.f.add(new i.$Zc);function ie(oe){fe.set(oe,re.add(te(oe)))}for(const oe of C)ie(oe);this.f.add(F(oe=>{ie(oe)})),this.f.add(Q(oe=>{fe.deleteAndDispose(oe)})),this.event=re.event}dispose(){this.f.dispose()}}t.$Vd=E;class B{constructor(){this.f=[]}wrapEvent(C){return(F,Q,te)=>C(re=>{const fe=this.f[this.f.length-1];fe?fe.push(()=>F.call(Q,re)):F.call(Q,re)},void 0,te)}bufferEvents(C){const F=[];this.f.push(F);const Q=C();return this.f.pop(),F.forEach(te=>te()),Q}}t.$Wd=B;class H{constructor(){this.f=!1,this.g=g.None,this.h=i.$Rc.None,this.j=new r({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(C){this.g=C,this.f&&(this.h.dispose(),this.h=C(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$Xd=H}),define($e[17],we([1,0,14,4,2]),function(le,t,y,L,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$MO=t.$LO=t.$KO=t.$JO=t.$IO=t.$HO=t.$GO=t.$FO=t.$EO=t.$DO=t.$CO=t.$BO=t.$AO=t.$zO=t.$yO=t.$xO=t.$wO=t.$vO=void 0;class U{constructor(){this.a=0,this.b=1,this.c=!1,this.d=new L.$Od,this.onDidChangeFullscreen=this.d.event}static{this.INSTANCE=new U}getZoomLevel(){return this.a}setZoomLevel(u){this.a!==u&&(this.a=u)}getZoomFactor(){return this.b}setZoomFactor(u){this.b=u}setFullscreen(u){this.c!==u&&(this.c=u,this.d.fire())}isFullscreen(){return this.c}}class D extends i.$Rc{constructor(){super(),this.a=this.B(new L.$Od),this.onDidChange=this.a.event,this.b=()=>this.f(!0),this.c=null,this.f(!1)}f(u){this.c?.removeEventListener("change",this.b),this.c=y.$window.matchMedia(`(resolution: ${y.$window.devicePixelRatio}dppx)`),this.c.addEventListener("change",this.b),u&&this.a.fire()}}class A extends i.$Rc{get value(){return this.b}constructor(){super(),this.a=this.B(new L.$Od),this.onDidChange=this.a.event,this.b=this.c();const u=this.B(new D);this.B(u.onDidChange(()=>{this.b=this.c(),this.a.fire(this.b)}))}c(){const u=document.createElement("canvas").getContext("2d"),o=y.$window.devicePixelRatio||1,N=u.webkitBackingStorePixelRatio||u.mozBackingStorePixelRatio||u.msBackingStorePixelRatio||u.oBackingStorePixelRatio||u.backingStorePixelRatio||1;return o/N}}class c{constructor(){this.a=null}b(){return this.a||(this.a=(0,i.$Kc)(new A)),this.a}get value(){return this.b().value}get onDidChange(){return this.b().onDidChange}}function g(b,u){typeof b=="string"&&(b=y.$window.matchMedia(b)),b.addEventListener("change",u)}t.$vO=g,t.$wO=new c;function f(b){U.INSTANCE.setZoomLevel(b)}t.$xO=f;function T(){return U.INSTANCE.getZoomLevel()}t.$yO=T;function s(){return U.INSTANCE.getZoomFactor()}t.$zO=s;function a(b){U.INSTANCE.setZoomFactor(b)}t.$AO=a;function e(b){U.INSTANCE.setFullscreen(b)}t.$BO=e;function h(){return U.INSTANCE.isFullscreen()}t.$CO=h,t.$DO=U.INSTANCE.onDidChangeFullscreen;const l=navigator.userAgent;t.$EO=l.indexOf("Firefox")>=0,t.$FO=l.indexOf("AppleWebKit")>=0,t.$GO=l.indexOf("Chrome")>=0,t.$HO=!t.$GO&&l.indexOf("Safari")>=0,t.$IO=!t.$GO&&!t.$HO&&t.$FO,t.$JO=l.indexOf("Electron/")>=0,t.$KO=l.indexOf("Android")>=0;let m=!1;if(y.$window.matchMedia){const b=y.$window.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),u=y.$window.matchMedia("(display-mode: fullscreen)");m=b.matches,g(b,({matches:o})=>{m&&u.matches||(m=o)})}function n(){return m}t.$LO=n;function r(){return navigator?.windowControlsOverlay?.visible}t.$MO=r}),define($e[22],we([1,0,4]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$VQ=void 0;class L{get event(){return this.a.event}constructor(U,D,A){const c=g=>this.a.fire(g);this.a=new y.$Od({onWillAddFirstListener:()=>U.addEventListener(D,c,A),onDidRemoveLastListener:()=>U.removeEventListener(D,c,A)})}dispose(){this.a.dispose()}}t.$VQ=L}),define($e[29],we([1,0,4]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Yd=t.CancellationToken=void 0;const L=Object.freeze(function(A,c){const g=setTimeout(A.bind(c),0);return{dispose(){clearTimeout(g)}}});var i;(function(A){function c(g){return g===A.None||g===A.Cancelled||g instanceof U?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}A.isCancellationToken=c,A.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:y.Event.None}),A.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(i||(t.CancellationToken=i={}));class U{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?L:(this.b||(this.b=new y.$Od),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class D{constructor(c){this.f=void 0,this.g=void 0,this.g=c&&c.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new U),this.f}cancel(){this.f?this.f instanceof U&&this.f.cancel():this.f=i.Cancelled}dispose(c=!1){c&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof U&&this.f.dispose():this.f=i.None}}t.$Yd=D}),define($e[84],we([1,0,29]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ze=t.$ye=t.$xe=void 0;class L{constructor(A){this.b=A,this.a=null}get(){if(this.a)return this.a;const A=new y.$Yd,c=this.b(A.token);return this.a={promise:c,dispose:()=>{this.a=null,A.cancel(),A.dispose()}},this.a}}t.$xe=L;class i{constructor(A){this.c=A,this.a=void 0,this.b=void 0}get(A){const c=JSON.stringify(A);return this.b!==c&&(this.b=c,this.a=this.c(A)),this.a}}t.$ye=i;class U{get cachedValues(){return this.a}constructor(A){this.b=A,this.a=new Map}get(A){if(this.a.has(A))return this.a.get(A);const c=this.b(A);return this.a.set(A,c),c}}t.$ze=U}),define($e[48],we([1,0,4,2]),function(le,t,y,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2r=t.$1r=t.$Zr=t.$Yr=t.ScrollbarVisibility=void 0;var i;(function(a){a[a.Auto=1]="Auto",a[a.Hidden=2]="Hidden",a[a.Visible=3]="Visible"})(i||(t.ScrollbarVisibility=i={}));class U{constructor(e,h,l,m,n,r,b){this.c=e,this._scrollStateBrand=void 0,this.c&&(h=h|0,l=l|0,m=m|0,n=n|0,r=r|0,b=b|0),this.rawScrollLeft=m,this.rawScrollTop=b,h<0&&(h=0),m+h>l&&(m=l-h),m<0&&(m=0),n<0&&(n=0),b+n>r&&(b=r-n),b<0&&(b=0),this.width=h,this.scrollWidth=l,this.scrollLeft=m,this.height=n,this.scrollHeight=r,this.scrollTop=b}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,h){return new U(this.c,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,h?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,h?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new U(this.c,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,h){const l=this.width!==e.width,m=this.scrollWidth!==e.scrollWidth,n=this.scrollLeft!==e.scrollLeft,r=this.height!==e.height,b=this.scrollHeight!==e.scrollHeight,u=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:h,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:l,scrollWidthChanged:m,scrollLeftChanged:n,heightChanged:r,scrollHeightChanged:b,scrollTopChanged:u}}}t.$Yr=U;class D extends L.$Rc{constructor(e){super(),this._scrollableBrand=void 0,this.j=this.B(new y.$Od),this.onScroll=this.j.event,this.c=e.smoothScrollDuration,this.f=e.scheduleAtNextAnimationFrame,this.g=new U(e.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(e){this.c=e}validateScrollPosition(e){return this.g.withScrollPosition(e)}getScrollDimensions(){return this.g}setScrollDimensions(e,h){const l=this.g.withScrollDimensions(e,h);this.n(l,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(e){const h=this.g.withScrollPosition(e);this.h&&(this.h.dispose(),this.h=null),this.n(h,!1)}setScrollPositionSmooth(e,h){if(this.c===0)return this.setScrollPositionNow(e);if(this.h){e={scrollLeft:typeof e.scrollLeft>"u"?this.h.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this.h.to.scrollTop:e.scrollTop};const l=this.g.withScrollPosition(e);if(this.h.to.scrollLeft===l.scrollLeft&&this.h.to.scrollTop===l.scrollTop)return;let m;h?m=new f(this.h.from,l,this.h.startTime,this.h.duration):m=this.h.combine(this.g,l,this.c),this.h.dispose(),this.h=m}else{const l=this.g.withScrollPosition(e);this.h=f.start(this.g,l,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const e=this.h.tick(),h=this.g.withScrollPosition(e);if(this.n(h,!0),!!this.h){if(e.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(e,h){const l=this.g;l.equals(e)||(this.g=e,this.j.fire(this.g.createScrollEvent(l,h)))}}t.$Zr=D;class A{constructor(e,h,l){this.scrollLeft=e,this.scrollTop=h,this.isDone=l}}t.$1r=A;function c(a,e){const h=e-a;return function(l){return a+h*s(l)}}function g(a,e,h){return function(l){return l<h?a(l/h):e((l-h)/(1-h))}}class f{constructor(e,h,l,m){this.from=e,this.to=h,this.duration=m,this.startTime=l,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(e,h,l){if(Math.abs(e-h)>2.5*l){let n,r;return e<h?(n=e+.75*l,r=h-.75*l):(n=e-.75*l,r=h+.75*l),g(c(e,n),c(r,h),.33)}return c(e,h)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(e){const h=(e-this.startTime)/this.duration;if(h<1){const l=this.c(h),m=this.d(h);return new A(l,m,!1)}return new A(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,h,l){return f.start(e,h,l)}static start(e,h,l){l=l+10;const m=Date.now()-10;return new f(e,h,m,l)}}t.$2r=f;function T(a){return Math.pow(a,3)}function s(a){return 1-T(1-a)}}),define($e[85],we([1,0,6,2]),function(le,t,y,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$be=t.$ae=t.$_d=t.$$d=t.$0d=t.$9d=t.$8d=t.$7d=t.$6d=t.$5d=t.$4d=t.$3d=t.$2d=t.$1d=t.$Zd=void 0;function i(b){const u=b;return u?typeof u.read=="function":!1}t.$Zd=i;function U(b){const u=b;return u?[u.on,u.pause,u.resume,u.destroy].every(o=>typeof o=="function"):!1}t.$1d=U;function D(b){const u=b;return u?U(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}t.$2d=D;function A(b,u){return new c(b,u)}t.$3d=A;class c{constructor(u,o){this.e=u,this.f=o,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(u){if(!this.a.destroyed){if(this.a.flowing)this.g(u);else if(this.b.data.push(u),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(o=>this.d.push(o))}}error(u){this.a.destroyed||(this.a.flowing?this.h(u):this.b.error.push(u))}end(u){this.a.destroyed||(typeof u<"u"&&this.write(u),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(u){this.c.data.slice(0).forEach(o=>o(u))}h(u){this.c.error.length===0?(0,y.$Z)(u):this.c.error.slice(0).forEach(o=>o(u))}i(){this.c.end.slice(0).forEach(u=>u())}on(u,o){if(!this.a.destroyed)switch(u){case"data":this.c.data.push(o),this.resume();break;case"end":this.c.end.push(o),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(o),this.a.flowing&&this.k();break}}removeListener(u,o){if(this.a.destroyed)return;let N;switch(u){case"data":N=this.c.data;break;case"end":N=this.c.end;break;case"error":N=this.c.error;break}if(N){const z=N.indexOf(o);z>=0&&N.splice(z,1)}}j(){if(this.b.data.length>0){const u=this.e(this.b.data);this.g(u),this.b.data.length=0;const o=[...this.d];this.d.length=0,o.forEach(N=>N())}}k(){if(this.c.error.length>0){for(const u of this.b.error)this.h(u);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function g(b,u){const o=[];let N;for(;(N=b.read())!==null;)o.push(N);return u(o)}t.$4d=g;function f(b,u,o){const N=[];let z;for(;(z=b.read())!==null&&N.length<o;)N.push(z);return z===null&&N.length>0?u(N):{read:()=>{if(N.length>0)return N.shift();if(typeof z<"u"){const R=z;return z=void 0,R}return b.read()}}}t.$5d=f;function T(b,u){return new Promise((o,N)=>{const z=[];s(b,{onData:R=>{u&&z.push(R)},onError:R=>{u?N(R):o(void 0)},onEnd:()=>{o(u?u(z):void 0)}})})}t.$6d=T;function s(b,u,o){b.on("error",N=>{o?.isCancellationRequested||u.onError(N)}),b.on("end",()=>{o?.isCancellationRequested||u.onEnd()}),b.on("data",N=>{o?.isCancellationRequested||u.onData(N)})}t.$7d=s;function a(b,u){return new Promise((o,N)=>{const z=new L.$Qc,R=[],d=H=>{if(R.push(H),R.length>u)return z.dispose(),b.pause(),o({stream:b,buffer:R,ended:!1})},E=H=>(z.dispose(),N(H)),B=()=>(z.dispose(),o({stream:b,buffer:R,ended:!0}));z.add((0,L.$Pc)(()=>b.removeListener("error",E))),b.on("error",E),z.add((0,L.$Pc)(()=>b.removeListener("end",B))),b.on("end",B),z.add((0,L.$Pc)(()=>b.removeListener("data",d))),b.on("data",d)})}t.$8d=a;function e(b,u){const o=A(u);return o.end(b),o}t.$9d=e;function h(){const b=A(()=>{throw new Error("not supported")});return b.end(),b}t.$0d=h;function l(b){let u=!1;return{read:()=>u?null:(u=!0,b)}}t.$$d=l;function m(b,u,o){const N=A(o);return s(b,{onData:z=>N.write(u.data(z)),onError:z=>N.error(u.error?u.error(z):z),onEnd:()=>N.end()}),N}t.$_d=m;function n(b,u,o){let N=!1;return{read:()=>{const z=u.read();return N?z:(N=!0,z!==null?o([b,z]):b)}}}t.$ae=n;function r(b,u,o){let N=!1;const z=A(o);return s(u,{onData:R=>N?z.write(R):(N=!0,z.write(o([b,R]))),onError:R=>z.error(R),onEnd:()=>{N||(N=!0,z.write(b)),z.end()}}),z}t.$be=r}),define($e[33],we([1,0,28,85]),function(le,t,y,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$we=t.$ve=t.$ue=t.$te=t.$se=t.$re=t.$qe=t.$pe=t.$oe=t.$ne=t.$me=t.$le=t.$ke=t.$je=t.$ie=t.$he=t.$ge=t.$fe=t.$ee=t.$de=t.$ce=void 0;const i=typeof Buffer<"u",U=new y.$U(()=>new Uint8Array(256));let D,A;class c{static alloc(F){return i?new c(Buffer.allocUnsafe(F)):new c(new Uint8Array(F))}static wrap(F){return i&&!Buffer.isBuffer(F)&&(F=Buffer.from(F.buffer,F.byteOffset,F.byteLength)),new c(F)}static fromString(F,Q){return!(Q?.dontUseNodeBuffer||!1)&&i?new c(Buffer.from(F)):(D||(D=new TextEncoder),new c(D.encode(F)))}static fromByteArray(F){const Q=c.alloc(F.length);for(let te=0,re=F.length;te<re;te++)Q.buffer[te]=F[te];return Q}static concat(F,Q){if(typeof Q>"u"){Q=0;for(let fe=0,ie=F.length;fe<ie;fe++)Q+=F[fe].byteLength}const te=c.alloc(Q);let re=0;for(let fe=0,ie=F.length;fe<ie;fe++){const oe=F[fe];te.set(oe,re),re+=oe.byteLength}return te}constructor(F){this.buffer=F,this.byteLength=this.buffer.byteLength}clone(){const F=c.alloc(this.byteLength);return F.set(this),F}toString(){return i?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(F,Q){return new c(this.buffer.subarray(F,Q))}set(F,Q){if(F instanceof c)this.buffer.set(F.buffer,Q);else if(F instanceof Uint8Array)this.buffer.set(F,Q);else if(F instanceof ArrayBuffer)this.buffer.set(new Uint8Array(F),Q);else if(ArrayBuffer.isView(F))this.buffer.set(new Uint8Array(F.buffer,F.byteOffset,F.byteLength),Q);else throw new Error("Unknown argument 'array'")}readUInt32BE(F){return s(this.buffer,F)}writeUInt32BE(F,Q){a(this.buffer,F,Q)}readUInt32LE(F){return e(this.buffer,F)}writeUInt32LE(F,Q){h(this.buffer,F,Q)}readUInt8(F){return l(this.buffer,F)}writeUInt8(F,Q){m(this.buffer,F,Q)}indexOf(F,Q=0){return g(this.buffer,F instanceof c?F.buffer:F,Q)}}t.$ce=c;function g(C,F,Q=0){const te=F.byteLength,re=C.byteLength;if(te===0)return 0;if(te===1)return C.indexOf(F[0]);if(te>re-Q)return-1;const fe=U.value;fe.fill(F.length);for(let Se=0;Se<F.length;Se++)fe[F[Se]]=F.length-Se-1;let ie=Q+F.length-1,oe=ie,be=-1;for(;ie<re;)if(C[ie]===F[oe]){if(oe===0){be=ie;break}ie--,oe--}else ie+=Math.max(F.length-oe,fe[C[ie]]),oe=F.length-1;return be}t.$de=g;function f(C,F){return C[F+0]<<0>>>0|C[F+1]<<8>>>0}t.$ee=f;function T(C,F,Q){C[Q+0]=F&255,F=F>>>8,C[Q+1]=F&255}t.$fe=T;function s(C,F){return C[F]*2**24+C[F+1]*2**16+C[F+2]*2**8+C[F+3]}t.$ge=s;function a(C,F,Q){C[Q+3]=F,F=F>>>8,C[Q+2]=F,F=F>>>8,C[Q+1]=F,F=F>>>8,C[Q]=F}t.$he=a;function e(C,F){return C[F+0]<<0>>>0|C[F+1]<<8>>>0|C[F+2]<<16>>>0|C[F+3]<<24>>>0}t.$ie=e;function h(C,F,Q){C[Q+0]=F&255,F=F>>>8,C[Q+1]=F&255,F=F>>>8,C[Q+2]=F&255,F=F>>>8,C[Q+3]=F&255}t.$je=h;function l(C,F){return C[F]}t.$ke=l;function m(C,F,Q){C[Q]=F}t.$le=m;function n(C){return L.$4d(C,F=>c.concat(F))}t.$me=n;function r(C){return L.$$d(C)}t.$ne=r;function b(C){return L.$6d(C,F=>c.concat(F))}t.$oe=b;async function u(C){return C.ended?c.concat(C.buffer):c.concat([...C.buffer,await b(C.stream)])}t.$pe=u;function o(C){return L.$9d(C,F=>c.concat(F))}t.$qe=o;function N(C){return L.$_d(C,{data:F=>typeof F=="string"?c.fromString(F):c.wrap(F)},F=>c.concat(F))}t.$re=N;function z(C){return L.$3d(F=>c.concat(F),C)}t.$se=z;function R(C,F){return L.$ae(C,F,Q=>c.concat(Q))}t.$te=R;function d(C,F){return L.$be(C,F,Q=>c.concat(Q))}t.$ue=d;function E(C){let F=0,Q=0,te=0;const re=new Uint8Array(Math.floor(C.length/4*3)),fe=oe=>{switch(Q){case 3:re[te++]=F|oe,Q=0;break;case 2:re[te++]=F|oe>>>2,F=oe<<6,Q=3;break;case 1:re[te++]=F|oe>>>4,F=oe<<4,Q=2;break;default:F=oe<<2,Q=1}};for(let oe=0;oe<C.length;oe++){const be=C.charCodeAt(oe);if(be>=65&&be<=90)fe(be-65);else if(be>=97&&be<=122)fe(be-97+26);else if(be>=48&&be<=57)fe(be-48+52);else if(be===43||be===45)fe(62);else if(be===47||be===95)fe(63);else{if(be===61)break;throw new SyntaxError(`Unexpected base64 character ${C[oe]}`)}}const ie=te;for(;Q>0;)fe(0);return c.wrap(re).slice(0,ie)}t.$ve=E;const B="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",H="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function x({buffer:C},F=!0,Q=!1){const te=Q?H:B;let re="";const fe=C.byteLength%3;let ie=0;for(;ie<C.byteLength-fe;ie+=3){const oe=C[ie+0],be=C[ie+1],Se=C[ie+2];re+=te[oe>>>2],re+=te[(oe<<4|be>>>4)&63],re+=te[(be<<2|Se>>>6)&63],re+=te[Se&63]}if(fe===1){const oe=C[ie+0];re+=te[oe>>>2],re+=te[oe<<4&63],F&&(re+="==")}else if(fe===2){const oe=C[ie+0],be=C[ie+1];re+=te[oe>>>2],re+=te[(oe<<4|be>>>4)&63],re+=te[be<<2&63],F&&(re+="=")}return re}t.$we=x}),define($e[12],we([1,0,84,28]),function(le,t,y,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yf=t.$xf=t.$wf=t.$vf=t.GraphemeBreakType=t.$uf=t.$tf=t.$sf=t.$rf=t.$qf=t.$pf=t.$of=t.$nf=t.$mf=t.$lf=t.$kf=t.$jf=t.$if=t.$hf=t.$gf=t.$ff=t.$ef=t.$df=t.$cf=t.$bf=t.$af=t.$_e=t.$$e=t.$0e=t.$9e=t.$8e=t.$7e=t.$6e=t.$5e=t.$4e=t.$3e=t.$2e=t.$1e=t.$Ze=t.$Ye=t.$Xe=t.$We=t.$Ve=t.$Ue=t.$Te=t.$Se=t.$Re=t.$Qe=t.$Pe=t.$Oe=t.$Ne=t.$Me=t.$Le=t.$Ke=t.$Je=t.$Ie=t.$He=t.$Ge=t.$Fe=t.$Ee=t.$De=t.$Ce=void 0;function i(Z){return!Z||typeof Z!="string"?!0:Z.trim().length===0}t.$Ce=i;const U=/{(\d+)}/g;function D(Z,...he){return he.length===0?Z:Z.replace(U,function(ve,Ee){const Ce=parseInt(Ee,10);return isNaN(Ce)||Ce<0||Ce>=he.length?ve:he[Ce]})}t.$De=D;const A=/{([^}]+)}/g;function c(Z,he){return Object.keys(he).length===0?Z:Z.replace(A,(ve,Ee)=>he[Ee]??ve)}t.$Ee=c;function g(Z){return Z.replace(/[<>&]/g,function(he){switch(he){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return he}})}t.$Fe=g;function f(Z){return Z.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.$Ge=f;function T(Z,he){let ve=0;const Ee=he.charCodeAt(0);for(let Ce=Z.length-1;Ce>=0;Ce--)Z.charCodeAt(Ce)===Ee&&ve++;return ve}t.$He=T;function s(Z,he,ve="\u2026"){return Z.length<=he?Z:`${Z.substr(0,he)}${ve}`}t.$Ie=s;function a(Z,he=" "){const ve=e(Z,he);return h(ve,he)}t.$Je=a;function e(Z,he){if(!Z||!he)return Z;const ve=he.length;if(ve===0||Z.length===0)return Z;let Ee=0;for(;Z.indexOf(he,Ee)===Ee;)Ee=Ee+ve;return Z.substring(Ee)}t.$Ke=e;function h(Z,he){if(!Z||!he)return Z;const ve=he.length,Ee=Z.length;if(ve===0||Ee===0)return Z;let Ce=Ee,Be=-1;for(;Be=Z.lastIndexOf(he,Ce-1),!(Be===-1||Be+ve!==Ce);){if(Be===0)return"";Ce=Be}return Z.substring(0,Ce)}t.$Le=h;function l(Z){return Z.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.$Me=l;function m(Z){return Z.replace(/\*/g,"")}t.$Ne=m;function n(Z,he,ve={}){if(!Z)throw new Error("Cannot create regex from empty string");he||(Z=f(Z)),ve.wholeWord&&(/\B/.test(Z.charAt(0))||(Z="\\b"+Z),/\B/.test(Z.charAt(Z.length-1))||(Z=Z+"\\b"));let Ee="";return ve.global&&(Ee+="g"),ve.matchCase||(Ee+="i"),ve.multiline&&(Ee+="m"),ve.unicode&&(Ee+="u"),new RegExp(Z,Ee)}t.$Oe=n;function r(Z){return Z.source==="^"||Z.source==="^$"||Z.source==="$"||Z.source==="^\\s*$"?!1:!!(Z.exec("")&&Z.lastIndex===0)}t.$Pe=r;function b(Z){return Z.split(/\r\n|\r|\n/)}t.$Qe=b;function u(Z){for(let he=0,ve=Z.length;he<ve;he++){const Ee=Z.charCodeAt(he);if(Ee!==32&&Ee!==9)return he}return-1}t.$Re=u;function o(Z,he=0,ve=Z.length){for(let Ee=he;Ee<ve;Ee++){const Ce=Z.charCodeAt(Ee);if(Ce!==32&&Ce!==9)return Z.substring(he,Ee)}return Z.substring(he,ve)}t.$Se=o;function N(Z,he=Z.length-1){for(let ve=he;ve>=0;ve--){const Ee=Z.charCodeAt(ve);if(Ee!==32&&Ee!==9)return ve}return-1}t.$Te=N;function z(Z,he,ve){const Ee=[];let Ce=0;for(const Be of Z.matchAll(he)){if(Ee.push(Z.slice(Ce,Be.index)),Be.index===void 0)throw new Error("match.index should be defined");Ce=Be.index+Be[0].length,Ee.push(ve(Be[0],...Be.slice(1),Be.index,Z,Be.groups))}return Ee.push(Z.slice(Ce)),Promise.all(Ee).then(Be=>Be.join(""))}t.$Ue=z;function R(Z,he){return Z<he?-1:Z>he?1:0}t.$Ve=R;function d(Z,he,ve=0,Ee=Z.length,Ce=0,Be=he.length){for(;ve<Ee&&Ce<Be;ve++,Ce++){const Je=Z.charCodeAt(ve),Ke=he.charCodeAt(Ce);if(Je<Ke)return-1;if(Je>Ke)return 1}const Ue=Ee-ve,Ze=Be-Ce;return Ue<Ze?-1:Ue>Ze?1:0}t.$We=d;function E(Z,he){return B(Z,he,0,Z.length,0,he.length)}t.$Xe=E;function B(Z,he,ve=0,Ee=Z.length,Ce=0,Be=he.length){for(;ve<Ee&&Ce<Be;ve++,Ce++){let Je=Z.charCodeAt(ve),Ke=he.charCodeAt(Ce);if(Je===Ke)continue;if(Je>=128||Ke>=128)return d(Z.toLowerCase(),he.toLowerCase(),ve,Ee,Ce,Be);x(Je)&&(Je-=32),x(Ke)&&(Ke-=32);const Ve=Je-Ke;if(Ve!==0)return Ve}const Ue=Ee-ve,Ze=Be-Ce;return Ue<Ze?-1:Ue>Ze?1:0}t.$Ye=B;function H(Z){return Z>=48&&Z<=57}t.$Ze=H;function x(Z){return Z>=97&&Z<=122}t.$1e=x;function C(Z){return Z>=65&&Z<=90}t.$2e=C;function F(Z,he){return Z.length===he.length&&B(Z,he)===0}t.$3e=F;function Q(Z,he){const ve=he.length;return he.length>Z.length?!1:B(Z,he,0,ve)===0}t.$4e=Q;function te(Z,he){const ve=Math.min(Z.length,he.length);let Ee;for(Ee=0;Ee<ve;Ee++)if(Z.charCodeAt(Ee)!==he.charCodeAt(Ee))return Ee;return ve}t.$5e=te;function re(Z,he){const ve=Math.min(Z.length,he.length);let Ee;const Ce=Z.length-1,Be=he.length-1;for(Ee=0;Ee<ve;Ee++)if(Z.charCodeAt(Ce-Ee)!==he.charCodeAt(Be-Ee))return Ee;return ve}t.$6e=re;function fe(Z){return 55296<=Z&&Z<=56319}t.$7e=fe;function ie(Z){return 56320<=Z&&Z<=57343}t.$8e=ie;function oe(Z,he){return(Z-55296<<10)+(he-56320)+65536}t.$9e=oe;function be(Z,he,ve){const Ee=Z.charCodeAt(ve);if(fe(Ee)&&ve+1<he){const Ce=Z.charCodeAt(ve+1);if(ie(Ce))return oe(Ee,Ce)}return Ee}t.$0e=be;function Se(Z,he){const ve=Z.charCodeAt(he-1);if(ie(ve)&&he>1){const Ee=Z.charCodeAt(he-2);if(fe(Ee))return oe(Ee,ve)}return ve}class Le{get offset(){return this.e}constructor(he,ve=0){this.c=he,this.d=he.length,this.e=ve}setOffset(he){this.e=he}prevCodePoint(){const he=Se(this.c,this.e);return this.e-=he>=65536?2:1,he}nextCodePoint(){const he=be(this.c,this.d,this.e);return this.e+=he>=65536?2:1,he}eol(){return this.e>=this.d}}t.$$e=Le;class Fe{get offset(){return this.c.offset}constructor(he,ve=0){this.c=new Le(he,ve)}nextGraphemeLength(){const he=Ae.getInstance(),ve=this.c,Ee=ve.offset;let Ce=he.getGraphemeBreakType(ve.nextCodePoint());for(;!ve.eol();){const Be=ve.offset,Ue=he.getGraphemeBreakType(ve.nextCodePoint());if(pe(Ce,Ue)){ve.setOffset(Be);break}Ce=Ue}return ve.offset-Ee}prevGraphemeLength(){const he=Ae.getInstance(),ve=this.c,Ee=ve.offset;let Ce=he.getGraphemeBreakType(ve.prevCodePoint());for(;ve.offset>0;){const Be=ve.offset,Ue=he.getGraphemeBreakType(ve.prevCodePoint());if(pe(Ue,Ce)){ve.setOffset(Be);break}Ce=Ue}return Ee-ve.offset}eol(){return this.c.eol()}}t.$_e=Fe;function de(Z,he){return new Fe(Z,he).nextGraphemeLength()}t.$af=de;function ne(Z,he){return new Fe(Z,he).prevGraphemeLength()}t.$bf=ne;function ce(Z,he){he>0&&ie(Z.charCodeAt(he))&&he--;const ve=he+de(Z,he);return[ve-ne(Z,ve),ve]}t.$cf=ce;function X(Z){const he=new Fe(Z);let ve=0;for(;!he.eol();)ve++,he.nextGraphemeLength();return ve}t.$df=X;let q;function G(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function P(Z){return q||(q=G()),q.test(Z)}t.$ef=P;const V=/^[\t\n\r\x20-\x7E]*$/;function p(Z){return V.test(Z)}t.$ff=p,t.$gf=/[\u2028\u2029]/;function W(Z){return t.$gf.test(Z)}t.$hf=W;function J(Z){return Z>=11904&&Z<=55215||Z>=63744&&Z<=64255||Z>=65281&&Z<=65374}t.$if=J;function M(Z){return Z>=127462&&Z<=127487||Z===8986||Z===8987||Z===9200||Z===9203||Z>=9728&&Z<=10175||Z===11088||Z===11093||Z>=127744&&Z<=128591||Z>=128640&&Z<=128764||Z>=128992&&Z<=129008||Z>=129280&&Z<=129535||Z>=129648&&Z<=129782}t.$jf=M;function $(Z,he){if(Z.length<he)return Z;const ve=/\b/g;let Ee=0;for(;ve.test(Z)&&!(Z.length-ve.lastIndex<he);)Ee=ve.lastIndex,ve.lastIndex+=1;return Z.substring(Ee).replace(/^\s/,"")}t.$kf=$;const w=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,I=/\x1b\].*?\x07/g;function v(Z){return Z&&(Z=Z.replace(w,"").replace(I,"")),Z}t.$lf=v,t.$mf=String.fromCharCode(65279);function O(Z){return!!(Z&&Z.length>0&&Z.charCodeAt(0)===65279)}t.$nf=O;function k(Z){return O(Z)?Z.substr(1):Z}t.$of=k;function S(Z,he){if(!Z||!he||Z.length<he.length)return!1;const ve=he.length,Ee=Z.toLowerCase();let Ce=0,Be=-1;for(;Ce<ve;){const Ue=Ee.indexOf(he[Ce],Be+1);if(Ue<0)return!1;Be=Ue,Ce++}return!0}t.$pf=S;function j(Z,he=!1){return Z?(he&&(Z=Z.replace(/\\./g,"")),Z.toLowerCase()!==Z):!1}t.$qf=j;function K(Z){return Z.charAt(0).toUpperCase()+Z.slice(1)}t.$rf=K;function ee(Z,he=1){if(he===0)return"";let ve=-1;do ve=Z.indexOf(`
`,ve+1),he--;while(he>0&&ve>=0);return ve===-1?Z:(Z[ve-1]==="\r"&&ve--,Z.substr(0,ve))}t.$sf=ee;function se(Z){return Z=Z%(2*26),Z<26?String.fromCharCode(97+Z):String.fromCharCode(65+Z-26)}t.$tf=se;function ge(Z){return Ae.getInstance().getGraphemeBreakType(Z)}t.$uf=ge;function pe(Z,he){return Z===0?he!==5&&he!==7:Z===2&&he===3?!1:Z===4||Z===2||Z===3||he===4||he===2||he===3?!0:!(Z===8&&(he===8||he===9||he===11||he===12)||(Z===11||Z===9)&&(he===9||he===10)||(Z===12||Z===10)&&he===10||he===5||he===13||he===7||Z===1||Z===13&&he===14||Z===6&&he===6)}var Pe;(function(Z){Z[Z.Other=0]="Other",Z[Z.Prepend=1]="Prepend",Z[Z.CR=2]="CR",Z[Z.LF=3]="LF",Z[Z.Control=4]="Control",Z[Z.Extend=5]="Extend",Z[Z.Regional_Indicator=6]="Regional_Indicator",Z[Z.SpacingMark=7]="SpacingMark",Z[Z.L=8]="L",Z[Z.V=9]="V",Z[Z.T=10]="T",Z[Z.LV=11]="LV",Z[Z.LVT=12]="LVT",Z[Z.ZWJ=13]="ZWJ",Z[Z.Extended_Pictographic=14]="Extended_Pictographic"})(Pe||(t.GraphemeBreakType=Pe={}));class Ae{static{this.c=null}static getInstance(){return Ae.c||(Ae.c=new Ae),Ae.c}constructor(){this.d=De()}getGraphemeBreakType(he){if(he<32)return he===10?3:he===13?2:4;if(he<127)return 0;const ve=this.d,Ee=ve.length/3;let Ce=1;for(;Ce<=Ee;)if(he<ve[3*Ce])Ce=2*Ce;else if(he>ve[3*Ce+1])Ce=2*Ce+1;else return ve[3*Ce+2];return 0}}function De(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ie(Z,he){if(Z===0)return 0;const ve=Oe(Z,he);if(ve!==void 0)return ve;const Ee=new Le(he,Z);return Ee.prevCodePoint(),Ee.offset}t.$vf=Ie;function Oe(Z,he){const ve=new Le(he,Z);let Ee=ve.prevCodePoint();for(;_e(Ee)||Ee===65039||Ee===8419;){if(ve.offset===0)return;Ee=ve.prevCodePoint()}if(!M(Ee))return;let Ce=ve.offset;return Ce>0&&ve.prevCodePoint()===8205&&(Ce=ve.offset),Ce}function _e(Z){return 127995<=Z&&Z<=127999}var He;(function(Z){Z[Z.zwj=8205]="zwj",Z[Z.emojiVariantSelector=65039]="emojiVariantSelector",Z[Z.enclosingKeyCap=8419]="enclosingKeyCap"})(He||(He={})),t.$wf="\xA0";class Me{static{this.c=new L.$U(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new y.$ye(he=>{function ve(Ve){const tt=new Map;for(let nt=0;nt<Ve.length;nt+=2)tt.set(Ve[nt],Ve[nt+1]);return tt}function Ee(Ve,tt){const nt=new Map(Ve);for(const[dt,ct]of tt)nt.set(dt,ct);return nt}function Ce(Ve,tt){if(!Ve)return tt;const nt=new Map;for(const[dt,ct]of Ve)tt.has(dt)&&nt.set(dt,ct);return nt}const Be=this.c.value;let Ue=he.filter(Ve=>!Ve.startsWith("_")&&Ve in Be);Ue.length===0&&(Ue=["_default"]);let Ze;for(const Ve of Ue){const tt=ve(Be[Ve]);Ze=Ce(Ze,tt)}const Je=ve(Be._common),Ke=Ee(Je,Ze);return new Me(Ke)})}static getInstance(he){return Me.d.get(Array.from(he))}static{this.e=new L.$U(()=>Object.keys(Me.c.value).filter(he=>!he.startsWith("_")))}static getLocales(){return Me.e.value}constructor(he){this.f=he}isAmbiguous(he){return this.f.has(he)}getPrimaryConfusable(he){return this.f.get(he)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$xf=Me;class Qe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Qe.c())),this.d}static isInvisibleCharacter(he){return Qe.e().has(he)}static get codePoints(){return Qe.e()}}t.$yf=Qe}),define($e[34],we([1,0,32,12]),function(le,t,y,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Vj=t.$Uj=t.$Tj=t.$Sj=t.FuzzyScore=t.$Rj=t.$Qj=t.$Pj=t.$Oj=t.$Nj=t.$Mj=t.$Lj=t.$Kj=t.$Jj=t.$Ij=t.$Hj=t.$Gj=t.or=void 0;function i(...k){return function(S,j){for(let K=0,ee=k.length;K<ee;K++){const se=k[K](S,j);if(se)return se}return null}}t.or=i,t.$Gj=U.bind(void 0,!1),t.$Hj=U.bind(void 0,!0);function U(k,S,j){if(!j||j.length<S.length)return null;let K;return k?K=L.$4e(j,S):K=j.indexOf(S)===0,K?S.length>0?[{start:0,end:S.length}]:[]:null}function D(k,S){const j=S.toLowerCase().indexOf(k.toLowerCase());return j===-1?null:[{start:j,end:j+k.length}]}t.$Ij=D;function A(k,S){return c(k.toLowerCase(),S.toLowerCase(),0,0)}t.$Jj=A;function c(k,S,j,K){if(j===k.length)return[];if(K===S.length)return null;if(k[j]===S[K]){let ee=null;return(ee=c(k,S,j+1,K+1))?m({start:K,end:K+1},ee):null}return c(k,S,j,K+1)}function g(k){return 97<=k&&k<=122}function f(k){return 65<=k&&k<=90}t.$Kj=f;function T(k){return 48<=k&&k<=57}function s(k){return k===32||k===9||k===10||k===13}const a=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(k=>a.add(k.charCodeAt(0)));function e(k){return s(k)||a.has(k)}function h(k,S){return k===S||e(k)&&e(S)}function l(k){return g(k)||f(k)||T(k)}function m(k,S){return S.length===0?S=[k]:k.end===S[0].start?S[0].start=k.start:S.unshift(k),S}function n(k,S){for(let j=S;j<k.length;j++){const K=k.charCodeAt(j);if(f(K)||T(K)||j>0&&!l(k.charCodeAt(j-1)))return j}return k.length}function r(k,S,j,K){if(j===k.length)return[];if(K===S.length)return null;if(k[j]!==S[K].toLowerCase())return null;{let ee=null,se=K+1;for(ee=r(k,S,j+1,K+1);!ee&&(se=n(S,se))<S.length;)ee=r(k,S,j+1,se),se++;return ee===null?null:m({start:K,end:K+1},ee)}}function b(k){let S=0,j=0,K=0,ee=0,se=0;for(let De=0;De<k.length;De++)se=k.charCodeAt(De),f(se)&&S++,g(se)&&j++,l(se)&&K++,T(se)&&ee++;const ge=S/k.length,pe=j/k.length,Pe=K/k.length,Ae=ee/k.length;return{upperPercent:ge,lowerPercent:pe,alphaPercent:Pe,numericPercent:Ae}}function u(k){const{upperPercent:S,lowerPercent:j}=k;return j===0&&S>.6}function o(k){const{upperPercent:S,lowerPercent:j,alphaPercent:K,numericPercent:ee}=k;return j>.2&&S<.8&&K>.6&&ee<.2}function N(k){let S=0,j=0,K=0,ee=0;for(let se=0;se<k.length;se++)K=k.charCodeAt(se),f(K)&&S++,g(K)&&j++,s(K)&&ee++;return(S===0||j===0)&&ee===0?k.length<=30:S<=5}function z(k,S){if(!S||(S=S.trim(),S.length===0)||!N(k)||S.length>60)return null;const j=b(S);if(!o(j)){if(!u(j))return null;S=S.toLowerCase()}let K=null,ee=0;for(k=k.toLowerCase();ee<S.length&&(K=r(k,S,0,ee))===null;)ee=n(S,ee+1);return K}t.$Lj=z;function R(k,S,j=!1){if(!S||S.length===0)return null;let K=null,ee=0;for(k=k.toLowerCase(),S=S.toLowerCase();ee<S.length&&(K=d(k,S,0,ee,j))===null;)ee=E(S,ee+1);return K}t.$Mj=R;function d(k,S,j,K,ee){if(j===k.length)return[];if(K===S.length)return null;if(h(k.charCodeAt(j),S.charCodeAt(K))){let se=null,ge=K+1;if(se=d(k,S,j+1,K+1,ee),!ee)for(;!se&&(ge=E(S,ge))<S.length;)se=d(k,S,j+1,ge,ee),ge++;return se?k.charCodeAt(j)!==S.charCodeAt(K)?se:m({start:K,end:K+1},se):null}else return null}function E(k,S){for(let j=S;j<k.length;j++)if(e(k.charCodeAt(j))||j>0&&e(k.charCodeAt(j-1)))return j;return k.length}const B=i(t.$Hj,z,D),H=i(t.$Hj,z,A),x=new y.$Cc(1e4);function C(k,S,j=!1){if(typeof k!="string"||typeof S!="string")return null;let K=x.get(k);K||(K=new RegExp(L.$Me(k),"i"),x.set(k,K));const ee=K.exec(S);return ee?[{start:ee.index,end:ee.index+ee[0].length}]:j?H(k,S):B(k,S)}t.$Nj=C;function F(k,S){const j=J(k,k.toLowerCase(),0,S,S.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return j?te(j):null}t.$Oj=F;function Q(k,S,j,K,ee,se){const ge=Math.min(13,k.length);for(;j<ge;j++){const pe=J(k,S,j,K,ee,se,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(pe)return pe}return[0,se]}t.$Pj=Q;function te(k){if(typeof k>"u")return[];const S=[],j=k[1];for(let K=k.length-1;K>1;K--){const ee=k[K]+j,se=S[S.length-1];se&&se.end===ee?se.end=ee+1:S.push({start:ee,end:ee+1})}return S}t.$Qj=te;const re=128;function fe(){const k=[],S=[];for(let j=0;j<=re;j++)S[j]=0;for(let j=0;j<=re;j++)k.push(S.slice(0));return k}function ie(k){const S=[];for(let j=0;j<=k;j++)S[j]=0;return S}const oe=ie(2*re),be=ie(2*re),Se=fe(),Le=fe(),Fe=fe(),de=!1;function ne(k,S,j,K,ee){function se(pe,Pe,Ae=" "){for(;pe.length<Pe;)pe=Ae+pe;return pe}let ge=` |   |${K.split("").map(pe=>se(pe,3)).join("|")}
`;for(let pe=0;pe<=j;pe++)pe===0?ge+=" |":ge+=`${S[pe-1]}|`,ge+=k[pe].slice(0,ee+1).map(Pe=>se(Pe.toString(),3)).join("|")+`
`;return ge}function ce(k,S,j,K){k=k.substr(S),j=j.substr(K),console.log(ne(Le,k,k.length,j,j.length)),console.log(ne(Fe,k,k.length,j,j.length)),console.log(ne(Se,k,k.length,j,j.length))}function X(k,S){if(S<0||S>=k.length)return!1;const j=k.codePointAt(S);switch(j){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!L.$jf(j)}}function q(k,S){if(S<0||S>=k.length)return!1;switch(k.charCodeAt(S)){case 32:case 9:return!0;default:return!1}}function G(k,S,j){return S[k]!==j[k]}function P(k,S,j,K,ee,se,ge=!1){for(;S<j&&ee<se;)k[S]===K[ee]&&(ge&&(oe[S]=ee),S+=1),ee+=1;return S===j}t.$Rj=P;var V;(function(k){k[k.Diag=1]="Diag",k[k.Left=2]="Left",k[k.LeftLeft=3]="LeftLeft"})(V||(V={}));var p;(function(k){k.Default=[-100,0];function S(j){return!j||j.length===2&&j[0]===-100&&j[1]===0}k.isDefault=S})(p||(t.FuzzyScore=p={}));class W{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(S,j){this.firstMatchCanBeWeak=S,this.boostFullMatch=j}}t.$Sj=W;function J(k,S,j,K,ee,se,ge=W.default){const pe=k.length>re?re:k.length,Pe=K.length>re?re:K.length;if(j>=pe||se>=Pe||pe-j>Pe-se||!P(S,j,pe,ee,se,Pe,!0))return;M(pe,Pe,j,se,S,ee);let Ae=1,De=1,Ie=j,Oe=se;const _e=[!1];for(Ae=1,Ie=j;Ie<pe;Ae++,Ie++){const he=oe[Ie],ve=be[Ie],Ee=Ie+1<pe?be[Ie+1]:Pe;for(De=he-se+1,Oe=he;Oe<Ee;De++,Oe++){let Ce=Number.MIN_SAFE_INTEGER,Be=!1;Oe<=ve&&(Ce=$(k,S,Ie,j,K,ee,Oe,Pe,se,Se[Ae-1][De-1]===0,_e));let Ue=0;Ce!==Number.MAX_SAFE_INTEGER&&(Be=!0,Ue=Ce+Le[Ae-1][De-1]);const Ze=Oe>he,Je=Ze?Le[Ae][De-1]+(Se[Ae][De-1]>0?-5:0):0,Ke=Oe>he+1&&Se[Ae][De-1]>0,Ve=Ke?Le[Ae][De-2]+(Se[Ae][De-2]>0?-5:0):0;if(Ke&&(!Ze||Ve>=Je)&&(!Be||Ve>=Ue))Le[Ae][De]=Ve,Fe[Ae][De]=3,Se[Ae][De]=0;else if(Ze&&(!Be||Je>=Ue))Le[Ae][De]=Je,Fe[Ae][De]=2,Se[Ae][De]=0;else if(Be)Le[Ae][De]=Ue,Fe[Ae][De]=1,Se[Ae][De]=Se[Ae-1][De-1]+1;else throw new Error("not possible")}}if(de&&ce(k,j,K,se),!_e[0]&&!ge.firstMatchCanBeWeak)return;Ae--,De--;const He=[Le[Ae][De],se];let Me=0,Qe=0;for(;Ae>=1;){let he=De;do{const ve=Fe[Ae][he];if(ve===3)he=he-2;else if(ve===2)he=he-1;else break}while(he>=1);Me>1&&S[j+Ae-1]===ee[se+De-1]&&!G(he+se-1,K,ee)&&Me+1>Se[Ae][he]&&(he=De),he===De?Me++:Me=1,Qe||(Qe=he),Ae--,De=he-1,He.push(De)}Pe===pe&&ge.boostFullMatch&&(He[0]+=2);const Z=Qe-pe;return He[0]-=Z,He}t.$Tj=J;function M(k,S,j,K,ee,se){let ge=k-1,pe=S-1;for(;ge>=j&&pe>=K;)ee[ge]===se[pe]&&(be[ge]=pe,ge--),pe--}function $(k,S,j,K,ee,se,ge,pe,Pe,Ae,De){if(S[j]!==se[ge])return Number.MIN_SAFE_INTEGER;let Ie=1,Oe=!1;return ge===j-K?Ie=k[j]===ee[ge]?7:5:G(ge,ee,se)&&(ge===0||!G(ge-1,ee,se))?(Ie=k[j]===ee[ge]?7:5,Oe=!0):X(se,ge)&&(ge===0||!X(se,ge-1))?Ie=5:(X(se,ge-1)||q(se,ge-1))&&(Ie=5,Oe=!0),Ie>1&&j===K&&(De[0]=!0),Oe||(Oe=G(ge,ee,se)||X(se,ge-1)||q(se,ge-1)),j===K?ge>Pe&&(Ie-=Oe?3:5):Ae?Ie+=Oe?2:0:Ie+=Oe?0:1,ge+1===pe&&(Ie-=Oe?3:5),Ie}function w(k,S,j,K,ee,se,ge){return v(k,S,j,K,ee,se,!0,ge)}t.$Uj=w;function I(k,S,j,K,ee,se,ge){return v(k,S,j,K,ee,se,!1,ge)}t.$Vj=I;function v(k,S,j,K,ee,se,ge,pe){let Pe=J(k,S,j,K,ee,se,pe);if(Pe&&!ge)return Pe;if(k.length>=3){const Ae=Math.min(7,k.length-1);for(let De=j+1;De<Ae;De++){const Ie=O(k,De);if(Ie){const Oe=J(Ie,Ie.toLowerCase(),j,K,ee,se,pe);Oe&&(Oe[0]-=3,(!Pe||Oe[0]>Pe[0])&&(Pe=Oe))}}}return Pe}function O(k,S){if(S+1>=k.length)return;const j=k[S],K=k[S+1];if(j!==K)return k.slice(0,S)+K+j+k.slice(S+2)}}),define($e[49],we([1,0,12]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ni=t.$Mi=t.$Li=t.$Ki=t.$Ji=t.$Ii=t.$Hi=void 0;function L(m){return i(m,0)}t.$Hi=L;function i(m,n){switch(typeof m){case"object":return m===null?U(349,n):Array.isArray(m)?c(m,n):g(m,n);case"string":return A(m,n);case"boolean":return D(m,n);case"number":return U(m,n);case"undefined":return U(937,n);default:return U(617,n)}}t.$Ii=i;function U(m,n){return(n<<5)-n+m|0}t.$Ji=U;function D(m,n){return U(m?433:863,n)}function A(m,n){n=U(149417,n);for(let r=0,b=m.length;r<b;r++)n=U(m.charCodeAt(r),n);return n}t.$Ki=A;function c(m,n){return n=U(104579,n),m.reduce((r,b)=>i(b,r),n)}function g(m,n){return n=U(181387,n),Object.keys(m).sort().reduce((r,b)=>(r=A(b,r),i(m[b],r)),n)}class f{constructor(){this.g=0}get value(){return this.g}hash(n){return this.g=i(n,this.g),this.g}}t.$Li=f;var T;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(T||(T={}));function s(m,n,r=32){const b=r-n,u=~((1<<b)-1);return(m<<n|(u&m)>>>b)>>>0}function a(m,n=0,r=m.byteLength,b=0){for(let u=0;u<r;u++)m[n+u]=b}function e(m,n,r="0"){for(;m.length<n;)m=r+m;return m}function h(m,n=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(r=>r.toString(16).padStart(2,"0")).join(""):e((m>>>0).toString(16),n/4)}t.$Mi=h;class l{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(n){const r=n.length;if(r===0)return;const b=this.p;let u=this.r,o=this.u,N,z;for(o!==0?(N=o,z=-1,o=0):(N=n.charCodeAt(0),z=0);;){let R=N;if(y.$7e(N))if(z+1<r){const d=n.charCodeAt(z+1);y.$8e(d)?(z++,R=y.$9e(N,d)):R=65533}else{o=N;break}else y.$8e(N)&&(R=65533);if(u=this.w(b,u,R),z++,z<r)N=n.charCodeAt(z);else break}this.r=u,this.u=o}w(n,r,b){return b<128?n[r++]=b:b<2048?(n[r++]=192|(b&1984)>>>6,n[r++]=128|(b&63)>>>0):b<65536?(n[r++]=224|(b&61440)>>>12,n[r++]=128|(b&4032)>>>6,n[r++]=128|(b&63)>>>0):(n[r++]=240|(b&1835008)>>>18,n[r++]=128|(b&258048)>>>12,n[r++]=128|(b&4032)>>>6,n[r++]=128|(b&63)>>>0),r>=64&&(this.y(),r-=64,this.t+=64,n[0]=n[64+0],n[1]=n[64+1],n[2]=n[64+2]),r}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),h(this.h)+h(this.l)+h(this.m)+h(this.n)+h(this.o)}x(){this.p[this.r++]=128,a(this.p,this.r),this.r>56&&(this.y(),a(this.p));const n=8*this.t;this.q.setUint32(56,Math.floor(n/4294967296),!1),this.q.setUint32(60,n%4294967296,!1),this.y()}y(){const n=l.g,r=this.q;for(let B=0;B<64;B+=4)n.setUint32(B,r.getUint32(B,!1),!1);for(let B=64;B<320;B+=4)n.setUint32(B,s(n.getUint32(B-12,!1)^n.getUint32(B-32,!1)^n.getUint32(B-56,!1)^n.getUint32(B-64,!1),1),!1);let b=this.h,u=this.l,o=this.m,N=this.n,z=this.o,R,d,E;for(let B=0;B<80;B++)B<20?(R=u&o|~u&N,d=1518500249):B<40?(R=u^o^N,d=1859775393):B<60?(R=u&o|u&N|o&N,d=2400959708):(R=u^o^N,d=3395469782),E=s(b,5)+R+z+d+n.getUint32(B*4,!1)&4294967295,z=N,N=o,o=s(u,30),u=b,b=E;this.h=this.h+b&4294967295,this.l=this.l+u&4294967295,this.m=this.m+o&4294967295,this.n=this.n+N&4294967295,this.o=this.o+z&4294967295}}t.$Ni=l}),define($e[86],we([1,0,75,49]),function(le,t,y,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ds=t.$Cs=t.$Bs=void 0;class i{constructor(s){this.a=s}getElements(){const s=this.a,a=new Int32Array(s.length);for(let e=0,h=s.length;e<h;e++)a[e]=s.charCodeAt(e);return a}}t.$Bs=i;function U(T,s,a){return new f(new i(T),new i(s)).ComputeDiff(a).changes}t.$Cs=U;class D{static Assert(s,a){if(!s)throw new Error(a)}}class A{static Copy(s,a,e,h,l){for(let m=0;m<l;m++)e[h+m]=s[a+m]}static Copy2(s,a,e,h,l){for(let m=0;m<l;m++)e[h+m]=s[a+m]}}var c;(function(T){T[T.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(c||(c={}));class g{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new y.$As(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(s,a){this.b=Math.min(this.b,s),this.c=Math.min(this.c,a),this.d++}AddModifiedElement(s,a){this.b=Math.min(this.b,s),this.c=Math.min(this.c,a),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class f{constructor(s,a,e=null){this.a=e,this.b=s,this.c=a;const[h,l,m]=f.o(s),[n,r,b]=f.o(a);this.d=m&&b,this.e=h,this.f=l,this.g=n,this.h=r,this.k=[],this.m=[]}static n(s){return s.length>0&&typeof s[0]=="string"}static o(s){const a=s.getElements();if(f.n(a)){const e=new Int32Array(a.length);for(let h=0,l=a.length;h<l;h++)e[h]=(0,L.$Ki)(a[h],0);return[a,e,!0]}return a instanceof Int32Array?[[],a,!1]:[[],new Int32Array(a),!1]}p(s,a){return this.f[s]!==this.h[a]?!1:this.d?this.e[s]===this.g[a]:!0}q(s,a){if(!this.p(s,a))return!1;const e=f.r(this.b,s),h=f.r(this.c,a);return e===h}static r(s,a){return typeof s.getStrictElement=="function"?s.getStrictElement(a):null}s(s,a){return this.f[s]!==this.f[a]?!1:this.d?this.e[s]===this.e[a]:!0}u(s,a){return this.h[s]!==this.h[a]?!1:this.d?this.g[s]===this.g[a]:!0}ComputeDiff(s){return this.v(0,this.f.length-1,0,this.h.length-1,s)}v(s,a,e,h,l){const m=[!1];let n=this.w(s,a,e,h,m);return l&&(n=this.z(n)),{quitEarly:m[0],changes:n}}w(s,a,e,h,l){for(l[0]=!1;s<=a&&e<=h&&this.p(s,e);)s++,e++;for(;a>=s&&h>=e&&this.p(a,h);)a--,h--;if(s>a||e>h){let o;return e<=h?(D.Assert(s===a+1,"originalStart should only be one more than originalEnd"),o=[new y.$As(s,0,e,h-e+1)]):s<=a?(D.Assert(e===h+1,"modifiedStart should only be one more than modifiedEnd"),o=[new y.$As(s,a-s+1,e,0)]):(D.Assert(s===a+1,"originalStart should only be one more than originalEnd"),D.Assert(e===h+1,"modifiedStart should only be one more than modifiedEnd"),o=[]),o}const m=[0],n=[0],r=this.y(s,a,e,h,m,n,l),b=m[0],u=n[0];if(r!==null)return r;if(!l[0]){const o=this.w(s,b,e,u,l);let N=[];return l[0]?N=[new y.$As(b+1,a-(b+1)+1,u+1,h-(u+1)+1)]:N=this.w(b+1,a,u+1,h,l),this.H(o,N)}return[new y.$As(s,a-s+1,e,h-e+1)]}x(s,a,e,h,l,m,n,r,b,u,o,N,z,R,d,E,B,H){let x=null,C=null,F=new g,Q=a,te=e,re=z[0]-E[0]-h,fe=-1073741824,ie=this.k.length-1;do{const oe=re+s;oe===Q||oe<te&&b[oe-1]<b[oe+1]?(o=b[oe+1],R=o-re-h,o<fe&&F.MarkNextChange(),fe=o,F.AddModifiedElement(o+1,R),re=oe+1-s):(o=b[oe-1]+1,R=o-re-h,o<fe&&F.MarkNextChange(),fe=o-1,F.AddOriginalElement(o,R+1),re=oe-1-s),ie>=0&&(b=this.k[ie],s=b[0],Q=1,te=b.length-1)}while(--ie>=-1);if(x=F.getReverseChanges(),H[0]){let oe=z[0]+1,be=E[0]+1;if(x!==null&&x.length>0){const Se=x[x.length-1];oe=Math.max(oe,Se.getOriginalEnd()),be=Math.max(be,Se.getModifiedEnd())}C=[new y.$As(oe,N-oe+1,be,d-be+1)]}else{F=new g,Q=m,te=n,re=z[0]-E[0]-r,fe=1073741824,ie=B?this.m.length-1:this.m.length-2;do{const oe=re+l;oe===Q||oe<te&&u[oe-1]>=u[oe+1]?(o=u[oe+1]-1,R=o-re-r,o>fe&&F.MarkNextChange(),fe=o+1,F.AddOriginalElement(o+1,R+1),re=oe+1-l):(o=u[oe-1],R=o-re-r,o>fe&&F.MarkNextChange(),fe=o,F.AddModifiedElement(o+1,R+1),re=oe-1-l),ie>=0&&(u=this.m[ie],l=u[0],Q=1,te=u.length-1)}while(--ie>=-1);C=F.getChanges()}return this.H(x,C)}y(s,a,e,h,l,m,n){let r=0,b=0,u=0,o=0,N=0,z=0;s--,e--,l[0]=0,m[0]=0,this.k=[],this.m=[];const R=a-s+(h-e),d=R+1,E=new Int32Array(d),B=new Int32Array(d),H=h-e,x=a-s,C=s-e,F=a-h,te=(x-H)%2===0;E[H]=s,B[x]=a,n[0]=!1;for(let re=1;re<=R/2+1;re++){let fe=0,ie=0;u=this.J(H-re,re,H,d),o=this.J(H+re,re,H,d);for(let be=u;be<=o;be+=2){be===u||be<o&&E[be-1]<E[be+1]?r=E[be+1]:r=E[be-1]+1,b=r-(be-H)-C;const Se=r;for(;r<a&&b<h&&this.p(r+1,b+1);)r++,b++;if(E[be]=r,r+b>fe+ie&&(fe=r,ie=b),!te&&Math.abs(be-x)<=re-1&&r>=B[be])return l[0]=r,m[0]=b,Se<=B[be]&&1447>0&&re<=1447+1?this.x(H,u,o,C,x,N,z,F,E,B,r,a,l,b,h,m,te,n):null}const oe=(fe-s+(ie-e)-re)/2;if(this.a!==null&&!this.a(fe,oe))return n[0]=!0,l[0]=fe,m[0]=ie,oe>0&&1447>0&&re<=1447+1?this.x(H,u,o,C,x,N,z,F,E,B,r,a,l,b,h,m,te,n):(s++,e++,[new y.$As(s,a-s+1,e,h-e+1)]);N=this.J(x-re,re,x,d),z=this.J(x+re,re,x,d);for(let be=N;be<=z;be+=2){be===N||be<z&&B[be-1]>=B[be+1]?r=B[be+1]-1:r=B[be-1],b=r-(be-x)-F;const Se=r;for(;r>s&&b>e&&this.p(r,b);)r--,b--;if(B[be]=r,te&&Math.abs(be-H)<=re&&r<=E[be])return l[0]=r,m[0]=b,Se>=E[be]&&1447>0&&re<=1447+1?this.x(H,u,o,C,x,N,z,F,E,B,r,a,l,b,h,m,te,n):null}if(re<=1447){let be=new Int32Array(o-u+2);be[0]=H-u+1,A.Copy2(E,u,be,1,o-u+1),this.k.push(be),be=new Int32Array(z-N+2),be[0]=x-N+1,A.Copy2(B,N,be,1,z-N+1),this.m.push(be)}}return this.x(H,u,o,C,x,N,z,F,E,B,r,a,l,b,h,m,te,n)}z(s){for(let a=0;a<s.length;a++){const e=s[a],h=a<s.length-1?s[a+1].originalStart:this.f.length,l=a<s.length-1?s[a+1].modifiedStart:this.h.length,m=e.originalLength>0,n=e.modifiedLength>0;for(;e.originalStart+e.originalLength<h&&e.modifiedStart+e.modifiedLength<l&&(!m||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!n||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const b=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!b)break;e.originalStart++,e.modifiedStart++}const r=[null];if(a<s.length-1&&this.I(s[a],s[a+1],r)){s[a]=r[0],s.splice(a+1,1),a--;continue}}for(let a=s.length-1;a>=0;a--){const e=s[a];let h=0,l=0;if(a>0){const o=s[a-1];h=o.originalStart+o.originalLength,l=o.modifiedStart+o.modifiedLength}const m=e.originalLength>0,n=e.modifiedLength>0;let r=0,b=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let o=1;;o++){const N=e.originalStart-o,z=e.modifiedStart-o;if(N<h||z<l||m&&!this.s(N,N+e.originalLength)||n&&!this.u(z,z+e.modifiedLength))break;const d=(N===h&&z===l?5:0)+this.G(N,e.originalLength,z,e.modifiedLength);d>b&&(b=d,r=o)}e.originalStart-=r,e.modifiedStart-=r;const u=[null];if(a>0&&this.I(s[a-1],s[a],u)){s[a-1]=u[0],s.splice(a,1),a++;continue}}if(this.d)for(let a=1,e=s.length;a<e;a++){const h=s[a-1],l=s[a],m=l.originalStart-h.originalStart-h.originalLength,n=h.originalStart,r=l.originalStart+l.originalLength,b=r-n,u=h.modifiedStart,o=l.modifiedStart+l.modifiedLength,N=o-u;if(m<5&&b<20&&N<20){const z=this.A(n,b,u,N,m);if(z){const[R,d]=z;(R!==h.originalStart+h.originalLength||d!==h.modifiedStart+h.modifiedLength)&&(h.originalLength=R-h.originalStart,h.modifiedLength=d-h.modifiedStart,l.originalStart=R+m,l.modifiedStart=d+m,l.originalLength=r-l.originalStart,l.modifiedLength=o-l.modifiedStart)}}}return s}A(s,a,e,h,l){if(a<l||h<l)return null;const m=s+a-l+1,n=e+h-l+1;let r=0,b=0,u=0;for(let o=s;o<m;o++)for(let N=e;N<n;N++){const z=this.B(o,N,l);z>0&&z>r&&(r=z,b=o,u=N)}return r>0?[b,u]:null}B(s,a,e){let h=0;for(let l=0;l<e;l++){if(!this.p(s+l,a+l))return 0;h+=this.e[s+l].length}return h}C(s){return s<=0||s>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[s])}D(s,a){if(this.C(s)||this.C(s-1))return!0;if(a>0){const e=s+a;if(this.C(e-1)||this.C(e))return!0}return!1}E(s){return s<=0||s>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[s])}F(s,a){if(this.E(s)||this.E(s-1))return!0;if(a>0){const e=s+a;if(this.E(e-1)||this.E(e))return!0}return!1}G(s,a,e,h){const l=this.D(s,a)?1:0,m=this.F(e,h)?1:0;return l+m}H(s,a){const e=[];if(s.length===0||a.length===0)return a.length>0?a:s;if(this.I(s[s.length-1],a[0],e)){const h=new Array(s.length+a.length-1);return A.Copy(s,0,h,0,s.length-1),h[s.length-1]=e[0],A.Copy(a,1,h,s.length,a.length-1),h}else{const h=new Array(s.length+a.length);return A.Copy(s,0,h,0,s.length),A.Copy(a,0,h,s.length,a.length),h}}I(s,a,e){if(D.Assert(s.originalStart<=a.originalStart,"Left change is not less than or equal to right change"),D.Assert(s.modifiedStart<=a.modifiedStart,"Left change is not less than or equal to right change"),s.originalStart+s.originalLength>=a.originalStart||s.modifiedStart+s.modifiedLength>=a.modifiedStart){const h=s.originalStart;let l=s.originalLength;const m=s.modifiedStart;let n=s.modifiedLength;return s.originalStart+s.originalLength>=a.originalStart&&(l=a.originalStart+a.originalLength-s.originalStart),s.modifiedStart+s.modifiedLength>=a.modifiedStart&&(n=a.modifiedStart+a.modifiedLength-s.modifiedStart),e[0]=new y.$As(h,l,m,n),!0}else return e[0]=null,!1}J(s,a,e,h){if(s>=0&&s<h)return s;const l=e,m=h-e-1,n=a%2===0;if(s<0){const r=l%2===0;return n===r?0:1}else{const r=m%2===0;return n===r?h-1:h-2}}}t.$Ds=f}),define($e[50],we([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ld=void 0,t.$Ld=Symbol("MicrotaskDelay")}),define($e[87],we([1,0,11,12]),function(le,t,y,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zh=t.$Yh=t.$Xh=t.$Wh=t.$Vh=void 0;class i{constructor(){this.b="",this.c=0}reset(a){return this.b=a,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(a){const e=a.charCodeAt(0),h=this.b.charCodeAt(this.c);return e-h}value(){return this.b[this.c]}}t.$Vh=i;class U{constructor(a=!0){this.e=a}reset(a){return this.b=a,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let a=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(a)this.c++;else break;else a=!1;return this}cmp(a){return this.e?(0,L.$We)(a,this.b,0,a.length,this.c,this.d):(0,L.$Ye)(a,this.b,0,a.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}t.$Wh=U;class D{constructor(a=!0,e=!0){this.f=a,this.g=e}reset(a){this.d=0,this.e=0,this.b=a,this.c=a.length;for(let e=a.length-1;e>=0;e--,this.c--){const h=this.b.charCodeAt(e);if(!(h===47||this.f&&h===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let a=!0;for(;this.e<this.c;this.e++){const e=this.b.charCodeAt(this.e);if(e===47||this.f&&e===92)if(a)this.d++;else break;else a=!1}return this}cmp(a){return this.g?(0,L.$We)(a,this.b,0,a.length,this.d,this.e):(0,L.$Ye)(a,this.b,0,a.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}t.$Xh=D;var A;(function(s){s[s.Scheme=1]="Scheme",s[s.Authority=2]="Authority",s[s.Path=3]="Path",s[s.Query=4]="Query",s[s.Fragment=5]="Fragment"})(A||(A={}));class c{constructor(a,e){this.f=a,this.g=e,this.d=[],this.e=0}reset(a){return this.c=a,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new D(!1,!this.f(a)),this.b.reset(a.path),this.b.value()&&this.d.push(3)),this.g(a)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(a){if(this.d[this.e]===1)return(0,L.$Xe)(a,this.c.scheme);if(this.d[this.e]===2)return(0,L.$Xe)(a,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(a);if(this.d[this.e]===4)return(0,L.$Ve)(a,this.c.query);if(this.d[this.e]===5)return(0,L.$Ve)(a,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}t.$Yh=c;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const a=this.right;return this.right=a.left,a.left=this,this.updateHeight(),a.updateHeight(),a}rotateRight(){const a=this.left;return this.left=a.right,a.right=this,this.updateHeight(),a.updateHeight(),a}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var f;(function(s){s[s.Left=-1]="Left",s[s.Mid=0]="Mid",s[s.Right=1]="Right"})(f||(f={}));class T{static forUris(a=()=>!1,e=()=>!1){return new T(new c(a,e))}static forPaths(a=!1){return new T(new D(void 0,!a))}static forStrings(){return new T(new i)}static forConfigKeys(){return new T(new U)}constructor(a){this.b=a}clear(){this.c=void 0}fill(a,e){if(e){const h=e.slice(0);(0,y.$Wb)(h);for(const l of h)this.set(l,a)}else{const h=a.slice(0);(0,y.$Wb)(h);for(const l of h)this.set(l[0],l[1])}}set(a,e){const h=this.b.reset(a);let l;this.c||(this.c=new g,this.c.segment=h.value());const m=[];for(l=this.c;;){const r=h.cmp(l.segment);if(r>0)l.left||(l.left=new g,l.left.segment=h.value()),m.push([-1,l]),l=l.left;else if(r<0)l.right||(l.right=new g,l.right.segment=h.value()),m.push([1,l]),l=l.right;else if(h.hasNext())h.next(),l.mid||(l.mid=new g,l.mid.segment=h.value()),m.push([0,l]),l=l.mid;else break}const n=l.value;l.value=e,l.key=a;for(let r=m.length-1;r>=0;r--){const b=m[r][1];b.updateHeight();const u=b.balanceFactor();if(u<-1||u>1){const o=m[r][0],N=m[r+1][0];if(o===1&&N===1)m[r][1]=b.rotateLeft();else if(o===-1&&N===-1)m[r][1]=b.rotateRight();else if(o===1&&N===-1)b.right=m[r+1][1]=m[r+1][1].rotateRight(),m[r][1]=b.rotateLeft();else if(o===-1&&N===1)b.left=m[r+1][1]=m[r+1][1].rotateLeft(),m[r][1]=b.rotateRight();else throw new Error;if(r>0)switch(m[r-1][0]){case-1:m[r-1][1].left=m[r][1];break;case 1:m[r-1][1].right=m[r][1];break;case 0:m[r-1][1].mid=m[r][1];break}else this.c=m[0][1]}}return n}get(a){return this.d(a)?.value}d(a){const e=this.b.reset(a);let h=this.c;for(;h;){const l=e.cmp(h.segment);if(l>0)h=h.left;else if(l<0)h=h.right;else if(e.hasNext())e.next(),h=h.mid;else break}return h}has(a){const e=this.d(a);return!(e?.value===void 0&&e?.mid===void 0)}delete(a){return this.e(a,!1)}deleteSuperstr(a){return this.e(a,!0)}e(a,e){const h=this.b.reset(a),l=[];let m=this.c;for(;m;){const n=h.cmp(m.segment);if(n>0)l.push([-1,m]),m=m.left;else if(n<0)l.push([1,m]),m=m.right;else if(h.hasNext())h.next(),l.push([0,m]),m=m.mid;else break}if(m){if(e?(m.left=void 0,m.mid=void 0,m.right=void 0,m.height=1):(m.key=void 0,m.value=void 0),!m.mid&&!m.value)if(m.left&&m.right){const n=this.f(m.right);if(n.key){const{key:r,value:b,segment:u}=n;this.e(n.key,!1),m.key=r,m.value=b,m.segment=u}}else{const n=m.left??m.right;if(l.length>0){const[r,b]=l[l.length-1];switch(r){case-1:b.left=n;break;case 0:b.mid=n;break;case 1:b.right=n;break}}else this.c=n}for(let n=l.length-1;n>=0;n--){const r=l[n][1];r.updateHeight();const b=r.balanceFactor();if(b>1?(r.right.balanceFactor()>=0||(r.right=r.right.rotateRight()),l[n][1]=r.rotateLeft()):b<-1&&(r.left.balanceFactor()<=0||(r.left=r.left.rotateLeft()),l[n][1]=r.rotateRight()),n>0)switch(l[n-1][0]){case-1:l[n-1][1].left=l[n][1];break;case 1:l[n-1][1].right=l[n][1];break;case 0:l[n-1][1].mid=l[n][1];break}else this.c=l[0][1]}}}f(a){for(;a.left;)a=a.left;return a}findSubstr(a){const e=this.b.reset(a);let h=this.c,l;for(;h;){const m=e.cmp(h.segment);if(m>0)h=h.left;else if(m<0)h=h.right;else if(e.hasNext())e.next(),l=h.value||l,h=h.mid;else break}return h&&h.value||l}findSuperstr(a){return this.g(a,!1)}g(a,e){const h=this.b.reset(a);let l=this.c;for(;l;){const m=h.cmp(l.segment);if(m>0)l=l.left;else if(m<0)l=l.right;else if(h.hasNext())h.next(),l=l.mid;else return l.mid?this.h(l.mid):e?l.value:void 0}}hasElementOrSubtree(a){return this.g(a,!0)!==void 0}forEach(a){for(const[e,h]of this)a(h,e)}*[Symbol.iterator](){yield*this.h(this.c)}h(a){const e=[];return this.j(a,e),e[Symbol.iterator]()}j(a,e){a&&(a.left&&this.j(a.left,e),a.value&&e.push([a.key,a.value]),a.mid&&this.j(a.mid,e),a.right&&this.j(a.right,e))}_isBalanced(){const a=e=>{if(!e)return!0;const h=e.balanceFactor();return h<-1||h>1?!1:a(e.left)&&a(e.right)};return a(this.c)}}t.$Zh=T}),define($e[7],we([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Qf=t.$Pf=t.$Of=t.$Nf=t.$Mf=t.$Lf=t.$Kf=t.$Jf=t.$If=t.$Hf=t.$Gf=t.$Ff=t.$Ef=t.$Df=t.$Cf=t.$Bf=t.$Af=t.$zf=void 0;function y(u){return typeof u=="string"}t.$zf=y;function L(u){return Array.isArray(u)&&u.every(o=>y(o))}t.$Af=L;function i(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}t.$Bf=i;function U(u){const o=Object.getPrototypeOf(Uint8Array);return typeof u=="object"&&u instanceof o}t.$Cf=U;function D(u){return typeof u=="number"&&!isNaN(u)}t.$Df=D;function A(u){return!!u&&typeof u[Symbol.iterator]=="function"}t.$Ef=A;function c(u){return u===!0||u===!1}t.$Ff=c;function g(u){return typeof u>"u"}t.$Gf=g;function f(u){return!T(u)}t.$Hf=f;function T(u){return g(u)||u===null}t.$If=T;function s(u,o){if(!u)throw new Error(o?`Unexpected type, expected '${o}'`:"Unexpected type")}t.$Jf=s;function a(u){if(T(u))throw new Error("Assertion Failed: argument is undefined or null");return u}t.$Kf=a;function e(...u){const o=[];for(let N=0;N<u.length;N++){const z=u[N];if(T(z))throw new Error(`Assertion Failed: argument at index ${N} is undefined or null`);o.push(z)}return o}t.$Lf=e;const h=Object.prototype.hasOwnProperty;function l(u){if(!i(u))return!1;for(const o in u)if(h.call(u,o))return!1;return!0}t.$Mf=l;function m(u){return typeof u=="function"}t.$Nf=m;function n(...u){return u.length>0&&u.every(m)}t.$Of=n;function r(u,o){const N=Math.min(u.length,o.length);for(let z=0;z<N;z++)b(u[z],o[z])}t.$Pf=r;function b(u,o){if(y(o)){if(typeof u!==o)throw new Error(`argument does not match constraint: typeof ${o}`)}else if(m(o)){try{if(u instanceof o)return}catch{}if(!T(u)&&u.constructor===o||o.length===1&&o.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.$Qf=b}),define($e[18],we([1,0,7]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Yj=t.$Xj=t.$Wj=void 0;const L=Object.create(null);function i(A,c){if((0,y.$zf)(c)){const g=L[c];if(g===void 0)throw new Error(`${A} references an unknown codicon: ${c}`);c=g}return L[A]=c,{id:A}}function U(){return L}t.$Wj=U;function D(){return Object.values(t.$Yj)}t.$Xj=D,t.$Yj={add:i("add",6e4),plus:i("plus",6e4),gistNew:i("gist-new",6e4),repoCreate:i("repo-create",6e4),lightbulb:i("lightbulb",60001),lightBulb:i("light-bulb",60001),repo:i("repo",60002),repoDelete:i("repo-delete",60002),gistFork:i("gist-fork",60003),repoForked:i("repo-forked",60003),gitPullRequest:i("git-pull-request",60004),gitPullRequestAbandoned:i("git-pull-request-abandoned",60004),recordKeys:i("record-keys",60005),keyboard:i("keyboard",60005),tag:i("tag",60006),tagAdd:i("tag-add",60006),tagRemove:i("tag-remove",60006),gitPullRequestLabel:i("git-pull-request-label",60006),person:i("person",60007),personFollow:i("person-follow",60007),personOutline:i("person-outline",60007),personFilled:i("person-filled",60007),gitBranch:i("git-branch",60008),gitBranchCreate:i("git-branch-create",60008),gitBranchDelete:i("git-branch-delete",60008),sourceControl:i("source-control",60008),mirror:i("mirror",60009),mirrorPublic:i("mirror-public",60009),star:i("star",60010),starAdd:i("star-add",60010),starDelete:i("star-delete",60010),starEmpty:i("star-empty",60010),comment:i("comment",60011),commentAdd:i("comment-add",60011),alert:i("alert",60012),warning:i("warning",60012),search:i("search",60013),searchSave:i("search-save",60013),logOut:i("log-out",60014),signOut:i("sign-out",60014),logIn:i("log-in",60015),signIn:i("sign-in",60015),eye:i("eye",60016),eyeUnwatch:i("eye-unwatch",60016),eyeWatch:i("eye-watch",60016),circleFilled:i("circle-filled",60017),primitiveDot:i("primitive-dot",60017),closeDirty:i("close-dirty",60017),debugBreakpoint:i("debug-breakpoint",60017),debugBreakpointDisabled:i("debug-breakpoint-disabled",60017),debugHint:i("debug-hint",60017),primitiveSquare:i("primitive-square",60018),edit:i("edit",60019),pencil:i("pencil",60019),info:i("info",60020),issueOpened:i("issue-opened",60020),gistPrivate:i("gist-private",60021),gitForkPrivate:i("git-fork-private",60021),lock:i("lock",60021),mirrorPrivate:i("mirror-private",60021),close:i("close",60022),removeClose:i("remove-close",60022),x:i("x",60022),repoSync:i("repo-sync",60023),sync:i("sync",60023),clone:i("clone",60024),desktopDownload:i("desktop-download",60024),beaker:i("beaker",60025),microscope:i("microscope",60025),vm:i("vm",60026),deviceDesktop:i("device-desktop",60026),file:i("file",60027),fileText:i("file-text",60027),more:i("more",60028),ellipsis:i("ellipsis",60028),kebabHorizontal:i("kebab-horizontal",60028),mailReply:i("mail-reply",60029),reply:i("reply",60029),organization:i("organization",60030),organizationFilled:i("organization-filled",60030),organizationOutline:i("organization-outline",60030),newFile:i("new-file",60031),fileAdd:i("file-add",60031),newFolder:i("new-folder",60032),fileDirectoryCreate:i("file-directory-create",60032),trash:i("trash",60033),trashcan:i("trashcan",60033),history:i("history",60034),clock:i("clock",60034),folder:i("folder",60035),fileDirectory:i("file-directory",60035),symbolFolder:i("symbol-folder",60035),logoGithub:i("logo-github",60036),markGithub:i("mark-github",60036),github:i("github",60036),terminal:i("terminal",60037),console:i("console",60037),repl:i("repl",60037),zap:i("zap",60038),symbolEvent:i("symbol-event",60038),error:i("error",60039),stop:i("stop",60039),variable:i("variable",60040),symbolVariable:i("symbol-variable",60040),array:i("array",60042),symbolArray:i("symbol-array",60042),symbolModule:i("symbol-module",60043),symbolPackage:i("symbol-package",60043),symbolNamespace:i("symbol-namespace",60043),symbolObject:i("symbol-object",60043),symbolMethod:i("symbol-method",60044),symbolFunction:i("symbol-function",60044),symbolConstructor:i("symbol-constructor",60044),symbolBoolean:i("symbol-boolean",60047),symbolNull:i("symbol-null",60047),symbolNumeric:i("symbol-numeric",60048),symbolNumber:i("symbol-number",60048),symbolStructure:i("symbol-structure",60049),symbolStruct:i("symbol-struct",60049),symbolParameter:i("symbol-parameter",60050),symbolTypeParameter:i("symbol-type-parameter",60050),symbolKey:i("symbol-key",60051),symbolText:i("symbol-text",60051),symbolReference:i("symbol-reference",60052),goToFile:i("go-to-file",60052),symbolEnum:i("symbol-enum",60053),symbolValue:i("symbol-value",60053),symbolRuler:i("symbol-ruler",60054),symbolUnit:i("symbol-unit",60054),activateBreakpoints:i("activate-breakpoints",60055),archive:i("archive",60056),arrowBoth:i("arrow-both",60057),arrowDown:i("arrow-down",60058),arrowLeft:i("arrow-left",60059),arrowRight:i("arrow-right",60060),arrowSmallDown:i("arrow-small-down",60061),arrowSmallLeft:i("arrow-small-left",60062),arrowSmallRight:i("arrow-small-right",60063),arrowSmallUp:i("arrow-small-up",60064),arrowUp:i("arrow-up",60065),bell:i("bell",60066),bold:i("bold",60067),book:i("book",60068),bookmark:i("bookmark",60069),debugBreakpointConditionalUnverified:i("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:i("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:i("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:i("debug-breakpoint-data-unverified",60072),debugBreakpointData:i("debug-breakpoint-data",60073),debugBreakpointDataDisabled:i("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:i("debug-breakpoint-log-unverified",60074),debugBreakpointLog:i("debug-breakpoint-log",60075),debugBreakpointLogDisabled:i("debug-breakpoint-log-disabled",60075),briefcase:i("briefcase",60076),broadcast:i("broadcast",60077),browser:i("browser",60078),bug:i("bug",60079),calendar:i("calendar",60080),caseSensitive:i("case-sensitive",60081),check:i("check",60082),checklist:i("checklist",60083),chevronDown:i("chevron-down",60084),dropDownButton:i("drop-down-button",60084),chevronLeft:i("chevron-left",60085),chevronRight:i("chevron-right",60086),chevronUp:i("chevron-up",60087),chromeClose:i("chrome-close",60088),chromeMaximize:i("chrome-maximize",60089),chromeMinimize:i("chrome-minimize",60090),chromeRestore:i("chrome-restore",60091),circle:i("circle",60092),circleOutline:i("circle-outline",60092),debugBreakpointUnverified:i("debug-breakpoint-unverified",60092),circleSlash:i("circle-slash",60093),circuitBoard:i("circuit-board",60094),clearAll:i("clear-all",60095),clippy:i("clippy",60096),closeAll:i("close-all",60097),cloudDownload:i("cloud-download",60098),cloudUpload:i("cloud-upload",60099),code:i("code",60100),collapseAll:i("collapse-all",60101),colorMode:i("color-mode",60102),commentDiscussion:i("comment-discussion",60103),compareChanges:i("compare-changes",60157),creditCard:i("credit-card",60105),dash:i("dash",60108),dashboard:i("dashboard",60109),database:i("database",60110),debugContinue:i("debug-continue",60111),debugDisconnect:i("debug-disconnect",60112),debugPause:i("debug-pause",60113),debugRestart:i("debug-restart",60114),debugStart:i("debug-start",60115),debugStepInto:i("debug-step-into",60116),debugStepOut:i("debug-step-out",60117),debugStepOver:i("debug-step-over",60118),debugStop:i("debug-stop",60119),debug:i("debug",60120),deviceCameraVideo:i("device-camera-video",60121),deviceCamera:i("device-camera",60122),deviceMobile:i("device-mobile",60123),diffAdded:i("diff-added",60124),diffIgnored:i("diff-ignored",60125),diffModified:i("diff-modified",60126),diffRemoved:i("diff-removed",60127),diffRenamed:i("diff-renamed",60128),diff:i("diff",60129),discard:i("discard",60130),editorLayout:i("editor-layout",60131),emptyWindow:i("empty-window",60132),exclude:i("exclude",60133),extensions:i("extensions",60134),eyeClosed:i("eye-closed",60135),fileBinary:i("file-binary",60136),fileCode:i("file-code",60137),fileMedia:i("file-media",60138),filePdf:i("file-pdf",60139),fileSubmodule:i("file-submodule",60140),fileSymlinkDirectory:i("file-symlink-directory",60141),fileSymlinkFile:i("file-symlink-file",60142),fileZip:i("file-zip",60143),files:i("files",60144),filter:i("filter",60145),flame:i("flame",60146),foldDown:i("fold-down",60147),foldUp:i("fold-up",60148),fold:i("fold",60149),folderActive:i("folder-active",60150),folderOpened:i("folder-opened",60151),gear:i("gear",60152),gift:i("gift",60153),gistSecret:i("gist-secret",60154),gist:i("gist",60155),gitCommit:i("git-commit",60156),gitCompare:i("git-compare",60157),gitMerge:i("git-merge",60158),githubAction:i("github-action",60159),githubAlt:i("github-alt",60160),globe:i("globe",60161),grabber:i("grabber",60162),graph:i("graph",60163),gripper:i("gripper",60164),heart:i("heart",60165),home:i("home",60166),horizontalRule:i("horizontal-rule",60167),hubot:i("hubot",60168),inbox:i("inbox",60169),issueClosed:i("issue-closed",60324),issueReopened:i("issue-reopened",60171),issues:i("issues",60172),italic:i("italic",60173),jersey:i("jersey",60174),json:i("json",60175),bracket:i("bracket",60175),kebabVertical:i("kebab-vertical",60176),key:i("key",60177),law:i("law",60178),lightbulbAutofix:i("lightbulb-autofix",60179),linkExternal:i("link-external",60180),link:i("link",60181),listOrdered:i("list-ordered",60182),listUnordered:i("list-unordered",60183),liveShare:i("live-share",60184),loading:i("loading",60185),location:i("location",60186),mailRead:i("mail-read",60187),mail:i("mail",60188),markdown:i("markdown",60189),megaphone:i("megaphone",60190),mention:i("mention",60191),milestone:i("milestone",60192),gitPullRequestMilestone:i("git-pull-request-milestone",60192),mortarBoard:i("mortar-board",60193),move:i("move",60194),multipleWindows:i("multiple-windows",60195),mute:i("mute",60196),noNewline:i("no-newline",60197),note:i("note",60198),octoface:i("octoface",60199),openPreview:i("open-preview",60200),package:i("package",60201),paintcan:i("paintcan",60202),pin:i("pin",60203),play:i("play",60204),run:i("run",60204),plug:i("plug",60205),preserveCase:i("preserve-case",60206),preview:i("preview",60207),project:i("project",60208),pulse:i("pulse",60209),question:i("question",60210),quote:i("quote",60211),radioTower:i("radio-tower",60212),reactions:i("reactions",60213),references:i("references",60214),refresh:i("refresh",60215),regex:i("regex",60216),remoteExplorer:i("remote-explorer",60217),remote:i("remote",60218),remove:i("remove",60219),replaceAll:i("replace-all",60220),replace:i("replace",60221),repoClone:i("repo-clone",60222),repoForcePush:i("repo-force-push",60223),repoPull:i("repo-pull",60224),repoPush:i("repo-push",60225),report:i("report",60226),requestChanges:i("request-changes",60227),rocket:i("rocket",60228),rootFolderOpened:i("root-folder-opened",60229),rootFolder:i("root-folder",60230),rss:i("rss",60231),ruby:i("ruby",60232),saveAll:i("save-all",60233),saveAs:i("save-as",60234),save:i("save",60235),screenFull:i("screen-full",60236),screenNormal:i("screen-normal",60237),searchStop:i("search-stop",60238),server:i("server",60240),settingsGear:i("settings-gear",60241),settings:i("settings",60242),shield:i("shield",60243),smiley:i("smiley",60244),sortPrecedence:i("sort-precedence",60245),splitHorizontal:i("split-horizontal",60246),splitVertical:i("split-vertical",60247),squirrel:i("squirrel",60248),starFull:i("star-full",60249),starHalf:i("star-half",60250),symbolClass:i("symbol-class",60251),symbolColor:i("symbol-color",60252),symbolCustomColor:i("symbol-customcolor",60252),symbolConstant:i("symbol-constant",60253),symbolEnumMember:i("symbol-enum-member",60254),symbolField:i("symbol-field",60255),symbolFile:i("symbol-file",60256),symbolInterface:i("symbol-interface",60257),symbolKeyword:i("symbol-keyword",60258),symbolMisc:i("symbol-misc",60259),symbolOperator:i("symbol-operator",60260),symbolProperty:i("symbol-property",60261),wrench:i("wrench",60261),wrenchSubaction:i("wrench-subaction",60261),symbolSnippet:i("symbol-snippet",60262),tasklist:i("tasklist",60263),telescope:i("telescope",60264),textSize:i("text-size",60265),threeBars:i("three-bars",60266),thumbsdown:i("thumbsdown",60267),thumbsup:i("thumbsup",60268),tools:i("tools",60269),triangleDown:i("triangle-down",60270),triangleLeft:i("triangle-left",60271),triangleRight:i("triangle-right",60272),triangleUp:i("triangle-up",60273),twitter:i("twitter",60274),unfold:i("unfold",60275),unlock:i("unlock",60276),unmute:i("unmute",60277),unverified:i("unverified",60278),verified:i("verified",60279),versions:i("versions",60280),vmActive:i("vm-active",60281),vmOutline:i("vm-outline",60282),vmRunning:i("vm-running",60283),watch:i("watch",60284),whitespace:i("whitespace",60285),wholeWord:i("whole-word",60286),window:i("window",60287),wordWrap:i("word-wrap",60288),zoomIn:i("zoom-in",60289),zoomOut:i("zoom-out",60290),listFilter:i("list-filter",60291),listFlat:i("list-flat",60292),listSelection:i("list-selection",60293),selection:i("selection",60293),listTree:i("list-tree",60294),debugBreakpointFunctionUnverified:i("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:i("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:i("debug-breakpoint-function-disabled",60296),debugStackframeActive:i("debug-stackframe-active",60297),circleSmallFilled:i("circle-small-filled",60298),debugStackframeDot:i("debug-stackframe-dot",60298),debugStackframe:i("debug-stackframe",60299),debugStackframeFocused:i("debug-stackframe-focused",60299),debugBreakpointUnsupported:i("debug-breakpoint-unsupported",60300),symbolString:i("symbol-string",60301),debugReverseContinue:i("debug-reverse-continue",60302),debugStepBack:i("debug-step-back",60303),debugRestartFrame:i("debug-restart-frame",60304),callIncoming:i("call-incoming",60306),callOutgoing:i("call-outgoing",60307),menu:i("menu",60308),expandAll:i("expand-all",60309),feedback:i("feedback",60310),gitPullRequestReviewer:i("git-pull-request-reviewer",60310),groupByRefType:i("group-by-ref-type",60311),ungroupByRefType:i("ungroup-by-ref-type",60312),account:i("account",60313),gitPullRequestAssignee:i("git-pull-request-assignee",60313),bellDot:i("bell-dot",60314),debugConsole:i("debug-console",60315),library:i("library",60316),output:i("output",60317),runAll:i("run-all",60318),syncIgnored:i("sync-ignored",60319),pinned:i("pinned",60320),githubInverted:i("github-inverted",60321),debugAlt:i("debug-alt",60305),serverProcess:i("server-process",60322),serverEnvironment:i("server-environment",60323),pass:i("pass",60324),stopCircle:i("stop-circle",60325),playCircle:i("play-circle",60326),record:i("record",60327),debugAltSmall:i("debug-alt-small",60328),vmConnect:i("vm-connect",60329),cloud:i("cloud",60330),merge:i("merge",60331),exportIcon:i("export",60332),graphLeft:i("graph-left",60333),magnet:i("magnet",60334),notebook:i("notebook",60335),redo:i("redo",60336),checkAll:i("check-all",60337),pinnedDirty:i("pinned-dirty",60338),passFilled:i("pass-filled",60339),circleLargeFilled:i("circle-large-filled",60340),circleLarge:i("circle-large",60341),circleLargeOutline:i("circle-large-outline",60341),combine:i("combine",60342),gather:i("gather",60342),table:i("table",60343),variableGroup:i("variable-group",60344),typeHierarchy:i("type-hierarchy",60345),typeHierarchySub:i("type-hierarchy-sub",60346),typeHierarchySuper:i("type-hierarchy-super",60347),gitPullRequestCreate:i("git-pull-request-create",60348),runAbove:i("run-above",60349),runBelow:i("run-below",60350),notebookTemplate:i("notebook-template",60351),debugRerun:i("debug-rerun",60352),workspaceTrusted:i("workspace-trusted",60353),workspaceUntrusted:i("workspace-untrusted",60354),workspaceUnspecified:i("workspace-unspecified",60355),terminalCmd:i("terminal-cmd",60356),terminalDebian:i("terminal-debian",60357),terminalLinux:i("terminal-linux",60358),terminalPowershell:i("terminal-powershell",60359),terminalTmux:i("terminal-tmux",60360),terminalUbuntu:i("terminal-ubuntu",60361),terminalBash:i("terminal-bash",60362),arrowSwap:i("arrow-swap",60363),copy:i("copy",60364),personAdd:i("person-add",60365),filterFilled:i("filter-filled",60366),wand:i("wand",60367),debugLineByLine:i("debug-line-by-line",60368),inspect:i("inspect",60369),layers:i("layers",60370),layersDot:i("layers-dot",60371),layersActive:i("layers-active",60372),compass:i("compass",60373),compassDot:i("compass-dot",60374),compassActive:i("compass-active",60375),azure:i("azure",60376),issueDraft:i("issue-draft",60377),gitPullRequestClosed:i("git-pull-request-closed",60378),gitPullRequestDraft:i("git-pull-request-draft",60379),debugAll:i("debug-all",60380),debugCoverage:i("debug-coverage",60381),runErrors:i("run-errors",60382),folderLibrary:i("folder-library",60383),debugContinueSmall:i("debug-continue-small",60384),beakerStop:i("beaker-stop",60385),graphLine:i("graph-line",60386),graphScatter:i("graph-scatter",60387),pieChart:i("pie-chart",60388),bracketDot:i("bracket-dot",60389),bracketError:i("bracket-error",60390),lockSmall:i("lock-small",60391),azureDevops:i("azure-devops",60392),verifiedFilled:i("verified-filled",60393),newLine:i("newline",60394),layout:i("layout",60395),layoutActivitybarLeft:i("layout-activitybar-left",60396),layoutActivitybarRight:i("layout-activitybar-right",60397),layoutPanelLeft:i("layout-panel-left",60398),layoutPanelCenter:i("layout-panel-center",60399),layoutPanelJustify:i("layout-panel-justify",60400),layoutPanelRight:i("layout-panel-right",60401),layoutPanel:i("layout-panel",60402),layoutSidebarLeft:i("layout-sidebar-left",60403),layoutSidebarRight:i("layout-sidebar-right",60404),layoutStatusbar:i("layout-statusbar",60405),layoutMenubar:i("layout-menubar",60406),layoutCentered:i("layout-centered",60407),layoutSidebarRightOff:i("layout-sidebar-right-off",60416),layoutPanelOff:i("layout-panel-off",60417),layoutSidebarLeftOff:i("layout-sidebar-left-off",60418),target:i("target",60408),indent:i("indent",60409),recordSmall:i("record-small",60410),errorSmall:i("error-small",60411),arrowCircleDown:i("arrow-circle-down",60412),arrowCircleLeft:i("arrow-circle-left",60413),arrowCircleRight:i("arrow-circle-right",60414),arrowCircleUp:i("arrow-circle-up",60415),heartFilled:i("heart-filled",60420),map:i("map",60421),mapFilled:i("map-filled",60422),circleSmall:i("circle-small",60423),bellSlash:i("bell-slash",60424),bellSlashDot:i("bell-slash-dot",60425),commentUnresolved:i("comment-unresolved",60426),gitPullRequestGoToChanges:i("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:i("git-pull-request-new-changes",60428),searchFuzzy:i("search-fuzzy",60429),commentDraft:i("comment-draft",60430),send:i("send",60431),sparkle:i("sparkle",60432),insert:i("insert",60433),mic:i("mic",60434),thumbsDownFilled:i("thumbsdown-filled",60435),thumbsUpFilled:i("thumbsup-filled",60436),coffee:i("coffee",60437),snake:i("snake",60438),game:i("game",60439),vr:i("vr",60440),chip:i("chip",60441),piano:i("piano",60442),music:i("music",60443),micFilled:i("mic-filled",60444),gitFetch:i("git-fetch",60445),copilot:i("copilot",60446),dialogError:i("dialog-error","error"),dialogWarning:i("dialog-warning","warning"),dialogInfo:i("dialog-info","info"),dialogClose:i("dialog-close","close"),treeItemExpanded:i("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:i("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:i("tree-filter-on-type-off","list-selection"),treeFilterClear:i("tree-filter-clear","close"),treeItemLoading:i("tree-item-loading","loading"),menuSelection:i("menu-selection","check"),menuSubmenu:i("menu-submenu","chevron-right"),menuBarMore:i("menubar-more","more"),scrollbarButtonLeft:i("scrollbar-button-left","triangle-left"),scrollbarButtonRight:i("scrollbar-button-right","triangle-right"),scrollbarButtonUp:i("scrollbar-button-up","triangle-up"),scrollbarButtonDown:i("scrollbar-button-down","triangle-down"),toolBarMore:i("toolbar-more","more"),quickInputBack:i("quick-input-back","arrow-left")}}),define($e[51],we([1,0,7]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jn=t.$in=t.$hn=t.$gn=t.$fn=t.$en=t.$dn=t.$cn=t.$bn=t.$an=t.$_m=t.$$m=void 0;function L(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const n=Array.isArray(m)?[]:{};return Object.entries(m).forEach(([r,b])=>{n[r]=b&&typeof b=="object"?L(b):b}),n}t.$$m=L;function i(m){if(!m||typeof m!="object")return m;const n=[m];for(;n.length>0;){const r=n.shift();Object.freeze(r);for(const b in r)if(U.call(r,b)){const u=r[b];typeof u=="object"&&!Object.isFrozen(u)&&!(0,y.$Cf)(u)&&n.push(u)}}return m}t.$_m=i;const U=Object.prototype.hasOwnProperty;function D(m,n){return A(m,n,new Set)}t.$an=D;function A(m,n,r){if((0,y.$If)(m))return m;const b=n(m);if(typeof b<"u")return b;if(Array.isArray(m)){const u=[];for(const o of m)u.push(A(o,n,r));return u}if((0,y.$Bf)(m)){if(r.has(m))throw new Error("Cannot clone recursive data-structure");r.add(m);const u={};for(const o in m)U.call(m,o)&&(u[o]=A(m[o],n,r));return r.delete(m),u}return m}function c(m,n,r=!0){return(0,y.$Bf)(m)?((0,y.$Bf)(n)&&Object.keys(n).forEach(b=>{b in m?r&&((0,y.$Bf)(m[b])&&(0,y.$Bf)(n[b])?c(m[b],n[b],r):m[b]=n[b]):m[b]=n[b]}),m):n}t.$bn=c;function g(m,n){if(m===n)return!0;if(m==null||n===null||n===void 0||typeof m!=typeof n||typeof m!="object"||Array.isArray(m)!==Array.isArray(n))return!1;let r,b;if(Array.isArray(m)){if(m.length!==n.length)return!1;for(r=0;r<m.length;r++)if(!g(m[r],n[r]))return!1}else{const u=[];for(b in m)u.push(b);u.sort();const o=[];for(b in n)o.push(b);if(o.sort(),!g(u,o))return!1;for(r=0;r<u.length;r++)if(!g(m[u[r]],n[u[r]]))return!1}return!0}t.$cn=g;function f(m){const n=new Set;return JSON.stringify(m,(r,b)=>{if((0,y.$Bf)(b)||Array.isArray(b)){if(n.has(b))return"[Circular]";n.add(b)}return b})}t.$dn=f;function T(m,n){const r=Object.create(null);return!m||!n||Object.keys(n).forEach(u=>{const o=m[u],N=n[u];g(o,N)||(r[u]=N)}),r}t.$en=T;function s(m,n){const r=n.toLowerCase(),b=Object.keys(m).find(u=>u.toLowerCase()===r);return b?m[b]:m[n]}t.$fn=s;function a(m,n){const r=Object.create(null);for(const[b,u]of Object.entries(m))n(b,u)&&(r[b]=u);return r}t.$gn=a;function e(m){let n=[];for(;Object.prototype!==m;)n=n.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return n}t.$hn=e;function h(m){const n=[];for(const r of e(m))typeof m[r]=="function"&&n.push(r);return n}t.$in=h;function l(m,n){const r=u=>function(){const o=Array.prototype.slice.call(arguments,0);return n(u,o)},b={};for(const u of m)b[u]=r(u);return b}t.$jn=l}),define($e[19],we([1,0,18]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ThemeIcon=t.$Zj=t.ThemeColor=void 0;var L;(function(D){function A(c){return c&&typeof c=="object"&&typeof c.id=="string"}D.isThemeColor=A})(L||(t.ThemeColor=L={}));function i(D){return{id:D}}t.$Zj=i;var U;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const A=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function c(n){const r=A.exec(n.id);if(!r)return c(y.$Yj.error);const[,b,u]=r,o=["codicon","codicon-"+b];return u&&o.push("codicon-modifier-"+u.substring(1)),o}D.asClassNameArray=c;function g(n){return c(n).join(" ")}D.asClassName=g;function f(n){return"."+c(n).join(".")}D.asCSSSelector=f;function T(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||L.isThemeColor(n.color))}D.isThemeIcon=T;const s=new RegExp(`^\\$\\((${D.iconNameExpression}(?:${D.iconModifierExpression})?)\\)$`);function a(n){const r=s.exec(n);if(!r)return;const[,b]=r;return{id:b}}D.fromString=a;function e(n){return{id:n}}D.fromId=e;function h(n,r){let b=n.id;const u=b.lastIndexOf("~");return u!==-1&&(b=b.substring(0,u)),r&&(b=`${b}~${r}`),{id:b}}D.modify=h;function l(n){const r=n.id.lastIndexOf("~");if(r!==-1)return n.id.substring(r+1)}D.getModifier=l;function m(n,r){return n.id===r.id&&n.color?.id===r.color?.id}D.isEqual=m})(U||(t.ThemeIcon=U={}))}),define($e[35],we([1,0,34,12,19]),function(le,t,y,L,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6j=t.$5j=t.$4j=t.$3j=t.$2j=t.$1j=void 0;const U="$(",D=new RegExp(`\\$\\(${i.ThemeIcon.iconNameExpression}(?:${i.ThemeIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${D.source}`,"g");function c(m){return m.replace(A,(n,r)=>r?n:`\\${n}`)}t.$1j=c;const g=new RegExp(`\\\\${D.source}`,"g");function f(m){return m.replace(g,n=>`\\${n}`)}t.$2j=f;const T=new RegExp(`(\\s)?(\\\\)?${D.source}(\\s)?`,"g");function s(m){return m.indexOf(U)===-1?m:m.replace(T,(n,r,b,u)=>b?n:r||u||"")}t.$3j=s;function a(m){return m?m.replace(/\$\((.*?)\)/g,(n,r)=>` ${r} `).trim():""}t.$4j=a;const e=new RegExp(`\\$\\(${i.ThemeIcon.iconNameCharacter}+\\)`,"g");function h(m){e.lastIndex=0;let n="";const r=[];let b=0;for(;;){const u=e.lastIndex,o=e.exec(m),N=m.substring(u,o?.index);if(N.length>0){n+=N;for(let z=0;z<N.length;z++)r.push(b)}if(!o)break;b+=o[0].length}return{text:n,iconOffsets:r}}t.$5j=h;function l(m,n,r=!1){const{text:b,iconOffsets:u}=n;if(!u||u.length===0)return(0,y.$Nj)(m,b,r);const o=(0,L.$Ke)(b," "),N=b.length-o.length,z=(0,y.$Nj)(m,o,r);if(z)for(const R of z){const d=u[R.start+N]+N;R.start+=d,R.end+=d}return z}t.$6j=l}),define($e[88],we([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$LT=t.$KT=void 0,t.$KT="vscode:contextmenu",t.$LT="vscode:onCloseContextMenu"}),define($e[89],we([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ST=void 0;class y{constructor(i,U){this.a=i,this.onMessage=U}send(i){try{this.a.send("vscode:message",i.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}t.$ST=y}),define($e[52],we([8]),{}),define($e[90],we([8]),{}),define($e[91],we([8]),{}),define($e[92],we([8]),{}),define($e[93],we([1,0,91,92]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})}),define($e[94],we([8]),{}),define($e[95],we([8]),{}),define($e[96],we([8]),{}),define($e[97],we([8]),{}),define($e[98],we([8]),{}),define($e[99],we([8]),{}),define($e[100],we([8]),{}),define($e[101],we([8]),{}),define($e[102],we([8]),{}),define($e[103],we([13,10]),function(le,t){return le.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define($e[104],we([13,10]),function(le,t){return le.create("vs/base/browser/ui/findinput/findInput",t)}),define($e[105],we([13,10]),function(le,t){return le.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define($e[106],we([13,10]),function(le,t){return le.create("vs/base/browser/ui/iconLabel/iconLabelHover",t)}),define($e[107],we([13,10]),function(le,t){return le.create("vs/base/browser/ui/inputbox/inputBox",t)}),define($e[108],we([13,10]),function(le,t){return le.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define($e[109],we([13,10]),function(le,t){return le.create("vs/base/browser/ui/tree/abstractTree",t)}),define($e[110],we([13,10]),function(le,t){return le.create("vs/base/common/actions",t)}),define($e[36],we([1,0,4,2,110]),function(le,t,y,L,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Di=t.$Ci=t.$Bi=t.$Ai=t.$zi=t.$yi=void 0;class U extends L.$Rc{constructor(s,a="",e="",h=!0,l){super(),this.h=this.B(new y.$Od),this.onDidChange=this.h.event,this.w=!0,this.j=s,this.m=a,this.u=e,this.w=h,this.C=l}get id(){return this.j}get label(){return this.m}set label(s){this.D(s)}D(s){this.m!==s&&(this.m=s,this.h.fire({label:s}))}get tooltip(){return this.n||""}set tooltip(s){this.F(s)}F(s){this.n!==s&&(this.n=s,this.h.fire({tooltip:s}))}get class(){return this.u}set class(s){this.G(s)}G(s){this.u!==s&&(this.u=s,this.h.fire({class:s}))}get enabled(){return this.w}set enabled(s){this.H(s)}H(s){this.w!==s&&(this.w=s,this.h.fire({enabled:s}))}get checked(){return this.z}set checked(s){this.I(s)}I(s){this.z!==s&&(this.z=s,this.h.fire({checked:s}))}async run(s,a){this.C&&await this.C(s)}}t.$yi=U;class D extends L.$Rc{constructor(){super(...arguments),this.f=this.B(new y.$Od),this.onWillRun=this.f.event,this.m=this.B(new y.$Od),this.onDidRun=this.m.event}async run(s,a){if(!s.enabled)return;this.f.fire({action:s});let e;try{await this.u(s,a)}catch(h){e=h}this.m.fire({action:s,error:e})}async u(s,a){await s.run(a)}}t.$zi=D;class A{constructor(){this.id=A.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...s){let a=[];for(const e of s)e.length&&(a.length?a=[...a,new A,...e]:a=e);return a}static{this.ID="vs.actions.separator"}async run(){}}t.$Ai=A;class c{get actions(){return this.a}constructor(s,a,e,h){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=s,this.label=a,this.class=h,this.a=e}async run(){}}t.$Bi=c;class g extends U{static{this.ID="vs.actions.empty"}constructor(){super(g.ID,i.localize(0,null),void 0,!1)}}t.$Ci=g;function f(T){return{id:T.id,label:T.label,class:void 0,enabled:T.enabled??!0,checked:T.checked??!1,run:async(...s)=>T.run(...s),tooltip:T.label}}t.$Di=f}),define($e[111],we([13,10]),function(le,t){return le.create("vs/base/common/platform",t)}),define($e[5],we([1,0,111]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$I=t.$H=t.$G=t.$F=t.$E=t.$D=t.OS=t.OperatingSystem=t.$B=t.$A=t.$z=t.$y=t.$x=t.Language=t.$w=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.Platform=t.$h=t.$g=void 0,t.$g="en";let L=!1,i=!1,U=!1,D=!1,A=!1,c=!1,g=!1,f=!1,T=!1,s=!1,a,e=t.$g,h=t.$g,l,m;t.$h=typeof self=="object"?self:typeof global=="object"?global:{};let n;typeof t.$h.vscode<"u"&&typeof t.$h.vscode.process<"u"?n=t.$h.vscode.process:typeof process<"u"&&(n=process);const r=typeof n?.versions?.electron=="string",b=r&&n?.type==="renderer";if(typeof navigator=="object"&&!b)m=navigator.userAgent,L=m.indexOf("Windows")>=0,i=m.indexOf("Macintosh")>=0,f=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,U=m.indexOf("Linux")>=0,s=m?.indexOf("Mobi")>=0,c=!0,a=y.getConfiguredDefaultLocale(y.localize(0,null))||t.$g,e=a,h=navigator.language;else if(typeof n=="object"){L=n.platform==="win32",i=n.platform==="darwin",U=n.platform==="linux",D=U&&!!n.env.SNAP&&!!n.env.SNAP_REVISION,g=r,T=!!n.env.CI||!!n.env.BUILD_ARTIFACTSTAGINGDIRECTORY,a=t.$g,e=t.$g;const H=n.env.VSCODE_NLS_CONFIG;if(H)try{const x=JSON.parse(H),C=x.availableLanguages["*"];a=x.locale,h=x.osLocale,e=C||t.$g,l=x._translationsConfigFile}catch{}A=!0}else console.error("Unable to resolve platform.");var u;(function(H){H[H.Web=0]="Web",H[H.Mac=1]="Mac",H[H.Linux=2]="Linux",H[H.Windows=3]="Windows"})(u||(t.Platform=u={}));function o(H){switch(H){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.$i=o;let N=0;i?N=1:L?N=3:U&&(N=2),t.$j=L,t.$k=i,t.$l=U,t.$m=D,t.$n=A,t.$o=g,t.$p=c,t.$q=c&&typeof t.$h.importScripts=="function",t.$r=f,t.$s=s,t.$t=T,t.$u=N,t.$v=m,t.$w=e;var z;(function(H){function x(){return t.$w}H.value=x;function C(){return t.$w.length===2?t.$w==="en":t.$w.length>=3?t.$w[0]==="e"&&t.$w[1]==="n"&&t.$w[2]==="-":!1}H.isDefaultVariant=C;function F(){return t.$w==="en"}H.isDefault=F})(z||(t.Language=z={})),t.$x=a,t.$y=h,t.$z=l,t.$A=typeof t.$h.postMessage=="function"&&!t.$h.importScripts,t.$B=(()=>{if(t.$A){const H=[];t.$h.addEventListener("message",C=>{if(C.data&&C.data.vscodeScheduleAsyncWork)for(let F=0,Q=H.length;F<Q;F++){const te=H[F];if(te.id===C.data.vscodeScheduleAsyncWork){H.splice(F,1),te.callback();return}}});let x=0;return C=>{const F=++x;H.push({id:F,callback:C}),t.$h.postMessage({vscodeScheduleAsyncWork:F},"*")}}return H=>setTimeout(H)})();var R;(function(H){H[H.Windows=1]="Windows",H[H.Macintosh=2]="Macintosh",H[H.Linux=3]="Linux"})(R||(t.OperatingSystem=R={})),t.OS=i||f?2:L?1:3;let d=!0,E=!1;function B(){if(!E){E=!0;const H=new Uint8Array(2);H[0]=1,H[1]=2,d=new Uint16Array(H.buffer)[0]===(2<<8)+1}return d}t.$D=B,t.$E=!!(t.$v&&t.$v.indexOf("Chrome")>=0),t.$F=!!(t.$v&&t.$v.indexOf("Firefox")>=0),t.$G=!!(!t.$E&&t.$v&&t.$v.indexOf("Safari")>=0),t.$H=!!(t.$v&&t.$v.indexOf("Edg/")>=0),t.$I=!!(t.$v&&t.$v.indexOf("Android")>=0)}),define($e[112],we([1,0,17,14,5]),function(le,t,y,L,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$NO=t.KeyboardSupport=void 0;var U;(function(D){D[D.Always=0]="Always",D[D.FullScreen=1]="FullScreen",D[D.None=2]="None"})(U||(t.KeyboardSupport=U={})),t.$NO={clipboard:{writeText:i.$n||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:i.$n||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:(()=>i.$n||y.$LO()?0:navigator.keyboard||y.$HO?1:2)(),touch:"ontouchstart"in L.$sO||navigator.maxTouchPoints>0,pointerEvents:L.$sO.PointerEvent&&("ontouchstart"in L.$sO||navigator.maxTouchPoints>0||navigator.maxTouchPoints>0)}}),define($e[15],we([1,0,17,44,78,5]),function(le,t,y,L,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$VO=t.$UO=t.$TO=void 0;function D(e){if(e.charCode){const l=String.fromCharCode(e.charCode).toUpperCase();return L.KeyCodeUtils.fromString(l)}const h=e.keyCode;if(h===3)return 7;if(y.$EO)switch(h){case 59:return 85;case 60:if(U.$l)return 97;break;case 61:return 86;case 107:return 109;case 109:return 111;case 173:return 88;case 224:if(U.$k)return 57;break}else if(y.$FO){if(U.$k&&h===93)return 57;if(!U.$k&&h===92)return 57}return L.$Eq[h]||0}const A=U.$k?256:2048,c=512,g=1024,f=U.$k?2048:256;function T(e){const h=[];return e.ctrlKey&&h.push("ctrl"),e.shiftKey&&h.push("shift"),e.altKey&&h.push("alt"),e.metaKey&&h.push("meta"),`modifiers: [${h.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}t.$TO=T;function s(e){const h=[];return e.ctrlKey&&h.push("ctrl"),e.shiftKey&&h.push("shift"),e.altKey&&h.push("alt"),e.metaKey&&h.push("meta"),`modifiers: [${h.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${L.KeyCodeUtils.toString(e.keyCode)}')`}t.$UO=s;class a{constructor(h){this._standardKeyboardEventBrand=!0;const l=h;this.browserEvent=l,this.target=l.target,this.ctrlKey=l.ctrlKey,this.shiftKey=l.shiftKey,this.altKey=l.altKey,this.metaKey=l.metaKey,this.altGraphKey=l.getModifierState("AltGraph"),this.keyCode=D(l),this.code=l.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this.a=this.c(),this.b=this.d()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this.b}equals(h){return this.a===h}c(){let h=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(h=this.keyCode);let l=0;return this.ctrlKey&&(l|=A),this.altKey&&(l|=c),this.shiftKey&&(l|=g),this.metaKey&&(l|=f),l|=h,l}d(){let h=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(h=this.keyCode),new i.$Mq(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,h)}}t.$VO=a}),define($e[20],we([1,0,17,71,14,5]),function(le,t,y,L,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$SO=t.$RO=t.$QO=void 0;class D{constructor(f){this.timestamp=Date.now(),this.browserEvent=f,this.leftButton=f.button===0,this.middleButton=f.button===1,this.rightButton=f.button===2,this.buttons=f.buttons,this.target=f.target,this.detail=f.detail||1,f.type==="dblclick"&&(this.detail=2),this.ctrlKey=f.ctrlKey,this.shiftKey=f.shiftKey,this.altKey=f.altKey,this.metaKey=f.metaKey,typeof f.pageX=="number"?(this.posx=f.pageX,this.posy=f.pageY):(this.posx=f.clientX+this.target.ownerDocument.body.scrollLeft+this.target.ownerDocument.documentElement.scrollLeft,this.posy=f.clientY+this.target.ownerDocument.body.scrollTop+this.target.ownerDocument.documentElement.scrollTop);const T=L.$OO.getPositionOfChildWindowRelativeToAncestorWindow(i.$window,f.view);this.posx-=T.left,this.posy-=T.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.$QO=D;class A extends D{constructor(f){super(f),this.dataTransfer=f.dataTransfer}}t.$RO=A;class c{constructor(f,T=0,s=0){if(this.browserEvent=f||null,this.target=f?f.target||f.targetNode||f.srcElement:null,this.deltaY=s,this.deltaX=T,f){const a=f,e=f;if(typeof a.wheelDeltaY<"u")this.deltaY=a.wheelDeltaY/120;else if(typeof e.VERTICAL_AXIS<"u"&&e.axis===e.VERTICAL_AXIS)this.deltaY=-e.detail/3;else if(f.type==="wheel"){const h=f;h.deltaMode===h.DOM_DELTA_LINE?y.$EO&&!U.$k?this.deltaY=-f.deltaY/3:this.deltaY=-f.deltaY:this.deltaY=-f.deltaY/40}if(typeof a.wheelDeltaX<"u")y.$HO&&U.$j?this.deltaX=-(a.wheelDeltaX/120):this.deltaX=a.wheelDeltaX/120;else if(typeof e.HORIZONTAL_AXIS<"u"&&e.axis===e.HORIZONTAL_AXIS)this.deltaX=-f.detail/3;else if(f.type==="wheel"){const h=f;h.deltaMode===h.DOM_DELTA_LINE?y.$EO&&!U.$k?this.deltaX=-f.deltaX/3:this.deltaX=-f.deltaX:this.deltaX=-f.deltaX/40}this.deltaY===0&&this.deltaX===0&&f.wheelDelta&&(this.deltaY=f.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.$SO=c}),define($e[113],we([1,0,5]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dc=t.$cc=t.env=t.cwd=void 0;let L;if(typeof y.$h.vscode<"u"&&typeof y.$h.vscode.process<"u"){const i=y.$h.vscode.process;L={get platform(){return i.platform},get arch(){return i.arch},get env(){return i.env},cwd(){return i.cwd()}}}else typeof process<"u"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:L={get platform(){return y.$j?"win32":y.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=L.cwd,t.env=L.env,t.$cc=L.platform,t.$dc=L.arch}),define($e[23],we([1,0,113]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sc=t.sep=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=t.$fc=t.$ec=void 0;const L=65,i=97,U=90,D=122,A=46,c=47,g=92,f=58,T=63;class s extends Error{constructor(N,z,R){let d;typeof z=="string"&&z.indexOf("not ")===0?(d="must not be",z=z.replace(/^not /,"")):d="must be";const E=N.indexOf(".")!==-1?"property":"argument";let B=`The "${N}" ${E} ${d} of type ${z}`;B+=`. Received type ${typeof R}`,super(B),this.code="ERR_INVALID_ARG_TYPE"}}function a(o,N){if(o===null||typeof o!="object")throw new s(N,"Object",o)}function e(o,N){if(typeof o!="string")throw new s(N,"string",o)}const h=y.$cc==="win32";function l(o){return o===c||o===g}function m(o){return o===c}function n(o){return o>=L&&o<=U||o>=i&&o<=D}function r(o,N,z,R){let d="",E=0,B=-1,H=0,x=0;for(let C=0;C<=o.length;++C){if(C<o.length)x=o.charCodeAt(C);else{if(R(x))break;x=c}if(R(x)){if(!(B===C-1||H===1))if(H===2){if(d.length<2||E!==2||d.charCodeAt(d.length-1)!==A||d.charCodeAt(d.length-2)!==A){if(d.length>2){const F=d.lastIndexOf(z);F===-1?(d="",E=0):(d=d.slice(0,F),E=d.length-1-d.lastIndexOf(z)),B=C,H=0;continue}else if(d.length!==0){d="",E=0,B=C,H=0;continue}}N&&(d+=d.length>0?`${z}..`:"..",E=2)}else d.length>0?d+=`${z}${o.slice(B+1,C)}`:d=o.slice(B+1,C),E=C-B-1;B=C,H=0}else x===A&&H!==-1?++H:H=-1}return d}function b(o,N){a(N,"pathObject");const z=N.dir||N.root,R=N.base||`${N.name||""}${N.ext||""}`;return z?z===N.root?`${z}${R}`:`${z}${o}${R}`:R}t.$ec={resolve(...o){let N="",z="",R=!1;for(let d=o.length-1;d>=-1;d--){let E;if(d>=0){if(E=o[d],e(E,"path"),E.length===0)continue}else N.length===0?E=y.cwd():(E=y.env[`=${N}`]||y.cwd(),(E===void 0||E.slice(0,2).toLowerCase()!==N.toLowerCase()&&E.charCodeAt(2)===g)&&(E=`${N}\\`));const B=E.length;let H=0,x="",C=!1;const F=E.charCodeAt(0);if(B===1)l(F)&&(H=1,C=!0);else if(l(F))if(C=!0,l(E.charCodeAt(1))){let Q=2,te=Q;for(;Q<B&&!l(E.charCodeAt(Q));)Q++;if(Q<B&&Q!==te){const re=E.slice(te,Q);for(te=Q;Q<B&&l(E.charCodeAt(Q));)Q++;if(Q<B&&Q!==te){for(te=Q;Q<B&&!l(E.charCodeAt(Q));)Q++;(Q===B||Q!==te)&&(x=`\\\\${re}\\${E.slice(te,Q)}`,H=Q)}}}else H=1;else n(F)&&E.charCodeAt(1)===f&&(x=E.slice(0,2),H=2,B>2&&l(E.charCodeAt(2))&&(C=!0,H=3));if(x.length>0)if(N.length>0){if(x.toLowerCase()!==N.toLowerCase())continue}else N=x;if(R){if(N.length>0)break}else if(z=`${E.slice(H)}\\${z}`,R=C,C&&N.length>0)break}return z=r(z,!R,"\\",l),R?`${N}\\${z}`:`${N}${z}`||"."},normalize(o){e(o,"path");const N=o.length;if(N===0)return".";let z=0,R,d=!1;const E=o.charCodeAt(0);if(N===1)return m(E)?"\\":o;if(l(E))if(d=!0,l(o.charCodeAt(1))){let H=2,x=H;for(;H<N&&!l(o.charCodeAt(H));)H++;if(H<N&&H!==x){const C=o.slice(x,H);for(x=H;H<N&&l(o.charCodeAt(H));)H++;if(H<N&&H!==x){for(x=H;H<N&&!l(o.charCodeAt(H));)H++;if(H===N)return`\\\\${C}\\${o.slice(x)}\\`;H!==x&&(R=`\\\\${C}\\${o.slice(x,H)}`,z=H)}}}else z=1;else n(E)&&o.charCodeAt(1)===f&&(R=o.slice(0,2),z=2,N>2&&l(o.charCodeAt(2))&&(d=!0,z=3));let B=z<N?r(o.slice(z),!d,"\\",l):"";return B.length===0&&!d&&(B="."),B.length>0&&l(o.charCodeAt(N-1))&&(B+="\\"),R===void 0?d?`\\${B}`:B:d?`${R}\\${B}`:`${R}${B}`},isAbsolute(o){e(o,"path");const N=o.length;if(N===0)return!1;const z=o.charCodeAt(0);return l(z)||N>2&&n(z)&&o.charCodeAt(1)===f&&l(o.charCodeAt(2))},join(...o){if(o.length===0)return".";let N,z;for(let E=0;E<o.length;++E){const B=o[E];e(B,"path"),B.length>0&&(N===void 0?N=z=B:N+=`\\${B}`)}if(N===void 0)return".";let R=!0,d=0;if(typeof z=="string"&&l(z.charCodeAt(0))){++d;const E=z.length;E>1&&l(z.charCodeAt(1))&&(++d,E>2&&(l(z.charCodeAt(2))?++d:R=!1))}if(R){for(;d<N.length&&l(N.charCodeAt(d));)d++;d>=2&&(N=`\\${N.slice(d)}`)}return t.$ec.normalize(N)},relative(o,N){if(e(o,"from"),e(N,"to"),o===N)return"";const z=t.$ec.resolve(o),R=t.$ec.resolve(N);if(z===R||(o=z.toLowerCase(),N=R.toLowerCase(),o===N))return"";let d=0;for(;d<o.length&&o.charCodeAt(d)===g;)d++;let E=o.length;for(;E-1>d&&o.charCodeAt(E-1)===g;)E--;const B=E-d;let H=0;for(;H<N.length&&N.charCodeAt(H)===g;)H++;let x=N.length;for(;x-1>H&&N.charCodeAt(x-1)===g;)x--;const C=x-H,F=B<C?B:C;let Q=-1,te=0;for(;te<F;te++){const fe=o.charCodeAt(d+te);if(fe!==N.charCodeAt(H+te))break;fe===g&&(Q=te)}if(te!==F){if(Q===-1)return R}else{if(C>F){if(N.charCodeAt(H+te)===g)return R.slice(H+te+1);if(te===2)return R.slice(H+te)}B>F&&(o.charCodeAt(d+te)===g?Q=te:te===2&&(Q=3)),Q===-1&&(Q=0)}let re="";for(te=d+Q+1;te<=E;++te)(te===E||o.charCodeAt(te)===g)&&(re+=re.length===0?"..":"\\..");return H+=Q,re.length>0?`${re}${R.slice(H,x)}`:(R.charCodeAt(H)===g&&++H,R.slice(H,x))},toNamespacedPath(o){if(typeof o!="string"||o.length===0)return o;const N=t.$ec.resolve(o);if(N.length<=2)return o;if(N.charCodeAt(0)===g){if(N.charCodeAt(1)===g){const z=N.charCodeAt(2);if(z!==T&&z!==A)return`\\\\?\\UNC\\${N.slice(2)}`}}else if(n(N.charCodeAt(0))&&N.charCodeAt(1)===f&&N.charCodeAt(2)===g)return`\\\\?\\${N}`;return o},dirname(o){e(o,"path");const N=o.length;if(N===0)return".";let z=-1,R=0;const d=o.charCodeAt(0);if(N===1)return l(d)?o:".";if(l(d)){if(z=R=1,l(o.charCodeAt(1))){let H=2,x=H;for(;H<N&&!l(o.charCodeAt(H));)H++;if(H<N&&H!==x){for(x=H;H<N&&l(o.charCodeAt(H));)H++;if(H<N&&H!==x){for(x=H;H<N&&!l(o.charCodeAt(H));)H++;if(H===N)return o;H!==x&&(z=R=H+1)}}}}else n(d)&&o.charCodeAt(1)===f&&(z=N>2&&l(o.charCodeAt(2))?3:2,R=z);let E=-1,B=!0;for(let H=N-1;H>=R;--H)if(l(o.charCodeAt(H))){if(!B){E=H;break}}else B=!1;if(E===-1){if(z===-1)return".";E=z}return o.slice(0,E)},basename(o,N){N!==void 0&&e(N,"ext"),e(o,"path");let z=0,R=-1,d=!0,E;if(o.length>=2&&n(o.charCodeAt(0))&&o.charCodeAt(1)===f&&(z=2),N!==void 0&&N.length>0&&N.length<=o.length){if(N===o)return"";let B=N.length-1,H=-1;for(E=o.length-1;E>=z;--E){const x=o.charCodeAt(E);if(l(x)){if(!d){z=E+1;break}}else H===-1&&(d=!1,H=E+1),B>=0&&(x===N.charCodeAt(B)?--B===-1&&(R=E):(B=-1,R=H))}return z===R?R=H:R===-1&&(R=o.length),o.slice(z,R)}for(E=o.length-1;E>=z;--E)if(l(o.charCodeAt(E))){if(!d){z=E+1;break}}else R===-1&&(d=!1,R=E+1);return R===-1?"":o.slice(z,R)},extname(o){e(o,"path");let N=0,z=-1,R=0,d=-1,E=!0,B=0;o.length>=2&&o.charCodeAt(1)===f&&n(o.charCodeAt(0))&&(N=R=2);for(let H=o.length-1;H>=N;--H){const x=o.charCodeAt(H);if(l(x)){if(!E){R=H+1;break}continue}d===-1&&(E=!1,d=H+1),x===A?z===-1?z=H:B!==1&&(B=1):z!==-1&&(B=-1)}return z===-1||d===-1||B===0||B===1&&z===d-1&&z===R+1?"":o.slice(z,d)},format:b.bind(null,"\\"),parse(o){e(o,"path");const N={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return N;const z=o.length;let R=0,d=o.charCodeAt(0);if(z===1)return l(d)?(N.root=N.dir=o,N):(N.base=N.name=o,N);if(l(d)){if(R=1,l(o.charCodeAt(1))){let Q=2,te=Q;for(;Q<z&&!l(o.charCodeAt(Q));)Q++;if(Q<z&&Q!==te){for(te=Q;Q<z&&l(o.charCodeAt(Q));)Q++;if(Q<z&&Q!==te){for(te=Q;Q<z&&!l(o.charCodeAt(Q));)Q++;Q===z?R=Q:Q!==te&&(R=Q+1)}}}}else if(n(d)&&o.charCodeAt(1)===f){if(z<=2)return N.root=N.dir=o,N;if(R=2,l(o.charCodeAt(2))){if(z===3)return N.root=N.dir=o,N;R=3}}R>0&&(N.root=o.slice(0,R));let E=-1,B=R,H=-1,x=!0,C=o.length-1,F=0;for(;C>=R;--C){if(d=o.charCodeAt(C),l(d)){if(!x){B=C+1;break}continue}H===-1&&(x=!1,H=C+1),d===A?E===-1?E=C:F!==1&&(F=1):E!==-1&&(F=-1)}return H!==-1&&(E===-1||F===0||F===1&&E===H-1&&E===B+1?N.base=N.name=o.slice(B,H):(N.name=o.slice(B,E),N.base=o.slice(B,H),N.ext=o.slice(E,H))),B>0&&B!==R?N.dir=o.slice(0,B-1):N.dir=N.root,N},sep:"\\",delimiter:";",win32:null,posix:null};const u=(()=>{if(h){const o=/\\/g;return()=>{const N=y.cwd().replace(o,"/");return N.slice(N.indexOf("/"))}}return()=>y.cwd()})();t.$fc={resolve(...o){let N="",z=!1;for(let R=o.length-1;R>=-1&&!z;R--){const d=R>=0?o[R]:u();e(d,"path"),d.length!==0&&(N=`${d}/${N}`,z=d.charCodeAt(0)===c)}return N=r(N,!z,"/",m),z?`/${N}`:N.length>0?N:"."},normalize(o){if(e(o,"path"),o.length===0)return".";const N=o.charCodeAt(0)===c,z=o.charCodeAt(o.length-1)===c;return o=r(o,!N,"/",m),o.length===0?N?"/":z?"./":".":(z&&(o+="/"),N?`/${o}`:o)},isAbsolute(o){return e(o,"path"),o.length>0&&o.charCodeAt(0)===c},join(...o){if(o.length===0)return".";let N;for(let z=0;z<o.length;++z){const R=o[z];e(R,"path"),R.length>0&&(N===void 0?N=R:N+=`/${R}`)}return N===void 0?".":t.$fc.normalize(N)},relative(o,N){if(e(o,"from"),e(N,"to"),o===N||(o=t.$fc.resolve(o),N=t.$fc.resolve(N),o===N))return"";const z=1,R=o.length,d=R-z,E=1,B=N.length-E,H=d<B?d:B;let x=-1,C=0;for(;C<H;C++){const Q=o.charCodeAt(z+C);if(Q!==N.charCodeAt(E+C))break;Q===c&&(x=C)}if(C===H)if(B>H){if(N.charCodeAt(E+C)===c)return N.slice(E+C+1);if(C===0)return N.slice(E+C)}else d>H&&(o.charCodeAt(z+C)===c?x=C:C===0&&(x=0));let F="";for(C=z+x+1;C<=R;++C)(C===R||o.charCodeAt(C)===c)&&(F+=F.length===0?"..":"/..");return`${F}${N.slice(E+x)}`},toNamespacedPath(o){return o},dirname(o){if(e(o,"path"),o.length===0)return".";const N=o.charCodeAt(0)===c;let z=-1,R=!0;for(let d=o.length-1;d>=1;--d)if(o.charCodeAt(d)===c){if(!R){z=d;break}}else R=!1;return z===-1?N?"/":".":N&&z===1?"//":o.slice(0,z)},basename(o,N){N!==void 0&&e(N,"ext"),e(o,"path");let z=0,R=-1,d=!0,E;if(N!==void 0&&N.length>0&&N.length<=o.length){if(N===o)return"";let B=N.length-1,H=-1;for(E=o.length-1;E>=0;--E){const x=o.charCodeAt(E);if(x===c){if(!d){z=E+1;break}}else H===-1&&(d=!1,H=E+1),B>=0&&(x===N.charCodeAt(B)?--B===-1&&(R=E):(B=-1,R=H))}return z===R?R=H:R===-1&&(R=o.length),o.slice(z,R)}for(E=o.length-1;E>=0;--E)if(o.charCodeAt(E)===c){if(!d){z=E+1;break}}else R===-1&&(d=!1,R=E+1);return R===-1?"":o.slice(z,R)},extname(o){e(o,"path");let N=-1,z=0,R=-1,d=!0,E=0;for(let B=o.length-1;B>=0;--B){const H=o.charCodeAt(B);if(H===c){if(!d){z=B+1;break}continue}R===-1&&(d=!1,R=B+1),H===A?N===-1?N=B:E!==1&&(E=1):N!==-1&&(E=-1)}return N===-1||R===-1||E===0||E===1&&N===R-1&&N===z+1?"":o.slice(N,R)},format:b.bind(null,"/"),parse(o){e(o,"path");const N={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return N;const z=o.charCodeAt(0)===c;let R;z?(N.root="/",R=1):R=0;let d=-1,E=0,B=-1,H=!0,x=o.length-1,C=0;for(;x>=R;--x){const F=o.charCodeAt(x);if(F===c){if(!H){E=x+1;break}continue}B===-1&&(H=!1,B=x+1),F===A?d===-1?d=x:C!==1&&(C=1):d!==-1&&(C=-1)}if(B!==-1){const F=E===0&&z?1:E;d===-1||C===0||C===1&&d===B-1&&d===E+1?N.base=N.name=o.slice(F,B):(N.name=o.slice(F,d),N.base=o.slice(F,B),N.ext=o.slice(d,B))}return E>0?N.dir=o.slice(0,E-1):z&&(N.dir="/"),N},sep:"/",delimiter:":",win32:null,posix:null},t.$fc.win32=t.$ec.win32=t.$ec,t.$fc.posix=t.$ec.posix=t.$fc,t.$gc=h?t.$ec.normalize:t.$fc.normalize,t.$hc=h?t.$ec.isAbsolute:t.$fc.isAbsolute,t.$ic=h?t.$ec.join:t.$fc.join,t.$jc=h?t.$ec.resolve:t.$fc.resolve,t.$kc=h?t.$ec.relative:t.$fc.relative,t.$lc=h?t.$ec.dirname:t.$fc.dirname,t.$mc=h?t.$ec.basename:t.$fc.basename,t.$nc=h?t.$ec.extname:t.$fc.extname,t.$oc=h?t.$ec.format:t.$fc.format,t.$pc=h?t.$ec.parse:t.$fc.parse,t.$qc=h?t.$ec.toNamespacedPath:t.$fc.toNamespacedPath,t.sep=h?t.$ec.sep:t.$fc.sep,t.$sc=h?t.$ec.delimiter:t.$fc.delimiter}),define($e[114],we([1,0,23,5,12,7]),function(le,t,y,L,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7f=t.$6f=t.$5f=t.$4f=t.$3f=t.$2f=t.$1f=t.$Zf=t.$Yf=t.$Xf=t.$Wf=t.$Vf=t.$Uf=t.$Tf=t.$Sf=t.$Rf=void 0;function D(E){return E===47||E===92}t.$Rf=D;function A(E){return E.replace(/[\\/]/g,y.$fc.sep)}t.$Sf=A;function c(E){return E.indexOf("/")===-1&&(E=A(E)),/^[a-zA-Z]:(\/|$)/.test(E)&&(E="/"+E),E}t.$Tf=c;function g(E,B=y.$fc.sep){if(!E)return"";const H=E.length,x=E.charCodeAt(0);if(D(x)){if(D(E.charCodeAt(1))&&!D(E.charCodeAt(2))){let F=3;const Q=F;for(;F<H&&!D(E.charCodeAt(F));F++);if(Q!==F&&!D(E.charCodeAt(F+1))){for(F+=1;F<H;F++)if(D(E.charCodeAt(F)))return E.slice(0,F+1).replace(/[\\/]/g,B)}}return B}else if(m(x)&&E.charCodeAt(1)===58)return D(E.charCodeAt(2))?E.slice(0,2)+B:E.slice(0,2);let C=E.indexOf("://");if(C!==-1){for(C+=3;C<H;C++)if(D(E.charCodeAt(C)))return E.slice(0,C+1)}return""}t.$Uf=g;function f(E){if(!L.$j||!E||E.length<5)return!1;let B=E.charCodeAt(0);if(B!==92||(B=E.charCodeAt(1),B!==92))return!1;let H=2;const x=H;for(;H<E.length&&(B=E.charCodeAt(H),B!==92);H++);return!(x===H||(B=E.charCodeAt(H+1),isNaN(B)||B===92))}t.$Vf=f;const T=/[\\/:\*\?"<>\|]/g,s=/[\\/]/g,a=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(E,B=L.$j){const H=B?T:s;return!(!E||E.length===0||/^\s+$/.test(E)||(H.lastIndex=0,H.test(E))||B&&a.test(E)||E==="."||E===".."||B&&E[E.length-1]==="."||B&&E.length!==E.trim().length||E.length>255)}t.$Wf=e;function h(E,B,H){const x=E===B;return!H||x?x:!E||!B?!1:(0,i.$3e)(E,B)}t.$Xf=h;function l(E,B,H,x=y.sep){if(E===B)return!0;if(!E||!B||B.length>E.length)return!1;if(H){if(!(0,i.$4e)(E,B))return!1;if(B.length===E.length)return!0;let F=B.length;return B.charAt(B.length-1)===x&&F--,E.charAt(F)===x}return B.charAt(B.length-1)!==x&&(B+=x),E.indexOf(B)===0}t.$Yf=l;function m(E){return E>=65&&E<=90||E>=97&&E<=122}t.$Zf=m;function n(E,B){return L.$j&&E.endsWith(":")&&(E+=y.sep),(0,y.$hc)(E)||(E=(0,y.$ic)(B,E)),E=(0,y.$gc)(E),L.$j?(E=(0,i.$Le)(E,y.sep),E.endsWith(":")&&(E+=y.sep)):(E=(0,i.$Le)(E,y.sep),E||(E=y.sep)),E}t.$1f=n;function r(E){const B=(0,y.$gc)(E);return L.$j?E.length>3?!1:b(B)&&(E.length===2||B.charCodeAt(2)===92):B===y.$fc.sep}t.$2f=r;function b(E,B=L.$j){return B?m(E.charCodeAt(0))&&E.charCodeAt(1)===58:!1}t.$3f=b;function u(E,B=L.$j){return b(E,B)?E[0]:void 0}t.$4f=u;function o(E,B,H){return B.length>E.length?-1:E===B?0:(H&&(E=E.toLowerCase(),B=B.toLowerCase()),E.indexOf(B))}t.$5f=o;function N(E){const B=E.split(":");let H,x,C;for(const F of B){const Q=Number(F);(0,U.$Df)(Q)?x===void 0?x=Q:C===void 0&&(C=Q):H=H?[H,F].join(":"):F}if(!H)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:H,line:x!==void 0?x:void 0,column:C!==void 0?C:x!==void 0?1:void 0}}t.$6f=N;const z="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",R="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function d(E,B,H=8){let x="";for(let F=0;F<H;F++){let Q;F===0&&L.$j&&!B&&(H===3||H===4)?Q=R:Q=z,x+=Q.charAt(Math.floor(Math.random()*Q.length))}let C;return B?C=`${B}-${x}`:C=x,E?(0,y.$ic)(E,C):C}t.$7f=d}),define($e[115],we([1,0,23]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Xr=t.$Wr=t.$Vr=t.$Ur=t.$Tr=void 0,t.$Tr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const L={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},i={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function U(f){const T=(0,y.$nc)(f),s=L[T.toLowerCase()];return s!==void 0?s:D(f)}t.$Ur=U;function D(f){const T=(0,y.$nc)(f);return i[T.toLowerCase()]}t.$Vr=D;function A(f){for(const T in i)if(i[T]===f)return T}t.$Wr=A;const c=/^(.+)\/(.+?)(;.+)?$/;function g(f,T){const s=c.exec(f);return s?`${s[1].toLowerCase()}/${s[2].toLowerCase()}${s[3]??""}`:T?void 0:f}t.$Xr=g}),define($e[16],we([1,0,23,5]),function(le,t,y,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vc=t.$uc=t.URI=void 0;const i=/^\w[\w\d+.-]*$/,U=/^\//,D=/^\/\//;function A(R,d){if(!R.scheme&&d)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${R.authority}", path: "${R.path}", query: "${R.query}", fragment: "${R.fragment}"}`);if(R.scheme&&!i.test(R.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(R.path){if(R.authority){if(!U.test(R.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(R.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function c(R,d){return!R&&!d?"file":R}function g(R,d){switch(R){case"https":case"http":case"file":d?d[0]!==T&&(d=T+d):d=T;break}return d}const f="",T="/",s=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class a{static isUri(d){return d instanceof a?!0:d?typeof d.authority=="string"&&typeof d.fragment=="string"&&typeof d.path=="string"&&typeof d.query=="string"&&typeof d.scheme=="string"&&typeof d.fsPath=="string"&&typeof d.with=="function"&&typeof d.toString=="function":!1}constructor(d,E,B,H,x,C=!1){typeof d=="object"?(this.scheme=d.scheme||f,this.authority=d.authority||f,this.path=d.path||f,this.query=d.query||f,this.fragment=d.fragment||f):(this.scheme=c(d,C),this.authority=E||f,this.path=g(this.scheme,B||f),this.query=H||f,this.fragment=x||f,A(this,C))}get fsPath(){return b(this,!1)}with(d){if(!d)return this;let{scheme:E,authority:B,path:H,query:x,fragment:C}=d;return E===void 0?E=this.scheme:E===null&&(E=f),B===void 0?B=this.authority:B===null&&(B=f),H===void 0?H=this.path:H===null&&(H=f),x===void 0?x=this.query:x===null&&(x=f),C===void 0?C=this.fragment:C===null&&(C=f),E===this.scheme&&B===this.authority&&H===this.path&&x===this.query&&C===this.fragment?this:new l(E,B,H,x,C)}static parse(d,E=!1){const B=s.exec(d);return B?new l(B[2]||f,z(B[4]||f),z(B[5]||f),z(B[7]||f),z(B[9]||f),E):new l(f,f,f,f,f)}static file(d){let E=f;if(L.$j&&(d=d.replace(/\\/g,T)),d[0]===T&&d[1]===T){const B=d.indexOf(T,2);B===-1?(E=d.substring(2),d=T):(E=d.substring(2,B),d=d.substring(B)||T)}return new l("file",E,d,f,f)}static from(d,E){return new l(d.scheme,d.authority,d.path,d.query,d.fragment,E)}static joinPath(d,...E){if(!d.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let B;return L.$j&&d.scheme==="file"?B=a.file(y.$ec.join(b(d,!0),...E)).path:B=y.$fc.join(d.path,...E),d.with({path:B})}toString(d=!1){return u(this,d)}toJSON(){return this}static revive(d){if(d){if(d instanceof a)return d;{const E=new l(d);return E._formatted=d.external??null,E._fsPath=d._sep===h?d.fsPath??null:null,E}}else return d}}t.URI=a;function e(R){return!R||typeof R!="object"?!1:typeof R.scheme=="string"&&(typeof R.authority=="string"||typeof R.authority>"u")&&(typeof R.path=="string"||typeof R.path>"u")&&(typeof R.query=="string"||typeof R.query>"u")&&(typeof R.fragment=="string"||typeof R.fragment>"u")}t.$uc=e;const h=L.$j?1:void 0;class l extends a{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=b(this,!1)),this._fsPath}toString(d=!1){return d?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const d={$mid:1};return this._fsPath&&(d.fsPath=this._fsPath,d._sep=h),this._formatted&&(d.external=this._formatted),this.path&&(d.path=this.path),this.scheme&&(d.scheme=this.scheme),this.authority&&(d.authority=this.authority),this.query&&(d.query=this.query),this.fragment&&(d.fragment=this.fragment),d}}const m={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function n(R,d,E){let B,H=-1;for(let x=0;x<R.length;x++){const C=R.charCodeAt(x);if(C>=97&&C<=122||C>=65&&C<=90||C>=48&&C<=57||C===45||C===46||C===95||C===126||d&&C===47||E&&C===91||E&&C===93||E&&C===58)H!==-1&&(B+=encodeURIComponent(R.substring(H,x)),H=-1),B!==void 0&&(B+=R.charAt(x));else{B===void 0&&(B=R.substr(0,x));const F=m[C];F!==void 0?(H!==-1&&(B+=encodeURIComponent(R.substring(H,x)),H=-1),B+=F):H===-1&&(H=x)}}return H!==-1&&(B+=encodeURIComponent(R.substring(H))),B!==void 0?B:R}function r(R){let d;for(let E=0;E<R.length;E++){const B=R.charCodeAt(E);B===35||B===63?(d===void 0&&(d=R.substr(0,E)),d+=m[B]):d!==void 0&&(d+=R[E])}return d!==void 0?d:R}function b(R,d){let E;return R.authority&&R.path.length>1&&R.scheme==="file"?E=`//${R.authority}${R.path}`:R.path.charCodeAt(0)===47&&(R.path.charCodeAt(1)>=65&&R.path.charCodeAt(1)<=90||R.path.charCodeAt(1)>=97&&R.path.charCodeAt(1)<=122)&&R.path.charCodeAt(2)===58?d?E=R.path.substr(1):E=R.path[1].toLowerCase()+R.path.substr(2):E=R.path,L.$j&&(E=E.replace(/\//g,"\\")),E}t.$vc=b;function u(R,d){const E=d?r:n;let B="",{scheme:H,authority:x,path:C,query:F,fragment:Q}=R;if(H&&(B+=H,B+=":"),(x||H==="file")&&(B+=T,B+=T),x){let te=x.indexOf("@");if(te!==-1){const re=x.substr(0,te);x=x.substr(te+1),te=re.lastIndexOf(":"),te===-1?B+=E(re,!1,!1):(B+=E(re.substr(0,te),!1,!1),B+=":",B+=E(re.substr(te+1),!1,!0)),B+="@"}x=x.toLowerCase(),te=x.lastIndexOf(":"),te===-1?B+=E(x,!1,!0):(B+=E(x.substr(0,te),!1,!0),B+=x.substr(te))}if(C){if(C.length>=3&&C.charCodeAt(0)===47&&C.charCodeAt(2)===58){const te=C.charCodeAt(1);te>=65&&te<=90&&(C=`/${String.fromCharCode(te+32)}:${C.substr(3)}`)}else if(C.length>=2&&C.charCodeAt(1)===58){const te=C.charCodeAt(0);te>=65&&te<=90&&(C=`${String.fromCharCode(te+32)}:${C.substr(2)}`)}B+=E(C,!0,!1)}return F&&(B+="?",B+=E(F,!1,!1)),Q&&(B+="#",B+=d?Q:n(Q,!1,!1)),B}function o(R){try{return decodeURIComponent(R)}catch{return R.length>3?R.substr(0,3)+o(R.substr(3)):R}}const N=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function z(R){return R.match(N)?R.replace(N,d=>o(d)):R}}),define($e[53],we([1,0,33,16]),function(le,t,y,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qh=t.$ph=t.$oh=void 0;function i(c){return JSON.stringify(c,D)}t.$oh=i;function U(c){let g=JSON.parse(c);return g=A(g),g}t.$ph=U;function D(c,g){return g instanceof RegExp?{$mid:2,source:g.source,flags:g.flags}:g}function A(c,g=0){if(!c||g>200)return c;if(typeof c=="object"){switch(c.$mid){case 1:return L.URI.revive(c);case 2:return new RegExp(c.source,c.flags);case 17:return new Date(c.source)}if(c instanceof y.$ce||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let f=0;f<c.length;++f)c[f]=A(c[f],g+1);else for(const f in c)Object.hasOwnProperty.call(c,f)&&(c[f]=A(c[f],g+1))}return c}t.$qh=A}),define($e[30],we([1,0,6,5,16]),function(le,t,y,L,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.$dg=t.$cg=t.$bg=t.$ag=t.$_f=t.$$f=t.$0f=t.$9f=t.$8f=t.Schemas=void 0;var U;(function(g){g.inMemory="inmemory",g.vscode="vscode",g.internal="private",g.walkThrough="walkThrough",g.walkThroughSnippet="walkThroughSnippet",g.http="http",g.https="https",g.file="file",g.mailto="mailto",g.untitled="untitled",g.data="data",g.command="command",g.vscodeRemote="vscode-remote",g.vscodeRemoteResource="vscode-remote-resource",g.vscodeManagedRemoteResource="vscode-managed-remote-resource",g.vscodeUserData="vscode-userdata",g.vscodeCustomEditor="vscode-custom-editor",g.vscodeNotebookCell="vscode-notebook-cell",g.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",g.vscodeNotebookCellOutput="vscode-notebook-cell-output",g.vscodeInteractiveInput="vscode-interactive-input",g.vscodeSettings="vscode-settings",g.vscodeWorkspaceTrust="vscode-workspace-trust",g.vscodeTerminal="vscode-terminal",g.vscodeChatSesssion="vscode-chat-editor",g.webviewPanel="webview-panel",g.vscodeWebview="vscode-webview",g.extension="extension",g.vscodeFileResource="vscode-file",g.tmp="tmp",g.vsls="vsls",g.vscodeSourceControl="vscode-scm"})(U||(t.Schemas=U={})),t.$8f="vscode-tkn",t.$9f="tkn";class D{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${U.vscodeRemoteResource}`}setPreferredWebSchema(f){this.d=f}setDelegate(f){this.e=f}setServerRootPath(f){this.f=`${f}/${U.vscodeRemoteResource}`}set(f,T,s){this.a[f]=T,this.b[f]=s}setConnectionToken(f,T){this.c[f]=T}getPreferredWebSchema(){return this.d}rewrite(f){if(this.e)try{return this.e(f)}catch(l){return y.$Z(l),f}const T=f.authority;let s=this.a[T];s&&s.indexOf(":")!==-1&&s.indexOf("[")===-1&&(s=`[${s}]`);const a=this.b[T],e=this.c[T];let h=`path=${encodeURIComponent(f.path)}`;return typeof e=="string"&&(h+=`&${t.$9f}=${encodeURIComponent(e)}`),i.URI.from({scheme:L.$p?this.d:U.vscodeRemoteResource,authority:`${s}:${a}`,path:this.f,query:h})}}t.$0f=new D,t.$$f="vs/../../extensions",t.$_f="vs/../../node_modules",t.$ag="vs/../../node_modules.asar",t.$bg="vs/../../node_modules.asar.unpacked",t.$cg="vscode-app";class A{static{this.a=t.$cg}asBrowserUri(f){const T=this.b(f,le);return this.uriToBrowserUri(T)}uriToBrowserUri(f){return f.scheme===U.vscodeRemote?t.$0f.rewrite(f):f.scheme===U.file&&(L.$n||L.$q&&L.$h.origin===`${U.vscodeFileResource}://${A.a}`)?f.with({scheme:U.vscodeFileResource,authority:f.authority||A.a,query:null,fragment:null}):f}asFileUri(f){const T=this.b(f,le);return this.uriToFileUri(T)}uriToFileUri(f){return f.scheme===U.vscodeFileResource?f.with({scheme:U.file,authority:f.authority!==A.a?f.authority:null,query:null,fragment:null}):f}b(f,T){return i.URI.isUri(f)?f:i.URI.parse(T.toUrl(f))}}t.$dg=new A;var c;(function(g){const f=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);g.CoopAndCoep=Object.freeze(f.get("3"));const T="vscode-coi";function s(e){let h;typeof e=="string"?h=new URL(e).searchParams:e instanceof URL?h=e.searchParams:i.URI.isUri(e)&&(h=new URL(e.toString(!0)).searchParams);const l=h?.get(T);if(l)return f.get(l)}g.getHeadersFromQuery=s;function a(e,h,l){if(!globalThis.crossOriginIsolated)return;const m=h&&l?"3":l?"2":"1";e instanceof URLSearchParams?e.set(T,m):e[T]=m}g.addSearchParam=a})(c||(t.COI=c={}))}),define($e[37],we([1,0,114,30,23,5,12,16]),function(le,t,y,L,i,U,D,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Gg=t.DataUri=t.$Fg=t.$Eg=t.$Dg=t.$Cg=t.$Bg=t.$Ag=t.$zg=t.$yg=t.$xg=t.$wg=t.$vg=t.$ug=t.$tg=t.$sg=t.$rg=t.$qg=t.$pg=t.$og=t.$ng=t.$mg=t.$lg=t.$kg=void 0;function c(a){return(0,A.$vc)(a,!0)}t.$kg=c;class g{constructor(e){this.a=e}compare(e,h,l=!1){return e===h?0:(0,D.$Ve)(this.getComparisonKey(e,l),this.getComparisonKey(h,l))}isEqual(e,h,l=!1){return e===h?!0:!e||!h?!1:this.getComparisonKey(e,l)===this.getComparisonKey(h,l)}getComparisonKey(e,h=!1){return e.with({path:this.a(e)?e.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(e){return this.a(e)}isEqualOrParent(e,h,l=!1){if(e.scheme===h.scheme){if(e.scheme===L.Schemas.file)return y.$Yf(c(e),c(h),this.a(e))&&e.query===h.query&&(l||e.fragment===h.fragment);if((0,t.$Bg)(e.authority,h.authority))return y.$Yf(e.path,h.path,this.a(e),"/")&&e.query===h.query&&(l||e.fragment===h.fragment)}return!1}joinPath(e,...h){return A.URI.joinPath(e,...h)}basenameOrAuthority(e){return(0,t.$tg)(e)||e.authority}basename(e){return i.$fc.basename(e.path)}extname(e){return i.$fc.extname(e.path)}dirname(e){if(e.path.length===0)return e;let h;return e.scheme===L.Schemas.file?h=A.URI.file(i.$lc(c(e))).path:(h=i.$fc.dirname(e.path),e.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),h="/")),e.with({path:h})}normalizePath(e){if(!e.path.length)return e;let h;return e.scheme===L.Schemas.file?h=A.URI.file(i.$gc(c(e))).path:h=i.$fc.normalize(e.path),e.with({path:h})}relativePath(e,h){if(e.scheme!==h.scheme||!(0,t.$Bg)(e.authority,h.authority))return;if(e.scheme===L.Schemas.file){const n=i.$kc(c(e),c(h));return U.$j?y.$Sf(n):n}let l=e.path||"/";const m=h.path||"/";if(this.a(e)){let n=0;for(const r=Math.min(l.length,m.length);n<r&&!(l.charCodeAt(n)!==m.charCodeAt(n)&&l.charAt(n).toLowerCase()!==m.charAt(n).toLowerCase());n++);l=m.substr(0,n)+l.substr(n)}return i.$fc.relative(l,m)}resolvePath(e,h){if(e.scheme===L.Schemas.file){const l=A.URI.file(i.$jc(c(e),h));return e.with({authority:l.authority,path:l.path})}return h=y.$Tf(h),e.with({path:i.$fc.resolve(e.path,h)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,h){return e===h||e!==void 0&&h!==void 0&&(0,D.$3e)(e,h)}hasTrailingPathSeparator(e,h=i.sep){if(e.scheme===L.Schemas.file){const l=c(e);return l.length>y.$Uf(l).length&&l[l.length-1]===h}else{const l=e.path;return l.length>1&&l.charCodeAt(l.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,h=i.sep){return(0,t.$Cg)(e,h)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,h=i.sep){let l=!1;if(e.scheme===L.Schemas.file){const m=c(e);l=m!==void 0&&m.length===y.$Uf(m).length&&m[m.length-1]===h}else{h="/";const m=e.path;l=m.length===1&&m.charCodeAt(m.length-1)===47}return!l&&!(0,t.$Cg)(e,h)?e.with({path:e.path+"/"}):e}}t.$lg=g,t.$mg=new g(()=>!1),t.$ng=new g(a=>a.scheme===L.Schemas.file?!U.$l:!0),t.$og=new g(a=>!0),t.$pg=t.$mg.isEqual.bind(t.$mg),t.$qg=t.$mg.isEqualOrParent.bind(t.$mg),t.$rg=t.$mg.getComparisonKey.bind(t.$mg),t.$sg=t.$mg.basenameOrAuthority.bind(t.$mg),t.$tg=t.$mg.basename.bind(t.$mg),t.$ug=t.$mg.extname.bind(t.$mg),t.$vg=t.$mg.dirname.bind(t.$mg),t.$wg=t.$mg.joinPath.bind(t.$mg),t.$xg=t.$mg.normalizePath.bind(t.$mg),t.$yg=t.$mg.relativePath.bind(t.$mg),t.$zg=t.$mg.resolvePath.bind(t.$mg),t.$Ag=t.$mg.isAbsolutePath.bind(t.$mg),t.$Bg=t.$mg.isEqualAuthority.bind(t.$mg),t.$Cg=t.$mg.hasTrailingPathSeparator.bind(t.$mg),t.$Dg=t.$mg.removeTrailingPathSeparator.bind(t.$mg),t.$Eg=t.$mg.addTrailingPathSeparator.bind(t.$mg);function f(a,e){const h=[];for(let l=0;l<a.length;l++){const m=e(a[l]);a.some((n,r)=>r===l?!1:(0,t.$qg)(m,e(n)))||h.push(a[l])}return h}t.$Fg=f;var T;(function(a){a.META_DATA_LABEL="label",a.META_DATA_DESCRIPTION="description",a.META_DATA_SIZE="size",a.META_DATA_MIME="mime";function e(h){const l=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(r=>{const[b,u]=r.split(":");b&&u&&l.set(b,u)});const n=h.path.substring(0,h.path.indexOf(";"));return n&&l.set(a.META_DATA_MIME,n),l}a.parseMetaData=e})(T||(t.DataUri=T={}));function s(a,e,h){if(e){let l=a.path;return l&&l[0]!==i.$fc.sep&&(l=i.$fc.sep+l),a.with({scheme:h,authority:e,path:l})}return a.with({scheme:h})}t.$Gg=s}),define($e[9],we([1,0,29,6,4,2,37,5,50]),function(le,t,y,L,i,U,D,A,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kh=t.$jh=t.$ih=t.$hh=t.Promises=t.$gh=t.$fh=t.$eh=t.$dh=t.$ch=t.$bh=t.$ah=t.$_g=t.$$g=t.$0g=t.$9g=t.$8g=t.$7g=t.$6g=t.$5g=t.$4g=t.$3g=t.$2g=t.$1g=t.$Zg=t.$Yg=t.$Xg=t.$Wg=t.$Vg=t.$Ug=t.$Tg=t.$Sg=t.$Rg=t.$Qg=t.$Pg=t.$Og=t.$Ng=t.$Mg=t.$Lg=t.$Kg=t.$Jg=t.$Ig=t.$Hg=void 0;function g(M){return!!M&&typeof M.then=="function"}t.$Hg=g;function f(M){const $=new y.$Yd,w=M($.token),I=new Promise((v,O)=>{const k=$.token.onCancellationRequested(()=>{k.dispose(),$.dispose(),O(new L.$4)});Promise.resolve(w).then(S=>{k.dispose(),$.dispose(),v(S)},S=>{k.dispose(),$.dispose(),O(S)})});return new class{cancel(){$.cancel()}then(v,O){return I.then(v,O)}catch(v){return this.then(void 0,v)}finally(v){return I.finally(v)}}}t.$Ig=f;function T(M,$,w){return new Promise((I,v)=>{const O=$.onCancellationRequested(()=>{O.dispose(),I(w)});M.then(I,v).finally(()=>O.dispose())})}t.$Jg=T;function s(M,$){return new Promise((w,I)=>{const v=$.onCancellationRequested(()=>{v.dispose(),I(new L.$4)});M.then(w,I).finally(()=>v.dispose())})}t.$Kg=s;async function a(M){let $=-1;const w=M.map((I,v)=>I.then(O=>($=v,O)));try{return await Promise.race(w)}finally{M.forEach((I,v)=>{v!==$&&I.cancel()})}}t.$Lg=a;function e(M,$,w){let I;const v=setTimeout(()=>{I?.(void 0),w?.()},$);return Promise.race([M.finally(()=>clearTimeout(v)),new Promise(O=>I=O)])}t.$Mg=e;function h(M){return new Promise(($,w)=>{const I=M();g(I)?I.then($,w):$(I)})}t.$Ng=h;class l{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue($){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=$,!this.b){const w=()=>{if(this.b=null,this.f)return;const I=this.queue(this.d);return this.d=null,I};this.b=new Promise(I=>{this.a.then(w,w).then(I)})}return new Promise((w,I)=>{this.b.then(w,I)})}return this.a=$(),new Promise((w,I)=>{this.a.then(v=>{this.a=null,w(v)},v=>{this.a=null,I(v)})})}dispose(){this.f=!0}}t.$Og=l;class m{constructor(){this.a=Promise.resolve(null)}queue($){return this.a=this.a.then(()=>$(),()=>$())}}t.$Pg=m;class n{constructor(){this.a=new Map}queue($,w){const v=(this.a.get($)??Promise.resolve()).catch(()=>{}).then(w).finally(()=>{this.a.get($)===v&&this.a.delete($)});return this.a.set($,v),v}}t.$Qg=n;const r=(M,$)=>{let w=!0;const I=setTimeout(()=>{w=!1,$()},M);return{isTriggered:()=>w,dispose:()=>{clearTimeout(I),w=!1}}},b=M=>{let $=!0;return queueMicrotask(()=>{$&&($=!1,M())}),{isTriggered:()=>$,dispose:()=>{$=!1}}};class u{constructor($){this.defaultDelay=$,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger($,w=this.defaultDelay){this.g=$,this.h(),this.b||(this.b=new Promise((v,O)=>{this.d=v,this.f=O}).then(()=>{if(this.b=null,this.d=null,this.g){const v=this.g;return this.g=null,v()}}));const I=()=>{this.a=null,this.d?.(null)};return this.a=w===c.$Ld?b(I):r(w,I),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new L.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}t.$Rg=u;class o{constructor($){this.a=new u($),this.b=new l}trigger($,w){return this.a.trigger(()=>this.b.queue($),w)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}t.$Sg=o;class N{constructor(){this.a=!1,this.b=new Promise(($,w)=>{this.d=$})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}t.$Tg=N;class z extends N{constructor($){super(),this.f=setTimeout(()=>this.open(),$)}open(){clearTimeout(this.f),super.open()}}t.$Ug=z;function R(M,$){return $?new Promise((w,I)=>{const v=setTimeout(()=>{O.dispose(),w()},M),O=$.onCancellationRequested(()=>{clearTimeout(v),O.dispose(),I(new L.$4)})}):f(w=>R(M,w))}t.$Vg=R;function d(M,$=0,w){const I=setTimeout(()=>{M(),w&&v.dispose()},$),v=(0,U.$Pc)(()=>{clearTimeout(I),w?.deleteAndLeak(v)});return w?.add(v),v}t.$Wg=d;function E(M,$,w){let I=0;const v=setInterval(()=>{I++,(I>=w||M())&&O.dispose()},$),O=(0,U.$Pc)(()=>{clearInterval(v)});return O}t.$Xg=E;function B(M){const $=[];let w=0;const I=M.length;function v(){return w<I?M[w++]():null}function O(k){k!=null&&$.push(k);const S=v();return S?S.then(O):Promise.resolve($)}return Promise.resolve(null).then(O)}t.$Yg=B;function H(M,$=I=>!!I,w=null){let I=0;const v=M.length,O=()=>{if(I>=v)return Promise.resolve(w);const k=M[I++];return Promise.resolve(k()).then(j=>$(j)?Promise.resolve(j):O())};return O()}t.$Zg=H;function x(M,$=I=>!!I,w=null){if(M.length===0)return Promise.resolve(w);let I=M.length;const v=()=>{I=-1;for(const O of M)O.cancel?.()};return new Promise((O,k)=>{for(const S of M)S.then(j=>{--I>=0&&$(j)?(v(),O(j)):I===0&&O(w)}).catch(j=>{--I>=0&&(v(),k(j))})})}t.$1g=x;class C{constructor($){this.a=0,this.d=$,this.f=[],this.b=0,this.g=new i.$Od}get onDrained(){return this.g.event}get size(){return this.a}queue($){return this.a++,new Promise((w,I)=>{this.f.push({factory:$,c:w,e:I}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const $=this.f.shift();this.b++;const w=$.factory();w.then($.c,$.e),w.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}t.$2g=C;class F extends C{constructor(){super(1)}}t.$3g=F;class Q{constructor(){this.a=new ne,this.b=0}queue($){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,$())):this.a.run(this.b++,$())}}t.$4g=Q;class te{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const $=new q;return this.b.add($),$.p}g(){for(const[,$]of this.a)if($.size>0)return!1;return!0}queueFor($,w=D.$mg){const I=w.getComparisonKey($);let v=this.a.get(I);if(!v){v=new F;const O=this.f++,k=i.Event.once(v.onDrained)(()=>{v?.dispose(),this.a.delete(I),this.h(),this.d?.deleteAndDispose(O),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new U.$Zc),this.d.set(O,k),this.a.set(I,v)}return v}h(){this.g()&&this.j()}j(){for(const $ of this.b)$.complete();this.b.clear()}dispose(){for(const[,$]of this.a)$.dispose();this.a.clear(),this.j(),this.d?.dispose()}}t.$5g=te;class re{constructor($,w){this.a=-1,typeof $=="function"&&typeof w=="number"&&this.setIfNotSet($,w)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet($,w){this.cancel(),this.a=setTimeout(()=>{this.a=-1,$()},w)}setIfNotSet($,w){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,$()},w))}}t.$6g=re;class fe{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet($,w){this.cancel(),this.a=setInterval(()=>{$()},w)}}t.$7g=fe;class ie{constructor($,w){this.b=-1,this.a=$,this.d=w,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule($=this.d){this.cancel(),this.b=setTimeout(this.f,$)}get delay(){return this.d}set delay($){this.d=$}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}t.$8g=ie;class oe{constructor($,w){w%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${w}ms is not a multiple of 1000ms.`),this.a=$,this.b=w,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule($=this.b){$%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${$}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil($/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}t.$9g=oe;class be extends ie{constructor($,w){super($,w),this.j=[]}work($){this.j.push($),this.isScheduled()||this.schedule()}h(){const $=this.j;this.j=[],this.a?.($)}dispose(){this.j=[],super.dispose()}}t.$0g=be;class Se extends U.$Rc{constructor($,w){super(),this.g=$,this.h=w,this.a=[],this.b=this.B(new U.$Sc),this.f=!1}get pending(){return this.a.length}work($){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+$.length>this.g.maxBufferedWork)return!1}else if(this.pending+$.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const w of $)this.a.push(w);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ie(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}t.$$g=Se,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?t.$_g=(M,$)=>{(0,A.$B)(()=>{if(w)return;const I=Date.now()+15;$(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,I-Date.now())}}))});let w=!1;return{dispose(){w||(w=!0)}}}:t.$_g=(M,$,w)=>{const I=M.requestIdleCallback($,typeof w=="number"?{timeout:w}:void 0);let v=!1;return{dispose(){v||(v=!0,M.cancelIdleCallback(I))}}},t.$ah=M=>(0,t.$_g)(globalThis,M)}();class Le{constructor($,w){this.d=!1,this.a=()=>{try{this.f=w()}catch(I){this.g=I}finally{this.d=!0}},this.b=(0,t.$_g)($,()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}t.$bh=Le;class Fe extends Le{constructor($){super(globalThis,$)}}t.$ch=Fe;async function de(M,$,w){let I;for(let v=0;v<w;v++)try{return await M()}catch(O){I=O,await R($)}throw I}t.$dh=de;class ne{isRunning($){return typeof $=="number"?this.a?.taskId===$:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run($,w,I){return this.a={taskId:$,cancel:()=>I?.(),promise:w},w.then(()=>this.d($),()=>this.d($)),w}d($){this.a&&$===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const $=this.b;this.b=void 0,$.run().then($.promiseResolve,$.promiseReject)}}queue($){if(this.b)this.b.run=$;else{let w,I;const v=new Promise((O,k)=>{w=O,I=k});this.b={run:$,promise:v,promiseResolve:w,promiseReject:I}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}t.$eh=ne;class ce{constructor($,w=()=>Date.now()){this.d=$,this.f=w,this.a=0,this.b=0}increment(){const $=this.f();return $-this.a>this.d&&(this.a=$,this.b=0),this.b++,this.b}}t.$fh=ce;var X;(function(M){M[M.Resolved=0]="Resolved",M[M.Rejected=1]="Rejected"})(X||(X={}));class q{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise(($,w)=>{this.a=$,this.b=w})}complete($){return new Promise(w=>{this.a($),this.d={outcome:0,value:$},w()})}error($){return new Promise(w=>{this.b($),this.d={outcome:1,value:$},w()})}cancel(){return this.error(new L.$4)}}t.$gh=q;var G;(function(M){async function $(I){let v;const O=await Promise.all(I.map(k=>k.then(S=>S,S=>{v||(v=S)})));if(typeof v<"u")throw v;return O}M.settled=$;function w(I){return new Promise(async(v,O)=>{try{await I(v,O)}catch(k){O(k)}})}M.withAsyncBody=w})(G||(t.Promises=G={}));var P;(function(M){M[M.Initial=0]="Initial",M[M.DoneOK=1]="DoneOK",M[M.DoneError=2]="DoneError"})(P||(P={}));class V{static fromArray($){return new V(w=>{w.emitMany($)})}static fromPromise($){return new V(async w=>{w.emitMany(await $)})}static fromPromises($){return new V(async w=>{await Promise.all($.map(async I=>w.emitOne(await I)))})}static merge($){return new V(async w=>{await Promise.all($.map(async I=>{for await(const v of I)w.emitOne(v)}))})}static{this.EMPTY=V.fromArray([])}constructor($){this.a=0,this.b=[],this.d=null,this.f=new i.$Od,queueMicrotask(async()=>{const w={emitOne:I=>this.g(I),emitMany:I=>this.h(I),reject:I=>this.k(I)};try{await Promise.resolve($(w)),this.j()}catch(I){this.k(I)}finally{w.emitOne=void 0,w.emitMany=void 0,w.reject=void 0}})}[Symbol.asyncIterator](){let $=0;return{next:async()=>{do{if(this.a===2)throw this.d;if($<this.b.length)return{done:!1,value:this.b[$++]};if(this.a===1)return{done:!0,value:void 0};await i.Event.toPromise(this.f.event)}while(!0)}}}static map($,w){return new V(async I=>{for await(const v of $)I.emitOne(w(v))})}map($){return V.map(this,$)}static filter($,w){return new V(async I=>{for await(const v of $)w(v)&&I.emitOne(v)})}filter($){return V.filter(this,$)}static coalesce($){return V.filter($,w=>!!w)}coalesce(){return V.coalesce(this)}static async toPromise($){const w=[];for await(const I of $)w.push(I);return w}toPromise(){return V.toPromise(this)}g($){this.a===0&&(this.b.push($),this.f.fire())}h($){this.a===0&&(this.b=this.b.concat($),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k($){this.a===0&&(this.a=2,this.d=$,this.f.fire())}}t.$hh=V;class p extends V{constructor($,w){super(w),this.l=$}cancel(){this.l.cancel()}}t.$ih=p;function W(M){const $=new y.$Yd,w=M($.token);return new p($,async I=>{const v=$.token.onCancellationRequested(()=>{v.dispose(),$.dispose(),I.reject(new L.$4)});try{for await(const O of w){if($.token.isCancellationRequested)return;I.emitOne(O)}v.dispose(),$.dispose()}catch(O){v.dispose(),$.dispose(),I.reject(O)}})}t.$jh=W;class J{constructor(){this.a=new q,this.b=new V(I=>{if($){I.reject($);return}return w&&I.emitMany(w),this.d=v=>I.reject(v),this.f=v=>I.emitOne(v),this.a.p});let $,w;this.f=I=>{w||(w=[]),w.push(I)},this.d=I=>{$||($=I)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject($){this.d($),this.a.complete()}emitOne($){this.f($)}}t.$kh=J}),define($e[3],we([1,0,17,112,15,20,9,6,4,116,2,30,5,16,49,14]),function(le,t,y,L,i,U,D,A,c,g,f,T,s,a,e,h){"use strict";var l;Object.defineProperty(t,"__esModule",{value:!0}),t.$nQ=t.$mQ=t.h=t.$kQ=t.$jQ=t.$iQ=t.$hQ=t.$gQ=t.$fQ=t.$eQ=t.$dQ=t.DetectedFullscreenMode=t.$cQ=t.$bQ=t.$aQ=t.$_P=t.$$P=t.$0P=t.$9P=t.$8P=t.$7P=t.$6P=t.$5P=t.$4P=t.$3P=t.$2P=t.$1P=t.$ZP=t.$YP=t.$=t.Namespace=t.$WP=t.$VP=t.$UP=t.$TP=t.$SP=t.$RP=t.$QP=t.$PP=t.$OP=t.$NP=t.$MP=t.$LP=t.$KP=t.$JP=t.$IP=t.$HP=t.$GP=t.$FP=t.$EP=t.$DP=t.$CP=t.$BP=t.$AP=t.$zP=t.$yP=t.$xP=t.$wP=t.$vP=t.$uP=t.$tP=t.$sP=t.$rP=t.$qP=t.$pP=t.$oP=t.$nP=t.$mP=t.$lP=t.$kP=t.$jP=t.$iP=t.$hP=t.$gP=t.$fP=t.$eP=t.$dP=t.$cP=t.$bP=t.$aP=t.$_O=t.$$O=t.$0O=t.$9O=t.$8O=t.$7O=t.$6O=t.$5O=t.$4O=t.$3O=t.$2O=t.$1O=t.$ZO=t.$YO=t.$XO=t.onDidUnregisterWindow=t.onWillUnregisterWindow=t.onDidRegisterWindow=t.getWindowId=t.getWindowsCount=t.getWindows=t.registerWindow=void 0,l=function(){const _=new Map;typeof h.$sO.vscodeWindowId!="number"&&Object.defineProperty(h.$sO,"vscodeWindowId",{get:()=>1}),_.set(h.$sO.vscodeWindowId,{window:h.$sO,disposables:new f.$Qc});const Y=new c.$Od,ae=new c.$Od,me=new c.$Od;return{onDidRegisterWindow:Y.event,onWillUnregisterWindow:me.event,onDidUnregisterWindow:ae.event,registerWindow(ye){if(_.has(ye.vscodeWindowId))return f.$Rc.None;const Re=new f.$Qc,ze={window:ye,disposables:Re.add(new f.$Qc)};return _.set(ye.vscodeWindowId,ze),Re.add((0,f.$Pc)(()=>{_.delete(ye.vscodeWindowId),ae.fire(ye)})),Re.add(r(ye,t.$NP.BEFORE_UNLOAD,()=>{me.fire(ye)})),Y.fire(ze),Re},getWindows(){return _.values()},getWindowsCount(){return _.size},getWindowId(ye){return ye.vscodeWindowId}}}(),t.registerWindow=l.registerWindow,t.getWindows=l.getWindows,t.getWindowsCount=l.getWindowsCount,t.getWindowId=l.getWindowId,t.onDidRegisterWindow=l.onDidRegisterWindow,t.onWillUnregisterWindow=l.onWillUnregisterWindow,t.onDidUnregisterWindow=l.onDidUnregisterWindow;function m(_){for(;_.firstChild;)_.firstChild.remove()}t.$XO=m;class n{constructor(Y,ae,me,ye){this.f=Y,this.g=ae,this.d=me,this.j=ye||!1,this.f.addEventListener(this.g,this.d,this.j)}dispose(){this.d&&(this.f.removeEventListener(this.g,this.d,this.j),this.f=null,this.d=null)}}function r(_,Y,ae,me){return new n(_,Y,ae,me)}t.$YO=r;function b(_){return function(Y){return _(new U.$QO(Y))}}function u(_){return function(Y){return _(new i.$VO(Y))}}const o=function(Y,ae,me,ye){let Re=me;return ae==="click"||ae==="mousedown"?Re=b(me):(ae==="keydown"||ae==="keypress"||ae==="keyup")&&(Re=u(me)),r(Y,ae,Re,ye)};t.$ZO=o;const N=function(Y,ae,me){const ye=b(ae);return R(Y,ye,me)};t.$1O=N;const z=function(Y,ae,me){const ye=b(ae);return E(Y,ye,me)};t.$2O=z;function R(_,Y,ae){return r(_,s.$r&&L.$NO.pointerEvents?t.$NP.POINTER_DOWN:t.$NP.MOUSE_DOWN,Y,ae)}t.$3O=R;function d(_,Y,ae){return r(_,s.$r&&L.$NO.pointerEvents?t.$NP.POINTER_MOVE:t.$NP.MOUSE_MOVE,Y,ae)}t.$4O=d;function E(_,Y,ae){return r(_,s.$r&&L.$NO.pointerEvents?t.$NP.POINTER_UP:t.$NP.MOUSE_UP,Y,ae)}t.$5O=E;class B{constructor(Y,ae=0){this.d=Y,this.priority=ae,this.f=!1}dispose(){this.f=!0}execute(){if(!this.f)try{this.d()}catch(Y){(0,A.$Z)(Y)}}static sort(Y,ae){return ae.priority-Y.priority}}(function(){const _=new Map,Y=new Map,ae=new Map,me=new Map,ye=Re=>{ae.set(Re,!1);const ze=_.get(Re)??[];for(Y.set(Re,ze),_.set(Re,[]),me.set(Re,!0);ze.length>0;)ze.sort(B.sort),ze.shift().execute();me.set(Re,!1)};t.$7O=(Re,ze,Ye=0)=>{const Ge=(0,t.getWindowId)(Re),qe=new B(ze,Ye);let st=_.get(Ge);return st||(st=[],_.set(Ge,st)),st.push(qe),ae.get(Ge)||(ae.set(Ge,!0),Re.requestAnimationFrame(()=>ye(Ge))),qe},t.$6O=(Re,ze,Ye)=>{const Ge=(0,t.getWindowId)(Re);if(me.get(Ge)){const qe=new B(ze,Ye);let st=Y.get(Ge);return st||(st=[],Y.set(Ge,st)),st.push(qe),qe}else return(0,t.$7O)(Re,ze,Ye)}})();function H(_,Y){return(0,t.$7O)(_,Y,1e4)}t.$8O=H;function x(_,Y){return(0,t.$7O)(_,Y,-1e4)}t.$9O=x;const C=8,F=function(_,Y){return Y};class Q extends f.$Rc{constructor(Y,ae,me,ye=F,Re=C){super();let ze=null,Ye=0;const Ge=this.B(new D.$6g),qe=()=>{Ye=new Date().getTime(),me(ze),ze=null};this.B(r(Y,ae,st=>{ze=ye(ze,st);const Nt=new Date().getTime()-Ye;Nt>=Re?(Ge.cancel(),qe()):Ge.setIfNotSet(qe,Re-Nt)}))}}function te(_,Y,ae,me,ye){return new Q(_,Y,ae,me,ye)}t.$0O=te;function re(_){return _.ownerDocument.defaultView.getComputedStyle(_,null)}t.$$O=re;function fe(_){const Y=_.ownerDocument,ae=Y.defaultView?.window;if(_!==Y.body)return new oe(_.clientWidth,_.clientHeight);if(s.$r&&ae?.visualViewport)return new oe(ae.visualViewport.width,ae.visualViewport.height);if(ae?.innerWidth&&ae.innerHeight)return new oe(ae.innerWidth,ae.innerHeight);if(Y.body&&Y.body.clientWidth&&Y.body.clientHeight)return new oe(Y.body.clientWidth,Y.body.clientHeight);if(Y.documentElement&&Y.documentElement.clientWidth&&Y.documentElement.clientHeight)return new oe(Y.documentElement.clientWidth,Y.documentElement.clientHeight);throw new Error("Unable to figure out browser width and height")}t.$_O=fe;class ie{static d(Y,ae){return parseFloat(ae)||0}static f(Y,ae,me){const ye=re(Y),Re=ye?ye.getPropertyValue(ae):"0";return ie.d(Y,Re)}static getBorderLeftWidth(Y){return ie.f(Y,"border-left-width","borderLeftWidth")}static getBorderRightWidth(Y){return ie.f(Y,"border-right-width","borderRightWidth")}static getBorderTopWidth(Y){return ie.f(Y,"border-top-width","borderTopWidth")}static getBorderBottomWidth(Y){return ie.f(Y,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(Y){return ie.f(Y,"padding-left","paddingLeft")}static getPaddingRight(Y){return ie.f(Y,"padding-right","paddingRight")}static getPaddingTop(Y){return ie.f(Y,"padding-top","paddingTop")}static getPaddingBottom(Y){return ie.f(Y,"padding-bottom","paddingBottom")}static getMarginLeft(Y){return ie.f(Y,"margin-left","marginLeft")}static getMarginTop(Y){return ie.f(Y,"margin-top","marginTop")}static getMarginRight(Y){return ie.f(Y,"margin-right","marginRight")}static getMarginBottom(Y){return ie.f(Y,"margin-bottom","marginBottom")}}class oe{static{this.None=new oe(0,0)}constructor(Y,ae){this.width=Y,this.height=ae}with(Y=this.width,ae=this.height){return Y!==this.width||ae!==this.height?new oe(Y,ae):this}static is(Y){return typeof Y=="object"&&typeof Y.height=="number"&&typeof Y.width=="number"}static lift(Y){return Y instanceof oe?Y:new oe(Y.width,Y.height)}static equals(Y,ae){return Y===ae?!0:!Y||!ae?!1:Y.width===ae.width&&Y.height===ae.height}}t.$aP=oe;function be(_){let Y=_.offsetParent,ae=_.offsetTop,me=_.offsetLeft;for(;(_=_.parentNode)!==null&&_!==_.ownerDocument.body&&_!==_.ownerDocument.documentElement;){ae-=_.scrollTop;const ye=v(_)?null:re(_);ye&&(me-=ye.direction!=="rtl"?_.scrollLeft:-_.scrollLeft),_===Y&&(me+=ie.getBorderLeftWidth(_),ae+=ie.getBorderTopWidth(_),ae+=_.offsetTop,me+=_.offsetLeft,Y=_.offsetParent)}return{left:me,top:ae}}t.$bP=be;function Se(_,Y,ae){typeof Y=="number"&&(_.style.width=`${Y}px`),typeof ae=="number"&&(_.style.height=`${ae}px`)}t.$cP=Se;function Le(_,Y,ae,me,ye,Re="absolute"){typeof Y=="number"&&(_.style.top=`${Y}px`),typeof ae=="number"&&(_.style.right=`${ae}px`),typeof me=="number"&&(_.style.bottom=`${me}px`),typeof ye=="number"&&(_.style.left=`${ye}px`),_.style.position=Re}t.$dP=Le;function Fe(_){const Y=_.getBoundingClientRect();return{left:Y.left+(_.ownerDocument.defaultView?.scrollX??0),top:Y.top+(_.ownerDocument.defaultView?.scrollY??0),width:Y.width,height:Y.height}}t.$eP=Fe;function de(_){let Y=_,ae=1;do{const me=re(Y).zoom;me!=null&&me!=="1"&&(ae*=me),Y=Y.parentElement}while(Y!==null&&Y!==Y.ownerDocument.documentElement);return ae}t.$fP=de;function ne(_){const Y=ie.getMarginLeft(_)+ie.getMarginRight(_);return _.offsetWidth+Y}t.$gP=ne;function ce(_){const Y=ie.getBorderLeftWidth(_)+ie.getBorderRightWidth(_),ae=ie.getPaddingLeft(_)+ie.getPaddingRight(_);return _.offsetWidth-Y-ae}t.$hP=ce;function X(_){const Y=ie.getMarginLeft(_)+ie.getMarginRight(_);return _.scrollWidth+Y}t.$iP=X;function q(_){const Y=ie.getBorderTopWidth(_)+ie.getBorderBottomWidth(_),ae=ie.getPaddingTop(_)+ie.getPaddingBottom(_);return _.offsetHeight-Y-ae}t.$jP=q;function G(_){const Y=ie.getMarginTop(_)+ie.getMarginBottom(_);return _.offsetHeight+Y}t.$kP=G;function P(_,Y){if(_===null)return 0;const ae=be(_),me=be(Y);return ae.left-me.left}function V(_,Y){const ae=Y.map(ye=>Math.max(X(ye),ne(ye))+P(ye,_)||0);return Math.max(...ae)}t.$lP=V;function p(_,Y){return!!Y?.contains(_)}t.$mP=p;const W="parentFlowToElementId";function J(_,Y){_.dataset[W]=Y.id}t.$nP=J;function M(_){const Y=_.dataset[W];return typeof Y=="string"?_.ownerDocument.getElementById(Y):null}function $(_,Y){let ae=_;for(;ae;){if(ae===Y)return!0;if(ae instanceof HTMLElement){const me=M(ae);if(me){ae=me;continue}}ae=ae.parentNode}return!1}t.$oP=$;function w(_,Y,ae){for(;_&&_.nodeType===_.ELEMENT_NODE;){if(_.classList.contains(Y))return _;if(ae){if(typeof ae=="string"){if(_.classList.contains(ae))return null}else if(_===ae)return null}_=_.parentNode}return null}t.$pP=w;function I(_,Y,ae){return!!w(_,Y,ae)}t.$qP=I;function v(_){return _&&!!_.host&&!!_.mode}t.$rP=v;function O(_){return!!k(_)}t.$sP=O;function k(_){for(;_.parentNode;){if(_===_.ownerDocument?.body)return null;_=_.parentNode}return v(_)?_:null}t.$tP=k;function S(){let _=se().activeElement;for(;_?.shadowRoot;)_=_.shadowRoot.activeElement;return _}t.$uP=S;function j(_){return _.ownerDocument.activeElement===_}t.$vP=j;function K(_){return p(_.ownerDocument.activeElement,_)}t.$wP=K;function ee(_){return _.ownerDocument===se()}t.$xP=ee;function se(){return(0,t.getWindowsCount)()<=1?document:Array.from((0,t.getWindows)()).map(({window:Y})=>Y.document).find(Y=>Y.hasFocus())??document}t.$yP=se;function ge(){return se().defaultView?.window??h.$sO}t.$zP=ge;function pe(_){const Y=_;if(Y?.ownerDocument?.defaultView)return Y.ownerDocument.defaultView.window;const ae=_;return ae?.view?ae.view.window:h.$sO}t.$AP=pe;function Pe(_){const Y=pe(_);Y!==ge()&&Y.focus()}t.$BP=Pe;const Ae=new Map;function De(_){return Ae.has(_)}t.$CP=De;function Ie(_=document.head,Y,ae){const me=document.createElement("style");if(me.type="text/css",me.media="screen",Y?.(me),_.appendChild(me),ae&&ae.add((0,f.$Pc)(()=>_.removeChild(me))),_===document.head){const ye=new Set;Ae.set(me,ye);for(const{window:Re,disposables:ze}of(0,t.getWindows)()){if(Re===h.$sO)continue;const Ye=ze.add(_e(me,ye,Re));ae?.add(Ye)}}return me}t.$DP=Ie;function Oe(_){const Y=new f.$Qc;for(const[ae,me]of Ae)Y.add(_e(ae,me,_));return Y}t.$EP=Oe;function _e(_,Y,ae){const me=new f.$Qc,ye=_.cloneNode(!0);ae.document.head.appendChild(ye),me.add((0,f.$Pc)(()=>ae.document.head.removeChild(ye)));for(const Re of Z(_))ye.sheet?.insertRule(Re.cssText,ye.sheet?.cssRules.length);return me.add(t.$FP.observe(_,me,{childList:!0})(()=>{ye.textContent=_.textContent})),Y.add(ye),me.add((0,f.$Pc)(()=>Y.delete(ye))),me}t.$FP=new class{constructor(){this.mutationObservers=new Map}observe(_,Y,ae){let me=this.mutationObservers.get(_);me||(me=new Map,this.mutationObservers.set(_,me));const ye=(0,e.$Hi)(ae);let Re=me.get(ye);if(Re)Re.users+=1;else{const ze=new c.$Od,Ye=new MutationObserver(qe=>ze.fire(qe));Ye.observe(_,ae);const Ge=Re={users:1,observer:Ye,onDidMutate:ze.event};Y.add((0,f.$Pc)(()=>{Ge.users-=1,Ge.users===0&&(ze.dispose(),Ye.disconnect(),me?.delete(ye),me?.size===0&&this.mutationObservers.delete(_))})),me.set(ye,Re)}return Re.onDidMutate}};function He(_=document.head){const Y=document.createElement("meta");return _.appendChild(Y),Y}t.$GP=He;let Me=null;function Qe(){return Me||(Me=Ie()),Me}function Z(_){return _?.sheet?.rules?_.sheet.rules:_?.sheet?.cssRules?_.sheet.cssRules:[]}function he(_,Y,ae=Qe()){if(!(!ae||!Y)){ae.sheet?.insertRule(`${_} {${Y}}`,0);for(const me of Ae.get(ae)??[])he(_,Y,me)}}t.$HP=he;function ve(_,Y=Qe()){if(!Y)return;const ae=Z(Y),me=[];for(let ye=0;ye<ae.length;ye++){const Re=ae[ye];Ee(Re)&&Re.selectorText.indexOf(_)!==-1&&me.push(ye)}for(let ye=me.length-1;ye>=0;ye--)Y.sheet?.deleteRule(me[ye]);for(const ye of Ae.get(Y)??[])ve(_,ye)}t.$IP=ve;function Ee(_){return typeof _.selectorText=="string"}function Ce(_){return _ instanceof MouseEvent||_ instanceof pe(_).MouseEvent}t.$JP=Ce;function Be(_){return _ instanceof KeyboardEvent||_ instanceof pe(_).KeyboardEvent}t.$KP=Be;function Ue(_){return _ instanceof PointerEvent||_ instanceof pe(_).PointerEvent}t.$LP=Ue;function Ze(_){return _ instanceof DragEvent||_ instanceof pe(_).DragEvent}t.$MP=Ze,t.$NP={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",PASTE:"paste",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:y.$FO?"webkitAnimationStart":"animationstart",ANIMATION_END:y.$FO?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:y.$FO?"webkitAnimationIteration":"animationiteration"};function Je(_){const Y=_;return!!(Y&&typeof Y.preventDefault=="function"&&typeof Y.stopPropagation=="function")}t.$OP=Je,t.$PP={stop:(_,Y)=>(_.preventDefault(),Y&&_.stopPropagation(),_)};function Ke(_){const Y=[];for(let ae=0;_&&_.nodeType===_.ELEMENT_NODE;ae++)Y[ae]=_.scrollTop,_=_.parentNode;return Y}t.$QP=Ke;function Ve(_,Y){for(let ae=0;_&&_.nodeType===_.ELEMENT_NODE;ae++)_.scrollTop!==Y[ae]&&(_.scrollTop=Y[ae]),_=_.parentNode}t.$RP=Ve;class tt extends f.$Rc{static m(Y){if(Y instanceof HTMLElement){const ae=k(Y),me=ae?ae.activeElement:Y.ownerDocument.activeElement;return p(me,Y)}else{const ae=Y;return p(ae.document.activeElement,ae.document)}}constructor(Y){super(),this.f=this.B(new c.$Od),this.onDidFocus=this.f.event,this.g=this.B(new c.$Od),this.onDidBlur=this.g.event;let ae=tt.m(Y),me=!1;const ye=()=>{me=!1,ae||(ae=!0,this.f.fire())},Re=()=>{ae&&(me=!0,(Y instanceof HTMLElement?pe(Y):Y).setTimeout(()=>{me&&(me=!1,ae=!1,this.g.fire())},0))};this.j=()=>{tt.m(Y)!==ae&&(ae?Re():ye())},this.B(r(Y,t.$NP.FOCUS,ye,!0)),this.B(r(Y,t.$NP.BLUR,Re,!0)),Y instanceof HTMLElement&&(this.B(r(Y,t.$NP.FOCUS_IN,()=>this.j())),this.B(r(Y,t.$NP.FOCUS_OUT,()=>this.j())))}refreshState(){this.j()}}function nt(_){return new tt(_)}t.$SP=nt;function dt(_,Y){return _.after(Y),Y}t.$TP=dt;function ct(_,...Y){if(_.append(...Y),Y.length===1&&typeof Y[0]!="string")return Y[0]}t.$UP=ct;function ft(_,Y){return _.insertBefore(Y,_.firstChild),Y}t.$VP=ft;function St(_,...Y){_.innerText="",ct(_,...Y)}t.$WP=St;const Ct=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var gt;(function(_){_.HTML="http://www.w3.org/1999/xhtml",_.SVG="http://www.w3.org/2000/svg"})(gt||(t.Namespace=gt={}));function wt(_,Y,ae,...me){const ye=Ct.exec(Y);if(!ye)throw new Error("Bad use of emmet");const Re=ye[1]||"div";let ze;return _!==gt.HTML?ze=document.createElementNS(_,Re):ze=document.createElement(Re),ye[3]&&(ze.id=ye[3]),ye[4]&&(ze.className=ye[4].replace(/\./g," ").trim()),ae&&Object.entries(ae).forEach(([Ye,Ge])=>{typeof Ge>"u"||(/^on\w+$/.test(Ye)?ze[Ye]=Ge:Ye==="selected"?Ge&&ze.setAttribute(Ye,"true"):ze.setAttribute(Ye,Ge))}),ze.append(...me),ze}function Pt(_,Y,...ae){return wt(gt.HTML,_,Y,...ae)}t.$=Pt,Pt.SVG=function(_,Y,...ae){return wt(gt.SVG,_,Y,...ae)};function Te(_,Y){const ae=[];return _.forEach((me,ye)=>{ye>0&&(Y instanceof Node?ae.push(Y.cloneNode()):ae.push(document.createTextNode(Y))),ae.push(me)}),ae}t.$YP=Te;function ue(_,...Y){_?ke(...Y):Ne(...Y)}t.$ZP=ue;function ke(..._){for(const Y of _)Y.style.display="",Y.removeAttribute("aria-hidden")}t.$1P=ke;function Ne(..._){for(const Y of _)Y.style.display="none",Y.setAttribute("aria-hidden","true")}t.$2P=Ne;function We(_,Y){for(;_&&_.nodeType===_.ELEMENT_NODE;){if(_ instanceof HTMLElement&&_.hasAttribute(Y))return _;_=_.parentNode}return null}function et(_){!_||!_.hasAttribute("tabIndex")||(_.ownerDocument.activeElement===_&&We(_.parentElement,"tabIndex")?.focus(),_.removeAttribute("tabindex"))}t.$3P=et;function rt(_){return Y=>{Y.preventDefault(),Y.stopPropagation(),_(Y)}}t.$4P=rt;function xe(_){return new Promise(Y=>{if(_.document.readyState==="complete"||_.document&&_.document.body!==null)Y(void 0);else{const me=()=>{_.window.removeEventListener("DOMContentLoaded",me,!1),Y()};_.window.addEventListener("DOMContentLoaded",me,!1)}})}t.$5P=xe;function at(_,Y){const ae=_.devicePixelRatio*Y;return Math.max(1,Math.floor(ae))/_.devicePixelRatio}t.$6P=at;function vt(_){h.$window.open(_,"_blank","noopener")}t.$7P=vt;const Dt=780,Bt=640;function yi(_){const Y=Math.floor(h.$window.screenLeft+h.$window.innerWidth/2-Dt/2),ae=Math.floor(h.$window.screenTop+h.$window.innerHeight/2-Bt/2);h.$window.open(_,"_blank",`width=${Dt},height=${Bt},top=${ae},left=${Y}`)}t.$8P=yi;function Ei(_,Y=!0){const ae=h.$window.open();return ae?(Y&&(ae.opener=null),ae.location.href=_,!0):!1}t.$9P=Ei;function Ai(_,Y){const ae=()=>{Y(),me=(0,t.$7O)(_,ae)};let me=(0,t.$7O)(_,ae);return(0,f.$Pc)(()=>me.dispose())}t.$0P=Ai,T.$0f.setPreferredWebSchema(/^https:/.test(h.$sO.location.href)?"https":"http");function ki(_){return _?`url('${T.$dg.uriToBrowserUri(_).toString(!0).replace(/'/g,"%27")}')`:"url('')"}t.$$P=ki;function Si(_){return`'${_.replace(/'/g,"%27")}'`}t.$_P=Si;function Gt(_,Y){if(_!==void 0){const ae=_.match(/^\s*var\((.+)\)$/);if(ae){const me=ae[1].split(",",2);return me.length===2&&(Y=Gt(me[1].trim(),Y)),`var(${me[0]}, ${Y})`}return _}return Y}t.$aQ=Gt;function Ci(_,Y){let ae;if(a.URI.isUri(_))ae=_.toString(!0);else{const ye=new Blob([_]);ae=URL.createObjectURL(ye),setTimeout(()=>URL.revokeObjectURL(ae))}const me=document.createElement("a");document.body.appendChild(me),me.download=Y,me.href=ae,me.click(),setTimeout(()=>document.body.removeChild(me))}t.$bQ=Ci;function Pi(){return new Promise(_=>{const Y=document.createElement("input");document.body.appendChild(Y),Y.type="file",Y.multiple=!0,c.Event.once(c.Event.fromDOMEventEmitter(Y,"input"))(()=>{_(Y.files??void 0)}),Y.click(),setTimeout(()=>document.body.removeChild(Y))})}t.$cQ=Pi;var yt;(function(_){_[_.DOCUMENT=1]="DOCUMENT",_[_.BROWSER=2]="BROWSER"})(yt||(t.DetectedFullscreenMode=yt={}));function Ni(){return document.fullscreenElement||document.webkitFullscreenElement||document.webkitIsFullScreen?{mode:yt.DOCUMENT,guess:!1}:h.$window.innerHeight===h.$window.screen.height?{mode:yt.BROWSER,guess:!1}:(s.$k||s.$l)&&h.$window.outerHeight===h.$window.screen.height&&h.$window.outerWidth===h.$window.screen.width?{mode:yt.BROWSER,guess:!0}:null}t.$dQ=Ni;function Xt(_,Y=!1){const ae=document.createElement("a");return g.addHook("afterSanitizeAttributes",me=>{for(const ye of["href","src"])if(me.hasAttribute(ye)){const Re=me.getAttribute(ye);if(ye==="href"&&Re.startsWith("#"))continue;if(ae.href=Re,!_.includes(ae.protocol.replace(/:$/,""))){if(Y&&ye==="src"&&ae.href.startsWith("data:"))continue;me.removeAttribute(ye)}}}),(0,f.$Pc)(()=>{g.removeHook("afterSanitizeAttributes")})}t.$eQ=Xt;const Fi=[T.Schemas.http,T.Schemas.https,T.Schemas.command];t.$fQ=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const Oi=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function Li(_,Y){const ae=Xt(Fi);try{const me=g.sanitize(Y,Oi);_.innerHTML=me}finally{ae.dispose()}}t.$gQ=Li;function Ti(_){const Y=new Uint16Array(_.length);for(let ye=0;ye<Y.length;ye++)Y[ye]=_.charCodeAt(ye);let ae="";const me=new Uint8Array(Y.buffer);for(let ye=0;ye<me.length;ye++)ae+=String.fromCharCode(me[ye]);return ae}function Ri(_){return btoa(Ti(_))}t.$hQ=Ri;class bt extends c.$Od{constructor(){super(),this.o=new f.$Qc,this.s={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this.o.add(c.Event.runAndSubscribe(t.onDidRegisterWindow,({window:Y,disposables:ae})=>this.B(Y,ae),{window:h.$sO,disposables:this.o}))}B(Y,ae){ae.add(r(Y,"keydown",me=>{if(me.defaultPrevented)return;const ye=new i.$VO(me);if(!(ye.keyCode===6&&me.repeat)){if(me.altKey&&!this.s.altKey)this.s.lastKeyPressed="alt";else if(me.ctrlKey&&!this.s.ctrlKey)this.s.lastKeyPressed="ctrl";else if(me.metaKey&&!this.s.metaKey)this.s.lastKeyPressed="meta";else if(me.shiftKey&&!this.s.shiftKey)this.s.lastKeyPressed="shift";else if(ye.keyCode!==6)this.s.lastKeyPressed=void 0;else return;this.s.altKey=me.altKey,this.s.ctrlKey=me.ctrlKey,this.s.metaKey=me.metaKey,this.s.shiftKey=me.shiftKey,this.s.lastKeyPressed&&(this.s.event=me,this.fire(this.s))}},!0)),ae.add(r(Y,"keyup",me=>{me.defaultPrevented||(!me.altKey&&this.s.altKey?this.s.lastKeyReleased="alt":!me.ctrlKey&&this.s.ctrlKey?this.s.lastKeyReleased="ctrl":!me.metaKey&&this.s.metaKey?this.s.lastKeyReleased="meta":!me.shiftKey&&this.s.shiftKey?this.s.lastKeyReleased="shift":this.s.lastKeyReleased=void 0,this.s.lastKeyPressed!==this.s.lastKeyReleased&&(this.s.lastKeyPressed=void 0),this.s.altKey=me.altKey,this.s.ctrlKey=me.ctrlKey,this.s.metaKey=me.metaKey,this.s.shiftKey=me.shiftKey,this.s.lastKeyReleased&&(this.s.event=me,this.fire(this.s)))},!0)),ae.add(r(Y.document.body,"mousedown",()=>{this.s.lastKeyPressed=void 0},!0)),ae.add(r(Y.document.body,"mouseup",()=>{this.s.lastKeyPressed=void 0},!0)),ae.add(r(Y.document.body,"mousemove",me=>{me.buttons&&(this.s.lastKeyPressed=void 0)},!0)),ae.add(r(Y,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this.s}get isModifierPressed(){return this.s.altKey||this.s.ctrlKey||this.s.metaKey||this.s.shiftKey}resetKeyStatus(){this.C(),this.fire(this.s)}C(){this.s={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return bt.A||(bt.A=new bt),bt.A}dispose(){super.dispose(),this.o.dispose()}}t.$iQ=bt;function Ii(_){const Y=document.cookie.match("(^|[^;]+)\\s*"+_+"\\s*=\\s*([^;]+)");return Y?Y.pop():void 0}t.$jQ=Ii;class Mi extends f.$Rc{constructor(Y,ae){super(),this.j=Y,this.m=ae,this.f=0,this.g=0,this.n()}n(){this.B(r(this.j,t.$NP.DRAG_ENTER,Y=>{this.f++,this.g=Y.timeStamp,this.m.onDragEnter(Y)})),this.B(r(this.j,t.$NP.DRAG_OVER,Y=>{Y.preventDefault(),this.m.onDragOver?.(Y,Y.timeStamp-this.g)})),this.B(r(this.j,t.$NP.DRAG_LEAVE,Y=>{this.f--,this.f===0&&(this.g=0,this.m.onDragLeave(Y))})),this.B(r(this.j,t.$NP.DRAG_END,Y=>{this.f=0,this.g=0,this.m.onDragEnd(Y)})),this.B(r(this.j,t.$NP.DROP,Y=>{this.f=0,this.g=0,this.m.onDrop(Y)}))}}t.$kQ=Mi;const Bi=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function zi(_,...Y){let ae,me;Array.isArray(Y[0])?(ae={},me=Y[0]):(ae=Y[0]||{},me=Y[1]);const ye=Bi.exec(_);if(!ye||!ye.groups)throw new Error("Bad use of h");const Re=ye.groups.tag||"div",ze=document.createElement(Re);ye.groups.id&&(ze.id=ye.groups.id);const Ye=[];if(ye.groups.class)for(const qe of ye.groups.class.split("."))qe!==""&&Ye.push(qe);if(ae.className!==void 0)for(const qe of ae.className.split("."))qe!==""&&Ye.push(qe);Ye.length>0&&(ze.className=Ye.join(" "));const Ge={};if(ye.groups.name&&(Ge[ye.groups.name]=ze),me)for(const qe of me)qe instanceof HTMLElement?ze.appendChild(qe):typeof qe=="string"?ze.append(qe):"root"in qe&&(Object.assign(Ge,qe),ze.appendChild(qe.root));for(const[qe,st]of Object.entries(ae))if(qe!=="className")if(qe==="style")for(const[Nt,zt]of Object.entries(st))ze.style.setProperty(Zt(Nt),typeof zt=="number"?zt+"px":""+zt);else qe==="tabIndex"?ze.tabIndex=st:ze.setAttribute(Zt(qe),st.toString());return Ge.root=ze,Ge}t.h=zi;function Zt(_){return _.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}function Jt(_,Y){for(const{name:ae,value:me}of _.attributes)Y.setAttribute(ae,me)}t.$mQ=Jt;function ji(_,Y,ae){const me=_.getAttribute(ae);me?Y.setAttribute(ae,me):Y.removeAttribute(ae)}function Hi(_,Y,ae){Jt(_,Y);const me=new f.$Qc;return me.add(t.$FP.observe(_,me,{attributes:!0,attributeFilter:ae})(ye=>{for(const Re of ye)Re.type==="attributes"&&Re.attributeName&&ji(_,Y,Re.attributeName)})),me}t.$nQ=Hi}),define($e[54],we([1,0,3,2,115]),function(le,t,y,L,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qQ=t.$pQ=t.$oQ=void 0;class U extends L.$Rc{constructor(c,g){super(),this.B((0,y.$YO)(c,"dragover",f=>{f.preventDefault(),this.a||(this.a=setTimeout(()=>{g(),this.a=null},800))})),["dragleave","drop","dragend"].forEach(f=>{this.B((0,y.$YO)(c,f,()=>{this.b()}))})}b(){this.a&&(clearTimeout(this.a),this.a=null)}dispose(){super.dispose(),this.b()}}t.$oQ=U,t.$pQ={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:i.$Tr.text,INTERNAL_URI_LIST:"application/vnd.code.uri-list"};function D(A,c,g,f,T){const s=document.createElement("div");if(s.className=g,s.textContent=c,T&&(s.style.color=T),f&&(s.style.background=f),A.dataTransfer){const a=(0,y.$AP)(A).document;a.body.appendChild(s),A.dataTransfer.setDragImage(s,-10,-10),setTimeout(()=>a.body.removeChild(s),0)}}t.$qQ=D}),define($e[55],we([1,0,3]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$UQ=t.$TQ=t.$SQ=void 0;function L(s,a={}){const e=U(a);return e.textContent=s,e}t.$SQ=L;function i(s,a={}){const e=U(a);return c(e,g(s,!!a.renderCodeSegments),a.actionHandler,a.renderCodeSegments),e}t.$TQ=i;function U(s){const a=s.inline?"span":"div",e=document.createElement(a);return s.className&&(e.className=s.className),e}t.$UQ=U;class D{constructor(a){this.b=a,this.c=0}eos(){return this.c>=this.b.length}next(){const a=this.peek();return this.advance(),a}peek(){return this.b[this.c]}advance(){this.c++}}var A;(function(s){s[s.Invalid=0]="Invalid",s[s.Root=1]="Root",s[s.Text=2]="Text",s[s.Bold=3]="Bold",s[s.Italics=4]="Italics",s[s.Action=5]="Action",s[s.ActionClose=6]="ActionClose",s[s.Code=7]="Code",s[s.NewLine=8]="NewLine"})(A||(A={}));function c(s,a,e,h){let l;if(a.type===2)l=document.createTextNode(a.content||"");else if(a.type===3)l=document.createElement("b");else if(a.type===4)l=document.createElement("i");else if(a.type===7&&h)l=document.createElement("code");else if(a.type===5&&e){const m=document.createElement("a");e.disposables.add(y.$ZO(m,"click",n=>{e.callback(String(a.index),n)})),l=m}else a.type===8?l=document.createElement("br"):a.type===1&&(l=s);l&&s!==l&&s.appendChild(l),l&&Array.isArray(a.children)&&a.children.forEach(m=>{c(l,m,e,h)})}function g(s,a){const e={type:1,children:[]};let h=0,l=e;const m=[],n=new D(s);for(;!n.eos();){let r=n.next();const b=r==="\\"&&T(n.peek(),a)!==0;if(b&&(r=n.next()),!b&&f(r,a)&&r===n.peek()){n.advance(),l.type===2&&(l=m.pop());const u=T(r,a);if(l.type===u||l.type===5&&u===6)l=m.pop();else{const o={type:u,children:[]};u===5&&(o.index=h,h++),l.children.push(o),m.push(l),l=o}}else if(r===`
`)l.type===2&&(l=m.pop()),l.children.push({type:8});else if(l.type!==2){const u={type:2,content:r};l.children.push(u),m.push(l),l=u}else l.content+=r}return l.type===2&&(l=m.pop()),m.length,e}function f(s,a){return T(s,a)!==0}function T(s,a){switch(s){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return a?7:0;default:return 0}}}),define($e[56],we([1,0,3,2]),function(le,t,y,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uQ=void 0;class i{constructor(){this.a=new L.$Qc,this.b=null,this.c=null}dispose(){this.stopMonitoring(!1),this.a.dispose()}stopMonitoring(D,A){if(!this.isMonitoring())return;this.a.clear(),this.b=null;const c=this.c;this.c=null,D&&c&&c(A)}isMonitoring(){return!!this.b}startMonitoring(D,A,c,g,f){this.isMonitoring()&&this.stopMonitoring(!1),this.b=g,this.c=f;let T=D;try{D.setPointerCapture(A),this.a.add((0,L.$Pc)(()=>{try{D.releasePointerCapture(A)}catch{}}))}catch{T=y.$AP(D)}this.a.add(y.$YO(T,y.$NP.POINTER_MOVE,s=>{if(s.buttons!==c){this.stopMonitoring(!0);return}s.preventDefault(),this.b(s)})),this.a.add(y.$YO(T,y.$NP.POINTER_UP,s=>this.stopMonitoring(!0)))}}t.$uQ=i});var Xe=this&&this.__decorate||function(le,t,y,L){var i=arguments.length,U=i<3?t:L===null?L=Object.getOwnPropertyDescriptor(t,y):L,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")U=Reflect.decorate(le,t,y,L);else for(var A=le.length-1;A>=0;A--)(D=le[A])&&(U=(i<3?D(U):i>3?D(t,y,U):D(t,y))||U);return i>3&&U&&Object.defineProperty(t,y,U),U};define($e[24],we([1,0,3,14,11,26,4,2,45]),function(le,t,y,L,i,U,D,A,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rQ=t.EventType=void 0;var g;(function(T){T.Tap="-monaco-gesturetap",T.Change="-monaco-gesturechange",T.Start="-monaco-gesturestart",T.End="-monaco-gesturesend",T.Contextmenu="-monaco-gesturecontextmenu"})(g||(t.EventType=g={}));class f extends A.$Rc{static{this.a=-.005}static{this.c=700}static{this.r=400}constructor(){super(),this.f=!1,this.g=new c.$1c,this.h=new c.$1c,this.m={},this.j=null,this.n=0,this.B(D.Event.runAndSubscribe(y.onDidRegisterWindow,({window:s,disposables:a})=>{a.add(y.$YO(s.document,"touchstart",e=>this.s(e),{passive:!1})),a.add(y.$YO(s.document,"touchend",e=>this.u(s,e))),a.add(y.$YO(s.document,"touchmove",e=>this.D(e),{passive:!1}))},{window:L.$sO,disposables:this.q}))}static addTarget(s){if(!f.isTouchDevice())return A.$Rc.None;f.b||(f.b=(0,A.$Kc)(new f));const a=f.b.g.push(s);return(0,A.$Pc)(a)}static ignoreTarget(s){if(!f.isTouchDevice())return A.$Rc.None;f.b||(f.b=(0,A.$Kc)(new f));const a=f.b.h.push(s);return(0,A.$Pc)(a)}static isTouchDevice(){return"ontouchstart"in L.$sO||navigator.maxTouchPoints>0}dispose(){this.j&&(this.j.dispose(),this.j=null),super.dispose()}s(s){const a=Date.now();this.j&&(this.j.dispose(),this.j=null);for(let e=0,h=s.targetTouches.length;e<h;e++){const l=s.targetTouches.item(e);this.m[l.identifier]={id:l.identifier,initialTarget:l.target,initialTimeStamp:a,initialPageX:l.pageX,initialPageY:l.pageY,rollingTimestamps:[a],rollingPageX:[l.pageX],rollingPageY:[l.pageY]};const m=this.w(g.Start,l.target);m.pageX=l.pageX,m.pageY=l.pageY,this.z(m)}this.f&&(s.preventDefault(),s.stopPropagation(),this.f=!1)}u(s,a){const e=Date.now(),h=Object.keys(this.m).length;for(let l=0,m=a.changedTouches.length;l<m;l++){const n=a.changedTouches.item(l);if(!this.m.hasOwnProperty(String(n.identifier))){console.warn("move of an UNKNOWN touch",n);continue}const r=this.m[n.identifier],b=Date.now()-r.initialTimeStamp;if(b<f.c&&Math.abs(r.initialPageX-i.$rb(r.rollingPageX))<30&&Math.abs(r.initialPageY-i.$rb(r.rollingPageY))<30){const u=this.w(g.Tap,r.initialTarget);u.pageX=i.$rb(r.rollingPageX),u.pageY=i.$rb(r.rollingPageY),this.z(u)}else if(b>=f.c&&Math.abs(r.initialPageX-i.$rb(r.rollingPageX))<30&&Math.abs(r.initialPageY-i.$rb(r.rollingPageY))<30){const u=this.w(g.Contextmenu,r.initialTarget);u.pageX=i.$rb(r.rollingPageX),u.pageY=i.$rb(r.rollingPageY),this.z(u)}else if(h===1){const u=i.$rb(r.rollingPageX),o=i.$rb(r.rollingPageY),N=i.$rb(r.rollingTimestamps)-r.rollingTimestamps[0],z=u-r.rollingPageX[0],R=o-r.rollingPageY[0],d=[...this.g].filter(E=>r.initialTarget instanceof Node&&E.contains(r.initialTarget));this.C(s,d,e,Math.abs(z)/N,z>0?1:-1,u,Math.abs(R)/N,R>0?1:-1,o)}this.z(this.w(g.End,r.initialTarget)),delete this.m[n.identifier]}this.f&&(a.preventDefault(),a.stopPropagation(),this.f=!1)}w(s,a){const e=document.createEvent("CustomEvent");return e.initEvent(s,!1,!0),e.initialTarget=a,e.tapCount=0,e}z(s){if(s.type===g.Tap){const a=new Date().getTime();let e=0;a-this.n>f.r?e=1:e=2,this.n=a,s.tapCount=e}else(s.type===g.Change||s.type===g.Contextmenu)&&(this.n=0);if(s.initialTarget instanceof Node){for(const a of this.h)if(a.contains(s.initialTarget))return;for(const a of this.g)a.contains(s.initialTarget)&&(a.dispatchEvent(s),this.f=!0)}}C(s,a,e,h,l,m,n,r,b){this.j=y.$7O(s,()=>{const u=Date.now(),o=u-e;let N=0,z=0,R=!0;h+=f.a*o,n+=f.a*o,h>0&&(R=!1,N=l*h*o),n>0&&(R=!1,z=r*n*o);const d=this.w(g.Change);d.translationX=N,d.translationY=z,a.forEach(E=>E.dispatchEvent(d)),R||this.C(s,a,u,h,l,m+N,n,r,b+z)})}D(s){const a=Date.now();for(let e=0,h=s.changedTouches.length;e<h;e++){const l=s.changedTouches.item(e);if(!this.m.hasOwnProperty(String(l.identifier))){console.warn("end of an UNKNOWN touch",l);continue}const m=this.m[l.identifier],n=this.w(g.Change,m.initialTarget);n.translationX=l.pageX-i.$rb(m.rollingPageX),n.translationY=l.pageY-i.$rb(m.rollingPageY),n.pageX=l.pageX,n.pageY=l.pageY,this.z(n),m.rollingPageX.length>3&&(m.rollingPageX.shift(),m.rollingPageY.shift(),m.rollingTimestamps.shift()),m.rollingPageX.push(l.pageX),m.rollingPageY.push(l.pageY),m.rollingTimestamps.push(a)}this.f&&(s.preventDefault(),s.stopPropagation(),this.f=!1)}}t.$rQ=f,Xe([U.$lh],f,"isTouchDevice",null)}),define($e[57],we([1,0,3,90]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$YQ=t.$XQ=t.$WQ=void 0;const L=2e4;let i,U,D,A,c;function g(a){i=document.createElement("div"),i.className="monaco-aria-container";const e=()=>{const l=document.createElement("div");return l.className="monaco-alert",l.setAttribute("role","alert"),l.setAttribute("aria-atomic","true"),i.appendChild(l),l};U=e(),D=e();const h=()=>{const l=document.createElement("div");return l.className="monaco-status",l.setAttribute("aria-live","polite"),l.setAttribute("aria-atomic","true"),i.appendChild(l),l};A=h(),c=h(),a.appendChild(i)}t.$WQ=g;function f(a){i&&(U.textContent!==a?(y.$XO(D),s(U,a)):(y.$XO(U),s(D,a)))}t.$XQ=f;function T(a){i&&(A.textContent!==a?(y.$XO(c),s(A,a)):(y.$XO(A),s(c,a)))}t.$YQ=T;function s(a,e){y.$XO(a),e.length>L&&(e=e.substr(0,L)),a.textContent=e,a.style.visibility="hidden",a.style.visibility="visible"}}),define($e[117],we([1,0,3,19]),function(le,t,y,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lR=t.$kR=void 0;const i=new RegExp(`(\\\\)?\\$\\((${L.ThemeIcon.iconNameExpression}(?:${L.ThemeIcon.iconModifierExpression})?)\\)`,"g");function U(A){const c=new Array;let g,f=0,T=0;for(;(g=i.exec(A))!==null;){T=g.index||0,f<T&&c.push(A.substring(f,T)),f=(g.index||0)+g[0].length;const[,s,a]=g;c.push(s?`$(${a})`:D({id:a}))}return f<A.length&&c.push(A.substring(f)),c}t.$kR=U;function D(A){const c=y.$("span");return c.classList.add(...L.ThemeIcon.asClassNameArray(A)),c}t.$lR=D}),define($e[118],we([1,0,3]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8Q=void 0;function L(U){try{U.parentElement?.removeChild(U)}catch{}}class i{constructor(D){this.d=D,this.a=new Map,this.b=new Set,this.c=!1}alloc(D){let A=this.h(D).pop(),c=!1;if(A)c=this.b.has(A.domNode),c&&this.b.delete(A.domNode);else{const g=(0,y.$)(".monaco-list-row"),T=this.i(D).renderTemplate(g);A={domNode:g,templateId:D,templateData:T}}return{row:A,isReusingConnectedDomNode:c}}release(D){D&&this.f(D)}transact(D){if(this.c)throw new Error("Already in transaction");this.c=!0;try{D()}finally{for(const A of this.b)this.g(A);this.b.clear(),this.c=!1}}f(D){const{domNode:A,templateId:c}=D;A&&(this.c?this.b.add(A):this.g(A)),this.h(c).push(D)}g(D){D.classList.remove("scrolling"),L(D)}h(D){let A=this.a.get(D);return A||(A=[],this.a.set(D,A)),A}dispose(){this.a.forEach((D,A)=>{for(const c of D)this.i(A).disposeTemplate(c.templateData),c.templateData=null}),this.a.clear(),this.b.clear()}i(D){const A=this.d.get(D);if(!A)throw new Error(`No renderer found for ${D}`);return A}}t.$8Q=i}),define($e[119],we([1,0,9,2]),function(le,t,y,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zQ=void 0;class i extends L.$Rc{constructor(D,A,c){super(),this.a=D,this.b=A,this.c=c,this.f=null,this.m=!1,this.j=!1,this.g=!1,this.h=!1,this.n=this.B(new y.$6g)}setVisibility(D){this.a!==D&&(this.a=D,this.s())}setShouldBeVisible(D){this.g=D,this.s()}r(){return this.a===2?!1:this.a===3?!0:this.g}s(){const D=this.r();this.h!==D&&(this.h=D,this.ensureVisibility())}setIsNeeded(D){this.j!==D&&(this.j=D,this.ensureVisibility())}setDomNode(D){this.f=D,this.f.setClassName(this.c),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this.j){this.u(!1);return}this.h?this.t():this.u(!0)}t(){this.m||(this.m=!0,this.n.setIfNotSet(()=>{this.f?.setClassName(this.b)},0))}u(D){this.n.cancel(),this.m&&(this.m=!1,this.f?.setClassName(this.c+(D?" fade":"")))}}t.$zQ=i}),define($e[120],we([1,0,3,24,11,4,2,5]),function(le,t,y,L,i,U,D,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sR=void 0;class c extends D.$Rc{constructor(f,T,s,a){super(),this.f=0,this.b=a||Object.create(null),this.c=[],this.a=document.createElement("select"),this.a.className="monaco-select-box",typeof this.b.ariaLabel=="string"&&this.a.setAttribute("aria-label",this.b.ariaLabel),typeof this.b.ariaDescription=="string"&&this.a.setAttribute("aria-description",this.b.ariaDescription),this.g=this.B(new U.$Od),this.h=s,this.j(),this.setOptions(f,T)}j(){this.B(L.$rQ.addTarget(this.a)),[L.EventType.Tap].forEach(f=>{this.B(y.$YO(this.a,f,T=>{this.a.focus()}))}),this.B(y.$ZO(this.a,"click",f=>{y.$PP.stop(f,!0)})),this.B(y.$ZO(this.a,"change",f=>{this.a.title=f.target.value,this.g.fire({index:f.target.selectedIndex,selected:f.target.value})})),this.B(y.$ZO(this.a,"keydown",f=>{let T=!1;A.$k?(f.keyCode===18||f.keyCode===16||f.keyCode===10)&&(T=!0):(f.keyCode===18&&f.altKey||f.keyCode===10||f.keyCode===3)&&(T=!0),T&&f.stopPropagation()}))}get onDidSelect(){return this.g.event}setOptions(f,T){(!this.c||!i.$tb(this.c,f))&&(this.c=f,this.a.options.length=0,this.c.forEach((s,a)=>{this.a.add(this.m(s.text,a,s.isDisabled))})),T!==void 0&&this.select(T)}select(f){this.c.length===0?this.f=0:f>=0&&f<this.c.length?this.f=f:f>this.c.length-1?this.select(this.c.length-1):this.f<0&&(this.f=0),this.a.selectedIndex=this.f,this.f<this.c.length&&typeof this.c[this.f].text=="string"?this.a.title=this.c[this.f].text:this.a.title=""}setAriaLabel(f){this.b.ariaLabel=f,this.a.setAttribute("aria-label",f)}focus(){this.a&&(this.a.tabIndex=0,this.a.focus())}blur(){this.a&&(this.a.tabIndex=-1,this.a.blur())}setFocusable(f){this.a.tabIndex=f?0:-1}render(f){f.classList.add("select-container"),f.appendChild(this.a),this.setOptions(this.c,this.f),this.applyStyles()}style(f){this.h=f,this.applyStyles()}applyStyles(){this.a&&(this.a.style.backgroundColor=this.h.selectBackground??"",this.a.style.color=this.h.selectForeground??"",this.a.style.borderColor=this.h.selectBorder??"")}m(f,T,s){const a=document.createElement("option");return a.value=f,a.text=f,a.disabled=!!s,a}}t.$sR=c}),define($e[58],we([1,0,25,11,9,50,86,4,27]),function(le,t,y,L,i,U,D,A,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ZS=t.$YS=t.$XS=void 0;function g(a){return typeof a=="object"&&"visibility"in a&&"data"in a}t.$XS=g;function f(a){switch(a){case!0:return 1;case!1:return 0;default:return a}}t.$YS=f;function T(a){return typeof a.collapsible=="boolean"}class s{constructor(e,h,l,m={}){this.o=e,this.p=h,this.rootRef=[],this.d=new A.$Wd,this.f=new A.$Od,this.onDidChangeCollapseState=this.d.wrapEvent(this.f.event),this.g=new A.$Od,this.onDidChangeRenderNodeCount=this.d.wrapEvent(this.g.event),this.l=new A.$Od,this.onDidSplice=this.l.event,this.m=new i.$Rg(U.$Ld),this.h=typeof m.collapseByDefault>"u"?!1:m.collapseByDefault,this.j=m.filter,this.k=typeof m.autoExpandSingleChildren>"u"?!1:m.autoExpandSingleChildren,this.c={parent:void 0,element:l,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(e,h,l=c.Iterable.empty(),m={}){if(e.length===0)throw new y.$VS(this.o,"Invalid tree location");m.diffIdentityProvider?this.q(m.diffIdentityProvider,e,h,l,m):this.s(e,h,l,m)}q(e,h,l,m=c.Iterable.empty(),n,r=n.diffDepth??0){const{parentNode:b}=this.G(h);if(!b.lastDiffIds)return this.s(h,l,m,n);const u=[...m],o=h[h.length-1],N=new D.$Ds({getElements:()=>b.lastDiffIds},{getElements:()=>[...b.children.slice(0,o),...u,...b.children.slice(o+l)].map(B=>e.getId(B.element).toString())}).ComputeDiff(!1);if(N.quitEarly)return b.lastDiffIds=void 0,this.s(h,l,u,n);const z=h.slice(0,-1),R=(B,H,x)=>{if(r>0)for(let C=0;C<x;C++)B--,H--,this.q(e,[...z,B,0],Number.MAX_SAFE_INTEGER,u[H].children,n,r-1)};let d=Math.min(b.children.length,o+l),E=u.length;for(const B of N.changes.sort((H,x)=>x.originalStart-H.originalStart))R(d,E,d-(B.originalStart+B.originalLength)),d=B.originalStart,E=B.modifiedStart-o,this.s([...z,d],B.originalLength,c.Iterable.slice(u,E,E+B.modifiedLength),n);R(d,E,d)}s(e,h,l=c.Iterable.empty(),{onDidCreateNode:m,onDidDeleteNode:n,diffIdentityProvider:r}){const{parentNode:b,listIndex:u,revealed:o,visible:N}=this.G(e),z=[],R=c.Iterable.map(l,fe=>this.w(fe,b,b.visible?1:0,o,z,m)),d=e[e.length-1],E=b.children.length>0;let B=0;for(let fe=d;fe>=0&&fe<b.children.length;fe--){const ie=b.children[fe];if(ie.visible){B=ie.visibleChildIndex;break}}const H=[];let x=0,C=0;for(const fe of R)H.push(fe),C+=fe.renderNodeCount,fe.visible&&(fe.visibleChildIndex=B+x++);const F=(0,L.$5b)(b.children,d,h,H);r?b.lastDiffIds?(0,L.$5b)(b.lastDiffIds,d,h,H.map(fe=>r.getId(fe.element).toString())):b.lastDiffIds=b.children.map(fe=>r.getId(fe.element).toString()):b.lastDiffIds=void 0;let Q=0;for(const fe of F)fe.visible&&Q++;if(Q!==0)for(let fe=d+H.length;fe<b.children.length;fe++){const ie=b.children[fe];ie.visible&&(ie.visibleChildIndex-=Q)}if(b.visibleChildrenCount+=x-Q,o&&N){const fe=F.reduce((ie,oe)=>ie+(oe.visible?oe.renderNodeCount:0),0);this.B(b,C-fe),this.p.splice(u,fe,z)}if(F.length>0&&n){const fe=ie=>{n(ie),ie.children.forEach(fe)};F.forEach(fe)}this.l.fire({insertedNodes:H,deletedNodes:F});const te=b.children.length>0;E!==te&&this.setCollapsible(e.slice(0,-1),te);let re=b;for(;re;){if(re.visibility===2){this.m.trigger(()=>this.refilter());break}re=re.parent}}rerender(e){if(e.length===0)throw new y.$VS(this.o,"Invalid tree location");const{node:h,listIndex:l,revealed:m}=this.F(e);h.visible&&m&&this.p.splice(l,1,[h])}updateElementHeight(e,h){if(e.length===0)throw new y.$VS(this.o,"Invalid tree location");const{listIndex:l}=this.F(e);this.p.updateElementHeight(l,h)}has(e){return this.D(e)}getListIndex(e){const{listIndex:h,visible:l,revealed:m}=this.F(e);return l&&m?h:-1}getListRenderCount(e){return this.E(e).renderNodeCount}isCollapsible(e){return this.E(e).collapsible}setCollapsible(e,h){const l=this.E(e);typeof h>"u"&&(h=!l.collapsible);const m={collapsible:h};return this.d.bufferEvents(()=>this.t(e,m))}isCollapsed(e){return this.E(e).collapsed}setCollapsed(e,h,l){const m=this.E(e);typeof h>"u"&&(h=!m.collapsed);const n={collapsed:h,recursive:l||!1};return this.d.bufferEvents(()=>this.t(e,n))}t(e,h){const{node:l,listIndex:m,revealed:n}=this.F(e),r=this.u(l,m,n,h);if(l!==this.c&&this.k&&r&&!T(h)&&l.collapsible&&!l.collapsed&&!h.recursive){let b=-1;for(let u=0;u<l.children.length;u++)if(l.children[u].visible)if(b>-1){b=-1;break}else b=u;b>-1&&this.t([...e,b],h)}return r}u(e,h,l,m){const n=this.v(e,m,!1);if(!l||!e.visible||!n)return n;const r=e.renderNodeCount,b=this.x(e),u=r-(h===-1?0:1);return this.p.splice(h+1,u,b.slice(1)),n}v(e,h,l){let m;if(e===this.c?m=!1:(T(h)?(m=e.collapsible!==h.collapsible,e.collapsible=h.collapsible):e.collapsible?(m=e.collapsed!==h.collapsed,e.collapsed=h.collapsed):m=!1,m&&this.f.fire({node:e,deep:l})),!T(h)&&h.recursive)for(const n of e.children)m=this.v(n,h,!0)||m;return m}expandTo(e){this.d.bufferEvents(()=>{let h=this.E(e);for(;h.parent;)h=h.parent,e=e.slice(0,e.length-1),h.collapsed&&this.t(e,{collapsed:!1,recursive:!1})})}refilter(){const e=this.c.renderNodeCount,h=this.z(this.c);this.p.splice(0,e,h),this.m.cancel()}w(e,h,l,m,n,r){const b={parent:h,element:e.element,children:[],depth:h.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof e.collapsible=="boolean"?e.collapsible:typeof e.collapsed<"u",collapsed:typeof e.collapsed>"u"?this.h:e.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},u=this.C(b,l);b.visibility=u,m&&n.push(b);const o=e.children||c.Iterable.empty(),N=m&&u!==0&&!b.collapsed;let z=0,R=1;for(const d of o){const E=this.w(d,b,u,N,n,r);b.children.push(E),R+=E.renderNodeCount,E.visible&&(E.visibleChildIndex=z++)}return b.collapsible=b.collapsible||b.children.length>0,b.visibleChildrenCount=z,b.visible=u===2?z>0:u===1,b.visible?b.collapsed||(b.renderNodeCount=R):(b.renderNodeCount=0,m&&n.pop()),r?.(b),b}x(e){const h=e.renderNodeCount,l=[];return this.y(e,l),this.B(e.parent,l.length-h),l}y(e,h){if(e.visible===!1)return 0;if(h.push(e),e.renderNodeCount=1,!e.collapsed)for(const l of e.children)e.renderNodeCount+=this.y(l,h);return this.g.fire(e),e.renderNodeCount}z(e){const h=e.renderNodeCount,l=[];return this.A(e,e.visible?1:0,l),this.B(e.parent,l.length-h),l}A(e,h,l,m=!0){let n;if(e!==this.c){if(n=this.C(e,h),n===0)return e.visible=!1,e.renderNodeCount=0,!1;m&&l.push(e)}const r=l.length;e.renderNodeCount=e===this.c?0:1;let b=!1;if(!e.collapsed||n!==0){let u=0;for(const o of e.children)b=this.A(o,n,l,m&&!e.collapsed)||b,o.visible&&(o.visibleChildIndex=u++);e.visibleChildrenCount=u}else e.visibleChildrenCount=0;return e!==this.c&&(e.visible=n===2?b:n===1,e.visibility=n),e.visible?e.collapsed||(e.renderNodeCount+=l.length-r):(e.renderNodeCount=0,m&&l.pop()),this.g.fire(e),e.visible}B(e,h){if(h!==0)for(;e;)e.renderNodeCount+=h,this.g.fire(e),e=e.parent}C(e,h){const l=this.j?this.j.filter(e.element,h):1;return typeof l=="boolean"?(e.filterData=void 0,l?1:0):g(l)?(e.filterData=l.data,f(l.visibility)):(e.filterData=void 0,f(l))}D(e,h=this.c){if(!e||e.length===0)return!0;const[l,...m]=e;return l<0||l>h.children.length?!1:this.D(m,h.children[l])}E(e,h=this.c){if(!e||e.length===0)return h;const[l,...m]=e;if(l<0||l>h.children.length)throw new y.$VS(this.o,"Invalid tree location");return this.E(m,h.children[l])}F(e){if(e.length===0)return{node:this.c,listIndex:-1,revealed:!0,visible:!1};const{parentNode:h,listIndex:l,revealed:m,visible:n}=this.G(e),r=e[e.length-1];if(r<0||r>h.children.length)throw new y.$VS(this.o,"Invalid tree location");const b=h.children[r];return{node:b,listIndex:l,revealed:m,visible:n&&b.visible}}G(e,h=this.c,l=0,m=!0,n=!0){const[r,...b]=e;if(r<0||r>h.children.length)throw new y.$VS(this.o,"Invalid tree location");for(let u=0;u<r;u++)l+=h.children[u].renderNodeCount;return m=m&&!h.collapsed,n=n&&h.visible,b.length===0?{parentNode:h,listIndex:l,revealed:m,visible:n}:this.G(b,h.children[r],l+1,m,n)}getNode(e=[]){return this.E(e)}getNodeLocation(e){const h=[];let l=e;for(;l.parent;)h.push(l.parent.children.indexOf(l)),l=l.parent;return h.reverse()}getParentNodeLocation(e){if(e.length!==0)return e.length===1?[]:(0,L.$sb)(e)[0]}getFirstElementChild(e){const h=this.E(e);if(h.children.length!==0)return h.children[0].element}getLastElementAncestor(e=[]){const h=this.E(e);if(h.children.length!==0)return this.H(h)}H(e){return e.children.length===0?e.element:this.H(e.children[e.children.length-1])}}t.$ZS=s}),define($e[121],we([1,0,58,25,27]),function(le,t,y,L,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6S=void 0;class U{get size(){return this.d.size}constructor(A,c,g={}){this.k=A,this.rootRef=null,this.d=new Map,this.f=new Map,this.c=new y.$ZS(A,c,null,g),this.onDidSplice=this.c.onDidSplice,this.onDidChangeCollapseState=this.c.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.c.onDidChangeRenderNodeCount,g.sorter&&(this.j={compare(f,T){return g.sorter.compare(f.element,T.element)}}),this.h=g.identityProvider}setChildren(A,c=i.Iterable.empty(),g={}){const f=this.o(A);this.l(f,this.m(c),g)}l(A,c=i.Iterable.empty(),g){const f=new Set,T=new Set,s=e=>{if(e.element===null)return;const h=e;if(f.add(h.element),this.d.set(h.element,h),this.h){const l=this.h.getId(h.element).toString();T.add(l),this.f.set(l,h)}g.onDidCreateNode?.(h)},a=e=>{if(e.element===null)return;const h=e;if(f.has(h.element)||this.d.delete(h.element),this.h){const l=this.h.getId(h.element).toString();T.has(l)||this.f.delete(l)}g.onDidDeleteNode?.(h)};this.c.splice([...A,0],Number.MAX_VALUE,c,{...g,onDidCreateNode:s,onDidDeleteNode:a})}m(A=i.Iterable.empty()){return this.j&&(A=[...A].sort(this.j.compare.bind(this.j))),i.Iterable.map(A,c=>{let g=this.d.get(c.element);if(!g&&this.h){const s=this.h.getId(c.element).toString();g=this.f.get(s)}if(!g){let s;return typeof c.collapsed>"u"?s=void 0:c.collapsed===L.ObjectTreeElementCollapseState.Collapsed||c.collapsed===L.ObjectTreeElementCollapseState.PreserveOrCollapsed?s=!0:c.collapsed===L.ObjectTreeElementCollapseState.Expanded||c.collapsed===L.ObjectTreeElementCollapseState.PreserveOrExpanded?s=!1:s=!!c.collapsed,{...c,children:this.m(c.children),collapsed:s}}const f=typeof c.collapsible=="boolean"?c.collapsible:g.collapsible;let T;return typeof c.collapsed>"u"||c.collapsed===L.ObjectTreeElementCollapseState.PreserveOrCollapsed||c.collapsed===L.ObjectTreeElementCollapseState.PreserveOrExpanded?T=g.collapsed:c.collapsed===L.ObjectTreeElementCollapseState.Collapsed?T=!0:c.collapsed===L.ObjectTreeElementCollapseState.Expanded?T=!1:T=!!c.collapsed,{...c,collapsible:f,collapsed:T,children:this.m(c.children)}})}rerender(A){const c=this.o(A);this.c.rerender(c)}updateElementHeight(A,c){const g=this.o(A);this.c.updateElementHeight(g,c)}resort(A=null,c=!0){if(!this.j)return;const g=this.o(A),f=this.c.getNode(g);this.l(g,this.n(f,c),{})}n(A,c,g=!0){let f=[...A.children];return(c||g)&&(f=f.sort(this.j.compare.bind(this.j))),i.Iterable.map(f,T=>({element:T.element,collapsible:T.collapsible,collapsed:T.collapsed,children:this.n(T,c,!1)}))}getFirstElementChild(A=null){const c=this.o(A);return this.c.getFirstElementChild(c)}getLastElementAncestor(A=null){const c=this.o(A);return this.c.getLastElementAncestor(c)}has(A){return this.d.has(A)}getListIndex(A){const c=this.o(A);return this.c.getListIndex(c)}getListRenderCount(A){const c=this.o(A);return this.c.getListRenderCount(c)}isCollapsible(A){const c=this.o(A);return this.c.isCollapsible(c)}setCollapsible(A,c){const g=this.o(A);return this.c.setCollapsible(g,c)}isCollapsed(A){const c=this.o(A);return this.c.isCollapsed(c)}setCollapsed(A,c,g){const f=this.o(A);return this.c.setCollapsed(f,c,g)}expandTo(A){const c=this.o(A);this.c.expandTo(c)}refilter(){this.c.refilter()}getNode(A=null){if(A===null)return this.c.getNode(this.c.rootRef);const c=this.d.get(A);if(!c)throw new L.$VS(this.k,`Tree element not found: ${A}`);return c}getNodeLocation(A){return A.element}getParentNodeLocation(A){if(A===null)throw new L.$VS(this.k,"Invalid getParentNodeLocation call");const c=this.d.get(A);if(!c)throw new L.$VS(this.k,`Tree element not found: ${A}`);const g=this.c.getNodeLocation(c),f=this.c.getParentNodeLocation(g);return this.c.getNode(f).element}o(A){if(A===null)return[];const c=this.d.get(A);if(!c)throw new L.$VS(this.k,`Tree element not found: ${A}`);return this.c.getNodeLocation(c)}}t.$6S=U}),define($e[21],we([1,0,3,15,20,24,2]),function(le,t,y,L,i,U,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vQ=void 0;class A extends D.$Rc{f(g,f){this.B(y.$YO(g,y.$NP.CLICK,T=>f(new i.$QO(T))))}j(g,f){this.B(y.$YO(g,y.$NP.MOUSE_DOWN,T=>f(new i.$QO(T))))}m(g,f){this.B(y.$YO(g,y.$NP.MOUSE_OVER,T=>f(new i.$QO(T))))}u(g,f){this.B(y.$YO(g,y.$NP.MOUSE_LEAVE,T=>f(new i.$QO(T))))}z(g,f){this.B(y.$YO(g,y.$NP.KEY_DOWN,T=>f(new L.$VO(T))))}C(g,f){this.B(y.$YO(g,y.$NP.KEY_UP,T=>f(new L.$VO(T))))}D(g,f){this.B(y.$YO(g,y.$NP.INPUT,f))}F(g,f){this.B(y.$YO(g,y.$NP.BLUR,f))}G(g,f){this.B(y.$YO(g,y.$NP.FOCUS,f))}H(g,f){this.B(y.$YO(g,y.$NP.CHANGE,f))}I(g){return U.$rQ.ignoreTarget(g)}}t.$vQ=A}),define($e[38],we([1,0,56,21,9,19,3]),function(le,t,y,L,i,U,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xQ=t.$wQ=void 0,t.$wQ=11;class A extends L.$vQ{constructor(g){super(),this.a=g.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=g.bgWidth+"px",this.bgDomNode.style.height=g.bgHeight+"px",typeof g.top<"u"&&(this.bgDomNode.style.top="0px"),typeof g.left<"u"&&(this.bgDomNode.style.left="0px"),typeof g.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof g.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=g.className,this.domNode.classList.add(...U.ThemeIcon.asClassNameArray(g.icon)),this.domNode.style.position="absolute",this.domNode.style.width=t.$wQ+"px",this.domNode.style.height=t.$wQ+"px",typeof g.top<"u"&&(this.domNode.style.top=g.top+"px"),typeof g.left<"u"&&(this.domNode.style.left=g.left+"px"),typeof g.bottom<"u"&&(this.domNode.style.bottom=g.bottom+"px"),typeof g.right<"u"&&(this.domNode.style.right=g.right+"px"),this.g=this.B(new y.$uQ),this.B(D.$ZO(this.bgDomNode,D.$NP.POINTER_DOWN,f=>this.h(f))),this.B(D.$ZO(this.domNode,D.$NP.POINTER_DOWN,f=>this.h(f))),this.b=this.B(new i.$7g),this.c=this.B(new i.$6g)}h(g){if(!g.target||!(g.target instanceof Element))return;const f=()=>{this.b.cancelAndSet(()=>this.a(),1e3/24)};this.a(),this.b.cancel(),this.c.cancelAndSet(f,200),this.g.startMonitoring(g.target,g.pointerId,g.buttons,T=>{},()=>{this.b.cancel(),this.c.cancel()}),g.preventDefault()}}t.$xQ=A}),define($e[59],we([1,0,3,41,56,38,119,21,5]),function(le,t,y,L,i,U,D,A,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$AQ=void 0;const g=140;class f extends A.$vQ{constructor(s){super(),this.g=s.lazyRender,this.a=s.host,this.b=s.scrollable,this.c=s.scrollByPage,this.h=s.scrollbarState,this.n=this.B(new D.$zQ(s.visibility,"visible scrollbar "+s.extraScrollbarClassName,"invisible scrollbar "+s.extraScrollbarClassName)),this.n.setIsNeeded(this.h.isNeeded()),this.r=this.B(new i.$uQ),this.s=!0,this.domNode=(0,L.$tQ)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this.n.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this.B(y.$YO(this.domNode.domNode,y.$NP.POINTER_DOWN,a=>this.M(a)))}t(s){const a=this.B(new U.$xQ(s));this.domNode.domNode.appendChild(a.bgDomNode),this.domNode.domNode.appendChild(a.domNode)}w(s,a,e,h){this.slider=(0,L.$tQ)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(s),this.slider.setLeft(a),typeof e=="number"&&this.slider.setWidth(e),typeof h=="number"&&this.slider.setHeight(h),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this.B(y.$YO(this.slider.domNode,y.$NP.POINTER_DOWN,l=>{l.button===0&&(l.preventDefault(),this.O(l))})),this.f(this.slider.domNode,l=>{l.leftButton&&l.stopPropagation()})}y(s){return this.h.setVisibleSize(s)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}J(s){return this.h.setScrollSize(s)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}L(s){return this.h.setScrollPosition(s)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}beginReveal(){this.n.setShouldBeVisible(!0)}beginHide(){this.n.setShouldBeVisible(!1)}render(){this.s&&(this.s=!1,this.Q(this.h.getRectangleLargeSize(),this.h.getRectangleSmallSize()),this.R(this.h.getSliderSize(),this.h.getArrowSize()+this.h.getSliderPosition()))}M(s){s.target===this.domNode.domNode&&this.N(s)}delegatePointerDown(s){const a=this.domNode.domNode.getClientRects()[0].top,e=a+this.h.getSliderPosition(),h=a+this.h.getSliderPosition()+this.h.getSliderSize(),l=this.U(s);e<=l&&l<=h?s.button===0&&(s.preventDefault(),this.O(s)):this.N(s)}N(s){let a,e;if(s.target===this.domNode.domNode&&typeof s.offsetX=="number"&&typeof s.offsetY=="number")a=s.offsetX,e=s.offsetY;else{const l=y.$eP(this.domNode.domNode);a=s.pageX-l.left,e=s.pageY-l.top}const h=this.S(a,e);this.P(this.c?this.h.getDesiredScrollPositionFromOffsetPaged(h):this.h.getDesiredScrollPositionFromOffset(h)),s.button===0&&(s.preventDefault(),this.O(s))}O(s){if(!s.target||!(s.target instanceof Element))return;const a=this.U(s),e=this.W(s),h=this.h.clone();this.slider.toggleClassName("active",!0),this.r.startMonitoring(s.target,s.pointerId,s.buttons,l=>{const m=this.W(l),n=Math.abs(m-e);if(c.$j&&n>g){this.P(h.getScrollPosition());return}const b=this.U(l)-a;this.P(h.getDesiredScrollPositionFromDelta(b))},()=>{this.slider.toggleClassName("active",!1),this.a.onDragEnd()}),this.a.onDragStart()}P(s){const a={};this.writeScrollPosition(a,s),this.b.setScrollPositionNow(a)}updateScrollbarSize(s){this.X(s),this.h.setScrollbarSize(s),this.s=!0,this.g||this.render()}isNeeded(){return this.h.isNeeded()}}t.$AQ=f}),define($e[122],we([1,0,20,59,38,42,18]),function(le,t,y,L,i,U,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$BQ=void 0;class A extends L.$AQ{constructor(g,f,T){const s=g.getScrollDimensions(),a=g.getCurrentScrollPosition();if(super({lazyRender:f.lazyRender,host:T,scrollbarState:new U.$yQ(f.horizontalHasArrows?f.arrowSize:0,f.horizontal===2?0:f.horizontalScrollbarSize,f.vertical===2?0:f.verticalScrollbarSize,s.width,s.scrollWidth,a.scrollLeft),visibility:f.horizontal,extraScrollbarClassName:"horizontal",scrollable:g,scrollByPage:f.scrollByPage}),f.horizontalHasArrows){const e=(f.arrowSize-i.$wQ)/2,h=(f.horizontalScrollbarSize-i.$wQ)/2;this.t({className:"scra",icon:D.$Yj.scrollbarButtonLeft,top:h,left:e,bottom:void 0,right:void 0,bgWidth:f.arrowSize,bgHeight:f.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new y.$SO(null,1,0))}),this.t({className:"scra",icon:D.$Yj.scrollbarButtonRight,top:h,left:void 0,bottom:void 0,right:e,bgWidth:f.arrowSize,bgHeight:f.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new y.$SO(null,-1,0))})}this.w(Math.floor((f.horizontalScrollbarSize-f.horizontalSliderSize)/2),0,void 0,f.horizontalSliderSize)}R(g,f){this.slider.setWidth(g),this.slider.setLeft(f)}Q(g,f){this.domNode.setWidth(g),this.domNode.setHeight(f),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(g){return this.s=this.J(g.scrollWidth)||this.s,this.s=this.L(g.scrollLeft)||this.s,this.s=this.y(g.width)||this.s,this.s}S(g,f){return g}U(g){return g.pageX}W(g){return g.pageY}X(g){this.slider.setHeight(g)}writeScrollPosition(g,f){g.scrollLeft=f}updateOptions(g){this.updateScrollbarSize(g.horizontal===2?0:g.horizontalScrollbarSize),this.h.setOppositeScrollbarSize(g.vertical===2?0:g.verticalScrollbarSize),this.n.setVisibility(g.horizontal),this.c=g.scrollByPage}}t.$BQ=A}),define($e[123],we([1,0,20,59,38,42,18]),function(le,t,y,L,i,U,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$CQ=void 0;class A extends L.$AQ{constructor(g,f,T){const s=g.getScrollDimensions(),a=g.getCurrentScrollPosition();if(super({lazyRender:f.lazyRender,host:T,scrollbarState:new U.$yQ(f.verticalHasArrows?f.arrowSize:0,f.vertical===2?0:f.verticalScrollbarSize,0,s.height,s.scrollHeight,a.scrollTop),visibility:f.vertical,extraScrollbarClassName:"vertical",scrollable:g,scrollByPage:f.scrollByPage}),f.verticalHasArrows){const e=(f.arrowSize-i.$wQ)/2,h=(f.verticalScrollbarSize-i.$wQ)/2;this.t({className:"scra",icon:D.$Yj.scrollbarButtonUp,top:e,left:h,bottom:void 0,right:void 0,bgWidth:f.verticalScrollbarSize,bgHeight:f.arrowSize,onActivate:()=>this.a.onMouseWheel(new y.$SO(null,0,1))}),this.t({className:"scra",icon:D.$Yj.scrollbarButtonDown,top:void 0,left:h,bottom:e,right:void 0,bgWidth:f.verticalScrollbarSize,bgHeight:f.arrowSize,onActivate:()=>this.a.onMouseWheel(new y.$SO(null,0,-1))})}this.w(0,Math.floor((f.verticalScrollbarSize-f.verticalSliderSize)/2),f.verticalSliderSize,void 0)}R(g,f){this.slider.setHeight(g),this.slider.setTop(f)}Q(g,f){this.domNode.setWidth(f),this.domNode.setHeight(g),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(g){return this.s=this.J(g.scrollHeight)||this.s,this.s=this.L(g.scrollTop)||this.s,this.s=this.y(g.height)||this.s,this.s}S(g,f){return f}U(g){return g.pageY}W(g){return g.pageX}X(g){this.slider.setWidth(g)}writeScrollPosition(g,f){g.scrollTop=f}updateOptions(g){this.updateScrollbarSize(g.vertical===2?0:g.verticalScrollbarSize),this.h.setOppositeScrollbarSize(0),this.n.setVisibility(g.vertical),this.c=g.scrollByPage}}t.$CQ=A}),define($e[60],we([1,0,17,3,41,20,122,123,21,9,4,2,5,48,97]),function(le,t,y,L,i,U,D,A,c,g,f,T,s,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$HQ=t.$GQ=t.$FQ=t.$EQ=t.$DQ=void 0;const e=500,h=50,l=!0;class m{constructor(R,d,E){this.timestamp=R,this.deltaX=d,this.deltaY=E,this.score=0}}class n{static{this.INSTANCE=new n}constructor(){this.a=5,this.b=[],this.c=-1,this.d=-1}isPhysicalMouseWheel(){if(this.c===-1&&this.d===-1)return!1;let R=1,d=0,E=1,B=this.d;do{const H=B===this.c?R:Math.pow(2,-E);if(R-=H,d+=this.b[B].score*H,B===this.c)break;B=(this.a+B-1)%this.a,E++}while(!0);return d<=.5}acceptStandardWheelEvent(R){const d=L.$AP(R.browserEvent).devicePixelRatio/(0,y.$zO)();s.$j||s.$l?this.accept(Date.now(),R.deltaX/d,R.deltaY/d):this.accept(Date.now(),R.deltaX,R.deltaY)}accept(R,d,E){const B=new m(R,d,E);B.score=this.f(B),this.c===-1&&this.d===-1?(this.b[0]=B,this.c=0,this.d=0):(this.d=(this.d+1)%this.a,this.d===this.c&&(this.c=(this.c+1)%this.a),this.b[this.d]=B)}f(R){if(Math.abs(R.deltaX)>0&&Math.abs(R.deltaY)>0)return 1;let d=.5;const E=this.c===-1&&this.d===-1?null:this.b[this.d];return(!this.g(R.deltaX)||!this.g(R.deltaY))&&(d+=.25),Math.min(Math.max(d,0),1)}g(R){return Math.abs(Math.round(R)-R)<.01}}t.$DQ=n;class r extends c.$vQ{get options(){return this.a}constructor(R,d,E){super(),this.O=this.B(new f.$Od),this.onScroll=this.O.event,this.P=this.B(new f.$Od),this.onWillScroll=this.P.event,R.style.overflow="hidden",this.a=N(d),this.b=E,this.B(this.b.onScroll(H=>{this.P.fire(H),this.S(H),this.O.fire(H)}));const B={onMouseWheel:H=>this.R(H),onDragStart:()=>this.W(),onDragEnd:()=>this.X()};this.c=this.B(new A.$CQ(this.b,this.a,B)),this.g=this.B(new D.$BQ(this.b,this.a,B)),this.h=document.createElement("div"),this.h.className="monaco-scrollable-element "+this.a.className,this.h.setAttribute("role","presentation"),this.h.style.position="relative",this.h.style.overflow="hidden",this.h.appendChild(R),this.h.appendChild(this.g.domNode.domNode),this.h.appendChild(this.c.domNode.domNode),this.a.useShadows?(this.n=(0,i.$tQ)(document.createElement("div")),this.n.setClassName("shadow"),this.h.appendChild(this.n.domNode),this.r=(0,i.$tQ)(document.createElement("div")),this.r.setClassName("shadow"),this.h.appendChild(this.r.domNode),this.s=(0,i.$tQ)(document.createElement("div")),this.s.setClassName("shadow"),this.h.appendChild(this.s.domNode)):(this.n=null,this.r=null,this.s=null),this.t=this.a.listenOnDomNode||this.h,this.w=[],this.Q(this.a.handleMouseWheel),this.m(this.t,H=>this.Z(H)),this.u(this.t,H=>this.Y(H)),this.L=this.B(new g.$6g),this.y=!1,this.J=!1,this.M=!0,this.N=!0}dispose(){this.w=(0,T.$Mc)(this.w),super.dispose()}getDomNode(){return this.h}getOverviewRulerLayoutInfo(){return{parent:this.h,insertBefore:this.c.domNode.domNode}}delegateVerticalScrollbarPointerDown(R){this.c.delegatePointerDown(R)}getScrollDimensions(){return this.b.getScrollDimensions()}setScrollDimensions(R){this.b.setScrollDimensions(R,!1)}updateClassName(R){this.a.className=R,s.$k&&(this.a.className+=" mac"),this.h.className="monaco-scrollable-element "+this.a.className}updateOptions(R){typeof R.handleMouseWheel<"u"&&(this.a.handleMouseWheel=R.handleMouseWheel,this.Q(this.a.handleMouseWheel)),typeof R.mouseWheelScrollSensitivity<"u"&&(this.a.mouseWheelScrollSensitivity=R.mouseWheelScrollSensitivity),typeof R.fastScrollSensitivity<"u"&&(this.a.fastScrollSensitivity=R.fastScrollSensitivity),typeof R.scrollPredominantAxis<"u"&&(this.a.scrollPredominantAxis=R.scrollPredominantAxis),typeof R.horizontal<"u"&&(this.a.horizontal=R.horizontal),typeof R.vertical<"u"&&(this.a.vertical=R.vertical),typeof R.horizontalScrollbarSize<"u"&&(this.a.horizontalScrollbarSize=R.horizontalScrollbarSize),typeof R.verticalScrollbarSize<"u"&&(this.a.verticalScrollbarSize=R.verticalScrollbarSize),typeof R.scrollByPage<"u"&&(this.a.scrollByPage=R.scrollByPage),this.g.updateOptions(this.a),this.c.updateOptions(this.a),this.a.lazyRender||this.U()}setRevealOnScroll(R){this.N=R}delegateScrollFromMouseWheelEvent(R){this.R(new U.$SO(R))}Q(R){if(this.w.length>0!==R&&(this.w=(0,T.$Mc)(this.w),R)){const E=B=>{this.R(new U.$SO(B))};this.w.push(L.$YO(this.t,L.$NP.MOUSE_WHEEL,E,{passive:!1}))}}R(R){if(R.browserEvent?.defaultPrevented)return;const d=n.INSTANCE;l&&d.acceptStandardWheelEvent(R);let E=!1;if(R.deltaY||R.deltaX){let H=R.deltaY*this.a.mouseWheelScrollSensitivity,x=R.deltaX*this.a.mouseWheelScrollSensitivity;this.a.scrollPredominantAxis&&(this.a.scrollYToX&&x+H===0?x=H=0:Math.abs(H)>=Math.abs(x)?x=0:H=0),this.a.flipAxes&&([H,x]=[x,H]);const C=!s.$k&&R.browserEvent&&R.browserEvent.shiftKey;(this.a.scrollYToX||C)&&!x&&(x=H,H=0),R.browserEvent&&R.browserEvent.altKey&&(x=x*this.a.fastScrollSensitivity,H=H*this.a.fastScrollSensitivity);const F=this.b.getFutureScrollPosition();let Q={};if(H){const te=h*H,re=F.scrollTop-(te<0?Math.floor(te):Math.ceil(te));this.c.writeScrollPosition(Q,re)}if(x){const te=h*x,re=F.scrollLeft-(te<0?Math.floor(te):Math.ceil(te));this.g.writeScrollPosition(Q,re)}Q=this.b.validateScrollPosition(Q),(F.scrollLeft!==Q.scrollLeft||F.scrollTop!==Q.scrollTop)&&(l&&this.a.mouseWheelSmoothScroll&&d.isPhysicalMouseWheel()?this.b.setScrollPositionSmooth(Q):this.b.setScrollPositionNow(Q),E=!0)}let B=E;!B&&this.a.alwaysConsumeMouseWheel&&(B=!0),!B&&this.a.consumeMouseWheelIfScrollbarIsNeeded&&(this.c.isNeeded()||this.g.isNeeded())&&(B=!0),B&&(R.preventDefault(),R.stopPropagation())}S(R){this.M=this.g.onDidScroll(R)||this.M,this.M=this.c.onDidScroll(R)||this.M,this.a.useShadows&&(this.M=!0),this.N&&this.$(),this.a.lazyRender||this.U()}renderNow(){if(!this.a.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this.U()}U(){if(this.M&&(this.M=!1,this.g.render(),this.c.render(),this.a.useShadows)){const R=this.b.getCurrentScrollPosition(),d=R.scrollTop>0,E=R.scrollLeft>0,B=E?" left":"",H=d?" top":"",x=E||d?" top-left-corner":"";this.n.setClassName(`shadow${B}`),this.r.setClassName(`shadow${H}`),this.s.setClassName(`shadow${x}${H}${B}`)}}W(){this.y=!0,this.$()}X(){this.y=!1,this.ab()}Y(R){this.J=!1,this.ab()}Z(R){this.J=!0,this.$()}$(){this.c.beginReveal(),this.g.beginReveal(),this.bb()}ab(){!this.J&&!this.y&&(this.c.beginHide(),this.g.beginHide())}bb(){!this.J&&!this.y&&this.L.cancelAndSet(()=>this.ab(),e)}}t.$EQ=r;class b extends r{constructor(R,d){d=d||{},d.mouseWheelSmoothScroll=!1;const E=new a.$Zr({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:B=>L.$7O(L.$AP(R),B)});super(R,d,E),this.B(E)}setScrollPosition(R){this.b.setScrollPositionNow(R)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$FQ=b;class u extends r{constructor(R,d,E){super(R,d,E)}setScrollPosition(R){R.reuseAnimation?this.b.setScrollPositionSmooth(R,R.reuseAnimation):this.b.setScrollPositionNow(R)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$GQ=u;class o extends r{constructor(R,d){d=d||{},d.mouseWheelSmoothScroll=!1;const E=new a.$Zr({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:B=>L.$7O(L.$AP(R),B)});super(R,d,E),this.B(E),this.cb=R,this.B(this.onScroll(B=>{B.scrollTopChanged&&(this.cb.scrollTop=B.scrollTop),B.scrollLeftChanged&&(this.cb.scrollLeft=B.scrollLeft)})),this.scanDomNode()}setScrollPosition(R){this.b.setScrollPositionNow(R)}getScrollPosition(){return this.b.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this.cb.clientWidth,scrollWidth:this.cb.scrollWidth,height:this.cb.clientHeight,scrollHeight:this.cb.scrollHeight}),this.setScrollPosition({scrollLeft:this.cb.scrollLeft,scrollTop:this.cb.scrollTop})}}t.$HQ=o;function N(z){const R={lazyRender:typeof z.lazyRender<"u"?z.lazyRender:!1,className:typeof z.className<"u"?z.className:"",useShadows:typeof z.useShadows<"u"?z.useShadows:!0,handleMouseWheel:typeof z.handleMouseWheel<"u"?z.handleMouseWheel:!0,flipAxes:typeof z.flipAxes<"u"?z.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof z.consumeMouseWheelIfScrollbarIsNeeded<"u"?z.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof z.alwaysConsumeMouseWheel<"u"?z.alwaysConsumeMouseWheel:!1,scrollYToX:typeof z.scrollYToX<"u"?z.scrollYToX:!1,mouseWheelScrollSensitivity:typeof z.mouseWheelScrollSensitivity<"u"?z.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof z.fastScrollSensitivity<"u"?z.fastScrollSensitivity:5,scrollPredominantAxis:typeof z.scrollPredominantAxis<"u"?z.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof z.mouseWheelSmoothScroll<"u"?z.mouseWheelSmoothScroll:!0,arrowSize:typeof z.arrowSize<"u"?z.arrowSize:11,listenOnDomNode:typeof z.listenOnDomNode<"u"?z.listenOnDomNode:null,horizontal:typeof z.horizontal<"u"?z.horizontal:1,horizontalScrollbarSize:typeof z.horizontalScrollbarSize<"u"?z.horizontalScrollbarSize:10,horizontalSliderSize:typeof z.horizontalSliderSize<"u"?z.horizontalSliderSize:0,horizontalHasArrows:typeof z.horizontalHasArrows<"u"?z.horizontalHasArrows:!1,vertical:typeof z.vertical<"u"?z.vertical:1,verticalScrollbarSize:typeof z.verticalScrollbarSize<"u"?z.verticalScrollbarSize:10,verticalHasArrows:typeof z.verticalHasArrows<"u"?z.verticalHasArrows:!1,verticalSliderSize:typeof z.verticalSliderSize<"u"?z.verticalSliderSize:0,scrollByPage:typeof z.scrollByPage<"u"?z.scrollByPage:!1};return R.horizontalSliderSize=typeof z.horizontalSliderSize<"u"?z.horizontalSliderSize:R.horizontalScrollbarSize,R.verticalSliderSize=typeof z.verticalSliderSize<"u"?z.verticalSliderSize:R.verticalScrollbarSize,s.$k&&(R.className+=" mac"),R}}),define($e[61],we([1,0,54,3,22,24,60,11,9,26,4,2,47,48,82,118,6]),function(le,t,y,L,i,U,D,A,c,g,f,T,s,a,e,h,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_Q=t.$$Q=t.$0Q=t.$9Q=void 0;const m={CurrentDragAndDropData:void 0},n={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(R){return[R]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class r{get context(){return this.d}set context(d){this.d=d}constructor(d){this.elements=d}update(){}getData(){return this.elements}}t.$9Q=r;class b{constructor(d){this.elements=d}update(){}getData(){return this.elements}}t.$0Q=b;class u{constructor(){this.types=[],this.files=[]}update(d){if(d.types&&this.types.splice(0,this.types.length,...d.types),d.files){this.files.splice(0,this.files.length);for(let E=0;E<d.files.length;E++){const B=d.files.item(E);B&&(B.size||B.type)&&this.files.push(B)}}}getData(){return{types:this.types,files:this.files}}}t.$$Q=u;function o(R,d){return Array.isArray(R)&&Array.isArray(d)?(0,A.$tb)(R,d):R===d}class N{constructor(d){d?.getSetSize?this.getSetSize=d.getSetSize.bind(d):this.getSetSize=(E,B,H)=>H,d?.getPosInSet?this.getPosInSet=d.getPosInSet.bind(d):this.getPosInSet=(E,B)=>B+1,d?.getRole?this.getRole=d.getRole.bind(d):this.getRole=E=>"listitem",d?.isChecked?this.isChecked=d.isChecked.bind(d):this.isChecked=E=>{}}}class z{static{this.c=0}get contentHeight(){return this.g.size}get contentWidth(){return this.E??0}get onDidScroll(){return this.q.onScroll}get onWillScroll(){return this.q.onWillScroll}get containerDomNode(){return this.o}get scrollableElementDomNode(){return this.q.getDomNode()}get P(){return this.O}set P(d){if(d!==this.O){if(d&&this.B)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this.O=d,this.domNode.classList.toggle("horizontal-scrolling",this.O),this.O){for(const E of this.d)this.Y(E);this.V(),this.q.setScrollDimensions({width:(0,L.$hP)(this.domNode)}),this.o.style.width=`${Math.max(this.E||0,this.n)}px`}else this.u.cancel(),this.q.setScrollDimensions({width:this.n,scrollWidth:this.n}),this.o.style.width=""}}constructor(d,E,B,H=n){if(this.Q=E,this.domId=`list_id_${++z.c}`,this.j=new Map,this.n=0,this.s=0,this.t=null,this.u=new c.$Rg(50),this.v=!1,this.x=T.$Rc.None,this.y=0,this.G=!1,this.J=T.$Rc.None,this.K=T.$Rc.None,this.L=new T.$Qc,this.M=new f.$Od,this.N=new f.$Od,this.onDidChangeContentHeight=f.Event.latch(this.M.event,void 0,this.L),this.onDidChangeContentWidth=f.Event.latch(this.N.event,void 0,this.L),this.O=!1,H.horizontalScrolling&&H.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.d=[],this.f=0,this.g=new e.$7Q(H.paddingTop??0);for(const C of B)this.j.set(C.templateId,C);this.h=this.L.add(new h.$8Q(this.j)),this.k=0,this.m=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof H.mouseSupport=="boolean"?H.mouseSupport:!0),this.O=H.horizontalScrolling??n.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this.O),this.C=typeof H.paddingBottom>"u"?0:H.paddingBottom,this.D=new N(H.accessibilityProvider),this.o=document.createElement("div"),this.o.className="monaco-list-rows",(H.transformOptimization??n.transformOptimization)&&(this.o.style.transform="translate3d(0px, 0px, 0px)",this.o.style.overflow="hidden",this.o.style.contain="strict"),this.L.add(U.$rQ.addTarget(this.o)),this.p=this.L.add(new a.$Zr({forceIntegerValues:!0,smoothScrollDuration:H.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:C=>(0,L.$7O)((0,L.$AP)(this.domNode),C)})),this.q=this.L.add(new D.$GQ(this.o,{alwaysConsumeMouseWheel:H.alwaysConsumeMouseWheel??n.alwaysConsumeMouseWheel,horizontal:1,vertical:H.verticalScrollMode??n.verticalScrollMode,useShadows:H.useShadows??n.useShadows,mouseWheelScrollSensitivity:H.mouseWheelScrollSensitivity,fastScrollSensitivity:H.fastScrollSensitivity,scrollByPage:H.scrollByPage},this.p)),this.domNode.appendChild(this.q.getDomNode()),d.appendChild(this.domNode),this.q.onScroll(this.gb,this,this.L),this.L.add((0,L.$YO)(this.o,U.EventType.Change,C=>this.hb(C))),this.L.add((0,L.$YO)(this.q.getDomNode(),"scroll",C=>C.target.scrollTop=0)),this.L.add((0,L.$YO)(this.domNode,"dragover",C=>this.jb(this.fb(C)))),this.L.add((0,L.$YO)(this.domNode,"drop",C=>this.lb(this.fb(C)))),this.L.add((0,L.$YO)(this.domNode,"dragleave",C=>this.kb(this.fb(C)))),this.L.add((0,L.$YO)(this.domNode,"dragend",C=>this.mb(C))),this.z=H.setRowLineHeight??n.setRowLineHeight,this.A=H.setRowHeight??n.setRowHeight,this.B=H.supportDynamicHeights??n.supportDynamicHeights,this.F=H.dnd??this.L.add(n.dnd),this.layout(H.initialSize?.height,H.initialSize?.width)}updateOptions(d){d.paddingBottom!==void 0&&(this.C=d.paddingBottom,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),d.smoothScrolling!==void 0&&this.p.setSmoothScrollDuration(d.smoothScrolling?125:0),d.horizontalScrolling!==void 0&&(this.P=d.horizontalScrolling);let E;if(d.scrollByPage!==void 0&&(E={...E??{},scrollByPage:d.scrollByPage}),d.mouseWheelScrollSensitivity!==void 0&&(E={...E??{},mouseWheelScrollSensitivity:d.mouseWheelScrollSensitivity}),d.fastScrollSensitivity!==void 0&&(E={...E??{},fastScrollSensitivity:d.fastScrollSensitivity}),E&&this.q.updateOptions(E),d.paddingTop!==void 0&&d.paddingTop!==this.g.paddingTop){const B=this.sb(this.k,this.m),H=d.paddingTop-this.g.paddingTop;this.g.paddingTop=d.paddingTop,this.W(B,Math.max(0,this.k+H),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.S(),this.B&&this.tb(this.k,this.m)}}delegateScrollFromMouseWheelEvent(d){this.q.delegateScrollFromMouseWheelEvent(d)}delegateVerticalScrollbarPointerDown(d){this.q.delegateVerticalScrollbarPointerDown(d)}updateElementHeight(d,E,B){if(d<0||d>=this.d.length)return;const H=this.d[d].size;if(typeof E>"u"){if(!this.B){console.warn("Dynamic heights not supported");return}this.d[d].lastDynamicHeightWidth=void 0,E=H+this.ub(d)}if(H===E)return;const x=this.sb(this.k,this.m);let C=0;d<x.start||B!==null&&B>d&&B<x.end?C=E-H:C=0,this.g.splice(d,1,[{size:E}]),this.d[d].size=E,this.W(x,Math.max(0,this.k+C),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.S(),this.B&&this.tb(this.k,this.m)}splice(d,E,B=[]){if(this.v)throw new Error("Can't run recursive splices.");this.v=!0;try{return this.R(d,E,B)}finally{this.v=!1,this.M.fire(this.contentHeight)}}R(d,E,B=[]){const H=this.sb(this.k,this.m),x={start:d,end:d+E},C=s.Range.intersect(H,x),F=new Map;for(let q=C.end-1;q>=C.start;q--){const G=this.d[q];if(G.dragStartDisposable.dispose(),G.checkedDisposable.dispose(),G.row){let P=F.get(G.templateId);P||(P=[],F.set(G.templateId,P));const V=this.j.get(G.templateId);V&&V.disposeElement&&V.disposeElement(G.element,q,G.row.templateData,G.size),P.push(G.row)}G.row=null}const Q={start:d+E,end:this.d.length},te=s.Range.intersect(Q,H),re=s.Range.relativeComplement(Q,H),fe=B.map(q=>({id:String(this.f++),element:q,templateId:this.Q.getTemplateId(q),size:this.Q.getHeight(q),width:void 0,hasDynamicHeight:!!this.Q.hasDynamicHeight&&this.Q.hasDynamicHeight(q),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:T.$Rc.None,checkedDisposable:T.$Rc.None}));let ie;d===0&&E>=this.d.length?(this.g=new e.$7Q(this.g.paddingTop),this.g.splice(0,0,fe),ie=this.d,this.d=fe):(this.g.splice(d,E,fe),ie=this.d.splice(d,E,...fe));const oe=B.length-E,be=this.sb(this.k,this.m),Se=(0,e.$5Q)(te,oe),Le=s.Range.intersect(be,Se);for(let q=Le.start;q<Le.end;q++)this.Z(this.d[q],q);const Fe=s.Range.relativeComplement(Se,be);for(const q of Fe)for(let G=q.start;G<q.end;G++)this.ab(G);const de=re.map(q=>(0,e.$5Q)(q,oe)),ce=[{start:d,end:d+B.length},...de].map(q=>s.Range.intersect(be,q)),X=this.vb(ce);for(const q of ce)for(let G=q.start;G<q.end;G++){const P=this.d[G],p=F.get(P.templateId)?.pop();this.X(G,X,p)}for(const q of F.values())for(const G of q)this.h.release(G);return this.S(),this.B&&this.tb(this.scrollTop,this.renderHeight),ie.map(q=>q.element)}S(){this.s=this.contentHeight,this.o.style.height=`${this.s}px`,this.t||(this.t=(0,L.$7O)((0,L.$AP)(this.domNode),()=>{this.q.setScrollDimensions({scrollHeight:this.scrollHeight}),this.V(),this.t=null}))}U(){if(!this.P){this.u.cancel();return}this.u.trigger(()=>this.V())}V(){if(!this.P)return;let d=0;for(const E of this.d)typeof E.width<"u"&&(d=Math.max(d,E.width));this.E=d,this.q.setScrollDimensions({scrollWidth:d===0?0:d+10}),this.N.fire(this.E)}updateWidth(d){if(!this.P||typeof this.E>"u")return;const E=this.d[d];this.Y(E),typeof E.width<"u"&&E.width>this.E&&(this.E=E.width,this.q.setScrollDimensions({scrollWidth:this.E+10}),this.N.fire(this.E))}rerender(){if(this.B){for(const d of this.d)d.lastDynamicHeightWidth=void 0;this.tb(this.k,this.m)}}get length(){return this.d.length}get renderHeight(){return this.q.getScrollDimensions().height}get firstVisibleIndex(){const d=this.sb(this.k,this.m),E=this.g.positionAt(d.start),B=this.g.positionAt(d.start+1);return B!==-1&&(B-E)/2+E<this.scrollTop?d.start+1:d.start}get lastVisibleIndex(){return this.sb(this.k,this.m).end-1}element(d){return this.d[d].element}indexOf(d){return this.d.findIndex(E=>E.element===d)}domElement(d){const E=this.d[d].row;return E&&E.domNode}elementHeight(d){return this.d[d].size}elementTop(d){return this.g.positionAt(d)}indexAt(d){return this.g.indexAt(d)}indexAfter(d){return this.g.indexAfter(d)}layout(d,E){const B={height:typeof d=="number"?d:(0,L.$jP)(this.domNode)};this.t&&(this.t.dispose(),this.t=null,B.scrollHeight=this.scrollHeight),this.q.setScrollDimensions(B),typeof E<"u"&&(this.n=E,this.B&&this.tb(this.scrollTop,this.renderHeight)),this.P&&this.q.setScrollDimensions({width:typeof E=="number"?E:(0,L.$hP)(this.domNode)})}W(d,E,B,H,x,C=!1){const F=this.sb(E,B),Q=s.Range.relativeComplement(F,d),te=s.Range.relativeComplement(d,F),re=this.vb(Q);if(C){const fe=s.Range.intersect(d,F);for(let ie=fe.start;ie<fe.end;ie++)this.Z(this.d[ie],ie)}this.h.transact(()=>{for(const fe of te)for(let ie=fe.start;ie<fe.end;ie++)this.ab(ie);for(const fe of Q)for(let ie=fe.start;ie<fe.end;ie++)this.X(ie,re)}),H!==void 0&&(this.o.style.left=`-${H}px`),this.o.style.top=`-${E}px`,this.P&&x!==void 0&&(this.o.style.width=`${Math.max(x,this.n)}px`),this.k=E,this.m=B}X(d,E,B){const H=this.d[d];let x=!1;if(!H.row)if(B)H.row=B;else{const re=this.h.alloc(H.templateId);H.row=re.row,x=re.isReusingConnectedDomNode}const C=this.D.getRole(H.element)||"listitem";H.row.domNode.setAttribute("role",C);const F=this.D.isChecked(H.element);if(typeof F=="boolean")H.row.domNode.setAttribute("aria-checked",String(!!F));else if(F){const re=fe=>H.row.domNode.setAttribute("aria-checked",String(!!fe));re(F.value),H.checkedDisposable=F.onDidChange(re)}(x||!H.row.domNode.parentElement)&&(E?this.o.insertBefore(H.row.domNode,E):this.o.appendChild(H.row.domNode)),this.Z(H,d);const Q=this.j.get(H.templateId);if(!Q)throw new Error(`No renderer found for template id ${H.templateId}`);Q?.renderElement(H.element,d,H.row.templateData,H.size);const te=this.F.getDragURI(H.element);H.dragStartDisposable.dispose(),H.row.domNode.draggable=!!te,te&&(H.dragStartDisposable=(0,L.$YO)(H.row.domNode,"dragstart",re=>this.ib(H.element,te,re))),this.P&&(this.Y(H),this.U())}Y(d){if(!d.row||!d.row.domNode)return;d.row.domNode.style.width="fit-content",d.width=(0,L.$hP)(d.row.domNode);const E=(0,L.$AP)(d.row.domNode).getComputedStyle(d.row.domNode);E.paddingLeft&&(d.width+=parseFloat(E.paddingLeft)),E.paddingRight&&(d.width+=parseFloat(E.paddingRight)),d.row.domNode.style.width=""}Z(d,E){d.row.domNode.style.top=`${this.elementTop(E)}px`,this.A&&(d.row.domNode.style.height=`${d.size}px`),this.z&&(d.row.domNode.style.lineHeight=`${d.size}px`),d.row.domNode.setAttribute("data-index",`${E}`),d.row.domNode.setAttribute("data-last-element",E===this.length-1?"true":"false"),d.row.domNode.setAttribute("data-parity",E%2===0?"even":"odd"),d.row.domNode.setAttribute("aria-setsize",String(this.D.getSetSize(d.element,E,this.length))),d.row.domNode.setAttribute("aria-posinset",String(this.D.getPosInSet(d.element,E))),d.row.domNode.setAttribute("id",this.getElementDomId(E)),d.row.domNode.classList.toggle("drop-target",d.dropTarget)}ab(d){const E=this.d[d];if(E.dragStartDisposable.dispose(),E.checkedDisposable.dispose(),E.row){const B=this.j.get(E.templateId);B&&B.disposeElement&&B.disposeElement(E.element,d,E.row.templateData,E.size),this.h.release(E.row),E.row=null}this.P&&this.U()}getScrollTop(){return this.q.getScrollPosition().scrollTop}setScrollTop(d,E){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),this.q.setScrollPosition({scrollTop:d,reuseAnimation:E})}getScrollLeft(){return this.q.getScrollPosition().scrollLeft}setScrollLeft(d){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollWidth:this.E})),this.q.setScrollPosition({scrollLeft:d})}get scrollTop(){return this.getScrollTop()}set scrollTop(d){this.setScrollTop(d)}get scrollHeight(){return this.s+(this.P?10:0)+this.C}get onMouseClick(){return f.Event.map(this.L.add(new i.$VQ(this.domNode,"click")).event,d=>this.bb(d),this.L)}get onMouseDblClick(){return f.Event.map(this.L.add(new i.$VQ(this.domNode,"dblclick")).event,d=>this.bb(d),this.L)}get onMouseMiddleClick(){return f.Event.filter(f.Event.map(this.L.add(new i.$VQ(this.domNode,"auxclick")).event,d=>this.bb(d),this.L),d=>d.browserEvent.button===1,this.L)}get onMouseUp(){return f.Event.map(this.L.add(new i.$VQ(this.domNode,"mouseup")).event,d=>this.bb(d),this.L)}get onMouseDown(){return f.Event.map(this.L.add(new i.$VQ(this.domNode,"mousedown")).event,d=>this.bb(d),this.L)}get onMouseOver(){return f.Event.map(this.L.add(new i.$VQ(this.domNode,"mouseover")).event,d=>this.bb(d),this.L)}get onMouseMove(){return f.Event.map(this.L.add(new i.$VQ(this.domNode,"mousemove")).event,d=>this.bb(d),this.L)}get onMouseOut(){return f.Event.map(this.L.add(new i.$VQ(this.domNode,"mouseout")).event,d=>this.bb(d),this.L)}get onContextMenu(){return f.Event.any(f.Event.map(this.L.add(new i.$VQ(this.domNode,"contextmenu")).event,d=>this.bb(d),this.L),f.Event.map(this.L.add(new i.$VQ(this.domNode,U.EventType.Contextmenu)).event,d=>this.eb(d),this.L))}get onTouchStart(){return f.Event.map(this.L.add(new i.$VQ(this.domNode,"touchstart")).event,d=>this.db(d),this.L)}get onTap(){return f.Event.map(this.L.add(new i.$VQ(this.o,U.EventType.Tap)).event,d=>this.eb(d),this.L)}bb(d){const E=this.rb(d.target||null),B=typeof E>"u"?void 0:this.d[E],H=B&&B.element;return{browserEvent:d,index:E,element:H}}db(d){const E=this.rb(d.target||null),B=typeof E>"u"?void 0:this.d[E],H=B&&B.element;return{browserEvent:d,index:E,element:H}}eb(d){const E=this.rb(d.initialTarget||null),B=typeof E>"u"?void 0:this.d[E],H=B&&B.element;return{browserEvent:d,index:E,element:H}}fb(d){const E=this.rb(d.target||null),B=typeof E>"u"?void 0:this.d[E],H=B&&B.element;return{browserEvent:d,index:E,element:H}}gb(d){try{const E=this.sb(this.k,this.m);this.W(E,d.scrollTop,d.height,d.scrollLeft,d.scrollWidth),this.B&&this.tb(d.scrollTop,d.height,d.inSmoothScrolling)}catch(E){throw console.error("Got bad scroll event:",d),E}}hb(d){d.preventDefault(),d.stopPropagation(),this.scrollTop-=d.translationY}ib(d,E,B){if(!B.dataTransfer)return;const H=this.F.getDragElements(d);if(B.dataTransfer.effectAllowed="copyMove",B.dataTransfer.setData(y.$pQ.TEXT,E),B.dataTransfer.setDragImage){let x;this.F.getDragLabel&&(x=this.F.getDragLabel(H,B)),typeof x>"u"&&(x=String(H.length));const C=(0,L.$)(".monaco-drag-image");C.textContent=x;const Q=(te=>{for(;te&&!te.classList.contains("monaco-workbench");)te=te.parentElement;return te||this.domNode.ownerDocument})(this.domNode);Q.appendChild(C),B.dataTransfer.setDragImage(C,-10,-10),setTimeout(()=>Q.removeChild(C),0)}this.domNode.classList.add("dragging"),this.H=new r(H),m.CurrentDragAndDropData=new b(H),this.F.onDragStart?.(this.H,B)}jb(d){if(d.browserEvent.preventDefault(),this.K.dispose(),m.CurrentDragAndDropData&&m.CurrentDragAndDropData.getData()==="vscode-ui"||(this.ob(d.browserEvent),!d.browserEvent.dataTransfer))return!1;if(!this.H)if(m.CurrentDragAndDropData)this.H=m.CurrentDragAndDropData;else{if(!d.browserEvent.dataTransfer.types)return!1;this.H=new u}const E=this.F.onDragOver(this.H,d.element,d.index,d.browserEvent);if(this.G=typeof E=="boolean"?E:E.accept,!this.G)return this.I=void 0,this.J.dispose(),!1;d.browserEvent.dataTransfer.dropEffect=typeof E!="boolean"&&E.effect===0?"copy":"move";let B;if(typeof E!="boolean"&&E.feedback?B=E.feedback:typeof d.index>"u"?B=[-1]:B=[d.index],B=(0,A.$Lb)(B).filter(H=>H>=-1&&H<this.length).sort((H,x)=>H-x),B=B[0]===-1?[-1]:B,o(this.I,B))return!0;if(this.I=B,this.J.dispose(),B[0]===-1)this.domNode.classList.add("drop-target"),this.o.classList.add("drop-target"),this.J=(0,T.$Pc)(()=>{this.domNode.classList.remove("drop-target"),this.o.classList.remove("drop-target")});else{for(const H of B){const x=this.d[H];x.dropTarget=!0,x.row?.domNode.classList.add("drop-target")}this.J=(0,T.$Pc)(()=>{for(const H of B){const x=this.d[H];x.dropTarget=!1,x.row?.domNode.classList.remove("drop-target")}})}return!0}kb(d){this.K.dispose(),this.K=(0,c.$Wg)(()=>this.nb(),100,this.L),this.H&&this.F.onDragLeave?.(this.H,d.element,d.index,d.browserEvent)}lb(d){if(!this.G)return;const E=this.H;this.qb(),this.nb(),this.domNode.classList.remove("dragging"),this.H=void 0,m.CurrentDragAndDropData=void 0,!(!E||!d.browserEvent.dataTransfer)&&(d.browserEvent.preventDefault(),E.update(d.browserEvent.dataTransfer),this.F.drop(E,d.element,d.index,d.browserEvent))}mb(d){this.G=!1,this.qb(),this.nb(),this.domNode.classList.remove("dragging"),this.H=void 0,m.CurrentDragAndDropData=void 0,this.F.onDragEnd?.(d)}nb(){this.I=void 0,this.J.dispose(),this.J=T.$Rc.None}ob(d){if(!this.w){const E=(0,L.$bP)(this.domNode).top;this.w=(0,L.$0P)((0,L.$AP)(this.domNode),this.pb.bind(this,E))}this.x.dispose(),this.x=(0,c.$Wg)(()=>{this.w&&(this.w.dispose(),this.w=void 0)},1e3,this.L),this.y=d.pageY}pb(d){if(this.y===void 0)return;const E=this.y-d,B=this.renderHeight-35;E<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(E-35))):E>B&&(this.scrollTop+=Math.min(14,Math.floor(.3*(E-B))))}qb(){this.x.dispose(),this.w&&(this.w.dispose(),this.w=void 0)}rb(d){const E=this.q.getDomNode();let B=d;for(;B instanceof HTMLElement&&B!==this.o&&E.contains(B);){const H=B.getAttribute("data-index");if(H){const x=Number(H);if(!isNaN(x))return x}B=B.parentElement}}sb(d,E){return{start:this.g.indexAt(d),end:this.g.indexAfter(d+E-1)}}tb(d,E,B){const H=this.sb(d,E);let x,C;d===this.elementTop(H.start)?(x=H.start,C=0):H.end-H.start>1&&(x=H.start+1,C=this.elementTop(x)-d);let F=0;for(;;){const Q=this.sb(d,E);let te=!1;for(let re=Q.start;re<Q.end;re++){const fe=this.ub(re);fe!==0&&this.g.splice(re,1,[this.d[re]]),F+=fe,te=te||fe!==0}if(!te){F!==0&&this.S();const re=s.Range.relativeComplement(H,Q);for(const ie of re)for(let oe=ie.start;oe<ie.end;oe++)this.d[oe].row&&this.ab(oe);const fe=s.Range.relativeComplement(Q,H);for(const ie of fe)for(let oe=ie.start;oe<ie.end;oe++){const be=oe+1,Se=be<this.d.length?this.d[be].row:null,Le=Se?Se.domNode:null;this.X(oe,Le)}for(let ie=Q.start;ie<Q.end;ie++)this.d[ie].row&&this.Z(this.d[ie],ie);if(typeof x=="number"){const ie=this.p.getFutureScrollPosition().scrollTop-d,oe=this.elementTop(x)-C+ie;this.setScrollTop(oe,B)}this.M.fire(this.contentHeight);return}}}ub(d){const E=this.d[d];if(this.Q.getDynamicHeight){const C=this.Q.getDynamicHeight(E.element);if(C!==null){const F=E.size;return E.size=C,E.lastDynamicHeightWidth=this.n,C-F}}if(!E.hasDynamicHeight||E.lastDynamicHeightWidth===this.n||this.Q.hasDynamicHeight&&!this.Q.hasDynamicHeight(E.element))return 0;const B=E.size;if(E.row)return E.row.domNode.style.height="",E.size=E.row.domNode.offsetHeight,E.lastDynamicHeightWidth=this.n,E.size-B;const{row:H}=this.h.alloc(E.templateId);H.domNode.style.height="",this.o.appendChild(H.domNode);const x=this.j.get(E.templateId);if(!x)throw new l.$bb("Missing renderer for templateId: "+E.templateId);return x.renderElement(E.element,d,H.templateData,void 0),E.size=H.domNode.offsetHeight,x.disposeElement?.(E.element,d,H.templateData,void 0),this.Q.setDynamicHeight?.(E.element,E.size),E.lastDynamicHeightWidth=this.n,this.o.removeChild(H.domNode),this.h.release(H),E.size-B}vb(d){const E=d[d.length-1];if(!E)return null;const B=this.d[E.end];return!B||!B.row?null:B.row.domNode}getElementDomId(d){return`${this.domId}_${d}`}dispose(){for(const d of this.d)if(d.dragStartDisposable.dispose(),d.checkedDisposable.dispose(),d.row){const E=this.j.get(d.row.templateId);E&&(E.disposeElement?.(d.element,-1,d.row.templateData,void 0),E.disposeTemplate(d.row.templateData))}this.d=[],this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),this.w?.dispose(),this.L.dispose()}}t.$_Q=z,Xe([g.$lh],z.prototype,"onMouseClick",null),Xe([g.$lh],z.prototype,"onMouseDblClick",null),Xe([g.$lh],z.prototype,"onMouseMiddleClick",null),Xe([g.$lh],z.prototype,"onMouseUp",null),Xe([g.$lh],z.prototype,"onMouseDown",null),Xe([g.$lh],z.prototype,"onMouseOver",null),Xe([g.$lh],z.prototype,"onMouseMove",null),Xe([g.$lh],z.prototype,"onMouseOut",null),Xe([g.$lh],z.prototype,"onContextMenu",null),Xe([g.$lh],z.prototype,"onTouchStart",null),Xe([g.$lh],z.prototype,"onTap",null)}),define($e[39],we([1,0,3,22,15,24,57,70,11,9,74,26,4,34,2,46,5,7,69,61,20,96]),function(le,t,y,L,i,U,D,A,c,g,f,T,s,a,e,h,l,m,n,r,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jR=t.$iR=t.$hR=t.$gR=t.$fR=t.$eR=t.$dR=t.TypeNavigationMode=t.$cR=t.$bR=t.$aR=void 0;class u{constructor(P){this.d=P,this.c=[]}get templateId(){return`template:${this.d.name}`}renderTemplate(P){return P}renderElement(P,V,p){const W=this.c.findIndex(J=>J.templateData===p);if(W>=0){const J=this.c[W];this.d.unrender(p),J.index=V}else{const J={index:V,templateData:p};this.c.push(J)}this.d.renderIndex(V,p)}splice(P,V,p){const W=[];for(const J of this.c)J.index<P?W.push(J):J.index>=P+V&&W.push({index:J.index+p-V,templateData:J.templateData});this.c=W}renderIndexes(P){for(const{index:V,templateData:p}of this.c)P.indexOf(V)>-1&&this.d.renderIndex(V,p)}disposeTemplate(P){const V=this.c.findIndex(p=>p.templateData===P);V<0||this.c.splice(V,1)}}class o{get name(){return this.h}get renderer(){return new u(this)}constructor(P){this.h=P,this.c=0,this.d=[],this.f=[],this.g=new s.$Od,this.onChange=this.g.event}splice(P,V,p){V=Math.max(0,Math.min(V,this.c-P));const W=p.length-V,J=P+V,M=[];let $=0;for(;$<this.f.length&&this.f[$]<P;)M.push(this.f[$++]);for(let I=0;I<p.length;I++)p[I]&&M.push(I+P);for(;$<this.f.length&&this.f[$]>=J;)M.push(this.f[$++]+W);const w=this.c+W;if(this.f.length>0&&M.length===0&&w>0){const I=this.f.find(v=>v>=P)??w-1;M.push(Math.min(I,w-1))}this.renderer.splice(P,V,p.length),this.k(M,M),this.c=w}renderIndex(P,V){V.classList.toggle(this.h,this.contains(P))}unrender(P){P.classList.remove(this.h)}set(P,V){return this.k(P,[...P].sort(de),V)}k(P,V,p){const W=this.d,J=this.f;this.d=P,this.f=V;const M=Le(J,P);return this.renderer.renderIndexes(M),this.g.fire({indexes:P,browserEvent:p}),W}get(){return this.d}contains(P){return(0,c.$vb)(this.f,P,de)>=0}dispose(){(0,e.$Mc)(this.g)}}Xe([T.$lh],o.prototype,"renderer",null);class N extends o{constructor(P){super("selected"),this.l=P}renderIndex(P,V){super.renderIndex(P,V),this.l&&(this.contains(P)?V.setAttribute("aria-selected","true"):V.setAttribute("aria-selected","false"))}}class z{constructor(P,V,p){this.c=P,this.d=V,this.f=p}splice(P,V,p){if(!this.f)return this.c.splice(P,V,new Array(p.length).fill(!1));const W=this.c.get().map($=>this.f.getId(this.d.element($)).toString());if(W.length===0)return this.c.splice(P,V,new Array(p.length).fill(!1));const J=new Set(W),M=p.map($=>J.has(this.f.getId($).toString()));this.c.splice(P,V,M)}}function R(G){return G.tagName==="INPUT"||G.tagName==="TEXTAREA"}t.$aR=R;function d(G){return G.classList.contains("monaco-editor")?!0:G.classList.contains("monaco-list")||!G.parentElement?!1:d(G.parentElement)}t.$bR=d;function E(G){return G.tagName==="A"&&G.classList.contains("monaco-button")||G.tagName==="DIV"&&G.classList.contains("monaco-button-dropdown")?!0:G.classList.contains("monaco-list")||!G.parentElement?!1:E(G.parentElement)}t.$cR=E;class B{get g(){return s.Event.chain(this.c.add(new L.$VQ(this.k.domNode,"keydown")).event,P=>P.filter(V=>!R(V.target)).map(V=>new i.$VO(V)))}constructor(P,V,p){this.h=P,this.k=V,this.c=new e.$Qc,this.d=new e.$Qc,this.f=p.multipleSelectionSupport,this.c.add(this.g(W=>{switch(W.keyCode){case 3:return this.l(W);case 16:return this.o(W);case 18:return this.p(W);case 11:return this.q(W);case 12:return this.s(W);case 9:return this.u(W);case 31:this.f&&(l.$k?W.metaKey:W.ctrlKey)&&this.t(W)}}))}updateOptions(P){P.multipleSelectionSupport!==void 0&&(this.f=P.multipleSelectionSupport)}l(P){P.preventDefault(),P.stopPropagation(),this.h.setSelection(this.h.getFocus(),P.browserEvent)}o(P){P.preventDefault(),P.stopPropagation(),this.h.focusPrevious(1,!1,P.browserEvent);const V=this.h.getFocus()[0];this.h.setAnchor(V),this.h.reveal(V),this.k.domNode.focus()}p(P){P.preventDefault(),P.stopPropagation(),this.h.focusNext(1,!1,P.browserEvent);const V=this.h.getFocus()[0];this.h.setAnchor(V),this.h.reveal(V),this.k.domNode.focus()}q(P){P.preventDefault(),P.stopPropagation(),this.h.focusPreviousPage(P.browserEvent);const V=this.h.getFocus()[0];this.h.setAnchor(V),this.h.reveal(V),this.k.domNode.focus()}s(P){P.preventDefault(),P.stopPropagation(),this.h.focusNextPage(P.browserEvent);const V=this.h.getFocus()[0];this.h.setAnchor(V),this.h.reveal(V),this.k.domNode.focus()}t(P){P.preventDefault(),P.stopPropagation(),this.h.setSelection((0,c.$Rb)(this.h.length),P.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus()}u(P){this.h.getSelection().length&&(P.preventDefault(),P.stopPropagation(),this.h.setSelection([],P.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus())}dispose(){this.c.dispose(),this.d.dispose()}}Xe([T.$lh],B.prototype,"g",null);var H;(function(G){G[G.Automatic=0]="Automatic",G[G.Trigger=1]="Trigger"})(H||(t.TypeNavigationMode=H={}));var x;(function(G){G[G.Idle=0]="Idle",G[G.Typing=1]="Typing"})(x||(x={})),t.$dR=new class{mightProducePrintableCharacter(G){return G.ctrlKey||G.metaKey||G.altKey?!1:G.keyCode>=31&&G.keyCode<=56||G.keyCode>=21&&G.keyCode<=30||G.keyCode>=98&&G.keyCode<=107||G.keyCode>=85&&G.keyCode<=95}};class C{constructor(P,V,p,W,J){this.o=P,this.p=V,this.q=p,this.s=W,this.t=J,this.c=!1,this.d=x.Idle,this.f=H.Automatic,this.g=!1,this.h=-1,this.k=new e.$Qc,this.l=new e.$Qc,this.updateOptions(P.options)}updateOptions(P){P.typeNavigationEnabled??!0?this.u():this.v(),this.f=P.typeNavigationMode??H.Automatic}trigger(){this.g=!this.g}u(){if(this.c)return;let P=!1;const V=s.Event.chain(this.k.add(new L.$VQ(this.p.domNode,"keydown")).event,J=>J.filter(M=>!R(M.target)).filter(()=>this.f===H.Automatic||this.g).map(M=>new i.$VO(M)).filter(M=>P||this.s(M)).filter(M=>this.t.mightProducePrintableCharacter(M)).forEach(M=>y.$PP.stop(M,!0)).map(M=>M.browserEvent.key)),p=s.Event.debounce(V,()=>null,800,void 0,void 0,void 0,this.k);s.Event.reduce(s.Event.any(V,p),(J,M)=>M===null?null:(J||"")+M,void 0,this.k)(this.x,this,this.k),p(this.w,this,this.k),V(()=>P=!0,void 0,this.k),p(()=>P=!1,void 0,this.k),this.c=!0,this.g=!1}v(){this.c&&(this.k.clear(),this.c=!1,this.g=!1)}w(){const P=this.o.getFocus();if(P.length>0&&P[0]===this.h){const V=this.o.options.accessibilityProvider?.getAriaLabel(this.o.element(P[0]));V&&(0,D.$XQ)(V)}this.h=-1}x(P){if(!P){this.d=x.Idle,this.g=!1;return}const V=this.o.getFocus(),p=V.length>0?V[0]:0,W=this.d===x.Idle?1:0;this.d=x.Typing;for(let J=0;J<this.o.length;J++){const M=(p+J+W)%this.o.length,$=this.q.getKeyboardNavigationLabel(this.p.element(M)),w=$&&$.toString();if(this.o.options.typeNavigationEnabled){if(typeof w<"u"){if((0,a.$Hj)(P,w)){this.h=p,this.o.setFocus([M]),this.o.reveal(M);return}const I=(0,a.$Oj)(P,w);if(I&&I[0].end-I[0].start>1&&I.length===1){this.h=p,this.o.setFocus([M]),this.o.reveal(M);return}}}else if(typeof w>"u"||(0,a.$Hj)(P,w)){this.h=p,this.o.setFocus([M]),this.o.reveal(M);return}}}dispose(){this.v(),this.k.dispose(),this.l.dispose()}}class F{constructor(P,V){this.d=P,this.f=V,this.c=new e.$Qc;const p=s.Event.chain(this.c.add(new L.$VQ(V.domNode,"keydown")).event,J=>J.filter(M=>!R(M.target)).map(M=>new i.$VO(M)));s.Event.chain(p,J=>J.filter(M=>M.keyCode===2&&!M.ctrlKey&&!M.metaKey&&!M.shiftKey&&!M.altKey))(this.g,this,this.c)}g(P){if(P.target!==this.f.domNode)return;const V=this.d.getFocus();if(V.length===0)return;const p=this.f.domElement(V[0]);if(!p)return;const W=p.querySelector("[tabIndex]");if(!W||!(W instanceof HTMLElement)||W.tabIndex===-1)return;const J=(0,y.$AP)(W).getComputedStyle(W);J.visibility==="hidden"||J.display==="none"||(P.preventDefault(),P.stopPropagation(),W.focus())}dispose(){this.c.dispose()}}function Q(G){return l.$k?G.browserEvent.metaKey:G.browserEvent.ctrlKey}t.$eR=Q;function te(G){return G.browserEvent.shiftKey}t.$fR=te;function re(G){return(0,y.$JP)(G)&&G.button===2}const fe={isSelectionSingleChangeEvent:Q,isSelectionRangeChangeEvent:te};class ie{constructor(P){this.k=P,this.f=new e.$Qc,this.g=new s.$Od,this.onPointer=this.g.event,P.options.multipleSelectionSupport!==!1&&(this.c=this.k.options.multipleSelectionController||fe),this.d=typeof P.options.mouseSupport>"u"||!!P.options.mouseSupport,this.d&&(P.onMouseDown(this.s,this,this.f),P.onContextMenu(this.t,this,this.f),P.onMouseDblClick(this.v,this,this.f),P.onTouchStart(this.s,this,this.f),this.f.add(U.$rQ.addTarget(P.getHTMLElement()))),s.Event.any(P.onMouseClick,P.onMouseMiddleClick,P.onTap)(this.u,this,this.f)}updateOptions(P){P.multipleSelectionSupport!==void 0&&(this.c=void 0,P.multipleSelectionSupport&&(this.c=this.k.options.multipleSelectionController||fe))}o(P){return this.c?this.c.isSelectionSingleChangeEvent(P):!1}p(P){return this.c?this.c.isSelectionRangeChangeEvent(P):!1}q(P){return this.o(P)||this.p(P)}s(P){d(P.browserEvent.target)||(0,y.$uP)()!==P.browserEvent.target&&this.k.domFocus()}t(P){if(R(P.browserEvent.target)||d(P.browserEvent.target))return;const V=typeof P.index>"u"?[]:[P.index];this.k.setFocus(V,P.browserEvent)}u(P){if(!this.d||R(P.browserEvent.target)||d(P.browserEvent.target)||P.browserEvent.isHandledByList)return;P.browserEvent.isHandledByList=!0;const V=P.index;if(typeof V>"u"){this.k.setFocus([],P.browserEvent),this.k.setSelection([],P.browserEvent),this.k.setAnchor(void 0);return}if(this.q(P))return this.w(P);this.k.setFocus([V],P.browserEvent),this.k.setAnchor(V),re(P.browserEvent)||this.k.setSelection([V],P.browserEvent),this.g.fire(P)}v(P){if(R(P.browserEvent.target)||d(P.browserEvent.target)||this.q(P)||P.browserEvent.isHandledByList)return;P.browserEvent.isHandledByList=!0;const V=this.k.getFocus();this.k.setSelection(V,P.browserEvent)}w(P){const V=P.index;let p=this.k.getAnchor();if(this.p(P)){typeof p>"u"&&(p=this.k.getFocus()[0]??V,this.k.setAnchor(p));const W=Math.min(p,V),J=Math.max(p,V),M=(0,c.$Rb)(W,J+1),$=this.k.getSelection(),w=Se(Le($,[p]),p);if(w.length===0)return;const I=Le(M,Fe($,w));this.k.setSelection(I,P.browserEvent),this.k.setFocus([V],P.browserEvent)}else if(this.o(P)){const W=this.k.getSelection(),J=W.filter(M=>M!==V);this.k.setFocus([V]),this.k.setAnchor(V),W.length===J.length?this.k.setSelection([...J,V],P.browserEvent):this.k.setSelection(J,P.browserEvent)}}dispose(){this.f.dispose()}}t.$gR=ie;class oe{constructor(P,V){this.c=P,this.d=V}style(P){const V=this.d&&`.${this.d}`,p=[];P.listBackground&&p.push(`.monaco-list${V} .monaco-list-rows { background: ${P.listBackground}; }`),P.listFocusBackground&&(p.push(`.monaco-list${V}:focus .monaco-list-row.focused { background-color: ${P.listFocusBackground}; }`),p.push(`.monaco-list${V}:focus .monaco-list-row.focused:hover { background-color: ${P.listFocusBackground}; }`)),P.listFocusForeground&&p.push(`.monaco-list${V}:focus .monaco-list-row.focused { color: ${P.listFocusForeground}; }`),P.listActiveSelectionBackground&&(p.push(`.monaco-list${V}:focus .monaco-list-row.selected { background-color: ${P.listActiveSelectionBackground}; }`),p.push(`.monaco-list${V}:focus .monaco-list-row.selected:hover { background-color: ${P.listActiveSelectionBackground}; }`)),P.listActiveSelectionForeground&&p.push(`.monaco-list${V}:focus .monaco-list-row.selected { color: ${P.listActiveSelectionForeground}; }`),P.listActiveSelectionIconForeground&&p.push(`.monaco-list${V}:focus .monaco-list-row.selected .codicon { color: ${P.listActiveSelectionIconForeground}; }`),P.listFocusAndSelectionBackground&&p.push(`
				.monaco-drag-image,
				.monaco-list${V}:focus .monaco-list-row.selected.focused { background-color: ${P.listFocusAndSelectionBackground}; }
			`),P.listFocusAndSelectionForeground&&p.push(`
				.monaco-drag-image,
				.monaco-list${V}:focus .monaco-list-row.selected.focused { color: ${P.listFocusAndSelectionForeground}; }
			`),P.listInactiveFocusForeground&&(p.push(`.monaco-list${V} .monaco-list-row.focused { color:  ${P.listInactiveFocusForeground}; }`),p.push(`.monaco-list${V} .monaco-list-row.focused:hover { color:  ${P.listInactiveFocusForeground}; }`)),P.listInactiveSelectionIconForeground&&p.push(`.monaco-list${V} .monaco-list-row.focused .codicon { color:  ${P.listInactiveSelectionIconForeground}; }`),P.listInactiveFocusBackground&&(p.push(`.monaco-list${V} .monaco-list-row.focused { background-color:  ${P.listInactiveFocusBackground}; }`),p.push(`.monaco-list${V} .monaco-list-row.focused:hover { background-color:  ${P.listInactiveFocusBackground}; }`)),P.listInactiveSelectionBackground&&(p.push(`.monaco-list${V} .monaco-list-row.selected { background-color:  ${P.listInactiveSelectionBackground}; }`),p.push(`.monaco-list${V} .monaco-list-row.selected:hover { background-color:  ${P.listInactiveSelectionBackground}; }`)),P.listInactiveSelectionForeground&&p.push(`.monaco-list${V} .monaco-list-row.selected { color: ${P.listInactiveSelectionForeground}; }`),P.listHoverBackground&&p.push(`.monaco-list${V}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${P.listHoverBackground}; }`),P.listHoverForeground&&p.push(`.monaco-list${V}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${P.listHoverForeground}; }`);const W=(0,y.$aQ)(P.listFocusAndSelectionOutline,(0,y.$aQ)(P.listSelectionOutline,P.listFocusOutline??""));W&&p.push(`.monaco-list${V}:focus .monaco-list-row.focused.selected { outline: 1px solid ${W}; outline-offset: -1px;}`),P.listFocusOutline&&p.push(`
				.monaco-drag-image,
				.monaco-list${V}:focus .monaco-list-row.focused { outline: 1px solid ${P.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${V}.last-focused .monaco-list-row.focused { outline: 1px solid ${P.listFocusOutline}; outline-offset: -1px; }
			`);const J=(0,y.$aQ)(P.listSelectionOutline,P.listInactiveFocusOutline??"");J&&p.push(`.monaco-list${V} .monaco-list-row.focused.selected { outline: 1px dotted ${J}; outline-offset: -1px; }`),P.listSelectionOutline&&p.push(`.monaco-list${V} .monaco-list-row.selected { outline: 1px dotted ${P.listSelectionOutline}; outline-offset: -1px; }`),P.listInactiveFocusOutline&&p.push(`.monaco-list${V} .monaco-list-row.focused { outline: 1px dotted ${P.listInactiveFocusOutline}; outline-offset: -1px; }`),P.listHoverOutline&&p.push(`.monaco-list${V} .monaco-list-row:hover { outline: 1px dashed ${P.listHoverOutline}; outline-offset: -1px; }`),P.listDropBackground&&p.push(`
				.monaco-list${V}.drop-target,
				.monaco-list${V} .monaco-list-rows.drop-target,
				.monaco-list${V} .monaco-list-row.drop-target { background-color: ${P.listDropBackground} !important; color: inherit !important; }
			`),P.tableColumnsBorder&&p.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${P.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),P.tableOddRowsBackgroundColor&&p.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${P.tableOddRowsBackgroundColor};
				}
			`),this.c.textContent=p.join(`
`)}}t.$hR=oe,t.$iR={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropBackground:"#383B3D",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:f.$2s.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:f.$2s.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:f.$2s.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0};const be={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}}};function Se(G,P){const V=G.indexOf(P);if(V===-1)return[];const p=[];let W=V-1;for(;W>=0&&G[W]===P-(V-W);)p.push(G[W--]);for(p.reverse(),W=V;W<G.length&&G[W]===P+(W-V);)p.push(G[W++]);return p}function Le(G,P){const V=[];let p=0,W=0;for(;p<G.length||W<P.length;)if(p>=G.length)V.push(P[W++]);else if(W>=P.length)V.push(G[p++]);else if(G[p]===P[W]){V.push(G[p]),p++,W++;continue}else G[p]<P[W]?V.push(G[p++]):V.push(P[W++]);return V}function Fe(G,P){const V=[];let p=0,W=0;for(;p<G.length||W<P.length;)if(p>=G.length)V.push(P[W++]);else if(W>=P.length)V.push(G[p++]);else if(G[p]===P[W]){p++,W++;continue}else G[p]<P[W]?V.push(G[p++]):W++;return V}const de=(G,P)=>G-P;class ne{constructor(P,V){this.c=P,this.d=V}get templateId(){return this.c}renderTemplate(P){return this.d.map(V=>V.renderTemplate(P))}renderElement(P,V,p,W){let J=0;for(const M of this.d)M.renderElement(P,V,p[J++],W)}disposeElement(P,V,p,W){let J=0;for(const M of this.d)M.disposeElement?.(P,V,p[J],W),J+=1}disposeTemplate(P){let V=0;for(const p of this.d)p.disposeTemplate(P[V++])}}class ce{constructor(P){this.c=P,this.templateId="a18n"}renderTemplate(P){return P}renderElement(P,V,p){const W=this.c.getAriaLabel(P);W?p.setAttribute("aria-label",W):p.removeAttribute("aria-label");const J=this.c.getAriaLevel&&this.c.getAriaLevel(P);typeof J=="number"?p.setAttribute("aria-level",`${J}`):p.removeAttribute("aria-level")}disposeTemplate(P){}}class X{constructor(P,V){this.c=P,this.d=V}getDragElements(P){const V=this.c.getSelectedElements();return V.indexOf(P)>-1?V:[P]}getDragURI(P){return this.d.getDragURI(P)}getDragLabel(P,V){if(this.d.getDragLabel)return this.d.getDragLabel(P,V)}onDragStart(P,V){this.d.onDragStart?.(P,V)}onDragOver(P,V,p,W){return this.d.onDragOver(P,V,p,W)}onDragLeave(P,V,p,W){this.d.onDragLeave?.(P,V,p,W)}onDragEnd(P){this.d.onDragEnd?.(P)}drop(P,V,p,W){this.d.drop(P,V,p,W)}dispose(){this.d.dispose()}}class q{get onDidChangeFocus(){return s.Event.map(this.g.wrapEvent(this.c.onChange),P=>this.G(P),this.y)}get onDidChangeSelection(){return s.Event.map(this.g.wrapEvent(this.d.onChange),P=>this.G(P),this.y)}get domId(){return this.k.domId}get onDidScroll(){return this.k.onDidScroll}get onMouseClick(){return this.k.onMouseClick}get onMouseDblClick(){return this.k.onMouseDblClick}get onMouseMiddleClick(){return this.k.onMouseMiddleClick}get onPointer(){return this.w.onPointer}get onMouseUp(){return this.k.onMouseUp}get onMouseDown(){return this.k.onMouseDown}get onMouseOver(){return this.k.onMouseOver}get onMouseMove(){return this.k.onMouseMove}get onMouseOut(){return this.k.onMouseOut}get onTouchStart(){return this.k.onTouchStart}get onTap(){return this.k.onTap}get onContextMenu(){let P=!1;const V=s.Event.chain(this.y.add(new L.$VQ(this.k.domNode,"keydown")).event,J=>J.map(M=>new i.$VO(M)).filter(M=>P=M.keyCode===58||M.shiftKey&&M.keyCode===68).map(M=>y.$PP.stop(M,!0)).filter(()=>!1)),p=s.Event.chain(this.y.add(new L.$VQ(this.k.domNode,"keyup")).event,J=>J.forEach(()=>P=!1).map(M=>new i.$VO(M)).filter(M=>M.keyCode===58||M.shiftKey&&M.keyCode===68).map(M=>y.$PP.stop(M,!0)).map(({browserEvent:M})=>{const $=this.getFocus(),w=$.length?$[0]:void 0,I=typeof w<"u"?this.k.element(w):void 0,v=typeof w<"u"?this.k.domElement(w):this.k.domNode;return{index:w,element:I,anchor:v,browserEvent:M}})),W=s.Event.chain(this.k.onContextMenu,J=>J.filter(M=>!P).map(({element:M,index:$,browserEvent:w})=>({element:M,index:$,anchor:new b.$QO(w),browserEvent:w})));return s.Event.any(V,p,W)}get onKeyDown(){return this.y.add(new L.$VQ(this.k.domNode,"keydown")).event}get onKeyUp(){return this.y.add(new L.$VQ(this.k.domNode,"keyup")).event}get onKeyPress(){return this.y.add(new L.$VQ(this.k.domNode,"keypress")).event}get onDidFocus(){return s.Event.signal(this.y.add(new L.$VQ(this.k.domNode,"focus",!0)).event)}get onDidBlur(){return s.Event.signal(this.y.add(new L.$VQ(this.k.domNode,"blur",!0)).event)}constructor(P,V,p,W,J=be){this.A=P,this.B=J,this.c=new o("focused"),this.f=new o("anchor"),this.g=new s.$Wd,this.x="",this.y=new e.$Qc,this.z=new s.$Od,this.onDidDispose=this.z.event;const M=this.B.accessibilityProvider&&this.B.accessibilityProvider.getWidgetRole?this.B.accessibilityProvider?.getWidgetRole():"list";this.d=new N(M!=="listbox");const $=[this.c.renderer,this.d.renderer];this.u=J.accessibilityProvider,this.u&&($.push(new ce(this.u)),this.u.onDidChangeActiveDescendant?.(this.I,this,this.y)),W=W.map(I=>new ne(I.templateId,[...$,I]));const w={...J,dnd:J.dnd&&new X(this,J.dnd)};if(this.k=this.C(V,p,W,w),this.k.domNode.setAttribute("role",M),J.styleController)this.q=J.styleController(this.k.domId);else{const I=(0,y.$DP)(this.k.domNode);this.q=new oe(I,this.k.domId)}if(this.o=new A.$ZQ([new z(this.c,this.k,J.identityProvider),new z(this.d,this.k,J.identityProvider),new z(this.f,this.k,J.identityProvider),this.k]),this.y.add(this.c),this.y.add(this.d),this.y.add(this.f),this.y.add(this.k),this.y.add(this.z),this.y.add(new F(this,this.k)),(typeof J.keyboardSupport!="boolean"||J.keyboardSupport)&&(this.v=new B(this,this.k,J),this.y.add(this.v)),J.keyboardNavigationLabelProvider){const I=J.keyboardNavigationDelegate||t.$dR;this.t=new C(this,this.k,J.keyboardNavigationLabelProvider,J.keyboardNavigationEventFilter??(()=>!0),I),this.y.add(this.t)}this.w=this.D(J),this.y.add(this.w),this.onDidChangeFocus(this.H,this,this.y),this.onDidChangeSelection(this.J,this,this.y),this.u&&(this.ariaLabel=this.u.getWidgetAriaLabel()),this.B.multipleSelectionSupport!==!1&&this.k.domNode.setAttribute("aria-multiselectable","true")}C(P,V,p,W){return new r.$_Q(P,V,p,W)}D(P){return new ie(this)}updateOptions(P={}){this.B={...this.B,...P},this.t?.updateOptions(this.B),this.B.multipleSelectionController!==void 0&&(this.B.multipleSelectionSupport?this.k.domNode.setAttribute("aria-multiselectable","true"):this.k.domNode.removeAttribute("aria-multiselectable")),this.w.updateOptions(P),this.v?.updateOptions(P),this.k.updateOptions(P)}get options(){return this.B}splice(P,V,p=[]){if(P<0||P>this.k.length)throw new n.$2Q(this.A,`Invalid start index: ${P}`);if(V<0)throw new n.$2Q(this.A,`Invalid delete count: ${V}`);V===0&&p.length===0||this.g.bufferEvents(()=>this.o.splice(P,V,p))}updateWidth(P){this.k.updateWidth(P)}updateElementHeight(P,V){this.k.updateElementHeight(P,V,null)}rerender(){this.k.rerender()}element(P){return this.k.element(P)}indexOf(P){return this.k.indexOf(P)}get length(){return this.k.length}get contentHeight(){return this.k.contentHeight}get contentWidth(){return this.k.contentWidth}get onDidChangeContentHeight(){return this.k.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.k.onDidChangeContentWidth}get scrollTop(){return this.k.getScrollTop()}set scrollTop(P){this.k.setScrollTop(P)}get scrollLeft(){return this.k.getScrollLeft()}set scrollLeft(P){this.k.setScrollLeft(P)}get scrollHeight(){return this.k.scrollHeight}get renderHeight(){return this.k.renderHeight}get firstVisibleIndex(){return this.k.firstVisibleIndex}get lastVisibleIndex(){return this.k.lastVisibleIndex}get ariaLabel(){return this.x}set ariaLabel(P){this.x=P,this.k.domNode.setAttribute("aria-label",P)}domFocus(){this.k.domNode.focus({preventScroll:!0})}layout(P,V){this.k.layout(P,V)}triggerTypeNavigation(){this.t?.trigger()}setSelection(P,V){for(const p of P)if(p<0||p>=this.length)throw new n.$2Q(this.A,`Invalid index ${p}`);this.d.set(P,V)}getSelection(){return this.d.get()}getSelectedElements(){return this.getSelection().map(P=>this.k.element(P))}setAnchor(P){if(typeof P>"u"){this.f.set([]);return}if(P<0||P>=this.length)throw new n.$2Q(this.A,`Invalid index ${P}`);this.f.set([P])}getAnchor(){return(0,c.$Nb)(this.f.get(),void 0)}getAnchorElement(){const P=this.getAnchor();return typeof P>"u"?void 0:this.element(P)}setFocus(P,V){for(const p of P)if(p<0||p>=this.length)throw new n.$2Q(this.A,`Invalid index ${p}`);this.c.set(P,V)}focusNext(P=1,V=!1,p,W){if(this.length===0)return;const J=this.c.get(),M=this.E(J.length>0?J[0]+P:0,V,W);M>-1&&this.setFocus([M],p)}focusPrevious(P=1,V=!1,p,W){if(this.length===0)return;const J=this.c.get(),M=this.F(J.length>0?J[0]-P:0,V,W);M>-1&&this.setFocus([M],p)}async focusNextPage(P,V){let p=this.k.indexAt(this.k.getScrollTop()+this.k.renderHeight);p=p===0?0:p-1;const W=this.getFocus()[0];if(W!==p&&(W===void 0||p>W)){const J=this.F(p,!1,V);J>-1&&W!==J?this.setFocus([J],P):this.setFocus([p],P)}else{const J=this.k.getScrollTop();let M=J+this.k.renderHeight;p>W&&(M-=this.k.elementHeight(p)),this.k.setScrollTop(M),this.k.getScrollTop()!==J&&(this.setFocus([]),await(0,g.$Vg)(0),await this.focusNextPage(P,V))}}async focusPreviousPage(P,V){let p;const W=this.k.getScrollTop();W===0?p=this.k.indexAt(W):p=this.k.indexAfter(W-1);const J=this.getFocus()[0];if(J!==p&&(J===void 0||J>=p)){const M=this.E(p,!1,V);M>-1&&J!==M?this.setFocus([M],P):this.setFocus([p],P)}else{const M=W;this.k.setScrollTop(W-this.k.renderHeight),this.k.getScrollTop()!==M&&(this.setFocus([]),await(0,g.$Vg)(0),await this.focusPreviousPage(P,V))}}focusLast(P,V){if(this.length===0)return;const p=this.F(this.length-1,!1,V);p>-1&&this.setFocus([p],P)}focusFirst(P,V){this.focusNth(0,P,V)}focusNth(P,V,p){if(this.length===0)return;const W=this.E(P,!1,p);W>-1&&this.setFocus([W],V)}E(P,V=!1,p){for(let W=0;W<this.length;W++){if(P>=this.length&&!V)return-1;if(P=P%this.length,!p||p(this.element(P)))return P;P++}return-1}F(P,V=!1,p){for(let W=0;W<this.length;W++){if(P<0&&!V)return-1;if(P=(this.length+P%this.length)%this.length,!p||p(this.element(P)))return P;P--}return-1}getFocus(){return this.c.get()}getFocusedElements(){return this.getFocus().map(P=>this.k.element(P))}reveal(P,V){if(P<0||P>=this.length)throw new n.$2Q(this.A,`Invalid index ${P}`);const p=this.k.getScrollTop(),W=this.k.elementTop(P),J=this.k.elementHeight(P);if((0,m.$Df)(V)){const M=J-this.k.renderHeight;this.k.setScrollTop(M*(0,h.$Sl)(V,0,1)+W)}else{const M=W+J,$=p+this.k.renderHeight;W<p&&M>=$||(W<p||M>=$&&J>=this.k.renderHeight?this.k.setScrollTop(W):M>=$&&this.k.setScrollTop(M-this.k.renderHeight))}}getRelativeTop(P){if(P<0||P>=this.length)throw new n.$2Q(this.A,`Invalid index ${P}`);const V=this.k.getScrollTop(),p=this.k.elementTop(P),W=this.k.elementHeight(P);if(p<V||p+W>V+this.k.renderHeight)return null;const J=W-this.k.renderHeight;return Math.abs((V-p)/J)}isDOMFocused(){return(0,y.$vP)(this.k.domNode)}getHTMLElement(){return this.k.domNode}getElementID(P){return this.k.getElementDomId(P)}style(P){this.q.style(P)}G({indexes:P,browserEvent:V}){return{indexes:P,elements:P.map(p=>this.k.element(p)),browserEvent:V}}H(){const P=this.c.get();this.k.domNode.classList.toggle("element-focused",P.length>0),this.I()}I(){const P=this.c.get();if(P.length>0){let V;this.u?.getActiveDescendantId&&(V=this.u.getActiveDescendantId(this.k.element(P[0]))),this.k.domNode.setAttribute("aria-activedescendant",V||this.k.getElementDomId(P[0]))}else this.k.domNode.removeAttribute("aria-activedescendant")}J(){const P=this.d.get();this.k.domNode.classList.toggle("selection-none",P.length===0),this.k.domNode.classList.toggle("selection-single",P.length===1),this.k.domNode.classList.toggle("selection-multiple",P.length>1)}dispose(){this.z.fire(),this.y.dispose(),this.z.dispose()}}t.$jR=q,Xe([T.$lh],q.prototype,"onDidChangeFocus",null),Xe([T.$lh],q.prototype,"onDidChangeSelection",null),Xe([T.$lh],q.prototype,"onContextMenu",null),Xe([T.$lh],q.prototype,"onKeyDown",null),Xe([T.$lh],q.prototype,"onKeyUp",null),Xe([T.$lh],q.prototype,"onKeyPress",null),Xe([T.$lh],q.prototype,"onDidFocus",null),Xe([T.$lh],q.prototype,"onDidBlur",null)}),define($e[62],we([1,0,6,35,37,12,16]),function(le,t,y,L,i,U,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bk=t.$ak=t.$_j=t.$$j=t.$0j=t.$9j=t.$8j=t.$7j=t.MarkdownStringTextNewlineStyle=void 0;var A;(function(l){l[l.Paragraph=0]="Paragraph",l[l.Break=1]="Break"})(A||(t.MarkdownStringTextNewlineStyle=A={}));class c{constructor(m="",n=!1){if(this.value=m,typeof this.value!="string")throw(0,y.$6)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(m,n=0){return this.value+=s(this.supportThemeIcons?(0,L.$1j)(m):m).replace(/([ \t]+)/g,(r,b)=>"&nbsp;".repeat(b.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===1?`\\
`:`

`),this}appendMarkdown(m){return this.value+=m,this}appendCodeblock(m,n){return this.value+="\n```",this.value+=m,this.value+=`
`,this.value+=n,this.value+="\n```\n",this}appendLink(m,n,r){return this.value+="[",this.value+=this.c(n,"]"),this.value+="](",this.value+=this.c(String(m),")"),r&&(this.value+=` "${this.c(this.c(r,'"'),")")}"`),this.value+=")",this}c(m,n){const r=new RegExp((0,U.$Ge)(n),"g");return m.replace(r,(b,u)=>m.charAt(u-1)!=="\\"?`\\${b}`:b)}}t.$7j=c;function g(l){return f(l)?!l.value:Array.isArray(l)?l.every(g):!0}t.$8j=g;function f(l){return l instanceof c?!0:l&&typeof l=="object"?typeof l.value=="string"&&(typeof l.isTrusted=="boolean"||typeof l.isTrusted=="object"||l.isTrusted===void 0)&&(typeof l.supportThemeIcons=="boolean"||l.supportThemeIcons===void 0):!1}t.$9j=f;function T(l,m){return l===m?!0:!l||!m?!1:l.value===m.value&&l.isTrusted===m.isTrusted&&l.supportThemeIcons===m.supportThemeIcons&&l.supportHtml===m.supportHtml&&(l.baseUri===m.baseUri||!!l.baseUri&&!!m.baseUri&&(0,i.$pg)(D.URI.from(l.baseUri),D.URI.from(m.baseUri)))}t.$0j=T;function s(l){return l.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}t.$$j=s;function a(l){return l.replace(/"/g,"&quot;")}t.$_j=a;function e(l){return l&&l.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}t.$ak=e;function h(l){const m=[],n=l.split("|").map(b=>b.trim());l=n[0];const r=n[1];if(r){const b=/height=(\d+)/.exec(r),u=/width=(\d+)/.exec(r),o=b?b[1]:"",N=u?u[1]:"",z=isFinite(parseInt(N)),R=isFinite(parseInt(o));z&&m.push(`width="${N}"`),R&&m.push(`height="${o}"`)}return{href:l,dimensions:m}}t.$bk=h}),define($e[124],we([1,0,3,116,22,55,15,20,117,6,4,62,35,77,28,2,79,53,30,51,37,12,16]),function(le,t,y,L,i,U,D,A,c,g,f,T,s,a,e,h,l,m,n,r,b,u,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qR=t.$pR=t.$oR=t.$nR=t.$mR=void 0;const N=Object.freeze({image:(X,q,G)=>{let P=[],V=[];return X&&({href:X,dimensions:P}=(0,T.$bk)(X),V.push(`src="${(0,T.$_j)(X)}"`)),G&&V.push(`alt="${(0,T.$_j)(G)}"`),q&&V.push(`title="${(0,T.$_j)(q)}"`),P.length&&(V=V.concat(P)),"<img "+V.join(" ")+">"},paragraph:X=>`<p>${X}</p>`,link:(X,q,G)=>typeof X!="string"?"":(X===G&&(G=(0,T.$ak)(G)),q=typeof q=="string"?(0,T.$_j)((0,T.$ak)(q)):"",X=(0,T.$ak)(X),X=X.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${X}" title="${q||X}">${G}</a>`)});function z(X,q={},G={}){const P=new h.$Qc;let V=!1;const p=(0,U.$UQ)(q),W=function(S){let j;try{j=(0,m.$ph)(decodeURIComponent(S))}catch{}return j?(j=(0,r.$an)(j,K=>{if(X.uris&&X.uris[K])return o.URI.revive(X.uris[K])}),encodeURIComponent(JSON.stringify(j))):S},J=function(S,j){const K=X.uris&&X.uris[S];let ee=o.URI.revive(K);return j?S.startsWith(n.Schemas.data+":")?S:(ee||(ee=o.URI.parse(S)),n.$dg.uriToBrowserUri(ee).toString(!0)):!ee||o.URI.parse(S).toString()===ee.toString()?S:(ee.query&&(ee=ee.with({query:W(ee.query)})),ee.toString())},M=new l.marked.Renderer;M.image=N.image,M.link=N.link,M.paragraph=N.paragraph;const $=[],w=[];if(q.codeBlockRendererSync?M.code=(S,j)=>{const K=a.$DM.nextId(),ee=q.codeBlockRendererSync(R(j),S);return w.push([K,ee]),`<div class="code" data-code="${K}">${(0,u.$Fe)(S)}</div>`}:q.codeBlockRenderer&&(M.code=(S,j)=>{const K=a.$DM.nextId(),ee=q.codeBlockRenderer(R(j),S);return $.push(ee.then(se=>[K,se])),`<div class="code" data-code="${K}">${(0,u.$Fe)(S)}</div>`}),q.actionHandler){const S=function(ee){let se=ee.target;if(!(se.tagName!=="A"&&(se=se.parentElement,!se||se.tagName!=="A")))try{let ge=se.dataset.href;ge&&(X.baseUri&&(ge=d(o.URI.from(X.baseUri),ge)),q.actionHandler.callback(ge,ee))}catch(ge){(0,g.$Z)(ge)}finally{ee.preventDefault()}},j=q.actionHandler.disposables.add(new i.$VQ(p,"click")),K=q.actionHandler.disposables.add(new i.$VQ(p,"auxclick"));q.actionHandler.disposables.add(f.Event.any(j.event,K.event)(ee=>{const se=new A.$QO(ee);!se.leftButton&&!se.middleButton||S(se)})),q.actionHandler.disposables.add(y.$YO(p,"keydown",ee=>{const se=new D.$VO(ee);!se.equals(10)&&!se.equals(3)||S(se)}))}X.supportHtml||(G.sanitizer=S=>(X.isTrusted?S.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?S:"",G.sanitize=!0,G.silent=!0),G.renderer=M;let I=X.value??"";I.length>1e5&&(I=`${I.substr(0,1e5)}\u2026`),X.supportThemeIcons&&(I=(0,s.$2j)(I));let v;if(q.fillInIncompleteTokens){const S={...l.marked.defaults,...G},j=l.marked.lexer(I,S),K=re(j);v=l.marked.parser(K,S)}else v=l.marked.parse(I,G);X.supportThemeIcons&&(v=(0,c.$kR)(v).map(j=>typeof j=="string"?j:j.outerHTML).join(""));const k=new DOMParser().parseFromString(E(X,v),"text/html");if(k.body.querySelectorAll("img").forEach(S=>{const j=S.getAttribute("src");if(j){let K=j;try{X.baseUri&&(K=d(o.URI.from(X.baseUri),K))}catch{}S.src=J(K,!0)}}),k.body.querySelectorAll("a").forEach(S=>{const j=S.getAttribute("href");if(S.setAttribute("href",""),!j||/^data:|javascript:/i.test(j)||/^command:/i.test(j)&&!X.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(j))S.replaceWith(...S.childNodes);else{let K=J(j,!1);X.baseUri&&(K=d(o.URI.from(X.baseUri),j)),S.dataset.href=K}}),p.innerHTML=E(X,k.body.innerHTML),$.length>0)Promise.all($).then(S=>{if(V)return;const j=new Map(S),K=p.querySelectorAll("div[data-code]");for(const ee of K){const se=j.get(ee.dataset.code??"");se&&y.$WP(ee,se)}q.asyncRenderCallback?.()});else if(w.length>0){const S=new Map(w),j=p.querySelectorAll("div[data-code]");for(const K of j){const ee=S.get(K.dataset.code??"");ee&&y.$WP(K,ee)}}if(q.asyncRenderCallback)for(const S of p.getElementsByTagName("img")){const j=P.add(y.$YO(S,"load",()=>{j.dispose(),q.asyncRenderCallback()}))}return{element:p,dispose:()=>{V=!0,P.dispose()}}}t.$mR=z;function R(X){if(!X)return"";const q=X.split(/[\s+|:|,|\{|\?]/,1);return q.length?q[0]:X}function d(X,q){return/^\w[\w\d+.-]*:/.test(q)?q:X.path.endsWith("/")?(0,b.$zg)(X,q).toString():(0,b.$zg)((0,b.$vg)(X),q).toString()}function E(X,q){const{config:G,allowedSchemes:P}=B(X);L.addHook("uponSanitizeAttribute",(p,W)=>{if(W.attrName==="style"||W.attrName==="class"){if(p.tagName==="SPAN"){if(W.attrName==="style"){W.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?$/.test(W.attrValue);return}else if(W.attrName==="class"){W.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(W.attrValue);return}}W.keepAttr=!1;return}});const V=y.$eQ(P);try{return L.sanitize(q,{...G,RETURN_TRUSTED_TYPE:!0})}finally{L.removeHook("uponSanitizeAttribute"),V.dispose()}}t.$nR=["align","autoplay","alt","class","controls","data-code","data-href","height","href","loop","muted","playsinline","poster","src","style","target","title","width","start"];function B(X){const q=[n.Schemas.http,n.Schemas.https,n.Schemas.mailto,n.Schemas.data,n.Schemas.file,n.Schemas.vscodeFileResource,n.Schemas.vscodeRemote,n.Schemas.vscodeRemoteResource];return X.isTrusted&&q.push(n.Schemas.command),{config:{ALLOWED_TAGS:[...y.$fQ],ALLOWED_ATTR:t.$nR,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:q}}function H(X){return typeof X=="string"?X:x(X)}t.$oR=H;function x(X){let q=X.value??"";q.length>1e5&&(q=`${q.substr(0,1e5)}\u2026`);const G=l.marked.parse(q,{renderer:F.value}).replace(/&(#\d+|[a-zA-Z]+);/g,P=>C.get(P)??P);return E({isTrusted:!1},G).toString()}t.$pR=x;const C=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),F=new e.$U(()=>{const X=new l.marked.Renderer;return X.code=q=>q,X.blockquote=q=>q,X.html=q=>"",X.heading=(q,G,P)=>q+`
`,X.hr=()=>"",X.list=(q,G)=>q,X.listitem=q=>q+`
`,X.paragraph=q=>q+`
`,X.table=(q,G)=>q+G+`
`,X.tablerow=q=>q,X.tablecell=(q,G)=>q+" ",X.strong=q=>q,X.em=q=>q,X.codespan=q=>q,X.br=()=>`
`,X.del=q=>q,X.image=(q,G,P)=>"",X.text=q=>q,X.link=(q,G,P)=>P,X});function Q(X){let q="";return X.forEach(G=>{q+=G.raw}),q}function te(X){for(const q of X.tokens)if(q.type==="text"){const G=q.raw.split(`
`),P=G[G.length-1];if(P.includes("`"))return ie(X);if(P.includes("**"))return Fe(X);if(P.match(/\*\w/))return oe(X);if(P.match(/(^|\s)__\w/))return de(X);if(P.match(/(^|\s)_\w/))return be(X);if(P.match(/(^|\s)\[.*\]\(\w*/))return Se(X);if(P.match(/(^|\s)\[\w/))return Le(X)}}function re(X){let q,G;for(q=0;q<X.length;q++){const P=X[q];if(P.type==="paragraph"&&P.raw.match(/(\n|^)```/)){G=fe(X.slice(q));break}if(P.type==="paragraph"&&P.raw.match(/(\n|^)\|/)){G=ce(X.slice(q));break}if(q===X.length-1&&P.type==="paragraph"){const V=te(P);if(V){G=[V];break}}}if(G){const P=[...X.slice(0,q),...G];return P.links=X.links,P}return X}t.$qR=re;function fe(X){const q=Q(X);return l.marked.lexer(q+"\n```")}function ie(X){return ne(X,"`")}function oe(X){return ne(X,"*")}function be(X){return ne(X,"_")}function Se(X){return ne(X,")")}function Le(X){return ne(X,"](about:blank)")}function Fe(X){return ne(X,"**")}function de(X){return ne(X,"__")}function ne(X,q){const G=Q(Array.isArray(X)?X:[X]);return l.marked.lexer(G+q)[0]}function ce(X){const q=Q(X),G=q.split(`
`);let P,V=!1;for(let p=0;p<G.length;p++){const W=G[p].trim();if(typeof P>"u"&&W.match(/^\s*\|/)){const J=W.match(/(\|[^\|]+)(?=\||$)/g);J&&(P=J.length)}else if(typeof P=="number")if(W.match(/^\s*\|/)){if(p!==G.length-1)return;V=!0}else return}if(typeof P=="number"&&P>0){const p=V?G.slice(0,-1).join(`
`):q,W=!!p.match(/\|\s*$/),J=p+(W?"":"|")+`
|${" --- |".repeat(P)}`;return l.marked.lexer(J)}}}),define($e[125],we([1,0,3,9,29,62,35,2,7,106]),function(le,t,y,L,i,U,D,A,c,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$MQ=t.$LQ=void 0;function f(a,e){(0,c.$zf)(e)?a.title=(0,D.$3j)(e):e?.markdownNotSupportedFallback?a.title=e.markdownNotSupportedFallback:a.removeAttribute("title")}t.$LQ=f;class T{constructor(e,h,l){this.c=e,this.d=h,this.f=l}async update(e,h,l){if(this.b&&(this.b.dispose(!0),this.b=void 0),this.isDisposed)return;let m;if(e===void 0||(0,c.$zf)(e)||e instanceof HTMLElement)m=e;else if(!(0,c.$Nf)(e.markdown))m=e.markdown??e.markdownNotSupportedFallback;else{this.a||this.g((0,g.localize)(0,null),h),this.b=new i.$Yd;const n=this.b.token;if(m=await e.markdown(n),m===void 0&&(m=e.markdownNotSupportedFallback),this.isDisposed||n.isCancellationRequested)return}this.g(m,h,l)}g(e,h,l){const m=this.a;if(this.h(e)){const n={content:e,target:this.d,showPointer:this.c.placement==="element",hoverPosition:2,skipFadeInAnimation:!this.f||!!m,...l};this.a=this.c.showHover(n,h)}m?.dispose()}h(e){return e?(0,U.$9j)(e)?!!e.value:!0:!1}get isDisposed(){return this.a?.isDisposed}dispose(){this.a?.dispose(),this.b?.dispose(!0),this.b=void 0}}function s(a,e,h,l){let m,n;const r=(z,R)=>{const d=n!==void 0;z&&(n?.dispose(),n=void 0),R&&(m?.dispose(),m=void 0),d&&a.onDidHideHover?.()},b=(z,R,d)=>new L.$6g(async()=>{(!n||n.isDisposed)&&(n=new T(a,d||e,z>0),await n.update(h,R,l))},z),u=()=>{if(m)return;const z=new A.$Qc,R=B=>r(!1,B.fromElement===e);z.add(y.$YO(e,y.$NP.MOUSE_LEAVE,R,!0));const d=()=>r(!0,!0);z.add(y.$YO(e,y.$NP.MOUSE_DOWN,d,!0));const E={targetElements:[e],dispose:()=>{}};if(a.placement===void 0||a.placement==="mouse"){const B=H=>{E.x=H.x+10,H.target instanceof HTMLElement&&H.target.classList.contains("action-label")&&r(!0,!0)};z.add(y.$YO(e,y.$NP.MOUSE_MOVE,B,!0))}z.add(b(a.delay,!1,E)),m=z},o=y.$YO(e,y.$NP.MOUSE_OVER,u,!0);return{show:z=>{r(!1,!0),b(0,z)},hide:()=>{r(!0,!0)},update:async(z,R)=>{h=z,await n?.update(h,void 0,R)},dispose:()=>{o.dispose(),r(!0,!0)}}}t.$MQ=s}),define($e[126],we([1,0,3,22,15,124,39,11,4,44,2,5,108,99]),function(le,t,y,L,i,U,D,A,c,g,f,T,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rR=void 0;const a=y.$,e="selectOption.entry.template";class h{get templateId(){return e}renderTemplate(n){const r=Object.create(null);return r.root=n,r.text=y.$UP(n,a(".option-text")),r.detail=y.$UP(n,a(".option-detail")),r.decoratorRight=y.$UP(n,a(".option-decorator-right")),r}renderElement(n,r,b){const u=b,o=n.text,N=n.detail,z=n.decoratorRight,R=n.isDisabled;u.text.textContent=o,u.detail.textContent=N||"",u.decoratorRight.innerText=z||"",R?u.root.classList.add("option-disabled"):u.root.classList.remove("option-disabled")}disposeTemplate(n){}}class l extends f.$Rc{static{this.a=32}static{this.b=2}static{this.c=3}constructor(n,r,b,u,o){super(),this.m=[],this.F=0,this.H=!1,this.J=!1,this.M=!1,this.f=!1,this.s=u,this.g=o||Object.create(null),typeof this.g.minBottomMargin!="number"?this.g.minBottomMargin=l.a:this.g.minBottomMargin<0&&(this.g.minBottomMargin=0),this.h=document.createElement("select"),this.h.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.g.ariaLabel=="string"&&this.h.setAttribute("aria-label",this.g.ariaLabel),typeof this.g.ariaDescription=="string"&&this.h.setAttribute("aria-description",this.g.ariaDescription),this.r=new c.$Od,this.B(this.r),this.O(),this.N(b),this.n=r||0,n&&this.setOptions(n,r),this.Q()}getHeight(){return 22}getTemplateId(){return e}N(n){this.u=n,this.w=y.$(".monaco-select-box-dropdown-container"),this.w.classList.add("monaco-select-box-dropdown-padding"),this.I=y.$UP(this.w,a(".select-box-details-pane"));const r=y.$UP(this.w,a(".select-box-dropdown-container-width-control")),b=y.$UP(r,a(".width-control-div"));this.D=document.createElement("span"),this.D.className="option-text-width-control",y.$UP(b,this.D),this.G=0,this.y=y.$DP(this.w),this.w.setAttribute("draggable","true"),this.B(y.$YO(this.w,y.$NP.DRAG_START,u=>{y.$PP.stop(u,!0)}))}O(){this.B(y.$ZO(this.h,"change",r=>{this.n=r.target.selectedIndex,this.r.fire({index:r.target.selectedIndex,selected:r.target.value}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)})),this.B(y.$YO(this.h,y.$NP.CLICK,r=>{y.$PP.stop(r),this.f?this.X(!0):this.W()})),this.B(y.$YO(this.h,y.$NP.MOUSE_DOWN,r=>{y.$PP.stop(r)}));let n;this.B(y.$YO(this.h,"touchstart",r=>{n=this.f})),this.B(y.$YO(this.h,"touchend",r=>{y.$PP.stop(r),n?this.X(!0):this.W()})),this.B(y.$YO(this.h,y.$NP.KEY_DOWN,r=>{const b=new i.$VO(r);let u=!1;T.$k?(b.keyCode===18||b.keyCode===16||b.keyCode===10||b.keyCode===3)&&(u=!0):(b.keyCode===18&&b.altKey||b.keyCode===16&&b.altKey||b.keyCode===10||b.keyCode===3)&&(u=!0),u&&(this.W(),y.$PP.stop(r,!0))}))}get onDidSelect(){return this.r.event}setOptions(n,r){A.$tb(this.m,n)||(this.m=n,this.h.options.length=0,this.H=!1,this.L=void 0,this.m.forEach((b,u)=>{this.h.add(this.U(b.text,u,b.isDisabled)),typeof b.description=="string"&&(this.H=!0)})),r!==void 0&&(this.select(r),this.F=this.n)}P(){this.z?.splice(0,this.z.length,this.m)}select(n){n>=0&&n<this.m.length?this.n=n:n>this.m.length-1?this.select(this.m.length-1):this.n<0&&(this.n=0),this.h.selectedIndex=this.n,this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)}setAriaLabel(n){this.g.ariaLabel=n,this.h.setAttribute("aria-label",this.g.ariaLabel)}focus(){this.h&&(this.h.tabIndex=0,this.h.focus())}blur(){this.h&&(this.h.tabIndex=-1,this.h.blur())}setFocusable(n){this.h.tabIndex=n?0:-1}render(n){this.j=n,n.classList.add("select-container"),n.appendChild(this.h),this.R()}Q(){const n=[];this.s.listFocusBackground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.s.listFocusBackground} !important; }`),this.s.listFocusForeground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.s.listFocusForeground} !important; }`),this.s.decoratorRightForeground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.s.decoratorRightForeground}; }`),this.s.selectBackground&&this.s.selectBorder&&this.s.selectBorder!==this.s.selectBackground?(n.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.s.selectBorder} } `),n.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectBorder} } `),n.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectBorder} } `)):this.s.selectListBorder&&(n.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectListBorder} } `),n.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectListBorder} } `)),this.s.listHoverForeground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.s.listHoverForeground} !important; }`),this.s.listHoverBackground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.s.listHoverBackground} !important; }`),this.s.listFocusOutline&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.s.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.s.listHoverOutline&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.s.listHoverOutline} !important; outline-offset: -1.6px !important; }`),n.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),n.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.y.textContent=n.join(`
`)}R(){const n=this.s.selectBackground??"",r=this.s.selectForeground??"",b=this.s.selectBorder??"";this.h.style.backgroundColor=n,this.h.style.color=r,this.h.style.borderColor=b}S(){const n=this.s.selectBackground??"",r=y.$aQ(this.s.selectListBackground,n);this.C.style.backgroundColor=r,this.I.style.backgroundColor=r;const b=this.s.focusBorder??"";this.w.style.outlineColor=b,this.w.style.outlineOffset="-1px",this.z.style(this.s)}U(n,r,b){const u=document.createElement("option");return u.value=n,u.text=n,u.disabled=!!b,u}W(){this.I.innerText="",!(!this.u||this.f)&&(this.cb(this.w),this.P(),this.u.showContextView({getAnchor:()=>this.h,render:n=>this.Y(n,!0),layout:()=>{this.ab()},onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.f=!0,this.X(!1),this.u.showContextView({getAnchor:()=>this.h,render:n=>this.Y(n),layout:()=>this.ab(),onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.F=this.n,this.f=!0,this.h.setAttribute("aria-expanded","true"))}X(n){!this.u||!this.f||(this.f=!1,this.h.setAttribute("aria-expanded","false"),n&&this.h.focus(),this.u.hideContextView())}Y(n,r){return n.appendChild(this.w),this.ab(r),{dispose:()=>{try{n.removeChild(this.w)}catch{}}}}Z(){let n=0;return this.m.forEach((r,b)=>{this.hb(b),this.I.offsetHeight>n&&(n=this.I.offsetHeight)}),n}ab(n){if(this.J)return!1;if(this.z){this.w.classList.add("visible");const r=y.$AP(this.h),b=y.$eP(this.h),u=y.$AP(this.h).getComputedStyle(this.h),o=parseFloat(u.getPropertyValue("--dropdown-padding-top"))+parseFloat(u.getPropertyValue("--dropdown-padding-bottom")),N=r.innerHeight-b.top-b.height-(this.g.minBottomMargin||0),z=b.top-l.b,R=this.h.offsetWidth,d=this.bb(this.D),E=Math.max(d,Math.round(R)).toString()+"px";this.w.style.width=E,this.z.getHTMLElement().style.height="",this.z.layout();let B=this.z.contentHeight;this.H&&this.L===void 0&&(this.L=this.Z());const H=this.H?this.L:0,x=B+o+H,C=Math.floor((N-o-H)/this.getHeight()),F=Math.floor((z-o-H)/this.getHeight());if(n)return b.top+b.height>r.innerHeight-22||b.top<l.b||C<1&&F<1?!1:(C<l.c&&F>C&&this.m.length>C?(this.G=1,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.I),this.w.appendChild(this.C),this.I.classList.remove("border-top"),this.I.classList.add("border-bottom")):(this.G=0,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.C),this.w.appendChild(this.I),this.I.classList.remove("border-bottom"),this.I.classList.add("border-top")),!0);if(b.top+b.height>r.innerHeight-22||b.top<l.b||this.G===0&&C<1||this.G===1&&F<1)return this.X(!0),!1;if(this.G===0){if(this.f&&C+F<1)return this.X(!0),!1;x>N&&(B=C*this.getHeight())}else x>z&&(B=F*this.getHeight());return this.z.layout(B),this.z.domFocus(),this.z.length>0&&(this.z.setFocus([this.n||0]),this.z.reveal(this.z.getFocus()[0]||0)),this.H?(this.z.getHTMLElement().style.height=B+o+"px",this.w.style.height=""):this.w.style.height=B+o+"px",this.hb(this.n),this.w.style.width=E,this.C.setAttribute("tabindex","0"),this.h.classList.add("synthetic-focus"),this.w.classList.add("synthetic-focus"),!0}else return!1}bb(n){let r=0;if(n){let b=0,u=0;this.m.forEach((o,N)=>{const z=o.detail?o.detail.length:0,R=o.decoratorRight?o.decoratorRight.length:0,d=o.text.length+z+R;d>u&&(b=N,u=d)}),n.textContent=this.m[b].text+(this.m[b].decoratorRight?this.m[b].decoratorRight+" ":""),r=y.$gP(n)}return r}cb(n){if(this.z)return;this.C=y.$UP(n,a(".select-box-dropdown-list-container")),this.t=new h,this.z=new D.$jR("SelectBoxCustom",this.C,this,[this.t],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:u=>{let o=u.text;return u.detail&&(o+=`. ${u.detail}`),u.decoratorRight&&(o+=`. ${u.decoratorRight}`),u.description&&(o+=`. ${u.description}`),o},getWidgetAriaLabel:()=>(0,s.localize)(0,null),getRole:()=>T.$k?"":"option",getWidgetRole:()=>"listbox"}}),this.g.ariaLabel&&(this.z.ariaLabel=this.g.ariaLabel);const r=this.B(new L.$VQ(this.C,"keydown")),b=c.Event.chain(r.event,u=>u.filter(()=>this.z.length>0).map(o=>new i.$VO(o)));this.B(c.Event.chain(b,u=>u.filter(o=>o.keyCode===3))(this.jb,this)),this.B(c.Event.chain(b,u=>u.filter(o=>o.keyCode===2))(this.jb,this)),this.B(c.Event.chain(b,u=>u.filter(o=>o.keyCode===9))(this.ib,this)),this.B(c.Event.chain(b,u=>u.filter(o=>o.keyCode===16))(this.lb,this)),this.B(c.Event.chain(b,u=>u.filter(o=>o.keyCode===18))(this.kb,this)),this.B(c.Event.chain(b,u=>u.filter(o=>o.keyCode===12))(this.nb,this)),this.B(c.Event.chain(b,u=>u.filter(o=>o.keyCode===11))(this.mb,this)),this.B(c.Event.chain(b,u=>u.filter(o=>o.keyCode===14))(this.ob,this)),this.B(c.Event.chain(b,u=>u.filter(o=>o.keyCode===13))(this.pb,this)),this.B(c.Event.chain(b,u=>u.filter(o=>o.keyCode>=21&&o.keyCode<=56||o.keyCode>=85&&o.keyCode<=113))(this.qb,this)),this.B(y.$YO(this.z.getHTMLElement(),y.$NP.POINTER_UP,u=>this.db(u))),this.B(this.z.onMouseOver(u=>typeof u.index<"u"&&this.z.setFocus([u.index]))),this.B(this.z.onDidChangeFocus(u=>this.gb(u))),this.B(y.$YO(this.w,y.$NP.FOCUS_OUT,u=>{!this.f||y.$mP(u.relatedTarget,this.w)||this.eb()})),this.z.getHTMLElement().setAttribute("aria-label",this.g.ariaLabel||""),this.z.getHTMLElement().setAttribute("aria-expanded","true"),this.S()}db(n){if(!this.z.length)return;y.$PP.stop(n);const r=n.target;if(!r||r.classList.contains("slider"))return;const b=r.closest(".monaco-list-row");if(!b)return;const u=Number(b.getAttribute("data-index")),o=b.classList.contains("option-disabled");u>=0&&u<this.m.length&&!o&&(this.n=u,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)),this.X(!0))}eb(){this.M||(this.n!==this.F&&this.select(this.F),this.X(!1))}fb(n,r){const b=o=>{for(let N=0;N<o.childNodes.length;N++){const z=o.childNodes.item(N);(z.tagName&&z.tagName.toLowerCase())==="img"?o.removeChild(z):b(z)}},u=(0,U.$mR)({value:n,supportThemeIcons:!0},{actionHandler:r});return u.element.classList.add("select-box-description-markdown"),b(u.element),u.element}gb(n){!this.f||!this.H||this.hb(n.indexes[0])}hb(n){this.I.innerText="";const r=this.m[n],b=r?.description??"",u=r?.descriptionIsMarkdown??!1;if(b){if(u){const o=r.descriptionMarkdownActionHandler;this.I.appendChild(this.fb(b,o))}else this.I.innerText=b;this.I.style.display="block"}else this.I.style.display="none";this.J=!0,this.u.layout(),this.J=!1}ib(n){y.$PP.stop(n),this.select(this.F),this.X(!0)}jb(n){y.$PP.stop(n),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)),this.X(!0)}kb(n){if(this.n<this.m.length-1){y.$PP.stop(n,!0);const r=this.m[this.n+1].isDisabled;if(r&&this.m.length>this.n+2)this.n+=2;else{if(r)return;this.n++}this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0])}}lb(n){this.n>0&&(y.$PP.stop(n,!0),this.m[this.n-1].isDisabled&&this.n>1?this.n-=2:this.n--,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]))}mb(n){y.$PP.stop(n),this.z.focusPreviousPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n<this.m.length-1&&(this.n++,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}nb(n){y.$PP.stop(n),this.z.focusNextPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n>0&&(this.n--,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}ob(n){y.$PP.stop(n),!(this.m.length<2)&&(this.n=0,this.m[this.n].isDisabled&&this.n>1&&this.n++,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}pb(n){y.$PP.stop(n),!(this.m.length<2)&&(this.n=this.m.length-1,this.m[this.n].isDisabled&&this.n>1&&this.n--,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}qb(n){const r=g.KeyCodeUtils.toString(n.keyCode);let b=-1;for(let u=0;u<this.m.length-1;u++)if(b=(u+this.n+1)%this.m.length,this.m[b].text.charAt(0).toUpperCase()===r&&!this.m[b].isDisabled){this.select(b),this.z.setFocus([b]),this.z.reveal(this.z.getFocus()[0]),y.$PP.stop(n);break}}dispose(){this.X(!1),super.dispose()}}t.$rR=l}),define($e[127],we([1,0,39,126,120,21,5,98]),function(le,t,y,L,i,U,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uR=t.$tR=void 0,t.$tR={...y.$iR,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class A extends U.$vQ{constructor(g,f,T,s,a){super(),D.$k&&!a?.useCustomDrawn?this.a=new i.$sR(g,f,s,a):this.a=new L.$rR(g,f,T,s,a),this.B(this.a)}get onDidSelect(){return this.a.onDidSelect}setOptions(g,f){this.a.setOptions(g,f)}select(g){this.a.select(g)}setAriaLabel(g){this.a.setAriaLabel(g)}focus(){this.a.focus()}blur(){this.a.blur()}setFocusable(g){this.a.setFocusable(g)}render(g){this.a.render(g)}}t.$uR=A}),define($e[63],we([1,0,17,54,3,24,125,127,36,2,5,7,103,52]),function(le,t,y,L,i,U,D,A,c,g,f,T,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$BR=t.$AR=t.$zR=void 0;class a extends g.$Rc{get action(){return this._action}constructor(m,n,r={}){super(),this.m=r,this._context=m||this,this._action=n,n instanceof c.$yi&&this.B(n.onDidChange(b=>{this.element&&this.t(b)}))}t(m){m.enabled!==void 0&&this.u(),m.checked!==void 0&&this.G(),m.class!==void 0&&this.F(),m.label!==void 0&&(this.w(),this.C()),m.tooltip!==void 0&&this.C()}get actionRunner(){return this.j||(this.j=this.B(new c.$zi)),this.j}set actionRunner(m){this.j=m}isEnabled(){return this._action.enabled}setActionContext(m){this._context=m}render(m){const n=this.element=m;this.B(U.$rQ.addTarget(m));const r=this.m&&this.m.draggable;r&&(m.draggable=!0,y.$EO&&this.B((0,i.$YO)(m,i.$NP.DRAG_START,b=>b.dataTransfer?.setData(L.$pQ.TEXT,this._action.label)))),this.B((0,i.$YO)(n,U.EventType.Tap,b=>this.onClick(b,!0))),this.B((0,i.$YO)(n,i.$NP.MOUSE_DOWN,b=>{r||i.$PP.stop(b,!0),this._action.enabled&&b.button===0&&n.classList.add("active")})),f.$k&&this.B((0,i.$YO)(n,i.$NP.CONTEXT_MENU,b=>{b.button===0&&b.ctrlKey===!0&&this.onClick(b)})),this.B((0,i.$YO)(n,i.$NP.CLICK,b=>{i.$PP.stop(b,!0),this.m&&this.m.isMenu||this.onClick(b)})),this.B((0,i.$YO)(n,i.$NP.DBLCLICK,b=>{i.$PP.stop(b,!0)})),[i.$NP.MOUSE_UP,i.$NP.MOUSE_OUT].forEach(b=>{this.B((0,i.$YO)(n,b,u=>{i.$PP.stop(u),n.classList.remove("active")}))})}onClick(m,n=!1){i.$PP.stop(m,!0);const r=T.$If(this._context)?this.m?.useEventAsContext?m:{preserveFocus:n}:this._context;this.actionRunner.run(this._action,r)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(m){this.element&&(this.element.tabIndex=m?0:-1)}get trapsArrowNavigation(){return!1}u(){}w(){}z(){return this.action.tooltip}C(){if(!this.element)return;const m=this.z()??"";this.D(),this.m.hoverDelegate?(this.element.title="",this.f?this.f.update(m):(this.f=(0,D.$MQ)(this.m.hoverDelegate,this.element,m),this.q.add(this.f))):this.element.title=m}D(){if(this.element){const m=this.z()??"";this.element.setAttribute("aria-label",m)}}F(){}G(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.$zR=a;class e extends a{constructor(m,n,r){super(m,n,r),this.m=r,this.m.icon=r.icon!==void 0?r.icon:!1,this.m.label=r.label!==void 0?r.label:!0,this.J=""}render(m){super.render(m),T.$Jf(this.element);const n=document.createElement("a");if(n.classList.add("action-label"),n.setAttribute("role",this.L()),this.H=n,this.element.appendChild(n),this.m.label&&this.m.keybinding){const r=document.createElement("span");r.classList.add("keybinding"),r.textContent=this.m.keybinding,this.element.appendChild(r)}this.F(),this.w(),this.C(),this.u(),this.G()}L(){return this._action.id===c.$Ai.ID?"presentation":this.m.isMenu?"menuitem":"button"}focus(){this.H&&(this.H.tabIndex=0,this.H.focus())}isFocused(){return!!this.H&&this.H?.tabIndex===0}blur(){this.H&&(this.H.tabIndex=-1)}setFocusable(m){this.H&&(this.H.tabIndex=m?0:-1)}w(){this.m.label&&this.H&&(this.H.textContent=this.action.label)}z(){let m=null;return this.action.tooltip?m=this.action.tooltip:!this.m.label&&this.action.label&&this.m.icon&&(m=this.action.label,this.m.keybinding&&(m=s.localize(0,null,m,this.m.keybinding))),m??void 0}F(){this.J&&this.H&&this.H.classList.remove(...this.J.split(" ")),this.m.icon?(this.J=this.action.class,this.H&&(this.H.classList.add("codicon"),this.J&&this.H.classList.add(...this.J.split(" "))),this.u()):this.H?.classList.remove("codicon")}u(){this.action.enabled?(this.H&&(this.H.removeAttribute("aria-disabled"),this.H.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.H&&(this.H.setAttribute("aria-disabled","true"),this.H.classList.add("disabled")),this.element?.classList.add("disabled"))}D(){if(this.H){const m=this.z()??"";this.H.setAttribute("aria-label",m)}}G(){this.H&&(this.action.checked!==void 0?(this.H.classList.toggle("checked",this.action.checked),this.H.setAttribute("aria-checked",this.action.checked?"true":"false"),this.H.setAttribute("role","checkbox")):(this.H.classList.remove("checked"),this.H.setAttribute("aria-checked",""),this.H.setAttribute("role",this.L())))}}t.$AR=e;class h extends a{constructor(m,n,r,b,u,o,N){super(m,n),this.b=new A.$uR(r,b,u,o,N),this.b.setFocusable(!1),this.B(this.b),this.g()}setOptions(m,n){this.b.setOptions(m,n)}select(m){this.b.select(m)}g(){this.B(this.b.onDidSelect(m=>this.n(m.selected,m.index)))}n(m,n){this.actionRunner.run(this._action,this.r(m,n))}r(m,n){return m}setFocusable(m){this.b.setFocusable(m)}focus(){this.b?.focus()}blur(){this.b?.blur()}render(m){this.b.render(m)}}t.$BR=h}),define($e[64],we([1,0,3,15,63,36,4,2,7,52]),function(le,t,y,L,i,U,D,A,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$OQ=t.$NQ=t.ActionsOrientation=void 0;var g;(function(s){s[s.HORIZONTAL=0]="HORIZONTAL",s[s.VERTICAL=1]="VERTICAL"})(g||(t.ActionsOrientation=g={}));class f extends A.$Rc{constructor(a,e={}){super(),this.g=this.B(new A.$Qc),this.r=this.B(new A.$Zc),this.w=!1,this.y=!0,this.C=this.B(new D.$Od),this.onDidBlur=this.C.event,this.D=this.B(new D.$Od({onWillAddFirstListener:()=>this.F=!0})),this.onDidCancel=this.D.event,this.F=!1,this.G=this.B(new D.$Od),this.onDidRun=this.G.event,this.H=this.B(new D.$Od),this.onWillRun=this.H.event,this.b=e,this.j=e.context??null,this.m=this.b.orientation??0,this.n={keyDown:this.b.triggerKeys?.keyDown??!1,keys:this.b.triggerKeys?.keys??[3,10]},this.b.actionRunner?this.f=this.b.actionRunner:(this.f=new U.$zi,this.g.add(this.f)),this.g.add(this.f.onDidRun(m=>this.G.fire(m))),this.g.add(this.f.onWillRun(m=>this.H.fire(m))),this.viewItems=[],this.t=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar",e.animated!==!1&&this.domNode.classList.add("animated");let h,l;switch(this.m){case 0:h=[15],l=[17];break;case 1:h=[16],l=[18],this.domNode.className+=" vertical";break}this.B(y.$YO(this.domNode,y.$NP.KEY_DOWN,m=>{const n=new L.$VO(m);let r=!0;const b=typeof this.t=="number"?this.viewItems[this.t]:void 0;h&&(n.equals(h[0])||n.equals(h[1]))?r=this.P():l&&(n.equals(l[0])||n.equals(l[1]))?r=this.O():n.equals(9)&&this.F?this.D.fire():n.equals(14)?r=this.M():n.equals(13)?r=this.N():n.equals(2)&&b instanceof i.$zR&&b.trapsArrowNavigation?r=this.O():this.J(n)?this.n.keyDown?this.R(n):this.w=!0:r=!1,r&&(n.preventDefault(),n.stopPropagation())})),this.B(y.$YO(this.domNode,y.$NP.KEY_UP,m=>{const n=new L.$VO(m);this.J(n)?(!this.n.keyDown&&this.w&&(this.w=!1,this.R(n)),n.preventDefault(),n.stopPropagation()):(n.equals(2)||n.equals(1026))&&this.L()})),this.u=this.B(y.$SP(this.domNode)),this.B(this.u.onDidBlur(()=>{(y.$uP()===this.domNode||!y.$mP(y.$uP(),this.domNode))&&(this.C.fire(),this.s=this.t,this.t=void 0,this.w=!1)})),this.B(this.u.onDidFocus(()=>this.L())),this.z=document.createElement("ul"),this.z.className="actions-container",this.b.highlightToggledItems&&this.z.classList.add("highlight-toggled"),this.z.setAttribute("role",this.b.ariaRole||"toolbar"),this.b.ariaLabel&&this.z.setAttribute("aria-label",this.b.ariaLabel),this.domNode.appendChild(this.z),a.appendChild(this.domNode)}I(){this.length()>=2?this.z.setAttribute("role",this.b.ariaRole||"toolbar"):this.z.setAttribute("role","presentation")}setAriaLabel(a){a?this.z.setAttribute("aria-label",a):this.z.removeAttribute("aria-label")}setFocusable(a){if(this.y=a,this.y){const e=this.viewItems.find(h=>h instanceof i.$zR&&h.isEnabled());e instanceof i.$zR&&e.setFocusable(!0)}else this.viewItems.forEach(e=>{e instanceof i.$zR&&e.setFocusable(!1)})}J(a){let e=!1;return this.n.keys.forEach(h=>{e=e||a.equals(h)}),e}L(){for(let a=0;a<this.z.children.length;a++){const e=this.z.children[a];if(y.$mP(y.$uP(),e)){this.t=a,this.viewItems[this.t]?.showHover?.();break}}}get context(){return this.j}set context(a){this.j=a,this.viewItems.forEach(e=>e.setActionContext(a))}get actionRunner(){return this.f}set actionRunner(a){this.f=a,this.g.clear(),this.g.add(this.f.onDidRun(e=>this.G.fire(e))),this.g.add(this.f.onWillRun(e=>this.H.fire(e))),this.viewItems.forEach(e=>e.actionRunner=a)}getContainer(){return this.domNode}hasAction(a){return this.viewItems.findIndex(e=>e.action.id===a.id)!==-1}getAction(a){if(typeof a=="number")return this.viewItems[a]?.action;if(a instanceof HTMLElement){for(;a.parentElement!==this.z;){if(!a.parentElement)return;a=a.parentElement}for(let e=0;e<this.z.childNodes.length;e++)if(this.z.childNodes[e]===a)return this.viewItems[e].action}}push(a,e={}){const h=Array.isArray(a)?a:[a];let l=c.$Df(e.index)?e.index:null;h.forEach(m=>{const n=document.createElement("li");n.className="action-item",n.setAttribute("role","presentation");let r;const b={hoverDelegate:this.b.hoverDelegate,...e};this.b.actionViewItemProvider&&(r=this.b.actionViewItemProvider(m,b)),r||(r=new i.$AR(this.context,m,b)),this.b.allowContextMenu||this.r.set(r,y.$YO(n,y.$NP.CONTEXT_MENU,u=>{y.$PP.stop(u,!0)})),r.actionRunner=this.f,r.setActionContext(this.context),r.render(n),this.y&&r instanceof i.$zR&&this.viewItems.length===0&&r.setFocusable(!0),l===null||l<0||l>=this.z.children.length?(this.z.appendChild(n),this.viewItems.push(r)):(this.z.insertBefore(n,this.z.children[l]),this.viewItems.splice(l,0,r),l++)}),typeof this.t=="number"&&this.focus(this.t),this.I()}getWidth(a){if(a>=0&&a<this.z.children.length){const e=this.z.children.item(a);if(e)return e.clientWidth}return 0}getHeight(a){if(a>=0&&a<this.z.children.length){const e=this.z.children.item(a);if(e)return e.clientHeight}return 0}pull(a){a>=0&&a<this.viewItems.length&&(this.z.removeChild(this.z.childNodes[a]),this.r.deleteAndDispose(this.viewItems[a]),(0,A.$Mc)(this.viewItems.splice(a,1)),this.I())}clear(){this.isEmpty()||(this.viewItems=(0,A.$Mc)(this.viewItems),this.r.clearAndDisposeAll(),y.$XO(this.z),this.I())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(a){let e=!1,h;if(a===void 0?e=!0:typeof a=="number"?h=a:typeof a=="boolean"&&(e=a),e&&typeof this.t>"u"){const l=this.viewItems.findIndex(m=>m.isEnabled());this.t=l===-1?void 0:l,this.Q(void 0,void 0,!0)}else h!==void 0&&(this.t=h),this.Q(void 0,void 0,!0)}M(){return this.t=this.length()-1,this.O(!0)}N(){return this.t=0,this.P(!0)}O(a){if(typeof this.t>"u")this.t=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const e=this.t;let h;do{if(!a&&this.b.preventLoopNavigation&&this.t+1>=this.viewItems.length)return this.t=e,!1;this.t=(this.t+1)%this.viewItems.length,h=this.viewItems[this.t]}while(this.t!==e&&(this.b.focusOnlyEnabledItems&&!h.isEnabled()||h.action.id===U.$Ai.ID));return this.Q(),!0}P(a){if(typeof this.t>"u")this.t=0;else if(this.viewItems.length<=1)return!1;const e=this.t;let h;do{if(this.t=this.t-1,this.t<0){if(!a&&this.b.preventLoopNavigation)return this.t=e,!1;this.t=this.viewItems.length-1}h=this.viewItems[this.t]}while(this.t!==e&&(this.b.focusOnlyEnabledItems&&!h.isEnabled()||h.action.id===U.$Ai.ID));return this.Q(!0),!0}Q(a,e,h=!1){typeof this.t>"u"&&this.z.focus({preventScroll:e}),this.s!==void 0&&this.s!==this.t&&this.viewItems[this.s]?.blur();const l=this.t!==void 0?this.viewItems[this.t]:void 0;if(l){let m=!0;c.$Nf(l.focus)||(m=!1),this.b.focusOnlyEnabledItems&&c.$Nf(l.isEnabled)&&!l.isEnabled()&&(m=!1),l.action.id===U.$Ai.ID&&(m=!1),m&&l.showHover?.(),m?(h||this.s!==this.t)&&(l.focus(a),this.s=this.t):(this.z.focus({preventScroll:e}),this.s=void 0)}}R(a){if(typeof this.t>"u")return;const e=this.viewItems[this.t];if(e instanceof i.$zR){const h=e._context===null||e._context===void 0?a:e._context;this.run(e._action,h)}}async run(a,e){await this.f.run(a,e)}dispose(){this.j=void 0,this.viewItems=(0,A.$Mc)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.$NQ=f;function T(s){if(!s.length)return s;let a=-1;for(let h=0;h<s.length;h++)if(s[h].id!==U.$Ai.ID){a=h;break}if(a===-1)return[];s=s.slice(a);for(let h=s.length-1;h>=0&&s[h].id===U.$Ai.ID;h--)s.splice(h,1);let e=!1;for(let h=s.length-1;h>=0;h--){const l=s[h].id===U.$Ai.ID;l&&!e?s.splice(h,1):l?l&&(e=!1):e=!0}return s}t.$OQ=T}),define($e[65],we([1,0,3,22,55,64,57,60,21,4,81,51,107,95]),function(le,t,y,L,i,U,D,A,c,g,f,T,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gS=t.$fS=t.$eS=t.MessageType=void 0;const a=y.$;var e;(function(m){m[m.INFO=1]="INFO",m[m.WARNING=2]="WARNING",m[m.ERROR=3]="ERROR"})(e||(t.MessageType=e={})),t.$eS={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class h extends c.$vQ{constructor(n,r,b){super(),this.w="idle",this.M=Number.POSITIVE_INFINITY,this.O=this.B(new g.$Od),this.onDidChange=this.O.event,this.P=this.B(new g.$Od),this.onDidHeightChange=this.P.event,this.a=r,this.g=b,this.h=null,this.n=this.g.placeholder||"",this.r=this.g.tooltip??(this.n||""),this.s=this.g.ariaLabel||"",this.g.validationOptions&&(this.t=this.g.validationOptions.validation),this.element=y.$UP(n,a(".monaco-inputbox.idle"));const u=this.g.flexibleHeight?"textarea":"input",o=y.$UP(this.element,a(".ibwrapper"));if(this.b=y.$UP(o,a(u+".input.empty")),this.b.setAttribute("autocorrect","off"),this.b.setAttribute("autocapitalize","off"),this.b.setAttribute("spellcheck","false"),this.G(this.b,()=>this.element.classList.add("synthetic-focus")),this.F(this.b,()=>this.element.classList.remove("synthetic-focus")),this.g.flexibleHeight){this.M=typeof this.g.flexibleMaxHeight=="number"?this.g.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.y=y.$UP(o,a("div.mirror")),this.y.innerText="\xA0",this.N=new A.$FQ(this.element,{vertical:1}),this.g.flexibleWidth&&(this.b.setAttribute("wrap","off"),this.y.style.whiteSpace="pre",this.y.style.wordWrap="initial"),y.$UP(n,this.N.getDomNode()),this.B(this.N),this.B(this.N.onScroll(R=>this.b.scrollTop=R.scrollTop));const N=this.B(new L.$VQ(n.ownerDocument,"selectionchange")),z=g.Event.filter(N.event,()=>n.ownerDocument.getSelection()?.anchorNode===o);this.B(z(this.S,this)),this.B(this.onDidHeightChange(this.S,this))}else this.b.type=this.g.type||"text",this.b.setAttribute("wrap","off");this.s&&this.b.setAttribute("aria-label",this.s),this.n&&!this.g.showPlaceholderOnFocus&&this.setPlaceHolder(this.n),this.r&&this.setTooltip(this.r),this.D(this.b,()=>this.Y()),this.F(this.b,()=>this.Q()),this.G(this.b,()=>this.R()),this.B(this.I(this.b)),setTimeout(()=>this.Z(),0),this.g.actions&&(this.c=this.B(new U.$NQ(this.element)),this.c.push(this.g.actions,{icon:!0,label:!1})),this.ab()}Q(){this.X(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder","")}R(){this.W(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder",this.n||"")}setPlaceHolder(n){this.n=n,this.b.setAttribute("placeholder",n)}setTooltip(n){this.r=n,this.b.title=n}setAriaLabel(n){this.s=n,n?this.b.setAttribute("aria-label",this.s):this.b.removeAttribute("aria-label")}getAriaLabel(){return this.s}get mirrorElement(){return this.y}get inputElement(){return this.b}get value(){return this.b.value}set value(n){this.b.value!==n&&(this.b.value=n,this.Y())}get step(){return this.b.step}set step(n){this.b.step=n}get height(){return typeof this.J=="number"?this.J:y.$kP(this.element)}focus(){this.b.focus()}blur(){this.b.blur()}hasFocus(){return y.$vP(this.b)}select(n=null){this.b.select(),n&&(this.b.setSelectionRange(n.start,n.end),n.end===this.b.value.length&&(this.b.scrollLeft=this.b.scrollWidth))}isSelectionAtEnd(){return this.b.selectionEnd===this.b.value.length&&this.b.selectionStart===this.b.selectionEnd}enable(){this.b.removeAttribute("disabled")}disable(){this.blur(),this.b.disabled=!0,this.X()}setEnabled(n){n?this.enable():this.disable()}get width(){return y.$gP(this.b)}set width(n){if(this.g.flexibleHeight&&this.g.flexibleWidth){let r=0;if(this.y){const b=parseFloat(this.y.style.paddingLeft||"")||0,u=parseFloat(this.y.style.paddingRight||"")||0;r=b+u}this.b.style.width=n-r+"px"}else this.b.style.width=n+"px";this.y&&(this.y.style.width=n+"px")}set paddingRight(n){this.b.style.width=`calc(100% - ${n}px)`,this.y&&(this.y.style.paddingRight=n+"px")}S(){if(typeof this.L!="number"||typeof this.J!="number"||!this.N)return;const n=this.L,r=this.J,b=this.b.scrollTop;this.N.setScrollDimensions({scrollHeight:n,height:r}),this.N.setScrollPosition({scrollTop:b})}showMessage(n,r){if(this.w==="open"&&(0,T.$cn)(this.h,n))return;this.h=n,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.U(n.type));const b=this.stylesForType(this.h.type);this.element.style.border=`1px solid ${y.$aQ(b.border,"transparent")}`,this.h.content&&(this.hasFocus()||r)&&this.W()}hideMessage(){this.h=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this.X(),this.ab()}isInputValid(){return!!this.t&&!this.t(this.value)}validate(){let n=null;return this.t&&(n=this.t(this.value),n?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(n)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),n?.type}stylesForType(n){const r=this.g.inputBoxStyles;switch(n){case 1:return{border:r.inputValidationInfoBorder,background:r.inputValidationInfoBackground,foreground:r.inputValidationInfoForeground};case 2:return{border:r.inputValidationWarningBorder,background:r.inputValidationWarningBackground,foreground:r.inputValidationWarningForeground};default:return{border:r.inputValidationErrorBorder,background:r.inputValidationErrorBackground,foreground:r.inputValidationErrorForeground}}}U(n){switch(n){case 1:return"info";case 2:return"warning";default:return"error"}}W(){if(!this.a||!this.h)return;let n;const r=()=>n.style.width=y.$gP(this.element)+"px";this.a.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:u=>{if(!this.h)return null;n=y.$UP(u,a(".monaco-inputbox-container")),r();const o={inline:!0,className:"monaco-inputbox-message"},N=this.h.formatContent?(0,i.$TQ)(this.h.content,o):(0,i.$SQ)(this.h.content,o);N.classList.add(this.U(this.h.type));const z=this.stylesForType(this.h.type);return N.style.backgroundColor=z.background??"",N.style.color=z.foreground??"",N.style.border=z.border?`1px solid ${z.border}`:"",y.$UP(n,N),null},onHide:()=>{this.w="closed"},layout:r});let b;this.h.type===3?b=s.localize(0,null,this.h.content):this.h.type===2?b=s.localize(1,null,this.h.content):b=s.localize(2,null,this.h.content),D.$XQ(b),this.w="open"}X(){this.a&&(this.w==="open"&&this.a.hideContextView(),this.w="idle")}Y(){this.O.fire(this.value),this.validate(),this.Z(),this.b.classList.toggle("empty",!this.value),this.w==="open"&&this.a&&this.a.layout()}Z(){if(!this.y)return;const n=this.value,b=n.charCodeAt(n.length-1)===10?" ":"";(n+b).replace(/\u000c/g,"")?this.y.textContent=n+b:this.y.innerText="\xA0",this.layout()}ab(){const n=this.g.inputBoxStyles,r=n.inputBackground??"",b=n.inputForeground??"",u=n.inputBorder??"";this.element.style.backgroundColor=r,this.element.style.color=b,this.b.style.backgroundColor="inherit",this.b.style.color=b,this.element.style.border=`1px solid ${y.$aQ(u,"transparent")}`}layout(){if(!this.y)return;const n=this.L;this.L=y.$kP(this.y),n!==this.L&&(this.J=Math.min(this.L,this.M),this.b.style.height=this.J+"px",this.P.fire(this.L))}insertAtCursor(n){const r=this.inputElement,b=r.selectionStart,u=r.selectionEnd,o=r.value;b!==null&&u!==null&&(this.value=o.substr(0,b)+n+o.substr(u),r.setSelectionRange(b+1,b+1),this.layout())}dispose(){this.X(),this.h=null,this.c?.dispose(),super.dispose()}}t.$fS=h;class l extends h{constructor(n,r,b){const u=s.localize(3,null,"\u21C5"),o=s.localize(4,null,"\u21C5");super(n,r,b),this.db=this.B(new g.$Od),this.onDidFocus=this.db.event,this.eb=this.B(new g.$Od),this.onDidBlur=this.eb.event,this.bb=new f.$cS(b.history,100);const N=()=>{if(b.showHistoryHint&&b.showHistoryHint()&&!this.n.endsWith(u)&&!this.n.endsWith(o)&&this.bb.getHistory().length){const z=this.n.endsWith(")")?u:o,R=this.n+z;b.showPlaceholderOnFocus&&!y.$vP(this.b)?this.n=R:this.setPlaceHolder(R)}};this.cb=new MutationObserver((z,R)=>{z.forEach(d=>{d.target.textContent||N()})}),this.cb.observe(this.b,{attributeFilter:["class"]}),this.G(this.b,()=>N()),this.F(this.b,()=>{const z=R=>{if(this.n.endsWith(R)){const d=this.n.slice(0,this.n.length-R.length);return b.showPlaceholderOnFocus?this.n=d:this.setPlaceHolder(d),!0}else return!1};z(o)||z(u)})}dispose(){super.dispose(),this.cb&&(this.cb.disconnect(),this.cb=void 0)}addToHistory(n){this.value&&(n||this.value!==this.hb())&&this.bb.add(this.value)}prependHistory(n){const r=this.getHistory();this.clearHistory(),n.forEach(b=>{this.bb.add(b)}),r.forEach(b=>{this.bb.add(b)})}getHistory(){return this.bb.getHistory()}isAtFirstInHistory(){return this.bb.isFirst()}isAtLastInHistory(){return this.bb.isLast()}isNowhereInHistory(){return this.bb.isNowhere()}showNextValue(){this.bb.has(this.value)||this.addToHistory();let n=this.jb();n&&(n=n===this.value?this.jb():n),this.value=n??"",D.$YQ(this.value?this.value:s.localize(5,null))}showPreviousValue(){this.bb.has(this.value)||this.addToHistory();let n=this.ib();n&&(n=n===this.value?this.ib():n),n&&(this.value=n,D.$YQ(this.value))}clearHistory(){this.bb.clear()}setPlaceHolder(n){super.setPlaceHolder(n),this.setTooltip(n)}Q(){super.Q(),this.eb.fire()}R(){super.R(),this.db.fire()}hb(){let n=this.bb.current();return n||(n=this.bb.last(),this.bb.next()),n}ib(){return this.bb.previous()||this.bb.first()}jb(){return this.bb.next()}}t.$gS=l}),define($e[66],we([1,0,63,21,18,19,4,3,100]),function(le,t,y,L,i,U,D,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yR=t.$xR=t.$wR=t.$vR=void 0,t.$vR={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class c extends y.$zR{constructor(s,a,e){super(s,a,e),this.a=this.B(new g({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.m.keybinding?`${this._action.label} (${this.m.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:e.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:e.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:e.toggleStyles?.inputActiveOptionForeground})),this.B(this.a.onChange(()=>this._action.checked=!!this.a&&this.a.checked))}render(s){this.element=s,this.element.appendChild(this.a.domNode)}u(){this.a&&(this.isEnabled()?this.a.enable():this.a.disable())}G(){this.a.checked=!!this._action.checked}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(s){this.a.domNode.tabIndex=s?0:-1}}t.$wR=c;class g extends L.$vQ{constructor(s){super(),this.a=this.B(new D.$Od),this.onChange=this.a.event,this.b=this.B(new D.$Od),this.onKeyDown=this.b.event,this.c=s,this.s=this.c.isChecked;const a=["monaco-custom-toggle"];this.c.icon&&(this.g=this.c.icon,a.push(...U.ThemeIcon.asClassNameArray(this.g))),this.c.actionClassName&&a.push(...this.c.actionClassName.split(" ")),this.s&&a.push("checked"),this.domNode=document.createElement("div"),this.domNode.title=this.c.title,this.domNode.classList.add(...a),this.c.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.setAttribute("aria-label",this.c.title),this.t(),this.f(this.domNode,e=>{this.enabled&&(this.checked=!this.s,this.a.fire(!1),e.preventDefault())}),this.B(this.I(this.domNode)),this.z(this.domNode,e=>{if(e.keyCode===10||e.keyCode===3){this.checked=!this.s,this.a.fire(!0),e.preventDefault(),e.stopPropagation();return}this.b.fire(e)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this.s}set checked(s){this.s=s,this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.classList.toggle("checked",this.s),this.t()}setIcon(s){this.g&&this.domNode.classList.remove(...U.ThemeIcon.asClassNameArray(this.g)),this.g=s,this.g&&this.domNode.classList.add(...U.ThemeIcon.asClassNameArray(this.g))}width(){return 2+2+2+16}t(){this.domNode&&(this.domNode.style.borderColor=this.s&&this.c.inputActiveOptionBorder||"",this.domNode.style.color=this.s&&this.c.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this.s&&this.c.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(s){this.domNode.title=s,this.domNode.setAttribute("aria-label",s)}}t.$xR=g;class f extends L.$vQ{constructor(s,a,e){super(),this.c=s,this.g=a,this.a=new g({title:this.c,isChecked:this.g,icon:i.$Yj.check,actionClassName:"monaco-checkbox",...t.$vR}),this.domNode=this.a.domNode,this.b=e,this.h(),this.B(this.a.onChange(()=>this.h()))}get checked(){return this.a.checked}set checked(s){this.a.checked=s,this.h()}focus(){this.domNode.focus()}hasFocus(){return(0,A.$vP)(this.domNode)}h(){this.domNode.style.color=this.b.checkboxForeground||"",this.domNode.style.backgroundColor=this.b.checkboxBackground||"",this.domNode.style.borderColor=this.b.checkboxBorder||""}}t.$yR=f}),define($e[128],we([1,0,66,18,105]),function(le,t,y,L,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tS=t.$sS=t.$rS=void 0;const U=i.localize(0,null),D=i.localize(1,null),A=i.localize(2,null);class c extends y.$xR{constructor(s){super({icon:L.$Yj.caseSensitive,title:U+s.appendTitle,isChecked:s.isChecked,inputActiveOptionBorder:s.inputActiveOptionBorder,inputActiveOptionForeground:s.inputActiveOptionForeground,inputActiveOptionBackground:s.inputActiveOptionBackground})}}t.$rS=c;class g extends y.$xR{constructor(s){super({icon:L.$Yj.wholeWord,title:D+s.appendTitle,isChecked:s.isChecked,inputActiveOptionBorder:s.inputActiveOptionBorder,inputActiveOptionForeground:s.inputActiveOptionForeground,inputActiveOptionBackground:s.inputActiveOptionBackground})}}t.$sS=g;class f extends y.$xR{constructor(s){super({icon:L.$Yj.regex,title:A+s.appendTitle,isChecked:s.isChecked,inputActiveOptionBorder:s.inputActiveOptionBorder,inputActiveOptionForeground:s.inputActiveOptionForeground,inputActiveOptionBackground:s.inputActiveOptionBackground})}}t.$tS=f}),define($e[129],we([1,0,3,128,65,21,4,104,2,94]),function(le,t,y,L,i,U,D,A,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uS=void 0;const g=A.localize(0,null);class f extends U.$vQ{static{this.OPTION_CHANGE="optionChange"}constructor(s,a,e){super(),this.n=!0,this.s=!1,this.w=this.B(new c.$Sc),this.N=[],this.O=this.B(new D.$Od),this.onDidOptionChange=this.O.event,this.P=this.B(new D.$Od),this.onKeyDown=this.P.event,this.Q=this.B(new D.$Od),this.onMouseDown=this.Q.event,this.R=this.B(new D.$Od),this.onInput=this.R.event,this.S=this.B(new D.$Od),this.onKeyUp=this.S.event,this.U=this.B(new D.$Od),this.onCaseSensitiveKeyDown=this.U.event,this.W=this.B(new D.$Od),this.onRegexKeyDown=this.W.event,this.Y=0,this.a=e.placeholder||"",this.b=e.validation,this.c=e.label||g,this.h=!!e.showCommonFindToggles;const h=e.appendCaseSensitiveLabel||"",l=e.appendWholeWordsLabel||"",m=e.appendRegexLabel||"",n=e.history||[],r=!!e.flexibleHeight,b=!!e.flexibleWidth,u=e.flexibleMaxHeight;if(this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this.B(new i.$gS(this.domNode,a,{placeholder:this.a||"",ariaLabel:this.c||"",validationOptions:{validation:this.b},history:n,showHistoryHint:e.showHistoryHint,flexibleHeight:r,flexibleWidth:b,flexibleMaxHeight:u,inputBoxStyles:e.inputBoxStyles})),this.h){this.J=this.B(new L.$tS({appendTitle:m,isChecked:!1,...e.toggleStyles})),this.B(this.J.onChange(N=>{this.O.fire(N),!N&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.J.onKeyDown(N=>{this.W.fire(N)})),this.L=this.B(new L.$sS({appendTitle:l,isChecked:!1,...e.toggleStyles})),this.B(this.L.onChange(N=>{this.O.fire(N),!N&&this.n&&this.inputBox.focus(),this.validate()})),this.M=this.B(new L.$rS({appendTitle:h,isChecked:!1,...e.toggleStyles})),this.B(this.M.onChange(N=>{this.O.fire(N),!N&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.M.onKeyDown(N=>{this.U.fire(N)}));const o=[this.M.domNode,this.L.domNode,this.J.domNode];this.z(this.domNode,N=>{if(N.equals(15)||N.equals(17)||N.equals(9)){const z=o.indexOf(this.domNode.ownerDocument.activeElement);if(z>=0){let R=-1;N.equals(17)?R=(z+1)%o.length:N.equals(15)&&(z===0?R=o.length-1:R=z-1),N.equals(9)?(o[z].blur(),this.inputBox.focus()):R>=0&&o[R].focus(),y.$PP.stop(N,!0)}}})}this.y=document.createElement("div"),this.y.className="controls",this.y.style.display=this.h?"":"none",this.M&&this.y.append(this.M.domNode),this.L&&this.y.appendChild(this.L.domNode),this.J&&this.y.appendChild(this.J.domNode),this.setAdditionalToggles(e?.additionalToggles),this.y&&this.domNode.appendChild(this.y),s?.appendChild(this.domNode),this.B(y.$YO(this.inputBox.inputElement,"compositionstart",o=>{this.s=!0})),this.B(y.$YO(this.inputBox.inputElement,"compositionend",o=>{this.s=!1,this.R.fire()})),this.z(this.inputBox.inputElement,o=>this.P.fire(o)),this.C(this.inputBox.inputElement,o=>this.S.fire(o)),this.D(this.inputBox.inputElement,o=>this.R.fire()),this.j(this.inputBox.inputElement,o=>this.Q.fire(o))}get isImeSessionInProgress(){return this.s}get onDidChange(){return this.inputBox.onDidChange}layout(s){this.inputBox.layout(),this.X(s.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.J?.enable(),this.L?.enable(),this.M?.enable();for(const s of this.N)s.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.J?.disable(),this.L?.disable(),this.M?.disable();for(const s of this.N)s.disable()}setFocusInputOnOptionClick(s){this.n=s}setEnabled(s){s?this.enable():this.disable()}setAdditionalToggles(s){for(const a of this.N)a.domNode.remove();this.N=[],this.w.value=new c.$Qc;for(const a of s??[])this.w.value.add(a),this.y.appendChild(a.domNode),this.w.value.add(a.onChange(e=>{this.O.fire(e),!e&&this.n&&this.inputBox.focus()})),this.N.push(a);this.N.length>0&&(this.y.style.display=""),this.X()}X(s=!1){s?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.M?.width()??0)+(this.L?.width()??0)+(this.J?.width()??0)+this.N.reduce((a,e)=>a+e.width(),0)}clear(){this.Z(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(s){this.inputBox.value!==s&&(this.inputBox.value=s)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.M?.checked??!1}setCaseSensitive(s){this.M&&(this.M.checked=s)}getWholeWords(){return this.L?.checked??!1}setWholeWords(s){this.L&&(this.L.checked=s)}getRegex(){return this.J?.checked??!1}setRegex(s){this.J&&(this.J.checked=s,this.validate())}focusOnCaseSensitive(){this.M?.focus()}focusOnRegex(){this.J?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this.Y),this.Y=1-this.Y,this.domNode.classList.add("highlight-"+this.Y)}validate(){this.inputBox.validate()}showMessage(s){this.inputBox.showMessage(s)}clearMessage(){this.inputBox.hideMessage()}Z(){this.inputBox.hideMessage()}}t.$uS=f}),define($e[130],we([1,0,3,22,15,64,129,65,61,39,66,58,25,36,11,9,18,19,32,4,34,2,46,7,109,101]),function(le,t,y,L,i,U,D,A,c,g,f,T,s,a,e,h,l,m,n,r,b,u,o,N,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5S=t.TreeFindMatchType=t.TreeFindMode=t.$4S=t.$3S=t.RenderIndentGuides=t.$2S=t.$1S=void 0;class R extends c.$9Q{set context(p){this.c.context=p}get context(){return this.c.context}constructor(p){super(p.elements.map(W=>W.element)),this.c=p}}function d(V){return V instanceof c.$9Q?new R(V):V}class E{constructor(p,W){this.d=p,this.f=W,this.b=u.$Rc.None,this.c=new u.$Qc}getDragURI(p){return this.f.getDragURI(p.element)}getDragLabel(p,W){if(this.f.getDragLabel)return this.f.getDragLabel(p.map(J=>J.element),W)}onDragStart(p,W){this.f.onDragStart?.(d(p),W)}onDragOver(p,W,J,M,$=!0){const w=this.f.onDragOver(d(p),W&&W.element,J,M),I=this.a!==W;if(I&&(this.b.dispose(),this.a=W),typeof W>"u")return w;if(I&&typeof w!="boolean"&&w.autoExpand&&(this.b=(0,h.$Wg)(()=>{const j=this.d(),K=j.getNodeLocation(W);j.isCollapsed(K)&&j.setCollapsed(K,!1),this.a=void 0},500,this.c)),typeof w=="boolean"||!w.accept||typeof w.bubble>"u"||w.feedback){if(!$){const j=typeof w=="boolean"?w:w.accept,K=typeof w=="boolean"?void 0:w.effect;return{accept:j,effect:K,feedback:[J]}}return w}if(w.bubble===1){const j=this.d(),K=j.getNodeLocation(W),ee=j.getParentNodeLocation(K),se=j.getNode(ee),ge=ee&&j.getListIndex(ee);return this.onDragOver(p,se,ge,M,!1)}const v=this.d(),O=v.getNodeLocation(W),k=v.getListIndex(O),S=v.getListRenderCount(O);return{...w,feedback:(0,e.$Rb)(k,k+S)}}drop(p,W,J,M){this.b.dispose(),this.a=void 0,this.f.drop(d(p),W&&W.element,J,M)}onDragEnd(p){this.f.onDragEnd?.(p)}dispose(){this.c.dispose(),this.f.dispose()}}function B(V,p){return p&&{...p,identityProvider:p.identityProvider&&{getId(W){return p.identityProvider.getId(W.element)}},dnd:p.dnd&&new E(V,p.dnd),multipleSelectionController:p.multipleSelectionController&&{isSelectionSingleChangeEvent(W){return p.multipleSelectionController.isSelectionSingleChangeEvent({...W,element:W.element})},isSelectionRangeChangeEvent(W){return p.multipleSelectionController.isSelectionRangeChangeEvent({...W,element:W.element})}},accessibilityProvider:p.accessibilityProvider&&{...p.accessibilityProvider,getSetSize(W){const J=V(),M=J.getNodeLocation(W),$=J.getParentNodeLocation(M);return J.getNode($).visibleChildrenCount},getPosInSet(W){return W.visibleChildIndex+1},isChecked:p.accessibilityProvider&&p.accessibilityProvider.isChecked?W=>p.accessibilityProvider.isChecked(W.element):void 0,getRole:p.accessibilityProvider&&p.accessibilityProvider.getRole?W=>p.accessibilityProvider.getRole(W.element):()=>"treeitem",getAriaLabel(W){return p.accessibilityProvider.getAriaLabel(W.element)},getWidgetAriaLabel(){return p.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:p.accessibilityProvider&&p.accessibilityProvider.getWidgetRole?()=>p.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:p.accessibilityProvider&&p.accessibilityProvider.getAriaLevel?W=>p.accessibilityProvider.getAriaLevel(W.element):W=>W.depth,getActiveDescendantId:p.accessibilityProvider.getActiveDescendantId&&(W=>p.accessibilityProvider.getActiveDescendantId(W.element))},keyboardNavigationLabelProvider:p.keyboardNavigationLabelProvider&&{...p.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(W){return p.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(W.element)}}}}class H{constructor(p){this.a=p}getHeight(p){return this.a.getHeight(p.element)}getTemplateId(p){return this.a.getTemplateId(p.element)}hasDynamicHeight(p){return!!this.a.hasDynamicHeight&&this.a.hasDynamicHeight(p.element)}setDynamicHeight(p,W){this.a.setDynamicHeight?.(p.element,W)}}t.$1S=H;class x{static lift(p){return p instanceof x?p:new x(p)}static empty(p=0){return new x({focus:[],selection:[],expanded:Object.create(null),scrollTop:p})}constructor(p){if(this.focus=new Set(p.focus),this.selection=new Set(p.selection),p.expanded instanceof Array){this.expanded=Object.create(null);for(const W of p.expanded)this.expanded[W]=1}else this.expanded=p.expanded;this.expanded=p.expanded,this.scrollTop=p.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.$2S=x;var C;(function(V){V.None="none",V.OnHover="onHover",V.Always="always"})(C||(t.RenderIndentGuides=C={}));class F{get elements(){return this.b}constructor(p,W=[]){this.b=W,this.a=new u.$Qc,this.onDidChange=r.Event.forEach(p,J=>this.b=J,this.a)}dispose(){this.a.dispose()}}class Q{static{this.a=8}constructor(p,W,J,M,$,w={}){this.o=p,this.p=W,this.q=M,this.s=$,this.b=new Map,this.c=new Map,this.d=Q.a,this.f=!1,this.g=!1,this.j=new Set,this.k=u.$Rc.None,this.m=new u.$Qc,this.templateId=p.templateId,this.updateOptions(w),r.Event.map(J,I=>I.node)(this.u,this,this.m),p.onDidChangeTwistieState?.(this.t,this,this.m)}updateOptions(p={}){if(typeof p.indent<"u"){const W=(0,o.$Sl)(p.indent,0,40);if(W!==this.d){this.d=W;for(const[J,M]of this.c)this.v(J,M)}}if(typeof p.renderIndentGuides<"u"){const W=p.renderIndentGuides!==C.None;if(W!==this.g){this.g=W;for(const[J,M]of this.c)this.w(J,M);if(this.k.dispose(),W){const J=new u.$Qc;this.q.onDidChange(this.x,this,J),this.k=J,this.x(this.q.elements)}}}typeof p.hideTwistiesOfChildlessElements<"u"&&(this.f=p.hideTwistiesOfChildlessElements)}renderTemplate(p){const W=(0,y.$UP)(p,(0,y.$)(".monaco-tl-row")),J=(0,y.$UP)(W,(0,y.$)(".monaco-tl-indent")),M=(0,y.$UP)(W,(0,y.$)(".monaco-tl-twistie")),$=(0,y.$UP)(W,(0,y.$)(".monaco-tl-contents")),w=this.o.renderTemplate($);return{container:p,indent:J,twistie:M,indentGuidesDisposable:u.$Rc.None,templateData:w}}renderElement(p,W,J,M){this.c.set(p,J),this.b.set(p.element,p),this.v(p,J),this.o.renderElement(p,W,J.templateData,M)}disposeElement(p,W,J,M){J.indentGuidesDisposable.dispose(),this.o.disposeElement?.(p,W,J.templateData,M),typeof M=="number"&&(this.c.delete(p),this.b.delete(p.element))}disposeTemplate(p){this.o.disposeTemplate(p.templateData)}t(p){const W=this.b.get(p);W&&this.u(W)}u(p){const W=this.c.get(p);W&&(this.x(this.q.elements),this.v(p,W))}v(p,W){const J=Q.a+(p.depth-1)*this.d;W.twistie.style.paddingLeft=`${J}px`,W.indent.style.width=`${J+this.d-16}px`,p.collapsible?W.container.setAttribute("aria-expanded",String(!p.collapsed)):W.container.removeAttribute("aria-expanded"),W.twistie.classList.remove(...m.ThemeIcon.asClassNameArray(l.$Yj.treeItemExpanded));let M=!1;this.o.renderTwistie&&(M=this.o.renderTwistie(p.element,W.twistie)),p.collapsible&&(!this.f||p.visibleChildrenCount>0)?(M||W.twistie.classList.add(...m.ThemeIcon.asClassNameArray(l.$Yj.treeItemExpanded)),W.twistie.classList.add("collapsible"),W.twistie.classList.toggle("collapsed",p.collapsed)):W.twistie.classList.remove("collapsible","collapsed"),this.w(p,W)}w(p,W){if((0,y.$XO)(W.indent),W.indentGuidesDisposable.dispose(),!this.g)return;const J=new u.$Qc,M=this.p();for(;;){const $=M.getNodeLocation(p),w=M.getParentNodeLocation($);if(!w)break;const I=M.getNode(w),v=(0,y.$)(".indent-guide",{style:`width: ${this.d}px`});this.j.has(I)&&v.classList.add("active"),W.indent.childElementCount===0?W.indent.appendChild(v):W.indent.insertBefore(v,W.indent.firstElementChild),this.s.add(I,v),J.add((0,u.$Pc)(()=>this.s.delete(I,v))),p=I}W.indentGuidesDisposable=J}x(p){if(!this.g)return;const W=new Set,J=this.p();p.forEach(M=>{const $=J.getNodeLocation(M);try{const w=J.getParentNodeLocation($);M.collapsible&&M.children.length>0&&!M.collapsed?W.add(M):w&&W.add(J.getNode(w))}catch{}}),this.j.forEach(M=>{W.has(M)||this.s.forEach(M,$=>$.classList.remove("active"))}),W.forEach(M=>{this.j.has(M)||this.s.forEach(M,$=>$.classList.add("active"))}),this.j=W}dispose(){this.c.clear(),this.b.clear(),this.k.dispose(),(0,u.$Mc)(this.m)}}class te{get totalCount(){return this.a}get matchCount(){return this.b}set pattern(p){this.c=p,this.d=p.toLowerCase()}constructor(p,W,J){this.g=p,this.j=W,this.k=J,this.a=0,this.b=0,this.c="",this.d="",this.f=new u.$Qc,p.onWillRefilter(this.m,this,this.f)}filter(p,W){let J=1;if(this.k){const w=this.k.filter(p,W);if(typeof w=="boolean"?J=w?1:0:(0,T.$XS)(w)?J=(0,T.$YS)(w.visibility):J=w,J===0)return!1}if(this.a++,!this.c)return this.b++,{data:b.FuzzyScore.Default,visibility:J};const M=this.j.getKeyboardNavigationLabel(p),$=Array.isArray(M)?M:[M];for(const w of $){const I=w&&w.toString();if(typeof I>"u")return{data:b.FuzzyScore.Default,visibility:J};let v;if(this.g.findMatchType===be.Contiguous){const O=I.toLowerCase().indexOf(this.d);if(O>-1){v=[Number.MAX_SAFE_INTEGER,0];for(let k=this.d.length;k>0;k--)v.push(O+k-1)}}else v=(0,b.$Tj)(this.c,this.d,0,I,I.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(v)return this.b++,$.length===1?{data:v,visibility:J}:{data:{label:I,score:v},visibility:J}}return this.g.findMode===oe.Filter?typeof this.g.options.defaultFindVisibility=="number"?this.g.options.defaultFindVisibility:this.g.options.defaultFindVisibility?this.g.options.defaultFindVisibility(p):2:{data:b.FuzzyScore.Default,visibility:J}}m(){this.a=0,this.b=0}dispose(){(0,u.$Mc)(this.f)}}class re extends f.$xR{constructor(p){super({icon:l.$Yj.listFilter,title:(0,z.localize)(0,null),isChecked:p.isChecked??!1,inputActiveOptionBorder:p.inputActiveOptionBorder,inputActiveOptionForeground:p.inputActiveOptionForeground,inputActiveOptionBackground:p.inputActiveOptionBackground})}}t.$3S=re;class fe extends f.$xR{constructor(p){super({icon:l.$Yj.searchFuzzy,title:(0,z.localize)(1,null),isChecked:p.isChecked??!1,inputActiveOptionBorder:p.inputActiveOptionBorder,inputActiveOptionForeground:p.inputActiveOptionForeground,inputActiveOptionBackground:p.inputActiveOptionBackground})}}t.$4S=fe;const ie={inputBoxStyles:A.$eS,toggleStyles:f.$vR,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var oe;(function(V){V[V.Highlight=0]="Highlight",V[V.Filter=1]="Filter"})(oe||(t.TreeFindMode=oe={}));var be;(function(V){V[V.Fuzzy=0]="Fuzzy",V[V.Contiguous=1]="Contiguous"})(be||(t.TreeFindMatchType=be={}));class Se extends u.$Rc{set mode(p){this.b.checked=p===oe.Filter,this.f.inputBox.setPlaceHolder(p===oe.Filter?(0,z.localize)(2,null):(0,z.localize)(3,null))}set matchType(p){this.c.checked=p===be.Fuzzy}get value(){return this.f.inputBox.value}set value(p){this.f.inputBox.value=p}constructor(p,W,J,M,$,w){super(),this.t=W,this.a=(0,y.h)(".monaco-tree-type-filter",[(0,y.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,y.h)(".monaco-tree-type-filter-input@findInput"),(0,y.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.j=0,this.m=0,this.s=0,this._onDidDisable=new r.$Od,this.onDidDisable=this._onDidDisable.event,p.appendChild(this.a.root),this.B((0,u.$Pc)(()=>p.removeChild(this.a.root)));const I=w?.styles??ie;I.listFilterWidgetBackground&&(this.a.root.style.backgroundColor=I.listFilterWidgetBackground),I.listFilterWidgetShadow&&(this.a.root.style.boxShadow=`0 0 8px 2px ${I.listFilterWidgetShadow}`),this.b=this.B(new re({...I.toggleStyles,isChecked:M===oe.Filter})),this.c=this.B(new fe({...I.toggleStyles,isChecked:$===be.Fuzzy})),this.onDidChangeMode=r.Event.map(this.b.onChange,()=>this.b.checked?oe.Filter:oe.Highlight,this.q),this.onDidChangeMatchType=r.Event.map(this.c.onChange,()=>this.c.checked?be.Fuzzy:be.Contiguous,this.q),this.f=this.B(new D.$uS(this.a.findInput,J,{label:(0,z.localize)(4,null),additionalToggles:[this.b,this.c],showCommonFindToggles:!1,inputBoxStyles:I.inputBoxStyles,toggleStyles:I.toggleStyles,history:w?.history})),this.g=this.B(new U.$NQ(this.a.actionbar)),this.mode=M;const v=this.B(new L.$VQ(this.f.inputBox.inputElement,"keydown")),O=r.Event.chain(v.event,K=>K.map(ee=>new i.$VO(ee)));this.B(O(K=>{if(K.equals(3)){K.preventDefault(),K.stopPropagation(),this.f.inputBox.addToHistory(),this.t.domFocus();return}if(K.equals(18)){K.preventDefault(),K.stopPropagation(),this.f.inputBox.isAtLastInHistory()||this.f.inputBox.isNowhereInHistory()?(this.f.inputBox.addToHistory(),this.t.domFocus()):this.f.inputBox.showNextValue();return}if(K.equals(16)){K.preventDefault(),K.stopPropagation(),this.f.inputBox.showPreviousValue();return}}));const k=this.B(new a.$yi("close",(0,z.localize)(5,null),"codicon codicon-close",!0,()=>this.dispose()));this.g.push(k,{icon:!0,label:!1});const S=this.B(new L.$VQ(this.a.grab,"mousedown"));this.B(S.event(K=>{const ee=new u.$Qc,se=ee.add(new L.$VQ((0,y.$AP)(K),"mousemove")),ge=ee.add(new L.$VQ((0,y.$AP)(K),"mouseup")),pe=this.m,Pe=K.pageX,Ae=this.s,De=K.pageY;this.a.grab.classList.add("grabbing");const Ie=this.a.root.style.transition;this.a.root.style.transition="unset";const Oe=_e=>{const He=_e.pageX-Pe;this.m=pe-He;const Me=_e.pageY-De;this.s=Ae+Me,this.layout()};ee.add(se.event(Oe)),ee.add(ge.event(_e=>{Oe(_e),this.a.grab.classList.remove("grabbing"),this.a.root.style.transition=Ie,ee.dispose()}))}));const j=r.Event.chain(this.B(new L.$VQ(this.a.grab,"keydown")).event,K=>K.map(ee=>new i.$VO(ee)));this.B(j(K=>{let ee,se;if(K.keyCode===15?ee=Number.POSITIVE_INFINITY:K.keyCode===17?ee=0:K.keyCode===10&&(ee=this.m===0?Number.POSITIVE_INFINITY:0),K.keyCode===16?se=0:K.keyCode===18&&(se=Number.POSITIVE_INFINITY),ee!==void 0&&(K.preventDefault(),K.stopPropagation(),this.m=ee,this.layout()),se!==void 0){K.preventDefault(),K.stopPropagation(),this.s=se;const ge=this.a.root.style.transition;this.a.root.style.transition="unset",this.layout(),setTimeout(()=>{this.a.root.style.transition=ge},0)}})),this.onDidChangeValue=this.f.onDidChange}getHistory(){return this.f.inputBox.getHistory()}focus(){this.f.focus()}select(){this.f.select(),this.f.inputBox.addToHistory(!0)}layout(p=this.j){this.j=p,this.m=(0,o.$Sl)(this.m,0,Math.max(0,p-212)),this.a.root.style.right=`${this.m}px`,this.s=(0,o.$Sl)(this.s,0,24),this.a.root.style.top=`${this.s}px`}showMessage(p){this.f.showMessage(p)}clearMessage(){this.f.clearMessage()}async dispose(){this._onDidDisable.fire(),this.a.root.classList.add("disabled"),await(0,h.$Vg)(300),super.dispose()}}class Le{get pattern(){return this.b}get mode(){return this.d}set mode(p){p!==this.d&&(this.d=p,this.g&&(this.g.mode=this.d),this.t.refilter(),this.A(),this.k.fire(p))}get matchType(){return this.f}set matchType(p){p!==this.f&&(this.f=p,this.g&&(this.g.matchType=this.f),this.t.refilter(),this.A(),this.m.fire(p))}constructor(p,W,J,M,$,w={}){this.t=p,this.u=J,this.v=M,this.w=$,this.x=w,this.b="",this.c="",this.j=0,this.k=new r.$Od,this.onDidChangeMode=this.k.event,this.m=new r.$Od,this.onDidChangeMatchType=this.m.event,this.o=new r.$Od,this.onDidChangePattern=this.o.event,this.p=new r.$Od,this.onDidChangeOpenState=this.p.event,this.q=new u.$Qc,this.s=new u.$Qc,this.d=p.options.defaultFindMode??oe.Highlight,this.f=p.options.defaultFindMatchType??be.Fuzzy,W.onDidSplice(this.z,this,this.s)}updateOptions(p={}){p.defaultFindMode!==void 0&&(this.mode=p.defaultFindMode),p.defaultFindMatchType!==void 0&&(this.matchType=p.defaultFindMatchType)}open(){if(this.g){this.g.focus(),this.g.select();return}this.g=new Se(this.u.getHTMLElement(),this.t,this.w,this.mode,this.matchType,{...this.x,history:this.a}),this.q.add(this.g),this.g.onDidChangeValue(this.y,this,this.q),this.g.onDidChangeMode(p=>this.mode=p,void 0,this.q),this.g.onDidChangeMatchType(p=>this.matchType=p,void 0,this.q),this.g.onDidDisable(this.close,this,this.q),this.g.layout(this.j),this.g.focus(),this.g.value=this.c,this.g.select(),this.p.fire(!0)}close(){this.g&&(this.a=this.g.getHistory(),this.g=void 0,this.q.clear(),this.c=this.pattern,this.y(""),this.t.domFocus(),this.p.fire(!1))}y(p){this.b=p,this.o.fire(p),this.v.pattern=p,this.t.refilter(),p&&this.t.focusNext(0,!0,void 0,J=>!b.FuzzyScore.isDefault(J.filterData));const W=this.t.getFocus();if(W.length>0){const J=W[0];this.t.getRelativeTop(J)===null&&this.t.reveal(J,.5)}this.A()}z(){!this.g||this.pattern.length===0||(this.t.refilter(),this.A())}A(){const p=this.v.totalCount>0&&this.v.matchCount===0;this.pattern&&p?this.t.options.showNotFoundMessage??!0?this.g?.showMessage({type:2,content:(0,z.localize)(6,null)}):this.g?.showMessage({type:2}):this.g?.clearMessage()}shouldAllowFocus(p){return!this.g||!this.pattern||this.d===oe.Filter||this.v.totalCount>0&&this.v.matchCount<=1?!0:!b.FuzzyScore.isDefault(p.filterData)}layout(p){this.j=p,this.g?.layout(p)}dispose(){this.a=void 0,this.o.dispose(),this.q.dispose(),this.s.dispose()}}function Fe(V){let p=s.TreeMouseEventTarget.Unknown;return(0,y.$qP)(V.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?p=s.TreeMouseEventTarget.Twistie:(0,y.$qP)(V.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?p=s.TreeMouseEventTarget.Element:(0,y.$qP)(V.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(p=s.TreeMouseEventTarget.Filter),{browserEvent:V.browserEvent,element:V.element?V.element.element:null,target:p}}function de(V){return{element:V.element?V.element.element:null,browserEvent:V.browserEvent,anchor:V.anchor}}function ne(V,p){p(V),V.children.forEach(W=>ne(W,p))}class ce{get f(){return this.d||(this.d=this.m()),this.d}constructor(p,W){this.g=p,this.j=W,this.a=[],this.c=new r.$Od,this.onDidChange=this.c.event}set(p,W){!W?.__forceEvent&&(0,e.$tb)(this.a,p)||this.k(p,!1,W)}k(p,W,J){if(this.a=[...p],this.b=void 0,this.d=void 0,!W){const M=this;this.c.fire({get elements(){return M.get()},browserEvent:J})}}get(){return this.b||(this.b=this.a.map(p=>p.element)),[...this.b]}getNodes(){return this.a}has(p){return this.f.has(p)}onDidModelSplice({insertedNodes:p,deletedNodes:W}){if(!this.j){const v=this.m(),O=k=>v.delete(k);W.forEach(k=>ne(k,O)),this.set([...v.values()]);return}const J=new Set,M=v=>J.add(this.j.getId(v.element).toString());W.forEach(v=>ne(v,M));const $=new Map,w=v=>$.set(this.j.getId(v.element).toString(),v);p.forEach(v=>ne(v,w));const I=[];for(const v of this.a){const O=this.j.getId(v.element).toString();if(!J.has(O))I.push(v);else{const S=$.get(O);S&&S.visible&&I.push(S)}}if(this.a.length>0&&I.length===0){const v=this.g();v&&I.push(v)}this.k(I,!0)}m(){const p=new Set;for(const W of this.a)p.add(W);return p}}class X extends g.$gR{constructor(p,W){super(p),this.x=W}u(p){if((0,g.$cR)(p.browserEvent.target)||(0,g.$aR)(p.browserEvent.target)||(0,g.$bR)(p.browserEvent.target)||p.browserEvent.isHandledByList)return;const W=p.element;if(!W)return super.u(p);if(this.p(p)||this.o(p))return super.u(p);const J=p.browserEvent.target,M=J.classList.contains("monaco-tl-twistie")||J.classList.contains("monaco-icon-label")&&J.classList.contains("folder-icon")&&p.browserEvent.offsetX<16;let $=!1;if(typeof this.x.expandOnlyOnTwistieClick=="function"?$=this.x.expandOnlyOnTwistieClick(W.element):$=!!this.x.expandOnlyOnTwistieClick,$&&!M&&p.browserEvent.detail!==2)return super.u(p);if(!this.x.expandOnDoubleClick&&p.browserEvent.detail===2)return super.u(p);if(W.collapsible){const w=this.x.getNodeLocation(W),I=p.browserEvent.altKey;if(this.x.setFocus([w]),this.x.toggleCollapsed(w,I),$&&M){p.browserEvent.isHandledByList=!0;return}}super.u(p)}v(p){p.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.x.expandOnDoubleClick||p.browserEvent.isHandledByList||super.v(p)}}class q extends g.$jR{constructor(p,W,J,M,$,w,I,v){super(p,W,J,M,v),this.p=$,this.s=w,this.K=I}D(p){return new X(this,p.tree)}splice(p,W,J=[]){if(super.splice(p,W,J),J.length===0)return;const M=[],$=[];let w;J.forEach((I,v)=>{this.p.has(I)&&M.push(p+v),this.s.has(I)&&$.push(p+v),this.K.has(I)&&(w=p+v)}),M.length>0&&super.setFocus((0,e.$Lb)([...super.getFocus(),...M])),$.length>0&&super.setSelection((0,e.$Lb)([...super.getSelection(),...$])),typeof w=="number"&&super.setAnchor(w)}setFocus(p,W,J=!1){super.setFocus(p,W),J||this.p.set(p.map(M=>this.element(M)),W)}setSelection(p,W,J=!1){super.setSelection(p,W),J||this.s.set(p.map(M=>this.element(M)),W)}setAnchor(p,W=!1){super.setAnchor(p),W||(typeof p>"u"?this.K.set([]):this.K.set([this.element(p)]))}}class G{get onDidScroll(){return this.j.onDidScroll}get onDidChangeFocus(){return this.w.wrapEvent(this.p.onDidChange)}get onDidChangeSelection(){return this.w.wrapEvent(this.q.onDidChange)}get onMouseClick(){return r.Event.map(this.j.onMouseClick,Fe)}get onMouseDblClick(){return r.Event.filter(r.Event.map(this.j.onMouseDblClick,Fe),p=>p.target!==s.TreeMouseEventTarget.Filter)}get onContextMenu(){return r.Event.map(this.j.onContextMenu,de)}get onTap(){return r.Event.map(this.j.onTap,Fe)}get onPointer(){return r.Event.map(this.j.onPointer,Fe)}get onKeyDown(){return this.j.onKeyDown}get onKeyUp(){return this.j.onKeyUp}get onKeyPress(){return this.j.onKeyPress}get onDidFocus(){return this.j.onDidFocus}get onDidBlur(){return this.j.onDidBlur}get onDidChangeModel(){return r.Event.signal(this.o.onDidSplice)}get onDidChangeCollapseState(){return this.o.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.o.onDidChangeRenderNodeCount}get findMode(){return this.x?.mode??oe.Highlight}set findMode(p){this.x&&(this.x.mode=p)}get findMatchType(){return this.x?.matchType??be.Fuzzy}set findMatchType(p){this.x&&(this.x.matchType=p)}get onDidChangeFindPattern(){return this.x?this.x.onDidChangePattern:r.Event.None}get expandOnDoubleClick(){return typeof this.E.expandOnDoubleClick>"u"?!0:this.E.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this.E.expandOnlyOnTwistieClick>"u"?!0:this.E.expandOnlyOnTwistieClick}get onDidDispose(){return this.j.onDidDispose}constructor(p,W,J,M,$={}){this.D=p,this.E=$,this.w=new r.$Wd,this.onDidChangeFindOpenState=r.Event.None,this.A=new u.$Qc,this.B=new r.$Od,this.onWillRefilter=this.B.event,this.C=new r.$Od,this.onDidUpdateOptions=this.C.event;const w=new H(J),I=new r.$Xd,v=new r.$Xd,O=this.A.add(new F(v.event)),k=new n.$Fc;this.k=M.map(se=>new Q(se,()=>this.o,I.event,O,k,$));for(const se of this.k)this.A.add(se);let S;$.keyboardNavigationLabelProvider&&(S=new te(this,$.keyboardNavigationLabelProvider,$.filter),$={...$,filter:S},this.A.add(S)),this.p=new ce(()=>this.j.getFocusedElements()[0],$.identityProvider),this.q=new ce(()=>this.j.getSelectedElements()[0],$.identityProvider),this.u=new ce(()=>this.j.getAnchorElement(),$.identityProvider),this.j=new q(p,W,w,this.k,this.p,this.q,this.u,{...B(()=>this.o,$),tree:this}),this.o=this.I(p,this.j,$),I.input=this.o.onDidChangeCollapseState;const j=r.Event.forEach(this.o.onDidSplice,se=>{this.w.bufferEvents(()=>{this.p.onDidModelSplice(se),this.q.onDidModelSplice(se)})},this.A);j(()=>null,null,this.A);const K=this.A.add(new r.$Od),ee=this.A.add(new h.$Rg(0));if(this.A.add(r.Event.any(j,this.p.onDidChange,this.q.onDidChange)(()=>{ee.trigger(()=>{const se=new Set;for(const ge of this.p.getNodes())se.add(ge);for(const ge of this.q.getNodes())se.add(ge);K.fire([...se.values()])})})),v.input=K.event,$.keyboardSupport!==!1){const se=r.Event.chain(this.j.onKeyDown,ge=>ge.filter(pe=>!(0,g.$aR)(pe.target)).map(pe=>new i.$VO(pe)));r.Event.chain(se,ge=>ge.filter(pe=>pe.keyCode===15))(this.F,this,this.A),r.Event.chain(se,ge=>ge.filter(pe=>pe.keyCode===17))(this.G,this,this.A),r.Event.chain(se,ge=>ge.filter(pe=>pe.keyCode===10))(this.H,this,this.A)}if(($.findWidgetEnabled??!0)&&$.keyboardNavigationLabelProvider&&$.contextViewProvider){const se=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.x=new Le(this,this.o,this.j,S,$.contextViewProvider,se),this.y=ge=>this.x.shouldAllowFocus(ge),this.onDidChangeFindOpenState=this.x.onDidChangeOpenState,this.A.add(this.x),this.onDidChangeFindMode=this.x.onDidChangeMode,this.onDidChangeFindMatchType=this.x.onDidChangeMatchType}else this.onDidChangeFindMode=r.Event.None,this.onDidChangeFindMatchType=r.Event.None;this.z=(0,y.$DP)(this.j.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this.E.renderIndentGuides===C.Always)}updateOptions(p={}){this.E={...this.E,...p};for(const W of this.k)W.updateOptions(p);this.j.updateOptions(this.E),this.x?.updateOptions(p),this.C.fire(this.E),this.getHTMLElement().classList.toggle("always",this.E.renderIndentGuides===C.Always)}get options(){return this.E}updateWidth(p){const W=this.o.getListIndex(p);W!==-1&&this.j.updateWidth(W)}getHTMLElement(){return this.j.getHTMLElement()}get contentHeight(){return this.j.contentHeight}get contentWidth(){return this.j.contentWidth}get onDidChangeContentHeight(){return this.j.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.j.onDidChangeContentWidth}get scrollTop(){return this.j.scrollTop}set scrollTop(p){this.j.scrollTop=p}get scrollLeft(){return this.j.scrollLeft}set scrollLeft(p){this.j.scrollLeft=p}get scrollHeight(){return this.j.scrollHeight}get renderHeight(){return this.j.renderHeight}get firstVisibleElement(){const p=this.j.firstVisibleIndex;return p<0||p>=this.j.length?void 0:this.j.element(p).element}get lastVisibleElement(){const p=this.j.lastVisibleIndex;return this.j.element(p).element}get ariaLabel(){return this.j.ariaLabel}set ariaLabel(p){this.j.ariaLabel=p}get selectionSize(){return this.q.getNodes().length}domFocus(){this.j.domFocus()}isDOMFocused(){return(0,y.$vP)(this.getHTMLElement())}layout(p,W){this.j.layout(p,W),(0,N.$Df)(W)&&this.x?.layout(W)}style(p){const W=`.${this.j.domId}`,J=[];p.treeIndentGuidesStroke&&(J.push(`.monaco-list${W}:hover .monaco-tl-indent > .indent-guide, .monaco-list${W}.always .monaco-tl-indent > .indent-guide  { border-color: ${p.treeInactiveIndentGuidesStroke}; }`),J.push(`.monaco-list${W} .monaco-tl-indent > .indent-guide.active { border-color: ${p.treeIndentGuidesStroke}; }`)),this.z.textContent=J.join(`
`),this.j.style(p)}getParentElement(p){const W=this.o.getParentNodeLocation(p);return this.o.getNode(W).element}getFirstElementChild(p){return this.o.getFirstElementChild(p)}getNode(p){return this.o.getNode(p)}getNodeLocation(p){return this.o.getNodeLocation(p)}collapse(p,W=!1){return this.o.setCollapsed(p,!0,W)}expand(p,W=!1){return this.o.setCollapsed(p,!1,W)}toggleCollapsed(p,W=!1){return this.o.setCollapsed(p,void 0,W)}expandAll(){this.o.setCollapsed(this.o.rootRef,!1,!0)}collapseAll(){this.o.setCollapsed(this.o.rootRef,!0,!0)}isCollapsible(p){return this.o.isCollapsible(p)}setCollapsible(p,W){return this.o.setCollapsible(p,W)}isCollapsed(p){return this.o.isCollapsed(p)}expandTo(p){this.o.expandTo(p)}triggerTypeNavigation(){this.j.triggerTypeNavigation()}openFind(){this.x?.open()}closeFind(){this.x?.close()}refilter(){this.B.fire(void 0),this.o.refilter()}setAnchor(p){if(typeof p>"u")return this.j.setAnchor(void 0);const W=this.o.getNode(p);this.u.set([W]);const J=this.o.getListIndex(p);J>-1&&this.j.setAnchor(J,!0)}getAnchor(){return(0,e.$Nb)(this.u.get(),void 0)}setSelection(p,W){const J=p.map($=>this.o.getNode($));this.q.set(J,W);const M=p.map($=>this.o.getListIndex($)).filter($=>$>-1);this.j.setSelection(M,W,!0)}getSelection(){return this.q.get()}setFocus(p,W){const J=p.map($=>this.o.getNode($));this.p.set(J,W);const M=p.map($=>this.o.getListIndex($)).filter($=>$>-1);this.j.setFocus(M,W,!0)}focusNext(p=1,W=!1,J,M=this.y){this.j.focusNext(p,W,J,M)}focusPrevious(p=1,W=!1,J,M=this.y){this.j.focusPrevious(p,W,J,M)}focusNextPage(p,W=this.y){return this.j.focusNextPage(p,W)}focusPreviousPage(p,W=this.y){return this.j.focusPreviousPage(p,W)}focusLast(p,W=this.y){this.j.focusLast(p,W)}focusFirst(p,W=this.y){this.j.focusFirst(p,W)}getFocus(){return this.p.get()}reveal(p,W){this.o.expandTo(p);const J=this.o.getListIndex(p);J!==-1&&this.j.reveal(J,W)}getRelativeTop(p){const W=this.o.getListIndex(p);return W===-1?null:this.j.getRelativeTop(W)}getViewState(p=this.options.identityProvider){if(!p)throw new s.$VS(this.D,"Can't get tree view state without an identity provider");const W=w=>p.getId(w).toString(),J=x.empty(this.scrollTop);for(const w of this.getFocus())J.focus.add(W(w));for(const w of this.getSelection())J.selection.add(W(w));const M=this.o.getNode(),$=[M];for(;$.length>0;){const w=$.shift();w!==M&&w.collapsible&&(J.expanded[W(w.element)]=w.collapsed?0:1),$.push(...w.children)}return J}F(p){p.preventDefault(),p.stopPropagation();const W=this.j.getFocusedElements();if(W.length===0)return;const J=W[0],M=this.o.getNodeLocation(J);if(!this.o.setCollapsed(M,!0)){const w=this.o.getParentNodeLocation(M);if(!w)return;const I=this.o.getListIndex(w);this.j.reveal(I),this.j.setFocus([I])}}G(p){p.preventDefault(),p.stopPropagation();const W=this.j.getFocusedElements();if(W.length===0)return;const J=W[0],M=this.o.getNodeLocation(J);if(!this.o.setCollapsed(M,!1)){if(!J.children.some(v=>v.visible))return;const[w]=this.j.getFocus(),I=w+1;this.j.reveal(I),this.j.setFocus([I])}}H(p){p.preventDefault(),p.stopPropagation();const W=this.j.getFocusedElements();if(W.length===0)return;const J=W[0],M=this.o.getNodeLocation(J),$=p.browserEvent.altKey;this.o.setCollapsed(M,void 0,$)}navigate(p){return new P(this.j,this.o,p)}dispose(){(0,u.$Mc)(this.A),this.j.dispose()}}t.$5S=G;class P{constructor(p,W,J){this.b=p,this.c=W,J?this.a=this.c.getListIndex(J):this.a=-1}current(){return this.a<0||this.a>=this.b.length?null:this.b.element(this.a).element}previous(){return this.a--,this.current()}next(){return this.a++,this.current()}first(){return this.a=0,this.current()}last(){return this.a=this.b.length-1,this.current()}}}),define($e[131],we([1,0,130,121,25,27]),function(le,t,y,L,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dT=void 0;class D extends y.$5S{constructor(c,g,f,T,s,a={}){super(c,g,f,T,a),this.f=c,this.g=s,this.d=new Map,this.c=a.identityProvider}getInput(){return this.b}setInput(c,g){if(g&&!this.c)throw new i.$VS(this.f,"Can't restore tree view state without an identity provider");if(this.b=c,!c){this.d.clear(),this.o.setChildren(null,U.Iterable.empty());return}if(!g){this.m(c);return}const f=[],T=[],s=e=>{const h=this.c.getId(e).toString();return!g.expanded[h]},a=e=>{const h=this.c.getId(e.element).toString();g.focus.has(h)&&f.push(e.element),g.selection.has(h)&&T.push(e.element)};this.m(c,s,a),this.setFocus(f),this.setSelection(T),g&&typeof g.scrollTop=="number"&&(this.scrollTop=g.scrollTop)}updateChildren(c=this.b){if(typeof this.b>"u")throw new i.$VS(this.f,"Tree input not set");let g;this.c&&(g=f=>{const T=this.c.getId(f).toString(),s=this.d.get(T);if(s)return s.collapsed}),this.m(c,g)}resort(c=this.b,g=!0){this.o.resort(c===this.b?null:c,g)}refresh(c){if(c===void 0){this.j.rerender();return}this.o.rerender(c)}m(c,g,f){let T;if(this.c){const s=new Set,a=f;f=e=>{const h=this.c.getId(e.element).toString();s.add(h),this.d.set(h,e),a?.(e)},T=e=>{const h=this.c.getId(e.element).toString();s.has(h)||this.d.delete(h)}}this.o.setChildren(c===this.b?null:c,this.s(c,g).elements,{onDidCreateNode:f,onDidDeleteNode:T})}s(c,g){const f=[...this.g.getChildren(c)];return{elements:U.Iterable.map(f,s=>{const{elements:a,size:e}=this.s(s,g),h=this.g.hasChildren?this.g.hasChildren(s):void 0,l=e===0?void 0:g&&g(s);return{element:s,children:a,collapsible:h,collapsed:l}}),size:f.length}}I(c,g,f){return new L.$6S(c,g,f)}}t.$dT=D}),define($e[67],we([1,0,11,9,33,29,26,6,4,2,53,12,7]),function(le,t,y,L,i,U,D,A,c,g,f,T,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ch=t.ProxyChannel=t.$Bh=t.$Ah=t.$zh=t.$yh=t.$xh=t.$wh=t.RequestInitiator=t.$vh=t.$uh=t.$th=t.$sh=t.$rh=void 0;var a;(function(de){de[de.Promise=100]="Promise",de[de.PromiseCancel=101]="PromiseCancel",de[de.EventListen=102]="EventListen",de[de.EventDispose=103]="EventDispose"})(a||(a={}));function e(de){switch(de){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function(de){de[de.Initialize=200]="Initialize",de[de.PromiseSuccess=201]="PromiseSuccess",de[de.PromiseError=202]="PromiseError",de[de.PromiseErrorObj=203]="PromiseErrorObj",de[de.EventFire=204]="EventFire"})(h||(h={}));function l(de){switch(de){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(de){de[de.Uninitialized=0]="Uninitialized",de[de.Idle=1]="Idle"})(m||(m={}));function n(de){let ne=0;for(let ce=0;;ce+=7){const X=de.read(1);if(ne|=(X.buffer[0]&127)<<ce,!(X.buffer[0]&128))return ne}}const r=z(0);function b(de,ne){if(ne===0){de.write(r);return}let ce=0;for(let q=ne;q!==0;q=q>>>7)ce++;const X=i.$ce.alloc(ce);for(let q=0;ne!==0;q++)X.buffer[q]=ne&127,ne=ne>>>7,ne>0&&(X.buffer[q]|=128);de.write(X)}class u{constructor(ne){this.b=ne,this.a=0}read(ne){const ce=this.b.slice(this.a,this.a+ne);return this.a+=ce.byteLength,ce}}t.$rh=u;class o{constructor(){this.a=[]}get buffer(){return i.$ce.concat(this.a)}write(ne){this.a.push(ne)}}t.$sh=o;var N;(function(de){de[de.Undefined=0]="Undefined",de[de.String=1]="String",de[de.Buffer=2]="Buffer",de[de.VSBuffer=3]="VSBuffer",de[de.Array=4]="Array",de[de.Object=5]="Object",de[de.Int=6]="Int"})(N||(N={}));function z(de){const ne=i.$ce.alloc(1);return ne.writeUInt8(de,0),ne}const R={Undefined:z(N.Undefined),String:z(N.String),Buffer:z(N.Buffer),VSBuffer:z(N.VSBuffer),Array:z(N.Array),Object:z(N.Object),Uint:z(N.Int)},d=typeof Buffer<"u";function E(de,ne){if(typeof ne>"u")de.write(R.Undefined);else if(typeof ne=="string"){const ce=i.$ce.fromString(ne);de.write(R.String),b(de,ce.byteLength),de.write(ce)}else if(d&&Buffer.isBuffer(ne)){const ce=i.$ce.wrap(ne);de.write(R.Buffer),b(de,ce.byteLength),de.write(ce)}else if(ne instanceof i.$ce)de.write(R.VSBuffer),b(de,ne.byteLength),de.write(ne);else if(Array.isArray(ne)){de.write(R.Array),b(de,ne.length);for(const ce of ne)E(de,ce)}else if(typeof ne=="number"&&(ne|0)===ne)de.write(R.Uint),b(de,ne);else{const ce=i.$ce.fromString(JSON.stringify(ne));de.write(R.Object),b(de,ce.byteLength),de.write(ce)}}t.$th=E;function B(de){switch(de.read(1).readUInt8(0)){case N.Undefined:return;case N.String:return de.read(n(de)).toString();case N.Buffer:return de.read(n(de)).buffer;case N.VSBuffer:return de.read(n(de));case N.Array:{const ce=n(de),X=[];for(let q=0;q<ce;q++)X.push(B(de));return X}case N.Object:return JSON.parse(de.read(n(de)).toString());case N.Int:return n(de)}}t.$uh=B;class H{constructor(ne,ce,X=null,q=1e3){this.h=ne,this.j=ce,this.k=X,this.l=q,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(G=>this.q(G)),this.m({type:200})}registerChannel(ne,ce){this.b.set(ne,ce),setTimeout(()=>this.w(ne),0)}m(ne){switch(ne.type){case 200:{const ce=this.o([ne.type]);this.k?.logOutgoing(ce,0,1,l(ne.type));return}case 201:case 202:case 204:case 203:{const ce=this.o([ne.type,ne.id],ne.data);this.k?.logOutgoing(ce,ne.id,1,l(ne.type),ne.data);return}}}o(ne,ce=void 0){const X=new o;return E(X,ne),E(X,ce),this.p(X.buffer)}p(ne){try{return this.h.send(ne),ne.byteLength}catch{return 0}}q(ne){const ce=new u(ne),X=B(ce),q=B(ce),G=X[0];switch(G){case 100:return this.k?.logIncoming(ne.byteLength,X[1],1,`${e(G)}: ${X[2]}.${X[3]}`,q),this.s({type:G,id:X[1],channelName:X[2],name:X[3],arg:q});case 102:return this.k?.logIncoming(ne.byteLength,X[1],1,`${e(G)}: ${X[2]}.${X[3]}`,q),this.t({type:G,id:X[1],channelName:X[2],name:X[3],arg:q});case 101:return this.k?.logIncoming(ne.byteLength,X[1],1,`${e(G)}`),this.u({type:G,id:X[1]});case 103:return this.k?.logIncoming(ne.byteLength,X[1],1,`${e(G)}`),this.u({type:G,id:X[1]})}}s(ne){const ce=this.b.get(ne.channelName);if(!ce){this.v(ne);return}const X=new U.$Yd;let q;try{q=ce.call(this.j,ne.name,ne.arg,X.token)}catch(V){q=Promise.reject(V)}const G=ne.id;q.then(V=>{this.m({id:G,data:V,type:201})},V=>{V instanceof Error?this.m({id:G,data:{message:V.message,name:V.name,stack:V.stack?V.stack.split?V.stack.split(`
`):V.stack:void 0},type:202}):this.m({id:G,data:V,type:203})}).finally(()=>{P.dispose(),this.d.delete(ne.id)});const P=(0,g.$Pc)(()=>X.cancel());this.d.set(ne.id,P)}t(ne){const ce=this.b.get(ne.channelName);if(!ce){this.v(ne);return}const X=ne.id,G=ce.listen(this.j,ne.name,ne.arg)(P=>this.m({id:X,data:P,type:204}));this.d.set(ne.id,G)}u(ne){const ce=this.d.get(ne.id);ce&&(ce.dispose(),this.d.delete(ne.id))}v(ne){let ce=this.g.get(ne.channelName);ce||(ce=[],this.g.set(ne.channelName,ce));const X=setTimeout(()=>{console.error(`Unknown channel: ${ne.channelName}`),ne.type===100&&this.m({id:ne.id,data:{name:"Unknown channel",message:`Channel name '${ne.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ce.push({request:ne,timeoutTimer:X})}w(ne){const ce=this.g.get(ne);if(ce){for(const X of ce)switch(clearTimeout(X.timeoutTimer),X.request.type){case 100:this.s(X.request);break;case 102:this.t(X.request);break}this.g.delete(ne)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,g.$Mc)(this.d.values()),this.d.clear()}}t.$vh=H;var x;(function(de){de[de.LocalSide=0]="LocalSide",de[de.OtherSide=1]="OtherSide"})(x||(t.RequestInitiator=x={}));class C{constructor(ne,ce=null){this.l=ne,this.a=!1,this.b=m.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new c.$Od,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(X=>this.s(X)),this.j=ce}getChannel(ne){const ce=this;return{call(X,q,G){return ce.a?Promise.reject(new A.$4):ce.m(ne,X,q,G)},listen(X,q){return ce.a?c.Event.None:ce.o(ne,X,q)}}}m(ne,ce,X,q=U.CancellationToken.None){const G=this.g++,V={id:G,type:100,channelName:ne,name:ce,arg:X};if(q.isCancellationRequested)return Promise.reject(new A.$4);let p;return new Promise((J,M)=>{if(q.isCancellationRequested)return M(new A.$4);const $=()=>{const O=k=>{switch(k.type){case 201:this.f.delete(G),J(k.data);break;case 202:{this.f.delete(G);const S=new Error(k.data.message);S.stack=Array.isArray(k.data.stack)?k.data.stack.join(`
`):k.data.stack,S.name=k.data.name,M(S);break}case 203:this.f.delete(G),M(k.data);break}};this.f.set(G,O),this.p(V)};let w=null;this.b===m.Idle?$():(w=(0,L.$Ig)(O=>this.u()),w.then(()=>{w=null,$()}));const I=()=>{w?(w.cancel(),w=null):this.p({id:G,type:101}),M(new A.$4)},v=q.onCancellationRequested(I);p=(0,g.$Oc)((0,g.$Pc)(I),v),this.d.add(p)}).finally(()=>{p.dispose(),this.d.delete(p)})}o(ne,ce,X){const q=this.g++,P={id:q,type:102,channelName:ne,name:ce,arg:X};let V=null;const p=new c.$Od({onWillAddFirstListener:()=>{V=(0,L.$Ig)(J=>this.u()),V.then(()=>{V=null,this.d.add(p),this.p(P)})},onDidRemoveLastListener:()=>{V?(V.cancel(),V=null):(this.d.delete(p),this.p({id:q,type:103}))}}),W=J=>p.fire(J.data);return this.f.set(q,W),p.event}p(ne){switch(ne.type){case 100:case 102:{const ce=this.q([ne.type,ne.id,ne.channelName,ne.name],ne.arg);this.j?.logOutgoing(ce,ne.id,0,`${e(ne.type)}: ${ne.channelName}.${ne.name}`,ne.arg);return}case 101:case 103:{const ce=this.q([ne.type,ne.id]);this.j?.logOutgoing(ce,ne.id,0,e(ne.type));return}}}q(ne,ce=void 0){const X=new o;return E(X,ne),E(X,ce),this.r(X.buffer)}r(ne){try{return this.l.send(ne),ne.byteLength}catch{return 0}}s(ne){const ce=new u(ne),X=B(ce),q=B(ce),G=X[0];switch(G){case 200:return this.j?.logIncoming(ne.byteLength,0,0,l(G)),this.t({type:X[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(ne.byteLength,X[1],0,l(G),q),this.t({type:X[0],id:X[1],data:q})}}t(ne){if(ne.type===200){this.b=m.Idle,this.k.fire();return}this.f.get(ne.id)?.(ne)}get onDidInitializePromise(){return c.Event.toPromise(this.onDidInitialize)}u(){return this.b===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,g.$Mc)(this.d.values()),this.d.clear()}}t.$wh=C,Xe([D.$lh],C.prototype,"onDidInitializePromise",null);class F{get connections(){const ne=[];return this.f.forEach(ce=>ne.push(ce)),ne}constructor(ne){this.a=new Map,this.f=new Set,this.g=new c.$Od,this.onDidAddConnection=this.g.event,this.h=new c.$Od,this.onDidRemoveConnection=this.h.event,this.j=new g.$Qc,this.j.add(ne(({protocol:ce,onDidClientDisconnect:X})=>{const q=c.Event.once(ce.onMessage);this.j.add(q(G=>{const P=new u(G),V=B(P),p=new H(ce,V),W=new C(ce);this.a.forEach((M,$)=>p.registerChannel($,M));const J={channelServer:p,channelClient:W,ctx:V};this.f.add(J),this.g.fire(J),this.j.add(X(()=>{p.dispose(),W.dispose(),this.f.delete(J),this.h.fire(J)}))}))}))}getChannel(ne,ce){const X=this;return{call(q,G,P){let V;if((0,s.$Nf)(ce)){const W=(0,y.$3b)(X.connections.filter(ce));V=W?Promise.resolve(W):c.Event.toPromise(c.Event.filter(X.onDidAddConnection,ce))}else V=ce.routeCall(X,q,G);const p=V.then(W=>W.channelClient.getChannel(ne));return te(p).call(q,G,P)},listen(q,G){if((0,s.$Nf)(ce))return X.k(ne,ce,q,G);const P=ce.routeEvent(X,q,G).then(V=>V.channelClient.getChannel(ne));return te(P).listen(q,G)}}}k(ne,ce,X,q){const G=this;let P;const V=new c.$Od({onWillAddFirstListener:()=>{P=new g.$Qc;const p=new c.$Ud,W=new Map,J=$=>{const I=$.channelClient.getChannel(ne).listen(X,q),v=p.add(I);W.set($,v)},M=$=>{const w=W.get($);w&&(w.dispose(),W.delete($))};G.connections.filter(ce).forEach(J),c.Event.filter(G.onDidAddConnection,ce)(J,void 0,P),G.onDidRemoveConnection(M,void 0,P),p.event(V.fire,V,P),P.add(p)},onDidRemoveLastListener:()=>{P?.dispose(),P=void 0}});return V.event}registerChannel(ne,ce){this.a.set(ne,ce);for(const X of this.f)X.channelServer.registerChannel(ne,ce)}dispose(){this.j.dispose();for(const ne of this.f)ne.channelClient.dispose(),ne.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}t.$xh=F;class Q{constructor(ne,ce,X=null){const q=new o;E(q,ce),ne.send(q.buffer),this.a=new C(ne,X),this.d=new H(ne,ce,X)}getChannel(ne){return this.a.getChannel(ne)}registerChannel(ne,ce){this.d.registerChannel(ne,ce)}dispose(){this.a.dispose(),this.d.dispose()}}t.$yh=Q;function te(de){return{call(ne,ce,X){return de.then(q=>q.call(ne,ce,X))},listen(ne,ce){const X=new c.$Xd;return de.then(q=>X.input=q.listen(ne,ce)),X.event}}}t.$zh=te;function re(de){let ne=!1;return{call(ce,X,q){return ne?de.call(ce,X,q):(0,L.$Vg)(0).then(()=>ne=!0).then(()=>de.call(ce,X,q))},listen(ce,X){if(ne)return de.listen(ce,X);const q=new c.$Xd;return(0,L.$Vg)(0).then(()=>ne=!0).then(()=>q.input=de.listen(ce,X)),q.event}}}t.$Ah=re;class fe{constructor(ne){this.a=ne}routeCall(ne){return this.b(ne)}routeEvent(ne){return this.b(ne)}async b(ne){for(const ce of ne.connections)if(await Promise.resolve(this.a(ce.ctx)))return Promise.resolve(ce);return await c.Event.toPromise(ne.onDidAddConnection),await this.b(ne)}}t.$Bh=fe;var ie;(function(de){function ne(G,P,V){const p=G,W=V&&V.disableMarshalling,J=new Map;for(const M in p)X(M)&&J.set(M,c.Event.buffer(p[M],!0,void 0,P));return new class{listen(M,$,w){const I=J.get($);if(I)return I;if(q($)){const v=p[$];if(typeof v=="function")return v.call(p,w)}throw new A.$ab(`Event not found: ${$}`)}call(M,$,w){const I=p[$];if(typeof I=="function"){if(!W&&Array.isArray(w))for(let O=0;O<w.length;O++)w[O]=(0,f.$qh)(w[O]);let v=I.apply(p,w);return v instanceof Promise||(v=Promise.resolve(v)),v}throw new A.$ab(`Method not found: ${$}`)}}}de.fromService=ne;function ce(G,P){const V=P&&P.disableMarshalling;return new Proxy({},{get(p,W){if(typeof W=="string")return P?.properties?.has(W)?P.properties.get(W):q(W)?function(J){return G.listen(W,J)}:X(W)?G.listen(W):async function(...J){let M;P&&!(0,s.$If)(P.context)?M=[P.context,...J]:M=J;const $=await G.call(W,M);return V?$:(0,f.$qh)($)};throw new A.$ab(`Property not found: ${String(W)}`)}})}de.toService=ce;function X(G){return G[0]==="o"&&G[1]==="n"&&T.$2e(G.charCodeAt(2))}function q(G){return/^onDynamic/.test(G)&&T.$2e(G.charCodeAt(9))}})(ie||(t.ProxyChannel=ie={}));const oe=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function be(de){if(Array.isArray(de))return de;if(de&&typeof de=="object"&&typeof de.toString=="function"){const ne=de.toString();if(ne!=="[object Object]")return ne}return de}function Se(de){return Array.isArray(de)?de.map(be):be(de)}function Le(de,ne,ce,X,q,G,P){P=Se(P);const V=oe[q],p=V[X%V.length];let W=[`%c[${de}]%c[${String(ne).padStart(7," ")}]%c[len: ${String(ce).padStart(5," ")}]%c${String(X).padStart(5," ")} - ${G}`,"color: darkgreen","color: grey","color: grey",`color: ${p}`];/\($/.test(G)?(W=W.concat(P),W.push(")")):W.push(P),console.log.apply(console,W)}class Fe{constructor(ne,ce){this.d=ne,this.f=ce,this.a=0,this.b=0}logOutgoing(ne,ce,X,q,G){this.b+=ne,Le(this.d,this.b,ne,ce,X,q,G)}logIncoming(ne,ce,X,q,G){this.a+=ne,Le(this.f,this.a,ne,ce,X,q,G)}}t.$Ch=Fe}),define($e[31],we([1,0,5]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$R=t.$Q=t.$P=t.$O=t.$N=void 0,t.$N=y.$h.vscode.ipcRenderer,t.$O=y.$h.vscode.ipcMessagePort,t.$P=y.$h.vscode.webFrame,t.$Q=y.$h.vscode.process,t.$R=y.$h.vscode.context}),define($e[132],we([1,0,88,31]),function(le,t,y,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$OT=void 0;let i=0;function U(A,c,g){const f=[],T=i++,s=`vscode:onContextMenu${T}`,a=(e,h,l)=>{f[h].click?.(l)};L.$N.once(s,a),L.$N.once(y.$LT,(e,h)=>{h===T&&(L.$N.removeListener(s,a),g?.())}),L.$N.send(y.$KT,T,A.map(e=>D(e,f)),s,c)}t.$OT=U;function D(A,c){const g={id:c.length,label:A.label,type:A.type,accelerator:A.accelerator,checked:A.checked,enabled:typeof A.enabled=="boolean"?A.enabled:!0,visible:typeof A.visible=="boolean"?A.visible:!0};return c.push(A),Array.isArray(A.submenu)&&(g.submenu=A.submenu.map(f=>D(f,c))),g}}),define($e[133],we([1,0,33,4,67,89,31]),function(le,t,y,L,i,U,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$WT=void 0;class A extends i.$yh{static f(){const g=L.Event.fromNodeEventEmitter(D.$N,"vscode:message",(f,T)=>y.$ce.wrap(T));return D.$N.send("vscode:hello"),new U.$ST(D.$N,g)}constructor(g){const f=A.f();super(f,g),this.b=f}dispose(){this.b.disconnect()}}t.$WT=A}),define($e[134],we([13,10]),function(le,t){return le.create("vs/platform/files/common/files",t)}),define($e[135],we([13,10]),function(le,t){return le.create("vs/platform/theme/common/iconRegistry",t)}),define($e[40],we([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Uh=t.$Th=t.$Sh=t._util=void 0;var y;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function A(c){return c[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=A})(y||(t._util=y={})),t.$Sh=i("instantiationService");function L(D,A,c){A[y.DI_TARGET]===A?A[y.DI_DEPENDENCIES].push({id:D,index:c}):(A[y.DI_DEPENDENCIES]=[{id:D,index:c}],A[y.DI_TARGET]=A)}function i(D){if(y.serviceIds.has(D))return y.serviceIds.get(D);const A=function(c,g,f){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(A,c,f)};return A.toString=()=>D,y.serviceIds.set(D,A),A}t.$Th=i;function U(D){return D}t.$Uh=U}),define($e[136],we([1,0,40]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wm=t.$vm=t.$um=t.ID=void 0,t.ID="diagnosticsService",t.$um=(0,y.$Th)(t.ID);function L(U){return!!U.hostName&&!!U.errorMessage}t.$vm=L;class i{async getPerformanceInfo(D,A){return{}}async getSystemInfo(D,A){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,A){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}t.$wm=i}),define($e[137],we([1,0,87,23,12,7,16,134,40,5,30,28]),function(le,t,y,L,i,U,D,A,c,g,f,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Lk=t.$Kk=t.$Jk=t.$Ik=t.$Hk=t.FileKind=t.$Gk=t.$Fk=t.$Ek=t.$Dk=t.$Ck=t.$Bk=t.$Ak=t.FileOperationResult=t.$zk=t.$yk=t.$xk=t.$wk=t.$vk=t.FileChangeType=t.$uk=t.FileOperation=t.$tk=t.$sk=t.$rk=t.$qk=t.$pk=t.$ok=t.FileSystemProviderErrorCode=t.$nk=t.$mk=t.$lk=t.$kk=t.$jk=t.$ik=t.$hk=t.$gk=t.$fk=t.FileSystemProviderCapabilities=t.$ek=t.FilePermission=t.FileType=t.$dk=t.$ck=void 0,t.$ck=(0,c.$Th)("fileService");function s(q){return q.create===!0}t.$dk=s;var a;(function(q){q[q.Unknown=0]="Unknown",q[q.File=1]="File",q[q.Directory=2]="Directory",q[q.SymbolicLink=64]="SymbolicLink"})(a||(t.FileType=a={}));var e;(function(q){q[q.Readonly=1]="Readonly",q[q.Locked=2]="Locked"})(e||(t.FilePermission=e={}));function h(q){const G=q;return!!G&&typeof G.onDidChange=="function"}t.$ek=h;var l;(function(q){q[q.None=0]="None",q[q.FileReadWrite=2]="FileReadWrite",q[q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",q[q.FileReadStream=16]="FileReadStream",q[q.FileFolderCopy=8]="FileFolderCopy",q[q.PathCaseSensitive=1024]="PathCaseSensitive",q[q.Readonly=2048]="Readonly",q[q.Trash=4096]="Trash",q[q.FileWriteUnlock=8192]="FileWriteUnlock",q[q.FileAtomicRead=16384]="FileAtomicRead",q[q.FileAtomicWrite=32768]="FileAtomicWrite",q[q.FileAtomicDelete=65536]="FileAtomicDelete",q[q.FileClone=131072]="FileClone"})(l||(t.FileSystemProviderCapabilities=l={}));function m(q){return!!(q.capabilities&2)}t.$fk=m;function n(q){return!!(q.capabilities&8)}t.$gk=n;function r(q){return!!(q.capabilities&131072)}t.$hk=r;function b(q){return!!(q.capabilities&4)}t.$ik=b;function u(q){return!!(q.capabilities&16)}t.$jk=u;function o(q){return m(q)?!!(q.capabilities&16384):!1}t.$kk=o;function N(q){return m(q)?!!(q.capabilities&32768):!1}t.$lk=N;function z(q){return!!(q.capabilities&65536)}t.$mk=z;function R(q){return!!(q.capabilities&2048)}t.$nk=R;var d;(function(q){q.FileExists="EntryExists",q.FileNotFound="EntryNotFound",q.FileNotADirectory="EntryNotADirectory",q.FileIsADirectory="EntryIsADirectory",q.FileExceedsStorageQuota="EntryExceedsStorageQuota",q.FileTooLarge="EntryTooLarge",q.FileWriteLocked="EntryWriteLocked",q.NoPermissions="NoPermissions",q.Unavailable="Unavailable",q.Unknown="Unknown"})(d||(t.FileSystemProviderErrorCode=d={}));class E extends Error{static create(G,P){const V=new E(G.toString(),P);return x(V,P),V}constructor(G,P){super(G),this.code=P}}t.$ok=E;function B(q,G){return E.create(q,G)}t.$pk=B;function H(q){return q||B((0,A.localize)(0,null),d.Unknown)}t.$qk=H;function x(q,G){return q.name=G?`${G} (FileSystemError)`:"FileSystemError",q}t.$rk=x;function C(q){if(!q)return d.Unknown;if(q instanceof E)return q.code;const G=/^(.+) \(FileSystemError\)$/.exec(q.name);if(!G)return d.Unknown;switch(G[1]){case d.FileExists:return d.FileExists;case d.FileIsADirectory:return d.FileIsADirectory;case d.FileNotADirectory:return d.FileNotADirectory;case d.FileNotFound:return d.FileNotFound;case d.FileTooLarge:return d.FileTooLarge;case d.FileWriteLocked:return d.FileWriteLocked;case d.NoPermissions:return d.NoPermissions;case d.Unavailable:return d.Unavailable}return d.Unknown}t.$sk=C;function F(q){if(q instanceof oe)return q.fileOperationResult;switch(C(q)){case d.FileNotFound:return 1;case d.FileIsADirectory:return 0;case d.FileNotADirectory:return 9;case d.FileWriteLocked:return 5;case d.NoPermissions:return 6;case d.FileExists:return 4;case d.FileTooLarge:return 7;default:return 10}}t.$tk=F;var Q;(function(q){q[q.CREATE=0]="CREATE",q[q.DELETE=1]="DELETE",q[q.MOVE=2]="MOVE",q[q.COPY=3]="COPY",q[q.WRITE=4]="WRITE"})(Q||(t.FileOperation=Q={}));class te{constructor(G,P,V){this.resource=G,this.operation=P,this.target=V}isOperation(G){return this.operation===G}}t.$uk=te;var re;(function(q){q[q.UPDATED=0]="UPDATED",q[q.ADDED=1]="ADDED",q[q.DELETED=2]="DELETED"})(re||(t.FileChangeType=re={}));class fe{static{this.a=null}constructor(G,P){this.c=P,this.b=void 0,this.d=new T.$U(()=>{const V=y.$Zh.forUris(()=>this.c);return V.fill(this.rawAdded.map(p=>[p,!0])),V}),this.f=new T.$U(()=>{const V=y.$Zh.forUris(()=>this.c);return V.fill(this.rawUpdated.map(p=>[p,!0])),V}),this.g=new T.$U(()=>{const V=y.$Zh.forUris(()=>this.c);return V.fill(this.rawDeleted.map(p=>[p,!0])),V}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const V of G){switch(V.type){case 1:this.rawAdded.push(V.resource);break;case 0:this.rawUpdated.push(V.resource);break;case 2:this.rawDeleted.push(V.resource);break}this.b!==fe.a&&(typeof V.cId=="number"?this.b===void 0?this.b=V.cId:this.b!==V.cId&&(this.b=fe.a):this.b!==void 0&&(this.b=fe.a))}}contains(G,...P){return this.h(G,{includeChildren:!1},...P)}affects(G,...P){return this.h(G,{includeChildren:!0},...P)}h(G,P,...V){if(!G)return!1;const p=V.length>0;return!!((!p||V.includes(1))&&(this.d.value.get(G)||P.includeChildren&&this.d.value.findSuperstr(G))||(!p||V.includes(0))&&(this.f.value.get(G)||P.includeChildren&&this.f.value.findSuperstr(G))||(!p||V.includes(2))&&(this.g.value.findSubstr(G)||P.includeChildren&&this.g.value.findSuperstr(G)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(G){return this.b===G}hasCorrelation(){return typeof this.b=="number"}}t.$vk=fe;function ie(q,G,P){return!q||!G||q===G||G.length>q.length?!1:(G.charAt(G.length-1)!==L.sep&&(G+=L.sep),P?(0,i.$4e)(q,G):q.indexOf(G)===0)}t.$wk=ie;class oe extends Error{constructor(G,P,V){super(G),this.fileOperationResult=P,this.options=V}}t.$xk=oe;class be extends oe{constructor(G,P,V,p){super(G,P,p),this.fileOperationResult=P,this.size=V}}t.$yk=be;class Se extends oe{constructor(G,P,V){super(G,2,V),this.stat=P}}t.$zk=Se;var Le;(function(q){q[q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",q[q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",q[q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",q[q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",q[q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",q[q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",q[q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",q[q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",q[q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",q[q.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",q[q.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Le||(t.FileOperationResult=Le={})),t.$Ak={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.$Bk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.$Ck="files.associations",t.$Dk="files.exclude",t.$Ek="files.readonlyInclude",t.$Fk="files.readonlyExclude",t.$Gk="files.readonlyFromPermissions";var Fe;(function(q){q[q.FILE=0]="FILE",q[q.FOLDER=1]="FOLDER",q[q.ROOT_FOLDER=2]="ROOT_FOLDER"})(Fe||(t.FileKind=Fe={})),t.$Hk="";function de(q){if(!(typeof q.size!="number"||typeof q.mtime!="number"))return q.mtime.toString(29)+q.size.toString(31)}t.$Ik=de;async function ne(q,G){if(!G.hasProvider(D.URI.from({scheme:q.scheme})))return new Promise(P=>{const V=G.onDidChangeFileSystemProviderRegistrations(p=>{p.scheme===q.scheme&&p.added&&(V.dispose(),P())})})}t.$Jk=ne;class ce{static{this.KB=1024}static{this.MB=ce.KB*ce.KB}static{this.GB=ce.MB*ce.KB}static{this.TB=ce.GB*ce.KB}static formatSize(G){return(0,U.$Df)(G)||(G=0),G<ce.KB?(0,A.localize)(1,null,G.toFixed(0)):G<ce.MB?(0,A.localize)(2,null,(G/ce.KB).toFixed(2)):G<ce.GB?(0,A.localize)(3,null,(G/ce.MB).toFixed(2)):G<ce.TB?(0,A.localize)(4,null,(G/ce.GB).toFixed(2)):(0,A.localize)(5,null,(G/ce.TB).toFixed(2))}}t.$Kk=ce;function X(q){const G=typeof q=="string"||q?.scheme===f.Schemas.vscodeRemote;return typeof q!="string"&&q?.scheme===f.Schemas.file?1024*ce.MB:G?10*ce.MB:g.$p?50*ce.MB:1024*ce.MB}t.$Lk=X}),define($e[138],we([1,0,40]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$e9b=t.$d9b=void 0,t.$d9b=(0,y.$Th)("mainProcessService");class L{constructor(U,D){this.a=U,this.b=D}getChannel(U){return this.a.getChannel(U,this.b)}registerChannel(U,D){this.a.registerChannel(U,D)}}t.$e9b=L}),define($e[139],we([1,0,2,133]),function(le,t,y,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$f9b=void 0;class i extends y.$Rc{constructor(D){super(),this.a=this.B(new L.$WT(`window:${D}`))}getChannel(D){return this.a.getChannel(D)}registerChannel(D,A){this.a.registerChannel(D,A)}}t.$f9b=i});var Di=this&&this.__param||function(le,t){return function(y,L){t(y,L,le)}};define($e[140],we([1,0,67,138]),function(le,t,y,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$j9b=void 0;let i=class{constructor(D,A){return this.windowId=D,y.ProxyChannel.toService(A.getChannel("nativeHost"),{context:D,properties:(()=>{const c=new Map;return c.set("windowId",D),c})()})}};t.$j9b=i,t.$j9b=i=Xe([Di(1,L.$d9b)],i)}),define($e[68],we([1,0,76,7]),function(le,t,y,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kn=void 0;class i{constructor(){this.a=new Map}add(D,A){y.ok(L.$zf(D)),y.ok(L.$Bf(A)),y.ok(!this.a.has(D),"There is already an extension with this id"),this.a.set(D,A)}knows(D){return this.a.has(D)}as(D){return this.a.get(D)||null}}t.$kn=new i}),define($e[141],we([1,0,4,68]),function(le,t,y,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ln=void 0,t.$ln={JSONContribution:"base.contributions.json"};function i(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class U{constructor(){this.b=new y.$Od,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(c,g){this.a[i(c)]=g,this.b.fire(c)}notifySchemaChanged(c){this.b.fire(c)}getSchemaContributions(){return{schemas:this.a}}}const D=new U;L.$kn.add(t.$ln.JSONContribution,D)}),define($e[142],we([1,0,9,18,19,4,7,16,135,141,68]),function(le,t,y,L,i,U,D,A,c,g,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ew=t.$dw=t.$cw=t.$bw=t.$aw=t.$_v=t.$$v=t.$0v=t.IconFontDefinition=t.IconContribution=t.$9v=void 0,t.$9v={IconContribution:"base.contributions.icons"};var T;(function(b){function u(o,N){let z=o.defaults;for(;i.ThemeIcon.isThemeIcon(z);){const R=e.getIcon(z.id);if(!R)return;z=R.defaults}return z}b.getDefinition=u})(T||(t.IconContribution=T={}));var s;(function(b){function u(N){return{weight:N.weight,style:N.style,src:N.src.map(z=>({format:z.format,location:z.location.toString()}))}}b.toJSONObject=u;function o(N){const z=R=>(0,D.$zf)(R)?R:void 0;if(N&&Array.isArray(N.src)&&N.src.every(R=>(0,D.$zf)(R.format)&&(0,D.$zf)(R.location)))return{weight:z(N.weight),style:z(N.style),src:N.src.map(R=>({format:R.format,location:A.URI.parse(R.location)}))}}b.fromJSONObject=o})(s||(t.IconFontDefinition=s={}));class a{constructor(){this.a=new U.$Od,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,c.localize)(0,null)},fontCharacter:{type:"string",description:(0,c.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${i.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(u,o,N,z){const R=this.b[u];if(R){if(N&&!R.description){R.description=N,this.d.properties[u].markdownDescription=`${N} $(${u})`;const B=this.e.enum.indexOf(u);B!==-1&&(this.e.enumDescriptions[B]=N),this.a.fire()}return R}const d={id:u,description:N,defaults:o,deprecationMessage:z};this.b[u]=d;const E={$ref:"#/definitions/icons"};return z&&(E.deprecationMessage=z),N&&(E.markdownDescription=`${N}: $(${u})`),this.d.properties[u]=E,this.e.enum.push(u),this.e.enumDescriptions.push(N||""),this.a.fire(),{id:u}}deregisterIcon(u){delete this.b[u],delete this.d.properties[u];const o=this.e.enum.indexOf(u);o!==-1&&(this.e.enum.splice(o,1),this.e.enumDescriptions.splice(o,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(u=>this.b[u])}getIcon(u){return this.b[u]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(u,o){const N=this.f[u];return N||(this.f[u]=o,this.a.fire(),o)}deregisterIconFont(u){delete this.f[u]}getIconFont(u){return this.f[u]}toString(){const u=(R,d)=>R.id.localeCompare(d.id),o=R=>{for(;i.ThemeIcon.isThemeIcon(R.defaults);)R=this.b[R.defaults.id];return`codicon codicon-${R?R.id:""}`},N=[];N.push("| preview     | identifier                        | default codicon ID                | description"),N.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const z=Object.keys(this.b).map(R=>this.b[R]);for(const R of z.filter(d=>!!d.description).sort(u))N.push(`|<i class="${o(R)}"></i>|${R.id}|${i.ThemeIcon.isThemeIcon(R.defaults)?R.defaults.id:R.id}|${R.description||""}|`);N.push("| preview     | identifier                        "),N.push("| ----------- | --------------------------------- |");for(const R of z.filter(d=>!i.ThemeIcon.isThemeIcon(d.defaults)).sort(u))N.push(`|<i class="${o(R)}"></i>|${R.id}|`);return N.join(`
`)}}const e=new a;f.$kn.add(t.$9v.IconContribution,e);function h(b,u,o,N){return e.registerIcon(b,u,o,N)}t.$0v=h;function l(){return e}t.$$v=l;function m(){const b=(0,L.$Wj)();for(const u in b){const o="\\"+b[u].toString(16);e.registerIcon(u,{fontCharacter:o})}}m(),t.$_v="vscode://schemas/icons";const n=f.$kn.as(g.$ln.JSONContribution);n.registerSchema(t.$_v,e.getIconSchema());const r=new y.$8g(()=>n.notifySchemaChanged(t.$_v),200);e.onDidChange(()=>{r.isScheduled()||r.schedule()}),t.$aw=h("widget-close",L.$Yj.close,(0,c.localize)(2,null)),t.$bw=h("goto-previous-location",L.$Yj.arrowUp,(0,c.localize)(3,null)),t.$cw=h("goto-next-location",L.$Yj.arrowDown,(0,c.localize)(4,null)),t.$dw=i.ThemeIcon.modify(L.$Yj.sync,"spin"),t.$ew=i.ThemeIcon.modify(L.$Yj.loading,"spin")}),define($e[143],we([1,0,3,4,2,19,142]),function(le,t,y,L,i,U,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hDb=t.$gDb=void 0;function A(g){const f=new i.$Qc,T=f.add(new L.$Od),s=(0,D.$$v)();return f.add(s.onDidChange(()=>T.fire())),g&&f.add(g.onDidProductIconThemeChange(()=>T.fire())),{dispose:()=>f.dispose(),onDidChange:T.event,getCSS(){const a=g?g.getProductIconTheme():new c,e={},h=m=>{const n=a.getIcon(m);if(!n)return;const r=n.font;return r?(e[r.id]=r.definition,`.codicon-${m.id}:before { content: '${n.fontCharacter}'; font-family: ${(0,y.$_P)(r.id)}; }`):`.codicon-${m.id}:before { content: '${n.fontCharacter}'; }`},l=[];for(const m of s.getIcons()){const n=h(m);n&&l.push(n)}for(const m in e){const n=e[m],r=n.weight?`font-weight: ${n.weight};`:"",b=n.style?`font-style: ${n.style};`:"",u=n.src.map(o=>`${(0,y.$$P)(o.location)} format('${o.format}')`).join(", ");l.push(`@font-face { src: ${u}; font-family: ${(0,y.$_P)(m)};${r}${b} font-display: block; }`)}return l.join(`
`)}}}t.$gDb=A;class c{getIcon(f){const T=(0,D.$$v)();let s=f.defaults;for(;U.ThemeIcon.isThemeIcon(s);){const a=T.getIcon(s.id);if(!a)return;s=a.defaults}return s}}t.$hDb=c}),define($e[144],we([1,0,5]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rC=t.$qC=t.$pC=t.$oC=t.$nC=t.$mC=t.$lC=t.$kC=t.$jC=void 0,t.$jC={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function L(T){return typeof T.parentId=="number"}t.$kC=L;function i(T){return!!T.workspaceUri}t.$lC=i;function U(T){return!!T.folderUri}t.$mC=U;function D(T){return!!T.fileUri}t.$nC=D;function A(T){const s=c(T),a=T.getValue("window.menuBarVisibility");return a==="default"||s==="native"&&a==="compact"||y.$k&&y.$n?"classic":a}t.$oC=A;function c(T){if(y.$p)return"custom";const s=T.getValue("window");if(s){if(y.$k&&s.nativeTabs===!0||y.$k&&s.nativeFullScreen===!1)return"native";const h=s.titleBarStyle;if(h==="native"||h==="custom")return h}return y.$l?"native":"custom"}t.$pC=c;function g(T){return!(!y.$j||y.$p||c(T)==="native")}t.$qC=g;function f(T=0){return Math.pow(1.2,T)}t.$rC=f}),define($e[145],we([1,0,17,3,14,31,144]),function(le,t,y,L,i,U,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$n9b=t.$m9b=t.$l9b=void 0;function A(T){for(const{window:s}of(0,L.getWindows)())c(s)?.webFrame?.setZoomLevel(T);(0,y.$AO)((0,D.$rC)(T)),(0,y.$xO)(T)}t.$l9b=A;function c(T){if(T===i.$sO)return{ipcRenderer:U.$N,webFrame:U.$P};{const s=T;if(s?.vscode?.ipcRenderer&&s?.vscode?.webFrame)return s.vscode}}function g(){A((0,y.$yO)()+1)}t.$m9b=g;function f(){A((0,y.$yO)()-1)}t.$n9b=f}),define($e[146],we([1,0,10,3,131,9,132,31,136,137,139,140,143,145,15,14,102,93]),function(le,t,y,L,i,U,D,A,c,g,f,T,s,a,e,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=void 0;const l=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,m=/\s--inspect-port=(?<port>\d+)/;class n{getHeight(C){return 22}getTemplateId(C){return d(C)?"process":z(C)?"machine":(0,c.$vm)(C)?"error":R(C)?"header":""}}class r{hasChildren(C){return(0,c.$vm)(C)?!1:d(C)?!!C.children?.length:!0}getChildren(C){return d(C)?C.children?C.children:[]:(0,c.$vm)(C)?[]:R(C)?C.processRoots.length>1?C.processRoots:[C.processRoots[0].rootProcess]:z(C)?[C.rootProcess]:[C.processes]}}class b{constructor(){this.templateId="header"}renderTemplate(C){const F=(0,L.$UP)(C,(0,L.$)(".row")),Q=(0,L.$UP)(F,(0,L.$)(".nameLabel")),te=(0,L.$UP)(F,(0,L.$)(".cpu")),re=(0,L.$UP)(F,(0,L.$)(".memory")),fe=(0,L.$UP)(F,(0,L.$)(".pid"));return{name:Q,CPU:te,memory:re,PID:fe}}renderElement(C,F,Q,te){Q.name.textContent=(0,y.localize)(0,null),Q.CPU.textContent=(0,y.localize)(1,null),Q.PID.textContent=(0,y.localize)(2,null),Q.memory.textContent=(0,y.localize)(3,null)}disposeTemplate(C){}}class u{constructor(){this.templateId="machine"}renderTemplate(C){const F=Object.create(null),Q=(0,L.$UP)(C,(0,L.$)(".row"));return F.name=(0,L.$UP)(Q,(0,L.$)(".nameLabel")),F}renderElement(C,F,Q,te){Q.name.textContent=C.element.name}disposeTemplate(C){}}class o{constructor(){this.templateId="error"}renderTemplate(C){const F=Object.create(null),Q=(0,L.$UP)(C,(0,L.$)(".row"));return F.name=(0,L.$UP)(Q,(0,L.$)(".nameLabel")),F}renderElement(C,F,Q,te){Q.name.textContent=C.element.errorMessage}disposeTemplate(C){}}class N{constructor(C,F,Q){this.a=C,this.b=F,this.c=Q,this.templateId="process"}renderTemplate(C){const F=(0,L.$UP)(C,(0,L.$)(".row")),Q=(0,L.$UP)(F,(0,L.$)(".nameLabel")),te=(0,L.$UP)(F,(0,L.$)(".cpu")),re=(0,L.$UP)(F,(0,L.$)(".memory")),fe=(0,L.$UP)(F,(0,L.$)(".pid"));return{name:Q,CPU:te,PID:fe,memory:re}}renderElement(C,F,Q,te){const{element:re}=C,fe=re.pid.toFixed(0);let ie=re.name;this.c.has(re.pid)&&(ie=this.c.get(re.pid)),Q.name.textContent=ie,Q.name.title=re.cmd,Q.CPU.textContent=re.load.toFixed(0),Q.PID.textContent=fe,Q.PID.parentElement.id=`pid-${fe}`;const oe=this.a==="win32"?re.mem:this.b*(re.mem/100);Q.memory.textContent=(oe/g.$Kk.MB).toFixed(0)}disposeTemplate(C){}}function z(x){return!!x.name&&!!x.rootProcess}function R(x){return!!x.processRoots}function d(x){return!!x.pid}class E{constructor(C,F){this.f=F,this.b=new Map;const Q=new f.$f9b(C);this.c=new T.$j9b(C,Q),this.k(F.styles),this.g(F),A.$N.on("vscode:pidToNameResponse",(te,re)=>{this.b=new Map;for(const[fe,ie]of re)this.b.set(fe,ie)}),A.$N.on("vscode:listProcessesResponse",async(te,re)=>{re.forEach((fe,ie)=>{d(fe.rootProcess)&&(fe.rootProcess.name=ie===0?`${this.f.applicationName} main`:"remote agent")}),this.d?(this.d.setInput({processes:{processRoots:re}}),this.d.layout(h.$sO.innerHeight,h.$sO.innerWidth)):await this.h(re),this.m(0)}),this.a=Date.now(),A.$N.send("vscode:pidToNameRequest"),A.$N.send("vscode:listProcesses")}g(C){document.onkeydown=F=>{const Q=C.platform==="darwin"?F.metaKey:F.ctrlKey;Q&&F.keyCode===87&&(F.stopPropagation(),F.preventDefault(),A.$N.send("vscode:closeProcessExplorer")),Q&&F.keyCode===187&&(0,a.$m9b)(),Q&&F.keyCode===189&&(0,a.$n9b)()}}async h(C){const F=document.getElementById("process-list");if(!F)return;const{totalmem:Q}=await this.c.getOSStatistics(),te=[new N(this.f.platform,Q,this.b),new b,new u,new o];this.d=new i.$dT("processExplorer",F,new n,te,new r,{identityProvider:{getId:re=>d(re)?re.pid.toString():(0,c.$vm)(re)?re.hostName:R(re)?"processes":z(re)?re.name:"header"}}),this.d.setInput({processes:{processRoots:C}}),this.d.layout(h.$sO.innerHeight,h.$sO.innerWidth),this.d.onKeyDown(re=>{const fe=new e.$VO(re);if(fe.keyCode===35&&fe.altKey){const ie=this.n();Promise.all(ie.map(oe=>this.c.killProcess(oe,"SIGTERM"))).then(()=>this.d?.refresh())}}),this.d.onContextMenu(re=>{d(re.element)&&this.l(re.element,!0)}),F.style.height=`${h.$sO.innerHeight}px`,h.$sO.addEventListener("resize",()=>{F.style.height=`${h.$sO.innerHeight}px`,this.d?.layout(h.$sO.innerHeight,h.$sO.innerWidth)})}i(C){const F=l.exec(C);return F&&F.groups.port!=="0"||C.indexOf("node ")>=0||C.indexOf("node.exe")>=0}j(C){const F={type:"node",request:"attach",name:`process ${C.pid}`};let Q=l.exec(C.cmd);Q?F.port=Number(Q.groups.port):F.processId=String(C.pid),Q=m.exec(C.cmd),Q&&(F.port=Number(Q.groups.port)),A.$N.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[F]})}k(C){const F=(0,L.$DP)(),Q=[];C.listFocusBackground&&(Q.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${C.listFocusBackground}; }`),Q.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${C.listFocusBackground}; }`)),C.listFocusForeground&&Q.push(`.monaco-list:focus .monaco-list-row.focused { color: ${C.listFocusForeground}; }`),C.listActiveSelectionBackground&&(Q.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${C.listActiveSelectionBackground}; }`),Q.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${C.listActiveSelectionBackground}; }`)),C.listActiveSelectionForeground&&Q.push(`.monaco-list:focus .monaco-list-row.selected { color: ${C.listActiveSelectionForeground}; }`),C.listHoverBackground&&Q.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${C.listHoverBackground}; }`),C.listHoverForeground&&Q.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${C.listHoverForeground}; }`),C.listFocusOutline&&Q.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${C.listFocusOutline}; outline-offset: -1px; }`),C.listHoverOutline&&Q.push(`.monaco-list-row:hover { outline: 1px dashed ${C.listHoverOutline}; outline-offset: -1px; }`),C.scrollbarShadowColor&&Q.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${C.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${C.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${C.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),C.scrollbarSliderBackgroundColor&&Q.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${C.scrollbarSliderBackgroundColor};
				}
			`),C.scrollbarSliderHoverBackgroundColor&&Q.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${C.scrollbarSliderHoverBackgroundColor};
				}
			`),C.scrollbarSliderActiveBackgroundColor&&Q.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${C.scrollbarSliderActiveBackgroundColor};
				}
			`),F.textContent=Q.join(`
`),C.color&&(document.body.style.color=C.color)}l(C,F){const Q=[],te=Number(C.pid);F&&(Q.push({accelerator:"Alt+E",label:(0,y.localize)(4,null),click:()=>{this.c.killProcess(te,"SIGTERM")}}),Q.push({label:(0,y.localize)(5,null),click:()=>{this.c.killProcess(te,"SIGKILL")}}),Q.push({type:"separator"})),Q.push({label:(0,y.localize)(6,null),click:()=>{const re=this.n();re?.includes(te)||(re.length=0,re.push(te));const fe=re?.map(ie=>document.getElementById(`pid-${ie}`)).filter(ie=>!!ie);if(fe){const ie=fe.map(oe=>oe.innerText).filter(oe=>!!oe);this.c.writeClipboardText(ie.join(`
`))}}}),Q.push({label:(0,y.localize)(7,null),click:()=>{const re=document.getElementById("process-list");re&&this.c.writeClipboardText(re.innerText)}}),C&&F&&this.i(C.cmd)&&(Q.push({type:"separator"}),Q.push({label:(0,y.localize)(8,null),click:()=>{this.j(C)}})),(0,D.$OT)(Q)}m(C){setTimeout(()=>{const F=Date.now(),Q=C+F-this.a;this.a=F,Q>1e3?(A.$N.send("vscode:pidToNameRequest"),A.$N.send("vscode:listProcesses")):this.m(Q)},200)}n(){return this.d?.getSelection()?.map(C=>{if(!(!C||!("pid"in C)))return C.pid}).filter(C=>!!C)}}function B(){const x=(0,L.$DP)();x.id="codiconStyles";const C=(0,s.$gDb)(void 0);function F(){x.textContent=C.getCSS()}const Q=new U.$8g(F,0);C.onDidChange(()=>Q.schedule()),Q.schedule()}function H(x){const C=x.data.platform==="win32"?"windows":x.data.platform==="linux"?"linux":"mac";document.body.classList.add(C),B(),(0,a.$l9b)(x.data.zoomLevel),new E(x.windowId,x.data)}t.startup=H})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/072c6b950b8822560c55eff1474c30951e2ab9c9/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
