/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/base/common/event","vs/nls!vs/code/node/cliProcessMain","vs/platform/log/common/log","vs/nls","vs/base/common/async","vs/base/common/errors","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/platform/files/common/files","vs/base/common/platform","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/uuid","vs/base/common/strings","vs/base/common/objects","vs/base/common/map","vs/platform/product/common/productService","os","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/platform/policy/common/policy","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/node/zip","vs/base/common/decorators","vs/base/common/json","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/base/common/amd","vs/base/common/assert","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/base/common/lazy","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","@vscode/policy-watcher","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],ne=function(J){for(var e=[],L=0,N=J.length;L<N;L++)e[L]=te[J[L]];return e};define(te[70],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=e.$S=void 0,e.$S=!1;class L{static get(){const D=new Map,A=new Map,j=new Map,b=new Map;function h(f,E){f.has(E.detail)||f.set(E.detail,-E.timestamp)}function c(f,E){const y=f.get(E.detail);y&&(y>=0||f.set(E.detail,y+E.timestamp))}let k=[];typeof J=="function"&&typeof J.getStats=="function"&&(k=J.getStats().slice(0).sort((f,E)=>f.timestamp-E.timestamp));for(const f of k)switch(f.type){case 10:h(D,f);break;case 11:case 12:c(D,f);break;case 21:h(A,f);break;case 22:c(A,f);break;case 33:h(j,f);break;case 34:c(j,f);break;case 31:h(b,f);break;case 32:c(b,f);break}let I=0;j.forEach(f=>I+=f);function d(f){const E=[];return f.forEach((y,m)=>E.push([m,y])),E}return{amdLoad:d(D),amdInvoke:d(A),nodeRequire:d(j),nodeEval:d(b),nodeRequireTotal:I}}static toMarkdownTable(D,A){let j="";const b=[];return D.forEach((h,c)=>{b[c]=h.length}),A.forEach(h=>{h.forEach((c,k)=>{typeof c>"u"&&(c=h[k]="-");const I=c.toString().length;b[k]=Math.max(I,b[k])})}),D.forEach((h,c)=>{j+=`| ${h+" ".repeat(b[c]-h.toString().length)} `}),j+=`|
`,D.forEach((h,c)=>{j+=`| ${"-".repeat(b[c])} `}),j+=`|
`,A.forEach(h=>{h.forEach((c,k)=>{typeof c<"u"&&(j+=`| ${c+" ".repeat(b[k]-c.toString().length)} `)}),j+=`|
`}),j}}e.$T=L}),define(te[52],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nh=e.$mh=e.$lh=void 0;function L(j){return(b,h,c)=>{let k=null,I=null;if(typeof c.value=="function"?(k="value",I=c.value):typeof c.get=="function"&&(k="get",I=c.get),!I)throw new Error("not supported");c[k]=j(I,h)}}function N(j,b,h){let c=null,k=null;if(typeof h.value=="function"?(c="value",k=h.value,k.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(c="get",k=h.get),!k)throw new Error("not supported");const I=`$memoize$${b}`;h[c]=function(...d){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:k.apply(this,d)}),this[I]}}e.$lh=N;function D(j,b,h){return L((c,k)=>{const I=`$debounce$${k}`,d=`$debounce$result$${k}`;return function(...f){this[d]||(this[d]=h?h():void 0),clearTimeout(this[I]),b&&(this[d]=b(this[d],...f),f=[this[d]]),this[I]=setTimeout(()=>{c.apply(this,f),this[d]=h?h():void 0},j)}})}e.$mh=D;function A(j,b,h){return L((c,k)=>{const I=`$throttle$timer$${k}`,d=`$throttle$result$${k}`,f=`$throttle$lastRun$${k}`,E=`$throttle$pending$${k}`;return function(...y){if(this[d]||(this[d]=h?h():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),b&&(this[d]=b(this[d],...y)),this[E])return;const m=this[f]+j;m<=Date.now()?(this[f]=Date.now(),c.apply(this,[this[d]]),this[d]=h?h():void 0):(this[E]=!0,this[I]=setTimeout(()=>{this[E]=!1,this[f]=Date.now(),c.apply(this,[this[d]]),this[d]=h?h():void 0},m-Date.now()))}})}e.$nh=A}),define(te[71],ne([0,1,9]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=e.$5c=e.$4c=e.$3c=e.ok=void 0;function N(h,c){if(!h)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}e.ok=N;function D(h,c="Unreachable"){throw new Error(c)}e.$3c=D;function A(h){if(!h)throw new L.$bb("Assertion Failed")}e.$4c=A;function j(h){if(!h()){debugger;h(),(0,L.$Z)(new L.$bb("Assertion Failed"))}}e.$5c=j;function b(h,c){let k=0;for(;k<h.length-1;){const I=h[k],d=h[k+1];if(!c(I,d))return!1;k++}return!0}e.$6c=b}),define(te[53],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var L;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(L||(e.ScanError=L={}));var N;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(N||(e.SyntaxKind=N={}));var D;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(D||(e.ParseErrorCode=D={}));var A;(function(s){s.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function j(s,o=!1){let t=0;const i=s.length;let n="",r=0,l=16,P=0;function v(se){let ue=0,ce=0;for(;ue<se;){const re=s.charCodeAt(t);if(re>=48&&re<=57)ce=ce*16+re-48;else if(re>=65&&re<=70)ce=ce*16+re-65+10;else if(re>=97&&re<=102)ce=ce*16+re-97+10;else break;t++,ue++}return ue<se&&(ce=-1),ce}function w(se){t=se,n="",r=0,l=16,P=0}function R(){const se=t;if(s.charCodeAt(t)===48)t++;else for(t++;t<s.length&&c(s.charCodeAt(t));)t++;if(t<s.length&&s.charCodeAt(t)===46)if(t++,t<s.length&&c(s.charCodeAt(t)))for(t++;t<s.length&&c(s.charCodeAt(t));)t++;else return P=3,s.substring(se,t);let ue=t;if(t<s.length&&(s.charCodeAt(t)===69||s.charCodeAt(t)===101))if(t++,(t<s.length&&s.charCodeAt(t)===43||s.charCodeAt(t)===45)&&t++,t<s.length&&c(s.charCodeAt(t))){for(t++;t<s.length&&c(s.charCodeAt(t));)t++;ue=t}else P=3;return s.substring(se,ue)}function B(){let se="",ue=t;for(;;){if(t>=i){se+=s.substring(ue,t),P=2;break}const ce=s.charCodeAt(t);if(ce===34){se+=s.substring(ue,t),t++;break}if(ce===92){if(se+=s.substring(ue,t),t++,t>=i){P=2;break}switch(s.charCodeAt(t++)){case 34:se+='"';break;case 92:se+="\\";break;case 47:se+="/";break;case 98:se+="\b";break;case 102:se+="\f";break;case 110:se+=`
`;break;case 114:se+="\r";break;case 116:se+="	";break;case 117:{const q=v(4);q>=0?se+=String.fromCharCode(q):P=4;break}default:P=5}ue=t;continue}if(ce>=0&&ce<=31)if(h(ce)){se+=s.substring(ue,t),P=2;break}else P=6;t++}return se}function _(){if(n="",P=0,r=t,t>=i)return r=i,l=17;let se=s.charCodeAt(t);if(b(se)){do t++,n+=String.fromCharCode(se),se=s.charCodeAt(t);while(b(se));return l=15}if(h(se))return t++,n+=String.fromCharCode(se),se===13&&s.charCodeAt(t)===10&&(t++,n+=`
`),l=14;switch(se){case 123:return t++,l=1;case 125:return t++,l=2;case 91:return t++,l=3;case 93:return t++,l=4;case 58:return t++,l=6;case 44:return t++,l=5;case 34:return t++,n=B(),l=10;case 47:{const ue=t-1;if(s.charCodeAt(t+1)===47){for(t+=2;t<i&&!h(s.charCodeAt(t));)t++;return n=s.substring(ue,t),l=12}if(s.charCodeAt(t+1)===42){t+=2;const ce=i-1;let re=!1;for(;t<ce;){if(s.charCodeAt(t)===42&&s.charCodeAt(t+1)===47){t+=2,re=!0;break}t++}return re||(t++,P=1),n=s.substring(ue,t),l=13}return n+=String.fromCharCode(se),t++,l=16}case 45:if(n+=String.fromCharCode(se),t++,t===i||!c(s.charCodeAt(t)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=R(),l=11;default:for(;t<i&&ee(se);)t++,se=s.charCodeAt(t);if(r!==t){switch(n=s.substring(r,t),n){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return n+=String.fromCharCode(se),t++,l=16}}function ee(se){if(b(se)||h(se))return!1;switch(se){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function oe(){let se;do se=_();while(se>=12&&se<=15);return se}return{setPosition:w,getPosition:()=>t,scan:o?oe:_,getToken:()=>l,getTokenValue:()=>n,getTokenOffset:()=>r,getTokenLength:()=>t-r,getTokenError:()=>P}}e.$Ym=j;function b(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function h(s){return s===10||s===13||s===8232||s===8233}function c(s){return s>=48&&s<=57}var k;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(k||(k={}));function I(s,o){const t=[],i=new Object;let n;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function P(v,w,R,B){r.value=v,r.offset=w,r.length=R,r.type=B,r.colonOffset=void 0,n=r}try{O(s,{onObjectBegin:(v,w)=>{if(o<=v)throw i;n=void 0,l=o>v,t.push("")},onObjectProperty:(v,w,R)=>{if(o<w||(P(v,w,R,"property"),t[t.length-1]=v,o<=w+R))throw i},onObjectEnd:(v,w)=>{if(o<=v)throw i;n=void 0,t.pop()},onArrayBegin:(v,w)=>{if(o<=v)throw i;n=void 0,t.push(0)},onArrayEnd:(v,w)=>{if(o<=v)throw i;n=void 0,t.pop()},onLiteralValue:(v,w,R)=>{if(o<w||(P(v,w,R,S(v)),o<=w+R))throw i},onSeparator:(v,w,R)=>{if(o<=w)throw i;if(v===":"&&n&&n.type==="property")n.colonOffset=w,l=!1,n=void 0;else if(v===","){const B=t[t.length-1];typeof B=="number"?t[t.length-1]=B+1:(l=!0,t[t.length-1]=""),n=void 0}}})}catch(v){if(v!==i)throw v}return{path:t,previousNode:n,isAtPropertyKey:l,matches:v=>{let w=0;for(let R=0;w<v.length&&R<t.length;R++)if(v[w]===t[R]||v[w]==="*")w++;else if(v[w]!=="**")return!1;return w===v.length}}}e.$Zm=I;function d(s,o=[],t=A.DEFAULT){let i=null,n=[];const r=[];function l(v){Array.isArray(n)?n.push(v):i!==null&&(n[i]=v)}return O(s,{onObjectBegin:()=>{const v={};l(v),r.push(n),n=v,i=null},onObjectProperty:v=>{i=v},onObjectEnd:()=>{n=r.pop()},onArrayBegin:()=>{const v=[];l(v),r.push(n),n=v,i=null},onArrayEnd:()=>{n=r.pop()},onLiteralValue:l,onError:(v,w,R)=>{o.push({error:v,offset:w,length:R})}},t),n[0]}e.$1m=d;function f(s,o=[],t=A.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(v){i.type==="property"&&(i.length=v-i.offset,i=i.parent)}function r(v){return i.children.push(v),v}O(s,{onObjectBegin:v=>{i=r({type:"object",offset:v,length:-1,parent:i,children:[]})},onObjectProperty:(v,w,R)=>{i=r({type:"property",offset:w,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:v,offset:w,length:R,parent:i})},onObjectEnd:(v,w)=>{i.length=v+w-i.offset,i=i.parent,n(v+w)},onArrayBegin:(v,w)=>{i=r({type:"array",offset:v,length:-1,parent:i,children:[]})},onArrayEnd:(v,w)=>{i.length=v+w-i.offset,i=i.parent,n(v+w)},onLiteralValue:(v,w,R)=>{r({type:S(v),offset:w,length:R,parent:i,value:v}),n(w+R)},onSeparator:(v,w,R)=>{i.type==="property"&&(v===":"?i.colonOffset=w:v===","&&n(w))},onError:(v,w,R)=>{o.push({error:v,offset:w,length:R})}},t);const P=i.children[0];return P&&delete P.parent,P}e.$2m=f;function E(s,o){if(!s)return;let t=s;for(const i of o)if(typeof i=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let n=!1;for(const r of t.children)if(Array.isArray(r.children)&&r.children[0].value===i){t=r.children[1],n=!0;break}if(!n)return}else{const n=i;if(t.type!=="array"||n<0||!Array.isArray(t.children)||n>=t.children.length)return;t=t.children[n]}return t}e.$3m=E;function y(s){if(!s.parent||!s.parent.children)return[];const o=y(s.parent);if(s.parent.type==="property"){const t=s.parent.children[0].value;o.push(t)}else if(s.parent.type==="array"){const t=s.parent.children.indexOf(s);t!==-1&&o.push(t)}return o}e.$4m=y;function m(s){switch(s.type){case"array":return s.children.map(m);case"object":{const o=Object.create(null);for(const t of s.children){const i=t.children[1];i&&(o[t.children[0].value]=m(i))}return o}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.$5m=m;function u(s,o,t=!1){return o>=s.offset&&o<s.offset+s.length||t&&o===s.offset+s.length}e.$6m=u;function $(s,o,t=!1){if(u(s,o,t)){const i=s.children;if(Array.isArray(i))for(let n=0;n<i.length&&i[n].offset<=o;n++){const r=$(i[n],o,t);if(r)return r}return s}}e.$7m=$;function O(s,o,t=A.DEFAULT){const i=j(s,!1);function n(Z){return Z?()=>Z(i.getTokenOffset(),i.getTokenLength()):()=>!0}function r(Z){return Z?K=>Z(K,i.getTokenOffset(),i.getTokenLength()):()=>!0}const l=n(o.onObjectBegin),P=r(o.onObjectProperty),v=n(o.onObjectEnd),w=n(o.onArrayBegin),R=n(o.onArrayEnd),B=r(o.onLiteralValue),_=r(o.onSeparator),ee=n(o.onComment),oe=r(o.onError),se=t&&t.disallowComments,ue=t&&t.allowTrailingComma;function ce(){for(;;){const Z=i.scan();switch(i.getTokenError()){case 4:re(14);break;case 5:re(15);break;case 3:re(13);break;case 1:se||re(11);break;case 2:re(12);break;case 6:re(16);break}switch(Z){case 12:case 13:se?re(10):ee();break;case 16:re(1);break;case 15:case 14:break;default:return Z}}}function re(Z,K=[],M=[]){if(oe(Z),K.length+M.length>0){let F=i.getToken();for(;F!==17;){if(K.indexOf(F)!==-1){ce();break}else if(M.indexOf(F)!==-1)break;F=ce()}}}function q(Z){const K=i.getTokenValue();return Z?B(K):P(K),ce(),!0}function X(){switch(i.getToken()){case 11:{let Z=0;try{Z=JSON.parse(i.getTokenValue()),typeof Z!="number"&&(re(2),Z=0)}catch{re(2)}B(Z);break}case 7:B(null);break;case 8:B(!0);break;case 9:B(!1);break;default:return!1}return ce(),!0}function T(){return i.getToken()!==10?(re(3,[],[2,5]),!1):(q(!1),i.getToken()===6?(_(":"),ce(),G()||re(4,[],[2,5])):re(5,[],[2,5]),!0)}function U(){l(),ce();let Z=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(Z||re(4,[],[]),_(","),ce(),i.getToken()===2&&ue)break}else Z&&re(6,[],[]);T()||re(4,[],[2,5]),Z=!0}return v(),i.getToken()!==2?re(7,[2],[]):ce(),!0}function H(){w(),ce();let Z=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(Z||re(4,[],[]),_(","),ce(),i.getToken()===4&&ue)break}else Z&&re(6,[],[]);G()||re(4,[],[4,5]),Z=!0}return R(),i.getToken()!==4?re(8,[4],[]):ce(),!0}function G(){switch(i.getToken()){case 3:return H();case 1:return U();case 10:return q(!0);default:return X()}}return ce(),i.getToken()===17?t.allowEmptyContent?!0:(re(4,[],[]),!1):G()?(i.getToken()!==17&&re(9,[],[]),!0):(re(4,[],[]),!1)}e.$8m=O;function p(s,o){const t=j(s),i=[];let n,r=0,l;do switch(l=t.getPosition(),n=t.scan(),n){case 12:case 13:case 17:r!==l&&i.push(s.substring(r,l)),o!==void 0&&i.push(t.getTokenValue().replace(/[^\r\n]/g,o)),r=t.getPosition();break}while(n!==17);return i.join("")}e.$9m=p;function S(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.$0m=S}),define(te[72],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wl=e.$Vl=e.$Ul=e.rot=e.$Sl=void 0;function L(b,h,c){return Math.min(Math.max(b,h),c)}e.$Sl=L;function N(b,h){return(h+b%h)%h}e.rot=N;class D{constructor(){this.a=0}getNext(){return this.a++}}e.$Ul=D;class A{constructor(){this.a=1,this.b=0}update(h){return this.b=this.b+(h-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Vl=A;class j{constructor(h){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(h),this.c.fill(0,0,h)}update(h){const c=this.c[this.d];return this.c[this.d]=h,this.d=(this.d+1)%this.c.length,this.e-=c,this.e+=h,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Wl=j}),function(){function J(D){const A=[];typeof D=="number"&&A.push("code/timeOrigin",D);function j(h){A.push(h,Date.now())}function b(){const h=[];for(let c=0;c<A.length;c+=2)h.push({name:A[c],startTime:A[c+1]});return h}return{mark:j,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const j of performance.getEntriesByType("mark"))A.push({name:j.name,startTime:Math.round(D+j.startTime)});return A}};if(typeof process=="object"){const D=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function L(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return L(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=L(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=L(N))}(),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var L=e();for(var N in L)(typeof exports=="object"?exports:J)[N]=L[N]}}(typeof self<"u"?self:this,function(){return function(J){var e={};function L(N){if(e[N])return e[N].exports;var D=e[N]={i:N,l:!1,exports:{}};return J[N].call(D.exports,D,D.exports,L),D.l=!0,D.exports}return L.m=J,L.c=e,L.d=function(N,D,A){L.o(N,D)||Object.defineProperty(N,D,{enumerable:!0,get:A})},L.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},L.t=function(N,D){if(1&D&&(N=L(N)),8&D||4&D&&typeof N=="object"&&N&&N.__esModule)return N;var A=Object.create(null);if(L.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:N}),2&D&&typeof N!="string")for(var j in N)L.d(A,j,function(b){return N[b]}.bind(null,j));return A},L.n=function(N){var D=N&&N.__esModule?function(){return N.default}:function(){return N};return L.d(D,"a",D),D},L.o=function(N,D){return Object.prototype.hasOwnProperty.call(N,D)},L.p="",L(L.s=0)}([function(J,e,L){(function(N){var D;e=J.exports=M,D=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,j=Number.MAX_SAFE_INTEGER||9007199254740991,b=e.re=[],h=e.src=[],c=0,k=c++;h[k]="0|[1-9]\\d*";var I=c++;h[I]="[0-9]+";var d=c++;h[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var f=c++;h[f]="("+h[k]+")\\.("+h[k]+")\\.("+h[k]+")";var E=c++;h[E]="("+h[I]+")\\.("+h[I]+")\\.("+h[I]+")";var y=c++;h[y]="(?:"+h[k]+"|"+h[d]+")";var m=c++;h[m]="(?:"+h[I]+"|"+h[d]+")";var u=c++;h[u]="(?:-("+h[y]+"(?:\\."+h[y]+")*))";var $=c++;h[$]="(?:-?("+h[m]+"(?:\\."+h[m]+")*))";var O=c++;h[O]="[0-9A-Za-z-]+";var p=c++;h[p]="(?:\\+("+h[O]+"(?:\\."+h[O]+")*))";var S=c++,s="v?"+h[f]+h[u]+"?"+h[p]+"?";h[S]="^"+s+"$";var o="[v=\\s]*"+h[E]+h[$]+"?"+h[p]+"?",t=c++;h[t]="^"+o+"$";var i=c++;h[i]="((?:<|>)?=?)";var n=c++;h[n]=h[I]+"|x|X|\\*";var r=c++;h[r]=h[k]+"|x|X|\\*";var l=c++;h[l]="[v=\\s]*("+h[r]+")(?:\\.("+h[r]+")(?:\\.("+h[r]+")(?:"+h[u]+")?"+h[p]+"?)?)?";var P=c++;h[P]="[v=\\s]*("+h[n]+")(?:\\.("+h[n]+")(?:\\.("+h[n]+")(?:"+h[$]+")?"+h[p]+"?)?)?";var v=c++;h[v]="^"+h[i]+"\\s*"+h[l]+"$";var w=c++;h[w]="^"+h[i]+"\\s*"+h[P]+"$";var R=c++;h[R]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var B=c++;h[B]="(?:~>?)";var _=c++;h[_]="(\\s*)"+h[B]+"\\s+",b[_]=new RegExp(h[_],"g");var ee=c++;h[ee]="^"+h[B]+h[l]+"$";var oe=c++;h[oe]="^"+h[B]+h[P]+"$";var se=c++;h[se]="(?:\\^)";var ue=c++;h[ue]="(\\s*)"+h[se]+"\\s+",b[ue]=new RegExp(h[ue],"g");var ce=c++;h[ce]="^"+h[se]+h[l]+"$";var re=c++;h[re]="^"+h[se]+h[P]+"$";var q=c++;h[q]="^"+h[i]+"\\s*("+o+")$|^$";var X=c++;h[X]="^"+h[i]+"\\s*("+s+")$|^$";var T=c++;h[T]="(\\s*)"+h[i]+"\\s*("+o+"|"+h[l]+")",b[T]=new RegExp(h[T],"g");var U=c++;h[U]="^\\s*("+h[l]+")\\s+-\\s+("+h[l]+")\\s*$";var H=c++;h[H]="^\\s*("+h[P]+")\\s+-\\s+("+h[P]+")\\s*$";var G=c++;h[G]="(<|>)?=?\\s*\\*";for(var Z=0;Z<35;Z++)D(Z,h[Z]),b[Z]||(b[Z]=new RegExp(h[Z]));function K(V,Y){if(V instanceof M)return V;if(typeof V!="string"||V.length>A||!(Y?b[t]:b[S]).test(V))return null;try{return new M(V,Y)}catch{return null}}function M(V,Y){if(V instanceof M){if(V.loose===Y)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof M))return new M(V,Y);D("SemVer",V,Y),this.loose=Y;var x=V.trim().match(Y?b[t]:b[S]);if(!x)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+x[1],this.minor=+x[2],this.patch=+x[3],this.major>j||this.major<0)throw new TypeError("Invalid major version");if(this.minor>j||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>j||this.patch<0)throw new TypeError("Invalid patch version");x[4]?this.prerelease=x[4].split(".").map(function($e){if(/^[0-9]+$/.test($e)){var ye=+$e;if(ye>=0&&ye<j)return ye}return $e}):this.prerelease=[],this.build=x[5]?x[5].split("."):[],this.format()}e.parse=K,e.valid=function(V,Y){var x=K(V,Y);return x?x.version:null},e.clean=function(V,Y){var x=K(V.trim().replace(/^[=v]+/,""),Y);return x?x.version:null},e.SemVer=M,M.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},M.prototype.toString=function(){return this.version},M.prototype.compare=function(V){return D("SemVer.compare",this.version,this.loose,V),V instanceof M||(V=new M(V,this.loose)),this.compareMain(V)||this.comparePre(V)},M.prototype.compareMain=function(V){return V instanceof M||(V=new M(V,this.loose)),a(this.major,V.major)||a(this.minor,V.minor)||a(this.patch,V.patch)},M.prototype.comparePre=function(V){if(V instanceof M||(V=new M(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var Y=0;do{var x=this.prerelease[Y],$e=V.prerelease[Y];if(D("prerelease compare",Y,x,$e),x===void 0&&$e===void 0)return 0;if($e===void 0)return 1;if(x===void 0)return-1;if(x!==$e)return a(x,$e)}while(++Y)},M.prototype.inc=function(V,Y){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Y);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Y);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Y),this.inc("pre",Y);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Y),this.inc("pre",Y);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var x=this.prerelease.length;--x>=0;)typeof this.prerelease[x]=="number"&&(this.prerelease[x]++,x=-2);x===-1&&this.prerelease.push(0)}Y&&(this.prerelease[0]===Y?isNaN(this.prerelease[1])&&(this.prerelease=[Y,0]):this.prerelease=[Y,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},e.inc=function(V,Y,x,$e){typeof x=="string"&&($e=x,x=void 0);try{return new M(V,x).inc(Y,$e).version}catch{return null}},e.diff=function(V,Y){if(Q(V,Y))return null;var x=K(V),$e=K(Y);if(x.prerelease.length||$e.prerelease.length){for(var ye in x)if((ye==="major"||ye==="minor"||ye==="patch")&&x[ye]!==$e[ye])return"pre"+ye;return"prerelease"}for(var ye in x)if((ye==="major"||ye==="minor"||ye==="patch")&&x[ye]!==$e[ye])return ye},e.compareIdentifiers=a;var F=/^[0-9]+$/;function a(V,Y){var x=F.test(V),$e=F.test(Y);return x&&$e&&(V=+V,Y=+Y),x&&!$e?-1:$e&&!x?1:V<Y?-1:V>Y?1:0}function g(V,Y,x){return new M(V,x).compare(new M(Y,x))}function z(V,Y,x){return g(V,Y,x)>0}function C(V,Y,x){return g(V,Y,x)<0}function Q(V,Y,x){return g(V,Y,x)===0}function W(V,Y,x){return g(V,Y,x)!==0}function le(V,Y,x){return g(V,Y,x)>=0}function ae(V,Y,x){return g(V,Y,x)<=0}function me(V,Y,x,$e){var ye;switch(Y){case"===":typeof V=="object"&&(V=V.version),typeof x=="object"&&(x=x.version),ye=V===x;break;case"!==":typeof V=="object"&&(V=V.version),typeof x=="object"&&(x=x.version),ye=V!==x;break;case"":case"=":case"==":ye=Q(V,x,$e);break;case"!=":ye=W(V,x,$e);break;case">":ye=z(V,x,$e);break;case">=":ye=le(V,x,$e);break;case"<":ye=C(V,x,$e);break;case"<=":ye=ae(V,x,$e);break;default:throw new TypeError("Invalid operator: "+Y)}return ye}function de(V,Y){if(V instanceof de){if(V.loose===Y)return V;V=V.value}if(!(this instanceof de))return new de(V,Y);D("comparator",V,Y),this.loose=Y,this.parse(V),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(V,Y){return a(Y,V)},e.major=function(V,Y){return new M(V,Y).major},e.minor=function(V,Y){return new M(V,Y).minor},e.patch=function(V,Y){return new M(V,Y).patch},e.compare=g,e.compareLoose=function(V,Y){return g(V,Y,!0)},e.rcompare=function(V,Y,x){return g(Y,V,x)},e.sort=function(V,Y){return V.sort(function(x,$e){return e.compare(x,$e,Y)})},e.rsort=function(V,Y){return V.sort(function(x,$e){return e.rcompare(x,$e,Y)})},e.gt=z,e.lt=C,e.eq=Q,e.neq=W,e.gte=le,e.lte=ae,e.cmp=me,e.Comparator=de;var ge={};function fe(V,Y){if(V instanceof fe)return V.loose===Y?V:new fe(V.raw,Y);if(V instanceof de)return new fe(V.value,Y);if(!(this instanceof fe))return new fe(V,Y);if(this.loose=Y,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(x){return this.parseRange(x.trim())},this).filter(function(x){return x.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function he(V){return!V||V.toLowerCase()==="x"||V==="*"}function we(V,Y,x,$e,ye,De,ke,Le,Ie,je,Ue,Oe,Ne){return((Y=he(x)?"":he($e)?">="+x+".0.0":he(ye)?">="+x+"."+$e+".0":">="+Y)+" "+(Le=he(Ie)?"":he(je)?"<"+(+Ie+1)+".0.0":he(Ue)?"<"+Ie+"."+(+je+1)+".0":Oe?"<="+Ie+"."+je+"."+Ue+"-"+Oe:"<="+Le)).trim()}function ve(V,Y){for(var x=0;x<V.length;x++)if(!V[x].test(Y))return!1;if(Y.prerelease.length){for(x=0;x<V.length;x++)if(D(V[x].semver),V[x].semver!==ge&&V[x].semver.prerelease.length>0){var $e=V[x].semver;if($e.major===Y.major&&$e.minor===Y.minor&&$e.patch===Y.patch)return!0}return!1}return!0}function Se(V,Y,x){try{Y=new fe(Y,x)}catch{return!1}return Y.test(V)}function Me(V,Y,x,$e){var ye,De,ke,Le,Ie;switch(V=new M(V,$e),Y=new fe(Y,$e),x){case">":ye=z,De=ae,ke=C,Le=">",Ie=">=";break;case"<":ye=C,De=le,ke=z,Le="<",Ie="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Se(V,Y,$e))return!1;for(var je=0;je<Y.set.length;++je){var Ue=Y.set[je],Oe=null,Ne=null;if(Ue.forEach(function(ze){ze.semver===ge&&(ze=new de(">=0.0.0")),Oe=Oe||ze,Ne=Ne||ze,ye(ze.semver,Oe.semver,$e)?Oe=ze:ke(ze.semver,Ne.semver,$e)&&(Ne=ze)}),Oe.operator===Le||Oe.operator===Ie||(!Ne.operator||Ne.operator===Le)&&De(V,Ne.semver)||Ne.operator===Ie&&ke(V,Ne.semver))return!1}return!0}de.prototype.parse=function(V){var Y=this.loose?b[q]:b[X],x=V.match(Y);if(!x)throw new TypeError("Invalid comparator: "+V);this.operator=x[1],this.operator==="="&&(this.operator=""),x[2]?this.semver=new M(x[2],this.loose):this.semver=ge},de.prototype.toString=function(){return this.value},de.prototype.test=function(V){return D("Comparator.test",V,this.loose),this.semver===ge||(typeof V=="string"&&(V=new M(V,this.loose)),me(V,this.operator,this.semver,this.loose))},de.prototype.intersects=function(V,Y){if(!(V instanceof de))throw new TypeError("a Comparator is required");var x;if(this.operator==="")return x=new fe(V.value,Y),Se(this.value,x,Y);if(V.operator==="")return x=new fe(this.value,Y),Se(V.semver,x,Y);var $e=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),ye=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),De=this.semver.version===V.semver.version,ke=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),Le=me(this.semver,"<",V.semver,Y)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),Ie=me(this.semver,">",V.semver,Y)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return $e||ye||De&&ke||Le||Ie},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(V){var Y=this.loose;V=V.trim(),D("range",V,Y);var x=Y?b[H]:b[U];V=V.replace(x,we),D("hyphen replace",V),V=V.replace(b[T],"$1$2$3"),D("comparator trim",V,b[T]),V=(V=(V=V.replace(b[_],"$1~")).replace(b[ue],"$1^")).split(/\s+/).join(" ");var $e=Y?b[q]:b[X],ye=V.split(" ").map(function(De){return function(ke,Le){return D("comp",ke),ke=function(Ie,je){return Ie.trim().split(/\s+/).map(function(Ue){return function(Oe,Ne){D("caret",Oe,Ne);var ze=Ne?b[re]:b[ce];return Oe.replace(ze,function(Ae,be,Ee,Pe,Re){var Fe;return D("caret",Oe,Ae,be,Ee,Pe,Re),he(be)?Fe="":he(Ee)?Fe=">="+be+".0.0 <"+(+be+1)+".0.0":he(Pe)?Fe=be==="0"?">="+be+"."+Ee+".0 <"+be+"."+(+Ee+1)+".0":">="+be+"."+Ee+".0 <"+(+be+1)+".0.0":Re?(D("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Fe=be==="0"?Ee==="0"?">="+be+"."+Ee+"."+Pe+Re+" <"+be+"."+Ee+"."+(+Pe+1):">="+be+"."+Ee+"."+Pe+Re+" <"+be+"."+(+Ee+1)+".0":">="+be+"."+Ee+"."+Pe+Re+" <"+(+be+1)+".0.0"):(D("no pr"),Fe=be==="0"?Ee==="0"?">="+be+"."+Ee+"."+Pe+" <"+be+"."+Ee+"."+(+Pe+1):">="+be+"."+Ee+"."+Pe+" <"+be+"."+(+Ee+1)+".0":">="+be+"."+Ee+"."+Pe+" <"+(+be+1)+".0.0"),D("caret return",Fe),Fe})}(Ue,je)}).join(" ")}(ke,Le),D("caret",ke),ke=function(Ie,je){return Ie.trim().split(/\s+/).map(function(Ue){return function(Oe,Ne){var ze=Ne?b[oe]:b[ee];return Oe.replace(ze,function(Ae,be,Ee,Pe,Re){var Fe;return D("tilde",Oe,Ae,be,Ee,Pe,Re),he(be)?Fe="":he(Ee)?Fe=">="+be+".0.0 <"+(+be+1)+".0.0":he(Pe)?Fe=">="+be+"."+Ee+".0 <"+be+"."+(+Ee+1)+".0":Re?(D("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Fe=">="+be+"."+Ee+"."+Pe+Re+" <"+be+"."+(+Ee+1)+".0"):Fe=">="+be+"."+Ee+"."+Pe+" <"+be+"."+(+Ee+1)+".0",D("tilde return",Fe),Fe})}(Ue,je)}).join(" ")}(ke,Le),D("tildes",ke),ke=function(Ie,je){return D("replaceXRanges",Ie,je),Ie.split(/\s+/).map(function(Ue){return function(Oe,Ne){Oe=Oe.trim();var ze=Ne?b[w]:b[v];return Oe.replace(ze,function(Ae,be,Ee,Pe,Re,Fe){D("xRange",Oe,Ae,be,Ee,Pe,Re,Fe);var qe=he(Ee),Ce=qe||he(Pe),Te=Ce||he(Re);return be==="="&&Te&&(be=""),qe?Ae=be===">"||be==="<"?"<0.0.0":"*":be&&Te?(Ce&&(Pe=0),Te&&(Re=0),be===">"?(be=">=",Ce?(Ee=+Ee+1,Pe=0,Re=0):Te&&(Pe=+Pe+1,Re=0)):be==="<="&&(be="<",Ce?Ee=+Ee+1:Pe=+Pe+1),Ae=be+Ee+"."+Pe+"."+Re):Ce?Ae=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":Te&&(Ae=">="+Ee+"."+Pe+".0 <"+Ee+"."+(+Pe+1)+".0"),D("xRange return",Ae),Ae})}(Ue,je)}).join(" ")}(ke,Le),D("xrange",ke),ke=function(Ie,je){return D("replaceStars",Ie,je),Ie.trim().replace(b[G],"")}(ke,Le),D("stars",ke),ke}(De,Y)}).join(" ").split(/\s+/);return this.loose&&(ye=ye.filter(function(De){return!!De.match($e)})),ye=ye.map(function(De){return new de(De,Y)})},fe.prototype.intersects=function(V,Y){if(!(V instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(x){return x.every(function($e){return V.set.some(function(ye){return ye.every(function(De){return $e.intersects(De,Y)})})})})},e.toComparators=function(V,Y){return new fe(V,Y).set.map(function(x){return x.map(function($e){return $e.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new M(V,this.loose));for(var Y=0;Y<this.set.length;Y++)if(ve(this.set[Y],V))return!0;return!1},e.satisfies=Se,e.maxSatisfying=function(V,Y,x){var $e=null,ye=null;try{var De=new fe(Y,x)}catch{return null}return V.forEach(function(ke){De.test(ke)&&($e&&ye.compare(ke)!==-1||(ye=new M($e=ke,x)))}),$e},e.minSatisfying=function(V,Y,x){var $e=null,ye=null;try{var De=new fe(Y,x)}catch{return null}return V.forEach(function(ke){De.test(ke)&&($e&&ye.compare(ke)!==1||(ye=new M($e=ke,x)))}),$e},e.validRange=function(V,Y){try{return new fe(V,Y).range||"*"}catch{return null}},e.ltr=function(V,Y,x){return Me(V,Y,"<",x)},e.gtr=function(V,Y,x){return Me(V,Y,">",x)},e.outside=Me,e.prerelease=function(V,Y){var x=K(V,Y);return x&&x.prerelease.length?x.prerelease:null},e.intersects=function(V,Y,x){return V=new fe(V,x),Y=new fe(Y,x),V.intersects(Y)},e.coerce=function(V){if(V instanceof M)return V;if(typeof V!="string")return null;var Y=V.match(b[R]);return Y==null?null:K((Y[1]||"0")+"."+(Y[2]||"0")+"."+(Y[3]||"0"))}}).call(this,L(1))},function(J,e){var L,N,D=J.exports={};function A(){throw new Error("setTimeout has not been defined")}function j(){throw new Error("clearTimeout has not been defined")}function b(m){if(L===setTimeout)return setTimeout(m,0);if((L===A||!L)&&setTimeout)return L=setTimeout,setTimeout(m,0);try{return L(m,0)}catch{try{return L.call(null,m,0)}catch{return L.call(this,m,0)}}}(function(){try{L=typeof setTimeout=="function"?setTimeout:A}catch{L=A}try{N=typeof clearTimeout=="function"?clearTimeout:j}catch{N=j}})();var h,c=[],k=!1,I=-1;function d(){k&&h&&(k=!1,h.length?c=h.concat(c):I=-1,c.length&&f())}function f(){if(!k){var m=b(d);k=!0;for(var u=c.length;u;){for(h=c,c=[];++I<u;)h&&h[I].run();I=-1,u=c.length}h=null,k=!1,function($){if(N===clearTimeout)return clearTimeout($);if((N===j||!N)&&clearTimeout)return N=clearTimeout,clearTimeout($);try{N($)}catch{try{return N.call(null,$)}catch{return N.call(this,$)}}}(m)}}function E(m,u){this.fun=m,this.array=u}function y(){}D.nextTick=function(m){var u=new Array(arguments.length-1);if(arguments.length>1)for(var $=1;$<arguments.length;$++)u[$-1]=arguments[$];c.push(new E(m,u)),c.length!==1||k||b(f)},E.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=y,D.addListener=y,D.once=y,D.off=y,D.removeListener=y,D.removeAllListeners=y,D.emit=y,D.prependListener=y,D.prependOnceListener=y,D.listeners=function(m){return[]},D.binding=function(m){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(m){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(te[73],ne([0,1]),function(J,e){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.$Cr=void 0;class N{constructor(b,h,c){this.level=b,this.key=h,this.value=c,this.forward=[]}}const D=void 0;class A{constructor(b,h=2**16){this.comparator=b,this[L]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(h)|0),this.e=new N(this.c,D,D)}get size(){return this.f}clear(){this.e=new N(this.c,D,D),this.f=0}has(b){return!!A.g(this,b,this.comparator)}get(b){return A.g(this,b,this.comparator)?.value}set(b,h){return A.h(this,b,h,this.comparator)&&(this.f+=1),this}delete(b){const h=A.k(this,b,this.comparator);return h&&(this.f-=1),h}forEach(b,h){let c=this.e.forward[0];for(;c;)b.call(h,c.value,c.key,this),c=c.forward[0]}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let b=this.e.forward[0];for(;b;)yield[b.key,b.value],b=b.forward[0]}*keys(){let b=this.e.forward[0];for(;b;)yield b.key,b=b.forward[0]}*values(){let b=this.e.forward[0];for(;b;)yield b.value,b=b.forward[0]}toString(){let b="[SkipList]:",h=this.e.forward[0];for(;h;)b+=`node(${h.key}, ${h.value}, lvl:${h.level})`,h=h.forward[0];return b}static g(b,h,c){let k=b.e;for(let I=b.d-1;I>=0;I--)for(;k.forward[I]&&c(k.forward[I].key,h)<0;)k=k.forward[I];if(k=k.forward[0],k&&c(k.key,h)===0)return k}static h(b,h,c,k){const I=[];let d=b.e;for(let f=b.d-1;f>=0;f--){for(;d.forward[f]&&k(d.forward[f].key,h)<0;)d=d.forward[f];I[f]=d}if(d=d.forward[0],d&&k(d.key,h)===0)return d.value=c,!1;{const f=A.j(b);if(f>b.d){for(let E=b.d;E<f;E++)I[E]=b.e;b.d=f}d=new N(f,h,c);for(let E=0;E<f;E++)d.forward[E]=I[E].forward[E],I[E].forward[E]=d;return!0}}static j(b,h=.5){let c=1;for(;Math.random()<h&&c<b.c;)c+=1;return c}static k(b,h,c){const k=[];let I=b.e;for(let d=b.d-1;d>=0;d--){for(;I.forward[d]&&c(I.forward[d].key,h)<0;)I=I.forward[d];k[d]=I}if(I=I.forward[0],!I||c(I.key,h)!==0)return!1;for(let d=0;d<b.d&&k[d].forward[d]===I;d++)k[d].forward[d]=I.forward[d];for(;b.d>0&&b.e.forward[b.d-1]===D;)b.d-=1;return!0}}e.$Cr=A}),define(te[45],ne([0,1,9,2]),function(J,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=void 0;function D(p){const S=p;return S?typeof S.read=="function":!1}e.$Zd=D;function A(p){const S=p;return S?[S.on,S.pause,S.resume,S.destroy].every(s=>typeof s=="function"):!1}e.$1d=A;function j(p){const S=p;return S?A(S.stream)&&Array.isArray(S.buffer)&&typeof S.ended=="boolean":!1}e.$2d=j;function b(p,S){return new h(p,S)}e.$3d=b;class h{constructor(S,s){this.e=S,this.f=s,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(S){if(!this.a.destroyed){if(this.a.flowing)this.g(S);else if(this.b.data.push(S),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(s=>this.d.push(s))}}error(S){this.a.destroyed||(this.a.flowing?this.h(S):this.b.error.push(S))}end(S){this.a.destroyed||(typeof S<"u"&&this.write(S),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(S){this.c.data.slice(0).forEach(s=>s(S))}h(S){this.c.error.length===0?(0,L.$Z)(S):this.c.error.slice(0).forEach(s=>s(S))}i(){this.c.end.slice(0).forEach(S=>S())}on(S,s){if(!this.a.destroyed)switch(S){case"data":this.c.data.push(s),this.resume();break;case"end":this.c.end.push(s),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(s),this.a.flowing&&this.k();break}}removeListener(S,s){if(this.a.destroyed)return;let o;switch(S){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const t=o.indexOf(s);t>=0&&o.splice(t,1)}}j(){if(this.b.data.length>0){const S=this.e(this.b.data);this.g(S),this.b.data.length=0;const s=[...this.d];this.d.length=0,s.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const S of this.b.error)this.h(S);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(p,S){const s=[];let o;for(;(o=p.read())!==null;)s.push(o);return S(s)}e.$4d=c;function k(p,S,s){const o=[];let t;for(;(t=p.read())!==null&&o.length<s;)o.push(t);return t===null&&o.length>0?S(o):{read:()=>{if(o.length>0)return o.shift();if(typeof t<"u"){const i=t;return t=void 0,i}return p.read()}}}e.$5d=k;function I(p,S){return new Promise((s,o)=>{const t=[];d(p,{onData:i=>{S&&t.push(i)},onError:i=>{S?o(i):s(void 0)},onEnd:()=>{s(S?S(t):void 0)}})})}e.$6d=I;function d(p,S,s){p.on("error",o=>{s?.isCancellationRequested||S.onError(o)}),p.on("end",()=>{s?.isCancellationRequested||S.onEnd()}),p.on("data",o=>{s?.isCancellationRequested||S.onData(o)})}e.$7d=d;function f(p,S){return new Promise((s,o)=>{const t=new N.$Qc,i=[],n=P=>{if(i.push(P),i.length>S)return t.dispose(),p.pause(),s({stream:p,buffer:i,ended:!1})},r=P=>(t.dispose(),o(P)),l=()=>(t.dispose(),s({stream:p,buffer:i,ended:!0}));t.add((0,N.$Pc)(()=>p.removeListener("error",r))),p.on("error",r),t.add((0,N.$Pc)(()=>p.removeListener("end",l))),p.on("end",l),t.add((0,N.$Pc)(()=>p.removeListener("data",n))),p.on("data",n)})}e.$8d=f;function E(p,S){const s=b(S);return s.end(p),s}e.$9d=E;function y(){const p=b(()=>{throw new Error("not supported")});return p.end(),p}e.$0d=y;function m(p){let S=!1;return{read:()=>S?null:(S=!0,p)}}e.$$d=m;function u(p,S,s){const o=b(s);return d(p,{onData:t=>o.write(S.data(t)),onError:t=>o.error(S.error?S.error(t):t),onEnd:()=>o.end()}),o}e.$_d=u;function $(p,S,s){let o=!1;return{read:()=>{const t=S.read();return o?t:(o=!0,t!==null?s([p,t]):p)}}}e.$ae=$;function O(p,S,s){let o=!1;const t=b(s);return d(S,{onData:i=>o?t.write(i):(o=!0,t.write(s([p,i]))),onError:i=>t.error(i),onEnd:()=>{o||(o=!0,t.write(p)),t.end()}}),t}e.$be=O}),define(te[14],ne([0,1,164,45]),function(J,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=void 0;const D=typeof Buffer<"u",A=new L.$U(()=>new Uint8Array(256));let j,b;class h{static alloc(R){return D?new h(Buffer.allocUnsafe(R)):new h(new Uint8Array(R))}static wrap(R){return D&&!Buffer.isBuffer(R)&&(R=Buffer.from(R.buffer,R.byteOffset,R.byteLength)),new h(R)}static fromString(R,B){return!(B?.dontUseNodeBuffer||!1)&&D?new h(Buffer.from(R)):(j||(j=new TextEncoder),new h(j.encode(R)))}static fromByteArray(R){const B=h.alloc(R.length);for(let _=0,ee=R.length;_<ee;_++)B.buffer[_]=R[_];return B}static concat(R,B){if(typeof B>"u"){B=0;for(let oe=0,se=R.length;oe<se;oe++)B+=R[oe].byteLength}const _=h.alloc(B);let ee=0;for(let oe=0,se=R.length;oe<se;oe++){const ue=R[oe];_.set(ue,ee),ee+=ue.byteLength}return _}constructor(R){this.buffer=R,this.byteLength=this.buffer.byteLength}clone(){const R=h.alloc(this.byteLength);return R.set(this),R}toString(){return D?this.buffer.toString():(b||(b=new TextDecoder),b.decode(this.buffer))}slice(R,B){return new h(this.buffer.subarray(R,B))}set(R,B){if(R instanceof h)this.buffer.set(R.buffer,B);else if(R instanceof Uint8Array)this.buffer.set(R,B);else if(R instanceof ArrayBuffer)this.buffer.set(new Uint8Array(R),B);else if(ArrayBuffer.isView(R))this.buffer.set(new Uint8Array(R.buffer,R.byteOffset,R.byteLength),B);else throw new Error("Unknown argument 'array'")}readUInt32BE(R){return d(this.buffer,R)}writeUInt32BE(R,B){f(this.buffer,R,B)}readUInt32LE(R){return E(this.buffer,R)}writeUInt32LE(R,B){y(this.buffer,R,B)}readUInt8(R){return m(this.buffer,R)}writeUInt8(R,B){u(this.buffer,R,B)}indexOf(R,B=0){return c(this.buffer,R instanceof h?R.buffer:R,B)}}e.$ce=h;function c(w,R,B=0){const _=R.byteLength,ee=w.byteLength;if(_===0)return 0;if(_===1)return w.indexOf(R[0]);if(_>ee-B)return-1;const oe=A.value;oe.fill(R.length);for(let re=0;re<R.length;re++)oe[R[re]]=R.length-re-1;let se=B+R.length-1,ue=se,ce=-1;for(;se<ee;)if(w[se]===R[ue]){if(ue===0){ce=se;break}se--,ue--}else se+=Math.max(R.length-ue,oe[w[se]]),ue=R.length-1;return ce}e.$de=c;function k(w,R){return w[R+0]<<0>>>0|w[R+1]<<8>>>0}e.$ee=k;function I(w,R,B){w[B+0]=R&255,R=R>>>8,w[B+1]=R&255}e.$fe=I;function d(w,R){return w[R]*2**24+w[R+1]*2**16+w[R+2]*2**8+w[R+3]}e.$ge=d;function f(w,R,B){w[B+3]=R,R=R>>>8,w[B+2]=R,R=R>>>8,w[B+1]=R,R=R>>>8,w[B]=R}e.$he=f;function E(w,R){return w[R+0]<<0>>>0|w[R+1]<<8>>>0|w[R+2]<<16>>>0|w[R+3]<<24>>>0}e.$ie=E;function y(w,R,B){w[B+0]=R&255,R=R>>>8,w[B+1]=R&255,R=R>>>8,w[B+2]=R&255,R=R>>>8,w[B+3]=R&255}e.$je=y;function m(w,R){return w[R]}e.$ke=m;function u(w,R,B){w[B]=R}e.$le=u;function $(w){return N.$4d(w,R=>h.concat(R))}e.$me=$;function O(w){return N.$$d(w)}e.$ne=O;function p(w){return N.$6d(w,R=>h.concat(R))}e.$oe=p;async function S(w){return w.ended?h.concat(w.buffer):h.concat([...w.buffer,await p(w.stream)])}e.$pe=S;function s(w){return N.$9d(w,R=>h.concat(R))}e.$qe=s;function o(w){return N.$_d(w,{data:R=>typeof R=="string"?h.fromString(R):h.wrap(R)},R=>h.concat(R))}e.$re=o;function t(w){return N.$3d(R=>h.concat(R),w)}e.$se=t;function i(w,R){return N.$ae(w,R,B=>h.concat(B))}e.$te=i;function n(w,R){return N.$be(w,R,B=>h.concat(B))}e.$ue=n;function r(w){let R=0,B=0,_=0;const ee=new Uint8Array(Math.floor(w.length/4*3)),oe=ue=>{switch(B){case 3:ee[_++]=R|ue,B=0;break;case 2:ee[_++]=R|ue>>>2,R=ue<<6,B=3;break;case 1:ee[_++]=R|ue>>>4,R=ue<<4,B=2;break;default:R=ue<<2,B=1}};for(let ue=0;ue<w.length;ue++){const ce=w.charCodeAt(ue);if(ce>=65&&ce<=90)oe(ce-65);else if(ce>=97&&ce<=122)oe(ce-97+26);else if(ce>=48&&ce<=57)oe(ce-48+52);else if(ce===43||ce===45)oe(62);else if(ce===47||ce===95)oe(63);else{if(ce===61)break;throw new SyntaxError(`Unexpected base64 character ${w[ue]}`)}}const se=_;for(;B>0;)oe(0);return h.wrap(ee).slice(0,se)}e.$ve=r;const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",P="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function v({buffer:w},R=!0,B=!1){const _=B?P:l;let ee="";const oe=w.byteLength%3;let se=0;for(;se<w.byteLength-oe;se+=3){const ue=w[se+0],ce=w[se+1],re=w[se+2];ee+=_[ue>>>2],ee+=_[(ue<<4|ce>>>4)&63],ee+=_[(ce<<2|re>>>6)&63],ee+=_[re&63]}if(oe===1){const ue=w[se+0];ee+=_[ue>>>2],ee+=_[ue<<4&63],R&&(ee+="==")}else if(oe===2){const ue=w[se+0],ce=w[se+1];ee+=_[ue>>>2],ee+=_[(ue<<4|ce>>>4)&63],ee+=_[ce<<2&63],R&&(ee+="=")}return ee}e.$we=v}),define(te[41],ne([0,1,29]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=void 0;function N(u){return D(u,0)}e.$Hi=N;function D(u,$){switch(typeof u){case"object":return u===null?A(349,$):Array.isArray(u)?h(u,$):c(u,$);case"string":return b(u,$);case"boolean":return j(u,$);case"number":return A(u,$);case"undefined":return A(937,$);default:return A(617,$)}}e.$Ii=D;function A(u,$){return($<<5)-$+u|0}e.$Ji=A;function j(u,$){return A(u?433:863,$)}function b(u,$){$=A(149417,$);for(let O=0,p=u.length;O<p;O++)$=A(u.charCodeAt(O),$);return $}e.$Ki=b;function h(u,$){return $=A(104579,$),u.reduce((O,p)=>D(p,O),$)}function c(u,$){return $=A(181387,$),Object.keys(u).sort().reduce((O,p)=>(O=b(p,O),D(u[p],O)),$)}class k{constructor(){this.g=0}get value(){return this.g}hash($){return this.g=D($,this.g),this.g}}e.$Li=k;var I;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function d(u,$,O=32){const p=O-$,S=~((1<<p)-1);return(u<<$|(S&u)>>>p)>>>0}function f(u,$=0,O=u.byteLength,p=0){for(let S=0;S<O;S++)u[$+S]=p}function E(u,$,O="0"){for(;u.length<$;)u=O+u;return u}function y(u,$=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(O=>O.toString(16).padStart(2,"0")).join(""):E((u>>>0).toString(16),$/4)}e.$Mi=y;class m{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update($){const O=$.length;if(O===0)return;const p=this.p;let S=this.r,s=this.u,o,t;for(s!==0?(o=s,t=-1,s=0):(o=$.charCodeAt(0),t=0);;){let i=o;if(L.$7e(o))if(t+1<O){const n=$.charCodeAt(t+1);L.$8e(n)?(t++,i=L.$9e(o,n)):i=65533}else{s=o;break}else L.$8e(o)&&(i=65533);if(S=this.w(p,S,i),t++,t<O)o=$.charCodeAt(t);else break}this.r=S,this.u=s}w($,O,p){return p<128?$[O++]=p:p<2048?($[O++]=192|(p&1984)>>>6,$[O++]=128|(p&63)>>>0):p<65536?($[O++]=224|(p&61440)>>>12,$[O++]=128|(p&4032)>>>6,$[O++]=128|(p&63)>>>0):($[O++]=240|(p&1835008)>>>18,$[O++]=128|(p&258048)>>>12,$[O++]=128|(p&4032)>>>6,$[O++]=128|(p&63)>>>0),O>=64&&(this.y(),O-=64,this.t+=64,$[0]=$[64+0],$[1]=$[64+1],$[2]=$[64+2]),O}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),y(this.h)+y(this.l)+y(this.m)+y(this.n)+y(this.o)}x(){this.p[this.r++]=128,f(this.p,this.r),this.r>56&&(this.y(),f(this.p));const $=8*this.t;this.q.setUint32(56,Math.floor($/4294967296),!1),this.q.setUint32(60,$%4294967296,!1),this.y()}y(){const $=m.g,O=this.q;for(let l=0;l<64;l+=4)$.setUint32(l,O.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)$.setUint32(l,d($.getUint32(l-12,!1)^$.getUint32(l-32,!1)^$.getUint32(l-56,!1)^$.getUint32(l-64,!1),1),!1);let p=this.h,S=this.l,s=this.m,o=this.n,t=this.o,i,n,r;for(let l=0;l<80;l++)l<20?(i=S&s|~S&o,n=1518500249):l<40?(i=S^s^o,n=1859775393):l<60?(i=S&s|S&o|s&o,n=2400959708):(i=S^s^o,n=3395469782),r=d(p,5)+i+t+n+$.getUint32(l*4,!1)&4294967295,t=o,o=s,s=d(S,30),S=p,p=r;this.h=this.h+p&4294967295,this.l=this.l+S&4294967295,this.m=this.m+s&4294967295,this.n=this.n+o&4294967295,this.o=this.o+t&4294967295}}e.$Ni=m}),define(te[54],ne([0,1,29]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(N||(N={})),function(D){const A="error",j="warning",b="warn",h="info",c="ignore";function k(d){return d?L.$3e(A,d)?D.Error:L.$3e(j,d)||L.$3e(b,d)?D.Warning:L.$3e(h,d)?D.Info:D.Ignore:D.Ignore}D.fromValue=k;function I(d){switch(d){case D.Error:return A;case D.Warning:return j;case D.Info:return h;default:return c}}D.toString=I}(N||(N={})),e.default=N}),define(te[30],ne([0,1,3]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=void 0;function N(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const $=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([O,p])=>{$[O]=p&&typeof p=="object"?N(p):p}),$}e.$$m=N;function D(u){if(!u||typeof u!="object")return u;const $=[u];for(;$.length>0;){const O=$.shift();Object.freeze(O);for(const p in O)if(A.call(O,p)){const S=O[p];typeof S=="object"&&!Object.isFrozen(S)&&!(0,L.$Cf)(S)&&$.push(S)}}return u}e.$_m=D;const A=Object.prototype.hasOwnProperty;function j(u,$){return b(u,$,new Set)}e.$an=j;function b(u,$,O){if((0,L.$If)(u))return u;const p=$(u);if(typeof p<"u")return p;if(Array.isArray(u)){const S=[];for(const s of u)S.push(b(s,$,O));return S}if((0,L.$Bf)(u)){if(O.has(u))throw new Error("Cannot clone recursive data-structure");O.add(u);const S={};for(const s in u)A.call(u,s)&&(S[s]=b(u[s],$,O));return O.delete(u),S}return u}function h(u,$,O=!0){return(0,L.$Bf)(u)?((0,L.$Bf)($)&&Object.keys($).forEach(p=>{p in u?O&&((0,L.$Bf)(u[p])&&(0,L.$Bf)($[p])?h(u[p],$[p],O):u[p]=$[p]):u[p]=$[p]}),u):$}e.$bn=h;function c(u,$){if(u===$)return!0;if(u==null||$===null||$===void 0||typeof u!=typeof $||typeof u!="object"||Array.isArray(u)!==Array.isArray($))return!1;let O,p;if(Array.isArray(u)){if(u.length!==$.length)return!1;for(O=0;O<u.length;O++)if(!c(u[O],$[O]))return!1}else{const S=[];for(p in u)S.push(p);S.sort();const s=[];for(p in $)s.push(p);if(s.sort(),!c(S,s))return!1;for(O=0;O<S.length;O++)if(!c(u[S[O]],$[S[O]]))return!1}return!0}e.$cn=c;function k(u){const $=new Set;return JSON.stringify(u,(O,p)=>{if((0,L.$Bf)(p)||Array.isArray(p)){if($.has(p))return"[Circular]";$.add(p)}return p})}e.$dn=k;function I(u,$){const O=Object.create(null);return!u||!$||Object.keys($).forEach(S=>{const s=u[S],o=$[S];c(s,o)||(O[S]=o)}),O}e.$en=I;function d(u,$){const O=$.toLowerCase(),p=Object.keys(u).find(S=>S.toLowerCase()===O);return p?u[p]:u[$]}e.$fn=d;function f(u,$){const O=Object.create(null);for(const[p,S]of Object.entries(u))$(p,S)&&(O[p]=S);return O}e.$gn=f;function E(u){let $=[];for(;Object.prototype!==u;)$=$.concat(Object.getOwnPropertyNames(u)),u=Object.getPrototypeOf(u);return $}e.$hn=E;function y(u){const $=[];for(const O of E(u))typeof u[O]=="function"&&$.push(O);return $}e.$in=y;function m(u,$){const O=S=>function(){const s=Array.prototype.slice.call(arguments,0);return $(S,s)},p={};for(const S of u)p[S]=O(S);return p}e.$jn=m}),define(te[28],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fg=e.$eg=void 0;const L=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(D){return L.test(D)}e.$eg=N,e.$fg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(b){for(let h=0;h<b.length;h++)b[h]=Math.floor(Math.random()*256);return b};const A=new Uint8Array(16),j=[];for(let b=0;b<256;b++)j.push(b.toString(16).padStart(2,"0"));return function(){D(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let h=0,c="";return c+=j[A[h++]],c+=j[A[h++]],c+=j[A[h++]],c+=j[A[h++]],c+="-",c+=j[A[h++]],c+=j[A[h++]],c+="-",c+=j[A[h++]],c+=j[A[h++]],c+="-",c+=j[A[h++]],c+=j[A[h++]],c+="-",c+=j[A[h++]],c+=j[A[h++]],c+=j[A[h++]],c+=j[A[h++]],c+=j[A[h++]],c+=j[A[h++]],c}}()}),define(te[74],ne([0,1,33]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=void 0;const N=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(j){const b=j.replace(/\-/g,":").toLowerCase();return!N.has(b)}function A(){const j=(0,L.networkInterfaces)();for(const b in j){const h=j[b];if(h){for(const{mac:c}of h)if(D(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$Um=A}),define(te[75],ne([7,5]),function(J,e){return J.create("vs/base/common/date",e)}),define(te[76],ne([0,1,75]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$im=e.$hm=void 0;const N=60,D=N*60,A=D*24,j=A*7,b=A*30,h=A*365;function c(I,d,f,E){typeof I!="number"&&(I=I.getTime());const y=Math.round((new Date().getTime()-I)/1e3);if(y<-30)return(0,L.localize)(0,null,c(new Date().getTime()+y*1e3,!1));if(!E&&y<30)return(0,L.localize)(1,null);let m;return y<N?(m=y,d?m===1?f?(0,L.localize)(2,null,m):(0,L.localize)(3,null,m):f?(0,L.localize)(4,null,m):(0,L.localize)(5,null,m):m===1?f?(0,L.localize)(6,null,m):(0,L.localize)(7,null,m):f?(0,L.localize)(8,null,m):(0,L.localize)(9,null,m)):y<D?(m=Math.floor(y/N),d?m===1?f?(0,L.localize)(10,null,m):(0,L.localize)(11,null,m):f?(0,L.localize)(12,null,m):(0,L.localize)(13,null,m):m===1?f?(0,L.localize)(14,null,m):(0,L.localize)(15,null,m):f?(0,L.localize)(16,null,m):(0,L.localize)(17,null,m)):y<A?(m=Math.floor(y/D),d?m===1?f?(0,L.localize)(18,null,m):(0,L.localize)(19,null,m):f?(0,L.localize)(20,null,m):(0,L.localize)(21,null,m):m===1?f?(0,L.localize)(22,null,m):(0,L.localize)(23,null,m):f?(0,L.localize)(24,null,m):(0,L.localize)(25,null,m)):y<j?(m=Math.floor(y/A),d?m===1?(0,L.localize)(26,null,m):(0,L.localize)(27,null,m):m===1?(0,L.localize)(28,null,m):(0,L.localize)(29,null,m)):y<b?(m=Math.floor(y/j),d?m===1?f?(0,L.localize)(30,null,m):(0,L.localize)(31,null,m):f?(0,L.localize)(32,null,m):(0,L.localize)(33,null,m):m===1?f?(0,L.localize)(34,null,m):(0,L.localize)(35,null,m):f?(0,L.localize)(36,null,m):(0,L.localize)(37,null,m)):y<h?(m=Math.floor(y/b),d?m===1?f?(0,L.localize)(38,null,m):(0,L.localize)(39,null,m):f?(0,L.localize)(40,null,m):(0,L.localize)(41,null,m):m===1?f?(0,L.localize)(42,null,m):(0,L.localize)(43,null,m):f?(0,L.localize)(44,null,m):(0,L.localize)(45,null,m)):(m=Math.floor(y/h),d?m===1?f?(0,L.localize)(46,null,m):(0,L.localize)(47,null,m):f?(0,L.localize)(48,null,m):(0,L.localize)(49,null,m):m===1?f?(0,L.localize)(50,null,m):(0,L.localize)(51,null,m):f?(0,L.localize)(52,null,m):(0,L.localize)(53,null,m))}e.$hm=c;function k(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$im=k}),define(te[77],ne([7,5]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(te[34],ne([0,1,19,3,77]),function(J,e,L,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gi=e.$Fi=e.$Ei=void 0;function A(I,d){return d&&(I.stack||I.stacktrace)?D.localize(0,null,b(I),j(I.stack)||j(I.stacktrace)):b(I)}function j(I){return Array.isArray(I)?I.join(`
`):I}function b(I){return I.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${I.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?D.localize(1,null,I.message):I.message||D.localize(2,null)}function h(I=null,d=!1){if(!I)return D.localize(3,null);if(Array.isArray(I)){const f=L.$Gb(I),E=h(f[0],d);return f.length>1?D.localize(4,null,E,f.length):E}if(N.$zf(I))return I;if(I.detail){const f=I.detail;if(f.error)return A(f.error,d);if(f.exception)return A(f.exception,d)}return I.stack?A(I,d):I.message?I.message:D.localize(5,null)}e.$Ei=h;function c(I){const d=I;return d instanceof Error&&Array.isArray(d.actions)}e.$Fi=c;function k(I,d){let f;return typeof I=="string"?f=new Error(I):f=I,f.actions=d,f}e.$Gi=k}),define(te[78],ne([7,5]),function(J,e){return J.create("vs/base/common/jsonErrorMessages",e)}),define(te[79],ne([0,1,78]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=void 0;function N(D){switch(D){case 1:return(0,L.localize)(0,null);case 2:return(0,L.localize)(1,null);case 3:return(0,L.localize)(2,null);case 4:return(0,L.localize)(3,null);case 5:return(0,L.localize)(4,null);case 6:return(0,L.localize)(5,null);case 7:return(0,L.localize)(6,null);case 8:return(0,L.localize)(7,null);case 9:return(0,L.localize)(8,null);default:return""}}e.$Ap=N}),define(te[55],ne([0,1,13]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=e.$Dl=e.TerminateResponseCode=e.Source=void 0;var N;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(N||(e.Source=N={}));var D;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(D||(e.TerminateResponseCode=D={}));function A(b,...h){const c=h.reduce((d,f)=>(d[f]=!0,d),{}),k=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter(d=>!c[d]).forEach(d=>{for(let f=0;f<k.length;f++)if(d.search(k[f])!==-1){delete b[d];break}})}e.$Dl=A;function j(b){b&&(delete b.DEBUG,L.$k&&delete b.DYLD_LIBRARY_PATH,L.$l&&delete b.LD_PRELOAD)}e.$El=j}),define(te[80],ne([0,1,11]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$4p=e.$3p=e.$2p=void 0;function N(c){const k=c;return k&&typeof k.type=="string"&&typeof k.severity=="string"}e.$2p=N;function D(c){const k=[];let I;try{const d=JSON.parse(c.arguments),f=d[d.length-1];f&&f.__$stack&&(d.pop(),I=f.__$stack),k.push(...d)}catch{k.push("Unable to log remote console arguments",c.arguments)}return{args:k,stack:I}}e.$3p=D;function A(c){if(typeof c!="string")return A(D(c).stack);const k=c;if(k){const I=j(k),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(d&&d.length===4)return{uri:L.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}e.$4p=A;function j(c){if(!c)return c;const k=c.indexOf(`
`);return k===-1?c:c.substring(0,k)}function b(c,k){const{args:I,stack:d}=D(c),f=typeof I[0]=="string"&&I.length===1;let E=j(d);E&&(E=`(${E.trim()})`);let y=[];if(typeof I[0]=="string"?E&&f?y=[`%c[${k}] %c${I[0]} %c${E}`,h("blue"),h(""),h("grey")]:y=[`%c[${k}] %c${I[0]}`,h("blue"),h(""),...I.slice(1)]:y=[`%c[${k}]%`,h("blue"),...I],E&&!f&&y.push(E),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,y)}e.log=b;function h(c){return`color: ${c}`}}),define(te[46],ne([0,1,14,11]),function(J,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qh=e.$ph=e.$oh=void 0;function D(h){return JSON.stringify(h,j)}e.$oh=D;function A(h){let c=JSON.parse(h);return c=b(c),c}e.$ph=A;function j(h,c){return c instanceof RegExp?{$mid:2,source:c.source,flags:c.flags}:c}function b(h,c=0){if(!h||c>200)return h;if(typeof h=="object"){switch(h.$mid){case 1:return N.URI.revive(h);case 2:return new RegExp(h.source,h.flags);case 17:return new Date(h.source)}if(h instanceof L.$ce||h instanceof Uint8Array)return h;if(Array.isArray(h))for(let k=0;k<h.length;++k)h[k]=b(h[k],c+1);else for(const k in h)Object.hasOwnProperty.call(h,k)&&(h[k]=b(h[k],c+1))}return h}e.$qh=b}),define(te[81],ne([0,1,70,15,13,11]),function(J,e,L,N,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LC=void 0;class j{constructor(d,f,E){this.id=d,this.dependencies=f,this.callback=E}}class b{static{this.INSTANCE=new b}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(d,f,E)=>{typeof d!="string"&&(E=f,f=d,d=null),(typeof f!="object"||!Array.isArray(f))&&(E=f,f=null),this.c.push(new j(d,f,E))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){if(d.startsWith(window.location.origin)||d.startsWith("vscode-file://vscode-app"))return d;throw new Error(`[trusted_script_src] Invalid script url: ${d}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){return d}})))}async load(d){this.g();const f=await(this.a?this.i(d):this.b?this.h(d):this.j(d));if(!f)throw new Error(`Did not receive a define call from script ${d}`);if(Array.isArray(f.dependencies)&&f.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${d}. The dependencies are: ${f.dependencies.join(", ")}`);return typeof f.callback=="function"?f.callback([]):f.callback}h(d){return new Promise((f,E)=>{const y=document.createElement("script");y.setAttribute("async","async"),y.setAttribute("type","text/javascript");const m=()=>{y.removeEventListener("load",u),y.removeEventListener("error",$)},u=O=>{m(),f(this.c.pop())},$=O=>{m(),E(O)};y.addEventListener("load",u),y.addEventListener("error",$),this.f&&(d=this.f.createScriptURL(d)),y.setAttribute("src",d),document.getElementsByTagName("head")[0].appendChild(y)})}i(d){return new Promise((f,E)=>{try{this.f&&(d=this.f.createScriptURL(d)),importScripts(d),f(this.c.pop())}catch(y){E(y)}})}async j(d){try{const f=globalThis._VSCODE_NODE_MODULES.fs,E=globalThis._VSCODE_NODE_MODULES.vm,y=globalThis._VSCODE_NODE_MODULES.module,m=A.URI.parse(d).fsPath,u=f.readFileSync(m).toString(),$=y.wrap(u.replace(/^#!.*/,""));return new E.Script($).runInThisContext().apply(),this.c.pop()}catch(f){throw f}}}const h=new Map;let c={};typeof globalThis.require=="object"&&(c=globalThis.require.paths??{});async function k(I,d,f){if(L.$S){f===void 0&&(f=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),c[I]&&(I=c[I]);const E=`${I}/${d}`;if(h.has(E))return h.get(E);let y;if(/^\w[\w\d+.-]*:\/\//.test(E))y=E;else{const O=`${f&&!D.$p?N.$ag:N.$_f}/${E}`;y=N.$dg.asBrowserUri(O).toString(!0)}const m=b.INSTANCE.load(y);return h.set(E,m),m}else return await new Promise((E,y)=>{J([I],E,y)})}e.$LC=k}),define(te[82],ne([0,1,33,47,28,74,13]),function(J,e,L,N,D,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xm=e.$Wm=e.$Vm=void 0,e.$Vm=new class{c(d){return this.a||(this.a=N.$Zh.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(d)}value(){if(this.b===void 0){let d=0,f=0;const E=(0,L.networkInterfaces)();for(const y in E){const m=E[y];if(m)for(const{mac:u,internal:$}of m)$||(f+=1,this.c(u.toUpperCase())&&(d+=1))}this.b=f>0?d/f:0}return this.b}};let b;async function h(d){return b||(b=(async()=>await c(d)||D.$fg())()),b}e.$Wm=h;async function c(d){try{const f=await new Promise((y,m)=>{J(["crypto"],y,m)}),E=(0,A.$Um)();return f.createHash("sha256").update(E,"utf8").digest("hex")}catch(f){d(f);return}}const k="Software\\Microsoft\\SQMClient";async function I(d){if(j.$j){const f=await new Promise((E,y)=>{J(["@vscode/windows-registry"],E,y)});try{return f.GetStringRegKey("HKEY_LOCAL_MACHINE",k,"MachineId")||""}catch(E){return d(E),""}}return""}e.$Xm=I}),define(te[83],ne([0,1,33,16,24]),function(J,e,L,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cl=e.$Bl=void 0;const A=/^\d+$/,j=/^Microsoft.PowerShell_.*/,b=/^Microsoft.PowerShellPreview_.*/;var h;(function(p){p[p.x64=0]="x64",p[p.x86=1]="x86",p[p.ARM=2]="ARM"})(h||(h={}));let c;switch(process.arch){case"ia32":c=1;break;case"arm":case"arm64":c=2;break;default:c=0;break}let k;process.env.PROCESSOR_ARCHITEW6432?k=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?k=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?k=1:k=0;class I{constructor(S,s,o){this.exePath=S,this.displayName=s,this.a=o}async exists(){return this.a===void 0&&(this.a=await D.SymlinkSupport.existsFile(this.exePath)),this.a}}function d({useAlternateBitness:p=!1}={}){return p?c===0?process.env["ProgramFiles(x86)"]||null:k===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function f({useAlternateBitness:p=!1,findPreview:S=!1}={}){const s=d({useAlternateBitness:p});if(!s)return null;const o=N.$ic(s,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(o))return null;let t=-1,i=null;for(const l of await D.Promises.readdir(o)){let P=-1;if(S){const w=l.indexOf("-");if(w<0)continue;const R=l.substring(0,w);if(!A.test(R)||l.substring(w+1)!=="preview")continue;P=parseInt(R,10)}else{if(!A.test(l))continue;P=parseInt(l,10)}if(P<=t)continue;const v=N.$ic(o,l,"pwsh.exe");await D.SymlinkSupport.existsFile(v)&&(i=v,t=P)}if(!i)return null;const n=s.includes("x86")?" (x86)":"",r=S?" Preview":"";return new I(i,`PowerShell${r}${n}`,!0)}async function E({findPreview:p}={}){if(!process.env.LOCALAPPDATA)return null;const S=N.$ic(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(S))return null;const{pwshMsixDirRegex:s,pwshMsixName:o}=p?{pwshMsixDirRegex:b,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:j,pwshMsixName:"PowerShell (Store)"};for(const t of await D.Promises.readdir(S))if(s.test(t)){const i=N.$ic(S,t,"pwsh.exe");return new I(i,o)}return null}function y(){const p=N.$ic(L.homedir(),".dotnet","tools","pwsh.exe");return new I(p,".NET Core PowerShell Global Tool")}function m(){const p=N.$ic(process.env.windir,c===1&&k!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new I(p,"Windows PowerShell",!0)}async function*u(){let p=await f();p&&(yield p),p=await f({useAlternateBitness:!0}),p&&(yield p),p=await E(),p&&(yield p),p=y(),p&&(yield p),p=await f({findPreview:!0}),p&&(yield p),p=await E({findPreview:!0}),p&&(yield p),p=await f({useAlternateBitness:!0,findPreview:!0}),p&&(yield p),p=m(),p&&(yield p)}async function*$(){for await(const p of u())await p.exists()&&(yield p)}e.$Bl=$;async function O(){for await(const p of $())return p;return null}e.$Cl=O}),define(te[56],ne([0,1,16,13,35,55,3,24]),function(J,e,L,N,D,A,j,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Gl=e.$Fl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function h(I=D.env){return I.comspec||"cmd.exe"}e.$Fl=h;function c(I){let d=[],f=!1;const E=function(y){if(f){d.push(y);return}(!I.send(y,u=>{if(u&&console.error(u),f=!1,d.length>0){const $=d.slice(0);d=[],$.forEach(O=>E(O))}})||N.$j)&&(f=!0)};return{send:E}}e.$Gl=c;var k;(function(I){async function d(f,E,y){if(L.$hc(f))return f;if(E===void 0&&(E=D.cwd()),L.$lc(f)!=="."||(y===void 0&&j.$zf(D.env.PATH)&&(y=D.env.PATH.split(L.$sc)),y===void 0||y.length===0))return L.$ic(E,f);async function u($){if(await b.Promises.exists($)){let O;try{O=await b.Promises.stat($)}catch(p){p.message.startsWith("EACCES")&&(O=await b.Promises.lstat($))}return O?!O.isDirectory():!1}return!1}for(const $ of y){let O;if(L.$hc($)?O=L.$ic($,f):O=L.$ic(E,$,f),await u(O))return O;let p=O+".com";if(await u(p)||(p=O+".exe",await u(p)))return p}return L.$ic(E,f)}I.findExecutable=d})(k||(e.win32=k={}))}),define(te[84],ne([0,1,33,13,83,56]),function(J,e,L,N,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hl=void 0;async function j(I,d){return I===1?N.$j?k():A.$Fl(d):h(I,d)}e.$Hl=j;let b=null;function h(I,d){if(N.$l&&I===2||N.$k&&I===3)return"/bin/bash";if(!b){let f;if(N.$j)f="/bin/bash";else{if(f=d.SHELL,!f)try{f=(0,L.userInfo)().shell}catch{}f||(f="sh"),f==="/bin/false"&&(f="/bin/bash")}b=f}return b}let c=null;async function k(){return c||(c=(await(0,D.$Cl)()).exePath),c}});var pe=this&&this.__decorate||function(J,e,L,N){var D=arguments.length,A=D<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,L):N,j;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(J,e,L,N);else for(var b=J.length-1;b>=0;b--)(j=J[b])&&(A=(D<3?j(A):D>3?j(e,L,A):j(e,L))||A);return D>3&&A&&Object.defineProperty(e,L,A),A};define(te[57],ne([0,1,19,8,14,20,52,9,4,2,46,29,3]),function(J,e,L,N,D,A,j,b,h,c,k,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ch=e.ProxyChannel=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.RequestInitiator=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=void 0;var f;(function(T){T[T.Promise=100]="Promise",T[T.PromiseCancel=101]="PromiseCancel",T[T.EventListen=102]="EventListen",T[T.EventDispose=103]="EventDispose"})(f||(f={}));function E(T){switch(T){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var y;(function(T){T[T.Initialize=200]="Initialize",T[T.PromiseSuccess=201]="PromiseSuccess",T[T.PromiseError=202]="PromiseError",T[T.PromiseErrorObj=203]="PromiseErrorObj",T[T.EventFire=204]="EventFire"})(y||(y={}));function m(T){switch(T){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(T){T[T.Uninitialized=0]="Uninitialized",T[T.Idle=1]="Idle"})(u||(u={}));function $(T){let U=0;for(let H=0;;H+=7){const G=T.read(1);if(U|=(G.buffer[0]&127)<<H,!(G.buffer[0]&128))return U}}const O=t(0);function p(T,U){if(U===0){T.write(O);return}let H=0;for(let Z=U;Z!==0;Z=Z>>>7)H++;const G=D.$ce.alloc(H);for(let Z=0;U!==0;Z++)G.buffer[Z]=U&127,U=U>>>7,U>0&&(G.buffer[Z]|=128);T.write(G)}class S{constructor(U){this.b=U,this.a=0}read(U){const H=this.b.slice(this.a,this.a+U);return this.a+=H.byteLength,H}}e.$rh=S;class s{constructor(){this.a=[]}get buffer(){return D.$ce.concat(this.a)}write(U){this.a.push(U)}}e.$sh=s;var o;(function(T){T[T.Undefined=0]="Undefined",T[T.String=1]="String",T[T.Buffer=2]="Buffer",T[T.VSBuffer=3]="VSBuffer",T[T.Array=4]="Array",T[T.Object=5]="Object",T[T.Int=6]="Int"})(o||(o={}));function t(T){const U=D.$ce.alloc(1);return U.writeUInt8(T,0),U}const i={Undefined:t(o.Undefined),String:t(o.String),Buffer:t(o.Buffer),VSBuffer:t(o.VSBuffer),Array:t(o.Array),Object:t(o.Object),Uint:t(o.Int)},n=typeof Buffer<"u";function r(T,U){if(typeof U>"u")T.write(i.Undefined);else if(typeof U=="string"){const H=D.$ce.fromString(U);T.write(i.String),p(T,H.byteLength),T.write(H)}else if(n&&Buffer.isBuffer(U)){const H=D.$ce.wrap(U);T.write(i.Buffer),p(T,H.byteLength),T.write(H)}else if(U instanceof D.$ce)T.write(i.VSBuffer),p(T,U.byteLength),T.write(U);else if(Array.isArray(U)){T.write(i.Array),p(T,U.length);for(const H of U)r(T,H)}else if(typeof U=="number"&&(U|0)===U)T.write(i.Uint),p(T,U);else{const H=D.$ce.fromString(JSON.stringify(U));T.write(i.Object),p(T,H.byteLength),T.write(H)}}e.$th=r;function l(T){switch(T.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return T.read($(T)).toString();case o.Buffer:return T.read($(T)).buffer;case o.VSBuffer:return T.read($(T));case o.Array:{const H=$(T),G=[];for(let Z=0;Z<H;Z++)G.push(l(T));return G}case o.Object:return JSON.parse(T.read($(T)).toString());case o.Int:return $(T)}}e.$uh=l;class P{constructor(U,H,G=null,Z=1e3){this.h=U,this.j=H,this.k=G,this.l=Z,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(K=>this.q(K)),this.m({type:200})}registerChannel(U,H){this.b.set(U,H),setTimeout(()=>this.w(U),0)}m(U){switch(U.type){case 200:{const H=this.o([U.type]);this.k?.logOutgoing(H,0,1,m(U.type));return}case 201:case 202:case 204:case 203:{const H=this.o([U.type,U.id],U.data);this.k?.logOutgoing(H,U.id,1,m(U.type),U.data);return}}}o(U,H=void 0){const G=new s;return r(G,U),r(G,H),this.p(G.buffer)}p(U){try{return this.h.send(U),U.byteLength}catch{return 0}}q(U){const H=new S(U),G=l(H),Z=l(H),K=G[0];switch(K){case 100:return this.k?.logIncoming(U.byteLength,G[1],1,`${E(K)}: ${G[2]}.${G[3]}`,Z),this.s({type:K,id:G[1],channelName:G[2],name:G[3],arg:Z});case 102:return this.k?.logIncoming(U.byteLength,G[1],1,`${E(K)}: ${G[2]}.${G[3]}`,Z),this.t({type:K,id:G[1],channelName:G[2],name:G[3],arg:Z});case 101:return this.k?.logIncoming(U.byteLength,G[1],1,`${E(K)}`),this.u({type:K,id:G[1]});case 103:return this.k?.logIncoming(U.byteLength,G[1],1,`${E(K)}`),this.u({type:K,id:G[1]})}}s(U){const H=this.b.get(U.channelName);if(!H){this.v(U);return}const G=new A.$Yd;let Z;try{Z=H.call(this.j,U.name,U.arg,G.token)}catch(F){Z=Promise.reject(F)}const K=U.id;Z.then(F=>{this.m({id:K,data:F,type:201})},F=>{F instanceof Error?this.m({id:K,data:{message:F.message,name:F.name,stack:F.stack?F.stack.split?F.stack.split(`
`):F.stack:void 0},type:202}):this.m({id:K,data:F,type:203})}).finally(()=>{M.dispose(),this.d.delete(U.id)});const M=(0,c.$Pc)(()=>G.cancel());this.d.set(U.id,M)}t(U){const H=this.b.get(U.channelName);if(!H){this.v(U);return}const G=U.id,K=H.listen(this.j,U.name,U.arg)(M=>this.m({id:G,data:M,type:204}));this.d.set(U.id,K)}u(U){const H=this.d.get(U.id);H&&(H.dispose(),this.d.delete(U.id))}v(U){let H=this.g.get(U.channelName);H||(H=[],this.g.set(U.channelName,H));const G=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===100&&this.m({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);H.push({request:U,timeoutTimer:G})}w(U){const H=this.g.get(U);if(H){for(const G of H)switch(clearTimeout(G.timeoutTimer),G.request.type){case 100:this.s(G.request);break;case 102:this.t(G.request);break}this.g.delete(U)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.$Mc)(this.d.values()),this.d.clear()}}e.$vh=P;var v;(function(T){T[T.LocalSide=0]="LocalSide",T[T.OtherSide=1]="OtherSide"})(v||(e.RequestInitiator=v={}));class w{constructor(U,H=null){this.l=U,this.a=!1,this.b=u.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new h.$Od,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(G=>this.s(G)),this.j=H}getChannel(U){const H=this;return{call(G,Z,K){return H.a?Promise.reject(new b.$4):H.m(U,G,Z,K)},listen(G,Z){return H.a?h.Event.None:H.o(U,G,Z)}}}m(U,H,G,Z=A.CancellationToken.None){const K=this.g++,F={id:K,type:100,channelName:U,name:H,arg:G};if(Z.isCancellationRequested)return Promise.reject(new b.$4);let a;return new Promise((z,C)=>{if(Z.isCancellationRequested)return C(new b.$4);const Q=()=>{const me=de=>{switch(de.type){case 201:this.f.delete(K),z(de.data);break;case 202:{this.f.delete(K);const ge=new Error(de.data.message);ge.stack=Array.isArray(de.data.stack)?de.data.stack.join(`
`):de.data.stack,ge.name=de.data.name,C(ge);break}case 203:this.f.delete(K),C(de.data);break}};this.f.set(K,me),this.p(F)};let W=null;this.b===u.Idle?Q():(W=(0,N.$Ig)(me=>this.u()),W.then(()=>{W=null,Q()}));const le=()=>{W?(W.cancel(),W=null):this.p({id:K,type:101}),C(new b.$4)},ae=Z.onCancellationRequested(le);a=(0,c.$Oc)((0,c.$Pc)(le),ae),this.d.add(a)}).finally(()=>{a.dispose(),this.d.delete(a)})}o(U,H,G){const Z=this.g++,M={id:Z,type:102,channelName:U,name:H,arg:G};let F=null;const a=new h.$Od({onWillAddFirstListener:()=>{F=(0,N.$Ig)(z=>this.u()),F.then(()=>{F=null,this.d.add(a),this.p(M)})},onDidRemoveLastListener:()=>{F?(F.cancel(),F=null):(this.d.delete(a),this.p({id:Z,type:103}))}}),g=z=>a.fire(z.data);return this.f.set(Z,g),a.event}p(U){switch(U.type){case 100:case 102:{const H=this.q([U.type,U.id,U.channelName,U.name],U.arg);this.j?.logOutgoing(H,U.id,0,`${E(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case 101:case 103:{const H=this.q([U.type,U.id]);this.j?.logOutgoing(H,U.id,0,E(U.type));return}}}q(U,H=void 0){const G=new s;return r(G,U),r(G,H),this.r(G.buffer)}r(U){try{return this.l.send(U),U.byteLength}catch{return 0}}s(U){const H=new S(U),G=l(H),Z=l(H),K=G[0];switch(K){case 200:return this.j?.logIncoming(U.byteLength,0,0,m(K)),this.t({type:G[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(U.byteLength,G[1],0,m(K),Z),this.t({type:G[0],id:G[1],data:Z})}}t(U){if(U.type===200){this.b=u.Idle,this.k.fire();return}this.f.get(U.id)?.(U)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}u(){return this.b===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.$Mc)(this.d.values()),this.d.clear()}}e.$wh=w,pe([j.$lh],w.prototype,"onDidInitializePromise",null);class R{get connections(){const U=[];return this.f.forEach(H=>U.push(H)),U}constructor(U){this.a=new Map,this.f=new Set,this.g=new h.$Od,this.onDidAddConnection=this.g.event,this.h=new h.$Od,this.onDidRemoveConnection=this.h.event,this.j=new c.$Qc,this.j.add(U(({protocol:H,onDidClientDisconnect:G})=>{const Z=h.Event.once(H.onMessage);this.j.add(Z(K=>{const M=new S(K),F=l(M),a=new P(H,F),g=new w(H);this.a.forEach((C,Q)=>a.registerChannel(Q,C));const z={channelServer:a,channelClient:g,ctx:F};this.f.add(z),this.g.fire(z),this.j.add(G(()=>{a.dispose(),g.dispose(),this.f.delete(z),this.h.fire(z)}))}))}))}getChannel(U,H){const G=this;return{call(Z,K,M){let F;if((0,d.$Nf)(H)){const g=(0,L.$3b)(G.connections.filter(H));F=g?Promise.resolve(g):h.Event.toPromise(h.Event.filter(G.onDidAddConnection,H))}else F=H.routeCall(G,Z,K);const a=F.then(g=>g.channelClient.getChannel(U));return _(a).call(Z,K,M)},listen(Z,K){if((0,d.$Nf)(H))return G.k(U,H,Z,K);const M=H.routeEvent(G,Z,K).then(F=>F.channelClient.getChannel(U));return _(M).listen(Z,K)}}}k(U,H,G,Z){const K=this;let M;const F=new h.$Od({onWillAddFirstListener:()=>{M=new c.$Qc;const a=new h.$Ud,g=new Map,z=Q=>{const le=Q.channelClient.getChannel(U).listen(G,Z),ae=a.add(le);g.set(Q,ae)},C=Q=>{const W=g.get(Q);W&&(W.dispose(),g.delete(Q))};K.connections.filter(H).forEach(z),h.Event.filter(K.onDidAddConnection,H)(z,void 0,M),K.onDidRemoveConnection(C,void 0,M),a.event(F.fire,F,M),M.add(a)},onDidRemoveLastListener:()=>{M?.dispose(),M=void 0}});return F.event}registerChannel(U,H){this.a.set(U,H);for(const G of this.f)G.channelServer.registerChannel(U,H)}dispose(){this.j.dispose();for(const U of this.f)U.channelClient.dispose(),U.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$xh=R;class B{constructor(U,H,G=null){const Z=new s;r(Z,H),U.send(Z.buffer),this.a=new w(U,G),this.d=new P(U,H,G)}getChannel(U){return this.a.getChannel(U)}registerChannel(U,H){this.d.registerChannel(U,H)}dispose(){this.a.dispose(),this.d.dispose()}}e.$yh=B;function _(T){return{call(U,H,G){return T.then(Z=>Z.call(U,H,G))},listen(U,H){const G=new h.$Xd;return T.then(Z=>G.input=Z.listen(U,H)),G.event}}}e.$zh=_;function ee(T){let U=!1;return{call(H,G,Z){return U?T.call(H,G,Z):(0,N.$Vg)(0).then(()=>U=!0).then(()=>T.call(H,G,Z))},listen(H,G){if(U)return T.listen(H,G);const Z=new h.$Xd;return(0,N.$Vg)(0).then(()=>U=!0).then(()=>Z.input=T.listen(H,G)),Z.event}}}e.$Ah=ee;class oe{constructor(U){this.a=U}routeCall(U){return this.b(U)}routeEvent(U){return this.b(U)}async b(U){for(const H of U.connections)if(await Promise.resolve(this.a(H.ctx)))return Promise.resolve(H);return await h.Event.toPromise(U.onDidAddConnection),await this.b(U)}}e.$Bh=oe;var se;(function(T){function U(K,M,F){const a=K,g=F&&F.disableMarshalling,z=new Map;for(const C in a)G(C)&&z.set(C,h.Event.buffer(a[C],!0,void 0,M));return new class{listen(C,Q,W){const le=z.get(Q);if(le)return le;if(Z(Q)){const ae=a[Q];if(typeof ae=="function")return ae.call(a,W)}throw new b.$ab(`Event not found: ${Q}`)}call(C,Q,W){const le=a[Q];if(typeof le=="function"){if(!g&&Array.isArray(W))for(let me=0;me<W.length;me++)W[me]=(0,k.$qh)(W[me]);let ae=le.apply(a,W);return ae instanceof Promise||(ae=Promise.resolve(ae)),ae}throw new b.$ab(`Method not found: ${Q}`)}}}T.fromService=U;function H(K,M){const F=M&&M.disableMarshalling;return new Proxy({},{get(a,g){if(typeof g=="string")return M?.properties?.has(g)?M.properties.get(g):Z(g)?function(z){return K.listen(g,z)}:G(g)?K.listen(g):async function(...z){let C;M&&!(0,d.$If)(M.context)?C=[M.context,...z]:C=z;const Q=await K.call(g,C);return F?Q:(0,k.$qh)(Q)};throw new b.$ab(`Property not found: ${String(g)}`)}})}T.toService=H;function G(K){return K[0]==="o"&&K[1]==="n"&&I.$2e(K.charCodeAt(2))}function Z(K){return/^onDynamic/.test(K)&&I.$2e(K.charCodeAt(9))}})(se||(e.ProxyChannel=se={}));const ue=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ce(T){if(Array.isArray(T))return T;if(T&&typeof T=="object"&&typeof T.toString=="function"){const U=T.toString();if(U!=="[object Object]")return U}return T}function re(T){return Array.isArray(T)?T.map(ce):ce(T)}function q(T,U,H,G,Z,K,M){M=re(M);const F=ue[Z],a=F[G%F.length];let g=[`%c[${T}]%c[${String(U).padStart(7," ")}]%c[len: ${String(H).padStart(5," ")}]%c${String(G).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${a}`];/\($/.test(K)?(g=g.concat(M),g.push(")")):g.push(M),console.log.apply(console,g)}class X{constructor(U,H){this.d=U,this.f=H,this.a=0,this.b=0}logOutgoing(U,H,G,Z,K){this.b+=U,q(this.d,this.b,U,H,G,Z,K)}logIncoming(U,H,G,Z,K){this.a+=U,q(this.f,this.a,U,H,G,Z,K)}}e.$Ch=X}),define(te[85],ne([0,1,58,8,14,20,80,9,4,2,30,56,55,57]),function(J,e,L,N,D,A,j,b,h,c,k,I,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=e.$6p=void 0;class E extends f.$vh{constructor(u){super({send:$=>{try{process.send?.($.buffer.toString("base64"))}catch{}},onMessage:h.Event.fromNodeEventEmitter(process,"message",$=>D.$ce.wrap(Buffer.from($,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.$6p=E;class y{constructor(u,$){this.i=u,this.j=$,this.c=new Set,this.g=new Map,this.h=new h.$Od,this.onDidProcessExit=this.h.event;const O=$&&$.timeout?$.timeout:6e4;this.b=new N.$Rg(O),this.d=null,this.f=null}getChannel(u){const $=this;return{call(O,p,S){return $.k(u,O,p,S)},listen(O,p){return $.l(u,O,p)}}}k(u,$,O,p=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(p.isCancellationRequested)return Promise.reject(b.$5());this.b.cancel();const S=this.n(u),s=(0,N.$Ig)(i=>S.call($,O,i)),o=p.onCancellationRequested(()=>s.cancel()),t=(0,c.$Pc)(()=>s.cancel());return this.c.add(t),s.finally(()=>{o.dispose(),this.c.delete(t),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),s}l(u,$,O){if(!this.b)return h.Event.None;this.b.cancel();let p;const S=new h.$Od({onWillAddFirstListener:()=>{p=this.n(u).listen($,O)(S.fire,S),this.c.add(p)},onDidRemoveLastListener:()=>{this.c.delete(p),p.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return S.event}get m(){if(!this.f){const u=this.j&&this.j.args?this.j.args:[],$=Object.create(null);$.env={...(0,k.$$m)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&($.env={...$.env,...this.j.env}),this.j&&this.j.freshExecArgv&&($.execArgv=[]),this.j&&typeof this.j.debug=="number"&&($.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&($.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),$.execArgv===void 0&&($.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,d.$El)($.env),this.d=(0,L.fork)(this.i,u,$);const O=new h.$Od;h.Event.fromNodeEventEmitter(this.d,"message",n=>n)(n=>{if((0,j.$2p)(n)){(0,j.log)(n,`IPC Library: ${this.j.serverName}`);return}O.fire(D.$ce.wrap(Buffer.from(n,"base64")))});const S=this.j.useQueue?(0,I.$Gl)(this.d):this.d,s=n=>this.d&&this.d.connected&&S.send(n.buffer.toString("base64")),o=O.event,t={send:s,onMessage:o};this.f=new f.$wh(t);const i=()=>this.o();process.once("exit",i),this.d.on("error",n=>console.warn('IPC "'+this.j.serverName+'" errored with '+n)),this.d.on("exit",(n,r)=>{process.removeListener("exit",i),this.c.forEach(l=>(0,c.$Mc)(l)),this.c.clear(),n!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+n+" and signal "+r),this.b?.cancel(),this.o(),this.h.fire({code:n,signal:r})})}return this.f}n(u){let $=this.g.get(u);return $||($=this.m.getChannel(u),this.g.set(u,$)),$}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$7p=y}),define(te[86],ne([0,1,8,4,2,46,3]),function(J,e,L,N,D,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7o=e.$6o=e.StorageState=e.$5o=e.StorageHint=void 0;var b;(function(d){d[d.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",d[d.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(b||(e.StorageHint=b={}));function h(d){const f=d;return f?.changed instanceof Map||f?.deleted instanceof Set}e.$5o=h;var c;(function(d){d[d.None=0]="None",d[d.Initialized=1]="Initialized",d[d.Closed=2]="Closed"})(c||(e.StorageState=c={}));class k extends D.$Rc{static{this.a=100}constructor(f,E=Object.create(null)){super(),this.r=f,this.s=E,this.b=this.B(new N.$Rd),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=this.B(new L.$Sg(k.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(f=>this.u(f)))}u(f){this.b.pause();try{f.changed?.forEach((E,y)=>this.w(y,E)),f.deleted?.forEach(E=>this.w(E,void 0))}finally{this.b.resume()}}w(f,E){if(this.c===c.Closed)return;let y=!1;(0,j.$If)(E)?y=this.f.delete(f):this.f.get(f)!==E&&(this.f.set(f,E),y=!0),y&&this.b.fire({key:f,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.s.hint!==b.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(f,E){const y=this.f.get(f);return(0,j.$If)(y)?E:y}getBoolean(f,E){const y=this.get(f);return(0,j.$If)(y)?E:y==="true"}getNumber(f,E){const y=this.get(f);return(0,j.$If)(y)?E:parseInt(y,10)}getObject(f,E){const y=this.get(f);return(0,j.$If)(y)?E:(0,A.$ph)(y)}async set(f,E,y=!1){if(this.c===c.Closed)return;if((0,j.$If)(E))return this.delete(f,y);const m=(0,j.$Bf)(E)||Array.isArray(E)?(0,A.$oh)(E):String(E);if(this.f.get(f)!==m)return this.f.set(f,m),this.j.set(f,m),this.h.delete(f),this.b.fire({key:f,external:y}),this.D()}async delete(f,E=!1){if(!(this.c===c.Closed||!this.f.delete(f)))return this.h.has(f)||this.h.add(f),this.j.delete(f),this.b.fire({key:f,external:E}),this.D()}async optimize(){if(this.c!==c.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=c.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const f={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(f).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(f){if(this.z)return this.D(f)}async D(f){return this.s.hint===b.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),f)}async whenFlushed(){if(this.z)return new Promise(f=>this.n.push(f))}isInMemory(){return this.s.hint===b.STORAGE_IN_MEMORY}}e.$6o=k;class I{constructor(){this.onDidChangeItemsExternal=N.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(f){f.insert?.forEach((E,y)=>this.a.set(y,E)),f.delete?.forEach(E=>this.a.delete(E))}async optimize(){}async close(){}}e.$7o=I}),define(te[87],ne([7,5]),function(J,e){return J.create("vs/base/node/zip",e)}),define(te[88],ne([7,5]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[89],ne([7,5]),function(J,e){return J.create("vs/platform/contextkey/common/contextkey",e)}),define(te[90],ne([7,5]),function(J,e){return J.create("vs/platform/contextkey/common/scanner",e)}),define(te[91],ne([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(te[92],ne([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[93],ne([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(te[94],ne([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(te[95],ne([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(te[96],ne([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(te[97],ne([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(te[98],ne([7,5]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[99],ne([7,5]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(te[100],ne([7,5]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(te[101],ne([7,5]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[102],ne([7,5]),function(J,e){return J.create("vs/platform/languagePacks/common/languagePacks",e)}),define(te[103],ne([7,5]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(te[104],ne([7,5]),function(J,e){return J.create("vs/platform/shell/node/shellEnv",e)}),define(te[105],ne([7,5]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[106],ne([7,5]),function(J,e){return J.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(te[107],ne([7,5]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(te[108],ne([0,1,9,90]),function(J,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oi=e.TokenType=void 0;var D;(function(c){c[c.LParen=0]="LParen",c[c.RParen=1]="RParen",c[c.Neg=2]="Neg",c[c.Eq=3]="Eq",c[c.NotEq=4]="NotEq",c[c.Lt=5]="Lt",c[c.LtEq=6]="LtEq",c[c.Gt=7]="Gt",c[c.GtEq=8]="GtEq",c[c.RegexOp=9]="RegexOp",c[c.RegexStr=10]="RegexStr",c[c.True=11]="True",c[c.False=12]="False",c[c.In=13]="In",c[c.Not=14]="Not",c[c.And=15]="And",c[c.Or=16]="Or",c[c.Str=17]="Str",c[c.QuotedStr=18]="QuotedStr",c[c.Error=19]="Error",c[c.EOF=20]="EOF"})(D||(e.TokenType=D={}));function A(...c){switch(c.length){case 1:return(0,N.localize)(0,null,c[0]);case 2:return(0,N.localize)(1,null,c[0],c[1]);case 3:return(0,N.localize)(2,null,c[0],c[1],c[2]);default:return}}const j=(0,N.localize)(3,null),b=(0,N.localize)(4,null);class h{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(k){switch(k.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return k.isTripleEq?"===":"==";case 4:return k.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return k.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return k.lexeme;case 18:return k.lexeme;case 19:return k.lexeme;case 20:return"EOF";default:throw(0,L.$7)(`unhandled token type: ${JSON.stringify(k)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(k=>k.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(k){return this.c=k,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const I=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:I})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const I=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:I})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(k){return this.r()||this.c.charCodeAt(this.e)!==k?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(k){this.f.push({type:k,offset:this.d})}l(k){const I=this.d,d=this.c.substring(this.d,this.e),f={type:19,offset:this.d,lexeme:d};this.g.push({offset:I,lexeme:d,additionalInfo:k}),this.f.push(f)}n(){this.m.lastIndex=this.d;const k=this.m.exec(this.c);if(k){this.e=this.d+k[0].length;const I=this.c.substring(this.d,this.e),d=h.b.get(I);d?this.k(d):this.f.push({type:17,lexeme:I,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(j);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let k=this.e,I=!1,d=!1;for(;;){if(k>=this.c.length){this.e=k,this.l(b);return}const E=this.c.charCodeAt(k);if(I)I=!1;else if(E===47&&!d){k++;break}else E===91?d=!0:E===92?I=!0:E===93&&(d=!1);k++}for(;k<this.c.length&&h.a.has(this.c.charCodeAt(k));)k++;this.e=k;const f=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:f,offset:this.d})}r(){return this.e>=this.c.length}}e.$Oi=h}),define(te[109],ne([0,1,76,52,15,16,35,17,11]),function(J,e,L,N,D,A,j,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mm=e.$lm=e.$km=e.$jm=void 0,e.$jm=/^([^.]+\..+):(.+)$/;class c{get appRoot(){return(0,A.$lc)(D.$dg.asFileUri("").fsPath)}get userHome(){return h.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return h.URI.file((0,A.$ic)(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(this.b.tmpDir)}get cacheHome(){return h.URI.file(this.userDataPath)}get stateResource(){return(0,b.$wg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:D.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,b.$wg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const f=(0,L.$im)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.$ic)(this.userDataPath,"logs",f)}return h.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,b.$wg)(h.URI.file((0,A.$ic)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,b.$wg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,b.$wg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,b.$wg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=j.env.VSCODE_PORTABLE;return f?h.URI.file((0,A.$ic)(f,"argv.json")):(0,b.$wg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file((0,A.$ic)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,A.$jc)(f):(0,A.$gc)((0,A.$ic)(D.$dg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const f=this.args["extensions-download-dir"];return f?h.URI.file((0,A.$jc)(f)):h.URI.file((0,A.$ic)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,A.$jc)(f);const E=j.env.VSCODE_EXTENSIONS;if(E)return E;const y=j.env.VSCODE_PORTABLE;return y?(0,A.$ic)(y,"extensions"):(0,b.$wg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(E=>/^[^:/?#]+?:\/\//.test(E)?h.URI.parse(E):h.URI.file((0,A.$gc)(E)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?h.URI.parse(f):h.URI.file((0,A.$gc)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return k(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!j.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(f=>!e.$jm.test(f))}get extensionLogLevel(){const f=[];for(const E of this.args.log||[]){const y=e.$jm.exec(E);y&&y[1]&&y[2]&&f.push([y[1],y[2]])}return f.length?f:void 0}get serviceMachineIdResource(){return(0,b.$wg)(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const f=j.env.VSCODE_PORTABLE;return f?h.URI.file((0,A.$ic)(f,"policy.json")):(0,b.$wg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(f){this.args.continueOn=f}get args(){return this.a}constructor(f,E,y){this.a=f,this.b=E,this.c=y,this.editSessionId=this.args.editSessionId}}e.$km=c,pe([N.$lh],c.prototype,"appRoot",null),pe([N.$lh],c.prototype,"userHome",null),pe([N.$lh],c.prototype,"userDataPath",null),pe([N.$lh],c.prototype,"appSettingsHome",null),pe([N.$lh],c.prototype,"tmpDir",null),pe([N.$lh],c.prototype,"cacheHome",null),pe([N.$lh],c.prototype,"stateResource",null),pe([N.$lh],c.prototype,"userRoamingDataHome",null),pe([N.$lh],c.prototype,"userDataSyncHome",null),pe([N.$lh],c.prototype,"sync",null),pe([N.$lh],c.prototype,"machineSettingsResource",null),pe([N.$lh],c.prototype,"workspaceStorageHome",null),pe([N.$lh],c.prototype,"localHistoryHome",null),pe([N.$lh],c.prototype,"keyboardLayoutResource",null),pe([N.$lh],c.prototype,"argvResource",null),pe([N.$lh],c.prototype,"isExtensionDevelopment",null),pe([N.$lh],c.prototype,"untitledWorkspacesHome",null),pe([N.$lh],c.prototype,"builtinExtensionsPath",null),pe([N.$lh],c.prototype,"extensionsPath",null),pe([N.$lh],c.prototype,"extensionDevelopmentLocationURI",null),pe([N.$lh],c.prototype,"extensionDevelopmentKind",null),pe([N.$lh],c.prototype,"extensionTestsLocationURI",null),pe([N.$lh],c.prototype,"debugExtensionHost",null),pe([N.$lh],c.prototype,"logLevel",null),pe([N.$lh],c.prototype,"extensionLogLevel",null),pe([N.$lh],c.prototype,"serviceMachineIdResource",null),pe([N.$lh],c.prototype,"disableTelemetry",null),pe([N.$lh],c.prototype,"disableWorkspaceTrust",null),pe([N.$lh],c.prototype,"useInMemorySecretStorage",null),pe([N.$lh],c.prototype,"policyFile",null);function k(d,f){return I(d["inspect-extensions"],d["inspect-brk-extensions"],5870,f,d.debugId,d.extensionEnvironment)}e.$lm=k;function I(d,f,E,y,m,u){const O=Number(f||d)||(y?null:E),p=O?!!f:!1;let S;if(u)try{S=JSON.parse(u)}catch{}return{port:O,break:p,debugId:m,env:S}}e.$mm=I}),function(){"use strict";function J(e,L,N){function D(j,b){const h=A(j,b),c=[h];return e.isAbsolute(h)||c.unshift(N),e.resolve(...c)}function A(j,b){process.env.VSCODE_DEV&&(b="code-oss-dev");const h=process.env.VSCODE_PORTABLE;if(h)return e.join(h,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,b);const k=j["user-data-dir"];if(k)return k;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const I=process.env.USERPROFILE;if(typeof I!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(I,"AppData","Roaming")}break;case"darwin":c=e.join(L.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(L.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,b)}return{getUserDataPath:D}}if(typeof define=="function")define(te[110],ne([165,33,35]),function(e,L,N){return J(e,L,N.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),L=require("os");module.exports=J(e,L,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[111],ne([0,1,33,109,110]),function(J,e,L,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pm=e.$om=e.$nm=void 0;class A extends N.$km{constructor(c,k){super(c,{homeDir:(0,L.homedir)(),tmpDir:(0,L.tmpdir)(),userDataDir:(0,D.getUserDataPath)(c,k.nameShort)},k)}}e.$nm=A;function j(h,c){return(0,N.$mm)(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,c,h.extensionEnvironment)}e.$om=j;function b(h,c){return(0,N.$mm)(h["inspect-sharedprocess"],h["inspect-brk-sharedprocess"],5879,c,h.extensionEnvironment)}e.$pm=b}),define(te[112],ne([0,1,3,94]),function(J,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=void 0;function D(j,b,h,c){try{A(j,b,h,c)}catch(k){j.error(k?.message??k)}return b}e.$Bp=D;function A(j,b,h,c){const k=(I,d,f)=>{const E=I[d];if((0,L.$zf)(E)){const y=E,m=y.length;if(m>1&&y[0]==="%"&&y[m-1]==="%"){const u=y.substr(1,m-2);let $=h[u];$===void 0&&c&&($=c[u]);const O=typeof $=="string"?$:$?.message,p=c?.[u],S=typeof p=="string"?p:p?.message;if(!O){S||j.warn(`[${b.name}]: ${(0,N.localize)(0,null,u)}`);return}if(f&&(d==="title"||d==="category")&&S&&S!==O){const s={value:O,original:S};I[d]=s}else I[d]=O}}else if((0,L.$Bf)(E))for(const y in E)E.hasOwnProperty(y)&&(y==="commands"?k(E,y,!0):k(E,y,f));else if(Array.isArray(E))for(let y=0;y<E.length;y++)k(E,y,f)};for(const I in b)b.hasOwnProperty(I)&&k(b,I)}}),define(te[48],ne([0,1,17,54,98,42]),function(J,e,L,N,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=void 0;const j=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function h(u){return u=u.trim(),u==="*"||j.test(u)}e.$Po=h;function c(u){if(!h(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const $=u.match(j);return $?{hasCaret:$[1]==="^",hasGreaterEquals:$[1]===">=",majorBase:$[2]==="x"?0:parseInt($[2],10),majorMustEqual:$[2]!=="x",minorBase:$[4]==="x"?0:parseInt($[4],10),minorMustEqual:$[4]!=="x",patchBase:$[6]==="x"?0:parseInt($[6],10),patchMustEqual:$[6]!=="x",preRelease:$[8]||null}:null}e.$Qo=c;function k(u){if(!u)return null;const $=u.majorBase,O=u.majorMustEqual,p=u.minorBase;let S=u.minorMustEqual;const s=u.patchBase;let o=u.patchMustEqual;u.hasCaret&&($===0||(S=!1),o=!1);let t=0;if(u.preRelease){const i=b.exec(u.preRelease);if(i){const[,n,r,l]=i;t=Date.UTC(Number(n),Number(r)-1,Number(l))}}return{majorBase:$,majorMustEqual:O,minorBase:p,minorMustEqual:S,patchBase:s,patchMustEqual:o,isMinimum:u.hasGreaterEquals,notBefore:t}}e.$Ro=k;function I(u,$,O){let p;typeof u=="string"?p=k(c(u)):p=u;let S;$ instanceof Date?S=$.getTime():typeof $=="string"&&(S=new Date($).getTime());let s;if(typeof O=="string"?s=k(c(O)):s=O,!p||!s)return!1;const o=p.majorBase,t=p.minorBase,i=p.patchBase;let n=s.majorBase,r=s.minorBase,l=s.patchBase;const P=s.notBefore;let v=s.majorMustEqual,w=s.minorMustEqual,R=s.patchMustEqual;return s.isMinimum?o>n?!0:o<n?!1:t>r?!0:t<r||S&&S<P?!1:i>=l:(o===1&&n===0&&(!v||!w||!R)&&(n=1,r=0,l=0,v=!0,w=!1,R=!1),o<n?!1:o>n?!v:t<r?!1:t>r?!w:i<l?!1:i>l?!R:!(S&&S<P))}e.$So=I;function d(u,$,O,p,S){const s=[];if(typeof p.publisher<"u"&&typeof p.publisher!="string")return s.push([N.default.Error,D.localize(0,null)]),s;if(typeof p.name!="string")return s.push([N.default.Error,D.localize(1,null,"name")]),s;if(typeof p.version!="string")return s.push([N.default.Error,D.localize(2,null,"version")]),s;if(!p.engines)return s.push([N.default.Error,D.localize(3,null,"engines")]),s;if(typeof p.engines.vscode!="string")return s.push([N.default.Error,D.localize(4,null,"engines.vscode")]),s;if(typeof p.extensionDependencies<"u"&&!m(p.extensionDependencies))return s.push([N.default.Error,D.localize(5,null,"extensionDependencies")]),s;if(typeof p.activationEvents<"u"){if(!m(p.activationEvents))return s.push([N.default.Error,D.localize(6,null,"activationEvents")]),s;if(typeof p.main>"u"&&typeof p.browser>"u")return s.push([N.default.Error,D.localize(7,null,"activationEvents","main","browser")]),s}if(typeof p.extensionKind<"u"&&typeof p.main>"u"&&s.push([N.default.Warning,D.localize(8,null,"extensionKind")]),typeof p.main<"u"){if(typeof p.main!="string")return s.push([N.default.Error,D.localize(9,null,"main")]),s;{const i=(0,L.$wg)(O,p.main);(0,L.$qg)(i,O)||s.push([N.default.Warning,D.localize(10,null,i.path,O.path)])}}if(typeof p.browser<"u"){if(typeof p.browser!="string")return s.push([N.default.Error,D.localize(11,null,"browser")]),s;{const i=(0,L.$wg)(O,p.browser);(0,L.$qg)(i,O)||s.push([N.default.Warning,D.localize(12,null,i.path,O.path)])}}if(!A.valid(p.version))return s.push([N.default.Error,D.localize(13,null)]),s;const o=[];if(!f(u,$,p,S,o))for(const i of o)s.push([N.default.Error,i]);return s}e.$To=d;function f(u,$,O,p,S){return p||typeof O.main>"u"&&typeof O.browser>"u"?!0:y(u,$,O.engines.vscode,S)}e.$Uo=f;function E(u,$,O){return u==="*"||y($,O,u)}e.$Vo=E;function y(u,$,O,p=[]){const S=k(c(O));if(!S)return p.push(D.localize(14,null,O)),!1;if(S.majorBase===0){if(!S.majorMustEqual||!S.minorMustEqual)return p.push(D.localize(15,null,O)),!1}else if(!S.majorMustEqual)return p.push(D.localize(16,null,O)),!1;return I(u,$,S)?!0:(p.push(D.localize(17,null,u,O)),!1)}function m(u){if(!Array.isArray(u))return!1;for(let $=0,O=u.length;$<O;$++)if(typeof u[$]!="string")return!1;return!0}}),define(te[113],ne([0,1,14,28]),function(J,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dp=void 0;async function D(A,j,b){let h=b&&b.get("storage.serviceMachineId",-1)||null;if(h)return h;try{const k=(await j.readFile(A.serviceMachineIdResource)).value.toString();h=(0,N.$eg)(k)?k:null}catch{h=null}if(!h){h=(0,N.$fg)();try{await j.writeFile(A.serviceMachineIdResource,L.$ce.fromString(h))}catch{}}return b?.store("storage.serviceMachineId",h,-1,1),h}e.$dp=D}),define(te[49],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qh=void 0;class L{constructor(D,A=[],j=!1){this.ctor=D,this.staticArguments=A,this.supportsDelayedInstantiation=j}}e.$Qh=L}),define(te[114],ne([0,1,49]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Br=e.$Ar=e.InstantiationType=void 0;const N=[];var D;(function(b){b[b.Eager=0]="Eager",b[b.Delayed=1]="Delayed"})(D||(e.InstantiationType=D={}));function A(b,h,c){h instanceof L.$Qh||(h=new L.$Qh(h,[],!!c)),N.push([b,h])}e.$Ar=A;function j(){return N}e.$Br=j}),define(te[115],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gq=e.$fq=void 0;class L{constructor(A,j){this.key=A,this.data=j,this.incoming=new Map,this.outgoing=new Map}}e.$fq=L;class N{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const j of this.a.values())j.outgoing.size===0&&A.push(j);return A}insertEdge(A,j){const b=this.lookupOrInsertNode(A),h=this.lookupOrInsertNode(j);b.outgoing.set(h.key,h),h.incoming.set(b.key,b)}removeNode(A){const j=this.b(A);this.a.delete(j);for(const b of this.a.values())b.outgoing.delete(j),b.incoming.delete(j)}lookupOrInsertNode(A){const j=this.b(A);let b=this.a.get(j);return b||(b=new L(j,A),this.a.set(j,b)),b}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[j,b]of this.a)A.push(`${j}
	(-> incoming)[${[...b.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...b.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,j]of this.a){const b=new Set([A]),h=this.c(j,b);if(h)return h}}c(A,j){for(const[b,h]of A.outgoing){if(j.has(b))return[...j,b].join(" -> ");j.add(b);const c=this.c(h,j);if(c)return c;j.delete(b)}}}e.$gq=N}),define(te[25],ne([0,1,3,11,10]),function(J,e,L,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.ConfigurationTarget=e.$pi=e.$oi=e.$ni=void 0,e.$ni=(0,D.$Th)("configurationService");function A(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof N.URI)}e.$oi=A;function j(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof N.URI)}e.$pi=j;var b;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(b||(e.ConfigurationTarget=b={}));function h(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$qi=h;function c(u){return u.applicationValue!==void 0||u.userValue!==void 0||u.userLocalValue!==void 0||u.userRemoteValue!==void 0||u.workspaceValue!==void 0||u.workspaceFolderValue!==void 0}e.$ri=c;function k(u,$){const O=Object.create(null);for(const p in u)I(O,p,u[p],$);return O}e.$si=k;function I(u,$,O,p){const S=$.split("."),s=S.pop();let o=u;for(let t=0;t<S.length;t++){const i=S[t];let n=o[i];switch(typeof n){case"undefined":n=o[i]=Object.create(null);break;case"object":break;default:p(`Ignoring ${$} as ${S.slice(0,t+1).join(".")} is ${JSON.stringify(n)}`);return}o=n}if(typeof o=="object"&&o!==null)try{o[s]=O}catch{p(`Ignoring ${$} as ${S.join(".")} is ${JSON.stringify(o)}`)}else p(`Ignoring ${$} as ${S.join(".")} is ${JSON.stringify(o)}`)}e.$ti=I;function d(u,$){const O=$.split(".");f(u,O)}e.$ui=d;function f(u,$){const O=$.shift();if($.length===0){delete u[O];return}if(Object.keys(u).indexOf(O)!==-1){const p=u[O];typeof p=="object"&&!Array.isArray(p)&&(f(p,$),Object.keys(p).length===0&&delete u[O])}}function E(u,$,O){function p(o,t){let i=o;for(const n of t){if(typeof i!="object"||i===null)return;i=i[n]}return i}const S=$.split("."),s=p(u,S);return typeof s>"u"?O:s}e.$vi=E;function y(u,$,O){Object.keys($).forEach(p=>{p!=="__proto__"&&(p in u?L.$Bf(u[p])&&L.$Bf($[p])?y(u[p],$[p],O):O&&(u[p]=$[p]):u[p]=$[p])})}e.$wi=y;function m(u){return u.replace(/[\[\]]/g,"")}e.$xi=m}),define(te[116],ne([0,1,13,29,108,10,89,9]),function(J,e,L,N,D,A,j,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.ContextKeyExprType=e.$Pi=void 0;const h=new Map;h.set("false",!1),h.set("true",!0),h.set("isMac",L.$k),h.set("isLinux",L.$l),h.set("isWindows",L.$j),h.set("isWeb",L.$p),h.set("isMacNative",L.$k&&!L.$p),h.set("isEdge",L.$H),h.set("isFirefox",L.$F),h.set("isChrome",L.$E),h.set("isSafari",L.$G);function c(F,a){if(h.get(F)!==void 0)throw(0,b.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");h.set(F,a)}e.$Pi=c;const k=Object.prototype.hasOwnProperty;var I;(function(F){F[F.False=0]="False",F[F.True=1]="True",F[F.Defined=2]="Defined",F[F.Not=3]="Not",F[F.Equals=4]="Equals",F[F.NotEquals=5]="NotEquals",F[F.And=6]="And",F[F.Regex=7]="Regex",F[F.NotRegex=8]="NotRegex",F[F.Or=9]="Or",F[F.In=10]="In",F[F.NotIn=11]="NotIn",F[F.Greater=12]="Greater",F[F.GreaterEquals=13]="GreaterEquals",F[F.Smaller=14]="Smaller",F[F.SmallerEquals=15]="SmallerEquals"})(I||(e.ContextKeyExprType=I={}));const d={regexParsingWithErrorRecovery:!0},f=(0,j.localize)(0,null),E=(0,j.localize)(1,null),y=(0,j.localize)(2,null),m=(0,j.localize)(3,null),u=(0,j.localize)(4,null),$=(0,j.localize)(5,null),O=(0,j.localize)(6,null),p=(0,j.localize)(7,null);class S{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(a=d){this.k=a,this.d=new D.$Oi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(a){if(a===""){this.h.push({message:f,offset:0,lexeme:"",additionalInfo:E});return}this.f=this.d.reset(a).scan(),this.g=0,this.h=[];try{const g=this.l();if(!this.E()){const z=this.D(),C=z.type===17?$:void 0;throw this.h.push({message:u,offset:z.offset,lexeme:D.$Oi.getLexeme(z),additionalInfo:C}),S.c}return g}catch(g){if(g!==S.c)throw g;return}}l(){return this.m()}m(){const a=[this.o()];for(;this.y(16);){const g=this.o();a.push(g)}return a.length===1?a[0]:s.or(...a)}o(){const a=[this.s()];for(;this.y(15);){const g=this.s();a.push(g)}return a.length===1?a[0]:s.and(...a)}s(){if(this.y(2)){const a=this.D();switch(a.type){case 11:return this.z(),n.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const g=this.l();return this.A(1,m),g?.negate()}case 17:return this.z(),B.create(a.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",a)}}return this.t()}t(){const a=this.D();switch(a.type){case 11:return this.z(),s.true();case 12:return this.z(),s.false();case 0:{this.z();const g=this.l();return this.A(1,m),g}case 17:{const g=a.lexeme;if(this.z(),this.y(9)){const C=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),C.type!==10)throw this.B("REGEX",C);const Q=C.lexeme,W=Q.lastIndexOf("/"),le=W===Q.length-1?void 0:this.w(Q.substring(W+1));let ae;try{ae=new RegExp(Q.substring(1,W),le)}catch{throw this.B("REGEX",C)}return ce.create(g,ae)}switch(C.type){case 10:case 19:{const Q=[C.lexeme];this.z();let W=this.D(),le=0;for(let fe=0;fe<C.lexeme.length;fe++)C.lexeme.charCodeAt(fe)===40?le++:C.lexeme.charCodeAt(fe)===41&&le--;for(;!this.E()&&W.type!==15&&W.type!==16;){switch(W.type){case 0:le++;break;case 1:le--;break;case 10:case 18:for(let fe=0;fe<W.lexeme.length;fe++)W.lexeme.charCodeAt(fe)===40?le++:C.lexeme.charCodeAt(fe)===41&&le--}if(le<0)break;Q.push(D.$Oi.getLexeme(W)),this.z(),W=this.D()}const ae=Q.join(""),me=ae.lastIndexOf("/"),de=me===ae.length-1?void 0:this.w(ae.substring(me+1));let ge;try{ge=new RegExp(ae.substring(1,me),de)}catch{throw this.B("REGEX",C)}return s.regex(g,ge)}case 18:{const Q=C.lexeme;this.z();let W=null;if(!(0,N.$Ce)(Q)){const le=Q.indexOf("/"),ae=Q.lastIndexOf("/");if(le!==ae&&le>=0){const me=Q.slice(le+1,ae),de=Q[ae+1]==="i"?"i":"";try{W=new RegExp(me,de)}catch{throw this.B("REGEX",C)}}}if(W===null)throw this.B("REGEX",C);return ce.create(g,W)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,y);const C=this.u();return s.notIn(g,C)}switch(this.D().type){case 3:{this.z();const C=this.u();if(this.x().type===18)return s.equals(g,C);switch(C){case"true":return s.has(g);case"false":return s.not(g);default:return s.equals(g,C)}}case 4:{this.z();const C=this.u();if(this.x().type===18)return s.notEquals(g,C);switch(C){case"true":return s.not(g);case"false":return s.has(g);default:return s.notEquals(g,C)}}case 5:return this.z(),se.create(g,this.u());case 6:return this.z(),ue.create(g,this.u());case 7:return this.z(),ee.create(g,this.u());case 8:return this.z(),oe.create(g,this.u());case 13:return this.z(),s.in(g,this.u());default:return s.has(g)}}case 20:throw this.h.push({message:O,offset:a.offset,lexeme:"",additionalInfo:p}),S.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const a=this.D();switch(a.type){case 17:case 18:return this.z(),a.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(a){return a.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(a){return this.C(a)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(a,g){if(this.C(a))return this.z();throw this.B(g,this.D())}B(a,g,z){const C=(0,j.localize)(8,null,a,D.$Oi.getLexeme(g)),Q=g.offset,W=D.$Oi.getLexeme(g);return this.h.push({message:C,offset:Q,lexeme:W,additionalInfo:z}),S.c}C(a){return this.D().type===a}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Qi=S;class s{static false(){return n.INSTANCE}static true(){return r.INSTANCE}static has(a){return l.create(a)}static equals(a,g){return P.create(a,g)}static notEquals(a,g){return R.create(a,g)}static regex(a,g){return ce.create(a,g)}static in(a,g){return v.create(a,g)}static notIn(a,g){return w.create(a,g)}static not(a){return B.create(a)}static and(...a){return X.create(a,null,!0)}static or(...a){return T.create(a,null,!0)}static greater(a,g){return ee.create(a,g)}static greaterEquals(a,g){return oe.create(a,g)}static smaller(a,g){return se.create(a,g)}static smallerEquals(a,g){return ue.create(a,g)}static{this.c=new S({regexParsingWithErrorRecovery:!1})}static deserialize(a){return a==null?void 0:this.c.parse(a)}}e.$Ri=s;function o(F){const a=new S({regexParsingWithErrorRecovery:!1});return F.map(g=>(a.parse(g),a.lexingErrors.length>0?a.lexingErrors.map(z=>({errorMessage:z.additionalInfo?(0,j.localize)(9,null,z.additionalInfo):(0,j.localize)(10,null),offset:z.offset,length:z.lexeme.length})):a.parsingErrors.length>0?a.parsingErrors.map(z=>({errorMessage:z.additionalInfo?`${z.message}. ${z.additionalInfo}`:z.message,offset:z.offset,length:z.lexeme.length})):[]))}e.$Si=o;function t(F,a){const g=F?F.substituteConstants():void 0,z=a?a.substituteConstants():void 0;return!g&&!z?!0:!g||!z?!1:g.equals(z)}e.$Ti=t;function i(F,a){return F.cmp(a)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}substituteConstants(){return this}evaluate(a){return!1}serialize(){return"false"}keys(){return[]}map(a){return this}negate(){return r.INSTANCE}}e.$Ui=n;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}substituteConstants(){return this}evaluate(a){return!0}serialize(){return"true"}keys(){return[]}map(a){return this}negate(){return n.INSTANCE}}e.$Vi=r;class l{static create(a,g=null){const z=h.get(a);return typeof z=="boolean"?z?r.INSTANCE:n.INSTANCE:new l(a,g)}constructor(a,g){this.key=a,this.c=g,this.type=2}cmp(a){return a.type!==this.type?this.type-a.type:H(this.key,a.key)}equals(a){return a.type===this.type?this.key===a.key:!1}substituteConstants(){const a=h.get(this.key);return typeof a=="boolean"?a?r.INSTANCE:n.INSTANCE:this}evaluate(a){return!!a.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(a){return a.mapDefined(this.key)}negate(){return this.c||(this.c=B.create(this.key,this)),this.c}}e.$Wi=l;class P{static create(a,g,z=null){if(typeof g=="boolean")return g?l.create(a,z):B.create(a,z);const C=h.get(a);return typeof C=="boolean"?g===(C?"true":"false")?r.INSTANCE:n.INSTANCE:new P(a,g,z)}constructor(a,g,z){this.c=a,this.d=g,this.f=z,this.type=4}cmp(a){return a.type!==this.type?this.type-a.type:G(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){const a=h.get(this.c);if(typeof a=="boolean"){const g=a?"true":"false";return this.d===g?r.INSTANCE:n.INSTANCE}return this}evaluate(a){return a.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(a){return a.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}e.$Xi=P;class v{static create(a,g){return new v(a,g)}constructor(a,g){this.d=a,this.f=g,this.type=10,this.c=null}cmp(a){return a.type!==this.type?this.type-a.type:G(this.d,this.f,a.d,a.f)}equals(a){return a.type===this.type?this.d===a.d&&this.f===a.f:!1}substituteConstants(){return this}evaluate(a){const g=a.getValue(this.f),z=a.getValue(this.d);return Array.isArray(g)?g.includes(z):typeof z=="string"&&typeof g=="object"&&g!==null?k.call(g,z):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(a){return a.mapIn(this.d,this.f)}negate(){return this.c||(this.c=w.create(this.d,this.f)),this.c}}e.$Yi=v;class w{static create(a,g){return new w(a,g)}constructor(a,g){this.d=a,this.f=g,this.type=11,this.c=v.create(a,g)}cmp(a){return a.type!==this.type?this.type-a.type:this.c.cmp(a.c)}equals(a){return a.type===this.type?this.c.equals(a.c):!1}substituteConstants(){return this}evaluate(a){return!this.c.evaluate(a)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(a){return a.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Zi=w;class R{static create(a,g,z=null){if(typeof g=="boolean")return g?B.create(a,z):l.create(a,z);const C=h.get(a);return typeof C=="boolean"?g===(C?"true":"false")?n.INSTANCE:r.INSTANCE:new R(a,g,z)}constructor(a,g,z){this.c=a,this.d=g,this.f=z,this.type=5}cmp(a){return a.type!==this.type?this.type-a.type:G(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){const a=h.get(this.c);if(typeof a=="boolean"){const g=a?"true":"false";return this.d===g?n.INSTANCE:r.INSTANCE}return this}evaluate(a){return a.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(a){return a.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.$1i=R;class B{static create(a,g=null){const z=h.get(a);return typeof z=="boolean"?z?n.INSTANCE:r.INSTANCE:new B(a,g)}constructor(a,g){this.c=a,this.d=g,this.type=3}cmp(a){return a.type!==this.type?this.type-a.type:H(this.c,a.c)}equals(a){return a.type===this.type?this.c===a.c:!1}substituteConstants(){const a=h.get(this.c);return typeof a=="boolean"?a?n.INSTANCE:r.INSTANCE:this}evaluate(a){return!a.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(a){return a.mapNot(this.c)}negate(){return this.d||(this.d=l.create(this.c,this)),this.d}}e.$2i=B;function _(F,a){if(typeof F=="string"){const g=parseFloat(F);isNaN(g)||(F=g)}return typeof F=="string"||typeof F=="number"?a(F):n.INSTANCE}class ee{static create(a,g,z=null){return _(g,C=>new ee(a,C,z))}constructor(a,g,z){this.c=a,this.d=g,this.f=z,this.type=12}cmp(a){return a.type!==this.type?this.type-a.type:G(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){return this}evaluate(a){return typeof this.d=="string"?!1:parseFloat(a.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(a){return a.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ue.create(this.c,this.d,this)),this.f}}e.$3i=ee;class oe{static create(a,g,z=null){return _(g,C=>new oe(a,C,z))}constructor(a,g,z){this.c=a,this.d=g,this.f=z,this.type=13}cmp(a){return a.type!==this.type?this.type-a.type:G(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){return this}evaluate(a){return typeof this.d=="string"?!1:parseFloat(a.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(a){return a.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=se.create(this.c,this.d,this)),this.f}}e.$4i=oe;class se{static create(a,g,z=null){return _(g,C=>new se(a,C,z))}constructor(a,g,z){this.c=a,this.d=g,this.f=z,this.type=14}cmp(a){return a.type!==this.type?this.type-a.type:G(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){return this}evaluate(a){return typeof this.d=="string"?!1:parseFloat(a.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(a){return a.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=oe.create(this.c,this.d,this)),this.f}}e.$5i=se;class ue{static create(a,g,z=null){return _(g,C=>new ue(a,C,z))}constructor(a,g,z){this.c=a,this.d=g,this.f=z,this.type=15}cmp(a){return a.type!==this.type?this.type-a.type:G(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){return this}evaluate(a){return typeof this.d=="string"?!1:parseFloat(a.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(a){return a.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=ee.create(this.c,this.d,this)),this.f}}e.$6i=ue;class ce{static create(a,g){return new ce(a,g)}constructor(a,g){this.d=a,this.f=g,this.type=7,this.c=null}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.d<a.d)return-1;if(this.d>a.d)return 1;const g=this.f?this.f.source:"",z=a.f?a.f.source:"";return g<z?-1:g>z?1:0}equals(a){if(a.type===this.type){const g=this.f?this.f.source:"",z=a.f?a.f.source:"";return this.d===a.d&&g===z}return!1}substituteConstants(){return this}evaluate(a){const g=a.getValue(this.d);return this.f?this.f.test(g):!1}serialize(){const a=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${a}`}keys(){return[this.d]}map(a){return a.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=re.create(this)),this.c}}e.$7i=ce;class re{static create(a){return new re(a)}constructor(a){this.c=a,this.type=8}cmp(a){return a.type!==this.type?this.type-a.type:this.c.cmp(a.c)}equals(a){return a.type===this.type?this.c.equals(a.c):!1}substituteConstants(){return this}evaluate(a){return!this.c.evaluate(a)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(a){return new re(this.c.map(a))}negate(){return this.c}}e.$8i=re;function q(F){let a=null;for(let g=0,z=F.length;g<z;g++){const C=F[g].substituteConstants();if(F[g]!==C&&a===null){a=[];for(let Q=0;Q<g;Q++)a[Q]=F[Q]}a!==null&&(a[g]=C)}return a===null?F:a}class X{static create(a,g,z){return X.d(a,g,z)}constructor(a,g){this.expr=a,this.c=g,this.type=6}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let g=0,z=this.expr.length;g<z;g++){const C=i(this.expr[g],a.expr[g]);if(C!==0)return C}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let g=0,z=this.expr.length;g<z;g++)if(!this.expr[g].equals(a.expr[g]))return!1;return!0}return!1}substituteConstants(){const a=q(this.expr);return a===this.expr?this:X.create(a,this.c,!1)}evaluate(a){for(let g=0,z=this.expr.length;g<z;g++)if(!this.expr[g].evaluate(a))return!1;return!0}static d(a,g,z){const C=[];let Q=!1;for(const W of a)if(W){if(W.type===1){Q=!0;continue}if(W.type===0)return n.INSTANCE;if(W.type===6){C.push(...W.expr);continue}C.push(W)}if(C.length===0&&Q)return r.INSTANCE;if(C.length!==0){if(C.length===1)return C[0];C.sort(i);for(let W=1;W<C.length;W++)C[W-1].equals(C[W])&&(C.splice(W,1),W--);if(C.length===1)return C[0];for(;C.length>1;){const W=C[C.length-1];if(W.type!==9)break;C.pop();const le=C.pop(),ae=C.length===0,me=T.create(W.expr.map(de=>X.create([de,le],null,z)),null,ae);me&&(C.push(me),C.sort(i))}if(C.length===1)return C[0];if(z){for(let W=0;W<C.length;W++)for(let le=W+1;le<C.length;le++)if(C[W].negate().equals(C[le]))return n.INSTANCE;if(C.length===1)return C[0]}return new X(C,g)}}serialize(){return this.expr.map(a=>a.serialize()).join(" && ")}keys(){const a=[];for(const g of this.expr)a.push(...g.keys());return a}map(a){return new X(this.expr.map(g=>g.map(a)),null)}negate(){if(!this.c){const a=[];for(const g of this.expr)a.push(g.negate());this.c=T.create(a,this,!0)}return this.c}}e.$9i=X;class T{static create(a,g,z){return T.d(a,g,z)}constructor(a,g){this.expr=a,this.c=g,this.type=9}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let g=0,z=this.expr.length;g<z;g++){const C=i(this.expr[g],a.expr[g]);if(C!==0)return C}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let g=0,z=this.expr.length;g<z;g++)if(!this.expr[g].equals(a.expr[g]))return!1;return!0}return!1}substituteConstants(){const a=q(this.expr);return a===this.expr?this:T.create(a,this.c,!1)}evaluate(a){for(let g=0,z=this.expr.length;g<z;g++)if(this.expr[g].evaluate(a))return!0;return!1}static d(a,g,z){let C=[],Q=!1;if(a){for(let W=0,le=a.length;W<le;W++){const ae=a[W];if(ae){if(ae.type===0){Q=!0;continue}if(ae.type===1)return r.INSTANCE;if(ae.type===9){C=C.concat(ae.expr);continue}C.push(ae)}}if(C.length===0&&Q)return n.INSTANCE;C.sort(i)}if(C.length!==0){if(C.length===1)return C[0];for(let W=1;W<C.length;W++)C[W-1].equals(C[W])&&(C.splice(W,1),W--);if(C.length===1)return C[0];if(z){for(let W=0;W<C.length;W++)for(let le=W+1;le<C.length;le++)if(C[W].negate().equals(C[le]))return r.INSTANCE;if(C.length===1)return C[0]}return new T(C,g)}}serialize(){return this.expr.map(a=>a.serialize()).join(" || ")}keys(){const a=[];for(const g of this.expr)a.push(...g.keys());return a}map(a){return new T(this.expr.map(g=>g.map(a)),null)}negate(){if(!this.c){const a=[];for(const g of this.expr)a.push(g.negate());for(;a.length>1;){const g=a.shift(),z=a.shift(),C=[];for(const Q of M(g))for(const W of M(z))C.push(X.create([Q,W],null,!1));a.unshift(T.create(C,null,!1))}this.c=T.create(a,this,!0)}return this.c}}e.$0i=T;class U extends l{static{this.d=[]}static all(){return U.d.values()}constructor(a,g,z){super(a,null),this.f=g,typeof z=="object"?U.d.push({...z,key:a}):z!==!0&&U.d.push({key:a,description:z,type:g!=null?typeof g:void 0})}bindTo(a){return a.createKey(this.key,this.f)}getValue(a){return a.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(a){return P.create(this.key,a)}notEqualsTo(a){return R.create(this.key,a)}}e.$$i=U,e.$_i=(0,A.$Th)("contextKeyService");function H(F,a){return F<a?-1:F>a?1:0}function G(F,a,g,z){return F<g?-1:F>g?1:a<z?-1:a>z?1:0}function Z(F,a){if(F.type===0||a.type===1)return!0;if(F.type===9)return a.type===9?K(F.expr,a.expr):!1;if(a.type===9){for(const g of a.expr)if(Z(F,g))return!0;return!1}if(F.type===6){if(a.type===6)return K(a.expr,F.expr);for(const g of F.expr)if(Z(g,a))return!0;return!1}return F.equals(a)}e.$aj=Z;function K(F,a){let g=0,z=0;for(;g<F.length&&z<a.length;){const C=F[g].cmp(a[z]);if(C<0)return!1;C===0&&g++,z++}return g===F.length}function M(F){return F.type===9?F.expr:[F]}}),define(te[59],ne([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sn=void 0,e.$Sn=(0,L.$Th)("downloadService")}),define(te[18],ne([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=e.$1h=void 0,e.$1h=(0,L.$Th)("environmentService"),e.$2h=(0,L.$Uh)(e.$1h)}),define(te[21],ne([0,1,92,10]),function(J,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$bo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=void 0,e.$2n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$3n=new RegExp(e.$2n),e.$4n="__web_extension",e.$5n="skipWalkthrough",e.$6n="extensionsSync",e.$7n="dependecyOrPackExtensionInstall";function D(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$8n=D;function A(u){switch(u){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$9n=A;function j(u,$){switch(u){case 3:return $==="x64"?"win32-x64":$==="arm64"?"win32-arm64":"unknown";case 2:return $==="x64"?"linux-x64":$==="arm64"?"linux-arm64":$==="arm"?"linux-armhf":"unknown";case"alpine":return $==="x64"?"alpine-x64":$==="arm64"?"alpine-arm64":"unknown";case 1:return $==="x64"?"darwin-x64":$==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$0n=j;function b(u,$){return $==="web"&&!u.includes("web")}e.$$n=b;function h(u,$,O){return b($,O)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===O}e.$_n=h;function c(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.$ao=c;var k;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(k||(e.SortBy=k={}));var I;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(I||(e.SortOrder=I={}));var d;(function(u){u.Install="install",u.Uninstall="uninstall"})(d||(e.StatisticType=d={}));var f;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(f||(e.InstallOperation=f={})),e.$bo=(0,N.$Th)("extensionGalleryService");var E;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Signature="Signature",u.Internal="Internal"})(E||(e.ExtensionManagementErrorCode=E={}));var y;(function(u){u.UnknownError="UnknownError",u.PackageIsInvalidZip="PackageIsInvalidZip",u.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(y||(e.ExtensionSignaturetErrorCode=y={}));class m extends Error{constructor($,O){super($),this.code=O,this.name=O}}e.$co=m,e.$do=(0,N.$Th)("extensionManagementService"),e.$eo="extensionsIdentifiers/disabled",e.$fo="extensionsIdentifiers/enabled",e.$go=(0,N.$Th)("IGlobalExtensionEnablementService"),e.$ho=(0,N.$Th)("IExtensionTipsService"),e.$io=(0,L.localize)(0,null),e.$jo={value:e.$io,original:"Extensions"},e.$ko={value:(0,L.localize)(1,null),original:"Preferences"}}),define(te[60],ne([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jp=e.$ip=void 0,e.$ip=(0,L.$Th)("IExtensionSignatureVerificationService");class N{b(){return this.a||(this.a=new Promise((A,j)=>J(["node-vsce-sign"],async b=>A(b),j))),this.a}async verify(A,j,b){let h;try{h=await this.b()}catch{return!1}return h.verify(A,j,b)}}e.$jp=N}),define(te[61],ne([0,1,14,9,100,12]),function(J,e,L,N,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=void 0;async function j(k,I,d,f,E,y){let m;try{await b(k,I,d,f,E,y)}catch(u){m=u}finally{m&&E.errorTransformer&&(m=E.errorTransformer(m)),typeof m<"u"&&d.error(m),d.end()}}e.$Qp=j;async function b(k,I,d,f,E,y){h(y);const m=await k.open(I,{create:!1});try{h(y);let u=0,$=0,O=E&&typeof E.length=="number"?E.length:void 0,p=L.$ce.alloc(Math.min(E.bufferSize,typeof O=="number"?O:E.bufferSize)),S=E&&typeof E.position=="number"?E.position:0,s=0;do $=await k.read(m,S,p.buffer,s,p.byteLength-s),S+=$,s+=$,u+=$,typeof O=="number"&&(O-=$),s===p.byteLength&&(await d.write(f(p)),p=L.$ce.alloc(Math.min(E.bufferSize,typeof O=="number"?O:E.bufferSize)),s=0);while($>0&&(typeof O!="number"||O>0)&&h(y)&&c(u,E));if(s>0){let o=s;typeof O=="number"&&(o=Math.min(s,O)),d.write(f(p.slice(0,o)))}}catch(u){throw(0,A.$qk)(u)}finally{await k.close(m)}}function h(k){if(k.isCancellationRequested)throw(0,N.$5)();return!0}function c(k,I){if(typeof I?.limits?.size=="number"&&k>I.limits.size)throw(0,A.$pk)((0,D.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(te[117],ne([0,1,4,166,2,13,167]),function(J,e,L,N,D,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=void 0;class b extends D.$Rc{constructor(){super(...arguments),this.a=this.B(new L.$Od),this.onDidChangeFile=this.a.event,this.b=this.B(new L.$Od),this.onDidLogMessage=this.b.event,this.onDidError=L.Event.None,this.c=new Map,this.f=!1}async watch(c){const k=this.j(c),I=k.filter(f=>{const E=this.c.get(f.path);return E?!(0,N.$Ej)(E.request.excludes,f.excludes)||!(0,N.$Ej)(E.request.includes,f.includes):!0}),d=Array.from(this.c.values()).filter(({request:f})=>!k.find(E=>E.path===f.path&&(0,N.$Ej)(E.excludes,f.excludes)&&(0,N.$Ej)(E.includes,f.includes))).map(({request:f})=>f.path);I.length&&this.m(`Request to start watching: ${I.map(f=>`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"}, includes: ${f.includes&&f.includes.length>0?JSON.stringify(f.includes):"<all>"}, correlationId: ${typeof f.correlationId=="number"?f.correlationId:"<none>"})`).join(",")}`),d.length&&this.m(`Request to stop watching: ${d.join(",")}`);for(const f of d)this.h(f);for(const f of I)this.g(f)}g(c){const k=new j.$aq(c,d=>this.a.fire(d),d=>this.b.fire(d),this.f),I={request:c,instance:k};this.c.set(c.path,I)}async stop(){for(const[c]of this.c)this.h(c);this.c.clear()}h(c){const k=this.c.get(c);k&&(this.c.delete(c),k.instance.dispose())}j(c){const k=new Map;for(const I of c){const d=A.$l?I.path:I.path.toLowerCase();let f=k.get(I.correlationId);f||(f=new Map,k.set(I.correlationId,f)),f.set(d,I)}return Array.from(k.values()).map(I=>Array.from(I.values())).flat()}async setVerboseLogging(c){this.f=c;for(const[,k]of this.c)k.instance.setVerboseLogging(c)}m(c){this.f&&this.b.fire({type:"trace",message:this.n(c)})}n(c,k){return k?`[File Watcher (node.js)] ${c} (path: ${k.request.path})`:`[File Watcher (node.js)] ${c}`}}e.$cq=b}),define(te[118],ne([0,1,62,117]),function(J,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=void 0;class D extends L.$Up{constructor(j,b,h){super(j,b,h),this.s()}r(j){return j.add(new N.$cq)}}e.$dq=D}),define(te[119],ne([0,1,15,57,85,62]),function(J,e,L,N,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=void 0;class j extends A.$Vp{constructor(h,c,k){super(h,c,k),this.s()}r(h){const c=h.add(new D.$7p(L.$dg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return h.add(c.onDidProcessExit(({code:k,signal:I})=>this.t(`terminated by itself with code ${k}, signal: ${I}`))),N.ProxyChannel.toService((0,N.$Ah)(c.getChannel("watcher")))}}e.$8p=j}),define(te[63],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rh=void 0;class L{constructor(...D){this.a=new Map;for(const[A,j]of D)this.set(A,j)}set(D,A){const j=this.a.get(D);return this.a.set(D,A),j}has(D){return this.a.has(D)}get(D){return this.a.get(D)}}e.$Rh=L}),define(te[120],ne([0,1,8,9,2,49,115,10,63,168]),function(J,e,L,N,D,A,j,b,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=e.$hq=void 0;const k=!1;class I extends Error{constructor(m){super("cyclic dependency between services"),this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class d{constructor(m=new h.$Rh,u=!1,$,O=k){this.f=m,this.g=u,this.h=$,this.i=O,this.o=new Set,this.f.set(b.$Sh,this),this._globalGraph=O?$?._globalGraph??new j.$gq(p=>p):void 0}createChild(m){return new d(m,this.g,this,this.i)}invokeFunction(m,...u){const $=E.traceInvocation(this.i,m);let O=!1;try{return m({get:S=>{if(O)throw(0,N.$7)("service accessor is only valid during the invocation of its target method");const s=this.m(S,$);if(!s)throw new Error(`[invokeFunction] unknown service '${S}'`);return s}},...u)}finally{O=!0,$.stop()}}createInstance(m,...u){let $,O;return m instanceof A.$Qh?($=E.traceCreation(this.i,m.ctor),O=this.j(m.ctor,m.staticArguments.concat(u),$)):($=E.traceCreation(this.i,m),O=this.j(m,u,$)),$.stop(),O}j(m,u=[],$){const O=b._util.getServiceDependencies(m).sort((s,o)=>s.index-o.index),p=[];for(const s of O){const o=this.m(s.id,$);o||this.u(`[createInstance] ${m.name} depends on UNKNOWN service ${s.id}.`,!1),p.push(o)}const S=O.length>0?O[0].index:u.length;if(u.length!==S){console.trace(`[createInstance] First service dependency of ${m.name} at position ${S+1} conflicts with ${u.length} static arguments`);const s=S-u.length;s>0?u=u.concat(new Array(s)):u=u.slice(0,S)}return Reflect.construct(m,u.concat(p))}k(m,u){if(this.f.get(m)instanceof A.$Qh)this.f.set(m,u);else if(this.h)this.h.k(m,u);else throw new Error("illegalState - setting UNKNOWN service instance")}l(m){const u=this.f.get(m);return!u&&this.h?this.h.l(m):u}m(m,u){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(m));const $=this.l(m);return $ instanceof A.$Qh?this.q(m,$,u.branch(m,!0)):(u.branch(m,!1),$)}q(m,u,$){if(this.o.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this.o.add(m);try{return this.r(m,u,$)}finally{this.o.delete(m)}}r(m,u,$){const O=new j.$gq(s=>s.id.toString());let p=0;const S=[{id:m,desc:u,_trace:$}];for(;S.length;){const s=S.pop();if(O.lookupOrInsertNode(s),p++>1e3)throw new I(O);for(const o of b._util.getServiceDependencies(s.desc.ctor)){const t=this.l(o.id);if(t||this.u(`[createInstance] ${m} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(s.id),String(o.id)),t instanceof A.$Qh){const i={id:o.id,desc:t,_trace:s._trace.branch(o.id,!0)};O.insertEdge(s,i),S.push(i)}}}for(;;){const s=O.roots();if(s.length===0){if(!O.isEmpty())throw new I(O);break}for(const{data:o}of s){if(this.l(o.id)instanceof A.$Qh){const i=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,i)}O.removeNode(o)}}return this.l(m)}s(m,u,$=[],O,p){if(this.f.get(m)instanceof A.$Qh)return this.t(m,u,$,O,p);if(this.h)return this.h.s(m,u,$,O,p);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}t(m,u,$=[],O,p){if(O){const S=new d(void 0,this.g,this,this.i);S.c=String(m);const s=new Map,o=new L.$ch(()=>{const t=S.j(u,$,p);for(const[i,n]of s){const r=t[i];if(typeof r=="function")for(const l of n)r.apply(t,l)}return s.clear(),t});return new Proxy(Object.create(null),{get(t,i){if(!o.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let l=s.get(i);return l||(l=new c.$1c,s.set(i,l)),(v,w,R)=>{const B=l.push([v,w,R]);return(0,D.$Pc)(B)}}if(i in t)return t[i];const n=o.value;let r=n[i];return typeof r!="function"||(r=r.bind(n),t[i]=r),r},set(t,i,n){return o.value[i]=n,!0},getPrototypeOf(t){return u.prototype}})}else return this.j(u,$,p)}u(m,u){if(u&&console.warn(m),this.g)throw new Error(m)}}e.$hq=d;var f;(function(y){y[y.None=0]="None",y[y.Creation=1]="Creation",y[y.Invocation=2]="Invocation",y[y.Branch=3]="Branch"})(f||(f={}));class E{static{this.all=new Set}static{this.c=new class extends E{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(m,u){return m?new E(2,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):E.c}static traceCreation(m,u){return m?new E(1,u.name):E.c}static{this.f=0}constructor(m,u){this.type=m,this.name=u,this.g=Date.now(),this.h=[]}branch(m,u){const $=new E(3,m.toString());return this.h.push([m,u,$]),$}stop(){const m=Date.now()-this.g;E.f+=m;let u=!1;function $(p,S){const s=[],o=new Array(p+1).join("	");for(const[t,i,n]of S.h)if(i&&n){u=!0,s.push(`${o}CREATES -> ${t}`);const r=$(p+1,n);r&&s.push(r)}else s.push(`${o}uses -> ${t}`);return s.join(`
`)}const O=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${$(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${E.f.toFixed(2)}ms)`];(m>2||u)&&E.all.add(O.join(`
`))}}e.$iq=E});var ie=this&&this.__param||function(J,e){return function(L,N){e(L,N,J)}};define(te[64],ne([0,1,20,2,13,102,21,10]),function(J,e,L,N,D,A,j,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xq=e.$Wq=e.$Vq=void 0;function h(k){return k.tags.find(I=>I.startsWith("lp-"))?.split("lp-")[1]}e.$Vq=h,e.$Wq=(0,b.$Th)("languagePackService");let c=class extends N.$Rc{constructor(I){super(),this.c=I}async getAvailableLanguages(){const I=new L.$Yd;setTimeout(()=>I.cancel(),1e3);let d;try{d=await this.c.query({text:'category:"language packs"',pageSize:20},I.token)}catch{return[]}const E=d.firstPage.filter(y=>y.properties.localizedLanguages?.length&&y.tags.some(m=>m.startsWith("lp-"))).map(y=>{const m=y.properties.localizedLanguages?.[0],u=h(y);return{...this.f(u,m,y),extensionId:y.identifier.id,galleryExtension:y}});return E.push(this.f("en","English")),E}f(I,d,f){const E=d??I;let y;if(E!==I&&(y=`(${I})`),I.toLowerCase()===D.$w.toLowerCase()&&(y??="",y+=(0,A.localize)(0,null)),f?.installCount){y??="";const m=f.installCount;let u;m>1e6?u=`${Math.floor(m/1e5)/10}M`:m>1e3?u=`${Math.floor(m/1e3)}K`:u=String(m),y+=` $(cloud-download) ${u}`}return{id:I,label:E,description:y}}};e.$Xq=c,e.$Xq=c=pe([ie(0,j.$bo)],c)}),define(te[6],ne([0,1,34,4,41,2,31,13,17,3,11,116,10]),function(J,e,L,N,D,A,j,b,h,c,k,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.log=e.$ej=e.LogLevel=e.$dj=e.$cj=e.$bj=void 0,e.$bj=(0,d.$Th)("logService"),e.$cj=(0,d.$Th)("loggerService");function f(){return new Date().toISOString()}function E(v){return(0,c.$Df)(v)}e.$dj=E;var y;(function(v){v[v.Off=0]="Off",v[v.Trace=1]="Trace",v[v.Debug=2]="Debug",v[v.Info=3]="Info",v[v.Warning=4]="Warning",v[v.Error=5]="Error"})(y||(e.LogLevel=y={})),e.$ej=y.Info;function m(v,w,R){switch(w){case y.Trace:v.trace(R);break;case y.Debug:v.debug(R);break;case y.Info:v.info(R);break;case y.Warning:v.warn(R);break;case y.Error:v.error(R);break;case y.Off:break;default:throw new Error(`Invalid log level ${w}`)}}e.log=m;function u(v,w=!1){let R="";for(let B=0;B<v.length;B++){let _=v[B];if(_ instanceof Error&&(_=(0,L.$Ei)(_,w)),typeof _=="object")try{_=JSON.stringify(_)}catch{}R+=(B>0?" ":"")+_}return R}class $ extends A.$Rc{constructor(){super(...arguments),this.b=e.$ej,this.c=this.B(new N.$Od),this.onDidChangeLogLevel=this.c.event}setLevel(w){this.b!==w&&(this.b=w,this.c.fire(this.b))}getLevel(){return this.b}f(w){return this.b!==y.Off&&this.b<=w}}e.$gj=$;class O extends ${constructor(w){super(),this.h=w}f(w){return this.h||super.f(w)}trace(w,...R){this.f(y.Trace)&&this.g(y.Trace,u([w,...R],!0))}debug(w,...R){this.f(y.Debug)&&this.g(y.Debug,u([w,...R]))}info(w,...R){this.f(y.Info)&&this.g(y.Info,u([w,...R]))}warn(w,...R){this.f(y.Warning)&&this.g(y.Warning,u([w,...R]))}error(w,...R){if(this.f(y.Error))if(w instanceof Error){const B=Array.prototype.slice.call(arguments);B[0]=w.stack,this.g(y.Error,u(B))}else this.g(y.Error,u([w,...R]))}flush(){}}e.$hj=O;class p extends ${constructor(w=e.$ej){super(),this.setLevel(w),this.g=!b.$j}trace(w,...R){this.f(y.Trace)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,w,...R):console.log(`[main ${f()}]`,w,...R))}debug(w,...R){this.f(y.Debug)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,w,...R):console.log(`[main ${f()}]`,w,...R))}info(w,...R){this.f(y.Info)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,w,...R):console.log(`[main ${f()}]`,w,...R))}warn(w,...R){this.f(y.Warning)&&(this.g?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,w,...R):console.warn(`[main ${f()}]`,w,...R))}error(w,...R){this.f(y.Error)&&(this.g?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,w,...R):console.error(`[main ${f()}]`,w,...R))}dispose(){}flush(){}}e.$ij=p;class S extends ${constructor(w=e.$ej,R=!0){super(),this.g=R,this.setLevel(w)}trace(w,...R){this.f(y.Trace)&&(this.g?console.log("%cTRACE","color: #888",w,...R):console.log(w,...R))}debug(w,...R){this.f(y.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",w,...R):console.log(w,...R))}info(w,...R){this.f(y.Info)&&(this.g?console.log("%c INFO","color: #33f",w,...R):console.log(w,...R))}warn(w,...R){this.f(y.Warning)&&(this.g?console.log("%c WARN","color: #993",w,...R):console.log(w,...R))}error(w,...R){this.f(y.Error)&&(this.g?console.log("%c  ERR","color: #f33",w,...R):console.error(w,...R))}dispose(){}flush(){}}e.$jj=S;class s extends ${constructor(w,R=e.$ej){super(),this.g=w,this.setLevel(R)}trace(w,...R){this.f(y.Trace)&&this.g.log(y.Trace,[this.h(w),...R])}debug(w,...R){this.f(y.Debug)&&this.g.log(y.Debug,[this.h(w),...R])}info(w,...R){this.f(y.Info)&&this.g.log(y.Info,[this.h(w),...R])}warn(w,...R){this.f(y.Warning)&&this.g.log(y.Warning,[this.h(w),...R])}error(w,...R){this.f(y.Error)&&this.g.log(y.Error,[this.h(w),...R])}h(w){return typeof w=="string"?w:(0,L.$Ei)(w,this.f(y.Trace))}dispose(){}flush(){}}e.$kj=s;class o extends ${constructor(w){super(),this.g=w,w.length&&this.setLevel(w[0].getLevel())}setLevel(w){for(const R of this.g)R.setLevel(w);super.setLevel(w)}trace(w,...R){for(const B of this.g)B.trace(w,...R)}debug(w,...R){for(const B of this.g)B.debug(w,...R)}info(w,...R){for(const B of this.g)B.info(w,...R)}warn(w,...R){for(const B of this.g)B.warn(w,...R)}error(w,...R){for(const B of this.g)B.error(w,...R)}flush(){for(const w of this.g)w.flush()}dispose(){for(const w of this.g)w.dispose()}}e.$lj=o;class t extends A.$Rc{constructor(w,R,B){if(super(),this.h=w,this.j=R,this.b=new j.$zc,this.c=this.B(new N.$Od),this.onDidChangeLoggers=this.c.event,this.f=this.B(new N.$Od),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new N.$Od),this.onDidChangeVisibility=this.g.event,B)for(const _ of B)this.b.set(_.resource,{logger:void 0,info:_})}m(w){return(0,c.$zf)(w)?[...this.b.values()].find(R=>R.info.id===w):this.b.get(w)}getLogger(w){return this.m(w)?.logger}createLogger(w,R){const B=this.n(w),_=(0,c.$zf)(w)?w:R?.id??(0,D.$Hi)(B.toString()).toString(16);let ee=this.b.get(B)?.logger;const oe=R?.logLevel==="always"?y.Trace:R?.logLevel;ee||(ee=this.s(B,oe??this.getLogLevel(B)??this.h,{...R,id:_}));const se={logger:ee,info:{resource:B,id:_,logLevel:oe,name:R?.name,hidden:R?.hidden,extensionId:R?.extensionId,when:R?.when}};return this.registerLogger(se.info),this.b.set(B,se),ee}n(w){return(0,c.$zf)(w)?(0,h.$wg)(this.j,`${w}.log`):w}setLogLevel(w,R){if(k.URI.isUri(w)){const B=w,_=R,ee=this.b.get(B);ee&&_!==ee.info.logLevel&&(ee.info.logLevel=_===this.h?void 0:_,ee.logger?.setLevel(_),this.b.set(ee.info.resource,ee),this.f.fire([B,_]))}else{this.h=w;for(const[B,_]of this.b.entries())this.b.get(B)?.info.logLevel===void 0&&_.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(w,R){const B=this.m(w);B&&R!==!B.info.hidden&&(B.info.hidden=!R,this.b.set(B.info.resource,B),this.g.fire([B.info.resource,R]))}getLogLevel(w){let R;return w&&(R=this.b.get(w)?.info.logLevel),R??this.h}registerLogger(w){const R=this.b.get(w.resource);R?R.info.hidden!==w.hidden&&this.setVisibility(w.resource,!w.hidden):(this.b.set(w.resource,{info:w,logger:void 0}),this.c.fire({added:[w],removed:[]}))}deregisterLogger(w){const R=this.b.get(w);R&&(R.logger&&R.logger.dispose(),this.b.delete(w),this.c.fire({added:[],removed:[R.info]}))}*getRegisteredLoggers(){for(const w of this.b.values())yield w.info}getRegisteredLogger(w){return this.b.get(w)?.info}dispose(){this.b.forEach(w=>w.logger?.dispose()),this.b.clear(),super.dispose()}}e.$mj=t;class i{constructor(){this.onDidChangeLogLevel=new N.$Od().event}setLevel(w){}getLevel(){return y.Info}trace(w,...R){}debug(w,...R){}info(w,...R){}warn(w,...R){}error(w,...R){}critical(w,...R){}dispose(){}flush(){}}e.$nj=i;class n extends i{}e.$oj=n;function r(v){if(v.verbose)return y.Trace;if(typeof v.logLevel=="string"){const w=P(v.logLevel.toLowerCase());if(w!==void 0)return w}return e.$ej}e.$pj=r;function l(v){switch(v){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Off:return"off"}}e.$qj=l;function P(v){switch(v){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Error;case"off":return y.Off}}e.$rj=P,e.$sj=new I.$$i("logLevel",l(y.Info))}),define(te[121],ne([0,1,19,8,9,4,2,16,62,6]),function(J,e,L,N,D,A,j,b,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=void 0;class k extends j.$Rc{constructor(d,f){super(),this.a=d,this.b=f,this.c=this.B(new A.$Od),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$Od),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new N.$Sg(0)),this.w=[],this.y=this.B(new N.$Sg(0))}watch(d,f){return f.recursive||this.b?.watcher?.forceUniversal?this.n(d,f):this.z(d,f)}n(d,f){const E={path:this.H(d),excludes:f.excludes,includes:f.includes,recursive:f.recursive,correlationId:f.correlationId},y=(0,L.$Tb)(this.j,E);return this.r(),(0,j.$Pc)(()=>{y(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(d=>(0,D.$Z)(d))}s(){this.h||(this.h=this.B(this.t(f=>this.c.fire((0,h.$Wp)(f)),f=>this.G(f),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)})));const d=this.b?.watcher?.recursive?.usePolling;if(d===!0)for(const f of this.j)(0,h.$Sp)(f)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(d))for(const f of this.j)(0,h.$Sp)(f)&&d.includes(f.path)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(d,f){const E={path:this.H(d),excludes:f.excludes,includes:f.includes,recursive:!1,correlationId:f.correlationId},y=(0,L.$Tb)(this.w,E);return this.C(),(0,j.$Pc)(()=>{y(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(d=>(0,D.$Z)(d))}D(){return this.u||(this.u=this.B(this.F(d=>this.c.fire((0,h.$Wp)(d)),d=>this.G(d),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)}))),this.u.watch(this.w)}G(d){d.type==="error"&&this.g.fire(d.message),this.a[d.type](d.message)}H(d){return(0,b.$gc)(d.fsPath)}}e.$1p=k}),define(te[122],ne([0,1,19,8,14,20,4,41,65,2,47,15,123,17,45,99,12,61,6,9]),function(J,e,L,N,D,A,j,b,h,c,k,I,d,f,E,y,m,u,$,O){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=void 0;let S=class extends c.$Rc{static{p=this}constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new j.$Od),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new j.$Od),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new j.$Od),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new j.$Od),this.onDidRunOperation=this.r.event,this.X=this.B(new j.$Od),this.Y=this.B(new j.$Od),this.onDidFilesChange=this.Y.event,this.Z=this.B(new j.$Od),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new N.$5g)}registerProvider(o,t){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,d.mark)(`code/registerFilesystem/${o}`);const i=new c.$Qc;return this.h.set(o,t),this.c.fire({added:!0,scheme:o,provider:t}),i.add(t.onDidChangeFile(n=>{const r=new m.$vk(n,!this.S(t));this.X.fire(r),r.hasCorrelation()||this.Y.fire(r)})),typeof t.onDidWatchError=="function"&&i.add(t.onDidWatchError(n=>this.Z.fire(new Error(n)))),i.add(t.onDidChangeCapabilities(()=>this.g.fire({provider:t,scheme:o}))),(0,c.$Pc)(()=>{this.c.fire({added:!1,scheme:o,provider:t}),this.h.delete(o),(0,c.$Mc)(i)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const t=[];this.f.fire({scheme:o,join(i){t.push(i)}}),!this.h.has(o)&&await N.Promises.settled(t)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,t){const i=this.h.get(o.scheme);return!!(i&&i.capabilities&t)}listCapabilities(){return h.Iterable.map(this.h,([o,t])=>({scheme:o,capabilities:t.capabilities}))}async j(o){if(!(0,f.$Ag)(o))throw new m.$xk((0,y.localize)(0,null,this.sb(o)),8);await this.activateProvider(o.scheme);const t=this.h.get(o.scheme);if(!t){const i=new O.$ab;throw i.message=(0,y.localize)(1,null,o.toString()),i}return t}async m(o){const t=await this.j(o);if((0,m.$ik)(t)||(0,m.$fk)(t)||(0,m.$jk)(t))return t;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const t=await this.j(o);if((0,m.$ik)(t)||(0,m.$fk)(t))return t;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,t){try{return await this.s(o,t)}catch(i){throw(0,m.$sk)(i)===m.FileSystemProviderErrorCode.FileNotFound?new m.$xk((0,y.localize)(2,null,this.sb(o)),1):(0,m.$qk)(i)}}async s(o,t){const i=await this.j(o),n=this.S(i),r=t?.resolveTo,l=t?.resolveSingleChildDescendants,P=t?.resolveMetadata,v=await i.stat(o);let w;return this.t(i,o,v,void 0,!!P,(R,B)=>(w||(w=k.$Zh.forUris(()=>!n),w.set(o,!0),r&&w.fill(!0,r)),w.get(R.resource)||w.findSuperstr(R.resource.with({query:null,fragment:null}))?!0:R.isDirectory&&l?B===1:!1))}async t(o,t,i,n,r,l){const{providerExtUri:P}=this.R(o),v={resource:t,name:P.basename(t),isFile:(i.type&m.FileType.File)!==0,isDirectory:(i.type&m.FileType.Directory)!==0,isSymbolicLink:(i.type&m.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&m.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((i.permissions??0)&m.FilePermission.Locked),etag:(0,m.$Ik)({mtime:i.mtime,size:i.size}),children:void 0};if(v.isDirectory&&l(v,n)){try{const w=await o.readdir(t),R=await N.Promises.settled(w.map(async([B,_])=>{try{const ee=P.joinPath(t,B),oe=r?await o.stat(ee):{type:_};return await this.t(o,ee,oe,w.length,r,l)}catch(ee){return this.b.trace(ee),null}}));v.children=(0,L.$Gb)(R)}catch(w){this.b.trace(w),v.children=[]}return v}return v}async resolveAll(o){return N.Promises.settled(o.map(async t=>{try{return{stat:await this.s(t.resource,t.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(o){const t=await this.j(o),i=await t.stat(o);return this.t(t,o,i,void 0,!0,()=>!1)}async exists(o){const t=await this.j(o);try{return!!await t.stat(o)}catch{return!1}}async canCreateFile(o,t){try{await this.u(o,t)}catch(i){return i}return!0}async u(o,t){if(!t?.overwrite&&await this.exists(o))throw new m.$xk((0,y.localize)(3,null,this.sb(o)),3,t)}async createFile(o,t=D.$ce.fromString(""),i){await this.u(o,i);const n=await this.writeFile(o,t);return this.r.fire(new m.$uk(o,0,n)),n}async writeFile(o,t,i){const n=this.qb(await this.n(o),o),{providerExtUri:r}=this.R(n);let l=i;if((0,m.$lk)(n)&&!l?.atomic){const P=n.enforceAtomicWriteFile?.(o);P&&(l={...i,atomic:P})}try{await this.w(n,o,l)||await this.U(n,r.dirname(o));let v;if((0,m.$fk)(n)&&!(t instanceof D.$ce))if((0,E.$1d)(t)){const w=await(0,E.$8d)(t,3);w.ended?v=D.$ce.concat(w.buffer):v=w}else v=(0,E.$5d)(t,w=>D.$ce.concat(w),3);else v=t;!(0,m.$ik)(n)||(0,m.$fk)(n)&&v instanceof D.$ce||(0,m.$fk)(n)&&(0,m.$lk)(n)&&l?.atomic?await this.hb(n,o,l,v):await this.db(n,o,l,v instanceof D.$ce?(0,D.$ne)(v):v),this.r.fire(new m.$uk(o,4))}catch(P){throw new m.$xk((0,y.localize)(4,null,this.sb(o),(0,m.$qk)(P).toString()),(0,m.$tk)(P),l)}return this.resolve(o,{resolveMetadata:!0})}async w(o,t,i){const n=!!i?.unlock;if(n&&!(o.capabilities&8192))throw new Error((0,y.localize)(5,null,this.sb(t)));if(!!i?.atomic){if(!(o.capabilities&32768))throw new Error((0,y.localize)(6,null,this.sb(t)));if(!(o.capabilities&2))throw new Error((0,y.localize)(7,null,this.sb(t)));if(n)throw new Error((0,y.localize)(8,null,this.sb(t)))}let l;try{l=await o.stat(t)}catch{return}if(l.type&m.FileType.Directory)throw new m.$xk((0,y.localize)(9,null,this.sb(t)),0,i);if(this.rb(t,l),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==m.$Hk&&typeof l.mtime=="number"&&typeof l.size=="number"&&i.mtime<l.mtime&&i.etag!==(0,m.$Ik)({mtime:i.mtime,size:l.size}))throw new m.$xk((0,y.localize)(10,null),3,i);return l}async readFile(o,t,i){const n=await this.m(o);return t?.atomic?this.z(n,o,t,i):this.C(n,o,t,i)}async z(o,t,i,n){return new Promise((r,l)=>{this.cb.queueFor(t,this.R(o).providerExtUri).queue(async()=>{try{const P=await this.C(o,t,i,n);r(P)}catch(P){l(P)}})})}async C(o,t,i,n){const r=await this.D(o,t,{...i,preferUnbuffered:!0},n);return{...r,value:await(0,D.$oe)(r.value)}}async readFileStream(o,t,i){const n=await this.m(o);return this.D(n,o,t,i)}async D(o,t,i,n){const r=new A.$Yd(n);let l=i;(0,m.$kk)(o)&&o.enforceAtomicReadFile?.(t)&&(l={...i,atomic:!0});const P=this.J(t,l).then(w=>w,w=>{throw r.dispose(!0),w});let v;try{return typeof l?.etag=="string"&&l.etag!==m.$Hk&&await P,l?.atomic&&(0,m.$kk)(o)||!((0,m.$ik)(o)||(0,m.$jk)(o))||(0,m.$fk)(o)&&l?.preferUnbuffered?v=this.I(o,t,l):(0,m.$jk)(o)?v=this.G(o,t,r.token,l):v=this.H(o,t,r.token,l),v.on("end",()=>r.dispose()),v.on("error",()=>r.dispose()),{...await P,value:v}}catch(w){throw v&&await(0,E.$6d)(v),this.F(w,t,l)}}F(o,t,i){const n=(0,y.localize)(11,null,this.sb(t),(0,m.$qk)(o).toString());return o instanceof m.$zk?new m.$zk(n,o.stat,i):o instanceof m.$yk?new m.$yk(n,o.fileOperationResult,o.size,o.options):new m.$xk(n,(0,m.$tk)(o),i)}G(o,t,i,n=Object.create(null)){const r=o.readFileStream(t,n,i);return(0,E.$_d)(r,{data:l=>l instanceof D.$ce?l:D.$ce.wrap(l),error:l=>this.F(l,t,n)},l=>D.$ce.concat(l))}H(o,t,i,n=Object.create(null)){const r=(0,D.$se)();return(0,u.$Qp)(o,t,r,l=>l,{...n,bufferSize:this.a,errorTransformer:l=>this.F(l,t,n)},i),r}I(o,t,i){const n=(0,E.$3d)(r=>D.$ce.concat(r));return(async()=>{try{let r;i?.atomic&&(0,m.$kk)(o)?r=await o.readFile(t,{atomic:!0}):r=await o.readFile(t),typeof i?.position=="number"&&(r=r.slice(i.position)),typeof i?.length=="number"&&(r=r.slice(0,i.length)),this.L(t,r.byteLength,i),n.end(D.$ce.wrap(r))}catch(r){n.error(r),n.end()}})(),n}async J(o,t){const i=await this.resolve(o,{resolveMetadata:!0});if(i.isDirectory)throw new m.$xk((0,y.localize)(12,null,this.sb(o)),0,t);if(typeof t?.etag=="string"&&t.etag!==m.$Hk&&t.etag===i.etag)throw new m.$zk((0,y.localize)(13,null),i,t);return this.L(o,i.size,t),i}L(o,t,i){if(typeof i?.limits?.size=="number"&&t>i.limits.size)throw new m.$yk((0,y.localize)(14,null,this.sb(o)),7,t,i)}async canMove(o,t,i){return this.M(o,t,"move",i)}async canCopy(o,t,i){return this.M(o,t,"copy",i)}async M(o,t,i,n){if(o.toString()!==t.toString())try{const r=i==="move"?this.qb(await this.n(o),o):await this.m(o),l=this.qb(await this.n(t),t);await this.Q(r,o,l,t,i,n)}catch(r){return r}return!0}async move(o,t,i){const n=this.qb(await this.n(o),o),r=this.qb(await this.n(t),t),l=await this.N(n,o,r,t,"move",!!i),P=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new m.$uk(o,l==="move"?2:3,P)),P}async copy(o,t,i){const n=await this.m(o),r=this.qb(await this.n(t),t),l=await this.N(n,o,r,t,"copy",!!i),P=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new m.$uk(o,l==="copy"?3:2,P)),P}async N(o,t,i,n,r,l){if(t.toString()===n.toString())return r;const{exists:P,isSameResourceWithDifferentPathCase:v}=await this.Q(o,t,i,n,r,l);if(P&&!v&&l&&await this.del(n,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(n)),r==="copy"){if(o===i&&(0,m.$gk)(o))await o.copy(t,n,{overwrite:l});else{const w=await this.resolve(t);w.isDirectory?await this.P(o,w,i,n):await this.O(o,t,i,n)}return r}else return o===i?(await o.rename(t,n,{overwrite:l}),r):(await this.N(o,t,i,n,"copy",l),await this.del(t,{recursive:!0}),"copy")}async O(o,t,i,n){if((0,m.$ik)(o)&&(0,m.$ik)(i))return this.jb(o,t,i,n);if((0,m.$ik)(o)&&(0,m.$fk)(i))return this.pb(o,t,i,n);if((0,m.$fk)(o)&&(0,m.$ik)(i))return this.nb(o,t,i,n);if((0,m.$fk)(o)&&(0,m.$fk)(i))return this.lb(o,t,i,n)}async P(o,t,i,n){await i.mkdir(n),Array.isArray(t.children)&&await N.Promises.settled(t.children.map(async r=>{const l=this.R(i).providerExtUri.joinPath(n,r.name);return r.isDirectory?this.P(o,await this.resolve(r.resource),i,l):this.O(o,r.resource,i,l)}))}async Q(o,t,i,n,r,l){let P=!1;if(o===i){const{providerExtUri:w,isPathCaseSensitive:R}=this.R(o);if(R||(P=w.isEqual(t,n)),P&&r==="copy")throw new Error((0,y.localize)(15,null,this.sb(t),this.sb(n)));if(!P&&w.isEqualOrParent(n,t))throw new Error((0,y.localize)(16,null,this.sb(t),this.sb(n)))}const v=await this.exists(n);if(v&&!P){if(!l)throw new m.$xk((0,y.localize)(17,null,this.sb(t),this.sb(n)),4);if(o===i){const{providerExtUri:w}=this.R(o);if(w.isEqualOrParent(t,n))throw new Error((0,y.localize)(18,null,this.sb(t),this.sb(n)))}}return{exists:v,isSameResourceWithDifferentPathCase:P}}R(o){const t=this.S(o);return{providerExtUri:t?f.$mg:f.$og,isPathCaseSensitive:t}}S(o){return!!(o.capabilities&1024)}async createFolder(o){const t=this.qb(await this.j(o),o);await this.U(t,o);const i=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new m.$uk(o,0,i)),i}async U(o,t){const i=[],{providerExtUri:n}=this.R(o);for(;!n.isEqual(t,n.dirname(t));)try{if(!((await o.stat(t)).type&m.FileType.Directory))throw new Error((0,y.localize)(19,null,this.sb(t)));break}catch(r){if((0,m.$sk)(r)!==m.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(n.basename(t)),t=n.dirname(t)}for(let r=i.length-1;r>=0;r--){t=n.joinPath(t,i[r]);try{await o.mkdir(t)}catch(l){if((0,m.$sk)(l)!==m.FileSystemProviderErrorCode.FileExists)throw l}}}async canDelete(o,t){try{await this.W(o,t)}catch(i){return i}return!0}async W(o,t){const i=this.qb(await this.j(o),o),n=!!t?.useTrash;if(n&&!(i.capabilities&4096))throw new Error((0,y.localize)(20,null,this.sb(o)));const r=t?.atomic;if(r&&!(i.capabilities&65536))throw new Error((0,y.localize)(21,null,this.sb(o)));if(n&&r)throw new Error((0,y.localize)(22,null,this.sb(o)));let l;try{l=await i.stat(o)}catch{}if(l)this.rb(o,l);else throw new m.$xk((0,y.localize)(23,null,this.sb(o)),1);if(!!!t?.recursive){const v=await this.resolve(o);if(v.isDirectory&&Array.isArray(v.children)&&v.children.length>0)throw new Error((0,y.localize)(24,null,this.sb(o)))}return i}async del(o,t){const i=await this.W(o,t);let n=t;if((0,m.$mk)(i)&&!n?.atomic){const v=i.enforceAtomicDelete?.(o);v&&(n={...t,atomic:v})}const r=!!n?.useTrash,l=!!n?.recursive,P=n?.atomic??!1;await i.delete(o,{recursive:l,useTrash:r,atomic:P}),this.r.fire(new m.$uk(o,1))}async cloneFile(o,t){const i=await this.j(o),n=this.qb(await this.n(t),t);if(i===n&&this.R(i).providerExtUri.isEqual(o,t))return;if(i===n&&(0,m.$hk)(i))return i.cloneFile(o,t);await this.U(n,this.R(n).providerExtUri.dirname(t));const r=this.cb.queueFor(o,this.R(i).providerExtUri);return i===n&&(0,m.$gk)(i)?r.queue(()=>i.copy(o,t,{overwrite:!0})):r.queue(()=>this.O(i,o,n,t))}static{this.ab=0}createWatcher(o,t){return this.watch(o,{...t,correlationId:p.ab++})}watch(o,t={recursive:!1,excludes:[]}){const i=new c.$Qc;let n=!1,r=()=>{n=!0};i.add((0,c.$Pc)(()=>r())),(async()=>{try{const P=await this.bb(o,t);n?(0,c.$Mc)(P):r=()=>(0,c.$Mc)(P)}catch(P){this.b.error(P)}})();const l=t.correlationId;if(typeof l=="number"){const P=i.add(new j.$Od);return i.add(this.X.event(w=>{w.correlates(l)&&P.fire(w)})),{onDidChange:P.event,dispose:()=>i.dispose()}}return i}async bb(o,t){const i=await this.j(o),n=(0,b.$Hi)([this.R(i).providerExtUri.getComparisonKey(o),t]);let r=this.$.get(n);return r||(r={count:0,disposable:i.watch(o,t)},this.$.set(n,r)),r.count+=1,(0,c.$Pc)(()=>{r&&(r.count--,r.count===0&&((0,c.$Mc)(r.disposable),this.$.delete(n)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,c.$Mc)(o.disposable);this.$.clear()}async db(o,t,i,n){return this.cb.queueFor(t,this.R(o).providerExtUri).queue(async()=>{const r=await o.open(t,{create:!0,unlock:i?.unlock??!1});try{(0,E.$1d)(n)||(0,E.$2d)(n)?await this.eb(o,r,n):await this.fb(o,r,n)}catch(l){throw(0,m.$qk)(l)}finally{await o.close(r)}})}async eb(o,t,i){let n=0,r;if((0,E.$2d)(i)){if(i.buffer.length>0){const l=D.$ce.concat(i.buffer);await this.gb(o,t,l,l.byteLength,n,0),n+=l.byteLength}if(i.ended)return;r=i.stream}else r=i;return new Promise((l,P)=>{(0,E.$7d)(r,{onData:async v=>{r.pause();try{await this.gb(o,t,v,v.byteLength,n,0)}catch(w){return P(w)}n+=v.byteLength,setTimeout(()=>r.resume())},onError:v=>P(v),onEnd:()=>l()})})}async fb(o,t,i){let n=0,r;for(;(r=i.read())!==null;)await this.gb(o,t,r,r.byteLength,n,0),n+=r.byteLength}async gb(o,t,i,n,r,l){let P=0;for(;P<n;){const v=await o.write(t,r+P,i.buffer,l+P,n-P);P+=v}}async hb(o,t,i,n){return this.cb.queueFor(t,this.R(o).providerExtUri).queue(()=>this.ib(o,t,i,n))}async ib(o,t,i,n){let r;n instanceof D.$ce?r=n:(0,E.$1d)(n)?r=await(0,D.$oe)(n):(0,E.$2d)(n)?r=await(0,D.$pe)(n):r=(0,D.$me)(n),await o.writeFile(t,r.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(o,t,i,n){return this.cb.queueFor(n,this.R(i).providerExtUri).queue(()=>this.kb(o,t,i,n))}async kb(o,t,i,n){let r,l;try{r=await o.open(t,{create:!1}),l=await i.open(n,{create:!0,unlock:!1});const P=D.$ce.alloc(this.a);let v=0,w=0,R=0;do R=await o.read(r,v,P.buffer,w,P.byteLength-w),await this.gb(i,l,P,R,v,w),v+=R,w+=R,w===P.byteLength&&(w=0);while(R>0)}catch(P){throw(0,m.$qk)(P)}finally{await N.Promises.settled([typeof r=="number"?o.close(r):Promise.resolve(),typeof l=="number"?i.close(l):Promise.resolve()])}}async lb(o,t,i,n){return this.cb.queueFor(n,this.R(i).providerExtUri).queue(()=>this.mb(o,t,i,n))}async mb(o,t,i,n){return i.writeFile(n,await o.readFile(t),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,t,i,n){return this.cb.queueFor(n,this.R(i).providerExtUri).queue(()=>this.ob(o,t,i,n))}async ob(o,t,i,n){const r=await i.open(n,{create:!0,unlock:!1});try{const l=await o.readFile(t);await this.gb(i,r,D.$ce.wrap(l),l.byteLength,0,0)}catch(l){throw(0,m.$qk)(l)}finally{await i.close(r)}}async pb(o,t,i,n){const r=await(0,D.$oe)(this.H(o,t,A.CancellationToken.None));await this.hb(i,n,void 0,r)}qb(o,t){if(o.capabilities&2048)throw new m.$xk((0,y.localize)(25,null,this.sb(t)),6);return o}rb(o,t){if((t.permissions??0)&m.FilePermission.Readonly)throw new m.$xk((0,y.localize)(26,null,this.sb(o)),6)}sb(o){return o.scheme===I.Schemas.file?o.fsPath:o.toString(!0)}};e.$Rp=S,e.$Rp=S=p=pe([ie(0,$.$bj)],S)}),define(te[124],ne([0,1,125,169,8,31,14,4,170,2,16,13,17,45,24,101,12,61,121,34,119,118]),function(J,e,L,N,D,A,j,b,h,c,k,I,d,f,E,y,m,u,$,O,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=void 0,(()=>{try{(0,N.gracefulify)(L)}catch(o){console.error(`Error enabling graceful-fs: ${(0,O.$Ei)(o)}`)}})();class s extends $.$1p{static{this.I=!1}constructor(t,i){super(t,i),this.onDidChangeCapabilities=b.Event.None,this.N=new A.$zc(n=>d.$ng.getComparisonKey(n)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,I.$l&&(this.J|=1024)),this.J}async stat(t){try{const{stat:i,symbolicLink:n}=await E.SymlinkSupport.stat(this.H(t));return{type:this.M(i,n),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:m.FilePermission.Locked}}catch(i){throw this.fb(i)}}async L(t){try{return await this.stat(t)}catch{return}}async readdir(t){try{const i=await E.Promises.readdir(this.H(t),{withFileTypes:!0}),n=[];return await Promise.all(i.map(async r=>{try{let l;r.isSymbolicLink()?l=(await this.stat((0,d.$wg)(t,r.name))).type:l=this.M(r),n.push([r.name,l])}catch(l){this.a.trace(l)}})),n}catch(i){throw this.fb(i)}}M(t,i){let n;return i?.dangling?n=m.FileType.Unknown:t.isFile()?n=m.FileType.File:t.isDirectory()?n=m.FileType.Directory:n=m.FileType.Unknown,i&&(n|=m.FileType.SymbolicLink),n}async O(t){const i=this.H(t);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let n;for(;n=this.N.get(t);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await n.wait();const r=new D.$Tg;return this.N.set(t,r),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,c.$Pc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.N.get(t)===r&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.N.delete(t)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),r.open()})}async readFile(t,i){let n;try{i?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(t)})`),n=await this.O(t));const r=this.H(t);return await E.Promises.readFile(r)}catch(r){throw this.fb(r)}finally{n?.dispose()}}P(t){s.I&&this.a.trace(t)}readFileStream(t,i,n){const r=(0,f.$3d)(l=>j.$ce.concat(l.map(P=>j.$ce.wrap(P))).buffer);return(0,u.$Qp)(this,t,r,l=>l.buffer,{...i,bufferSize:256*1024},n),r}async writeFile(t,i,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.Q(t)?this.R(t,(0,d.$wg)((0,d.$vg)(t),`${(0,d.$tg)(t)}${n.atomic.postfix}`),i,n):this.S(t,i,n)}async Q(t){try{const i=this.H(t),{symbolicLink:n}=await E.SymlinkSupport.stat(i);if(n)return!1}catch{}return!0}async R(t,i,n,r){const l=new c.$Qc;try{l.add(await this.O(t)),l.add(await this.O(i)),await this.S(i,n,r,!0);try{await this.rename(i,t,{overwrite:!0})}catch(P){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw P}}finally{l.dispose()}}async S(t,i,n,r){let l;try{const P=this.H(t);if(!n.create||!n.overwrite){if(await E.Promises.exists(P)){if(!n.overwrite)throw(0,m.$pk)((0,y.localize)(0,null),m.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,m.$pk)((0,y.localize)(1,null),m.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(t,{create:!0,unlock:n.unlock},r),await this.write(l,0,i,0,i.byteLength)}catch(P){throw await this.gb(t,P)}finally{typeof l=="number"&&await this.close(l)}}static{this.Y=!0}static configureFlushOnWrite(t){s.Y=t}async open(t,i,n){const r=this.H(t);let l;(0,m.$dk)(i)&&!n&&(l=await this.O(t));let P;try{if((0,m.$dk)(i)&&i.unlock)try{const{stat:w}=await E.SymlinkSupport.stat(r);w.mode&128||await E.Promises.chmod(r,w.mode|128)}catch(w){w.code!=="ENOENT"&&this.a.trace(w)}let v;if((0,m.$dk)(i)){if(I.$j)try{await E.Promises.truncate(r,0),v="r+"}catch(w){w.code!=="ENOENT"&&this.a.trace(w)}v||(v="w")}else v="r";P=await E.Promises.open(r,v)}catch(v){throw l?.dispose(),(0,m.$dk)(i)?await this.gb(t,v):this.fb(v)}if(this.U.set(P,0),(0,m.$dk)(i)&&this.X.set(P,t),l){const v=this.W.get(P);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${P} (${r})`),this.W.set(P,l),v&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${P} (${r})`),v.dispose())}return P}async close(t){const i=this.W.get(t);try{if(this.U.delete(t),this.X.delete(t)&&s.Y)try{await E.Promises.fdatasync(t)}catch(n){s.configureFlushOnWrite(!1),this.a.error(n)}return await E.Promises.close(t)}catch(n){throw this.fb(n)}finally{i&&(this.W.get(t)===i&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.W.delete(t)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),i.dispose())}}async read(t,i,n,r,l){const P=this.Z(t,i);let v=null;try{v=(await E.Promises.read(t,n,r,l,P)).bytesRead}catch(w){throw this.fb(w)}finally{this.$(t,P,v)}return v}Z(t,i){return i===this.U.get(t)?null:i}$(t,i,n){const r=this.U.get(t);typeof r=="number"&&(typeof i=="number"||(typeof n=="number"?this.U.set(t,r+n):this.U.delete(t)))}async write(t,i,n,r,l){return(0,D.$dh)(()=>this.ab(t,i,n,r,l),100,3)}async ab(t,i,n,r,l){const P=this.Z(t,i);let v=null;try{v=(await E.Promises.write(t,n,r,l,P)).bytesWritten}catch(w){throw await this.gb(this.X.get(t),w)}finally{this.$(t,P,v)}return v}async mkdir(t){try{await E.Promises.mkdir(this.H(t))}catch(i){throw this.fb(i)}}async delete(t,i){try{const n=this.H(t);if(i.recursive){let r;i?.atomic!==!1&&i.atomic.postfix&&(r=(0,k.$ic)((0,k.$lc)(n),`${(0,k.$mc)(n)}${i.atomic.postfix}`)),await E.Promises.rm(n,E.RimRafMode.MOVE,r)}else try{await E.Promises.unlink(n)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let l=!1;try{const{stat:P,symbolicLink:v}=await E.SymlinkSupport.stat(n);l=P.isDirectory()&&!v}catch{}if(l)await E.Promises.rmdir(n);else throw r}else throw r}}catch(n){throw this.fb(n)}}async rename(t,i,n){const r=this.H(t),l=this.H(i);if(r!==l)try{await this.bb(t,i,"move",n.overwrite),await E.Promises.rename(r,l)}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,y.localize)(2,null,(0,k.$mc)(r),(0,k.$mc)((0,k.$lc)(l)),P.toString()))),this.fb(P)}}async copy(t,i,n){const r=this.H(t),l=this.H(i);if(r!==l)try{await this.bb(t,i,"copy",n.overwrite),await E.Promises.copy(r,l,{preserveSymlinks:!0})}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,y.localize)(3,null,(0,k.$mc)(r),(0,k.$mc)((0,k.$lc)(l)),P.toString()))),this.fb(P)}}async bb(t,i,n,r){const l=this.H(t),P=this.H(i);let v=!1;if(!!(this.capabilities&1024)||(v=(0,h.$Xf)(l,P,!0)),v){if(n==="copy")throw(0,m.$pk)((0,y.localize)(4,null),m.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const R=await this.L(t);if(!R)throw(0,m.$pk)((0,y.localize)(5,null),m.FileSystemProviderErrorCode.FileNotFound);const B=await this.L(i);if(B){if(!r)throw(0,m.$pk)((0,y.localize)(6,null),m.FileSystemProviderErrorCode.FileExists);R.type&m.FileType.File&&B.type&m.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(t,i){return this.cb(t,i,!1)}async cb(t,i,n){const r=this.H(t),l=this.H(i),P=!!(this.capabilities&1024);if((0,h.$Xf)(r,l,!P))return;const v=new c.$Qc;try{v.add(await this.O(t)),v.add(await this.O(i)),n&&await E.Promises.mkdir((0,k.$lc)(l),{recursive:!0}),await E.Promises.copyFile(r,l)}catch(w){if(w.code==="ENOENT"&&!n)return this.cb(t,i,!0);throw this.fb(w)}finally{v.dispose()}}t(t,i,n){return new p.$8p(r=>t(r),r=>i(r),n)}F(t,i,n){return new S.$dq(r=>t(r),r=>i(r),n)}fb(t){if(t instanceof m.$ok)return t;let i=t,n;switch(t.code){case"ENOENT":n=m.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=m.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=m.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=m.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=m.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${t.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=m.FileSystemProviderErrorCode.Unknown;break;default:n=m.FileSystemProviderErrorCode.Unknown}return(0,m.$pk)(i,n)}async gb(t,i){let n=this.fb(i);if(t&&n.code===m.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await E.SymlinkSupport.stat(this.H(t));r.mode&128||(n=(0,m.$pk)(i,m.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return n}}e.$eq=s}),define(te[126],ne([0,1,2,6]),function(J,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UN=void 0;class D extends L.$Rc{constructor(j,b=[]){super(),this.a=new N.$lj([j,...b]),this.B(j.onDidChangeLogLevel(h=>this.setLevel(h)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(j){this.a.setLevel(j)}getLevel(){return this.a.getLevel()}trace(j,...b){this.a.trace(j,...b)}debug(j,...b){this.a.debug(j,...b)}info(j,...b){this.a.info(j,...b)}warn(j,...b){this.a.warn(j,...b)}error(j,...b){this.a.error(j,...b)}flush(){this.a.flush()}}e.$UN=D}),define(te[127],ne([0,1,12,6]),function(J,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JN=void 0;var D;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(D||(D={}));async function A(c,k,I,d,f){try{const E=await new Promise((m,u)=>{J(["@vscode/spdlog"],m,u)});E.setFlushOn(D.Trace);const y=await E.createAsyncRotatingLogger(c,k,I,d);return f?y.clearFormatters():y.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),y}catch(E){console.error(E)}return null}function j(c,k,I){switch(k){case N.LogLevel.Trace:c.trace(I);break;case N.LogLevel.Debug:c.debug(I);break;case N.LogLevel.Info:c.info(I);break;case N.LogLevel.Warning:c.warn(I);break;case N.LogLevel.Error:c.error(I);break;case N.LogLevel.Off:break;default:throw new Error(`Invalid log level ${k}`)}}function b(c,k){switch(k){case N.LogLevel.Trace:c.setLevel(D.Trace);break;case N.LogLevel.Debug:c.setLevel(D.Debug);break;case N.LogLevel.Info:c.setLevel(D.Info);break;case N.LogLevel.Warning:c.setLevel(D.Warning);break;case N.LogLevel.Error:c.setLevel(D.Error);break;case N.LogLevel.Off:c.setLevel(D.Off);break;default:throw new Error(`Invalid log level ${k}`)}}class h extends N.$hj{constructor(k,I,d,f,E){super(),this.m=[],this.setLevel(E),this.n=this.s(k,I,d,f),this.B(this.onDidChangeLogLevel(y=>{this.r&&b(this.r,y)}))}async s(k,I,d,f){const E=d?6:1,y=30/E*L.$Kk.MB,m=await A(k,I,y,E,f);if(m){this.r=m,b(this.r,this.getLevel());for(const{level:u,message:$}of this.m)j(this.r,u,$);this.m=[]}}g(k,I){this.r?j(this.r,k,I):this.getLevel()<=k&&this.m.push({level:k,message:I})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$JN=h}),define(te[128],ne([0,1,28,6,127]),function(J,e,L,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KN=void 0;class A extends N.$mj{s(b,h,c){return new D.$JN((0,L.$fg)(),b.fsPath,!c?.donotRotate,!!c?.donotUseFormatters,h)}}e.$KN=A}),define(te[38],ne([0,1,4,65,2,10]),function(J,e,L,N,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$on=e.$nn=e.$mn=void 0,e.$mn=(0,A.$Th)("policy");class j extends D.$Rc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new L.$Od),this.onDidChange=this.h.event}async updatePolicyDefinitions(c){const k=Object.keys(this.f).length;return this.f={...c,...this.f},k!==Object.keys(this.f).length&&await this.j(c),N.Iterable.reduce(this.g.entries(),(I,[d,f])=>({...I,[d]:f}),{})}getPolicyValue(c){return this.g.get(c)}serialize(){return N.Iterable.reduce(Object.entries(this.f),(c,[k,I])=>({...c,[k]:{definition:I,value:this.g.get(k)}}),{})}}e.$nn=j;class b{constructor(){this.onDidChange=L.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$on=b}),define(te[129],ne([0,1,8,4,65,3,12,6,38]),function(J,e,L,N,D,A,j,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b9b=void 0;function c(I,d){const f=[];for(const E of new Set(D.Iterable.concat(I.keys(),d.keys())))I.get(E)!==d.get(E)&&f.push(E);return f}let k=class extends h.$nn{constructor(d,f,E){super(),this.m=d,this.n=f,this.s=E,this.c=this.B(new L.$Sg(500));const y=N.Event.filter(f.onDidFilesChange,m=>m.affects(d));this.B(f.watch(d)),this.B(y(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const d=new Map;try{const f=await this.n.readFile(this.m),E=JSON.parse(f.value.toString());if(!(0,A.$Bf)(E))throw new Error("Policy file isn't a JSON object");for(const y of Object.keys(E))this.f[y]&&d.set(y,E[y])}catch(f){f.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",f)}return d}async w(){const d=await this.u(),f=c(this.g,d);this.g=d,f.length>0&&this.h.fire(f)}};e.$b9b=k,e.$b9b=k=pe([ie(1,j.$ck),ie(2,b.$bj)],k)}),define(te[130],ne([0,1,38,8,171,2,6]),function(J,e,L,N,D,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a9b=void 0;let b=class extends L.$nn{constructor(c,k){super(),this.m=c,this.n=k,this.a=new N.$Og,this.b=this.B(new A.$Sc)}async j(c){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(c).length} policy definitions`),await this.a.queue(()=>new Promise((k,I)=>{try{this.b.value=(0,D.createWatcher)(this.n,c,d=>{this.t(d),k()})}catch(d){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",d),I(d)}}))}t(c){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(c)}`);for(const k in c){const I=c[k];I===void 0?this.g.delete(k):this.g.set(k,I)}this.h.fire(Object.keys(c))}};e.$a9b=b,e.$a9b=b=pe([ie(0,j.$bj)],b)}),define(te[32],ne([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uj=e.$tj=void 0,e.$tj=(0,L.$Th)("productService"),e.$uj="vscode://schemas/vscode-product"}),define(te[36],ne([0,1,71,3]),function(J,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kn=void 0;class D{constructor(){this.a=new Map}add(j,b){L.ok(N.$zf(j)),L.ok(N.$Bf(b)),L.ok(!this.a.has(j),"There is already an extension with this id"),this.a.set(j,b)}knows(j){return this.a.has(j)}as(j){return this.a.get(j)||null}}e.$kn=new D}),define(te[131],ne([0,1,4,36]),function(J,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=void 0,e.$ln={JSONContribution:"base.contributions.json"};function D(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class A{constructor(){this.b=new L.$Od,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(h,c){this.a[D(h)]=c,this.b.fire(h)}notifySchemaChanged(h){this.b.fire(h)}getSchemaContributions(){return{schemas:this.a}}}const j=new A;N.$kn.add(e.$ln.JSONContribution,j)}),define(te[43],ne([0,1,19,4,3,88,25,131,36]),function(J,e,L,N,D,A,j,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.ConfigurationScope=e.$pn=e.EditPresentationTypes=void 0;var c;(function(S){S.Multiline="multilineText",S.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.$pn={Configuration:"base.contributions.configuration"};var k;(function(S){S[S.APPLICATION=1]="APPLICATION",S[S.MACHINE=2]="MACHINE",S[S.WINDOW=3]="WINDOW",S[S.RESOURCE=4]="RESOURCE",S[S.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",S[S.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(k||(e.ConfigurationScope=k={})),e.$qn={properties:{},patternProperties:{}},e.$rn={properties:{},patternProperties:{}},e.$sn={properties:{},patternProperties:{}},e.$tn={properties:{},patternProperties:{}},e.$un={properties:{},patternProperties:{}},e.$vn={properties:{},patternProperties:{}},e.$wn="vscode://schemas/settings/resourceLanguage",e.$xn="vscode://schemas/settings/configurationDefaults";const I=h.$kn.as(b.$ln.JSONContribution);class d{constructor(){this.h=new Set,this.i=new N.$Od,this.onDidSchemaChange=this.i.event,this.j=new N.$Od,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},I.registerSchema(e.$wn,this.g),this.v()}registerConfiguration(s,o=!0){this.registerConfigurations([s],o)}registerConfigurations(s,o=!0){const t=new Set;this.n(s,o,t),I.registerSchema(e.$wn,this.g),this.i.fire(),this.j.fire({properties:t})}deregisterConfigurations(s){const o=new Set;this.o(s,o),I.registerSchema(e.$wn,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:s,remove:o}){const t=new Set;this.o(o,t),this.n(s,!1,t),I.registerSchema(e.$wn,this.g),this.i.fire(),this.j.fire({properties:t})}registerDefaultConfigurations(s){const o=new Set;this.k(s,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(s,o){const t=[];for(const{overrides:i,source:n}of s)for(const r in i)if(o.add(r),e.$zn.test(r)){const l=this.a.get(r),P=l?.valuesSources??new Map;if(n)for(const B of Object.keys(i[r]))P.set(B,n);const v={...l?.value||{},...i[r]};this.a.set(r,{source:n,value:v,valuesSources:P});const w=(0,j.$xi)(r),R={type:"object",default:v,description:A.localize(1,null,w),$ref:e.$wn,defaultDefaultValue:v,source:D.$zf(n)?void 0:n,defaultValueSource:n};t.push(...y(r)),this.d[r]=R,this.b.properties[r]=R}else{this.a.set(r,{value:i[r],source:n});const l=this.d[r];l&&(this.w(r,l),this.r(r,l))}this.m(t)}deregisterDefaultConfigurations(s){const o=new Set;this.l(s,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(s,o){for(const{overrides:t,source:i}of s)for(const n in t){const r=this.a.get(n),l=D.$zf(i)?i:i?.id,P=D.$zf(r?.source)?r?.source:r?.source?.id;if(l===P)if(o.add(n),this.a.delete(n),e.$zn.test(n))delete this.d[n],delete this.b.properties[n];else{const v=this.d[n];v&&(this.w(n,v),this.r(n,v))}}this.u()}deltaConfiguration(s){let o=!1;const t=new Set;s.removedDefaults&&(this.l(s.removedDefaults,t),o=!0),s.addedDefaults&&(this.k(s.addedDefaults,t),o=!0),s.removedConfigurations&&this.o(s.removedConfigurations,t),s.addedConfigurations&&this.n(s.addedConfigurations,!1,t),this.i.fire(),this.j.fire({properties:t,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...s){this.i.fire()}registerOverrideIdentifiers(s){this.m(s),this.i.fire()}m(s){for(const o of s)this.h.add(o);this.u()}n(s,o,t){s.forEach(i=>{this.p(i,o,i.extensionInfo,i.restrictedProperties,void 0,t),this.c.push(i),this.q(i)})}o(s,o){const t=i=>{if(i.properties)for(const n in i.properties){o.add(n);const r=this.d[n];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[n],this.s(n,i.properties[n])}i.allOf?.forEach(n=>t(n))};for(const i of s){t(i);const n=this.c.indexOf(i);n!==-1&&this.c.splice(n,1)}}p(s,o=!0,t,i,n=3,r){n=D.$If(s.scope)?n:s.scope;const l=s.properties;if(l)for(const v in l){const w=l[v];if(o&&O(v,w)){delete l[v];continue}if(w.source=t,w.defaultDefaultValue=l[v].default,this.w(v,w),e.$zn.test(v)?w.scope=void 0:(w.scope=D.$If(w.scope)?n:w.scope,w.restricted=D.$If(w.restricted)?!!i?.includes(v):w.restricted),l[v].hasOwnProperty("included")&&!l[v].included){this.f[v]=l[v],delete l[v];continue}else this.d[v]=l[v],l[v].policy?.name&&this.e.set(l[v].policy.name,v);!l[v].deprecationMessage&&l[v].markdownDeprecationMessage&&(l[v].deprecationMessage=l[v].markdownDeprecationMessage),r.add(v)}const P=s.allOf;if(P)for(const v of P)this.p(v,o,t,i,n,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(s){const o=t=>{const i=t.properties;if(i)for(const r in i)this.r(r,i[r]);t.allOf?.forEach(o)};o(s)}r(s,o){switch(e.$qn.properties[s]=o,o.scope){case 1:e.$rn.properties[s]=o;break;case 2:e.$sn.properties[s]=o;break;case 6:e.$tn.properties[s]=o;break;case 3:e.$un.properties[s]=o;break;case 4:e.$vn.properties[s]=o;break;case 5:e.$vn.properties[s]=o,this.g.properties[s]=o;break}}s(s,o){switch(delete e.$qn.properties[s],o.scope){case 1:delete e.$rn.properties[s];break;case 2:delete e.$sn.properties[s];break;case 6:delete e.$tn.properties[s];break;case 3:delete e.$un.properties[s];break;case 4:case 5:delete e.$vn.properties[s],delete this.g.properties[s];break}}u(){for(const s of this.h.values()){const o=`[${s}]`,t={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.$wn};this.w(o,t),e.$qn.properties[o]=t,e.$rn.properties[o]=t,e.$sn.properties[o]=t,e.$tn.properties[o]=t,e.$un.properties[o]=t,e.$vn.properties[o]=t}}v(){const s={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.$wn};e.$qn.patternProperties[e.$yn]=s,e.$rn.patternProperties[e.$yn]=s,e.$sn.patternProperties[e.$yn]=s,e.$tn.patternProperties[e.$yn]=s,e.$un.patternProperties[e.$yn]=s,e.$vn.patternProperties[e.$yn]=s,this.i.fire()}w(s,o){const t=this.a.get(s);let i=t?.value,n=t?.source;D.$Gf(i)&&(i=o.defaultDefaultValue,n=void 0),D.$Gf(i)&&(i=u(o.type)),o.default=i,o.defaultValueSource=n}}const f="\\[([^\\]]+)\\]",E=new RegExp(f,"g");e.$yn=`^(${f})+$`,e.$zn=new RegExp(e.$yn);function y(S){const s=[];if(e.$zn.test(S)){let o=E.exec(S);for(;o?.length;){const t=o[1].trim();t&&s.push(t),o=E.exec(S)}}return(0,L.$Lb)(s)}e.$An=y;function m(S){return S.reduce((s,o)=>`${s}[${o}]`,"")}e.$Bn=m;function u(S){switch(Array.isArray(S)?S[0]:S){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Cn=u;const $=new d;h.$kn.add(e.$pn.Configuration,$);function O(S,s){return S.trim()?e.$zn.test(S)?A.localize(7,null,S):$.getConfigurationProperties()[S]!==void 0?A.localize(8,null,S):s.policy?.name&&$.getPolicyConfigurations().get(s.policy?.name)!==void 0?A.localize(9,null,S,s.policy?.name,$.getPolicyConfigurations().get(s.policy?.name)):null:A.localize(6,null)}e.$Dn=O;function p(){const S=[],s=$.getConfigurationProperties();for(const o of Object.keys(s))S.push([o,s[o].scope]);return S.push(["launch",4]),S.push(["task",4]),S}e.$En=p}),define(te[66],ne([0,1,19,4,53,2,31,30,3,11,25,43,36]),function(J,e,L,N,D,A,j,b,h,c,k,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=void 0;function f(o){return Object.isFrozen(o)?o:b.$_m(o)}class E{constructor(t={},i=[],n=[],r){this.b=t,this.c=i,this.d=n,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const t=this.raw.map(i=>{if(i instanceof E)return i;const n=new y("");return n.parseRaw(i),n.configurationModel});this.f=t.reduce((i,n)=>n===i?n:i.merge(n),t[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,k.$vi)(this.contents,t):this.contents}inspect(t,i){const n=this.rawConfiguration.getValue(t),r=i?this.rawConfiguration.getOverrideValue(t,i):void 0,l=i?this.rawConfiguration.override(i).getValue(t):n;return{value:n,override:r,merged:l}}getOverrideValue(t,i){const n=this.i(i);return n?t?(0,k.$vi)(n,t):n:void 0}getKeysForOverrideIdentifier(t){const i=[];for(const n of this.overrides)n.identifiers.includes(t)&&i.push(...n.keys);return L.$Lb(i)}getAllOverrideIdentifiers(){const t=[];for(const i of this.overrides)t.push(...i.identifiers);return L.$Lb(t)}override(t){let i=this.a.get(t);return i||(i=this.g(t),this.a.set(t,i)),i}merge(...t){const i=b.$$m(this.contents),n=b.$$m(this.overrides),r=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const P of t)if(l.push(...P.raw?.length?P.raw:[P]),!P.isEmpty()){this.h(i,P.contents);for(const v of P.overrides){const[w]=n.filter(R=>L.$tb(R.identifiers,v.identifiers));w?(this.h(w.contents,v.contents),w.keys.push(...v.keys),w.keys=L.$Lb(w.keys)):n.push(b.$$m(v))}for(const v of P.keys)r.indexOf(v)===-1&&r.push(v)}return new E(i,r,n,l.every(P=>P instanceof E)?void 0:l)}g(t){const i=this.i(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const n={};for(const r of L.$Lb([...Object.keys(this.contents),...Object.keys(i)])){let l=this.contents[r];const P=i[r];P&&(typeof l=="object"&&typeof P=="object"?(l=b.$$m(l),this.h(l,P)):l=P),n[r]=l}return new E(n,this.keys,this.overrides)}h(t,i){for(const n of Object.keys(i)){if(n in t&&h.$Bf(t[n])&&h.$Bf(i[n])){this.h(t[n],i[n]);continue}t[n]=b.$$m(i[n])}}i(t){let i=null,n=null;const r=l=>{l&&(n?this.h(n,l):n=b.$$m(l))};for(const l of this.overrides)l.identifiers.length===1&&l.identifiers[0]===t?i=l.contents:l.identifiers.includes(t)&&r(l.contents);return r(i),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,i){this.j(t,i,!0)}setValue(t,i){this.j(t,i,!1)}removeValue(t){const i=this.keys.indexOf(t);i!==-1&&(this.keys.splice(i,1),(0,k.$ui)(this.contents,t),I.$zn.test(t)&&this.overrides.splice(this.overrides.findIndex(n=>L.$tb(n.identifiers,(0,I.$An)(t))),1))}j(t,i,n){(0,k.$ti)(this.contents,t,i,r=>console.error(r)),n=n||this.keys.indexOf(t)===-1,n&&this.keys.push(t),I.$zn.test(t)&&this.overrides.push({identifiers:(0,I.$An)(t),keys:Object.keys(this.contents[t]),contents:(0,k.$si)(this.contents[t],r=>console.error(r))})}}e.$Fn=E;class y{constructor(t){this.f=t,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new E}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,i){if(!h.$If(t)){const n=this.g(t);this.parseRaw(n,i)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,i){this.a=t;const{contents:n,keys:r,overrides:l,restricted:P,hasExcludedProperties:v}=this.h(t,i);this.b=new E(n,r,l,v?[t]:void 0),this.c=P||[]}g(t){let i={},n=null,r=[];const l=[],P=[];function v(R){Array.isArray(r)?r.push(R):n!==null&&(r[n]=R)}const w={onObjectBegin:()=>{const R={};v(R),l.push(r),r=R,n=null},onObjectProperty:R=>{n=R},onObjectEnd:()=>{r=l.pop()},onArrayBegin:()=>{const R=[];v(R),l.push(r),r=R,n=null},onArrayEnd:()=>{r=l.pop()},onLiteralValue:v,onError:(R,B,_)=>{P.push({error:R,offset:B,length:_})}};if(t)try{D.$8m(t,w),i=r[0]||{}}catch(R){console.error(`Error while parsing settings file ${this.f}: ${R}`),this.d=[R]}return i}h(t,i){const n=d.$kn.as(I.$pn.Configuration).getConfigurationProperties(),r=this.i(t,n,!0,i);t=r.raw;const l=(0,k.$si)(t,w=>console.error(`Conflict in settings file ${this.f}: ${w}`)),P=Object.keys(t),v=this.j(t,w=>console.error(`Conflict in settings file ${this.f}: ${w}`));return{contents:l,keys:P,overrides:v,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(t,i,n,r){let l=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:l};const P={},v=[];for(const w in t)if(I.$zn.test(w)&&n){const R=this.i(t[w],i,!1,r);P[w]=R.raw,l=l||R.hasExcludedProperties,v.push(...R.restricted)}else{const R=i[w],B=R?typeof R.scope<"u"?R.scope:3:void 0;R?.restricted&&v.push(w),!r.exclude?.includes(w)&&(r.include?.includes(w)||(B===void 0||r.scopes===void 0||r.scopes.includes(B))&&!(r.skipRestricted&&R?.restricted))?P[w]=t[w]:l=!0}return{raw:P,restricted:v,hasExcludedProperties:l}}j(t,i){const n=[];for(const r of Object.keys(t))if(I.$zn.test(r)){const l={};for(const P in t[r])l[P]=t[r][P];n.push({identifiers:(0,I.$An)(r),keys:Object.keys(l),contents:(0,k.$si)(l,i)})}return n}}e.$Gn=y;class m extends A.$Rc{constructor(t,i,n,r){super(),this.c=t,this.f=i,this.g=r,this.b=this.B(new N.$Od),this.onDidChange=this.b.event,this.a=new y(this.c.toString()),this.B(this.g.watch(n.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(N.Event.any(N.Event.filter(this.g.onDidFilesChange,l=>l.contains(this.c)),N.Event.filter(this.g.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&n.isEqual(l.resource,t)))(()=>this.b.fire()))}async loadConfiguration(){try{const t=await this.g.readFile(this.c);return this.a.parse(t.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new E}}reparse(t){return t&&(this.f=t),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Hn=m;class u{constructor(t,i,n,r,l,P,v,w,R,B,_,ee,oe){this.a=t,this.b=i,this.c=n,this.overrideIdentifiers=r,this.d=l,this.f=P,this.g=v,this.h=w,this.i=R,this.j=B,this.k=_,this.l=ee,this.m=oe}get value(){return f(this.c)}n(t,i,n){const r=t.inspect(i,n);return{get value(){return f(r.value)},get override(){return f(r.override)},get merged(){return f(r.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class ${constructor(t,i,n,r,l=new E,P=new E,v=new j.$zc,w=new E,R=new j.$zc){this.c=t,this.d=i,this.f=n,this.g=r,this.h=l,this.i=P,this.j=v,this.l=w,this.m=R,this.a=null,this.b=new j.$zc,this.n=null}getValue(t,i,n){return this.q(t,i,n).getValue(t)}updateValue(t,i,n={}){let r;n.resource?(r=this.m.get(n.resource),r||(r=new E,this.m.set(n.resource,r))):r=this.l,i===void 0?r.removeValue(t):r.setValue(t,i),n.resource||(this.a=null)}inspect(t,i,n){const r=this.q(t,i,n),l=this.u(i.resource,n),P=i.resource?this.m.get(i.resource)||this.l:this.l,v=new Set;for(const w of r.overrides)for(const R of w.identifiers)r.getOverrideValue(t,R)!==void 0&&v.add(R);return new u(t,i,r.getValue(t),v.size?[...v]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this.i:void 0,l||void 0,P)}keys(t){const i=this.u(void 0,t);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(t){this.c=t,this.a=null,this.b.clear()}updatePolicyConfiguration(t){this.d=t}updateApplicationConfiguration(t){this.f=t,this.a=null,this.b.clear()}updateLocalUserConfiguration(t){this.g=t,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(t){this.h=t,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(t){this.i=t,this.a=null,this.b.clear()}updateFolderConfiguration(t,i){this.j.set(t,i),this.b.delete(t)}deleteFolderConfiguration(t){this.p.delete(t),this.b.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const n=[];if(!i){const{added:r,updated:l,removed:P}=S(this.c,t);i=[...r,...l,...P]}for(const r of i)for(const l of(0,I.$An)(r)){const P=this.c.getKeysForOverrideIdentifier(l),v=t.getKeysForOverrideIdentifier(l),w=[...v.filter(R=>P.indexOf(R)===-1),...P.filter(R=>v.indexOf(R)===-1),...P.filter(R=>!b.$cn(this.c.override(l).getValue(R),t.override(l).getValue(R)))];n.push([l,w])}return this.updateDefaultConfiguration(t),{keys:i,overrides:n}}compareAndUpdatePolicyConfiguration(t){const{added:i,updated:n,removed:r}=S(this.d,t),l=[...i,...n,...r];return l.length&&this.updatePolicyConfiguration(t),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:i,updated:n,removed:r,overrides:l}=S(this.applicationConfiguration,t),P=[...i,...n,...r];return P.length&&this.updateApplicationConfiguration(t),{keys:P,overrides:l}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:n,removed:r,overrides:l}=S(this.localUserConfiguration,t),P=[...i,...n,...r];return P.length&&this.updateLocalUserConfiguration(t),{keys:P,overrides:l}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:n,removed:r,overrides:l}=S(this.remoteUserConfiguration,t),P=[...i,...n,...r];return P.length&&this.updateRemoteUserConfiguration(t),{keys:P,overrides:l}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:n,removed:r,overrides:l}=S(this.workspaceConfiguration,t),P=[...i,...n,...r];return P.length&&this.updateWorkspaceConfiguration(t),{keys:P,overrides:l}}compareAndUpdateFolderConfiguration(t,i){const n=this.p.get(t),{added:r,updated:l,removed:P,overrides:v}=S(n,i),w=[...r,...l,...P];return(w.length||!n)&&this.updateFolderConfiguration(t,i),{keys:w,overrides:v}}compareAndDeleteFolderConfiguration(t){const i=this.p.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:n,updated:r,removed:l,overrides:P}=S(i,void 0);return{keys:[...n,...r,...l],overrides:P}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(t,i,n){let r=this.r(i,n);return i.overrideIdentifier&&(r=r.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(t)!==void 0&&(r=r.merge(this.d)),r}r({resource:t},i){let n=this.s();if(i&&t){const r=i.getFolder(t);r&&(n=this.t(r.uri)||n);const l=this.m.get(t);l&&(n=n.merge(l))}return n}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(t){let i=this.b.get(t);if(!i){const n=this.s(),r=this.j.get(t);r?(i=n.merge(r),this.b.set(t,i)):i=n}return i}u(t,i){if(i&&t){const n=i.getFolder(t);if(n)return this.j.get(n.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((t,i)=>{const{contents:n,overrides:r,keys:l}=this.j.get(i);return t.push([i,{contents:n,overrides:r,keys:l}]),t},[])}}allKeys(){const t=new Set;return this.c.keys.forEach(i=>t.add(i)),this.userConfiguration.keys.forEach(i=>t.add(i)),this.i.keys.forEach(i=>t.add(i)),this.j.forEach(i=>i.keys.forEach(n=>t.add(n))),[...t.values()]}v(){const t=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(n=>t.add(n))),[...t.values()]}w(t){const i=new Set;return this.c.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this.i.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this.j.forEach(n=>n.getKeysForOverrideIdentifier(t).forEach(r=>i.add(r))),[...i.values()]}static parse(t){const i=this.x(t.defaults),n=this.x(t.policy),r=this.x(t.application),l=this.x(t.user),P=this.x(t.workspace),v=t.folders.reduce((w,R)=>(w.set(c.URI.revive(R[0]),this.x(R[1])),w),new j.$zc);return new $(i,n,r,l,new E,P,v,new E,new j.$zc)}static x(t){return new E(t.contents,t.keys,t.overrides)}}e.$In=$;function O(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const t=new Set,i=new Map;for(const r of o)r.keys.forEach(l=>t.add(l)),r.overrides.forEach(([l,P])=>{const v=(0,j.$wc)(i,l,new Set);P.forEach(w=>v.add(w))});const n=[];return i.forEach((r,l)=>n.push([l,[...r.values()]])),{keys:[...t.values()],overrides:n}}e.$Jn=O;class p{constructor(t,i,n,r){this.change=t,this.f=i,this.g=n,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const l of t.keys)this.affectedKeys.add(l);for(const[,l]of t.overrides)for(const P of l)this.affectedKeys.add(P);this.d=this.a;for(const l of this.affectedKeys)this.d+=l+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=$.parse(this.f.data)),this.i}affectsConfiguration(t,i){const n=this.a+t,r=this.d.indexOf(n);if(r<0)return!1;const l=r+n.length;if(l>=this.d.length)return!1;const P=this.d.charCodeAt(l);if(P!==this.b&&P!==this.c)return!1;if(i){const v=this.previousConfiguration?this.previousConfiguration.getValue(t,i,this.f?.workspace):void 0,w=this.g.getValue(t,i,this.h);return!b.$cn(v,w)}return!0}}e.$Kn=p;function S(o,t){const{added:i,removed:n,updated:r}=s(t?.rawConfiguration,o?.rawConfiguration),l=[],P=o?.getAllOverrideIdentifiers()||[],v=t?.getAllOverrideIdentifiers()||[];if(t){const w=v.filter(R=>!P.includes(R));for(const R of w)l.push([R,t.getKeysForOverrideIdentifier(R)])}if(o){const w=P.filter(R=>!v.includes(R));for(const R of w)l.push([R,o.getKeysForOverrideIdentifier(R)])}if(t&&o){for(const w of P)if(v.includes(w)){const R=s({contents:o.getOverrideValue(void 0,w)||{},keys:o.getKeysForOverrideIdentifier(w)},{contents:t.getOverrideValue(void 0,w)||{},keys:t.getKeysForOverrideIdentifier(w)});l.push([w,[...R.added,...R.removed,...R.updated]])}}return{added:i,removed:n,updated:r,overrides:l}}function s(o,t){const i=o?t?o.keys.filter(l=>t.keys.indexOf(l)===-1):[...o.keys]:[],n=t?o?t.keys.filter(l=>o.keys.indexOf(l)===-1):[...t.keys]:[],r=[];if(o&&t){for(const l of t.keys)if(o.keys.indexOf(l)!==-1){const P=(0,k.$vi)(t.contents,l),v=(0,k.$vi)(o.contents,l);b.$cn(P,v)||r.push(l)}}return{added:i,removed:n,updated:r}}}),define(te[132],ne([0,1,19,4,2,30,3,66,43,6,38,36]),function(J,e,L,N,D,A,j,b,h,c,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nn=e.$Mn=e.$Ln=void 0;class d extends D.$Rc{constructor(){super(...arguments),this.a=this.B(new N.$Od),this.onDidChangeConfiguration=this.a.event,this.b=new b.$Fn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(I.$kn.as(h.$pn.Configuration).onDidUpdateConfiguration(({properties:m,defaultsOverrides:u})=>this.c(Array.from(m),u))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(m,u){this.h(m,I.$kn.as(h.$pn.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:m})}f(){return{}}g(){this.b=new b.$Fn;const m=I.$kn.as(h.$pn.Configuration).getConfigurationProperties();this.h(Object.keys(m),m)}h(m,u){const $=this.f();for(const O of m){const p=$[O],S=u[O];p!==void 0?this.b.addValue(O,p):S?this.b.addValue(O,S.default):this.b.removeValue(O)}}}e.$Ln=d;class f{constructor(){this.onDidChangeConfiguration=N.Event.None,this.configurationModel=new b.$Fn}async initialize(){return this.configurationModel}}e.$Mn=f;let E=class extends D.$Rc{get configurationModel(){return this.b}constructor(m,u,$){super(),this.c=m,this.f=u,this.g=$,this.a=this.B(new N.$Od),this.onDidChangeConfiguration=this.a.event,this.b=new b.$Fn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(m=>this.j(m))),this.B(this.c.onDidChangeConfiguration(async({properties:m})=>this.m(await this.h(m),!0))),this.b}async h(m){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",m);const u={},$=[],O=I.$kn.as(h.$pn.Configuration).getConfigurationProperties();for(const p of m){const S=O[p];if(!S){$.push(p);continue}if(S.policy){if(S.type!=="string"&&S.type!=="number"){this.g.warn(`Policy ${S.policy.name} has unsupported type ${S.type}`);continue}$.push(p),u[S.policy.name]={type:S.type}}}return(0,j.$Mf)(u)||await this.f.updatePolicyDefinitions(u),$}j(m){this.g.trace("PolicyConfiguration#onDidChangePolicies",m);const u=I.$kn.as(h.$pn.Configuration).getPolicyConfigurations(),$=(0,L.$Gb)(m.map(O=>u.get(O)));this.m($,!0)}m(m,u){this.g.trace("PolicyConfiguration#update",m);const $=I.$kn.as(h.$pn.Configuration).getConfigurationProperties(),O=[],p=this.b.isEmpty();for(const S of m){const s=$[S]?.policy?.name;if(s){const o=this.f.getPolicyValue(s);(p?o!==void 0:!(0,A.$cn)(this.b.getValue(S),o))&&O.push([S,o])}else this.b.getValue(S)!==void 0&&O.push([S,void 0])}if(O.length){this.g.trace("PolicyConfiguration#changed",O);const S=this.b;this.b=new b.$Fn;for(const s of S.keys)this.b.setValue(s,S.getValue(s));for(const[s,o]of O)o===void 0?this.b.removeValue(s):this.b.setValue(s,o);u&&this.a.fire(this.b)}}};e.$Nn=E,e.$Nn=E=pe([ie(1,k.$mn),ie(2,c.$bj)],E)}),define(te[133],ne([0,1,8,4,2,17,25,66,132,38]),function(J,e,L,N,D,A,j,b,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=void 0;class k extends D.$Rc{constructor(d,f,E,y){super(),this.j=d,this.h=this.B(new N.$Od),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new h.$Ln),this.c=E instanceof c.$on?new h.$Mn:this.B(new h.$Nn(this.b,E,y)),this.f=this.B(new b.$Hn(this.j,{},A.$ng,f)),this.a=new b.$In(this.b.configurationModel,this.c.configurationModel,new b.$Fn,new b.$Fn),this.g=this.B(new L.$8g(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:m,properties:u})=>this.n(m,u))),this.B(this.c.onDidChangeConfiguration(m=>this.r(m))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[d,f,E]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new b.$In(d,f,new b.$Fn,E)}getConfigurationData(){return this.a.toData()}getValue(d,f){const E=typeof d=="string"?d:void 0,y=(0,j.$oi)(d)?d:(0,j.$oi)(f)?f:{};return this.a.getValue(E,y,void 0)}updateValue(d,f,E,y){return Promise.reject(new Error("not supported"))}inspect(d){return this.a.inspect(d,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const d=await this.f.loadConfiguration();this.m(d)}m(d){const f=this.a.toData(),E=this.a.compareAndUpdateLocalUserConfiguration(d);this.s(E,f,2)}n(d,f){const E=this.a.toData(),y=this.a.compareAndUpdateDefaultConfiguration(d,f);this.s(y,E,7)}r(d){const f=this.a.toData(),E=this.a.compareAndUpdatePolicyConfiguration(d);this.s(E,f,7)}s(d,f,E){const y=new b.$Kn(d,{data:f},this.a);y.source=E,y.sourceConfig=this.t(E),this.h.fire(y)}t(d){switch(d){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$On=k}),define(te[67],ne([0,1,15]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3k=e.$2k=e.$1k=e.$Zk=e.$Yk=void 0;function N(c){return c.scheme===L.Schemas.vscodeRemote?c.authority:void 0}e.$Yk=N;function D(c){if(!c)return;const k=c.indexOf("+");return k<0?c:c.substr(0,k)}e.$Zk=D;function A(c){return`/${c.quality??"oss"}-${c.commit??"dev"}`}e.$1k=A;function j(c){const{host:k,port:I}=h(c);if(typeof I>"u")throw new Error("Remote authority doesn't contain a port!");return{host:k,port:I}}e.$2k=j;function b(c,k){let{host:I,port:d}=h(c);return typeof d>"u"&&(d=k),{host:I,port:d}}e.$3k=b;function h(c){const k=c.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(k)return{host:k[1],port:parseInt(k[2],10)};const I=c.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const d=c.match(/(.*):(\d+)$/);return d?{host:d[1],port:parseInt(d[2],10)}:{host:c,port:void 0}}}),define(te[37],ne([0,1,29,10,67]),function(J,e,L,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.TargetPlatform=e.ExtensionType=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=void 0,e.$4l="extensions.user.cache",e.$5l="extensions.builtin.cache",e.$6l="undefined_publisher",e.$7l=["ui","workspace","web"];function A(y){if(typeof y=="object"&&y!==null&&y.supported!==!0)return y.description}e.$8l=A,e.$9l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var j;(function(y){y[y.System=0]="System",y[y.User=1]="User"})(j||(e.ExtensionType=j={}));var b;(function(y){y.WIN32_X64="win32-x64",y.WIN32_ARM64="win32-arm64",y.LINUX_X64="linux-x64",y.LINUX_ARM64="linux-arm64",y.LINUX_ARMHF="linux-armhf",y.ALPINE_X64="alpine-x64",y.ALPINE_ARM64="alpine-arm64",y.DARWIN_X64="darwin-x64",y.DARWIN_ARM64="darwin-arm64",y.WEB="web",y.UNIVERSAL="universal",y.UNKNOWN="unknown",y.UNDEFINED="undefined"})(b||(e.TargetPlatform=b={}));class h{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,u){if(typeof m>"u"||m===null)return typeof u>"u"||u===null;if(typeof u>"u"||u===null)return!1;if(typeof m=="string"||typeof u=="string"){const $=typeof m=="string"?m:m.value,O=typeof u=="string"?u:u.value;return L.$3e($,O)}return m._lower===u._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.$0l=h;class c{get size(){return this.c.size}constructor(m){if(this.c=new Set,m)for(const u of m)this.add(u)}add(m){this.c.add(h.toKey(m))}delete(m){return this.c.delete(h.toKey(m))}has(m){return this.c.has(h.toKey(m))}}e.$$l=c;class k{constructor(){this.c=new Map}clear(){this.c.clear()}delete(m){this.c.delete(h.toKey(m))}get(m){return this.c.get(h.toKey(m))}has(m){return this.c.has(h.toKey(m))}set(m,u){this.c.set(h.toKey(m),u)}values(){return this.c.values()}forEach(m){this.c.forEach(m)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$_l=k;function I(y){return d(y)}e.$am=I;function d(y){return y.contributes&&y.contributes.localizations?y.contributes.localizations.length>0:!1}e.$bm=d;function f(y){return y.contributes&&y.contributes.authentication?y.contributes.authentication.length>0:!1}e.$cm=f;function E(y,m){if(m){const u=`onResolveRemoteAuthority:${(0,D.$Zk)(m)}`;return!!y.activationEvents?.includes(u)}return!1}e.$dm=E,e.$em=(0,N.$Th)("IBuiltinExtensionsScannerService")}),define(te[134],ne([0,1,2,37,12]),function(J,e,L,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kp=void 0;class A extends L.$Rc{constructor(b,h,c,k,I){super(),this.a=b,this.b=h,this.c=c,this.f=I,this.B(k.onDidInstallExtensions(d=>this.g(d))),this.B(k.onDidUninstallExtension(d=>this.h(d)))}g(b){for(const h of b)h.local&&this.invalidate(h.profileLocation)}h(b){b.error||this.invalidate(b.profileLocation)}async invalidate(b){if(b)for(const h of this.a.profiles)this.c.extUri.isEqual(h.extensionsResource,b)&&await this.j(h);else await this.j(this.a.defaultProfile)}async j(b){try{await this.b.del(this.c.extUri.joinPath(b.cacheHome,N.$4l))}catch(h){(0,D.$tk)(h)!==1&&this.f.error(h)}}}e.$Kp=A}),define(te[44],ne([0,1,14,9,2,103,43,10,6,36]),function(J,e,L,N,D,A,j,b,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=void 0,e.$Wo=(0,b.$Th)("requestService");class k{constructor(S){this.b=S}toJSON(){if(!this.a){const S=Object.create(null);for(const s in this.b)s.toLowerCase()==="authorization"||s.toLowerCase()==="proxy-authorization"?S[s]="*****":S[s]=this.b[s];this.a=S}return this.a}}class I extends D.$Rc{constructor(S){super(),this.b=0,this.a=S.createLogger("network",{name:(0,A.localize)(0,null),when:h.$sj.isEqualTo((0,h.$qj)(h.LogLevel.Trace)).serialize()})}async c(S,s,o){const t=`${S} #${++this.b}: ${s.url}`;this.a.trace(`${t} - begin`,s.type,new k(s.headers??{}));try{const i=await o();return this.a.trace(`${t} - end`,s.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${t} - error`,s.type,(0,N.$9)(i)),i}}}e.$Xo=I;function d(p){return p.res.statusCode&&p.res.statusCode>=200&&p.res.statusCode<300||p.res.statusCode===1223}e.$Yo=d;function f(p){return p.res.statusCode===204}e.$Zo=f;async function E(p){return f(p)?null:(await(0,L.$oe)(p.stream)).toString()}e.$1o=E;async function y(p){if(!d(p))throw new Error("Server returned "+p.res.statusCode);return E(p)}e.$2o=y;async function m(p){if(!d(p))throw new Error("Server returned "+p.res.statusCode);if(f(p))return null;const s=(await(0,L.$oe)(p.stream)).toString();try{return JSON.parse(s)}catch(o){throw o.message+=`:
`+s,o}}e.$3o=m;function u(p){O(p)}e.$4o=u;let $;function O(p){const S=c.$kn.as(j.$pn.Configuration),s=$;$={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:p,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,A.localize)(12,null),restricted:!0}}},S.updateConfigurations({add:[$],remove:s?[s]:[]})}O(1)}),define(te[135],ne([0,1,20,15,12,44]),function(J,e,L,N,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0N=void 0;let j=class{constructor(h,c){this.a=h,this.b=c}async download(h,c,k=L.CancellationToken.None){if(h.scheme===N.Schemas.file||h.scheme===N.Schemas.vscodeRemote){await this.b.copy(h,c);return}const I={type:"GET",url:h.toString(!0)},d=await this.a.request(I,k);if(d.res.statusCode===200)await this.b.writeFile(c,d.stream);else{const f=await(0,A.$2o)(d);throw new Error(`Expected 200, got back ${d.res.statusCode} instead.

${f}`)}}};e.$0N=j,e.$0N=j=pe([ie(0,A.$Wo),ie(1,D.$ck)],j)}),define(te[136],ne([0,1,137,3]),function(J,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=void 0;function D(j,b){return j.protocol==="http:"?b.HTTP_PROXY||b.http_proxy||null:j.protocol==="https:"&&(b.HTTPS_PROXY||b.https_proxy||b.HTTP_PROXY||b.http_proxy)||null}async function A(j,b,h={}){const c=(0,L.parse)(j),k=h.proxyUrl||D(c,b);if(!k)return null;const I=(0,L.parse)(k);if(!/^https?:$/.test(I.protocol||""))return null;const d={host:I.hostname||"",port:(I.port?+I.port:0)||(I.protocol==="https"?443:80),auth:I.auth,rejectUnauthorized:(0,N.$Ff)(h.strictSSL)?h.strictSSL:!0};return c.protocol==="http:"?new(await new Promise((f,E)=>{J(["http-proxy-agent"],f,E)})).HttpProxyAgent(k,d):new(await new Promise((f,E)=>{J(["https-proxy-agent"],f,E)})).HttpsProxyAgent(k,d)}e.$2q=A}),define(te[138],ne([0,1,58,16,104,20,34,9,13,28,84,172,8,72]),function(J,e,L,N,D,A,j,b,h,c,k,I,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xl=void 0;let E;async function y(u,$,O,p){return O["force-disable-user-env"]?($.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):h.$j?($.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,I.$Rl)(p)&&!O["force-user-env"]?($.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,I.$Rl)(p)?$.trace("resolveShellEnv(): running (--force-user-env)"):$.trace("resolveShellEnv(): running (macOS/Linux)"),E||(E=d.Promises.withAsyncBody(async(S,s)=>{const o=new A.$Yd;let t=1e4;const i=u.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(t=(0,f.$Sl)(i,1,120)*1e3);const n=setTimeout(()=>{o.dispose(!0),s(new Error((0,D.localize)(0,null)))},t);try{S(await m($,o.token))}catch(r){!(0,b.$3)(r)&&!o.token.isCancellationRequested?s(new Error((0,D.localize)(1,null,(0,j.$Ei)(r)))):S({})}finally{clearTimeout(n),o.dispose()}})),E)}e.$Xl=y;async function m(u,$){const O=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",O);const p=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",p);const S=(0,c.$fg)().replace(/-/g,"").substr(0,12),s=new RegExp(S+"({.*})"+S),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};u.trace("getUnixShellEnvironment#env",o);const t=await(0,k.$Hl)(h.OS,o);return u.trace("getUnixShellEnvironment#shell",t),new Promise((i,n)=>{if($.isCancellationRequested)return n(new b.$4);const r=(0,N.$mc)(t);let l,P;const v=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(r)?(l=`& '${process.execPath}' ${v} -p '''${S}'' + JSON.stringify(process.env) + ''${S}'''`,P=["-Login","-Command"]):r==="nu"?(l=`^'${process.execPath}' ${v} -p '"${S}" + JSON.stringify(process.env) + "${S}"'`,P=["-i","-l","-c"]):(l=`'${process.execPath}' ${v} -p '"${S}" + JSON.stringify(process.env) + "${S}"'`,r==="tcsh"||r==="csh"?P=["-ic"]:P=["-i","-l","-c"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(P),l);const w=(0,L.spawn)(t,[...P,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});$.onCancellationRequested(()=>(w.kill(),n(new b.$4))),w.on("error",_=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,j.$Ei)(_)),n(_)});const R=[];w.stdout.on("data",_=>R.push(_));const B=[];w.stderr.on("data",_=>B.push(_)),w.on("close",(_,ee)=>{const oe=Buffer.concat(R).toString("utf8");u.trace("getUnixShellEnvironment#raw",oe);const se=Buffer.concat(B).toString("utf8");if(se.trim()&&u.trace("getUnixShellEnvironment#stderr",se),_||ee)return n(new Error((0,D.localize)(2,null,_,ee)));const ue=s.exec(oe),ce=ue?ue[1]:"{}";try{const re=JSON.parse(ce);O?re.ELECTRON_RUN_AS_NODE=O:delete re.ELECTRON_RUN_AS_NODE,p?re.ELECTRON_NO_ATTACH_CONSOLE=p:delete re.ELECTRON_NO_ATTACH_CONSOLE,delete re.VSCODE_RESOLVING_ENVIRONMENT,delete re.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",re),i(re)}catch(re){u.error("getUnixShellEnvironment#errorCaught",(0,j.$Ei)(re)),n(re)}})})}}),define(te[139],ne([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MN=e.$LN=void 0,e.$LN=(0,L.$Th)("stateReadService"),e.$MN=(0,L.$Th)("stateService")}),define(te[68],ne([0,1,8,14,2,3,18,12,6]),function(J,e,L,N,D,A,j,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PN=e.$ON=e.$NN=e.SaveStrategy=void 0;var c;(function(f){f[f.IMMEDIATE=0]="IMMEDIATE",f[f.DELAYED=1]="DELAYED"})(c||(e.SaveStrategy=c={}));class k extends D.$Rc{constructor(E,y,m,u){super(),this.h=E,this.j=y,this.m=m,this.n=u,this.a=Object.create(null),this.b="",this.c=this.B(new L.$Sg(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(E){E.fileOperationResult!==1&&this.m.error(E)}}getItem(E,y){const m=this.a[E];return(0,A.$If)(m)?y:m}setItem(E,y){this.setItems([{key:E,data:y}])}setItems(E){let y=!1;for(const{key:m,data:u}of E)this.a[m]!==u&&((0,A.$If)(u)?(0,A.$Gf)(this.a[m])||(this.a[m]=void 0,y=!0):(this.a[m]=u,y=!0));y&&this.s()}removeItem(E){(0,A.$Gf)(this.a[E])||(this.a[E]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const E=JSON.stringify(this.a,null,4);if(E!==this.b)try{await this.n.writeFile(this.h,N.$ce.fromString(E),{atomic:{postfix:".vsctmp"}}),this.b=E}catch(y){this.m.error(y)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$NN=k;let I=class extends D.$Rc{constructor(E,y,m,u){super(),this.a=this.B(new k(y.stateResource,E,m,u))}async init(){await this.a.init()}getItem(E,y){return this.a.getItem(E,y)}};e.$ON=I,e.$ON=I=pe([ie(1,j.$1h),ie(2,h.$bj),ie(3,b.$ck)],I);class d extends I{setItem(E,y){this.a.setItem(E,y)}setItems(E){this.a.setItems(E)}removeItem(E){this.a.removeItem(E)}close(){return this.a.close()}}e.$PN=d}),define(te[69],ne([0,1,13,35,28]),function(J,e,L,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mo=e.$lo=void 0;function A(h){if(L.$u===2&&/^penguin(\.|$)/i.test(h))return"chromebook"}function j(h,c,k,I,d,f,E,y,m){const u=Object.create(null);u["common.machineId"]=f,u["common.sqmId"]=E,u.sessionID=(0,D.$fg)()+Date.now(),u.commitHash=I,u.version=d,u["common.platformVersion"]=(h||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=(0,L.$i)(L.$u),u["common.nodePlatform"]=N.$cc,u["common.nodeArch"]=k,u["common.product"]=m||"desktop",y&&(u["common.msftInternal"]=y);let $=0;const O=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-O,enumerable:!0},"common.sequence":{get:()=>$++,enumerable:!0}}),L.$m&&(u["common.snap"]="true");const p=A(c);return p&&(u["common.platformDetail"]=p),u}e.$lo=j;function b(h){const c=N.env.USERDNSDOMAIN;if(!c)return!1;const k=c.toLowerCase();return h.some(I=>k===I)}e.$mo=b}),define(te[26],ne([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$ql=e.$pl=e.$ol=e.$nl=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=e.$hl=e.$gl=void 0,e.$gl=(0,L.$Th)("telemetryService"),e.$hl=(0,L.$Th)("customEndpointTelemetryService"),e.$il="telemetry.currentSessionDate",e.$jl="telemetry.firstSessionDate",e.$kl="telemetry.lastSessionDate",e.$ll="telemetry.machineId",e.$ml="telemetry.sqmId",e.$nl="telemetry",e.$ol="telemetry.telemetryLevel",e.$pl="telemetry.enableCrashReporter",e.$ql="telemetry.enableTelemetry";var N;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(N||(e.TelemetryLevel=N={}));var D;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(D||(e.TelemetryConfiguration=D={}))}),define(te[39],ne([0,1,30,3,4,25,67,69,26]),function(J,e,L,N,D,A,j,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=void 0;class c{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$no=c;class k{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$oo=k,e.$po=new k;class I{async publicLog(n,r,l){}async publicLogError(n,r,l){}}e.$qo=I,e.$ro="telemetry",e.$so="extensionTelemetryLog",e.$to={log:()=>null,flush:()=>Promise.resolve(null)};function d(i,n){return D.Event.debounce(n.onDidChangeConfiguration,(l,P)=>{const v=l?new Set([...l.affectedKeys,...P.affectedKeys]):P.affectedKeys;return{...P,affectedKeys:v}},1e3,!0)(l=>{l.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,A.$qi)(l.source),configurationKeys:Array.from(l.affectedKeys)})})}e.$uo=d;function f(i,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!i.enableTelemetry)}e.$vo=f;function E(i,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$wo=E;function y(i){const n=i.getValue(h.$ol),r=i.getValue(h.$pl);if(i.getValue(h.$ql)===!1||r===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$xo=y;function m(i){const n={},r={},l={};O(i,l);for(let P in l){P=P.length>150?P.substr(P.length-149):P;const v=l[P];typeof v=="number"?r[P]=v:typeof v=="boolean"?r[P]=v?1:0:typeof v=="string"?(v.length>8192&&console.warn(`Telemetry property: ${P} has been trimmed to 8192, the original length is ${v.length}`),n[P]=v.substring(0,8191)):typeof v<"u"&&v!==null&&(n[P]=v)}return{properties:n,measurements:r}}e.$yo=m;const u=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function $(i){if(!i)return"none";const n=(0,j.$Zk)(i);return u.has(n)?n:"other"}e.$zo=$;function O(i,n,r=0,l){if(i)for(const P of Object.getOwnPropertyNames(i)){const v=i[P],w=l?l+P:P;Array.isArray(v)?n[w]=(0,L.$dn)(v):v instanceof Date?n[w]=v.toISOString():(0,N.$Bf)(v)?r<2?O(v,n,r+1,w+"."):n[w]=(0,L.$dn)(v):n[w]=v}}function p(i,n){const r=i.msftInternalDomains||[],l=n.getValue("telemetry.internalTesting");return(0,b.$mo)(r)||l}e.$Ao=p;function S(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$Bo=S;function s(i,n){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let r=i;const l=[];for(const R of n)for(;;){const B=R.exec(i);if(!B)break;l.push([B.index,R.lastIndex])}const P=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,v=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let w=0;for(r="";;){const R=v.exec(i);if(!R)break;const B=l.some(([_,ee])=>R.index<ee&&_<v.lastIndex);!P.test(R[0])&&!B&&(r+=i.substring(w,R.index)+"<REDACTED: user-file-path>",w=v.lastIndex)}return w<i.length&&(r+=i.substr(w)),r}function o(i){if(!i)return i;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of n)if(r.regex.test(i))return`<REDACTED: ${r.label}>`;return i}function t(i,n){return(0,L.$an)(i,r=>{if(r instanceof c||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let l=r.replaceAll("%20"," ");l=s(l,n);for(const P of n)l=l.replace(P,"");return l=o(l),l}})}e.$Co=t}),define(te[27],ne([0,1,29,21,37,13,11,9,35,39]),function(J,e,L,N,D,A,j,b,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=void 0;function k(t,i){return t.uuid&&i.uuid?t.uuid===i.uuid:t.id===i.id?!0:(0,L.$Xe)(t.id,i.id)===0}e.$Do=k;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class d{static create(i){const n=i.manifest?i.manifest.version:i.version,r=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new d(i.identifier,n,r)}static parse(i){const n=I.exec(i);return n&&n[1]&&n[2]?new d({id:n[1]},n[2],n[4]||void 0):null}constructor(i,n,r="undefined"){this.version=n,this.targetPlatform=r,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof d?k(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$Eo=d;const f=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function E(t){const i=f.exec(t);return i&&i[1]?[m(i[1]),i[2]]:[m(t),void 0]}e.$Fo=E;function y(t,i){return`${t}.${i}`}e.$Go=y;function m(t){return t.toLowerCase()}e.$Ho=m;function u(t,i){return m(y(t??D.$6l,i))}e.$Io=u;function $(t,i){const n=[],r=l=>{for(const P of n)if(P.some(v=>k(i(v),i(l))))return P;return null};for(const l of t){const P=r(l);P?P.push(l):n.push([l])}return n}e.$Jo=$;function O(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.$Ko=O;function p(t){return{id:new c.$no(t.identifier.id),name:new c.$no(t.name),galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),isSigned:t.isSigned,...t.telemetryData}}e.$Lo=p,e.$Mo=new D.$0l("pprice.better-merge");function S(t,i){const n=[],r=i.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const l=r.shift();if(l&&n.every(P=>!k(P.identifier,{id:l}))){const P=t.filter(v=>k(v.identifier,{id:l}));P.length===1&&(n.push(P[0]),r.push(...P[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.$No=S;async function s(t,i){if(!A.$l)return!1;let n;try{n=(await t.readFile(j.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await t.readFile(j.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){i.debug("Error while getting the os-release file.",(0,b.$9)(l))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(t,i){const n=await s(t,i),r=(0,N.$0n)(n?"alpine":A.$u,h.$dc);return i.debug("ComputeTargetPlatform:",r),r}e.$Oo=o}),define(te[140],ne([0,1,20,9,15,17,42,11,93,21,27,37]),function(J,e,L,N,D,A,j,b,h,c,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kp=void 0;const d=m=>(0,h.localize)(0,null,m),f=(0,h.localize)(1,null,"ms-dotnettools.csharp");function E(m,u){return u?`${m.publisher}.${m.name}@${m.version}`:`${m.publisher}.${m.name}`}let y=class{constructor(u,$,O){this.a=u,this.b=$,this.d=O}get f(){}async listExtensions(u,$,O){let p=await this.b.getInstalled(1,O);const S=I.$9l.map(o=>o.toLowerCase());if($&&$!==""){if(S.indexOf($.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}p=p.filter(o=>o.manifest.categories?o.manifest.categories.map(i=>i.toLowerCase()).indexOf($.toLowerCase())>-1:!1)}else if($===""){this.a.info("Possible Categories: "),S.forEach(o=>{this.a.info(o)});return}this.f&&this.a.info((0,h.localize)(2,null,this.f)),p=p.sort((o,t)=>o.identifier.id.localeCompare(t.identifier.id));let s;for(const o of p)s!==o.identifier.id&&(s=o.identifier.id,this.a.info(E(o.manifest,u)))}async installExtensions(u,$,O,p){const S=[];try{const s=[];u.length&&this.a.info(this.f?(0,h.localize)(3,null,this.f):(0,h.localize)(4,null));const o=[];let t=[];const i=(r,l,P)=>{t.push({id:r,version:l!=="prerelease"?l:void 0,installOptions:{...O,isBuiltin:P,installPreReleaseVersion:l==="prerelease"||O.installPreReleaseVersion}})};for(const r of u)if(r instanceof b.URI)o.push({vsix:r,installOptions:O});else{const[l,P]=(0,k.$Fo)(r);i(l,P,!1)}for(const r of $)if(r instanceof b.URI)o.push({vsix:r,installOptions:{...O,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[l,P]=(0,k.$Fo)(r);i(l,P,!0)}const n=await this.b.getInstalled(1,O.profileLocation);if(o.length&&await Promise.all(o.map(async({vsix:r,installOptions:l})=>{try{const P=await this.g(r,l,p,n);P&&s.push(P)}catch(P){this.a.error(P),S.push(r.toString())}})),t.length&&(t=t.filter(({id:r,version:l})=>{const P=n.find(v=>(0,k.$Do)(v.identifier,{id:r}));if(P){if(!p&&(!l||l==="prerelease"&&P.preRelease))return this.a.info((0,h.localize)(5,null,r,P.manifest.version,r)),!1;if(l&&P.manifest.version===l)return this.a.info((0,h.localize)(6,null,`${r}@${l}`)),!1}return!0}),t.length)){const r=await this.h(t);await Promise.all(t.map(async l=>{const P=r.get(l.id.toLowerCase());if(P)try{const v=await this.j(l,P,n);v&&s.push(v)}catch(v){this.a.error(v.message||v.stack||v),S.push(l.id)}else this.a.error(`${d(l.version?`${l.id}@${l.version}`:l.id)}
${f}`),S.push(l.id)}))}}catch(s){throw this.a.error((0,h.localize)(7,null,(0,N.$9)(s))),s}if(S.length)throw new Error((0,h.localize)(8,null,S.join(", ")))}async g(u,$,O,p){const S=await this.b.getManifest(u);if(!S)throw new Error("Invalid vsix");if(await this.l(S,O,$.profileLocation,p))try{return await this.b.install(u,$),this.a.info((0,h.localize)(9,null,(0,A.$tg)(u))),S}catch(o){if((0,N.$3)(o))return this.a.info((0,h.localize)(10,null,(0,A.$tg)(u))),null;throw o}return null}async h(u){const $=new Map,O=u.some(s=>s.installOptions.installPreReleaseVersion),p=await this.b.getTargetPlatform(),S=[];for(const s of u)c.$3n.test(s.id)&&S.push({...s,preRelease:O});if(S.length){const s=await this.d.getExtensions(S,{targetPlatform:p},L.CancellationToken.None);for(const o of s)$.set(o.identifier.id.toLowerCase(),o)}return $}async j({id:u,version:$,installOptions:O},p,S){const s=await this.d.getManifest(p,L.CancellationToken.None);if(s&&!this.k(s))return null;const o=S.find(t=>(0,k.$Do)(t.identifier,p.identifier));if(o){if(p.version===o.manifest.version)return this.a.info((0,h.localize)(11,null,$?`${u}@${$}`:u)),null;this.a.info((0,h.localize)(12,null,u,p.version))}try{O.isBuiltin?this.a.info($?(0,h.localize)(13,null,u,$):(0,h.localize)(14,null,u)):this.a.info($?(0,h.localize)(15,null,u,$):(0,h.localize)(16,null,u));const t=await this.b.installFromGallery(p,{...O,installGivenVersion:!!$});return this.a.info((0,h.localize)(17,null,u,t.manifest.version)),s}catch(t){if((0,N.$3)(t))return this.a.info((0,h.localize)(18,null,u)),null;throw t}}k(u){return!0}async l(u,$,O,p){if(!$){const S={id:(0,k.$Io)(u.publisher,u.name)},s=p.find(o=>(0,k.$Do)(S,o.identifier)&&(0,j.gt)(o.manifest.version,u.version));if(s)return this.a.info((0,h.localize)(19,null,s.identifier.id,s.manifest.version,u.version)),!1}return this.k(u)}async uninstallExtensions(u,$,O){const p=async s=>{if(s instanceof b.URI){const o=await this.b.getManifest(s);return E(o)}return s},S=[];for(const s of u){const o=await p(s),i=(await this.b.getInstalled(void 0,O)).filter(n=>(0,k.$Do)(n.identifier,{id:o}));if(!i.length)throw new Error(`${this.m(o)}
${f}`);if(i.some(n=>n.type===0)){this.a.info((0,h.localize)(20,null,o));return}if(!$&&i.some(n=>n.isBuiltin)){this.a.info((0,h.localize)(21,null,o));return}this.a.info((0,h.localize)(22,null,o));for(const n of i)await this.b.uninstall(n,{profileLocation:O}),S.push(n);this.f?this.a.info((0,h.localize)(23,null,o,this.f)):this.a.info((0,h.localize)(24,null,o))}}async locateExtension(u){const $=await this.b.getInstalled();u.forEach(O=>{$.forEach(p=>{if(p.identifier.id===O&&p.location.scheme===D.Schemas.file){this.a.info(p.location.fsPath);return}})})}m(u){return this.f?(0,h.localize)(25,null,u,this.f):(0,h.localize)(26,null,u)}};e.$kp=y,e.$kp=y=pe([ie(1,c.$do),ie(2,c.$bo)],y)}),define(te[141],ne([0,1,4,2,31,27,37]),function(J,e,L,N,D,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lp=void 0;class b extends N.$Rc{constructor(c,k,I,d,f,E,y){super(),this.f=c,this.g=k,this.h=I,this.j=d,this.m=f,this.n=E,this.r=y,this.a=this.B(new L.$Od),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new N.$Zc),this.s().then(null,m=>y.error(m))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(c=>this.u(c.added))),this.B(this.j.onAddExtensions(c=>this.w(c))),this.B(this.j.onDidAddExtensions(c=>this.y(c))),this.B(this.j.onRemoveExtensions(c=>this.z(c))),this.B(this.j.onDidRemoveExtensions(c=>this.C(c))),this.B(this.n.onDidFilesChange(c=>this.D(c)))}async u(c){try{c.length&&await Promise.all(c.map(k=>(this.c.set(k.id,(0,N.$Oc)(this.n.watch(this.m.extUri.dirname(k.extensionsResource)),this.n.watch(k.extensionsResource))),this.G(k.extensionsResource))))}catch(k){throw this.r.error(k),k}}async w(c){for(const k of c.extensions)this.I(this.L(k.identifier,k.version),c.profileLocation)}async y(c){for(const k of c.extensions){const I=this.L(k.identifier,k.version);c.error?this.J(I,c.profileLocation):this.I(I,c.profileLocation)}}async z(c){for(const k of c.extensions)this.J(this.L(k.identifier,k.version),c.profileLocation)}async C(c){const k=[],I=[];for(const d of c.extensions){const f=this.L(d.identifier,d.version);c.error?this.I(f,c.profileLocation):(this.J(f,c.profileLocation),this.b.has(f)||(this.r.debug("Extension is removed from all profiles",d.identifier.id,d.version),I.push(this.f.scanInstalledExtensionAtLocation(d.location).then(E=>{E?k.push(E):this.r.info("Extension not found at the location",d.location.toString())},E=>this.r.error(E)))))}try{await Promise.all(I),k.length&&await this.H(k)}catch(d){this.r.error(d)}}D(c){for(const k of this.h.profiles)c.contains(k.extensionsResource,0,1)&&this.F(k.extensionsResource)}async F(c){const k=[],I=[],d=await this.j.scanProfileExtensions(c),f=new Set,E=new Set;for(const[y,m]of this.b)m.has(c)&&E.add(y);for(const y of d){const m=this.L(y.identifier,y.version);f.add(m),E.has(m)||(k.push(y.identifier),this.I(m,c))}for(const y of E)if(!f.has(y)){const m=this.M(y);m&&(I.push(m.identifier),this.J(y,c))}(k.length||I.length)&&this.a.fire({added:k.length?{extensions:k,profileLocation:c}:void 0,removed:I.length?{extensions:I,profileLocation:c}:void 0})}async G(c){const k=await this.j.scanProfileExtensions(c);for(const I of k)this.I(this.L(I.identifier,I.version),c)}async H(c){c||(c=(await this.f.scanAllUserInstalledExtensions()).filter(I=>!this.b.has(this.L(I.identifier,I.manifest.version)))),c.length&&await this.f.markAsUninstalled(...c)}I(c,k){let I=this.b.get(c);I||this.b.set(c,I=new D.$Ac(d=>this.m.extUri.getComparisonKey(d))),I.add(k)}J(c,k){const I=this.b.get(c);I&&I.delete(k),I?.size||this.b.delete(c)}L(c,k){return`${j.$0l.toKey(c.id)}@${k}`}M(c){const[k,I]=(0,A.$Fo)(c);return I?{identifier:{id:k},version:I}:void 0}}e.$Lp=b}),define(te[142],ne([0,1,113,39]),function(J,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ep=void 0;async function D(A,j,b,h,c,k,I){const d={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${j.nameShort})`};if((0,N.$vo)(j,b)&&(0,N.$xo)(h)===3){const f=await(0,L.$dp)(b,c,k);d["X-Market-User-Id"]=f,d["VSCode-SessionId"]=I.machineId||f}return d}e.$ep=D}),define(te[143],ne([0,1,173,19,8,2,15,16,24,18,21,27,6,64,11]),function(J,e,L,N,D,A,j,b,h,c,k,I,d,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=void 0;let y=class extends f.$Xq{constructor(O,p,S,s){super(S),this.h=O,this.j=s,this.g=this.B(new m(p,s)),this.h.registerParticipant({postInstall:async o=>this.m(o),postUninstall:async o=>this.n(o)})}async getBuiltInExtensionTranslationsUri(O,p){const s=(await this.g.getLanguagePacks())[p];if(!s){this.j.warn(`No language pack found for ${p}`);return}const o=s.translations[O];return o?E.URI.file(o):void 0}async getInstalledLanguages(){const O=await this.g.getLanguagePacks(),p=Object.keys(O).map(S=>{const s=O[S];return{...this.f(S,s.label),extensionId:s.extensions[0].extensionIdentifier.id}});return p.push(this.f("en","English")),p.sort((S,s)=>S.label.localeCompare(s.label)),p}async m(O){O&&O.manifest&&O.manifest.contributes&&O.manifest.contributes.localizations&&O.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",O.identifier.id),await this.update())}async n(O){const p=await this.g.getLanguagePacks();Object.keys(p).some(S=>p[S]&&p[S].extensions.some(s=>(0,I.$Do)(s.extensionIdentifier,O.identifier)))&&(this.j.info("Removing language packs from the extension",O.identifier.id),await this.update())}async update(){const[O,p]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),S=await this.g.update(p);return!(0,N.$tb)(Object.keys(O),Object.keys(S))}};e.$Yq=y,e.$Yq=y=pe([ie(0,k.$do),ie(1,c.$2h),ie(2,k.$bo),ie(3,d.$bj)],y);let m=class extends A.$Rc{constructor(O,p){super(),this.j=p,this.c={},this.f=(0,b.$ic)(O.userDataPath,"languagepacks.json"),this.g=new D.$3g}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(O){return this.s(p=>{Object.keys(p).forEach(S=>delete p[S]),this.m(p,...O)}).then(()=>this.c)}m(O,...p){for(const S of p)S&&S.manifest&&S.manifest.contributes&&S.manifest.contributes.localizations&&S.manifest.contributes.localizations.length&&this.n(O,S);Object.keys(O).forEach(S=>this.r(O[S]))}n(O,p){const S=p.identifier,s=p.manifest.contributes&&p.manifest.contributes.localizations?p.manifest.contributes.localizations:[];for(const o of s)if(p.location.scheme===j.Schemas.file&&u(o)){let t=O[o.languageId];t||(t={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},O[o.languageId]=t);const i=t.extensions.filter(n=>(0,I.$Do)(n.extensionIdentifier,S))[0];i?i.version=p.manifest.version:t.extensions.push({extensionIdentifier:S,version:p.manifest.version});for(const n of o.translations)t.translations[n.id]=(0,b.$ic)(p.location.fsPath,n.path)}}r(O){if(O){const p=(0,L.createHash)("md5");for(const S of O.extensions)p.update(S.extensionIdentifier.uuid||S.extensionIdentifier.id).update(S.version);O.hash=p.digest("hex")}}s(O=()=>null){return this.g.queue(()=>{let p=null;return h.Promises.readFile(this.f,"utf8").then(void 0,S=>S.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(S)).then(S=>{try{return JSON.parse(S)}catch{return{}}}).then(S=>(p=O(S),S)).then(S=>{for(const o of Object.keys(S))S[o]||delete S[o];this.c=S,this.h=!0;const s=JSON.stringify(this.c);return this.j.debug("Writing language packs",s),h.Promises.writeFile(this.f,s)}).then(()=>p,S=>this.j.error(S))})}};m=pe([ie(0,c.$2h),ie(1,d.$bj)],m);function u($){if(typeof $.languageId!="string"||!Array.isArray($.translations)||$.translations.length===0)return!1;for(const O of $.translations)if(typeof O.id!="string"||typeof O.path!="string")return!1;return!($.languageName&&typeof $.languageName!="string"||$.localizedLanguageName&&typeof $.localizedLanguageName!="string")}}),define(te[144],ne([0,1,81,9,30,39]),function(J,e,L,N,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HN=void 0;const j="https://mobile.events.data.microsoft.com/OneCollector/1.0",b="https://mobile.events.data.microsoft.com/ping";async function h(k,I,d){const f=await(0,L.$LC)("@microsoft/1ds-core-js","dist/ms.core.js"),E=await(0,L.$LC)("@microsoft/1ds-post-js","dist/ms.post.js"),y=new f.AppInsightsCore,m=new E.PostChannel,u={instrumentationKey:k,endpointUrl:j,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[m]]};if(d){u.extensionConfig={};const $={alwaysUseXhrOverride:!0,httpXHROverride:d};u.extensionConfig[m.identifier]=$}return y.initialize(u,[]),y.addTelemetryInitializer($=>{I&&($.ext=$.ext??{},$.ext.utc=$.ext.utc??{},$.ext.utc.flags=8462029)}),y}class c{constructor(I,d,f,E,y){this.e=I,this.f=d,this.g=f,this.h=y,this.c=j,this.d=b,this.g||(this.g={}),typeof E=="function"?this.a=E():this.a=E,this.b=null}i(I){if(this.a){if(typeof this.a!="string"){I(this.a);return}this.b||(this.b=h(this.a,this.e,this.h)),this.b.then(d=>{I(d)},d=>{(0,N.$Z)(d),console.error(d)})}}log(I,d){if(!this.a)return;d=(0,D.$bn)(d,this.g),d=(0,A.$yo)(d);const f=this.f+"/"+I;try{this.i(E=>{E.pluginVersionString=d?.properties.version??"Unknown",E.track({name:f,baseData:{name:f,properties:d?.properties,measurements:d?.measurements}})})}catch{}}flush(){return this.a?new Promise(I=>{this.i(d=>{d.unload(!0,()=>{this.a=void 0,I(void 0)})})}):Promise.resolve(void 0)}}e.$HN=c}),define(te[145],ne([0,1,2,30,13,29,105,25,43,146,32,36,26,39]),function(J,e,L,N,D,A,j,b,h,c,k,I,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=void 0;let E=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(u,$,O){this.k=$,this.l=O,this.d={},this.i=new L.$Qc,this.j=[],this.b=u.appenders,this.c=u.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=u.piiPaths||[],this.g=3,this.h=!!u.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const p of this.f)this.j.push(new RegExp((0,A.$Ge)(p),"gi")),p.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.$Ge)(p.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(p=>{(p.affectsConfiguration(d.$ol)||p.affectsConfiguration(d.$ql)||p.affectsConfiguration(d.$pl))&&this.m()}))}setExperimentProperty(u,$){this.d[u]=$}m(){let u=(0,f.$xo)(this.k);const $=this.l.enabledTelemetryLevels;if($){this.h=this.sendErrorTelemetry?$.error:!1;const O=$.usage?3:$.error?2:0;u=Math.min(u,O)}this.g=u}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(u,$,O){this.g<$||(O=(0,N.$bn)(O,this.d),O=(0,f.$Co)(O,this.j),O=(0,N.$bn)(O,this.c),this.b.forEach(p=>p.log(u,O)))}publicLog(u,$){this.n(u,3,$)}publicLog2(u,$){this.publicLog(u,$)}publicLogError(u,$){this.h&&this.n(u,2,$)}publicLogError2(u,$){this.publicLogError(u,$)}};e.$5q=E,e.$5q=E=pe([ie(1,b.$ni),ie(2,k.$tj)],E);function y(){const m=(0,j.localize)(0,null,c.default.nameLong),u=c.default.privacyStatementUrl?(0,j.localize)(2,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,j.localize)(1,null,"https://aka.ms/vscode-telemetry"),$=D.$p?"":(0,j.localize)(3,null),O=(0,j.localize)(4,null),p=(0,j.localize)(5,null),S=(0,j.localize)(6,null),s=(0,j.localize)(7,null),o=`
|       | ${O} | ${p} | ${S} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,j.localize)(8,null);return`
${m} ${u} ${$}

&nbsp;

${s}
${o}

&nbsp;

${t}
`}I.$kn.as(h.$pn.Configuration).registerConfiguration({id:d.$nl,order:1,type:"object",title:(0,j.localize)(9,null),properties:{[d.$ol]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,j.localize)(10,null),(0,j.localize)(11,null),(0,j.localize)(12,null),(0,j.localize)(13,null)],markdownDescription:y(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),I.$kn.as(h.$pn.Configuration).registerConfiguration({id:d.$nl,order:110,type:"object",title:(0,j.localize)(14,null),properties:{[d.$ql]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,j.localize)(16,null,c.default.nameLong,c.default.privacyStatementUrl):(0,j.localize)(15,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,j.localize)(17,null,`\`#${d.$ol}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[147],ne([0,1,14,20,174,144]),function(J,e,L,N,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IN=void 0;async function j(k,I){const d=await I.request(k,N.CancellationToken.None),f=(await(0,L.$oe)(d.stream)).toString(),E=d.res.statusCode??200;return{headers:d.res.headers,statusCode:E,responseData:f}}async function b(k){const I={method:k.type,headers:k.headers};return new Promise((f,E)=>{const y=D.request(k.url??"",I,m=>{m.on("data",function(u){f({headers:m.headers,statusCode:m.statusCode??200,responseData:u.toString()})}),m.on("error",function(u){E(u)})});y.write(k.data,m=>{m&&E(m)}),y.end()})}async function h(k,I,d){const f=typeof I.data=="string"?I.data:new TextDecoder().decode(I.data),E={type:"POST",headers:{...I.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(I.data).toString()},url:I.urlString,data:f};try{const y=k?await j(E,k):await b(E);d(y.statusCode,y.headers,y.responseData)}catch{d(0,{})}}class c extends A.$HN{constructor(I,d,f,E,y){const m={sendPOST:(u,$)=>{h(I,u,$)}};super(d,f,E,y,m)}}e.$IN=c}),define(te[148],ne([0,1,16,24]),function(J,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y9b=void 0;async function D(A,j){const b=Object.create(null),h=(k,I)=>{const d=JSON.parse(k);b[I]=d};if(j){const k=[],I=await N.Promises.readdir(j);for(const f of I)try{(await N.Promises.stat((0,L.$ic)(j,f))).isDirectory()&&k.push(f)}catch{}const d=[];for(const f of k)(await N.Promises.readdir((0,L.$ic)(j,f))).filter(y=>y==="telemetry.json").length===1&&d.push(f);for(const f of d){const E=(await N.Promises.readFile((0,L.$ic)(j,f,"telemetry.json"))).toString();h(E,f)}}let c=(await N.Promises.readFile((0,L.$ic)(A,"telemetry-core.json"))).toString();return h(c,"vscode-core"),c=(await N.Promises.readFile((0,L.$ic)(A,"telemetry-extensions.json"))).toString(),h(c,"vscode-extensions"),JSON.stringify(b,null,4)}e.$y9b=D}),define(te[149],ne([0,1,13,82,26]),function(J,e,L,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R8b=e.$Q8b=void 0;async function A(b,h){let c=b.getItem(D.$ll);return(typeof c!="string"||L.$k&&c==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(c=await(0,N.$Wm)(h.error.bind(h))),c}e.$Q8b=A;async function j(b,h){let c=b.getItem(D.$ml);return typeof c!="string"&&(c=await(0,N.$Xm)(h.error.bind(h))),c}e.$R8b=j}),define(te[22],ne([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mk=void 0,e.$Mk=(0,L.$Th)("IUriIdentityService")}),define(te[150],ne([0,1,22,114,12,17,73,4,2]),function(J,e,L,N,D,A,j,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=void 0;class c{static{this._clock=0}constructor(d){this.uri=d,this.time=c._clock++}touch(){return this.time=c._clock++,this}}let k=class{constructor(d){this.g=d,this.c=new h.$Qc,this.f=2**16;const f=new Map,E=y=>{let m=f.get(y.scheme);return m===void 0&&(m=d.hasProvider(y)&&!this.g.hasCapability(y,1024),f.set(y.scheme,m)),m};this.c.add(b.Event.any(d.onDidChangeFileSystemProviderRegistrations,d.onDidChangeFileSystemProviderCapabilities)(y=>{f.delete(y.scheme)})),this.extUri=new A.$lg(E),this.d=new j.$Cr((y,m)=>this.extUri.compare(y,m,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(d){this.g.hasProvider(d)&&(d=(0,A.$xg)(d));const f=this.d.get(d);return f?f.touch().uri.with({fragment:d.fragment}):(this.d.set(d,new c(d)),this.h(),d)}h(){if(this.d.size<this.f)return;const d=[...this.d.entries()].sort((E,y)=>E[1].time<y[1].time?1:E[1].time>y[1].time?-1:0);c._clock=0,this.d.clear();const f=this.f*.5;for(let E=0;E<f;E++)this.d.set(d[E][0],d[E][1].touch())}};e.$Dr=k,e.$Dr=k=pe([ie(0,D.$ck)],k),(0,N.$Ar)(L.$Mk,k,1)}),define(te[151],ne([0,1,4,2,12,47,31]),function(J,e,L,N,D,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c9b=void 0;class b extends N.$Rc{constructor(c,k,I,d,f,E){super(),this.f=c,this.g=k,this.h=I,this.j=d,this.m=f,this.n=E,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new L.$Od),this.onDidChangeFile=this.a.event,this.b=A.$Zh.forUris(()=>!(this.capabilities&1024)),this.c=new j.$Ac(y=>this.m.extUri.getComparisonKey(this.t(y))),this.r(),this.B(d.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(y=>this.s(y)))}r(){this.c.clear();for(const c of this.j.profiles)this.c.add(c.settingsResource),this.c.add(c.keybindingsResource),this.c.add(c.tasksResource),this.c.add(c.extensionsResource)}open(c,k){return this.g.open(this.t(c),k)}close(c){return this.g.close(c)}read(c,k,I,d,f){return this.g.read(c,k,I,d,f)}write(c,k,I,d,f){return this.g.write(c,k,I,d,f)}watch(c,k){this.b.set(c,c);const I=this.g.watch(this.t(c),k);return(0,N.$Pc)(()=>{this.b.delete(c),I.dispose()})}stat(c){return this.g.stat(this.t(c))}mkdir(c){return this.g.mkdir(this.t(c))}rename(c,k,I){return this.g.rename(this.t(c),this.t(k),I)}readFile(c,k){return this.g.readFile(this.t(c),k)}readFileStream(c,k,I){return this.g.readFileStream(this.t(c),k,I)}readdir(c){return this.g.readdir(this.t(c))}enforceAtomicReadFile(c){return this.c.has(c)}writeFile(c,k,I){return this.g.writeFile(this.t(c),k,I)}enforceAtomicWriteFile(c){return this.c.has(c)?{postfix:".vsctmp"}:!1}delete(c,k){return this.g.delete(this.t(c),k)}copy(c,k,I){if((0,D.$gk)(this.g))return this.g.copy(this.t(c),this.t(k),I);throw new Error("copy not supported")}cloneFile(c,k){if((0,D.$hk)(this.g))return this.g.cloneFile(this.t(c),this.t(k));throw new Error("clone not supported")}s(c){const k=[];for(const I of c){if(I.resource.scheme!==this.f)continue;const d=this.u(I.resource);this.b.findSubstr(d)&&k.push({resource:d,type:I.type,cId:I.cId})}k.length&&(this.n.debug("User data changed"),this.a.fire(k))}t(c){return c.with({scheme:this.f})}u(c){return c.with({scheme:this.h})}}e.$c9b=b}),define(te[152],ne([0,1,107,16,47,17,11,10,15]),function(J,e,L,N,D,A,j,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.WorkbenchState=e.$0h=e.$9h=e.$8h=e.$7h=e.$6h=e.$5h=e.$4h=e.$3h=void 0,e.$3h=(0,b.$Th)("contextService");function c(i){const n=i;return typeof n?.id=="string"&&j.URI.isUri(n.uri)}e.$4h=c;function k(i){return typeof i?.id=="string"&&!c(i)&&!d(i)}e.$5h=k,e.$6h={id:"ext-dev"},e.$7h={id:"empty-window"};function I(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,N.$mc)(i)}:n?e.$6h:e.$7h;const r=i;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.$8h=I;function d(i){const n=i;return typeof n?.id=="string"&&j.URI.isUri(n.configPath)}e.$9h=d;function f(i){const n=i;if(n?.uri)return{id:n.id,uri:j.URI.revive(n.uri)};const r=i;if(r?.configPath)return{id:r.id,configPath:j.URI.revive(r.configPath)};if(i?.id)return{id:i.id}}e.$0h=f;var E;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(E||(e.WorkbenchState=E={}));function y(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.$$h=y;function m(i){const n=i;return!!(n&&typeof n=="object"&&j.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.$_h=m;class u{constructor(n,r,l,P,v){this.h=n,this.j=l,this.k=P,this.l=v,this.c=D.$Zh.forUris(this.l,()=>!0),this.folders=r}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=D.$Zh.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$ai=u;class ${constructor(n,r){this.raw=r,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,A.$wg)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$bi=$;function O(i){return new $({uri:i,index:0,name:(0,A.$sg)(i)},{uri:i.toString()})}e.$ci=O,e.$di="code-workspace",e.$ei=`.${e.$di}`,e.$fi=[{name:(0,L.localize)(0,null),extensions:[e.$di]}],e.$gi="workspace.json";function p(i,n){return A.$ng.isEqualOrParent(i,n.untitledWorkspacesHome)}e.$hi=p;function S(i){let n;return j.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===h.Schemas.tmp}e.$ii=S,e.$ji="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function s(i){return i.id===e.$ji}e.$ki=s;function o(i,n){return!p(i,n)&&!S(i)}e.$li=o;function t(i){return(typeof i=="string"?(0,N.$nc)(i):(0,A.$ug)(i))===e.$ei}e.$mi=t}),define(te[23],ne([0,1,41,4,2,17,11,106,18,12,10,6,152,31,22,8,28,29,3]),function(J,e,L,N,D,A,j,b,h,c,k,I,d,f,E,y,m,u,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.ProfileResourceType=void 0;var O;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(O||(e.ProfileResourceType=O={}));function p(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&j.URI.isUri(n.location)&&j.URI.isUri(n.globalStorageHome)&&j.URI.isUri(n.settingsResource)&&j.URI.isUri(n.keybindingsResource)&&j.URI.isUri(n.tasksResource)&&j.URI.isUri(n.snippetsHome)&&j.URI.isUri(n.extensionsResource))}e.$Nk=p,e.$Ok=(0,k.$Th)("IUserDataProfilesService");function S(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:j.URI.revive(i.location).with({scheme:n}),globalStorageHome:j.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:j.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:j.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:j.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:j.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:j.URI.revive(i.extensionsResource).with({scheme:n}),cacheHome:j.URI.revive(i.cacheHome).with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.$Pk=S;function s(i,n,r,l,P,v){return{id:i,name:n,location:r,isDefault:!1,shortName:P?.shortName,icon:P?.icon,globalStorageHome:v&&P?.useDefaultFlags?.globalState?v.globalStorageHome:(0,A.$wg)(r,"globalStorage"),settingsResource:v&&P?.useDefaultFlags?.settings?v.settingsResource:(0,A.$wg)(r,"settings.json"),keybindingsResource:v&&P?.useDefaultFlags?.keybindings?v.keybindingsResource:(0,A.$wg)(r,"keybindings.json"),tasksResource:v&&P?.useDefaultFlags?.tasks?v.tasksResource:(0,A.$wg)(r,"tasks.json"),snippetsHome:v&&P?.useDefaultFlags?.snippets?v.snippetsHome:(0,A.$wg)(r,"snippets"),extensionsResource:v&&P?.useDefaultFlags?.extensions?v.extensionsResource:(0,A.$wg)(r,"extensions.json"),cacheHome:(0,A.$wg)(l,i),useDefaultFlags:P?.useDefaultFlags,isTransient:P?.transient}}e.$Qk=s;let o=class extends D.$Rc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(n,r,l,P){super(),this.t=n,this.u=r,this.w=l,this.y=P,this.f=!0,this.h=this.B(new N.$Od),this.onDidChangeProfiles=this.h.event,this.j=this.B(new N.$Od),this.onWillCreateProfile=this.j.event,this.m=this.B(new N.$Od),this.onWillRemoveProfile=this.m.event,this.n=this.B(new N.$Od),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new f.$zc,emptyWindows:new Map},this.profilesHome=(0,A.$wg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,A.$wg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(n){this.f!==n&&(this.z=void 0,this.f=n)}isEnabled(){return this.f}get C(){if(!this.z){const n=this.D(),r=[n];if(this.f)try{for(const v of this.O()){if(!v.name||!(0,$.$zf)(v.name)||!v.location){this.y.warn("Skipping the invalid stored profile",v.location||v.name);continue}r.push(s((0,A.$tg)(v.location),v.name,v.location,this.g,{shortName:v.shortName,icon:v.icon,useDefaultFlags:v.useDefaultFlags},n))}}catch(v){this.y.error(v)}const l=new f.$zc,P=new Map;if(r.length)try{const v=this.Q();if(v.workspaces)for(const[w,R]of Object.entries(v.workspaces)){const B=j.URI.parse(w),_=r.find(ee=>ee.id===R);_&&l.set(B,_)}if(v.emptyWindows)for(const[w,R]of Object.entries(v.emptyWindows)){const B=r.find(_=>_.id===R);B&&P.set(w,B)}}catch(v){this.y.error(v)}this.z={profiles:r,workspaces:l,emptyWindows:P}}return this.z}D(){const n=s("__default__profile__",(0,b.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...n,extensionsResource:this.S()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const r="Temp",l=new RegExp(`${(0,u.$Ge)(r)}\\s(\\d+)`);let P=0;for(const w of this.profiles){const R=l.exec(w.name),B=R?parseInt(R[1]):0;P=B>P?B:P}const v=`${r} ${P+1}`;return this.createProfile((0,L.$Hi)((0,m.$fg)()).toString(16),v,{transient:!0},n)}async createNamedProfile(n,r,l){return this.createProfile((0,L.$Hi)((0,m.$fg)()).toString(16),n,r,l)}async createProfile(n,r,l,P){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const v=await this.F(n,r,l);return P&&await this.setProfileForWorkspace(P,v),v}async F(n,r,l){if(!(0,$.$zf)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let P=this.r.get(r);return P||(P=(async()=>{try{const v=this.profiles.find(B=>B.name===r||B.id===n);if(v)return v;const w=s(n,r,(0,A.$wg)(this.profilesHome,n),this.g,l,this.defaultProfile);await this.u.createFolder(w.location);const R=[];return this.j.fire({profile:w,join(B){R.push(B)}}),await y.Promises.settled(R),this.I([w],[],[]),w}finally{this.r.delete(r)}})(),this.r.set(r,P)),P}async updateProfile(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let l=this.profiles.find(P=>P.id===n.id);if(!l)throw new Error(`Profile '${n.name}' does not exist`);return l=s(l.id,r.name??l.name,l.location,this.g,{shortName:r.shortName??l.shortName,icon:r.icon===null?void 0:r.icon??l.icon,transient:r.transient??l.isTransient,useDefaultFlags:r.useDefaultFlags??l.useDefaultFlags},this.defaultProfile),this.I([],[],[l]),l}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(P=>P.id===n.id);if(!r)throw new Error(`Profile '${n.name}' does not exist`);const l=[];this.m.fire({profile:r,join(P){l.push(P)}});try{await Promise.allSettled(l)}catch(P){this.y.error(P)}for(const P of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(P)?.id&&this.C.emptyWindows.delete(P);for(const P of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(P)?.id&&this.C.workspaces.delete(P);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(P){(0,c.$tk)(P)!==1&&this.y.error(P)}}async setProfileForWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const l=this.profiles.find(P=>P.id===r.id);if(!l)throw new Error(`Profile '${r.name}' does not exist`);this.L(n,l)}unsetWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(n,void 0,r)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const n=await this.u.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(r=>r.isDirectory&&this.profiles.every(l=>!this.w.extUri.isEqual(l.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(n.map(r=>this.removeProfile(r)))}getProfileForWorkspace(n){const r=this.G(n);return j.URI.isUri(r)?this.s.workspaces.get(r)??this.C.workspaces.get(r):this.s.emptyWindows.get(r)??this.C.emptyWindows.get(r)}G(n){return(0,d.$4h)(n)?n.uri:(0,d.$9h)(n)?n.configPath:n.id}H(n){return!!([...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,n.location)))}I(n,r,l){const P=[...this.profiles,...n],v=[];this.s.profiles=[];for(let w of P)w.isDefault||r.some(R=>w.id===R.id)||(w=l.find(R=>w.id===R.id)??w,w.isTransient?this.s.profiles.push(w):v.push({location:w.location,name:w.name,shortName:w.shortName,icon:w.icon,useDefaultFlags:w.useDefaultFlags}));this.P(v),this.z=void 0,this.J(n,r,l)}J(n,r,l){this.h.fire({added:n,removed:r,updated:l,all:this.profiles})}L(n,r,l){l=r?.isTransient?!0:l,l||this.L(n,void 0,!0);const P=this.G(n),v=l?this.s:this.C;j.URI.isUri(P)?(v.workspaces.delete(P),r&&v.workspaces.set(P,r)):(v.emptyWindows.delete(P),r&&v.emptyWindows.set(P,r)),l||this.M()}M(){const n={};for(const[l,P]of this.C.workspaces.entries())n[l.toString()]=P.id;const r={};for(const[l,P]of this.C.emptyWindows.entries())r[l.toString()]=P.id;this.R({workspaces:n,emptyWindows:r}),this.z=void 0}N(n){const r={},l=this.D();if(n.workspaces)for(const[v,w]of Object.entries(n.workspaces)){const R=j.URI.parse(w);r[v]=this.w.extUri.isEqual(R,l.location)?l.id:this.w.extUri.basename(R)}const P={};if(n.emptyWindows)for(const[v,w]of Object.entries(n.emptyWindows)){const R=j.URI.parse(w);P[v]=this.w.extUri.isEqual(R,l.location)?l.id:this.w.extUri.basename(R)}return{workspaces:r,emptyWindows:P}}O(){return[]}P(n){throw new Error("not implemented")}Q(){return{}}R(n){throw new Error("not implemented")}S(){}};e.$Rk=o,e.$Rk=o=pe([ie(0,h.$1h),ie(1,c.$ck),ie(2,E.$Mk),ie(3,I.$bj)],o);class t extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(n){this.a=n}Q(){return this.X}R(n){this.X=n}}e.$Sk=t}),define(te[153],ne([0,1,19,8,20,9,4,2,13,3,11,91,21,27,37,6,32,26,22,23]),function(J,e,L,N,D,A,j,b,h,c,k,I,d,f,E,y,m,u,$,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wp=e.$vp=e.$up=e.$tp=void 0;let p=class extends b.$Rc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(n,r,l,P,v,w){super(),this.z=n,this.C=r,this.D=l,this.F=P,this.G=v,this.H=w,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new j.$Od),this.s=this.B(new j.$Od),this.t=this.B(new j.$Od),this.u=this.B(new j.$Od),this.w=this.B(new j.$Od),this.y=[],this.B((0,b.$Pc)(()=>{this.j.forEach(({task:R})=>R.cancel()),this.m.forEach(R=>R.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(n){const r=await this.getTargetPlatform();return n.allTargetPlatforms.some(l=>(0,d.$_n)(l,n.allTargetPlatforms,r))}async installFromGallery(n,r={}){try{const P=(await this.installGalleryExtensions([{extension:n,options:r}])).find(({identifier:v})=>(0,f.$Do)(v,n.identifier));if(P?.local)return P?.local;throw P?.error?P.error:s(new Error(`Unknown error while installing extension ${n.identifier.id}`))}catch(l){throw s(l)}}async installGalleryExtensions(n){if(!this.z.isEnabled())throw new d.$co(I.localize(0,null),d.ExtensionManagementErrorCode.Internal);const r=[],l=[];await Promise.allSettled(n.map(async({extension:P,options:v})=>{try{const w=await this.O(P,!!v?.installGivenVersion,!!v?.installPreReleaseVersion);l.push({...w,options:v})}catch(w){r.push({identifier:P.identifier,operation:2,source:P,error:w})}})),l.length&&r.push(...await this.I(l));for(const P of r)P.error&&(this.F.error("Failed to install extension.",P.identifier.id),this.F.error(P.error),P.source&&!k.URI.isUri(P.source)&&o(this.C,"extensionGallery:install",{extensionData:(0,f.$Lo)(P.source),error:P.error}));return r}async uninstall(n,r={}){return this.F.trace("ExtensionManagementService#uninstall",n.identifier.id),this.Q(n,r)}async toggleAppliationScope(n,r){if((0,E.$am)(n.manifest)||n.isBuiltin)return n;if(n.isApplicationScoped){let l=await this.updateMetadata(n,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)||(l=await this.ab(n,this.H.defaultProfile.extensionsResource,r));for(const P of this.H.profiles){const v=(await this.getInstalled(1,P.extensionsResource)).find(w=>(0,f.$Do)(w.identifier,n.identifier));v?this.w.fire(v):this.u.fire({identifier:n.identifier,profileLocation:P.extensionsResource})}return l}else{const l=this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(n,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.ab(n,r,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:l.identifier,operation:2,local:l,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),l}}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.g||n-this.h>1e3*60*5)&&(this.g=this.X(),this.h=n),this.g}registerParticipant(n){this.y.push(n)}async I(n){const r=[];return await Promise.allSettled(n.map(async l=>{try{const P=await this.J(l,(v,w)=>n.some(R=>(0,f.$Ho)(w.identifier.id)===(0,f.$Io)(R.manifest.publisher,R.manifest.name))?!1:this.L(v,w));r.push(...P)}catch(P){r.push({identifier:{id:(0,f.$Io)(l.manifest.publisher,l.manifest.name)},operation:2,source:l.extension,error:P})}})),this.s.fire(r),r}async J({manifest:n,extension:r,options:l},P){const v=l.isApplicationScoped||l.isBuiltin||(0,E.$am)(n),w={...l,installOnlyNewlyAddedFromExtensionPack:k.URI.isUri(r)?l.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:v,profileLocation:v?this.H.defaultProfile.extensionsResource:l.profileLocation??this.Y()},R=ue=>`${f.$Eo.create(ue).toString()}${w.profileLocation?`-${w.profileLocation.toString()}`:""}`;if(!k.URI.isUri(r)){const ue=this.j.get(R(r));if(ue)return this.F.info("Extensions is already requested to install",r.identifier.id),await ue.task.waitUntilTaskIsFinished(),[]}const B=[],_=[],ee=[],oe=this.Z(n,r,w);k.URI.isUri(r)||this.j.set(R(r),{task:oe,waitingTasks:[]}),this.n.fire({identifier:oe.identifier,source:r,profileLocation:w.profileLocation}),this.F.info("Installing extension:",oe.identifier.id),B.push({task:oe,manifest:n});let se=!1;try{if(w.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",oe.identifier.id);else try{const ce=await this.N(oe.identifier,n,!!w.installOnlyNewlyAddedFromExtensionPack,!!w.installPreReleaseVersion,w.profileLocation),re=await this.getInstalled(void 0,w.profileLocation),q={...w,donotIncludePackAndDependencies:!0,context:{...w.context,[d.$7n]:!0}};for(const{gallery:X,manifest:T}of(0,L.$Lb)(ce,({gallery:U})=>U.identifier.id)){se=se||!!T.extensionDependencies?.some(G=>(0,f.$Do)({id:G},oe.identifier));const U=R(X),H=this.j.get(U);if(H){if(P(oe,H.task)){const G=H.task.identifier;this.F.info("Waiting for already requested installing extension",G.id,oe.identifier.id),H.waitingTasks.push(oe),_.push(j.Event.toPromise(j.Event.filter(this.onDidInstallExtensions,Z=>Z.some(K=>(0,f.$Do)(K.identifier,G)))).then(Z=>{if(this.F.info("Finished waiting for already requested installing extension",G.id,oe.identifier.id),!Z.find(M=>(0,f.$Do)(M.identifier,G))?.local)throw new Error(`Extension ${G.id} is not installed`)}))}}else if(!re.some(({identifier:G})=>(0,f.$Do)(G,X.identifier))){const G=this.Z(T,X,q);this.j.set(U,{task:G,waitingTasks:[oe]}),this.n.fire({identifier:G.identifier,source:X,profileLocation:w.profileLocation}),this.F.info("Installing extension:",G.identifier.id,oe.identifier.id),B.push({task:G,manifest:T})}}}catch(ce){if(k.URI.isUri(oe.source))(0,L.$Kb)(n.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",oe.identifier.id,ce.message),(0,L.$Kb)(n.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",oe.identifier.id,ce.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",oe.identifier.id),ce}const ue=B.reduce((ce,{task:re,manifest:q})=>(ce.set(re.identifier.id.toLowerCase(),{task:re,manifest:q}),ce),new Map);for(;ue.size;){let ce;const re=[...ue.values()].filter(({manifest:q})=>!q.extensionDependencies?.some(X=>ue.has(X.toLowerCase())));re.length?ce=ue.size===1?re:re.filter(({task:q})=>!(q===oe&&!se)):(this.F.info("Found extensions with circular dependencies",re.map(({task:q})=>q.identifier.id)),ce=[...ue.values()]),await this.M(ce.map(async({task:q})=>{const X=new Date().getTime();try{const T=await q.run();if(await this.M(this.y.map(U=>U.postInstall(T,q.source,w,D.CancellationToken.None))),!k.URI.isUri(q.source)){const U=q.operation===3,H=U?void 0:(new Date().getTime()-q.source.lastUpdated)/1e3;if(o(this.C,U?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,f.$Lo)(q.source),verificationStatus:q.verificationStatus,duration:new Date().getTime()-X,durationSinceUpdate:H}),h.$p&&q.operation!==3)try{await this.z.reportStatistic(T.manifest.publisher,T.manifest.name,T.manifest.version,"install")}catch{}}ee.push({local:T,identifier:q.identifier,operation:q.operation,source:q.source,context:q.options.context,profileLocation:q.profileLocation,applicationScoped:T.isApplicationScoped})}catch(T){throw k.URI.isUri(q.source)||o(this.C,q.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,f.$Lo)(q.source),verificationStatus:q.verificationStatus,duration:new Date().getTime()-X,error:T}),this.F.error("Error while installing the extension:",q.identifier.id),T}finally{ue.delete(q.identifier.id.toLowerCase())}}))}return _.length&&await this.M(_),ee.forEach(({identifier:ce})=>this.F.info("Extension installed successfully:",ce.id)),ee}catch(ue){if(B.forEach(({task:ce})=>ce.cancel()),ee.length)try{const ce=await Promise.allSettled(ee.map(({local:re})=>this.$(re,{versionOnly:!0,profileLocation:w.profileLocation}).run()));for(let re=0;re<ce.length;re++){const q=ce[re],{identifier:X}=ee[re];q.status==="fulfilled"?this.F.info("Rollback: Uninstalled extension",X.id):this.F.warn("Rollback: Error while uninstalling extension",X.id,(0,A.$9)(q.reason))}}catch(ce){this.F.warn("Error while rolling back extensions",(0,A.$9)(ce),ee.map(({identifier:re})=>re.id))}return B.map(({task:ce})=>({identifier:ce.identifier,operation:2,source:ce.source,context:w.context,profileLocation:w.profileLocation,error:ue}))}finally{for(const{task:ue}of B)ue.source&&!k.URI.isUri(ue.source)&&this.j.delete(R(ue.source))}}L(n,r){for(const[,{task:l,waitingTasks:P}]of this.j.entries())if(l===n&&(P.includes(r)||P.some(v=>this.L(v,r)))||l===r&&P[0]&&!this.L(n,P[0]))return!1;return!0}async M(n){const r=[],l=[],P=await Promise.allSettled(n);for(const v of P)v.status==="fulfilled"?r.push(v.value):l.push(v.reason);if(l.length)throw S(l);return r}async N(n,r,l,P,v){if(!this.z.isEnabled())return[];const w=await this.getInstalled(void 0,v),R=[],B=[],_=async(ee,oe)=>{R.push(ee);const se=oe.extensionDependencies||[],ue=[...se];if(oe.extensionPack){const ce=l?w.find(re=>(0,f.$Do)(re.identifier,ee)):void 0;for(const re of oe.extensionPack)ce&&ce.manifest.extensionPack&&ce.manifest.extensionPack.some(q=>(0,f.$Do)({id:q},{id:re}))||ue.every(q=>!(0,f.$Do)({id:q},{id:re}))&&ue.push(re)}if(ue.length){const ce=ue.filter(re=>R.every(q=>!(0,f.$Do)(q,{id:re})));if(ce.length){const re=await this.z.getExtensions(ce.map(q=>({id:q,preRelease:P})),D.CancellationToken.None);for(const q of re){if(R.find(U=>(0,f.$Do)(U,q.identifier)))continue;const X=se.some(U=>(0,f.$Do)({id:U},q.identifier));let T;try{T=await this.O(q,!1,P)}catch(U){if(X)throw U;this.F.info("Skipping the packed extension as it cannot be installed",q.identifier.id,(0,A.$9)(U));continue}B.push({gallery:T.extension,manifest:T.manifest}),await _(T.extension.identifier,T.manifest)}}}};return await _(n,r),B}async O(n,r,l){let P;const v=await this.getExtensionsControlManifest();if(v.malicious.some(B=>(0,f.$Do)(n.identifier,B)))throw new d.$co(I.localize(1,null,n.identifier.id),d.ExtensionManagementErrorCode.Malicious);const w=v.deprecated[n.identifier.id.toLowerCase()];if(w?.extension?.autoMigrate){if(this.F.info(`The '${n.identifier.id}' extension is deprecated, fetching the compatible '${w.extension.id}' extension instead.`),P=(await this.z.getExtensions([{id:w.extension.id,preRelease:w.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},D.CancellationToken.None))[0],!P)throw new d.$co(I.localize(2,null,n.identifier.id,w.extension.id),d.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(n)){const B=await this.getTargetPlatform();throw new d.$co(I.localize(3,null,n.identifier.id,this.G.nameLong,(0,d.$8n)(B)),d.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(P=await this.P(n,r,l),!P)throw!l&&n.properties.isPreReleaseVersion&&(await this.z.getExtensions([n.identifier],D.CancellationToken.None))[0]?new d.$co(I.localize(4,null,n.identifier.id),d.ExtensionManagementErrorCode.ReleaseVersionNotFound):new d.$co(I.localize(5,null,n.identifier.id,this.G.nameLong,this.G.version),d.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",P.identifier.id);const R=await this.z.getManifest(P,D.CancellationToken.None);if(R===null)throw new d.$co(`Missing manifest for extension ${P.identifier.id}`,d.ExtensionManagementErrorCode.Invalid);if(R.version!==P.version)throw new d.$co(`Cannot install '${P.identifier.id}' extension because of version mismatch in Marketplace`,d.ExtensionManagementErrorCode.Invalid);return{extension:P,manifest:R}}async P(n,r,l){const P=await this.getTargetPlatform();let v=null;return!r&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==l&&(v=(await this.z.getExtensions([{...n.identifier,preRelease:l}],{targetPlatform:P,compatible:!0},D.CancellationToken.None))[0]||null),!v&&await this.z.isExtensionCompatible(n,l,P)&&(v=n),v||(r?v=(await this.z.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:P,compatible:!0},D.CancellationToken.None))[0]||null:v=await this.z.getCompatibleExtension(n,l,P)),v}async Q(n,r){const l={...r,profileLocation:n.isApplicationScoped?this.H.defaultProfile.extensionsResource:r.profileLocation??this.Y()},P=ee=>`${ee.id.toLowerCase()}${l.versionOnly?`-${n.manifest.version}`:""}${l.profileLocation?`@${l.profileLocation.toString()}`:""}`,v=this.m.get(P(n.identifier));if(v)return this.F.info("Extensions is already requested to uninstall",n.identifier.id),v.waitUntilTaskIsFinished();const w=ee=>{const oe=this.$(ee,l);return this.m.set(P(oe.extension.identifier),oe),l.profileLocation?this.F.info("Uninstalling extension from the profile:",`${ee.identifier.id}@${ee.manifest.version}`,l.profileLocation.toString()):this.F.info("Uninstalling extension:",`${ee.identifier.id}@${ee.manifest.version}`),this.t.fire({identifier:ee.identifier,profileLocation:l.profileLocation,applicationScoped:ee.isApplicationScoped}),oe},R=(ee,oe)=>{oe?l.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${ee.identifier.id}@${ee.manifest.version}`,l.profileLocation.toString(),oe.message):this.F.error("Failed to uninstall extension:",`${ee.identifier.id}@${ee.manifest.version}`,oe.message):l.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${ee.identifier.id}@${ee.manifest.version}`,l.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${ee.identifier.id}@${ee.manifest.version}`),o(this.C,"extensionGallery:uninstall",{extensionData:(0,f.$Ko)(ee),error:oe}),this.u.fire({identifier:ee.identifier,error:oe?.code,profileLocation:l.profileLocation,applicationScoped:ee.isApplicationScoped})},B=[],_=[];try{B.push(w(n));const ee=await this.getInstalled(1,l.profileLocation);if(l.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const oe=this.U(n,ee);for(const se of oe)this.m.has(P(se.identifier))?this.F.info("Extensions is already requested to uninstall",se.identifier.id):B.push(w(se))}l.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.R(B.map(oe=>oe.extension),ee,n),await this.M(B.map(async oe=>{try{if(await oe.run(),await this.M(this.y.map(se=>se.postUninstall(oe.extension,l,D.CancellationToken.None))),oe.extension.identifier.uuid)try{await this.z.reportStatistic(oe.extension.manifest.publisher,oe.extension.manifest.name,oe.extension.manifest.version,"uninstall")}catch{}R(oe.extension)}catch(se){const ue=se instanceof d.$co?se:new d.$co((0,A.$9)(se),d.ExtensionManagementErrorCode.Internal);throw R(oe.extension,ue),ue}finally{_.push(oe)}}))}catch(ee){const oe=ee instanceof d.$co?ee:new d.$co((0,A.$9)(ee),d.ExtensionManagementErrorCode.Internal);for(const se of B){try{se.cancel()}catch{}_.includes(se)||R(se.extension,oe)}throw oe}finally{for(const ee of B)this.m.delete(P(ee.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",ee.extension.identifier.id)}}R(n,r,l){for(const P of n){const v=this.W(P,r);if(v.length){const w=v.filter(R=>!n.some(B=>(0,f.$Do)(B.identifier,R.identifier)));if(w.length)throw new Error(this.S(P,w,l))}}}S(n,r,l){return l===n?r.length===1?I.localize(6,null,l.manifest.displayName||l.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?I.localize(7,null,l.manifest.displayName||l.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):I.localize(8,null,l.manifest.displayName||l.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?I.localize(9,null,l.manifest.displayName||l.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?I.localize(10,null,l.manifest.displayName||l.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):I.localize(11,null,l.manifest.displayName||l.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}U(n,r,l=[]){if(l.indexOf(n)!==-1)return[];l.push(n);const P=n.manifest.extensionPack?n.manifest.extensionPack:[];if(P.length){const v=r.filter(R=>!R.isBuiltin&&P.some(B=>(0,f.$Do)({id:B},R.identifier))),w=[];for(const R of v)w.push(...this.U(R,r,l));return[...v,...w]}return[]}W(n,r){return r.filter(l=>l.manifest.extensionDependencies&&l.manifest.extensionDependencies.some(P=>(0,f.$Do)({id:P},n.identifier)))}async X(){try{this.F.trace("ExtensionManagementService.refreshReportedCache");const n=await this.z.getExtensionsControlManifest();return this.F.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$tp=p,e.$tp=p=pe([ie(0,d.$bo),ie(1,u.$gl),ie(2,$.$Mk),ie(3,y.$bj),ie(4,m.$tj),ie(5,O.$Ok)],p);function S(i){const n=Array.isArray(i)?i:[i];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((r,l)=>new Error(`${r.message}${r.message?",":""}${l instanceof Error?l.message:l}`),new Error(""))}e.$up=S;function s(i){if(i instanceof d.$co)return i;const n=new d.$co(i.message,d.ExtensionManagementErrorCode.Internal);return n.stack=i.stack,n}e.$vp=s;function o(i,n,{extensionData:r,verificationStatus:l,duration:P,error:v,durationSinceUpdate:w}){let R,B;(0,c.$Hf)(l)&&(l===!0?l="Verified":(l===!1||(R=d.ExtensionManagementErrorCode.Signature,B=l),l="Unverified")),v&&(v instanceof d.$co?(R=v.code,v.code===d.ExtensionManagementErrorCode.Signature&&(B=v.message)):R=d.ExtensionManagementErrorCode.Internal),i.publicLog(n,{...r,verificationStatus:l,success:!v,duration:P,errorcode:R,errorcodeDetail:B,durationSinceUpdate:w})}class t{constructor(){this.d=new N.$Tg}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,N.$Ig)(n=>this.h(n))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,N.$Ig)(n=>new Promise((r,l)=>{const P=n.onCancellationRequested(()=>{P.dispose(),l(new A.$4)})})),this.d.open()),this.g.cancel()}}e.$wp=t}),define(te[40],ne([0,1,8,14,2,4,31,11,21,27,12,10,6,23,22,3,9,26]),function(J,e,L,N,D,A,j,b,h,c,k,I,d,f,E,y,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=e.$yp=e.$xp=e.ExtensionsProfileScanningErrorCode=void 0;var $;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})($||(e.ExtensionsProfileScanningErrorCode=$={}));class O extends Error{constructor(t,i){super(t),this.code=i}}e.$xp=O,e.$yp=(0,I.$Th)("IExtensionsProfileScannerService");let p=class extends D.$Rc{constructor(t,i,n,r,l,P){super(),this.j=t,this.m=i,this.n=n,this.r=r,this.s=l,this.t=P,this.b=this.B(new A.$Od),this.onAddExtensions=this.b.event,this.c=this.B(new A.$Od),this.onDidAddExtensions=this.c.event,this.f=this.B(new A.$Od),this.onRemoveExtensions=this.f.event,this.g=this.B(new A.$Od),this.onDidRemoveExtensions=this.g.event,this.h=new j.$zc}scanProfileExtensions(t,i){return this.u(t,void 0,i)}async addExtensionsToProfile(t,i){const n=[],r=[];try{return await this.u(i,l=>{const P=[];for(const v of l)t.some(([w])=>(0,c.$Do)(w.identifier,v.identifier)&&w.manifest.version!==v.version)?n.push(v):P.push(v);for(const[v,w]of t){const R=P.findIndex(_=>(0,c.$Do)(_.identifier,v.identifier)&&_.version===v.manifest.version),B={identifier:v.identifier,version:v.manifest.version,location:v.location,metadata:w};R===-1?(r.push(B),P.push(B)):P.splice(R,1,B)}return r.length&&this.b.fire({extensions:r,profileLocation:i}),n.length&&this.f.fire({extensions:n,profileLocation:i}),P}),r.length&&this.c.fire({extensions:r,profileLocation:i}),n.length&&this.g.fire({extensions:n,profileLocation:i}),r}catch(l){throw r.length&&this.c.fire({extensions:r,error:l,profileLocation:i}),n.length&&this.g.fire({extensions:n,error:l,profileLocation:i}),l}}async updateMetadata(t,i){const n=[];return await this.u(i,r=>{const l=[];for(const P of r){const v=t.find(([w])=>(0,c.$Do)(w.identifier,P.identifier)&&w.manifest.version===P.version);v&&(P.metadata={...P.metadata,...v[1]},n.push(P)),l.push(P)}return l}),n}async removeExtensionFromProfile(t,i){const n=[];try{await this.u(i,r=>{const l=[];for(const P of r)(0,c.$Do)(P.identifier,t.identifier)?n.push(P):l.push(P);return n.length&&this.f.fire({extensions:n,profileLocation:i}),l}),n.length&&this.g.fire({extensions:n,profileLocation:i})}catch(r){throw n.length&&this.g.fire({extensions:n,error:r,profileLocation:i}),r}}async u(t,i,n){return this.F(t).queue(async()=>{let r=[],l;try{const P=await this.m.readFile(t);l=JSON.parse(P.value.toString().trim()||"[]")}catch(P){if((0,k.$tk)(P)!==1)throw P;if(this.r.extUri.isEqual(t,this.n.defaultProfile.extensionsResource)&&(l=await this.D()),!l&&n?.bailOutWhenFileNotFound)throw new O((0,m.$9)(P),"ERROR_PROFILE_NOT_FOUND")}if(l){Array.isArray(l)||this.w(t);let P=!1;for(const v of l){S(v)||this.w(t);let w;if((0,y.$zf)(v.relativeLocation)&&v.relativeLocation)w=this.z(v.relativeLocation);else if((0,y.$zf)(v.location))w=this.z(v.location),P=!0,v.relativeLocation=v.location,v.location=w.toJSON();else{w=b.URI.revive(v.location);const R=this.y(w);R&&(P=!0,v.relativeLocation=R)}r.push({identifier:v.identifier,location:w,version:v.version,metadata:v.metadata})}P&&await this.m.writeFile(t,N.$ce.fromString(JSON.stringify(l)))}if(i){r=i(r);const P=r.map(v=>({identifier:v.identifier,version:v.version,location:v.location.toJSON(),relativeLocation:this.y(v.location),metadata:v.metadata}));await this.m.writeFile(t,N.$ce.fromString(JSON.stringify(P)))}return r})}w(t){const i=new O(`Invalid extensions content in ${t.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(t){return this.r.extUri.isEqual(this.r.extUri.dirname(t),this.j)?this.r.extUri.basename(t):void 0}z(t){return this.r.extUri.joinPath(this.j,t)}async D(){return this.C||(this.C=(async()=>{const t=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let n;try{n=(await this.m.readFile(t)).value.toString()}catch(l){if((0,k.$tk)(l)===1)return;throw l}this.t.info("Migrating extensions from old default profile location",t.toString());let r;try{const l=JSON.parse(n);Array.isArray(l)&&l.every(P=>S(P))?r=l:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",l)}catch(l){this.t.error(l)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,N.$ce.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",t.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(l){if((0,k.$tk)(l)===3)this.t.info("Migration from old default profile location to new location is done by another window",t.toString(),this.n.defaultProfile.extensionsResource.toString());else throw l}try{await this.m.del(t)}catch(l){(0,k.$tk)(l)!==1&&this.t.error(l)}try{await this.m.del(i)}catch(l){(0,k.$tk)(l)!==1&&this.t.error(l)}return r})()),this.C}F(t){let i=this.h.get(t);return i||(i=new L.$3g,this.h.set(t,i)),i}};e.$zp=p,e.$zp=p=pe([ie(1,k.$ck),ie(2,f.$Ok),ie(3,E.$Mk),ie(4,u.$gl),ie(5,d.$bj)],p);function S(o){return(0,y.$Bf)(o)&&(0,h.$ao)(o.identifier)&&(s(o.location)||(0,y.$zf)(o.location)&&o.location)&&((0,y.$Gf)(o.relativeLocation)||(0,y.$zf)(o.relativeLocation))&&o.version&&(0,y.$zf)(o.version)}function s(o){return o?(0,y.$zf)(o.path)&&(0,y.$zf)(o.scheme):!1}}),define(te[50],ne([0,1,19,8,30,14,9,53,79,2,15,16,13,17,42,54,3,11,95,18,27,37,48,12,10,6,32,4,46,40,23,22,112]),function(J,e,L,N,D,A,j,b,h,c,k,I,d,f,E,y,m,u,$,O,p,S,s,o,t,i,n,r,l,P,v,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gp=e.$Fp=e.$Ep=e.$Dp=e.$Cp=e.Translations=void 0;var B;(function(re){function q(X,T){if(X===T)return!0;const U=Object.keys(X),H=new Set;for(const G of Object.keys(T))H.add(G);if(U.length!==H.size)return!1;for(const G of U){if(X[G]!==T[G])return!1;H.delete(G)}return H.size===0}re.equals=q})(B||(e.Translations=B={})),e.$Cp=(0,t.$Th)("IExtensionsScannerService");let _=class extends c.$Rc{constructor(q,X,T,U,H,G,Z,K,M,F,a,g){super(),this.systemExtensionsLocation=q,this.userExtensionsLocation=X,this.r=T,this.s=U,this.t=H,this.u=G,this.w=Z,this.y=K,this.z=M,this.C=F,this.D=a,this.F=g,this.g=this.B(new r.$Od),this.onDidChangeCache=this.g.event,this.h=(0,f.$wg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(se,this.s,this.h)),this.m=this.B(this.F.createInstance(se,this.s,this.h)),this.n=this.B(this.F.createInstance(oe,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,p.$Oo)(this.w,this.y)),this.G}async scanAllExtensions(q,X,T){const[U,H]=await Promise.all([this.scanSystemExtensions(q),this.scanUserExtensions(X)]),G=T?await this.scanExtensionsUnderDevelopment(q,[...U,...H]):[];return this.L(U,H,G,await this.getTargetPlatform(),!0)}async scanSystemExtensions(q){const X=[];X.push(this.M(!!q.useCache,q.language)),X.push(this.N(q.language,!!q.checkControlFile));const[T,U]=await Promise.all(X);return this.J([...T,...U],0,q,!1)}async scanUserExtensions(q){const X=q.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",X);const T=this.D.extUri.isEqual(q.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,U=await this.P(X,!!q.profileLocation,1,!q.includeUninstalled,q.language,!0,T),H=q.useCache&&!U.devMode&&U.excludeObsolete?this.m:this.n;let G;try{G=await H.scanExtensions(U)}catch(Z){if(Z instanceof P.$xp&&Z.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),G=await H.scanExtensions(U);else throw Z}return G=await this.J(G,1,q,!0),this.y.trace("Scanned user extensions:",G.length),G}async scanExtensionsUnderDevelopment(q,X){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const T=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(U=>U.scheme===k.Schemas.file).map(async U=>{const H=await this.P(U,!1,1,!0,q.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(H)).map(Z=>(Z.type=X.find(K=>(0,p.$Do)(K.identifier,Z.identifier))?.type??Z.type,this.n.validate(Z,H)))}))).flat();return this.J(T,"development",q,!0)}return[]}async scanExistingExtension(q,X,T){const U=await this.P(q,!1,X,!0,T.language,!0,void 0),H=await this.n.scanExtension(U);return!H||!T.includeInvalid&&!H.isValid?null:H}async scanOneOrMultipleExtensions(q,X,T){const U=await this.P(q,!1,X,!0,T.language,!0,void 0),H=await this.n.scanOneOrMultipleExtensions(U);return this.J(H,X,T,!0)}async scanMetadata(q){const X=(0,f.$wg)(q,"package.json"),T=(await this.w.readFile(X)).value.toString();return JSON.parse(T).__metadata}async updateMetadata(q,X){const T=(0,f.$wg)(q,"package.json"),U=(await this.w.readFile(T)).value.toString(),H=JSON.parse(U);X.isMachineScoped===!1&&delete X.isMachineScoped,X.isBuiltin===!1&&delete X.isBuiltin,H.__metadata={...H.__metadata,...X},await this.w.writeFile((0,f.$wg)(q,"package.json"),A.$ce.fromString(JSON.stringify(H,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(q){if(q instanceof P.$xp&&q.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw q}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const q=await this.scanUserExtensions({includeInvalid:!0});if(q.length)await this.u.addExtensionsToProfile(q.map(X=>[X,X.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,A.$ce.fromString(JSON.stringify([])))}catch(X){(0,o.$tk)(X)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,j.$9)(X))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(q){this.y.error(q)}finally{this.H=void 0}})()),this.H}async J(q,X,T,U){return T.includeAllVersions||(q=this.L(X===0?q:void 0,X===1?q:void 0,X==="development"?q:void 0,await this.getTargetPlatform(),U)),T.includeInvalid||(q=q.filter(H=>H.isValid)),q.sort((H,G)=>{const Z=I.$mc(H.location.fsPath),K=I.$mc(G.location.fsPath);return Z<K?-1:Z>K?1:0})}L(q,X,T,U,H){const G=(K,M,F)=>{if(K.isValid&&!M.isValid)return!1;if(K.isValid===M.isValid){if(H&&E.gt(K.manifest.version,M.manifest.version))return this.y.debug(`Skipping extension ${M.location.path} with lower version ${M.manifest.version} in favour of ${K.location.path} with version ${K.manifest.version}`),!1;if(E.eq(K.manifest.version,M.manifest.version)){if(K.type===0)return this.y.debug(`Skipping extension ${M.location.path} in favour of system extension ${K.location.path} with same version`),!1;if(K.targetPlatform===U)return this.y.debug(`Skipping extension ${M.location.path} from different target platform ${M.targetPlatform}`),!1}}return F?this.y.warn(`Overwriting user extension ${K.location.path} with ${M.location.path}.`):this.y.debug(`Overwriting user extension ${K.location.path} with ${M.location.path}.`),!0},Z=new S.$_l;return q?.forEach(K=>{const M=Z.get(K.identifier.id);(!M||G(M,K,!1))&&Z.set(K.identifier.id,K)}),X?.forEach(K=>{const M=Z.get(K.identifier.id);if(!M&&q&&K.type===0){this.y.debug(`Skipping obsolete system extension ${K.location.path}.`);return}(!M||G(M,K,!1))&&Z.set(K.identifier.id,K)}),T?.forEach(K=>{const M=Z.get(K.identifier.id);(!M||G(M,K,!0))&&Z.set(K.identifier.id,K),Z.set(K.identifier.id,K)}),[...Z.values()]}async M(q,X){this.y.trace("Started scanning system extensions");const T=await this.P(this.systemExtensionsLocation,!1,0,!0,X,!0,void 0),H=await(q&&!T.devMode?this.j:this.n).scanExtensions(T);return this.y.trace("Scanned system extensions:",H.length),H}async N(q,X){const T=this.z.isBuilt?[]:this.C.builtInExtensions;if(!T?.length)return[];this.y.trace("Started scanning dev system extensions");const U=X?await this.O():{},H=[],G=u.URI.file(I.$gc(I.$ic(k.$dg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const K of T){const M=U[K.name]||"marketplace";switch(M){case"disabled":break;case"marketplace":H.push((0,f.$wg)(G,K.name));break;default:H.push(u.URI.file(M));break}}const Z=await Promise.all(H.map(async K=>this.n.scanExtension(await this.P(K,!1,0,!0,q,!0,void 0))));return this.y.trace("Scanned dev system extensions:",Z.length),(0,L.$Gb)(Z)}async O(){try{const q=await this.w.readFile(this.r);return JSON.parse(q.value.toString())}catch{return{}}}async P(q,X,T,U,H,G,Z){const K=await this.f(H??d.$w),M=await this.Q(q),F=X&&!this.D.extUri.isEqual(q,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,a=F?await this.Q(F):void 0;return new ee(q,M,F,a,X,Z,T,U,G,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,H,K)}async Q(q){try{const X=await this.w.stat(q);if(typeof X.mtime=="number")return X.mtime}catch{}}};e.$Dp=_,e.$Dp=_=pe([ie(4,v.$Ok),ie(5,P.$yp),ie(6,o.$ck),ie(7,i.$bj),ie(8,O.$1h),ie(9,n.$tj),ie(10,w.$Mk),ie(11,t.$Sh)],_);class ee{constructor(q,X,T,U,H,G,Z,K,M,F,a,g,z,C,Q){this.location=q,this.mtime=X,this.applicationExtensionslocation=T,this.applicationExtensionslocationMtime=U,this.profile=H,this.profileScanOptions=G,this.type=Z,this.excludeObsolete=K,this.validate=M,this.productVersion=F,this.productDate=a,this.productCommit=g,this.devMode=z,this.language=C,this.translations=Q}static createNlsConfiguration(q){return{language:q.language,pseudo:q.language==="pseudo",devMode:q.devMode,translations:q.translations}}static equals(q,X){return(0,f.$pg)(q.location,X.location)&&q.mtime===X.mtime&&(0,f.$pg)(q.applicationExtensionslocation,X.applicationExtensionslocation)&&q.applicationExtensionslocationMtime===X.applicationExtensionslocationMtime&&q.profile===X.profile&&D.$cn(q.profileScanOptions,X.profileScanOptions)&&q.type===X.type&&q.excludeObsolete===X.excludeObsolete&&q.validate===X.validate&&q.productVersion===X.productVersion&&q.productDate===X.productDate&&q.productCommit===X.productCommit&&q.devMode===X.devMode&&q.language===X.language&&B.equals(q.translations,X.translations)}}e.$Ep=ee;let oe=class extends c.$Rc{constructor(q,X,T,U,H){super(),this.f=q,this.g=X,this.h=T,this.j=U,this.m=H}async scanExtensions(q){const X=q.profile?await this.r(q):await this.n(q);let T={};if(q.excludeObsolete&&q.type===1)try{const U=(await this.j.readFile(this.f)).value.toString();T=JSON.parse(U)}catch{}return(0,m.$Mf)(T)?X:X.filter(U=>!T[p.$Eo.create(U).toString()])}async n(q){const X=await this.j.resolve(q.location);if(!X.children?.length)return[];const T=await Promise.all(X.children.map(async U=>{if(!U.isDirectory||q.type===1&&(0,f.$tg)(U.resource).indexOf(".")===0)return null;const H=new ee(U.resource,q.mtime,q.applicationExtensionslocation,q.applicationExtensionslocationMtime,q.profile,q.profileScanOptions,q.type,q.excludeObsolete,q.validate,q.productVersion,q.productDate,q.productCommit,q.devMode,q.language,q.translations);return this.scanExtension(H)}));return(0,L.$Gb)(T).sort((U,H)=>U.location.path<H.location.path?-1:1)}async r(q){let X=await this.s(q.location,()=>!0,q);if(q.applicationExtensionslocation&&!this.h.extUri.isEqual(q.location,q.applicationExtensionslocation)){X=X.filter(U=>!U.metadata?.isApplicationScoped);const T=await this.s(q.applicationExtensionslocation,U=>!!U.metadata?.isBuiltin||!!U.metadata?.isApplicationScoped,q);X.push(...T)}return X}async s(q,X,T){const U=await this.g.scanProfileExtensions(q,T.profileScanOptions);if(!U.length)return[];const H=await Promise.all(U.map(async G=>{if(X(G)){const Z=new ee(G.location,T.mtime,T.applicationExtensionslocation,T.applicationExtensionslocationMtime,T.profile,T.profileScanOptions,T.type,T.excludeObsolete,T.validate,T.productVersion,T.productDate,T.productCommit,T.devMode,T.language,T.translations);return this.scanExtension(Z,G.metadata)}return null}));return(0,L.$Gb)(H)}async scanOneOrMultipleExtensions(q){try{if(await this.j.exists((0,f.$wg)(q.location,"package.json"))){const X=await this.scanExtension(q);return X?[X]:[]}else return await this.scanExtensions(q)}catch(X){return this.m.error(`Error scanning extensions at ${q.location.path}:`,(0,j.$9)(X)),[]}}async scanExtension(q,X){try{let T=await this.scanExtensionManifest(q.location);if(T){T.publisher||(T.publisher=S.$6l),X=X??T.__metadata,delete T.__metadata;const U=(0,p.$Io)(T.publisher,T.name),H=X?.id?{id:U,uuid:X.id}:{id:U},G=X?.isSystem?0:q.type,Z=G===0||!!X?.isBuiltin;T=await this.t(q.location,T,ee.createNlsConfiguration(q));const K={type:G,identifier:H,manifest:T,location:q.location,isBuiltin:Z,targetPlatform:X?.targetPlatform??"undefined",metadata:X,isValid:!0,validations:[]};return q.validate?this.validate(K,q):K}}catch(T){q.type!==0&&this.m.error(T)}return null}validate(q,X){let T=!0;const U=(0,s.$To)(X.productVersion,X.productDate,X.location,q.manifest,q.isBuiltin);for(const[H,G]of U)H===y.default.Error&&(T=!1,this.m.error(this.z(X.location,G)));return q.isValid=T,q.validations=U,q}async scanExtensionManifest(q){const X=(0,f.$wg)(q,"package.json");let T;try{T=(await this.j.readFile(X)).value.toString()}catch(H){return(0,o.$tk)(H)!==1&&this.m.error(this.z(q,(0,$.localize)(0,null,X.path,H.message))),null}let U;try{U=JSON.parse(T)}catch{const G=[];(0,b.$1m)(T,G);for(const Z of G)this.m.error(this.z(q,(0,$.localize)(1,null,X.path,Z.offset,Z.length,(0,h.$Ap)(Z.error))));return null}return(0,b.$0m)(U)!=="object"?(this.m.error(this.z(q,(0,$.localize)(2,null,X.path))),null):U}async t(q,X,T){const U=await this.u(q,X,T);if(U)try{const H=[],G=await this.w(U.default,H);if(H.length>0)return H.forEach(K=>{this.m.error(this.z(q,(0,$.localize)(3,null,U.default?.path,(0,h.$Ap)(K.error))))}),X;if((0,b.$0m)(U)!=="object")return this.m.error(this.z(q,(0,$.localize)(4,null,U.default?.path))),X;const Z=U.values||Object.create(null);return(0,R.$Bp)(this.m,X,Z,G)}catch{}return X}async u(q,X,T){const U=(0,f.$wg)(q,"package.nls.json"),H=(M,F)=>{F.forEach(a=>{this.m.error(this.z(q,(0,$.localize)(5,null,M?.path,(0,h.$Ap)(a.error))))})},G=M=>{this.m.error(this.z(q,(0,$.localize)(6,null,M?.path)))},Z=`${X.publisher}.${X.name}`,K=T.translations[Z];if(K)try{const M=u.URI.file(K),F=(await this.j.readFile(M)).value.toString(),a=[],g=(0,b.$1m)(F,a);return a.length>0?(H(M,a),{values:void 0,default:U}):(0,b.$0m)(g)!=="object"?(G(M),{values:void 0,default:U}):{values:g.contents?g.contents.package:void 0,default:U}}catch{return{values:void 0,default:U}}else{if(!await this.j.exists(U))return;let F;try{F=await this.y(q,T)}catch{return}if(!F.localized)return{values:void 0,default:F.original};try{const a=(await this.j.readFile(F.localized)).value.toString(),g=[],z=(0,b.$1m)(a,g);return g.length>0?(H(F.localized,g),{values:void 0,default:F.original}):(0,b.$0m)(z)!=="object"?(G(F.localized),{values:void 0,default:F.original}):{values:z,default:F.original}}catch{return{values:void 0,default:F.original}}}}async w(q,X){if(q)try{const T=(await this.j.readFile(q)).value.toString();return(0,b.$1m)(T,X)}catch{}}y(q,X){return new Promise((T,U)=>{const H=G=>{const Z=(0,f.$wg)(q,`package.nls.${G}.json`);this.j.exists(Z).then(K=>{K&&T({localized:Z,original:(0,f.$wg)(q,"package.nls.json")});const M=G.lastIndexOf("-");M===-1?T({localized:(0,f.$wg)(q,"package.nls.json"),original:null}):(G=G.substring(0,M),H(G))})};if(X.devMode||X.pseudo||!X.language)return T({localized:(0,f.$wg)(q,"package.nls.json"),original:null});H(X.language)})}z(q,X){return`[${q.path}]: ${X}`}};oe=pe([ie(1,P.$yp),ie(2,w.$Mk),ie(3,o.$ck),ie(4,i.$bj)],oe);let se=class extends oe{constructor(q,X,T,U,H,G,Z){super(X,U,H,G,Z),this.G=q,this.H=T,this.D=this.B(new N.$Sg(3e3)),this.F=this.B(new r.$Od),this.onDidChangeCache=this.F.event}async scanExtensions(q){const X=this.M(q),T=await this.I(X);if(this.C=q,T&&T.input&&ee.equals(T.input,this.C))return this.m.debug("Using cached extensions scan result",q.location.toString()),this.D.trigger(()=>this.L()),T.result.map(H=>(H.location=u.URI.revive(H.location),H));const U=await super.scanExtensions(q);return await this.J(X,{input:q,result:U}),U}async I(q){try{const X=await this.j.readFile(q),T=JSON.parse(X.value.toString());return{result:T.result,input:(0,l.$qh)(T.input)}}catch(X){this.m.debug("Error while reading the extension cache file:",q.path,(0,j.$9)(X))}return null}async J(q,X){try{await this.j.writeFile(q,A.$ce.fromString(JSON.stringify(X)))}catch(T){this.m.debug("Error while writing the extension cache file:",q.path,(0,j.$9)(T))}}async L(){if(!this.C)return;const q=this.M(this.C),X=await this.I(q);if(!X)return;const T=X.result,U=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!D.$cn(U,T))try{this.m.info("Invalidating Cache",T,U),await this.j.del(q),this.F.fire()}catch(H){this.m.error(H)}}M(q){const X=this.N(q);return this.h.extUri.joinPath(X.cacheHome,q.type===0?S.$5l:S.$4l)}N(q){return q.type===0?this.H.defaultProfile:q.profile?this.h.extUri.isEqual(q.location,this.G.extensionsResource)?this.G:this.H.profiles.find(X=>this.h.extUri.isEqual(q.location,X.extensionsResource))??this.G:this.H.defaultProfile}};se=pe([ie(2,v.$Ok),ie(3,P.$yp),ie(4,w.$Mk),ie(5,o.$ck),ie(6,i.$bj)],se);function ue(re,q){const X=(0,p.$Go)(re.manifest.publisher,re.manifest.name);return{id:X,identifier:new S.$0l(X),isBuiltin:re.type===0,isUserBuiltin:re.type===1&&re.isBuiltin,isUnderDevelopment:q,extensionLocation:re.location,uuid:re.identifier.uuid,targetPlatform:re.targetPlatform,...re.manifest}}e.$Fp=ue;class ce extends _{constructor(q,X,T,U,H,G,Z,K,M,F,a,g){super(q,X,(0,f.$wg)(T,".vscode-oss-dev","extensions","control.json"),U,H,G,Z,K,M,F,a,g),this.R=(async()=>{if(d.$z)try{const z=await this.w.readFile(u.URI.file(d.$z));return JSON.parse(z.value.toString())}catch{}return Object.create(null)})()}f(q){return this.R}}e.$Gp=ce}),define(te[154],ne([0,1,58,8,34,4,2,15,16,24,6,23]),function(J,e,L,N,D,A,j,b,h,c,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ip=void 0;let d=class extends j.$Rc{constructor(E,y){super(),this.b=E,this.f=y,this.a=new N.$2g(5)}async postUninstall(E){const y=this.g(E,"uninstall");y&&(this.f.info(E.identifier.id,E.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(y.script,"uninstall",y.args,!0,E),this.f.info("Finished running post uninstall script",E.identifier.id,E.manifest.version)}catch(m){this.f.error("Failed to run post uninstall script",E.identifier.id,E.manifest.version),this.f.error(m)}}));try{await c.Promises.rm(this.m(E))}catch(m){this.f.error("Error while removing extension storage path",E.identifier.id),this.f.error(m)}}g(E,y){const m=`vscode:${y}`;if(E.location.scheme===b.Schemas.file&&E.manifest&&E.manifest.scripts&&typeof E.manifest.scripts[m]=="string"){const u=E.manifest.scripts[m].split(" ");return u.length<2||u[0]!=="node"||!u[1]?(this.f.warn(E.identifier.id,E.manifest.version,`${m} should be a node script`),null):{script:(0,h.$ic)(E.location.fsPath,u[1]),args:u.slice(2)||[]}}return null}h(E,y,m,u,$){return new Promise((O,p)=>{const S=this.j(E,y,m,$);let s;const o=t=>{s&&(clearTimeout(s),s=null),t?p(t):O(void 0)};S.on("error",t=>{o((0,D.$Ei)(t)||"Unknown")}),S.on("exit",(t,i)=>{o(t?`post-${y} process exited with code ${t}`:void 0)}),u&&(s=setTimeout(()=>{s=null,S.kill(),p("timed out")},5e3))})}j(E,y,m,u){const $={silent:!0,execArgv:void 0},O=(0,L.fork)(E,[`--type=extension-post-${y}`,...m],$);O.stdout.setEncoding("utf8"),O.stderr.setEncoding("utf8");const p=A.Event.fromNodeEventEmitter(O.stdout,"data"),S=A.Event.fromNodeEventEmitter(O.stderr,"data");p(t=>this.f.info(u.identifier.id,u.manifest.version,`post-${y}`,t)),S(t=>this.f.error(u.identifier.id,u.manifest.version,`post-${y}`,t));const s=A.Event.any(A.Event.map(p,t=>({data:`%c${t}`,format:[""]})),A.Event.map(S,t=>({data:`%c${t}`,format:["color: red"]})));return A.Event.debounce(s,(t,i)=>t?{data:t.data+i.data,format:[...t.format,...i.format]}:{data:i.data,format:i.format},100)(t=>{console.group(u.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),O}m(E){return(0,h.$ic)(this.b.defaultProfile.globalStorageHome.fsPath,E.identifier.id.toLowerCase())}};e.$Ip=d,e.$Ip=d=pe([ie(0,I.$Ok),ie(1,k.$bj)],d)}),define(te[155],ne([0,1,6,23,22,26,40,12,18,11]),function(J,e,L,N,D,A,j,b,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TN=void 0;let k=class extends j.$zp{constructor(d,f,E,y,m,u){super(c.URI.file(d.extensionsPath),f,E,y,m,u)}};e.$TN=k,e.$TN=k=pe([ie(0,h.$2h),ie(1,b.$ck),ie(2,N.$Ok),ie(3,D.$Mk),ie(4,A.$gl),ie(5,L.$bj)],k)}),define(te[156],ne([0,1,11,18,40,50,12,10,6,32,22,23]),function(J,e,L,N,D,A,j,b,h,c,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N8b=void 0;let d=class extends A.$Gp{constructor(E,y,m,u,$,O,p,S){super(L.URI.file($.builtinExtensionsPath),L.URI.file($.extensionsPath),$.userHome,E.defaultProfile,E,y,m,u,$,O,p,S)}};e.$N8b=d,e.$N8b=d=pe([ie(0,I.$Ok),ie(1,D.$yp),ie(2,j.$ck),ie(3,h.$bj),ie(4,N.$2h),ie(5,c.$tj),ie(6,k.$Mk),ie(7,b.$Sh)],d)}),define(te[157],ne([0,1,8,4,2,123,3,86,10,23]),function(J,e,L,N,D,A,j,b,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$0o=e.$9o=e.$8o=void 0,e.$8o="__$__isNewStorageMarker",e.$9o="__$__targetStorageMarker",e.$0o=(0,h.$Th)("storageService");var k;(function($){$[$.NONE=0]="NONE",$[$.SHUTDOWN=1]="SHUTDOWN"})(k||(e.WillSaveStateReason=k={}));var I;(function($){$[$.APPLICATION=-1]="APPLICATION",$[$.PROFILE=0]="PROFILE",$[$.WORKSPACE=1]="WORKSPACE"})(I||(e.StorageScope=I={}));var d;(function($){$[$.USER=0]="USER",$[$.MACHINE=1]="MACHINE"})(d||(e.StorageTarget=d={}));function f($){const O=$.get(e.$9o);if(O)try{return JSON.parse(O)}catch{}return Object.create(null)}e.$$o=f;class E extends D.$Rc{static{this.a=60*1e3}constructor(O={flushInterval:E.a}){super(),this.m=O,this.b=this.B(new N.$Rd),this.c=this.B(new N.$Rd),this.onDidChangeTarget=this.c.event,this.f=this.B(new N.$Od),this.onWillSaveState=this.f.event,this.h=this.B(new L.$8g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new D.$Sc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(O,p,S){return N.Event.filter(this.b.event,s=>s.scope===O&&(p===void 0||s.key===p),S)}n(){this.j.value=(0,L.$ah)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,D.$Mc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.O()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(O,p){const{key:S,external:s}=p;if(S===e.$9o){switch(O){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:O})}else this.b.fire({scope:O,key:S,target:this.J(O)[S],external:s})}w(O){this.f.fire({reason:O})}get(O,p,S){return this.P(p)?.get(O,S)}getBoolean(O,p,S){return this.P(p)?.getBoolean(O,S)}getNumber(O,p,S){return this.P(p)?.getNumber(O,S)}getObject(O,p,S){return this.P(p)?.getObject(O,S)}storeAll(O,p){this.y(()=>{for(const S of O)this.store(S.key,S.value,S.scope,S.target,p)})}store(O,p,S,s,o=!1){if((0,j.$If)(p)){this.remove(O,S,o);return}this.y(()=>{this.z(O,S,s),this.P(S)?.set(O,p,o)})}remove(O,p,S=!1){this.y(()=>{this.z(O,p,void 0),this.P(p)?.delete(O,S)})}y(O){this.b.pause(),this.c.pause();try{O()}finally{this.b.resume(),this.c.resume()}}keys(O,p){const S=[],s=this.J(O);for(const o of Object.keys(s))s[o]===p&&S.push(o);return S}z(O,p,S,s=!1){const o=this.J(p);typeof S=="number"?o[O]!==S&&(o[O]=S,this.P(p)?.set(e.$9o,JSON.stringify(o),s)):typeof o[O]=="number"&&(delete o[O],this.P(p)?.set(e.$9o,JSON.stringify(o),s))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(O){switch(O){case-1:return this.I;case 0:return this.G;default:return this.D}}L(O){const p=this.P(O);return p?f(p):Object.create(null)}isNew(O){return this.getBoolean(e.$8o,O)===!0}async flush(O=k.NONE){this.f.fire({reason:O});const p=this.P(-1),S=this.P(0),s=this.P(1);switch(O){case k.NONE:await L.Promises.settled([p?.whenFlushed()??Promise.resolve(),S?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve()]);break;case k.SHUTDOWN:await L.Promises.settled([p?.flush(0)??Promise.resolve(),S?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve()]);break}}async log(){const O=this.P(-1)?.items??new Map,p=this.P(0)?.items??new Map,S=this.P(1)?.items??new Map;return u(O,p,S,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(O){return await this.flush(),this.P(O)?.optimize()}async switch(O,p){return this.w(k.NONE),(0,c.$Nk)(O)?this.R(O,p):this.S(O,p)}M(O,p){return!(O.id===p.id||y(p)&&y(O))}N(O,p,S){this.y(()=>{const s=new Set;for(const[o,t]of O)s.add(o),p.get(o)!==t&&this.u(S,{key:o,external:!0});for(const[o]of p.items)s.has(o)||this.u(S,{key:o,external:!0})})}}e.$_o=E;function y($){return $.isDefault||!!$.useDefaultFlags?.globalState}e.$ap=y;class m extends E{constructor(){super(),this.U=this.B(new b.$6o(new b.$7o,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new b.$6o(new b.$7o,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new b.$6o(new b.$7o,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(O=>this.u(1,O))),this.B(this.W.onDidChangeStorage(O=>this.u(0,O))),this.B(this.U.onDidChangeStorage(O=>this.u(-1,O)))}P(O){switch(O){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(O){switch(O){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(O){return!1}}e.$bp=m;async function u($,O,p,S,s,o){const t=B=>{try{return JSON.parse(B)}catch{return B}},i=new Map,n=new Map;$.forEach((B,_)=>{i.set(_,B),n.set(_,t(B))});const r=new Map,l=new Map;O.forEach((B,_)=>{r.set(_,B),l.set(_,t(B))});const P=new Map,v=new Map;p.forEach((B,_)=>{P.set(_,B),v.set(_,t(B))}),console.group(S!==s?`Storage: Application (path: ${S})`:`Storage: Application & Profile (path: ${S}, default profile)`);const w=[];if(i.forEach((B,_)=>{w.push({key:_,value:B})}),console.table(w),console.groupEnd(),console.log(n),S!==s){console.group(`Storage: Profile (path: ${s}, profile specific)`);const B=[];r.forEach((_,ee)=>{B.push({key:ee,value:_})}),console.table(B),console.groupEnd(),console.log(l)}console.group(`Storage: Workspace (path: ${o})`);const R=[];P.forEach((B,_)=>{R.push({key:_,value:B})}),console.table(R),console.groupEnd(),console.log(v)}e.$cp=u}),define(te[158],ne([0,1,19,20,9,13,35,3,11,25,18,21,27,48,12,6,32,44,142,157,26,175]),function(J,e,L,N,D,A,j,b,h,c,k,I,d,f,E,y,m,u,$,O,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hp=e.$gp=e.$fp=void 0;const s=A.$p?"web":(0,I.$0n)(A.$u,j.$dc),o="X-Market-Search-Activity-Id";var t;(function(a){a[a.None=0]="None",a[a.IncludeVersions=1]="IncludeVersions",a[a.IncludeFiles=2]="IncludeFiles",a[a.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",a[a.IncludeSharedAccounts=8]="IncludeSharedAccounts",a[a.IncludeVersionProperties=16]="IncludeVersionProperties",a[a.ExcludeNonValidated=32]="ExcludeNonValidated",a[a.IncludeInstallationTargets=64]="IncludeInstallationTargets",a[a.IncludeAssetUri=128]="IncludeAssetUri",a[a.IncludeStatistics=256]="IncludeStatistics",a[a.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",a[a.Unpublished=4096]="Unpublished",a[a.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function i(...a){return String(a.reduce((g,z)=>g|z,0))}var n;(function(a){a[a.Tag=1]="Tag",a[a.ExtensionId=4]="ExtensionId",a[a.Category=5]="Category",a[a.ExtensionName=7]="ExtensionName",a[a.Target=8]="Target",a[a.Featured=9]="Featured",a[a.SearchText=10]="SearchText",a[a.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},l={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},v={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:t.None,criteria:[],assetTypes:[]};class w{constructor(g=v){this.d=g}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(g,z=this.d.pageSize){return new w({...this.d,pageNumber:g,pageSize:z})}withFilter(g,...z){const C=[...this.d.criteria,...z.length?z.map(Q=>({filterType:g,value:Q})):[{filterType:g}]];return new w({...this.d,criteria:C})}withSortBy(g){return new w({...this.d,sortBy:g})}withSortOrder(g){return new w({...this.d,sortOrder:g})}withFlags(...g){return new w({...this.d,flags:g.reduce((z,C)=>z|C,0)})}withAssetTypes(...g){return new w({...this.d,assetTypes:g})}withSource(g){return new w({...this.d,source:g})}get raw(){const{criteria:g,pageNumber:z,pageSize:C,sortBy:Q,sortOrder:W,flags:le,assetTypes:ae}=this.d;return{filters:[{criteria:g,pageNumber:z,pageSize:C,sortBy:Q,sortOrder:W}],assetTypes:ae,flags:le}}get searchText(){const g=this.d.criteria.filter(z=>z.filterType===n.SearchText)[0];return g&&g.value?g.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(g=>String(g.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function R(a,g){const z=(a||[]).filter(C=>C.statisticName===g)[0];return z?z.value:0}function B(a){const g="Microsoft.VisualStudio.Code.Translation.";return a.files.filter(C=>C.assetType.indexOf(g)===0).reduce((C,Q)=>{const W=oe(a,Q.assetType);return W&&C.push([Q.assetType.substring(g.length),W]),C},[])}function _(a){if(a.properties){const g=a.properties.filter(Q=>Q.key===r.Repository),z=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),C=g.filter(Q=>z.test(Q.value))[0];return C?{uri:C.value,fallbackUri:C.value}:null}return oe(a,r.Repository)}function ee(a){return{uri:`${a.fallbackAssetUri}/${r.VSIX}?redirect=true${a.targetPlatform?`&targetPlatform=${a.targetPlatform}`:""}`,fallbackUri:`${a.fallbackAssetUri}/${r.VSIX}${a.targetPlatform?`?targetPlatform=${a.targetPlatform}`:""}`}}function oe(a,g){return a.files.filter(C=>C.assetType===g)[0]?{uri:`${a.assetUri}/${g}${a.targetPlatform?`?targetPlatform=${a.targetPlatform}`:""}`,fallbackUri:`${a.fallbackAssetUri}/${g}${a.targetPlatform?`?targetPlatform=${a.targetPlatform}`:""}`}:null}function se(a,g){const z=a.properties?a.properties.filter(Q=>Q.key===g):[],C=z.length>0&&z[0].value;return C?C.split(",").map(Q=>(0,d.$Ho)(Q)):[]}function ue(a){const g=a.properties?a.properties.filter(z=>z.key===l.Engine):[];return g.length>0&&g[0].value||""}function ce(a){const g=a.properties?a.properties.filter(z=>z.key===l.PreRelease):[];return g.length>0&&g[0].value==="true"}function re(a){const g=a.properties?a.properties.filter(C=>C.key===l.LocalizedLanguages):[],z=g.length>0&&g[0].value||"";return z?z.split(","):[]}function q(a){return a.properties?.find(g=>g.key===l.SponsorLink)?.value}function X(a){return a.indexOf("preview")!==-1}function T(a){return a.targetPlatform?(0,I.$9n)(a.targetPlatform):"undefined"}function U(a){const g=(0,L.$Lb)(a.versions.map(T)),z=!!a.tags?.includes(I.$4n),C=g.indexOf("web");return z?C===-1&&g.push("web"):C!==-1&&g.splice(C,1),g}function H(a,g){for(let z=0;z<a.length;z++){const C=a[z];if(C.version===a[z-1]?.version){let Q=z;if(T(C)===g)for(;Q>0&&a[Q-1].version===C.version;)Q--;Q!==z&&(a.splice(z,1),a.splice(Q,0,C))}}return a}e.$fp=H;function G(a,g,z){a.telemetryData={index:g,querySource:z,queryActivityId:a.queryContext?.[o]}}function Z(a,g,z,C){const Q=a.versions[0],W={manifest:oe(g,r.Manifest),readme:oe(g,r.Details),changelog:oe(g,r.Changelog),license:oe(g,r.License),repository:_(g),download:ee(g),icon:oe(g,r.Icon),signature:oe(g,r.Signature),coreTranslations:B(g)};return{identifier:{id:(0,d.$Io)(a.publisher.publisherName,a.extensionName),uuid:a.extensionId},name:a.extensionName,version:g.version,displayName:a.displayName,publisherId:a.publisher.publisherId,publisher:a.publisher.publisherName,publisherDisplayName:a.publisher.displayName,publisherDomain:a.publisher.domain?{link:a.publisher.domain,verified:!!a.publisher.isDomainVerified}:void 0,publisherSponsorLink:q(Q),description:a.shortDescription||"",installCount:R(a.statistics,"install"),rating:R(a.statistics,"averagerating"),ratingCount:R(a.statistics,"ratingcount"),categories:a.categories||[],tags:a.tags||[],releaseDate:Date.parse(a.releaseDate),lastUpdated:Date.parse(a.lastUpdated),allTargetPlatforms:z,assets:W,properties:{dependencies:se(g,l.Dependency),extensionPack:se(g,l.ExtensionPack),engine:ue(g),localizedLanguages:re(g),targetPlatform:T(g),isPreReleaseVersion:ce(g)},hasPreReleaseVersion:ce(Q),hasReleaseVersion:!0,preview:X(a.flags),isSigned:!!W.signature,queryContext:C}}let K=class{constructor(g,z,C,Q,W,le,ae,me){this.k=z,this.l=C,this.n=Q,this.o=W,this.q=le,this.u=ae,this.w=me;const de=ae.extensionsGallery,ge=de?.servicePPEUrl&&me.getValue("_extensionsGallery.enablePPE");this.d=ge?de.servicePPEUrl:de?.serviceUrl,this.g=ge?void 0:de?.searchUrl,this.h=de?.controlUrl,this.j=(0,$.$ep)(ae.version,ae,this.n,this.w,this.q,g,this.o)}x(g=""){return`${this.d}${g}`}isEnabled(){return!!this.d}async getExtensions(g,z,C){const Q=N.CancellationToken.isCancellationToken(z)?{}:z,W=N.CancellationToken.isCancellationToken(z)?z:C,le=[],ae=[],me=[],de=[];let ge=!0;for(const we of g){we.uuid?ae.push(we.uuid):le.push(we.id);const ve=!!(we.version||we.preRelease);me.push({id:we.id,uuid:we.uuid,includePreRelease:ve}),we.version&&de.push({id:we.id,uuid:we.uuid,version:we.version}),ge=ge&&!!we.hasPreRelease&&!ve}if(!ae.length&&!le.length)return[];let fe=new w().withPage(1,g.length);ae.length&&(fe=fe.withFilter(n.ExtensionId,...ae)),le.length&&(fe=fe.withFilter(n.ExtensionName,...le)),(Q.queryAllVersions||ge)&&(fe=fe.withFlags(fe.flags,t.IncludeVersions)),Q.source&&(fe=fe.withSource(Q.source));const{extensions:he}=await this.z(fe,{targetPlatform:Q.targetPlatform??s,includePreRelease:me,versions:de,compatible:!!Q.compatible},W);return Q.source&&he.forEach((we,ve)=>G(we,ve,Q.source)),he}async getCompatibleExtension(g,z,C){if((0,I.$$n)(g.allTargetPlatforms,C))return null;if(await this.isExtensionCompatible(g,z,C))return g;const Q=new w().withFlags(t.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,g.identifier.uuid),{extensions:W}=await this.z(Q,{targetPlatform:C,compatible:!0,includePreRelease:z},N.CancellationToken.None);return W[0]||null}async isExtensionCompatible(g,z,C){if(!(0,I.$_n)(g.properties.targetPlatform,g.allTargetPlatforms,C)||!z&&g.properties.isPreReleaseVersion)return!1;let Q=g.properties.engine;if(!Q){const W=await this.getManifest(g,N.CancellationToken.None);if(!W)throw new Error("Manifest was not found");Q=W.engines.vscode}return(0,f.$Vo)(Q,this.u.version,this.u.date)}async y(g,z,C,Q,W){if(!(0,I.$_n)(T(g),Q,W)||z!=="any"&&ce(g)!==(z==="prerelease"))return!1;if(C)try{const le=await this.E(g);if(!(0,f.$Vo)(le,this.u.version,this.u.date))return!1}catch(le){return this.l.error(`Error while getting the engine for the version ${g.version}.`,(0,D.$9)(le)),!1}return!0}async query(g,z){let C=g.text||"";const Q=g.pageSize??50;let W=new w().withPage(1,Q);C?(C=C.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,fe,he)=>(W=W.withFilter(n.Category,he||fe),"")),C=C.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,fe,he)=>(W=W.withFilter(n.Tag,he||fe),"")),C=C.replace(/\bfeatured(\s+|\b|$)/g,()=>(W=W.withFilter(n.Featured),"")),C=C.trim(),C&&(C=C.length<200?C:C.substring(0,200),W=W.withFilter(n.SearchText,C)),W=W.withSortBy(0)):g.ids?W=W.withFilter(n.ExtensionId,...g.ids):g.names?W=W.withFilter(n.ExtensionName,...g.names):W=W.withSortBy(4),typeof g.sortBy=="number"&&(W=W.withSortBy(g.sortBy)),typeof g.sortOrder=="number"&&(W=W.withSortOrder(g.sortOrder)),g.source&&(W=W.withSource(g.source));const le=async(ge,fe)=>{const{extensions:he,total:we}=await this.z(ge,{targetPlatform:s,compatible:!1,includePreRelease:!!g.includePreRelease},fe);return he.forEach((ve,Se)=>G(ve,(ge.pageNumber-1)*ge.pageSize+Se,g.source)),{extensions:he,total:we}},{extensions:ae,total:me}=await le(W,z),de=async(ge,fe)=>{if(fe.isCancellationRequested)throw new D.$4;const{extensions:he}=await le(W.withPage(ge+1),fe);return he};return{firstPage:ae,total:me,pageSize:W.pageSize,getPage:de}}async z(g,z,C){const Q=g.flags;g.flags&t.IncludeLatestVersionOnly&&g.flags&t.IncludeVersions&&(g=g.withFlags(g.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(g.flags&t.IncludeLatestVersionOnly)&&!(g.flags&t.IncludeVersions)&&(g=g.withFlags(g.flags,t.IncludeLatestVersionOnly)),z.versions?.length&&(g=g.withFlags(g.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),g=g.withFlags(g.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:W,total:le,context:ae}=await this.B(g,C);if(!(g.flags&t.IncludeLatestVersionOnly)){const fe=[];for(const he of W){const we=await this.A(he,z,ae);we&&fe.push(we)}return{extensions:fe,total:le}}const de=[],ge=new Map;for(let fe=0;fe<W.length;fe++){const he=W[fe],we={id:(0,d.$Io)(he.publisher.publisherName,he.extensionName),uuid:he.extensionId},ve=(0,b.$Ff)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(Me=>(0,d.$Do)(Me,we))?.includePreRelease;if(z.compatible&&(0,I.$$n)(U(he),z.targetPlatform))continue;const Se=await this.A(he,z,ae);!Se||Se.properties.isPreReleaseVersion&&(!ve||!Se.hasReleaseVersion)||!Se.properties.isPreReleaseVersion&&Se.properties.targetPlatform!==z.targetPlatform&&Se.hasPreReleaseVersion?ge.set(he.extensionId,fe):de.push([fe,Se])}if(ge.size){const fe=new S.$Kd,he=new w().withFlags(Q&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,ge.size).withFilter(n.ExtensionId,...ge.keys()),{extensions:we}=await this.z(he,z,C);this.o.publicLog2("galleryService:additionalQuery",{duration:fe.elapsed(),count:ge.size});for(const ve of we){const Se=ge.get(ve.identifier.uuid);de.push([Se,ve])}}return{extensions:de.sort((fe,he)=>fe[0]-he[0]).map(([,fe])=>fe),total:le}}async A(g,z,C){const Q={id:(0,d.$Io)(g.publisher.publisherName,g.extensionName),uuid:g.extensionId},W=z.versions?.find(de=>(0,d.$Do)(de,Q))?.version,le=(0,b.$Ff)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(de=>(0,d.$Do)(de,Q))?.includePreRelease,ae=U(g),me=H(g.versions,z.targetPlatform);if(z.compatible&&(0,I.$$n)(ae,z.targetPlatform))return null;for(let de=0;de<me.length;de++){const ge=me[de];if(!(W&&ge.version!==W)){if(await this.y(ge,le?"any":"release",z.compatible,ae,z.targetPlatform))return Z(g,ge,ae,C);if(W&&ge.version===W)return null}}return W||z.compatible?null:Z(g,g.versions[0],ae)}async B(g,z){if(!this.isEnabled())throw new Error("No extension gallery service configured.");g=g.withFlags(g.flags,t.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,i(t.Unpublished));const C=await this.j,Q=JSON.stringify(g.raw),W={...C,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Q.length)},le=new S.$Kd;let ae,me,de=0;try{if(ae=await this.k.request({type:"POST",url:this.g&&g.criteria.some(fe=>fe.filterType===n.SearchText)?this.g:this.x("/extensionquery"),data:Q,headers:W},z),ae.res.statusCode&&ae.res.statusCode>=400&&ae.res.statusCode<500)return{galleryExtensions:[],total:de};const ge=await(0,u.$3o)(ae);if(ge){const fe=ge.results[0],he=fe.extensions,we=fe.resultMetadata&&fe.resultMetadata.filter(ve=>ve.metadataType==="ResultCount")[0];return de=we&&we.metadataItems.filter(ve=>ve.name==="TotalCount")[0].count||0,{galleryExtensions:he,total:de,context:{[o]:ae.res.headers.activityid}}}return{galleryExtensions:[],total:de}}catch(ge){throw me=ge,ge}finally{this.o.publicLog2("galleryService:query",{...g.telemetryData,requestBodySize:String(Q.length),duration:le.elapsed(),success:!!ae&&(0,u.$Yo)(ae),responseBodySize:ae?.res.headers["Content-Length"],statusCode:ae?String(ae.res.statusCode):void 0,errorCode:me?(0,D.$3)(me)?"canceled":(0,D.$9)(me).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(de)})}}async reportStatistic(g,z,C,Q){if(!this.isEnabled())return;const W=A.$p?this.x(`/itemName/${g}.${z}/version/${C}/statType/${Q==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${g}/extensions/${z}/${C}/stats?statType=${Q}`),le=A.$p?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",me={...await this.j,Accept:le};try{await this.k.request({type:"POST",url:W,headers:me},N.CancellationToken.None)}catch{}}async download(g,z,C){this.l.trace("ExtensionGalleryService#download",g.identifier.id);const Q=(0,d.$Lo)(g),W=new Date().getTime(),le=fe=>this.o.publicLog("galleryService:downloadVSIX",{...Q,duration:fe}),ae=C===2?"install":C===3?"update":"",me=ae?{uri:`${g.assets.download.uri}${h.URI.parse(g.assets.download.uri).query?"&":"?"}${ae}=true`,fallbackUri:`${g.assets.download.fallbackUri}${h.URI.parse(g.assets.download.fallbackUri).query?"&":"?"}${ae}=true`}:g.assets.download,de=g.queryContext?.[o]?{[o]:g.queryContext[o]}:void 0,ge=await this.D(me,de?{headers:de}:void 0);await this.q.writeFile(z,ge.stream),le(new Date().getTime()-W)}async downloadSignatureArchive(g,z){if(!g.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",g.identifier.id);const C=await this.D(g.assets.signature);await this.q.writeFile(z,C.stream)}async getReadme(g,z){if(g.assets.readme){const C=await this.D(g.assets.readme,{},z);return await(0,u.$2o)(C)||""}return""}async getManifest(g,z){if(g.assets.manifest){const C=await this.D(g.assets.manifest,{},z),Q=await(0,u.$2o)(C);return Q?JSON.parse(Q):null}return null}async C(g,z){const C=oe(g,r.Manifest);if(!C)throw new Error("Manifest was not found");const Q={"Accept-Encoding":"gzip"},W=await this.D(C,{headers:Q});return await(0,u.$3o)(W)}async getCoreTranslation(g,z){const C=g.assets.coreTranslations.filter(Q=>Q[0]===z.toUpperCase())[0];if(C){const Q=await this.D(C[1]),W=await(0,u.$2o)(Q);return W?JSON.parse(W):null}return null}async getChangelog(g,z){if(g.assets.changelog){const C=await this.D(g.assets.changelog,{},z);return await(0,u.$2o)(C)||""}return""}async getAllCompatibleVersions(g,z,C){let Q=new w().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);g.identifier.uuid?Q=Q.withFilter(n.ExtensionId,g.identifier.uuid):Q=Q.withFilter(n.ExtensionName,g.identifier.id);const{galleryExtensions:W}=await this.B(Q,N.CancellationToken.None);if(!W.length)return[];const le=U(W[0]);if((0,I.$$n)(le,C))return[];const ae=[];await Promise.all(W[0].versions.map(async ge=>{try{await this.y(ge,z?"any":"release",!0,le,C)&&ae.push(ge)}catch{}}));const me=[],de=new Set;for(const ge of H(ae,C))de.has(ge.version)||(de.add(ge.version),me.push({version:ge.version,date:ge.lastUpdated,isPreReleaseVersion:ce(ge)}));return me}async D(g,z={},C=N.CancellationToken.None){const Q=await this.j,W={type:"GET"},le={...Q,...z.headers||{}};z={...z,...W,headers:le};const ae=g.uri,me=g.fallbackUri,de={...z,url:ae};try{const ge=await this.k.request(de,C);if(ge.res.statusCode===200)return ge;const fe=await(0,u.$2o)(ge);throw new Error(`Expected 200, got back ${ge.res.statusCode} instead.

${fe}`)}catch(ge){if((0,D.$3)(ge))throw ge;const fe=(0,D.$9)(ge);this.o.publicLog2("galleryService:cdnFallback",{url:ae,message:fe});const he={...z,url:me};return this.k.request(he,C)}}async E(g){let z=ue(g);if(!z){const C=await this.C(g,N.CancellationToken.None);if(!C)throw new Error("Manifest was not found");z=C.engines.vscode}return z}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const g=await this.k.request({type:"GET",url:this.h},N.CancellationToken.None);if(g.res.statusCode!==200)throw new Error("Could not get extensions report.");const z=await(0,u.$3o)(g),C=[],Q={},W=[];if(z){for(const le of z.malicious)C.push({id:le});if(z.migrateToPreRelease)for(const[le,ae]of Object.entries(z.migrateToPreRelease))(!ae.engine||(0,f.$Vo)(ae.engine,this.u.version,this.u.date))&&(Q[le.toLowerCase()]={disallowInstall:!0,extension:{id:ae.id,displayName:ae.displayName,autoMigrate:{storage:!!ae.migrateStorage},preRelease:!0}});if(z.deprecated)for(const[le,ae]of Object.entries(z.deprecated))ae&&(Q[le.toLowerCase()]=(0,b.$Ff)(ae)?{}:ae);if(z.search)for(const le of z.search)W.push(le)}return{malicious:C,deprecated:Q,search:W}}};K=pe([ie(1,u.$Wo),ie(2,y.$bj),ie(3,k.$1h),ie(4,p.$gl),ie(5,E.$ck),ie(6,m.$tj),ie(7,c.$ni)],K);let M=class extends K{constructor(g,z,C,Q,W,le,ae,me){super(g,z,C,Q,W,le,ae,me)}};e.$gp=M,e.$gp=M=pe([ie(0,O.$0o),ie(1,u.$Wo),ie(2,y.$bj),ie(3,k.$1h),ie(4,p.$gl),ie(5,E.$ck),ie(6,m.$tj),ie(7,c.$ni)],M);let F=class extends K{constructor(g,z,C,Q,W,le,ae){super(void 0,g,z,C,Q,W,le,ae)}};e.$hp=F,e.$hp=F=pe([ie(0,u.$Wo),ie(1,y.$bj),ie(2,k.$1h),ie(3,p.$gl),ie(4,E.$ck),ie(5,m.$tj),ie(6,c.$ni)],F)}),define(te[159],ne([0,1,11,18,12,6,139,22,23,3,68]),function(J,e,L,N,D,A,j,b,h,c,k){"use strict";var I,d;Object.defineProperty(e,"__esModule",{value:!0}),e.$SN=e.$RN=e.$QN=void 0;let f=class extends h.$Rk{static{I=this}static{this.a="profileAssociationsMigration"}constructor(u,$,O,p,S){super(O,p,$,S),this.U=u,this.W=O}O(){return this.U.getItem(I.b,[]).map($=>({...$,location:(0,c.$zf)($.location)?this.w.extUri.joinPath(this.profilesHome,$.location):L.URI.revive($.location)}))}Q(){const u=this.U.getItem(I.c,{});return this.U.getItem(I.a,!1)?u:this.N(u)}S(){return this.w.extUri.joinPath(L.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$QN=f,e.$QN=f=I=pe([ie(0,j.$LN),ie(1,b.$Mk),ie(2,N.$2h),ie(3,D.$ck),ie(4,A.$bj)],f);let E=d=class extends f{constructor(u,$,O,p,S){super(u,$,O,p,S),this.$=u}P(u){u.length?this.$.setItem(d.b,u.map($=>({...$,location:this.w.extUri.basename($.location)}))):this.$.removeItem(d.b)}O(){const u=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(u),this.$.setItem("userDataProfilesMigration",!0)),u}R(u){u.emptyWindows||u.workspaces?this.$.setItem(d.c,u):this.$.removeItem(d.c)}Q(){const u="workspaceAndProfileInfo",$=this.$.getItem(u,void 0);if($){this.$.removeItem(u);const p=$.reduce((S,{workspace:s,profile:o})=>(S[L.URI.revive(s).toString()]=L.URI.revive(o).toString(),S),{});this.$.setItem(d.c,{workspaces:p})}const O=super.Q();return this.$.getItem(d.a,!1)||(this.R(O),this.$.setItem(d.a,!0)),O}};e.$RN=E,e.$RN=E=d=pe([ie(0,j.$MN),ie(1,b.$Mk),ie(2,N.$2h),ie(3,D.$ck),ie(4,A.$bj)],E);let y=class extends E{constructor(u,$,O,p){super(new k.$PN(0,$,p,O),u,$,O,p)}async init(){return await this.$.init(),super.init()}};e.$SN=y,e.$SN=y=pe([ie(0,b.$Mk),ie(1,N.$2h),ie(2,D.$ck),ie(3,A.$bj)],y)}),define(te[51],ne([0,1,125,8,16,3,24,87,176,177]),function(J,e,L,N,D,A,j,b,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=e.$rp=e.zip=e.$pp=e.$op=void 0,e.$op="end of central directory record signature not found";const k=new RegExp(e.$op);class I extends Error{constructor(o,t){let i=t.message;switch(o){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=o,this.cause=t}}e.$pp=I;function d(s){const o=s.externalFileAttributes>>16||33188;return[448,56,7].map(t=>o&t).reduce((t,i)=>t+i,o&61440)}function f(s){if(s instanceof I)return s;let o;return k.test(s.message)&&(o="CorruptZip"),new I(o,s)}function E(s,o,t,i,n,r){const l=D.$lc(o),P=D.$ic(i,l);if(!P.startsWith(i))return Promise.reject(new Error(b.localize(0,null,o)));const v=D.$ic(i,o);let w;return r.onCancellationRequested(()=>{w?.destroy()}),Promise.resolve(j.Promises.mkdir(P,{recursive:!0})).then(()=>new Promise((R,B)=>{if(!r.isCancellationRequested)try{w=(0,L.createWriteStream)(v,{mode:t}),w.once("close",()=>R()),w.once("error",B),s.once("error",B),s.pipe(w)}catch(_){B(_)}}))}function y(s,o,t,i){let n=(0,N.$Ig)(()=>Promise.resolve()),r=0;const l=i.onCancellationRequested(()=>{n.cancel(),s.close()});return new Promise((P,v)=>{const w=new N.$Pg,R=B=>{B.isCancellationRequested||(r++,s.readEntry())};s.once("error",v),s.once("close",()=>n.then(()=>{i.isCancellationRequested||s.entryCount===r?P():v(new I("Incomplete",new Error(b.localize(1,null,r,s.entryCount))))},v)),s.readEntry(),s.on("entry",B=>{if(i.isCancellationRequested)return;if(!t.sourcePathRegex.test(B.fileName)){R(i);return}const _=B.fileName.replace(t.sourcePathRegex,"");if(/\/$/.test(_)){const se=D.$ic(o,_);n=(0,N.$Ig)(ue=>j.Promises.mkdir(se,{recursive:!0}).then(()=>R(ue)).then(void 0,v));return}const ee=u(s,B),oe=d(B);n=(0,N.$Ig)(se=>w.queue(()=>ee.then(ue=>E(ue,_,oe,o,t,se).then(()=>R(se)))).then(null,v))})}).finally(()=>l.dispose())}function m(s,o=!1){return new Promise((t,i)=>{(0,h.open)(s,o?{lazyEntries:!0}:void 0,(n,r)=>{n?i(f(n)):t((0,A.$Kf)(r))})})}function u(s,o){return new Promise((t,i)=>{s.openReadStream(o,(n,r)=>{n?i(f(n)):t((0,A.$Kf)(r))})})}function $(s,o){return new Promise((t,i)=>{const n=new c.ZipFile;o.forEach(l=>{l.contents?n.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&n.addFile(l.localPath,l.path)}),n.end();const r=(0,L.createWriteStream)(s);n.outputStream.pipe(r),n.outputStream.once("error",i),r.once("error",i),r.once("finish",()=>t(s))})}e.zip=$;function O(s,o,t={},i){const n=new RegExp(t.sourcePath?`^${t.sourcePath}`:"");let r=m(s,!0);return t.overwrite&&(r=r.then(l=>j.Promises.rm(o).then(()=>l))),r.then(l=>y(l,o,{sourcePathRegex:n},i))}e.$rp=O;function p(s,o){return m(s).then(t=>new Promise((i,n)=>{t.on("entry",r=>{r.fileName===o&&u(t,r).then(l=>i(l),l=>n(l))}),t.once("close",()=>n(new Error(b.localize(2,null,o))))}))}function S(s,o){return p(s,o).then(t=>new Promise((i,n)=>{const r=[];t.once("error",n),t.on("data",l=>r.push(l)),t.on("end",()=>i(Buffer.concat(r)))}))}e.$sp=S}),define(te[160],ne([0,1,8,9,2,15,17,42,3,28,24,51,25,18,21,27,60,12,6]),function(J,e,L,N,D,A,j,b,h,c,k,I,d,f,E,y,m,u,$){"use strict";var O;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hp=void 0;let p=class extends D.$Rc{static{O=this}static{this.c=".sigzip"}constructor(s,o,t,i,n,r){super(),this.h=o,this.j=t,this.m=i,this.n=n,this.r=r,this.extensionsDownloadDir=s.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(s,o,t){await this.g;const i=(0,j.$wg)(this.extensionsDownloadDir,this.z(s));try{await this.w(s,i,r=>this.j.download(s,r,o))}catch(r){throw new E.$co(r.message,E.ExtensionManagementErrorCode.Download)}let n=!1;if(t&&this.t(s)){const r=await this.u(s);try{n=await this.n.verify(i.fsPath,r.fsPath,this.r.getLevel()===$.LogLevel.Trace)}catch(l){const P=l;if(n=P.code,P.output&&this.r.trace(`Extension signature verification details for ${s.identifier.id} ${s.version}:
${P.output}`),n===E.ExtensionSignaturetErrorCode.PackageIsInvalidZip||n===E.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new E.$co(I.$op,E.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(r)}catch(l){this.r.error(l)}}}return n===!0?this.r.info(`Extension signature is verified: ${s.identifier.id}`):n===!1?this.r.info(`Extension signature verification is not done: ${s.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${n}': ${s.identifier.id}`),{location:i,verificationStatus:n}}t(s){if(!s.isSigned)return!1;const o=this.m.getValue("extensions.verifySignature");return(0,h.$Ff)(o)?o:!0}async u(s){await this.g;const o=(0,j.$wg)(this.extensionsDownloadDir,`${this.z(s)}${O.c}`);return await this.w(s,o,t=>this.j.downloadSignatureArchive(s,t)),o}async w(s,o,t){if(await this.h.exists(o))return;if(o.scheme!==A.Schemas.file){await t(o);return}const i=(0,j.$wg)(this.extensionsDownloadDir,`.${(0,c.$fg)()}`);await this.h.exists(i)||await t(i);try{await k.Promises.rename(i.fsPath,o.fsPath,2*60*1e3)}catch(n){try{await this.h.del(i)}catch{}if(n.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",s.identifier.id,o.path);else throw this.r.info(`Rename failed because of ${(0,N.$9)(n)}. Deleted the file from downloaded location`,i.path),n}}async delete(s){await this.g,await this.h.del(s)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const s=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(s.children){const o=[],t=[],i=[];for(const l of s.children)if(l.name.endsWith(O.c))i.push(l.resource);else{const P=y.$Eo.parse(l.name);P&&t.push([P,l])}const n=(0,y.$Jo)(t,([l])=>l),r=[];for(const l of n)l.sort((P,v)=>b.rcompare(P[0].version,v[0].version)),o.push(...l.slice(1).map(P=>P[1].resource)),r.push(l[0][1]);r.sort((l,P)=>l.mtime-P.mtime),o.push(...r.slice(0,Math.max(0,r.length-this.f)).map(l=>l.resource)),o.push(...i),await L.Promises.settled(o.map(l=>(this.r.trace("Deleting from cache",l.path),this.h.del(l))))}}catch(s){this.r.error(s)}}z(s){return this.f?y.$Eo.create(s).toString().toLowerCase():(0,c.$fg)()}};e.$Hp=p,e.$Hp=p=O=pe([ie(0,f.$2h),ie(1,u.$ck),ie(2,E.$bo),ie(3,d.$ni),ie(4,m.$ip),ie(5,$.$bj)],p)}),define(te[161],ne([0,1,51,97]),function(J,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=void 0;function D(A){return(0,L.$sp)(A,"extension/package.json").then(j=>{try{return JSON.parse(j.toString("utf8"))}catch{throw new Error((0,N.localize)(0,null))}})}e.$Jp=D}),define(te[162],ne([0,1,8,14,20,34,9,4,41,2,31,15,16,17,42,3,11,28,24,51,96,59,18,153,21,27,40,50,160,154,161,134,141,48,12,10,6,32,26,22,23]),function(J,e,L,N,D,A,j,b,h,c,k,I,d,f,E,y,m,u,$,O,p,S,s,o,t,i,n,r,l,P,v,w,R,B,_,ee,oe,se,ue,ce,re){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=e.$Op=e.$Np=e.$Mp=void 0,e.$Mp=(0,ee.$Uh)(t.$do);const q=".vsctmp";let X=class extends o.$tp{constructor(M,F,a,g,z,C,Q,W,le,ae,me,de){super(M,F,me,a,ae,de),this.fb=z,this.gb=C,this.hb=Q,this.ib=le,this.eb=new Map,this.rb=new k.$Ac;const ge=this.B(W.createInstance(P.$Ip));this.bb=this.B(W.createInstance(T,he=>ge.postUninstall(he))),this.cb=this.B(new w.$Kp(de,le,me,this,this.F)),this.db=this.B(W.createInstance(l.$Hp));const fe=this.B(new R.$Lp(this,this.fb,de,C,me,le,a));this.B(fe.onDidChangeExtensionsByAnotherSource(he=>this.qb(he))),this.sb()}getTargetPlatform(){return this.jb||(this.jb=(0,i.$Oo)(this.ib,this.F)),this.jb}async zip(M){this.F.trace("ExtensionManagementService#zip",M.identifier.id);const F=await this.pb(M),a=await(0,O.zip)((0,f.$wg)(this.db.extensionsDownloadDir,(0,u.$fg)()).fsPath,F);return m.URI.file(a)}async unzip(M){return this.F.trace("ExtensionManagementService#unzip",M.toString()),(await this.install(M)).identifier}async getManifest(M){const{location:F,cleanup:a}=await this.lb(M),g=d.$jc(F.fsPath);try{return await(0,v.$Jp)(g)}finally{await a()}}getInstalled(M,F=this.H.defaultProfile.extensionsResource){return this.bb.scanExtensions(M??null,F)}scanAllUserInstalledExtensions(){return this.bb.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(M){return this.bb.scanUserExtensionAtLocation(M)}async install(M,F={}){this.F.trace("ExtensionManagementService#install",M.toString());const{location:a,cleanup:g}=await this.lb(M);try{const z=await(0,v.$Jp)(d.$jc(a.fsPath)),C=(0,i.$Io)(z.publisher,z.name);if(z.engines&&z.engines.vscode&&!(0,B.$Vo)(z.engines.vscode,this.G.version,this.G.date))throw new Error(p.localize(0,null,C,this.G.version));const W=(await this.I([{manifest:z,extension:a,options:F}])).find(({identifier:le})=>(0,i.$Do)(le,{id:C}));if(W?.local)return W.local;throw W?.error?W.error:(0,o.$vp)(new Error(`Unknown error while installing extension ${C}`))}finally{await g()}}async installFromLocation(M,F){this.F.trace("ExtensionManagementService#installFromLocation",M.toString());const a=await this.bb.scanUserExtensionAtLocation(M);if(!a)throw new Error(`Cannot find a valid extension from the location ${M.toString()}`);return await this.ub([[a,void 0]],F),this.F.info("Successfully installed extension",a.identifier.id,F.toString()),a}async installExtensionsFromProfile(M,F,a){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",M,F.toString(),a.toString());const g=(await this.bb.scanExtensions(1,F)).filter(z=>M.some(C=>(0,i.$Do)(C,z.identifier)));if(g.length){const z=await Promise.all(g.map(C=>this.bb.scanMetadata(C,F)));await this.ub(g.map((C,Q)=>[C,z[Q]]),a),this.F.info("Successfully installed extensions",g.map(C=>C.identifier.id),a.toString())}return g}async updateMetadata(M,F,a=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",M.identifier.id),F.isPreReleaseVersion&&(F.preRelease=!0),F.isMachineScoped===!1&&(F.isMachineScoped=void 0),F.isBuiltin===!1&&(F.isBuiltin=void 0),F.pinned===!1&&(F.pinned=void 0),M=await this.bb.updateMetadata(M,F,a),this.cb.invalidate(a),this.w.fire(M),M}async reinstallFromGallery(M){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",M.identifier.id),!this.z.isEnabled())throw new Error(p.localize(1,null));const F=await this.getTargetPlatform(),[a]=await this.z.getExtensions([{...M.identifier,preRelease:M.preRelease}],{targetPlatform:F,compatible:!0},D.CancellationToken.None);if(!a)throw new Error(p.localize(2,null));await this.bb.setUninstalled(M);try{await this.bb.removeUninstalledExtension(M)}catch(g){throw new Error(p.localize(3,null,(0,A.$Ei)(g)))}return this.installFromGallery(a)}ab(M,F,a,g){return this.bb.copyExtension(M,F,a,g)}copyExtensions(M,F){return this.bb.copyExtensions(M,F)}markAsUninstalled(...M){return this.bb.setUninstalled(...M)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.bb.cleanUp()}catch(M){this.F.error(M)}}async download(M,F,a){const{location:g}=await this.db.download(M,F,!a);return g}async lb(M){if(M.scheme===I.Schemas.file)return{location:M,async cleanup(){}};this.F.trace("Downloading extension from",M.toString());const F=(0,f.$wg)(this.db.extensionsDownloadDir,(0,u.$fg)());return await this.hb.download(M,F),this.F.info("Downloaded extension to",F.toString()),{location:F,cleanup:async()=>{try{await this.ib.del(F)}catch(g){this.F.error(g)}}}}Y(){return this.H.defaultProfile.extensionsResource}Z(M,F,a){if(m.URI.isUri(F))return new G(M,F,a,this.z,this.bb,this.D,this.H,this.fb,this.gb,this.F);const g=i.$Eo.create(F).toString();let z=this.eb.get(g);return z||(this.eb.set(g,z=new H(M,F,a,this.db,this.bb,this.D,this.H,this.fb,this.gb,this.F)),z.waitUntilTaskIsFinished().finally(()=>this.eb.delete(g))),z}$(M,F){return new Z(M,F.profileLocation,this.gb)}async pb(M){const F=async g=>{let z=await $.Promises.readdir(g);z=z.map(W=>d.$ic(g,W));const C=await Promise.all(z.map(W=>$.Promises.stat(W)));let Q=Promise.resolve([]);return C.forEach((W,le)=>{const ae=z[le];W.isFile()&&(Q=Q.then(me=>[...me,ae])),W.isDirectory()&&(Q=Q.then(me=>F(ae).then(de=>[...me,...de])))}),Q};return(await F(M.location.fsPath)).map(g=>({path:`extension/${d.$kc(M.location.fsPath,g)}`,localPath:g}))}async qb({added:M,removed:F}){if(F){const a=M&&this.D.extUri.isEqual(F.profileLocation,M.profileLocation)?F.extensions.filter(g=>M.extensions.every(z=>!(0,i.$Do)(z,g))):F.extensions;for(const g of a)this.F.info("Extensions removed from another source",g.id,F.profileLocation.toString()),this.u.fire({identifier:g,profileLocation:F.profileLocation})}if(M){const g=(await this.bb.scanExtensions(1,M.profileLocation)).filter(z=>M.extensions.some(C=>(0,i.$Do)(C,z.identifier)));this.s.fire(g.map(z=>(this.F.info("Extensions added from another source",z.identifier.id,M.profileLocation.toString()),{identifier:z.identifier,local:z,profileLocation:M.profileLocation,operation:1})))}}async sb(){this.B(this.bb.onExtract(F=>this.rb.add(F)));const M=await this.ib.resolve(this.fb.userExtensionsLocation);for(const F of M.children??[])F.isDirectory&&this.rb.add(F.resource);this.B(this.ib.watch(this.fb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(F=>this.tb(F)))}async tb(M){if(!M.affects(this.fb.userExtensionsLocation,1))return;const F=[];for(const a of M.rawAdded){if(this.rb.has(a)||!this.D.extUri.isEqual(this.D.extUri.dirname(a),this.fb.userExtensionsLocation)||this.D.extUri.isEqual(a,this.D.extUri.joinPath(this.fb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(a).startsWith(".")||!(await this.ib.stat(a)).isDirectory)continue;const g=await this.bb.scanUserExtensionAtLocation(a);g&&g.installedTimestamp===void 0&&(this.rb.add(a),F.push(g))}F.length&&(await this.ub(F.map(a=>[a,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",F.map(a=>a.identifier.id)))}async ub(M,F){const a=M.map(g=>g[0]);await this.vb(a),await this.gb.addExtensionsToProfile(M,F),this.s.fire(a.map(g=>({local:g,identifier:g.identifier,operation:1,profileLocation:F})))}async vb(M){const F=await this.bb.getUninstalledExtensions();for(const a of M){const g=i.$Eo.create(a);F[g.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",g.id),await this.bb.setInstalled(g),this.F.info("Removed the extension from uninstalled list:",g.id))}}};e.$Np=X,e.$Np=X=pe([ie(0,t.$bo),ie(1,ue.$gl),ie(2,oe.$bj),ie(3,s.$2h),ie(4,r.$Cp),ie(5,n.$yp),ie(6,S.$Sn),ie(7,ee.$Sh),ie(8,_.$ck),ie(9,se.$tj),ie(10,ce.$Mk),ie(11,re.$Ok)],X);let T=class extends c.$Rc{constructor(M,F,a,g,z,C){super(),this.j=M,this.m=F,this.n=a,this.s=g,this.t=z,this.u=C,this.h=this.B(new b.$Od),this.onExtract=this.h.event,this.c=(0,f.$wg)(this.n.userExtensionsLocation,".obsolete"),this.g=new L.$3g}async cleanUp(){await this.H(),await this.G()}async scanExtensions(M,F){const a={includeInvalid:!0,profileLocation:F};let g=[];return M===null||M===0?g.push(...await this.n.scanAllExtensions({includeInvalid:!0},a,!1)):M===1&&g.push(...await this.n.scanUserExtensions(a)),g=M!==null?g.filter(z=>z.type===M):g,Promise.all(g.map(z=>this.F(z)))}async scanAllUserExtensions(M){const F=await this.n.scanUserExtensions({includeAllVersions:!M,includeInvalid:!0});return Promise.all(F.map(a=>this.F(a)))}async scanUserExtensionAtLocation(M){try{const F=await this.n.scanExistingExtension(M,1,{includeInvalid:!0});if(F)return await this.F(F)}catch(F){this.u.error(F)}return null}async extractUserExtension(M,F,a,g,z){const C=M.toString(),Q=m.URI.file(d.$ic(this.n.userExtensionsLocation.fsPath,`.${(0,u.$fg)()}`)),W=m.URI.file(d.$ic(this.n.userExtensionsLocation.fsPath,C));let le=await this.m.exists(W);if(le&&g){try{await this.y(M.id,W,"removeExisting")}catch{throw new t.$co(p.localize(4,null,W.fsPath,M.id),t.ExtensionManagementErrorCode.Delete)}le=!1}if(!le)try{try{this.u.trace(`Started extracting the extension from ${F} to ${W.fsPath}`),await(0,O.$rp)(F,Q.fsPath,{sourcePath:"extension",overwrite:!0},z),this.u.info(`Extracted extension to ${W}:`,M.id)}catch(ae){let me=t.ExtensionManagementErrorCode.Extract;throw ae instanceof O.$pp&&(ae.type==="CorruptZip"?me=t.ExtensionManagementErrorCode.CorruptZip:ae.type==="Incomplete"&&(me=t.ExtensionManagementErrorCode.IncompleteZip)),new t.$co(ae.message,me)}await this.n.updateMetadata(Q,a);try{this.u.trace(`Started renaming the extension from ${Q.fsPath} to ${W.fsPath}`),await this.C(Q.fsPath,W.fsPath),this.u.info("Renamed to",W.fsPath)}catch(ae){if(ae.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",M.id);else throw this.u.info(`Rename failed because of ${(0,j.$9)(ae)}. Deleted from extracted location`,Q),ae}this.h.fire(W)}catch(ae){try{await this.m.del(Q,{recursive:!0})}catch{}throw ae}return this.D(W,1)}async scanMetadata(M,F){return F?(await this.w(M,F))?.metadata:this.n.scanMetadata(M.location)}async w(M,F){return(await this.s.scanProfileExtensions(F)).find(g=>(0,i.$Do)(g.identifier,M.identifier))}async updateMetadata(M,F,a){return a?await this.s.updateMetadata([[M,F]],a):await this.n.updateMetadata(M.location,F),this.D(M.location,M.type,a)}getUninstalledExtensions(){return this.z()}async setUninstalled(...M){const F=M.map(a=>i.$Eo.create(a));await this.z(a=>F.forEach(g=>{a[g.toString()]=!0,this.u.info("Marked extension as uninstalled",g.toString())}))}async setInstalled(M){await this.z(F=>delete F[M.toString()])}async removeExtension(M,F){if(this.t.extUri.isEqualOrParent(M.location,this.n.userExtensionsLocation))return this.y(M.identifier.id,M.location,F)}async removeUninstalledExtension(M){await this.removeExtension(M,"uninstalled"),await this.z(F=>delete F[i.$Eo.create(M).toString()])}async copyExtension(M,F,a,g){const z=await this.w(M,F),C=await this.w(M,a);return g={...z?.metadata,...g},C?await this.s.updateMetadata([[M,{...C.metadata,...g}]],a):await this.s.addExtensionsToProfile([[M,g]],a),this.D(M.location,M.type,a)}async copyExtensions(M,F){const a=await this.scanExtensions(1,M),g=await Promise.all(a.filter(z=>!z.isApplicationScoped).map(async z=>[z,await this.scanMetadata(z,M)]));await this.s.addExtensionsToProfile(g,F)}async y(M,F,a){this.u.trace(`Deleting ${a} extension from disk`,M,F.fsPath);const g=this.t.extUri.joinPath(this.t.extUri.dirname(F),`${this.t.extUri.basename(F)}.${(0,h.$Hi)((0,u.$fg)()).toString(16)}${q}`);await this.C(F.fsPath,g.fsPath),await this.m.del(g,{recursive:!0}),this.u.info(`Deleted ${a} extension from disk`,M,F.fsPath)}async z(M){return this.g.queue(async()=>{let F;try{F=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(g){if((0,_.$tk)(g)!==1)throw g}let a={};if(F)try{a=JSON.parse(F)}catch{}return M&&(M(a),Object.keys(a).length?await this.m.writeFile(this.c,N.$ce.fromString(JSON.stringify(a))):await this.m.del(this.c)),a})}async C(M,F){try{await $.Promises.rename(M,F,2*60*1e3)}catch(a){throw new t.$co(a.message||p.localize(5,null,M,F),a.code||t.ExtensionManagementErrorCode.Rename)}}async D(M,F,a){if(a){const z=(await this.n.scanUserExtensions({profileLocation:a})).find(C=>this.t.extUri.isEqual(C.location,M));if(z)return this.F(z)}else{const g=await this.n.scanExistingExtension(M,F,{includeInvalid:!0});if(g)return this.F(g)}throw new Error(p.localize(6,null,M.path))}async F(M){const F=await this.m.resolve(M.location);let a,g;return F.children&&(a=F.children.find(({name:z})=>/^readme(\.txt|\.md|)$/i.test(z))?.resource,g=F.children.find(({name:z})=>/^changelog(\.txt|\.md|)$/i.test(z))?.resource),{identifier:M.identifier,type:M.type,isBuiltin:M.isBuiltin||!!M.metadata?.isBuiltin,location:M.location,manifest:M.manifest,targetPlatform:M.targetPlatform,validations:M.validations,isValid:M.isValid,readmeUrl:a,changelogUrl:g,publisherDisplayName:M.metadata?.publisherDisplayName||null,publisherId:M.metadata?.publisherId||null,isApplicationScoped:!!M.metadata?.isApplicationScoped,isMachineScoped:!!M.metadata?.isMachineScoped,isPreReleaseVersion:!!M.metadata?.isPreReleaseVersion,preRelease:!!M.metadata?.preRelease,installedTimestamp:M.metadata?.installedTimestamp,updated:!!M.metadata?.updated,pinned:!!M.metadata?.pinned}}async G(){const M=await this.getUninstalledExtensions();if(Object.keys(M).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(M));const F=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),a=new Set;for(const z of F)M[i.$Eo.create(z).toString()]||a.add(z.identifier.id.toLowerCase());try{const z=(0,i.$Jo)(F,C=>C.identifier);await L.Promises.settled(z.map(async C=>{const Q=C.sort((W,le)=>E.rcompare(W.manifest.version,le.manifest.version))[0];a.has(Q.identifier.id.toLowerCase())||await this.j(await this.F(Q))}))}catch(z){this.u.error(z)}const g=F.filter(z=>z.metadata&&M[i.$Eo.create(z).toString()]);await Promise.allSettled(g.map(z=>this.removeUninstalledExtension(z)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let M;try{M=await this.m.resolve(this.n.userExtensionsLocation)}catch(F){(0,_.$tk)(F)!==1&&this.u.error(F);return}if(M?.children)try{await Promise.allSettled(M.children.map(async F=>{if(!(!F.isDirectory||!F.name.endsWith(q))){this.u.trace("Deleting the temporarily deleted folder",F.resource.toString());try{await this.m.del(F.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",F.resource.toString())}catch(a){(0,_.$tk)(a)!==1&&this.u.error(a)}}}))}catch{}}};e.$Op=T,e.$Op=T=pe([ie(1,_.$ck),ie(2,r.$Cp),ie(3,n.$yp),ie(4,ce.$Mk),ie(5,oe.$bj)],T);class U extends o.$wp{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,y.$Gf)(this.options.operation)?this.l:this.options.operation}constructor(M,F,a,g,z,C,Q,W,le){super(),this.identifier=M,this.source=F,this.options=a,this.m=g,this.n=z,this.o=C,this.p=Q,this.q=W,this.s=le,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(M){const[F,a]=await this.x(M);return this.j=F.isBuiltin||F.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[F,a]],this.j),F}async u({zipPath:M,key:F,metadata:a},g,z){let C=await this.v(F);return C||(this.s.trace("Extracting extension...",F.id),C=await this.m.extractUserExtension(F,M,a,g,z),this.s.info("Extracting extension completed.",F.id)),C}async v(M){return await this.w(M)?(this.s.trace("Removing the extension from uninstalled list:",M.id),await this.m.setInstalled(M),this.s.info("Removed the extension from uninstalled list:",M.id),(await this.m.scanAllUserExtensions(!0)).find(g=>i.$Eo.create(g).equals(M))):void 0}async w(M){return!!(await this.m.getUninstalledExtensions())[M.toString()]}}class H extends U{constructor(M,F,a,g,z,C,Q,W,le,ae){super(F.identifier,F,a,z,C,Q,W,le,ae),this.y=F,this.z=g}async x(M){const a=(await this.m.scanExtensions(null,this.options.profileLocation)).find(Q=>(0,i.$Do)(Q.identifier,this.y.identifier));a&&(this.l=3);const g={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||a?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||a?.isMachineScoped,isBuiltin:this.options.isBuiltin||a?.isBuiltin,isSystem:a?.type===0?!0:void 0,updated:!!a,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0,preRelease:this.y.properties.isPreReleaseVersion||((0,y.$Ff)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:a?.preRelease)};if(a?.manifest.version===this.y.version)return[await this.m.updateMetadata(a,g),g];const{location:z,verificationStatus:C}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=C,this.B(z.fsPath),[await this.u({zipPath:z.fsPath,key:i.$Eo.create(this.y),metadata:g},!1,M),g]}catch(Q){try{await this.z.delete(z)}catch(W){this.s.warn("Error while deleting the downloaded file",z.toString(),(0,j.$9)(W))}throw Q}}async B(M){try{await(0,v.$Jp)(M)}catch(F){throw new t.$co((0,o.$up)(F).message,t.ExtensionManagementErrorCode.Invalid)}}}e.$Pp=H;class G extends U{constructor(M,F,a,g,z,C,Q,W,le,ae){super({id:(0,i.$Io)(M.publisher,M.name)},F,a,z,C,Q,W,le,ae),this.y=M,this.z=F,this.A=g}async h(M){const F=await super.h(M);return this.D(F,M),F}async x(M){const F=new i.$Eo(this.identifier,this.y.version),g=(await this.m.scanExtensions(1,this.options.profileLocation)).find(Q=>(0,i.$Do)(this.identifier,Q.identifier)),z={isApplicationScoped:this.options.isApplicationScoped||g?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||g?.isMachineScoped,isBuiltin:this.options.isBuiltin||g?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0};if(g)if(this.l=3,F.equals(new i.$Eo(g.identifier,g.manifest.version)))try{await this.m.removeExtension(g,"existing")}catch{throw new Error(p.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&E.gt(g.manifest.version,this.y.version)&&await this.m.setUninstalled(g);else{const Q=await this.v(F);if(Q)try{await this.m.removeExtension(Q,"existing")}catch{throw new Error(p.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:d.$jc(this.z.fsPath),key:F,metadata:z},!0,M),z]}async D(M,F){try{let[a]=await this.A.getExtensions([{id:M.identifier.id,version:M.manifest.version}],F);if(a||([a]=await this.A.getExtensions([{id:M.identifier.id}],F)),a){const g={id:a.identifier.uuid,publisherDisplayName:a.publisherDisplayName,publisherId:a.publisherId,isPreReleaseVersion:a.properties.isPreReleaseVersion,preRelease:a.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(M,g,this.options.profileLocation)}}catch{}}}class Z extends o.$wp{constructor(M,F,a){super(),this.extension=M,this.j=F,this.k=a}async h(M){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(te[163],ne([0,1,137,8,14,9,3,25,18,138,6,44,136,178]),function(J,e,L,N,D,A,j,b,h,c,k,I,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=e.$3q=void 0;let E=class extends I.$Xo{constructor($,O,p,S){super(S),this.m=$,this.n=O,this.r=p,this.s(),this.B($.onDidChangeConfiguration(s=>{s.affectsConfiguration("http")&&this.s()}))}s(){const $=this.m.getValue("http");this.f=$?.proxy,this.g=!!$?.proxyStrictSSL,this.h=$?.proxyAuthorization}async request($,O){const{f:p,g:S}=this;let s;try{s=await(0,c.$Xl)(this.m,this.r,this.n.args,process.env)}catch(i){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,A.$9)(i)))}const o={...process.env,...s},t=$.agent?$.agent:await(0,d.$2q)($.url||"",o,{proxyUrl:p,strictSSL:S});return $.agent=t,$.strictSSL=S,this.h&&($.headers={...$.headers||{},"Proxy-Authorization":this.h}),this.c($.isChromiumNetwork?"electron":"node",$,()=>m($,O))}async resolveProxy($){}};e.$3q=E,e.$3q=E=pe([ie(0,b.$ni),ie(1,h.$2h),ie(2,k.$bj),ie(3,k.$cj)],E);async function y(u){return((0,L.parse)(u.url).protocol==="https:"?await new Promise((p,S)=>{J(["https"],p,S)}):await new Promise((p,S)=>{J(["http"],p,S)})).request}async function m(u,$){return N.Promises.withAsyncBody(async(O,p)=>{const S=(0,L.parse)(u.url),s=u.getRawRequest?u.getRawRequest(u):await y(u),o={hostname:S.hostname,port:S.port?parseInt(S.port):S.protocol==="https:"?443:80,protocol:S.protocol,path:S.path,method:u.type||"GET",headers:u.headers,agent:u.agent,rejectUnauthorized:(0,j.$Ff)(u.strictSSL)?u.strictSSL:!0};u.user&&u.password&&(o.auth=u.user+":"+u.password);const t=s(o,i=>{const n=(0,j.$Df)(u.followRedirects)?u.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)m({...u,url:i.headers.location,followRedirects:n-1},$).then(O,p);else{let r=i;!u.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(r=i.pipe((0,f.createGunzip)())),O({res:i,stream:(0,D.$re)(r)})}});t.on("error",p),u.timeout&&t.setTimeout(u.timeout),u.isChromiumNetwork&&t.removeHeader("Content-Length"),u.data&&typeof u.data=="string"&&t.write(u.data),t.end(),$.onCancellationRequested(()=>{t.abort(),p(new A.$4)})})}e.$4q=m}),define(te[179],ne([0,1,33,8,34,9,2,15,16,13,35,11,24,25,133,59,135,18,111,158,21,60,140,40,50,162,156,12,122,124,49,120,63,64,143,6,129,38,130,146,32,44,163,68,69,26,145,39,147,148,22,150,23,159,149,155,126,128,5,151]),function(J,e,L,N,D,A,j,b,h,c,k,I,d,f,E,y,m,u,$,O,p,S,s,o,t,i,n,r,l,P,v,w,R,B,_,ee,oe,se,ue,ce,re,q,X,T,U,H,G,Z,K,M,F,a,g,z,C,Q,W,le,ae,me){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class de extends j.$Rc{constructor(he){super(),this.b=he,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[he,we]=await this.f();return he.invokeFunction(async ve=>{const Se=ve.get(ee.$bj),Me=ve.get(r.$ck),V=ve.get(u.$2h),Y=ve.get(g.$Ok);Se.info("CLI main",this.b),this.g(Se),await this.h(V,Me,Y,he),await Promise.all(we.map(x=>{(0,N.$Mg)(x.flush(),1e3)}))})}async f(){const he=new R.$Rh,we={_serviceBrand:void 0,...ce.default};he.set(re.$tj,we);const ve=new $.$nm(this.b,we);he.set(u.$2h,ve),await Promise.all([ve.appSettingsHome.with({scheme:b.Schemas.file}).fsPath,ve.extensionsPath].map(Ae=>Ae?d.Promises.mkdir(Ae,{recursive:!0}):void 0));const Se=new le.$KN((0,ee.$pj)(ve),ve.logsHome);he.set(ee.$cj,Se);const Me=this.B(Se.createLogger("cli",{name:(0,ae.localize)(0,null)})),V=[];Se.getLogLevel()===ee.LogLevel.Trace&&V.push(new ee.$jj(Se.getLogLevel()));const Y=this.B(new W.$UN(Me,V));he.set(ee.$bj,Y);const x=this.B(new l.$Rp(Y));he.set(r.$ck,x);const $e=this.B(new P.$eq(Y));x.registerProvider(b.Schemas.file,$e);const ye=new a.$Dr(x);he.set(F.$Mk,ye);const De=new T.$ON(1,ve,Y,x),ke=new z.$QN(De,ye,ve,x,Y);he.set(g.$Ok,ke),x.registerProvider(b.Schemas.vscodeUserData,new me.$c9b(b.Schemas.file,$e,b.Schemas.vscodeUserData,ke,ye,Y));const Le=c.$j&&we.win32RegValueName?this.B(new ue.$a9b(Y,we.win32RegValueName)):ve.policyFile?this.B(new oe.$b9b(ve.policyFile,x,Y)):new se.$on;he.set(se.$mn,Le);const Ie=this.B(new E.$On(ke.defaultProfile.settingsResource,x,Le,Y));he.set(f.$ni,Ie),await Promise.all([De.init(),Ie.initialize()]);let je;try{je=await(0,C.$Q8b)(De,Y)}catch(Ae){Ae.code!=="ENOENT"&&Y.error(Ae)}const Ue=await(0,C.$R8b)(De,Y);ke.init(),he.set(F.$Mk,new a.$Dr(x));const Oe=new X.$3q(Ie,ve,Y,Se);he.set(q.$Wo,Oe),he.set(y.$Sn,new v.$Qh(m.$0N,void 0,!0)),he.set(o.$yp,new v.$Qh(Q.$TN,void 0,!0)),he.set(t.$Cp,new v.$Qh(n.$N8b,void 0,!0)),he.set(S.$ip,new v.$Qh(S.$jp,void 0,!0)),he.set(i.$Mp,new v.$Qh(i.$Np,void 0,!0)),he.set(p.$bo,new v.$Qh(O.$hp,void 0,!0)),he.set(B.$Wq,new v.$Qh(_.$Yq,void 0,!1));const Ne=[],ze=(0,Z.$Ao)(we,Ie);if((0,Z.$vo)(we,ve)){we.aiConfig&&we.aiConfig.ariaKey&&Ne.push(new K.$IN(Oe,ze,"monacoworkbench",null,we.aiConfig.ariaKey));const Ae={appenders:Ne,sendErrorTelemetry:!1,commonProperties:(0,U.$lo)((0,L.release)(),(0,L.hostname)(),process.arch,we.commit,we.version,je,Ue,ze),piiPaths:(0,Z.$Bo)(ve)};he.set(H.$gl,new v.$Qh(G.$5q,[Ae],!1))}else he.set(H.$gl,Z.$po);return[new w.$hq(he),Ne]}g(he){(0,A.setUnexpectedErrorHandler)(we=>{const ve=(0,D.$Ei)(we,!0);ve&&he.error(`[uncaught exception in CLI]: ${ve}`)}),process.on("uncaughtException",we=>{(0,A.$Y)(we)||(0,A.$Z)(we)}),process.on("unhandledRejection",we=>(0,A.$Z)(we))}async h(he,we,ve,Se){let Me;if(he.args.profile&&(Me=ve.profiles.find(Y=>Y.name===he.args.profile),!Me))throw new Error(`Profile '${he.args.profile}' not found.`);const V=(Me??ve.defaultProfile).extensionsResource;if(this.b["list-extensions"])return Se.createInstance(s.$kp,new ee.$jj(ee.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,V);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const Y={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:V};return Se.createInstance(s.$kp,new ee.$jj(ee.LogLevel.Info,!1)).installExtensions(this.j(this.b["install-extension"]||[]),this.j(this.b["install-builtin-extension"]||[]),Y,!!this.b.force)}else{if(this.b["uninstall-extension"])return Se.createInstance(s.$kp,new ee.$jj(ee.LogLevel.Info,!1)).uninstallExtensions(this.j(this.b["uninstall-extension"]),!!this.b.force,V);if(this.b["locate-extension"])return Se.createInstance(s.$kp,new ee.$jj(ee.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,M.$y9b)(he.appRoot,he.extensionsPath))}}j(he){return he.map(we=>/\.vsix$/i.test(we)?I.URI.file((0,h.$hc)(we)?we:(0,h.$ic)((0,k.cwd)(),we)):we)}}async function ge(fe){const he=new de(fe);try{await he.run()}finally{he.dispose()}}e.main=ge})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/072c6b950b8822560c55eff1474c30951e2ab9c9/core/vs/code/node/cliProcessMain.js.map
