/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ae=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/base/common/errors","vs/platform/log/common/log","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/base/common/uri","vs/platform/files/common/files","vs/base/common/types","vs/nls","vs/platform/environment/common/environment","vs/base/common/buffer","vs/base/common/path","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/arrays","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetry","vs/base/common/network","vs/platform/userDataSync/common/userDataSync","vs/platform/product/common/productService","vs/base/common/cancellation","vs/base/common/strings","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/map","vs/base/common/json","os","vs/base/common/process","vs/base/common/errorMessage","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/platform/externalServices/common/serviceMachineId","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/base/common/extpath","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","fs","vs/base/common/semver/semver","vs/platform/ipc/common/mainProcessService","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/stopwatch","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/decorators","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/macAddress","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/native/common/nativeHostService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/node/sharedProcess/contrib/extensions","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","util","path","graceful-fs","https","yauzl","yazl","zlib","vs/code/node/sharedProcess/sharedProcessMain"],ce=function(ie){for(var e=[],I=0,N=ie.length;I<N;I++)e[I]=ae[ie[I]];return e};define(ae[123],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=e.$S=void 0,e.$S=!1;class I{static get(){const j=new Map,L=new Map,O=new Map,R=new Map;function S(l,$){l.has($.detail)||l.set($.detail,-$.timestamp)}function d(l,$){const y=l.get($.detail);y&&(y>=0||l.set($.detail,y+$.timestamp))}let P=[];typeof ie=="function"&&typeof ie.getStats=="function"&&(P=ie.getStats().slice(0).sort((l,$)=>l.timestamp-$.timestamp));for(const l of P)switch(l.type){case 10:S(j,l);break;case 11:case 12:d(j,l);break;case 21:S(L,l);break;case 22:d(L,l);break;case 33:S(O,l);break;case 34:d(O,l);break;case 31:S(R,l);break;case 32:d(R,l);break}let E=0;O.forEach(l=>E+=l);function b(l){const $=[];return l.forEach((y,w)=>$.push([w,y])),$}return{amdLoad:b(j),amdInvoke:b(L),nodeRequire:b(O),nodeEval:b(R),nodeRequireTotal:E}}static toMarkdownTable(j,L){let O="";const R=[];return j.forEach((S,d)=>{R[d]=S.length}),L.forEach(S=>{S.forEach((d,P)=>{typeof d>"u"&&(d=S[P]="-");const E=d.toString().length;R[P]=Math.max(E,R[P])})}),j.forEach((S,d)=>{O+=`| ${S+" ".repeat(R[d]-S.toString().length)} `}),O+=`|
`,j.forEach((S,d)=>{O+=`| ${"-".repeat(R[d])} `}),O+=`|
`,L.forEach(S=>{S.forEach((d,P)=>{typeof d<"u"&&(O+=`| ${d+" ".repeat(R[P]-d.toString().length)} `)}),O+=`|
`}),O}}e.$T=I}),define(ae[124],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=void 0;function I(y,w,c){const u=N(y,w);if(u!==-1)return y[u]}e.$eb=I;function N(y,w,c=y.length-1){for(let u=c;u>=0;u--){const f=y[u];if(w(f))return u}return-1}e.$fb=N;function j(y,w){const c=L(y,w);return c===-1?void 0:y[c]}e.$gb=j;function L(y,w,c=0,u=y.length){let f=c,m=u;for(;f<m;){const k=Math.floor((f+m)/2);w(y[k])?f=k+1:m=k}return f-1}e.$hb=L;function O(y,w){const c=R(y,w);return c===y.length?void 0:y[c]}e.$ib=O;function R(y,w,c=0,u=y.length){let f=c,m=u;for(;f<m;){const k=Math.floor((f+m)/2);w(y[k])?m=k:f=k+1}return f}e.$jb=R;function S(y,w,c=0,u=y.length){const f=R(y,w,c,u);return f===y.length?-1:f}e.$kb=S;class d{static{this.assertInvariants=!1}constructor(w){this.e=w,this.c=0}findLastMonotonous(w){if(d.assertInvariants){if(this.d){for(const u of this.e)if(this.d(u)&&!w(u))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=w}const c=L(this.e,w,this.c);return this.c=c+1,c===-1?void 0:this.e[c]}}e.$lb=d;function P(y,w){if(y.length===0)return;let c=y[0];for(let u=1;u<y.length;u++){const f=y[u];w(f,c)>0&&(c=f)}return c}e.$mb=P;function E(y,w){if(y.length===0)return;let c=y[0];for(let u=1;u<y.length;u++){const f=y[u];w(f,c)>=0&&(c=f)}return c}e.$nb=E;function b(y,w){return P(y,(c,u)=>-w(c,u))}e.$ob=b;function l(y,w){if(y.length===0)return-1;let c=0;for(let u=1;u<y.length;u++){const f=y[u];w(f,y[c])>0&&(c=u)}return c}e.$pb=l;function $(y,w){for(const c of y){const u=w(c);if(u!==void 0)return u}}e.$qb=$}),define(ae[125],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M=e.$L=e.$K=e.$J=void 0;function I(O,R){const S=Object.create(null);for(const d of O){const P=R(d);let E=S[P];E||(E=S[P]=[]),E.push(d)}return S}e.$J=I;function N(O,R){const S=[],d=[];for(const P of O)R.has(P)||S.push(P);for(const P of R)O.has(P)||d.push(P);return{removed:S,added:d}}e.$K=N;function j(O,R){const S=[],d=[];for(const[P,E]of O)R.has(P)||S.push(E);for(const[P,E]of R)O.has(P)||d.push(E);return{removed:S,added:d}}e.$L=j;function L(O,R){const S=new Set;for(const d of R)O.has(d)&&S.add(d);return S}e.$M=L}),define(ae[84],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nh=e.$mh=e.$lh=void 0;function I(O){return(R,S,d)=>{let P=null,E=null;if(typeof d.value=="function"?(P="value",E=d.value):typeof d.get=="function"&&(P="get",E=d.get),!E)throw new Error("not supported");d[P]=O(E,S)}}function N(O,R,S){let d=null,P=null;if(typeof S.value=="function"?(d="value",P=S.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(d="get",P=S.get),!P)throw new Error("not supported");const E=`$memoize$${R}`;S[d]=function(...b){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,b)}),this[E]}}e.$lh=N;function j(O,R,S){return I((d,P)=>{const E=`$debounce$${P}`,b=`$debounce$result$${P}`;return function(...l){this[b]||(this[b]=S?S():void 0),clearTimeout(this[E]),R&&(this[b]=R(this[b],...l),l=[this[b]]),this[E]=setTimeout(()=>{d.apply(this,l),this[b]=S?S():void 0},O)}})}e.$mh=j;function L(O,R,S){return I((d,P)=>{const E=`$throttle$timer$${P}`,b=`$throttle$result$${P}`,l=`$throttle$lastRun$${P}`,$=`$throttle$pending$${P}`;return function(...y){if(this[b]||(this[b]=S?S():void 0),(this[l]===null||this[l]===void 0)&&(this[l]=-Number.MAX_VALUE),R&&(this[b]=R(this[b],...y)),this[$])return;const w=this[l]+O;w<=Date.now()?(this[l]=Date.now(),d.apply(this,[this[b]]),this[b]=S?S():void 0):(this[$]=!0,this[E]=setTimeout(()=>{this[$]=!1,this[l]=Date.now(),d.apply(this,[this[b]]),this[b]=S?S():void 0},w-Date.now()))}})}e.$nh=L}),define(ae[7],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.setUnexpectedErrorHandler=e.$W=e.$V=void 0;class I{constructor(){this.b=[],this.a=function(s){setTimeout(()=>{throw s.stack?f.isErrorNoTelemetry(s)?new f(s.message+`

`+s.stack):new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.b.push(s),()=>{this.d(s)}}c(s){this.b.forEach(a=>{a(s)})}d(s){this.b.splice(this.b.indexOf(s),1)}setUnexpectedErrorHandler(s){this.a=s}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(s){this.a(s),this.c(s)}onUnexpectedExternalError(s){this.a(s)}}e.$V=I,e.$W=new I;function N(k){e.$W.setUnexpectedErrorHandler(k)}e.setUnexpectedErrorHandler=N;function j(k){if(!k||typeof k!="object")return!1;const s=k;return s.code==="EPIPE"&&s.syscall?.toUpperCase()==="WRITE"}e.$Y=j;function L(k){d(k)||e.$W.onUnexpectedError(k)}e.$Z=L;function O(k){d(k)||e.$W.onUnexpectedExternalError(k)}e.$1=O;function R(k){if(k instanceof Error){const{name:s,message:a}=k,n=k.stacktrace||k.stack;return{$isError:!0,name:s,message:a,stack:n,noTelemetry:f.isErrorNoTelemetry(k)}}return k}e.$2=R;const S="Canceled";function d(k){return k instanceof P?!0:k instanceof Error&&k.name===S&&k.message===S}e.$3=d;class P extends Error{constructor(){super(S),this.name=this.message}}e.$4=P;function E(){const k=new Error(S);return k.name=k.message,k}e.$5=E;function b(k){return k?new Error(`Illegal argument: ${k}`):new Error("Illegal argument")}e.$6=b;function l(k){return k?new Error(`Illegal state: ${k}`):new Error("Illegal state")}e.$7=l;class $ extends TypeError{constructor(s){super(s?`${s} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$8=$;function y(k){return k?k.message?k.message:k.stack?k.stack.split(`
`)[0]:String(k):"Error"}e.$9=y;class w extends Error{constructor(s){super("NotImplemented"),s&&(this.message=s)}}e.$0=w;class c extends Error{constructor(s){super("NotSupported"),s&&(this.message=s)}}e.$$=c;class u extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=u;class f extends Error{constructor(s){super(s),this.name="CodeExpectedError"}static fromError(s){if(s instanceof f)return s;const a=new f;return a.message=s.message,a.stack=s.stack,a}static isErrorNoTelemetry(s){return s.name==="CodeExpectedError"}}e.$ab=f;class m extends Error{constructor(s){super(s||"An unexpected bug occurred."),Object.setPrototypeOf(this,m.prototype)}}e.$bb=m}),define(ae[18],ce([0,1,7,124]),function(ie,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.$6b=e.CompareResult=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.$Fb=e.top=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=e.$rb=void 0;function j(F,U=0){return F[F.length-(1+U)]}e.$rb=j;function L(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}e.$sb=L;function O(F,U,W=(te,se)=>te===se){if(F===U)return!0;if(!F||!U||F.length!==U.length)return!1;for(let te=0,se=F.length;te<se;te++)if(!W(F[te],U[te]))return!1;return!0}e.$tb=O;function R(F,U){const W=F.length-1;U<W&&(F[U]=F[W]),F.pop()}e.$ub=R;function S(F,U,W){return d(F.length,te=>W(F[te],U))}e.$vb=S;function d(F,U){let W=0,te=F-1;for(;W<=te;){const se=(W+te)/2|0,ue=U(se);if(ue<0)W=se+1;else if(ue>0)te=se-1;else return se}return-(W+1)}e.$wb=d;function P(F,U,W){if(F=F|0,F>=U.length)throw new TypeError("invalid index");const te=U[Math.floor(U.length*Math.random())],se=[],ue=[],le=[];for(const $e of U){const fe=W($e,te);fe<0?se.push($e):fe>0?ue.push($e):le.push($e)}return F<se.length?P(F,se,W):F<se.length+le.length?le[0]:P(F-(se.length+le.length),ue,W)}e.$xb=P;function E(F,U){const W=[];let te;for(const se of F.slice(0).sort(U))!te||U(te[0],se)!==0?(te=[se],W.push(te)):te.push(se);return W}e.$yb=E;function*b(F,U){let W,te;for(const se of F)te!==void 0&&U(te,se)?W.push(se):(W&&(yield W),W=[se]),te=se;W&&(yield W)}e.$zb=b;function l(F,U){for(let W=0;W<=F.length;W++)U(W===0?void 0:F[W-1],W===F.length?void 0:F[W])}e.$Ab=l;function $(F,U){for(let W=0;W<F.length;W++)U(W===0?void 0:F[W-1],F[W],W+1===F.length?void 0:F[W+1])}e.$Bb=$;function y(F,U,W){const te=[];function se($e,fe,we){if(fe===0&&we.length===0)return;const ve=te[te.length-1];ve&&ve.start+ve.deleteCount===$e?(ve.deleteCount+=fe,ve.toInsert.push(...we)):te.push({start:$e,deleteCount:fe,toInsert:we})}let ue=0,le=0;for(;;){if(ue===F.length){se(ue,0,U.slice(le));break}if(le===U.length){se(ue,F.length-ue,[]);break}const $e=F[ue],fe=U[le],we=W($e,fe);we===0?(ue+=1,le+=1):we<0?(se(ue,1,[]),ue+=1):we>0&&(se(ue,0,[fe]),le+=1)}return te}e.$Cb=y;function w(F,U,W){const te=y(F,U,W),se=[],ue=[];for(const le of te)se.push(...F.slice(le.start,le.start+le.deleteCount)),ue.push(...le.toInsert);return{removed:se,added:ue}}e.$Db=w;function c(F,U,W){if(W===0)return[];const te=F.slice(0,W).sort(U);return f(F,U,te,W,F.length),te}e.top=c;function u(F,U,W,te,se){return W===0?Promise.resolve([]):new Promise((ue,le)=>{(async()=>{const $e=F.length,fe=F.slice(0,W).sort(U);for(let we=W,ve=Math.min(W+te,$e);we<$e;we=ve,ve=Math.min(ve+te,$e)){if(we>W&&await new Promise(Oe=>setTimeout(Oe)),se&&se.isCancellationRequested)throw new I.$4;f(F,U,fe,we,ve)}return fe})().then(ue,le)})}e.$Fb=u;function f(F,U,W,te,se){for(const ue=W.length;te<se;te++){const le=F[te];if(U(le,W[ue-1])<0){W.pop();const $e=(0,N.$jb)(W,fe=>U(le,fe)<0);W.splice($e,0,le)}}}function m(F){return F.filter(U=>!!U)}e.$Gb=m;function k(F){let U=0;for(let W=0;W<F.length;W++)F[W]&&(F[U]=F[W],U+=1);F.length=U}e.$Hb=k;function s(F,U,W){F.splice(W,0,F.splice(U,1)[0])}e.$Ib=s;function a(F){return!Array.isArray(F)||F.length===0}e.$Jb=a;function n(F){return Array.isArray(F)&&F.length>0}e.$Kb=n;function i(F,U=W=>W){const W=new Set;return F.filter(te=>{const se=U(te);return W.has(se)?!1:(W.add(se),!0)})}e.$Lb=i;function t(F){const U=new Set;return W=>{const te=F(W);return U.has(te)?!1:(U.add(te),!0)}}e.$Mb=t;function r(F,U){return F.length>0?F[0]:U}e.$Nb=r;function o(F,U){return F.length>0?F[F.length-1]:U}e.$Ob=o;function v(F,U,W=(te,se)=>te===se){let te=0;for(let se=0,ue=Math.min(F.length,U.length);se<ue&&W(F[se],U[se]);se++)te++;return te}e.$Pb=v;function p(F){return[].concat(...F)}e.$Qb=p;function h(F,U){let W=typeof U=="number"?F:0;typeof U=="number"?W=F:(W=0,U=F);const te=[];if(W<=U)for(let se=W;se<U;se++)te.push(se);else for(let se=W;se>U;se--)te.push(se);return te}e.$Rb=h;function g(F,U,W){return F.reduce((te,se)=>(te[U(se)]=W?W(se):se,te),Object.create(null))}e.$Sb=g;function D(F,U){return F.push(U),()=>T(F,U)}e.$Tb=D;function T(F,U){const W=F.indexOf(U);if(W>-1)return F.splice(W,1),U}e.$Ub=T;function M(F,U,W){const te=F.slice(0,U),se=F.slice(U);return te.concat(W,se)}e.$Vb=M;function z(F,U){let W;if(typeof U=="number"){let te=U;W=()=>{const se=Math.sin(te++)*179426549;return se-Math.floor(se)}}else W=Math.random;for(let te=F.length-1;te>0;te-=1){const se=Math.floor(W()*(te+1)),ue=F[te];F[te]=F[se],F[se]=ue}}e.$Wb=z;function B(F,U){const W=F.indexOf(U);W>-1&&(F.splice(W,1),F.unshift(U))}e.$Xb=B;function Z(F,U){const W=F.indexOf(U);W>-1&&(F.splice(W,1),F.push(U))}e.$Yb=Z;function K(F,U){for(const W of U)F.push(W)}e.$Zb=K;function x(F,U){return Array.isArray(F)?F.map(U):U(F)}e.$1b=x;function H(F){return Array.isArray(F)?F:[F]}e.$2b=H;function Y(F){return F[Math.floor(Math.random()*F.length)]}e.$3b=Y;function G(F,U,W){const te=ee(F,U),se=F.length,ue=W.length;F.length=se+ue;for(let le=se-1;le>=te;le--)F[le+ue]=F[le];for(let le=0;le<ue;le++)F[le+te]=W[le]}e.$4b=G;function V(F,U,W,te){const se=ee(F,U);let ue=F.splice(se,W);return ue===void 0&&(ue=[]),G(F,se,te),ue}e.$5b=V;function ee(F,U){return U<0?Math.max(U+F.length,0):Math.min(U,F.length)}var ne;(function(F){function U(ue){return ue<0}F.isLessThan=U;function W(ue){return ue<=0}F.isLessThanOrEqual=W;function te(ue){return ue>0}F.isGreaterThan=te;function se(ue){return ue===0}F.isNeitherLessOrGreaterThan=se,F.greaterThan=1,F.lessThan=-1,F.neitherLessOrGreaterThan=0})(ne||(e.CompareResult=ne={}));function _(F,U){return(W,te)=>U(F(W),F(te))}e.$6b=_;function re(...F){return(U,W)=>{for(const te of F){const se=te(U,W);if(!ne.isNeitherLessOrGreaterThan(se))return se}return ne.neitherLessOrGreaterThan}}e.$7b=re;const Q=(F,U)=>F-U;e.$8b=Q;const q=(F,U)=>(0,e.$8b)(F?1:0,U?1:0);e.$9b=q;function C(F){return(U,W)=>-F(U,W)}e.$0b=C;class A{constructor(U){this.g=U,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(U){let W=this.c;for(;W<this.g.length&&U(this.g[W]);)W++;const te=W===this.c?null:this.g.slice(this.c,W);return this.c=W,te}takeFromEndWhile(U){let W=this.d;for(;W>=0&&U(this.g[W]);)W--;const te=W===this.d?null:this.g.slice(W+1,this.d+1);return this.d=W,te}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const U=this.g[this.c];return this.c++,U}removeLast(){const U=this.g[this.d];return this.d--,U}takeCount(U){const W=this.g.slice(this.c,this.c+U);return this.c+=U,W}}e.$$b=A;class J{static{this.empty=new J(U=>{})}constructor(U){this.iterate=U}forEach(U){this.iterate(W=>(U(W),!0))}toArray(){const U=[];return this.iterate(W=>(U.push(W),!0)),U}filter(U){return new J(W=>this.iterate(te=>U(te)?W(te):!0))}map(U){return new J(W=>this.iterate(te=>W(U(te))))}some(U){let W=!1;return this.iterate(te=>(W=U(te),!W)),W}findFirst(U){let W;return this.iterate(te=>U(te)?(W=te,!1):!0),W}findLast(U){let W;return this.iterate(te=>(U(te)&&(W=te),!0)),W}findLastMaxBy(U){let W,te=!0;return this.iterate(se=>((te||ne.isGreaterThan(U(se,W)))&&(te=!1,W=se),!0)),W}}e.$_b=J}),define(ae[126],ce([0,1,7]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=e.$5c=e.$4c=e.$3c=e.ok=void 0;function N(S,d){if(!S)throw new Error(d?`Assertion failed (${d})`:"Assertion Failed")}e.ok=N;function j(S,d="Unreachable"){throw new Error(d)}e.$3c=j;function L(S){if(!S)throw new I.$bb("Assertion Failed")}e.$4c=L;function O(S){if(!S()){debugger;S(),(0,I.$Z)(new I.$bb("Assertion Failed"))}}e.$5c=O;function R(S,d){let P=0;for(;P<S.length-1;){const E=S[P],b=S[P+1];if(!d(E,b))return!1;P++}return!0}e.$6c=R}),define(ae[85],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=void 0;function I(N){const j=this;let L=!1,O;return function(){return L||(L=!0,O=N.apply(j,arguments)),O}}e.$cb=I}),define(ae[60],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var I;(function(N){function j(k){return k&&typeof k=="object"&&typeof k[Symbol.iterator]=="function"}N.is=j;const L=Object.freeze([]);function O(){return L}N.empty=O;function*R(k){yield k}N.single=R;function S(k){return j(k)?k:R(k)}N.wrap=S;function d(k){return k||L}N.from=d;function*P(k){for(let s=k.length-1;s>=0;s--)yield k[s]}N.reverse=P;function E(k){return!k||k[Symbol.iterator]().next().done===!0}N.isEmpty=E;function b(k){return k[Symbol.iterator]().next().value}N.first=b;function l(k,s){for(const a of k)if(s(a))return!0;return!1}N.some=l;function $(k,s){for(const a of k)if(s(a))return a}N.find=$;function*y(k,s){for(const a of k)s(a)&&(yield a)}N.filter=y;function*w(k,s){let a=0;for(const n of k)yield s(n,a++)}N.map=w;function*c(...k){for(const s of k)for(const a of s)yield a}N.concat=c;function u(k,s,a){let n=a;for(const i of k)n=s(n,i);return n}N.reduce=u;function*f(k,s,a=k.length){for(s<0&&(s+=k.length),a<0?a+=k.length:a>k.length&&(a=k.length);s<a;s++)yield k[s]}N.slice=f;function m(k,s=Number.POSITIVE_INFINITY){const a=[];if(s===0)return[a,k];const n=k[Symbol.iterator]();for(let i=0;i<s;i++){const t=n.next();if(t.done)return[a,N.empty()];a.push(t.value)}return[a,{[Symbol.iterator](){return n}}]}N.consume=m})(I||(e.Iterable=I={}))}),define(ae[35],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var I;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(I||(e.ScanError=I={}));var N;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(N||(e.SyntaxKind=N={}));var j;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(j||(e.ParseErrorCode=j={}));var L;(function(s){s.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function O(s,a=!1){let n=0;const i=s.length;let t="",r=0,o=16,v=0;function p(B){let Z=0,K=0;for(;Z<B;){const x=s.charCodeAt(n);if(x>=48&&x<=57)K=K*16+x-48;else if(x>=65&&x<=70)K=K*16+x-65+10;else if(x>=97&&x<=102)K=K*16+x-97+10;else break;n++,Z++}return Z<B&&(K=-1),K}function h(B){n=B,t="",r=0,o=16,v=0}function g(){const B=n;if(s.charCodeAt(n)===48)n++;else for(n++;n<s.length&&d(s.charCodeAt(n));)n++;if(n<s.length&&s.charCodeAt(n)===46)if(n++,n<s.length&&d(s.charCodeAt(n)))for(n++;n<s.length&&d(s.charCodeAt(n));)n++;else return v=3,s.substring(B,n);let Z=n;if(n<s.length&&(s.charCodeAt(n)===69||s.charCodeAt(n)===101))if(n++,(n<s.length&&s.charCodeAt(n)===43||s.charCodeAt(n)===45)&&n++,n<s.length&&d(s.charCodeAt(n))){for(n++;n<s.length&&d(s.charCodeAt(n));)n++;Z=n}else v=3;return s.substring(B,Z)}function D(){let B="",Z=n;for(;;){if(n>=i){B+=s.substring(Z,n),v=2;break}const K=s.charCodeAt(n);if(K===34){B+=s.substring(Z,n),n++;break}if(K===92){if(B+=s.substring(Z,n),n++,n>=i){v=2;break}switch(s.charCodeAt(n++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:{const H=p(4);H>=0?B+=String.fromCharCode(H):v=4;break}default:v=5}Z=n;continue}if(K>=0&&K<=31)if(S(K)){B+=s.substring(Z,n),v=2;break}else v=6;n++}return B}function T(){if(t="",v=0,r=n,n>=i)return r=i,o=17;let B=s.charCodeAt(n);if(R(B)){do n++,t+=String.fromCharCode(B),B=s.charCodeAt(n);while(R(B));return o=15}if(S(B))return n++,t+=String.fromCharCode(B),B===13&&s.charCodeAt(n)===10&&(n++,t+=`
`),o=14;switch(B){case 123:return n++,o=1;case 125:return n++,o=2;case 91:return n++,o=3;case 93:return n++,o=4;case 58:return n++,o=6;case 44:return n++,o=5;case 34:return n++,t=D(),o=10;case 47:{const Z=n-1;if(s.charCodeAt(n+1)===47){for(n+=2;n<i&&!S(s.charCodeAt(n));)n++;return t=s.substring(Z,n),o=12}if(s.charCodeAt(n+1)===42){n+=2;const K=i-1;let x=!1;for(;n<K;){if(s.charCodeAt(n)===42&&s.charCodeAt(n+1)===47){n+=2,x=!0;break}n++}return x||(n++,v=1),t=s.substring(Z,n),o=13}return t+=String.fromCharCode(B),n++,o=16}case 45:if(t+=String.fromCharCode(B),n++,n===i||!d(s.charCodeAt(n)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return t+=g(),o=11;default:for(;n<i&&M(B);)n++,B=s.charCodeAt(n);if(r!==n){switch(t=s.substring(r,n),t){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return t+=String.fromCharCode(B),n++,o=16}}function M(B){if(R(B)||S(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function z(){let B;do B=T();while(B>=12&&B<=15);return B}return{setPosition:h,getPosition:()=>n,scan:a?z:T,getToken:()=>o,getTokenValue:()=>t,getTokenOffset:()=>r,getTokenLength:()=>n-r,getTokenError:()=>v}}e.$Ym=O;function R(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function S(s){return s===10||s===13||s===8232||s===8233}function d(s){return s>=48&&s<=57}var P;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(P||(P={}));function E(s,a){const n=[],i=new Object;let t;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function v(p,h,g,D){r.value=p,r.offset=h,r.length=g,r.type=D,r.colonOffset=void 0,t=r}try{f(s,{onObjectBegin:(p,h)=>{if(a<=p)throw i;t=void 0,o=a>p,n.push("")},onObjectProperty:(p,h,g)=>{if(a<h||(v(p,h,g,"property"),n[n.length-1]=p,a<=h+g))throw i},onObjectEnd:(p,h)=>{if(a<=p)throw i;t=void 0,n.pop()},onArrayBegin:(p,h)=>{if(a<=p)throw i;t=void 0,n.push(0)},onArrayEnd:(p,h)=>{if(a<=p)throw i;t=void 0,n.pop()},onLiteralValue:(p,h,g)=>{if(a<h||(v(p,h,g,k(p)),a<=h+g))throw i},onSeparator:(p,h,g)=>{if(a<=h)throw i;if(p===":"&&t&&t.type==="property")t.colonOffset=h,o=!1,t=void 0;else if(p===","){const D=n[n.length-1];typeof D=="number"?n[n.length-1]=D+1:(o=!0,n[n.length-1]=""),t=void 0}}})}catch(p){if(p!==i)throw p}return{path:n,previousNode:t,isAtPropertyKey:o,matches:p=>{let h=0;for(let g=0;h<p.length&&g<n.length;g++)if(p[h]===n[g]||p[h]==="*")h++;else if(p[h]!=="**")return!1;return h===p.length}}}e.$Zm=E;function b(s,a=[],n=L.DEFAULT){let i=null,t=[];const r=[];function o(p){Array.isArray(t)?t.push(p):i!==null&&(t[i]=p)}return f(s,{onObjectBegin:()=>{const p={};o(p),r.push(t),t=p,i=null},onObjectProperty:p=>{i=p},onObjectEnd:()=>{t=r.pop()},onArrayBegin:()=>{const p=[];o(p),r.push(t),t=p,i=null},onArrayEnd:()=>{t=r.pop()},onLiteralValue:o,onError:(p,h,g)=>{a.push({error:p,offset:h,length:g})}},n),t[0]}e.$1m=b;function l(s,a=[],n=L.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(p){i.type==="property"&&(i.length=p-i.offset,i=i.parent)}function r(p){return i.children.push(p),p}f(s,{onObjectBegin:p=>{i=r({type:"object",offset:p,length:-1,parent:i,children:[]})},onObjectProperty:(p,h,g)=>{i=r({type:"property",offset:h,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:p,offset:h,length:g,parent:i})},onObjectEnd:(p,h)=>{i.length=p+h-i.offset,i=i.parent,t(p+h)},onArrayBegin:(p,h)=>{i=r({type:"array",offset:p,length:-1,parent:i,children:[]})},onArrayEnd:(p,h)=>{i.length=p+h-i.offset,i=i.parent,t(p+h)},onLiteralValue:(p,h,g)=>{r({type:k(p),offset:h,length:g,parent:i,value:p}),t(h+g)},onSeparator:(p,h,g)=>{i.type==="property"&&(p===":"?i.colonOffset=h:p===","&&t(h))},onError:(p,h,g)=>{a.push({error:p,offset:h,length:g})}},n);const v=i.children[0];return v&&delete v.parent,v}e.$2m=l;function $(s,a){if(!s)return;let n=s;for(const i of a)if(typeof i=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let t=!1;for(const r of n.children)if(Array.isArray(r.children)&&r.children[0].value===i){n=r.children[1],t=!0;break}if(!t)return}else{const t=i;if(n.type!=="array"||t<0||!Array.isArray(n.children)||t>=n.children.length)return;n=n.children[t]}return n}e.$3m=$;function y(s){if(!s.parent||!s.parent.children)return[];const a=y(s.parent);if(s.parent.type==="property"){const n=s.parent.children[0].value;a.push(n)}else if(s.parent.type==="array"){const n=s.parent.children.indexOf(s);n!==-1&&a.push(n)}return a}e.$4m=y;function w(s){switch(s.type){case"array":return s.children.map(w);case"object":{const a=Object.create(null);for(const n of s.children){const i=n.children[1];i&&(a[n.children[0].value]=w(i))}return a}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.$5m=w;function c(s,a,n=!1){return a>=s.offset&&a<s.offset+s.length||n&&a===s.offset+s.length}e.$6m=c;function u(s,a,n=!1){if(c(s,a,n)){const i=s.children;if(Array.isArray(i))for(let t=0;t<i.length&&i[t].offset<=a;t++){const r=u(i[t],a,n);if(r)return r}return s}}e.$7m=u;function f(s,a,n=L.DEFAULT){const i=O(s,!1);function t(_){return _?()=>_(i.getTokenOffset(),i.getTokenLength()):()=>!0}function r(_){return _?re=>_(re,i.getTokenOffset(),i.getTokenLength()):()=>!0}const o=t(a.onObjectBegin),v=r(a.onObjectProperty),p=t(a.onObjectEnd),h=t(a.onArrayBegin),g=t(a.onArrayEnd),D=r(a.onLiteralValue),T=r(a.onSeparator),M=t(a.onComment),z=r(a.onError),B=n&&n.disallowComments,Z=n&&n.allowTrailingComma;function K(){for(;;){const _=i.scan();switch(i.getTokenError()){case 4:x(14);break;case 5:x(15);break;case 3:x(13);break;case 1:B||x(11);break;case 2:x(12);break;case 6:x(16);break}switch(_){case 12:case 13:B?x(10):M();break;case 16:x(1);break;case 15:case 14:break;default:return _}}}function x(_,re=[],Q=[]){if(z(_),re.length+Q.length>0){let q=i.getToken();for(;q!==17;){if(re.indexOf(q)!==-1){K();break}else if(Q.indexOf(q)!==-1)break;q=K()}}}function H(_){const re=i.getTokenValue();return _?D(re):v(re),K(),!0}function Y(){switch(i.getToken()){case 11:{let _=0;try{_=JSON.parse(i.getTokenValue()),typeof _!="number"&&(x(2),_=0)}catch{x(2)}D(_);break}case 7:D(null);break;case 8:D(!0);break;case 9:D(!1);break;default:return!1}return K(),!0}function G(){return i.getToken()!==10?(x(3,[],[2,5]),!1):(H(!1),i.getToken()===6?(T(":"),K(),ne()||x(4,[],[2,5])):x(5,[],[2,5]),!0)}function V(){o(),K();let _=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(_||x(4,[],[]),T(","),K(),i.getToken()===2&&Z)break}else _&&x(6,[],[]);G()||x(4,[],[2,5]),_=!0}return p(),i.getToken()!==2?x(7,[2],[]):K(),!0}function ee(){h(),K();let _=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(_||x(4,[],[]),T(","),K(),i.getToken()===4&&Z)break}else _&&x(6,[],[]);ne()||x(4,[],[4,5]),_=!0}return g(),i.getToken()!==4?x(8,[4],[]):K(),!0}function ne(){switch(i.getToken()){case 3:return ee();case 1:return V();case 10:return H(!0);default:return Y()}}return K(),i.getToken()===17?n.allowEmptyContent?!0:(x(4,[],[]),!1):ne()?(i.getToken()!==17&&x(9,[],[]),!0):(x(4,[],[]),!1)}e.$8m=f;function m(s,a){const n=O(s),i=[];let t,r=0,o;do switch(o=n.getPosition(),t=n.scan(),t){case 12:case 13:case 17:r!==o&&i.push(s.substring(r,o)),a!==void 0&&i.push(n.getTokenValue().replace(/[^\r\n]/g,a)),r=n.getPosition();break}while(t!==17);return i.join("")}e.$9m=m;function k(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.$0m=k}),define(ae[42],ce([0,1,35]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nT=e.$mT=e.$lT=e.$kT=void 0;function N(d,P,E){let b,l,$,y,w;if(P){for(y=P.offset,w=y+P.length,$=y;$>0&&!S(d,$-1);)$--;let o=w;for(;o<d.length&&!S(d,o);)o++;l=d.substring($,o),b=O(l,E)}else l=d,b=0,$=0,y=0,w=d.length;const c=R(E,d);let u=!1,f=0,m;E.insertSpaces?m=L(" ",E.tabSize||4):m="	";const k=(0,I.$Ym)(l,!1);let s=!1;function a(){return c+L(m,b+f)}function n(){let o=k.scan();for(u=!1;o===15||o===14;)u=u||o===14,o=k.scan();return s=o===16||k.getTokenError()!==0,o}const i=[];function t(o,v,p){!s&&v<w&&p>y&&d.substring(v,p)!==o&&i.push({offset:v,length:p-v,content:o})}let r=n();if(r!==17){const o=k.getTokenOffset()+$,v=L(m,b);t(v,$,o)}for(;r!==17;){let o=k.getTokenOffset()+k.getTokenLength()+$,v=n(),p="";for(;!u&&(v===12||v===13);){const g=k.getTokenOffset()+$;t(" ",o,g),o=k.getTokenOffset()+k.getTokenLength()+$,p=v===12?a():"",v=n()}if(v===2)r!==1&&(f--,p=a());else if(v===4)r!==3&&(f--,p=a());else{switch(r){case 3:case 1:f++,p=a();break;case 5:case 12:p=a();break;case 13:u?p=a():p=" ";break;case 6:p=" ";break;case 10:if(v===6){p="";break}case 7:case 8:case 9:case 11:case 2:case 4:v===12||v===13?p=" ":v!==5&&v!==17&&(s=!0);break;case 16:s=!0;break}u&&(v===12||v===13)&&(p=a())}const h=k.getTokenOffset()+$;t(p,o,h),r=v}return i}e.$kT=N;function j(d,P){const E=JSON.stringify(d,void 0,P.insertSpaces?P.tabSize||4:"	");return P.eol!==void 0?E.replace(/\r\n|\r|\n/g,P.eol):E}e.$lT=j;function L(d,P){let E="";for(let b=0;b<P;b++)E+=d;return E}function O(d,P){let E=0,b=0;const l=P.tabSize||4;for(;E<d.length;){const $=d.charAt(E);if($===" ")b++;else if($==="	")b+=l;else break;E++}return Math.floor(b/l)}function R(d,P){for(let E=0;E<P.length;E++){const b=P.charAt(E);if(b==="\r")return E+1<P.length&&P.charAt(E+1)===`
`?`\r
`:"\r";if(b===`
`)return`
`}return d&&d.eol||`
`}e.$mT=R;function S(d,P){return`\r
`.indexOf(d.charAt(P))!==-1}e.$nT=S}),define(ae[86],ce([0,1,35,42]),function(ie,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sT=e.$rT=e.$qT=e.$pT=e.$oT=void 0;function j(d,P,E){return L(d,P,void 0,E)}e.$oT=j;function L(d,P,E,b,l){const $=P.slice(),y=[],w=(0,I.$2m)(d,y);let c,u;for(;$.length>0&&(u=$.pop(),c=(0,I.$3m)(w,$),c===void 0&&E!==void 0);)typeof u=="string"?E={[u]:E}:E=[E];if(c)if(c.type==="object"&&typeof u=="string"&&Array.isArray(c.children)){const f=(0,I.$3m)(c,[u]);if(f!==void 0)if(E===void 0){if(!f.parent)throw new Error("Malformed AST");const m=c.children.indexOf(f.parent);let k,s=f.parent.offset+f.parent.length;if(m>0){const a=c.children[m-1];k=a.offset+a.length}else k=c.offset+1,c.children.length>1&&(s=c.children[1].offset);return O(d,{offset:k,length:s-k,content:""},b)}else return O(d,{offset:f.offset,length:f.length,content:JSON.stringify(E)},b);else{if(E===void 0)return[];const m=`${JSON.stringify(u)}: ${JSON.stringify(E)}`,k=l?l(c.children.map(a=>a.children[0].value)):c.children.length;let s;if(k>0){const a=c.children[k-1];s={offset:a.offset+a.length,length:0,content:","+m}}else c.children.length===0?s={offset:c.offset+1,length:0,content:m}:s={offset:c.offset+1,length:0,content:m+","};return O(d,s,b)}}else if(c.type==="array"&&typeof u=="number"&&Array.isArray(c.children))if(E!==void 0){const f=`${JSON.stringify(E)}`;let m;if(c.children.length===0||u===0)m={offset:c.offset+1,length:0,content:c.children.length===0?f:f+","};else{const k=u===-1||u>c.children.length?c.children.length:u,s=c.children[k-1];m={offset:s.offset+s.length,length:0,content:","+f}}return O(d,m,b)}else{const f=u,m=c.children[f];let k;if(c.children.length===1)k={offset:c.offset+1,length:c.length-2,content:""};else if(c.children.length-1===f){const s=c.children[f-1],a=s.offset+s.length,n=c.offset+c.length;k={offset:a,length:n-2-a,content:""}}else k={offset:m.offset,length:c.children[f+1].offset-m.offset,content:""};return O(d,k,b)}else throw new Error(`Can not add ${typeof u!="number"?"index":"property"} to parent of type ${c.type}`);else{if(E===void 0)throw new Error("Can not delete in empty document");return O(d,{offset:w?w.offset:0,length:w?w.length:0,content:JSON.stringify(E)},b)}}e.$pT=L;function O(d,P,E){let b=R(d,P),l=P.offset,$=P.offset+P.content.length;if(P.length===0||P.content.length===0){for(;l>0&&!(0,N.$nT)(b,l-1);)l--;for(;$<b.length&&!(0,N.$nT)(b,$);)$++}const y=(0,N.$kT)(b,{offset:l,length:$-l},E);for(let c=y.length-1;c>=0;c--){const u=y[c];b=R(b,u),l=Math.min(l,u.offset),$=Math.max($,u.offset+u.length),$+=u.content.length-u.length}const w=d.length-(b.length-$)-l;return[{offset:l,length:w,content:b.substring(l,$)}]}e.$qT=O;function R(d,P){return d.substring(0,P.offset)+P.content+d.substring(P.offset+P.length)}e.$rT=R;function S(d,P){const E=P.slice(0).sort((l,$)=>{const y=l.offset-$.offset;return y===0?l.length-$.length:y});let b=d.length;for(let l=E.length-1;l>=0;l--){const $=E[l];if($.offset+$.length<=b)d=R(d,$);else throw new Error("Overlapping edit");b=$.offset}return d}e.$sT=S}),define(ae[61],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=void 0;class I{constructor(j){this.d=j,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(j){this.c=j}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$U=I}),define(ae[87],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1c=void 0;class I{static{this.Undefined=new I(void 0)}constructor(L){this.element=L,this.next=I.Undefined,this.prev=I.Undefined}}class N{constructor(){this.a=I.Undefined,this.b=I.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===I.Undefined}clear(){let L=this.a;for(;L!==I.Undefined;){const O=L.next;L.prev=I.Undefined,L.next=I.Undefined,L=O}this.a=I.Undefined,this.b=I.Undefined,this.c=0}unshift(L){return this.d(L,!1)}push(L){return this.d(L,!0)}d(L,O){const R=new I(L);if(this.a===I.Undefined)this.a=R,this.b=R;else if(O){const d=this.b;this.b=R,R.prev=d,d.next=R}else{const d=this.a;this.a=R,R.next=d,d.prev=R}this.c+=1;let S=!1;return()=>{S||(S=!0,this.e(R))}}shift(){if(this.a!==I.Undefined){const L=this.a.element;return this.e(this.a),L}}pop(){if(this.b!==I.Undefined){const L=this.b.element;return this.e(this.b),L}}e(L){if(L.prev!==I.Undefined&&L.next!==I.Undefined){const O=L.prev;O.next=L.next,L.next.prev=O}else L.prev===I.Undefined&&L.next===I.Undefined?(this.a=I.Undefined,this.b=I.Undefined):L.next===I.Undefined?(this.b=this.b.prev,this.b.next=I.Undefined):L.prev===I.Undefined&&(this.a=this.a.next,this.a.prev=I.Undefined);this.c-=1}*[Symbol.iterator](){let L=this.a;for(;L!==I.Undefined;)yield L.element,L=L.next}}e.$1c=N}),define(ae[34],ce([0,1]),function(ie,e){"use strict";var I,N,j;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.$Bc=e.Touch=e.$Ac=e.$zc=e.$yc=e.$xc=e.$wc=void 0;function L(u,f,m){let k=u.get(f);return k===void 0&&(k=m,u.set(f,k)),k}e.$wc=L;function O(u){const f=[];return u.forEach((m,k)=>{f.push(`${k} => ${m}`)}),`Map(${u.size}) {${f.join(", ")}}`}e.$xc=O;function R(u){const f=[];return u.forEach(m=>{f.push(m)}),`Set(${u.size}) {${f.join(", ")}}`}e.$yc=R;class S{constructor(f,m){this.uri=f,this.value=m}}function d(u){return Array.isArray(u)}class P{static{this.a=f=>f.toString()}constructor(f,m){if(this[I]="ResourceMap",f instanceof P)this.b=new Map(f.b),this.c=m??P.a;else if(d(f)){this.b=new Map,this.c=m??P.a;for(const[k,s]of f)this.set(k,s)}else this.b=new Map,this.c=f??P.a}set(f,m){return this.b.set(this.c(f),new S(f,m)),this}get(f){return this.b.get(this.c(f))?.value}has(f){return this.b.has(this.c(f))}get size(){return this.b.size}clear(){this.b.clear()}delete(f){return this.b.delete(this.c(f))}forEach(f,m){typeof m<"u"&&(f=f.bind(m));for(const[k,s]of this.b)f(s.value,s.uri,this)}*values(){for(const f of this.b.values())yield f.value}*keys(){for(const f of this.b.values())yield f.uri}*entries(){for(const f of this.b.values())yield[f.uri,f.value]}*[(I=Symbol.toStringTag,Symbol.iterator)](){for(const[,f]of this.b)yield[f.uri,f.value]}}e.$zc=P;class E{constructor(f,m){this[N]="ResourceSet",!f||typeof f=="function"?this.a=new P(f):(this.a=new P(m),f.forEach(this.add,this))}get size(){return this.a.size}add(f){return this.a.set(f,f),this}clear(){this.a.clear()}delete(f){return this.a.delete(f)}forEach(f,m){this.a.forEach((k,s)=>f.call(m,s,s,this))}has(f){return this.a.has(f)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ac=E;var b;(function(u){u[u.None=0]="None",u[u.AsOld=1]="AsOld",u[u.AsNew=2]="AsNew"})(b||(e.Touch=b={}));class l{constructor(){this[j]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(f){return this.a.has(f)}get(f,m=0){const k=this.a.get(f);if(k)return m!==0&&this.j(k,m),k.value}set(f,m,k=0){let s=this.a.get(f);if(s)s.value=m,k!==0&&this.j(s,k);else{switch(s={key:f,value:m,next:void 0,previous:void 0},k){case 0:this.h(s);break;case 1:this.g(s);break;case 2:this.h(s);break;default:this.h(s);break}this.a.set(f,s),this.d++}return this}delete(f){return!!this.remove(f)}remove(f){const m=this.a.get(f);if(m)return this.a.delete(f),this.i(m),this.d--,m.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const f=this.b;return this.a.delete(f.key),this.i(f),this.d--,f.value}forEach(f,m){const k=this.e;let s=this.b;for(;s;){if(m?f.bind(m)(s.value,s.key,this):f(s.value,s.key,this),this.e!==k)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const f=this,m=this.e;let k=this.b;const s={[Symbol.iterator](){return s},next(){if(f.e!==m)throw new Error("LinkedMap got modified during iteration.");if(k){const a={value:k.key,done:!1};return k=k.next,a}else return{value:void 0,done:!0}}};return s}values(){const f=this,m=this.e;let k=this.b;const s={[Symbol.iterator](){return s},next(){if(f.e!==m)throw new Error("LinkedMap got modified during iteration.");if(k){const a={value:k.value,done:!1};return k=k.next,a}else return{value:void 0,done:!0}}};return s}entries(){const f=this,m=this.e;let k=this.b;const s={[Symbol.iterator](){return s},next(){if(f.e!==m)throw new Error("LinkedMap got modified during iteration.");if(k){const a={value:[k.key,k.value],done:!1};return k=k.next,a}else return{value:void 0,done:!0}}};return s}[(j=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(f){if(f>=this.size)return;if(f===0){this.clear();return}let m=this.b,k=this.size;for(;m&&k>f;)this.a.delete(m.key),m=m.next,k--;this.b=m,this.d=k,m&&(m.previous=void 0),this.e++}g(f){if(!this.b&&!this.c)this.c=f;else if(this.b)f.next=this.b,this.b.previous=f;else throw new Error("Invalid list");this.b=f,this.e++}h(f){if(!this.b&&!this.c)this.b=f;else if(this.c)f.previous=this.c,this.c.next=f;else throw new Error("Invalid list");this.c=f,this.e++}i(f){if(f===this.b&&f===this.c)this.b=void 0,this.c=void 0;else if(f===this.b){if(!f.next)throw new Error("Invalid list");f.next.previous=void 0,this.b=f.next}else if(f===this.c){if(!f.previous)throw new Error("Invalid list");f.previous.next=void 0,this.c=f.previous}else{const m=f.next,k=f.previous;if(!m||!k)throw new Error("Invalid list");m.previous=k,k.next=m}f.next=void 0,f.previous=void 0,this.e++}j(f,m){if(!this.b||!this.c)throw new Error("Invalid list");if(!(m!==1&&m!==2)){if(m===1){if(f===this.b)return;const k=f.next,s=f.previous;f===this.c?(s.next=void 0,this.c=s):(k.previous=s,s.next=k),f.previous=void 0,f.next=this.b,this.b.previous=f,this.b=f,this.e++}else if(m===2){if(f===this.c)return;const k=f.next,s=f.previous;f===this.b?(k.previous=void 0,this.b=k):(k.previous=s,s.next=k),f.next=void 0,f.previous=this.c,this.c.next=f,this.c=f,this.e++}}}toJSON(){const f=[];return this.forEach((m,k)=>{f.push([k,m])}),f}fromJSON(f){this.clear();for(const[m,k]of f)this.set(m,k)}}e.$Bc=l;class $ extends l{constructor(f,m=1){super(),this.k=f,this.l=Math.min(Math.max(0,m),1)}get limit(){return this.k}set limit(f){this.k=f,this.m()}get ratio(){return this.l}set ratio(f){this.l=Math.min(Math.max(0,f),1),this.m()}get(f,m=2){return super.get(f,m)}peek(f){return super.get(f,0)}set(f,m){return super.set(f,m,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Cc=$;class y{constructor(){this.a=new Map}add(f){return this.a.set(f,(this.a.get(f)||0)+1),this}delete(f){let m=this.a.get(f)||0;return m===0?!1:(m--,m===0?this.a.delete(f):this.a.set(f,m),!0)}has(f){return this.a.has(f)}}e.$Dc=y;class w{constructor(f){if(this.a=new Map,this.b=new Map,f)for(const[m,k]of f)this.set(m,k)}clear(){this.a.clear(),this.b.clear()}set(f,m){this.a.set(f,m),this.b.set(m,f)}get(f){return this.a.get(f)}getKey(f){return this.b.get(f)}delete(f){const m=this.a.get(f);return m===void 0?!1:(this.a.delete(f),this.b.delete(m),!0)}forEach(f,m){this.a.forEach((k,s)=>{f.call(m,k,s,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Ec=w;class c{constructor(){this.a=new Map}add(f,m){let k=this.a.get(f);k||(k=new Set,this.a.set(f,k)),k.add(m)}delete(f,m){const k=this.a.get(f);k&&(k.delete(m),k.size===0&&this.a.delete(f))}forEach(f,m){const k=this.a.get(f);k&&k.forEach(m)}get(f){const m=this.a.get(f);return m||new Set}}e.$Fc=c}),define(ae[2],ce([0,1,18,125,34,85,60]),function(ie,e,I,N,j,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=void 0;const R=!1;let S=null;class d{constructor(){this.b=new Map}static{this.a=0}c(g){let D=this.b.get(g);return D||(D={parent:null,source:null,isSingleton:!1,value:g,idx:d.a++},this.b.set(g,D)),D}trackDisposable(g){const D=this.c(g);D.source||(D.source=new Error().stack)}setParent(g,D){const T=this.c(g);T.parent=D}markAsDisposed(g){this.b.delete(g)}markAsSingleton(g){this.c(g).isSingleton=!0}f(g,D){const T=D.get(g);if(T)return T;const M=g.parent?this.f(this.c(g.parent),D):g;return D.set(g,M),M}getTrackedDisposables(){const g=new Map;return[...this.b.entries()].filter(([,T])=>T.source!==null&&!this.f(T,g).isSingleton).flatMap(([T])=>T)}computeLeakingDisposables(g=10,D){let T;if(D)T=D;else{const K=new Map,x=[...this.b.values()].filter(Y=>Y.source!==null&&!this.f(Y,K).isSingleton);if(x.length===0)return;const H=new Set(x.map(Y=>Y.value));if(T=x.filter(Y=>!(Y.parent&&H.has(Y.parent))),T.length===0)throw new Error("There are cyclic diposable chains!")}if(!T)return;function M(K){function x(Y,G){for(;Y.length>0&&G.some(V=>typeof V=="string"?V===Y[0]:Y[0].match(V));)Y.shift()}const H=K.source.split(`
`).map(Y=>Y.trim().replace("at ","")).filter(Y=>Y!=="");return x(H,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),H.reverse()}const z=new j.$Fc;for(const K of T){const x=M(K);for(let H=0;H<=x.length;H++)z.add(x.slice(0,H).join(`
`),K)}T.sort((0,I.$6b)(K=>K.idx,I.$8b));let B="",Z=0;for(const K of T.slice(0,g)){Z++;const x=M(K),H=[];for(let Y=0;Y<x.length;Y++){let G=x[Y];G=`(shared with ${z.get(x.slice(0,Y+1).join(`
`)).size}/${T.length} leaks) at ${G}`;const ee=z.get(x.slice(0,Y).join(`
`)),ne=(0,N.$J)([...ee].map(_=>M(_)[Y]),_=>_);delete ne[x[Y]];for(const[_,re]of Object.entries(ne))H.unshift(`    - stacktraces of ${re.length} other leaks continue with ${_}`);H.unshift(G)}B+=`


==================== Leaking disposable ${Z}/${T.length}: ${K.value.constructor.name} ====================
${H.join(`
`)}
============================================================

`}return T.length>g&&(B+=`


... and ${T.length-g} more leaking disposables

`),{leaks:T,details:B}}}e.$Gc=d;function P(h){S=h}if(e.$Hc=P,R){const h="__is_disposable_tracked__";P(new class{trackDisposable(g){const D=new Error("Potentially leaked disposable").stack;setTimeout(()=>{g[h]||console.log(D)},3e3)}setParent(g,D){if(g&&g!==s.None)try{g[h]=!0}catch{}}markAsDisposed(g){if(g&&g!==s.None)try{g[h]=!0}catch{}}markAsSingleton(g){}})}function E(h){return S?.trackDisposable(h),h}e.$Ic=E;function b(h){S?.markAsDisposed(h)}e.$Jc=b;function l(h,g){S?.setParent(h,g)}function $(h,g){if(S)for(const D of h)S.setParent(D,g)}function y(h){return S?.markAsSingleton(h),h}e.$Kc=y;function w(h){return typeof h.dispose=="function"&&h.dispose.length===0}e.$Lc=w;function c(h){if(O.Iterable.is(h)){const g=[];for(const D of h)if(D)try{D.dispose()}catch(T){g.push(T)}if(g.length===1)throw g[0];if(g.length>1)throw new AggregateError(g,"Encountered errors while disposing of store");return Array.isArray(h)?[]:h}else if(h)return h.dispose(),h}e.$Mc=c;function u(h){for(const g of h)w(g)&&g.dispose();return[]}e.$Nc=u;function f(...h){const g=m(()=>c(h));return $(h,g),g}e.$Oc=f;function m(h){const g=E({dispose:(0,L.$cb)(()=>{b(g),h()})});return g}e.$Pc=m;class k{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,E(this)}dispose(){this.g||(b(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{c(this.f)}finally{this.f.clear()}}add(g){if(!g)return g;if(g===this)throw new Error("Cannot register a disposable on itself!");return l(g,this),this.g?k.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(g),g}delete(g){if(g){if(g===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(g),g.dispose()}}deleteAndLeak(g){g&&this.f.has(g)&&(this.f.delete(g),l(g,null))}}e.$Qc=k;class s{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new k,E(this),l(this.q,this)}dispose(){b(this),this.q.dispose()}B(g){if(g===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(g)}}e.$Rc=s;class a{constructor(){this.b=!1,E(this)}get value(){return this.b?void 0:this.a}set value(g){this.b||g===this.a||(this.a?.dispose(),g&&l(g,this),this.a=g)}clear(){this.value=void 0}dispose(){this.b=!0,b(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const g=this.a;return this.a=void 0,g&&l(g,null),g}}e.$Sc=a;class n{constructor(g){this.b=g,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Tc=n;class i{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,E(this)}set(g){let D=g;return this.unset=()=>D=void 0,this.isset=()=>D!==void 0,this.dispose=()=>{D&&(D(),D=void 0,b(this))},this}}e.$Uc=i;class t{constructor(){this.a=new Map}acquire(g,...D){let T=this.a.get(g);T||(T={counter:0,object:this.b(g,...D)},this.a.set(g,T));const{object:M}=T,z=(0,L.$cb)(()=>{--T.counter===0&&(this.c(g,T.object),this.a.delete(g))});return T.counter++,{object:M,dispose:z}}}e.$Vc=t;class r{constructor(g){this.a=g}async acquire(g,...D){const T=this.a.acquire(g,...D);try{return{object:await T.object,dispose:()=>T.dispose()}}catch(M){throw T.dispose(),M}}}e.$Wc=r;class o{constructor(g){this.object=g}dispose(){}}e.$Xc=o;function v(h){const g=new k;try{h(g)}finally{g.dispose()}}e.$Yc=v;class p{constructor(){this.a=new Map,this.b=!1,E(this)}dispose(){b(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{c(this.a.values())}finally{this.a.clear()}}has(g){return this.a.has(g)}get size(){return this.a.size}get(g){return this.a.get(g)}set(g,D,T=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),T||this.a.get(g)?.dispose(),this.a.set(g,D)}deleteAndDispose(g){this.a.get(g)?.dispose(),this.a.delete(g)}keys(){return this.a.keys()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$Zc=p}),define(ae[88],ce([0,1,34]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ul=e.$tl=e.$sl=void 0;const N=new I.$Cc(1e4);function j(d){return S(d,"NFC",N)}e.$sl=j;const L=new I.$Cc(1e4);function O(d){return S(d,"NFD",L)}e.$tl=O;const R=/[^\u0000-\u0080]/;function S(d,P,E){if(!d)return d;const b=E.get(d);if(b)return b;let l;return R.test(d)?l=d.normalize(P):l=d,E.set(d,l),l}e.$ul=function(){const d=/[\u0300-\u036f]/g;return function(P){return O(P).replace(d,"")}}()}),function(){function ie(j){const L=[];typeof j=="number"&&L.push("code/timeOrigin",j);function O(S){L.push(S,Date.now())}function R(){const S=[];for(let d=0;d<L.length;d+=2)S.push({name:L[d],startTime:L[d+1]});return S}return{mark:O,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ie():{mark(j){performance.mark(j)},getMarks(){let j=performance.timeOrigin;typeof j!="number"&&(j=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(j)}];for(const O of performance.getEntriesByType("mark"))L.push({name:O.name,startTime:Math.round(j+O.startTime)});return L}};if(typeof process=="object"){const j=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ie(j)}else return console.trace("perf-util loaded in UNKNOWN environment"),ie()}function I(j){return j.MonacoPerformanceMarks||(j.MonacoPerformanceMarks=e()),j.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=I(N))}(),function(ie,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var N in I)(typeof exports=="object"?exports:ie)[N]=I[N]}}(typeof self<"u"?self:this,function(){return function(ie){var e={};function I(N){if(e[N])return e[N].exports;var j=e[N]={i:N,l:!1,exports:{}};return ie[N].call(j.exports,j,j.exports,I),j.l=!0,j.exports}return I.m=ie,I.c=e,I.d=function(N,j,L){I.o(N,j)||Object.defineProperty(N,j,{enumerable:!0,get:L})},I.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},I.t=function(N,j){if(1&j&&(N=I(N)),8&j||4&j&&typeof N=="object"&&N&&N.__esModule)return N;var L=Object.create(null);if(I.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:N}),2&j&&typeof N!="string")for(var O in N)I.d(L,O,function(R){return N[R]}.bind(null,O));return L},I.n=function(N){var j=N&&N.__esModule?function(){return N.default}:function(){return N};return I.d(j,"a",j),j},I.o=function(N,j){return Object.prototype.hasOwnProperty.call(N,j)},I.p="",I(I.s=0)}([function(ie,e,I){(function(N){var j;e=ie.exports=Q,j=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var he=Array.prototype.slice.call(arguments,0);he.unshift("SEMVER"),console.log.apply(console,he)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,O=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],S=e.src=[],d=0,P=d++;S[P]="0|[1-9]\\d*";var E=d++;S[E]="[0-9]+";var b=d++;S[b]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var l=d++;S[l]="("+S[P]+")\\.("+S[P]+")\\.("+S[P]+")";var $=d++;S[$]="("+S[E]+")\\.("+S[E]+")\\.("+S[E]+")";var y=d++;S[y]="(?:"+S[P]+"|"+S[b]+")";var w=d++;S[w]="(?:"+S[E]+"|"+S[b]+")";var c=d++;S[c]="(?:-("+S[y]+"(?:\\."+S[y]+")*))";var u=d++;S[u]="(?:-?("+S[w]+"(?:\\."+S[w]+")*))";var f=d++;S[f]="[0-9A-Za-z-]+";var m=d++;S[m]="(?:\\+("+S[f]+"(?:\\."+S[f]+")*))";var k=d++,s="v?"+S[l]+S[c]+"?"+S[m]+"?";S[k]="^"+s+"$";var a="[v=\\s]*"+S[$]+S[u]+"?"+S[m]+"?",n=d++;S[n]="^"+a+"$";var i=d++;S[i]="((?:<|>)?=?)";var t=d++;S[t]=S[E]+"|x|X|\\*";var r=d++;S[r]=S[P]+"|x|X|\\*";var o=d++;S[o]="[v=\\s]*("+S[r]+")(?:\\.("+S[r]+")(?:\\.("+S[r]+")(?:"+S[c]+")?"+S[m]+"?)?)?";var v=d++;S[v]="[v=\\s]*("+S[t]+")(?:\\.("+S[t]+")(?:\\.("+S[t]+")(?:"+S[u]+")?"+S[m]+"?)?)?";var p=d++;S[p]="^"+S[i]+"\\s*"+S[o]+"$";var h=d++;S[h]="^"+S[i]+"\\s*"+S[v]+"$";var g=d++;S[g]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var D=d++;S[D]="(?:~>?)";var T=d++;S[T]="(\\s*)"+S[D]+"\\s+",R[T]=new RegExp(S[T],"g");var M=d++;S[M]="^"+S[D]+S[o]+"$";var z=d++;S[z]="^"+S[D]+S[v]+"$";var B=d++;S[B]="(?:\\^)";var Z=d++;S[Z]="(\\s*)"+S[B]+"\\s+",R[Z]=new RegExp(S[Z],"g");var K=d++;S[K]="^"+S[B]+S[o]+"$";var x=d++;S[x]="^"+S[B]+S[v]+"$";var H=d++;S[H]="^"+S[i]+"\\s*("+a+")$|^$";var Y=d++;S[Y]="^"+S[i]+"\\s*("+s+")$|^$";var G=d++;S[G]="(\\s*)"+S[i]+"\\s*("+a+"|"+S[o]+")",R[G]=new RegExp(S[G],"g");var V=d++;S[V]="^\\s*("+S[o]+")\\s+-\\s+("+S[o]+")\\s*$";var ee=d++;S[ee]="^\\s*("+S[v]+")\\s+-\\s+("+S[v]+")\\s*$";var ne=d++;S[ne]="(<|>)?=?\\s*\\*";for(var _=0;_<35;_++)j(_,S[_]),R[_]||(R[_]=new RegExp(S[_]));function re(he,ge){if(he instanceof Q)return he;if(typeof he!="string"||he.length>L||!(ge?R[n]:R[k]).test(he))return null;try{return new Q(he,ge)}catch{return null}}function Q(he,ge){if(he instanceof Q){if(he.loose===ge)return he;he=he.version}else if(typeof he!="string")throw new TypeError("Invalid Version: "+he);if(he.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof Q))return new Q(he,ge);j("SemVer",he,ge),this.loose=ge;var be=he.trim().match(ge?R[n]:R[k]);if(!be)throw new TypeError("Invalid Version: "+he);if(this.raw=he,this.major=+be[1],this.minor=+be[2],this.patch=+be[3],this.major>O||this.major<0)throw new TypeError("Invalid major version");if(this.minor>O||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>O||this.patch<0)throw new TypeError("Invalid patch version");be[4]?this.prerelease=be[4].split(".").map(function(Se){if(/^[0-9]+$/.test(Se)){var Ce=+Se;if(Ce>=0&&Ce<O)return Ce}return Se}):this.prerelease=[],this.build=be[5]?be[5].split("."):[],this.format()}e.parse=re,e.valid=function(he,ge){var be=re(he,ge);return be?be.version:null},e.clean=function(he,ge){var be=re(he.trim().replace(/^[=v]+/,""),ge);return be?be.version:null},e.SemVer=Q,Q.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Q.prototype.toString=function(){return this.version},Q.prototype.compare=function(he){return j("SemVer.compare",this.version,this.loose,he),he instanceof Q||(he=new Q(he,this.loose)),this.compareMain(he)||this.comparePre(he)},Q.prototype.compareMain=function(he){return he instanceof Q||(he=new Q(he,this.loose)),C(this.major,he.major)||C(this.minor,he.minor)||C(this.patch,he.patch)},Q.prototype.comparePre=function(he){if(he instanceof Q||(he=new Q(he,this.loose)),this.prerelease.length&&!he.prerelease.length)return-1;if(!this.prerelease.length&&he.prerelease.length)return 1;if(!this.prerelease.length&&!he.prerelease.length)return 0;var ge=0;do{var be=this.prerelease[ge],Se=he.prerelease[ge];if(j("prerelease compare",ge,be,Se),be===void 0&&Se===void 0)return 0;if(Se===void 0)return 1;if(be===void 0)return-1;if(be!==Se)return C(be,Se)}while(++ge)},Q.prototype.inc=function(he,ge){switch(he){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ge);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ge);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ge),this.inc("pre",ge);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ge),this.inc("pre",ge);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var be=this.prerelease.length;--be>=0;)typeof this.prerelease[be]=="number"&&(this.prerelease[be]++,be=-2);be===-1&&this.prerelease.push(0)}ge&&(this.prerelease[0]===ge?isNaN(this.prerelease[1])&&(this.prerelease=[ge,0]):this.prerelease=[ge,0]);break;default:throw new Error("invalid increment argument: "+he)}return this.format(),this.raw=this.version,this},e.inc=function(he,ge,be,Se){typeof be=="string"&&(Se=be,be=void 0);try{return new Q(he,be).inc(ge,Se).version}catch{return null}},e.diff=function(he,ge){if(U(he,ge))return null;var be=re(he),Se=re(ge);if(be.prerelease.length||Se.prerelease.length){for(var Ce in be)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&be[Ce]!==Se[Ce])return"pre"+Ce;return"prerelease"}for(var Ce in be)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&be[Ce]!==Se[Ce])return Ce},e.compareIdentifiers=C;var q=/^[0-9]+$/;function C(he,ge){var be=q.test(he),Se=q.test(ge);return be&&Se&&(he=+he,ge=+ge),be&&!Se?-1:Se&&!be?1:he<ge?-1:he>ge?1:0}function A(he,ge,be){return new Q(he,be).compare(new Q(ge,be))}function J(he,ge,be){return A(he,ge,be)>0}function F(he,ge,be){return A(he,ge,be)<0}function U(he,ge,be){return A(he,ge,be)===0}function W(he,ge,be){return A(he,ge,be)!==0}function te(he,ge,be){return A(he,ge,be)>=0}function se(he,ge,be){return A(he,ge,be)<=0}function ue(he,ge,be,Se){var Ce;switch(ge){case"===":typeof he=="object"&&(he=he.version),typeof be=="object"&&(be=be.version),Ce=he===be;break;case"!==":typeof he=="object"&&(he=he.version),typeof be=="object"&&(be=be.version),Ce=he!==be;break;case"":case"=":case"==":Ce=U(he,be,Se);break;case"!=":Ce=W(he,be,Se);break;case">":Ce=J(he,be,Se);break;case">=":Ce=te(he,be,Se);break;case"<":Ce=F(he,be,Se);break;case"<=":Ce=se(he,be,Se);break;default:throw new TypeError("Invalid operator: "+ge)}return Ce}function le(he,ge){if(he instanceof le){if(he.loose===ge)return he;he=he.value}if(!(this instanceof le))return new le(he,ge);j("comparator",he,ge),this.loose=ge,this.parse(he),this.semver===$e?this.value="":this.value=this.operator+this.semver.version,j("comp",this)}e.rcompareIdentifiers=function(he,ge){return C(ge,he)},e.major=function(he,ge){return new Q(he,ge).major},e.minor=function(he,ge){return new Q(he,ge).minor},e.patch=function(he,ge){return new Q(he,ge).patch},e.compare=A,e.compareLoose=function(he,ge){return A(he,ge,!0)},e.rcompare=function(he,ge,be){return A(ge,he,be)},e.sort=function(he,ge){return he.sort(function(be,Se){return e.compare(be,Se,ge)})},e.rsort=function(he,ge){return he.sort(function(be,Se){return e.rcompare(be,Se,ge)})},e.gt=J,e.lt=F,e.eq=U,e.neq=W,e.gte=te,e.lte=se,e.cmp=ue,e.Comparator=le;var $e={};function fe(he,ge){if(he instanceof fe)return he.loose===ge?he:new fe(he.raw,ge);if(he instanceof le)return new fe(he.value,ge);if(!(this instanceof fe))return new fe(he,ge);if(this.loose=ge,this.raw=he,this.set=he.split(/\s*\|\|\s*/).map(function(be){return this.parseRange(be.trim())},this).filter(function(be){return be.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+he);this.format()}function we(he){return!he||he.toLowerCase()==="x"||he==="*"}function ve(he,ge,be,Se,Ce,ze,je,Ue,Fe,oe,de,me,ye){return((ge=we(be)?"":we(Se)?">="+be+".0.0":we(Ce)?">="+be+"."+Se+".0":">="+ge)+" "+(Ue=we(Fe)?"":we(oe)?"<"+(+Fe+1)+".0.0":we(de)?"<"+Fe+"."+(+oe+1)+".0":me?"<="+Fe+"."+oe+"."+de+"-"+me:"<="+Ue)).trim()}function Oe(he,ge){for(var be=0;be<he.length;be++)if(!he[be].test(ge))return!1;if(ge.prerelease.length){for(be=0;be<he.length;be++)if(j(he[be].semver),he[be].semver!==$e&&he[be].semver.prerelease.length>0){var Se=he[be].semver;if(Se.major===ge.major&&Se.minor===ge.minor&&Se.patch===ge.patch)return!0}return!1}return!0}function Ne(he,ge,be){try{ge=new fe(ge,be)}catch{return!1}return ge.test(he)}function Me(he,ge,be,Se){var Ce,ze,je,Ue,Fe;switch(he=new Q(he,Se),ge=new fe(ge,Se),be){case">":Ce=J,ze=se,je=F,Ue=">",Fe=">=";break;case"<":Ce=F,ze=te,je=J,Ue="<",Fe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ne(he,ge,Se))return!1;for(var oe=0;oe<ge.set.length;++oe){var de=ge.set[oe],me=null,ye=null;if(de.forEach(function(ke){ke.semver===$e&&(ke=new le(">=0.0.0")),me=me||ke,ye=ye||ke,Ce(ke.semver,me.semver,Se)?me=ke:je(ke.semver,ye.semver,Se)&&(ye=ke)}),me.operator===Ue||me.operator===Fe||(!ye.operator||ye.operator===Ue)&&ze(he,ye.semver)||ye.operator===Fe&&je(he,ye.semver))return!1}return!0}le.prototype.parse=function(he){var ge=this.loose?R[H]:R[Y],be=he.match(ge);if(!be)throw new TypeError("Invalid comparator: "+he);this.operator=be[1],this.operator==="="&&(this.operator=""),be[2]?this.semver=new Q(be[2],this.loose):this.semver=$e},le.prototype.toString=function(){return this.value},le.prototype.test=function(he){return j("Comparator.test",he,this.loose),this.semver===$e||(typeof he=="string"&&(he=new Q(he,this.loose)),ue(he,this.operator,this.semver,this.loose))},le.prototype.intersects=function(he,ge){if(!(he instanceof le))throw new TypeError("a Comparator is required");var be;if(this.operator==="")return be=new fe(he.value,ge),Ne(this.value,be,ge);if(he.operator==="")return be=new fe(this.value,ge),Ne(he.semver,be,ge);var Se=!(this.operator!==">="&&this.operator!==">"||he.operator!==">="&&he.operator!==">"),Ce=!(this.operator!=="<="&&this.operator!=="<"||he.operator!=="<="&&he.operator!=="<"),ze=this.semver.version===he.semver.version,je=!(this.operator!==">="&&this.operator!=="<="||he.operator!==">="&&he.operator!=="<="),Ue=ue(this.semver,"<",he.semver,ge)&&(this.operator===">="||this.operator===">")&&(he.operator==="<="||he.operator==="<"),Fe=ue(this.semver,">",he.semver,ge)&&(this.operator==="<="||this.operator==="<")&&(he.operator===">="||he.operator===">");return Se||Ce||ze&&je||Ue||Fe},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(he){return he.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(he){var ge=this.loose;he=he.trim(),j("range",he,ge);var be=ge?R[ee]:R[V];he=he.replace(be,ve),j("hyphen replace",he),he=he.replace(R[G],"$1$2$3"),j("comparator trim",he,R[G]),he=(he=(he=he.replace(R[T],"$1~")).replace(R[Z],"$1^")).split(/\s+/).join(" ");var Se=ge?R[H]:R[Y],Ce=he.split(" ").map(function(ze){return function(je,Ue){return j("comp",je),je=function(Fe,oe){return Fe.trim().split(/\s+/).map(function(de){return function(me,ye){j("caret",me,ye);var ke=ye?R[x]:R[K];return me.replace(ke,function(Re,Pe,Ie,De,Ae){var Te;return j("caret",me,Re,Pe,Ie,De,Ae),we(Pe)?Te="":we(Ie)?Te=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":we(De)?Te=Pe==="0"?">="+Pe+"."+Ie+".0 <"+Pe+"."+(+Ie+1)+".0":">="+Pe+"."+Ie+".0 <"+(+Pe+1)+".0.0":Ae?(j("replaceCaret pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Te=Pe==="0"?Ie==="0"?">="+Pe+"."+Ie+"."+De+Ae+" <"+Pe+"."+Ie+"."+(+De+1):">="+Pe+"."+Ie+"."+De+Ae+" <"+Pe+"."+(+Ie+1)+".0":">="+Pe+"."+Ie+"."+De+Ae+" <"+(+Pe+1)+".0.0"):(j("no pr"),Te=Pe==="0"?Ie==="0"?">="+Pe+"."+Ie+"."+De+" <"+Pe+"."+Ie+"."+(+De+1):">="+Pe+"."+Ie+"."+De+" <"+Pe+"."+(+Ie+1)+".0":">="+Pe+"."+Ie+"."+De+" <"+(+Pe+1)+".0.0"),j("caret return",Te),Te})}(de,oe)}).join(" ")}(je,Ue),j("caret",je),je=function(Fe,oe){return Fe.trim().split(/\s+/).map(function(de){return function(me,ye){var ke=ye?R[z]:R[M];return me.replace(ke,function(Re,Pe,Ie,De,Ae){var Te;return j("tilde",me,Re,Pe,Ie,De,Ae),we(Pe)?Te="":we(Ie)?Te=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":we(De)?Te=">="+Pe+"."+Ie+".0 <"+Pe+"."+(+Ie+1)+".0":Ae?(j("replaceTilde pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Te=">="+Pe+"."+Ie+"."+De+Ae+" <"+Pe+"."+(+Ie+1)+".0"):Te=">="+Pe+"."+Ie+"."+De+" <"+Pe+"."+(+Ie+1)+".0",j("tilde return",Te),Te})}(de,oe)}).join(" ")}(je,Ue),j("tildes",je),je=function(Fe,oe){return j("replaceXRanges",Fe,oe),Fe.split(/\s+/).map(function(de){return function(me,ye){me=me.trim();var ke=ye?R[h]:R[p];return me.replace(ke,function(Re,Pe,Ie,De,Ae,Te){j("xRange",me,Re,Pe,Ie,De,Ae,Te);var Be=we(Ie),qe=Be||we(De),Ve=qe||we(Ae);return Pe==="="&&Ve&&(Pe=""),Be?Re=Pe===">"||Pe==="<"?"<0.0.0":"*":Pe&&Ve?(qe&&(De=0),Ve&&(Ae=0),Pe===">"?(Pe=">=",qe?(Ie=+Ie+1,De=0,Ae=0):Ve&&(De=+De+1,Ae=0)):Pe==="<="&&(Pe="<",qe?Ie=+Ie+1:De=+De+1),Re=Pe+Ie+"."+De+"."+Ae):qe?Re=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":Ve&&(Re=">="+Ie+"."+De+".0 <"+Ie+"."+(+De+1)+".0"),j("xRange return",Re),Re})}(de,oe)}).join(" ")}(je,Ue),j("xrange",je),je=function(Fe,oe){return j("replaceStars",Fe,oe),Fe.trim().replace(R[ne],"")}(je,Ue),j("stars",je),je}(ze,ge)}).join(" ").split(/\s+/);return this.loose&&(Ce=Ce.filter(function(ze){return!!ze.match(Se)})),Ce=Ce.map(function(ze){return new le(ze,ge)})},fe.prototype.intersects=function(he,ge){if(!(he instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(be){return be.every(function(Se){return he.set.some(function(Ce){return Ce.every(function(ze){return Se.intersects(ze,ge)})})})})},e.toComparators=function(he,ge){return new fe(he,ge).set.map(function(be){return be.map(function(Se){return Se.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(he){if(!he)return!1;typeof he=="string"&&(he=new Q(he,this.loose));for(var ge=0;ge<this.set.length;ge++)if(Oe(this.set[ge],he))return!0;return!1},e.satisfies=Ne,e.maxSatisfying=function(he,ge,be){var Se=null,Ce=null;try{var ze=new fe(ge,be)}catch{return null}return he.forEach(function(je){ze.test(je)&&(Se&&Ce.compare(je)!==-1||(Ce=new Q(Se=je,be)))}),Se},e.minSatisfying=function(he,ge,be){var Se=null,Ce=null;try{var ze=new fe(ge,be)}catch{return null}return he.forEach(function(je){ze.test(je)&&(Se&&Ce.compare(je)!==1||(Ce=new Q(Se=je,be)))}),Se},e.validRange=function(he,ge){try{return new fe(he,ge).range||"*"}catch{return null}},e.ltr=function(he,ge,be){return Me(he,ge,"<",be)},e.gtr=function(he,ge,be){return Me(he,ge,">",be)},e.outside=Me,e.prerelease=function(he,ge){var be=re(he,ge);return be&&be.prerelease.length?be.prerelease:null},e.intersects=function(he,ge,be){return he=new fe(he,be),ge=new fe(ge,be),he.intersects(ge)},e.coerce=function(he){if(he instanceof Q)return he;if(typeof he!="string")return null;var ge=he.match(R[g]);return ge==null?null:re((ge[1]||"0")+"."+(ge[2]||"0")+"."+(ge[3]||"0"))}}).call(this,I(1))},function(ie,e){var I,N,j=ie.exports={};function L(){throw new Error("setTimeout has not been defined")}function O(){throw new Error("clearTimeout has not been defined")}function R(w){if(I===setTimeout)return setTimeout(w,0);if((I===L||!I)&&setTimeout)return I=setTimeout,setTimeout(w,0);try{return I(w,0)}catch{try{return I.call(null,w,0)}catch{return I.call(this,w,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:L}catch{I=L}try{N=typeof clearTimeout=="function"?clearTimeout:O}catch{N=O}})();var S,d=[],P=!1,E=-1;function b(){P&&S&&(P=!1,S.length?d=S.concat(d):E=-1,d.length&&l())}function l(){if(!P){var w=R(b);P=!0;for(var c=d.length;c;){for(S=d,d=[];++E<c;)S&&S[E].run();E=-1,c=d.length}S=null,P=!1,function(u){if(N===clearTimeout)return clearTimeout(u);if((N===O||!N)&&clearTimeout)return N=clearTimeout,clearTimeout(u);try{N(u)}catch{try{return N.call(null,u)}catch{return N.call(this,u)}}}(w)}}function $(w,c){this.fun=w,this.array=c}function y(){}j.nextTick=function(w){var c=new Array(arguments.length-1);if(arguments.length>1)for(var u=1;u<arguments.length;u++)c[u-1]=arguments[u];d.push(new $(w,c)),d.length!==1||P||R(l)},$.prototype.run=function(){this.fun.apply(null,this.array)},j.title="browser",j.browser=!0,j.env={},j.argv=[],j.version="",j.versions={},j.on=y,j.addListener=y,j.once=y,j.off=y,j.removeListener=y,j.removeAllListeners=y,j.emit=y,j.prependListener=y,j.prependOnceListener=y,j.listeners=function(w){return[]},j.binding=function(w){throw new Error("process.binding is not supported")},j.cwd=function(){return"/"},j.chdir=function(w){throw new Error("process.chdir is not supported")},j.umask=function(){return 0}}])}),define(ae[127],ce([0,1]),function(ie,e){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$Cr=void 0;class N{constructor(R,S,d){this.level=R,this.key=S,this.value=d,this.forward=[]}}const j=void 0;class L{constructor(R,S=2**16){this.comparator=R,this[I]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(S)|0),this.e=new N(this.c,j,j)}get size(){return this.f}clear(){this.e=new N(this.c,j,j),this.f=0}has(R){return!!L.g(this,R,this.comparator)}get(R){return L.g(this,R,this.comparator)?.value}set(R,S){return L.h(this,R,S,this.comparator)&&(this.f+=1),this}delete(R){const S=L.k(this,R,this.comparator);return S&&(this.f-=1),S}forEach(R,S){let d=this.e.forward[0];for(;d;)R.call(S,d.value,d.key,this),d=d.forward[0]}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this.e.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this.e.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this.e.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",S=this.e.forward[0];for(;S;)R+=`node(${S.key}, ${S.value}, lvl:${S.level})`,S=S.forward[0];return R}static g(R,S,d){let P=R.e;for(let E=R.d-1;E>=0;E--)for(;P.forward[E]&&d(P.forward[E].key,S)<0;)P=P.forward[E];if(P=P.forward[0],P&&d(P.key,S)===0)return P}static h(R,S,d,P){const E=[];let b=R.e;for(let l=R.d-1;l>=0;l--){for(;b.forward[l]&&P(b.forward[l].key,S)<0;)b=b.forward[l];E[l]=b}if(b=b.forward[0],b&&P(b.key,S)===0)return b.value=d,!1;{const l=L.j(R);if(l>R.d){for(let $=R.d;$<l;$++)E[$]=R.e;R.d=l}b=new N(l,S,d);for(let $=0;$<l;$++)b.forward[$]=E[$].forward[$],E[$].forward[$]=b;return!0}}static j(R,S=.5){let d=1;for(;Math.random()<S&&d<R.c;)d+=1;return d}static k(R,S,d){const P=[];let E=R.e;for(let b=R.d-1;b>=0;b--){for(;E.forward[b]&&d(E.forward[b].key,S)<0;)E=E.forward[b];P[b]=E}if(E=E.forward[0],!E||d(E.key,S)!==0)return!1;for(let b=0;b<R.d&&P[b].forward[b]===E;b++)P[b].forward[b]=E.forward[b];for(;R.d>0&&R.e.forward[R.d-1]===j;)R.d-=1;return!0}}e.$Cr=L}),define(ae[62],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kd=void 0;const I=globalThis.performance&&typeof globalThis.performance.now=="function";class N{static create(L){return new N(L)}constructor(L){this.c=I&&L===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Kd=N}),define(ae[3],ce([0,1,7,85,2,87,62]),function(ie,e,I,N,j,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.Event=void 0;const R=!1,S=!1;var d;(function(p){p.None=()=>j.$Rc.None;function h(ue){if(S){const{onDidAddListener:le}=ue,$e=$.create();let fe=0;ue.onDidAddListener=()=>{++fe===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),$e.print()),le?.()}}}function g(ue,le){return Y(ue,()=>{},0,void 0,!0,void 0,le)}p.defer=g;function D(ue){return(le,$e=null,fe)=>{let we=!1,ve;return ve=ue(Oe=>{if(!we)return ve?ve.dispose():we=!0,le.call($e,Oe)},null,fe),we&&ve.dispose(),ve}}p.once=D;function T(ue,le,$e){return x((fe,we=null,ve)=>ue(Oe=>fe.call(we,le(Oe)),null,ve),$e)}p.map=T;function M(ue,le,$e){return x((fe,we=null,ve)=>ue(Oe=>{le(Oe),fe.call(we,Oe)},null,ve),$e)}p.forEach=M;function z(ue,le,$e){return x((fe,we=null,ve)=>ue(Oe=>le(Oe)&&fe.call(we,Oe),null,ve),$e)}p.filter=z;function B(ue){return ue}p.signal=B;function Z(...ue){return(le,$e=null,fe)=>{const we=(0,j.$Oc)(...ue.map(ve=>ve(Oe=>le.call($e,Oe))));return H(we,fe)}}p.any=Z;function K(ue,le,$e,fe){let we=$e;return T(ue,ve=>(we=le(we,ve),we),fe)}p.reduce=K;function x(ue,le){let $e;const fe={onWillAddFirstListener(){$e=ue(we.fire,we)},onDidRemoveLastListener(){$e?.dispose()}};le||h(fe);const we=new f(fe);return le?.add(we),we.event}function H(ue,le){return le instanceof Array?le.push(ue):le&&le.add(ue),ue}function Y(ue,le,$e=100,fe=!1,we=!1,ve,Oe){let Ne,Me,he,ge=0,be;const Se={leakWarningThreshold:ve,onWillAddFirstListener(){Ne=ue(ze=>{ge++,Me=le(Me,ze),fe&&!he&&(Ce.fire(Me),Me=void 0),be=()=>{const je=Me;Me=void 0,he=void 0,(!fe||ge>1)&&Ce.fire(je),ge=0},typeof $e=="number"?(clearTimeout(he),he=setTimeout(be,$e)):he===void 0&&(he=0,queueMicrotask(be))})},onWillRemoveListener(){we&&ge>0&&be?.()},onDidRemoveLastListener(){be=void 0,Ne.dispose()}};Oe||h(Se);const Ce=new f(Se);return Oe?.add(Ce),Ce.event}p.debounce=Y;function G(ue,le=0,$e){return p.debounce(ue,(fe,we)=>fe?(fe.push(we),fe):[we],le,void 0,!0,void 0,$e)}p.accumulate=G;function V(ue,le=(fe,we)=>fe===we,$e){let fe=!0,we;return z(ue,ve=>{const Oe=fe||!le(ve,we);return fe=!1,we=ve,Oe},$e)}p.latch=V;function ee(ue,le,$e){return[p.filter(ue,le,$e),p.filter(ue,fe=>!le(fe),$e)]}p.split=ee;function ne(ue,le=!1,$e=[],fe){let we=$e.slice(),ve=ue(Me=>{we?we.push(Me):Ne.fire(Me)});fe&&fe.add(ve);const Oe=()=>{we?.forEach(Me=>Ne.fire(Me)),we=null},Ne=new f({onWillAddFirstListener(){ve||(ve=ue(Me=>Ne.fire(Me)),fe&&fe.add(ve))},onDidAddFirstListener(){we&&(le?setTimeout(Oe):Oe())},onDidRemoveLastListener(){ve&&ve.dispose(),ve=null}});return fe&&fe.add(Ne),Ne.event}p.buffer=ne;function _(ue,le){return(fe,we,ve)=>{const Oe=le(new Q);return ue(function(Ne){const Me=Oe.evaluate(Ne);Me!==re&&fe.call(we,Me)},void 0,ve)}}p.chain=_;const re=Symbol("HaltChainable");class Q{constructor(){this.f=[]}map(le){return this.f.push(le),this}forEach(le){return this.f.push($e=>(le($e),$e)),this}filter(le){return this.f.push($e=>le($e)?$e:re),this}reduce(le,$e){let fe=$e;return this.f.push(we=>(fe=le(fe,we),fe)),this}latch(le=($e,fe)=>$e===fe){let $e=!0,fe;return this.f.push(we=>{const ve=$e||!le(we,fe);return $e=!1,fe=we,ve?we:re}),this}evaluate(le){for(const $e of this.f)if(le=$e(le),le===re)break;return le}}function q(ue,le,$e=fe=>fe){const fe=(...Ne)=>Oe.fire($e(...Ne)),we=()=>ue.on(le,fe),ve=()=>ue.removeListener(le,fe),Oe=new f({onWillAddFirstListener:we,onDidRemoveLastListener:ve});return Oe.event}p.fromNodeEventEmitter=q;function C(ue,le,$e=fe=>fe){const fe=(...Ne)=>Oe.fire($e(...Ne)),we=()=>ue.addEventListener(le,fe),ve=()=>ue.removeEventListener(le,fe),Oe=new f({onWillAddFirstListener:we,onDidRemoveLastListener:ve});return Oe.event}p.fromDOMEventEmitter=C;function A(ue){return new Promise(le=>D(ue)(le))}p.toPromise=A;function J(ue){const le=new f;return ue.then($e=>{le.fire($e)},()=>{le.fire(void 0)}).finally(()=>{le.dispose()}),le.event}p.fromPromise=J;function F(ue,le,$e){return le($e),ue(fe=>le(fe))}p.runAndSubscribe=F;function U(ue,le){let $e=null;function fe(ve){$e?.dispose(),$e=new j.$Qc,le(ve,$e)}fe(void 0);const we=ue(ve=>fe(ve));return(0,j.$Pc)(()=>{we.dispose(),$e?.dispose()})}p.runAndSubscribeWithStore=U;class W{constructor(le,$e){this._observable=le,this.f=0,this.g=!1;const fe={onWillAddFirstListener:()=>{le.addObserver(this)},onDidRemoveLastListener:()=>{le.removeObserver(this)}};$e||h(fe),this.emitter=new f(fe),$e&&$e.add(this.emitter)}beginUpdate(le){this.f++}handlePossibleChange(le){}handleChange(le,$e){this.g=!0}endUpdate(le){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function te(ue,le){return new W(ue,le).emitter.event}p.fromObservable=te;function se(ue){return le=>{let $e=0,fe=!1;const we={beginUpdate(){$e++},endUpdate(){$e--,$e===0&&(ue.reportChanges(),fe&&(fe=!1,le()))},handlePossibleChange(){},handleChange(){fe=!0}};return ue.addObserver(we),ue.reportChanges(),{dispose(){ue.removeObserver(we)}}}}p.fromObservableLight=se})(d||(e.Event=d={}));class P{static{this.all=new Set}static{this.f=0}constructor(h){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${h}_${P.f++}`,P.all.add(this)}start(h){this.g=new O.$Kd,this.listenerCount=h}stop(){if(this.g){const h=this.g.elapsed();this.durations.push(h),this.elapsedOverall+=h,this.invocationCount+=1,this.g=void 0}}}e.$Md=P;let E=-1;function b(p){const h=E;return E=p,{dispose(){E=h}}}e.$Nd=b;class l{constructor(h,g=Math.random().toString(18).slice(2,5)){this.threshold=h,this.name=g,this.g=0}dispose(){this.f?.clear()}check(h,g){const D=this.threshold;if(D<=0||g<D)return;this.f||(this.f=new Map);const T=this.f.get(h.value)||0;if(this.f.set(h.value,T+1),this.g-=1,this.g<=0){this.g=D*.5;let M,z=0;for(const[B,Z]of this.f)(!M||z<Z)&&(M=B,z=Z);console.warn(`[${this.name}] potential listener LEAK detected, having ${g} listeners already. MOST frequent listener (${z}):`),console.warn(M)}return()=>{const M=this.f.get(h.value)||0;this.f.set(h.value,M-1)}}}class ${static create(){return new $(new Error().stack??"")}constructor(h){this.value=h}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let y=0;class w{constructor(h){this.value=h,this.id=y++}}const c=2,u=(p,h)=>{if(p instanceof w)h(p);else for(let g=0;g<p.length;g++){const D=p[g];D&&h(D)}};class f{constructor(h){this.w=0,this.f=h,this.g=E>0||this.f?.leakWarningThreshold?new l(this.f?.leakWarningThreshold??E):void 0,this.j=this.f?._profName?new P(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(R){const h=this.t;queueMicrotask(()=>{u(h,g=>g.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(h,g,D)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),j.$Rc.None;if(this.m)return j.$Rc.None;g&&(h=h.bind(g));const T=new w(h);let M,z;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(T.stack=$.create(),M=this.g.check(T.stack,this.w+1)),R&&(T.stack=z??$.create()),this.t?this.t instanceof w?(this.u??=new k,this.t=[this.t,T]):this.t.push(T):(this.f?.onWillAddFirstListener?.(this),this.t=T,this.f?.onDidAddFirstListener?.(this)),this.w++;const B=(0,j.$Pc)(()=>{M?.(),this.x(T)});return D instanceof j.$Qc?D.add(B):Array.isArray(D)&&D.push(B),B},this.q}x(h){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const g=this.t,D=g.indexOf(h);if(D===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,g[D]=void 0;const T=this.u.current===this;if(this.w*c<=g.length){let M=0;for(let z=0;z<g.length;z++)g[z]?g[M++]=g[z]:T&&(this.u.end--,M<this.u.i&&this.u.i--);g.length=M}}y(h,g){if(!h)return;const D=this.f?.onListenerError||I.$Z;if(!D){h.value(g);return}try{h.value(g)}catch(T){D(T)}}z(h){const g=h.current.t;for(;h.i<h.end;)this.y(g[h.i++],h.value);h.reset()}fire(h){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof w)this.y(this.t,h);else{const g=this.u;g.enqueue(this,h,this.t.length),this.z(g)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Od=f;const m=()=>new k;e.$Pd=m;class k{constructor(){this.i=-1,this.end=0}enqueue(h,g,D){this.i=0,this.end=D,this.current=h,this.value=g}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class s extends f{async fireAsync(h,g,D){if(this.t)for(this.h||(this.h=new L.$1c),u(this.t,T=>this.h.push([T.value,h]));this.h.size>0&&!g.isCancellationRequested;){const[T,M]=this.h.shift(),z=[],B={...M,token:g,waitUntil:Z=>{if(Object.isFrozen(z))throw new Error("waitUntil can NOT be called asynchronous");D&&(Z=D(Z,T)),z.push(Z)}};try{T(B)}catch(Z){(0,I.$Z)(Z);continue}Object.freeze(z),await Promise.allSettled(z).then(Z=>{for(const K of Z)K.status==="rejected"&&(0,I.$Z)(K.reason)})}}}e.$Qd=s;class a extends f{get isPaused(){return this.h!==0}constructor(h){super(h),this.h=0,this.s=new L.$1c,this.A=h?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const h=Array.from(this.s);this.s.clear(),super.fire(this.A(h))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(h){this.w&&(this.h!==0?this.s.push(h):super.fire(h))}}e.$Rd=a;class n extends a{constructor(h){super(h),this.k=h.delay??100}fire(h){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(h)}}e.$Sd=n;class i extends f{constructor(h){super(h),this.h=[],this.k=h?.merge}fire(h){this.hasListeners()&&(this.h.push(h),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(g=>super.fire(g)),this.h=[]}))}}e.$Td=i;class t{constructor(){this.g=!1,this.h=[],this.f=new f({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(h){const g={event:h,listener:null};this.h.push(g),this.g&&this.m(g);const D=()=>{this.g&&this.o(g);const T=this.h.indexOf(g);this.h.splice(T,1)};return(0,j.$Pc)((0,N.$cb)(D))}j(){this.g=!0,this.h.forEach(h=>this.m(h))}k(){this.g=!1,this.h.forEach(h=>this.o(h))}m(h){h.listener=h.event(g=>this.f.fire(g))}o(h){h.listener&&h.listener.dispose(),h.listener=null}dispose(){this.f.dispose()}}e.$Ud=t;class r{constructor(h,g,D,T){this.f=new j.$Qc;const M=this.f.add(new t),z=this.f.add(new j.$Zc);function B(Z){z.set(Z,M.add(T(Z)))}for(const Z of h)B(Z);this.f.add(g(Z=>{B(Z)})),this.f.add(D(Z=>{z.deleteAndDispose(Z)})),this.event=M.event}dispose(){this.f.dispose()}}e.$Vd=r;class o{constructor(){this.f=[]}wrapEvent(h){return(g,D,T)=>h(M=>{const z=this.f[this.f.length-1];z?z.push(()=>g.call(D,M)):g.call(D,M)},void 0,T)}bufferEvents(h){const g=[];this.f.push(g);const D=h();return this.f.pop(),g.forEach(T=>T()),D}}e.$Wd=o;class v{constructor(){this.f=!1,this.g=d.None,this.h=j.$Rc.None,this.j=new f({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(h){this.g=h,this.f&&(this.h.dispose(),this.h=h(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$Xd=v}),define(ae[26],ce([0,1,3]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yd=e.CancellationToken=void 0;const N=Object.freeze(function(R,S){const d=setTimeout(R.bind(S),0);return{dispose(){clearTimeout(d)}}});var j;(function(R){function S(d){return d===R.None||d===R.Cancelled||d instanceof L?!0:!d||typeof d!="object"?!1:typeof d.isCancellationRequested=="boolean"&&typeof d.onCancellationRequested=="function"}R.isCancellationToken=S,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:I.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:N})})(j||(e.CancellationToken=j={}));class L{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?N:(this.b||(this.b=new I.$Od),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class O{constructor(S){this.f=void 0,this.g=void 0,this.g=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new L),this.f}cancel(){this.f?this.f instanceof L&&this.f.cancel():this.f=j.Cancelled}dispose(S=!1){S&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof L&&this.f.dispose():this.f=j.None}}e.$Yd=O}),define(ae[128],ce([0,1,26]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=e.$ye=e.$xe=void 0;class N{constructor(R){this.b=R,this.a=null}get(){if(this.a)return this.a;const R=new I.$Yd,S=this.b(R.token);return this.a={promise:S,dispose:()=>{this.a=null,R.cancel(),R.dispose()}},this.a}}e.$xe=N;class j{constructor(R){this.c=R,this.a=void 0,this.b=void 0}get(R){const S=JSON.stringify(R);return this.b!==S&&(this.b=S,this.a=this.c(R)),this.a}}e.$ye=j;class L{get cachedValues(){return this.a}constructor(R){this.b=R,this.a=new Map}get(R){if(this.a.has(R))return this.a.get(R);const S=this.b(R);return this.a.set(R,S),S}}e.$ze=L}),define(ae[46],ce([0,1,7,2]),function(ie,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=void 0;function j(m){const k=m;return k?typeof k.read=="function":!1}e.$Zd=j;function L(m){const k=m;return k?[k.on,k.pause,k.resume,k.destroy].every(s=>typeof s=="function"):!1}e.$1d=L;function O(m){const k=m;return k?L(k.stream)&&Array.isArray(k.buffer)&&typeof k.ended=="boolean":!1}e.$2d=O;function R(m,k){return new S(m,k)}e.$3d=R;class S{constructor(k,s){this.e=k,this.f=s,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(k){if(!this.a.destroyed){if(this.a.flowing)this.g(k);else if(this.b.data.push(k),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(s=>this.d.push(s))}}error(k){this.a.destroyed||(this.a.flowing?this.h(k):this.b.error.push(k))}end(k){this.a.destroyed||(typeof k<"u"&&this.write(k),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(k){this.c.data.slice(0).forEach(s=>s(k))}h(k){this.c.error.length===0?(0,I.$Z)(k):this.c.error.slice(0).forEach(s=>s(k))}i(){this.c.end.slice(0).forEach(k=>k())}on(k,s){if(!this.a.destroyed)switch(k){case"data":this.c.data.push(s),this.resume();break;case"end":this.c.end.push(s),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(s),this.a.flowing&&this.k();break}}removeListener(k,s){if(this.a.destroyed)return;let a;switch(k){case"data":a=this.c.data;break;case"end":a=this.c.end;break;case"error":a=this.c.error;break}if(a){const n=a.indexOf(s);n>=0&&a.splice(n,1)}}j(){if(this.b.data.length>0){const k=this.e(this.b.data);this.g(k),this.b.data.length=0;const s=[...this.d];this.d.length=0,s.forEach(a=>a())}}k(){if(this.c.error.length>0){for(const k of this.b.error)this.h(k);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function d(m,k){const s=[];let a;for(;(a=m.read())!==null;)s.push(a);return k(s)}e.$4d=d;function P(m,k,s){const a=[];let n;for(;(n=m.read())!==null&&a.length<s;)a.push(n);return n===null&&a.length>0?k(a):{read:()=>{if(a.length>0)return a.shift();if(typeof n<"u"){const i=n;return n=void 0,i}return m.read()}}}e.$5d=P;function E(m,k){return new Promise((s,a)=>{const n=[];b(m,{onData:i=>{k&&n.push(i)},onError:i=>{k?a(i):s(void 0)},onEnd:()=>{s(k?k(n):void 0)}})})}e.$6d=E;function b(m,k,s){m.on("error",a=>{s?.isCancellationRequested||k.onError(a)}),m.on("end",()=>{s?.isCancellationRequested||k.onEnd()}),m.on("data",a=>{s?.isCancellationRequested||k.onData(a)})}e.$7d=b;function l(m,k){return new Promise((s,a)=>{const n=new N.$Qc,i=[],t=v=>{if(i.push(v),i.length>k)return n.dispose(),m.pause(),s({stream:m,buffer:i,ended:!1})},r=v=>(n.dispose(),a(v)),o=()=>(n.dispose(),s({stream:m,buffer:i,ended:!0}));n.add((0,N.$Pc)(()=>m.removeListener("error",r))),m.on("error",r),n.add((0,N.$Pc)(()=>m.removeListener("end",o))),m.on("end",o),n.add((0,N.$Pc)(()=>m.removeListener("data",t))),m.on("data",t)})}e.$8d=l;function $(m,k){const s=R(k);return s.end(m),s}e.$9d=$;function y(){const m=R(()=>{throw new Error("not supported")});return m.end(),m}e.$0d=y;function w(m){let k=!1;return{read:()=>k?null:(k=!0,m)}}e.$$d=w;function c(m,k,s){const a=R(s);return b(m,{onData:n=>a.write(k.data(n)),onError:n=>a.error(k.error?k.error(n):n),onEnd:()=>a.end()}),a}e.$_d=c;function u(m,k,s){let a=!1;return{read:()=>{const n=k.read();return a?n:(a=!0,n!==null?s([m,n]):m)}}}e.$ae=u;function f(m,k,s){let a=!1;const n=R(s);return b(k,{onData:i=>a?n.write(i):(a=!0,n.write(s([m,i]))),onError:i=>n.error(i),onEnd:()=>{a||(a=!0,n.write(m)),n.end()}}),n}e.$be=f}),define(ae[15],ce([0,1,61,46]),function(ie,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=void 0;const j=typeof Buffer<"u",L=new I.$U(()=>new Uint8Array(256));let O,R;class S{static alloc(g){return j?new S(Buffer.allocUnsafe(g)):new S(new Uint8Array(g))}static wrap(g){return j&&!Buffer.isBuffer(g)&&(g=Buffer.from(g.buffer,g.byteOffset,g.byteLength)),new S(g)}static fromString(g,D){return!(D?.dontUseNodeBuffer||!1)&&j?new S(Buffer.from(g)):(O||(O=new TextEncoder),new S(O.encode(g)))}static fromByteArray(g){const D=S.alloc(g.length);for(let T=0,M=g.length;T<M;T++)D.buffer[T]=g[T];return D}static concat(g,D){if(typeof D>"u"){D=0;for(let z=0,B=g.length;z<B;z++)D+=g[z].byteLength}const T=S.alloc(D);let M=0;for(let z=0,B=g.length;z<B;z++){const Z=g[z];T.set(Z,M),M+=Z.byteLength}return T}constructor(g){this.buffer=g,this.byteLength=this.buffer.byteLength}clone(){const g=S.alloc(this.byteLength);return g.set(this),g}toString(){return j?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(g,D){return new S(this.buffer.subarray(g,D))}set(g,D){if(g instanceof S)this.buffer.set(g.buffer,D);else if(g instanceof Uint8Array)this.buffer.set(g,D);else if(g instanceof ArrayBuffer)this.buffer.set(new Uint8Array(g),D);else if(ArrayBuffer.isView(g))this.buffer.set(new Uint8Array(g.buffer,g.byteOffset,g.byteLength),D);else throw new Error("Unknown argument 'array'")}readUInt32BE(g){return b(this.buffer,g)}writeUInt32BE(g,D){l(this.buffer,g,D)}readUInt32LE(g){return $(this.buffer,g)}writeUInt32LE(g,D){y(this.buffer,g,D)}readUInt8(g){return w(this.buffer,g)}writeUInt8(g,D){c(this.buffer,g,D)}indexOf(g,D=0){return d(this.buffer,g instanceof S?g.buffer:g,D)}}e.$ce=S;function d(h,g,D=0){const T=g.byteLength,M=h.byteLength;if(T===0)return 0;if(T===1)return h.indexOf(g[0]);if(T>M-D)return-1;const z=L.value;z.fill(g.length);for(let x=0;x<g.length;x++)z[g[x]]=g.length-x-1;let B=D+g.length-1,Z=B,K=-1;for(;B<M;)if(h[B]===g[Z]){if(Z===0){K=B;break}B--,Z--}else B+=Math.max(g.length-Z,z[h[B]]),Z=g.length-1;return K}e.$de=d;function P(h,g){return h[g+0]<<0>>>0|h[g+1]<<8>>>0}e.$ee=P;function E(h,g,D){h[D+0]=g&255,g=g>>>8,h[D+1]=g&255}e.$fe=E;function b(h,g){return h[g]*2**24+h[g+1]*2**16+h[g+2]*2**8+h[g+3]}e.$ge=b;function l(h,g,D){h[D+3]=g,g=g>>>8,h[D+2]=g,g=g>>>8,h[D+1]=g,g=g>>>8,h[D]=g}e.$he=l;function $(h,g){return h[g+0]<<0>>>0|h[g+1]<<8>>>0|h[g+2]<<16>>>0|h[g+3]<<24>>>0}e.$ie=$;function y(h,g,D){h[D+0]=g&255,g=g>>>8,h[D+1]=g&255,g=g>>>8,h[D+2]=g&255,g=g>>>8,h[D+3]=g&255}e.$je=y;function w(h,g){return h[g]}e.$ke=w;function c(h,g,D){h[D]=g}e.$le=c;function u(h){return N.$4d(h,g=>S.concat(g))}e.$me=u;function f(h){return N.$$d(h)}e.$ne=f;function m(h){return N.$6d(h,g=>S.concat(g))}e.$oe=m;async function k(h){return h.ended?S.concat(h.buffer):S.concat([...h.buffer,await m(h.stream)])}e.$pe=k;function s(h){return N.$9d(h,g=>S.concat(g))}e.$qe=s;function a(h){return N.$_d(h,{data:g=>typeof g=="string"?S.fromString(g):S.wrap(g)},g=>S.concat(g))}e.$re=a;function n(h){return N.$3d(g=>S.concat(g),h)}e.$se=n;function i(h,g){return N.$ae(h,g,D=>S.concat(D))}e.$te=i;function t(h,g){return N.$be(h,g,D=>S.concat(D))}e.$ue=t;function r(h){let g=0,D=0,T=0;const M=new Uint8Array(Math.floor(h.length/4*3)),z=Z=>{switch(D){case 3:M[T++]=g|Z,D=0;break;case 2:M[T++]=g|Z>>>2,g=Z<<6,D=3;break;case 1:M[T++]=g|Z>>>4,g=Z<<4,D=2;break;default:g=Z<<2,D=1}};for(let Z=0;Z<h.length;Z++){const K=h.charCodeAt(Z);if(K>=65&&K<=90)z(K-65);else if(K>=97&&K<=122)z(K-97+26);else if(K>=48&&K<=57)z(K-48+52);else if(K===43||K===45)z(62);else if(K===47||K===95)z(63);else{if(K===61)break;throw new SyntaxError(`Unexpected base64 character ${h[Z]}`)}}const B=T;for(;D>0;)z(0);return S.wrap(M).slice(0,B)}e.$ve=r;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function p({buffer:h},g=!0,D=!1){const T=D?v:o;let M="";const z=h.byteLength%3;let B=0;for(;B<h.byteLength-z;B+=3){const Z=h[B+0],K=h[B+1],x=h[B+2];M+=T[Z>>>2],M+=T[(Z<<4|K>>>4)&63],M+=T[(K<<2|x>>>6)&63],M+=T[x&63]}if(z===1){const Z=h[B+0];M+=T[Z>>>2],M+=T[Z<<4&63],g&&(M+="==")}else if(z===2){const Z=h[B+0],K=h[B+1];M+=T[Z>>>2],M+=T[(Z<<4|K>>>4)&63],M+=T[K<<2&63],g&&(M+="=")}return M}e.$we=p}),define(ae[27],ce([0,1,128,61]),function(ie,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yf=e.$xf=e.$wf=e.$vf=e.GraphemeBreakType=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=void 0;function j(oe){return!oe||typeof oe!="string"?!0:oe.trim().length===0}e.$Ce=j;const L=/{(\d+)}/g;function O(oe,...de){return de.length===0?oe:oe.replace(L,function(me,ye){const ke=parseInt(ye,10);return isNaN(ke)||ke<0||ke>=de.length?me:de[ke]})}e.$De=O;const R=/{([^}]+)}/g;function S(oe,de){return Object.keys(de).length===0?oe:oe.replace(R,(me,ye)=>de[ye]??me)}e.$Ee=S;function d(oe){return oe.replace(/[<>&]/g,function(de){switch(de){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return de}})}e.$Fe=d;function P(oe){return oe.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Ge=P;function E(oe,de){let me=0;const ye=de.charCodeAt(0);for(let ke=oe.length-1;ke>=0;ke--)oe.charCodeAt(ke)===ye&&me++;return me}e.$He=E;function b(oe,de,me="\u2026"){return oe.length<=de?oe:`${oe.substr(0,de)}${me}`}e.$Ie=b;function l(oe,de=" "){const me=$(oe,de);return y(me,de)}e.$Je=l;function $(oe,de){if(!oe||!de)return oe;const me=de.length;if(me===0||oe.length===0)return oe;let ye=0;for(;oe.indexOf(de,ye)===ye;)ye=ye+me;return oe.substring(ye)}e.$Ke=$;function y(oe,de){if(!oe||!de)return oe;const me=de.length,ye=oe.length;if(me===0||ye===0)return oe;let ke=ye,Re=-1;for(;Re=oe.lastIndexOf(de,ke-1),!(Re===-1||Re+me!==ke);){if(Re===0)return"";ke=Re}return oe.substring(0,ke)}e.$Le=y;function w(oe){return oe.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Me=w;function c(oe){return oe.replace(/\*/g,"")}e.$Ne=c;function u(oe,de,me={}){if(!oe)throw new Error("Cannot create regex from empty string");de||(oe=P(oe)),me.wholeWord&&(/\B/.test(oe.charAt(0))||(oe="\\b"+oe),/\B/.test(oe.charAt(oe.length-1))||(oe=oe+"\\b"));let ye="";return me.global&&(ye+="g"),me.matchCase||(ye+="i"),me.multiline&&(ye+="m"),me.unicode&&(ye+="u"),new RegExp(oe,ye)}e.$Oe=u;function f(oe){return oe.source==="^"||oe.source==="^$"||oe.source==="$"||oe.source==="^\\s*$"?!1:!!(oe.exec("")&&oe.lastIndex===0)}e.$Pe=f;function m(oe){return oe.split(/\r\n|\r|\n/)}e.$Qe=m;function k(oe){for(let de=0,me=oe.length;de<me;de++){const ye=oe.charCodeAt(de);if(ye!==32&&ye!==9)return de}return-1}e.$Re=k;function s(oe,de=0,me=oe.length){for(let ye=de;ye<me;ye++){const ke=oe.charCodeAt(ye);if(ke!==32&&ke!==9)return oe.substring(de,ye)}return oe.substring(de,me)}e.$Se=s;function a(oe,de=oe.length-1){for(let me=de;me>=0;me--){const ye=oe.charCodeAt(me);if(ye!==32&&ye!==9)return me}return-1}e.$Te=a;function n(oe,de,me){const ye=[];let ke=0;for(const Re of oe.matchAll(de)){if(ye.push(oe.slice(ke,Re.index)),Re.index===void 0)throw new Error("match.index should be defined");ke=Re.index+Re[0].length,ye.push(me(Re[0],...Re.slice(1),Re.index,oe,Re.groups))}return ye.push(oe.slice(ke)),Promise.all(ye).then(Re=>Re.join(""))}e.$Ue=n;function i(oe,de){return oe<de?-1:oe>de?1:0}e.$Ve=i;function t(oe,de,me=0,ye=oe.length,ke=0,Re=de.length){for(;me<ye&&ke<Re;me++,ke++){const De=oe.charCodeAt(me),Ae=de.charCodeAt(ke);if(De<Ae)return-1;if(De>Ae)return 1}const Pe=ye-me,Ie=Re-ke;return Pe<Ie?-1:Pe>Ie?1:0}e.$We=t;function r(oe,de){return o(oe,de,0,oe.length,0,de.length)}e.$Xe=r;function o(oe,de,me=0,ye=oe.length,ke=0,Re=de.length){for(;me<ye&&ke<Re;me++,ke++){let De=oe.charCodeAt(me),Ae=de.charCodeAt(ke);if(De===Ae)continue;if(De>=128||Ae>=128)return t(oe.toLowerCase(),de.toLowerCase(),me,ye,ke,Re);p(De)&&(De-=32),p(Ae)&&(Ae-=32);const Te=De-Ae;if(Te!==0)return Te}const Pe=ye-me,Ie=Re-ke;return Pe<Ie?-1:Pe>Ie?1:0}e.$Ye=o;function v(oe){return oe>=48&&oe<=57}e.$Ze=v;function p(oe){return oe>=97&&oe<=122}e.$1e=p;function h(oe){return oe>=65&&oe<=90}e.$2e=h;function g(oe,de){return oe.length===de.length&&o(oe,de)===0}e.$3e=g;function D(oe,de){const me=de.length;return de.length>oe.length?!1:o(oe,de,0,me)===0}e.$4e=D;function T(oe,de){const me=Math.min(oe.length,de.length);let ye;for(ye=0;ye<me;ye++)if(oe.charCodeAt(ye)!==de.charCodeAt(ye))return ye;return me}e.$5e=T;function M(oe,de){const me=Math.min(oe.length,de.length);let ye;const ke=oe.length-1,Re=de.length-1;for(ye=0;ye<me;ye++)if(oe.charCodeAt(ke-ye)!==de.charCodeAt(Re-ye))return ye;return me}e.$6e=M;function z(oe){return 55296<=oe&&oe<=56319}e.$7e=z;function B(oe){return 56320<=oe&&oe<=57343}e.$8e=B;function Z(oe,de){return(oe-55296<<10)+(de-56320)+65536}e.$9e=Z;function K(oe,de,me){const ye=oe.charCodeAt(me);if(z(ye)&&me+1<de){const ke=oe.charCodeAt(me+1);if(B(ke))return Z(ye,ke)}return ye}e.$0e=K;function x(oe,de){const me=oe.charCodeAt(de-1);if(B(me)&&de>1){const ye=oe.charCodeAt(de-2);if(z(ye))return Z(ye,me)}return me}class H{get offset(){return this.e}constructor(de,me=0){this.c=de,this.d=de.length,this.e=me}setOffset(de){this.e=de}prevCodePoint(){const de=x(this.c,this.e);return this.e-=de>=65536?2:1,de}nextCodePoint(){const de=K(this.c,this.d,this.e);return this.e+=de>=65536?2:1,de}eol(){return this.e>=this.d}}e.$$e=H;class Y{get offset(){return this.c.offset}constructor(de,me=0){this.c=new H(de,me)}nextGraphemeLength(){const de=ge.getInstance(),me=this.c,ye=me.offset;let ke=de.getGraphemeBreakType(me.nextCodePoint());for(;!me.eol();){const Re=me.offset,Pe=de.getGraphemeBreakType(me.nextCodePoint());if(Me(ke,Pe)){me.setOffset(Re);break}ke=Pe}return me.offset-ye}prevGraphemeLength(){const de=ge.getInstance(),me=this.c,ye=me.offset;let ke=de.getGraphemeBreakType(me.prevCodePoint());for(;me.offset>0;){const Re=me.offset,Pe=de.getGraphemeBreakType(me.prevCodePoint());if(Me(Pe,ke)){me.setOffset(Re);break}ke=Pe}return ye-me.offset}eol(){return this.c.eol()}}e.$_e=Y;function G(oe,de){return new Y(oe,de).nextGraphemeLength()}e.$af=G;function V(oe,de){return new Y(oe,de).prevGraphemeLength()}e.$bf=V;function ee(oe,de){de>0&&B(oe.charCodeAt(de))&&de--;const me=de+G(oe,de);return[me-V(oe,me),me]}e.$cf=ee;function ne(oe){const de=new Y(oe);let me=0;for(;!de.eol();)me++,de.nextGraphemeLength();return me}e.$df=ne;let _;function re(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Q(oe){return _||(_=re()),_.test(oe)}e.$ef=Q;const q=/^[\t\n\r\x20-\x7E]*$/;function C(oe){return q.test(oe)}e.$ff=C,e.$gf=/[\u2028\u2029]/;function A(oe){return e.$gf.test(oe)}e.$hf=A;function J(oe){return oe>=11904&&oe<=55215||oe>=63744&&oe<=64255||oe>=65281&&oe<=65374}e.$if=J;function F(oe){return oe>=127462&&oe<=127487||oe===8986||oe===8987||oe===9200||oe===9203||oe>=9728&&oe<=10175||oe===11088||oe===11093||oe>=127744&&oe<=128591||oe>=128640&&oe<=128764||oe>=128992&&oe<=129008||oe>=129280&&oe<=129535||oe>=129648&&oe<=129782}e.$jf=F;function U(oe,de){if(oe.length<de)return oe;const me=/\b/g;let ye=0;for(;me.test(oe)&&!(oe.length-me.lastIndex<de);)ye=me.lastIndex,me.lastIndex+=1;return oe.substring(ye).replace(/^\s/,"")}e.$kf=U;const W=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,te=/\x1b\].*?\x07/g;function se(oe){return oe&&(oe=oe.replace(W,"").replace(te,"")),oe}e.$lf=se,e.$mf=String.fromCharCode(65279);function ue(oe){return!!(oe&&oe.length>0&&oe.charCodeAt(0)===65279)}e.$nf=ue;function le(oe){return ue(oe)?oe.substr(1):oe}e.$of=le;function $e(oe,de){if(!oe||!de||oe.length<de.length)return!1;const me=de.length,ye=oe.toLowerCase();let ke=0,Re=-1;for(;ke<me;){const Pe=ye.indexOf(de[ke],Re+1);if(Pe<0)return!1;Re=Pe,ke++}return!0}e.$pf=$e;function fe(oe,de=!1){return oe?(de&&(oe=oe.replace(/\\./g,"")),oe.toLowerCase()!==oe):!1}e.$qf=fe;function we(oe){return oe.charAt(0).toUpperCase()+oe.slice(1)}e.$rf=we;function ve(oe,de=1){if(de===0)return"";let me=-1;do me=oe.indexOf(`
`,me+1),de--;while(de>0&&me>=0);return me===-1?oe:(oe[me-1]==="\r"&&me--,oe.substr(0,me))}e.$sf=ve;function Oe(oe){return oe=oe%(2*26),oe<26?String.fromCharCode(97+oe):String.fromCharCode(65+oe-26)}e.$tf=Oe;function Ne(oe){return ge.getInstance().getGraphemeBreakType(oe)}e.$uf=Ne;function Me(oe,de){return oe===0?de!==5&&de!==7:oe===2&&de===3?!1:oe===4||oe===2||oe===3||de===4||de===2||de===3?!0:!(oe===8&&(de===8||de===9||de===11||de===12)||(oe===11||oe===9)&&(de===9||de===10)||(oe===12||oe===10)&&de===10||de===5||de===13||de===7||oe===1||oe===13&&de===14||oe===6&&de===6)}var he;(function(oe){oe[oe.Other=0]="Other",oe[oe.Prepend=1]="Prepend",oe[oe.CR=2]="CR",oe[oe.LF=3]="LF",oe[oe.Control=4]="Control",oe[oe.Extend=5]="Extend",oe[oe.Regional_Indicator=6]="Regional_Indicator",oe[oe.SpacingMark=7]="SpacingMark",oe[oe.L=8]="L",oe[oe.V=9]="V",oe[oe.T=10]="T",oe[oe.LV=11]="LV",oe[oe.LVT=12]="LVT",oe[oe.ZWJ=13]="ZWJ",oe[oe.Extended_Pictographic=14]="Extended_Pictographic"})(he||(e.GraphemeBreakType=he={}));class ge{static{this.c=null}static getInstance(){return ge.c||(ge.c=new ge),ge.c}constructor(){this.d=be()}getGraphemeBreakType(de){if(de<32)return de===10?3:de===13?2:4;if(de<127)return 0;const me=this.d,ye=me.length/3;let ke=1;for(;ke<=ye;)if(de<me[3*ke])ke=2*ke;else if(de>me[3*ke+1])ke=2*ke+1;else return me[3*ke+2];return 0}}function be(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Se(oe,de){if(oe===0)return 0;const me=Ce(oe,de);if(me!==void 0)return me;const ye=new H(de,oe);return ye.prevCodePoint(),ye.offset}e.$vf=Se;function Ce(oe,de){const me=new H(de,oe);let ye=me.prevCodePoint();for(;ze(ye)||ye===65039||ye===8419;){if(me.offset===0)return;ye=me.prevCodePoint()}if(!F(ye))return;let ke=me.offset;return ke>0&&me.prevCodePoint()===8205&&(ke=me.offset),ke}function ze(oe){return 127995<=oe&&oe<=127999}var je;(function(oe){oe[oe.zwj=8205]="zwj",oe[oe.emojiVariantSelector=65039]="emojiVariantSelector",oe[oe.enclosingKeyCap=8419]="enclosingKeyCap"})(je||(je={})),e.$wf="\xA0";class Ue{static{this.c=new N.$U(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new I.$ye(de=>{function me(Te){const Be=new Map;for(let qe=0;qe<Te.length;qe+=2)Be.set(Te[qe],Te[qe+1]);return Be}function ye(Te,Be){const qe=new Map(Te);for(const[Ve,_e]of Be)qe.set(Ve,_e);return qe}function ke(Te,Be){if(!Te)return Be;const qe=new Map;for(const[Ve,_e]of Te)Be.has(Ve)&&qe.set(Ve,_e);return qe}const Re=this.c.value;let Pe=de.filter(Te=>!Te.startsWith("_")&&Te in Re);Pe.length===0&&(Pe=["_default"]);let Ie;for(const Te of Pe){const Be=me(Re[Te]);Ie=ke(Ie,Be)}const De=me(Re._common),Ae=ye(De,Ie);return new Ue(Ae)})}static getInstance(de){return Ue.d.get(Array.from(de))}static{this.e=new N.$U(()=>Object.keys(Ue.c.value).filter(de=>!de.startsWith("_")))}static getLocales(){return Ue.e.value}constructor(de){this.f=de}isAmbiguous(de){return this.f.has(de)}getPrimaryConfusable(de){return this.f.get(de)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$xf=Ue;class Fe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Fe.c())),this.d}static isInvisibleCharacter(de){return Fe.e().has(de)}static get codePoints(){return Fe.e()}}e.$yf=Fe}),define(ae[52],ce([0,1,27]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=void 0;function N(c){return j(c,0)}e.$Hi=N;function j(c,u){switch(typeof c){case"object":return c===null?L(349,u):Array.isArray(c)?S(c,u):d(c,u);case"string":return R(c,u);case"boolean":return O(c,u);case"number":return L(c,u);case"undefined":return L(937,u);default:return L(617,u)}}e.$Ii=j;function L(c,u){return(u<<5)-u+c|0}e.$Ji=L;function O(c,u){return L(c?433:863,u)}function R(c,u){u=L(149417,u);for(let f=0,m=c.length;f<m;f++)u=L(c.charCodeAt(f),u);return u}e.$Ki=R;function S(c,u){return u=L(104579,u),c.reduce((f,m)=>j(m,f),u)}function d(c,u){return u=L(181387,u),Object.keys(c).sort().reduce((f,m)=>(f=R(m,f),j(c[m],f)),u)}class P{constructor(){this.g=0}get value(){return this.g}hash(u){return this.g=j(u,this.g),this.g}}e.$Li=P;var E;(function(c){c[c.BLOCK_SIZE=64]="BLOCK_SIZE",c[c.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function b(c,u,f=32){const m=f-u,k=~((1<<m)-1);return(c<<u|(k&c)>>>m)>>>0}function l(c,u=0,f=c.byteLength,m=0){for(let k=0;k<f;k++)c[u+k]=m}function $(c,u,f="0"){for(;c.length<u;)c=f+c;return c}function y(c,u=32){return c instanceof ArrayBuffer?Array.from(new Uint8Array(c)).map(f=>f.toString(16).padStart(2,"0")).join(""):$((c>>>0).toString(16),u/4)}e.$Mi=y;class w{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(u){const f=u.length;if(f===0)return;const m=this.p;let k=this.r,s=this.u,a,n;for(s!==0?(a=s,n=-1,s=0):(a=u.charCodeAt(0),n=0);;){let i=a;if(I.$7e(a))if(n+1<f){const t=u.charCodeAt(n+1);I.$8e(t)?(n++,i=I.$9e(a,t)):i=65533}else{s=a;break}else I.$8e(a)&&(i=65533);if(k=this.w(m,k,i),n++,n<f)a=u.charCodeAt(n);else break}this.r=k,this.u=s}w(u,f,m){return m<128?u[f++]=m:m<2048?(u[f++]=192|(m&1984)>>>6,u[f++]=128|(m&63)>>>0):m<65536?(u[f++]=224|(m&61440)>>>12,u[f++]=128|(m&4032)>>>6,u[f++]=128|(m&63)>>>0):(u[f++]=240|(m&1835008)>>>18,u[f++]=128|(m&258048)>>>12,u[f++]=128|(m&4032)>>>6,u[f++]=128|(m&63)>>>0),f>=64&&(this.y(),f-=64,this.t+=64,u[0]=u[64+0],u[1]=u[64+1],u[2]=u[64+2]),f}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),y(this.h)+y(this.l)+y(this.m)+y(this.n)+y(this.o)}x(){this.p[this.r++]=128,l(this.p,this.r),this.r>56&&(this.y(),l(this.p));const u=8*this.t;this.q.setUint32(56,Math.floor(u/4294967296),!1),this.q.setUint32(60,u%4294967296,!1),this.y()}y(){const u=w.g,f=this.q;for(let o=0;o<64;o+=4)u.setUint32(o,f.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)u.setUint32(o,b(u.getUint32(o-12,!1)^u.getUint32(o-32,!1)^u.getUint32(o-56,!1)^u.getUint32(o-64,!1),1),!1);let m=this.h,k=this.l,s=this.m,a=this.n,n=this.o,i,t,r;for(let o=0;o<80;o++)o<20?(i=k&s|~k&a,t=1518500249):o<40?(i=k^s^a,t=1859775393):o<60?(i=k&s|k&a|s&a,t=2400959708):(i=k^s^a,t=3395469782),r=b(m,5)+i+n+t+u.getUint32(o*4,!1)&4294967295,n=a,a=s,s=b(k,30),k=m,m=r;this.h=this.h+m&4294967295,this.l=this.l+k&4294967295,this.m=this.m+s&4294967295,this.n=this.n+a&4294967295,this.o=this.o+n&4294967295}}e.$Ni=w}),define(ae[89],ce([0,1,27]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(j){j[j.Ignore=0]="Ignore",j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(N||(N={})),function(j){const L="error",O="warning",R="warn",S="info",d="ignore";function P(b){return b?I.$3e(L,b)?j.Error:I.$3e(O,b)||I.$3e(R,b)?j.Warning:I.$3e(S,b)?j.Info:j.Ignore:j.Ignore}j.fromValue=P;function E(b){switch(b){case j.Error:return L;case j.Warning:return O;case j.Info:return S;default:return d}}j.toString=E}(N||(N={})),e.default=N}),define(ae[129],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ld=void 0,e.$Ld=Symbol("MicrotaskDelay")}),define(ae[47],ce([0,1,18,27]),function(ie,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=void 0;class j{constructor(){this.b="",this.c=0}reset(l){return this.b=l,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(l){const $=l.charCodeAt(0),y=this.b.charCodeAt(this.c);return $-y}value(){return this.b[this.c]}}e.$Vh=j;class L{constructor(l=!0){this.e=l}reset(l){return this.b=l,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let l=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(l)this.c++;else break;else l=!1;return this}cmp(l){return this.e?(0,N.$We)(l,this.b,0,l.length,this.c,this.d):(0,N.$Ye)(l,this.b,0,l.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Wh=L;class O{constructor(l=!0,$=!0){this.f=l,this.g=$}reset(l){this.d=0,this.e=0,this.b=l,this.c=l.length;for(let $=l.length-1;$>=0;$--,this.c--){const y=this.b.charCodeAt($);if(!(y===47||this.f&&y===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let l=!0;for(;this.e<this.c;this.e++){const $=this.b.charCodeAt(this.e);if($===47||this.f&&$===92)if(l)this.d++;else break;else l=!1}return this}cmp(l){return this.g?(0,N.$We)(l,this.b,0,l.length,this.d,this.e):(0,N.$Ye)(l,this.b,0,l.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Xh=O;var R;(function(b){b[b.Scheme=1]="Scheme",b[b.Authority=2]="Authority",b[b.Path=3]="Path",b[b.Query=4]="Query",b[b.Fragment=5]="Fragment"})(R||(R={}));class S{constructor(l,$){this.f=l,this.g=$,this.d=[],this.e=0}reset(l){return this.c=l,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new O(!1,!this.f(l)),this.b.reset(l.path),this.b.value()&&this.d.push(3)),this.g(l)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(l){if(this.d[this.e]===1)return(0,N.$Xe)(l,this.c.scheme);if(this.d[this.e]===2)return(0,N.$Xe)(l,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(l);if(this.d[this.e]===4)return(0,N.$Ve)(l,this.c.query);if(this.d[this.e]===5)return(0,N.$Ve)(l,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Yh=S;class d{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const l=this.right;return this.right=l.left,l.left=this,this.updateHeight(),l.updateHeight(),l}rotateRight(){const l=this.left;return this.left=l.right,l.right=this,this.updateHeight(),l.updateHeight(),l}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var P;(function(b){b[b.Left=-1]="Left",b[b.Mid=0]="Mid",b[b.Right=1]="Right"})(P||(P={}));class E{static forUris(l=()=>!1,$=()=>!1){return new E(new S(l,$))}static forPaths(l=!1){return new E(new O(void 0,!l))}static forStrings(){return new E(new j)}static forConfigKeys(){return new E(new L)}constructor(l){this.b=l}clear(){this.c=void 0}fill(l,$){if($){const y=$.slice(0);(0,I.$Wb)(y);for(const w of y)this.set(w,l)}else{const y=l.slice(0);(0,I.$Wb)(y);for(const w of y)this.set(w[0],w[1])}}set(l,$){const y=this.b.reset(l);let w;this.c||(this.c=new d,this.c.segment=y.value());const c=[];for(w=this.c;;){const f=y.cmp(w.segment);if(f>0)w.left||(w.left=new d,w.left.segment=y.value()),c.push([-1,w]),w=w.left;else if(f<0)w.right||(w.right=new d,w.right.segment=y.value()),c.push([1,w]),w=w.right;else if(y.hasNext())y.next(),w.mid||(w.mid=new d,w.mid.segment=y.value()),c.push([0,w]),w=w.mid;else break}const u=w.value;w.value=$,w.key=l;for(let f=c.length-1;f>=0;f--){const m=c[f][1];m.updateHeight();const k=m.balanceFactor();if(k<-1||k>1){const s=c[f][0],a=c[f+1][0];if(s===1&&a===1)c[f][1]=m.rotateLeft();else if(s===-1&&a===-1)c[f][1]=m.rotateRight();else if(s===1&&a===-1)m.right=c[f+1][1]=c[f+1][1].rotateRight(),c[f][1]=m.rotateLeft();else if(s===-1&&a===1)m.left=c[f+1][1]=c[f+1][1].rotateLeft(),c[f][1]=m.rotateRight();else throw new Error;if(f>0)switch(c[f-1][0]){case-1:c[f-1][1].left=c[f][1];break;case 1:c[f-1][1].right=c[f][1];break;case 0:c[f-1][1].mid=c[f][1];break}else this.c=c[0][1]}}return u}get(l){return this.d(l)?.value}d(l){const $=this.b.reset(l);let y=this.c;for(;y;){const w=$.cmp(y.segment);if(w>0)y=y.left;else if(w<0)y=y.right;else if($.hasNext())$.next(),y=y.mid;else break}return y}has(l){const $=this.d(l);return!($?.value===void 0&&$?.mid===void 0)}delete(l){return this.e(l,!1)}deleteSuperstr(l){return this.e(l,!0)}e(l,$){const y=this.b.reset(l),w=[];let c=this.c;for(;c;){const u=y.cmp(c.segment);if(u>0)w.push([-1,c]),c=c.left;else if(u<0)w.push([1,c]),c=c.right;else if(y.hasNext())y.next(),w.push([0,c]),c=c.mid;else break}if(c){if($?(c.left=void 0,c.mid=void 0,c.right=void 0,c.height=1):(c.key=void 0,c.value=void 0),!c.mid&&!c.value)if(c.left&&c.right){const u=this.f(c.right);if(u.key){const{key:f,value:m,segment:k}=u;this.e(u.key,!1),c.key=f,c.value=m,c.segment=k}}else{const u=c.left??c.right;if(w.length>0){const[f,m]=w[w.length-1];switch(f){case-1:m.left=u;break;case 0:m.mid=u;break;case 1:m.right=u;break}}else this.c=u}for(let u=w.length-1;u>=0;u--){const f=w[u][1];f.updateHeight();const m=f.balanceFactor();if(m>1?(f.right.balanceFactor()>=0||(f.right=f.right.rotateRight()),w[u][1]=f.rotateLeft()):m<-1&&(f.left.balanceFactor()<=0||(f.left=f.left.rotateLeft()),w[u][1]=f.rotateRight()),u>0)switch(w[u-1][0]){case-1:w[u-1][1].left=w[u][1];break;case 1:w[u-1][1].right=w[u][1];break;case 0:w[u-1][1].mid=w[u][1];break}else this.c=w[0][1]}}}f(l){for(;l.left;)l=l.left;return l}findSubstr(l){const $=this.b.reset(l);let y=this.c,w;for(;y;){const c=$.cmp(y.segment);if(c>0)y=y.left;else if(c<0)y=y.right;else if($.hasNext())$.next(),w=y.value||w,y=y.mid;else break}return y&&y.value||w}findSuperstr(l){return this.g(l,!1)}g(l,$){const y=this.b.reset(l);let w=this.c;for(;w;){const c=y.cmp(w.segment);if(c>0)w=w.left;else if(c<0)w=w.right;else if(y.hasNext())y.next(),w=w.mid;else return w.mid?this.h(w.mid):$?w.value:void 0}}hasElementOrSubtree(l){return this.g(l,!0)!==void 0}forEach(l){for(const[$,y]of this)l(y,$)}*[Symbol.iterator](){yield*this.h(this.c)}h(l){const $=[];return this.j(l,$),$[Symbol.iterator]()}j(l,$){l&&(l.left&&this.j(l.left,$),l.value&&$.push([l.key,l.value]),l.mid&&this.j(l.mid,$),l.right&&this.j(l.right,$))}_isBalanced(){const l=$=>{if(!$)return!0;const y=$.balanceFactor();return y<-1||y>1?!1:l($.left)&&l($.right)};return l(this.c)}}e.$Zh=E}),define(ae[12],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=void 0;function I(k){return typeof k=="string"}e.$zf=I;function N(k){return Array.isArray(k)&&k.every(s=>I(s))}e.$Af=N;function j(k){return typeof k=="object"&&k!==null&&!Array.isArray(k)&&!(k instanceof RegExp)&&!(k instanceof Date)}e.$Bf=j;function L(k){const s=Object.getPrototypeOf(Uint8Array);return typeof k=="object"&&k instanceof s}e.$Cf=L;function O(k){return typeof k=="number"&&!isNaN(k)}e.$Df=O;function R(k){return!!k&&typeof k[Symbol.iterator]=="function"}e.$Ef=R;function S(k){return k===!0||k===!1}e.$Ff=S;function d(k){return typeof k>"u"}e.$Gf=d;function P(k){return!E(k)}e.$Hf=P;function E(k){return d(k)||k===null}e.$If=E;function b(k,s){if(!k)throw new Error(s?`Unexpected type, expected '${s}'`:"Unexpected type")}e.$Jf=b;function l(k){if(E(k))throw new Error("Assertion Failed: argument is undefined or null");return k}e.$Kf=l;function $(...k){const s=[];for(let a=0;a<k.length;a++){const n=k[a];if(E(n))throw new Error(`Assertion Failed: argument at index ${a} is undefined or null`);s.push(n)}return s}e.$Lf=$;const y=Object.prototype.hasOwnProperty;function w(k){if(!j(k))return!1;for(const s in k)if(y.call(k,s))return!1;return!0}e.$Mf=w;function c(k){return typeof k=="function"}e.$Nf=c;function u(...k){return k.length>0&&k.every(c)}e.$Of=u;function f(k,s){const a=Math.min(k.length,s.length);for(let n=0;n<a;n++)m(k[n],s[n])}e.$Pf=f;function m(k,s){if(I(s)){if(typeof k!==s)throw new Error(`argument does not match constraint: typeof ${s}`)}else if(c(s)){try{if(k instanceof s)return}catch{}if(!E(k)&&k.constructor===s||s.length===1&&s.call(void 0,k)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Qf=m}),define(ae[30],ce([0,1,12]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=void 0;function N(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const u=Array.isArray(c)?[]:{};return Object.entries(c).forEach(([f,m])=>{u[f]=m&&typeof m=="object"?N(m):m}),u}e.$$m=N;function j(c){if(!c||typeof c!="object")return c;const u=[c];for(;u.length>0;){const f=u.shift();Object.freeze(f);for(const m in f)if(L.call(f,m)){const k=f[m];typeof k=="object"&&!Object.isFrozen(k)&&!(0,I.$Cf)(k)&&u.push(k)}}return c}e.$_m=j;const L=Object.prototype.hasOwnProperty;function O(c,u){return R(c,u,new Set)}e.$an=O;function R(c,u,f){if((0,I.$If)(c))return c;const m=u(c);if(typeof m<"u")return m;if(Array.isArray(c)){const k=[];for(const s of c)k.push(R(s,u,f));return k}if((0,I.$Bf)(c)){if(f.has(c))throw new Error("Cannot clone recursive data-structure");f.add(c);const k={};for(const s in c)L.call(c,s)&&(k[s]=R(c[s],u,f));return f.delete(c),k}return c}function S(c,u,f=!0){return(0,I.$Bf)(c)?((0,I.$Bf)(u)&&Object.keys(u).forEach(m=>{m in c?f&&((0,I.$Bf)(c[m])&&(0,I.$Bf)(u[m])?S(c[m],u[m],f):c[m]=u[m]):c[m]=u[m]}),c):u}e.$bn=S;function d(c,u){if(c===u)return!0;if(c==null||u===null||u===void 0||typeof c!=typeof u||typeof c!="object"||Array.isArray(c)!==Array.isArray(u))return!1;let f,m;if(Array.isArray(c)){if(c.length!==u.length)return!1;for(f=0;f<c.length;f++)if(!d(c[f],u[f]))return!1}else{const k=[];for(m in c)k.push(m);k.sort();const s=[];for(m in u)s.push(m);if(s.sort(),!d(k,s))return!1;for(f=0;f<k.length;f++)if(!d(c[k[f]],u[k[f]]))return!1}return!0}e.$cn=d;function P(c){const u=new Set;return JSON.stringify(c,(f,m)=>{if((0,I.$Bf)(m)||Array.isArray(m)){if(u.has(m))return"[Circular]";u.add(m)}return m})}e.$dn=P;function E(c,u){const f=Object.create(null);return!c||!u||Object.keys(u).forEach(k=>{const s=c[k],a=u[k];d(s,a)||(f[k]=a)}),f}e.$en=E;function b(c,u){const f=u.toLowerCase(),m=Object.keys(c).find(k=>k.toLowerCase()===f);return m?c[m]:c[u]}e.$fn=b;function l(c,u){const f=Object.create(null);for(const[m,k]of Object.entries(c))u(m,k)&&(f[m]=k);return f}e.$gn=l;function $(c){let u=[];for(;Object.prototype!==c;)u=u.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return u}e.$hn=$;function y(c){const u=[];for(const f of $(c))typeof c[f]=="function"&&u.push(f);return u}e.$in=y;function w(c,u){const f=k=>function(){const s=Array.prototype.slice.call(arguments,0);return u(k,s)},m={};for(const k of c)m[k]=f(k);return m}e.$jn=w}),define(ae[32],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fg=e.$eg=void 0;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(j){return I.test(j)}e.$eg=N,e.$fg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let j;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?j=crypto.getRandomValues.bind(crypto):j=function(R){for(let S=0;S<R.length;S++)R[S]=Math.floor(Math.random()*256);return R};const L=new Uint8Array(16),O=[];for(let R=0;R<256;R++)O.push(R.toString(16).padStart(2,"0"));return function(){j(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let S=0,d="";return d+=O[L[S++]],d+=O[L[S++]],d+=O[L[S++]],d+=O[L[S++]],d+="-",d+=O[L[S++]],d+=O[L[S++]],d+="-",d+=O[L[S++]],d+=O[L[S++]],d+="-",d+=O[L[S++]],d+=O[L[S++]],d+="-",d+=O[L[S++]],d+=O[L[S++]],d+=O[L[S++]],d+=O[L[S++]],d+=O[L[S++]],d+=O[L[S++]],d}}()}),define(ae[130],ce([0,1,36]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=void 0;const N=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function j(O){const R=O.replace(/\-/g,":").toLowerCase();return!N.has(R)}function L(){const O=(0,I.networkInterfaces)();for(const R in O){const S=O[R];if(S){for(const{mac:d}of S)if(j(d))return d}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$Um=L}),define(ae[131],ce([0,1,267,15]),function(ie,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IT=void 0;class j extends I.Transform{constructor(O){if(super(),typeof O=="number")this.b=O,this.c=1;else{const R=Buffer.isBuffer(O)?O:Buffer.from(O);this.b=R.length===1?R[0]:R,this.c=R.length}}_transform(O,R,S){this.a?this.a=Buffer.concat([this.a,O]):this.a=O;let d=0;for(;d<this.a.length;){const P=typeof this.b=="number"?this.a.indexOf(this.b,d):(0,N.$de)(this.a,this.b,d);if(P===-1)break;this.push(this.a.slice(d,P+this.c)),d=P+this.c}this.a=d===this.a.length?void 0:this.a.slice(d),S()}_flush(O){this.a&&this.push(this.a),O()}}e.$IT=j}),define(ae[132],ce([0,1,63]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jg=e.$ig=e.$hg=void 0;function N(R,S,d,P=1){let E=!1;return new Promise(b=>{const l=setTimeout(()=>{if(!E)return E=!0,b(0)},d);j(R,S,P,$=>{if(!E)return E=!0,clearTimeout(l),b($)})})}e.$hg=N;function j(R,S,d,P){if(S===0)return P(0);const E=new I.Socket;E.once("connect",()=>(O(E),j(R+d,S-1,d,P))),E.once("data",()=>{}),E.once("error",b=>(O(E),b.code!=="ECONNREFUSED"?j(R+d,S-1,d,P):P(R))),E.connect(R,"127.0.0.1")}e.$ig={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function L(R,S,d,P="127.0.0.1"){let E=!1,b,l=1;const $=I.createServer({pauseOnConnect:!0});function y(w,c){E||(E=!0,$.removeAllListeners(),$.close(),b&&clearTimeout(b),c(w))}return new Promise(w=>{b=setTimeout(()=>{y(0,w)},d),$.on("listening",()=>{y(R,w)}),$.on("error",c=>{c&&(c.code==="EADDRINUSE"||c.code==="EACCES")&&l<S?(R++,l++,$.listen(R,P)):y(0,w)}),$.on("close",()=>{y(0,w)}),$.listen(R,P)})}e.$jg=L;function O(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(S){console.error(S)}}}),define(ae[133],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YT=void 0;function I(N){return!!N.parentPort}e.$YT=I}),define(ae[134],ce([13,9]),function(ie,e){return ie.create("vs/base/common/date",e)}),define(ae[64],ce([0,1,134]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$im=e.$hm=void 0;const N=60,j=N*60,L=j*24,O=L*7,R=L*30,S=L*365;function d(E,b,l,$){typeof E!="number"&&(E=E.getTime());const y=Math.round((new Date().getTime()-E)/1e3);if(y<-30)return(0,I.localize)(0,null,d(new Date().getTime()+y*1e3,!1));if(!$&&y<30)return(0,I.localize)(1,null);let w;return y<N?(w=y,b?w===1?l?(0,I.localize)(2,null,w):(0,I.localize)(3,null,w):l?(0,I.localize)(4,null,w):(0,I.localize)(5,null,w):w===1?l?(0,I.localize)(6,null,w):(0,I.localize)(7,null,w):l?(0,I.localize)(8,null,w):(0,I.localize)(9,null,w)):y<j?(w=Math.floor(y/N),b?w===1?l?(0,I.localize)(10,null,w):(0,I.localize)(11,null,w):l?(0,I.localize)(12,null,w):(0,I.localize)(13,null,w):w===1?l?(0,I.localize)(14,null,w):(0,I.localize)(15,null,w):l?(0,I.localize)(16,null,w):(0,I.localize)(17,null,w)):y<L?(w=Math.floor(y/j),b?w===1?l?(0,I.localize)(18,null,w):(0,I.localize)(19,null,w):l?(0,I.localize)(20,null,w):(0,I.localize)(21,null,w):w===1?l?(0,I.localize)(22,null,w):(0,I.localize)(23,null,w):l?(0,I.localize)(24,null,w):(0,I.localize)(25,null,w)):y<O?(w=Math.floor(y/L),b?w===1?(0,I.localize)(26,null,w):(0,I.localize)(27,null,w):w===1?(0,I.localize)(28,null,w):(0,I.localize)(29,null,w)):y<R?(w=Math.floor(y/O),b?w===1?l?(0,I.localize)(30,null,w):(0,I.localize)(31,null,w):l?(0,I.localize)(32,null,w):(0,I.localize)(33,null,w):w===1?l?(0,I.localize)(34,null,w):(0,I.localize)(35,null,w):l?(0,I.localize)(36,null,w):(0,I.localize)(37,null,w)):y<S?(w=Math.floor(y/R),b?w===1?l?(0,I.localize)(38,null,w):(0,I.localize)(39,null,w):l?(0,I.localize)(40,null,w):(0,I.localize)(41,null,w):w===1?l?(0,I.localize)(42,null,w):(0,I.localize)(43,null,w):l?(0,I.localize)(44,null,w):(0,I.localize)(45,null,w)):(w=Math.floor(y/S),b?w===1?l?(0,I.localize)(46,null,w):(0,I.localize)(47,null,w):l?(0,I.localize)(48,null,w):(0,I.localize)(49,null,w):w===1?l?(0,I.localize)(50,null,w):(0,I.localize)(51,null,w):l?(0,I.localize)(52,null,w):(0,I.localize)(53,null,w))}e.$hm=d;function P(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$im=P}),define(ae[135],ce([13,9]),function(ie,e){return ie.create("vs/base/common/errorMessage",e)}),define(ae[38],ce([0,1,18,12,135]),function(ie,e,I,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gi=e.$Fi=e.$Ei=void 0;function L(E,b){return b&&(E.stack||E.stacktrace)?j.localize(0,null,R(E),O(E.stack)||O(E.stacktrace)):R(E)}function O(E){return Array.isArray(E)?E.join(`
`):E}function R(E){return E.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${E.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?j.localize(1,null,E.message):E.message||j.localize(2,null)}function S(E=null,b=!1){if(!E)return j.localize(3,null);if(Array.isArray(E)){const l=I.$Gb(E),$=S(l[0],b);return l.length>1?j.localize(4,null,$,l.length):$}if(N.$zf(E))return E;if(E.detail){const l=E.detail;if(l.error)return L(l.error,b);if(l.exception)return L(l.exception,b)}return E.stack?L(E,b):E.message?E.message:j.localize(5,null)}e.$Ei=S;function d(E){const b=E;return b instanceof Error&&Array.isArray(b.actions)}e.$Fi=d;function P(E,b){let l;return typeof E=="string"?l=new Error(E):l=E,l.actions=b,l}e.$Gi=P}),define(ae[136],ce([13,9]),function(ie,e){return ie.create("vs/base/common/jsonErrorMessages",e)}),define(ae[137],ce([0,1,136]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=void 0;function N(j){switch(j){case 1:return(0,I.localize)(0,null);case 2:return(0,I.localize)(1,null);case 3:return(0,I.localize)(2,null);case 4:return(0,I.localize)(3,null);case 5:return(0,I.localize)(4,null);case 6:return(0,I.localize)(5,null);case 7:return(0,I.localize)(6,null);case 8:return(0,I.localize)(7,null);case 9:return(0,I.localize)(8,null);default:return""}}e.$Ap=N}),define(ae[138],ce([13,9]),function(ie,e){return ie.create("vs/base/common/platform",e)}),define(ae[5],ce([0,1,138]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$h=e.$g=void 0,e.$g="en";let N=!1,j=!1,L=!1,O=!1,R=!1,S=!1,d=!1,P=!1,E=!1,b=!1,l,$=e.$g,y=e.$g,w,c;e.$h=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.$h.vscode<"u"&&typeof e.$h.vscode.process<"u"?u=e.$h.vscode.process:typeof process<"u"&&(u=process);const f=typeof u?.versions?.electron=="string",m=f&&u?.type==="renderer";if(typeof navigator=="object"&&!m)c=navigator.userAgent,N=c.indexOf("Windows")>=0,j=c.indexOf("Macintosh")>=0,P=(c.indexOf("Macintosh")>=0||c.indexOf("iPad")>=0||c.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=c.indexOf("Linux")>=0,b=c?.indexOf("Mobi")>=0,S=!0,l=I.getConfiguredDefaultLocale(I.localize(0,null))||e.$g,$=l,y=navigator.language;else if(typeof u=="object"){N=u.platform==="win32",j=u.platform==="darwin",L=u.platform==="linux",O=L&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,d=f,E=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,l=e.$g,$=e.$g;const v=u.env.VSCODE_NLS_CONFIG;if(v)try{const p=JSON.parse(v),h=p.availableLanguages["*"];l=p.locale,y=p.osLocale,$=h||e.$g,w=p._translationsConfigFile}catch{}R=!0}else console.error("Unable to resolve platform.");var k;(function(v){v[v.Web=0]="Web",v[v.Mac=1]="Mac",v[v.Linux=2]="Linux",v[v.Windows=3]="Windows"})(k||(e.Platform=k={}));function s(v){switch(v){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$i=s;let a=0;j?a=1:N?a=3:L&&(a=2),e.$j=N,e.$k=j,e.$l=L,e.$m=O,e.$n=R,e.$o=d,e.$p=S,e.$q=S&&typeof e.$h.importScripts=="function",e.$r=P,e.$s=b,e.$t=E,e.$u=a,e.$v=c,e.$w=$;var n;(function(v){function p(){return e.$w}v.value=p;function h(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}v.isDefaultVariant=h;function g(){return e.$w==="en"}v.isDefault=g})(n||(e.Language=n={})),e.$x=l,e.$y=y,e.$z=w,e.$A=typeof e.$h.postMessage=="function"&&!e.$h.importScripts,e.$B=(()=>{if(e.$A){const v=[];e.$h.addEventListener("message",h=>{if(h.data&&h.data.vscodeScheduleAsyncWork)for(let g=0,D=v.length;g<D;g++){const T=v[g];if(T.id===h.data.vscodeScheduleAsyncWork){v.splice(g,1),T.callback();return}}});let p=0;return h=>{const g=++p;v.push({id:g,callback:h}),e.$h.postMessage({vscodeScheduleAsyncWork:g},"*")}}return v=>setTimeout(v)})();var i;(function(v){v[v.Windows=1]="Windows",v[v.Macintosh=2]="Macintosh",v[v.Linux=3]="Linux"})(i||(e.OperatingSystem=i={})),e.OS=j||P?2:N?1:3;let t=!0,r=!1;function o(){if(!r){r=!0;const v=new Uint8Array(2);v[0]=1,v[1]=2,t=new Uint16Array(v.buffer)[0]===(2<<8)+1}return t}e.$D=o,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0)}),define(ae[37],ce([0,1,5]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dc=e.$cc=e.env=e.cwd=void 0;let N;if(typeof I.$h.vscode<"u"&&typeof I.$h.vscode.process<"u"){const j=I.$h.vscode.process;N={get platform(){return j.platform},get arch(){return j.arch},get env(){return j.env},cwd(){return j.cwd()}}}else typeof process<"u"?N={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:N={get platform(){return I.$j?"win32":I.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=N.cwd,e.env=N.env,e.$cc=N.platform,e.$dc=N.arch}),define(ae[16],ce([0,1,37]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sc=e.sep=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=void 0;const N=65,j=97,L=90,O=122,R=46,S=47,d=92,P=58,E=63;class b extends Error{constructor(a,n,i){let t;typeof n=="string"&&n.indexOf("not ")===0?(t="must not be",n=n.replace(/^not /,"")):t="must be";const r=a.indexOf(".")!==-1?"property":"argument";let o=`The "${a}" ${r} ${t} of type ${n}`;o+=`. Received type ${typeof i}`,super(o),this.code="ERR_INVALID_ARG_TYPE"}}function l(s,a){if(s===null||typeof s!="object")throw new b(a,"Object",s)}function $(s,a){if(typeof s!="string")throw new b(a,"string",s)}const y=I.$cc==="win32";function w(s){return s===S||s===d}function c(s){return s===S}function u(s){return s>=N&&s<=L||s>=j&&s<=O}function f(s,a,n,i){let t="",r=0,o=-1,v=0,p=0;for(let h=0;h<=s.length;++h){if(h<s.length)p=s.charCodeAt(h);else{if(i(p))break;p=S}if(i(p)){if(!(o===h-1||v===1))if(v===2){if(t.length<2||r!==2||t.charCodeAt(t.length-1)!==R||t.charCodeAt(t.length-2)!==R){if(t.length>2){const g=t.lastIndexOf(n);g===-1?(t="",r=0):(t=t.slice(0,g),r=t.length-1-t.lastIndexOf(n)),o=h,v=0;continue}else if(t.length!==0){t="",r=0,o=h,v=0;continue}}a&&(t+=t.length>0?`${n}..`:"..",r=2)}else t.length>0?t+=`${n}${s.slice(o+1,h)}`:t=s.slice(o+1,h),r=h-o-1;o=h,v=0}else p===R&&v!==-1?++v:v=-1}return t}function m(s,a){l(a,"pathObject");const n=a.dir||a.root,i=a.base||`${a.name||""}${a.ext||""}`;return n?n===a.root?`${n}${i}`:`${n}${s}${i}`:i}e.$ec={resolve(...s){let a="",n="",i=!1;for(let t=s.length-1;t>=-1;t--){let r;if(t>=0){if(r=s[t],$(r,"path"),r.length===0)continue}else a.length===0?r=I.cwd():(r=I.env[`=${a}`]||I.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==a.toLowerCase()&&r.charCodeAt(2)===d)&&(r=`${a}\\`));const o=r.length;let v=0,p="",h=!1;const g=r.charCodeAt(0);if(o===1)w(g)&&(v=1,h=!0);else if(w(g))if(h=!0,w(r.charCodeAt(1))){let D=2,T=D;for(;D<o&&!w(r.charCodeAt(D));)D++;if(D<o&&D!==T){const M=r.slice(T,D);for(T=D;D<o&&w(r.charCodeAt(D));)D++;if(D<o&&D!==T){for(T=D;D<o&&!w(r.charCodeAt(D));)D++;(D===o||D!==T)&&(p=`\\\\${M}\\${r.slice(T,D)}`,v=D)}}}else v=1;else u(g)&&r.charCodeAt(1)===P&&(p=r.slice(0,2),v=2,o>2&&w(r.charCodeAt(2))&&(h=!0,v=3));if(p.length>0)if(a.length>0){if(p.toLowerCase()!==a.toLowerCase())continue}else a=p;if(i){if(a.length>0)break}else if(n=`${r.slice(v)}\\${n}`,i=h,h&&a.length>0)break}return n=f(n,!i,"\\",w),i?`${a}\\${n}`:`${a}${n}`||"."},normalize(s){$(s,"path");const a=s.length;if(a===0)return".";let n=0,i,t=!1;const r=s.charCodeAt(0);if(a===1)return c(r)?"\\":s;if(w(r))if(t=!0,w(s.charCodeAt(1))){let v=2,p=v;for(;v<a&&!w(s.charCodeAt(v));)v++;if(v<a&&v!==p){const h=s.slice(p,v);for(p=v;v<a&&w(s.charCodeAt(v));)v++;if(v<a&&v!==p){for(p=v;v<a&&!w(s.charCodeAt(v));)v++;if(v===a)return`\\\\${h}\\${s.slice(p)}\\`;v!==p&&(i=`\\\\${h}\\${s.slice(p,v)}`,n=v)}}}else n=1;else u(r)&&s.charCodeAt(1)===P&&(i=s.slice(0,2),n=2,a>2&&w(s.charCodeAt(2))&&(t=!0,n=3));let o=n<a?f(s.slice(n),!t,"\\",w):"";return o.length===0&&!t&&(o="."),o.length>0&&w(s.charCodeAt(a-1))&&(o+="\\"),i===void 0?t?`\\${o}`:o:t?`${i}\\${o}`:`${i}${o}`},isAbsolute(s){$(s,"path");const a=s.length;if(a===0)return!1;const n=s.charCodeAt(0);return w(n)||a>2&&u(n)&&s.charCodeAt(1)===P&&w(s.charCodeAt(2))},join(...s){if(s.length===0)return".";let a,n;for(let r=0;r<s.length;++r){const o=s[r];$(o,"path"),o.length>0&&(a===void 0?a=n=o:a+=`\\${o}`)}if(a===void 0)return".";let i=!0,t=0;if(typeof n=="string"&&w(n.charCodeAt(0))){++t;const r=n.length;r>1&&w(n.charCodeAt(1))&&(++t,r>2&&(w(n.charCodeAt(2))?++t:i=!1))}if(i){for(;t<a.length&&w(a.charCodeAt(t));)t++;t>=2&&(a=`\\${a.slice(t)}`)}return e.$ec.normalize(a)},relative(s,a){if($(s,"from"),$(a,"to"),s===a)return"";const n=e.$ec.resolve(s),i=e.$ec.resolve(a);if(n===i||(s=n.toLowerCase(),a=i.toLowerCase(),s===a))return"";let t=0;for(;t<s.length&&s.charCodeAt(t)===d;)t++;let r=s.length;for(;r-1>t&&s.charCodeAt(r-1)===d;)r--;const o=r-t;let v=0;for(;v<a.length&&a.charCodeAt(v)===d;)v++;let p=a.length;for(;p-1>v&&a.charCodeAt(p-1)===d;)p--;const h=p-v,g=o<h?o:h;let D=-1,T=0;for(;T<g;T++){const z=s.charCodeAt(t+T);if(z!==a.charCodeAt(v+T))break;z===d&&(D=T)}if(T!==g){if(D===-1)return i}else{if(h>g){if(a.charCodeAt(v+T)===d)return i.slice(v+T+1);if(T===2)return i.slice(v+T)}o>g&&(s.charCodeAt(t+T)===d?D=T:T===2&&(D=3)),D===-1&&(D=0)}let M="";for(T=t+D+1;T<=r;++T)(T===r||s.charCodeAt(T)===d)&&(M+=M.length===0?"..":"\\..");return v+=D,M.length>0?`${M}${i.slice(v,p)}`:(i.charCodeAt(v)===d&&++v,i.slice(v,p))},toNamespacedPath(s){if(typeof s!="string"||s.length===0)return s;const a=e.$ec.resolve(s);if(a.length<=2)return s;if(a.charCodeAt(0)===d){if(a.charCodeAt(1)===d){const n=a.charCodeAt(2);if(n!==E&&n!==R)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(u(a.charCodeAt(0))&&a.charCodeAt(1)===P&&a.charCodeAt(2)===d)return`\\\\?\\${a}`;return s},dirname(s){$(s,"path");const a=s.length;if(a===0)return".";let n=-1,i=0;const t=s.charCodeAt(0);if(a===1)return w(t)?s:".";if(w(t)){if(n=i=1,w(s.charCodeAt(1))){let v=2,p=v;for(;v<a&&!w(s.charCodeAt(v));)v++;if(v<a&&v!==p){for(p=v;v<a&&w(s.charCodeAt(v));)v++;if(v<a&&v!==p){for(p=v;v<a&&!w(s.charCodeAt(v));)v++;if(v===a)return s;v!==p&&(n=i=v+1)}}}}else u(t)&&s.charCodeAt(1)===P&&(n=a>2&&w(s.charCodeAt(2))?3:2,i=n);let r=-1,o=!0;for(let v=a-1;v>=i;--v)if(w(s.charCodeAt(v))){if(!o){r=v;break}}else o=!1;if(r===-1){if(n===-1)return".";r=n}return s.slice(0,r)},basename(s,a){a!==void 0&&$(a,"ext"),$(s,"path");let n=0,i=-1,t=!0,r;if(s.length>=2&&u(s.charCodeAt(0))&&s.charCodeAt(1)===P&&(n=2),a!==void 0&&a.length>0&&a.length<=s.length){if(a===s)return"";let o=a.length-1,v=-1;for(r=s.length-1;r>=n;--r){const p=s.charCodeAt(r);if(w(p)){if(!t){n=r+1;break}}else v===-1&&(t=!1,v=r+1),o>=0&&(p===a.charCodeAt(o)?--o===-1&&(i=r):(o=-1,i=v))}return n===i?i=v:i===-1&&(i=s.length),s.slice(n,i)}for(r=s.length-1;r>=n;--r)if(w(s.charCodeAt(r))){if(!t){n=r+1;break}}else i===-1&&(t=!1,i=r+1);return i===-1?"":s.slice(n,i)},extname(s){$(s,"path");let a=0,n=-1,i=0,t=-1,r=!0,o=0;s.length>=2&&s.charCodeAt(1)===P&&u(s.charCodeAt(0))&&(a=i=2);for(let v=s.length-1;v>=a;--v){const p=s.charCodeAt(v);if(w(p)){if(!r){i=v+1;break}continue}t===-1&&(r=!1,t=v+1),p===R?n===-1?n=v:o!==1&&(o=1):n!==-1&&(o=-1)}return n===-1||t===-1||o===0||o===1&&n===t-1&&n===i+1?"":s.slice(n,t)},format:m.bind(null,"\\"),parse(s){$(s,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return a;const n=s.length;let i=0,t=s.charCodeAt(0);if(n===1)return w(t)?(a.root=a.dir=s,a):(a.base=a.name=s,a);if(w(t)){if(i=1,w(s.charCodeAt(1))){let D=2,T=D;for(;D<n&&!w(s.charCodeAt(D));)D++;if(D<n&&D!==T){for(T=D;D<n&&w(s.charCodeAt(D));)D++;if(D<n&&D!==T){for(T=D;D<n&&!w(s.charCodeAt(D));)D++;D===n?i=D:D!==T&&(i=D+1)}}}}else if(u(t)&&s.charCodeAt(1)===P){if(n<=2)return a.root=a.dir=s,a;if(i=2,w(s.charCodeAt(2))){if(n===3)return a.root=a.dir=s,a;i=3}}i>0&&(a.root=s.slice(0,i));let r=-1,o=i,v=-1,p=!0,h=s.length-1,g=0;for(;h>=i;--h){if(t=s.charCodeAt(h),w(t)){if(!p){o=h+1;break}continue}v===-1&&(p=!1,v=h+1),t===R?r===-1?r=h:g!==1&&(g=1):r!==-1&&(g=-1)}return v!==-1&&(r===-1||g===0||g===1&&r===v-1&&r===o+1?a.base=a.name=s.slice(o,v):(a.name=s.slice(o,r),a.base=s.slice(o,v),a.ext=s.slice(r,v))),o>0&&o!==i?a.dir=s.slice(0,o-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null};const k=(()=>{if(y){const s=/\\/g;return()=>{const a=I.cwd().replace(s,"/");return a.slice(a.indexOf("/"))}}return()=>I.cwd()})();e.$fc={resolve(...s){let a="",n=!1;for(let i=s.length-1;i>=-1&&!n;i--){const t=i>=0?s[i]:k();$(t,"path"),t.length!==0&&(a=`${t}/${a}`,n=t.charCodeAt(0)===S)}return a=f(a,!n,"/",c),n?`/${a}`:a.length>0?a:"."},normalize(s){if($(s,"path"),s.length===0)return".";const a=s.charCodeAt(0)===S,n=s.charCodeAt(s.length-1)===S;return s=f(s,!a,"/",c),s.length===0?a?"/":n?"./":".":(n&&(s+="/"),a?`/${s}`:s)},isAbsolute(s){return $(s,"path"),s.length>0&&s.charCodeAt(0)===S},join(...s){if(s.length===0)return".";let a;for(let n=0;n<s.length;++n){const i=s[n];$(i,"path"),i.length>0&&(a===void 0?a=i:a+=`/${i}`)}return a===void 0?".":e.$fc.normalize(a)},relative(s,a){if($(s,"from"),$(a,"to"),s===a||(s=e.$fc.resolve(s),a=e.$fc.resolve(a),s===a))return"";const n=1,i=s.length,t=i-n,r=1,o=a.length-r,v=t<o?t:o;let p=-1,h=0;for(;h<v;h++){const D=s.charCodeAt(n+h);if(D!==a.charCodeAt(r+h))break;D===S&&(p=h)}if(h===v)if(o>v){if(a.charCodeAt(r+h)===S)return a.slice(r+h+1);if(h===0)return a.slice(r+h)}else t>v&&(s.charCodeAt(n+h)===S?p=h:h===0&&(p=0));let g="";for(h=n+p+1;h<=i;++h)(h===i||s.charCodeAt(h)===S)&&(g+=g.length===0?"..":"/..");return`${g}${a.slice(r+p)}`},toNamespacedPath(s){return s},dirname(s){if($(s,"path"),s.length===0)return".";const a=s.charCodeAt(0)===S;let n=-1,i=!0;for(let t=s.length-1;t>=1;--t)if(s.charCodeAt(t)===S){if(!i){n=t;break}}else i=!1;return n===-1?a?"/":".":a&&n===1?"//":s.slice(0,n)},basename(s,a){a!==void 0&&$(a,"ext"),$(s,"path");let n=0,i=-1,t=!0,r;if(a!==void 0&&a.length>0&&a.length<=s.length){if(a===s)return"";let o=a.length-1,v=-1;for(r=s.length-1;r>=0;--r){const p=s.charCodeAt(r);if(p===S){if(!t){n=r+1;break}}else v===-1&&(t=!1,v=r+1),o>=0&&(p===a.charCodeAt(o)?--o===-1&&(i=r):(o=-1,i=v))}return n===i?i=v:i===-1&&(i=s.length),s.slice(n,i)}for(r=s.length-1;r>=0;--r)if(s.charCodeAt(r)===S){if(!t){n=r+1;break}}else i===-1&&(t=!1,i=r+1);return i===-1?"":s.slice(n,i)},extname(s){$(s,"path");let a=-1,n=0,i=-1,t=!0,r=0;for(let o=s.length-1;o>=0;--o){const v=s.charCodeAt(o);if(v===S){if(!t){n=o+1;break}continue}i===-1&&(t=!1,i=o+1),v===R?a===-1?a=o:r!==1&&(r=1):a!==-1&&(r=-1)}return a===-1||i===-1||r===0||r===1&&a===i-1&&a===n+1?"":s.slice(a,i)},format:m.bind(null,"/"),parse(s){$(s,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return a;const n=s.charCodeAt(0)===S;let i;n?(a.root="/",i=1):i=0;let t=-1,r=0,o=-1,v=!0,p=s.length-1,h=0;for(;p>=i;--p){const g=s.charCodeAt(p);if(g===S){if(!v){r=p+1;break}continue}o===-1&&(v=!1,o=p+1),g===R?t===-1?t=p:h!==1&&(h=1):t!==-1&&(h=-1)}if(o!==-1){const g=r===0&&n?1:r;t===-1||h===0||h===1&&t===o-1&&t===r+1?a.base=a.name=s.slice(g,o):(a.name=s.slice(g,t),a.base=s.slice(g,o),a.ext=s.slice(t,o))}return r>0?a.dir=s.slice(0,r-1):n&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.$fc.win32=e.$ec.win32=e.$ec,e.$fc.posix=e.$ec.posix=e.$fc,e.$gc=y?e.$ec.normalize:e.$fc.normalize,e.$hc=y?e.$ec.isAbsolute:e.$fc.isAbsolute,e.$ic=y?e.$ec.join:e.$fc.join,e.$jc=y?e.$ec.resolve:e.$fc.resolve,e.$kc=y?e.$ec.relative:e.$fc.relative,e.$lc=y?e.$ec.dirname:e.$fc.dirname,e.$mc=y?e.$ec.basename:e.$fc.basename,e.$nc=y?e.$ec.extname:e.$fc.extname,e.$oc=y?e.$ec.format:e.$fc.format,e.$pc=y?e.$ec.parse:e.$fc.parse,e.$qc=y?e.$ec.toNamespacedPath:e.$fc.toNamespacedPath,e.sep=y?e.$ec.sep:e.$fc.sep,e.$sc=y?e.$ec.delimiter:e.$fc.delimiter}),define(ae[48],ce([0,1,16,5,27,12]),function(ie,e,I,N,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=void 0;function O(r){return r===47||r===92}e.$Rf=O;function R(r){return r.replace(/[\\/]/g,I.$fc.sep)}e.$Sf=R;function S(r){return r.indexOf("/")===-1&&(r=R(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.$Tf=S;function d(r,o=I.$fc.sep){if(!r)return"";const v=r.length,p=r.charCodeAt(0);if(O(p)){if(O(r.charCodeAt(1))&&!O(r.charCodeAt(2))){let g=3;const D=g;for(;g<v&&!O(r.charCodeAt(g));g++);if(D!==g&&!O(r.charCodeAt(g+1))){for(g+=1;g<v;g++)if(O(r.charCodeAt(g)))return r.slice(0,g+1).replace(/[\\/]/g,o)}}return o}else if(c(p)&&r.charCodeAt(1)===58)return O(r.charCodeAt(2))?r.slice(0,2)+o:r.slice(0,2);let h=r.indexOf("://");if(h!==-1){for(h+=3;h<v;h++)if(O(r.charCodeAt(h)))return r.slice(0,h+1)}return""}e.$Uf=d;function P(r){if(!N.$j||!r||r.length<5)return!1;let o=r.charCodeAt(0);if(o!==92||(o=r.charCodeAt(1),o!==92))return!1;let v=2;const p=v;for(;v<r.length&&(o=r.charCodeAt(v),o!==92);v++);return!(p===v||(o=r.charCodeAt(v+1),isNaN(o)||o===92))}e.$Vf=P;const E=/[\\/:\*\?"<>\|]/g,b=/[\\/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function $(r,o=N.$j){const v=o?E:b;return!(!r||r.length===0||/^\s+$/.test(r)||(v.lastIndex=0,v.test(r))||o&&l.test(r)||r==="."||r===".."||o&&r[r.length-1]==="."||o&&r.length!==r.trim().length||r.length>255)}e.$Wf=$;function y(r,o,v){const p=r===o;return!v||p?p:!r||!o?!1:(0,j.$3e)(r,o)}e.$Xf=y;function w(r,o,v,p=I.sep){if(r===o)return!0;if(!r||!o||o.length>r.length)return!1;if(v){if(!(0,j.$4e)(r,o))return!1;if(o.length===r.length)return!0;let g=o.length;return o.charAt(o.length-1)===p&&g--,r.charAt(g)===p}return o.charAt(o.length-1)!==p&&(o+=p),r.indexOf(o)===0}e.$Yf=w;function c(r){return r>=65&&r<=90||r>=97&&r<=122}e.$Zf=c;function u(r,o){return N.$j&&r.endsWith(":")&&(r+=I.sep),(0,I.$hc)(r)||(r=(0,I.$ic)(o,r)),r=(0,I.$gc)(r),N.$j?(r=(0,j.$Le)(r,I.sep),r.endsWith(":")&&(r+=I.sep)):(r=(0,j.$Le)(r,I.sep),r||(r=I.sep)),r}e.$1f=u;function f(r){const o=(0,I.$gc)(r);return N.$j?r.length>3?!1:m(o)&&(r.length===2||o.charCodeAt(2)===92):o===I.$fc.sep}e.$2f=f;function m(r,o=N.$j){return o?c(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.$3f=m;function k(r,o=N.$j){return m(r,o)?r[0]:void 0}e.$4f=k;function s(r,o,v){return o.length>r.length?-1:r===o?0:(v&&(r=r.toLowerCase(),o=o.toLowerCase()),r.indexOf(o))}e.$5f=s;function a(r){const o=r.split(":");let v,p,h;for(const g of o){const D=Number(g);(0,L.$Df)(D)?p===void 0?p=D:h===void 0&&(h=D):v=v?[v,g].join(":"):g}if(!v)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:v,line:p!==void 0?p:void 0,column:h!==void 0?h:p!==void 0?1:void 0}}e.$6f=a;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function t(r,o,v=8){let p="";for(let g=0;g<v;g++){let D;g===0&&N.$j&&!o&&(v===3||v===4)?D=i:D=n,p+=D.charAt(Math.floor(Math.random()*D.length))}let h;return o?h=`${o}-${p}`:h=p,r?(0,I.$ic)(r,h):h}e.$7f=t}),define(ae[139],ce([0,1,16]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xr=e.$Wr=e.$Vr=e.$Ur=e.$Tr=void 0,e.$Tr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},j={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(P){const E=(0,I.$nc)(P),b=N[E.toLowerCase()];return b!==void 0?b:O(P)}e.$Ur=L;function O(P){const E=(0,I.$nc)(P);return j[E.toLowerCase()]}e.$Vr=O;function R(P){for(const E in j)if(j[E]===P)return E}e.$Wr=R;const S=/^(.+)\/(.+?)(;.+)?$/;function d(P,E){const b=S.exec(P);return b?`${b[1].toLowerCase()}/${b[2].toLowerCase()}${b[3]??""}`:E?void 0:P}e.$Xr=d}),define(ae[90],ce([0,1,5]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=e.$Dl=e.TerminateResponseCode=e.Source=void 0;var N;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(N||(e.Source=N={}));var j;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(j||(e.TerminateResponseCode=j={}));function L(R,...S){const d=S.reduce((b,l)=>(b[l]=!0,b),{}),P=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(b=>!d[b]).forEach(b=>{for(let l=0;l<P.length;l++)if(b.search(P[l])!==-1){delete R[b];break}})}e.$Dl=L;function O(R){R&&(delete R.DEBUG,I.$k&&delete R.DYLD_LIBRARY_PATH,I.$l&&delete R.LD_PRELOAD)}e.$El=O}),define(ae[10],ce([0,1,16,5]),function(ie,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vc=e.$uc=e.URI=void 0;const j=/^\w[\w\d+.-]*$/,L=/^\//,O=/^\/\//;function R(i,t){if(!i.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!j.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!L.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(O.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(i,t){return!i&&!t?"file":i}function d(i,t){switch(i){case"https":case"http":case"file":t?t[0]!==E&&(t=E+t):t=E;break}return t}const P="",E="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class l{static isUri(t){return t instanceof l?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}constructor(t,r,o,v,p,h=!1){typeof t=="object"?(this.scheme=t.scheme||P,this.authority=t.authority||P,this.path=t.path||P,this.query=t.query||P,this.fragment=t.fragment||P):(this.scheme=S(t,h),this.authority=r||P,this.path=d(this.scheme,o||P),this.query=v||P,this.fragment=p||P,R(this,h))}get fsPath(){return m(this,!1)}with(t){if(!t)return this;let{scheme:r,authority:o,path:v,query:p,fragment:h}=t;return r===void 0?r=this.scheme:r===null&&(r=P),o===void 0?o=this.authority:o===null&&(o=P),v===void 0?v=this.path:v===null&&(v=P),p===void 0?p=this.query:p===null&&(p=P),h===void 0?h=this.fragment:h===null&&(h=P),r===this.scheme&&o===this.authority&&v===this.path&&p===this.query&&h===this.fragment?this:new w(r,o,v,p,h)}static parse(t,r=!1){const o=b.exec(t);return o?new w(o[2]||P,n(o[4]||P),n(o[5]||P),n(o[7]||P),n(o[9]||P),r):new w(P,P,P,P,P)}static file(t){let r=P;if(N.$j&&(t=t.replace(/\\/g,E)),t[0]===E&&t[1]===E){const o=t.indexOf(E,2);o===-1?(r=t.substring(2),t=E):(r=t.substring(2,o),t=t.substring(o)||E)}return new w("file",r,t,P,P)}static from(t,r){return new w(t.scheme,t.authority,t.path,t.query,t.fragment,r)}static joinPath(t,...r){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return N.$j&&t.scheme==="file"?o=l.file(I.$ec.join(m(t,!0),...r)).path:o=I.$fc.join(t.path,...r),t.with({path:o})}toString(t=!1){return k(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof l)return t;{const r=new w(t);return r._formatted=t.external??null,r._fsPath=t._sep===y?t.fsPath??null:null,r}}else return t}}e.URI=l;function $(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.$uc=$;const y=N.$j?1:void 0;class w extends l{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=m(this,!1)),this._fsPath}toString(t=!1){return t?k(this,!0):(this._formatted||(this._formatted=k(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=y),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const c={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(i,t,r){let o,v=-1;for(let p=0;p<i.length;p++){const h=i.charCodeAt(p);if(h>=97&&h<=122||h>=65&&h<=90||h>=48&&h<=57||h===45||h===46||h===95||h===126||t&&h===47||r&&h===91||r&&h===93||r&&h===58)v!==-1&&(o+=encodeURIComponent(i.substring(v,p)),v=-1),o!==void 0&&(o+=i.charAt(p));else{o===void 0&&(o=i.substr(0,p));const g=c[h];g!==void 0?(v!==-1&&(o+=encodeURIComponent(i.substring(v,p)),v=-1),o+=g):v===-1&&(v=p)}}return v!==-1&&(o+=encodeURIComponent(i.substring(v))),o!==void 0?o:i}function f(i){let t;for(let r=0;r<i.length;r++){const o=i.charCodeAt(r);o===35||o===63?(t===void 0&&(t=i.substr(0,r)),t+=c[o]):t!==void 0&&(t+=i[r])}return t!==void 0?t:i}function m(i,t){let r;return i.authority&&i.path.length>1&&i.scheme==="file"?r=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?t?r=i.path.substr(1):r=i.path[1].toLowerCase()+i.path.substr(2):r=i.path,N.$j&&(r=r.replace(/\//g,"\\")),r}e.$vc=m;function k(i,t){const r=t?f:u;let o="",{scheme:v,authority:p,path:h,query:g,fragment:D}=i;if(v&&(o+=v,o+=":"),(p||v==="file")&&(o+=E,o+=E),p){let T=p.indexOf("@");if(T!==-1){const M=p.substr(0,T);p=p.substr(T+1),T=M.lastIndexOf(":"),T===-1?o+=r(M,!1,!1):(o+=r(M.substr(0,T),!1,!1),o+=":",o+=r(M.substr(T+1),!1,!0)),o+="@"}p=p.toLowerCase(),T=p.lastIndexOf(":"),T===-1?o+=r(p,!1,!0):(o+=r(p.substr(0,T),!1,!0),o+=p.substr(T))}if(h){if(h.length>=3&&h.charCodeAt(0)===47&&h.charCodeAt(2)===58){const T=h.charCodeAt(1);T>=65&&T<=90&&(h=`/${String.fromCharCode(T+32)}:${h.substr(3)}`)}else if(h.length>=2&&h.charCodeAt(1)===58){const T=h.charCodeAt(0);T>=65&&T<=90&&(h=`${String.fromCharCode(T+32)}:${h.substr(2)}`)}o+=r(h,!0,!1)}return g&&(o+="?",o+=r(g,!1,!1)),D&&(o+="#",o+=t?D:u(D,!1,!1)),o}function s(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+s(i.substr(3)):i}}const a=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(i){return i.match(a)?i.replace(a,t=>s(t)):i}}),define(ae[140],ce([0,1,10]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$4p=e.$3p=e.$2p=void 0;function N(d){const P=d;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.$2p=N;function j(d){const P=[];let E;try{const b=JSON.parse(d.arguments),l=b[b.length-1];l&&l.__$stack&&(b.pop(),E=l.__$stack),P.push(...b)}catch{P.push("Unable to log remote console arguments",d.arguments)}return{args:P,stack:E}}e.$3p=j;function L(d){if(typeof d!="string")return L(j(d).stack);const P=d;if(P){const E=O(P),b=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(b&&b.length===4)return{uri:I.URI.file(b[1]),line:Number(b[2]),column:Number(b[3])}}}e.$4p=L;function O(d){if(!d)return d;const P=d.indexOf(`
`);return P===-1?d:d.substring(0,P)}function R(d,P){const{args:E,stack:b}=j(d),l=typeof E[0]=="string"&&E.length===1;let $=O(b);$&&($=`(${$.trim()})`);let y=[];if(typeof E[0]=="string"?$&&l?y=[`%c[${P}] %c${E[0]} %c${$}`,S("blue"),S(""),S("grey")]:y=[`%c[${P}] %c${E[0]}`,S("blue"),S(""),...E.slice(1)]:y=[`%c[${P}]%`,S("blue"),...E],$&&!l&&y.push($),typeof console[d.severity]!="function")throw new Error("Unknown console method");console[d.severity].apply(console,y)}e.log=R;function S(d){return`color: ${d}`}}),define(ae[65],ce([0,1,15,10]),function(ie,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qh=e.$ph=e.$oh=void 0;function j(S){return JSON.stringify(S,O)}e.$oh=j;function L(S){let d=JSON.parse(S);return d=R(d),d}e.$ph=L;function O(S,d){return d instanceof RegExp?{$mid:2,source:d.source,flags:d.flags}:d}function R(S,d=0){if(!S||d>200)return S;if(typeof S=="object"){switch(S.$mid){case 1:return N.URI.revive(S);case 2:return new RegExp(S.source,S.flags);case 17:return new Date(S.source)}if(S instanceof I.$ce||S instanceof Uint8Array)return S;if(Array.isArray(S))for(let P=0;P<S.length;++P)S[P]=R(S[P],d+1);else for(const P in S)Object.hasOwnProperty.call(S,P)&&(S[P]=R(S[P],d+1))}return S}e.$qh=R}),define(ae[23],ce([0,1,7,5,10]),function(ie,e,I,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.Schemas=void 0;var L;(function(d){d.inMemory="inmemory",d.vscode="vscode",d.internal="private",d.walkThrough="walkThrough",d.walkThroughSnippet="walkThroughSnippet",d.http="http",d.https="https",d.file="file",d.mailto="mailto",d.untitled="untitled",d.data="data",d.command="command",d.vscodeRemote="vscode-remote",d.vscodeRemoteResource="vscode-remote-resource",d.vscodeManagedRemoteResource="vscode-managed-remote-resource",d.vscodeUserData="vscode-userdata",d.vscodeCustomEditor="vscode-custom-editor",d.vscodeNotebookCell="vscode-notebook-cell",d.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",d.vscodeNotebookCellOutput="vscode-notebook-cell-output",d.vscodeInteractiveInput="vscode-interactive-input",d.vscodeSettings="vscode-settings",d.vscodeWorkspaceTrust="vscode-workspace-trust",d.vscodeTerminal="vscode-terminal",d.vscodeChatSesssion="vscode-chat-editor",d.webviewPanel="webview-panel",d.vscodeWebview="vscode-webview",d.extension="extension",d.vscodeFileResource="vscode-file",d.tmp="tmp",d.vsls="vsls",d.vscodeSourceControl="vscode-scm"})(L||(e.Schemas=L={})),e.$8f="vscode-tkn",e.$9f="tkn";class O{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${L.vscodeRemoteResource}`}setPreferredWebSchema(P){this.d=P}setDelegate(P){this.e=P}setServerRootPath(P){this.f=`${P}/${L.vscodeRemoteResource}`}set(P,E,b){this.a[P]=E,this.b[P]=b}setConnectionToken(P,E){this.c[P]=E}getPreferredWebSchema(){return this.d}rewrite(P){if(this.e)try{return this.e(P)}catch(w){return I.$Z(w),P}const E=P.authority;let b=this.a[E];b&&b.indexOf(":")!==-1&&b.indexOf("[")===-1&&(b=`[${b}]`);const l=this.b[E],$=this.c[E];let y=`path=${encodeURIComponent(P.path)}`;return typeof $=="string"&&(y+=`&${e.$9f}=${encodeURIComponent($)}`),j.URI.from({scheme:N.$p?this.d:L.vscodeRemoteResource,authority:`${b}:${l}`,path:this.f,query:y})}}e.$0f=new O,e.$$f="vs/../../extensions",e.$_f="vs/../../node_modules",e.$ag="vs/../../node_modules.asar",e.$bg="vs/../../node_modules.asar.unpacked",e.$cg="vscode-app";class R{static{this.a=e.$cg}asBrowserUri(P){const E=this.b(P,ie);return this.uriToBrowserUri(E)}uriToBrowserUri(P){return P.scheme===L.vscodeRemote?e.$0f.rewrite(P):P.scheme===L.file&&(N.$n||N.$q&&N.$h.origin===`${L.vscodeFileResource}://${R.a}`)?P.with({scheme:L.vscodeFileResource,authority:P.authority||R.a,query:null,fragment:null}):P}asFileUri(P){const E=this.b(P,ie);return this.uriToFileUri(E)}uriToFileUri(P){return P.scheme===L.vscodeFileResource?P.with({scheme:L.file,authority:P.authority!==R.a?P.authority:null,query:null,fragment:null}):P}b(P,E){return j.URI.isUri(P)?P:j.URI.parse(E.toUrl(P))}}e.$dg=new R;var S;(function(d){const P=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);d.CoopAndCoep=Object.freeze(P.get("3"));const E="vscode-coi";function b($){let y;typeof $=="string"?y=new URL($).searchParams:$ instanceof URL?y=$.searchParams:j.URI.isUri($)&&(y=new URL($.toString(!0)).searchParams);const w=y?.get(E);if(w)return P.get(w)}d.getHeadersFromQuery=b;function l($,y,w){if(!globalThis.crossOriginIsolated)return;const c=y&&w?"3":w?"2":"1";$ instanceof URLSearchParams?$.set(E,c):$[E]=c}d.addSearchParam=l})(S||(e.COI=S={}))}),define(ae[141],ce([0,1,123,23,5,10]),function(ie,e,I,N,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LC=void 0;class O{constructor(b,l,$){this.id=b,this.dependencies=l,this.callback=$}}class R{static{this.INSTANCE=new R}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(b,l,$)=>{typeof b!="string"&&($=l,l=b,b=null),(typeof l!="object"||!Array.isArray(l))&&($=l,l=null),this.c.push(new O(b,l,$))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(b){if(b.startsWith(window.location.origin)||b.startsWith("vscode-file://vscode-app"))return b;throw new Error(`[trusted_script_src] Invalid script url: ${b}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(b){return b}})))}async load(b){this.g();const l=await(this.a?this.i(b):this.b?this.h(b):this.j(b));if(!l)throw new Error(`Did not receive a define call from script ${b}`);if(Array.isArray(l.dependencies)&&l.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${b}. The dependencies are: ${l.dependencies.join(", ")}`);return typeof l.callback=="function"?l.callback([]):l.callback}h(b){return new Promise((l,$)=>{const y=document.createElement("script");y.setAttribute("async","async"),y.setAttribute("type","text/javascript");const w=()=>{y.removeEventListener("load",c),y.removeEventListener("error",u)},c=f=>{w(),l(this.c.pop())},u=f=>{w(),$(f)};y.addEventListener("load",c),y.addEventListener("error",u),this.f&&(b=this.f.createScriptURL(b)),y.setAttribute("src",b),document.getElementsByTagName("head")[0].appendChild(y)})}i(b){return new Promise((l,$)=>{try{this.f&&(b=this.f.createScriptURL(b)),importScripts(b),l(this.c.pop())}catch(y){$(y)}})}async j(b){try{const l=globalThis._VSCODE_NODE_MODULES.fs,$=globalThis._VSCODE_NODE_MODULES.vm,y=globalThis._VSCODE_NODE_MODULES.module,w=L.URI.parse(b).fsPath,c=l.readFileSync(w).toString(),u=y.wrap(c.replace(/^#!.*/,""));return new $.Script(u).runInThisContext().apply(),this.c.pop()}catch(l){throw l}}}const S=new Map;let d={};typeof globalThis.require=="object"&&(d=globalThis.require.paths??{});async function P(E,b,l){if(I.$S){l===void 0&&(l=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),d[E]&&(E=d[E]);const $=`${E}/${b}`;if(S.has($))return S.get($);let y;if(/^\w[\w\d+.-]*:\/\//.test($))y=$;else{const f=`${l&&!j.$p?N.$ag:N.$_f}/${$}`;y=N.$dg.asBrowserUri(f).toString(!0)}const w=R.INSTANCE.load(y);return S.set($,w),w}else return await new Promise(($,y)=>{ie([E],$,y)})}e.$LC=P}),define(ae[19],ce([0,1,48,23,16,5,27,10]),function(ie,e,I,N,j,L,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gg=e.DataUri=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=void 0;function S(l){return(0,R.$vc)(l,!0)}e.$kg=S;class d{constructor($){this.a=$}compare($,y,w=!1){return $===y?0:(0,O.$Ve)(this.getComparisonKey($,w),this.getComparisonKey(y,w))}isEqual($,y,w=!1){return $===y?!0:!$||!y?!1:this.getComparisonKey($,w)===this.getComparisonKey(y,w)}getComparisonKey($,y=!1){return $.with({path:this.a($)?$.path.toLowerCase():void 0,fragment:y?null:void 0}).toString()}ignorePathCasing($){return this.a($)}isEqualOrParent($,y,w=!1){if($.scheme===y.scheme){if($.scheme===N.Schemas.file)return I.$Yf(S($),S(y),this.a($))&&$.query===y.query&&(w||$.fragment===y.fragment);if((0,e.$Bg)($.authority,y.authority))return I.$Yf($.path,y.path,this.a($),"/")&&$.query===y.query&&(w||$.fragment===y.fragment)}return!1}joinPath($,...y){return R.URI.joinPath($,...y)}basenameOrAuthority($){return(0,e.$tg)($)||$.authority}basename($){return j.$fc.basename($.path)}extname($){return j.$fc.extname($.path)}dirname($){if($.path.length===0)return $;let y;return $.scheme===N.Schemas.file?y=R.URI.file(j.$lc(S($))).path:(y=j.$fc.dirname($.path),$.authority&&y.length&&y.charCodeAt(0)!==47&&(console.error(`dirname("${$.toString})) resulted in a relative path`),y="/")),$.with({path:y})}normalizePath($){if(!$.path.length)return $;let y;return $.scheme===N.Schemas.file?y=R.URI.file(j.$gc(S($))).path:y=j.$fc.normalize($.path),$.with({path:y})}relativePath($,y){if($.scheme!==y.scheme||!(0,e.$Bg)($.authority,y.authority))return;if($.scheme===N.Schemas.file){const u=j.$kc(S($),S(y));return L.$j?I.$Sf(u):u}let w=$.path||"/";const c=y.path||"/";if(this.a($)){let u=0;for(const f=Math.min(w.length,c.length);u<f&&!(w.charCodeAt(u)!==c.charCodeAt(u)&&w.charAt(u).toLowerCase()!==c.charAt(u).toLowerCase());u++);w=c.substr(0,u)+w.substr(u)}return j.$fc.relative(w,c)}resolvePath($,y){if($.scheme===N.Schemas.file){const w=R.URI.file(j.$jc(S($),y));return $.with({authority:w.authority,path:w.path})}return y=I.$Tf(y),$.with({path:j.$fc.resolve($.path,y)})}isAbsolutePath($){return!!$.path&&$.path[0]==="/"}isEqualAuthority($,y){return $===y||$!==void 0&&y!==void 0&&(0,O.$3e)($,y)}hasTrailingPathSeparator($,y=j.sep){if($.scheme===N.Schemas.file){const w=S($);return w.length>I.$Uf(w).length&&w[w.length-1]===y}else{const w=$.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test($.fsPath)}}removeTrailingPathSeparator($,y=j.sep){return(0,e.$Cg)($,y)?$.with({path:$.path.substr(0,$.path.length-1)}):$}addTrailingPathSeparator($,y=j.sep){let w=!1;if($.scheme===N.Schemas.file){const c=S($);w=c!==void 0&&c.length===I.$Uf(c).length&&c[c.length-1]===y}else{y="/";const c=$.path;w=c.length===1&&c.charCodeAt(c.length-1)===47}return!w&&!(0,e.$Cg)($,y)?$.with({path:$.path+"/"}):$}}e.$lg=d,e.$mg=new d(()=>!1),e.$ng=new d(l=>l.scheme===N.Schemas.file?!L.$l:!0),e.$og=new d(l=>!0),e.$pg=e.$mg.isEqual.bind(e.$mg),e.$qg=e.$mg.isEqualOrParent.bind(e.$mg),e.$rg=e.$mg.getComparisonKey.bind(e.$mg),e.$sg=e.$mg.basenameOrAuthority.bind(e.$mg),e.$tg=e.$mg.basename.bind(e.$mg),e.$ug=e.$mg.extname.bind(e.$mg),e.$vg=e.$mg.dirname.bind(e.$mg),e.$wg=e.$mg.joinPath.bind(e.$mg),e.$xg=e.$mg.normalizePath.bind(e.$mg),e.$yg=e.$mg.relativePath.bind(e.$mg),e.$zg=e.$mg.resolvePath.bind(e.$mg),e.$Ag=e.$mg.isAbsolutePath.bind(e.$mg),e.$Bg=e.$mg.isEqualAuthority.bind(e.$mg),e.$Cg=e.$mg.hasTrailingPathSeparator.bind(e.$mg),e.$Dg=e.$mg.removeTrailingPathSeparator.bind(e.$mg),e.$Eg=e.$mg.addTrailingPathSeparator.bind(e.$mg);function P(l,$){const y=[];for(let w=0;w<l.length;w++){const c=$(l[w]);l.some((u,f)=>f===w?!1:(0,e.$qg)(c,$(u)))||y.push(l[w])}return y}e.$Fg=P;var E;(function(l){l.META_DATA_LABEL="label",l.META_DATA_DESCRIPTION="description",l.META_DATA_SIZE="size",l.META_DATA_MIME="mime";function $(y){const w=new Map;y.path.substring(y.path.indexOf(";")+1,y.path.lastIndexOf(";")).split(";").forEach(f=>{const[m,k]=f.split(":");m&&k&&w.set(m,k)});const u=y.path.substring(0,y.path.indexOf(";"));return u&&w.set(l.META_DATA_MIME,u),w}l.parseMetaData=$})(E||(e.DataUri=E={}));function b(l,$,y){if($){let w=l.path;return w&&w[0]!==j.$fc.sep&&(w=j.$fc.sep+w),l.with({scheme:y,authority:$,path:w})}return l.with({scheme:y})}e.$Gg=b}),define(ae[6],ce([0,1,26,7,3,2,19,5,129]),function(ie,e,I,N,j,L,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kh=e.$jh=e.$ih=e.$hh=e.Promises=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=void 0;function d(F){return!!F&&typeof F.then=="function"}e.$Hg=d;function P(F){const U=new I.$Yd,W=F(U.token),te=new Promise((se,ue)=>{const le=U.token.onCancellationRequested(()=>{le.dispose(),U.dispose(),ue(new N.$4)});Promise.resolve(W).then($e=>{le.dispose(),U.dispose(),se($e)},$e=>{le.dispose(),U.dispose(),ue($e)})});return new class{cancel(){U.cancel()}then(se,ue){return te.then(se,ue)}catch(se){return this.then(void 0,se)}finally(se){return te.finally(se)}}}e.$Ig=P;function E(F,U,W){return new Promise((te,se)=>{const ue=U.onCancellationRequested(()=>{ue.dispose(),te(W)});F.then(te,se).finally(()=>ue.dispose())})}e.$Jg=E;function b(F,U){return new Promise((W,te)=>{const se=U.onCancellationRequested(()=>{se.dispose(),te(new N.$4)});F.then(W,te).finally(()=>se.dispose())})}e.$Kg=b;async function l(F){let U=-1;const W=F.map((te,se)=>te.then(ue=>(U=se,ue)));try{return await Promise.race(W)}finally{F.forEach((te,se)=>{se!==U&&te.cancel()})}}e.$Lg=l;function $(F,U,W){let te;const se=setTimeout(()=>{te?.(void 0),W?.()},U);return Promise.race([F.finally(()=>clearTimeout(se)),new Promise(ue=>te=ue)])}e.$Mg=$;function y(F){return new Promise((U,W)=>{const te=F();d(te)?te.then(U,W):U(te)})}e.$Ng=y;class w{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(U){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=U,!this.b){const W=()=>{if(this.b=null,this.f)return;const te=this.queue(this.d);return this.d=null,te};this.b=new Promise(te=>{this.a.then(W,W).then(te)})}return new Promise((W,te)=>{this.b.then(W,te)})}return this.a=U(),new Promise((W,te)=>{this.a.then(se=>{this.a=null,W(se)},se=>{this.a=null,te(se)})})}dispose(){this.f=!0}}e.$Og=w;class c{constructor(){this.a=Promise.resolve(null)}queue(U){return this.a=this.a.then(()=>U(),()=>U())}}e.$Pg=c;class u{constructor(){this.a=new Map}queue(U,W){const se=(this.a.get(U)??Promise.resolve()).catch(()=>{}).then(W).finally(()=>{this.a.get(U)===se&&this.a.delete(U)});return this.a.set(U,se),se}}e.$Qg=u;const f=(F,U)=>{let W=!0;const te=setTimeout(()=>{W=!1,U()},F);return{isTriggered:()=>W,dispose:()=>{clearTimeout(te),W=!1}}},m=F=>{let U=!0;return queueMicrotask(()=>{U&&(U=!1,F())}),{isTriggered:()=>U,dispose:()=>{U=!1}}};class k{constructor(U){this.defaultDelay=U,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(U,W=this.defaultDelay){this.g=U,this.h(),this.b||(this.b=new Promise((se,ue)=>{this.d=se,this.f=ue}).then(()=>{if(this.b=null,this.d=null,this.g){const se=this.g;return this.g=null,se()}}));const te=()=>{this.a=null,this.d?.(null)};return this.a=W===S.$Ld?m(te):f(W,te),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new N.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Rg=k;class s{constructor(U){this.a=new k(U),this.b=new w}trigger(U,W){return this.a.trigger(()=>this.b.queue(U),W)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Sg=s;class a{constructor(){this.a=!1,this.b=new Promise((U,W)=>{this.d=U})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Tg=a;class n extends a{constructor(U){super(),this.f=setTimeout(()=>this.open(),U)}open(){clearTimeout(this.f),super.open()}}e.$Ug=n;function i(F,U){return U?new Promise((W,te)=>{const se=setTimeout(()=>{ue.dispose(),W()},F),ue=U.onCancellationRequested(()=>{clearTimeout(se),ue.dispose(),te(new N.$4)})}):P(W=>i(F,W))}e.$Vg=i;function t(F,U=0,W){const te=setTimeout(()=>{F(),W&&se.dispose()},U),se=(0,L.$Pc)(()=>{clearTimeout(te),W?.deleteAndLeak(se)});return W?.add(se),se}e.$Wg=t;function r(F,U,W){let te=0;const se=setInterval(()=>{te++,(te>=W||F())&&ue.dispose()},U),ue=(0,L.$Pc)(()=>{clearInterval(se)});return ue}e.$Xg=r;function o(F){const U=[];let W=0;const te=F.length;function se(){return W<te?F[W++]():null}function ue(le){le!=null&&U.push(le);const $e=se();return $e?$e.then(ue):Promise.resolve(U)}return Promise.resolve(null).then(ue)}e.$Yg=o;function v(F,U=te=>!!te,W=null){let te=0;const se=F.length,ue=()=>{if(te>=se)return Promise.resolve(W);const le=F[te++];return Promise.resolve(le()).then(fe=>U(fe)?Promise.resolve(fe):ue())};return ue()}e.$Zg=v;function p(F,U=te=>!!te,W=null){if(F.length===0)return Promise.resolve(W);let te=F.length;const se=()=>{te=-1;for(const ue of F)ue.cancel?.()};return new Promise((ue,le)=>{for(const $e of F)$e.then(fe=>{--te>=0&&U(fe)?(se(),ue(fe)):te===0&&ue(W)}).catch(fe=>{--te>=0&&(se(),le(fe))})})}e.$1g=p;class h{constructor(U){this.a=0,this.d=U,this.f=[],this.b=0,this.g=new j.$Od}get onDrained(){return this.g.event}get size(){return this.a}queue(U){return this.a++,new Promise((W,te)=>{this.f.push({factory:U,c:W,e:te}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const U=this.f.shift();this.b++;const W=U.factory();W.then(U.c,U.e),W.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$2g=h;class g extends h{constructor(){super(1)}}e.$3g=g;class D{constructor(){this.a=new V,this.b=0}queue(U){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,U())):this.a.run(this.b++,U())}}e.$4g=D;class T{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const U=new _;return this.b.add(U),U.p}g(){for(const[,U]of this.a)if(U.size>0)return!1;return!0}queueFor(U,W=O.$mg){const te=W.getComparisonKey(U);let se=this.a.get(te);if(!se){se=new g;const ue=this.f++,le=j.Event.once(se.onDrained)(()=>{se?.dispose(),this.a.delete(te),this.h(),this.d?.deleteAndDispose(ue),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new L.$Zc),this.d.set(ue,le),this.a.set(te,se)}return se}h(){this.g()&&this.j()}j(){for(const U of this.b)U.complete();this.b.clear()}dispose(){for(const[,U]of this.a)U.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$5g=T;class M{constructor(U,W){this.a=-1,typeof U=="function"&&typeof W=="number"&&this.setIfNotSet(U,W)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(U,W){this.cancel(),this.a=setTimeout(()=>{this.a=-1,U()},W)}setIfNotSet(U,W){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,U()},W))}}e.$6g=M;class z{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(U,W){this.cancel(),this.a=setInterval(()=>{U()},W)}}e.$7g=z;class B{constructor(U,W){this.b=-1,this.a=U,this.d=W,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(U=this.d){this.cancel(),this.b=setTimeout(this.f,U)}get delay(){return this.d}set delay(U){this.d=U}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$8g=B;class Z{constructor(U,W){W%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${W}ms is not a multiple of 1000ms.`),this.a=U,this.b=W,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(U=this.b){U%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(U/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$9g=Z;class K extends B{constructor(U,W){super(U,W),this.j=[]}work(U){this.j.push(U),this.isScheduled()||this.schedule()}h(){const U=this.j;this.j=[],this.a?.(U)}dispose(){this.j=[],super.dispose()}}e.$0g=K;class x extends L.$Rc{constructor(U,W){super(),this.g=U,this.h=W,this.a=[],this.b=this.B(new L.$Sc),this.f=!1}get pending(){return this.a.length}work(U){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+U.length>this.g.maxBufferedWork)return!1}else if(this.pending+U.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const W of U)this.a.push(W);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new B(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$$g=x,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$_g=(F,U)=>{(0,R.$B)(()=>{if(W)return;const te=Date.now()+15;U(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,te-Date.now())}}))});let W=!1;return{dispose(){W||(W=!0)}}}:e.$_g=(F,U,W)=>{const te=F.requestIdleCallback(U,typeof W=="number"?{timeout:W}:void 0);let se=!1;return{dispose(){se||(se=!0,F.cancelIdleCallback(te))}}},e.$ah=F=>(0,e.$_g)(globalThis,F)}();class H{constructor(U,W){this.d=!1,this.a=()=>{try{this.f=W()}catch(te){this.g=te}finally{this.d=!0}},this.b=(0,e.$_g)(U,()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$bh=H;class Y extends H{constructor(U){super(globalThis,U)}}e.$ch=Y;async function G(F,U,W){let te;for(let se=0;se<W;se++)try{return await F()}catch(ue){te=ue,await i(U)}throw te}e.$dh=G;class V{isRunning(U){return typeof U=="number"?this.a?.taskId===U:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(U,W,te){return this.a={taskId:U,cancel:()=>te?.(),promise:W},W.then(()=>this.d(U),()=>this.d(U)),W}d(U){this.a&&U===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const U=this.b;this.b=void 0,U.run().then(U.promiseResolve,U.promiseReject)}}queue(U){if(this.b)this.b.run=U;else{let W,te;const se=new Promise((ue,le)=>{W=ue,te=le});this.b={run:U,promise:se,promiseResolve:W,promiseReject:te}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$eh=V;class ee{constructor(U,W=()=>Date.now()){this.d=U,this.f=W,this.a=0,this.b=0}increment(){const U=this.f();return U-this.a>this.d&&(this.a=U,this.b=0),this.b++,this.b}}e.$fh=ee;var ne;(function(F){F[F.Resolved=0]="Resolved",F[F.Rejected=1]="Rejected"})(ne||(ne={}));class _{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((U,W)=>{this.a=U,this.b=W})}complete(U){return new Promise(W=>{this.a(U),this.d={outcome:0,value:U},W()})}error(U){return new Promise(W=>{this.b(U),this.d={outcome:1,value:U},W()})}cancel(){return this.error(new N.$4)}}e.$gh=_;var re;(function(F){async function U(te){let se;const ue=await Promise.all(te.map(le=>le.then($e=>$e,$e=>{se||(se=$e)})));if(typeof se<"u")throw se;return ue}F.settled=U;function W(te){return new Promise(async(se,ue)=>{try{await te(se,ue)}catch(le){ue(le)}})}F.withAsyncBody=W})(re||(e.Promises=re={}));var Q;(function(F){F[F.Initial=0]="Initial",F[F.DoneOK=1]="DoneOK",F[F.DoneError=2]="DoneError"})(Q||(Q={}));class q{static fromArray(U){return new q(W=>{W.emitMany(U)})}static fromPromise(U){return new q(async W=>{W.emitMany(await U)})}static fromPromises(U){return new q(async W=>{await Promise.all(U.map(async te=>W.emitOne(await te)))})}static merge(U){return new q(async W=>{await Promise.all(U.map(async te=>{for await(const se of te)W.emitOne(se)}))})}static{this.EMPTY=q.fromArray([])}constructor(U){this.a=0,this.b=[],this.d=null,this.f=new j.$Od,queueMicrotask(async()=>{const W={emitOne:te=>this.g(te),emitMany:te=>this.h(te),reject:te=>this.k(te)};try{await Promise.resolve(U(W)),this.j()}catch(te){this.k(te)}finally{W.emitOne=void 0,W.emitMany=void 0,W.reject=void 0}})}[Symbol.asyncIterator](){let U=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(U<this.b.length)return{done:!1,value:this.b[U++]};if(this.a===1)return{done:!0,value:void 0};await j.Event.toPromise(this.f.event)}while(!0)}}}static map(U,W){return new q(async te=>{for await(const se of U)te.emitOne(W(se))})}map(U){return q.map(this,U)}static filter(U,W){return new q(async te=>{for await(const se of U)W(se)&&te.emitOne(se)})}filter(U){return q.filter(this,U)}static coalesce(U){return q.filter(U,W=>!!W)}coalesce(){return q.coalesce(this)}static async toPromise(U){const W=[];for await(const te of U)W.push(te);return W}toPromise(){return q.toPromise(this)}g(U){this.a===0&&(this.b.push(U),this.f.fire())}h(U){this.a===0&&(this.b=this.b.concat(U),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(U){this.a===0&&(this.a=2,this.d=U,this.f.fire())}}e.$hh=q;class C extends q{constructor(U,W){super(W),this.l=U}cancel(){this.l.cancel()}}e.$ih=C;function A(F){const U=new I.$Yd,W=F(U.token);return new C(U,async te=>{const se=U.token.onCancellationRequested(()=>{se.dispose(),U.dispose(),te.reject(new N.$4)});try{for await(const ue of W){if(U.token.isCancellationRequested)return;te.emitOne(ue)}se.dispose(),U.dispose()}catch(ue){se.dispose(),U.dispose(),te.reject(ue)}})}e.$jh=A;class J{constructor(){this.a=new _,this.b=new q(te=>{if(U){te.reject(U);return}return W&&te.emitMany(W),this.d=se=>te.reject(se),this.f=se=>te.emitOne(se),this.a.p});let U,W;this.f=te=>{W||(W=[]),W.push(te)},this.d=te=>{U||(U=te)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(U){this.d(U),this.a.complete()}emitOne(U){this.f(U)}}e.$kh=J}),define(ae[91],ce([0,1,18,6,48,34,16,5,27]),function(ie,e,I,N,j,L,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=void 0;function d(){return Object.create(null)}e.$vj=d,e.$wj="**",e.$xj="/";const P="[/\\\\]",E="[^/\\\\]",b=/\//g;function l(Y,G){switch(Y){case 0:return"";case 1:return`${E}*?`;default:return`(?:${P}|${E}+${P}${G?`|${P}${E}+`:""})*?`}}function $(Y,G){if(!Y)return[];const V=[];let ee=!1,ne=!1,_="";for(const re of Y){switch(re){case G:if(!ee&&!ne){V.push(_),_="";continue}break;case"{":ee=!0;break;case"}":ee=!1;break;case"[":ne=!0;break;case"]":ne=!1;break}_+=re}return _&&V.push(_),V}e.$yj=$;function y(Y){if(!Y)return"";let G="";const V=$(Y,e.$xj);if(V.every(ee=>ee===e.$wj))G=".*";else{let ee=!1;V.forEach((ne,_)=>{if(ne===e.$wj){if(ee)return;G+=l(2,_===V.length-1)}else{let re=!1,Q="",q=!1,C="";for(const A of ne){if(A!=="}"&&re){Q+=A;continue}if(q&&(A!=="]"||!C)){let J;A==="-"?J=A:(A==="^"||A==="!")&&!C?J="^":A===e.$xj?J="":J=(0,S.$Ge)(A),C+=J;continue}switch(A){case"{":re=!0;continue;case"[":q=!0;continue;case"}":{const F=`(?:${$(Q,",").map(U=>y(U)).join("|")})`;G+=F,re=!1,Q="";break}case"]":{G+="["+C+"]",q=!1,C="";break}case"?":G+=E;continue;case"*":G+=l(1);continue;default:G+=(0,S.$Ge)(A)}}_<V.length-1&&(V[_+1]!==e.$wj||_+2<V.length)&&(G+=P)}ee=ne===e.$wj})}return G}const w=/^\*\*\/\*\.[\w\.-]+$/,c=/^\*\*\/([\w\.-]+)\/?$/,u=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,f=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,m=/^\*\*((\/[\w\.-]+)+)\/?$/,k=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new L.$Cc(1e4),a=function(){return!1},n=function(){return null};function i(Y,G){if(!Y)return n;let V;typeof Y!="string"?V=Y.pattern:V=Y,V=V.trim();const ee=`${V}_${!!G.trimForExclusions}`;let ne=s.get(ee);if(ne)return t(ne,Y);let _;return w.test(V)?ne=o(V.substr(4),V):(_=c.exec(r(V,G)))?ne=v(_[1],V):(G.trimForExclusions?f:u).test(V)?ne=p(V,G):(_=m.exec(r(V,G)))?ne=h(_[1].substr(1),V,!0):(_=k.exec(r(V,G)))?ne=h(_[1],V,!1):ne=g(V),s.set(ee,ne),t(ne,Y)}function t(Y,G){if(typeof G=="string")return Y;const V=function(ee,ne){return(0,j.$Yf)(ee,G.base,!R.$l)?Y((0,S.$Ke)(ee.substr(G.base.length),O.sep),ne):null};return V.allBasenames=Y.allBasenames,V.allPaths=Y.allPaths,V.basenames=Y.basenames,V.patterns=Y.patterns,V}function r(Y,G){return G.trimForExclusions&&Y.endsWith("/**")?Y.substr(0,Y.length-2):Y}function o(Y,G){return function(V,ee){return typeof V=="string"&&V.endsWith(Y)?G:null}}function v(Y,G){const V=`/${Y}`,ee=`\\${Y}`,ne=function(re,Q){return typeof re!="string"?null:Q?Q===Y?G:null:re===Y||re.endsWith(V)||re.endsWith(ee)?G:null},_=[Y];return ne.basenames=_,ne.patterns=[G],ne.allBasenames=_,ne}function p(Y,G){const V=x(Y.slice(1,-1).split(",").map(Q=>i(Q,G)).filter(Q=>Q!==n),Y),ee=V.length;if(!ee)return n;if(ee===1)return V[0];const ne=function(Q,q){for(let C=0,A=V.length;C<A;C++)if(V[C](Q,q))return Y;return null},_=V.find(Q=>!!Q.allBasenames);_&&(ne.allBasenames=_.allBasenames);const re=V.reduce((Q,q)=>q.allPaths?Q.concat(q.allPaths):Q,[]);return re.length&&(ne.allPaths=re),ne}function h(Y,G,V){const ee=O.sep===O.$fc.sep,ne=ee?Y:Y.replace(b,O.sep),_=O.sep+ne,re=O.$fc.sep+Y;let Q;return V?Q=function(q,C){return typeof q=="string"&&(q===ne||q.endsWith(_)||!ee&&(q===Y||q.endsWith(re)))?G:null}:Q=function(q,C){return typeof q=="string"&&(q===ne||!ee&&q===Y)?G:null},Q.allPaths=[(V?"*/":"./")+Y],Q}function g(Y){try{const G=new RegExp(`^${y(Y)}$`);return function(V){return G.lastIndex=0,typeof V=="string"&&G.test(V)?Y:null}}catch{return n}}function D(Y,G,V){return!Y||typeof G!="string"?!1:T(Y)(G,void 0,V)}e.$zj=D;function T(Y,G={}){if(!Y)return a;if(typeof Y=="string"||M(Y)){const V=i(Y,G);if(V===n)return a;const ee=function(ne,_){return!!V(ne,_)};return V.allBasenames&&(ee.allBasenames=V.allBasenames),V.allPaths&&(ee.allPaths=V.allPaths),ee}return Z(Y,G)}e.$Aj=T;function M(Y){const G=Y;return G?typeof G.base=="string"&&typeof G.pattern=="string":!1}e.$Bj=M;function z(Y){return Y.allBasenames||[]}e.$Cj=z;function B(Y){return Y.allPaths||[]}e.$Dj=B;function Z(Y,G){const V=x(Object.getOwnPropertyNames(Y).map(Q=>K(Q,Y[Q],G)).filter(Q=>Q!==n)),ee=V.length;if(!ee)return n;if(!V.some(Q=>!!Q.requiresSiblings)){if(ee===1)return V[0];const Q=function(A,J){let F;for(let U=0,W=V.length;U<W;U++){const te=V[U](A,J);if(typeof te=="string")return te;(0,N.$Hg)(te)&&(F||(F=[]),F.push(te))}return F?(async()=>{for(const U of F){const W=await U;if(typeof W=="string")return W}return null})():null},q=V.find(A=>!!A.allBasenames);q&&(Q.allBasenames=q.allBasenames);const C=V.reduce((A,J)=>J.allPaths?A.concat(J.allPaths):A,[]);return C.length&&(Q.allPaths=C),Q}const ne=function(Q,q,C){let A,J;for(let F=0,U=V.length;F<U;F++){const W=V[F];W.requiresSiblings&&C&&(q||(q=(0,O.$mc)(Q)),A||(A=q.substr(0,q.length-(0,O.$nc)(Q).length)));const te=W(Q,q,A,C);if(typeof te=="string")return te;(0,N.$Hg)(te)&&(J||(J=[]),J.push(te))}return J?(async()=>{for(const F of J){const U=await F;if(typeof U=="string")return U}return null})():null},_=V.find(Q=>!!Q.allBasenames);_&&(ne.allBasenames=_.allBasenames);const re=V.reduce((Q,q)=>q.allPaths?Q.concat(q.allPaths):Q,[]);return re.length&&(ne.allPaths=re),ne}function K(Y,G,V){if(G===!1)return n;const ee=i(Y,V);if(ee===n)return n;if(typeof G=="boolean")return ee;if(G){const ne=G.when;if(typeof ne=="string"){const _=(re,Q,q,C)=>{if(!C||!ee(re,Q))return null;const A=ne.replace("$(basename)",()=>q),J=C(A);return(0,N.$Hg)(J)?J.then(F=>F?Y:null):J?Y:null};return _.requiresSiblings=!0,_}}return ee}function x(Y,G){const V=Y.filter(Q=>!!Q.basenames);if(V.length<2)return Y;const ee=V.reduce((Q,q)=>{const C=q.basenames;return C?Q.concat(C):Q},[]);let ne;if(G){ne=[];for(let Q=0,q=ee.length;Q<q;Q++)ne.push(G)}else ne=V.reduce((Q,q)=>{const C=q.patterns;return C?Q.concat(C):Q},[]);const _=function(Q,q){if(typeof Q!="string")return null;if(!q){let A;for(A=Q.length;A>0;A--){const J=Q.charCodeAt(A-1);if(J===47||J===92)break}q=Q.substr(A)}const C=ee.indexOf(q);return C!==-1?ne[C]:null};_.basenames=ee,_.patterns=ne,_.allBasenames=ee;const re=Y.filter(Q=>!Q.basenames);return re.push(_),re}function H(Y,G){return(0,I.$tb)(Y,G,(V,ee)=>typeof V=="string"&&typeof ee=="string"?V===ee:typeof V!="string"&&typeof ee!="string"?V.base===ee.base&&V.pattern===ee.pattern:!1)}e.$Ej=H}),define(ae[92],ce([0,1,15,10]),function(ie,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.$Pm=void 0;function j(E){return E.toJSON()}class L{constructor(b){this.a=b}transformIncoming(b){const l=this.a.transformIncoming(b);return l===b?b:j(N.URI.from(l))}transformOutgoing(b){const l=this.a.transformOutgoing(b);return l===b?b:j(N.URI.from(l))}transformOutgoingURI(b){const l=this.a.transformOutgoing(b);return l===b?b:N.URI.from(l)}transformOutgoingScheme(b){return this.a.transformOutgoingScheme(b)}}e.$Pm=L,e.$Qm=new class{transformIncoming(E){return E}transformOutgoing(E){return E}transformOutgoingURI(E){return E}transformOutgoingScheme(E){return E}};function O(E,b,l){if(!E||l>200)return null;if(typeof E=="object"){if(E instanceof N.URI)return b.transformOutgoing(E);for(const $ in E)if(Object.hasOwnProperty.call(E,$)){const y=O(E[$],b,l+1);y!==null&&(E[$]=y)}}return null}function R(E,b){const l=O(E,b,0);return l===null?E:l}e.$Rm=R;function S(E,b,l,$){if(!E||$>200)return null;if(typeof E=="object"){if(E.$mid===1)return l?N.URI.revive(b.transformIncoming(E)):b.transformIncoming(E);if(E instanceof I.$ce)return null;for(const y in E)if(Object.hasOwnProperty.call(E,y)){const w=S(E[y],b,l,$+1);w!==null&&(E[y]=w)}}return null}function d(E,b){const l=S(E,b,!1,0);return l===null?E:l}e.$Sm=d;function P(E,b){const l=S(E,b,!0,0);return l===null?E:l}e.$Tm=P}),define(ae[142],ce([0,1,36,47,32,130,5]),function(ie,e,I,N,j,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xm=e.$Wm=e.$Vm=void 0,e.$Vm=new class{c(b){return this.a||(this.a=N.$Zh.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(b)}value(){if(this.b===void 0){let b=0,l=0;const $=(0,I.networkInterfaces)();for(const y in $){const w=$[y];if(w)for(const{mac:c,internal:u}of w)u||(l+=1,this.c(c.toUpperCase())&&(b+=1))}this.b=l>0?b/l:0}return this.b}};let R;async function S(b){return R||(R=(async()=>await d(b)||j.$fg())()),R}e.$Wm=S;async function d(b){try{const l=await new Promise((y,w)=>{ie(["crypto"],y,w)}),$=(0,L.$Um)();return l.createHash("sha256").update($,"utf8").digest("hex")}catch(l){b(l);return}}const P="Software\\Microsoft\\SQMClient";async function E(b){if(O.$j){const l=await new Promise(($,y)=>{ie(["@vscode/windows-registry"],$,y)});try{return l.GetStringRegKey("HKEY_LOCAL_MACHINE",P,"MachineId")||""}catch($){return b($),""}}return""}e.$Xm=E}),define(ae[31],ce([0,1,53,36,268,6,48,88,16,5,19,10]),function(ie,e,I,N,j,L,O,R,S,d,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var b;(function(K){K[K.UNLINK=0]="UNLINK",K[K.MOVE=1]="MOVE"})(b||(e.RimRafMode=b={}));async function l(K,x=b.UNLINK,H){if((0,O.$2f)(K))throw new Error("rimraf - will refuse to recursively delete root");return x===b.UNLINK?y(K):$(K,H)}async function $(K,x=(0,O.$7f)((0,N.tmpdir)())){try{try{await I.promises.rename(K,x)}catch(H){return H.code==="ENOENT"?void 0:y(K)}y(x).catch(H=>{})}catch(H){if(H.code!=="ENOENT")throw H}}async function y(K){return(0,j.promisify)(I.rm)(K,{recursive:!0,force:!0,maxRetries:3})}function w(K){if((0,O.$2f)(K))throw new Error("rimraf - will refuse to recursively delete root");I.rmSync(K,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=w;async function c(K,x){return m(await(x?u(K):(0,j.promisify)(I.readdir)(K)))}async function u(K){try{return await(0,j.promisify)(I.readdir)(K,{withFileTypes:!0})}catch(Y){console.warn("[node.js fs] readdir with filetypes failed with error: ",Y)}const x=[],H=await c(K);for(const Y of H){let G=!1,V=!1,ee=!1;try{const ne=await e.Promises.lstat((0,S.$ic)(K,Y));G=ne.isFile(),V=ne.isDirectory(),ee=ne.isSymbolicLink()}catch(ne){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ne)}x.push({name:Y,isFile:()=>G,isDirectory:()=>V,isSymbolicLink:()=>ee})}return x}function f(K){return m(I.readdirSync(K))}e.readdirSync=f;function m(K){return K.map(x=>typeof x=="string"?d.$k?(0,R.$sl)(x):x:(x.name=d.$k?(0,R.$sl)(x.name):x.name,x))}async function k(K){const x=await c(K),H=[];for(const Y of x)await a.existsDirectory((0,S.$ic)(K,Y))&&H.push(Y);return H}function s(K,x=1e3){return new Promise(H=>{let Y=!1;const G=setInterval(()=>{Y||(Y=!0,I.access(K,V=>{Y=!1,V&&(clearInterval(G),H(void 0))}))},x)})}e.whenDeleted=s;var a;(function(K){async function x(G){let V;try{if(V=await e.Promises.lstat(G),!V.isSymbolicLink())return{stat:V}}catch{}try{return{stat:await e.Promises.stat(G),symbolicLink:V?.isSymbolicLink()?{dangling:!1}:void 0}}catch(ee){if(ee.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};if(d.$j&&ee.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(G)),symbolicLink:{dangling:!1}}}catch(ne){if(ne.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};throw ne}throw ee}}K.stat=x;async function H(G){try{const{stat:V,symbolicLink:ee}=await K.stat(G);return V.isFile()&&ee?.dangling!==!0}catch{}return!1}K.existsFile=H;async function Y(G){try{const{stat:V,symbolicLink:ee}=await K.stat(G);return V.isDirectory()&&ee?.dangling!==!0}catch{}return!1}K.existsDirectory=Y})(a||(e.SymlinkSupport=a={}));const n=new L.$5g;function i(K,x,H){return n.queueFor(E.URI.file(K),P.$ng).queue(()=>{const Y=p(H);return new Promise((G,V)=>o(K,x,Y,ee=>ee?V(ee):G()))})}let t=!0;function r(K){t=K}e.configureFlushOnWrite=r;function o(K,x,H,Y){if(!t)return I.writeFile(K,x,{mode:H.mode,flag:H.flag},Y);I.open(K,H.flag,H.mode,(G,V)=>{if(G)return Y(G);I.writeFile(V,x,ee=>{if(ee)return I.close(V,()=>Y(ee));I.fdatasync(V,ne=>(ne&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ne),r(!1)),I.close(V,_=>Y(_))))})})}function v(K,x,H){const Y=p(H);if(!t)return I.writeFileSync(K,x,{mode:Y.mode,flag:Y.flag});const G=I.openSync(K,Y.flag,Y.mode);try{I.writeFileSync(G,x);try{I.fdatasyncSync(G)}catch(V){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",V),r(!1)}}finally{I.closeSync(G)}}e.writeFileSync=v;function p(K){return K?{mode:typeof K.mode=="number"?K.mode:438,flag:typeof K.flag=="string"?K.flag:"w"}:{mode:438,flag:"w"}}async function h(K,x,H=6e4){if(K!==x)try{d.$j&&typeof H=="number"?await g(K,x,Date.now(),H):await(0,j.promisify)(I.rename)(K,x)}catch(Y){if(K.toLowerCase()!==x.toLowerCase()&&Y.code==="EXDEV"||K.endsWith("."))await D(K,x,{preserveSymlinks:!1}),await l(K,b.MOVE);else throw Y}}async function g(K,x,H,Y,G=0){try{return await(0,j.promisify)(I.rename)(K,x)}catch(V){if(V.code!=="EACCES"&&V.code!=="EPERM"&&V.code!=="EBUSY")throw V;if(Date.now()-H>=Y)throw console.error(`[node.js fs] rename failed after ${G} retries with error: ${V}`),V;if(G===0){let ee=!1;try{const{stat:ne}=await a.stat(x);ne.isFile()||(ee=!0)}catch{}if(ee)throw V}return await(0,L.$Vg)(Math.min(100,G*10)),g(K,x,H,Y,G+1)}}async function D(K,x,H){return M(K,x,{root:{source:K,target:x},options:H,handledSourcePaths:new Set})}const T=511;async function M(K,x,H){if(H.handledSourcePaths.has(K))return;H.handledSourcePaths.add(K);const{stat:Y,symbolicLink:G}=await a.stat(K);if(G){if(H.options.preserveSymlinks)try{return await Z(K,x,H)}catch(V){console.warn("[node.js fs] copy of symlink failed: ",V)}if(G.dangling)return}return Y.isDirectory()?z(K,x,Y.mode&T,H):B(K,x,Y.mode&T)}async function z(K,x,H,Y){await e.Promises.mkdir(x,{recursive:!0,mode:H});const G=await c(K);for(const V of G)await M((0,S.$ic)(K,V),(0,S.$ic)(x,V),Y)}async function B(K,x,H){await e.Promises.copyFile(K,x),await e.Promises.chmod(x,H)}async function Z(K,x,H){let Y=await e.Promises.readlink(K);(0,O.$Yf)(Y,H.root.source,!d.$l)&&(Y=(0,S.$ic)(H.root.target,Y.substr(H.root.source.length+1))),await e.Promises.symlink(Y,x)}e.Promises=new class{get access(){return(0,j.promisify)(I.access)}get stat(){return(0,j.promisify)(I.stat)}get lstat(){return(0,j.promisify)(I.lstat)}get utimes(){return(0,j.promisify)(I.utimes)}get read(){return(K,x,H,Y,G)=>new Promise((V,ee)=>{I.read(K,x,H,Y,G,(ne,_,re)=>ne?ee(ne):V({bytesRead:_,buffer:re}))})}get readFile(){return(0,j.promisify)(I.readFile)}get write(){return(K,x,H,Y,G)=>new Promise((V,ee)=>{I.write(K,x,H,Y,G,(ne,_,re)=>ne?ee(ne):V({bytesWritten:_,buffer:re}))})}get appendFile(){return(0,j.promisify)(I.appendFile)}get fdatasync(){return(0,j.promisify)(I.fdatasync)}get truncate(){return(0,j.promisify)(I.truncate)}get copyFile(){return(0,j.promisify)(I.copyFile)}get open(){return(0,j.promisify)(I.open)}get close(){return(0,j.promisify)(I.close)}get symlink(){return(0,j.promisify)(I.symlink)}get readlink(){return(0,j.promisify)(I.readlink)}get chmod(){return(0,j.promisify)(I.chmod)}get mkdir(){return(0,j.promisify)(I.mkdir)}get unlink(){return(0,j.promisify)(I.unlink)}get rmdir(){return(0,j.promisify)(I.rmdir)}get realpath(){return(0,j.promisify)(I.realpath)}async exists(K){try{return await e.Promises.access(K),!0}catch{return!1}}get readdir(){return c}get readDirsInDir(){return k}get writeFile(){return i}get rm(){return l}get rename(){return h}get copy(){return D}}}),define(ae[143],ce([0,1,53,16,5,27,31]),function(ie,e,I,N,j,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_p=e.$$p=e.$0p=e.$9p=void 0;function R(b){if(j.$l)return b;const l=(0,N.$lc)(b);if(b===l)return b;const $=((0,N.$mc)(b)||b).toLowerCase();try{const w=(0,O.readdirSync)(l).filter(c=>c.toLowerCase()===$);if(w.length===1){const c=R(l);if(c)return(0,N.$ic)(c,w[0])}else if(w.length>1){const c=w.indexOf($);if(c>=0){const u=R(l);if(u)return(0,N.$ic)(u,w[c])}}}catch{}return null}e.$9p=R;async function S(b){if(j.$l)return b;const l=(0,N.$lc)(b);if(b===l)return b;const $=((0,N.$mc)(b)||b).toLowerCase();try{const w=(await O.Promises.readdir(l)).filter(c=>c.toLowerCase()===$);if(w.length===1){const c=await S(l);if(c)return(0,N.$ic)(c,w[0])}else if(w.length>1){const c=w.indexOf($);if(c>=0){const u=await S(l);if(u)return(0,N.$ic)(u,w[c])}}}catch{}return null}e.$0p=S;async function d(b){try{return await O.Promises.realpath(b)}catch{const $=E(b);return await O.Promises.access($,I.constants.R_OK),$}}e.$$p=d;function P(b){try{return I.realpathSync(b)}catch{const $=E(b);return I.accessSync($,I.constants.R_OK),$}}e.$_p=P;function E(b){return(0,L.$Le)((0,N.$gc)(b),N.sep)}}),define(ae[144],ce([0,1,16,5,37,90,12,31]),function(ie,e,I,N,j,L,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Gl=e.$Fl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function S(E=j.env){return E.comspec||"cmd.exe"}e.$Fl=S;function d(E){let b=[],l=!1;const $=function(y){if(l){b.push(y);return}(!E.send(y,c=>{if(c&&console.error(c),l=!1,b.length>0){const u=b.slice(0);b=[],u.forEach(f=>$(f))}})||N.$j)&&(l=!0)};return{send:$}}e.$Gl=d;var P;(function(E){async function b(l,$,y){if(I.$hc(l))return l;if($===void 0&&($=j.cwd()),I.$lc(l)!=="."||(y===void 0&&O.$zf(j.env.PATH)&&(y=j.env.PATH.split(I.$sc)),y===void 0||y.length===0))return I.$ic($,l);async function c(u){if(await R.Promises.exists(u)){let f;try{f=await R.Promises.stat(u)}catch(m){m.message.startsWith("EACCES")&&(f=await R.Promises.lstat(u))}return f?!f.isDirectory():!1}return!1}for(const u of y){let f;if(I.$hc(u)?f=I.$ic(u,l):f=I.$ic($,u,l),await c(f))return f;let m=f+".com";if(await c(m)||(m=f+".exe",await c(m)))return m}return I.$ic($,l)}E.findExecutable=b})(P||(e.win32=P={}))}),define(ae[145],ce([0,1,66,23]),function(ie,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gr=void 0;function j(O){return new Promise((R,S)=>{let d;const P=new Map;function E(l,$,y,w,c){const u=P.get($);if(l===O||u){const f={name:b(y),cmd:y,pid:l,ppid:$,load:w,mem:c};P.set(l,f),l===O&&(d=f),u&&(u.children||(u.children=[]),u.children.push(f),u.children.length>1&&(u.children=u.children.sort((m,k)=>m.pid-k.pid)))}}function b(l){const $=/--utility-sub-type=network/i,y=/--ms-enable-electron-run-as-node/i,w=/--crashes-directory/i,c=/\\pipe\\winpty-control/i,u=/conhost\.exe.+--headless/i,f=/--type=([a-zA-Z-]+)/;if(w.exec(l))return"electron-crash-reporter";if(c.exec(l))return"winpty-agent";if(u.exec(l))return"conpty-agent";let m=f.exec(l);if(m&&m.length===2)return m[1]==="renderer"?"window":m[1]==="utility"?$.exec(l)?"utility-network-service":"utility-process":m[1]==="extensionHost"?"extension-host":m[1];const k=/[a-zA-Z-]+\.js/g;let s="";do m=k.exec(l),m&&(s+=m+" ");while(m);return s&&l.indexOf("node ")<0&&l.indexOf("node.exe")<0?`electron-nodejs (${s})`:y.exec(l)?`electron-nodejs (${l})`:l}if(process.platform==="win32"){const l=$=>$.indexOf("\\\\?\\")===0||$.indexOf("\\??\\")===0?$.substring(4):$.indexOf('"\\\\?\\')===0||$.indexOf('"\\??\\')===0?'"'+$.substring(5):$;new Promise(($,y)=>{ie(["@vscode/windows-process-tree"],$,y)}).then($=>{$.getProcessList(O,y=>{if(!y){S(new Error(`Root process ${O} not found`));return}$.getProcessCpuUsage(y,w=>{const c=new Map;w.forEach(u=>{const f=l(u.commandLine||"");c.set(u.pid,{name:b(f),cmd:f,pid:u.pid,ppid:u.ppid,load:u.cpu||0,mem:u.memory||0})}),d=c.get(O),d?(c.forEach(u=>{const f=c.get(u.ppid);f&&(f.children||(f.children=[]),f.children.push(u))}),c.forEach(u=>{u.children&&(u.children=u.children.sort((f,m)=>f.pid-m.pid))}),R(d)):S(new Error(`Root process ${O} not found`))})},$.ProcessDataFlag.CommandLine|$.ProcessDataFlag.Memory)})}else{let l=function(){let $=[d];const y=[];for(;$.length;){const c=$.shift();c&&(y.push(c.pid),c.children&&($=$.concat(c.children)))}let w=JSON.stringify(N.$dg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);w+=" "+y.join(" "),(0,I.exec)(w,{},(c,u,f)=>{if(c||f)S(c||new Error(f.toString()));else{const m=u.toString().split(`
`);for(let k=0;k<y.length;k++){const s=P.get(y[k]);s.load=parseFloat(m[k])}if(!d){S(new Error(`Root process ${O} not found`));return}R(d)}})};(0,I.exec)("which ps",{},($,y,w)=>{if($||w)if(process.platform!=="linux")S($||new Error(w.toString()));else{const c=JSON.stringify(N.$dg.asFileUri("vs/base/node/ps.sh").fsPath);(0,I.exec)(c,{},(u,f,m)=>{u||m?S(u||new Error(m.toString())):(L(f,E),l())})}else{const c=y.toString().trim(),u="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,I.exec)(`${c} ${u}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(f,m,k)=>{f||k&&!k.includes("screen size is bogus")?S(f||new Error(k.toString())):(L(m,E),process.platform==="linux"?l():d?R(d):S(new Error(`Root process ${O} not found`)))})}})}})}e.$Gr=j;function L(O,R){const S=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,d=O.toString().split(`
`);for(const P of d){const E=S.exec(P.trim());E&&E.length===6&&R(parseInt(E[1]),parseInt(E[2]),E[5],parseFloat(E[3]),parseFloat(E[4]))}}});var pe=this&&this.__decorate||function(ie,e,I,N){var j=arguments.length,L=j<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,I):N,O;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(ie,e,I,N);else for(var R=ie.length-1;R>=0;R--)(O=ie[R])&&(L=(j<3?O(L):j>3?O(e,I,L):O(e,I))||L);return j>3&&L&&Object.defineProperty(e,I,L),L};define(ae[40],ce([0,1,18,6,15,26,84,7,3,2,65,27,12]),function(ie,e,I,N,j,L,O,R,S,d,P,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ch=e.ProxyChannel=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.RequestInitiator=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=void 0;var l;(function(G){G[G.Promise=100]="Promise",G[G.PromiseCancel=101]="PromiseCancel",G[G.EventListen=102]="EventListen",G[G.EventDispose=103]="EventDispose"})(l||(l={}));function $(G){switch(G){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var y;(function(G){G[G.Initialize=200]="Initialize",G[G.PromiseSuccess=201]="PromiseSuccess",G[G.PromiseError=202]="PromiseError",G[G.PromiseErrorObj=203]="PromiseErrorObj",G[G.EventFire=204]="EventFire"})(y||(y={}));function w(G){switch(G){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var c;(function(G){G[G.Uninitialized=0]="Uninitialized",G[G.Idle=1]="Idle"})(c||(c={}));function u(G){let V=0;for(let ee=0;;ee+=7){const ne=G.read(1);if(V|=(ne.buffer[0]&127)<<ee,!(ne.buffer[0]&128))return V}}const f=n(0);function m(G,V){if(V===0){G.write(f);return}let ee=0;for(let _=V;_!==0;_=_>>>7)ee++;const ne=j.$ce.alloc(ee);for(let _=0;V!==0;_++)ne.buffer[_]=V&127,V=V>>>7,V>0&&(ne.buffer[_]|=128);G.write(ne)}class k{constructor(V){this.b=V,this.a=0}read(V){const ee=this.b.slice(this.a,this.a+V);return this.a+=ee.byteLength,ee}}e.$rh=k;class s{constructor(){this.a=[]}get buffer(){return j.$ce.concat(this.a)}write(V){this.a.push(V)}}e.$sh=s;var a;(function(G){G[G.Undefined=0]="Undefined",G[G.String=1]="String",G[G.Buffer=2]="Buffer",G[G.VSBuffer=3]="VSBuffer",G[G.Array=4]="Array",G[G.Object=5]="Object",G[G.Int=6]="Int"})(a||(a={}));function n(G){const V=j.$ce.alloc(1);return V.writeUInt8(G,0),V}const i={Undefined:n(a.Undefined),String:n(a.String),Buffer:n(a.Buffer),VSBuffer:n(a.VSBuffer),Array:n(a.Array),Object:n(a.Object),Uint:n(a.Int)},t=typeof Buffer<"u";function r(G,V){if(typeof V>"u")G.write(i.Undefined);else if(typeof V=="string"){const ee=j.$ce.fromString(V);G.write(i.String),m(G,ee.byteLength),G.write(ee)}else if(t&&Buffer.isBuffer(V)){const ee=j.$ce.wrap(V);G.write(i.Buffer),m(G,ee.byteLength),G.write(ee)}else if(V instanceof j.$ce)G.write(i.VSBuffer),m(G,V.byteLength),G.write(V);else if(Array.isArray(V)){G.write(i.Array),m(G,V.length);for(const ee of V)r(G,ee)}else if(typeof V=="number"&&(V|0)===V)G.write(i.Uint),m(G,V);else{const ee=j.$ce.fromString(JSON.stringify(V));G.write(i.Object),m(G,ee.byteLength),G.write(ee)}}e.$th=r;function o(G){switch(G.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return G.read(u(G)).toString();case a.Buffer:return G.read(u(G)).buffer;case a.VSBuffer:return G.read(u(G));case a.Array:{const ee=u(G),ne=[];for(let _=0;_<ee;_++)ne.push(o(G));return ne}case a.Object:return JSON.parse(G.read(u(G)).toString());case a.Int:return u(G)}}e.$uh=o;class v{constructor(V,ee,ne=null,_=1e3){this.h=V,this.j=ee,this.k=ne,this.l=_,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(re=>this.q(re)),this.m({type:200})}registerChannel(V,ee){this.b.set(V,ee),setTimeout(()=>this.w(V),0)}m(V){switch(V.type){case 200:{const ee=this.o([V.type]);this.k?.logOutgoing(ee,0,1,w(V.type));return}case 201:case 202:case 204:case 203:{const ee=this.o([V.type,V.id],V.data);this.k?.logOutgoing(ee,V.id,1,w(V.type),V.data);return}}}o(V,ee=void 0){const ne=new s;return r(ne,V),r(ne,ee),this.p(ne.buffer)}p(V){try{return this.h.send(V),V.byteLength}catch{return 0}}q(V){const ee=new k(V),ne=o(ee),_=o(ee),re=ne[0];switch(re){case 100:return this.k?.logIncoming(V.byteLength,ne[1],1,`${$(re)}: ${ne[2]}.${ne[3]}`,_),this.s({type:re,id:ne[1],channelName:ne[2],name:ne[3],arg:_});case 102:return this.k?.logIncoming(V.byteLength,ne[1],1,`${$(re)}: ${ne[2]}.${ne[3]}`,_),this.t({type:re,id:ne[1],channelName:ne[2],name:ne[3],arg:_});case 101:return this.k?.logIncoming(V.byteLength,ne[1],1,`${$(re)}`),this.u({type:re,id:ne[1]});case 103:return this.k?.logIncoming(V.byteLength,ne[1],1,`${$(re)}`),this.u({type:re,id:ne[1]})}}s(V){const ee=this.b.get(V.channelName);if(!ee){this.v(V);return}const ne=new L.$Yd;let _;try{_=ee.call(this.j,V.name,V.arg,ne.token)}catch(q){_=Promise.reject(q)}const re=V.id;_.then(q=>{this.m({id:re,data:q,type:201})},q=>{q instanceof Error?this.m({id:re,data:{message:q.message,name:q.name,stack:q.stack?q.stack.split?q.stack.split(`
`):q.stack:void 0},type:202}):this.m({id:re,data:q,type:203})}).finally(()=>{Q.dispose(),this.d.delete(V.id)});const Q=(0,d.$Pc)(()=>ne.cancel());this.d.set(V.id,Q)}t(V){const ee=this.b.get(V.channelName);if(!ee){this.v(V);return}const ne=V.id,re=ee.listen(this.j,V.name,V.arg)(Q=>this.m({id:ne,data:Q,type:204}));this.d.set(V.id,re)}u(V){const ee=this.d.get(V.id);ee&&(ee.dispose(),this.d.delete(V.id))}v(V){let ee=this.g.get(V.channelName);ee||(ee=[],this.g.set(V.channelName,ee));const ne=setTimeout(()=>{console.error(`Unknown channel: ${V.channelName}`),V.type===100&&this.m({id:V.id,data:{name:"Unknown channel",message:`Channel name '${V.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ee.push({request:V,timeoutTimer:ne})}w(V){const ee=this.g.get(V);if(ee){for(const ne of ee)switch(clearTimeout(ne.timeoutTimer),ne.request.type){case 100:this.s(ne.request);break;case 102:this.t(ne.request);break}this.g.delete(V)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,d.$Mc)(this.d.values()),this.d.clear()}}e.$vh=v;var p;(function(G){G[G.LocalSide=0]="LocalSide",G[G.OtherSide=1]="OtherSide"})(p||(e.RequestInitiator=p={}));class h{constructor(V,ee=null){this.l=V,this.a=!1,this.b=c.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new S.$Od,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ne=>this.s(ne)),this.j=ee}getChannel(V){const ee=this;return{call(ne,_,re){return ee.a?Promise.reject(new R.$4):ee.m(V,ne,_,re)},listen(ne,_){return ee.a?S.Event.None:ee.o(V,ne,_)}}}m(V,ee,ne,_=L.CancellationToken.None){const re=this.g++,q={id:re,type:100,channelName:V,name:ee,arg:ne};if(_.isCancellationRequested)return Promise.reject(new R.$4);let C;return new Promise((J,F)=>{if(_.isCancellationRequested)return F(new R.$4);const U=()=>{const ue=le=>{switch(le.type){case 201:this.f.delete(re),J(le.data);break;case 202:{this.f.delete(re);const $e=new Error(le.data.message);$e.stack=Array.isArray(le.data.stack)?le.data.stack.join(`
`):le.data.stack,$e.name=le.data.name,F($e);break}case 203:this.f.delete(re),F(le.data);break}};this.f.set(re,ue),this.p(q)};let W=null;this.b===c.Idle?U():(W=(0,N.$Ig)(ue=>this.u()),W.then(()=>{W=null,U()}));const te=()=>{W?(W.cancel(),W=null):this.p({id:re,type:101}),F(new R.$4)},se=_.onCancellationRequested(te);C=(0,d.$Oc)((0,d.$Pc)(te),se),this.d.add(C)}).finally(()=>{C.dispose(),this.d.delete(C)})}o(V,ee,ne){const _=this.g++,Q={id:_,type:102,channelName:V,name:ee,arg:ne};let q=null;const C=new S.$Od({onWillAddFirstListener:()=>{q=(0,N.$Ig)(J=>this.u()),q.then(()=>{q=null,this.d.add(C),this.p(Q)})},onDidRemoveLastListener:()=>{q?(q.cancel(),q=null):(this.d.delete(C),this.p({id:_,type:103}))}}),A=J=>C.fire(J.data);return this.f.set(_,A),C.event}p(V){switch(V.type){case 100:case 102:{const ee=this.q([V.type,V.id,V.channelName,V.name],V.arg);this.j?.logOutgoing(ee,V.id,0,`${$(V.type)}: ${V.channelName}.${V.name}`,V.arg);return}case 101:case 103:{const ee=this.q([V.type,V.id]);this.j?.logOutgoing(ee,V.id,0,$(V.type));return}}}q(V,ee=void 0){const ne=new s;return r(ne,V),r(ne,ee),this.r(ne.buffer)}r(V){try{return this.l.send(V),V.byteLength}catch{return 0}}s(V){const ee=new k(V),ne=o(ee),_=o(ee),re=ne[0];switch(re){case 200:return this.j?.logIncoming(V.byteLength,0,0,w(re)),this.t({type:ne[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(V.byteLength,ne[1],0,w(re),_),this.t({type:ne[0],id:ne[1],data:_})}}t(V){if(V.type===200){this.b=c.Idle,this.k.fire();return}this.f.get(V.id)?.(V)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}u(){return this.b===c.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,d.$Mc)(this.d.values()),this.d.clear()}}e.$wh=h,pe([O.$lh],h.prototype,"onDidInitializePromise",null);class g{get connections(){const V=[];return this.f.forEach(ee=>V.push(ee)),V}constructor(V){this.a=new Map,this.f=new Set,this.g=new S.$Od,this.onDidAddConnection=this.g.event,this.h=new S.$Od,this.onDidRemoveConnection=this.h.event,this.j=new d.$Qc,this.j.add(V(({protocol:ee,onDidClientDisconnect:ne})=>{const _=S.Event.once(ee.onMessage);this.j.add(_(re=>{const Q=new k(re),q=o(Q),C=new v(ee,q),A=new h(ee);this.a.forEach((F,U)=>C.registerChannel(U,F));const J={channelServer:C,channelClient:A,ctx:q};this.f.add(J),this.g.fire(J),this.j.add(ne(()=>{C.dispose(),A.dispose(),this.f.delete(J),this.h.fire(J)}))}))}))}getChannel(V,ee){const ne=this;return{call(_,re,Q){let q;if((0,b.$Nf)(ee)){const A=(0,I.$3b)(ne.connections.filter(ee));q=A?Promise.resolve(A):S.Event.toPromise(S.Event.filter(ne.onDidAddConnection,ee))}else q=ee.routeCall(ne,_,re);const C=q.then(A=>A.channelClient.getChannel(V));return T(C).call(_,re,Q)},listen(_,re){if((0,b.$Nf)(ee))return ne.k(V,ee,_,re);const Q=ee.routeEvent(ne,_,re).then(q=>q.channelClient.getChannel(V));return T(Q).listen(_,re)}}}k(V,ee,ne,_){const re=this;let Q;const q=new S.$Od({onWillAddFirstListener:()=>{Q=new d.$Qc;const C=new S.$Ud,A=new Map,J=U=>{const te=U.channelClient.getChannel(V).listen(ne,_),se=C.add(te);A.set(U,se)},F=U=>{const W=A.get(U);W&&(W.dispose(),A.delete(U))};re.connections.filter(ee).forEach(J),S.Event.filter(re.onDidAddConnection,ee)(J,void 0,Q),re.onDidRemoveConnection(F,void 0,Q),C.event(q.fire,q,Q),Q.add(C)},onDidRemoveLastListener:()=>{Q?.dispose(),Q=void 0}});return q.event}registerChannel(V,ee){this.a.set(V,ee);for(const ne of this.f)ne.channelServer.registerChannel(V,ee)}dispose(){this.j.dispose();for(const V of this.f)V.channelClient.dispose(),V.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$xh=g;class D{constructor(V,ee,ne=null){const _=new s;r(_,ee),V.send(_.buffer),this.a=new h(V,ne),this.d=new v(V,ee,ne)}getChannel(V){return this.a.getChannel(V)}registerChannel(V,ee){this.d.registerChannel(V,ee)}dispose(){this.a.dispose(),this.d.dispose()}}e.$yh=D;function T(G){return{call(V,ee,ne){return G.then(_=>_.call(V,ee,ne))},listen(V,ee){const ne=new S.$Xd;return G.then(_=>ne.input=_.listen(V,ee)),ne.event}}}e.$zh=T;function M(G){let V=!1;return{call(ee,ne,_){return V?G.call(ee,ne,_):(0,N.$Vg)(0).then(()=>V=!0).then(()=>G.call(ee,ne,_))},listen(ee,ne){if(V)return G.listen(ee,ne);const _=new S.$Xd;return(0,N.$Vg)(0).then(()=>V=!0).then(()=>_.input=G.listen(ee,ne)),_.event}}}e.$Ah=M;class z{constructor(V){this.a=V}routeCall(V){return this.b(V)}routeEvent(V){return this.b(V)}async b(V){for(const ee of V.connections)if(await Promise.resolve(this.a(ee.ctx)))return Promise.resolve(ee);return await S.Event.toPromise(V.onDidAddConnection),await this.b(V)}}e.$Bh=z;var B;(function(G){function V(re,Q,q){const C=re,A=q&&q.disableMarshalling,J=new Map;for(const F in C)ne(F)&&J.set(F,S.Event.buffer(C[F],!0,void 0,Q));return new class{listen(F,U,W){const te=J.get(U);if(te)return te;if(_(U)){const se=C[U];if(typeof se=="function")return se.call(C,W)}throw new R.$ab(`Event not found: ${U}`)}call(F,U,W){const te=C[U];if(typeof te=="function"){if(!A&&Array.isArray(W))for(let ue=0;ue<W.length;ue++)W[ue]=(0,P.$qh)(W[ue]);let se=te.apply(C,W);return se instanceof Promise||(se=Promise.resolve(se)),se}throw new R.$ab(`Method not found: ${U}`)}}}G.fromService=V;function ee(re,Q){const q=Q&&Q.disableMarshalling;return new Proxy({},{get(C,A){if(typeof A=="string")return Q?.properties?.has(A)?Q.properties.get(A):_(A)?function(J){return re.listen(A,J)}:ne(A)?re.listen(A):async function(...J){let F;Q&&!(0,b.$If)(Q.context)?F=[Q.context,...J]:F=J;const U=await re.call(A,F);return q?U:(0,P.$qh)(U)};throw new R.$ab(`Property not found: ${String(A)}`)}})}G.toService=ee;function ne(re){return re[0]==="o"&&re[1]==="n"&&E.$2e(re.charCodeAt(2))}function _(re){return/^onDynamic/.test(re)&&E.$2e(re.charCodeAt(9))}})(B||(e.ProxyChannel=B={}));const Z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function K(G){if(Array.isArray(G))return G;if(G&&typeof G=="object"&&typeof G.toString=="function"){const V=G.toString();if(V!=="[object Object]")return V}return G}function x(G){return Array.isArray(G)?G.map(K):K(G)}function H(G,V,ee,ne,_,re,Q){Q=x(Q);const q=Z[_],C=q[ne%q.length];let A=[`%c[${G}]%c[${String(V).padStart(7," ")}]%c[len: ${String(ee).padStart(5," ")}]%c${String(ne).padStart(5," ")} - ${re}`,"color: darkgreen","color: grey","color: grey",`color: ${C}`];/\($/.test(re)?(A=A.concat(Q),A.push(")")):A.push(Q),console.log.apply(console,A)}class Y{constructor(V,ee){this.d=V,this.f=ee,this.a=0,this.b=0}logOutgoing(V,ee,ne,_,re){this.b+=V,H(this.d,this.b,V,ee,ne,_,re)}logIncoming(V,ee,ne,_,re){this.a+=V,H(this.f,this.a,V,ee,ne,_,re)}}e.$Ch=Y}),define(ae[67],ce([0,1,15,3,2,40]),function(ie,e,I,N,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.ProtocolConstants=e.$Dh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var O;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(O||(e.SocketDiagnosticsEventType=O={}));var R;(function(i){i.enableDiagnostics=!1,i.records=[];const t=new WeakMap;let r=0;function o(p,h){if(!t.has(p)){const g=String(++r);t.set(p,g)}return t.get(p)}function v(p,h,g,D){if(!i.enableDiagnostics)return;const T=o(p,h);if(D instanceof I.$ce||D instanceof Uint8Array||D instanceof ArrayBuffer||ArrayBuffer.isView(D)){const M=I.$ce.alloc(D.byteLength);M.set(D),i.records.push({timestamp:Date.now(),id:T,label:h,type:g,buff:M})}else i.records.push({timestamp:Date.now(),id:T,label:h,type:g,data:D})}i.traceSocketEvent=v})(R||(e.SocketDiagnostics=R={}));var S;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S||(e.SocketCloseEventType=S={}));let d=null;function P(){return d||(d=I.$ce.alloc(0)),d}class E{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(t){this.a.push(t),this.b+=t.byteLength}read(t){return this.c(t,!0)}peek(t){return this.c(t,!1)}c(t,r){if(t===0)return P();if(t>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===t){const h=this.a[0];return r&&(this.a.shift(),this.b-=t),h}if(this.a[0].byteLength>t){const h=this.a[0].slice(0,t);return r&&(this.a[0]=this.a[0].slice(t),this.b-=t),h}const o=I.$ce.alloc(t);let v=0,p=0;for(;t>0;){const h=this.a[p];if(h.byteLength>t){const g=h.slice(0,t);o.set(g,v),v+=t,r&&(this.a[p]=h.slice(t),this.b-=t),t-=t}else o.set(h,v),v+=h.byteLength,r?(this.a.shift(),this.b-=h.byteLength):p++,t-=h.byteLength}return o}}e.$Dh=E;var b;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(b||(b={}));function l(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var $;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})($||(e.ProtocolConstants=$={}));class y{constructor(t,r,o,v){this.type=t,this.id=r,this.ack=o,this.data=v,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends j.$Rc{constructor(t){super(),this.f=this.B(new N.$Od),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=t,this.b=!1,this.c=new E,this.B(this.a.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(t){if(!(!t||t.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(t);this.c.byteLength>=this.g.readLen;){const r=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=r.readUInt32BE(9),this.g.messageType=r.readUInt8(0),this.g.id=r.readUInt32BE(1),this.g.ack=r.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:l(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const o=this.g.messageType,v=this.g.id,p=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",r),this.f.fire(new y(o,v,p,r)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class c{constructor(t){this.k=null,this.a=!1,this.b=!1,this.c=t,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(t){if(this.a)return;t.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=I.$ce.alloc(13);r.writeUInt8(t.type,0),r.writeUInt32BE(t.id,1),r.writeUInt32BE(t.ack,5),r.writeUInt32BE(t.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:l(t.type),id:t.id,ack:t.ack,messageSize:t.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",t.data),this.j(r,t.data)}g(t,r){const o=this.f===0;return this.d.push(t,r),this.f+=t.byteLength+r.byteLength,o}h(){const t=I.$ce.concat(this.d,this.f);return this.d.length=0,this.f=0,t}j(t,r){this.g(t,r)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const t=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:t.byteLength}),this.c.write(t)}}class u extends j.$Rc{constructor(t){super(),this.f=new N.$Od,this.onMessage=this.f.event,this.g=new N.$Od,this.onDidDispose=this.g.event,this.a=t,this.b=this.B(new c(this.a)),this.c=this.B(new w(this.a)),this.B(this.c.onMessage(r=>{r.type===1&&this.f.fire(r.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(t){this.b.write(new y(1,0,0,t))}}e.$Eh=u;class f extends L.$yh{static fromSocket(t,r){return new f(new u(t),r)}get onDidDispose(){return this.b.onDidDispose}constructor(t,r,o=null){super(t,r,o),this.b=t}dispose(){super.dispose();const t=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),t.end()}}e.$Fh=f;class m{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new N.$Od({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(t){this.b?this.d.length>0?this.d.push(t):this.a.fire(t):this.d.push(t)}flushBuffer(){this.d=[]}}e.$Gh=m;class k{constructor(t){this.data=t,this.next=null}}class s{constructor(){this.a=null,this.b=null}length(){let t=0,r=this.a;for(;r;)r=r.next,t++;return t}peek(){return this.a?this.a.data:null}toArray(){const t=[];let r=0,o=this.a;for(;o;)t[r++]=o.data,o=o.next;return t}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(t){const r=new k(t);if(!this.a){this.a=r,this.b=r;return}this.b.next=r,this.b=r}}class a{static{this.a=10}static{this.b=null}static getInstance(){return a.b||(a.b=new a),a.b}constructor(){this.c=[];const t=Date.now();for(let r=0;r<a.a;r++)this.c[r]=t-1e3*r;setInterval(()=>{for(let r=a.a;r>=1;r--)this.c[r]=this.c[r-1];this.c[0]=Date.now()},1e3)}d(){const t=Date.now(),r=(1+a.a)*1e3;let o=0;for(let v=0;v<a.a;v++)t-this.c[v]<=r&&o++;return 1-o/a.a}hasHighLoad(){return this.d()>=.5}}class n{get unacknowledgedCount(){return this.c-this.d}constructor(t){this.u=new m,this.onControlMessage=this.u.event,this.v=new m,this.onMessage=this.v.event,this.w=new m,this.onDidDispose=this.w.event,this.x=new m,this.onSocketClose=this.x.event,this.y=new m,this.onSocketTimeout=this.y.event,this.s=t.loadEstimator??a.getInstance(),this.t=t.sendKeepAlive??!0,this.a=!1,this.b=new s,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new j.$Qc,this.o=t.socket,this.p=this.r.add(new c(this.o)),this.q=this.r.add(new w(this.o)),this.r.add(this.q.onMessage(r=>this.z(r))),this.r.add(this.o.onClose(r=>this.x.fire(r))),t.initialChunk&&this.q.acceptChunk(t.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const t=new y(5,0,0,P());this.p.write(t),this.p.flush()}sendPause(){const t=new y(7,0,0,P());this.p.write(t)}sendResume(){const t=new y(8,0,0,P());this.p.write(t)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(t,r){this.a=!0,this.r.dispose(),this.r=new j.$Qc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=t,this.p=this.r.add(new c(this.o)),this.q=this.r.add(new w(this.o)),this.r.add(this.q.onMessage(o=>this.z(o))),this.r.add(this.o.onClose(o=>this.x.fire(o))),this.q.acceptChunk(r)}endAcceptReconnection(){this.a=!1,this.h=this.g;const t=new y(3,0,this.h,P());this.p.write(t);const r=this.b.toArray();for(let o=0,v=r.length;o<v;o++)this.p.write(r[o]);this.B()}acceptDisconnect(){this.w.fire()}z(t){if(t.ack>this.d){this.d=t.ack;do{const r=this.b.peek();if(r&&r.id<=t.ack)this.b.pop();else break}while(!0)}switch(t.type){case 0:break;case 1:{if(t.id>this.g)if(t.id!==this.g+1){const r=Date.now();r-this.m>1e4&&(this.m=r,this.p.write(new y(6,0,0,P())))}else this.g=t.id,this.j=Date.now(),this.A(),this.v.fire(t.data);break}case 2:{this.u.fire(t.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const r=this.b.toArray();for(let o=0,v=r.length;o<v;o++)this.p.write(r[o]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(t){const r=++this.c;this.h=this.g;const o=new y(1,r,this.h,t);this.b.push(o),this.a||(this.p.write(o),this.B())}sendControl(t){const r=new y(2,0,0,t);this.p.write(r)}A(){if(this.g<=this.h||this.k)return;const t=Date.now()-this.j;if(t>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-t+5)}B(){if(this.c<=this.d||this.f||this.a)return;const t=this.b.peek(),r=Date.now()-t.writtenTime,o=Date.now()-this.q.lastReadTime,v=Date.now()-this.n;if(r>=2e4&&o>=2e4&&v>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:o});return}const p=Math.max(2e4-r,2e4-o,2e4-v,500);this.f=setTimeout(()=>{this.f=null,this.B()},p)}C(){if(this.g<=this.h)return;this.h=this.g;const t=new y(3,0,this.h,P());this.p.write(t)}D(){this.h=this.g;const t=new y(9,0,this.h,P());this.p.write(t)}}e.$Hh=n}),define(ae[93],ce([0,1,66,6,15,26,140,7,3,2,30,144,90,40]),function(ie,e,I,N,j,L,O,R,S,d,P,E,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=e.$6p=void 0;class $ extends l.$vh{constructor(c){super({send:u=>{try{process.send?.(u.buffer.toString("base64"))}catch{}},onMessage:S.Event.fromNodeEventEmitter(process,"message",u=>j.$ce.wrap(Buffer.from(u,"base64")))},c),process.once("disconnect",()=>this.dispose())}}e.$6p=$;class y{constructor(c,u){this.i=c,this.j=u,this.c=new Set,this.g=new Map,this.h=new S.$Od,this.onDidProcessExit=this.h.event;const f=u&&u.timeout?u.timeout:6e4;this.b=new N.$Rg(f),this.d=null,this.f=null}getChannel(c){const u=this;return{call(f,m,k){return u.k(c,f,m,k)},listen(f,m){return u.l(c,f,m)}}}k(c,u,f,m=L.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(m.isCancellationRequested)return Promise.reject(R.$5());this.b.cancel();const k=this.n(c),s=(0,N.$Ig)(i=>k.call(u,f,i)),a=m.onCancellationRequested(()=>s.cancel()),n=(0,d.$Pc)(()=>s.cancel());return this.c.add(n),s.finally(()=>{a.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),s}l(c,u,f){if(!this.b)return S.Event.None;this.b.cancel();let m;const k=new S.$Od({onWillAddFirstListener:()=>{m=this.n(c).listen(u,f)(k.fire,k),this.c.add(m)},onDidRemoveLastListener:()=>{this.c.delete(m),m.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return k.event}get m(){if(!this.f){const c=this.j&&this.j.args?this.j.args:[],u=Object.create(null);u.env={...(0,P.$$m)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(u.env={...u.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(u.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(u.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(u.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),u.execArgv===void 0&&(u.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t)).filter(t=>!t.startsWith("--vscode-"))),(0,b.$El)(u.env),this.d=(0,I.fork)(this.i,c,u);const f=new S.$Od;S.Event.fromNodeEventEmitter(this.d,"message",t=>t)(t=>{if((0,O.$2p)(t)){(0,O.log)(t,`IPC Library: ${this.j.serverName}`);return}f.fire(j.$ce.wrap(Buffer.from(t,"base64")))});const k=this.j.useQueue?(0,E.$Gl)(this.d):this.d,s=t=>this.d&&this.d.connected&&k.send(t.buffer.toString("base64")),a=f.event,n={send:s,onMessage:a};this.f=new l.$wh(n);const i=()=>this.o();process.once("exit",i),this.d.on("error",t=>console.warn('IPC "'+this.j.serverName+'" errored with '+t)),this.d.on("exit",(t,r)=>{process.removeListener("exit",i),this.c.forEach(o=>(0,d.$Mc)(o)),this.c.clear(),t!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+t+" and signal "+r),this.b?.cancel(),this.o(),this.h.fire({code:t,signal:r})})}return this.f}n(c){let u=this.g.get(c);return u||(u=this.m.getChannel(c),this.g.set(c,u)),u}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$7p=y}),define(ae[146],ce([0,1,133,15,40,3,12,18]),function(ie,e,I,N,j,L,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1T=e.$ZT=void 0;class S{constructor(b){this.a=b,this.onMessage=L.Event.fromNodeEventEmitter(this.a,"message",l=>N.$ce.wrap(l.data)),b.start()}send(b){this.a.postMessage(b.buffer)}disconnect(){this.a.close()}}class d extends j.$xh{static b(b){(0,O.$Jf)((0,I.$YT)(process),"Electron Utility Process");const l=new L.$Od;return process.parentPort.on("message",$=>{if(b?.handledClientConnection($))return;const y=(0,R.$Nb)($.ports);y&&l.fire(y)}),L.Event.map(l.event,$=>({protocol:new S($),onDidClientDisconnect:L.Event.fromNodeEventEmitter($,"close")}))}constructor(b){super(d.b(b))}}e.$ZT=d;function P(E,b,l){const $=y=>{y.data===b&&(E.removeListener("message",$),l())};E.on("message",$)}e.$1T=P}),define(ae[68],ce([0,1,6,3,2,65,12]),function(ie,e,I,N,j,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7o=e.$6o=e.StorageState=e.$5o=e.StorageHint=void 0;var R;(function(b){b[b.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",b[b.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(R||(e.StorageHint=R={}));function S(b){const l=b;return l?.changed instanceof Map||l?.deleted instanceof Set}e.$5o=S;var d;(function(b){b[b.None=0]="None",b[b.Initialized=1]="Initialized",b[b.Closed=2]="Closed"})(d||(e.StorageState=d={}));class P extends j.$Rc{static{this.a=100}constructor(l,$=Object.create(null)){super(),this.r=l,this.s=$,this.b=this.B(new N.$Rd),this.onDidChangeStorage=this.b.event,this.c=d.None,this.f=new Map,this.g=this.B(new I.$Sg(P.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(l=>this.u(l)))}u(l){this.b.pause();try{l.changed?.forEach(($,y)=>this.w(y,$)),l.deleted?.forEach($=>this.w($,void 0))}finally{this.b.resume()}}w(l,$){if(this.c===d.Closed)return;let y=!1;(0,O.$If)($)?y=this.f.delete(l):this.f.get(l)!==$&&(this.f.set(l,$),y=!0),y&&this.b.fire({key:l,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===d.None&&(this.c=d.Initialized,this.s.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(l,$){const y=this.f.get(l);return(0,O.$If)(y)?$:y}getBoolean(l,$){const y=this.get(l);return(0,O.$If)(y)?$:y==="true"}getNumber(l,$){const y=this.get(l);return(0,O.$If)(y)?$:parseInt(y,10)}getObject(l,$){const y=this.get(l);return(0,O.$If)(y)?$:(0,L.$ph)(y)}async set(l,$,y=!1){if(this.c===d.Closed)return;if((0,O.$If)($))return this.delete(l,y);const w=(0,O.$Bf)($)||Array.isArray($)?(0,L.$oh)($):String($);if(this.f.get(l)!==w)return this.f.set(l,w),this.j.set(l,w),this.h.delete(l),this.b.fire({key:l,external:y}),this.D()}async delete(l,$=!1){if(!(this.c===d.Closed||!this.f.delete(l)))return this.h.has(l)||this.h.add(l),this.j.delete(l),this.b.fire({key:l,external:$}),this.D()}async optimize(){if(this.c!==d.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=d.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const l={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(l).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(l){if(this.z)return this.D(l)}async D(l){return this.s.hint===R.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),l)}async whenFlushed(){if(this.z)return new Promise(l=>this.n.push(l))}isInMemory(){return this.s.hint===R.STORAGE_IN_MEMORY}}e.$6o=P;class E{constructor(){this.onDidChangeItemsExternal=N.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(l){l.insert?.forEach(($,y)=>this.a.set(y,$)),l.delete?.forEach($=>this.a.delete($))}async optimize(){}async close(){}}e.$7o=E}),define(ae[147],ce([13,9]),function(ie,e){return ie.create("vs/base/node/zip",e)}),define(ae[148],ce([13,9]),function(ie,e){return ie.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ae[149],ce([13,9]),function(ie,e){return ie.create("vs/platform/contextkey/common/contextkey",e)}),define(ae[150],ce([13,9]),function(ie,e){return ie.create("vs/platform/contextkey/common/scanner",e)}),define(ae[151],ce([13,9]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ae[152],ce([13,9]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ae[153],ce([13,9]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ae[154],ce([13,9]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ae[155],ce([13,9]),function(ie,e){return ie.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ae[156],ce([13,9]),function(ie,e){return ie.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ae[157],ce([13,9]),function(ie,e){return ie.create("vs/platform/extensions/common/extensionValidator",e)}),define(ae[158],ce([13,9]),function(ie,e){return ie.create("vs/platform/files/common/fileService",e)}),define(ae[159],ce([13,9]),function(ie,e){return ie.create("vs/platform/files/common/files",e)}),define(ae[160],ce([13,9]),function(ie,e){return ie.create("vs/platform/files/common/io",e)}),define(ae[161],ce([13,9]),function(ie,e){return ie.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ae[162],ce([13,9]),function(ie,e){return ie.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ae[163],ce([13,9]),function(ie,e){return ie.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(ae[164],ce([13,9]),function(ie,e){return ie.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(ae[165],ce([13,9]),function(ie,e){return ie.create("vs/platform/request/common/request",e)}),define(ae[166],ce([13,9]),function(ie,e){return ie.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(ae[167],ce([13,9]),function(ie,e){return ie.create("vs/platform/telemetry/common/telemetryService",e)}),define(ae[168],ce([13,9]),function(ie,e){return ie.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ae[169],ce([13,9]),function(ie,e){return ie.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(ae[170],ce([13,9]),function(ie,e){return ie.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(ae[171],ce([13,9]),function(ie,e){return ie.create("vs/platform/userDataSync/common/settingsSync",e)}),define(ae[172],ce([13,9]),function(ie,e){return ie.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(ae[173],ce([13,9]),function(ie,e){return ie.create("vs/platform/userDataSync/common/userDataSync",e)}),define(ae[174],ce([13,9]),function(ie,e){return ie.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(ae[175],ce([13,9]),function(ie,e){return ie.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(ae[176],ce([13,9]),function(ie,e){return ie.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(ae[177],ce([13,9]),function(ie,e){return ie.create("vs/platform/workspace/common/workspace",e)}),define(ae[178],ce([0,1,7,150]),function(ie,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oi=e.TokenType=void 0;var j;(function(d){d[d.LParen=0]="LParen",d[d.RParen=1]="RParen",d[d.Neg=2]="Neg",d[d.Eq=3]="Eq",d[d.NotEq=4]="NotEq",d[d.Lt=5]="Lt",d[d.LtEq=6]="LtEq",d[d.Gt=7]="Gt",d[d.GtEq=8]="GtEq",d[d.RegexOp=9]="RegexOp",d[d.RegexStr=10]="RegexStr",d[d.True=11]="True",d[d.False=12]="False",d[d.In=13]="In",d[d.Not=14]="Not",d[d.And=15]="And",d[d.Or=16]="Or",d[d.Str=17]="Str",d[d.QuotedStr=18]="QuotedStr",d[d.Error=19]="Error",d[d.EOF=20]="EOF"})(j||(e.TokenType=j={}));function L(...d){switch(d.length){case 1:return(0,N.localize)(0,null,d[0]);case 2:return(0,N.localize)(1,null,d[0],d[1]);case 3:return(0,N.localize)(2,null,d[0],d[1],d[2]);default:return}}const O=(0,N.localize)(3,null),R=(0,N.localize)(4,null);class S{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(P){switch(P.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return P.isTripleEq?"===":"==";case 4:return P.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return P.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return P.lexeme;case 18:return P.lexeme;case 19:return P.lexeme;case 20:return"EOF";default:throw(0,I.$7)(`unhandled token type: ${JSON.stringify(P)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(P=>P.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(P){return this.c=P,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const E=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:E})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const E=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:E})}else this.h(126)?this.k(9):this.l(L("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(L("&&"));break;case 124:this.h(124)?this.k(16):this.l(L("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(P){return this.r()||this.c.charCodeAt(this.e)!==P?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(P){this.f.push({type:P,offset:this.d})}l(P){const E=this.d,b=this.c.substring(this.d,this.e),l={type:19,offset:this.d,lexeme:b};this.g.push({offset:E,lexeme:b,additionalInfo:P}),this.f.push(l)}n(){this.m.lastIndex=this.d;const P=this.m.exec(this.c);if(P){this.e=this.d+P[0].length;const E=this.c.substring(this.d,this.e),b=S.b.get(E);b?this.k(b):this.f.push({type:17,lexeme:E,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(O);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let P=this.e,E=!1,b=!1;for(;;){if(P>=this.c.length){this.e=P,this.l(R);return}const $=this.c.charCodeAt(P);if(E)E=!1;else if($===47&&!b){P++;break}else $===91?b=!0:$===92?E=!0:$===93&&(b=!1);P++}for(;P<this.c.length&&S.a.has(this.c.charCodeAt(P));)P++;this.e=P;const l=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:l,offset:this.d})}r(){return this.e>=this.c.length}}e.$Oi=S}),define(ae[179],ce([0,1,64,84,23,16,37,19,10]),function(ie,e,I,N,j,L,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mm=e.$lm=e.$km=e.$jm=void 0,e.$jm=/^([^.]+\..+):(.+)$/;class d{get appRoot(){return(0,L.$lc)(j.$dg.asFileUri("").fsPath)}get userHome(){return S.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return S.URI.file((0,L.$ic)(this.userDataPath,"User"))}get tmpDir(){return S.URI.file(this.b.tmpDir)}get cacheHome(){return S.URI.file(this.userDataPath)}get stateResource(){return(0,R.$wg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:j.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,R.$wg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const l=(0,I.$im)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.$ic)(this.userDataPath,"logs",l)}return S.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.$wg)(S.URI.file((0,L.$ic)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,R.$wg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,R.$wg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,R.$wg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const l=O.env.VSCODE_PORTABLE;return l?S.URI.file((0,L.$ic)(l,"argv.json")):(0,R.$wg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return S.URI.file((0,L.$ic)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const l=this.args["builtin-extensions-dir"];return l?(0,L.$jc)(l):(0,L.$gc)((0,L.$ic)(j.$dg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const l=this.args["extensions-download-dir"];return l?S.URI.file((0,L.$jc)(l)):S.URI.file((0,L.$ic)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const l=this.args["extensions-dir"];if(l)return(0,L.$jc)(l);const $=O.env.VSCODE_EXTENSIONS;if($)return $;const y=O.env.VSCODE_PORTABLE;return y?(0,L.$ic)(y,"extensions"):(0,R.$wg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const l=this.args.extensionDevelopmentPath;if(Array.isArray(l))return l.map($=>/^[^:/?#]+?:\/\//.test($)?S.URI.parse($):S.URI.file((0,L.$gc)($)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(l=>l==="ui"||l==="workspace"||l==="web"?l:"workspace")}get extensionTestsLocationURI(){const l=this.args.extensionTestsPath;if(l)return/^[^:/?#]+?:\/\//.test(l)?S.URI.parse(l):S.URI.file((0,L.$gc)(l))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const l=this.args["disable-extension"];if(l){if(typeof l=="string")return[l];if(Array.isArray(l)&&l.length>0)return l}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!O.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(l=>!e.$jm.test(l))}get extensionLogLevel(){const l=[];for(const $ of this.args.log||[]){const y=e.$jm.exec($);y&&y[1]&&y[2]&&l.push([y[1],y[2]])}return l.length?l:void 0}get serviceMachineIdResource(){return(0,R.$wg)(S.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const l=O.env.VSCODE_PORTABLE;return l?S.URI.file((0,L.$ic)(l,"policy.json")):(0,R.$wg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(l){this.args.continueOn=l}get args(){return this.a}constructor(l,$,y){this.a=l,this.b=$,this.c=y,this.editSessionId=this.args.editSessionId}}e.$km=d,pe([N.$lh],d.prototype,"appRoot",null),pe([N.$lh],d.prototype,"userHome",null),pe([N.$lh],d.prototype,"userDataPath",null),pe([N.$lh],d.prototype,"appSettingsHome",null),pe([N.$lh],d.prototype,"tmpDir",null),pe([N.$lh],d.prototype,"cacheHome",null),pe([N.$lh],d.prototype,"stateResource",null),pe([N.$lh],d.prototype,"userRoamingDataHome",null),pe([N.$lh],d.prototype,"userDataSyncHome",null),pe([N.$lh],d.prototype,"sync",null),pe([N.$lh],d.prototype,"machineSettingsResource",null),pe([N.$lh],d.prototype,"workspaceStorageHome",null),pe([N.$lh],d.prototype,"localHistoryHome",null),pe([N.$lh],d.prototype,"keyboardLayoutResource",null),pe([N.$lh],d.prototype,"argvResource",null),pe([N.$lh],d.prototype,"isExtensionDevelopment",null),pe([N.$lh],d.prototype,"untitledWorkspacesHome",null),pe([N.$lh],d.prototype,"builtinExtensionsPath",null),pe([N.$lh],d.prototype,"extensionsPath",null),pe([N.$lh],d.prototype,"extensionDevelopmentLocationURI",null),pe([N.$lh],d.prototype,"extensionDevelopmentKind",null),pe([N.$lh],d.prototype,"extensionTestsLocationURI",null),pe([N.$lh],d.prototype,"debugExtensionHost",null),pe([N.$lh],d.prototype,"logLevel",null),pe([N.$lh],d.prototype,"extensionLogLevel",null),pe([N.$lh],d.prototype,"serviceMachineIdResource",null),pe([N.$lh],d.prototype,"disableTelemetry",null),pe([N.$lh],d.prototype,"disableWorkspaceTrust",null),pe([N.$lh],d.prototype,"useInMemorySecretStorage",null),pe([N.$lh],d.prototype,"policyFile",null);function P(b,l){return E(b["inspect-extensions"],b["inspect-brk-extensions"],5870,l,b.debugId,b.extensionEnvironment)}e.$lm=P;function E(b,l,$,y,w,c){const f=Number(l||b)||(y?null:$),m=f?!!l:!1;let k;if(c)try{k=JSON.parse(c)}catch{}return{port:f,break:m,debugId:w,env:k}}e.$mm=E}),function(){"use strict";function ie(e,I,N){function j(O,R){const S=L(O,R),d=[S];return e.isAbsolute(S)||d.unshift(N),e.resolve(...d)}function L(O,R){process.env.VSCODE_DEV&&(R="code-oss-dev");const S=process.env.VSCODE_PORTABLE;if(S)return e.join(S,"user-data");let d=process.env.VSCODE_APPDATA;if(d)return e.join(d,R);const P=O["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(d=process.env.APPDATA,!d){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");d=e.join(E,"AppData","Roaming")}break;case"darwin":d=e.join(I.homedir(),"Library","Application Support");break;case"linux":d=process.env.XDG_CONFIG_HOME||e.join(I.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(d,R)}return{getUserDataPath:j}}if(typeof define=="function")define(ae[180],ce([269,36,37]),function(e,I,N){return ie(e,I,N.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),I=require("os");module.exports=ie(e,I,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ae[181],ce([0,1,36,179,180]),function(ie,e,I,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pm=e.$om=e.$nm=void 0;class L extends N.$km{constructor(d,P){super(d,{homeDir:(0,I.homedir)(),tmpDir:(0,I.tmpdir)(),userDataDir:(0,j.getUserDataPath)(d,P.nameShort)},P)}}e.$nm=L;function O(S,d){return(0,N.$mm)(S["inspect-ptyhost"],S["inspect-brk-ptyhost"],5877,d,S.extensionEnvironment)}e.$om=O;function R(S,d){return(0,N.$mm)(S["inspect-sharedprocess"],S["inspect-brk-sharedprocess"],5879,d,S.extensionEnvironment)}e.$pm=R}),define(ae[182],ce([0,1,12,153]),function(ie,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=void 0;function j(O,R,S,d){try{L(O,R,S,d)}catch(P){O.error(P?.message??P)}return R}e.$Bp=j;function L(O,R,S,d){const P=(E,b,l)=>{const $=E[b];if((0,I.$zf)($)){const y=$,w=y.length;if(w>1&&y[0]==="%"&&y[w-1]==="%"){const c=y.substr(1,w-2);let u=S[c];u===void 0&&d&&(u=d[c]);const f=typeof u=="string"?u:u?.message,m=d?.[c],k=typeof m=="string"?m:m?.message;if(!f){k||O.warn(`[${R.name}]: ${(0,N.localize)(0,null,c)}`);return}if(l&&(b==="title"||b==="category")&&k&&k!==f){const s={value:f,original:k};E[b]=s}else E[b]=f}}else if((0,I.$Bf)($))for(const y in $)$.hasOwnProperty(y)&&(y==="commands"?P($,y,!0):P($,y,l));else if(Array.isArray($))for(let y=0;y<$.length;y++)P($,y,l)};for(const E in R)R.hasOwnProperty(E)&&P(R,E)}}),define(ae[183],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$09b=e.$99b=void 0;class I{constructor(L){this.a=L}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(L){return this.a.call("promptImportantExtensionsInstallNotification",[L])}promptWorkspaceRecommendations(L){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.$99b=I;class N{constructor(L){this.a=L}listen(L,O){throw new Error(`Event not found: ${O}`)}call(L,O,R){switch(O){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(R[0])}throw new Error(`Call not found: ${O}`)}}e.$09b=N}),define(ae[69],ce([0,1,19,89,157,54]),function(ie,e,I,N,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=void 0;const O=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function S(c){return c=c.trim(),c==="*"||O.test(c)}e.$Po=S;function d(c){if(!S(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const u=c.match(O);return u?{hasCaret:u[1]==="^",hasGreaterEquals:u[1]===">=",majorBase:u[2]==="x"?0:parseInt(u[2],10),majorMustEqual:u[2]!=="x",minorBase:u[4]==="x"?0:parseInt(u[4],10),minorMustEqual:u[4]!=="x",patchBase:u[6]==="x"?0:parseInt(u[6],10),patchMustEqual:u[6]!=="x",preRelease:u[8]||null}:null}e.$Qo=d;function P(c){if(!c)return null;const u=c.majorBase,f=c.majorMustEqual,m=c.minorBase;let k=c.minorMustEqual;const s=c.patchBase;let a=c.patchMustEqual;c.hasCaret&&(u===0||(k=!1),a=!1);let n=0;if(c.preRelease){const i=R.exec(c.preRelease);if(i){const[,t,r,o]=i;n=Date.UTC(Number(t),Number(r)-1,Number(o))}}return{majorBase:u,majorMustEqual:f,minorBase:m,minorMustEqual:k,patchBase:s,patchMustEqual:a,isMinimum:c.hasGreaterEquals,notBefore:n}}e.$Ro=P;function E(c,u,f){let m;typeof c=="string"?m=P(d(c)):m=c;let k;u instanceof Date?k=u.getTime():typeof u=="string"&&(k=new Date(u).getTime());let s;if(typeof f=="string"?s=P(d(f)):s=f,!m||!s)return!1;const a=m.majorBase,n=m.minorBase,i=m.patchBase;let t=s.majorBase,r=s.minorBase,o=s.patchBase;const v=s.notBefore;let p=s.majorMustEqual,h=s.minorMustEqual,g=s.patchMustEqual;return s.isMinimum?a>t?!0:a<t?!1:n>r?!0:n<r||k&&k<v?!1:i>=o:(a===1&&t===0&&(!p||!h||!g)&&(t=1,r=0,o=0,p=!0,h=!1,g=!1),a<t?!1:a>t?!p:n<r?!1:n>r?!h:i<o?!1:i>o?!g:!(k&&k<v))}e.$So=E;function b(c,u,f,m,k){const s=[];if(typeof m.publisher<"u"&&typeof m.publisher!="string")return s.push([N.default.Error,j.localize(0,null)]),s;if(typeof m.name!="string")return s.push([N.default.Error,j.localize(1,null,"name")]),s;if(typeof m.version!="string")return s.push([N.default.Error,j.localize(2,null,"version")]),s;if(!m.engines)return s.push([N.default.Error,j.localize(3,null,"engines")]),s;if(typeof m.engines.vscode!="string")return s.push([N.default.Error,j.localize(4,null,"engines.vscode")]),s;if(typeof m.extensionDependencies<"u"&&!w(m.extensionDependencies))return s.push([N.default.Error,j.localize(5,null,"extensionDependencies")]),s;if(typeof m.activationEvents<"u"){if(!w(m.activationEvents))return s.push([N.default.Error,j.localize(6,null,"activationEvents")]),s;if(typeof m.main>"u"&&typeof m.browser>"u")return s.push([N.default.Error,j.localize(7,null,"activationEvents","main","browser")]),s}if(typeof m.extensionKind<"u"&&typeof m.main>"u"&&s.push([N.default.Warning,j.localize(8,null,"extensionKind")]),typeof m.main<"u"){if(typeof m.main!="string")return s.push([N.default.Error,j.localize(9,null,"main")]),s;{const i=(0,I.$wg)(f,m.main);(0,I.$qg)(i,f)||s.push([N.default.Warning,j.localize(10,null,i.path,f.path)])}}if(typeof m.browser<"u"){if(typeof m.browser!="string")return s.push([N.default.Error,j.localize(11,null,"browser")]),s;{const i=(0,I.$wg)(f,m.browser);(0,I.$qg)(i,f)||s.push([N.default.Warning,j.localize(12,null,i.path,f.path)])}}if(!L.valid(m.version))return s.push([N.default.Error,j.localize(13,null)]),s;const a=[];if(!l(c,u,m,k,a))for(const i of a)s.push([N.default.Error,i]);return s}e.$To=b;function l(c,u,f,m,k){return m||typeof f.main>"u"&&typeof f.browser>"u"?!0:y(c,u,f.engines.vscode,k)}e.$Uo=l;function $(c,u,f){return c==="*"||y(u,f,c)}e.$Vo=$;function y(c,u,f,m=[]){const k=P(d(f));if(!k)return m.push(j.localize(14,null,f)),!1;if(k.majorBase===0){if(!k.majorMustEqual||!k.minorMustEqual)return m.push(j.localize(15,null,f)),!1}else if(!k.majorMustEqual)return m.push(j.localize(16,null,f)),!1;return E(c,u,k)?!0:(m.push(j.localize(17,null,c,f)),!1)}function w(c){if(!Array.isArray(c))return!1;for(let u=0,f=c.length;u<f;u++)if(typeof c[u]!="string")return!1;return!0}}),define(ae[43],ce([0,1,15,32]),function(ie,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dp=void 0;async function j(L,O,R){let S=R&&R.get("storage.serviceMachineId",-1)||null;if(S)return S;try{const P=(await O.readFile(L.serviceMachineIdResource)).value.toString();S=(0,N.$eg)(P)?P:null}catch{S=null}if(!S){S=(0,N.$fg)();try{await O.writeFile(L.serviceMachineIdResource,I.$ce.fromString(S))}catch{}}return R?.store("storage.serviceMachineId",S,-1,1),S}e.$dp=j}),define(ae[70],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qh=void 0;class I{constructor(j,L=[],O=!1){this.ctor=j,this.staticArguments=L,this.supportsDelayedInstantiation=O}}e.$Qh=I}),define(ae[184],ce([0,1,70]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Br=e.$Ar=e.InstantiationType=void 0;const N=[];var j;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(j||(e.InstantiationType=j={}));function L(R,S,d){S instanceof I.$Qh||(S=new I.$Qh(S,[],!!d)),N.push([R,S])}e.$Ar=L;function O(){return N}e.$Br=O}),define(ae[185],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gq=e.$fq=void 0;class I{constructor(L,O){this.key=L,this.data=O,this.incoming=new Map,this.outgoing=new Map}}e.$fq=I;class N{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const O of this.a.values())O.outgoing.size===0&&L.push(O);return L}insertEdge(L,O){const R=this.lookupOrInsertNode(L),S=this.lookupOrInsertNode(O);R.outgoing.set(S.key,S),S.incoming.set(R.key,R)}removeNode(L){const O=this.b(L);this.a.delete(O);for(const R of this.a.values())R.outgoing.delete(O),R.incoming.delete(O)}lookupOrInsertNode(L){const O=this.b(L);let R=this.a.get(O);return R||(R=new I(O,L),this.a.set(O,R)),R}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[O,R]of this.a)L.push(`${O}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,O]of this.a){const R=new Set([L]),S=this.c(O,R);if(S)return S}}c(L,O){for(const[R,S]of L.outgoing){if(O.has(R))return[...O,R].join(" -> ");O.add(R);const d=this.c(S,O);if(d)return d;O.delete(R)}}}e.$gq=N}),define(ae[4],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uh=e.$Th=e.$Sh=e._util=void 0;var I;(function(O){O.serviceIds=new Map,O.DI_TARGET="$di$target",O.DI_DEPENDENCIES="$di$dependencies";function R(S){return S[O.DI_DEPENDENCIES]||[]}O.getServiceDependencies=R})(I||(e._util=I={})),e.$Sh=j("instantiationService");function N(O,R,S){R[I.DI_TARGET]===R?R[I.DI_DEPENDENCIES].push({id:O,index:S}):(R[I.DI_DEPENDENCIES]=[{id:O,index:S}],R[I.DI_TARGET]=R)}function j(O){if(I.serviceIds.has(O))return I.serviceIds.get(O);const R=function(S,d,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(R,S,P)};return R.toString=()=>O,I.serviceIds.set(O,R),R}e.$Th=j;function L(O){return O}e.$Uh=L}),define(ae[186],ce([0,1,4]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F9b=void 0,e.$F9b=(0,I.$Th)("checksumService")}),define(ae[20],ce([0,1,12,10,4]),function(ie,e,I,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.ConfigurationTarget=e.$pi=e.$oi=e.$ni=void 0,e.$ni=(0,j.$Th)("configurationService");function L(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof N.URI)}e.$oi=L;function O(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof N.URI)}e.$pi=O;var R;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(R||(e.ConfigurationTarget=R={}));function S(c){switch(c){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$qi=S;function d(c){return c.applicationValue!==void 0||c.userValue!==void 0||c.userLocalValue!==void 0||c.userRemoteValue!==void 0||c.workspaceValue!==void 0||c.workspaceFolderValue!==void 0}e.$ri=d;function P(c,u){const f=Object.create(null);for(const m in c)E(f,m,c[m],u);return f}e.$si=P;function E(c,u,f,m){const k=u.split("."),s=k.pop();let a=c;for(let n=0;n<k.length;n++){const i=k[n];let t=a[i];switch(typeof t){case"undefined":t=a[i]=Object.create(null);break;case"object":break;default:m(`Ignoring ${u} as ${k.slice(0,n+1).join(".")} is ${JSON.stringify(t)}`);return}a=t}if(typeof a=="object"&&a!==null)try{a[s]=f}catch{m(`Ignoring ${u} as ${k.join(".")} is ${JSON.stringify(a)}`)}else m(`Ignoring ${u} as ${k.join(".")} is ${JSON.stringify(a)}`)}e.$ti=E;function b(c,u){const f=u.split(".");l(c,f)}e.$ui=b;function l(c,u){const f=u.shift();if(u.length===0){delete c[f];return}if(Object.keys(c).indexOf(f)!==-1){const m=c[f];typeof m=="object"&&!Array.isArray(m)&&(l(m,u),Object.keys(m).length===0&&delete c[f])}}function $(c,u,f){function m(a,n){let i=a;for(const t of n){if(typeof i!="object"||i===null)return;i=i[t]}return i}const k=u.split("."),s=m(c,k);return typeof s>"u"?f:s}e.$vi=$;function y(c,u,f){Object.keys(u).forEach(m=>{m!=="__proto__"&&(m in c?I.$Bf(c[m])&&I.$Bf(u[m])?y(c[m],u[m],f):f&&(c[m]=u[m]):c[m]=u[m])})}e.$wi=y;function w(c){return c.replace(/[\[\]]/g,"")}e.$xi=w}),define(ae[94],ce([0,1,5,27,178,4,149,7]),function(ie,e,I,N,j,L,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.ContextKeyExprType=e.$Pi=void 0;const S=new Map;S.set("false",!1),S.set("true",!0),S.set("isMac",I.$k),S.set("isLinux",I.$l),S.set("isWindows",I.$j),S.set("isWeb",I.$p),S.set("isMacNative",I.$k&&!I.$p),S.set("isEdge",I.$H),S.set("isFirefox",I.$F),S.set("isChrome",I.$E),S.set("isSafari",I.$G);function d(q,C){if(S.get(q)!==void 0)throw(0,R.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");S.set(q,C)}e.$Pi=d;const P=Object.prototype.hasOwnProperty;var E;(function(q){q[q.False=0]="False",q[q.True=1]="True",q[q.Defined=2]="Defined",q[q.Not=3]="Not",q[q.Equals=4]="Equals",q[q.NotEquals=5]="NotEquals",q[q.And=6]="And",q[q.Regex=7]="Regex",q[q.NotRegex=8]="NotRegex",q[q.Or=9]="Or",q[q.In=10]="In",q[q.NotIn=11]="NotIn",q[q.Greater=12]="Greater",q[q.GreaterEquals=13]="GreaterEquals",q[q.Smaller=14]="Smaller",q[q.SmallerEquals=15]="SmallerEquals"})(E||(e.ContextKeyExprType=E={}));const b={regexParsingWithErrorRecovery:!0},l=(0,O.localize)(0,null),$=(0,O.localize)(1,null),y=(0,O.localize)(2,null),w=(0,O.localize)(3,null),c=(0,O.localize)(4,null),u=(0,O.localize)(5,null),f=(0,O.localize)(6,null),m=(0,O.localize)(7,null);class k{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(C=b){this.k=C,this.d=new j.$Oi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(C){if(C===""){this.h.push({message:l,offset:0,lexeme:"",additionalInfo:$});return}this.f=this.d.reset(C).scan(),this.g=0,this.h=[];try{const A=this.l();if(!this.E()){const J=this.D(),F=J.type===17?u:void 0;throw this.h.push({message:c,offset:J.offset,lexeme:j.$Oi.getLexeme(J),additionalInfo:F}),k.c}return A}catch(A){if(A!==k.c)throw A;return}}l(){return this.m()}m(){const C=[this.o()];for(;this.y(16);){const A=this.o();C.push(A)}return C.length===1?C[0]:s.or(...C)}o(){const C=[this.s()];for(;this.y(15);){const A=this.s();C.push(A)}return C.length===1?C[0]:s.and(...C)}s(){if(this.y(2)){const C=this.D();switch(C.type){case 11:return this.z(),t.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const A=this.l();return this.A(1,w),A?.negate()}case 17:return this.z(),D.create(C.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",C)}}return this.t()}t(){const C=this.D();switch(C.type){case 11:return this.z(),s.true();case 12:return this.z(),s.false();case 0:{this.z();const A=this.l();return this.A(1,w),A}case 17:{const A=C.lexeme;if(this.z(),this.y(9)){const F=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),F.type!==10)throw this.B("REGEX",F);const U=F.lexeme,W=U.lastIndexOf("/"),te=W===U.length-1?void 0:this.w(U.substring(W+1));let se;try{se=new RegExp(U.substring(1,W),te)}catch{throw this.B("REGEX",F)}return K.create(A,se)}switch(F.type){case 10:case 19:{const U=[F.lexeme];this.z();let W=this.D(),te=0;for(let fe=0;fe<F.lexeme.length;fe++)F.lexeme.charCodeAt(fe)===40?te++:F.lexeme.charCodeAt(fe)===41&&te--;for(;!this.E()&&W.type!==15&&W.type!==16;){switch(W.type){case 0:te++;break;case 1:te--;break;case 10:case 18:for(let fe=0;fe<W.lexeme.length;fe++)W.lexeme.charCodeAt(fe)===40?te++:F.lexeme.charCodeAt(fe)===41&&te--}if(te<0)break;U.push(j.$Oi.getLexeme(W)),this.z(),W=this.D()}const se=U.join(""),ue=se.lastIndexOf("/"),le=ue===se.length-1?void 0:this.w(se.substring(ue+1));let $e;try{$e=new RegExp(se.substring(1,ue),le)}catch{throw this.B("REGEX",F)}return s.regex(A,$e)}case 18:{const U=F.lexeme;this.z();let W=null;if(!(0,N.$Ce)(U)){const te=U.indexOf("/"),se=U.lastIndexOf("/");if(te!==se&&te>=0){const ue=U.slice(te+1,se),le=U[se+1]==="i"?"i":"";try{W=new RegExp(ue,le)}catch{throw this.B("REGEX",F)}}}if(W===null)throw this.B("REGEX",F);return K.create(A,W)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,y);const F=this.u();return s.notIn(A,F)}switch(this.D().type){case 3:{this.z();const F=this.u();if(this.x().type===18)return s.equals(A,F);switch(F){case"true":return s.has(A);case"false":return s.not(A);default:return s.equals(A,F)}}case 4:{this.z();const F=this.u();if(this.x().type===18)return s.notEquals(A,F);switch(F){case"true":return s.not(A);case"false":return s.has(A);default:return s.notEquals(A,F)}}case 5:return this.z(),B.create(A,this.u());case 6:return this.z(),Z.create(A,this.u());case 7:return this.z(),M.create(A,this.u());case 8:return this.z(),z.create(A,this.u());case 13:return this.z(),s.in(A,this.u());default:return s.has(A)}}case 20:throw this.h.push({message:f,offset:C.offset,lexeme:"",additionalInfo:m}),k.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const C=this.D();switch(C.type){case 17:case 18:return this.z(),C.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(C){return C.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(C){return this.C(C)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(C,A){if(this.C(C))return this.z();throw this.B(A,this.D())}B(C,A,J){const F=(0,O.localize)(8,null,C,j.$Oi.getLexeme(A)),U=A.offset,W=j.$Oi.getLexeme(A);return this.h.push({message:F,offset:U,lexeme:W,additionalInfo:J}),k.c}C(C){return this.D().type===C}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Qi=k;class s{static false(){return t.INSTANCE}static true(){return r.INSTANCE}static has(C){return o.create(C)}static equals(C,A){return v.create(C,A)}static notEquals(C,A){return g.create(C,A)}static regex(C,A){return K.create(C,A)}static in(C,A){return p.create(C,A)}static notIn(C,A){return h.create(C,A)}static not(C){return D.create(C)}static and(...C){return Y.create(C,null,!0)}static or(...C){return G.create(C,null,!0)}static greater(C,A){return M.create(C,A)}static greaterEquals(C,A){return z.create(C,A)}static smaller(C,A){return B.create(C,A)}static smallerEquals(C,A){return Z.create(C,A)}static{this.c=new k({regexParsingWithErrorRecovery:!1})}static deserialize(C){return C==null?void 0:this.c.parse(C)}}e.$Ri=s;function a(q){const C=new k({regexParsingWithErrorRecovery:!1});return q.map(A=>(C.parse(A),C.lexingErrors.length>0?C.lexingErrors.map(J=>({errorMessage:J.additionalInfo?(0,O.localize)(9,null,J.additionalInfo):(0,O.localize)(10,null),offset:J.offset,length:J.lexeme.length})):C.parsingErrors.length>0?C.parsingErrors.map(J=>({errorMessage:J.additionalInfo?`${J.message}. ${J.additionalInfo}`:J.message,offset:J.offset,length:J.lexeme.length})):[]))}e.$Si=a;function n(q,C){const A=q?q.substituteConstants():void 0,J=C?C.substituteConstants():void 0;return!A&&!J?!0:!A||!J?!1:A.equals(J)}e.$Ti=n;function i(q,C){return q.cmp(C)}class t{static{this.INSTANCE=new t}constructor(){this.type=0}cmp(C){return this.type-C.type}equals(C){return C.type===this.type}substituteConstants(){return this}evaluate(C){return!1}serialize(){return"false"}keys(){return[]}map(C){return this}negate(){return r.INSTANCE}}e.$Ui=t;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(C){return this.type-C.type}equals(C){return C.type===this.type}substituteConstants(){return this}evaluate(C){return!0}serialize(){return"true"}keys(){return[]}map(C){return this}negate(){return t.INSTANCE}}e.$Vi=r;class o{static create(C,A=null){const J=S.get(C);return typeof J=="boolean"?J?r.INSTANCE:t.INSTANCE:new o(C,A)}constructor(C,A){this.key=C,this.c=A,this.type=2}cmp(C){return C.type!==this.type?this.type-C.type:ee(this.key,C.key)}equals(C){return C.type===this.type?this.key===C.key:!1}substituteConstants(){const C=S.get(this.key);return typeof C=="boolean"?C?r.INSTANCE:t.INSTANCE:this}evaluate(C){return!!C.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(C){return C.mapDefined(this.key)}negate(){return this.c||(this.c=D.create(this.key,this)),this.c}}e.$Wi=o;class v{static create(C,A,J=null){if(typeof A=="boolean")return A?o.create(C,J):D.create(C,J);const F=S.get(C);return typeof F=="boolean"?A===(F?"true":"false")?r.INSTANCE:t.INSTANCE:new v(C,A,J)}constructor(C,A,J){this.c=C,this.d=A,this.f=J,this.type=4}cmp(C){return C.type!==this.type?this.type-C.type:ne(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){const C=S.get(this.c);if(typeof C=="boolean"){const A=C?"true":"false";return this.d===A?r.INSTANCE:t.INSTANCE}return this}evaluate(C){return C.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(C){return C.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=g.create(this.c,this.d,this)),this.f}}e.$Xi=v;class p{static create(C,A){return new p(C,A)}constructor(C,A){this.d=C,this.f=A,this.type=10,this.c=null}cmp(C){return C.type!==this.type?this.type-C.type:ne(this.d,this.f,C.d,C.f)}equals(C){return C.type===this.type?this.d===C.d&&this.f===C.f:!1}substituteConstants(){return this}evaluate(C){const A=C.getValue(this.f),J=C.getValue(this.d);return Array.isArray(A)?A.includes(J):typeof J=="string"&&typeof A=="object"&&A!==null?P.call(A,J):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(C){return C.mapIn(this.d,this.f)}negate(){return this.c||(this.c=h.create(this.d,this.f)),this.c}}e.$Yi=p;class h{static create(C,A){return new h(C,A)}constructor(C,A){this.d=C,this.f=A,this.type=11,this.c=p.create(C,A)}cmp(C){return C.type!==this.type?this.type-C.type:this.c.cmp(C.c)}equals(C){return C.type===this.type?this.c.equals(C.c):!1}substituteConstants(){return this}evaluate(C){return!this.c.evaluate(C)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(C){return C.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Zi=h;class g{static create(C,A,J=null){if(typeof A=="boolean")return A?D.create(C,J):o.create(C,J);const F=S.get(C);return typeof F=="boolean"?A===(F?"true":"false")?t.INSTANCE:r.INSTANCE:new g(C,A,J)}constructor(C,A,J){this.c=C,this.d=A,this.f=J,this.type=5}cmp(C){return C.type!==this.type?this.type-C.type:ne(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){const C=S.get(this.c);if(typeof C=="boolean"){const A=C?"true":"false";return this.d===A?t.INSTANCE:r.INSTANCE}return this}evaluate(C){return C.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(C){return C.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$1i=g;class D{static create(C,A=null){const J=S.get(C);return typeof J=="boolean"?J?t.INSTANCE:r.INSTANCE:new D(C,A)}constructor(C,A){this.c=C,this.d=A,this.type=3}cmp(C){return C.type!==this.type?this.type-C.type:ee(this.c,C.c)}equals(C){return C.type===this.type?this.c===C.c:!1}substituteConstants(){const C=S.get(this.c);return typeof C=="boolean"?C?t.INSTANCE:r.INSTANCE:this}evaluate(C){return!C.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(C){return C.mapNot(this.c)}negate(){return this.d||(this.d=o.create(this.c,this)),this.d}}e.$2i=D;function T(q,C){if(typeof q=="string"){const A=parseFloat(q);isNaN(A)||(q=A)}return typeof q=="string"||typeof q=="number"?C(q):t.INSTANCE}class M{static create(C,A,J=null){return T(A,F=>new M(C,F,J))}constructor(C,A,J){this.c=C,this.d=A,this.f=J,this.type=12}cmp(C){return C.type!==this.type?this.type-C.type:ne(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){return this}evaluate(C){return typeof this.d=="string"?!1:parseFloat(C.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(C){return C.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=Z.create(this.c,this.d,this)),this.f}}e.$3i=M;class z{static create(C,A,J=null){return T(A,F=>new z(C,F,J))}constructor(C,A,J){this.c=C,this.d=A,this.f=J,this.type=13}cmp(C){return C.type!==this.type?this.type-C.type:ne(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){return this}evaluate(C){return typeof this.d=="string"?!1:parseFloat(C.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(C){return C.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=B.create(this.c,this.d,this)),this.f}}e.$4i=z;class B{static create(C,A,J=null){return T(A,F=>new B(C,F,J))}constructor(C,A,J){this.c=C,this.d=A,this.f=J,this.type=14}cmp(C){return C.type!==this.type?this.type-C.type:ne(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){return this}evaluate(C){return typeof this.d=="string"?!1:parseFloat(C.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(C){return C.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$5i=B;class Z{static create(C,A,J=null){return T(A,F=>new Z(C,F,J))}constructor(C,A,J){this.c=C,this.d=A,this.f=J,this.type=15}cmp(C){return C.type!==this.type?this.type-C.type:ne(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){return this}evaluate(C){return typeof this.d=="string"?!1:parseFloat(C.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(C){return C.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$6i=Z;class K{static create(C,A){return new K(C,A)}constructor(C,A){this.d=C,this.f=A,this.type=7,this.c=null}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.d<C.d)return-1;if(this.d>C.d)return 1;const A=this.f?this.f.source:"",J=C.f?C.f.source:"";return A<J?-1:A>J?1:0}equals(C){if(C.type===this.type){const A=this.f?this.f.source:"",J=C.f?C.f.source:"";return this.d===C.d&&A===J}return!1}substituteConstants(){return this}evaluate(C){const A=C.getValue(this.d);return this.f?this.f.test(A):!1}serialize(){const C=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${C}`}keys(){return[this.d]}map(C){return C.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=x.create(this)),this.c}}e.$7i=K;class x{static create(C){return new x(C)}constructor(C){this.c=C,this.type=8}cmp(C){return C.type!==this.type?this.type-C.type:this.c.cmp(C.c)}equals(C){return C.type===this.type?this.c.equals(C.c):!1}substituteConstants(){return this}evaluate(C){return!this.c.evaluate(C)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(C){return new x(this.c.map(C))}negate(){return this.c}}e.$8i=x;function H(q){let C=null;for(let A=0,J=q.length;A<J;A++){const F=q[A].substituteConstants();if(q[A]!==F&&C===null){C=[];for(let U=0;U<A;U++)C[U]=q[U]}C!==null&&(C[A]=F)}return C===null?q:C}class Y{static create(C,A,J){return Y.d(C,A,J)}constructor(C,A){this.expr=C,this.c=A,this.type=6}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.expr.length<C.expr.length)return-1;if(this.expr.length>C.expr.length)return 1;for(let A=0,J=this.expr.length;A<J;A++){const F=i(this.expr[A],C.expr[A]);if(F!==0)return F}return 0}equals(C){if(C.type===this.type){if(this.expr.length!==C.expr.length)return!1;for(let A=0,J=this.expr.length;A<J;A++)if(!this.expr[A].equals(C.expr[A]))return!1;return!0}return!1}substituteConstants(){const C=H(this.expr);return C===this.expr?this:Y.create(C,this.c,!1)}evaluate(C){for(let A=0,J=this.expr.length;A<J;A++)if(!this.expr[A].evaluate(C))return!1;return!0}static d(C,A,J){const F=[];let U=!1;for(const W of C)if(W){if(W.type===1){U=!0;continue}if(W.type===0)return t.INSTANCE;if(W.type===6){F.push(...W.expr);continue}F.push(W)}if(F.length===0&&U)return r.INSTANCE;if(F.length!==0){if(F.length===1)return F[0];F.sort(i);for(let W=1;W<F.length;W++)F[W-1].equals(F[W])&&(F.splice(W,1),W--);if(F.length===1)return F[0];for(;F.length>1;){const W=F[F.length-1];if(W.type!==9)break;F.pop();const te=F.pop(),se=F.length===0,ue=G.create(W.expr.map(le=>Y.create([le,te],null,J)),null,se);ue&&(F.push(ue),F.sort(i))}if(F.length===1)return F[0];if(J){for(let W=0;W<F.length;W++)for(let te=W+1;te<F.length;te++)if(F[W].negate().equals(F[te]))return t.INSTANCE;if(F.length===1)return F[0]}return new Y(F,A)}}serialize(){return this.expr.map(C=>C.serialize()).join(" && ")}keys(){const C=[];for(const A of this.expr)C.push(...A.keys());return C}map(C){return new Y(this.expr.map(A=>A.map(C)),null)}negate(){if(!this.c){const C=[];for(const A of this.expr)C.push(A.negate());this.c=G.create(C,this,!0)}return this.c}}e.$9i=Y;class G{static create(C,A,J){return G.d(C,A,J)}constructor(C,A){this.expr=C,this.c=A,this.type=9}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.expr.length<C.expr.length)return-1;if(this.expr.length>C.expr.length)return 1;for(let A=0,J=this.expr.length;A<J;A++){const F=i(this.expr[A],C.expr[A]);if(F!==0)return F}return 0}equals(C){if(C.type===this.type){if(this.expr.length!==C.expr.length)return!1;for(let A=0,J=this.expr.length;A<J;A++)if(!this.expr[A].equals(C.expr[A]))return!1;return!0}return!1}substituteConstants(){const C=H(this.expr);return C===this.expr?this:G.create(C,this.c,!1)}evaluate(C){for(let A=0,J=this.expr.length;A<J;A++)if(this.expr[A].evaluate(C))return!0;return!1}static d(C,A,J){let F=[],U=!1;if(C){for(let W=0,te=C.length;W<te;W++){const se=C[W];if(se){if(se.type===0){U=!0;continue}if(se.type===1)return r.INSTANCE;if(se.type===9){F=F.concat(se.expr);continue}F.push(se)}}if(F.length===0&&U)return t.INSTANCE;F.sort(i)}if(F.length!==0){if(F.length===1)return F[0];for(let W=1;W<F.length;W++)F[W-1].equals(F[W])&&(F.splice(W,1),W--);if(F.length===1)return F[0];if(J){for(let W=0;W<F.length;W++)for(let te=W+1;te<F.length;te++)if(F[W].negate().equals(F[te]))return r.INSTANCE;if(F.length===1)return F[0]}return new G(F,A)}}serialize(){return this.expr.map(C=>C.serialize()).join(" || ")}keys(){const C=[];for(const A of this.expr)C.push(...A.keys());return C}map(C){return new G(this.expr.map(A=>A.map(C)),null)}negate(){if(!this.c){const C=[];for(const A of this.expr)C.push(A.negate());for(;C.length>1;){const A=C.shift(),J=C.shift(),F=[];for(const U of Q(A))for(const W of Q(J))F.push(Y.create([U,W],null,!1));C.unshift(G.create(F,null,!1))}this.c=G.create(C,this,!0)}return this.c}}e.$0i=G;class V extends o{static{this.d=[]}static all(){return V.d.values()}constructor(C,A,J){super(C,null),this.f=A,typeof J=="object"?V.d.push({...J,key:C}):J!==!0&&V.d.push({key:C,description:J,type:A!=null?typeof A:void 0})}bindTo(C){return C.createKey(this.key,this.f)}getValue(C){return C.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(C){return v.create(this.key,C)}notEqualsTo(C){return g.create(this.key,C)}}e.$$i=V,e.$_i=(0,L.$Th)("contextKeyService");function ee(q,C){return q<C?-1:q>C?1:0}function ne(q,C,A,J){return q<A?-1:q>A?1:C<J?-1:C>J?1:0}function _(q,C){if(q.type===0||C.type===1)return!0;if(q.type===9)return C.type===9?re(q.expr,C.expr):!1;if(C.type===9){for(const A of C.expr)if(_(q,A))return!0;return!1}if(q.type===6){if(C.type===6)return re(C.expr,q.expr);for(const A of q.expr)if(_(A,C))return!0;return!1}return q.equals(C)}e.$aj=_;function re(q,C){let A=0,J=0;for(;A<q.length&&J<C.length;){const F=q[A].cmp(C[J]);if(F<0)return!1;F===0&&A++,J++}return A===q.length}function Q(q){return q.type===9?q.expr:[q]}}),define(ae[95],ce([0,1,4]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wm=e.$vm=e.$um=e.ID=void 0,e.ID="diagnosticsService",e.$um=(0,I.$Th)(e.ID);function N(L){return!!L.hostName&&!!L.errorMessage}e.$vm=N;class j{async getPerformanceInfo(O,R){return{}}async getSystemInfo(O,R){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(O,R){return""}async getWorkspaceFileExtensions(O){return{extensions:[]}}async reportWorkspaceStats(O){}}e.$wm=j}),define(ae[96],ce([0,1,4]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sn=void 0,e.$Sn=(0,I.$Th)("downloadService")}),define(ae[14],ce([0,1,4]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=e.$1h=void 0,e.$1h=(0,I.$Th)("environmentService"),e.$2h=(0,I.$Uh)(e.$1h)}),define(ae[29],ce([0,1,152,4]),function(ie,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$bo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=void 0,e.$2n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$3n=new RegExp(e.$2n),e.$4n="__web_extension",e.$5n="skipWalkthrough",e.$6n="extensionsSync",e.$7n="dependecyOrPackExtensionInstall";function j(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$8n=j;function L(c){switch(c){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$9n=L;function O(c,u){switch(c){case 3:return u==="x64"?"win32-x64":u==="arm64"?"win32-arm64":"unknown";case 2:return u==="x64"?"linux-x64":u==="arm64"?"linux-arm64":u==="arm"?"linux-armhf":"unknown";case"alpine":return u==="x64"?"alpine-x64":u==="arm64"?"alpine-arm64":"unknown";case 1:return u==="x64"?"darwin-x64":u==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$0n=O;function R(c,u){return u==="web"&&!c.includes("web")}e.$$n=R;function S(c,u,f){return R(u,f)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===f}e.$_n=S;function d(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.$ao=d;var P;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(P||(e.SortBy=P={}));var E;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(E||(e.SortOrder=E={}));var b;(function(c){c.Install="install",c.Uninstall="uninstall"})(b||(e.StatisticType=b={}));var l;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(l||(e.InstallOperation=l={})),e.$bo=(0,N.$Th)("extensionGalleryService");var $;(function(c){c.Unsupported="Unsupported",c.Deprecated="Deprecated",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Signature="Signature",c.Internal="Internal"})($||(e.ExtensionManagementErrorCode=$={}));var y;(function(c){c.UnknownError="UnknownError",c.PackageIsInvalidZip="PackageIsInvalidZip",c.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(y||(e.ExtensionSignaturetErrorCode=y={}));class w extends Error{constructor(u,f){super(u),this.code=f,this.name=f}}e.$co=w,e.$do=(0,N.$Th)("extensionManagementService"),e.$eo="extensionsIdentifiers/disabled",e.$fo="extensionsIdentifiers/enabled",e.$go=(0,N.$Th)("IGlobalExtensionEnablementService"),e.$ho=(0,N.$Th)("IExtensionTipsService"),e.$io=(0,I.localize)(0,null),e.$jo={value:e.$io,original:"Extensions"},e.$ko={value:(0,I.localize)(1,null),original:"Preferences"}}),define(ae[187],ce([0,1,3,2,30,10,92,29]),function(ie,e,I,N,j,L,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$np=e.$mp=e.$lp=void 0;function S(w,c){return w?L.URI.revive(c?c.transformIncoming(w):w):void 0}function d(w,c){return c?c.transformOutgoingURI(w):w}function P(w,c){c=c||O.$Qm;const u=w.manifest;return{...(0,O.$Tm)({...w,manifest:void 0},c),manifest:u}}function E(w,c){return w?.profileLocation?(0,O.$Tm)(w,c??O.$Qm):w}function b(w,c){return c?(0,j.$an)(w,u=>u instanceof L.URI?c.transformOutgoingURI(u):void 0):w}class l{constructor(c,u){this.a=c,this.b=u,this.onInstallExtension=I.Event.buffer(c.onInstallExtension,!0),this.onDidInstallExtensions=I.Event.buffer(c.onDidInstallExtensions,!0),this.onUninstallExtension=I.Event.buffer(c.onUninstallExtension,!0),this.onDidUninstallExtension=I.Event.buffer(c.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=I.Event.buffer(c.onDidUpdateExtensionMetadata,!0)}listen(c,u){const f=this.b(c);switch(u){case"onInstallExtension":return I.Event.map(this.onInstallExtension,m=>({...m,profileLocation:m.profileLocation?d(m.profileLocation,f):m.profileLocation}));case"onDidInstallExtensions":return I.Event.map(this.onDidInstallExtensions,m=>m.map(k=>({...k,local:k.local?b(k.local,f):k.local,profileLocation:k.profileLocation?d(k.profileLocation,f):k.profileLocation})));case"onUninstallExtension":return I.Event.map(this.onUninstallExtension,m=>({...m,profileLocation:m.profileLocation?d(m.profileLocation,f):m.profileLocation}));case"onDidUninstallExtension":return I.Event.map(this.onDidUninstallExtension,m=>({...m,profileLocation:m.profileLocation?d(m.profileLocation,f):m.profileLocation}));case"onDidUpdateExtensionMetadata":return I.Event.map(this.onDidUpdateExtensionMetadata,m=>b(m,f))}throw new Error("Invalid listen")}async call(c,u,f){const m=this.b(c);switch(u){case"zip":{const k=P(f[0],m),s=await this.a.zip(k);return d(s,m)}case"unzip":return this.a.unzip(S(f[0],m));case"install":return this.a.install(S(f[0],m),E(f[1],m));case"installFromLocation":return this.a.installFromLocation(S(f[0],m),S(f[1],m));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(f[0],S(f[1],m),S(f[2],m));case"getManifest":return this.a.getManifest(S(f[0],m));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(f[0]);case"installFromGallery":return this.a.installFromGallery(f[0],E(f[1],m));case"installGalleryExtensions":{const k=f[0];return this.a.installGalleryExtensions(k.map(({extension:s,options:a})=>({extension:s,options:E(a,m)??{}})))}case"uninstall":return this.a.uninstall(P(f[0],m),E(f[1],m));case"reinstallFromGallery":return this.a.reinstallFromGallery(P(f[0],m));case"getInstalled":return(await this.a.getInstalled(f[0],S(f[1],m))).map(s=>b(s,m));case"toggleAppliationScope":{const k=await this.a.toggleAppliationScope(P(f[0],m),S(f[1],m));return b(k,m)}case"copyExtensions":return this.a.copyExtensions(S(f[0],m),S(f[1],m));case"updateMetadata":{const k=await this.a.updateMetadata(P(f[0],m),f[1],S(f[2],m));return b(k,m)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(f[0],f[1],f[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$lp=l;class $ extends N.$Rc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(c){super(),this.m=c,this.c=this.B(new I.$Od),this.f=this.B(new I.$Od),this.g=this.B(new I.$Od),this.h=this.B(new I.$Od),this.j=this.B(new I.$Od),this.B(this.m.listen("onInstallExtension")(u=>this.n(this.c,{...u,source:this.r(u.source)?L.URI.revive(u.source):u.source,profileLocation:L.URI.revive(u.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(u=>this.n(this.f,u.map(f=>({...f,local:f.local?P(f.local,null):f.local,source:this.r(f.source)?L.URI.revive(f.source):f.source,profileLocation:L.URI.revive(f.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(u=>this.n(this.g,{...u,profileLocation:L.URI.revive(u.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(u=>this.n(this.h,{...u,profileLocation:L.URI.revive(u.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(u=>this.j.fire(P(u,null))))}n(c,u){c.fire(u)}r(c){return c?typeof c.path=="string"&&typeof c.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(c){const u=await this.getTargetPlatform();return c.allTargetPlatforms.some(f=>(0,R.$_n)(f,c.allTargetPlatforms,u))}zip(c){return Promise.resolve(this.m.call("zip",[c]).then(u=>L.URI.revive(u)))}unzip(c){return Promise.resolve(this.m.call("unzip",[c]))}install(c,u){return Promise.resolve(this.m.call("install",[c,u])).then(f=>P(f,null))}installFromLocation(c,u){return Promise.resolve(this.m.call("installFromLocation",[c,u])).then(f=>P(f,null))}async installExtensionsFromProfile(c,u,f){return(await this.m.call("installExtensionsFromProfile",[c,u,f])).map(k=>P(k,null))}getManifest(c){return Promise.resolve(this.m.call("getManifest",[c]))}installFromGallery(c,u){return Promise.resolve(this.m.call("installFromGallery",[c,u])).then(f=>P(f,null))}async installGalleryExtensions(c){return(await this.m.call("installGalleryExtensions",[c])).map(f=>({...f,local:f.local?P(f.local,null):f.local,source:this.r(f.source)?L.URI.revive(f.source):f.source,profileLocation:L.URI.revive(f.profileLocation)}))}uninstall(c,u){return Promise.resolve(this.m.call("uninstall",[c,u]))}reinstallFromGallery(c){return Promise.resolve(this.m.call("reinstallFromGallery",[c])).then(u=>P(u,null))}getInstalled(c=null,u){return Promise.resolve(this.m.call("getInstalled",[c,u])).then(f=>f.map(m=>P(m,null)))}updateMetadata(c,u,f){return Promise.resolve(this.m.call("updateMetadata",[c,u,f])).then(m=>P(m,null))}toggleAppliationScope(c,u){return this.m.call("toggleAppliationScope",[c,u]).then(f=>P(f,null))}copyExtensions(c,u){return this.m.call("copyExtensions",[c,u])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(c,u,f){const m=await this.m.call("download",[c,u,f]);return L.URI.revive(m)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$mp=$;class y{constructor(c){this.a=c}listen(c,u){throw new Error("Invalid listen")}call(c,u,f){switch(u){case"getConfigBasedTips":return this.a.getConfigBasedTips(L.URI.revive(f[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$np=y}),define(ae[97],ce([0,1,4]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jp=e.$ip=void 0,e.$ip=(0,I.$Th)("IExtensionSignatureVerificationService");class N{b(){return this.a||(this.a=new Promise((L,O)=>ie(["node-vsce-sign"],async R=>L(R),O))),this.a}async verify(L,O,R){let S;try{S=await this.b()}catch{return!1}return S.verify(L,O,R)}}e.$jp=N}),define(ae[98],ce([0,1,4]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yWb=e.RecommendationsNotificationResult=e.$xWb=e.RecommendationSource=void 0;var N;(function(O){O[O.FILE=1]="FILE",O[O.WORKSPACE=2]="WORKSPACE",O[O.EXE=3]="EXE"})(N||(e.RecommendationSource=N={}));function j(O){switch(O){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.$xWb=j;var L;(function(O){O.Ignored="ignored",O.Cancelled="cancelled",O.TooMany="toomany",O.IncompatibleWindow="incompatibleWindow",O.Accepted="reacted"})(L||(e.RecommendationsNotificationResult=L={})),e.$yWb=(0,I.$Th)("IExtensionRecommendationNotificationService")}),define(ae[11],ce([0,1,47,16,27,12,10,159,4,5,23,61]),function(ie,e,I,N,j,L,O,R,S,d,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lk=e.$Kk=e.$Jk=e.$Ik=e.$Hk=e.FileKind=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.FileOperationResult=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.FileChangeType=e.$uk=e.FileOperation=e.$tk=e.$sk=e.$rk=e.$qk=e.$pk=e.$ok=e.FileSystemProviderErrorCode=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.FileSystemProviderCapabilities=e.$ek=e.FilePermission=e.FileType=e.$dk=e.$ck=void 0,e.$ck=(0,S.$Th)("fileService");function b(_){return _.create===!0}e.$dk=b;var l;(function(_){_[_.Unknown=0]="Unknown",_[_.File=1]="File",_[_.Directory=2]="Directory",_[_.SymbolicLink=64]="SymbolicLink"})(l||(e.FileType=l={}));var $;(function(_){_[_.Readonly=1]="Readonly",_[_.Locked=2]="Locked"})($||(e.FilePermission=$={}));function y(_){const re=_;return!!re&&typeof re.onDidChange=="function"}e.$ek=y;var w;(function(_){_[_.None=0]="None",_[_.FileReadWrite=2]="FileReadWrite",_[_.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",_[_.FileReadStream=16]="FileReadStream",_[_.FileFolderCopy=8]="FileFolderCopy",_[_.PathCaseSensitive=1024]="PathCaseSensitive",_[_.Readonly=2048]="Readonly",_[_.Trash=4096]="Trash",_[_.FileWriteUnlock=8192]="FileWriteUnlock",_[_.FileAtomicRead=16384]="FileAtomicRead",_[_.FileAtomicWrite=32768]="FileAtomicWrite",_[_.FileAtomicDelete=65536]="FileAtomicDelete",_[_.FileClone=131072]="FileClone"})(w||(e.FileSystemProviderCapabilities=w={}));function c(_){return!!(_.capabilities&2)}e.$fk=c;function u(_){return!!(_.capabilities&8)}e.$gk=u;function f(_){return!!(_.capabilities&131072)}e.$hk=f;function m(_){return!!(_.capabilities&4)}e.$ik=m;function k(_){return!!(_.capabilities&16)}e.$jk=k;function s(_){return c(_)?!!(_.capabilities&16384):!1}e.$kk=s;function a(_){return c(_)?!!(_.capabilities&32768):!1}e.$lk=a;function n(_){return!!(_.capabilities&65536)}e.$mk=n;function i(_){return!!(_.capabilities&2048)}e.$nk=i;var t;(function(_){_.FileExists="EntryExists",_.FileNotFound="EntryNotFound",_.FileNotADirectory="EntryNotADirectory",_.FileIsADirectory="EntryIsADirectory",_.FileExceedsStorageQuota="EntryExceedsStorageQuota",_.FileTooLarge="EntryTooLarge",_.FileWriteLocked="EntryWriteLocked",_.NoPermissions="NoPermissions",_.Unavailable="Unavailable",_.Unknown="Unknown"})(t||(e.FileSystemProviderErrorCode=t={}));class r extends Error{static create(re,Q){const q=new r(re.toString(),Q);return p(q,Q),q}constructor(re,Q){super(re),this.code=Q}}e.$ok=r;function o(_,re){return r.create(_,re)}e.$pk=o;function v(_){return _||o((0,R.localize)(0,null),t.Unknown)}e.$qk=v;function p(_,re){return _.name=re?`${re} (FileSystemError)`:"FileSystemError",_}e.$rk=p;function h(_){if(!_)return t.Unknown;if(_ instanceof r)return _.code;const re=/^(.+) \(FileSystemError\)$/.exec(_.name);if(!re)return t.Unknown;switch(re[1]){case t.FileExists:return t.FileExists;case t.FileIsADirectory:return t.FileIsADirectory;case t.FileNotADirectory:return t.FileNotADirectory;case t.FileNotFound:return t.FileNotFound;case t.FileTooLarge:return t.FileTooLarge;case t.FileWriteLocked:return t.FileWriteLocked;case t.NoPermissions:return t.NoPermissions;case t.Unavailable:return t.Unavailable}return t.Unknown}e.$sk=h;function g(_){if(_ instanceof Z)return _.fileOperationResult;switch(h(_)){case t.FileNotFound:return 1;case t.FileIsADirectory:return 0;case t.FileNotADirectory:return 9;case t.FileWriteLocked:return 5;case t.NoPermissions:return 6;case t.FileExists:return 4;case t.FileTooLarge:return 7;default:return 10}}e.$tk=g;var D;(function(_){_[_.CREATE=0]="CREATE",_[_.DELETE=1]="DELETE",_[_.MOVE=2]="MOVE",_[_.COPY=3]="COPY",_[_.WRITE=4]="WRITE"})(D||(e.FileOperation=D={}));class T{constructor(re,Q,q){this.resource=re,this.operation=Q,this.target=q}isOperation(re){return this.operation===re}}e.$uk=T;var M;(function(_){_[_.UPDATED=0]="UPDATED",_[_.ADDED=1]="ADDED",_[_.DELETED=2]="DELETED"})(M||(e.FileChangeType=M={}));class z{static{this.a=null}constructor(re,Q){this.c=Q,this.b=void 0,this.d=new E.$U(()=>{const q=I.$Zh.forUris(()=>this.c);return q.fill(this.rawAdded.map(C=>[C,!0])),q}),this.f=new E.$U(()=>{const q=I.$Zh.forUris(()=>this.c);return q.fill(this.rawUpdated.map(C=>[C,!0])),q}),this.g=new E.$U(()=>{const q=I.$Zh.forUris(()=>this.c);return q.fill(this.rawDeleted.map(C=>[C,!0])),q}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const q of re){switch(q.type){case 1:this.rawAdded.push(q.resource);break;case 0:this.rawUpdated.push(q.resource);break;case 2:this.rawDeleted.push(q.resource);break}this.b!==z.a&&(typeof q.cId=="number"?this.b===void 0?this.b=q.cId:this.b!==q.cId&&(this.b=z.a):this.b!==void 0&&(this.b=z.a))}}contains(re,...Q){return this.h(re,{includeChildren:!1},...Q)}affects(re,...Q){return this.h(re,{includeChildren:!0},...Q)}h(re,Q,...q){if(!re)return!1;const C=q.length>0;return!!((!C||q.includes(1))&&(this.d.value.get(re)||Q.includeChildren&&this.d.value.findSuperstr(re))||(!C||q.includes(0))&&(this.f.value.get(re)||Q.includeChildren&&this.f.value.findSuperstr(re))||(!C||q.includes(2))&&(this.g.value.findSubstr(re)||Q.includeChildren&&this.g.value.findSuperstr(re)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(re){return this.b===re}hasCorrelation(){return typeof this.b=="number"}}e.$vk=z;function B(_,re,Q){return!_||!re||_===re||re.length>_.length?!1:(re.charAt(re.length-1)!==N.sep&&(re+=N.sep),Q?(0,j.$4e)(_,re):_.indexOf(re)===0)}e.$wk=B;class Z extends Error{constructor(re,Q,q){super(re),this.fileOperationResult=Q,this.options=q}}e.$xk=Z;class K extends Z{constructor(re,Q,q,C){super(re,Q,C),this.fileOperationResult=Q,this.size=q}}e.$yk=K;class x extends Z{constructor(re,Q,q){super(re,2,q),this.stat=Q}}e.$zk=x;var H;(function(_){_[_.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",_[_.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",_[_.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",_[_.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",_[_.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",_[_.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",_[_.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",_[_.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",_[_.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",_[_.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",_[_.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(H||(e.FileOperationResult=H={})),e.$Ak={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Bk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Ck="files.associations",e.$Dk="files.exclude",e.$Ek="files.readonlyInclude",e.$Fk="files.readonlyExclude",e.$Gk="files.readonlyFromPermissions";var Y;(function(_){_[_.FILE=0]="FILE",_[_.FOLDER=1]="FOLDER",_[_.ROOT_FOLDER=2]="ROOT_FOLDER"})(Y||(e.FileKind=Y={})),e.$Hk="";function G(_){if(!(typeof _.size!="number"||typeof _.mtime!="number"))return _.mtime.toString(29)+_.size.toString(31)}e.$Ik=G;async function V(_,re){if(!re.hasProvider(O.URI.from({scheme:_.scheme})))return new Promise(Q=>{const q=re.onDidChangeFileSystemProviderRegistrations(C=>{C.scheme===_.scheme&&C.added&&(q.dispose(),Q())})})}e.$Jk=V;class ee{static{this.KB=1024}static{this.MB=ee.KB*ee.KB}static{this.GB=ee.MB*ee.KB}static{this.TB=ee.GB*ee.KB}static formatSize(re){return(0,L.$Df)(re)||(re=0),re<ee.KB?(0,R.localize)(1,null,re.toFixed(0)):re<ee.MB?(0,R.localize)(2,null,(re/ee.KB).toFixed(2)):re<ee.GB?(0,R.localize)(3,null,(re/ee.MB).toFixed(2)):re<ee.TB?(0,R.localize)(4,null,(re/ee.GB).toFixed(2)):(0,R.localize)(5,null,(re/ee.TB).toFixed(2))}}e.$Kk=ee;function ne(_){const re=typeof _=="string"||_?.scheme===P.Schemas.vscodeRemote;return typeof _!="string"&&_?.scheme===P.Schemas.file?1024*ee.MB:re?10*ee.MB:d.$p?50*ee.MB:1024*ee.MB}e.$Lk=ne});var X=this&&this.__param||function(ie,e){return function(I,N){e(I,N,ie)}};define(ae[188],ce([0,1,71,46,11]),function(ie,e,I,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G9b=void 0;let L=class{constructor(R){this.a=R}async checksum(R){const S=(await this.a.readFileStream(R)).value;return new Promise((d,P)=>{const E=(0,I.createHash)("md5");(0,N.$7d)(S,{onData:b=>E.update(b.buffer),onError:b=>P(b),onEnd:()=>d(E.digest("base64").replace(/=+$/,""))})})}};e.$G9b=L,e.$G9b=L=pe([X(0,j.$ck)],L)}),define(ae[99],ce([0,1,15,7,160,11]),function(ie,e,I,N,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=void 0;async function O(P,E,b,l,$,y){let w;try{await R(P,E,b,l,$,y)}catch(c){w=c}finally{w&&$.errorTransformer&&(w=$.errorTransformer(w)),typeof w<"u"&&b.error(w),b.end()}}e.$Qp=O;async function R(P,E,b,l,$,y){S(y);const w=await P.open(E,{create:!1});try{S(y);let c=0,u=0,f=$&&typeof $.length=="number"?$.length:void 0,m=I.$ce.alloc(Math.min($.bufferSize,typeof f=="number"?f:$.bufferSize)),k=$&&typeof $.position=="number"?$.position:0,s=0;do u=await P.read(w,k,m.buffer,s,m.byteLength-s),k+=u,s+=u,c+=u,typeof f=="number"&&(f-=u),s===m.byteLength&&(await b.write(l(m)),m=I.$ce.alloc(Math.min($.bufferSize,typeof f=="number"?f:$.bufferSize)),s=0);while(u>0&&(typeof f!="number"||f>0)&&S(y)&&d(c,$));if(s>0){let a=s;typeof f=="number"&&(a=Math.min(s,f)),b.write(l(m.slice(0,a)))}}catch(c){throw(0,L.$qk)(c)}finally{await P.close(w)}}function S(P){if(P.isCancellationRequested)throw(0,N.$5)();return!0}function d(P,E){if(typeof E?.limits?.size=="number"&&P>E.limits.size)throw(0,L.$pk)((0,j.localize)(0,null),L.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ae[49],ce([0,1,91,2,16,5,10,11]),function(ie,e,I,N,j,L,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=e.$Yp=e.$Xp=e.$Wp=e.$Vp=e.$Up=e.$Tp=e.$Sp=void 0;function S(c){return c.recursive===!0}e.$Sp=S;class d extends N.$Rc{static{this.a=5}constructor(u,f,m,k){super(),this.h=u,this.j=f,this.m=m,this.n=k,this.c=this.B(new N.$Sc),this.f=void 0,this.g=0}s(){const u=new N.$Qc;this.c.value=u,this.b=this.r(u),this.b.setVerboseLogging(this.m),u.add(this.b.onDidChangeFile(f=>this.h(f))),u.add(this.b.onDidLogMessage(f=>this.j(f))),u.add(this.b.onDidError(f=>this.t(f)))}t(u){this.n.restartOnError?this.g<d.a&&this.f?(this.w(`restarting watcher after error: ${u}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${u}`):this.w(u)}u(u){this.g++,this.s(),this.watch(u)}async watch(u){this.f=u,await this.b?.watch(u)}async setVerboseLogging(u){this.m=u,await this.b?.setVerboseLogging(u)}w(u){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${u}`})}y(u){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${u}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Tp=d;class P extends d{constructor(u,f,m){super(u,f,m,{type:"node.js",restartOnError:!1})}}e.$Up=P;class E extends d{constructor(u,f,m){super(u,f,m,{type:"universal",restartOnError:!0})}}e.$Vp=E;function b(c){return c.map(u=>({type:u.type,resource:O.URI.revive(u.resource),cId:u.cId}))}e.$Wp=b;function l(c){const u=new w;for(const f of c)u.processEvent(f);return u.coalesce()}e.$Xp=l;function $(c,u){return typeof u=="string"&&!u.startsWith(I.$wj)&&!(0,j.$hc)(u)?{base:c,pattern:u}:u}e.$Yp=$;function y(c,u){const f=[];for(const m of u)f.push((0,I.$Aj)($(c,m)));return f}e.$Zp=y;class w{constructor(){this.a=new Set,this.b=new Map}c(u){return L.$l?u.resource.fsPath:u.resource.fsPath.toLowerCase()}processEvent(u){const f=this.b.get(this.c(u));let m=!1;if(f){const k=f.type,s=u.type;f.resource.fsPath!==u.resource.fsPath&&(u.type===2||u.type===1)?m=!0:k===1&&s===2?(this.b.delete(this.c(u)),this.a.delete(f)):k===2&&s===1?f.type=0:k===1&&s===0||(f.type=s)}else m=!0;m&&(this.a.add(u),this.b.set(this.c(u),u))}coalesce(){const u=[],f=[];return Array.from(this.a).filter(m=>m.type!==2?(u.push(m),!1):!0).sort((m,k)=>m.resource.fsPath.length-k.resource.fsPath.length).filter(m=>f.some(k=>(0,R.$wk)(m.resource.fsPath,k,!L.$l))?!1:(f.push(m.resource.fsPath),!0)).concat(u)}}}),define(ae[189],ce([0,1,15,38,7,3,2,46,32,11,49]),function(ie,e,I,N,j,L,O,R,S,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DN=e.$CN=void 0,e.$CN="localFilesystem";class E extends O.$Rc{constructor(l,$){super(),this.a=l,this.b=$,this.onDidChangeCapabilities=L.Event.None,this.f=this.B(new L.$Od),this.onDidChangeFile=this.f.event,this.g=this.B(new L.$Od),this.onDidWatchError=this.g.event,this.h=(0,S.$fg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(l){return this.a.call("stat",[l])}readdir(l){return this.a.call("readdir",[l])}async readFile(l,$){const{buffer:y}=await this.a.call("readFile",[l,$]);return y}readFileStream(l,$,y){const w=(0,R.$3d)(u=>I.$ce.concat(u.map(f=>I.$ce.wrap(f))).buffer),c=new O.$Qc;return c.add(this.a.listen("readFileStream",[l,$])(u=>{if(u instanceof I.$ce)w.write(u.buffer);else{if(u==="end")w.end();else{let f;if(u instanceof Error)f=u;else{const m=u;f=(0,d.$pk)(m.message??(0,N.$Ei)(m),m.code??d.FileSystemProviderErrorCode.Unknown)}w.error(f),w.end()}c.dispose()}})),c.add(y.onCancellationRequested(()=>{w.error((0,j.$5)()),w.end(),c.dispose()})),w}writeFile(l,$,y){return this.a.call("writeFile",[l,I.$ce.wrap($),y])}open(l,$){return this.a.call("open",[l,$])}close(l){return this.a.call("close",[l])}async read(l,$,y,w,c){const[u,f]=await this.a.call("read",[l,$,c]);return y.set(u.buffer.slice(0,f),w),f}write(l,$,y,w,c){return this.a.call("write",[l,$,I.$ce.wrap(y),w,c])}mkdir(l){return this.a.call("mkdir",[l])}delete(l,$){return this.a.call("delete",[l,$])}rename(l,$,y){return this.a.call("rename",[l,$,y])}copy(l,$,y){return this.a.call("copy",[l,$,y])}cloneFile(l,$){return this.a.call("cloneFile",[l,$])}j(){this.B(this.a.listen("fileChange",[this.h])(l=>{if(Array.isArray(l)){const $=l;this.f.fire((0,P.$Wp)($))}else{const $=l;this.g.fire($)}}))}watch(l,$){const y=(0,S.$fg)();return this.a.call("watch",[this.h,y,l,$]),(0,O.$Pc)(()=>this.a.call("unwatch",[this.h,y]))}}e.$DN=E}),define(ae[190],ce([0,1,53,6,26,48,2,88,16,5,19,10,143,31,49]),function(ie,e,I,N,j,L,O,R,S,d,P,E,b,l,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=e.$aq=void 0;class y extends O.$Rc{static{this.a=100}static{this.b=75}constructor(u,f,m,k){super(),this.m=u,this.n=f,this.r=m,this.s=k,this.c=this.B(new N.$$g({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},s=>this.n(s))),this.f=this.B(new N.$0g(s=>this.z(s),y.b)),this.g=(0,$.$Zp)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,$.$Zp)(this.m.path,this.m.includes):void 0,this.j=new j.$Yd,this.ready=this.t()}async t(){try{const u=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const f=await l.Promises.stat(u);this.B(await this.w(u,f.isDirectory()))}catch(u){u.code!=="ENOENT"?this.D(u):this.G(u)}}async u(u){let f=u.path;try{f=await l.Promises.realpath(u.path),u.path===f&&(f=await(0,b.$0p)(u.path)??u.path),u.path!==f&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${u.path}, real: ${f})`)}catch{}return f}async w(u,f){if(d.$k&&(0,L.$Yf)(u,"/Volumes/",!0))return this.D(`Refusing to watch ${u} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),O.$Rc.None;const m=new j.$Yd(this.j.token),k=new O.$Qc;try{const s=E.URI.file(this.m.path),a=(0,S.$mc)(u),n=(0,I.watch)(u);k.add((0,O.$Pc)(()=>{n.removeAllListeners(),n.close()})),this.G(`Started watching: '${u}'`);const i=new Set;if(f)try{for(const r of await l.Promises.readdir(u))i.add(r)}catch(r){this.D(r)}const t=new Map;k.add((0,O.$Pc)(()=>{for(const[,r]of t)r.dispose();t.clear()})),n.on("error",(r,o)=>{this.D(`Failed to watch ${u} for changes using fs.watch() (${r}, ${o})`),this.dispose()}),n.on("change",(r,o)=>{if(m.token.isCancellationRequested)return;this.G(`[raw] ["${r}"] ${o}`);let v="";if(o&&(v=o.toString(),d.$k&&(v=(0,R.$sl)(v))),!(!v||r!=="change"&&r!=="rename"))if(f)if(r==="rename"){t.get(v)?.dispose();const p=setTimeout(async()=>{if(t.delete(v),v===a&&!await l.Promises.exists(u)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const h=await this.C((0,S.$ic)(u,v));if(m.token.isCancellationRequested)return;let g;h?i.has(v)?g=0:(g=1,i.add(v)):(i.delete(v),g=2),this.y({resource:(0,P.$wg)(s,v),type:g,cId:this.m.correlationId})},y.a);t.set(v,(0,O.$Pc)(()=>clearTimeout(p)))}else{let p;i.has(v)?p=0:(p=1,i.add(v)),this.y({resource:(0,P.$wg)(s,v),type:p,cId:this.m.correlationId})}else if(r==="rename"||v!==a){const p=setTimeout(async()=>{const h=await l.Promises.exists(u);m.token.isCancellationRequested||(h?(this.y({resource:s,type:0,cId:this.m.correlationId},!0),k.add(await this.w(u,!1))):(this.y({resource:s,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},y.a);k.clear(),k.add((0,O.$Pc)(()=>clearTimeout(p)))}else this.y({resource:s,type:0,cId:this.m.correlationId},!0)})}catch(s){await l.Promises.exists(u)&&!m.token.isCancellationRequested&&this.D(`Failed to watch ${u} for changes using fs.watch() (${s.toString()})`)}return(0,O.$Pc)(()=>{m.dispose(!0),k.dispose()})}y(u,f=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.resource.fsPath}`),!f&&this.g.some(m=>m(u.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${u.resource.fsPath}`):!f&&this.h&&this.h.length>0&&!this.h.some(m=>m(u.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${u.resource.fsPath}`):this.f.work(u))}z(u){const f=(0,$.$Xp)(u);if(f.length>0){if(this.s)for(const k of f)this.G(` >> normalized ${k.type===1?"[ADDED]":k.type===2?"[DELETED]":"[CHANGED]"} ${k.resource.fsPath}`);this.c.work(f)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${f[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${f.length}, most recent change: ${f[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(u){if(d.$l)return l.Promises.exists(u);try{const f=(0,S.$mc)(u);return(await l.Promises.readdir((0,S.$lc)(u))).some(k=>k===f)}catch(f){return this.G(f),!1}}setVerboseLogging(u){this.s=u}D(u){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${u}`})}F(u){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${u}`})}G(u){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${u}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$aq=y;async function w(c,u,f,m,k=512){const s=await l.Promises.open(c,"r"),a=Buffer.allocUnsafe(k),n=new j.$Yd(m);let i,t=!1;const r={path:c,excludes:[],recursive:!1},o=new y(r,v=>{(async()=>{for(const{type:p}of v)if(p===0){if(t)return;t=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:h}=await l.Promises.read(s,a,0,k,null);if(!h||n.token.isCancellationRequested)break;u(a.slice(0,h))}}catch(h){i=new Error(h),n.dispose(!0)}finally{t=!1}}})()});return await o.ready,f(),new Promise((v,p)=>{n.token.onCancellationRequested(async()=>{o.dispose();try{await l.Promises.close(s)}catch(h){i=new Error(h)}i?p(i):v()})})}e.$bq=w}),define(ae[191],ce([0,1,3,91,2,5,190]),function(ie,e,I,N,j,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=void 0;class R extends j.$Rc{constructor(){super(...arguments),this.a=this.B(new I.$Od),this.onDidChangeFile=this.a.event,this.b=this.B(new I.$Od),this.onDidLogMessage=this.b.event,this.onDidError=I.Event.None,this.c=new Map,this.f=!1}async watch(d){const P=this.j(d),E=P.filter(l=>{const $=this.c.get(l.path);return $?!(0,N.$Ej)($.request.excludes,l.excludes)||!(0,N.$Ej)($.request.includes,l.includes):!0}),b=Array.from(this.c.values()).filter(({request:l})=>!P.find($=>$.path===l.path&&(0,N.$Ej)($.excludes,l.excludes)&&(0,N.$Ej)($.includes,l.includes))).map(({request:l})=>l.path);E.length&&this.m(`Request to start watching: ${E.map(l=>`${l.path} (excludes: ${l.excludes.length>0?l.excludes:"<none>"}, includes: ${l.includes&&l.includes.length>0?JSON.stringify(l.includes):"<all>"}, correlationId: ${typeof l.correlationId=="number"?l.correlationId:"<none>"})`).join(",")}`),b.length&&this.m(`Request to stop watching: ${b.join(",")}`);for(const l of b)this.h(l);for(const l of E)this.g(l)}g(d){const P=new O.$aq(d,b=>this.a.fire(b),b=>this.b.fire(b),this.f),E={request:d,instance:P};this.c.set(d.path,E)}async stop(){for(const[d]of this.c)this.h(d);this.c.clear()}h(d){const P=this.c.get(d);P&&(this.c.delete(d),P.instance.dispose())}j(d){const P=new Map;for(const E of d){const b=L.$l?E.path:E.path.toLowerCase();let l=P.get(E.correlationId);l||(l=new Map,P.set(E.correlationId,l)),l.set(b,E)}return Array.from(P.values()).map(E=>Array.from(E.values())).flat()}async setVerboseLogging(d){this.f=d;for(const[,P]of this.c)P.instance.setVerboseLogging(d)}m(d){this.f&&this.b.fire({type:"trace",message:this.n(d)})}n(d,P){return P?`[File Watcher (node.js)] ${d} (path: ${P.request.path})`:`[File Watcher (node.js)] ${d}`}}e.$cq=R}),define(ae[192],ce([0,1,49,191]),function(ie,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=void 0;class j extends I.$Up{constructor(O,R,S){super(O,R,S),this.s()}r(O){return O.add(new N.$cq)}}e.$dq=j}),define(ae[193],ce([0,1,23,40,93,49]),function(ie,e,I,N,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=void 0;class O extends L.$Vp{constructor(S,d,P){super(S,d,P),this.s()}r(S){const d=S.add(new j.$7p(I.$dg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return S.add(d.onDidProcessExit(({code:P,signal:E})=>this.t(`terminated by itself with code ${P}, signal: ${E}`))),N.ProxyChannel.toService((0,N.$Ah)(d.getChannel("watcher")))}}e.$8p=O}),define(ae[72],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rh=void 0;class I{constructor(...j){this.a=new Map;for(const[L,O]of j)this.set(L,O)}set(j,L){const O=this.a.get(j);return this.a.set(j,L),O}has(j){return this.a.has(j)}get(j){return this.a.get(j)}}e.$Rh=I}),define(ae[194],ce([0,1,6,7,2,70,185,4,72,87]),function(ie,e,I,N,j,L,O,R,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=e.$hq=void 0;const P=!1;class E extends Error{constructor(w){super("cyclic dependency between services"),this.message=w.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${w.toString()}`}}class b{constructor(w=new S.$Rh,c=!1,u,f=P){this.f=w,this.g=c,this.h=u,this.i=f,this.o=new Set,this.f.set(R.$Sh,this),this._globalGraph=f?u?._globalGraph??new O.$gq(m=>m):void 0}createChild(w){return new b(w,this.g,this,this.i)}invokeFunction(w,...c){const u=$.traceInvocation(this.i,w);let f=!1;try{return w({get:k=>{if(f)throw(0,N.$7)("service accessor is only valid during the invocation of its target method");const s=this.m(k,u);if(!s)throw new Error(`[invokeFunction] unknown service '${k}'`);return s}},...c)}finally{f=!0,u.stop()}}createInstance(w,...c){let u,f;return w instanceof L.$Qh?(u=$.traceCreation(this.i,w.ctor),f=this.j(w.ctor,w.staticArguments.concat(c),u)):(u=$.traceCreation(this.i,w),f=this.j(w,c,u)),u.stop(),f}j(w,c=[],u){const f=R._util.getServiceDependencies(w).sort((s,a)=>s.index-a.index),m=[];for(const s of f){const a=this.m(s.id,u);a||this.u(`[createInstance] ${w.name} depends on UNKNOWN service ${s.id}.`,!1),m.push(a)}const k=f.length>0?f[0].index:c.length;if(c.length!==k){console.trace(`[createInstance] First service dependency of ${w.name} at position ${k+1} conflicts with ${c.length} static arguments`);const s=k-c.length;s>0?c=c.concat(new Array(s)):c=c.slice(0,k)}return Reflect.construct(w,c.concat(m))}k(w,c){if(this.f.get(w)instanceof L.$Qh)this.f.set(w,c);else if(this.h)this.h.k(w,c);else throw new Error("illegalState - setting UNKNOWN service instance")}l(w){const c=this.f.get(w);return!c&&this.h?this.h.l(w):c}m(w,c){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(w));const u=this.l(w);return u instanceof L.$Qh?this.q(w,u,c.branch(w,!0)):(c.branch(w,!1),u)}q(w,c,u){if(this.o.has(w))throw new Error(`illegal state - RECURSIVELY instantiating service '${w}'`);this.o.add(w);try{return this.r(w,c,u)}finally{this.o.delete(w)}}r(w,c,u){const f=new O.$gq(s=>s.id.toString());let m=0;const k=[{id:w,desc:c,_trace:u}];for(;k.length;){const s=k.pop();if(f.lookupOrInsertNode(s),m++>1e3)throw new E(f);for(const a of R._util.getServiceDependencies(s.desc.ctor)){const n=this.l(a.id);if(n||this.u(`[createInstance] ${w} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(s.id),String(a.id)),n instanceof L.$Qh){const i={id:a.id,desc:n,_trace:s._trace.branch(a.id,!0)};f.insertEdge(s,i),k.push(i)}}}for(;;){const s=f.roots();if(s.length===0){if(!f.isEmpty())throw new E(f);break}for(const{data:a}of s){if(this.l(a.id)instanceof L.$Qh){const i=this.s(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this.k(a.id,i)}f.removeNode(a)}}return this.l(w)}s(w,c,u=[],f,m){if(this.f.get(w)instanceof L.$Qh)return this.t(w,c,u,f,m);if(this.h)return this.h.s(w,c,u,f,m);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}t(w,c,u=[],f,m){if(f){const k=new b(void 0,this.g,this,this.i);k.c=String(w);const s=new Map,a=new I.$ch(()=>{const n=k.j(c,u,m);for(const[i,t]of s){const r=n[i];if(typeof r=="function")for(const o of t)r.apply(n,o)}return s.clear(),n});return new Proxy(Object.create(null),{get(n,i){if(!a.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let o=s.get(i);return o||(o=new d.$1c,s.set(i,o)),(p,h,g)=>{const D=o.push([p,h,g]);return(0,j.$Pc)(D)}}if(i in n)return n[i];const t=a.value;let r=t[i];return typeof r!="function"||(r=r.bind(t),n[i]=r),r},set(n,i,t){return a.value[i]=t,!0},getPrototypeOf(n){return c.prototype}})}else return this.j(c,u,m)}u(w,c){if(c&&console.warn(w),this.g)throw new Error(w)}}e.$hq=b;var l;(function(y){y[y.None=0]="None",y[y.Creation=1]="Creation",y[y.Invocation=2]="Invocation",y[y.Branch=3]="Branch"})(l||(l={}));class ${static{this.all=new Set}static{this.c=new class extends ${constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(w,c){return w?new $(2,c.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):$.c}static traceCreation(w,c){return w?new $(1,c.name):$.c}static{this.f=0}constructor(w,c){this.type=w,this.name=c,this.g=Date.now(),this.h=[]}branch(w,c){const u=new $(3,w.toString());return this.h.push([w,c,u]),u}stop(){const w=Date.now()-this.g;$.f+=w;let c=!1;function u(m,k){const s=[],a=new Array(m+1).join("	");for(const[n,i,t]of k.h)if(i&&t){c=!0,s.push(`${a}CREATES -> ${n}`);const r=u(m+1,t);r&&s.push(r)}else s.push(`${a}uses -> ${n}`);return s.join(`
`)}const f=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${u(1,this)}`,`DONE, took ${w.toFixed(2)}ms (grand total ${$.f.toFixed(2)}ms)`];(w>2||c)&&$.all.add(f.join(`
`))}}e.$iq=$}),define(ae[55],ce([0,1,4]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e9b=e.$d9b=void 0,e.$d9b=(0,I.$Th)("mainProcessService");class N{constructor(L,O){this.a=L,this.b=O}getChannel(L){return this.a.getChannel(L,this.b)}registerChannel(L,O){this.a.registerChannel(L,O)}}e.$e9b=N}),define(ae[73],ce([0,1,26,2,5,162,29,4]),function(ie,e,I,N,j,L,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xq=e.$Wq=e.$Vq=void 0;function S(P){return P.tags.find(E=>E.startsWith("lp-"))?.split("lp-")[1]}e.$Vq=S,e.$Wq=(0,R.$Th)("languagePackService");let d=class extends N.$Rc{constructor(E){super(),this.c=E}async getAvailableLanguages(){const E=new I.$Yd;setTimeout(()=>E.cancel(),1e3);let b;try{b=await this.c.query({text:'category:"language packs"',pageSize:20},E.token)}catch{return[]}const $=b.firstPage.filter(y=>y.properties.localizedLanguages?.length&&y.tags.some(w=>w.startsWith("lp-"))).map(y=>{const w=y.properties.localizedLanguages?.[0],c=S(y);return{...this.f(c,w,y),extensionId:y.identifier.id,galleryExtension:y}});return $.push(this.f("en","English")),$}f(E,b,l){const $=b??E;let y;if($!==E&&(y=`(${E})`),E.toLowerCase()===j.$w.toLowerCase()&&(y??="",y+=(0,L.localize)(0,null)),l?.installCount){y??="";const w=l.installCount;let c;w>1e6?c=`${Math.floor(w/1e5)/10}M`:w>1e3?c=`${Math.floor(w/1e3)}K`:c=String(w),y+=` $(cloud-download) ${c}`}return{id:E,label:$,description:y}}};e.$Xq=d,e.$Xq=d=pe([X(0,O.$bo)],d)}),define(ae[195],ce([0,1,2,73]),function(ie,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C9b=void 0;let j=class extends I.$Rc{constructor(O){super(),this.a=O,this.b()}b(){this.a.update()}};e.$C9b=j,e.$C9b=j=pe([X(0,N.$Wq)],j)}),define(ae[8],ce([0,1,38,3,52,2,34,5,19,12,10,94,4]),function(ie,e,I,N,j,L,O,R,S,d,P,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.log=e.$ej=e.LogLevel=e.$dj=e.$cj=e.$bj=void 0,e.$bj=(0,b.$Th)("logService"),e.$cj=(0,b.$Th)("loggerService");function l(){return new Date().toISOString()}function $(p){return(0,d.$Df)(p)}e.$dj=$;var y;(function(p){p[p.Off=0]="Off",p[p.Trace=1]="Trace",p[p.Debug=2]="Debug",p[p.Info=3]="Info",p[p.Warning=4]="Warning",p[p.Error=5]="Error"})(y||(e.LogLevel=y={})),e.$ej=y.Info;function w(p,h,g){switch(h){case y.Trace:p.trace(g);break;case y.Debug:p.debug(g);break;case y.Info:p.info(g);break;case y.Warning:p.warn(g);break;case y.Error:p.error(g);break;case y.Off:break;default:throw new Error(`Invalid log level ${h}`)}}e.log=w;function c(p,h=!1){let g="";for(let D=0;D<p.length;D++){let T=p[D];if(T instanceof Error&&(T=(0,I.$Ei)(T,h)),typeof T=="object")try{T=JSON.stringify(T)}catch{}g+=(D>0?" ":"")+T}return g}class u extends L.$Rc{constructor(){super(...arguments),this.b=e.$ej,this.c=this.B(new N.$Od),this.onDidChangeLogLevel=this.c.event}setLevel(h){this.b!==h&&(this.b=h,this.c.fire(this.b))}getLevel(){return this.b}f(h){return this.b!==y.Off&&this.b<=h}}e.$gj=u;class f extends u{constructor(h){super(),this.h=h}f(h){return this.h||super.f(h)}trace(h,...g){this.f(y.Trace)&&this.g(y.Trace,c([h,...g],!0))}debug(h,...g){this.f(y.Debug)&&this.g(y.Debug,c([h,...g]))}info(h,...g){this.f(y.Info)&&this.g(y.Info,c([h,...g]))}warn(h,...g){this.f(y.Warning)&&this.g(y.Warning,c([h,...g]))}error(h,...g){if(this.f(y.Error))if(h instanceof Error){const D=Array.prototype.slice.call(arguments);D[0]=h.stack,this.g(y.Error,c(D))}else this.g(y.Error,c([h,...g]))}flush(){}}e.$hj=f;class m extends u{constructor(h=e.$ej){super(),this.setLevel(h),this.g=!R.$j}trace(h,...g){this.f(y.Trace)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,h,...g):console.log(`[main ${l()}]`,h,...g))}debug(h,...g){this.f(y.Debug)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,h,...g):console.log(`[main ${l()}]`,h,...g))}info(h,...g){this.f(y.Info)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,h,...g):console.log(`[main ${l()}]`,h,...g))}warn(h,...g){this.f(y.Warning)&&(this.g?console.warn(`\x1B[93m[main ${l()}]\x1B[0m`,h,...g):console.warn(`[main ${l()}]`,h,...g))}error(h,...g){this.f(y.Error)&&(this.g?console.error(`\x1B[91m[main ${l()}]\x1B[0m`,h,...g):console.error(`[main ${l()}]`,h,...g))}dispose(){}flush(){}}e.$ij=m;class k extends u{constructor(h=e.$ej,g=!0){super(),this.g=g,this.setLevel(h)}trace(h,...g){this.f(y.Trace)&&(this.g?console.log("%cTRACE","color: #888",h,...g):console.log(h,...g))}debug(h,...g){this.f(y.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",h,...g):console.log(h,...g))}info(h,...g){this.f(y.Info)&&(this.g?console.log("%c INFO","color: #33f",h,...g):console.log(h,...g))}warn(h,...g){this.f(y.Warning)&&(this.g?console.log("%c WARN","color: #993",h,...g):console.log(h,...g))}error(h,...g){this.f(y.Error)&&(this.g?console.log("%c  ERR","color: #f33",h,...g):console.error(h,...g))}dispose(){}flush(){}}e.$jj=k;class s extends u{constructor(h,g=e.$ej){super(),this.g=h,this.setLevel(g)}trace(h,...g){this.f(y.Trace)&&this.g.log(y.Trace,[this.h(h),...g])}debug(h,...g){this.f(y.Debug)&&this.g.log(y.Debug,[this.h(h),...g])}info(h,...g){this.f(y.Info)&&this.g.log(y.Info,[this.h(h),...g])}warn(h,...g){this.f(y.Warning)&&this.g.log(y.Warning,[this.h(h),...g])}error(h,...g){this.f(y.Error)&&this.g.log(y.Error,[this.h(h),...g])}h(h){return typeof h=="string"?h:(0,I.$Ei)(h,this.f(y.Trace))}dispose(){}flush(){}}e.$kj=s;class a extends u{constructor(h){super(),this.g=h,h.length&&this.setLevel(h[0].getLevel())}setLevel(h){for(const g of this.g)g.setLevel(h);super.setLevel(h)}trace(h,...g){for(const D of this.g)D.trace(h,...g)}debug(h,...g){for(const D of this.g)D.debug(h,...g)}info(h,...g){for(const D of this.g)D.info(h,...g)}warn(h,...g){for(const D of this.g)D.warn(h,...g)}error(h,...g){for(const D of this.g)D.error(h,...g)}flush(){for(const h of this.g)h.flush()}dispose(){for(const h of this.g)h.dispose()}}e.$lj=a;class n extends L.$Rc{constructor(h,g,D){if(super(),this.h=h,this.j=g,this.b=new O.$zc,this.c=this.B(new N.$Od),this.onDidChangeLoggers=this.c.event,this.f=this.B(new N.$Od),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new N.$Od),this.onDidChangeVisibility=this.g.event,D)for(const T of D)this.b.set(T.resource,{logger:void 0,info:T})}m(h){return(0,d.$zf)(h)?[...this.b.values()].find(g=>g.info.id===h):this.b.get(h)}getLogger(h){return this.m(h)?.logger}createLogger(h,g){const D=this.n(h),T=(0,d.$zf)(h)?h:g?.id??(0,j.$Hi)(D.toString()).toString(16);let M=this.b.get(D)?.logger;const z=g?.logLevel==="always"?y.Trace:g?.logLevel;M||(M=this.s(D,z??this.getLogLevel(D)??this.h,{...g,id:T}));const B={logger:M,info:{resource:D,id:T,logLevel:z,name:g?.name,hidden:g?.hidden,extensionId:g?.extensionId,when:g?.when}};return this.registerLogger(B.info),this.b.set(D,B),M}n(h){return(0,d.$zf)(h)?(0,S.$wg)(this.j,`${h}.log`):h}setLogLevel(h,g){if(P.URI.isUri(h)){const D=h,T=g,M=this.b.get(D);M&&T!==M.info.logLevel&&(M.info.logLevel=T===this.h?void 0:T,M.logger?.setLevel(T),this.b.set(M.info.resource,M),this.f.fire([D,T]))}else{this.h=h;for(const[D,T]of this.b.entries())this.b.get(D)?.info.logLevel===void 0&&T.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(h,g){const D=this.m(h);D&&g!==!D.info.hidden&&(D.info.hidden=!g,this.b.set(D.info.resource,D),this.g.fire([D.info.resource,g]))}getLogLevel(h){let g;return h&&(g=this.b.get(h)?.info.logLevel),g??this.h}registerLogger(h){const g=this.b.get(h.resource);g?g.info.hidden!==h.hidden&&this.setVisibility(h.resource,!h.hidden):(this.b.set(h.resource,{info:h,logger:void 0}),this.c.fire({added:[h],removed:[]}))}deregisterLogger(h){const g=this.b.get(h);g&&(g.logger&&g.logger.dispose(),this.b.delete(h),this.c.fire({added:[],removed:[g.info]}))}*getRegisteredLoggers(){for(const h of this.b.values())yield h.info}getRegisteredLogger(h){return this.b.get(h)?.info}dispose(){this.b.forEach(h=>h.logger?.dispose()),this.b.clear(),super.dispose()}}e.$mj=n;class i{constructor(){this.onDidChangeLogLevel=new N.$Od().event}setLevel(h){}getLevel(){return y.Info}trace(h,...g){}debug(h,...g){}info(h,...g){}warn(h,...g){}error(h,...g){}critical(h,...g){}dispose(){}flush(){}}e.$nj=i;class t extends i{}e.$oj=t;function r(p){if(p.verbose)return y.Trace;if(typeof p.logLevel=="string"){const h=v(p.logLevel.toLowerCase());if(h!==void 0)return h}return e.$ej}e.$pj=r;function o(p){switch(p){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Off:return"off"}}e.$qj=o;function v(p){switch(p){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Error;case"off":return y.Off}}e.$rj=v,e.$sj=new E.$$i("logLevel",o(y.Info))}),define(ae[196],ce([0,1,6,7,2,23,16,19,31,14,8]),function(ie,e,I,N,j,L,O,R,S,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D9b=void 0;let E=class extends j.$Rc{constructor(l,$){super(),this.a=l,this.b=$,this.B(new I.$8g(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const l=(0,R.$tg)(this.a.logsHome),$=(0,R.$vg)(this.a.logsHome.with({scheme:L.Schemas.file})).fsPath,c=(await S.Promises.readdir($)).filter(f=>/^\d{8}T\d{6}$/.test(f)).sort().filter(f=>f!==l),u=c.slice(0,Math.max(0,c.length-9));u.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${u.join(", ")}'`),await Promise.all(u.map(f=>S.Promises.rm((0,O.$ic)($,f)))))}catch(l){(0,N.$Z)(l)}}};e.$D9b=E,e.$D9b=E=pe([X(0,d.$1h),X(1,P.$bj)],E)}),define(ae[197],ce([0,1,18,6,7,3,2,16,49,8]),function(ie,e,I,N,j,L,O,R,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=void 0;class P extends O.$Rc{constructor(b,l){super(),this.a=b,this.b=l,this.c=this.B(new L.$Od),this.onDidChangeFile=this.c.event,this.g=this.B(new L.$Od),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new N.$Sg(0)),this.w=[],this.y=this.B(new N.$Sg(0))}watch(b,l){return l.recursive||this.b?.watcher?.forceUniversal?this.n(b,l):this.z(b,l)}n(b,l){const $={path:this.H(b),excludes:l.excludes,includes:l.includes,recursive:l.recursive,correlationId:l.correlationId},y=(0,I.$Tb)(this.j,$);return this.r(),(0,O.$Pc)(()=>{y(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(b=>(0,j.$Z)(b))}s(){this.h||(this.h=this.B(this.t(l=>this.c.fire((0,S.$Wp)(l)),l=>this.G(l),this.a.getLevel()===d.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===d.LogLevel.Trace)})));const b=this.b?.watcher?.recursive?.usePolling;if(b===!0)for(const l of this.j)(0,S.$Sp)(l)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(b))for(const l of this.j)(0,S.$Sp)(l)&&b.includes(l.path)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(b,l){const $={path:this.H(b),excludes:l.excludes,includes:l.includes,recursive:!1,correlationId:l.correlationId},y=(0,I.$Tb)(this.w,$);return this.C(),(0,O.$Pc)(()=>{y(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(b=>(0,j.$Z)(b))}D(){return this.u||(this.u=this.B(this.F(b=>this.c.fire((0,S.$Wp)(b)),b=>this.G(b),this.a.getLevel()===d.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===d.LogLevel.Trace)}))),this.u.watch(this.w)}G(b){b.type==="error"&&this.g.fire(b.message),this.a[b.type](b.message)}H(b){return(0,R.$gc)(b.fsPath)}}e.$1p=P}),define(ae[198],ce([0,1,18,6,15,26,3,52,60,2,47,23,100,19,46,158,11,99,8,7]),function(ie,e,I,N,j,L,O,R,S,d,P,E,b,l,$,y,w,c,u,f){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=void 0;let k=class extends d.$Rc{static{m=this}constructor(a){super(),this.b=a,this.a=256*1024,this.c=this.B(new O.$Od),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new O.$Od),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new O.$Od),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new O.$Od),this.onDidRunOperation=this.r.event,this.X=this.B(new O.$Od),this.Y=this.B(new O.$Od),this.onDidFilesChange=this.Y.event,this.Z=this.B(new O.$Od),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new N.$5g)}registerProvider(a,n){if(this.h.has(a))throw new Error(`A filesystem provider for the scheme '${a}' is already registered.`);(0,b.mark)(`code/registerFilesystem/${a}`);const i=new d.$Qc;return this.h.set(a,n),this.c.fire({added:!0,scheme:a,provider:n}),i.add(n.onDidChangeFile(t=>{const r=new w.$vk(t,!this.S(n));this.X.fire(r),r.hasCorrelation()||this.Y.fire(r)})),typeof n.onDidWatchError=="function"&&i.add(n.onDidWatchError(t=>this.Z.fire(new Error(t)))),i.add(n.onDidChangeCapabilities(()=>this.g.fire({provider:n,scheme:a}))),(0,d.$Pc)(()=>{this.c.fire({added:!1,scheme:a,provider:n}),this.h.delete(a),(0,d.$Mc)(i)})}getProvider(a){return this.h.get(a)}async activateProvider(a){const n=[];this.f.fire({scheme:a,join(i){n.push(i)}}),!this.h.has(a)&&await N.Promises.settled(n)}async canHandleResource(a){return await this.activateProvider(a.scheme),this.hasProvider(a)}hasProvider(a){return this.h.has(a.scheme)}hasCapability(a,n){const i=this.h.get(a.scheme);return!!(i&&i.capabilities&n)}listCapabilities(){return S.Iterable.map(this.h,([a,n])=>({scheme:a,capabilities:n.capabilities}))}async j(a){if(!(0,l.$Ag)(a))throw new w.$xk((0,y.localize)(0,null,this.sb(a)),8);await this.activateProvider(a.scheme);const n=this.h.get(a.scheme);if(!n){const i=new f.$ab;throw i.message=(0,y.localize)(1,null,a.toString()),i}return n}async m(a){const n=await this.j(a);if((0,w.$ik)(n)||(0,w.$fk)(n)||(0,w.$jk)(n))return n;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(a){const n=await this.j(a);if((0,w.$ik)(n)||(0,w.$fk)(n))return n;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(a,n){try{return await this.s(a,n)}catch(i){throw(0,w.$sk)(i)===w.FileSystemProviderErrorCode.FileNotFound?new w.$xk((0,y.localize)(2,null,this.sb(a)),1):(0,w.$qk)(i)}}async s(a,n){const i=await this.j(a),t=this.S(i),r=n?.resolveTo,o=n?.resolveSingleChildDescendants,v=n?.resolveMetadata,p=await i.stat(a);let h;return this.t(i,a,p,void 0,!!v,(g,D)=>(h||(h=P.$Zh.forUris(()=>!t),h.set(a,!0),r&&h.fill(!0,r)),h.get(g.resource)||h.findSuperstr(g.resource.with({query:null,fragment:null}))?!0:g.isDirectory&&o?D===1:!1))}async t(a,n,i,t,r,o){const{providerExtUri:v}=this.R(a),p={resource:n,name:v.basename(n),isFile:(i.type&w.FileType.File)!==0,isDirectory:(i.type&w.FileType.Directory)!==0,isSymbolicLink:(i.type&w.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&w.FilePermission.Readonly)||!!(a.capabilities&2048),locked:!!((i.permissions??0)&w.FilePermission.Locked),etag:(0,w.$Ik)({mtime:i.mtime,size:i.size}),children:void 0};if(p.isDirectory&&o(p,t)){try{const h=await a.readdir(n),g=await N.Promises.settled(h.map(async([D,T])=>{try{const M=v.joinPath(n,D),z=r?await a.stat(M):{type:T};return await this.t(a,M,z,h.length,r,o)}catch(M){return this.b.trace(M),null}}));p.children=(0,I.$Gb)(g)}catch(h){this.b.trace(h),p.children=[]}return p}return p}async resolveAll(a){return N.Promises.settled(a.map(async n=>{try{return{stat:await this.s(n.resource,n.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(a){const n=await this.j(a),i=await n.stat(a);return this.t(n,a,i,void 0,!0,()=>!1)}async exists(a){const n=await this.j(a);try{return!!await n.stat(a)}catch{return!1}}async canCreateFile(a,n){try{await this.u(a,n)}catch(i){return i}return!0}async u(a,n){if(!n?.overwrite&&await this.exists(a))throw new w.$xk((0,y.localize)(3,null,this.sb(a)),3,n)}async createFile(a,n=j.$ce.fromString(""),i){await this.u(a,i);const t=await this.writeFile(a,n);return this.r.fire(new w.$uk(a,0,t)),t}async writeFile(a,n,i){const t=this.qb(await this.n(a),a),{providerExtUri:r}=this.R(t);let o=i;if((0,w.$lk)(t)&&!o?.atomic){const v=t.enforceAtomicWriteFile?.(a);v&&(o={...i,atomic:v})}try{await this.w(t,a,o)||await this.U(t,r.dirname(a));let p;if((0,w.$fk)(t)&&!(n instanceof j.$ce))if((0,$.$1d)(n)){const h=await(0,$.$8d)(n,3);h.ended?p=j.$ce.concat(h.buffer):p=h}else p=(0,$.$5d)(n,h=>j.$ce.concat(h),3);else p=n;!(0,w.$ik)(t)||(0,w.$fk)(t)&&p instanceof j.$ce||(0,w.$fk)(t)&&(0,w.$lk)(t)&&o?.atomic?await this.hb(t,a,o,p):await this.db(t,a,o,p instanceof j.$ce?(0,j.$ne)(p):p),this.r.fire(new w.$uk(a,4))}catch(v){throw new w.$xk((0,y.localize)(4,null,this.sb(a),(0,w.$qk)(v).toString()),(0,w.$tk)(v),o)}return this.resolve(a,{resolveMetadata:!0})}async w(a,n,i){const t=!!i?.unlock;if(t&&!(a.capabilities&8192))throw new Error((0,y.localize)(5,null,this.sb(n)));if(!!i?.atomic){if(!(a.capabilities&32768))throw new Error((0,y.localize)(6,null,this.sb(n)));if(!(a.capabilities&2))throw new Error((0,y.localize)(7,null,this.sb(n)));if(t)throw new Error((0,y.localize)(8,null,this.sb(n)))}let o;try{o=await a.stat(n)}catch{return}if(o.type&w.FileType.Directory)throw new w.$xk((0,y.localize)(9,null,this.sb(n)),0,i);if(this.rb(n,o),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==w.$Hk&&typeof o.mtime=="number"&&typeof o.size=="number"&&i.mtime<o.mtime&&i.etag!==(0,w.$Ik)({mtime:i.mtime,size:o.size}))throw new w.$xk((0,y.localize)(10,null),3,i);return o}async readFile(a,n,i){const t=await this.m(a);return n?.atomic?this.z(t,a,n,i):this.C(t,a,n,i)}async z(a,n,i,t){return new Promise((r,o)=>{this.cb.queueFor(n,this.R(a).providerExtUri).queue(async()=>{try{const v=await this.C(a,n,i,t);r(v)}catch(v){o(v)}})})}async C(a,n,i,t){const r=await this.D(a,n,{...i,preferUnbuffered:!0},t);return{...r,value:await(0,j.$oe)(r.value)}}async readFileStream(a,n,i){const t=await this.m(a);return this.D(t,a,n,i)}async D(a,n,i,t){const r=new L.$Yd(t);let o=i;(0,w.$kk)(a)&&a.enforceAtomicReadFile?.(n)&&(o={...i,atomic:!0});const v=this.J(n,o).then(h=>h,h=>{throw r.dispose(!0),h});let p;try{return typeof o?.etag=="string"&&o.etag!==w.$Hk&&await v,o?.atomic&&(0,w.$kk)(a)||!((0,w.$ik)(a)||(0,w.$jk)(a))||(0,w.$fk)(a)&&o?.preferUnbuffered?p=this.I(a,n,o):(0,w.$jk)(a)?p=this.G(a,n,r.token,o):p=this.H(a,n,r.token,o),p.on("end",()=>r.dispose()),p.on("error",()=>r.dispose()),{...await v,value:p}}catch(h){throw p&&await(0,$.$6d)(p),this.F(h,n,o)}}F(a,n,i){const t=(0,y.localize)(11,null,this.sb(n),(0,w.$qk)(a).toString());return a instanceof w.$zk?new w.$zk(t,a.stat,i):a instanceof w.$yk?new w.$yk(t,a.fileOperationResult,a.size,a.options):new w.$xk(t,(0,w.$tk)(a),i)}G(a,n,i,t=Object.create(null)){const r=a.readFileStream(n,t,i);return(0,$.$_d)(r,{data:o=>o instanceof j.$ce?o:j.$ce.wrap(o),error:o=>this.F(o,n,t)},o=>j.$ce.concat(o))}H(a,n,i,t=Object.create(null)){const r=(0,j.$se)();return(0,c.$Qp)(a,n,r,o=>o,{...t,bufferSize:this.a,errorTransformer:o=>this.F(o,n,t)},i),r}I(a,n,i){const t=(0,$.$3d)(r=>j.$ce.concat(r));return(async()=>{try{let r;i?.atomic&&(0,w.$kk)(a)?r=await a.readFile(n,{atomic:!0}):r=await a.readFile(n),typeof i?.position=="number"&&(r=r.slice(i.position)),typeof i?.length=="number"&&(r=r.slice(0,i.length)),this.L(n,r.byteLength,i),t.end(j.$ce.wrap(r))}catch(r){t.error(r),t.end()}})(),t}async J(a,n){const i=await this.resolve(a,{resolveMetadata:!0});if(i.isDirectory)throw new w.$xk((0,y.localize)(12,null,this.sb(a)),0,n);if(typeof n?.etag=="string"&&n.etag!==w.$Hk&&n.etag===i.etag)throw new w.$zk((0,y.localize)(13,null),i,n);return this.L(a,i.size,n),i}L(a,n,i){if(typeof i?.limits?.size=="number"&&n>i.limits.size)throw new w.$yk((0,y.localize)(14,null,this.sb(a)),7,n,i)}async canMove(a,n,i){return this.M(a,n,"move",i)}async canCopy(a,n,i){return this.M(a,n,"copy",i)}async M(a,n,i,t){if(a.toString()!==n.toString())try{const r=i==="move"?this.qb(await this.n(a),a):await this.m(a),o=this.qb(await this.n(n),n);await this.Q(r,a,o,n,i,t)}catch(r){return r}return!0}async move(a,n,i){const t=this.qb(await this.n(a),a),r=this.qb(await this.n(n),n),o=await this.N(t,a,r,n,"move",!!i),v=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new w.$uk(a,o==="move"?2:3,v)),v}async copy(a,n,i){const t=await this.m(a),r=this.qb(await this.n(n),n),o=await this.N(t,a,r,n,"copy",!!i),v=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new w.$uk(a,o==="copy"?3:2,v)),v}async N(a,n,i,t,r,o){if(n.toString()===t.toString())return r;const{exists:v,isSameResourceWithDifferentPathCase:p}=await this.Q(a,n,i,t,r,o);if(v&&!p&&o&&await this.del(t,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(t)),r==="copy"){if(a===i&&(0,w.$gk)(a))await a.copy(n,t,{overwrite:o});else{const h=await this.resolve(n);h.isDirectory?await this.P(a,h,i,t):await this.O(a,n,i,t)}return r}else return a===i?(await a.rename(n,t,{overwrite:o}),r):(await this.N(a,n,i,t,"copy",o),await this.del(n,{recursive:!0}),"copy")}async O(a,n,i,t){if((0,w.$ik)(a)&&(0,w.$ik)(i))return this.jb(a,n,i,t);if((0,w.$ik)(a)&&(0,w.$fk)(i))return this.pb(a,n,i,t);if((0,w.$fk)(a)&&(0,w.$ik)(i))return this.nb(a,n,i,t);if((0,w.$fk)(a)&&(0,w.$fk)(i))return this.lb(a,n,i,t)}async P(a,n,i,t){await i.mkdir(t),Array.isArray(n.children)&&await N.Promises.settled(n.children.map(async r=>{const o=this.R(i).providerExtUri.joinPath(t,r.name);return r.isDirectory?this.P(a,await this.resolve(r.resource),i,o):this.O(a,r.resource,i,o)}))}async Q(a,n,i,t,r,o){let v=!1;if(a===i){const{providerExtUri:h,isPathCaseSensitive:g}=this.R(a);if(g||(v=h.isEqual(n,t)),v&&r==="copy")throw new Error((0,y.localize)(15,null,this.sb(n),this.sb(t)));if(!v&&h.isEqualOrParent(t,n))throw new Error((0,y.localize)(16,null,this.sb(n),this.sb(t)))}const p=await this.exists(t);if(p&&!v){if(!o)throw new w.$xk((0,y.localize)(17,null,this.sb(n),this.sb(t)),4);if(a===i){const{providerExtUri:h}=this.R(a);if(h.isEqualOrParent(n,t))throw new Error((0,y.localize)(18,null,this.sb(n),this.sb(t)))}}return{exists:p,isSameResourceWithDifferentPathCase:v}}R(a){const n=this.S(a);return{providerExtUri:n?l.$mg:l.$og,isPathCaseSensitive:n}}S(a){return!!(a.capabilities&1024)}async createFolder(a){const n=this.qb(await this.j(a),a);await this.U(n,a);const i=await this.resolve(a,{resolveMetadata:!0});return this.r.fire(new w.$uk(a,0,i)),i}async U(a,n){const i=[],{providerExtUri:t}=this.R(a);for(;!t.isEqual(n,t.dirname(n));)try{if(!((await a.stat(n)).type&w.FileType.Directory))throw new Error((0,y.localize)(19,null,this.sb(n)));break}catch(r){if((0,w.$sk)(r)!==w.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(t.basename(n)),n=t.dirname(n)}for(let r=i.length-1;r>=0;r--){n=t.joinPath(n,i[r]);try{await a.mkdir(n)}catch(o){if((0,w.$sk)(o)!==w.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(a,n){try{await this.W(a,n)}catch(i){return i}return!0}async W(a,n){const i=this.qb(await this.j(a),a),t=!!n?.useTrash;if(t&&!(i.capabilities&4096))throw new Error((0,y.localize)(20,null,this.sb(a)));const r=n?.atomic;if(r&&!(i.capabilities&65536))throw new Error((0,y.localize)(21,null,this.sb(a)));if(t&&r)throw new Error((0,y.localize)(22,null,this.sb(a)));let o;try{o=await i.stat(a)}catch{}if(o)this.rb(a,o);else throw new w.$xk((0,y.localize)(23,null,this.sb(a)),1);if(!!!n?.recursive){const p=await this.resolve(a);if(p.isDirectory&&Array.isArray(p.children)&&p.children.length>0)throw new Error((0,y.localize)(24,null,this.sb(a)))}return i}async del(a,n){const i=await this.W(a,n);let t=n;if((0,w.$mk)(i)&&!t?.atomic){const p=i.enforceAtomicDelete?.(a);p&&(t={...n,atomic:p})}const r=!!t?.useTrash,o=!!t?.recursive,v=t?.atomic??!1;await i.delete(a,{recursive:o,useTrash:r,atomic:v}),this.r.fire(new w.$uk(a,1))}async cloneFile(a,n){const i=await this.j(a),t=this.qb(await this.n(n),n);if(i===t&&this.R(i).providerExtUri.isEqual(a,n))return;if(i===t&&(0,w.$hk)(i))return i.cloneFile(a,n);await this.U(t,this.R(t).providerExtUri.dirname(n));const r=this.cb.queueFor(a,this.R(i).providerExtUri);return i===t&&(0,w.$gk)(i)?r.queue(()=>i.copy(a,n,{overwrite:!0})):r.queue(()=>this.O(i,a,t,n))}static{this.ab=0}createWatcher(a,n){return this.watch(a,{...n,correlationId:m.ab++})}watch(a,n={recursive:!1,excludes:[]}){const i=new d.$Qc;let t=!1,r=()=>{t=!0};i.add((0,d.$Pc)(()=>r())),(async()=>{try{const v=await this.bb(a,n);t?(0,d.$Mc)(v):r=()=>(0,d.$Mc)(v)}catch(v){this.b.error(v)}})();const o=n.correlationId;if(typeof o=="number"){const v=i.add(new O.$Od);return i.add(this.X.event(h=>{h.correlates(o)&&v.fire(h)})),{onDidChange:v.event,dispose:()=>i.dispose()}}return i}async bb(a,n){const i=await this.j(a),t=(0,R.$Hi)([this.R(i).providerExtUri.getComparisonKey(a),n]);let r=this.$.get(t);return r||(r={count:0,disposable:i.watch(a,n)},this.$.set(t,r)),r.count+=1,(0,d.$Pc)(()=>{r&&(r.count--,r.count===0&&((0,d.$Mc)(r.disposable),this.$.delete(t)))})}dispose(){super.dispose();for(const[,a]of this.$)(0,d.$Mc)(a.disposable);this.$.clear()}async db(a,n,i,t){return this.cb.queueFor(n,this.R(a).providerExtUri).queue(async()=>{const r=await a.open(n,{create:!0,unlock:i?.unlock??!1});try{(0,$.$1d)(t)||(0,$.$2d)(t)?await this.eb(a,r,t):await this.fb(a,r,t)}catch(o){throw(0,w.$qk)(o)}finally{await a.close(r)}})}async eb(a,n,i){let t=0,r;if((0,$.$2d)(i)){if(i.buffer.length>0){const o=j.$ce.concat(i.buffer);await this.gb(a,n,o,o.byteLength,t,0),t+=o.byteLength}if(i.ended)return;r=i.stream}else r=i;return new Promise((o,v)=>{(0,$.$7d)(r,{onData:async p=>{r.pause();try{await this.gb(a,n,p,p.byteLength,t,0)}catch(h){return v(h)}t+=p.byteLength,setTimeout(()=>r.resume())},onError:p=>v(p),onEnd:()=>o()})})}async fb(a,n,i){let t=0,r;for(;(r=i.read())!==null;)await this.gb(a,n,r,r.byteLength,t,0),t+=r.byteLength}async gb(a,n,i,t,r,o){let v=0;for(;v<t;){const p=await a.write(n,r+v,i.buffer,o+v,t-v);v+=p}}async hb(a,n,i,t){return this.cb.queueFor(n,this.R(a).providerExtUri).queue(()=>this.ib(a,n,i,t))}async ib(a,n,i,t){let r;t instanceof j.$ce?r=t:(0,$.$1d)(t)?r=await(0,j.$oe)(t):(0,$.$2d)(t)?r=await(0,j.$pe)(t):r=(0,j.$me)(t),await a.writeFile(n,r.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(a,n,i,t){return this.cb.queueFor(t,this.R(i).providerExtUri).queue(()=>this.kb(a,n,i,t))}async kb(a,n,i,t){let r,o;try{r=await a.open(n,{create:!1}),o=await i.open(t,{create:!0,unlock:!1});const v=j.$ce.alloc(this.a);let p=0,h=0,g=0;do g=await a.read(r,p,v.buffer,h,v.byteLength-h),await this.gb(i,o,v,g,p,h),p+=g,h+=g,h===v.byteLength&&(h=0);while(g>0)}catch(v){throw(0,w.$qk)(v)}finally{await N.Promises.settled([typeof r=="number"?a.close(r):Promise.resolve(),typeof o=="number"?i.close(o):Promise.resolve()])}}async lb(a,n,i,t){return this.cb.queueFor(t,this.R(i).providerExtUri).queue(()=>this.mb(a,n,i,t))}async mb(a,n,i,t){return i.writeFile(t,await a.readFile(n),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(a,n,i,t){return this.cb.queueFor(t,this.R(i).providerExtUri).queue(()=>this.ob(a,n,i,t))}async ob(a,n,i,t){const r=await i.open(t,{create:!0,unlock:!1});try{const o=await a.readFile(n);await this.gb(i,r,j.$ce.wrap(o),o.byteLength,0,0)}catch(o){throw(0,w.$qk)(o)}finally{await i.close(r)}}async pb(a,n,i,t){const r=await(0,j.$oe)(this.H(a,n,L.CancellationToken.None));await this.hb(i,t,void 0,r)}qb(a,n){if(a.capabilities&2048)throw new w.$xk((0,y.localize)(25,null,this.sb(n)),6);return a}rb(a,n){if((n.permissions??0)&w.FilePermission.Readonly)throw new w.$xk((0,y.localize)(26,null,this.sb(a)),6)}sb(a){return a.scheme===E.Schemas.file?a.fsPath:a.toString(!0)}};e.$Rp=k,e.$Rp=k=m=pe([X(0,u.$bj)],k)}),define(ae[199],ce([0,1,53,270,6,34,15,3,48,2,16,5,19,46,31,161,11,99,197,38,193,192]),function(ie,e,I,N,j,L,O,R,S,d,P,E,b,l,$,y,w,c,u,f,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=void 0,(()=>{try{(0,N.gracefulify)(I)}catch(a){console.error(`Error enabling graceful-fs: ${(0,f.$Ei)(a)}`)}})();class s extends u.$1p{static{this.I=!1}constructor(n,i){super(n,i),this.onDidChangeCapabilities=R.Event.None,this.N=new L.$zc(t=>b.$ng.getComparisonKey(t)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,E.$l&&(this.J|=1024)),this.J}async stat(n){try{const{stat:i,symbolicLink:t}=await $.SymlinkSupport.stat(this.H(n));return{type:this.M(i,t),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:w.FilePermission.Locked}}catch(i){throw this.fb(i)}}async L(n){try{return await this.stat(n)}catch{return}}async readdir(n){try{const i=await $.Promises.readdir(this.H(n),{withFileTypes:!0}),t=[];return await Promise.all(i.map(async r=>{try{let o;r.isSymbolicLink()?o=(await this.stat((0,b.$wg)(n,r.name))).type:o=this.M(r),t.push([r.name,o])}catch(o){this.a.trace(o)}})),t}catch(i){throw this.fb(i)}}M(n,i){let t;return i?.dangling?t=w.FileType.Unknown:n.isFile()?t=w.FileType.File:n.isDirectory()?t=w.FileType.Directory:t=w.FileType.Unknown,i&&(t|=w.FileType.SymbolicLink),t}async O(n){const i=this.H(n);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let t;for(;t=this.N.get(n);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await t.wait();const r=new j.$Tg;return this.N.set(n,r),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,d.$Pc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.N.get(n)===r&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.N.delete(n)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),r.open()})}async readFile(n,i){let t;try{i?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(n)})`),t=await this.O(n));const r=this.H(n);return await $.Promises.readFile(r)}catch(r){throw this.fb(r)}finally{t?.dispose()}}P(n){s.I&&this.a.trace(n)}readFileStream(n,i,t){const r=(0,l.$3d)(o=>O.$ce.concat(o.map(v=>O.$ce.wrap(v))).buffer);return(0,c.$Qp)(this,n,r,o=>o.buffer,{...i,bufferSize:256*1024},t),r}async writeFile(n,i,t){return t?.atomic!==!1&&t?.atomic?.postfix&&await this.Q(n)?this.R(n,(0,b.$wg)((0,b.$vg)(n),`${(0,b.$tg)(n)}${t.atomic.postfix}`),i,t):this.S(n,i,t)}async Q(n){try{const i=this.H(n),{symbolicLink:t}=await $.SymlinkSupport.stat(i);if(t)return!1}catch{}return!0}async R(n,i,t,r){const o=new d.$Qc;try{o.add(await this.O(n)),o.add(await this.O(i)),await this.S(i,t,r,!0);try{await this.rename(i,n,{overwrite:!0})}catch(v){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw v}}finally{o.dispose()}}async S(n,i,t,r){let o;try{const v=this.H(n);if(!t.create||!t.overwrite){if(await $.Promises.exists(v)){if(!t.overwrite)throw(0,w.$pk)((0,y.localize)(0,null),w.FileSystemProviderErrorCode.FileExists)}else if(!t.create)throw(0,w.$pk)((0,y.localize)(1,null),w.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(n,{create:!0,unlock:t.unlock},r),await this.write(o,0,i,0,i.byteLength)}catch(v){throw await this.gb(n,v)}finally{typeof o=="number"&&await this.close(o)}}static{this.Y=!0}static configureFlushOnWrite(n){s.Y=n}async open(n,i,t){const r=this.H(n);let o;(0,w.$dk)(i)&&!t&&(o=await this.O(n));let v;try{if((0,w.$dk)(i)&&i.unlock)try{const{stat:h}=await $.SymlinkSupport.stat(r);h.mode&128||await $.Promises.chmod(r,h.mode|128)}catch(h){h.code!=="ENOENT"&&this.a.trace(h)}let p;if((0,w.$dk)(i)){if(E.$j)try{await $.Promises.truncate(r,0),p="r+"}catch(h){h.code!=="ENOENT"&&this.a.trace(h)}p||(p="w")}else p="r";v=await $.Promises.open(r,p)}catch(p){throw o?.dispose(),(0,w.$dk)(i)?await this.gb(n,p):this.fb(p)}if(this.U.set(v,0),(0,w.$dk)(i)&&this.X.set(v,n),o){const p=this.W.get(v);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${v} (${r})`),this.W.set(v,o),p&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${v} (${r})`),p.dispose())}return v}async close(n){const i=this.W.get(n);try{if(this.U.delete(n),this.X.delete(n)&&s.Y)try{await $.Promises.fdatasync(n)}catch(t){s.configureFlushOnWrite(!1),this.a.error(t)}return await $.Promises.close(n)}catch(t){throw this.fb(t)}finally{i&&(this.W.get(n)===i&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.W.delete(n)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),i.dispose())}}async read(n,i,t,r,o){const v=this.Z(n,i);let p=null;try{p=(await $.Promises.read(n,t,r,o,v)).bytesRead}catch(h){throw this.fb(h)}finally{this.$(n,v,p)}return p}Z(n,i){return i===this.U.get(n)?null:i}$(n,i,t){const r=this.U.get(n);typeof r=="number"&&(typeof i=="number"||(typeof t=="number"?this.U.set(n,r+t):this.U.delete(n)))}async write(n,i,t,r,o){return(0,j.$dh)(()=>this.ab(n,i,t,r,o),100,3)}async ab(n,i,t,r,o){const v=this.Z(n,i);let p=null;try{p=(await $.Promises.write(n,t,r,o,v)).bytesWritten}catch(h){throw await this.gb(this.X.get(n),h)}finally{this.$(n,v,p)}return p}async mkdir(n){try{await $.Promises.mkdir(this.H(n))}catch(i){throw this.fb(i)}}async delete(n,i){try{const t=this.H(n);if(i.recursive){let r;i?.atomic!==!1&&i.atomic.postfix&&(r=(0,P.$ic)((0,P.$lc)(t),`${(0,P.$mc)(t)}${i.atomic.postfix}`)),await $.Promises.rm(t,$.RimRafMode.MOVE,r)}else try{await $.Promises.unlink(t)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let o=!1;try{const{stat:v,symbolicLink:p}=await $.SymlinkSupport.stat(t);o=v.isDirectory()&&!p}catch{}if(o)await $.Promises.rmdir(t);else throw r}else throw r}}catch(t){throw this.fb(t)}}async rename(n,i,t){const r=this.H(n),o=this.H(i);if(r!==o)try{await this.bb(n,i,"move",t.overwrite),await $.Promises.rename(r,o)}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,y.localize)(2,null,(0,P.$mc)(r),(0,P.$mc)((0,P.$lc)(o)),v.toString()))),this.fb(v)}}async copy(n,i,t){const r=this.H(n),o=this.H(i);if(r!==o)try{await this.bb(n,i,"copy",t.overwrite),await $.Promises.copy(r,o,{preserveSymlinks:!0})}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,y.localize)(3,null,(0,P.$mc)(r),(0,P.$mc)((0,P.$lc)(o)),v.toString()))),this.fb(v)}}async bb(n,i,t,r){const o=this.H(n),v=this.H(i);let p=!1;if(!!(this.capabilities&1024)||(p=(0,S.$Xf)(o,v,!0)),p){if(t==="copy")throw(0,w.$pk)((0,y.localize)(4,null),w.FileSystemProviderErrorCode.FileExists);if(t==="move")return}const g=await this.L(n);if(!g)throw(0,w.$pk)((0,y.localize)(5,null),w.FileSystemProviderErrorCode.FileNotFound);const D=await this.L(i);if(D){if(!r)throw(0,w.$pk)((0,y.localize)(6,null),w.FileSystemProviderErrorCode.FileExists);g.type&w.FileType.File&&D.type&w.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(n,i){return this.cb(n,i,!1)}async cb(n,i,t){const r=this.H(n),o=this.H(i),v=!!(this.capabilities&1024);if((0,S.$Xf)(r,o,!v))return;const p=new d.$Qc;try{p.add(await this.O(n)),p.add(await this.O(i)),t&&await $.Promises.mkdir((0,P.$lc)(o),{recursive:!0}),await $.Promises.copyFile(r,o)}catch(h){if(h.code==="ENOENT"&&!t)return this.cb(n,i,!0);throw this.fb(h)}finally{p.dispose()}}t(n,i,t){return new m.$8p(r=>n(r),r=>i(r),t)}F(n,i,t){return new k.$dq(r=>n(r),r=>i(r),t)}fb(n){if(n instanceof w.$ok)return n;let i=n,t;switch(n.code){case"ENOENT":t=w.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=w.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=w.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=w.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=w.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${n.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,t=w.FileSystemProviderErrorCode.Unknown;break;default:t=w.FileSystemProviderErrorCode.Unknown}return(0,w.$pk)(i,t)}async gb(n,i){let t=this.fb(i);if(n&&t.code===w.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await $.SymlinkSupport.stat(this.H(n));r.mode&128||(t=(0,w.$pk)(i,w.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return t}}e.$eq=s}),define(ae[101],ce([0,1,3,2,4,8]),function(ie,e,I,N,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$79b=e.$69b=void 0,e.$69b=(0,j.$Th)("sharedProcessLifecycleService");let O=class extends N.$Rc{constructor(S){super(),this.b=S,this.a=this.B(new I.$Od),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.$79b=O,e.$79b=O=pe([X(0,L.$bj)],O)}),define(ae[200],ce([0,1,10,3,8,2]),function(ie,e,I,N,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$er=e.$dr=e.$cr=void 0;class O extends j.$mj{constructor(E,b,l,$,y){super(b,l,$),this.r=E,this.t=y,this.B(y.listen("onDidChangeLogLevel",E)(w=>{(0,j.$dj)(w)?super.setLogLevel(w):super.setLogLevel(I.URI.revive(w[0]),w[1])})),this.B(y.listen("onDidChangeVisibility",E)(([w,c])=>super.setVisibility(I.URI.revive(w),c))),this.B(y.listen("onDidChangeLoggers",E)(({added:w,removed:c})=>{for(const u of w)super.registerLogger({...u,resource:I.URI.revive(u.resource)});for(const u of c)super.deregisterLogger(u.resource)}))}createConsoleMainLogger(){return new j.$kj({log:(E,b)=>{this.t.call("consoleLog",[E,b])}})}registerLogger(E){super.registerLogger(E),this.t.call("registerLogger",[E,this.r])}deregisterLogger(E){super.deregisterLogger(E),this.t.call("deregisterLogger",[E,this.r])}setLogLevel(E,b){super.setLogLevel(E,b),this.t.call("setLogLevel",[E,b])}setVisibility(E,b){super.setVisibility(E,b),this.t.call("setVisibility",[this.n(E),b])}s(E,b,l){return new R(this.t,E,b,l,this.r)}static setLogLevel(E,b,l){return E.call("setLogLevel",[b,l])}}e.$cr=O;class R extends j.$hj{constructor(E,b,l,$,y){super($?.logLevel==="always"),this.r=E,this.s=b,this.m=!1,this.n=[],this.setLevel(l),this.r.call("createLogger",[b,$,y]).then(()=>{this.u(this.n),this.m=!0})}g(E,b){const l=[[E,b]];this.m?this.u(l):this.n.push(...l)}u(E){this.r.call("log",[this.s,E])}}class S{constructor(E,b){this.a=E,this.b=b}listen(E,b){const l=this.b(E);switch(b){case"onDidChangeLoggers":return N.Event.map(this.a.onDidChangeLoggers,$=>({added:[...$.added].map(y=>this.c(y,l)),removed:[...$.removed].map(y=>this.c(y,l))}));case"onDidChangeVisibility":return N.Event.map(this.a.onDidChangeVisibility,$=>[l.transformOutgoingURI($[0]),$[1]]);case"onDidChangeLogLevel":return N.Event.map(this.a.onDidChangeLogLevel,$=>(0,j.$dj)($)?$:[l.transformOutgoingURI($[0]),$[1]])}throw new Error(`Event not found: ${b}`)}async call(E,b,l){const $=this.b(E);switch(b){case"setLogLevel":return(0,j.$dj)(l[0])?this.a.setLogLevel(l[0]):this.a.setLogLevel(I.URI.revive($.transformIncoming(l[0][0])),l[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(y=>this.c(y,$)))}throw new Error(`Call not found: ${b}`)}c(E,b){return{...E,resource:b.transformOutgoingURI(E.resource)}}}e.$dr=S;class d extends L.$Rc{constructor(E,b){super(),b.call("setLogLevel",[E.getLogLevel()]),this.B(E.onDidChangeLogLevel(l=>b.call("setLogLevel",[l]))),b.call("getRegisteredLoggers").then(l=>{for(const $ of l)E.registerLogger({...$,resource:I.URI.revive($.resource)})}),this.B(b.listen("onDidChangeVisibility")(([l,$])=>E.setVisibility(I.URI.revive(l),$))),this.B(b.listen("onDidChangeLoggers")(({added:l,removed:$})=>{for(const y of l)E.registerLogger({...y,resource:I.URI.revive(y.resource)});for(const y of $)E.deregisterLogger(y.resource)}))}}e.$er=d}),define(ae[201],ce([0,1,2,8]),function(ie,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UN=void 0;class j extends I.$Rc{constructor(O,R=[]){super(),this.a=new N.$lj([O,...R]),this.B(O.onDidChangeLogLevel(S=>this.setLevel(S)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(O){this.a.setLevel(O)}getLevel(){return this.a.getLevel()}trace(O,...R){this.a.trace(O,...R)}debug(O,...R){this.a.debug(O,...R)}info(O,...R){this.a.info(O,...R)}warn(O,...R){this.a.warn(O,...R)}error(O,...R){this.a.error(O,...R)}flush(){this.a.flush()}}e.$UN=j}),define(ae[56],ce([0,1,4]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$27b=void 0,e.$27b=(0,I.$Th)("nativeHostService")}),define(ae[202],ce([0,1,40,55]),function(ie,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j9b=void 0;let j=class{constructor(O,R){return this.windowId=O,I.ProxyChannel.toService(R.getChannel("nativeHost"),{context:O,properties:(()=>{const S=new Map;return S.set("windowId",O),S})()})}};e.$j9b=j,e.$j9b=j=pe([X(1,N.$d9b)],j)}),define(ae[57],ce([0,1,3,60,2,4]),function(ie,e,I,N,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$on=e.$nn=e.$mn=void 0,e.$mn=(0,L.$Th)("policy");class O extends j.$Rc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new I.$Od),this.onDidChange=this.h.event}async updatePolicyDefinitions(d){const P=Object.keys(this.f).length;return this.f={...d,...this.f},P!==Object.keys(this.f).length&&await this.j(d),N.Iterable.reduce(this.g.entries(),(E,[b,l])=>({...E,[b]:l}),{})}getPolicyValue(d){return this.g.get(d)}serialize(){return N.Iterable.reduce(Object.entries(this.f),(d,[P,E])=>({...d,[P]:{definition:E,value:this.g.get(P)}}),{})}}e.$nn=O;class R{constructor(){this.onDidChange=I.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$on=R}),define(ae[203],ce([0,1,3,2,57]),function(ie,e,I,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M8b=e.$L8b=void 0;class L{constructor(S){this.b=S,this.a=new N.$Qc}listen(S,d){switch(d){case"onDidChange":return I.Event.map(this.b.onDidChange,P=>P.reduce((E,b)=>({...E,[b]:this.b.getPolicyValue(b)??null}),{}),this.a)}throw new Error(`Event not found: ${d}`)}call(S,d,P){switch(d){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(P)}throw new Error(`Call not found: ${d}`)}dispose(){this.a.dispose()}}e.$L8b=L;class O extends j.$nn{constructor(S,d){super(),this.a=d;for(const P in S){const{definition:E,value:b}=S[P];this.f[P]=E,b!==void 0&&this.g.set(P,b)}this.a.listen("onDidChange")(P=>{for(const E in P){const b=P[E];b===null?this.g.delete(E):this.g.set(E,b)}this.h.fire(Object.keys(P))})}async j(S){const d=await this.a.call("updatePolicyDefinitions",S);for(const P in d)this.g.set(P,d[P])}}e.$M8b=O}),define(ae[102],ce([0,1,5,37]),function(ie,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let j;if(typeof I.$h.vscode<"u"&&typeof I.$h.vscode.context<"u"){const L=I.$h.vscode.context.configuration();if(L)j=L.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(j=globalThis._VSCODE_PRODUCT_JSON,N.env.VSCODE_DEV&&Object.assign(j,{nameShort:`${j.nameShort} Dev`,nameLong:`${j.nameLong} Dev`,dataFolderName:`${j.dataFolderName}-dev`,serverDataFolderName:j.serverDataFolderName?`${j.serverDataFolderName}-dev`:void 0}),!j.version){const L=globalThis._VSCODE_PACKAGE_JSON;Object.assign(j,{version:L.version})}}else j={},Object.keys(j).length===0&&Object.assign(j,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=j}),define(ae[25],ce([0,1,4]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uj=e.$tj=void 0,e.$tj=(0,I.$Th)("productService"),e.$uj="vscode://schemas/vscode-product"}),define(ae[204],ce([0,1,6,7,2,16,31,8,25]),function(ie,e,I,N,j,L,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A9b=void 0;let d=class extends j.$Rc{constructor(E,b,l){super(),this.b=b,this.c=l,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,E&&this.B(new I.$8g(()=>{this.f(E)},3e4)).schedule()}async f(E){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const b=Date.now(),l=(0,L.$lc)(E),$=(0,L.$mc)(E),y=await O.Promises.readdir(l);await Promise.all(y.map(async w=>{if(w===$)return;const c=(0,L.$ic)(l,w),u=await O.Promises.stat(c);if(u.isDirectory()&&b-u.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${w}.`),O.Promises.rm(c)}))}catch(b){(0,N.$Z)(b)}}};e.$A9b=d,e.$A9b=d=pe([X(1,S.$tj),X(2,R.$bj)],d)}),define(ae[205],ce([0,1,6,7,2,16,31,14,8,25]),function(ie,e,I,N,j,L,O,R,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B9b=void 0;let P=class extends j.$Rc{constructor(b,l,$){super(),this.b=b,this.c=l,this.f=$,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new I.$8g(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const b=Object.create(null),l=JSON.parse(await O.Promises.readFile((0,L.$ic)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const u of Object.keys(l)){const f=l[u];b[`${f.hash}.${u}`]=!0}const $=(0,L.$ic)(this.b.userDataPath,"clp");if(!await O.Promises.exists($))return;const w=await O.Promises.readdir($);for(const u of w){if(b[u]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${u}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${u}`),await O.Promises.rm((0,L.$ic)($,u))}const c=Date.now();for(const u of Object.keys(b)){const f=(0,L.$ic)($,u),m=await O.Promises.readdir(f);for(const k of m){if(k==="tcf.json")continue;const s=(0,L.$ic)(f,k),a=await O.Promises.stat(s);a.isDirectory()&&c-a.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,L.$ic)(u,k)}`),await O.Promises.rm(s))}}}catch(b){(0,N.$Z)(b)}}};e.$B9b=P,e.$B9b=P=pe([X(0,R.$2h),X(1,S.$bj),X(2,d.$tj)],P)}),define(ae[206],ce([0,1,16,4]),function(ie,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$bF=void 0,e.$bF=(0,N.$Th)("IV8InspectProfilingService");var j;(function(L){function O(S){return!!(S.samples&&S.timeDeltas)}L.isValidProfile=O;function R(S,d="noAbsolutePaths"){for(const P of S.nodes)P.callFrame&&P.callFrame.url&&((0,I.$hc)(P.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(P.callFrame.url))&&(P.callFrame.url=(0,I.$ic)(d,(0,I.$mc)(P.callFrame.url)));return S}L.rewriteAbsolutePaths=R})(j||(e.Utils=j={}))}),define(ae[207],ce([0,1,32]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V9b=void 0;class N{constructor(){this.a=new Map}async startProfiling(L){const R=await(await new Promise((d,P)=>{ie(["v8-inspect-profiler"],d,P)})).startProfiling({port:L.port,checkForPaused:!0}),S=(0,I.$fg)();return this.a.set(S,R),S}async stopProfiling(L){const O=this.a.get(L);if(!O)throw new Error(`UNKNOWN session '${L}'`);const R=await O.stop();return this.a.delete(L),R.profile}}e.$V9b=N}),define(ae[41],ce([0,1,126,12]),function(ie,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kn=void 0;class j{constructor(){this.a=new Map}add(O,R){I.ok(N.$zf(O)),I.ok(N.$Bf(R)),I.ok(!this.a.has(O),"There is already an extension with this id"),this.a.set(O,R)}knows(O){return this.a.has(O)}as(O){return this.a.get(O)||null}}e.$kn=new j}),define(ae[103],ce([0,1,3,41]),function(ie,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=void 0,e.$ln={JSONContribution:"base.contributions.json"};function j(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class L{constructor(){this.b=new I.$Od,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(S,d){this.a[j(S)]=d,this.b.fire(S)}notifySchemaChanged(S){this.b.fire(S)}getSchemaContributions(){return{schemas:this.a}}}const O=new L;N.$kn.add(e.$ln.JSONContribution,O)}),define(ae[50],ce([0,1,18,3,12,148,20,103,41]),function(ie,e,I,N,j,L,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.ConfigurationScope=e.$pn=e.EditPresentationTypes=void 0;var d;(function(k){k.Multiline="multilineText",k.Singleline="singlelineText"})(d||(e.EditPresentationTypes=d={})),e.$pn={Configuration:"base.contributions.configuration"};var P;(function(k){k[k.APPLICATION=1]="APPLICATION",k[k.MACHINE=2]="MACHINE",k[k.WINDOW=3]="WINDOW",k[k.RESOURCE=4]="RESOURCE",k[k.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",k[k.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P||(e.ConfigurationScope=P={})),e.$qn={properties:{},patternProperties:{}},e.$rn={properties:{},patternProperties:{}},e.$sn={properties:{},patternProperties:{}},e.$tn={properties:{},patternProperties:{}},e.$un={properties:{},patternProperties:{}},e.$vn={properties:{},patternProperties:{}},e.$wn="vscode://schemas/settings/resourceLanguage",e.$xn="vscode://schemas/settings/configurationDefaults";const E=S.$kn.as(R.$ln.JSONContribution);class b{constructor(){this.h=new Set,this.i=new N.$Od,this.onDidSchemaChange=this.i.event,this.j=new N.$Od,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},E.registerSchema(e.$wn,this.g),this.v()}registerConfiguration(s,a=!0){this.registerConfigurations([s],a)}registerConfigurations(s,a=!0){const n=new Set;this.n(s,a,n),E.registerSchema(e.$wn,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(s){const a=new Set;this.o(s,a),E.registerSchema(e.$wn,this.g),this.i.fire(),this.j.fire({properties:a})}updateConfigurations({add:s,remove:a}){const n=new Set;this.o(a,n),this.n(s,!1,n),E.registerSchema(e.$wn,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(s){const a=new Set;this.k(s,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}k(s,a){const n=[];for(const{overrides:i,source:t}of s)for(const r in i)if(a.add(r),e.$zn.test(r)){const o=this.a.get(r),v=o?.valuesSources??new Map;if(t)for(const D of Object.keys(i[r]))v.set(D,t);const p={...o?.value||{},...i[r]};this.a.set(r,{source:t,value:p,valuesSources:v});const h=(0,O.$xi)(r),g={type:"object",default:p,description:L.localize(1,null,h),$ref:e.$wn,defaultDefaultValue:p,source:j.$zf(t)?void 0:t,defaultValueSource:t};n.push(...y(r)),this.d[r]=g,this.b.properties[r]=g}else{this.a.set(r,{value:i[r],source:t});const o=this.d[r];o&&(this.w(r,o),this.r(r,o))}this.m(n)}deregisterDefaultConfigurations(s){const a=new Set;this.l(s,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}l(s,a){for(const{overrides:n,source:i}of s)for(const t in n){const r=this.a.get(t),o=j.$zf(i)?i:i?.id,v=j.$zf(r?.source)?r?.source:r?.source?.id;if(o===v)if(a.add(t),this.a.delete(t),e.$zn.test(t))delete this.d[t],delete this.b.properties[t];else{const p=this.d[t];p&&(this.w(t,p),this.r(t,p))}}this.u()}deltaConfiguration(s){let a=!1;const n=new Set;s.removedDefaults&&(this.l(s.removedDefaults,n),a=!0),s.addedDefaults&&(this.k(s.addedDefaults,n),a=!0),s.removedConfigurations&&this.o(s.removedConfigurations,n),s.addedConfigurations&&this.n(s.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:a})}notifyConfigurationSchemaUpdated(...s){this.i.fire()}registerOverrideIdentifiers(s){this.m(s),this.i.fire()}m(s){for(const a of s)this.h.add(a);this.u()}n(s,a,n){s.forEach(i=>{this.p(i,a,i.extensionInfo,i.restrictedProperties,void 0,n),this.c.push(i),this.q(i)})}o(s,a){const n=i=>{if(i.properties)for(const t in i.properties){a.add(t);const r=this.d[t];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[t],this.s(t,i.properties[t])}i.allOf?.forEach(t=>n(t))};for(const i of s){n(i);const t=this.c.indexOf(i);t!==-1&&this.c.splice(t,1)}}p(s,a=!0,n,i,t=3,r){t=j.$If(s.scope)?t:s.scope;const o=s.properties;if(o)for(const p in o){const h=o[p];if(a&&f(p,h)){delete o[p];continue}if(h.source=n,h.defaultDefaultValue=o[p].default,this.w(p,h),e.$zn.test(p)?h.scope=void 0:(h.scope=j.$If(h.scope)?t:h.scope,h.restricted=j.$If(h.restricted)?!!i?.includes(p):h.restricted),o[p].hasOwnProperty("included")&&!o[p].included){this.f[p]=o[p],delete o[p];continue}else this.d[p]=o[p],o[p].policy?.name&&this.e.set(o[p].policy.name,p);!o[p].deprecationMessage&&o[p].markdownDeprecationMessage&&(o[p].deprecationMessage=o[p].markdownDeprecationMessage),r.add(p)}const v=s.allOf;if(v)for(const p of v)this.p(p,a,n,i,t,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(s){const a=n=>{const i=n.properties;if(i)for(const r in i)this.r(r,i[r]);n.allOf?.forEach(a)};a(s)}r(s,a){switch(e.$qn.properties[s]=a,a.scope){case 1:e.$rn.properties[s]=a;break;case 2:e.$sn.properties[s]=a;break;case 6:e.$tn.properties[s]=a;break;case 3:e.$un.properties[s]=a;break;case 4:e.$vn.properties[s]=a;break;case 5:e.$vn.properties[s]=a,this.g.properties[s]=a;break}}s(s,a){switch(delete e.$qn.properties[s],a.scope){case 1:delete e.$rn.properties[s];break;case 2:delete e.$sn.properties[s];break;case 6:delete e.$tn.properties[s];break;case 3:delete e.$un.properties[s];break;case 4:case 5:delete e.$vn.properties[s],delete this.g.properties[s];break}}u(){for(const s of this.h.values()){const a=`[${s}]`,n={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.$wn};this.w(a,n),e.$qn.properties[a]=n,e.$rn.properties[a]=n,e.$sn.properties[a]=n,e.$tn.properties[a]=n,e.$un.properties[a]=n,e.$vn.properties[a]=n}}v(){const s={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.$wn};e.$qn.patternProperties[e.$yn]=s,e.$rn.patternProperties[e.$yn]=s,e.$sn.patternProperties[e.$yn]=s,e.$tn.patternProperties[e.$yn]=s,e.$un.patternProperties[e.$yn]=s,e.$vn.patternProperties[e.$yn]=s,this.i.fire()}w(s,a){const n=this.a.get(s);let i=n?.value,t=n?.source;j.$Gf(i)&&(i=a.defaultDefaultValue,t=void 0),j.$Gf(i)&&(i=c(a.type)),a.default=i,a.defaultValueSource=t}}const l="\\[([^\\]]+)\\]",$=new RegExp(l,"g");e.$yn=`^(${l})+$`,e.$zn=new RegExp(e.$yn);function y(k){const s=[];if(e.$zn.test(k)){let a=$.exec(k);for(;a?.length;){const n=a[1].trim();n&&s.push(n),a=$.exec(k)}}return(0,I.$Lb)(s)}e.$An=y;function w(k){return k.reduce((s,a)=>`${s}[${a}]`,"")}e.$Bn=w;function c(k){switch(Array.isArray(k)?k[0]:k){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Cn=c;const u=new b;S.$kn.add(e.$pn.Configuration,u);function f(k,s){return k.trim()?e.$zn.test(k)?L.localize(7,null,k):u.getConfigurationProperties()[k]!==void 0?L.localize(8,null,k):s.policy?.name&&u.getPolicyConfigurations().get(s.policy?.name)!==void 0?L.localize(9,null,k,s.policy?.name,u.getPolicyConfigurations().get(s.policy?.name)):null:L.localize(6,null)}e.$Dn=f;function m(){const k=[],s=u.getConfigurationProperties();for(const a of Object.keys(s))k.push([a,s[a].scope]);return k.push(["launch",4]),k.push(["task",4]),k}e.$En=m}),define(ae[74],ce([0,1,18,3,35,2,34,30,12,10,20,50,41]),function(ie,e,I,N,j,L,O,R,S,d,P,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=void 0;function l(a){return Object.isFrozen(a)?a:R.$_m(a)}class ${constructor(n={},i=[],t=[],r){this.b=n,this.c=i,this.d=t,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const n=this.raw.map(i=>{if(i instanceof $)return i;const t=new y("");return t.parseRaw(i),t.configurationModel});this.f=n.reduce((i,t)=>t===i?t:i.merge(t),n[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,P.$vi)(this.contents,n):this.contents}inspect(n,i){const t=this.rawConfiguration.getValue(n),r=i?this.rawConfiguration.getOverrideValue(n,i):void 0,o=i?this.rawConfiguration.override(i).getValue(n):t;return{value:t,override:r,merged:o}}getOverrideValue(n,i){const t=this.i(i);return t?n?(0,P.$vi)(t,n):t:void 0}getKeysForOverrideIdentifier(n){const i=[];for(const t of this.overrides)t.identifiers.includes(n)&&i.push(...t.keys);return I.$Lb(i)}getAllOverrideIdentifiers(){const n=[];for(const i of this.overrides)n.push(...i.identifiers);return I.$Lb(n)}override(n){let i=this.a.get(n);return i||(i=this.g(n),this.a.set(n,i)),i}merge(...n){const i=R.$$m(this.contents),t=R.$$m(this.overrides),r=[...this.keys],o=this.raw?.length?[...this.raw]:[this];for(const v of n)if(o.push(...v.raw?.length?v.raw:[v]),!v.isEmpty()){this.h(i,v.contents);for(const p of v.overrides){const[h]=t.filter(g=>I.$tb(g.identifiers,p.identifiers));h?(this.h(h.contents,p.contents),h.keys.push(...p.keys),h.keys=I.$Lb(h.keys)):t.push(R.$$m(p))}for(const p of v.keys)r.indexOf(p)===-1&&r.push(p)}return new $(i,r,t,o.every(v=>v instanceof $)?void 0:o)}g(n){const i=this.i(n);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const t={};for(const r of I.$Lb([...Object.keys(this.contents),...Object.keys(i)])){let o=this.contents[r];const v=i[r];v&&(typeof o=="object"&&typeof v=="object"?(o=R.$$m(o),this.h(o,v)):o=v),t[r]=o}return new $(t,this.keys,this.overrides)}h(n,i){for(const t of Object.keys(i)){if(t in n&&S.$Bf(n[t])&&S.$Bf(i[t])){this.h(n[t],i[t]);continue}n[t]=R.$$m(i[t])}}i(n){let i=null,t=null;const r=o=>{o&&(t?this.h(t,o):t=R.$$m(o))};for(const o of this.overrides)o.identifiers.length===1&&o.identifiers[0]===n?i=o.contents:o.identifiers.includes(n)&&r(o.contents);return r(i),t}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,i){this.j(n,i,!0)}setValue(n,i){this.j(n,i,!1)}removeValue(n){const i=this.keys.indexOf(n);i!==-1&&(this.keys.splice(i,1),(0,P.$ui)(this.contents,n),E.$zn.test(n)&&this.overrides.splice(this.overrides.findIndex(t=>I.$tb(t.identifiers,(0,E.$An)(n))),1))}j(n,i,t){(0,P.$ti)(this.contents,n,i,r=>console.error(r)),t=t||this.keys.indexOf(n)===-1,t&&this.keys.push(n),E.$zn.test(n)&&this.overrides.push({identifiers:(0,E.$An)(n),keys:Object.keys(this.contents[n]),contents:(0,P.$si)(this.contents[n],r=>console.error(r))})}}e.$Fn=$;class y{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new $}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,i){if(!S.$If(n)){const t=this.g(n);this.parseRaw(t,i)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,i){this.a=n;const{contents:t,keys:r,overrides:o,restricted:v,hasExcludedProperties:p}=this.h(n,i);this.b=new $(t,r,o,p?[n]:void 0),this.c=v||[]}g(n){let i={},t=null,r=[];const o=[],v=[];function p(g){Array.isArray(r)?r.push(g):t!==null&&(r[t]=g)}const h={onObjectBegin:()=>{const g={};p(g),o.push(r),r=g,t=null},onObjectProperty:g=>{t=g},onObjectEnd:()=>{r=o.pop()},onArrayBegin:()=>{const g=[];p(g),o.push(r),r=g,t=null},onArrayEnd:()=>{r=o.pop()},onLiteralValue:p,onError:(g,D,T)=>{v.push({error:g,offset:D,length:T})}};if(n)try{j.$8m(n,h),i=r[0]||{}}catch(g){console.error(`Error while parsing settings file ${this.f}: ${g}`),this.d=[g]}return i}h(n,i){const t=b.$kn.as(E.$pn.Configuration).getConfigurationProperties(),r=this.i(n,t,!0,i);n=r.raw;const o=(0,P.$si)(n,h=>console.error(`Conflict in settings file ${this.f}: ${h}`)),v=Object.keys(n),p=this.j(n,h=>console.error(`Conflict in settings file ${this.f}: ${h}`));return{contents:o,keys:v,overrides:p,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(n,i,t,r){let o=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:o};const v={},p=[];for(const h in n)if(E.$zn.test(h)&&t){const g=this.i(n[h],i,!1,r);v[h]=g.raw,o=o||g.hasExcludedProperties,p.push(...g.restricted)}else{const g=i[h],D=g?typeof g.scope<"u"?g.scope:3:void 0;g?.restricted&&p.push(h),!r.exclude?.includes(h)&&(r.include?.includes(h)||(D===void 0||r.scopes===void 0||r.scopes.includes(D))&&!(r.skipRestricted&&g?.restricted))?v[h]=n[h]:o=!0}return{raw:v,restricted:p,hasExcludedProperties:o}}j(n,i){const t=[];for(const r of Object.keys(n))if(E.$zn.test(r)){const o={};for(const v in n[r])o[v]=n[r][v];t.push({identifiers:(0,E.$An)(r),keys:Object.keys(o),contents:(0,P.$si)(o,i)})}return t}}e.$Gn=y;class w extends L.$Rc{constructor(n,i,t,r){super(),this.c=n,this.f=i,this.g=r,this.b=this.B(new N.$Od),this.onDidChange=this.b.event,this.a=new y(this.c.toString()),this.B(this.g.watch(t.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(N.Event.any(N.Event.filter(this.g.onDidFilesChange,o=>o.contains(this.c)),N.Event.filter(this.g.onDidRunOperation,o=>(o.isOperation(0)||o.isOperation(3)||o.isOperation(1)||o.isOperation(4))&&t.isEqual(o.resource,n)))(()=>this.b.fire()))}async loadConfiguration(){try{const n=await this.g.readFile(this.c);return this.a.parse(n.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new $}}reparse(n){return n&&(this.f=n),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Hn=w;class c{constructor(n,i,t,r,o,v,p,h,g,D,T,M,z){this.a=n,this.b=i,this.c=t,this.overrideIdentifiers=r,this.d=o,this.f=v,this.g=p,this.h=h,this.i=g,this.j=D,this.k=T,this.l=M,this.m=z}get value(){return l(this.c)}n(n,i,t){const r=n.inspect(i,t);return{get value(){return l(r.value)},get override(){return l(r.override)},get merged(){return l(r.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class u{constructor(n,i,t,r,o=new $,v=new $,p=new O.$zc,h=new $,g=new O.$zc){this.c=n,this.d=i,this.f=t,this.g=r,this.h=o,this.i=v,this.j=p,this.l=h,this.m=g,this.a=null,this.b=new O.$zc,this.n=null}getValue(n,i,t){return this.q(n,i,t).getValue(n)}updateValue(n,i,t={}){let r;t.resource?(r=this.m.get(t.resource),r||(r=new $,this.m.set(t.resource,r))):r=this.l,i===void 0?r.removeValue(n):r.setValue(n,i),t.resource||(this.a=null)}inspect(n,i,t){const r=this.q(n,i,t),o=this.u(i.resource,t),v=i.resource?this.m.get(i.resource)||this.l:this.l,p=new Set;for(const h of r.overrides)for(const g of h.identifiers)r.getOverrideValue(n,g)!==void 0&&p.add(g);return new c(n,i,r.getValue(n),p.size?[...p]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,t?this.i:void 0,o||void 0,v)}keys(n){const i=this.u(void 0,n);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.i=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,i){this.j.set(n,i),this.b.delete(n)}deleteFolderConfiguration(n){this.p.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,i){const t=[];if(!i){const{added:r,updated:o,removed:v}=k(this.c,n);i=[...r,...o,...v]}for(const r of i)for(const o of(0,E.$An)(r)){const v=this.c.getKeysForOverrideIdentifier(o),p=n.getKeysForOverrideIdentifier(o),h=[...p.filter(g=>v.indexOf(g)===-1),...v.filter(g=>p.indexOf(g)===-1),...v.filter(g=>!R.$cn(this.c.override(o).getValue(g),n.override(o).getValue(g)))];t.push([o,h])}return this.updateDefaultConfiguration(n),{keys:i,overrides:t}}compareAndUpdatePolicyConfiguration(n){const{added:i,updated:t,removed:r}=k(this.d,n),o=[...i,...t,...r];return o.length&&this.updatePolicyConfiguration(n),{keys:o,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:i,updated:t,removed:r,overrides:o}=k(this.applicationConfiguration,n),v=[...i,...t,...r];return v.length&&this.updateApplicationConfiguration(n),{keys:v,overrides:o}}compareAndUpdateLocalUserConfiguration(n){const{added:i,updated:t,removed:r,overrides:o}=k(this.localUserConfiguration,n),v=[...i,...t,...r];return v.length&&this.updateLocalUserConfiguration(n),{keys:v,overrides:o}}compareAndUpdateRemoteUserConfiguration(n){const{added:i,updated:t,removed:r,overrides:o}=k(this.remoteUserConfiguration,n),v=[...i,...t,...r];return v.length&&this.updateRemoteUserConfiguration(n),{keys:v,overrides:o}}compareAndUpdateWorkspaceConfiguration(n){const{added:i,updated:t,removed:r,overrides:o}=k(this.workspaceConfiguration,n),v=[...i,...t,...r];return v.length&&this.updateWorkspaceConfiguration(n),{keys:v,overrides:o}}compareAndUpdateFolderConfiguration(n,i){const t=this.p.get(n),{added:r,updated:o,removed:v,overrides:p}=k(t,i),h=[...r,...o,...v];return(h.length||!t)&&this.updateFolderConfiguration(n,i),{keys:h,overrides:p}}compareAndDeleteFolderConfiguration(n){const i=this.p.get(n);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:t,updated:r,removed:o,overrides:v}=k(i,void 0);return{keys:[...t,...r,...o],overrides:v}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(n,i,t){let r=this.r(i,t);return i.overrideIdentifier&&(r=r.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(r=r.merge(this.d)),r}r({resource:n},i){let t=this.s();if(i&&n){const r=i.getFolder(n);r&&(t=this.t(r.uri)||t);const o=this.m.get(n);o&&(t=t.merge(o))}return t}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(n){let i=this.b.get(n);if(!i){const t=this.s(),r=this.j.get(n);r?(i=t.merge(r),this.b.set(n,i)):i=t}return i}u(n,i){if(i&&n){const t=i.getFolder(n);if(t)return this.j.get(t.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((n,i)=>{const{contents:t,overrides:r,keys:o}=this.j.get(i);return n.push([i,{contents:t,overrides:r,keys:o}]),n},[])}}allKeys(){const n=new Set;return this.c.keys.forEach(i=>n.add(i)),this.userConfiguration.keys.forEach(i=>n.add(i)),this.i.keys.forEach(i=>n.add(i)),this.j.forEach(i=>i.keys.forEach(t=>n.add(t))),[...n.values()]}v(){const n=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(t=>n.add(t))),[...n.values()]}w(n){const i=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(t=>i.add(t)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(t=>i.add(t)),this.i.getKeysForOverrideIdentifier(n).forEach(t=>i.add(t)),this.j.forEach(t=>t.getKeysForOverrideIdentifier(n).forEach(r=>i.add(r))),[...i.values()]}static parse(n){const i=this.x(n.defaults),t=this.x(n.policy),r=this.x(n.application),o=this.x(n.user),v=this.x(n.workspace),p=n.folders.reduce((h,g)=>(h.set(d.URI.revive(g[0]),this.x(g[1])),h),new O.$zc);return new u(i,t,r,o,new $,v,p,new $,new O.$zc)}static x(n){return new $(n.contents,n.keys,n.overrides)}}e.$In=u;function f(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const n=new Set,i=new Map;for(const r of a)r.keys.forEach(o=>n.add(o)),r.overrides.forEach(([o,v])=>{const p=(0,O.$wc)(i,o,new Set);v.forEach(h=>p.add(h))});const t=[];return i.forEach((r,o)=>t.push([o,[...r.values()]])),{keys:[...n.values()],overrides:t}}e.$Jn=f;class m{constructor(n,i,t,r){this.change=n,this.f=i,this.g=t,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const o of n.keys)this.affectedKeys.add(o);for(const[,o]of n.overrides)for(const v of o)this.affectedKeys.add(v);this.d=this.a;for(const o of this.affectedKeys)this.d+=o+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=u.parse(this.f.data)),this.i}affectsConfiguration(n,i){const t=this.a+n,r=this.d.indexOf(t);if(r<0)return!1;const o=r+t.length;if(o>=this.d.length)return!1;const v=this.d.charCodeAt(o);if(v!==this.b&&v!==this.c)return!1;if(i){const p=this.previousConfiguration?this.previousConfiguration.getValue(n,i,this.f?.workspace):void 0,h=this.g.getValue(n,i,this.h);return!R.$cn(p,h)}return!0}}e.$Kn=m;function k(a,n){const{added:i,removed:t,updated:r}=s(n?.rawConfiguration,a?.rawConfiguration),o=[],v=a?.getAllOverrideIdentifiers()||[],p=n?.getAllOverrideIdentifiers()||[];if(n){const h=p.filter(g=>!v.includes(g));for(const g of h)o.push([g,n.getKeysForOverrideIdentifier(g)])}if(a){const h=v.filter(g=>!p.includes(g));for(const g of h)o.push([g,a.getKeysForOverrideIdentifier(g)])}if(n&&a){for(const h of v)if(p.includes(h)){const g=s({contents:a.getOverrideValue(void 0,h)||{},keys:a.getKeysForOverrideIdentifier(h)},{contents:n.getOverrideValue(void 0,h)||{},keys:n.getKeysForOverrideIdentifier(h)});o.push([h,[...g.added,...g.removed,...g.updated]])}}return{added:i,removed:t,updated:r,overrides:o}}function s(a,n){const i=a?n?a.keys.filter(o=>n.keys.indexOf(o)===-1):[...a.keys]:[],t=n?a?n.keys.filter(o=>a.keys.indexOf(o)===-1):[...n.keys]:[],r=[];if(a&&n){for(const o of n.keys)if(a.keys.indexOf(o)!==-1){const v=(0,P.$vi)(n.contents,o),p=(0,P.$vi)(a.contents,o);R.$cn(v,p)||r.push(o)}}return{added:i,removed:t,updated:r}}}),define(ae[208],ce([0,1,18,3,2,30,12,74,50,8,57,41]),function(ie,e,I,N,j,L,O,R,S,d,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nn=e.$Mn=e.$Ln=void 0;class b extends j.$Rc{constructor(){super(...arguments),this.a=this.B(new N.$Od),this.onDidChangeConfiguration=this.a.event,this.b=new R.$Fn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(E.$kn.as(S.$pn.Configuration).onDidUpdateConfiguration(({properties:w,defaultsOverrides:c})=>this.c(Array.from(w),c))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(w,c){this.h(w,E.$kn.as(S.$pn.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:w})}f(){return{}}g(){this.b=new R.$Fn;const w=E.$kn.as(S.$pn.Configuration).getConfigurationProperties();this.h(Object.keys(w),w)}h(w,c){const u=this.f();for(const f of w){const m=u[f],k=c[f];m!==void 0?this.b.addValue(f,m):k?this.b.addValue(f,k.default):this.b.removeValue(f)}}}e.$Ln=b;class l{constructor(){this.onDidChangeConfiguration=N.Event.None,this.configurationModel=new R.$Fn}async initialize(){return this.configurationModel}}e.$Mn=l;let $=class extends j.$Rc{get configurationModel(){return this.b}constructor(w,c,u){super(),this.c=w,this.f=c,this.g=u,this.a=this.B(new N.$Od),this.onDidChangeConfiguration=this.a.event,this.b=new R.$Fn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(w=>this.j(w))),this.B(this.c.onDidChangeConfiguration(async({properties:w})=>this.m(await this.h(w),!0))),this.b}async h(w){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",w);const c={},u=[],f=E.$kn.as(S.$pn.Configuration).getConfigurationProperties();for(const m of w){const k=f[m];if(!k){u.push(m);continue}if(k.policy){if(k.type!=="string"&&k.type!=="number"){this.g.warn(`Policy ${k.policy.name} has unsupported type ${k.type}`);continue}u.push(m),c[k.policy.name]={type:k.type}}}return(0,O.$Mf)(c)||await this.f.updatePolicyDefinitions(c),u}j(w){this.g.trace("PolicyConfiguration#onDidChangePolicies",w);const c=E.$kn.as(S.$pn.Configuration).getPolicyConfigurations(),u=(0,I.$Gb)(w.map(f=>c.get(f)));this.m(u,!0)}m(w,c){this.g.trace("PolicyConfiguration#update",w);const u=E.$kn.as(S.$pn.Configuration).getConfigurationProperties(),f=[],m=this.b.isEmpty();for(const k of w){const s=u[k]?.policy?.name;if(s){const a=this.f.getPolicyValue(s);(m?a!==void 0:!(0,L.$cn)(this.b.getValue(k),a))&&f.push([k,a])}else this.b.getValue(k)!==void 0&&f.push([k,void 0])}if(f.length){this.g.trace("PolicyConfiguration#changed",f);const k=this.b;this.b=new R.$Fn;for(const s of k.keys)this.b.setValue(s,k.getValue(s));for(const[s,a]of f)a===void 0?this.b.removeValue(s):this.b.setValue(s,a);c&&this.a.fire(this.b)}}};e.$Nn=$,e.$Nn=$=pe([X(1,P.$mn),X(2,d.$bj)],$)}),define(ae[209],ce([0,1,6,3,2,19,20,74,208,57]),function(ie,e,I,N,j,L,O,R,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=void 0;class P extends j.$Rc{constructor(b,l,$,y){super(),this.j=b,this.h=this.B(new N.$Od),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new S.$Ln),this.c=$ instanceof d.$on?new S.$Mn:this.B(new S.$Nn(this.b,$,y)),this.f=this.B(new R.$Hn(this.j,{},L.$ng,l)),this.a=new R.$In(this.b.configurationModel,this.c.configurationModel,new R.$Fn,new R.$Fn),this.g=this.B(new I.$8g(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:w,properties:c})=>this.n(w,c))),this.B(this.c.onDidChangeConfiguration(w=>this.r(w))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[b,l,$]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new R.$In(b,l,new R.$Fn,$)}getConfigurationData(){return this.a.toData()}getValue(b,l){const $=typeof b=="string"?b:void 0,y=(0,O.$oi)(b)?b:(0,O.$oi)(l)?l:{};return this.a.getValue($,y,void 0)}updateValue(b,l,$,y){return Promise.reject(new Error("not supported"))}inspect(b){return this.a.inspect(b,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const b=await this.f.loadConfiguration();this.m(b)}m(b){const l=this.a.toData(),$=this.a.compareAndUpdateLocalUserConfiguration(b);this.s($,l,2)}n(b,l){const $=this.a.toData(),y=this.a.compareAndUpdateDefaultConfiguration(b,l);this.s(y,$,7)}r(b){const l=this.a.toData(),$=this.a.compareAndUpdatePolicyConfiguration(b);this.s($,l,7)}s(b,l,$){const y=new R.$Kn(b,{data:l},this.a);y.source=$,y.sourceConfig=this.t($),this.h.fire(y)}t(b){switch(b){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$On=P}),define(ae[210],ce([0,1,15,3,2,67]),function(ie,e,I,N,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zpb=e.$Ypb=e.$Xpb=e.$Wpb=void 0;const O=(d,P,E)=>{const b=new Uint8Array(16);for(let y=0;y<16;y++)b[y]=Math.round(Math.random()*256);const l=(0,I.$we)(I.$ce.wrap(b));return[`GET ws://localhost${d}?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${l}`].join(`\r
`)+`\r
\r
`};e.$Wpb=O,e.$Xpb=I.$ce.fromString(`\r
\r
`);async function R(d,P,E,b,l){d.write(I.$ce.fromString((0,e.$Wpb)(P,E,b)));const $=new j.$Qc;try{return await new Promise((y,w)=>{let c;$.add(d.onData(u=>{c?c=I.$ce.concat([c,u],c.byteLength+u.byteLength):c=u;const f=c.indexOf(e.$Xpb);if(f===-1)return;y(d),d.pauseData();const m=c.slice(f+e.$Xpb.byteLength);m.byteLength&&l.onData.fire(m)})),$.add(d.onClose(u=>w(u??new Error("socket closed")))),$.add(d.onEnd(()=>w(new Error("socket ended"))))})}catch(y){throw d.dispose(),y}finally{$.dispose()}}e.$Ypb=R;class S extends j.$Rc{constructor(P,E){super(),this.g=P,this.a=this.B(new N.$Rd),this.onData=(...b)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...b)),this.b=this.B(new N.$Od),this.onDidDispose=this.b.event,this.f=!1,this.B(E.onData),this.B(E.onData.event(b=>this.a.fire(b))),this.onClose=this.B(E.onClose).event,this.onEnd=this.B(E.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(P,E){L.SocketDiagnostics.traceSocketEvent(this,this.g,P,E)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$Zpb=S}),define(ae[211],ce([0,1,7,4]),function(ie,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xk=e.$Wk=e.RemoteAuthorityResolverErrorCode=e.$Vk=e.$Uk=e.RemoteConnectionType=e.$Tk=void 0,e.$Tk=(0,N.$Th)("remoteAuthorityResolverService");var j;(function(P){P[P.WebSocket=0]="WebSocket",P[P.Managed=1]="Managed"})(j||(e.RemoteConnectionType=j={}));class L{constructor(E){this.id=E,this.type=1}toString(){return`Managed(${this.id})`}}e.$Uk=L;class O{constructor(E,b){this.host=E,this.port=b,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Vk=O;var R;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound",P.InvalidAuthority="InvalidAuthority"})(R||(e.RemoteAuthorityResolverErrorCode=R={}));class S extends I.$ab{static isNotAvailable(E){return E instanceof S&&E._code===R.NotAvailable}static isTemporarilyNotAvailable(E){return E instanceof S&&E._code===R.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof S&&E._code===R.NoResolverFound}static isInvalidAuthority(E){return E instanceof S&&E._code===R.InvalidAuthority}static isHandled(E){return E instanceof S&&E.isHandled}constructor(E,b=R.Unknown,l){super(E),this._message=E,this._code=b,this._detail=l,this.isHandled=b===R.NotAvailable&&l===!0,Object.setPrototypeOf(this,S.prototype)}}e.$Wk=S;function d(P){const E=P.indexOf("+");return E===-1?P:P.substring(0,E)}e.$Xk=d}),define(ae[75],ce([0,1,23]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3k=e.$2k=e.$1k=e.$Zk=e.$Yk=void 0;function N(d){return d.scheme===I.Schemas.vscodeRemote?d.authority:void 0}e.$Yk=N;function j(d){if(!d)return;const P=d.indexOf("+");return P<0?d:d.substr(0,P)}e.$Zk=j;function L(d){return`/${d.quality??"oss"}-${d.commit??"dev"}`}e.$1k=L;function O(d){const{host:P,port:E}=S(d);if(typeof E>"u")throw new Error("Remote authority doesn't contain a port!");return{host:P,port:E}}e.$2k=O;function R(d,P){let{host:E,port:b}=S(d);return typeof b>"u"&&(b=P),{host:E,port:b}}e.$3k=R;function S(d){const P=d.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const E=d.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const b=d.match(/(.*):(\d+)$/);return b?{host:b[1],port:parseInt(b[2],10)}:{host:d,port:void 0}}}),define(ae[44],ce([0,1,27,4,75]),function(ie,e,I,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.TargetPlatform=e.ExtensionType=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=void 0,e.$4l="extensions.user.cache",e.$5l="extensions.builtin.cache",e.$6l="undefined_publisher",e.$7l=["ui","workspace","web"];function L(y){if(typeof y=="object"&&y!==null&&y.supported!==!0)return y.description}e.$8l=L,e.$9l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var O;(function(y){y[y.System=0]="System",y[y.User=1]="User"})(O||(e.ExtensionType=O={}));var R;(function(y){y.WIN32_X64="win32-x64",y.WIN32_ARM64="win32-arm64",y.LINUX_X64="linux-x64",y.LINUX_ARM64="linux-arm64",y.LINUX_ARMHF="linux-armhf",y.ALPINE_X64="alpine-x64",y.ALPINE_ARM64="alpine-arm64",y.DARWIN_X64="darwin-x64",y.DARWIN_ARM64="darwin-arm64",y.WEB="web",y.UNIVERSAL="universal",y.UNKNOWN="unknown",y.UNDEFINED="undefined"})(R||(e.TargetPlatform=R={}));class S{constructor(w){this.value=w,this._lower=w.toLowerCase()}static equals(w,c){if(typeof w>"u"||w===null)return typeof c>"u"||c===null;if(typeof c>"u"||c===null)return!1;if(typeof w=="string"||typeof c=="string"){const u=typeof w=="string"?w:w.value,f=typeof c=="string"?c:c.value;return I.$3e(u,f)}return w._lower===c._lower}static toKey(w){return typeof w=="string"?w.toLowerCase():w._lower}}e.$0l=S;class d{get size(){return this.c.size}constructor(w){if(this.c=new Set,w)for(const c of w)this.add(c)}add(w){this.c.add(S.toKey(w))}delete(w){return this.c.delete(S.toKey(w))}has(w){return this.c.has(S.toKey(w))}}e.$$l=d;class P{constructor(){this.c=new Map}clear(){this.c.clear()}delete(w){this.c.delete(S.toKey(w))}get(w){return this.c.get(S.toKey(w))}has(w){return this.c.has(S.toKey(w))}set(w,c){this.c.set(S.toKey(w),c)}values(){return this.c.values()}forEach(w){this.c.forEach(w)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$_l=P;function E(y){return b(y)}e.$am=E;function b(y){return y.contributes&&y.contributes.localizations?y.contributes.localizations.length>0:!1}e.$bm=b;function l(y){return y.contributes&&y.contributes.authentication?y.contributes.authentication.length>0:!1}e.$cm=l;function $(y,w){if(w){const c=`onResolveRemoteAuthority:${(0,j.$Zk)(w)}`;return!!y.activationEvents?.includes(c)}return!1}e.$dm=$,e.$em=(0,N.$Th)("IBuiltinExtensionsScannerService")}),define(ae[212],ce([0,1,2,44,11]),function(ie,e,I,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kp=void 0;class L extends I.$Rc{constructor(R,S,d,P,E){super(),this.a=R,this.b=S,this.c=d,this.f=E,this.B(P.onDidInstallExtensions(b=>this.g(b))),this.B(P.onDidUninstallExtension(b=>this.h(b)))}g(R){for(const S of R)S.local&&this.invalidate(S.profileLocation)}h(R){R.error||this.invalidate(R.profileLocation)}async invalidate(R){if(R)for(const S of this.a.profiles)this.c.extUri.isEqual(S.extensionsResource,R)&&await this.j(S);else await this.j(this.a.defaultProfile)}async j(R){try{await this.b.del(this.c.extUri.joinPath(R.cacheHome,N.$4l))}catch(S){(0,j.$tk)(S)!==1&&this.f.error(S)}}}e.$Kp=L}),define(ae[213],ce([0,1,6,15,26,7,3,2,100,62,32,67,211,75]),function(ie,e,I,N,j,L,O,R,S,d,P,E,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.$$k=e.PersistentConnectionEventType=e.$0k=e.$9k=e.$8k=e.ConnectionType=void 0;const $=30*1e3;var y;(function(q){q[q.Management=1]="Management",q[q.ExtensionHost=2]="ExtensionHost",q[q.Tunnel=3]="Tunnel"})(y||(e.ConnectionType=y={}));function w(q){switch(q){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function c(q){const C=new j.$Yd;return setTimeout(()=>C.cancel(),q),C.token}function u(q,C){if(q.isCancellationRequested||C.isCancellationRequested)return j.CancellationToken.Cancelled;const A=new j.$Yd;return q.onCancellationRequested(()=>A.cancel()),C.onCancellationRequested(()=>A.cancel()),A.token}class f{get didTimeout(){return this.c==="timedout"}constructor(C){this.c="pending",this.d=new R.$Qc,this.promise=new Promise((A,J)=>{this.f=A,this.g=J}),C.isCancellationRequested?this.h():this.d.add(C.onCancellationRequested(()=>this.h()))}registerDisposable(C){this.c==="pending"?this.d.add(C):C.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const C=new Error("Time limit reached");return C.code="ETIMEDOUT",C.syscall="connect",C}resolve(C){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(C))}reject(C){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(C))}}function m(q,C){const A=new f(C);return A.registerDisposable(q.onControlMessage(J=>{const F=JSON.parse(J.toString()),U=V(F);U?A.reject(U):A.resolve(F)})),A.promise}function k(q,C,A,J,F,U,W,te){const se=new f(te),ue=d.$Kd.create(!1);return q.info(`Creating a socket (${W})...`),S.mark(`code/willCreateSocket/${U}`),C.connect(A,J,F,W).then(le=>{se.didTimeout?(S.mark(`code/didCreateSocketError/${U}`),q.info(`Creating a socket (${W}) finished after ${ue.elapsed()} ms, but this is too late and has timed out already.`),le?.dispose()):(S.mark(`code/didCreateSocketOK/${U}`),q.info(`Creating a socket (${W}) was successful after ${ue.elapsed()} ms.`),se.resolve(le))},le=>{S.mark(`code/didCreateSocketError/${U}`),q.info(`Creating a socket (${W}) returned an error after ${ue.elapsed()} ms.`),q.error(le),se.reject(le)}),se.promise}function s(q,C){const A=new f(C);return q.then(J=>{A.didTimeout||A.resolve(J)},J=>{A.didTimeout||A.reject(J)}),A.promise}async function a(q,C,A,J){const F=re(q,C);q.logService.trace(`${F} 1/6. invoking socketFactory.connect().`);let U;try{U=await k(q.logService,q.remoteSocketFactoryService,q.connectTo,(0,l.$1k)(q),`reconnectionToken=${q.reconnectionToken}&reconnection=${q.reconnectionProtocol?"true":"false"}`,w(C),`renderer-${w(C)}-${q.reconnectionToken}`,J)}catch(le){throw q.logService.error(`${F} socketFactory.connect() failed or timed out. Error:`),q.logService.error(le),le}q.logService.trace(`${F} 2/6. socketFactory.connect() was successful.`);let W,te;q.reconnectionProtocol?(q.reconnectionProtocol.beginAcceptReconnection(U,null),W=q.reconnectionProtocol,te=!1):(W=new E.$Hh({socket:U}),te=!0),q.logService.trace(`${F} 3/6. sending AuthRequest control message.`);const se=await s(q.signService.createNewMessage((0,P.$fg)()),J),ue={type:"auth",auth:q.connectionToken||"00000000000000000000",data:se.data};W.sendControl(N.$ce.fromString(JSON.stringify(ue)));try{const le=await m(W,u(J,c(1e4)));if(le.type!=="sign"||typeof le.data!="string"){const ve=new Error("Unexpected handshake message");throw ve.code="VSCODE_CONNECTION_ERROR",ve}if(q.logService.trace(`${F} 4/6. received SignRequest control message.`),!await s(q.signService.validate(se,le.signedData),J)){const ve=new Error("Refused to connect to unsupported server");throw ve.code="VSCODE_CONNECTION_ERROR",ve}const fe=await s(q.signService.sign(le.data),J),we={type:"connectionType",commit:q.commit,signedData:fe,desiredConnectionType:C};return A&&(we.args=A),q.logService.trace(`${F} 5/6. sending ConnectionTypeRequest control message.`),W.sendControl(N.$ce.fromString(JSON.stringify(we))),{protocol:W,ownsProtocol:te}}catch(le){throw le&&le.code==="ETIMEDOUT"&&(q.logService.error(`${F} the handshake timed out. Error:`),q.logService.error(le)),le&&le.code==="VSCODE_CONNECTION_ERROR"&&(q.logService.error(`${F} received error control message when negotiating connection. Error:`),q.logService.error(le)),te&&G(W),le}}async function n(q,C,A,J){const F=Date.now(),U=re(q,C),{protocol:W,ownsProtocol:te}=await a(q,C,A,J),se=new f(J);return se.registerDisposable(W.onControlMessage(ue=>{const le=JSON.parse(ue.toString()),$e=V(le);$e?(q.logService.error(`${U} received error control message when negotiating connection. Error:`),q.logService.error($e),te&&G(W),se.reject($e)):(q.reconnectionProtocol?.endAcceptReconnection(),q.logService.trace(`${U} 6/6. handshake finished, connection is up and running after ${Q(F)}!`),se.resolve({protocol:W,firstMessage:le}))})),se.promise}async function i(q,C){const{protocol:A}=await n(q,1,void 0,C);return{protocol:A}}async function t(q,C,A){const{protocol:J,firstMessage:F}=await n(q,2,C,A),U=F&&F.debugPort;return{protocol:J,debugPort:U}}async function r(q,C,A){const J=Date.now(),F=re(q,3),{protocol:U}=await a(q,3,C,A);return q.logService.trace(`${F} 6/6. handshake finished, connection is up and running after ${Q(J)}!`),U}async function o(q,C,A){const{connectTo:J,connectionToken:F}=await q.addressProvider.getAddress();return{commit:q.commit,quality:q.quality,connectTo:J,connectionToken:F,reconnectionToken:C,reconnectionProtocol:A,remoteSocketFactoryService:q.remoteSocketFactoryService,signService:q.signService,logService:q.logService}}async function v(q,C,A){return h(q,async J=>{const{protocol:F}=await i(J,j.CancellationToken.None);return new H(q,C,A,J.reconnectionToken,F)})}e.$8k=v;async function p(q,C){return h(q,async A=>{const{protocol:J,debugPort:F}=await t(A,C,j.CancellationToken.None);return new Y(q,C,A.reconnectionToken,J,F)})}e.$9k=p;async function h(q,C){for(let J=1;;J++)try{const F=(0,P.$fg)(),U=await o(q,F,null);return await C(U)}catch(F){if(J<5)q.logService.error(`[remote-connection][attempt ${J}] An error occurred in initial connection! Will retry... Error:`),q.logService.error(F);else throw q.logService.error(`[remote-connection][attempt ${J}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),q.logService.error(F),x.triggerPermanentFailure(0,0,b.$Wk.isHandled(F)),F}}async function g(q,C,A){const J=await o(q,(0,P.$fg)(),null);return await r(J,{host:C,port:A},j.CancellationToken.None)}e.$0k=g;function D(q){return(0,I.$Ig)(C=>new Promise((A,J)=>{const F=setTimeout(A,q*1e3);C.onCancellationRequested(()=>{clearTimeout(F),A()})}))}var T;(function(q){q[q.ConnectionLost=0]="ConnectionLost",q[q.ReconnectionWait=1]="ReconnectionWait",q[q.ReconnectionRunning=2]="ReconnectionRunning",q[q.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",q[q.ConnectionGain=4]="ConnectionGain"})(T||(e.PersistentConnectionEventType=T={}));class M{constructor(C,A){this.reconnectionToken=C,this.millisSinceLastIncomingData=A,this.type=0}}e.$$k=M;class z{constructor(C,A,J,F){this.reconnectionToken=C,this.millisSinceLastIncomingData=A,this.durationSeconds=J,this.c=F,this.type=1}skipWait(){this.c.cancel()}}e.$_k=z;class B{constructor(C,A,J){this.reconnectionToken=C,this.millisSinceLastIncomingData=A,this.attempt=J,this.type=2}}e.$al=B;class Z{constructor(C,A,J){this.reconnectionToken=C,this.millisSinceLastIncomingData=A,this.attempt=J,this.type=4}}e.$bl=Z;class K{constructor(C,A,J,F){this.reconnectionToken=C,this.millisSinceLastIncomingData=A,this.attempt=J,this.handled=F,this.type=3}}e.$cl=K;class x extends R.$Rc{static triggerPermanentFailure(C,A,J){this._permanentFailure=!0,this.f=C,this.g=A,this.h=J,this.j.forEach(F=>F.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(C=>C.y())}static debugPauseSocketWriting(){this.j.forEach(C=>C.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||x._permanentFailure}constructor(C,A,J,F,U){super(),this.t=C,this.u=A,this.reconnectionToken=J,this.protocol=F,this.w=U,this.m=this.B(new O.$Od),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new Z(this.reconnectionToken,0,0)),this.B(F.onSocketClose(W=>{const te=_(this.t,this.reconnectionToken,!0);W?W.type===0?(this.u.logService.info(`${te} received socket close event (hadError: ${W.hadError}).`),W.error&&this.u.logService.error(W.error)):(this.u.logService.info(`${te} received socket close event (wasClean: ${W.wasClean}, code: ${W.code}, reason: ${W.reason}).`),W.event&&this.u.logService.error(W.event)):this.u.logService.info(`${te} received socket close event.`),this.y()})),this.B(F.onSocketTimeout(W=>{const te=_(this.t,this.reconnectionToken,!0);this.u.logService.info(`${te} received socket timeout event (unacknowledgedMsgCount: ${W.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${W.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${W.timeSinceLastReceivedSomeData}).`),this.y()})),x.j.push(this),this.B((0,R.$Pc)(()=>{const W=x.j.indexOf(this);W>=0&&x.j.splice(W,1)})),this.n&&this.D(x.f,x.g,x.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const C=_(this.t,this.reconnectionToken,!0);this.u.logService.info(`${C} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const A=[0,5,5,10,10,10,10,10,30];let J=-1;do{J++;const F=J<A.length?A[J]:A[A.length-1];try{if(F>0){const W=D(F);this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F,W)),this.u.logService.info(`${C} waiting for ${F} seconds before reconnecting...`);try{await W}catch{}}if(this.n){this.u.logService.error(`${C} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new B(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),J+1)),this.u.logService.info(`${C} resolving connection...`);const U=await o(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${C} connecting to ${U.connectTo}...`),await this.G(U,c($)),this.u.logService.info(`${C} reconnected!`),this.m.fire(new Z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),J+1));break}catch(U){if(U.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${C} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(U),this.C(this.protocol.getMillisSinceLastIncomingData(),J+1,!1);break}if(J>360){this.u.logService.error(`${C} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(U),this.C(this.protocol.getMillisSinceLastIncomingData(),J+1,!1);break}if(b.$Wk.isTemporarilyNotAvailable(U)){this.u.logService.info(`${C} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(U);continue}if((U.code==="ETIMEDOUT"||U.code==="ENETUNREACH"||U.code==="ECONNREFUSED"||U.code==="ECONNRESET")&&U.syscall==="connect"){this.u.logService.info(`${C} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(U);continue}if((0,L.$3)(U)){this.u.logService.info(`${C} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(U);continue}if(U instanceof b.$Wk){this.u.logService.error(`${C} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(U),this.C(this.protocol.getMillisSinceLastIncomingData(),J+1,b.$Wk.isHandled(U));break}this.u.logService.error(`${C} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(U),this.C(this.protocol.getMillisSinceLastIncomingData(),J+1,!1);break}}while(!this.n&&!this.s)}C(C,A,J){this.w?x.triggerPermanentFailure(C,A,J):this.D(C,A,J)}D(C,A,J){this.m.fire(new K(this.reconnectionToken,C,A,J)),G(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$dl=x;class H extends x{constructor(C,A,J,F,U){super(1,C,F,U,!0),this.client=this.B(new E.$Fh(U,{remoteAuthority:A,clientId:J},C.ipcLogger))}async G(C,A){await i(C,A)}}e.$el=H;class Y extends x{constructor(C,A,J,F,U){super(2,C,J,F,!1),this.H=A,this.debugPort=U}async G(C,A){await t(C,this.H,A)}}e.$fl=Y;function G(q){try{q.acceptDisconnect();const C=q.getSocket();q.dispose(),C.dispose()}catch(C){(0,L.$Z)(C)}}function V(q){if(q&&q.type==="error"){const C=new Error(`Connection error: ${q.reason}`);return C.code="VSCODE_CONNECTION_ERROR",C}return null}function ee(q,C){for(;q.length<C;)q+=" ";return q}function ne(q,C){return`[remote-connection][${ee(w(q),13)}][${C.substr(0,5)}\u2026]`}function _(q,C,A){return`${ne(q,C)}[${A?"reconnect":"initial"}]`}function re(q,C){return`${_(C,q.reconnectionToken,!!q.reconnectionProtocol)}[${q.connectTo}]`}function Q(q){return`${Date.now()-q} ms`}}),define(ae[104],ce([0,1,2,4]),function(ie,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5k=e.$4k=void 0,e.$4k=(0,N.$Th)("remoteSocketFactoryService");class j{constructor(){this.a={}}register(O,R){return this.a[O]??=[],this.a[O].push(R),(0,I.$Pc)(()=>{const S=this.a[O]?.indexOf(R);typeof S=="number"&&S>=0&&this.a[O]?.splice(S,1)})}b(O){return(this.a[O.type]||[]).find(S=>S.supports(O))}connect(O,R,S,d){const P=this.b(O);if(!P)throw new Error(`No socket factory found for ${O}`);return P.connect(O,R,S,d)}}e.$5k=j}),define(ae[214],ce([0,1,4]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T9b=e.$S9b=void 0,e.$S9b=(0,I.$Th)("sharedProcessTunnelService"),e.$T9b="sharedProcessTunnel"}),define(ae[105],ce([0,1,4,163]),function(ie,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$49b=e.$39b=e.$29b=e.$19b=e.$Z9b=e.TunnelStates=e.$Y9b=e.$X9b=void 0,e.$X9b=(0,I.$Th)("IRemoteTunnelService"),e.$Y9b={active:!1};var j;(function(L){L.disconnected=O=>({type:"disconnected",onTokenFailed:O}),L.connected=(O,R)=>({type:"connected",info:O,serviceInstallFailed:R}),L.connecting=O=>({type:"connecting",progress:O}),L.uninitialized={type:"uninitialized"}})(j||(e.TunnelStates=j={})),e.$Z9b="remote.tunnels.access",e.$19b=e.$Z9b+".hostNameOverride",e.$29b=e.$Z9b+".preventSleep",e.$39b="remoteTunnelService",e.$49b=(0,N.localize)(0,null)}),define(ae[58],ce([0,1,15,7,2,165,50,4,8,41]),function(ie,e,I,N,j,L,O,R,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=void 0,e.$Wo=(0,R.$Th)("requestService");class P{constructor(k){this.b=k}toJSON(){if(!this.a){const k=Object.create(null);for(const s in this.b)s.toLowerCase()==="authorization"||s.toLowerCase()==="proxy-authorization"?k[s]="*****":k[s]=this.b[s];this.a=k}return this.a}}class E extends j.$Rc{constructor(k){super(),this.b=0,this.a=k.createLogger("network",{name:(0,L.localize)(0,null),when:S.$sj.isEqualTo((0,S.$qj)(S.LogLevel.Trace)).serialize()})}async c(k,s,a){const n=`${k} #${++this.b}: ${s.url}`;this.a.trace(`${n} - begin`,s.type,new P(s.headers??{}));try{const i=await a();return this.a.trace(`${n} - end`,s.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${n} - error`,s.type,(0,N.$9)(i)),i}}}e.$Xo=E;function b(m){return m.res.statusCode&&m.res.statusCode>=200&&m.res.statusCode<300||m.res.statusCode===1223}e.$Yo=b;function l(m){return m.res.statusCode===204}e.$Zo=l;async function $(m){return l(m)?null:(await(0,I.$oe)(m.stream)).toString()}e.$1o=$;async function y(m){if(!b(m))throw new Error("Server returned "+m.res.statusCode);return $(m)}e.$2o=y;async function w(m){if(!b(m))throw new Error("Server returned "+m.res.statusCode);if(l(m))return null;const s=(await(0,I.$oe)(m.stream)).toString();try{return JSON.parse(s)}catch(a){throw a.message+=`:
`+s,a}}e.$3o=w;function c(m){f(m)}e.$4o=c;let u;function f(m){const k=d.$kn.as(O.$pn.Configuration),s=u;u={id:"http",order:15,title:(0,L.localize)(1,null),type:"object",scope:m,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,L.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(6,null),(0,L.localize)(7,null),(0,L.localize)(8,null),(0,L.localize)(9,null)],default:"override",description:(0,L.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,L.localize)(12,null),restricted:!0}}},k.updateConfigurations({add:[u],remove:s?[s]:[]})}f(1)}),define(ae[215],ce([0,1,26,23,11,58]),function(ie,e,I,N,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0N=void 0;let O=class{constructor(S,d){this.a=S,this.b=d}async download(S,d,P=I.CancellationToken.None){if(S.scheme===N.Schemas.file||S.scheme===N.Schemas.vscodeRemote){await this.b.copy(S,d);return}const E={type:"GET",url:S.toString(!0)},b=await this.a.request(E,P);if(b.res.statusCode===200)await this.b.writeFile(d,b.stream);else{const l=await(0,L.$2o)(b);throw new Error(`Expected 200, got back ${b.res.statusCode} instead.

${l}`)}}};e.$0N=O,e.$0N=O=pe([X(0,L.$Wo),X(1,j.$ck)],O)}),define(ae[216],ce([0,1,15,26]),function(ie,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=e.$Zq=void 0;class j{constructor(R){this.a=R}listen(R,S){throw new Error("Invalid listen")}call(R,S,d,P=N.CancellationToken.None){switch(S){case"request":return this.a.request(d[0],P).then(async({res:E,stream:b})=>{const l=await(0,I.$oe)(b);return[{statusCode:E.statusCode,headers:E.headers},l]});case"resolveProxy":return this.a.resolveProxy(d[0])}throw new Error("Invalid call")}}e.$Zq=j;class L{constructor(R){this.a=R}async request(R,S){const[d,P]=await this.a.call("request",[R],S);return{res:d,stream:(0,I.$qe)(P)}}async resolveProxy(R){return this.a.call("resolveProxy",[R])}}e.$1q=L}),define(ae[217],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l8b=e.$k8b=e.$j8b=void 0,e.$j8b={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$k8b={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$l8b={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(ae[218],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d4b=void 0;class I{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(j){try{const L=await this.c();if(L){const O=String(I.a++);return this.b.set(O,L),{id:O,data:L.createNewMessage(j)}}}catch{}return{id:"",data:j}}async validate(j,L){if(!j.id)return!0;const O=this.b.get(j.id);if(!O)return!1;this.b.delete(j.id);try{return O.validate(L)==="ok"}catch{return!1}finally{O.dispose?.()}}async sign(j){try{return await this.d(j)}catch{}return j}}e.$d4b=I}),define(ae[106],ce([0,1,4]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7k=e.$6k=void 0,e.$6k="signService",e.$7k=(0,I.$Th)(e.$6k)}),define(ae[219],ce([0,1,218]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_8b=void 0;class N extends I.$d4b{c(){return this.h().then(L=>new L.validator)}d(L){return this.h().then(O=>new O.signer().sign(L))}h(){return new Promise((L,O)=>ie(["vsda"],L,O))}}e.$_8b=N}),define(ae[76],ce([0,1,3,2]),function(ie,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XDb=e.$WDb=e.$VDb=e.$UDb=void 0;class j extends N.$Rc{constructor(E,b,l){super(),this.a=E,this.b=b,this.c=l}async getItems(){const E={profile:this.b,workspace:this.c},b=await this.a.call("getItems",E);return new Map(b)}updateItems(E){const b={profile:this.b,workspace:this.c};return E.insert&&(b.insert=Array.from(E.insert.entries())),E.delete&&(b.delete=Array.from(E.delete.values())),this.a.call("updateItems",b)}optimize(){const E={profile:this.b,workspace:this.c};return this.a.call("optimize",E)}}class L extends j{constructor(E,b){super(E,b,void 0),this.f=this.B(new I.$Od),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(E=>this.h(E)))}h(E){(Array.isArray(E.changed)||Array.isArray(E.deleted))&&this.f.fire({changed:E.changed?new Map(E.changed):void 0,deleted:E.deleted?new Set(E.deleted):void 0})}}class O extends L{constructor(E){super(E,void 0)}async close(){this.dispose()}}e.$UDb=O;class R extends L{constructor(E,b){super(E,b)}async close(){this.dispose()}}e.$VDb=R;class S extends j{constructor(E,b){super(E,void 0,b),this.onDidChangeItemsExternal=I.Event.None}async close(){this.dispose()}}e.$WDb=S;class d{constructor(E){this.a=E}isUsed(E){const b={payload:E,profile:void 0,workspace:void 0};return this.a.call("isUsed",b)}}e.$XDb=d}),define(ae[107],ce([0,1,5,37,32]),function(ie,e,I,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mo=e.$lo=void 0;function L(S){if(I.$u===2&&/^penguin(\.|$)/i.test(S))return"chromebook"}function O(S,d,P,E,b,l,$,y,w){const c=Object.create(null);c["common.machineId"]=l,c["common.sqmId"]=$,c.sessionID=(0,j.$fg)()+Date.now(),c.commitHash=E,c.version=b,c["common.platformVersion"]=(S||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,I.$i)(I.$u),c["common.nodePlatform"]=N.$cc,c["common.nodeArch"]=P,c["common.product"]=w||"desktop",y&&(c["common.msftInternal"]=y);let u=0;const f=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-f,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),I.$m&&(c["common.snap"]="true");const m=L(d);return m&&(c["common.platformDetail"]=m),c}e.$lo=O;function R(S){const d=N.env.USERDNSDOMAIN;if(!d)return!1;const P=d.toLowerCase();return S.some(E=>P===E)}e.$mo=R}),define(ae[22],ce([0,1,4]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$ql=e.$pl=e.$ol=e.$nl=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=e.$hl=e.$gl=void 0,e.$gl=(0,I.$Th)("telemetryService"),e.$hl=(0,I.$Th)("customEndpointTelemetryService"),e.$il="telemetry.currentSessionDate",e.$jl="telemetry.firstSessionDate",e.$kl="telemetry.lastSessionDate",e.$ll="telemetry.machineId",e.$ml="telemetry.sqmId",e.$nl="telemetry",e.$ol="telemetry.telemetryLevel",e.$pl="telemetry.enableCrashReporter",e.$ql="telemetry.enableTelemetry";var N;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(N||(e.TelemetryLevel=N={}));var j;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(j||(e.TelemetryConfiguration=j={}))}),define(ae[220],ce([0,1,36,6,35,23,16,5,10,142,31,145,95,11,25,22]),function(ie,e,I,N,j,L,O,R,S,d,P,E,b,l,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kr=e.$Jr=e.$Ir=e.$Hr=void 0;const w=new Map;async function c(s,a){const n=`${s}::${a.join(":")}`,i=w.get(n);if(i)return i;const t=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],r=new Map,o=new Map,v=2e4;function p(g,D,T,M){const z=D.substring(g.length+1);return N.Promises.withAsyncBody(async B=>{let Z;try{Z=await P.Promises.readdir(D,{withFileTypes:!0})}catch{B();return}if(M.count>=v){M.count+=Z.length,M.maxReached=!0,B();return}let K=Z.length;if(K===0){B();return}let x=Z;M.count+Z.length>v&&(M.maxReached=!0,K=v-M.count,x=Z.slice(0,K)),M.count+=Z.length;for(const H of x)if(H.isDirectory()){if(T.includes(H.name)||await p(g,(0,O.$ic)(D,H.name),T,M),--K===0){B();return}}else{const Y=H.name.lastIndexOf(".");if(Y>=0){const G=H.name.substring(Y+1);G&&r.set(G,(r.get(G)??0)+1)}for(const G of t)G.relativePathPattern?.test(z)!==!1&&G.filePattern.test(H.name)&&o.set(G.tag,(o.get(G.tag)??0)+1);if(--K===0){B();return}}})}const h=N.Promises.withAsyncBody(async g=>{const D={count:0,maxReached:!1};await p(s,s,a,D);const T=await m(s);g({configFiles:u(o),fileTypes:u(r),fileCount:D.count,maxFilesReached:D.maxReached,launchConfigFiles:T})});return w.set(n,h),h}e.$Hr=c;function u(s){return Array.from(s.entries(),([a,n])=>({name:a,count:n})).sort((a,n)=>n.count-a.count)}function f(){const s={os:`${I.type()} ${I.arch()} ${I.release()}`,memory:`${(I.totalmem()/l.$Kk.GB).toFixed(2)}GB (${(I.freemem()/l.$Kk.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(d.$Vm.value()*100)}%`},a=I.cpus();return a&&a.length>0&&(s.cpus=`${a[0].model} (${a.length} x ${a[0].speed})`),s}e.$Ir=f;async function m(s){try{const a=new Map,n=(0,O.$ic)(s,".vscode","launch.json"),i=await P.Promises.readFile(n),t=[],r=(0,j.$1m)(i.toString(),t);if(t.length)return console.log(`Unable to parse ${n}`),[];if((0,j.$0m)(r)==="object"&&r.configurations)for(const o of r.configurations){const v=o.type;v&&(a.has(v)?a.set(v,a.get(v)+1):a.set(v,1))}return u(a)}catch{return[]}}e.$Jr=m;let k=class{constructor(a,n){this.c=a,this.d=n}f(a){const n=[];return n.push(`OS Version:       ${a.os}`),n.push(`CPUs:             ${a.cpus}`),n.push(`Memory (System):  ${a.memory}`),n.push(`VM:               ${a.vmHint}`),n.join(`
`)}g(a){const n=[];n.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),n.push(`OS Version:       ${I.type()} ${I.arch()} ${I.release()}`);const i=I.cpus();return i&&i.length>0&&n.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),n.push(`Memory (System):  ${(I.totalmem()/l.$Kk.GB).toFixed(2)}GB (${(I.freemem()/l.$Kk.GB).toFixed(2)}GB free)`),R.$j||n.push(`Load (avg):       ${I.loadavg().map(t=>Math.round(t)).join(", ")}`),n.push(`VM:               ${Math.round(d.$Vm.value()*100)}%`),n.push(`Screen Reader:    ${a.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${a.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.j(a.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(a,n){return Promise.all([(0,E.$Gr)(a.mainPID),this.k(a)]).then(async i=>{let[t,r]=i,o=this.m(a,t);return n.forEach(v=>{if((0,b.$vm)(v))o+=`
${v.errorMessage}`,r+=`
${v.errorMessage}`;else if(o+=`

Remote: ${v.hostName}`,v.processes&&(o+=`
${this.m(a,v.processes)}`),v.workspaceMetadata){r+=`
|  Remote: ${v.hostName}`;for(const p of Object.keys(v.workspaceMetadata)){const h=v.workspaceMetadata[p];let g=`${h.fileCount} files`;h.maxFilesReached&&(g=`more than ${g}`),r+=`|    Folder (${p}): ${g}`,r+=this.h(h)}}}),{processInfo:o,workspaceInfo:r}})}async getSystemInfo(a,n){const{memory:i,vmHint:t,os:r,cpus:o}=f(),v={os:r,memory:i,cpus:o,vmHint:t,processArgs:`${a.mainArguments.join(" ")}`,gpuStatus:a.gpuFeatureStatus,screenReader:`${a.screenReader?"yes":"no"}`,remoteData:n};return R.$j||(v.load=`${I.loadavg().map(p=>Math.round(p)).join(", ")}`),R.$l&&(v.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(v)}async getDiagnostics(a,n){const i=[];return(0,E.$Gr)(a.mainPID).then(async t=>(i.push(""),i.push(this.g(a)),i.push(""),i.push(this.m(a,t)),a.windows.some(r=>r.folderURIs&&r.folderURIs.length>0&&!r.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(a))),n.forEach(r=>{if((0,b.$vm)(r))i.push(`
${r.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${r.hostName}`),i.push(this.f(r.machineInfo)),r.processes&&i.push(this.m(a,r.processes)),r.workspaceMetadata)for(const o of Object.keys(r.workspaceMetadata)){const v=r.workspaceMetadata[o];let p=`${v.fileCount} files`;v.maxFilesReached&&(p=`more than ${p}`),i.push(`Folder (${o}): ${p}`),i.push(this.h(v))}}),i.push(""),i.push(""),i.join(`
`)))}h(a){const n=[];let t=0;const r=(h,g)=>{const D=` ${h}(${g})`;t+D.length>60?(n.push(o),o="|                 ",t=o.length):t+=D.length,o+=D};let o="|      File types:";const v=10,p=a.fileTypes.length>v?v:a.fileTypes.length;for(let h=0;h<p;h++){const g=a.fileTypes[h];r(g.name,g.count)}if(n.push(o),a.configFiles.length>=0&&(o="|      Conf files:",t=0,a.configFiles.forEach(h=>{r(h.name,h.count)}),n.push(o)),a.launchConfigFiles.length>0){let h="|      Launch Configs:";a.launchConfigFiles.forEach(g=>{const D=g.count>1?` ${g.name}(${g.count})`:` ${g.name}`;h+=D}),n.push(h)}return n.join(`
`)}j(a){const n=Math.max(...Object.keys(a).map(i=>i.length));return Object.keys(a).map(i=>`${i}:  ${" ".repeat(n-i.length)}  ${a[i]}`).join(`
                  `)}k(a){const n=[],i=[];return a.windows.forEach(t=>{t.folderURIs.length===0||t.remoteAuthority||(n.push(`|  Window (${t.title})`),t.folderURIs.forEach(r=>{const o=S.URI.revive(r);if(o.scheme===L.Schemas.file){const v=o.fsPath;i.push(c(v,["node_modules",".git"]).then(p=>{let h=`${p.fileCount} files`;p.maxFilesReached&&(h=`more than ${h}`),n.push(`|    Folder (${(0,O.$mc)(v)}): ${h}`),n.push(this.h(p))}).catch(p=>{n.push(`|      Error: Unable to collect workspace stats for folder ${v} (${p.toString()})`)}))}else n.push(`|    Folder (${o.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(t=>n.join(`
`)).catch(t=>`Unable to collect workspace stats: ${t}`)}m(a,n){const i=new Map;a.windows.forEach(r=>i.set(r.pid,`window [${r.id}] (${r.title})`)),a.pidToNames.forEach(({pid:r,name:o})=>i.set(r,o));const t=[];return t.push("CPU %	Mem MB	   PID	Process"),n&&this.n(a.mainPID,i,t,n,0),t.join(`
`)}n(a,n,i,t,r){const o=r===0;let v;o?v=t.pid===a?`${this.d.applicationName} main`:"remote agent":n.has(t.pid)?v=n.get(t.pid):v=`${"  ".repeat(r)} ${t.name}`;const p=process.platform==="win32"?t.mem:I.totalmem()*(t.mem/100);i.push(`${t.load.toFixed(0).padStart(5," ")}	${(p/l.$Kk.MB).toFixed(0).padStart(6," ")}	${t.pid.toFixed(0).padStart(6," ")}	${v}`),Array.isArray(t.children)&&t.children.forEach(h=>this.n(a,n,i,h,r+1))}async getWorkspaceFileExtensions(a){const n=new Set;for(const{uri:i}of a.folders){const t=S.URI.revive(i);if(t.scheme!==L.Schemas.file)continue;const r=t.fsPath;try{(await c(r,["node_modules",".git"])).fileTypes.forEach(v=>n.add(v.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(a){for(const{uri:n}of a.folders){const i=S.URI.revive(n);if(i.scheme!==L.Schemas.file)continue;const t=i.fsPath;try{const r=await c(t,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":a.telemetryId,rendererSessionId:a.rendererSessionId}),r.fileTypes.forEach(o=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:a.rendererSessionId,type:o.name,count:o.count})}),r.launchConfigFiles.forEach(o=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:a.rendererSessionId,type:o.name,count:o.count})}),r.configFiles.forEach(o=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:a.rendererSessionId,type:o.name,count:o.count})})}catch{}}}};e.$Kr=k,e.$Kr=k=pe([X(0,y.$gl),X(1,$.$tj)],k)}),define(ae[108],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p8b=e.$o8b=void 0;class I{constructor(L){this.b=L}listen(L,O){throw new Error(`Event not found: ${O}`)}call(L,O,{eventName:R,data:S}){return this.b.forEach(d=>d.log(R,S)),Promise.resolve(null)}}e.$o8b=I;class N{constructor(L){this.b=L}log(L,O){return this.b.call("log",{eventName:L,data:O}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$p8b=N}),define(ae[45],ce([0,1,30,12,3,20,75,107,22]),function(ie,e,I,N,j,L,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=void 0;class d{constructor(t){this.value=t,this.isTrustedTelemetryValue=!0}}e.$no=d;class P{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$oo=P,e.$po=new P;class E{async publicLog(t,r,o){}async publicLogError(t,r,o){}}e.$qo=E,e.$ro="telemetry",e.$so="extensionTelemetryLog",e.$to={log:()=>null,flush:()=>Promise.resolve(null)};function b(i,t){return j.Event.debounce(t.onDidChangeConfiguration,(o,v)=>{const p=o?new Set([...o.affectedKeys,...v.affectedKeys]):v.affectedKeys;return{...v,affectedKeys:p}},1e3,!0)(o=>{o.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,L.$qi)(o.source),configurationKeys:Array.from(o.affectedKeys)})})}e.$uo=b;function l(i,t){return!t.isBuilt&&!t.disableTelemetry?!0:!(t.disableTelemetry||!i.enableTelemetry)}e.$vo=l;function $(i,t){return t.extensionTestsLocationURI?!0:!(t.isBuilt||t.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$wo=$;function y(i){const t=i.getValue(S.$ol),r=i.getValue(S.$pl);if(i.getValue(S.$ql)===!1||r===!1)return 0;switch(t??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$xo=y;function w(i){const t={},r={},o={};f(i,o);for(let v in o){v=v.length>150?v.substr(v.length-149):v;const p=o[v];typeof p=="number"?r[v]=p:typeof p=="boolean"?r[v]=p?1:0:typeof p=="string"?(p.length>8192&&console.warn(`Telemetry property: ${v} has been trimmed to 8192, the original length is ${p.length}`),t[v]=p.substring(0,8191)):typeof p<"u"&&p!==null&&(t[v]=p)}return{properties:t,measurements:r}}e.$yo=w;const c=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function u(i){if(!i)return"none";const t=(0,O.$Zk)(i);return c.has(t)?t:"other"}e.$zo=u;function f(i,t,r=0,o){if(i)for(const v of Object.getOwnPropertyNames(i)){const p=i[v],h=o?o+v:v;Array.isArray(p)?t[h]=(0,I.$dn)(p):p instanceof Date?t[h]=p.toISOString():(0,N.$Bf)(p)?r<2?f(p,t,r+1,h+"."):t[h]=(0,I.$dn)(p):t[h]=p}}function m(i,t){const r=i.msftInternalDomains||[],o=t.getValue("telemetry.internalTesting");return(0,R.$mo)(r)||o}e.$Ao=m;function k(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$Bo=k;function s(i,t){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let r=i;const o=[];for(const g of t)for(;;){const D=g.exec(i);if(!D)break;o.push([D.index,g.lastIndex])}const v=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,p=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let h=0;for(r="";;){const g=p.exec(i);if(!g)break;const D=o.some(([T,M])=>g.index<M&&T<p.lastIndex);!v.test(g[0])&&!D&&(r+=i.substring(h,g.index)+"<REDACTED: user-file-path>",h=p.lastIndex)}return h<i.length&&(r+=i.substr(h)),r}function a(i){if(!i)return i;const t=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of t)if(r.regex.test(i))return`<REDACTED: ${r.label}>`;return i}function n(i,t){return(0,I.$an)(i,r=>{if(r instanceof d||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let o=r.replaceAll("%20"," ");o=s(o,t);for(const v of t)o=o.replace(v,"");return o=a(o),o}})}e.$Co=n}),define(ae[33],ce([0,1,27,29,44,5,10,7,37,45]),function(ie,e,I,N,j,L,O,R,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=void 0;function P(n,i){return n.uuid&&i.uuid?n.uuid===i.uuid:n.id===i.id?!0:(0,I.$Xe)(n.id,i.id)===0}e.$Do=P;const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class b{static create(i){const t=i.manifest?i.manifest.version:i.version,r=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new b(i.identifier,t,r)}static parse(i){const t=E.exec(i);return t&&t[1]&&t[2]?new b({id:t[1]},t[2],t[4]||void 0):null}constructor(i,t,r="undefined"){this.version=t,this.targetPlatform=r,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof b?P(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$Eo=b;const l=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function $(n){const i=l.exec(n);return i&&i[1]?[w(i[1]),i[2]]:[w(n),void 0]}e.$Fo=$;function y(n,i){return`${n}.${i}`}e.$Go=y;function w(n){return n.toLowerCase()}e.$Ho=w;function c(n,i){return w(y(n??j.$6l,i))}e.$Io=c;function u(n,i){const t=[],r=o=>{for(const v of t)if(v.some(p=>P(i(p),i(o))))return v;return null};for(const o of n){const v=r(o);v?v.push(o):t.push([o])}return t}e.$Jo=u;function f(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.$Ko=f;function m(n){return{id:new d.$no(n.identifier.id),name:new d.$no(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.$Lo=m,e.$Mo=new j.$0l("pprice.better-merge");function k(n,i){const t=[],r=i.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const o=r.shift();if(o&&t.every(v=>!P(v.identifier,{id:o}))){const v=n.filter(p=>P(p.identifier,{id:o}));v.length===1&&(t.push(v[0]),r.push(...v[0].manifest.extensionDependencies?.slice(0)??[]))}}return t}e.$No=k;async function s(n,i){if(!L.$l)return!1;let t;try{t=(await n.readFile(O.URI.file("/etc/os-release"))).value.toString()}catch{try{t=(await n.readFile(O.URI.file("/usr/lib/os-release"))).value.toString()}catch(o){i.debug("Error while getting the os-release file.",(0,R.$9)(o))}}return!!t&&(t.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function a(n,i){const t=await s(n,i),r=(0,N.$0n)(t?"alpine":L.$u,S.$dc);return i.debug("ComputeTargetPlatform:",r),r}e.$Oo=a}),define(ae[221],ce([0,1,18,2,19,10,11,25,6,3,16,5,37,33]),function(ie,e,I,N,j,L,O,R,S,d,P,E,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k6b=e.$j6b=void 0;let $=class extends N.$Rc{constructor(f,m){super(),this.b=f,this.c=m,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,k])=>this.a.set(k.configPath,k))}getConfigBasedTips(f){return this.f(f)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(f){const m=[];for(const[k,s]of this.a)if(!(s.configScheme&&s.configScheme!==f.scheme))try{const a=(await this.b.readFile((0,j.$wg)(f,k))).value.toString();for(const[n,i]of Object.entries(s.recommendations))(!i.contentPattern||new RegExp(i.contentPattern,"mig").test(a))&&m.push({extensionId:n,extensionName:i.name,configName:s.configName,important:!!i.important,isExtensionPack:!!i.isExtensionPack,whenNotInstalled:i.whenNotInstalled})}catch{}return m}};e.$j6b=$,e.$j6b=$=pe([X(0,O.$ck),X(1,R.$tj)],$);const y="extensionTips/promptedExecutableTips",w="extensionTips/lastPromptedMediumImpExeTime";class c extends ${constructor(f,m,k,s,a,n,i,t){super(i,t),this.r=f,this.s=m,this.t=k,this.u=s,this.w=a,this.z=n,this.g=new Map,this.h=new Map,this.j=new Map,this.m=new Map,this.n=new Map,t.exeBasedExtensionTips&&Object.entries(t.exeBasedExtensionTips).forEach(([r,o])=>{const v=[],p=[],h=[];Object.entries(o.recommendations).forEach(([g,D])=>{D.important?o.important?v.push({extensionId:g,extensionName:D.name,isExtensionPack:!!D.isExtensionPack}):p.push({extensionId:g,extensionName:D.name,isExtensionPack:!!D.isExtensionPack}):h.push({extensionId:g,extensionName:D.name,isExtensionPack:!!D.isExtensionPack})}),v.length&&this.g.set(r,{exeFriendlyName:o.friendlyName,windowsPath:o.windowsPath,recommendations:v}),p.length&&this.h.set(r,{exeFriendlyName:o.friendlyName,windowsPath:o.windowsPath,recommendations:p}),h.length&&this.j.set(r,{exeFriendlyName:o.friendlyName,windowsPath:o.windowsPath,recommendations:h})}),(0,S.$Wg)(async()=>{await this.C(),this.F(),this.G()},3e3,this.q)}async getImportantExecutableBasedTips(){const f=await this.O(this.g),m=await this.O(this.h);return[...f,...m]}getOtherExecutableBasedTips(){return this.O(this.j)}async C(){const f=await this.O(this.g),m=await this.O(this.h),k=await this.u.getInstalled();this.m=this.D(f,k),this.n=this.D(m,k)}D(f,m){const k=new Map;f.forEach(t=>k.set(t.extensionId.toLowerCase(),t));const{installed:s,uninstalled:a}=this.N([...k.keys()],m);for(const t of s){const r=k.get(t);r&&this.t.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:t,exeName:r.exeName})}for(const t of a){const r=k.get(t);r&&this.t.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:t,exeName:r.exeName})}const n=this.L(),i=new Map;for(const t of a){const r=k.get(t);if(r&&(!n[r.exeName]||!n[r.exeName].includes(r.extensionId))){let o=i.get(r.exeName);o||(o=[],i.set(r.exeName,o)),o.push(r)}}return i}F(){if(this.m.size===0)return;const[f,m]=[...this.m.entries()][0];this.H(m).then(k=>{switch(k){case"reacted":this.M(m[0].exeName,m);break;case"ignored":this.m.delete(f);break;case"incompatibleWindow":{const s=d.Event.once(d.Event.latch(d.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(s(()=>this.F()));break}case"toomany":{const s=this.B(new N.$Sc);s.value=(0,S.$Wg)(()=>{s.dispose(),this.F()},60*60*1e3);break}}})}G(){if(this.n.size===0)return;const f=this.I(),m=Date.now()-f,k=7*24*60*60*1e3;if(m<k){const n=this.B(new N.$Sc);n.value=(0,S.$Wg)(()=>{n.dispose(),this.G()},k-m);return}const[s,a]=[...this.n.entries()][0];this.H(a).then(n=>{switch(n){case"reacted":{this.J(Date.now()),this.n.delete(s),this.M(a[0].exeName,a);const i=this.B(new N.$Sc);i.value=(0,S.$Wg)(()=>{i.dispose(),this.G()},k);break}case"ignored":this.n.delete(s),this.G();break;case"incompatibleWindow":{const i=d.Event.once(d.Event.latch(d.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(i(()=>this.G()));break}case"toomany":{const i=this.B(new N.$Sc);i.value=(0,S.$Wg)(()=>{i.dispose(),this.G()},60*60*1e3);break}}})}async H(f){const m=await this.u.getInstalled(1),k=f.filter(s=>!s.whenNotInstalled||s.whenNotInstalled.every(a=>m.every(n=>!(0,l.$Do)(n.identifier,{id:a})))).map(({extensionId:s})=>s.toLowerCase());return this.z.promptImportantExtensionsInstallNotification({extensions:k,source:3,name:f[0].exeFriendlyName,searchValue:`@exe:"${f[0].exeName}"`})}I(){let f=this.w.getNumber(w,-1);return f||(f=Date.now(),this.J(f)),f}J(f){this.w.store(w,f,-1,1)}L(){return JSON.parse(this.w.get(y,-1,"{}"))}M(f,m){const k=this.L();k[f]=m.map(({extensionId:s})=>s.toLowerCase()),this.w.store(y,JSON.stringify(k),-1,0)}N(f,m){const k=[],s=[],a=m.reduce((n,i)=>(n.add(i.identifier.id.toLowerCase()),n),new Set);return f.forEach(n=>{a.has(n.toLowerCase())?k.push(n):s.push(n)}),{installed:k,uninstalled:s}}async O(f){const m=[],k=new Map;for(const s of f.keys()){const a=f.get(s);if(!a||!(0,I.$Kb)(a.recommendations))continue;const n=[];E.$j?a.windowsPath&&n.push(a.windowsPath.replace("%USERPROFILE%",()=>b.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>b.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>b.env.ProgramFiles).replace("%APPDATA%",()=>b.env.APPDATA).replace("%WINDIR%",()=>b.env.WINDIR)):(n.push((0,P.$ic)("/usr/local/bin",s)),n.push((0,P.$ic)("/usr/bin",s)),n.push((0,P.$ic)(this.r.fsPath,s)));for(const i of n){let t=k.get(i);if(t===void 0&&(t=await this.b.exists(L.URI.file(i)),k.set(i,t)),t)for(const{extensionId:r,extensionName:o,isExtensionPack:v,whenNotInstalled:p}of a.recommendations)m.push({extensionId:r,extensionName:o,isExtensionPack:v,exeName:s,exeFriendlyName:a.exeFriendlyName,windowsPath:a.windowsPath,whenNotInstalled:p})}}return m}}e.$k6b=c}),define(ae[222],ce([0,1,26,33]),function(ie,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OWb=void 0;async function j(L,O,R,S,d){try{const P=await L.getExtensionsControlManifest();if(!P.deprecated)return;const E=await L.getInstalled(1);for(const[b,l]of Object.entries(P.deprecated)){if(!l?.extension)continue;const{id:$,autoMigrate:y,preRelease:w}=l.extension;if(!y)continue;const c=E.find(f=>(0,N.$Do)(f.identifier,{id:b}));if(!c)continue;const u=(await O.getExtensions([{id:$,preRelease:w}],{targetPlatform:await L.getTargetPlatform(),compatible:!0},I.CancellationToken.None))[0];if(!u){d.info(`Skipping migrating '${c.identifier.id}' extension because, the comaptible target '${$}' extension is not found`);continue}try{d.info(`Migrating '${c.identifier.id}' extension to '${$}' extension...`);const f=!S.getDisabledExtensions().some(k=>(0,N.$Do)(k,c.identifier));await L.uninstall(c),d.info(`Uninstalled the unsupported extension '${c.identifier.id}'`);let m=E.find(k=>(0,N.$Do)(k.identifier,{id:$}));(!m||!m.isPreReleaseVersion&&f)&&(m=await L.installFromGallery(u,{installPreReleaseVersion:!0,isMachineScoped:c.isMachineScoped,operation:4}),d.info(`Installed the pre-release extension '${m.identifier.id}'`),f||(await S.disableExtension(m.identifier),d.info(`Disabled the pre-release extension '${m.identifier.id}' because the unsupported extension '${c.identifier.id}' is disabled`)),y.storage&&(R.addToMigrationList((0,N.$Go)(c.manifest.publisher,c.manifest.name),(0,N.$Go)(m.manifest.publisher,m.manifest.name)),d.info("Added pre-release extension to the storage migration list"))),d.info(`Migrated '${c.identifier.id}' extension to '${$}' extension.`)}catch(f){d.error(f)}}}catch(P){d.error(P)}}e.$OWb=j}),define(ae[223],ce([0,1,3,2,34,33,44]),function(ie,e,I,N,j,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lp=void 0;class R extends N.$Rc{constructor(d,P,E,b,l,$,y){super(),this.f=d,this.g=P,this.h=E,this.j=b,this.m=l,this.n=$,this.r=y,this.a=this.B(new I.$Od),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new N.$Zc),this.s().then(null,w=>y.error(w))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(d=>this.u(d.added))),this.B(this.j.onAddExtensions(d=>this.w(d))),this.B(this.j.onDidAddExtensions(d=>this.y(d))),this.B(this.j.onRemoveExtensions(d=>this.z(d))),this.B(this.j.onDidRemoveExtensions(d=>this.C(d))),this.B(this.n.onDidFilesChange(d=>this.D(d)))}async u(d){try{d.length&&await Promise.all(d.map(P=>(this.c.set(P.id,(0,N.$Oc)(this.n.watch(this.m.extUri.dirname(P.extensionsResource)),this.n.watch(P.extensionsResource))),this.G(P.extensionsResource))))}catch(P){throw this.r.error(P),P}}async w(d){for(const P of d.extensions)this.I(this.L(P.identifier,P.version),d.profileLocation)}async y(d){for(const P of d.extensions){const E=this.L(P.identifier,P.version);d.error?this.J(E,d.profileLocation):this.I(E,d.profileLocation)}}async z(d){for(const P of d.extensions)this.J(this.L(P.identifier,P.version),d.profileLocation)}async C(d){const P=[],E=[];for(const b of d.extensions){const l=this.L(b.identifier,b.version);d.error?this.I(l,d.profileLocation):(this.J(l,d.profileLocation),this.b.has(l)||(this.r.debug("Extension is removed from all profiles",b.identifier.id,b.version),E.push(this.f.scanInstalledExtensionAtLocation(b.location).then($=>{$?P.push($):this.r.info("Extension not found at the location",b.location.toString())},$=>this.r.error($)))))}try{await Promise.all(E),P.length&&await this.H(P)}catch(b){this.r.error(b)}}D(d){for(const P of this.h.profiles)d.contains(P.extensionsResource,0,1)&&this.F(P.extensionsResource)}async F(d){const P=[],E=[],b=await this.j.scanProfileExtensions(d),l=new Set,$=new Set;for(const[y,w]of this.b)w.has(d)&&$.add(y);for(const y of b){const w=this.L(y.identifier,y.version);l.add(w),$.has(w)||(P.push(y.identifier),this.I(w,d))}for(const y of $)if(!l.has(y)){const w=this.M(y);w&&(E.push(w.identifier),this.J(y,d))}(P.length||E.length)&&this.a.fire({added:P.length?{extensions:P,profileLocation:d}:void 0,removed:E.length?{extensions:E,profileLocation:d}:void 0})}async G(d){const P=await this.j.scanProfileExtensions(d);for(const E of P)this.I(this.L(E.identifier,E.version),d)}async H(d){d||(d=(await this.f.scanAllUserInstalledExtensions()).filter(E=>!this.b.has(this.L(E.identifier,E.manifest.version)))),d.length&&await this.f.markAsUninstalled(...d)}I(d,P){let E=this.b.get(d);E||this.b.set(d,E=new j.$Ac(b=>this.m.extUri.getComparisonKey(b))),E.add(P)}J(d,P){const E=this.b.get(d);E&&E.delete(P),E?.size||this.b.delete(d)}L(d,P){return`${O.$0l.toKey(d.id)}@${P}`}M(d){const[P,E]=(0,L.$Fo)(d);return E?{identifier:{id:P},version:E}:void 0}}e.$Lp=R}),define(ae[224],ce([0,1,43,45]),function(ie,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ep=void 0;async function j(L,O,R,S,d,P,E){const b={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${O.nameShort})`};if((0,N.$vo)(O,R)&&(0,N.$xo)(S)===3){const l=await(0,I.$dp)(R,d,P);b["X-Market-User-Id"]=l,b["VSCode-SessionId"]=E.machineId||l}return b}e.$ep=j}),define(ae[225],ce([0,1,71,18,6,2,23,16,31,14,29,33,8,73,10]),function(ie,e,I,N,j,L,O,R,S,d,P,E,b,l,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=void 0;let y=class extends l.$Xq{constructor(f,m,k,s){super(k),this.h=f,this.j=s,this.g=this.B(new w(m,s)),this.h.registerParticipant({postInstall:async a=>this.m(a),postUninstall:async a=>this.n(a)})}async getBuiltInExtensionTranslationsUri(f,m){const s=(await this.g.getLanguagePacks())[m];if(!s){this.j.warn(`No language pack found for ${m}`);return}const a=s.translations[f];return a?$.URI.file(a):void 0}async getInstalledLanguages(){const f=await this.g.getLanguagePacks(),m=Object.keys(f).map(k=>{const s=f[k];return{...this.f(k,s.label),extensionId:s.extensions[0].extensionIdentifier.id}});return m.push(this.f("en","English")),m.sort((k,s)=>k.label.localeCompare(s.label)),m}async m(f){f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",f.identifier.id),await this.update())}async n(f){const m=await this.g.getLanguagePacks();Object.keys(m).some(k=>m[k]&&m[k].extensions.some(s=>(0,E.$Do)(s.extensionIdentifier,f.identifier)))&&(this.j.info("Removing language packs from the extension",f.identifier.id),await this.update())}async update(){const[f,m]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),k=await this.g.update(m);return!(0,N.$tb)(Object.keys(f),Object.keys(k))}};e.$Yq=y,e.$Yq=y=pe([X(0,P.$do),X(1,d.$2h),X(2,P.$bo),X(3,b.$bj)],y);let w=class extends L.$Rc{constructor(f,m){super(),this.j=m,this.c={},this.f=(0,R.$ic)(f.userDataPath,"languagepacks.json"),this.g=new j.$3g}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(f){return this.s(m=>{Object.keys(m).forEach(k=>delete m[k]),this.m(m,...f)}).then(()=>this.c)}m(f,...m){for(const k of m)k&&k.manifest&&k.manifest.contributes&&k.manifest.contributes.localizations&&k.manifest.contributes.localizations.length&&this.n(f,k);Object.keys(f).forEach(k=>this.r(f[k]))}n(f,m){const k=m.identifier,s=m.manifest.contributes&&m.manifest.contributes.localizations?m.manifest.contributes.localizations:[];for(const a of s)if(m.location.scheme===O.Schemas.file&&c(a)){let n=f[a.languageId];n||(n={hash:"",extensions:[],translations:{},label:a.localizedLanguageName??a.languageName},f[a.languageId]=n);const i=n.extensions.filter(t=>(0,E.$Do)(t.extensionIdentifier,k))[0];i?i.version=m.manifest.version:n.extensions.push({extensionIdentifier:k,version:m.manifest.version});for(const t of a.translations)n.translations[t.id]=(0,R.$ic)(m.location.fsPath,t.path)}}r(f){if(f){const m=(0,I.createHash)("md5");for(const k of f.extensions)m.update(k.extensionIdentifier.uuid||k.extensionIdentifier.id).update(k.version);f.hash=m.digest("hex")}}s(f=()=>null){return this.g.queue(()=>{let m=null;return S.Promises.readFile(this.f,"utf8").then(void 0,k=>k.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(k)).then(k=>{try{return JSON.parse(k)}catch{return{}}}).then(k=>(m=f(k),k)).then(k=>{for(const a of Object.keys(k))k[a]||delete k[a];this.c=k,this.h=!0;const s=JSON.stringify(this.c);return this.j.debug("Writing language packs",s),S.Promises.writeFile(this.f,s)}).then(()=>m,k=>this.j.error(k))})}};w=pe([X(0,d.$2h),X(1,b.$bj)],w);function c(u){if(typeof u.languageId!="string"||!Array.isArray(u.translations)||u.translations.length===0)return!1;for(const f of u.translations)if(typeof f.id!="string"||typeof f.path!="string")return!1;return!(u.languageName&&typeof u.languageName!="string"||u.localizedLanguageName&&typeof u.localizedLanguageName!="string")}}),define(ae[226],ce([0,1,141,7,30,45]),function(ie,e,I,N,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HN=void 0;const O="https://mobile.events.data.microsoft.com/OneCollector/1.0",R="https://mobile.events.data.microsoft.com/ping";async function S(P,E,b){const l=await(0,I.$LC)("@microsoft/1ds-core-js","dist/ms.core.js"),$=await(0,I.$LC)("@microsoft/1ds-post-js","dist/ms.post.js"),y=new l.AppInsightsCore,w=new $.PostChannel,c={instrumentationKey:P,endpointUrl:O,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[w]]};if(b){c.extensionConfig={};const u={alwaysUseXhrOverride:!0,httpXHROverride:b};c.extensionConfig[w.identifier]=u}return y.initialize(c,[]),y.addTelemetryInitializer(u=>{E&&(u.ext=u.ext??{},u.ext.utc=u.ext.utc??{},u.ext.utc.flags=8462029)}),y}class d{constructor(E,b,l,$,y){this.e=E,this.f=b,this.g=l,this.h=y,this.c=O,this.d=R,this.g||(this.g={}),typeof $=="function"?this.a=$():this.a=$,this.b=null}i(E){if(this.a){if(typeof this.a!="string"){E(this.a);return}this.b||(this.b=S(this.a,this.e,this.h)),this.b.then(b=>{E(b)},b=>{(0,N.$Z)(b),console.error(b)})}}log(E,b){if(!this.a)return;b=(0,j.$bn)(b,this.g),b=(0,L.$yo)(b);const l=this.f+"/"+E;try{this.i($=>{$.pluginVersionString=b?.properties.version??"Unknown",$.track({name:l,baseData:{name:l,properties:b?.properties,measurements:b?.measurements}})})}catch{}}flush(){return this.a?new Promise(E=>{this.i(b=>{b.unload(!0,()=>{this.a=void 0,E(void 0)})})}):Promise.resolve(void 0)}}e.$HN=d}),define(ae[109],ce([0,1,2,166,14,8,25,45]),function(ie,e,I,N,j,L,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K5b=void 0;let S=class extends I.$Rc{constructor(P,E,b,l,$=""){super(),this.b=$;const y=E.getLogger(R.$ro);if(y)this.a=this.B(y);else{const c=(0,R.$wo)(l,b)?" (Not Sent)":"",u=()=>(0,R.$vo)(l,b)&&P.getLevel()===L.LogLevel.Trace;this.a=this.B(E.createLogger(R.$ro,{name:(0,N.localize)(0,null,c),hidden:!u()})),this.B(P.onDidChangeLogLevel(()=>E.setVisibility(R.$ro,u()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(P,E){this.a.trace(`${this.b}telemetry/${P}`,(0,R.$yo)(E))}};e.$K5b=S,e.$K5b=S=pe([X(0,L.$bj),X(1,L.$cj),X(2,j.$1h),X(3,O.$tj)],S)}),define(ae[110],ce([0,1,2,30,5,27,167,20,50,102,25,41,22,45]),function(ie,e,I,N,j,L,O,R,S,d,P,E,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=void 0;let $=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(c,u,f){this.k=u,this.l=f,this.d={},this.i=new I.$Qc,this.j=[],this.b=c.appenders,this.c=c.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=c.piiPaths||[],this.g=3,this.h=!!c.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const m of this.f)this.j.push(new RegExp((0,L.$Ge)(m),"gi")),m.indexOf("\\")>=0&&this.j.push(new RegExp((0,L.$Ge)(m.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(m=>{(m.affectsConfiguration(b.$ol)||m.affectsConfiguration(b.$ql)||m.affectsConfiguration(b.$pl))&&this.m()}))}setExperimentProperty(c,u){this.d[c]=u}m(){let c=(0,l.$xo)(this.k);const u=this.l.enabledTelemetryLevels;if(u){this.h=this.sendErrorTelemetry?u.error:!1;const f=u.usage?3:u.error?2:0;c=Math.min(c,f)}this.g=c}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(c,u,f){this.g<u||(f=(0,N.$bn)(f,this.d),f=(0,l.$Co)(f,this.j),f=(0,N.$bn)(f,this.c),this.b.forEach(m=>m.log(c,f)))}publicLog(c,u){this.n(c,3,u)}publicLog2(c,u){this.publicLog(c,u)}publicLogError(c,u){this.h&&this.n(c,2,u)}publicLogError2(c,u){this.publicLogError(c,u)}};e.$5q=$,e.$5q=$=pe([X(1,R.$ni),X(2,P.$tj)],$);function y(){const w=(0,O.localize)(0,null,d.default.nameLong),c=d.default.privacyStatementUrl?(0,O.localize)(2,null,"https://aka.ms/vscode-telemetry",d.default.privacyStatementUrl):(0,O.localize)(1,null,"https://aka.ms/vscode-telemetry"),u=j.$p?"":(0,O.localize)(3,null),f=(0,O.localize)(4,null),m=(0,O.localize)(5,null),k=(0,O.localize)(6,null),s=(0,O.localize)(7,null),a=`
|       | ${f} | ${m} | ${k} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,O.localize)(8,null);return`
${w} ${c} ${u}

&nbsp;

${s}
${a}

&nbsp;

${n}
`}E.$kn.as(S.$pn.Configuration).registerConfiguration({id:b.$nl,order:1,type:"object",title:(0,O.localize)(9,null),properties:{[b.$ol]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,O.localize)(10,null),(0,O.localize)(11,null),(0,O.localize)(12,null),(0,O.localize)(13,null)],markdownDescription:y(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),E.$kn.as(S.$pn.Configuration).registerConfiguration({id:b.$nl,order:110,type:"object",title:(0,O.localize)(14,null),properties:{[b.$ql]:{type:"boolean",markdownDescription:d.default.privacyStatementUrl?(0,O.localize)(16,null,d.default.nameLong,d.default.privacyStatementUrl):(0,O.localize)(15,null,d.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,O.localize)(17,null,`\`#${b.$ol}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ae[227],ce([0,1,15,26,271,226]),function(ie,e,I,N,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IN=void 0;async function O(P,E){const b=await E.request(P,N.CancellationToken.None),l=(await(0,I.$oe)(b.stream)).toString(),$=b.res.statusCode??200;return{headers:b.res.headers,statusCode:$,responseData:l}}async function R(P){const E={method:P.type,headers:P.headers};return new Promise((l,$)=>{const y=j.request(P.url??"",E,w=>{w.on("data",function(c){l({headers:w.headers,statusCode:w.statusCode??200,responseData:c.toString()})}),w.on("error",function(c){$(c)})});y.write(P.data,w=>{w&&$(w)}),y.end()})}async function S(P,E,b){const l=typeof E.data=="string"?E.data:new TextDecoder().decode(E.data),$={type:"POST",headers:{...E.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(E.data).toString()},url:E.urlString,data:l};try{const y=P?await O($,P):await R($);b(y.statusCode,y.headers,y.responseData)}catch{b(0,{})}}class d extends L.$HN{constructor(E,b,l,$,y){const w={sendPOST:(c,u)=>{S(E,c,u)}};super(b,l,$,y,w)}}e.$IN=d}),define(ae[228],ce([0,1,23,93,20,14,8,25,22,108,109,110]),function(ie,e,I,N,j,L,O,R,S,d,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H9b=void 0;let b=class{constructor($,y,w,c,u,f){this.b=$,this.c=y,this.d=w,this.e=c,this.f=u,this.g=f,this.a=new Map}h($){if(!this.a.has($.id)){const y=Object.create(null);y["common.vscodemachineid"]=this.c.machineId,y["common.vscodesessionid"]=this.c.sessionId;const w=[$.id,JSON.stringify(y),$.aiKey],u=new N.$7p(I.$dg.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:w,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),f=[new d.$p8b(u),new P.$K5b(this.d,this.e,this.f,this.g,`[${$.id}] `)];this.a.set($.id,new E.$5q({appenders:f,sendErrorTelemetry:$.sendErrorTelemetry},this.b,this.g))}return this.a.get($.id)}publicLog($,y,w){this.h($).publicLog(y,w)}publicLogError($,y,w){this.h($).publicLogError(y,w)}};e.$H9b=b,e.$H9b=b=pe([X(0,j.$ni),X(1,S.$gl),X(2,O.$bj),X(3,O.$cj),X(4,L.$1h),X(5,R.$tj)],b)}),define(ae[77],ce([0,1,3,20,4,8]),function(ie,e,I,N,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lv=e.$kv=e.$jv=e.$iv=e.$hv=e.$gv=e.$fv=e.$ev=e.ProvidedOnAutoForward=e.$dv=e.TunnelPrivacyId=e.TunnelProtocol=e.$cv=e.$bv=void 0,e.$bv=(0,j.$Th)("tunnelService"),e.$cv=(0,j.$Th)("sharedTunnelsService");var O;(function(w){w.Http="http",w.Https="https"})(O||(e.TunnelProtocol=O={}));var R;(function(w){w.ConstantPrivate="constantPrivate",w.Private="private",w.Public="public"})(R||(e.TunnelPrivacyId=R={}));function S(w){return!!w.forwardPort}e.$dv=S;var d;(function(w){w[w.Notify=1]="Notify",w[w.OpenBrowser=2]="OpenBrowser",w[w.OpenPreview=3]="OpenPreview",w[w.Silent=4]="Silent",w[w.Ignore=5]="Ignore",w[w.OpenBrowserOnce=6]="OpenBrowserOnce"})(d||(e.ProvidedOnAutoForward=d={}));function P(w){if(w.scheme!=="http"&&w.scheme!=="https")return;const c=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(w.authority);if(c)return{address:c[1],port:+c[2]}}e.$ev=P,e.$fv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function E(w){return e.$fv.indexOf(w)>=0}e.$gv=E,e.$hv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function b(w){return e.$hv.indexOf(w)>=0}e.$iv=b;function l(w,c,u,f){if(u===1)return!1;if(u===2&&b(c)){const m=/(\d+)\.(\d+)\.(\d+)/g.exec(f);if(m?.length===4&&parseInt(m[1])>=18)return!1}return w<1024}e.$jv=l;class ${constructor(c,u,f){this.remoteAddress=c,this.localAddress=u,this.b=f,this.a=new I.$Od,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$kv=$;let y=class{constructor(c,u){this.j=c,this.k=u,this.a=new I.$Od,this.onTunnelOpened=this.a.event,this.b=new I.$Od,this.onTunnelClosed=this.b.event,this.c=new I.$Od,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const c=this.k.getValue("remote.localPortHost");return!c||c==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(c){return this.f=c,c?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(c){this.g=c.elevation,this.h=c.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const c=[],u=Array.from(this.e.values());for(const f of u){const m=Array.from(f.values());for(const k of m){const s=await k.value;s&&typeof s!="string"&&c.push(s)}}return c}async dispose(){for(const c of this.e.values()){for(const{value:u}of c.values())await u.then(f=>typeof f!="string"?f?.dispose():void 0);c.clear()}this.e.clear()}setEnvironmentTunnel(c,u,f,m,k){this.p(c,u,Promise.resolve({tunnelRemoteHost:c,tunnelRemotePort:u,localAddress:f,privacy:m,protocol:k,dispose:()=>Promise.resolve()}))}async getExistingTunnel(c,u){(b(c)||E(c))&&(c=e.$fv[0]);const f=this.r(c,u);if(f)return++f.refcount,f.value}openTunnel(c,u,f,m,k,s=!1,a,n){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${f} on local port ${k}.`);const i=this.f??c;if(!i)return;if(u||(u="localhost"),m||(m=this.l),this.f&&this.i.has(f)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const t=this.s(i,u,f,m,k,s,a,n);return t?t.then(r=>{if(r){if(typeof r=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(u,f),r}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(u,f);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const o=this.n(r);return(r.tunnelRemoteHost!==u||r.tunnelRemotePort!==f)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),a&&r.privacy!==a&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(o),o}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),t)}n(c){return{tunnelRemotePort:c.tunnelRemotePort,tunnelRemoteHost:c.tunnelRemoteHost,tunnelLocalPort:c.tunnelLocalPort,localAddress:c.localAddress,privacy:c.privacy,protocol:c.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${c.tunnelRemoteHost}:${c.tunnelRemotePort} `);const u=this.e.get(c.tunnelRemoteHost);if(u){const f=u.get(c.tunnelRemotePort);f&&(f.refcount--,await this.o(c.tunnelRemoteHost,c.tunnelRemotePort,f))}}}}async o(c,u,f){if(f.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${c}:${u}.`);const m=f.value.then(async k=>{k&&typeof k!="string"&&(await k.dispose(!0),this.b.fire({host:k.tunnelRemoteHost,port:k.tunnelRemotePort}))});return this.e.has(c)&&this.e.get(c).delete(u),m}}async closeTunnel(c,u){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${c}:${u} `);const f=this.e.get(c);if(f&&f.has(u)){const m=f.get(u);m.refcount=0,await this.o(c,u,m)}}p(c,u,f){this.e.has(c)||this.e.set(c,new Map),this.e.get(c).set(u,{refcount:1,value:f})}async q(c,u){const f=this.e.get(c);if(f){const m=f.get(u),k=m?await m.value:void 0;(!k||typeof k=="string")&&f.delete(u),f.size===0&&this.e.delete(c)}}r(c,u){const f=[c];E(c)?(f.push(...e.$fv),f.push(...e.$hv)):b(c)&&f.push(...e.$hv);const m=f.map(k=>this.e.get(k));for(const k of m){const s=k?.get(u);if(s)return s}}canTunnel(c){return!!P(c)}t(c,u,f,m,k,s,a){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${f} on local port ${m}.`);const n=f;this.i.add(n);const i=m===void 0?f:m,t={elevationRequired:k?this.isPortPrivileged(i):!1},r={remoteAddress:{host:u,port:f},localAddressPort:m,privacy:s,public:s?s!==R.Private:void 0,protocol:a},o=c.forwardPort(r,t);return o?(this.p(u,f,o),o.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(n)})):this.i.delete(n),o}};e.$lv=y,e.$lv=y=pe([X(0,L.$bj),X(1,N.$ni)],y)}),define(ae[229],ce([0,1,8,77,2,7,6]),function(ie,e,I,N,j,L,O){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$U9b=void 0;class S extends j.$Rc{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new O.$gh),this.b.p)}setAddress(E){this.a=E,this.b&&(this.b.complete(E),this.b=null)}setTunnel(E){this.B(E)}}let d=class extends j.$Rc{static{R=this}static{this.a=0}constructor(E,b){super(),this.f=E,this.g=b,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(E=>E.dispose())}async createTunnel(){return{id:String(++R.a)}}async startTunnel(E,b,l,$,y,w,c){const u=new S,f=await Promise.resolve(this.f.openTunnel(E,u,l,$,y,w,c));if(!f||typeof f=="string")throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${l}:${$} (remote).`),u.dispose(),new Error("Could not create tunnel");if(this.c.has(b))throw this.c.delete(b),u.dispose(),await f.dispose(),(0,L.$5)();return u.setTunnel(f),this.b.set(b,u),this.g.info(`[SharedProcessTunnelService] Created tunnel ${b}: ${f.localAddress} (local) to ${l}:${$} (remote).`),{tunnelLocalPort:f.tunnelLocalPort,localAddress:f.localAddress}}async setAddress(E,b){const l=this.b.get(E);l&&l.setAddress(b)}async destroyTunnel(E){const b=this.b.get(E);if(b){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${E}.`),this.b.delete(E),await b.dispose();return}this.c.add(E)}};e.$U9b=d,e.$U9b=d=R=pe([X(0,N.$cv),X(1,I.$bj)],d)}),define(ae[28],ce([0,1,4]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mk=void 0,e.$Mk=(0,I.$Th)("IUriIdentityService")}),define(ae[230],ce([0,1,28,184,11,19,127,3,2]),function(ie,e,I,N,j,L,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=void 0;class d{static{this._clock=0}constructor(b){this.uri=b,this.time=d._clock++}touch(){return this.time=d._clock++,this}}let P=class{constructor(b){this.g=b,this.c=new S.$Qc,this.f=2**16;const l=new Map,$=y=>{let w=l.get(y.scheme);return w===void 0&&(w=b.hasProvider(y)&&!this.g.hasCapability(y,1024),l.set(y.scheme,w)),w};this.c.add(R.Event.any(b.onDidChangeFileSystemProviderRegistrations,b.onDidChangeFileSystemProviderCapabilities)(y=>{l.delete(y.scheme)})),this.extUri=new L.$lg($),this.d=new O.$Cr((y,w)=>this.extUri.compare(y,w,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(b){this.g.hasProvider(b)&&(b=(0,L.$xg)(b));const l=this.d.get(b);return l?l.touch().uri.with({fragment:b.fragment}):(this.d.set(b,new d(b)),this.h(),b)}h(){if(this.d.size<this.f)return;const b=[...this.d.entries()].sort(($,y)=>$[1].time<y[1].time?1:$[1].time>y[1].time?-1:0);d._clock=0,this.d.clear();const l=this.f*.5;for(let $=0;$<l;$++)this.d.set(b[$][0],b[$][1].touch())}};e.$Dr=P,e.$Dr=P=pe([X(0,j.$ck)],P),(0,N.$Ar)(I.$Mk,P,1)}),define(ae[231],ce([0,1,3,2,11,47,34]),function(ie,e,I,N,j,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c9b=void 0;class R extends N.$Rc{constructor(d,P,E,b,l,$){super(),this.f=d,this.g=P,this.h=E,this.j=b,this.m=l,this.n=$,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new I.$Od),this.onDidChangeFile=this.a.event,this.b=L.$Zh.forUris(()=>!(this.capabilities&1024)),this.c=new O.$Ac(y=>this.m.extUri.getComparisonKey(this.t(y))),this.r(),this.B(b.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(y=>this.s(y)))}r(){this.c.clear();for(const d of this.j.profiles)this.c.add(d.settingsResource),this.c.add(d.keybindingsResource),this.c.add(d.tasksResource),this.c.add(d.extensionsResource)}open(d,P){return this.g.open(this.t(d),P)}close(d){return this.g.close(d)}read(d,P,E,b,l){return this.g.read(d,P,E,b,l)}write(d,P,E,b,l){return this.g.write(d,P,E,b,l)}watch(d,P){this.b.set(d,d);const E=this.g.watch(this.t(d),P);return(0,N.$Pc)(()=>{this.b.delete(d),E.dispose()})}stat(d){return this.g.stat(this.t(d))}mkdir(d){return this.g.mkdir(this.t(d))}rename(d,P,E){return this.g.rename(this.t(d),this.t(P),E)}readFile(d,P){return this.g.readFile(this.t(d),P)}readFileStream(d,P,E){return this.g.readFileStream(this.t(d),P,E)}readdir(d){return this.g.readdir(this.t(d))}enforceAtomicReadFile(d){return this.c.has(d)}writeFile(d,P,E){return this.g.writeFile(this.t(d),P,E)}enforceAtomicWriteFile(d){return this.c.has(d)?{postfix:".vsctmp"}:!1}delete(d,P){return this.g.delete(this.t(d),P)}copy(d,P,E){if((0,j.$gk)(this.g))return this.g.copy(this.t(d),this.t(P),E);throw new Error("copy not supported")}cloneFile(d,P){if((0,j.$hk)(this.g))return this.g.cloneFile(this.t(d),this.t(P));throw new Error("clone not supported")}s(d){const P=[];for(const E of d){if(E.resource.scheme!==this.f)continue;const b=this.u(E.resource);this.b.findSubstr(b)&&P.push({resource:b,type:E.type,cId:E.cId})}P.length&&(this.n.debug("User data changed"),this.a.fire(P))}t(d){return d.with({scheme:this.f})}u(d){return d.with({scheme:this.h})}}e.$c9b=R}),define(ae[78],ce([0,1,86]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BDb=e.$ADb=e.edit=void 0;function N(O,R,S,d){const P=(0,I.$pT)(O,R,S,d)[0];return P&&(O=O.substring(0,P.offset)+P.content+O.substring(P.offset+P.length)),O}e.edit=N;function j(O,R,S){let d=S;for(;d>=0;){if(O.charAt(d)===R.charAt(R.length-1)&&R.length===1)return d+1;if(d--,R.length===2&&d>=0&&O.charAt(d)===R.charAt(0))return d+2}return 0}e.$ADb=j;function L(O,R,S){let d=S;for(;d>=0;)if(O.charAt(d)===R.charAt(R.length-1)&&R.length===1||(d++,R.length===2&&d>=0&&O.charAt(d)===R.charAt(1)))return d;return O.length-1}e.$BDb=L}),define(ae[232],ce([0,1,30,54,12]),function(ie,e,I,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r4b=void 0;function L(l,$,y,w,c,u){const f=[],m=[],k=[];if(!$){const B=l.filter(({identifier:Z})=>c.every(K=>K.toLowerCase()!==Z.id.toLowerCase()));return{local:{added:f,removed:m,updated:k},remote:B.length>0?{added:B,updated:[],removed:[],all:B}:null}}l=l.map(E),$=$.map(E),y=y?y.map(E):null;const s=new Map,a=B=>{B.uuid&&s.set(B.id.toLowerCase(),B.uuid)};l.forEach(({identifier:B})=>a(B)),$.forEach(({identifier:B})=>a(B)),y?.forEach(({identifier:B})=>a(B)),w?.forEach(({identifier:B})=>a(B)),u?.forEach(B=>a(B));const n=B=>{const Z=B.identifier.uuid||s.get(B.identifier.id.toLowerCase());return Z?`uuid:${Z}`:`id:${B.identifier.id.toLowerCase()}`},i=(B,Z)=>(B.set(n(Z),Z),B),t=l.reduce(i,new Map),r=$.reduce(i,new Map),o=$.reduce((B,Z)=>i(B,(0,I.$$m)(Z)),new Map),v=y?y.reduce(i,new Map):null,p=w.reduce(i,new Map),h=c.reduce((B,Z)=>{const K=s.get(Z.toLowerCase());return B.add(K?`uuid:${K}`:`id:${Z.toLowerCase()}`)},new Set),g=u?u.reduce((B,{id:Z,uuid:K})=>(K=K??s.get(Z.toLowerCase()),B.add(K?`uuid:${K}`:`id:${Z.toLowerCase()}`)),new Set):null,D=O(t,r,h,!1);if(D.added.size>0||D.removed.size>0||D.updated.size>0){const B=O(v,t,h,!1),Z=O(v,r,h,!0),K=(x,H,Y,G)=>{let V,ee,ne;return H.installed?(V=G.pinned,ne=G.preRelease,V&&(ee=G.version)):(V=Y.pinned,ne=Y.preRelease,V&&(ee=Y.version)),V===void 0&&(V=H.pinned,V&&(ee=H.version)),ne===void 0&&(ne=H.preRelease),{...G,installed:H.installed||Y.installed,pinned:V,preRelease:ne,version:ee??(Y.version&&(!H.installed||N.gt(Y.version,H.version))?Y.version:H.version),state:S(H,Y,v?.get(x))}};for(const x of Z.removed.values()){const H=t.get(x);if(!H)continue;const Y=(0,j.$Kf)(v?.get(x)),G=g&&!g.has(x)&&Y.installed;H.installed&&G?m.push(H.identifier):o.set(x,H)}for(const x of Z.added.values()){const H=(0,j.$Kf)(r.get(x)),Y=t.get(x);if(Y){if(D.updated.has(x)){const G=K(x,Y,H,H);R(Y,H,!1,!1)||k.push(b(G,x)),o.set(x,G)}}else H.installed&&f.push(b(H,x))}for(const x of Z.updated.values()){const H=(0,j.$Kf)(r.get(x)),Y=(0,j.$Kf)(v?.get(x)),G=t.get(x);if(G)if(g&&!g.has(x)&&Y.installed&&G.installed&&!H.installed)m.push(G.identifier);else{const ee=K(x,G,H,H);k.push(b(ee,x)),o.set(x,ee)}else H.installed&&f.push(b(H,x))}for(const x of B.added.values())Z.added.has(x)||o.set(x,(0,j.$Kf)(t.get(x)));for(const x of B.updated.values()){if(Z.removed.has(x)||Z.updated.has(x))continue;const H=(0,j.$Kf)(t.get(x)),Y=(0,j.$Kf)(r.get(x));o.set(x,K(x,H,Y,H))}for(const x of B.removed.values())Z.updated.has(x)||Z.removed.has(x)||p.has(x)||(0,j.$Kf)(r.get(x)).installed&&g&&(g.has(x)||!(0,j.$Kf)(v?.get(x)).installed||o.delete(x))}const T=[],M=O(r,o,new Set,!0),z=M.added.size>0||M.updated.size>0||M.removed.size>0;return z&&o.forEach((B,Z)=>T.push(b(B,Z))),{local:{added:f,removed:m,updated:k},remote:z?{added:[...M.added].map(B=>o.get(B)),updated:[...M.updated].map(B=>o.get(B)),removed:[...M.removed].map(B=>r.get(B)),all:T}:null}}e.$r4b=L;function O(l,$,y,w){const c=l?[...l.keys()].filter(s=>!y.has(s)):[],u=[...$.keys()].filter(s=>!y.has(s)),f=u.filter(s=>!c.includes(s)).reduce((s,a)=>(s.add(a),s),new Set),m=c.filter(s=>!u.includes(s)).reduce((s,a)=>(s.add(a),s),new Set),k=new Set;for(const s of c){if(m.has(s))continue;const a=l.get(s),n=$.get(s);(!n||!R(a,n,w,!0))&&k.add(s)}return{added:f,removed:m,updated:k}}function R(l,$,y,w){return!(l.disabled!==$.disabled||!!l.isApplicationScoped!=!!$.isApplicationScoped||w&&l.installed!==$.installed||l.installed&&$.installed&&(l.preRelease!==$.preRelease||l.pinned!==$.pinned||$.pinned&&l.version!==$.version)||!P(l.state,$.state)||y&&l.version!==$.version)}function S(l,$,y){const w=l.state,c=$.state,u=y?.state;if(!$.version||w&&N.gt(l.version,$.version))return w;if(c&&N.gt($.version,l.version)||!w)return c;if(!c)return w;const f=(0,I.$$m)(w),m=u?d(u,c):{added:Object.keys(c).reduce((s,a)=>(s.add(a),s),new Set),removed:new Set,updated:new Set},k=u?d(u,w):{added:Object.keys(w).reduce((s,a)=>(s.add(a),s),new Set),removed:new Set,updated:new Set};for(const s of[...m.added.values(),...m.updated.values()])f[s]=c[s];for(const s of m.removed.values())k.updated.has(s)||delete f[s];return f}function d(l,$){const y=Object.keys(l),w=Object.keys($),c=w.filter(m=>!y.includes(m)).reduce((m,k)=>(m.add(k),m),new Set),u=y.filter(m=>!w.includes(m)).reduce((m,k)=>(m.add(k),m),new Set),f=new Set;for(const m of y){if(u.has(m))continue;const k=l[m],s=$[m];(0,I.$cn)(k,s)||f.add(m)}return{added:c,removed:u,updated:f}}function P(l={},$={}){const{added:y,removed:w,updated:c}=d(l,$);return y.size===0&&w.size===0&&c.size===0}function E(l){return{...l,disabled:!!l.disabled,installed:!!l.installed}}function b(l,$){const y={...l,identifier:{id:l.identifier.id,uuid:$.startsWith("uuid:")?$.substring(5):void 0},preRelease:!!l.preRelease,pinned:!!l.pinned};return l.disabled||delete y.disabled,l.installed||delete y.installed,l.state||delete y.state,l.isApplicationScoped||delete y.isApplicationScoped,y}}),define(ae[111],ce([0,1,18,20,4]),function(ie,e,I,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yFb=e.$xFb=void 0,e.$xFb=(0,j.$Th)("IIgnoredExtensionsManagementService");let L=class{constructor(R){this.a=R}hasToNeverSyncExtension(R){return this.b().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.b().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,S){let d=[...this.a.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return d=d.filter(P=>P!==R&&P!==`-${R}`),S&&d.push(R.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",d.length?d:void 0,2)}updateSynchronizedExtensions(R,S){let d=[...this.a.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return d=d.filter(P=>P!==R&&P!==`-${R}`),S&&d.push(`-${R.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",d.length?d:void 0,2)}getIgnoredExtensions(R){const S=R.filter(b=>b.isMachineScoped).map(b=>b.identifier.id.toLowerCase()),d=this.b().map(b=>b.toLowerCase()),P=[],E=[];if(Array.isArray(d))for(const b of d)b.startsWith("-")?E.push(b.substring(1)):P.push(b);return(0,I.$Lb)([...S,...P].filter(b=>!E.includes(b)))}b(){let R=this.a.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.a.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(S=>S.toLowerCase())}};e.$yFb=L,e.$yFb=L=pe([X(0,N.$ni)],L)}),define(ae[233],ce([0,1,18,35,30,94,78]),function(ie,e,I,N,j,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x4b=void 0;function R(m){return(0,N.$1m)(m)||[]}async function S(m,k,s,a,n){const i=R(m),t=R(k),r=s?R(s):null,o=[...i,...t,...r||[]].map(K=>K.key),v=await n.resolveUserBindings(o),p=P(i,t,r,v);if(!p.hasLocalForwarded&&!p.hasRemoteForwarded)return{mergeContent:m,hasChanges:!1,hasConflicts:!1};if(!p.hasLocalForwarded&&p.hasRemoteForwarded)return{mergeContent:k,hasChanges:!0,hasConflicts:!1};if(p.hasLocalForwarded&&!p.hasRemoteForwarded)return{mergeContent:m,hasChanges:!0,hasConflicts:!1};const h=b(i),g=b(t),D=r?b(r):null,T=$(h,g,v),M=D?$(D,h,v):{added:[...h.keys()].reduce((K,x)=>(K.add(x),K),new Set),removed:new Set,updated:new Set},z=D?$(D,g,v):{added:[...g.keys()].reduce((K,x)=>(K.add(x),K),new Set),removed:new Set,updated:new Set},B=d(T,M,z);let Z=m;for(const K of B.removed.values())B.conflicts.has(K)||(Z=u(Z,K,a));for(const K of B.added.values()){if(B.conflicts.has(K))continue;const x=g.get(K);if(x.some(H=>H.command!==`-${K}`&&p.conflicts.has(v[H.key]))){B.conflicts.add(K);continue}Z=c(Z,x,a)}for(const K of B.updated.values()){if(B.conflicts.has(K))continue;const x=g.get(K);if(x.some(H=>H.command!==`-${K}`&&p.conflicts.has(v[H.key]))){B.conflicts.add(K);continue}Z=f(Z,K,x,a)}return{mergeContent:Z,hasChanges:!0,hasConflicts:B.conflicts.size>0}}e.$x4b=S;function d(m,k,s){const a=new Set,n=new Set,i=new Set,t=new Set;for(const r of k.removed.values())s.updated.has(r)&&t.add(r);for(const r of s.removed.values())t.has(r)||(k.updated.has(r)?t.add(r):n.add(r));for(const r of k.added.values())t.has(r)||s.added.has(r)&&m.updated.has(r)&&t.add(r);for(const r of s.added.values())t.has(r)||(k.added.has(r)?m.updated.has(r)&&t.add(r):a.add(r));for(const r of k.updated.values())t.has(r)||s.updated.has(r)&&m.updated.has(r)&&t.add(r);for(const r of s.updated.values())t.has(r)||(k.updated.has(r)?m.updated.has(r)&&t.add(r):i.add(r));return{added:a,removed:n,updated:i,conflicts:t}}function P(m,k,s,a){const n=new Set,i=E(m,a),t=E(k,a),r=s?E(s,a):null,o=l(i,t);if(o.added.size===0&&o.removed.size===0&&o.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const v=r?l(r,i):{added:[...i.keys()].reduce((M,z)=>(M.add(z),M),new Set),removed:new Set,updated:new Set};if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const p=r?l(r,t):{added:[...t.keys()].reduce((M,z)=>(M.add(z),M),new Set),removed:new Set,updated:new Set};if(p.added.size===0&&p.removed.size===0&&p.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:h,removed:g,updated:D,conflicts:T}=d(o,v,p);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:h,removed:g,updated:D,conflicts:T}}function E(m,k){const s=new Map;for(const a of m){const n=k[a.key];let i=s.get(n);i||(i=[],s.set(n,i)),i.push(a)}return s}function b(m){const k=new Map;for(const s of m){const a=s.command[0]==="-"?s.command.substring(1):s.command;let n=k.get(a);n||(n=[],k.set(a,n)),n.push(s)}return k}function l(m,k){const s=[...m.keys()],a=[...k.keys()],n=a.filter(r=>!s.includes(r)).reduce((r,o)=>(r.add(o),r),new Set),i=s.filter(r=>!a.includes(r)).reduce((r,o)=>(r.add(o),r),new Set),t=new Set;for(const r of s){if(i.has(r))continue;const o=m.get(r).map(p=>({...p,key:r})),v=k.get(r).map(p=>({...p,key:r}));(0,I.$tb)(o,v,(p,h)=>w(p,h))||t.add(r)}return{added:n,removed:i,updated:t}}function $(m,k,s){const a=[...m.keys()],n=[...k.keys()],i=n.filter(o=>!a.includes(o)).reduce((o,v)=>(o.add(v),o),new Set),t=a.filter(o=>!n.includes(o)).reduce((o,v)=>(o.add(v),o),new Set),r=new Set;for(const o of a){if(t.has(o))continue;const v=m.get(o).map(h=>({...h,key:s[h.key]})),p=k.get(o).map(h=>({...h,key:s[h.key]}));y(v,p)||r.add(o)}return{added:i,removed:t,updated:r}}function y(m,k){return!(!(0,I.$tb)(m.filter(({command:s})=>s[0]!=="-"),k.filter(({command:s})=>s[0]!=="-"),(s,a)=>w(s,a))||!(0,I.$tb)(m.filter(({command:s})=>s[0]==="-"),k.filter(({command:s})=>s[0]==="-"),(s,a)=>w(s,a)))}function w(m,k){if(m.command!==k.command||m.key!==k.key)return!1;const s=L.$Ri.deserialize(m.when),a=L.$Ri.deserialize(k.when);return!(s&&!a||!s&&a||s&&a&&!s.equals(a)||!j.$cn(m.args,k.args))}function c(m,k,s){for(const a of k)m=O.edit(m,[-1],a,s);return m}function u(m,k,s){const a=R(m);for(let n=a.length-1;n>=0;n--)(a[n].command===k||a[n].command===`-${k}`)&&(m=O.edit(m,[n],void 0,s));return m}function f(m,k,s,a){const n=R(m),i=n.findIndex(t=>t.command===k||t.command===`-${k}`);for(let t=n.length-1;t>=0;t--)(n[t].command===k||n[t].command===`-${k}`)&&(m=O.edit(m,[t],void 0,a));for(let t=s.length-1;t>=0;t--)m=O.edit(m,[i],s[t],a);return m}}),define(ae[234],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F4b=e.$E4b=void 0;function I(L,O,R){const S={},d={},P=new Set;if(!O)return{local:{added:S,updated:d,removed:[...P.values()]},remote:{added:L,updated:{},removed:[]},conflicts:[]};const E=N(L,O);if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{local:{added:S,updated:d,removed:[...P.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const b=N(R,L),l=N(R,O),$={},y={},w=new Set,c=new Set;for(const u of b.removed.values())l.updated.has(u)?S[u]=O[u]:w.add(u);for(const u of l.removed.values())c.has(u)||(b.updated.has(u)?c.add(u):P.add(u));for(const u of b.updated.values())c.has(u)||(l.updated.has(u)?E.updated.has(u)&&c.add(u):y[u]=L[u]);for(const u of l.updated.values())c.has(u)||(b.updated.has(u)?E.updated.has(u)&&c.add(u):L[u]!==void 0&&(d[u]=O[u]));for(const u of b.added.values())c.has(u)||(l.added.has(u)?E.updated.has(u)&&c.add(u):$[u]=L[u]);for(const u of l.added.values())c.has(u)||(b.added.has(u)?E.updated.has(u)&&c.add(u):S[u]=O[u]);return{local:{added:S,removed:[...P.values()],updated:d},remote:{added:$,removed:[...w.values()],updated:y},conflicts:[...c.values()]}}e.$E4b=I;function N(L,O){const R=L?Object.keys(L):[],S=O?Object.keys(O):[],d=S.filter(b=>!R.includes(b)).reduce((b,l)=>(b.add(l),b),new Set),P=R.filter(b=>!S.includes(b)).reduce((b,l)=>(b.add(l),b),new Set),E=new Set;for(const b of R){if(P.has(b))continue;const l=L[b],$=O[b];l!==$&&E.add(b)}return{added:d,removed:P,updated:E}}function j(L,O){const{added:R,removed:S,updated:d}=N(L,O);return R.size===0&&S.size===0&&d.size===0}e.$F4b=j}),define(ae[235],ce([0,1,30]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n6b=void 0;function N(L,O,R,S){const d={added:[],removed:[],updated:[]};let P={added:[],removed:[],updated:[]};if(!O){const b=L.filter(({id:l})=>!S.includes(l));return b.length?P.added=b:P=null,{local:d,remote:P}}const E=j(L,O,S);if(E.added.length>0||E.removed.length>0||E.updated.length>0){const b=j(R,L,S),l=j(R,O,S);for(const $ of l.removed){const y=L.find(w=>w.id===$);y&&d.removed.push(y)}for(const $ of l.added){const y=O.find(w=>w.id===$);b.added.includes($)?E.updated.includes($)&&d.updated.push(y):d.added.push(y)}for(const $ of l.updated)d.updated.push(O.find(y=>y.id===$));for(const $ of b.added)l.added.includes($)||P.added.push(L.find(y=>y.id===$));for(const $ of b.updated)l.removed.includes($)||l.updated.includes($)||P.updated.push(L.find(y=>y.id===$));for(const $ of b.removed){const y=O.find(w=>w.id===$);y&&P.removed.push(y)}}return P.added.length===0&&P.removed.length===0&&P.updated.length===0&&(P=null),{local:d,remote:P}}e.$n6b=N;function j(L,O,R){L=L?L.filter(({id:l})=>!R.includes(l)):[],O=O.filter(({id:l})=>!R.includes(l));const S=L.map(({id:l})=>l),d=O.map(({id:l})=>l),P=d.filter(l=>!S.includes(l)),E=S.filter(l=>!d.includes(l)),b=[];for(const{id:l,name:$,shortName:y,icon:w,useDefaultFlags:c}of L){if(E.includes(l))continue;const u=O.find(f=>f.id===l);(!u||u.name!==$||u.shortName!==y||u.icon!==w||!(0,I.$cn)(u.useDefaultFlags,c))&&b.push(l)}return{added:P,removed:E,updated:b}}}),define(ae[24],ce([0,1,18,12,173,50,29,4,103,41]),function(ie,e,I,N,j,L,O,R,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$whb=e.$vhb=e.$uhb=e.$thb=e.$shb=e.$rhb=e.$qhb=e.$phb=e.$ohb=e.$nhb=e.$mhb=e.MergeState=e.Change=e.SyncStatus=e.$lhb=e.$khb=e.$jhb=e.UserDataSyncErrorCode=e.$ihb=e.$hhb=e.$ghb=e.$fhb=e.$ehb=e.$dhb=e.$chb=e.$bhb=e.$ahb=e.SyncResource=e.$_gb=e.$$gb=e.$0gb=e.$9gb=e.$8gb=e.$7gb=void 0;function P(){const t=d.$kn.as(L.$pn.Configuration).getConfigurationProperties();return Object.keys(t).filter(r=>!!t[r].disallowSyncIgnore)}e.$7gb=P;function E(){const t=d.$kn.as(L.$pn.Configuration).getConfigurationProperties(),r=Object.keys(t).filter(p=>!!t[p].ignoreSync),o=Object.keys(t).filter(p=>t[p].scope===2||t[p].scope===6),v=P();return(0,I.$Lb)([...r,...o,...v])}e.$8gb=E,e.$9gb="settingsSync",e.$0gb="settingsSync.keybindingsPerPlatform";function b(){const t="vscode://schemas/ignoredSettings",r=d.$kn.as(L.$pn.Configuration);r.registerConfiguration({id:"settingsSync",order:30,title:(0,j.localize)(0,null),type:"object",properties:{[e.$0gb]:{type:"boolean",description:(0,j.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,j.localize)(2,null),items:[{type:"string",pattern:O.$2n,errorMessage:(0,j.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,j.localize)(4,null),default:[],scope:1,$ref:t,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const o=d.$kn.as(S.$ln.JSONContribution),v=()=>{const p=P(),h=E(),g=Object.keys(L.$qn.properties).filter(M=>!h.includes(M)),D=h.filter(M=>!p.includes(M)),T={items:{type:"string",enum:[...g,...D.map(M=>`-${M}`)]}};o.registerSchema(t,T)};return r.onDidUpdateConfiguration(()=>v())}e.$$gb=b;function l(t){return t&&(0,N.$Bf)(t)&&(0,N.$zf)(t.id)&&Array.isArray(t.scopes)}e.$_gb=l;var $;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState",t.Profiles="profiles",t.WorkspaceState="workspaceState"})($||(e.SyncResource=$={})),e.$ahb=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function y(t,...r){return t?[t,...r]:r}e.$bhb=y;function w(t,r,o,v){return v.joinPath(o.userDataSyncHome,...y(t,r,`lastSync${r}.json`))}e.$chb=w,e.$dhb=(0,R.$Th)("IUserDataSyncStoreManagementService"),e.$ehb=(0,R.$Th)("IUserDataSyncStoreService"),e.$fhb=(0,R.$Th)("IUserDataSyncLocalStoreService"),e.$ghb="x-operation-id",e.$hhb="X-Execution-Id";function c(t){const r={};return r[e.$hhb]=t,r}e.$ihb=c;var u;(function(t){t.Unauthorized="Unauthorized",t.Forbidden="Forbidden",t.NotFound="NotFound",t.MethodNotFound="MethodNotFound",t.Conflict="Conflict",t.Gone="Gone",t.PreconditionFailed="PreconditionFailed",t.TooLarge="TooLarge",t.UpgradeRequired="UpgradeRequired",t.PreconditionRequired="PreconditionRequired",t.TooManyRequests="RemoteTooManyRequests",t.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",t.RequestFailed="RequestFailed",t.RequestCanceled="RequestCanceled",t.RequestTimeout="RequestTimeout",t.RequestProtocolNotSupported="RequestProtocolNotSupported",t.RequestPathNotEscaped="RequestPathNotEscaped",t.RequestHeadersNotObject="RequestHeadersNotObject",t.NoCollection="NoCollection",t.NoRef="NoRef",t.EmptyResponse="EmptyResponse",t.TurnedOff="TurnedOff",t.SessionExpired="SessionExpired",t.ServiceChanged="ServiceChanged",t.DefaultServiceChanged="DefaultServiceChanged",t.LocalTooManyProfiles="LocalTooManyProfiles",t.LocalTooManyRequests="LocalTooManyRequests",t.LocalPreconditionFailed="LocalPreconditionFailed",t.LocalInvalidContent="LocalInvalidContent",t.LocalError="LocalError",t.IncompatibleLocalContent="IncompatibleLocalContent",t.IncompatibleRemoteContent="IncompatibleRemoteContent",t.Unknown="Unknown"})(u||(e.UserDataSyncErrorCode=u={}));class f extends Error{constructor(r,o,v,p){super(r),this.code=o,this.resource=v,this.operationId=p,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.$jhb=f;class m extends f{constructor(r,o,v,p,h){super(r,v,void 0,h),this.url=o,this.serverCode=p}}e.$khb=m;class k extends f{constructor(r,o){super(r,o)}}e.$lhb=k,function(t){function r(o){if(o instanceof t)return o;const v=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(o.name);if(v&&v[1]){const p=v[2]==="unknown"?void 0:v[2],h=v[3]==="unknown"?void 0:v[3];return new t(o.message,v[1],p,h)}return new t(o.message,"Unknown")}t.toUserDataSyncError=r}(f||(e.$jhb=f={}));var s;(function(t){t.Uninitialized="uninitialized",t.Idle="idle",t.Syncing="syncing",t.HasConflicts="hasConflicts"})(s||(e.SyncStatus=s={}));var a;(function(t){t[t.None=0]="None",t[t.Added=1]="Added",t[t.Modified=2]="Modified",t[t.Deleted=3]="Deleted"})(a||(e.Change=a={}));var n;(function(t){t.Preview="preview",t.Conflict="conflict",t.Accepted="accepted"})(n||(e.MergeState=n={})),e.$mhb="sync.store.url.type";function i(t){return`sync.enable.${t}`}e.$nhb=i,e.$ohb=(0,R.$Th)("IUserDataSyncEnablementService"),e.$phb=(0,R.$Th)("IUserDataSyncService"),e.$qhb=(0,R.$Th)("IUserDataSyncResourceProviderService"),e.$rhb=(0,R.$Th)("IUserDataAutoSyncService"),e.$shb=(0,R.$Th)("IUserDataSyncUtilService"),e.$thb=(0,R.$Th)("IUserDataSyncLogService"),e.$uhb="userDataSync",e.$vhb="vscode-userdata-sync",e.$whb="preview"}),define(ae[236],ce([0,1,30,24]),function(ie,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TEb=void 0;function j(O,R,S,d,P){if(!R)return{remote:{added:Object.keys(O),removed:[],updated:[],all:Object.keys(O).length>0?O:null},local:{added:{},removed:[],updated:{}}};const E=L(O,R);if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const b=S?L(S,R):{added:Object.keys(R).reduce((u,f)=>(u.add(f),u),new Set),removed:new Set,updated:new Set},l=S?L(S,O):{added:Object.keys(O).reduce((u,f)=>(u.add(f),u),new Set),removed:new Set,updated:new Set},$={added:{},removed:[],updated:{}},y=I.$$m(R),w=!S;for(const u of l.added.values())u!==N.$mhb&&w&&b.added.has(u)||(y[u]=O[u]);for(const u of l.updated.values())y[u]=O[u];for(const u of l.removed.values())d.unregistered.includes(u)||delete y[u];for(const u of b.added.values()){const f=R[u];if(d.machine.includes(u)){P.info(`GlobalState: Skipped adding ${u} in local storage because it is declared as machine scoped.`);continue}if(S&&l.added.has(u))continue;const m=O[u];m&&m.value===f.value||u===N.$mhb&&w&&l.added.has(u)||(m?$.updated[u]=f:$.added[u]=f)}for(const u of b.updated.values()){const f=R[u];if(d.machine.includes(u)){P.info(`GlobalState: Skipped updating ${u} in local storage because it is declared as machine scoped.`);continue}if(l.updated.has(u)||l.removed.has(u))continue;const m=O[u];m&&m.value===f.value||($.updated[u]=f)}for(const u of b.removed.values()){if(d.machine.includes(u)){P.trace(`GlobalState: Skipped removing ${u} in local storage because it is declared as machine scoped.`);continue}l.updated.has(u)||l.removed.has(u)||$.removed.push(u)}const c=L(R,y);return{local:$,remote:{added:[...c.added],updated:[...c.updated],removed:[...c.removed],all:c.added.size===0&&c.removed.size===0&&c.updated.size===0?null:y}}}e.$TEb=j;function L(O,R){const S=Object.keys(O),d=Object.keys(R),P=d.filter(l=>!S.includes(l)).reduce((l,$)=>(l.add($),l),new Set),E=S.filter(l=>!d.includes(l)).reduce((l,$)=>(l.add($),l),new Set),b=new Set;for(const l of S){if(E.has(l))continue;const $=O[l],y=R[l];I.$cn($,y)||b.add(l)}return{added:P,removed:E,updated:b}}}),define(ae[237],ce([0,1,18,35,86,42,30,78,24]),function(ie,e,I,N,j,L,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HDb=e.$GDb=e.$FDb=e.$EDb=e.$DDb=e.$CDb=void 0;function d(o,v,p){let h=[];p?h=E(p):h=P(v);const g=[],D=[...(0,S.$7gb)()];if(Array.isArray(h))for(const T of h)T.startsWith("-")?D.push(T.substring(1)):g.push(T);return(0,I.$Lb)([...o,...g].filter(T=>!D.includes(T)))}e.$CDb=d;function P(o){let v=o.inspect("settingsSync.ignoredSettings").userValue;return v!==void 0||(v=o.inspect("sync.ignoredSettings").userValue,v!==void 0)?v:o.getValue("settingsSync.ignoredSettings")||[]}function E(o){const v=(0,N.$1m)(o);return v?v["settingsSync.ignoredSettings"]||v["sync.ignoredSettings"]||[]:[]}function b(o,v){const p=(0,N.$1m)(o)||{};let h="{}";for(const g of Object.keys(p)){const D=(0,j.$pT)(h,[g],p[g],v);h=(0,j.$sT)(h,D)}return h}e.$DDb=b;function l(o,v,p,h){if(p.length){const g=r(v),D=(0,N.$1m)(v)||{},T=(0,N.$1m)(o);if(!T)return o;const M=[];for(const z of p){const B=D[z],Z=T[z];B===void 0?o=R.edit(o,[z],void 0,h):Z!==void 0?o=R.edit(o,[z],B,h):M.push(s(z,g))}M.sort((z,B)=>z.startOffset-B.startOffset),M.forEach(z=>o=u(z.setting.key,v,o,h))}return o}e.$EDb=l;function $(o,v,p,h,g,D){const T=l(o,v,h,D),M=p!==T,z=p!==v;if(!M&&!z)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(M&&!z)return{conflictsSettings:[],localContent:null,remoteContent:T,hasConflicts:!1};if(z&&!M)return{conflictsSettings:[],localContent:l(v,o,h,D),remoteContent:null,hasConflicts:!1};if(p===null&&w(o)){const A=y(o,v,h)?null:l(v,o,h,D);return{conflictsSettings:[],localContent:A,remoteContent:null,hasConflicts:!1}}let B=o,Z=v;const K=(0,N.$1m)(o),x=(0,N.$1m)(v),H=p?(0,N.$1m)(p):null,Y=h.reduce((A,J)=>(A.add(J),A),new Set),G=c(K,x,Y),V=c(H,K,Y),ee=c(H,x,Y),ne=new Map,_=new Set,re=A=>{_.add(A);const J=g.filter(({key:F})=>F===A)[0];J?(B=R.edit(B,[A],J.value,D),Z=R.edit(Z,[A],J.value,D)):ne.set(A,{key:A,localValue:K[A],remoteValue:x[A]})};for(const A of V.removed.values())ee.updated.has(A)?re(A):Z=R.edit(Z,[A],void 0,D);for(const A of ee.removed.values())_.has(A)||(V.updated.has(A)?re(A):B=R.edit(B,[A],void 0,D));for(const A of V.updated.values())_.has(A)||(ee.updated.has(A)?G.updated.has(A)&&re(A):Z=R.edit(Z,[A],K[A],D));for(const A of ee.updated.values())_.has(A)||(V.updated.has(A)?G.updated.has(A)&&re(A):B=R.edit(B,[A],x[A],D));for(const A of V.added.values())_.has(A)||(ee.added.has(A)?G.updated.has(A)&&re(A):Z=u(A,B,Z,D));for(const A of ee.added.values())_.has(A)||(V.added.has(A)?G.updated.has(A)&&re(A):B=u(A,Z,B,D));const Q=ne.size>0||!y(B,Z,h),q=Q||!y(B,o,[]),C=Q||!y(Z,v,[]);return{localContent:q?B:null,remoteContent:C?Z:null,conflictsSettings:[...ne.values()],hasConflicts:Q}}e.$FDb=$;function y(o,v,p){if(o===v)return!0;const h=(0,N.$1m)(o),g=(0,N.$1m)(v),D=p.reduce((z,B)=>(z.add(B),z),new Set),T=r(o).filter(z=>!(z.setting&&D.has(z.setting.key))),M=r(v).filter(z=>!(z.setting&&D.has(z.setting.key)));if(T.length!==M.length)return!1;for(let z=0;z<T.length;z++){const B=T[z],Z=M[z];if(B.setting&&Z.setting){if(B.setting.key!==Z.setting.key||!O.$cn(h[B.setting.key],g[B.setting.key]))return!1}else if(!B.setting&&!Z.setting){if(B.value!==Z.value)return!1}else return!1}return!0}function w(o){return o?r(o).length===0:!0}e.$GDb=w;function c(o,v,p){const h=o?Object.keys(o).filter(z=>!p.has(z)):[],g=Object.keys(v).filter(z=>!p.has(z)),D=g.filter(z=>!h.includes(z)).reduce((z,B)=>(z.add(B),z),new Set),T=h.filter(z=>!g.includes(z)).reduce((z,B)=>(z.add(B),z),new Set),M=new Set;if(o)for(const z of h){if(T.has(z))continue;const B=o[z],Z=v[z];O.$cn(B,Z)||M.add(z)}return{added:D,removed:T,updated:M}}function u(o,v,p,h){const g=(0,N.$1m)(v),D=r(v),T=r(p),M=f(o,D,T);return m(p,o,g[o],M,T,h)}e.$HDb=u;function f(o,v,p){const h=v.findIndex(D=>D.setting?.key===o),g=v[h-1];if(g){if(g.setting){const T=s(g.setting.key,p);if(T)return{index:p.indexOf(T),insertAfter:!0}}else{const T=a(h,v);if(T){const M=s(T.setting.key,p);if(M){const z=n(p.indexOf(M),p),B=i(v,T,v[h]);if(z){const Z=i(p,M,z),K=t(B,Z);return K?{index:p.indexOf(K),insertAfter:!0}:{index:p.indexOf(z),insertAfter:!1}}else{const Z=i(p,M,p[p.length-1]),K=t(B,Z);return K?{index:p.indexOf(K),insertAfter:!0}:{index:p.length-1,insertAfter:!0}}}}}const D=v[h+1];if(D)if(D.setting){const T=s(D.setting.key,p);if(T)return{index:p.indexOf(T),insertAfter:!1}}else{const T=n(h,v);if(T){const M=s(T.setting.key,p);if(M){const z=a(p.indexOf(M),p),B=i(v,v[h],T);if(z){const Z=i(p,z,M),K=t(B.reverse(),Z.reverse());return K?{index:p.indexOf(K),insertAfter:!1}:{index:p.indexOf(z),insertAfter:!0}}else{const Z=i(p,p[0],M),K=t(B.reverse(),Z.reverse());return K?{index:p.indexOf(K),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:p.length-1,insertAfter:!0}}function m(o,v,p,h,g,D){let T;return h.index===-1?T=(0,j.$pT)(o,[v],p,D):T=k(o,v,p,h,g,D).map(M=>(0,j.$qT)(o,M,D)[0]),(0,j.$sT)(o,T)}function k(o,v,p,h,g,D){const T=`${JSON.stringify(v)}: ${JSON.stringify(p)}`,M=(0,L.$mT)(D,o),z=g[h.index];if(h.insertAfter){const B=[];if(z.setting)B.push({offset:z.endOffset,length:0,content:","+T});else{const Z=n(h.index,g),K=a(h.index,g),x=K?.setting?.commaOffset;K&&x===void 0&&B.push({offset:K.endOffset,length:0,content:","});const H=x!==void 0&&x>z.endOffset;B.push({offset:H?x+1:z.endOffset,length:0,content:Z?M+T+",":M+T})}return B}else{if(z.setting)return[{offset:z.startOffset,length:0,content:T+","}];const B=(g[h.index-1]&&!g[h.index-1].setting?M:"")+T+(n(h.index,g)?",":"")+M;return[{offset:z.startOffset,length:0,content:B}]}}function s(o,v){return v.filter(p=>p.setting?.key===o)[0]}function a(o,v){for(let p=o-1;p>=0;p--)if(v[p].setting)return v[p]}function n(o,v){for(let p=o+1;p<v.length;p++)if(v[p].setting)return v[p]}function i(o,v,p){const h=o.indexOf(v),g=o.indexOf(p);return o.filter((D,T)=>h<T&&T<g)}function t(o,v){if(o.length&&v.length){let p=0;for(;p<v.length&&p<o.length;p++)if(o[p].value!==v[p].value)return v[p-1];return v[p-1]}}function r(o){const v=[];let p=-1,h,g;const D={onObjectBegin:T=>{p++},onObjectProperty:(T,M,z)=>{p===0&&(h=M,g=T)},onObjectEnd:(T,M)=>{p--,p===0&&v.push({startOffset:h,endOffset:T+M,value:o.substring(h,T+M),setting:{key:g,commaOffset:void 0}})},onArrayBegin:(T,M)=>{p++},onArrayEnd:(T,M)=>{p--,p===0&&v.push({startOffset:h,endOffset:T+M,value:o.substring(h,T+M),setting:{key:g,commaOffset:void 0}})},onLiteralValue:(T,M,z)=>{p===0&&v.push({startOffset:h,endOffset:M+z,value:o.substring(h,M+z),setting:{key:g,commaOffset:void 0}})},onSeparator:(T,M,z)=>{if(p===0&&T===","){let B=v.length-1;for(;B>=0&&!v[B].setting;B--);const Z=v[B];Z&&v.splice(B,1,{startOffset:Z.startOffset,endOffset:Z.endOffset,value:Z.value,setting:{key:Z.setting.key,commaOffset:M}})}},onComment:(T,M)=>{p===0&&v.push({startOffset:T,endOffset:T+M,value:o.substring(T,T+M)})}};return(0,N.$8m)(o,D),v}}),define(ae[79],ce([0,1,3,2,4,24]),function(ie,e,I,N,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nDb=e.$mDb=void 0,e.$mDb=(0,j.$Th)("IUserDataSyncAccountService");let O=class extends N.$Rc{get account(){return this.a}constructor(S,d){super(),this.g=S,this.h=d,this.b=this.B(new I.$Od),this.onDidChangeAccount=this.b.event,this.c=this.B(new I.$Od),this.onTokenFailed=this.c.event,this.f=!1,this.B(S.onTokenFailed(P=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,P),this.updateAccount(void 0),P==="Forbidden"?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(S.onTokenSucceed(()=>this.f=!1))}async updateAccount(S){(S&&this.a?S.token!==this.a.token||S.authenticationProviderId!==this.a.authenticationProviderId:S!==this.a)&&(this.a=S,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(S))}};e.$nDb=O,e.$nDb=O=pe([X(0,L.$ehb),X(1,L.$thb)],O)}),define(ae[238],ce([0,1,2,10]),function(ie,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O9b=e.$N9b=e.$M9b=e.$L9b=e.$K9b=e.$J9b=e.$I9b=void 0;class j{constructor(b){this.a=b}listen(b,l){switch(l){case"onError":return this.a.onError}throw new Error(`Event not found: ${l}`)}call(b,l,$){switch(l){case"triggerSync":return this.a.triggerSync($[0],$[1],$[2]);case"turnOn":return this.a.turnOn();case"turnOff":return this.a.turnOff($[0])}throw new Error("Invalid call")}}e.$I9b=j;class L{constructor(b){this.a=b}listen(b,l){throw new Error(`Event not found: ${l}`)}call(b,l,$){switch(l){case"resolveDefaultIgnoredSettings":return this.a.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.a.resolveUserBindings($[0]);case"resolveFormattingOptions":return this.a.resolveFormattingOptions(N.URI.revive($[0]))}throw new Error("Invalid call")}}e.$J9b=L;class O{constructor(b){this.a=b}async resolveDefaultIgnoredSettings(){return this.a.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(b){return this.a.call("resolveUserKeybindings",[b])}async resolveFormattingOptions(b){return this.a.call("resolveFormattingOptions",[b])}}e.$K9b=O;class R{constructor(b){this.a=b}listen(b,l){switch(l){case"onDidChange":return this.a.onDidChange}throw new Error(`Event not found: ${l}`)}async call(b,l,$){switch(l){case"getMachines":return this.a.getMachines();case"addCurrentMachine":return this.a.addCurrentMachine();case"removeCurrentMachine":return this.a.removeCurrentMachine();case"renameMachine":return this.a.renameMachine($[0],$[1]);case"setEnablements":return this.a.setEnablements($)}throw new Error("Invalid call")}}e.$L9b=R;class S{constructor(b){this.a=b}listen(b,l){switch(l){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`Event not found: ${l}`)}call(b,l,$){switch(l){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount($)}throw new Error("Invalid call")}}e.$M9b=S;class d{constructor(b){this.a=b}listen(b,l){switch(l){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${l}`)}call(b,l,$){switch(l){case"switch":return this.a.switch($[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.$N9b=d;class P extends I.$Rc{constructor(b){super(),this.a=b,this.onDidChangeUserDataSyncStore=this.a.listen("onDidChangeUserDataSyncStore")}async switch(b){return this.a.call("switch",[b])}async getPreviousUserDataSyncStore(){const b=await this.a.call("getPreviousUserDataSyncStore");return this.b(b)}b(b){return{url:N.URI.revive(b.url),type:b.type,defaultUrl:N.URI.revive(b.defaultUrl),insidersUrl:N.URI.revive(b.insidersUrl),stableUrl:N.URI.revive(b.stableUrl),canSwitch:b.canSwitch,authenticationProviders:b.authenticationProviders}}}e.$O9b=P}),define(ae[239],ce([0,1,19,174,14,8,24]),function(ie,e,I,N,j,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zFb=void 0;let R=class extends L.$gj{constructor(d,P){super(),this.g=this.B(d.createLogger((0,I.$wg)(P.logsHome,`${O.$uhb}.log`),{id:O.$uhb,name:(0,N.localize)(0,null)}))}trace(d,...P){this.g.trace(d,...P)}debug(d,...P){this.g.debug(d,...P)}info(d,...P){this.g.info(d,...P)}warn(d,...P){this.g.warn(d,...P)}error(d,...P){this.g.error(d,...P)}flush(){this.g.flush()}};e.$zFb=R,e.$zFb=R=pe([X(0,L.$cj),X(1,j.$1h)],R)}),define(ae[240],ce([0,1,6,3,2]),function(ie,e,I,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J8b=void 0;class L extends j.$Rc{constructor({onDidOpenMainWindow:R,onDidFocusMainWindow:S,getActiveWindowId:d}){super(),this.a=this.B(new j.$Qc),N.Event.latch(N.Event.any(R,S))(this.f,this,this.a),this.b=(0,I.$Ig)(()=>d()),(async()=>{try{const E=await this.b;this.c=typeof this.c=="number"?this.c:E}catch{}finally{this.b=void 0}})()}f(R){this.b&&(this.b.cancel(),this.b=void 0),this.c=R}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$J8b=L}),define(ae[112],ce([0,1,177,16,47,19,10,4,23]),function(ie,e,I,N,j,L,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.WorkbenchState=e.$0h=e.$9h=e.$8h=e.$7h=e.$6h=e.$5h=e.$4h=e.$3h=void 0,e.$3h=(0,R.$Th)("contextService");function d(i){const t=i;return typeof t?.id=="string"&&O.URI.isUri(t.uri)}e.$4h=d;function P(i){return typeof i?.id=="string"&&!d(i)&&!b(i)}e.$5h=P,e.$6h={id:"ext-dev"},e.$7h={id:"empty-window"};function E(i,t){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,N.$mc)(i)}:t?e.$6h:e.$7h;const r=i;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.$8h=E;function b(i){const t=i;return typeof t?.id=="string"&&O.URI.isUri(t.configPath)}e.$9h=b;function l(i){const t=i;if(t?.uri)return{id:t.id,uri:O.URI.revive(t.uri)};const r=i;if(r?.configPath)return{id:r.id,configPath:O.URI.revive(r.configPath)};if(i?.id)return{id:i.id}}e.$0h=l;var $;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})($||(e.WorkbenchState=$={}));function y(i){const t=i;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}e.$$h=y;function w(i){const t=i;return!!(t&&typeof t=="object"&&O.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}e.$_h=w;class c{constructor(t,r,o,v,p){this.h=t,this.j=o,this.k=v,this.l=p,this.c=j.$Zh.forUris(this.l,()=>!0),this.folders=r}update(t){this.h=t.id,this.k=t.configuration,this.j=t.transient,this.l=t.l,this.folders=t.folders}get folders(){return this.g}set folders(t){this.g=t,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(t){this.k=t}getFolder(t){return t&&this.c.findSubstr(t)||null}n(){this.c=j.$Zh.forUris(this.l,()=>!0);for(const t of this.folders)this.c.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$ai=c;class u{constructor(t,r){this.raw=r,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,L.$wg)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$bi=u;function f(i){return new u({uri:i,index:0,name:(0,L.$sg)(i)},{uri:i.toString()})}e.$ci=f,e.$di="code-workspace",e.$ei=`.${e.$di}`,e.$fi=[{name:(0,I.localize)(0,null),extensions:[e.$di]}],e.$gi="workspace.json";function m(i,t){return L.$ng.isEqualOrParent(i,t.untitledWorkspacesHome)}e.$hi=m;function k(i){let t;return O.URI.isUri(i)?t=i:t=i.configuration,t?.scheme===S.Schemas.tmp}e.$ii=k,e.$ji="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function s(i){return i.id===e.$ji}e.$ki=s;function a(i,t){return!m(i,t)&&!k(i)}e.$li=a;function n(i){return(typeof i=="string"?(0,N.$nc)(i):(0,L.$ug)(i))===e.$ei}e.$mi=n}),define(ae[17],ce([0,1,52,3,2,19,10,168,14,11,4,8,112,34,28,6,32,27,12]),function(ie,e,I,N,j,L,O,R,S,d,P,E,b,l,$,y,w,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.ProfileResourceType=void 0;var f;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(f||(e.ProfileResourceType=f={}));function m(i){const t=i;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&O.URI.isUri(t.location)&&O.URI.isUri(t.globalStorageHome)&&O.URI.isUri(t.settingsResource)&&O.URI.isUri(t.keybindingsResource)&&O.URI.isUri(t.tasksResource)&&O.URI.isUri(t.snippetsHome)&&O.URI.isUri(t.extensionsResource))}e.$Nk=m,e.$Ok=(0,P.$Th)("IUserDataProfilesService");function k(i,t){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:O.URI.revive(i.location).with({scheme:t}),globalStorageHome:O.URI.revive(i.globalStorageHome).with({scheme:t}),settingsResource:O.URI.revive(i.settingsResource).with({scheme:t}),keybindingsResource:O.URI.revive(i.keybindingsResource).with({scheme:t}),tasksResource:O.URI.revive(i.tasksResource).with({scheme:t}),snippetsHome:O.URI.revive(i.snippetsHome).with({scheme:t}),extensionsResource:O.URI.revive(i.extensionsResource).with({scheme:t}),cacheHome:O.URI.revive(i.cacheHome).with({scheme:t}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.$Pk=k;function s(i,t,r,o,v,p){return{id:i,name:t,location:r,isDefault:!1,shortName:v?.shortName,icon:v?.icon,globalStorageHome:p&&v?.useDefaultFlags?.globalState?p.globalStorageHome:(0,L.$wg)(r,"globalStorage"),settingsResource:p&&v?.useDefaultFlags?.settings?p.settingsResource:(0,L.$wg)(r,"settings.json"),keybindingsResource:p&&v?.useDefaultFlags?.keybindings?p.keybindingsResource:(0,L.$wg)(r,"keybindings.json"),tasksResource:p&&v?.useDefaultFlags?.tasks?p.tasksResource:(0,L.$wg)(r,"tasks.json"),snippetsHome:p&&v?.useDefaultFlags?.snippets?p.snippetsHome:(0,L.$wg)(r,"snippets"),extensionsResource:p&&v?.useDefaultFlags?.extensions?p.extensionsResource:(0,L.$wg)(r,"extensions.json"),cacheHome:(0,L.$wg)(o,i),useDefaultFlags:v?.useDefaultFlags,isTransient:v?.transient}}e.$Qk=s;let a=class extends j.$Rc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(t,r,o,v){super(),this.t=t,this.u=r,this.w=o,this.y=v,this.f=!0,this.h=this.B(new N.$Od),this.onDidChangeProfiles=this.h.event,this.j=this.B(new N.$Od),this.onWillCreateProfile=this.j.event,this.m=this.B(new N.$Od),this.onWillRemoveProfile=this.m.event,this.n=this.B(new N.$Od),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new l.$zc,emptyWindows:new Map},this.profilesHome=(0,L.$wg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,L.$wg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(t){this.f!==t&&(this.z=void 0,this.f=t)}isEnabled(){return this.f}get C(){if(!this.z){const t=this.D(),r=[t];if(this.f)try{for(const p of this.O()){if(!p.name||!(0,u.$zf)(p.name)||!p.location){this.y.warn("Skipping the invalid stored profile",p.location||p.name);continue}r.push(s((0,L.$tg)(p.location),p.name,p.location,this.g,{shortName:p.shortName,icon:p.icon,useDefaultFlags:p.useDefaultFlags},t))}}catch(p){this.y.error(p)}const o=new l.$zc,v=new Map;if(r.length)try{const p=this.Q();if(p.workspaces)for(const[h,g]of Object.entries(p.workspaces)){const D=O.URI.parse(h),T=r.find(M=>M.id===g);T&&o.set(D,T)}if(p.emptyWindows)for(const[h,g]of Object.entries(p.emptyWindows)){const D=r.find(T=>T.id===g);D&&v.set(h,D)}}catch(p){this.y.error(p)}this.z={profiles:r,workspaces:o,emptyWindows:v}}return this.z}D(){const t=s("__default__profile__",(0,R.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...t,extensionsResource:this.S()??t.extensionsResource,isDefault:!0}}async createTransientProfile(t){const r="Temp",o=new RegExp(`${(0,c.$Ge)(r)}\\s(\\d+)`);let v=0;for(const h of this.profiles){const g=o.exec(h.name),D=g?parseInt(g[1]):0;v=D>v?D:v}const p=`${r} ${v+1}`;return this.createProfile((0,I.$Hi)((0,w.$fg)()).toString(16),p,{transient:!0},t)}async createNamedProfile(t,r,o){return this.createProfile((0,I.$Hi)((0,w.$fg)()).toString(16),t,r,o)}async createProfile(t,r,o,v){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const p=await this.F(t,r,o);return v&&await this.setProfileForWorkspace(v,p),p}async F(t,r,o){if(!(0,u.$zf)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let v=this.r.get(r);return v||(v=(async()=>{try{const p=this.profiles.find(D=>D.name===r||D.id===t);if(p)return p;const h=s(t,r,(0,L.$wg)(this.profilesHome,t),this.g,o,this.defaultProfile);await this.u.createFolder(h.location);const g=[];return this.j.fire({profile:h,join(D){g.push(D)}}),await y.Promises.settled(g),this.I([h],[],[]),h}finally{this.r.delete(r)}})(),this.r.set(r,v)),v}async updateProfile(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let o=this.profiles.find(v=>v.id===t.id);if(!o)throw new Error(`Profile '${t.name}' does not exist`);return o=s(o.id,r.name??o.name,o.location,this.g,{shortName:r.shortName??o.shortName,icon:r.icon===null?void 0:r.icon??o.icon,transient:r.transient??o.isTransient,useDefaultFlags:r.useDefaultFlags??o.useDefaultFlags},this.defaultProfile),this.I([],[],[o]),o}async removeProfile(t){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(t.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(v=>v.id===t.id);if(!r)throw new Error(`Profile '${t.name}' does not exist`);const o=[];this.m.fire({profile:r,join(v){o.push(v)}});try{await Promise.allSettled(o)}catch(v){this.y.error(v)}for(const v of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(v)?.id&&this.C.emptyWindows.delete(v);for(const v of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(v)?.id&&this.C.workspaces.delete(v);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(v){(0,d.$tk)(v)!==1&&this.y.error(v)}}async setProfileForWorkspace(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const o=this.profiles.find(v=>v.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);this.L(t,o)}unsetWorkspace(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(t,void 0,r)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const t=await this.u.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(r=>r.isDirectory&&this.profiles.every(o=>!this.w.extUri.isEqual(o.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const t=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(t.map(r=>this.removeProfile(r)))}getProfileForWorkspace(t){const r=this.G(t);return O.URI.isUri(r)?this.s.workspaces.get(r)??this.C.workspaces.get(r):this.s.emptyWindows.get(r)??this.C.emptyWindows.get(r)}G(t){return(0,b.$4h)(t)?t.uri:(0,b.$9h)(t)?t.configPath:t.id}H(t){return!!([...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,t.location)))}I(t,r,o){const v=[...this.profiles,...t],p=[];this.s.profiles=[];for(let h of v)h.isDefault||r.some(g=>h.id===g.id)||(h=o.find(g=>h.id===g.id)??h,h.isTransient?this.s.profiles.push(h):p.push({location:h.location,name:h.name,shortName:h.shortName,icon:h.icon,useDefaultFlags:h.useDefaultFlags}));this.P(p),this.z=void 0,this.J(t,r,o)}J(t,r,o){this.h.fire({added:t,removed:r,updated:o,all:this.profiles})}L(t,r,o){o=r?.isTransient?!0:o,o||this.L(t,void 0,!0);const v=this.G(t),p=o?this.s:this.C;O.URI.isUri(v)?(p.workspaces.delete(v),r&&p.workspaces.set(v,r)):(p.emptyWindows.delete(v),r&&p.emptyWindows.set(v,r)),o||this.M()}M(){const t={};for(const[o,v]of this.C.workspaces.entries())t[o.toString()]=v.id;const r={};for(const[o,v]of this.C.emptyWindows.entries())r[o.toString()]=v.id;this.R({workspaces:t,emptyWindows:r}),this.z=void 0}N(t){const r={},o=this.D();if(t.workspaces)for(const[p,h]of Object.entries(t.workspaces)){const g=O.URI.parse(h);r[p]=this.w.extUri.isEqual(g,o.location)?o.id:this.w.extUri.basename(g)}const v={};if(t.emptyWindows)for(const[p,h]of Object.entries(t.emptyWindows)){const g=O.URI.parse(h);v[p]=this.w.extUri.isEqual(g,o.location)?o.id:this.w.extUri.basename(g)}return{workspaces:r,emptyWindows:v}}O(){return[]}P(t){throw new Error("not implemented")}Q(){return{}}R(t){throw new Error("not implemented")}S(){}};e.$Rk=a,e.$Rk=a=pe([X(0,S.$1h),X(1,d.$ck),X(2,$.$Mk),X(3,E.$bj)],a);class n extends a{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(t){this.a=t}Q(){return this.X}R(t){this.X=t}}e.$Sk=n}),define(ae[241],ce([0,1,6,2,17]),function(ie,e,I,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W9b=void 0;let L=class extends N.$Rc{constructor(R){super(),this.B(new I.$8g(()=>{R.cleanUp()},10*1e3)).schedule()}};e.$W9b=L,e.$W9b=L=pe([X(0,j.$Ok)],L)}),define(ae[242],ce([0,1,18,6,26,7,3,2,5,12,10,151,29,33,44,8,25,22,28,17]),function(ie,e,I,N,j,L,O,R,S,d,P,E,b,l,$,y,w,c,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wp=e.$vp=e.$up=e.$tp=void 0;let m=class extends R.$Rc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(t,r,o,v,p,h){super(),this.z=t,this.C=r,this.D=o,this.F=v,this.G=p,this.H=h,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new O.$Od),this.s=this.B(new O.$Od),this.t=this.B(new O.$Od),this.u=this.B(new O.$Od),this.w=this.B(new O.$Od),this.y=[],this.B((0,R.$Pc)(()=>{this.j.forEach(({task:g})=>g.cancel()),this.m.forEach(g=>g.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(t){const r=await this.getTargetPlatform();return t.allTargetPlatforms.some(o=>(0,b.$_n)(o,t.allTargetPlatforms,r))}async installFromGallery(t,r={}){try{const v=(await this.installGalleryExtensions([{extension:t,options:r}])).find(({identifier:p})=>(0,l.$Do)(p,t.identifier));if(v?.local)return v?.local;throw v?.error?v.error:s(new Error(`Unknown error while installing extension ${t.identifier.id}`))}catch(o){throw s(o)}}async installGalleryExtensions(t){if(!this.z.isEnabled())throw new b.$co(E.localize(0,null),b.ExtensionManagementErrorCode.Internal);const r=[],o=[];await Promise.allSettled(t.map(async({extension:v,options:p})=>{try{const h=await this.O(v,!!p?.installGivenVersion,!!p?.installPreReleaseVersion);o.push({...h,options:p})}catch(h){r.push({identifier:v.identifier,operation:2,source:v,error:h})}})),o.length&&r.push(...await this.I(o));for(const v of r)v.error&&(this.F.error("Failed to install extension.",v.identifier.id),this.F.error(v.error),v.source&&!P.URI.isUri(v.source)&&a(this.C,"extensionGallery:install",{extensionData:(0,l.$Lo)(v.source),error:v.error}));return r}async uninstall(t,r={}){return this.F.trace("ExtensionManagementService#uninstall",t.identifier.id),this.Q(t,r)}async toggleAppliationScope(t,r){if((0,$.$am)(t.manifest)||t.isBuiltin)return t;if(t.isApplicationScoped){let o=await this.updateMetadata(t,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)||(o=await this.ab(t,this.H.defaultProfile.extensionsResource,r));for(const v of this.H.profiles){const p=(await this.getInstalled(1,v.extensionsResource)).find(h=>(0,l.$Do)(h.identifier,t.identifier));p?this.w.fire(p):this.u.fire({identifier:t.identifier,profileLocation:v.extensionsResource})}return o}else{const o=this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(t,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.ab(t,r,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:o.identifier,operation:2,local:o,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),o}}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.g||t-this.h>1e3*60*5)&&(this.g=this.X(),this.h=t),this.g}registerParticipant(t){this.y.push(t)}async I(t){const r=[];return await Promise.allSettled(t.map(async o=>{try{const v=await this.J(o,(p,h)=>t.some(g=>(0,l.$Ho)(h.identifier.id)===(0,l.$Io)(g.manifest.publisher,g.manifest.name))?!1:this.L(p,h));r.push(...v)}catch(v){r.push({identifier:{id:(0,l.$Io)(o.manifest.publisher,o.manifest.name)},operation:2,source:o.extension,error:v})}})),this.s.fire(r),r}async J({manifest:t,extension:r,options:o},v){const p=o.isApplicationScoped||o.isBuiltin||(0,$.$am)(t),h={...o,installOnlyNewlyAddedFromExtensionPack:P.URI.isUri(r)?o.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:p,profileLocation:p?this.H.defaultProfile.extensionsResource:o.profileLocation??this.Y()},g=Z=>`${l.$Eo.create(Z).toString()}${h.profileLocation?`-${h.profileLocation.toString()}`:""}`;if(!P.URI.isUri(r)){const Z=this.j.get(g(r));if(Z)return this.F.info("Extensions is already requested to install",r.identifier.id),await Z.task.waitUntilTaskIsFinished(),[]}const D=[],T=[],M=[],z=this.Z(t,r,h);P.URI.isUri(r)||this.j.set(g(r),{task:z,waitingTasks:[]}),this.n.fire({identifier:z.identifier,source:r,profileLocation:h.profileLocation}),this.F.info("Installing extension:",z.identifier.id),D.push({task:z,manifest:t});let B=!1;try{if(h.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",z.identifier.id);else try{const K=await this.N(z.identifier,t,!!h.installOnlyNewlyAddedFromExtensionPack,!!h.installPreReleaseVersion,h.profileLocation),x=await this.getInstalled(void 0,h.profileLocation),H={...h,donotIncludePackAndDependencies:!0,context:{...h.context,[b.$7n]:!0}};for(const{gallery:Y,manifest:G}of(0,I.$Lb)(K,({gallery:V})=>V.identifier.id)){B=B||!!G.extensionDependencies?.some(ne=>(0,l.$Do)({id:ne},z.identifier));const V=g(Y),ee=this.j.get(V);if(ee){if(v(z,ee.task)){const ne=ee.task.identifier;this.F.info("Waiting for already requested installing extension",ne.id,z.identifier.id),ee.waitingTasks.push(z),T.push(O.Event.toPromise(O.Event.filter(this.onDidInstallExtensions,_=>_.some(re=>(0,l.$Do)(re.identifier,ne)))).then(_=>{if(this.F.info("Finished waiting for already requested installing extension",ne.id,z.identifier.id),!_.find(Q=>(0,l.$Do)(Q.identifier,ne))?.local)throw new Error(`Extension ${ne.id} is not installed`)}))}}else if(!x.some(({identifier:ne})=>(0,l.$Do)(ne,Y.identifier))){const ne=this.Z(G,Y,H);this.j.set(V,{task:ne,waitingTasks:[z]}),this.n.fire({identifier:ne.identifier,source:Y,profileLocation:h.profileLocation}),this.F.info("Installing extension:",ne.identifier.id,z.identifier.id),D.push({task:ne,manifest:G})}}}catch(K){if(P.URI.isUri(z.source))(0,I.$Kb)(t.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",z.identifier.id,K.message),(0,I.$Kb)(t.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",z.identifier.id,K.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",z.identifier.id),K}const Z=D.reduce((K,{task:x,manifest:H})=>(K.set(x.identifier.id.toLowerCase(),{task:x,manifest:H}),K),new Map);for(;Z.size;){let K;const x=[...Z.values()].filter(({manifest:H})=>!H.extensionDependencies?.some(Y=>Z.has(Y.toLowerCase())));x.length?K=Z.size===1?x:x.filter(({task:H})=>!(H===z&&!B)):(this.F.info("Found extensions with circular dependencies",x.map(({task:H})=>H.identifier.id)),K=[...Z.values()]),await this.M(K.map(async({task:H})=>{const Y=new Date().getTime();try{const G=await H.run();if(await this.M(this.y.map(V=>V.postInstall(G,H.source,h,j.CancellationToken.None))),!P.URI.isUri(H.source)){const V=H.operation===3,ee=V?void 0:(new Date().getTime()-H.source.lastUpdated)/1e3;if(a(this.C,V?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,l.$Lo)(H.source),verificationStatus:H.verificationStatus,duration:new Date().getTime()-Y,durationSinceUpdate:ee}),S.$p&&H.operation!==3)try{await this.z.reportStatistic(G.manifest.publisher,G.manifest.name,G.manifest.version,"install")}catch{}}M.push({local:G,identifier:H.identifier,operation:H.operation,source:H.source,context:H.options.context,profileLocation:H.profileLocation,applicationScoped:G.isApplicationScoped})}catch(G){throw P.URI.isUri(H.source)||a(this.C,H.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,l.$Lo)(H.source),verificationStatus:H.verificationStatus,duration:new Date().getTime()-Y,error:G}),this.F.error("Error while installing the extension:",H.identifier.id),G}finally{Z.delete(H.identifier.id.toLowerCase())}}))}return T.length&&await this.M(T),M.forEach(({identifier:K})=>this.F.info("Extension installed successfully:",K.id)),M}catch(Z){if(D.forEach(({task:K})=>K.cancel()),M.length)try{const K=await Promise.allSettled(M.map(({local:x})=>this.$(x,{versionOnly:!0,profileLocation:h.profileLocation}).run()));for(let x=0;x<K.length;x++){const H=K[x],{identifier:Y}=M[x];H.status==="fulfilled"?this.F.info("Rollback: Uninstalled extension",Y.id):this.F.warn("Rollback: Error while uninstalling extension",Y.id,(0,L.$9)(H.reason))}}catch(K){this.F.warn("Error while rolling back extensions",(0,L.$9)(K),M.map(({identifier:x})=>x.id))}return D.map(({task:K})=>({identifier:K.identifier,operation:2,source:K.source,context:h.context,profileLocation:h.profileLocation,error:Z}))}finally{for(const{task:Z}of D)Z.source&&!P.URI.isUri(Z.source)&&this.j.delete(g(Z.source))}}L(t,r){for(const[,{task:o,waitingTasks:v}]of this.j.entries())if(o===t&&(v.includes(r)||v.some(p=>this.L(p,r)))||o===r&&v[0]&&!this.L(t,v[0]))return!1;return!0}async M(t){const r=[],o=[],v=await Promise.allSettled(t);for(const p of v)p.status==="fulfilled"?r.push(p.value):o.push(p.reason);if(o.length)throw k(o);return r}async N(t,r,o,v,p){if(!this.z.isEnabled())return[];const h=await this.getInstalled(void 0,p),g=[],D=[],T=async(M,z)=>{g.push(M);const B=z.extensionDependencies||[],Z=[...B];if(z.extensionPack){const K=o?h.find(x=>(0,l.$Do)(x.identifier,M)):void 0;for(const x of z.extensionPack)K&&K.manifest.extensionPack&&K.manifest.extensionPack.some(H=>(0,l.$Do)({id:H},{id:x}))||Z.every(H=>!(0,l.$Do)({id:H},{id:x}))&&Z.push(x)}if(Z.length){const K=Z.filter(x=>g.every(H=>!(0,l.$Do)(H,{id:x})));if(K.length){const x=await this.z.getExtensions(K.map(H=>({id:H,preRelease:v})),j.CancellationToken.None);for(const H of x){if(g.find(V=>(0,l.$Do)(V,H.identifier)))continue;const Y=B.some(V=>(0,l.$Do)({id:V},H.identifier));let G;try{G=await this.O(H,!1,v)}catch(V){if(Y)throw V;this.F.info("Skipping the packed extension as it cannot be installed",H.identifier.id,(0,L.$9)(V));continue}D.push({gallery:G.extension,manifest:G.manifest}),await T(G.extension.identifier,G.manifest)}}}};return await T(t,r),D}async O(t,r,o){let v;const p=await this.getExtensionsControlManifest();if(p.malicious.some(D=>(0,l.$Do)(t.identifier,D)))throw new b.$co(E.localize(1,null,t.identifier.id),b.ExtensionManagementErrorCode.Malicious);const h=p.deprecated[t.identifier.id.toLowerCase()];if(h?.extension?.autoMigrate){if(this.F.info(`The '${t.identifier.id}' extension is deprecated, fetching the compatible '${h.extension.id}' extension instead.`),v=(await this.z.getExtensions([{id:h.extension.id,preRelease:h.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},j.CancellationToken.None))[0],!v)throw new b.$co(E.localize(2,null,t.identifier.id,h.extension.id),b.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(t)){const D=await this.getTargetPlatform();throw new b.$co(E.localize(3,null,t.identifier.id,this.G.nameLong,(0,b.$8n)(D)),b.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(v=await this.P(t,r,o),!v)throw!o&&t.properties.isPreReleaseVersion&&(await this.z.getExtensions([t.identifier],j.CancellationToken.None))[0]?new b.$co(E.localize(4,null,t.identifier.id),b.ExtensionManagementErrorCode.ReleaseVersionNotFound):new b.$co(E.localize(5,null,t.identifier.id,this.G.nameLong,this.G.version),b.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",v.identifier.id);const g=await this.z.getManifest(v,j.CancellationToken.None);if(g===null)throw new b.$co(`Missing manifest for extension ${v.identifier.id}`,b.ExtensionManagementErrorCode.Invalid);if(g.version!==v.version)throw new b.$co(`Cannot install '${v.identifier.id}' extension because of version mismatch in Marketplace`,b.ExtensionManagementErrorCode.Invalid);return{extension:v,manifest:g}}async P(t,r,o){const v=await this.getTargetPlatform();let p=null;return!r&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==o&&(p=(await this.z.getExtensions([{...t.identifier,preRelease:o}],{targetPlatform:v,compatible:!0},j.CancellationToken.None))[0]||null),!p&&await this.z.isExtensionCompatible(t,o,v)&&(p=t),p||(r?p=(await this.z.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:v,compatible:!0},j.CancellationToken.None))[0]||null:p=await this.z.getCompatibleExtension(t,o,v)),p}async Q(t,r){const o={...r,profileLocation:t.isApplicationScoped?this.H.defaultProfile.extensionsResource:r.profileLocation??this.Y()},v=M=>`${M.id.toLowerCase()}${o.versionOnly?`-${t.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,p=this.m.get(v(t.identifier));if(p)return this.F.info("Extensions is already requested to uninstall",t.identifier.id),p.waitUntilTaskIsFinished();const h=M=>{const z=this.$(M,o);return this.m.set(v(z.extension.identifier),z),o.profileLocation?this.F.info("Uninstalling extension from the profile:",`${M.identifier.id}@${M.manifest.version}`,o.profileLocation.toString()):this.F.info("Uninstalling extension:",`${M.identifier.id}@${M.manifest.version}`),this.t.fire({identifier:M.identifier,profileLocation:o.profileLocation,applicationScoped:M.isApplicationScoped}),z},g=(M,z)=>{z?o.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${M.identifier.id}@${M.manifest.version}`,o.profileLocation.toString(),z.message):this.F.error("Failed to uninstall extension:",`${M.identifier.id}@${M.manifest.version}`,z.message):o.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${M.identifier.id}@${M.manifest.version}`,o.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${M.identifier.id}@${M.manifest.version}`),a(this.C,"extensionGallery:uninstall",{extensionData:(0,l.$Ko)(M),error:z}),this.u.fire({identifier:M.identifier,error:z?.code,profileLocation:o.profileLocation,applicationScoped:M.isApplicationScoped})},D=[],T=[];try{D.push(h(t));const M=await this.getInstalled(1,o.profileLocation);if(o.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const z=this.U(t,M);for(const B of z)this.m.has(v(B.identifier))?this.F.info("Extensions is already requested to uninstall",B.identifier.id):D.push(h(B))}o.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.R(D.map(z=>z.extension),M,t),await this.M(D.map(async z=>{try{if(await z.run(),await this.M(this.y.map(B=>B.postUninstall(z.extension,o,j.CancellationToken.None))),z.extension.identifier.uuid)try{await this.z.reportStatistic(z.extension.manifest.publisher,z.extension.manifest.name,z.extension.manifest.version,"uninstall")}catch{}g(z.extension)}catch(B){const Z=B instanceof b.$co?B:new b.$co((0,L.$9)(B),b.ExtensionManagementErrorCode.Internal);throw g(z.extension,Z),Z}finally{T.push(z)}}))}catch(M){const z=M instanceof b.$co?M:new b.$co((0,L.$9)(M),b.ExtensionManagementErrorCode.Internal);for(const B of D){try{B.cancel()}catch{}T.includes(B)||g(B.extension,z)}throw z}finally{for(const M of D)this.m.delete(v(M.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",M.extension.identifier.id)}}R(t,r,o){for(const v of t){const p=this.W(v,r);if(p.length){const h=p.filter(g=>!t.some(D=>(0,l.$Do)(D.identifier,g.identifier)));if(h.length)throw new Error(this.S(v,h,o))}}}S(t,r,o){return o===t?r.length===1?E.localize(6,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?E.localize(7,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):E.localize(8,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?E.localize(9,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?E.localize(10,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):E.localize(11,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}U(t,r,o=[]){if(o.indexOf(t)!==-1)return[];o.push(t);const v=t.manifest.extensionPack?t.manifest.extensionPack:[];if(v.length){const p=r.filter(g=>!g.isBuiltin&&v.some(D=>(0,l.$Do)({id:D},g.identifier))),h=[];for(const g of p)h.push(...this.U(g,r,o));return[...p,...h]}return[]}W(t,r){return r.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(v=>(0,l.$Do)({id:v},t.identifier)))}async X(){try{this.F.trace("ExtensionManagementService.refreshReportedCache");const t=await this.z.getExtensionsControlManifest();return this.F.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$tp=m,e.$tp=m=pe([X(0,b.$bo),X(1,c.$gl),X(2,u.$Mk),X(3,y.$bj),X(4,w.$tj),X(5,f.$Ok)],m);function k(i){const t=Array.isArray(i)?i:[i];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((r,o)=>new Error(`${r.message}${r.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}e.$up=k;function s(i){if(i instanceof b.$co)return i;const t=new b.$co(i.message,b.ExtensionManagementErrorCode.Internal);return t.stack=i.stack,t}e.$vp=s;function a(i,t,{extensionData:r,verificationStatus:o,duration:v,error:p,durationSinceUpdate:h}){let g,D;(0,d.$Hf)(o)&&(o===!0?o="Verified":(o===!1||(g=b.ExtensionManagementErrorCode.Signature,D=o),o="Unverified")),p&&(p instanceof b.$co?(g=p.code,p.code===b.ExtensionManagementErrorCode.Signature&&(D=p.message)):g=b.ExtensionManagementErrorCode.Internal),i.publicLog(t,{...r,verificationStatus:o,success:!p,duration:v,errorcode:g,errorcodeDetail:D,durationSinceUpdate:h})}class n{constructor(){this.d=new N.$Tg}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,N.$Ig)(t=>this.h(t))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,N.$Ig)(t=>new Promise((r,o)=>{const v=t.onCancellationRequested(()=>{v.dispose(),o(new L.$4)})})),this.d.open()),this.g.cancel()}}e.$wp=n}),define(ae[51],ce([0,1,6,15,2,3,34,10,29,33,11,4,8,17,28,12,7,22]),function(ie,e,I,N,j,L,O,R,S,d,P,E,b,l,$,y,w,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=e.$yp=e.$xp=e.ExtensionsProfileScanningErrorCode=void 0;var u;(function(a){a.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",a.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(u||(e.ExtensionsProfileScanningErrorCode=u={}));class f extends Error{constructor(n,i){super(n),this.code=i}}e.$xp=f,e.$yp=(0,E.$Th)("IExtensionsProfileScannerService");let m=class extends j.$Rc{constructor(n,i,t,r,o,v){super(),this.j=n,this.m=i,this.n=t,this.r=r,this.s=o,this.t=v,this.b=this.B(new L.$Od),this.onAddExtensions=this.b.event,this.c=this.B(new L.$Od),this.onDidAddExtensions=this.c.event,this.f=this.B(new L.$Od),this.onRemoveExtensions=this.f.event,this.g=this.B(new L.$Od),this.onDidRemoveExtensions=this.g.event,this.h=new O.$zc}scanProfileExtensions(n,i){return this.u(n,void 0,i)}async addExtensionsToProfile(n,i){const t=[],r=[];try{return await this.u(i,o=>{const v=[];for(const p of o)n.some(([h])=>(0,d.$Do)(h.identifier,p.identifier)&&h.manifest.version!==p.version)?t.push(p):v.push(p);for(const[p,h]of n){const g=v.findIndex(T=>(0,d.$Do)(T.identifier,p.identifier)&&T.version===p.manifest.version),D={identifier:p.identifier,version:p.manifest.version,location:p.location,metadata:h};g===-1?(r.push(D),v.push(D)):v.splice(g,1,D)}return r.length&&this.b.fire({extensions:r,profileLocation:i}),t.length&&this.f.fire({extensions:t,profileLocation:i}),v}),r.length&&this.c.fire({extensions:r,profileLocation:i}),t.length&&this.g.fire({extensions:t,profileLocation:i}),r}catch(o){throw r.length&&this.c.fire({extensions:r,error:o,profileLocation:i}),t.length&&this.g.fire({extensions:t,error:o,profileLocation:i}),o}}async updateMetadata(n,i){const t=[];return await this.u(i,r=>{const o=[];for(const v of r){const p=n.find(([h])=>(0,d.$Do)(h.identifier,v.identifier)&&h.manifest.version===v.version);p&&(v.metadata={...v.metadata,...p[1]},t.push(v)),o.push(v)}return o}),t}async removeExtensionFromProfile(n,i){const t=[];try{await this.u(i,r=>{const o=[];for(const v of r)(0,d.$Do)(v.identifier,n.identifier)?t.push(v):o.push(v);return t.length&&this.f.fire({extensions:t,profileLocation:i}),o}),t.length&&this.g.fire({extensions:t,profileLocation:i})}catch(r){throw t.length&&this.g.fire({extensions:t,error:r,profileLocation:i}),r}}async u(n,i,t){return this.F(n).queue(async()=>{let r=[],o;try{const v=await this.m.readFile(n);o=JSON.parse(v.value.toString().trim()||"[]")}catch(v){if((0,P.$tk)(v)!==1)throw v;if(this.r.extUri.isEqual(n,this.n.defaultProfile.extensionsResource)&&(o=await this.D()),!o&&t?.bailOutWhenFileNotFound)throw new f((0,w.$9)(v),"ERROR_PROFILE_NOT_FOUND")}if(o){Array.isArray(o)||this.w(n);let v=!1;for(const p of o){k(p)||this.w(n);let h;if((0,y.$zf)(p.relativeLocation)&&p.relativeLocation)h=this.z(p.relativeLocation);else if((0,y.$zf)(p.location))h=this.z(p.location),v=!0,p.relativeLocation=p.location,p.location=h.toJSON();else{h=R.URI.revive(p.location);const g=this.y(h);g&&(v=!0,p.relativeLocation=g)}r.push({identifier:p.identifier,location:h,version:p.version,metadata:p.metadata})}v&&await this.m.writeFile(n,N.$ce.fromString(JSON.stringify(o)))}if(i){r=i(r);const v=r.map(p=>({identifier:p.identifier,version:p.version,location:p.location.toJSON(),relativeLocation:this.y(p.location),metadata:p.metadata}));await this.m.writeFile(n,N.$ce.fromString(JSON.stringify(v)))}return r})}w(n){const i=new f(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(n){return this.r.extUri.isEqual(this.r.extUri.dirname(n),this.j)?this.r.extUri.basename(n):void 0}z(n){return this.r.extUri.joinPath(this.j,n)}async D(){return this.C||(this.C=(async()=>{const n=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let t;try{t=(await this.m.readFile(n)).value.toString()}catch(o){if((0,P.$tk)(o)===1)return;throw o}this.t.info("Migrating extensions from old default profile location",n.toString());let r;try{const o=JSON.parse(t);Array.isArray(o)&&o.every(v=>k(v))?r=o:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",o)}catch(o){this.t.error(o)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,N.$ce.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",n.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(o){if((0,P.$tk)(o)===3)this.t.info("Migration from old default profile location to new location is done by another window",n.toString(),this.n.defaultProfile.extensionsResource.toString());else throw o}try{await this.m.del(n)}catch(o){(0,P.$tk)(o)!==1&&this.t.error(o)}try{await this.m.del(i)}catch(o){(0,P.$tk)(o)!==1&&this.t.error(o)}return r})()),this.C}F(n){let i=this.h.get(n);return i||(i=new I.$3g,this.h.set(n,i)),i}};e.$zp=m,e.$zp=m=pe([X(1,P.$ck),X(2,l.$Ok),X(3,$.$Mk),X(4,c.$gl),X(5,b.$bj)],m);function k(a){return(0,y.$Bf)(a)&&(0,S.$ao)(a.identifier)&&(s(a.location)||(0,y.$zf)(a.location)&&a.location)&&((0,y.$Gf)(a.relativeLocation)||(0,y.$zf)(a.relativeLocation))&&a.version&&(0,y.$zf)(a.version)}function s(a){return a?(0,y.$zf)(a.path)&&(0,y.$zf)(a.scheme):!1}}),define(ae[80],ce([0,1,18,6,30,15,7,35,137,2,23,16,5,19,54,89,12,10,154,14,33,44,69,11,4,8,25,3,65,51,17,28,182]),function(ie,e,I,N,j,L,O,R,S,d,P,E,b,l,$,y,w,c,u,f,m,k,s,a,n,i,t,r,o,v,p,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gp=e.$Fp=e.$Ep=e.$Dp=e.$Cp=e.Translations=void 0;var D;(function(x){function H(Y,G){if(Y===G)return!0;const V=Object.keys(Y),ee=new Set;for(const ne of Object.keys(G))ee.add(ne);if(V.length!==ee.size)return!1;for(const ne of V){if(Y[ne]!==G[ne])return!1;ee.delete(ne)}return ee.size===0}x.equals=H})(D||(e.Translations=D={})),e.$Cp=(0,n.$Th)("IExtensionsScannerService");let T=class extends d.$Rc{constructor(H,Y,G,V,ee,ne,_,re,Q,q,C,A){super(),this.systemExtensionsLocation=H,this.userExtensionsLocation=Y,this.r=G,this.s=V,this.t=ee,this.u=ne,this.w=_,this.y=re,this.z=Q,this.C=q,this.D=C,this.F=A,this.g=this.B(new r.$Od),this.onDidChangeCache=this.g.event,this.h=(0,l.$wg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(B,this.s,this.h)),this.m=this.B(this.F.createInstance(B,this.s,this.h)),this.n=this.B(this.F.createInstance(z,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,m.$Oo)(this.w,this.y)),this.G}async scanAllExtensions(H,Y,G){const[V,ee]=await Promise.all([this.scanSystemExtensions(H),this.scanUserExtensions(Y)]),ne=G?await this.scanExtensionsUnderDevelopment(H,[...V,...ee]):[];return this.L(V,ee,ne,await this.getTargetPlatform(),!0)}async scanSystemExtensions(H){const Y=[];Y.push(this.M(!!H.useCache,H.language)),Y.push(this.N(H.language,!!H.checkControlFile));const[G,V]=await Promise.all(Y);return this.J([...G,...V],0,H,!1)}async scanUserExtensions(H){const Y=H.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",Y);const G=this.D.extUri.isEqual(H.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,V=await this.P(Y,!!H.profileLocation,1,!H.includeUninstalled,H.language,!0,G),ee=H.useCache&&!V.devMode&&V.excludeObsolete?this.m:this.n;let ne;try{ne=await ee.scanExtensions(V)}catch(_){if(_ instanceof v.$xp&&_.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),ne=await ee.scanExtensions(V);else throw _}return ne=await this.J(ne,1,H,!0),this.y.trace("Scanned user extensions:",ne.length),ne}async scanExtensionsUnderDevelopment(H,Y){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const G=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(V=>V.scheme===P.Schemas.file).map(async V=>{const ee=await this.P(V,!1,1,!0,H.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(ee)).map(_=>(_.type=Y.find(re=>(0,m.$Do)(re.identifier,_.identifier))?.type??_.type,this.n.validate(_,ee)))}))).flat();return this.J(G,"development",H,!0)}return[]}async scanExistingExtension(H,Y,G){const V=await this.P(H,!1,Y,!0,G.language,!0,void 0),ee=await this.n.scanExtension(V);return!ee||!G.includeInvalid&&!ee.isValid?null:ee}async scanOneOrMultipleExtensions(H,Y,G){const V=await this.P(H,!1,Y,!0,G.language,!0,void 0),ee=await this.n.scanOneOrMultipleExtensions(V);return this.J(ee,Y,G,!0)}async scanMetadata(H){const Y=(0,l.$wg)(H,"package.json"),G=(await this.w.readFile(Y)).value.toString();return JSON.parse(G).__metadata}async updateMetadata(H,Y){const G=(0,l.$wg)(H,"package.json"),V=(await this.w.readFile(G)).value.toString(),ee=JSON.parse(V);Y.isMachineScoped===!1&&delete Y.isMachineScoped,Y.isBuiltin===!1&&delete Y.isBuiltin,ee.__metadata={...ee.__metadata,...Y},await this.w.writeFile((0,l.$wg)(H,"package.json"),L.$ce.fromString(JSON.stringify(ee,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(H){if(H instanceof v.$xp&&H.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw H}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const H=await this.scanUserExtensions({includeInvalid:!0});if(H.length)await this.u.addExtensionsToProfile(H.map(Y=>[Y,Y.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,L.$ce.fromString(JSON.stringify([])))}catch(Y){(0,a.$tk)(Y)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,O.$9)(Y))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(H){this.y.error(H)}finally{this.H=void 0}})()),this.H}async J(H,Y,G,V){return G.includeAllVersions||(H=this.L(Y===0?H:void 0,Y===1?H:void 0,Y==="development"?H:void 0,await this.getTargetPlatform(),V)),G.includeInvalid||(H=H.filter(ee=>ee.isValid)),H.sort((ee,ne)=>{const _=E.$mc(ee.location.fsPath),re=E.$mc(ne.location.fsPath);return _<re?-1:_>re?1:0})}L(H,Y,G,V,ee){const ne=(re,Q,q)=>{if(re.isValid&&!Q.isValid)return!1;if(re.isValid===Q.isValid){if(ee&&$.gt(re.manifest.version,Q.manifest.version))return this.y.debug(`Skipping extension ${Q.location.path} with lower version ${Q.manifest.version} in favour of ${re.location.path} with version ${re.manifest.version}`),!1;if($.eq(re.manifest.version,Q.manifest.version)){if(re.type===0)return this.y.debug(`Skipping extension ${Q.location.path} in favour of system extension ${re.location.path} with same version`),!1;if(re.targetPlatform===V)return this.y.debug(`Skipping extension ${Q.location.path} from different target platform ${Q.targetPlatform}`),!1}}return q?this.y.warn(`Overwriting user extension ${re.location.path} with ${Q.location.path}.`):this.y.debug(`Overwriting user extension ${re.location.path} with ${Q.location.path}.`),!0},_=new k.$_l;return H?.forEach(re=>{const Q=_.get(re.identifier.id);(!Q||ne(Q,re,!1))&&_.set(re.identifier.id,re)}),Y?.forEach(re=>{const Q=_.get(re.identifier.id);if(!Q&&H&&re.type===0){this.y.debug(`Skipping obsolete system extension ${re.location.path}.`);return}(!Q||ne(Q,re,!1))&&_.set(re.identifier.id,re)}),G?.forEach(re=>{const Q=_.get(re.identifier.id);(!Q||ne(Q,re,!0))&&_.set(re.identifier.id,re),_.set(re.identifier.id,re)}),[..._.values()]}async M(H,Y){this.y.trace("Started scanning system extensions");const G=await this.P(this.systemExtensionsLocation,!1,0,!0,Y,!0,void 0),ee=await(H&&!G.devMode?this.j:this.n).scanExtensions(G);return this.y.trace("Scanned system extensions:",ee.length),ee}async N(H,Y){const G=this.z.isBuilt?[]:this.C.builtInExtensions;if(!G?.length)return[];this.y.trace("Started scanning dev system extensions");const V=Y?await this.O():{},ee=[],ne=c.URI.file(E.$gc(E.$ic(P.$dg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const re of G){const Q=V[re.name]||"marketplace";switch(Q){case"disabled":break;case"marketplace":ee.push((0,l.$wg)(ne,re.name));break;default:ee.push(c.URI.file(Q));break}}const _=await Promise.all(ee.map(async re=>this.n.scanExtension(await this.P(re,!1,0,!0,H,!0,void 0))));return this.y.trace("Scanned dev system extensions:",_.length),(0,I.$Gb)(_)}async O(){try{const H=await this.w.readFile(this.r);return JSON.parse(H.value.toString())}catch{return{}}}async P(H,Y,G,V,ee,ne,_){const re=await this.f(ee??b.$w),Q=await this.Q(H),q=Y&&!this.D.extUri.isEqual(H,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,C=q?await this.Q(q):void 0;return new M(H,Q,q,C,Y,_,G,V,ne,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,ee,re)}async Q(H){try{const Y=await this.w.stat(H);if(typeof Y.mtime=="number")return Y.mtime}catch{}}};e.$Dp=T,e.$Dp=T=pe([X(4,p.$Ok),X(5,v.$yp),X(6,a.$ck),X(7,i.$bj),X(8,f.$1h),X(9,t.$tj),X(10,h.$Mk),X(11,n.$Sh)],T);class M{constructor(H,Y,G,V,ee,ne,_,re,Q,q,C,A,J,F,U){this.location=H,this.mtime=Y,this.applicationExtensionslocation=G,this.applicationExtensionslocationMtime=V,this.profile=ee,this.profileScanOptions=ne,this.type=_,this.excludeObsolete=re,this.validate=Q,this.productVersion=q,this.productDate=C,this.productCommit=A,this.devMode=J,this.language=F,this.translations=U}static createNlsConfiguration(H){return{language:H.language,pseudo:H.language==="pseudo",devMode:H.devMode,translations:H.translations}}static equals(H,Y){return(0,l.$pg)(H.location,Y.location)&&H.mtime===Y.mtime&&(0,l.$pg)(H.applicationExtensionslocation,Y.applicationExtensionslocation)&&H.applicationExtensionslocationMtime===Y.applicationExtensionslocationMtime&&H.profile===Y.profile&&j.$cn(H.profileScanOptions,Y.profileScanOptions)&&H.type===Y.type&&H.excludeObsolete===Y.excludeObsolete&&H.validate===Y.validate&&H.productVersion===Y.productVersion&&H.productDate===Y.productDate&&H.productCommit===Y.productCommit&&H.devMode===Y.devMode&&H.language===Y.language&&D.equals(H.translations,Y.translations)}}e.$Ep=M;let z=class extends d.$Rc{constructor(H,Y,G,V,ee){super(),this.f=H,this.g=Y,this.h=G,this.j=V,this.m=ee}async scanExtensions(H){const Y=H.profile?await this.r(H):await this.n(H);let G={};if(H.excludeObsolete&&H.type===1)try{const V=(await this.j.readFile(this.f)).value.toString();G=JSON.parse(V)}catch{}return(0,w.$Mf)(G)?Y:Y.filter(V=>!G[m.$Eo.create(V).toString()])}async n(H){const Y=await this.j.resolve(H.location);if(!Y.children?.length)return[];const G=await Promise.all(Y.children.map(async V=>{if(!V.isDirectory||H.type===1&&(0,l.$tg)(V.resource).indexOf(".")===0)return null;const ee=new M(V.resource,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(ee)}));return(0,I.$Gb)(G).sort((V,ee)=>V.location.path<ee.location.path?-1:1)}async r(H){let Y=await this.s(H.location,()=>!0,H);if(H.applicationExtensionslocation&&!this.h.extUri.isEqual(H.location,H.applicationExtensionslocation)){Y=Y.filter(V=>!V.metadata?.isApplicationScoped);const G=await this.s(H.applicationExtensionslocation,V=>!!V.metadata?.isBuiltin||!!V.metadata?.isApplicationScoped,H);Y.push(...G)}return Y}async s(H,Y,G){const V=await this.g.scanProfileExtensions(H,G.profileScanOptions);if(!V.length)return[];const ee=await Promise.all(V.map(async ne=>{if(Y(ne)){const _=new M(ne.location,G.mtime,G.applicationExtensionslocation,G.applicationExtensionslocationMtime,G.profile,G.profileScanOptions,G.type,G.excludeObsolete,G.validate,G.productVersion,G.productDate,G.productCommit,G.devMode,G.language,G.translations);return this.scanExtension(_,ne.metadata)}return null}));return(0,I.$Gb)(ee)}async scanOneOrMultipleExtensions(H){try{if(await this.j.exists((0,l.$wg)(H.location,"package.json"))){const Y=await this.scanExtension(H);return Y?[Y]:[]}else return await this.scanExtensions(H)}catch(Y){return this.m.error(`Error scanning extensions at ${H.location.path}:`,(0,O.$9)(Y)),[]}}async scanExtension(H,Y){try{let G=await this.scanExtensionManifest(H.location);if(G){G.publisher||(G.publisher=k.$6l),Y=Y??G.__metadata,delete G.__metadata;const V=(0,m.$Io)(G.publisher,G.name),ee=Y?.id?{id:V,uuid:Y.id}:{id:V},ne=Y?.isSystem?0:H.type,_=ne===0||!!Y?.isBuiltin;G=await this.t(H.location,G,M.createNlsConfiguration(H));const re={type:ne,identifier:ee,manifest:G,location:H.location,isBuiltin:_,targetPlatform:Y?.targetPlatform??"undefined",metadata:Y,isValid:!0,validations:[]};return H.validate?this.validate(re,H):re}}catch(G){H.type!==0&&this.m.error(G)}return null}validate(H,Y){let G=!0;const V=(0,s.$To)(Y.productVersion,Y.productDate,Y.location,H.manifest,H.isBuiltin);for(const[ee,ne]of V)ee===y.default.Error&&(G=!1,this.m.error(this.z(Y.location,ne)));return H.isValid=G,H.validations=V,H}async scanExtensionManifest(H){const Y=(0,l.$wg)(H,"package.json");let G;try{G=(await this.j.readFile(Y)).value.toString()}catch(ee){return(0,a.$tk)(ee)!==1&&this.m.error(this.z(H,(0,u.localize)(0,null,Y.path,ee.message))),null}let V;try{V=JSON.parse(G)}catch{const ne=[];(0,R.$1m)(G,ne);for(const _ of ne)this.m.error(this.z(H,(0,u.localize)(1,null,Y.path,_.offset,_.length,(0,S.$Ap)(_.error))));return null}return(0,R.$0m)(V)!=="object"?(this.m.error(this.z(H,(0,u.localize)(2,null,Y.path))),null):V}async t(H,Y,G){const V=await this.u(H,Y,G);if(V)try{const ee=[],ne=await this.w(V.default,ee);if(ee.length>0)return ee.forEach(re=>{this.m.error(this.z(H,(0,u.localize)(3,null,V.default?.path,(0,S.$Ap)(re.error))))}),Y;if((0,R.$0m)(V)!=="object")return this.m.error(this.z(H,(0,u.localize)(4,null,V.default?.path))),Y;const _=V.values||Object.create(null);return(0,g.$Bp)(this.m,Y,_,ne)}catch{}return Y}async u(H,Y,G){const V=(0,l.$wg)(H,"package.nls.json"),ee=(Q,q)=>{q.forEach(C=>{this.m.error(this.z(H,(0,u.localize)(5,null,Q?.path,(0,S.$Ap)(C.error))))})},ne=Q=>{this.m.error(this.z(H,(0,u.localize)(6,null,Q?.path)))},_=`${Y.publisher}.${Y.name}`,re=G.translations[_];if(re)try{const Q=c.URI.file(re),q=(await this.j.readFile(Q)).value.toString(),C=[],A=(0,R.$1m)(q,C);return C.length>0?(ee(Q,C),{values:void 0,default:V}):(0,R.$0m)(A)!=="object"?(ne(Q),{values:void 0,default:V}):{values:A.contents?A.contents.package:void 0,default:V}}catch{return{values:void 0,default:V}}else{if(!await this.j.exists(V))return;let q;try{q=await this.y(H,G)}catch{return}if(!q.localized)return{values:void 0,default:q.original};try{const C=(await this.j.readFile(q.localized)).value.toString(),A=[],J=(0,R.$1m)(C,A);return A.length>0?(ee(q.localized,A),{values:void 0,default:q.original}):(0,R.$0m)(J)!=="object"?(ne(q.localized),{values:void 0,default:q.original}):{values:J,default:q.original}}catch{return{values:void 0,default:q.original}}}}async w(H,Y){if(H)try{const G=(await this.j.readFile(H)).value.toString();return(0,R.$1m)(G,Y)}catch{}}y(H,Y){return new Promise((G,V)=>{const ee=ne=>{const _=(0,l.$wg)(H,`package.nls.${ne}.json`);this.j.exists(_).then(re=>{re&&G({localized:_,original:(0,l.$wg)(H,"package.nls.json")});const Q=ne.lastIndexOf("-");Q===-1?G({localized:(0,l.$wg)(H,"package.nls.json"),original:null}):(ne=ne.substring(0,Q),ee(ne))})};if(Y.devMode||Y.pseudo||!Y.language)return G({localized:(0,l.$wg)(H,"package.nls.json"),original:null});ee(Y.language)})}z(H,Y){return`[${H.path}]: ${Y}`}};z=pe([X(1,v.$yp),X(2,h.$Mk),X(3,a.$ck),X(4,i.$bj)],z);let B=class extends z{constructor(H,Y,G,V,ee,ne,_){super(Y,V,ee,ne,_),this.G=H,this.H=G,this.D=this.B(new N.$Sg(3e3)),this.F=this.B(new r.$Od),this.onDidChangeCache=this.F.event}async scanExtensions(H){const Y=this.M(H),G=await this.I(Y);if(this.C=H,G&&G.input&&M.equals(G.input,this.C))return this.m.debug("Using cached extensions scan result",H.location.toString()),this.D.trigger(()=>this.L()),G.result.map(ee=>(ee.location=c.URI.revive(ee.location),ee));const V=await super.scanExtensions(H);return await this.J(Y,{input:H,result:V}),V}async I(H){try{const Y=await this.j.readFile(H),G=JSON.parse(Y.value.toString());return{result:G.result,input:(0,o.$qh)(G.input)}}catch(Y){this.m.debug("Error while reading the extension cache file:",H.path,(0,O.$9)(Y))}return null}async J(H,Y){try{await this.j.writeFile(H,L.$ce.fromString(JSON.stringify(Y)))}catch(G){this.m.debug("Error while writing the extension cache file:",H.path,(0,O.$9)(G))}}async L(){if(!this.C)return;const H=this.M(this.C),Y=await this.I(H);if(!Y)return;const G=Y.result,V=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!j.$cn(V,G))try{this.m.info("Invalidating Cache",G,V),await this.j.del(H),this.F.fire()}catch(ee){this.m.error(ee)}}M(H){const Y=this.N(H);return this.h.extUri.joinPath(Y.cacheHome,H.type===0?k.$5l:k.$4l)}N(H){return H.type===0?this.H.defaultProfile:H.profile?this.h.extUri.isEqual(H.location,this.G.extensionsResource)?this.G:this.H.profiles.find(Y=>this.h.extUri.isEqual(H.location,Y.extensionsResource))??this.G:this.H.defaultProfile}};B=pe([X(2,p.$Ok),X(3,v.$yp),X(4,h.$Mk),X(5,a.$ck),X(6,i.$bj)],B);function Z(x,H){const Y=(0,m.$Go)(x.manifest.publisher,x.manifest.name);return{id:Y,identifier:new k.$0l(Y),isBuiltin:x.type===0,isUserBuiltin:x.type===1&&x.isBuiltin,isUnderDevelopment:H,extensionLocation:x.location,uuid:x.identifier.uuid,targetPlatform:x.targetPlatform,...x.manifest}}e.$Fp=Z;class K extends T{constructor(H,Y,G,V,ee,ne,_,re,Q,q,C,A){super(H,Y,(0,l.$wg)(G,".vscode-oss-dev","extensions","control.json"),V,ee,ne,_,re,Q,q,C,A),this.R=(async()=>{if(b.$z)try{const J=await this.w.readFile(c.URI.file(b.$z));return JSON.parse(J.value.toString())}catch{}return Object.create(null)})()}f(H){return this.R}}e.$Gp=K}),define(ae[243],ce([0,1,66,6,38,3,2,23,16,31,8,17]),function(ie,e,I,N,j,L,O,R,S,d,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ip=void 0;let b=class extends O.$Rc{constructor($,y){super(),this.b=$,this.f=y,this.a=new N.$2g(5)}async postUninstall($){const y=this.g($,"uninstall");y&&(this.f.info($.identifier.id,$.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(y.script,"uninstall",y.args,!0,$),this.f.info("Finished running post uninstall script",$.identifier.id,$.manifest.version)}catch(w){this.f.error("Failed to run post uninstall script",$.identifier.id,$.manifest.version),this.f.error(w)}}));try{await d.Promises.rm(this.m($))}catch(w){this.f.error("Error while removing extension storage path",$.identifier.id),this.f.error(w)}}g($,y){const w=`vscode:${y}`;if($.location.scheme===R.Schemas.file&&$.manifest&&$.manifest.scripts&&typeof $.manifest.scripts[w]=="string"){const c=$.manifest.scripts[w].split(" ");return c.length<2||c[0]!=="node"||!c[1]?(this.f.warn($.identifier.id,$.manifest.version,`${w} should be a node script`),null):{script:(0,S.$ic)($.location.fsPath,c[1]),args:c.slice(2)||[]}}return null}h($,y,w,c,u){return new Promise((f,m)=>{const k=this.j($,y,w,u);let s;const a=n=>{s&&(clearTimeout(s),s=null),n?m(n):f(void 0)};k.on("error",n=>{a((0,j.$Ei)(n)||"Unknown")}),k.on("exit",(n,i)=>{a(n?`post-${y} process exited with code ${n}`:void 0)}),c&&(s=setTimeout(()=>{s=null,k.kill(),m("timed out")},5e3))})}j($,y,w,c){const u={silent:!0,execArgv:void 0},f=(0,I.fork)($,[`--type=extension-post-${y}`,...w],u);f.stdout.setEncoding("utf8"),f.stderr.setEncoding("utf8");const m=L.Event.fromNodeEventEmitter(f.stdout,"data"),k=L.Event.fromNodeEventEmitter(f.stderr,"data");m(n=>this.f.info(c.identifier.id,c.manifest.version,`post-${y}`,n)),k(n=>this.f.error(c.identifier.id,c.manifest.version,`post-${y}`,n));const s=L.Event.any(L.Event.map(m,n=>({data:`%c${n}`,format:[""]})),L.Event.map(k,n=>({data:`%c${n}`,format:["color: red"]})));return L.Event.debounce(s,(n,i)=>n?{data:n.data+i.data,format:[...n.format,...i.format]}:{data:i.data,format:i.format},100)(n=>{console.group(c.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),f}m($){return(0,S.$ic)(this.b.defaultProfile.globalStorageHome.fsPath,$.identifier.id.toLowerCase())}};e.$Ip=b,e.$Ip=b=pe([X(0,E.$Ok),X(1,P.$bj)],b)}),define(ae[244],ce([0,1,8,17,28,22,51,11,14,10]),function(ie,e,I,N,j,L,O,R,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TN=void 0;let P=class extends O.$zp{constructor(b,l,$,y,w,c){super(d.URI.file(b.extensionsPath),l,$,y,w,c)}};e.$TN=P,e.$TN=P=pe([X(0,S.$2h),X(1,R.$ck),X(2,N.$Ok),X(3,j.$Mk),X(4,L.$gl),X(5,I.$bj)],P)}),define(ae[245],ce([0,1,10,14,51,80,11,4,8,25,28,17]),function(ie,e,I,N,j,L,O,R,S,d,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N8b=void 0;let b=class extends L.$Gp{constructor($,y,w,c,u,f,m,k){super(I.URI.file(u.builtinExtensionsPath),I.URI.file(u.extensionsPath),u.userHome,$.defaultProfile,$,y,w,c,u,f,m,k)}};e.$N8b=b,e.$N8b=b=pe([X(0,E.$Ok),X(1,j.$yp),X(2,O.$ck),X(3,S.$bj),X(4,N.$2h),X(5,d.$tj),X(6,P.$Mk),X(7,R.$Sh)],b)}),define(ae[21],ce([0,1,6,3,2,100,12,68,4,17]),function(ie,e,I,N,j,L,O,R,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$0o=e.$9o=e.$8o=void 0,e.$8o="__$__isNewStorageMarker",e.$9o="__$__targetStorageMarker",e.$0o=(0,S.$Th)("storageService");var P;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(P||(e.WillSaveStateReason=P={}));var E;(function(u){u[u.APPLICATION=-1]="APPLICATION",u[u.PROFILE=0]="PROFILE",u[u.WORKSPACE=1]="WORKSPACE"})(E||(e.StorageScope=E={}));var b;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})(b||(e.StorageTarget=b={}));function l(u){const f=u.get(e.$9o);if(f)try{return JSON.parse(f)}catch{}return Object.create(null)}e.$$o=l;class $ extends j.$Rc{static{this.a=60*1e3}constructor(f={flushInterval:$.a}){super(),this.m=f,this.b=this.B(new N.$Rd),this.c=this.B(new N.$Rd),this.onDidChangeTarget=this.c.event,this.f=this.B(new N.$Od),this.onWillSaveState=this.f.event,this.h=this.B(new I.$8g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new j.$Sc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(f,m,k){return N.Event.filter(this.b.event,s=>s.scope===f&&(m===void 0||s.key===m),k)}n(){this.j.value=(0,I.$ah)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,j.$Mc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.O()}finally{(0,L.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(f,m){const{key:k,external:s}=m;if(k===e.$9o){switch(f){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:f})}else this.b.fire({scope:f,key:k,target:this.J(f)[k],external:s})}w(f){this.f.fire({reason:f})}get(f,m,k){return this.P(m)?.get(f,k)}getBoolean(f,m,k){return this.P(m)?.getBoolean(f,k)}getNumber(f,m,k){return this.P(m)?.getNumber(f,k)}getObject(f,m,k){return this.P(m)?.getObject(f,k)}storeAll(f,m){this.y(()=>{for(const k of f)this.store(k.key,k.value,k.scope,k.target,m)})}store(f,m,k,s,a=!1){if((0,O.$If)(m)){this.remove(f,k,a);return}this.y(()=>{this.z(f,k,s),this.P(k)?.set(f,m,a)})}remove(f,m,k=!1){this.y(()=>{this.z(f,m,void 0),this.P(m)?.delete(f,k)})}y(f){this.b.pause(),this.c.pause();try{f()}finally{this.b.resume(),this.c.resume()}}keys(f,m){const k=[],s=this.J(f);for(const a of Object.keys(s))s[a]===m&&k.push(a);return k}z(f,m,k,s=!1){const a=this.J(m);typeof k=="number"?a[f]!==k&&(a[f]=k,this.P(m)?.set(e.$9o,JSON.stringify(a),s)):typeof a[f]=="number"&&(delete a[f],this.P(m)?.set(e.$9o,JSON.stringify(a),s))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(f){switch(f){case-1:return this.I;case 0:return this.G;default:return this.D}}L(f){const m=this.P(f);return m?l(m):Object.create(null)}isNew(f){return this.getBoolean(e.$8o,f)===!0}async flush(f=P.NONE){this.f.fire({reason:f});const m=this.P(-1),k=this.P(0),s=this.P(1);switch(f){case P.NONE:await I.Promises.settled([m?.whenFlushed()??Promise.resolve(),k?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await I.Promises.settled([m?.flush(0)??Promise.resolve(),k?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve()]);break}}async log(){const f=this.P(-1)?.items??new Map,m=this.P(0)?.items??new Map,k=this.P(1)?.items??new Map;return c(f,m,k,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(f){return await this.flush(),this.P(f)?.optimize()}async switch(f,m){return this.w(P.NONE),(0,d.$Nk)(f)?this.R(f,m):this.S(f,m)}M(f,m){return!(f.id===m.id||y(m)&&y(f))}N(f,m,k){this.y(()=>{const s=new Set;for(const[a,n]of f)s.add(a),m.get(a)!==n&&this.u(k,{key:a,external:!0});for(const[a]of m.items)s.has(a)||this.u(k,{key:a,external:!0})})}}e.$_o=$;function y(u){return u.isDefault||!!u.useDefaultFlags?.globalState}e.$ap=y;class w extends ${constructor(){super(),this.U=this.B(new R.$6o(new R.$7o,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new R.$6o(new R.$7o,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new R.$6o(new R.$7o,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(f=>this.u(1,f))),this.B(this.W.onDidChangeStorage(f=>this.u(0,f))),this.B(this.U.onDidChangeStorage(f=>this.u(-1,f)))}P(f){switch(f){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(f){switch(f){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(f){return!1}}e.$bp=w;async function c(u,f,m,k,s,a){const n=D=>{try{return JSON.parse(D)}catch{return D}},i=new Map,t=new Map;u.forEach((D,T)=>{i.set(T,D),t.set(T,n(D))});const r=new Map,o=new Map;f.forEach((D,T)=>{r.set(T,D),o.set(T,n(D))});const v=new Map,p=new Map;m.forEach((D,T)=>{v.set(T,D),p.set(T,n(D))}),console.group(k!==s?`Storage: Application (path: ${k})`:`Storage: Application & Profile (path: ${k}, default profile)`);const h=[];if(i.forEach((D,T)=>{h.push({key:T,value:D})}),console.table(h),console.groupEnd(),console.log(t),k!==s){console.group(`Storage: Profile (path: ${s}, profile specific)`);const D=[];r.forEach((T,M)=>{D.push({key:M,value:T})}),console.table(D),console.groupEnd(),console.log(o)}console.group(`Storage: Workspace (path: ${a})`);const g=[];v.forEach((D,T)=>{g.push({key:T,value:D})}),console.table(g),console.groupEnd(),console.log(p)}e.$cp=c}),define(ae[113],ce([0,1,3,2,12,29,33,21]),function(ie,e,I,N,j,L,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lDb=e.$kDb=void 0;let S=class extends N.$Rc{constructor(E,b){super(),this.a=new I.$Od,this.onDidChangeEnablement=this.a.event,this.b=this.B(new d(E)),this.B(this.b.onDidChange(l=>this.a.fire({extensions:l,source:"storage"}))),this.B(b.onDidInstallExtensions(l=>l.forEach(({local:$,operation:y})=>{$&&y===4&&this.f($.identifier)})))}async enableExtension(E,b){return this.f(E)?(this.a.fire({extensions:[E],source:b}),!0):!1}async disableExtension(E,b){return this.c(E)?(this.a.fire({extensions:[E],source:b}),!0):!1}getDisabledExtensions(){return this.h(L.$eo)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(E){const b=this.getDisabledExtensions();return b.every(l=>!(0,O.$Do)(l,E))?(b.push(E),this.g(b),!0):!1}f(E){const b=this.getDisabledExtensions();for(let l=0;l<b.length;l++){const $=b[l];if((0,O.$Do)($,E))return b.splice(l,1),this.g(b),!0}return!1}g(E){this.j(L.$eo,E)}h(E){return this.b.get(E,0)}j(E,b){this.b.set(E,b,0)}};e.$kDb=S,e.$kDb=S=pe([X(0,R.$0o),X(1,L.$do)],S);class d extends N.$Rc{constructor(E){super(),this.c=E,this.a=Object.create(null),this.b=this.B(new I.$Od),this.onDidChange=this.b.event,this.B(E.onDidChangeValue(0,void 0,this.B(new N.$Qc))(b=>this.f(b)))}get(E,b){let l;return b===0?((0,j.$If)(this.a[E])&&(this.a[E]=this.g(E,b)),l=this.a[E]):l=this.g(E,b),JSON.parse(l)}set(E,b,l){const $=JSON.stringify(b.map(({id:w,uuid:c})=>({id:w,uuid:c})));this.g(E,l)!==$&&(l===0&&(b.length?this.a[E]=$:delete this.a[E]),this.h(E,b.length?$:void 0,l))}f(E){if(!(0,j.$If)(this.a[E.key])&&this.g(E.key,E.scope)!==this.a[E.key]){const l=this.get(E.key,E.scope);delete this.a[E.key];const $=this.get(E.key,E.scope),y=l.filter(c=>!$.some(u=>(0,O.$Do)(c,u))),w=$.filter(c=>!l.some(u=>(0,O.$Do)(u,c)));(y.length||w.length)&&this.b.fire([...y,...w])}}g(E,b){return this.c.get(E,b,"[]")}h(E,b,l){b?this.c.store(E,b,l,1):this.c.remove(E,l)}}e.$lDb=d}),define(ae[246],ce([0,1,18,26,7,5,37,12,10,20,14,29,33,69,11,8,25,58,224,21,22,62]),function(ie,e,I,N,j,L,O,R,S,d,P,E,b,l,$,y,w,c,u,f,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hp=e.$gp=e.$fp=void 0;const s=L.$p?"web":(0,E.$0n)(L.$u,O.$dc),a="X-Market-Search-Activity-Id";var n;(function(C){C[C.None=0]="None",C[C.IncludeVersions=1]="IncludeVersions",C[C.IncludeFiles=2]="IncludeFiles",C[C.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",C[C.IncludeSharedAccounts=8]="IncludeSharedAccounts",C[C.IncludeVersionProperties=16]="IncludeVersionProperties",C[C.ExcludeNonValidated=32]="ExcludeNonValidated",C[C.IncludeInstallationTargets=64]="IncludeInstallationTargets",C[C.IncludeAssetUri=128]="IncludeAssetUri",C[C.IncludeStatistics=256]="IncludeStatistics",C[C.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",C[C.Unpublished=4096]="Unpublished",C[C.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function i(...C){return String(C.reduce((A,J)=>A|J,0))}var t;(function(C){C[C.Tag=1]="Tag",C[C.ExtensionId=4]="ExtensionId",C[C.Category=5]="Category",C[C.ExtensionName=7]="ExtensionName",C[C.Target=8]="Target",C[C.Featured=9]="Featured",C[C.SearchText=10]="SearchText",C[C.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},p={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class h{constructor(A=p){this.d=A}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(A,J=this.d.pageSize){return new h({...this.d,pageNumber:A,pageSize:J})}withFilter(A,...J){const F=[...this.d.criteria,...J.length?J.map(U=>({filterType:A,value:U})):[{filterType:A}]];return new h({...this.d,criteria:F})}withSortBy(A){return new h({...this.d,sortBy:A})}withSortOrder(A){return new h({...this.d,sortOrder:A})}withFlags(...A){return new h({...this.d,flags:A.reduce((J,F)=>J|F,0)})}withAssetTypes(...A){return new h({...this.d,assetTypes:A})}withSource(A){return new h({...this.d,source:A})}get raw(){const{criteria:A,pageNumber:J,pageSize:F,sortBy:U,sortOrder:W,flags:te,assetTypes:se}=this.d;return{filters:[{criteria:A,pageNumber:J,pageSize:F,sortBy:U,sortOrder:W}],assetTypes:se,flags:te}}get searchText(){const A=this.d.criteria.filter(J=>J.filterType===t.SearchText)[0];return A&&A.value?A.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(A=>String(A.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function g(C,A){const J=(C||[]).filter(F=>F.statisticName===A)[0];return J?J.value:0}function D(C){const A="Microsoft.VisualStudio.Code.Translation.";return C.files.filter(F=>F.assetType.indexOf(A)===0).reduce((F,U)=>{const W=z(C,U.assetType);return W&&F.push([U.assetType.substring(A.length),W]),F},[])}function T(C){if(C.properties){const A=C.properties.filter(U=>U.key===r.Repository),J=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),F=A.filter(U=>J.test(U.value))[0];return F?{uri:F.value,fallbackUri:F.value}:null}return z(C,r.Repository)}function M(C){return{uri:`${C.fallbackAssetUri}/${r.VSIX}?redirect=true${C.targetPlatform?`&targetPlatform=${C.targetPlatform}`:""}`,fallbackUri:`${C.fallbackAssetUri}/${r.VSIX}${C.targetPlatform?`?targetPlatform=${C.targetPlatform}`:""}`}}function z(C,A){return C.files.filter(F=>F.assetType===A)[0]?{uri:`${C.assetUri}/${A}${C.targetPlatform?`?targetPlatform=${C.targetPlatform}`:""}`,fallbackUri:`${C.fallbackAssetUri}/${A}${C.targetPlatform?`?targetPlatform=${C.targetPlatform}`:""}`}:null}function B(C,A){const J=C.properties?C.properties.filter(U=>U.key===A):[],F=J.length>0&&J[0].value;return F?F.split(",").map(U=>(0,b.$Ho)(U)):[]}function Z(C){const A=C.properties?C.properties.filter(J=>J.key===o.Engine):[];return A.length>0&&A[0].value||""}function K(C){const A=C.properties?C.properties.filter(J=>J.key===o.PreRelease):[];return A.length>0&&A[0].value==="true"}function x(C){const A=C.properties?C.properties.filter(F=>F.key===o.LocalizedLanguages):[],J=A.length>0&&A[0].value||"";return J?J.split(","):[]}function H(C){return C.properties?.find(A=>A.key===o.SponsorLink)?.value}function Y(C){return C.indexOf("preview")!==-1}function G(C){return C.targetPlatform?(0,E.$9n)(C.targetPlatform):"undefined"}function V(C){const A=(0,I.$Lb)(C.versions.map(G)),J=!!C.tags?.includes(E.$4n),F=A.indexOf("web");return J?F===-1&&A.push("web"):F!==-1&&A.splice(F,1),A}function ee(C,A){for(let J=0;J<C.length;J++){const F=C[J];if(F.version===C[J-1]?.version){let U=J;if(G(F)===A)for(;U>0&&C[U-1].version===F.version;)U--;U!==J&&(C.splice(J,1),C.splice(U,0,F))}}return C}e.$fp=ee;function ne(C,A,J){C.telemetryData={index:A,querySource:J,queryActivityId:C.queryContext?.[a]}}function _(C,A,J,F){const U=C.versions[0],W={manifest:z(A,r.Manifest),readme:z(A,r.Details),changelog:z(A,r.Changelog),license:z(A,r.License),repository:T(A),download:M(A),icon:z(A,r.Icon),signature:z(A,r.Signature),coreTranslations:D(A)};return{identifier:{id:(0,b.$Io)(C.publisher.publisherName,C.extensionName),uuid:C.extensionId},name:C.extensionName,version:A.version,displayName:C.displayName,publisherId:C.publisher.publisherId,publisher:C.publisher.publisherName,publisherDisplayName:C.publisher.displayName,publisherDomain:C.publisher.domain?{link:C.publisher.domain,verified:!!C.publisher.isDomainVerified}:void 0,publisherSponsorLink:H(U),description:C.shortDescription||"",installCount:g(C.statistics,"install"),rating:g(C.statistics,"averagerating"),ratingCount:g(C.statistics,"ratingcount"),categories:C.categories||[],tags:C.tags||[],releaseDate:Date.parse(C.releaseDate),lastUpdated:Date.parse(C.lastUpdated),allTargetPlatforms:J,assets:W,properties:{dependencies:B(A,o.Dependency),extensionPack:B(A,o.ExtensionPack),engine:Z(A),localizedLanguages:x(A),targetPlatform:G(A),isPreReleaseVersion:K(A)},hasPreReleaseVersion:K(U),hasReleaseVersion:!0,preview:Y(C.flags),isSigned:!!W.signature,queryContext:F}}let re=class{constructor(A,J,F,U,W,te,se,ue){this.k=J,this.l=F,this.n=U,this.o=W,this.q=te,this.u=se,this.w=ue;const le=se.extensionsGallery,$e=le?.servicePPEUrl&&ue.getValue("_extensionsGallery.enablePPE");this.d=$e?le.servicePPEUrl:le?.serviceUrl,this.g=$e?void 0:le?.searchUrl,this.h=le?.controlUrl,this.j=(0,u.$ep)(se.version,se,this.n,this.w,this.q,A,this.o)}x(A=""){return`${this.d}${A}`}isEnabled(){return!!this.d}async getExtensions(A,J,F){const U=N.CancellationToken.isCancellationToken(J)?{}:J,W=N.CancellationToken.isCancellationToken(J)?J:F,te=[],se=[],ue=[],le=[];let $e=!0;for(const ve of A){ve.uuid?se.push(ve.uuid):te.push(ve.id);const Oe=!!(ve.version||ve.preRelease);ue.push({id:ve.id,uuid:ve.uuid,includePreRelease:Oe}),ve.version&&le.push({id:ve.id,uuid:ve.uuid,version:ve.version}),$e=$e&&!!ve.hasPreRelease&&!Oe}if(!se.length&&!te.length)return[];let fe=new h().withPage(1,A.length);se.length&&(fe=fe.withFilter(t.ExtensionId,...se)),te.length&&(fe=fe.withFilter(t.ExtensionName,...te)),(U.queryAllVersions||$e)&&(fe=fe.withFlags(fe.flags,n.IncludeVersions)),U.source&&(fe=fe.withSource(U.source));const{extensions:we}=await this.z(fe,{targetPlatform:U.targetPlatform??s,includePreRelease:ue,versions:le,compatible:!!U.compatible},W);return U.source&&we.forEach((ve,Oe)=>ne(ve,Oe,U.source)),we}async getCompatibleExtension(A,J,F){if((0,E.$$n)(A.allTargetPlatforms,F))return null;if(await this.isExtensionCompatible(A,J,F))return A;const U=new h().withFlags(n.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,A.identifier.uuid),{extensions:W}=await this.z(U,{targetPlatform:F,compatible:!0,includePreRelease:J},N.CancellationToken.None);return W[0]||null}async isExtensionCompatible(A,J,F){if(!(0,E.$_n)(A.properties.targetPlatform,A.allTargetPlatforms,F)||!J&&A.properties.isPreReleaseVersion)return!1;let U=A.properties.engine;if(!U){const W=await this.getManifest(A,N.CancellationToken.None);if(!W)throw new Error("Manifest was not found");U=W.engines.vscode}return(0,l.$Vo)(U,this.u.version,this.u.date)}async y(A,J,F,U,W){if(!(0,E.$_n)(G(A),U,W)||J!=="any"&&K(A)!==(J==="prerelease"))return!1;if(F)try{const te=await this.E(A);if(!(0,l.$Vo)(te,this.u.version,this.u.date))return!1}catch(te){return this.l.error(`Error while getting the engine for the version ${A.version}.`,(0,j.$9)(te)),!1}return!0}async query(A,J){let F=A.text||"";const U=A.pageSize??50;let W=new h().withPage(1,U);F?(F=F.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,($e,fe,we)=>(W=W.withFilter(t.Category,we||fe),"")),F=F.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,($e,fe,we)=>(W=W.withFilter(t.Tag,we||fe),"")),F=F.replace(/\bfeatured(\s+|\b|$)/g,()=>(W=W.withFilter(t.Featured),"")),F=F.trim(),F&&(F=F.length<200?F:F.substring(0,200),W=W.withFilter(t.SearchText,F)),W=W.withSortBy(0)):A.ids?W=W.withFilter(t.ExtensionId,...A.ids):A.names?W=W.withFilter(t.ExtensionName,...A.names):W=W.withSortBy(4),typeof A.sortBy=="number"&&(W=W.withSortBy(A.sortBy)),typeof A.sortOrder=="number"&&(W=W.withSortOrder(A.sortOrder)),A.source&&(W=W.withSource(A.source));const te=async($e,fe)=>{const{extensions:we,total:ve}=await this.z($e,{targetPlatform:s,compatible:!1,includePreRelease:!!A.includePreRelease},fe);return we.forEach((Oe,Ne)=>ne(Oe,($e.pageNumber-1)*$e.pageSize+Ne,A.source)),{extensions:we,total:ve}},{extensions:se,total:ue}=await te(W,J),le=async($e,fe)=>{if(fe.isCancellationRequested)throw new j.$4;const{extensions:we}=await te(W.withPage($e+1),fe);return we};return{firstPage:se,total:ue,pageSize:W.pageSize,getPage:le}}async z(A,J,F){const U=A.flags;A.flags&n.IncludeLatestVersionOnly&&A.flags&n.IncludeVersions&&(A=A.withFlags(A.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(A.flags&n.IncludeLatestVersionOnly)&&!(A.flags&n.IncludeVersions)&&(A=A.withFlags(A.flags,n.IncludeLatestVersionOnly)),J.versions?.length&&(A=A.withFlags(A.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),A=A.withFlags(A.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:W,total:te,context:se}=await this.B(A,F);if(!(A.flags&n.IncludeLatestVersionOnly)){const fe=[];for(const we of W){const ve=await this.A(we,J,se);ve&&fe.push(ve)}return{extensions:fe,total:te}}const le=[],$e=new Map;for(let fe=0;fe<W.length;fe++){const we=W[fe],ve={id:(0,b.$Io)(we.publisher.publisherName,we.extensionName),uuid:we.extensionId},Oe=(0,R.$Ff)(J.includePreRelease)?J.includePreRelease:!!J.includePreRelease.find(Me=>(0,b.$Do)(Me,ve))?.includePreRelease;if(J.compatible&&(0,E.$$n)(V(we),J.targetPlatform))continue;const Ne=await this.A(we,J,se);!Ne||Ne.properties.isPreReleaseVersion&&(!Oe||!Ne.hasReleaseVersion)||!Ne.properties.isPreReleaseVersion&&Ne.properties.targetPlatform!==J.targetPlatform&&Ne.hasPreReleaseVersion?$e.set(we.extensionId,fe):le.push([fe,Ne])}if($e.size){const fe=new k.$Kd,we=new h().withFlags(U&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,$e.size).withFilter(t.ExtensionId,...$e.keys()),{extensions:ve}=await this.z(we,J,F);this.o.publicLog2("galleryService:additionalQuery",{duration:fe.elapsed(),count:$e.size});for(const Oe of ve){const Ne=$e.get(Oe.identifier.uuid);le.push([Ne,Oe])}}return{extensions:le.sort((fe,we)=>fe[0]-we[0]).map(([,fe])=>fe),total:te}}async A(A,J,F){const U={id:(0,b.$Io)(A.publisher.publisherName,A.extensionName),uuid:A.extensionId},W=J.versions?.find(le=>(0,b.$Do)(le,U))?.version,te=(0,R.$Ff)(J.includePreRelease)?J.includePreRelease:!!J.includePreRelease.find(le=>(0,b.$Do)(le,U))?.includePreRelease,se=V(A),ue=ee(A.versions,J.targetPlatform);if(J.compatible&&(0,E.$$n)(se,J.targetPlatform))return null;for(let le=0;le<ue.length;le++){const $e=ue[le];if(!(W&&$e.version!==W)){if(await this.y($e,te?"any":"release",J.compatible,se,J.targetPlatform))return _(A,$e,se,F);if(W&&$e.version===W)return null}}return W||J.compatible?null:_(A,A.versions[0],se)}async B(A,J){if(!this.isEnabled())throw new Error("No extension gallery service configured.");A=A.withFlags(A.flags,n.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,i(n.Unpublished));const F=await this.j,U=JSON.stringify(A.raw),W={...F,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(U.length)},te=new k.$Kd;let se,ue,le=0;try{if(se=await this.k.request({type:"POST",url:this.g&&A.criteria.some(fe=>fe.filterType===t.SearchText)?this.g:this.x("/extensionquery"),data:U,headers:W},J),se.res.statusCode&&se.res.statusCode>=400&&se.res.statusCode<500)return{galleryExtensions:[],total:le};const $e=await(0,c.$3o)(se);if($e){const fe=$e.results[0],we=fe.extensions,ve=fe.resultMetadata&&fe.resultMetadata.filter(Oe=>Oe.metadataType==="ResultCount")[0];return le=ve&&ve.metadataItems.filter(Oe=>Oe.name==="TotalCount")[0].count||0,{galleryExtensions:we,total:le,context:{[a]:se.res.headers.activityid}}}return{galleryExtensions:[],total:le}}catch($e){throw ue=$e,$e}finally{this.o.publicLog2("galleryService:query",{...A.telemetryData,requestBodySize:String(U.length),duration:te.elapsed(),success:!!se&&(0,c.$Yo)(se),responseBodySize:se?.res.headers["Content-Length"],statusCode:se?String(se.res.statusCode):void 0,errorCode:ue?(0,j.$3)(ue)?"canceled":(0,j.$9)(ue).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(le)})}}async reportStatistic(A,J,F,U){if(!this.isEnabled())return;const W=L.$p?this.x(`/itemName/${A}.${J}/version/${F}/statType/${U==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${A}/extensions/${J}/${F}/stats?statType=${U}`),te=L.$p?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ue={...await this.j,Accept:te};try{await this.k.request({type:"POST",url:W,headers:ue},N.CancellationToken.None)}catch{}}async download(A,J,F){this.l.trace("ExtensionGalleryService#download",A.identifier.id);const U=(0,b.$Lo)(A),W=new Date().getTime(),te=fe=>this.o.publicLog("galleryService:downloadVSIX",{...U,duration:fe}),se=F===2?"install":F===3?"update":"",ue=se?{uri:`${A.assets.download.uri}${S.URI.parse(A.assets.download.uri).query?"&":"?"}${se}=true`,fallbackUri:`${A.assets.download.fallbackUri}${S.URI.parse(A.assets.download.fallbackUri).query?"&":"?"}${se}=true`}:A.assets.download,le=A.queryContext?.[a]?{[a]:A.queryContext[a]}:void 0,$e=await this.D(ue,le?{headers:le}:void 0);await this.q.writeFile(J,$e.stream),te(new Date().getTime()-W)}async downloadSignatureArchive(A,J){if(!A.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",A.identifier.id);const F=await this.D(A.assets.signature);await this.q.writeFile(J,F.stream)}async getReadme(A,J){if(A.assets.readme){const F=await this.D(A.assets.readme,{},J);return await(0,c.$2o)(F)||""}return""}async getManifest(A,J){if(A.assets.manifest){const F=await this.D(A.assets.manifest,{},J),U=await(0,c.$2o)(F);return U?JSON.parse(U):null}return null}async C(A,J){const F=z(A,r.Manifest);if(!F)throw new Error("Manifest was not found");const U={"Accept-Encoding":"gzip"},W=await this.D(F,{headers:U});return await(0,c.$3o)(W)}async getCoreTranslation(A,J){const F=A.assets.coreTranslations.filter(U=>U[0]===J.toUpperCase())[0];if(F){const U=await this.D(F[1]),W=await(0,c.$2o)(U);return W?JSON.parse(W):null}return null}async getChangelog(A,J){if(A.assets.changelog){const F=await this.D(A.assets.changelog,{},J);return await(0,c.$2o)(F)||""}return""}async getAllCompatibleVersions(A,J,F){let U=new h().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);A.identifier.uuid?U=U.withFilter(t.ExtensionId,A.identifier.uuid):U=U.withFilter(t.ExtensionName,A.identifier.id);const{galleryExtensions:W}=await this.B(U,N.CancellationToken.None);if(!W.length)return[];const te=V(W[0]);if((0,E.$$n)(te,F))return[];const se=[];await Promise.all(W[0].versions.map(async $e=>{try{await this.y($e,J?"any":"release",!0,te,F)&&se.push($e)}catch{}}));const ue=[],le=new Set;for(const $e of ee(se,F))le.has($e.version)||(le.add($e.version),ue.push({version:$e.version,date:$e.lastUpdated,isPreReleaseVersion:K($e)}));return ue}async D(A,J={},F=N.CancellationToken.None){const U=await this.j,W={type:"GET"},te={...U,...J.headers||{}};J={...J,...W,headers:te};const se=A.uri,ue=A.fallbackUri,le={...J,url:se};try{const $e=await this.k.request(le,F);if($e.res.statusCode===200)return $e;const fe=await(0,c.$2o)($e);throw new Error(`Expected 200, got back ${$e.res.statusCode} instead.

${fe}`)}catch($e){if((0,j.$3)($e))throw $e;const fe=(0,j.$9)($e);this.o.publicLog2("galleryService:cdnFallback",{url:se,message:fe});const we={...J,url:ue};return this.k.request(we,F)}}async E(A){let J=Z(A);if(!J){const F=await this.C(A,N.CancellationToken.None);if(!F)throw new Error("Manifest was not found");J=F.engines.vscode}return J}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const A=await this.k.request({type:"GET",url:this.h},N.CancellationToken.None);if(A.res.statusCode!==200)throw new Error("Could not get extensions report.");const J=await(0,c.$3o)(A),F=[],U={},W=[];if(J){for(const te of J.malicious)F.push({id:te});if(J.migrateToPreRelease)for(const[te,se]of Object.entries(J.migrateToPreRelease))(!se.engine||(0,l.$Vo)(se.engine,this.u.version,this.u.date))&&(U[te.toLowerCase()]={disallowInstall:!0,extension:{id:se.id,displayName:se.displayName,autoMigrate:{storage:!!se.migrateStorage},preRelease:!0}});if(J.deprecated)for(const[te,se]of Object.entries(J.deprecated))se&&(U[te.toLowerCase()]=(0,R.$Ff)(se)?{}:se);if(J.search)for(const te of J.search)W.push(te)}return{malicious:F,deprecated:U,search:W}}};re=pe([X(1,c.$Wo),X(2,y.$bj),X(3,P.$1h),X(4,m.$gl),X(5,$.$ck),X(6,w.$tj),X(7,d.$ni)],re);let Q=class extends re{constructor(A,J,F,U,W,te,se,ue){super(A,J,F,U,W,te,se,ue)}};e.$gp=Q,e.$gp=Q=pe([X(0,f.$0o),X(1,c.$Wo),X(2,y.$bj),X(3,P.$1h),X(4,m.$gl),X(5,$.$ck),X(6,w.$tj),X(7,d.$ni)],Q);let q=class extends re{constructor(A,J,F,U,W,te,se){super(void 0,A,J,F,U,W,te,se)}};e.$hp=q,e.$hp=q=pe([X(0,c.$Wo),X(1,y.$bj),X(2,P.$1h),X(3,m.$gl),X(4,$.$ck),X(5,w.$tj),X(6,d.$ni)],q)}),define(ae[81],ce([0,1,4,3,2,21,33,25,18,8,12]),function(ie,e,I,N,j,L,O,R,S,d,P){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$2u=e.$1u=void 0,e.$1u=(0,I.$Th)("IExtensionStorageService");const b=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let l=class extends j.$Rc{static{E=this}static{this.a=512*1024}static b(y){return`extensionKeys/${(0,O.$Ho)(y.id)}@${y.version}`}static c(y){const w=b.exec(y);if(w&&w[1])return{id:w[1],version:w[2]}}static async removeOutdatedExtensionVersions(y,w){const c=await y.getInstalled(),u=[];for(const[f,m]of E.f(w)){const k=c.find(s=>(0,O.$Do)(s.identifier,{id:f}))?.manifest.version;for(const s of m)k!==s&&u.push(E.b({id:f,version:s}))}for(const f of u)w.remove(f,0)}static f(y){const w=new Map,c=y.keys(0,1);for(const u of c){const f=E.c(u);if(f){let m=w.get(f.id.toLowerCase());m||w.set(f.id.toLowerCase(),m=[]),m.push(f.version)}}return w}constructor(y,w,c){super(),this.j=y,this.m=w,this.n=c,this.g=this.B(new N.$Od),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=E.f(y),this.B(this.j.onDidChangeValue(0,void 0,this.B(new j.$Qc))(u=>this.r(u)))}r(y){if(this.h.has(y.key.toLowerCase())){this.g.fire();return}const w=E.c(y.key);if(w){if(this.j.get(y.key,0)===void 0)this.h.delete(w.id.toLowerCase());else{let c=this.h.get(w.id.toLowerCase());c||this.h.set(w.id.toLowerCase(),c=[]),c.push(w.version),this.g.fire()}return}}s(y){if((0,P.$zf)(y))return y;const w=y.manifest?y.manifest.publisher:y.publisher,c=y.manifest?y.manifest.name:y.name;return(0,O.$Go)(w,c)}getExtensionState(y,w){const c=this.s(y),u=this.getExtensionStateRaw(y,w);if(u)try{return JSON.parse(u)}catch(f){this.n.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${c}, global: ${w}): ${f}`)}}getExtensionStateRaw(y,w){const c=this.s(y),u=this.j.get(c,w?0:1);return u&&u?.length>E.a&&this.n.warn(`[mainThreadStorage] large extension state detected (extensionId: ${c}, global: ${w}): ${u.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),u}setExtensionState(y,w,c){const u=this.s(y);w===void 0?this.j.remove(u,c?0:1):this.j.store(u,JSON.stringify(w),c?0:1,1)}setKeysForSync(y,w){this.j.store(E.b(y),JSON.stringify(w),0,1)}getKeysForSync(y){const w=this.m.extensionSyncedKeys?.[y.id.toLowerCase()],c=this.j.get(E.b(y),0),u=c?JSON.parse(c):void 0;return u&&w?(0,S.$Lb)([...u,...w]):u||w}addToMigrationList(y,w){if(y!==w){const c=this.t.filter(u=>!u.includes(y)&&!u.includes(w));c.push([y,w]),this.t=c}}getSourceExtensionToMigrate(y){const w=this.t.find(([,c])=>y===c);return w?w[0]:void 0}get t(){const y=this.j.get("extensionStorage.migrationList",-1,"[]");try{const w=JSON.parse(y);if(Array.isArray(w))return w}catch{}return[]}set t(y){y.length?this.j.store("extensionStorage.migrationList",JSON.stringify(y),-1,1):this.j.remove("extensionStorage.migrationList",-1)}};e.$2u=l,e.$2u=l=E=pe([X(0,L.$0o),X(1,R.$tj),X(2,d.$bj)],l)}),define(ae[247],ce([0,1,29,11,25,14,98,56,21,22,221]),function(ie,e,I,N,j,L,O,R,S,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_9b=void 0;let E=class extends P.$k6b{constructor(l,$,y,w,c,u,f,m){super(l.userHome,c,$,y,w,u,f,m)}};e.$_9b=E,e.$_9b=E=pe([X(0,L.$2h),X(1,d.$gl),X(2,I.$do),X(3,S.$0o),X(4,R.$27b),X(5,O.$yWb),X(6,N.$ck),X(7,j.$tj)],E)}),define(ae[248],ce([0,1,105,3,22,14,2,8,16,66,25,5,6,101,20,164,36,21,12,131,19]),function(ie,e,I,N,j,L,O,R,S,d,P,E,b,l,$,y,w,c,u,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$89b=void 0;const k=[I.$19b,I.$29b],s="remoteTunnelSession",a="remoteTunnelIsService";let n=class extends O.$Rc{constructor(o,v,p,h,g,D,T){super(),this.y=o,this.z=v,this.C=p,this.D=D,this.F=T,this.f=new N.$Od,this.onDidTokenFailed=this.f.event,this.g=new N.$Od,this.onDidChangeTunnelStatus=this.g.event,this.h=new N.$Od,this.onDidChangeMode=this.h.event,this.n=I.$Y9b,this.w=!1,this.I=(M,z)=>{z?this.j.error(M):this.j.info(M)},this.j=this.B(h.createLogger((0,m.$wg)(p.logsHome,`${I.$39b}.log`),{id:I.$39b,name:I.$49b})),this.t=new b.$Rg(100),this.B(this.j.onDidChangeLogLevel(M=>this.j.info("Log level changed to "+(0,R.$qj)(M)))),this.B(g.onWillShutdown(()=>{this.r?.cancel(),this.r=void 0,this.dispose()})),this.B(D.onDidChangeConfiguration(M=>{k.some(z=>M.affectsConfiguration(z))&&this.t.trigger(()=>this.L())})),this.n=this.R(),this.s=I.TunnelStates.uninitialized}async getTunnelStatus(){return this.s}G(o){this.s=o,this.g.fire(o)}H(o){t(this.n,o)||(this.n=o,this.S(o),this.h.fire(this.n),o.active?(this.j.info(`Session updated: ${o.session.accountLabel} (${o.session.providerId}) (service=${o.asService})`),o.session.token&&this.j.info(`Session token updated: ${o.session.accountLabel} (${o.session.providerId})`)):this.j.info("Session reset"))}getMode(){return Promise.resolve(this.n)}async initialize(o){if(this.w)return this.s;this.w=!0,this.H(o);try{await this.t.trigger(()=>this.L())}catch(v){this.j.error(v)}return this.s}J(){if(!this.u){let o;E.$k?o=this.C.appRoot:o=(0,S.$lc)((0,S.$lc)(this.C.appRoot)),this.u=(0,S.$ic)(o,"bin",`${this.z.tunnelApplicationName}${E.$j?".exe":""}`)}return this.u}async startTunnel(o){if(t(this.n,o)&&this.s.type!=="disconnected")return this.s;this.H(o);try{await this.t.trigger(()=>this.L())}catch(v){this.j.error(v)}return this.s}async stopTunnel(){if(this.r&&(this.r.cancel(),this.r=void 0),!this.n.active)return;const o=this.n.asService;this.H(I.$Y9b);try{o&&this.O("uninstallService",["service","uninstall"])}catch(v){this.j.error(v)}try{await this.O("stop",["kill"])}catch(v){this.j.error(v)}this.G(I.TunnelStates.disconnected())}async L(){this.y.publicLog2("remoteTunnel.enablement",{enabled:this.n.active,service:this.n.active&&this.n.asService}),this.r&&(this.r.cancel(),this.r=void 0);let o="",v=!1;const p=(z,B)=>{B?this.j.error(z):o+=z,!this.C.isBuilt&&z.startsWith("   Compiling")&&this.G(I.TunnelStates.connecting((0,y.localize)(0,null)))},h=this.O("status",["status"],p);this.r=h;try{if(await h,this.r!==h)return;let z;try{z=JSON.parse(o.trim().split(`
`).find(B=>B.startsWith("{")))}catch{this.j.error(`Could not parse status output: ${JSON.stringify(o.trim())}`),this.G(I.TunnelStates.disconnected());return}if(v=z.service_installed,this.j.info(z.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!z.tunnel&&!this.n.active){this.G(I.TunnelStates.disconnected());return}}catch(z){this.j.error(z),this.G(I.TunnelStates.disconnected());return}finally{this.r===h&&(this.r=void 0)}const g=this.n.active?this.n.session:void 0;if(g&&g.token){const z=g.token;this.G(I.TunnelStates.connecting((0,y.localize)(1,null,g.accountLabel,g.providerId)));const B=(K,x)=>{K=K.replaceAll(z,"*".repeat(4)),p(K,x)},Z=this.O("login",["user","login","--provider",g.providerId,"--access-token",z,"--log",(0,R.$qj)(this.j.getLevel())],B);this.r=Z;try{if(await Z,this.r!==Z)return}catch(K){this.j.error(K),this.r=void 0,this.f.fire(g),this.G(I.TunnelStates.disconnected(g));return}}const D=this.Q();D?this.G(I.TunnelStates.connecting((0,y.localize)(2,null,D))):this.G(I.TunnelStates.connecting((0,y.localize)(3,null)));const T=["--accept-server-license-terms","--log",(0,R.$qj)(this.j.getLevel())];D?T.push("--name",D):T.push("--random-name");let M=!1;return this.n.active&&this.n.asService&&!v&&(M=await this.M(T)===!1),this.N(g,T,M)}async M(o){let v;try{v=await this.O("serviceInstall",["service","install",...o])}catch(p){this.j.error(p),v=1}if(v!==0){const p=(0,y.localize)(4,null);return this.j.warn(p),this.G(I.TunnelStates.connecting(p)),!1}return!0}async N(o,v,p){v.push("--parent-process-id",String(process.pid)),this.P()&&v.push("--no-sleep");let h=!1;const g=this.O("tunnel",v,(D,T)=>{T?this.j.error(D):this.j.info(D),D.includes("Connected to an existing tunnel process")&&(h=!0);const M=D.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(M){const z={link:M[1],domain:M[2],tunnelName:M[4],isAttached:h};this.G(I.TunnelStates.connected(z,p))}else D.match(/error refreshing token/)&&(g.cancel(),this.f.fire(o),this.G(I.TunnelStates.disconnected(o)))});this.r=g,g.finally(()=>{g===this.r&&(this.j.info("tunnel process terminated"),this.r=void 0,this.n=I.$Y9b,this.G(I.TunnelStates.disconnected()))})}O(o,v,p=this.I){return(0,b.$Ig)(h=>new Promise((g,D)=>{h.isCancellationRequested&&g(-1);let T;const M=["ignore","pipe","pipe"];if(h.onCancellationRequested(()=>{T&&(this.j.info(`${o} terminating(${T.pid})`),T.kill())}),!this.C.isBuilt)p(`Building tunnel CLI from sources and run
`,!1),p(`${o} Spawning: cargo run -- tunnel ${v.join(" ")}
`,!1),T=(0,d.spawn)("cargo",["run","--","tunnel",...v],{cwd:(0,S.$ic)(this.C.appRoot,"cli"),stdio:M});else{p(`Running tunnel CLI
`,!1);const z=this.J();p(`${o} Spawning: ${z} tunnel ${v.join(" ")}
`,!1),T=(0,d.spawn)(z,["tunnel",...v],{cwd:(0,w.homedir)(),stdio:M})}T.stdout.pipe(new f.$IT(`
`)).on("data",z=>{if(T){const B=z.toString();p(B,!1)}}),T.stderr.pipe(new f.$IT(`
`)).on("data",z=>{if(T){const B=z.toString();p(B,!0)}}),T.on("exit",z=>{T&&(p(`${o} exit(${T.pid}): + ${z} `,!1),T=void 0,g(z||0))}),T.on("error",z=>{T&&(p(`${o} error(${T.pid}): + ${z} `,!0),T=void 0,D())})}))}async getTunnelName(){return this.Q()}P(){return!!this.D.getValue(I.$29b)}Q(){let o=this.D.getValue(I.$19b)||(0,w.hostname)();return o=o.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),o||void 0}R(){try{const o=this.F.get(s,-1),v=this.F.getBoolean(a,-1,!1);if(o){const p=JSON.parse(o);if(p&&(0,u.$zf)(p.accountLabel)&&(0,u.$zf)(p.sessionId)&&(0,u.$zf)(p.providerId))return{active:!0,session:p,asService:v};this.j.error("Problems restoring session from storage, invalid format",p)}}catch(o){this.j.error("Problems restoring session from storage",o)}return I.$Y9b}S(o){if(o.active){const v={providerId:o.session.providerId,sessionId:o.session.sessionId,accountLabel:o.session.accountLabel};this.F.store(s,JSON.stringify(v),-1,1),this.F.store(a,o.asService,-1,1)}else this.F.remove(s,-1),this.F.remove(a,-1)}};e.$89b=n,e.$89b=n=pe([X(0,j.$gl),X(1,P.$tj),X(2,L.$2h),X(3,R.$cj),X(4,l.$69b),X(5,$.$ni),X(6,c.$0o)],n);function i(r,o){return r&&o?r.sessionId===o.sessionId&&r.providerId===o.providerId&&r.token===o.token:r===o}const t=(r,o)=>r.active!==o.active?!1:r.active&&o.active?r.asService===o.asService&&i(r.session,o.session):!0}),define(ae[249],ce([0,1,6,2,23,19,68,21,76,17]),function(ie,e,I,N,j,L,O,R,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a0b=void 0;class P extends R.$_o{constructor(b,l,$,y){super(),this.bb=b,this.cb=l,this.db=$,this.eb=y,this.s=this.cb.defaultProfile,this.U=this.fb(),this.W=this.cb.currentProfile,this.X=this.B(new N.$Qc),this.Y=this.gb(this.W),this.Z=this.bb?.id,this.$=this.B(new N.$Qc),this.ab=this.hb(this.bb)}fb(){const b=this.B(new S.$UDb(this.db.getChannel("storage"))),l=this.B(new O.$6o(b));return this.B(l.onDidChangeStorage($=>this.u(-1,$))),l}gb(b){this.X.clear(),this.W=b;let l;if((0,R.$ap)(b))l=this.U;else{const $=this.X.add(new S.$VDb(this.db.getChannel("storage"),b));l=this.X.add(new O.$6o($))}return this.X.add(l.onDidChangeStorage($=>this.u(0,$))),l}hb(b){this.$.clear(),this.Z=b?.id;let l;if(b){const $=this.$.add(new S.$WDb(this.db.getChannel("storage"),b));l=this.$.add(new O.$6o($)),this.$.add(l.onDidChangeStorage(y=>this.u(1,y)))}return l}async O(){await I.Promises.settled([this.U.init(),this.Y.init(),this.ab?.init()??Promise.resolve()])}P(b){switch(b){case-1:return this.U;case 0:return this.Y;default:return this.ab}}Q(b){switch(b){case-1:return this.s.globalStorageHome.with({scheme:j.Schemas.file}).fsPath;case 0:return this.W?.globalStorageHome.with({scheme:j.Schemas.file}).fsPath;default:return this.Z?`${(0,L.$wg)(this.eb.workspaceStorageHome,this.Z,"state.vscdb").with({scheme:j.Schemas.file}).fsPath}`:void 0}}async close(){this.t(),this.w(R.WillSaveStateReason.SHUTDOWN),await I.Promises.settled([this.U.close(),this.Y.close(),this.ab?.close()??Promise.resolve()])}async R(b){if(!this.M(this.W,b))return;const l=this.Y,$=l.items;l!==this.U&&await l.close(),this.Y=this.gb(b),await this.Y.init(),this.N($,this.Y,0)}async S(b,l){const $=this.ab,y=$?.items??new Map;await $?.close(),this.ab=this.hb(b),await this.ab.init(),this.N(y,this.ab,1)}hasScope(b){return(0,d.$Nk)(b)?this.W.id===b.id:this.Z===b.id}}e.$a0b=P}),define(ae[250],ce([0,1,3,2,17,92]),function(ie,e,I,N,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2N=e.$1N=void 0;class O{constructor(d,P){this.a=d,this.b=P}listen(d,P){const E=this.b(d);switch(P){case"onDidChangeProfiles":return I.Event.map(this.a.onDidChangeProfiles,b=>({all:b.all.map(l=>(0,L.$Rm)({...l},E)),added:b.added.map(l=>(0,L.$Rm)({...l},E)),removed:b.removed.map(l=>(0,L.$Rm)({...l},E)),updated:b.updated.map(l=>(0,L.$Rm)({...l},E))}))}throw new Error(`Invalid listen ${P}`)}async call(d,P,E){const b=this.b(d);switch(P){case"createProfile":{const l=await this.a.createProfile(E[0],E[1],E[2]);return(0,L.$Rm)({...l},b)}case"updateProfile":{let l=(0,j.$Pk)((0,L.$Sm)(E[0],b),this.a.profilesHome.scheme);return l=await this.a.updateProfile(l,E[1]),(0,L.$Rm)({...l},b)}case"removeProfile":{const l=(0,j.$Pk)((0,L.$Sm)(E[0],b),this.a.profilesHome.scheme);return this.a.removeProfile(l)}}throw new Error(`Invalid call ${P}`)}}e.$1N=O;class R extends N.$Rc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(d,P,E){super(),this.profilesHome=P,this.f=E,this.a=[],this.b=this.B(new I.$Od),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=d.map(b=>(0,j.$Pk)(b,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(b=>{const l=b.added.map(w=>(0,j.$Pk)(w,this.profilesHome.scheme)),$=b.removed.map(w=>(0,j.$Pk)(w,this.profilesHome.scheme)),y=b.updated.map(w=>(0,j.$Pk)(w,this.profilesHome.scheme));this.a=b.all.map(w=>(0,j.$Pk)(w,this.profilesHome.scheme)),this.b.fire({added:l,removed:$,updated:y,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(d){this.c=d}isEnabled(){return this.c}async createNamedProfile(d,P,E){const b=await this.f.call("createNamedProfile",[d,P,E]);return(0,j.$Pk)(b,this.profilesHome.scheme)}async createProfile(d,P,E,b){const l=await this.f.call("createProfile",[d,P,E,b]);return(0,j.$Pk)(l,this.profilesHome.scheme)}async createTransientProfile(d){const P=await this.f.call("createTransientProfile",[d]);return(0,j.$Pk)(P,this.profilesHome.scheme)}async setProfileForWorkspace(d,P){await this.f.call("setProfileForWorkspace",[d,P])}removeProfile(d){return this.f.call("removeProfile",[d])}async updateProfile(d,P){const E=await this.f.call("updateProfile",[d,P]);return(0,j.$Pk)(E,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$2N=R}),define(ae[59],ce([0,1,2,68,4,21,3,76,17]),function(ie,e,I,N,j,L,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1Db=e.$ZDb=e.$YDb=void 0,e.$YDb=(0,j.$Th)("IUserDataProfileStorageService");let d=class extends I.$Rc{constructor(l){super(),this.a=l}async readStorageData(l){return this.withProfileScopedStorageService(l,async $=>this.b($))}async updateStorageData(l,$,y){return this.withProfileScopedStorageService(l,async w=>this.c(w,$,y))}async withProfileScopedStorageService(l,$){if(this.a.hasScope(l))return $(this.a);const y=await this.g(l),w=new E(y);try{await w.initialize();const c=await $(w);return await w.flush(),c}finally{w.dispose(),await this.f(y)}}b(l){const $=new Map,y=w=>{for(const c of l.keys(0,w))$.set(c,{value:l.get(c,0),target:w})};return y(0),y(1),$}c(l,$,y){l.storeAll(Array.from($.entries()).map(([w,c])=>({key:w,value:c,scope:0,target:y})),!0)}async f(l){try{await l.close()}finally{(0,I.$Lc)(l)&&l.dispose()}}};e.$ZDb=d,e.$ZDb=d=pe([X(0,L.$0o)],d);class P extends d{constructor(l,$,y,w){super(y),this.j=l;const c=l.getChannel("profileStorageListener"),u=this.B(new I.$Sc);this.h=this.B(new O.$Od({onWillAddFirstListener:()=>{u.value=c.listen("onDidChange")(f=>{w.trace("profile storage changes",f),this.h.fire({targetChanges:f.targetChanges.map(m=>(0,S.$Pk)(m,$.profilesHome.scheme)),valueChanges:f.valueChanges.map(m=>({...m,profile:(0,S.$Pk)(m.profile,$.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>u.value=void 0})),this.onDidChange=this.h.event}async g(l){const $=this.j.getChannel("storage");return(0,L.$ap)(l)?new R.$UDb($):new R.$VDb($,l)}}e.$1Db=P;class E extends L.$_o{constructor(l){super({flushInterval:100}),this.s=this.B(new N.$6o(l))}O(){return this.s.init()}P(l){return l===0?this.s:void 0}Q(){}async R(){}async S(){}hasScope(){return!1}}}),define(ae[251],ce([0,1,21,8,17,55,59]),function(ie,e,I,N,j,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R9b=void 0;let R=class extends O.$1Db{constructor(d,P,E,b){super(d,P,E,b)}};e.$R9b=R,e.$R9b=R=pe([X(0,L.$d9b),X(1,j.$Ok),X(2,I.$0o),X(3,N.$bj)],R)}),define(ae[39],ce([0,1,18,6,15,26,3,35,2,27,12,169,20,14,11,8,43,21,22,28,24,17]),function(ie,e,I,N,j,L,O,R,S,d,P,E,b,l,$,y,w,c,u,f,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SEb=e.$REb=e.$QEb=e.$PEb=e.$OEb=e.$NEb=e.$MEb=void 0;function s(v){return!!(v&&v.ref!==void 0&&typeof v.ref=="string"&&v.ref!==""&&v.syncData!==void 0&&(v.syncData===null||a(v.syncData)))}e.$MEb=s;function a(v){return!!(v&&v.version!==void 0&&typeof v.version=="number"&&v.content!==void 0&&typeof v.content=="string"&&(Object.keys(v).length===2||Object.keys(v).length===3&&v.machineId!==void 0&&typeof v.machineId=="string"))}e.$NEb=a;function n(v,p){return`${(0,d.$rf)(v)}${p.isDefault?"":` (${p.name})`}`}e.$OEb=n;let i=class extends S.$Rc{get status(){return this.m}get conflicts(){return{...this.syncResource,conflicts:this.s}}constructor(p,h,g,D,T,M,z,B,Z,K,x,H){super(),this.syncResource=p,this.collection=h,this.G=g,this.H=D,this.I=T,this.J=M,this.L=z,this.M=B,this.N=Z,this.O=K,this.P=x,this.c=null,this.m="idle",this.n=this.B(new O.$Od),this.onDidChangeStatus=this.n.event,this.s=[],this.t=this.B(new O.$Od),this.onDidChangeConflicts=this.t.event,this.u=this.B(new N.$Sg(50)),this.w=this.B(new O.$Od),this.onDidChangeLocal=this.w.event,this.z=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.C=!1,this.F={},this.resource=this.syncResource.syncResource,this.D=n(p.syncResource,p.profile),this.h=H.extUri,this.f=this.h.joinPath(D.userDataSyncHome,...(0,m.$bhb)(p.profile.isDefault?void 0:p.profile.id,p.syncResource)),this.g=this.h.joinPath(this.f,m.$whb),this.y=(0,m.$chb)(p.profile.isDefault?void 0:p.profile.id,p.syncResource,D,this.h),this.j=(0,w.$dp)(D,g,T)}Q(){this.u.trigger(()=>this.R())}async R(){if(this.status==="hasConflicts"){this.O.info(`${this.D}: In conflicts state and local change detected. Syncing again...`);const p=await this.c;this.c=null;const h=await this.Y(p.remoteUserData,p.lastSyncUserData,!0,this.ob());this.S(h)}else{this.O.trace(`${this.D}: Checking for local changes...`);const p=await this.getLastSyncUserData();(p?await this.ub(p):!0)&&this.w.fire()}}S(p){this.m!==p&&(this.m=p,this.n.fire(p))}async sync(p,h={}){await this.U(p,!0,this.ob(),h)}async preview(p,h,g={}){return this.U(p,!1,h,g)}async apply(p,h={}){try{this.F={...h};const g=await this.ab(p);return this.S(g),this.c}finally{this.F={}}}async U(p,h,g,D){try{if(this.F={...D},this.status==="hasConflicts")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.O.trace(`${this.D}: Started synchronizing ${this.resource.toLowerCase()}...`),this.S("syncing");let T="idle";try{const M=await this.getLastSyncUserData(),z=await this.X(p,M);return T=await this.Y(z,M,h,g),T==="hasConflicts"?this.O.info(`${this.D}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):T==="idle"&&this.O.trace(`${this.D}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.S(T)}}finally{this.F={}}}async replace(p){const h=this.kb(p);if(!h)return!1;await this.stop();try{this.O.trace(`${this.D}: Started resetting ${this.resource.toLowerCase()}...`),this.S("syncing");const g=await this.getLastSyncUserData(),D=await this.X(null,g),T=await this.W(D),M=await this.qb({ref:D.ref,syncData:h},g,T,this.ob(),L.CancellationToken.None),z=[];for(const B of M){const Z=await this.sb(B,B.remoteResource,void 0,L.CancellationToken.None),{remoteChange:K}=await this.sb(B,B.previewResource,B.remoteContent,L.CancellationToken.None);z.push([B,{...Z,remoteChange:K!==0?K:2}])}await this.tb(D,g,z,!1),this.O.info(`${this.D}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.S("idle")}return!0}async W(p){const h=await this.j;return!!p.syncData?.machineId&&p.syncData.machineId===h}async X(p,h){if(h){const g=p?p[this.resource]:void 0;if(h.ref===g||g===void 0&&h.syncData===null)return h}return this.getRemoteUserData(h)}async Y(p,h,g,D){if(p.syncData&&p.syncData.version>this.pb)throw this.N.publicLog2("sync/incompatible",{source:this.resource}),new m.$jhb((0,E.localize)(0,null,this.resource,this.pb,p.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.Z(p,h,g,D)}catch(T){if(T instanceof m.$jhb)switch(T.code){case"LocalPreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize ${this.D} as there is a new local version available. Synchronizing again...`),this.Y(p,h,g,D);case"Conflict":case"PreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),p=await this.getRemoteUserData(null),h=await this.getLastSyncUserData(),this.Y(p,h,g,D)}throw T}}async Z(p,h,g,D){try{const T=await this.W(p),M=!T&&h===null&&this.gb()!==void 0,z=g&&!M;this.c||(this.c=(0,N.$Ig)(Z=>this.eb(p,h,T,z,D,Z)));let B=await this.c;if(g&&M){this.O.info(`${this.D}: Accepting remote because it was synced before and the last sync data is not available.`);for(const Z of B.resourcePreviews)B=await this.accept(Z.remoteResource)||B}return this.cb(B.resourcePreviews),B.resourcePreviews.some(({mergeState:Z})=>Z==="conflict")?"hasConflicts":g?await this.ab(!1):"syncing"}catch(T){throw this.c=null,T}}async merge(p){return await this.$(p,async h=>{const g=await this.rb(h,L.CancellationToken.None);await this.G.writeFile(h.previewResource,j.$ce.fromString(g?.content||""));const D=g&&!g.hasConflicts?await this.sb(h,h.previewResource,void 0,L.CancellationToken.None):void 0;return h.acceptResult=D,h.mergeState=g.hasConflicts?"conflict":D?"accepted":"preview",h.localChange=D?D.localChange:g.localChange,h.remoteChange=D?D.remoteChange:g.remoteChange,h}),this.c}async accept(p,h){return await this.$(p,async g=>{const D=await this.sb(g,p,h,L.CancellationToken.None);return g.acceptResult=D,g.mergeState="accepted",g.localChange=D.localChange,g.remoteChange=D.remoteChange,g}),this.c}async discard(p){return await this.$(p,async h=>{const g=await this.rb(h,L.CancellationToken.None);return await this.G.writeFile(h.previewResource,j.$ce.fromString(g.content||"")),h.acceptResult=void 0,h.mergeState="preview",h.localChange=g.localChange,h.remoteChange=g.remoteChange,h}),this.c}async $(p,h){if(!this.c)return;let g=await this.c;const D=g.resourcePreviews.findIndex(({localResource:T,remoteResource:M,previewResource:z})=>this.h.isEqual(T,p)||this.h.isEqual(M,p)||this.h.isEqual(z,p));D!==-1&&(this.c=(0,N.$Ig)(async T=>{const M=[...g.resourcePreviews];return M[D]=await h(M[D]),{...g,resourcePreviews:M}}),g=await this.c,this.cb(g.resourcePreviews),g.resourcePreviews.some(({mergeState:T})=>T==="conflict")?this.S("hasConflicts"):this.S("syncing"))}async ab(p){if(!this.c)return"idle";const h=await this.c;return h.resourcePreviews.some(({mergeState:g})=>g==="conflict")?"hasConflicts":h.resourcePreviews.some(({mergeState:g})=>g!=="accepted")?"syncing":(await this.tb(h.remoteUserData,h.lastSyncUserData,h.resourcePreviews.map(g=>[g,g.acceptResult]),p),this.c=null,await this.bb(),"idle")}async bb(){try{await this.G.del(this.g,{recursive:!0})}catch{}}cb(p){const h=p.filter(({mergeState:g})=>g==="conflict");(0,I.$tb)(this.s,h,(g,D)=>this.h.isEqual(g.previewResource,D.previewResource))||(this.s=h,this.t.fire(this.conflicts))}async hasPreviouslySynced(){const p=await this.getLastSyncUserData();return!!p&&p.syncData!==null}async db(p){const h=this.c?await this.c:null;if(h)for(const g of h.resourcePreviews){if(this.h.isEqual(g.acceptedResource,p))return g.acceptResult?g.acceptResult.content:null;if(this.h.isEqual(g.remoteResource,p))return g.remoteContent;if(this.h.isEqual(g.localResource,p))return g.localContent;if(this.h.isEqual(g.baseResource,p))return g.baseContent}return null}async resetLocal(){this.I.remove(this.z,-1);try{await this.G.del(this.y)}catch(p){(0,$.$tk)(p)!==1&&this.O.error(p)}}async eb(p,h,g,D,T,M){const z=await this.qb(p,h,g,T,M),B=[];for(const Z of z){const K=Z.previewResource.with({scheme:m.$vhb,authority:"accepted"});if(Z.localChange===0&&Z.remoteChange===0)B.push({...Z,acceptedResource:K,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const x=D?await this.rb(Z,M):void 0;if(M.isCancellationRequested)break;await this.G.writeFile(Z.previewResource,j.$ce.fromString(x?.content||""));const H=x&&!x.hasConflicts?await this.sb(Z,Z.previewResource,void 0,M):void 0;B.push({...Z,acceptResult:H,mergeState:x?.hasConflicts?"conflict":H?"accepted":"preview",localChange:H?H.localChange:x?x.localChange:Z.localChange,remoteChange:H?H.remoteChange:x?x.remoteChange:Z.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:p,lastSyncUserData:h,resourcePreviews:B,isLastSyncFromCurrentMachine:g}}async getLastSyncUserData(){let p=this.gb();if(p||(p=await this.jb()),!p)return this.O.info(`${this.D}: Last sync data state does not exist.`),null;const h=JSON.parse(p),g=this.M.getResourceSyncStateVersion(this.resource);if(this.C=!!h.version&&!!g&&h.version!==g,this.C)return this.O.info(`${this.D}: Reset last sync state because last sync state version ${h.version} is not compatible with current sync state version ${g}.`),await this.resetLocal(),null;let D,T=1;for(;D===void 0&&T++<6;)try{const M=await this.hb();M&&(M.ref===h.ref?D=M.syncData:this.O.info(`${this.D}: Last sync data stored locally is not same as the last sync state.`));break}catch(M){if(M instanceof $.$xk&&M.fileOperationResult===1){this.O.info(`${this.D}: Last sync resource does not exist locally.`);break}else{if(M instanceof m.$jhb)throw M;this.O.error(M,T)}}if(D===void 0)try{const M=await this.J.resolveResourceContent(this.resource,h.ref,this.collection,this.F);D=M===null?null:this.kb(M),await this.ib({ref:h.ref,syncData:D})}catch(M){if(M instanceof m.$jhb&&M.code==="NotFound")this.O.info(`${this.D}: Last sync resource does not exist remotely.`);else throw M}return D===void 0?null:{...h,syncData:D}}async fb(p,h={}){if(h.ref||h.version)throw new Error("Cannot have core properties as additional");const g=this.M.getResourceSyncStateVersion(this.resource),D={ref:p.ref,version:g,...h};this.I.store(this.z,JSON.stringify(D),-1,1),await this.ib(p)}gb(){return this.I.get(this.z,-1)}async hb(){const p=(await this.G.readFile(this.y)).value.toString();try{const h=p?JSON.parse(p):void 0;if(s(h))return h}catch(h){this.O.error(h)}}async ib(p){await this.G.writeFile(this.y,j.$ce.fromString(JSON.stringify(p)))}async jb(){try{const p=await this.G.readFile(this.y),h=JSON.parse(p.value.toString());await this.G.del(this.y),h.ref&&h.content!==void 0?(this.I.store(this.z,JSON.stringify({...h,content:void 0}),-1,1),await this.ib({ref:h.ref,syncData:h.content===null?null:JSON.parse(h.content)})):this.O.info(`${this.D}: Migrating last sync user data. Invalid data.`,h)}catch(p){p instanceof $.$xk&&p.fileOperationResult===1?this.O.info(`${this.D}: Migrating last sync user data. Resource does not exist.`):this.O.error(p)}return this.I.get(this.z,-1)}async getRemoteUserData(p){const{ref:h,content:g}=await this.lb(p);let D=null;return g!==null&&(D=this.kb(g)),{ref:h,syncData:D}}kb(p){try{const h=JSON.parse(p);if(a(h))return h}catch(h){this.O.error(h)}throw new m.$jhb((0,E.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async lb(p){const h=p?{ref:p.ref,content:p.syncData?JSON.stringify(p.syncData):null}:null;return this.J.readResource(this.resource,h,this.collection,this.F)}async mb(p,h){const g=await this.j,D={version:this.pb,machineId:g,content:p};try{return h=await this.J.writeResource(this.resource,JSON.stringify(D),h,this.collection,this.F),{ref:h,syncData:D}}catch(T){throw T instanceof m.$jhb&&T.code==="TooLarge"&&(T=new m.$jhb(T.message,T.code,this.resource)),T}}async nb(p){const h={version:this.pb,content:p};return this.L.writeResource(this.resource,JSON.stringify(h),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!=="idle"&&(this.O.trace(`${this.D}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.cb([]),await this.bb(),this.S("idle"),this.O.info(`${this.D}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}ob(){return this.P.getValue(m.$9gb)}};e.$PEb=i,e.$PEb=i=pe([X(2,$.$ck),X(3,l.$1h),X(4,c.$0o),X(5,m.$ehb),X(6,m.$fhb),X(7,m.$ohb),X(8,u.$gl),X(9,m.$thb),X(10,b.$ni),X(11,f.$Mk)],i);let t=class extends i{constructor(p,h,g,D,T,M,z,B,Z,K,x,H,Y){super(h,g,D,T,M,z,B,Z,K,x,H,Y),this.r=p,this.B(this.G.watch(this.h.dirname(p))),this.B(this.G.onDidFilesChange(G=>this.yb(G)))}async vb(){try{return await this.G.readFile(this.r)}catch{return null}}async wb(p,h,g){try{h?await this.G.writeFile(this.r,j.$ce.fromString(p),g?void 0:h):await this.G.createFile(this.r,j.$ce.fromString(p),{overwrite:g})}catch(D){throw D instanceof $.$xk&&D.fileOperationResult===1||D instanceof $.$xk&&D.fileOperationResult===3?new m.$jhb(D.message,"LocalPreconditionFailed"):D}}async xb(){try{await this.G.del(this.r)}catch(p){if(!(p instanceof $.$xk&&p.fileOperationResult===1))throw p}}yb(p){p.contains(this.r)&&this.Q()}};e.$QEb=t,e.$QEb=t=pe([X(3,$.$ck),X(4,l.$1h),X(5,c.$0o),X(6,m.$ehb),X(7,m.$fhb),X(8,m.$ohb),X(9,u.$gl),X(10,m.$thb),X(11,b.$ni),X(12,f.$Mk)],t);let r=class extends t{constructor(p,h,g,D,T,M,z,B,Z,K,x,H,Y,G){super(p,h,g,D,T,M,z,B,Z,K,x,Y,G),this.zb=H,this.Bb=void 0}Ab(p,h){const g=[],D=(0,R.$1m)(p,g,{allowEmptyContent:!0,allowTrailingComma:!0});return g.length>0||!(0,P.$Gf)(D)&&h!==Array.isArray(D)}Cb(){return this.Bb||(this.Bb=this.zb.resolveFormattingOptions(this.r)),this.Bb}};e.$REb=r,e.$REb=r=pe([X(3,$.$ck),X(4,l.$1h),X(5,c.$0o),X(6,m.$ehb),X(7,m.$fhb),X(8,m.$ohb),X(9,u.$gl),X(10,m.$thb),X(11,m.$shb),X(12,b.$ni),X(13,f.$Mk)],r);let o=class{constructor(p,h,g,D,T,M,z){this.resource=p,this.g=h,this.h=g,this.j=D,this.k=T,this.l=M,this.d=z.extUri,this.f=(0,m.$chb)(void 0,this.resource,g,this.d)}async initialize({ref:p,content:h}){if(!h){this.j.info("Remote content does not exist.",this.resource);return}const g=this.m(h);if(g)try{await this.o({ref:p,syncData:g})}catch(D){this.j.error(D)}}m(p){try{const h=JSON.parse(p);if(a(h))return h}catch(h){this.j.error(h)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(p,h={}){if(h.ref||h.version)throw new Error("Cannot have core properties as additional");const g={ref:p.ref,version:void 0,...h};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(g),-1,1),await this.k.writeFile(this.f,j.$ce.fromString(JSON.stringify(p)))}};e.$SEb=o,e.$SEb=o=pe([X(1,k.$Ok),X(2,l.$1h),X(3,y.$bj),X(4,$.$ck),X(5,c.$0o),X(6,f.$Mk)],o)}),define(ae[114],ce([0,1,6,26,7,3,42,2,27,20,14,113,29,33,81,44,11,4,72,8,21,22,28,17,39,232,111,24,59]),function(ie,e,I,N,j,L,O,R,S,d,P,E,b,l,$,y,w,c,u,f,m,k,s,a,n,i,t,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w4b=e.$v4b=e.$u4b=e.$t4b=e.$s4b=void 0;async function v(M,z){const B=JSON.parse(M.content);if(M.version===1||M.version===2){const Z=(await z.getInstalled(0)).filter(K=>K.isBuiltin);for(const K of B)M.version===1&&(K.enabled===!1&&(K.disabled=!0),delete K.enabled),M.version===2&&Z.every(x=>!(0,l.$Do)(x.identifier,K.identifier))&&(K.installed=!0)}return B}function p(M){return JSON.parse(M.content)}e.$s4b=p;function h(M,z){return M.sort((B,Z)=>!B.identifier.uuid&&Z.identifier.uuid?-1:B.identifier.uuid&&!Z.identifier.uuid?1:(0,S.$Ve)(B.identifier.id,Z.identifier.id)),z?(0,O.$lT)(M,{}):JSON.stringify(M)}e.$t4b=h;let g=class extends n.$PEb{constructor(z,B,Z,K,x,H,Y,G,V,ee,ne,_,re,Q,q,C,A){super({syncResource:"extensions",profile:z},B,K,Z,x,H,Y,_,re,ee,ne,q),this.Cb=G,this.Db=V,this.Eb=A,this.pb=6,this.wb=this.h.joinPath(this.g,"extensions.json"),this.xb=this.wb.with({scheme:r.$vhb,authority:"base"}),this.yb=this.wb.with({scheme:r.$vhb,authority:"local"}),this.zb=this.wb.with({scheme:r.$vhb,authority:"remote"}),this.Ab=this.wb.with({scheme:r.$vhb,authority:"accepted"}),this.Bb=this.Eb.createInstance(D),this.B(L.Event.any(L.Event.filter(this.Cb.onDidInstallExtensions,J=>J.some(({local:F})=>!!F)),L.Event.filter(this.Cb.onDidUninstallExtension,J=>!J.error),L.Event.filter(C.onDidChange,J=>J.valueChanges.some(({profile:F,changes:U})=>this.syncResource.profile.id===F.id&&U.some(W=>W.key===b.$eo))),Q.onDidChangeExtensionStorageToSync)(()=>this.Q()))}async qb(z,B){const Z=z.syncData?await v(z.syncData,this.Cb):null,K=B?.skippedExtensions??[],x=B?.builtinExtensions??null,H=B?.syncData?await v(B.syncData,this.Cb):null,{localExtensions:Y,ignoredExtensions:G}=await this.Bb.getLocalExtensions(this.syncResource.profile);Z?this.O.trace(`${this.D}: Merging remote extensions with local extensions...`):this.O.trace(`${this.D}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:V,remote:ee}=(0,i.$r4b)(Y,Z,H,K,G,x),ne={local:V,remote:ee,content:this.Hb(Y,V.added,V.updated,V.removed),localChange:V.added.length>0||V.removed.length>0||V.updated.length>0?2:0,remoteChange:ee!==null?2:0},_=this.Ob(Y,!1);return[{skippedExtensions:K,builtinExtensions:x,baseResource:this.xb,baseContent:H?this.Ob(H,!1):_,localResource:this.yb,localContent:_,localExtensions:Y,remoteResource:this.zb,remoteExtensions:Z,remoteContent:Z?this.Ob(Z,!1):null,previewResource:this.wb,previewResult:ne,localChange:ne.localChange,remoteChange:ne.remoteChange,acceptedResource:this.Ab}]}async ub(z){const B=z.syncData?await v(z.syncData,this.Cb):null,{localExtensions:Z,ignoredExtensions:K}=await this.Bb.getLocalExtensions(this.syncResource.profile),{remote:x}=(0,i.$r4b)(Z,B,B,z.skippedExtensions||[],K,z.builtinExtensions||[]);return x!==null}Hb(z,B,Z,K){const x=[...B,...Z],H=new Set,Y=G=>{H.add(G.id.toLowerCase()),G.uuid&&H.add(G.uuid)};x.forEach(({identifier:G})=>Y(G)),K.forEach(Y);for(const G of z)H.has(G.identifier.id.toLowerCase())||G.identifier.uuid&&H.has(G.identifier.uuid)||x.push(G);return this.Ob(x,!1)}async rb(z,B){return{...z.previewResult,hasConflicts:!1}}async sb(z,B,Z,K){if(this.h.isEqual(B,this.yb))return this.Kb(z);if(this.h.isEqual(B,this.zb))return this.Lb(z);if(this.h.isEqual(B,this.wb))return z.previewResult;throw new Error(`Invalid Resource: ${B.toString()}`)}async Kb(z){const B=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Z=this.Db.getIgnoredExtensions(B),K=(0,i.$r4b)(z.localExtensions,null,null,z.skippedExtensions,Z,z.builtinExtensions),{local:x,remote:H}=K;return{content:z.localContent,local:x,remote:H,localChange:x.added.length>0||x.removed.length>0||x.updated.length>0?2:0,remoteChange:H!==null?2:0}}async Lb(z){const B=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Z=this.Db.getIgnoredExtensions(B),K=z.remoteContent?JSON.parse(z.remoteContent):null;if(K!==null){const x=(0,i.$r4b)(z.localExtensions,K,z.localExtensions,[],Z,z.builtinExtensions),{local:H,remote:Y}=x;return{content:z.remoteContent,local:H,remote:Y,localChange:H.added.length>0||H.removed.length>0||H.updated.length>0?2:0,remoteChange:Y!==null?2:0}}else return{content:z.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(z,B,Z,K){let{skippedExtensions:x,builtinExtensions:H,localExtensions:Y}=Z[0][0];const{local:G,remote:V,localChange:ee,remoteChange:ne}=Z[0][1];if(ee===0&&ne===0&&this.O.info(`${this.D}: No changes found during synchronizing extensions.`),ee!==0&&(await this.nb(JSON.stringify(Y)),x=await this.Bb.updateLocalExtensions(G.added,G.removed,G.updated,x,this.syncResource.profile)),V){this.O.trace(`${this.D}: Updating remote extensions...`);const _=JSON.stringify(V.all);z=await this.mb(_,K?null:z.ref),this.O.info(`${this.D}: Updated remote extensions.${V.added.length?` Added: ${JSON.stringify(V.added.map(re=>re.identifier.id))}.`:""}${V.updated.length?` Updated: ${JSON.stringify(V.updated.map(re=>re.identifier.id))}.`:""}${V.removed.length?` Removed: ${JSON.stringify(V.removed.map(re=>re.identifier.id))}.`:""}`)}B?.ref!==z.ref&&(this.O.trace(`${this.D}: Updating last synchronized extensions...`),H=this.Nb(Y,H),await this.fb(z,{skippedExtensions:x,builtinExtensions:H}),this.O.info(`${this.D}: Updated last synchronized extensions.${x.length?` Skipped: ${JSON.stringify(x.map(_=>_.identifier.id))}.`:""}`))}Nb(z,B){const Z=new Set,K=[];for(const x of z)Z.add(x.identifier.id.toLowerCase()),x.installed||K.push(x.identifier);if(B)for(const x of B)Z.has(x.id.toLowerCase())||K.push(x);return K}async resolveContent(z){if(this.h.isEqual(this.zb,z)||this.h.isEqual(this.xb,z)||this.h.isEqual(this.yb,z)||this.h.isEqual(this.Ab,z)){const B=await this.db(z);return B&&this.Ob(JSON.parse(B),!0)}return null}Ob(z,B){return h(z,B)}async hasLocalData(){try{const{localExtensions:z}=await this.Bb.getLocalExtensions(this.syncResource.profile);if(z.some(B=>B.installed||B.disabled))return!0}catch{}return!1}};e.$u4b=g,e.$u4b=g=pe([X(2,P.$1h),X(3,w.$ck),X(4,m.$0o),X(5,r.$ehb),X(6,r.$fhb),X(7,b.$do),X(8,t.$xFb),X(9,r.$thb),X(10,d.$ni),X(11,r.$ohb),X(12,k.$gl),X(13,$.$1u),X(14,s.$Mk),X(15,o.$YDb),X(16,c.$Sh)],g);let D=class{constructor(z,B,Z,K,x,H){this.a=z,this.b=B,this.c=Z,this.d=K,this.f=x,this.g=H}async getLocalExtensions(z){const B=await this.a.getInstalled(void 0,z.extensionsResource),Z=this.d.getIgnoredExtensions(B);return{localExtensions:await this.j(z,async(x,H)=>{const Y=x.getDisabledExtensions();return B.map(G=>{const{identifier:V,isBuiltin:ee,manifest:ne,preRelease:_,pinned:re,isApplicationScoped:Q}=G,q={identifier:V,preRelease:_,version:ne.version,pinned:!!re};Q&&!(0,y.$am)(ne)&&(q.isApplicationScoped=Q),Y.some(C=>(0,l.$Do)(C,V))&&(q.disabled=!0),ee||(q.installed=!0);try{const C=H.getKeysForSync({id:V.id,version:ne.version});if(C){const A=H.getExtensionState(G,!0)||{};q.state=Object.keys(A).reduce((J,F)=>(C.includes(F)&&(J[F]=A[F]),J),{})}}catch(C){this.g.info(`${(0,n.$OEb)("extensions",z)}: Error while parsing extension state`,(0,j.$9)(C))}return q})}),ignoredExtensions:Z}}async updateLocalExtensions(z,B,Z,K,x){const H=(0,n.$OEb)("extensions",x),Y=[],G=new Map,V=[],ee=[],ne=await this.a.getInstalled(void 0,x.extensionsResource);if((z.length||Z.length)&&await this.j(x,async(Q,q)=>{await I.Promises.settled([...z,...Z].map(async C=>{const A=ne.find(U=>(0,l.$Do)(U.identifier,C.identifier));if(A&&A.isBuiltin){C.state&&A.manifest.version===C.version&&this.h(C.state,A,A.manifest.version,q),Q.getDisabledExtensions().some(W=>(0,l.$Do)(W,C.identifier))!==!!C.disabled&&(C.disabled?(this.g.trace(`${H}: Disabling extension...`,C.identifier.id),await Q.disableExtension(C.identifier),this.g.info(`${H}: Disabled extension`,C.identifier.id)):(this.g.trace(`${H}: Enabling extension...`,C.identifier.id),await Q.enableExtension(C.identifier),this.g.info(`${H}: Enabled extension`,C.identifier.id))),V.push(C.identifier);return}const J=C.pinned?C.version:void 0,F=(await this.c.getExtensions([{...C.identifier,version:J,preRelease:J?void 0:C.preRelease}],N.CancellationToken.None))[0];if(C.state&&(A?A.manifest.version===C.version:F)&&this.h(C.state,A||F,A?.manifest.version,q),F)try{Q.getDisabledExtensions().some(W=>(0,l.$Do)(W,C.identifier))!==!!C.disabled&&(C.disabled?(this.g.trace(`${H}: Disabling extension...`,C.identifier.id,F.version),await Q.disableExtension(F.identifier),this.g.info(`${H}: Disabled extension`,C.identifier.id,F.version)):(this.g.trace(`${H}: Enabling extension...`,C.identifier.id,F.version),await Q.enableExtension(F.identifier),this.g.info(`${H}: Enabled extension`,C.identifier.id,F.version))),(!A||A.preRelease!==C.preRelease||A.pinned!==C.pinned||J&&A.manifest.version!==J)&&(await this.a.canInstall(F)?(Y.push({extension:F,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:C.pinned&&!!C.version,installPreReleaseVersion:C.preRelease,profileLocation:x.extensionsResource,isApplicationScoped:C.isApplicationScoped,context:{[b.$5n]:!0,[b.$6n]:!0}}}),G.set(F.identifier.id.toLowerCase(),C)):(this.g.info(`${H}: Skipped synchronizing extension because it cannot be installed.`,F.displayName||F.identifier.id),ee.push(C)))}catch(U){ee.push(C),this.g.error(U),this.g.info(`${H}: Skipped synchronizing extension`,F.displayName||F.identifier.id)}else ee.push(C),this.g.info(`${H}: Skipped synchronizing extension because the extension is not found.`,C.identifier.id)}))}),B.length){const Q=ne.filter(({identifier:q,isBuiltin:C})=>!C&&B.some(A=>(0,l.$Do)(q,A)));await I.Promises.settled(Q.map(async q=>{this.g.trace(`${H}: Uninstalling local extension...`,q.identifier.id),await this.a.uninstall(q,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:x.extensionsResource}),this.g.info(`${H}: Uninstalled local extension.`,q.identifier.id),V.push(q.identifier)}))}const _=await this.a.installGalleryExtensions(Y);for(const{identifier:Q,local:q,error:C,source:A}of _){const J=A;if(q)this.g.info(`${H}: Installed extension.`,Q.id,J.version),V.push(Q);else{const F=G.get(Q.id.toLowerCase());F&&(ee.push(F),this.g.info(`${H}: Skipped synchronizing extension`,J.displayName||J.identifier.id)),C instanceof b.$co&&[b.ExtensionManagementErrorCode.Incompatible,b.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(C.code)?this.g.info(`${H}: Skipped synchronizing extension because the compatible extension is not found.`,J.displayName||J.identifier.id):C&&this.g.error(C)}}const re=[];for(const Q of K)V.some(q=>(0,l.$Do)(q,Q.identifier))||re.push(Q);for(const Q of ee)re.some(q=>(0,l.$Do)(q.identifier,Q.identifier))||re.push(Q);return re}h(z,B,Z,K){const x=K.getExtensionState(B,!0)||{},H=Z?K.getKeysForSync({id:B.identifier.id,version:Z}):void 0;H?H.forEach(Y=>{x[Y]=z[Y]}):Object.keys(z).forEach(Y=>x[Y]=z[Y]),K.setExtensionState(B,x,!0)}async j(z,B){return this.b.withProfileScopedStorageService(z,async Z=>{const K=new R.$Qc,x=this.f.createChild(new u.$Rh([m.$0o,Z])),H=K.add(x.createInstance(E.$kDb)),Y=K.add(x.createInstance($.$2u));try{return await B(H,Y)}finally{K.dispose()}})}};e.$v4b=D,e.$v4b=D=pe([X(0,b.$do),X(1,o.$YDb),X(2,b.$bo),X(3,t.$xFb),X(4,c.$Sh),X(5,r.$thb)],D);let T=class extends n.$SEb{constructor(z,B,Z,K,x,H,Y,G){super("extensions",K,x,H,Z,Y,G),this.p=z,this.q=B}async t(z){return z.syncData?await v(z.syncData,this.p):null}u(z,B){const Z=[],K=[],x=[];for(const H of z){if(this.q.hasToNeverSyncExtension(H.identifier.id))continue;const Y=B.find(G=>(0,l.$Do)(G.identifier,H.identifier));Y?(Z.push(Y),H.disabled&&x.push(H.identifier)):H.installed&&(K.push({...H.identifier,preRelease:!!H.preRelease}),H.disabled&&x.push(H.identifier))}return{installedExtensions:Z,newExtensions:K,disabledExtensions:x,remoteExtensions:z}}};e.$w4b=T,e.$w4b=T=pe([X(0,b.$do),X(1,t.$xFb),X(2,w.$ck),X(3,a.$Ok),X(4,P.$1h),X(5,f.$bj),X(6,m.$0o),X(7,s.$Mk)],T)}),define(ae[115],ce([0,1,15,7,3,35,42,5,32,20,14,11,8,43,21,22,28,39,78,236,24,17,59,4]),function(ie,e,I,N,j,L,O,R,S,d,P,E,b,l,$,y,w,c,u,f,m,k,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YEb=e.$XEb=e.$WEb=e.$VEb=e.$UEb=void 0;const n="globalState.argv.",i=["locale"];function t(g,D){const T=g.storage?Object.keys(g.storage).sort():[],M={};return T.forEach(z=>M[z]=g.storage[z]),g.storage=M,D?(0,O.$lT)(g,{}):JSON.stringify(g)}e.$UEb=t;const r=1;let o=class extends c.$PEb{constructor(D,T,M,z,B,Z,K,x,H,Y,G,V,ee,ne){super({syncResource:"globalState",profile:D},T,z,x,V,B,Z,H,Y,K,G,ee),this.Bb=M,this.pb=r,this.vb=this.h.joinPath(this.g,"globalState.json"),this.wb=this.vb.with({scheme:m.$vhb,authority:"base"}),this.xb=this.vb.with({scheme:m.$vhb,authority:"local"}),this.yb=this.vb.with({scheme:m.$vhb,authority:"remote"}),this.zb=this.vb.with({scheme:m.$vhb,authority:"accepted"}),this.Ab=ne.createInstance(v),this.B(z.watch(this.h.dirname(this.H.argvResource))),this.B(j.Event.any(j.Event.filter(z.onDidFilesChange,_=>_.contains(this.H.argvResource)),j.Event.filter(M.onDidChange,_=>!!(_.targetChanges.some(re=>this.syncResource.profile.id===re.id)||_.valueChanges.some(({profile:re,changes:Q})=>this.syncResource.profile.id===re.id&&Q.some(q=>q.target===0)))))(()=>this.Q()))}async qb(D,T,M){const z=D.syncData?JSON.parse(D.syncData.content):null;T=T===null&&M?D:T;const B=T&&T.syncData?JSON.parse(T.syncData.content):null,Z=await this.Ab.getLocalGlobalState(this.syncResource.profile);z?this.O.trace(`${this.D}: Merging remote ui state with local ui state...`):this.O.trace(`${this.D}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const K=await this.Jb(B),{local:x,remote:H}=(0,f.$TEb)(Z.storage,z?z.storage:null,B?B.storage:null,K,this.O),Y={content:null,local:x,remote:H,localChange:Object.keys(x.added).length>0||Object.keys(x.updated).length>0||x.removed.length>0?2:0,remoteChange:H.all!==null?2:0},G=t(Z,!1);return[{baseResource:this.wb,baseContent:B?t(B,!1):G,localResource:this.xb,localContent:G,localUserData:Z,remoteResource:this.yb,remoteContent:z?t(z,!1):null,previewResource:this.vb,previewResult:Y,localChange:Y.localChange,remoteChange:Y.remoteChange,acceptedResource:this.zb,storageKeys:K}]}async ub(D){const T=D.syncData?JSON.parse(D.syncData.content):null;if(T===null)return!0;const M=await this.Ab.getLocalGlobalState(this.syncResource.profile),z=await this.Jb(T),{remote:B}=(0,f.$TEb)(M.storage,T.storage,T.storage,z,this.O);return B.all!==null}async rb(D,T){return{...D.previewResult,hasConflicts:!1}}async sb(D,T,M,z){if(this.h.isEqual(T,this.xb))return this.Gb(D);if(this.h.isEqual(T,this.yb))return this.Hb(D);if(this.h.isEqual(T,this.vb))return D.previewResult;throw new Error(`Invalid Resource: ${T.toString()}`)}async Gb(D){return{content:D.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(D.localUserData.storage),removed:[],updated:[],all:D.localUserData.storage},localChange:0,remoteChange:2}}async Hb(D){if(D.remoteContent!==null){const T=JSON.parse(D.remoteContent),{local:M,remote:z}=(0,f.$TEb)(D.localUserData.storage,T.storage,null,D.storageKeys,this.O);return{content:D.remoteContent,local:M,remote:z,localChange:Object.keys(M.added).length>0||Object.keys(M.updated).length>0||M.removed.length>0?2:0,remoteChange:z!==null?2:0}}else return{content:D.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async tb(D,T,M,z){const{localUserData:B}=M[0][0],{local:Z,remote:K,localChange:x,remoteChange:H}=M[0][1];if(x===0&&H===0&&this.O.info(`${this.D}: No changes found during synchronizing ui state.`),x!==0&&(this.O.trace(`${this.D}: Updating local ui state...`),await this.nb(JSON.stringify(B)),await this.Ab.writeLocalGlobalState(Z,this.syncResource.profile),this.O.info(`${this.D}: Updated local ui state`)),H!==0){this.O.trace(`${this.D}: Updating remote ui state...`);const Y=JSON.stringify({storage:K.all});D=await this.mb(Y,z?null:D.ref),this.O.info(`${this.D}: Updated remote ui state.${K.added.length?` Added: ${K.added}.`:""}${K.updated.length?` Updated: ${K.updated}.`:""}${K.removed.length?` Removed: ${K.removed}.`:""}`)}T?.ref!==D.ref&&(this.O.trace(`${this.D}: Updating last synchronized ui state...`),await this.fb(D),this.O.info(`${this.D}: Updated last synchronized ui state`))}async resolveContent(D){if(this.h.isEqual(this.yb,D)||this.h.isEqual(this.wb,D)||this.h.isEqual(this.xb,D)||this.h.isEqual(this.zb,D)){const T=await this.db(D);return T&&t(JSON.parse(T),!0)}return null}async hasLocalData(){try{const{storage:D}=await this.Ab.getLocalGlobalState(this.syncResource.profile);if(Object.keys(D).length>1||D[`${n}.locale`]?.value!=="en")return!0}catch{}return!1}async Jb(D){const T=await this.Bb.readStorageData(this.syncResource.profile),M=[],z=[];for(const[K,x]of T)x.target===0?M.push(K):x.target===1&&z.push(K);const B=[...M,...z],Z=D?.storage?Object.keys(D.storage).filter(K=>!K.startsWith(n)&&!B.includes(K)&&T.get(K)!==void 0):[];if(!R.$p){const K=[...m.$ahb.map(x=>(0,m.$nhb)(x)),m.$mhb];Z.push(...K),z.push(...K)}return{user:M,machine:z,unregistered:Z}}};e.$VEb=o,e.$VEb=o=pe([X(2,s.$YDb),X(3,E.$ck),X(4,m.$ehb),X(5,m.$fhb),X(6,m.$thb),X(7,P.$1h),X(8,m.$ohb),X(9,y.$gl),X(10,d.$ni),X(11,$.$0o),X(12,w.$Mk),X(13,a.$Sh)],o);let v=class{constructor(D,T,M,z){this.a=D,this.b=T,this.c=M,this.d=z}async getLocalGlobalState(D){const T={};if(D.isDefault){const z=await this.f(),B=(0,L.$1m)(z);for(const Z of i)B[Z]!==void 0&&(T[`${n}${Z}`]={version:1,value:B[Z]})}const M=await this.c.readStorageData(D);for(const[z,B]of M)B.value&&B.target===0&&(T[z]={version:1,value:B.value});return{storage:T}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const D=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),D.value.toString()}catch(D){this.d.debug((0,N.$9)(D))}return"{}"}async writeLocalGlobalState({added:D,removed:T,updated:M},z){const B=(0,c.$OEb)("globalState",z),Z={},K=new Map,x=await this.c.readStorageData(z),H=(Y,G)=>{for(const V of Y){if(V.startsWith(n)){Z[V.substring(n.length)]=G?G[V].value:void 0;continue}if(G){const ee=G[V];ee.value!==x.get(V)?.value&&K.set(V,ee.value)}else x.get(V)!==void 0&&K.set(V,void 0)}};if(H(Object.keys(D),D),H(Object.keys(M),M),H(T),Object.keys(Z).length){this.d.trace(`${B}: Updating locale...`);const Y=await this.f();let G=Y;for(const V of Object.keys(Z))G=(0,u.edit)(G,[V],Z[V],{});Y!==G&&(this.d.trace(`${B}: Updating locale...`),await this.a.writeFile(this.b.argvResource,I.$ce.fromString(G)),this.d.info(`${B}: Updated locale.`)),this.d.info(`${B}: Updated locale`)}K.size&&(this.d.trace(`${B}: Updating global state...`),await this.c.updateStorageData(z,K,0),this.d.info(`${B}: Updated global state`,[...K.keys()]))}};e.$WEb=v,e.$WEb=v=pe([X(0,E.$ck),X(1,P.$1h),X(2,s.$YDb),X(3,m.$thb)],v);let p=class extends c.$SEb{constructor(D,T,M,z,B,Z){super("globalState",M,z,B,T,D,Z)}async o(D){const T=D.syncData?JSON.parse(D.syncData.content):null;if(!T){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const M={},z={};for(const B of Object.keys(T.storage))B.startsWith(n)?M[B.substring(n.length)]=T.storage[B].value:this.l.get(B,0)===void 0&&(z[B]=T.storage[B].value);if(Object.keys(M).length){let B="{}";try{B=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const Z of Object.keys(M))B=(0,u.edit)(B,[Z],M[Z],{});await this.k.writeFile(this.h.argvResource,I.$ce.fromString(B))}if(Object.keys(z).length){const B=[];for(const Z of Object.keys(z))B.push({key:Z,value:z[Z],scope:0,target:0});this.l.storeAll(B,!0)}}};e.$XEb=p,e.$XEb=p=pe([X(0,$.$0o),X(1,E.$ck),X(2,k.$Ok),X(3,P.$1h),X(4,m.$thb),X(5,w.$Mk)],p);let h=class{constructor(D,T,M,z,B){this.a=D,this.b=T,this.c=M,this.d=z,this.f=B}getSyncStoreType(D){return this.h(D)?.storage[m.$mhb]?.value}async sync(D){const T=(0,m.$ihb)((0,S.$fg)());try{return await this.g(D,T)}catch(M){if(M instanceof m.$jhb)switch(M.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(D,T)}throw M}}async g(D,T){const M=await this.a.readResource("globalState",null,void 0,T),z=this.h(M)||{storage:{}};z.storage[m.$mhb]={value:D,version:r};const B=await(0,l.$dp)(this.c,this.d,this.b),Z={version:r,machineId:B,content:t(z,!1)};await this.a.writeResource("globalState",JSON.stringify(Z),M.ref,void 0,T)}h({content:D}){if(!D)return null;const T=JSON.parse(D);if((0,c.$NEb)(T))return T?JSON.parse(T.content):null;throw new Error("Invalid remote data")}};e.$YEb=h,e.$YEb=h=pe([X(1,$.$0o),X(2,P.$1h),X(3,E.$ck),X(4,b.$bj)],h)}),define(ae[116],ce([0,1,18,15,3,35,5,12,170,20,14,11,21,22,28,17,39,233,24]),function(ie,e,I,N,j,L,O,R,S,d,P,E,b,l,$,y,w,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A4b=e.$z4b=e.$y4b=void 0;function f(s,a,n){try{const i=JSON.parse(s);if(!a)return(0,R.$Gf)(i.all)?null:i.all;switch(O.OS){case 2:return(0,R.$Gf)(i.mac)?null:i.mac;case 3:return(0,R.$Gf)(i.linux)?null:i.linux;case 1:return(0,R.$Gf)(i.windows)?null:i.windows}}catch(i){return n.error(i),null}}e.$y4b=f;let m=class extends w.$REb{constructor(a,n,i,t,r,o,v,p,h,g,D,T,M){super(a.keybindingsResource,{syncResource:"keybindings",profile:a},n,p,h,g,i,t,v,T,r,D,o,M),this.pb=2,this.Eb=this.h.joinPath(this.g,"keybindings.json"),this.Fb=this.Eb.with({scheme:u.$vhb,authority:"base"}),this.Gb=this.Eb.with({scheme:u.$vhb,authority:"local"}),this.Hb=this.Eb.with({scheme:u.$vhb,authority:"remote"}),this.Ib=this.Eb.with({scheme:u.$vhb,authority:"accepted"}),this.B(j.Event.filter(o.onDidChangeConfiguration,z=>z.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.Q()))}async qb(a,n,i,t){const r=a.syncData?f(a.syncData.content,t.keybindingsPerPlatform??this.Qb(),this.O):null;n=n===null&&i?a:n;const o=n?this.Ob(n):null,v=await this.vb(),p=await this.Cb();let h=null,g=!1,D=!1,T=!1;if(r){let B=v?v.value.toString():"[]";if(B=B||"[]",this.Ab(B,!0))throw new u.$jhb((0,S.localize)(0,null),"LocalInvalidContent",this.resource);if(!o||o!==B||o!==r){this.O.trace(`${this.D}: Merging remote keybindings with local keybindings...`);const Z=await(0,c.$x4b)(B,r,o,p,this.zb);Z.hasChanges&&(h=Z.mergeContent,T=Z.hasConflicts,g=T||Z.mergeContent!==B,D=T||Z.mergeContent!==r)}}else v&&(this.O.trace(`${this.D}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),h=v.value.toString(),D=!0);const M={content:T?o:h,localChange:g?v?2:1:0,remoteChange:D?2:0,hasConflicts:T},z=v?v.value.toString():null;return[{fileContent:v,baseResource:this.Fb,baseContent:o,localResource:this.Gb,localContent:z,localChange:M.localChange,remoteResource:this.Hb,remoteContent:r,remoteChange:M.remoteChange,previewResource:this.Eb,previewResult:M,acceptedResource:this.Ib}]}async ub(a){const n=this.Ob(a);if(n===null)return!0;const i=await this.vb(),t=i?i.value.toString():"",r=await this.Cb(),o=await(0,c.$x4b)(t||"[]",n,n,r,this.zb);return o.hasConflicts||o.mergeContent!==n}async rb(a,n){return a.previewResult}async sb(a,n,i,t){if(this.h.isEqual(n,this.Gb))return{content:a.fileContent?a.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(n,this.Hb))return{content:a.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(n,this.Eb))return i===void 0?{content:a.previewResult.content,localChange:a.previewResult.localChange,remoteChange:a.previewResult.remoteChange}:{content:i,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${n.toString()}`)}async tb(a,n,i,t){const{fileContent:r}=i[0][0];let{content:o,localChange:v,remoteChange:p}=i[0][1];if(v===0&&p===0&&this.O.info(`${this.D}: No changes found during synchronizing keybindings.`),o!==null&&(o=o.trim(),o=o||"[]",this.Ab(o,!0)))throw new u.$jhb((0,S.localize)(1,null),"LocalInvalidContent",this.resource);if(v!==0&&(this.O.trace(`${this.D}: Updating local keybindings...`),r&&await this.nb(this.Pb(r.value.toString())),await this.wb(o||"[]",r,t),this.O.info(`${this.D}: Updated local keybindings`)),p!==0){this.O.trace(`${this.D}: Updating remote keybindings...`);const h=this.Pb(o||"[]",a.syncData?.content);a=await this.mb(h,t?null:a.ref),this.O.info(`${this.D}: Updated remote keybindings`)}try{await this.G.del(this.Eb)}catch{}n?.ref!==a.ref&&(this.O.trace(`${this.D}: Updating last synchronized keybindings...`),await this.fb(a,{platformSpecific:this.Qb()}),this.O.info(`${this.D}: Updated last synchronized keybindings`))}async hasLocalData(){try{const a=await this.vb();if(a){const n=(0,L.$1m)(a.value.toString());if((0,I.$Kb)(n))return!0}}catch(a){if(a.fileOperationResult!==1)return!0}return!1}async resolveContent(a){return this.h.isEqual(this.Hb,a)||this.h.isEqual(this.Fb,a)||this.h.isEqual(this.Gb,a)||this.h.isEqual(this.Ib,a)?this.db(a):null}Ob(a){return!a.syncData||a.platformSpecific!==void 0&&a.platformSpecific!==this.Qb()?null:f(a.syncData.content,this.Qb(),this.O)}Pb(a,n){let i={};try{i=JSON.parse(n||"{}")}catch(t){this.O.error(t)}switch(this.Qb()?delete i.all:i.all=a,O.OS){case 2:i.mac=a;break;case 3:i.linux=a;break;case 1:i.windows=a;break}return JSON.stringify(i)}Qb(){return!!this.P.getValue(u.$0gb)}};e.$z4b=m,e.$z4b=m=pe([X(2,u.$ehb),X(3,u.$fhb),X(4,u.$thb),X(5,d.$ni),X(6,u.$ohb),X(7,E.$ck),X(8,P.$1h),X(9,b.$0o),X(10,u.$shb),X(11,l.$gl),X(12,$.$Mk)],m);let k=class extends w.$SEb{constructor(a,n,i,t,r,o){super("keybindings",n,i,t,a,r,o)}async o(a){const n=a.syncData?this.p(a.syncData.content):null;if(!n){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,N.$ce.fromString(n)),await this.n(a)}async i(){try{const a=await this.k.readFile(this.g.defaultProfile.settingsResource),n=(0,L.$1m)(a.value.toString());return!(0,I.$Kb)(n)}catch(a){return a.fileOperationResult===1}}p(a){try{return f(a,!0,this.j)}catch(n){return this.j.error(n),null}}};e.$A4b=k,e.$A4b=k=pe([X(0,E.$ck),X(1,y.$Ok),X(2,P.$1h),X(3,u.$thb),X(4,b.$0o),X(5,$.$Mk)],k)}),define(ae[117],ce([0,1,15,3,171,20,74,14,29,11,21,22,28,17,39,237,24]),function(ie,e,I,N,j,L,O,R,S,d,P,E,b,l,$,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D4b=e.$C4b=e.$B4b=void 0;function c(k){return k&&k.settings&&typeof k.settings=="string"&&Object.keys(k).length===1}function u(k){const s=JSON.parse(k);return c(s)?s:{settings:k}}e.$B4b=u;let f=class extends $.$REb{constructor(s,a,n,i,t,r,o,v,p,h,g,D,T,M){super(s.settingsResource,{syncResource:"settings",profile:s},a,n,i,t,r,o,g,D,v,p,h,M),this.Eb=T,this.pb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:w.$vhb,authority:"base"}),this.localResource=this.previewResource.with({scheme:w.$vhb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:w.$vhb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:w.$vhb,authority:"accepted"}),this.Ob=void 0}async getRemoteUserDataSyncConfiguration(s){const a=await this.getLastSyncUserData(),n=await this.X(s,a),i=this.Lb(n),t=new O.$Gn(w.$9gb);return i?.settings&&t.parse(i.settings),t.configurationModel.getValue(w.$9gb)||{}}async qb(s,a,n){const i=await this.vb(),t=await this.Cb(),r=this.Lb(s);a=a===null&&n?s:a;const o=a?this.Lb(a):null,v=await this.Pb();let p=null,h=!1,g=!1,D=!1;if(r){let B=i?i.value.toString().trim():"{}";B=B||"{}",this.Qb(B),this.O.trace(`${this.D}: Merging remote settings with local settings...`);const Z=(0,y.$FDb)(B,r.settings,o?o.settings:null,v,[],t);p=Z.localContent||Z.remoteContent,h=Z.localContent!==null,g=Z.remoteContent!==null,D=Z.hasConflicts}else i&&(this.O.trace(`${this.D}: Remote settings does not exist. Synchronizing settings for the first time.`),p=i.value.toString().trim()||"{}",this.Qb(p),g=!0);const T=i?i.value.toString():null,M=o?.settings??null,z={content:D?M:p,localChange:h?2:0,remoteChange:g?2:0,hasConflicts:D};return[{fileContent:i,baseResource:this.baseResource,baseContent:M,localResource:this.localResource,localContent:T,localChange:z.localChange,remoteResource:this.remoteResource,remoteContent:r?r.settings:null,remoteChange:z.remoteChange,previewResource:this.previewResource,previewResult:z,acceptedResource:this.acceptedResource}]}async ub(s){const a=this.Lb(s);if(a===null)return!0;const n=await this.vb(),i=n?n.value.toString().trim():"",t=await this.Pb(),r=await this.Cb();return(0,y.$FDb)(i||"{}",a.settings,a.settings,t,[],r).remoteContent!==null}async rb(s,a){const n=await this.Cb(),i=await this.Pb();return{...s.previewResult,content:s.previewResult.content?(0,y.$EDb)(s.previewResult.content,"{}",i,n):null}}async sb(s,a,n,i){const t=await this.Cb(),r=await this.Pb();if(this.h.isEqual(a,this.localResource))return{content:s.fileContent?(0,y.$EDb)(s.fileContent.value.toString(),"{}",r,t):null,localChange:0,remoteChange:2};if(this.h.isEqual(a,this.remoteResource))return{content:s.remoteContent!==null?(0,y.$EDb)(s.remoteContent,s.fileContent?s.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:0};if(this.h.isEqual(a,this.previewResource))return n===void 0?{content:s.previewResult.content,localChange:s.previewResult.localChange,remoteChange:s.previewResult.remoteChange}:{content:n!==null?(0,y.$EDb)(n,s.fileContent?s.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${a.toString()}`)}async tb(s,a,n,i){const{fileContent:t}=n[0][0];let{content:r,localChange:o,remoteChange:v}=n[0][1];if(o===0&&v===0&&this.O.info(`${this.D}: No changes found during synchronizing settings.`),r=r?r.trim():"{}",r=r||"{}",this.Qb(r),o!==0&&(this.O.trace(`${this.D}: Updating local settings...`),t&&await this.nb(JSON.stringify(this.Nb(t.value.toString()))),await this.wb(r,t,i),await this.P.reloadConfiguration(3),this.O.info(`${this.D}: Updated local settings`)),v!==0){const p=await this.Cb(),h=this.Lb(s),g=await this.Pb(r);r=(0,y.$EDb)(r,h?h.settings:"{}",g,p),this.O.trace(`${this.D}: Updating remote settings...`),s=await this.mb(JSON.stringify(this.Nb(r)),i?null:s.ref),this.O.info(`${this.D}: Updated remote settings`)}try{await this.G.del(this.previewResource)}catch{}a?.ref!==s.ref&&(this.O.trace(`${this.D}: Updating last synchronized settings...`),await this.fb(s),this.O.info(`${this.D}: Updated last synchronized settings`))}async hasLocalData(){try{const s=await this.vb();if(s)return!(0,y.$GDb)(s.value.toString())}catch(s){if(s.fileOperationResult!==1)return!0}return!1}async resolveContent(s){return this.h.isEqual(this.remoteResource,s)||this.h.isEqual(this.localResource,s)||this.h.isEqual(this.acceptedResource,s)||this.h.isEqual(this.baseResource,s)?this.db(s):null}async db(s){let a=await super.db(s);if(a){const n=await this.Cb(),i=await this.Pb();a=(0,y.$EDb)(a,"{}",i,n)}return a}Lb(s){return s.syncData?this.Mb(s.syncData.content):null}Mb(s){try{return u(s)}catch(a){this.O.error(a)}return null}Nb(s){return{settings:s}}async Pb(s){if(!this.Ob){this.Ob=this.zb.resolveDefaultIgnoredSettings();const n=this.B(N.Event.any(N.Event.filter(this.Eb.onDidInstallExtensions,i=>i.some(({local:t})=>!!t)),N.Event.filter(this.Eb.onDidUninstallExtension,i=>!i.error))(()=>{n.dispose(),this.Ob=void 0}))}const a=await this.Ob;return(0,y.$CDb)(a,this.P,s)}Qb(s){if(this.Ab(s,!1))throw new w.$jhb((0,j.localize)(0,null),"LocalInvalidContent",this.resource)}};e.$C4b=f,e.$C4b=f=pe([X(2,d.$ck),X(3,R.$1h),X(4,P.$0o),X(5,w.$ehb),X(6,w.$fhb),X(7,w.$thb),X(8,w.$shb),X(9,L.$ni),X(10,w.$ohb),X(11,E.$gl),X(12,S.$do),X(13,b.$Mk)],f);let m=class extends $.$SEb{constructor(s,a,n,i,t,r){super("settings",a,n,i,s,t,r)}async o(s){const a=s.syncData?this.p(s.syncData.content):null;if(!a){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,I.$ce.fromString(a.settings)),await this.n(s)}async i(){try{const s=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,y.$GDb)(s.value.toString().trim())}catch(s){return s.fileOperationResult===1}}p(s){try{return u(s)}catch(a){this.j.error(a)}return null}};e.$D4b=m,e.$D4b=m=pe([X(0,d.$ck),X(1,l.$Ok),X(2,R.$1h),X(3,w.$thb),X(4,P.$0o),X(5,b.$Mk)],m)}),define(ae[118],ce([0,1,15,3,30,20,14,11,21,22,28,17,39,234,24]),function(ie,e,I,N,j,L,O,R,S,d,P,E,b,l,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I4b=e.$H4b=e.$G4b=void 0;function y(u){return JSON.parse(u.content)}e.$G4b=y;let w=class extends b.$PEb{constructor(f,m,k,s,a,n,i,t,r,o,v,p){super({syncResource:"snippets",profile:f},m,s,k,a,n,i,o,v,t,r,p),this.pb=1,this.vb=f.snippetsHome,this.B(this.G.watch(k.userRoamingDataHome)),this.B(this.G.watch(this.vb)),this.B(N.Event.filter(this.G.onDidFilesChange,h=>h.affects(this.vb))(()=>this.Q()))}async qb(f,m,k){const s=await this.Hb(),a=this.Gb(s),n=f.syncData?this.Fb(f.syncData):null;m=m===null&&k?f:m;const i=m&&m.syncData?this.Fb(m.syncData):null;n?this.O.trace(`${this.D}: Merging remote snippets with local snippets...`):this.O.trace(`${this.D}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const t=(0,l.$E4b)(a,n,i);return this.Bb(t,s,n||{},i||{})}async ub(f){const m=f.syncData?this.Fb(f.syncData):null;if(m===null)return!0;const k=await this.Hb(),s=this.Gb(k),a=(0,l.$E4b)(s,m,m);return Object.keys(a.remote.added).length>0||Object.keys(a.remote.updated).length>0||a.remote.removed.length>0||a.conflicts.length>0}async rb(f,m){return f.previewResult}async sb(f,m,k,s){if(this.h.isEqualOrParent(m,this.g.with({scheme:$.$vhb,authority:"local"})))return{content:f.fileContent?f.fileContent.value.toString():null,localChange:0,remoteChange:f.fileContent?f.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(m,this.g.with({scheme:$.$vhb,authority:"remote"})))return{content:f.remoteContent,localChange:f.remoteContent!==null?f.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(m,this.g))return k===void 0?{content:f.previewResult.content,localChange:f.previewResult.localChange,remoteChange:f.previewResult.remoteChange}:{content:k,localChange:k===null?f.fileContent!==null?3:0:2,remoteChange:k===null?f.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${m.toString()}`)}async tb(f,m,k,s){const a=k.map(([n,i])=>({...n,acceptResult:i}));a.every(({localChange:n,remoteChange:i})=>n===0&&i===0)&&this.O.info(`${this.D}: No changes found during synchronizing snippets.`),a.some(({localChange:n})=>n!==0)&&(await this.Cb(a),await this.Db(a,s)),a.some(({remoteChange:n})=>n!==0)&&(f=await this.Eb(a,f,s)),m?.ref!==f.ref&&(this.O.trace(`${this.D}: Updating last synchronized snippets...`),await this.fb(f),this.O.info(`${this.D}: Updated last synchronized snippets`));for(const{previewResource:n}of a)try{await this.G.del(n)}catch{}}Bb(f,m,k,s){const a=new Map;for(const n of Object.keys(f.local.added)){const i={content:f.local.added[n],hasConflicts:!1,localChange:1,remoteChange:0};a.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$vhb,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$vhb,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$vhb,authority:"remote"}),remoteContent:k[n],previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$vhb,authority:"accepted"})})}for(const n of Object.keys(f.local.updated)){const i={content:f.local.updated[n],hasConflicts:!1,localChange:2,remoteChange:0},t=m[n]?m[n].value.toString():null;a.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$vhb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$vhb,authority:"local"}),fileContent:m[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$vhb,authority:"remote"}),remoteContent:k[n],previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$vhb,authority:"accepted"})})}for(const n of f.local.removed){const i={content:null,hasConflicts:!1,localChange:3,remoteChange:0},t=m[n]?m[n].value.toString():null;a.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$vhb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$vhb,authority:"local"}),fileContent:m[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$vhb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$vhb,authority:"accepted"})})}for(const n of Object.keys(f.remote.added)){const i={content:f.remote.added[n],hasConflicts:!1,localChange:0,remoteChange:1},t=m[n]?m[n].value.toString():null;a.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$vhb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$vhb,authority:"local"}),fileContent:m[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$vhb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$vhb,authority:"accepted"})})}for(const n of Object.keys(f.remote.updated)){const i={content:f.remote.updated[n],hasConflicts:!1,localChange:0,remoteChange:2},t=m[n]?m[n].value.toString():null;a.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$vhb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$vhb,authority:"local"}),fileContent:m[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$vhb,authority:"remote"}),remoteContent:k[n],previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$vhb,authority:"accepted"})})}for(const n of f.remote.removed){const i={content:null,hasConflicts:!1,localChange:0,remoteChange:3};a.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$vhb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$vhb,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$vhb,authority:"remote"}),remoteContent:k[n],previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$vhb,authority:"accepted"})})}for(const n of f.conflicts){const i={content:s[n]??null,hasConflicts:!0,localChange:m[n]?2:1,remoteChange:k[n]?2:1},t=m[n]?m[n].value.toString():null;a.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$vhb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$vhb,authority:"local"}),fileContent:m[n]||null,localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$vhb,authority:"remote"}),remoteContent:k[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$vhb,authority:"accepted"})})}for(const n of Object.keys(m))if(!a.has(n)){const i={content:m[n]?m[n].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},t=m[n]?m[n].value.toString():null;a.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$vhb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$vhb,authority:"local"}),fileContent:m[n]||null,localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$vhb,authority:"remote"}),remoteContent:k[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$vhb,authority:"accepted"})})}return[...a.values()]}async resolveContent(f){return this.h.isEqualOrParent(f,this.g.with({scheme:$.$vhb,authority:"remote"}))||this.h.isEqualOrParent(f,this.g.with({scheme:$.$vhb,authority:"local"}))||this.h.isEqualOrParent(f,this.g.with({scheme:$.$vhb,authority:"base"}))||this.h.isEqualOrParent(f,this.g.with({scheme:$.$vhb,authority:"accepted"}))?this.db(f):null}async hasLocalData(){try{const f=await this.Hb();if(Object.keys(f).length)return!0}catch{}return!1}async Cb(f){const m={};for(const k of f)k.fileContent&&(m[this.h.basename(k.localResource)]=k.fileContent);await this.nb(JSON.stringify(this.Gb(m)))}async Db(f,m){for(const{fileContent:k,acceptResult:s,localResource:a,remoteResource:n,localChange:i}of f)if(i!==0){const t=n?this.h.basename(n):this.h.basename(a),r=this.h.joinPath(this.vb,t);i===3?(this.O.trace(`${this.D}: Deleting snippet...`,this.h.basename(r)),await this.G.del(r),this.O.info(`${this.D}: Deleted snippet`,this.h.basename(r))):i===1?(this.O.trace(`${this.D}: Creating snippet...`,this.h.basename(r)),await this.G.createFile(r,I.$ce.fromString(s.content),{overwrite:m}),this.O.info(`${this.D}: Created snippet`,this.h.basename(r))):(this.O.trace(`${this.D}: Updating snippet...`,this.h.basename(r)),await this.G.writeFile(r,I.$ce.fromString(s.content),m?void 0:k),this.O.info(`${this.D}: Updated snippet`,this.h.basename(r)))}}async Eb(f,m,k){const s=m.syncData?this.Fb(m.syncData):{},a=(0,j.$$m)(s);for(const{acceptResult:n,localResource:i,remoteResource:t,remoteChange:r}of f)if(r!==0){const o=i?this.h.basename(i):this.h.basename(t);r===3?delete a[o]:a[o]=n.content}return(0,l.$F4b)(s,a)||(this.O.trace(`${this.D}: Updating remote snippets...`),m=await this.mb(JSON.stringify(a),k?null:m.ref),this.O.info(`${this.D}: Updated remote snippets`)),m}Fb(f){return y(f)}Gb(f){const m={};for(const k of Object.keys(f))m[k]=f[k].value.toString();return m}async Hb(){const f={};let m;try{m=await this.G.resolve(this.vb)}catch(k){if(k instanceof R.$xk&&k.fileOperationResult===1)return f;throw k}for(const k of m.children||[]){const s=k.resource,a=this.h.extname(s);if(a===".json"||a===".code-snippets"){const n=this.h.relativePath(this.vb,s),i=await this.G.readFile(s);f[n]=i}}return f}};e.$H4b=w,e.$H4b=w=pe([X(2,O.$1h),X(3,R.$ck),X(4,S.$0o),X(5,$.$ehb),X(6,$.$fhb),X(7,$.$thb),X(8,L.$ni),X(9,$.$ohb),X(10,d.$gl),X(11,P.$Mk)],w);let c=class extends b.$SEb{constructor(f,m,k,s,a,n){super("snippets",m,k,s,f,a,n)}async o(f){const m=f.syncData?JSON.parse(f.syncData.content):null;if(!m){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const s of Object.keys(m)){const a=m[s];if(a){const n=this.d.joinPath(this.g.defaultProfile.snippetsHome,s);await this.k.createFile(n,I.$ce.fromString(a)),this.j.info("Created snippet",this.d.basename(n))}}await this.n(f)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(f){return f.fileOperationResult===1}}};e.$I4b=c,e.$I4b=c=pe([X(0,R.$ck),X(1,E.$Ok),X(2,O.$1h),X(3,$.$thb),X(4,S.$0o),X(5,P.$Mk)],c)}),define(ae[119],ce([0,1,15,20,14,11,21,22,28,17,39,24]),function(ie,e,I,N,j,L,O,R,S,d,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L4b=e.$K4b=e.$J4b=void 0;function b(w,c){try{return JSON.parse(w).tasks??null}catch(u){return c.error(u),null}}e.$J4b=b;let l=class extends P.$QEb{constructor(c,u,f,m,k,s,a,n,i,t,r,o){super(c.tasksResource,{syncResource:"tasks",profile:c},u,n,i,t,f,m,a,r,k,s,o),this.pb=1,this.Ab=this.h.joinPath(this.g,"tasks.json"),this.Bb=this.Ab.with({scheme:E.$vhb,authority:"base"}),this.Cb=this.Ab.with({scheme:E.$vhb,authority:"local"}),this.Db=this.Ab.with({scheme:E.$vhb,authority:"remote"}),this.Eb=this.Ab.with({scheme:E.$vhb,authority:"accepted"})}async qb(c,u,f,m){const k=c.syncData?b(c.syncData.content,this.O):null;u=u===null&&f?c:u;const s=u?.syncData?b(u.syncData.content,this.O):null,a=await this.vb();let n=null,i=!1,t=!1,r=!1;if(c.syncData){const p=a?a.value.toString():null;if(!s||s!==p||s!==k){this.O.trace(`${this.D}: Merging remote tasks with local tasks...`);const h=y(p,k,s);n=h.content,r=h.hasConflicts,i=h.hasLocalChanged,t=h.hasRemoteChanged}}else a&&(this.O.trace(`${this.D}: Remote tasks does not exist. Synchronizing tasks for the first time.`),n=a.value.toString(),t=!0);const o={content:r?s:n,localChange:i?a?2:1:0,remoteChange:t?2:0,hasConflicts:r},v=a?a.value.toString():null;return[{fileContent:a,baseResource:this.Bb,baseContent:s,localResource:this.Cb,localContent:v,localChange:o.localChange,remoteResource:this.Db,remoteContent:k,remoteChange:o.remoteChange,previewResource:this.Ab,previewResult:o,acceptedResource:this.Eb}]}async ub(c){const u=c?.syncData?b(c.syncData.content,this.O):null;if(u===null)return!0;const f=await this.vb(),m=f?f.value.toString():null,k=y(m,u,u);return k.hasLocalChanged||k.hasRemoteChanged}async rb(c,u){return c.previewResult}async sb(c,u,f,m){if(this.h.isEqual(u,this.Cb))return{content:c.fileContent?c.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(u,this.Db))return{content:c.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(u,this.Ab))return f===void 0?{content:c.previewResult.content,localChange:c.previewResult.localChange,remoteChange:c.previewResult.remoteChange}:{content:f,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${u.toString()}`)}async tb(c,u,f,m){const{fileContent:k}=f[0][0],{content:s,localChange:a,remoteChange:n}=f[0][1];if(a===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing tasks.`),a!==0&&(this.O.trace(`${this.D}: Updating local tasks...`),k&&await this.nb(JSON.stringify(this.Kb(k.value.toString()))),s?await this.wb(s,k,m):await this.xb(),this.O.info(`${this.D}: Updated local tasks`)),n!==0){this.O.trace(`${this.D}: Updating remote tasks...`);const i=JSON.stringify(this.Kb(s));c=await this.mb(i,m?null:c.ref),this.O.info(`${this.D}: Updated remote tasks`)}try{await this.G.del(this.Ab)}catch{}u?.ref!==c.ref&&(this.O.trace(`${this.D}: Updating last synchronized tasks...`),await this.fb(c),this.O.info(`${this.D}: Updated last synchronized tasks`))}async hasLocalData(){return this.G.exists(this.r)}async resolveContent(c){return this.h.isEqual(this.Db,c)||this.h.isEqual(this.Bb,c)||this.h.isEqual(this.Cb,c)||this.h.isEqual(this.Eb,c)?this.db(c):null}Kb(c){return c?{tasks:c}:{}}};e.$K4b=l,e.$K4b=l=pe([X(2,E.$ehb),X(3,E.$fhb),X(4,E.$thb),X(5,N.$ni),X(6,E.$ohb),X(7,L.$ck),X(8,j.$1h),X(9,O.$0o),X(10,R.$gl),X(11,S.$Mk)],l);let $=class extends P.$SEb{constructor(c,u,f,m,k,s){super("tasks",u,f,m,c,k,s),this.c=this.g.defaultProfile.tasksResource}async o(c){const u=c.syncData?b(c.syncData.content,this.j):null;if(!u){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,I.$ce.fromString(u)),await this.n(c)}async p(){return this.k.exists(this.c)}};e.$L4b=$,e.$L4b=$=pe([X(0,L.$ck),X(1,d.$Ok),X(2,j.$1h),X(3,E.$thb),X(4,O.$0o),X(5,S.$Mk)],$);function y(w,c,u){if(w===null&&c===null&&u===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(w===c)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const f=u!==w,m=u!==c;return!f&&!m?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:f&&!m?{content:w,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:m&&!f?{content:c,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:w,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(ae[120],ce([0,1,42,20,14,11,21,22,28,17,39,235,24]),function(ie,e,I,N,j,L,O,R,S,d,P,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q6b=e.$p6b=e.$o6b=void 0;let l=class extends P.$PEb{constructor(c,u,f,m,k,s,a,n,i,t,r,o,v){super({syncResource:"profiles",profile:c},u,m,k,s,a,n,r,o,i,t,v),this.vb=f,this.pb=2,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:b.$vhb,authority:"base"}),this.localResource=this.previewResource.with({scheme:b.$vhb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:b.$vhb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:b.$vhb,authority:"accepted"}),this.B(f.onDidChangeProfiles(()=>this.Q()))}async getLastSyncedProfiles(){const c=await this.getLastSyncUserData();return c?.syncData?y(c.syncData):null}async getRemoteSyncedProfiles(c){const u=await this.getLastSyncUserData(),f=await this.X(c,u);return f?.syncData?y(f.syncData):null}async qb(c,u,f){if(!this.vb.isEnabled())throw new b.$jhb("Cannot sync profiles because they are disabled","LocalError");const m=c.syncData?y(c.syncData):null,k=u?.syncData?y(u.syncData):null,s=this.Db(),{local:a,remote:n}=(0,E.$n6b)(s,m,k,[]),i={local:a,remote:n,content:k?this.Eb(k):null,localChange:a.added.length>0||a.removed.length>0||a.updated.length>0?2:0,remoteChange:n!==null?2:0},t=$(s,!1);return[{baseResource:this.baseResource,baseContent:k?this.Eb(k):null,localResource:this.localResource,localContent:t,remoteResource:this.remoteResource,remoteContent:m?this.Eb(m):null,remoteProfiles:m,previewResource:this.previewResource,previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.acceptedResource}]}async ub(c){const u=c?.syncData?y(c.syncData):null,f=this.Db(),{remote:m}=(0,E.$n6b)(f,u,u,[]);return!!m?.added.length||!!m?.removed.length||!!m?.updated.length}async rb(c,u){return{...c.previewResult,hasConflicts:!1}}async sb(c,u,f,m){if(this.h.isEqual(u,this.localResource))return this.Ab(c);if(this.h.isEqual(u,this.remoteResource))return this.Bb(c);if(this.h.isEqual(u,this.previewResource))return c.previewResult;throw new Error(`Invalid Resource: ${u.toString()}`)}async Ab(c){const u=this.Db(),f=(0,E.$n6b)(u,null,null,[]),{local:m,remote:k}=f;return{content:c.localContent,local:m,remote:k,localChange:m.added.length>0||m.removed.length>0||m.updated.length>0?2:0,remoteChange:k!==null?2:0}}async Bb(c){const u=c.remoteContent?JSON.parse(c.remoteContent):null,f=[],m=[];for(const k of this.Db()){const s=u?.find(a=>a.id===k.id);s&&(f.push({id:k.id,name:k.name,collection:s.collection}),m.push(k))}if(u!==null){const k=(0,E.$n6b)(m,u,f,[]),{local:s,remote:a}=k;return{content:c.remoteContent,local:s,remote:a,localChange:s.added.length>0||s.removed.length>0||s.updated.length>0?2:0,remoteChange:a!==null?2:0}}else return{content:c.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(c,u,f,m){const{local:k,remote:s,localChange:a,remoteChange:n}=f[0][1];a===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing profiles.`);const i=f[0][0].remoteProfiles||[];if(i.length+(s?.added.length??0)-(s?.removed.length??0)>20)throw new b.$jhb("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(a!==0){await this.nb($(this.Db(),!1));const t=[];for(const r of k.added)t.push((async()=>{this.O.trace(`${this.D}: Creating '${r.name}' profile...`),await this.vb.createProfile(r.id,r.name,{shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.O.info(`${this.D}: Created profile '${r.name}'.`)})());for(const r of k.removed)t.push((async()=>{this.O.trace(`${this.D}: Removing '${r.name}' profile...`),await this.vb.removeProfile(r),this.O.info(`${this.D}: Removed profile '${r.name}'.`)})());for(const r of k.updated){const o=this.vb.profiles.find(v=>v.id===r.id);o?t.push((async()=>{this.O.trace(`${this.D}: Updating '${r.name}' profile...`),await this.vb.updateProfile(o,{name:r.name,shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.O.info(`${this.D}: Updated profile '${r.name}'.`)})()):this.O.info(`${this.D}: Could not find profile with id '${r.id}' to update.`)}await Promise.all(t)}if(n!==0){this.O.trace(`${this.D}: Updating remote profiles...`);const t=[],r=i.length+(s?.added.length??0)<=20;if(r)for(const o of s?.added||[]){const v=await this.J.createCollection(this.F);t.push(v),i.push({id:o.id,name:o.name,collection:v,shortName:o.shortName,icon:o.icon,useDefaultFlags:o.useDefaultFlags})}else this.O.info(`${this.D}: Could not create remote profiles as there are too many profiles.`);for(const o of s?.removed||[])i.splice(i.findIndex(({id:v})=>o.id===v),1);for(const o of s?.updated||[]){const v=i.find(({id:p})=>o.id===p);v&&i.splice(i.indexOf(v),1,{...v,id:o.id,name:o.name,shortName:o.shortName,icon:o.icon,useDefaultFlags:o.useDefaultFlags})}try{c=await this.updateRemoteProfiles(i,m?null:c.ref),this.O.info(`${this.D}: Updated remote profiles.${r&&s?.added.length?` Added: ${JSON.stringify(s.added.map(o=>o.name))}.`:""}${s?.updated.length?` Updated: ${JSON.stringify(s.updated.map(o=>o.name))}.`:""}${s?.removed.length?` Removed: ${JSON.stringify(s.removed.map(o=>o.name))}.`:""}`)}catch(o){if(t.length){this.O.info(`${this.D}: Failed to update remote profiles. Cleaning up added collections...`);for(const v of t)await this.J.deleteCollection(v,this.F)}throw o}for(const o of s?.removed||[])await this.J.deleteCollection(o.collection,this.F)}u?.ref!==c.ref&&(this.O.trace(`${this.D}: Updating last synchronized profiles...`),await this.fb(c),this.O.info(`${this.D}: Updated last synchronized profiles.`))}async updateRemoteProfiles(c,u){return this.mb(this.Eb(c),u)}async hasLocalData(){return this.Db().length>0}async resolveContent(c){if(this.h.isEqual(this.remoteResource,c)||this.h.isEqual(this.baseResource,c)||this.h.isEqual(this.localResource,c)||this.h.isEqual(this.acceptedResource,c)){const u=await this.db(c);return u&&(0,I.$lT)(JSON.parse(u),{})}return null}Db(){return this.vb.profiles.filter(c=>!c.isDefault&&!c.isTransient)}Eb(c){return JSON.stringify([...c].sort((u,f)=>u.name.localeCompare(f.name)))}};e.$o6b=l,e.$o6b=l=pe([X(2,d.$Ok),X(3,L.$ck),X(4,j.$1h),X(5,O.$0o),X(6,b.$ehb),X(7,b.$fhb),X(8,b.$thb),X(9,N.$ni),X(10,b.$ohb),X(11,R.$gl),X(12,S.$Mk)],l);function $(w,c){const u=[...w].sort((f,m)=>f.name.localeCompare(m.name)).map(f=>({id:f.id,name:f.name}));return c?(0,I.$lT)(u,{}):JSON.stringify(u)}e.$p6b=$;function y(w){return JSON.parse(w.content)}e.$q6b=y}),define(ae[252],ce([0,1,3,2,5,14,21,22,24]),function(ie,e,I,N,j,L,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b6b=void 0;const d="sync.enable";let P=class extends N.$Rc{constructor(b,l,$,y){super(),this.c=b,this.f=l,this.g=$,this.h=y,this.a=new I.$Od,this.onDidChangeEnablement=this.a.event,this.b=new I.$Od,this.onDidChangeResourceEnablement=this.b.event,this.B(b.onDidChangeValue(-1,void 0,this.B(new N.$Qc))(w=>this.m(w)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(d,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(b){b&&!this.canToggleEnablement()||(this.f.publicLog2(d,{enabled:b}),this.c.store(d,b,-1,1))}isResourceEnabled(b){return this.c.getBoolean((0,S.$nhb)(b),-1,!0)}setResourceEnablement(b,l){if(this.isResourceEnabled(b)!==l){const $=(0,S.$nhb)(b);this.j($,l)}}getResourceSyncStateVersion(b){}j(b,l){this.c.store(b,l,-1,j.$p?0:1)}m(b){if(d===b.key){this.a.fire(this.isEnabled());return}const l=S.$ahb.filter($=>(0,S.$nhb)($)===b.key)[0];if(l){this.b.fire([l,this.isResourceEnabled(l)]);return}}};e.$b6b=P,e.$b6b=P=pe([X(0,O.$0o),X(1,R.$gl),X(2,L.$1h),X(3,S.$dhb)],P)}),define(ae[253],ce([0,1,6,15,64,2,19,20,14,11,17,24]),function(ie,e,I,N,j,L,O,R,S,d,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m6b=void 0;let b=class extends L.$Rc{constructor($,y,w,c,u){super(),this.a=$,this.b=y,this.c=w,this.f=c,this.g=u,this.h()}async h(){for(const y of this.g.profiles)for(const w of E.$ahb)try{await this.m(this.j(w,y.isDefault?void 0:y.id))}catch(c){this.f.error(c)}let $;try{$=await this.b.resolve(this.a.userDataSyncHome)}catch(y){(0,d.$tk)(y)!==1&&this.f.error(y);return}if($.children){for(const y of $.children)if(y.isDirectory&&!this.g.profiles.some(w=>w.id===y.name))try{this.f.info("Deleting non existing profile from backup",y.resource.path),await this.b.del(y.resource,{recursive:!0})}catch(w){this.f.error(w)}}}async getAllResourceRefs($,y,w){const c=this.j($,y,w);try{const u=await this.b.resolve(c);if(u.children)return u.children.filter(m=>m.isFile&&!m.name.startsWith("lastSync")).sort().reverse().map(m=>({ref:m.name,created:this.n(m)}))}catch(u){if((0,d.$tk)(u)!==1)throw u}return[]}async resolveResourceContent($,y,w,c){const u=this.j($,w,c),f=(0,O.$wg)(u,y);try{return(await this.b.readFile(f)).value.toString()}catch(m){return this.f.error(m),null}}async writeResource($,y,w,c,u){const f=this.j($,c,u),m=(0,O.$wg)(f,`${(0,j.$im)(w).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(m,N.$ce.fromString(y))}catch(k){this.f.error(k)}}j($,y,w=this.a.userDataSyncHome){return(0,O.$wg)(w,...y?[y,$]:[$])}async m($){try{try{if(!await this.b.exists($))return}catch{return}const y=await this.b.resolve($);if(y.children){const w=y.children.filter(m=>m.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(m.name)).sort(),c=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let u=w.filter(m=>Date.now()-this.n(m)>c);const f=w.length-u.length;f<10&&(u=u.slice(10-f)),await I.Promises.settled(u.map(async m=>{this.f.info("Deleting from backup",m.resource.path),await this.b.del(m.resource)}))}}catch(y){this.f.error(y)}}n($){return new Date(parseInt($.name.substring(0,4)),parseInt($.name.substring(4,6))-1,parseInt($.name.substring(6,8)),parseInt($.name.substring(9,11)),parseInt($.name.substring(11,13)),parseInt($.name.substring(13,15))).getTime()}};e.$m6b=b,e.$m6b=b=pe([X(0,S.$1h),X(1,d.$ck),X(2,R.$ni),X(3,E.$thb),X(4,P.$Ok)],b)}),define(ae[82],ce([0,1,3,2,5,27,175,14,11,4,25,43,21,24]),function(ie,e,I,N,j,L,O,R,S,d,P,E,b,l){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$6gb=e.$5gb=e.$4gb=void 0,e.$4gb=(0,d.$Th)("IUserDataSyncMachinesService");const y="sync.currentMachineName",w="Safari",c="Chrome",u="Edge",f="Firefox",m="Android";function k(n){switch(n){case w:case c:case u:case f:case m:case(0,j.$i)(0):return!0}return!1}e.$5gb=k;function s(){return j.$G?w:j.$E?c:j.$H?u:j.$F?f:j.$I?m:(0,j.$i)(j.$p?0:j.$u)}let a=class extends N.$Rc{static{$=this}static{this.a=1}static{this.b="machines"}constructor(i,t,r,o,v,p){super(),this.h=r,this.j=o,this.m=v,this.n=p,this.c=this.B(new I.$Od),this.onDidChange=this.c.event,this.g=null,this.f=(0,E.$dp)(i,t,r)}async getMachines(i){const t=await this.f;return(await this.s(i)).machines.map(o=>({...o,isCurrent:o.id===t}))}async addCurrentMachine(i){const t=await this.f,r=await this.s(i);r.machines.some(({id:o})=>o===t)||(r.machines.push({id:t,name:this.r(r.machines),platform:s()}),await this.t(r))}async removeCurrentMachine(i){const t=await this.f,r=await this.s(i),o=r.machines.filter(({id:v})=>v!==t);o.length!==r.machines.length&&(r.machines=o,await this.t(r))}async renameMachine(i,t,r){const o=await this.s(r),v=o.machines.find(({id:p})=>p===i);if(v){v.name=t,await this.t(o);const p=await this.f;i===p&&this.h.store(y,t,-1,1)}}async setEnablements(i){const t=await this.s();for(const[r,o]of i){const v=t.machines.find(p=>p.id===r);v&&(v.disabled=o?void 0:!0)}await this.t(t)}r(i){const t=this.h.get(y,-1);if(t)return t;const r=`${this.n.embedderIdentifier?`${this.n.embedderIdentifier} - `:""}${s()} (${this.n.nameShort})`,o=new RegExp(`${(0,L.$Ge)(r)}\\s#(\\d+)`);let v=0;for(const p of i){const h=o.exec(p.name),g=h?parseInt(h[1]):0;v=g>v?g:v}return`${r} #${v+1}`}async s(i){this.g=await this.u(i);const t=this.w(this.g);if(t.version!==$.a)throw new Error((0,O.localize)(0,null,this.n.nameLong));return t}async t(i){const t=JSON.stringify(i),r=await this.j.writeResource($.b,t,this.g?.ref||null);this.g={ref:r,content:t},this.c.fire()}async u(i){if(this.g){const t=i&&i.latest?i.latest[$.b]:void 0;if(this.g.ref===t)return this.g;if(t===void 0&&this.g.content===null)return this.g}return this.j.readResource($.b,this.g)}w(i){if(i.content!==null)try{return JSON.parse(i.content)}catch(t){this.m.error(t)}return{version:$.a,machines:[]}}};e.$6gb=a,e.$6gb=a=$=pe([X(0,R.$1h),X(1,S.$ck),X(2,b.$0o),X(3,l.$ehb),X(4,l.$thb),X(5,P.$tj)],a)}),define(ae[254],ce([0,1,6,64,38,7,3,2,5,19,10,172,25,21,22,24,79,82]),function(ie,e,I,N,j,L,O,R,S,d,P,E,b,l,$,y,w,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s6b=void 0;const u="sync.disableMachineEventually",f="sync.sessionId",m="sync.storeUrl",k="sync.productQuality";let s=class extends R.$Rc{get n(){const i=this.H.get(m,-1);return i?P.URI.parse(i):void 0}set n(i){i?this.H.store(m,i.toString(),-1,1):this.H.remove(m,-1)}get s(){return this.H.get(k,-1)}set s(i){i?this.H.store(k,i,-1,1):this.H.remove(k,-1)}constructor(i,t,r,o,v,p,h,g,D,T){super(),this.u=t,this.w=r,this.y=o,this.z=v,this.C=p,this.D=h,this.F=g,this.G=D,this.H=T,this.a=this.B(new R.$Sc),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new O.$Od),this.onError=this.h.event,this.S=[],this.f=this.B(new I.$Sg(this.U())),this.j=this.n,this.n=t.userDataSyncStore?.url,this.r=this.s,this.s=i.quality,this.n&&(this.C.info("Using settings sync service",this.n.toString()),this.B(t.onDidChangeUserDataSyncStore(()=>{(0,d.$pg)(this.n,t.userDataSyncStore?.url)||(this.j=this.n,this.n=t.userDataSyncStore?.url,this.n&&this.C.info("Using settings sync service",this.n.toString()))})),this.y.isEnabled()?this.C.info("Auto Sync is enabled."):this.C.info("Auto Sync is disabled."),this.I(),this.Q()&&this.P(),this.B(h.onDidChangeAccount(()=>this.I())),this.B(r.onDidChangeDonotMakeRequestsUntil(()=>this.I())),this.B(v.onDidChangeLocal(M=>this.triggerSync([M],!1,!1))),this.B(O.Event.filter(this.y.onDidChangeResourceEnablement,([,M])=>M)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.u.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}I(){const{enabled:i,message:t}=this.L();i?this.a.value===void 0&&(this.a.value=new a(this.j,1e3*60*5,this.u,this.w,this.z,this.G,this.C,this.F,this.H),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(r=>this.O(r))),this.J()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(t&&this.C.info(t),this.a.clear()):t&&this.y.isEnabled()&&this.C.info(t))}J(){return!0}L(){return this.y.isEnabled()?this.D.account?this.w.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,N.$im)(this.w.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.R(),this.j=this.n,this.M(!0)}async turnOff(i,t,r){try{this.D.account&&!r&&await this.G.removeCurrentMachine(),this.M(!1),this.H.remove(f,-1),i?(this.F.publicLog2("sync/turnOffEveryWhere"),await this.z.reset()):await this.z.resetLocal()}catch(o){if(this.C.error(o),t)this.M(!1);else throw o}}M(i){this.y.isEnabled()!==i&&(this.y.setEnablement(i),this.I())}N(){return!!this.r&&!!this.s&&this.r!==this.s}async O(i){if(!i){this.b=0;return}const t=y.$jhb.toUserDataSyncError(i);t instanceof y.$lhb&&this.F.publicLog2("autosync/error",{code:t.code,service:this.u.userDataSyncStore.url.toString()}),t.code==="SessionExpired"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current session is expired")):t.code==="TurnedOff"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):t.code==="LocalTooManyRequests"?(this.g=!0,this.C.info("Auto Sync: Suspended sync because of making too many requests to server"),this.I()):t.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because of making too many requests to server")):t.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):t.code==="UpgradeRequired"||t.code==="Gone"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):t.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${t.resource} content with newer version than of client. Requires client upgrade.`)):t.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${t.resource} content with older version than of client. Requires server reset.`)):t.code==="ServiceChanged"||t.code==="DefaultServiceChanged"?S.$p&&t.code==="DefaultServiceChanged"&&!this.N()?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.C.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.C.error(t),this.b++),this.h.fire(t)}async P(){this.H.store(u,!0,-1,1),await(0,I.$Vg)(1e3*60*10),this.Q()&&(this.R(),!this.y.isEnabled()&&this.D.account&&await this.G.removeCurrentMachine())}Q(){return this.H.getBoolean(u,-1,!1)}R(){this.H.remove(u,-1)}async triggerSync(i,t,r){if(this.a.value===void 0)return this.f.cancel();if(t&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.C.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.S.push(...i),this.f.trigger(async()=>{this.C.trace("activity sources",...this.S);const o=this.D.account?.authenticationProviderId||"";this.F.publicLog2("sync/triggered",{sources:this.S,providerId:o}),this.S=[],this.a.value&&await this.a.value.sync("Activity",r)},this.b?this.U()*1*Math.min(Math.pow(2,this.b),60):this.U())}U(){return 2e3}};e.$s6b=s,e.$s6b=s=pe([X(0,b.$tj),X(1,y.$dhb),X(2,y.$ehb),X(3,y.$ohb),X(4,y.$phb),X(5,y.$thb),X(6,w.$mDb),X(7,$.$gl),X(8,c.$4gb),X(9,l.$0o)],s);class a extends R.$Rc{static{this.a="Interval"}constructor(i,t,r,o,v,p,h,g,D){super(),this.m=i,this.n=t,this.r=r,this.s=o,this.u=v,this.w=p,this.y=h,this.z=g,this.C=D,this.b=this.B(new R.$Sc),this.c=this.B(new O.$Od),this.onDidStartSync=this.c.event,this.f=this.B(new O.$Od),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.D())),this.B((0,R.$Pc)(()=>{this.j&&(this.j.cancel(),this.y.info("Auto sync: Cancelled sync that is in progress"),this.j=void 0),this.h?.stop(),this.y.info("Auto Sync: Stopped")})),this.sync(a.a,!1)}D(){this.b.value=(0,I.$Wg)(()=>{this.sync(a.a,!1),this.b.value=void 0},this.n)}sync(i,t){const r=(0,I.$Ig)(async o=>{if(this.j)try{this.y.debug("Auto Sync: Waiting until sync is finished."),await this.j}catch(v){if((0,L.$3)(v))return}return this.H(i,t,o)});return this.j=r,this.j.finally(()=>this.j=void 0),this.j}F(){return this.m!==void 0&&!(0,d.$pg)(this.m,this.r.userDataSyncStore?.url)}async G(){const i=await this.r.getPreviousUserDataSyncStore(),t=this.r.userDataSyncStore;return!!t&&!!i&&(!(0,d.$pg)(t.defaultUrl,i.defaultUrl)||!(0,d.$pg)(t.insidersUrl,i.insidersUrl)||!(0,d.$pg)(t.stableUrl,i.stableUrl))}async H(i,t,r){this.y.info(`Auto Sync: Triggered by ${i}`),this.c.fire();let o;try{await this.I(t,r)}catch(v){if(this.y.error(v),o=v,y.$jhb.toUserDataSyncError(v).code==="MethodNotFound")try{this.y.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.u.cleanUpRemoteData(),this.y.info("Auto Sync: Retrying sync..."),await this.I(t,r),o=void 0}catch(p){this.y.error(p),o=p}}this.f.fire(o)}async I(i,t){if(this.h=await this.u.createSyncTask(this.g,i),t.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.u.hasPreviouslySynced())throw this.F()?await this.G()?new y.$lhb((0,E.localize)(0,null),"DefaultServiceChanged"):new y.$lhb((0,E.localize)(1,null),"ServiceChanged"):new y.$lhb((0,E.localize)(2,null),"TurnedOff");const r=this.C.get(f,-1);if(r&&this.g&&r!==this.g.session)throw this.F()?await this.G()?new y.$lhb((0,E.localize)(3,null),"DefaultServiceChanged"):new y.$lhb((0,E.localize)(4,null),"ServiceChanged"):new y.$lhb((0,E.localize)(5,null),"SessionExpired");const o=await this.w.getMachines(this.g||void 0);if(t.isCancellationRequested)return;const v=o.find(h=>h.isCurrent);if(v?.disabled)throw new y.$lhb((0,E.localize)(6,null),"TurnedOff");const p=new Date().getTime();if(await this.h.run(),this.z.publicLog2("settingsSync:sync",{duration:new Date().getTime()-p}),this.g===null)try{this.g=await this.s.manifest(null)}catch(h){throw new y.$lhb((0,j.$Ei)(h),h instanceof y.$jhb?h.code:"Unknown")}this.g&&this.g.session!==r&&this.C.store(f,this.g.session,-1,1),!t.isCancellationRequested&&(v||await this.w.addCurrentMachine(this.g||void 0))}register(i){return super.B(i)}}}),define(ae[255],ce([0,1,10,176,14,11,43,21,28,24,17,39,118,117,116,20,119,114,115,4,120,42,27]),function(ie,e,I,N,j,L,O,R,S,d,P,E,b,l,$,y,w,c,u,f,m,k,s){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$36b=void 0;let n=class{static{a=this}static{this.a="not-existing-resource"}static{this.b="remote-backup"}static{this.c="local-backup"}constructor(t,r,o,v,p,h,g,D,T,M){this.e=t,this.f=r,this.g=o,this.h=p,this.i=h,this.j=g,this.k=D,this.l=T,this.n=M,this.d=v.extUri}async getRemoteSyncedProfiles(){const t=await this.e.readResource("profiles",null,void 0);if(t.content){const r=this.L(t.content,"profiles");return(0,m.$q6b)(r)}return[]}async getLocalSyncedProfiles(t){const r=await this.f.getAllResourceRefs("profiles",void 0,t);if(r.length){const o=await this.f.resolveResourceContent("profiles",r[0].ref,void 0,t);if(o){const v=this.L(o,"profiles");return(0,m.$q6b)(v)}}return[]}async getLocalSyncedMachines(t){const r=await this.f.getAllResourceRefs("machines",void 0,t);if(r.length){const o=await this.f.resolveResourceContent("machines",r[0].ref,void 0,t);if(o)return JSON.parse(o).machines.map(p=>({...p,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(t,r){return(await this.e.getAllResourceRefs(t,r?.collection)).map(({created:v,ref:p})=>({created:v,uri:this.J({remote:!0,syncResource:t,profile:r?.id??this.k.defaultProfile.id,location:void 0,collection:r?.collection,ref:p,node:void 0})}))}async getLocalSyncResourceHandles(t,r,o){return(await this.f.getAllResourceRefs(t,r?.collection,o)).map(({created:p,ref:h})=>({created:p,uri:this.J({remote:!1,syncResource:t,profile:r?.id??this.k.defaultProfile.id,collection:r?.collection,ref:h,node:void 0,location:o})}))}resolveUserDataSyncResource({uri:t}){const r=this.K(t),o=r?this.k.profiles.find(v=>v.id===r.profile):void 0;return r&&o?{profile:o,syncResource:r?.syncResource}:void 0}async getAssociatedResources({uri:t}){const r=this.K(t);if(!r)return[];const o=this.k.profiles.find(v=>v.id===r.profile);switch(r.syncResource){case"settings":return this.s(t,o);case"keybindings":return this.u(t,o);case"tasks":return this.w(t,o);case"snippets":return this.y(t,o);case"globalState":return this.D(t,o);case"extensions":return this.A(t,o);case"profiles":return this.G(t,o);case"workspaceState":return[]}}async getMachineId({uri:t}){const r=this.K(t);if(r){if(r.remote){if(r.ref){const{content:o}=await this.M(r.syncResource,r.ref,r.collection);if(o)return this.L(o,r.syncResource)?.machineId}return}if(r.location){if(r.ref){const o=await this.f.resolveResourceContent(r.syncResource,r.ref,r.collection,r.location);if(o)return this.L(o,r.syncResource)?.machineId}return}return(0,O.$dp)(this.h,this.j,this.i)}}async resolveContent(t){const r=this.K(t);if(!r||r.node===a.a)return null;if(r.ref){const o=await this.o(r.remote,r.syncResource,r.collection,r.ref,r.location);return r.node&&o?this.q(r.syncResource,o,r.node):o}return!r.remote&&!r.node?this.r(r.syncResource,r.profile):null}async o(t,r,o,v,p){if(t){const{content:h}=await this.M(r,v,o);return h}return this.f.resolveResourceContent(r,v,o,p)}q(t,r,o){const v=this.L(r,t);switch(t){case"settings":return this.t(v,o);case"keybindings":return this.v(v,o);case"tasks":return this.x(v,o);case"snippets":return this.z(v,o);case"globalState":return this.E(v,o);case"extensions":return this.B(v,o);case"profiles":return this.H(v,o);case"workspaceState":return null}}async r(t,r){const o=this.k.profiles.find(v=>v.id===r);if(!o)return null;switch(t){case"globalState":return this.F(o);case"extensions":return this.C(o);case"profiles":return this.I(o);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null;case"workspaceState":return null}}s(t,r){const o=this.d.joinPath(t,"settings.json"),v=r?r.settingsResource:this.d.joinPath(t,a.a);return[{resource:o,comparableResource:v}]}t(t,r){switch(r){case"settings.json":return(0,l.$B4b)(t.content).settings}return null}u(t,r){const o=this.d.joinPath(t,"keybindings.json"),v=r?r.keybindingsResource:this.d.joinPath(t,a.a);return[{resource:o,comparableResource:v}]}v(t,r){switch(r){case"keybindings.json":return(0,$.$y4b)(t.content,!!this.l.getValue(d.$0gb),this.g)}return null}w(t,r){const o=this.d.joinPath(t,"tasks.json"),v=r?r.tasksResource:this.d.joinPath(t,a.a);return[{resource:o,comparableResource:v}]}x(t,r){switch(r){case"tasks.json":return(0,w.$J4b)(t.content,this.g)}return null}async y(t,r){const o=await this.resolveContent(t);if(o){const v=this.L(o,"snippets");if(v){const p=(0,b.$G4b)(v),h=[];for(const g of Object.keys(p)){const D=this.d.joinPath(t,g),T=r?this.d.joinPath(r.snippetsHome,g):this.d.joinPath(t,a.a);h.push({resource:D,comparableResource:T})}return h}}return[]}z(t,r){return(0,b.$G4b)(t)[r]||null}A(t,r){const o=this.d.joinPath(t,"extensions.json"),v=r?this.J({remote:!1,syncResource:"extensions",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,a.a);return[{resource:o,comparableResource:v}]}B(t,r){switch(r){case"extensions.json":return(0,c.$t4b)((0,c.$s4b)(t),!0)}return null}async C(t){const{localExtensions:r}=await this.n.createInstance(c.$v4b).getLocalExtensions(t);return(0,c.$t4b)(r,!0)}D(t,r){const o=this.d.joinPath(t,"globalState.json"),v=r?this.J({remote:!1,syncResource:"globalState",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,a.a);return[{resource:o,comparableResource:v}]}E(t,r){switch(r){case"globalState.json":return(0,u.$UEb)(JSON.parse(t.content),!0)}return null}async F(t){const r=await this.n.createInstance(u.$WEb).getLocalGlobalState(t);return(0,u.$UEb)(r,!0)}G(t,r){const o=this.d.joinPath(t,"profiles.json"),v=this.J({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:o,comparableResource:v}]}H(t,r){switch(r){case"profiles.json":return(0,k.$lT)(JSON.parse(t.content),{})}return null}async I(t){return(0,m.$p6b)(this.k.profiles.filter(r=>!r.isDefault&&!r.isTransient),!0)}J(t){const r=t.remote?a.b:a.c,o=[];return t.location&&(o.push(`scheme:${t.location.scheme}`),o.push(`authority:${t.location.authority}`),o.push((0,s.$Je)(t.location.path,"/"))),o.push(`syncResource:${t.syncResource}`),o.push(`profile:${t.profile}`),t.collection&&o.push(`collection:${t.collection}`),t.ref&&o.push(`ref:${t.ref}`),t.node&&o.push(t.node),this.d.joinPath(I.URI.from({scheme:d.$vhb,authority:r,path:"/",query:t.location?.query,fragment:t.location?.fragment}),...o)}K(t){if(t.scheme!==d.$vhb)return;const r=[];for(;t.path!=="/";)r.unshift(this.d.basename(t)),t=this.d.dirname(t);if(r.length<2)return;const o=t.authority===a.b;let v,p;const h=[];let g,D,T,M,z;for(;r.length;){const B=r.shift();B.startsWith("scheme:")?v=B.substring(7):B.startsWith("authority:")?p=B.substring(10):B.startsWith("syncResource:")?g=B.substring(13):B.startsWith("profile:")?D=B.substring(8):B.startsWith("collection:")?T=B.substring(11):B.startsWith("ref:")?M=B.substring(4):g?z=B:h.push(B)}return{remote:o,syncResource:g,profile:D,collection:T,ref:M,node:z,location:v&&p!==void 0?this.d.joinPath(I.URI.from({scheme:v,authority:p,query:t.query,fragment:t.fragment,path:"/"}),...h):void 0}}L(t,r){try{const o=JSON.parse(t);if((0,E.$NEb)(o))return o}catch(o){this.g.error(o)}throw new d.$jhb((0,N.localize)(0,null),"IncompatibleRemoteContent",r)}async M(t,r,o){const v=await this.e.resolveResourceContent(t,r,o);return{ref:r,content:v}}};e.$36b=n,e.$36b=n=a=pe([X(0,d.$ehb),X(1,d.$fhb),X(2,d.$thb),X(3,S.$Mk),X(4,j.$1h),X(5,R.$0o),X(6,L.$ck),X(7,P.$Ok),X(8,y.$ni),X(9,f.$Sh)],n)}),define(ae[256],ce([0,1,18,6,26,38,3,2,19,12,32,20,29,11,4,21,22,17,114,115,116,117,118,119,120,24]),function(ie,e,I,N,j,L,O,R,S,d,P,E,b,l,$,y,w,c,u,f,m,k,s,a,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r6b=void 0;const t="sync.lastSyncTime";let r=class extends R.$Rc{get status(){return this.f}get conflicts(){return this.j}get lastSyncTime(){return this.t}constructor(g,D,T,M,z,B,Z,K,x,H,Y){super(),this.C=g,this.D=D,this.F=T,this.G=M,this.H=z,this.I=B,this.J=Z,this.L=K,this.M=x,this.N=H,this.O=Y,this.f="uninitialized",this.g=this.B(new O.$Od),this.onDidChangeStatus=this.g.event,this.h=this.B(new O.$Od),this.onDidChangeLocal=this.h.event,this.j=[],this.m=this.B(new O.$Od),this.onDidChangeConflicts=this.m.event,this.n=[],this.r=this.B(new O.$Od),this.onSyncErrors=this.r.event,this.t=void 0,this.u=this.B(new O.$Od),this.onDidChangeLastSyncTime=this.u.event,this.w=this.B(new O.$Od),this.onDidResetLocal=this.w.event,this.y=this.B(new O.$Od),this.onDidResetRemote=this.y.event,this.z=new Map,this.f=T.userDataSyncStore?"idle":"uninitialized",this.t=this.J.getNumber(t,-1,void 0),this.B((0,R.$Pc)(()=>this.bb()))}async createSyncTask(g,D){this.cb(),this.H.info("Sync started.");const T=new Date().getTime(),M=(0,P.$fg)();try{const K=(0,i.$ihb)(M);D&&(K["Cache-Control"]="no-cache"),g=await this.D.manifest(g,K)}catch(K){const x=i.$jhb.toUserDataSyncError(K);throw p(x,M,this.F,this.I),x}const z=!1,B=this;let Z;return{manifest:g,async run(){if(z)throw new Error("Can run a task only once");Z=(0,N.$Ig)(K=>B.P(g,!1,M,K)),await Z.finally(()=>Z=void 0),B.H.info(`Sync done. Took ${new Date().getTime()-T}ms`),B.$()},stop(){return Z?.cancel(),B.U()}}}async createManualSyncTask(){if(this.cb(),this.L.isEnabled())throw new i.$jhb("Cannot start manual sync when sync is enabled","LocalError");this.H.info("Sync started.");const g=new Date().getTime(),D=(0,P.$fg)(),T=(0,i.$ihb)(D);let M;try{M=await this.D.manifest(null,T)}catch(Z){const K=i.$jhb.toUserDataSyncError(Z);throw p(K,D,this.F,this.I),K}await this.resetLocal();const z=this,B=new j.$Yd;return{id:D,async merge(){return z.P(M,!0,D,B.token)},async apply(){try{try{await z.R(M,D,B.token)}catch(Z){if(i.$jhb.toUserDataSyncError(Z).code==="MethodNotFound")z.H.info("Client is making invalid requests. Cleaning up data..."),await z.cleanUpRemoteData(),z.H.info("Applying manual sync again..."),await z.R(M,D,B.token);else throw Z}}catch(Z){throw z.H.error(Z),Z}z.H.info(`Sync done. Took ${new Date().getTime()-g}ms`),z.$()},async stop(){B.cancel(),await z.U(),await z.resetLocal()}}}async P(g,D,T,M){this.n=[];try{this.status!=="hasConflicts"&&this.Y("syncing");const z=this.getOrCreateActiveProfileSynchronizer(this.M.defaultProfile,void 0);this.n.push(...await this.S(z,g,D,T,M));const B=z.enabled.find(Z=>Z.resource==="profiles");if(B){const Z=await B.getLastSyncedProfiles()||[];if(M.isCancellationRequested)return;await this.Q(Z,g,D,T,M)}}finally{this.status!=="hasConflicts"&&this.Y("idle"),this.r.fire(this.n)}}async Q(g,D,T,M,z){for(const B of g){if(z.isCancellationRequested)return;const Z=this.M.profiles.find(x=>x.id===B.id);if(!Z){this.H.error(`Profile with id:${B.id} and name: ${B.name} does not exist locally to sync.`);continue}this.H.info("Syncing profile.",B.name);const K=this.getOrCreateActiveProfileSynchronizer(Z,B);this.n.push(...await this.S(K,D,T,M,z))}for(const[B,Z]of this.z.entries())this.M.profiles.some(K=>K.id===Z[0].profile.id)||(Z[1].dispose(),this.z.delete(B))}async R(g,D,T){const M=this.ab();for(const x of M){if(T.isCancellationRequested)return;await x.apply(D,T)}const z=M.find(x=>x.profile.isDefault);if(!z)return;const B=z.enabled.find(x=>x.resource==="profiles");if(!B)return;const K=(await B.getRemoteSyncedProfiles(g?.latest??null)||[]).filter(x=>M.every(H=>H.profile.id!==x.id));K.length&&await this.Q(K,g,!1,D,T)}async S(g,D,T,M,z){return(await g.sync(D,T,M,z)).map(([Z,K])=>({profile:g.profile,syncResource:Z,error:K}))}async U(){this.status!=="idle"&&await Promise.allSettled(this.ab().map(g=>g.stop()))}async resolveContent(g){const D=await this.N.resolveContent(g);if(D)return D;for(const T of this.ab())for(const M of T.enabled){const z=await M.resolveContent(g);if(z)return z}return null}async replace(g){this.cb();const D=this.N.resolveUserDataSyncResource(g);if(!D)return;const T=await this.resolveContent(g.uri);T&&await this.W(D.profile,async M=>{if(D.syncResource===M.resource)return await M.replace(T),!0})}async accept(g,D,T,M){this.cb(),await this.W(g.profile,async z=>{if(g.syncResource===z.resource)return await z.accept(D,T),M&&await z.apply((0,d.$Ff)(M)?!1:M.force,(0,i.$ihb)((0,P.$fg)())),!0})}async hasLocalData(){return!!await this.W(this.M.defaultProfile,async D=>{if(D.resource!=="globalState"&&await D.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.W(this.M.defaultProfile,async D=>{if(await D.hasPreviouslySynced())return!0})}async reset(){this.cb(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.cb();try{await this.D.clear(),this.H.info("Cleared data on server")}catch(g){this.H.error(g)}this.y.fire()}async resetLocal(){this.cb(),this.t=void 0,this.J.remove(t,-1);for(const[g]of this.z.values())try{await g.resetLocal()}catch(D){this.H.error(D)}this.bb(),this.w.fire(),this.H.info("Did reset the local sync state.")}async cleanUpRemoteData(){const g=await this.N.getRemoteSyncedProfiles(),D=g.map(B=>B.collection),T=await this.D.getAllCollections(),M=T.filter(B=>!D.includes(B));M.length&&(this.H.info(`Deleting ${M.length} redundant collections on server`),await Promise.allSettled(M.map(B=>this.D.deleteCollection(B))),this.H.info("Deleted redundant collections on server"));const z=g.filter(B=>T.includes(B.collection));if(z.length!==g.length){const B=this.G.createInstance(n.$o6b,this.M.defaultProfile,void 0);try{this.H.info("Resetting the last synced state of profiles"),await B.resetLocal(),this.H.info("Did reset the last synced state of profiles"),this.H.info("Updating remote profiles with invalid collections on server"),await B.updateRemoteProfiles(z,null),this.H.info("Updated remote profiles on server")}finally{B.dispose()}}}async saveRemoteActivityData(g){this.cb();const D=await this.D.getActivityData();await this.C.writeFile(g,D)}async extractActivityData(g,D){const T=(await this.C.readFile(g)).value.toString(),M=JSON.parse(T);if(M.resources)for(const z in M.resources)for(const B of M.resources[z])await this.O.writeResource(z,B.content,new Date(B.created*1e3),void 0,D);if(M.collections)for(const z in M.collections)for(const B in M.collections[z].resources)for(const Z of M.collections[z].resources?.[B]??[])await this.O.writeResource(B,Z.content,new Date(Z.created*1e3),z,D)}async W(g,D){const T=new R.$Qc;try{const M=this.z.get(g.id);if(M){const x=await this.X(M[0],D,T);return(0,d.$Gf)(x)?null:x}if(g.isDefault){const x=T.add(this.G.createInstance(o,g,void 0)),H=await this.X(x,D,T);return(0,d.$Gf)(H)?null:H}if(this.M.isEnabled())return null;const z=T.add(this.G.createInstance(n.$o6b,g,void 0)),B=await this.D.manifest(null),K=(await z.getRemoteSyncedProfiles(B?.latest??null)||[]).find(x=>x.id===g.id);if(K){const x=T.add(this.G.createInstance(o,g,K.collection)),H=await this.X(x,D,T);return(0,d.$Gf)(H)?null:H}return null}finally{T.dispose()}}async X(g,D,T){const M=[...g.enabled,...g.disabled.reduce((z,B)=>(B!=="workspaceState"&&z.push(T.add(g.createSynchronizer(B))),z),[])];for(const z of M){const B=await D(z);if(!(0,d.$Gf)(B))return B}}Y(g){const D=this.f;this.f!==g&&(this.f=g,this.g.fire(g),D==="hasConflicts"&&this.$())}Z(){const g=this.ab().map(D=>D.conflicts).flat();(0,I.$tb)(this.j,g,(D,T)=>D.profile.id===T.profile.id&&D.syncResource===T.syncResource&&(0,I.$tb)(D.conflicts,T.conflicts,(M,z)=>(0,S.$pg)(M.previewResource,z.previewResource)))||(this.j=g,this.m.fire(g))}$(){this.status==="idle"&&(this.t=new Date().getTime(),this.J.store(t,this.t,-1,1),this.u.fire(this.t))}getOrCreateActiveProfileSynchronizer(g,D){let T=this.z.get(g.id);if(T&&T[0].collection!==D?.collection&&(this.H.error("Profile synchronizer collection does not match with the remote sync profile collection"),T[1].dispose(),T=void 0,this.z.delete(g.id)),!T){const M=new R.$Qc,z=M.add(this.G.createInstance(o,g,D?.collection));M.add(z.onDidChangeStatus(B=>this.Y(B))),M.add(z.onDidChangeConflicts(B=>this.Z())),M.add(z.onDidChangeLocal(B=>this.h.fire(B))),this.z.set(g.id,T=[z,M])}return T[0]}ab(){const g=[];for(const[D]of this.z.values())g.push(D);return g}bb(){this.z.forEach(([,g])=>g.dispose()),this.z.clear()}cb(){if(!this.F.userDataSyncStore)throw new Error("Not enabled")}};e.$r6b=r,e.$r6b=r=pe([X(0,l.$ck),X(1,i.$ehb),X(2,i.$dhb),X(3,$.$Sh),X(4,i.$thb),X(5,w.$gl),X(6,y.$0o),X(7,i.$ohb),X(8,c.$Ok),X(9,i.$qhb),X(10,i.$fhb)],r);let o=class extends R.$Rc{get enabled(){return this.f.sort((g,D)=>g[1]-D[1]).map(([g])=>g)}get disabled(){return i.$ahb.filter(g=>!this.r.isResourceEnabled(g))}get status(){return this.g}get conflicts(){return this.m}constructor(g,D,T,M,z,B,Z,K,x,H){super(),this.profile=g,this.collection=D,this.r=T,this.t=M,this.u=z,this.w=B,this.y=Z,this.z=K,this.C=x,this.D=H,this.f=[],this.g="idle",this.h=this.B(new O.$Od),this.onDidChangeStatus=this.h.event,this.j=this.B(new O.$Od),this.onDidChangeLocal=this.j.event,this.m=[],this.n=this.B(new O.$Od),this.onDidChangeConflicts=this.n.event,this.B(T.onDidChangeResourceEnablement(([Y,G])=>this.F(Y,G))),this.B((0,R.$Pc)(()=>this.f.splice(0,this.f.length).forEach(([,,Y])=>Y.dispose())));for(const Y of i.$ahb)T.isResourceEnabled(Y)&&this.G(Y)}F(g,D){D?this.G(g):this.H(g)}G(g){if(this.f.some(([z])=>z.resource===g))return;if(g==="extensions"&&!this.u.isEnabled()){this.z.info("Skipping extensions sync because gallery is not configured");return}if(g==="profiles"&&(!this.profile.isDefault||!this.C.isEnabled())||g==="workspaceState")return;if(g!=="profiles"&&this.profile.useDefaultFlags?.[g]){this.z.debug(`Skipping syncing ${g} in ${this.profile.name} because it is already synced by default profile`);return}const D=new R.$Qc,T=D.add(this.createSynchronizer(g));D.add(T.onDidChangeStatus(()=>this.L())),D.add(T.onDidChangeConflicts(()=>this.M())),D.add(T.onDidChangeLocal(()=>this.j.fire(g)));const M=this.N(g);this.f.push([T,M,D])}H(g){const D=this.f.findIndex(([T])=>T.resource===g);if(D!==-1){const[[T,,M]]=this.f.splice(D,1);M.dispose(),this.L(),Promise.allSettled([T.stop(),T.resetLocal()]).then(null,z=>this.z.error(z))}}createSynchronizer(g){switch(g){case"settings":return this.t.createInstance(k.$C4b,this.profile,this.collection);case"keybindings":return this.t.createInstance(m.$z4b,this.profile,this.collection);case"snippets":return this.t.createInstance(s.$H4b,this.profile,this.collection);case"tasks":return this.t.createInstance(a.$K4b,this.profile,this.collection);case"globalState":return this.t.createInstance(f.$VEb,this.profile,this.collection);case"extensions":return this.t.createInstance(u.$u4b,this.profile,this.collection);case"profiles":return this.t.createInstance(n.$o6b,this.profile,this.collection)}}async sync(g,D,T,M){if(M.isCancellationRequested)return[];const z=this.enabled;if(!z.length)return[];try{const B=[],Z=(0,i.$ihb)(T),K=(this.collection?g?.collections?.[this.collection]?.latest:g?.latest)??null,x=D?await this.I(K):{};for(const H of z){if(M.isCancellationRequested)return[];if(!this.r.isResourceEnabled(H.resource))return[];try{if(D){const Y=await H.preview(K,x,Z);if(Y)for(const G of Y.resourcePreviews)(G.localChange!==0||G.remoteChange!==0)&&G.mergeState==="preview"&&await H.merge(G.previewResource)}else await H.sync(K,Z)}catch(Y){const G=i.$jhb.toUserDataSyncError(Y);if(p(G,T,this.w,this.y),v(Y))throw G;this.z.error(Y),this.z.error(`${H.resource}: ${(0,L.$Ei)(Y)}`),B.push([H.resource,G])}}return B}finally{this.L()}}async apply(g,D){const T=(0,i.$ihb)(g);for(const M of this.enabled){if(D.isCancellationRequested)return;try{await M.apply(!1,T)}catch(z){const B=i.$jhb.toUserDataSyncError(z);if(p(B,g,this.w,this.y),v(z))throw B;this.z.error(z),this.z.error(`${M.resource}: ${(0,L.$Ei)(z)}`)}}}async stop(){for(const g of this.enabled)try{g.status!=="idle"&&await g.stop()}catch(D){this.z.error(D)}}async resetLocal(){for(const g of this.enabled)try{await g.resetLocal()}catch(D){this.z.error(`${g.resource}: ${(0,L.$Ei)(D)}`),this.z.error(D)}}async I(g){if(!this.profile.isDefault)return{};const D=this.D.getValue(i.$9gb),T=this.enabled.find(M=>M instanceof k.$C4b);if(T){const M=await T.getRemoteUserDataSyncConfiguration(g);return{...D,...M}}return D}J(g){this.g!==g&&(this.g=g,this.h.fire(g))}L(){return this.M(),this.enabled.some(g=>g.status==="hasConflicts")?this.J("hasConflicts"):this.enabled.some(g=>g.status==="syncing")?this.J("syncing"):this.J("idle")}M(){const g=this.enabled.filter(D=>D.status==="hasConflicts").filter(D=>D.conflicts.conflicts.length>0).map(D=>D.conflicts);(0,I.$tb)(this.m,g,(D,T)=>D.syncResource===T.syncResource&&(0,I.$tb)(D.conflicts,T.conflicts,(M,z)=>(0,S.$pg)(M.previewResource,z.previewResource)))||(this.m=g,this.n.fire(g))}N(g){switch(g){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6;case"workspaceState":return 7}}};o=pe([X(2,i.$ohb),X(3,$.$Sh),X(4,b.$bo),X(5,i.$dhb),X(6,w.$gl),X(7,i.$thb),X(8,c.$Ok),X(9,E.$ni)],o);function v(h){if(h instanceof i.$jhb)switch(h.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function p(h,g,D,T){T.publicLog2("sync/error",{code:h.code,serverCode:h instanceof i.$khb?String(h.serverCode):void 0,url:h instanceof i.$khb?h.url:void 0,resource:h.resource,executionId:g,service:D.userDataSyncStore.url.toString()})}}),define(ae[257],ce([0,1,3,2,10,17,24]),function(ie,e,I,N,j,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q9b=e.$P9b=void 0;function R(b,l){return{...b,profile:(0,L.$Pk)(b.profile,l.profilesHome.scheme)}}function S(b){return{created:b.created,uri:j.URI.revive(b.uri)}}class d{constructor(l,$,y){this.c=l,this.d=$,this.f=y,this.a=new Map,this.b=new I.$Od}listen(l,$){switch($){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`Event not found: ${$}`)}async call(l,$,y){try{return await this.g(l,$,y)}catch(w){throw this.f.error(w),w}}async g(l,$,y){switch($){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(j.URI.revive(y[0]));case"accept":return this.c.accept(R(y[0],this.d),j.URI.revive(y[1]),y[2],y[3]);case"replace":return this.c.replace(S(y[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"getRemoteActivityData":return this.c.saveRemoteActivityData(j.URI.revive(y[0]));case"extractActivityData":return this.c.extractActivityData(j.URI.revive(y[0]),j.URI.revive(y[1]));case"createManualSyncTask":return this.i()}if($.startsWith("manualSync/")){const w=$.substring(11),c=y[0],u=this.h(c);switch(y=y.slice(1),w){case"merge":return u.merge();case"apply":return u.apply().then(()=>this.a.delete(this.j(u.id)));case"stop":return u.stop().finally(()=>this.a.delete(this.j(u.id)))}}throw new Error("Invalid call")}h(l){const $=this.a.get(this.j(l));if(!$)throw new Error(`Manual sync taks not found: ${l}`);return $}async i(){const l=await this.c.createManualSyncTask();return this.a.set(this.j(l.id),l),l.id}j(l){return`manualSyncTask-${l}`}}e.$P9b=d;let P=class extends N.$Rc{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(l,$){super(),this.n=$,this.b="uninitialized",this.c=this.B(new I.$Od),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new I.$Od),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.j=this.B(new I.$Od),this.onDidChangeLastSyncTime=this.j.event,this.m=this.B(new I.$Od),this.onSyncErrors=this.m.event,this.a={call(y,w,c){return l.call(y,w,c).then(null,u=>{throw O.$jhb.toUserDataSyncError(u)})},listen(y,w){return l.listen(y,w)}},this.a.call("_getInitialData").then(([y,w,c])=>{this.s(y),this.t(w),c&&this.u(c),this.B(this.a.listen("onDidChangeStatus")(u=>this.s(u))),this.B(this.a.listen("onDidChangeLastSyncTime")(u=>this.u(u)))}),this.B(this.a.listen("onDidChangeConflicts")(y=>this.t(y))),this.B(this.a.listen("onSyncErrors")(y=>this.m.fire(y.map(w=>({...w,error:O.$jhb.toUserDataSyncError(w.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const l=await this.a.call("createManualSyncTask"),$=this;return new E(l,{async call(w,c,u){return $.a.call(`manualSync/${w}`,[l,...Array.isArray(c)?c:[c]],u)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(l,$,y,w){return this.a.call("accept",[l,$,y,w])}resolveContent(l){return this.a.call("resolveContent",[l])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(l){return this.a.call("replace",[l])}saveRemoteActivityData(l){return this.a.call("getRemoteActivityData",[l])}extractActivityData(l,$){return this.a.call("extractActivityData",[l,$])}async s(l){this.b=l,this.c.fire(l)}async t(l){this.f=l.map($=>({syncResource:$.syncResource,profile:(0,L.$Pk)($.profile,this.n.profilesHome.scheme),conflicts:$.conflicts.map(y=>({...y,baseResource:j.URI.revive(y.baseResource),localResource:j.URI.revive(y.localResource),remoteResource:j.URI.revive(y.remoteResource),previewResource:j.URI.revive(y.previewResource)}))})),this.g.fire(this.f)}u(l){this.h!==l&&(this.h=l,this.j.fire(l))}};e.$Q9b=P,e.$Q9b=P=pe([X(1,L.$Ok)],P);class E extends N.$Rc{constructor(l,$){super(),this.id=l,this.a=$}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose")}}}),define(ae[258],ce([0,1,6,26,7,3,2,139,5,19,12,10,32,20,14,11,25,58,43,21,24]),function(ie,e,I,N,j,L,O,R,S,d,P,E,b,l,$,y,w,c,u,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LEb=e.$KEb=e.$JEb=e.$IEb=e.$HEb=void 0;const k="configurationSync.store",s="sync.previous.store",a="sync.donot-make-requests-until",n="sync.user-session-id",i="sync.machine-session-id",t=100,r=1e3*60*5;let o=class extends O.$Rc{get userDataSyncStore(){return this.b}get c(){return this.h.get(m.$mhb,-1)}set c(T){this.h.store(m.$mhb,T,-1,S.$p?0:1)}constructor(T,M,z){super(),this.f=T,this.g=M,this.h=z,this.a=this.B(new L.$Od),this.onDidChangeUserDataSyncStore=this.a.event,this.j();const B=this.B(new O.$Qc);this.B(L.Event.filter(z.onDidChangeValue(-1,m.$mhb,B),()=>this.c!==this.userDataSyncStore?.type,B)(()=>this.j()))}j(){this.b=this.m(this.f[k]),this.a.fire()}m(T){if(T&&(T=S.$p&&T.web?{...T,...T.web}:T,(0,P.$zf)(T.url)&&(0,P.$Bf)(T.authenticationProviders)&&Object.keys(T.authenticationProviders).every(M=>Array.isArray(T.authenticationProviders[M].scopes)))){const M=T,z=!!M.canSwitch,B=M.url===M.insidersUrl?"insiders":"stable",Z=(z?this.c:void 0)||B,K=Z==="insiders"?M.insidersUrl:Z==="stable"?M.stableUrl:M.url;return{url:E.URI.parse(K),type:Z,defaultType:B,defaultUrl:E.URI.parse(M.url),stableUrl:E.URI.parse(M.stableUrl),insidersUrl:E.URI.parse(M.insidersUrl),canSwitch:z,authenticationProviders:Object.keys(M.authenticationProviders).reduce((x,H)=>(x.push({id:H,scopes:M.authenticationProviders[H].scopes}),x),[])}}}};e.$HEb=o,e.$HEb=o=pe([X(0,w.$tj),X(1,l.$ni),X(2,f.$0o)],o);let v=class extends o{constructor(T,M,z){super(T,M,z);const B=this.h.get(s,-1);B&&(this.n=JSON.parse(B));const Z=this.f[k];Z?this.h.store(s,JSON.stringify(Z),-1,1):this.h.remove(s,-1)}async switch(T){T!==this.c&&(this.c=T,this.j())}async getPreviousUserDataSyncStore(){return this.m(this.n)}};e.$IEb=v,e.$IEb=v=pe([X(0,w.$tj),X(1,l.$ni),X(2,f.$0o)],v);let p=class extends O.$Rc{get donotMakeRequestsUntil(){return this.j}constructor(T,M,z,B,Z,K,x){super(),this.n=z,this.r=B,this.s=x,this.g=this.B(new L.$Od),this.onTokenFailed=this.g.event,this.h=this.B(new L.$Od),this.onTokenSucceed=this.h.event,this.j=void 0,this.m=this.B(new L.$Od),this.onDidChangeDonotMakeRequestsUntil=this.m.event,this.w=void 0,this.t(T),this.c=(0,u.$dp)(Z,K,x).then(H=>{const Y={"X-Client-Name":`${M.applicationName}${S.$p?"-web":""}`,"X-Client-Version":M.version};return M.commit&&(Y["X-Client-Commit"]=M.commit),Y}),this.f=new g(t,r,this.n,this.r),this.u(),this.B((0,O.$Pc)(()=>{this.w&&(this.w.cancel(),this.w=void 0)}))}setAuthToken(T,M){this.b={token:T,type:M}}t(T){this.a=T?(0,d.$wg)(T,"v1"):void 0}u(){const T=this.s.getNumber(a,-1);T&&Date.now()<T&&this.y(new Date(T))}y(T){this.j?.getTime()!==T?.getTime()&&(this.j=T,this.w&&(this.w.cancel(),this.w=void 0),this.j?(this.s.store(a,this.j.getTime(),-1,1),this.w=(0,I.$Ig)(M=>(0,I.$Vg)(this.j.getTime()-Date.now(),M).then(()=>this.y(void 0))),this.w.then(null,M=>null)):this.s.remove(a,-1),this.m.fire())}async getAllCollections(T={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,d.$wg)(this.a,"collection").toString();T={...T},T["Content-Type"]="application/json";const z=await this.D(M,{type:"GET",headers:T},[],N.CancellationToken.None);return(await(0,c.$3o)(z))?.map(({id:B})=>B)||[]}async createCollection(T={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,d.$wg)(this.a,"collection").toString();T={...T},T["Content-Type"]=R.$Tr.text;const z=await this.D(M,{type:"POST",headers:T},[],N.CancellationToken.None),B=await(0,c.$2o)(z);if(!B)throw new m.$khb("Server did not return the collection id",M,"NoCollection",z.res.statusCode,z.res.headers[m.$ghb]);return B}async deleteCollection(T,M={}){if(!this.a)throw new Error("No settings sync store url configured.");const z=T?(0,d.$wg)(this.a,"collection",T).toString():(0,d.$wg)(this.a,"collection").toString();M={...M},await this.D(z,{type:"DELETE",headers:M},[],N.CancellationToken.None)}async getAllResourceRefs(T,M){if(!this.a)throw new Error("No settings sync store url configured.");const z=this.z(this.a,M,T),B={},Z=await this.D(z.toString(),{type:"GET",headers:B},[],N.CancellationToken.None);return(await(0,c.$3o)(Z)||[]).map(({url:x,created:H})=>({ref:(0,d.$yg)(z,z.with({path:x})),created:H*1e3}))}async resolveResourceContent(T,M,z,B={}){if(!this.a)throw new Error("No settings sync store url configured.");const Z=(0,d.$wg)(this.z(this.a,z,T),M).toString();B={...B},B["Cache-Control"]="no-cache";const K=await this.D(Z,{type:"GET",headers:B},[],N.CancellationToken.None);return await(0,c.$2o)(K)}async deleteResource(T,M,z){if(!this.a)throw new Error("No settings sync store url configured.");const B=M!==null?(0,d.$wg)(this.z(this.a,z,T),M).toString():this.z(this.a,z,T).toString(),Z={};await this.D(B,{type:"DELETE",headers:Z},[],N.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const T=(0,d.$wg)(this.a,"resource").toString(),M={"Content-Type":R.$Tr.text};await this.D(T,{type:"DELETE",headers:M},[],N.CancellationToken.None)}async readResource(T,M,z,B={}){if(!this.a)throw new Error("No settings sync store url configured.");const Z=(0,d.$wg)(this.z(this.a,z,T),"latest").toString();B={...B},B["Cache-Control"]="no-cache",M&&(B["If-None-Match"]=M.ref);const K=await this.D(Z,{type:"GET",headers:B},[304],N.CancellationToken.None);let x=null;if(K.res.statusCode===304&&(x=M),x===null){const H=K.res.headers.etag;if(!H)throw new m.$khb("Server did not return the ref",Z,"NoRef",K.res.statusCode,K.res.headers[m.$ghb]);const Y=await(0,c.$2o)(K);if(!Y&&K.res.statusCode===304)throw new m.$khb("Empty response",Z,"EmptyResponse",K.res.statusCode,K.res.headers[m.$ghb]);x={ref:H,content:Y}}return x}async writeResource(T,M,z,B,Z={}){if(!this.a)throw new Error("No settings sync store url configured.");const K=this.z(this.a,B,T).toString();Z={...Z},Z["Content-Type"]=R.$Tr.text,z&&(Z["If-Match"]=z);const x=await this.D(K,{type:"POST",data:M,headers:Z},[],N.CancellationToken.None),H=x.res.headers.etag;if(!H)throw new m.$khb("Server did not return the ref",K,"NoRef",x.res.statusCode,x.res.headers[m.$ghb]);return H}async manifest(T,M={}){if(!this.a)throw new Error("No settings sync store url configured.");const z=(0,d.$wg)(this.a,"manifest").toString();M={...M},M["Content-Type"]="application/json",T&&(M["If-None-Match"]=T.ref);const B=await this.D(z,{type:"GET",headers:M},[304],N.CancellationToken.None);let Z=null;if(B.res.statusCode===304&&(Z=T),!Z){const x=B.res.headers.etag;if(!x)throw new m.$khb("Server did not return the ref",z,"NoRef",B.res.statusCode,B.res.headers[m.$ghb]);const H=await(0,c.$2o)(B);if(!H&&B.res.statusCode===304)throw new m.$khb("Empty response",z,"EmptyResponse",B.res.statusCode,B.res.headers[m.$ghb]);H&&(Z={...JSON.parse(H),ref:x})}const K=this.s.get(n,-1);return K&&Z&&K!==Z.session&&this.C(),Z===null&&K&&this.C(),Z&&this.s.store(n,Z.session,-1,1),Z}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.C()}async getActivityData(){if(!this.a)throw new Error("No settings sync store url configured.");const T=(0,d.$wg)(this.a,"download").toString(),M={},z=await this.D(T,{type:"GET",headers:M},[],N.CancellationToken.None);if(!(0,c.$Yo)(z))throw new m.$khb("Server returned "+z.res.statusCode,T,"EmptyResponse",z.res.statusCode,z.res.headers[m.$ghb]);if((0,c.$Zo)(z))throw new m.$khb("Empty response",T,"EmptyResponse",z.res.statusCode,z.res.headers[m.$ghb]);return z.stream}z(T,M,z){return M?(0,d.$wg)(T,"collection",M,"resource",z):(0,d.$wg)(T,"resource",z)}C(){this.s.remove(n,-1),this.s.remove(i,-1)}async D(T,M,z,B){if(!this.b)throw new m.$khb("No Auth Token Available",T,"Unauthorized",void 0,void 0);if(this.j&&Date.now()<this.j.getTime())throw new m.$khb(`${M.type} request '${T}' failed because of too many requests (429).`,T,"TooManyRequestsAndRetryAfter",void 0,void 0);this.y(void 0);const Z=await this.c;M.headers={...M.headers||{},...Z,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.F(M.headers),this.r.trace("Sending request to server",{url:T,type:M.type,headers:{...M.headers,authorization:void 0}});let K;try{K=await this.f.request(T,M,B)}catch(V){if(!(V instanceof m.$khb)){let ee="RequestFailed";const ne=(0,j.$9)(V).toLowerCase();ne.includes("xhr timeout")?ee="RequestTimeout":ne.includes("protocol")&&ne.includes("not supported")?ee="RequestProtocolNotSupported":ne.includes("request path contains unescaped characters")?ee="RequestPathNotEscaped":ne.includes("headers must be an object")?ee="RequestHeadersNotObject":(0,j.$3)(V)&&(ee="RequestCanceled"),V=new m.$khb(`Connection refused for the request '${T}'.`,T,ee,void 0,void 0)}throw this.r.info("Request failed",T),V}const x=K.res.headers[m.$ghb],H={url:T,status:K.res.statusCode,"execution-id":M.headers[m.$hhb],"operation-id":x},Y=(0,c.$Yo)(K)||K.res.statusCode&&z.includes(K.res.statusCode);let G="";if(Y?this.r.trace("Request succeeded",H):(G=await(0,c.$1o)(K)||"",this.r.info("Request failed",H,G)),K.res.statusCode===401||K.res.statusCode===403){if(this.b=void 0,K.res.statusCode===401)throw this.g.fire("Unauthorized"),new m.$khb(`${M.type} request '${T}' failed because of Unauthorized (401).`,T,"Unauthorized",K.res.statusCode,x);if(K.res.statusCode===403)throw this.g.fire("Forbidden"),new m.$khb(`${M.type} request '${T}' failed because the access is forbidden (403).`,T,"Forbidden",K.res.statusCode,x)}if(this.h.fire(),K.res.statusCode===404)throw new m.$khb(`${M.type} request '${T}' failed because the requested resource is not found (404).`,T,"NotFound",K.res.statusCode,x);if(K.res.statusCode===405)throw new m.$khb(`${M.type} request '${T}' failed because the requested endpoint is not found (405). ${G}`,T,"MethodNotFound",K.res.statusCode,x);if(K.res.statusCode===409)throw new m.$khb(`${M.type} request '${T}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,T,"Conflict",K.res.statusCode,x);if(K.res.statusCode===410)throw new m.$khb(`${M.type} request '${T}' failed because the requested resource is not longer available (410).`,T,"Gone",K.res.statusCode,x);if(K.res.statusCode===412)throw new m.$khb(`${M.type} request '${T}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,T,"PreconditionFailed",K.res.statusCode,x);if(K.res.statusCode===413)throw new m.$khb(`${M.type} request '${T}' failed because of too large payload (413).`,T,"TooLarge",K.res.statusCode,x);if(K.res.statusCode===426)throw new m.$khb(`${M.type} request '${T}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,T,"UpgradeRequired",K.res.statusCode,x);if(K.res.statusCode===429){const V=K.res.headers["retry-after"];throw V?(this.y(new Date(Date.now()+parseInt(V)*1e3)),new m.$khb(`${M.type} request '${T}' failed because of too many requests (429).`,T,"TooManyRequestsAndRetryAfter",K.res.statusCode,x)):new m.$khb(`${M.type} request '${T}' failed because of too many requests (429).`,T,"RemoteTooManyRequests",K.res.statusCode,x)}if(!Y)throw new m.$khb("Server returned "+K.res.statusCode,T,"Unknown",K.res.statusCode,x);return K}F(T){let M=this.s.get(i,-1);M===void 0&&(M=(0,b.$fg)(),this.s.store(i,M,-1,1)),T["X-Machine-Session-Id"]=M;const z=this.s.get(n,-1);z!==void 0&&(T["X-User-Session-Id"]=z)}};e.$JEb=p,e.$JEb=p=pe([X(1,w.$tj),X(2,c.$Wo),X(3,m.$thb),X(4,$.$1h),X(5,y.$ck),X(6,f.$0o)],p);let h=class extends p{constructor(T,M,z,B,Z,K,x){super(T.userDataSyncStore?.url,M,z,B,Z,K,x),this.B(T.onDidChangeUserDataSyncStore(()=>this.t(T.userDataSyncStore?.url)))}};e.$KEb=h,e.$KEb=h=pe([X(0,m.$dhb),X(1,w.$tj),X(2,c.$Wo),X(3,m.$thb),X(4,$.$1h),X(5,y.$ck),X(6,f.$0o)],h);class g{constructor(T,M,z,B){this.c=T,this.d=M,this.f=z,this.g=B,this.a=[],this.b=void 0}request(T,M,z){if(this.h()&&this.i(),M.url=T,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new m.$khb(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,T,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(T),this.f.request(M,z)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.$LEb=g}),define(ae[259],ce([0,1,3,56,25,21,22,254,24,79,82]),function(ie,e,I,N,j,L,O,R,S,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$9b=void 0;let E=class extends R.$s6b{constructor(l,$,y,w,c,u,f,m,k,s,a){super(l,$,y,w,c,f,m,k,s,a),this.B(I.Event.debounce(I.Event.any(I.Event.map(u.onDidFocusMainWindow,()=>"windowFocus"),I.Event.map(u.onDidOpenMainWindow,()=>"windowOpen")),(n,i)=>n?[...n,i]:[i],1e3)(n=>this.triggerSync(n,!0,!1)))}};e.$$9b=E,e.$$9b=E=pe([X(0,j.$tj),X(1,S.$dhb),X(2,S.$ehb),X(3,S.$ohb),X(4,S.$phb),X(5,N.$27b),X(6,S.$thb),X(7,d.$mDb),X(8,O.$gl),X(9,P.$4gb),X(10,L.$0o)],E)}),define(ae[260],ce([0,1,71,23,5,19]),function(ie,e,I,N,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w7b=e.$v7b=e.$u7b=e.$t7b=void 0,e.$t7b=128/4;function O(d){function P(){let E=d.scheme===N.Schemas.file?(0,L.$kg)(d):d.toString();return j.$l||(E=E.toLowerCase()),(0,I.createHash)("md5").update(E).digest("hex")}return{id:P(),configPath:d}}e.$u7b=O;function R(d,P){function E(){if(d.scheme!==N.Schemas.file)return(0,I.createHash)("md5").update(d.toString()).digest("hex");if(!P)return;let l;return j.$l?l=P.ino:j.$k?l=P.birthtime.getTime():j.$j&&(typeof P.birthtimeMs=="number"?l=Math.floor(P.birthtimeMs):l=P.birthtime.getTime()),(0,I.createHash)("md5").update(d.fsPath).update(l?String(l):"").digest("hex")}const b=E();if(typeof b=="string")return{id:b,uri:d}}e.$v7b=R;function S(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$w7b=S}),define(ae[261],ce([0,1,6,7,2,16,31,14,8,76,112,260,56,55,23]),function(ie,e,I,N,j,L,O,R,S,d,P,E,b,l,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E9b=void 0;let y=class extends j.$Rc{constructor(c,u,f,m){super(),this.a=c,this.b=u,this.c=f,this.f=m,this.B(new I.$8g(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const c=this.a.workspaceStorageHome.with({scheme:$.Schemas.file}).fsPath,u=await O.Promises.readdir(c),f=new d.$XDb(this.f.getChannel("storage"));await Promise.all(u.map(async m=>{const k=(0,L.$ic)(c,m);m.length===E.$t7b||m===P.$6h.id||(await this.c.getWindows({includeAuxiliaryWindows:!1})).some(n=>n.workspace?.id===m)||await f.isUsed(k)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${m} as it seems to be an unused empty workspace.`),await O.Promises.rm(k))}))}catch(c){(0,N.$Z)(c)}}};e.$E9b=y,e.$E9b=y=pe([X(0,R.$2h),X(1,S.$bj),X(2,b.$27b),X(3,l.$d9b)],y)}),define(ae[83],ce([0,1,53,6,16,12,31,147,272,273]),function(ie,e,I,N,j,L,O,R,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=e.$rp=e.zip=e.$pp=e.$op=void 0,e.$op="end of central directory record signature not found";const P=new RegExp(e.$op);class E extends Error{constructor(a,n){let i=n.message;switch(a){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=a,this.cause=n}}e.$pp=E;function b(s){const a=s.externalFileAttributes>>16||33188;return[448,56,7].map(n=>a&n).reduce((n,i)=>n+i,a&61440)}function l(s){if(s instanceof E)return s;let a;return P.test(s.message)&&(a="CorruptZip"),new E(a,s)}function $(s,a,n,i,t,r){const o=j.$lc(a),v=j.$ic(i,o);if(!v.startsWith(i))return Promise.reject(new Error(R.localize(0,null,a)));const p=j.$ic(i,a);let h;return r.onCancellationRequested(()=>{h?.destroy()}),Promise.resolve(O.Promises.mkdir(v,{recursive:!0})).then(()=>new Promise((g,D)=>{if(!r.isCancellationRequested)try{h=(0,I.createWriteStream)(p,{mode:n}),h.once("close",()=>g()),h.once("error",D),s.once("error",D),s.pipe(h)}catch(T){D(T)}}))}function y(s,a,n,i){let t=(0,N.$Ig)(()=>Promise.resolve()),r=0;const o=i.onCancellationRequested(()=>{t.cancel(),s.close()});return new Promise((v,p)=>{const h=new N.$Pg,g=D=>{D.isCancellationRequested||(r++,s.readEntry())};s.once("error",p),s.once("close",()=>t.then(()=>{i.isCancellationRequested||s.entryCount===r?v():p(new E("Incomplete",new Error(R.localize(1,null,r,s.entryCount))))},p)),s.readEntry(),s.on("entry",D=>{if(i.isCancellationRequested)return;if(!n.sourcePathRegex.test(D.fileName)){g(i);return}const T=D.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(T)){const B=j.$ic(a,T);t=(0,N.$Ig)(Z=>O.Promises.mkdir(B,{recursive:!0}).then(()=>g(Z)).then(void 0,p));return}const M=c(s,D),z=b(D);t=(0,N.$Ig)(B=>h.queue(()=>M.then(Z=>$(Z,T,z,a,n,B).then(()=>g(B)))).then(null,p))})}).finally(()=>o.dispose())}function w(s,a=!1){return new Promise((n,i)=>{(0,S.open)(s,a?{lazyEntries:!0}:void 0,(t,r)=>{t?i(l(t)):n((0,L.$Kf)(r))})})}function c(s,a){return new Promise((n,i)=>{s.openReadStream(a,(t,r)=>{t?i(l(t)):n((0,L.$Kf)(r))})})}function u(s,a){return new Promise((n,i)=>{const t=new d.ZipFile;a.forEach(o=>{o.contents?t.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&t.addFile(o.localPath,o.path)}),t.end();const r=(0,I.createWriteStream)(s);t.outputStream.pipe(r),t.outputStream.once("error",i),r.once("error",i),r.once("finish",()=>n(s))})}e.zip=u;function f(s,a,n={},i){const t=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let r=w(s,!0);return n.overwrite&&(r=r.then(o=>O.Promises.rm(a).then(()=>o))),r.then(o=>y(o,a,{sourcePathRegex:t},i))}e.$rp=f;function m(s,a){return w(s).then(n=>new Promise((i,t)=>{n.on("entry",r=>{r.fileName===a&&c(n,r).then(o=>i(o),o=>t(o))}),n.once("close",()=>t(new Error(R.localize(2,null,a))))}))}function k(s,a){return m(s,a).then(n=>new Promise((i,t)=>{const r=[];n.once("error",t),n.on("data",o=>r.push(o)),n.on("end",()=>i(Buffer.concat(r)))}))}e.$sp=k}),define(ae[262],ce([0,1,6,7,2,23,19,54,12,32,31,83,20,14,29,33,97,11,8]),function(ie,e,I,N,j,L,O,R,S,d,P,E,b,l,$,y,w,c,u){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hp=void 0;let m=class extends j.$Rc{static{f=this}static{this.c=".sigzip"}constructor(s,a,n,i,t,r){super(),this.h=a,this.j=n,this.m=i,this.n=t,this.r=r,this.extensionsDownloadDir=s.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(s,a,n){await this.g;const i=(0,O.$wg)(this.extensionsDownloadDir,this.z(s));try{await this.w(s,i,r=>this.j.download(s,r,a))}catch(r){throw new $.$co(r.message,$.ExtensionManagementErrorCode.Download)}let t=!1;if(n&&this.t(s)){const r=await this.u(s);try{t=await this.n.verify(i.fsPath,r.fsPath,this.r.getLevel()===u.LogLevel.Trace)}catch(o){const v=o;if(t=v.code,v.output&&this.r.trace(`Extension signature verification details for ${s.identifier.id} ${s.version}:
${v.output}`),t===$.ExtensionSignaturetErrorCode.PackageIsInvalidZip||t===$.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new $.$co(E.$op,$.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(r)}catch(o){this.r.error(o)}}}return t===!0?this.r.info(`Extension signature is verified: ${s.identifier.id}`):t===!1?this.r.info(`Extension signature verification is not done: ${s.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${t}': ${s.identifier.id}`),{location:i,verificationStatus:t}}t(s){if(!s.isSigned)return!1;const a=this.m.getValue("extensions.verifySignature");return(0,S.$Ff)(a)?a:!0}async u(s){await this.g;const a=(0,O.$wg)(this.extensionsDownloadDir,`${this.z(s)}${f.c}`);return await this.w(s,a,n=>this.j.downloadSignatureArchive(s,n)),a}async w(s,a,n){if(await this.h.exists(a))return;if(a.scheme!==L.Schemas.file){await n(a);return}const i=(0,O.$wg)(this.extensionsDownloadDir,`.${(0,d.$fg)()}`);await this.h.exists(i)||await n(i);try{await P.Promises.rename(i.fsPath,a.fsPath,2*60*1e3)}catch(t){try{await this.h.del(i)}catch{}if(t.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",s.identifier.id,a.path);else throw this.r.info(`Rename failed because of ${(0,N.$9)(t)}. Deleted the file from downloaded location`,i.path),t}}async delete(s){await this.g,await this.h.del(s)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const s=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(s.children){const a=[],n=[],i=[];for(const o of s.children)if(o.name.endsWith(f.c))i.push(o.resource);else{const v=y.$Eo.parse(o.name);v&&n.push([v,o])}const t=(0,y.$Jo)(n,([o])=>o),r=[];for(const o of t)o.sort((v,p)=>R.rcompare(v[0].version,p[0].version)),a.push(...o.slice(1).map(v=>v[1].resource)),r.push(o[0][1]);r.sort((o,v)=>o.mtime-v.mtime),a.push(...r.slice(0,Math.max(0,r.length-this.f)).map(o=>o.resource)),a.push(...i),await I.Promises.settled(a.map(o=>(this.r.trace("Deleting from cache",o.path),this.h.del(o))))}}catch(s){this.r.error(s)}}z(s){return this.f?y.$Eo.create(s).toString().toLowerCase():(0,d.$fg)()}};e.$Hp=m,e.$Hp=m=f=pe([X(0,l.$2h),X(1,c.$ck),X(2,$.$bo),X(3,b.$ni),X(4,w.$ip),X(5,u.$bj)],m)}),define(ae[263],ce([0,1,83,156]),function(ie,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=void 0;function j(L){return(0,I.$sp)(L,"extension/package.json").then(O=>{try{return JSON.parse(O.toString("utf8"))}catch{throw new Error((0,N.localize)(0,null))}})}e.$Jp=j}),define(ae[121],ce([0,1,6,15,26,38,7,3,52,2,34,23,16,19,54,12,10,32,31,83,155,96,14,242,29,33,51,80,262,243,263,212,223,69,11,4,8,25,22,28,17]),function(ie,e,I,N,j,L,O,R,S,d,P,E,b,l,$,y,w,c,u,f,m,k,s,a,n,i,t,r,o,v,p,h,g,D,T,M,z,B,Z,K,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=e.$Op=e.$Np=e.$Mp=void 0,e.$Mp=(0,M.$Uh)(n.$do);const H=".vsctmp";let Y=class extends a.$tp{constructor(Q,q,C,A,J,F,U,W,te,se,ue,le){super(Q,q,ue,C,se,le),this.fb=J,this.gb=F,this.hb=U,this.ib=te,this.eb=new Map,this.rb=new P.$Ac;const $e=this.B(W.createInstance(v.$Ip));this.bb=this.B(W.createInstance(G,we=>$e.postUninstall(we))),this.cb=this.B(new h.$Kp(le,te,ue,this,this.F)),this.db=this.B(W.createInstance(o.$Hp));const fe=this.B(new g.$Lp(this,this.fb,le,F,ue,te,C));this.B(fe.onDidChangeExtensionsByAnotherSource(we=>this.qb(we))),this.sb()}getTargetPlatform(){return this.jb||(this.jb=(0,i.$Oo)(this.ib,this.F)),this.jb}async zip(Q){this.F.trace("ExtensionManagementService#zip",Q.identifier.id);const q=await this.pb(Q),C=await(0,f.zip)((0,l.$wg)(this.db.extensionsDownloadDir,(0,c.$fg)()).fsPath,q);return w.URI.file(C)}async unzip(Q){return this.F.trace("ExtensionManagementService#unzip",Q.toString()),(await this.install(Q)).identifier}async getManifest(Q){const{location:q,cleanup:C}=await this.lb(Q),A=b.$jc(q.fsPath);try{return await(0,p.$Jp)(A)}finally{await C()}}getInstalled(Q,q=this.H.defaultProfile.extensionsResource){return this.bb.scanExtensions(Q??null,q)}scanAllUserInstalledExtensions(){return this.bb.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(Q){return this.bb.scanUserExtensionAtLocation(Q)}async install(Q,q={}){this.F.trace("ExtensionManagementService#install",Q.toString());const{location:C,cleanup:A}=await this.lb(Q);try{const J=await(0,p.$Jp)(b.$jc(C.fsPath)),F=(0,i.$Io)(J.publisher,J.name);if(J.engines&&J.engines.vscode&&!(0,D.$Vo)(J.engines.vscode,this.G.version,this.G.date))throw new Error(m.localize(0,null,F,this.G.version));const W=(await this.I([{manifest:J,extension:C,options:q}])).find(({identifier:te})=>(0,i.$Do)(te,{id:F}));if(W?.local)return W.local;throw W?.error?W.error:(0,a.$vp)(new Error(`Unknown error while installing extension ${F}`))}finally{await A()}}async installFromLocation(Q,q){this.F.trace("ExtensionManagementService#installFromLocation",Q.toString());const C=await this.bb.scanUserExtensionAtLocation(Q);if(!C)throw new Error(`Cannot find a valid extension from the location ${Q.toString()}`);return await this.ub([[C,void 0]],q),this.F.info("Successfully installed extension",C.identifier.id,q.toString()),C}async installExtensionsFromProfile(Q,q,C){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",Q,q.toString(),C.toString());const A=(await this.bb.scanExtensions(1,q)).filter(J=>Q.some(F=>(0,i.$Do)(F,J.identifier)));if(A.length){const J=await Promise.all(A.map(F=>this.bb.scanMetadata(F,q)));await this.ub(A.map((F,U)=>[F,J[U]]),C),this.F.info("Successfully installed extensions",A.map(F=>F.identifier.id),C.toString())}return A}async updateMetadata(Q,q,C=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",Q.identifier.id),q.isPreReleaseVersion&&(q.preRelease=!0),q.isMachineScoped===!1&&(q.isMachineScoped=void 0),q.isBuiltin===!1&&(q.isBuiltin=void 0),q.pinned===!1&&(q.pinned=void 0),Q=await this.bb.updateMetadata(Q,q,C),this.cb.invalidate(C),this.w.fire(Q),Q}async reinstallFromGallery(Q){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",Q.identifier.id),!this.z.isEnabled())throw new Error(m.localize(1,null));const q=await this.getTargetPlatform(),[C]=await this.z.getExtensions([{...Q.identifier,preRelease:Q.preRelease}],{targetPlatform:q,compatible:!0},j.CancellationToken.None);if(!C)throw new Error(m.localize(2,null));await this.bb.setUninstalled(Q);try{await this.bb.removeUninstalledExtension(Q)}catch(A){throw new Error(m.localize(3,null,(0,L.$Ei)(A)))}return this.installFromGallery(C)}ab(Q,q,C,A){return this.bb.copyExtension(Q,q,C,A)}copyExtensions(Q,q){return this.bb.copyExtensions(Q,q)}markAsUninstalled(...Q){return this.bb.setUninstalled(...Q)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.bb.cleanUp()}catch(Q){this.F.error(Q)}}async download(Q,q,C){const{location:A}=await this.db.download(Q,q,!C);return A}async lb(Q){if(Q.scheme===E.Schemas.file)return{location:Q,async cleanup(){}};this.F.trace("Downloading extension from",Q.toString());const q=(0,l.$wg)(this.db.extensionsDownloadDir,(0,c.$fg)());return await this.hb.download(Q,q),this.F.info("Downloaded extension to",q.toString()),{location:q,cleanup:async()=>{try{await this.ib.del(q)}catch(A){this.F.error(A)}}}}Y(){return this.H.defaultProfile.extensionsResource}Z(Q,q,C){if(w.URI.isUri(q))return new ne(Q,q,C,this.z,this.bb,this.D,this.H,this.fb,this.gb,this.F);const A=i.$Eo.create(q).toString();let J=this.eb.get(A);return J||(this.eb.set(A,J=new ee(Q,q,C,this.db,this.bb,this.D,this.H,this.fb,this.gb,this.F)),J.waitUntilTaskIsFinished().finally(()=>this.eb.delete(A))),J}$(Q,q){return new _(Q,q.profileLocation,this.gb)}async pb(Q){const q=async A=>{let J=await u.Promises.readdir(A);J=J.map(W=>b.$ic(A,W));const F=await Promise.all(J.map(W=>u.Promises.stat(W)));let U=Promise.resolve([]);return F.forEach((W,te)=>{const se=J[te];W.isFile()&&(U=U.then(ue=>[...ue,se])),W.isDirectory()&&(U=U.then(ue=>q(se).then(le=>[...ue,...le])))}),U};return(await q(Q.location.fsPath)).map(A=>({path:`extension/${b.$kc(Q.location.fsPath,A)}`,localPath:A}))}async qb({added:Q,removed:q}){if(q){const C=Q&&this.D.extUri.isEqual(q.profileLocation,Q.profileLocation)?q.extensions.filter(A=>Q.extensions.every(J=>!(0,i.$Do)(J,A))):q.extensions;for(const A of C)this.F.info("Extensions removed from another source",A.id,q.profileLocation.toString()),this.u.fire({identifier:A,profileLocation:q.profileLocation})}if(Q){const A=(await this.bb.scanExtensions(1,Q.profileLocation)).filter(J=>Q.extensions.some(F=>(0,i.$Do)(F,J.identifier)));this.s.fire(A.map(J=>(this.F.info("Extensions added from another source",J.identifier.id,Q.profileLocation.toString()),{identifier:J.identifier,local:J,profileLocation:Q.profileLocation,operation:1})))}}async sb(){this.B(this.bb.onExtract(q=>this.rb.add(q)));const Q=await this.ib.resolve(this.fb.userExtensionsLocation);for(const q of Q.children??[])q.isDirectory&&this.rb.add(q.resource);this.B(this.ib.watch(this.fb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(q=>this.tb(q)))}async tb(Q){if(!Q.affects(this.fb.userExtensionsLocation,1))return;const q=[];for(const C of Q.rawAdded){if(this.rb.has(C)||!this.D.extUri.isEqual(this.D.extUri.dirname(C),this.fb.userExtensionsLocation)||this.D.extUri.isEqual(C,this.D.extUri.joinPath(this.fb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(C).startsWith(".")||!(await this.ib.stat(C)).isDirectory)continue;const A=await this.bb.scanUserExtensionAtLocation(C);A&&A.installedTimestamp===void 0&&(this.rb.add(C),q.push(A))}q.length&&(await this.ub(q.map(C=>[C,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",q.map(C=>C.identifier.id)))}async ub(Q,q){const C=Q.map(A=>A[0]);await this.vb(C),await this.gb.addExtensionsToProfile(Q,q),this.s.fire(C.map(A=>({local:A,identifier:A.identifier,operation:1,profileLocation:q})))}async vb(Q){const q=await this.bb.getUninstalledExtensions();for(const C of Q){const A=i.$Eo.create(C);q[A.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",A.id),await this.bb.setInstalled(A),this.F.info("Removed the extension from uninstalled list:",A.id))}}};e.$Np=Y,e.$Np=Y=pe([X(0,n.$bo),X(1,Z.$gl),X(2,z.$bj),X(3,s.$2h),X(4,r.$Cp),X(5,t.$yp),X(6,k.$Sn),X(7,M.$Sh),X(8,T.$ck),X(9,B.$tj),X(10,K.$Mk),X(11,x.$Ok)],Y);let G=class extends d.$Rc{constructor(Q,q,C,A,J,F){super(),this.j=Q,this.m=q,this.n=C,this.s=A,this.t=J,this.u=F,this.h=this.B(new R.$Od),this.onExtract=this.h.event,this.c=(0,l.$wg)(this.n.userExtensionsLocation,".obsolete"),this.g=new I.$3g}async cleanUp(){await this.H(),await this.G()}async scanExtensions(Q,q){const C={includeInvalid:!0,profileLocation:q};let A=[];return Q===null||Q===0?A.push(...await this.n.scanAllExtensions({includeInvalid:!0},C,!1)):Q===1&&A.push(...await this.n.scanUserExtensions(C)),A=Q!==null?A.filter(J=>J.type===Q):A,Promise.all(A.map(J=>this.F(J)))}async scanAllUserExtensions(Q){const q=await this.n.scanUserExtensions({includeAllVersions:!Q,includeInvalid:!0});return Promise.all(q.map(C=>this.F(C)))}async scanUserExtensionAtLocation(Q){try{const q=await this.n.scanExistingExtension(Q,1,{includeInvalid:!0});if(q)return await this.F(q)}catch(q){this.u.error(q)}return null}async extractUserExtension(Q,q,C,A,J){const F=Q.toString(),U=w.URI.file(b.$ic(this.n.userExtensionsLocation.fsPath,`.${(0,c.$fg)()}`)),W=w.URI.file(b.$ic(this.n.userExtensionsLocation.fsPath,F));let te=await this.m.exists(W);if(te&&A){try{await this.y(Q.id,W,"removeExisting")}catch{throw new n.$co(m.localize(4,null,W.fsPath,Q.id),n.ExtensionManagementErrorCode.Delete)}te=!1}if(!te)try{try{this.u.trace(`Started extracting the extension from ${q} to ${W.fsPath}`),await(0,f.$rp)(q,U.fsPath,{sourcePath:"extension",overwrite:!0},J),this.u.info(`Extracted extension to ${W}:`,Q.id)}catch(se){let ue=n.ExtensionManagementErrorCode.Extract;throw se instanceof f.$pp&&(se.type==="CorruptZip"?ue=n.ExtensionManagementErrorCode.CorruptZip:se.type==="Incomplete"&&(ue=n.ExtensionManagementErrorCode.IncompleteZip)),new n.$co(se.message,ue)}await this.n.updateMetadata(U,C);try{this.u.trace(`Started renaming the extension from ${U.fsPath} to ${W.fsPath}`),await this.C(U.fsPath,W.fsPath),this.u.info("Renamed to",W.fsPath)}catch(se){if(se.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",Q.id);else throw this.u.info(`Rename failed because of ${(0,O.$9)(se)}. Deleted from extracted location`,U),se}this.h.fire(W)}catch(se){try{await this.m.del(U,{recursive:!0})}catch{}throw se}return this.D(W,1)}async scanMetadata(Q,q){return q?(await this.w(Q,q))?.metadata:this.n.scanMetadata(Q.location)}async w(Q,q){return(await this.s.scanProfileExtensions(q)).find(A=>(0,i.$Do)(A.identifier,Q.identifier))}async updateMetadata(Q,q,C){return C?await this.s.updateMetadata([[Q,q]],C):await this.n.updateMetadata(Q.location,q),this.D(Q.location,Q.type,C)}getUninstalledExtensions(){return this.z()}async setUninstalled(...Q){const q=Q.map(C=>i.$Eo.create(C));await this.z(C=>q.forEach(A=>{C[A.toString()]=!0,this.u.info("Marked extension as uninstalled",A.toString())}))}async setInstalled(Q){await this.z(q=>delete q[Q.toString()])}async removeExtension(Q,q){if(this.t.extUri.isEqualOrParent(Q.location,this.n.userExtensionsLocation))return this.y(Q.identifier.id,Q.location,q)}async removeUninstalledExtension(Q){await this.removeExtension(Q,"uninstalled"),await this.z(q=>delete q[i.$Eo.create(Q).toString()])}async copyExtension(Q,q,C,A){const J=await this.w(Q,q),F=await this.w(Q,C);return A={...J?.metadata,...A},F?await this.s.updateMetadata([[Q,{...F.metadata,...A}]],C):await this.s.addExtensionsToProfile([[Q,A]],C),this.D(Q.location,Q.type,C)}async copyExtensions(Q,q){const C=await this.scanExtensions(1,Q),A=await Promise.all(C.filter(J=>!J.isApplicationScoped).map(async J=>[J,await this.scanMetadata(J,Q)]));await this.s.addExtensionsToProfile(A,q)}async y(Q,q,C){this.u.trace(`Deleting ${C} extension from disk`,Q,q.fsPath);const A=this.t.extUri.joinPath(this.t.extUri.dirname(q),`${this.t.extUri.basename(q)}.${(0,S.$Hi)((0,c.$fg)()).toString(16)}${H}`);await this.C(q.fsPath,A.fsPath),await this.m.del(A,{recursive:!0}),this.u.info(`Deleted ${C} extension from disk`,Q,q.fsPath)}async z(Q){return this.g.queue(async()=>{let q;try{q=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(A){if((0,T.$tk)(A)!==1)throw A}let C={};if(q)try{C=JSON.parse(q)}catch{}return Q&&(Q(C),Object.keys(C).length?await this.m.writeFile(this.c,N.$ce.fromString(JSON.stringify(C))):await this.m.del(this.c)),C})}async C(Q,q){try{await u.Promises.rename(Q,q,2*60*1e3)}catch(C){throw new n.$co(C.message||m.localize(5,null,Q,q),C.code||n.ExtensionManagementErrorCode.Rename)}}async D(Q,q,C){if(C){const J=(await this.n.scanUserExtensions({profileLocation:C})).find(F=>this.t.extUri.isEqual(F.location,Q));if(J)return this.F(J)}else{const A=await this.n.scanExistingExtension(Q,q,{includeInvalid:!0});if(A)return this.F(A)}throw new Error(m.localize(6,null,Q.path))}async F(Q){const q=await this.m.resolve(Q.location);let C,A;return q.children&&(C=q.children.find(({name:J})=>/^readme(\.txt|\.md|)$/i.test(J))?.resource,A=q.children.find(({name:J})=>/^changelog(\.txt|\.md|)$/i.test(J))?.resource),{identifier:Q.identifier,type:Q.type,isBuiltin:Q.isBuiltin||!!Q.metadata?.isBuiltin,location:Q.location,manifest:Q.manifest,targetPlatform:Q.targetPlatform,validations:Q.validations,isValid:Q.isValid,readmeUrl:C,changelogUrl:A,publisherDisplayName:Q.metadata?.publisherDisplayName||null,publisherId:Q.metadata?.publisherId||null,isApplicationScoped:!!Q.metadata?.isApplicationScoped,isMachineScoped:!!Q.metadata?.isMachineScoped,isPreReleaseVersion:!!Q.metadata?.isPreReleaseVersion,preRelease:!!Q.metadata?.preRelease,installedTimestamp:Q.metadata?.installedTimestamp,updated:!!Q.metadata?.updated,pinned:!!Q.metadata?.pinned}}async G(){const Q=await this.getUninstalledExtensions();if(Object.keys(Q).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(Q));const q=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),C=new Set;for(const J of q)Q[i.$Eo.create(J).toString()]||C.add(J.identifier.id.toLowerCase());try{const J=(0,i.$Jo)(q,F=>F.identifier);await I.Promises.settled(J.map(async F=>{const U=F.sort((W,te)=>$.rcompare(W.manifest.version,te.manifest.version))[0];C.has(U.identifier.id.toLowerCase())||await this.j(await this.F(U))}))}catch(J){this.u.error(J)}const A=q.filter(J=>J.metadata&&Q[i.$Eo.create(J).toString()]);await Promise.allSettled(A.map(J=>this.removeUninstalledExtension(J)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let Q;try{Q=await this.m.resolve(this.n.userExtensionsLocation)}catch(q){(0,T.$tk)(q)!==1&&this.u.error(q);return}if(Q?.children)try{await Promise.allSettled(Q.children.map(async q=>{if(!(!q.isDirectory||!q.name.endsWith(H))){this.u.trace("Deleting the temporarily deleted folder",q.resource.toString());try{await this.m.del(q.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",q.resource.toString())}catch(C){(0,T.$tk)(C)!==1&&this.u.error(C)}}}))}catch{}}};e.$Op=G,e.$Op=G=pe([X(1,T.$ck),X(2,r.$Cp),X(3,t.$yp),X(4,K.$Mk),X(5,z.$bj)],G);class V extends a.$wp{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,y.$Gf)(this.options.operation)?this.l:this.options.operation}constructor(Q,q,C,A,J,F,U,W,te){super(),this.identifier=Q,this.source=q,this.options=C,this.m=A,this.n=J,this.o=F,this.p=U,this.q=W,this.s=te,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(Q){const[q,C]=await this.x(Q);return this.j=q.isBuiltin||q.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[q,C]],this.j),q}async u({zipPath:Q,key:q,metadata:C},A,J){let F=await this.v(q);return F||(this.s.trace("Extracting extension...",q.id),F=await this.m.extractUserExtension(q,Q,C,A,J),this.s.info("Extracting extension completed.",q.id)),F}async v(Q){return await this.w(Q)?(this.s.trace("Removing the extension from uninstalled list:",Q.id),await this.m.setInstalled(Q),this.s.info("Removed the extension from uninstalled list:",Q.id),(await this.m.scanAllUserExtensions(!0)).find(A=>i.$Eo.create(A).equals(Q))):void 0}async w(Q){return!!(await this.m.getUninstalledExtensions())[Q.toString()]}}class ee extends V{constructor(Q,q,C,A,J,F,U,W,te,se){super(q.identifier,q,C,J,F,U,W,te,se),this.y=q,this.z=A}async x(Q){const C=(await this.m.scanExtensions(null,this.options.profileLocation)).find(U=>(0,i.$Do)(U.identifier,this.y.identifier));C&&(this.l=3);const A={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||C?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||C?.isMachineScoped,isBuiltin:this.options.isBuiltin||C?.isBuiltin,isSystem:C?.type===0?!0:void 0,updated:!!C,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0,preRelease:this.y.properties.isPreReleaseVersion||((0,y.$Ff)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:C?.preRelease)};if(C?.manifest.version===this.y.version)return[await this.m.updateMetadata(C,A),A];const{location:J,verificationStatus:F}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=F,this.B(J.fsPath),[await this.u({zipPath:J.fsPath,key:i.$Eo.create(this.y),metadata:A},!1,Q),A]}catch(U){try{await this.z.delete(J)}catch(W){this.s.warn("Error while deleting the downloaded file",J.toString(),(0,O.$9)(W))}throw U}}async B(Q){try{await(0,p.$Jp)(Q)}catch(q){throw new n.$co((0,a.$up)(q).message,n.ExtensionManagementErrorCode.Invalid)}}}e.$Pp=ee;class ne extends V{constructor(Q,q,C,A,J,F,U,W,te,se){super({id:(0,i.$Io)(Q.publisher,Q.name)},q,C,J,F,U,W,te,se),this.y=Q,this.z=q,this.A=A}async h(Q){const q=await super.h(Q);return this.D(q,Q),q}async x(Q){const q=new i.$Eo(this.identifier,this.y.version),A=(await this.m.scanExtensions(1,this.options.profileLocation)).find(U=>(0,i.$Do)(this.identifier,U.identifier)),J={isApplicationScoped:this.options.isApplicationScoped||A?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||A?.isMachineScoped,isBuiltin:this.options.isBuiltin||A?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0};if(A)if(this.l=3,q.equals(new i.$Eo(A.identifier,A.manifest.version)))try{await this.m.removeExtension(A,"existing")}catch{throw new Error(m.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&$.gt(A.manifest.version,this.y.version)&&await this.m.setUninstalled(A);else{const U=await this.v(q);if(U)try{await this.m.removeExtension(U,"existing")}catch{throw new Error(m.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:b.$jc(this.z.fsPath),key:q,metadata:J},!0,Q),J]}async D(Q,q){try{let[C]=await this.A.getExtensions([{id:Q.identifier.id,version:Q.manifest.version}],q);if(C||([C]=await this.A.getExtensions([{id:Q.identifier.id}],q)),C){const A={id:C.identifier.uuid,publisherDisplayName:C.publisherDisplayName,publisherId:C.publisherId,isPreReleaseVersion:C.properties.isPreReleaseVersion,preRelease:C.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(Q,A,this.options.profileLocation)}}catch{}}}class _ extends a.$wp{constructor(Q,q,C){super(),this.extension=Q,this.j=q,this.k=C}async h(Q){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ae[264],ce([0,1,2,29,81,222,121,8,21]),function(ie,e,I,N,j,L,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$59b=void 0;let d=class extends I.$Rc{constructor(E,b,l,$,y,w){super(),E.cleanUp(),(0,L.$OWb)(E,b,l,$,w),j.$2u.removeOutdatedExtensionVersions(E,y)}};e.$59b=d,e.$59b=d=pe([X(0,O.$Mp),X(1,N.$bo),X(2,j.$1u),X(3,N.$go),X(4,S.$0o),X(5,R.$bj)],d)}),define(ae[122],ce([0,1,71,63,36,274,15,7,3,2,16,5,32,40,67]),function(ie,e,I,N,j,L,O,R,S,d,P,E,b,l,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=void 0;class y{traceSocketEvent(h,g){$.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,h,g)}constructor(h,g=""){this.f=!0,this.debugLabel=g,this.socket=h,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=D=>{if(this.traceSocketEvent("error",{code:D?.code,message:D?.message}),D){if(D.code==="EPIPE")return;(0,R.$Z)(D)}},this.socket.on("error",this.a),this.b=D=>{this.traceSocketEvent("close",{hadError:D}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(h){const g=D=>{this.traceSocketEvent("read",D),h(O.$ce.wrap(D))};return this.socket.on("data",g),{dispose:()=>this.socket.off("data",g)}}onClose(h){const g=D=>{h({type:0,hadError:D,error:void 0})};return this.socket.on("close",g),{dispose:()=>this.socket.off("close",g)}}onEnd(h){const g=()=>{h()};return this.socket.on("end",g),{dispose:()=>this.socket.off("end",g)}}write(h){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",h),this.socket.write(h.buffer,g=>{if(g){if(g.code==="EPIPE")return;(0,R.$Z)(g)}})}catch(g){if(g.code==="EPIPE")return;(0,R.$Z)(g)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((h,g)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),h();return}const D=()=>{this.socket.off("close",D),this.socket.off("end",D),this.socket.off("error",D),this.socket.off("timeout",D),this.socket.off("drain",D),this.traceSocketEvent("nodeDrainEnd"),h()};this.socket.on("close",D),this.socket.on("end",D),this.socket.on("error",D),this.socket.on("timeout",D),this.socket.on("drain",D)})}}e.$Ih=y;var w;(function(p){p[p.MinHeaderByteSize=2]="MinHeaderByteSize",p[p.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(w||(w={}));var c;(function(p){p[p.PeekHeader=1]="PeekHeader",p[p.ReadHeader=2]="ReadHeader",p[p.ReadBody=3]="ReadBody",p[p.Fin=4]="Fin"})(c||(c={}));class u extends d.$Rc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(h,g){this.socket.traceSocketEvent(h,g)}constructor(h,g,D,T){super(),this.f=this.B(new S.$Od),this.g=this.B(new S.$Od),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=h,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:g,inflateBytesLength:D?.byteLength||0,recordInflateBytes:T}),this.a=this.B(new f(this,g,D,T,this.f,(M,z)=>this.m(M,z))),this.B(this.a.onError(M=>{console.error(M),(0,R.$Z)(M),this.g.fire({type:0,hadError:!0,error:M})})),this.b=new $.$Dh,this.B(this.socket.onData(M=>this.n(M))),this.B(this.socket.onClose(async M=>{this.a.isProcessingReadQueue()&&await S.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(M)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(h){return this.f.event(h)}onClose(h){return this.g.event(h)}onEnd(h){return this.socket.onEnd(h)}write(h){let g=0;for(;g<h.byteLength;)this.a.writeMessage(h.slice(g,Math.min(g+262144,h.byteLength)),{compressed:!0,opcode:2}),g+=262144}m(h,{compressed:g,opcode:D}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",h);let T=2;h.byteLength<126?T+=0:h.byteLength<2**16?T+=2:T+=8;const M=O.$ce.alloc(T),z=g?64:0,B=D&15;if(M.writeUInt8(128|z|B,0),h.byteLength<126)M.writeUInt8(h.byteLength,1);else if(h.byteLength<2**16){M.writeUInt8(126,1);let Z=1;M.writeUInt8(h.byteLength>>>8&255,++Z),M.writeUInt8(h.byteLength>>>0&255,++Z)}else{M.writeUInt8(127,1);let Z=1;M.writeUInt8(0,++Z),M.writeUInt8(0,++Z),M.writeUInt8(0,++Z),M.writeUInt8(0,++Z),M.writeUInt8(h.byteLength>>>24&255,++Z),M.writeUInt8(h.byteLength>>>16&255,++Z),M.writeUInt8(h.byteLength>>>8&255,++Z),M.writeUInt8(h.byteLength>>>0&255,++Z)}this.socket.write(O.$ce.concat([M,h]))}end(){this.h=!0,this.socket.end()}n(h){if(h.byteLength!==0){for(this.b.acceptChunk(h);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const g=this.b.peek(this.j.readLen),D=g.readUInt8(0),T=(D&128)>>>7,M=(D&64)>>>6,z=D&15,B=g.readUInt8(1),Z=(B&128)>>>7,K=B&127;this.j.state=2,this.j.readLen=2+(Z?4:0)+(K===126?2:0)+(K===127?8:0),this.j.fin=T,this.j.firstFrameOfMessage&&(this.j.compressed=!!M),this.j.firstFrameOfMessage=!!T,this.j.mask=0,this.j.opcode=z,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const g=this.b.read(this.j.readLen),D=g.readUInt8(1),T=(D&128)>>>7;let M=D&127,z=1;M===126?M=g.readUInt8(++z)*2**8+g.readUInt8(++z):M===127&&(M=g.readUInt8(++z)*0+g.readUInt8(++z)*0+g.readUInt8(++z)*0+g.readUInt8(++z)*0+g.readUInt8(++z)*2**24+g.readUInt8(++z)*2**16+g.readUInt8(++z)*2**8+g.readUInt8(++z));let B=0;T&&(B=g.readUInt8(++z)*2**24+g.readUInt8(++z)*2**16+g.readUInt8(++z)*2**8+g.readUInt8(++z)),this.j.state=3,this.j.readLen=M,this.j.mask=B,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const g=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",g),s(g,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",g),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(g,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(g,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await S.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Jh=u;class f extends d.$Rc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:O.$ce.alloc(0)}constructor(h,g,D,T,M,z){super(),this.n=h,this.r=M,this.s=z,this.a=this.B(new S.$Od),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new S.$Od),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new S.$Od),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,g?(this.b=this.B(new m(this.n,T,D,{windowBits:15})),this.f=this.B(new k(this.n,{windowBits:15})),this.B(this.b.onError(B=>this.a.fire(B))),this.B(this.f.onError(B=>this.a.fire(B)))):(this.b=null,this.f=null)}writeMessage(h,g){this.g.push({data:h,options:g}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:h,options:g}=this.g.shift();if(this.f&&g.compressed){const D=await this.w(this.f,h);this.s(D,g)}else this.s(h,{...g,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(h,g){return new Promise((D,T)=>{h.write(g),h.flush(M=>D(M))})}acceptFrame(h,g,D){this.h.push({data:h,isCompressed:g,isLastFrameOfMessage:D}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const h=this.h.shift();if(this.b&&h.isCompressed){const g=await this.C(this.b,h.data,h.isLastFrameOfMessage);this.r.fire(g)}else this.r.fire(h.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(h,g,D){return new Promise((T,M)=>{h.write(g),D&&h.write(O.$ce.fromByteArray([0,0,255,255])),h.flush(z=>T(z))})}}class m extends d.$Rc{get recordedInflateBytes(){return this.j?O.$ce.concat(this.f):O.$ce.alloc(0)}constructor(h,g,D,T){super(),this.h=h,this.j=g,this.a=this.B(new S.$Od),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,L.createInflateRaw)(T),this.b.on("error",M=>{this.h.traceSocketEvent("zlibInflateError",{message:M?.message,code:M?.code}),this.a.fire(M)}),this.b.on("data",M=>{this.h.traceSocketEvent("zlibInflateData",M),this.g.push(O.$ce.wrap(M))}),D&&(this.h.traceSocketEvent("zlibInflateInitialWrite",D.buffer),this.b.write(D.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(h){this.j&&this.f.push(h.clone()),this.h.traceSocketEvent("zlibInflateWrite",h),this.b.write(h.buffer)}flush(h){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const g=O.$ce.concat(this.g);this.g.length=0,h(g)})}}class k extends d.$Rc{constructor(h,g){super(),this.g=h,this.a=this.B(new S.$Od),this.onError=this.a.event,this.f=[],this.b=(0,L.createDeflateRaw)({windowBits:15}),this.b.on("error",D=>{this.g.traceSocketEvent("zlibDeflateError",{message:D?.message,code:D?.code}),this.a.fire(D)}),this.b.on("data",D=>{this.g.traceSocketEvent("zlibDeflateData",D),this.f.push(O.$ce.wrap(D))})}write(h){this.g.traceSocketEvent("zlibDeflateWrite",h.buffer),this.b.write(h.buffer)}flush(h){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let g=O.$ce.concat(this.f);this.f.length=0,g=g.slice(0,g.byteLength-4),h(g)})}}function s(p,h){if(h===0)return;const g=p.byteLength>>>2;for(let Z=0;Z<g;Z++){const K=p.readUInt32BE(Z*4);p.writeUInt32BE(K^h,Z*4)}const D=g*4,T=p.byteLength-D,M=h>>>24&255,z=h>>>16&255,B=h>>>8&255;T>=1&&p.writeUInt8(p.readUInt8(D)^M,D),T>=2&&p.writeUInt8(p.readUInt8(D+1)^z,D+1),T>=3&&p.writeUInt8(p.readUInt8(D+2)^B,D+2)}e.$Kh=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function n(){const p=(0,b.$fg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${p}-sock`;const h=process.platform!=="darwin"&&e.$Kh?e.$Kh:(0,j.tmpdir)(),g=(0,P.$ic)(h,`vscode-ipc-${p}.sock`);return t(g),g}e.$Lh=n;function i(p,h,g){const D=(0,I.createHash)("md5").update(p).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${D}-${g}-${h}-sock`;const T=g.substr(0,4),M=h.substr(0,6),z=D.substr(0,8);let B;return process.platform!=="darwin"&&e.$Kh&&!process.env.VSCODE_PORTABLE?B=(0,P.$ic)(e.$Kh,`vscode-${z}-${T}-${M}.sock`):B=(0,P.$ic)(p,`${T}-${M}.sock`),t(B),B}e.$Mh=i;function t(p){const h=a[E.$u];typeof h=="number"&&p.length>=h&&console.warn(`WARNING: IPC handle "${p}" is longer than ${h} chars, try a shorter --user-data-dir`)}class r extends l.$xh{static b(h){const g=S.Event.fromNodeEventEmitter(h,"connection");return S.Event.map(g,D=>({protocol:new $.$Eh(new y(D,"ipc-server-connection")),onDidClientDisconnect:S.Event.once(S.Event.fromNodeEventEmitter(D,"close"))}))}constructor(h){super(r.b(h)),this.d=h}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Nh=r;function o(p){return new Promise((h,g)=>{const D=(0,N.createServer)();D.on("error",g),D.listen(p,()=>{D.removeListener("error",g),h(new r(D))})})}e.$Oh=o;function v(p,h){return new Promise((g,D)=>{const T=(0,N.createConnection)(p,()=>{T.removeListener("error",D),g($.$Fh.fromSocket(new y(T,`ipc-client${h}`),h))});T.once("error",D)})}e.$Ph=v}),define(ae[265],ce([0,1,63,122,210]),function(ie,e,I,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b0b=void 0,e.$b0b=new class{supports(L){return!0}connect({host:L,port:O},R,S,d){return new Promise((P,E)=>{const b=I.createConnection({host:L,port:O},()=>{b.removeListener("error",E),b.write((0,j.$Wpb)(R,S,d));const l=$=>{$.toString().indexOf(`\r
\r
`)>=0&&(b.off("data",l),P(new N.$Ih(b,d)))};b.on("data",l)});b.setNoDelay(!0),b.once("error",E)})}}}),define(ae[266],ce([0,1,63,36,132,122,6,2,5,20,8,25,213,104,106,77,15]),function(ie,e,I,N,j,L,O,R,S,d,P,E,b,l,$,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$08b=e.$98b=e.$88b=e.$78b=void 0;async function c(s,a,n,i,t){let r;for(let o=3;o&&(r?.dispose(),r=await new u(s,a,n,i,t).waitForReady(),!(t&&j.$ig[t]||!j.$ig[r.tunnelLocalPort]));o--);return r}class u extends R.$Rc{constructor(a,n,i,t,r){super(),this.m=n,this.n=r,this.privacy=y.TunnelPrivacyId.Private,this.j=new Map,this.a=a,this.b=I.createServer(),this.c=new O.$Tg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=o=>this.r(o),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=t,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(n=>{n()})}async waitForReady(){const a=this.n??this.tunnelRemotePort,n=(0,y.$iv)(this.m)?"0.0.0.0":"127.0.0.1";let i=await(0,j.$jg)(a,2,1e3,n),t=null;return this.b.listen(i,this.m),await this.c.wait(),t=this.b.address(),t||(i=0,this.b.listen(i,this.m),await this.c.wait(),t=this.b.address()),this.tunnelLocalPort=t.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${t.port}`,this}async r(a){a.pause();const n=(0,y.$gv)(this.tunnelRemoteHost)||(0,y.$iv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,b.$0k)(this.a,n,this.tunnelRemotePort),t=i.getSocket(),r=i.readEntireBuffer();i.dispose(),r.byteLength>0&&a.write(r.buffer),a.on("end",()=>{a.localAddress&&this.j.delete(a.localAddress),t.end()}),a.on("close",()=>t.end()),a.on("error",()=>{a.localAddress&&this.j.delete(a.localAddress),t instanceof L.$Ih?t.socket.destroy():t.end()}),t instanceof L.$Ih?this.t(a,t):this.s(a,t),a.localAddress&&this.j.set(a.localAddress,()=>{a.end(),t.end()})}s(a,n){n.onClose(()=>a.destroy()),n.onEnd(()=>a.end()),n.onData(i=>a.write(i.buffer)),a.on("data",i=>n.write(w.$ce.wrap(i))),a.resume()}t(a,n){const i=n.socket;i.on("end",()=>a.end()),i.on("close",()=>a.end()),i.on("error",()=>{a.destroy()}),i.pipe(a),a.pipe(i)}}e.$78b=u;let f=class extends y.$lv{constructor(a,n,i,t,r){super(n,r),this.u=a,this.v=i,this.w=t}isPortPrivileged(a){return(0,y.$jv)(a,this.l,S.OS,N.release())}s(a,n,i,t,r,o,v,p){const h=this.r(n,i);if(h)return++h.refcount,h.value;if((0,y.$dv)(a))return this.t(a,n,i,r,o,v,p);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${i} on local port ${r}.`);const g={commit:this.w.commit,quality:this.w.quality,addressProvider:a,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},D=c(g,t,n,i,r);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(n,i,D),D}}};e.$88b=f,e.$88b=f=pe([X(0,l.$4k),X(1,P.$bj),X(2,$.$7k),X(3,E.$tj),X(4,d.$ni)],f);let m=class extends f{constructor(a,n,i,t,r){super(a,n,i,t,r)}};e.$98b=m,e.$98b=m=pe([X(0,l.$4k),X(1,P.$bj),X(2,$.$7k),X(3,E.$tj),X(4,d.$ni)],m);let k=class extends R.$Rc{constructor(a,n,i,t,r){super(),this.b=a,this.c=n,this.f=i,this.g=t,this.h=r,this.a=new Map}async openTunnel(a,n,i,t,r,o,v,p,h){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${t} on local port ${o}.`),!this.a.has(a)){const g=new m(this.b,this.c,this.g,this.f,this.h);this.B(g),this.a.set(a,g),g.onTunnelClosed(async()=>{(await g.tunnels).length===0&&(g.dispose(),this.a.delete(a))})}return this.a.get(a).openTunnel(n,i,t,r,o,v,p,h)}};e.$08b=k,e.$08b=k=pe([X(0,l.$4k),X(1,P.$bj),X(2,E.$tj),X(3,$.$7k),X(4,d.$ni)],k)}),define(ae[275],ce([0,1,36,38,7,2,23,10,18,3,40,146,204,205,195,196,261,186,188,20,209,95,220,96,215,14,113,246,29,97,187,121,98,11,198,199,70,4,194,72,73,225,8,200,102,25,58,21,107,22,108,109,110,45,228,81,111,24,79,253,238,239,82,252,256,257,258,59,251,240,106,219,77,266,214,229,28,230,5,231,189,207,206,80,245,17,51,203,57,250,227,241,105,255,264,9,201,101,248,244,216,183,56,202,259,247,55,249,104,265,181,217]),function(ie,e,I,N,j,L,O,R,S,d,P,E,b,l,$,y,w,c,u,f,m,k,s,a,n,i,t,r,o,v,p,h,g,D,T,M,z,B,Z,K,x,H,Y,G,V,ee,ne,_,re,Q,q,C,A,J,F,U,W,te,se,ue,le,$e,fe,we,ve,Oe,Ne,Me,he,ge,be,Se,Ce,ze,je,Ue,Fe,oe,de,me,ye,ke,Re,Pe,Ie,De,Ae,Te,Be,qe,Ve,_e,ut,yt,vt,Et,kt,ft,St,Pt,Ct,Rt,Ot,It,Dt,jt,dt,Lt,$t,At,Nt,it){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Tt extends L.$Rc{constructor(Ee){super(),this.f=Ee,this.a=this.B(new E.$ZT(this)),this.b=void 0,this.c=this.B(new d.$Od),this.g()}g(){let Ee=!1;const Le=()=>{Ee||(Ee=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",Le),(0,E.$1T)(process.parentPort,it.$j8b.exit,Le)}async init(){const Ee=await this.h();(0,te.$$gb)(),Ee.invokeFunction(Le=>{const Ke=Le.get(Y.$bj),We=Le.get(Q.$gl),Qe=Le.get(De.$Ok);Ke.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(Le),this.m(Ke),this.n(We,Qe),this.B(Qe.onDidChangeProfiles(()=>this.n(We,Qe)))}),this.B((0,L.$Oc)(Ee.createInstance(b.$A9b,this.f.codeCachePath),Ee.createInstance(l.$B9b),Ee.createInstance(w.$E9b),Ee.createInstance(y.$D9b),Ee.createInstance($.$C9b),Ee.createInstance(vt.$59b),Ee.createInstance(_e.$W9b)))}async h(){const Ee=new K.$Rh,Le={_serviceBrand:void 0,...V.default};Ee.set(ee.$tj,Le);const Ke=new P.$Bh(He=>He==="main"),We=new dt.$e9b(this.a,Ke);Ee.set(dt.$d9b,We);const Qe=this.f.policiesData?new Te.$M8b(this.f.policiesData,We.getChannel("policy")):new Be.$on;Ee.set(Be.$mn,Qe);const Ge=new Nt.$nm(this.f.args,Le);Ee.set(i.$2h,Ge);const xe=new G.$cr(void 0,this.f.logLevel,Ge.logsHome,this.f.loggers.map(He=>({...He,resource:R.URI.revive(He.resource)})),We.getChannel("logger"));Ee.set(Y.$cj,xe);const st=this.B(xe.createLogger("sharedprocess",{name:(0,Et.localize)(0,null)})),ct=this.B(new Y.$jj(st.getLevel())),Je=this.B(new kt.$UN(st,[ct]));Ee.set(Y.$bj,Je),this.b=this.B(new ft.$79b(Je)),Ee.set(ft.$69b,this.b);const Ye=this.B(new T.$Rp(Je));Ee.set(D.$ck,Ye);const lt=this.B(new M.$eq(Je));Ye.registerProvider(O.Schemas.file,lt);const rt=new oe.$Dr(Ye);Ee.set(Fe.$Mk,rt);const Xe=this.B(new qe.$2N(this.f.profiles.all,R.URI.revive(this.f.profiles.home).with({scheme:Ge.userRoamingDataHome.scheme}),We.getChannel("userDataProfiles")));Ee.set(De.$Ok,Xe);const ht=this.B(new me.$c9b(O.Schemas.file,this.B(new ye.$DN(We.getChannel(ye.$CN),{pathCaseSensitive:de.$l})),O.Schemas.vscodeUserData,Xe,rt,Je));Ye.registerProvider(O.Schemas.vscodeUserData,ht);const Ze=this.B(new m.$On(Xe.defaultProfile.settingsResource,Ye,Qe,Je));Ee.set(f.$ni,Ze);const et=new Lt.$a0b(void 0,{defaultProfile:Xe.defaultProfile,currentProfile:Xe.defaultProfile},We,Ge);Ee.set(_.$0o,et),this.B((0,L.$Pc)(()=>et.flush())),await Promise.all([Ze.initialize(),et.initialize()]);const mt=new Ct.$1q(We.getChannel("request"));Ee.set(ne.$Wo,mt),Ee.set(c.$F9b,new z.$Qh(u.$G9b,void 0,!1)),Ee.set(Re.$bF,new z.$Qh(ke.$V9b,void 0,!1));const bt=new It.$j9b(-1,We);Ee.set(Ot.$27b,bt),Ee.set(a.$Sn,new z.$Qh(n.$0N,void 0,!0));const Ft=this.B(new ge.$J8b(bt)),Mt=new P.$Bh(He=>Ft.getActiveClientId().then(at=>He===at));Ee.set(g.$yWb,new Rt.$99b(this.a.getChannel("extensionRecommendationNotification",Mt)));let ot;const tt=[],wt=(0,J.$Ao)(Le,Ze);if((0,J.$vo)(Le,Ge)){const He=new C.$K5b(Je,xe,Ge,Le);if(tt.push(He),!(0,J.$wo)(Le,Ge)&&Le.aiConfig?.ariaKey){const at=new Ve.$IN(mt,wt,"monacoworkbench",null,Le.aiConfig.ariaKey);this.B((0,L.$Pc)(()=>at.flush())),tt.push(at)}ot=new A.$5q({appenders:tt,commonProperties:(0,re.$lo)((0,I.release)(),(0,I.hostname)(),process.arch,Le.commit,Le.version,this.f.machineId,this.f.sqmId,wt),sendErrorTelemetry:!0,piiPaths:(0,J.$Bo)(Ge)},Ze,Le)}else{ot=J.$po;const He=J.$to;tt.push(He)}this.a.registerChannel("telemetryAppender",new q.$o8b(tt)),Ee.set(Q.$gl,ot);const zt=new F.$H9b(Ze,ot,Je,xe,Ge,Le);Ee.set(Q.$hl,zt),Ee.set(Ae.$yp,new z.$Qh(Pt.$TN,void 0,!0)),Ee.set(Pe.$Cp,new z.$Qh(Ie.$N8b,void 0,!0)),Ee.set(v.$ip,new z.$Qh(v.$jp,void 0,!0)),Ee.set(h.$Mp,new z.$Qh(h.$Np,void 0,!0)),Ee.set(o.$bo,new z.$Qh(r.$gp,void 0,!0)),Ee.set(o.$ho,new z.$Qh(jt.$_9b,void 0,!1)),Ee.set(x.$Wq,new z.$Qh(H.$Yq,void 0,!1)),Ee.set(k.$um,new z.$Qh(s.$Kr,void 0,!1)),Ee.set(se.$mDb,new z.$Qh(se.$nDb,void 0,!0)),Ee.set(te.$thb,new z.$Qh($e.$zFb,void 0,!0)),Ee.set(te.$shb,new le.$K9b(this.a.getChannel("userDataSyncUtil",He=>He.ctx!=="main"))),Ee.set(o.$go,new z.$Qh(t.$kDb,void 0,!1)),Ee.set(W.$xFb,new z.$Qh(W.$yFb,void 0,!0)),Ee.set(U.$1u,new z.$Qh(U.$2u)),Ee.set(te.$dhb,new z.$Qh(Ne.$IEb,void 0,!0)),Ee.set(te.$ehb,new z.$Qh(Ne.$KEb,void 0,!0)),Ee.set(fe.$4gb,new z.$Qh(fe.$6gb,void 0,!0)),Ee.set(te.$fhb,new z.$Qh(ue.$m6b,void 0,!1)),Ee.set(te.$ohb,new z.$Qh(we.$b6b,void 0,!0)),Ee.set(te.$phb,new z.$Qh(ve.$r6b,void 0,!1)),Ee.set(Me.$YDb,new z.$Qh(he.$R9b,void 0,!0)),Ee.set(te.$qhb,new z.$Qh(yt.$36b,void 0,!0)),Ee.set(be.$7k,new z.$Qh(Se.$_8b,void 0,!1));const pt=new $t.$5k;return Ee.set($t.$4k,pt),pt.register(0,At.$b0b),Ee.set(Ce.$cv,new z.$Qh(ze.$08b)),Ee.set(je.$S9b,new z.$Qh(Ue.$U9b)),Ee.set(ut.$X9b,new z.$Qh(St.$89b)),new Z.$hq(Ee)}j(Ee){const Le=this.B(new L.$Qc),Ke=new p.$lp(Ee.get(o.$do),()=>null);this.a.registerChannel("extensions",Ke);const We=P.ProxyChannel.fromService(Ee.get(x.$Wq),Le);this.a.registerChannel("languagePacks",We);const Qe=P.ProxyChannel.fromService(Ee.get(k.$um),Le);this.a.registerChannel("diagnostics",Qe);const Ge=new p.$np(Ee.get(o.$ho));this.a.registerChannel("extensionTipsService",Ge);const xe=P.ProxyChannel.fromService(Ee.get(c.$F9b),Le);this.a.registerChannel("checksum",xe);const st=P.ProxyChannel.fromService(Ee.get(Re.$bF),Le);this.a.registerChannel("v8InspectProfiling",st);const ct=new le.$L9b(Ee.get(fe.$4gb));this.a.registerChannel("userDataSyncMachines",ct);const Je=P.ProxyChannel.fromService(Ee.get(Q.$hl),Le);this.a.registerChannel("customEndpointTelemetry",Je);const Ye=new le.$M9b(Ee.get(se.$mDb));this.a.registerChannel("userDataSyncAccount",Ye);const lt=new le.$N9b(Ee.get(te.$dhb));this.a.registerChannel("userDataSyncStoreManagement",lt);const rt=new Oe.$P9b(Ee.get(te.$phb),Ee.get(De.$Ok),Ee.get(Y.$bj));this.a.registerChannel("userDataSync",rt);const Xe=this.B(Ee.get(B.$Sh).createInstance(Dt.$$9b)),ht=new le.$I9b(Xe);this.a.registerChannel("userDataAutoSync",ht),this.a.registerChannel("IUserDataSyncResourceProviderService",P.ProxyChannel.fromService(Ee.get(te.$qhb),Le));const Ze=P.ProxyChannel.fromService(Ee.get(je.$S9b),Le);this.a.registerChannel(je.$T9b,Ze);const et=P.ProxyChannel.fromService(Ee.get(ut.$X9b),Le);this.a.registerChannel("remoteTunnel",et)}m(Ee){process.on("uncaughtException",Le=>(0,j.$Z)(Le)),process.on("unhandledRejection",Le=>(0,j.$Z)(Le)),(0,j.setUnexpectedErrorHandler)(Le=>{const Ke=(0,N.$Ei)(Le,!0);Ke&&Ee.error(`[uncaught exception in sharedProcess]: ${Ke}`)})}n(Ee,Le){Ee.publicLog2("profilesInfo",{count:Le.profiles.length})}handledClientConnection(Ee){if(Ee.data!==it.$l8b.response)return!1;const Le=(0,S.$Nb)(Ee.ports);return Le?(this.c.fire(Le),!0):!1}}async function gt(nt){const Ee=new Tt(nt);process.parentPort.postMessage(it.$j8b.ipcReady),await Ee.init(),process.parentPort.postMessage(it.$j8b.initDone)}e.main=gt,process.parentPort.once("message",nt=>{gt(nt.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/072c6b950b8822560c55eff1474c30951e2ab9c9/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
