/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ke=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/async","vs/base/common/errors","vs/base/common/platform","vs/base/common/strings","vs/workbench/api/common/extHostTypeConverters","vs/platform/log/common/log","vs/base/common/path","vs/base/common/network","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/uuid","vs/base/common/extpath","vs/base/common/glob","vs/workbench/api/common/extHostCommands","vs/workbench/services/search/common/search","vs/base/common/stopwatch","vs/platform/registry/common/platform","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/process","child_process","vs/base/common/iterator","vs/base/common/hash","vs/editor/common/core/position","vs/base/common/marshalling","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/decorators","vs/base/common/assert","vs/base/common/themables","net","os","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/editor/common/model","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/arraysFind","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/product/common/productService","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Se=function($e){for(var e=[],I=0,F=$e.length;I<F;I++)e[I]=ke[$e[I]];return e};define(ke[159],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=e.$S=void 0,e.$S=!1;class I{static get(){const f=new Map,L=new Map,R=new Map,p=new Map;function E(y,S){y.has(S.detail)||y.set(S.detail,-S.timestamp)}function m(y,S){const w=y.get(S.detail);w&&(w>=0||y.set(S.detail,w+S.timestamp))}let A=[];typeof $e=="function"&&typeof $e.getStats=="function"&&(A=$e.getStats().slice(0).sort((y,S)=>y.timestamp-S.timestamp));for(const y of A)switch(y.type){case 10:E(f,y);break;case 11:case 12:m(f,y);break;case 21:E(L,y);break;case 22:m(L,y);break;case 33:E(R,y);break;case 34:m(R,y);break;case 31:E(p,y);break;case 32:m(p,y);break}let P=0;R.forEach(y=>P+=y);function g(y){const S=[];return y.forEach((w,c)=>S.push([c,w])),S}return{amdLoad:g(f),amdInvoke:g(L),nodeRequire:g(R),nodeEval:g(p),nodeRequireTotal:P}}static toMarkdownTable(f,L){let R="";const p=[];return f.forEach((E,m)=>{p[m]=E.length}),L.forEach(E=>{E.forEach((m,A)=>{typeof m>"u"&&(m=E[A]="-");const P=m.toString().length;p[A]=Math.max(P,p[A])})}),f.forEach((E,m)=>{R+=`| ${E+" ".repeat(p[m]-E.toString().length)} `}),R+=`|
`,f.forEach((E,m)=>{R+=`| ${"-".repeat(p[m])} `}),R+=`|
`,L.forEach(E=>{E.forEach((m,A)=>{typeof m<"u"&&(R+=`| ${m+" ".repeat(p[A]-m.toString().length)} `)}),R+=`|
`}),R}}e.$T=I}),define(ke[121],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=void 0;function I(w,c,s){const i=F(w,c);if(i!==-1)return w[i]}e.$eb=I;function F(w,c,s=w.length-1){for(let i=s;i>=0;i--){const n=w[i];if(c(n))return i}return-1}e.$fb=F;function f(w,c){const s=L(w,c);return s===-1?void 0:w[s]}e.$gb=f;function L(w,c,s=0,i=w.length){let n=s,o=i;for(;n<o;){const a=Math.floor((n+o)/2);c(w[a])?n=a+1:o=a}return n-1}e.$hb=L;function R(w,c){const s=p(w,c);return s===w.length?void 0:w[s]}e.$ib=R;function p(w,c,s=0,i=w.length){let n=s,o=i;for(;n<o;){const a=Math.floor((n+o)/2);c(w[a])?o=a:n=a+1}return n}e.$jb=p;function E(w,c,s=0,i=w.length){const n=p(w,c,s,i);return n===w.length?-1:n}e.$kb=E;class m{static{this.assertInvariants=!1}constructor(c){this.e=c,this.c=0}findLastMonotonous(c){if(m.assertInvariants){if(this.d){for(const i of this.e)if(this.d(i)&&!c(i))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=c}const s=L(this.e,c,this.c);return this.c=s+1,s===-1?void 0:this.e[s]}}e.$lb=m;function A(w,c){if(w.length===0)return;let s=w[0];for(let i=1;i<w.length;i++){const n=w[i];c(n,s)>0&&(s=n)}return s}e.$mb=A;function P(w,c){if(w.length===0)return;let s=w[0];for(let i=1;i<w.length;i++){const n=w[i];c(n,s)>=0&&(s=n)}return s}e.$nb=P;function g(w,c){return A(w,(s,i)=>-c(s,i))}e.$ob=g;function y(w,c){if(w.length===0)return-1;let s=0;for(let i=1;i<w.length;i++){const n=w[i];c(n,w[s])>0&&(s=i)}return s}e.$pb=y;function S(w,c){for(const s of w){const i=c(s);if(i!==void 0)return i}}e.$qb=S}),define(ke[74],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M=e.$L=e.$K=e.$J=void 0;function I(R,p){const E=Object.create(null);for(const m of R){const A=p(m);let P=E[A];P||(P=E[A]=[]),P.push(m)}return E}e.$J=I;function F(R,p){const E=[],m=[];for(const A of R)p.has(A)||E.push(A);for(const A of p)R.has(A)||m.push(A);return{removed:E,added:m}}e.$K=F;function f(R,p){const E=[],m=[];for(const[A,P]of R)p.has(A)||E.push(P);for(const[A,P]of p)R.has(A)||m.push(P);return{removed:E,added:m}}e.$L=f;function L(R,p){const E=new Set;for(const m of p)R.has(m)&&E.add(m);return E}e.$M=L}),define(ke[59],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nh=e.$mh=e.$lh=void 0;function I(R){return(p,E,m)=>{let A=null,P=null;if(typeof m.value=="function"?(A="value",P=m.value):typeof m.get=="function"&&(A="get",P=m.get),!P)throw new Error("not supported");m[A]=R(P,E)}}function F(R,p,E){let m=null,A=null;if(typeof E.value=="function"?(m="value",A=E.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(m="get",A=E.get),!A)throw new Error("not supported");const P=`$memoize$${p}`;E[m]=function(...g){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,g)}),this[P]}}e.$lh=F;function f(R,p,E){return I((m,A)=>{const P=`$debounce$${A}`,g=`$debounce$result$${A}`;return function(...y){this[g]||(this[g]=E?E():void 0),clearTimeout(this[P]),p&&(this[g]=p(this[g],...y),y=[this[g]]),this[P]=setTimeout(()=>{m.apply(this,y),this[g]=E?E():void 0},R)}})}e.$mh=f;function L(R,p,E){return I((m,A)=>{const P=`$throttle$timer$${A}`,g=`$throttle$result$${A}`,y=`$throttle$lastRun$${A}`,S=`$throttle$pending$${A}`;return function(...w){if(this[g]||(this[g]=E?E():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),p&&(this[g]=p(this[g],...w)),this[S])return;const c=this[y]+R;c<=Date.now()?(this[y]=Date.now(),m.apply(this,[this[g]]),this[g]=E?E():void 0):(this[S]=!0,this[P]=setTimeout(()=>{this[S]=!1,this[y]=Date.now(),m.apply(this,[this[g]]),this[g]=E?E():void 0},c-Date.now()))}})}e.$nh=L}),define(ke[11],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.setUnexpectedErrorHandler=e.$W=e.$V=void 0;class I{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?n.isErrorNoTelemetry(t)?new n(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(r=>{r(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$V=I,e.$W=new I;function F(a){e.$W.setUnexpectedErrorHandler(a)}e.setUnexpectedErrorHandler=F;function f(a){if(!a||typeof a!="object")return!1;const t=a;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$Y=f;function L(a){m(a)||e.$W.onUnexpectedError(a)}e.$Z=L;function R(a){m(a)||e.$W.onUnexpectedExternalError(a)}e.$1=R;function p(a){if(a instanceof Error){const{name:t,message:r}=a,d=a.stacktrace||a.stack;return{$isError:!0,name:t,message:r,stack:d,noTelemetry:n.isErrorNoTelemetry(a)}}return a}e.$2=p;const E="Canceled";function m(a){return a instanceof A?!0:a instanceof Error&&a.name===E&&a.message===E}e.$3=m;class A extends Error{constructor(){super(E),this.name=this.message}}e.$4=A;function P(){const a=new Error(E);return a.name=a.message,a}e.$5=P;function g(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}e.$6=g;function y(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}e.$7=y;class S extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$8=S;function w(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}e.$9=w;class c extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$0=c;class s extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$$=s;class i extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=i;class n extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof n)return t;const r=new n;return r.message=t.message,r.stack=t.stack,r}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$ab=n;class o extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,o.prototype)}}e.$bb=o}),define(ke[19],Se([1,0,11,121]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.$6b=e.CompareResult=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.$Fb=e.top=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=e.$rb=void 0;function f(ne,G=0){return ne[ne.length-(1+G)]}e.$rb=f;function L(ne){if(ne.length===0)throw new Error("Invalid tail call");return[ne.slice(0,ne.length-1),ne[ne.length-1]]}e.$sb=L;function R(ne,G,J=(ge,x)=>ge===x){if(ne===G)return!0;if(!ne||!G||ne.length!==G.length)return!1;for(let ge=0,x=ne.length;ge<x;ge++)if(!J(ne[ge],G[ge]))return!1;return!0}e.$tb=R;function p(ne,G){const J=ne.length-1;G<J&&(ne[G]=ne[J]),ne.pop()}e.$ub=p;function E(ne,G,J){return m(ne.length,ge=>J(ne[ge],G))}e.$vb=E;function m(ne,G){let J=0,ge=ne-1;for(;J<=ge;){const x=(J+ge)/2|0,le=G(x);if(le<0)J=x+1;else if(le>0)ge=x-1;else return x}return-(J+1)}e.$wb=m;function A(ne,G,J){if(ne=ne|0,ne>=G.length)throw new TypeError("invalid index");const ge=G[Math.floor(G.length*Math.random())],x=[],le=[],te=[];for(const de of G){const be=J(de,ge);be<0?x.push(de):be>0?le.push(de):te.push(de)}return ne<x.length?A(ne,x,J):ne<x.length+te.length?te[0]:A(ne-(x.length+te.length),le,J)}e.$xb=A;function P(ne,G){const J=[];let ge;for(const x of ne.slice(0).sort(G))!ge||G(ge[0],x)!==0?(ge=[x],J.push(ge)):ge.push(x);return J}e.$yb=P;function*g(ne,G){let J,ge;for(const x of ne)ge!==void 0&&G(ge,x)?J.push(x):(J&&(yield J),J=[x]),ge=x;J&&(yield J)}e.$zb=g;function y(ne,G){for(let J=0;J<=ne.length;J++)G(J===0?void 0:ne[J-1],J===ne.length?void 0:ne[J])}e.$Ab=y;function S(ne,G){for(let J=0;J<ne.length;J++)G(J===0?void 0:ne[J-1],ne[J],J+1===ne.length?void 0:ne[J+1])}e.$Bb=S;function w(ne,G,J){const ge=[];function x(de,be,Pe){if(be===0&&Pe.length===0)return;const B=ge[ge.length-1];B&&B.start+B.deleteCount===de?(B.deleteCount+=be,B.toInsert.push(...Pe)):ge.push({start:de,deleteCount:be,toInsert:Pe})}let le=0,te=0;for(;;){if(le===ne.length){x(le,0,G.slice(te));break}if(te===G.length){x(le,ne.length-le,[]);break}const de=ne[le],be=G[te],Pe=J(de,be);Pe===0?(le+=1,te+=1):Pe<0?(x(le,1,[]),le+=1):Pe>0&&(x(le,0,[be]),te+=1)}return ge}e.$Cb=w;function c(ne,G,J){const ge=w(ne,G,J),x=[],le=[];for(const te of ge)x.push(...ne.slice(te.start,te.start+te.deleteCount)),le.push(...te.toInsert);return{removed:x,added:le}}e.$Db=c;function s(ne,G,J){if(J===0)return[];const ge=ne.slice(0,J).sort(G);return n(ne,G,ge,J,ne.length),ge}e.top=s;function i(ne,G,J,ge,x){return J===0?Promise.resolve([]):new Promise((le,te)=>{(async()=>{const de=ne.length,be=ne.slice(0,J).sort(G);for(let Pe=J,B=Math.min(J+ge,de);Pe<de;Pe=B,B=Math.min(B+ge,de)){if(Pe>J&&await new Promise(Q=>setTimeout(Q)),x&&x.isCancellationRequested)throw new I.$4;n(ne,G,be,Pe,B)}return be})().then(le,te)})}e.$Fb=i;function n(ne,G,J,ge,x){for(const le=J.length;ge<x;ge++){const te=ne[ge];if(G(te,J[le-1])<0){J.pop();const de=(0,F.$jb)(J,be=>G(te,be)<0);J.splice(de,0,te)}}}function o(ne){return ne.filter(G=>!!G)}e.$Gb=o;function a(ne){let G=0;for(let J=0;J<ne.length;J++)ne[J]&&(ne[G]=ne[J],G+=1);ne.length=G}e.$Hb=a;function t(ne,G,J){ne.splice(J,0,ne.splice(G,1)[0])}e.$Ib=t;function r(ne){return!Array.isArray(ne)||ne.length===0}e.$Jb=r;function d(ne){return Array.isArray(ne)&&ne.length>0}e.$Kb=d;function u(ne,G=J=>J){const J=new Set;return ne.filter(ge=>{const x=G(ge);return J.has(x)?!1:(J.add(x),!0)})}e.$Lb=u;function l(ne){const G=new Set;return J=>{const ge=ne(J);return G.has(ge)?!1:(G.add(ge),!0)}}e.$Mb=l;function h(ne,G){return ne.length>0?ne[0]:G}e.$Nb=h;function k(ne,G){return ne.length>0?ne[ne.length-1]:G}e.$Ob=k;function D(ne,G,J=(ge,x)=>ge===x){let ge=0;for(let x=0,le=Math.min(ne.length,G.length);x<le&&J(ne[x],G[x]);x++)ge++;return ge}e.$Pb=D;function $(ne){return[].concat(...ne)}e.$Qb=$;function b(ne,G){let J=typeof G=="number"?ne:0;typeof G=="number"?J=ne:(J=0,G=ne);const ge=[];if(J<=G)for(let x=J;x<G;x++)ge.push(x);else for(let x=J;x>G;x--)ge.push(x);return ge}e.$Rb=b;function v(ne,G,J){return ne.reduce((ge,x)=>(ge[G(x)]=J?J(x):x,ge),Object.create(null))}e.$Sb=v;function C(ne,G){return ne.push(G),()=>N(ne,G)}e.$Tb=C;function N(ne,G){const J=ne.indexOf(G);if(J>-1)return ne.splice(J,1),G}e.$Ub=N;function z(ne,G,J){const ge=ne.slice(0,G),x=ne.slice(G);return ge.concat(J,x)}e.$Vb=z;function M(ne,G){let J;if(typeof G=="number"){let ge=G;J=()=>{const x=Math.sin(ge++)*179426549;return x-Math.floor(x)}}else J=Math.random;for(let ge=ne.length-1;ge>0;ge-=1){const x=Math.floor(J()*(ge+1)),le=ne[ge];ne[ge]=ne[x],ne[x]=le}}e.$Wb=M;function O(ne,G){const J=ne.indexOf(G);J>-1&&(ne.splice(J,1),ne.unshift(G))}e.$Xb=O;function j(ne,G){const J=ne.indexOf(G);J>-1&&(ne.splice(J,1),ne.push(G))}e.$Yb=j;function T(ne,G){for(const J of G)ne.push(J)}e.$Zb=T;function V(ne,G){return Array.isArray(ne)?ne.map(G):G(ne)}e.$1b=V;function q(ne){return Array.isArray(ne)?ne:[ne]}e.$2b=q;function fe(ne){return ne[Math.floor(Math.random()*ne.length)]}e.$3b=fe;function ee(ne,G,J){const ge=X(ne,G),x=ne.length,le=J.length;ne.length=x+le;for(let te=x-1;te>=ge;te--)ne[te+le]=ne[te];for(let te=0;te<le;te++)ne[te+ge]=J[te]}e.$4b=ee;function Y(ne,G,J,ge){const x=X(ne,G);let le=ne.splice(x,J);return le===void 0&&(le=[]),ee(ne,x,ge),le}e.$5b=Y;function X(ne,G){return G<0?Math.max(G+ne.length,0):Math.min(G,ne.length)}var ae;(function(ne){function G(le){return le<0}ne.isLessThan=G;function J(le){return le<=0}ne.isLessThanOrEqual=J;function ge(le){return le>0}ne.isGreaterThan=ge;function x(le){return le===0}ne.isNeitherLessOrGreaterThan=x,ne.greaterThan=1,ne.lessThan=-1,ne.neitherLessOrGreaterThan=0})(ae||(e.CompareResult=ae={}));function Z(ne,G){return(J,ge)=>G(ne(J),ne(ge))}e.$6b=Z;function se(...ne){return(G,J)=>{for(const ge of ne){const x=ge(G,J);if(!ae.isNeitherLessOrGreaterThan(x))return x}return ae.neitherLessOrGreaterThan}}e.$7b=se;const we=(ne,G)=>ne-G;e.$8b=we;const H=(ne,G)=>(0,e.$8b)(ne?1:0,G?1:0);e.$9b=H;function U(ne){return(G,J)=>-ne(G,J)}e.$0b=U;class ce{constructor(G){this.g=G,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(G){let J=this.c;for(;J<this.g.length&&G(this.g[J]);)J++;const ge=J===this.c?null:this.g.slice(this.c,J);return this.c=J,ge}takeFromEndWhile(G){let J=this.d;for(;J>=0&&G(this.g[J]);)J--;const ge=J===this.d?null:this.g.slice(J+1,this.d+1);return this.d=J,ge}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const G=this.g[this.c];return this.c++,G}removeLast(){const G=this.g[this.d];return this.d--,G}takeCount(G){const J=this.g.slice(this.c,this.c+G);return this.c+=G,J}}e.$$b=ce;class Ee{static{this.empty=new Ee(G=>{})}constructor(G){this.iterate=G}forEach(G){this.iterate(J=>(G(J),!0))}toArray(){const G=[];return this.iterate(J=>(G.push(J),!0)),G}filter(G){return new Ee(J=>this.iterate(ge=>G(ge)?J(ge):!0))}map(G){return new Ee(J=>this.iterate(ge=>J(G(ge))))}some(G){let J=!1;return this.iterate(ge=>(J=G(ge),!J)),J}findFirst(G){let J;return this.iterate(ge=>G(ge)?(J=ge,!1):!0),J}findLast(G){let J;return this.iterate(ge=>(G(ge)&&(J=ge),!0)),J}findLastMaxBy(G){let J,ge=!0;return this.iterate(x=>((ge||ae.isGreaterThan(G(x,J)))&&(ge=!1,J=x),!0)),J}}e.$_b=Ee}),define(ke[60],Se([1,0,11]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=e.$5c=e.$4c=e.$3c=e.ok=void 0;function F(E,m){if(!E)throw new Error(m?`Assertion failed (${m})`:"Assertion Failed")}e.ok=F;function f(E,m="Unreachable"){throw new Error(m)}e.$3c=f;function L(E){if(!E)throw new I.$bb("Assertion Failed")}e.$4c=L;function R(E){if(!E()){debugger;E(),(0,I.$Z)(new I.$bb("Assertion Failed"))}}e.$5c=R;function p(E,m){let A=0;for(;A<E.length-1;){const P=E[A],g=E[A+1];if(!m(P,g))return!1;A++}return!0}e.$6c=p}),define(ke[75],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=void 0;function I(F){const f=this;let L=!1,R;return function(){return L||(L=!0,R=F.apply(f,arguments)),R}}e.$cb=I}),define(ke[122],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DM=e.$CM=void 0;class I{constructor(f){this.a=f,this.b=0}nextId(){return this.a+ ++this.b}}e.$CM=I,e.$DM=new I("id#")}),define(ke[51],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var I;(function(F){function f(a){return a&&typeof a=="object"&&typeof a[Symbol.iterator]=="function"}F.is=f;const L=Object.freeze([]);function R(){return L}F.empty=R;function*p(a){yield a}F.single=p;function E(a){return f(a)?a:p(a)}F.wrap=E;function m(a){return a||L}F.from=m;function*A(a){for(let t=a.length-1;t>=0;t--)yield a[t]}F.reverse=A;function P(a){return!a||a[Symbol.iterator]().next().done===!0}F.isEmpty=P;function g(a){return a[Symbol.iterator]().next().value}F.first=g;function y(a,t){for(const r of a)if(t(r))return!0;return!1}F.some=y;function S(a,t){for(const r of a)if(t(r))return r}F.find=S;function*w(a,t){for(const r of a)t(r)&&(yield r)}F.filter=w;function*c(a,t){let r=0;for(const d of a)yield t(d,r++)}F.map=c;function*s(...a){for(const t of a)for(const r of t)yield r}F.concat=s;function i(a,t,r){let d=r;for(const u of a)d=t(d,u);return d}F.reduce=i;function*n(a,t,r=a.length){for(t<0&&(t+=a.length),r<0?r+=a.length:r>a.length&&(r=a.length);t<r;t++)yield a[t]}F.slice=n;function o(a,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,a];const d=a[Symbol.iterator]();for(let u=0;u<t;u++){const l=d.next();if(l.done)return[r,F.empty()];r.push(l.value)}return[r,{[Symbol.iterator](){return d}}]}F.consume=o})(I||(e.Iterable=I={}))}),define(ke[160],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var I;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(I||(e.ScanError=I={}));var F;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(F||(e.SyntaxKind=F={}));var f;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(f||(e.ParseErrorCode=f={}));var L;(function(t){t.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function R(t,r=!1){let d=0;const u=t.length;let l="",h=0,k=16,D=0;function $(O){let j=0,T=0;for(;j<O;){const V=t.charCodeAt(d);if(V>=48&&V<=57)T=T*16+V-48;else if(V>=65&&V<=70)T=T*16+V-65+10;else if(V>=97&&V<=102)T=T*16+V-97+10;else break;d++,j++}return j<O&&(T=-1),T}function b(O){d=O,l="",h=0,k=16,D=0}function v(){const O=d;if(t.charCodeAt(d)===48)d++;else for(d++;d<t.length&&m(t.charCodeAt(d));)d++;if(d<t.length&&t.charCodeAt(d)===46)if(d++,d<t.length&&m(t.charCodeAt(d)))for(d++;d<t.length&&m(t.charCodeAt(d));)d++;else return D=3,t.substring(O,d);let j=d;if(d<t.length&&(t.charCodeAt(d)===69||t.charCodeAt(d)===101))if(d++,(d<t.length&&t.charCodeAt(d)===43||t.charCodeAt(d)===45)&&d++,d<t.length&&m(t.charCodeAt(d))){for(d++;d<t.length&&m(t.charCodeAt(d));)d++;j=d}else D=3;return t.substring(O,j)}function C(){let O="",j=d;for(;;){if(d>=u){O+=t.substring(j,d),D=2;break}const T=t.charCodeAt(d);if(T===34){O+=t.substring(j,d),d++;break}if(T===92){if(O+=t.substring(j,d),d++,d>=u){D=2;break}switch(t.charCodeAt(d++)){case 34:O+='"';break;case 92:O+="\\";break;case 47:O+="/";break;case 98:O+="\b";break;case 102:O+="\f";break;case 110:O+=`
`;break;case 114:O+="\r";break;case 116:O+="	";break;case 117:{const q=$(4);q>=0?O+=String.fromCharCode(q):D=4;break}default:D=5}j=d;continue}if(T>=0&&T<=31)if(E(T)){O+=t.substring(j,d),D=2;break}else D=6;d++}return O}function N(){if(l="",D=0,h=d,d>=u)return h=u,k=17;let O=t.charCodeAt(d);if(p(O)){do d++,l+=String.fromCharCode(O),O=t.charCodeAt(d);while(p(O));return k=15}if(E(O))return d++,l+=String.fromCharCode(O),O===13&&t.charCodeAt(d)===10&&(d++,l+=`
`),k=14;switch(O){case 123:return d++,k=1;case 125:return d++,k=2;case 91:return d++,k=3;case 93:return d++,k=4;case 58:return d++,k=6;case 44:return d++,k=5;case 34:return d++,l=C(),k=10;case 47:{const j=d-1;if(t.charCodeAt(d+1)===47){for(d+=2;d<u&&!E(t.charCodeAt(d));)d++;return l=t.substring(j,d),k=12}if(t.charCodeAt(d+1)===42){d+=2;const T=u-1;let V=!1;for(;d<T;){if(t.charCodeAt(d)===42&&t.charCodeAt(d+1)===47){d+=2,V=!0;break}d++}return V||(d++,D=1),l=t.substring(j,d),k=13}return l+=String.fromCharCode(O),d++,k=16}case 45:if(l+=String.fromCharCode(O),d++,d===u||!m(t.charCodeAt(d)))return k=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=v(),k=11;default:for(;d<u&&z(O);)d++,O=t.charCodeAt(d);if(h!==d){switch(l=t.substring(h,d),l){case"true":return k=8;case"false":return k=9;case"null":return k=7}return k=16}return l+=String.fromCharCode(O),d++,k=16}}function z(O){if(p(O)||E(O))return!1;switch(O){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function M(){let O;do O=N();while(O>=12&&O<=15);return O}return{setPosition:b,getPosition:()=>d,scan:r?M:N,getToken:()=>k,getTokenValue:()=>l,getTokenOffset:()=>h,getTokenLength:()=>d-h,getTokenError:()=>D}}e.$Ym=R;function p(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function E(t){return t===10||t===13||t===8232||t===8233}function m(t){return t>=48&&t<=57}var A;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(A||(A={}));function P(t,r){const d=[],u=new Object;let l;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let k=!1;function D($,b,v,C){h.value=$,h.offset=b,h.length=v,h.type=C,h.colonOffset=void 0,l=h}try{n(t,{onObjectBegin:($,b)=>{if(r<=$)throw u;l=void 0,k=r>$,d.push("")},onObjectProperty:($,b,v)=>{if(r<b||(D($,b,v,"property"),d[d.length-1]=$,r<=b+v))throw u},onObjectEnd:($,b)=>{if(r<=$)throw u;l=void 0,d.pop()},onArrayBegin:($,b)=>{if(r<=$)throw u;l=void 0,d.push(0)},onArrayEnd:($,b)=>{if(r<=$)throw u;l=void 0,d.pop()},onLiteralValue:($,b,v)=>{if(r<b||(D($,b,v,a($)),r<=b+v))throw u},onSeparator:($,b,v)=>{if(r<=b)throw u;if($===":"&&l&&l.type==="property")l.colonOffset=b,k=!1,l=void 0;else if($===","){const C=d[d.length-1];typeof C=="number"?d[d.length-1]=C+1:(k=!0,d[d.length-1]=""),l=void 0}}})}catch($){if($!==u)throw $}return{path:d,previousNode:l,isAtPropertyKey:k,matches:$=>{let b=0;for(let v=0;b<$.length&&v<d.length;v++)if($[b]===d[v]||$[b]==="*")b++;else if($[b]!=="**")return!1;return b===$.length}}}e.$Zm=P;function g(t,r=[],d=L.DEFAULT){let u=null,l=[];const h=[];function k($){Array.isArray(l)?l.push($):u!==null&&(l[u]=$)}return n(t,{onObjectBegin:()=>{const $={};k($),h.push(l),l=$,u=null},onObjectProperty:$=>{u=$},onObjectEnd:()=>{l=h.pop()},onArrayBegin:()=>{const $=[];k($),h.push(l),l=$,u=null},onArrayEnd:()=>{l=h.pop()},onLiteralValue:k,onError:($,b,v)=>{r.push({error:$,offset:b,length:v})}},d),l[0]}e.$1m=g;function y(t,r=[],d=L.DEFAULT){let u={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l($){u.type==="property"&&(u.length=$-u.offset,u=u.parent)}function h($){return u.children.push($),$}n(t,{onObjectBegin:$=>{u=h({type:"object",offset:$,length:-1,parent:u,children:[]})},onObjectProperty:($,b,v)=>{u=h({type:"property",offset:b,length:-1,parent:u,children:[]}),u.children.push({type:"string",value:$,offset:b,length:v,parent:u})},onObjectEnd:($,b)=>{u.length=$+b-u.offset,u=u.parent,l($+b)},onArrayBegin:($,b)=>{u=h({type:"array",offset:$,length:-1,parent:u,children:[]})},onArrayEnd:($,b)=>{u.length=$+b-u.offset,u=u.parent,l($+b)},onLiteralValue:($,b,v)=>{h({type:a($),offset:b,length:v,parent:u,value:$}),l(b+v)},onSeparator:($,b,v)=>{u.type==="property"&&($===":"?u.colonOffset=b:$===","&&l(b))},onError:($,b,v)=>{r.push({error:$,offset:b,length:v})}},d);const D=u.children[0];return D&&delete D.parent,D}e.$2m=y;function S(t,r){if(!t)return;let d=t;for(const u of r)if(typeof u=="string"){if(d.type!=="object"||!Array.isArray(d.children))return;let l=!1;for(const h of d.children)if(Array.isArray(h.children)&&h.children[0].value===u){d=h.children[1],l=!0;break}if(!l)return}else{const l=u;if(d.type!=="array"||l<0||!Array.isArray(d.children)||l>=d.children.length)return;d=d.children[l]}return d}e.$3m=S;function w(t){if(!t.parent||!t.parent.children)return[];const r=w(t.parent);if(t.parent.type==="property"){const d=t.parent.children[0].value;r.push(d)}else if(t.parent.type==="array"){const d=t.parent.children.indexOf(t);d!==-1&&r.push(d)}return r}e.$4m=w;function c(t){switch(t.type){case"array":return t.children.map(c);case"object":{const r=Object.create(null);for(const d of t.children){const u=d.children[1];u&&(r[d.children[0].value]=c(u))}return r}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$5m=c;function s(t,r,d=!1){return r>=t.offset&&r<t.offset+t.length||d&&r===t.offset+t.length}e.$6m=s;function i(t,r,d=!1){if(s(t,r,d)){const u=t.children;if(Array.isArray(u))for(let l=0;l<u.length&&u[l].offset<=r;l++){const h=i(u[l],r,d);if(h)return h}return t}}e.$7m=i;function n(t,r,d=L.DEFAULT){const u=R(t,!1);function l(Z){return Z?()=>Z(u.getTokenOffset(),u.getTokenLength()):()=>!0}function h(Z){return Z?se=>Z(se,u.getTokenOffset(),u.getTokenLength()):()=>!0}const k=l(r.onObjectBegin),D=h(r.onObjectProperty),$=l(r.onObjectEnd),b=l(r.onArrayBegin),v=l(r.onArrayEnd),C=h(r.onLiteralValue),N=h(r.onSeparator),z=l(r.onComment),M=h(r.onError),O=d&&d.disallowComments,j=d&&d.allowTrailingComma;function T(){for(;;){const Z=u.scan();switch(u.getTokenError()){case 4:V(14);break;case 5:V(15);break;case 3:V(13);break;case 1:O||V(11);break;case 2:V(12);break;case 6:V(16);break}switch(Z){case 12:case 13:O?V(10):z();break;case 16:V(1);break;case 15:case 14:break;default:return Z}}}function V(Z,se=[],we=[]){if(M(Z),se.length+we.length>0){let H=u.getToken();for(;H!==17;){if(se.indexOf(H)!==-1){T();break}else if(we.indexOf(H)!==-1)break;H=T()}}}function q(Z){const se=u.getTokenValue();return Z?C(se):D(se),T(),!0}function fe(){switch(u.getToken()){case 11:{let Z=0;try{Z=JSON.parse(u.getTokenValue()),typeof Z!="number"&&(V(2),Z=0)}catch{V(2)}C(Z);break}case 7:C(null);break;case 8:C(!0);break;case 9:C(!1);break;default:return!1}return T(),!0}function ee(){return u.getToken()!==10?(V(3,[],[2,5]),!1):(q(!1),u.getToken()===6?(N(":"),T(),ae()||V(4,[],[2,5])):V(5,[],[2,5]),!0)}function Y(){k(),T();let Z=!1;for(;u.getToken()!==2&&u.getToken()!==17;){if(u.getToken()===5){if(Z||V(4,[],[]),N(","),T(),u.getToken()===2&&j)break}else Z&&V(6,[],[]);ee()||V(4,[],[2,5]),Z=!0}return $(),u.getToken()!==2?V(7,[2],[]):T(),!0}function X(){b(),T();let Z=!1;for(;u.getToken()!==4&&u.getToken()!==17;){if(u.getToken()===5){if(Z||V(4,[],[]),N(","),T(),u.getToken()===4&&j)break}else Z&&V(6,[],[]);ae()||V(4,[],[4,5]),Z=!0}return v(),u.getToken()!==4?V(8,[4],[]):T(),!0}function ae(){switch(u.getToken()){case 3:return X();case 1:return Y();case 10:return q(!0);default:return fe()}}return T(),u.getToken()===17?d.allowEmptyContent?!0:(V(4,[],[]),!1):ae()?(u.getToken()!==17&&V(9,[],[]),!0):(V(4,[],[]),!1)}e.$8m=n;function o(t,r){const d=R(t),u=[];let l,h=0,k;do switch(k=d.getPosition(),l=d.scan(),l){case 12:case 13:case 17:h!==k&&u.push(t.substring(h,k)),r!==void 0&&u.push(d.getTokenValue().replace(/[^\r\n]/g,r)),h=d.getPosition();break}while(l!==17);return u.join("")}e.$9m=o;function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$0m=a}),define(ke[48],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=void 0;class I{constructor(f){this.d=f,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(f){this.c=f}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$U=I}),define(ke[76],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1c=void 0;class I{static{this.Undefined=new I(void 0)}constructor(L){this.element=L,this.next=I.Undefined,this.prev=I.Undefined}}class F{constructor(){this.a=I.Undefined,this.b=I.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===I.Undefined}clear(){let L=this.a;for(;L!==I.Undefined;){const R=L.next;L.prev=I.Undefined,L.next=I.Undefined,L=R}this.a=I.Undefined,this.b=I.Undefined,this.c=0}unshift(L){return this.d(L,!1)}push(L){return this.d(L,!0)}d(L,R){const p=new I(L);if(this.a===I.Undefined)this.a=p,this.b=p;else if(R){const m=this.b;this.b=p,p.prev=m,m.next=p}else{const m=this.a;this.a=p,p.next=m,m.prev=p}this.c+=1;let E=!1;return()=>{E||(E=!0,this.e(p))}}shift(){if(this.a!==I.Undefined){const L=this.a.element;return this.e(this.a),L}}pop(){if(this.b!==I.Undefined){const L=this.b.element;return this.e(this.b),L}}e(L){if(L.prev!==I.Undefined&&L.next!==I.Undefined){const R=L.prev;R.next=L.next,L.next.prev=R}else L.prev===I.Undefined&&L.next===I.Undefined?(this.a=I.Undefined,this.b=I.Undefined):L.next===I.Undefined?(this.b=this.b.prev,this.b.next=I.Undefined):L.prev===I.Undefined&&(this.a=this.a.next,this.a.prev=I.Undefined);this.c-=1}*[Symbol.iterator](){let L=this.a;for(;L!==I.Undefined;)yield L.element,L=L.next}}e.$1c=F}),define(ke[28],Se([1,0]),function($e,e){"use strict";var I,F,f;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.$Bc=e.Touch=e.$Ac=e.$zc=e.$yc=e.$xc=e.$wc=void 0;function L(i,n,o){let a=i.get(n);return a===void 0&&(a=o,i.set(n,a)),a}e.$wc=L;function R(i){const n=[];return i.forEach((o,a)=>{n.push(`${a} => ${o}`)}),`Map(${i.size}) {${n.join(", ")}}`}e.$xc=R;function p(i){const n=[];return i.forEach(o=>{n.push(o)}),`Set(${i.size}) {${n.join(", ")}}`}e.$yc=p;class E{constructor(n,o){this.uri=n,this.value=o}}function m(i){return Array.isArray(i)}class A{static{this.a=n=>n.toString()}constructor(n,o){if(this[I]="ResourceMap",n instanceof A)this.b=new Map(n.b),this.c=o??A.a;else if(m(n)){this.b=new Map,this.c=o??A.a;for(const[a,t]of n)this.set(a,t)}else this.b=new Map,this.c=n??A.a}set(n,o){return this.b.set(this.c(n),new E(n,o)),this}get(n){return this.b.get(this.c(n))?.value}has(n){return this.b.has(this.c(n))}get size(){return this.b.size}clear(){this.b.clear()}delete(n){return this.b.delete(this.c(n))}forEach(n,o){typeof o<"u"&&(n=n.bind(o));for(const[a,t]of this.b)n(t.value,t.uri,this)}*values(){for(const n of this.b.values())yield n.value}*keys(){for(const n of this.b.values())yield n.uri}*entries(){for(const n of this.b.values())yield[n.uri,n.value]}*[(I=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.b)yield[n.uri,n.value]}}e.$zc=A;class P{constructor(n,o){this[F]="ResourceSet",!n||typeof n=="function"?this.a=new A(n):(this.a=new A(o),n.forEach(this.add,this))}get size(){return this.a.size}add(n){return this.a.set(n,n),this}clear(){this.a.clear()}delete(n){return this.a.delete(n)}forEach(n,o){this.a.forEach((a,t)=>n.call(o,t,t,this))}has(n){return this.a.has(n)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(F=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ac=P;var g;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(g||(e.Touch=g={}));class y{constructor(){this[f]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(n){return this.a.has(n)}get(n,o=0){const a=this.a.get(n);if(a)return o!==0&&this.j(a,o),a.value}set(n,o,a=0){let t=this.a.get(n);if(t)t.value=o,a!==0&&this.j(t,a);else{switch(t={key:n,value:o,next:void 0,previous:void 0},a){case 0:this.h(t);break;case 1:this.g(t);break;case 2:this.h(t);break;default:this.h(t);break}this.a.set(n,t),this.d++}return this}delete(n){return!!this.remove(n)}remove(n){const o=this.a.get(n);if(o)return this.a.delete(n),this.i(o),this.d--,o.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const n=this.b;return this.a.delete(n.key),this.i(n),this.d--,n.value}forEach(n,o){const a=this.e;let t=this.b;for(;t;){if(o?n.bind(o)(t.value,t.key,this):n(t.value,t.key,this),this.e!==a)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const n=this,o=this.e;let a=this.b;const t={[Symbol.iterator](){return t},next(){if(n.e!==o)throw new Error("LinkedMap got modified during iteration.");if(a){const r={value:a.key,done:!1};return a=a.next,r}else return{value:void 0,done:!0}}};return t}values(){const n=this,o=this.e;let a=this.b;const t={[Symbol.iterator](){return t},next(){if(n.e!==o)throw new Error("LinkedMap got modified during iteration.");if(a){const r={value:a.value,done:!1};return a=a.next,r}else return{value:void 0,done:!0}}};return t}entries(){const n=this,o=this.e;let a=this.b;const t={[Symbol.iterator](){return t},next(){if(n.e!==o)throw new Error("LinkedMap got modified during iteration.");if(a){const r={value:[a.key,a.value],done:!1};return a=a.next,r}else return{value:void 0,done:!0}}};return t}[(f=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(n){if(n>=this.size)return;if(n===0){this.clear();return}let o=this.b,a=this.size;for(;o&&a>n;)this.a.delete(o.key),o=o.next,a--;this.b=o,this.d=a,o&&(o.previous=void 0),this.e++}g(n){if(!this.b&&!this.c)this.c=n;else if(this.b)n.next=this.b,this.b.previous=n;else throw new Error("Invalid list");this.b=n,this.e++}h(n){if(!this.b&&!this.c)this.b=n;else if(this.c)n.previous=this.c,this.c.next=n;else throw new Error("Invalid list");this.c=n,this.e++}i(n){if(n===this.b&&n===this.c)this.b=void 0,this.c=void 0;else if(n===this.b){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this.b=n.next}else if(n===this.c){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this.c=n.previous}else{const o=n.next,a=n.previous;if(!o||!a)throw new Error("Invalid list");o.previous=a,a.next=o}n.next=void 0,n.previous=void 0,this.e++}j(n,o){if(!this.b||!this.c)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(n===this.b)return;const a=n.next,t=n.previous;n===this.c?(t.next=void 0,this.c=t):(a.previous=t,t.next=a),n.previous=void 0,n.next=this.b,this.b.previous=n,this.b=n,this.e++}else if(o===2){if(n===this.c)return;const a=n.next,t=n.previous;n===this.b?(a.previous=void 0,this.b=a):(a.previous=t,t.next=a),n.next=void 0,n.previous=this.c,this.c.next=n,this.c=n,this.e++}}}toJSON(){const n=[];return this.forEach((o,a)=>{n.push([a,o])}),n}fromJSON(n){this.clear();for(const[o,a]of n)this.set(o,a)}}e.$Bc=y;class S extends y{constructor(n,o=1){super(),this.k=n,this.l=Math.min(Math.max(0,o),1)}get limit(){return this.k}set limit(n){this.k=n,this.m()}get ratio(){return this.l}set ratio(n){this.l=Math.min(Math.max(0,n),1),this.m()}get(n,o=2){return super.get(n,o)}peek(n){return super.get(n,0)}set(n,o){return super.set(n,o,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Cc=S;class w{constructor(){this.a=new Map}add(n){return this.a.set(n,(this.a.get(n)||0)+1),this}delete(n){let o=this.a.get(n)||0;return o===0?!1:(o--,o===0?this.a.delete(n):this.a.set(n,o),!0)}has(n){return this.a.has(n)}}e.$Dc=w;class c{constructor(n){if(this.a=new Map,this.b=new Map,n)for(const[o,a]of n)this.set(o,a)}clear(){this.a.clear(),this.b.clear()}set(n,o){this.a.set(n,o),this.b.set(o,n)}get(n){return this.a.get(n)}getKey(n){return this.b.get(n)}delete(n){const o=this.a.get(n);return o===void 0?!1:(this.a.delete(n),this.b.delete(o),!0)}forEach(n,o){this.a.forEach((a,t)=>{n.call(o,a,t,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Ec=c;class s{constructor(){this.a=new Map}add(n,o){let a=this.a.get(n);a||(a=new Set,this.a.set(n,a)),a.add(o)}delete(n,o){const a=this.a.get(n);a&&(a.delete(o),a.size===0&&this.a.delete(n))}forEach(n,o){const a=this.a.get(n);a&&a.forEach(o)}get(n){const o=this.a.get(n);return o||new Set}}e.$Fc=s}),define(ke[3],Se([1,0,19,74,28,75,51]),function($e,e,I,F,f,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=void 0;const p=!1;let E=null;class m{constructor(){this.b=new Map}static{this.a=0}c(v){let C=this.b.get(v);return C||(C={parent:null,source:null,isSingleton:!1,value:v,idx:m.a++},this.b.set(v,C)),C}trackDisposable(v){const C=this.c(v);C.source||(C.source=new Error().stack)}setParent(v,C){const N=this.c(v);N.parent=C}markAsDisposed(v){this.b.delete(v)}markAsSingleton(v){this.c(v).isSingleton=!0}f(v,C){const N=C.get(v);if(N)return N;const z=v.parent?this.f(this.c(v.parent),C):v;return C.set(v,z),z}getTrackedDisposables(){const v=new Map;return[...this.b.entries()].filter(([,N])=>N.source!==null&&!this.f(N,v).isSingleton).flatMap(([N])=>N)}computeLeakingDisposables(v=10,C){let N;if(C)N=C;else{const T=new Map,V=[...this.b.values()].filter(fe=>fe.source!==null&&!this.f(fe,T).isSingleton);if(V.length===0)return;const q=new Set(V.map(fe=>fe.value));if(N=V.filter(fe=>!(fe.parent&&q.has(fe.parent))),N.length===0)throw new Error("There are cyclic diposable chains!")}if(!N)return;function z(T){function V(fe,ee){for(;fe.length>0&&ee.some(Y=>typeof Y=="string"?Y===fe[0]:fe[0].match(Y));)fe.shift()}const q=T.source.split(`
`).map(fe=>fe.trim().replace("at ","")).filter(fe=>fe!=="");return V(q,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),q.reverse()}const M=new f.$Fc;for(const T of N){const V=z(T);for(let q=0;q<=V.length;q++)M.add(V.slice(0,q).join(`
`),T)}N.sort((0,I.$6b)(T=>T.idx,I.$8b));let O="",j=0;for(const T of N.slice(0,v)){j++;const V=z(T),q=[];for(let fe=0;fe<V.length;fe++){let ee=V[fe];ee=`(shared with ${M.get(V.slice(0,fe+1).join(`
`)).size}/${N.length} leaks) at ${ee}`;const X=M.get(V.slice(0,fe).join(`
`)),ae=(0,F.$J)([...X].map(Z=>z(Z)[fe]),Z=>Z);delete ae[V[fe]];for(const[Z,se]of Object.entries(ae))q.unshift(`    - stacktraces of ${se.length} other leaks continue with ${Z}`);q.unshift(ee)}O+=`


==================== Leaking disposable ${j}/${N.length}: ${T.value.constructor.name} ====================
${q.join(`
`)}
============================================================

`}return N.length>v&&(O+=`


... and ${N.length-v} more leaking disposables

`),{leaks:N,details:O}}}e.$Gc=m;function A(b){E=b}if(e.$Hc=A,p){const b="__is_disposable_tracked__";A(new class{trackDisposable(v){const C=new Error("Potentially leaked disposable").stack;setTimeout(()=>{v[b]||console.log(C)},3e3)}setParent(v,C){if(v&&v!==t.None)try{v[b]=!0}catch{}}markAsDisposed(v){if(v&&v!==t.None)try{v[b]=!0}catch{}}markAsSingleton(v){}})}function P(b){return E?.trackDisposable(b),b}e.$Ic=P;function g(b){E?.markAsDisposed(b)}e.$Jc=g;function y(b,v){E?.setParent(b,v)}function S(b,v){if(E)for(const C of b)E.setParent(C,v)}function w(b){return E?.markAsSingleton(b),b}e.$Kc=w;function c(b){return typeof b.dispose=="function"&&b.dispose.length===0}e.$Lc=c;function s(b){if(R.Iterable.is(b)){const v=[];for(const C of b)if(C)try{C.dispose()}catch(N){v.push(N)}if(v.length===1)throw v[0];if(v.length>1)throw new AggregateError(v,"Encountered errors while disposing of store");return Array.isArray(b)?[]:b}else if(b)return b.dispose(),b}e.$Mc=s;function i(b){for(const v of b)c(v)&&v.dispose();return[]}e.$Nc=i;function n(...b){const v=o(()=>s(b));return S(b,v),v}e.$Oc=n;function o(b){const v=P({dispose:(0,L.$cb)(()=>{g(v),b()})});return v}e.$Pc=o;class a{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,P(this)}dispose(){this.g||(g(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{s(this.f)}finally{this.f.clear()}}add(v){if(!v)return v;if(v===this)throw new Error("Cannot register a disposable on itself!");return y(v,this),this.g?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(v),v}delete(v){if(v){if(v===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(v),v.dispose()}}deleteAndLeak(v){v&&this.f.has(v)&&(this.f.delete(v),y(v,null))}}e.$Qc=a;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new a,P(this),y(this.q,this)}dispose(){g(this),this.q.dispose()}B(v){if(v===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(v)}}e.$Rc=t;class r{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value(v){this.b||v===this.a||(this.a?.dispose(),v&&y(v,this),this.a=v)}clear(){this.value=void 0}dispose(){this.b=!0,g(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const v=this.a;return this.a=void 0,v&&y(v,null),v}}e.$Sc=r;class d{constructor(v){this.b=v,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Tc=d;class u{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(v){let C=v;return this.unset=()=>C=void 0,this.isset=()=>C!==void 0,this.dispose=()=>{C&&(C(),C=void 0,g(this))},this}}e.$Uc=u;class l{constructor(){this.a=new Map}acquire(v,...C){let N=this.a.get(v);N||(N={counter:0,object:this.b(v,...C)},this.a.set(v,N));const{object:z}=N,M=(0,L.$cb)(()=>{--N.counter===0&&(this.c(v,N.object),this.a.delete(v))});return N.counter++,{object:z,dispose:M}}}e.$Vc=l;class h{constructor(v){this.a=v}async acquire(v,...C){const N=this.a.acquire(v,...C);try{return{object:await N.object,dispose:()=>N.dispose()}}catch(z){throw N.dispose(),z}}}e.$Wc=h;class k{constructor(v){this.object=v}dispose(){}}e.$Xc=k;function D(b){const v=new a;try{b(v)}finally{v.dispose()}}e.$Yc=D;class ${constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){g(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{s(this.a.values())}finally{this.a.clear()}}has(v){return this.a.has(v)}get size(){return this.a.size}get(v){return this.a.get(v)}set(v,C,N=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),N||this.a.get(v)?.dispose(),this.a.set(v,C)}deleteAndDispose(v){this.a.get(v)?.dispose(),this.a.delete(v)}keys(){return this.a.keys()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$Zc=$}),function($e,e){typeof define=="function"&&define.amd?define(ke[161],Se([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):($e=typeof globalThis<"u"?globalThis:$e||self,e($e.marked={}))}(this,function($e){"use strict";function e(G,J){for(var ge=0;ge<J.length;ge++){var x=J[ge];x.enumerable=x.enumerable||!1,x.configurable=!0,"value"in x&&(x.writable=!0),Object.defineProperty(G,x.key,x)}}function I(G,J,ge){return J&&e(G.prototype,J),ge&&e(G,ge),Object.defineProperty(G,"prototype",{writable:!1}),G}function F(G,J){if(G){if(typeof G=="string")return f(G,J);var ge=Object.prototype.toString.call(G).slice(8,-1);if(ge==="Object"&&G.constructor&&(ge=G.constructor.name),ge==="Map"||ge==="Set")return Array.from(G);if(ge==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ge))return f(G,J)}}function f(G,J){(J==null||J>G.length)&&(J=G.length);for(var ge=0,x=new Array(J);ge<J;ge++)x[ge]=G[ge];return x}function L(G,J){var ge=typeof Symbol<"u"&&G[Symbol.iterator]||G["@@iterator"];if(ge)return(ge=ge.call(G)).next.bind(ge);if(Array.isArray(G)||(ge=F(G))||J&&G&&typeof G.length=="number"){ge&&(G=ge);var x=0;return function(){return x>=G.length?{done:!0}:{done:!1,value:G[x++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}$e.defaults=R();function p(G){$e.defaults=G}var E=/[&<>"']/,m=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,P=/[<>"']|&(?!#?\w+;)/g,g={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},y=function(J){return g[J]};function S(G,J){if(J){if(E.test(G))return G.replace(m,y)}else if(A.test(G))return G.replace(P,y);return G}var w=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function c(G){return G.replace(w,function(J,ge){return ge=ge.toLowerCase(),ge==="colon"?":":ge.charAt(0)==="#"?ge.charAt(1)==="x"?String.fromCharCode(parseInt(ge.substring(2),16)):String.fromCharCode(+ge.substring(1)):""})}var s=/(^|[^\[])\^/g;function i(G,J){G=typeof G=="string"?G:G.source,J=J||"";var ge={replace:function(le,te){return te=te.source||te,te=te.replace(s,"$1"),G=G.replace(le,te),ge},getRegex:function(){return new RegExp(G,J)}};return ge}var n=/[^\w:]/g,o=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function a(G,J,ge){if(G){var x;try{x=decodeURIComponent(c(ge)).replace(n,"").toLowerCase()}catch{return null}if(x.indexOf("javascript:")===0||x.indexOf("vbscript:")===0||x.indexOf("data:")===0)return null}J&&!o.test(ge)&&(ge=l(J,ge));try{ge=encodeURI(ge).replace(/%25/g,"%")}catch{return null}return ge}var t={},r=/^[^:]+:\/*[^/]*$/,d=/^([^:]+:)[\s\S]*$/,u=/^([^:]+:\/*[^/]*)[\s\S]*$/;function l(G,J){t[" "+G]||(r.test(G)?t[" "+G]=G+"/":t[" "+G]=$(G,"/",!0)),G=t[" "+G];var ge=G.indexOf(":")===-1;return J.substring(0,2)==="//"?ge?J:G.replace(d,"$1")+J:J.charAt(0)==="/"?ge?J:G.replace(u,"$1")+J:G+J}var h={exec:function(){}};function k(G){for(var J=1,ge,x;J<arguments.length;J++){ge=arguments[J];for(x in ge)Object.prototype.hasOwnProperty.call(ge,x)&&(G[x]=ge[x])}return G}function D(G,J){var ge=G.replace(/\|/g,function(te,de,be){for(var Pe=!1,B=de;--B>=0&&be[B]==="\\";)Pe=!Pe;return Pe?"|":" |"}),x=ge.split(/ \|/),le=0;if(x[0].trim()||x.shift(),x.length>0&&!x[x.length-1].trim()&&x.pop(),x.length>J)x.splice(J);else for(;x.length<J;)x.push("");for(;le<x.length;le++)x[le]=x[le].trim().replace(/\\\|/g,"|");return x}function $(G,J,ge){var x=G.length;if(x===0)return"";for(var le=0;le<x;){var te=G.charAt(x-le-1);if(te===J&&!ge)le++;else if(te!==J&&ge)le++;else break}return G.slice(0,x-le)}function b(G,J){if(G.indexOf(J[1])===-1)return-1;for(var ge=G.length,x=0,le=0;le<ge;le++)if(G[le]==="\\")le++;else if(G[le]===J[0])x++;else if(G[le]===J[1]&&(x--,x<0))return le;return-1}function v(G){G&&G.sanitize&&!G.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function C(G,J){if(J<1)return"";for(var ge="";J>1;)J&1&&(ge+=G),J>>=1,G+=G;return ge+G}function N(G,J,ge,x){var le=J.href,te=J.title?S(J.title):null,de=G[1].replace(/\\([\[\]])/g,"$1");if(G[0].charAt(0)!=="!"){x.state.inLink=!0;var be={type:"link",raw:ge,href:le,title:te,text:de,tokens:x.inlineTokens(de)};return x.state.inLink=!1,be}return{type:"image",raw:ge,href:le,title:te,text:S(de)}}function z(G,J){var ge=G.match(/^(\s+)(?:```)/);if(ge===null)return J;var x=ge[1];return J.split(`
`).map(function(le){var te=le.match(/^\s+/);if(te===null)return le;var de=te[0];return de.length>=x.length?le.slice(x.length):le}).join(`
`)}var M=function(){function G(ge){this.options=ge||$e.defaults}var J=G.prototype;return J.space=function(x){var le=this.rules.block.newline.exec(x);if(le&&le[0].length>0)return{type:"space",raw:le[0]}},J.code=function(x){var le=this.rules.block.code.exec(x);if(le){var te=le[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:le[0],codeBlockStyle:"indented",text:this.options.pedantic?te:$(te,`
`)}}},J.fences=function(x){var le=this.rules.block.fences.exec(x);if(le){var te=le[0],de=z(te,le[3]||"");return{type:"code",raw:te,lang:le[2]?le[2].trim():le[2],text:de}}},J.heading=function(x){var le=this.rules.block.heading.exec(x);if(le){var te=le[2].trim();if(/#$/.test(te)){var de=$(te,"#");(this.options.pedantic||!de||/ $/.test(de))&&(te=de.trim())}return{type:"heading",raw:le[0],depth:le[1].length,text:te,tokens:this.lexer.inline(te)}}},J.hr=function(x){var le=this.rules.block.hr.exec(x);if(le)return{type:"hr",raw:le[0]}},J.blockquote=function(x){var le=this.rules.block.blockquote.exec(x);if(le){var te=le[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:le[0],tokens:this.lexer.blockTokens(te,[]),text:te}}},J.list=function(x){var le=this.rules.block.list.exec(x);if(le){var te,de,be,Pe,B,Q,re,oe,_,me,ye,ze,We=le[1].trim(),_e=We.length>1,Ye={type:"list",raw:"",ordered:_e,start:_e?+We.slice(0,-1):"",loose:!1,items:[]};We=_e?"\\d{1,9}\\"+We.slice(-1):"\\"+We,this.options.pedantic&&(We=_e?We:"[*+-]");for(var it=new RegExp("^( {0,3}"+We+")((?:[	 ][^\\n]*)?(?:\\n|$))");x&&(ze=!1,!(!(le=it.exec(x))||this.rules.block.hr.test(x)));){if(te=le[0],x=x.substring(te.length),oe=le[2].split(`
`,1)[0],_=x.split(`
`,1)[0],this.options.pedantic?(Pe=2,ye=oe.trimLeft()):(Pe=le[2].search(/[^ ]/),Pe=Pe>4?1:Pe,ye=oe.slice(Pe),Pe+=le[1].length),Q=!1,!oe&&/^ *$/.test(_)&&(te+=_+`
`,x=x.substring(_.length+1),ze=!0),!ze)for(var tt=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Ae=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Oe=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}(?:```|~~~)"),Ve=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}#");x&&(me=x.split(`
`,1)[0],oe=me,this.options.pedantic&&(oe=oe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Oe.test(oe)||Ve.test(oe)||tt.test(oe)||Ae.test(x)));){if(oe.search(/[^ ]/)>=Pe||!oe.trim())ye+=`
`+oe.slice(Pe);else if(!Q)ye+=`
`+oe;else break;!Q&&!oe.trim()&&(Q=!0),te+=me+`
`,x=x.substring(me.length+1)}Ye.loose||(re?Ye.loose=!0:/\n *\n *$/.test(te)&&(re=!0)),this.options.gfm&&(de=/^\[[ xX]\] /.exec(ye),de&&(be=de[0]!=="[ ] ",ye=ye.replace(/^\[[ xX]\] +/,""))),Ye.items.push({type:"list_item",raw:te,task:!!de,checked:be,loose:!1,text:ye}),Ye.raw+=te}Ye.items[Ye.items.length-1].raw=te.trimRight(),Ye.items[Ye.items.length-1].text=ye.trimRight(),Ye.raw=Ye.raw.trimRight();var Re=Ye.items.length;for(B=0;B<Re;B++){this.lexer.state.top=!1,Ye.items[B].tokens=this.lexer.blockTokens(Ye.items[B].text,[]);var Xe=Ye.items[B].tokens.filter(function(ue){return ue.type==="space"}),he=Xe.every(function(ue){for(var Ie=ue.raw.split(""),Ke=0,Ue=L(Ie),Ze;!(Ze=Ue()).done;){var nt=Ze.value;if(nt===`
`&&(Ke+=1),Ke>1)return!0}return!1});!Ye.loose&&Xe.length&&he&&(Ye.loose=!0,Ye.items[B].loose=!0)}return Ye}},J.html=function(x){var le=this.rules.block.html.exec(x);if(le){var te={type:"html",raw:le[0],pre:!this.options.sanitizer&&(le[1]==="pre"||le[1]==="script"||le[1]==="style"),text:le[0]};if(this.options.sanitize){var de=this.options.sanitizer?this.options.sanitizer(le[0]):S(le[0]);te.type="paragraph",te.text=de,te.tokens=this.lexer.inline(de)}return te}},J.def=function(x){var le=this.rules.block.def.exec(x);if(le){le[3]&&(le[3]=le[3].substring(1,le[3].length-1));var te=le[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:te,raw:le[0],href:le[2],title:le[3]}}},J.table=function(x){var le=this.rules.block.table.exec(x);if(le){var te={type:"table",header:D(le[1]).map(function(re){return{text:re}}),align:le[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:le[3]&&le[3].trim()?le[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(te.header.length===te.align.length){te.raw=le[0];var de=te.align.length,be,Pe,B,Q;for(be=0;be<de;be++)/^ *-+: *$/.test(te.align[be])?te.align[be]="right":/^ *:-+: *$/.test(te.align[be])?te.align[be]="center":/^ *:-+ *$/.test(te.align[be])?te.align[be]="left":te.align[be]=null;for(de=te.rows.length,be=0;be<de;be++)te.rows[be]=D(te.rows[be],te.header.length).map(function(re){return{text:re}});for(de=te.header.length,Pe=0;Pe<de;Pe++)te.header[Pe].tokens=this.lexer.inline(te.header[Pe].text);for(de=te.rows.length,Pe=0;Pe<de;Pe++)for(Q=te.rows[Pe],B=0;B<Q.length;B++)Q[B].tokens=this.lexer.inline(Q[B].text);return te}}},J.lheading=function(x){var le=this.rules.block.lheading.exec(x);if(le)return{type:"heading",raw:le[0],depth:le[2].charAt(0)==="="?1:2,text:le[1],tokens:this.lexer.inline(le[1])}},J.paragraph=function(x){var le=this.rules.block.paragraph.exec(x);if(le){var te=le[1].charAt(le[1].length-1)===`
`?le[1].slice(0,-1):le[1];return{type:"paragraph",raw:le[0],text:te,tokens:this.lexer.inline(te)}}},J.text=function(x){var le=this.rules.block.text.exec(x);if(le)return{type:"text",raw:le[0],text:le[0],tokens:this.lexer.inline(le[0])}},J.escape=function(x){var le=this.rules.inline.escape.exec(x);if(le)return{type:"escape",raw:le[0],text:S(le[1])}},J.tag=function(x){var le=this.rules.inline.tag.exec(x);if(le)return!this.lexer.state.inLink&&/^<a /i.test(le[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(le[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(le[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(le[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:le[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):S(le[0]):le[0]}},J.link=function(x){var le=this.rules.inline.link.exec(x);if(le){var te=le[2].trim();if(!this.options.pedantic&&/^</.test(te)){if(!/>$/.test(te))return;var de=$(te.slice(0,-1),"\\");if((te.length-de.length)%2===0)return}else{var be=b(le[2],"()");if(be>-1){var Pe=le[0].indexOf("!")===0?5:4,B=Pe+le[1].length+be;le[2]=le[2].substring(0,be),le[0]=le[0].substring(0,B).trim(),le[3]=""}}var Q=le[2],re="";if(this.options.pedantic){var oe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Q);oe&&(Q=oe[1],re=oe[3])}else re=le[3]?le[3].slice(1,-1):"";return Q=Q.trim(),/^</.test(Q)&&(this.options.pedantic&&!/>$/.test(te)?Q=Q.slice(1):Q=Q.slice(1,-1)),N(le,{href:Q&&Q.replace(this.rules.inline._escapes,"$1"),title:re&&re.replace(this.rules.inline._escapes,"$1")},le[0],this.lexer)}},J.reflink=function(x,le){var te;if((te=this.rules.inline.reflink.exec(x))||(te=this.rules.inline.nolink.exec(x))){var de=(te[2]||te[1]).replace(/\s+/g," ");if(de=le[de.toLowerCase()],!de||!de.href){var be=te[0].charAt(0);return{type:"text",raw:be,text:be}}return N(te,de,te[0],this.lexer)}},J.emStrong=function(x,le,te){te===void 0&&(te="");var de=this.rules.inline.emStrong.lDelim.exec(x);if(de&&!(de[3]&&te.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var be=de[1]||de[2]||"";if(!be||be&&(te===""||this.rules.inline.punctuation.exec(te))){var Pe=de[0].length-1,B,Q,re=Pe,oe=0,_=de[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(_.lastIndex=0,le=le.slice(-1*x.length+Pe);(de=_.exec(le))!=null;)if(B=de[1]||de[2]||de[3]||de[4]||de[5]||de[6],!!B){if(Q=B.length,de[3]||de[4]){re+=Q;continue}else if((de[5]||de[6])&&Pe%3&&!((Pe+Q)%3)){oe+=Q;continue}if(re-=Q,!(re>0)){if(Q=Math.min(Q,Q+re+oe),Math.min(Pe,Q)%2){var me=x.slice(1,Pe+de.index+Q);return{type:"em",raw:x.slice(0,Pe+de.index+Q+1),text:me,tokens:this.lexer.inlineTokens(me)}}var ye=x.slice(2,Pe+de.index+Q-1);return{type:"strong",raw:x.slice(0,Pe+de.index+Q+1),text:ye,tokens:this.lexer.inlineTokens(ye)}}}}}},J.codespan=function(x){var le=this.rules.inline.code.exec(x);if(le){var te=le[2].replace(/\n/g," "),de=/[^ ]/.test(te),be=/^ /.test(te)&&/ $/.test(te);return de&&be&&(te=te.substring(1,te.length-1)),te=S(te,!0),{type:"codespan",raw:le[0],text:te}}},J.br=function(x){var le=this.rules.inline.br.exec(x);if(le)return{type:"br",raw:le[0]}},J.del=function(x){var le=this.rules.inline.del.exec(x);if(le)return{type:"del",raw:le[0],text:le[2],tokens:this.lexer.inlineTokens(le[2])}},J.autolink=function(x,le){var te=this.rules.inline.autolink.exec(x);if(te){var de,be;return te[2]==="@"?(de=S(this.options.mangle?le(te[1]):te[1]),be="mailto:"+de):(de=S(te[1]),be=de),{type:"link",raw:te[0],text:de,href:be,tokens:[{type:"text",raw:de,text:de}]}}},J.url=function(x,le){var te;if(te=this.rules.inline.url.exec(x)){var de,be;if(te[2]==="@")de=S(this.options.mangle?le(te[0]):te[0]),be="mailto:"+de;else{var Pe;do Pe=te[0],te[0]=this.rules.inline._backpedal.exec(te[0])[0];while(Pe!==te[0]);de=S(te[0]),te[1]==="www."?be="http://"+de:be=de}return{type:"link",raw:te[0],text:de,href:be,tokens:[{type:"text",raw:de,text:de}]}}},J.inlineText=function(x,le){var te=this.rules.inline.text.exec(x);if(te){var de;return this.lexer.state.inRawBlock?de=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(te[0]):S(te[0]):te[0]:de=S(this.options.smartypants?le(te[0]):te[0]),{type:"text",raw:te[0],text:de}}},G}(),O={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:h,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};O._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,O._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,O.def=i(O.def).replace("label",O._label).replace("title",O._title).getRegex(),O.bullet=/(?:[*+-]|\d{1,9}[.)])/,O.listItemStart=i(/^( *)(bull) */).replace("bull",O.bullet).getRegex(),O.list=i(O.list).replace(/bull/g,O.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+O.def.source+")").getRegex(),O._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",O._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,O.html=i(O.html,"i").replace("comment",O._comment).replace("tag",O._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),O.paragraph=i(O._paragraph).replace("hr",O.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",O._tag).getRegex(),O.blockquote=i(O.blockquote).replace("paragraph",O.paragraph).getRegex(),O.normal=k({},O),O.gfm=k({},O.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),O.gfm.table=i(O.gfm.table).replace("hr",O.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",O._tag).getRegex(),O.gfm.paragraph=i(O._paragraph).replace("hr",O.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",O.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",O._tag).getRegex(),O.pedantic=k({},O.normal,{html:i(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",O._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:h,paragraph:i(O.normal._paragraph).replace("hr",O.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",O.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var j={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:h,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:h,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};j._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",j.punctuation=i(j.punctuation).replace(/punctuation/g,j._punctuation).getRegex(),j.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,j.escapedEmSt=/\\\*|\\_/g,j._comment=i(O._comment).replace("(?:-->|$)","-->").getRegex(),j.emStrong.lDelim=i(j.emStrong.lDelim).replace(/punct/g,j._punctuation).getRegex(),j.emStrong.rDelimAst=i(j.emStrong.rDelimAst,"g").replace(/punct/g,j._punctuation).getRegex(),j.emStrong.rDelimUnd=i(j.emStrong.rDelimUnd,"g").replace(/punct/g,j._punctuation).getRegex(),j._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,j._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,j._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,j.autolink=i(j.autolink).replace("scheme",j._scheme).replace("email",j._email).getRegex(),j._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,j.tag=i(j.tag).replace("comment",j._comment).replace("attribute",j._attribute).getRegex(),j._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,j._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,j._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,j.link=i(j.link).replace("label",j._label).replace("href",j._href).replace("title",j._title).getRegex(),j.reflink=i(j.reflink).replace("label",j._label).replace("ref",O._label).getRegex(),j.nolink=i(j.nolink).replace("ref",O._label).getRegex(),j.reflinkSearch=i(j.reflinkSearch,"g").replace("reflink",j.reflink).replace("nolink",j.nolink).getRegex(),j.normal=k({},j),j.pedantic=k({},j.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:i(/^!?\[(label)\]\((.*?)\)/).replace("label",j._label).getRegex(),reflink:i(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",j._label).getRegex()}),j.gfm=k({},j.normal,{escape:i(j.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),j.gfm.url=i(j.gfm.url,"i").replace("email",j.gfm._extended_email).getRegex(),j.breaks=k({},j.gfm,{br:i(j.br).replace("{2,}","*").getRegex(),text:i(j.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function T(G){return G.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function V(G){var J="",ge,x,le=G.length;for(ge=0;ge<le;ge++)x=G.charCodeAt(ge),Math.random()>.5&&(x="x"+x.toString(16)),J+="&#"+x+";";return J}var q=function(){function G(ge){this.tokens=[],this.tokens.links=Object.create(null),this.options=ge||$e.defaults,this.options.tokenizer=this.options.tokenizer||new M,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var x={block:O.normal,inline:j.normal};this.options.pedantic?(x.block=O.pedantic,x.inline=j.pedantic):this.options.gfm&&(x.block=O.gfm,this.options.breaks?x.inline=j.breaks:x.inline=j.gfm),this.tokenizer.rules=x}G.lex=function(x,le){var te=new G(le);return te.lex(x)},G.lexInline=function(x,le){var te=new G(le);return te.inlineTokens(x)};var J=G.prototype;return J.lex=function(x){x=x.replace(/\r\n|\r/g,`
`),this.blockTokens(x,this.tokens);for(var le;le=this.inlineQueue.shift();)this.inlineTokens(le.src,le.tokens);return this.tokens},J.blockTokens=function(x,le){var te=this;le===void 0&&(le=[]),this.options.pedantic?x=x.replace(/\t/g,"    ").replace(/^ +$/gm,""):x=x.replace(/^( *)(\t+)/gm,function(re,oe,_){return oe+"    ".repeat(_.length)});for(var de,be,Pe,B;x;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(re){return(de=re.call({lexer:te},x,le))?(x=x.substring(de.raw.length),le.push(de),!0):!1}))){if(de=this.tokenizer.space(x)){x=x.substring(de.raw.length),de.raw.length===1&&le.length>0?le[le.length-1].raw+=`
`:le.push(de);continue}if(de=this.tokenizer.code(x)){x=x.substring(de.raw.length),be=le[le.length-1],be&&(be.type==="paragraph"||be.type==="text")?(be.raw+=`
`+de.raw,be.text+=`
`+de.text,this.inlineQueue[this.inlineQueue.length-1].src=be.text):le.push(de);continue}if(de=this.tokenizer.fences(x)){x=x.substring(de.raw.length),le.push(de);continue}if(de=this.tokenizer.heading(x)){x=x.substring(de.raw.length),le.push(de);continue}if(de=this.tokenizer.hr(x)){x=x.substring(de.raw.length),le.push(de);continue}if(de=this.tokenizer.blockquote(x)){x=x.substring(de.raw.length),le.push(de);continue}if(de=this.tokenizer.list(x)){x=x.substring(de.raw.length),le.push(de);continue}if(de=this.tokenizer.html(x)){x=x.substring(de.raw.length),le.push(de);continue}if(de=this.tokenizer.def(x)){x=x.substring(de.raw.length),be=le[le.length-1],be&&(be.type==="paragraph"||be.type==="text")?(be.raw+=`
`+de.raw,be.text+=`
`+de.raw,this.inlineQueue[this.inlineQueue.length-1].src=be.text):this.tokens.links[de.tag]||(this.tokens.links[de.tag]={href:de.href,title:de.title});continue}if(de=this.tokenizer.table(x)){x=x.substring(de.raw.length),le.push(de);continue}if(de=this.tokenizer.lheading(x)){x=x.substring(de.raw.length),le.push(de);continue}if(Pe=x,this.options.extensions&&this.options.extensions.startBlock&&function(){var re=1/0,oe=x.slice(1),_=void 0;te.options.extensions.startBlock.forEach(function(me){_=me.call({lexer:this},oe),typeof _=="number"&&_>=0&&(re=Math.min(re,_))}),re<1/0&&re>=0&&(Pe=x.substring(0,re+1))}(),this.state.top&&(de=this.tokenizer.paragraph(Pe))){be=le[le.length-1],B&&be.type==="paragraph"?(be.raw+=`
`+de.raw,be.text+=`
`+de.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=be.text):le.push(de),B=Pe.length!==x.length,x=x.substring(de.raw.length);continue}if(de=this.tokenizer.text(x)){x=x.substring(de.raw.length),be=le[le.length-1],be&&be.type==="text"?(be.raw+=`
`+de.raw,be.text+=`
`+de.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=be.text):le.push(de);continue}if(x){var Q="Infinite loop on byte: "+x.charCodeAt(0);if(this.options.silent){console.error(Q);break}else throw new Error(Q)}}return this.state.top=!0,le},J.inline=function(x,le){return le===void 0&&(le=[]),this.inlineQueue.push({src:x,tokens:le}),le},J.inlineTokens=function(x,le){var te=this;le===void 0&&(le=[]);var de,be,Pe,B=x,Q,re,oe;if(this.tokens.links){var _=Object.keys(this.tokens.links);if(_.length>0)for(;(Q=this.tokenizer.rules.inline.reflinkSearch.exec(B))!=null;)_.includes(Q[0].slice(Q[0].lastIndexOf("[")+1,-1))&&(B=B.slice(0,Q.index)+"["+C("a",Q[0].length-2)+"]"+B.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Q=this.tokenizer.rules.inline.blockSkip.exec(B))!=null;)B=B.slice(0,Q.index)+"["+C("a",Q[0].length-2)+"]"+B.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Q=this.tokenizer.rules.inline.escapedEmSt.exec(B))!=null;)B=B.slice(0,Q.index)+"++"+B.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;x;)if(re||(oe=""),re=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ye){return(de=ye.call({lexer:te},x,le))?(x=x.substring(de.raw.length),le.push(de),!0):!1}))){if(de=this.tokenizer.escape(x)){x=x.substring(de.raw.length),le.push(de);continue}if(de=this.tokenizer.tag(x)){x=x.substring(de.raw.length),be=le[le.length-1],be&&de.type==="text"&&be.type==="text"?(be.raw+=de.raw,be.text+=de.text):le.push(de);continue}if(de=this.tokenizer.link(x)){x=x.substring(de.raw.length),le.push(de);continue}if(de=this.tokenizer.reflink(x,this.tokens.links)){x=x.substring(de.raw.length),be=le[le.length-1],be&&de.type==="text"&&be.type==="text"?(be.raw+=de.raw,be.text+=de.text):le.push(de);continue}if(de=this.tokenizer.emStrong(x,B,oe)){x=x.substring(de.raw.length),le.push(de);continue}if(de=this.tokenizer.codespan(x)){x=x.substring(de.raw.length),le.push(de);continue}if(de=this.tokenizer.br(x)){x=x.substring(de.raw.length),le.push(de);continue}if(de=this.tokenizer.del(x)){x=x.substring(de.raw.length),le.push(de);continue}if(de=this.tokenizer.autolink(x,V)){x=x.substring(de.raw.length),le.push(de);continue}if(!this.state.inLink&&(de=this.tokenizer.url(x,V))){x=x.substring(de.raw.length),le.push(de);continue}if(Pe=x,this.options.extensions&&this.options.extensions.startInline&&function(){var ye=1/0,ze=x.slice(1),We=void 0;te.options.extensions.startInline.forEach(function(_e){We=_e.call({lexer:this},ze),typeof We=="number"&&We>=0&&(ye=Math.min(ye,We))}),ye<1/0&&ye>=0&&(Pe=x.substring(0,ye+1))}(),de=this.tokenizer.inlineText(Pe,T)){x=x.substring(de.raw.length),de.raw.slice(-1)!=="_"&&(oe=de.raw.slice(-1)),re=!0,be=le[le.length-1],be&&be.type==="text"?(be.raw+=de.raw,be.text+=de.text):le.push(de);continue}if(x){var me="Infinite loop on byte: "+x.charCodeAt(0);if(this.options.silent){console.error(me);break}else throw new Error(me)}}return le},I(G,null,[{key:"rules",get:function(){return{block:O,inline:j}}}]),G}(),fe=function(){function G(ge){this.options=ge||$e.defaults}var J=G.prototype;return J.code=function(x,le,te){var de=(le||"").match(/\S*/)[0];if(this.options.highlight){var be=this.options.highlight(x,de);be!=null&&be!==x&&(te=!0,x=be)}return x=x.replace(/\n$/,"")+`
`,de?'<pre><code class="'+this.options.langPrefix+S(de,!0)+'">'+(te?x:S(x,!0))+`</code></pre>
`:"<pre><code>"+(te?x:S(x,!0))+`</code></pre>
`},J.blockquote=function(x){return`<blockquote>
`+x+`</blockquote>
`},J.html=function(x){return x},J.heading=function(x,le,te,de){if(this.options.headerIds){var be=this.options.headerPrefix+de.slug(te);return"<h"+le+' id="'+be+'">'+x+"</h"+le+`>
`}return"<h"+le+">"+x+"</h"+le+`>
`},J.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},J.list=function(x,le,te){var de=le?"ol":"ul",be=le&&te!==1?' start="'+te+'"':"";return"<"+de+be+`>
`+x+"</"+de+`>
`},J.listitem=function(x){return"<li>"+x+`</li>
`},J.checkbox=function(x){return"<input "+(x?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},J.paragraph=function(x){return"<p>"+x+`</p>
`},J.table=function(x,le){return le&&(le="<tbody>"+le+"</tbody>"),`<table>
<thead>
`+x+`</thead>
`+le+`</table>
`},J.tablerow=function(x){return`<tr>
`+x+`</tr>
`},J.tablecell=function(x,le){var te=le.header?"th":"td",de=le.align?"<"+te+' align="'+le.align+'">':"<"+te+">";return de+x+("</"+te+`>
`)},J.strong=function(x){return"<strong>"+x+"</strong>"},J.em=function(x){return"<em>"+x+"</em>"},J.codespan=function(x){return"<code>"+x+"</code>"},J.br=function(){return this.options.xhtml?"<br/>":"<br>"},J.del=function(x){return"<del>"+x+"</del>"},J.link=function(x,le,te){if(x=a(this.options.sanitize,this.options.baseUrl,x),x===null)return te;var de='<a href="'+S(x)+'"';return le&&(de+=' title="'+le+'"'),de+=">"+te+"</a>",de},J.image=function(x,le,te){if(x=a(this.options.sanitize,this.options.baseUrl,x),x===null)return te;var de='<img src="'+x+'" alt="'+te+'"';return le&&(de+=' title="'+le+'"'),de+=this.options.xhtml?"/>":">",de},J.text=function(x){return x},G}(),ee=function(){function G(){}var J=G.prototype;return J.strong=function(x){return x},J.em=function(x){return x},J.codespan=function(x){return x},J.del=function(x){return x},J.html=function(x){return x},J.text=function(x){return x},J.link=function(x,le,te){return""+te},J.image=function(x,le,te){return""+te},J.br=function(){return""},G}(),Y=function(){function G(){this.seen={}}var J=G.prototype;return J.serialize=function(x){return x.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},J.getNextSafeSlug=function(x,le){var te=x,de=0;if(this.seen.hasOwnProperty(te)){de=this.seen[x];do de++,te=x+"-"+de;while(this.seen.hasOwnProperty(te))}return le||(this.seen[x]=de,this.seen[te]=0),te},J.slug=function(x,le){le===void 0&&(le={});var te=this.serialize(x);return this.getNextSafeSlug(te,le.dryrun)},G}(),X=function(){function G(ge){this.options=ge||$e.defaults,this.options.renderer=this.options.renderer||new fe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ee,this.slugger=new Y}G.parse=function(x,le){var te=new G(le);return te.parse(x)},G.parseInline=function(x,le){var te=new G(le);return te.parseInline(x)};var J=G.prototype;return J.parse=function(x,le){le===void 0&&(le=!0);var te="",de,be,Pe,B,Q,re,oe,_,me,ye,ze,We,_e,Ye,it,tt,Ae,Oe,Ve,Re=x.length;for(de=0;de<Re;de++){if(ye=x[de],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ye.type]&&(Ve=this.options.extensions.renderers[ye.type].call({parser:this},ye),Ve!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ye.type))){te+=Ve||"";continue}switch(ye.type){case"space":continue;case"hr":{te+=this.renderer.hr();continue}case"heading":{te+=this.renderer.heading(this.parseInline(ye.tokens),ye.depth,c(this.parseInline(ye.tokens,this.textRenderer)),this.slugger);continue}case"code":{te+=this.renderer.code(ye.text,ye.lang,ye.escaped);continue}case"table":{for(_="",oe="",B=ye.header.length,be=0;be<B;be++)oe+=this.renderer.tablecell(this.parseInline(ye.header[be].tokens),{header:!0,align:ye.align[be]});for(_+=this.renderer.tablerow(oe),me="",B=ye.rows.length,be=0;be<B;be++){for(re=ye.rows[be],oe="",Q=re.length,Pe=0;Pe<Q;Pe++)oe+=this.renderer.tablecell(this.parseInline(re[Pe].tokens),{header:!1,align:ye.align[Pe]});me+=this.renderer.tablerow(oe)}te+=this.renderer.table(_,me);continue}case"blockquote":{me=this.parse(ye.tokens),te+=this.renderer.blockquote(me);continue}case"list":{for(ze=ye.ordered,We=ye.start,_e=ye.loose,B=ye.items.length,me="",be=0;be<B;be++)it=ye.items[be],tt=it.checked,Ae=it.task,Ye="",it.task&&(Oe=this.renderer.checkbox(tt),_e?it.tokens.length>0&&it.tokens[0].type==="paragraph"?(it.tokens[0].text=Oe+" "+it.tokens[0].text,it.tokens[0].tokens&&it.tokens[0].tokens.length>0&&it.tokens[0].tokens[0].type==="text"&&(it.tokens[0].tokens[0].text=Oe+" "+it.tokens[0].tokens[0].text)):it.tokens.unshift({type:"text",text:Oe}):Ye+=Oe),Ye+=this.parse(it.tokens,_e),me+=this.renderer.listitem(Ye,Ae,tt);te+=this.renderer.list(me,ze,We);continue}case"html":{te+=this.renderer.html(ye.text);continue}case"paragraph":{te+=this.renderer.paragraph(this.parseInline(ye.tokens));continue}case"text":{for(me=ye.tokens?this.parseInline(ye.tokens):ye.text;de+1<Re&&x[de+1].type==="text";)ye=x[++de],me+=`
`+(ye.tokens?this.parseInline(ye.tokens):ye.text);te+=le?this.renderer.paragraph(me):me;continue}default:{var Xe='Token with "'+ye.type+'" type was not found.';if(this.options.silent){console.error(Xe);return}else throw new Error(Xe)}}}return te},J.parseInline=function(x,le){le=le||this.renderer;var te="",de,be,Pe,B=x.length;for(de=0;de<B;de++){if(be=x[de],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[be.type]&&(Pe=this.options.extensions.renderers[be.type].call({parser:this},be),Pe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(be.type))){te+=Pe||"";continue}switch(be.type){case"escape":{te+=le.text(be.text);break}case"html":{te+=le.html(be.text);break}case"link":{te+=le.link(be.href,be.title,this.parseInline(be.tokens,le));break}case"image":{te+=le.image(be.href,be.title,be.text);break}case"strong":{te+=le.strong(this.parseInline(be.tokens,le));break}case"em":{te+=le.em(this.parseInline(be.tokens,le));break}case"codespan":{te+=le.codespan(be.text);break}case"br":{te+=le.br();break}case"del":{te+=le.del(this.parseInline(be.tokens,le));break}case"text":{te+=le.text(be.text);break}default:{var Q='Token with "'+be.type+'" type was not found.';if(this.options.silent){console.error(Q);return}else throw new Error(Q)}}}return te},G}();function ae(G,J,ge){if(typeof G>"u"||G===null)throw new Error("marked(): input parameter is undefined or null");if(typeof G!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(G)+", string expected");if(typeof J=="function"&&(ge=J,J=null),J=k({},ae.defaults,J||{}),v(J),ge){var x=J.highlight,le;try{le=q.lex(G,J)}catch(B){return ge(B)}var te=function(Q){var re;if(!Q)try{J.walkTokens&&ae.walkTokens(le,J.walkTokens),re=X.parse(le,J)}catch(oe){Q=oe}return J.highlight=x,Q?ge(Q):ge(null,re)};if(!x||x.length<3||(delete J.highlight,!le.length))return te();var de=0;ae.walkTokens(le,function(B){B.type==="code"&&(de++,setTimeout(function(){x(B.text,B.lang,function(Q,re){if(Q)return te(Q);re!=null&&re!==B.text&&(B.text=re,B.escaped=!0),de--,de===0&&te()})},0))}),de===0&&te();return}function be(B){if(B.message+=`
Please report this to https://github.com/markedjs/marked.`,J.silent)return"<p>An error occurred:</p><pre>"+S(B.message+"",!0)+"</pre>";throw B}try{var Pe=q.lex(G,J);if(J.walkTokens){if(J.async)return Promise.all(ae.walkTokens(Pe,J.walkTokens)).then(function(){return X.parse(Pe,J)}).catch(be);ae.walkTokens(Pe,J.walkTokens)}return X.parse(Pe,J)}catch(B){be(B)}}ae.options=ae.setOptions=function(G){return k(ae.defaults,G),p(ae.defaults),ae},ae.getDefaults=R,ae.defaults=$e.defaults,ae.use=function(){for(var G=arguments.length,J=new Array(G),ge=0;ge<G;ge++)J[ge]=arguments[ge];var x=k.apply(void 0,[{}].concat(J)),le=ae.defaults.extensions||{renderers:{},childTokens:{}},te;J.forEach(function(de){if(de.extensions&&(te=!0,de.extensions.forEach(function(Pe){if(!Pe.name)throw new Error("extension name required");if(Pe.renderer){var B=le.renderers?le.renderers[Pe.name]:null;B?le.renderers[Pe.name]=function(){for(var Q=arguments.length,re=new Array(Q),oe=0;oe<Q;oe++)re[oe]=arguments[oe];var _=Pe.renderer.apply(this,re);return _===!1&&(_=B.apply(this,re)),_}:le.renderers[Pe.name]=Pe.renderer}if(Pe.tokenizer){if(!Pe.level||Pe.level!=="block"&&Pe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");le[Pe.level]?le[Pe.level].unshift(Pe.tokenizer):le[Pe.level]=[Pe.tokenizer],Pe.start&&(Pe.level==="block"?le.startBlock?le.startBlock.push(Pe.start):le.startBlock=[Pe.start]:Pe.level==="inline"&&(le.startInline?le.startInline.push(Pe.start):le.startInline=[Pe.start]))}Pe.childTokens&&(le.childTokens[Pe.name]=Pe.childTokens)})),de.renderer&&function(){var Pe=ae.defaults.renderer||new fe,B=function(oe){var _=Pe[oe];Pe[oe]=function(){for(var me=arguments.length,ye=new Array(me),ze=0;ze<me;ze++)ye[ze]=arguments[ze];var We=de.renderer[oe].apply(Pe,ye);return We===!1&&(We=_.apply(Pe,ye)),We}};for(var Q in de.renderer)B(Q);x.renderer=Pe}(),de.tokenizer&&function(){var Pe=ae.defaults.tokenizer||new M,B=function(oe){var _=Pe[oe];Pe[oe]=function(){for(var me=arguments.length,ye=new Array(me),ze=0;ze<me;ze++)ye[ze]=arguments[ze];var We=de.tokenizer[oe].apply(Pe,ye);return We===!1&&(We=_.apply(Pe,ye)),We}};for(var Q in de.tokenizer)B(Q);x.tokenizer=Pe}(),de.walkTokens){var be=ae.defaults.walkTokens;x.walkTokens=function(Pe){var B=[];return B.push(de.walkTokens.call(this,Pe)),be&&(B=B.concat(be.call(this,Pe))),B}}te&&(x.extensions=le),ae.setOptions(x)})},ae.walkTokens=function(G,J){for(var ge=[],x=function(){var be=te.value;switch(ge=ge.concat(J.call(ae,be)),be.type){case"table":{for(var Pe=L(be.header),B;!(B=Pe()).done;){var Q=B.value;ge=ge.concat(ae.walkTokens(Q.tokens,J))}for(var re=L(be.rows),oe;!(oe=re()).done;)for(var _=oe.value,me=L(_),ye;!(ye=me()).done;){var ze=ye.value;ge=ge.concat(ae.walkTokens(ze.tokens,J))}break}case"list":{ge=ge.concat(ae.walkTokens(be.items,J));break}default:ae.defaults.extensions&&ae.defaults.extensions.childTokens&&ae.defaults.extensions.childTokens[be.type]?ae.defaults.extensions.childTokens[be.type].forEach(function(We){ge=ge.concat(ae.walkTokens(be[We],J))}):be.tokens&&(ge=ge.concat(ae.walkTokens(be.tokens,J)))}},le=L(G),te;!(te=le()).done;)x();return ge},ae.parseInline=function(G,J){if(typeof G>"u"||G===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof G!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(G)+", string expected");J=k({},ae.defaults,J||{}),v(J);try{var ge=q.lexInline(G,J);return J.walkTokens&&ae.walkTokens(ge,J.walkTokens),X.parseInline(ge,J)}catch(x){if(x.message+=`
Please report this to https://github.com/markedjs/marked.`,J.silent)return"<p>An error occurred:</p><pre>"+S(x.message+"",!0)+"</pre>";throw x}},ae.Parser=X,ae.parser=X.parse,ae.Renderer=fe,ae.TextRenderer=ee,ae.Lexer=q,ae.lexer=q.lex,ae.Tokenizer=M,ae.Slugger=Y,ae.parse=ae;var Z=ae.options,se=ae.setOptions,we=ae.use,H=ae.walkTokens,U=ae.parseInline,ce=ae,Ee=X.parse,ne=q.lex;$e.Lexer=q,$e.Parser=X,$e.Renderer=fe,$e.Slugger=Y,$e.TextRenderer=ee,$e.Tokenizer=M,$e.getDefaults=R,$e.lexer=ne,$e.marked=ae,$e.options=Z,$e.parse=ce,$e.parseInline=U,$e.parser=Ee,$e.setOptions=se,$e.use=we,$e.walkTokens=H,Object.defineProperty($e,"__esModule",{value:!0})}),define(ke[77],Se([1,0,28]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ul=e.$tl=e.$sl=void 0;const F=new I.$Cc(1e4);function f(m){return E(m,"NFC",F)}e.$sl=f;const L=new I.$Cc(1e4);function R(m){return E(m,"NFD",L)}e.$tl=R;const p=/[^\u0000-\u0080]/;function E(m,A,P){if(!m)return m;const g=P.get(m);if(g)return g;let y;return p.test(m)?y=m.normalize(A):y=m,P.set(m,y),y}e.$ul=function(){const m=/[\u0300-\u036f]/g;return function(A){return R(A).replace(m,"")}}()}),define(ke[123],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wl=e.$Vl=e.$Ul=e.rot=e.$Sl=void 0;function I(p,E,m){return Math.min(Math.max(p,E),m)}e.$Sl=I;function F(p,E){return(E+p%E)%E}e.rot=F;class f{constructor(){this.a=0}getNext(){return this.a++}}e.$Ul=f;class L{constructor(){this.a=1,this.b=0}update(E){return this.b=this.b+(E-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Vl=L;class R{constructor(E){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(E),this.c.fill(0,0,E)}update(E){const m=this.c[this.d];return this.c[this.d]=E,this.d=(this.d+1)%this.c.length,this.e-=m,this.e+=E,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Wl=R}),function(){function $e(f){const L=[];typeof f=="number"&&L.push("code/timeOrigin",f);function R(E){L.push(E,Date.now())}function p(){const E=[];for(let m=0;m<L.length;m+=2)E.push({name:L[m],startTime:L[m+1]});return E}return{mark:R,getMarks:p}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?$e():{mark(f){performance.mark(f)},getMarks(){let f=performance.timeOrigin;typeof f!="number"&&(f=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(f)}];for(const R of performance.getEntriesByType("mark"))L.push({name:R.name,startTime:Math.round(f+R.startTime)});return L}};if(typeof process=="object"){const f=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return $e(f)}else return console.trace("perf-util loaded in UNKNOWN environment"),$e()}function I(f){return f.MonacoPerformanceMarks||(f.MonacoPerformanceMarks=e()),f.MonacoPerformanceMarks}var F;typeof global=="object"?F=global:typeof self=="object"?F=self:F={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(F)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(F):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),F.perf=I(F))}(),function($e,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var F in I)(typeof exports=="object"?exports:$e)[F]=I[F]}}(typeof self<"u"?self:this,function(){return function($e){var e={};function I(F){if(e[F])return e[F].exports;var f=e[F]={i:F,l:!1,exports:{}};return $e[F].call(f.exports,f,f.exports,I),f.l=!0,f.exports}return I.m=$e,I.c=e,I.d=function(F,f,L){I.o(F,f)||Object.defineProperty(F,f,{enumerable:!0,get:L})},I.r=function(F){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(F,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(F,"__esModule",{value:!0})},I.t=function(F,f){if(1&f&&(F=I(F)),8&f||4&f&&typeof F=="object"&&F&&F.__esModule)return F;var L=Object.create(null);if(I.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:F}),2&f&&typeof F!="string")for(var R in F)I.d(L,R,function(p){return F[p]}.bind(null,R));return L},I.n=function(F){var f=F&&F.__esModule?function(){return F.default}:function(){return F};return I.d(f,"a",f),f},I.o=function(F,f){return Object.prototype.hasOwnProperty.call(F,f)},I.p="",I(I.s=0)}([function($e,e,I){(function(F){var f;e=$e.exports=we,f=typeof F=="object"&&F.env&&F.env.NODE_DEBUG&&/\bsemver\b/i.test(F.env.NODE_DEBUG)?function(){var _=Array.prototype.slice.call(arguments,0);_.unshift("SEMVER"),console.log.apply(console,_)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,p=e.re=[],E=e.src=[],m=0,A=m++;E[A]="0|[1-9]\\d*";var P=m++;E[P]="[0-9]+";var g=m++;E[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=m++;E[y]="("+E[A]+")\\.("+E[A]+")\\.("+E[A]+")";var S=m++;E[S]="("+E[P]+")\\.("+E[P]+")\\.("+E[P]+")";var w=m++;E[w]="(?:"+E[A]+"|"+E[g]+")";var c=m++;E[c]="(?:"+E[P]+"|"+E[g]+")";var s=m++;E[s]="(?:-("+E[w]+"(?:\\."+E[w]+")*))";var i=m++;E[i]="(?:-?("+E[c]+"(?:\\."+E[c]+")*))";var n=m++;E[n]="[0-9A-Za-z-]+";var o=m++;E[o]="(?:\\+("+E[n]+"(?:\\."+E[n]+")*))";var a=m++,t="v?"+E[y]+E[s]+"?"+E[o]+"?";E[a]="^"+t+"$";var r="[v=\\s]*"+E[S]+E[i]+"?"+E[o]+"?",d=m++;E[d]="^"+r+"$";var u=m++;E[u]="((?:<|>)?=?)";var l=m++;E[l]=E[P]+"|x|X|\\*";var h=m++;E[h]=E[A]+"|x|X|\\*";var k=m++;E[k]="[v=\\s]*("+E[h]+")(?:\\.("+E[h]+")(?:\\.("+E[h]+")(?:"+E[s]+")?"+E[o]+"?)?)?";var D=m++;E[D]="[v=\\s]*("+E[l]+")(?:\\.("+E[l]+")(?:\\.("+E[l]+")(?:"+E[i]+")?"+E[o]+"?)?)?";var $=m++;E[$]="^"+E[u]+"\\s*"+E[k]+"$";var b=m++;E[b]="^"+E[u]+"\\s*"+E[D]+"$";var v=m++;E[v]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var C=m++;E[C]="(?:~>?)";var N=m++;E[N]="(\\s*)"+E[C]+"\\s+",p[N]=new RegExp(E[N],"g");var z=m++;E[z]="^"+E[C]+E[k]+"$";var M=m++;E[M]="^"+E[C]+E[D]+"$";var O=m++;E[O]="(?:\\^)";var j=m++;E[j]="(\\s*)"+E[O]+"\\s+",p[j]=new RegExp(E[j],"g");var T=m++;E[T]="^"+E[O]+E[k]+"$";var V=m++;E[V]="^"+E[O]+E[D]+"$";var q=m++;E[q]="^"+E[u]+"\\s*("+r+")$|^$";var fe=m++;E[fe]="^"+E[u]+"\\s*("+t+")$|^$";var ee=m++;E[ee]="(\\s*)"+E[u]+"\\s*("+r+"|"+E[k]+")",p[ee]=new RegExp(E[ee],"g");var Y=m++;E[Y]="^\\s*("+E[k]+")\\s+-\\s+("+E[k]+")\\s*$";var X=m++;E[X]="^\\s*("+E[D]+")\\s+-\\s+("+E[D]+")\\s*$";var ae=m++;E[ae]="(<|>)?=?\\s*\\*";for(var Z=0;Z<35;Z++)f(Z,E[Z]),p[Z]||(p[Z]=new RegExp(E[Z]));function se(_,me){if(_ instanceof we)return _;if(typeof _!="string"||_.length>L||!(me?p[d]:p[a]).test(_))return null;try{return new we(_,me)}catch{return null}}function we(_,me){if(_ instanceof we){if(_.loose===me)return _;_=_.version}else if(typeof _!="string")throw new TypeError("Invalid Version: "+_);if(_.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof we))return new we(_,me);f("SemVer",_,me),this.loose=me;var ye=_.trim().match(me?p[d]:p[a]);if(!ye)throw new TypeError("Invalid Version: "+_);if(this.raw=_,this.major=+ye[1],this.minor=+ye[2],this.patch=+ye[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");ye[4]?this.prerelease=ye[4].split(".").map(function(ze){if(/^[0-9]+$/.test(ze)){var We=+ze;if(We>=0&&We<R)return We}return ze}):this.prerelease=[],this.build=ye[5]?ye[5].split("."):[],this.format()}e.parse=se,e.valid=function(_,me){var ye=se(_,me);return ye?ye.version:null},e.clean=function(_,me){var ye=se(_.trim().replace(/^[=v]+/,""),me);return ye?ye.version:null},e.SemVer=we,we.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},we.prototype.toString=function(){return this.version},we.prototype.compare=function(_){return f("SemVer.compare",this.version,this.loose,_),_ instanceof we||(_=new we(_,this.loose)),this.compareMain(_)||this.comparePre(_)},we.prototype.compareMain=function(_){return _ instanceof we||(_=new we(_,this.loose)),U(this.major,_.major)||U(this.minor,_.minor)||U(this.patch,_.patch)},we.prototype.comparePre=function(_){if(_ instanceof we||(_=new we(_,this.loose)),this.prerelease.length&&!_.prerelease.length)return-1;if(!this.prerelease.length&&_.prerelease.length)return 1;if(!this.prerelease.length&&!_.prerelease.length)return 0;var me=0;do{var ye=this.prerelease[me],ze=_.prerelease[me];if(f("prerelease compare",me,ye,ze),ye===void 0&&ze===void 0)return 0;if(ze===void 0)return 1;if(ye===void 0)return-1;if(ye!==ze)return U(ye,ze)}while(++me)},we.prototype.inc=function(_,me){switch(_){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",me);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",me);break;case"prepatch":this.prerelease.length=0,this.inc("patch",me),this.inc("pre",me);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",me),this.inc("pre",me);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ye=this.prerelease.length;--ye>=0;)typeof this.prerelease[ye]=="number"&&(this.prerelease[ye]++,ye=-2);ye===-1&&this.prerelease.push(0)}me&&(this.prerelease[0]===me?isNaN(this.prerelease[1])&&(this.prerelease=[me,0]):this.prerelease=[me,0]);break;default:throw new Error("invalid increment argument: "+_)}return this.format(),this.raw=this.version,this},e.inc=function(_,me,ye,ze){typeof ye=="string"&&(ze=ye,ye=void 0);try{return new we(_,ye).inc(me,ze).version}catch{return null}},e.diff=function(_,me){if(G(_,me))return null;var ye=se(_),ze=se(me);if(ye.prerelease.length||ze.prerelease.length){for(var We in ye)if((We==="major"||We==="minor"||We==="patch")&&ye[We]!==ze[We])return"pre"+We;return"prerelease"}for(var We in ye)if((We==="major"||We==="minor"||We==="patch")&&ye[We]!==ze[We])return We},e.compareIdentifiers=U;var H=/^[0-9]+$/;function U(_,me){var ye=H.test(_),ze=H.test(me);return ye&&ze&&(_=+_,me=+me),ye&&!ze?-1:ze&&!ye?1:_<me?-1:_>me?1:0}function ce(_,me,ye){return new we(_,ye).compare(new we(me,ye))}function Ee(_,me,ye){return ce(_,me,ye)>0}function ne(_,me,ye){return ce(_,me,ye)<0}function G(_,me,ye){return ce(_,me,ye)===0}function J(_,me,ye){return ce(_,me,ye)!==0}function ge(_,me,ye){return ce(_,me,ye)>=0}function x(_,me,ye){return ce(_,me,ye)<=0}function le(_,me,ye,ze){var We;switch(me){case"===":typeof _=="object"&&(_=_.version),typeof ye=="object"&&(ye=ye.version),We=_===ye;break;case"!==":typeof _=="object"&&(_=_.version),typeof ye=="object"&&(ye=ye.version),We=_!==ye;break;case"":case"=":case"==":We=G(_,ye,ze);break;case"!=":We=J(_,ye,ze);break;case">":We=Ee(_,ye,ze);break;case">=":We=ge(_,ye,ze);break;case"<":We=ne(_,ye,ze);break;case"<=":We=x(_,ye,ze);break;default:throw new TypeError("Invalid operator: "+me)}return We}function te(_,me){if(_ instanceof te){if(_.loose===me)return _;_=_.value}if(!(this instanceof te))return new te(_,me);f("comparator",_,me),this.loose=me,this.parse(_),this.semver===de?this.value="":this.value=this.operator+this.semver.version,f("comp",this)}e.rcompareIdentifiers=function(_,me){return U(me,_)},e.major=function(_,me){return new we(_,me).major},e.minor=function(_,me){return new we(_,me).minor},e.patch=function(_,me){return new we(_,me).patch},e.compare=ce,e.compareLoose=function(_,me){return ce(_,me,!0)},e.rcompare=function(_,me,ye){return ce(me,_,ye)},e.sort=function(_,me){return _.sort(function(ye,ze){return e.compare(ye,ze,me)})},e.rsort=function(_,me){return _.sort(function(ye,ze){return e.rcompare(ye,ze,me)})},e.gt=Ee,e.lt=ne,e.eq=G,e.neq=J,e.gte=ge,e.lte=x,e.cmp=le,e.Comparator=te;var de={};function be(_,me){if(_ instanceof be)return _.loose===me?_:new be(_.raw,me);if(_ instanceof te)return new be(_.value,me);if(!(this instanceof be))return new be(_,me);if(this.loose=me,this.raw=_,this.set=_.split(/\s*\|\|\s*/).map(function(ye){return this.parseRange(ye.trim())},this).filter(function(ye){return ye.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+_);this.format()}function Pe(_){return!_||_.toLowerCase()==="x"||_==="*"}function B(_,me,ye,ze,We,_e,Ye,it,tt,Ae,Oe,Ve,Re){return((me=Pe(ye)?"":Pe(ze)?">="+ye+".0.0":Pe(We)?">="+ye+"."+ze+".0":">="+me)+" "+(it=Pe(tt)?"":Pe(Ae)?"<"+(+tt+1)+".0.0":Pe(Oe)?"<"+tt+"."+(+Ae+1)+".0":Ve?"<="+tt+"."+Ae+"."+Oe+"-"+Ve:"<="+it)).trim()}function Q(_,me){for(var ye=0;ye<_.length;ye++)if(!_[ye].test(me))return!1;if(me.prerelease.length){for(ye=0;ye<_.length;ye++)if(f(_[ye].semver),_[ye].semver!==de&&_[ye].semver.prerelease.length>0){var ze=_[ye].semver;if(ze.major===me.major&&ze.minor===me.minor&&ze.patch===me.patch)return!0}return!1}return!0}function re(_,me,ye){try{me=new be(me,ye)}catch{return!1}return me.test(_)}function oe(_,me,ye,ze){var We,_e,Ye,it,tt;switch(_=new we(_,ze),me=new be(me,ze),ye){case">":We=Ee,_e=x,Ye=ne,it=">",tt=">=";break;case"<":We=ne,_e=ge,Ye=Ee,it="<",tt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(re(_,me,ze))return!1;for(var Ae=0;Ae<me.set.length;++Ae){var Oe=me.set[Ae],Ve=null,Re=null;if(Oe.forEach(function(Xe){Xe.semver===de&&(Xe=new te(">=0.0.0")),Ve=Ve||Xe,Re=Re||Xe,We(Xe.semver,Ve.semver,ze)?Ve=Xe:Ye(Xe.semver,Re.semver,ze)&&(Re=Xe)}),Ve.operator===it||Ve.operator===tt||(!Re.operator||Re.operator===it)&&_e(_,Re.semver)||Re.operator===tt&&Ye(_,Re.semver))return!1}return!0}te.prototype.parse=function(_){var me=this.loose?p[q]:p[fe],ye=_.match(me);if(!ye)throw new TypeError("Invalid comparator: "+_);this.operator=ye[1],this.operator==="="&&(this.operator=""),ye[2]?this.semver=new we(ye[2],this.loose):this.semver=de},te.prototype.toString=function(){return this.value},te.prototype.test=function(_){return f("Comparator.test",_,this.loose),this.semver===de||(typeof _=="string"&&(_=new we(_,this.loose)),le(_,this.operator,this.semver,this.loose))},te.prototype.intersects=function(_,me){if(!(_ instanceof te))throw new TypeError("a Comparator is required");var ye;if(this.operator==="")return ye=new be(_.value,me),re(this.value,ye,me);if(_.operator==="")return ye=new be(this.value,me),re(_.semver,ye,me);var ze=!(this.operator!==">="&&this.operator!==">"||_.operator!==">="&&_.operator!==">"),We=!(this.operator!=="<="&&this.operator!=="<"||_.operator!=="<="&&_.operator!=="<"),_e=this.semver.version===_.semver.version,Ye=!(this.operator!==">="&&this.operator!=="<="||_.operator!==">="&&_.operator!=="<="),it=le(this.semver,"<",_.semver,me)&&(this.operator===">="||this.operator===">")&&(_.operator==="<="||_.operator==="<"),tt=le(this.semver,">",_.semver,me)&&(this.operator==="<="||this.operator==="<")&&(_.operator===">="||_.operator===">");return ze||We||_e&&Ye||it||tt},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(_){return _.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(_){var me=this.loose;_=_.trim(),f("range",_,me);var ye=me?p[X]:p[Y];_=_.replace(ye,B),f("hyphen replace",_),_=_.replace(p[ee],"$1$2$3"),f("comparator trim",_,p[ee]),_=(_=(_=_.replace(p[N],"$1~")).replace(p[j],"$1^")).split(/\s+/).join(" ");var ze=me?p[q]:p[fe],We=_.split(" ").map(function(_e){return function(Ye,it){return f("comp",Ye),Ye=function(tt,Ae){return tt.trim().split(/\s+/).map(function(Oe){return function(Ve,Re){f("caret",Ve,Re);var Xe=Re?p[V]:p[T];return Ve.replace(Xe,function(he,ue,Ie,Ke,Ue){var Ze;return f("caret",Ve,he,ue,Ie,Ke,Ue),Pe(ue)?Ze="":Pe(Ie)?Ze=">="+ue+".0.0 <"+(+ue+1)+".0.0":Pe(Ke)?Ze=ue==="0"?">="+ue+"."+Ie+".0 <"+ue+"."+(+Ie+1)+".0":">="+ue+"."+Ie+".0 <"+(+ue+1)+".0.0":Ue?(f("replaceCaret pr",Ue),Ue.charAt(0)!=="-"&&(Ue="-"+Ue),Ze=ue==="0"?Ie==="0"?">="+ue+"."+Ie+"."+Ke+Ue+" <"+ue+"."+Ie+"."+(+Ke+1):">="+ue+"."+Ie+"."+Ke+Ue+" <"+ue+"."+(+Ie+1)+".0":">="+ue+"."+Ie+"."+Ke+Ue+" <"+(+ue+1)+".0.0"):(f("no pr"),Ze=ue==="0"?Ie==="0"?">="+ue+"."+Ie+"."+Ke+" <"+ue+"."+Ie+"."+(+Ke+1):">="+ue+"."+Ie+"."+Ke+" <"+ue+"."+(+Ie+1)+".0":">="+ue+"."+Ie+"."+Ke+" <"+(+ue+1)+".0.0"),f("caret return",Ze),Ze})}(Oe,Ae)}).join(" ")}(Ye,it),f("caret",Ye),Ye=function(tt,Ae){return tt.trim().split(/\s+/).map(function(Oe){return function(Ve,Re){var Xe=Re?p[M]:p[z];return Ve.replace(Xe,function(he,ue,Ie,Ke,Ue){var Ze;return f("tilde",Ve,he,ue,Ie,Ke,Ue),Pe(ue)?Ze="":Pe(Ie)?Ze=">="+ue+".0.0 <"+(+ue+1)+".0.0":Pe(Ke)?Ze=">="+ue+"."+Ie+".0 <"+ue+"."+(+Ie+1)+".0":Ue?(f("replaceTilde pr",Ue),Ue.charAt(0)!=="-"&&(Ue="-"+Ue),Ze=">="+ue+"."+Ie+"."+Ke+Ue+" <"+ue+"."+(+Ie+1)+".0"):Ze=">="+ue+"."+Ie+"."+Ke+" <"+ue+"."+(+Ie+1)+".0",f("tilde return",Ze),Ze})}(Oe,Ae)}).join(" ")}(Ye,it),f("tildes",Ye),Ye=function(tt,Ae){return f("replaceXRanges",tt,Ae),tt.split(/\s+/).map(function(Oe){return function(Ve,Re){Ve=Ve.trim();var Xe=Re?p[b]:p[$];return Ve.replace(Xe,function(he,ue,Ie,Ke,Ue,Ze){f("xRange",Ve,he,ue,Ie,Ke,Ue,Ze);var nt=Pe(Ie),ct=nt||Pe(Ke),bt=ct||Pe(Ue);return ue==="="&&bt&&(ue=""),nt?he=ue===">"||ue==="<"?"<0.0.0":"*":ue&&bt?(ct&&(Ke=0),bt&&(Ue=0),ue===">"?(ue=">=",ct?(Ie=+Ie+1,Ke=0,Ue=0):bt&&(Ke=+Ke+1,Ue=0)):ue==="<="&&(ue="<",ct?Ie=+Ie+1:Ke=+Ke+1),he=ue+Ie+"."+Ke+"."+Ue):ct?he=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":bt&&(he=">="+Ie+"."+Ke+".0 <"+Ie+"."+(+Ke+1)+".0"),f("xRange return",he),he})}(Oe,Ae)}).join(" ")}(Ye,it),f("xrange",Ye),Ye=function(tt,Ae){return f("replaceStars",tt,Ae),tt.trim().replace(p[ae],"")}(Ye,it),f("stars",Ye),Ye}(_e,me)}).join(" ").split(/\s+/);return this.loose&&(We=We.filter(function(_e){return!!_e.match(ze)})),We=We.map(function(_e){return new te(_e,me)})},be.prototype.intersects=function(_,me){if(!(_ instanceof be))throw new TypeError("a Range is required");return this.set.some(function(ye){return ye.every(function(ze){return _.set.some(function(We){return We.every(function(_e){return ze.intersects(_e,me)})})})})},e.toComparators=function(_,me){return new be(_,me).set.map(function(ye){return ye.map(function(ze){return ze.value}).join(" ").trim().split(" ")})},be.prototype.test=function(_){if(!_)return!1;typeof _=="string"&&(_=new we(_,this.loose));for(var me=0;me<this.set.length;me++)if(Q(this.set[me],_))return!0;return!1},e.satisfies=re,e.maxSatisfying=function(_,me,ye){var ze=null,We=null;try{var _e=new be(me,ye)}catch{return null}return _.forEach(function(Ye){_e.test(Ye)&&(ze&&We.compare(Ye)!==-1||(We=new we(ze=Ye,ye)))}),ze},e.minSatisfying=function(_,me,ye){var ze=null,We=null;try{var _e=new be(me,ye)}catch{return null}return _.forEach(function(Ye){_e.test(Ye)&&(ze&&We.compare(Ye)!==1||(We=new we(ze=Ye,ye)))}),ze},e.validRange=function(_,me){try{return new be(_,me).range||"*"}catch{return null}},e.ltr=function(_,me,ye){return oe(_,me,"<",ye)},e.gtr=function(_,me,ye){return oe(_,me,">",ye)},e.outside=oe,e.prerelease=function(_,me){var ye=se(_,me);return ye&&ye.prerelease.length?ye.prerelease:null},e.intersects=function(_,me,ye){return _=new be(_,ye),me=new be(me,ye),_.intersects(me)},e.coerce=function(_){if(_ instanceof we)return _;if(typeof _!="string")return null;var me=_.match(p[v]);return me==null?null:se((me[1]||"0")+"."+(me[2]||"0")+"."+(me[3]||"0"))}}).call(this,I(1))},function($e,e){var I,F,f=$e.exports={};function L(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function p(c){if(I===setTimeout)return setTimeout(c,0);if((I===L||!I)&&setTimeout)return I=setTimeout,setTimeout(c,0);try{return I(c,0)}catch{try{return I.call(null,c,0)}catch{return I.call(this,c,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:L}catch{I=L}try{F=typeof clearTimeout=="function"?clearTimeout:R}catch{F=R}})();var E,m=[],A=!1,P=-1;function g(){A&&E&&(A=!1,E.length?m=E.concat(m):P=-1,m.length&&y())}function y(){if(!A){var c=p(g);A=!0;for(var s=m.length;s;){for(E=m,m=[];++P<s;)E&&E[P].run();P=-1,s=m.length}E=null,A=!1,function(i){if(F===clearTimeout)return clearTimeout(i);if((F===R||!F)&&clearTimeout)return F=clearTimeout,clearTimeout(i);try{F(i)}catch{try{return F.call(null,i)}catch{return F.call(this,i)}}}(c)}}function S(c,s){this.fun=c,this.array=s}function w(){}f.nextTick=function(c){var s=new Array(arguments.length-1);if(arguments.length>1)for(var i=1;i<arguments.length;i++)s[i-1]=arguments[i];m.push(new S(c,s)),m.length!==1||A||p(y)},S.prototype.run=function(){this.fun.apply(null,this.array)},f.title="browser",f.browser=!0,f.env={},f.argv=[],f.version="",f.versions={},f.on=w,f.addListener=w,f.once=w,f.off=w,f.removeListener=w,f.removeAllListeners=w,f.emit=w,f.prependListener=w,f.prependOnceListener=w,f.listeners=function(c){return[]},f.binding=function(c){throw new Error("process.binding is not supported")},f.cwd=function(){return"/"},f.chdir=function(c){throw new Error("process.chdir is not supported")},f.umask=function(){return 0}}])}),define(ke[37],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kd=void 0;const I=globalThis.performance&&typeof globalThis.performance.now=="function";class F{static create(L){return new F(L)}constructor(L){this.c=I&&L===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Kd=F}),define(ke[4],Se([1,0,11,75,3,76,37]),function($e,e,I,F,f,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.Event=void 0;const p=!1,E=!1;var m;(function($){$.None=()=>f.$Rc.None;function b(le){if(E){const{onDidAddListener:te}=le,de=S.create();let be=0;le.onDidAddListener=()=>{++be===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),de.print()),te?.()}}}function v(le,te){return fe(le,()=>{},0,void 0,!0,void 0,te)}$.defer=v;function C(le){return(te,de=null,be)=>{let Pe=!1,B;return B=le(Q=>{if(!Pe)return B?B.dispose():Pe=!0,te.call(de,Q)},null,be),Pe&&B.dispose(),B}}$.once=C;function N(le,te,de){return V((be,Pe=null,B)=>le(Q=>be.call(Pe,te(Q)),null,B),de)}$.map=N;function z(le,te,de){return V((be,Pe=null,B)=>le(Q=>{te(Q),be.call(Pe,Q)},null,B),de)}$.forEach=z;function M(le,te,de){return V((be,Pe=null,B)=>le(Q=>te(Q)&&be.call(Pe,Q),null,B),de)}$.filter=M;function O(le){return le}$.signal=O;function j(...le){return(te,de=null,be)=>{const Pe=(0,f.$Oc)(...le.map(B=>B(Q=>te.call(de,Q))));return q(Pe,be)}}$.any=j;function T(le,te,de,be){let Pe=de;return N(le,B=>(Pe=te(Pe,B),Pe),be)}$.reduce=T;function V(le,te){let de;const be={onWillAddFirstListener(){de=le(Pe.fire,Pe)},onDidRemoveLastListener(){de?.dispose()}};te||b(be);const Pe=new n(be);return te?.add(Pe),Pe.event}function q(le,te){return te instanceof Array?te.push(le):te&&te.add(le),le}function fe(le,te,de=100,be=!1,Pe=!1,B,Q){let re,oe,_,me=0,ye;const ze={leakWarningThreshold:B,onWillAddFirstListener(){re=le(_e=>{me++,oe=te(oe,_e),be&&!_&&(We.fire(oe),oe=void 0),ye=()=>{const Ye=oe;oe=void 0,_=void 0,(!be||me>1)&&We.fire(Ye),me=0},typeof de=="number"?(clearTimeout(_),_=setTimeout(ye,de)):_===void 0&&(_=0,queueMicrotask(ye))})},onWillRemoveListener(){Pe&&me>0&&ye?.()},onDidRemoveLastListener(){ye=void 0,re.dispose()}};Q||b(ze);const We=new n(ze);return Q?.add(We),We.event}$.debounce=fe;function ee(le,te=0,de){return $.debounce(le,(be,Pe)=>be?(be.push(Pe),be):[Pe],te,void 0,!0,void 0,de)}$.accumulate=ee;function Y(le,te=(be,Pe)=>be===Pe,de){let be=!0,Pe;return M(le,B=>{const Q=be||!te(B,Pe);return be=!1,Pe=B,Q},de)}$.latch=Y;function X(le,te,de){return[$.filter(le,te,de),$.filter(le,be=>!te(be),de)]}$.split=X;function ae(le,te=!1,de=[],be){let Pe=de.slice(),B=le(oe=>{Pe?Pe.push(oe):re.fire(oe)});be&&be.add(B);const Q=()=>{Pe?.forEach(oe=>re.fire(oe)),Pe=null},re=new n({onWillAddFirstListener(){B||(B=le(oe=>re.fire(oe)),be&&be.add(B))},onDidAddFirstListener(){Pe&&(te?setTimeout(Q):Q())},onDidRemoveLastListener(){B&&B.dispose(),B=null}});return be&&be.add(re),re.event}$.buffer=ae;function Z(le,te){return(be,Pe,B)=>{const Q=te(new we);return le(function(re){const oe=Q.evaluate(re);oe!==se&&be.call(Pe,oe)},void 0,B)}}$.chain=Z;const se=Symbol("HaltChainable");class we{constructor(){this.f=[]}map(te){return this.f.push(te),this}forEach(te){return this.f.push(de=>(te(de),de)),this}filter(te){return this.f.push(de=>te(de)?de:se),this}reduce(te,de){let be=de;return this.f.push(Pe=>(be=te(be,Pe),be)),this}latch(te=(de,be)=>de===be){let de=!0,be;return this.f.push(Pe=>{const B=de||!te(Pe,be);return de=!1,be=Pe,B?Pe:se}),this}evaluate(te){for(const de of this.f)if(te=de(te),te===se)break;return te}}function H(le,te,de=be=>be){const be=(...re)=>Q.fire(de(...re)),Pe=()=>le.on(te,be),B=()=>le.removeListener(te,be),Q=new n({onWillAddFirstListener:Pe,onDidRemoveLastListener:B});return Q.event}$.fromNodeEventEmitter=H;function U(le,te,de=be=>be){const be=(...re)=>Q.fire(de(...re)),Pe=()=>le.addEventListener(te,be),B=()=>le.removeEventListener(te,be),Q=new n({onWillAddFirstListener:Pe,onDidRemoveLastListener:B});return Q.event}$.fromDOMEventEmitter=U;function ce(le){return new Promise(te=>C(le)(te))}$.toPromise=ce;function Ee(le){const te=new n;return le.then(de=>{te.fire(de)},()=>{te.fire(void 0)}).finally(()=>{te.dispose()}),te.event}$.fromPromise=Ee;function ne(le,te,de){return te(de),le(be=>te(be))}$.runAndSubscribe=ne;function G(le,te){let de=null;function be(B){de?.dispose(),de=new f.$Qc,te(B,de)}be(void 0);const Pe=le(B=>be(B));return(0,f.$Pc)(()=>{Pe.dispose(),de?.dispose()})}$.runAndSubscribeWithStore=G;class J{constructor(te,de){this._observable=te,this.f=0,this.g=!1;const be={onWillAddFirstListener:()=>{te.addObserver(this)},onDidRemoveLastListener:()=>{te.removeObserver(this)}};de||b(be),this.emitter=new n(be),de&&de.add(this.emitter)}beginUpdate(te){this.f++}handlePossibleChange(te){}handleChange(te,de){this.g=!0}endUpdate(te){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function ge(le,te){return new J(le,te).emitter.event}$.fromObservable=ge;function x(le){return te=>{let de=0,be=!1;const Pe={beginUpdate(){de++},endUpdate(){de--,de===0&&(le.reportChanges(),be&&(be=!1,te()))},handlePossibleChange(){},handleChange(){be=!0}};return le.addObserver(Pe),le.reportChanges(),{dispose(){le.removeObserver(Pe)}}}}$.fromObservableLight=x})(m||(e.Event=m={}));class A{static{this.all=new Set}static{this.f=0}constructor(b){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${b}_${A.f++}`,A.all.add(this)}start(b){this.g=new R.$Kd,this.listenerCount=b}stop(){if(this.g){const b=this.g.elapsed();this.durations.push(b),this.elapsedOverall+=b,this.invocationCount+=1,this.g=void 0}}}e.$Md=A;let P=-1;function g($){const b=P;return P=$,{dispose(){P=b}}}e.$Nd=g;class y{constructor(b,v=Math.random().toString(18).slice(2,5)){this.threshold=b,this.name=v,this.g=0}dispose(){this.f?.clear()}check(b,v){const C=this.threshold;if(C<=0||v<C)return;this.f||(this.f=new Map);const N=this.f.get(b.value)||0;if(this.f.set(b.value,N+1),this.g-=1,this.g<=0){this.g=C*.5;let z,M=0;for(const[O,j]of this.f)(!z||M<j)&&(z=O,M=j);console.warn(`[${this.name}] potential listener LEAK detected, having ${v} listeners already. MOST frequent listener (${M}):`),console.warn(z)}return()=>{const z=this.f.get(b.value)||0;this.f.set(b.value,z-1)}}}class S{static create(){return new S(new Error().stack??"")}constructor(b){this.value=b}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let w=0;class c{constructor(b){this.value=b,this.id=w++}}const s=2,i=($,b)=>{if($ instanceof c)b($);else for(let v=0;v<$.length;v++){const C=$[v];C&&b(C)}};class n{constructor(b){this.w=0,this.f=b,this.g=P>0||this.f?.leakWarningThreshold?new y(this.f?.leakWarningThreshold??P):void 0,this.j=this.f?._profName?new A(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(p){const b=this.t;queueMicrotask(()=>{i(b,v=>v.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(b,v,C)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),f.$Rc.None;if(this.m)return f.$Rc.None;v&&(b=b.bind(v));const N=new c(b);let z,M;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(N.stack=S.create(),z=this.g.check(N.stack,this.w+1)),p&&(N.stack=M??S.create()),this.t?this.t instanceof c?(this.u??=new a,this.t=[this.t,N]):this.t.push(N):(this.f?.onWillAddFirstListener?.(this),this.t=N,this.f?.onDidAddFirstListener?.(this)),this.w++;const O=(0,f.$Pc)(()=>{z?.(),this.x(N)});return C instanceof f.$Qc?C.add(O):Array.isArray(C)&&C.push(O),O},this.q}x(b){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const v=this.t,C=v.indexOf(b);if(C===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,v[C]=void 0;const N=this.u.current===this;if(this.w*s<=v.length){let z=0;for(let M=0;M<v.length;M++)v[M]?v[z++]=v[M]:N&&(this.u.end--,z<this.u.i&&this.u.i--);v.length=z}}y(b,v){if(!b)return;const C=this.f?.onListenerError||I.$Z;if(!C){b.value(v);return}try{b.value(v)}catch(N){C(N)}}z(b){const v=b.current.t;for(;b.i<b.end;)this.y(v[b.i++],b.value);b.reset()}fire(b){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof c)this.y(this.t,b);else{const v=this.u;v.enqueue(this,b,this.t.length),this.z(v)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Od=n;const o=()=>new a;e.$Pd=o;class a{constructor(){this.i=-1,this.end=0}enqueue(b,v,C){this.i=0,this.end=C,this.current=b,this.value=v}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends n{async fireAsync(b,v,C){if(this.t)for(this.h||(this.h=new L.$1c),i(this.t,N=>this.h.push([N.value,b]));this.h.size>0&&!v.isCancellationRequested;){const[N,z]=this.h.shift(),M=[],O={...z,token:v,waitUntil:j=>{if(Object.isFrozen(M))throw new Error("waitUntil can NOT be called asynchronous");C&&(j=C(j,N)),M.push(j)}};try{N(O)}catch(j){(0,I.$Z)(j);continue}Object.freeze(M),await Promise.allSettled(M).then(j=>{for(const T of j)T.status==="rejected"&&(0,I.$Z)(T.reason)})}}}e.$Qd=t;class r extends n{get isPaused(){return this.h!==0}constructor(b){super(b),this.h=0,this.s=new L.$1c,this.A=b?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const b=Array.from(this.s);this.s.clear(),super.fire(this.A(b))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(b){this.w&&(this.h!==0?this.s.push(b):super.fire(b))}}e.$Rd=r;class d extends r{constructor(b){super(b),this.k=b.delay??100}fire(b){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(b)}}e.$Sd=d;class u extends n{constructor(b){super(b),this.h=[],this.k=b?.merge}fire(b){this.hasListeners()&&(this.h.push(b),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(v=>super.fire(v)),this.h=[]}))}}e.$Td=u;class l{constructor(){this.g=!1,this.h=[],this.f=new n({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(b){const v={event:b,listener:null};this.h.push(v),this.g&&this.m(v);const C=()=>{this.g&&this.o(v);const N=this.h.indexOf(v);this.h.splice(N,1)};return(0,f.$Pc)((0,F.$cb)(C))}j(){this.g=!0,this.h.forEach(b=>this.m(b))}k(){this.g=!1,this.h.forEach(b=>this.o(b))}m(b){b.listener=b.event(v=>this.f.fire(v))}o(b){b.listener&&b.listener.dispose(),b.listener=null}dispose(){this.f.dispose()}}e.$Ud=l;class h{constructor(b,v,C,N){this.f=new f.$Qc;const z=this.f.add(new l),M=this.f.add(new f.$Zc);function O(j){M.set(j,z.add(N(j)))}for(const j of b)O(j);this.f.add(v(j=>{O(j)})),this.f.add(C(j=>{M.deleteAndDispose(j)})),this.event=z.event}dispose(){this.f.dispose()}}e.$Vd=h;class k{constructor(){this.f=[]}wrapEvent(b){return(v,C,N)=>b(z=>{const M=this.f[this.f.length-1];M?M.push(()=>v.call(C,z)):v.call(C,z)},void 0,N)}bufferEvents(b){const v=[];this.f.push(v);const C=b();return this.f.pop(),v.forEach(N=>N()),C}}e.$Wd=k;class D{constructor(){this.f=!1,this.g=m.None,this.h=f.$Rc.None,this.j=new n({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(b){this.g=b,this.f&&(this.h.dispose(),this.h=b(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$Xd=D}),define(ke[21],Se([1,0,4]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yd=e.CancellationToken=void 0;const F=Object.freeze(function(p,E){const m=setTimeout(p.bind(E),0);return{dispose(){clearTimeout(m)}}});var f;(function(p){function E(m){return m===p.None||m===p.Cancelled||m instanceof L?!0:!m||typeof m!="object"?!1:typeof m.isCancellationRequested=="boolean"&&typeof m.onCancellationRequested=="function"}p.isCancellationToken=E,p.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:I.Event.None}),p.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:F})})(f||(e.CancellationToken=f={}));class L{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?F:(this.b||(this.b=new I.$Od),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class R{constructor(E){this.f=void 0,this.g=void 0,this.g=E&&E.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new L),this.f}cancel(){this.f?this.f instanceof L&&this.f.cancel():this.f=f.Cancelled}dispose(E=!1){E&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof L&&this.f.dispose():this.f=f.None}}e.$Yd=R}),define(ke[162],Se([1,0,21]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=e.$ye=e.$xe=void 0;class F{constructor(p){this.b=p,this.a=null}get(){if(this.a)return this.a;const p=new I.$Yd,E=this.b(p.token);return this.a={promise:E,dispose:()=>{this.a=null,p.cancel(),p.dispose()}},this.a}}e.$xe=F;class f{constructor(p){this.c=p,this.a=void 0,this.b=void 0}get(p){const E=JSON.stringify(p);return this.b!==E&&(this.b=E,this.a=this.c(p)),this.a}}e.$ye=f;class L{get cachedValues(){return this.a}constructor(p){this.b=p,this.a=new Map}get(p){if(this.a.has(p))return this.a.get(p);const E=this.b(p);return this.a.set(p,E),E}}e.$ze=L}),define(ke[98],Se([1,0,11,3]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=void 0;function f(o){const a=o;return a?typeof a.read=="function":!1}e.$Zd=f;function L(o){const a=o;return a?[a.on,a.pause,a.resume,a.destroy].every(t=>typeof t=="function"):!1}e.$1d=L;function R(o){const a=o;return a?L(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.$2d=R;function p(o,a){return new E(o,a)}e.$3d=p;class E{constructor(a,t){this.e=a,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(a){if(!this.a.destroyed){if(this.a.flowing)this.g(a);else if(this.b.data.push(a),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(a){this.a.destroyed||(this.a.flowing?this.h(a):this.b.error.push(a))}end(a){this.a.destroyed||(typeof a<"u"&&this.write(a),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(a){this.c.data.slice(0).forEach(t=>t(a))}h(a){this.c.error.length===0?(0,I.$Z)(a):this.c.error.slice(0).forEach(t=>t(a))}i(){this.c.end.slice(0).forEach(a=>a())}on(a,t){if(!this.a.destroyed)switch(a){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(a,t){if(this.a.destroyed)return;let r;switch(a){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const d=r.indexOf(t);d>=0&&r.splice(d,1)}}j(){if(this.b.data.length>0){const a=this.e(this.b.data);this.g(a),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const a of this.b.error)this.h(a);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function m(o,a){const t=[];let r;for(;(r=o.read())!==null;)t.push(r);return a(t)}e.$4d=m;function A(o,a,t){const r=[];let d;for(;(d=o.read())!==null&&r.length<t;)r.push(d);return d===null&&r.length>0?a(r):{read:()=>{if(r.length>0)return r.shift();if(typeof d<"u"){const u=d;return d=void 0,u}return o.read()}}}e.$5d=A;function P(o,a){return new Promise((t,r)=>{const d=[];g(o,{onData:u=>{a&&d.push(u)},onError:u=>{a?r(u):t(void 0)},onEnd:()=>{t(a?a(d):void 0)}})})}e.$6d=P;function g(o,a,t){o.on("error",r=>{t?.isCancellationRequested||a.onError(r)}),o.on("end",()=>{t?.isCancellationRequested||a.onEnd()}),o.on("data",r=>{t?.isCancellationRequested||a.onData(r)})}e.$7d=g;function y(o,a){return new Promise((t,r)=>{const d=new F.$Qc,u=[],l=D=>{if(u.push(D),u.length>a)return d.dispose(),o.pause(),t({stream:o,buffer:u,ended:!1})},h=D=>(d.dispose(),r(D)),k=()=>(d.dispose(),t({stream:o,buffer:u,ended:!0}));d.add((0,F.$Pc)(()=>o.removeListener("error",h))),o.on("error",h),d.add((0,F.$Pc)(()=>o.removeListener("end",k))),o.on("end",k),d.add((0,F.$Pc)(()=>o.removeListener("data",l))),o.on("data",l)})}e.$8d=y;function S(o,a){const t=p(a);return t.end(o),t}e.$9d=S;function w(){const o=p(()=>{throw new Error("not supported")});return o.end(),o}e.$0d=w;function c(o){let a=!1;return{read:()=>a?null:(a=!0,o)}}e.$$d=c;function s(o,a,t){const r=p(t);return g(o,{onData:d=>r.write(a.data(d)),onError:d=>r.error(a.error?a.error(d):d),onEnd:()=>r.end()}),r}e.$_d=s;function i(o,a,t){let r=!1;return{read:()=>{const d=a.read();return r?d:(r=!0,d!==null?t([o,d]):o)}}}e.$ae=i;function n(o,a,t){let r=!1;const d=p(t);return g(a,{onData:u=>r?d.write(u):(r=!0,d.write(t([o,u]))),onError:u=>d.error(u),onEnd:()=>{r||(r=!0,d.write(o)),d.end()}}),d}e.$be=n}),define(ke[22],Se([1,0,48,98]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=void 0;const f=typeof Buffer<"u",L=new I.$U(()=>new Uint8Array(256));let R,p;class E{static alloc(v){return f?new E(Buffer.allocUnsafe(v)):new E(new Uint8Array(v))}static wrap(v){return f&&!Buffer.isBuffer(v)&&(v=Buffer.from(v.buffer,v.byteOffset,v.byteLength)),new E(v)}static fromString(v,C){return!(C?.dontUseNodeBuffer||!1)&&f?new E(Buffer.from(v)):(R||(R=new TextEncoder),new E(R.encode(v)))}static fromByteArray(v){const C=E.alloc(v.length);for(let N=0,z=v.length;N<z;N++)C.buffer[N]=v[N];return C}static concat(v,C){if(typeof C>"u"){C=0;for(let M=0,O=v.length;M<O;M++)C+=v[M].byteLength}const N=E.alloc(C);let z=0;for(let M=0,O=v.length;M<O;M++){const j=v[M];N.set(j,z),z+=j.byteLength}return N}constructor(v){this.buffer=v,this.byteLength=this.buffer.byteLength}clone(){const v=E.alloc(this.byteLength);return v.set(this),v}toString(){return f?this.buffer.toString():(p||(p=new TextDecoder),p.decode(this.buffer))}slice(v,C){return new E(this.buffer.subarray(v,C))}set(v,C){if(v instanceof E)this.buffer.set(v.buffer,C);else if(v instanceof Uint8Array)this.buffer.set(v,C);else if(v instanceof ArrayBuffer)this.buffer.set(new Uint8Array(v),C);else if(ArrayBuffer.isView(v))this.buffer.set(new Uint8Array(v.buffer,v.byteOffset,v.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(v){return g(this.buffer,v)}writeUInt32BE(v,C){y(this.buffer,v,C)}readUInt32LE(v){return S(this.buffer,v)}writeUInt32LE(v,C){w(this.buffer,v,C)}readUInt8(v){return c(this.buffer,v)}writeUInt8(v,C){s(this.buffer,v,C)}indexOf(v,C=0){return m(this.buffer,v instanceof E?v.buffer:v,C)}}e.$ce=E;function m(b,v,C=0){const N=v.byteLength,z=b.byteLength;if(N===0)return 0;if(N===1)return b.indexOf(v[0]);if(N>z-C)return-1;const M=L.value;M.fill(v.length);for(let V=0;V<v.length;V++)M[v[V]]=v.length-V-1;let O=C+v.length-1,j=O,T=-1;for(;O<z;)if(b[O]===v[j]){if(j===0){T=O;break}O--,j--}else O+=Math.max(v.length-j,M[b[O]]),j=v.length-1;return T}e.$de=m;function A(b,v){return b[v+0]<<0>>>0|b[v+1]<<8>>>0}e.$ee=A;function P(b,v,C){b[C+0]=v&255,v=v>>>8,b[C+1]=v&255}e.$fe=P;function g(b,v){return b[v]*2**24+b[v+1]*2**16+b[v+2]*2**8+b[v+3]}e.$ge=g;function y(b,v,C){b[C+3]=v,v=v>>>8,b[C+2]=v,v=v>>>8,b[C+1]=v,v=v>>>8,b[C]=v}e.$he=y;function S(b,v){return b[v+0]<<0>>>0|b[v+1]<<8>>>0|b[v+2]<<16>>>0|b[v+3]<<24>>>0}e.$ie=S;function w(b,v,C){b[C+0]=v&255,v=v>>>8,b[C+1]=v&255,v=v>>>8,b[C+2]=v&255,v=v>>>8,b[C+3]=v&255}e.$je=w;function c(b,v){return b[v]}e.$ke=c;function s(b,v,C){b[C]=v}e.$le=s;function i(b){return F.$4d(b,v=>E.concat(v))}e.$me=i;function n(b){return F.$$d(b)}e.$ne=n;function o(b){return F.$6d(b,v=>E.concat(v))}e.$oe=o;async function a(b){return b.ended?E.concat(b.buffer):E.concat([...b.buffer,await o(b.stream)])}e.$pe=a;function t(b){return F.$9d(b,v=>E.concat(v))}e.$qe=t;function r(b){return F.$_d(b,{data:v=>typeof v=="string"?E.fromString(v):E.wrap(v)},v=>E.concat(v))}e.$re=r;function d(b){return F.$3d(v=>E.concat(v),b)}e.$se=d;function u(b,v){return F.$ae(b,v,C=>E.concat(C))}e.$te=u;function l(b,v){return F.$be(b,v,C=>E.concat(C))}e.$ue=l;function h(b){let v=0,C=0,N=0;const z=new Uint8Array(Math.floor(b.length/4*3)),M=j=>{switch(C){case 3:z[N++]=v|j,C=0;break;case 2:z[N++]=v|j>>>2,v=j<<6,C=3;break;case 1:z[N++]=v|j>>>4,v=j<<4,C=2;break;default:v=j<<2,C=1}};for(let j=0;j<b.length;j++){const T=b.charCodeAt(j);if(T>=65&&T<=90)M(T-65);else if(T>=97&&T<=122)M(T-97+26);else if(T>=48&&T<=57)M(T-48+52);else if(T===43||T===45)M(62);else if(T===47||T===95)M(63);else{if(T===61)break;throw new SyntaxError(`Unexpected base64 character ${b[j]}`)}}const O=N;for(;C>0;)M(0);return E.wrap(z).slice(0,O)}e.$ve=h;const k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function $({buffer:b},v=!0,C=!1){const N=C?D:k;let z="";const M=b.byteLength%3;let O=0;for(;O<b.byteLength-M;O+=3){const j=b[O+0],T=b[O+1],V=b[O+2];z+=N[j>>>2],z+=N[(j<<4|T>>>4)&63],z+=N[(T<<2|V>>>6)&63],z+=N[V&63]}if(M===1){const j=b[O+0];z+=N[j>>>2],z+=N[j<<4&63],v&&(z+="==")}else if(M===2){const j=b[O+0],T=b[O+1];z+=N[j>>>2],z+=N[(j<<4|T>>>4)&63],z+=N[T<<2&63],v&&(z+="=")}return z}e.$we=$}),define(ke[13],Se([1,0,162,48]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yf=e.$xf=e.$wf=e.$vf=e.GraphemeBreakType=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=void 0;function f(Ae){return!Ae||typeof Ae!="string"?!0:Ae.trim().length===0}e.$Ce=f;const L=/{(\d+)}/g;function R(Ae,...Oe){return Oe.length===0?Ae:Ae.replace(L,function(Ve,Re){const Xe=parseInt(Re,10);return isNaN(Xe)||Xe<0||Xe>=Oe.length?Ve:Oe[Xe]})}e.$De=R;const p=/{([^}]+)}/g;function E(Ae,Oe){return Object.keys(Oe).length===0?Ae:Ae.replace(p,(Ve,Re)=>Oe[Re]??Ve)}e.$Ee=E;function m(Ae){return Ae.replace(/[<>&]/g,function(Oe){switch(Oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Oe}})}e.$Fe=m;function A(Ae){return Ae.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Ge=A;function P(Ae,Oe){let Ve=0;const Re=Oe.charCodeAt(0);for(let Xe=Ae.length-1;Xe>=0;Xe--)Ae.charCodeAt(Xe)===Re&&Ve++;return Ve}e.$He=P;function g(Ae,Oe,Ve="\u2026"){return Ae.length<=Oe?Ae:`${Ae.substr(0,Oe)}${Ve}`}e.$Ie=g;function y(Ae,Oe=" "){const Ve=S(Ae,Oe);return w(Ve,Oe)}e.$Je=y;function S(Ae,Oe){if(!Ae||!Oe)return Ae;const Ve=Oe.length;if(Ve===0||Ae.length===0)return Ae;let Re=0;for(;Ae.indexOf(Oe,Re)===Re;)Re=Re+Ve;return Ae.substring(Re)}e.$Ke=S;function w(Ae,Oe){if(!Ae||!Oe)return Ae;const Ve=Oe.length,Re=Ae.length;if(Ve===0||Re===0)return Ae;let Xe=Re,he=-1;for(;he=Ae.lastIndexOf(Oe,Xe-1),!(he===-1||he+Ve!==Xe);){if(he===0)return"";Xe=he}return Ae.substring(0,Xe)}e.$Le=w;function c(Ae){return Ae.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Me=c;function s(Ae){return Ae.replace(/\*/g,"")}e.$Ne=s;function i(Ae,Oe,Ve={}){if(!Ae)throw new Error("Cannot create regex from empty string");Oe||(Ae=A(Ae)),Ve.wholeWord&&(/\B/.test(Ae.charAt(0))||(Ae="\\b"+Ae),/\B/.test(Ae.charAt(Ae.length-1))||(Ae=Ae+"\\b"));let Re="";return Ve.global&&(Re+="g"),Ve.matchCase||(Re+="i"),Ve.multiline&&(Re+="m"),Ve.unicode&&(Re+="u"),new RegExp(Ae,Re)}e.$Oe=i;function n(Ae){return Ae.source==="^"||Ae.source==="^$"||Ae.source==="$"||Ae.source==="^\\s*$"?!1:!!(Ae.exec("")&&Ae.lastIndex===0)}e.$Pe=n;function o(Ae){return Ae.split(/\r\n|\r|\n/)}e.$Qe=o;function a(Ae){for(let Oe=0,Ve=Ae.length;Oe<Ve;Oe++){const Re=Ae.charCodeAt(Oe);if(Re!==32&&Re!==9)return Oe}return-1}e.$Re=a;function t(Ae,Oe=0,Ve=Ae.length){for(let Re=Oe;Re<Ve;Re++){const Xe=Ae.charCodeAt(Re);if(Xe!==32&&Xe!==9)return Ae.substring(Oe,Re)}return Ae.substring(Oe,Ve)}e.$Se=t;function r(Ae,Oe=Ae.length-1){for(let Ve=Oe;Ve>=0;Ve--){const Re=Ae.charCodeAt(Ve);if(Re!==32&&Re!==9)return Ve}return-1}e.$Te=r;function d(Ae,Oe,Ve){const Re=[];let Xe=0;for(const he of Ae.matchAll(Oe)){if(Re.push(Ae.slice(Xe,he.index)),he.index===void 0)throw new Error("match.index should be defined");Xe=he.index+he[0].length,Re.push(Ve(he[0],...he.slice(1),he.index,Ae,he.groups))}return Re.push(Ae.slice(Xe)),Promise.all(Re).then(he=>he.join(""))}e.$Ue=d;function u(Ae,Oe){return Ae<Oe?-1:Ae>Oe?1:0}e.$Ve=u;function l(Ae,Oe,Ve=0,Re=Ae.length,Xe=0,he=Oe.length){for(;Ve<Re&&Xe<he;Ve++,Xe++){const Ke=Ae.charCodeAt(Ve),Ue=Oe.charCodeAt(Xe);if(Ke<Ue)return-1;if(Ke>Ue)return 1}const ue=Re-Ve,Ie=he-Xe;return ue<Ie?-1:ue>Ie?1:0}e.$We=l;function h(Ae,Oe){return k(Ae,Oe,0,Ae.length,0,Oe.length)}e.$Xe=h;function k(Ae,Oe,Ve=0,Re=Ae.length,Xe=0,he=Oe.length){for(;Ve<Re&&Xe<he;Ve++,Xe++){let Ke=Ae.charCodeAt(Ve),Ue=Oe.charCodeAt(Xe);if(Ke===Ue)continue;if(Ke>=128||Ue>=128)return l(Ae.toLowerCase(),Oe.toLowerCase(),Ve,Re,Xe,he);$(Ke)&&(Ke-=32),$(Ue)&&(Ue-=32);const Ze=Ke-Ue;if(Ze!==0)return Ze}const ue=Re-Ve,Ie=he-Xe;return ue<Ie?-1:ue>Ie?1:0}e.$Ye=k;function D(Ae){return Ae>=48&&Ae<=57}e.$Ze=D;function $(Ae){return Ae>=97&&Ae<=122}e.$1e=$;function b(Ae){return Ae>=65&&Ae<=90}e.$2e=b;function v(Ae,Oe){return Ae.length===Oe.length&&k(Ae,Oe)===0}e.$3e=v;function C(Ae,Oe){const Ve=Oe.length;return Oe.length>Ae.length?!1:k(Ae,Oe,0,Ve)===0}e.$4e=C;function N(Ae,Oe){const Ve=Math.min(Ae.length,Oe.length);let Re;for(Re=0;Re<Ve;Re++)if(Ae.charCodeAt(Re)!==Oe.charCodeAt(Re))return Re;return Ve}e.$5e=N;function z(Ae,Oe){const Ve=Math.min(Ae.length,Oe.length);let Re;const Xe=Ae.length-1,he=Oe.length-1;for(Re=0;Re<Ve;Re++)if(Ae.charCodeAt(Xe-Re)!==Oe.charCodeAt(he-Re))return Re;return Ve}e.$6e=z;function M(Ae){return 55296<=Ae&&Ae<=56319}e.$7e=M;function O(Ae){return 56320<=Ae&&Ae<=57343}e.$8e=O;function j(Ae,Oe){return(Ae-55296<<10)+(Oe-56320)+65536}e.$9e=j;function T(Ae,Oe,Ve){const Re=Ae.charCodeAt(Ve);if(M(Re)&&Ve+1<Oe){const Xe=Ae.charCodeAt(Ve+1);if(O(Xe))return j(Re,Xe)}return Re}e.$0e=T;function V(Ae,Oe){const Ve=Ae.charCodeAt(Oe-1);if(O(Ve)&&Oe>1){const Re=Ae.charCodeAt(Oe-2);if(M(Re))return j(Re,Ve)}return Ve}class q{get offset(){return this.e}constructor(Oe,Ve=0){this.c=Oe,this.d=Oe.length,this.e=Ve}setOffset(Oe){this.e=Oe}prevCodePoint(){const Oe=V(this.c,this.e);return this.e-=Oe>=65536?2:1,Oe}nextCodePoint(){const Oe=T(this.c,this.d,this.e);return this.e+=Oe>=65536?2:1,Oe}eol(){return this.e>=this.d}}e.$$e=q;class fe{get offset(){return this.c.offset}constructor(Oe,Ve=0){this.c=new q(Oe,Ve)}nextGraphemeLength(){const Oe=me.getInstance(),Ve=this.c,Re=Ve.offset;let Xe=Oe.getGraphemeBreakType(Ve.nextCodePoint());for(;!Ve.eol();){const he=Ve.offset,ue=Oe.getGraphemeBreakType(Ve.nextCodePoint());if(oe(Xe,ue)){Ve.setOffset(he);break}Xe=ue}return Ve.offset-Re}prevGraphemeLength(){const Oe=me.getInstance(),Ve=this.c,Re=Ve.offset;let Xe=Oe.getGraphemeBreakType(Ve.prevCodePoint());for(;Ve.offset>0;){const he=Ve.offset,ue=Oe.getGraphemeBreakType(Ve.prevCodePoint());if(oe(ue,Xe)){Ve.setOffset(he);break}Xe=ue}return Re-Ve.offset}eol(){return this.c.eol()}}e.$_e=fe;function ee(Ae,Oe){return new fe(Ae,Oe).nextGraphemeLength()}e.$af=ee;function Y(Ae,Oe){return new fe(Ae,Oe).prevGraphemeLength()}e.$bf=Y;function X(Ae,Oe){Oe>0&&O(Ae.charCodeAt(Oe))&&Oe--;const Ve=Oe+ee(Ae,Oe);return[Ve-Y(Ae,Ve),Ve]}e.$cf=X;function ae(Ae){const Oe=new fe(Ae);let Ve=0;for(;!Oe.eol();)Ve++,Oe.nextGraphemeLength();return Ve}e.$df=ae;let Z;function se(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function we(Ae){return Z||(Z=se()),Z.test(Ae)}e.$ef=we;const H=/^[\t\n\r\x20-\x7E]*$/;function U(Ae){return H.test(Ae)}e.$ff=U,e.$gf=/[\u2028\u2029]/;function ce(Ae){return e.$gf.test(Ae)}e.$hf=ce;function Ee(Ae){return Ae>=11904&&Ae<=55215||Ae>=63744&&Ae<=64255||Ae>=65281&&Ae<=65374}e.$if=Ee;function ne(Ae){return Ae>=127462&&Ae<=127487||Ae===8986||Ae===8987||Ae===9200||Ae===9203||Ae>=9728&&Ae<=10175||Ae===11088||Ae===11093||Ae>=127744&&Ae<=128591||Ae>=128640&&Ae<=128764||Ae>=128992&&Ae<=129008||Ae>=129280&&Ae<=129535||Ae>=129648&&Ae<=129782}e.$jf=ne;function G(Ae,Oe){if(Ae.length<Oe)return Ae;const Ve=/\b/g;let Re=0;for(;Ve.test(Ae)&&!(Ae.length-Ve.lastIndex<Oe);)Re=Ve.lastIndex,Ve.lastIndex+=1;return Ae.substring(Re).replace(/^\s/,"")}e.$kf=G;const J=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ge=/\x1b\].*?\x07/g;function x(Ae){return Ae&&(Ae=Ae.replace(J,"").replace(ge,"")),Ae}e.$lf=x,e.$mf=String.fromCharCode(65279);function le(Ae){return!!(Ae&&Ae.length>0&&Ae.charCodeAt(0)===65279)}e.$nf=le;function te(Ae){return le(Ae)?Ae.substr(1):Ae}e.$of=te;function de(Ae,Oe){if(!Ae||!Oe||Ae.length<Oe.length)return!1;const Ve=Oe.length,Re=Ae.toLowerCase();let Xe=0,he=-1;for(;Xe<Ve;){const ue=Re.indexOf(Oe[Xe],he+1);if(ue<0)return!1;he=ue,Xe++}return!0}e.$pf=de;function be(Ae,Oe=!1){return Ae?(Oe&&(Ae=Ae.replace(/\\./g,"")),Ae.toLowerCase()!==Ae):!1}e.$qf=be;function Pe(Ae){return Ae.charAt(0).toUpperCase()+Ae.slice(1)}e.$rf=Pe;function B(Ae,Oe=1){if(Oe===0)return"";let Ve=-1;do Ve=Ae.indexOf(`
`,Ve+1),Oe--;while(Oe>0&&Ve>=0);return Ve===-1?Ae:(Ae[Ve-1]==="\r"&&Ve--,Ae.substr(0,Ve))}e.$sf=B;function Q(Ae){return Ae=Ae%(2*26),Ae<26?String.fromCharCode(97+Ae):String.fromCharCode(65+Ae-26)}e.$tf=Q;function re(Ae){return me.getInstance().getGraphemeBreakType(Ae)}e.$uf=re;function oe(Ae,Oe){return Ae===0?Oe!==5&&Oe!==7:Ae===2&&Oe===3?!1:Ae===4||Ae===2||Ae===3||Oe===4||Oe===2||Oe===3?!0:!(Ae===8&&(Oe===8||Oe===9||Oe===11||Oe===12)||(Ae===11||Ae===9)&&(Oe===9||Oe===10)||(Ae===12||Ae===10)&&Oe===10||Oe===5||Oe===13||Oe===7||Ae===1||Ae===13&&Oe===14||Ae===6&&Oe===6)}var _;(function(Ae){Ae[Ae.Other=0]="Other",Ae[Ae.Prepend=1]="Prepend",Ae[Ae.CR=2]="CR",Ae[Ae.LF=3]="LF",Ae[Ae.Control=4]="Control",Ae[Ae.Extend=5]="Extend",Ae[Ae.Regional_Indicator=6]="Regional_Indicator",Ae[Ae.SpacingMark=7]="SpacingMark",Ae[Ae.L=8]="L",Ae[Ae.V=9]="V",Ae[Ae.T=10]="T",Ae[Ae.LV=11]="LV",Ae[Ae.LVT=12]="LVT",Ae[Ae.ZWJ=13]="ZWJ",Ae[Ae.Extended_Pictographic=14]="Extended_Pictographic"})(_||(e.GraphemeBreakType=_={}));class me{static{this.c=null}static getInstance(){return me.c||(me.c=new me),me.c}constructor(){this.d=ye()}getGraphemeBreakType(Oe){if(Oe<32)return Oe===10?3:Oe===13?2:4;if(Oe<127)return 0;const Ve=this.d,Re=Ve.length/3;let Xe=1;for(;Xe<=Re;)if(Oe<Ve[3*Xe])Xe=2*Xe;else if(Oe>Ve[3*Xe+1])Xe=2*Xe+1;else return Ve[3*Xe+2];return 0}}function ye(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ze(Ae,Oe){if(Ae===0)return 0;const Ve=We(Ae,Oe);if(Ve!==void 0)return Ve;const Re=new q(Oe,Ae);return Re.prevCodePoint(),Re.offset}e.$vf=ze;function We(Ae,Oe){const Ve=new q(Oe,Ae);let Re=Ve.prevCodePoint();for(;_e(Re)||Re===65039||Re===8419;){if(Ve.offset===0)return;Re=Ve.prevCodePoint()}if(!ne(Re))return;let Xe=Ve.offset;return Xe>0&&Ve.prevCodePoint()===8205&&(Xe=Ve.offset),Xe}function _e(Ae){return 127995<=Ae&&Ae<=127999}var Ye;(function(Ae){Ae[Ae.zwj=8205]="zwj",Ae[Ae.emojiVariantSelector=65039]="emojiVariantSelector",Ae[Ae.enclosingKeyCap=8419]="enclosingKeyCap"})(Ye||(Ye={})),e.$wf="\xA0";class it{static{this.c=new F.$U(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new I.$ye(Oe=>{function Ve(Ze){const nt=new Map;for(let ct=0;ct<Ze.length;ct+=2)nt.set(Ze[ct],Ze[ct+1]);return nt}function Re(Ze,nt){const ct=new Map(Ze);for(const[bt,Et]of nt)ct.set(bt,Et);return ct}function Xe(Ze,nt){if(!Ze)return nt;const ct=new Map;for(const[bt,Et]of Ze)nt.has(bt)&&ct.set(bt,Et);return ct}const he=this.c.value;let ue=Oe.filter(Ze=>!Ze.startsWith("_")&&Ze in he);ue.length===0&&(ue=["_default"]);let Ie;for(const Ze of ue){const nt=Ve(he[Ze]);Ie=Xe(Ie,nt)}const Ke=Ve(he._common),Ue=Re(Ke,Ie);return new it(Ue)})}static getInstance(Oe){return it.d.get(Array.from(Oe))}static{this.e=new F.$U(()=>Object.keys(it.c.value).filter(Oe=>!Oe.startsWith("_")))}static getLocales(){return it.e.value}constructor(Oe){this.f=Oe}isAmbiguous(Oe){return this.f.has(Oe)}getPrimaryConfusable(Oe){return this.f.get(Oe)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$xf=it;class tt{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(tt.c())),this.d}static isInvisibleCharacter(Oe){return tt.e().has(Oe)}static get codePoints(){return tt.e()}}e.$yf=tt}),define(ke[124],Se([1,0,28,13]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.FuzzyScore=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.or=void 0;function f(...te){return function(de,be){for(let Pe=0,B=te.length;Pe<B;Pe++){const Q=te[Pe](de,be);if(Q)return Q}return null}}e.or=f,e.$Gj=L.bind(void 0,!1),e.$Hj=L.bind(void 0,!0);function L(te,de,be){if(!be||be.length<de.length)return null;let Pe;return te?Pe=F.$4e(be,de):Pe=be.indexOf(de)===0,Pe?de.length>0?[{start:0,end:de.length}]:[]:null}function R(te,de){const be=de.toLowerCase().indexOf(te.toLowerCase());return be===-1?null:[{start:be,end:be+te.length}]}e.$Ij=R;function p(te,de){return E(te.toLowerCase(),de.toLowerCase(),0,0)}e.$Jj=p;function E(te,de,be,Pe){if(be===te.length)return[];if(Pe===de.length)return null;if(te[be]===de[Pe]){let B=null;return(B=E(te,de,be+1,Pe+1))?s({start:Pe,end:Pe+1},B):null}return E(te,de,be,Pe+1)}function m(te){return 97<=te&&te<=122}function A(te){return 65<=te&&te<=90}e.$Kj=A;function P(te){return 48<=te&&te<=57}function g(te){return te===32||te===9||te===10||te===13}const y=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(te=>y.add(te.charCodeAt(0)));function S(te){return g(te)||y.has(te)}function w(te,de){return te===de||S(te)&&S(de)}function c(te){return m(te)||A(te)||P(te)}function s(te,de){return de.length===0?de=[te]:te.end===de[0].start?de[0].start=te.start:de.unshift(te),de}function i(te,de){for(let be=de;be<te.length;be++){const Pe=te.charCodeAt(be);if(A(Pe)||P(Pe)||be>0&&!c(te.charCodeAt(be-1)))return be}return te.length}function n(te,de,be,Pe){if(be===te.length)return[];if(Pe===de.length)return null;if(te[be]!==de[Pe].toLowerCase())return null;{let B=null,Q=Pe+1;for(B=n(te,de,be+1,Pe+1);!B&&(Q=i(de,Q))<de.length;)B=n(te,de,be+1,Q),Q++;return B===null?null:s({start:Pe,end:Pe+1},B)}}function o(te){let de=0,be=0,Pe=0,B=0,Q=0;for(let ye=0;ye<te.length;ye++)Q=te.charCodeAt(ye),A(Q)&&de++,m(Q)&&be++,c(Q)&&Pe++,P(Q)&&B++;const re=de/te.length,oe=be/te.length,_=Pe/te.length,me=B/te.length;return{upperPercent:re,lowerPercent:oe,alphaPercent:_,numericPercent:me}}function a(te){const{upperPercent:de,lowerPercent:be}=te;return be===0&&de>.6}function t(te){const{upperPercent:de,lowerPercent:be,alphaPercent:Pe,numericPercent:B}=te;return be>.2&&de<.8&&Pe>.6&&B<.2}function r(te){let de=0,be=0,Pe=0,B=0;for(let Q=0;Q<te.length;Q++)Pe=te.charCodeAt(Q),A(Pe)&&de++,m(Pe)&&be++,g(Pe)&&B++;return(de===0||be===0)&&B===0?te.length<=30:de<=5}function d(te,de){if(!de||(de=de.trim(),de.length===0)||!r(te)||de.length>60)return null;const be=o(de);if(!t(be)){if(!a(be))return null;de=de.toLowerCase()}let Pe=null,B=0;for(te=te.toLowerCase();B<de.length&&(Pe=n(te,de,0,B))===null;)B=i(de,B+1);return Pe}e.$Lj=d;function u(te,de,be=!1){if(!de||de.length===0)return null;let Pe=null,B=0;for(te=te.toLowerCase(),de=de.toLowerCase();B<de.length&&(Pe=l(te,de,0,B,be))===null;)B=h(de,B+1);return Pe}e.$Mj=u;function l(te,de,be,Pe,B){if(be===te.length)return[];if(Pe===de.length)return null;if(w(te.charCodeAt(be),de.charCodeAt(Pe))){let Q=null,re=Pe+1;if(Q=l(te,de,be+1,Pe+1,B),!B)for(;!Q&&(re=h(de,re))<de.length;)Q=l(te,de,be+1,re,B),re++;return Q?te.charCodeAt(be)!==de.charCodeAt(Pe)?Q:s({start:Pe,end:Pe+1},Q):null}else return null}function h(te,de){for(let be=de;be<te.length;be++)if(S(te.charCodeAt(be))||be>0&&S(te.charCodeAt(be-1)))return be;return te.length}const k=f(e.$Hj,d,R),D=f(e.$Hj,d,p),$=new I.$Cc(1e4);function b(te,de,be=!1){if(typeof te!="string"||typeof de!="string")return null;let Pe=$.get(te);Pe||(Pe=new RegExp(F.$Me(te),"i"),$.set(te,Pe));const B=Pe.exec(de);return B?[{start:B.index,end:B.index+B[0].length}]:be?D(te,de):k(te,de)}e.$Nj=b;function v(te,de){const be=Ee(te,te.toLowerCase(),0,de,de.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return be?N(be):null}e.$Oj=v;function C(te,de,be,Pe,B,Q){const re=Math.min(13,te.length);for(;be<re;be++){const oe=Ee(te,de,be,Pe,B,Q,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(oe)return oe}return[0,Q]}e.$Pj=C;function N(te){if(typeof te>"u")return[];const de=[],be=te[1];for(let Pe=te.length-1;Pe>1;Pe--){const B=te[Pe]+be,Q=de[de.length-1];Q&&Q.end===B?Q.end=B+1:de.push({start:B,end:B+1})}return de}e.$Qj=N;const z=128;function M(){const te=[],de=[];for(let be=0;be<=z;be++)de[be]=0;for(let be=0;be<=z;be++)te.push(de.slice(0));return te}function O(te){const de=[];for(let be=0;be<=te;be++)de[be]=0;return de}const j=O(2*z),T=O(2*z),V=M(),q=M(),fe=M(),ee=!1;function Y(te,de,be,Pe,B){function Q(oe,_,me=" "){for(;oe.length<_;)oe=me+oe;return oe}let re=` |   |${Pe.split("").map(oe=>Q(oe,3)).join("|")}
`;for(let oe=0;oe<=be;oe++)oe===0?re+=" |":re+=`${de[oe-1]}|`,re+=te[oe].slice(0,B+1).map(_=>Q(_.toString(),3)).join("|")+`
`;return re}function X(te,de,be,Pe){te=te.substr(de),be=be.substr(Pe),console.log(Y(q,te,te.length,be,be.length)),console.log(Y(fe,te,te.length,be,be.length)),console.log(Y(V,te,te.length,be,be.length))}function ae(te,de){if(de<0||de>=te.length)return!1;const be=te.codePointAt(de);switch(be){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!F.$jf(be)}}function Z(te,de){if(de<0||de>=te.length)return!1;switch(te.charCodeAt(de)){case 32:case 9:return!0;default:return!1}}function se(te,de,be){return de[te]!==be[te]}function we(te,de,be,Pe,B,Q,re=!1){for(;de<be&&B<Q;)te[de]===Pe[B]&&(re&&(j[de]=B),de+=1),B+=1;return de===be}e.$Rj=we;var H;(function(te){te[te.Diag=1]="Diag",te[te.Left=2]="Left",te[te.LeftLeft=3]="LeftLeft"})(H||(H={}));var U;(function(te){te.Default=[-100,0];function de(be){return!be||be.length===2&&be[0]===-100&&be[1]===0}te.isDefault=de})(U||(e.FuzzyScore=U={}));class ce{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(de,be){this.firstMatchCanBeWeak=de,this.boostFullMatch=be}}e.$Sj=ce;function Ee(te,de,be,Pe,B,Q,re=ce.default){const oe=te.length>z?z:te.length,_=Pe.length>z?z:Pe.length;if(be>=oe||Q>=_||oe-be>_-Q||!we(de,be,oe,B,Q,_,!0))return;ne(oe,_,be,Q,de,B);let me=1,ye=1,ze=be,We=Q;const _e=[!1];for(me=1,ze=be;ze<oe;me++,ze++){const Oe=j[ze],Ve=T[ze],Re=ze+1<oe?T[ze+1]:_;for(ye=Oe-Q+1,We=Oe;We<Re;ye++,We++){let Xe=Number.MIN_SAFE_INTEGER,he=!1;We<=Ve&&(Xe=G(te,de,ze,be,Pe,B,We,_,Q,V[me-1][ye-1]===0,_e));let ue=0;Xe!==Number.MAX_SAFE_INTEGER&&(he=!0,ue=Xe+q[me-1][ye-1]);const Ie=We>Oe,Ke=Ie?q[me][ye-1]+(V[me][ye-1]>0?-5:0):0,Ue=We>Oe+1&&V[me][ye-1]>0,Ze=Ue?q[me][ye-2]+(V[me][ye-2]>0?-5:0):0;if(Ue&&(!Ie||Ze>=Ke)&&(!he||Ze>=ue))q[me][ye]=Ze,fe[me][ye]=3,V[me][ye]=0;else if(Ie&&(!he||Ke>=ue))q[me][ye]=Ke,fe[me][ye]=2,V[me][ye]=0;else if(he)q[me][ye]=ue,fe[me][ye]=1,V[me][ye]=V[me-1][ye-1]+1;else throw new Error("not possible")}}if(ee&&X(te,be,Pe,Q),!_e[0]&&!re.firstMatchCanBeWeak)return;me--,ye--;const Ye=[q[me][ye],Q];let it=0,tt=0;for(;me>=1;){let Oe=ye;do{const Ve=fe[me][Oe];if(Ve===3)Oe=Oe-2;else if(Ve===2)Oe=Oe-1;else break}while(Oe>=1);it>1&&de[be+me-1]===B[Q+ye-1]&&!se(Oe+Q-1,Pe,B)&&it+1>V[me][Oe]&&(Oe=ye),Oe===ye?it++:it=1,tt||(tt=Oe),me--,ye=Oe-1,Ye.push(ye)}_===oe&&re.boostFullMatch&&(Ye[0]+=2);const Ae=tt-oe;return Ye[0]-=Ae,Ye}e.$Tj=Ee;function ne(te,de,be,Pe,B,Q){let re=te-1,oe=de-1;for(;re>=be&&oe>=Pe;)B[re]===Q[oe]&&(T[re]=oe,re--),oe--}function G(te,de,be,Pe,B,Q,re,oe,_,me,ye){if(de[be]!==Q[re])return Number.MIN_SAFE_INTEGER;let ze=1,We=!1;return re===be-Pe?ze=te[be]===B[re]?7:5:se(re,B,Q)&&(re===0||!se(re-1,B,Q))?(ze=te[be]===B[re]?7:5,We=!0):ae(Q,re)&&(re===0||!ae(Q,re-1))?ze=5:(ae(Q,re-1)||Z(Q,re-1))&&(ze=5,We=!0),ze>1&&be===Pe&&(ye[0]=!0),We||(We=se(re,B,Q)||ae(Q,re-1)||Z(Q,re-1)),be===Pe?re>_&&(ze-=We?3:5):me?ze+=We?2:0:ze+=We?0:1,re+1===oe&&(ze-=We?3:5),ze}function J(te,de,be,Pe,B,Q,re){return x(te,de,be,Pe,B,Q,!0,re)}e.$Uj=J;function ge(te,de,be,Pe,B,Q,re){return x(te,de,be,Pe,B,Q,!1,re)}e.$Vj=ge;function x(te,de,be,Pe,B,Q,re,oe){let _=Ee(te,de,be,Pe,B,Q,oe);if(_&&!re)return _;if(te.length>=3){const me=Math.min(7,te.length-1);for(let ye=be+1;ye<me;ye++){const ze=le(te,ye);if(ze){const We=Ee(ze,ze.toLowerCase(),be,Pe,B,Q,oe);We&&(We[0]-=3,(!_||We[0]>_[0])&&(_=We))}}}return _}function le(te,de){if(de+1>=te.length)return;const be=te[de],Pe=te[de+1];if(be!==Pe)return te.slice(0,de)+Pe+be+te.slice(de+2)}}),define(ke[52],Se([1,0,13]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=void 0;function F(s){return f(s,0)}e.$Hi=F;function f(s,i){switch(typeof s){case"object":return s===null?L(349,i):Array.isArray(s)?E(s,i):m(s,i);case"string":return p(s,i);case"boolean":return R(s,i);case"number":return L(s,i);case"undefined":return L(937,i);default:return L(617,i)}}e.$Ii=f;function L(s,i){return(i<<5)-i+s|0}e.$Ji=L;function R(s,i){return L(s?433:863,i)}function p(s,i){i=L(149417,i);for(let n=0,o=s.length;n<o;n++)i=L(s.charCodeAt(n),i);return i}e.$Ki=p;function E(s,i){return i=L(104579,i),s.reduce((n,o)=>f(o,n),i)}function m(s,i){return i=L(181387,i),Object.keys(s).sort().reduce((n,o)=>(n=p(o,n),f(s[o],n)),i)}class A{constructor(){this.g=0}get value(){return this.g}hash(i){return this.g=f(i,this.g),this.g}}e.$Li=A;var P;(function(s){s[s.BLOCK_SIZE=64]="BLOCK_SIZE",s[s.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function g(s,i,n=32){const o=n-i,a=~((1<<o)-1);return(s<<i|(a&s)>>>o)>>>0}function y(s,i=0,n=s.byteLength,o=0){for(let a=0;a<n;a++)s[i+a]=o}function S(s,i,n="0"){for(;s.length<i;)s=n+s;return s}function w(s,i=32){return s instanceof ArrayBuffer?Array.from(new Uint8Array(s)).map(n=>n.toString(16).padStart(2,"0")).join(""):S((s>>>0).toString(16),i/4)}e.$Mi=w;class c{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(i){const n=i.length;if(n===0)return;const o=this.p;let a=this.r,t=this.u,r,d;for(t!==0?(r=t,d=-1,t=0):(r=i.charCodeAt(0),d=0);;){let u=r;if(I.$7e(r))if(d+1<n){const l=i.charCodeAt(d+1);I.$8e(l)?(d++,u=I.$9e(r,l)):u=65533}else{t=r;break}else I.$8e(r)&&(u=65533);if(a=this.w(o,a,u),d++,d<n)r=i.charCodeAt(d);else break}this.r=a,this.u=t}w(i,n,o){return o<128?i[n++]=o:o<2048?(i[n++]=192|(o&1984)>>>6,i[n++]=128|(o&63)>>>0):o<65536?(i[n++]=224|(o&61440)>>>12,i[n++]=128|(o&4032)>>>6,i[n++]=128|(o&63)>>>0):(i[n++]=240|(o&1835008)>>>18,i[n++]=128|(o&258048)>>>12,i[n++]=128|(o&4032)>>>6,i[n++]=128|(o&63)>>>0),n>=64&&(this.y(),n-=64,this.t+=64,i[0]=i[64+0],i[1]=i[64+1],i[2]=i[64+2]),n}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),w(this.h)+w(this.l)+w(this.m)+w(this.n)+w(this.o)}x(){this.p[this.r++]=128,y(this.p,this.r),this.r>56&&(this.y(),y(this.p));const i=8*this.t;this.q.setUint32(56,Math.floor(i/4294967296),!1),this.q.setUint32(60,i%4294967296,!1),this.y()}y(){const i=c.g,n=this.q;for(let k=0;k<64;k+=4)i.setUint32(k,n.getUint32(k,!1),!1);for(let k=64;k<320;k+=4)i.setUint32(k,g(i.getUint32(k-12,!1)^i.getUint32(k-32,!1)^i.getUint32(k-56,!1)^i.getUint32(k-64,!1),1),!1);let o=this.h,a=this.l,t=this.m,r=this.n,d=this.o,u,l,h;for(let k=0;k<80;k++)k<20?(u=a&t|~a&r,l=1518500249):k<40?(u=a^t^r,l=1859775393):k<60?(u=a&t|a&r|t&r,l=2400959708):(u=a^t^r,l=3395469782),h=g(o,5)+u+d+l+i.getUint32(k*4,!1)&4294967295,d=r,r=t,t=g(a,30),a=o,o=h;this.h=this.h+o&4294967295,this.l=this.l+a&4294967295,this.m=this.m+t&4294967295,this.n=this.n+r&4294967295,this.o=this.o+d&4294967295}}e.$Ni=c}),define(ke[39],Se([1,0,13]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var F;(function(f){f[f.Ignore=0]="Ignore",f[f.Info=1]="Info",f[f.Warning=2]="Warning",f[f.Error=3]="Error"})(F||(F={})),function(f){const L="error",R="warning",p="warn",E="info",m="ignore";function A(g){return g?I.$3e(L,g)?f.Error:I.$3e(R,g)||I.$3e(p,g)?f.Warning:I.$3e(E,g)?f.Info:f.Ignore:f.Ignore}f.fromValue=A;function P(g){switch(g){case f.Error:return L;case f.Warning:return R;case f.Info:return E;default:return m}}f.toString=P}(F||(F={})),e.default=F}),define(ke[163],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ld=void 0,e.$Ld=Symbol("MicrotaskDelay")}),define(ke[78],Se([1,0,19,13]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=void 0;class f{constructor(){this.b="",this.c=0}reset(y){return this.b=y,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(y){const S=y.charCodeAt(0),w=this.b.charCodeAt(this.c);return S-w}value(){return this.b[this.c]}}e.$Vh=f;class L{constructor(y=!0){this.e=y}reset(y){return this.b=y,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let y=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(y)this.c++;else break;else y=!1;return this}cmp(y){return this.e?(0,F.$We)(y,this.b,0,y.length,this.c,this.d):(0,F.$Ye)(y,this.b,0,y.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Wh=L;class R{constructor(y=!0,S=!0){this.f=y,this.g=S}reset(y){this.d=0,this.e=0,this.b=y,this.c=y.length;for(let S=y.length-1;S>=0;S--,this.c--){const w=this.b.charCodeAt(S);if(!(w===47||this.f&&w===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let y=!0;for(;this.e<this.c;this.e++){const S=this.b.charCodeAt(this.e);if(S===47||this.f&&S===92)if(y)this.d++;else break;else y=!1}return this}cmp(y){return this.g?(0,F.$We)(y,this.b,0,y.length,this.d,this.e):(0,F.$Ye)(y,this.b,0,y.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Xh=R;var p;(function(g){g[g.Scheme=1]="Scheme",g[g.Authority=2]="Authority",g[g.Path=3]="Path",g[g.Query=4]="Query",g[g.Fragment=5]="Fragment"})(p||(p={}));class E{constructor(y,S){this.f=y,this.g=S,this.d=[],this.e=0}reset(y){return this.c=y,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(y)),this.b.reset(y.path),this.b.value()&&this.d.push(3)),this.g(y)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(y){if(this.d[this.e]===1)return(0,F.$Xe)(y,this.c.scheme);if(this.d[this.e]===2)return(0,F.$Xe)(y,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(y);if(this.d[this.e]===4)return(0,F.$Ve)(y,this.c.query);if(this.d[this.e]===5)return(0,F.$Ve)(y,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Yh=E;class m{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const y=this.right;return this.right=y.left,y.left=this,this.updateHeight(),y.updateHeight(),y}rotateRight(){const y=this.left;return this.left=y.right,y.right=this,this.updateHeight(),y.updateHeight(),y}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function(g){g[g.Left=-1]="Left",g[g.Mid=0]="Mid",g[g.Right=1]="Right"})(A||(A={}));class P{static forUris(y=()=>!1,S=()=>!1){return new P(new E(y,S))}static forPaths(y=!1){return new P(new R(void 0,!y))}static forStrings(){return new P(new f)}static forConfigKeys(){return new P(new L)}constructor(y){this.b=y}clear(){this.c=void 0}fill(y,S){if(S){const w=S.slice(0);(0,I.$Wb)(w);for(const c of w)this.set(c,y)}else{const w=y.slice(0);(0,I.$Wb)(w);for(const c of w)this.set(c[0],c[1])}}set(y,S){const w=this.b.reset(y);let c;this.c||(this.c=new m,this.c.segment=w.value());const s=[];for(c=this.c;;){const n=w.cmp(c.segment);if(n>0)c.left||(c.left=new m,c.left.segment=w.value()),s.push([-1,c]),c=c.left;else if(n<0)c.right||(c.right=new m,c.right.segment=w.value()),s.push([1,c]),c=c.right;else if(w.hasNext())w.next(),c.mid||(c.mid=new m,c.mid.segment=w.value()),s.push([0,c]),c=c.mid;else break}const i=c.value;c.value=S,c.key=y;for(let n=s.length-1;n>=0;n--){const o=s[n][1];o.updateHeight();const a=o.balanceFactor();if(a<-1||a>1){const t=s[n][0],r=s[n+1][0];if(t===1&&r===1)s[n][1]=o.rotateLeft();else if(t===-1&&r===-1)s[n][1]=o.rotateRight();else if(t===1&&r===-1)o.right=s[n+1][1]=s[n+1][1].rotateRight(),s[n][1]=o.rotateLeft();else if(t===-1&&r===1)o.left=s[n+1][1]=s[n+1][1].rotateLeft(),s[n][1]=o.rotateRight();else throw new Error;if(n>0)switch(s[n-1][0]){case-1:s[n-1][1].left=s[n][1];break;case 1:s[n-1][1].right=s[n][1];break;case 0:s[n-1][1].mid=s[n][1];break}else this.c=s[0][1]}}return i}get(y){return this.d(y)?.value}d(y){const S=this.b.reset(y);let w=this.c;for(;w;){const c=S.cmp(w.segment);if(c>0)w=w.left;else if(c<0)w=w.right;else if(S.hasNext())S.next(),w=w.mid;else break}return w}has(y){const S=this.d(y);return!(S?.value===void 0&&S?.mid===void 0)}delete(y){return this.e(y,!1)}deleteSuperstr(y){return this.e(y,!0)}e(y,S){const w=this.b.reset(y),c=[];let s=this.c;for(;s;){const i=w.cmp(s.segment);if(i>0)c.push([-1,s]),s=s.left;else if(i<0)c.push([1,s]),s=s.right;else if(w.hasNext())w.next(),c.push([0,s]),s=s.mid;else break}if(s){if(S?(s.left=void 0,s.mid=void 0,s.right=void 0,s.height=1):(s.key=void 0,s.value=void 0),!s.mid&&!s.value)if(s.left&&s.right){const i=this.f(s.right);if(i.key){const{key:n,value:o,segment:a}=i;this.e(i.key,!1),s.key=n,s.value=o,s.segment=a}}else{const i=s.left??s.right;if(c.length>0){const[n,o]=c[c.length-1];switch(n){case-1:o.left=i;break;case 0:o.mid=i;break;case 1:o.right=i;break}}else this.c=i}for(let i=c.length-1;i>=0;i--){const n=c[i][1];n.updateHeight();const o=n.balanceFactor();if(o>1?(n.right.balanceFactor()>=0||(n.right=n.right.rotateRight()),c[i][1]=n.rotateLeft()):o<-1&&(n.left.balanceFactor()<=0||(n.left=n.left.rotateLeft()),c[i][1]=n.rotateRight()),i>0)switch(c[i-1][0]){case-1:c[i-1][1].left=c[i][1];break;case 1:c[i-1][1].right=c[i][1];break;case 0:c[i-1][1].mid=c[i][1];break}else this.c=c[0][1]}}}f(y){for(;y.left;)y=y.left;return y}findSubstr(y){const S=this.b.reset(y);let w=this.c,c;for(;w;){const s=S.cmp(w.segment);if(s>0)w=w.left;else if(s<0)w=w.right;else if(S.hasNext())S.next(),c=w.value||c,w=w.mid;else break}return w&&w.value||c}findSuperstr(y){return this.g(y,!1)}g(y,S){const w=this.b.reset(y);let c=this.c;for(;c;){const s=w.cmp(c.segment);if(s>0)c=c.left;else if(s<0)c=c.right;else if(w.hasNext())w.next(),c=c.mid;else return c.mid?this.h(c.mid):S?c.value:void 0}}hasElementOrSubtree(y){return this.g(y,!0)!==void 0}forEach(y){for(const[S,w]of this)y(w,S)}*[Symbol.iterator](){yield*this.h(this.c)}h(y){const S=[];return this.j(y,S),S[Symbol.iterator]()}j(y,S){y&&(y.left&&this.j(y.left,S),y.value&&S.push([y.key,y.value]),y.mid&&this.j(y.mid,S),y.right&&this.j(y.right,S))}_isBalanced(){const y=S=>{if(!S)return!0;const w=S.balanceFactor();return w<-1||w>1?!1:y(S.left)&&y(S.right)};return y(this.c)}}e.$Zh=P}),define(ke[18],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=void 0;function I(a){return typeof a=="string"}e.$zf=I;function F(a){return Array.isArray(a)&&a.every(t=>I(t))}e.$Af=F;function f(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.$Bf=f;function L(a){const t=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof t}e.$Cf=L;function R(a){return typeof a=="number"&&!isNaN(a)}e.$Df=R;function p(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.$Ef=p;function E(a){return a===!0||a===!1}e.$Ff=E;function m(a){return typeof a>"u"}e.$Gf=m;function A(a){return!P(a)}e.$Hf=A;function P(a){return m(a)||a===null}e.$If=P;function g(a,t){if(!a)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$Jf=g;function y(a){if(P(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.$Kf=y;function S(...a){const t=[];for(let r=0;r<a.length;r++){const d=a[r];if(P(d))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);t.push(d)}return t}e.$Lf=S;const w=Object.prototype.hasOwnProperty;function c(a){if(!f(a))return!1;for(const t in a)if(w.call(a,t))return!1;return!0}e.$Mf=c;function s(a){return typeof a=="function"}e.$Nf=s;function i(...a){return a.length>0&&a.every(s)}e.$Of=i;function n(a,t){const r=Math.min(a.length,t.length);for(let d=0;d<r;d++)o(a[d],t[d])}e.$Pf=n;function o(a,t){if(I(t)){if(typeof a!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(s(t)){try{if(a instanceof t)return}catch{}if(!P(a)&&a.constructor===t||t.length===1&&t.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Qf=o}),define(ke[79],Se([1,0,18]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yj=e.$Xj=e.$Wj=void 0;const F=Object.create(null);function f(p,E){if((0,I.$zf)(E)){const m=F[E];if(m===void 0)throw new Error(`${p} references an unknown codicon: ${E}`);E=m}return F[p]=E,{id:p}}function L(){return F}e.$Wj=L;function R(){return Object.values(e.$Yj)}e.$Xj=R,e.$Yj={add:f("add",6e4),plus:f("plus",6e4),gistNew:f("gist-new",6e4),repoCreate:f("repo-create",6e4),lightbulb:f("lightbulb",60001),lightBulb:f("light-bulb",60001),repo:f("repo",60002),repoDelete:f("repo-delete",60002),gistFork:f("gist-fork",60003),repoForked:f("repo-forked",60003),gitPullRequest:f("git-pull-request",60004),gitPullRequestAbandoned:f("git-pull-request-abandoned",60004),recordKeys:f("record-keys",60005),keyboard:f("keyboard",60005),tag:f("tag",60006),tagAdd:f("tag-add",60006),tagRemove:f("tag-remove",60006),gitPullRequestLabel:f("git-pull-request-label",60006),person:f("person",60007),personFollow:f("person-follow",60007),personOutline:f("person-outline",60007),personFilled:f("person-filled",60007),gitBranch:f("git-branch",60008),gitBranchCreate:f("git-branch-create",60008),gitBranchDelete:f("git-branch-delete",60008),sourceControl:f("source-control",60008),mirror:f("mirror",60009),mirrorPublic:f("mirror-public",60009),star:f("star",60010),starAdd:f("star-add",60010),starDelete:f("star-delete",60010),starEmpty:f("star-empty",60010),comment:f("comment",60011),commentAdd:f("comment-add",60011),alert:f("alert",60012),warning:f("warning",60012),search:f("search",60013),searchSave:f("search-save",60013),logOut:f("log-out",60014),signOut:f("sign-out",60014),logIn:f("log-in",60015),signIn:f("sign-in",60015),eye:f("eye",60016),eyeUnwatch:f("eye-unwatch",60016),eyeWatch:f("eye-watch",60016),circleFilled:f("circle-filled",60017),primitiveDot:f("primitive-dot",60017),closeDirty:f("close-dirty",60017),debugBreakpoint:f("debug-breakpoint",60017),debugBreakpointDisabled:f("debug-breakpoint-disabled",60017),debugHint:f("debug-hint",60017),primitiveSquare:f("primitive-square",60018),edit:f("edit",60019),pencil:f("pencil",60019),info:f("info",60020),issueOpened:f("issue-opened",60020),gistPrivate:f("gist-private",60021),gitForkPrivate:f("git-fork-private",60021),lock:f("lock",60021),mirrorPrivate:f("mirror-private",60021),close:f("close",60022),removeClose:f("remove-close",60022),x:f("x",60022),repoSync:f("repo-sync",60023),sync:f("sync",60023),clone:f("clone",60024),desktopDownload:f("desktop-download",60024),beaker:f("beaker",60025),microscope:f("microscope",60025),vm:f("vm",60026),deviceDesktop:f("device-desktop",60026),file:f("file",60027),fileText:f("file-text",60027),more:f("more",60028),ellipsis:f("ellipsis",60028),kebabHorizontal:f("kebab-horizontal",60028),mailReply:f("mail-reply",60029),reply:f("reply",60029),organization:f("organization",60030),organizationFilled:f("organization-filled",60030),organizationOutline:f("organization-outline",60030),newFile:f("new-file",60031),fileAdd:f("file-add",60031),newFolder:f("new-folder",60032),fileDirectoryCreate:f("file-directory-create",60032),trash:f("trash",60033),trashcan:f("trashcan",60033),history:f("history",60034),clock:f("clock",60034),folder:f("folder",60035),fileDirectory:f("file-directory",60035),symbolFolder:f("symbol-folder",60035),logoGithub:f("logo-github",60036),markGithub:f("mark-github",60036),github:f("github",60036),terminal:f("terminal",60037),console:f("console",60037),repl:f("repl",60037),zap:f("zap",60038),symbolEvent:f("symbol-event",60038),error:f("error",60039),stop:f("stop",60039),variable:f("variable",60040),symbolVariable:f("symbol-variable",60040),array:f("array",60042),symbolArray:f("symbol-array",60042),symbolModule:f("symbol-module",60043),symbolPackage:f("symbol-package",60043),symbolNamespace:f("symbol-namespace",60043),symbolObject:f("symbol-object",60043),symbolMethod:f("symbol-method",60044),symbolFunction:f("symbol-function",60044),symbolConstructor:f("symbol-constructor",60044),symbolBoolean:f("symbol-boolean",60047),symbolNull:f("symbol-null",60047),symbolNumeric:f("symbol-numeric",60048),symbolNumber:f("symbol-number",60048),symbolStructure:f("symbol-structure",60049),symbolStruct:f("symbol-struct",60049),symbolParameter:f("symbol-parameter",60050),symbolTypeParameter:f("symbol-type-parameter",60050),symbolKey:f("symbol-key",60051),symbolText:f("symbol-text",60051),symbolReference:f("symbol-reference",60052),goToFile:f("go-to-file",60052),symbolEnum:f("symbol-enum",60053),symbolValue:f("symbol-value",60053),symbolRuler:f("symbol-ruler",60054),symbolUnit:f("symbol-unit",60054),activateBreakpoints:f("activate-breakpoints",60055),archive:f("archive",60056),arrowBoth:f("arrow-both",60057),arrowDown:f("arrow-down",60058),arrowLeft:f("arrow-left",60059),arrowRight:f("arrow-right",60060),arrowSmallDown:f("arrow-small-down",60061),arrowSmallLeft:f("arrow-small-left",60062),arrowSmallRight:f("arrow-small-right",60063),arrowSmallUp:f("arrow-small-up",60064),arrowUp:f("arrow-up",60065),bell:f("bell",60066),bold:f("bold",60067),book:f("book",60068),bookmark:f("bookmark",60069),debugBreakpointConditionalUnverified:f("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:f("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:f("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:f("debug-breakpoint-data-unverified",60072),debugBreakpointData:f("debug-breakpoint-data",60073),debugBreakpointDataDisabled:f("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:f("debug-breakpoint-log-unverified",60074),debugBreakpointLog:f("debug-breakpoint-log",60075),debugBreakpointLogDisabled:f("debug-breakpoint-log-disabled",60075),briefcase:f("briefcase",60076),broadcast:f("broadcast",60077),browser:f("browser",60078),bug:f("bug",60079),calendar:f("calendar",60080),caseSensitive:f("case-sensitive",60081),check:f("check",60082),checklist:f("checklist",60083),chevronDown:f("chevron-down",60084),dropDownButton:f("drop-down-button",60084),chevronLeft:f("chevron-left",60085),chevronRight:f("chevron-right",60086),chevronUp:f("chevron-up",60087),chromeClose:f("chrome-close",60088),chromeMaximize:f("chrome-maximize",60089),chromeMinimize:f("chrome-minimize",60090),chromeRestore:f("chrome-restore",60091),circle:f("circle",60092),circleOutline:f("circle-outline",60092),debugBreakpointUnverified:f("debug-breakpoint-unverified",60092),circleSlash:f("circle-slash",60093),circuitBoard:f("circuit-board",60094),clearAll:f("clear-all",60095),clippy:f("clippy",60096),closeAll:f("close-all",60097),cloudDownload:f("cloud-download",60098),cloudUpload:f("cloud-upload",60099),code:f("code",60100),collapseAll:f("collapse-all",60101),colorMode:f("color-mode",60102),commentDiscussion:f("comment-discussion",60103),compareChanges:f("compare-changes",60157),creditCard:f("credit-card",60105),dash:f("dash",60108),dashboard:f("dashboard",60109),database:f("database",60110),debugContinue:f("debug-continue",60111),debugDisconnect:f("debug-disconnect",60112),debugPause:f("debug-pause",60113),debugRestart:f("debug-restart",60114),debugStart:f("debug-start",60115),debugStepInto:f("debug-step-into",60116),debugStepOut:f("debug-step-out",60117),debugStepOver:f("debug-step-over",60118),debugStop:f("debug-stop",60119),debug:f("debug",60120),deviceCameraVideo:f("device-camera-video",60121),deviceCamera:f("device-camera",60122),deviceMobile:f("device-mobile",60123),diffAdded:f("diff-added",60124),diffIgnored:f("diff-ignored",60125),diffModified:f("diff-modified",60126),diffRemoved:f("diff-removed",60127),diffRenamed:f("diff-renamed",60128),diff:f("diff",60129),discard:f("discard",60130),editorLayout:f("editor-layout",60131),emptyWindow:f("empty-window",60132),exclude:f("exclude",60133),extensions:f("extensions",60134),eyeClosed:f("eye-closed",60135),fileBinary:f("file-binary",60136),fileCode:f("file-code",60137),fileMedia:f("file-media",60138),filePdf:f("file-pdf",60139),fileSubmodule:f("file-submodule",60140),fileSymlinkDirectory:f("file-symlink-directory",60141),fileSymlinkFile:f("file-symlink-file",60142),fileZip:f("file-zip",60143),files:f("files",60144),filter:f("filter",60145),flame:f("flame",60146),foldDown:f("fold-down",60147),foldUp:f("fold-up",60148),fold:f("fold",60149),folderActive:f("folder-active",60150),folderOpened:f("folder-opened",60151),gear:f("gear",60152),gift:f("gift",60153),gistSecret:f("gist-secret",60154),gist:f("gist",60155),gitCommit:f("git-commit",60156),gitCompare:f("git-compare",60157),gitMerge:f("git-merge",60158),githubAction:f("github-action",60159),githubAlt:f("github-alt",60160),globe:f("globe",60161),grabber:f("grabber",60162),graph:f("graph",60163),gripper:f("gripper",60164),heart:f("heart",60165),home:f("home",60166),horizontalRule:f("horizontal-rule",60167),hubot:f("hubot",60168),inbox:f("inbox",60169),issueClosed:f("issue-closed",60324),issueReopened:f("issue-reopened",60171),issues:f("issues",60172),italic:f("italic",60173),jersey:f("jersey",60174),json:f("json",60175),bracket:f("bracket",60175),kebabVertical:f("kebab-vertical",60176),key:f("key",60177),law:f("law",60178),lightbulbAutofix:f("lightbulb-autofix",60179),linkExternal:f("link-external",60180),link:f("link",60181),listOrdered:f("list-ordered",60182),listUnordered:f("list-unordered",60183),liveShare:f("live-share",60184),loading:f("loading",60185),location:f("location",60186),mailRead:f("mail-read",60187),mail:f("mail",60188),markdown:f("markdown",60189),megaphone:f("megaphone",60190),mention:f("mention",60191),milestone:f("milestone",60192),gitPullRequestMilestone:f("git-pull-request-milestone",60192),mortarBoard:f("mortar-board",60193),move:f("move",60194),multipleWindows:f("multiple-windows",60195),mute:f("mute",60196),noNewline:f("no-newline",60197),note:f("note",60198),octoface:f("octoface",60199),openPreview:f("open-preview",60200),package:f("package",60201),paintcan:f("paintcan",60202),pin:f("pin",60203),play:f("play",60204),run:f("run",60204),plug:f("plug",60205),preserveCase:f("preserve-case",60206),preview:f("preview",60207),project:f("project",60208),pulse:f("pulse",60209),question:f("question",60210),quote:f("quote",60211),radioTower:f("radio-tower",60212),reactions:f("reactions",60213),references:f("references",60214),refresh:f("refresh",60215),regex:f("regex",60216),remoteExplorer:f("remote-explorer",60217),remote:f("remote",60218),remove:f("remove",60219),replaceAll:f("replace-all",60220),replace:f("replace",60221),repoClone:f("repo-clone",60222),repoForcePush:f("repo-force-push",60223),repoPull:f("repo-pull",60224),repoPush:f("repo-push",60225),report:f("report",60226),requestChanges:f("request-changes",60227),rocket:f("rocket",60228),rootFolderOpened:f("root-folder-opened",60229),rootFolder:f("root-folder",60230),rss:f("rss",60231),ruby:f("ruby",60232),saveAll:f("save-all",60233),saveAs:f("save-as",60234),save:f("save",60235),screenFull:f("screen-full",60236),screenNormal:f("screen-normal",60237),searchStop:f("search-stop",60238),server:f("server",60240),settingsGear:f("settings-gear",60241),settings:f("settings",60242),shield:f("shield",60243),smiley:f("smiley",60244),sortPrecedence:f("sort-precedence",60245),splitHorizontal:f("split-horizontal",60246),splitVertical:f("split-vertical",60247),squirrel:f("squirrel",60248),starFull:f("star-full",60249),starHalf:f("star-half",60250),symbolClass:f("symbol-class",60251),symbolColor:f("symbol-color",60252),symbolCustomColor:f("symbol-customcolor",60252),symbolConstant:f("symbol-constant",60253),symbolEnumMember:f("symbol-enum-member",60254),symbolField:f("symbol-field",60255),symbolFile:f("symbol-file",60256),symbolInterface:f("symbol-interface",60257),symbolKeyword:f("symbol-keyword",60258),symbolMisc:f("symbol-misc",60259),symbolOperator:f("symbol-operator",60260),symbolProperty:f("symbol-property",60261),wrench:f("wrench",60261),wrenchSubaction:f("wrench-subaction",60261),symbolSnippet:f("symbol-snippet",60262),tasklist:f("tasklist",60263),telescope:f("telescope",60264),textSize:f("text-size",60265),threeBars:f("three-bars",60266),thumbsdown:f("thumbsdown",60267),thumbsup:f("thumbsup",60268),tools:f("tools",60269),triangleDown:f("triangle-down",60270),triangleLeft:f("triangle-left",60271),triangleRight:f("triangle-right",60272),triangleUp:f("triangle-up",60273),twitter:f("twitter",60274),unfold:f("unfold",60275),unlock:f("unlock",60276),unmute:f("unmute",60277),unverified:f("unverified",60278),verified:f("verified",60279),versions:f("versions",60280),vmActive:f("vm-active",60281),vmOutline:f("vm-outline",60282),vmRunning:f("vm-running",60283),watch:f("watch",60284),whitespace:f("whitespace",60285),wholeWord:f("whole-word",60286),window:f("window",60287),wordWrap:f("word-wrap",60288),zoomIn:f("zoom-in",60289),zoomOut:f("zoom-out",60290),listFilter:f("list-filter",60291),listFlat:f("list-flat",60292),listSelection:f("list-selection",60293),selection:f("selection",60293),listTree:f("list-tree",60294),debugBreakpointFunctionUnverified:f("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:f("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:f("debug-breakpoint-function-disabled",60296),debugStackframeActive:f("debug-stackframe-active",60297),circleSmallFilled:f("circle-small-filled",60298),debugStackframeDot:f("debug-stackframe-dot",60298),debugStackframe:f("debug-stackframe",60299),debugStackframeFocused:f("debug-stackframe-focused",60299),debugBreakpointUnsupported:f("debug-breakpoint-unsupported",60300),symbolString:f("symbol-string",60301),debugReverseContinue:f("debug-reverse-continue",60302),debugStepBack:f("debug-step-back",60303),debugRestartFrame:f("debug-restart-frame",60304),callIncoming:f("call-incoming",60306),callOutgoing:f("call-outgoing",60307),menu:f("menu",60308),expandAll:f("expand-all",60309),feedback:f("feedback",60310),gitPullRequestReviewer:f("git-pull-request-reviewer",60310),groupByRefType:f("group-by-ref-type",60311),ungroupByRefType:f("ungroup-by-ref-type",60312),account:f("account",60313),gitPullRequestAssignee:f("git-pull-request-assignee",60313),bellDot:f("bell-dot",60314),debugConsole:f("debug-console",60315),library:f("library",60316),output:f("output",60317),runAll:f("run-all",60318),syncIgnored:f("sync-ignored",60319),pinned:f("pinned",60320),githubInverted:f("github-inverted",60321),debugAlt:f("debug-alt",60305),serverProcess:f("server-process",60322),serverEnvironment:f("server-environment",60323),pass:f("pass",60324),stopCircle:f("stop-circle",60325),playCircle:f("play-circle",60326),record:f("record",60327),debugAltSmall:f("debug-alt-small",60328),vmConnect:f("vm-connect",60329),cloud:f("cloud",60330),merge:f("merge",60331),exportIcon:f("export",60332),graphLeft:f("graph-left",60333),magnet:f("magnet",60334),notebook:f("notebook",60335),redo:f("redo",60336),checkAll:f("check-all",60337),pinnedDirty:f("pinned-dirty",60338),passFilled:f("pass-filled",60339),circleLargeFilled:f("circle-large-filled",60340),circleLarge:f("circle-large",60341),circleLargeOutline:f("circle-large-outline",60341),combine:f("combine",60342),gather:f("gather",60342),table:f("table",60343),variableGroup:f("variable-group",60344),typeHierarchy:f("type-hierarchy",60345),typeHierarchySub:f("type-hierarchy-sub",60346),typeHierarchySuper:f("type-hierarchy-super",60347),gitPullRequestCreate:f("git-pull-request-create",60348),runAbove:f("run-above",60349),runBelow:f("run-below",60350),notebookTemplate:f("notebook-template",60351),debugRerun:f("debug-rerun",60352),workspaceTrusted:f("workspace-trusted",60353),workspaceUntrusted:f("workspace-untrusted",60354),workspaceUnspecified:f("workspace-unspecified",60355),terminalCmd:f("terminal-cmd",60356),terminalDebian:f("terminal-debian",60357),terminalLinux:f("terminal-linux",60358),terminalPowershell:f("terminal-powershell",60359),terminalTmux:f("terminal-tmux",60360),terminalUbuntu:f("terminal-ubuntu",60361),terminalBash:f("terminal-bash",60362),arrowSwap:f("arrow-swap",60363),copy:f("copy",60364),personAdd:f("person-add",60365),filterFilled:f("filter-filled",60366),wand:f("wand",60367),debugLineByLine:f("debug-line-by-line",60368),inspect:f("inspect",60369),layers:f("layers",60370),layersDot:f("layers-dot",60371),layersActive:f("layers-active",60372),compass:f("compass",60373),compassDot:f("compass-dot",60374),compassActive:f("compass-active",60375),azure:f("azure",60376),issueDraft:f("issue-draft",60377),gitPullRequestClosed:f("git-pull-request-closed",60378),gitPullRequestDraft:f("git-pull-request-draft",60379),debugAll:f("debug-all",60380),debugCoverage:f("debug-coverage",60381),runErrors:f("run-errors",60382),folderLibrary:f("folder-library",60383),debugContinueSmall:f("debug-continue-small",60384),beakerStop:f("beaker-stop",60385),graphLine:f("graph-line",60386),graphScatter:f("graph-scatter",60387),pieChart:f("pie-chart",60388),bracketDot:f("bracket-dot",60389),bracketError:f("bracket-error",60390),lockSmall:f("lock-small",60391),azureDevops:f("azure-devops",60392),verifiedFilled:f("verified-filled",60393),newLine:f("newline",60394),layout:f("layout",60395),layoutActivitybarLeft:f("layout-activitybar-left",60396),layoutActivitybarRight:f("layout-activitybar-right",60397),layoutPanelLeft:f("layout-panel-left",60398),layoutPanelCenter:f("layout-panel-center",60399),layoutPanelJustify:f("layout-panel-justify",60400),layoutPanelRight:f("layout-panel-right",60401),layoutPanel:f("layout-panel",60402),layoutSidebarLeft:f("layout-sidebar-left",60403),layoutSidebarRight:f("layout-sidebar-right",60404),layoutStatusbar:f("layout-statusbar",60405),layoutMenubar:f("layout-menubar",60406),layoutCentered:f("layout-centered",60407),layoutSidebarRightOff:f("layout-sidebar-right-off",60416),layoutPanelOff:f("layout-panel-off",60417),layoutSidebarLeftOff:f("layout-sidebar-left-off",60418),target:f("target",60408),indent:f("indent",60409),recordSmall:f("record-small",60410),errorSmall:f("error-small",60411),arrowCircleDown:f("arrow-circle-down",60412),arrowCircleLeft:f("arrow-circle-left",60413),arrowCircleRight:f("arrow-circle-right",60414),arrowCircleUp:f("arrow-circle-up",60415),heartFilled:f("heart-filled",60420),map:f("map",60421),mapFilled:f("map-filled",60422),circleSmall:f("circle-small",60423),bellSlash:f("bell-slash",60424),bellSlashDot:f("bell-slash-dot",60425),commentUnresolved:f("comment-unresolved",60426),gitPullRequestGoToChanges:f("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:f("git-pull-request-new-changes",60428),searchFuzzy:f("search-fuzzy",60429),commentDraft:f("comment-draft",60430),send:f("send",60431),sparkle:f("sparkle",60432),insert:f("insert",60433),mic:f("mic",60434),thumbsDownFilled:f("thumbsdown-filled",60435),thumbsUpFilled:f("thumbsup-filled",60436),coffee:f("coffee",60437),snake:f("snake",60438),game:f("game",60439),vr:f("vr",60440),chip:f("chip",60441),piano:f("piano",60442),music:f("music",60443),micFilled:f("mic-filled",60444),gitFetch:f("git-fetch",60445),copilot:f("copilot",60446),dialogError:f("dialog-error","error"),dialogWarning:f("dialog-warning","warning"),dialogInfo:f("dialog-info","info"),dialogClose:f("dialog-close","close"),treeItemExpanded:f("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:f("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:f("tree-filter-on-type-off","list-selection"),treeFilterClear:f("tree-filter-clear","close"),treeItemLoading:f("tree-item-loading","loading"),menuSelection:f("menu-selection","check"),menuSubmenu:f("menu-submenu","chevron-right"),menuBarMore:f("menubar-more","more"),scrollbarButtonLeft:f("scrollbar-button-left","triangle-left"),scrollbarButtonRight:f("scrollbar-button-right","triangle-right"),scrollbarButtonUp:f("scrollbar-button-up","triangle-up"),scrollbarButtonDown:f("scrollbar-button-down","triangle-down"),toolBarMore:f("toolbar-more","more"),quickInputBack:f("quick-input-back","arrow-left")}}),define(ke[24],Se([1,0,18]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=void 0;function F(s){if(!s||typeof s!="object"||s instanceof RegExp)return s;const i=Array.isArray(s)?[]:{};return Object.entries(s).forEach(([n,o])=>{i[n]=o&&typeof o=="object"?F(o):o}),i}e.$$m=F;function f(s){if(!s||typeof s!="object")return s;const i=[s];for(;i.length>0;){const n=i.shift();Object.freeze(n);for(const o in n)if(L.call(n,o)){const a=n[o];typeof a=="object"&&!Object.isFrozen(a)&&!(0,I.$Cf)(a)&&i.push(a)}}return s}e.$_m=f;const L=Object.prototype.hasOwnProperty;function R(s,i){return p(s,i,new Set)}e.$an=R;function p(s,i,n){if((0,I.$If)(s))return s;const o=i(s);if(typeof o<"u")return o;if(Array.isArray(s)){const a=[];for(const t of s)a.push(p(t,i,n));return a}if((0,I.$Bf)(s)){if(n.has(s))throw new Error("Cannot clone recursive data-structure");n.add(s);const a={};for(const t in s)L.call(s,t)&&(a[t]=p(s[t],i,n));return n.delete(s),a}return s}function E(s,i,n=!0){return(0,I.$Bf)(s)?((0,I.$Bf)(i)&&Object.keys(i).forEach(o=>{o in s?n&&((0,I.$Bf)(s[o])&&(0,I.$Bf)(i[o])?E(s[o],i[o],n):s[o]=i[o]):s[o]=i[o]}),s):i}e.$bn=E;function m(s,i){if(s===i)return!0;if(s==null||i===null||i===void 0||typeof s!=typeof i||typeof s!="object"||Array.isArray(s)!==Array.isArray(i))return!1;let n,o;if(Array.isArray(s)){if(s.length!==i.length)return!1;for(n=0;n<s.length;n++)if(!m(s[n],i[n]))return!1}else{const a=[];for(o in s)a.push(o);a.sort();const t=[];for(o in i)t.push(o);if(t.sort(),!m(a,t))return!1;for(n=0;n<a.length;n++)if(!m(s[a[n]],i[a[n]]))return!1}return!0}e.$cn=m;function A(s){const i=new Set;return JSON.stringify(s,(n,o)=>{if((0,I.$Bf)(o)||Array.isArray(o)){if(i.has(o))return"[Circular]";i.add(o)}return o})}e.$dn=A;function P(s,i){const n=Object.create(null);return!s||!i||Object.keys(i).forEach(a=>{const t=s[a],r=i[a];m(t,r)||(n[a]=r)}),n}e.$en=P;function g(s,i){const n=i.toLowerCase(),o=Object.keys(s).find(a=>a.toLowerCase()===n);return o?s[o]:s[i]}e.$fn=g;function y(s,i){const n=Object.create(null);for(const[o,a]of Object.entries(s))i(o,a)&&(n[o]=a);return n}e.$gn=y;function S(s){let i=[];for(;Object.prototype!==s;)i=i.concat(Object.getOwnPropertyNames(s)),s=Object.getPrototypeOf(s);return i}e.$hn=S;function w(s){const i=[];for(const n of S(s))typeof s[n]=="function"&&i.push(n);return i}e.$in=w;function c(s,i){const n=a=>function(){const t=Array.prototype.slice.call(arguments,0);return i(a,t)},o={};for(const a of s)o[a]=n(a);return o}e.$jn=c}),define(ke[61],Se([1,0,79]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Zj=e.ThemeColor=void 0;var F;(function(R){function p(E){return E&&typeof E=="object"&&typeof E.id=="string"}R.isThemeColor=p})(F||(e.ThemeColor=F={}));function f(R){return{id:R}}e.$Zj=f;var L;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const p=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function E(i){const n=p.exec(i.id);if(!n)return E(I.$Yj.error);const[,o,a]=n,t=["codicon","codicon-"+o];return a&&t.push("codicon-modifier-"+a.substring(1)),t}R.asClassNameArray=E;function m(i){return E(i).join(" ")}R.asClassName=m;function A(i){return"."+E(i).join(".")}R.asCSSSelector=A;function P(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||F.isThemeColor(i.color))}R.isThemeIcon=P;const g=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function y(i){const n=g.exec(i);if(!n)return;const[,o]=n;return{id:o}}R.fromString=y;function S(i){return{id:i}}R.fromId=S;function w(i,n){let o=i.id;const a=o.lastIndexOf("~");return a!==-1&&(o=o.substring(0,a)),n&&(o=`${o}~${n}`),{id:o}}R.modify=w;function c(i){const n=i.id.lastIndexOf("~");if(n!==-1)return i.id.substring(n+1)}R.getModifier=c;function s(i,n){return i.id===n.id&&i.color?.id===n.color?.id}R.isEqual=s})(L||(e.ThemeIcon=L={}))}),define(ke[164],Se([1,0,124,13,61]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6j=e.$5j=e.$4j=e.$3j=e.$2j=e.$1j=void 0;const L="$(",R=new RegExp(`\\$\\(${f.ThemeIcon.iconNameExpression}(?:${f.ThemeIcon.iconModifierExpression})?\\)`,"g"),p=new RegExp(`(\\\\)?${R.source}`,"g");function E(s){return s.replace(p,(i,n)=>n?i:`\\${i}`)}e.$1j=E;const m=new RegExp(`\\\\${R.source}`,"g");function A(s){return s.replace(m,i=>`\\${i}`)}e.$2j=A;const P=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function g(s){return s.indexOf(L)===-1?s:s.replace(P,(i,n,o,a)=>o?i:n||a||"")}e.$3j=g;function y(s){return s?s.replace(/\$\((.*?)\)/g,(i,n)=>` ${n} `).trim():""}e.$4j=y;const S=new RegExp(`\\$\\(${f.ThemeIcon.iconNameCharacter}+\\)`,"g");function w(s){S.lastIndex=0;let i="";const n=[];let o=0;for(;;){const a=S.lastIndex,t=S.exec(s),r=s.substring(a,t?.index);if(r.length>0){i+=r;for(let d=0;d<r.length;d++)n.push(o)}if(!t)break;o+=t[0].length}return{text:i,iconOffsets:n}}e.$5j=w;function c(s,i,n=!1){const{text:o,iconOffsets:a}=i;if(!a||a.length===0)return(0,I.$Nj)(s,o,n);const t=(0,F.$Ke)(o," "),r=o.length-t.length,d=(0,I.$Nj)(s,t,n);if(d)for(const u of d){const l=a[u.start+r]+r;u.start+=l,u.end+=l}return d}e.$6j=c}),define(ke[125],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Be=e.$Ae=e.Constants=void 0;var I;(function(L){L[L.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",L[L.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",L[L.MAX_UINT_8=255]="MAX_UINT_8",L[L.MAX_UINT_16=65535]="MAX_UINT_16",L[L.MAX_UINT_32=4294967295]="MAX_UINT_32",L[L.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(I||(e.Constants=I={}));function F(L){return L<0?0:L>255?255:L|0}e.$Ae=F;function f(L){return L<0?0:L>4294967295?4294967295:L|0}e.$Be=f}),define(ke[32],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fg=e.$eg=void 0;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function F(f){return I.test(f)}e.$eg=F,e.$fg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let f;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?f=crypto.getRandomValues.bind(crypto):f=function(p){for(let E=0;E<p.length;E++)p[E]=Math.floor(Math.random()*256);return p};const L=new Uint8Array(16),R=[];for(let p=0;p<256;p++)R.push(p.toString(16).padStart(2,"0"));return function(){f(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let E=0,m="";return m+=R[L[E++]],m+=R[L[E++]],m+=R[L[E++]],m+=R[L[E++]],m+="-",m+=R[L[E++]],m+=R[L[E++]],m+="-",m+=R[L[E++]],m+=R[L[E++]],m+="-",m+=R[L[E++]],m+=R[L[E++]],m+="-",m+=R[L[E++]],m+=R[L[E++]],m+=R[L[E++]],m+=R[L[E++]],m+=R[L[E++]],m+=R[L[E++]],m}}()}),define(ke[165],Se([1,0,19,51,32]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7s=e.$6s=e.$5s=e.$4s=e.$3s=void 0;function L(P){return{asString:async()=>P,asFile:()=>{},value:typeof P=="string"?P:void 0}}e.$3s=L;function R(P,g,y){const S={id:(0,f.$fg)(),name:P,uri:g,data:y};return{asString:async()=>"",asFile:()=>S,value:void 0}}e.$4s=R;class p{constructor(){this.a=new Map}get size(){let g=0;for(const y of this.a)g++;return g}has(g){return this.a.has(this.b(g))}matches(g){const y=[...this.a.keys()];return F.Iterable.some(this,([S,w])=>w.asFile())&&y.push("files"),A(E(g),y)}get(g){return this.a.get(this.b(g))?.[0]}append(g,y){const S=this.a.get(g);S?S.push(y):this.a.set(this.b(g),[y])}replace(g,y){this.a.set(this.b(g),[y])}delete(g){this.a.delete(this.b(g))}*[Symbol.iterator](){for(const[g,y]of this.a)for(const S of y)yield[g,S]}b(g){return E(g)}}e.$5s=p;function E(P){return P.toLowerCase()}function m(P,g){return A(E(P),g.map(E))}e.$6s=m;function A(P,g){if(P==="*/*")return g.length>0;if(g.includes(P))return!0;const y=P.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!y)return!1;const[S,w,c]=y;return c==="*"?g.some(s=>s.startsWith(w+"/")):!1}e.$7s=Object.freeze({create:P=>(0,I.$Lb)(P.map(g=>g.toString())).join(`\r
`),split:P=>P.split(`\r
`),parse:P=>e.$7s.split(P).filter(g=>!g.startsWith("#"))})}),define(ke[166],Se([1,0,62]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jg=e.$ig=e.$hg=void 0;function F(p,E,m,A=1){let P=!1;return new Promise(g=>{const y=setTimeout(()=>{if(!P)return P=!0,g(0)},m);f(p,E,A,S=>{if(!P)return P=!0,clearTimeout(y),g(S)})})}e.$hg=F;function f(p,E,m,A){if(E===0)return A(0);const P=new I.Socket;P.once("connect",()=>(R(P),f(p+m,E-1,m,A))),P.once("data",()=>{}),P.once("error",g=>(R(P),g.code!=="ECONNREFUSED"?f(p+m,E-1,m,A):A(p))),P.connect(p,"127.0.0.1")}e.$ig={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function L(p,E,m,A="127.0.0.1"){let P=!1,g,y=1;const S=I.createServer({pauseOnConnect:!0});function w(c,s){P||(P=!0,S.removeAllListeners(),S.close(),g&&clearTimeout(g),s(c))}return new Promise(c=>{g=setTimeout(()=>{w(0,c)},m),S.on("listening",()=>{w(p,c)}),S.on("error",s=>{s&&(s.code==="EADDRINUSE"||s.code==="EACCES")&&y<E?(p++,y++,S.listen(p,A)):w(0,c)}),S.on("close",()=>{w(0,c)}),S.listen(p,A)})}e.$jg=L;function R(p){try{p.removeAllListeners("connect"),p.removeAllListeners("error"),p.end(),p.destroy(),p.unref()}catch(E){console.error(E)}}}),define(ke[126],Se([1,0,125]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vs=e.$Us=void 0;class F{constructor(p){const E=(0,I.$Ae)(p);this.c=E,this.a=F.d(E),this.b=new Map}static d(p){const E=new Uint8Array(256);return E.fill(p),E}set(p,E){const m=(0,I.$Ae)(E);p>=0&&p<256?this.a[p]=m:this.b.set(p,m)}get(p){return p>=0&&p<256?this.a[p]:this.b.get(p)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$Us=F;var f;(function(R){R[R.False=0]="False",R[R.True=1]="True"})(f||(f={}));class L{constructor(){this.a=new F(0)}add(p){this.a.set(p,1)}has(p){return this.a.get(p)===1}clear(){return this.a.clear()}}e.$Vs=L}),define(ke[167],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0s=e.StringEOL=void 0;var I;(function(f){f[f.Unknown=0]="Unknown",f[f.Invalid=3]="Invalid",f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(I||(e.StringEOL=I={}));function F(f){let L=0,R=0,p=0,E=0;for(let m=0,A=f.length;m<A;m++){const P=f.charCodeAt(m);P===13?(L===0&&(R=m),L++,m+1<A&&f.charCodeAt(m+1)===10?(E|=2,m++):E|=3,p=m+1):P===10&&(E|=1,L===0&&(R=m),L++,p=m+1)}return L===0&&(R=f.length),[L,R,f.length-p,E]}e.$0s=F}),define(ke[53],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ws=void 0;class I{constructor(f,L){this.lineNumber=f,this.column=L}with(f=this.lineNumber,L=this.column){return f===this.lineNumber&&L===this.column?this:new I(f,L)}delta(f=0,L=0){return this.with(this.lineNumber+f,this.column+L)}equals(f){return I.equals(this,f)}static equals(f,L){return!f&&!L?!0:!!f&&!!L&&f.lineNumber===L.lineNumber&&f.column===L.column}isBefore(f){return I.isBefore(this,f)}static isBefore(f,L){return f.lineNumber<L.lineNumber?!0:L.lineNumber<f.lineNumber?!1:f.column<L.column}isBeforeOrEqual(f){return I.isBeforeOrEqual(this,f)}static isBeforeOrEqual(f,L){return f.lineNumber<L.lineNumber?!0:L.lineNumber<f.lineNumber?!1:f.column<=L.column}static compare(f,L){const R=f.lineNumber|0,p=L.lineNumber|0;if(R===p){const E=f.column|0,m=L.column|0;return E-m}return R-p}clone(){return new I(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(f){return new I(f.lineNumber,f.column)}static isIPosition(f){return f&&typeof f.lineNumber=="number"&&typeof f.column=="number"}}e.$ws=I}),define(ke[29],Se([1,0,53]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xs=void 0;class F{constructor(L,R,p,E){L>p||L===p&&R>E?(this.startLineNumber=p,this.startColumn=E,this.endLineNumber=L,this.endColumn=R):(this.startLineNumber=L,this.startColumn=R,this.endLineNumber=p,this.endColumn=E)}isEmpty(){return F.isEmpty(this)}static isEmpty(L){return L.startLineNumber===L.endLineNumber&&L.startColumn===L.endColumn}containsPosition(L){return F.containsPosition(this,L)}static containsPosition(L,R){return!(R.lineNumber<L.startLineNumber||R.lineNumber>L.endLineNumber||R.lineNumber===L.startLineNumber&&R.column<L.startColumn||R.lineNumber===L.endLineNumber&&R.column>L.endColumn)}static strictContainsPosition(L,R){return!(R.lineNumber<L.startLineNumber||R.lineNumber>L.endLineNumber||R.lineNumber===L.startLineNumber&&R.column<=L.startColumn||R.lineNumber===L.endLineNumber&&R.column>=L.endColumn)}containsRange(L){return F.containsRange(this,L)}static containsRange(L,R){return!(R.startLineNumber<L.startLineNumber||R.endLineNumber<L.startLineNumber||R.startLineNumber>L.endLineNumber||R.endLineNumber>L.endLineNumber||R.startLineNumber===L.startLineNumber&&R.startColumn<L.startColumn||R.endLineNumber===L.endLineNumber&&R.endColumn>L.endColumn)}strictContainsRange(L){return F.strictContainsRange(this,L)}static strictContainsRange(L,R){return!(R.startLineNumber<L.startLineNumber||R.endLineNumber<L.startLineNumber||R.startLineNumber>L.endLineNumber||R.endLineNumber>L.endLineNumber||R.startLineNumber===L.startLineNumber&&R.startColumn<=L.startColumn||R.endLineNumber===L.endLineNumber&&R.endColumn>=L.endColumn)}plusRange(L){return F.plusRange(this,L)}static plusRange(L,R){let p,E,m,A;return R.startLineNumber<L.startLineNumber?(p=R.startLineNumber,E=R.startColumn):R.startLineNumber===L.startLineNumber?(p=R.startLineNumber,E=Math.min(R.startColumn,L.startColumn)):(p=L.startLineNumber,E=L.startColumn),R.endLineNumber>L.endLineNumber?(m=R.endLineNumber,A=R.endColumn):R.endLineNumber===L.endLineNumber?(m=R.endLineNumber,A=Math.max(R.endColumn,L.endColumn)):(m=L.endLineNumber,A=L.endColumn),new F(p,E,m,A)}intersectRanges(L){return F.intersectRanges(this,L)}static intersectRanges(L,R){let p=L.startLineNumber,E=L.startColumn,m=L.endLineNumber,A=L.endColumn;const P=R.startLineNumber,g=R.startColumn,y=R.endLineNumber,S=R.endColumn;return p<P?(p=P,E=g):p===P&&(E=Math.max(E,g)),m>y?(m=y,A=S):m===y&&(A=Math.min(A,S)),p>m||p===m&&E>A?null:new F(p,E,m,A)}equalsRange(L){return F.equalsRange(this,L)}static equalsRange(L,R){return!L&&!R?!0:!!L&&!!R&&L.startLineNumber===R.startLineNumber&&L.startColumn===R.startColumn&&L.endLineNumber===R.endLineNumber&&L.endColumn===R.endColumn}getEndPosition(){return F.getEndPosition(this)}static getEndPosition(L){return new I.$ws(L.endLineNumber,L.endColumn)}getStartPosition(){return F.getStartPosition(this)}static getStartPosition(L){return new I.$ws(L.startLineNumber,L.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(L,R){return new F(this.startLineNumber,this.startColumn,L,R)}setStartPosition(L,R){return new F(L,R,this.endLineNumber,this.endColumn)}collapseToStart(){return F.collapseToStart(this)}static collapseToStart(L){return new F(L.startLineNumber,L.startColumn,L.startLineNumber,L.startColumn)}collapseToEnd(){return F.collapseToEnd(this)}static collapseToEnd(L){return new F(L.endLineNumber,L.endColumn,L.endLineNumber,L.endColumn)}delta(L){return new F(this.startLineNumber+L,this.startColumn,this.endLineNumber+L,this.endColumn)}static fromPositions(L,R=L){return new F(L.lineNumber,L.column,R.lineNumber,R.column)}static lift(L){return L?new F(L.startLineNumber,L.startColumn,L.endLineNumber,L.endColumn):null}static isIRange(L){return L&&typeof L.startLineNumber=="number"&&typeof L.startColumn=="number"&&typeof L.endLineNumber=="number"&&typeof L.endColumn=="number"}static areIntersectingOrTouching(L,R){return!(L.endLineNumber<R.startLineNumber||L.endLineNumber===R.startLineNumber&&L.endColumn<R.startColumn||R.endLineNumber<L.startLineNumber||R.endLineNumber===L.startLineNumber&&R.endColumn<L.startColumn)}static areIntersecting(L,R){return!(L.endLineNumber<R.startLineNumber||L.endLineNumber===R.startLineNumber&&L.endColumn<=R.startColumn||R.endLineNumber<L.startLineNumber||R.endLineNumber===L.startLineNumber&&R.endColumn<=L.startColumn)}static compareRangesUsingStarts(L,R){if(L&&R){const m=L.startLineNumber|0,A=R.startLineNumber|0;if(m===A){const P=L.startColumn|0,g=R.startColumn|0;if(P===g){const y=L.endLineNumber|0,S=R.endLineNumber|0;if(y===S){const w=L.endColumn|0,c=R.endColumn|0;return w-c}return y-S}return P-g}return m-A}return(L?1:0)-(R?1:0)}static compareRangesUsingEnds(L,R){return L.endLineNumber===R.endLineNumber?L.endColumn===R.endColumn?L.startLineNumber===R.startLineNumber?L.startColumn-R.startColumn:L.startLineNumber-R.startLineNumber:L.endColumn-R.endColumn:L.endLineNumber-R.endLineNumber}static spansMultipleLines(L){return L.endLineNumber>L.startLineNumber}toJSON(){return this}}e.$xs=F}),define(ke[168],Se([1,0,29]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ys=void 0;class F{static insert(L,R){return{range:new I.$xs(L.lineNumber,L.column,L.lineNumber,L.column),text:R,forceMoveMarkers:!0}}static delete(L){return{range:L,text:null}}static replace(L,R){return{range:L,text:R}}static replaceMove(L,R){return{range:L,text:R,forceMoveMarkers:!0}}}e.$ys=F}),define(ke[169],Se([1,0,53,29]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zs=e.SelectionDirection=void 0;var f;(function(R){R[R.LTR=0]="LTR",R[R.RTL=1]="RTL"})(f||(e.SelectionDirection=f={}));class L extends F.$xs{constructor(p,E,m,A){super(p,E,m,A),this.selectionStartLineNumber=p,this.selectionStartColumn=E,this.positionLineNumber=m,this.positionColumn=A}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(p){return L.selectionsEqual(this,p)}static selectionsEqual(p,E){return p.selectionStartLineNumber===E.selectionStartLineNumber&&p.selectionStartColumn===E.selectionStartColumn&&p.positionLineNumber===E.positionLineNumber&&p.positionColumn===E.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(p,E){return this.getDirection()===0?new L(this.startLineNumber,this.startColumn,p,E):new L(p,E,this.startLineNumber,this.startColumn)}getPosition(){return new I.$ws(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new I.$ws(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(p,E){return this.getDirection()===0?new L(p,E,this.endLineNumber,this.endColumn):new L(this.endLineNumber,this.endColumn,p,E)}static fromPositions(p,E=p){return new L(p.lineNumber,p.column,E.lineNumber,E.column)}static fromRange(p,E){return E===0?new L(p.startLineNumber,p.startColumn,p.endLineNumber,p.endColumn):new L(p.endLineNumber,p.endColumn,p.startLineNumber,p.startColumn)}static liftSelection(p){return new L(p.selectionStartLineNumber,p.selectionStartColumn,p.positionLineNumber,p.positionColumn)}static selectionsArrEqual(p,E){if(p&&!E||!p&&E)return!1;if(!p&&!E)return!0;if(p.length!==E.length)return!1;for(let m=0,A=p.length;m<A;m++)if(!this.selectionsEqual(p[m],E[m]))return!1;return!0}static isISelection(p){return p&&typeof p.selectionStartLineNumber=="number"&&typeof p.selectionStartColumn=="number"&&typeof p.positionLineNumber=="number"&&typeof p.positionColumn=="number"}static createWithDirection(p,E,m,A,P){return P===0?new L(p,E,m,A):new L(m,A,p,E)}}e.$zs=L}),define(ke[170],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7r=void 0,e.$7r={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ke[171],Se([1,0,126]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xs=e.$Ws=e.WordCharacterClass=void 0;var F;(function(R){R[R.Regular=0]="Regular",R[R.Whitespace=1]="Whitespace",R[R.WordSeparator=2]="WordSeparator"})(F||(e.WordCharacterClass=F={}));class f extends I.$Us{constructor(p){super(0);for(let E=0,m=p.length;E<m;E++)this.set(p.charCodeAt(E),2);this.set(32,1),this.set(9,1)}}e.$Ws=f;function L(R){const p={};return E=>(p.hasOwnProperty(E)||(p[E]=R(E)),p[E])}e.$Xs=L(R=>new f(R))}),define(ke[127],Se([1,0,51,3,76]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_r=e.$$r=e.$0r=e.$9r=e.$8r=void 0,e.$8r="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function L(P=""){let g="(-?\\d*\\.\\d\\w*)|([^";for(const y of e.$8r)P.indexOf(y)>=0||(g+="\\"+y);return g+="\\s]+)",new RegExp(g,"g")}e.$9r=L();function R(P){let g=e.$9r;if(P&&P instanceof RegExp)if(P.global)g=P;else{let y="g";P.ignoreCase&&(y+="i"),P.multiline&&(y+="m"),P.unicode&&(y+="u"),g=new RegExp(P.source,y)}return g.lastIndex=0,g}e.$0r=R;const p=new f.$1c;p.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function E(P){const g=p.unshift(P);return(0,F.$Pc)(g)}e.$$r=E;function m(P,g,y,S,w){if(w||(w=I.Iterable.first(p)),y.length>w.maxLen){let o=P-w.maxLen/2;return o<0?o=0:S+=o,y=y.substring(o,P+w.maxLen/2),m(P,g,y,S,w)}const c=Date.now(),s=P-1-S;let i=-1,n=null;for(let o=1;!(Date.now()-c>=w.timeBudget);o++){const a=s-w.windowSize*o;g.lastIndex=Math.max(0,a);const t=A(g,y,s,i);if(!t&&n||(n=t,a<=0))break;i=a}if(n){const o={word:n[0],startColumn:S+1+n.index,endColumn:S+1+n.index+n[0].length};return g.lastIndex=0,o}return null}e.$_r=m;function A(P,g,y,S){let w;for(;w=P.exec(g);){const c=w.index||0;if(c<=y&&P.lastIndex>=y)return w;if(S>0&&c>S)return null}return null}}),define(ke[172],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ut=e.$tt=e.IndentAction=void 0;var I;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(I||(e.IndentAction=I={}));class F{constructor(p){if(this.e=null,this.f=!1,this.open=p.open,this.close=p.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(p.notIn))for(let E=0,m=p.notIn.length;E<m;E++)switch(p.notIn[E]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(p){switch(p){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(p,E){if(p.getTokenCount()===0)return!0;const m=p.findTokenIndexAtOffset(E-2),A=p.getStandardTokenType(m);return this.isOK(A)}g(p,E){for(let m=p;m<=E;m++){const A=String.fromCharCode(m);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$tt=F;class f{constructor(p){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const E of p)L(this.autoClosingPairsOpenByStart,E.open.charAt(0),E),L(this.autoClosingPairsOpenByEnd,E.open.charAt(E.open.length-1),E),L(this.autoClosingPairsCloseByStart,E.close.charAt(0),E),L(this.autoClosingPairsCloseByEnd,E.close.charAt(E.close.length-1),E),E.close.length===1&&E.open.length===1&&L(this.autoClosingPairsCloseSingleChar,E.close,E)}}e.$ut=f;function L(R,p,E){R.has(p)?R.get(p).push(E):R.set(p,[E])}}),define(ke[173],Se([1,0,126]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AZ=e.$zZ=e.$yZ=e.State=void 0;var F;(function(y){y[y.Invalid=0]="Invalid",y[y.Start=1]="Start",y[y.H=2]="H",y[y.HT=3]="HT",y[y.HTT=4]="HTT",y[y.HTTP=5]="HTTP",y[y.F=6]="F",y[y.FI=7]="FI",y[y.FIL=8]="FIL",y[y.BeforeColon=9]="BeforeColon",y[y.AfterColon=10]="AfterColon",y[y.AlmostThere=11]="AlmostThere",y[y.End=12]="End",y[y.Accept=13]="Accept",y[y.LastKnownState=14]="LastKnownState"})(F||(e.State=F={}));class f{constructor(S,w,c){const s=new Uint8Array(S*w);for(let i=0,n=S*w;i<n;i++)s[i]=c;this.a=s,this.rows=S,this.cols=w}get(S,w){return this.a[S*this.cols+w]}set(S,w,c){this.a[S*this.cols+w]=c}}class L{constructor(S){let w=0,c=0;for(let i=0,n=S.length;i<n;i++){const[o,a,t]=S[i];a>w&&(w=a),o>c&&(c=o),t>c&&(c=t)}w++,c++;const s=new f(c,w,0);for(let i=0,n=S.length;i<n;i++){const[o,a,t]=S[i];s.set(o,a,t)}this.a=s,this.b=w}nextState(S,w){return w<0||w>=this.b?0:this.a.get(S,w)}}e.$yZ=L;let R=null;function p(){return R===null&&(R=new L([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),R}var E;(function(y){y[y.None=0]="None",y[y.ForceTermination=1]="ForceTermination",y[y.CannotEndIn=2]="CannotEndIn"})(E||(E={}));let m=null;function A(){if(m===null){m=new I.$Us(0);const y=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let w=0;w<y.length;w++)m.set(y.charCodeAt(w),1);const S=".,;:";for(let w=0;w<S.length;w++)m.set(S.charCodeAt(w),2)}return m}class P{static a(S,w,c,s,i){let n=i-1;do{const o=w.charCodeAt(n);if(S.get(o)!==2)break;n--}while(n>s);if(s>0){const o=w.charCodeAt(s-1),a=w.charCodeAt(n);(o===40&&a===41||o===91&&a===93||o===123&&a===125)&&n--}return{range:{startLineNumber:c,startColumn:s+1,endLineNumber:c,endColumn:n+2},url:w.substring(s,n+1)}}static computeLinks(S,w=p()){const c=A(),s=[];for(let i=1,n=S.getLineCount();i<=n;i++){const o=S.getLineContent(i),a=o.length;let t=0,r=0,d=0,u=1,l=!1,h=!1,k=!1,D=!1;for(;t<a;){let $=!1;const b=o.charCodeAt(t);if(u===13){let v;switch(b){case 40:l=!0,v=0;break;case 41:v=l?0:1;break;case 91:k=!0,h=!0,v=0;break;case 93:k=!1,v=h?0:1;break;case 123:D=!0,v=0;break;case 125:v=D?0:1;break;case 39:case 34:case 96:d===b?v=1:d===39||d===34||d===96?v=0:v=1;break;case 42:v=d===42?1:0;break;case 124:v=d===124?1:0;break;case 32:v=k?0:1;break;default:v=c.get(b)}v===1&&(s.push(P.a(c,o,i,r,t)),$=!0)}else if(u===12){let v;b===91?(h=!0,v=0):v=c.get(b),v===1?$=!0:u=13}else u=w.nextState(u,b),u===0&&($=!0);$&&(u=1,l=!1,h=!1,D=!1,r=t+1,d=b),t++}u===13&&s.push(P.a(c,o,i,r,a))}return s}}e.$zZ=P;function g(y){return!y||typeof y.getLineCount!="function"||typeof y.getLineContent!="function"?[]:P.computeLinks(y)}e.$AZ=g}),define(ke[80],Se([1,0,24]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tu=e.$Su=e.$Ru=e.$Qu=e.ModelConstants=e.PositionAffinity=e.$Pu=e.TrackedRangeStickiness=e.$Ou=e.$Nu=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var F;(function(o){o[o.Left=1]="Left",o[o.Center=2]="Center",o[o.Right=4]="Right",o[o.Full=7]="Full"})(F||(e.OverviewRulerLane=F={}));var f;(function(o){o[o.Left=1]="Left",o[o.Right=2]="Right"})(f||(e.GlyphMarginLane=f={}));var L;(function(o){o[o.Inline=1]="Inline",o[o.Gutter=2]="Gutter"})(L||(e.MinimapPosition=L={}));var R;(function(o){o[o.Both=0]="Both",o[o.Right=1]="Right",o[o.Left=2]="Left",o[o.None=3]="None"})(R||(e.InjectedTextCursorStops=R={}));var p;(function(o){o[o.TextDefined=0]="TextDefined",o[o.LF=1]="LF",o[o.CRLF=2]="CRLF"})(p||(e.EndOfLinePreference=p={}));var E;(function(o){o[o.LF=1]="LF",o[o.CRLF=2]="CRLF"})(E||(e.DefaultEndOfLine=E={}));var m;(function(o){o[o.LF=0]="LF",o[o.CRLF=1]="CRLF"})(m||(e.EndOfLineSequence=m={}));class A{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(a){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,a.tabSize|0),a.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,a.indentSize|0),this.a=!1),this.insertSpaces=!!a.insertSpaces,this.defaultEOL=a.defaultEOL|0,this.trimAutoWhitespace=!!a.trimAutoWhitespace,this.bracketPairColorizationOptions=a.bracketPairColorizationOptions}equals(a){return this.tabSize===a.tabSize&&this.a===a.a&&this.indentSize===a.indentSize&&this.insertSpaces===a.insertSpaces&&this.defaultEOL===a.defaultEOL&&this.trimAutoWhitespace===a.trimAutoWhitespace&&(0,I.$cn)(this.bracketPairColorizationOptions,a.bracketPairColorizationOptions)}createChangeEvent(a){return{tabSize:this.tabSize!==a.tabSize,indentSize:this.indentSize!==a.indentSize,insertSpaces:this.insertSpaces!==a.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==a.trimAutoWhitespace}}}e.$Nu=A;class P{constructor(a,t){this._findMatchBrand=void 0,this.range=a,this.matches=t}}e.$Ou=P;var g;(function(o){o[o.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",o[o.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",o[o.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",o[o.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(g||(e.TrackedRangeStickiness=g={}));function y(o){return o&&typeof o.read=="function"}e.$Pu=y;var S;(function(o){o[o.Left=0]="Left",o[o.Right=1]="Right",o[o.None=2]="None",o[o.LeftOfInjectedText=3]="LeftOfInjectedText",o[o.RightOfInjectedText=4]="RightOfInjectedText"})(S||(e.PositionAffinity=S={}));var w;(function(o){o[o.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(w||(e.ModelConstants=w={}));class c{constructor(a,t,r,d,u,l){this.identifier=a,this.range=t,this.text=r,this.forceMoveMarkers=d,this.isAutoWhitespaceEdit=u,this._isTracked=l}}e.$Qu=c;class s{constructor(a,t,r){this.regex=a,this.wordSeparators=t,this.simpleSearch=r}}e.$Ru=s;class i{constructor(a,t,r){this.reverseEdits=a,this.changes=t,this.trimAutoWhitespaceLineNumbers=r}}e.$Su=i;function n(o){return!o.isTooLargeForSyncing()&&!o.isForSimpleWidget}e.$Tu=n}),define(ke[174],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xB=e.$wB=e.$vB=e.$uB=e.$tB=e.$sB=e.$rB=e.$qB=e.$pB=e.NodeColor=e.$oB=void 0;class I{constructor(c,s){this.piece=c,this.color=s,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$pB)return f(this.right);let c=this;for(;c.parent!==e.$pB&&c.parent.left!==c;)c=c.parent;return c.parent===e.$pB?e.$pB:c.parent}prev(){if(this.left!==e.$pB)return L(this.left);let c=this;for(;c.parent!==e.$pB&&c.parent.right!==c;)c=c.parent;return c.parent===e.$pB?e.$pB:c.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$oB=I;var F;(function(w){w[w.Black=0]="Black",w[w.Red=1]="Red"})(F||(e.NodeColor=F={})),e.$pB=new I(null,0),e.$pB.parent=e.$pB,e.$pB.left=e.$pB,e.$pB.right=e.$pB,e.$pB.color=0;function f(w){for(;w.left!==e.$pB;)w=w.left;return w}e.$qB=f;function L(w){for(;w.right!==e.$pB;)w=w.right;return w}e.$rB=L;function R(w){return w===e.$pB?0:w.size_left+w.piece.length+R(w.right)}function p(w){return w===e.$pB?0:w.lf_left+w.piece.lineFeedCnt+p(w.right)}function E(){e.$pB.parent=e.$pB}function m(w,c){const s=c.right;s.size_left+=c.size_left+(c.piece?c.piece.length:0),s.lf_left+=c.lf_left+(c.piece?c.piece.lineFeedCnt:0),c.right=s.left,s.left!==e.$pB&&(s.left.parent=c),s.parent=c.parent,c.parent===e.$pB?w.root=s:c.parent.left===c?c.parent.left=s:c.parent.right=s,s.left=c,c.parent=s}e.$sB=m;function A(w,c){const s=c.left;c.left=s.right,s.right!==e.$pB&&(s.right.parent=c),s.parent=c.parent,c.size_left-=s.size_left+(s.piece?s.piece.length:0),c.lf_left-=s.lf_left+(s.piece?s.piece.lineFeedCnt:0),c.parent===e.$pB?w.root=s:c===c.parent.right?c.parent.right=s:c.parent.left=s,s.right=c,c.parent=s}e.$tB=A;function P(w,c){let s,i;if(c.left===e.$pB?(i=c,s=i.right):c.right===e.$pB?(i=c,s=i.left):(i=f(c.right),s=i.right),i===w.root){w.root=s,s.color=0,c.detach(),E(),w.root.parent=e.$pB;return}const n=i.color===1;if(i===i.parent.left?i.parent.left=s:i.parent.right=s,i===c?(s.parent=i.parent,S(w,s)):(i.parent===c?s.parent=i:s.parent=i.parent,S(w,s),i.left=c.left,i.right=c.right,i.parent=c.parent,i.color=c.color,c===w.root?w.root=i:c===c.parent.left?c.parent.left=i:c.parent.right=i,i.left!==e.$pB&&(i.left.parent=i),i.right!==e.$pB&&(i.right.parent=i),i.size_left=c.size_left,i.lf_left=c.lf_left,S(w,i)),c.detach(),s.parent.left===s){const a=R(s),t=p(s);if(a!==s.parent.size_left||t!==s.parent.lf_left){const r=a-s.parent.size_left,d=t-s.parent.lf_left;s.parent.size_left=a,s.parent.lf_left=t,y(w,s.parent,r,d)}}if(S(w,s.parent),n){E();return}let o;for(;s!==w.root&&s.color===0;)s===s.parent.left?(o=s.parent.right,o.color===1&&(o.color=0,s.parent.color=1,m(w,s.parent),o=s.parent.right),o.left.color===0&&o.right.color===0?(o.color=1,s=s.parent):(o.right.color===0&&(o.left.color=0,o.color=1,A(w,o),o=s.parent.right),o.color=s.parent.color,s.parent.color=0,o.right.color=0,m(w,s.parent),s=w.root)):(o=s.parent.left,o.color===1&&(o.color=0,s.parent.color=1,A(w,s.parent),o=s.parent.left),o.left.color===0&&o.right.color===0?(o.color=1,s=s.parent):(o.left.color===0&&(o.right.color=0,o.color=1,m(w,o),o=s.parent.left),o.color=s.parent.color,s.parent.color=0,o.left.color=0,A(w,s.parent),s=w.root));s.color=0,E()}e.$uB=P;function g(w,c){for(S(w,c);c!==w.root&&c.parent.color===1;)if(c.parent===c.parent.parent.left){const s=c.parent.parent.right;s.color===1?(c.parent.color=0,s.color=0,c.parent.parent.color=1,c=c.parent.parent):(c===c.parent.right&&(c=c.parent,m(w,c)),c.parent.color=0,c.parent.parent.color=1,A(w,c.parent.parent))}else{const s=c.parent.parent.left;s.color===1?(c.parent.color=0,s.color=0,c.parent.parent.color=1,c=c.parent.parent):(c===c.parent.left&&(c=c.parent,A(w,c)),c.parent.color=0,c.parent.parent.color=1,m(w,c.parent.parent))}w.root.color=0}e.$vB=g;function y(w,c,s,i){for(;c!==w.root&&c!==e.$pB;)c.parent.left===c&&(c.parent.size_left+=s,c.parent.lf_left+=i),c=c.parent}e.$wB=y;function S(w,c){let s=0,i=0;if(c!==w.root){for(;c!==w.root&&c===c.parent.right;)c=c.parent;if(c!==w.root)for(c=c.parent,s=R(c.left)-c.size_left,i=p(c.left)-c.lf_left,c.size_left+=s,c.lf_left+=i;c!==w.root&&(s!==0||i!==0);)c.parent.left===c&&(c.parent.size_left+=s,c.parent.lf_left+=i),c=c.parent}}e.$xB=S}),define(ke[175],Se([1,0,19,125]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yu=e.$Xu=e.$Wu=void 0;class f{constructor(E){this.a=E,this.b=new Uint32Array(E.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(E,m){E=(0,F.$Be)(E);const A=this.a,P=this.b,g=m.length;return g===0?!1:(this.a=new Uint32Array(A.length+g),this.a.set(A.subarray(0,E),0),this.a.set(A.subarray(E),E+g),this.a.set(m,E),E-1<this.c[0]&&(this.c[0]=E-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}setValue(E,m){return E=(0,F.$Be)(E),m=(0,F.$Be)(m),this.a[E]===m?!1:(this.a[E]=m,E-1<this.c[0]&&(this.c[0]=E-1),!0)}removeValues(E,m){E=(0,F.$Be)(E),m=(0,F.$Be)(m);const A=this.a,P=this.b;if(E>=A.length)return!1;const g=A.length-E;return m>=g&&(m=g),m===0?!1:(this.a=new Uint32Array(A.length-m),this.a.set(A.subarray(0,E),0),this.a.set(A.subarray(E+m),E),this.b=new Uint32Array(this.a.length),E-1<this.c[0]&&(this.c[0]=E-1),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(E){return E<0?0:(E=(0,F.$Be)(E),this.d(E))}d(E){if(E<=this.c[0])return this.b[E];let m=this.c[0]+1;m===0&&(this.b[0]=this.a[0],m++),E>=this.a.length&&(E=this.a.length-1);for(let A=m;A<=E;A++)this.b[A]=this.b[A-1]+this.a[A];return this.c[0]=Math.max(this.c[0],E),this.b[E]}getIndexOf(E){E=Math.floor(E),this.getTotalSum();let m=0,A=this.a.length-1,P=0,g=0,y=0;for(;m<=A;)if(P=m+(A-m)/2|0,g=this.b[P],y=g-this.a[P],E<y)A=P-1;else if(E>=g)m=P+1;else break;return new R(P,E-y)}}e.$Wu=f;class L{constructor(E){this.a=E,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(E){return this.g(),E===0?0:this.d[E-1]}getIndexOf(E){this.g();const m=this.e[E],A=m>0?this.d[m-1]:0;return new R(m,E-A)}removeValues(E,m){this.a.splice(E,m),this.f(E)}insertValues(E,m){this.a=(0,I.$Vb)(this.a,E,m),this.f(E)}f(E){this.b=!1,this.c=Math.min(this.c,E-1)}g(){if(!this.b){for(let E=this.c+1,m=this.a.length;E<m;E++){const A=this.a[E],P=E>0?this.d[E-1]:0;this.d[E]=P+A;for(let g=0;g<A;g++)this.e[P+g]=E}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(E,m){this.a[E]!==m&&(this.a[E]=m,this.f(E))}}e.$Xu=L;class R{constructor(E,m){this.index=E,this.remainder=m,this._prefixSumIndexOfResultBrand=void 0,this.index=E,this.remainder=m}}e.$Yu=R}),define(ke[176],Se([1,0,13,53,175]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zu=void 0;class L{constructor(p,E,m,A){this.d=p,this.f=E,this.g=m,this.h=A,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(p){p.eol&&p.eol!==this.g&&(this.g=p.eol,this.j=null);const E=p.changes;for(const m of E)this.o(m.range),this.p(new F.$ws(m.range.startLineNumber,m.range.startColumn),m.text);this.h=p.versionId,this.k=null}l(){if(!this.j){const p=this.g.length,E=this.f.length,m=new Uint32Array(E);for(let A=0;A<E;A++)m[A]=this.f[A].length+p;this.j=new f.$Wu(m)}}n(p,E){this.f[p]=E,this.j&&this.j.setValue(p,this.f[p].length+this.g.length)}o(p){if(p.startLineNumber===p.endLineNumber){if(p.startColumn===p.endColumn)return;this.n(p.startLineNumber-1,this.f[p.startLineNumber-1].substring(0,p.startColumn-1)+this.f[p.startLineNumber-1].substring(p.endColumn-1));return}this.n(p.startLineNumber-1,this.f[p.startLineNumber-1].substring(0,p.startColumn-1)+this.f[p.endLineNumber-1].substring(p.endColumn-1)),this.f.splice(p.startLineNumber,p.endLineNumber-p.startLineNumber),this.j&&this.j.removeValues(p.startLineNumber,p.endLineNumber-p.startLineNumber)}p(p,E){if(E.length===0)return;const m=(0,I.$Qe)(E);if(m.length===1){this.n(p.lineNumber-1,this.f[p.lineNumber-1].substring(0,p.column-1)+m[0]+this.f[p.lineNumber-1].substring(p.column-1));return}m[m.length-1]+=this.f[p.lineNumber-1].substring(p.column-1),this.n(p.lineNumber-1,this.f[p.lineNumber-1].substring(0,p.column-1)+m[0]);const A=new Uint32Array(m.length-1);for(let P=1;P<m.length;P++)this.f.splice(p.lineNumber+P-1,0,m[P]),A[P-1]=m[P].length+this.g.length;this.j&&this.j.insertValues(p.lineNumber,A)}}e.$Zu=L}),define(ke[99],Se([1,0,13,171,53,29,80]),function($e,e,I,F,f,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DB=e.$CB=e.$BB=e.$AB=e.$zB=e.$yB=void 0;const p=999;class E{constructor(i,n,o,a){this.searchString=i,this.isRegex=n,this.matchCase=o,this.wordSeparators=a}parseSearchRequest(){if(this.searchString==="")return null;let i;this.isRegex?i=m(this.searchString):i=this.searchString.indexOf(`
`)>=0;let n=null;try{n=I.$Oe(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:i,global:!0,unicode:!0})}catch{return null}if(!n)return null;let o=!this.isRegex&&!i;return o&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(o=this.matchCase),new R.$Ru(n,this.wordSeparators?(0,F.$Xs)(this.wordSeparators):null,o?this.searchString:null)}}e.$yB=E;function m(s){if(!s||s.length===0)return!1;for(let i=0,n=s.length;i<n;i++){const o=s.charCodeAt(i);if(o===10)return!0;if(o===92){if(i++,i>=n)break;const a=s.charCodeAt(i);if(a===110||a===114||a===87)return!0}}return!1}e.$zB=m;function A(s,i,n){if(!n)return new R.$Ou(s,null);const o=[];for(let a=0,t=i.length;a<t;a++)o[a]=i[a];return new R.$Ou(s,o)}e.$AB=A;class P{constructor(i){const n=[];let o=0;for(let a=0,t=i.length;a<t;a++)i.charCodeAt(a)===10&&(n[o++]=a);this.a=n}findLineFeedCountBeforeOffset(i){const n=this.a;let o=0,a=n.length-1;if(a===-1||i<=n[0])return 0;for(;o<a;){const t=o+((a-o)/2>>0);n[t]>=i?a=t-1:n[t+1]>=i?(o=t,a=t):o=t+1}return o+1}}class g{static findMatches(i,n,o,a,t){const r=n.parseSearchRequest();return r?r.regex.multiline?this.b(i,o,new c(r.wordSeparators,r.regex),a,t):this.c(i,o,r,a,t):[]}static a(i,n,o,a,t,r){let d,u=0;a?(u=a.findLineFeedCountBeforeOffset(t),d=n+t+u):d=n+t;let l;if(a){const $=a.findLineFeedCountBeforeOffset(t+r.length)-u;l=d+r.length+$}else l=d+r.length;const h=i.getPositionAt(d),k=i.getPositionAt(l);return new L.$xs(h.lineNumber,h.column,k.lineNumber,k.column)}static b(i,n,o,a,t){const r=i.getOffsetAt(n.getStartPosition()),d=i.getValueInRange(n,1),u=i.getEOL()===`\r
`?new P(d):null,l=[];let h=0,k;for(o.reset(0);k=o.next(d);)if(l[h++]=A(this.a(i,r,d,u,k.index,k[0]),k,a),h>=t)return l;return l}static c(i,n,o,a,t){const r=[];let d=0;if(n.startLineNumber===n.endLineNumber){const l=i.getLineContent(n.startLineNumber).substring(n.startColumn-1,n.endColumn-1);return d=this.d(o,l,n.startLineNumber,n.startColumn-1,d,r,a,t),r}const u=i.getLineContent(n.startLineNumber).substring(n.startColumn-1);d=this.d(o,u,n.startLineNumber,n.startColumn-1,d,r,a,t);for(let l=n.startLineNumber+1;l<n.endLineNumber&&d<t;l++)d=this.d(o,i.getLineContent(l),l,0,d,r,a,t);if(d<t){const l=i.getLineContent(n.endLineNumber).substring(0,n.endColumn-1);d=this.d(o,l,n.endLineNumber,0,d,r,a,t)}return r}static d(i,n,o,a,t,r,d,u){const l=i.wordSeparators;if(!d&&i.simpleSearch){const D=i.simpleSearch,$=D.length,b=n.length;let v=-$;for(;(v=n.indexOf(D,v+$))!==-1;)if((!l||w(l,n,b,v,$))&&(r[t++]=new R.$Ou(new L.$xs(o,v+1+a,o,v+1+$+a),null),t>=u))return t;return t}const h=new c(i.wordSeparators,i.regex);let k;h.reset(0);do if(k=h.next(n),k&&(r[t++]=A(new L.$xs(o,k.index+1+a,o,k.index+1+k[0].length+a),k,d),t>=u))return t;while(k);return t}static findNextMatch(i,n,o,a){const t=n.parseSearchRequest();if(!t)return null;const r=new c(t.wordSeparators,t.regex);return t.regex.multiline?this.e(i,o,r,a):this.f(i,o,r,a)}static e(i,n,o,a){const t=new f.$ws(n.lineNumber,1),r=i.getOffsetAt(t),d=i.getLineCount(),u=i.getValueInRange(new L.$xs(t.lineNumber,t.column,d,i.getLineMaxColumn(d)),1),l=i.getEOL()===`\r
`?new P(u):null;o.reset(n.column-1);const h=o.next(u);return h?A(this.a(i,r,u,l,h.index,h[0]),h,a):n.lineNumber!==1||n.column!==1?this.e(i,new f.$ws(1,1),o,a):null}static f(i,n,o,a){const t=i.getLineCount(),r=n.lineNumber,d=i.getLineContent(r),u=this.g(o,d,r,n.column,a);if(u)return u;for(let l=1;l<=t;l++){const h=(r+l-1)%t,k=i.getLineContent(h+1),D=this.g(o,k,h+1,1,a);if(D)return D}return null}static g(i,n,o,a,t){i.reset(a-1);const r=i.next(n);return r?A(new L.$xs(o,r.index+1,o,r.index+1+r[0].length),r,t):null}static findPreviousMatch(i,n,o,a){const t=n.parseSearchRequest();if(!t)return null;const r=new c(t.wordSeparators,t.regex);return t.regex.multiline?this.h(i,o,r,a):this.j(i,o,r,a)}static h(i,n,o,a){const t=this.b(i,new L.$xs(1,1,n.lineNumber,n.column),o,a,10*p);if(t.length>0)return t[t.length-1];const r=i.getLineCount();return n.lineNumber!==r||n.column!==i.getLineMaxColumn(r)?this.h(i,new f.$ws(r,i.getLineMaxColumn(r)),o,a):null}static j(i,n,o,a){const t=i.getLineCount(),r=n.lineNumber,d=i.getLineContent(r).substring(0,n.column-1),u=this.k(o,d,r,a);if(u)return u;for(let l=1;l<=t;l++){const h=(t+r-l-1)%t,k=i.getLineContent(h+1),D=this.k(o,k,h+1,a);if(D)return D}return null}static k(i,n,o,a){let t=null,r;for(i.reset(0);r=i.next(n);)t=A(new L.$xs(o,r.index+1,o,r.index+1+r[0].length),r,a);return t}}e.$BB=g;function y(s,i,n,o,a){if(o===0)return!0;const t=i.charCodeAt(o-1);if(s.get(t)!==0||t===13||t===10)return!0;if(a>0){const r=i.charCodeAt(o);if(s.get(r)!==0)return!0}return!1}function S(s,i,n,o,a){if(o+a===n)return!0;const t=i.charCodeAt(o+a);if(s.get(t)!==0||t===13||t===10)return!0;if(a>0){const r=i.charCodeAt(o+a-1);if(s.get(r)!==0)return!0}return!1}function w(s,i,n,o,a){return y(s,i,n,o,a)&&S(s,i,n,o,a)}e.$CB=w;class c{constructor(i,n){this._wordSeparators=i,this.a=n,this.b=-1,this.c=0}reset(i){this.a.lastIndex=i,this.b=-1,this.c=0}next(i){const n=i.length;let o;do{if(this.b+this.c===n||(o=this.a.exec(i),!o))return null;const a=o.index,t=o[0].length;if(a===this.b&&t===this.c){if(t===0){I.$0e(i,n,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=a,this.c=t,!this._wordSeparators||w(this._wordSeparators,i,n,a,t))return o}while(o);return null}}e.$DB=c}),define(ke[128],Se([1,0,53,29,80,174,99]),function($e,e,I,F,f,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IB=e.$HB=e.$GB=e.$FB=e.$EB=void 0;const p=65535;function E(s){let i;return s[s.length-1]<65536?i=new Uint16Array(s.length):i=new Uint32Array(s.length),i.set(s,0),i}class m{constructor(i,n,o,a,t){this.lineStarts=i,this.cr=n,this.lf=o,this.crlf=a,this.isBasicASCII=t}}function A(s,i=!0){const n=[0];let o=1;for(let a=0,t=s.length;a<t;a++){const r=s.charCodeAt(a);r===13?a+1<t&&s.charCodeAt(a+1)===10?(n[o++]=a+2,a++):n[o++]=a+1:r===10&&(n[o++]=a+1)}return i?E(n):n}e.$EB=A;function P(s,i){s.length=0,s[0]=0;let n=1,o=0,a=0,t=0,r=!0;for(let u=0,l=i.length;u<l;u++){const h=i.charCodeAt(u);h===13?u+1<l&&i.charCodeAt(u+1)===10?(t++,s[n++]=u+2,u++):(o++,s[n++]=u+1):h===10?(a++,s[n++]=u+1):r&&h!==9&&(h<32||h>126)&&(r=!1)}const d=new m(E(s),o,a,t,r);return s.length=0,d}e.$FB=P;class g{constructor(i,n,o,a,t){this.bufferIndex=i,this.start=n,this.end=o,this.lineFeedCnt=a,this.length=t}}e.$GB=g;class y{constructor(i,n){this.buffer=i,this.lineStarts=n}}e.$HB=y;class S{constructor(i,n){this.a=[],this.c=i,this.d=n,this.b=0,i.root!==L.$pB&&i.iterate(i.root,o=>(o!==L.$pB&&this.a.push(o.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class w{constructor(i){this.a=i,this.b=[]}get(i){for(let n=this.b.length-1;n>=0;n--){const o=this.b[n];if(o.nodeStartOffset<=i&&o.nodeStartOffset+o.node.piece.length>=i)return o}return null}get2(i){for(let n=this.b.length-1;n>=0;n--){const o=this.b[n];if(o.nodeStartLineNumber&&o.nodeStartLineNumber<i&&o.nodeStartLineNumber+o.node.piece.lineFeedCnt>=i)return o}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let n=!1;const o=this.b;for(let a=0;a<o.length;a++){const t=o[a];if(t.node.parent===null||t.nodeStartOffset>=i){o[a]=null,n=!0;continue}}if(n){const a=[];for(const t of o)t!==null&&a.push(t);this.b=a}}}class c{constructor(i,n,o){this.create(i,n,o)}create(i,n,o){this.a=[new y("",[0])],this.g={line:0,column:0},this.root=L.$pB,this.b=1,this.c=0,this.d=n,this.e=n.length,this.f=o;let a=null;for(let t=0,r=i.length;t<r;t++)if(i[t].buffer.length>0){i[t].lineStarts||(i[t].lineStarts=A(i[t].buffer));const d=new g(t+1,{line:0,column:0},{line:i[t].lineStarts.length-1,column:i[t].buffer.length-i[t].lineStarts[i[t].lineStarts.length-1]},i[t].lineStarts.length-1,i[t].buffer.length);this.a.push(i[t]),a=this.S(a,d)}this.h=new w(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const n=p,o=n-Math.floor(n/3),a=o*2;let t="",r=0;const d=[];if(this.iterate(this.root,u=>{const l=this.R(u),h=l.length;if(r<=o||r+h<a)return t+=l,r+=h,!0;const k=t.replace(/\r\n|\r|\n/g,i);return d.push(new y(k,A(k))),t=l,r=h,!0}),r>0){const u=t.replace(/\r\n|\r|\n/g,i);d.push(new y(u,A(u)))}this.create(d,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new S(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let n=0;return this.iterate(this.root,a=>{if(a===L.$pB)return!0;const t=this.R(a),r=t.length,d=i.G(n),u=i.G(n+r),l=i.getValueInRange2(d,u);return n+=r,t===l})}getOffsetAt(i,n){let o=0,a=this.root;for(;a!==L.$pB;)if(a.left!==L.$pB&&a.lf_left+1>=i)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt+1>=i){o+=a.size_left;const t=this.B(a,i-a.lf_left-2);return o+=t+n-1}else i-=a.lf_left+a.piece.lineFeedCnt,o+=a.size_left+a.piece.length,a=a.right;return o}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let n=this.root,o=0;const a=i;for(;n!==L.$pB;)if(n.size_left!==0&&n.size_left>=i)n=n.left;else if(n.size_left+n.piece.length>=i){const t=this.A(n,i-n.size_left);if(o+=n.lf_left+t.index,t.index===0){const r=this.getOffsetAt(o+1,1),d=a-r;return new I.$ws(o+1,d+1)}return new I.$ws(o+1,t.remainder+1)}else if(i-=n.size_left+n.piece.length,o+=n.lf_left+n.piece.lineFeedCnt,n.right===L.$pB){const t=this.getOffsetAt(o+1,1),r=a-i-t;return new I.$ws(o+1,r+1)}else n=n.right;return new I.$ws(1,1)}getValueInRange(i,n){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const o=this.H(i.startLineNumber,i.startColumn),a=this.H(i.endLineNumber,i.endColumn),t=this.getValueInRange2(o,a);return n?n!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,n):n===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,n):t}getValueInRange2(i,n){if(i.node===n.node){const d=i.node,u=this.a[d.piece.bufferIndex].buffer,l=this.u(d.piece.bufferIndex,d.piece.start);return u.substring(l+i.remainder,l+n.remainder)}let o=i.node;const a=this.a[o.piece.bufferIndex].buffer,t=this.u(o.piece.bufferIndex,o.piece.start);let r=a.substring(t+i.remainder,t+o.piece.length);for(o=o.next();o!==L.$pB;){const d=this.a[o.piece.bufferIndex].buffer,u=this.u(o.piece.bufferIndex,o.piece.start);if(o===n.node){r+=d.substring(u,u+n.remainder);break}else r+=d.substr(u,o.piece.length);o=o.next()}return r}getLinesContent(){const i=[];let n=0,o="",a=!1;return this.iterate(this.root,t=>{if(t===L.$pB)return!0;const r=t.piece;let d=r.length;if(d===0)return!0;const u=this.a[r.bufferIndex].buffer,l=this.a[r.bufferIndex].lineStarts,h=r.start.line,k=r.end.line;let D=l[h]+r.start.column;if(a&&(u.charCodeAt(D)===10&&(D++,d--),i[n++]=o,o="",a=!1,d===0))return!0;if(h===k)return!this.f&&u.charCodeAt(D+d-1)===13?(a=!0,o+=u.substr(D,d-1)):o+=u.substr(D,d),!0;o+=this.f?u.substring(D,Math.max(D,l[h+1]-this.e)):u.substring(D,l[h+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=o;for(let $=h+1;$<k;$++)o=this.f?u.substring(l[$],l[$+1]-this.e):u.substring(l[$],l[$+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=o;return!this.f&&u.charCodeAt(l[k]+r.end.column-1)===13?(a=!0,r.end.column===0?n--:o=u.substr(l[k],r.end.column-1)):o=u.substr(l[k],r.end.column),!0}),a&&(i[n++]=o,o=""),i[n++]=o,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const n=i.node.next();if(!n)return 0;const o=this.a[n.piece.bufferIndex],a=this.u(n.piece.bufferIndex,n.piece.start);return o.buffer.charCodeAt(a)}else{const n=this.a[i.node.piece.bufferIndex],a=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return n.buffer.charCodeAt(a)}}getLineCharCode(i,n){const o=this.H(i,n+1);return this.l(o)}getLineLength(i){if(i===this.getLineCount()){const n=this.getOffsetAt(i,1);return this.getLength()-n}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const n=this.G(i);return this.l(n)}findMatchesInNode(i,n,o,a,t,r,d,u,l,h,k){const D=this.a[i.piece.bufferIndex],$=this.u(i.piece.bufferIndex,i.piece.start),b=this.u(i.piece.bufferIndex,t),v=this.u(i.piece.bufferIndex,r);let C;const N={line:0,column:0};let z,M;n._wordSeparators?(z=D.buffer.substring(b,v),M=O=>O+b,n.reset(0)):(z=D.buffer,M=O=>O,n.reset(b));do if(C=n.next(z),C){if(M(C.index)>=v)return h;this.s(i,M(C.index)-$,N);const O=this.t(i.piece.bufferIndex,t,N),j=N.line===t.line?N.column-t.column+a:N.column+1,T=j+C[0].length;if(k[h++]=(0,R.$AB)(new F.$xs(o+O,j,o+O,T),C,u),M(C.index)+C[0].length>=v||h>=l)return h}while(C);return h}findMatchesLineByLine(i,n,o,a){const t=[];let r=0;const d=new R.$DB(n.wordSeparators,n.regex);let u=this.H(i.startLineNumber,i.startColumn);if(u===null)return[];const l=this.H(i.endLineNumber,i.endColumn);if(l===null)return[];let h=this.s(u.node,u.remainder);const k=this.s(l.node,l.remainder);if(u.node===l.node)return this.findMatchesInNode(u.node,d,i.startLineNumber,i.startColumn,h,k,n,o,a,r,t),t;let D=i.startLineNumber,$=u.node;for(;$!==l.node;){const v=this.t($.piece.bufferIndex,h,$.piece.end);if(v>=1){const N=this.a[$.piece.bufferIndex].lineStarts,z=this.u($.piece.bufferIndex,$.piece.start),M=N[h.line+v],O=D===i.startLineNumber?i.startColumn:1;if(r=this.findMatchesInNode($,d,D,O,h,this.s($,M-z),n,o,a,r,t),r>=a)return t;D+=v}const C=D===i.startLineNumber?i.startColumn-1:0;if(D===i.endLineNumber){const N=this.getLineContent(D).substring(C,i.endColumn-1);return r=this.n(n,d,N,i.endLineNumber,C,r,t,o,a),t}if(r=this.n(n,d,this.getLineContent(D).substr(C),D,C,r,t,o,a),r>=a)return t;D++,u=this.H(D,1),$=u.node,h=this.s(u.node,u.remainder)}if(D===i.endLineNumber){const v=D===i.startLineNumber?i.startColumn-1:0,C=this.getLineContent(D).substring(v,i.endColumn-1);return r=this.n(n,d,C,i.endLineNumber,v,r,t,o,a),t}const b=D===i.startLineNumber?i.startColumn:1;return r=this.findMatchesInNode(l.node,d,D,b,h,k,n,o,a,r,t),t}n(i,n,o,a,t,r,d,u,l){const h=i.wordSeparators;if(!u&&i.simpleSearch){const D=i.simpleSearch,$=D.length,b=o.length;let v=-$;for(;(v=o.indexOf(D,v+$))!==-1;)if((!h||(0,R.$CB)(h,o,b,v,$))&&(d[r++]=new f.$Ou(new F.$xs(a,v+1+t,a,v+1+$+t),null),r>=l))return r;return r}let k;n.reset(0);do if(k=n.next(o),k&&(d[r++]=(0,R.$AB)(new F.$xs(a,k.index+1+t,a,k.index+1+k[0].length+t),k,u),r>=l))return r;while(k);return r}insert(i,n,o=!1){if(this.f=this.f&&o,this.j.lineNumber=0,this.j.value="",this.root!==L.$pB){const{node:a,remainder:t,nodeStartOffset:r}=this.G(i),d=a.piece,u=d.bufferIndex,l=this.s(a,t);if(a.piece.bufferIndex===0&&d.end.line===this.g.line&&d.end.column===this.g.column&&r+d.length===i&&n.length<p){this.F(a,n),this.y();return}if(r===i)this.o(n,a),this.h.validate(i);else if(r+a.piece.length>i){const h=[];let k=new g(d.bufferIndex,l,d.end,this.t(d.bufferIndex,l,d.end),this.u(u,d.end)-this.u(u,l));if(this.K()&&this.M(n)&&this.I(a,t)===10){const v={line:k.start.line+1,column:0};k=new g(k.bufferIndex,v,k.end,this.t(k.bufferIndex,v,k.end),k.length-1),n+=`
`}if(this.K()&&this.L(n))if(this.I(a,t-1)===13){const v=this.s(a,t-1);this.C(a,v),n="\r"+n,a.piece.length===0&&h.push(a)}else this.C(a,l);else this.C(a,l);const D=this.w(n);k.length>0&&this.S(a,k);let $=a;for(let b=0;b<D.length;b++)$=this.S($,D[b]);this.v(h)}else this.q(n,a)}else{const a=this.w(n);let t=this.T(null,a[0]);for(let r=1;r<a.length;r++)t=this.S(t,a[r])}this.y()}delete(i,n){if(this.j.lineNumber=0,this.j.value="",n<=0||this.root===L.$pB)return;const o=this.G(i),a=this.G(i+n),t=o.node,r=a.node;if(t===r){const D=this.s(t,o.remainder),$=this.s(t,a.remainder);if(o.nodeStartOffset===i){if(n===t.piece.length){const b=t.next();(0,L.$uB)(this,t),this.N(b),this.y();return}this.D(t,$),this.h.validate(i),this.N(t),this.y();return}if(o.nodeStartOffset+t.piece.length===i+n){this.C(t,D),this.O(t),this.y();return}this.E(t,D,$),this.y();return}const d=[],u=this.s(t,o.remainder);this.C(t,u),this.h.validate(i),t.piece.length===0&&d.push(t);const l=this.s(r,a.remainder);this.D(r,l),r.piece.length===0&&d.push(r);const h=t.next();for(let D=h;D!==L.$pB&&D!==r;D=D.next())d.push(D);const k=t.piece.length===0?t.prev():t;this.v(d),this.O(k),this.y()}o(i,n){const o=[];if(this.K()&&this.M(i)&&this.L(n)){const r=n.piece,d={line:r.start.line+1,column:0},u=new g(r.bufferIndex,d,r.end,this.t(r.bufferIndex,d,r.end),r.length-1);n.piece=u,i+=`
`,(0,L.$wB)(this,n,-1,-1),n.piece.length===0&&o.push(n)}const a=this.w(i);let t=this.T(n,a[a.length-1]);for(let r=a.length-2;r>=0;r--)t=this.T(t,a[r]);this.N(t),this.v(o)}q(i,n){this.Q(i,n)&&(i+=`
`);const o=this.w(i),a=this.S(n,o[0]);let t=a;for(let r=1;r<o.length;r++)t=this.S(t,o[r]);this.N(a)}s(i,n,o){const a=i.piece,t=i.piece.bufferIndex,r=this.a[t].lineStarts,u=r[a.start.line]+a.start.column+n;let l=a.start.line,h=a.end.line,k=0,D=0,$=0;for(;l<=h&&(k=l+(h-l)/2|0,$=r[k],k!==h);)if(D=r[k+1],u<$)h=k-1;else if(u>=D)l=k+1;else break;return o?(o.line=k,o.column=u-$,null):{line:k,column:u-$}}t(i,n,o){if(o.column===0)return o.line-n.line;const a=this.a[i].lineStarts;if(o.line===a.length-1)return o.line-n.line;const t=a[o.line+1],r=a[o.line]+o.column;if(t>r+1)return o.line-n.line;const d=r-1;return this.a[i].buffer.charCodeAt(d)===13?o.line-n.line+1:o.line-n.line}u(i,n){return this.a[i].lineStarts[n.line]+n.column}v(i){for(let n=0;n<i.length;n++)(0,L.$uB)(this,i[n])}w(i){if(i.length>p){const h=[];for(;i.length>p;){const D=i.charCodeAt(p-1);let $;D===13||D>=55296&&D<=56319?($=i.substring(0,p-1),i=i.substring(p-1)):($=i.substring(0,p),i=i.substring(p));const b=A($);h.push(new g(this.a.length,{line:0,column:0},{line:b.length-1,column:$.length-b[b.length-1]},b.length-1,$.length)),this.a.push(new y($,b))}const k=A(i);return h.push(new g(this.a.length,{line:0,column:0},{line:k.length-1,column:i.length-k[k.length-1]},k.length-1,i.length)),this.a.push(new y(i,k)),h}let n=this.a[0].buffer.length;const o=A(i,!1);let a=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===n&&n!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},a=this.g;for(let h=0;h<o.length;h++)o[h]+=n+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(o.slice(1)),this.a[0].buffer+="_"+i,n+=1}else{if(n!==0)for(let h=0;h<o.length;h++)o[h]+=n;this.a[0].lineStarts=this.a[0].lineStarts.concat(o.slice(1)),this.a[0].buffer+=i}const t=this.a[0].buffer.length,r=this.a[0].lineStarts.length-1,d=t-this.a[0].lineStarts[r],u={line:r,column:d},l=new g(0,a,u,this.t(0,a,u),t-n);return this.g=u,[l]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,n=0){let o=this.root,a="";const t=this.h.get2(i);if(t){o=t.node;const r=this.B(o,i-t.nodeStartLineNumber-1),d=this.a[o.piece.bufferIndex].buffer,u=this.u(o.piece.bufferIndex,o.piece.start);if(t.nodeStartLineNumber+o.piece.lineFeedCnt===i)a=d.substring(u+r,u+o.piece.length);else{const l=this.B(o,i-t.nodeStartLineNumber);return d.substring(u+r,u+l-n)}}else{let r=0;const d=i;for(;o!==L.$pB;)if(o.left!==L.$pB&&o.lf_left>=i-1)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt>i-1){const u=this.B(o,i-o.lf_left-2),l=this.B(o,i-o.lf_left-1),h=this.a[o.piece.bufferIndex].buffer,k=this.u(o.piece.bufferIndex,o.piece.start);return r+=o.size_left,this.h.set({node:o,nodeStartOffset:r,nodeStartLineNumber:d-(i-1-o.lf_left)}),h.substring(k+u,k+l-n)}else if(o.lf_left+o.piece.lineFeedCnt===i-1){const u=this.B(o,i-o.lf_left-2),l=this.a[o.piece.bufferIndex].buffer,h=this.u(o.piece.bufferIndex,o.piece.start);a=l.substring(h+u,h+o.piece.length);break}else i-=o.lf_left+o.piece.lineFeedCnt,r+=o.size_left+o.piece.length,o=o.right}for(o=o.next();o!==L.$pB;){const r=this.a[o.piece.bufferIndex].buffer;if(o.piece.lineFeedCnt>0){const d=this.B(o,0),u=this.u(o.piece.bufferIndex,o.piece.start);return a+=r.substring(u,u+d-n),a}else{const d=this.u(o.piece.bufferIndex,o.piece.start);a+=r.substr(d,o.piece.length)}o=o.next()}return a}y(){let i=this.root,n=1,o=0;for(;i!==L.$pB;)n+=i.lf_left+i.piece.lineFeedCnt,o+=i.size_left+i.piece.length,i=i.right;this.b=n,this.c=o,this.h.validate(this.c)}A(i,n){const o=i.piece,a=this.s(i,n),t=a.line-o.start.line;if(this.u(o.bufferIndex,o.end)-this.u(o.bufferIndex,o.start)===n){const r=this.t(i.piece.bufferIndex,o.start,a);if(r!==t)return{index:r,remainder:0}}return{index:t,remainder:a.column}}B(i,n){if(n<0)return 0;const o=i.piece,a=this.a[o.bufferIndex].lineStarts,t=o.start.line+n+1;return t>o.end.line?a[o.end.line]+o.end.column-a[o.start.line]-o.start.column:a[t]-a[o.start.line]-o.start.column}C(i,n){const o=i.piece,a=o.lineFeedCnt,t=this.u(o.bufferIndex,o.end),r=n,d=this.u(o.bufferIndex,r),u=this.t(o.bufferIndex,o.start,r),l=u-a,h=d-t,k=o.length+h;i.piece=new g(o.bufferIndex,o.start,r,u,k),(0,L.$wB)(this,i,h,l)}D(i,n){const o=i.piece,a=o.lineFeedCnt,t=this.u(o.bufferIndex,o.start),r=n,d=this.t(o.bufferIndex,r,o.end),u=this.u(o.bufferIndex,r),l=d-a,h=t-u,k=o.length+h;i.piece=new g(o.bufferIndex,r,o.end,d,k),(0,L.$wB)(this,i,h,l)}E(i,n,o){const a=i.piece,t=a.start,r=a.end,d=a.length,u=a.lineFeedCnt,l=n,h=this.t(a.bufferIndex,a.start,l),k=this.u(a.bufferIndex,n)-this.u(a.bufferIndex,t);i.piece=new g(a.bufferIndex,a.start,l,h,k),(0,L.$wB)(this,i,k-d,h-u);const D=new g(a.bufferIndex,o,r,this.t(a.bufferIndex,o,r),this.u(a.bufferIndex,r)-this.u(a.bufferIndex,o)),$=this.S(i,D);this.N($)}F(i,n){this.Q(n,i)&&(n+=`
`);const o=this.K()&&this.L(n)&&this.M(i),a=this.a[0].buffer.length;this.a[0].buffer+=n;const t=A(n,!1);for(let $=0;$<t.length;$++)t[$]+=a;if(o){const $=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:a-$}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const r=this.a[0].lineStarts.length-1,d=this.a[0].buffer.length-this.a[0].lineStarts[r],u={line:r,column:d},l=i.piece.length+n.length,h=i.piece.lineFeedCnt,k=this.t(0,i.piece.start,u),D=k-h;i.piece=new g(i.piece.bufferIndex,i.piece.start,u,k,l),this.g=u,(0,L.$wB)(this,i,n.length,D)}G(i){let n=this.root;const o=this.h.get(i);if(o)return{node:o.node,nodeStartOffset:o.nodeStartOffset,remainder:i-o.nodeStartOffset};let a=0;for(;n!==L.$pB;)if(n.size_left>i)n=n.left;else if(n.size_left+n.piece.length>=i){a+=n.size_left;const t={node:n,remainder:i-n.size_left,nodeStartOffset:a};return this.h.set(t),t}else i-=n.size_left+n.piece.length,a+=n.size_left+n.piece.length,n=n.right;return null}H(i,n){let o=this.root,a=0;for(;o!==L.$pB;)if(o.left!==L.$pB&&o.lf_left>=i-1)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt>i-1){const t=this.B(o,i-o.lf_left-2),r=this.B(o,i-o.lf_left-1);return a+=o.size_left,{node:o,remainder:Math.min(t+n-1,r),nodeStartOffset:a}}else if(o.lf_left+o.piece.lineFeedCnt===i-1){const t=this.B(o,i-o.lf_left-2);if(t+n-1<=o.piece.length)return{node:o,remainder:t+n-1,nodeStartOffset:a};n-=o.piece.length-t;break}else i-=o.lf_left+o.piece.lineFeedCnt,a+=o.size_left+o.piece.length,o=o.right;for(o=o.next();o!==L.$pB;){if(o.piece.lineFeedCnt>0){const t=this.B(o,0),r=this.J(o);return{node:o,remainder:Math.min(n-1,t),nodeStartOffset:r}}else if(o.piece.length>=n-1){const t=this.J(o);return{node:o,remainder:n-1,nodeStartOffset:t}}else n-=o.piece.length;o=o.next()}return null}I(i,n){if(i.piece.lineFeedCnt<1)return-1;const o=this.a[i.piece.bufferIndex],a=this.u(i.piece.bufferIndex,i.piece.start)+n;return o.buffer.charCodeAt(a)}J(i){if(!i)return 0;let n=i.size_left;for(;i!==this.root;)i.parent.right===i&&(n+=i.parent.size_left+i.parent.piece.length),i=i.parent;return n}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===L.$pB||i.piece.lineFeedCnt===0)return!1;const n=i.piece,o=this.a[n.bufferIndex].lineStarts,a=n.start.line,t=o[a]+n.start.column;return a===o.length-1||o[a+1]>t+1?!1:this.a[n.bufferIndex].buffer.charCodeAt(t)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===L.$pB||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const n=i.prev();this.M(n)&&this.P(n,i)}}O(i){if(this.K()&&this.M(i)){const n=i.next();this.L(n)&&this.P(i,n)}}P(i,n){const o=[],a=this.a[i.piece.bufferIndex].lineStarts;let t;i.piece.end.column===0?t={line:i.piece.end.line-1,column:a[i.piece.end.line]-a[i.piece.end.line-1]-1}:t={line:i.piece.end.line,column:i.piece.end.column-1};const r=i.piece.length-1,d=i.piece.lineFeedCnt-1;i.piece=new g(i.piece.bufferIndex,i.piece.start,t,d,r),(0,L.$wB)(this,i,-1,-1),i.piece.length===0&&o.push(i);const u={line:n.piece.start.line+1,column:0},l=n.piece.length-1,h=this.t(n.piece.bufferIndex,u,n.piece.end);n.piece=new g(n.piece.bufferIndex,u,n.piece.end,h,l),(0,L.$wB)(this,n,-1,-1),n.piece.length===0&&o.push(n);const k=this.w(`\r
`);this.S(i,k[0]);for(let D=0;D<o.length;D++)(0,L.$uB)(this,o[D])}Q(i,n){if(this.K()&&this.M(i)){const o=n.next();if(this.L(o)){if(i+=`
`,o.piece.length===1)(0,L.$uB)(this,o);else{const a=o.piece,t={line:a.start.line+1,column:0},r=a.length-1,d=this.t(a.bufferIndex,t,a.end);o.piece=new g(a.bufferIndex,t,a.end,d,r),(0,L.$wB)(this,o,-1,-1)}return!0}}return!1}iterate(i,n){if(i===L.$pB)return n(L.$pB);const o=this.iterate(i.left,n);return o&&n(i)&&this.iterate(i.right,n)}R(i){if(i===L.$pB)return"";const n=this.a[i.piece.bufferIndex],o=i.piece,a=this.u(o.bufferIndex,o.start),t=this.u(o.bufferIndex,o.end);return n.buffer.substring(a,t)}getPieceContent(i){const n=this.a[i.bufferIndex],o=this.u(i.bufferIndex,i.start),a=this.u(i.bufferIndex,i.end);return n.buffer.substring(o,a)}S(i,n){const o=new L.$oB(n,1);if(o.left=L.$pB,o.right=L.$pB,o.parent=L.$pB,o.size_left=0,o.lf_left=0,this.root===L.$pB)this.root=o,o.color=0;else if(i.right===L.$pB)i.right=o,o.parent=i;else{const t=(0,L.$qB)(i.right);t.left=o,o.parent=t}return(0,L.$vB)(this,o),o}T(i,n){const o=new L.$oB(n,1);if(o.left=L.$pB,o.right=L.$pB,o.parent=L.$pB,o.size_left=0,o.lf_left=0,this.root===L.$pB)this.root=o,o.color=0;else if(i.left===L.$pB)i.left=o,o.parent=i;else{const a=(0,L.$rB)(i.left);a.right=o,o.parent=a}return(0,L.$vB)(this,o),o}U(i){let n="";return this.iterate(i,o=>(n+=this.R(o),!0)),n}}e.$IB=c}),define(ke[177],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l8=e.$k8=void 0;class I{constructor(){this.a=new Map}removeDragOperationTransfer(L){if(L&&this.a.has(L)){const R=this.a.get(L);return this.a.delete(L),R}}addDragOperationTransfer(L,R){this.a.set(L,R)}}e.$k8=I;class F{constructor(L){this.identifier=L}}e.$l8=F}),define(ke[178],Se([1,0,4,3]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9s=void 0;class f{constructor(){this.a=new Map,this.b=new Map,this.c=new I.$Od,this.onDidChange=this.c.event,this.d=null}handleChange(p){this.c.fire({changedLanguages:p,changedColorMap:!1})}register(p,E){return this.a.set(p,E),this.handleChange([p]),(0,F.$Pc)(()=>{this.a.get(p)===E&&(this.a.delete(p),this.handleChange([p]))})}get(p){return this.a.get(p)||null}registerFactory(p,E){this.b.get(p)?.dispose();const m=new L(this,p,E);return this.b.set(p,m),(0,F.$Pc)(()=>{const A=this.b.get(p);!A||A!==m||(this.b.delete(p),A.dispose())})}async getOrCreate(p){const E=this.get(p);if(E)return E;const m=this.b.get(p);return!m||m.isResolved?null:(await m.resolve(),this.get(p))}isResolved(p){if(this.get(p))return!0;const m=this.b.get(p);return!!(!m||m.isResolved)}setColorMap(p){this.d=p,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$9s=f;class L extends F.$Rc{get isResolved(){return this.c}constructor(p,E,m){super(),this.f=p,this.g=E,this.h=m,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const p=await this.h.tokenizationSupport;this.c=!0,p&&!this.a&&this.B(this.f.register(this.g,p))}}}),define(ke[179],Se([8,9]),function($e,e){return $e.create("vs/base/common/actions",e)}),define(ke[180],Se([1,0,4,3,179]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=void 0;class L extends F.$Rc{constructor(g,y="",S="",w=!0,c){super(),this.h=this.B(new I.$Od),this.onDidChange=this.h.event,this.w=!0,this.j=g,this.m=y,this.u=S,this.w=w,this.C=c}get id(){return this.j}get label(){return this.m}set label(g){this.D(g)}D(g){this.m!==g&&(this.m=g,this.h.fire({label:g}))}get tooltip(){return this.n||""}set tooltip(g){this.F(g)}F(g){this.n!==g&&(this.n=g,this.h.fire({tooltip:g}))}get class(){return this.u}set class(g){this.G(g)}G(g){this.u!==g&&(this.u=g,this.h.fire({class:g}))}get enabled(){return this.w}set enabled(g){this.H(g)}H(g){this.w!==g&&(this.w=g,this.h.fire({enabled:g}))}get checked(){return this.z}set checked(g){this.I(g)}I(g){this.z!==g&&(this.z=g,this.h.fire({checked:g}))}async run(g,y){this.C&&await this.C(g)}}e.$yi=L;class R extends F.$Rc{constructor(){super(...arguments),this.f=this.B(new I.$Od),this.onWillRun=this.f.event,this.m=this.B(new I.$Od),this.onDidRun=this.m.event}async run(g,y){if(!g.enabled)return;this.f.fire({action:g});let S;try{await this.u(g,y)}catch(w){S=w}this.m.fire({action:g,error:S})}async u(g,y){await g.run(y)}}e.$zi=R;class p{constructor(){this.id=p.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...g){let y=[];for(const S of g)S.length&&(y.length?y=[...y,new p,...S]:y=S);return y}static{this.ID="vs.actions.separator"}async run(){}}e.$Ai=p;class E{get actions(){return this.a}constructor(g,y,S,w){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=g,this.label=y,this.class=w,this.a=S}async run(){}}e.$Bi=E;class m extends L{static{this.ID="vs.actions.empty"}constructor(){super(m.ID,f.localize(0,null),void 0,!1)}}e.$Ci=m;function A(P){return{id:P.id,label:P.label,class:void 0,enabled:P.enabled??!0,checked:P.checked??!1,run:async(...g)=>P.run(...g),tooltip:P.label}}e.$Di=A}),define(ke[181],Se([8,9]),function($e,e){return $e.create("vs/base/common/date",e)}),define(ke[182],Se([1,0,181]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$im=e.$hm=void 0;const F=60,f=F*60,L=f*24,R=L*7,p=L*30,E=L*365;function m(P,g,y,S){typeof P!="number"&&(P=P.getTime());const w=Math.round((new Date().getTime()-P)/1e3);if(w<-30)return(0,I.localize)(0,null,m(new Date().getTime()+w*1e3,!1));if(!S&&w<30)return(0,I.localize)(1,null);let c;return w<F?(c=w,g?c===1?y?(0,I.localize)(2,null,c):(0,I.localize)(3,null,c):y?(0,I.localize)(4,null,c):(0,I.localize)(5,null,c):c===1?y?(0,I.localize)(6,null,c):(0,I.localize)(7,null,c):y?(0,I.localize)(8,null,c):(0,I.localize)(9,null,c)):w<f?(c=Math.floor(w/F),g?c===1?y?(0,I.localize)(10,null,c):(0,I.localize)(11,null,c):y?(0,I.localize)(12,null,c):(0,I.localize)(13,null,c):c===1?y?(0,I.localize)(14,null,c):(0,I.localize)(15,null,c):y?(0,I.localize)(16,null,c):(0,I.localize)(17,null,c)):w<L?(c=Math.floor(w/f),g?c===1?y?(0,I.localize)(18,null,c):(0,I.localize)(19,null,c):y?(0,I.localize)(20,null,c):(0,I.localize)(21,null,c):c===1?y?(0,I.localize)(22,null,c):(0,I.localize)(23,null,c):y?(0,I.localize)(24,null,c):(0,I.localize)(25,null,c)):w<R?(c=Math.floor(w/L),g?c===1?(0,I.localize)(26,null,c):(0,I.localize)(27,null,c):c===1?(0,I.localize)(28,null,c):(0,I.localize)(29,null,c)):w<p?(c=Math.floor(w/R),g?c===1?y?(0,I.localize)(30,null,c):(0,I.localize)(31,null,c):y?(0,I.localize)(32,null,c):(0,I.localize)(33,null,c):c===1?y?(0,I.localize)(34,null,c):(0,I.localize)(35,null,c):y?(0,I.localize)(36,null,c):(0,I.localize)(37,null,c)):w<E?(c=Math.floor(w/p),g?c===1?y?(0,I.localize)(38,null,c):(0,I.localize)(39,null,c):y?(0,I.localize)(40,null,c):(0,I.localize)(41,null,c):c===1?y?(0,I.localize)(42,null,c):(0,I.localize)(43,null,c):y?(0,I.localize)(44,null,c):(0,I.localize)(45,null,c)):(c=Math.floor(w/E),g?c===1?y?(0,I.localize)(46,null,c):(0,I.localize)(47,null,c):y?(0,I.localize)(48,null,c):(0,I.localize)(49,null,c):c===1?y?(0,I.localize)(50,null,c):(0,I.localize)(51,null,c):y?(0,I.localize)(52,null,c):(0,I.localize)(53,null,c))}e.$hm=m;function A(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$im=A}),define(ke[183],Se([8,9]),function($e,e){return $e.create("vs/base/common/errorMessage",e)}),define(ke[43],Se([1,0,19,18,183]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gi=e.$Fi=e.$Ei=void 0;function L(P,g){return g&&(P.stack||P.stacktrace)?f.localize(0,null,p(P),R(P.stack)||R(P.stacktrace)):p(P)}function R(P){return Array.isArray(P)?P.join(`
`):P}function p(P){return P.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${P.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?f.localize(1,null,P.message):P.message||f.localize(2,null)}function E(P=null,g=!1){if(!P)return f.localize(3,null);if(Array.isArray(P)){const y=I.$Gb(P),S=E(y[0],g);return y.length>1?f.localize(4,null,S,y.length):S}if(F.$zf(P))return P;if(P.detail){const y=P.detail;if(y.error)return L(y.error,g);if(y.exception)return L(y.exception,g)}return P.stack?L(P,g):P.message?P.message:f.localize(5,null)}e.$Ei=E;function m(P){const g=P;return g instanceof Error&&Array.isArray(g.actions)}e.$Fi=m;function A(P,g){let y;return typeof P=="string"?y=new Error(P):y=P,y.actions=g,y}e.$Gi=A}),define(ke[184],Se([8,9]),function($e,e){return $e.create("vs/base/common/platform",e)}),define(ke[12],Se([1,0,184]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$h=e.$g=void 0,e.$g="en";let F=!1,f=!1,L=!1,R=!1,p=!1,E=!1,m=!1,A=!1,P=!1,g=!1,y,S=e.$g,w=e.$g,c,s;e.$h=typeof self=="object"?self:typeof global=="object"?global:{};let i;typeof e.$h.vscode<"u"&&typeof e.$h.vscode.process<"u"?i=e.$h.vscode.process:typeof process<"u"&&(i=process);const n=typeof i?.versions?.electron=="string",o=n&&i?.type==="renderer";if(typeof navigator=="object"&&!o)s=navigator.userAgent,F=s.indexOf("Windows")>=0,f=s.indexOf("Macintosh")>=0,A=(s.indexOf("Macintosh")>=0||s.indexOf("iPad")>=0||s.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=s.indexOf("Linux")>=0,g=s?.indexOf("Mobi")>=0,E=!0,y=I.getConfiguredDefaultLocale(I.localize(0,null))||e.$g,S=y,w=navigator.language;else if(typeof i=="object"){F=i.platform==="win32",f=i.platform==="darwin",L=i.platform==="linux",R=L&&!!i.env.SNAP&&!!i.env.SNAP_REVISION,m=n,P=!!i.env.CI||!!i.env.BUILD_ARTIFACTSTAGINGDIRECTORY,y=e.$g,S=e.$g;const D=i.env.VSCODE_NLS_CONFIG;if(D)try{const $=JSON.parse(D),b=$.availableLanguages["*"];y=$.locale,w=$.osLocale,S=b||e.$g,c=$._translationsConfigFile}catch{}p=!0}else console.error("Unable to resolve platform.");var a;(function(D){D[D.Web=0]="Web",D[D.Mac=1]="Mac",D[D.Linux=2]="Linux",D[D.Windows=3]="Windows"})(a||(e.Platform=a={}));function t(D){switch(D){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$i=t;let r=0;f?r=1:F?r=3:L&&(r=2),e.$j=F,e.$k=f,e.$l=L,e.$m=R,e.$n=p,e.$o=m,e.$p=E,e.$q=E&&typeof e.$h.importScripts=="function",e.$r=A,e.$s=g,e.$t=P,e.$u=r,e.$v=s,e.$w=S;var d;(function(D){function $(){return e.$w}D.value=$;function b(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}D.isDefaultVariant=b;function v(){return e.$w==="en"}D.isDefault=v})(d||(e.Language=d={})),e.$x=y,e.$y=w,e.$z=c,e.$A=typeof e.$h.postMessage=="function"&&!e.$h.importScripts,e.$B=(()=>{if(e.$A){const D=[];e.$h.addEventListener("message",b=>{if(b.data&&b.data.vscodeScheduleAsyncWork)for(let v=0,C=D.length;v<C;v++){const N=D[v];if(N.id===b.data.vscodeScheduleAsyncWork){D.splice(v,1),N.callback();return}}});let $=0;return b=>{const v=++$;D.push({id:v,callback:b}),e.$h.postMessage({vscodeScheduleAsyncWork:v},"*")}}return D=>setTimeout(D)})();var u;(function(D){D[D.Windows=1]="Windows",D[D.Macintosh=2]="Macintosh",D[D.Linux=3]="Linux"})(u||(e.OperatingSystem=u={})),e.OS=f||A?2:F?1:3;let l=!0,h=!1;function k(){if(!h){h=!0;const D=new Uint8Array(2);D[0]=1,D[1]=2,l=new Uint16Array(D.buffer)[0]===(2<<8)+1}return l}e.$D=k,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0)}),define(ke[49],Se([1,0,12]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dc=e.$cc=e.env=e.cwd=void 0;let F;if(typeof I.$h.vscode<"u"&&typeof I.$h.vscode.process<"u"){const f=I.$h.vscode.process;F={get platform(){return f.platform},get arch(){return f.arch},get env(){return f.env},cwd(){return f.cwd()}}}else typeof process<"u"?F={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:F={get platform(){return I.$j?"win32":I.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=F.cwd,e.env=F.env,e.$cc=F.platform,e.$dc=F.arch}),define(ke[16],Se([1,0,49]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sc=e.sep=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=void 0;const F=65,f=97,L=90,R=122,p=46,E=47,m=92,A=58,P=63;class g extends Error{constructor(r,d,u){let l;typeof d=="string"&&d.indexOf("not ")===0?(l="must not be",d=d.replace(/^not /,"")):l="must be";const h=r.indexOf(".")!==-1?"property":"argument";let k=`The "${r}" ${h} ${l} of type ${d}`;k+=`. Received type ${typeof u}`,super(k),this.code="ERR_INVALID_ARG_TYPE"}}function y(t,r){if(t===null||typeof t!="object")throw new g(r,"Object",t)}function S(t,r){if(typeof t!="string")throw new g(r,"string",t)}const w=I.$cc==="win32";function c(t){return t===E||t===m}function s(t){return t===E}function i(t){return t>=F&&t<=L||t>=f&&t<=R}function n(t,r,d,u){let l="",h=0,k=-1,D=0,$=0;for(let b=0;b<=t.length;++b){if(b<t.length)$=t.charCodeAt(b);else{if(u($))break;$=E}if(u($)){if(!(k===b-1||D===1))if(D===2){if(l.length<2||h!==2||l.charCodeAt(l.length-1)!==p||l.charCodeAt(l.length-2)!==p){if(l.length>2){const v=l.lastIndexOf(d);v===-1?(l="",h=0):(l=l.slice(0,v),h=l.length-1-l.lastIndexOf(d)),k=b,D=0;continue}else if(l.length!==0){l="",h=0,k=b,D=0;continue}}r&&(l+=l.length>0?`${d}..`:"..",h=2)}else l.length>0?l+=`${d}${t.slice(k+1,b)}`:l=t.slice(k+1,b),h=b-k-1;k=b,D=0}else $===p&&D!==-1?++D:D=-1}return l}function o(t,r){y(r,"pathObject");const d=r.dir||r.root,u=r.base||`${r.name||""}${r.ext||""}`;return d?d===r.root?`${d}${u}`:`${d}${t}${u}`:u}e.$ec={resolve(...t){let r="",d="",u=!1;for(let l=t.length-1;l>=-1;l--){let h;if(l>=0){if(h=t[l],S(h,"path"),h.length===0)continue}else r.length===0?h=I.cwd():(h=I.env[`=${r}`]||I.cwd(),(h===void 0||h.slice(0,2).toLowerCase()!==r.toLowerCase()&&h.charCodeAt(2)===m)&&(h=`${r}\\`));const k=h.length;let D=0,$="",b=!1;const v=h.charCodeAt(0);if(k===1)c(v)&&(D=1,b=!0);else if(c(v))if(b=!0,c(h.charCodeAt(1))){let C=2,N=C;for(;C<k&&!c(h.charCodeAt(C));)C++;if(C<k&&C!==N){const z=h.slice(N,C);for(N=C;C<k&&c(h.charCodeAt(C));)C++;if(C<k&&C!==N){for(N=C;C<k&&!c(h.charCodeAt(C));)C++;(C===k||C!==N)&&($=`\\\\${z}\\${h.slice(N,C)}`,D=C)}}}else D=1;else i(v)&&h.charCodeAt(1)===A&&($=h.slice(0,2),D=2,k>2&&c(h.charCodeAt(2))&&(b=!0,D=3));if($.length>0)if(r.length>0){if($.toLowerCase()!==r.toLowerCase())continue}else r=$;if(u){if(r.length>0)break}else if(d=`${h.slice(D)}\\${d}`,u=b,b&&r.length>0)break}return d=n(d,!u,"\\",c),u?`${r}\\${d}`:`${r}${d}`||"."},normalize(t){S(t,"path");const r=t.length;if(r===0)return".";let d=0,u,l=!1;const h=t.charCodeAt(0);if(r===1)return s(h)?"\\":t;if(c(h))if(l=!0,c(t.charCodeAt(1))){let D=2,$=D;for(;D<r&&!c(t.charCodeAt(D));)D++;if(D<r&&D!==$){const b=t.slice($,D);for($=D;D<r&&c(t.charCodeAt(D));)D++;if(D<r&&D!==$){for($=D;D<r&&!c(t.charCodeAt(D));)D++;if(D===r)return`\\\\${b}\\${t.slice($)}\\`;D!==$&&(u=`\\\\${b}\\${t.slice($,D)}`,d=D)}}}else d=1;else i(h)&&t.charCodeAt(1)===A&&(u=t.slice(0,2),d=2,r>2&&c(t.charCodeAt(2))&&(l=!0,d=3));let k=d<r?n(t.slice(d),!l,"\\",c):"";return k.length===0&&!l&&(k="."),k.length>0&&c(t.charCodeAt(r-1))&&(k+="\\"),u===void 0?l?`\\${k}`:k:l?`${u}\\${k}`:`${u}${k}`},isAbsolute(t){S(t,"path");const r=t.length;if(r===0)return!1;const d=t.charCodeAt(0);return c(d)||r>2&&i(d)&&t.charCodeAt(1)===A&&c(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let r,d;for(let h=0;h<t.length;++h){const k=t[h];S(k,"path"),k.length>0&&(r===void 0?r=d=k:r+=`\\${k}`)}if(r===void 0)return".";let u=!0,l=0;if(typeof d=="string"&&c(d.charCodeAt(0))){++l;const h=d.length;h>1&&c(d.charCodeAt(1))&&(++l,h>2&&(c(d.charCodeAt(2))?++l:u=!1))}if(u){for(;l<r.length&&c(r.charCodeAt(l));)l++;l>=2&&(r=`\\${r.slice(l)}`)}return e.$ec.normalize(r)},relative(t,r){if(S(t,"from"),S(r,"to"),t===r)return"";const d=e.$ec.resolve(t),u=e.$ec.resolve(r);if(d===u||(t=d.toLowerCase(),r=u.toLowerCase(),t===r))return"";let l=0;for(;l<t.length&&t.charCodeAt(l)===m;)l++;let h=t.length;for(;h-1>l&&t.charCodeAt(h-1)===m;)h--;const k=h-l;let D=0;for(;D<r.length&&r.charCodeAt(D)===m;)D++;let $=r.length;for(;$-1>D&&r.charCodeAt($-1)===m;)$--;const b=$-D,v=k<b?k:b;let C=-1,N=0;for(;N<v;N++){const M=t.charCodeAt(l+N);if(M!==r.charCodeAt(D+N))break;M===m&&(C=N)}if(N!==v){if(C===-1)return u}else{if(b>v){if(r.charCodeAt(D+N)===m)return u.slice(D+N+1);if(N===2)return u.slice(D+N)}k>v&&(t.charCodeAt(l+N)===m?C=N:N===2&&(C=3)),C===-1&&(C=0)}let z="";for(N=l+C+1;N<=h;++N)(N===h||t.charCodeAt(N)===m)&&(z+=z.length===0?"..":"\\..");return D+=C,z.length>0?`${z}${u.slice(D,$)}`:(u.charCodeAt(D)===m&&++D,u.slice(D,$))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const r=e.$ec.resolve(t);if(r.length<=2)return t;if(r.charCodeAt(0)===m){if(r.charCodeAt(1)===m){const d=r.charCodeAt(2);if(d!==P&&d!==p)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(i(r.charCodeAt(0))&&r.charCodeAt(1)===A&&r.charCodeAt(2)===m)return`\\\\?\\${r}`;return t},dirname(t){S(t,"path");const r=t.length;if(r===0)return".";let d=-1,u=0;const l=t.charCodeAt(0);if(r===1)return c(l)?t:".";if(c(l)){if(d=u=1,c(t.charCodeAt(1))){let D=2,$=D;for(;D<r&&!c(t.charCodeAt(D));)D++;if(D<r&&D!==$){for($=D;D<r&&c(t.charCodeAt(D));)D++;if(D<r&&D!==$){for($=D;D<r&&!c(t.charCodeAt(D));)D++;if(D===r)return t;D!==$&&(d=u=D+1)}}}}else i(l)&&t.charCodeAt(1)===A&&(d=r>2&&c(t.charCodeAt(2))?3:2,u=d);let h=-1,k=!0;for(let D=r-1;D>=u;--D)if(c(t.charCodeAt(D))){if(!k){h=D;break}}else k=!1;if(h===-1){if(d===-1)return".";h=d}return t.slice(0,h)},basename(t,r){r!==void 0&&S(r,"ext"),S(t,"path");let d=0,u=-1,l=!0,h;if(t.length>=2&&i(t.charCodeAt(0))&&t.charCodeAt(1)===A&&(d=2),r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let k=r.length-1,D=-1;for(h=t.length-1;h>=d;--h){const $=t.charCodeAt(h);if(c($)){if(!l){d=h+1;break}}else D===-1&&(l=!1,D=h+1),k>=0&&($===r.charCodeAt(k)?--k===-1&&(u=h):(k=-1,u=D))}return d===u?u=D:u===-1&&(u=t.length),t.slice(d,u)}for(h=t.length-1;h>=d;--h)if(c(t.charCodeAt(h))){if(!l){d=h+1;break}}else u===-1&&(l=!1,u=h+1);return u===-1?"":t.slice(d,u)},extname(t){S(t,"path");let r=0,d=-1,u=0,l=-1,h=!0,k=0;t.length>=2&&t.charCodeAt(1)===A&&i(t.charCodeAt(0))&&(r=u=2);for(let D=t.length-1;D>=r;--D){const $=t.charCodeAt(D);if(c($)){if(!h){u=D+1;break}continue}l===-1&&(h=!1,l=D+1),$===p?d===-1?d=D:k!==1&&(k=1):d!==-1&&(k=-1)}return d===-1||l===-1||k===0||k===1&&d===l-1&&d===u+1?"":t.slice(d,l)},format:o.bind(null,"\\"),parse(t){S(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const d=t.length;let u=0,l=t.charCodeAt(0);if(d===1)return c(l)?(r.root=r.dir=t,r):(r.base=r.name=t,r);if(c(l)){if(u=1,c(t.charCodeAt(1))){let C=2,N=C;for(;C<d&&!c(t.charCodeAt(C));)C++;if(C<d&&C!==N){for(N=C;C<d&&c(t.charCodeAt(C));)C++;if(C<d&&C!==N){for(N=C;C<d&&!c(t.charCodeAt(C));)C++;C===d?u=C:C!==N&&(u=C+1)}}}}else if(i(l)&&t.charCodeAt(1)===A){if(d<=2)return r.root=r.dir=t,r;if(u=2,c(t.charCodeAt(2))){if(d===3)return r.root=r.dir=t,r;u=3}}u>0&&(r.root=t.slice(0,u));let h=-1,k=u,D=-1,$=!0,b=t.length-1,v=0;for(;b>=u;--b){if(l=t.charCodeAt(b),c(l)){if(!$){k=b+1;break}continue}D===-1&&($=!1,D=b+1),l===p?h===-1?h=b:v!==1&&(v=1):h!==-1&&(v=-1)}return D!==-1&&(h===-1||v===0||v===1&&h===D-1&&h===k+1?r.base=r.name=t.slice(k,D):(r.name=t.slice(k,h),r.base=t.slice(k,D),r.ext=t.slice(h,D))),k>0&&k!==u?r.dir=t.slice(0,k-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null};const a=(()=>{if(w){const t=/\\/g;return()=>{const r=I.cwd().replace(t,"/");return r.slice(r.indexOf("/"))}}return()=>I.cwd()})();e.$fc={resolve(...t){let r="",d=!1;for(let u=t.length-1;u>=-1&&!d;u--){const l=u>=0?t[u]:a();S(l,"path"),l.length!==0&&(r=`${l}/${r}`,d=l.charCodeAt(0)===E)}return r=n(r,!d,"/",s),d?`/${r}`:r.length>0?r:"."},normalize(t){if(S(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===E,d=t.charCodeAt(t.length-1)===E;return t=n(t,!r,"/",s),t.length===0?r?"/":d?"./":".":(d&&(t+="/"),r?`/${t}`:t)},isAbsolute(t){return S(t,"path"),t.length>0&&t.charCodeAt(0)===E},join(...t){if(t.length===0)return".";let r;for(let d=0;d<t.length;++d){const u=t[d];S(u,"path"),u.length>0&&(r===void 0?r=u:r+=`/${u}`)}return r===void 0?".":e.$fc.normalize(r)},relative(t,r){if(S(t,"from"),S(r,"to"),t===r||(t=e.$fc.resolve(t),r=e.$fc.resolve(r),t===r))return"";const d=1,u=t.length,l=u-d,h=1,k=r.length-h,D=l<k?l:k;let $=-1,b=0;for(;b<D;b++){const C=t.charCodeAt(d+b);if(C!==r.charCodeAt(h+b))break;C===E&&($=b)}if(b===D)if(k>D){if(r.charCodeAt(h+b)===E)return r.slice(h+b+1);if(b===0)return r.slice(h+b)}else l>D&&(t.charCodeAt(d+b)===E?$=b:b===0&&($=0));let v="";for(b=d+$+1;b<=u;++b)(b===u||t.charCodeAt(b)===E)&&(v+=v.length===0?"..":"/..");return`${v}${r.slice(h+$)}`},toNamespacedPath(t){return t},dirname(t){if(S(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===E;let d=-1,u=!0;for(let l=t.length-1;l>=1;--l)if(t.charCodeAt(l)===E){if(!u){d=l;break}}else u=!1;return d===-1?r?"/":".":r&&d===1?"//":t.slice(0,d)},basename(t,r){r!==void 0&&S(r,"ext"),S(t,"path");let d=0,u=-1,l=!0,h;if(r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let k=r.length-1,D=-1;for(h=t.length-1;h>=0;--h){const $=t.charCodeAt(h);if($===E){if(!l){d=h+1;break}}else D===-1&&(l=!1,D=h+1),k>=0&&($===r.charCodeAt(k)?--k===-1&&(u=h):(k=-1,u=D))}return d===u?u=D:u===-1&&(u=t.length),t.slice(d,u)}for(h=t.length-1;h>=0;--h)if(t.charCodeAt(h)===E){if(!l){d=h+1;break}}else u===-1&&(l=!1,u=h+1);return u===-1?"":t.slice(d,u)},extname(t){S(t,"path");let r=-1,d=0,u=-1,l=!0,h=0;for(let k=t.length-1;k>=0;--k){const D=t.charCodeAt(k);if(D===E){if(!l){d=k+1;break}continue}u===-1&&(l=!1,u=k+1),D===p?r===-1?r=k:h!==1&&(h=1):r!==-1&&(h=-1)}return r===-1||u===-1||h===0||h===1&&r===u-1&&r===d+1?"":t.slice(r,u)},format:o.bind(null,"/"),parse(t){S(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const d=t.charCodeAt(0)===E;let u;d?(r.root="/",u=1):u=0;let l=-1,h=0,k=-1,D=!0,$=t.length-1,b=0;for(;$>=u;--$){const v=t.charCodeAt($);if(v===E){if(!D){h=$+1;break}continue}k===-1&&(D=!1,k=$+1),v===p?l===-1?l=$:b!==1&&(b=1):l!==-1&&(b=-1)}if(k!==-1){const v=h===0&&d?1:h;l===-1||b===0||b===1&&l===k-1&&l===h+1?r.base=r.name=t.slice(v,k):(r.name=t.slice(v,l),r.base=t.slice(v,k),r.ext=t.slice(l,k))}return h>0?r.dir=t.slice(0,h-1):d&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.$fc.win32=e.$ec.win32=e.$ec,e.$fc.posix=e.$ec.posix=e.$fc,e.$gc=w?e.$ec.normalize:e.$fc.normalize,e.$hc=w?e.$ec.isAbsolute:e.$fc.isAbsolute,e.$ic=w?e.$ec.join:e.$fc.join,e.$jc=w?e.$ec.resolve:e.$fc.resolve,e.$kc=w?e.$ec.relative:e.$fc.relative,e.$lc=w?e.$ec.dirname:e.$fc.dirname,e.$mc=w?e.$ec.basename:e.$fc.basename,e.$nc=w?e.$ec.extname:e.$fc.extname,e.$oc=w?e.$ec.format:e.$fc.format,e.$pc=w?e.$ec.parse:e.$fc.parse,e.$qc=w?e.$ec.toNamespacedPath:e.$fc.toNamespacedPath,e.sep=w?e.$ec.sep:e.$fc.sep,e.$sc=w?e.$ec.delimiter:e.$fc.delimiter}),define(ke[129],Se([1,0,48,16]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xq=e.$wq=e.$vq=e.$uq=e.$tq=e.$sq=e.$rq=e.$qq=e.$pq=e.$oq=e.$nq=e.$mq=e.$lq=void 0;const f=new I.$U(()=>{const D=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:D,collatorIsNumeric:D.resolvedOptions().numeric}}),L=new I.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new I.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function p(D,$,b=!1){const v=D||"",C=$||"",N=f.value.collator.compare(v,C);return f.value.collatorIsNumeric&&N===0&&v!==C?v<C?-1:1:N}e.$lq=p;function E(D,$){const b=L.value.collator;return D=D||"",$=$||"",o(b,D,$)}e.$mq=E;function m(D,$){const b=L.value.collator;return D=D||"",$=$||"",d(D,$)||o(b,D,$)}e.$nq=m;function A(D,$){const b=L.value.collator;return D=D||"",$=$||"",r(D,$)||o(b,D,$)}e.$oq=A;function P(D,$){return D=D||"",$=$||"",D===$?0:D<$?-1:1}e.$pq=P;function g(D,$){const[b,v]=i(D),[C,N]=i($);let z=f.value.collator.compare(v,N);if(z===0){if(f.value.collatorIsNumeric&&v!==N)return v<N?-1:1;if(z=f.value.collator.compare(b,C),f.value.collatorIsNumeric&&z===0&&b!==C)return b<C?-1:1}return z}e.$qq=g;function y(D,$){D=D||"",$=$||"";const b=n(D),v=n($),C=L.value.collator,N=R.value.collator;return o(N,b,v)||o(C,D,$)}e.$rq=y;function S(D,$){D=D||"",$=$||"";const b=n(D),v=n($),C=L.value.collator,N=R.value.collator;return o(N,b,v)||d(D,$)||o(C,D,$)}e.$sq=S;function w(D,$){D=D||"",$=$||"";const b=n(D),v=n($),C=L.value.collator,N=R.value.collator;return o(N,b,v)||r(D,$)||o(C,D,$)}e.$tq=w;function c(D,$){D=D||"",$=$||"";const b=n(D).toLowerCase(),v=n($).toLowerCase();return b!==v?b<v?-1:1:D!==$?D<$?-1:1:0}e.$uq=c;const s=/^(.*?)(\.([^.]*))?$/;function i(D,$=!1){const b=D?s.exec(D):[];let v=[b&&b[1]||"",b&&b[3]||""];return $&&(!v[0]&&v[1]||v[0]&&v[0].charAt(0)===".")&&(v=[v[0]+"."+v[1],""]),v}function n(D){const $=D?s.exec(D):[];return $&&$[1]&&$[1].charAt(0)!=="."&&$[3]||""}function o(D,$,b){const v=D.compare($,b);return v!==0?v:$.length!==b.length?$.length<b.length?-1:1:0}function a(D){const $=D.charAt(0);return $.toLocaleUpperCase()!==$}function t(D){const $=D.charAt(0);return $.toLocaleLowerCase()!==$}function r(D,$){return a(D)&&t($)?-1:t(D)&&a($)?1:0}function d(D,$){return t(D)&&a($)?-1:a(D)&&t($)?1:0}function u(D,$,b=!1){return b||(D=D&&D.toLowerCase(),$=$&&$.toLowerCase()),D===$?0:D<$?-1:1}function l(D,$,b=!1){const v=D.split(F.sep),C=$.split(F.sep),N=v.length-1,z=C.length-1;let M,O;for(let j=0;;j++){if(M=N===j,O=z===j,M&&O)return p(v[j],C[j],b);if(M)return-1;if(O)return 1;const T=u(v[j],C[j],b);if(T!==0)return T}}e.$vq=l;function h(D,$,b){const v=D.toLowerCase(),C=$.toLowerCase(),N=k(D,$,b);if(N)return N;const z=v.endsWith(b),M=C.endsWith(b);if(z!==M)return z?-1:1;const O=p(v,C);return O!==0?O:v.localeCompare(C)}e.$wq=h;function k(D,$,b){const v=D.toLowerCase(),C=$.toLowerCase(),N=v.startsWith(b),z=C.startsWith(b);if(N!==z)return N?-1:1;if(N&&z){if(v.length<C.length)return-1;if(v.length>C.length)return 1}return 0}e.$xq=k}),define(ke[33],Se([1,0,16,12,13,18]),function($e,e,I,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=void 0;function R(h){return h===47||h===92}e.$Rf=R;function p(h){return h.replace(/[\\/]/g,I.$fc.sep)}e.$Sf=p;function E(h){return h.indexOf("/")===-1&&(h=p(h)),/^[a-zA-Z]:(\/|$)/.test(h)&&(h="/"+h),h}e.$Tf=E;function m(h,k=I.$fc.sep){if(!h)return"";const D=h.length,$=h.charCodeAt(0);if(R($)){if(R(h.charCodeAt(1))&&!R(h.charCodeAt(2))){let v=3;const C=v;for(;v<D&&!R(h.charCodeAt(v));v++);if(C!==v&&!R(h.charCodeAt(v+1))){for(v+=1;v<D;v++)if(R(h.charCodeAt(v)))return h.slice(0,v+1).replace(/[\\/]/g,k)}}return k}else if(s($)&&h.charCodeAt(1)===58)return R(h.charCodeAt(2))?h.slice(0,2)+k:h.slice(0,2);let b=h.indexOf("://");if(b!==-1){for(b+=3;b<D;b++)if(R(h.charCodeAt(b)))return h.slice(0,b+1)}return""}e.$Uf=m;function A(h){if(!F.$j||!h||h.length<5)return!1;let k=h.charCodeAt(0);if(k!==92||(k=h.charCodeAt(1),k!==92))return!1;let D=2;const $=D;for(;D<h.length&&(k=h.charCodeAt(D),k!==92);D++);return!($===D||(k=h.charCodeAt(D+1),isNaN(k)||k===92))}e.$Vf=A;const P=/[\\/:\*\?"<>\|]/g,g=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function S(h,k=F.$j){const D=k?P:g;return!(!h||h.length===0||/^\s+$/.test(h)||(D.lastIndex=0,D.test(h))||k&&y.test(h)||h==="."||h===".."||k&&h[h.length-1]==="."||k&&h.length!==h.trim().length||h.length>255)}e.$Wf=S;function w(h,k,D){const $=h===k;return!D||$?$:!h||!k?!1:(0,f.$3e)(h,k)}e.$Xf=w;function c(h,k,D,$=I.sep){if(h===k)return!0;if(!h||!k||k.length>h.length)return!1;if(D){if(!(0,f.$4e)(h,k))return!1;if(k.length===h.length)return!0;let v=k.length;return k.charAt(k.length-1)===$&&v--,h.charAt(v)===$}return k.charAt(k.length-1)!==$&&(k+=$),h.indexOf(k)===0}e.$Yf=c;function s(h){return h>=65&&h<=90||h>=97&&h<=122}e.$Zf=s;function i(h,k){return F.$j&&h.endsWith(":")&&(h+=I.sep),(0,I.$hc)(h)||(h=(0,I.$ic)(k,h)),h=(0,I.$gc)(h),F.$j?(h=(0,f.$Le)(h,I.sep),h.endsWith(":")&&(h+=I.sep)):(h=(0,f.$Le)(h,I.sep),h||(h=I.sep)),h}e.$1f=i;function n(h){const k=(0,I.$gc)(h);return F.$j?h.length>3?!1:o(k)&&(h.length===2||k.charCodeAt(2)===92):k===I.$fc.sep}e.$2f=n;function o(h,k=F.$j){return k?s(h.charCodeAt(0))&&h.charCodeAt(1)===58:!1}e.$3f=o;function a(h,k=F.$j){return o(h,k)?h[0]:void 0}e.$4f=a;function t(h,k,D){return k.length>h.length?-1:h===k?0:(D&&(h=h.toLowerCase(),k=k.toLowerCase()),h.indexOf(k))}e.$5f=t;function r(h){const k=h.split(":");let D,$,b;for(const v of k){const C=Number(v);(0,L.$Df)(C)?$===void 0?$=C:b===void 0&&(b=C):D=D?[D,v].join(":"):v}if(!D)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:D,line:$!==void 0?$:void 0,column:b!==void 0?b:$!==void 0?1:void 0}}e.$6f=r;const d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",u="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function l(h,k,D=8){let $="";for(let v=0;v<D;v++){let C;v===0&&F.$j&&!k&&(D===3||D===4)?C=u:C=d,$+=C.charAt(Math.floor(Math.random()*C.length))}let b;return k?b=`${k}-${$}`:b=$,h?(0,I.$ic)(h,b):b}e.$7f=l}),define(ke[130],Se([1,0,129,124,52,16,12,13]),function($e,e,I,F,f,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=e.$Cq=e.$Bq=e.$Aq=e.$zq=e.$yq=void 0;const E=0,m=[E,[]];function A(V,q,fe,ee){if(!V||!q)return m;const Y=V.length,X=q.length;if(Y<X)return m;const ae=V.toLowerCase();return P(q,fe,X,V,ae,Y,ee)}e.$yq=A;function P(V,q,fe,ee,Y,X,ae){const Z=[],se=[];for(let ce=0;ce<fe;ce++){const Ee=ce*X,ne=Ee-X,G=ce>0,J=V[ce],ge=q[ce];for(let x=0;x<X;x++){const le=x>0,te=Ee+x,de=te-1,be=ne+x-1,Pe=le?Z[de]:0,B=G&&le?Z[be]:0,Q=G&&le?se[be]:0;let re;!B&&G?re=0:re=g(J,ge,ee,Y,x,Q),re&&B+re>=Pe&&(ae||G||Y.startsWith(q,x))?(se[te]=Q+1,Z[te]=B+re):(se[te]=E,Z[te]=Pe)}}const we=[];let H=fe-1,U=X-1;for(;H>=0&&U>=0;){const ce=H*X+U;se[ce]===E||(we.push(U),H--),U--}return[Z[fe*X-1],we.reverse()]}function g(V,q,fe,ee,Y,X){let ae=0;if(!y(q,ee[Y]))return ae;if(ae+=1,X>0&&(ae+=X*5),V===fe[Y]&&(ae+=1),Y===0)ae+=8;else{const Z=S(fe.charCodeAt(Y-1));Z?ae+=Z:(0,F.$Kj)(fe.charCodeAt(Y))&&X===0&&(ae+=2)}return ae}function y(V,q){return V===q?!0:V==="/"||V==="\\"?q==="/"||q==="\\":!1}function S(V){switch(V){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const w=[void 0,[]];function c(V,q,fe=0,ee=0){const Y=q;return Y.values&&Y.values.length>1?s(V,Y.values,fe,ee):i(V,q,fe,ee)}e.$zq=c;function s(V,q,fe,ee){let Y=0;const X=[];for(const ae of q){const[Z,se]=i(V,ae,fe,ee);if(typeof Z!="number")return w;Y+=Z,X.push(...se)}return[Y,D(X)]}function i(V,q,fe,ee){const Y=(0,F.$Tj)(q.original,q.originalLowercase,fe,V,V.toLowerCase(),ee,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Y?[Y[0],(0,F.$Qj)(Y)]:w}const n=Object.freeze({score:0}),o=1<<18,a=1<<17,t=1<<16;function r(V,q,fe,ee){const Y=ee.values?ee.values:[ee];return(0,f.$Hi)({[ee.normalized]:{values:Y.map(ae=>({value:ae.normalized,expectContiguousMatch:ae.expectContiguousMatch})),label:V,description:q,allowNonContiguousMatches:fe}})}function d(V,q,fe,ee,Y){if(!V||!q.normalized)return n;const X=ee.getItemLabel(V);if(!X)return n;const ae=ee.getItemDescription(V),Z=r(X,ae,fe,q),se=Y[Z];if(se)return se;const we=u(X,ae,ee.getItemPath(V),q,fe);return Y[Z]=we,we}e.$Aq=d;function u(V,q,fe,ee,Y){const X=!fe||!ee.containsPathSeparator;return fe&&(R.$l?ee.pathNormalized===fe:(0,p.$3e)(ee.pathNormalized,fe))?{score:o,labelMatch:[{start:0,end:V.length}],descriptionMatch:q?[{start:0,end:q.length}]:void 0}:ee.values&&ee.values.length>1?l(V,q,fe,ee.values,X,Y):h(V,q,fe,ee,X,Y)}function l(V,q,fe,ee,Y,X){let ae=0;const Z=[],se=[];for(const we of ee){const{score:H,labelMatch:U,descriptionMatch:ce}=h(V,q,fe,we,Y,X);if(H===E)return n;ae+=H,U&&Z.push(...U),ce&&se.push(...ce)}return{score:ae,labelMatch:D(Z),descriptionMatch:D(se)}}function h(V,q,fe,ee,Y,X){if(Y||!q){const[ae,Z]=A(V,ee.normalized,ee.normalizedLowercase,X&&!ee.expectContiguousMatch);if(ae){const se=(0,F.$Hj)(ee.normalized,V);let we;if(se){we=a;const H=Math.round(ee.normalized.length/V.length*100);we+=H}else we=t;return{score:we+ae,labelMatch:se||k(Z)}}}if(q){let ae=q;fe&&(ae=`${q}${L.sep}`);const Z=ae.length,se=`${ae}${V}`,[we,H]=A(se,ee.normalized,ee.normalizedLowercase,X&&!ee.expectContiguousMatch);if(we){const U=k(H),ce=[],Ee=[];return U.forEach(ne=>{ne.start<Z&&ne.end>Z?(ce.push({start:0,end:ne.end-Z}),Ee.push({start:ne.start,end:Z})):ne.start>=Z?ce.push({start:ne.start-Z,end:ne.end-Z}):Ee.push(ne)}),{score:we,labelMatch:ce,descriptionMatch:Ee}}}return n}function k(V){const q=[];if(!V)return q;let fe;for(const ee of V)fe&&fe.end===ee?fe.end+=1:(fe={start:ee,end:ee+1},q.push(fe));return q}function D(V){const q=V.sort((Y,X)=>Y.start-X.start),fe=[];let ee;for(const Y of q)!ee||!$(ee,Y)?(ee=Y,fe.push(Y)):(ee.start=Math.min(ee.start,Y.start),ee.end=Math.max(ee.end,Y.end));return fe}function $(V,q){return!(V.end<q.start||q.end<V.start)}function b(V,q,fe,ee,Y,X){const ae=d(V,fe,ee,Y,X),Z=d(q,fe,ee,Y,X),se=ae.score,we=Z.score;if((se===o||we===o)&&se!==we)return se===o?-1:1;if(se>t||we>t){if(se!==we)return se>we?-1:1;if(se<a&&we<a){const J=C(ae.labelMatch,Z.labelMatch);if(J!==0)return J}const ne=Y.getItemLabel(V)||"",G=Y.getItemLabel(q)||"";if(ne.length!==G.length)return ne.length-G.length}if(se!==we)return se>we?-1:1;const H=Array.isArray(ae.labelMatch)&&ae.labelMatch.length>0,U=Array.isArray(Z.labelMatch)&&Z.labelMatch.length>0;if(H&&!U)return-1;if(U&&!H)return 1;const ce=v(V,ae,Y),Ee=v(q,Z,Y);return ce&&Ee&&ce!==Ee?Ee>ce?-1:1:N(V,q,fe,Y)}e.$Bq=b;function v(V,q,fe){let ee=-1,Y=-1;if(q.descriptionMatch&&q.descriptionMatch.length?ee=q.descriptionMatch[0].start:q.labelMatch&&q.labelMatch.length&&(ee=q.labelMatch[0].start),q.labelMatch&&q.labelMatch.length){if(Y=q.labelMatch[q.labelMatch.length-1].end,q.descriptionMatch&&q.descriptionMatch.length){const X=fe.getItemDescription(V);X&&(Y+=X.length)}}else q.descriptionMatch&&q.descriptionMatch.length&&(Y=q.descriptionMatch[q.descriptionMatch.length-1].end);return Y-ee}function C(V,q){if(!V&&!q||(!V||!V.length)&&(!q||!q.length))return 0;if(!q||!q.length)return-1;if(!V||!V.length)return 1;const fe=V[0].start,Y=V[V.length-1].end-fe,X=q[0].start,Z=q[q.length-1].end-X;return Y===Z?0:Z<Y?1:-1}function N(V,q,fe,ee){const Y=ee.getItemLabel(V)||"",X=ee.getItemLabel(q)||"",ae=ee.getItemDescription(V),Z=ee.getItemDescription(q),se=Y.length+(ae?ae.length:0),we=X.length+(Z?Z.length:0);if(se!==we)return se-we;const H=ee.getItemPath(V),U=ee.getItemPath(q);return H&&U&&H.length!==U.length?H.length-U.length:Y!==X?(0,I.$wq)(Y,X,fe.normalized):ae&&Z&&ae!==Z?(0,I.$wq)(ae,Z,fe.normalized):H&&U&&H!==U?(0,I.$wq)(H,U,fe.normalized):0}function z(V){return V.startsWith('"')&&V.endsWith('"')}const M=" ";function O(V){typeof V!="string"&&(V="");const q=V.toLowerCase(),{pathNormalized:fe,normalized:ee,normalizedLowercase:Y}=j(V),X=fe.indexOf(L.sep)>=0,ae=z(V);let Z;const se=V.split(M);if(se.length>1)for(const we of se){const H=z(we),{pathNormalized:U,normalized:ce,normalizedLowercase:Ee}=j(we);ce&&(Z||(Z=[]),Z.push({original:we,originalLowercase:we.toLowerCase(),pathNormalized:U,normalized:ce,normalizedLowercase:Ee,expectContiguousMatch:H}))}return{original:V,originalLowercase:q,pathNormalized:fe,normalized:ee,normalizedLowercase:Y,values:Z,containsPathSeparator:X,expectContiguousMatch:ae}}e.$Cq=O;function j(V){let q;R.$j?q=V.replace(/\//g,L.sep):q=V.replace(/\\/g,L.sep);const fe=(0,p.$Ne)(q).replace(/\s|"/g,"");return{pathNormalized:q,normalized:fe,normalizedLowercase:fe.toLowerCase()}}function T(V){return Array.isArray(V)?O(V.map(q=>q.original).join(M)):O(V.original)}e.$Dq=T}),define(ke[100],Se([1,0,16]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xr=e.$Wr=e.$Vr=e.$Ur=e.$Tr=void 0,e.$Tr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const F={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},f={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(A){const P=(0,I.$nc)(A),g=F[P.toLowerCase()];return g!==void 0?g:R(A)}e.$Ur=L;function R(A){const P=(0,I.$nc)(A);return f[P.toLowerCase()]}e.$Vr=R;function p(A){for(const P in f)if(f[P]===A)return P}e.$Wr=p;const E=/^(.+)\/(.+?)(;.+)?$/;function m(A,P){const g=E.exec(A);return g?`${g[1].toLowerCase()}/${g[2].toLowerCase()}${g[3]??""}`:P?void 0:A}e.$Xr=m}),define(ke[101],Se([1,0,12]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=e.$Dl=e.TerminateResponseCode=e.Source=void 0;var F;(function(p){p[p.stdout=0]="stdout",p[p.stderr=1]="stderr"})(F||(e.Source=F={}));var f;(function(p){p[p.Success=0]="Success",p[p.Unknown=1]="Unknown",p[p.AccessDenied=2]="AccessDenied",p[p.ProcessNotFound=3]="ProcessNotFound"})(f||(e.TerminateResponseCode=f={}));function L(p,...E){const m=E.reduce((g,y)=>(g[y]=!0,g),{}),A=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(p).filter(g=>!m[g]).forEach(g=>{for(let y=0;y<A.length;y++)if(g.search(A[y])!==-1){delete p[g];break}})}e.$Dl=L;function R(p){p&&(delete p.DEBUG,I.$k&&delete p.DYLD_LIBRARY_PATH,I.$l&&delete p.LD_PRELOAD)}e.$El=R}),define(ke[2],Se([1,0,16,12]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vc=e.$uc=e.URI=void 0;const f=/^\w[\w\d+.-]*$/,L=/^\//,R=/^\/\//;function p(u,l){if(!u.scheme&&l)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${u.authority}", path: "${u.path}", query: "${u.query}", fragment: "${u.fragment}"}`);if(u.scheme&&!f.test(u.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(u.path){if(u.authority){if(!L.test(u.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(R.test(u.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function E(u,l){return!u&&!l?"file":u}function m(u,l){switch(u){case"https":case"http":case"file":l?l[0]!==P&&(l=P+l):l=P;break}return l}const A="",P="/",g=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{static isUri(l){return l instanceof y?!0:l?typeof l.authority=="string"&&typeof l.fragment=="string"&&typeof l.path=="string"&&typeof l.query=="string"&&typeof l.scheme=="string"&&typeof l.fsPath=="string"&&typeof l.with=="function"&&typeof l.toString=="function":!1}constructor(l,h,k,D,$,b=!1){typeof l=="object"?(this.scheme=l.scheme||A,this.authority=l.authority||A,this.path=l.path||A,this.query=l.query||A,this.fragment=l.fragment||A):(this.scheme=E(l,b),this.authority=h||A,this.path=m(this.scheme,k||A),this.query=D||A,this.fragment=$||A,p(this,b))}get fsPath(){return o(this,!1)}with(l){if(!l)return this;let{scheme:h,authority:k,path:D,query:$,fragment:b}=l;return h===void 0?h=this.scheme:h===null&&(h=A),k===void 0?k=this.authority:k===null&&(k=A),D===void 0?D=this.path:D===null&&(D=A),$===void 0?$=this.query:$===null&&($=A),b===void 0?b=this.fragment:b===null&&(b=A),h===this.scheme&&k===this.authority&&D===this.path&&$===this.query&&b===this.fragment?this:new c(h,k,D,$,b)}static parse(l,h=!1){const k=g.exec(l);return k?new c(k[2]||A,d(k[4]||A),d(k[5]||A),d(k[7]||A),d(k[9]||A),h):new c(A,A,A,A,A)}static file(l){let h=A;if(F.$j&&(l=l.replace(/\\/g,P)),l[0]===P&&l[1]===P){const k=l.indexOf(P,2);k===-1?(h=l.substring(2),l=P):(h=l.substring(2,k),l=l.substring(k)||P)}return new c("file",h,l,A,A)}static from(l,h){return new c(l.scheme,l.authority,l.path,l.query,l.fragment,h)}static joinPath(l,...h){if(!l.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let k;return F.$j&&l.scheme==="file"?k=y.file(I.$ec.join(o(l,!0),...h)).path:k=I.$fc.join(l.path,...h),l.with({path:k})}toString(l=!1){return a(this,l)}toJSON(){return this}static revive(l){if(l){if(l instanceof y)return l;{const h=new c(l);return h._formatted=l.external??null,h._fsPath=l._sep===w?l.fsPath??null:null,h}}else return l}}e.URI=y;function S(u){return!u||typeof u!="object"?!1:typeof u.scheme=="string"&&(typeof u.authority=="string"||typeof u.authority>"u")&&(typeof u.path=="string"||typeof u.path>"u")&&(typeof u.query=="string"||typeof u.query>"u")&&(typeof u.fragment=="string"||typeof u.fragment>"u")}e.$uc=S;const w=F.$j?1:void 0;class c extends y{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=o(this,!1)),this._fsPath}toString(l=!1){return l?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const l={$mid:1};return this._fsPath&&(l.fsPath=this._fsPath,l._sep=w),this._formatted&&(l.external=this._formatted),this.path&&(l.path=this.path),this.scheme&&(l.scheme=this.scheme),this.authority&&(l.authority=this.authority),this.query&&(l.query=this.query),this.fragment&&(l.fragment=this.fragment),l}}const s={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function i(u,l,h){let k,D=-1;for(let $=0;$<u.length;$++){const b=u.charCodeAt($);if(b>=97&&b<=122||b>=65&&b<=90||b>=48&&b<=57||b===45||b===46||b===95||b===126||l&&b===47||h&&b===91||h&&b===93||h&&b===58)D!==-1&&(k+=encodeURIComponent(u.substring(D,$)),D=-1),k!==void 0&&(k+=u.charAt($));else{k===void 0&&(k=u.substr(0,$));const v=s[b];v!==void 0?(D!==-1&&(k+=encodeURIComponent(u.substring(D,$)),D=-1),k+=v):D===-1&&(D=$)}}return D!==-1&&(k+=encodeURIComponent(u.substring(D))),k!==void 0?k:u}function n(u){let l;for(let h=0;h<u.length;h++){const k=u.charCodeAt(h);k===35||k===63?(l===void 0&&(l=u.substr(0,h)),l+=s[k]):l!==void 0&&(l+=u[h])}return l!==void 0?l:u}function o(u,l){let h;return u.authority&&u.path.length>1&&u.scheme==="file"?h=`//${u.authority}${u.path}`:u.path.charCodeAt(0)===47&&(u.path.charCodeAt(1)>=65&&u.path.charCodeAt(1)<=90||u.path.charCodeAt(1)>=97&&u.path.charCodeAt(1)<=122)&&u.path.charCodeAt(2)===58?l?h=u.path.substr(1):h=u.path[1].toLowerCase()+u.path.substr(2):h=u.path,F.$j&&(h=h.replace(/\//g,"\\")),h}e.$vc=o;function a(u,l){const h=l?n:i;let k="",{scheme:D,authority:$,path:b,query:v,fragment:C}=u;if(D&&(k+=D,k+=":"),($||D==="file")&&(k+=P,k+=P),$){let N=$.indexOf("@");if(N!==-1){const z=$.substr(0,N);$=$.substr(N+1),N=z.lastIndexOf(":"),N===-1?k+=h(z,!1,!1):(k+=h(z.substr(0,N),!1,!1),k+=":",k+=h(z.substr(N+1),!1,!0)),k+="@"}$=$.toLowerCase(),N=$.lastIndexOf(":"),N===-1?k+=h($,!1,!0):(k+=h($.substr(0,N),!1,!0),k+=$.substr(N))}if(b){if(b.length>=3&&b.charCodeAt(0)===47&&b.charCodeAt(2)===58){const N=b.charCodeAt(1);N>=65&&N<=90&&(b=`/${String.fromCharCode(N+32)}:${b.substr(3)}`)}else if(b.length>=2&&b.charCodeAt(1)===58){const N=b.charCodeAt(0);N>=65&&N<=90&&(b=`${String.fromCharCode(N+32)}:${b.substr(2)}`)}k+=h(b,!0,!1)}return v&&(k+="?",k+=h(v,!1,!1)),C&&(k+="#",k+=l?C:i(C,!1,!1)),k}function t(u){try{return decodeURIComponent(u)}catch{return u.length>3?u.substr(0,3)+t(u.substr(3)):u}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function d(u){return u.match(r)?u.replace(r,l=>t(l)):u}}),define(ke[185],Se([1,0,2]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$4p=e.$3p=e.$2p=void 0;function F(m){const A=m;return A&&typeof A.type=="string"&&typeof A.severity=="string"}e.$2p=F;function f(m){const A=[];let P;try{const g=JSON.parse(m.arguments),y=g[g.length-1];y&&y.__$stack&&(g.pop(),P=y.__$stack),A.push(...g)}catch{A.push("Unable to log remote console arguments",m.arguments)}return{args:A,stack:P}}e.$3p=f;function L(m){if(typeof m!="string")return L(f(m).stack);const A=m;if(A){const P=R(A),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(P||"");if(g&&g.length===4)return{uri:I.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}e.$4p=L;function R(m){if(!m)return m;const A=m.indexOf(`
`);return A===-1?m:m.substring(0,A)}function p(m,A){const{args:P,stack:g}=f(m),y=typeof P[0]=="string"&&P.length===1;let S=R(g);S&&(S=`(${S.trim()})`);let w=[];if(typeof P[0]=="string"?S&&y?w=[`%c[${A}] %c${P[0]} %c${S}`,E("blue"),E(""),E("grey")]:w=[`%c[${A}] %c${P[0]}`,E("blue"),E(""),...P.slice(1)]:w=[`%c[${A}]%`,E("blue"),...P],S&&!y&&w.push(S),typeof console[m.severity]!="function")throw new Error("Unknown console method");console[m.severity].apply(console,w)}e.log=p;function E(m){return`color: ${m}`}}),define(ke[54],Se([1,0,22,2]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qh=e.$ph=e.$oh=void 0;function f(E){return JSON.stringify(E,R)}e.$oh=f;function L(E){let m=JSON.parse(E);return m=p(m),m}e.$ph=L;function R(E,m){return m instanceof RegExp?{$mid:2,source:m.source,flags:m.flags}:m}function p(E,m=0){if(!E||m>200)return E;if(typeof E=="object"){switch(E.$mid){case 1:return F.URI.revive(E);case 2:return new RegExp(E.source,E.flags);case 17:return new Date(E.source)}if(E instanceof I.$ce||E instanceof Uint8Array)return E;if(Array.isArray(E))for(let A=0;A<E.length;++A)E[A]=p(E[A],m+1);else for(const A in E)Object.hasOwnProperty.call(E,A)&&(E[A]=p(E[A],m+1))}return E}e.$qh=p}),define(ke[17],Se([1,0,11,12,2]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.Schemas=void 0;var L;(function(m){m.inMemory="inmemory",m.vscode="vscode",m.internal="private",m.walkThrough="walkThrough",m.walkThroughSnippet="walkThroughSnippet",m.http="http",m.https="https",m.file="file",m.mailto="mailto",m.untitled="untitled",m.data="data",m.command="command",m.vscodeRemote="vscode-remote",m.vscodeRemoteResource="vscode-remote-resource",m.vscodeManagedRemoteResource="vscode-managed-remote-resource",m.vscodeUserData="vscode-userdata",m.vscodeCustomEditor="vscode-custom-editor",m.vscodeNotebookCell="vscode-notebook-cell",m.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",m.vscodeNotebookCellOutput="vscode-notebook-cell-output",m.vscodeInteractiveInput="vscode-interactive-input",m.vscodeSettings="vscode-settings",m.vscodeWorkspaceTrust="vscode-workspace-trust",m.vscodeTerminal="vscode-terminal",m.vscodeChatSesssion="vscode-chat-editor",m.webviewPanel="webview-panel",m.vscodeWebview="vscode-webview",m.extension="extension",m.vscodeFileResource="vscode-file",m.tmp="tmp",m.vsls="vsls",m.vscodeSourceControl="vscode-scm"})(L||(e.Schemas=L={})),e.$8f="vscode-tkn",e.$9f="tkn";class R{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${L.vscodeRemoteResource}`}setPreferredWebSchema(A){this.d=A}setDelegate(A){this.e=A}setServerRootPath(A){this.f=`${A}/${L.vscodeRemoteResource}`}set(A,P,g){this.a[A]=P,this.b[A]=g}setConnectionToken(A,P){this.c[A]=P}getPreferredWebSchema(){return this.d}rewrite(A){if(this.e)try{return this.e(A)}catch(c){return I.$Z(c),A}const P=A.authority;let g=this.a[P];g&&g.indexOf(":")!==-1&&g.indexOf("[")===-1&&(g=`[${g}]`);const y=this.b[P],S=this.c[P];let w=`path=${encodeURIComponent(A.path)}`;return typeof S=="string"&&(w+=`&${e.$9f}=${encodeURIComponent(S)}`),f.URI.from({scheme:F.$p?this.d:L.vscodeRemoteResource,authority:`${g}:${y}`,path:this.f,query:w})}}e.$0f=new R,e.$$f="vs/../../extensions",e.$_f="vs/../../node_modules",e.$ag="vs/../../node_modules.asar",e.$bg="vs/../../node_modules.asar.unpacked",e.$cg="vscode-app";class p{static{this.a=e.$cg}asBrowserUri(A){const P=this.b(A,$e);return this.uriToBrowserUri(P)}uriToBrowserUri(A){return A.scheme===L.vscodeRemote?e.$0f.rewrite(A):A.scheme===L.file&&(F.$n||F.$q&&F.$h.origin===`${L.vscodeFileResource}://${p.a}`)?A.with({scheme:L.vscodeFileResource,authority:A.authority||p.a,query:null,fragment:null}):A}asFileUri(A){const P=this.b(A,$e);return this.uriToFileUri(P)}uriToFileUri(A){return A.scheme===L.vscodeFileResource?A.with({scheme:L.file,authority:A.authority!==p.a?A.authority:null,query:null,fragment:null}):A}b(A,P){return f.URI.isUri(A)?A:f.URI.parse(P.toUrl(A))}}e.$dg=new p;var E;(function(m){const A=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);m.CoopAndCoep=Object.freeze(A.get("3"));const P="vscode-coi";function g(S){let w;typeof S=="string"?w=new URL(S).searchParams:S instanceof URL?w=S.searchParams:f.URI.isUri(S)&&(w=new URL(S.toString(!0)).searchParams);const c=w?.get(P);if(c)return A.get(c)}m.getHeadersFromQuery=g;function y(S,w,c){if(!globalThis.crossOriginIsolated)return;const s=w&&c?"3":c?"2":"1";S instanceof URLSearchParams?S.set(P,s):S[P]=s}m.addSearchParam=y})(E||(e.COI=E={}))}),define(ke[186],Se([1,0,159,17,12,2]),function($e,e,I,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LC=void 0;class R{constructor(g,y,S){this.id=g,this.dependencies=y,this.callback=S}}class p{static{this.INSTANCE=new p}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(g,y,S)=>{typeof g!="string"&&(S=y,y=g,g=null),(typeof y!="object"||!Array.isArray(y))&&(S=y,y=null),this.c.push(new R(g,y,S))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){if(g.startsWith(window.location.origin)||g.startsWith("vscode-file://vscode-app"))return g;throw new Error(`[trusted_script_src] Invalid script url: ${g}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){return g}})))}async load(g){this.g();const y=await(this.a?this.i(g):this.b?this.h(g):this.j(g));if(!y)throw new Error(`Did not receive a define call from script ${g}`);if(Array.isArray(y.dependencies)&&y.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${g}. The dependencies are: ${y.dependencies.join(", ")}`);return typeof y.callback=="function"?y.callback([]):y.callback}h(g){return new Promise((y,S)=>{const w=document.createElement("script");w.setAttribute("async","async"),w.setAttribute("type","text/javascript");const c=()=>{w.removeEventListener("load",s),w.removeEventListener("error",i)},s=n=>{c(),y(this.c.pop())},i=n=>{c(),S(n)};w.addEventListener("load",s),w.addEventListener("error",i),this.f&&(g=this.f.createScriptURL(g)),w.setAttribute("src",g),document.getElementsByTagName("head")[0].appendChild(w)})}i(g){return new Promise((y,S)=>{try{this.f&&(g=this.f.createScriptURL(g)),importScripts(g),y(this.c.pop())}catch(w){S(w)}})}async j(g){try{const y=globalThis._VSCODE_NODE_MODULES.fs,S=globalThis._VSCODE_NODE_MODULES.vm,w=globalThis._VSCODE_NODE_MODULES.module,c=L.URI.parse(g).fsPath,s=y.readFileSync(c).toString(),i=w.wrap(s.replace(/^#!.*/,""));return new S.Script(i).runInThisContext().apply(),this.c.pop()}catch(y){throw y}}}const E=new Map;let m={};typeof globalThis.require=="object"&&(m=globalThis.require.paths??{});async function A(P,g,y){if(I.$S){y===void 0&&(y=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),m[P]&&(P=m[P]);const S=`${P}/${g}`;if(E.has(S))return E.get(S);let w;if(/^\w[\w\d+.-]*:\/\//.test(S))w=S;else{const n=`${y&&!f.$p?F.$ag:F.$_f}/${S}`;w=F.$dg.asBrowserUri(n).toString(!0)}const c=p.INSTANCE.load(w);return E.set(S,c),c}else return await new Promise((S,w)=>{$e([P],S,w)})}e.$LC=A}),define(ke[23],Se([1,0,33,17,16,12,13,2]),function($e,e,I,F,f,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gg=e.DataUri=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=void 0;function E(y){return(0,p.$vc)(y,!0)}e.$kg=E;class m{constructor(S){this.a=S}compare(S,w,c=!1){return S===w?0:(0,R.$Ve)(this.getComparisonKey(S,c),this.getComparisonKey(w,c))}isEqual(S,w,c=!1){return S===w?!0:!S||!w?!1:this.getComparisonKey(S,c)===this.getComparisonKey(w,c)}getComparisonKey(S,w=!1){return S.with({path:this.a(S)?S.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(S){return this.a(S)}isEqualOrParent(S,w,c=!1){if(S.scheme===w.scheme){if(S.scheme===F.Schemas.file)return I.$Yf(E(S),E(w),this.a(S))&&S.query===w.query&&(c||S.fragment===w.fragment);if((0,e.$Bg)(S.authority,w.authority))return I.$Yf(S.path,w.path,this.a(S),"/")&&S.query===w.query&&(c||S.fragment===w.fragment)}return!1}joinPath(S,...w){return p.URI.joinPath(S,...w)}basenameOrAuthority(S){return(0,e.$tg)(S)||S.authority}basename(S){return f.$fc.basename(S.path)}extname(S){return f.$fc.extname(S.path)}dirname(S){if(S.path.length===0)return S;let w;return S.scheme===F.Schemas.file?w=p.URI.file(f.$lc(E(S))).path:(w=f.$fc.dirname(S.path),S.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${S.toString})) resulted in a relative path`),w="/")),S.with({path:w})}normalizePath(S){if(!S.path.length)return S;let w;return S.scheme===F.Schemas.file?w=p.URI.file(f.$gc(E(S))).path:w=f.$fc.normalize(S.path),S.with({path:w})}relativePath(S,w){if(S.scheme!==w.scheme||!(0,e.$Bg)(S.authority,w.authority))return;if(S.scheme===F.Schemas.file){const i=f.$kc(E(S),E(w));return L.$j?I.$Sf(i):i}let c=S.path||"/";const s=w.path||"/";if(this.a(S)){let i=0;for(const n=Math.min(c.length,s.length);i<n&&!(c.charCodeAt(i)!==s.charCodeAt(i)&&c.charAt(i).toLowerCase()!==s.charAt(i).toLowerCase());i++);c=s.substr(0,i)+c.substr(i)}return f.$fc.relative(c,s)}resolvePath(S,w){if(S.scheme===F.Schemas.file){const c=p.URI.file(f.$jc(E(S),w));return S.with({authority:c.authority,path:c.path})}return w=I.$Tf(w),S.with({path:f.$fc.resolve(S.path,w)})}isAbsolutePath(S){return!!S.path&&S.path[0]==="/"}isEqualAuthority(S,w){return S===w||S!==void 0&&w!==void 0&&(0,R.$3e)(S,w)}hasTrailingPathSeparator(S,w=f.sep){if(S.scheme===F.Schemas.file){const c=E(S);return c.length>I.$Uf(c).length&&c[c.length-1]===w}else{const c=S.path;return c.length>1&&c.charCodeAt(c.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(S.fsPath)}}removeTrailingPathSeparator(S,w=f.sep){return(0,e.$Cg)(S,w)?S.with({path:S.path.substr(0,S.path.length-1)}):S}addTrailingPathSeparator(S,w=f.sep){let c=!1;if(S.scheme===F.Schemas.file){const s=E(S);c=s!==void 0&&s.length===I.$Uf(s).length&&s[s.length-1]===w}else{w="/";const s=S.path;c=s.length===1&&s.charCodeAt(s.length-1)===47}return!c&&!(0,e.$Cg)(S,w)?S.with({path:S.path+"/"}):S}}e.$lg=m,e.$mg=new m(()=>!1),e.$ng=new m(y=>y.scheme===F.Schemas.file?!L.$l:!0),e.$og=new m(y=>!0),e.$pg=e.$mg.isEqual.bind(e.$mg),e.$qg=e.$mg.isEqualOrParent.bind(e.$mg),e.$rg=e.$mg.getComparisonKey.bind(e.$mg),e.$sg=e.$mg.basenameOrAuthority.bind(e.$mg),e.$tg=e.$mg.basename.bind(e.$mg),e.$ug=e.$mg.extname.bind(e.$mg),e.$vg=e.$mg.dirname.bind(e.$mg),e.$wg=e.$mg.joinPath.bind(e.$mg),e.$xg=e.$mg.normalizePath.bind(e.$mg),e.$yg=e.$mg.relativePath.bind(e.$mg),e.$zg=e.$mg.resolvePath.bind(e.$mg),e.$Ag=e.$mg.isAbsolutePath.bind(e.$mg),e.$Bg=e.$mg.isEqualAuthority.bind(e.$mg),e.$Cg=e.$mg.hasTrailingPathSeparator.bind(e.$mg),e.$Dg=e.$mg.removeTrailingPathSeparator.bind(e.$mg),e.$Eg=e.$mg.addTrailingPathSeparator.bind(e.$mg);function A(y,S){const w=[];for(let c=0;c<y.length;c++){const s=S(y[c]);y.some((i,n)=>n===c?!1:(0,e.$qg)(s,S(i)))||w.push(y[c])}return w}e.$Fg=A;var P;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function S(w){const c=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(n=>{const[o,a]=n.split(":");o&&a&&c.set(o,a)});const i=w.path.substring(0,w.path.indexOf(";"));return i&&c.set(y.META_DATA_MIME,i),c}y.parseMetaData=S})(P||(e.DataUri=P={}));function g(y,S,w){if(S){let c=y.path;return c&&c[0]!==f.$fc.sep&&(c=f.$fc.sep+c),y.with({scheme:w,authority:S,path:c})}return y.with({scheme:w})}e.$Gg=g}),define(ke[10],Se([1,0,21,11,4,3,23,12,163]),function($e,e,I,F,f,L,R,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kh=e.$jh=e.$ih=e.$hh=e.Promises=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=void 0;function m(ne){return!!ne&&typeof ne.then=="function"}e.$Hg=m;function A(ne){const G=new I.$Yd,J=ne(G.token),ge=new Promise((x,le)=>{const te=G.token.onCancellationRequested(()=>{te.dispose(),G.dispose(),le(new F.$4)});Promise.resolve(J).then(de=>{te.dispose(),G.dispose(),x(de)},de=>{te.dispose(),G.dispose(),le(de)})});return new class{cancel(){G.cancel()}then(x,le){return ge.then(x,le)}catch(x){return this.then(void 0,x)}finally(x){return ge.finally(x)}}}e.$Ig=A;function P(ne,G,J){return new Promise((ge,x)=>{const le=G.onCancellationRequested(()=>{le.dispose(),ge(J)});ne.then(ge,x).finally(()=>le.dispose())})}e.$Jg=P;function g(ne,G){return new Promise((J,ge)=>{const x=G.onCancellationRequested(()=>{x.dispose(),ge(new F.$4)});ne.then(J,ge).finally(()=>x.dispose())})}e.$Kg=g;async function y(ne){let G=-1;const J=ne.map((ge,x)=>ge.then(le=>(G=x,le)));try{return await Promise.race(J)}finally{ne.forEach((ge,x)=>{x!==G&&ge.cancel()})}}e.$Lg=y;function S(ne,G,J){let ge;const x=setTimeout(()=>{ge?.(void 0),J?.()},G);return Promise.race([ne.finally(()=>clearTimeout(x)),new Promise(le=>ge=le)])}e.$Mg=S;function w(ne){return new Promise((G,J)=>{const ge=ne();m(ge)?ge.then(G,J):G(ge)})}e.$Ng=w;class c{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(G){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=G,!this.b){const J=()=>{if(this.b=null,this.f)return;const ge=this.queue(this.d);return this.d=null,ge};this.b=new Promise(ge=>{this.a.then(J,J).then(ge)})}return new Promise((J,ge)=>{this.b.then(J,ge)})}return this.a=G(),new Promise((J,ge)=>{this.a.then(x=>{this.a=null,J(x)},x=>{this.a=null,ge(x)})})}dispose(){this.f=!0}}e.$Og=c;class s{constructor(){this.a=Promise.resolve(null)}queue(G){return this.a=this.a.then(()=>G(),()=>G())}}e.$Pg=s;class i{constructor(){this.a=new Map}queue(G,J){const x=(this.a.get(G)??Promise.resolve()).catch(()=>{}).then(J).finally(()=>{this.a.get(G)===x&&this.a.delete(G)});return this.a.set(G,x),x}}e.$Qg=i;const n=(ne,G)=>{let J=!0;const ge=setTimeout(()=>{J=!1,G()},ne);return{isTriggered:()=>J,dispose:()=>{clearTimeout(ge),J=!1}}},o=ne=>{let G=!0;return queueMicrotask(()=>{G&&(G=!1,ne())}),{isTriggered:()=>G,dispose:()=>{G=!1}}};class a{constructor(G){this.defaultDelay=G,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(G,J=this.defaultDelay){this.g=G,this.h(),this.b||(this.b=new Promise((x,le)=>{this.d=x,this.f=le}).then(()=>{if(this.b=null,this.d=null,this.g){const x=this.g;return this.g=null,x()}}));const ge=()=>{this.a=null,this.d?.(null)};return this.a=J===E.$Ld?o(ge):n(J,ge),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new F.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Rg=a;class t{constructor(G){this.a=new a(G),this.b=new c}trigger(G,J){return this.a.trigger(()=>this.b.queue(G),J)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Sg=t;class r{constructor(){this.a=!1,this.b=new Promise((G,J)=>{this.d=G})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Tg=r;class d extends r{constructor(G){super(),this.f=setTimeout(()=>this.open(),G)}open(){clearTimeout(this.f),super.open()}}e.$Ug=d;function u(ne,G){return G?new Promise((J,ge)=>{const x=setTimeout(()=>{le.dispose(),J()},ne),le=G.onCancellationRequested(()=>{clearTimeout(x),le.dispose(),ge(new F.$4)})}):A(J=>u(ne,J))}e.$Vg=u;function l(ne,G=0,J){const ge=setTimeout(()=>{ne(),J&&x.dispose()},G),x=(0,L.$Pc)(()=>{clearTimeout(ge),J?.deleteAndLeak(x)});return J?.add(x),x}e.$Wg=l;function h(ne,G,J){let ge=0;const x=setInterval(()=>{ge++,(ge>=J||ne())&&le.dispose()},G),le=(0,L.$Pc)(()=>{clearInterval(x)});return le}e.$Xg=h;function k(ne){const G=[];let J=0;const ge=ne.length;function x(){return J<ge?ne[J++]():null}function le(te){te!=null&&G.push(te);const de=x();return de?de.then(le):Promise.resolve(G)}return Promise.resolve(null).then(le)}e.$Yg=k;function D(ne,G=ge=>!!ge,J=null){let ge=0;const x=ne.length,le=()=>{if(ge>=x)return Promise.resolve(J);const te=ne[ge++];return Promise.resolve(te()).then(be=>G(be)?Promise.resolve(be):le())};return le()}e.$Zg=D;function $(ne,G=ge=>!!ge,J=null){if(ne.length===0)return Promise.resolve(J);let ge=ne.length;const x=()=>{ge=-1;for(const le of ne)le.cancel?.()};return new Promise((le,te)=>{for(const de of ne)de.then(be=>{--ge>=0&&G(be)?(x(),le(be)):ge===0&&le(J)}).catch(be=>{--ge>=0&&(x(),te(be))})})}e.$1g=$;class b{constructor(G){this.a=0,this.d=G,this.f=[],this.b=0,this.g=new f.$Od}get onDrained(){return this.g.event}get size(){return this.a}queue(G){return this.a++,new Promise((J,ge)=>{this.f.push({factory:G,c:J,e:ge}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const G=this.f.shift();this.b++;const J=G.factory();J.then(G.c,G.e),J.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$2g=b;class v extends b{constructor(){super(1)}}e.$3g=v;class C{constructor(){this.a=new Y,this.b=0}queue(G){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,G())):this.a.run(this.b++,G())}}e.$4g=C;class N{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const G=new Z;return this.b.add(G),G.p}g(){for(const[,G]of this.a)if(G.size>0)return!1;return!0}queueFor(G,J=R.$mg){const ge=J.getComparisonKey(G);let x=this.a.get(ge);if(!x){x=new v;const le=this.f++,te=f.Event.once(x.onDrained)(()=>{x?.dispose(),this.a.delete(ge),this.h(),this.d?.deleteAndDispose(le),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new L.$Zc),this.d.set(le,te),this.a.set(ge,x)}return x}h(){this.g()&&this.j()}j(){for(const G of this.b)G.complete();this.b.clear()}dispose(){for(const[,G]of this.a)G.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$5g=N;class z{constructor(G,J){this.a=-1,typeof G=="function"&&typeof J=="number"&&this.setIfNotSet(G,J)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(G,J){this.cancel(),this.a=setTimeout(()=>{this.a=-1,G()},J)}setIfNotSet(G,J){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,G()},J))}}e.$6g=z;class M{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(G,J){this.cancel(),this.a=setInterval(()=>{G()},J)}}e.$7g=M;class O{constructor(G,J){this.b=-1,this.a=G,this.d=J,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(G=this.d){this.cancel(),this.b=setTimeout(this.f,G)}get delay(){return this.d}set delay(G){this.d=G}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$8g=O;class j{constructor(G,J){J%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${J}ms is not a multiple of 1000ms.`),this.a=G,this.b=J,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(G=this.b){G%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${G}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(G/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$9g=j;class T extends O{constructor(G,J){super(G,J),this.j=[]}work(G){this.j.push(G),this.isScheduled()||this.schedule()}h(){const G=this.j;this.j=[],this.a?.(G)}dispose(){this.j=[],super.dispose()}}e.$0g=T;class V extends L.$Rc{constructor(G,J){super(),this.g=G,this.h=J,this.a=[],this.b=this.B(new L.$Sc),this.f=!1}get pending(){return this.a.length}work(G){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+G.length>this.g.maxBufferedWork)return!1}else if(this.pending+G.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const J of G)this.a.push(J);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new O(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$$g=V,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$_g=(ne,G)=>{(0,p.$B)(()=>{if(J)return;const ge=Date.now()+15;G(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ge-Date.now())}}))});let J=!1;return{dispose(){J||(J=!0)}}}:e.$_g=(ne,G,J)=>{const ge=ne.requestIdleCallback(G,typeof J=="number"?{timeout:J}:void 0);let x=!1;return{dispose(){x||(x=!0,ne.cancelIdleCallback(ge))}}},e.$ah=ne=>(0,e.$_g)(globalThis,ne)}();class q{constructor(G,J){this.d=!1,this.a=()=>{try{this.f=J()}catch(ge){this.g=ge}finally{this.d=!0}},this.b=(0,e.$_g)(G,()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$bh=q;class fe extends q{constructor(G){super(globalThis,G)}}e.$ch=fe;async function ee(ne,G,J){let ge;for(let x=0;x<J;x++)try{return await ne()}catch(le){ge=le,await u(G)}throw ge}e.$dh=ee;class Y{isRunning(G){return typeof G=="number"?this.a?.taskId===G:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(G,J,ge){return this.a={taskId:G,cancel:()=>ge?.(),promise:J},J.then(()=>this.d(G),()=>this.d(G)),J}d(G){this.a&&G===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const G=this.b;this.b=void 0,G.run().then(G.promiseResolve,G.promiseReject)}}queue(G){if(this.b)this.b.run=G;else{let J,ge;const x=new Promise((le,te)=>{J=le,ge=te});this.b={run:G,promise:x,promiseResolve:J,promiseReject:ge}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$eh=Y;class X{constructor(G,J=()=>Date.now()){this.d=G,this.f=J,this.a=0,this.b=0}increment(){const G=this.f();return G-this.a>this.d&&(this.a=G,this.b=0),this.b++,this.b}}e.$fh=X;var ae;(function(ne){ne[ne.Resolved=0]="Resolved",ne[ne.Rejected=1]="Rejected"})(ae||(ae={}));class Z{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((G,J)=>{this.a=G,this.b=J})}complete(G){return new Promise(J=>{this.a(G),this.d={outcome:0,value:G},J()})}error(G){return new Promise(J=>{this.b(G),this.d={outcome:1,value:G},J()})}cancel(){return this.error(new F.$4)}}e.$gh=Z;var se;(function(ne){async function G(ge){let x;const le=await Promise.all(ge.map(te=>te.then(de=>de,de=>{x||(x=de)})));if(typeof x<"u")throw x;return le}ne.settled=G;function J(ge){return new Promise(async(x,le)=>{try{await ge(x,le)}catch(te){le(te)}})}ne.withAsyncBody=J})(se||(e.Promises=se={}));var we;(function(ne){ne[ne.Initial=0]="Initial",ne[ne.DoneOK=1]="DoneOK",ne[ne.DoneError=2]="DoneError"})(we||(we={}));class H{static fromArray(G){return new H(J=>{J.emitMany(G)})}static fromPromise(G){return new H(async J=>{J.emitMany(await G)})}static fromPromises(G){return new H(async J=>{await Promise.all(G.map(async ge=>J.emitOne(await ge)))})}static merge(G){return new H(async J=>{await Promise.all(G.map(async ge=>{for await(const x of ge)J.emitOne(x)}))})}static{this.EMPTY=H.fromArray([])}constructor(G){this.a=0,this.b=[],this.d=null,this.f=new f.$Od,queueMicrotask(async()=>{const J={emitOne:ge=>this.g(ge),emitMany:ge=>this.h(ge),reject:ge=>this.k(ge)};try{await Promise.resolve(G(J)),this.j()}catch(ge){this.k(ge)}finally{J.emitOne=void 0,J.emitMany=void 0,J.reject=void 0}})}[Symbol.asyncIterator](){let G=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(G<this.b.length)return{done:!1,value:this.b[G++]};if(this.a===1)return{done:!0,value:void 0};await f.Event.toPromise(this.f.event)}while(!0)}}}static map(G,J){return new H(async ge=>{for await(const x of G)ge.emitOne(J(x))})}map(G){return H.map(this,G)}static filter(G,J){return new H(async ge=>{for await(const x of G)J(x)&&ge.emitOne(x)})}filter(G){return H.filter(this,G)}static coalesce(G){return H.filter(G,J=>!!J)}coalesce(){return H.coalesce(this)}static async toPromise(G){const J=[];for await(const ge of G)J.push(ge);return J}toPromise(){return H.toPromise(this)}g(G){this.a===0&&(this.b.push(G),this.f.fire())}h(G){this.a===0&&(this.b=this.b.concat(G),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(G){this.a===0&&(this.a=2,this.d=G,this.f.fire())}}e.$hh=H;class U extends H{constructor(G,J){super(J),this.l=G}cancel(){this.l.cancel()}}e.$ih=U;function ce(ne){const G=new I.$Yd,J=ne(G.token);return new U(G,async ge=>{const x=G.token.onCancellationRequested(()=>{x.dispose(),G.dispose(),ge.reject(new F.$4)});try{for await(const le of J){if(G.token.isCancellationRequested)return;ge.emitOne(le)}x.dispose(),G.dispose()}catch(le){x.dispose(),G.dispose(),ge.reject(le)}})}e.$jh=ce;class Ee{constructor(){this.a=new Z,this.b=new H(ge=>{if(G){ge.reject(G);return}return J&&ge.emitMany(J),this.d=x=>ge.reject(x),this.f=x=>ge.emitOne(x),this.a.p});let G,J;this.f=ge=>{J||(J=[]),J.push(ge)},this.d=ge=>{G||(G=ge)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(G){this.d(G),this.a.complete()}emitOne(G){this.f(G)}}e.$kh=Ee}),define(ke[34],Se([1,0,19,10,33,28,16,12,13]),function($e,e,I,F,f,L,R,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=void 0;function m(){return Object.create(null)}e.$vj=m,e.$wj="**",e.$xj="/";const A="[/\\\\]",P="[^/\\\\]",g=/\//g;function y(fe,ee){switch(fe){case 0:return"";case 1:return`${P}*?`;default:return`(?:${A}|${P}+${A}${ee?`|${A}${P}+`:""})*?`}}function S(fe,ee){if(!fe)return[];const Y=[];let X=!1,ae=!1,Z="";for(const se of fe){switch(se){case ee:if(!X&&!ae){Y.push(Z),Z="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":ae=!0;break;case"]":ae=!1;break}Z+=se}return Z&&Y.push(Z),Y}e.$yj=S;function w(fe){if(!fe)return"";let ee="";const Y=S(fe,e.$xj);if(Y.every(X=>X===e.$wj))ee=".*";else{let X=!1;Y.forEach((ae,Z)=>{if(ae===e.$wj){if(X)return;ee+=y(2,Z===Y.length-1)}else{let se=!1,we="",H=!1,U="";for(const ce of ae){if(ce!=="}"&&se){we+=ce;continue}if(H&&(ce!=="]"||!U)){let Ee;ce==="-"?Ee=ce:(ce==="^"||ce==="!")&&!U?Ee="^":ce===e.$xj?Ee="":Ee=(0,E.$Ge)(ce),U+=Ee;continue}switch(ce){case"{":se=!0;continue;case"[":H=!0;continue;case"}":{const ne=`(?:${S(we,",").map(G=>w(G)).join("|")})`;ee+=ne,se=!1,we="";break}case"]":{ee+="["+U+"]",H=!1,U="";break}case"?":ee+=P;continue;case"*":ee+=y(1);continue;default:ee+=(0,E.$Ge)(ce)}}Z<Y.length-1&&(Y[Z+1]!==e.$wj||Z+2<Y.length)&&(ee+=A)}X=ae===e.$wj})}return ee}const c=/^\*\*\/\*\.[\w\.-]+$/,s=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,n=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new L.$Cc(1e4),r=function(){return!1},d=function(){return null};function u(fe,ee){if(!fe)return d;let Y;typeof fe!="string"?Y=fe.pattern:Y=fe,Y=Y.trim();const X=`${Y}_${!!ee.trimForExclusions}`;let ae=t.get(X);if(ae)return l(ae,fe);let Z;return c.test(Y)?ae=k(Y.substr(4),Y):(Z=s.exec(h(Y,ee)))?ae=D(Z[1],Y):(ee.trimForExclusions?n:i).test(Y)?ae=$(Y,ee):(Z=o.exec(h(Y,ee)))?ae=b(Z[1].substr(1),Y,!0):(Z=a.exec(h(Y,ee)))?ae=b(Z[1],Y,!1):ae=v(Y),t.set(X,ae),l(ae,fe)}function l(fe,ee){if(typeof ee=="string")return fe;const Y=function(X,ae){return(0,f.$Yf)(X,ee.base,!p.$l)?fe((0,E.$Ke)(X.substr(ee.base.length),R.sep),ae):null};return Y.allBasenames=fe.allBasenames,Y.allPaths=fe.allPaths,Y.basenames=fe.basenames,Y.patterns=fe.patterns,Y}function h(fe,ee){return ee.trimForExclusions&&fe.endsWith("/**")?fe.substr(0,fe.length-2):fe}function k(fe,ee){return function(Y,X){return typeof Y=="string"&&Y.endsWith(fe)?ee:null}}function D(fe,ee){const Y=`/${fe}`,X=`\\${fe}`,ae=function(se,we){return typeof se!="string"?null:we?we===fe?ee:null:se===fe||se.endsWith(Y)||se.endsWith(X)?ee:null},Z=[fe];return ae.basenames=Z,ae.patterns=[ee],ae.allBasenames=Z,ae}function $(fe,ee){const Y=V(fe.slice(1,-1).split(",").map(we=>u(we,ee)).filter(we=>we!==d),fe),X=Y.length;if(!X)return d;if(X===1)return Y[0];const ae=function(we,H){for(let U=0,ce=Y.length;U<ce;U++)if(Y[U](we,H))return fe;return null},Z=Y.find(we=>!!we.allBasenames);Z&&(ae.allBasenames=Z.allBasenames);const se=Y.reduce((we,H)=>H.allPaths?we.concat(H.allPaths):we,[]);return se.length&&(ae.allPaths=se),ae}function b(fe,ee,Y){const X=R.sep===R.$fc.sep,ae=X?fe:fe.replace(g,R.sep),Z=R.sep+ae,se=R.$fc.sep+fe;let we;return Y?we=function(H,U){return typeof H=="string"&&(H===ae||H.endsWith(Z)||!X&&(H===fe||H.endsWith(se)))?ee:null}:we=function(H,U){return typeof H=="string"&&(H===ae||!X&&H===fe)?ee:null},we.allPaths=[(Y?"*/":"./")+fe],we}function v(fe){try{const ee=new RegExp(`^${w(fe)}$`);return function(Y){return ee.lastIndex=0,typeof Y=="string"&&ee.test(Y)?fe:null}}catch{return d}}function C(fe,ee,Y){return!fe||typeof ee!="string"?!1:N(fe)(ee,void 0,Y)}e.$zj=C;function N(fe,ee={}){if(!fe)return r;if(typeof fe=="string"||z(fe)){const Y=u(fe,ee);if(Y===d)return r;const X=function(ae,Z){return!!Y(ae,Z)};return Y.allBasenames&&(X.allBasenames=Y.allBasenames),Y.allPaths&&(X.allPaths=Y.allPaths),X}return j(fe,ee)}e.$Aj=N;function z(fe){const ee=fe;return ee?typeof ee.base=="string"&&typeof ee.pattern=="string":!1}e.$Bj=z;function M(fe){return fe.allBasenames||[]}e.$Cj=M;function O(fe){return fe.allPaths||[]}e.$Dj=O;function j(fe,ee){const Y=V(Object.getOwnPropertyNames(fe).map(we=>T(we,fe[we],ee)).filter(we=>we!==d)),X=Y.length;if(!X)return d;if(!Y.some(we=>!!we.requiresSiblings)){if(X===1)return Y[0];const we=function(ce,Ee){let ne;for(let G=0,J=Y.length;G<J;G++){const ge=Y[G](ce,Ee);if(typeof ge=="string")return ge;(0,F.$Hg)(ge)&&(ne||(ne=[]),ne.push(ge))}return ne?(async()=>{for(const G of ne){const J=await G;if(typeof J=="string")return J}return null})():null},H=Y.find(ce=>!!ce.allBasenames);H&&(we.allBasenames=H.allBasenames);const U=Y.reduce((ce,Ee)=>Ee.allPaths?ce.concat(Ee.allPaths):ce,[]);return U.length&&(we.allPaths=U),we}const ae=function(we,H,U){let ce,Ee;for(let ne=0,G=Y.length;ne<G;ne++){const J=Y[ne];J.requiresSiblings&&U&&(H||(H=(0,R.$mc)(we)),ce||(ce=H.substr(0,H.length-(0,R.$nc)(we).length)));const ge=J(we,H,ce,U);if(typeof ge=="string")return ge;(0,F.$Hg)(ge)&&(Ee||(Ee=[]),Ee.push(ge))}return Ee?(async()=>{for(const ne of Ee){const G=await ne;if(typeof G=="string")return G}return null})():null},Z=Y.find(we=>!!we.allBasenames);Z&&(ae.allBasenames=Z.allBasenames);const se=Y.reduce((we,H)=>H.allPaths?we.concat(H.allPaths):we,[]);return se.length&&(ae.allPaths=se),ae}function T(fe,ee,Y){if(ee===!1)return d;const X=u(fe,Y);if(X===d)return d;if(typeof ee=="boolean")return X;if(ee){const ae=ee.when;if(typeof ae=="string"){const Z=(se,we,H,U)=>{if(!U||!X(se,we))return null;const ce=ae.replace("$(basename)",()=>H),Ee=U(ce);return(0,F.$Hg)(Ee)?Ee.then(ne=>ne?fe:null):Ee?fe:null};return Z.requiresSiblings=!0,Z}}return X}function V(fe,ee){const Y=fe.filter(we=>!!we.basenames);if(Y.length<2)return fe;const X=Y.reduce((we,H)=>{const U=H.basenames;return U?we.concat(U):we},[]);let ae;if(ee){ae=[];for(let we=0,H=X.length;we<H;we++)ae.push(ee)}else ae=Y.reduce((we,H)=>{const U=H.patterns;return U?we.concat(U):we},[]);const Z=function(we,H){if(typeof we!="string")return null;if(!H){let ce;for(ce=we.length;ce>0;ce--){const Ee=we.charCodeAt(ce-1);if(Ee===47||Ee===92)break}H=we.substr(ce)}const U=X.indexOf(H);return U!==-1?ae[U]:null};Z.basenames=X,Z.patterns=ae,Z.allBasenames=X;const se=fe.filter(we=>!we.basenames);return se.push(Z),se}function q(fe,ee){return(0,I.$tb)(fe,ee,(Y,X)=>typeof Y=="string"&&typeof X=="string"?Y===X:typeof Y!="string"&&typeof X!="string"?Y.base===X.base&&Y.pattern===X.pattern:!1)}e.$Ej=q}),define(ke[81],Se([1,0,11,164,23,13,2]),function($e,e,I,F,f,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=e.MarkdownStringTextNewlineStyle=void 0;var p;(function(c){c[c.Paragraph=0]="Paragraph",c[c.Break=1]="Break"})(p||(e.MarkdownStringTextNewlineStyle=p={}));class E{constructor(s="",i=!1){if(this.value=s,typeof this.value!="string")throw(0,I.$6)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(s,i=0){return this.value+=g(this.supportThemeIcons?(0,F.$1j)(s):s).replace(/([ \t]+)/g,(n,o)=>"&nbsp;".repeat(o.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===1?`\\
`:`

`),this}appendMarkdown(s){return this.value+=s,this}appendCodeblock(s,i){return this.value+="\n```",this.value+=s,this.value+=`
`,this.value+=i,this.value+="\n```\n",this}appendLink(s,i,n){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(s),")"),n&&(this.value+=` "${this.c(this.c(n,'"'),")")}"`),this.value+=")",this}c(s,i){const n=new RegExp((0,L.$Ge)(i),"g");return s.replace(n,(o,a)=>s.charAt(a-1)!=="\\"?`\\${o}`:o)}}e.$7j=E;function m(c){return A(c)?!c.value:Array.isArray(c)?c.every(m):!0}e.$8j=m;function A(c){return c instanceof E?!0:c&&typeof c=="object"?typeof c.value=="string"&&(typeof c.isTrusted=="boolean"||typeof c.isTrusted=="object"||c.isTrusted===void 0)&&(typeof c.supportThemeIcons=="boolean"||c.supportThemeIcons===void 0):!1}e.$9j=A;function P(c,s){return c===s?!0:!c||!s?!1:c.value===s.value&&c.isTrusted===s.isTrusted&&c.supportThemeIcons===s.supportThemeIcons&&c.supportHtml===s.supportHtml&&(c.baseUri===s.baseUri||!!c.baseUri&&!!s.baseUri&&(0,f.$pg)(R.URI.from(c.baseUri),R.URI.from(s.baseUri)))}e.$0j=P;function g(c){return c.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$$j=g;function y(c){return c.replace(/"/g,"&quot;")}e.$_j=y;function S(c){return c&&c.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$ak=S;function w(c){const s=[],i=c.split("|").map(o=>o.trim());c=i[0];const n=i[1];if(n){const o=/height=(\d+)/.exec(n),a=/width=(\d+)/.exec(n),t=o?o[1]:"",r=a?a[1]:"",d=isFinite(parseInt(r)),u=isFinite(parseInt(t));d&&s.push(`width="${r}"`),u&&s.push(`height="${t}"`)}return{href:c,dimensions:s}}e.$bk=w}),define(ke[102],Se([1,0,19,33,16,12,23,13]),function($e,e,I,F,f,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ev=e.$Dv=e.$Cv=e.$Bv=e.$Av=e.$zv=e.$yv=e.$xv=e.$wv=e.$vv=void 0;function E(u,l){const{os:h,tildify:k,relative:D}=l;if(D){const v=m(u,D,h);if(typeof v=="string")return v}let $=u.fsPath;if(h===1&&!L.$j?$=$.replace(/\//g,"\\"):h!==1&&L.$j&&($=$.replace(/\\/g,"/")),h!==1&&k?.userHome){const v=k.userHome.fsPath;let C;u.scheme!==k.userHome.scheme&&u.path[0]===f.$fc.sep&&u.path[1]!==f.$fc.sep?C=k.userHome.with({path:u.path}).fsPath:C=$,$=g(C,v,h)}return(h===1?f.$ec:f.$fc).normalize(A($,h===1))}e.$vv=E;function m(u,l,h){const k=h===1?f.$ec:f.$fc,D=h===3?R.$mg:R.$og,$=l.getWorkspace(),b=(0,I.$Nb)($.folders);if(!b)return;u.scheme!==b.uri.scheme&&u.path[0]===f.$fc.sep&&u.path[1]!==f.$fc.sep&&(u=b.uri.with({path:u.path}));const v=l.getWorkspaceFolder(u);if(!v)return;let C;if(D.isEqual(v.uri,u)?C="":C=D.relativePath(v.uri,u)??"",C&&(C=k.normalize(C)),$.folders.length>1&&!l.noPrefix){const N=v.name?v.name:D.basenameOrAuthority(v.uri);C=C?`${N} \u2022 ${C}`:N}return C}function A(u,l=L.$j){return(0,F.$3f)(u,l)?u.charAt(0).toUpperCase()+u.slice(1):u}e.$wv=A;let P=Object.create(null);function g(u,l,h=L.OS){if(h===1||!u||!l)return u;let k=P.original===l?P.normalized:void 0;k||(k=l,L.$j&&(k=(0,F.$Sf)(k)),k=`${(0,p.$Le)(k,f.$fc.sep)}${f.$fc.sep}`,P={original:l,normalized:k});let D=u;return L.$j&&(D=(0,F.$Sf)(D)),(h===3?D.startsWith(k):(0,p.$4e)(D,k))?`~/${D.substr(k.length)}`:u}e.$xv=g;function y(u,l){return u.replace(/^~($|\/|\\)/,`${l}$1`)}e.$yv=y;const S="\u2026",w="\\\\",c="~";function s(u,l=f.sep){const h=new Array(u.length);let k=!1;for(let D=0;D<u.length;D++){const $=u[D];if($===""){h[D]=`.${l}`;continue}if(!$){h[D]=$;continue}k=!0;let b="",v=$;v.indexOf(w)===0?(b=v.substr(0,v.indexOf(w)+w.length),v=v.substr(v.indexOf(w)+w.length)):v.indexOf(l)===0?(b=v.substr(0,v.indexOf(l)+l.length),v=v.substr(v.indexOf(l)+l.length)):v.indexOf(c)===0&&(b=v.substr(0,v.indexOf(c)+c.length),v=v.substr(v.indexOf(c)+c.length));const C=v.split(l);for(let N=1;k&&N<=C.length;N++)for(let z=C.length-N;k&&z>=0;z--){k=!1;let M=C.slice(z,z+N).join(l);for(let O=0;!k&&O<u.length;O++)if(O!==D&&u[O]&&u[O].indexOf(M)>-1){const j=z+N===C.length,T=z>0&&u[O].indexOf(l)>-1?l+M:M,V=u[O].endsWith(T);k=!j||V}if(!k){let O="";(C[0].endsWith(":")||b!=="")&&(z===1&&(z=0,N++,M=C[0]+l+M),z>0&&(O=C[0]+l),O=b+O),z>0&&(O=O+S+l),O=O+M,z+N<C.length&&(O=O+l+S),h[D]=O}}k&&(h[D]=$)}return h}e.$zv=s;var i;(function(u){u[u.TEXT=0]="TEXT",u[u.VARIABLE=1]="VARIABLE",u[u.SEPARATOR=2]="SEPARATOR"})(i||(i={}));function n(u,l=Object.create(null)){const h=[];let k=!1,D="";for(const $ of u)if($==="$"||k&&$==="{")D&&h.push({value:D,type:i.TEXT}),D="",k=!0;else if($==="}"&&k){const b=l[D];if(typeof b=="string")b.length&&h.push({value:b,type:i.VARIABLE});else if(b){const v=h[h.length-1];(!v||v.type!==i.SEPARATOR)&&h.push({value:b.label,type:i.SEPARATOR})}D="",k=!1}else D+=$;return D&&!k&&h.push({value:D,type:i.TEXT}),h.filter(($,b)=>{if($.type===i.SEPARATOR){const v=h[b-1],C=h[b+1];return[v,C].every(N=>N&&(N.type===i.VARIABLE||N.type===i.TEXT)&&N.value.length>0)}return!0}).map($=>$.value).join("")}e.$Av=n;function o(u,l){return L.$k||l?u.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.$k?"&":"&&"):u.replace(/&&|&/g,h=>h==="&"?"&&":"&")}e.$Bv=o;function a(u,l){return L.$k||l?u.replace(/\(&&\w\)|&&/g,""):L.$j?u.replace(/&&|&/g,h=>h==="&"?"&&":"&"):u.replace(/&&/g,"_")}e.$Cv=a;function t(u){return u.replace(/&/g,"&&")}e.$Dv=t;function r(u){if(u.endsWith("]")){const l=u.lastIndexOf(" [",u.length-2);if(l!==-1){const h=d(u.substring(0,l));return{name:h.name,parentPath:h.parentPath+u.substring(l)}}}return d(u)}e.$Ev=r;function d(u){const l=u.indexOf("/")!==-1?f.$fc:f.$ec,h=l.basename(u),k=l.dirname(u);return h.length?{name:h,parentPath:k}:{name:k,parentPath:""}}}),define(ke[131],Se([1,0,22,2]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.$Pm=void 0;function f(P){return P.toJSON()}class L{constructor(g){this.a=g}transformIncoming(g){const y=this.a.transformIncoming(g);return y===g?g:f(F.URI.from(y))}transformOutgoing(g){const y=this.a.transformOutgoing(g);return y===g?g:f(F.URI.from(y))}transformOutgoingURI(g){const y=this.a.transformOutgoing(g);return y===g?g:F.URI.from(y)}transformOutgoingScheme(g){return this.a.transformOutgoingScheme(g)}}e.$Pm=L,e.$Qm=new class{transformIncoming(P){return P}transformOutgoing(P){return P}transformOutgoingURI(P){return P}transformOutgoingScheme(P){return P}};function R(P,g,y){if(!P||y>200)return null;if(typeof P=="object"){if(P instanceof F.URI)return g.transformOutgoing(P);for(const S in P)if(Object.hasOwnProperty.call(P,S)){const w=R(P[S],g,y+1);w!==null&&(P[S]=w)}}return null}function p(P,g){const y=R(P,g,0);return y===null?P:y}e.$Rm=p;function E(P,g,y,S){if(!P||S>200)return null;if(typeof P=="object"){if(P.$mid===1)return y?F.URI.revive(g.transformIncoming(P)):g.transformIncoming(P);if(P instanceof I.$ce)return null;for(const w in P)if(Object.hasOwnProperty.call(P,w)){const c=E(P[w],g,y,S+1);c!==null&&(P[w]=c)}}return null}function m(P,g){const y=E(P,g,!1,0);return y===null?P:y}e.$Sm=m;function A(P,g){const y=E(P,g,!0,0);return y===null?P:y}e.$Tm=A}),define(ke[30],Se([1,0,55,63,387,10,33,77,16,12,23,2]),function($e,e,I,F,f,L,R,p,E,m,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var g;(function(T){T[T.UNLINK=0]="UNLINK",T[T.MOVE=1]="MOVE"})(g||(e.RimRafMode=g={}));async function y(T,V=g.UNLINK,q){if((0,R.$2f)(T))throw new Error("rimraf - will refuse to recursively delete root");return V===g.UNLINK?w(T):S(T,q)}async function S(T,V=(0,R.$7f)((0,F.tmpdir)())){try{try{await I.promises.rename(T,V)}catch(q){return q.code==="ENOENT"?void 0:w(T)}w(V).catch(q=>{})}catch(q){if(q.code!=="ENOENT")throw q}}async function w(T){return(0,f.promisify)(I.rm)(T,{recursive:!0,force:!0,maxRetries:3})}function c(T){if((0,R.$2f)(T))throw new Error("rimraf - will refuse to recursively delete root");I.rmSync(T,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=c;async function s(T,V){return o(await(V?i(T):(0,f.promisify)(I.readdir)(T)))}async function i(T){try{return await(0,f.promisify)(I.readdir)(T,{withFileTypes:!0})}catch(fe){console.warn("[node.js fs] readdir with filetypes failed with error: ",fe)}const V=[],q=await s(T);for(const fe of q){let ee=!1,Y=!1,X=!1;try{const ae=await e.Promises.lstat((0,E.$ic)(T,fe));ee=ae.isFile(),Y=ae.isDirectory(),X=ae.isSymbolicLink()}catch(ae){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ae)}V.push({name:fe,isFile:()=>ee,isDirectory:()=>Y,isSymbolicLink:()=>X})}return V}function n(T){return o(I.readdirSync(T))}e.readdirSync=n;function o(T){return T.map(V=>typeof V=="string"?m.$k?(0,p.$sl)(V):V:(V.name=m.$k?(0,p.$sl)(V.name):V.name,V))}async function a(T){const V=await s(T),q=[];for(const fe of V)await r.existsDirectory((0,E.$ic)(T,fe))&&q.push(fe);return q}function t(T,V=1e3){return new Promise(q=>{let fe=!1;const ee=setInterval(()=>{fe||(fe=!0,I.access(T,Y=>{fe=!1,Y&&(clearInterval(ee),q(void 0))}))},V)})}e.whenDeleted=t;var r;(function(T){async function V(ee){let Y;try{if(Y=await e.Promises.lstat(ee),!Y.isSymbolicLink())return{stat:Y}}catch{}try{return{stat:await e.Promises.stat(ee),symbolicLink:Y?.isSymbolicLink()?{dangling:!1}:void 0}}catch(X){if(X.code==="ENOENT"&&Y)return{stat:Y,symbolicLink:{dangling:!0}};if(m.$j&&X.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(ee)),symbolicLink:{dangling:!1}}}catch(ae){if(ae.code==="ENOENT"&&Y)return{stat:Y,symbolicLink:{dangling:!0}};throw ae}throw X}}T.stat=V;async function q(ee){try{const{stat:Y,symbolicLink:X}=await T.stat(ee);return Y.isFile()&&X?.dangling!==!0}catch{}return!1}T.existsFile=q;async function fe(ee){try{const{stat:Y,symbolicLink:X}=await T.stat(ee);return Y.isDirectory()&&X?.dangling!==!0}catch{}return!1}T.existsDirectory=fe})(r||(e.SymlinkSupport=r={}));const d=new L.$5g;function u(T,V,q){return d.queueFor(P.URI.file(T),A.$ng).queue(()=>{const fe=$(q);return new Promise((ee,Y)=>k(T,V,fe,X=>X?Y(X):ee()))})}let l=!0;function h(T){l=T}e.configureFlushOnWrite=h;function k(T,V,q,fe){if(!l)return I.writeFile(T,V,{mode:q.mode,flag:q.flag},fe);I.open(T,q.flag,q.mode,(ee,Y)=>{if(ee)return fe(ee);I.writeFile(Y,V,X=>{if(X)return I.close(Y,()=>fe(X));I.fdatasync(Y,ae=>(ae&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ae),h(!1)),I.close(Y,Z=>fe(Z))))})})}function D(T,V,q){const fe=$(q);if(!l)return I.writeFileSync(T,V,{mode:fe.mode,flag:fe.flag});const ee=I.openSync(T,fe.flag,fe.mode);try{I.writeFileSync(ee,V);try{I.fdatasyncSync(ee)}catch(Y){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",Y),h(!1)}}finally{I.closeSync(ee)}}e.writeFileSync=D;function $(T){return T?{mode:typeof T.mode=="number"?T.mode:438,flag:typeof T.flag=="string"?T.flag:"w"}:{mode:438,flag:"w"}}async function b(T,V,q=6e4){if(T!==V)try{m.$j&&typeof q=="number"?await v(T,V,Date.now(),q):await(0,f.promisify)(I.rename)(T,V)}catch(fe){if(T.toLowerCase()!==V.toLowerCase()&&fe.code==="EXDEV"||T.endsWith("."))await C(T,V,{preserveSymlinks:!1}),await y(T,g.MOVE);else throw fe}}async function v(T,V,q,fe,ee=0){try{return await(0,f.promisify)(I.rename)(T,V)}catch(Y){if(Y.code!=="EACCES"&&Y.code!=="EPERM"&&Y.code!=="EBUSY")throw Y;if(Date.now()-q>=fe)throw console.error(`[node.js fs] rename failed after ${ee} retries with error: ${Y}`),Y;if(ee===0){let X=!1;try{const{stat:ae}=await r.stat(V);ae.isFile()||(X=!0)}catch{}if(X)throw Y}return await(0,L.$Vg)(Math.min(100,ee*10)),v(T,V,q,fe,ee+1)}}async function C(T,V,q){return z(T,V,{root:{source:T,target:V},options:q,handledSourcePaths:new Set})}const N=511;async function z(T,V,q){if(q.handledSourcePaths.has(T))return;q.handledSourcePaths.add(T);const{stat:fe,symbolicLink:ee}=await r.stat(T);if(ee){if(q.options.preserveSymlinks)try{return await j(T,V,q)}catch(Y){console.warn("[node.js fs] copy of symlink failed: ",Y)}if(ee.dangling)return}return fe.isDirectory()?M(T,V,fe.mode&N,q):O(T,V,fe.mode&N)}async function M(T,V,q,fe){await e.Promises.mkdir(V,{recursive:!0,mode:q});const ee=await s(T);for(const Y of ee)await z((0,E.$ic)(T,Y),(0,E.$ic)(V,Y),fe)}async function O(T,V,q){await e.Promises.copyFile(T,V),await e.Promises.chmod(V,q)}async function j(T,V,q){let fe=await e.Promises.readlink(T);(0,R.$Yf)(fe,q.root.source,!m.$l)&&(fe=(0,E.$ic)(q.root.target,fe.substr(q.root.source.length+1))),await e.Promises.symlink(fe,V)}e.Promises=new class{get access(){return(0,f.promisify)(I.access)}get stat(){return(0,f.promisify)(I.stat)}get lstat(){return(0,f.promisify)(I.lstat)}get utimes(){return(0,f.promisify)(I.utimes)}get read(){return(T,V,q,fe,ee)=>new Promise((Y,X)=>{I.read(T,V,q,fe,ee,(ae,Z,se)=>ae?X(ae):Y({bytesRead:Z,buffer:se}))})}get readFile(){return(0,f.promisify)(I.readFile)}get write(){return(T,V,q,fe,ee)=>new Promise((Y,X)=>{I.write(T,V,q,fe,ee,(ae,Z,se)=>ae?X(ae):Y({bytesWritten:Z,buffer:se}))})}get appendFile(){return(0,f.promisify)(I.appendFile)}get fdatasync(){return(0,f.promisify)(I.fdatasync)}get truncate(){return(0,f.promisify)(I.truncate)}get copyFile(){return(0,f.promisify)(I.copyFile)}get open(){return(0,f.promisify)(I.open)}get close(){return(0,f.promisify)(I.close)}get symlink(){return(0,f.promisify)(I.symlink)}get readlink(){return(0,f.promisify)(I.readlink)}get chmod(){return(0,f.promisify)(I.chmod)}get mkdir(){return(0,f.promisify)(I.mkdir)}get unlink(){return(0,f.promisify)(I.unlink)}get rmdir(){return(0,f.promisify)(I.rmdir)}get realpath(){return(0,f.promisify)(I.realpath)}async exists(T){try{return await e.Promises.access(T),!0}catch{return!1}}get readdir(){return s}get readDirsInDir(){return a}get writeFile(){return u}get rm(){return y}get rename(){return b}get copy(){return C}}}),define(ke[103],Se([1,0,55,16,12,13,30]),function($e,e,I,F,f,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_p=e.$$p=e.$0p=e.$9p=void 0;function p(g){if(f.$l)return g;const y=(0,F.$lc)(g);if(g===y)return g;const S=((0,F.$mc)(g)||g).toLowerCase();try{const c=(0,R.readdirSync)(y).filter(s=>s.toLowerCase()===S);if(c.length===1){const s=p(y);if(s)return(0,F.$ic)(s,c[0])}else if(c.length>1){const s=c.indexOf(S);if(s>=0){const i=p(y);if(i)return(0,F.$ic)(i,c[s])}}}catch{}return null}e.$9p=p;async function E(g){if(f.$l)return g;const y=(0,F.$lc)(g);if(g===y)return g;const S=((0,F.$mc)(g)||g).toLowerCase();try{const c=(await R.Promises.readdir(y)).filter(s=>s.toLowerCase()===S);if(c.length===1){const s=await E(y);if(s)return(0,F.$ic)(s,c[0])}else if(c.length>1){const s=c.indexOf(S);if(s>=0){const i=await E(y);if(i)return(0,F.$ic)(i,c[s])}}}catch{}return null}e.$0p=E;async function m(g){try{return await R.Promises.realpath(g)}catch{const S=P(g);return await R.Promises.access(S,I.constants.R_OK),S}}e.$$p=m;function A(g){try{return I.realpathSync(g)}catch{const S=P(g);return I.accessSync(S,I.constants.R_OK),S}}e.$_p=A;function P(g){return(0,L.$Le)((0,F.$gc)(g),F.sep)}}),define(ke[104],Se([1,0,16,12,49,101,18,30]),function($e,e,I,F,f,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Gl=e.$Fl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function E(P=f.env){return P.comspec||"cmd.exe"}e.$Fl=E;function m(P){let g=[],y=!1;const S=function(w){if(y){g.push(w);return}(!P.send(w,s=>{if(s&&console.error(s),y=!1,g.length>0){const i=g.slice(0);g=[],i.forEach(n=>S(n))}})||F.$j)&&(y=!0)};return{send:S}}e.$Gl=m;var A;(function(P){async function g(y,S,w){if(I.$hc(y))return y;if(S===void 0&&(S=f.cwd()),I.$lc(y)!=="."||(w===void 0&&R.$zf(f.env.PATH)&&(w=f.env.PATH.split(I.$sc)),w===void 0||w.length===0))return I.$ic(S,y);async function s(i){if(await p.Promises.exists(i)){let n;try{n=await p.Promises.stat(i)}catch(o){o.message.startsWith("EACCES")&&(n=await p.Promises.lstat(i))}return n?!n.isDirectory():!1}return!1}for(const i of w){let n;if(I.$hc(i)?n=I.$ic(i,y):n=I.$ic(S,i,y),await s(n))return n;let o=n+".com";if(await s(o)||(o=n+".exe",await s(o)))return o}return I.$ic(S,y)}P.findExecutable=g})(A||(e.win32=A={}))});var He=this&&this.__decorate||function($e,e,I,F){var f=arguments.length,L=f<3?e:F===null?F=Object.getOwnPropertyDescriptor(e,I):F,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate($e,e,I,F);else for(var p=$e.length-1;p>=0;p--)(R=$e[p])&&(L=(f<3?R(L):f>3?R(e,I,L):R(e,I))||L);return f>3&&L&&Object.defineProperty(e,I,L),L};define(ke[82],Se([1,0,19,10,22,21,59,11,4,3,54,13,18]),function($e,e,I,F,f,L,R,p,E,m,A,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ch=e.ProxyChannel=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.RequestInitiator=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=void 0;var y;(function(ee){ee[ee.Promise=100]="Promise",ee[ee.PromiseCancel=101]="PromiseCancel",ee[ee.EventListen=102]="EventListen",ee[ee.EventDispose=103]="EventDispose"})(y||(y={}));function S(ee){switch(ee){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(ee){ee[ee.Initialize=200]="Initialize",ee[ee.PromiseSuccess=201]="PromiseSuccess",ee[ee.PromiseError=202]="PromiseError",ee[ee.PromiseErrorObj=203]="PromiseErrorObj",ee[ee.EventFire=204]="EventFire"})(w||(w={}));function c(ee){switch(ee){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var s;(function(ee){ee[ee.Uninitialized=0]="Uninitialized",ee[ee.Idle=1]="Idle"})(s||(s={}));function i(ee){let Y=0;for(let X=0;;X+=7){const ae=ee.read(1);if(Y|=(ae.buffer[0]&127)<<X,!(ae.buffer[0]&128))return Y}}const n=d(0);function o(ee,Y){if(Y===0){ee.write(n);return}let X=0;for(let Z=Y;Z!==0;Z=Z>>>7)X++;const ae=f.$ce.alloc(X);for(let Z=0;Y!==0;Z++)ae.buffer[Z]=Y&127,Y=Y>>>7,Y>0&&(ae.buffer[Z]|=128);ee.write(ae)}class a{constructor(Y){this.b=Y,this.a=0}read(Y){const X=this.b.slice(this.a,this.a+Y);return this.a+=X.byteLength,X}}e.$rh=a;class t{constructor(){this.a=[]}get buffer(){return f.$ce.concat(this.a)}write(Y){this.a.push(Y)}}e.$sh=t;var r;(function(ee){ee[ee.Undefined=0]="Undefined",ee[ee.String=1]="String",ee[ee.Buffer=2]="Buffer",ee[ee.VSBuffer=3]="VSBuffer",ee[ee.Array=4]="Array",ee[ee.Object=5]="Object",ee[ee.Int=6]="Int"})(r||(r={}));function d(ee){const Y=f.$ce.alloc(1);return Y.writeUInt8(ee,0),Y}const u={Undefined:d(r.Undefined),String:d(r.String),Buffer:d(r.Buffer),VSBuffer:d(r.VSBuffer),Array:d(r.Array),Object:d(r.Object),Uint:d(r.Int)},l=typeof Buffer<"u";function h(ee,Y){if(typeof Y>"u")ee.write(u.Undefined);else if(typeof Y=="string"){const X=f.$ce.fromString(Y);ee.write(u.String),o(ee,X.byteLength),ee.write(X)}else if(l&&Buffer.isBuffer(Y)){const X=f.$ce.wrap(Y);ee.write(u.Buffer),o(ee,X.byteLength),ee.write(X)}else if(Y instanceof f.$ce)ee.write(u.VSBuffer),o(ee,Y.byteLength),ee.write(Y);else if(Array.isArray(Y)){ee.write(u.Array),o(ee,Y.length);for(const X of Y)h(ee,X)}else if(typeof Y=="number"&&(Y|0)===Y)ee.write(u.Uint),o(ee,Y);else{const X=f.$ce.fromString(JSON.stringify(Y));ee.write(u.Object),o(ee,X.byteLength),ee.write(X)}}e.$th=h;function k(ee){switch(ee.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return ee.read(i(ee)).toString();case r.Buffer:return ee.read(i(ee)).buffer;case r.VSBuffer:return ee.read(i(ee));case r.Array:{const X=i(ee),ae=[];for(let Z=0;Z<X;Z++)ae.push(k(ee));return ae}case r.Object:return JSON.parse(ee.read(i(ee)).toString());case r.Int:return i(ee)}}e.$uh=k;class D{constructor(Y,X,ae=null,Z=1e3){this.h=Y,this.j=X,this.k=ae,this.l=Z,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(se=>this.q(se)),this.m({type:200})}registerChannel(Y,X){this.b.set(Y,X),setTimeout(()=>this.w(Y),0)}m(Y){switch(Y.type){case 200:{const X=this.o([Y.type]);this.k?.logOutgoing(X,0,1,c(Y.type));return}case 201:case 202:case 204:case 203:{const X=this.o([Y.type,Y.id],Y.data);this.k?.logOutgoing(X,Y.id,1,c(Y.type),Y.data);return}}}o(Y,X=void 0){const ae=new t;return h(ae,Y),h(ae,X),this.p(ae.buffer)}p(Y){try{return this.h.send(Y),Y.byteLength}catch{return 0}}q(Y){const X=new a(Y),ae=k(X),Z=k(X),se=ae[0];switch(se){case 100:return this.k?.logIncoming(Y.byteLength,ae[1],1,`${S(se)}: ${ae[2]}.${ae[3]}`,Z),this.s({type:se,id:ae[1],channelName:ae[2],name:ae[3],arg:Z});case 102:return this.k?.logIncoming(Y.byteLength,ae[1],1,`${S(se)}: ${ae[2]}.${ae[3]}`,Z),this.t({type:se,id:ae[1],channelName:ae[2],name:ae[3],arg:Z});case 101:return this.k?.logIncoming(Y.byteLength,ae[1],1,`${S(se)}`),this.u({type:se,id:ae[1]});case 103:return this.k?.logIncoming(Y.byteLength,ae[1],1,`${S(se)}`),this.u({type:se,id:ae[1]})}}s(Y){const X=this.b.get(Y.channelName);if(!X){this.v(Y);return}const ae=new L.$Yd;let Z;try{Z=X.call(this.j,Y.name,Y.arg,ae.token)}catch(H){Z=Promise.reject(H)}const se=Y.id;Z.then(H=>{this.m({id:se,data:H,type:201})},H=>{H instanceof Error?this.m({id:se,data:{message:H.message,name:H.name,stack:H.stack?H.stack.split?H.stack.split(`
`):H.stack:void 0},type:202}):this.m({id:se,data:H,type:203})}).finally(()=>{we.dispose(),this.d.delete(Y.id)});const we=(0,m.$Pc)(()=>ae.cancel());this.d.set(Y.id,we)}t(Y){const X=this.b.get(Y.channelName);if(!X){this.v(Y);return}const ae=Y.id,se=X.listen(this.j,Y.name,Y.arg)(we=>this.m({id:ae,data:we,type:204}));this.d.set(Y.id,se)}u(Y){const X=this.d.get(Y.id);X&&(X.dispose(),this.d.delete(Y.id))}v(Y){let X=this.g.get(Y.channelName);X||(X=[],this.g.set(Y.channelName,X));const ae=setTimeout(()=>{console.error(`Unknown channel: ${Y.channelName}`),Y.type===100&&this.m({id:Y.id,data:{name:"Unknown channel",message:`Channel name '${Y.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);X.push({request:Y,timeoutTimer:ae})}w(Y){const X=this.g.get(Y);if(X){for(const ae of X)switch(clearTimeout(ae.timeoutTimer),ae.request.type){case 100:this.s(ae.request);break;case 102:this.t(ae.request);break}this.g.delete(Y)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,m.$Mc)(this.d.values()),this.d.clear()}}e.$vh=D;var $;(function(ee){ee[ee.LocalSide=0]="LocalSide",ee[ee.OtherSide=1]="OtherSide"})($||(e.RequestInitiator=$={}));class b{constructor(Y,X=null){this.l=Y,this.a=!1,this.b=s.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new E.$Od,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ae=>this.s(ae)),this.j=X}getChannel(Y){const X=this;return{call(ae,Z,se){return X.a?Promise.reject(new p.$4):X.m(Y,ae,Z,se)},listen(ae,Z){return X.a?E.Event.None:X.o(Y,ae,Z)}}}m(Y,X,ae,Z=L.CancellationToken.None){const se=this.g++,H={id:se,type:100,channelName:Y,name:X,arg:ae};if(Z.isCancellationRequested)return Promise.reject(new p.$4);let U;return new Promise((Ee,ne)=>{if(Z.isCancellationRequested)return ne(new p.$4);const G=()=>{const le=te=>{switch(te.type){case 201:this.f.delete(se),Ee(te.data);break;case 202:{this.f.delete(se);const de=new Error(te.data.message);de.stack=Array.isArray(te.data.stack)?te.data.stack.join(`
`):te.data.stack,de.name=te.data.name,ne(de);break}case 203:this.f.delete(se),ne(te.data);break}};this.f.set(se,le),this.p(H)};let J=null;this.b===s.Idle?G():(J=(0,F.$Ig)(le=>this.u()),J.then(()=>{J=null,G()}));const ge=()=>{J?(J.cancel(),J=null):this.p({id:se,type:101}),ne(new p.$4)},x=Z.onCancellationRequested(ge);U=(0,m.$Oc)((0,m.$Pc)(ge),x),this.d.add(U)}).finally(()=>{U.dispose(),this.d.delete(U)})}o(Y,X,ae){const Z=this.g++,we={id:Z,type:102,channelName:Y,name:X,arg:ae};let H=null;const U=new E.$Od({onWillAddFirstListener:()=>{H=(0,F.$Ig)(Ee=>this.u()),H.then(()=>{H=null,this.d.add(U),this.p(we)})},onDidRemoveLastListener:()=>{H?(H.cancel(),H=null):(this.d.delete(U),this.p({id:Z,type:103}))}}),ce=Ee=>U.fire(Ee.data);return this.f.set(Z,ce),U.event}p(Y){switch(Y.type){case 100:case 102:{const X=this.q([Y.type,Y.id,Y.channelName,Y.name],Y.arg);this.j?.logOutgoing(X,Y.id,0,`${S(Y.type)}: ${Y.channelName}.${Y.name}`,Y.arg);return}case 101:case 103:{const X=this.q([Y.type,Y.id]);this.j?.logOutgoing(X,Y.id,0,S(Y.type));return}}}q(Y,X=void 0){const ae=new t;return h(ae,Y),h(ae,X),this.r(ae.buffer)}r(Y){try{return this.l.send(Y),Y.byteLength}catch{return 0}}s(Y){const X=new a(Y),ae=k(X),Z=k(X),se=ae[0];switch(se){case 200:return this.j?.logIncoming(Y.byteLength,0,0,c(se)),this.t({type:ae[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(Y.byteLength,ae[1],0,c(se),Z),this.t({type:ae[0],id:ae[1],data:Z})}}t(Y){if(Y.type===200){this.b=s.Idle,this.k.fire();return}this.f.get(Y.id)?.(Y)}get onDidInitializePromise(){return E.Event.toPromise(this.onDidInitialize)}u(){return this.b===s.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,m.$Mc)(this.d.values()),this.d.clear()}}e.$wh=b,He([R.$lh],b.prototype,"onDidInitializePromise",null);class v{get connections(){const Y=[];return this.f.forEach(X=>Y.push(X)),Y}constructor(Y){this.a=new Map,this.f=new Set,this.g=new E.$Od,this.onDidAddConnection=this.g.event,this.h=new E.$Od,this.onDidRemoveConnection=this.h.event,this.j=new m.$Qc,this.j.add(Y(({protocol:X,onDidClientDisconnect:ae})=>{const Z=E.Event.once(X.onMessage);this.j.add(Z(se=>{const we=new a(se),H=k(we),U=new D(X,H),ce=new b(X);this.a.forEach((ne,G)=>U.registerChannel(G,ne));const Ee={channelServer:U,channelClient:ce,ctx:H};this.f.add(Ee),this.g.fire(Ee),this.j.add(ae(()=>{U.dispose(),ce.dispose(),this.f.delete(Ee),this.h.fire(Ee)}))}))}))}getChannel(Y,X){const ae=this;return{call(Z,se,we){let H;if((0,g.$Nf)(X)){const ce=(0,I.$3b)(ae.connections.filter(X));H=ce?Promise.resolve(ce):E.Event.toPromise(E.Event.filter(ae.onDidAddConnection,X))}else H=X.routeCall(ae,Z,se);const U=H.then(ce=>ce.channelClient.getChannel(Y));return N(U).call(Z,se,we)},listen(Z,se){if((0,g.$Nf)(X))return ae.k(Y,X,Z,se);const we=X.routeEvent(ae,Z,se).then(H=>H.channelClient.getChannel(Y));return N(we).listen(Z,se)}}}k(Y,X,ae,Z){const se=this;let we;const H=new E.$Od({onWillAddFirstListener:()=>{we=new m.$Qc;const U=new E.$Ud,ce=new Map,Ee=G=>{const ge=G.channelClient.getChannel(Y).listen(ae,Z),x=U.add(ge);ce.set(G,x)},ne=G=>{const J=ce.get(G);J&&(J.dispose(),ce.delete(G))};se.connections.filter(X).forEach(Ee),E.Event.filter(se.onDidAddConnection,X)(Ee,void 0,we),se.onDidRemoveConnection(ne,void 0,we),U.event(H.fire,H,we),we.add(U)},onDidRemoveLastListener:()=>{we?.dispose(),we=void 0}});return H.event}registerChannel(Y,X){this.a.set(Y,X);for(const ae of this.f)ae.channelServer.registerChannel(Y,X)}dispose(){this.j.dispose();for(const Y of this.f)Y.channelClient.dispose(),Y.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$xh=v;class C{constructor(Y,X,ae=null){const Z=new t;h(Z,X),Y.send(Z.buffer),this.a=new b(Y,ae),this.d=new D(Y,X,ae)}getChannel(Y){return this.a.getChannel(Y)}registerChannel(Y,X){this.d.registerChannel(Y,X)}dispose(){this.a.dispose(),this.d.dispose()}}e.$yh=C;function N(ee){return{call(Y,X,ae){return ee.then(Z=>Z.call(Y,X,ae))},listen(Y,X){const ae=new E.$Xd;return ee.then(Z=>ae.input=Z.listen(Y,X)),ae.event}}}e.$zh=N;function z(ee){let Y=!1;return{call(X,ae,Z){return Y?ee.call(X,ae,Z):(0,F.$Vg)(0).then(()=>Y=!0).then(()=>ee.call(X,ae,Z))},listen(X,ae){if(Y)return ee.listen(X,ae);const Z=new E.$Xd;return(0,F.$Vg)(0).then(()=>Y=!0).then(()=>Z.input=ee.listen(X,ae)),Z.event}}}e.$Ah=z;class M{constructor(Y){this.a=Y}routeCall(Y){return this.b(Y)}routeEvent(Y){return this.b(Y)}async b(Y){for(const X of Y.connections)if(await Promise.resolve(this.a(X.ctx)))return Promise.resolve(X);return await E.Event.toPromise(Y.onDidAddConnection),await this.b(Y)}}e.$Bh=M;var O;(function(ee){function Y(se,we,H){const U=se,ce=H&&H.disableMarshalling,Ee=new Map;for(const ne in U)ae(ne)&&Ee.set(ne,E.Event.buffer(U[ne],!0,void 0,we));return new class{listen(ne,G,J){const ge=Ee.get(G);if(ge)return ge;if(Z(G)){const x=U[G];if(typeof x=="function")return x.call(U,J)}throw new p.$ab(`Event not found: ${G}`)}call(ne,G,J){const ge=U[G];if(typeof ge=="function"){if(!ce&&Array.isArray(J))for(let le=0;le<J.length;le++)J[le]=(0,A.$qh)(J[le]);let x=ge.apply(U,J);return x instanceof Promise||(x=Promise.resolve(x)),x}throw new p.$ab(`Method not found: ${G}`)}}}ee.fromService=Y;function X(se,we){const H=we&&we.disableMarshalling;return new Proxy({},{get(U,ce){if(typeof ce=="string")return we?.properties?.has(ce)?we.properties.get(ce):Z(ce)?function(Ee){return se.listen(ce,Ee)}:ae(ce)?se.listen(ce):async function(...Ee){let ne;we&&!(0,g.$If)(we.context)?ne=[we.context,...Ee]:ne=Ee;const G=await se.call(ce,ne);return H?G:(0,A.$qh)(G)};throw new p.$ab(`Property not found: ${String(ce)}`)}})}ee.toService=X;function ae(se){return se[0]==="o"&&se[1]==="n"&&P.$2e(se.charCodeAt(2))}function Z(se){return/^onDynamic/.test(se)&&P.$2e(se.charCodeAt(9))}})(O||(e.ProxyChannel=O={}));const j=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function T(ee){if(Array.isArray(ee))return ee;if(ee&&typeof ee=="object"&&typeof ee.toString=="function"){const Y=ee.toString();if(Y!=="[object Object]")return Y}return ee}function V(ee){return Array.isArray(ee)?ee.map(T):T(ee)}function q(ee,Y,X,ae,Z,se,we){we=V(we);const H=j[Z],U=H[ae%H.length];let ce=[`%c[${ee}]%c[${String(Y).padStart(7," ")}]%c[len: ${String(X).padStart(5," ")}]%c${String(ae).padStart(5," ")} - ${se}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(se)?(ce=ce.concat(we),ce.push(")")):ce.push(we),console.log.apply(console,ce)}class fe{constructor(Y,X){this.d=Y,this.f=X,this.a=0,this.b=0}logOutgoing(Y,X,ae,Z,se){this.b+=Y,q(this.d,this.b,Y,X,ae,Z,se)}logIncoming(Y,X,ae,Z,se){this.a+=Y,q(this.f,this.a,Y,X,ae,Z,se)}}e.$Ch=fe}),define(ke[83],Se([1,0,22,4,3,82]),function($e,e,I,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.ProtocolConstants=e.$Dh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var R;(function(u){u.Created="created",u.Read="read",u.Write="write",u.Open="open",u.Error="error",u.Close="close",u.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",u.NodeEndReceived="nodeEndReceived",u.NodeEndSent="nodeEndSent",u.NodeDrainBegin="nodeDrainBegin",u.NodeDrainEnd="nodeDrainEnd",u.zlibInflateError="zlibInflateError",u.zlibInflateData="zlibInflateData",u.zlibInflateInitialWrite="zlibInflateInitialWrite",u.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",u.zlibInflateWrite="zlibInflateWrite",u.zlibInflateFlushFired="zlibInflateFlushFired",u.zlibDeflateError="zlibDeflateError",u.zlibDeflateData="zlibDeflateData",u.zlibDeflateWrite="zlibDeflateWrite",u.zlibDeflateFlushFired="zlibDeflateFlushFired",u.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",u.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",u.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",u.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",u.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",u.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",u.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",u.ProtocolHeaderRead="protocolHeaderRead",u.ProtocolMessageRead="protocolMessageRead",u.ProtocolHeaderWrite="protocolHeaderWrite",u.ProtocolMessageWrite="protocolMessageWrite",u.ProtocolWrite="protocolWrite"})(R||(e.SocketDiagnosticsEventType=R={}));var p;(function(u){u.enableDiagnostics=!1,u.records=[];const l=new WeakMap;let h=0;function k($,b){if(!l.has($)){const v=String(++h);l.set($,v)}return l.get($)}function D($,b,v,C){if(!u.enableDiagnostics)return;const N=k($,b);if(C instanceof I.$ce||C instanceof Uint8Array||C instanceof ArrayBuffer||ArrayBuffer.isView(C)){const z=I.$ce.alloc(C.byteLength);z.set(C),u.records.push({timestamp:Date.now(),id:N,label:b,type:v,buff:z})}else u.records.push({timestamp:Date.now(),id:N,label:b,type:v,data:C})}u.traceSocketEvent=D})(p||(e.SocketDiagnostics=p={}));var E;(function(u){u[u.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",u[u.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(E||(e.SocketCloseEventType=E={}));let m=null;function A(){return m||(m=I.$ce.alloc(0)),m}class P{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(l){this.a.push(l),this.b+=l.byteLength}read(l){return this.c(l,!0)}peek(l){return this.c(l,!1)}c(l,h){if(l===0)return A();if(l>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===l){const b=this.a[0];return h&&(this.a.shift(),this.b-=l),b}if(this.a[0].byteLength>l){const b=this.a[0].slice(0,l);return h&&(this.a[0]=this.a[0].slice(l),this.b-=l),b}const k=I.$ce.alloc(l);let D=0,$=0;for(;l>0;){const b=this.a[$];if(b.byteLength>l){const v=b.slice(0,l);k.set(v,D),D+=l,h&&(this.a[$]=b.slice(l),this.b-=l),l-=l}else k.set(b,D),D+=b.byteLength,h?(this.a.shift(),this.b-=b.byteLength):$++,l-=b.byteLength}return k}}e.$Dh=P;var g;(function(u){u[u.None=0]="None",u[u.Regular=1]="Regular",u[u.Control=2]="Control",u[u.Ack=3]="Ack",u[u.Disconnect=5]="Disconnect",u[u.ReplayRequest=6]="ReplayRequest",u[u.Pause=7]="Pause",u[u.Resume=8]="Resume",u[u.KeepAlive=9]="KeepAlive"})(g||(g={}));function y(u){switch(u){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var S;(function(u){u[u.HeaderLength=13]="HeaderLength",u[u.AcknowledgeTime=2e3]="AcknowledgeTime",u[u.TimeoutTime=2e4]="TimeoutTime",u[u.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",u[u.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",u[u.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(S||(e.ProtocolConstants=S={}));class w{constructor(l,h,k,D){this.type=l,this.id=h,this.ack=k,this.data=D,this.writtenTime=0}get size(){return this.data.byteLength}}class c extends f.$Rc{constructor(l){super(),this.f=this.B(new F.$Od),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=l,this.b=!1,this.c=new P,this.B(this.a.onData(h=>this.acceptChunk(h))),this.lastReadTime=Date.now()}acceptChunk(l){if(!(!l||l.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(l);this.c.byteLength>=this.g.readLen;){const h=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=h.readUInt32BE(9),this.g.messageType=h.readUInt8(0),this.g.id=h.readUInt32BE(1),this.g.ack=h.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:y(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const k=this.g.messageType,D=this.g.id,$=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",h),this.f.fire(new w(k,D,$,h)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class s{constructor(l){this.k=null,this.a=!1,this.b=!1,this.c=l,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(l){if(this.a)return;l.writtenTime=Date.now(),this.lastWriteTime=Date.now();const h=I.$ce.alloc(13);h.writeUInt8(l.type,0),h.writeUInt32BE(l.id,1),h.writeUInt32BE(l.ack,5),h.writeUInt32BE(l.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:y(l.type),id:l.id,ack:l.ack,messageSize:l.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",l.data),this.j(h,l.data)}g(l,h){const k=this.f===0;return this.d.push(l,h),this.f+=l.byteLength+h.byteLength,k}h(){const l=I.$ce.concat(this.d,this.f);return this.d.length=0,this.f=0,l}j(l,h){this.g(l,h)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const l=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:l.byteLength}),this.c.write(l)}}class i extends f.$Rc{constructor(l){super(),this.f=new F.$Od,this.onMessage=this.f.event,this.g=new F.$Od,this.onDidDispose=this.g.event,this.a=l,this.b=this.B(new s(this.a)),this.c=this.B(new c(this.a)),this.B(this.c.onMessage(h=>{h.type===1&&this.f.fire(h.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(l){this.b.write(new w(1,0,0,l))}}e.$Eh=i;class n extends L.$yh{static fromSocket(l,h){return new n(new i(l),h)}get onDidDispose(){return this.b.onDidDispose}constructor(l,h,k=null){super(l,h,k),this.b=l}dispose(){super.dispose();const l=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),l.end()}}e.$Fh=n;class o{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new F.$Od({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(l){this.b?this.d.length>0?this.d.push(l):this.a.fire(l):this.d.push(l)}flushBuffer(){this.d=[]}}e.$Gh=o;class a{constructor(l){this.data=l,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let l=0,h=this.a;for(;h;)h=h.next,l++;return l}peek(){return this.a?this.a.data:null}toArray(){const l=[];let h=0,k=this.a;for(;k;)l[h++]=k.data,k=k.next;return l}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(l){const h=new a(l);if(!this.a){this.a=h,this.b=h;return}this.b.next=h,this.b=h}}class r{static{this.a=10}static{this.b=null}static getInstance(){return r.b||(r.b=new r),r.b}constructor(){this.c=[];const l=Date.now();for(let h=0;h<r.a;h++)this.c[h]=l-1e3*h;setInterval(()=>{for(let h=r.a;h>=1;h--)this.c[h]=this.c[h-1];this.c[0]=Date.now()},1e3)}d(){const l=Date.now(),h=(1+r.a)*1e3;let k=0;for(let D=0;D<r.a;D++)l-this.c[D]<=h&&k++;return 1-k/r.a}hasHighLoad(){return this.d()>=.5}}class d{get unacknowledgedCount(){return this.c-this.d}constructor(l){this.u=new o,this.onControlMessage=this.u.event,this.v=new o,this.onMessage=this.v.event,this.w=new o,this.onDidDispose=this.w.event,this.x=new o,this.onSocketClose=this.x.event,this.y=new o,this.onSocketTimeout=this.y.event,this.s=l.loadEstimator??r.getInstance(),this.t=l.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new f.$Qc,this.o=l.socket,this.p=this.r.add(new s(this.o)),this.q=this.r.add(new c(this.o)),this.r.add(this.q.onMessage(h=>this.z(h))),this.r.add(this.o.onClose(h=>this.x.fire(h))),l.initialChunk&&this.q.acceptChunk(l.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const l=new w(5,0,0,A());this.p.write(l),this.p.flush()}sendPause(){const l=new w(7,0,0,A());this.p.write(l)}sendResume(){const l=new w(8,0,0,A());this.p.write(l)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(l,h){this.a=!0,this.r.dispose(),this.r=new f.$Qc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=l,this.p=this.r.add(new s(this.o)),this.q=this.r.add(new c(this.o)),this.r.add(this.q.onMessage(k=>this.z(k))),this.r.add(this.o.onClose(k=>this.x.fire(k))),this.q.acceptChunk(h)}endAcceptReconnection(){this.a=!1,this.h=this.g;const l=new w(3,0,this.h,A());this.p.write(l);const h=this.b.toArray();for(let k=0,D=h.length;k<D;k++)this.p.write(h[k]);this.B()}acceptDisconnect(){this.w.fire()}z(l){if(l.ack>this.d){this.d=l.ack;do{const h=this.b.peek();if(h&&h.id<=l.ack)this.b.pop();else break}while(!0)}switch(l.type){case 0:break;case 1:{if(l.id>this.g)if(l.id!==this.g+1){const h=Date.now();h-this.m>1e4&&(this.m=h,this.p.write(new w(6,0,0,A())))}else this.g=l.id,this.j=Date.now(),this.A(),this.v.fire(l.data);break}case 2:{this.u.fire(l.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const h=this.b.toArray();for(let k=0,D=h.length;k<D;k++)this.p.write(h[k]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(l){const h=++this.c;this.h=this.g;const k=new w(1,h,this.h,l);this.b.push(k),this.a||(this.p.write(k),this.B())}sendControl(l){const h=new w(2,0,0,l);this.p.write(h)}A(){if(this.g<=this.h||this.k)return;const l=Date.now()-this.j;if(l>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-l+5)}B(){if(this.c<=this.d||this.f||this.a)return;const l=this.b.peek(),h=Date.now()-l.writtenTime,k=Date.now()-this.q.lastReadTime,D=Date.now()-this.n;if(h>=2e4&&k>=2e4&&D>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:h,timeSinceLastReceivedSomeData:k});return}const $=Math.max(2e4-h,2e4-k,2e4-D,500);this.f=setTimeout(()=>{this.f=null,this.B()},$)}C(){if(this.g<=this.h)return;this.h=this.g;const l=new w(3,0,this.h,A());this.p.write(l)}D(){this.h=this.g;const l=new w(9,0,this.h,A());this.p.write(l)}}e.$Hh=d}),define(ke[187],Se([1,0,50,10,22,21,185,11,4,3,24,104,101,82]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=e.$6p=void 0;class S extends y.$vh{constructor(s){super({send:i=>{try{process.send?.(i.buffer.toString("base64"))}catch{}},onMessage:E.Event.fromNodeEventEmitter(process,"message",i=>f.$ce.wrap(Buffer.from(i,"base64")))},s),process.once("disconnect",()=>this.dispose())}}e.$6p=S;class w{constructor(s,i){this.i=s,this.j=i,this.c=new Set,this.g=new Map,this.h=new E.$Od,this.onDidProcessExit=this.h.event;const n=i&&i.timeout?i.timeout:6e4;this.b=new F.$Rg(n),this.d=null,this.f=null}getChannel(s){const i=this;return{call(n,o,a){return i.k(s,n,o,a)},listen(n,o){return i.l(s,n,o)}}}k(s,i,n,o=L.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(p.$5());this.b.cancel();const a=this.n(s),t=(0,F.$Ig)(u=>a.call(i,n,u)),r=o.onCancellationRequested(()=>t.cancel()),d=(0,m.$Pc)(()=>t.cancel());return this.c.add(d),t.finally(()=>{r.dispose(),this.c.delete(d),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(s,i,n){if(!this.b)return E.Event.None;this.b.cancel();let o;const a=new E.$Od({onWillAddFirstListener:()=>{o=this.n(s).listen(i,n)(a.fire,a),this.c.add(o)},onDidRemoveLastListener:()=>{this.c.delete(o),o.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return a.event}get m(){if(!this.f){const s=this.j&&this.j.args?this.j.args:[],i=Object.create(null);i.env={...(0,A.$$m)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(i.env={...i.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(i.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(i.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(i.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),i.execArgv===void 0&&(i.execArgv=process.execArgv.filter(l=>!/^--inspect(-brk)?=/.test(l)).filter(l=>!l.startsWith("--vscode-"))),(0,g.$El)(i.env),this.d=(0,I.fork)(this.i,s,i);const n=new E.$Od;E.Event.fromNodeEventEmitter(this.d,"message",l=>l)(l=>{if((0,R.$2p)(l)){(0,R.log)(l,`IPC Library: ${this.j.serverName}`);return}n.fire(f.$ce.wrap(Buffer.from(l,"base64")))});const a=this.j.useQueue?(0,P.$Gl)(this.d):this.d,t=l=>this.d&&this.d.connected&&a.send(l.buffer.toString("base64")),r=n.event,d={send:t,onMessage:r};this.f=new y.$wh(d);const u=()=>this.o();process.once("exit",u),this.d.on("error",l=>console.warn('IPC "'+this.j.serverName+'" errored with '+l)),this.d.on("exit",(l,h)=>{process.removeListener("exit",u),this.c.forEach(k=>(0,m.$Mc)(k)),this.c.clear(),l!==0&&h!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+l+" and signal "+h),this.b?.cancel(),this.o(),this.h.fire({code:l,signal:h})})}return this.f}n(s){let i=this.g.get(s);return i||(i=this.m.getChannel(s),this.g.set(s,i)),i}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$7p=w}),define(ke[188],Se([1,0,10,4,3,54,18]),function($e,e,I,F,f,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7o=e.$6o=e.StorageState=e.$5o=e.StorageHint=void 0;var p;(function(g){g[g.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",g[g.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(p||(e.StorageHint=p={}));function E(g){const y=g;return y?.changed instanceof Map||y?.deleted instanceof Set}e.$5o=E;var m;(function(g){g[g.None=0]="None",g[g.Initialized=1]="Initialized",g[g.Closed=2]="Closed"})(m||(e.StorageState=m={}));class A extends f.$Rc{static{this.a=100}constructor(y,S=Object.create(null)){super(),this.r=y,this.s=S,this.b=this.B(new F.$Rd),this.onDidChangeStorage=this.b.event,this.c=m.None,this.f=new Map,this.g=this.B(new I.$Sg(A.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(y=>this.u(y)))}u(y){this.b.pause();try{y.changed?.forEach((S,w)=>this.w(w,S)),y.deleted?.forEach(S=>this.w(S,void 0))}finally{this.b.resume()}}w(y,S){if(this.c===m.Closed)return;let w=!1;(0,R.$If)(S)?w=this.f.delete(y):this.f.get(y)!==S&&(this.f.set(y,S),w=!0),w&&this.b.fire({key:y,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===m.None&&(this.c=m.Initialized,this.s.hint!==p.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(y,S){const w=this.f.get(y);return(0,R.$If)(w)?S:w}getBoolean(y,S){const w=this.get(y);return(0,R.$If)(w)?S:w==="true"}getNumber(y,S){const w=this.get(y);return(0,R.$If)(w)?S:parseInt(w,10)}getObject(y,S){const w=this.get(y);return(0,R.$If)(w)?S:(0,L.$ph)(w)}async set(y,S,w=!1){if(this.c===m.Closed)return;if((0,R.$If)(S))return this.delete(y,w);const c=(0,R.$Bf)(S)||Array.isArray(S)?(0,L.$oh)(S):String(S);if(this.f.get(y)!==c)return this.f.set(y,c),this.j.set(y,c),this.h.delete(y),this.b.fire({key:y,external:w}),this.D()}async delete(y,S=!1){if(!(this.c===m.Closed||!this.f.delete(y)))return this.h.has(y)||this.h.add(y),this.j.delete(y),this.b.fire({key:y,external:S}),this.D()}async optimize(){if(this.c!==m.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=m.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const y={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(y).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(y){if(this.z)return this.D(y)}async D(y){return this.s.hint===p.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),y)}async whenFlushed(){if(this.z)return new Promise(y=>this.n.push(y))}isInMemory(){return this.s.hint===p.STORAGE_IN_MEMORY}}e.$6o=A;class P{constructor(){this.onDidChangeItemsExternal=F.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(y){y.insert?.forEach((S,w)=>this.a.set(w,S)),y.delete?.forEach(S=>this.a.delete(S))}async optimize(){}async close(){}}e.$7o=P}),define(ke[189],Se([1,0,13,12,22]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rs=e.$Qs=e.$Ps=void 0;let L;function R(){return L||(L=new TextDecoder("UTF-16LE")),L}let p;function E(){return p||(p=new TextDecoder("UTF-16BE")),p}let m;function A(){return m||(m=F.$D()?R():E()),m}e.$Ps=A;function P(S,w,c){const s=new Uint16Array(S.buffer,w,c);return c>0&&(s[0]===65279||s[0]===65534)?g(S,w,c):R().decode(s)}e.$Qs=P;function g(S,w,c){const s=[];let i=0;for(let n=0;n<c;n++){const o=f.$ee(S,w);w+=2,s[i++]=String.fromCharCode(o)}return s.join("")}class y{constructor(w){this.a=w|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const w=new Uint16Array(this.b.buffer,0,this.d);return A().decode(w)}f(){const w=this.e();this.d=0,this.c===null?this.c=[w]:this.c[this.c.length]=w}appendCharCode(w){const c=this.a-this.d;c<=1&&(c===0||I.$7e(w))&&this.f(),this.b[this.d++]=w}appendASCIICharCode(w){this.d===this.a&&this.f(),this.b[this.d++]=w}appendString(w){const c=w.length;if(this.d+c>=this.a){this.f(),this.c[this.c.length]=w;return}for(let s=0;s<c;s++)this.b[this.d++]=w.charCodeAt(s)}}e.$Rs=y}),define(ke[190],Se([1,0,22,189]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ts=e.$Ss=void 0;function f(E){return E.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class L{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(m,A,P,g){this.oldPosition=m,this.oldText=A,this.newPosition=P,this.newText=g}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${f(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${f(this.oldText)}")`:`(replace@${this.oldPosition} "${f(this.oldText)}" with "${f(this.newText)}")`}static a(m){return 4+2*m.length}static c(m,A,P){const g=A.length;I.$he(m,g,P),P+=4;for(let y=0;y<g;y++)I.$fe(m,A.charCodeAt(y),P),P+=2;return P}static d(m,A){const P=I.$ge(m,A);return A+=4,(0,F.$Qs)(m,A,P)}writeSize(){return 4+4+L.a(this.oldText)+L.a(this.newText)}write(m,A){return I.$he(m,this.oldPosition,A),A+=4,I.$he(m,this.newPosition,A),A+=4,A=L.c(m,this.oldText,A),A=L.c(m,this.newText,A),A}static read(m,A,P){const g=I.$ge(m,A);A+=4;const y=I.$ge(m,A);A+=4;const S=L.d(m,A);A+=L.a(S);const w=L.d(m,A);return A+=L.a(w),P.push(new L(g,S,y,w)),A}}e.$Ss=L;function R(E,m){return E===null||E.length===0?m:new p(E,m).compress()}e.$Ts=R;class p{constructor(m,A){this.a=m,this.c=A,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let m=0,A=0,P=this.n(m),g=this.l(A);for(;m<this.f||A<this.h;){if(P===null){this.k(g),g=this.l(++A);continue}if(g===null){this.m(P),P=this.n(++m);continue}if(g.oldEnd<=P.newPosition){this.k(g),g=this.l(++A);continue}if(P.newEnd<=g.oldPosition){this.m(P),P=this.n(++m);continue}if(g.oldPosition<P.newPosition){const[s,i]=p.r(g,P.newPosition-g.oldPosition);this.k(s),g=i;continue}if(P.newPosition<g.oldPosition){const[s,i]=p.q(P,g.oldPosition-P.newPosition);this.m(s),P=i;continue}let w,c;if(g.oldEnd===P.newEnd)w=P,c=g,P=this.n(++m),g=this.l(++A);else if(g.oldEnd<P.newEnd){const[s,i]=p.q(P,g.oldLength);w=s,c=g,P=i,g=this.l(++A)}else{const[s,i]=p.r(g,P.newLength);w=P,c=s,P=this.n(++m),g=i}this.d[this.e++]=new L(w.oldPosition,w.oldText,c.newPosition,c.newText),this.g+=w.newLength-w.oldLength,this.j+=c.newLength-c.oldLength}const y=p.s(this.d);return p.t(y)}k(m){this.d[this.e++]=p.o(this.g,m),this.j+=m.newLength-m.oldLength}l(m){return m<this.h?this.c[m]:null}m(m){this.d[this.e++]=p.p(this.j,m),this.g+=m.newLength-m.oldLength}n(m){return m<this.f?this.a[m]:null}static o(m,A){return new L(A.oldPosition-m,A.oldText,A.newPosition,A.newText)}static p(m,A){return new L(A.oldPosition,A.oldText,A.newPosition+m,A.newText)}static q(m,A){const P=m.newText.substr(0,A),g=m.newText.substr(A);return[new L(m.oldPosition,m.oldText,m.newPosition,P),new L(m.oldEnd,"",m.newPosition+A,g)]}static r(m,A){const P=m.oldText.substr(0,A),g=m.oldText.substr(A);return[new L(m.oldPosition,P,m.newPosition,m.newText),new L(m.oldPosition+A,g,m.newEnd,"")]}static s(m){if(m.length===0)return m;const A=[];let P=0,g=m[0];for(let y=1;y<m.length;y++){const S=m[y];g.oldEnd===S.oldPosition?g=new L(g.oldPosition,g.oldText+S.oldText,g.newPosition,g.newText+S.newText):(A[P++]=g,g=S)}return A[P++]=g,A}static t(m){if(m.length===0)return m;const A=[];let P=0;for(let g=0;g<m.length;g++){const y=m[g];y.oldText!==y.newText&&(A[P++]=y)}return A}}}),define(ke[191],Se([1,0,34,16]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HE=void 0;function f(L,R,p,E,m,A){if(Array.isArray(L)){let P=0;for(const g of L){const y=f(g,R,p,E,m,A);if(y===10)return y;y>P&&(P=y)}return P}else{if(typeof L=="string")return E?L==="*"?5:L===p?10:0:0;if(L){const{language:P,pattern:g,scheme:y,hasAccessToAllModels:S,notebookType:w}=L;if(!E&&!S)return 0;w&&m&&(R=m);let c=0;if(y)if(y===R.scheme)c=10;else if(y==="*")c=5;else return 0;if(P)if(P===p)c=10;else if(P==="*")c=Math.max(c,5);else return 0;if(w)if(w===A)c=10;else if(w==="*"&&A!==void 0)c=Math.max(c,5);else return 0;if(g){let s;if(typeof g=="string"?s=g:s={...g,base:(0,F.$gc)(g.base)},s===R.fsPath||(0,I.$zj)(s,R.fsPath))c=10;else return 0}return c}else return 0}}e.$HE=f}),define(ke[192],Se([1,0,4,13,29,80,128,167,190,3]),function($e,e,I,F,f,L,R,p,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JB=void 0;class A extends m.$Rc{constructor(g,y,S,w,c,s,i){super(),this.m=this.B(new I.$Od),this.onDidChangeContent=this.m.event,this.f=y,this.j=!s,this.g=w,this.h=c,this.c=new R.$IB(g,S,i)}equals(g){return!(g instanceof A)||this.f!==g.f||this.getEOL()!==g.getEOL()?!1:this.c.equal(g.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(g){return this.c.createSnapshot(g?this.f:"")}getOffsetAt(g,y){return this.c.getOffsetAt(g,y)}getPositionAt(g){return this.c.getPositionAt(g)}getRangeAt(g,y){const S=g+y,w=this.getPositionAt(g),c=this.getPositionAt(S);return new f.$xs(w.lineNumber,w.column,c.lineNumber,c.column)}getValueInRange(g,y=0){if(g.isEmpty())return"";const S=this.n(y);return this.c.getValueInRange(g,S)}getValueLengthInRange(g,y=0){if(g.isEmpty())return 0;if(g.startLineNumber===g.endLineNumber)return g.endColumn-g.startColumn;const S=this.getOffsetAt(g.startLineNumber,g.startColumn),w=this.getOffsetAt(g.endLineNumber,g.endColumn);let c=0;const s=this.n(y),i=this.getEOL();if(s.length!==i.length){const n=s.length-i.length,o=g.endLineNumber-g.startLineNumber;c=n*o}return w-S+c}getCharacterCountInRange(g,y=0){if(this.j){let S=0;const w=g.startLineNumber,c=g.endLineNumber;for(let s=w;s<=c;s++){const i=this.getLineContent(s),n=s===w?g.startColumn-1:0,o=s===c?g.endColumn-1:i.length;for(let a=n;a<o;a++)F.$7e(i.charCodeAt(a))?(S=S+1,a=a+1):S=S+1}return S+=this.n(y).length*(c-w),S}return this.getValueLengthInRange(g,y)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(g){return this.c.getLineContent(g)}getLineCharCode(g,y){return this.c.getLineCharCode(g,y)}getCharCode(g){return this.c.getCharCode(g)}getLineLength(g){return this.c.getLineLength(g)}getLineMinColumn(g){return 1}getLineMaxColumn(g){return this.getLineLength(g)+1}getLineFirstNonWhitespaceColumn(g){const y=F.$Re(this.getLineContent(g));return y===-1?0:y+1}getLineLastNonWhitespaceColumn(g){const y=F.$Te(this.getLineContent(g));return y===-1?0:y+2}n(g){switch(g){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(g){this.c.setEOL(g)}applyEdits(g,y,S){let w=this.g,c=this.h,s=this.j,i=!0,n=[];for(let l=0;l<g.length;l++){const h=g[l];i&&h._isTracked&&(i=!1);const k=h.range;if(h.text){let C=!0;s||(C=!F.$ff(h.text),s=C),!w&&C&&(w=F.$ef(h.text)),!c&&C&&(c=F.$hf(h.text))}let D="",$=0,b=0,v=0;if(h.text){let C;[$,b,v,C]=(0,p.$0s)(h.text);const N=this.getEOL();C===0||C===(N===`\r
`?2:1)?D=h.text:D=h.text.replace(/\r\n|\r|\n/g,N)}n[l]={sortIndex:l,identifier:h.identifier||null,range:k,rangeOffset:this.getOffsetAt(k.startLineNumber,k.startColumn),rangeLength:this.getValueLengthInRange(k),text:D,eolCount:$,firstLineLength:b,lastLineLength:v,forceMoveMarkers:!!h.forceMoveMarkers,isAutoWhitespaceEdit:h.isAutoWhitespaceEdit||!1}}n.sort(A.u);let o=!1;for(let l=0,h=n.length-1;l<h;l++){const k=n[l].range.getEndPosition(),D=n[l+1].range.getStartPosition();if(D.isBeforeOrEqual(k)){if(D.isBefore(k))throw new Error("Overlapping ranges are not allowed!");o=!0}}i&&(n=this.s(n));const a=S||y?A._getInverseEditRanges(n):[],t=[];if(y)for(let l=0;l<n.length;l++){const h=n[l],k=a[l];if(h.isAutoWhitespaceEdit&&h.range.isEmpty())for(let D=k.startLineNumber;D<=k.endLineNumber;D++){let $="";D===k.startLineNumber&&($=this.getLineContent(h.range.startLineNumber),F.$Re($)!==-1)||t.push({lineNumber:D,oldContent:$})}}let r=null;if(S){let l=0;r=[];for(let h=0;h<n.length;h++){const k=n[h],D=a[h],$=this.getValueInRange(k.range),b=k.rangeOffset+l;l+=k.text.length-$.length,r[h]={sortIndex:k.sortIndex,identifier:k.identifier,range:D,text:$,textChange:new E.$Ss(k.rangeOffset,$,b,k.text)}}o||r.sort((h,k)=>h.sortIndex-k.sortIndex)}this.g=w,this.h=c,this.j=s;const d=this.t(n);let u=null;if(y&&t.length>0){t.sort((l,h)=>h.lineNumber-l.lineNumber),u=[];for(let l=0,h=t.length;l<h;l++){const k=t[l].lineNumber;if(l>0&&t[l-1].lineNumber===k)continue;const D=t[l].oldContent,$=this.getLineContent(k);$.length===0||$===D||F.$Re($)!==-1||u.push(k)}}return this.m.fire(),new L.$Su(r,d,u)}s(g){return g.length<1e3?g:[this._toSingleEditOperation(g)]}_toSingleEditOperation(g){let y=!1;const S=g[0].range,w=g[g.length-1].range,c=new f.$xs(S.startLineNumber,S.startColumn,w.endLineNumber,w.endColumn);let s=S.startLineNumber,i=S.startColumn;const n=[];for(let d=0,u=g.length;d<u;d++){const l=g[d],h=l.range;y=y||l.forceMoveMarkers,n.push(this.getValueInRange(new f.$xs(s,i,h.startLineNumber,h.startColumn))),l.text.length>0&&n.push(l.text),s=h.endLineNumber,i=h.endColumn}const o=n.join(""),[a,t,r]=(0,p.$0s)(o);return{sortIndex:0,identifier:g[0].identifier,range:c,rangeOffset:this.getOffsetAt(c.startLineNumber,c.startColumn),rangeLength:this.getValueLengthInRange(c,0),text:o,eolCount:a,firstLineLength:t,lastLineLength:r,forceMoveMarkers:y,isAutoWhitespaceEdit:!1}}t(g){g.sort(A.w);const y=[];for(let S=0;S<g.length;S++){const w=g[S],c=w.range.startLineNumber,s=w.range.startColumn,i=w.range.endLineNumber,n=w.range.endColumn;if(c===i&&s===n&&w.text.length===0)continue;w.text?(this.c.delete(w.rangeOffset,w.rangeLength),this.c.insert(w.rangeOffset,w.text,!0)):this.c.delete(w.rangeOffset,w.rangeLength);const o=new f.$xs(c,s,i,n);y.push({range:o,rangeLength:w.rangeLength,text:w.text,rangeOffset:w.rangeOffset,forceMoveMarkers:w.forceMoveMarkers})}return y}findMatchesLineByLine(g,y,S,w){return this.c.findMatchesLineByLine(g,y,S,w)}getPieceTree(){return this.c}static _getInverseEditRange(g,y){const S=g.startLineNumber,w=g.startColumn,[c,s,i]=(0,p.$0s)(y);let n;if(y.length>0){const o=c+1;o===1?n=new f.$xs(S,w,S,w+s):n=new f.$xs(S,w,S+o-1,i+1)}else n=new f.$xs(S,w,S,w);return n}static _getInverseEditRanges(g){const y=[];let S=0,w=0,c=null;for(let s=0,i=g.length;s<i;s++){const n=g[s];let o,a;c?c.range.endLineNumber===n.range.startLineNumber?(o=S,a=w+(n.range.startColumn-c.range.endColumn)):(o=S+(n.range.startLineNumber-c.range.endLineNumber),a=n.range.startColumn):(o=n.range.startLineNumber,a=n.range.startColumn);let t;if(n.text.length>0){const r=n.eolCount+1;r===1?t=new f.$xs(o,a,o,a+n.firstLineLength):t=new f.$xs(o,a,o+r-1,n.lastLineLength+1)}else t=new f.$xs(o,a,o,a);S=t.endLineNumber,w=t.endColumn,y.push(t),c=n}return y}static u(g,y){const S=f.$xs.compareRangesUsingEnds(g.range,y.range);return S===0?g.sortIndex-y.sortIndex:S}static w(g,y){const S=f.$xs.compareRangesUsingEnds(g.range,y.range);return S===0?y.sortIndex-g.sortIndex:-S}}e.$JB=A}),define(ke[193],Se([1,0,13,128,192]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KB=void 0;class L{constructor(E,m,A,P,g,y,S,w,c){this.a=E,this.b=m,this.c=A,this.d=P,this.e=g,this.f=y,this.g=S,this.h=w,this.j=c}k(E){const m=this.c+this.d+this.e,A=this.c+this.e;return m===0?E===1?`
`:`\r
`:A>m/2?`\r
`:`
`}create(E){const m=this.k(E),A=this.a;if(this.j&&(m===`\r
`&&(this.c>0||this.d>0)||m===`
`&&(this.c>0||this.e>0)))for(let g=0,y=A.length;g<y;g++){const S=A[g].buffer.replace(/\r\n|\r|\n/g,m),w=(0,F.$EB)(S);A[g]=new F.$HB(S,w)}const P=new f.$JB(A,this.b,m,this.f,this.g,this.h,this.j);return{textBuffer:P,disposable:P}}getFirstLineText(E){return this.a[0].buffer.substr(0,E).split(/\r\n|\r|\n/)[0]}}class R{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(E){if(E.length===0)return;this.a.length===0&&I.$nf(E)&&(this.b=I.$mf,E=E.substr(1));const m=E.charCodeAt(E.length-1);m===13||m>=55296&&m<=56319?(this.m(E.substr(0,E.length-1),!1),this.c=!0,this.d=m):(this.m(E,!1),this.c=!1,this.d=m)}m(E,m){!m&&E.length===0||(this.c?this.n(String.fromCharCode(this.d)+E):this.n(E))}n(E){const m=(0,F.$FB)(this.e,E);this.a.push(new F.$HB(E,m.lineStarts)),this.f+=m.cr,this.g+=m.lf,this.h+=m.crlf,m.isBasicASCII||(this.l=!1,this.j||(this.j=I.$ef(E)),this.k||(this.k=I.$hf(E)))}finish(E=!0){return this.o(),new L(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,E)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const E=this.a[this.a.length-1];E.buffer+=String.fromCharCode(this.d);const m=(0,F.$EB)(E.buffer);E.lineStarts=m,this.d===13&&this.f++}}}e.$KB=R}),define(ke[132],Se([1,0,22,12]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u$=e.$t$=void 0;var f;(function(P){P[P.Full=1]="Full",P[P.Delta=2]="Delta"})(f||(f={}));function L(P){for(let g=0,y=P.length;g<y;g+=4){const S=P[g+0],w=P[g+1],c=P[g+2],s=P[g+3];P[g+0]=s,P[g+1]=c,P[g+2]=w,P[g+3]=S}}function R(P){const g=new Uint8Array(P.buffer,P.byteOffset,P.length*4);return F.$D()||L(g),I.$ce.wrap(g)}function p(P){const g=P.buffer;if(F.$D()||L(g),g.byteOffset%4===0)return new Uint32Array(g.buffer,g.byteOffset,g.length/4);{const y=new Uint8Array(g.byteLength);return y.set(g),new Uint32Array(y.buffer,y.byteOffset,y.length/4)}}function E(P){const g=new Uint32Array(m(P));let y=0;if(g[y++]=P.id,P.type==="full")g[y++]=1,g[y++]=P.data.length,g.set(P.data,y),y+=P.data.length;else{g[y++]=2,g[y++]=P.deltas.length;for(const S of P.deltas)g[y++]=S.start,g[y++]=S.deleteCount,S.data?(g[y++]=S.data.length,g.set(S.data,y),y+=S.data.length):g[y++]=0}return R(g)}e.$t$=E;function m(P){let g=0;if(g+=1+1,P.type==="full")g+=1+P.data.length;else{g+=1,g+=(1+1+1)*P.deltas.length;for(const y of P.deltas)y.data&&(g+=y.data.length)}return g}function A(P){const g=p(P);let y=0;const S=g[y++];if(g[y++]===1){const i=g[y++],n=g.subarray(y,y+i);return y+=i,{id:S,type:"full",data:n}}const c=g[y++],s=[];for(let i=0;i<c;i++){const n=g[y++],o=g[y++],a=g[y++];let t;a>0&&(t=g.subarray(y,y+a),y+=a),s[i]={start:n,deleteCount:o,data:t}}return{id:S,type:"delta",deltas:s}}e.$u$=A}),define(ke[194],Se([8,9]),function($e,e){return $e.create("vs/editor/common/config/editorOptions",e)}),define(ke[133],Se([1,0,19,24,12,170,127,194]),function($e,e,I,F,f,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var E;(function(he){he[he.None=0]="None",he[he.Keep=1]="Keep",he[he.Brackets=2]="Brackets",he[he.Advanced=3]="Advanced",he[he.Full=4]="Full"})(E||(e.EditorAutoIndentStrategy=E={})),e.MINIMAP_GUTTER_WIDTH=8;class m{constructor(ue){this.c=ue}hasChanged(ue){return this.c[ue]}}e.ConfigurationChangedEvent=m;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class P{constructor(ue,Ie,Ke,Ue){this.id=ue,this.name=Ie,this.defaultValue=Ke,this.schema=Ue}applyUpdate(ue,Ie){return y(ue,Ie)}compute(ue,Ie,Ke){return Ke}}class g{constructor(ue,Ie){this.newValue=ue,this.didChange=Ie}}e.ApplyUpdateResult=g;function y(he,ue){if(typeof he!="object"||typeof ue!="object"||!he||!ue)return new g(ue,he!==ue);if(Array.isArray(he)||Array.isArray(ue)){const Ke=Array.isArray(he)&&Array.isArray(ue)&&I.$tb(he,ue);return new g(ue,!Ke)}let Ie=!1;for(const Ke in ue)if(ue.hasOwnProperty(Ke)){const Ue=y(he[Ke],ue[Ke]);Ue.didChange&&(he[Ke]=Ue.newValue,Ie=!0)}return new g(he,Ie)}class S{constructor(ue){this.schema=void 0,this.id=ue,this.name="_never_",this.defaultValue=void 0}applyUpdate(ue,Ie){return y(ue,Ie)}validate(ue){return this.defaultValue}}class w{constructor(ue,Ie,Ke,Ue){this.id=ue,this.name=Ie,this.defaultValue=Ke,this.schema=Ue}applyUpdate(ue,Ie){return y(ue,Ie)}validate(ue){return typeof ue>"u"?this.defaultValue:ue}compute(ue,Ie,Ke){return Ke}}function c(he,ue){return typeof he>"u"?ue:he==="false"?!1:!!he}e.boolean=c;class s extends w{constructor(ue,Ie,Ke,Ue=void 0){typeof Ue<"u"&&(Ue.type="boolean",Ue.default=Ke),super(ue,Ie,Ke,Ue)}validate(ue){return c(ue,this.defaultValue)}}function i(he,ue,Ie,Ke){if(typeof he>"u")return ue;let Ue=parseInt(he,10);return isNaN(Ue)?ue:(Ue=Math.max(Ie,Ue),Ue=Math.min(Ke,Ue),Ue|0)}e.clampedInt=i;class n extends w{static clampedInt(ue,Ie,Ke,Ue){return i(ue,Ie,Ke,Ue)}constructor(ue,Ie,Ke,Ue,Ze,nt=void 0){typeof nt<"u"&&(nt.type="integer",nt.default=Ke,nt.minimum=Ue,nt.maximum=Ze),super(ue,Ie,Ke,nt),this.minimum=Ue,this.maximum=Ze}validate(ue){return n.clampedInt(ue,this.defaultValue,this.minimum,this.maximum)}}function o(he,ue,Ie,Ke){if(typeof he>"u")return ue;const Ue=a.float(he,ue);return a.clamp(Ue,Ie,Ke)}e.clampedFloat=o;class a extends w{static clamp(ue,Ie,Ke){return ue<Ie?Ie:ue>Ke?Ke:ue}static float(ue,Ie){if(typeof ue=="number")return ue;if(typeof ue>"u")return Ie;const Ke=parseFloat(ue);return isNaN(Ke)?Ie:Ke}constructor(ue,Ie,Ke,Ue,Ze){typeof Ze<"u"&&(Ze.type="number",Ze.default=Ke),super(ue,Ie,Ke,Ze),this.validationFn=Ue}validate(ue){return this.validationFn(a.float(ue,this.defaultValue))}}class t extends w{static string(ue,Ie){return typeof ue!="string"?Ie:ue}constructor(ue,Ie,Ke,Ue=void 0){typeof Ue<"u"&&(Ue.type="string",Ue.default=Ke),super(ue,Ie,Ke,Ue)}validate(ue){return t.string(ue,this.defaultValue)}}function r(he,ue,Ie,Ke){return typeof he!="string"?ue:Ke&&he in Ke?Ke[he]:Ie.indexOf(he)===-1?ue:he}e.stringSet=r;class d extends w{constructor(ue,Ie,Ke,Ue,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.enum=Ue,Ze.default=Ke),super(ue,Ie,Ke,Ze),this.c=Ue}validate(ue){return r(ue,this.defaultValue,this.c)}}class u extends P{constructor(ue,Ie,Ke,Ue,Ze,nt,ct=void 0){typeof ct<"u"&&(ct.type="string",ct.enum=Ze,ct.default=Ue),super(ue,Ie,Ke,ct),this.c=Ze,this.d=nt}validate(ue){return typeof ue!="string"?this.defaultValue:this.c.indexOf(ue)===-1?this.defaultValue:this.d(ue)}}function l(he){switch(he){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class h extends P{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[p.localize(0,null),p.localize(1,null),p.localize(2,null)],default:"auto",tags:["accessibility"],description:p.localize(3,null)})}validate(ue){switch(ue){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ue,Ie,Ke){return Ke===0?ue.accessibilitySupport:Ke}}class k extends P{constructor(){const ue={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",ue,{"editor.comments.insertSpace":{type:"boolean",default:ue.insertSpace,description:p.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ue.ignoreEmptyLines,description:p.localize(5,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{insertSpace:c(Ie.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:c(Ie.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var D;(function(he){he[he.Hidden=0]="Hidden",he[he.Blink=1]="Blink",he[he.Smooth=2]="Smooth",he[he.Phase=3]="Phase",he[he.Expand=4]="Expand",he[he.Solid=5]="Solid"})(D||(e.TextEditorCursorBlinkingStyle=D={}));function $(he){switch(he){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var b;(function(he){he[he.Line=1]="Line",he[he.Block=2]="Block",he[he.Underline=3]="Underline",he[he.LineThin=4]="LineThin",he[he.BlockOutline=5]="BlockOutline",he[he.UnderlineThin=6]="UnderlineThin"})(b||(e.TextEditorCursorStyle=b={}));function v(he){switch(he){case b.Line:return"line";case b.Block:return"block";case b.Underline:return"underline";case b.LineThin:return"line-thin";case b.BlockOutline:return"block-outline";case b.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=v;function C(he){switch(he){case"line":return b.Line;case"block":return b.Block;case"underline":return b.Underline;case"line-thin":return b.LineThin;case"block-outline":return b.BlockOutline;case"underline-thin":return b.UnderlineThin}}class N extends S{constructor(){super(141)}compute(ue,Ie,Ke){const Ue=["monaco-editor"];return Ie.get(39)&&Ue.push(Ie.get(39)),ue.extraEditorClassName&&Ue.push(ue.extraEditorClassName),Ie.get(73)==="default"?Ue.push("mouse-default"):Ie.get(73)==="copy"&&Ue.push("mouse-copy"),Ie.get(111)&&Ue.push("showUnused"),Ie.get(139)&&Ue.push("showDeprecated"),Ue.join(" ")}}class z extends s{constructor(){super(37,"emptySelectionClipboard",!0,{description:p.localize(6,null)})}compute(ue,Ie,Ke){return Ke&&ue.emptySelectionClipboard}}class M extends P{constructor(){const ue={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",ue,{"editor.find.cursorMoveOnType":{type:"boolean",default:ue.cursorMoveOnType,description:p.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ue.seedSearchStringFromSelection,enumDescriptions:[p.localize(8,null),p.localize(9,null),p.localize(10,null)],description:p.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ue.autoFindInSelection,enumDescriptions:[p.localize(12,null),p.localize(13,null),p.localize(14,null)],description:p.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ue.globalFindClipboard,description:p.localize(16,null),included:f.$k},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ue.addExtraSpaceOnTop,description:p.localize(17,null)},"editor.find.loop":{type:"boolean",default:ue.loop,description:p.localize(18,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{cursorMoveOnType:c(Ie.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ue.seedSearchStringFromSelection=="boolean"?ue.seedSearchStringFromSelection?"always":"never":r(Ie.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ue.autoFindInSelection=="boolean"?ue.autoFindInSelection?"always":"never":r(Ie.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:c(Ie.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:c(Ie.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:c(Ie.loop,this.defaultValue.loop)}}}class O extends P{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",O.OFF,{anyOf:[{type:"boolean",description:p.localize(19,null)},{type:"string",description:p.localize(20,null)}],description:p.localize(21,null),default:!1})}validate(ue){return typeof ue>"u"?this.defaultValue:typeof ue=="string"?ue==="false"?O.OFF:ue==="true"?O.ON:ue:ue?O.ON:O.OFF}}e.EditorFontLigatures=O;class j extends P{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",j.OFF,{anyOf:[{type:"boolean",description:p.localize(22,null)},{type:"string",description:p.localize(23,null)}],description:p.localize(24,null),default:!1})}validate(ue){return typeof ue>"u"?this.defaultValue:typeof ue=="string"?ue==="false"?j.OFF:ue==="true"?j.TRANSLATE:ue:ue?j.TRANSLATE:j.OFF}compute(ue,Ie,Ke){return ue.fontInfo.fontVariationSettings}}e.EditorFontVariations=j;class T extends S{constructor(){super(50)}compute(ue,Ie,Ke){return ue.fontInfo}}class V extends w{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:p.localize(25,null)})}validate(ue){const Ie=a.float(ue,this.defaultValue);return Ie===0?e.EDITOR_FONT_DEFAULTS.fontSize:a.clamp(Ie,6,100)}compute(ue,Ie,Ke){return ue.fontInfo.fontSize}}class q extends P{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:q.d,maximum:q.e,errorMessage:p.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:q.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:p.localize(27,null)})}validate(ue){return ue==="normal"||ue==="bold"?ue:String(n.clampedInt(ue,e.EDITOR_FONT_DEFAULTS.fontWeight,q.d,q.e))}}class fe extends P{constructor(){const ue={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ie={type:"string",enum:["peek","gotoAndPeek","goto"],default:ue.multiple,enumDescriptions:[p.localize(28,null),p.localize(29,null),p.localize(30,null)]},Ke=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",ue,{"editor.gotoLocation.multiple":{deprecationMessage:p.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:p.localize(32,null),...Ie},"editor.gotoLocation.multipleTypeDefinitions":{description:p.localize(33,null),...Ie},"editor.gotoLocation.multipleDeclarations":{description:p.localize(34,null),...Ie},"editor.gotoLocation.multipleImplementations":{description:p.localize(35,null),...Ie},"editor.gotoLocation.multipleReferences":{description:p.localize(36,null),...Ie},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ue.alternativeDefinitionCommand,enum:Ke,description:p.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ue.alternativeTypeDefinitionCommand,enum:Ke,description:p.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ue.alternativeDeclarationCommand,enum:Ke,description:p.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ue.alternativeImplementationCommand,enum:Ke,description:p.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ue.alternativeReferenceCommand,enum:Ke,description:p.localize(41,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{multiple:r(Ie.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ie.multipleDefinitions??r(Ie.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ie.multipleTypeDefinitions??r(Ie.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ie.multipleDeclarations??r(Ie.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ie.multipleImplementations??r(Ie.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ie.multipleReferences??r(Ie.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ie.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ie.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ie.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ie.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ie.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ee extends P{constructor(){const ue={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",ue,{"editor.hover.enabled":{type:"boolean",default:ue.enabled,description:p.localize(42,null)},"editor.hover.delay":{type:"number",default:ue.delay,minimum:0,maximum:1e4,description:p.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:ue.sticky,description:p.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:ue.hidingDelay,description:p.localize(45,null)},"editor.hover.above":{type:"boolean",default:ue.above,description:p.localize(46,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:c(Ie.enabled,this.defaultValue.enabled),delay:n.clampedInt(Ie.delay,this.defaultValue.delay,0,1e4),sticky:c(Ie.sticky,this.defaultValue.sticky),hidingDelay:n.clampedInt(Ie.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:c(Ie.above,this.defaultValue.above)}}}var Y;(function(he){he[he.None=0]="None",he[he.Text=1]="Text",he[he.Blocks=2]="Blocks"})(Y||(e.RenderMinimap=Y={}));class X extends S{constructor(){super(144)}compute(ue,Ie,Ke){return X.computeLayout(Ie,{memory:ue.memory,outerWidth:ue.outerWidth,outerHeight:ue.outerHeight,isDominatedByLongLines:ue.isDominatedByLongLines,lineHeight:ue.fontInfo.lineHeight,viewLineCount:ue.viewLineCount,lineNumbersDigitCount:ue.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ue.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ue.fontInfo.maxDigitWidth,pixelRatio:ue.pixelRatio,glyphMarginDecorationLaneCount:ue.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(ue){const Ie=ue.height/ue.lineHeight,Ke=Math.floor(ue.paddingTop/ue.lineHeight);let Ue=Math.floor(ue.paddingBottom/ue.lineHeight);ue.scrollBeyondLastLine&&(Ue=Math.max(Ue,Ie-1));const Ze=(Ke+ue.viewLineCount+Ue)/(ue.pixelRatio*ue.height),nt=Math.floor(ue.viewLineCount/Ze);return{typicalViewportLineCount:Ie,extraLinesBeforeFirstLine:Ke,extraLinesBeyondLastLine:Ue,desiredRatio:Ze,minimapLineCount:nt}}static c(ue,Ie){const Ke=ue.outerWidth,Ue=ue.outerHeight,Ze=ue.pixelRatio;if(!ue.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ze*Ue),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ue};const nt=Ie.stableMinimapLayoutInput,ct=nt&&ue.outerHeight===nt.outerHeight&&ue.lineHeight===nt.lineHeight&&ue.typicalHalfwidthCharacterWidth===nt.typicalHalfwidthCharacterWidth&&ue.pixelRatio===nt.pixelRatio&&ue.scrollBeyondLastLine===nt.scrollBeyondLastLine&&ue.paddingTop===nt.paddingTop&&ue.paddingBottom===nt.paddingBottom&&ue.minimap.enabled===nt.minimap.enabled&&ue.minimap.side===nt.minimap.side&&ue.minimap.size===nt.minimap.size&&ue.minimap.showSlider===nt.minimap.showSlider&&ue.minimap.renderCharacters===nt.minimap.renderCharacters&&ue.minimap.maxColumn===nt.minimap.maxColumn&&ue.minimap.scale===nt.minimap.scale&&ue.verticalScrollbarWidth===nt.verticalScrollbarWidth&&ue.isViewportWrapping===nt.isViewportWrapping,bt=ue.lineHeight,Et=ue.typicalHalfwidthCharacterWidth,Kt=ue.scrollBeyondLastLine,Ht=ue.minimap.renderCharacters;let wt=Ze>=2?Math.round(ue.minimap.scale*2):ue.minimap.scale;const zt=ue.minimap.maxColumn,Ot=ue.minimap.size,Gt=ue.minimap.side,Ut=ue.verticalScrollbarWidth,Dt=ue.viewLineCount,Ft=ue.remainingWidth,Bt=ue.isViewportWrapping,Jt=Ht?2:3;let Wt=Math.floor(Ze*Ue);const Vt=Wt/Ze;let Nt=!1,ut=!1,ft=Jt*wt,At=wt/Ze,qt=1;if(Ot==="fill"||Ot==="fit"){const{typicalViewportLineCount:Qt,extraLinesBeforeFirstLine:Me,extraLinesBeyondLastLine:Te,desiredRatio:Ce,minimapLineCount:ie}=X.computeContainedMinimapLineCount({viewLineCount:Dt,scrollBeyondLastLine:Kt,paddingTop:ue.paddingTop,paddingBottom:ue.paddingBottom,height:Ue,lineHeight:bt,pixelRatio:Ze});if(Dt/ie>1)Nt=!0,ut=!0,wt=1,ft=1,At=wt/Ze;else{let qe=!1,xe=wt+1;if(Ot==="fit"){const Je=Math.ceil((Me+Dt+Te)*ft);Bt&&ct&&Ft<=Ie.stableFitRemainingWidth?(qe=!0,xe=Ie.stableFitMaxMinimapScale):qe=Je>Wt}if(Ot==="fill"||qe){Nt=!0;const Je=wt;ft=Math.min(bt*Ze,Math.max(1,Math.floor(1/Ce))),Bt&&ct&&Ft<=Ie.stableFitRemainingWidth&&(xe=Ie.stableFitMaxMinimapScale),wt=Math.min(xe,Math.max(1,Math.floor(ft/Jt))),wt>Je&&(qt=Math.min(2,wt/Je)),At=wt/Ze/qt,Wt=Math.ceil(Math.max(Qt,Me+Dt+Te)*ft),Bt?(Ie.stableMinimapLayoutInput=ue,Ie.stableFitRemainingWidth=Ft,Ie.stableFitMaxMinimapScale=wt):(Ie.stableMinimapLayoutInput=null,Ie.stableFitRemainingWidth=0)}}}const Lt=Math.floor(zt*At),at=Math.min(Lt,Math.max(0,Math.floor((Ft-Ut-2)*At/(Et+At)))+e.MINIMAP_GUTTER_WIDTH);let vt=Math.floor(Ze*at);const Tt=vt/Ze;vt=Math.floor(vt*qt);const Pt=Ht?1:2,Ge=Gt==="left"?0:Ke-at-Ut;return{renderMinimap:Pt,minimapLeft:Ge,minimapWidth:at,minimapHeightIsEditorHeight:Nt,minimapIsSampling:ut,minimapScale:wt,minimapLineHeight:ft,minimapCanvasInnerWidth:vt,minimapCanvasInnerHeight:Wt,minimapCanvasOuterWidth:Tt,minimapCanvasOuterHeight:Vt}}static computeLayout(ue,Ie){const Ke=Ie.outerWidth|0,Ue=Ie.outerHeight|0,Ze=Ie.lineHeight|0,nt=Ie.lineNumbersDigitCount|0,ct=Ie.typicalHalfwidthCharacterWidth,bt=Ie.maxDigitWidth,Et=Ie.pixelRatio,Kt=Ie.viewLineCount,Ht=ue.get(136),wt=Ht==="inherit"?ue.get(135):Ht,zt=wt==="inherit"?ue.get(131):wt,Ot=ue.get(134),Gt=Ie.isDominatedByLongLines,Ut=ue.get(57),Dt=ue.get(67).renderType!==0,Ft=ue.get(68),Bt=ue.get(105),Jt=ue.get(84),Wt=ue.get(72),Vt=ue.get(103),Nt=Vt.verticalScrollbarSize,ut=Vt.verticalHasArrows,ft=Vt.arrowSize,At=Vt.horizontalScrollbarSize,qt=ue.get(43),Lt=ue.get(110)!=="never";let at=ue.get(65);qt&&Lt&&(at+=16);let vt=0;if(Dt){const kt=Math.max(nt,Ft);vt=Math.round(kt*bt)}let Tt=0;Ut&&(Tt=Ze*Ie.glyphMarginDecorationLaneCount);let Pt=0,Ge=Pt+Tt,Qt=Ge+vt,Me=Qt+at;const Te=Ke-Tt-vt-at;let Ce=!1,ie=!1,Fe=-1;wt==="inherit"&&Gt?(Ce=!0,ie=!0):zt==="on"||zt==="bounded"?ie=!0:zt==="wordWrapColumn"&&(Fe=Ot);const qe=X.c({outerWidth:Ke,outerHeight:Ue,lineHeight:Ze,typicalHalfwidthCharacterWidth:ct,pixelRatio:Et,scrollBeyondLastLine:Bt,paddingTop:Jt.top,paddingBottom:Jt.bottom,minimap:Wt,verticalScrollbarWidth:Nt,viewLineCount:Kt,remainingWidth:Te,isViewportWrapping:ie},Ie.memory||new A);qe.renderMinimap!==0&&qe.minimapLeft===0&&(Pt+=qe.minimapWidth,Ge+=qe.minimapWidth,Qt+=qe.minimapWidth,Me+=qe.minimapWidth);const xe=Te-qe.minimapWidth,Je=Math.max(1,Math.floor((xe-Nt-2)/ct)),rt=ut?ft:0;return ie&&(Fe=Math.max(1,Je),zt==="bounded"&&(Fe=Math.min(Fe,Ot))),{width:Ke,height:Ue,glyphMarginLeft:Pt,glyphMarginWidth:Tt,glyphMarginDecorationLaneCount:Ie.glyphMarginDecorationLaneCount,lineNumbersLeft:Ge,lineNumbersWidth:vt,decorationsLeft:Qt,decorationsWidth:at,contentLeft:Me,contentWidth:xe,minimap:qe,viewportColumn:Je,isWordWrapMinified:Ce,isViewportWrapping:ie,wrappingColumn:Fe,verticalScrollbarWidth:Nt,horizontalScrollbarHeight:At,overviewRuler:{top:rt,width:Nt,height:Ue-2*rt,right:0}}}}e.EditorLayoutInfoComputer=X;class ae extends P{constructor(){super(138,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[p.localize(47,null),p.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:p.localize(49,null)}})}validate(ue){return r(ue,"simple",["simple","advanced"])}compute(ue,Ie,Ke){return Ie.get(2)===2?"advanced":Ke}}class Z extends P{constructor(){const ue={enabled:!0};super(64,"lightbulb",ue,{"editor.lightbulb.enabled":{type:"boolean",default:ue.enabled,description:p.localize(50,null)}})}validate(ue){return!ue||typeof ue!="object"?this.defaultValue:{enabled:c(ue.enabled,this.defaultValue.enabled)}}}class se extends P{constructor(){const ue={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",ue,{"editor.stickyScroll.enabled":{type:"boolean",default:ue.enabled,description:p.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:ue.maxLineCount,minimum:1,maximum:10,description:p.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:ue.defaultModel,description:p.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:ue.scrollWithEditor,description:p.localize(54,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:c(Ie.enabled,this.defaultValue.enabled),maxLineCount:n.clampedInt(Ie.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:r(Ie.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:c(Ie.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class we extends P{constructor(){const ue={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(140,"inlayHints",ue,{"editor.inlayHints.enabled":{type:"string",default:ue.enabled,description:p.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[p.localize(56,null),p.localize(57,null,f.$k?"Ctrl+Option":"Ctrl+Alt"),p.localize(58,null,f.$k?"Ctrl+Option":"Ctrl+Alt"),p.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:ue.fontSize,markdownDescription:p.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:ue.fontFamily,markdownDescription:p.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:ue.padding,description:p.localize(62,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return typeof Ie.enabled=="boolean"&&(Ie.enabled=Ie.enabled?"on":"off"),{enabled:r(Ie.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:n.clampedInt(Ie.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ie.fontFamily,this.defaultValue.fontFamily),padding:c(Ie.padding,this.defaultValue.padding)}}}class H extends P{constructor(){super(65,"lineDecorationsWidth",10)}validate(ue){return typeof ue=="string"&&/^\d+(\.\d+)?ch$/.test(ue)?-parseFloat(ue.substring(0,ue.length-2)):n.clampedInt(ue,this.defaultValue,0,1e3)}compute(ue,Ie,Ke){return Ke<0?n.clampedInt(-Ke*ue.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ke}}class U extends a{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ue=>a.clamp(ue,0,150),{markdownDescription:p.localize(63,null)})}compute(ue,Ie,Ke){return ue.fontInfo.lineHeight}}class ce extends P{constructor(){const ue={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",ue,{"editor.minimap.enabled":{type:"boolean",default:ue.enabled,description:p.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:ue.autohide,description:p.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[p.localize(66,null),p.localize(67,null),p.localize(68,null)],default:ue.size,description:p.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ue.side,description:p.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ue.showSlider,description:p.localize(71,null)},"editor.minimap.scale":{type:"number",default:ue.scale,minimum:1,maximum:3,enum:[1,2,3],description:p.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ue.renderCharacters,description:p.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:ue.maxColumn,description:p.localize(74,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:c(Ie.enabled,this.defaultValue.enabled),autohide:c(Ie.autohide,this.defaultValue.autohide),size:r(Ie.size,this.defaultValue.size,["proportional","fill","fit"]),side:r(Ie.side,this.defaultValue.side,["right","left"]),showSlider:r(Ie.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:c(Ie.renderCharacters,this.defaultValue.renderCharacters),scale:n.clampedInt(Ie.scale,1,1,3),maxColumn:n.clampedInt(Ie.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Ee(he){return he==="ctrlCmd"?f.$k?"metaKey":"ctrlKey":"altKey"}class ne extends P{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(76,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{top:n.clampedInt(Ie.top,0,0,1e3),bottom:n.clampedInt(Ie.bottom,0,0,1e3)}}}class G extends P{constructor(){const ue={enabled:!0,cycle:!0};super(86,"parameterHints",ue,{"editor.parameterHints.enabled":{type:"boolean",default:ue.enabled,description:p.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:ue.cycle,description:p.localize(78,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:c(Ie.enabled,this.defaultValue.enabled),cycle:c(Ie.cycle,this.defaultValue.cycle)}}}class J extends S{constructor(){super(142)}compute(ue,Ie,Ke){return ue.pixelRatio}}class ge extends P{constructor(){const ue={other:"on",comments:"off",strings:"off"},Ie=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[p.localize(79,null),p.localize(80,null),p.localize(81,null)]}];super(89,"quickSuggestions",ue,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ie,default:ue.strings,description:p.localize(82,null)},comments:{anyOf:Ie,default:ue.comments,description:p.localize(83,null)},other:{anyOf:Ie,default:ue.other,description:p.localize(84,null)}},default:ue,markdownDescription:p.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=ue}validate(ue){if(typeof ue=="boolean"){const Et=ue?"on":"off";return{comments:Et,strings:Et,other:Et}}if(!ue||typeof ue!="object")return this.defaultValue;const{other:Ie,comments:Ke,strings:Ue}=ue,Ze=["on","inline","off"];let nt,ct,bt;return typeof Ie=="boolean"?nt=Ie?"on":"off":nt=r(Ie,this.defaultValue.other,Ze),typeof Ke=="boolean"?ct=Ke?"on":"off":ct=r(Ke,this.defaultValue.comments,Ze),typeof Ue=="boolean"?bt=Ue?"on":"off":bt=r(Ue,this.defaultValue.strings,Ze),{other:nt,comments:ct,strings:bt}}}var x;(function(he){he[he.Off=0]="Off",he[he.On=1]="On",he[he.Relative=2]="Relative",he[he.Interval=3]="Interval",he[he.Custom=4]="Custom"})(x||(e.RenderLineNumbersType=x={}));class le extends P{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[p.localize(86,null),p.localize(87,null),p.localize(88,null),p.localize(89,null)],default:"on",description:p.localize(90,null)})}validate(ue){let Ie=this.defaultValue.renderType,Ke=this.defaultValue.renderFn;return typeof ue<"u"&&(typeof ue=="function"?(Ie=4,Ke=ue):ue==="interval"?Ie=3:ue==="relative"?Ie=2:ue==="on"?Ie=1:Ie=0),{renderType:Ie,renderFn:Ke}}}function te(he){const ue=he.get(98);return ue==="editable"?he.get(91):ue!=="on"}e.filterValidationDecorations=te;class de extends P{constructor(){const ue=[],Ie={type:"number",description:p.localize(91,null)};super(102,"rulers",ue,{type:"array",items:{anyOf:[Ie,{type:["object"],properties:{column:Ie,color:{type:"string",description:p.localize(92,null),format:"color-hex"}}}]},default:ue,description:p.localize(93,null)})}validate(ue){if(Array.isArray(ue)){const Ie=[];for(const Ke of ue)if(typeof Ke=="number")Ie.push({column:n.clampedInt(Ke,0,0,1e4),color:null});else if(Ke&&typeof Ke=="object"){const Ue=Ke;Ie.push({column:n.clampedInt(Ue.column,0,0,1e4),color:Ue.color})}return Ie.sort((Ke,Ue)=>Ke.column-Ue.column),Ie}return this.defaultValue}}class be extends P{constructor(){super(92,"readOnlyMessage",void 0)}validate(ue){return!ue||typeof ue!="object"?this.defaultValue:ue}}function Pe(he,ue){if(typeof he!="string")return ue;switch(he){case"hidden":return 2;case"visible":return 3;default:return 1}}class B extends P{constructor(){const ue={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",ue,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(94,null),p.localize(95,null),p.localize(96,null)],default:"auto",description:p.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(98,null),p.localize(99,null),p.localize(100,null)],default:"auto",description:p.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ue.verticalScrollbarSize,description:p.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ue.horizontalScrollbarSize,description:p.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ue.scrollByPage,description:p.localize(104,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:ue.ignoreHorizontalScrollbarInContentHeight,description:p.localize(105,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue,Ke=n.clampedInt(Ie.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ue=n.clampedInt(Ie.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:n.clampedInt(Ie.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Pe(Ie.vertical,this.defaultValue.vertical),horizontal:Pe(Ie.horizontal,this.defaultValue.horizontal),useShadows:c(Ie.useShadows,this.defaultValue.useShadows),verticalHasArrows:c(Ie.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:c(Ie.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:c(Ie.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:c(Ie.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ke,horizontalSliderSize:n.clampedInt(Ie.horizontalSliderSize,Ke,0,1e3),verticalScrollbarSize:Ue,verticalSliderSize:n.clampedInt(Ie.verticalSliderSize,Ue,0,1e3),scrollByPage:c(Ie.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:c(Ie.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Q extends P{constructor(){const ue={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",ue,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.nonBasicASCII,description:p.localize(106,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ue.invisibleCharacters,description:p.localize(107,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ue.ambiguousCharacters,description:p.localize(108,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.includeComments,description:p.localize(109,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.includeStrings,description:p.localize(110,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ue.allowedCharacters,description:p.localize(111,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ue.allowedLocales,description:p.localize(112,null)}})}applyUpdate(ue,Ie){let Ke=!1;Ie.allowedCharacters&&ue&&(F.$cn(ue.allowedCharacters,Ie.allowedCharacters)||(ue={...ue,allowedCharacters:Ie.allowedCharacters},Ke=!0)),Ie.allowedLocales&&ue&&(F.$cn(ue.allowedLocales,Ie.allowedLocales)||(ue={...ue,allowedLocales:Ie.allowedLocales},Ke=!0));const Ue=super.applyUpdate(ue,Ie);return Ke?new g(Ue.newValue,!0):Ue}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{nonBasicASCII:me(Ie.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:c(Ie.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:c(Ie.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:me(Ie.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:me(Ie.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(ue.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(ue.allowedLocales,this.defaultValue.allowedLocales)}}c(ue,Ie){if(typeof ue!="object"||!ue)return Ie;const Ke={};for(const[Ue,Ze]of Object.entries(ue))Ze===!0&&(Ke[Ue]=!0);return Ke}}class re extends P{constructor(){const ue={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",ue,{"editor.inlineSuggest.enabled":{type:"boolean",default:ue.enabled,description:p.localize(113,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:ue.showToolbar,enum:["always","onHover"],enumDescriptions:[p.localize(114,null),p.localize(115,null)],description:p.localize(116,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:ue.suppressSuggestions,description:p.localize(117,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:c(Ie.enabled,this.defaultValue.enabled),mode:r(Ie.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:r(Ie.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:c(Ie.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:c(Ie.keepOnBlur,this.defaultValue.keepOnBlur)}}}class oe extends P{constructor(){const ue={enabled:L.$7r.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:L.$7r.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",ue,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ue.enabled,markdownDescription:p.localize(118,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:ue.independentColorPoolPerBracketType,description:p.localize(119,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:c(Ie.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:c(Ie.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class _ extends P{constructor(){const ue={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",ue,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[p.localize(120,null),p.localize(121,null),p.localize(122,null)],default:ue.bracketPairs,description:p.localize(123,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[p.localize(124,null),p.localize(125,null),p.localize(126,null)],default:ue.bracketPairsHorizontal,description:p.localize(127,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ue.highlightActiveBracketPair,description:p.localize(128,null)},"editor.guides.indentation":{type:"boolean",default:ue.indentation,description:p.localize(129,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[p.localize(130,null),p.localize(131,null),p.localize(132,null)],default:ue.highlightActiveIndentation,description:p.localize(133,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{bracketPairs:me(Ie.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:me(Ie.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:c(Ie.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:c(Ie.indentation,this.defaultValue.indentation),highlightActiveIndentation:me(Ie.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function me(he,ue,Ie){const Ke=Ie.indexOf(he);return Ke===-1?ue:Ie[Ke]}class ye extends P{constructor(){const ue={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",ue,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[p.localize(134,null),p.localize(135,null)],default:ue.insertMode,description:p.localize(136,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ue.filterGraceful,description:p.localize(137,null)},"editor.suggest.localityBonus":{type:"boolean",default:ue.localityBonus,description:p.localize(138,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ue.shareSuggestSelections,markdownDescription:p.localize(139,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[p.localize(140,null),p.localize(141,null),p.localize(142,null),p.localize(143,null)],default:ue.selectionMode,markdownDescription:p.localize(144,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ue.snippetsPreventQuickSuggestions,description:p.localize(145,null)},"editor.suggest.showIcons":{type:"boolean",default:ue.showIcons,description:p.localize(146,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ue.showStatusBar,description:p.localize(147,null)},"editor.suggest.preview":{type:"boolean",default:ue.preview,description:p.localize(148,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ue.showInlineDetails,description:p.localize(149,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:p.localize(150,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:p.localize(151,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:p.localize(152,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:p.localize(153,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:p.localize(154,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:p.localize(155,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:p.localize(156,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:p.localize(157,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:p.localize(158,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:p.localize(159,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:p.localize(160,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:p.localize(161,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:p.localize(162,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:p.localize(163,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:p.localize(164,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:p.localize(165,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:p.localize(166,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:p.localize(167,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:p.localize(168,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:p.localize(169,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:p.localize(170,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:p.localize(171,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:p.localize(172,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:p.localize(173,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:p.localize(174,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:p.localize(175,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:p.localize(176,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:p.localize(177,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:p.localize(178,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:p.localize(179,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:p.localize(180,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:p.localize(181,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{insertMode:r(Ie.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:c(Ie.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:c(Ie.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:c(Ie.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:c(Ie.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:r(Ie.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:c(Ie.showIcons,this.defaultValue.showIcons),showStatusBar:c(Ie.showStatusBar,this.defaultValue.showStatusBar),preview:c(Ie.preview,this.defaultValue.preview),previewMode:r(Ie.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:c(Ie.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:c(Ie.showMethods,this.defaultValue.showMethods),showFunctions:c(Ie.showFunctions,this.defaultValue.showFunctions),showConstructors:c(Ie.showConstructors,this.defaultValue.showConstructors),showDeprecated:c(Ie.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:c(Ie.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:c(Ie.showFields,this.defaultValue.showFields),showVariables:c(Ie.showVariables,this.defaultValue.showVariables),showClasses:c(Ie.showClasses,this.defaultValue.showClasses),showStructs:c(Ie.showStructs,this.defaultValue.showStructs),showInterfaces:c(Ie.showInterfaces,this.defaultValue.showInterfaces),showModules:c(Ie.showModules,this.defaultValue.showModules),showProperties:c(Ie.showProperties,this.defaultValue.showProperties),showEvents:c(Ie.showEvents,this.defaultValue.showEvents),showOperators:c(Ie.showOperators,this.defaultValue.showOperators),showUnits:c(Ie.showUnits,this.defaultValue.showUnits),showValues:c(Ie.showValues,this.defaultValue.showValues),showConstants:c(Ie.showConstants,this.defaultValue.showConstants),showEnums:c(Ie.showEnums,this.defaultValue.showEnums),showEnumMembers:c(Ie.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:c(Ie.showKeywords,this.defaultValue.showKeywords),showWords:c(Ie.showWords,this.defaultValue.showWords),showColors:c(Ie.showColors,this.defaultValue.showColors),showFiles:c(Ie.showFiles,this.defaultValue.showFiles),showReferences:c(Ie.showReferences,this.defaultValue.showReferences),showFolders:c(Ie.showFolders,this.defaultValue.showFolders),showTypeParameters:c(Ie.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:c(Ie.showSnippets,this.defaultValue.showSnippets),showUsers:c(Ie.showUsers,this.defaultValue.showUsers),showIssues:c(Ie.showIssues,this.defaultValue.showIssues)}}}class ze extends P{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:p.localize(182,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:p.localize(183,null),default:!0,type:"boolean"}})}validate(ue){return!ue||typeof ue!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:c(ue.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:c(ue.selectSubwords,this.defaultValue.selectSubwords)}}}var We;(function(he){he[he.None=0]="None",he[he.Same=1]="Same",he[he.Indent=2]="Indent",he[he.DeepIndent=3]="DeepIndent"})(We||(e.WrappingIndent=We={}));class _e extends P{constructor(){super(137,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[p.localize(184,null),p.localize(185,null),p.localize(186,null),p.localize(187,null)],description:p.localize(188,null),default:"same"}})}validate(ue){switch(ue){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(ue,Ie,Ke){return Ie.get(2)===2?0:Ke}}class Ye extends S{constructor(){super(145)}compute(ue,Ie,Ke){const Ue=Ie.get(144);return{isDominatedByLongLines:ue.isDominatedByLongLines,isWordWrapMinified:Ue.isWordWrapMinified,isViewportWrapping:Ue.isViewportWrapping,wrappingColumn:Ue.wrappingColumn}}}class it extends P{constructor(){const ue={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",ue,{"editor.dropIntoEditor.enabled":{type:"boolean",default:ue.enabled,markdownDescription:p.localize(189,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:p.localize(190,null),enum:["afterDrop","never"],enumDescriptions:[p.localize(191,null),p.localize(192,null)],default:"afterDrop"}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:c(Ie.enabled,this.defaultValue.enabled),showDropSelector:r(Ie.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class tt extends P{constructor(){const ue={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",ue,{"editor.pasteAs.enabled":{type:"boolean",default:ue.enabled,markdownDescription:p.localize(193,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:p.localize(194,null),enum:["afterPaste","never"],enumDescriptions:[p.localize(195,null),p.localize(196,null)],default:"afterPaste"}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:c(Ie.enabled,this.defaultValue.enabled),showPasteSelector:r(Ie.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Ae="Consolas, 'Courier New', monospace",Oe="Menlo, Monaco, 'Courier New', monospace",Ve="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:f.$k?Oe:f.$l?Ve:Ae,fontWeight:"normal",fontSize:f.$k?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Re(he){return e.editorOptionsRegistry[he.id]=he,he}var Xe;(function(he){he[he.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",he[he.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",he[he.accessibilitySupport=2]="accessibilitySupport",he[he.accessibilityPageSize=3]="accessibilityPageSize",he[he.ariaLabel=4]="ariaLabel",he[he.ariaRequired=5]="ariaRequired",he[he.autoClosingBrackets=6]="autoClosingBrackets",he[he.autoClosingComments=7]="autoClosingComments",he[he.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",he[he.autoClosingDelete=9]="autoClosingDelete",he[he.autoClosingOvertype=10]="autoClosingOvertype",he[he.autoClosingQuotes=11]="autoClosingQuotes",he[he.autoIndent=12]="autoIndent",he[he.automaticLayout=13]="automaticLayout",he[he.autoSurround=14]="autoSurround",he[he.bracketPairColorization=15]="bracketPairColorization",he[he.guides=16]="guides",he[he.codeLens=17]="codeLens",he[he.codeLensFontFamily=18]="codeLensFontFamily",he[he.codeLensFontSize=19]="codeLensFontSize",he[he.colorDecorators=20]="colorDecorators",he[he.colorDecoratorsLimit=21]="colorDecoratorsLimit",he[he.columnSelection=22]="columnSelection",he[he.comments=23]="comments",he[he.contextmenu=24]="contextmenu",he[he.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",he[he.cursorBlinking=26]="cursorBlinking",he[he.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",he[he.cursorStyle=28]="cursorStyle",he[he.cursorSurroundingLines=29]="cursorSurroundingLines",he[he.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",he[he.cursorWidth=31]="cursorWidth",he[he.disableLayerHinting=32]="disableLayerHinting",he[he.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",he[he.domReadOnly=34]="domReadOnly",he[he.dragAndDrop=35]="dragAndDrop",he[he.dropIntoEditor=36]="dropIntoEditor",he[he.emptySelectionClipboard=37]="emptySelectionClipboard",he[he.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",he[he.extraEditorClassName=39]="extraEditorClassName",he[he.fastScrollSensitivity=40]="fastScrollSensitivity",he[he.find=41]="find",he[he.fixedOverflowWidgets=42]="fixedOverflowWidgets",he[he.folding=43]="folding",he[he.foldingStrategy=44]="foldingStrategy",he[he.foldingHighlight=45]="foldingHighlight",he[he.foldingImportsByDefault=46]="foldingImportsByDefault",he[he.foldingMaximumRegions=47]="foldingMaximumRegions",he[he.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",he[he.fontFamily=49]="fontFamily",he[he.fontInfo=50]="fontInfo",he[he.fontLigatures=51]="fontLigatures",he[he.fontSize=52]="fontSize",he[he.fontWeight=53]="fontWeight",he[he.fontVariations=54]="fontVariations",he[he.formatOnPaste=55]="formatOnPaste",he[he.formatOnType=56]="formatOnType",he[he.glyphMargin=57]="glyphMargin",he[he.gotoLocation=58]="gotoLocation",he[he.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",he[he.hover=60]="hover",he[he.inDiffEditor=61]="inDiffEditor",he[he.inlineSuggest=62]="inlineSuggest",he[he.letterSpacing=63]="letterSpacing",he[he.lightbulb=64]="lightbulb",he[he.lineDecorationsWidth=65]="lineDecorationsWidth",he[he.lineHeight=66]="lineHeight",he[he.lineNumbers=67]="lineNumbers",he[he.lineNumbersMinChars=68]="lineNumbersMinChars",he[he.linkedEditing=69]="linkedEditing",he[he.links=70]="links",he[he.matchBrackets=71]="matchBrackets",he[he.minimap=72]="minimap",he[he.mouseStyle=73]="mouseStyle",he[he.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",he[he.mouseWheelZoom=75]="mouseWheelZoom",he[he.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",he[he.multiCursorModifier=77]="multiCursorModifier",he[he.multiCursorPaste=78]="multiCursorPaste",he[he.multiCursorLimit=79]="multiCursorLimit",he[he.multiDocumentOccurrencesHighlight=80]="multiDocumentOccurrencesHighlight",he[he.occurrencesHighlight=81]="occurrencesHighlight",he[he.overviewRulerBorder=82]="overviewRulerBorder",he[he.overviewRulerLanes=83]="overviewRulerLanes",he[he.padding=84]="padding",he[he.pasteAs=85]="pasteAs",he[he.parameterHints=86]="parameterHints",he[he.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",he[he.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",he[he.quickSuggestions=89]="quickSuggestions",he[he.quickSuggestionsDelay=90]="quickSuggestionsDelay",he[he.readOnly=91]="readOnly",he[he.readOnlyMessage=92]="readOnlyMessage",he[he.renameOnType=93]="renameOnType",he[he.renderControlCharacters=94]="renderControlCharacters",he[he.renderFinalNewline=95]="renderFinalNewline",he[he.renderLineHighlight=96]="renderLineHighlight",he[he.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",he[he.renderValidationDecorations=98]="renderValidationDecorations",he[he.renderWhitespace=99]="renderWhitespace",he[he.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",he[he.roundedSelection=101]="roundedSelection",he[he.rulers=102]="rulers",he[he.scrollbar=103]="scrollbar",he[he.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",he[he.scrollBeyondLastLine=105]="scrollBeyondLastLine",he[he.scrollPredominantAxis=106]="scrollPredominantAxis",he[he.selectionClipboard=107]="selectionClipboard",he[he.selectionHighlight=108]="selectionHighlight",he[he.selectOnLineNumbers=109]="selectOnLineNumbers",he[he.showFoldingControls=110]="showFoldingControls",he[he.showUnused=111]="showUnused",he[he.snippetSuggestions=112]="snippetSuggestions",he[he.smartSelect=113]="smartSelect",he[he.smoothScrolling=114]="smoothScrolling",he[he.stickyScroll=115]="stickyScroll",he[he.stickyTabStops=116]="stickyTabStops",he[he.stopRenderingLineAfter=117]="stopRenderingLineAfter",he[he.suggest=118]="suggest",he[he.suggestFontSize=119]="suggestFontSize",he[he.suggestLineHeight=120]="suggestLineHeight",he[he.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",he[he.suggestSelection=122]="suggestSelection",he[he.tabCompletion=123]="tabCompletion",he[he.tabIndex=124]="tabIndex",he[he.unicodeHighlighting=125]="unicodeHighlighting",he[he.unusualLineTerminators=126]="unusualLineTerminators",he[he.useShadowDOM=127]="useShadowDOM",he[he.useTabStops=128]="useTabStops",he[he.wordBreak=129]="wordBreak",he[he.wordSeparators=130]="wordSeparators",he[he.wordWrap=131]="wordWrap",he[he.wordWrapBreakAfterCharacters=132]="wordWrapBreakAfterCharacters",he[he.wordWrapBreakBeforeCharacters=133]="wordWrapBreakBeforeCharacters",he[he.wordWrapColumn=134]="wordWrapColumn",he[he.wordWrapOverride1=135]="wordWrapOverride1",he[he.wordWrapOverride2=136]="wordWrapOverride2",he[he.wrappingIndent=137]="wrappingIndent",he[he.wrappingStrategy=138]="wrappingStrategy",he[he.showDeprecated=139]="showDeprecated",he[he.inlayHints=140]="inlayHints",he[he.editorClassName=141]="editorClassName",he[he.pixelRatio=142]="pixelRatio",he[he.tabFocusMode=143]="tabFocusMode",he[he.layoutInfo=144]="layoutInfo",he[he.wrappingInfo=145]="wrappingInfo",he[he.defaultColorDecorators=146]="defaultColorDecorators",he[he.colorDecoratorsActivatedOn=147]="colorDecoratorsActivatedOn",he[he.inlineCompletionsAccessibilityVerbose=148]="inlineCompletionsAccessibilityVerbose"})(Xe||(e.EditorOption=Xe={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Re(new s(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:p.localize(197,null)})),acceptSuggestionOnEnter:Re(new d(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",p.localize(198,null),""],markdownDescription:p.localize(199,null)})),accessibilitySupport:Re(new h),accessibilityPageSize:Re(new n(3,"accessibilityPageSize",10,1,1073741824,{description:p.localize(200,null),tags:["accessibility"]})),ariaLabel:Re(new t(4,"ariaLabel",p.localize(201,null))),ariaRequired:Re(new s(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Re(new s(8,"screenReaderAnnounceInlineSuggestion",!0,{description:p.localize(202,null),tags:["accessibility"]})),autoClosingBrackets:Re(new d(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(203,null),p.localize(204,null),""],description:p.localize(205,null)})),autoClosingComments:Re(new d(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(206,null),p.localize(207,null),""],description:p.localize(208,null)})),autoClosingDelete:Re(new d(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",p.localize(209,null),""],description:p.localize(210,null)})),autoClosingOvertype:Re(new d(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",p.localize(211,null),""],description:p.localize(212,null)})),autoClosingQuotes:Re(new d(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(213,null),p.localize(214,null),""],description:p.localize(215,null)})),autoIndent:Re(new u(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],l,{enumDescriptions:[p.localize(216,null),p.localize(217,null),p.localize(218,null),p.localize(219,null),p.localize(220,null)],description:p.localize(221,null)})),automaticLayout:Re(new s(13,"automaticLayout",!1)),autoSurround:Re(new d(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[p.localize(222,null),p.localize(223,null),p.localize(224,null),""],description:p.localize(225,null)})),bracketPairColorization:Re(new oe),bracketPairGuides:Re(new _),stickyTabStops:Re(new s(116,"stickyTabStops",!1,{description:p.localize(226,null)})),codeLens:Re(new s(17,"codeLens",!0,{description:p.localize(227,null)})),codeLensFontFamily:Re(new t(18,"codeLensFontFamily","",{description:p.localize(228,null)})),codeLensFontSize:Re(new n(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:p.localize(229,null)})),colorDecorators:Re(new s(20,"colorDecorators",!0,{description:p.localize(230,null)})),colorDecoratorActivatedOn:Re(new d(147,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[p.localize(231,null),p.localize(232,null),p.localize(233,null)],description:p.localize(234,null)})),colorDecoratorsLimit:Re(new n(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:p.localize(235,null)})),columnSelection:Re(new s(22,"columnSelection",!1,{description:p.localize(236,null)})),comments:Re(new k),contextmenu:Re(new s(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Re(new s(25,"copyWithSyntaxHighlighting",!0,{description:p.localize(237,null)})),cursorBlinking:Re(new u(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],$,{description:p.localize(238,null)})),cursorSmoothCaretAnimation:Re(new d(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[p.localize(239,null),p.localize(240,null),p.localize(241,null)],description:p.localize(242,null)})),cursorStyle:Re(new u(28,"cursorStyle",b.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],C,{description:p.localize(243,null)})),cursorSurroundingLines:Re(new n(29,"cursorSurroundingLines",0,0,1073741824,{description:p.localize(244,null)})),cursorSurroundingLinesStyle:Re(new d(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[p.localize(245,null),p.localize(246,null)],markdownDescription:p.localize(247,null)})),cursorWidth:Re(new n(31,"cursorWidth",0,0,1073741824,{markdownDescription:p.localize(248,null)})),disableLayerHinting:Re(new s(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Re(new s(33,"disableMonospaceOptimizations",!1)),domReadOnly:Re(new s(34,"domReadOnly",!1)),dragAndDrop:Re(new s(35,"dragAndDrop",!0,{description:p.localize(249,null)})),emptySelectionClipboard:Re(new z),dropIntoEditor:Re(new it),stickyScroll:Re(new se),experimentalWhitespaceRendering:Re(new d(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[p.localize(250,null),p.localize(251,null),p.localize(252,null)],description:p.localize(253,null)})),extraEditorClassName:Re(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Re(new a(40,"fastScrollSensitivity",5,he=>he<=0?5:he,{markdownDescription:p.localize(254,null)})),find:Re(new M),fixedOverflowWidgets:Re(new s(42,"fixedOverflowWidgets",!1)),folding:Re(new s(43,"folding",!0,{description:p.localize(255,null)})),foldingStrategy:Re(new d(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[p.localize(256,null),p.localize(257,null)],description:p.localize(258,null)})),foldingHighlight:Re(new s(45,"foldingHighlight",!0,{description:p.localize(259,null)})),foldingImportsByDefault:Re(new s(46,"foldingImportsByDefault",!1,{description:p.localize(260,null)})),foldingMaximumRegions:Re(new n(47,"foldingMaximumRegions",5e3,10,65e3,{description:p.localize(261,null)})),unfoldOnClickAfterEndOfLine:Re(new s(48,"unfoldOnClickAfterEndOfLine",!1,{description:p.localize(262,null)})),fontFamily:Re(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:p.localize(263,null)})),fontInfo:Re(new T),fontLigatures2:Re(new O),fontSize:Re(new V),fontWeight:Re(new q),fontVariations:Re(new j),formatOnPaste:Re(new s(55,"formatOnPaste",!1,{description:p.localize(264,null)})),formatOnType:Re(new s(56,"formatOnType",!1,{description:p.localize(265,null)})),glyphMargin:Re(new s(57,"glyphMargin",!0,{description:p.localize(266,null)})),gotoLocation:Re(new fe),hideCursorInOverviewRuler:Re(new s(59,"hideCursorInOverviewRuler",!1,{description:p.localize(267,null)})),hover:Re(new ee),inDiffEditor:Re(new s(61,"inDiffEditor",!1)),letterSpacing:Re(new a(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,he=>a.clamp(he,-5,20),{description:p.localize(268,null)})),lightbulb:Re(new Z),lineDecorationsWidth:Re(new H),lineHeight:Re(new U),lineNumbers:Re(new le),lineNumbersMinChars:Re(new n(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Re(new s(69,"linkedEditing",!1,{description:p.localize(269,null)})),links:Re(new s(70,"links",!0,{description:p.localize(270,null)})),matchBrackets:Re(new d(71,"matchBrackets","always",["always","near","never"],{description:p.localize(271,null)})),minimap:Re(new ce),mouseStyle:Re(new d(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Re(new a(74,"mouseWheelScrollSensitivity",1,he=>he===0?1:he,{markdownDescription:p.localize(272,null)})),mouseWheelZoom:Re(new s(75,"mouseWheelZoom",!1,{markdownDescription:p.localize(273,null)})),multiCursorMergeOverlapping:Re(new s(76,"multiCursorMergeOverlapping",!0,{description:p.localize(274,null)})),multiCursorModifier:Re(new u(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Ee,{markdownEnumDescriptions:[p.localize(275,null),p.localize(276,null)],markdownDescription:p.localize(277,null)})),multiCursorPaste:Re(new d(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[p.localize(278,null),p.localize(279,null)],markdownDescription:p.localize(280,null)})),multiCursorLimit:Re(new n(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:p.localize(281,null)})),occurrencesHighlight:Re(new s(81,"occurrencesHighlight",!0,{description:p.localize(282,null)})),multiDocumentOccurrencesHighlight:Re(new s(80,"multiDocumentOccurrencesHighlight",!1,{description:p.localize(283,null)})),overviewRulerBorder:Re(new s(82,"overviewRulerBorder",!0,{description:p.localize(284,null)})),overviewRulerLanes:Re(new n(83,"overviewRulerLanes",3,0,3)),padding:Re(new ne),pasteAs:Re(new tt),parameterHints:Re(new G),peekWidgetDefaultFocus:Re(new d(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[p.localize(285,null),p.localize(286,null)],description:p.localize(287,null)})),definitionLinkOpensInPeek:Re(new s(88,"definitionLinkOpensInPeek",!1,{description:p.localize(288,null)})),quickSuggestions:Re(new ge),quickSuggestionsDelay:Re(new n(90,"quickSuggestionsDelay",10,0,1073741824,{description:p.localize(289,null)})),readOnly:Re(new s(91,"readOnly",!1)),readOnlyMessage:Re(new be),renameOnType:Re(new s(93,"renameOnType",!1,{description:p.localize(290,null),markdownDeprecationMessage:p.localize(291,null)})),renderControlCharacters:Re(new s(94,"renderControlCharacters",!0,{description:p.localize(292,null),restricted:!0})),renderFinalNewline:Re(new d(95,"renderFinalNewline",f.$l?"dimmed":"on",["off","on","dimmed"],{description:p.localize(293,null)})),renderLineHighlight:Re(new d(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",p.localize(294,null)],description:p.localize(295,null)})),renderLineHighlightOnlyWhenFocus:Re(new s(97,"renderLineHighlightOnlyWhenFocus",!1,{description:p.localize(296,null)})),renderValidationDecorations:Re(new d(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Re(new d(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",p.localize(297,null),p.localize(298,null),p.localize(299,null),""],description:p.localize(300,null)})),revealHorizontalRightPadding:Re(new n(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Re(new s(101,"roundedSelection",!0,{description:p.localize(301,null)})),rulers:Re(new de),scrollbar:Re(new B),scrollBeyondLastColumn:Re(new n(104,"scrollBeyondLastColumn",4,0,1073741824,{description:p.localize(302,null)})),scrollBeyondLastLine:Re(new s(105,"scrollBeyondLastLine",!0,{description:p.localize(303,null)})),scrollPredominantAxis:Re(new s(106,"scrollPredominantAxis",!0,{description:p.localize(304,null)})),selectionClipboard:Re(new s(107,"selectionClipboard",!0,{description:p.localize(305,null),included:f.$l})),selectionHighlight:Re(new s(108,"selectionHighlight",!0,{description:p.localize(306,null)})),selectOnLineNumbers:Re(new s(109,"selectOnLineNumbers",!0)),showFoldingControls:Re(new d(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[p.localize(307,null),p.localize(308,null),p.localize(309,null)],description:p.localize(310,null)})),showUnused:Re(new s(111,"showUnused",!0,{description:p.localize(311,null)})),showDeprecated:Re(new s(139,"showDeprecated",!0,{description:p.localize(312,null)})),inlayHints:Re(new we),snippetSuggestions:Re(new d(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[p.localize(313,null),p.localize(314,null),p.localize(315,null),p.localize(316,null)],description:p.localize(317,null)})),smartSelect:Re(new ze),smoothScrolling:Re(new s(114,"smoothScrolling",!1,{description:p.localize(318,null)})),stopRenderingLineAfter:Re(new n(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Re(new ye),inlineSuggest:Re(new re),inlineCompletionsAccessibilityVerbose:Re(new s(148,"inlineCompletionsAccessibilityVerbose",!1,{description:p.localize(319,null)})),suggestFontSize:Re(new n(119,"suggestFontSize",0,0,1e3,{markdownDescription:p.localize(320,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Re(new n(120,"suggestLineHeight",0,0,1e3,{markdownDescription:p.localize(321,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Re(new s(121,"suggestOnTriggerCharacters",!0,{description:p.localize(322,null)})),suggestSelection:Re(new d(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[p.localize(323,null),p.localize(324,null),p.localize(325,null)],description:p.localize(326,null)})),tabCompletion:Re(new d(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[p.localize(327,null),p.localize(328,null),p.localize(329,null)],description:p.localize(330,null)})),tabIndex:Re(new n(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:Re(new Q),unusualLineTerminators:Re(new d(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[p.localize(331,null),p.localize(332,null),p.localize(333,null)],description:p.localize(334,null)})),useShadowDOM:Re(new s(127,"useShadowDOM",!0)),useTabStops:Re(new s(128,"useTabStops",!0,{description:p.localize(335,null)})),wordBreak:Re(new d(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[p.localize(336,null),p.localize(337,null)],description:p.localize(338,null)})),wordSeparators:Re(new t(130,"wordSeparators",R.$8r,{description:p.localize(339,null)})),wordWrap:Re(new d(131,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[p.localize(340,null),p.localize(341,null),p.localize(342,null),p.localize(343,null)],description:p.localize(344,null)})),wordWrapBreakAfterCharacters:Re(new t(132,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Re(new t(133,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Re(new n(134,"wordWrapColumn",80,1,1073741824,{markdownDescription:p.localize(345,null)})),wordWrapOverride1:Re(new d(135,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Re(new d(136,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Re(new N),defaultColorDecorators:Re(new s(146,"defaultColorDecorators",!1,{markdownDescription:p.localize(346,null)})),pixelRatio:Re(new J),tabFocusMode:Re(new s(143,"tabFocusMode",!1,{markdownDescription:p.localize(347,null)})),layoutInfo:Re(new X),wrappingInfo:Re(new Ye),wrappingIndent:Re(new _e),wrappingStrategy:Re(new ae)}}),define(ke[195],Se([8,9]),function($e,e){return $e.create("vs/editor/common/languages",e)}),define(ke[84],Se([1,0,79,2,168,29,178,195]),function($e,e,I,F,f,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.$ot=e.$nt=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.$mt=e.$lt=e.SymbolKinds=e.SymbolTag=e.$kt=e.$jt=e.SymbolKind=e.$it=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$ht=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$gt=e.$ft=e.$et=void 0;class E{constructor(O,j,T){this.offset=O,this.type=j,this.language=T,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$et=E;class m{constructor(O,j){this.tokens=O,this.endState=j,this._tokenizationResultBrand=void 0}}e.$ft=m;class A{constructor(O,j){this.tokens=O,this.endState=j,this._encodedTokenizationResultBrand=void 0}}e.$gt=A;var P;(function(M){M[M.Method=0]="Method",M[M.Function=1]="Function",M[M.Constructor=2]="Constructor",M[M.Field=3]="Field",M[M.Variable=4]="Variable",M[M.Class=5]="Class",M[M.Struct=6]="Struct",M[M.Interface=7]="Interface",M[M.Module=8]="Module",M[M.Property=9]="Property",M[M.Event=10]="Event",M[M.Operator=11]="Operator",M[M.Unit=12]="Unit",M[M.Value=13]="Value",M[M.Constant=14]="Constant",M[M.Enum=15]="Enum",M[M.EnumMember=16]="EnumMember",M[M.Keyword=17]="Keyword",M[M.Text=18]="Text",M[M.Color=19]="Color",M[M.File=20]="File",M[M.Reference=21]="Reference",M[M.Customcolor=22]="Customcolor",M[M.Folder=23]="Folder",M[M.TypeParameter=24]="TypeParameter",M[M.User=25]="User",M[M.Issue=26]="Issue",M[M.Snippet=27]="Snippet"})(P||(e.CompletionItemKind=P={}));var g;(function(M){const O=new Map;O.set(0,I.$Yj.symbolMethod),O.set(1,I.$Yj.symbolFunction),O.set(2,I.$Yj.symbolConstructor),O.set(3,I.$Yj.symbolField),O.set(4,I.$Yj.symbolVariable),O.set(5,I.$Yj.symbolClass),O.set(6,I.$Yj.symbolStruct),O.set(7,I.$Yj.symbolInterface),O.set(8,I.$Yj.symbolModule),O.set(9,I.$Yj.symbolProperty),O.set(10,I.$Yj.symbolEvent),O.set(11,I.$Yj.symbolOperator),O.set(12,I.$Yj.symbolUnit),O.set(13,I.$Yj.symbolValue),O.set(15,I.$Yj.symbolEnum),O.set(14,I.$Yj.symbolConstant),O.set(15,I.$Yj.symbolEnum),O.set(16,I.$Yj.symbolEnumMember),O.set(17,I.$Yj.symbolKeyword),O.set(27,I.$Yj.symbolSnippet),O.set(18,I.$Yj.symbolText),O.set(19,I.$Yj.symbolColor),O.set(20,I.$Yj.symbolFile),O.set(21,I.$Yj.symbolReference),O.set(22,I.$Yj.symbolCustomColor),O.set(23,I.$Yj.symbolFolder),O.set(24,I.$Yj.symbolTypeParameter),O.set(25,I.$Yj.account),O.set(26,I.$Yj.issues);function j(q){let fe=O.get(q);return fe||(console.info("No codicon found for CompletionItemKind "+q),fe=I.$Yj.symbolProperty),fe}M.toIcon=j;const T=new Map;T.set("method",0),T.set("function",1),T.set("constructor",2),T.set("field",3),T.set("variable",4),T.set("class",5),T.set("struct",6),T.set("interface",7),T.set("module",8),T.set("property",9),T.set("event",10),T.set("operator",11),T.set("unit",12),T.set("value",13),T.set("constant",14),T.set("enum",15),T.set("enum-member",16),T.set("enumMember",16),T.set("keyword",17),T.set("snippet",27),T.set("text",18),T.set("color",19),T.set("file",20),T.set("reference",21),T.set("customcolor",22),T.set("folder",23),T.set("type-parameter",24),T.set("typeParameter",24),T.set("account",25),T.set("issue",26);function V(q,fe){let ee=T.get(q);return typeof ee>"u"&&!fe&&(ee=9),ee}M.fromString=V})(g||(e.CompletionItemKinds=g={}));var y;(function(M){M[M.Deprecated=1]="Deprecated"})(y||(e.CompletionItemTag=y={}));var S;(function(M){M[M.None=0]="None",M[M.KeepWhitespace=1]="KeepWhitespace",M[M.InsertAsSnippet=4]="InsertAsSnippet"})(S||(e.CompletionItemInsertTextRule=S={}));var w;(function(M){M[M.Invoke=0]="Invoke",M[M.TriggerCharacter=1]="TriggerCharacter",M[M.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(w||(e.CompletionTriggerKind=w={}));var c;(function(M){M[M.Automatic=0]="Automatic",M[M.Explicit=1]="Explicit"})(c||(e.InlineCompletionTriggerKind=c={}));class s{constructor(O,j,T,V){this.range=O,this.text=j,this.completionKind=T,this.isSnippetText=V}equals(O){return L.$xs.lift(this.range).equalsRange(O.range)&&this.text===O.text&&this.completionKind===O.completionKind&&this.isSnippetText===O.isSnippetText}}e.$ht=s;var i;(function(M){M[M.Invoke=1]="Invoke",M[M.Auto=2]="Auto"})(i||(e.CodeActionTriggerType=i={}));var n;(function(M){M[M.Invoke=1]="Invoke",M[M.TriggerCharacter=2]="TriggerCharacter",M[M.ContentChange=3]="ContentChange"})(n||(e.SignatureHelpTriggerKind=n={}));var o;(function(M){M[M.Text=0]="Text",M[M.Read=1]="Read",M[M.Write=2]="Write"})(o||(e.DocumentHighlightKind=o={}));function a(M){return M&&F.URI.isUri(M.uri)&&L.$xs.isIRange(M.range)&&(L.$xs.isIRange(M.originSelectionRange)||L.$xs.isIRange(M.targetSelectionRange))}e.$it=a;var t;(function(M){M[M.File=0]="File",M[M.Module=1]="Module",M[M.Namespace=2]="Namespace",M[M.Package=3]="Package",M[M.Class=4]="Class",M[M.Method=5]="Method",M[M.Property=6]="Property",M[M.Field=7]="Field",M[M.Constructor=8]="Constructor",M[M.Enum=9]="Enum",M[M.Interface=10]="Interface",M[M.Function=11]="Function",M[M.Variable=12]="Variable",M[M.Constant=13]="Constant",M[M.String=14]="String",M[M.Number=15]="Number",M[M.Boolean=16]="Boolean",M[M.Array=17]="Array",M[M.Object=18]="Object",M[M.Key=19]="Key",M[M.Null=20]="Null",M[M.EnumMember=21]="EnumMember",M[M.Struct=22]="Struct",M[M.Event=23]="Event",M[M.Operator=24]="Operator",M[M.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.$jt={[17]:(0,p.localize)(0,null),[16]:(0,p.localize)(1,null),[4]:(0,p.localize)(2,null),[13]:(0,p.localize)(3,null),[8]:(0,p.localize)(4,null),[9]:(0,p.localize)(5,null),[21]:(0,p.localize)(6,null),[23]:(0,p.localize)(7,null),[7]:(0,p.localize)(8,null),[0]:(0,p.localize)(9,null),[11]:(0,p.localize)(10,null),[10]:(0,p.localize)(11,null),[19]:(0,p.localize)(12,null),[5]:(0,p.localize)(13,null),[1]:(0,p.localize)(14,null),[2]:(0,p.localize)(15,null),[20]:(0,p.localize)(16,null),[15]:(0,p.localize)(17,null),[18]:(0,p.localize)(18,null),[24]:(0,p.localize)(19,null),[3]:(0,p.localize)(20,null),[6]:(0,p.localize)(21,null),[14]:(0,p.localize)(22,null),[22]:(0,p.localize)(23,null),[25]:(0,p.localize)(24,null),[12]:(0,p.localize)(25,null)};function r(M,O){return(0,p.localize)(26,null,M,e.$jt[O])}e.$kt=r;var d;(function(M){M[M.Deprecated=1]="Deprecated"})(d||(e.SymbolTag=d={}));var u;(function(M){const O=new Map;O.set(0,I.$Yj.symbolFile),O.set(1,I.$Yj.symbolModule),O.set(2,I.$Yj.symbolNamespace),O.set(3,I.$Yj.symbolPackage),O.set(4,I.$Yj.symbolClass),O.set(5,I.$Yj.symbolMethod),O.set(6,I.$Yj.symbolProperty),O.set(7,I.$Yj.symbolField),O.set(8,I.$Yj.symbolConstructor),O.set(9,I.$Yj.symbolEnum),O.set(10,I.$Yj.symbolInterface),O.set(11,I.$Yj.symbolFunction),O.set(12,I.$Yj.symbolVariable),O.set(13,I.$Yj.symbolConstant),O.set(14,I.$Yj.symbolString),O.set(15,I.$Yj.symbolNumber),O.set(16,I.$Yj.symbolBoolean),O.set(17,I.$Yj.symbolArray),O.set(18,I.$Yj.symbolObject),O.set(19,I.$Yj.symbolKey),O.set(20,I.$Yj.symbolNull),O.set(21,I.$Yj.symbolEnumMember),O.set(22,I.$Yj.symbolStruct),O.set(23,I.$Yj.symbolEvent),O.set(24,I.$Yj.symbolOperator),O.set(25,I.$Yj.symbolTypeParameter);function j(T){let V=O.get(T);return V||(console.info("No codicon found for SymbolKind "+T),V=I.$Yj.symbolProperty),V}M.toIcon=j})(u||(e.SymbolKinds=u={}));class l{static asEditOperation(O){return f.$ys.replace(L.$xs.lift(O.range),O.text)}}e.$lt=l;class h{static{this.Comment=new h("comment")}static{this.Imports=new h("imports")}static{this.Region=new h("region")}static fromValue(O){switch(O){case"comment":return h.Comment;case"imports":return h.Imports;case"region":return h.Region}return new h(O)}constructor(O){this.value=O}}e.$mt=h;var k;(function(M){function O(j){return!j||typeof j!="object"?!1:typeof j.id=="string"&&typeof j.title=="string"}M.is=O})(k||(e.Command=k={}));var D;(function(M){M[M.Collapsed=0]="Collapsed",M[M.Expanded=1]="Expanded"})(D||(e.CommentThreadCollapsibleState=D={}));var $;(function(M){M[M.Unresolved=0]="Unresolved",M[M.Resolved=1]="Resolved"})($||(e.CommentThreadState=$={}));var b;(function(M){M[M.Editing=0]="Editing",M[M.Preview=1]="Preview"})(b||(e.CommentMode=b={}));var v;(function(M){M[M.Published=0]="Published",M[M.Draft=1]="Draft"})(v||(e.CommentState=v={}));var C;(function(M){M[M.Type=1]="Type",M[M.Parameter=2]="Parameter"})(C||(e.InlayHintKind=C={}));class N{constructor(O){this.b=O,this.a=null}dispose(){this.a&&this.a.then(O=>{O&&O.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$nt=N,e.$ot=new R.$9s;var z;(function(M){M[M.None=0]="None",M[M.Option=1]="Option",M[M.Default=2]="Default",M[M.Preferred=3]="Preferred"})(z||(e.ExternalUriOpenerPriority=z={}))}),define(ke[196],Se([8,9]),function($e,e){return $e.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ke[197],Se([8,9]),function($e,e){return $e.create("vs/platform/contextkey/common/contextkey",e)}),define(ke[198],Se([8,9]),function($e,e){return $e.create("vs/platform/contextkey/common/scanner",e)}),define(ke[199],Se([8,9]),function($e,e){return $e.create("vs/platform/dialogs/common/dialogs",e)}),define(ke[200],Se([8,9]),function($e,e){return $e.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ke[201],Se([8,9]),function($e,e){return $e.create("vs/platform/extensions/common/extensionValidator",e)}),define(ke[202],Se([8,9]),function($e,e){return $e.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ke[203],Se([8,9]),function($e,e){return $e.create("vs/platform/files/common/files",e)}),define(ke[204],Se([8,9]),function($e,e){return $e.create("vs/platform/files/common/io",e)}),define(ke[205],Se([8,9]),function($e,e){return $e.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ke[206],Se([8,9]),function($e,e){return $e.create("vs/platform/markers/common/markers",e)}),define(ke[207],Se([8,9]),function($e,e){return $e.create("vs/platform/theme/common/iconRegistry",e)}),define(ke[208],Se([8,9]),function($e,e){return $e.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ke[209],Se([8,9]),function($e,e){return $e.create("vs/platform/workspace/common/workspace",e)}),define(ke[210],Se([8,9]),function($e,e){return $e.create("vs/workbench/api/common/extHostChat",e)}),define(ke[211],Se([8,9]),function($e,e){return $e.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(ke[212],Se([8,9]),function($e,e){return $e.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ke[213],Se([8,9]),function($e,e){return $e.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ke[214],Se([8,9]),function($e,e){return $e.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(ke[215],Se([8,9]),function($e,e){return $e.create("vs/workbench/api/common/extHostLogService",e)}),define(ke[216],Se([8,9]),function($e,e){return $e.create("vs/workbench/api/common/extHostNotebook",e)}),define(ke[217],Se([8,9]),function($e,e){return $e.create("vs/workbench/api/common/extHostProgress",e)}),define(ke[218],Se([8,9]),function($e,e){return $e.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ke[219],Se([8,9]),function($e,e){return $e.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ke[220],Se([8,9]),function($e,e){return $e.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ke[221],Se([8,9]),function($e,e){return $e.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ke[222],Se([8,9]),function($e,e){return $e.create("vs/workbench/api/common/extHostTunnelService",e)}),define(ke[223],Se([8,9]),function($e,e){return $e.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ke[224],Se([8,9]),function($e,e){return $e.create("vs/workbench/api/node/extHostDebugService",e)}),define(ke[225],Se([8,9]),function($e,e){return $e.create("vs/workbench/common/configuration",e)}),define(ke[226],Se([8,9]),function($e,e){return $e.create("vs/workbench/common/editor",e)}),define(ke[227],Se([8,9]),function($e,e){return $e.create("vs/workbench/common/views",e)}),define(ke[228],Se([8,9]),function($e,e){return $e.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ke[229],Se([8,9]),function($e,e){return $e.create("vs/workbench/contrib/debug/common/debug",e)}),define(ke[230],Se([8,9]),function($e,e){return $e.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ke[231],Se([8,9]),function($e,e){return $e.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ke[232],Se([8,9]),function($e,e){return $e.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ke[233],Se([8,9]),function($e,e){return $e.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ke[234],Se([8,9]),function($e,e){return $e.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(ke[235],Se([8,9]),function($e,e){return $e.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ke[236],Se([8,9]),function($e,e){return $e.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(ke[237],Se([8,9]),function($e,e){return $e.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ke[238],Se([1,0,11,198]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oi=e.TokenType=void 0;var f;(function(m){m[m.LParen=0]="LParen",m[m.RParen=1]="RParen",m[m.Neg=2]="Neg",m[m.Eq=3]="Eq",m[m.NotEq=4]="NotEq",m[m.Lt=5]="Lt",m[m.LtEq=6]="LtEq",m[m.Gt=7]="Gt",m[m.GtEq=8]="GtEq",m[m.RegexOp=9]="RegexOp",m[m.RegexStr=10]="RegexStr",m[m.True=11]="True",m[m.False=12]="False",m[m.In=13]="In",m[m.Not=14]="Not",m[m.And=15]="And",m[m.Or=16]="Or",m[m.Str=17]="Str",m[m.QuotedStr=18]="QuotedStr",m[m.Error=19]="Error",m[m.EOF=20]="EOF"})(f||(e.TokenType=f={}));function L(...m){switch(m.length){case 1:return(0,F.localize)(0,null,m[0]);case 2:return(0,F.localize)(1,null,m[0],m[1]);case 3:return(0,F.localize)(2,null,m[0],m[1],m[2]);default:return}}const R=(0,F.localize)(3,null),p=(0,F.localize)(4,null);class E{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,I.$7)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(A=>A.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(A){return this.c=A,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const P=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:P})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const P=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:P})}else this.h(126)?this.k(9):this.l(L("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(L("&&"));break;case 124:this.h(124)?this.k(16):this.l(L("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(A){return this.r()||this.c.charCodeAt(this.e)!==A?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(A){this.f.push({type:A,offset:this.d})}l(A){const P=this.d,g=this.c.substring(this.d,this.e),y={type:19,offset:this.d,lexeme:g};this.g.push({offset:P,lexeme:g,additionalInfo:A}),this.f.push(y)}n(){this.m.lastIndex=this.d;const A=this.m.exec(this.c);if(A){this.e=this.d+A[0].length;const P=this.c.substring(this.d,this.e),g=E.b.get(P);g?this.k(g):this.f.push({type:17,lexeme:P,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let A=this.e,P=!1,g=!1;for(;;){if(A>=this.c.length){this.e=A,this.l(p);return}const S=this.c.charCodeAt(A);if(P)P=!1;else if(S===47&&!g){A++;break}else S===91?g=!0:S===92?P=!0:S===93&&(g=!1);A++}for(;A<this.c.length&&E.a.has(this.c.charCodeAt(A));)A++;this.e=A;const y=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:y,offset:this.d})}r(){return this.e>=this.c.length}}e.$Oi=E}),define(ke[239],Se([1,0,23,39,201,388]),function($e,e,I,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,p=/^-(\d{4})(\d{2})(\d{2})$/;function E(s){return s=s.trim(),s==="*"||R.test(s)}e.$Po=E;function m(s){if(!E(s))return null;if(s=s.trim(),s==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=s.match(R);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}e.$Qo=m;function A(s){if(!s)return null;const i=s.majorBase,n=s.majorMustEqual,o=s.minorBase;let a=s.minorMustEqual;const t=s.patchBase;let r=s.patchMustEqual;s.hasCaret&&(i===0||(a=!1),r=!1);let d=0;if(s.preRelease){const u=p.exec(s.preRelease);if(u){const[,l,h,k]=u;d=Date.UTC(Number(l),Number(h)-1,Number(k))}}return{majorBase:i,majorMustEqual:n,minorBase:o,minorMustEqual:a,patchBase:t,patchMustEqual:r,isMinimum:s.hasGreaterEquals,notBefore:d}}e.$Ro=A;function P(s,i,n){let o;typeof s=="string"?o=A(m(s)):o=s;let a;i instanceof Date?a=i.getTime():typeof i=="string"&&(a=new Date(i).getTime());let t;if(typeof n=="string"?t=A(m(n)):t=n,!o||!t)return!1;const r=o.majorBase,d=o.minorBase,u=o.patchBase;let l=t.majorBase,h=t.minorBase,k=t.patchBase;const D=t.notBefore;let $=t.majorMustEqual,b=t.minorMustEqual,v=t.patchMustEqual;return t.isMinimum?r>l?!0:r<l?!1:d>h?!0:d<h||a&&a<D?!1:u>=k:(r===1&&l===0&&(!$||!b||!v)&&(l=1,h=0,k=0,$=!0,b=!1,v=!1),r<l?!1:r>l?!$:d<h?!1:d>h?!b:u<k?!1:u>k?!v:!(a&&a<D))}e.$So=P;function g(s,i,n,o,a){const t=[];if(typeof o.publisher<"u"&&typeof o.publisher!="string")return t.push([F.default.Error,f.localize(0,null)]),t;if(typeof o.name!="string")return t.push([F.default.Error,f.localize(1,null,"name")]),t;if(typeof o.version!="string")return t.push([F.default.Error,f.localize(2,null,"version")]),t;if(!o.engines)return t.push([F.default.Error,f.localize(3,null,"engines")]),t;if(typeof o.engines.vscode!="string")return t.push([F.default.Error,f.localize(4,null,"engines.vscode")]),t;if(typeof o.extensionDependencies<"u"&&!c(o.extensionDependencies))return t.push([F.default.Error,f.localize(5,null,"extensionDependencies")]),t;if(typeof o.activationEvents<"u"){if(!c(o.activationEvents))return t.push([F.default.Error,f.localize(6,null,"activationEvents")]),t;if(typeof o.main>"u"&&typeof o.browser>"u")return t.push([F.default.Error,f.localize(7,null,"activationEvents","main","browser")]),t}if(typeof o.extensionKind<"u"&&typeof o.main>"u"&&t.push([F.default.Warning,f.localize(8,null,"extensionKind")]),typeof o.main<"u"){if(typeof o.main!="string")return t.push([F.default.Error,f.localize(9,null,"main")]),t;{const u=(0,I.$wg)(n,o.main);(0,I.$qg)(u,n)||t.push([F.default.Warning,f.localize(10,null,u.path,n.path)])}}if(typeof o.browser<"u"){if(typeof o.browser!="string")return t.push([F.default.Error,f.localize(11,null,"browser")]),t;{const u=(0,I.$wg)(n,o.browser);(0,I.$qg)(u,n)||t.push([F.default.Warning,f.localize(12,null,u.path,n.path)])}}if(!L.valid(o.version))return t.push([F.default.Error,f.localize(13,null)]),t;const r=[];if(!y(s,i,o,a,r))for(const u of r)t.push([F.default.Error,u]);return t}e.$To=g;function y(s,i,n,o,a){return o||typeof n.main>"u"&&typeof n.browser>"u"?!0:w(s,i,n.engines.vscode,a)}e.$Uo=y;function S(s,i,n){return s==="*"||w(i,n,s)}e.$Vo=S;function w(s,i,n,o=[]){const a=A(m(n));if(!a)return o.push(f.localize(14,null,n)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return o.push(f.localize(15,null,n)),!1}else if(!a.majorMustEqual)return o.push(f.localize(16,null,n)),!1;return P(s,i,a)?!0:(o.push(f.localize(17,null,s,n)),!1)}function c(s){if(!Array.isArray(s))return!1;for(let i=0,n=s.length;i<n;i++)if(typeof s[i]!="string")return!1;return!0}}),define(ke[105],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qh=void 0;class I{constructor(f,L=[],R=!1){this.ctor=f,this.staticArguments=L,this.supportsDelayedInstantiation=R}}e.$Qh=I}),define(ke[106],Se([1,0,105]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Br=e.$Ar=e.InstantiationType=void 0;const F=[];var f;(function(p){p[p.Eager=0]="Eager",p[p.Delayed=1]="Delayed"})(f||(e.InstantiationType=f={}));function L(p,E,m){E instanceof I.$Qh||(E=new I.$Qh(E,[],!!m)),F.push([p,E])}e.$Ar=L;function R(){return F}e.$Br=R}),define(ke[240],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gq=e.$fq=void 0;class I{constructor(L,R){this.key=L,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$fq=I;class F{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const R of this.a.values())R.outgoing.size===0&&L.push(R);return L}insertEdge(L,R){const p=this.lookupOrInsertNode(L),E=this.lookupOrInsertNode(R);p.outgoing.set(E.key,E),E.incoming.set(p.key,p)}removeNode(L){const R=this.b(L);this.a.delete(R);for(const p of this.a.values())p.outgoing.delete(R),p.incoming.delete(R)}lookupOrInsertNode(L){const R=this.b(L);let p=this.a.get(R);return p||(p=new I(R,L),this.a.set(R,p)),p}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[R,p]of this.a)L.push(`${R}
	(-> incoming)[${[...p.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...p.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,R]of this.a){const p=new Set([L]),E=this.c(R,p);if(E)return E}}c(L,R){for(const[p,E]of L.outgoing){if(R.has(p))return[...R,p].join(" -> ");R.add(p);const m=this.c(E,R);if(m)return m;R.delete(p)}}}e.$gq=F}),define(ke[5],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uh=e.$Th=e.$Sh=e._util=void 0;var I;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function p(E){return E[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=p})(I||(e._util=I={})),e.$Sh=f("instantiationService");function F(R,p,E){p[I.DI_TARGET]===p?p[I.DI_DEPENDENCIES].push({id:R,index:E}):(p[I.DI_DEPENDENCIES]=[{id:R,index:E}],p[I.DI_TARGET]=p)}function f(R){if(I.serviceIds.has(R))return I.serviceIds.get(R);const p=function(E,m,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");F(p,E,A)};return p.toString=()=>R,I.serviceIds.set(R,p),p}e.$Th=f;function L(R){return R}e.$Uh=L}),define(ke[44],Se([1,0,18,2,5]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.ConfigurationTarget=e.$pi=e.$oi=e.$ni=void 0,e.$ni=(0,f.$Th)("configurationService");function L(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof F.URI)}e.$oi=L;function R(s){return s&&typeof s=="object"&&(!s.overrideIdentifiers||Array.isArray(s.overrideIdentifiers))&&!s.overrideIdentifier&&(!s.resource||s.resource instanceof F.URI)}e.$pi=R;var p;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.USER=2]="USER",s[s.USER_LOCAL=3]="USER_LOCAL",s[s.USER_REMOTE=4]="USER_REMOTE",s[s.WORKSPACE=5]="WORKSPACE",s[s.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",s[s.DEFAULT=7]="DEFAULT",s[s.MEMORY=8]="MEMORY"})(p||(e.ConfigurationTarget=p={}));function E(s){switch(s){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$qi=E;function m(s){return s.applicationValue!==void 0||s.userValue!==void 0||s.userLocalValue!==void 0||s.userRemoteValue!==void 0||s.workspaceValue!==void 0||s.workspaceFolderValue!==void 0}e.$ri=m;function A(s,i){const n=Object.create(null);for(const o in s)P(n,o,s[o],i);return n}e.$si=A;function P(s,i,n,o){const a=i.split("."),t=a.pop();let r=s;for(let d=0;d<a.length;d++){const u=a[d];let l=r[u];switch(typeof l){case"undefined":l=r[u]=Object.create(null);break;case"object":break;default:o(`Ignoring ${i} as ${a.slice(0,d+1).join(".")} is ${JSON.stringify(l)}`);return}r=l}if(typeof r=="object"&&r!==null)try{r[t]=n}catch{o(`Ignoring ${i} as ${a.join(".")} is ${JSON.stringify(r)}`)}else o(`Ignoring ${i} as ${a.join(".")} is ${JSON.stringify(r)}`)}e.$ti=P;function g(s,i){const n=i.split(".");y(s,n)}e.$ui=g;function y(s,i){const n=i.shift();if(i.length===0){delete s[n];return}if(Object.keys(s).indexOf(n)!==-1){const o=s[n];typeof o=="object"&&!Array.isArray(o)&&(y(o,i),Object.keys(o).length===0&&delete s[n])}}function S(s,i,n){function o(r,d){let u=r;for(const l of d){if(typeof u!="object"||u===null)return;u=u[l]}return u}const a=i.split("."),t=o(s,a);return typeof t>"u"?n:t}e.$vi=S;function w(s,i,n){Object.keys(i).forEach(o=>{o!=="__proto__"&&(o in s?I.$Bf(s[o])&&I.$Bf(i[o])?w(s[o],i[o],n):n&&(s[o]=i[o]):s[o]=i[o])})}e.$wi=w;function c(s){return s.replace(/[\[\]]/g,"")}e.$xi=c}),define(ke[45],Se([1,0,12,13,238,5,197,11]),function($e,e,I,F,f,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.ContextKeyExprType=e.$Pi=void 0;const E=new Map;E.set("false",!1),E.set("true",!0),E.set("isMac",I.$k),E.set("isLinux",I.$l),E.set("isWindows",I.$j),E.set("isWeb",I.$p),E.set("isMacNative",I.$k&&!I.$p),E.set("isEdge",I.$H),E.set("isFirefox",I.$F),E.set("isChrome",I.$E),E.set("isSafari",I.$G);function m(H,U){if(E.get(H)!==void 0)throw(0,p.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");E.set(H,U)}e.$Pi=m;const A=Object.prototype.hasOwnProperty;var P;(function(H){H[H.False=0]="False",H[H.True=1]="True",H[H.Defined=2]="Defined",H[H.Not=3]="Not",H[H.Equals=4]="Equals",H[H.NotEquals=5]="NotEquals",H[H.And=6]="And",H[H.Regex=7]="Regex",H[H.NotRegex=8]="NotRegex",H[H.Or=9]="Or",H[H.In=10]="In",H[H.NotIn=11]="NotIn",H[H.Greater=12]="Greater",H[H.GreaterEquals=13]="GreaterEquals",H[H.Smaller=14]="Smaller",H[H.SmallerEquals=15]="SmallerEquals"})(P||(e.ContextKeyExprType=P={}));const g={regexParsingWithErrorRecovery:!0},y=(0,R.localize)(0,null),S=(0,R.localize)(1,null),w=(0,R.localize)(2,null),c=(0,R.localize)(3,null),s=(0,R.localize)(4,null),i=(0,R.localize)(5,null),n=(0,R.localize)(6,null),o=(0,R.localize)(7,null);class a{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(U=g){this.k=U,this.d=new f.$Oi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(U){if(U===""){this.h.push({message:y,offset:0,lexeme:"",additionalInfo:S});return}this.f=this.d.reset(U).scan(),this.g=0,this.h=[];try{const ce=this.l();if(!this.E()){const Ee=this.D(),ne=Ee.type===17?i:void 0;throw this.h.push({message:s,offset:Ee.offset,lexeme:f.$Oi.getLexeme(Ee),additionalInfo:ne}),a.c}return ce}catch(ce){if(ce!==a.c)throw ce;return}}l(){return this.m()}m(){const U=[this.o()];for(;this.y(16);){const ce=this.o();U.push(ce)}return U.length===1?U[0]:t.or(...U)}o(){const U=[this.s()];for(;this.y(15);){const ce=this.s();U.push(ce)}return U.length===1?U[0]:t.and(...U)}s(){if(this.y(2)){const U=this.D();switch(U.type){case 11:return this.z(),l.INSTANCE;case 12:return this.z(),h.INSTANCE;case 0:{this.z();const ce=this.l();return this.A(1,c),ce?.negate()}case 17:return this.z(),C.create(U.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",U)}}return this.t()}t(){const U=this.D();switch(U.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const ce=this.l();return this.A(1,c),ce}case 17:{const ce=U.lexeme;if(this.z(),this.y(9)){const ne=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),ne.type!==10)throw this.B("REGEX",ne);const G=ne.lexeme,J=G.lastIndexOf("/"),ge=J===G.length-1?void 0:this.w(G.substring(J+1));let x;try{x=new RegExp(G.substring(1,J),ge)}catch{throw this.B("REGEX",ne)}return T.create(ce,x)}switch(ne.type){case 10:case 19:{const G=[ne.lexeme];this.z();let J=this.D(),ge=0;for(let be=0;be<ne.lexeme.length;be++)ne.lexeme.charCodeAt(be)===40?ge++:ne.lexeme.charCodeAt(be)===41&&ge--;for(;!this.E()&&J.type!==15&&J.type!==16;){switch(J.type){case 0:ge++;break;case 1:ge--;break;case 10:case 18:for(let be=0;be<J.lexeme.length;be++)J.lexeme.charCodeAt(be)===40?ge++:ne.lexeme.charCodeAt(be)===41&&ge--}if(ge<0)break;G.push(f.$Oi.getLexeme(J)),this.z(),J=this.D()}const x=G.join(""),le=x.lastIndexOf("/"),te=le===x.length-1?void 0:this.w(x.substring(le+1));let de;try{de=new RegExp(x.substring(1,le),te)}catch{throw this.B("REGEX",ne)}return t.regex(ce,de)}case 18:{const G=ne.lexeme;this.z();let J=null;if(!(0,F.$Ce)(G)){const ge=G.indexOf("/"),x=G.lastIndexOf("/");if(ge!==x&&ge>=0){const le=G.slice(ge+1,x),te=G[x+1]==="i"?"i":"";try{J=new RegExp(le,te)}catch{throw this.B("REGEX",ne)}}}if(J===null)throw this.B("REGEX",ne);return T.create(ce,J)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,w);const ne=this.u();return t.notIn(ce,ne)}switch(this.D().type){case 3:{this.z();const ne=this.u();if(this.x().type===18)return t.equals(ce,ne);switch(ne){case"true":return t.has(ce);case"false":return t.not(ce);default:return t.equals(ce,ne)}}case 4:{this.z();const ne=this.u();if(this.x().type===18)return t.notEquals(ce,ne);switch(ne){case"true":return t.not(ce);case"false":return t.has(ce);default:return t.notEquals(ce,ne)}}case 5:return this.z(),O.create(ce,this.u());case 6:return this.z(),j.create(ce,this.u());case 7:return this.z(),z.create(ce,this.u());case 8:return this.z(),M.create(ce,this.u());case 13:return this.z(),t.in(ce,this.u());default:return t.has(ce)}}case 20:throw this.h.push({message:n,offset:U.offset,lexeme:"",additionalInfo:o}),a.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const U=this.D();switch(U.type){case 17:case 18:return this.z(),U.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(U){return U.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(U){return this.C(U)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(U,ce){if(this.C(U))return this.z();throw this.B(ce,this.D())}B(U,ce,Ee){const ne=(0,R.localize)(8,null,U,f.$Oi.getLexeme(ce)),G=ce.offset,J=f.$Oi.getLexeme(ce);return this.h.push({message:ne,offset:G,lexeme:J,additionalInfo:Ee}),a.c}C(U){return this.D().type===U}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Qi=a;class t{static false(){return l.INSTANCE}static true(){return h.INSTANCE}static has(U){return k.create(U)}static equals(U,ce){return D.create(U,ce)}static notEquals(U,ce){return v.create(U,ce)}static regex(U,ce){return T.create(U,ce)}static in(U,ce){return $.create(U,ce)}static notIn(U,ce){return b.create(U,ce)}static not(U){return C.create(U)}static and(...U){return fe.create(U,null,!0)}static or(...U){return ee.create(U,null,!0)}static greater(U,ce){return z.create(U,ce)}static greaterEquals(U,ce){return M.create(U,ce)}static smaller(U,ce){return O.create(U,ce)}static smallerEquals(U,ce){return j.create(U,ce)}static{this.c=new a({regexParsingWithErrorRecovery:!1})}static deserialize(U){return U==null?void 0:this.c.parse(U)}}e.$Ri=t;function r(H){const U=new a({regexParsingWithErrorRecovery:!1});return H.map(ce=>(U.parse(ce),U.lexingErrors.length>0?U.lexingErrors.map(Ee=>({errorMessage:Ee.additionalInfo?(0,R.localize)(9,null,Ee.additionalInfo):(0,R.localize)(10,null),offset:Ee.offset,length:Ee.lexeme.length})):U.parsingErrors.length>0?U.parsingErrors.map(Ee=>({errorMessage:Ee.additionalInfo?`${Ee.message}. ${Ee.additionalInfo}`:Ee.message,offset:Ee.offset,length:Ee.lexeme.length})):[]))}e.$Si=r;function d(H,U){const ce=H?H.substituteConstants():void 0,Ee=U?U.substituteConstants():void 0;return!ce&&!Ee?!0:!ce||!Ee?!1:ce.equals(Ee)}e.$Ti=d;function u(H,U){return H.cmp(U)}class l{static{this.INSTANCE=new l}constructor(){this.type=0}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!1}serialize(){return"false"}keys(){return[]}map(U){return this}negate(){return h.INSTANCE}}e.$Ui=l;class h{static{this.INSTANCE=new h}constructor(){this.type=1}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!0}serialize(){return"true"}keys(){return[]}map(U){return this}negate(){return l.INSTANCE}}e.$Vi=h;class k{static create(U,ce=null){const Ee=E.get(U);return typeof Ee=="boolean"?Ee?h.INSTANCE:l.INSTANCE:new k(U,ce)}constructor(U,ce){this.key=U,this.c=ce,this.type=2}cmp(U){return U.type!==this.type?this.type-U.type:X(this.key,U.key)}equals(U){return U.type===this.type?this.key===U.key:!1}substituteConstants(){const U=E.get(this.key);return typeof U=="boolean"?U?h.INSTANCE:l.INSTANCE:this}evaluate(U){return!!U.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(U){return U.mapDefined(this.key)}negate(){return this.c||(this.c=C.create(this.key,this)),this.c}}e.$Wi=k;class D{static create(U,ce,Ee=null){if(typeof ce=="boolean")return ce?k.create(U,Ee):C.create(U,Ee);const ne=E.get(U);return typeof ne=="boolean"?ce===(ne?"true":"false")?h.INSTANCE:l.INSTANCE:new D(U,ce,Ee)}constructor(U,ce,Ee){this.c=U,this.d=ce,this.f=Ee,this.type=4}cmp(U){return U.type!==this.type?this.type-U.type:ae(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=E.get(this.c);if(typeof U=="boolean"){const ce=U?"true":"false";return this.d===ce?h.INSTANCE:l.INSTANCE}return this}evaluate(U){return U.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(U){return U.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$Xi=D;class ${static create(U,ce){return new $(U,ce)}constructor(U,ce){this.d=U,this.f=ce,this.type=10,this.c=null}cmp(U){return U.type!==this.type?this.type-U.type:ae(this.d,this.f,U.d,U.f)}equals(U){return U.type===this.type?this.d===U.d&&this.f===U.f:!1}substituteConstants(){return this}evaluate(U){const ce=U.getValue(this.f),Ee=U.getValue(this.d);return Array.isArray(ce)?ce.includes(Ee):typeof Ee=="string"&&typeof ce=="object"&&ce!==null?A.call(ce,Ee):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(U){return U.mapIn(this.d,this.f)}negate(){return this.c||(this.c=b.create(this.d,this.f)),this.c}}e.$Yi=$;class b{static create(U,ce){return new b(U,ce)}constructor(U,ce){this.d=U,this.f=ce,this.type=11,this.c=$.create(U,ce)}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(U){return U.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Zi=b;class v{static create(U,ce,Ee=null){if(typeof ce=="boolean")return ce?C.create(U,Ee):k.create(U,Ee);const ne=E.get(U);return typeof ne=="boolean"?ce===(ne?"true":"false")?l.INSTANCE:h.INSTANCE:new v(U,ce,Ee)}constructor(U,ce,Ee){this.c=U,this.d=ce,this.f=Ee,this.type=5}cmp(U){return U.type!==this.type?this.type-U.type:ae(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=E.get(this.c);if(typeof U=="boolean"){const ce=U?"true":"false";return this.d===ce?l.INSTANCE:h.INSTANCE}return this}evaluate(U){return U.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(U){return U.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$1i=v;class C{static create(U,ce=null){const Ee=E.get(U);return typeof Ee=="boolean"?Ee?l.INSTANCE:h.INSTANCE:new C(U,ce)}constructor(U,ce){this.c=U,this.d=ce,this.type=3}cmp(U){return U.type!==this.type?this.type-U.type:X(this.c,U.c)}equals(U){return U.type===this.type?this.c===U.c:!1}substituteConstants(){const U=E.get(this.c);return typeof U=="boolean"?U?l.INSTANCE:h.INSTANCE:this}evaluate(U){return!U.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(U){return U.mapNot(this.c)}negate(){return this.d||(this.d=k.create(this.c,this)),this.d}}e.$2i=C;function N(H,U){if(typeof H=="string"){const ce=parseFloat(H);isNaN(ce)||(H=ce)}return typeof H=="string"||typeof H=="number"?U(H):l.INSTANCE}class z{static create(U,ce,Ee=null){return N(ce,ne=>new z(U,ne,Ee))}constructor(U,ce,Ee){this.c=U,this.d=ce,this.f=Ee,this.type=12}cmp(U){return U.type!==this.type?this.type-U.type:ae(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$3i=z;class M{static create(U,ce,Ee=null){return N(ce,ne=>new M(U,ne,Ee))}constructor(U,ce,Ee){this.c=U,this.d=ce,this.f=Ee,this.type=13}cmp(U){return U.type!==this.type?this.type-U.type:ae(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$4i=M;class O{static create(U,ce,Ee=null){return N(ce,ne=>new O(U,ne,Ee))}constructor(U,ce,Ee){this.c=U,this.d=ce,this.f=Ee,this.type=14}cmp(U){return U.type!==this.type?this.type-U.type:ae(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$5i=O;class j{static create(U,ce,Ee=null){return N(ce,ne=>new j(U,ne,Ee))}constructor(U,ce,Ee){this.c=U,this.d=ce,this.f=Ee,this.type=15}cmp(U){return U.type!==this.type?this.type-U.type:ae(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$6i=j;class T{static create(U,ce){return new T(U,ce)}constructor(U,ce){this.d=U,this.f=ce,this.type=7,this.c=null}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.d<U.d)return-1;if(this.d>U.d)return 1;const ce=this.f?this.f.source:"",Ee=U.f?U.f.source:"";return ce<Ee?-1:ce>Ee?1:0}equals(U){if(U.type===this.type){const ce=this.f?this.f.source:"",Ee=U.f?U.f.source:"";return this.d===U.d&&ce===Ee}return!1}substituteConstants(){return this}evaluate(U){const ce=U.getValue(this.d);return this.f?this.f.test(ce):!1}serialize(){const U=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${U}`}keys(){return[this.d]}map(U){return U.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=V.create(this)),this.c}}e.$7i=T;class V{static create(U){return new V(U)}constructor(U){this.c=U,this.type=8}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(U){return new V(this.c.map(U))}negate(){return this.c}}e.$8i=V;function q(H){let U=null;for(let ce=0,Ee=H.length;ce<Ee;ce++){const ne=H[ce].substituteConstants();if(H[ce]!==ne&&U===null){U=[];for(let G=0;G<ce;G++)U[G]=H[G]}U!==null&&(U[ce]=ne)}return U===null?H:U}class fe{static create(U,ce,Ee){return fe.d(U,ce,Ee)}constructor(U,ce){this.expr=U,this.c=ce,this.type=6}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let ce=0,Ee=this.expr.length;ce<Ee;ce++){const ne=u(this.expr[ce],U.expr[ce]);if(ne!==0)return ne}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let ce=0,Ee=this.expr.length;ce<Ee;ce++)if(!this.expr[ce].equals(U.expr[ce]))return!1;return!0}return!1}substituteConstants(){const U=q(this.expr);return U===this.expr?this:fe.create(U,this.c,!1)}evaluate(U){for(let ce=0,Ee=this.expr.length;ce<Ee;ce++)if(!this.expr[ce].evaluate(U))return!1;return!0}static d(U,ce,Ee){const ne=[];let G=!1;for(const J of U)if(J){if(J.type===1){G=!0;continue}if(J.type===0)return l.INSTANCE;if(J.type===6){ne.push(...J.expr);continue}ne.push(J)}if(ne.length===0&&G)return h.INSTANCE;if(ne.length!==0){if(ne.length===1)return ne[0];ne.sort(u);for(let J=1;J<ne.length;J++)ne[J-1].equals(ne[J])&&(ne.splice(J,1),J--);if(ne.length===1)return ne[0];for(;ne.length>1;){const J=ne[ne.length-1];if(J.type!==9)break;ne.pop();const ge=ne.pop(),x=ne.length===0,le=ee.create(J.expr.map(te=>fe.create([te,ge],null,Ee)),null,x);le&&(ne.push(le),ne.sort(u))}if(ne.length===1)return ne[0];if(Ee){for(let J=0;J<ne.length;J++)for(let ge=J+1;ge<ne.length;ge++)if(ne[J].negate().equals(ne[ge]))return l.INSTANCE;if(ne.length===1)return ne[0]}return new fe(ne,ce)}}serialize(){return this.expr.map(U=>U.serialize()).join(" && ")}keys(){const U=[];for(const ce of this.expr)U.push(...ce.keys());return U}map(U){return new fe(this.expr.map(ce=>ce.map(U)),null)}negate(){if(!this.c){const U=[];for(const ce of this.expr)U.push(ce.negate());this.c=ee.create(U,this,!0)}return this.c}}e.$9i=fe;class ee{static create(U,ce,Ee){return ee.d(U,ce,Ee)}constructor(U,ce){this.expr=U,this.c=ce,this.type=9}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let ce=0,Ee=this.expr.length;ce<Ee;ce++){const ne=u(this.expr[ce],U.expr[ce]);if(ne!==0)return ne}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let ce=0,Ee=this.expr.length;ce<Ee;ce++)if(!this.expr[ce].equals(U.expr[ce]))return!1;return!0}return!1}substituteConstants(){const U=q(this.expr);return U===this.expr?this:ee.create(U,this.c,!1)}evaluate(U){for(let ce=0,Ee=this.expr.length;ce<Ee;ce++)if(this.expr[ce].evaluate(U))return!0;return!1}static d(U,ce,Ee){let ne=[],G=!1;if(U){for(let J=0,ge=U.length;J<ge;J++){const x=U[J];if(x){if(x.type===0){G=!0;continue}if(x.type===1)return h.INSTANCE;if(x.type===9){ne=ne.concat(x.expr);continue}ne.push(x)}}if(ne.length===0&&G)return l.INSTANCE;ne.sort(u)}if(ne.length!==0){if(ne.length===1)return ne[0];for(let J=1;J<ne.length;J++)ne[J-1].equals(ne[J])&&(ne.splice(J,1),J--);if(ne.length===1)return ne[0];if(Ee){for(let J=0;J<ne.length;J++)for(let ge=J+1;ge<ne.length;ge++)if(ne[J].negate().equals(ne[ge]))return h.INSTANCE;if(ne.length===1)return ne[0]}return new ee(ne,ce)}}serialize(){return this.expr.map(U=>U.serialize()).join(" || ")}keys(){const U=[];for(const ce of this.expr)U.push(...ce.keys());return U}map(U){return new ee(this.expr.map(ce=>ce.map(U)),null)}negate(){if(!this.c){const U=[];for(const ce of this.expr)U.push(ce.negate());for(;U.length>1;){const ce=U.shift(),Ee=U.shift(),ne=[];for(const G of we(ce))for(const J of we(Ee))ne.push(fe.create([G,J],null,!1));U.unshift(ee.create(ne,null,!1))}this.c=ee.create(U,this,!0)}return this.c}}e.$0i=ee;class Y extends k{static{this.d=[]}static all(){return Y.d.values()}constructor(U,ce,Ee){super(U,null),this.f=ce,typeof Ee=="object"?Y.d.push({...Ee,key:U}):Ee!==!0&&Y.d.push({key:U,description:Ee,type:ce!=null?typeof ce:void 0})}bindTo(U){return U.createKey(this.key,this.f)}getValue(U){return U.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(U){return D.create(this.key,U)}notEqualsTo(U){return v.create(this.key,U)}}e.$$i=Y,e.$_i=(0,L.$Th)("contextKeyService");function X(H,U){return H<U?-1:H>U?1:0}function ae(H,U,ce,Ee){return H<ce?-1:H>ce?1:U<Ee?-1:U>Ee?1:0}function Z(H,U){if(H.type===0||U.type===1)return!0;if(H.type===9)return U.type===9?se(H.expr,U.expr):!1;if(U.type===9){for(const ce of U.expr)if(Z(H,ce))return!0;return!1}if(H.type===6){if(U.type===6)return se(U.expr,H.expr);for(const ce of H.expr)if(Z(ce,U))return!0;return!1}return H.equals(U)}e.$aj=Z;function se(H,U){let ce=0,Ee=0;for(;ce<H.length&&Ee<U.length;){const ne=H[ce].cmp(U[Ee]);if(ne<0)return!1;ne===0&&ce++,Ee++}return ce===H.length}function we(H){return H.type===9?H.expr:[H]}}),define(ke[241],Se([1,0,23,39,199,5,102,12,24]),function($e,e,I,F,f,L,R,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jv=e.$Iv=e.ConfirmResult=e.$Hv=e.$Gv=e.$Fv=void 0,e.$Fv=(0,L.$Th)("dialogService");var m;(function(w){w[w.Confirmation=1]="Confirmation",w[w.Prompt=2]="Prompt",w[w.Input=3]="Input"})(m||(m={}));class A{a(c){return this.d(c,m.Confirmation)}b(c){return this.d(c,m.Prompt)}c(c){return this.d(c,m.Input)}d(c,s){const i=[];switch(s){case m.Confirmation:{const n=c;n.primaryButton?i.push(n.primaryButton):i.push((0,f.localize)(0,null)),n.cancelButton?i.push(n.cancelButton):i.push((0,f.localize)(1,null));break}case m.Prompt:{const n=c;Array.isArray(n.buttons)&&n.buttons.length>0&&i.push(...n.buttons.map(o=>o.label)),n.cancelButton&&(n.cancelButton===!0?i.push((0,f.localize)(2,null)):typeof n.cancelButton=="string"?i.push(n.cancelButton):n.cancelButton.label?i.push(n.cancelButton.label):i.push((0,f.localize)(3,null))),i.length===0&&i.push((0,f.localize)(4,null));break}case m.Input:{const n=c;n.primaryButton?i.push(n.primaryButton):i.push((0,f.localize)(5,null)),n.cancelButton?i.push(n.cancelButton):i.push((0,f.localize)(6,null));break}}return i}e(c){if(typeof c=="string")return c;if(typeof c=="number")return c===F.default.Info?"info":c===F.default.Error?"error":c===F.default.Warning?"warning":"none"}f(c,s,i){const n=[...c.buttons??[]];c.cancelButton&&typeof c.cancelButton!="string"&&typeof c.cancelButton!="boolean"&&n.push(c.cancelButton);let o=n[s]?.run({checkboxChecked:i});return o instanceof Promise||(o=Promise.resolve(o)),{result:o,checkboxChecked:i}}}e.$Gv=A,e.$Hv=(0,L.$Th)("fileDialogService");var P;(function(w){w[w.SAVE=0]="SAVE",w[w.DONT_SAVE=1]="DONT_SAVE",w[w.CANCEL=2]="CANCEL"})(P||(e.ConfirmResult=P={}));const g=10;function y(w){const c=[];return c.push(...w.slice(0,g).map(s=>typeof s=="string"?s:(0,I.$tg)(s))),w.length>g&&(w.length-g===1?c.push((0,f.localize)(7,null)):c.push((0,f.localize)(8,null,w.length-g))),c.push(""),c.join(`
`)}e.$Iv=y;function S(w,c){const s=(0,E.$$m)(w);let i=(s.buttons??[]).map(t=>(0,R.$Cv)(t)),n=(w.buttons||[]).map((t,r)=>r),o=0,a=s.cancelId??i.length-1;if(i.length>1){const t=typeof a=="number"?i[a]:void 0;if(p.$l||p.$k){if(typeof t=="string"&&i.length>1&&a!==1){i.splice(a,1),i.splice(1,0,t);const r=n[a];n.splice(a,1),n.splice(1,0,r),a=1}p.$l&&i.length>1&&(i=i.reverse(),n=n.reverse(),o=i.length-1,typeof t=="string"&&(a=o-1))}else if(p.$j&&typeof t=="string"&&i.length>1&&a!==i.length-1){i.splice(a,1),i.push(t);const r=n[a];n.splice(a,1),n.push(r),a=i.length-1}}return s.buttons=i,s.defaultId=o,s.cancelId=a,s.noLink=!0,s.title=s.title||c.nameLong,{options:s,buttonIndeces:n}}e.$Jv=S}),define(ke[134],Se([1,0,5]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=e.$1h=void 0,e.$1h=(0,I.$Th)("environmentService"),e.$2h=(0,I.$Uh)(e.$1h)}),define(ke[135],Se([1,0,200,5]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$bo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=void 0,e.$2n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$3n=new RegExp(e.$2n),e.$4n="__web_extension",e.$5n="skipWalkthrough",e.$6n="extensionsSync",e.$7n="dependecyOrPackExtensionInstall";function f(s){switch(s){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$8n=f;function L(s){switch(s){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$9n=L;function R(s,i){switch(s){case 3:return i==="x64"?"win32-x64":i==="arm64"?"win32-arm64":"unknown";case 2:return i==="x64"?"linux-x64":i==="arm64"?"linux-arm64":i==="arm"?"linux-armhf":"unknown";case"alpine":return i==="x64"?"alpine-x64":i==="arm64"?"alpine-arm64":"unknown";case 1:return i==="x64"?"darwin-x64":i==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$0n=R;function p(s,i){return i==="web"&&!s.includes("web")}e.$$n=p;function E(s,i,n){return p(i,n)?!1:s==="undefined"||s==="universal"?!0:s==="unknown"?!1:s===n}e.$_n=E;function m(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(!s.uuid||typeof s.uuid=="string")}e.$ao=m;var A;(function(s){s[s.NoneOrRelevance=0]="NoneOrRelevance",s[s.LastUpdatedDate=1]="LastUpdatedDate",s[s.Title=2]="Title",s[s.PublisherName=3]="PublisherName",s[s.InstallCount=4]="InstallCount",s[s.PublishedDate=10]="PublishedDate",s[s.AverageRating=6]="AverageRating",s[s.WeightedRating=12]="WeightedRating"})(A||(e.SortBy=A={}));var P;(function(s){s[s.Default=0]="Default",s[s.Ascending=1]="Ascending",s[s.Descending=2]="Descending"})(P||(e.SortOrder=P={}));var g;(function(s){s.Install="install",s.Uninstall="uninstall"})(g||(e.StatisticType=g={}));var y;(function(s){s[s.None=1]="None",s[s.Install=2]="Install",s[s.Update=3]="Update",s[s.Migrate=4]="Migrate"})(y||(e.InstallOperation=y={})),e.$bo=(0,F.$Th)("extensionGalleryService");var S;(function(s){s.Unsupported="Unsupported",s.Deprecated="Deprecated",s.Malicious="Malicious",s.Incompatible="Incompatible",s.IncompatibleTargetPlatform="IncompatibleTargetPlatform",s.ReleaseVersionNotFound="ReleaseVersionNotFound",s.Invalid="Invalid",s.Download="Download",s.Extract="Extract",s.Delete="Delete",s.Rename="Rename",s.CorruptZip="CorruptZip",s.IncompleteZip="IncompleteZip",s.Signature="Signature",s.Internal="Internal"})(S||(e.ExtensionManagementErrorCode=S={}));var w;(function(s){s.UnknownError="UnknownError",s.PackageIsInvalidZip="PackageIsInvalidZip",s.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(w||(e.ExtensionSignaturetErrorCode=w={}));class c extends Error{constructor(i,n){super(i),this.code=n,this.name=n}}e.$co=c,e.$do=(0,F.$Th)("extensionManagementService"),e.$eo="extensionsIdentifiers/disabled",e.$fo="extensionsIdentifiers/enabled",e.$go=(0,F.$Th)("IGlobalExtensionEnablementService"),e.$ho=(0,F.$Th)("IExtensionTipsService"),e.$io=(0,I.localize)(0,null),e.$jo={value:e.$io,original:"Extensions"},e.$ko={value:(0,I.localize)(1,null),original:"Preferences"}}),define(ke[242],Se([1,0,5]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2Yb=e.$1Yb=void 0,e.$1Yb=(0,I.$Th)("externalTerminal"),e.$2Yb="Terminal.app"}),define(ke[243],Se([1,0,50,17,16,12,101,30,104,202,242]),function($e,e,I,F,f,L,R,p,E,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z7b=e.$Y7b=e.$X7b=void 0;const P=m.localize(0,null);class g{async getDefaultTerminalForPlatforms(){return{windows:y.getDefaultTerminalWindows(),linux:await w.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class y extends g{static{this.b="cmd.exe"}openTerminal(o,a){return this.spawnTerminal(I,o,E.$Fl(),a)}spawnTerminal(o,a,t,r){const d=a.windowsExec||y.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const u=f.$mc(d,".exe").toLowerCase();if(u==="cmder")return o.spawn(d,r?[r]:void 0),Promise.resolve(void 0);const l=["/c","start","/wait"];return d.indexOf(" ")>=0&&l.push('""'),l.push(d),u==="wt"&&l.push("-d ."),new Promise((h,k)=>{const D=c(process),$=o.spawn(t,l,{cwd:r,env:D});$.on("error",k),$.on("exit",()=>h())})}runInTerminal(o,a,t,r,d){const u="windowsExec"in d&&d.windowsExec?d.windowsExec:y.getDefaultTerminalWindows();return new Promise((l,h)=>{const k=`"${a} - ${P}"`,D=`""${t.join('" "')}" & pause"`,$=Object.assign({},c(process),r);Object.keys($).filter(z=>$[z]===null).forEach(z=>delete $[z]);const b={cwd:a,env:$,windowsVerbatimArguments:!0};let v,C;f.$mc(u,".exe")==="wt"?(v=u,C=["-d",".",y.b,"/c",D]):(v=y.b,C=["/c","start",k,"/wait",u,"/c",D]),I.spawn(v,C,b).on("error",z=>{h(s(z))}),l(void 0)})}static getDefaultTerminalWindows(){if(!y.d){const o=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");y.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${o?"Sysnative":"System32"}\\cmd.exe`}return y.d}}e.$X7b=y;class S extends g{static{this.b="/usr/bin/osascript"}openTerminal(o,a){return this.spawnTerminal(I,o,a)}runInTerminal(o,a,t,r,d){const u=d.osxExec||A.$2Yb;return new Promise((l,h)=>{if(u===A.$2Yb||u==="iTerm.app"){const k=u===A.$2Yb?"TerminalHelper":"iTermHelper",$=[F.$dg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${k}.scpt`).fsPath,"-t",o||P,"-w",a];for(const C of t)$.push("-a"),$.push(C);if(r){const C=Object.assign({},c(process),r);for(const N in C){const z=C[N];z===null?($.push("-u"),$.push(N)):($.push("-e"),$.push(`${N}=${z}`))}}let b="";const v=I.spawn(S.b,$);v.on("error",C=>{h(s(C))}),v.stderr.on("data",C=>{b+=C.toString()}),v.on("exit",C=>{if(C===0)l(void 0);else if(b){const N=b.split(`
`,1);h(new Error(N[0]))}else h(new Error(m.localize(1,null,k,C)))})}else h(new Error(m.localize(2,null,u)))})}spawnTerminal(o,a,t){const r=a.osxExec||A.$2Yb;return new Promise((d,u)=>{const l=["-a",r];t&&l.push(t);const h=c(process),k=o.spawn("/usr/bin/open",l,{cwd:t,env:h});k.on("error",u),k.on("exit",()=>d())})}}e.$Y7b=S;class w extends g{static{this.b=m.localize(3,null)}openTerminal(o,a){return this.spawnTerminal(I,o,a)}runInTerminal(o,a,t,r,d){const u=d.linuxExec?Promise.resolve(d.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((l,h)=>{const k=[];u.then(D=>{D.indexOf("gnome-terminal")>=0?k.push("-x"):k.push("-e"),k.push("bash"),k.push("-c");const $=`${i(t)}; echo; read -p "${w.b}" -n1;`;k.push(`''${$}''`);const b=Object.assign({},c(process),r);Object.keys(b).filter(z=>b[z]===null).forEach(z=>delete b[z]);const v={cwd:a,env:b};let C="";const N=I.spawn(D,k,v);N.on("error",z=>{h(s(z))}),N.stderr.on("data",z=>{C+=z.toString()}),N.on("exit",z=>{if(z===0)l(void 0);else if(C){const M=C.split(`
`,1);h(new Error(M[0]))}else h(new Error(m.localize(4,null,D,z)))})})})}static async getDefaultTerminalLinuxReady(){if(!w.d)if(!L.$l)w.d=Promise.resolve("xterm");else{const o=await p.Promises.exists("/etc/debian_version");w.d=new Promise(a=>{o?a("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?a("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?a("konsole"):process.env.COLORTERM?a(process.env.COLORTERM):process.env.TERM?a(process.env.TERM):a("xterm")})}return w.d}spawnTerminal(o,a,t){const r=a.linuxExec?Promise.resolve(a.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((d,u)=>{r.then(l=>{const h=c(process),k=o.spawn(l,[],{cwd:t,env:h});k.on("error",u),k.on("exit",()=>d())})})}}e.$Z7b=w;function c(n){const o={...n.env};return(0,R.$Dl)(o),o}function s(n){return"errno"in n&&n.errno==="ENOENT"&&"path"in n&&typeof n.path=="string"?new Error(m.localize(5,null,n.path)):n}function i(n){let o="";for(const a of n)a.indexOf(" ")>=0?o+='"'+a+'"':o+=a,o+=" ";return o}}),define(ke[31],Se([1,0,78,16,13,18,2,203,5,12,17,48]),function($e,e,I,F,f,L,R,p,E,m,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lk=e.$Kk=e.$Jk=e.$Ik=e.$Hk=e.FileKind=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.FileOperationResult=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.FileChangeType=e.$uk=e.FileOperation=e.$tk=e.$sk=e.$rk=e.$qk=e.$pk=e.$ok=e.FileSystemProviderErrorCode=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.FileSystemProviderCapabilities=e.$ek=e.FilePermission=e.FileType=e.$dk=e.$ck=void 0,e.$ck=(0,E.$Th)("fileService");function g(Z){return Z.create===!0}e.$dk=g;var y;(function(Z){Z[Z.Unknown=0]="Unknown",Z[Z.File=1]="File",Z[Z.Directory=2]="Directory",Z[Z.SymbolicLink=64]="SymbolicLink"})(y||(e.FileType=y={}));var S;(function(Z){Z[Z.Readonly=1]="Readonly",Z[Z.Locked=2]="Locked"})(S||(e.FilePermission=S={}));function w(Z){const se=Z;return!!se&&typeof se.onDidChange=="function"}e.$ek=w;var c;(function(Z){Z[Z.None=0]="None",Z[Z.FileReadWrite=2]="FileReadWrite",Z[Z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",Z[Z.FileReadStream=16]="FileReadStream",Z[Z.FileFolderCopy=8]="FileFolderCopy",Z[Z.PathCaseSensitive=1024]="PathCaseSensitive",Z[Z.Readonly=2048]="Readonly",Z[Z.Trash=4096]="Trash",Z[Z.FileWriteUnlock=8192]="FileWriteUnlock",Z[Z.FileAtomicRead=16384]="FileAtomicRead",Z[Z.FileAtomicWrite=32768]="FileAtomicWrite",Z[Z.FileAtomicDelete=65536]="FileAtomicDelete",Z[Z.FileClone=131072]="FileClone"})(c||(e.FileSystemProviderCapabilities=c={}));function s(Z){return!!(Z.capabilities&2)}e.$fk=s;function i(Z){return!!(Z.capabilities&8)}e.$gk=i;function n(Z){return!!(Z.capabilities&131072)}e.$hk=n;function o(Z){return!!(Z.capabilities&4)}e.$ik=o;function a(Z){return!!(Z.capabilities&16)}e.$jk=a;function t(Z){return s(Z)?!!(Z.capabilities&16384):!1}e.$kk=t;function r(Z){return s(Z)?!!(Z.capabilities&32768):!1}e.$lk=r;function d(Z){return!!(Z.capabilities&65536)}e.$mk=d;function u(Z){return!!(Z.capabilities&2048)}e.$nk=u;var l;(function(Z){Z.FileExists="EntryExists",Z.FileNotFound="EntryNotFound",Z.FileNotADirectory="EntryNotADirectory",Z.FileIsADirectory="EntryIsADirectory",Z.FileExceedsStorageQuota="EntryExceedsStorageQuota",Z.FileTooLarge="EntryTooLarge",Z.FileWriteLocked="EntryWriteLocked",Z.NoPermissions="NoPermissions",Z.Unavailable="Unavailable",Z.Unknown="Unknown"})(l||(e.FileSystemProviderErrorCode=l={}));class h extends Error{static create(se,we){const H=new h(se.toString(),we);return $(H,we),H}constructor(se,we){super(se),this.code=we}}e.$ok=h;function k(Z,se){return h.create(Z,se)}e.$pk=k;function D(Z){return Z||k((0,p.localize)(0,null),l.Unknown)}e.$qk=D;function $(Z,se){return Z.name=se?`${se} (FileSystemError)`:"FileSystemError",Z}e.$rk=$;function b(Z){if(!Z)return l.Unknown;if(Z instanceof h)return Z.code;const se=/^(.+) \(FileSystemError\)$/.exec(Z.name);if(!se)return l.Unknown;switch(se[1]){case l.FileExists:return l.FileExists;case l.FileIsADirectory:return l.FileIsADirectory;case l.FileNotADirectory:return l.FileNotADirectory;case l.FileNotFound:return l.FileNotFound;case l.FileTooLarge:return l.FileTooLarge;case l.FileWriteLocked:return l.FileWriteLocked;case l.NoPermissions:return l.NoPermissions;case l.Unavailable:return l.Unavailable}return l.Unknown}e.$sk=b;function v(Z){if(Z instanceof j)return Z.fileOperationResult;switch(b(Z)){case l.FileNotFound:return 1;case l.FileIsADirectory:return 0;case l.FileNotADirectory:return 9;case l.FileWriteLocked:return 5;case l.NoPermissions:return 6;case l.FileExists:return 4;case l.FileTooLarge:return 7;default:return 10}}e.$tk=v;var C;(function(Z){Z[Z.CREATE=0]="CREATE",Z[Z.DELETE=1]="DELETE",Z[Z.MOVE=2]="MOVE",Z[Z.COPY=3]="COPY",Z[Z.WRITE=4]="WRITE"})(C||(e.FileOperation=C={}));class N{constructor(se,we,H){this.resource=se,this.operation=we,this.target=H}isOperation(se){return this.operation===se}}e.$uk=N;var z;(function(Z){Z[Z.UPDATED=0]="UPDATED",Z[Z.ADDED=1]="ADDED",Z[Z.DELETED=2]="DELETED"})(z||(e.FileChangeType=z={}));class M{static{this.a=null}constructor(se,we){this.c=we,this.b=void 0,this.d=new P.$U(()=>{const H=I.$Zh.forUris(()=>this.c);return H.fill(this.rawAdded.map(U=>[U,!0])),H}),this.f=new P.$U(()=>{const H=I.$Zh.forUris(()=>this.c);return H.fill(this.rawUpdated.map(U=>[U,!0])),H}),this.g=new P.$U(()=>{const H=I.$Zh.forUris(()=>this.c);return H.fill(this.rawDeleted.map(U=>[U,!0])),H}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const H of se){switch(H.type){case 1:this.rawAdded.push(H.resource);break;case 0:this.rawUpdated.push(H.resource);break;case 2:this.rawDeleted.push(H.resource);break}this.b!==M.a&&(typeof H.cId=="number"?this.b===void 0?this.b=H.cId:this.b!==H.cId&&(this.b=M.a):this.b!==void 0&&(this.b=M.a))}}contains(se,...we){return this.h(se,{includeChildren:!1},...we)}affects(se,...we){return this.h(se,{includeChildren:!0},...we)}h(se,we,...H){if(!se)return!1;const U=H.length>0;return!!((!U||H.includes(1))&&(this.d.value.get(se)||we.includeChildren&&this.d.value.findSuperstr(se))||(!U||H.includes(0))&&(this.f.value.get(se)||we.includeChildren&&this.f.value.findSuperstr(se))||(!U||H.includes(2))&&(this.g.value.findSubstr(se)||we.includeChildren&&this.g.value.findSuperstr(se)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(se){return this.b===se}hasCorrelation(){return typeof this.b=="number"}}e.$vk=M;function O(Z,se,we){return!Z||!se||Z===se||se.length>Z.length?!1:(se.charAt(se.length-1)!==F.sep&&(se+=F.sep),we?(0,f.$4e)(Z,se):Z.indexOf(se)===0)}e.$wk=O;class j extends Error{constructor(se,we,H){super(se),this.fileOperationResult=we,this.options=H}}e.$xk=j;class T extends j{constructor(se,we,H,U){super(se,we,U),this.fileOperationResult=we,this.size=H}}e.$yk=T;class V extends j{constructor(se,we,H){super(se,2,H),this.stat=we}}e.$zk=V;var q;(function(Z){Z[Z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",Z[Z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",Z[Z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",Z[Z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",Z[Z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",Z[Z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",Z[Z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",Z[Z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",Z[Z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",Z[Z.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",Z[Z.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(q||(e.FileOperationResult=q={})),e.$Ak={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Bk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Ck="files.associations",e.$Dk="files.exclude",e.$Ek="files.readonlyInclude",e.$Fk="files.readonlyExclude",e.$Gk="files.readonlyFromPermissions";var fe;(function(Z){Z[Z.FILE=0]="FILE",Z[Z.FOLDER=1]="FOLDER",Z[Z.ROOT_FOLDER=2]="ROOT_FOLDER"})(fe||(e.FileKind=fe={})),e.$Hk="";function ee(Z){if(!(typeof Z.size!="number"||typeof Z.mtime!="number"))return Z.mtime.toString(29)+Z.size.toString(31)}e.$Ik=ee;async function Y(Z,se){if(!se.hasProvider(R.URI.from({scheme:Z.scheme})))return new Promise(we=>{const H=se.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===Z.scheme&&U.added&&(H.dispose(),we())})})}e.$Jk=Y;class X{static{this.KB=1024}static{this.MB=X.KB*X.KB}static{this.GB=X.MB*X.KB}static{this.TB=X.GB*X.KB}static formatSize(se){return(0,L.$Df)(se)||(se=0),se<X.KB?(0,p.localize)(1,null,se.toFixed(0)):se<X.MB?(0,p.localize)(2,null,(se/X.KB).toFixed(2)):se<X.GB?(0,p.localize)(3,null,(se/X.MB).toFixed(2)):se<X.TB?(0,p.localize)(4,null,(se/X.GB).toFixed(2)):(0,p.localize)(5,null,(se/X.TB).toFixed(2))}}e.$Kk=X;function ae(Z){const se=typeof Z=="string"||Z?.scheme===A.Schemas.vscodeRemote;return typeof Z!="string"&&Z?.scheme===A.Schemas.file?1024*X.MB:se?10*X.MB:m.$p?50*X.MB:1024*X.MB}e.$Lk=ae}),define(ke[244],Se([1,0,22,11,204,31]),function($e,e,I,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=void 0;async function R(A,P,g,y,S,w){let c;try{await p(A,P,g,y,S,w)}catch(s){c=s}finally{c&&S.errorTransformer&&(c=S.errorTransformer(c)),typeof c<"u"&&g.error(c),g.end()}}e.$Qp=R;async function p(A,P,g,y,S,w){E(w);const c=await A.open(P,{create:!1});try{E(w);let s=0,i=0,n=S&&typeof S.length=="number"?S.length:void 0,o=I.$ce.alloc(Math.min(S.bufferSize,typeof n=="number"?n:S.bufferSize)),a=S&&typeof S.position=="number"?S.position:0,t=0;do i=await A.read(c,a,o.buffer,t,o.byteLength-t),a+=i,t+=i,s+=i,typeof n=="number"&&(n-=i),t===o.byteLength&&(await g.write(y(o)),o=I.$ce.alloc(Math.min(S.bufferSize,typeof n=="number"?n:S.bufferSize)),t=0);while(i>0&&(typeof n!="number"||n>0)&&E(w)&&m(s,S));if(t>0){let r=t;typeof n=="number"&&(r=Math.min(t,n)),g.write(y(o.slice(0,r)))}}catch(s){throw(0,L.$qk)(s)}finally{await A.close(c)}}function E(A){if(A.isCancellationRequested)throw(0,F.$5)();return!0}function m(A,P){if(typeof P?.limits?.size=="number"&&A>P.limits.size)throw(0,L.$pk)((0,f.localize)(0,null),L.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ke[85],Se([1,0,34,3,16,12,2,31]),function($e,e,I,F,f,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=e.$Yp=e.$Xp=e.$Wp=e.$Vp=e.$Up=e.$Tp=e.$Sp=void 0;function E(s){return s.recursive===!0}e.$Sp=E;class m extends F.$Rc{static{this.a=5}constructor(i,n,o,a){super(),this.h=i,this.j=n,this.m=o,this.n=a,this.c=this.B(new F.$Sc),this.f=void 0,this.g=0}s(){const i=new F.$Qc;this.c.value=i,this.b=this.r(i),this.b.setVerboseLogging(this.m),i.add(this.b.onDidChangeFile(n=>this.h(n))),i.add(this.b.onDidLogMessage(n=>this.j(n))),i.add(this.b.onDidError(n=>this.t(n)))}t(i){this.n.restartOnError?this.g<m.a&&this.f?(this.w(`restarting watcher after error: ${i}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${i}`):this.w(i)}u(i){this.g++,this.s(),this.watch(i)}async watch(i){this.f=i,await this.b?.watch(i)}async setVerboseLogging(i){this.m=i,await this.b?.setVerboseLogging(i)}w(i){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${i}`})}y(i){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${i}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Tp=m;class A extends m{constructor(i,n,o){super(i,n,o,{type:"node.js",restartOnError:!1})}}e.$Up=A;class P extends m{constructor(i,n,o){super(i,n,o,{type:"universal",restartOnError:!0})}}e.$Vp=P;function g(s){return s.map(i=>({type:i.type,resource:R.URI.revive(i.resource),cId:i.cId}))}e.$Wp=g;function y(s){const i=new c;for(const n of s)i.processEvent(n);return i.coalesce()}e.$Xp=y;function S(s,i){return typeof i=="string"&&!i.startsWith(I.$wj)&&!(0,f.$hc)(i)?{base:s,pattern:i}:i}e.$Yp=S;function w(s,i){const n=[];for(const o of i)n.push((0,I.$Aj)(S(s,o)));return n}e.$Zp=w;class c{constructor(){this.a=new Set,this.b=new Map}c(i){return L.$l?i.resource.fsPath:i.resource.fsPath.toLowerCase()}processEvent(i){const n=this.b.get(this.c(i));let o=!1;if(n){const a=n.type,t=i.type;n.resource.fsPath!==i.resource.fsPath&&(i.type===2||i.type===1)?o=!0:a===1&&t===2?(this.b.delete(this.c(i)),this.a.delete(n)):a===2&&t===1?n.type=0:a===1&&t===0||(n.type=t)}else o=!0;o&&(this.a.add(i),this.b.set(this.c(i),i))}coalesce(){const i=[],n=[];return Array.from(this.a).filter(o=>o.type!==2?(i.push(o),!1):!0).sort((o,a)=>o.resource.fsPath.length-a.resource.fsPath.length).filter(o=>n.some(a=>(0,p.$wk)(o.resource.fsPath,a,!L.$l))?!1:(n.push(o.resource.fsPath),!0)).concat(i)}}}),define(ke[245],Se([1,0,55,10,21,33,3,77,16,12,23,2,103,30,85]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=e.$aq=void 0;class w extends R.$Rc{static{this.a=100}static{this.b=75}constructor(i,n,o,a){super(),this.m=i,this.n=n,this.r=o,this.s=a,this.c=this.B(new F.$$g({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.n(t))),this.f=this.B(new F.$0g(t=>this.z(t),w.b)),this.g=(0,S.$Zp)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,S.$Zp)(this.m.path,this.m.includes):void 0,this.j=new f.$Yd,this.ready=this.t()}async t(){try{const i=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const n=await y.Promises.stat(i);this.B(await this.w(i,n.isDirectory()))}catch(i){i.code!=="ENOENT"?this.D(i):this.G(i)}}async u(i){let n=i.path;try{n=await y.Promises.realpath(i.path),i.path===n&&(n=await(0,g.$0p)(i.path)??i.path),i.path!==n&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${i.path}, real: ${n})`)}catch{}return n}async w(i,n){if(m.$k&&(0,L.$Yf)(i,"/Volumes/",!0))return this.D(`Refusing to watch ${i} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),R.$Rc.None;const o=new f.$Yd(this.j.token),a=new R.$Qc;try{const t=P.URI.file(this.m.path),r=(0,E.$mc)(i),d=(0,I.watch)(i);a.add((0,R.$Pc)(()=>{d.removeAllListeners(),d.close()})),this.G(`Started watching: '${i}'`);const u=new Set;if(n)try{for(const h of await y.Promises.readdir(i))u.add(h)}catch(h){this.D(h)}const l=new Map;a.add((0,R.$Pc)(()=>{for(const[,h]of l)h.dispose();l.clear()})),d.on("error",(h,k)=>{this.D(`Failed to watch ${i} for changes using fs.watch() (${h}, ${k})`),this.dispose()}),d.on("change",(h,k)=>{if(o.token.isCancellationRequested)return;this.G(`[raw] ["${h}"] ${k}`);let D="";if(k&&(D=k.toString(),m.$k&&(D=(0,p.$sl)(D))),!(!D||h!=="change"&&h!=="rename"))if(n)if(h==="rename"){l.get(D)?.dispose();const $=setTimeout(async()=>{if(l.delete(D),D===r&&!await y.Promises.exists(i)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const b=await this.C((0,E.$ic)(i,D));if(o.token.isCancellationRequested)return;let v;b?u.has(D)?v=0:(v=1,u.add(D)):(u.delete(D),v=2),this.y({resource:(0,A.$wg)(t,D),type:v,cId:this.m.correlationId})},w.a);l.set(D,(0,R.$Pc)(()=>clearTimeout($)))}else{let $;u.has(D)?$=0:($=1,u.add(D)),this.y({resource:(0,A.$wg)(t,D),type:$,cId:this.m.correlationId})}else if(h==="rename"||D!==r){const $=setTimeout(async()=>{const b=await y.Promises.exists(i);o.token.isCancellationRequested||(b?(this.y({resource:t,type:0,cId:this.m.correlationId},!0),a.add(await this.w(i,!1))):(this.y({resource:t,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},w.a);a.clear(),a.add((0,R.$Pc)(()=>clearTimeout($)))}else this.y({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){await y.Promises.exists(i)&&!o.token.isCancellationRequested&&this.D(`Failed to watch ${i} for changes using fs.watch() (${t.toString()})`)}return(0,R.$Pc)(()=>{o.dispose(!0),a.dispose()})}y(i,n=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${i.type===1?"[ADDED]":i.type===2?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`),!n&&this.g.some(o=>o(i.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${i.resource.fsPath}`):!n&&this.h&&this.h.length>0&&!this.h.some(o=>o(i.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${i.resource.fsPath}`):this.f.work(i))}z(i){const n=(0,S.$Xp)(i);if(n.length>0){if(this.s)for(const a of n)this.G(` >> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.resource.fsPath}`);this.c.work(n)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${n[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${n.length}, most recent change: ${n[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(i){if(m.$l)return y.Promises.exists(i);try{const n=(0,E.$mc)(i);return(await y.Promises.readdir((0,E.$lc)(i))).some(a=>a===n)}catch(n){return this.G(n),!1}}setVerboseLogging(i){this.s=i}D(i){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${i}`})}F(i){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${i}`})}G(i){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${i}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$aq=w;async function c(s,i,n,o,a=512){const t=await y.Promises.open(s,"r"),r=Buffer.allocUnsafe(a),d=new f.$Yd(o);let u,l=!1;const h={path:s,excludes:[],recursive:!1},k=new w(h,D=>{(async()=>{for(const{type:$}of D)if($===0){if(l)return;l=!0;try{for(;!d.token.isCancellationRequested;){const{bytesRead:b}=await y.Promises.read(t,r,0,a,null);if(!b||d.token.isCancellationRequested)break;i(r.slice(0,b))}}catch(b){u=new Error(b),d.dispose(!0)}finally{l=!1}}})()});return await k.ready,n(),new Promise((D,$)=>{d.token.onCancellationRequested(async()=>{k.dispose();try{await y.Promises.close(t)}catch(b){u=new Error(b)}u?$(u):D()})})}e.$bq=c}),define(ke[246],Se([1,0,4,34,3,12,245]),function($e,e,I,F,f,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=void 0;class p extends f.$Rc{constructor(){super(...arguments),this.a=this.B(new I.$Od),this.onDidChangeFile=this.a.event,this.b=this.B(new I.$Od),this.onDidLogMessage=this.b.event,this.onDidError=I.Event.None,this.c=new Map,this.f=!1}async watch(m){const A=this.j(m),P=A.filter(y=>{const S=this.c.get(y.path);return S?!(0,F.$Ej)(S.request.excludes,y.excludes)||!(0,F.$Ej)(S.request.includes,y.includes):!0}),g=Array.from(this.c.values()).filter(({request:y})=>!A.find(S=>S.path===y.path&&(0,F.$Ej)(S.excludes,y.excludes)&&(0,F.$Ej)(S.includes,y.includes))).map(({request:y})=>y.path);P.length&&this.m(`Request to start watching: ${P.map(y=>`${y.path} (excludes: ${y.excludes.length>0?y.excludes:"<none>"}, includes: ${y.includes&&y.includes.length>0?JSON.stringify(y.includes):"<all>"}, correlationId: ${typeof y.correlationId=="number"?y.correlationId:"<none>"})`).join(",")}`),g.length&&this.m(`Request to stop watching: ${g.join(",")}`);for(const y of g)this.h(y);for(const y of P)this.g(y)}g(m){const A=new R.$aq(m,g=>this.a.fire(g),g=>this.b.fire(g),this.f),P={request:m,instance:A};this.c.set(m.path,P)}async stop(){for(const[m]of this.c)this.h(m);this.c.clear()}h(m){const A=this.c.get(m);A&&(this.c.delete(m),A.instance.dispose())}j(m){const A=new Map;for(const P of m){const g=L.$l?P.path:P.path.toLowerCase();let y=A.get(P.correlationId);y||(y=new Map,A.set(P.correlationId,y)),y.set(g,P)}return Array.from(A.values()).map(P=>Array.from(P.values())).flat()}async setVerboseLogging(m){this.f=m;for(const[,A]of this.c)A.instance.setVerboseLogging(m)}m(m){this.f&&this.b.fire({type:"trace",message:this.n(m)})}n(m,A){return A?`[File Watcher (node.js)] ${m} (path: ${A.request.path})`:`[File Watcher (node.js)] ${m}`}}e.$cq=p}),define(ke[247],Se([1,0,85,246]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=void 0;class f extends I.$Up{constructor(R,p,E){super(R,p,E),this.s()}r(R){return R.add(new F.$cq)}}e.$dq=f}),define(ke[248],Se([1,0,17,82,187,85]),function($e,e,I,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=void 0;class R extends L.$Vp{constructor(E,m,A){super(E,m,A),this.s()}r(E){const m=E.add(new f.$7p(I.$dg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return E.add(m.onDidProcessExit(({code:A,signal:P})=>this.t(`terminated by itself with code ${A}, signal: ${P}`))),F.ProxyChannel.toService((0,F.$Ah)(m.getChannel("watcher")))}}e.$8p=R}),define(ke[107],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rh=void 0;class I{constructor(...f){this.a=new Map;for(const[L,R]of f)this.set(L,R)}set(f,L){const R=this.a.get(f);return this.a.set(f,L),R}has(f){return this.a.has(f)}get(f){return this.a.get(f)}}e.$Rh=I}),define(ke[249],Se([1,0,10,11,3,105,240,5,107,76]),function($e,e,I,F,f,L,R,p,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=e.$hq=void 0;const A=!1;class P extends Error{constructor(c){super("cyclic dependency between services"),this.message=c.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class g{constructor(c=new E.$Rh,s=!1,i,n=A){this.f=c,this.g=s,this.h=i,this.i=n,this.o=new Set,this.f.set(p.$Sh,this),this._globalGraph=n?i?._globalGraph??new R.$gq(o=>o):void 0}createChild(c){return new g(c,this.g,this,this.i)}invokeFunction(c,...s){const i=S.traceInvocation(this.i,c);let n=!1;try{return c({get:a=>{if(n)throw(0,F.$7)("service accessor is only valid during the invocation of its target method");const t=this.m(a,i);if(!t)throw new Error(`[invokeFunction] unknown service '${a}'`);return t}},...s)}finally{n=!0,i.stop()}}createInstance(c,...s){let i,n;return c instanceof L.$Qh?(i=S.traceCreation(this.i,c.ctor),n=this.j(c.ctor,c.staticArguments.concat(s),i)):(i=S.traceCreation(this.i,c),n=this.j(c,s,i)),i.stop(),n}j(c,s=[],i){const n=p._util.getServiceDependencies(c).sort((t,r)=>t.index-r.index),o=[];for(const t of n){const r=this.m(t.id,i);r||this.u(`[createInstance] ${c.name} depends on UNKNOWN service ${t.id}.`,!1),o.push(r)}const a=n.length>0?n[0].index:s.length;if(s.length!==a){console.trace(`[createInstance] First service dependency of ${c.name} at position ${a+1} conflicts with ${s.length} static arguments`);const t=a-s.length;t>0?s=s.concat(new Array(t)):s=s.slice(0,a)}return Reflect.construct(c,s.concat(o))}k(c,s){if(this.f.get(c)instanceof L.$Qh)this.f.set(c,s);else if(this.h)this.h.k(c,s);else throw new Error("illegalState - setting UNKNOWN service instance")}l(c){const s=this.f.get(c);return!s&&this.h?this.h.l(c):s}m(c,s){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(c));const i=this.l(c);return i instanceof L.$Qh?this.q(c,i,s.branch(c,!0)):(s.branch(c,!1),i)}q(c,s,i){if(this.o.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this.o.add(c);try{return this.r(c,s,i)}finally{this.o.delete(c)}}r(c,s,i){const n=new R.$gq(t=>t.id.toString());let o=0;const a=[{id:c,desc:s,_trace:i}];for(;a.length;){const t=a.pop();if(n.lookupOrInsertNode(t),o++>1e3)throw new P(n);for(const r of p._util.getServiceDependencies(t.desc.ctor)){const d=this.l(r.id);if(d||this.u(`[createInstance] ${c} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(r.id)),d instanceof L.$Qh){const u={id:r.id,desc:d,_trace:t._trace.branch(r.id,!0)};n.insertEdge(t,u),a.push(u)}}}for(;;){const t=n.roots();if(t.length===0){if(!n.isEmpty())throw new P(n);break}for(const{data:r}of t){if(this.l(r.id)instanceof L.$Qh){const u=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,u)}n.removeNode(r)}}return this.l(c)}s(c,s,i=[],n,o){if(this.f.get(c)instanceof L.$Qh)return this.t(c,s,i,n,o);if(this.h)return this.h.s(c,s,i,n,o);throw new Error(`illegalState - creating UNKNOWN service instance ${s.name}`)}t(c,s,i=[],n,o){if(n){const a=new g(void 0,this.g,this,this.i);a.c=String(c);const t=new Map,r=new I.$ch(()=>{const d=a.j(s,i,o);for(const[u,l]of t){const h=d[u];if(typeof h=="function")for(const k of l)h.apply(d,k)}return t.clear(),d});return new Proxy(Object.create(null),{get(d,u){if(!r.isInitialized&&typeof u=="string"&&(u.startsWith("onDid")||u.startsWith("onWill"))){let k=t.get(u);return k||(k=new m.$1c,t.set(u,k)),($,b,v)=>{const C=k.push([$,b,v]);return(0,f.$Pc)(C)}}if(u in d)return d[u];const l=r.value;let h=l[u];return typeof h!="function"||(h=h.bind(l),d[u]=h),h},set(d,u,l){return r.value[u]=l,!0},getPrototypeOf(d){return s.prototype}})}else return this.j(s,i,o)}u(c,s){if(s&&console.warn(c),this.g)throw new Error(c)}}e.$hq=g;var y;(function(w){w[w.None=0]="None",w[w.Creation=1]="Creation",w[w.Invocation=2]="Invocation",w[w.Branch=3]="Branch"})(y||(y={}));class S{static{this.all=new Set}static{this.c=new class extends S{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(c,s){return c?new S(2,s.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):S.c}static traceCreation(c,s){return c?new S(1,s.name):S.c}static{this.f=0}constructor(c,s){this.type=c,this.name=s,this.g=Date.now(),this.h=[]}branch(c,s){const i=new S(3,c.toString());return this.h.push([c,s,i]),i}stop(){const c=Date.now()-this.g;S.f+=c;let s=!1;function i(o,a){const t=[],r=new Array(o+1).join("	");for(const[d,u,l]of a.h)if(u&&l){s=!0,t.push(`${r}CREATES -> ${d}`);const h=i(o+1,l);h&&t.push(h)}else t.push(`${r}uses -> ${d}`);return t.join(`
`)}const n=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${i(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${S.f.toFixed(2)}ms)`];(c>2||s)&&S.all.add(n.join(`
`))}}e.$iq=S}),define(ke[15],Se([1,0,43,4,52,3,28,12,23,18,2,45,5]),function($e,e,I,F,f,L,R,p,E,m,A,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.log=e.$ej=e.LogLevel=e.$dj=e.$cj=e.$bj=void 0,e.$bj=(0,g.$Th)("logService"),e.$cj=(0,g.$Th)("loggerService");function y(){return new Date().toISOString()}function S($){return(0,m.$Df)($)}e.$dj=S;var w;(function($){$[$.Off=0]="Off",$[$.Trace=1]="Trace",$[$.Debug=2]="Debug",$[$.Info=3]="Info",$[$.Warning=4]="Warning",$[$.Error=5]="Error"})(w||(e.LogLevel=w={})),e.$ej=w.Info;function c($,b,v){switch(b){case w.Trace:$.trace(v);break;case w.Debug:$.debug(v);break;case w.Info:$.info(v);break;case w.Warning:$.warn(v);break;case w.Error:$.error(v);break;case w.Off:break;default:throw new Error(`Invalid log level ${b}`)}}e.log=c;function s($,b=!1){let v="";for(let C=0;C<$.length;C++){let N=$[C];if(N instanceof Error&&(N=(0,I.$Ei)(N,b)),typeof N=="object")try{N=JSON.stringify(N)}catch{}v+=(C>0?" ":"")+N}return v}class i extends L.$Rc{constructor(){super(...arguments),this.b=e.$ej,this.c=this.B(new F.$Od),this.onDidChangeLogLevel=this.c.event}setLevel(b){this.b!==b&&(this.b=b,this.c.fire(this.b))}getLevel(){return this.b}f(b){return this.b!==w.Off&&this.b<=b}}e.$gj=i;class n extends i{constructor(b){super(),this.h=b}f(b){return this.h||super.f(b)}trace(b,...v){this.f(w.Trace)&&this.g(w.Trace,s([b,...v],!0))}debug(b,...v){this.f(w.Debug)&&this.g(w.Debug,s([b,...v]))}info(b,...v){this.f(w.Info)&&this.g(w.Info,s([b,...v]))}warn(b,...v){this.f(w.Warning)&&this.g(w.Warning,s([b,...v]))}error(b,...v){if(this.f(w.Error))if(b instanceof Error){const C=Array.prototype.slice.call(arguments);C[0]=b.stack,this.g(w.Error,s(C))}else this.g(w.Error,s([b,...v]))}flush(){}}e.$hj=n;class o extends i{constructor(b=e.$ej){super(),this.setLevel(b),this.g=!p.$j}trace(b,...v){this.f(w.Trace)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,b,...v):console.log(`[main ${y()}]`,b,...v))}debug(b,...v){this.f(w.Debug)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,b,...v):console.log(`[main ${y()}]`,b,...v))}info(b,...v){this.f(w.Info)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,b,...v):console.log(`[main ${y()}]`,b,...v))}warn(b,...v){this.f(w.Warning)&&(this.g?console.warn(`\x1B[93m[main ${y()}]\x1B[0m`,b,...v):console.warn(`[main ${y()}]`,b,...v))}error(b,...v){this.f(w.Error)&&(this.g?console.error(`\x1B[91m[main ${y()}]\x1B[0m`,b,...v):console.error(`[main ${y()}]`,b,...v))}dispose(){}flush(){}}e.$ij=o;class a extends i{constructor(b=e.$ej,v=!0){super(),this.g=v,this.setLevel(b)}trace(b,...v){this.f(w.Trace)&&(this.g?console.log("%cTRACE","color: #888",b,...v):console.log(b,...v))}debug(b,...v){this.f(w.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",b,...v):console.log(b,...v))}info(b,...v){this.f(w.Info)&&(this.g?console.log("%c INFO","color: #33f",b,...v):console.log(b,...v))}warn(b,...v){this.f(w.Warning)&&(this.g?console.log("%c WARN","color: #993",b,...v):console.log(b,...v))}error(b,...v){this.f(w.Error)&&(this.g?console.log("%c  ERR","color: #f33",b,...v):console.error(b,...v))}dispose(){}flush(){}}e.$jj=a;class t extends i{constructor(b,v=e.$ej){super(),this.g=b,this.setLevel(v)}trace(b,...v){this.f(w.Trace)&&this.g.log(w.Trace,[this.h(b),...v])}debug(b,...v){this.f(w.Debug)&&this.g.log(w.Debug,[this.h(b),...v])}info(b,...v){this.f(w.Info)&&this.g.log(w.Info,[this.h(b),...v])}warn(b,...v){this.f(w.Warning)&&this.g.log(w.Warning,[this.h(b),...v])}error(b,...v){this.f(w.Error)&&this.g.log(w.Error,[this.h(b),...v])}h(b){return typeof b=="string"?b:(0,I.$Ei)(b,this.f(w.Trace))}dispose(){}flush(){}}e.$kj=t;class r extends i{constructor(b){super(),this.g=b,b.length&&this.setLevel(b[0].getLevel())}setLevel(b){for(const v of this.g)v.setLevel(b);super.setLevel(b)}trace(b,...v){for(const C of this.g)C.trace(b,...v)}debug(b,...v){for(const C of this.g)C.debug(b,...v)}info(b,...v){for(const C of this.g)C.info(b,...v)}warn(b,...v){for(const C of this.g)C.warn(b,...v)}error(b,...v){for(const C of this.g)C.error(b,...v)}flush(){for(const b of this.g)b.flush()}dispose(){for(const b of this.g)b.dispose()}}e.$lj=r;class d extends L.$Rc{constructor(b,v,C){if(super(),this.h=b,this.j=v,this.b=new R.$zc,this.c=this.B(new F.$Od),this.onDidChangeLoggers=this.c.event,this.f=this.B(new F.$Od),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new F.$Od),this.onDidChangeVisibility=this.g.event,C)for(const N of C)this.b.set(N.resource,{logger:void 0,info:N})}m(b){return(0,m.$zf)(b)?[...this.b.values()].find(v=>v.info.id===b):this.b.get(b)}getLogger(b){return this.m(b)?.logger}createLogger(b,v){const C=this.n(b),N=(0,m.$zf)(b)?b:v?.id??(0,f.$Hi)(C.toString()).toString(16);let z=this.b.get(C)?.logger;const M=v?.logLevel==="always"?w.Trace:v?.logLevel;z||(z=this.s(C,M??this.getLogLevel(C)??this.h,{...v,id:N}));const O={logger:z,info:{resource:C,id:N,logLevel:M,name:v?.name,hidden:v?.hidden,extensionId:v?.extensionId,when:v?.when}};return this.registerLogger(O.info),this.b.set(C,O),z}n(b){return(0,m.$zf)(b)?(0,E.$wg)(this.j,`${b}.log`):b}setLogLevel(b,v){if(A.URI.isUri(b)){const C=b,N=v,z=this.b.get(C);z&&N!==z.info.logLevel&&(z.info.logLevel=N===this.h?void 0:N,z.logger?.setLevel(N),this.b.set(z.info.resource,z),this.f.fire([C,N]))}else{this.h=b;for(const[C,N]of this.b.entries())this.b.get(C)?.info.logLevel===void 0&&N.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(b,v){const C=this.m(b);C&&v!==!C.info.hidden&&(C.info.hidden=!v,this.b.set(C.info.resource,C),this.g.fire([C.info.resource,v]))}getLogLevel(b){let v;return b&&(v=this.b.get(b)?.info.logLevel),v??this.h}registerLogger(b){const v=this.b.get(b.resource);v?v.info.hidden!==b.hidden&&this.setVisibility(b.resource,!b.hidden):(this.b.set(b.resource,{info:b,logger:void 0}),this.c.fire({added:[b],removed:[]}))}deregisterLogger(b){const v=this.b.get(b);v&&(v.logger&&v.logger.dispose(),this.b.delete(b),this.c.fire({added:[],removed:[v.info]}))}*getRegisteredLoggers(){for(const b of this.b.values())yield b.info}getRegisteredLogger(b){return this.b.get(b)?.info}dispose(){this.b.forEach(b=>b.logger?.dispose()),this.b.clear(),super.dispose()}}e.$mj=d;class u{constructor(){this.onDidChangeLogLevel=new F.$Od().event}setLevel(b){}getLevel(){return w.Info}trace(b,...v){}debug(b,...v){}info(b,...v){}warn(b,...v){}error(b,...v){}critical(b,...v){}dispose(){}flush(){}}e.$nj=u;class l extends u{}e.$oj=l;function h($){if($.verbose)return w.Trace;if(typeof $.logLevel=="string"){const b=D($.logLevel.toLowerCase());if(b!==void 0)return b}return e.$ej}e.$pj=h;function k($){switch($){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Off:return"off"}}e.$qj=k;function D($){switch($){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Error;case"off":return w.Off}}e.$rj=D,e.$sj=new P.$$i("logLevel",k(w.Info))}),define(ke[250],Se([1,0,19,10,11,4,3,16,85,15]),function($e,e,I,F,f,L,R,p,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=void 0;class A extends R.$Rc{constructor(g,y){super(),this.a=g,this.b=y,this.c=this.B(new L.$Od),this.onDidChangeFile=this.c.event,this.g=this.B(new L.$Od),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new F.$Sg(0)),this.w=[],this.y=this.B(new F.$Sg(0))}watch(g,y){return y.recursive||this.b?.watcher?.forceUniversal?this.n(g,y):this.z(g,y)}n(g,y){const S={path:this.H(g),excludes:y.excludes,includes:y.includes,recursive:y.recursive,correlationId:y.correlationId},w=(0,I.$Tb)(this.j,S);return this.r(),(0,R.$Pc)(()=>{w(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(g=>(0,f.$Z)(g))}s(){this.h||(this.h=this.B(this.t(y=>this.c.fire((0,E.$Wp)(y)),y=>this.G(y),this.a.getLevel()===m.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===m.LogLevel.Trace)})));const g=this.b?.watcher?.recursive?.usePolling;if(g===!0)for(const y of this.j)(0,E.$Sp)(y)&&(y.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(g))for(const y of this.j)(0,E.$Sp)(y)&&g.includes(y.path)&&(y.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(g,y){const S={path:this.H(g),excludes:y.excludes,includes:y.includes,recursive:!1,correlationId:y.correlationId},w=(0,I.$Tb)(this.w,S);return this.C(),(0,R.$Pc)(()=>{w(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(g=>(0,f.$Z)(g))}D(){return this.u||(this.u=this.B(this.F(g=>this.c.fire((0,E.$Wp)(g)),g=>this.G(g),this.a.getLevel()===m.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===m.LogLevel.Trace)}))),this.u.watch(this.w)}G(g){g.type==="error"&&this.g.fire(g.message),this.a[g.type](g.message)}H(g){return(0,p.$gc)(g.fsPath)}}e.$1p=A}),define(ke[251],Se([1,0,55,389,10,28,22,4,33,3,16,12,23,98,30,205,31,244,250,43,248,247]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,S,w,c,s,i,n,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=void 0,(()=>{try{(0,F.gracefulify)(I)}catch(r){console.error(`Error enabling graceful-fs: ${(0,n.$Ei)(r)}`)}})();class t extends i.$1p{static{this.I=!1}constructor(d,u){super(d,u),this.onDidChangeCapabilities=p.Event.None,this.N=new L.$zc(l=>g.$ng.getComparisonKey(l)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,P.$l&&(this.J|=1024)),this.J}async stat(d){try{const{stat:u,symbolicLink:l}=await S.SymlinkSupport.stat(this.H(d));return{type:this.M(u,l),ctime:u.birthtime.getTime(),mtime:u.mtime.getTime(),size:u.size,permissions:u.mode&128?void 0:c.FilePermission.Locked}}catch(u){throw this.fb(u)}}async L(d){try{return await this.stat(d)}catch{return}}async readdir(d){try{const u=await S.Promises.readdir(this.H(d),{withFileTypes:!0}),l=[];return await Promise.all(u.map(async h=>{try{let k;h.isSymbolicLink()?k=(await this.stat((0,g.$wg)(d,h.name))).type:k=this.M(h),l.push([h.name,k])}catch(k){this.a.trace(k)}})),l}catch(u){throw this.fb(u)}}M(d,u){let l;return u?.dangling?l=c.FileType.Unknown:d.isFile()?l=c.FileType.File:d.isDirectory()?l=c.FileType.Directory:l=c.FileType.Unknown,u&&(l|=c.FileType.SymbolicLink),l}async O(d){const u=this.H(d);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${u})`);let l;for(;l=this.N.get(d);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${u})`),await l.wait();const h=new f.$Tg;return this.N.set(d,h),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${u})`),(0,m.$Pc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${u})`),this.N.get(d)===h&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${u})`),this.N.delete(d)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${u})`),h.open()})}async readFile(d,u){let l;try{u?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(d)})`),l=await this.O(d));const h=this.H(d);return await S.Promises.readFile(h)}catch(h){throw this.fb(h)}finally{l?.dispose()}}P(d){t.I&&this.a.trace(d)}readFileStream(d,u,l){const h=(0,y.$3d)(k=>R.$ce.concat(k.map(D=>R.$ce.wrap(D))).buffer);return(0,s.$Qp)(this,d,h,k=>k.buffer,{...u,bufferSize:256*1024},l),h}async writeFile(d,u,l){return l?.atomic!==!1&&l?.atomic?.postfix&&await this.Q(d)?this.R(d,(0,g.$wg)((0,g.$vg)(d),`${(0,g.$tg)(d)}${l.atomic.postfix}`),u,l):this.S(d,u,l)}async Q(d){try{const u=this.H(d),{symbolicLink:l}=await S.SymlinkSupport.stat(u);if(l)return!1}catch{}return!0}async R(d,u,l,h){const k=new m.$Qc;try{k.add(await this.O(d)),k.add(await this.O(u)),await this.S(u,l,h,!0);try{await this.rename(u,d,{overwrite:!0})}catch(D){try{await this.delete(u,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw D}}finally{k.dispose()}}async S(d,u,l,h){let k;try{const D=this.H(d);if(!l.create||!l.overwrite){if(await S.Promises.exists(D)){if(!l.overwrite)throw(0,c.$pk)((0,w.localize)(0,null),c.FileSystemProviderErrorCode.FileExists)}else if(!l.create)throw(0,c.$pk)((0,w.localize)(1,null),c.FileSystemProviderErrorCode.FileNotFound)}k=await this.open(d,{create:!0,unlock:l.unlock},h),await this.write(k,0,u,0,u.byteLength)}catch(D){throw await this.gb(d,D)}finally{typeof k=="number"&&await this.close(k)}}static{this.Y=!0}static configureFlushOnWrite(d){t.Y=d}async open(d,u,l){const h=this.H(d);let k;(0,c.$dk)(u)&&!l&&(k=await this.O(d));let D;try{if((0,c.$dk)(u)&&u.unlock)try{const{stat:b}=await S.SymlinkSupport.stat(h);b.mode&128||await S.Promises.chmod(h,b.mode|128)}catch(b){b.code!=="ENOENT"&&this.a.trace(b)}let $;if((0,c.$dk)(u)){if(P.$j)try{await S.Promises.truncate(h,0),$="r+"}catch(b){b.code!=="ENOENT"&&this.a.trace(b)}$||($="w")}else $="r";D=await S.Promises.open(h,$)}catch($){throw k?.dispose(),(0,c.$dk)(u)?await this.gb(d,$):this.fb($)}if(this.U.set(D,0),(0,c.$dk)(u)&&this.X.set(D,d),k){const $=this.W.get(D);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${D} (${h})`),this.W.set(D,k),$&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${D} (${h})`),$.dispose())}return D}async close(d){const u=this.W.get(d);try{if(this.U.delete(d),this.X.delete(d)&&t.Y)try{await S.Promises.fdatasync(d)}catch(l){t.configureFlushOnWrite(!1),this.a.error(l)}return await S.Promises.close(d)}catch(l){throw this.fb(l)}finally{u&&(this.W.get(d)===u&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${d}`),this.W.delete(d)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${d}`),u.dispose())}}async read(d,u,l,h,k){const D=this.Z(d,u);let $=null;try{$=(await S.Promises.read(d,l,h,k,D)).bytesRead}catch(b){throw this.fb(b)}finally{this.$(d,D,$)}return $}Z(d,u){return u===this.U.get(d)?null:u}$(d,u,l){const h=this.U.get(d);typeof h=="number"&&(typeof u=="number"||(typeof l=="number"?this.U.set(d,h+l):this.U.delete(d)))}async write(d,u,l,h,k){return(0,f.$dh)(()=>this.ab(d,u,l,h,k),100,3)}async ab(d,u,l,h,k){const D=this.Z(d,u);let $=null;try{$=(await S.Promises.write(d,l,h,k,D)).bytesWritten}catch(b){throw await this.gb(this.X.get(d),b)}finally{this.$(d,D,$)}return $}async mkdir(d){try{await S.Promises.mkdir(this.H(d))}catch(u){throw this.fb(u)}}async delete(d,u){try{const l=this.H(d);if(u.recursive){let h;u?.atomic!==!1&&u.atomic.postfix&&(h=(0,A.$ic)((0,A.$lc)(l),`${(0,A.$mc)(l)}${u.atomic.postfix}`)),await S.Promises.rm(l,S.RimRafMode.MOVE,h)}else try{await S.Promises.unlink(l)}catch(h){if(h.code==="EPERM"||h.code==="EISDIR"){let k=!1;try{const{stat:D,symbolicLink:$}=await S.SymlinkSupport.stat(l);k=D.isDirectory()&&!$}catch{}if(k)await S.Promises.rmdir(l);else throw h}else throw h}}catch(l){throw this.fb(l)}}async rename(d,u,l){const h=this.H(d),k=this.H(u);if(h!==k)try{await this.bb(d,u,"move",l.overwrite),await S.Promises.rename(h,k)}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,w.localize)(2,null,(0,A.$mc)(h),(0,A.$mc)((0,A.$lc)(k)),D.toString()))),this.fb(D)}}async copy(d,u,l){const h=this.H(d),k=this.H(u);if(h!==k)try{await this.bb(d,u,"copy",l.overwrite),await S.Promises.copy(h,k,{preserveSymlinks:!0})}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,w.localize)(3,null,(0,A.$mc)(h),(0,A.$mc)((0,A.$lc)(k)),D.toString()))),this.fb(D)}}async bb(d,u,l,h){const k=this.H(d),D=this.H(u);let $=!1;if(!!(this.capabilities&1024)||($=(0,E.$Xf)(k,D,!0)),$){if(l==="copy")throw(0,c.$pk)((0,w.localize)(4,null),c.FileSystemProviderErrorCode.FileExists);if(l==="move")return}const v=await this.L(d);if(!v)throw(0,c.$pk)((0,w.localize)(5,null),c.FileSystemProviderErrorCode.FileNotFound);const C=await this.L(u);if(C){if(!h)throw(0,c.$pk)((0,w.localize)(6,null),c.FileSystemProviderErrorCode.FileExists);v.type&c.FileType.File&&C.type&c.FileType.File||await this.delete(u,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(d,u){return this.cb(d,u,!1)}async cb(d,u,l){const h=this.H(d),k=this.H(u),D=!!(this.capabilities&1024);if((0,E.$Xf)(h,k,!D))return;const $=new m.$Qc;try{$.add(await this.O(d)),$.add(await this.O(u)),l&&await S.Promises.mkdir((0,A.$lc)(k),{recursive:!0}),await S.Promises.copyFile(h,k)}catch(b){if(b.code==="ENOENT"&&!l)return this.cb(d,u,!0);throw this.fb(b)}finally{$.dispose()}}t(d,u,l){return new o.$8p(h=>d(h),h=>u(h),l)}F(d,u,l){return new a.$dq(h=>d(h),h=>u(h),l)}fb(d){if(d instanceof c.$ok)return d;let u=d,l;switch(d.code){case"ENOENT":l=c.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":l=c.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":l=c.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":l=c.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":l=c.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":u=`${d.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,l=c.FileSystemProviderErrorCode.Unknown;break;default:l=c.FileSystemProviderErrorCode.Unknown}return(0,c.$pk)(u,l)}async gb(d,u){let l=this.fb(u);if(d&&l.code===c.FileSystemProviderErrorCode.NoPermissions)try{const{stat:h}=await S.SymlinkSupport.stat(this.H(d));h.mode&128||(l=(0,c.$pk)(u,c.FileSystemProviderErrorCode.FileWriteLocked))}catch(h){this.a.trace(h)}return l}}e.$eq=t}),define(ke[252],Se([1,0,3,15]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UN=void 0;class f extends I.$Rc{constructor(R,p=[]){super(),this.a=new F.$lj([R,...p]),this.B(R.onDidChangeLogLevel(E=>this.setLevel(E)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...p){this.a.trace(R,...p)}debug(R,...p){this.a.debug(R,...p)}info(R,...p){this.a.info(R,...p)}warn(R,...p){this.a.warn(R,...p)}error(R,...p){this.a.error(R,...p)}flush(){this.a.flush()}}e.$UN=f}),define(ke[253],Se([1,0,31,15]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JN=void 0;var f;(function(m){m[m.Trace=0]="Trace",m[m.Debug=1]="Debug",m[m.Info=2]="Info",m[m.Warning=3]="Warning",m[m.Error=4]="Error",m[m.Critical=5]="Critical",m[m.Off=6]="Off"})(f||(f={}));async function L(m,A,P,g,y){try{const S=await new Promise((c,s)=>{$e(["@vscode/spdlog"],c,s)});S.setFlushOn(f.Trace);const w=await S.createAsyncRotatingLogger(m,A,P,g);return y?w.clearFormatters():w.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),w}catch(S){console.error(S)}return null}function R(m,A,P){switch(A){case F.LogLevel.Trace:m.trace(P);break;case F.LogLevel.Debug:m.debug(P);break;case F.LogLevel.Info:m.info(P);break;case F.LogLevel.Warning:m.warn(P);break;case F.LogLevel.Error:m.error(P);break;case F.LogLevel.Off:break;default:throw new Error(`Invalid log level ${A}`)}}function p(m,A){switch(A){case F.LogLevel.Trace:m.setLevel(f.Trace);break;case F.LogLevel.Debug:m.setLevel(f.Debug);break;case F.LogLevel.Info:m.setLevel(f.Info);break;case F.LogLevel.Warning:m.setLevel(f.Warning);break;case F.LogLevel.Error:m.setLevel(f.Error);break;case F.LogLevel.Off:m.setLevel(f.Off);break;default:throw new Error(`Invalid log level ${A}`)}}class E extends F.$hj{constructor(A,P,g,y,S){super(),this.m=[],this.setLevel(S),this.n=this.s(A,P,g,y),this.B(this.onDidChangeLogLevel(w=>{this.r&&p(this.r,w)}))}async s(A,P,g,y){const S=g?6:1,w=30/S*I.$Kk.MB,c=await L(A,P,w,S,y);if(c){this.r=c,p(this.r,this.getLevel());for(const{level:s,message:i}of this.m)R(this.r,s,i);this.m=[]}}g(A,P){this.r?R(this.r,A,P):this.getLevel()<=A&&this.m.push({level:A,message:P})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$JN=E}),define(ke[136],Se([1,0,39,206,5]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var L;(function(E){E[E.Unnecessary=1]="Unnecessary",E[E.Deprecated=2]="Deprecated"})(L||(e.MarkerTag=L={}));var R;(function(E){E[E.Hint=1]="Hint",E[E.Info=2]="Info",E[E.Warning=4]="Warning",E[E.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(E){function m(S,w){return w-S}E.compare=m;const A=Object.create(null);A[E.Error]=(0,F.localize)(0,null),A[E.Warning]=(0,F.localize)(1,null),A[E.Info]=(0,F.localize)(2,null);function P(S){return A[S]||""}E.toString=P;function g(S){switch(S){case I.default.Error:return E.Error;case I.default.Warning:return E.Warning;case I.default.Info:return E.Info;case I.default.Ignore:return E.Hint}}E.fromSeverity=g;function y(S){switch(S){case E.Error:return I.default.Error;case E.Warning:return I.default.Warning;case E.Info:return I.default.Info;case E.Hint:return I.default.Ignore}}E.toSeverity=y}(R||(e.MarkerSeverity=R={}));var p;(function(E){const m="";function A(g){return P(g,!0)}E.makeKey=A;function P(g,y){const S=[m];return g.source?S.push(g.source.replace("\xA6","\\\xA6")):S.push(m),g.code?typeof g.code=="string"?S.push(g.code.replace("\xA6","\\\xA6")):S.push(g.code.value.replace("\xA6","\\\xA6")):S.push(m),g.severity!==void 0&&g.severity!==null?S.push(R.toString(g.severity)):S.push(m),g.message&&y?S.push(g.message.replace("\xA6","\\\xA6")):S.push(m),g.startLineNumber!==void 0&&g.startLineNumber!==null?S.push(g.startLineNumber.toString()):S.push(m),g.startColumn!==void 0&&g.startColumn!==null?S.push(g.startColumn.toString()):S.push(m),g.endLineNumber!==void 0&&g.endLineNumber!==null?S.push(g.endLineNumber.toString()):S.push(m),g.endColumn!==void 0&&g.endColumn!==null?S.push(g.endColumn.toString()):S.push(m),S.push(m),S.join("\xA6")}E.makeKeyOptionalMessage=P})(p||(e.IMarkerData=p={})),e.$dt=(0,f.$Th)("markerService")}),define(ke[254],Se([1,0,4,39,5]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6u=e.$5u=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$4u=e.Severity=void 0,e.Severity=F.default,e.$4u=(0,f.$Th)("notificationService");var L;(function(A){A[A.DEFAULT=0]="DEFAULT",A[A.SILENT=1]="SILENT",A[A.URGENT=2]="URGENT"})(L||(e.NotificationPriority=L={}));var R;(function(A){A[A.WORKSPACE=0]="WORKSPACE",A[A.PROFILE=1]="PROFILE",A[A.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));var p;(function(A){A[A.OFF=0]="OFF",A[A.SILENT=1]="SILENT",A[A.ERROR=2]="ERROR"})(p||(e.NotificationsFilter=p={}));class E{constructor(){this.progress=new m,this.onDidClose=I.Event.None,this.onDidChangeVisibility=I.Event.None}updateSeverity(P){}updateMessage(P){}updateActions(P){}close(){}}e.$5u=E;class m{infinite(){}done(){}total(P){}worked(P){}}e.$6u=m}),define(ke[137],Se([1,0,13,2,5]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JU=e.$IU=e.$HU=e.$GU=e.$FU=void 0,e.$FU=(0,f.$Th)("openerService");function L(m,A){return F.URI.isUri(m)?(0,I.$3e)(m.scheme,A):(0,I.$4e)(m,A+":")}e.$GU=L;function R(m,...A){return A.some(P=>L(m,P))}e.$HU=R;function p(m,A){return m.with({fragment:`${A.startLineNumber},${A.startColumn}${A.endLineNumber?`-${A.endLineNumber}${A.endColumn?`,${A.endColumn}`:""}`:""}`})}e.$IU=p;function E(m){let A;const P=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(m.fragment);return P&&(A={startLineNumber:parseInt(P[1]),startColumn:P[2]?parseInt(P[2]):1,endLineNumber:P[4]?parseInt(P[4]):void 0,endColumn:P[4]?P[5]?parseInt(P[5]):1:void 0},m=m.with({fragment:""})),{selection:A,uri:m}}e.$JU=E}),define(ke[255],Se([1,0,12,49]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let f;if(typeof I.$h.vscode<"u"&&typeof I.$h.vscode.context<"u"){const L=I.$h.vscode.context.configuration();if(L)f=L.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(f=globalThis._VSCODE_PRODUCT_JSON,F.env.VSCODE_DEV&&Object.assign(f,{nameShort:`${f.nameShort} Dev`,nameLong:`${f.nameLong} Dev`,dataFolderName:`${f.dataFolderName}-dev`,serverDataFolderName:f.serverDataFolderName?`${f.serverDataFolderName}-dev`:void 0}),!f.version){const L=globalThis._VSCODE_PACKAGE_JSON;Object.assign(f,{version:L.version})}}else f={},Object.keys(f).length===0&&Object.assign(f,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=f}),define(ke[138],Se([1,0,5]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uj=e.$tj=void 0,e.$tj=(0,I.$Th)("productService"),e.$uj="vscode://schemas/vscode-product"});var Be=this&&this.__param||function($e,e){return function(I,F){e(I,F,$e)}};define(ke[64],Se([1,0,10,21,3,5]),function($e,e,I,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$av=e.$_u=e.$$u=e.$0u=e.$9u=e.$8u=e.ProgressLocation=e.$7u=void 0,e.$7u=(0,L.$Th)("progressService");var R;(function(P){P[P.Explorer=1]="Explorer",P[P.Scm=3]="Scm",P[P.Extensions=5]="Extensions",P[P.Window=10]="Window",P[P.Notification=15]="Notification",P[P.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$8u=Object.freeze({total(){},worked(){},done(){}});class p{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(g){this.b=g}report(g){this.a=g,this.b(this.a)}}e.$9u=p;class E{get value(){return this.a}constructor(g){this.e=g}report(g){this.b?this.b.push(g):this.b=[g],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const g=this.b.shift();this.a=g,await this.e(this.a)}}finally{this.c=!1;const g=this.d;this.d=void 0,g?.()}}drain(){return this.c?new Promise(g=>{const y=this.d;this.d=()=>{y?.(),g()}}):Promise.resolve()}}e.$0u=E;let m=class extends f.$Rc{constructor(g,y){super(),this.a=new I.$gh,y.withProgress(g,S=>(this.b=S,this.c&&S.report(this.c),this.a.p)),this.B((0,f.$Pc)(()=>this.a.complete()))}report(g){this.b?this.b.report(g):this.c=g}};e.$$u=m,e.$$u=m=He([Be(1,e.$7u)],m);class A extends f.$Rc{constructor(g){super(),this.g=g,this.a=0,this.b=this.B(new f.$Qc)}start(g){this.stop();const y=++this.a,S=new F.$Yd;return this.f=setTimeout(()=>{y===this.a&&(this.c=this.g.show(!0))},g),this.b.add((0,f.$Pc)(()=>clearTimeout(this.f))),this.b.add((0,f.$Pc)(()=>S.cancel())),this.b.add((0,f.$Pc)(()=>this.c?this.c.done():void 0)),{id:y,token:S.token,stop:()=>this.h(y),isCurrent:()=>this.a===y}}stop(){this.h(this.a)}h(g){this.a===g&&this.b.clear()}}e.$_u=A,e.$av=(0,L.$Th)("editorProgressService")}),define(ke[38],Se([1,0,60,18]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kn=void 0;class f{constructor(){this.a=new Map}add(R,p){I.ok(F.$zf(R)),I.ok(F.$Bf(p)),I.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,p)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$kn=new f}),define(ke[108],Se([1,0,4,38]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=void 0,e.$ln={JSONContribution:"base.contributions.json"};function f(p){return p.length>0&&p.charAt(p.length-1)==="#"?p.substring(0,p.length-1):p}class L{constructor(){this.b=new I.$Od,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(E,m){this.a[f(E)]=m,this.b.fire(E)}notifySchemaChanged(E){this.b.fire(E)}getSchemaContributions(){return{schemas:this.a}}}const R=new L;F.$kn.add(e.$ln.JSONContribution,R)}),define(ke[86],Se([1,0,19,4,18,196,44,108,38]),function($e,e,I,F,f,L,R,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.ConfigurationScope=e.$pn=e.EditPresentationTypes=void 0;var m;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(m||(e.EditPresentationTypes=m={})),e.$pn={Configuration:"base.contributions.configuration"};var A;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.$qn={properties:{},patternProperties:{}},e.$rn={properties:{},patternProperties:{}},e.$sn={properties:{},patternProperties:{}},e.$tn={properties:{},patternProperties:{}},e.$un={properties:{},patternProperties:{}},e.$vn={properties:{},patternProperties:{}},e.$wn="vscode://schemas/settings/resourceLanguage",e.$xn="vscode://schemas/settings/configurationDefaults";const P=E.$kn.as(p.$ln.JSONContribution);class g{constructor(){this.h=new Set,this.i=new F.$Od,this.onDidSchemaChange=this.i.event,this.j=new F.$Od,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},P.registerSchema(e.$wn,this.g),this.v()}registerConfiguration(t,r=!0){this.registerConfigurations([t],r)}registerConfigurations(t,r=!0){const d=new Set;this.n(t,r,d),P.registerSchema(e.$wn,this.g),this.i.fire(),this.j.fire({properties:d})}deregisterConfigurations(t){const r=new Set;this.o(t,r),P.registerSchema(e.$wn,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:t,remove:r}){const d=new Set;this.o(r,d),this.n(t,!1,d),P.registerSchema(e.$wn,this.g),this.i.fire(),this.j.fire({properties:d})}registerDefaultConfigurations(t){const r=new Set;this.k(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(t,r){const d=[];for(const{overrides:u,source:l}of t)for(const h in u)if(r.add(h),e.$zn.test(h)){const k=this.a.get(h),D=k?.valuesSources??new Map;if(l)for(const C of Object.keys(u[h]))D.set(C,l);const $={...k?.value||{},...u[h]};this.a.set(h,{source:l,value:$,valuesSources:D});const b=(0,R.$xi)(h),v={type:"object",default:$,description:L.localize(1,null,b),$ref:e.$wn,defaultDefaultValue:$,source:f.$zf(l)?void 0:l,defaultValueSource:l};d.push(...w(h)),this.d[h]=v,this.b.properties[h]=v}else{this.a.set(h,{value:u[h],source:l});const k=this.d[h];k&&(this.w(h,k),this.r(h,k))}this.m(d)}deregisterDefaultConfigurations(t){const r=new Set;this.l(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(t,r){for(const{overrides:d,source:u}of t)for(const l in d){const h=this.a.get(l),k=f.$zf(u)?u:u?.id,D=f.$zf(h?.source)?h?.source:h?.source?.id;if(k===D)if(r.add(l),this.a.delete(l),e.$zn.test(l))delete this.d[l],delete this.b.properties[l];else{const $=this.d[l];$&&(this.w(l,$),this.r(l,$))}}this.u()}deltaConfiguration(t){let r=!1;const d=new Set;t.removedDefaults&&(this.l(t.removedDefaults,d),r=!0),t.addedDefaults&&(this.k(t.addedDefaults,d),r=!0),t.removedConfigurations&&this.o(t.removedConfigurations,d),t.addedConfigurations&&this.n(t.addedConfigurations,!1,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const r of t)this.h.add(r);this.u()}n(t,r,d){t.forEach(u=>{this.p(u,r,u.extensionInfo,u.restrictedProperties,void 0,d),this.c.push(u),this.q(u)})}o(t,r){const d=u=>{if(u.properties)for(const l in u.properties){r.add(l);const h=this.d[l];h?.policy?.name&&this.e.delete(h.policy.name),delete this.d[l],this.s(l,u.properties[l])}u.allOf?.forEach(l=>d(l))};for(const u of t){d(u);const l=this.c.indexOf(u);l!==-1&&this.c.splice(l,1)}}p(t,r=!0,d,u,l=3,h){l=f.$If(t.scope)?l:t.scope;const k=t.properties;if(k)for(const $ in k){const b=k[$];if(r&&n($,b)){delete k[$];continue}if(b.source=d,b.defaultDefaultValue=k[$].default,this.w($,b),e.$zn.test($)?b.scope=void 0:(b.scope=f.$If(b.scope)?l:b.scope,b.restricted=f.$If(b.restricted)?!!u?.includes($):b.restricted),k[$].hasOwnProperty("included")&&!k[$].included){this.f[$]=k[$],delete k[$];continue}else this.d[$]=k[$],k[$].policy?.name&&this.e.set(k[$].policy.name,$);!k[$].deprecationMessage&&k[$].markdownDeprecationMessage&&(k[$].deprecationMessage=k[$].markdownDeprecationMessage),h.add($)}const D=t.allOf;if(D)for(const $ of D)this.p($,r,d,u,l,h)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const r=d=>{const u=d.properties;if(u)for(const h in u)this.r(h,u[h]);d.allOf?.forEach(r)};r(t)}r(t,r){switch(e.$qn.properties[t]=r,r.scope){case 1:e.$rn.properties[t]=r;break;case 2:e.$sn.properties[t]=r;break;case 6:e.$tn.properties[t]=r;break;case 3:e.$un.properties[t]=r;break;case 4:e.$vn.properties[t]=r;break;case 5:e.$vn.properties[t]=r,this.g.properties[t]=r;break}}s(t,r){switch(delete e.$qn.properties[t],r.scope){case 1:delete e.$rn.properties[t];break;case 2:delete e.$sn.properties[t];break;case 6:delete e.$tn.properties[t];break;case 3:delete e.$un.properties[t];break;case 4:case 5:delete e.$vn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const r=`[${t}]`,d={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.$wn};this.w(r,d),e.$qn.properties[r]=d,e.$rn.properties[r]=d,e.$sn.properties[r]=d,e.$tn.properties[r]=d,e.$un.properties[r]=d,e.$vn.properties[r]=d}}v(){const t={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.$wn};e.$qn.patternProperties[e.$yn]=t,e.$rn.patternProperties[e.$yn]=t,e.$sn.patternProperties[e.$yn]=t,e.$tn.patternProperties[e.$yn]=t,e.$un.patternProperties[e.$yn]=t,e.$vn.patternProperties[e.$yn]=t,this.i.fire()}w(t,r){const d=this.a.get(t);let u=d?.value,l=d?.source;f.$Gf(u)&&(u=r.defaultDefaultValue,l=void 0),f.$Gf(u)&&(u=s(r.type)),r.default=u,r.defaultValueSource=l}}const y="\\[([^\\]]+)\\]",S=new RegExp(y,"g");e.$yn=`^(${y})+$`,e.$zn=new RegExp(e.$yn);function w(a){const t=[];if(e.$zn.test(a)){let r=S.exec(a);for(;r?.length;){const d=r[1].trim();d&&t.push(d),r=S.exec(a)}}return(0,I.$Lb)(t)}e.$An=w;function c(a){return a.reduce((t,r)=>`${t}[${r}]`,"")}e.$Bn=c;function s(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Cn=s;const i=new g;E.$kn.add(e.$pn.Configuration,i);function n(a,t){return a.trim()?e.$zn.test(a)?L.localize(7,null,a):i.getConfigurationProperties()[a]!==void 0?L.localize(8,null,a):t.policy?.name&&i.getPolicyConfigurations().get(t.policy?.name)!==void 0?L.localize(9,null,a,t.policy?.name,i.getPolicyConfigurations().get(t.policy?.name)):null:L.localize(6,null)}e.$Dn=n;function o(){const a=[],t=i.getConfigurationProperties();for(const r of Object.keys(t))a.push([r,t[r].scope]);return a.push(["launch",4]),a.push(["task",4]),a}e.$En=o}),define(ke[256],Se([1,0,19,4,160,3,28,24,18,2,44,86,38]),function($e,e,I,F,f,L,R,p,E,m,A,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=void 0;function y(r){return Object.isFrozen(r)?r:p.$_m(r)}class S{constructor(d={},u=[],l=[],h){this.b=d,this.c=u,this.d=l,this.raw=h,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const d=this.raw.map(u=>{if(u instanceof S)return u;const l=new w("");return l.parseRaw(u),l.configurationModel});this.f=d.reduce((u,l)=>l===u?l:u.merge(l),d[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(d){return d?(0,A.$vi)(this.contents,d):this.contents}inspect(d,u){const l=this.rawConfiguration.getValue(d),h=u?this.rawConfiguration.getOverrideValue(d,u):void 0,k=u?this.rawConfiguration.override(u).getValue(d):l;return{value:l,override:h,merged:k}}getOverrideValue(d,u){const l=this.i(u);return l?d?(0,A.$vi)(l,d):l:void 0}getKeysForOverrideIdentifier(d){const u=[];for(const l of this.overrides)l.identifiers.includes(d)&&u.push(...l.keys);return I.$Lb(u)}getAllOverrideIdentifiers(){const d=[];for(const u of this.overrides)d.push(...u.identifiers);return I.$Lb(d)}override(d){let u=this.a.get(d);return u||(u=this.g(d),this.a.set(d,u)),u}merge(...d){const u=p.$$m(this.contents),l=p.$$m(this.overrides),h=[...this.keys],k=this.raw?.length?[...this.raw]:[this];for(const D of d)if(k.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.h(u,D.contents);for(const $ of D.overrides){const[b]=l.filter(v=>I.$tb(v.identifiers,$.identifiers));b?(this.h(b.contents,$.contents),b.keys.push(...$.keys),b.keys=I.$Lb(b.keys)):l.push(p.$$m($))}for(const $ of D.keys)h.indexOf($)===-1&&h.push($)}return new S(u,h,l,k.every(D=>D instanceof S)?void 0:k)}g(d){const u=this.i(d);if(!u||typeof u!="object"||!Object.keys(u).length)return this;const l={};for(const h of I.$Lb([...Object.keys(this.contents),...Object.keys(u)])){let k=this.contents[h];const D=u[h];D&&(typeof k=="object"&&typeof D=="object"?(k=p.$$m(k),this.h(k,D)):k=D),l[h]=k}return new S(l,this.keys,this.overrides)}h(d,u){for(const l of Object.keys(u)){if(l in d&&E.$Bf(d[l])&&E.$Bf(u[l])){this.h(d[l],u[l]);continue}d[l]=p.$$m(u[l])}}i(d){let u=null,l=null;const h=k=>{k&&(l?this.h(l,k):l=p.$$m(k))};for(const k of this.overrides)k.identifiers.length===1&&k.identifiers[0]===d?u=k.contents:k.identifiers.includes(d)&&h(k.contents);return h(u),l}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(d,u){this.j(d,u,!0)}setValue(d,u){this.j(d,u,!1)}removeValue(d){const u=this.keys.indexOf(d);u!==-1&&(this.keys.splice(u,1),(0,A.$ui)(this.contents,d),P.$zn.test(d)&&this.overrides.splice(this.overrides.findIndex(l=>I.$tb(l.identifiers,(0,P.$An)(d))),1))}j(d,u,l){(0,A.$ti)(this.contents,d,u,h=>console.error(h)),l=l||this.keys.indexOf(d)===-1,l&&this.keys.push(d),P.$zn.test(d)&&this.overrides.push({identifiers:(0,P.$An)(d),keys:Object.keys(this.contents[d]),contents:(0,A.$si)(this.contents[d],h=>console.error(h))})}}e.$Fn=S;class w{constructor(d){this.f=d,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new S}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(d,u){if(!E.$If(d)){const l=this.g(d);this.parseRaw(l,u)}}reparse(d){this.a&&this.parseRaw(this.a,d)}parseRaw(d,u){this.a=d;const{contents:l,keys:h,overrides:k,restricted:D,hasExcludedProperties:$}=this.h(d,u);this.b=new S(l,h,k,$?[d]:void 0),this.c=D||[]}g(d){let u={},l=null,h=[];const k=[],D=[];function $(v){Array.isArray(h)?h.push(v):l!==null&&(h[l]=v)}const b={onObjectBegin:()=>{const v={};$(v),k.push(h),h=v,l=null},onObjectProperty:v=>{l=v},onObjectEnd:()=>{h=k.pop()},onArrayBegin:()=>{const v=[];$(v),k.push(h),h=v,l=null},onArrayEnd:()=>{h=k.pop()},onLiteralValue:$,onError:(v,C,N)=>{D.push({error:v,offset:C,length:N})}};if(d)try{f.$8m(d,b),u=h[0]||{}}catch(v){console.error(`Error while parsing settings file ${this.f}: ${v}`),this.d=[v]}return u}h(d,u){const l=g.$kn.as(P.$pn.Configuration).getConfigurationProperties(),h=this.i(d,l,!0,u);d=h.raw;const k=(0,A.$si)(d,b=>console.error(`Conflict in settings file ${this.f}: ${b}`)),D=Object.keys(d),$=this.j(d,b=>console.error(`Conflict in settings file ${this.f}: ${b}`));return{contents:k,keys:D,overrides:$,restricted:h.restricted,hasExcludedProperties:h.hasExcludedProperties}}i(d,u,l,h){let k=!1;if(!h?.scopes&&!h?.skipRestricted&&!h?.exclude?.length)return{raw:d,restricted:[],hasExcludedProperties:k};const D={},$=[];for(const b in d)if(P.$zn.test(b)&&l){const v=this.i(d[b],u,!1,h);D[b]=v.raw,k=k||v.hasExcludedProperties,$.push(...v.restricted)}else{const v=u[b],C=v?typeof v.scope<"u"?v.scope:3:void 0;v?.restricted&&$.push(b),!h.exclude?.includes(b)&&(h.include?.includes(b)||(C===void 0||h.scopes===void 0||h.scopes.includes(C))&&!(h.skipRestricted&&v?.restricted))?D[b]=d[b]:k=!0}return{raw:D,restricted:$,hasExcludedProperties:k}}j(d,u){const l=[];for(const h of Object.keys(d))if(P.$zn.test(h)){const k={};for(const D in d[h])k[D]=d[h][D];l.push({identifiers:(0,P.$An)(h),keys:Object.keys(k),contents:(0,A.$si)(k,u)})}return l}}e.$Gn=w;class c extends L.$Rc{constructor(d,u,l,h){super(),this.c=d,this.f=u,this.g=h,this.b=this.B(new F.$Od),this.onDidChange=this.b.event,this.a=new w(this.c.toString()),this.B(this.g.watch(l.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(F.Event.any(F.Event.filter(this.g.onDidFilesChange,k=>k.contains(this.c)),F.Event.filter(this.g.onDidRunOperation,k=>(k.isOperation(0)||k.isOperation(3)||k.isOperation(1)||k.isOperation(4))&&l.isEqual(k.resource,d)))(()=>this.b.fire()))}async loadConfiguration(){try{const d=await this.g.readFile(this.c);return this.a.parse(d.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new S}}reparse(d){return d&&(this.f=d),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Hn=c;class s{constructor(d,u,l,h,k,D,$,b,v,C,N,z,M){this.a=d,this.b=u,this.c=l,this.overrideIdentifiers=h,this.d=k,this.f=D,this.g=$,this.h=b,this.i=v,this.j=C,this.k=N,this.l=z,this.m=M}get value(){return y(this.c)}n(d,u,l){const h=d.inspect(u,l);return{get value(){return y(h.value)},get override(){return y(h.override)},get merged(){return y(h.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class i{constructor(d,u,l,h,k=new S,D=new S,$=new R.$zc,b=new S,v=new R.$zc){this.c=d,this.d=u,this.f=l,this.g=h,this.h=k,this.i=D,this.j=$,this.l=b,this.m=v,this.a=null,this.b=new R.$zc,this.n=null}getValue(d,u,l){return this.q(d,u,l).getValue(d)}updateValue(d,u,l={}){let h;l.resource?(h=this.m.get(l.resource),h||(h=new S,this.m.set(l.resource,h))):h=this.l,u===void 0?h.removeValue(d):h.setValue(d,u),l.resource||(this.a=null)}inspect(d,u,l){const h=this.q(d,u,l),k=this.u(u.resource,l),D=u.resource?this.m.get(u.resource)||this.l:this.l,$=new Set;for(const b of h.overrides)for(const v of b.identifiers)h.getOverrideValue(d,v)!==void 0&&$.add(v);return new s(d,u,h.getValue(d),$.size?[...$]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,l?this.i:void 0,k||void 0,D)}keys(d){const u=this.u(void 0,d);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:u?u.keys.slice(0):[]}}updateDefaultConfiguration(d){this.c=d,this.a=null,this.b.clear()}updatePolicyConfiguration(d){this.d=d}updateApplicationConfiguration(d){this.f=d,this.a=null,this.b.clear()}updateLocalUserConfiguration(d){this.g=d,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(d){this.h=d,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(d){this.i=d,this.a=null,this.b.clear()}updateFolderConfiguration(d,u){this.j.set(d,u),this.b.delete(d)}deleteFolderConfiguration(d){this.p.delete(d),this.b.delete(d)}compareAndUpdateDefaultConfiguration(d,u){const l=[];if(!u){const{added:h,updated:k,removed:D}=a(this.c,d);u=[...h,...k,...D]}for(const h of u)for(const k of(0,P.$An)(h)){const D=this.c.getKeysForOverrideIdentifier(k),$=d.getKeysForOverrideIdentifier(k),b=[...$.filter(v=>D.indexOf(v)===-1),...D.filter(v=>$.indexOf(v)===-1),...D.filter(v=>!p.$cn(this.c.override(k).getValue(v),d.override(k).getValue(v)))];l.push([k,b])}return this.updateDefaultConfiguration(d),{keys:u,overrides:l}}compareAndUpdatePolicyConfiguration(d){const{added:u,updated:l,removed:h}=a(this.d,d),k=[...u,...l,...h];return k.length&&this.updatePolicyConfiguration(d),{keys:k,overrides:[]}}compareAndUpdateApplicationConfiguration(d){const{added:u,updated:l,removed:h,overrides:k}=a(this.applicationConfiguration,d),D=[...u,...l,...h];return D.length&&this.updateApplicationConfiguration(d),{keys:D,overrides:k}}compareAndUpdateLocalUserConfiguration(d){const{added:u,updated:l,removed:h,overrides:k}=a(this.localUserConfiguration,d),D=[...u,...l,...h];return D.length&&this.updateLocalUserConfiguration(d),{keys:D,overrides:k}}compareAndUpdateRemoteUserConfiguration(d){const{added:u,updated:l,removed:h,overrides:k}=a(this.remoteUserConfiguration,d),D=[...u,...l,...h];return D.length&&this.updateRemoteUserConfiguration(d),{keys:D,overrides:k}}compareAndUpdateWorkspaceConfiguration(d){const{added:u,updated:l,removed:h,overrides:k}=a(this.workspaceConfiguration,d),D=[...u,...l,...h];return D.length&&this.updateWorkspaceConfiguration(d),{keys:D,overrides:k}}compareAndUpdateFolderConfiguration(d,u){const l=this.p.get(d),{added:h,updated:k,removed:D,overrides:$}=a(l,u),b=[...h,...k,...D];return(b.length||!l)&&this.updateFolderConfiguration(d,u),{keys:b,overrides:$}}compareAndDeleteFolderConfiguration(d){const u=this.p.get(d);if(!u)throw new Error("Unknown folder");this.deleteFolderConfiguration(d);const{added:l,updated:h,removed:k,overrides:D}=a(u,void 0);return{keys:[...l,...h,...k],overrides:D}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(d,u,l){let h=this.r(u,l);return u.overrideIdentifier&&(h=h.override(u.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(d)!==void 0&&(h=h.merge(this.d)),h}r({resource:d},u){let l=this.s();if(u&&d){const h=u.getFolder(d);h&&(l=this.t(h.uri)||l);const k=this.m.get(d);k&&(l=l.merge(k))}return l}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(d){let u=this.b.get(d);if(!u){const l=this.s(),h=this.j.get(d);h?(u=l.merge(h),this.b.set(d,u)):u=l}return u}u(d,u){if(u&&d){const l=u.getFolder(d);if(l)return this.j.get(l.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((d,u)=>{const{contents:l,overrides:h,keys:k}=this.j.get(u);return d.push([u,{contents:l,overrides:h,keys:k}]),d},[])}}allKeys(){const d=new Set;return this.c.keys.forEach(u=>d.add(u)),this.userConfiguration.keys.forEach(u=>d.add(u)),this.i.keys.forEach(u=>d.add(u)),this.j.forEach(u=>u.keys.forEach(l=>d.add(l))),[...d.values()]}v(){const d=new Set;return this.c.getAllOverrideIdentifiers().forEach(u=>d.add(u)),this.userConfiguration.getAllOverrideIdentifiers().forEach(u=>d.add(u)),this.i.getAllOverrideIdentifiers().forEach(u=>d.add(u)),this.j.forEach(u=>u.getAllOverrideIdentifiers().forEach(l=>d.add(l))),[...d.values()]}w(d){const u=new Set;return this.c.getKeysForOverrideIdentifier(d).forEach(l=>u.add(l)),this.userConfiguration.getKeysForOverrideIdentifier(d).forEach(l=>u.add(l)),this.i.getKeysForOverrideIdentifier(d).forEach(l=>u.add(l)),this.j.forEach(l=>l.getKeysForOverrideIdentifier(d).forEach(h=>u.add(h))),[...u.values()]}static parse(d){const u=this.x(d.defaults),l=this.x(d.policy),h=this.x(d.application),k=this.x(d.user),D=this.x(d.workspace),$=d.folders.reduce((b,v)=>(b.set(m.URI.revive(v[0]),this.x(v[1])),b),new R.$zc);return new i(u,l,h,k,new S,D,$,new S,new R.$zc)}static x(d){return new S(d.contents,d.keys,d.overrides)}}e.$In=i;function n(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const d=new Set,u=new Map;for(const h of r)h.keys.forEach(k=>d.add(k)),h.overrides.forEach(([k,D])=>{const $=(0,R.$wc)(u,k,new Set);D.forEach(b=>$.add(b))});const l=[];return u.forEach((h,k)=>l.push([k,[...h.values()]])),{keys:[...d.values()],overrides:l}}e.$Jn=n;class o{constructor(d,u,l,h){this.change=d,this.f=u,this.g=l,this.h=h,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const k of d.keys)this.affectedKeys.add(k);for(const[,k]of d.overrides)for(const D of k)this.affectedKeys.add(D);this.d=this.a;for(const k of this.affectedKeys)this.d+=k+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=i.parse(this.f.data)),this.i}affectsConfiguration(d,u){const l=this.a+d,h=this.d.indexOf(l);if(h<0)return!1;const k=h+l.length;if(k>=this.d.length)return!1;const D=this.d.charCodeAt(k);if(D!==this.b&&D!==this.c)return!1;if(u){const $=this.previousConfiguration?this.previousConfiguration.getValue(d,u,this.f?.workspace):void 0,b=this.g.getValue(d,u,this.h);return!p.$cn($,b)}return!0}}e.$Kn=o;function a(r,d){const{added:u,removed:l,updated:h}=t(d?.rawConfiguration,r?.rawConfiguration),k=[],D=r?.getAllOverrideIdentifiers()||[],$=d?.getAllOverrideIdentifiers()||[];if(d){const b=$.filter(v=>!D.includes(v));for(const v of b)k.push([v,d.getKeysForOverrideIdentifier(v)])}if(r){const b=D.filter(v=>!$.includes(v));for(const v of b)k.push([v,r.getKeysForOverrideIdentifier(v)])}if(d&&r){for(const b of D)if($.includes(b)){const v=t({contents:r.getOverrideValue(void 0,b)||{},keys:r.getKeysForOverrideIdentifier(b)},{contents:d.getOverrideValue(void 0,b)||{},keys:d.getKeysForOverrideIdentifier(b)});k.push([b,[...v.added,...v.removed,...v.updated]])}}return{added:u,removed:l,updated:h,overrides:k}}function t(r,d){const u=r?d?r.keys.filter(k=>d.keys.indexOf(k)===-1):[...r.keys]:[],l=d?r?d.keys.filter(k=>r.keys.indexOf(k)===-1):[...d.keys]:[],h=[];if(r&&d){for(const k of d.keys)if(r.keys.indexOf(k)!==-1){const D=(0,A.$vi)(d.contents,k),$=(0,A.$vi)(r.contents,k);p.$cn(D,$)||h.push(k)}}return{added:u,removed:l,updated:h}}}),define(ke[257],Se([1,0,22,4,3,83]),function($e,e,I,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zpb=e.$Ypb=e.$Xpb=e.$Wpb=void 0;const R=(m,A,P)=>{const g=new Uint8Array(16);for(let w=0;w<16;w++)g[w]=Math.round(Math.random()*256);const y=(0,I.$we)(I.$ce.wrap(g));return[`GET ws://localhost${m}?${A}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${y}`].join(`\r
`)+`\r
\r
`};e.$Wpb=R,e.$Xpb=I.$ce.fromString(`\r
\r
`);async function p(m,A,P,g,y){m.write(I.$ce.fromString((0,e.$Wpb)(A,P,g)));const S=new f.$Qc;try{return await new Promise((w,c)=>{let s;S.add(m.onData(i=>{s?s=I.$ce.concat([s,i],s.byteLength+i.byteLength):s=i;const n=s.indexOf(e.$Xpb);if(n===-1)return;w(m),m.pauseData();const o=s.slice(n+e.$Xpb.byteLength);o.byteLength&&y.onData.fire(o)})),S.add(m.onClose(i=>c(i??new Error("socket closed")))),S.add(m.onEnd(()=>c(new Error("socket ended"))))})}catch(w){throw m.dispose(),w}finally{S.dispose()}}e.$Ypb=p;class E extends f.$Rc{constructor(A,P){super(),this.g=A,this.a=this.B(new F.$Rd),this.onData=(...g)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...g)),this.b=this.B(new F.$Od),this.onDidDispose=this.b.event,this.f=!1,this.B(P.onData),this.B(P.onData.event(g=>this.a.fire(g))),this.onClose=this.B(P.onClose).event,this.onEnd=this.B(P.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(A,P){L.SocketDiagnostics.traceSocketEvent(this,this.g,A,P)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$Zpb=E}),define(ke[65],Se([1,0,11,5]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xk=e.$Wk=e.RemoteAuthorityResolverErrorCode=e.$Vk=e.$Uk=e.RemoteConnectionType=e.$Tk=void 0,e.$Tk=(0,F.$Th)("remoteAuthorityResolverService");var f;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(f||(e.RemoteConnectionType=f={}));class L{constructor(P){this.id=P,this.type=1}toString(){return`Managed(${this.id})`}}e.$Uk=L;class R{constructor(P,g){this.host=P,this.port=g,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Vk=R;var p;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})(p||(e.RemoteAuthorityResolverErrorCode=p={}));class E extends I.$ab{static isNotAvailable(P){return P instanceof E&&P._code===p.NotAvailable}static isTemporarilyNotAvailable(P){return P instanceof E&&P._code===p.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof E&&P._code===p.NoResolverFound}static isInvalidAuthority(P){return P instanceof E&&P._code===p.InvalidAuthority}static isHandled(P){return P instanceof E&&P.isHandled}constructor(P,g=p.Unknown,y){super(P),this._message=P,this._code=g,this._detail=y,this.isHandled=g===p.NotAvailable&&y===!0,Object.setPrototypeOf(this,E.prototype)}}e.$Wk=E;function m(A){const P=A.indexOf("+");return P===-1?A:A.substring(0,P)}e.$Xk=m}),define(ke[66],Se([1,0,17]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3k=e.$2k=e.$1k=e.$Zk=e.$Yk=void 0;function F(m){return m.scheme===I.Schemas.vscodeRemote?m.authority:void 0}e.$Yk=F;function f(m){if(!m)return;const A=m.indexOf("+");return A<0?m:m.substr(0,A)}e.$Zk=f;function L(m){return`/${m.quality??"oss"}-${m.commit??"dev"}`}e.$1k=L;function R(m){const{host:A,port:P}=E(m);if(typeof P>"u")throw new Error("Remote authority doesn't contain a port!");return{host:A,port:P}}e.$2k=R;function p(m,A){let{host:P,port:g}=E(m);return typeof g>"u"&&(g=A),{host:P,port:g}}e.$3k=p;function E(m){const A=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(A)return{host:A[1],port:parseInt(A[2],10)};const P=m.match(/^(\[[0-9a-z:]+\])$/);if(P)return{host:P[1],port:void 0};const g=m.match(/(.*):(\d+)$/);return g?{host:g[1],port:parseInt(g[2],10)}:{host:m,port:void 0}}}),define(ke[26],Se([1,0,13,5,66]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.TargetPlatform=e.ExtensionType=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=void 0,e.$4l="extensions.user.cache",e.$5l="extensions.builtin.cache",e.$6l="undefined_publisher",e.$7l=["ui","workspace","web"];function L(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.$8l=L,e.$9l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(R||(e.ExtensionType=R={}));var p;(function(w){w.WIN32_X64="win32-x64",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(p||(e.TargetPlatform=p={}));class E{constructor(c){this.value=c,this._lower=c.toLowerCase()}static equals(c,s){if(typeof c>"u"||c===null)return typeof s>"u"||s===null;if(typeof s>"u"||s===null)return!1;if(typeof c=="string"||typeof s=="string"){const i=typeof c=="string"?c:c.value,n=typeof s=="string"?s:s.value;return I.$3e(i,n)}return c._lower===s._lower}static toKey(c){return typeof c=="string"?c.toLowerCase():c._lower}}e.$0l=E;class m{get size(){return this.c.size}constructor(c){if(this.c=new Set,c)for(const s of c)this.add(s)}add(c){this.c.add(E.toKey(c))}delete(c){return this.c.delete(E.toKey(c))}has(c){return this.c.has(E.toKey(c))}}e.$$l=m;class A{constructor(){this.c=new Map}clear(){this.c.clear()}delete(c){this.c.delete(E.toKey(c))}get(c){return this.c.get(E.toKey(c))}has(c){return this.c.has(E.toKey(c))}set(c,s){this.c.set(E.toKey(c),s)}values(){return this.c.values()}forEach(c){this.c.forEach(c)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$_l=A;function P(w){return g(w)}e.$am=P;function g(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}e.$bm=g;function y(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}e.$cm=y;function S(w,c){if(c){const s=`onResolveRemoteAuthority:${(0,f.$Zk)(c)}`;return!!w.activationEvents?.includes(s)}return!1}e.$dm=S,e.$em=(0,F.$Th)("IBuiltinExtensionsScannerService")}),define(ke[139],Se([1,0,11,26]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aF=e.$_E=void 0;class f{constructor(){this.a=new Map,this.b=new WeakMap}register(R,p){this.a.set(R,p)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const p=Object.create(null);for(const E of R){const m=this.readActivationEvents(E);m.length>0&&(p[F.$0l.toKey(E.identifier)]=m)}return p}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const p=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let E=0;E<p.length;E++)p[E]==="onUri"&&(p[E]=`onUri:${F.$0l.toKey(R.identifier)}`);if(!R.contributes)return p;for(const E in R.contributes){const m=this.a.get(E);if(!m)continue;const A=R.contributes[E],P=Array.isArray(A)?A:[A];try{m(P,p)}catch(g){(0,I.$Z)(g)}}return p}}e.$_E=f,e.$aF=new f}),define(ke[258],Se([1,0,10,22,21,11,4,3,56,37,32,83,65,66]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.$$k=e.PersistentConnectionEventType=e.$0k=e.$9k=e.$8k=e.ConnectionType=void 0;const S=30*1e3;var w;(function(H){H[H.Management=1]="Management",H[H.ExtensionHost=2]="ExtensionHost",H[H.Tunnel=3]="Tunnel"})(w||(e.ConnectionType=w={}));function c(H){switch(H){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function s(H){const U=new f.$Yd;return setTimeout(()=>U.cancel(),H),U.token}function i(H,U){if(H.isCancellationRequested||U.isCancellationRequested)return f.CancellationToken.Cancelled;const ce=new f.$Yd;return H.onCancellationRequested(()=>ce.cancel()),U.onCancellationRequested(()=>ce.cancel()),ce.token}class n{get didTimeout(){return this.c==="timedout"}constructor(U){this.c="pending",this.d=new p.$Qc,this.promise=new Promise((ce,Ee)=>{this.f=ce,this.g=Ee}),U.isCancellationRequested?this.h():this.d.add(U.onCancellationRequested(()=>this.h()))}registerDisposable(U){this.c==="pending"?this.d.add(U):U.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const U=new Error("Time limit reached");return U.code="ETIMEDOUT",U.syscall="connect",U}resolve(U){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(U))}reject(U){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(U))}}function o(H,U){const ce=new n(U);return ce.registerDisposable(H.onControlMessage(Ee=>{const ne=JSON.parse(Ee.toString()),G=Y(ne);G?ce.reject(G):ce.resolve(ne)})),ce.promise}function a(H,U,ce,Ee,ne,G,J,ge){const x=new n(ge),le=m.$Kd.create(!1);return H.info(`Creating a socket (${J})...`),E.mark(`code/willCreateSocket/${G}`),U.connect(ce,Ee,ne,J).then(te=>{x.didTimeout?(E.mark(`code/didCreateSocketError/${G}`),H.info(`Creating a socket (${J}) finished after ${le.elapsed()} ms, but this is too late and has timed out already.`),te?.dispose()):(E.mark(`code/didCreateSocketOK/${G}`),H.info(`Creating a socket (${J}) was successful after ${le.elapsed()} ms.`),x.resolve(te))},te=>{E.mark(`code/didCreateSocketError/${G}`),H.info(`Creating a socket (${J}) returned an error after ${le.elapsed()} ms.`),H.error(te),x.reject(te)}),x.promise}function t(H,U){const ce=new n(U);return H.then(Ee=>{ce.didTimeout||ce.resolve(Ee)},Ee=>{ce.didTimeout||ce.reject(Ee)}),ce.promise}async function r(H,U,ce,Ee){const ne=se(H,U);H.logService.trace(`${ne} 1/6. invoking socketFactory.connect().`);let G;try{G=await a(H.logService,H.remoteSocketFactoryService,H.connectTo,(0,y.$1k)(H),`reconnectionToken=${H.reconnectionToken}&reconnection=${H.reconnectionProtocol?"true":"false"}`,c(U),`renderer-${c(U)}-${H.reconnectionToken}`,Ee)}catch(te){throw H.logService.error(`${ne} socketFactory.connect() failed or timed out. Error:`),H.logService.error(te),te}H.logService.trace(`${ne} 2/6. socketFactory.connect() was successful.`);let J,ge;H.reconnectionProtocol?(H.reconnectionProtocol.beginAcceptReconnection(G,null),J=H.reconnectionProtocol,ge=!1):(J=new P.$Hh({socket:G}),ge=!0),H.logService.trace(`${ne} 3/6. sending AuthRequest control message.`);const x=await t(H.signService.createNewMessage((0,A.$fg)()),Ee),le={type:"auth",auth:H.connectionToken||"00000000000000000000",data:x.data};J.sendControl(F.$ce.fromString(JSON.stringify(le)));try{const te=await o(J,i(Ee,s(1e4)));if(te.type!=="sign"||typeof te.data!="string"){const B=new Error("Unexpected handshake message");throw B.code="VSCODE_CONNECTION_ERROR",B}if(H.logService.trace(`${ne} 4/6. received SignRequest control message.`),!await t(H.signService.validate(x,te.signedData),Ee)){const B=new Error("Refused to connect to unsupported server");throw B.code="VSCODE_CONNECTION_ERROR",B}const be=await t(H.signService.sign(te.data),Ee),Pe={type:"connectionType",commit:H.commit,signedData:be,desiredConnectionType:U};return ce&&(Pe.args=ce),H.logService.trace(`${ne} 5/6. sending ConnectionTypeRequest control message.`),J.sendControl(F.$ce.fromString(JSON.stringify(Pe))),{protocol:J,ownsProtocol:ge}}catch(te){throw te&&te.code==="ETIMEDOUT"&&(H.logService.error(`${ne} the handshake timed out. Error:`),H.logService.error(te)),te&&te.code==="VSCODE_CONNECTION_ERROR"&&(H.logService.error(`${ne} received error control message when negotiating connection. Error:`),H.logService.error(te)),ge&&ee(J),te}}async function d(H,U,ce,Ee){const ne=Date.now(),G=se(H,U),{protocol:J,ownsProtocol:ge}=await r(H,U,ce,Ee),x=new n(Ee);return x.registerDisposable(J.onControlMessage(le=>{const te=JSON.parse(le.toString()),de=Y(te);de?(H.logService.error(`${G} received error control message when negotiating connection. Error:`),H.logService.error(de),ge&&ee(J),x.reject(de)):(H.reconnectionProtocol?.endAcceptReconnection(),H.logService.trace(`${G} 6/6. handshake finished, connection is up and running after ${we(ne)}!`),x.resolve({protocol:J,firstMessage:te}))})),x.promise}async function u(H,U){const{protocol:ce}=await d(H,1,void 0,U);return{protocol:ce}}async function l(H,U,ce){const{protocol:Ee,firstMessage:ne}=await d(H,2,U,ce),G=ne&&ne.debugPort;return{protocol:Ee,debugPort:G}}async function h(H,U,ce){const Ee=Date.now(),ne=se(H,3),{protocol:G}=await r(H,3,U,ce);return H.logService.trace(`${ne} 6/6. handshake finished, connection is up and running after ${we(Ee)}!`),G}async function k(H,U,ce){const{connectTo:Ee,connectionToken:ne}=await H.addressProvider.getAddress();return{commit:H.commit,quality:H.quality,connectTo:Ee,connectionToken:ne,reconnectionToken:U,reconnectionProtocol:ce,remoteSocketFactoryService:H.remoteSocketFactoryService,signService:H.signService,logService:H.logService}}async function D(H,U,ce){return b(H,async Ee=>{const{protocol:ne}=await u(Ee,f.CancellationToken.None);return new q(H,U,ce,Ee.reconnectionToken,ne)})}e.$8k=D;async function $(H,U){return b(H,async ce=>{const{protocol:Ee,debugPort:ne}=await l(ce,U,f.CancellationToken.None);return new fe(H,U,ce.reconnectionToken,Ee,ne)})}e.$9k=$;async function b(H,U){for(let Ee=1;;Ee++)try{const ne=(0,A.$fg)(),G=await k(H,ne,null);return await U(G)}catch(ne){if(Ee<5)H.logService.error(`[remote-connection][attempt ${Ee}] An error occurred in initial connection! Will retry... Error:`),H.logService.error(ne);else throw H.logService.error(`[remote-connection][attempt ${Ee}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),H.logService.error(ne),V.triggerPermanentFailure(0,0,g.$Wk.isHandled(ne)),ne}}async function v(H,U,ce){const Ee=await k(H,(0,A.$fg)(),null);return await h(Ee,{host:U,port:ce},f.CancellationToken.None)}e.$0k=v;function C(H){return(0,I.$Ig)(U=>new Promise((ce,Ee)=>{const ne=setTimeout(ce,H*1e3);U.onCancellationRequested(()=>{clearTimeout(ne),ce()})}))}var N;(function(H){H[H.ConnectionLost=0]="ConnectionLost",H[H.ReconnectionWait=1]="ReconnectionWait",H[H.ReconnectionRunning=2]="ReconnectionRunning",H[H.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",H[H.ConnectionGain=4]="ConnectionGain"})(N||(e.PersistentConnectionEventType=N={}));class z{constructor(U,ce){this.reconnectionToken=U,this.millisSinceLastIncomingData=ce,this.type=0}}e.$$k=z;class M{constructor(U,ce,Ee,ne){this.reconnectionToken=U,this.millisSinceLastIncomingData=ce,this.durationSeconds=Ee,this.c=ne,this.type=1}skipWait(){this.c.cancel()}}e.$_k=M;class O{constructor(U,ce,Ee){this.reconnectionToken=U,this.millisSinceLastIncomingData=ce,this.attempt=Ee,this.type=2}}e.$al=O;class j{constructor(U,ce,Ee){this.reconnectionToken=U,this.millisSinceLastIncomingData=ce,this.attempt=Ee,this.type=4}}e.$bl=j;class T{constructor(U,ce,Ee,ne){this.reconnectionToken=U,this.millisSinceLastIncomingData=ce,this.attempt=Ee,this.handled=ne,this.type=3}}e.$cl=T;class V extends p.$Rc{static triggerPermanentFailure(U,ce,Ee){this._permanentFailure=!0,this.f=U,this.g=ce,this.h=Ee,this.j.forEach(ne=>ne.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(U=>U.y())}static debugPauseSocketWriting(){this.j.forEach(U=>U.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||V._permanentFailure}constructor(U,ce,Ee,ne,G){super(),this.t=U,this.u=ce,this.reconnectionToken=Ee,this.protocol=ne,this.w=G,this.m=this.B(new R.$Od),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new j(this.reconnectionToken,0,0)),this.B(ne.onSocketClose(J=>{const ge=Z(this.t,this.reconnectionToken,!0);J?J.type===0?(this.u.logService.info(`${ge} received socket close event (hadError: ${J.hadError}).`),J.error&&this.u.logService.error(J.error)):(this.u.logService.info(`${ge} received socket close event (wasClean: ${J.wasClean}, code: ${J.code}, reason: ${J.reason}).`),J.event&&this.u.logService.error(J.event)):this.u.logService.info(`${ge} received socket close event.`),this.y()})),this.B(ne.onSocketTimeout(J=>{const ge=Z(this.t,this.reconnectionToken,!0);this.u.logService.info(`${ge} received socket timeout event (unacknowledgedMsgCount: ${J.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${J.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${J.timeSinceLastReceivedSomeData}).`),this.y()})),V.j.push(this),this.B((0,p.$Pc)(()=>{const J=V.j.indexOf(this);J>=0&&V.j.splice(J,1)})),this.n&&this.D(V.f,V.g,V.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const U=Z(this.t,this.reconnectionToken,!0);this.u.logService.info(`${U} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const ce=[0,5,5,10,10,10,10,10,30];let Ee=-1;do{Ee++;const ne=Ee<ce.length?ce[Ee]:ce[ce.length-1];try{if(ne>0){const J=C(ne);this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ne,J)),this.u.logService.info(`${U} waiting for ${ne} seconds before reconnecting...`);try{await J}catch{}}if(this.n){this.u.logService.error(`${U} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Ee+1)),this.u.logService.info(`${U} resolving connection...`);const G=await k(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${U} connecting to ${G.connectTo}...`),await this.G(G,s(S)),this.u.logService.info(`${U} reconnected!`),this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Ee+1));break}catch(G){if(G.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${U} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(G),this.C(this.protocol.getMillisSinceLastIncomingData(),Ee+1,!1);break}if(Ee>360){this.u.logService.error(`${U} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(G),this.C(this.protocol.getMillisSinceLastIncomingData(),Ee+1,!1);break}if(g.$Wk.isTemporarilyNotAvailable(G)){this.u.logService.info(`${U} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(G);continue}if((G.code==="ETIMEDOUT"||G.code==="ENETUNREACH"||G.code==="ECONNREFUSED"||G.code==="ECONNRESET")&&G.syscall==="connect"){this.u.logService.info(`${U} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(G);continue}if((0,L.$3)(G)){this.u.logService.info(`${U} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(G);continue}if(G instanceof g.$Wk){this.u.logService.error(`${U} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(G),this.C(this.protocol.getMillisSinceLastIncomingData(),Ee+1,g.$Wk.isHandled(G));break}this.u.logService.error(`${U} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(G),this.C(this.protocol.getMillisSinceLastIncomingData(),Ee+1,!1);break}}while(!this.n&&!this.s)}C(U,ce,Ee){this.w?V.triggerPermanentFailure(U,ce,Ee):this.D(U,ce,Ee)}D(U,ce,Ee){this.m.fire(new T(this.reconnectionToken,U,ce,Ee)),ee(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$dl=V;class q extends V{constructor(U,ce,Ee,ne,G){super(1,U,ne,G,!0),this.client=this.B(new P.$Fh(G,{remoteAuthority:ce,clientId:Ee},U.ipcLogger))}async G(U,ce){await u(U,ce)}}e.$el=q;class fe extends V{constructor(U,ce,Ee,ne,G){super(2,U,Ee,ne,!1),this.H=ce,this.debugPort=G}async G(U,ce){await l(U,this.H,ce)}}e.$fl=fe;function ee(H){try{H.acceptDisconnect();const U=H.getSocket();H.dispose(),U.dispose()}catch(U){(0,L.$Z)(U)}}function Y(H){if(H&&H.type==="error"){const U=new Error(`Connection error: ${H.reason}`);return U.code="VSCODE_CONNECTION_ERROR",U}return null}function X(H,U){for(;H.length<U;)H+=" ";return H}function ae(H,U){return`[remote-connection][${X(c(H),13)}][${U.substr(0,5)}\u2026]`}function Z(H,U,ce){return`${ae(H,U)}[${ce?"reconnect":"initial"}]`}function se(H,U){return`${Z(U,H.reconnectionToken,!!H.reconnectionProtocol)}[${H.connectTo}]`}function we(H){return`${Date.now()-H} ms`}}),define(ke[259],Se([1,0,3,5]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5k=e.$4k=void 0,e.$4k=(0,F.$Th)("remoteSocketFactoryService");class f{constructor(){this.a={}}register(R,p){return this.a[R]??=[],this.a[R].push(p),(0,I.$Pc)(()=>{const E=this.a[R]?.indexOf(p);typeof E=="number"&&E>=0&&this.a[R]?.splice(E,1)})}b(R){return(this.a[R.type]||[]).find(E=>E.supports(R))}connect(R,p,E,m){const A=this.b(R);if(!A)throw new Error(`No socket factory found for ${R}`);return A.connect(R,p,E,m)}}e.$5k=f}),define(ke[260],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d4b=void 0;class I{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(f){try{const L=await this.c();if(L){const R=String(I.a++);return this.b.set(R,L),{id:R,data:L.createNewMessage(f)}}}catch{}return{id:"",data:f}}async validate(f,L){if(!f.id)return!0;const R=this.b.get(f.id);if(!R)return!1;this.b.delete(f.id);try{return R.validate(L)==="ok"}catch{return!1}finally{R.dispose?.()}}async sign(f){try{return await this.d(f)}catch{}return f}}e.$d4b=I}),define(ke[109],Se([1,0,5]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7k=e.$6k=void 0,e.$6k="signService",e.$7k=(0,I.$Th)(e.$6k)}),define(ke[140],Se([1,0,260]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_8b=void 0;class F extends I.$d4b{c(){return this.h().then(L=>new L.validator)}d(L){return this.h().then(R=>new R.signer().sign(L))}h(){return new Promise((L,R)=>$e(["vsda"],L,R))}}e.$_8b=F}),define(ke[261],Se([1,0,12,49,32]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mo=e.$lo=void 0;function L(E){if(I.$u===2&&/^penguin(\.|$)/i.test(E))return"chromebook"}function R(E,m,A,P,g,y,S,w,c){const s=Object.create(null);s["common.machineId"]=y,s["common.sqmId"]=S,s.sessionID=(0,f.$fg)()+Date.now(),s.commitHash=P,s.version=g,s["common.platformVersion"]=(E||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),s["common.platform"]=(0,I.$i)(I.$u),s["common.nodePlatform"]=F.$cc,s["common.nodeArch"]=A,s["common.product"]=c||"desktop",w&&(s["common.msftInternal"]=w);let i=0;const n=Date.now();Object.defineProperties(s,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),I.$m&&(s["common.snap"]="true");const o=L(m);return o&&(s["common.platformDetail"]=o),s}e.$lo=R;function p(E){const m=F.env.USERDNSDOMAIN;if(!m)return!1;const A=m.toLowerCase();return E.some(P=>A===P)}e.$mo=p}),define(ke[262],Se([1,0,5]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$ql=e.$pl=e.$ol=e.$nl=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=e.$hl=e.$gl=void 0,e.$gl=(0,I.$Th)("telemetryService"),e.$hl=(0,I.$Th)("customEndpointTelemetryService"),e.$il="telemetry.currentSessionDate",e.$jl="telemetry.firstSessionDate",e.$kl="telemetry.lastSessionDate",e.$ll="telemetry.machineId",e.$ml="telemetry.sqmId",e.$nl="telemetry",e.$ol="telemetry.telemetryLevel",e.$pl="telemetry.enableCrashReporter",e.$ql="telemetry.enableTelemetry";var F;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(F||(e.TelemetryLevel=F={}));var f;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(f||(e.TelemetryConfiguration=f={}))}),define(ke[87],Se([1,0,24,18,4,44,66,261,262]),function($e,e,I,F,f,L,R,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=void 0;class m{constructor(l){this.value=l,this.isTrustedTelemetryValue=!0}}e.$no=m;class A{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$oo=A,e.$po=new A;class P{async publicLog(l,h,k){}async publicLogError(l,h,k){}}e.$qo=P,e.$ro="telemetry",e.$so="extensionTelemetryLog",e.$to={log:()=>null,flush:()=>Promise.resolve(null)};function g(u,l){return f.Event.debounce(l.onDidChangeConfiguration,(k,D)=>{const $=k?new Set([...k.affectedKeys,...D.affectedKeys]):D.affectedKeys;return{...D,affectedKeys:$}},1e3,!0)(k=>{k.source!==7&&u.publicLog2("updateConfiguration",{configurationSource:(0,L.$qi)(k.source),configurationKeys:Array.from(k.affectedKeys)})})}e.$uo=g;function y(u,l){return!l.isBuilt&&!l.disableTelemetry?!0:!(l.disableTelemetry||!u.enableTelemetry)}e.$vo=y;function S(u,l){return l.extensionTestsLocationURI?!0:!(l.isBuilt||l.disableTelemetry||u.enableTelemetry&&u.aiConfig?.ariaKey)}e.$wo=S;function w(u){const l=u.getValue(E.$ol),h=u.getValue(E.$pl);if(u.getValue(E.$ql)===!1||h===!1)return 0;switch(l??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$xo=w;function c(u){const l={},h={},k={};n(u,k);for(let D in k){D=D.length>150?D.substr(D.length-149):D;const $=k[D];typeof $=="number"?h[D]=$:typeof $=="boolean"?h[D]=$?1:0:typeof $=="string"?($.length>8192&&console.warn(`Telemetry property: ${D} has been trimmed to 8192, the original length is ${$.length}`),l[D]=$.substring(0,8191)):typeof $<"u"&&$!==null&&(l[D]=$)}return{properties:l,measurements:h}}e.$yo=c;const s=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function i(u){if(!u)return"none";const l=(0,R.$Zk)(u);return s.has(l)?l:"other"}e.$zo=i;function n(u,l,h=0,k){if(u)for(const D of Object.getOwnPropertyNames(u)){const $=u[D],b=k?k+D:D;Array.isArray($)?l[b]=(0,I.$dn)($):$ instanceof Date?l[b]=$.toISOString():(0,F.$Bf)($)?h<2?n($,l,h+1,b+"."):l[b]=(0,I.$dn)($):l[b]=$}}function o(u,l){const h=u.msftInternalDomains||[],k=l.getValue("telemetry.internalTesting");return(0,p.$mo)(h)||k}e.$Ao=o;function a(u){return[u.appRoot,u.extensionsPath,u.userHome.fsPath,u.tmpDir.fsPath,u.userDataPath]}e.$Bo=a;function t(u,l){if(!u||!u.includes("/")&&!u.includes("\\"))return u;let h=u;const k=[];for(const v of l)for(;;){const C=v.exec(u);if(!C)break;k.push([C.index,v.lastIndex])}const D=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,$=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let b=0;for(h="";;){const v=$.exec(u);if(!v)break;const C=k.some(([N,z])=>v.index<z&&N<$.lastIndex);!D.test(v[0])&&!C&&(h+=u.substring(b,v.index)+"<REDACTED: user-file-path>",b=$.lastIndex)}return b<u.length&&(h+=u.substr(b)),h}function r(u){if(!u)return u;const l=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const h of l)if(h.regex.test(u))return`<REDACTED: ${h.label}>`;return u}function d(u,l){return(0,I.$an)(u,h=>{if(h instanceof m||Object.hasOwnProperty.call(h,"isTrustedTelemetryValue"))return h.value;if(typeof h=="string"){let k=h.replaceAll("%20"," ");k=t(k,l);for(const D of l)k=k.replace(D,"");return k=r(k),k}})}e.$Co=d}),define(ke[263],Se([1,0,13,135,26,12,2,11,49,87]),function($e,e,I,F,f,L,R,p,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=void 0;function A(d,u){return d.uuid&&u.uuid?d.uuid===u.uuid:d.id===u.id?!0:(0,I.$Xe)(d.id,u.id)===0}e.$Do=A;const P=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class g{static create(u){const l=u.manifest?u.manifest.version:u.version,h=u.manifest?u.targetPlatform:u.properties.targetPlatform;return new g(u.identifier,l,h)}static parse(u){const l=P.exec(u);return l&&l[1]&&l[2]?new g({id:l[1]},l[2],l[4]||void 0):null}constructor(u,l,h="undefined"){this.version=l,this.targetPlatform=h,this.id=u.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(u){return u instanceof g?A(this,u)&&this.version===u.version&&this.targetPlatform===u.targetPlatform:!1}}e.$Eo=g;const y=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function S(d){const u=y.exec(d);return u&&u[1]?[c(u[1]),u[2]]:[c(d),void 0]}e.$Fo=S;function w(d,u){return`${d}.${u}`}e.$Go=w;function c(d){return d.toLowerCase()}e.$Ho=c;function s(d,u){return c(w(d??f.$6l,u))}e.$Io=s;function i(d,u){const l=[],h=k=>{for(const D of l)if(D.some($=>A(u($),u(k))))return D;return null};for(const k of d){const D=h(k);D?D.push(k):l.push([k])}return l}e.$Jo=i;function n(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}e.$Ko=n;function o(d){return{id:new m.$no(d.identifier.id),name:new m.$no(d.name),galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,isPreReleaseVersion:d.properties.isPreReleaseVersion,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),isSigned:d.isSigned,...d.telemetryData}}e.$Lo=o,e.$Mo=new f.$0l("pprice.better-merge");function a(d,u){const l=[],h=u.manifest.extensionDependencies?.slice(0)??[];for(;h.length;){const k=h.shift();if(k&&l.every(D=>!A(D.identifier,{id:k}))){const D=d.filter($=>A($.identifier,{id:k}));D.length===1&&(l.push(D[0]),h.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return l}e.$No=a;async function t(d,u){if(!L.$l)return!1;let l;try{l=(await d.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{l=(await d.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(k){u.debug("Error while getting the os-release file.",(0,p.$9)(k))}}return!!l&&(l.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(d,u){const l=await t(d,u),h=(0,F.$0n)(l?"alpine":L.$u,E.$dc);return u.debug("ComputeTargetPlatform:",h),h}e.$Oo=r}),define(ke[264],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tr=e.$sr=e.$rr=e.$qr=e.$pr=e.$or=void 0;function I(E){return[...E.entries()]}e.$or=I;function F(E){return E?[...E.entries()]:[]}e.$pr=F;function f(E){return new Map(E)}e.$qr=f;function L(E){return new Map(E??[])}e.$rr=L;function R(E){return Array.from(E.entries()).map(m=>[m[0],I(m[1].map),F(m[1].descriptionMap)])}e.$sr=R;function p(E){return new Map(E.map(m=>[m[0],{map:f(m[1]),descriptionMap:L(m[2])}]))}e.$tr=p}),define(ke[265],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eqb=void 0;class I{constructor(f){this.b=f,this.a=new Map}dispose(){for(const f of this.a.values())f.dispose()}startBuffering(f,L,R=5){const p=L(E=>{const m=typeof E=="string"?E:E.data;let A=this.a.get(f);if(A){A.data.push(m);return}const P=setTimeout(()=>this.flushBuffer(f),R);A={data:[m],timeoutId:P,dispose:()=>{clearTimeout(P),this.flushBuffer(f),p.dispose()}},this.a.set(f,A)});return p}stopBuffering(f){this.a.get(f)?.dispose()}flushBuffer(f){const L=this.a.get(f);L&&(this.a.delete(f),this.b(f,L.data.join("")))}}e.$eqb=I}),define(ke[266],Se([1,0,10,79,61,4,18,2,207,108,38]),function($e,e,I,F,f,L,R,p,E,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ew=e.$dw=e.$cw=e.$bw=e.$aw=e.$_v=e.$$v=e.$0v=e.IconFontDefinition=e.IconContribution=e.$9v=void 0,e.$9v={IconContribution:"base.contributions.icons"};var P;(function(o){function a(t,r){let d=t.defaults;for(;f.ThemeIcon.isThemeIcon(d);){const u=S.getIcon(d.id);if(!u)return;d=u.defaults}return d}o.getDefinition=a})(P||(e.IconContribution=P={}));var g;(function(o){function a(r){return{weight:r.weight,style:r.style,src:r.src.map(d=>({format:d.format,location:d.location.toString()}))}}o.toJSONObject=a;function t(r){const d=u=>(0,R.$zf)(u)?u:void 0;if(r&&Array.isArray(r.src)&&r.src.every(u=>(0,R.$zf)(u.format)&&(0,R.$zf)(u.location)))return{weight:d(r.weight),style:d(r.style),src:r.src.map(u=>({format:u.format,location:p.URI.parse(u.location)}))}}o.fromJSONObject=t})(g||(e.IconFontDefinition=g={}));class y{constructor(){this.a=new L.$Od,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,E.localize)(0,null)},fontCharacter:{type:"string",description:(0,E.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${f.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(a,t,r,d){const u=this.b[a];if(u){if(r&&!u.description){u.description=r,this.d.properties[a].markdownDescription=`${r} $(${a})`;const k=this.e.enum.indexOf(a);k!==-1&&(this.e.enumDescriptions[k]=r),this.a.fire()}return u}const l={id:a,description:r,defaults:t,deprecationMessage:d};this.b[a]=l;const h={$ref:"#/definitions/icons"};return d&&(h.deprecationMessage=d),r&&(h.markdownDescription=`${r}: $(${a})`),this.d.properties[a]=h,this.e.enum.push(a),this.e.enumDescriptions.push(r||""),this.a.fire(),{id:a}}deregisterIcon(a){delete this.b[a],delete this.d.properties[a];const t=this.e.enum.indexOf(a);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(a=>this.b[a])}getIcon(a){return this.b[a]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(a,t){const r=this.f[a];return r||(this.f[a]=t,this.a.fire(),t)}deregisterIconFont(a){delete this.f[a]}getIconFont(a){return this.f[a]}toString(){const a=(u,l)=>u.id.localeCompare(l.id),t=u=>{for(;f.ThemeIcon.isThemeIcon(u.defaults);)u=this.b[u.defaults.id];return`codicon codicon-${u?u.id:""}`},r=[];r.push("| preview     | identifier                        | default codicon ID                | description"),r.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const d=Object.keys(this.b).map(u=>this.b[u]);for(const u of d.filter(l=>!!l.description).sort(a))r.push(`|<i class="${t(u)}"></i>|${u.id}|${f.ThemeIcon.isThemeIcon(u.defaults)?u.defaults.id:u.id}|${u.description||""}|`);r.push("| preview     | identifier                        "),r.push("| ----------- | --------------------------------- |");for(const u of d.filter(l=>!f.ThemeIcon.isThemeIcon(l.defaults)).sort(a))r.push(`|<i class="${t(u)}"></i>|${u.id}|`);return r.join(`
`)}}const S=new y;A.$kn.add(e.$9v.IconContribution,S);function w(o,a,t,r){return S.registerIcon(o,a,t,r)}e.$0v=w;function c(){return S}e.$$v=c;function s(){const o=(0,F.$Wj)();for(const a in o){const t="\\"+o[a].toString(16);S.registerIcon(a,{fontCharacter:t})}}s(),e.$_v="vscode://schemas/icons";const i=A.$kn.as(m.$ln.JSONContribution);i.registerSchema(e.$_v,S.getIconSchema());const n=new I.$8g(()=>i.notifySchemaChanged(e.$_v),200);S.onDidChange(()=>{n.isScheduled()||n.schedule()}),e.$aw=w("widget-close",F.$Yj.close,(0,E.localize)(2,null)),e.$bw=w("goto-previous-location",F.$Yj.arrowUp,(0,E.localize)(3,null)),e.$cw=w("goto-next-location",F.$Yj.arrowDown,(0,E.localize)(4,null)),e.$dw=f.ThemeIcon.modify(F.$Yj.sync,"spin"),e.$ew=f.ThemeIcon.modify(F.$Yj.loading,"spin")}),define(ke[88],Se([1,0,4,44,5,15]),function($e,e,I,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lv=e.$kv=e.$jv=e.$iv=e.$hv=e.$gv=e.$fv=e.$ev=e.ProvidedOnAutoForward=e.$dv=e.TunnelPrivacyId=e.TunnelProtocol=e.$cv=e.$bv=void 0,e.$bv=(0,f.$Th)("tunnelService"),e.$cv=(0,f.$Th)("sharedTunnelsService");var R;(function(c){c.Http="http",c.Https="https"})(R||(e.TunnelProtocol=R={}));var p;(function(c){c.ConstantPrivate="constantPrivate",c.Private="private",c.Public="public"})(p||(e.TunnelPrivacyId=p={}));function E(c){return!!c.forwardPort}e.$dv=E;var m;(function(c){c[c.Notify=1]="Notify",c[c.OpenBrowser=2]="OpenBrowser",c[c.OpenPreview=3]="OpenPreview",c[c.Silent=4]="Silent",c[c.Ignore=5]="Ignore",c[c.OpenBrowserOnce=6]="OpenBrowserOnce"})(m||(e.ProvidedOnAutoForward=m={}));function A(c){if(c.scheme!=="http"&&c.scheme!=="https")return;const s=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(c.authority);if(s)return{address:s[1],port:+s[2]}}e.$ev=A,e.$fv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function P(c){return e.$fv.indexOf(c)>=0}e.$gv=P,e.$hv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function g(c){return e.$hv.indexOf(c)>=0}e.$iv=g;function y(c,s,i,n){if(i===1)return!1;if(i===2&&g(s)){const o=/(\d+)\.(\d+)\.(\d+)/g.exec(n);if(o?.length===4&&parseInt(o[1])>=18)return!1}return c<1024}e.$jv=y;class S{constructor(s,i,n){this.remoteAddress=s,this.localAddress=i,this.b=n,this.a=new I.$Od,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$kv=S;let w=class{constructor(s,i){this.j=s,this.k=i,this.a=new I.$Od,this.onTunnelOpened=this.a.event,this.b=new I.$Od,this.onTunnelClosed=this.b.event,this.c=new I.$Od,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const s=this.k.getValue("remote.localPortHost");return!s||s==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(s){return this.f=s,s?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(s){this.g=s.elevation,this.h=s.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const s=[],i=Array.from(this.e.values());for(const n of i){const o=Array.from(n.values());for(const a of o){const t=await a.value;t&&typeof t!="string"&&s.push(t)}}return s}async dispose(){for(const s of this.e.values()){for(const{value:i}of s.values())await i.then(n=>typeof n!="string"?n?.dispose():void 0);s.clear()}this.e.clear()}setEnvironmentTunnel(s,i,n,o,a){this.p(s,i,Promise.resolve({tunnelRemoteHost:s,tunnelRemotePort:i,localAddress:n,privacy:o,protocol:a,dispose:()=>Promise.resolve()}))}async getExistingTunnel(s,i){(g(s)||P(s))&&(s=e.$fv[0]);const n=this.r(s,i);if(n)return++n.refcount,n.value}openTunnel(s,i,n,o,a,t=!1,r,d){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${i}:${n} on local port ${a}.`);const u=this.f??s;if(!u)return;if(i||(i="localhost"),o||(o=this.l),this.f&&this.i.has(n)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const l=this.s(u,i,n,o,a,t,r,d);return l?l.then(h=>{if(h){if(typeof h=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(i,n),h}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(i,n);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const k=this.n(h);return(h.tunnelRemoteHost!==i||h.tunnelRemotePort!==n)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),r&&h.privacy!==r&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(k),k}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),l)}n(s){return{tunnelRemotePort:s.tunnelRemotePort,tunnelRemoteHost:s.tunnelRemoteHost,tunnelLocalPort:s.tunnelLocalPort,localAddress:s.localAddress,privacy:s.privacy,protocol:s.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${s.tunnelRemoteHost}:${s.tunnelRemotePort} `);const i=this.e.get(s.tunnelRemoteHost);if(i){const n=i.get(s.tunnelRemotePort);n&&(n.refcount--,await this.o(s.tunnelRemoteHost,s.tunnelRemotePort,n))}}}}async o(s,i,n){if(n.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${s}:${i}.`);const o=n.value.then(async a=>{a&&typeof a!="string"&&(await a.dispose(!0),this.b.fire({host:a.tunnelRemoteHost,port:a.tunnelRemotePort}))});return this.e.has(s)&&this.e.get(s).delete(i),o}}async closeTunnel(s,i){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${s}:${i} `);const n=this.e.get(s);if(n&&n.has(i)){const o=n.get(i);o.refcount=0,await this.o(s,i,o)}}p(s,i,n){this.e.has(s)||this.e.set(s,new Map),this.e.get(s).set(i,{refcount:1,value:n})}async q(s,i){const n=this.e.get(s);if(n){const o=n.get(i),a=o?await o.value:void 0;(!a||typeof a=="string")&&n.delete(i),n.size===0&&this.e.delete(s)}}r(s,i){const n=[s];P(s)?(n.push(...e.$fv),n.push(...e.$hv)):g(s)&&n.push(...e.$hv);const o=n.map(a=>this.e.get(a));for(const a of o){const t=a?.get(i);if(t)return t}}canTunnel(s){return!!A(s)}t(s,i,n,o,a,t,r){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${i}:${n} on local port ${o}.`);const d=n;this.i.add(d);const u=o===void 0?n:o,l={elevationRequired:a?this.isPortPrivileged(u):!1},h={remoteAddress:{host:i,port:n},localAddressPort:o,privacy:t,public:t?t!==p.Private:void 0,protocol:r},k=s.forwardPort(h,l);return k?(this.p(i,n,k),k.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(d)})):this.i.delete(d),k}};e.$lv=w,e.$lv=w=He([Be(0,L.$bj),Be(1,F.$ni)],w)}),define(ke[267],Se([1,0,5]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mk=void 0,e.$Mk=(0,I.$Th)("IUriIdentityService")}),define(ke[268],Se([1,0,5]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$mv=void 0,e.$mv=(0,I.$Th)("editSessionIdentityService");var F;(function(f){f[f.Complete=100]="Complete",f[f.Partial=50]="Partial",f[f.None=0]="None"})(F||(e.EditSessionIdentityMatch=F={}))}),define(ke[269],Se([1,0,17]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=void 0;function F(E){return E.scheme!==I.Schemas.file&&E.scheme!==I.Schemas.vscodeRemote}e.$2J=F;function f(E){if(E.folders.length)return E.folders.every(m=>F(m.uri))?E.folders[0].uri:void 0;if(E.configuration&&F(E.configuration))return E.configuration}e.$3J=f;function L(E){return f(E)?.scheme}e.$4J=L;function R(E){return f(E)?.authority}e.$5J=R;function p(E){return f(E)!==void 0}e.$6J=p}),define(ke[40],Se([1,0,209,16,78,23,2,5,17]),function($e,e,I,F,f,L,R,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.WorkbenchState=e.$0h=e.$9h=e.$8h=e.$7h=e.$6h=e.$5h=e.$4h=e.$3h=void 0,e.$3h=(0,p.$Th)("contextService");function m(u){const l=u;return typeof l?.id=="string"&&R.URI.isUri(l.uri)}e.$4h=m;function A(u){return typeof u?.id=="string"&&!m(u)&&!g(u)}e.$5h=A,e.$6h={id:"ext-dev"},e.$7h={id:"empty-window"};function P(u,l){if(typeof u=="string"||typeof u>"u")return typeof u=="string"?{id:(0,F.$mc)(u)}:l?e.$6h:e.$7h;const h=u;return h.configuration?{id:h.id,configPath:h.configuration}:h.folders.length===1?{id:h.id,uri:h.folders[0].uri}:{id:h.id}}e.$8h=P;function g(u){const l=u;return typeof l?.id=="string"&&R.URI.isUri(l.configPath)}e.$9h=g;function y(u){const l=u;if(l?.uri)return{id:l.id,uri:R.URI.revive(l.uri)};const h=u;if(h?.configPath)return{id:h.id,configPath:R.URI.revive(h.configPath)};if(u?.id)return{id:u.id}}e.$0h=y;var S;(function(u){u[u.EMPTY=1]="EMPTY",u[u.FOLDER=2]="FOLDER",u[u.WORKSPACE=3]="WORKSPACE"})(S||(e.WorkbenchState=S={}));function w(u){const l=u;return!!(l&&typeof l=="object"&&typeof l.id=="string"&&Array.isArray(l.folders))}e.$$h=w;function c(u){const l=u;return!!(l&&typeof l=="object"&&R.URI.isUri(l.uri)&&typeof l.name=="string"&&typeof l.toResource=="function")}e.$_h=c;class s{constructor(l,h,k,D,$){this.h=l,this.j=k,this.k=D,this.l=$,this.c=f.$Zh.forUris(this.l,()=>!0),this.folders=h}update(l){this.h=l.id,this.k=l.configuration,this.j=l.transient,this.l=l.l,this.folders=l.folders}get folders(){return this.g}set folders(l){this.g=l,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(l){this.k=l}getFolder(l){return l&&this.c.findSubstr(l)||null}n(){this.c=f.$Zh.forUris(this.l,()=>!0);for(const l of this.folders)this.c.set(l.uri,l)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$ai=s;class i{constructor(l,h){this.raw=h,this.uri=l.uri,this.index=l.index,this.name=l.name}toResource(l){return(0,L.$wg)(this.uri,l)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$bi=i;function n(u){return new i({uri:u,index:0,name:(0,L.$sg)(u)},{uri:u.toString()})}e.$ci=n,e.$di="code-workspace",e.$ei=`.${e.$di}`,e.$fi=[{name:(0,I.localize)(0,null),extensions:[e.$di]}],e.$gi="workspace.json";function o(u,l){return L.$ng.isEqualOrParent(u,l.untitledWorkspacesHome)}e.$hi=o;function a(u){let l;return R.URI.isUri(u)?l=u:l=u.configuration,l?.scheme===E.Schemas.tmp}e.$ii=a,e.$ji="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(u){return u.id===e.$ji}e.$ki=t;function r(u,l){return!o(u,l)&&!a(u)}e.$li=r;function d(u){return(typeof u=="string"?(0,F.$nc)(u):(0,L.$ug)(u))===e.$ei}e.$mi=d}),define(ke[270],Se([1,0,52,4,3,23,2,208,134,31,5,15,40,28,267,10,32,13,18]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,S,w,c,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.ProfileResourceType=void 0;var n;(function(u){u.Settings="settings",u.Keybindings="keybindings",u.Snippets="snippets",u.Tasks="tasks",u.Extensions="extensions",u.GlobalState="globalState"})(n||(e.ProfileResourceType=n={}));function o(u){const l=u;return!!(l&&typeof l=="object"&&typeof l.id=="string"&&typeof l.isDefault=="boolean"&&typeof l.name=="string"&&R.URI.isUri(l.location)&&R.URI.isUri(l.globalStorageHome)&&R.URI.isUri(l.settingsResource)&&R.URI.isUri(l.keybindingsResource)&&R.URI.isUri(l.tasksResource)&&R.URI.isUri(l.snippetsHome)&&R.URI.isUri(l.extensionsResource))}e.$Nk=o,e.$Ok=(0,A.$Th)("IUserDataProfilesService");function a(u,l){return{id:u.id,isDefault:u.isDefault,name:u.name,shortName:u.shortName,icon:u.icon,location:R.URI.revive(u.location).with({scheme:l}),globalStorageHome:R.URI.revive(u.globalStorageHome).with({scheme:l}),settingsResource:R.URI.revive(u.settingsResource).with({scheme:l}),keybindingsResource:R.URI.revive(u.keybindingsResource).with({scheme:l}),tasksResource:R.URI.revive(u.tasksResource).with({scheme:l}),snippetsHome:R.URI.revive(u.snippetsHome).with({scheme:l}),extensionsResource:R.URI.revive(u.extensionsResource).with({scheme:l}),cacheHome:R.URI.revive(u.cacheHome).with({scheme:l}),useDefaultFlags:u.useDefaultFlags,isTransient:u.isTransient}}e.$Pk=a;function t(u,l,h,k,D,$){return{id:u,name:l,location:h,isDefault:!1,shortName:D?.shortName,icon:D?.icon,globalStorageHome:$&&D?.useDefaultFlags?.globalState?$.globalStorageHome:(0,L.$wg)(h,"globalStorage"),settingsResource:$&&D?.useDefaultFlags?.settings?$.settingsResource:(0,L.$wg)(h,"settings.json"),keybindingsResource:$&&D?.useDefaultFlags?.keybindings?$.keybindingsResource:(0,L.$wg)(h,"keybindings.json"),tasksResource:$&&D?.useDefaultFlags?.tasks?$.tasksResource:(0,L.$wg)(h,"tasks.json"),snippetsHome:$&&D?.useDefaultFlags?.snippets?$.snippetsHome:(0,L.$wg)(h,"snippets"),extensionsResource:$&&D?.useDefaultFlags?.extensions?$.extensionsResource:(0,L.$wg)(h,"extensions.json"),cacheHome:(0,L.$wg)(k,u),useDefaultFlags:D?.useDefaultFlags,isTransient:D?.transient}}e.$Qk=t;let r=class extends f.$Rc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(l,h,k,D){super(),this.t=l,this.u=h,this.w=k,this.y=D,this.f=!0,this.h=this.B(new F.$Od),this.onDidChangeProfiles=this.h.event,this.j=this.B(new F.$Od),this.onWillCreateProfile=this.j.event,this.m=this.B(new F.$Od),this.onWillRemoveProfile=this.m.event,this.n=this.B(new F.$Od),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new y.$zc,emptyWindows:new Map},this.profilesHome=(0,L.$wg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,L.$wg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(l){this.f!==l&&(this.z=void 0,this.f=l)}isEnabled(){return this.f}get C(){if(!this.z){const l=this.D(),h=[l];if(this.f)try{for(const $ of this.O()){if(!$.name||!(0,i.$zf)($.name)||!$.location){this.y.warn("Skipping the invalid stored profile",$.location||$.name);continue}h.push(t((0,L.$tg)($.location),$.name,$.location,this.g,{shortName:$.shortName,icon:$.icon,useDefaultFlags:$.useDefaultFlags},l))}}catch($){this.y.error($)}const k=new y.$zc,D=new Map;if(h.length)try{const $=this.Q();if($.workspaces)for(const[b,v]of Object.entries($.workspaces)){const C=R.URI.parse(b),N=h.find(z=>z.id===v);N&&k.set(C,N)}if($.emptyWindows)for(const[b,v]of Object.entries($.emptyWindows)){const C=h.find(N=>N.id===v);C&&D.set(b,C)}}catch($){this.y.error($)}this.z={profiles:h,workspaces:k,emptyWindows:D}}return this.z}D(){const l=t("__default__profile__",(0,p.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...l,extensionsResource:this.S()??l.extensionsResource,isDefault:!0}}async createTransientProfile(l){const h="Temp",k=new RegExp(`${(0,s.$Ge)(h)}\\s(\\d+)`);let D=0;for(const b of this.profiles){const v=k.exec(b.name),C=v?parseInt(v[1]):0;D=C>D?C:D}const $=`${h} ${D+1}`;return this.createProfile((0,I.$Hi)((0,c.$fg)()).toString(16),$,{transient:!0},l)}async createNamedProfile(l,h,k){return this.createProfile((0,I.$Hi)((0,c.$fg)()).toString(16),l,h,k)}async createProfile(l,h,k,D){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const $=await this.F(l,h,k);return D&&await this.setProfileForWorkspace(D,$),$}async F(l,h,k){if(!(0,i.$zf)(h)||!h)throw new Error("Name of the profile is mandatory and must be of type `string`");let D=this.r.get(h);return D||(D=(async()=>{try{const $=this.profiles.find(C=>C.name===h||C.id===l);if($)return $;const b=t(l,h,(0,L.$wg)(this.profilesHome,l),this.g,k,this.defaultProfile);await this.u.createFolder(b.location);const v=[];return this.j.fire({profile:b,join(C){v.push(C)}}),await w.Promises.settled(v),this.I([b],[],[]),b}finally{this.r.delete(h)}})(),this.r.set(h,D)),D}async updateProfile(l,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let k=this.profiles.find(D=>D.id===l.id);if(!k)throw new Error(`Profile '${l.name}' does not exist`);return k=t(k.id,h.name??k.name,k.location,this.g,{shortName:h.shortName??k.shortName,icon:h.icon===null?void 0:h.icon??k.icon,transient:h.transient??k.isTransient,useDefaultFlags:h.useDefaultFlags??k.useDefaultFlags},this.defaultProfile),this.I([],[],[k]),k}async removeProfile(l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(l.isDefault)throw new Error("Cannot remove default profile");const h=this.profiles.find(D=>D.id===l.id);if(!h)throw new Error(`Profile '${l.name}' does not exist`);const k=[];this.m.fire({profile:h,join(D){k.push(D)}});try{await Promise.allSettled(k)}catch(D){this.y.error(D)}for(const D of[...this.C.emptyWindows.keys()])h.id===this.C.emptyWindows.get(D)?.id&&this.C.emptyWindows.delete(D);for(const D of[...this.C.workspaces.keys()])h.id===this.C.workspaces.get(D)?.id&&this.C.workspaces.delete(D);this.M(),this.I([],[h],[]);try{await this.u.del(h.cacheHome,{recursive:!0})}catch(D){(0,m.$tk)(D)!==1&&this.y.error(D)}}async setProfileForWorkspace(l,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const k=this.profiles.find(D=>D.id===h.id);if(!k)throw new Error(`Profile '${h.name}' does not exist`);this.L(l,k)}unsetWorkspace(l,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(l,void 0,h)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const l=await this.u.resolve(this.profilesHome);await Promise.all((l.children||[]).filter(h=>h.isDirectory&&this.profiles.every(k=>!this.w.extUri.isEqual(k.location,h.resource))).map(h=>this.u.del(h.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const l=this.s.profiles.filter(h=>!this.H(h));await Promise.allSettled(l.map(h=>this.removeProfile(h)))}getProfileForWorkspace(l){const h=this.G(l);return R.URI.isUri(h)?this.s.workspaces.get(h)??this.C.workspaces.get(h):this.s.emptyWindows.get(h)??this.C.emptyWindows.get(h)}G(l){return(0,g.$4h)(l)?l.uri:(0,g.$9h)(l)?l.configPath:l.id}H(l){return!!([...this.s.emptyWindows.values()].some(h=>this.w.extUri.isEqual(h.location,l.location))||[...this.s.workspaces.values()].some(h=>this.w.extUri.isEqual(h.location,l.location))||[...this.C.emptyWindows.values()].some(h=>this.w.extUri.isEqual(h.location,l.location))||[...this.C.workspaces.values()].some(h=>this.w.extUri.isEqual(h.location,l.location)))}I(l,h,k){const D=[...this.profiles,...l],$=[];this.s.profiles=[];for(let b of D)b.isDefault||h.some(v=>b.id===v.id)||(b=k.find(v=>b.id===v.id)??b,b.isTransient?this.s.profiles.push(b):$.push({location:b.location,name:b.name,shortName:b.shortName,icon:b.icon,useDefaultFlags:b.useDefaultFlags}));this.P($),this.z=void 0,this.J(l,h,k)}J(l,h,k){this.h.fire({added:l,removed:h,updated:k,all:this.profiles})}L(l,h,k){k=h?.isTransient?!0:k,k||this.L(l,void 0,!0);const D=this.G(l),$=k?this.s:this.C;R.URI.isUri(D)?($.workspaces.delete(D),h&&$.workspaces.set(D,h)):($.emptyWindows.delete(D),h&&$.emptyWindows.set(D,h)),k||this.M()}M(){const l={};for(const[k,D]of this.C.workspaces.entries())l[k.toString()]=D.id;const h={};for(const[k,D]of this.C.emptyWindows.entries())h[k.toString()]=D.id;this.R({workspaces:l,emptyWindows:h}),this.z=void 0}N(l){const h={},k=this.D();if(l.workspaces)for(const[$,b]of Object.entries(l.workspaces)){const v=R.URI.parse(b);h[$]=this.w.extUri.isEqual(v,k.location)?k.id:this.w.extUri.basename(v)}const D={};if(l.emptyWindows)for(const[$,b]of Object.entries(l.emptyWindows)){const v=R.URI.parse(b);D[$]=this.w.extUri.isEqual(v,k.location)?k.id:this.w.extUri.basename(v)}return{workspaces:h,emptyWindows:D}}O(){return[]}P(l){throw new Error("not implemented")}Q(){return{}}R(l){throw new Error("not implemented")}S(){}};e.$Rk=r,e.$Rk=r=He([Be(0,E.$1h),Be(1,m.$ck),Be(2,S.$Mk),Be(3,P.$bj)],r);class d extends r{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(l){this.a=l}Q(){return this.X}R(l){this.X=l}}e.$Sk=d}),define(ke[271],Se([1,0,10,4,3,56,18,188,5,270]),function($e,e,I,F,f,L,R,p,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$0o=e.$9o=e.$8o=void 0,e.$8o="__$__isNewStorageMarker",e.$9o="__$__targetStorageMarker",e.$0o=(0,E.$Th)("storageService");var A;(function(i){i[i.NONE=0]="NONE",i[i.SHUTDOWN=1]="SHUTDOWN"})(A||(e.WillSaveStateReason=A={}));var P;(function(i){i[i.APPLICATION=-1]="APPLICATION",i[i.PROFILE=0]="PROFILE",i[i.WORKSPACE=1]="WORKSPACE"})(P||(e.StorageScope=P={}));var g;(function(i){i[i.USER=0]="USER",i[i.MACHINE=1]="MACHINE"})(g||(e.StorageTarget=g={}));function y(i){const n=i.get(e.$9o);if(n)try{return JSON.parse(n)}catch{}return Object.create(null)}e.$$o=y;class S extends f.$Rc{static{this.a=60*1e3}constructor(n={flushInterval:S.a}){super(),this.m=n,this.b=this.B(new F.$Rd),this.c=this.B(new F.$Rd),this.onDidChangeTarget=this.c.event,this.f=this.B(new F.$Od),this.onWillSaveState=this.f.event,this.h=this.B(new I.$8g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new f.$Sc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(n,o,a){return F.Event.filter(this.b.event,t=>t.scope===n&&(o===void 0||t.key===o),a)}n(){this.j.value=(0,I.$ah)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,f.$Mc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.O()}finally{(0,L.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(n,o){const{key:a,external:t}=o;if(a===e.$9o){switch(n){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:n})}else this.b.fire({scope:n,key:a,target:this.J(n)[a],external:t})}w(n){this.f.fire({reason:n})}get(n,o,a){return this.P(o)?.get(n,a)}getBoolean(n,o,a){return this.P(o)?.getBoolean(n,a)}getNumber(n,o,a){return this.P(o)?.getNumber(n,a)}getObject(n,o,a){return this.P(o)?.getObject(n,a)}storeAll(n,o){this.y(()=>{for(const a of n)this.store(a.key,a.value,a.scope,a.target,o)})}store(n,o,a,t,r=!1){if((0,R.$If)(o)){this.remove(n,a,r);return}this.y(()=>{this.z(n,a,t),this.P(a)?.set(n,o,r)})}remove(n,o,a=!1){this.y(()=>{this.z(n,o,void 0),this.P(o)?.delete(n,a)})}y(n){this.b.pause(),this.c.pause();try{n()}finally{this.b.resume(),this.c.resume()}}keys(n,o){const a=[],t=this.J(n);for(const r of Object.keys(t))t[r]===o&&a.push(r);return a}z(n,o,a,t=!1){const r=this.J(o);typeof a=="number"?r[n]!==a&&(r[n]=a,this.P(o)?.set(e.$9o,JSON.stringify(r),t)):typeof r[n]=="number"&&(delete r[n],this.P(o)?.set(e.$9o,JSON.stringify(r),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(n){switch(n){case-1:return this.I;case 0:return this.G;default:return this.D}}L(n){const o=this.P(n);return o?y(o):Object.create(null)}isNew(n){return this.getBoolean(e.$8o,n)===!0}async flush(n=A.NONE){this.f.fire({reason:n});const o=this.P(-1),a=this.P(0),t=this.P(1);switch(n){case A.NONE:await I.Promises.settled([o?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case A.SHUTDOWN:await I.Promises.settled([o?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const n=this.P(-1)?.items??new Map,o=this.P(0)?.items??new Map,a=this.P(1)?.items??new Map;return s(n,o,a,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(n){return await this.flush(),this.P(n)?.optimize()}async switch(n,o){return this.w(A.NONE),(0,m.$Nk)(n)?this.R(n,o):this.S(n,o)}M(n,o){return!(n.id===o.id||w(o)&&w(n))}N(n,o,a){this.y(()=>{const t=new Set;for(const[r,d]of n)t.add(r),o.get(r)!==d&&this.u(a,{key:r,external:!0});for(const[r]of o.items)t.has(r)||this.u(a,{key:r,external:!0})})}}e.$_o=S;function w(i){return i.isDefault||!!i.useDefaultFlags?.globalState}e.$ap=w;class c extends S{constructor(){super(),this.U=this.B(new p.$6o(new p.$7o,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new p.$6o(new p.$7o,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new p.$6o(new p.$7o,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(n=>this.u(1,n))),this.B(this.W.onDidChangeStorage(n=>this.u(0,n))),this.B(this.U.onDidChangeStorage(n=>this.u(-1,n)))}P(n){switch(n){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(n){switch(n){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(n){return!1}}e.$bp=c;async function s(i,n,o,a,t,r){const d=C=>{try{return JSON.parse(C)}catch{return C}},u=new Map,l=new Map;i.forEach((C,N)=>{u.set(N,C),l.set(N,d(C))});const h=new Map,k=new Map;n.forEach((C,N)=>{h.set(N,C),k.set(N,d(C))});const D=new Map,$=new Map;o.forEach((C,N)=>{D.set(N,C),$.set(N,d(C))}),console.group(a!==t?`Storage: Application (path: ${a})`:`Storage: Application & Profile (path: ${a}, default profile)`);const b=[];if(u.forEach((C,N)=>{b.push({key:N,value:C})}),console.table(b),console.groupEnd(),console.log(l),a!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const C=[];h.forEach((N,z)=>{C.push({key:z,value:N})}),console.table(C),console.groupEnd(),console.log(k)}console.group(`Storage: Workspace (path: ${r})`);const v=[];D.forEach((C,N)=>{v.push({key:N,value:C})}),console.table(v),console.groupEnd(),console.log($)}e.$cp=s}),define(ke[110],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zcc=void 0;class I{static{this.a=!1}constructor(f){this.d=f,this.b=new Map,this.c=1}add(f){const L=this.c++;return this.b.set(L,f),this.e(),L}get(f,L){return this.b.has(f)?this.b.get(f)[L]:void 0}delete(f){this.b.delete(f),this.e()}e(){I.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Zcc=I}),define(ke[57],Se([1,0,17,23,5]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3cc=e.$2cc=void 0;class L{constructor(){this.a=new Set(Object.keys(I.Schemas)),this.b=new Map,this.extUri=new F.$lg(p=>{const E=this.b.get(p.scheme);return!(E===void 0||E&1024)})}$acceptProviderInfos(p,E){E===null?this.b.delete(p.scheme):this.b.set(p.scheme,E)}isFreeScheme(p){return!this.b.has(p)&&!this.a.has(p)}getCapabilities(p){return this.b.get(p)}}e.$2cc=L,e.$3cc=(0,f.$Th)("IExtHostFileSystemInfo")}),define(ke[27],Se([1,0,5]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NM=void 0,e.$NM=(0,I.$Th)("IExtHostInitDataService")}),define(ke[272],Se([1,0,215,15,252,27]),function($e,e,I,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ec=void 0;let R=class extends f.$UN{constructor(E,m,A){const P=A.remote.isRemote?"remoteexthost":E?"workerexthost":"exthost",g=A.remote.isRemote?(0,I.localize)(0,null):E?(0,I.localize)(1,null):(0,I.localize)(2,null);super(m.createLogger(P,{name:g}))}};e.$$ec=R,e.$$ec=R=He([Be(1,F.$cj),Be(2,L.$NM)],R)}),define(ke[273],Se([1,0,10]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tdc=e.$sdc=void 0;class F{constructor(R,p,E){this.h=new Map,this.a=R,this.b=p,this.c=E,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(m=>(this.f=m,this)),this.g=this.c.onDidChangeStorage(m=>{m.shared===this.b&&m.key===this.a&&(this.f=m.value)}),this.i=new I.$8g(()=>{const m=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const A of m.values())A.complete()}catch(A){for(const P of m.values())P.error(A)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,p){let E=this.f[R];return typeof E>"u"&&(E=p),E}update(R,p){this.f[R]=p;const E=this.h.get(R);if(E!==void 0)return E.p;const m=new I.$gh;return this.h.set(R,m),this.i.isScheduled()||this.i.schedule(),m.p}dispose(){this.g.dispose()}}e.$sdc=F;class f extends F{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,p){super(R.identifier.value,!0,p),this.j=R}}e.$tdc=f}),define(ke[274],Se([1,0,4,2]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rec=void 0;class f{constructor(R){this.c=R,this.a=new I.$Od,this.onDidSaveNotebookDocument=this.a.event,this.b=new I.$Od,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,p,E,m){const P=this.c.getNotebookDocument(F.URI.revive(R)).acceptModelChanged(p.value,E,m);this.b.fire(P)}$acceptDirtyStateChanged(R,p){this.c.getNotebookDocument(F.URI.revive(R)).acceptDirty(p)}$acceptModelSaved(R){const p=this.c.getNotebookDocument(F.URI.revive(R));this.a.fire(p.apiNotebook)}}e.$Rec=f}),define(ke[20],Se([1,0,5]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yM=e.$xM=void 0,e.$xM=(0,I.$Th)("IExtHostRpcService");class F{constructor(L){this.getProxy=L.getProxy.bind(L),this.set=L.set.bind(L),this.dispose=L.dispose.bind(L),this.assertRegistered=L.assertRegistered.bind(L),this.drain=L.drain.bind(L)}}e.$yM=F}),define(ke[275],Se([1,0,26,4]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Edc=void 0;class f{#e;constructor(R,p){this.b=new F.$Od,this.onDidChange=this.b.event,this.a=I.$0l.toKey(R.identifier),this.#e=p,this.#e.onDidChangePassword(E=>{E.extensionId===this.a&&this.b.fire({key:E.key})})}get(R){return this.#e.get(this.a,R)}store(R,p){return this.#e.store(this.a,R,p)}delete(R){return this.#e.delete(this.a,R)}}e.$Edc=f}),define(ke[67],Se([1,0,5]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bdc=e.$adc=void 0,e.$adc=(0,I.$Th)("IURITransformerService");class F{constructor(L){L?(this.transformIncoming=L.transformIncoming.bind(L),this.transformOutgoing=L.transformOutgoing.bind(L),this.transformOutgoingURI=L.transformOutgoingURI.bind(L),this.transformOutgoingScheme=L.transformOutgoingScheme.bind(L)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$bdc=F}),define(ke[276],Se([1,0,22]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$cb=e.$0cb=void 0;class F{constructor(){this.buffers=[]}add(E){let m=this.buffers.indexOf(E);return m<0&&(m=this.buffers.length,this.buffers.push(E)),m}}function f(p,E){if(E.serializeBuffersForPostMessage){const m=new F,P=JSON.stringify(p,(y,S)=>{if(S instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:m.add(S)};if(ArrayBuffer.isView(S)){const w=L(S);if(w)return{$$vscode_array_buffer_reference$$:!0,index:m.add(S.buffer),view:{type:w,byteLength:S.byteLength,byteOffset:S.byteOffset}}}return S}),g=m.buffers.map(y=>{const S=new Uint8Array(y);return I.$ce.wrap(S)});return{message:P,buffers:g}}else return{message:JSON.stringify(p),buffers:[]}}e.$0cb=f;function L(p){switch(p.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(p,E){const m=E.map(g=>{const y=new ArrayBuffer(g.byteLength);return new Uint8Array(y).set(g.buffer),y}),A=E.length?(g,y)=>{if(y&&typeof y=="object"&&y.$$vscode_array_buffer_reference$$){const S=y,{index:w}=S,c=m[w];if(S.view)switch(S.view.type){case 1:return new Int8Array(c,S.view.byteOffset,S.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(c,S.view.byteOffset,S.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(c,S.view.byteOffset,S.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(c,S.view.byteOffset,S.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(c,S.view.byteOffset,S.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(c,S.view.byteOffset,S.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(c,S.view.byteOffset,S.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(c,S.view.byteOffset,S.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(c,S.view.byteOffset,S.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(c,S.view.byteOffset,S.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(c,S.view.byteOffset,S.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return c}return y}:void 0;return{message:JSON.parse(p,A),arrayBuffers:m}}e.$$cb=R}),define(ke[277],Se([1,0,278,390,391,62,2,15,392]),function($e,e,I,F,f,L,R,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gfc=void 0;const m=!1;function A(n,o,a,t,r,d){const u=d.environment.useHostProxy,l=typeof u=="boolean"?u:!d.remote.isRemote,h={resolveProxy:$=>n.resolveProxy($),lookupProxyAuthorization:c.bind(void 0,t,r,o,{},d.remote.isRemote),getProxyURL:()=>o.getConfiguration("http").get("proxy"),getProxySupport:()=>o.getConfiguration("http").get("proxySupport")||"off",getSystemCertificatesV1:()=>g(o),getSystemCertificatesV2:()=>y(o),log:($,b,...v)=>{switch($){case E.LogLevel.Trace:t.trace(b,...v);break;case E.LogLevel.Debug:t.debug(b,...v);break;case E.LogLevel.Info:t.info(b,...v);break;case E.LogLevel.Warning:t.warn(b,...v);break;case E.LogLevel.Error:t.error(b,...v);break;case E.LogLevel.Critical:t.error(b,...v);break;case E.LogLevel.Off:break;default:C($,b,v);break}function C(N,z,...M){t.error("Unknown log level",N),t.error(z,...M)}},getLogLevel:()=>{const $=t.getLevel();switch($){case p.LogLevel.Trace:return E.LogLevel.Trace;case p.LogLevel.Debug:return E.LogLevel.Debug;case p.LogLevel.Info:return E.LogLevel.Info;case p.LogLevel.Warning:return E.LogLevel.Warning;case p.LogLevel.Error:return E.LogLevel.Error;case p.LogLevel.Off:return E.LogLevel.Off;default:return b($)}function b(v){return t.error("Unknown log level",v),E.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:l,addCertificates:[],env:process.env},k=(0,E.createProxyResolver)(h),D=P(h,k);return w(a,D)}e.$Gfc=A;function P(n,o){return{http:Object.assign(I,(0,E.createHttpPatch)(n,I,o)),https:Object.assign(F,(0,E.createHttpPatch)(n,F,o)),net:Object.assign(L,(0,E.createNetPatch)(n,L)),tls:Object.assign(f,(0,E.createTlsPatch)(n,f))}}function g(n){const o=n.getConfiguration("http");return!o.get("experimental.systemCertificatesV2",m)&&!!o.get("systemCertificates")}function y(n){const o=n.getConfiguration("http");return!!o.get("experimental.systemCertificatesV2",m)&&!!o.get("systemCertificates")}const S=new Map;function w(n,o){return n.getExtensionPathIndex().then(a=>{const t=globalThis._VSCODE_NODE_MODULES.module,r=t._load;t._load=function(u,l,h){if(u==="net")return o.net;if(u==="tls")return o.tls;if(u!=="http"&&u!=="https")return r.apply(this,arguments);const k=a.findSubstr(R.URI.file(l.filename));let D=S.get(k);if(D||S.set(k,D={}),!D[u]){const $=o[u];D[u]={...$}}return D[u]}})}async function c(n,o,a,t,r,d,u,l){const h=t[d];u&&(t[d]=u),n.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${d}`,`proxyAuthenticate:${u}`,`proxyAuthenticateCache:${h}`);const k=u||h,D=Array.isArray(k)?k:typeof k=="string"?[k]:[];if(i(o,D,r),D.some($=>/^(Negotiate|Kerberos)( |$)/i.test($))&&!l.kerberosRequested)try{l.kerberosRequested=!0;const $=await new Promise((z,M)=>{$e(["kerberos"],z,M)}),b=new URL(d),v=a.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${b.hostname}`:`HTTP@${b.hostname}`);return n.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${d}`,`spn:${v}`),"Negotiate "+await(await $.initializeClient(v)).step("")}catch($){n.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",$)}}let s=!1;function i(n,o,a){s||!o.length||(s=!0,n.$publicLog2("proxyAuthenticationRequest",{authenticationType:o.map(t=>t.split(" ")[0]).join(","),extensionHostType:a?"remote":"local"}))}}),define(ke[279],Se([1,0,131]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Er=void 0;function F(L){return{transformIncoming:R=>R.scheme==="vscode-remote"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="file"?{scheme:"vscode-local",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoing:R=>R.scheme==="file"?{scheme:"vscode-remote",authority:L,path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="vscode-local"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoingScheme:R=>R==="file"?"vscode-remote":R==="vscode-local"?"file":R}}function f(L){return new I.$Pm(F(L))}e.$Er=f}),define(ke[141],Se([1,0,226,18,2,3,5,38,31,17,43,180,39]),function($e,e,I,F,f,L,R,p,E,m,A,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xE=e.$wE=e.$vE=e.EditorsOrder=e.$uE=e.CloseDirection=e.$tE=e.$sE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$rE=e.$qE=e.$pE=e.$oE=e.$nE=e.$mE=e.$lE=e.$kE=e.EditorInputCapabilities=e.$jE=e.SaveReason=e.Verbosity=e.$iE=e.$hE=e.$gE=e.$fE=e.$eE=e.$dE=e.$cE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$bE=e.$aE=e.$_D=e.$$D=e.$0D=void 0,e.$0D={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$$D={id:"default",displayName:(0,I.localize)(0,null),providerDisplayName:(0,I.localize)(1,null)},e.$_D="workbench.editor.sidebysideEditor",e.$aE="workbench.editors.textDiffEditor",e.$bE="workbench.editors.binaryResourceDiffEditor";var y;(function(se){se[se.PROGRAMMATIC=1]="PROGRAMMATIC",se[se.USER=2]="USER",se[se.EDIT=3]="EDIT",se[se.NAVIGATION=4]="NAVIGATION",se[se.JUMP=5]="JUMP"})(y||(e.EditorPaneSelectionChangeReason=y={}));var S;(function(se){se[se.IDENTICAL=1]="IDENTICAL",se[se.SIMILAR=2]="SIMILAR",se[se.DIFFERENT=3]="DIFFERENT"})(S||(e.EditorPaneSelectionCompareResult=S={}));function w(se){const we=se;return!!we&&typeof we.getSelection=="function"&&!!we.onDidChangeSelection}e.$cE=w;function c(se,we,H){for(const U of H.visibleEditorPanes)if(U.group.id===we&&se.matches(U.input))return U.getViewState()}e.$dE=c;function s(se){if(h(se))return!1;const we=se;return f.URI.isUri(we?.resource)}e.$eE=s;function i(se){if(h(se))return!1;const we=se;return we?.original!==void 0&&we.modified!==void 0}e.$fE=i;function n(se){if(h(se)||i(se))return!1;const we=se;return we?.primary!==void 0&&we.secondary!==void 0}e.$gE=n;function o(se){if(h(se))return!1;const we=se;return we?we.resource===void 0||we.resource.scheme===m.Schemas.untitled||we.forceUntitled===!0:!1}e.$hE=o;function a(se){if(h(se))return!1;const we=se;return f.URI.isUri(we?.base?.resource)&&f.URI.isUri(we?.input1?.resource)&&f.URI.isUri(we?.input2?.resource)&&f.URI.isUri(we?.result?.resource)}e.$iE=a;var t;(function(se){se[se.SHORT=0]="SHORT",se[se.MEDIUM=1]="MEDIUM",se[se.LONG=2]="LONG"})(t||(e.Verbosity=t={}));var r;(function(se){se[se.EXPLICIT=1]="EXPLICIT",se[se.AUTO=2]="AUTO",se[se.FOCUS_CHANGE=3]="FOCUS_CHANGE",se[se.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(r||(e.SaveReason=r={}));class d{constructor(){this.a=new Map}registerSource(we,H){let U=this.a.get(we);return U||(U={source:we,label:H},this.a.set(we,U)),U.source}getSourceLabel(we){return this.a.get(we)?.label??we}}e.$jE=new d;var u;(function(se){se[se.None=0]="None",se[se.Readonly=2]="Readonly",se[se.Untitled=4]="Untitled",se[se.Singleton=8]="Singleton",se[se.RequiresTrust=16]="RequiresTrust",se[se.CanSplitInGroup=32]="CanSplitInGroup",se[se.ForceDescription=64]="ForceDescription",se[se.CanDropIntoEditor=128]="CanDropIntoEditor",se[se.MultipleEditors=256]="MultipleEditors",se[se.Scratchpad=512]="Scratchpad",se[se.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(u||(e.EditorInputCapabilities=u={}));class l extends L.$Rc{}e.$kE=l;function h(se){return se instanceof l}e.$lE=h;function k(se){const we=se;return f.URI.isUri(we?.preferredResource)}function D(se){const we=se;return h(we?.primary)&&h(we?.secondary)}e.$mE=D;function $(se){const we=se;return h(we?.modified)&&h(we?.original)}e.$nE=$;function b(se,we,H,U,ce){return Z(U,[(0,P.$Di)({id:"workbench.action.openLargeFile",label:(0,I.localize)(2,null),run:()=>{const Ee={...H,limits:{size:Number.MAX_VALUE}};se.openEditor(we,Ee)}}),(0,P.$Di)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,I.localize)(3,null),run:()=>ce.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:g.default.Warning})}e.$oE=b;function v(se){return h(se?.editor)}e.$pE=v;function C(se){const we=se;return v(se)&&we?.group!==void 0}e.$qE=C;function N(se){const we=se;return typeof we?.groupId=="number"&&h(we.editor)}e.$rE=N;var z;(function(se){se[se.UNKNOWN=0]="UNKNOWN",se[se.REPLACE=1]="REPLACE",se[se.MOVE=2]="MOVE",se[se.UNPIN=3]="UNPIN"})(z||(e.EditorCloseContext=z={}));var M;(function(se){se[se.GROUP_ACTIVE=0]="GROUP_ACTIVE",se[se.GROUP_INDEX=1]="GROUP_INDEX",se[se.GROUP_LABEL=2]="GROUP_LABEL",se[se.GROUP_LOCKED=3]="GROUP_LOCKED",se[se.EDITOR_OPEN=4]="EDITOR_OPEN",se[se.EDITOR_CLOSE=5]="EDITOR_CLOSE",se[se.EDITOR_MOVE=6]="EDITOR_MOVE",se[se.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",se[se.EDITOR_LABEL=8]="EDITOR_LABEL",se[se.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",se[se.EDITOR_PIN=10]="EDITOR_PIN",se[se.EDITOR_STICKY=11]="EDITOR_STICKY",se[se.EDITOR_DIRTY=12]="EDITOR_DIRTY",se[se.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(M||(e.GroupModelChangeKind=M={}));var O;(function(se){se[se.PRIMARY=1]="PRIMARY",se[se.SECONDARY=2]="SECONDARY",se[se.BOTH=3]="BOTH",se[se.ANY=4]="ANY"})(O||(e.SideBySideEditor=O={}));class j{getOriginalUri(we,H){if(!we)return;if(a(we))return e.$tE.getOriginalUri(we.result,H);if(H?.supportSideBySide){const{primary:ce,secondary:Ee}=this.a(we);if(ce&&Ee){if(H?.supportSideBySide===O.BOTH)return{primary:this.getOriginalUri(ce,{filterByScheme:H.filterByScheme}),secondary:this.getOriginalUri(Ee,{filterByScheme:H.filterByScheme})};if(H?.supportSideBySide===O.ANY)return this.getOriginalUri(ce,{filterByScheme:H.filterByScheme})??this.getOriginalUri(Ee,{filterByScheme:H.filterByScheme});we=H.supportSideBySide===O.PRIMARY?ce:Ee}}if(i(we)||n(we)||a(we))return;const U=k(we)?we.preferredResource:we.resource;return!U||!H||!H.filterByScheme?U:this.b(U,H.filterByScheme)}a(we){return D(we)||n(we)?{primary:we.primary,secondary:we.secondary}:$(we)||i(we)?{primary:we.modified,secondary:we.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(we,H){if(!we)return;if(a(we))return e.$tE.getCanonicalUri(we.result,H);if(H?.supportSideBySide){const{primary:ce,secondary:Ee}=this.a(we);if(ce&&Ee){if(H?.supportSideBySide===O.BOTH)return{primary:this.getCanonicalUri(ce,{filterByScheme:H.filterByScheme}),secondary:this.getCanonicalUri(Ee,{filterByScheme:H.filterByScheme})};if(H?.supportSideBySide===O.ANY)return this.getCanonicalUri(ce,{filterByScheme:H.filterByScheme})??this.getCanonicalUri(Ee,{filterByScheme:H.filterByScheme});we=H.supportSideBySide===O.PRIMARY?ce:Ee}}if(i(we)||n(we)||a(we))return;const U=we.resource;return!U||!H||!H.filterByScheme?U:this.b(U,H.filterByScheme)}b(we,H){if(Array.isArray(H)){if(H.some(U=>we.scheme===U))return we}else if(H===we.scheme)return we}}var T;(function(se){se[se.UNKNOWN=0]="UNKNOWN",se[se.KEYBOARD=1]="KEYBOARD",se[se.MOUSE=2]="MOUSE"})(T||(e.EditorCloseMethod=T={}));function V(se,we,H,U){if(!se.isSticky(we))return!1;switch(U.preventPinnedEditorClose){case"keyboardAndMouse":return H===T.MOUSE||H===T.KEYBOARD;case"mouse":return H===T.MOUSE;case"keyboard":return H===T.KEYBOARD}return!1}e.$sE=V,e.$tE=new j;var q;(function(se){se[se.LEFT=0]="LEFT",se[se.RIGHT=1]="RIGHT"})(q||(e.CloseDirection=q={}));class fe{constructor(){this.c=new Map,this.d=new Map}start(we){const H=this.a=we.get(R.$Sh);for(const[U,ce]of this.c)this.e(U,ce,H);this.c.clear()}e(we,H,U){const ce=U.createInstance(H);this.d.set(we,ce)}registerFileEditorFactory(we){if(this.b)throw new Error("Can only register one file editor factory.");this.b=we}getFileEditorFactory(){return(0,F.$Kf)(this.b)}registerEditorSerializer(we,H){if(this.c.has(we)||this.d.has(we))throw new Error(`A editor serializer with type ID '${we}' was already registered.`);return this.a?this.e(we,H,this.a):this.c.set(we,H),(0,L.$Pc)(()=>{this.c.delete(we),this.d.delete(we)})}getEditorSerializer(we){return this.d.get(typeof we=="string"?we:we.typeId)}}p.$kn.add(e.$0D.EditorFactory,new fe);async function ee(se,we,H){return!se||!se.length?[]:await Promise.all(se.map(async U=>{const ce=f.URI.revive(U.fileUri);if(!ce){H.info("Cannot resolve the path because it is not valid.",U);return}if(!await we.canHandleResource(ce)){H.info("Cannot resolve the path because it cannot be handled",U);return}let ne=U.exists,G=U.type;if(typeof ne!="boolean"||typeof G!="number")try{G=(await we.stat(ce)).isDirectory?E.FileType.Directory:E.FileType.Unknown,ne=!0}catch(ge){H.error(ge),ne=!1}if(!ne&&U.openOnlyIfExists){H.info("Cannot resolve the path because it does not exist",U);return}if(G===E.FileType.Directory){H.info("Cannot resolve the path because it is a directory",U);return}const J={...U.options,pinned:!0};return ne?{resource:ce,options:J}:{resource:ce,options:J,forceUntitled:!0}}))}e.$uE=ee;var Y;(function(se){se[se.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",se[se.SEQUENTIAL=1]="SEQUENTIAL"})(Y||(e.EditorsOrder=Y={}));function X(se){const we=se;if(!we)return!1;const H=we;if(H.modified)return X(H.modified);const U=we;return!!(U.contributionsState&&U.viewState&&Array.isArray(U.cursorState))}e.$vE=X;function ae(se){return(0,A.$Fi)(se)}e.$wE=ae;function Z(se,we,H){const U=(0,A.$Gi)(se,we);return U.forceMessage=H?.forceMessage,U.forceSeverity=H?.forceSeverity,U.allowDialog=H?.allowDialog,U}e.$xE=Z}),define(ke[280],Se([1,0,4,227,5,3,28,38,19,24,79,266]),function($e,e,I,F,f,L,R,p,E,m,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GE=e.$FE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$EE=e.$DE=e.ViewContentGroups=e.$CE=e.$BE=e.ViewContainerLocation=e.Extensions=e.$AE=e.$zE=e.$yE=void 0,e.$yE="views",e.$zE=(0,F.localize)(0,null),e.$AE=(0,P.$0v)("default-view-icon",A.$Yj.window,(0,F.localize)(1,null));var g;(function(r){r.ViewContainersRegistry="workbench.registry.view.containers",r.ViewsRegistry="workbench.registry.view"})(g||(e.Extensions=g={}));var y;(function(r){r[r.Sidebar=0]="Sidebar",r[r.Panel=1]="Panel",r[r.AuxiliaryBar=2]="AuxiliaryBar"})(y||(e.ViewContainerLocation=y={})),e.$BE=[0,1,2];function S(r){switch(r){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$CE=S;class w extends L.$Rc{constructor(){super(...arguments),this.c=this.B(new I.$Od),this.onDidRegister=this.c.event,this.f=this.B(new I.$Od),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,E.$Qb)([...this.g.values()])}registerViewContainer(d,u,l){const h=this.get(d.id);if(h)return h;const k=d;return k.openCommandActionDescriptor=l?.doNotRegisterOpenCommand?void 0:k.openCommandActionDescriptor??{id:k.id},(0,R.$wc)(this.g,u,[]).push(k),l?.isDefault&&this.h.push(k),this.c.fire({viewContainer:k,viewContainerLocation:u}),k}deregisterViewContainer(d){for(const u of this.g.keys()){const l=this.g.get(u),h=l?.indexOf(d);if(h!==-1){l?.splice(h,1),l.length===0&&this.g.delete(u),this.f.fire({viewContainer:d,viewContainerLocation:u});return}}}get(d){return this.all.filter(u=>u.id===d)[0]}getViewContainers(d){return[...this.g.get(d)||[]]}getViewContainerLocation(d){return[...this.g.keys()].filter(u=>this.getViewContainers(u).filter(l=>l?.id===d.id).length>0)[0]}getDefaultViewContainer(d){return this.h.find(u=>this.getViewContainerLocation(u)===d)}}p.$kn.add(g.ViewContainersRegistry,new w);var c;(function(r){r.Open="2_open",r.Debug="4_debug",r.SCM="5_scm",r.More="9_more"})(c||(e.ViewContentGroups=c={}));function s(r,d){const u=r.group??c.More,l=d.group??c.More;return u!==l?u.localeCompare(l):(r.order??5)-(d.order??5)}class i extends L.$Rc{constructor(){super(...arguments),this.c=this.B(new I.$Od),this.onViewsRegistered=this.c.event,this.f=this.B(new I.$Od),this.onViewsDeregistered=this.f.event,this.g=this.B(new I.$Od),this.onDidChangeContainer=this.g.event,this.h=this.B(new I.$Od),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Fc}registerViews(d,u){this.registerViews2([{views:d,viewContainer:u}])}registerViews2(d){d.forEach(({views:u,viewContainer:l})=>this.r(u,l)),this.c.fire(d)}deregisterViews(d,u){const l=this.s(d,u);l.length&&this.f.fire({views:l,viewContainer:u})}moveViews(d,u){for(const l of this.m.keys())if(l!==u){const h=this.s(d,l);h.length&&(this.r(h,u),this.g.fire({views:h,from:l,to:u}))}}getViews(d){return this.m.get(d)||[]}getView(d){for(const u of this.j){const l=(this.m.get(u)||[]).filter(h=>h.id===d)[0];if(l)return l}return null}getViewContainer(d){for(const u of this.j)if((this.m.get(u)||[]).filter(h=>h.id===d)[0])return u;return null}registerViewWelcomeContent(d,u){return this.n.add(d,u),this.h.fire(d),(0,L.$Pc)(()=>{this.n.delete(d,u),this.h.fire(d)})}registerViewWelcomeContent2(d,u){const l=new Map;for(const[h,k]of u)this.n.add(d,k),l.set(h,(0,L.$Pc)(()=>{this.n.delete(d,k),this.h.fire(d)}));return this.h.fire(d),l}getViewWelcomeContent(d){const u=[];return this.n.forEach(d,l=>u.push(l)),u.sort(s)}r(d,u){let l=this.m.get(u);l||(l=[],this.m.set(u,l),this.j.push(u));for(const h of d){if(this.getView(h.id)!==null)throw new Error((0,F.localize)(2,null,h.id));l.push(h)}}s(d,u){const l=this.m.get(u);if(!l)return[];const h=[],k=[];for(const D of l)d.includes(D)?h.push(D):k.push(D);return h.length&&(k.length?this.m.set(u,k):(this.m.delete(u),this.j.splice(this.j.indexOf(u),1))),h}}p.$kn.add(g.ViewsRegistry,new i),e.$DE=(0,f.$Th)("viewsService"),e.$EE=(0,f.$Th)("viewDescriptorService");var n;(function(r){r[r.Default=0]="Default",r[r.Expand=1]="Expand"})(n||(e.ViewVisibilityState=n={}));var o;(function(r){r[r.None=0]="None",r[r.Collapsed=1]="Collapsed",r[r.Expanded=2]="Expanded"})(o||(e.TreeItemCollapsibleState=o={}));class a{constructor(d,u){this.c=!1,this.d=!1,(0,m.$bn)(this,d),this.d=!!u,this.resolve=async l=>{if(u&&!this.c){const h=await u(l);h&&(this.tooltip=this.tooltip??h.tooltip,this.command=this.command??h.command)}l.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$FE=a;class t extends Error{constructor(d){super((0,F.localize)(3,null,d)),this.name="NoTreeViewError"}static is(d){return d.name==="NoTreeViewError"}}e.$GE=t}),define(ke[281],Se([1,0,2,29,5]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9E=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$8E=e.$7E=void 0;function L(m){return!!m&&typeof m=="object"&&"uri"in m&&m.uri instanceof I.URI&&"version"in m&&typeof m.version=="number"&&"ranges"in m&&Array.isArray(m.ranges)&&m.ranges.every(F.$xs.isIRange)}e.$7E=L;function R(m){return!!m&&typeof m=="object"&&"documents"in m&&Array.isArray(m.documents)&&m.documents.every(L)}e.$8E=R;var p;(function(m){m[m.Down=0]="Down",m[m.Up=1]="Up"})(p||(e.InteractiveSessionVoteDirection=p={}));var E;(function(m){m[m.Action=1]="Action",m[m.Toolbar=2]="Toolbar"})(E||(e.InteractiveSessionCopyKind=E={})),e.$9E=(0,f.$Th)("IChatService")}),define(ke[142],Se([1,0,4,10,228]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ddb=void 0;class L{constructor(){this.f=new Map,this.k=[],this.m=new I.$Od,this.n=new I.$Od,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(p){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=p}onEvent(p){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=p}onRequest(p){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=p}sendResponse(p){p.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${p.command}`)):this.s("response",p)}sendRequest(p,E,m,A){const P={command:p};if(E&&Object.keys(E).length>0&&(P.arguments=E),this.s("request",P),typeof A=="number"){const g=setTimeout(()=>{clearTimeout(g);const y=this.f.get(P.seq);if(y){this.f.delete(P.seq);const S={type:"response",seq:0,request_seq:P.seq,success:!1,command:p,message:(0,f.localize)(0,null,A,p)};y(S)}},A)}return m&&this.f.set(P.seq,m),P.seq}acceptMessage(p){this.j?this.j(p):(this.k.push(p),this.k.length===1&&this.q())}o(p,E){return p.type!=="event"||E.type!=="event"}async q(){let p;for(;this.k.length;){if((!p||this.o(this.k[0],p))&&await(0,F.$Vg)(0),p=this.k.shift(),!p)return;switch(p.type){case"event":this.i?.(p);break;case"request":this.g?.(p);break;case"response":{const E=p,m=this.f.get(E.request_seq);m&&(this.f.delete(E.request_seq),m(E));break}}}}s(p,E){E.type=p,E.seq=this.d++,this.sendMessage(E)}async u(){if(this.f.size===0)return Promise.resolve();const p=new Map;this.f.forEach((E,m)=>p.set(m,E)),await(0,F.$Vg)(500),p.forEach((E,m)=>{E({type:"response",seq:0,request_seq:m,success:!1,command:"canceled",message:"canceled"}),this.f.delete(m)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$Ddb=L}),define(ke[282],Se([1,0,229,45,5]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$jH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$iH=e.MemoryRangeType=e.$hH=e.State=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=void 0,e.$eG="workbench.view.debug",e.$fG="workbench.debug.variablesView",e.$gG="workbench.debug.watchExpressionsView",e.$hG="workbench.debug.callStackView",e.$iG="workbench.debug.loadedScriptsView",e.$jG="workbench.debug.breakPointsView",e.$kG="workbench.debug.disassemblyView",e.$lG="workbench.panel.repl",e.$mG="workbench.panel.repl.view",e.$nG=new F.$$i("debugType",void 0,{type:"string",description:I.localize(0,null)}),e.$oG=new F.$$i("debugConfigurationType",void 0,{type:"string",description:I.localize(1,null)}),e.$pG=new F.$$i("debugState","inactive",{type:"string",description:I.localize(2,null)}),e.$qG="debugUx",e.$rG=new F.$$i(e.$qG,"default",{type:"string",description:I.localize(3,null)}),e.$sG=new F.$$i("hasDebugged",!1,{type:"boolean",description:I.localize(4,null)}),e.$tG=new F.$$i("inDebugMode",!1,{type:"boolean",description:I.localize(5,null)}),e.$uG=new F.$$i("inDebugRepl",!1,{type:"boolean",description:I.localize(6,null)}),e.$vG=new F.$$i("breakpointWidgetVisible",!1,{type:"boolean",description:I.localize(7,null)}),e.$wG=new F.$$i("inBreakpointWidget",!1,{type:"boolean",description:I.localize(8,null)}),e.$xG=new F.$$i("breakpointsFocused",!0,{type:"boolean",description:I.localize(9,null)}),e.$yG=new F.$$i("watchExpressionsFocused",!0,{type:"boolean",description:I.localize(10,null)}),e.$zG=new F.$$i("watchExpressionsExist",!1,{type:"boolean",description:I.localize(11,null)}),e.$AG=new F.$$i("variablesFocused",!0,{type:"boolean",description:I.localize(12,null)}),e.$BG=new F.$$i("expressionSelected",!1,{type:"boolean",description:I.localize(13,null)}),e.$CG=new F.$$i("breakpointInputFocused",!1,{type:"boolean",description:I.localize(14,null)}),e.$DG=new F.$$i("callStackItemType",void 0,{type:"string",description:I.localize(15,null)}),e.$EG=new F.$$i("callStackSessionIsAttach",!1,{type:"boolean",description:I.localize(16,null)}),e.$FG=new F.$$i("callStackItemStopped",!1,{type:"boolean",description:I.localize(17,null)}),e.$GG=new F.$$i("callStackSessionHasOneThread",!1,{type:"boolean",description:I.localize(18,null)}),e.$HG=new F.$$i("watchItemType",void 0,{type:"string",description:I.localize(19,null)}),e.$IG=new F.$$i("canViewMemory",void 0,{type:"boolean",description:I.localize(20,null)}),e.$JG=new F.$$i("breakpointItemType",void 0,{type:"string",description:I.localize(21,null)}),e.$KG=new F.$$i("breakpointSupportsCondition",!1,{type:"boolean",description:I.localize(22,null)}),e.$LG=new F.$$i("loadedScriptsSupported",!1,{type:"boolean",description:I.localize(23,null)}),e.$MG=new F.$$i("loadedScriptsItemType",void 0,{type:"string",description:I.localize(24,null)}),e.$NG=new F.$$i("focusedSessionIsAttach",!1,{type:"boolean",description:I.localize(25,null)}),e.$OG=new F.$$i("focusedSessionIsNoDebug",!1,{type:"boolean",description:I.localize(26,null)}),e.$PG=new F.$$i("stepBackSupported",!1,{type:"boolean",description:I.localize(27,null)}),e.$QG=new F.$$i("restartFrameSupported",!1,{type:"boolean",description:I.localize(28,null)}),e.$RG=new F.$$i("stackFrameSupportsRestart",!1,{type:"boolean",description:I.localize(29,null)}),e.$SG=new F.$$i("jumpToCursorSupported",!1,{type:"boolean",description:I.localize(30,null)}),e.$TG=new F.$$i("stepIntoTargetsSupported",!1,{type:"boolean",description:I.localize(31,null)}),e.$UG=new F.$$i("breakpointsExist",!1,{type:"boolean",description:I.localize(32,null)}),e.$VG=new F.$$i("debuggersAvailable",!1,{type:"boolean",description:I.localize(33,null)}),e.$WG=new F.$$i("debugExtensionAvailable",!0,{type:"boolean",description:I.localize(34,null)}),e.$XG=new F.$$i("debugProtocolVariableMenuContext",void 0,{type:"string",description:I.localize(35,null)}),e.$YG=new F.$$i("debugSetVariableSupported",!1,{type:"boolean",description:I.localize(36,null)}),e.$ZG=new F.$$i("debugSetExpressionSupported",!1,{type:"boolean",description:I.localize(37,null)}),e.$1G=new F.$$i("breakWhenValueChangesSupported",!1,{type:"boolean",description:I.localize(38,null)}),e.$2G=new F.$$i("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:I.localize(39,null)}),e.$3G=new F.$$i("breakWhenValueIsReadSupported",!1,{type:"boolean",description:I.localize(40,null)}),e.$4G=new F.$$i("terminateDebuggeeSupported",!1,{type:"boolean",description:I.localize(41,null)}),e.$5G=new F.$$i("suspendDebuggeeSupported",!1,{type:"boolean",description:I.localize(42,null)}),e.$6G=new F.$$i("variableEvaluateNamePresent",!1,{type:"boolean",description:I.localize(43,null)}),e.$7G=new F.$$i("variableIsReadonly",!1,{type:"boolean",description:I.localize(44,null)}),e.$8G=new F.$$i("exceptionWidgetVisible",!1,{type:"boolean",description:I.localize(45,null)}),e.$9G=new F.$$i("multiSessionRepl",!1,{type:"boolean",description:I.localize(46,null)}),e.$0G=new F.$$i("multiSessionDebug",!1,{type:"boolean",description:I.localize(47,null)}),e.$$G=new F.$$i("disassembleRequestSupported",!1,{type:"boolean",description:I.localize(48,null)}),e.$_G=new F.$$i("disassemblyViewFocus",!1,{type:"boolean",description:I.localize(49,null)}),e.$aH=new F.$$i("languageSupportsDisassembleRequest",!1,{type:"boolean",description:I.localize(50,null)}),e.$bH=new F.$$i("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:I.localize(51,null)});const L=g=>I.localize(52,null,g);e.$cH=L,e.$dH="editor.contrib.debug",e.$eH="editor.contrib.breakpoint",e.$fH="debug",e.$gH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:I.localize(53,null)};var R;(function(g){g[g.Inactive=0]="Inactive",g[g.Initializing=1]="Initializing",g[g.Stopped=2]="Stopped",g[g.Running=3]="Running"})(R||(e.State=R={}));function p(g){switch(g){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$hH=p;var E;(function(g){g[g.Valid=0]="Valid",g[g.Unreadable=1]="Unreadable",g[g.Error=2]="Error"})(E||(e.MemoryRangeType=E={})),e.$iH="vscode-debug-memory";var m;(function(g){g[g.Initial=1]="Initial",g[g.Dynamic=2]="Dynamic"})(m||(e.DebugConfigurationProviderTriggerKind=m={}));var A;(function(g){g.UnverifiedBreakpoints="unverifiedBreakpoints"})(A||(e.DebuggerString=A={})),e.$jH=(0,f.$Th)("debugService");var P;(function(g){g[g.CONDITION=0]="CONDITION",g[g.HIT_COUNT=1]="HIT_COUNT",g[g.LOG_MESSAGE=2]="LOG_MESSAGE"})(P||(e.BreakpointWidgetContext=P={}))}),define(ke[283],Se([1,0,13,2,16,24,17,29,21,19]),function($e,e,I,F,f,L,R,p,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RF=e.$QF=e.$PF=e.$OF=e.$NF=e.$MF=e.$LF=e.$KF=e.$JF=e.$IF=e.$HF=e.$GF=e.$FF=void 0;const A=/{([^}]+)}/g;function P(D,$,b){return D.replace(A,function(v,C){return $&&C.length>0&&C[0]!=="_"?v:b&&b.hasOwnProperty(C)?b[C]:v})}e.$FF=P;function g(D){const $={};for(const b of Object.keys(D))b.startsWith("!")||($[b]=D[b]);return $}e.$GF=g;function y(D){return D.configuration.request==="attach"&&!S(D)&&(!D.parentSession||y(D.parentSession))}e.$HF=y;function S(D){let $=D.configuration.type;if($)return $==="vslsShare"&&($=D.configuration.adapterProxy.configuration.type),(0,I.$3e)($,"extensionhost")||(0,I.$3e)($,"pwa-extensionhost")?D:D.parentSession?S(D.parentSession):void 0}e.$IF=S;function w(D){return D.type&&(D.label||D.program||D.runtime)}e.$JF=w;function c(D,$,b){let v,C=0;const N=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let z=null;for(;z=N.exec(D);){const M=z.index+1,O=M+z[0].length;if(M<=$&&O>=b){v=z[0],C=M;break}}if(v){const M=/\w+/g;let O=null;for(;(O=M.exec(v))&&!(O.index+1+C+O[0].length>=b););O&&(v=v.substring(0,M.lastIndex))}return v?{start:C,end:C+v.length-1}:{start:0,end:0}}e.$KF=c;async function s(D,$,b,v){if(D.evaluatableExpressionProvider.has($)){const C=D.evaluatableExpressionProvider.ordered($),N=(0,m.$Gb)(await Promise.all(C.map(async z=>{try{return await z.provideEvaluatableExpression($,b,v??E.CancellationToken.None)}catch{return}})));if(N.length>0){let z=N[0].expression;const M=N[0].range;return z||(z=$.getLineContent(b.lineNumber).substring(M.startColumn-1,M.endColumn-1)),{range:M,matchingExpression:z}}}else{const C=$.getLineContent(b.lineNumber),{start:N,end:z}=c(C,b.column,b.column),M=C.substring(N-1,z);return{matchingExpression:M,range:new p.$xs(b.lineNumber,N,b.lineNumber,N+M.length)}}return null}e.$LF=s;const i=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(D){return!!(D&&D.match(i))}e.$MF=n;function o(D){if(typeof D.path=="string"&&!(typeof D.sourceReference=="number"&&D.sourceReference>0)){if(n(D.path))return F.URI.parse(D.path);if((0,f.$hc)(D.path))return F.URI.file(D.path)}return D.path}function a(D){if(typeof D.path=="object"){const $=F.URI.revive(D.path);if($)return $.scheme===R.Schemas.file?$.fsPath:$.toString()}return D.path}function t(D,$){const b=$?o:a,v=(0,L.$$m)(D);return d(v,(C,N)=>{C&&N&&(N.path=b(N))}),v}e.$NF=t;function r(D,$){const b=$?o:a,v=(0,L.$$m)(D);return d(v,(C,N)=>{!C&&N&&(N.path=b(N))}),v}e.$OF=r;function d(D,$){switch(D.type){case"event":{const b=D;switch(b.event){case"output":$(!1,b.body.source);break;case"loadedSource":$(!1,b.body.source);break;case"breakpoint":$(!1,b.body.breakpoint.source);break;default:break}break}case"request":{const b=D;switch(b.command){case"setBreakpoints":$(!0,b.arguments.source);break;case"breakpointLocations":$(!0,b.arguments.source);break;case"source":$(!0,b.arguments.source);break;case"gotoTargets":$(!0,b.arguments.source);break;case"launchVSCode":b.arguments.args.forEach(v=>$(!1,v));break;default:break}break}case"response":{const b=D;if(b.success&&b.body)switch(b.command){case"stackTrace":b.body.stackFrames.forEach(v=>$(!1,v.source));break;case"loadedSources":b.body.sources.forEach(v=>$(!1,v));break;case"scopes":b.body.scopes.forEach(v=>$(!1,v.source));break;case"setFunctionBreakpoints":b.body.breakpoints.forEach(v=>$(!1,v.source));break;case"setBreakpoints":b.body.breakpoints.forEach(v=>$(!1,v.source));break;case"disassemble":b.body?.instructions.forEach(C=>$(!1,C.location));break;default:break}break}}}function u(D){return D.filter($=>!$.presentation?.hidden).sort(($,b)=>$.presentation?b.presentation?$.presentation.group?b.presentation.group?$.presentation.group!==b.presentation.group?$.presentation.group.localeCompare(b.presentation.group):l($.presentation.order,b.presentation.order):-1:b.presentation.group?1:l($.presentation.order,b.presentation.order):-1:b.presentation?1:0)}e.$PF=u;function l(D,$){return typeof D!="number"?typeof $!="number"?0:1:typeof $!="number"?-1:D-$}async function h(D,$){const b=D.getValue("debug.saveBeforeStart",{overrideIdentifier:$.activeTextEditorLanguageId});if(b!=="none"&&(await $.saveAll(),b==="allEditorsInActiveGroup")){const v=$.activeEditorPane;v&&v.input.resource?.scheme===R.Schemas.untitled&&await $.save({editor:v.input,groupId:v.group.id})}await D.reloadConfiguration()}e.$QF=h;const k=(D,$)=>!D||!$?D===$:D.name===$.name&&D.path===$.path&&D.sourceReference===$.sourceReference;e.$RF=k}),define(ke[284],Se([1,0,50,62,24,16,12,13,30,230,142]),function($e,e,I,F,f,L,R,p,E,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ifc=e.$hfc=e.$gfc=e.$ffc=e.$efc=void 0;class P extends A.$Ddb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.l=/: */}constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(s,i){this.p=i,this.r=Buffer.allocUnsafe(0),this.t=-1,s.on("data",n=>this.w(n))}sendMessage(s){if(this.p){const i=JSON.stringify(s);this.p.write(`Content-Length: ${Buffer.byteLength(i,"utf8")}${P.a}${i}`,"utf8")}}w(s){for(this.r=Buffer.concat([this.r,s]);;){if(this.t>=0){if(this.r.length>=this.t){const i=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,i.length>0)try{this.acceptMessage(JSON.parse(i))}catch(n){this.m.fire(new Error((n.message||n)+`
`+i))}continue}}else{const i=this.r.indexOf(P.a);if(i!==-1){const o=this.r.toString("utf8",0,i).split(P.b);for(const a of o){const t=a.split(P.l);t[0]==="Content-Length"&&(this.t=Number(t[1]))}this.r=this.r.slice(i+P.a.length);continue}}break}}}e.$efc=P;class g extends P{startSession(){return new Promise((s,i)=>{let n=!1;this.x=this.y(()=>{this.v(this.x,this.x),s(),n=!0}),this.x.on("close",()=>{n?this.m.fire(new Error("connection closed")):i(new Error("connection closed"))}),this.x.on("error",o=>{n?this.m.fire(o):i(o)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.$ffc=g;class y extends g{constructor(s){super(),this.z=s}y(s){return F.createConnection(this.z.port,this.z.host||"127.0.0.1",s)}}e.$gfc=y;class S extends g{constructor(s){super(),this.z=s}y(s){return F.createConnection(this.z.path,s)}}e.$hfc=S;class w extends P{constructor(s,i){super(),this.y=s,this.z=i}async startSession(){const s=this.y.command,i=this.y.args,n=this.y.options||{};try{if(s)if(L.$hc(s)){if(!await E.Promises.exists(s))throw new Error(m.localize(0,null,s))}else s.indexOf("/")<0&&s.indexOf("\\")<0;else throw new Error(m.localize(1,null,this.z));let o=process.env;if(n.env&&Object.keys(n.env).length>0&&(o=f.$bn(f.$$m(process.env),n.env)),s==="node")if(Array.isArray(i)&&i.length>0){const a=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:o,execArgv:a?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};n.cwd&&(t.cwd=n.cwd);const r=I.fork(i[0],i.slice(1),t);if(!r.pid)throw new Error(m.localize(2,null,i[0]));this.x=r}else throw new Error(m.localize(3,null));else{const a={env:o};n.cwd&&(a.cwd=n.cwd),this.x=I.spawn(s,i,a)}this.x.on("error",a=>{this.m.fire(a)}),this.x.on("exit",(a,t)=>{this.n.fire(a)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",a=>{this.m.fire(a)}),this.x.stdin.on("error",a=>{this.m.fire(a)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(o){this.m.fire(o)}}async stopSession(){return this.x?(await this.u(),R.$j?new Promise((s,i)=>{const n=I.exec(`taskkill /F /T /PID ${this.x.pid}`,function(o,a,t){if(o)return i(o)});n.on("exit",s),n.on("error",i)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(s,i){if(!s)return;const n=Object.create(null);s.runtime&&(s.runtime.indexOf("./")===0?n.runtime=L.$ic(i,s.runtime):n.runtime=s.runtime),s.runtimeArgs&&(n.runtimeArgs=s.runtimeArgs),s.program&&(L.$hc(s.program)?n.program=s.program:n.program=L.$ic(i,s.program)),s.args&&(n.args=s.args);const o=s;return o.win&&(n.win=w.A(o.win,i)),o.winx86&&(n.winx86=w.A(o.winx86,i)),o.windows&&(n.windows=w.A(o.windows,i)),o.osx&&(n.osx=w.A(o.osx,i)),o.linux&&(n.linux=w.A(o.linux,i)),n}static platformAdapterExecutable(s,i){let n=Object.create(null);i=i.toLowerCase();for(const u of s)if(u.contributes){const l=u.contributes.debuggers;l&&l.length>0&&l.filter(h=>typeof h.type=="string"&&p.$3e(h.type,i)).forEach(h=>{const k=w.A(h,u.extensionLocation.fsPath);n=f.$bn(n,k,u.isBuiltin)})}let o;R.$j&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?o=n.winx86||n.win||n.windows:R.$j?o=n.win||n.windows:R.$k?o=n.osx:R.$l&&(o=n.linux),o=o||n;const a=o.program||n.program,t=o.args||n.args,r=o.runtime||n.runtime,d=o.runtimeArgs||n.runtimeArgs;if(r)return{type:"executable",command:r,args:(d||[]).concat(typeof a=="string"?[a]:[]).concat(t||[])};if(a)return{type:"executable",command:a,args:t||[]}}}e.$ifc=w}),define(ke[285],Se([1,0,50,33,12]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kfc=e.$jfc=void 0;function L(m,A){return new Promise((P,g)=>{let y="";const S=I.spawn(m,A);S.pid&&S.stdout.on("data",w=>{y+=w.toString()}),S.on("error",w=>{g(w)}),S.on("close",w=>{P(y)})})}async function R(m){if(m)if(f.$j){const A=await new Promise((P,g)=>{$e(["@vscode/windows-process-tree"],P,g)});return new Promise(P=>{A.getProcessTree(m,g=>{P(!!g&&g.children.length>0)})})}else return L("/usr/bin/pgrep",["-lP",String(m)]).then(A=>{const P=A.trim();return!(P.length===0||P.indexOf(" tmux")>=0)},A=>!0);return Promise.resolve(!0)}e.$jfc=R;var p;(function(m){m[m.cmd=0]="cmd",m[m.powershell=1]="powershell",m[m.bash=2]="bash"})(p||(p={}));function E(m,A,P,g,y){m=m.trim().toLowerCase();let S;m.indexOf("powershell")>=0||m.indexOf("pwsh")>=0?S=1:m.indexOf("cmd.exe")>=0?S=0:m.indexOf("bash")>=0?S=2:f.$j?S=0:S=2;let w,c=" ";switch(S){case 1:if(w=s=>(s=s.replace(/\'/g,"''"),s.length>0&&s.charAt(s.length-1)==="\\"?`'${s}\\'`:`'${s}'`),g){const s=(0,F.$4f)(g);s&&(c+=`${s}:; `),c+=`cd ${w(g)}; `}if(y)for(const s in y){const i=y[s];i===null?c+=`Remove-Item env:${s}; `:c+=`\${env:${s}}='${i}'; `}if(A.length>0){const s=A.shift(),i=P?s:w(s);c+=i[0]==="'"?`& ${i} `:`${i} `;for(const n of A)c+=n==="<"||n===">"||P?n:w(n),c+=" "}break;case 0:if(w=s=>(s=s.replace(/\"/g,'""'),s=s.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(i=>s.includes(i))||s.length===0?`"${s}"`:s),g){const s=(0,F.$4f)(g);s&&(c+=`${s}: && `),c+=`cd ${w(g)} && `}if(y){c+='cmd /C "';for(const s in y){let i=y[s];i===null?c+=`set "${s}=" && `:(i=i.replace(/[&^|<>]/g,n=>`^${n}`),c+=`set "${s}=${i}" && `)}}for(const s of A)c+=s==="<"||s===">"||P?s:w(s),c+=" ";y&&(c+='"');break;case 2:{w=i=>(i=i.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),i.length===0?'""':i);const s=i=>/[^\w@%\/+=,.:^-]/.test(i)?`'${i.replace(/'/g,"'\\''")}'`:i;if(g&&(c+=`cd ${w(g)} ; `),y){c+="/usr/bin/env";for(const i in y){const n=y[i];n===null?c+=` -u ${s(i)}`:c+=` ${s(`${i}=${n}`)}`}c+=" "}for(const i of A)c+=i==="<"||i===">"||P?i:w(i),c+=" ";break}}return c}e.$kfc=E}),define(ke[111],Se([1,0,22,34,51,100,17,16,12,45]),function($e,e,I,F,f,L,R,p,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CI=e.$BI=e.$AI=e.$zI=e.CellStatusbarAlignment=e.$yI=e.$xI=e.$wI=e.NotebookEditorPriority=e.$vI=e.$uI=e.$tI=e.$sI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$rI=e.$qI=e.$pI=e.$oI=e.CellKind=e.$nI=e.$mI=e.$lI=void 0,e.$lI="workbench.editor.notebook",e.$mI="workbench.editor.notebookTextDiffEditor",e.$nI="workbench.editor.interactive";var A;(function(T){T[T.Markup=1]="Markup",T[T.Code=2]="Code"})(A||(e.CellKind=A={})),e.$oI=["application/json","application/javascript","text/html","image/svg+xml",L.$Tr.latex,L.$Tr.markdown,"image/png","image/jpeg",L.$Tr.text],e.$pI=[L.$Tr.latex,L.$Tr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",L.$Tr.text],e.$qI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$rI="_notAvailable";var P;(function(T){T[T.Running=1]="Running",T[T.Idle=2]="Idle"})(P||(e.NotebookRunState=P={}));var g;(function(T){T[T.Unconfirmed=1]="Unconfirmed",T[T.Pending=2]="Pending",T[T.Executing=3]="Executing"})(g||(e.NotebookCellExecutionState=g={}));var y;(function(T){T[T.Unconfirmed=1]="Unconfirmed",T[T.Pending=2]="Pending",T[T.Executing=3]="Executing"})(y||(e.NotebookExecutionState=y={}));var S;(function(T){T[T.WithHardKernelDependency=0]="WithHardKernelDependency",T[T.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",T[T.Pure=2]="Pure",T[T.Never=3]="Never"})(S||(e.NotebookRendererMatch=S={}));var w;(function(T){T.Always="always",T.Never="never",T.Optional="optional"})(w||(e.RendererMessagingSpec=w={}));var c;(function(T){T[T.ModelChange=1]="ModelChange",T[T.Move=2]="Move",T[T.ChangeCellLanguage=5]="ChangeCellLanguage",T[T.Initialize=6]="Initialize",T[T.ChangeCellMetadata=7]="ChangeCellMetadata",T[T.Output=8]="Output",T[T.OutputItem=9]="OutputItem",T[T.ChangeCellContent=10]="ChangeCellContent",T[T.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",T[T.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",T[T.ChangeCellMime=13]="ChangeCellMime",T[T.Unknown=100]="Unknown"})(c||(e.NotebookCellsChangeType=c={}));var s;(function(T){T[T.Handle=0]="Handle",T[T.Index=1]="Index"})(s||(e.SelectionStateType=s={}));var i;(function(T){T[T.Replace=1]="Replace",T[T.Output=2]="Output",T[T.Metadata=3]="Metadata",T[T.CellLanguage=4]="CellLanguage",T[T.DocumentMetadata=5]="DocumentMetadata",T[T.Move=6]="Move",T[T.OutputItems=7]="OutputItems",T[T.PartialMetadata=8]="PartialMetadata",T[T.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var n;(function(T){T.scheme=R.Schemas.vscodeNotebookCell;const V=["W","X","Y","Z","a","b","c","d","e","f"],q=new RegExp(`^[${V.join("")}]+`),fe=7;function ee(we,H){const U=H.toString(fe),Ee=`${U.length<V.length?V[U.length-1]:"z"}${U}s${(0,I.$we)(I.$ce.fromString(we.scheme),!0,!0)}`;return we.with({scheme:T.scheme,fragment:Ee})}T.generate=ee;function Y(we){if(we.scheme!==T.scheme)return;const H=we.fragment.indexOf("s");if(H<0)return;const U=parseInt(we.fragment.substring(0,H).replace(q,""),fe),ce=(0,I.$ve)(we.fragment.substring(H+1)).toString();if(!isNaN(U))return{handle:U,notebook:we.with({scheme:ce,fragment:null})}}T.parse=Y;function X(we,H){return we.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${H??""},${we.scheme!==R.Schemas.file?we.scheme:""}`})}T.generateCellOutputUri=X;function ae(we){if(we.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const H=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(we.fragment);if(!H)return;const U=H[1]&&H[1]!==""?H[1]:void 0,ce=H[2];return{outputId:U,notebook:we.with({scheme:ce||R.Schemas.file,fragment:null})}}T.parseCellOutputUri=ae;function Z(we,H,U){return T.generate(we,H).with({scheme:U})}T.generateCellPropertyUri=Z;function se(we,H){if(we.scheme===H)return T.parse(we.with({scheme:T.scheme}))}T.parseCellPropertyUri=se})(n||(e.CellUri=n={}));const o=T=>E.$j?T.replace(/\//g,"\\"):T;class a{constructor(V=[],q=e.$oI){this.e=q,this.d=[...new Set(V)].map(fe=>({pattern:fe,matches:F.$Aj(o(fe))}))}sort(V){const q=new Map(f.Iterable.map(V,ee=>[ee,o(ee)]));let fe=[];for(const{matches:ee}of this.d)for(const[Y,X]of q)if(ee(X)){fe.push(Y),q.delete(Y);break}return q.size&&(fe=fe.concat([...q.keys()].sort((ee,Y)=>this.e.indexOf(ee)-this.e.indexOf(Y)))),fe}prioritize(V,q){const fe=this.f(V);if(fe===-1){this.d.unshift({pattern:V,matches:F.$Aj(o(V))});return}const ee=new Set(q.map(X=>this.f(X,fe)));ee.delete(-1);const Y=Array.from(ee).sort();this.d.splice(fe+1,0,...Y.map(X=>this.d[X]));for(let X=Y.length-1;X>=0;X--)this.d.splice(Y[X],1)}toArray(){return this.d.map(V=>V.pattern)}f(V,q=this.d.length){const fe=o(V);for(let ee=0;ee<q;ee++)if(this.d[ee].matches(fe))return ee;return-1}}e.$sI=a;function t(T,V,q,fe=(ee,Y)=>ee===Y){const ee=[];function Y(Z,se,we){if(se===0&&we.length===0)return;const H=ee[ee.length-1];H&&H.start+H.deleteCount===Z?(H.deleteCount+=se,H.toInsert.push(...we)):ee.push({start:Z,deleteCount:se,toInsert:we})}let X=0,ae=0;for(;;){if(X===T.length){Y(X,0,V.slice(ae));break}if(ae===V.length){Y(X,T.length-X,[]);break}const Z=T[X],se=V[ae];if(fe(Z,se)){X+=1,ae+=1;continue}q(se)?(Y(X,1,[]),X+=1):(Y(X,0,[se]),ae+=1)}return ee}e.$tI=t,e.$uI=new m.$$i("notebookEditorCursorAtBoundary","none"),e.$vI=new m.$$i("notebookEditorCursorAtLineBoundary","none");var r;(function(T){T.default="default",T.option="option"})(r||(e.NotebookEditorPriority=r={}));function d(T){const V=T;return!!((typeof V.include=="string"||F.$Bj(V.include))&&(typeof V.exclude=="string"||F.$Bj(V.exclude)))}e.$wI=d;function u(T,V,q){if(Array.isArray(T.viewType)&&T.viewType.indexOf(V)>=0||T.viewType===V)return!0;if(T.filenamePattern){const fe=d(T.filenamePattern)?T.filenamePattern.include:T.filenamePattern,ee=d(T.filenamePattern)?T.filenamePattern.exclude:void 0;if(F.$zj(fe,(0,p.$mc)(q.fsPath).toLowerCase()))return!(ee&&F.$zj(ee,(0,p.$mc)(q.fsPath).toLowerCase()))}return!1}e.$xI=u,e.$yI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell"};var l;(function(T){T[T.Left=1]="Left",T[T.Right=2]="Right"})(l||(e.CellStatusbarAlignment=l={}));class h{static{this.d="notebook/"}static create(V){return`${h.d}${V}`}static parse(V){if(V.startsWith(h.d))return V.substring(h.d.length)}}e.$zI=h;function k(T){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(T)}e.$AI=k;const D=new TextDecoder;function $(T){const V=[];let q=!1;for(const X of T)(V.length===0||q)&&(V.push(X),q=!0);let fe=C(V);const ee=I.$ce.concat(V.map(X=>I.$ce.wrap(X))),Y=j(ee);return fe=fe||Y.byteLength!==ee.byteLength,{data:Y,didCompression:fe}}e.$BI=$,e.$CI=`${String.fromCharCode(27)}[A`;const b=e.$CI.split("").map(T=>T.charCodeAt(0)),v=10;function C(T){let V=!1;return T.forEach((q,fe)=>{if(fe===0||q.length<e.$CI.length)return;const ee=T[fe-1],Y=q.subarray(0,e.$CI.length);if(Y[0]===b[0]&&Y[1]===b[1]&&Y[2]===b[2]){const X=ee.lastIndexOf(v);if(X===-1)return;V=!0,T[fe-1]=ee.subarray(0,X),T[fe]=q.subarray(e.$CI.length)}}),V}function N(T){let V=T;do T=V,V=T.replace(/[^\n]\x08/gm,"");while(V.length<T.length);return T}function z(T){for(T=T.replace(/\r+\n/gm,`
`);T.search(/\r[^$]/g)>-1;){const V=T.match(/^(.*)\r+/m)[1];let q=T.match(/\r+(.*)$/m)[1];q=q+V.slice(q.length,V.length),T=T.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,q)}return T}const M="\b".charCodeAt(0),O="\r".charCodeAt(0);function j(T){return!T.buffer.includes(M)&&!T.buffer.includes(O)?T:I.$ce.fromString(z(N(D.decode(T.buffer))))}}),define(ke[7],Se([1,0,19,11,81,28,100,13,18,2,32,26,31,65,111]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,S){"use strict";var w,c,s,i,n,o,a,t,r,d,u,l,h,k,D,$,b,v;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$mM=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$lM=e.$kM=e.$jM=e.$iM=e.$hM=e.$gM=e.$fM=e.$eM=e.$dM=e.$cM=e.$bM=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$aM=e.$_L=e.$$L=e.$0L=e.$9L=e.$8L=e.$7L=e.$6L=e.TestRunProfileKind=e.TestResultState=e.$5L=e.$4L=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$3L=e.$2L=e.$1L=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$ZL=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$YL=e.$XL=e.$WL=e.$VL=e.$UL=e.ColorThemeKind=e.$TL=e.$SL=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$RL=e.DebugConsoleMode=e.$QL=e.$PL=e.$OL=e.$NL=e.$ML=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$LL=e.$KL=e.FileChangeType=e.$JL=e.$IL=e.$HL=e.$GL=e.InlineCompletionTriggerKind=e.$FL=e.$EL=e.$DL=e.$CL=e.$BL=e.$AL=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=e.$uL=e.$tL=e.ConfigurationTarget=e.$sL=e.$rL=e.$qL=e.$pL=e.$oL=e.$nL=e.$mL=e.$lL=e.$kL=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$jL=e.ViewBadge=e.ProgressLocation=e.$iL=e.$hL=e.TaskScope=e.ShellQuoting=e.$gL=e.$fL=e.$eL=e.TaskPanelKind=e.TaskRevealKind=e.$dL=e.TerminalLocation=e.$cL=e.$bL=e.$aL=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$_K=e.$$K=e.$0K=e.$9K=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$8K=e.StatusBarAlignment=e.ViewColumn=e.$7K=e.$6K=e.$5K=e.$4K=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$3K=e.$2K=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$1K=e.$ZK=e.$YK=e.$XK=e.$WK=e.LanguageStatusSeverity=e.$VK=e.$UK=e.$TK=e.$SK=e.$RK=e.$QK=e.CodeActionTriggerKind=e.$PK=e.$OK=e.SymbolTag=e.SymbolKind=e.$NK=e.DocumentHighlightKind=e.$MK=e.$LK=e.$KK=e.$JK=e.DiagnosticSeverity=e.DiagnosticTag=e.$IK=e.$HK=e.FileEditType=e.$GK=e.$FK=e.$EK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$DK=e.$CK=e.$BK=e.$AK=e.$zK=e.$yK=e.$xK=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function C(K){return Object.assign(K,{apply:function(...ve){if(ve.length===0)return Reflect.construct(K,[]);{const Le=ve.length===1?[]:ve[1];return Reflect.construct(K,Le,ve[0].constructor)}},call:function(...ve){if(ve.length===0)return Reflect.construct(K,[]);{const[Le,...Qe]=ve;return Reflect.construct(K,Qe,Le.constructor)}}})}var N;(function(K){K[K.Top=0]="Top",K[K.Bottom=1]="Bottom"})(N||(e.TerminalOutputAnchor=N={}));var z;(function(K){K[K.TerminalCommand=0]="TerminalCommand",K[K.Opener=1]="Opener",K[K.Command=3]="Command"})(z||(e.TerminalQuickFixType=z={}));let M=w=class{static from(...W){let ve=W;return new w(function(){if(ve){for(const Le of ve)Le&&typeof Le.dispose=="function"&&Le.dispose();ve=void 0}})}#e;constructor(W){this.#e=W}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$xK=M,e.$xK=M=w=He([C],M);let O=c=class{static Min(...W){if(W.length===0)throw new TypeError;let ve=W[0];for(let Le=1;Le<W.length;Le++){const Qe=W[Le];Qe.isBefore(ve)&&(ve=Qe)}return ve}static Max(...W){if(W.length===0)throw new TypeError;let ve=W[0];for(let Le=1;Le<W.length;Le++){const Qe=W[Le];Qe.isAfter(ve)&&(ve=Qe)}return ve}static isPosition(W){if(!W)return!1;if(W instanceof c)return!0;const{line:ve,character:Le}=W;return typeof ve=="number"&&typeof Le=="number"}static of(W){if(W instanceof c)return W;if(this.isPosition(W))return new c(W.line,W.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(W,ve){if(W<0)throw(0,F.$6)("line must be non-negative");if(ve<0)throw(0,F.$6)("character must be non-negative");this.c=W,this.e=ve}isBefore(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<W.e}isBeforeOrEqual(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<=W.e}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this.c===W.c&&this.e===W.e}compareTo(W){return this.c<W.c?-1:this.c>W.line?1:this.e<W.e?-1:this.e>W.e?1:0}translate(W,ve=0){if(W===null||ve===null)throw(0,F.$6)();let Le;return typeof W>"u"?Le=0:typeof W=="number"?Le=W:(Le=typeof W.lineDelta=="number"?W.lineDelta:0,ve=typeof W.characterDelta=="number"?W.characterDelta:0),Le===0&&ve===0?this:new c(this.line+Le,this.character+ve)}with(W,ve=this.character){if(W===null||ve===null)throw(0,F.$6)();let Le;return typeof W>"u"?Le=this.line:typeof W=="number"?Le=W:(Le=typeof W.line=="number"?W.line:this.line,ve=typeof W.character=="number"?W.character:this.character),Le===this.line&&ve===this.character?this:new c(Le,ve)}toJSON(){return{line:this.line,character:this.character}}};e.$yK=O,e.$yK=O=c=He([C],O);let j=s=class{static isRange(W){return W instanceof s?!0:W?O.isPosition(W.start)&&O.isPosition(W.end):!1}static of(W){if(W instanceof s)return W;if(this.isRange(W))return new s(W.start,W.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(W,ve,Le,Qe){let et,ot;if(typeof W=="number"&&typeof ve=="number"&&typeof Le=="number"&&typeof Qe=="number"?(et=new O(W,ve),ot=new O(Le,Qe)):O.isPosition(W)&&O.isPosition(ve)&&(et=O.of(W),ot=O.of(ve)),!et||!ot)throw new Error("Invalid arguments");et.isBefore(ot)?(this.c=et,this.e=ot):(this.c=ot,this.e=et)}contains(W){return s.isRange(W)?this.contains(W.start)&&this.contains(W.end):O.isPosition(W)?!(O.of(W).isBefore(this.c)||this.e.isBefore(W)):!1}isEqual(W){return this.c.isEqual(W.c)&&this.e.isEqual(W.e)}intersection(W){const ve=O.Max(W.start,this.c),Le=O.Min(W.end,this.e);if(!ve.isAfter(Le))return new s(ve,Le)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const ve=O.Min(W.start,this.c),Le=O.Max(W.end,this.end);return new s(ve,Le)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(W,ve=this.end){if(W===null||ve===null)throw(0,F.$6)();let Le;return W?O.isPosition(W)?Le=W:(Le=W.start||this.start,ve=W.end||this.end):Le=this.start,Le.isEqual(this.c)&&ve.isEqual(this.end)?this:new s(Le,ve)}toJSON(){return[this.start,this.end]}};e.$zK=j,e.$zK=j=s=He([C],j);let T=i=class extends j{static isSelection(W){return W instanceof i?!0:W?j.isRange(W)&&O.isPosition(W.anchor)&&O.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(W,ve,Le,Qe){let et,ot;if(typeof W=="number"&&typeof ve=="number"&&typeof Le=="number"&&typeof Qe=="number"?(et=new O(W,ve),ot=new O(Le,Qe)):O.isPosition(W)&&O.isPosition(ve)&&(et=O.of(W),ot=O.of(ve)),!et||!ot)throw new Error("Invalid arguments");super(et,ot),this.f=et,this.g=ot}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$AK=T,e.$AK=T=i=He([C],T);const V=K=>{if(typeof K!="string"||K.length===0||!/^[0-9A-Za-z_\-]+$/.test(K))throw(0,F.$6)("connectionToken")};class q{static isResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.host=="string"&&typeof W.port=="number"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,ve,Le){if(typeof W!="string"||W.length===0)throw(0,F.$6)("host");if(typeof ve!="number"||ve===0||Math.round(ve)!==ve)throw(0,F.$6)("port");typeof Le<"u"&&V(Le),this.host=W,this.port=Math.round(ve),this.connectionToken=Le}}e.$BK=q;class fe{static isManagedResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.makeConnection=="function"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,ve){this.makeConnection=W,this.connectionToken=ve,typeof ve<"u"&&V(ve)}}e.$CK=fe;class ee extends Error{static NotAvailable(W,ve){return new ee(W,y.RemoteAuthorityResolverErrorCode.NotAvailable,ve)}static TemporarilyNotAvailable(W){return new ee(W,y.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(W,ve=y.RemoteAuthorityResolverErrorCode.Unknown,Le){super(W),this._message=W,this._code=ve,this._detail=Le,Object.setPrototypeOf(this,ee.prototype)}}e.$DK=ee;var Y;(function(K){K[K.LF=1]="LF",K[K.CRLF=2]="CRLF"})(Y||(e.EndOfLine=Y={}));var X;(function(K){K[K.Replace=1]="Replace",K[K.Append=2]="Append",K[K.Prepend=3]="Prepend"})(X||(e.EnvironmentVariableMutatorType=X={}));let ae=n=class{static isTextEdit(W){return W instanceof n?!0:W?j.isRange(W)&&typeof W.newText=="string":!1}static replace(W,ve){return new n(W,ve)}static insert(W,ve){return n.replace(new j(W,W),ve)}static delete(W){return n.replace(W,"")}static setEndOfLine(W){const ve=new n(new j(new O(0,0),new O(0,0)),"");return ve.newEol=W,ve}get range(){return this.c}set range(W){if(W&&!j.isRange(W))throw(0,F.$6)("range");this.c=W}get newText(){return this.e||""}set newText(W){if(W&&typeof W!="string")throw(0,F.$6)("newText");this.e=W}get newEol(){return this.f}set newEol(W){if(W&&typeof W!="number")throw(0,F.$6)("newEol");this.f=W}constructor(W,ve){this.c=W,this.e=ve}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$EK=ae,e.$EK=ae=n=He([C],ae);let Z=o=class{static isNotebookCellEdit(W){return W instanceof o?!0:W?xt.isNotebookRange(W)&&Array.isArray(W.newCells):!1}static replaceCells(W,ve){return new o(W,ve)}static insertCells(W,ve){return new o(new xt(W,W),ve)}static deleteCells(W){return new o(W,[])}static updateCellMetadata(W,ve){const Le=new o(new xt(W,W),[]);return Le.newCellMetadata=ve,Le}static updateNotebookMetadata(W){const ve=new o(new xt(0,0),[]);return ve.newNotebookMetadata=W,ve}constructor(W,ve){this.range=W,this.newCells=ve}};e.$FK=Z,e.$FK=Z=o=He([C],Z);class se{static isSnippetTextEdit(W){return W instanceof se?!0:W?j.isRange(W.range)&&U.isSnippetString(W.snippet):!1}static replace(W,ve){return new se(W,ve)}static insert(W,ve){return se.replace(new j(W,W),ve)}constructor(W,ve){this.range=W,this.snippet=ve}}e.$GK=se;var we;(function(K){K[K.File=1]="File",K[K.Text=2]="Text",K[K.Cell=3]="Cell",K[K.CellReplace=5]="CellReplace",K[K.Snippet=6]="Snippet"})(we||(e.FileEditType=we={}));let H=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(W,ve,Le,Qe){this.c.push({_type:1,from:W,to:ve,options:Le,metadata:Qe})}createFile(W,ve,Le){this.c.push({_type:1,from:void 0,to:W,options:ve,metadata:Le})}deleteFile(W,ve,Le){this.c.push({_type:1,from:W,to:void 0,options:ve,metadata:Le})}e(W,ve,Le){this.c.push({_type:3,metadata:Le,uri:W,edit:{editType:5,metadata:ve},notebookMetadata:ve})}f(W,ve,Le,Qe){const et=ve.start,ot=ve.end;(et!==ot||Le.length>0)&&this.c.push({_type:5,uri:W,index:et,count:ot-et,cells:Le,metadata:Qe})}g(W,ve,Le,Qe){this.c.push({_type:3,metadata:Qe,uri:W,edit:{editType:3,index:ve,metadata:Le}})}replace(W,ve,Le,Qe){this.c.push({_type:2,uri:W,edit:new ae(ve,Le),metadata:Qe})}insert(W,ve,Le,Qe){this.replace(W,new j(ve,ve),Le,Qe)}delete(W,ve,Le){this.replace(W,ve,"",Le)}has(W){return this.c.some(ve=>ve._type===2&&ve.uri.toString()===W.toString())}set(W,ve){if(ve)for(const Le of ve){if(!Le)continue;let Qe,et;Array.isArray(Le)?(Qe=Le[0],et=Le[1]):Qe=Le,Z.isNotebookCellEdit(Qe)?Qe.newCellMetadata?this.g(W,Qe.range.start,Qe.newCellMetadata,et):Qe.newNotebookMetadata?this.e(W,Qe.newNotebookMetadata,et):this.f(W,Qe.range,Qe.newCells,et):se.isSnippetTextEdit(Qe)?this.c.push({_type:6,uri:W,range:Qe.range,edit:Qe.snippet,metadata:et}):this.c.push({_type:2,uri:W,edit:Qe,metadata:et})}else{for(let Le=0;Le<this.c.length;Le++){const Qe=this.c[Le];switch(Qe._type){case 2:case 6:case 3:case 5:Qe.uri.toString()===W.toString()&&(this.c[Le]=void 0);break}}(0,I.$Hb)(this.c)}}get(W){const ve=[];for(const Le of this.c)Le._type===2&&Le.uri.toString()===W.toString()&&ve.push(Le.edit);return ve}entries(){const W=new L.$zc;for(const ve of this.c)if(ve._type===2){let Le=W.get(ve.uri);Le||(Le=[ve.uri,[]],W.set(ve.uri,Le)),Le[1].push(ve.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$HK=H,e.$HK=H=He([C],H);let U=a=class{static isSnippetString(W){return W instanceof a?!0:W?typeof W.value=="string":!1}static c(W){return W.replace(/\$|}|\\/g,"\\$&")}constructor(W){this.e=1,this.value=W||""}appendText(W){return this.value+=a.c(W),this}appendTabstop(W=this.e++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,ve=this.e++){if(typeof W=="function"){const Le=new a;Le.e=this.e,W(Le),this.e=Le.e,W=Le.value}else W=a.c(W);return this.value+="${",this.value+=ve,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,ve=this.e++){const Le=W.map(Qe=>Qe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ve,this.value+="|",this.value+=Le,this.value+="|}",this}appendVariable(W,ve){if(typeof ve=="function"){const Le=new a;Le.e=this.e,ve(Le),this.e=Le.e,ve=Le.value}else typeof ve=="string"&&(ve=ve.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,ve&&(this.value+=":",this.value+=ve),this.value+="}",this}};e.$IK=U,e.$IK=U=a=He([C],U);var ce;(function(K){K[K.Unnecessary=1]="Unnecessary",K[K.Deprecated=2]="Deprecated"})(ce||(e.DiagnosticTag=ce={}));var Ee;(function(K){K[K.Hint=3]="Hint",K[K.Information=2]="Information",K[K.Warning=1]="Warning",K[K.Error=0]="Error"})(Ee||(e.DiagnosticSeverity=Ee={}));let ne=t=class{static isLocation(W){return W instanceof t?!0:W?j.isRange(W.range)&&m.URI.isUri(W.uri):!1}constructor(W,ve){if(this.uri=W,ve)if(j.isRange(ve))this.range=j.of(ve);else if(O.isPosition(ve))this.range=new j(ve,ve);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$JK=ne,e.$JK=ne=t=He([C],ne);let G=class{static is(W){return W?typeof W.message=="string"&&W.location&&j.isRange(W.location.range)&&m.URI.isUri(W.location.uri):!1}constructor(W,ve){this.location=W,this.message=ve}static isEqual(W,ve){return W===ve?!0:!W||!ve?!1:W.message===ve.message&&W.location.range.isEqual(ve.location.range)&&W.location.uri.toString()===ve.location.uri.toString()}};e.$KK=G,e.$KK=G=He([C],G);let J=class{constructor(W,ve,Le=Ee.Error){if(!j.isRange(W))throw new TypeError("range must be set");if(!ve)throw new TypeError("message must be set");this.range=W,this.message=ve,this.severity=Le}toJSON(){return{severity:Ee[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,ve){return W===ve?!0:!W||!ve?!1:W.message===ve.message&&W.severity===ve.severity&&W.code===ve.code&&W.severity===ve.severity&&W.source===ve.source&&W.range.isEqual(ve.range)&&(0,I.$tb)(W.tags,ve.tags)&&(0,I.$tb)(W.relatedInformation,ve.relatedInformation,G.isEqual)}};e.$LK=J,e.$LK=J=He([C],J);let ge=class{constructor(W,ve){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=ve}};e.$MK=ge,e.$MK=ge=He([C],ge);var x;(function(K){K[K.Text=0]="Text",K[K.Read=1]="Read",K[K.Write=2]="Write"})(x||(e.DocumentHighlightKind=x={}));let le=class{constructor(W,ve=x.Text){this.range=W,this.kind=ve}toJSON(){return{range:this.range,kind:x[this.kind]}}};e.$NK=le,e.$NK=le=He([C],le);var te;(function(K){K[K.File=0]="File",K[K.Module=1]="Module",K[K.Namespace=2]="Namespace",K[K.Package=3]="Package",K[K.Class=4]="Class",K[K.Method=5]="Method",K[K.Property=6]="Property",K[K.Field=7]="Field",K[K.Constructor=8]="Constructor",K[K.Enum=9]="Enum",K[K.Interface=10]="Interface",K[K.Function=11]="Function",K[K.Variable=12]="Variable",K[K.Constant=13]="Constant",K[K.String=14]="String",K[K.Number=15]="Number",K[K.Boolean=16]="Boolean",K[K.Array=17]="Array",K[K.Object=18]="Object",K[K.Key=19]="Key",K[K.Null=20]="Null",K[K.EnumMember=21]="EnumMember",K[K.Struct=22]="Struct",K[K.Event=23]="Event",K[K.Operator=24]="Operator",K[K.TypeParameter=25]="TypeParameter"})(te||(e.SymbolKind=te={}));var de;(function(K){K[K.Deprecated=1]="Deprecated"})(de||(e.SymbolTag=de={}));let be=r=class{static validate(W){if(!W.name)throw new Error("name must not be falsy")}constructor(W,ve,Le,Qe,et){this.name=W,this.kind=ve,this.containerName=et,typeof Le=="string"&&(this.containerName=Le),Qe instanceof ne?this.location=Qe:Le instanceof j&&(this.location=new ne(Qe,Le)),r.validate(this)}toJSON(){return{name:this.name,kind:te[this.kind],location:this.location,containerName:this.containerName}}};e.$OK=be,e.$OK=be=r=He([C],be);let Pe=d=class{static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children?.forEach(d.validate)}constructor(W,ve,Le,Qe,et){this.name=W,this.detail=ve,this.kind=Le,this.range=Qe,this.selectionRange=et,this.children=[],d.validate(this)}};e.$PK=Pe,e.$PK=Pe=d=He([C],Pe);var B;(function(K){K[K.Invoke=1]="Invoke",K[K.Automatic=2]="Automatic"})(B||(e.CodeActionTriggerKind=B={}));let Q=class{constructor(W,ve){this.title=W,this.kind=ve}};e.$QK=Q,e.$QK=Q=He([C],Q);let re=class{static{u=this}static{this.c="."}constructor(W){this.value=W}append(W){return new u(this.value?this.value+u.c+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+u.c)}};e.$RK=re,e.$RK=re=u=He([C],re),re.Empty=new re(""),re.QuickFix=re.Empty.append("quickfix"),re.Refactor=re.Empty.append("refactor"),re.RefactorExtract=re.Refactor.append("extract"),re.RefactorInline=re.Refactor.append("inline"),re.RefactorMove=re.Refactor.append("move"),re.RefactorRewrite=re.Refactor.append("rewrite"),re.Source=re.Empty.append("source"),re.SourceOrganizeImports=re.Source.append("organizeImports"),re.SourceFixAll=re.Source.append("fixAll"),re.Notebook=re.Empty.append("notebook");let oe=class{constructor(W,ve){if(this.range=W,this.parent=ve,ve&&!ve.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$SK=oe,e.$SK=oe=He([C],oe);class _{constructor(W,ve,Le,Qe,et,ot){this.kind=W,this.name=ve,this.detail=Le,this.uri=Qe,this.range=et,this.selectionRange=ot}}e.$TK=_;class me{constructor(W,ve){this.fromRanges=ve,this.from=W}}e.$UK=me;class ye{constructor(W,ve){this.fromRanges=ve,this.to=W}}e.$VK=ye;var ze;(function(K){K[K.Information=0]="Information",K[K.Warning=1]="Warning",K[K.Error=2]="Error"})(ze||(e.LanguageStatusSeverity=ze={}));let We=class{constructor(W,ve){this.range=W,this.command=ve}get isResolved(){return!!this.command}};e.$WK=We,e.$WK=We=He([C],We);let _e=l=class{#e;static isMarkdownString(W){return W instanceof l?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}constructor(W,ve=!1){this.#e=new f.$7j(W,{supportThemeIcons:ve})}get value(){return this.#e.value}set value(W){this.#e.value=W}get isTrusted(){return this.#e.isTrusted}set isTrusted(W){this.#e.isTrusted=W}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(W){this.#e.supportThemeIcons=W}get supportHtml(){return this.#e.supportHtml}set supportHtml(W){this.#e.supportHtml=W}get baseUri(){return this.#e.baseUri}set baseUri(W){this.#e.baseUri=W}appendText(W){return this.#e.appendText(W),this}appendMarkdown(W){return this.#e.appendMarkdown(W),this}appendCodeblock(W,ve){return this.#e.appendCodeblock(ve??"",W),this}};e.$XK=_e,e.$XK=_e=l=He([C],_e);let Ye=class{constructor(W,ve){this.label=W,this.documentation=ve}};e.$YK=Ye,e.$YK=Ye=He([C],Ye);let it=class{constructor(W,ve){this.label=W,this.documentation=ve,this.parameters=[]}};e.$ZK=it,e.$ZK=it=He([C],it);let tt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$1K=tt,e.$1K=tt=He([C],tt);var Ae;(function(K){K[K.Invoke=1]="Invoke",K[K.TriggerCharacter=2]="TriggerCharacter",K[K.ContentChange=3]="ContentChange"})(Ae||(e.SignatureHelpTriggerKind=Ae={}));var Oe;(function(K){K[K.Type=1]="Type",K[K.Parameter=2]="Parameter"})(Oe||(e.InlayHintKind=Oe={}));let Ve=class{constructor(W){this.value=W}};e.$2K=Ve,e.$2K=Ve=He([C],Ve);let Re=class{constructor(W,ve,Le){this.position=W,this.label=ve,this.kind=Le}};e.$3K=Re,e.$3K=Re=He([C],Re);var Xe;(function(K){K[K.Invoke=0]="Invoke",K[K.TriggerCharacter=1]="TriggerCharacter",K[K.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Xe||(e.CompletionTriggerKind=Xe={}));var he;(function(K){K[K.Text=0]="Text",K[K.Method=1]="Method",K[K.Function=2]="Function",K[K.Constructor=3]="Constructor",K[K.Field=4]="Field",K[K.Variable=5]="Variable",K[K.Class=6]="Class",K[K.Interface=7]="Interface",K[K.Module=8]="Module",K[K.Property=9]="Property",K[K.Unit=10]="Unit",K[K.Value=11]="Value",K[K.Enum=12]="Enum",K[K.Keyword=13]="Keyword",K[K.Snippet=14]="Snippet",K[K.Color=15]="Color",K[K.File=16]="File",K[K.Reference=17]="Reference",K[K.Folder=18]="Folder",K[K.EnumMember=19]="EnumMember",K[K.Constant=20]="Constant",K[K.Struct=21]="Struct",K[K.Event=22]="Event",K[K.Operator=23]="Operator",K[K.TypeParameter=24]="TypeParameter",K[K.User=25]="User",K[K.Issue=26]="Issue"})(he||(e.CompletionItemKind=he={}));var ue;(function(K){K[K.Deprecated=1]="Deprecated"})(ue||(e.CompletionItemTag=ue={}));let Ie=class{constructor(W,ve){this.label=W,this.kind=ve}toJSON(){return{label:this.label,kind:this.kind&&he[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$4K=Ie,e.$4K=Ie=He([C],Ie);let Ke=class{constructor(W=[],ve=!1){this.items=W,this.isIncomplete=ve}};e.$5K=Ke,e.$5K=Ke=He([C],Ke);let Ue=class{constructor(W,ve,Le){this.insertText=W,this.range=ve,this.command=Le}};e.$6K=Ue,e.$6K=Ue=He([C],Ue);let Ze=class{constructor(W){this.commands=void 0,this.suppressSuggestions=void 0,this.items=W}};e.$7K=Ze,e.$7K=Ze=He([C],Ze);var nt;(function(K){K[K.Active=-1]="Active",K[K.Beside=-2]="Beside",K[K.One=1]="One",K[K.Two=2]="Two",K[K.Three=3]="Three",K[K.Four=4]="Four",K[K.Five=5]="Five",K[K.Six=6]="Six",K[K.Seven=7]="Seven",K[K.Eight=8]="Eight",K[K.Nine=9]="Nine"})(nt||(e.ViewColumn=nt={}));var ct;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(ct||(e.StatusBarAlignment=ct={}));function bt(K,W){return`${P.$0l.toKey(K)}.${W}`}e.$8K=bt;var Et;(function(K){K[K.Off=0]="Off",K[K.On=1]="On",K[K.Relative=2]="Relative"})(Et||(e.TextEditorLineNumbersStyle=Et={}));var Kt;(function(K){K[K.Manual=1]="Manual",K[K.AfterDelay=2]="AfterDelay",K[K.FocusOut=3]="FocusOut"})(Kt||(e.TextDocumentSaveReason=Kt={}));var Ht;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(Ht||(e.TextEditorRevealType=Ht={}));var wt;(function(K){K[K.Keyboard=1]="Keyboard",K[K.Mouse=2]="Mouse",K[K.Command=3]="Command"})(wt||(e.TextEditorSelectionChangeKind=wt={}));var zt;(function(K){K[K.Undo=1]="Undo",K[K.Redo=2]="Redo"})(zt||(e.TextDocumentChangeReason=zt={}));var Ot;(function(K){K[K.OpenOpen=0]="OpenOpen",K[K.ClosedClosed=1]="ClosedClosed",K[K.OpenClosed=2]="OpenClosed",K[K.ClosedOpen=3]="ClosedOpen"})(Ot||(e.DecorationRangeBehavior=Ot={})),function(K){function W(ve){switch(ve){case"keyboard":return K.Keyboard;case"mouse":return K.Mouse;case"api":return K.Command}}K.fromValue=W}(wt||(e.TextEditorSelectionChangeKind=wt={}));var Gt;(function(K){K[K.Other=0]="Other",K[K.Comment=1]="Comment",K[K.String=2]="String",K[K.RegEx=3]="RegEx"})(Gt||(e.SyntaxTokenType=Gt={})),function(K){function W(ve){switch(ve){case K.Other:return"other";case K.Comment:return"comment";case K.String:return"string";case K.RegEx:return"regex"}return"other"}K.toString=W}(Gt||(e.SyntaxTokenType=Gt={}));let Ut=class{constructor(W,ve){if(ve&&!m.URI.isUri(ve))throw(0,F.$6)("target");if(!j.isRange(W)||W.isEmpty)throw(0,F.$6)("range");this.range=W,this.target=ve}};e.$9K=Ut,e.$9K=Ut=He([C],Ut);let Dt=class{constructor(W,ve,Le,Qe){this.red=W,this.green=ve,this.blue=Le,this.alpha=Qe}};e.$0K=Dt,e.$0K=Dt=He([C],Dt);let Ft=class{constructor(W,ve){if(ve&&!(ve instanceof Dt))throw(0,F.$6)("color");if(!j.isRange(W)||W.isEmpty)throw(0,F.$6)("range");this.range=W,this.color=ve}};e.$$K=Ft,e.$$K=Ft=He([C],Ft);let Bt=class{constructor(W){if(!W||typeof W!="string")throw(0,F.$6)("label");this.label=W}};e.$_K=Bt,e.$_K=Bt=He([C],Bt);var Jt;(function(K){K[K.RGB=0]="RGB",K[K.HEX=1]="HEX",K[K.HSL=2]="HSL"})(Jt||(e.ColorFormat=Jt={}));var Wt;(function(K){K[K.Error=0]="Error",K[K.Warning=1]="Warning",K[K.Information=2]="Information"})(Wt||(e.SourceControlInputBoxValidationType=Wt={}));var Vt;(function(K){K[K.Unknown=0]="Unknown",K[K.Shutdown=1]="Shutdown",K[K.Process=2]="Process",K[K.User=3]="User",K[K.Extension=4]="Extension"})(Vt||(e.TerminalExitReason=Vt={}));class Nt{constructor(W,ve,Le){if(this.startIndex=W,this.length=ve,this.tooltip=Le,typeof W!="number"||W<0)throw(0,F.$6)("startIndex");if(typeof ve!="number"||ve<1)throw(0,F.$6)("length");if(Le!==void 0&&typeof Le!="string")throw(0,F.$6)("tooltip")}}e.$aL=Nt;class ut{constructor(W){this.uri=W}}e.$bL=ut;class ft{constructor(W){this.terminalCommand=W}}e.$cL=ft;var At;(function(K){K[K.Panel=1]="Panel",K[K.Editor=2]="Editor"})(At||(e.TerminalLocation=At={}));class qt{constructor(W){if(this.options=W,typeof W!="object")throw(0,F.$6)("options")}}e.$dL=qt;var Lt;(function(K){K[K.Always=1]="Always",K[K.Silent=2]="Silent",K[K.Never=3]="Never"})(Lt||(e.TaskRevealKind=Lt={}));var at;(function(K){K[K.Shared=1]="Shared",K[K.Dedicated=2]="Dedicated",K[K.New=3]="New"})(at||(e.TaskPanelKind=at={}));let vt=class{static{h=this}static{this.Clean=new h("clean","Clean")}static{this.Build=new h("build","Build")}static{this.Rebuild=new h("rebuild","Rebuild")}static{this.Test=new h("test","Test")}static from(W){switch(W){case"clean":return h.Clean;case"build":return h.Build;case"rebuild":return h.Rebuild;case"test":return h.Test;default:return}}constructor(W,ve){if(this.label=ve,typeof W!="string"||typeof ve!="string")throw(0,F.$6)("name");this.c=W}get id(){return this.c}};e.$eL=vt,e.$eL=vt=h=He([C],vt);function Tt(K){let W="";for(let ve=0;ve<K.length;ve++)W+=K[ve].replace(/,/g,",,")+",";return W}let Pt=class{constructor(W,ve,Le){if(typeof W!="string")throw(0,F.$6)("process");this.e=[],this.c=W,ve!==void 0&&(Array.isArray(ve)?(this.e=ve,this.f=Le):this.f=ve)}get process(){return this.c}set process(W){if(typeof W!="string")throw(0,F.$6)("process");this.c=W}get args(){return this.e}set args(W){Array.isArray(W)||(W=[]),this.e=W}get options(){return this.f}set options(W){this.f=W}computeId(){const W=[];if(W.push("process"),this.c!==void 0&&W.push(this.c),this.e&&this.e.length>0)for(const ve of this.e)W.push(ve);return Tt(W)}};e.$fL=Pt,e.$fL=Pt=He([C],Pt);let Ge=class{constructor(W,ve,Le){if(this.f=[],Array.isArray(ve)){if(!W)throw(0,F.$6)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,F.$6)("command");this.e=W,this.f=ve,this.g=Le}else{if(typeof W!="string")throw(0,F.$6)("commandLine");this.c=W,this.g=ve}}get commandLine(){return this.c}set commandLine(W){if(typeof W!="string")throw(0,F.$6)("commandLine");this.c=W}get command(){return this.e?this.e:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,F.$6)("command");this.e=W}get args(){return this.f}set args(W){this.f=W||[]}get options(){return this.g}set options(W){this.g=W}computeId(){const W=[];if(W.push("shell"),this.c!==void 0&&W.push(this.c),this.e!==void 0&&W.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ve of this.f)W.push(typeof ve=="string"?ve:ve.value);return Tt(W)}};e.$gL=Ge,e.$gL=Ge=He([C],Ge);var Qt;(function(K){K[K.Escape=1]="Escape",K[K.Strong=2]="Strong",K[K.Weak=3]="Weak"})(Qt||(e.ShellQuoting=Qt={}));var Me;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace"})(Me||(e.TaskScope=Me={}));class Te{constructor(W){this.c=W}computeId(){return"customExecution"+(0,A.$fg)()}set callback(W){this.c=W}get callback(){return this.c}}e.$hL=Te;let Ce=class{static{k=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(W,ve,Le,Qe,et,ot){this.j=!1,this.k=this.definition=W;let ht;typeof ve=="string"?(this.m=this.name=ve,this.t=this.source=Le,this.execution=Qe,ht=et,this.j=!0):ve===Me.Global||ve===Me.Workspace?(this.target=ve,this.m=this.name=Le,this.t=this.source=Qe,this.execution=et,ht=ot):(this.target=ve,this.m=this.name=Le,this.t=this.source=Qe,this.execution=et,ht=ot),typeof ht=="string"?(this.o=[ht],this.q=!0):Array.isArray(ht)?(this.o=ht,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.w=Object.create(null),this.x=Object.create(null)}get _id(){return this.h}set _id(W){this.h=W}get _deprecated(){return this.j}z(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.A())}A(){this.n instanceof Pt?this.k={type:k.e,id:this.n.computeId()}:this.n instanceof Ge?this.k={type:k.f,id:this.n.computeId()}:this.n instanceof Te?this.k={type:k.c,id:this.n.computeId()}:this.k={type:k.g,id:(0,A.$fg)()}}get definition(){return this.k}set definition(W){if(W==null)throw(0,F.$6)("Kind can't be undefined or null");this.z(),this.k=W}get scope(){return this.l}set target(W){this.z(),this.l=W}get name(){return this.m}set name(W){if(typeof W!="string")throw(0,F.$6)("name");this.z(),this.m=W}get execution(){return this.n}set execution(W){W===null&&(W=void 0),this.z(),this.n=W;const ve=this.k.type;(k.g===ve||k.e===ve||k.f===ve||k.c===ve)&&this.A()}get problemMatchers(){return this.o}set problemMatchers(W){if(Array.isArray(W))this.z(),this.o=W,this.q=!0;else{this.z(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.z(),this.r=W}get source(){return this.t}set source(W){if(typeof W!="string"||W.length===0)throw(0,F.$6)("source must be a string of length > 0");this.z(),this.t=W}get group(){return this.u}set group(W){W===null&&(W=void 0),this.z(),this.u=W}get detail(){return this.y}set detail(W){W===null&&(W=void 0),this.y=W}get presentationOptions(){return this.w}set presentationOptions(W){W==null&&(W=Object.create(null)),this.z(),this.w=W}get runOptions(){return this.x}set runOptions(W){W==null&&(W=Object.create(null)),this.z(),this.x=W}};e.$iL=Ce,e.$iL=Ce=k=He([C],Ce);var ie;(function(K){K[K.SourceControl=1]="SourceControl",K[K.Window=10]="Window",K[K.Notification=15]="Notification"})(ie||(e.ProgressLocation=ie={}));var Fe;(function(K){function W(ve){const Le=ve;return(0,E.$Df)(Le.value)?Le.tooltip&&!(0,E.$zf)(Le.tooltip)?(console.log("INVALID view badge, invalid tooltip",Le.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Le.value),!1)}K.isViewBadge=W})(Fe||(e.ViewBadge=Fe={}));let qe=D=class{static isTreeItem(W,ve){const Le=W;if(Le.checkboxState!==void 0){const Qe=(0,E.$Df)(Le.checkboxState)?Le.checkboxState:(0,E.$Bf)(Le.checkboxState)&&(0,E.$Df)(Le.checkboxState.state)?Le.checkboxState.state:void 0,et=!(0,E.$Df)(Le.checkboxState)&&(0,E.$Bf)(Le.checkboxState)?Le.checkboxState.tooltip:void 0;if(Qe===void 0||Qe!==Je.Checked&&Qe!==Je.Unchecked||et!==void 0&&!(0,E.$zf)(et))return console.log("INVALID tree item, invalid checkboxState",Le.checkboxState),!1}if(W instanceof D)return!0;if(Le.label!==void 0&&!(0,E.$zf)(Le.label)&&!Le.label?.label)return console.log("INVALID tree item, invalid label",Le.label),!1;if(Le.id!==void 0&&!(0,E.$zf)(Le.id))return console.log("INVALID tree item, invalid id",Le.id),!1;if(Le.iconPath!==void 0&&!(0,E.$zf)(Le.iconPath)&&!m.URI.isUri(Le.iconPath)&&(!Le.iconPath||!(0,E.$zf)(Le.iconPath.id))){const Qe=Le.iconPath;if(!Qe||!(0,E.$zf)(Qe.light)&&!m.URI.isUri(Qe.light)&&!(0,E.$zf)(Qe.dark)&&!m.URI.isUri(Qe.dark))return console.log("INVALID tree item, invalid iconPath",Le.iconPath),!1}return Le.description!==void 0&&!(0,E.$zf)(Le.description)&&typeof Le.description!="boolean"?(console.log("INVALID tree item, invalid description",Le.description),!1):Le.resourceUri!==void 0&&!m.URI.isUri(Le.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Le.resourceUri),!1):Le.tooltip!==void 0&&!(0,E.$zf)(Le.tooltip)&&!(Le.tooltip instanceof _e)?(console.log("INVALID tree item, invalid tooltip",Le.tooltip),!1):Le.command!==void 0&&!Le.command.command?(console.log("INVALID tree item, invalid command",Le.command),!1):Le.collapsibleState!==void 0&&Le.collapsibleState<xe.None&&Le.collapsibleState>xe.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Le.collapsibleState),!1):Le.contextValue!==void 0&&!(0,E.$zf)(Le.contextValue)?(console.log("INVALID tree item, invalid contextValue",Le.contextValue),!1):Le.accessibilityInformation!==void 0&&!Le.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Le.accessibilityInformation),!1):!0}constructor(W,ve=xe.None){this.collapsibleState=ve,m.URI.isUri(W)?this.resourceUri=W:this.label=W}};e.$jL=qe,e.$jL=qe=D=He([C],qe);var xe;(function(K){K[K.None=0]="None",K[K.Collapsed=1]="Collapsed",K[K.Expanded=2]="Expanded"})(xe||(e.TreeItemCollapsibleState=xe={}));var Je;(function(K){K[K.Unchecked=0]="Unchecked",K[K.Checked=1]="Checked"})(Je||(e.TreeItemCheckboxState=Je={}));let rt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(W){this.value=W}};e.$kL=rt,e.$kL=rt=He([C],rt);class kt extends rt{}e.$lL=kt;class St extends kt{#e;constructor(W){super(""),this.#e=W}asFile(){return this.#e}}e.$mL=St;class mt{constructor(W,ve,Le,Qe){this.name=W,this.uri=ve,this._itemId=Le,this.c=Qe}data(){return this.c()}}e.$nL=mt;let dt=class{#e=new Map;constructor(W){for(const[ve,Le]of W??[]){const Qe=this.#e.get(this.#t(ve));Qe?Qe.push(Le):this.#e.set(this.#t(ve),[Le])}}get(W){return this.#e.get(this.#t(W))?.[0]}set(W,ve){this.#e.set(this.#t(W),[ve])}forEach(W,ve){for(const[Le,Qe]of this.#e)for(const et of Qe)W.call(ve,et,Le,this)}*[Symbol.iterator](){for(const[W,ve]of this.#e)for(const Le of ve)yield[W,Le]}#t(W){return W.toLowerCase()}};e.$oL=dt,e.$oL=dt=He([C],dt);let gt=class{constructor(W){this.insertText=W}};e.$pL=gt,e.$pL=gt=He([C],gt);let ui=class{constructor(W,ve){this.label=ve,this.insertText=W}};e.$qL=ui,e.$qL=ui=He([C],ui);let Ct=class{constructor(W,ve){this.id=W,this.color=ve}static isThemeIcon(W){return typeof W.id!="string"?(console.log("INVALID ThemeIcon, invalid id",W.id),!1):!0}};e.$rL=Ct,e.$rL=Ct=He([C],Ct),Ct.File=new Ct("file"),Ct.Folder=new Ct("folder");let Di=class{constructor(W){this.id=W}};e.$sL=Di,e.$sL=Di=He([C],Di);var li;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace",K[K.WorkspaceFolder=3]="WorkspaceFolder"})(li||(e.ConfigurationTarget=li={}));let $i=class{get base(){return this.c}set base(W){this.c=W,this.e=m.URI.file(W)}get baseUri(){return this.e}set baseUri(W){this.e=W,this.c=W.fsPath}constructor(W,ve){if(typeof W!="string"&&(!W||!m.URI.isUri(W)&&!m.URI.isUri(W.uri)))throw(0,F.$6)("base");if(typeof ve!="string")throw(0,F.$6)("pattern");typeof W=="string"?this.baseUri=m.URI.file(W):m.URI.isUri(W)?this.baseUri=W:this.baseUri=W.uri,this.pattern=ve}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$tL=$i,e.$tL=$i=He([C],$i);const It=new WeakMap;function gn(K,W){It.set(K,W)}e.$uL=gn;let ri=class{constructor(W,ve,Le,Qe){this.enabled=typeof W=="boolean"?W:!0,typeof ve=="string"&&(this.condition=ve),typeof Le=="string"&&(this.hitCondition=Le),typeof Qe=="string"&&(this.logMessage=Qe)}get id(){return this.c||(this.c=It.get(this)??(0,A.$fg)()),this.c}};e.$vL=ri,e.$vL=ri=He([C],ri);let yt=class extends ri{constructor(W,ve,Le,Qe,et){if(super(ve,Le,Qe,et),W===null)throw(0,F.$6)("location");this.location=W}};e.$wL=yt,e.$wL=yt=He([C],yt);let bi=class extends ri{constructor(W,ve,Le,Qe,et){super(ve,Le,Qe,et),this.functionName=W}};e.$xL=bi,e.$xL=bi=He([C],bi);let pi=class extends ri{constructor(W,ve,Le,Qe,et,ot,ht){if(super(Qe,et,ot,ht),!ve)throw(0,F.$6)("dataId");this.label=W,this.dataId=ve,this.canPersist=Le}};e.$yL=pi,e.$yL=pi=He([C],pi);let si=class{constructor(W,ve,Le){this.command=W,this.args=ve||[],this.options=Le}};e.$zL=si,e.$zL=si=He([C],si);let Ci=class{constructor(W,ve){this.port=W,this.host=ve}};e.$AL=Ci,e.$AL=Ci=He([C],Ci);let Ii=class{constructor(W){this.path=W}};e.$BL=Ii,e.$BL=Ii=He([C],Ii);let Rt=class{constructor(W){this.implementation=W}};e.$CL=Rt,e.$CL=Rt=He([C],Rt);let wi=class{constructor(W,ve,Le){this.session=W,this.threadId=ve,this.frameId=Le}};e.$DL=wi,e.$DL=wi=He([C],wi);let Pi=class{constructor(W,ve){this.session=W,this.threadId=ve}};e.$EL=Pi,e.$EL=Pi=He([C],Pi);let oi=class{constructor(W,ve){this.range=W,this.expression=ve}};e.$FL=oi,e.$FL=oi=He([C],oi);var hi;(function(K){K[K.Invoke=0]="Invoke",K[K.Automatic=1]="Automatic"})(hi||(e.InlineCompletionTriggerKind=hi={}));let lt=class{constructor(W,ve){this.range=W,this.text=ve}};e.$GL=lt,e.$GL=lt=He([C],lt);let Ai=class{constructor(W,ve,Le=!0){this.range=W,this.variableName=ve,this.caseSensitiveLookup=Le}};e.$HL=Ai,e.$HL=Ai=He([C],Ai);let Zt=class{constructor(W,ve){this.range=W,this.expression=ve}};e.$IL=Zt,e.$IL=Zt=He([C],Zt);let ii=class{constructor(W,ve){this.frameId=W,this.stoppedLocation=ve}};e.$JL=ii,e.$JL=ii=He([C],ii);var Li;(function(K){K[K.Changed=1]="Changed",K[K.Created=2]="Created",K[K.Deleted=3]="Deleted"})(Li||(e.FileChangeType=Li={}));let Ri=$=class extends Error{static FileExists(W){return new $(W,g.FileSystemProviderErrorCode.FileExists,$.FileExists)}static FileNotFound(W){return new $(W,g.FileSystemProviderErrorCode.FileNotFound,$.FileNotFound)}static FileNotADirectory(W){return new $(W,g.FileSystemProviderErrorCode.FileNotADirectory,$.FileNotADirectory)}static FileIsADirectory(W){return new $(W,g.FileSystemProviderErrorCode.FileIsADirectory,$.FileIsADirectory)}static NoPermissions(W){return new $(W,g.FileSystemProviderErrorCode.NoPermissions,$.NoPermissions)}static Unavailable(W){return new $(W,g.FileSystemProviderErrorCode.Unavailable,$.Unavailable)}constructor(W,ve=g.FileSystemProviderErrorCode.Unknown,Le){super(m.URI.isUri(W)?W.toString(!0):W),this.code=Le?.name??"Unknown",(0,g.$rk)(this,ve),Object.setPrototypeOf(this,$.prototype),typeof Error.captureStackTrace=="function"&&typeof Le=="function"&&Error.captureStackTrace(this,Le)}};e.$KL=Ri,e.$KL=Ri=$=He([C],Ri);let Mi=class{constructor(W,ve,Le){this.start=W,this.end=ve,this.kind=Le}};e.$LL=Mi,e.$LL=Mi=He([C],Mi);var Yi;(function(K){K[K.Comment=1]="Comment",K[K.Imports=2]="Imports",K[K.Region=3]="Region"})(Yi||(e.FoldingRangeKind=Yi={}));var Fi;(function(K){K[K.Collapsed=0]="Collapsed",K[K.Expanded=1]="Expanded"})(Fi||(e.CommentThreadCollapsibleState=Fi={}));var Xi;(function(K){K[K.Editing=0]="Editing",K[K.Preview=1]="Preview"})(Xi||(e.CommentMode=Xi={}));var Ti;(function(K){K[K.Published=0]="Published",K[K.Draft=1]="Draft"})(Ti||(e.CommentState=Ti={}));var ai;(function(K){K[K.Unresolved=0]="Unresolved",K[K.Resolved=1]="Resolved"})(ai||(e.CommentThreadState=ai={}));class mn{constructor(W,ve=[]){this.tokenTypes=W,this.tokenModifiers=ve}}e.$ML=mn;function Oi(K){return typeof K>"u"||(0,E.$Af)(K)}class di{constructor(W){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,W){this.l=!0;for(let ve=0,Le=W.tokenTypes.length;ve<Le;ve++)this.j.set(W.tokenTypes[ve],ve);for(let ve=0,Le=W.tokenModifiers.length;ve<Le;ve++)this.k.set(W.tokenModifiers[ve],ve)}}push(W,ve,Le,Qe,et){if(typeof W=="number"&&typeof ve=="number"&&typeof Le=="number"&&typeof Qe=="number"&&(typeof et=="number"||typeof et>"u"))return typeof et>"u"&&(et=0),this.n(W,ve,Le,Qe,et);if(j.isRange(W)&&typeof ve=="string"&&Oi(Le))return this.m(W,ve,Le);throw(0,F.$6)()}m(W,ve,Le){if(!this.l)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(ve))throw new Error("`tokenType` is not in the provided legend");const Qe=W.start.line,et=W.start.character,ot=W.end.character-W.start.character,ht=this.j.get(ve);let jt=0;if(Le)for(const Xt of Le){if(!this.k.has(Xt))throw new Error("`tokenModifier` is not in the provided legend");const ei=this.k.get(Xt);jt|=1<<ei>>>0}this.n(Qe,et,ot,ht,jt)}n(W,ve,Le,Qe,et){if(this.f&&(W<this.c||W===this.c&&ve<this.e)){this.f=!1;const jt=this.g.length/5|0;let Xt=0,ei=0;for(let ti=0;ti<jt;ti++){let ni=this.g[5*ti],Ji=this.g[5*ti+1];ni===0?(ni=Xt,Ji+=ei):ni+=Xt,this.g[5*ti]=ni,this.g[5*ti+1]=Ji,Xt=ni,ei=Ji}}let ot=W,ht=ve;this.f&&this.h>0&&(ot-=this.c,ot===0&&(ht-=this.e)),this.g[this.h++]=ot,this.g[this.h++]=ht,this.g[this.h++]=Le,this.g[this.h++]=Qe,this.g[this.h++]=et,this.c=W,this.e=ve}static o(W){const ve=[],Le=W.length/5|0;for(let ht=0;ht<Le;ht++)ve[ht]=ht;ve.sort((ht,jt)=>{const Xt=W[5*ht],ei=W[5*jt];if(Xt===ei){const ti=W[5*ht+1],ni=W[5*jt+1];return ti-ni}return Xt-ei});const Qe=new Uint32Array(W.length);let et=0,ot=0;for(let ht=0;ht<Le;ht++){const jt=5*ve[ht],Xt=W[jt+0],ei=W[jt+1],ti=W[jt+2],ni=W[jt+3],Ji=W[jt+4],In=Xt-et,Tn=In===0?ei-ot:ei,Qi=5*ht;Qe[Qi+0]=In,Qe[Qi+1]=Tn,Qe[Qi+2]=ti,Qe[Qi+3]=ni,Qe[Qi+4]=Ji,et=Xt,ot=ei}return Qe}build(W){return this.f?new Ni(new Uint32Array(this.g),W):new Ni(di.o(this.g),W)}}e.$NL=di;class Ni{constructor(W,ve){this.resultId=ve,this.data=W}}e.$OL=Ni;class $n{constructor(W,ve,Le){this.start=W,this.deleteCount=ve,this.data=Le}}e.$PL=$n;class fi{constructor(W,ve){this.resultId=ve,this.edits=W}}e.$QL=fi;var Zi;(function(K){K[K.Separate=0]="Separate",K[K.MergeWithParent=1]="MergeWithParent"})(Zi||(e.DebugConsoleMode=Zi={}));let ji=class{static{this.Back={iconPath:new Ct("arrow-left")}}constructor(){}};e.$RL=ji,e.$RL=ji=He([C],ji);var xi;(function(K){K[K.Separator=-1]="Separator",K[K.Default=0]="Default"})(xi||(e.QuickPickItemKind=xi={}));var gi;(function(K){K[K.Info=1]="Info",K[K.Warning=2]="Warning",K[K.Error=3]="Error"})(gi||(e.InputBoxValidationSeverity=gi={}));var _i;(function(K){K[K.UI=1]="UI",K[K.Workspace=2]="Workspace"})(_i||(e.ExtensionKind=_i={}));class bn{static validate(W){if(typeof W.badge=="string"){let ve=(0,p.$af)(W.badge,0);if(ve<W.badge.length&&(ve+=(0,p.$af)(W.badge,ve)),W.badge.length>ve)throw new Error("The 'badge'-property must be undefined or a short character")}else if(W.badge&&!Ct.isThemeIcon(W.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty");return!0}constructor(W,ve,Le){this.badge=W,this.tooltip=ve,this.color=Le}}e.$SL=bn;let zi=class{constructor(W){this.kind=W}};e.$TL=zi,e.$TL=zi=He([C],zi);var mi;(function(K){K[K.Light=1]="Light",K[K.Dark=2]="Dark",K[K.HighContrast=3]="HighContrast",K[K.HighContrastLight=4]="HighContrastLight"})(mi||(e.ColorThemeKind=mi={}));class xt{static isNotebookRange(W){return W instanceof xt?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(W,ve){if(W<0)throw(0,F.$6)("start must be positive");if(ve<0)throw(0,F.$6)("end must be positive");W<=ve?(this.c=W,this.e=ve):(this.c=ve,this.e=W)}with(W){let ve=this.c,Le=this.e;return W.start!==void 0&&(ve=W.start),W.end!==void 0&&(Le=W.end),ve===this.c&&Le===this.e?this:new xt(ve,Le)}}e.$UL=xt;class vi{static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(ve=>vi.isNotebookCellData(ve))}static isNotebookCellData(W){return!0}constructor(W,ve,Le,Qe,et,ot,ht){this.kind=W,this.value=ve,this.languageId=Le,this.mime=Qe,this.outputs=et??[],this.metadata=ot,this.executionSummary=ht,vi.validate(this)}}e.$VL=vi;class en{constructor(W){this.cells=W}}e.$WL=en;class Yt{static isNotebookCellOutputItem(W){return W instanceof Yt?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const ve={name:W.name,message:W.message,stack:W.stack};return Yt.json(ve,"application/vnd.code.notebook.error")}static stdout(W){return Yt.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return Yt.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,ve="application/octet-stream"){return new Yt(W,ve)}static#e=new TextEncoder;static text(W,ve=R.$Tr.text){const Le=Yt.#e.encode(String(W));return new Yt(Le,ve)}static json(W,ve="text/x-json"){const Le=JSON.stringify(W,void 0,"	");return Yt.text(Le,ve)}constructor(W,ve){this.data=W,this.mime=ve;const Le=(0,R.$Xr)(ve,!0);if(!Le)throw new Error(`INVALID mime type: ${ve}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Le}}e.$XL=Yt;class yi{static isNotebookCellOutput(W){return W instanceof yi?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&Array.isArray(W.items)}static ensureUniqueMimeTypes(W,ve=!1){const Le=new Set,Qe=new Set;for(let et=0;et<W.length;et++){const ot=W[et],ht=(0,R.$Xr)(ot.mime);if(!Le.has(ht)||(0,S.$AI)(ht)){Le.add(ht);continue}Qe.add(et),ve&&console.warn(`DUPLICATED mime type '${ot.mime}' will be dropped`)}return Qe.size===0?W:W.filter((et,ot)=>!Qe.has(ot))}constructor(W,ve,Le){this.items=yi.ensureUniqueMimeTypes(W,!0),typeof ve=="string"?(this.id=ve,this.metadata=Le):(this.id=(0,A.$fg)(),this.metadata=ve??Le)}}e.$YL=yi;var tn;(function(K){K[K.Markup=1]="Markup",K[K.Code=2]="Code"})(tn||(e.NotebookCellKind=tn={}));var nn;(function(K){K[K.Idle=1]="Idle",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(nn||(e.NotebookCellExecutionState=nn={}));var rn;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(rn||(e.NotebookCellStatusBarAlignment=rn={}));var Ei;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(Ei||(e.NotebookEditorRevealType=Ei={}));class sn{constructor(W,ve){this.text=W,this.alignment=ve}}e.$ZL=sn;var je;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred"})(je||(e.NotebookControllerAffinity=je={}));var _t;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred",K[K.Hidden=-1]="Hidden"})(_t||(e.NotebookControllerAffinity2=_t={}));class on{constructor(W,ve=[]){this.uri=W,this.provides=(0,I.$2b)(ve)}}e.$1L=on;class $t{constructor(W){this.label=W}}e.$2L=$t;let Ui=class{constructor(W,ve){this.label=W,this.timestamp=ve}};e.$3L=Ui,e.$3L=Ui=He([C],Ui);var an;(function(K){K[K.Production=1]="Production",K[K.Development=2]="Development",K[K.Test=3]="Test"})(an||(e.ExtensionMode=an={}));var Bi;(function(K){K[K.Node=1]="Node",K[K.Webworker=2]="Webworker"})(Bi||(e.ExtensionRuntime=Bi={}));var cn;(function(K){K[K.Other=0]="Other",K[K.Comment=1]="Comment",K[K.String=2]="String",K[K.RegEx=3]="RegEx"})(cn||(e.StandardTokenType=cn={}));class ki{constructor(W,ve){this.ranges=W,this.wordPattern=ve}}e.$4L=ki;class pn{constructor(W){this.c=W}get autoForwardAction(){return this.c}}e.$5L=pn;var un;(function(K){K[K.Queued=1]="Queued",K[K.Running=2]="Running",K[K.Passed=3]="Passed",K[K.Failed=4]="Failed",K[K.Skipped=5]="Skipped",K[K.Errored=6]="Errored"})(un||(e.TestResultState=un={}));var ln;(function(K){K[K.Run=1]="Run",K[K.Debug=2]="Debug",K[K.Coverage=3]="Coverage"})(ln||(e.TestRunProfileKind=ln={}));let Si=class{constructor(W=void 0,ve=void 0,Le=void 0,Qe=!1){this.include=W,this.exclude=ve,this.profile=Le,this.continuous=Qe}};e.$6L=Si,e.$6L=Si=He([C],Si);let Wi=b=class{static diff(W,ve,Le){const Qe=new b(W);return Qe.expectedOutput=ve,Qe.actualOutput=Le,Qe}constructor(W){this.message=W}};e.$7L=Wi,e.$7L=Wi=b=He([C],Wi);let Vi=class{constructor(W){this.id=W}};e.$8L=Vi,e.$8L=Vi=He([C],Vi);let ci=class{constructor(W,ve){this.covered=W,this.total=ve}};e.$9L=ci,e.$9L=ci=He([C],ci);let qi=v=class{static fromDetails(W,ve){const Le=new ci(0,0),Qe=new ci(0,0),et=new ci(0,0);for(const ht of ve)if("branches"in ht){Le.total+=1,Le.covered+=ht.executionCount>0?1:0;for(const jt of ht.branches)Qe.total+=1,Qe.covered+=jt.executionCount>0?1:0}else et.total+=1,et.covered+=ht.executionCount>0?1:0;const ot=new v(W,Le,Qe.total>0?Qe:void 0,et.total>0?et:void 0);return ot.detailedCoverage=ve,ot}constructor(W,ve,Le,Qe){this.uri=W,this.statementCoverage=ve,this.branchCoverage=Le,this.functionCoverage=Qe}};e.$0L=qi,e.$0L=qi=v=He([C],qi);let Ki=class{constructor(W,ve,Le=[]){this.executionCount=W,this.location=ve,this.branches=Le}};e.$$L=Ki,e.$$L=Ki=He([C],Ki);let Hi=class{constructor(W,ve){this.executionCount=W,this.location=ve}};e.$_L=Hi,e.$_L=Hi=He([C],Hi);let Gi=class{constructor(W,ve){this.executionCount=W,this.location=ve}};e.$aM=Gi,e.$aM=Gi=He([C],Gi);var hn;(function(K){K[K.None=0]="None",K[K.Option=1]="Option",K[K.Default=2]="Default",K[K.Preferred=3]="Preferred"})(hn||(e.ExternalUriOpenerPriority=hn={}));var dn;(function(K){K[K.Untrusted=0]="Untrusted",K[K.Trusted=1]="Trusted",K[K.Unspecified=2]="Unspecified"})(dn||(e.WorkspaceTrustState=dn={}));var fn;(function(K){K[K.Notify=1]="Notify",K[K.OpenBrowser=2]="OpenBrowser",K[K.OpenPreview=3]="OpenPreview",K[K.Silent=4]="Silent",K[K.Ignore=5]="Ignore",K[K.OpenBrowserOnce=6]="OpenBrowserOnce"})(fn||(e.PortAutoForwardAction=fn={}));class pe{constructor(W,ve,Le,Qe,et,ot){this.kind=W,this.name=ve,this.detail=Le,this.uri=Qe,this.range=et,this.selectionRange=ot}}e.$bM=pe;class De{constructor(W){this.uri=W}}e.$cM=De;class Ne{constructor(W,ve){this.original=W,this.modified=ve}}e.$dM=Ne;class st{constructor(W,ve,Le,Qe){this.base=W,this.input1=ve,this.input2=Le,this.result=Qe}}e.$eM=st;class pt{constructor(W,ve){this.uri=W,this.viewType=ve}}e.$fM=pt;class Mt{constructor(W){this.viewType=W}}e.$gM=Mt;class Pn{constructor(W,ve){this.uri=W,this.notebookType=ve}}e.$hM=Pn;class An{constructor(W,ve,Le){this.original=W,this.modified=ve,this.notebookType=Le}}e.$iM=An;class Ln{constructor(){}}e.$jM=Ln;class Rn{constructor(W,ve){this.uri=W,this.inputBoxUri=ve}}e.$kM=Rn;class Mn{constructor(W){this.providerId=W}}e.$lM=Mn;var wn;(function(K){K[K.Down=0]="Down",K[K.Up=1]="Up"})(wn||(e.InteractiveSessionVoteDirection=wn={}));var vn;(function(K){K[K.Action=1]="Action",K[K.Toolbar=2]="Toolbar"})(vn||(e.InteractiveSessionCopyKind=vn={}));var yn;(function(K){K[K.Unhelpful=0]="Unhelpful",K[K.Helpful=1]="Helpful",K[K.Undone=2]="Undone",K[K.Accepted=3]="Accepted"})(yn||(e.InteractiveEditorResponseFeedbackKind=yn={}));var En;(function(K){K[K.System=0]="System",K[K.User=1]="User",K[K.Assistant=2]="Assistant",K[K.Function=3]="Function"})(En||(e.ChatMessageRole=En={}));var kn;(function(K){K[K.Short=1]="Short",K[K.Medium=2]="Medium",K[K.Full=3]="Full"})(kn||(e.ChatVariableLevel=kn={}));class Fn{constructor(W,ve){this.role=W,this.content=ve}}e.$mM=Fn;var Sn;(function(K){K[K.Unhelpful=0]="Unhelpful",K[K.Helpful=1]="Helpful"})(Sn||(e.ChatAgentResultFeedbackKind=Sn={}));var Dn;(function(K){K[K.SymbolInformation=1]="SymbolInformation",K[K.CommandInformation=2]="CommandInformation",K[K.SearchInformation=3]="SearchInformation",K[K.SettingInformation=4]="SettingInformation"})(Dn||(e.RelatedInformationType=Dn={}));var Cn;(function(K){K[K.Started=1]="Started",K[K.Recognizing=2]="Recognizing",K[K.Recognized=3]="Recognized",K[K.Stopped=4]="Stopped"})(Cn||(e.SpeechToTextStatus=Cn={}))}),define(ke[143],Se([1,0,60,17,13,176,127,7,19]),function($e,e,I,F,f,L,R,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BM=e.$AM=e.$zM=void 0;const m=new Map;function A(S,w){w?m.set(S,w):m.delete(S)}e.$zM=A;function P(S){return m.get(S)}class g extends L.$Zu{constructor(w,c,s,i,n,o,a,t){super(c,s,i,n),this.c=w,this.m=o,this.q=a,this.notebook=t,this.b=!1}dispose(){(0,I.ok)(!this.b),this.b=!0,this.q=!1}equalLines(w){return(0,E.$tb)(this.f,w)}get document(){if(!this.a){const w=this;this.a={get uri(){return w.d},get fileName(){return w.d.fsPath},get isUntitled(){return w.d.scheme===F.Schemas.untitled},get languageId(){return w.m},get version(){return w.h},get isClosed(){return w.b},get isDirty(){return w.q},save(){return w.r()},getText(c){return c?w.s(c):w.getText()},get eol(){return w.g===`
`?p.EndOfLine.LF:p.EndOfLine.CRLF},get lineCount(){return w.f.length},lineAt(c){return w.t(c)},offsetAt(c){return w.u(c)},positionAt(c){return w.v(c)},validateRange(c){return w.w(c)},validatePosition(c){return w.x(c)},getWordRangeAtPosition(c,s){return w.y(c,s)}}}return Object.freeze(this.a)}_acceptLanguageId(w){(0,I.ok)(!this.b),this.m=w}_acceptIsDirty(w){(0,I.ok)(!this.b),this.q=w}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(w){const c=this.w(w);if(c.isEmpty)return"";if(c.isSingleLine)return this.f[c.start.line].substring(c.start.character,c.end.character);const s=this.g,i=c.start.line,n=c.end.line,o=[];o.push(this.f[i].substring(c.start.character));for(let a=i+1;a<n;a++)o.push(this.f[a]);return o.push(this.f[n].substring(0,c.end.character)),o.join(s)}t(w){let c;if(w instanceof p.$yK?c=w.line:typeof w=="number"&&(c=w),typeof c!="number"||c<0||c>=this.f.length||Math.floor(c)!==c)throw new Error("Illegal value for `line`");return new y(c,this.f[c],c===this.f.length-1)}u(w){return w=this.x(w),this.l(),this.j.getPrefixSum(w.line-1)+w.character}v(w){w=Math.floor(w),w=Math.max(0,w),this.l();const c=this.j.getIndexOf(w),s=this.f[c.index].length;return new p.$yK(c.index,Math.min(c.remainder,s))}w(w){if(!(w instanceof p.$zK))throw new Error("Invalid argument");const c=this.x(w.start),s=this.x(w.end);return c===w.start&&s===w.end?w:new p.$zK(c.line,c.character,s.line,s.character)}x(w){if(!(w instanceof p.$yK))throw new Error("Invalid argument");if(this.f.length===0)return w.with(0,0);let{line:c,character:s}=w,i=!1;if(c<0)c=0,s=0,i=!0;else if(c>=this.f.length)c=this.f.length-1,s=this.f[c].length,i=!0;else{const n=this.f[c].length;s<0?(s=0,i=!0):s>n&&(s=n,i=!0)}return i?new p.$yK(c,s):w}y(w,c){const s=this.x(w);if(!c)c=P(this.m);else if((0,f.$Pe)(c))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${c.source}' because it matches the empty string.`);const i=(0,R.$_r)(s.character+1,(0,R.$0r)(c),this.f[s.line],0);if(i)return new p.$zK(s.line,i.startColumn-1,s.line,i.endColumn-1)}}e.$AM=g;class y{constructor(w,c,s){this.a=w,this.b=c,this.c=s}get lineNumber(){return this.a}get text(){return this.b}get range(){return new p.$zK(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new p.$zK(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$BM=y}),define(ke[286],Se([1,0,7,20,4]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aec=void 0;let L=class{constructor(p){this.a=new I.$TL(I.ColorThemeKind.Dark),this.b=new f.$Od}get activeColorTheme(){return this.a}$onColorThemeChange(p){let E;switch(p){case"light":E=I.ColorThemeKind.Light;break;case"hcDark":E=I.ColorThemeKind.HighContrast;break;case"hcLight":E=I.ColorThemeKind.HighContrastLight;break;default:E=I.ColorThemeKind.Dark}this.a=new I.$TL(E),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Aec=L,e.$Aec=L=He([Be(0,F.$xM)],L)}),define(ke[287],Se([1,0,5]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EI=e.CellExecutionUpdateType=void 0;var F;(function(f){f[f.Output=1]="Output",f[f.OutputItems=2]="OutputItems",f[f.ExecutionState=3]="ExecutionState"})(F||(e.CellExecutionUpdateType=F={})),e.$EI=(0,I.$Th)("INotebookExecutionService")}),define(ke[288],Se([1,0,3,29,193,99]),function($e,e,I,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yOb=void 0;class R extends I.$Rc{constructor(E,m,A){super(),this._source=E,this.b=m,this.c=A,this.a=void 0}f(E){const m=E.getLineCount();return new F.$xs(1,1,m,this.g(E,m))}g(E,m){if(m<1||m>E.getLineCount())throw new Error("Illegal value for lineNumber");return E.getLineLength(m)+1}get inputTextBuffer(){if(!this.b){const E=new f.$KB;E.acceptChunk(this._source);const m=E.finish(!0),{textBuffer:A,disposable:P}=m.create(1);this.b=A,this.B(P)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(E=>{const m=new f.$KB;m.acceptChunk(E);const A=m.finish(!0),{textBuffer:P,disposable:g}=A.create(1);return this.B(g),P})),this.a}findInInputs(E){const A=new L.$yB(E,!1,!1,null).parseSearchRequest();if(!A)return[];const P=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(P,A,!0,5e3)}findInOutputs(E){const A=new L.$yB(E,!1,!1,null).parseSearchRequest();return A?this.outputTextBuffers.map(P=>{const g=P.findMatchesLineByLine(this.f(P),A,!0,5e3);if(g.length!==0)return{textBuffer:P,matches:g}}).filter(P=>!!P):[]}}e.$yOb=R}),define(ke[68],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lJ=e.TestPosition=e.TestIdPathParts=void 0;var I;(function(L){L.Delimiter="\0"})(I||(e.TestIdPathParts=I={}));var F;(function(L){L[L.IsSame=0]="IsSame",L[L.Disconnected=1]="Disconnected",L[L.IsChild=2]="IsChild",L[L.IsParent=3]="IsParent"})(F||(e.TestPosition=F={}));class f{static fromExtHostTestItem(R,p,E=R.parent){if(R._isRoot)return new f([p]);const m=[R.id];for(let A=E;A&&A.id!==p;A=A.parent)m.push(A.id);return m.push(p),new f(m.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const p=R.indexOf("\0");return p===-1?R:R.slice(0,p)}static fromString(R){return new f(R.split("\0"))}static join(R,p){return new f([...R.path,p])}static joinToString(R,p){return R.toString()+"\0"+p}static parentId(R){const p=R.lastIndexOf("\0");return p===-1?void 0:R.slice(0,p)}static localId(R){const p=R.lastIndexOf("\0");return p===-1?R:R.slice(p+1)}static isChild(R,p){return p.startsWith(R)&&p[R.length]==="\0"}static compare(R,p){return R===p?0:f.isChild(R,p)?2:f.isChild(p,R)?3:1}constructor(R,p=R.length){if(this.path=R,this.d=p,R.length===0||p<1)throw new Error("cannot create test with empty path")}get rootId(){return new f(this.path,1)}get parentId(){return this.d>1?new f(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new f(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new f(this.path,R)}compare(R){if(typeof R=="string")return f.compare(this.toString(),R);for(let p=0;p<R.d&&p<this.d;p++)if(R.path[p]!==this.path[p])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.$lJ=f}),define(ke[89],Se([1,0,2,29,68]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sJ=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$rJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$qJ=e.$pJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$oJ=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$nJ=e.$mJ=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var L;(function(D){D[D.Unset=0]="Unset",D[D.Queued=1]="Queued",D[D.Running=2]="Running",D[D.Passed=3]="Passed",D[D.Failed=4]="Failed",D[D.Skipped=5]="Skipped",D[D.Errored=6]="Errored"})(L||(e.TestResultState=L={}));var R;(function(D){D[D.Run=1]="Run",D[D.Debug=2]="Debug",D[D.Coverage=3]="Coverage"})(R||(e.ExtTestRunProfileKind=R={}));var p;(function(D){D[D.Run=2]="Run",D[D.Debug=4]="Debug",D[D.Coverage=8]="Coverage",D[D.HasNonDefaultProfile=16]="HasNonDefaultProfile",D[D.HasConfigurable=32]="HasConfigurable",D[D.SupportsContinuousRun=64]="SupportsContinuousRun"})(p||(e.TestRunProfileBitset=p={})),e.$mJ=[2,4,8,16,32,64];const E=D=>"runId"in D;e.$nJ=E;var m;(function(D){D.serialize=$=>({range:$.range.toJSON(),uri:$.uri.toJSON()}),D.deserialize=$=>({range:F.$xs.lift($.range),uri:I.URI.revive($.uri)})})(m||(e.IRichLocation=m={}));var A;(function(D){D[D.Error=0]="Error",D[D.Output=1]="Output"})(A||(e.TestMessageType=A={}));var P;(function(D){D.serialize=$=>({message:$.message,type:0,expected:$.expected,actual:$.actual,contextValue:$.contextValue,location:$.location&&m.serialize($.location)}),D.deserialize=$=>({message:$.message,type:0,expected:$.expected,actual:$.actual,contextValue:$.contextValue,location:$.location&&m.deserialize($.location)})})(P||(e.ITestErrorMessage=P={}));const g=(D,$)=>`${$?"s":"e"}${D}`;e.$oJ=g;var y;(function(D){D.serialize=$=>({message:$.message,type:1,offset:$.offset,length:$.length,location:$.location&&m.serialize($.location)}),D.deserialize=$=>({message:$.message,type:1,offset:$.offset,length:$.length,location:$.location&&m.deserialize($.location)})})(y||(e.ITestOutputMessage=y={}));var S;(function(D){D.serialize=$=>$.type===0?P.serialize($):y.serialize($),D.deserialize=$=>$.type===0?P.deserialize($):y.deserialize($)})(S||(e.ITestMessage=S={}));var w;(function(D){D.serializeWithoutMessages=$=>({state:$.state,duration:$.duration,messages:[]}),D.serialize=$=>({state:$.state,duration:$.duration,messages:$.messages.map(S.serialize)}),D.deserialize=$=>({state:$.state,duration:$.duration,messages:$.messages.map(S.deserialize)})})(w||(e.ITestTaskState=w={}));const c="\0",s=(D,$)=>D+c+$;e.$pJ=s;const i=D=>{const $=D.indexOf(c);return{ctrlId:D.slice(0,$),tagId:D.slice($+1)}};e.$qJ=i;var n;(function(D){D.serialize=$=>({extId:$.extId,label:$.label,tags:$.tags,busy:$.busy,children:void 0,uri:$.uri?.toJSON(),range:$.range?.toJSON()||null,description:$.description,error:$.error,sortText:$.sortText}),D.deserialize=$=>({extId:$.extId,label:$.label,tags:$.tags,busy:$.busy,children:void 0,uri:$.uri?I.URI.revive($.uri):void 0,range:$.range?F.$xs.lift($.range):null,description:$.description,error:$.error,sortText:$.sortText})})(n||(e.ITestItem=n={}));var o;(function(D){D[D.NotExpandable=0]="NotExpandable",D[D.Expandable=1]="Expandable",D[D.BusyExpanding=2]="BusyExpanding",D[D.Expanded=3]="Expanded"})(o||(e.TestItemExpandState=o={}));var a;(function(D){D.serialize=$=>({expand:$.expand,item:n.serialize($.item)}),D.deserialize=$=>({controllerId:f.$lJ.root($.item.extId),expand:$.expand,item:n.deserialize($.item)})})(a||(e.InternalTestItem=a={}));var t;(function(D){D.serialize=$=>{let b;return $.item&&(b={},$.item.label!==void 0&&(b.label=$.item.label),$.item.tags!==void 0&&(b.tags=$.item.tags),$.item.busy!==void 0&&(b.busy=$.item.busy),$.item.uri!==void 0&&(b.uri=$.item.uri?.toJSON()),$.item.range!==void 0&&(b.range=$.item.range?.toJSON()),$.item.description!==void 0&&(b.description=$.item.description),$.item.error!==void 0&&(b.error=$.item.error),$.item.sortText!==void 0&&(b.sortText=$.item.sortText)),{extId:$.extId,expand:$.expand,item:b}},D.deserialize=$=>{let b;return $.item&&(b={},$.item.label!==void 0&&(b.label=$.item.label),$.item.tags!==void 0&&(b.tags=$.item.tags),$.item.busy!==void 0&&(b.busy=$.item.busy),$.item.range!==void 0&&(b.range=$.item.range?F.$xs.lift($.item.range):null),$.item.description!==void 0&&(b.description=$.item.description),$.item.error!==void 0&&(b.error=$.item.error),$.item.sortText!==void 0&&(b.sortText=$.item.sortText)),{extId:$.extId,expand:$.expand,item:b}}})(t||(e.ITestItemUpdate=t={}));const r=(D,$)=>{$.expand!==void 0&&(D.expand=$.expand),$.item!==void 0&&(D.item=D.item?Object.assign(D.item,$.item):$.item)};e.$rJ=r;var d;(function(D){D.serializeWithoutMessages=$=>({...a.serialize($),ownComputedState:$.ownComputedState,computedState:$.computedState,tasks:$.tasks.map(w.serializeWithoutMessages)}),D.serialize=$=>({...a.serialize($),ownComputedState:$.ownComputedState,computedState:$.computedState,tasks:$.tasks.map(w.serialize)}),D.deserialize=$=>({...a.deserialize($),ownComputedState:$.ownComputedState,computedState:$.computedState,tasks:$.tasks.map(w.deserialize),retired:!0})})(d||(e.TestResultItem=d={}));var u;(function(D){D[D.Function=0]="Function",D[D.Statement=1]="Statement"})(u||(e.DetailType=u={}));var l;(function(D){D[D.Add=0]="Add",D[D.Update=1]="Update",D[D.DocumentSynced=2]="DocumentSynced",D[D.Remove=3]="Remove",D[D.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",D[D.Retire=5]="Retire",D[D.AddTag=6]="AddTag",D[D.RemoveTag=7]="RemoveTag"})(l||(e.TestDiffOpType=l={}));var h;(function(D){D.deserialize=$=>$.op===0?{op:$.op,item:a.deserialize($.item)}:$.op===1?{op:$.op,item:t.deserialize($.item)}:$.op===2?{op:$.op,uri:I.URI.revive($.uri),docv:$.docv}:$,D.serialize=$=>$.op===0?{op:$.op,item:a.serialize($.item)}:$.op===1?{op:$.op,item:t.serialize($.item)}:$})(h||(e.TestsDiffOp=h={}));class k{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply($){const b=this.o();for(const v of $)switch(v.op){case 0:this.j(a.deserialize(v.item),b);break;case 1:this.k(t.deserialize(v.item),b);break;case 3:this.l(v.itemId,b);break;case 5:this.m(v.itemId);break;case 4:this.updatePendingRoots(v.amount);break;case 6:this.c.set(v.tag.id,v.tag);break;case 7:this.c.delete(v.id);break}b.complete?.()}j($,b){const v=f.$lJ.parentId($.item.extId)?.toString();let C;if(!v)C=this.p($),this.f.add(C),this.d.set($.item.extId,C);else if(this.d.has(v)){const N=this.d.get(v);N.children.add($.item.extId),C=this.p($,N),this.d.set($.item.extId,C)}else{console.error(`Test with unknown parent ID: ${JSON.stringify($)}`);return}return b.add?.(C),$.expand===2&&this.g++,C}k($,b){const v=this.d.get($.extId);if(v)return $.expand!==void 0&&(v.expand===2&&this.g--,$.expand===2&&this.g++),(0,e.$rJ)(v,$),b.update?.(v),v}l($,b){const v=this.d.get($);if(!v)return;const C=f.$lJ.parentId(v.item.extId)?.toString();C?this.d.get(C).children.delete(v.item.extId):this.f.delete(v);const N=[[$]];for(;N.length;)for(const z of N.pop()){const M=this.d.get(z);M&&(N.push(M.children),this.d.delete(z),b.remove?.(M,M!==v),M.expand===2&&this.g--)}}m($){}updatePendingRoots($){this.h+=$}o(){return{}}}e.$sJ=k}),define(ke[112],Se([1,0,10,4,3,60,89,68]),function($e,e,I,F,f,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rM=e.$qM=e.$pM=e.$oM=e.$nM=e.TestItemEventOp=void 0;var E;(function(i){i[i.Upsert=0]="Upsert",i[i.SetTags=1]="SetTags",i[i.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",i[i.RemoveChild=3]="RemoveChild",i[i.SetProp=4]="SetProp",i[i.Bulk=5]="Bulk",i[i.DocumentSynced=6]="DocumentSynced"})(E||(e.TestItemEventOp=E={}));const m=(i,n)=>i===n,P=Object.entries({range:(i,n)=>i===n?!0:!i||!n?!1:i.equalsRange(n),busy:m,label:m,description:m,error:m,sortText:m,tags:(i,n)=>!(i.length!==n.length||i.some(o=>!n.includes(o)))}),g=(i,n)=>{let o;for(const[a,t]of P)t(i[a],n[a])||(o?o[a]=n[a]:o={[a]:n[a]});return o};class y extends f.$Rc{get root(){return this.s.root}constructor(n){super(),this.s=n,this.f=this.B(new I.$8g(()=>this.flushDiff(),200)),this.g=this.B(new F.$Od),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(n){this.h=n;for(const o of this.tree.values())this.I(o)}get resolveHandler(){return this.h}collectDiff(){const n=this.m;return this.m=[],n}pushDiff(n){switch(n.op){case 2:{for(const o of this.m)if(o.op===2&&o.uri===n.uri){o.docv=n.docv;return}break}case 1:{const o=this.m[this.m.length-1];if(o){if(o.op===1&&o.item.extId===n.item.extId){(0,R.$rJ)(o.item,n.item);return}if(o.op===0&&o.item.item.extId===n.item.extId){(0,R.$rJ)(o.item,n.item);return}}break}}this.m.push(n),this.f.isScheduled()||this.f.schedule()}expand(n,o){const a=this.tree.get(n);if(a){if((a.expandLevels===void 0||o>a.expandLevels)&&(a.expandLevels=o),a.expand===1){const t=this.L(a);return t.isOpen()?this.J(a,o-1):t.wait().then(()=>this.J(a,o-1))}else if(a.expand===3)return a.resolveBarrier?.isOpen()===!1?a.resolveBarrier.wait().then(()=>this.J(a,o-1)):this.J(a,o-1)}}dispose(){for(const n of this.tree.values())this.s.getApiFor(n.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(n,o){switch(o.op){case 3:this.N(p.$lJ.joinToString(n.fullId,o.id));break;case 0:this.y(o.item,n);break;case 5:for(const a of o.ops)this.u(n,a);break;case 1:this.z(o.new,o.old,n.fullId.toString());break;case 2:this.I(n);break;case 4:this.pushDiff({op:1,item:{extId:n.fullId.toString(),item:o.update}});break;case 6:this.w(n.actual.uri);break;default:(0,L.$3c)(o)}}w(n){n&&this.pushDiff({op:2,uri:n,docv:this.s.getDocumentVersion(n)})}y(n,o){const a=p.$lJ.fromExtHostTestItem(n,this.root.id,o?.actual),t=this.s.getApiFor(n);t.parent&&t.parent!==o?.actual&&this.s.getChildren(t.parent).delete(n.id);let r=this.tree.get(a.toString());if(!r){r={fullId:a,actual:n,expandLevels:o?.expandLevels?o.expandLevels-1:void 0,expand:0},n.tags.forEach(this.C,this),this.tree.set(r.fullId.toString(),r),this.F(n,o),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:r.expand,item:this.s.toITestItem(n)}}),this.H(n,r,o);return}if(r.actual===n){this.G(n,r,o);return}if(r.actual.uri?.toString()!==n.uri?.toString())return this.N(a.toString()),this.y(n,o);const d=this.s.getChildren(r.actual),u=r.actual,l=g(this.s.toITestItem(u),this.s.toITestItem(n));this.s.getApiFor(u).listener=void 0,r.actual=n,r.expand=0,l&&(l.hasOwnProperty("tags")&&(this.z(n.tags,u.tags,a.toString()),delete l.tags),this.u(r,{op:4,update:l})),this.H(n,r,o);for(const[h,k]of d)this.s.getChildren(n).get(k.id)||this.N(p.$lJ.joinToString(a,k.id));this.w(r.actual.uri)}z(n,o,a){const t=new Set(o.map(r=>r.id));for(const r of n)t.delete(r.id)||this.C(r);this.pushDiff({op:1,item:{extId:a,item:{tags:n.map(r=>(0,R.$pJ)(this.s.controllerId,r.id))}}}),t.forEach(this.D,this)}C(n){const o=this.j.get(n.id);o?o.refCount++:(this.j.set(n.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.$pJ)(this.s.controllerId,n.id)}}))}D(n){const o=this.j.get(n);o&&!--o.refCount&&(this.j.delete(n),this.pushDiff({op:7,id:(0,R.$pJ)(this.s.controllerId,n)}))}F(n,o){this.s.getApiFor(n).parent=o&&o.actual!==this.root?o.actual:void 0}G(n,o,a){this.F(n,a);const t=this.s.getApiFor(n);t.parent=a?.actual,t.listener=r=>this.u(o,r),this.I(o)}H(n,o,a){this.G(n,o,a);for(const[t,r]of this.s.getChildren(n))this.y(r,o)}I(n){let o;this.h?n.resolveBarrier?o=n.resolveBarrier.isOpen()?3:2:o=n.actual.canResolveChildren?1:0:o=0,o!==n.expand&&(n.expand=o,this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:o}}),o===1&&n.expandLevels!==void 0&&this.L(n))}J(n,o){if(o<0)return;const a=[];for(const[t,r]of this.s.getChildren(n.actual)){const d=this.expand(p.$lJ.joinToString(n.fullId,r.id),o);(0,I.$Hg)(d)&&a.push(d)}if(a.length)return Promise.all(a).then(()=>{})}L(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this.h){const r=new I.$Tg;return r.open(),r}n.expand=2,this.M(n);const o=n.resolveBarrier=new I.$Tg,a=r=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,r)};let t;try{t=this.h(n.actual===this.root?void 0:n.actual)}catch(r){a(r)}return(0,I.$Hg)(t)?t.catch(a).then(()=>{o.open(),this.I(n)}):(o.open(),this.I(n)),n.resolveBarrier}M(n){this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:n.expand}})}N(n){const o=this.tree.get(n);if(!o)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:n});const a=[o];for(;a.length;){const t=a.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const r of t.actual.tags)this.D(r.id);this.tree.delete(t.fullId.toString());for(const[r,d]of this.s.getChildren(t.actual))a.push(this.tree.get(p.$lJ.joinToString(t.fullId,d.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.g.fire(n)}}e.$nM=y;class S extends Error{constructor(n){super(`Attempted to insert a duplicate test item ID ${n}`)}}e.$oM=S;class w extends Error{constructor(n){super(`TestItem with ID "${n}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$pM=w;class c extends Error{constructor(n,o,a){super(`TestItem with ID "${n}" is from controller "${o}" and cannot be added as a child of an item from controller "${a}".`)}}e.$qM=c;const s=(i,n,o)=>{let a=new Map;return{get size(){return a.size},forEach(t,r){for(const d of a.values())t.call(r,d,this)},[Symbol.iterator](){return a.entries()},replace(t){const r=new Map,d=new Set(a.keys()),u={op:5,ops:[]};for(const l of t){if(!(l instanceof o))throw new w(l.id);const h=n(l).controllerId;if(h!==i.controllerId)throw new c(l.id,h,i.controllerId);if(r.has(l.id))throw new S(l.id);r.set(l.id,l),d.delete(l.id),u.ops.push({op:0,item:l})}for(const l of d.keys())u.ops.push({op:3,id:l});i.listener?.(u),a=r},add(t){if(!(t instanceof o))throw new w(t.id);a.set(t.id,t),i.listener?.({op:0,item:t})},delete(t){a.delete(t)&&i.listener?.({op:3,id:t})},get(t){return a.get(t)},toJSON(){return Array.from(a.values())}}};e.$rM=s}),define(ke[144],Se([1,0,112]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tM=e.$sM=void 0;const F=new WeakMap,f=(R,p)=>{const E={controllerId:p};return F.set(R,E),E};e.$sM=f;const L=R=>{const p=F.get(R);if(!p)throw new I.$pM(R?.id||"<unknown>");return p};e.$tM=L}),define(ke[113],Se([1,0,17,2]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3tb=e.$2tb=e.$1tb=e.$Ztb=e.$Ytb=void 0,e.$Ytb="vscode-cdn.net",e.$Ztb=`vscode-resource.${e.$Ytb}`,e.$1tb=`'self' https://*.${e.$Ytb}`;function f(p,E){return p.scheme===I.Schemas.http||p.scheme===I.Schemas.https?p:(E&&E.authority&&E.isRemote&&p.scheme===I.Schemas.file&&(p=F.URI.from({scheme:I.Schemas.vscodeRemote,authority:E.authority,path:p.path})),F.URI.from({scheme:I.Schemas.https,authority:`${p.scheme}+${L(p.authority)}.${e.$Ztb}`,path:p.path,fragment:p.fragment,query:p.query}))}e.$2tb=f;function L(p){return p.replace(/./g,E=>{const m=E.charCodeAt(0);return m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57?E:"-"+m.toString(16).padStart(4,"0")})}function R(p){return p.replace(/-([0-9a-f]{4})/g,(E,m)=>String.fromCharCode(parseInt(m,16)))}e.$3tb=R}),define(ke[289],Se([1,0,4,3,113]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$dc=void 0;class L{constructor(p,E,m){this.d=p,this.e=E,this.f=m,this.a=0,this.b=new F.$Qc,this.c=new Map,this.b.add(E.onDidChangeVisibleTextEditors(()=>{const A=E.getVisibleTextEditors();for(const P of this.c.values())A.indexOf(P.editor)<0&&P.inset.dispose()}))}dispose(){this.c.forEach(p=>p.inset.dispose()),this.b.dispose()}createWebviewEditorInset(p,E,m,A,P){let g;for(const n of this.e.getVisibleTextEditors(!0))if(n.value===p){g=n;break}if(!g)throw new Error("not a visible editor");const y=this,S=this.a++,w=new I.$Od,c=new I.$Od,s=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(n){return(0,f.$2tb)(n,y.f)}get cspSource(){return f.$1tb}set options(n){this.b=n,y.d.$setOptions(S,n)}get options(){return this.b}set html(n){this.a=n,y.d.$setHtml(S,n)}get html(){return this.a}get onDidReceiveMessage(){return w.event}postMessage(n){return y.d.$postMessage(S,n)}},i=new class{constructor(){this.editor=p,this.line=E,this.height=m,this.webview=s,this.onDidDispose=c.event}dispose(){y.c.has(S)&&(y.c.delete(S),y.d.$disposeEditorInset(S),c.fire(),c.dispose(),w.dispose())}};return this.d.$createEditorInset(S,g.id,g.value.document.uri,E+1,m,A||{},P.identifier,P.extensionLocation),this.c.set(S,{editor:p,inset:i,onDidReceiveMessage:w}),i}$onDidDispose(p){const E=this.c.get(p);E&&E.inset.dispose()}$onDidReceiveMessage(p,E){this.c.get(p)?.onDidReceiveMessage.fire(E)}}e.$$dc=L}),define(ke[290],Se([1,0,5]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kN=e.VariableKind=e.$jN=void 0,e.$jN=(0,I.$Th)("configurationResolverService");var F;(function(L){L.Unknown="unknown",L.Env="env",L.Config="config",L.Command="command",L.Input="input",L.ExtensionInstallFolder="extensionInstallFolder",L.WorkspaceFolder="workspaceFolder",L.Cwd="cwd",L.WorkspaceFolderBasename="workspaceFolderBasename",L.UserHome="userHome",L.LineNumber="lineNumber",L.SelectedText="selectedText",L.File="file",L.FileWorkspaceFolder="fileWorkspaceFolder",L.RelativeFile="relativeFile",L.RelativeFileDirname="relativeFileDirname",L.FileDirname="fileDirname",L.FileExtname="fileExtname",L.FileBasename="fileBasename",L.FileBasenameNoExtension="fileBasenameNoExtension",L.FileDirnameBasename="fileDirnameBasename",L.ExecPath="execPath",L.ExecInstallFolder="execInstallFolder",L.PathSeparator="pathSeparator"})(F||(e.VariableKind=F={}));class f extends Error{constructor(R,p){super(p),this.variable=R}}e.$kN=f}),define(ke[291],Se([1,0,16,49,18,24,12,102,233,290,13]),function($e,e,I,F,f,L,R,p,E,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yN=void 0;class P{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(y,S,w,c){this.h=new Map,this.a=y,this.b=S,this.g=w,c&&(this.c=c.then(s=>this.i(s)))}i(y){if(R.$j){const S=Object.create(null);return Object.keys(y).forEach(w=>{S[w.toLowerCase()]=y[w]}),S}return y}resolveWithEnvironment(y,S,w){return this.l({env:this.i(y),userHome:void 0},S?S.uri:void 0,w)}async resolveAsync(y,S){const w={env:await this.c,userHome:await this.g};return this.l(w,y?y.uri:void 0,S)}async j(y,S,w,c){const s=L.$$m(S);R.$j&&s.windows?Object.keys(s.windows).forEach(n=>s[n]=s.windows[n]):R.$k&&s.osx?Object.keys(s.osx).forEach(n=>s[n]=s.osx[n]):R.$l&&s.linux&&Object.keys(s.linux).forEach(n=>s[n]=s.linux[n]),delete s.windows,delete s.osx,delete s.linux;const i={env:await this.c,userHome:await this.g};return this.l(i,y?y.uri:void 0,s,w,c)}async resolveAnyAsync(y,S,w){return this.j(y,S,w)}async resolveAnyMap(y,S,w){const c=new Map;return{newConfig:await this.j(y,S,w,c),resolvedVariables:c}}resolveWithInteractionReplace(y,S,w,c){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(y,S,w,c){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(y,S){if(this.h.has(y))throw new Error("Variable "+y+" is contributed twice.");this.h.set(y,S)}async l(y,S,w,c,s){if(f.$zf(w))return this.m(y,S,w,c,s);if(Array.isArray(w))return Promise.all(w.map(i=>this.l(y,S,i,c,s)));if(f.$Bf(w)){const i=Object.create(null),n=await Promise.all(Object.keys(w).map(async o=>[await this.m(y,S,o,c,s),await this.l(y,S,w[o],c,s)]));for(const[o,a]of n)i[o]=a;return i}return w}m(y,S,w,c,s){return(0,A.$Ue)(w,P.VARIABLE_REGEXP,async(i,n)=>{if(n.includes(P.VARIABLE_LHS))return i;let o=await this.o(y,i,n,S,c);return s?.set(n,o),o!==i&&f.$zf(o)&&o.match(P.VARIABLE_REGEXP)&&(o=await this.m(y,S,o,c,s)),o})}n(y){return this.b?this.b.getUriLabel(y,{noPrefix:!0}):y.fsPath}async o(y,S,w,c,s){let i;const n=w.split(":");n.length>1&&(w=n[0],i=n[1]);const o=r=>{const d=this.a.getFilePath();if(d)return(0,p.$wv)(d);throw new m.$kN(r,(0,E.localize)(0,null,S))},a=r=>{const d=o(r);if(this.a.getWorkspaceFolderPathForFile){const u=this.a.getWorkspaceFolderPathForFile();if(u)return(0,p.$wv)(u)}throw new m.$kN(r,(0,E.localize)(1,null,S,I.$mc(d)))},t=r=>{if(i){const d=this.a.getFolderUri(i);if(d)return d;throw new m.$kN(r,(0,E.localize)(2,null,S,i))}if(c)return c;throw this.a.getWorkspaceFolderCount()>1?new m.$kN(r,(0,E.localize)(3,null,S)):new m.$kN(r,(0,E.localize)(4,null,S))};switch(w){case"env":if(i){if(y.env){const r=y.env[R.$j?i.toLowerCase():i];if(f.$zf(r))return r}return""}throw new m.$kN(m.VariableKind.Env,(0,E.localize)(5,null,S));case"config":if(i){const r=this.a.getConfigurationValue(c,i);if(f.$If(r))throw new m.$kN(m.VariableKind.Config,(0,E.localize)(6,null,S,i));if(f.$Bf(r))throw new m.$kN(m.VariableKind.Config,(0,E.localize)(7,null,S,i));return r}throw new m.$kN(m.VariableKind.Config,(0,E.localize)(8,null,S));case"command":return this.p(m.VariableKind.Command,S,i,s,"command");case"input":return this.p(m.VariableKind.Input,S,i,s,"input");case"extensionInstallFolder":if(i){const r=await this.a.getExtension(i);if(!r)throw new m.$kN(m.VariableKind.ExtensionInstallFolder,(0,E.localize)(9,null,S,i));return this.n(r.extensionLocation)}throw new m.$kN(m.VariableKind.ExtensionInstallFolder,(0,E.localize)(10,null,S));default:switch(w){case"workspaceRoot":case"workspaceFolder":return(0,p.$wv)(this.n(t(m.VariableKind.WorkspaceFolder)));case"cwd":return c||i?(0,p.$wv)(this.n(t(m.VariableKind.Cwd))):F.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,p.$wv)(I.$mc(this.n(t(m.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(y.userHome)return y.userHome;throw new m.$kN(m.VariableKind.UserHome,(0,E.localize)(11,null,S))}case"lineNumber":{const r=this.a.getLineNumber();if(r)return r;throw new m.$kN(m.VariableKind.LineNumber,(0,E.localize)(12,null,S))}case"selectedText":{const r=this.a.getSelectedText();if(r)return r;throw new m.$kN(m.VariableKind.SelectedText,(0,E.localize)(13,null,S))}case"file":return o(m.VariableKind.File);case"fileWorkspaceFolder":return a(m.VariableKind.FileWorkspaceFolder);case"relativeFile":return c||i?I.$kc(this.n(t(m.VariableKind.RelativeFile)),o(m.VariableKind.RelativeFile)):o(m.VariableKind.RelativeFile);case"relativeFileDirname":{const r=I.$lc(o(m.VariableKind.RelativeFileDirname));if(c||i){const d=I.$kc(this.n(t(m.VariableKind.RelativeFileDirname)),r);return d.length===0?".":d}return r}case"fileDirname":return I.$lc(o(m.VariableKind.FileDirname));case"fileExtname":return I.$nc(o(m.VariableKind.FileExtname));case"fileBasename":return I.$mc(o(m.VariableKind.FileBasename));case"fileBasenameNoExtension":{const r=I.$mc(o(m.VariableKind.FileBasenameNoExtension));return r.slice(0,r.length-I.$nc(r).length)}case"fileDirnameBasename":return I.$mc(I.$lc(o(m.VariableKind.FileDirnameBasename)));case"execPath":{const r=this.a.getExecPath();return r||S}case"execInstallFolder":{const r=this.a.getAppRoot();return r||S}case"pathSeparator":return I.sep;default:try{const r=i?`${w}:${i}`:w;return this.p(m.VariableKind.Unknown,S,r,s,void 0)}catch{return S}}}}p(y,S,w,c,s){if(w&&c){const i=s===void 0?c[w]:c[s+":"+w];if(typeof i=="string")return i;throw new m.$kN(y,(0,E.localize)(14,null,S))}return S}}e.$yN=P}),define(ke[145],Se([1,0,5,141]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GC=e.$FC=e.OpenEditorContext=e.GroupsOrder=e.$EC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$DC=void 0,e.$DC=(0,I.$Th)("editorGroupsService");var f;(function(S){S[S.UP=0]="UP",S[S.DOWN=1]="DOWN",S[S.LEFT=2]="LEFT",S[S.RIGHT=3]="RIGHT"})(f||(e.GroupDirection=f={}));var L;(function(S){S[S.HORIZONTAL=0]="HORIZONTAL",S[S.VERTICAL=1]="VERTICAL"})(L||(e.GroupOrientation=L={}));var R;(function(S){S[S.FIRST=0]="FIRST",S[S.LAST=1]="LAST",S[S.NEXT=2]="NEXT",S[S.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var p;(function(S){S[S.MAXIMIZE=0]="MAXIMIZE",S[S.EXPAND=1]="EXPAND",S[S.EVEN=2]="EVEN"})(p||(e.GroupsArrangement=p={}));var E;(function(S){S[S.COPY_EDITORS=0]="COPY_EDITORS",S[S.MOVE_EDITORS=1]="MOVE_EDITORS"})(E||(e.MergeGroupMode=E={}));function m(S){const w=S;return(0,F.$lE)(w?.editor)&&(0,F.$lE)(w?.replacement)}e.$EC=m;var A;(function(S){S[S.CREATION_TIME=0]="CREATION_TIME",S[S.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",S[S.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var P;(function(S){S[S.NEW_EDITOR=1]="NEW_EDITOR",S[S.MOVE_EDITOR=2]="MOVE_EDITOR",S[S.COPY_EDITOR=3]="COPY_EDITOR"})(P||(e.OpenEditorContext=P={}));function g(S){const w=S;return!!w&&typeof w.id=="number"&&Array.isArray(w.editors)}e.$FC=g;function y(S){return S.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$GC=y}),define(ke[292],Se([1,0,5,145]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KC=e.$JC=e.$IC=e.$HC=void 0,e.$HC=(0,I.$Th)("editorService"),e.$IC=-1,e.$JC=-2;function f(L){const R=L;return typeof L=="number"||(0,F.$FC)(R)}e.$KC=f}),define(ke[146],Se([1,0,5,134]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PJ=void 0,e.$PJ=(0,I.$Uh)(F.$1h)}),define(ke[147],Se([1,0,26,4,16,3]),function($e,e,I,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h5b=e.$g5b=e.$f5b=e.$e5b=e.$d5b=void 0;class R{constructor(s,i){this.versionId=s,this.removedDueToLooping=i}}e.$d5b=R;class p{static isHostExtension(s,i,n){if(i.getExtensionDescription(s))return!1;const o=n.getExtensionDescription(s);return o?!!((o.main||o.browser)&&o.api==="none"):!1}constructor(s,i){this.j=s,this.c=new F.$Od,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(S),this.f=new I.$_l,this.g=[],this.h=new Map;for(const s of this.e){if(this.f.has(s.identifier)){console.error("Extension `"+s.identifier.value+"` is already registered");continue}this.f.set(s.identifier,s),this.g.push(s);const i=this.j.readActivationEvents(s);for(const n of i)this.h.has(n)||this.h.set(n,[]),this.h.get(n).push(s)}}set(s){return this.e=s,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(s,i){this.e=w(this.e,i),this.e=this.e.concat(s);const n=p.l(this.e);return this.e=w(this.e,n.map(o=>o.identifier)),this.k(),this.d++,this.c.fire(void 0),new R(this.d,n)}static l(s){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(r){this.d.has(r)||(this.d.add(r),this.e.push(r))}addArc(r,d){this.addNode(r),this.addNode(d),this.c.has(r)?this.c.get(r).push(d):this.c.set(r,[d])}getArcs(r){return this.c.has(r)?this.c.get(r):[]}hasOnlyGoodArcs(r,d){const u=i.getArcs(r);for(let l=0;l<u.length;l++)if(!d.has(u[l]))return!1;return!0}getNodes(){return this.e}},n=new I.$_l;for(const r of s)if(n.set(r.identifier,r),r.extensionDependencies)for(const d of r.extensionDependencies)i.addArc(I.$0l.toKey(r.identifier),I.$0l.toKey(d));const o=new Set;i.getNodes().filter(r=>i.getArcs(r).length===0).forEach(r=>o.add(r));const a=i.getNodes().filter(r=>!o.has(r));let t;do{t=!1;for(let r=0;r<a.length;r++){const d=a[r];i.hasOnlyGoodArcs(d,o)&&(a.splice(r,1),r--,o.add(d),t=!0)}}while(t);return a.map(r=>n.get(r))}containsActivationEvent(s){return this.h.has(s)}containsExtension(s){return this.f.has(s)}getExtensionDescriptionsForActivationEvent(s){const i=this.h.get(s);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new E(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(s){const i=this.f.get(s);return i||void 0}getExtensionDescriptionByUUID(s){for(const i of this.g)if(i.uuid===s)return i}getExtensionDescriptionByIdOrUUID(s,i){return this.getExtensionDescription(s)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$e5b=p;class E{constructor(s,i){this.versionId=s,this.extensions=i}}e.$f5b=E;class m{constructor(s){this.d=new g,this.c=new p(s,[])}async acquireLock(s){const i=await this.d.acquire(s);return new A(this,i)}deltaExtensions(s,i,n){if(!s.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,n)}containsActivationEvent(s){return this.c.containsActivationEvent(s)}containsExtension(s){return this.c.containsExtension(s)}getExtensionDescriptionsForActivationEvent(s){return this.c.getExtensionDescriptionsForActivationEvent(s)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(s){return this.c.getExtensionDescription(s)}getExtensionDescriptionByUUID(s){return this.c.getExtensionDescriptionByUUID(s)}getExtensionDescriptionByIdOrUUID(s,i){return this.c.getExtensionDescriptionByIdOrUUID(s,i)}}e.$g5b=m;class A extends L.$Rc{constructor(s,i){super(),this.f=s,this.c=!1,this.B(i)}isAcquiredFor(s){return!this.c&&this.f===s}}e.$h5b=A;class P{constructor(s){this.name=s,this.promise=new Promise((i,n)=>{this.c=i})}resolve(s){this.c(s)}}class g{constructor(){this.c=[],this.d=!1}async acquire(s){const i=new P(s);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const s=this.c.shift();this.d=!0;let i=!0;const n=setTimeout(()=>{i&&console.warn(`The customer named ${s.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),o=()=>{i&&(clearTimeout(n),i=!1,this.d=!1,this.e())};s.resolve((0,L.$Pc)(o))}}var y;(function(c){c[c.Builtin=0]="Builtin",c[c.User=1]="User",c[c.Dev=2]="Dev"})(y||(y={}));function S(c,s){const i=c.isBuiltin?0:c.isUnderDevelopment?2:1,n=s.isBuiltin?0:s.isUnderDevelopment?2:1;if(i!==n)return i-n;const o=f.$fc.basename(c.extensionLocation.path),a=f.$fc.basename(s.extensionLocation.path);return o<a?-1:o>a?1:0}function w(c,s){const i=new I.$$l(s);return c.filter(n=>!i.has(n.identifier))}}),define(ke[293],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fm=e.$Em=e.$Dm=e.$Cm=e.$Bm=e.ExtHostConnectionType=void 0;var I;(function(A){A[A.IPC=1]="IPC",A[A.Socket=2]="Socket",A[A.MessagePort=3]="MessagePort"})(I||(e.ExtHostConnectionType=I={}));class F{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(P){this.pipeName=P,this.type=1}serialize(P){P[F.ENV_KEY]=this.pipeName}}e.$Bm=F;class f{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(P){P[f.ENV_KEY]="1"}}e.$Cm=f;class L{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(P){P[L.ENV_KEY]="1"}}e.$Dm=L;function R(A){delete A[F.ENV_KEY],delete A[f.ENV_KEY],delete A[L.ENV_KEY]}function p(A,P){R(P),A.serialize(P)}e.$Em=p;function E(A){if(A[F.ENV_KEY])return m(A,new F(A[F.ENV_KEY]));if(A[f.ENV_KEY])return m(A,new f);if(A[L.ENV_KEY])return m(A,new L);throw new Error("No connection information defined in environment!")}e.$Fm=E;function m(A,P){return R(A),P}}),define(ke[114],Se([1,0,22]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$gm=e.$fm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var F;(function(m){m[m.Desktop=1]="Desktop",m[m.Web=2]="Web"})(F||(e.UIKind=F={}));var f;(function(m){m[m.VersionMismatch=55]="VersionMismatch",m[m.UnexpectedError=81]="UnexpectedError"})(f||(e.ExtensionHostExitCode=f={}));var L;(function(m){m[m.Initialized=0]="Initialized",m[m.Ready=1]="Ready",m[m.Terminate=2]="Terminate"})(L||(e.MessageType=L={}));function R(m){const A=I.$ce.alloc(1);switch(m){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}e.$fm=R;function p(m,A){if(m.byteLength!==1)return!1;switch(m.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}e.$gm=p;var E;(function(m){m.Start="START_NATIVE_LOG",m.End="END_NATIVE_LOG"})(E||(e.NativeLogMarkers=E={}))}),define(ke[90],Se([1,0,5,4,15,27,114,66,87,24,2,3,219]),function($e,e,I,F,f,L,R,p,E,m,A,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RM=e.$QM=e.$PM=e.$OM=void 0;let y=class extends P.$Rc{constructor(s,i){super(),this.s=s,this.t=i,this.a=this.B(new F.$Od),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new F.$Od),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=A.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:E.$so,name:(0,g.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(i.onDidChangeLogLevel(n=>{(0,f.$dj)(n)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===f.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(s,i,n){const o=this.getTelemetryDetails(),a=new S(i,n,s,this.n,this.j,this.getBuiltInCommonProperties(s),{isUsageEnabled:o.isUsageEnabled,isErrorsEnabled:o.isErrorsEnabled}),t=this.r.get(s.identifier.value)??[];return this.r.set(s.identifier.value,[...t,a]),a.apiTelemetryLogger}$initializeTelemetryLevel(s,i,n){this.f=s,this.g=i,this.c=n??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(s){const i=Object.create(null);switch(i["common.extname"]=`${s.publisher}.${s.name}`,i["common.extversion"]=s.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=w(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:i["common.uikind"]="web";break;case R.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,p.$Zk)((0,E.$zo)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(s){this.h=this.getTelemetryConfiguration(),this.f=s;const i=this.getTelemetryDetails();this.r.forEach((n,o)=>{const a=n.filter(t=>!t.isDisposed);a.length===0?this.r.delete(o):this.r.set(o,a)}),this.r.forEach(n=>{for(const o of n)o.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(s,i){const o=this.r.get(s.value)?.filter(t=>!t.isDisposed);if(!o)return this.r.delete(s.value),!1;let a=!1;for(const t of o)t.ignoreUnhandledExtHostErrors||(t.logError(i),a=!0);return a}};e.$OM=y,e.$OM=y=He([Be(0,L.$NM),Be(1,f.$cj)],y);class S{static validateSender(s){if(typeof s!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof s.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof s.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof s.flush<"u"&&typeof s.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(s,i,n,o,a,t,r){this.g=n,this.h=o,this.i=a,this.j=t,this.a=new F.$Od,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=s,this.d={isUsageEnabled:r.isUsageEnabled,isErrorsEnabled:r.isErrorsEnabled}}updateTelemetryEnablements(s,i){this.e&&(this.d={isUsageEnabled:s,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(s){let i="properties"in s?s.properties??{}:s;return i=(0,E.$Co)(i,[]),this.c&&(i=(0,m.$bn)(i,this.c)),this.b||(i=(0,m.$bn)(i,this.j)),"properties"in s?s.properties=i:s=i,s}k(s,i){this.f&&(this.g.publisher==="vscode"?s=this.g.name+"/"+s:s=this.g.identifier.value+"/"+s,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(s,i),this.h.trace(s,i))}logUsage(s,i){this.d.isUsageEnabled&&this.k(s,i)}logError(s,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof s=="string")this.k(s,i);else{const n={name:s.name,message:s.message,stack:s.stack,cause:s.cause},o=(0,E.$Co)(n,[]),a=new Error(o.message,{cause:o.cause});a.stack=o.stack,a.name=o.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(a,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const s=this,i={logUsage:s.logUsage.bind(s),get isUsageEnabled(){return s.d.isUsageEnabled},get isErrorsEnabled(){return s.d.isErrorsEnabled},logError:s.logError.bind(s),dispose:s.dispose.bind(s),onDidChangeEnableStates:s.a.event.bind(s)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let s=this.f;this.f=void 0,Promise.resolve(s.flush()).then(s=void 0),this.e=void 0}else this.f=void 0}}e.$PM=S;function w(c){const s=Date.now()-new Date(c).getTime();return isNaN(s)?!1:s<1e3*60*60*24}e.$QM=w,e.$RM=(0,I.$Th)("IExtHostTelemetry")}),define(ke[25],Se([1,0,4,2,263,139,26,5]),function($e,e,I,F,f,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AF=e.$zF=e.$yF=e.ActivationKind=e.$xF=e.$wF=e.$vF=e.$uF=e.$tF=e.ExtensionHostStartup=e.$sF=e.$rF=e.$qF=e.$pF=void 0,e.$pF=Object.freeze({identifier:new R.$0l("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:F.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$qF="extensions.webWorker",e.$rF=(0,p.$Th)("extensionService");class E{constructor(a){this.dependency=a}}e.$sF=E;var m;(function(o){o[o.EagerAutoStart=1]="EagerAutoStart",o[o.EagerManualStart=2]="EagerManualStart",o[o.Lazy=3]="Lazy"})(m||(e.ExtensionHostStartup=m={}));class A{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(a,t,r){this.c=a,this.d=t.slice(0),this.e=r.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:L.$aF.createActivationEventsMap(this.d)}}set(a,t,r){if(this.c>a)throw new Error(`ExtensionHostExtensions: invalid versionId ${a} (current: ${this.c})`);const d=[],u=[],l=[],h=[],k=P(this.d),D=P(t),$=(z,M)=>z.extensionLocation.toString()===M.extensionLocation.toString()||z.isBuiltin===M.isBuiltin||z.isUserBuiltin===M.isUserBuiltin||z.isUnderDevelopment===M.isUnderDevelopment;for(const z of this.d){const M=D.get(z.identifier);if(!M){d.push(z.identifier),k.delete(z.identifier);continue}if(!$(z,M)){d.push(z.identifier),k.delete(z.identifier);continue}}for(const z of t){const M=k.get(z.identifier);if(!M){u.push(z);continue}if(!$(M,z)){d.push(M.identifier),k.delete(M.identifier);continue}}const b=new R.$$l(this.e),v=new R.$$l(r);for(const z of this.e)v.has(z)||l.push(z);for(const z of r)b.has(z)||h.push(z);const C=L.$aF.createActivationEventsMap(u),N={versionId:a,toRemove:d,toAdd:u,addActivationEvents:C,myToRemove:l,myToAdd:h};return this.delta(N),N}delta(a){if(this.c>=a.versionId)return null;const{toRemove:t,toAdd:r,myToRemove:d,myToAdd:u}=a,l=new R.$$l(t),h=new R.$$l(d);for(let k=0;k<this.d.length;k++)l.has(this.d[k].identifier)&&(this.d.splice(k,1),k--);for(let k=0;k<this.e.length;k++)h.has(this.e[k])&&(this.e.splice(k,1),k--);for(const k of r)this.d.push(k);for(const k of u)this.e.push(k);return this.f=null,a}containsExtension(a){for(const t of this.e)if(R.$0l.equals(t,a))return!0;return!1}containsActivationEvent(a){return this.f||(this.f=this.g()),this.f.has(a)}g(){const a=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const r=L.$aF.readActivationEvents(t);for(const d of r)a.add(d)}return a}}e.$tF=A;function P(o){const a=new R.$_l;for(const t of o)a.set(t.identifier,t);return a}function g(o,a){return o.enabledApiProposals?o.enabledApiProposals.includes(a):!1}e.$uF=g;function y(o,a){if(!g(o,a))throw new Error(`Extension '${o.identifier.value}' CANNOT use API proposal: ${a}.
Its package.json#enabledApiProposals-property declares: ${o.enabledApiProposals?.join(", ")??"[]"} but NOT ${a}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${o.identifier.value}`)}e.$vF=y;class S{constructor(a,t,r,d){this.codeLoadingTime=a,this.activateCallTime=t,this.activateResolvedTime=r,this.activationReason=d}}e.$wF=S;class w{constructor(a,t){this.description=a,this.value=t}}e.$xF=w;var c;(function(o){o[o.Normal=0]="Normal",o[o.Immediate=1]="Immediate"})(c||(e.ActivationKind=c={}));function s(o){return{type:o.isBuiltin?0:1,isBuiltin:o.isBuiltin||o.isUserBuiltin,identifier:{id:(0,f.$Io)(o.publisher,o.name),uuid:o.uuid},manifest:o,location:o.extensionLocation,targetPlatform:o.targetPlatform,validations:[],isValid:!0}}e.$yF=s;function i(o,a){return{identifier:new R.$0l((0,f.$Go)(o.manifest.publisher,o.manifest.name)),isBuiltin:o.type===0,isUserBuiltin:o.type===1&&o.isBuiltin,isUnderDevelopment:!!a,extensionLocation:o.location,...o.manifest,uuid:o.identifier.uuid,targetPlatform:o.targetPlatform}}e.$zF=i;class n{constructor(){this.onDidRegisterExtensions=I.Event.None,this.onDidChangeExtensionsStatus=I.Event.None,this.onDidChangeExtensions=I.Event.None,this.onWillActivateByEvent=I.Event.None,this.onDidChangeResponsiveChange=I.Event.None,this.onWillStop=I.Event.None,this.extensions=[]}activateByEvent(a){return Promise.resolve(void 0)}activationEventIsDone(a){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(a){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(a,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(a){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$AF=n}),define(ke[294],Se([1,0,11,147,26,25,15,10]),function($e,e,I,F,f,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pdc=e.$odc=e.$ndc=e.$mdc=e.$ldc=e.$kdc=void 0;class E{static{this.NONE=new E(!1,-1,-1,-1)}constructor(s,i,n,o){this.startup=s,this.codeLoadingTime=i,this.activateCallTime=n,this.activateResolvedTime=o}}e.$kdc=E;class m{constructor(s){this.a=s,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(s,i){return s===-1||i===-1?-1:i-s}build(){return new E(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$ldc=m;class A{constructor(s,i,n,o,a,t){this.activationFailed=s,this.activationFailedError=i,this.activationTimes=n,this.module=o,this.exports=a,this.subscriptions=t}}e.$mdc=A;class P extends A{constructor(s){super(!1,null,s,{activate:void 0,deactivate:void 0},void 0,[])}}e.$ndc=P;class g extends A{constructor(){super(!1,null,E.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$odc=g;class y extends A{constructor(s){super(!0,s,E.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let S=class{constructor(s,i,n,o){this.g=o,this.a=s,this.b=i,this.c=n,this.d=new f.$_l,this.f=Object.create(null)}dispose(){for(const[s,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const s=[];for(const[i,n]of this.d)s.push(n.wait());await Promise.all(s)}isActivated(s){const i=this.d.get(s);return!!(i&&i.value)}getActivatedExtension(s){const i=this.d.get(s);if(!i||!i.value)throw new Error(`Extension '${s.value}' is not known or not activated`);return i.value}async activateByEvent(s,i){if(this.f[s])return;const n=this.a.getExtensionDescriptionsForActivationEvent(s);await this.h(n.map(o=>({id:o.identifier,reason:{startup:i,extensionId:o.identifier,activationEvent:s}}))),this.f[s]=!0}activateById(s,i){const n=this.a.getExtensionDescription(s);if(!n)throw new Error(`Extension '${s}' is not known`);return this.h([{id:n.identifier,reason:i}])}async h(s){const i=s.filter(n=>!this.isActivated(n.id)).map(n=>this.j(n));await Promise.all(i.map(n=>n.wait()))}j(s){if(this.d.has(s.id))return this.d.get(s.id);if(this.l(s.id))return this.k(s,null,[],null);const i=this.a.getExtensionDescription(s.id);if(!i){const a=new Error(`Cannot activate unknown extension '${s.id.value}'`),t=this.k(s,null,[],new y(a));return this.c.onExtensionActivationError(s.id,a,new L.$sF(s.id.value)),t}const n=[],o=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const a of o){if(this.m(a))continue;const t=this.d.get(a);if(t){n.push(t);continue}if(this.l(a)){n.push(this.j({id:this.b.getExtensionDescription(a).identifier,reason:s.reason}));continue}const r=this.a.getExtensionDescription(a);if(r){if(!r.main&&!r.browser)continue;n.push(this.j({id:r.identifier,reason:s.reason}));continue}const d=i.displayName||i.identifier.value,u=new Error(`Cannot activate the '${d}' extension because it depends on unknown extension '${a}'`),l=this.k(s,i.displayName,[],new y(u));return this.c.onExtensionActivationError(i.identifier,u,new L.$sF(a)),l}return this.k(s,i.displayName,n,null)}k(s,i,n,o){const a=new w(s.id,i,s.reason,n,o,this.c,this.g);return this.d.set(s.id,a),a}l(s){return F.$e5b.isHostExtension(s,this.a,this.b)}m(s){const i=this.b.getExtensionDescription(s);return i?!i.main&&!i.browser:!1}};e.$pdc=S,e.$pdc=S=He([Be(3,R.$bj)],S);let w=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(s,i,n,o,a,t,r){this.c=s,this.d=i,this.f=n,this.g=o,this.h=a,this.j=t,this.k=r,this.a=new p.$Tg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let s=0;s<this.g.length;s++){const i=this.g[s];if(i.value&&!i.value.activationFailed){this.g.splice(s,1),s--;continue}if(i.value&&i.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);n.detail=i.value.activationFailedError,this.h=new y(n),this.j.onExtensionActivationError(this.c,n,null);return}}this.g.length>0&&await Promise.race(this.g.map(s=>s.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(s){const i=new Error;if(s&&s.name&&(i.name=s.name),s&&s.message?i.message=`Activating extension '${this.c.value}' failed: ${s.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${s}.`,s&&s.stack&&(i.stack=s.stack),this.h=new y(i),this.b&&I.$3(s))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(s)}}};w=He([Be(6,R.$bj)],w)}),define(ke[14],Se([1,0,19,22,165,75,81,28,161,54,100,24,18,2,29,84,136,144,141,111,68,89,292,7,25]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,S,w,c,s,i,n,o,a,t,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$wM=e.$vM=e.MarkdownString=e.$uM=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var u;(function(Me){function Te(ie){const{selectionStartLineNumber:Fe,selectionStartColumn:qe,positionLineNumber:xe,positionColumn:Je}=ie,rt=new r.$yK(Fe-1,qe-1),kt=new r.$yK(xe-1,Je-1);return new r.$AK(rt,kt)}Me.to=Te;function Ce(ie){const{anchor:Fe,active:qe}=ie;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:qe.line+1,positionColumn:qe.character+1}}Me.from=Ce})(u||(e.Selection=u={}));var l;(function(Me){function Te(ie){if(!ie)return;const{start:Fe,end:qe}=ie;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:qe.line+1,endColumn:qe.character+1}}Me.from=Te;function Ce(ie){if(!ie)return;const{startLineNumber:Fe,startColumn:qe,endLineNumber:xe,endColumn:Je}=ie;return new r.$zK(Fe-1,qe-1,xe-1,Je-1)}Me.to=Ce})(l||(e.Range=l={}));var h;(function(Me){function Te(Ce){switch(Ce){case 1:return r.StandardTokenType.Comment;case 0:return r.StandardTokenType.Other;case 3:return r.StandardTokenType.RegEx;case 2:return r.StandardTokenType.String}}Me.to=Te})(h||(e.TokenType=h={}));var k;(function(Me){function Te(ie){return new r.$yK(ie.lineNumber-1,ie.column-1)}Me.to=Te;function Ce(ie){return{lineNumber:ie.line+1,column:ie.character+1}}Me.from=Ce})(k||(e.Position=k={}));var D;(function(Me){function Te(Fe,qe,xe){return(0,I.$Gb)((0,I.$2b)(Fe).map(Je=>Ce(Je,qe,xe)))}Me.from=Te;function Ce(Fe,qe,xe){if(typeof Fe=="string")return{$serialized:!0,language:Fe,isBuiltin:xe?.isBuiltin};if(Fe)return{$serialized:!0,language:Fe.language,scheme:ie(Fe.scheme,qe),pattern:he.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType,isBuiltin:xe?.isBuiltin}}function ie(Fe,qe){return qe&&typeof Fe=="string"?qe.transformOutgoingScheme(Fe):Fe}})(D||(e.DocumentSelector=D={}));var $;(function(Me){function Te(ie){switch(ie){case r.DiagnosticTag.Unnecessary:return 1;case r.DiagnosticTag.Deprecated:return 2}}Me.from=Te;function Ce(ie){switch(ie){case 1:return r.DiagnosticTag.Unnecessary;case 2:return r.DiagnosticTag.Deprecated;default:return}}Me.to=Ce})($||(e.DiagnosticTag=$={}));var b;(function(Me){function Te(ie){let Fe;return ie.code&&((0,g.$zf)(ie.code)||(0,g.$Df)(ie.code)?Fe=String(ie.code):Fe={value:String(ie.code.value),target:ie.code.target}),{...l.from(ie.range),message:ie.message,source:ie.source,code:Fe,severity:C.from(ie.severity),relatedInformation:ie.relatedInformation&&ie.relatedInformation.map(v.from),tags:Array.isArray(ie.tags)?(0,I.$Gb)(ie.tags.map($.from)):void 0}}Me.from=Te;function Ce(ie){const Fe=new r.$LK(l.to(ie),ie.message,C.to(ie.severity));return Fe.source=ie.source,Fe.code=(0,g.$zf)(ie.code)?ie.code:ie.code?.value,Fe.relatedInformation=ie.relatedInformation&&ie.relatedInformation.map(v.to),Fe.tags=ie.tags&&(0,I.$Gb)(ie.tags.map($.to)),Fe}Me.to=Ce})(b||(e.Diagnostic=b={}));var v;(function(Me){function Te(ie){return{...l.from(ie.location.range),message:ie.message,resource:ie.location.uri}}Me.from=Te;function Ce(ie){return new r.$KK(new r.$JK(ie.resource,l.to(ie)),ie.message)}Me.to=Ce})(v||(e.DiagnosticRelatedInformation=v={}));var C;(function(Me){function Te(ie){switch(ie){case r.DiagnosticSeverity.Error:return c.MarkerSeverity.Error;case r.DiagnosticSeverity.Warning:return c.MarkerSeverity.Warning;case r.DiagnosticSeverity.Information:return c.MarkerSeverity.Info;case r.DiagnosticSeverity.Hint:return c.MarkerSeverity.Hint}return c.MarkerSeverity.Error}Me.from=Te;function Ce(ie){switch(ie){case c.MarkerSeverity.Info:return r.DiagnosticSeverity.Information;case c.MarkerSeverity.Warning:return r.DiagnosticSeverity.Warning;case c.MarkerSeverity.Error:return r.DiagnosticSeverity.Error;case c.MarkerSeverity.Hint:return r.DiagnosticSeverity.Hint;default:return r.DiagnosticSeverity.Error}}Me.to=Ce})(C||(e.DiagnosticSeverity=C={}));var N;(function(Me){function Te(ie){return typeof ie=="number"&&ie>=r.ViewColumn.One?ie-1:ie===r.ViewColumn.Beside?t.$JC:t.$IC}Me.from=Te;function Ce(ie){if(typeof ie=="number"&&ie>=0)return ie+1;throw new Error("invalid 'EditorGroupColumn'")}Me.to=Ce})(N||(e.ViewColumn=N={}));function z(Me){return typeof Me.range<"u"}function M(Me){return Me.length===0?!0:!!z(Me[0])}e.$uM=M;var O;(function(Me){function Te(Je){return Je.map(Me.from)}Me.fromMany=Te;function Ce(Je){return Je&&typeof Je=="object"&&typeof Je.language=="string"&&typeof Je.value=="string"}function ie(Je){let rt;if(Ce(Je)){const{language:dt,value:gt}=Je;rt={value:"```"+dt+`
`+gt+"\n```\n"}}else r.$XK.isMarkdownString(Je)?rt={value:Je.value,isTrusted:Je.isTrusted,supportThemeIcons:Je.supportThemeIcons,supportHtml:Je.supportHtml,baseUri:Je.baseUri}:typeof Je=="string"?rt={value:Je}:rt={value:""};const kt=Object.create(null);rt.uris=kt;const St=dt=>{try{let gt=y.URI.parse(dt,!0);gt=gt.with({query:Fe(gt.query,kt)}),kt[dt]=gt}catch{}return""},mt=new E.marked.Renderer;return mt.link=St,mt.image=dt=>typeof dt=="string"?St(R.$bk(dt).href):"",(0,E.marked)(rt.value,{renderer:mt}),rt}Me.from=ie;function Fe(Je,rt){if(!Je)return Je;let kt;try{kt=(0,m.$ph)(Je)}catch{}if(!kt)return Je;let St=!1;return kt=(0,P.$an)(kt,mt=>{if(y.URI.isUri(mt)){const dt=`__uri_${Math.random().toString(16).slice(2,8)}`;return rt[dt]=mt,St=!0,dt}else return}),St?JSON.stringify(kt):Je}function qe(Je){const rt=new r.$XK(Je.value,Je.supportThemeIcons);return rt.isTrusted=Je.isTrusted,rt.supportHtml=Je.supportHtml,rt.baseUri=Je.baseUri?y.URI.from(Je.baseUri):void 0,rt}Me.to=qe;function xe(Je){if(Je)return typeof Je=="string"?Je:Me.from(Je)}Me.fromStrict=xe})(O||(e.MarkdownString=O={}));function j(Me){return M(Me)?Me.map(Te=>({range:l.from(Te.range),hoverMessage:Array.isArray(Te.hoverMessage)?O.fromMany(Te.hoverMessage):Te.hoverMessage?O.from(Te.hoverMessage):void 0,renderOptions:Te.renderOptions})):Me.map(Te=>({range:l.from(Te)}))}e.$vM=j;function T(Me){return typeof Me>"u"?Me:typeof Me=="string"?y.URI.file(Me):Me}e.$wM=T;var V;(function(Me){function Te(Ce){return typeof Ce>"u"?Ce:{contentText:Ce.contentText,contentIconPath:Ce.contentIconPath?T(Ce.contentIconPath):void 0,border:Ce.border,borderColor:Ce.borderColor,fontStyle:Ce.fontStyle,fontWeight:Ce.fontWeight,textDecoration:Ce.textDecoration,color:Ce.color,backgroundColor:Ce.backgroundColor,margin:Ce.margin,width:Ce.width,height:Ce.height}}Me.from=Te})(V||(e.ThemableDecorationAttachmentRenderOptions=V={}));var q;(function(Me){function Te(Ce){return typeof Ce>"u"?Ce:{backgroundColor:Ce.backgroundColor,outline:Ce.outline,outlineColor:Ce.outlineColor,outlineStyle:Ce.outlineStyle,outlineWidth:Ce.outlineWidth,border:Ce.border,borderColor:Ce.borderColor,borderRadius:Ce.borderRadius,borderSpacing:Ce.borderSpacing,borderStyle:Ce.borderStyle,borderWidth:Ce.borderWidth,fontStyle:Ce.fontStyle,fontWeight:Ce.fontWeight,textDecoration:Ce.textDecoration,cursor:Ce.cursor,color:Ce.color,opacity:Ce.opacity,letterSpacing:Ce.letterSpacing,gutterIconPath:Ce.gutterIconPath?T(Ce.gutterIconPath):void 0,gutterIconSize:Ce.gutterIconSize,overviewRulerColor:Ce.overviewRulerColor,before:Ce.before?V.from(Ce.before):void 0,after:Ce.after?V.from(Ce.after):void 0}}Me.from=Te})(q||(e.ThemableDecorationRenderOptions=q={}));var fe;(function(Me){function Te(Ce){if(typeof Ce>"u")return Ce;switch(Ce){case r.DecorationRangeBehavior.OpenOpen:return 0;case r.DecorationRangeBehavior.ClosedClosed:return 1;case r.DecorationRangeBehavior.OpenClosed:return 2;case r.DecorationRangeBehavior.ClosedOpen:return 3}}Me.from=Te})(fe||(e.DecorationRangeBehavior=fe={}));var ee;(function(Me){function Te(Ce){return{isWholeLine:Ce.isWholeLine,rangeBehavior:Ce.rangeBehavior?fe.from(Ce.rangeBehavior):void 0,overviewRulerLane:Ce.overviewRulerLane,light:Ce.light?q.from(Ce.light):void 0,dark:Ce.dark?q.from(Ce.dark):void 0,backgroundColor:Ce.backgroundColor,outline:Ce.outline,outlineColor:Ce.outlineColor,outlineStyle:Ce.outlineStyle,outlineWidth:Ce.outlineWidth,border:Ce.border,borderColor:Ce.borderColor,borderRadius:Ce.borderRadius,borderSpacing:Ce.borderSpacing,borderStyle:Ce.borderStyle,borderWidth:Ce.borderWidth,fontStyle:Ce.fontStyle,fontWeight:Ce.fontWeight,textDecoration:Ce.textDecoration,cursor:Ce.cursor,color:Ce.color,opacity:Ce.opacity,letterSpacing:Ce.letterSpacing,gutterIconPath:Ce.gutterIconPath?T(Ce.gutterIconPath):void 0,gutterIconSize:Ce.gutterIconSize,overviewRulerColor:Ce.overviewRulerColor,before:Ce.before?V.from(Ce.before):void 0,after:Ce.after?V.from(Ce.after):void 0}}Me.from=Te})(ee||(e.DecorationRenderOptions=ee={}));var Y;(function(Me){function Te(ie){return{text:ie.newText,eol:ie.newEol&&Ae.from(ie.newEol),range:l.from(ie.range)}}Me.from=Te;function Ce(ie){const Fe=new r.$EK(l.to(ie.range),ie.text);return Fe.newEol=typeof ie.eol>"u"?void 0:Ae.to(ie.eol),Fe}Me.to=Ce})(Y||(e.TextEdit=Y={}));var X;(function(Me){function Te(ie,Fe){const qe={edits:[]};if(ie instanceof r.$HK){const xe=new p.$Ac;for(const Je of ie._allEntries())Je._type===1&&y.URI.isUri(Je.to)&&Je.from===void 0&&xe.add(Je.to);for(const Je of ie._allEntries())if(Je._type===1){let rt;Je.options?.contents&&(ArrayBuffer.isView(Je.options.contents)?rt={type:"base64",value:(0,F.$we)(F.$ce.wrap(Je.options.contents))}:rt={type:"dataTransferItem",id:Je.options.contents._itemId}),qe.edits.push({oldResource:Je.from,newResource:Je.to,options:{...Je.options,contents:rt},metadata:Je.metadata})}else Je._type===2?qe.edits.push({resource:Je.uri,textEdit:Y.from(Je.edit),versionId:xe.has(Je.uri)?void 0:Fe?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===6?qe.edits.push({resource:Je.uri,textEdit:{range:l.from(Je.range),text:Je.edit.value,insertAsSnippet:!0},versionId:xe.has(Je.uri)?void 0:Fe?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===3?qe.edits.push({metadata:Je.metadata,resource:Je.uri,cellEdit:Je.edit,notebookMetadata:Je.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(Je.uri)}):Je._type===5&&qe.edits.push({metadata:Je.metadata,resource:Je.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(Je.uri),cellEdit:{editType:1,index:Je.index,count:Je.count,cells:Je.cells.map(bt.from)}})}return qe}Me.from=Te;function Ce(ie){const Fe=new r.$HK,qe=new p.$zc;for(const xe of ie.edits)if(xe.textEdit){const Je=xe,rt=y.URI.revive(Je.resource),kt=l.to(Je.textEdit.range),St=Je.textEdit.text,mt=Je.textEdit.insertAsSnippet;let dt;mt?dt=r.$GK.replace(kt,new r.$IK(St)):dt=r.$EK.replace(kt,St);const gt=qe.get(rt);gt?gt.push(dt):qe.set(rt,[dt])}else Fe.renameFile(y.URI.revive(xe.oldResource),y.URI.revive(xe.newResource),xe.options);for(const[xe,Je]of qe)Fe.set(xe,Je);return Fe}Me.to=Ce})(X||(e.WorkspaceEdit=X={}));var ae;(function(Me){const Te=Object.create(null);Te[r.SymbolKind.File]=0,Te[r.SymbolKind.Module]=1,Te[r.SymbolKind.Namespace]=2,Te[r.SymbolKind.Package]=3,Te[r.SymbolKind.Class]=4,Te[r.SymbolKind.Method]=5,Te[r.SymbolKind.Property]=6,Te[r.SymbolKind.Field]=7,Te[r.SymbolKind.Constructor]=8,Te[r.SymbolKind.Enum]=9,Te[r.SymbolKind.Interface]=10,Te[r.SymbolKind.Function]=11,Te[r.SymbolKind.Variable]=12,Te[r.SymbolKind.Constant]=13,Te[r.SymbolKind.String]=14,Te[r.SymbolKind.Number]=15,Te[r.SymbolKind.Boolean]=16,Te[r.SymbolKind.Array]=17,Te[r.SymbolKind.Object]=18,Te[r.SymbolKind.Key]=19,Te[r.SymbolKind.Null]=20,Te[r.SymbolKind.EnumMember]=21,Te[r.SymbolKind.Struct]=22,Te[r.SymbolKind.Event]=23,Te[r.SymbolKind.Operator]=24,Te[r.SymbolKind.TypeParameter]=25;function Ce(Fe){return typeof Te[Fe]=="number"?Te[Fe]:6}Me.from=Ce;function ie(Fe){for(const qe in Te)if(Te[qe]===Fe)return Number(qe);return r.SymbolKind.Property}Me.to=ie})(ae||(e.SymbolKind=ae={}));var Z;(function(Me){function Te(ie){switch(ie){case r.SymbolTag.Deprecated:return 1}}Me.from=Te;function Ce(ie){switch(ie){case 1:return r.SymbolTag.Deprecated}}Me.to=Ce})(Z||(e.SymbolTag=Z={}));var se;(function(Me){function Te(ie){return{name:ie.name,kind:ae.from(ie.kind),tags:ie.tags&&ie.tags.map(Z.from),containerName:ie.containerName,location:Ee.from(ie.location)}}Me.from=Te;function Ce(ie){const Fe=new r.$OK(ie.name,ae.to(ie.kind),ie.containerName,Ee.to(ie.location));return Fe.tags=ie.tags&&ie.tags.map(Z.to),Fe}Me.to=Ce})(se||(e.WorkspaceSymbol=se={}));var we;(function(Me){function Te(ie){const Fe={name:ie.name||"!!MISSING: name!!",detail:ie.detail,range:l.from(ie.range),selectionRange:l.from(ie.selectionRange),kind:ae.from(ie.kind),tags:ie.tags?.map(Z.from)??[]};return ie.children&&(Fe.children=ie.children.map(Te)),Fe}Me.from=Te;function Ce(ie){const Fe=new r.$PK(ie.name,ie.detail,ae.to(ie.kind),l.to(ie.range),l.to(ie.selectionRange));return(0,I.$Kb)(ie.tags)&&(Fe.tags=ie.tags.map(Z.to)),ie.children&&(Fe.children=ie.children.map(Ce)),Fe}Me.to=Ce})(we||(e.DocumentSymbol=we={}));var H;(function(Me){function Te(ie){const Fe=new r.$TK(ae.to(ie.kind),ie.name,ie.detail||"",y.URI.revive(ie.uri),l.to(ie.range),l.to(ie.selectionRange));return Fe._sessionId=ie._sessionId,Fe._itemId=ie._itemId,Fe}Me.to=Te;function Ce(ie,Fe,qe){if(Fe=Fe??ie._sessionId,qe=qe??ie._itemId,Fe===void 0||qe===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:qe,name:ie.name,detail:ie.detail,kind:ae.from(ie.kind),uri:ie.uri,range:l.from(ie.range),selectionRange:l.from(ie.selectionRange),tags:ie.tags?.map(Z.from)}}Me.from=Ce})(H||(e.CallHierarchyItem=H={}));var U;(function(Me){function Te(Ce){return new r.$UK(H.to(Ce.from),Ce.fromRanges.map(ie=>l.to(ie)))}Me.to=Te})(U||(e.CallHierarchyIncomingCall=U={}));var ce;(function(Me){function Te(Ce){return new r.$VK(H.to(Ce.to),Ce.fromRanges.map(ie=>l.to(ie)))}Me.to=Te})(ce||(e.CallHierarchyOutgoingCall=ce={}));var Ee;(function(Me){function Te(ie){return{range:ie.range&&l.from(ie.range),uri:ie.uri}}Me.from=Te;function Ce(ie){return new r.$JK(y.URI.revive(ie.uri),l.to(ie.range))}Me.to=Ce})(Ee||(e.location=Ee={}));var ne;(function(Me){function Te(ie){const Fe=ie,qe=ie;return{originSelectionRange:Fe.originSelectionRange?l.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:qe.uri,range:l.from(Fe.targetRange?Fe.targetRange:qe.range),targetSelectionRange:Fe.targetSelectionRange?l.from(Fe.targetSelectionRange):void 0}}Me.from=Te;function Ce(ie){return{targetUri:y.URI.revive(ie.uri),targetRange:l.to(ie.range),targetSelectionRange:ie.targetSelectionRange?l.to(ie.targetSelectionRange):void 0,originSelectionRange:ie.originSelectionRange?l.to(ie.originSelectionRange):void 0}}Me.to=Ce})(ne||(e.DefinitionLink=ne={}));var G;(function(Me){function Te(ie){return{range:l.from(ie.range),contents:O.fromMany(ie.contents)}}Me.from=Te;function Ce(ie){return new r.$MK(ie.contents.map(O.to),l.to(ie.range))}Me.to=Ce})(G||(e.Hover=G={}));var J;(function(Me){function Te(ie){return{range:l.from(ie.range),expression:ie.expression}}Me.from=Te;function Ce(ie){return new r.$FL(l.to(ie.range),ie.expression)}Me.to=Ce})(J||(e.EvaluatableExpression=J={}));var ge;(function(Me){function Te(ie){if(ie instanceof r.$GL)return{type:"text",range:l.from(ie.range),text:ie.text};if(ie instanceof r.$HL)return{type:"variable",range:l.from(ie.range),variableName:ie.variableName,caseSensitiveLookup:ie.caseSensitiveLookup};if(ie instanceof r.$IL)return{type:"expression",range:l.from(ie.range),expression:ie.expression};throw new Error("Unknown 'InlineValue' type")}Me.from=Te;function Ce(ie){switch(ie.type){case"text":return{range:l.to(ie.range),text:ie.text};case"variable":return{range:l.to(ie.range),variableName:ie.variableName,caseSensitiveLookup:ie.caseSensitiveLookup};case"expression":return{range:l.to(ie.range),expression:ie.expression}}}Me.to=Ce})(ge||(e.InlineValue=ge={}));var x;(function(Me){function Te(ie){return{frameId:ie.frameId,stoppedLocation:l.from(ie.stoppedLocation)}}Me.from=Te;function Ce(ie){return new r.$JL(ie.frameId,l.to(ie.stoppedLocation))}Me.to=Ce})(x||(e.InlineValueContext=x={}));var le;(function(Me){function Te(ie){return{range:l.from(ie.range),kind:ie.kind}}Me.from=Te;function Ce(ie){return new r.$NK(l.to(ie.range),ie.kind)}Me.to=Ce})(le||(e.DocumentHighlight=le={}));var te;(function(Me){function Te(Ce){switch(Ce){case 1:return r.CompletionTriggerKind.TriggerCharacter;case 2:return r.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return r.CompletionTriggerKind.Invoke}}Me.to=Te})(te||(e.CompletionTriggerKind=te={}));var de;(function(Me){function Te(Ce){return{triggerKind:te.to(Ce.triggerKind),triggerCharacter:Ce.triggerCharacter}}Me.to=Te})(de||(e.CompletionContext=de={}));var be;(function(Me){function Te(ie){switch(ie){case r.CompletionItemTag.Deprecated:return 1}}Me.from=Te;function Ce(ie){switch(ie){case 1:return r.CompletionItemTag.Deprecated}}Me.to=Ce})(be||(e.CompletionItemTag=be={}));var Pe;(function(Me){const Te=new Map([[r.CompletionItemKind.Method,0],[r.CompletionItemKind.Function,1],[r.CompletionItemKind.Constructor,2],[r.CompletionItemKind.Field,3],[r.CompletionItemKind.Variable,4],[r.CompletionItemKind.Class,5],[r.CompletionItemKind.Interface,7],[r.CompletionItemKind.Struct,6],[r.CompletionItemKind.Module,8],[r.CompletionItemKind.Property,9],[r.CompletionItemKind.Unit,12],[r.CompletionItemKind.Value,13],[r.CompletionItemKind.Constant,14],[r.CompletionItemKind.Enum,15],[r.CompletionItemKind.EnumMember,16],[r.CompletionItemKind.Keyword,17],[r.CompletionItemKind.Snippet,27],[r.CompletionItemKind.Text,18],[r.CompletionItemKind.Color,19],[r.CompletionItemKind.File,20],[r.CompletionItemKind.Reference,21],[r.CompletionItemKind.Folder,23],[r.CompletionItemKind.Event,10],[r.CompletionItemKind.Operator,11],[r.CompletionItemKind.TypeParameter,24],[r.CompletionItemKind.Issue,26],[r.CompletionItemKind.User,25]]);function Ce(qe){return Te.get(qe)??9}Me.from=Ce;const ie=new Map([[0,r.CompletionItemKind.Method],[1,r.CompletionItemKind.Function],[2,r.CompletionItemKind.Constructor],[3,r.CompletionItemKind.Field],[4,r.CompletionItemKind.Variable],[5,r.CompletionItemKind.Class],[7,r.CompletionItemKind.Interface],[6,r.CompletionItemKind.Struct],[8,r.CompletionItemKind.Module],[9,r.CompletionItemKind.Property],[12,r.CompletionItemKind.Unit],[13,r.CompletionItemKind.Value],[14,r.CompletionItemKind.Constant],[15,r.CompletionItemKind.Enum],[16,r.CompletionItemKind.EnumMember],[17,r.CompletionItemKind.Keyword],[27,r.CompletionItemKind.Snippet],[18,r.CompletionItemKind.Text],[19,r.CompletionItemKind.Color],[20,r.CompletionItemKind.File],[21,r.CompletionItemKind.Reference],[23,r.CompletionItemKind.Folder],[10,r.CompletionItemKind.Event],[11,r.CompletionItemKind.Operator],[24,r.CompletionItemKind.TypeParameter],[25,r.CompletionItemKind.User],[26,r.CompletionItemKind.Issue]]);function Fe(qe){return ie.get(qe)??r.CompletionItemKind.Property}Me.to=Fe})(Pe||(e.CompletionItemKind=Pe={}));var B;(function(Me){function Te(Ce,ie){const Fe=new r.$4K(Ce.label);return Fe.insertText=Ce.insertText,Fe.kind=Pe.to(Ce.kind),Fe.tags=Ce.tags?.map(be.to),Fe.detail=Ce.detail,Fe.documentation=R.$9j(Ce.documentation)?O.to(Ce.documentation):Ce.documentation,Fe.sortText=Ce.sortText,Fe.filterText=Ce.filterText,Fe.preselect=Ce.preselect,Fe.commitCharacters=Ce.commitCharacters,S.$xs.isIRange(Ce.range)?Fe.range=l.to(Ce.range):typeof Ce.range=="object"&&(Fe.range={inserting:l.to(Ce.range.insert),replacing:l.to(Ce.range.replace)}),Fe.keepWhitespace=typeof Ce.insertTextRules>"u"?!1:!!(Ce.insertTextRules&1),typeof Ce.insertTextRules<"u"&&Ce.insertTextRules&4?Fe.insertText=new r.$IK(Ce.insertText):(Fe.insertText=Ce.insertText,Fe.textEdit=Fe.range instanceof r.$zK?new r.$EK(Fe.range,Fe.insertText):void 0),Ce.additionalTextEdits&&Ce.additionalTextEdits.length>0&&(Fe.additionalTextEdits=Ce.additionalTextEdits.map(qe=>Y.to(qe))),Fe.command=ie&&Ce.command?ie.fromInternal(Ce.command):void 0,Fe}Me.to=Te})(B||(e.CompletionItem=B={}));var Q;(function(Me){function Te(ie){if(typeof ie.label!="string"&&!Array.isArray(ie.label))throw new TypeError("Invalid label");return{label:ie.label,documentation:O.fromStrict(ie.documentation)}}Me.from=Te;function Ce(ie){return{label:ie.label,documentation:R.$9j(ie.documentation)?O.to(ie.documentation):ie.documentation}}Me.to=Ce})(Q||(e.ParameterInformation=Q={}));var re;(function(Me){function Te(ie){return{label:ie.label,documentation:O.fromStrict(ie.documentation),parameters:Array.isArray(ie.parameters)?ie.parameters.map(Q.from):[],activeParameter:ie.activeParameter}}Me.from=Te;function Ce(ie){return{label:ie.label,documentation:R.$9j(ie.documentation)?O.to(ie.documentation):ie.documentation,parameters:Array.isArray(ie.parameters)?ie.parameters.map(Q.to):[],activeParameter:ie.activeParameter}}Me.to=Ce})(re||(e.SignatureInformation=re={}));var oe;(function(Me){function Te(ie){return{activeSignature:ie.activeSignature,activeParameter:ie.activeParameter,signatures:Array.isArray(ie.signatures)?ie.signatures.map(re.from):[]}}Me.from=Te;function Ce(ie){return{activeSignature:ie.activeSignature,activeParameter:ie.activeParameter,signatures:Array.isArray(ie.signatures)?ie.signatures.map(re.to):[]}}Me.to=Ce})(oe||(e.SignatureHelp=oe={}));var _;(function(Me){function Te(Ce,ie){const Fe=new r.$3K(k.to(ie.position),typeof ie.label=="string"?ie.label:ie.label.map(me.to.bind(void 0,Ce)),ie.kind&&ye.to(ie.kind));return Fe.textEdits=ie.textEdits&&ie.textEdits.map(Y.to),Fe.tooltip=R.$9j(ie.tooltip)?O.to(ie.tooltip):ie.tooltip,Fe.paddingLeft=ie.paddingLeft,Fe.paddingRight=ie.paddingRight,Fe}Me.to=Te})(_||(e.InlayHint=_={}));var me;(function(Me){function Te(Ce,ie){const Fe=new r.$2K(ie.label);return Fe.tooltip=R.$9j(ie.tooltip)?O.to(ie.tooltip):ie.tooltip,w.Command.is(ie.command)&&(Fe.command=Ce.fromInternal(ie.command)),ie.location&&(Fe.location=Ee.to(ie.location)),Fe}Me.to=Te})(me||(e.InlayHintLabelPart=me={}));var ye;(function(Me){function Te(ie){return ie}Me.from=Te;function Ce(ie){return ie}Me.to=Ce})(ye||(e.InlayHintKind=ye={}));var ze;(function(Me){function Te(ie){return{range:l.from(ie.range),url:ie.target,tooltip:ie.tooltip}}Me.from=Te;function Ce(ie){let Fe;if(ie.url)try{Fe=typeof ie.url=="string"?y.URI.parse(ie.url,!0):y.URI.revive(ie.url)}catch{}return new r.$9K(l.to(ie.range),Fe)}Me.to=Ce})(ze||(e.DocumentLink=ze={}));var We;(function(Me){function Te(ie){const Fe=new r.$_K(ie.label);return ie.textEdit&&(Fe.textEdit=Y.to(ie.textEdit)),ie.additionalTextEdits&&(Fe.additionalTextEdits=ie.additionalTextEdits.map(qe=>Y.to(qe))),Fe}Me.to=Te;function Ce(ie){return{label:ie.label,textEdit:ie.textEdit?Y.from(ie.textEdit):void 0,additionalTextEdits:ie.additionalTextEdits?ie.additionalTextEdits.map(Fe=>Y.from(Fe)):void 0}}Me.from=Ce})(We||(e.ColorPresentation=We={}));var _e;(function(Me){function Te(ie){return new r.$0K(ie[0],ie[1],ie[2],ie[3])}Me.to=Te;function Ce(ie){return[ie.red,ie.green,ie.blue,ie.alpha]}Me.from=Ce})(_e||(e.Color=_e={}));var Ye;(function(Me){function Te(ie){return{range:l.from(ie.range)}}Me.from=Te;function Ce(ie){return new r.$SK(l.to(ie.range))}Me.to=Ce})(Ye||(e.SelectionRange=Ye={}));var it;(function(Me){function Te(Ce){switch(Ce){case 2:return r.TextDocumentSaveReason.AfterDelay;case 1:return r.TextDocumentSaveReason.Manual;case 3:case 4:return r.TextDocumentSaveReason.FocusOut}}Me.to=Te})(it||(e.TextDocumentSaveReason=it={}));var tt;(function(Me){function Te(ie){switch(ie){case r.TextEditorLineNumbersStyle.Off:return 0;case r.TextEditorLineNumbersStyle.Relative:return 2;case r.TextEditorLineNumbersStyle.On:default:return 1}}Me.from=Te;function Ce(ie){switch(ie){case 0:return r.TextEditorLineNumbersStyle.Off;case 2:return r.TextEditorLineNumbersStyle.Relative;case 1:default:return r.TextEditorLineNumbersStyle.On}}Me.to=Ce})(tt||(e.TextEditorLineNumbersStyle=tt={}));var Ae;(function(Me){function Te(ie){if(ie===r.EndOfLine.CRLF)return 1;if(ie===r.EndOfLine.LF)return 0}Me.from=Te;function Ce(ie){if(ie===1)return r.EndOfLine.CRLF;if(ie===0)return r.EndOfLine.LF}Me.to=Ce})(Ae||(e.EndOfLine=Ae={}));var Oe;(function(Me){function Te(Ce){if(typeof Ce=="object")return Ce.viewId;switch(Ce){case r.ProgressLocation.SourceControl:return 3;case r.ProgressLocation.Window:return 10;case r.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Me.from=Te})(Oe||(e.ProgressLocation=Oe={}));var Ve;(function(Me){function Te(ie){const Fe={start:ie.start+1,end:ie.end+1};return ie.kind&&(Fe.kind=Re.from(ie.kind)),Fe}Me.from=Te;function Ce(ie){const Fe={start:ie.start-1,end:ie.end-1};return ie.kind&&(Fe.kind=Re.to(ie.kind)),Fe}Me.to=Ce})(Ve||(e.FoldingRange=Ve={}));var Re;(function(Me){function Te(ie){if(ie)switch(ie){case r.FoldingRangeKind.Comment:return w.$mt.Comment;case r.FoldingRangeKind.Imports:return w.$mt.Imports;case r.FoldingRangeKind.Region:return w.$mt.Region}}Me.from=Te;function Ce(ie){if(ie)switch(ie.value){case w.$mt.Comment.value:return r.FoldingRangeKind.Comment;case w.$mt.Imports.value:return r.FoldingRangeKind.Imports;case w.$mt.Region.value:return r.FoldingRangeKind.Region}}Me.to=Ce})(Re||(e.FoldingRangeKind=Re={}));var Xe;(function(Me){function Te(Ce){if(Ce)return{pinned:typeof Ce.preview=="boolean"?!Ce.preview:void 0,inactive:Ce.background,preserveFocus:Ce.preserveFocus,selection:typeof Ce.selection=="object"?l.from(Ce.selection):void 0,override:typeof Ce.override=="boolean"?i.$$D.id:void 0}}Me.from=Te})(Xe||(e.TextEditorOpenOptions=Xe={}));var he;(function(Me){function Te(qe){return qe instanceof r.$tL?qe.toJSON():typeof qe=="string"?qe:Ce(qe)||ie(qe)?new r.$tL(qe.baseUri??qe.base,qe.pattern).toJSON():qe}Me.from=Te;function Ce(qe){const xe=qe;return xe?y.URI.isUri(xe.baseUri)&&typeof xe.pattern=="string":!1}function ie(qe){const xe=qe;return xe?typeof xe.base=="string"&&typeof xe.pattern=="string":!1}function Fe(qe){return typeof qe=="string"?qe:new r.$tL(y.URI.revive(qe.baseUri),qe.pattern)}Me.to=Fe})(he||(e.GlobPattern=he={}));var ue;(function(Me){function Te(Ce){if(Ce){if(Array.isArray(Ce))return Ce.map(Te);if(typeof Ce=="string")return Ce;{const ie=Ce;return{language:ie.language,scheme:ie.scheme,pattern:he.from(ie.pattern),exclusive:ie.exclusive,notebookType:ie.notebookType}}}else return}Me.from=Te})(ue||(e.LanguageSelector=ue={}));var Ie;(function(Me){function Te(ie){return!!ie&&typeof ie=="object"&&"documents"in ie&&Array.isArray(ie.documents)&&ie.documents.every(Fe=>Array.isArray(Fe)&&Fe.every(qe=>qe&&typeof qe=="object"&&"uri"in qe&&y.URI.isUri(qe.uri)&&"version"in qe&&typeof qe.version=="number"&&"ranges"in qe&&Array.isArray(qe.ranges)&&qe.ranges.every(xe=>xe instanceof r.$zK)))}Me.is=Te;function Ce(ie){return{documents:ie.documents.map(Fe=>Fe.map(qe=>({uri:y.URI.from(qe.uri),version:qe.version,ranges:qe.ranges.map(xe=>l.from(xe))})))}}Me.from=Ce})(Ie||(e.MappedEditsContext=Ie={}));var Ke;(function(Me){function Te(ie){return{start:ie.start,end:ie.end}}Me.from=Te;function Ce(ie){return new r.$UL(ie.start,ie.end)}Me.to=Ce})(Ke||(e.NotebookRange=Ke={}));var Ue;(function(Me){function Te(ie){return{timing:typeof ie.runStartTime=="number"&&typeof ie.runEndTime=="number"?{startTime:ie.runStartTime,endTime:ie.runEndTime}:void 0,executionOrder:ie.executionOrder,success:ie.lastRunSuccess}}Me.to=Te;function Ce(ie){return{lastRunSuccess:ie.success,runStartTime:ie.timing?.startTime,runEndTime:ie.timing?.endTime,executionOrder:ie.executionOrder}}Me.from=Ce})(Ue||(e.NotebookCellExecutionSummary=Ue={}));var Ze;(function(Me){function Te(Ce){if(Ce===n.NotebookCellExecutionState.Unconfirmed)return r.NotebookCellExecutionState.Pending;if(Ce===n.NotebookCellExecutionState.Pending)return;if(Ce===n.NotebookCellExecutionState.Executing)return r.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Ce}`)}Me.to=Te})(Ze||(e.NotebookCellExecutionState=Ze={}));var nt;(function(Me){function Te(ie){switch(ie){case r.NotebookCellKind.Markup:return n.CellKind.Markup;case r.NotebookCellKind.Code:default:return n.CellKind.Code}}Me.from=Te;function Ce(ie){switch(ie){case n.CellKind.Markup:return r.NotebookCellKind.Markup;case n.CellKind.Code:default:return r.NotebookCellKind.Code}}Me.to=Ce})(nt||(e.NotebookCellKind=nt={}));var ct;(function(Me){function Te(ie){const Fe={metadata:ie.metadata??Object.create(null),cells:[]};for(const qe of ie.cells)r.$VL.validate(qe),Fe.cells.push(bt.from(qe));return Fe}Me.from=Te;function Ce(ie){const Fe=new r.$WL(ie.cells.map(bt.to));return(0,g.$Mf)(ie.metadata)||(Fe.metadata=ie.metadata),Fe}Me.to=Ce})(ct||(e.NotebookData=ct={}));var bt;(function(Me){function Te(ie){return{cellKind:nt.from(ie.kind),language:ie.languageId,mime:ie.mime,source:ie.value,metadata:ie.metadata,internalMetadata:Ue.from(ie.executionSummary??{}),outputs:ie.outputs?ie.outputs.map(Kt.from):[]}}Me.from=Te;function Ce(ie){return new r.$VL(nt.to(ie.cellKind),ie.source,ie.language,ie.mime,ie.outputs?ie.outputs.map(Kt.to):void 0,ie.metadata,ie.internalMetadata?Ue.to(ie.internalMetadata):void 0)}Me.to=Ce})(bt||(e.NotebookCellData=bt={}));var Et;(function(Me){function Te(ie){return{mime:ie.mime,valueBytes:F.$ce.wrap(ie.data)}}Me.from=Te;function Ce(ie){return new r.$XL(ie.valueBytes.buffer,ie.mime)}Me.to=Ce})(Et||(e.NotebookCellOutputItem=Et={}));var Kt;(function(Me){function Te(ie){return{outputId:ie.id,items:ie.items.map(Et.from),metadata:ie.metadata}}Me.from=Te;function Ce(ie){const Fe=ie.items.map(Et.to);return new r.$YL(Fe,ie.outputId,ie.metadata)}Me.to=Ce})(Kt||(e.NotebookCellOutput=Kt={}));var Ht;(function(Me){function Te(Fe){return ie(Fe)?{include:he.from(Fe.include)??void 0,exclude:he.from(Fe.exclude)??void 0}:he.from(Fe)??void 0}Me.from=Te;function Ce(Fe){return ie(Fe)?{include:he.to(Fe.include),exclude:he.to(Fe.exclude)}:he.to(Fe)}Me.to=Ce;function ie(Fe){const qe=Fe;return qe?!(0,g.$If)(qe.include)&&!(0,g.$If)(qe.exclude):!1}})(Ht||(e.NotebookExclusiveDocumentPattern=Ht={}));var wt;(function(Me){function Te(Ce,ie,Fe){const qe=typeof Ce.command=="string"?{title:"",command:Ce.command}:Ce.command;return{alignment:Ce.alignment===r.NotebookCellStatusBarAlignment.Left?1:2,command:ie.toInternal(qe,Fe),text:Ce.text,tooltip:Ce.tooltip,accessibilityInformation:Ce.accessibilityInformation,priority:Ce.priority}}Me.from=Te})(wt||(e.NotebookStatusBarItem=wt={}));var zt;(function(Me){function Te(Ce,ie,Fe){const qe=typeof Ce.command=="string"?{title:"",command:Ce.command}:Ce.command;return{command:ie.toInternal(qe,Fe),label:Ce.label,description:Ce.description,detail:Ce.detail,documentation:Ce.documentation}}Me.from=Te})(zt||(e.NotebookKernelSourceAction=zt={}));var Ot;(function(Me){function Te(Ce){return{transientOutputs:Ce?.transientOutputs??!1,transientCellMetadata:Ce?.transientCellMetadata??{},transientDocumentMetadata:Ce?.transientDocumentMetadata??{},cellContentMetadata:Ce?.cellContentMetadata??{}}}Me.from=Te})(Ot||(e.NotebookDocumentContentOptions=Ot={}));var Gt;(function(Me){function Te(ie){return{uri:ie.uri,provides:ie.provides}}Me.from=Te;function Ce(ie){return new r.$1L(y.URI.revive(ie.uri),ie.provides)}Me.to=Ce})(Gt||(e.NotebookRendererScript=Gt={}));var Ut;(function(Me){function Te(ie){return{message:O.fromStrict(ie.message)||"",type:0,expected:ie.expectedOutput,actual:ie.actualOutput,contextValue:ie.contextValue,location:ie.location&&{range:l.from(ie.location.range),uri:ie.location.uri}}}Me.from=Te;function Ce(ie){const Fe=new r.$7L(typeof ie.message=="string"?ie.message:O.to(ie.message));return Fe.actualOutput=ie.actual,Fe.expectedOutput=ie.expected,Fe.contextValue=ie.contextValue,Fe.location=ie.location?Ee.to(ie.location):void 0,Fe}Me.to=Ce})(Ut||(e.TestMessage=Ut={}));var Dt;(function(Me){Me.namespace=a.$pJ,Me.denamespace=a.$qJ})(Dt||(e.TestTag=Dt={}));var Ft;(function(Me){function Te(ie){const Fe=(0,s.$tM)(ie).controllerId;return{extId:o.$lJ.fromExtHostTestItem(ie,Fe).toString(),label:ie.label,uri:y.URI.revive(ie.uri),busy:ie.busy,tags:ie.tags.map(qe=>Dt.namespace(Fe,qe.id)),range:S.$xs.lift(l.from(ie.range)),description:ie.description||null,sortText:ie.sortText||null,error:ie.error&&O.fromStrict(ie.error)||null}}Me.from=Te;function Ce(ie){return{parent:void 0,error:void 0,id:o.$lJ.fromString(ie.extId).localId,label:ie.label,uri:y.URI.revive(ie.uri),tags:(ie.tags||[]).map(Fe=>{const{tagId:qe}=Dt.denamespace(Fe);return new r.$8L(qe)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:l.to(ie.range||void 0),canResolveChildren:!1,busy:ie.busy,description:ie.description||void 0,sortText:ie.sortText||void 0}}Me.toPlain=Ce})(Ft||(e.TestItem=Ft={})),function(Me){function Te(ie){return{id:ie.id}}Me.from=Te;function Ce(ie){return new r.$8L(ie.id)}Me.to=Ce}(Dt||(e.TestTag=Dt={}));var Bt;(function(Me){const Te=(ie,Fe)=>{const qe=[];for(const[Je,rt]of Fe)o.$lJ.compare(rt.item.extId,Je)===2&&(Fe.delete(Je),qe.push(rt));const xe={...Ft.toPlain(ie.item),parent:void 0,taskStates:ie.tasks.map(Je=>({state:Je.state,duration:Je.duration,messages:Je.messages.filter(rt=>rt.type===0).map(Ut.to)})),children:qe.map(Je=>Te(Je,Fe))};for(const Je of xe.children)Je.parent=xe;return xe};function Ce(ie){const Fe=[],qe=new Map;for(const xe of ie.items){qe.set(xe.item.extId,xe);const Je=o.$lJ.root(xe.item.extId);ie.request.targets.some(rt=>rt.controllerId===Je&&rt.testIds.includes(xe.item.extId))&&Fe.push(xe)}return{completedAt:ie.completedAt,results:Fe.map(xe=>Te(xe,qe))}}Me.to=Ce})(Bt||(e.TestResults=Bt={}));var Jt;(function(Me){function Te(qe){return{covered:qe.covered,total:qe.covered}}function Ce(qe){return"line"in qe?k.from(qe):l.from(qe)}function ie(qe){return"branches"in qe?{count:qe.executionCount,location:Ce(qe.location),type:1,branches:qe.branches.length?qe.branches.map(xe=>({count:xe.executionCount,location:xe.location&&Ce(xe.location)})):void 0}:{type:0,count:qe.executionCount,location:Ce(qe.location)}}Me.fromDetailed=ie;function Fe(qe){return{uri:qe.uri,statement:Te(qe.statementCoverage),branch:qe.branchCoverage&&Te(qe.branchCoverage),function:qe.functionCoverage&&Te(qe.functionCoverage),details:qe.detailedCoverage?.map(ie)}}Me.fromFile=Fe})(Jt||(e.TestCoverage=Jt={}));var Wt;(function(Me){function Te(Ce){switch(Ce){case 1:return r.CodeActionTriggerKind.Invoke;case 2:return r.CodeActionTriggerKind.Automatic}}Me.to=Te})(Wt||(e.CodeActionTriggerKind=Wt={}));var Vt;(function(Me){function Te(ie){const Fe=new r.$bM(ae.to(ie.kind),ie.name,ie.detail||"",y.URI.revive(ie.uri),l.to(ie.range),l.to(ie.selectionRange));return Fe._sessionId=ie._sessionId,Fe._itemId=ie._itemId,Fe}Me.to=Te;function Ce(ie,Fe,qe){if(Fe=Fe??ie._sessionId,qe=qe??ie._itemId,Fe===void 0||qe===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:qe,kind:ae.from(ie.kind),name:ie.name,detail:ie.detail??"",uri:ie.uri,range:l.from(ie.range),selectionRange:l.from(ie.selectionRange),tags:ie.tags?.map(Z.from)}}Me.from=Ce})(Vt||(e.TypeHierarchyItem=Vt={}));var Nt;(function(Me){function Te(Ce){if(Ce)return{value:Ce.value,tooltip:Ce.tooltip}}Me.from=Te})(Nt||(e.ViewBadge=Nt={}));var ut;(function(Me){function Te(qe,xe,Je){const rt=xe.fileData;return rt?new r.$mL(new r.$nL(rt.name,y.URI.revive(rt.uri),rt.id,(0,L.$cb)(()=>Je(rt.id)))):qe===A.$Tr.uriList&&xe.uriListData?new r.$lL(Fe(xe.uriListData)):new r.$lL(xe.asString)}Me.to=Te;async function Ce(qe,xe){const Je=await xe.asString();if(qe===A.$Tr.uriList)return{asString:Je,fileData:void 0,uriListData:ie(Je)};const rt=xe.asFile();return{asString:Je,fileData:rt?{name:rt.name,uri:rt.uri,id:rt._itemId??rt.id}:void 0}}Me.from=Ce;function ie(qe){return f.$7s.split(qe).map(xe=>{if(xe.startsWith("#"))return xe;try{return y.URI.parse(xe)}catch{}return xe})}function Fe(qe){return f.$7s.create(qe.map(xe=>typeof xe=="string"?xe:y.URI.revive(xe)))}})(ut||(e.DataTransferItem=ut={}));var ft;(function(Me){function Te(ie,Fe){const qe=ie.items.map(([xe,Je])=>[xe,ut.to(xe,Je,Fe)]);return new r.$oL(qe)}Me.toDataTransfer=Te;async function Ce(ie){const Fe={items:[]},qe=[];for(const[xe,Je]of ie)qe.push((async()=>{Fe.items.push([xe,await ut.from(xe,Je)])})());return await Promise.all(qe),Fe}Me.from=Ce})(ft||(e.DataTransfer=ft={}));var At;(function(Me){function Te(ie){return{message:ie.message,metadata:ie.metadata,title:ie.title,tooltip:ie.tooltip}}Me.to=Te;function Ce(ie){return{kind:"reply",message:ie.message,metadata:ie.metadata,title:ie.title,tooltip:ie.tooltip}}Me.from=Ce})(At||(e.ChatReplyFollowup=At={}));var qt;(function(Me){function Te(Ce){return typeof Ce=="string"?{title:Ce,message:Ce,kind:"reply"}:"commandId"in Ce?{kind:"command",title:Ce.title??"",commandId:Ce.commandId??"",when:Ce.when??"",args:Ce.args}:At.from(Ce)}Me.from=Te})(qt||(e.ChatFollowup=qt={}));var Lt;(function(Me){function Te(ie){const Fe=new r.$mM(at.to(ie.role),ie.content);return Fe.name=ie.name,Fe}Me.to=Te;function Ce(ie){return{role:at.from(ie.role),content:ie.content,name:ie.name}}Me.from=Ce})(Lt||(e.ChatMessage=Lt={}));var at;(function(Me){function Te(ie){switch(ie){case 0:return r.ChatMessageRole.System;case 1:return r.ChatMessageRole.User;case 2:return r.ChatMessageRole.Assistant;case 3:return r.ChatMessageRole.Function}}Me.to=Te;function Ce(ie){switch(ie){case r.ChatMessageRole.System:return 0;case r.ChatMessageRole.Assistant:return 2;case r.ChatMessageRole.Function:return 3;case r.ChatMessageRole.User:default:return 1}}Me.from=Ce})(at||(e.ChatMessageRole=at={}));var vt;(function(Me){function Te(Fe){const qe={};for(const xe of Object.keys(Fe))qe[xe]=Fe[xe].map(Me.to);return qe}Me.objectTo=Te;function Ce(Fe){return{level:Tt.to(Fe.level),value:Fe.value,description:Fe.description}}Me.to=Ce;function ie(Fe){return{level:Tt.from(Fe.level),value:Fe.value,description:Fe.description}}Me.from=ie})(vt||(e.ChatVariable=vt={}));var Tt;(function(Me){function Te(ie){switch(ie){case"short":return r.ChatVariableLevel.Short;case"medium":return r.ChatVariableLevel.Medium;case"full":default:return r.ChatVariableLevel.Full}}Me.to=Te;function Ce(ie){switch(ie){case r.ChatVariableLevel.Short:return"short";case r.ChatVariableLevel.Medium:return"medium";case r.ChatVariableLevel.Full:default:return"full"}}Me.from=Ce})(Tt||(e.ChatVariableLevel=Tt={}));var Pt;(function(Me){function Te(Ce){switch(Ce){case 1:return r.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return r.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return r.InteractiveEditorResponseFeedbackKind.Undone;case 3:return r.InteractiveEditorResponseFeedbackKind.Accepted}}Me.to=Te})(Pt||(e.InteractiveEditorResponseFeedbackKind=Pt={}));var Ge;(function(Me){function Te(Ce,ie){return"placeholder"in ie&&"resolvedContent"in ie?{placeholder:ie.placeholder}:"responseId"in ie?{requestId:ie.responseId}:"markdownContent"in ie?((0,d.$vF)(Ce,"chatAgents2Additions"),{content:O.from(ie.markdownContent)}):"content"in ie?typeof ie.content=="string"?ie:((0,d.$vF)(Ce,"chatAgents2Additions"),{content:O.from(ie.content)}):"documents"in ie?{documents:ie.documents.map(Fe=>({uri:Fe.uri,version:Fe.version,ranges:Fe.ranges.map(qe=>l.from(qe))}))}:"reference"in ie?{reference:"uri"in ie.reference?{uri:ie.reference.uri,range:l.from(ie.reference.range)}:ie.reference}:"inlineReference"in ie?{inlineReference:"uri"in ie.inlineReference?{uri:ie.inlineReference.uri,range:l.from(ie.inlineReference.range)}:ie.inlineReference,title:ie.title}:("agentName"in ie&&(0,d.$vF)(Ce,"chatAgents2Additions"),ie)}Me.from=Te})(Ge||(e.ChatResponseProgress=Ge={}));var Qt;(function(Me){function Te(Ce,ie,Fe){return"terminalCommand"in Ce?{terminalCommand:Ce.terminalCommand}:"uri"in Ce?{uri:Ce.uri}:ie.toInternal(Ce,Fe)}Me.from=Te})(Qt||(e.TerminalQuickFix=Qt={}))}),define(ke[295],Se([1,0,2,11,7,14,76]),function($e,e,I,F,f,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jdc=void 0;class p{constructor(m,A,P,g={timeout:1500,errors:3}){this.c=m,this.d=A,this.f=P,this.g=g,this.a=new R.$1c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(m){return(A,P,g)=>{const S={dispose:this.a.push([A,P,m])};return Array.isArray(g)&&g.push(S),S}}async $participateInSave(m,A){const P=I.URI.revive(m);let g=!1;const y=setTimeout(()=>g=!0,this.g.timeout),S=[];try{for(const w of[...this.a]){if(g)break;const c=this.d.getDocument(P),s=await this.h(w,{document:c,reason:L.TextDocumentSaveReason.to(A)});S.push(s)}}finally{clearTimeout(y)}return S}h([m,A,P],g){const y=this.b.get(m);return typeof y=="number"&&y>this.g.errors?Promise.resolve(!1):this.i(P,m,A,g).then(()=>!0,S=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' threw ERROR`),this.c.error(S),!(S instanceof Error)||S.message!=="concurrent_edits"){const w=this.b.get(m);this.b.set(m,w?w+1:1),typeof w=="number"&&w>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(m,A,P,g){const y=[],S=Date.now(),{document:w,reason:c}=g,{version:s}=w,i=Object.freeze({document:w,reason:c,waitUntil(n){if(Object.isFrozen(y))throw(0,F.$7)("waitUntil can not be called async");y.push(Promise.resolve(n))}});try{A.apply(P,[i])}catch(n){return Promise.reject(n)}return Object.freeze(y),new Promise((n,o)=>{const a=setTimeout(()=>o(new Error("timeout")),this.g.timeout);return Promise.all(y).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${m.identifier.value}' finished after ${Date.now()-S}ms`),clearTimeout(a),n(t)}).catch(t=>{clearTimeout(a),o(t)})}).then(n=>{const o={edits:[]};for(const a of n)if(Array.isArray(a)&&a.every(t=>t instanceof f.$EK))for(const{newText:t,newEol:r,range:d}of a)o.edits.push({resource:w.uri,versionId:void 0,textEdit:{range:d&&L.Range.from(d),text:t,eol:r&&L.EndOfLine.from(r)}});if(o.edits.length!==0)return s===w.version?this.f.$tryApplyWorkspaceEdit(o):Promise.reject(new Error("concurrent_edits"))})}}e.$jdc=p}),define(ke[296],Se([1,0,17,2,14,7,111]),function($e,e,I,F,f,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xec=e.$wec=void 0;class p{constructor(P,g,y,S){this.start=P,this.deletedCount=g,this.deletedItems=y,this.items=S}asApiEvent(){return{range:new L.$UL(this.start,this.start+this.deletedCount),addedCells:this.items.map(P=>P.apiCell),removedCells:this.deletedItems}}}class E{static asModelAddData(P,g){return{EOL:g.eol,lines:g.source,languageId:g.language,uri:g.uri,isDirty:!1,versionId:1,notebook:P}}constructor(P,g,y){this.notebook=P,this.h=g,this.j=y,this.handle=y.handle,this.uri=F.URI.revive(y.uri),this.cellKind=y.cellKind,this.a=y.outputs.map(f.NotebookCellOutput.to),this.e=y.internalMetadata??{},this.b=Object.freeze(y.metadata??{}),this.d=Object.freeze(f.NotebookCellExecutionSummary.to(y.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const P=this,g=this.h.getDocument(this.uri);if(!g)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const y={get index(){return P.notebook.getCellIndex(P)},notebook:P.notebook.apiNotebook,kind:f.NotebookCellKind.to(this.j.cellKind),document:g.document,get mime(){return P.g},set mime(S){P.g=S},get outputs(){return P.a.slice(0)},get metadata(){return P.b},get executionSummary(){return P.d}};this.f=Object.freeze(y)}return this.f}setOutputs(P){this.a=P.map(f.NotebookCellOutput.to)}setOutputItems(P,g,y){const S=y.map(f.NotebookCellOutputItem.to),w=this.a.find(c=>c.id===P);if(w&&(g||(w.items.length=0),w.items.push(...S),w.items.length>1&&w.items.every(c=>R.$AI(c.mime)))){const c=new Map,s=[];w.items.forEach(i=>{let n;c.has(i.mime)?n=c.get(i.mime):(n=[],c.set(i.mime,n),s.push(i.mime)),n.push(i.data)}),w.items.length=0,s.forEach(i=>{const n=R.$BI(c.get(i));w.items.push({mime:i,data:n.data.buffer})})}}setMetadata(P){this.b=Object.freeze(P)}setInternalMetadata(P){this.e=P,this.d=Object.freeze(f.NotebookCellExecutionSummary.to(P))}setMime(P){}}e.$wec=E;class m{static{this.a=0}constructor(P,g,y,S,w){this.k=P,this.l=g,this.m=y,this.uri=S,this.handle=m.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=w.viewType,this.f=Object.freeze(w.metadata??Object.create(null)),this.r([[0,0,w.cells]],!0,void 0),this.g=w.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const P=this,g={get uri(){return P.uri},get version(){return P.g},get notebookType(){return P.d},get isDirty(){return P.h},get isUntitled(){return P.uri.scheme===I.Schemas.untitled},get isClosed(){return P.j},get metadata(){return P.f},get cellCount(){return P.b.length},cellAt(y){return y=P.n(y),P.b[y].apiCell},getCells(y){return(y?P.p(y):P.b).map(w=>w.apiCell)},save(){return P.q()}};this.e=Object.freeze(g)}return this.e}acceptDocumentPropertiesChanged(P){P.metadata&&(this.f=Object.freeze({...this.f,...P.metadata}))}acceptDirty(P){this.h=P}acceptModelChanged(P,g,y){this.g=P.versionId,this.h=g,this.acceptDocumentPropertiesChanged({metadata:y});const S={notebook:this.apiNotebook,metadata:y,cellChanges:[],contentChanges:[]},w=[];for(const s of P.rawEvents)s.kind===R.NotebookCellsChangeType.ModelChange?this.r(s.changes,!1,S.contentChanges):s.kind===R.NotebookCellsChangeType.Move?this.s(s.index,s.length,s.newIdx,S.contentChanges):s.kind===R.NotebookCellsChangeType.Output?(this.t(s.index,s.outputs),w.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===R.NotebookCellsChangeType.OutputItem?(this.u(s.index,s.outputId,s.append,s.outputItems),w.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(s.index,s.language),w.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document})):s.kind===R.NotebookCellsChangeType.ChangeCellContent?w.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document}):s.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(s.index,s.mime):s.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(s.index,s.metadata),w.push({cell:this.b[s.index].apiCell,metadata:this.b[s.index].apiCell.metadata})):s.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(s.index,s.internalMetadata),w.push({cell:this.b[s.index].apiCell,executionSummary:this.b[s.index].apiCell.executionSummary}));const c=new Map;for(let s=0;s<w.length;s++){const i=w[s],n=c.get(i.cell);if(n===void 0){const o=S.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...i});c.set(i.cell,o-1)}else S.cellChanges[n]={...S.cellChanges[n],...i}}return Object.freeze(S),Object.freeze(S.cellChanges),Object.freeze(S.contentChanges),S}n(P){return P=P|0,P<0?0:P>=this.b.length?this.b.length-1:P}o(P){let g=P.start|0,y=P.end|0;return g<0&&(g=0),y>this.b.length&&(y=this.b.length),P.with({start:g,end:y})}p(P){P=this.o(P);const g=[];for(let y=P.start;y<P.end;y++)g.push(this.b[y]);return g}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(P,g,y){if(this.j)return;const S=[],w=[],c=[];if(P.reverse().forEach(s=>{const n=s[2].map(t=>{const r=new E(this,this.l,t);return g||w.push(E.asModelAddData(this.apiNotebook,t)),r}),o=new p(s[0],s[1],[],n),a=this.b.splice(s[0],s[1],...n);for(const t of a)c.push(t.uri),o.deletedItems.push(t.apiCell);S.push(o)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:w,removedDocuments:c}),y)for(const s of S)y.push(s.asApiEvent())}s(P,g,y,S){const w=this.b.splice(P,g);this.b.splice(y,0,...w);const c=[new p(P,g,w.map(s=>s.apiCell),[]),new p(y,0,[],w)];for(const s of c)S.push(s.asApiEvent())}t(P,g){this.b[P].setOutputs(g)}u(P,g,y,S){this.b[P].setOutputItems(g,y,S)}v(P,g){const y=this.b[P];y.apiCell.document.languageId!==g&&this.m.$acceptModelLanguageChanged(y.uri,g)}w(P,g){const y=this.b[P];y.apiCell.mime=g}x(P,g){this.b[P].setMetadata(g)}y(P,g){this.b[P].setInternalMetadata(g)}getCellFromApiCell(P){return this.b.find(g=>g.apiCell===P)}getCellFromIndex(P){return this.b[P]}getCell(P){return this.b.find(g=>g.handle===P)}getCellIndex(P){return this.b.indexOf(P)}}e.$xec=m}),define(ke[297],Se([1,0,4,2,14,7]),function($e,e,I,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xec=void 0;class R{constructor(E,m,A,P={timeout:1500,errors:3}){this.b=E,this.c=m,this.d=A,this.f=P,this.a=new I.$Qd}dispose(){}getOnWillSaveNotebookDocumentEvent(E){return(m,A,P)=>{const g=function(S){m.call(A,S)};return g.extension=E,this.a.event(g,void 0,P)}}async $participateInSave(E,m,A){const P=F.URI.revive(E),g=this.c.getNotebookDocument(P);if(!g)throw new Error("Unable to resolve notebook document");const y=[];if(await this.a.fireAsync({notebook:g.apiNotebook,reason:f.TextDocumentSaveReason.to(m)},A,async(w,c)=>{const s=Date.now(),i=await await Promise.resolve(w);Date.now()-s>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",c.extension.identifier),!A.isCancellationRequested&&i&&(i instanceof L.$HK?y.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",c.extension.identifier,"ignored due to invalid data"))}),A.isCancellationRequested)return!1;if(y.length===0)return!0;const S={edits:[]};for(const w of y){const{edits:c}=f.WorkspaceEdit.from(w);S.edits=S.edits.concat(c)}return this.d.$tryApplyWorkspaceEdit(S)}}e.$Xec=R}),define(ke[148],Se([1,0,11,14,7]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yec=void 0;class L{static{this.apiEditorsToExtHost=new WeakMap}constructor(p,E,m,A,P,g){this.id=p,this.f=E,this.notebookData=m,this.a=[],this.b=[],this.d=!1,this.a=P,this.b=A,this.c=g}get apiEditor(){if(!this.e){const p=this;this.e={get notebook(){return p.notebookData.apiNotebook},get selection(){return p.a[0]},set selection(E){this.selections=[E]},get selections(){return p.a},set selections(E){if(!Array.isArray(E)||!E.every(f.$UL.isNotebookRange))throw(0,I.$6)("selections");p.a=E,p.g(E)},get visibleRanges(){return p.b},revealRange(E,m){p.f.$tryRevealRange(p.id,F.NotebookRange.from(E),m??f.NotebookEditorRevealType.Default)},get viewColumn(){return p.c}},L.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(p){this.d=p}_acceptVisibleRanges(p){this.b=p}_acceptSelections(p){this.a=p}g(p){this.f.$trySetSelections(this.id,p.map(F.NotebookRange.from))}_acceptViewColumn(p){this.c=p}}e.$yec=L}),define(ke[298],Se([1,0,11,4,15,14]),function($e,e,I,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qec=void 0;let R=class{constructor(E,m){this.c=E,this.d=m,this.a=new F.$Od({onListenerError:I.$1}),this.b=new F.$Od({onListenerError:I.$1}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(E,m){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",E,m);const A=this.d.getEditorById(E);m.visibleRanges&&A._acceptVisibleRanges(m.visibleRanges.ranges.map(L.NotebookRange.to)),m.selections&&A._acceptSelections(m.selections.selections.map(L.NotebookRange.to)),m.visibleRanges&&this.b.fire({notebookEditor:A.apiEditor,visibleRanges:A.apiEditor.visibleRanges}),m.selections&&this.a.fire(Object.freeze({notebookEditor:A.apiEditor,selections:A.apiEditor.selections}))}$acceptEditorViewColumns(E){for(const m in E)this.d.getEditorById(m)._acceptViewColumn(L.ViewColumn.to(E[m]))}};e.$Qec=R,e.$Qec=R=He([Be(0,f.$bj)],R)}),define(ke[299],Se([1,0,14,64,217,21,59,11]),function($e,e,I,F,f,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Udc=void 0;class E{constructor(g){this.b=0,this.c=new Map,this.a=g}async withProgress(g,y,S){const w=this.b++,{title:c,location:s,cancellable:i}=y,n={label:(0,f.localize)(0,null,g.displayName||g.name),id:g.identifier.value};return this.a.$startProgress(w,{location:I.ProgressLocation.from(s),title:c,source:n,cancellable:i},g.isUnderDevelopment?void 0:g.identifier.value).catch(p.$1),this.d(w,S,!!i)}d(g,y,S){let w;S&&(w=new L.$Yd,this.c.set(g,w));const c=i=>{this.a.$progressEnd(i),this.c.delete(i),w?.dispose()};let s;try{s=y(new A(this.a,g),S&&w?w.token:L.CancellationToken.None)}catch(i){throw c(g),i}return s.then(i=>c(g),i=>c(g)),s}$acceptProgressCanceled(g){const y=this.c.get(g);y&&(y.cancel(),this.c.delete(g))}}e.$Udc=E;function m(P,g){return P.message=g.message,typeof g.increment=="number"&&(typeof P.increment=="number"?P.increment+=g.increment:P.increment=g.increment),P}class A extends F.$9u{constructor(g,y){super(S=>this.throttledReport(S)),this.c=g,this.d=y}throttledReport(g){this.c.$progressReport(this.d,g)}}He([(0,R.$nh)(100,(P,g)=>m(P,g),()=>Object.create(null))],A.prototype,"throttledReport",null)}),define(ke[149],Se([1,0,29,144,68,112,89,14,2]),function($e,e,I,F,f,L,R,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MM=e.$LM=e.$KM=e.$JM=void 0;const m=(n,o,a,t)=>{let r=o;return{enumerable:!0,configurable:!1,get(){return r},set(d){if(!a(r,d)){const u=r;r=d,n.listener?.(t(d,u))}}}},A=(n,o)=>n===o,P={range:(n,o)=>n===o?!0:!n||!o?!1:n.isEqual(o),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(n,o)=>!(n.length!==o.length||n.some(a=>!o.find(t=>a.id===t.id)))},g=n=>o=>({op:4,update:n(o)}),y=(n,o)=>({range:(()=>{let a;const t=g(r=>({range:I.$xs.lift(p.Range.from(r))}));return{enumerable:!0,configurable:!1,get(){return a},set(r){n.listener?.({op:6}),P.range(a,r)||(a=r,n.listener?.(t(r)))}}})(),label:m(n,o,P.label,g(a=>({label:a}))),description:m(n,void 0,P.description,g(a=>({description:a}))),sortText:m(n,void 0,P.sortText,g(a=>({sortText:a}))),canResolveChildren:m(n,!1,P.canResolveChildren,a=>({op:2,state:a})),busy:m(n,!1,P.busy,g(a=>({busy:a}))),error:m(n,void 0,P.error,g(a=>({error:p.MarkdownString.fromStrict(a)||null}))),tags:m(n,[],P.tags,(a,t)=>({op:1,new:a.map(p.TestTag.from),old:t.map(p.TestTag.from)}))}),S=n=>{const o=f.$lJ.fromString(n.extId),a=new c(o.controllerId,o.localId,n.label,E.URI.revive(n.uri)||void 0);return a.range=p.Range.to(n.range||void 0),a.description=n.description||void 0,a.sortText=n.sortText||void 0,a.tags=n.tags.map(t=>p.TestTag.to({id:(0,R.$qJ)(t).tagId})),a},w=n=>{let o;for(const a of n.tests){const t=S(a.item);(0,F.$tM)(t).parent=o,o=t}return o};e.$JM=w;class c{constructor(o,a,t,r){if(a.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(a)} symbol`);const d=(0,F.$sM)(this,o);Object.defineProperties(this,{id:{value:a,enumerable:!0,writable:!1},uri:{value:r,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return d.parent instanceof s?void 0:d.parent}},children:{value:(0,L.$rM)(d,F.$tM,c),enumerable:!0,writable:!1},...y(d,t)})}}e.$KM=c;class s extends c{constructor(o,a){super(o,o,a,void 0),this._isRoot=!0}}e.$LM=s;class i extends L.$nM{constructor(o,a,t){super({controllerId:o,getDocumentVersion:r=>r&&t.getDocument(r)?.version,getApiFor:F.$tM,getChildren:r=>r.children,root:new s(o,a),toITestItem:p.TestItem.from})}}e.$MM=i}),define(ke[150],Se([1,0,60,11,122,14,7]),function($e,e,I,F,f,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GM=e.$FM=e.$EM=void 0;class p{static{this.c=new f.$CM("TextEditorDecorationType")}constructor(g,y,S){const w=p.c.nextId();g.$registerTextEditorDecorationType(y.identifier,w,L.DecorationRenderOptions.from(S)),this.value=Object.freeze({key:w,dispose(){g.$removeTextEditorDecorationType(w)}})}}e.$EM=p;class E{constructor(g,y){this.g=[],this.h=void 0,this.j=!1,this.c=g,this.d=g.version,this.e=y.undoStopBefore,this.f=y.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(g,y){this.k();let S=null;if(g instanceof R.$yK)S=new R.$zK(g,g);else if(g instanceof R.$zK)S=g;else throw new Error("Unrecognized location");this.l(S,y,!1)}insert(g,y){this.k(),this.l(new R.$zK(g,g),y,!0)}delete(g){this.k();let y=null;if(g instanceof R.$zK)y=g;else throw new Error("Unrecognized location");this.l(y,null,!0)}l(g,y,S){const w=this.c.validateRange(g);this.g.push({range:w,text:y,forceMoveMarkers:S})}setEndOfLine(g){if(this.k(),g!==R.EndOfLine.LF&&g!==R.EndOfLine.CRLF)throw(0,F.$6)("endOfLine");this.h=g}}class m{constructor(g,y,S,w){this.c=g,this.d=y,this._accept(S),this.e=w;const c=this;this.value={get tabSize(){return c.f},set tabSize(s){c.m(s)},get indentSize(){return c.g},set indentSize(s){c.o(s)},get insertSpaces(){return c.h},set insertSpaces(s){c.q(s)},get cursorStyle(){return c.j},set cursorStyle(s){c.s(s)},get lineNumbers(){return c.k},set lineNumbers(s){c.t(s)}}}_accept(g){this.f=g.tabSize,this.g=g.indentSize,this.h=g.insertSpaces,this.j=g.cursorStyle,this.k=L.TextEditorLineNumbersStyle.to(g.lineNumbers)}l(g){if(g==="auto")return"auto";if(typeof g=="number"){const y=Math.floor(g);return y>0?y:null}if(typeof g=="string"){const y=parseInt(g,10);return isNaN(y)?null:y>0?y:null}return null}m(g){const y=this.l(g);if(y!==null){if(typeof y=="number"){if(this.f===y)return;this.f=y}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:y}))}}n(g){if(g==="tabSize")return"tabSize";if(typeof g=="number"){const y=Math.floor(g);return y>0?y:null}if(typeof g=="string"){const y=parseInt(g,10);return isNaN(y)?null:y>0?y:null}return null}o(g){const y=this.n(g);if(y!==null){if(typeof y=="number"){if(this.g===y)return;this.g=y}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:y}))}}p(g){return g==="auto"?"auto":g==="false"?!1:!!g}q(g){const y=this.p(g);if(typeof y=="boolean"){if(this.h===y)return;this.h=y}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:y}))}s(g){this.j!==g&&(this.j=g,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:g})))}t(g){this.k!==g&&(this.k=g,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:L.TextEditorLineNumbersStyle.from(g)})))}assign(g){const y={};let S=!1;if(typeof g.tabSize<"u"){const w=this.l(g.tabSize);w==="auto"?(S=!0,y.tabSize=w):typeof w=="number"&&this.f!==w&&(this.f=w,S=!0,y.tabSize=w)}if(typeof g.indentSize<"u"){const w=this.n(g.indentSize);w==="tabSize"?(S=!0,y.indentSize=w):typeof w=="number"&&this.g!==w&&(this.g=w,S=!0,y.indentSize=w)}if(typeof g.insertSpaces<"u"){const w=this.p(g.insertSpaces);w==="auto"?(S=!0,y.insertSpaces=w):this.h!==w&&(this.h=w,S=!0,y.insertSpaces=w)}typeof g.cursorStyle<"u"&&this.j!==g.cursorStyle&&(this.j=g.cursorStyle,S=!0,y.cursorStyle=g.cursorStyle),typeof g.lineNumbers<"u"&&this.k!==g.lineNumbers&&(this.k=g.lineNumbers,S=!0,y.lineNumbers=L.TextEditorLineNumbersStyle.from(g.lineNumbers)),S&&this.u("setOptions",this.c.$trySetOptions(this.d,y))}u(g,y){y.catch(S=>{this.e.warn(`ExtHostTextEditorOptions '${g}' failed:'`),this.e.warn(S)})}}e.$FM=m;class A{constructor(g,y,S,w,c,s,i,n){this.id=g,this.j=y,this.k=S,this.g=!1,this.h=new Set,this.c=c,this.d=new m(this.j,this.id,s,S),this.e=i,this.f=n;const o=this;this.value=Object.freeze({get document(){return w.value},set document(a){throw new F.$8("document")},get selection(){return o.c&&o.c[0]},set selection(a){if(!(a instanceof R.$AK))throw(0,F.$6)("selection");o.c=[a],o.l()},get selections(){return o.c},set selections(a){if(!Array.isArray(a)||a.some(t=>!(t instanceof R.$AK)))throw(0,F.$6)("selections");o.c=a,o.l()},get visibleRanges(){return o.e},set visibleRanges(a){throw new F.$8("visibleRanges")},get options(){return o.d.value},set options(a){o.g||o.d.assign(a)},get viewColumn(){return o.f},set viewColumn(a){throw new F.$8("viewColumn")},edit(a,t={undoStopBefore:!0,undoStopAfter:!0}){if(o.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new E(w.value,t);return a(r),o.m(r)},insertSnippet(a,t,r={undoStopBefore:!0,undoStopAfter:!0}){if(o.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let d;if(!t||Array.isArray(t)&&t.length===0)d=o.c.map(u=>L.Range.from(u));else if(t instanceof R.$yK){const{lineNumber:u,column:l}=L.Position.from(t);d=[{startLineNumber:u,startColumn:l,endLineNumber:u,endColumn:l}]}else if(t instanceof R.$zK)d=[L.Range.from(t)];else{d=[];for(const u of t)if(u instanceof R.$zK)d.push(L.Range.from(u));else{const{lineNumber:l,column:h}=L.Position.from(u);d.push({startLineNumber:l,startColumn:h,endLineNumber:l,endColumn:h})}}return y.$tryInsertSnippet(g,w.value.version,a.value,d,r)},setDecorations(a,t){const r=t.length===0;r&&!o.h.has(a.key)||(r?o.h.delete(a.key):o.h.add(a.key),o.n(()=>{if(L.$uM(t))return y.$trySetDecorations(g,a.key,L.$vM(t));{const d=new Array(4*t.length);for(let u=0,l=t.length;u<l;u++){const h=t[u];d[4*u]=h.start.line+1,d[4*u+1]=h.start.character+1,d[4*u+2]=h.end.line+1,d[4*u+3]=h.end.character+1}return y.$trySetDecorationsFast(g,a.key,d)}}))},revealRange(a,t){o.n(()=>y.$tryRevealRange(g,L.Range.from(a),t||R.TextEditorRevealType.Default))},show(a){y.$tryShowEditor(g,L.ViewColumn.from(a))},hide(){y.$tryHideEditor(g)}})}dispose(){(0,I.ok)(!this.g),this.g=!0}_acceptOptions(g){(0,I.ok)(!this.g),this.d._accept(g)}_acceptVisibleRanges(g){(0,I.ok)(!this.g),this.e=g}_acceptViewColumn(g){(0,I.ok)(!this.g),this.f=g}_acceptSelections(g){(0,I.ok)(!this.g),this.c=g}async l(){const g=this.c.map(L.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,g)),this.value}m(g){const y=g.finalize();if(y.edits.length===0&&!y.setEndOfLine)return Promise.resolve(!0);const S=y.edits.map(c=>c.range);S.sort((c,s)=>c.end.line===s.end.line?c.end.character===s.end.character?c.start.line===s.start.line?c.start.character-s.start.character:c.start.line-s.start.line:c.end.character-s.end.character:c.end.line-s.end.line);for(let c=0,s=S.length-1;c<s;c++){const i=S[c].end;if(S[c+1].start.isBefore(i))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const w=y.edits.map(c=>({range:L.Range.from(c.range),text:c.text,forceMoveMarkers:c.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,y.documentVersionId,w,{setEndOfLine:typeof y.setEndOfLine=="number"?L.EndOfLine.from(y.setEndOfLine):void 0,undoStopBefore:y.undoStopBefore,undoStopAfter:y.undoStopAfter})}n(g){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):g().then(()=>this,y=>(y instanceof Error&&y.name==="DISPOSED"||this.k.warn(y),null))}}e.$GM=A}),define(ke[300],Se([1,0,221,23,2,4,3,280,10,7,18,19,14,81,21,177,25]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,S,w,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2dc=void 0;function s(o,a){if((0,A.$zf)(o))return{label:o};if(o&&typeof o=="object"&&typeof o.label=="string"){let t;return Array.isArray(o.highlights)&&(t=o.highlights.filter(r=>r.length===2&&typeof r[0]=="number"&&typeof r[1]=="number"),t=t.length?t:void 0),{label:o.label,highlights:t}}}class i extends R.$Rc{constructor(a,t,r){super(),this.f=a,this.g=t,this.h=r,this.a=new Map,this.b=new w.$k8;function d(u){return u&&u.$treeViewId&&(u.$treeItemHandle||u.$selectedTreeItems||u.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:u=>d(u)?this.r(u):Array.isArray(u)&&u.length>0?u.map(l=>d(l)?this.r(l):l):u})}registerTreeDataProvider(a,t,r){const d=this.createTreeView(a,{treeDataProvider:t},r);return{dispose:()=>d.dispose()}}createTreeView(a,t,r){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const d=t.dragAndDropController?.dropMimeTypes??[],u=t.dragAndDropController?.dragMimeTypes??[],l=!!t.dragAndDropController?.handleDrag,h=!!t.dragAndDropController?.handleDrop,k=this.m(a,t,r),D={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:d,dragMimeTypes:u,hasHandleDrag:l,hasHandleDrop:h,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},$=this.f.$registerTreeViewDataProvider(a,D),b={get onDidCollapseElement(){return k.onDidCollapseElement},get onDidExpandElement(){return k.onDidExpandElement},get selection(){return k.selectedElements},get onDidChangeSelection(){return k.onDidChangeSelection},get activeItem(){return(0,c.$vF)(r,"treeViewActiveItem"),k.focusedElement},get onDidChangeActiveItem(){return(0,c.$vF)(r,"treeViewActiveItem"),k.onDidChangeActiveItem},get visible(){return k.visible},get onDidChangeVisibility(){return k.onDidChangeVisibility},get onDidChangeCheckboxState(){return k.onDidChangeCheckboxState},get message(){return k.message},set message(v){(0,y.$9j)(v)&&(0,c.$vF)(r,"treeViewMarkdownMessage"),k.message=v},get title(){return k.title},set title(v){k.title=v},get description(){return k.description},set description(v){k.description=v},get badge(){return k.badge},set badge(v){v!==void 0&&m.ViewBadge.isViewBadge(v)?k.badge={value:Math.floor(Math.abs(v.value)),tooltip:v.tooltip}:v===void 0&&(k.badge=void 0)},reveal:(v,C)=>k.reveal(v,C),dispose:async()=>{await $,this.a.delete(a),k.dispose()}};return this.B(b),b}$getChildren(a,t){const r=this.a.get(a);return r?r.getChildren(t):Promise.reject(new p.$GE(a))}async $handleDrop(a,t,r,d,u,l,h,k){const D=this.a.get(a);if(!D)return Promise.reject(new p.$GE(a));const $=g.DataTransfer.toDataTransfer(r,async b=>(await this.f.$resolveDropFileData(a,t,b)).buffer);return h===a&&k&&await this.j($,D,k,u,l),D.onDrop($,d,u)}async j(a,t,r,d,u){const l=this.b.removeDragOperationTransfer(u);if(l)(await l)?.forEach((h,k)=>{h&&a.set(k,h)});else if(u&&t.handleDrag){const h=t.handleDrag(r,a,d);this.b.addDragOperationTransfer(u,h),await h}return a}async $handleDrag(a,t,r,d){const u=this.a.get(a);if(!u)return Promise.reject(new p.$GE(a));const l=await this.j(new m.$oL,u,t,d,r);if(!(!l||d.isCancellationRequested))return g.DataTransfer.from(l)}async $hasResolve(a){const t=this.a.get(a);if(!t)throw new p.$GE(a);return t.hasResolve}$resolve(a,t,r){const d=this.a.get(a);if(!d)throw new p.$GE(a);return d.resolveTreeItem(t,r)}$setExpanded(a,t,r){const d=this.a.get(a);if(!d)throw new p.$GE(a);d.setExpanded(t,r)}$setSelectionAndFocus(a,t,r){const d=this.a.get(a);if(!d)throw new p.$GE(a);d.setSelectionAndFocus(t,r)}$setVisible(a,t){const r=this.a.get(a);if(!r){if(!t)return;throw new p.$GE(a)}r.setVisible(t)}$changeCheckboxState(a,t){const r=this.a.get(a);if(!r)throw new p.$GE(a);r.setCheckboxState(t)}m(a,t,r){const d=this.B(new n(a,t,this.f,this.g.converter,this.h,r));return this.a.set(a,d),d}r(a){const t=this.a.get(a.$treeViewId);return t&&"$treeItemHandle"in a?t.getExtensionElement(a.$treeItemHandle):t&&"$focusedTreeItem"in a&&a.$focusedTreeItem?t.focusedElement:null}}e.$2dc=i;class n extends R.$Rc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(a=>this.getExtensionElement(a)).filter(a=>!(0,A.$If)(a))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(a,t,r,d,u,l){if(super(),this.I=a,this.J=r,this.L=d,this.M=u,this.N=l,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new L.$Od),this.onDidExpandElement=this.u.event,this.w=this.B(new L.$Od),this.onDidCollapseElement=this.w.event,this.y=this.B(new L.$Od),this.onDidChangeSelection=this.y.event,this.z=this.B(new L.$Od),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new L.$Od),this.onDidChangeVisibility=this.C.event,this.D=this.B(new L.$Od),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new L.$Od),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new S.$Yd,l.contributes&&l.contributes.views)for(const $ in l.contributes.views)for(const b of l.contributes.views[$])b.id===a&&(this.P=b.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData($=>this.F.fire({message:!1,element:$})));let h,k;const D=L.Event.debounce(this.F.event,($,b)=>($||($={message:!1,elements:[]}),b.element!==!1&&(h||(h=new Promise(v=>k=v),this.G=this.G.then(()=>h)),Array.isArray(b.element)?$.elements.push(...b.element):$.elements.push(b.element)),b.message&&($.message=!0),$),200,!0);this.B(D(({message:$,elements:b})=>{b.length&&(this.H=this.H.then(()=>{const v=k;return h=null,this.$(b).then(()=>v())})),$&&this.J.$setMessage(this.I,g.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(a){const t=a?this.getExtensionElement(a):void 0;if(a&&!t)return this.M.error(`No tree item with id '${a}' found.`),Promise.resolve([]);let r=this.X(a);return r||(r=await this.Y(t)),r?r.map(d=>d.item):void 0}getExtensionElement(a){return this.j.get(a)}reveal(a,t){t=t||{select:!0,focus:!1};const r=(0,A.$If)(t.select)?!0:t.select,d=(0,A.$If)(t.focus)?!1:t.focus,u=(0,A.$If)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):a?this.G.then(()=>this.S(a)).then(l=>this.W(a,l[l.length-1]).then(h=>this.J.$reveal(this.I,{item:h.item,parentChain:l.map(k=>k.item)},{select:r,focus:d,expand:u})),l=>this.M.error(l)):this.J.$reveal(this.I,void 0,{select:r,focus:d,expand:u})}get message(){return this.O}set message(a){this.O=a,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(a){this.P=a,this.J.$setTitle(this.I,a,this.Q)}get description(){return this.Q}set description(a){this.Q=a,this.J.$setTitle(this.I,this.P,a)}get badge(){return this.R}set badge(a){this.R?.value===a?.value&&this.R?.tooltip===a?.tooltip||(this.R=g.ViewBadge.from(a),this.J.$setBadge(this.I,a))}setExpanded(a,t){const r=this.getExtensionElement(a);r&&(t?this.u.fire(Object.freeze({element:r})):this.w.fire(Object.freeze({element:r})))}setSelectionAndFocus(a,t){const r=!(0,P.$tb)(this.s,a);this.s=a;const d=this.t!==t;this.t=t,r&&this.y.fire(Object.freeze({selection:this.selectedElements})),d&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(a){a!==this.r&&(this.r=a,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(a){const t=(await Promise.all(a.map(async r=>{const d=this.getExtensionElement(r.treeItemHandle);return d?{extensionItem:d,treeItem:await this.f.getTreeItem(d),newState:r.newState?m.TreeItemCheckboxState.Checked:m.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(r=>r!==void 0);t.forEach(r=>{r.treeItem.checkboxState=r.newState?m.TreeItemCheckboxState.Checked:m.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(r=>[r.extensionItem,r.newState])})}async handleDrag(a,t,r){const d=[];for(const u of a){const l=this.getExtensionElement(u);l&&d.push(l)}if(!(!this.g?.handleDrag||d.length===0))return await this.g.handleDrag(d,t,r),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(a,t,r){const d=t?this.getExtensionElement(t):void 0;if(!(!d&&t||!this.g?.handleDrop))return(0,E.$Ng)(()=>this.g?.handleDrop?this.g.handleDrop(d,a,r):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(a,t){if(!this.f.resolveTreeItem)return;const r=this.j.get(a);if(r){const d=this.m.get(r);if(d){const u=await this.f.resolveTreeItem(d.extensionItem,r,t)??d.extensionItem;return this.hb(u),d.item.tooltip=this.eb(u.tooltip),d.item.command=this.fb(d.disposableStore,u.command),d.item}}}S(a){return this.U(a).then(t=>t?this.S(t).then(r=>this.W(t,r[r.length-1]).then(d=>(r.push(d),r))):Promise.resolve([]))}U(a){const t=this.m.get(a);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,E.$Ng)(()=>this.f.getParent(a))}W(a,t){const r=this.m.get(a);return r?Promise.resolve(r):(0,E.$Ng)(()=>this.f.getTreeItem(a)).then(d=>this.kb(a,d,t,!0)).then(d=>this.getChildren(t?t.item.handle:void 0).then(()=>{const u=this.getExtensionElement(d);if(u){const l=this.m.get(u);if(l)return Promise.resolve(l)}throw new Error(`Cannot resolve tree item for element ${d} from extension ${this.N.identifier.value}`)}))}X(a){if(a){let t;if(typeof a=="string"){const r=this.getExtensionElement(a);t=r?this.m.get(r):void 0}else t=a;return t&&t.children||void 0}return this.h}async Y(a){this.rb(a);const t=new S.$Yd(this.Z.token);try{const r=a?this.m.get(a):void 0,d=await this.f.getChildren(a);if(t.token.isCancellationRequested)return;const u=await Promise.all((0,P.$Gb)(d||[]).map(async l=>{const h=await this.f.getTreeItem(l);return h&&!t.token.isCancellationRequested?this.db(l,h,r):null}));return t.token.isCancellationRequested?void 0:(0,P.$Gb)(u)}finally{t.dispose()}}$(a){if(a.some(r=>!r))return this.Z.dispose(!0),this.Z=new S.$Yd,this.tb(),this.J.$refresh(this.I);{const r=this.ab(a);if(r.length)return this.bb(r)}return Promise.resolve(void 0)}ab(a){const t=new Set,r=a.map(u=>this.m.get(u));for(const u of r)if(u&&!t.has(u.item.handle)){let l=u;for(;l&&l.parent&&r.findIndex(h=>l&&l.parent&&h&&h.item.handle===l.parent.item.handle)===-1;){const h=this.j.get(l.parent.item.handle);l=h?this.m.get(h):void 0}l&&!l.parent&&t.add(u.item.handle)}const d=[];return t.forEach(u=>{const l=this.j.get(u);if(l){const h=this.m.get(l);h&&(!h.parent||!t.has(h.parent.item.handle))&&d.push(u)}}),d}bb(a){const t={};return Promise.all(a.map(r=>this.cb(r).then(d=>{d&&(t[r]=d.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(a){const t=this.getExtensionElement(a);if(t){const r=this.m.get(t);if(r)return this.rb(t),(0,E.$Ng)(()=>this.f.getTreeItem(t)).then(d=>{if(d){const u=this.ib(t,d,r.parent);return this.pb(t,u,r,r.parent),r.dispose(),u}return null})}return Promise.resolve(null)}db(a,t,r){const d=this.ib(a,t,r);if(t.id&&this.j.has(d.item.handle))throw new Error((0,I.localize)(0,null,t.id));return this.ob(a,d),this.qb(d,r),d}eb(a){return m.$XK.isMarkdownString(a)?g.MarkdownString.from(a):a}fb(a,t){return t?{...this.L.toInternal(t,a),originalId:t.command}:void 0}gb(a){if(a.checkboxState===void 0)return;let t,r,d;return typeof a.checkboxState=="number"?t=a.checkboxState:(t=a.checkboxState.state,r=a.checkboxState.tooltip,d=a.checkboxState.accessibilityInformation),{isChecked:t===m.TreeItemCheckboxState.Checked,tooltip:r,accessibilityInformation:d}}hb(a){if(!m.$jL.isTreeItem(a,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(a,t,r){this.hb(t);const d=this.B(new R.$Qc),u=this.kb(a,t,r),l=this.lb(t);return{item:{handle:u,parentHandle:r?r.item.handle:void 0,label:s(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(d,t.command),contextValue:t.contextValue,icon:l,iconDark:this.mb(t)||l,themeIcon:this.jb(t),collapsibleState:(0,A.$If)(t.collapsibleState)?m.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:r,children:void 0,disposableStore:d,dispose(){d.dispose()}}}jb(a){return a.iconPath instanceof m.$rL?a.iconPath:void 0}kb(a,{id:t,label:r,resourceUri:d},u,l){if(t)return`${n.b}/${t}`;const h=s(r,this.N),k=u?u.item.handle:n.a;let D=h?h.label:d?(0,F.$tg)(d):"";D=D.indexOf("/")!==-1?D.replace("/","//"):D;const $=this.m.has(a)?this.m.get(a).item.handle:void 0,b=this.X(u)||[];let v,C=0;do{if(v=`${k}/${C}:${D}`,l||!this.j.has(v)||$===v)break;C++}while(C<=b.length);return v}lb(a){if(a.iconPath&&!(a.iconPath instanceof m.$rL))return typeof a.iconPath=="string"||f.URI.isUri(a.iconPath)?this.nb(a.iconPath):this.nb(a.iconPath.light)}mb(a){if(a.iconPath&&!(a.iconPath instanceof m.$rL)&&a.iconPath.dark)return this.nb(a.iconPath.dark)}nb(a){return f.URI.isUri(a)?a:f.URI.file(a)}ob(a,t){this.j.set(t.item.handle,a),this.m.set(a,t)}pb(a,t,r,d){this.j.delete(t.item.handle),this.m.delete(a),t.item.handle!==r.item.handle&&this.j.delete(r.item.handle),this.ob(a,t);const u=this.X(d)||[],l=u.filter(h=>h.item.handle===r.item.handle)[0];l&&u.splice(u.indexOf(l),1,t)}qb(a,t){t?(t.children||(t.children=[]),t.children.push(a)):(this.h||(this.h=[]),this.h.push(a))}rb(a){if(a){const t=this.m.get(a);if(t){if(t.children)for(const r of t.children){const d=this.j.get(r.item.handle);d&&this.sb(d)}t.children=void 0}}else this.tb()}sb(a){const t=this.m.get(a);if(t){if(t.children)for(const r of t.children){const d=this.j.get(r.item.handle);d&&this.sb(d)}this.m.delete(a),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(a=>a.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(ke[301],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmInputBoxActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testingActiveProfile:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testingActiveProfile.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ke[302],Se([1,0,235,11,39,135,108,38,26,301,138,139]),function($e,e,I,F,f,L,R,p,E,m,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oF=e.$nF=e.$mF=e.$lF=e.$kF=e.$jF=void 0;const g=p.$kn.as(R.$ln.JSONContribution);class y{constructor(a,t,r){this.a=a,this.b=t,this.c=r}d(a,t){this.a({type:a,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(a){this.d(f.default.Error,a)}warn(a){this.d(f.default.Warning,a)}info(a){this.d(f.default.Info,a)}}e.$jF=y;class S{static a(a){const t=new E.$$l;for(let r=0,d=a.length;r<d;r++)t.add(a[r].description.identifier);return t}static compute(a,t){if(!a||!a.length)return new S(t,[]);if(!t||!t.length)return new S([],a);const r=this.a(a),d=this.a(t),u=t.filter(h=>!r.has(h.description.identifier)),l=a.filter(h=>!d.has(h.description.identifier));return new S(u,l)}constructor(a,t){this.added=a,this.removed=t}}e.$kF=S;class w{constructor(a,t){this.name=a,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(a){if(this.a!==null)throw new Error("Handler already set!");this.a=a,this.d()}acceptUsers(a){this.c=S.compute(this.b,a),this.b=a,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(a){(0,F.$Z)(a)}}}e.$lF=w;const c={type:"string",enum:["ui","workspace"],enumDescriptions:[I.localize(0,null),I.localize(1,null)]},s="vscode://schemas/vscode-extensions";e.$mF={properties:{engines:{type:"object",description:I.localize(2,null),properties:{vscode:{type:"string",description:I.localize(3,null),default:"^1.22.0"}}},publisher:{description:I.localize(4,null),type:"string"},displayName:{description:I.localize(5,null),type:"string"},categories:{description:I.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:E.$9l},{type:"string",const:"Languages",deprecationMessage:I.localize(7,null)}]}},galleryBanner:{type:"object",description:I.localize(8,null),properties:{color:{description:I.localize(9,null),type:"string"},theme:{description:I.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:I.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:I.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:I.localize(13,null)},enabledApiProposals:{markdownDescription:I.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(m.allApiProposals),markdownEnumDescriptions:Object.values(m.allApiProposals)}},api:{markdownDescription:I.localize(15,null),type:"string",enum:["none"],enumDescriptions:[I.localize(16,null)]},activationEvents:{description:I.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:I.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:I.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:I.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:I.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:I.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:I.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:I.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:I.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:I.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:I.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:I.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:I.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:I.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:I.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:I.localize(32,null)},{label:"onUri",body:"onUri",description:I.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:I.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:I.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:I.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:I.localize(37,null)},{label:"onRenderer",description:I.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:I.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:I.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:I.localize(41,null)},{label:"*",description:I.localize(42,null),body:"*"}]}},badges:{type:"array",description:I.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:I.localize(44,null)},href:{type:"string",description:I.localize(45,null)},description:{type:"string",description:I.localize(46,null)}}}},markdown:{type:"string",description:I.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:I.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:I.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$2n}},extensionPack:{description:I.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$2n}},extensionKind:{description:I.localize(51,null),type:"array",items:c,default:["workspace"],defaultSnippets:[{body:["ui"],description:I.localize(52,null)},{body:["workspace"],description:I.localize(53,null)},{body:["ui","workspace"],description:I.localize(54,null)},{body:["workspace","ui"],description:I.localize(55,null)},{body:[],description:I.localize(56,null)}]},capabilities:{description:I.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:I.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:I.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[I.localize(60,null),I.localize(61,null),I.localize(62,null)]},description:{type:"string",markdownDescription:I.localize(63,null)}}},untrustedWorkspaces:{description:I.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:I.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[I.localize(66,null),I.localize(67,null),I.localize(68,null)]},restrictedConfigurations:{description:I.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:I.localize(70,null)}}}}},sponsor:{description:I.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:I.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:I.localize(73,null),type:"string"},"vscode:uninstall":{description:I.localize(74,null),type:"string"}}},icon:{type:"string",description:I.localize(75,null)},l10n:{type:"string",description:I.localize(76,null)},pricing:{type:"string",markdownDescription:I.localize(77,null),enum:["Free","Trial"],default:"Free"}}};class i{constructor(){this.a=new Map}registerExtensionPoint(a){if(this.a.has(a.extensionPoint))throw new Error("Duplicate extension point: "+a.extensionPoint);const t=new w(a.extensionPoint,a.defaultExtensionKind);return this.a.set(a.extensionPoint,t),a.activationEventsGenerator&&P.$aF.register(a.extensionPoint,a.activationEventsGenerator),e.$mF.properties.contributes.properties[a.extensionPoint]=a.jsonSchema,g.registerSchema(s,e.$mF),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$nF=i;const n={ExtensionsRegistry:"ExtensionsRegistry"};p.$kn.add(n.ExtensionsRegistry,new i),e.$oF=p.$kn.as(n.ExtensionsRegistry),g.registerSchema(s,e.$mF),g.registerSchema(A.$uj,{properties:{extensionEnabledApiProposals:{description:I.localize(78,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(m.allApiProposals),markdownEnumDescriptions:Object.values(m.allApiProposals)}}]}}}})}),define(ke[303],Se([1,0,231,18,24,302,45,4]),function($e,e,I,F,f,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6F=void 0;const E={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:I.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:I.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:I.localize(2,null),default:""}}};var m;(function(g){function y(S,w,c){if(!S)return;const s=F.$zf(S.type)?S.type:void 0;if(!s||s.length===0){c.error(I.localize(3,null));return}const i=[];if(Array.isArray(S.required))for(const n of S.required)F.$zf(n)&&i.push(n);return{extensionId:w.value,taskType:s,required:i,properties:S.properties?f.$$m(S.properties):{},when:S.when?R.$Ri.deserialize(S.when):void 0}}g.from=y})(m||(m={}));const A=L.$oF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(g,y)=>{for(const S of g)S.type&&y.push(`onTaskType:${S.type}`)},jsonSchema:{description:I.localize(4,null),type:"array",items:E}});class P{constructor(){this.d=new p.$Od,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((y,S)=>{A.setHandler((w,c)=>{this.c=void 0;try{for(const s of c.removed){const i=s.value;for(const n of i)this.a&&n.type&&this.a[n.type]&&delete this.a[n.type]}for(const s of c.added){const i=s.value;for(const n of i){const o=m.from(n,s.description.identifier,s.collector);o&&(this.a[o.taskType]=o)}}(c.removed.length>0||c.added.length>0)&&this.d.fire()}catch{}y(void 0)})})}onReady(){return this.b}get(y){return this.a[y]}all(){return Object.keys(this.a).map(y=>this.a[y])}getJsonSchema(){if(this.c===void 0){const y=[];for(const S of this.all()){const w={type:"object",additionalProperties:!1};S.required.length>0&&(w.required=S.required.slice(0)),S.properties!==void 0?w.properties=f.$$m(S.properties):w.properties=Object.create(null),w.properties.type={type:"string",enum:[S.taskType]},y.push(w)}this.c={oneOf:y}}return this.c}}e.$6F=new P}),define(ke[304],Se([1,0,232,18,23,24,45,303]),function($e,e,I,F,f,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$dG=e.JsonSchemaVersion=e.ExecutionEngine=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$0F=e.ShellQuoting=e.$9F=e.$8F=e.$7F=void 0,e.$7F="settings",e.$8F=new R.$$i("taskRunning",!1,I.localize(0,null)),e.$9F={value:I.localize(1,null),original:"Tasks"};var E;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(E||(e.ShellQuoting=E={})),e.$0F="$customized",function(j){function T(V){if(!V)return j.Strong;switch(V.toLowerCase()){case"escape":return j.Escape;case"strong":return j.Strong;case"weak":return j.Weak;default:return j.Strong}}j.from=T}(E||(e.ShellQuoting=E={}));var m;(function(j){j.defaults={cwd:"${workspaceFolder}"}})(m||(e.CommandOptions=m={}));var A;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(A||(e.RevealKind=A={})),function(j){function T(V){switch(V.toLowerCase()){case"always":return j.Always;case"silent":return j.Silent;case"never":return j.Never;default:return j.Always}}j.fromString=T}(A||(e.RevealKind=A={}));var P;(function(j){j[j.Never=1]="Never",j[j.OnProblem=2]="OnProblem",j[j.Always=3]="Always"})(P||(e.RevealProblemKind=P={})),function(j){function T(V){switch(V.toLowerCase()){case"always":return j.Always;case"never":return j.Never;case"onproblem":return j.OnProblem;default:return j.OnProblem}}j.fromString=T}(P||(e.RevealProblemKind=P={}));var g;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(g||(e.PanelKind=g={})),function(j){function T(V){switch(V.toLowerCase()){case"shared":return j.Shared;case"dedicated":return j.Dedicated;case"new":return j.New;default:return j.Shared}}j.fromString=T}(g||(e.PanelKind=g={}));var y;(function(j){j.defaults={echo:!0,reveal:A.Always,revealProblems:P.Never,focus:!1,panel:g.Shared,showReuseMessage:!0,clear:!1}})(y||(e.PresentationOptions=y={}));var S;(function(j){j[j.Shell=1]="Shell",j[j.Process=2]="Process",j[j.CustomExecution=3]="CustomExecution"})(S||(e.RuntimeType=S={})),function(j){function T(q){switch(q.toLowerCase()){case"shell":return j.Shell;case"process":return j.Process;case"customExecution":return j.CustomExecution;default:return j.Process}}j.fromString=T;function V(q){switch(q){case j.Shell:return"shell";case j.Process:return"process";case j.CustomExecution:return"customExecution";default:return"process"}}j.toString=V}(S||(e.RuntimeType=S={}));var w;(function(j){function T(V){return F.$zf(V)?V:V.value}j.value=T})(w||(e.CommandString=w={}));var c;(function(j){j.Clean={_id:"clean",isDefault:!1},j.Build={_id:"build",isDefault:!1},j.Rebuild={_id:"rebuild",isDefault:!1},j.Test={_id:"test",isDefault:!1};function T(q){return q===j.Clean._id||q===j.Build._id||q===j.Rebuild._id||q===j.Test._id}j.is=T;function V(q){if(q!==void 0)return F.$zf(q)?T(q)?{_id:q,isDefault:!1}:void 0:q}j.from=V})(c||(e.TaskGroup=c={}));var s;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.Folder=3]="Folder"})(s||(e.TaskScope=s={}));var i;(function(j){j.Workspace="workspace",j.Extension="extension",j.InMemory="inMemory",j.WorkspaceFile="workspaceFile",j.User="user";function T(V){switch(V){case j.User:return 2;case j.WorkspaceFile:return 5;default:return 6}}j.toConfigurationTarget=T})(i||(e.TaskSourceKind=i={}));var n;(function(j){j.parallel="parallel",j.sequence="sequence"})(n||(e.DependsOrder=n={}));var o;(function(j){j[j.default=1]="default",j[j.folderOpen=2]="folderOpen"})(o||(e.RunOnOptions=o={}));var a;(function(j){j.defaults={reevaluateOnRerun:!0,runOn:o.default,instanceLimit:1}})(a||(e.RunOptions=a={}));class t{constructor(T,V,q,fe,ee,Y){this._label="",this._id=T,V&&(this._label=V),q&&(this.type=q),this.runOptions=fe,this.configurationProperties=ee,this._source=Y}getDefinition(T){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const T={folder:this.d(),id:this._id};return JSON.stringify(T)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(T,V=!1){if(T===void 0)return!1;if(F.$zf(T))return T===this._label||T===this.configurationProperties.identifier||V&&T===this._id;const q=this.getDefinition(!0);return q!==void 0&&q._key===T._key}getQualifiedLabel(){const T=this.getWorkspaceFolder();return T?`${this._label} (${T.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(T){this.c===void 0&&(this.c=[]),T&&(this.c=this.c.concat(T))}get taskLoadMessages(){return this.c}}e.$$F=t;class r extends t{constructor(T,V,q,fe,ee,Y,X,ae){super(T,q,void 0,X,ae,V),this.command={},this._source=V,this.hasDefinedMatchers=Y,ee&&(this.command=ee)}clone(){return new r(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(T=!1){if(T&&this._source.customizes!==void 0)return this._source.customizes;{let V;switch(this.command?this.command.runtime:void 0){case S.Shell:V="shell";break;case S.Process:V="process";break;case S.CustomExecution:V="customExecution";break;case void 0:V="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:V,_key:this._id,id:this._id}}}static is(T){return T instanceof r}getMapKey(){const T=this._source.config.workspaceFolder;return T?`${T.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$7F:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const T=this.d();if(!T)return;let V=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(V+=this._source.kind);const q={type:e.$0F,folder:T,id:V};return JSON.stringify(q)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?f.$tg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(T){return new r(T._id,T._source,T._label,T.type,T.command,T.hasDefinedMatchers,T.runOptions,T.configurationProperties)}}e.$_F=r;class d extends t{constructor(T,V,q,fe,ee,Y,X){super(T,q,fe,Y,X,V),this._source=V,this.configures=ee}static is(T){return T instanceof d}f(T){return T}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?f.$tg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$7F:this._source.config.workspaceFolder?.uri.toString()}getKey(){const T=this.d();if(!T)return;let V=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(V+=this._source.kind);const q={type:e.$0F,folder:T,id:V};return JSON.stringify(q)}}e.$aG=d;class u extends t{constructor(T,V,q,fe,ee,Y,X,ae,Z){super(T,q,fe,ae,Z,V),this.defines=ee,this.hasDefinedMatchers=X,this.command=Y,this.icon=Z.icon,this.hide=Z.hide}clone(){return new u(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(T){return T instanceof u}getMapKey(){const T=this._source.workspaceFolder;return T?`${this._source.scope.toString()}|${T.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const T={type:"contributed",scope:this._source.scope,id:this._id};return T.folder=this.d(),JSON.stringify(T)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(T){return new u(T._id,T._source,T._label,T.type,T.defines,T.command,T.hasDefinedMatchers,T.runOptions,T.configurationProperties)}}e.$bG=u;class l extends t{constructor(T,V,q,fe,ee,Y){super(T,q,fe,ee,Y,V),this._source=V}clone(){return new l(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(T){return T instanceof l}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(T){return new l(T._id,T._source,T._label,T.type,T.runOptions,T.configurationProperties)}}e.$cG=l;var h;(function(j){j[j.Process=1]="Process",j[j.Terminal=2]="Terminal"})(h||(e.ExecutionEngine=h={})),function(j){j._default=j.Terminal}(h||(e.ExecutionEngine=h={}));var k;(function(j){j[j.V0_1_0=1]="V0_1_0",j[j.V2_0_0=2]="V2_0_0"})(k||(e.JsonSchemaVersion=k={}));class D{constructor(T){this.c=new Map;for(let V=0;V<T.length;V++)this.c.set(T[V].uri.toString(),V)}compare(T,V){const q=T.getWorkspaceFolder(),fe=V.getWorkspaceFolder();if(q&&fe){let ee=this.c.get(q.uri.toString());ee=ee===void 0?0:ee+1;let Y=this.c.get(fe.uri.toString());return Y=Y===void 0?0:Y+1,ee===Y?T._label.localeCompare(V._label):ee-Y}else return!q&&fe?-1:q&&!fe?1:0}}e.$dG=D;var $;(function(j){j.DependsOnStarted="dependsOnStarted",j.AcquiredInput="acquiredInput",j.Start="start",j.ProcessStarted="processStarted",j.Active="active",j.Inactive="inactive",j.Changed="changed",j.Terminated="terminated",j.ProcessEnded="processEnded",j.End="end"})($||(e.TaskEventKind=$={}));var b;(function(j){j.SingleRun="singleRun",j.Background="background"})(b||(e.TaskRunType=b={}));var v;(function(j){j[j.System=0]="System",j[j.User=1]="User",j[j.FolderOpen=2]="FolderOpen",j[j.ConfigurationChange=3]="ConfigurationChange",j[j.Reconnect=4]="Reconnect"})(v||(e.TaskRunSource=v={}));var C;(function(j){function T(ae){return{taskId:ae._id,taskName:ae.configurationProperties.name,runType:ae.configurationProperties.isBackground?"background":"singleRun",group:ae.configurationProperties.group,__task:ae}}function V(ae,Z,se){return{...T(ae),kind:"start",terminalId:Z,resolvedVariables:se}}j.start=V;function q(ae,Z,se){return{...T(ae),kind:"processStarted",terminalId:Z,processId:se}}j.processStarted=q;function fe(ae,Z,se){return{...T(ae),kind:"processEnded",terminalId:Z,exitCode:se}}j.processEnded=fe;function ee(ae,Z,se){return{...T(ae),kind:"terminated",exitReason:se,terminalId:Z}}j.terminated=ee;function Y(ae,Z,se){return{...T(Z),kind:ae,terminalId:se}}j.general=Y;function X(){return{kind:"changed"}}j.changed=X})(C||(e.TaskEvent=C={}));var N;(function(j){function T(q){const fe=Object.keys(q).sort();let ee="";for(const Y of fe){let X=q[Y];X instanceof Object?X=T(X):typeof X=="string"&&(X=X.replace(/,/g,",,")),ee+=Y+","+X+","}return ee}function V(q){const ee={_key:T(q),type:q.taskType};return Object.assign(ee,q),ee}j.create=V})(N||(e.KeyedTaskIdentifier=N={}));var z;(function(j){j.AutoDetect="task.autoDetect",j.SaveBeforeRun="task.saveBeforeRun",j.ShowDecorations="task.showDecorations",j.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",j.SlowProviderWarning="task.slowProviderWarning",j.QuickOpenHistory="task.quickOpen.history",j.QuickOpenDetail="task.quickOpen.detail",j.QuickOpenSkip="task.quickOpen.skip",j.QuickOpenShowAll="task.quickOpen.showAll",j.AllowAutomaticTasks="task.allowAutomaticTasks",j.Reconnection="task.reconnection",j.VerboseLogging="task.verboseLogging"})(z||(e.TaskSettingId=z={}));var M;(function(j){j.Tasks="tasks",j.SuppressTaskName="tasks.suppressTaskName",j.Windows="tasks.windows",j.Osx="tasks.osx",j.Linux="tasks.linux",j.ShowOutput="tasks.showOutput",j.IsShellCommand="tasks.isShellCommand",j.ServiceTestSetting="tasks.service.testSetting"})(M||(e.TasksSchemaProperties=M={}));var O;(function(j){function T(V,q){const fe=p.$6F.get(V.type);if(fe===void 0){const ae=L.$$m(V);return delete ae._key,N.create(ae)}const ee=Object.create(null);ee.type=fe.taskType;const Y=new Set;fe.required.forEach(ae=>Y.add(ae));const X=fe.properties;for(const ae of Object.keys(X)){const Z=V[ae];if(Z!=null)ee[ae]=Z;else if(Y.has(ae)){const se=X[ae];if(se.default!==void 0)ee[ae]=L.$$m(se.default);else switch(se.type){case"boolean":ee[ae]=!1;break;case"number":case"integer":ee[ae]=0;break;case"string":ee[ae]="";break;default:q.error(I.localize(2,null,JSON.stringify(V,void 0,0),ae));return}}}return N.create(ee)}j.createTaskIdentifier=T})(O||(e.TaskDefinition=O={}))}),define(ke[305],Se([1,0,11]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j5b=e.$i5b=void 0;class F{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,p)=>{this.b=R,this.d=p,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,I.$Z)(R))}then(R,p){return this.j().then(R,p)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$i5b=F;class f extends F{constructor(){super(),this.h=!0,this.i=new I.$4}}e.$j5b=f}),define(ke[69],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uv=e.$tv=e.$sv=e.$rv=void 0;class I{static{this.count=0}constructor(E){this._proxyIdentifierBrand=void 0,this.sid=E,this.nid=++I.count}}e.$rv=I;const F=[];function f(p){const E=new I(p);return F[E.nid]=E,E}e.$sv=f;function L(p){return F[p].sid}e.$tv=L;class R{constructor(E){this.value=E}}e.$uv=R}),define(ke[6],Se([1,0,69]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wK=e.$vK=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$uK=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var F;(function(w){w[w.Default=0]="Default",w[w.InCenter=1]="InCenter",w[w.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",w[w.AtTop=3]="AtTop"})(F||(e.TextEditorRevealType=F={}));var f;(function(w){w[w.UnknownInput=0]="UnknownInput",w[w.TextInput=1]="TextInput",w[w.TextDiffInput=2]="TextDiffInput",w[w.TextMergeInput=3]="TextMergeInput",w[w.NotebookInput=4]="NotebookInput",w[w.NotebookDiffInput=5]="NotebookDiffInput",w[w.CustomEditorInput=6]="CustomEditorInput",w[w.WebviewEditorInput=7]="WebviewEditorInput",w[w.TerminalEditorInput=8]="TerminalEditorInput",w[w.InteractiveEditorInput=9]="InteractiveEditorInput",w[w.ChatEditorInput=10]="ChatEditorInput"})(f||(e.TabInputKind=f={}));var L;(function(w){w[w.TAB_OPEN=0]="TAB_OPEN",w[w.TAB_CLOSE=1]="TAB_CLOSE",w[w.TAB_UPDATE=2]="TAB_UPDATE",w[w.TAB_MOVE=3]="TAB_MOVE"})(L||(e.TabModelOperationKind=L={}));var R;(function(w){w[w.Editable=0]="Editable",w[w.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var p;(function(w){w[w.Int8Array=1]="Int8Array",w[w.Uint8Array=2]="Uint8Array",w[w.Uint8ClampedArray=3]="Uint8ClampedArray",w[w.Int16Array=4]="Int16Array",w[w.Uint16Array=5]="Uint16Array",w[w.Int32Array=6]="Int32Array",w[w.Uint32Array=7]="Uint32Array",w[w.Float32Array=8]="Float32Array",w[w.Float64Array=9]="Float64Array",w[w.BigInt64Array=10]="BigInt64Array",w[w.BigUint64Array=11]="BigUint64Array"})(p||(e.WebviewMessageArrayBufferViewType=p={}));var E;(function(w){w[w.Text=1]="Text",w[w.Error=2]="Error",w[w.Rich=3]="Rich"})(E||(e.CellOutputKind=E={}));var m;(function(w){w[w.Default=0]="Default",w[w.InCenter=1]="InCenter",w[w.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",w[w.AtTop=3]="AtTop"})(m||(e.NotebookEditorRevealType=m={}));var A;(function(w){w[w.None=0]="None",w[w.Process=1]="Process",w[w.Output=2]="Output"})(A||(e.CandidatePortSource=A={}));class P{static{this.a=0}static mixin(c){return c._id=P.a++,c}}e.$uK=P;var g;(function(w){w.label="a",w.kind="b",w.detail="c",w.documentation="d",w.sortText="e",w.filterText="f",w.preselect="g",w.insertText="h",w.insertTextRules="i",w.range="j",w.commitCharacters="k",w.additionalTextEdits="l",w.kindModifier="m",w.commandIdent="n",w.commandId="o",w.commandArguments="p"})(g||(e.ISuggestDataDtoField=g={}));var y;(function(w){w.defaultRanges="a",w.completions="b",w.isIncomplete="c",w.duration="d"})(y||(e.ISuggestResultDtoField=y={}));var S;(function(w){w[w.Workspace=0]="Workspace",w[w.TextDocument=1]="TextDocument"})(S||(e.ExtHostTestingResource=S={})),e.$vK={MainThreadAuthentication:(0,I.$sv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.$sv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,I.$sv)("MainThreadChatProvider"),MainThreadChatAgents:(0,I.$sv)("MainThreadChatAgents"),MainThreadChatAgents2:(0,I.$sv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,I.$sv)("MainThreadChatVariables"),MainThreadClipboard:(0,I.$sv)("MainThreadClipboard"),MainThreadCommands:(0,I.$sv)("MainThreadCommands"),MainThreadComments:(0,I.$sv)("MainThreadComments"),MainThreadConfiguration:(0,I.$sv)("MainThreadConfiguration"),MainThreadConsole:(0,I.$sv)("MainThreadConsole"),MainThreadDebugService:(0,I.$sv)("MainThreadDebugService"),MainThreadDecorations:(0,I.$sv)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.$sv)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.$sv)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.$sv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.$sv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.$sv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.$sv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.$sv)("MainThreadEditorTabs"),MainThreadErrors:(0,I.$sv)("MainThreadErrors"),MainThreadTreeViews:(0,I.$sv)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.$sv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,I.$sv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.$sv)("MainThreadLanguages"),MainThreadLogger:(0,I.$sv)("MainThreadLogger"),MainThreadMessageService:(0,I.$sv)("MainThreadMessageService"),MainThreadOutputService:(0,I.$sv)("MainThreadOutputService"),MainThreadProgress:(0,I.$sv)("MainThreadProgress"),MainThreadQuickDiff:(0,I.$sv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,I.$sv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.$sv)("MainThreadStatusBar"),MainThreadSecretState:(0,I.$sv)("MainThreadSecretState"),MainThreadStorage:(0,I.$sv)("MainThreadStorage"),MainThreadSpeech:(0,I.$sv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,I.$sv)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.$sv)("MainThreadTerminalService"),MainThreadWebviews:(0,I.$sv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.$sv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.$sv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.$sv)("MainThreadCustomEditors"),MainThreadUrls:(0,I.$sv)("MainThreadUrls"),MainThreadUriOpeners:(0,I.$sv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,I.$sv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,I.$sv)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.$sv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,I.$sv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,I.$sv)("MainThreadExtensionService"),MainThreadSCM:(0,I.$sv)("MainThreadSCM"),MainThreadSearch:(0,I.$sv)("MainThreadSearch"),MainThreadShare:(0,I.$sv)("MainThreadShare"),MainThreadTask:(0,I.$sv)("MainThreadTask"),MainThreadWindow:(0,I.$sv)("MainThreadWindow"),MainThreadLabelService:(0,I.$sv)("MainThreadLabelService"),MainThreadNotebook:(0,I.$sv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.$sv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.$sv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.$sv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,I.$sv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,I.$sv)("MainThreadInteractive"),MainThreadChat:(0,I.$sv)("MainThreadChat"),MainThreadInlineChat:(0,I.$sv)("MainThreadInlineChatShape"),MainThreadTheming:(0,I.$sv)("MainThreadTheming"),MainThreadTunnelService:(0,I.$sv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,I.$sv)("MainThreadManagedSockets"),MainThreadTimeline:(0,I.$sv)("MainThreadTimeline"),MainThreadTesting:(0,I.$sv)("MainThreadTesting"),MainThreadLocalization:(0,I.$sv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,I.$sv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,I.$sv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,I.$sv)("MainThreadIssueReporter")},e.$wK={ExtHostCommands:(0,I.$sv)("ExtHostCommands"),ExtHostConfiguration:(0,I.$sv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.$sv)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.$sv)("ExtHostDebugService"),ExtHostDecorations:(0,I.$sv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.$sv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.$sv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.$sv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.$sv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.$sv)("ExtHostEditors"),ExtHostTreeViews:(0,I.$sv)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.$sv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.$sv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.$sv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,I.$sv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,I.$sv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.$sv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,I.$sv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,I.$sv)("ExtHostStatusBar"),ExtHostShare:(0,I.$sv)("ExtHostShare"),ExtHostExtensionService:(0,I.$sv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,I.$sv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,I.$sv)("ExtHostTerminalService"),ExtHostSCM:(0,I.$sv)("ExtHostSCM"),ExtHostSearch:(0,I.$sv)("ExtHostSearch"),ExtHostTask:(0,I.$sv)("ExtHostTask"),ExtHostWorkspace:(0,I.$sv)("ExtHostWorkspace"),ExtHostWindow:(0,I.$sv)("ExtHostWindow"),ExtHostWebviews:(0,I.$sv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.$sv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.$sv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.$sv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.$sv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.$sv)("ExtHostEditorTabs"),ExtHostProgress:(0,I.$sv)("ExtHostProgress"),ExtHostComments:(0,I.$sv)("ExtHostComments"),ExtHostSecretState:(0,I.$sv)("ExtHostSecretState"),ExtHostStorage:(0,I.$sv)("ExtHostStorage"),ExtHostUrls:(0,I.$sv)("ExtHostUrls"),ExtHostUriOpeners:(0,I.$sv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,I.$sv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,I.$sv)("ExtHostOutputService"),ExtHosLabelService:(0,I.$sv)("ExtHostLabelService"),ExtHostNotebook:(0,I.$sv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,I.$sv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,I.$sv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,I.$sv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,I.$sv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,I.$sv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,I.$sv)("ExtHostInteractive"),ExtHostInlineChat:(0,I.$sv)("ExtHostInlineChatShape"),ExtHostChat:(0,I.$sv)("ExtHostChat"),ExtHostChatAgents:(0,I.$sv)("ExtHostChatAgents"),ExtHostChatAgents2:(0,I.$sv)("ExtHostChatAgents"),ExtHostChatVariables:(0,I.$sv)("ExtHostChatVariables"),ExtHostChatProvider:(0,I.$sv)("ExtHostChatProvider"),ExtHostSpeech:(0,I.$sv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,I.$sv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,I.$sv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,I.$sv)("ExtHostTheming"),ExtHostTunnelService:(0,I.$sv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,I.$sv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,I.$sv)("ExtHostAuthentication"),ExtHostTimeline:(0,I.$sv)("ExtHostTimeline"),ExtHostTesting:(0,I.$sv)("ExtHostTesting"),ExtHostTelemetry:(0,I.$sv)("ExtHostTelemetry"),ExtHostLocalization:(0,I.$sv)("ExtHostLocalization"),ExtHostIssueReporter:(0,I.$sv)("ExtHostIssueReporter")}}),define(ke[306],Se([1,0,6,7]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4ec=void 0;class f{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(I.$vK.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,p,E){if(this.a.size===0)throw new Error("No related information providers registered");const m=this.a.get(R);if(!m)throw new Error("related information provider not found");return await m.provideRelatedInformation(p,E)??[]}getRelatedInformation(R,p,E){return this.c.$getAiRelatedInformation(p,E)}registerRelatedInformationProvider(R,p,E){const m=this.b;return this.b++,this.a.set(m,E),this.c.$registerAiRelatedInformationProvider(m,p),new F.$xK(()=>{this.c.$unregisterAiRelatedInformationProvider(m),this.a.delete(m)})}}e.$4ec=f}),define(ke[91],Se([1,0,5,15,6,20]),function($e,e,I,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8cc=e.$7cc=e.$6cc=void 0,e.$6cc=(0,I.$Th)("IExtHostApiDeprecationService");let R=class{constructor(E,m){this.c=m,this.a=new Set,this.b=E.getProxy(f.$vK.MainThreadTelemetry)}report(E,m,A){const P=this.d(E,m);this.a.has(P)||(this.a.add(P),m.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${E}' is deprecated. ${A}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:m.identifier.value,apiId:E}))}d(E,m){return`${E}-${m.identifier.value}`}};e.$7cc=R,e.$7cc=R=He([Be(0,L.$xM),Be(1,F.$bj)],R),e.$8cc=Object.freeze(new class{report(p,E,m){}})}),define(ke[307],Se([1,0,4,6,7,26]),function($e,e,I,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bec=void 0;class R{constructor(m){this.b=new Map,this.c=[],this.d=new I.$Od,this.onDidChangeSessions=this.d.event,this.f=new p,this.g=new p,this.a=m.getProxy(F.$vK.MainThreadAuthentication)}$setProviders(m){return this.c=m,Promise.resolve()}async getSession(m,A,P,g={}){const y=L.$0l.toKey(m.identifier),S=[...P].sort().join(" ");return await this.f.getOrCreate(`${y} ${A} ${S}`,async()=>{await this.a.$ensureProvider(A);const w=m.displayName||m.name;return this.a.$getSession(A,P,y,w,g)})}async getSessions(m,A,P){const g=L.$0l.toKey(m.identifier),y=[...P].sort().join(" ");return await this.g.getOrCreate(`${g} ${y}`,async()=>{await this.a.$ensureProvider(A);const S=m.displayName||m.name;return this.a.$getSessions(A,P,g,S)})}async removeSession(m,A){const P=this.b.get(m);return P?P.provider.removeSession(A):this.a.$removeSession(m,A)}registerAuthenticationProvider(m,A,P,g){if(this.b.get(m))throw new Error(`An authentication provider with id '${m}' is already registered.`);this.b.set(m,{label:A,provider:P,options:g??{supportsMultipleAccounts:!1}}),this.c.find(S=>S.id===m)||this.c.push({id:m,label:A});const y=P.onDidChangeSessions(S=>{this.a.$sendDidChangeSessions(m,{added:S.added??[],changed:S.changed??[],removed:S.removed??[]})});return this.a.$registerAuthenticationProvider(m,A,g?.supportsMultipleAccounts??!1),new f.$xK(()=>{y.dispose(),this.b.delete(m);const S=this.c.findIndex(w=>w.id===m);S>-1&&this.c.splice(S),this.a.$unregisterAuthenticationProvider(m)})}$createSession(m,A,P){const g=this.b.get(m);if(g)return Promise.resolve(g.provider.createSession(A,P));throw new Error(`Unable to find authentication provider with handle: ${m}`)}$removeSession(m,A){const P=this.b.get(m);if(P)return Promise.resolve(P.provider.removeSession(A));throw new Error(`Unable to find authentication provider with handle: ${m}`)}$getSessions(m,A){const P=this.b.get(m);if(P)return Promise.resolve(P.provider.getSessions(A));throw new Error(`Unable to find authentication provider with handle: ${m}`)}$onDidChangeAuthenticationSessions(m,A){return this.d.fire({provider:{id:m,label:A}}),Promise.resolve()}}e.$Bec=R;class p{constructor(){this.a=new Map}getOrCreate(m,A){const P=this.a.get(m);if(P)return P;const g=A().finally(()=>this.a.delete(m));return this.a.set(m,g),g}}}),define(ke[308],Se([1,0,6,20,14]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hec=void 0;let L=class{constructor(p,E){this.a=p.getProxy(I.$vK.MainThreadBulkEdits),this.b={getTextDocumentVersion:m=>E.getDocument(m)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(p,E,m){const A=f.WorkspaceEdit.from(p,this.b);return this.a.$tryApplyWorkspaceEdit(A,void 0,m?.isRefactoring??!1)}};e.$Hec=L,e.$Hec=L=He([Be(0,F.$xM)],L)}),define(ke[309],Se([1,0,10,4,51,3,37,210,6,14]),function($e,e,I,F,f,L,R,p,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vec=void 0;class A{static{this.a=0}constructor(y,S){this.extension=y,this.provider=S,this.handle=A.a++}}class P{static{this.a=0}constructor(y,S){this.h=S,this.b=new Map,this.d=new Map,this.e=new F.$Od,this.onDidPerformUserAction=this.e.event,this.g=y.getProxy(E.$vK.MainThreadChat)}registerChatProvider(y,S,w){const c=new A(y,w);return this.b.set(c.handle,c),this.g.$registerChatProvider(c.handle,S),(0,L.$Pc)(()=>{this.g.$unregisterChatProvider(c.handle),this.b.delete(c.handle)})}transferChatSession(y,S){const w=f.Iterable.find(this.d.keys(),c=>this.d.get(c)===y)??0;typeof w=="number"&&this.g.$transferChatSession(w,S)}sendInteractiveRequestToProvider(y,S){this.g.$sendRequestToProvider(y,S)}async $prepareChat(y,S,w){const c=this.b.get(y);if(!c)return;const s=await c.provider.prepareSession(S,w);if(!s)return;const i=P.a++;return this.d.set(i,s),{id:i,requesterUsername:s.requester?.name,requesterAvatarIconUri:s.requester?.icon,responderUsername:s.responder?.name,responderAvatarIconUri:s.responder?.icon,inputPlaceholder:s.inputPlaceholder}}async $provideWelcomeMessage(y,S){const w=this.b.get(y);if(!w||!w.provider.provideWelcomeMessage)return;const c=await w.provider.provideWelcomeMessage(S);if(c)return c.map(s=>typeof s=="string"?s:Array.isArray(s)?s.map(i=>m.ChatReplyFollowup.from(i)):m.MarkdownString.from(s))}async $provideFollowups(y,S,w){const c=this.b.get(y);if(!c)return;const s=this.d.get(S);return!s||!c.provider.provideFollowups?void 0:(await c.provider.provideFollowups(s,w))?.map(n=>m.ChatFollowup.from(n))}async $provideSampleQuestions(y,S){const w=this.b.get(y);if(!w||!w.provider.provideSampleQuestions)return;const c=await w.provider.provideSampleQuestions(S);if(c)return c?.map(s=>m.ChatReplyFollowup.from(s))}$removeRequest(y,S,w){const c=this.b.get(y);if(!c)return;const s=this.d.get(S);s&&c.provider.removeRequest&&c.provider.removeRequest(s,w)}async $provideReply(y,S,w,c){const s=this.b.get(y);if(!s)return;const i=this.d.get(S);if(!i)return;const n={session:i,message:w.message,variables:{}};if(w.variables)for(const u of Object.keys(w.variables))n.variables[u]=w.variables[u].map(m.ChatVariable.to);const o=R.$Kd.create(!1);let a;const t={report:u=>{if(c.isCancellationRequested)return;typeof a>"u"&&(a=o.elapsed());const l=m.ChatResponseProgress.from(s.extension,u);if("placeholder"in u&&"resolvedContent"in u){const h=Promise.all([this.g.$acceptResponseProgress(y,S,l),u.resolvedContent]);(0,I.$Jg)(h,c).then(k=>{if(!k)return;const[D,$]=k;this.g.$acceptResponseProgress(y,S,$,D??void 0)})}else this.g.$acceptResponseProgress(y,S,l)}};let r;try{r=await s.provider.provideResponseWithProgress(n,t,c),r||(r={errorDetails:{message:(0,p.localize)(0,null)}})}catch(u){r={errorDetails:{message:(0,p.localize)(1,null,u.message),responseIsIncomplete:!0}},this.h.error(u)}try{if(i.saveState&&this.d.has(S)){const u=i.saveState();this.g.$acceptChatState(S,u)}}catch(u){this.h.warn(u)}const d={firstProgress:a??0,totalElapsed:o.elapsed()};return{errorDetails:r.errorDetails,timings:d}}async $provideSlashCommands(y,S,w){const c=this.b.get(y);if(!c)return;const s=this.d.get(S);return!s||!c.provider.provideSlashCommands?void 0:(await c.provider.provideSlashCommands(s,w))?.map(n=>({...n,kind:m.CompletionItemKind.from(n.kind)}))}$releaseSession(y){this.d.delete(y)}async $onDidPerformUserAction(y){this.e.fire(y)}}e.$Vec=P}),define(ke[310],Se([1,0,10,3,64,6,14,7]),function($e,e,I,F,f,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6ec=void 0;class E{static{this.a=0}constructor(P,g,y){this.d=g,this.e=y,this.b=new Map,this.c=P.getProxy(L.$vK.MainThreadChatAgents)}registerAgent(P,g,y,S){const w=E.a++;return this.b.set(w,{extension:P,agent:y}),this.c.$registerAgent(w,g,S),(0,F.$Pc)(()=>{this.c.$unregisterAgent(w),this.b.delete(w)})}async $invokeAgent(P,g,y,S,w){const c=this.b.get(P);if(!c){this.e.warn(`[CHAT](${P}) CANNOT invoke agent because the agent is not registered`);return}let s=!1;function i(){if(s)throw new Error("Only valid while executing the command")}const n=new I.$gh;w.onCancellationRequested(()=>n.complete()),setTimeout(()=>n.complete(),10*1e3),this.d.allowListExtensionWhile(c.extension,n.p);const o=c.agent({role:p.ChatMessageRole.User,content:y},{history:S.history.map(R.ChatMessage.to)},new f.$9u(a=>{i(),this.c.$handleProgressChunk(g,{content:m(a.message)?a.message:a.message.value})}),w);try{return await(0,I.$Jg)(Promise.resolve(o).then(a=>{if(a&&"followUp"in a)return{followUp:a?.followUp?.map(r=>R.ChatFollowup.from(r))}}),w)}finally{s=!0,n.complete()}}}e.$6ec=E;function m(A){return!!A&&typeof A=="object"&&"treeData"in A}}),define(ke[311],Se([1,0,10,21,43,4,37,18,2,211,64,6,14,7,281,25]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7ec=void 0;class c{static{this.a=0}constructor(n,o,a){this.i=o,this.j=a,this.b=new Map,this.g=new Map,this.h=new Map,this.d=n.getProxy(P.$vK.MainThreadChatAgents2)}createChatAgent(n,o,a){const t=c.a++,r=new s(n,o,this.d,t,a);return this.b.set(t,r),this.d.$registerAgent(t,o,{}),r.apiAgent}async $invokeAgent(n,o,a,t,r,d){this.g.delete(o);const u=this.b.get(n);if(!u)throw new Error(`[CHAT](${n}) CANNOT invoke agent because the agent is not registered`);let l=!1;function h(){if(l)throw new Error("Only valid while executing the command")}const k=new I.$gh;d.onCancellationRequested(()=>k.complete()),setTimeout(()=>k.complete(),10*1e3),this.i.allowListExtensionWhile(u.extension.identifier,k.p);const D=t.command?await u.validateSlashCommand(t.command):void 0,$=R.$Kd.create(!1);let b;try{const v=u.invoke({prompt:t.message,variables:g.ChatVariable.objectTo(t.variables),slashCommand:D},{history:r.history.map(g.ChatMessage.to)},new A.$9u(C=>{h(),typeof b>"u"&&"content"in C&&(b=$.elapsed());const N=g.ChatResponseProgress.from(u.extension,C);if("placeholder"in C&&"resolvedContent"in C){const z=Promise.all([this.d.$handleProgressChunk(a,N),C.resolvedContent]);(0,I.$Jg)(z,d).then(M=>{if(!M)return;const[O,j]=M;this.d.$handleProgressChunk(a,j,O??void 0)})}else this.d.$handleProgressChunk(a,N)}),d);return await(0,I.$Jg)(Promise.resolve(v).then(C=>{if(C){this.g.set(o,C);let N=this.h.get(o);N||(N=new Map,this.h.set(o,N)),N.set(a,C);const z={firstProgress:b,totalElapsed:$.elapsed()};return{errorDetails:C.errorDetails,timings:z}}else this.g.delete(o)}),d)}catch(v){return this.j.error(v,u.extension),{errorDetails:{message:(0,m.localize)(0,null,(0,f.$Ei)(v)),responseIsIncomplete:!0}}}finally{l=!0,k.complete()}}$releaseSession(n){this.g.delete(n),this.h.delete(n)}async $provideSlashCommands(n,o){const a=this.b.get(n);return a?a.provideSlashCommand(o):[]}$provideFollowups(n,o,a){const t=this.b.get(n);if(!t)return Promise.resolve([]);const r=this.g.get(o);return r?t.provideFollowups(r,a):Promise.resolve([])}$acceptFeedback(n,o,a,t){const r=this.b.get(n);if(!r)return;const d=this.h.get(o)?.get(a);if(!d)return;let u;switch(t){case S.InteractiveSessionVoteDirection.Down:u=y.ChatAgentResultFeedbackKind.Unhelpful;break;case S.InteractiveSessionVoteDirection.Up:u=y.ChatAgentResultFeedbackKind.Helpful;break}r.acceptFeedback(Object.freeze({result:d,kind:u}))}$acceptAction(n,o,a,t){const r=this.b.get(n);if(!r)return;const d=this.h.get(o)?.get(a);d&&t.action.kind!=="vote"&&r.acceptAction(Object.freeze({action:t.action,result:d}))}}e.$7ec=c;class s{constructor(n,o,a,t,r){this.extension=n,this.n=o,this.o=a,this.q=t,this.r=r,this.l=new L.$Od,this.m=new L.$Od}acceptFeedback(n){this.l.fire(n)}acceptAction(n){this.m.fire(n)}async validateSlashCommand(n){this.b||(await this.provideSlashCommand(F.CancellationToken.None),(0,p.$Jf)(this.b));const o=this.b.find(a=>a.name===n);if(!o)throw new Error(`Unknown slashCommand: ${n}`);return o}async provideSlashCommand(n){if(!this.a)return[];const o=await this.a.provideSlashCommands(n);return o?(this.b=o,o.map(a=>({name:a.name,description:a.description,followupPlaceholder:a.followupPlaceholder,shouldRepopulate:a.shouldRepopulate}))):[]}async provideFollowups(n,o){if(!this.d)return[];const a=await this.d.provideFollowups(n,o);return a?a.map(t=>g.ChatFollowup.from(t)):[]}get apiAgent(){let n=!1,o=!1;const a=()=>{n||o||(o=!0,queueMicrotask(()=>{this.o.$updateAgent(this.q,{description:this.g??"",fullName:this.h,icon:this.i?this.i instanceof E.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof y.$rL?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowup:this.d!==void 0,isDefault:this.j,isSecondary:this.k}),o=!1}))},t=this;return{get name(){return t.n},get description(){return t.g??""},set description(r){t.g=r,a()},get fullName(){return t.h??t.extension.displayName??t.extension.name},set fullName(r){t.h=r,a()},get iconPath(){return t.i},set iconPath(r){t.i=r,a()},get slashCommandProvider(){return t.a},set slashCommandProvider(r){t.a=r,a()},get followupProvider(){return t.d},set followupProvider(r){t.d=r,a()},get isDefault(){return(0,w.$vF)(t.extension,"defaultChatAgent"),t.j},set isDefault(r){(0,w.$vF)(t.extension,"defaultChatAgent"),t.j=r,a()},get isSecondary(){return(0,w.$vF)(t.extension,"defaultChatAgent"),t.k},set isSecondary(r){(0,w.$vF)(t.extension,"defaultChatAgent"),t.k=r,a()},get onDidReceiveFeedback(){return t.l.event},onDidPerformAction:(0,w.$uF)(this.extension,"chatAgents2Additions")?this.m.event:void 0,dispose(){n=!0,t.a=void 0,t.d=void 0,t.l.dispose(),t.o.$unregisterAgent(t.q)}}}invoke(n,o,a,t){return this.r(n,o,a,t)}}}),define(ke[312],Se([1,0,21,3,6,14,64,26,10,4]),function($e,e,I,F,f,L,R,p,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1ec=void 0;class A{constructor(S,w){this.stream=new E.$kh,this.stream=w??new E.$kh;const c=this;this.apiObj={option:S,response:c.stream.asyncIterable}}}class P{constructor(S,w){this.a=new m.$Od,this.b=new Map,this.c=new E.$kh,this.d=!1;const c=this;this.apiObject={result:S,response:c.c.asyncIterable,onDidStartResponseStream:c.a.event,cancel(){w.cancel()}},S.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,s]of this.b)s.stream.resolve();else this.c.resolve()})}handleFragment(S){if(this.d)return;let w=this.b.get(S.index);w||(this.b.size===0?w=new A(S.index,this.c):w=new A(S.index),this.b.set(S.index,w),this.a.fire(w.apiObj)),w.stream.emitOne(S.part)}}class g{static{this.a=1}constructor(S,w){this.d=w,this.c=new Map,this.e=new Map,this.f=new p.$_l,this.b=S.getProxy(f.$vK.MainThreadChatProvider)}registerProvider(S,w,c,s){const i=g.a++;return this.c.set(i,{extension:S,provider:c}),this.b.$registerProvider(i,w,{extension:S,displayName:s.name??S.value}),(0,F.$Pc)(()=>{this.b.$unregisterProvider(i),this.c.delete(i)})}async $provideChatResponse(S,w,c,s,i){const n=this.c.get(S);if(!n)return;const o=new R.$9u(async a=>{if(i.isCancellationRequested){this.d.warn(`[CHAT](${n.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(w,{index:a.index,part:a.part})});return n.provider.provideChatResponse(c.map(L.ChatMessage.to),s,o,i)}allowListExtensionWhile(S,w){this.f.set(S,w),w.finally(()=>this.f.delete(S))}async requestChatResponseProvider(S,w){if(!this.f.has(S))throw new Error("Extension is NOT allowed to make chat requests");const c=this;return{get isRevoked(){return!c.f.has(S)},makeRequest(s,i,n){if(!c.f.has(S))throw new Error("Access to chat has been revoked");const o=new I.$Yd(n),a=Math.random()*1e6|0,t=c.b.$fetchResponse(S,w,a,s.map(L.ChatMessage.from),i??{},o.token),r=new P(t,o);return c.e.set(a,{res:r}),t.finally(()=>{c.e.delete(a)}),r.apiObject}}}async $handleResponseFragment(S,w){const c=this.e.get(S);c&&c.res.handleFragment(w)}}e.$1ec=g}),define(ke[313],Se([1,0,3,6,11,14]),function($e,e,I,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3ec=void 0;class R{static{this.a=0}constructor(E){this.b=new Map,this.c=E.getProxy(F.$vK.MainThreadChatVariables)}async $resolveVariable(E,m,A){const P=this.b.get(E);if(P)try{const g=await P.resolver.resolve(P.data.name,{message:m},A);if(g)return g.map(L.ChatVariable.from)}catch(g){(0,f.$1)(g)}}registerVariableResolver(E,m,A,P){const g=R.a++;return this.b.set(g,{extension:E.identifier,data:{name:m,description:A},resolver:P}),this.c.$registerVariable(g,{name:m,description:A}),(0,I.$Pc)(()=>{this.b.delete(g),this.c.$unregisterVariable(g)})}}e.$3ec=R}),define(ke[314],Se([1,0,6]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$cc=void 0;class F{constructor(L){const R=L.getProxy(I.$vK.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(p){return R.$writeText(p)}})}}e.$$cc=F}),define(ke[35],Se([1,0,18,7,14,24,6,19,15,54,29,53,2,3,5,20,149,22,69,43,37,87,90]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,S,w,c,s,i,n,o,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XM=e.$WM=e.$VM=e.$UM=e.$TM=e.$SM=void 0;let r=class{#e;#t;#i;constructor(D,$,b){this.b=new Map,this.c=new Map,this.#e=D.getProxy(R.$vK.MainThreadCommands),this.d=$,this.#i=b,this.#t=D.getProxy(R.$vK.MainThreadTelemetry),this.converter=new d(this,v=>{const C=this.c.get(v);return C?.result===l.Void?C:void 0},$),this.f=[{processArgument(v){return(0,m.$qh)(v)}},{processArgument(v){return(0,L.$an)(v,function(C){if(A.$xs.isIRange(C))return f.Range.to(C);if(P.$ws.isIPosition(C))return f.Position.to(C);if(A.$xs.isIRange(C.range)&&g.URI.isUri(C.uri))return f.location.to(C);if(C instanceof s.$ce)return C.buffer.buffer;if(!Array.isArray(C))return C})}}]}registerArgumentProcessor(D){this.f.push(D)}registerApiCommand(D){const $=this.registerCommand(!1,D.id,async(...b)=>{const v=D.args.map((N,z)=>{if(!N.validate(b[z]))throw new Error(`Invalid argument '${N.name}' when running '${D.id}', received: ${typeof b[z]=="object"?JSON.stringify(b[z],null,"	"):b[z]} `);return N.convert(b[z])}),C=await this.executeCommand(D.internalId,...v);return D.result.convert(C,b,this.converter)},void 0,{description:D.description,args:D.args,returns:D.result.description});return this.c.set(D.id,D),new F.$xK(()=>{$.dispose(),this.c.delete(D.id)})}registerCommand(D,$,b,v,C,N){if(this.d.trace("ExtHostCommands#registerCommand",$),!$.trim().length)throw new Error("invalid id");if(this.b.has($))throw new Error(`command '${$}' already exists`);return this.b.set($,{callback:b,thisArg:v,metadata:C,extension:N}),D&&this.#e.$registerCommand($),new F.$xK(()=>{this.b.delete($)&&D&&this.#e.$unregisterCommand($)})}executeCommand(D,...$){return this.d.trace("ExtHostCommands#executeCommand",D),this.g(D,$,!0)}async g(D,$,b){if(this.b.has(D))return this.#e.$fireCommandActivationEvent(D),this.h(D,$,!1);{let v=!1;const C=(0,L.$an)($,function(N){if(N instanceof F.$yK)return f.Position.from(N);if(N instanceof F.$zK)return f.Range.from(N);if(N instanceof F.$JK)return f.location.from(N);if(F.$UL.isNotebookRange(N))return f.NotebookRange.from(N);if(N instanceof ArrayBuffer)return v=!0,s.$ce.wrap(new Uint8Array(N));if(N instanceof Uint8Array)return v=!0,s.$ce.wrap(N);if(N instanceof s.$ce)return v=!0,N;if(!Array.isArray(N))return N});try{const N=await this.#e.$executeCommand(D,v?new i.$uv(C):C,b);return(0,m.$qh)(N)}catch(N){if(N instanceof Error&&N.message==="$executeCommand:retry")return this.g(D,$,!1);throw N}}}async h(D,$,b){const v=this.b.get(D);if(!v)throw new Error("Unknown command");const{callback:C,thisArg:N,metadata:z}=v;if(z?.args)for(let O=0;O<z.args.length;O++)try{(0,I.$Qf)($[O],z.args[O].constraint)}catch{throw new Error(`Running the contributed command: '${D}' failed. Illegal argument '${z.args[O].name}' - ${z.args[O].description}`)}const M=o.$Kd.create();try{return await C.apply(N,$)}catch(O){if(D===this.converter.delegatingCommandId){const j=this.converter.getActualCommand(...$);j&&(D=j.command)}if(this.d.error(O,D,v.extension?.identifier),!b)throw O;if(v.extension?.identifier){const j=this.#i.onExtensionError(v.extension.identifier,O);this.d.trace("forwarded error to extension?",j,v.extension?.identifier)}throw new class extends Error{constructor(){super((0,n.$Ei)(O)),this.id=D,this.source=v.extension?.displayName??v.extension?.name}}}finally{this.j(v,D,M.elapsed())}}j(D,$,b){D.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:D.extension.identifier.value,id:new a.$no($),duration:b})}$executeContributedCommand(D,...$){this.d.trace("ExtHostCommands#$executeContributedCommand",D);const b=this.b.get(D);return b?($=$.map(v=>this.f.reduce((C,N)=>N.processArgument(C,b.extension?.identifier),v)),this.h(D,$,!0)):Promise.reject(new Error(`Contributed command '${D}' does not exist.`))}getCommands(D=!1){return this.d.trace("ExtHostCommands#getCommands",D),this.#e.$getCommands().then($=>(D&&($=$.filter(b=>b[0]!=="_")),$))}$getContributedCommandMetadata(){const D=Object.create(null);for(const[$,b]of this.b){const{metadata:v}=b;v&&(D[$]=v)}return Promise.resolve(D)}};e.$SM=r,e.$SM=r=He([Be(0,w.$xM),Be(1,E.$bj),Be(2,t.$RM)],r),e.$TM=(0,S.$Th)("IExtHostCommands");class d{constructor(D,$,b){this.d=D,this.f=$,this.g=b,this.delegatingCommandId=`__vsc${Date.now().toString(36)} `,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(D,$){if(!D)return;const b={$ident:void 0,id:D.command,title:D.title,tooltip:D.tooltip};if(!D.command)return b;const v=this.f(D.command);if(v)b.id=v.internalId,b.arguments=v.args.map((C,N)=>C.convert(D.arguments&&D.arguments[N]));else if((0,p.$Kb)(D.arguments)){const C=`${D.command} /${++this.c}`;this.b.set(C,D),$.add((0,y.$Pc)(()=>{this.b.delete(C),this.g.trace("CommandsConverter#DISPOSE",C)})),b.$ident=C,b.id=this.delegatingCommandId,b.arguments=[C],this.g.trace("CommandsConverter#CREATE",D.command,C)}return b}fromInternal(D){return typeof D.$ident=="string"?this.b.get(D.$ident):{command:D.id,title:D.title,arguments:D.arguments}}getActualCommand(...D){return this.b.get(D[0])}h(...D){const $=this.getActualCommand(...D);return this.g.trace("CommandsConverter#EXECUTE",D[0],$?$.command:"MISSING"),$?this.d.executeCommand($.command,...$.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${D[0]}`)}}e.$UM=d;class u{static{this.Uri=new u("uri","Uri of a text document",D=>g.URI.isUri(D),D=>D)}static{this.Position=new u("position","A position in a text document",D=>F.$yK.isPosition(D),f.Position.from)}static{this.Range=new u("range","A range in a text document",D=>F.$zK.isRange(D),f.Range.from)}static{this.Selection=new u("selection","A selection in a text document",D=>F.$AK.isSelection(D),f.Selection.from)}static{this.Number=new u("number","",D=>typeof D=="number",D=>D)}static{this.String=new u("string","",D=>typeof D=="string",D=>D)}static{this.StringArray=u.Arr(u.String)}static Arr(D){return new u(`${D.name}_array`,`Array of ${D.name}, ${D.description}`,$=>Array.isArray($)&&$.every(b=>D.validate(b)),$=>$.map(b=>D.convert(b)))}static{this.CallHierarchyItem=new u("item","A call hierarchy item",D=>D instanceof F.$TK,f.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new u("item","A type hierarchy item",D=>D instanceof F.$bM,f.TypeHierarchyItem.from)}static{this.TestItem=new u("testItem","A VS Code TestItem",D=>D instanceof c.$KM,f.TestItem.from)}constructor(D,$,b,v){this.name=D,this.description=$,this.validate=b,this.convert=v}optional(){return new u(this.name,`(optional) ${this.description}`,D=>D==null||this.validate(D),D=>D===void 0?void 0:D===null?null:this.convert(D))}with(D,$){return new u(D??this.name,$??this.description,this.validate,this.convert)}}e.$VM=u;class l{static{this.Void=new l("no result",D=>D)}constructor(D,$){this.description=D,this.convert=$}}e.$WM=l;class h{constructor(D,$,b,v,C){this.id=D,this.internalId=$,this.description=b,this.args=v,this.result=C}}e.$XM=h}),define(ke[315],Se([1,0,19,17,2,84,132,45,137,35,14,7]),function($e,e,I,F,f,L,R,p,E,m,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0cc=void 0;const g=[new m.$XM("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[m.$VM.Uri,m.$VM.Position],new m.$WM("A promise that resolves to an array of DocumentHighlight-instances.",S(A.DocumentHighlight.to))),new m.$XM("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[m.$VM.Uri],new m.$WM("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(c,s)=>{if((0,I.$Jb)(c))return;class i extends P.$OK{static to(o){const a=new i(o.name,A.SymbolKind.to(o.kind),o.containerName||"",new P.$JK(s[0],A.Range.to(o.range)));return a.detail=o.detail,a.range=a.location.range,a.selectionRange=A.Range.to(o.selectionRange),a.children=o.children?o.children.map(i.to):[],a}}return c.map(i.to)})),new m.$XM("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[m.$VM.Uri,new m.$VM("options","Formatting options",c=>!0,c=>c)],new m.$WM("A promise that resolves to an array of TextEdits.",S(A.TextEdit.to))),new m.$XM("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[m.$VM.Uri,m.$VM.Range,new m.$VM("options","Formatting options",c=>!0,c=>c)],new m.$WM("A promise that resolves to an array of TextEdits.",S(A.TextEdit.to))),new m.$XM("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[m.$VM.Uri,m.$VM.Position,new m.$VM("ch","Trigger character",c=>typeof c=="string",c=>c),new m.$VM("options","Formatting options",c=>!0,c=>c)],new m.$WM("A promise that resolves to an array of TextEdits.",S(A.TextEdit.to))),new m.$XM("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[m.$VM.Uri,m.$VM.Position],new m.$WM("A promise that resolves to an array of Location or LocationLink instances.",w)),new m.$XM("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[m.$VM.Uri,m.$VM.Position],new m.$WM("A promise that resolves to an array of Location or LocationLink instances.",w)),new m.$XM("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[m.$VM.Uri,m.$VM.Position],new m.$WM("A promise that resolves to an array of Location or LocationLink instances.",w)),new m.$XM("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[m.$VM.Uri,m.$VM.Position],new m.$WM("A promise that resolves to an array of Location or LocationLink instances.",w)),new m.$XM("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[m.$VM.Uri,m.$VM.Position],new m.$WM("A promise that resolves to an array of Location-instances.",S(A.location.to))),new m.$XM("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[m.$VM.Uri,m.$VM.Position],new m.$WM("A promise that resolves to an array of Hover-instances.",S(A.Hover.to))),new m.$XM("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[m.$VM.Uri,new m.$VM("position","A position in a text document",c=>Array.isArray(c)&&c.every(s=>P.$yK.isPosition(s)),c=>c.map(A.Position.from))],new m.$WM("A promise that resolves to an array of ranges.",c=>c.map(s=>{let i;for(const n of s.reverse())i=new P.$SK(A.Range.to(n),i);return i}))),new m.$XM("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[m.$VM.String.with("query","Search string")],new m.$WM("A promise that resolves to an array of SymbolInformation-instances.",c=>c.map(A.WorkspaceSymbol.to))),new m.$XM("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[m.$VM.Uri,m.$VM.Position],new m.$WM("A promise that resolves to an array of CallHierarchyItem-instances",c=>c.map(A.CallHierarchyItem.to))),new m.$XM("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[m.$VM.CallHierarchyItem],new m.$WM("A promise that resolves to an array of CallHierarchyIncomingCall-instances",c=>c.map(A.CallHierarchyIncomingCall.to))),new m.$XM("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[m.$VM.CallHierarchyItem],new m.$WM("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",c=>c.map(A.CallHierarchyOutgoingCall.to))),new m.$XM("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[m.$VM.Uri,m.$VM.Position],new m.$WM("A promise that resolves to a range and placeholder text.",c=>{if(c)return{range:A.Range.to(c.range),placeholder:c.text}})),new m.$XM("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[m.$VM.Uri,m.$VM.Position,m.$VM.String.with("newName","The new symbol name")],new m.$WM("A promise that resolves to a WorkspaceEdit.",c=>{if(c){if(c.rejectReason)throw new Error(c.rejectReason);return A.WorkspaceEdit.to(c)}})),new m.$XM("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[m.$VM.Uri,m.$VM.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new m.$WM("A promise that resolves to an array of DocumentLink-instances.",c=>c.map(A.DocumentLink.to))),new m.$XM("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[m.$VM.Uri],new m.$WM("A promise that resolves to SemanticTokensLegend.",c=>{if(c)return new P.$ML(c.tokenTypes,c.tokenModifiers)})),new m.$XM("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[m.$VM.Uri],new m.$WM("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const s=(0,R.$u$)(c);if(s.type==="full")return new P.$OL(s.data,void 0)})),new m.$XM("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[m.$VM.Uri,m.$VM.Range.optional()],new m.$WM("A promise that resolves to SemanticTokensLegend.",c=>{if(c)return new P.$ML(c.tokenTypes,c.tokenModifiers)})),new m.$XM("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[m.$VM.Uri,m.$VM.Range],new m.$WM("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const s=(0,R.$u$)(c);if(s.type==="full")return new P.$OL(s.data,void 0)})),new m.$XM("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[m.$VM.Uri,m.$VM.Position,m.$VM.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),m.$VM.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new m.$WM("A promise that resolves to a CompletionList-instance.",(c,s,i)=>{if(!c)return new P.$5K([]);const n=c.suggestions.map(o=>A.CompletionItem.to(o,i));return new P.$5K(n,c.incomplete)})),new m.$XM("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[m.$VM.Uri,m.$VM.Position,m.$VM.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new m.$WM("A promise that resolves to SignatureHelp.",c=>{if(c)return A.SignatureHelp.to(c)})),new m.$XM("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[m.$VM.Uri,m.$VM.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new m.$WM("A promise that resolves to an array of CodeLens-instances.",(c,s,i)=>S(n=>new P.$WK(A.Range.to(n.range),n.command&&i.fromInternal(n.command)))(c))),new m.$XM("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[m.$VM.Uri,new m.$VM("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",c=>P.$zK.isRange(c),c=>P.$AK.isSelection(c)?A.Selection.from(c):A.Range.from(c)),m.$VM.String.with("kind","Code action kind to return code actions for").optional(),m.$VM.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new m.$WM("A promise that resolves to an array of Command-instances.",(c,s,i)=>S(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return i.fromInternal(n.command)}else{const o=new P.$QK(n.title,n.kind?new P.$RK(n.kind):void 0);return n.edit&&(o.edit=A.WorkspaceEdit.to(n.edit)),n.command&&(o.command=i.fromInternal(n.command)),o.isPreferred=n.isPreferred,o}})(c))),new m.$XM("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[m.$VM.Uri],new m.$WM("A promise that resolves to an array of ColorInformation objects.",c=>c?c.map(s=>new P.$$K(A.Range.to(s.range),A.Color.to(s.color))):[])),new m.$XM("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new m.$VM("color","The color to show and insert",c=>c instanceof P.$0K,A.Color.from),new m.$VM("context","Context object with uri and range",c=>!0,c=>({uri:c.uri,range:A.Range.from(c.range)}))],new m.$WM("A promise that resolves to an array of ColorPresentation objects.",c=>c?c.map(A.ColorPresentation.to):[])),new m.$XM("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[m.$VM.Uri,m.$VM.Range],new m.$WM("A promise that resolves to an array of Inlay objects",(c,s,i)=>c.map(A.InlayHint.to.bind(void 0,i)))),new m.$XM("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[m.$VM.Uri],new m.$WM("A promise that resolves to an array of FoldingRange objects",(c,s)=>{if(c)return c.map(A.FoldingRange.to)})),new m.$XM("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new m.$WM("A promise that resolves to an array of NotebookContentProvider static info objects.",S(c=>({viewType:c.viewType,displayName:c.displayName,options:{transientOutputs:c.options.transientOutputs,transientCellMetadata:c.options.transientCellMetadata,transientDocumentMetadata:c.options.transientDocumentMetadata},filenamePattern:c.filenamePattern.map(s=>A.NotebookExclusiveDocumentPattern.to(s))})))),new m.$XM("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[m.$VM.Uri,m.$VM.Range,new m.$VM("context","An InlineValueContext",c=>c&&typeof c.frameId=="number"&&c.stoppedLocation instanceof P.$zK,c=>A.InlineValueContext.from(c))],new m.$WM("A promise that resolves to an array of InlineValue objects",c=>c.map(A.InlineValue.to))),new m.$XM("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new m.$VM("uriOrString","Uri-instance or string (only http/https)",c=>f.URI.isUri(c)||typeof c=="string"&&(0,E.$HU)(c,F.Schemas.http,F.Schemas.https),c=>c),new m.$VM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[A.ViewColumn.from(c),void 0]:[A.ViewColumn.from(c.viewColumn),A.TextEditorOpenOptions.from(c)])).optional(),m.$VM.String.with("label","").optional()],m.$WM.Void),new m.$XM("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[m.$VM.Uri.with("resource","Resource to open"),m.$VM.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new m.$VM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[A.ViewColumn.from(c),void 0]:[A.ViewColumn.from(c.viewColumn),A.TextEditorOpenOptions.from(c)])).optional()],m.$WM.Void),new m.$XM("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[m.$VM.Uri.with("left","Left-hand side resource of the diff editor"),m.$VM.Uri.with("right","Right-hand side resource of the diff editor"),m.$VM.String.with("title","Human readable title for the diff editor").optional(),new m.$VM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="object",c=>c&&[A.ViewColumn.from(c.viewColumn),A.TextEditorOpenOptions.from(c)]).optional()],m.$WM.Void),new m.$XM("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[m.$VM.Uri,m.$VM.Position],new m.$WM("A promise that resolves to an array of TypeHierarchyItem-instances",c=>c.map(A.TypeHierarchyItem.to))),new m.$XM("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[m.$VM.TypeHierarchyItem],new m.$WM("A promise that resolves to an array of TypeHierarchyItem-instances",c=>c.map(A.TypeHierarchyItem.to))),new m.$XM("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[m.$VM.TypeHierarchyItem],new m.$WM("A promise that resolves to an array of TypeHierarchyItem-instances",c=>c.map(A.TypeHierarchyItem.to))),new m.$XM("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[m.$VM.TestItem],m.$WM.Void),new m.$XM("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[m.$VM.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],m.$WM.Void),new m.$XM("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[m.$VM.String.with("name","The context key name"),new m.$VM("value","The context key value",()=>!0,c=>c)],m.$WM.Void),new m.$XM("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[m.$VM.Uri,m.$VM.StringArray,new m.$VM("MappedEditsContext","Mapped Edits Context",c=>A.MappedEditsContext.is(c),c=>A.MappedEditsContext.from(c))],new m.$WM("A promise that resolves to a workspace edit or null",c=>c?A.WorkspaceEdit.to(c):null))];class y{static register(s){g.forEach(s.registerApiCommand,s),this.a(s)}static a(s){s.registerCommand(!1,"_validateWhenClauses",p.$Si)}}e.$0cc=y;function S(c){return s=>{if(Array.isArray(s))return s.map(c)}}function w(c){if(!Array.isArray(c))return;const s=[];for(const i of c)L.$it(i)?s.push(A.DefinitionLink.to(i)):s.push(A.location.to(i));return s}}),define(ke[316],Se([1,0,10,59,4,3,2,84,26,14,7,6,25]),function($e,e,I,F,f,L,R,p,E,m,A,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_cc=void 0;function y(S,w,c){const s=S.getProxy(P.$vK.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new E.$_l,w.registerArgumentProcessor({processArgument:h=>{if(h&&h.$mid===6){const k=this.b.get(h.handle);return k?k.value:h}else if(h&&h.$mid===7){const k=this.b.get(h.commentControlHandle);if(!k)return h;const D=k.getCommentThread(h.commentThreadHandle);return D?D.value:h}else if(h&&(h.$mid===9||h.$mid===8)){const k=this.b.get(h.thread.commentControlHandle);if(!k)return h;const D=k.getCommentThread(h.thread.commentThreadHandle);return D?h.$mid===8?D.value:{thread:D.value,text:h.text}:h}else if(h&&h.$mid===10){const k=this.b.get(h.thread.commentControlHandle);if(!k)return h;const D=k.getCommentThread(h.thread.commentThreadHandle);if(!D)return h;const $=h.commentUniqueId,b=D.getCommentByUniqueId($);return b||h}else if(h&&h.$mid===11){const k=this.b.get(h.thread.commentControlHandle);if(!k)return h;const D=k.getCommentThread(h.thread.commentThreadHandle);if(!D)return h;const $=h.text,b=h.commentUniqueId,v=D.getCommentByUniqueId(b);return v?(typeof v.body=="string"?v.body=$:v.body=new A.$XK($),v):h}return h}})}createCommentController(h,k,D){const $=i.a++,b=new o(h,$,k,D);this.b.set(b.handle,b);const v=this.c.get(h.identifier)||[];return v.push(b),this.c.set(h.identifier,v),b.value}async $createCommentThreadTemplate(h,k,D){const $=this.b.get(h);$&&$.$createCommentThreadTemplate(k,D)}async $updateCommentThreadTemplate(h,k,D){const $=this.b.get(h);$&&$.$updateCommentThreadTemplate(k,D)}$deleteCommentThread(h,k){this.b.get(h)?.$deleteCommentThread(k)}$provideCommentingRanges(h,k,D){const $=this.b.get(h);if(!$||!$.commentingRangeProvider)return Promise.resolve(void 0);const b=c.getDocument(R.URI.revive(k));return(0,I.$Ng)(async()=>{const v=await $.commentingRangeProvider.provideCommentingRanges(b,D);let C;return Array.isArray(v)?C={ranges:v,fileComments:!1}:v?C={ranges:v.ranges||[],fileComments:v.fileComments||!1}:C=v??void 0,C}).then(v=>{let C;return v&&(C={ranges:v.ranges.map(N=>m.Range.from(N)),fileComments:v.fileComments}),C})}$toggleReaction(h,k,D,$,b){const v=this.b.get(h);return!v||!v.reactionHandler?Promise.resolve(void 0):(0,I.$Ng)(()=>{const C=v.getCommentThread(k);if(C){const N=C.getCommentByUniqueId($.uniqueIdInThread);if(v!==void 0&&N&&v.reactionHandler)return v.reactionHandler(N,r(b))}return Promise.resolve(void 0)})}}class n{static{this.a=0}set threadId(h){this.n=h}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(h){(h===void 0!=(this.p===void 0)||!h||!this.p||!h.isEqual(this.p))&&(this.p=h,this.b.range=h,this.c.fire())}get range(){return this.p}set canReply(h){this.d!==h&&(this.d=h,this.b.canReply=h,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(h){this.e=h,this.b.label=h,this.c.fire()}get contextValue(){return this.f}set contextValue(h){this.f=h,this.b.contextValue=h,this.c.fire()}get comments(){return this.q}set comments(h){this.q=h,this.b.comments=h,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(h){this.g=h,this.b.collapsibleState=h,this.c.fire()}get state(){return this.h}set state(h){this.h=h,this.b.state=h,this.c.fire()}get isDisposed(){return this.j}constructor(h,k,D,$,b,v,C,N){this.m=k,this.n=D,this.o=$,this.p=b,this.q=v,this.extensionDescription=C,this.r=N,this.handle=n.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new f.$Od,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new L.$Sc,this.l.value=new L.$Qc,this.n===void 0&&(this.n=`${h}.${this.handle}`),s.$createCommentThread(k,this.handle,this.n,this.o,m.Range.from(this.p),C.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=v,this.i.push({dispose:()=>{s.$deleteCommentThread(k,this.handle)}});const z=this;this.value={get uri(){return z.uri},get range(){return z.range},set range(M){z.range=M},get comments(){return z.comments},set comments(M){z.comments=M},get collapsibleState(){return z.collapsibleState},set collapsibleState(M){z.collapsibleState=M},get canReply(){return z.canReply},set canReply(M){z.canReply=M},get contextValue(){return z.contextValue},set contextValue(M){z.contextValue=M},get label(){return z.label},set label(M){z.label=M},get state(){return z.state},set state(M){z.state=M},dispose:()=>{z.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new L.$Qc);const h=D=>Object.prototype.hasOwnProperty.call(this.b,D),k={};h("range")&&(k.range=m.Range.from(this.p)),h("label")&&(k.label=this.label),h("contextValue")&&(k.contextValue=this.contextValue??null),h("comments")&&(k.comments=this.q.map(D=>a(this,D,this.k,this.extensionDescription))),h("collapsibleState")&&(k.collapseState=d(this.g)),h("canReply")&&(k.canReply=this.canReply),h("state")&&(k.state=u(this.h)),h("isTemplate")&&(k.isTemplate=this.r),this.b={},s.$updateCommentThread(this.m,this.handle,this.n,this.o,k)}getCommentByUniqueId(h){for(const k of this.k){const D=k[0],$=k[1];if(h===$)return D}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(h=>h.dispose())}}He([(0,F.$mh)(100)],n.prototype,"eventuallyUpdateCommentThread",null);class o{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(h){this.b=h,s.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(h){this.c=h,s.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!h})}get options(){return this.d}set options(h){this.d=h,s.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(h,k,D,$){this.f=h,this.g=k,this.h=D,this.i=$,this.a=new Map,s.$registerCommentController(this.handle,D,$,this.f.identifier.value);const b=this;this.value=Object.freeze({id:b.id,label:b.label,get options(){return b.options},set options(v){b.options=v},get commentingRangeProvider(){return b.commentingRangeProvider},set commentingRangeProvider(v){b.commentingRangeProvider=v},get reactionHandler(){return b.reactionHandler},set reactionHandler(v){b.reactionHandler=v},createCommentThread(v,C,N){return b.createCommentThread(v,C,N).value},dispose:()=>{b.dispose()}}),this.e=[],this.e.push({dispose:()=>{s.$unregisterCommentController(this.handle)}})}createCommentThread(h,k,D){k===void 0&&(0,g.$vF)(this.f,"fileComments");const $=new n(this.id,this.handle,void 0,h,k,D,this.f,!1);return this.a.set($.handle,$),$}$createCommentThreadTemplate(h,k){const D=new n(this.id,this.handle,void 0,R.URI.revive(h),m.Range.to(k),[],this.f,!0);return D.collapsibleState=p.CommentThreadCollapsibleState.Expanded,this.a.set(D.handle,D),D}$updateCommentThreadTemplate(h,k){const D=this.a.get(h);D&&(D.range=m.Range.to(k))}$deleteCommentThread(h){this.a.get(h)?.dispose(),this.a.delete(h)}getCommentThread(h){return this.a.get(h)}dispose(){this.a.forEach(h=>{h.dispose()}),this.e.forEach(h=>h.dispose())}}function a(l,h,k,D){let $=k.get(h);return $||($=++l.commentHandle,k.set(h,$)),h.state!==void 0&&(0,g.$vF)(D,"commentsDraftState"),{mode:h.mode,contextValue:h.contextValue,uniqueIdInThread:$,body:typeof h.body=="string"?h.body:m.MarkdownString.from(h.body),userName:h.author.name,userIconPath:h.author.iconPath,label:h.label,commentReactions:h.reactions?h.reactions.map(b=>t(b)):void 0,state:h.state,timestamp:h.timestamp?.toJSON()}}function t(l){return{label:l.label,iconPath:l.iconPath?m.$wM(l.iconPath):void 0,count:l.count,hasReacted:l.authorHasReacted}}function r(l){return{label:l.label||"",count:l.count||0,iconPath:l.iconPath?R.URI.revive(l.iconPath):"",authorHasReacted:l.hasReacted||!1}}function d(l){if(l!==void 0)switch(l){case A.CommentThreadCollapsibleState.Expanded:return p.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return p.CommentThreadCollapsibleState.Collapsed}return p.CommentThreadCollapsibleState.Collapsed}function u(l){if(l!==void 0)switch(l){case A.CommentThreadState.Unresolved:return p.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return p.CommentThreadState.Resolved}return p.CommentThreadState.Unresolved}return new i}e.$_cc=y}),define(ke[317],Se([1,0,24,6,27,20]),function($e,e,I,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0ec=void 0;let R=class{constructor(A,P){this.a=A.getProxy(F.$vK.MainThreadConsole),this.b=P.consoleForward.includeStack,this.c=P.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(A,P){const g=this,y=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){g.e(A,P,y,arguments)}})}e(A,P,g,y){this.a.$logExtensionHostMessage({type:"__$console",severity:P,arguments:E(y,this.b)}),this.c&&this.f(A,g,y)}};e.$0ec=R,e.$0ec=R=He([Be(0,L.$xM),Be(1,f.$NM)],R);const p=1e5;function E(m,A){const P=[];if(m.length)for(let g=0;g<m.length;g++){let y=m[g];if(typeof y>"u")y="undefined";else if(y instanceof Error){const S=y;S.stack?y=S.stack:y=S.toString()}P.push(y)}if(A){const g=new Error().stack;g&&P.push({__$stack:g.split(`
`).slice(3).join(`
`)})}try{const g=(0,I.$dn)(P);return g.length>p?"Output omitted for a large object that exceeds the limits":g}catch(g){return`Output omitted for an object that cannot be inspected ('${g.toString()}')`}}}),define(ke[151],Se([1,0,2,6,7,5,20,15,19,13,16,25]),function($e,e,I,F,f,L,R,p,E,m,A,P){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$bec=e.$aec=void 0;let y=class{static{g=this}static{this.c=0}static{this.d=250}constructor(w,c){this.h=c,this.f=new Map,this.g=w.getProxy(F.$vK.MainThreadDecorations)}registerFileDecorationProvider(w,c){const s=g.c++;this.f.set(s,{provider:w,extensionDescription:c}),this.g.$registerDecorationProvider(s,c.identifier.value);const i=w.onDidChangeFileDecorations&&w.onDidChangeFileDecorations(n=>{if(!n){this.g.$onDidChange(s,null);return}const o=(0,E.$2b)(n);if(o.length<=g.d){this.g.$onDidChange(s,o);return}this.h.warn("[Decorations] CAPPING events from decorations provider",c.identifier.value,o.length);const a=o.map(d=>({uri:d,rank:(0,m.$He)(d.path,"/")})),t=(0,E.$yb)(a,(d,u)=>d.rank-u.rank||(0,m.$Ve)(d.uri.path,u.uri.path)),r=[];e:for(const d of t){let u;for(const l of d){const h=(0,A.$lc)(l.uri.path);if(u!==h&&(u=h,r.push(l.uri)>=g.d))break e}}this.g.$onDidChange(s,r)});return new f.$xK(()=>{i?.dispose(),this.g.$unregisterDecorationProvider(s),this.f.delete(s)})}async $provideDecorations(w,c,s){if(!this.f.has(w))return Object.create(null);const i=Object.create(null),{provider:n,extensionDescription:o}=this.f.get(w);return await Promise.all(c.map(async a=>{try{const{uri:t,id:r}=a,d=await Promise.resolve(n.provideFileDecoration(I.URI.revive(t),s));if(!d)return;try{f.$SL.validate(d),d.badge&&typeof d.badge!="string"&&(0,P.$vF)(o,"codiconDecoration"),i[r]=[d.propagate,d.tooltip,d.badge,d.color]}catch(u){this.h.warn(`INVALID decoration from extension '${o.identifier.value}': ${u}`)}}catch(t){this.h.error(t)}})),i}};e.$aec=y,e.$aec=y=g=He([Be(0,R.$xM),Be(1,p.$bj)],y),e.$bec=(0,L.$Th)("IExtHostDecorations")}),define(ke[318],Se([1,0,212,136,2,6,7,14,4,15,28,57]),function($e,e,I,F,f,L,R,p,E,m,A,P){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$5cc=e.$4cc=void 0;class y{#e;#t;#i;constructor(c,s,i,n,o,a,t,r){this.d=c,this.e=s,this.f=i,this.g=n,this.h=o,this.c=!1,this.f=Math.max(n,i),this.#i=new A.$zc(d=>a.getComparisonKey(d)),this.#e=t,this.#t=r}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(c,s){if(!c){this.clear();return}this.j();let i=[];if(f.URI.isUri(c)){if(!s){this.delete(c);return}this.#i.set(c,s.slice()),i=[c]}else if(Array.isArray(c)){i=[];let a;c=[...c].sort(y.k);for(const t of c){const[r,d]=t;if((!a||r.toString()!==a.toString())&&(a&&this.#i.get(a).length===0&&this.#i.delete(a),a=r,i.push(r),this.#i.set(r,[])),d)this.#i.get(r)?.push(...d);else{const u=this.#i.get(r);u&&(u.length=0)}}}if(this.#t.fire(i),!this.#e)return;const n=[];let o=0;for(const a of i){let t=[];const r=this.#i.get(a);if(r)if(r.length>this.g){t=[];const d=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let u=0;u<4;u++)for(const l of r)if(l.severity===d[u]&&t.push({...p.Diagnostic.from(l),modelVersionId:this.h(a)})===this.g)break e;t.push({severity:F.MarkerSeverity.Info,message:(0,I.localize)(0,null,r.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=r.map(d=>({...p.Diagnostic.from(d),modelVersionId:this.h(a)}));if(n.push([a,t]),o+=t.length,o>this.f)break}this.#e.$changeMany(this.e,n)}delete(c){this.j(),this.#t.fire([c]),this.#i.delete(c),this.#e?.$changeMany(this.e,[[c,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(c,s){this.j();for(const[i,n]of this)c.call(s,i,n,this)}*[Symbol.iterator](){this.j();for(const c of this.#i.keys())yield[c,this.get(c)]}get(c){this.j();const s=this.#i.get(c);return Array.isArray(s)?Object.freeze(s.slice(0)):[]}has(c){return this.j(),Array.isArray(this.#i.get(c))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(c,s){return c[0].toString()<s[0].toString()?-1:c[0].toString()>s[0].toString()?1:0}}e.$4cc=y;let S=class{static{g=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*g.d}static _mapper(c){const s=new A.$zc;for(const i of c)s.set(i,i);return{uris:Object.freeze(Array.from(s.values()))}}constructor(c,s,i,n){this.j=s,this.k=i,this.l=n,this.g=new Map,this.h=new E.$Sd({merge:o=>o.flat(),delay:50}),this.onDidChangeDiagnostics=E.Event.map(this.h.event,g._mapper),this.f=c.getProxy(L.$vK.MainThreadDiagnostics)}createDiagnosticCollection(c,s){const{g:i,f:n,h:o,j:a,k:t,l:r}=this,d=new class{$changeMany(h,k){n.$changeMany(h,k),a.trace("[DiagnosticCollection] change many (extension, owner, uris)",c.value,h,k.length===0?"CLEARING":k)}$clear(h){n.$clear(h),a.trace("[DiagnosticCollection] remove all (extension, owner)",c.value,h)}dispose(){n.dispose()}};let u;if(!s)s="_generated_diagnostic_collection_name_#"+g.c++,u=s;else if(!i.has(s))u=s;else{this.j.warn(`DiagnosticCollection with name '${s}' does already exist.`);do u=s+g.c++;while(i.has(u))}return new class extends y{constructor(){super(s,u,g.e,g.d,h=>r.getDocument(h)?.version,t.extUri,d,o),i.set(u,this)}dispose(){super.dispose(),i.delete(u)}}}getDiagnostics(c){if(c)return this.m(c);{const s=new Map,i=[];for(const n of this.g.values())n.forEach((o,a)=>{let t=s.get(o.toString());typeof t>"u"&&(t=i.length,s.set(o.toString(),t),i.push([o,[]])),i[t][1]=i[t][1].concat(...a)});return i}}m(c){let s=[];for(const i of this.g.values())i.has(c)&&(s=s.concat(i.get(c)));return s}$acceptMarkersChange(c){if(!this.n){const s="_generated_mirror",i=new y(s,s,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,n=>{},this.k.extUri,void 0,this.h);this.g.set(s,i),this.n=i}for(const[s,i]of c)this.n.set(f.URI.revive(s),i.map(p.Diagnostic.to))}};e.$5cc=S,e.$5cc=S=g=He([Be(1,m.$bj),Be(2,P.$3cc)],S)}),define(ke[319],Se([1,0,2,6,25]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hdc=void 0;class L{constructor(p){this.a=p.getProxy(F.$vK.MainThreadDialogs)}showOpenDialog(p,E){return E?.allowUIResources&&(0,f.$vF)(p,"showLocal"),this.a.$showOpenDialog(E).then(m=>m?m.map(A=>I.URI.revive(A)):void 0)}showSaveDialog(p){return this.a.$showSaveDialog(p).then(E=>E?I.URI.revive(E):void 0)}}e.$hdc=L}),define(ke[320],Se([1,0,11,2,7,6,17,21,13]),function($e,e,I,F,f,L,R,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$idc=void 0;class m{static{this.a=0}constructor(P,g,y){this.d=g,this.e=y,this.b=new Map,this.c=P.getProxy(L.$vK.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(P,g){if(Object.keys(R.Schemas).indexOf(P)>=0)throw new Error(`scheme '${P}' already registered`);const y=m.a++;this.b.set(y,g),this.c.$registerTextContentProvider(y,P);let S;return typeof g.onDidChange=="function"&&(S=g.onDidChange(w=>{if(w.scheme!==P){this.e.warn(`Provider for scheme '${P}' is firing event for schema '${w.scheme}' which will be IGNORED`);return}this.d.getDocument(w)&&this.$provideTextDocumentContent(y,w).then(c=>{if(!c&&typeof c!="string")return;const s=this.d.getDocument(w);if(!s)return;const i=(0,E.$Qe)(c);if(!s.equalLines(i))return this.c.$onVirtualDocumentChange(w,c)},I.$Z)})),new f.$xK(()=>{this.b.delete(y)&&this.c.$unregisterTextContentProvider(y),S&&(S.dispose(),S=void 0)})}$provideTextDocumentContent(P,g){const y=this.b.get(P);return y?Promise.resolve(y.provideTextDocumentContent(F.URI.revive(g),p.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${g.scheme}`))}}e.$idc=m}),define(ke[321],Se([1,0,4,3,2,6,143,14,18,24,7,11]),function($e,e,I,F,f,L,R,p,E,m,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1cc=void 0;class g{constructor(S,w){this.a=new I.$Od({onListenerError:P.$1}),this.b=new I.$Od({onListenerError:P.$1}),this.c=new I.$Od({onListenerError:P.$1}),this.d=new I.$Od({onListenerError:P.$1}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new F.$Qc,this.h=new Map,this.f=S.getProxy(L.$vK.MainThreadDocuments),this.g=w,this.g.onDidRemoveDocuments(c=>{for(const s of c)this.b.fire(s.document)},void 0,this.e),this.g.onDidAddDocuments(c=>{for(const s of c)this.a.fire(s.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(S){if(!S)return;const w=this.g.getDocument(S);if(w)return w}getDocument(S){const w=this.getDocumentData(S);if(!w?.document)throw new Error(`Unable to retrieve document from URI '${S}'`);return w.document}ensureDocumentData(S){const w=this.g.getDocument(S);if(w)return Promise.resolve(w);let c=this.h.get(S.toString());return c||(c=this.f.$tryOpenDocument(S).then(s=>{this.h.delete(S.toString());const i=f.URI.revive(s);return(0,E.$Kf)(this.g.getDocument(i))},s=>(this.h.delete(S.toString()),Promise.reject(s))),this.h.set(S.toString(),c)),c}createDocumentData(S){return this.f.$tryCreateDocument(S).then(w=>f.URI.revive(w))}$acceptModelLanguageChanged(S,w){const c=f.URI.revive(S),s=this.g.getDocument(c);if(!s)throw new Error("unknown document");this.b.fire(s.document),s._acceptLanguageId(w),this.a.fire(s.document)}$acceptModelSaved(S){const w=f.URI.revive(S),c=this.g.getDocument(w);if(!c)throw new Error("unknown document");this.$acceptDirtyStateChanged(S,!1),this.d.fire(c.document)}$acceptDirtyStateChanged(S,w){const c=f.URI.revive(S),s=this.g.getDocument(c);if(!s)throw new Error("unknown document");s._acceptIsDirty(w),this.c.fire({document:s.document,contentChanges:[],reason:void 0})}$acceptModelChanged(S,w,c){const s=f.URI.revive(S),i=this.g.getDocument(s);if(!i)throw new Error("unknown document");i._acceptIsDirty(c),i.onEvents(w);let n;w.isUndoing?n=A.TextDocumentChangeReason.Undo:w.isRedoing&&(n=A.TextDocumentChangeReason.Redo),this.c.fire((0,m.$_m)({document:i.document,contentChanges:w.changes.map(o=>({range:p.Range.to(o.range),rangeOffset:o.rangeOffset,rangeLength:o.rangeLength,text:o.text})),reason:n}))}setWordDefinitionFor(S,w){(0,R.$zM)(S,w)}}e.$1cc=g}),define(ke[70],Se([1,0,60,4,3,2,5,6,143,20,150,14,15,28,17,51,48]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,S,w,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IM=e.$HM=void 0;class s{constructor(o){this.value=o,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let i=class{constructor(o,a){this.h=o,this.i=a,this.a=null,this.b=new Map,this.c=new y.$zc,this.d=new F.$Od,this.e=new F.$Od,this.f=new F.$Od,this.g=new F.$Od,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(o){this.acceptDocumentsAndEditorsDelta(o)}acceptDocumentsAndEditorsDelta(o){const a=[],t=[],r=[];if(o.removedDocuments)for(const d of o.removedDocuments){const u=L.URI.revive(d),l=this.c.get(u);l?.unref()&&(this.c.delete(u),a.push(l.value))}if(o.addedDocuments)for(const d of o.addedDocuments){const u=L.URI.revive(d.uri);let l=this.c.get(u);if(l&&u.scheme!==S.Schemas.vscodeNotebookCell&&u.scheme!==S.Schemas.vscodeInteractiveInput)throw new Error(`document '${u} already exists!'`);l||(l=new s(new E.$AM(this.h.getProxy(p.$vK.MainThreadDocuments),u,d.lines,d.EOL,d.versionId,d.languageId,d.isDirty,d.notebook)),this.c.set(u,l),t.push(l.value)),l.ref()}if(o.removedEditors)for(const d of o.removedEditors){const u=this.b.get(d);this.b.delete(d),u&&r.push(u)}if(o.addedEditors)for(const d of o.addedEditors){const u=L.URI.revive(d.documentUri);I.ok(this.c.has(u),`document '${u}' does not exist`),I.ok(!this.b.has(d.id),`editor '${d.id}' already exists!`);const l=this.c.get(u).value,h=new A.$GM(d.id,this.h.getProxy(p.$vK.MainThreadTextEditors),this.i,new c.$U(()=>l.document),d.selections.map(P.Selection.to),d.options,d.visibleRanges.map(k=>P.Range.to(k)),typeof d.editorPosition=="number"?P.ViewColumn.to(d.editorPosition):void 0);this.b.set(d.id,h)}o.newActiveEditor!==void 0&&(I.ok(o.newActiveEditor===null||this.b.has(o.newActiveEditor),`active editor '${o.newActiveEditor}' does not exist`),this.a=o.newActiveEditor),(0,f.$Mc)(a),(0,f.$Mc)(r),o.removedDocuments&&this.e.fire(a),o.addedDocuments&&this.d.fire(t),(o.removedEditors||o.addedEditors)&&this.f.fire(this.allEditors().map(d=>d.value)),o.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(o){return this.c.get(o)?.value}allDocuments(){return w.Iterable.map(this.c.values(),o=>o.value)}getEditor(o){return this.b.get(o)}activeEditor(o){if(!this.a)return;const a=this.b.get(this.a);return o?a:a?.value}allEditors(){return[...this.b.values()]}};e.$HM=i,e.$HM=i=He([Be(0,m.$xM),Be(1,g.$bj)],i),e.$IM=(0,R.$Th)("IExtHostDocumentsAndEditors")}),define(ke[71],Se([1,0,74,4,18,2,5,6,20,14,7]),function($e,e,I,F,f,L,R,p,E,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gec=e.$fec=void 0,e.$fec=(0,R.$Th)("IExtHostEditorTabs");class P{constructor(c,s,i){this.e=i,this.d=s,this.acceptDtoUpdate(c)}get apiObject(){if(!this.a){const c=this,s={get isActive(){return c.b.id===c.e()},get label(){return c.b.label},get input(){return c.c},get isDirty(){return c.b.isDirty},get isPinned(){return c.b.isPinned},get isPreview(){return c.b.isPreview},get group(){return c.d.apiObject}};this.a=Object.freeze(s)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(c){this.b=c,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.$cM(L.URI.revive(this.b.input.uri));case 2:return new A.$dM(L.URI.revive(this.b.input.original),L.URI.revive(this.b.input.modified));case 3:return new A.$eM(L.URI.revive(this.b.input.base),L.URI.revive(this.b.input.input1),L.URI.revive(this.b.input.input2),L.URI.revive(this.b.input.result));case 6:return new A.$fM(L.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.$gM(this.b.input.viewType);case 4:return new A.$hM(L.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.$iM(L.URI.revive(this.b.input.original),L.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.$jM;case 9:return new A.$kM(L.URI.revive(this.b.input.uri),L.URI.revive(this.b.input.inputBoxUri));case 10:return new A.$lM(this.b.input.providerId);default:return}}}class g{constructor(c,s){this.c=[],this.d="",this.b=c,this.e=s;for(const i of c.tabs)i.isActive&&(this.d=i.id),this.c.push(new P(i,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const c=this,s={get isActive(){return c.b.groupId===c.e()},get viewColumn(){return m.ViewColumn.to(c.b.viewColumn)},get activeTab(){return c.c.find(i=>i.tabId===c.d)?.apiObject},get tabs(){return Object.freeze(c.c.map(i=>i.apiObject))}};this.a=Object.freeze(s)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(c){this.b=c}acceptTabOperation(c){if(c.kind===0){const i=new P(c.tabDto,this,()=>this.activeTabId());return this.c.splice(c.index,0,i),c.tabDto.isActive&&(this.d=i.tabId),i}else if(c.kind===1){const i=this.c.splice(c.index,1)[0];if(!i)throw new Error(`Tab close updated received for index ${c.index} which does not exist`);return i.tabId===this.d&&(this.d=""),i}else if(c.kind===3){if(c.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const i=this.c.splice(c.oldIndex,1)[0];if(!i)throw new Error(`Tab move updated received for index ${c.oldIndex} which does not exist`);return this.c.splice(c.index,0,i),i}const s=this.c.find(i=>i.tabId===c.tabDto.id);if(!s)throw new Error("INVALID tab");return c.tabDto.isActive?this.d=c.tabDto.id:this.d===c.tabDto.id&&!c.tabDto.isActive&&(this.d=""),s.acceptDtoUpdate(c.tabDto),s}activeTabId(){return this.d}}let y=class{constructor(c){this.b=new F.$Od,this.c=new F.$Od,this.e=[],this.a=c.getProxy(p.$vK.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const c=this,s={onDidChangeTabGroups:c.c.event,onDidChangeTabs:c.b.event,get all(){return Object.freeze(c.e.map(i=>i.apiObject))},get activeTabGroup(){const i=c.d;return(0,f.$Kf)(c.e.find(o=>o.groupId===i)?.apiObject)},close:async(i,n)=>{const o=Array.isArray(i)?i:[i];return o.length?S(o[0])?this.j(o,n):this.i(o,n):!0}};this.f=Object.freeze(s)}return this.f}$acceptEditorTabModel(c){const s=new Set(this.e.map(d=>d.groupId)),i=new Set(c.map(d=>d.groupId)),n=(0,I.$K)(s,i),o=this.e.filter(d=>n.removed.includes(d.groupId)).map(d=>d.apiObject),a=[],t=[];this.e=c.map(d=>{const u=new g(d,()=>this.d);return n.added.includes(u.groupId)?a.push(u.apiObject):t.push(u.apiObject),u});const r=(0,f.$Kf)(c.find(d=>d.isActive===!0)?.groupId);r!==void 0&&this.d!==r&&(this.d=r),this.c.fire(Object.freeze({opened:a,closed:o,changed:t}))}$acceptTabGroupUpdate(c){const s=this.e.find(i=>i.groupId===c.groupId);if(!s)throw new Error("Update Group IPC call received before group creation.");s.acceptGroupDtoUpdate(c),c.isActive&&(this.d=c.groupId),this.c.fire(Object.freeze({changed:[s.apiObject],opened:[],closed:[]}))}$acceptTabOperation(c){const s=this.e.find(n=>n.groupId===c.groupId);if(!s)throw new Error("Update Tabs IPC call received before group creation.");const i=s.acceptTabOperation(c);switch(c.kind){case 0:this.b.fire(Object.freeze({opened:[i.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[i.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[i.apiObject]}));return}}g(c){for(const s of this.e)for(const i of s.tabs)if(i.apiObject===c)return i}h(c){return this.e.find(s=>s.apiObject===c)}async i(c,s){const i=[];for(const n of c){const o=this.g(n);if(!o)throw new Error("Tab close: Invalid tab not found!");i.push(o.tabId)}return this.a.$closeTab(i,s)}async j(c,s){const i=[];for(const n of c){const o=this.h(n);if(!o)throw new Error("Group close: Invalid group not found!");i.push(o.groupId)}return this.a.$closeGroup(i,s)}};e.$gec=y,e.$gec=y=He([Be(0,E.$xM)],y);function S(w){return w.tabs!==void 0}}),define(ke[322],Se([1,0,6,7]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ec=void 0;class f{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(I.$vK.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,p,E){if(this.a.size===0)throw new Error("No embedding vector providers registered");const m=this.a.get(R);if(!m)throw new Error("Embedding vector provider not found");const A=await m.provideEmbeddingVector(p,E);if(!A)throw new Error("Embedding vector provider returned undefined");return A}registerEmbeddingVectorProvider(R,p,E){const m=this.b;return this.b++,this.a.set(m,E),this.c.$registerAiEmbeddingVectorProvider(p,m),new F.$xK(()=>{this.c.$unregisterAiEmbeddingVectorProvider(m),this.a.delete(m)})}}e.$5ec=f}),define(ke[323],Se([1,0,2,6,3,7,14,173,13,22,25,81]),function($e,e,I,F,f,L,R,p,E,m,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Odc=void 0;class g{constructor(){this.a=[]}add(w){this.b=void 0,this.a.push(w)}delete(w){const c=this.a.indexOf(w);c>=0&&(this.a.splice(c,1),this.b=void 0)}c(){if(!this.b){const w=this.a.sort(),c=[];let s,i,n=14,o=14;for(const a of w){let t=s?(0,E.$5e)(s,a):0;for(t===0?i=1:i=o;t<a.length;t++)t+1===a.length?(n=o,o=9):o+=1,c.push([i,a.toUpperCase().charCodeAt(t),o]),c.push([i,a.toLowerCase().charCodeAt(t),o]),i=o;s=a,o=n}c.push([9,58,10]),c.push([10,47,12]),this.b=new p.$yZ(c)}}provideDocumentLinks(w){this.c();const c=[],s=p.$zZ.computeLinks({getLineContent(i){return w.lineAt(i-1).text},getLineCount(){return w.lineCount}},this.b);for(const i of s){const n=R.DocumentLink.to(i);n.target&&c.push(n)}return c}}class y{constructor(w,c){this.i=c,this.b=new g,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=w.getProxy(F.$vK.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(w,c,s,i={}){if(y.j(s),this.d.has(c))throw new Error(`a provider for the scheme '${c}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(w,"*",this.b));const n=this.h++;this.b.add(c),this.d.add(c),this.c.set(n,s);let o=2;i.isCaseSensitive&&(o+=1024),i.isReadonly&&(o+=2048),typeof s.copy=="function"&&(o+=8),typeof s.open=="function"&&typeof s.close=="function"&&typeof s.read=="function"&&typeof s.write=="function"&&((0,A.$vF)(w,"fsChunks"),o+=4);let a;i.isReadonly&&(0,P.$9j)(i.isReadonly)&&((0,A.$vF)(w,"readonlyMessage"),a={value:i.isReadonly.value,isTrusted:i.isReadonly.isTrusted,supportThemeIcons:i.isReadonly.supportThemeIcons,supportHtml:i.isReadonly.supportHtml,baseUri:i.isReadonly.baseUri,uris:i.isReadonly.uris}),this.a.$registerFileSystemProvider(n,c,o,a).catch(r=>{console.error(`FAILED to register filesystem provider of ${w.identifier.value}-extension for the scheme ${c}`),console.error(r)});const t=s.onDidChangeFile(r=>{const d=[];for(const u of r){const{uri:l,type:h}=u;if(l.scheme!==c)continue;let k;switch(h){case L.FileChangeType.Changed:k=0;break;case L.FileChangeType.Created:k=1;break;case L.FileChangeType.Deleted:k=2;break;default:throw new Error("Unknown FileChangeType")}d.push({resource:l,type:k})}this.a.$onFileSystemChange(n,d)});return(0,f.$Pc)(()=>{t.dispose(),this.b.delete(c),this.d.delete(c),this.c.delete(n),this.a.$unregisterProvider(n)})}static j(w){if(!w)throw new Error("MISSING provider");if(typeof w.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof w.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof w.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof w.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof w.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof w.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof w.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof w.rename!="function")throw new Error("Provider does NOT implement rename")}static k(w){const{type:c,ctime:s,mtime:i,size:n,permissions:o}=w;return{type:c,ctime:s,mtime:i,size:n,permissions:o}}$stat(w,c){return Promise.resolve(this.l(w).stat(I.URI.revive(c))).then(s=>y.k(s))}$readdir(w,c){return Promise.resolve(this.l(w).readDirectory(I.URI.revive(c)))}$readFile(w,c){return Promise.resolve(this.l(w).readFile(I.URI.revive(c))).then(s=>m.$ce.wrap(s))}$writeFile(w,c,s,i){return Promise.resolve(this.l(w).writeFile(I.URI.revive(c),s.buffer,i))}$delete(w,c,s){return Promise.resolve(this.l(w).delete(I.URI.revive(c),s))}$rename(w,c,s,i){return Promise.resolve(this.l(w).rename(I.URI.revive(c),I.URI.revive(s),i))}$copy(w,c,s,i){const n=this.l(w);if(!n.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(n.copy(I.URI.revive(c),I.URI.revive(s),i))}$mkdir(w,c){return Promise.resolve(this.l(w).createDirectory(I.URI.revive(c)))}$watch(w,c,s,i){const n=this.l(w).watch(I.URI.revive(s),i);this.f.set(c,n)}$unwatch(w,c){const s=this.f.get(c);s&&(s.dispose(),this.f.delete(c))}$open(w,c,s){const i=this.l(w);if(!i.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(i.open(I.URI.revive(c),s))}$close(w,c){const s=this.l(w);if(!s.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(s.close(c))}$read(w,c,s,i){const n=this.l(w);if(!n.read)throw new Error('FileSystemProvider does not implement "read"');const o=m.$ce.alloc(i);return Promise.resolve(n.read(c,s,o.buffer,0,i)).then(a=>o.slice(0,a))}$write(w,c,s,i){const n=this.l(w);if(!n.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(n.write(c,s,i.buffer,0,i.byteLength))}l(w){const c=this.c.get(w);if(!c){const s=new Error;throw s.name="ENOPRO",s.message="no provider",s}return c}}e.$Odc=y}),define(ke[72],Se([1,0,6,31,7,22,5,20,57,3,10,23,17]),function($e,e,I,F,f,L,R,p,E,m,A,P,g){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$vdc=e.$udc=void 0;let S=y=class{constructor(c,s){this.b=new Map,this.c=new A.$5g,this.a=c.getProxy(I.$vK.MainThreadFileSystem);const i=this;this.value=Object.freeze({async stat(n){try{let o;const a=i.b.get(n.scheme);return a?(await i.a.$ensureActivation(n.scheme),o=await a.impl.stat(n)):o=await i.a.$stat(n),{type:o.type,ctime:o.ctime,mtime:o.mtime,size:o.size,permissions:o.permissions===F.FilePermission.Readonly?1:void 0}}catch(o){y.e(o)}},async readDirectory(n){try{const o=i.b.get(n.scheme);return o?(await i.a.$ensureActivation(n.scheme),(await o.impl.readDirectory(n)).slice()):await i.a.$readdir(n)}catch(o){return y.e(o)}},async createDirectory(n){try{const o=i.b.get(n.scheme);return o&&!o.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(o.impl,o.extUri,n)):await i.a.$mkdir(n)}catch(o){return y.e(o)}},async readFile(n){try{const o=i.b.get(n.scheme);return o?(await i.a.$ensureActivation(n.scheme),(await o.impl.readFile(n)).slice()):(await i.a.$readFile(n)).buffer}catch(o){return y.e(o)}},async writeFile(n,o){try{const a=i.b.get(n.scheme);return a&&!a.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(a.impl,a.extUri,a.extUri.dirname(n)),await i.c.queueFor(n).queue(()=>Promise.resolve(a.impl.writeFile(n,o,{create:!0,overwrite:!0})))):await i.a.$writeFile(n,L.$ce.wrap(o))}catch(a){return y.e(a)}},async delete(n,o){try{const a=i.b.get(n.scheme);return a&&!a.isReadonly?(await i.a.$ensureActivation(n.scheme),await a.impl.delete(n,{recursive:!1,...o})):await i.a.$delete(n,{recursive:!1,useTrash:!1,atomic:!1,...o})}catch(a){return y.e(a)}},async rename(n,o,a){try{return await i.a.$rename(n,o,{overwrite:!1,...a})}catch(t){return y.e(t)}},async copy(n,o,a){try{return await i.a.$copy(n,o,{overwrite:!1,...a})}catch(t){return y.e(t)}},isWritableFileSystem(n){const o=s.getCapabilities(n);if(typeof o=="number")return!(o&2048)}})}async d(c,s,i){const n=[];for(;!s.isEqual(i,s.dirname(i));)try{if(!((await c.stat(i)).type&F.FileType.Directory))throw f.$KL.FileExists(`Unable to create folder '${i.scheme===g.Schemas.file?i.fsPath:i.toString(!0)}' that already exists but is not a directory`);break}catch(o){if(F.$sk(o)!==F.FileSystemProviderErrorCode.FileNotFound)throw o;n.push(s.basename(i)),i=s.dirname(i)}for(let o=n.length-1;o>=0;o--){i=s.joinPath(i,n[o]);try{await c.createDirectory(i)}catch(a){if(F.$sk(a)!==F.FileSystemProviderErrorCode.FileExists)throw a}}}static e(c){if(c instanceof f.$KL)throw c;if(c instanceof F.$ok)switch(c.code){case F.FileSystemProviderErrorCode.FileExists:throw f.$KL.FileExists(c.message);case F.FileSystemProviderErrorCode.FileNotFound:throw f.$KL.FileNotFound(c.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw f.$KL.FileNotADirectory(c.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw f.$KL.FileIsADirectory(c.message);case F.FileSystemProviderErrorCode.NoPermissions:throw f.$KL.NoPermissions(c.message);case F.FileSystemProviderErrorCode.Unavailable:throw f.$KL.Unavailable(c.message);default:throw new f.$KL(c.message,c.name)}if(!(c instanceof Error))throw new f.$KL(String(c));if(c.name==="ENOPRO"||c.message.includes("ENOPRO"))throw f.$KL.Unavailable(c.message);switch(c.name){case F.FileSystemProviderErrorCode.FileExists:throw f.$KL.FileExists(c.message);case F.FileSystemProviderErrorCode.FileNotFound:throw f.$KL.FileNotFound(c.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw f.$KL.FileNotADirectory(c.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw f.$KL.FileIsADirectory(c.message);case F.FileSystemProviderErrorCode.NoPermissions:throw f.$KL.NoPermissions(c.message);case F.FileSystemProviderErrorCode.Unavailable:throw f.$KL.Unavailable(c.message);default:throw new f.$KL(c.message,c.name)}}addFileSystemProvider(c,s,i){return this.b.set(c,{impl:s,extUri:i?.isCaseSensitive?P.$mg:P.$og,isReadonly:!!i?.isReadonly}),(0,m.$Pc)(()=>this.b.delete(c))}getFileSystemProviderExtUri(c){return this.b.get(c)?.extUri??P.$mg}};e.$udc=S,e.$udc=S=y=He([Be(0,p.$xM),Be(1,E.$3cc)],S),e.$vdc=(0,R.$Th)("IExtHostConsumerFileSystem")}),define(ke[324],Se([1,0,4,34,2,6,14,7,48]),function($e,e,I,F,f,L,R,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pdc=void 0;class m{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(y,S,w,c,s,i){this.a=Math.random(),this.b=new I.$Od,this.c=new I.$Od,this.d=new I.$Od,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const n=(0,F.$Aj)(s),o=typeof s=="string",a=i?.correlate,t=c(r=>{if(!(typeof r.session=="number"&&r.session!==this.a)&&!(a&&typeof r.session>"u")){if(!i?.ignoreCreateEvents)for(const d of r.created){const u=f.URI.revive(d);n(u.fsPath)&&(!o||S.getWorkspaceFolder(u))&&this.b.fire(u)}if(!i?.ignoreChangeEvents)for(const d of r.changed){const u=f.URI.revive(d);n(u.fsPath)&&(!o||S.getWorkspaceFolder(u))&&this.c.fire(u)}if(!i?.ignoreDeleteEvents)for(const d of r.deleted){const u=f.URI.revive(d);n(u.fsPath)&&(!o||S.getWorkspaceFolder(u))&&this.d.fire(u)}}});this.g=p.$xK.from(this.i(y,w,s,i,i?.correlate),this.b,this.c,this.d,t)}i(y,S,w,c,s){const i=p.$xK.from();if(typeof w=="string")return i;const n=y.getProxy(L.$vK.MainThreadFileSystemEventService);let o=!1;return(w.pattern.includes(F.$wj)||w.pattern.includes(F.$xj))&&(o=!0),n.$watch(S.identifier.value,this.a,w.baseUri,{recursive:o,excludes:c?.excludes??[]},!!s),p.$xK.from({dispose:()=>n.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class A{constructor(y){this.a=y,this.session=this.a.session,this.b=new E.$U(()=>this.a.created.map(f.URI.revive)),this.c=new E.$U(()=>this.a.changed.map(f.URI.revive)),this.d=new E.$U(()=>this.a.deleted.map(f.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class P{constructor(y,S,w){this.j=y,this.k=S,this.l=w,this.a=new I.$Od,this.b=new I.$Od,this.c=new I.$Od,this.d=new I.$Od,this.g=new I.$Qd,this.h=new I.$Qd,this.i=new I.$Qd,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(y,S,w,c){return new m(this.j,y,S,this.a.event,R.GlobPattern.from(w),c)}$onFileEvent(y){this.a.fire(new A(y))}$onDidRunFileOperation(y,S){switch(y){case 2:this.b.fire(Object.freeze({files:S.map(w=>({oldUri:f.URI.revive(w.source),newUri:f.URI.revive(w.target)}))}));break;case 1:this.d.fire(Object.freeze({files:S.map(w=>f.URI.revive(w.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:S.map(w=>f.URI.revive(w.target))}));break;default:}}getOnWillRenameFileEvent(y){return this.m(y,this.g)}getOnWillCreateFileEvent(y){return this.m(y,this.h)}getOnWillDeleteFileEvent(y){return this.m(y,this.i)}m(y,S){return(w,c,s)=>{const i=function(o){w.call(c,o)};return i.extension=y,S.event(i,void 0,s)}}async $onWillRunFileOperation(y,S,w,c){switch(y){case 2:return await this.n(this.g,{files:S.map(s=>({oldUri:f.URI.revive(s.source),newUri:f.URI.revive(s.target)}))},w,c);case 1:return await this.n(this.i,{files:S.map(s=>f.URI.revive(s.target))},w,c);case 0:case 3:return await this.n(this.h,{files:S.map(s=>f.URI.revive(s.target))},w,c)}}async n(y,S,w,c){const s=new Set,i=[];if(await y.fireAsync(S,c,async(o,a)=>{const t=Date.now(),r=await Promise.resolve(o);r instanceof p.$HK&&(i.push([a.extension,r]),s.add(a.extension.displayName??a.extension.identifier.value)),Date.now()-t>w&&this.k.warn("SLOW file-participant",a.extension.identifier)}),c.isCancellationRequested||i.length===0)return;const n={edits:[]};for(const[,o]of i){const{edits:a}=R.WorkspaceEdit.from(o,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});n.edits=n.edits.concat(a)}return{edit:n,extensionNames:Array.from(s)}}}e.$Pdc=P}),define(ke[325],Se([1,0,3,2,6,14,7,35,10]),function($e,e,I,F,f,L,R,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wec=void 0;class m{static{this.a=0}constructor(y,S){this.extension=y,this.provider=S,this.handle=m.a++}}class A{constructor(y){this.session=y,this.responses=[]}}class P{static{this.a=0}constructor(y,S,w,c){this.f=w,this.g=c,this.b=new Map,this.d=new Map,this.e=y.getProxy(f.$vK.MainThreadInlineChat),S.registerApiCommand(new p.$XM("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new p.$VM("Run arguments","",s=>!0,s=>{if(s)return{initialRange:s.initialRange?L.Range.from(s.initialRange):void 0,initialSelection:s.initialSelection?L.Selection.from(s.initialSelection):void 0,message:s.message,autoSend:s.autoSend,position:s.position?L.Position.from(s.position):void 0}})],p.$WM.Void))}registerProvider(y,S,w){const c=new m(y,S);return this.b.set(c.handle,c),this.e.$registerInteractiveEditorProvider(c.handle,w.label,y.identifier.value,typeof S.handleInteractiveEditorResponseFeedback=="function"),(0,I.$Pc)(()=>{this.e.$unregisterInteractiveEditorProvider(c.handle),this.b.delete(c.handle)})}async $prepareSession(y,S,w,c){const s=this.b.get(y);if(!s){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this.f.getDocument(F.URI.revive(S)),n=L.Selection.to(w),o=await s.provider.prepareInteractiveEditorSession({document:i,selection:n},c);if(!o)return;if(o.wholeRange&&!o.wholeRange.contains(n))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const a=P.a++;return this.d.set(a,new A(o)),{id:a,placeholder:o.placeholder,input:o.input,slashCommands:o.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:L.Range.from(o.wholeRange),message:o.message}}async $provideResponse(y,S,w,c){const s=this.b.get(y);if(!s)return;const i=this.d.get(S.id);if(!i)return;const n={prompt:w.prompt,selection:L.Selection.to(w.selection),wholeRange:L.Range.to(w.wholeRange),attempt:w.attempt,live:w.live};let o=!1;const a={report:async h=>{if(!w.live&&h.edits?.length)throw new Error("Progress reporting is only supported for live sessions");o||c.isCancellationRequested||await this.e.$handleProgressChunk(w.requestId,{message:h.message,edits:h.edits?.map(L.TextEdit.from),editsShouldBeInstant:h.editsShouldBeInstant,slashCommand:h.slashCommand?.command,markdownFragment:R.$XK.isMarkdownString(h.content)?h.content.value:h.content})}},t=Promise.resolve(s.provider.provideInteractiveEditorResponse(i.session,n,a,c));let r;try{r=await(0,E.$Jg)(t,c)}finally{o=!0}if(!r)return;const d=i.responses.push(r)-1,u={wholeRange:L.Range.from(r.wholeRange),placeholder:r.placeholder};if(P.h(r))return{...u,id:d,type:"message",message:L.MarkdownString.from(r.contents)};const{edits:l}=r;return l instanceof R.$HK?{...u,id:d,type:"bulkEdit",edits:L.WorkspaceEdit.from(l)}:{...u,id:d,type:"editorEdit",edits:l.map(L.TextEdit.from)}}$handleFeedback(y,S,w,c){const s=this.b.get(y),i=this.d.get(S),n=i?.responses[w];if(s&&n){const o=L.InteractiveEditorResponseFeedbackKind.to(c);s.provider.handleInteractiveEditorResponseFeedback?.(i.session,n,o)}}$releaseSession(y,S){}static h(y){return typeof y=="object"&&typeof y.contents=="object"}}e.$Wec=P}),define(ke[326],Se([1,0,2,35]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sec=void 0;class f{constructor(R,p,E,m,A){this.a=p,this.b=E,this.c=m;const P=new F.$XM("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new F.$VM("showOptions","Show Options",g=>!0,g=>g),new F.$VM("resource","Interactive resource Uri",g=>!0,g=>g),new F.$VM("controllerId","Notebook controller Id",g=>!0,g=>g),new F.$VM("title","Interactive editor title",g=>!0,g=>g)],new F.$WM("Notebook and input URI",g=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",g.notebookEditorId),g.notebookEditorId!==void 0){const y=this.a.getEditorById(g.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",y.id),{notebookUri:I.URI.revive(g.notebookUri),inputUri:I.URI.revive(g.inputUri),notebookEditor:y.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",g.notebookUri,g.inputUri),{notebookUri:I.URI.revive(g.notebookUri),inputUri:I.URI.revive(g.inputUri)}}));this.c.registerApiCommand(P)}$willAddInteractiveDocument(R,p,E,m){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:p,lines:[""],languageId:E,uri:R,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(I.URI.revive(m))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,p){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$Sec=f}),define(ke[327],Se([1,0,6,7]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yec=void 0;class f{constructor(R){this.a=new Map,this.b=new Map,this.c=R.getProxy(I.$vK.MainThreadIssueReporter)}async $getIssueReporterUri(R,p){if(this.a.size===0)throw new Error("No issue request handlers registered");const E=this.a.get(R);if(!E)throw new Error("Issue request handler not found");const m=await E.handleIssueUrlRequest();if(!m)throw new Error("Issue request handler returned no result");return m}async $getIssueReporterData(R,p){if(this.b.size===0)throw new Error("No issue request handlers registered");const E=this.b.get(R);if(!E)throw new Error("Issue data provider not found");const m=await E.provideIssueData(p);if(!m)throw new Error("Issue data provider returned no result");return m}async $getIssueReporterTemplate(R,p){if(this.b.size===0)throw new Error("No issue request handlers registered");const E=this.b.get(R);if(!E)throw new Error("Issue data provider not found");const m=await E.provideIssueTemplate(p);if(!m)throw new Error("Issue template provider returned no result");return m}registerIssueUriRequestHandler(R,p){const E=R.identifier.value;return this.a.set(E,p),this.c.$registerIssueUriRequestHandler(E),new F.$xK(()=>{this.c.$unregisterIssueUriRequestHandler(E),this.a.delete(E)})}registerIssueDataProvider(R,p){const E=R.identifier.value;return this.b.set(E,p),this.c.$registerIssueDataProvider(E),new F.$xK(()=>{this.c.$unregisterIssueDataProvider(E),this.b.delete(E)})}}e.$Yec=f}),define(ke[328],Se([1,0,3,6]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_dc=void 0;class f{constructor(R){this.b=0,this.a=R.getProxy(F.$vK.MainThreadLabelService)}$registerResourceLabelFormatter(R){const p=this.b++;return this.a.$registerResourceLabelFormatter(p,R),(0,I.$Pc)(()=>{this.a.$unregisterResourceLabelFormatter(p)})}}e.$_dc=f}),define(ke[329],Se([1,0,2,24,14,7,84,6,13,29,19,18,169,21,26,3,132,122,110,37,11,10,25,214]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,S,w,c,s,i,n,o,a,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9cc=void 0;class d{constructor(B,Q){this.d=B,this.e=Q}async provideDocumentSymbols(B,Q){const re=this.d.getDocument(B),oe=await this.e.provideDocumentSymbols(re,Q);if(!(0,A.$Jb)(oe))return oe[0]instanceof L.$PK?oe.map(f.DocumentSymbol.from):d.f(oe)}static f(B){B=B.slice(0).sort((oe,_)=>{let me=oe.location.range.start.compareTo(_.location.range.start);return me===0&&(me=_.location.range.end.compareTo(oe.location.range.end)),me});const Q=[],re=[];for(const oe of B){const _={name:oe.name||"!!MISSING: name!!",kind:f.SymbolKind.from(oe.kind),tags:oe.tags?.map(f.SymbolTag.from)||[],detail:"",containerName:oe.containerName,range:f.Range.from(oe.location.range),selectionRange:f.Range.from(oe.location.range),children:[]};for(;;){if(re.length===0){re.push(_),Q.push(_);break}const me=re[re.length-1];if(m.$xs.containsRange(me.range,_.range)&&!m.$xs.equalsRange(me.range,_.range)){me.children?.push(_),re.push(_);break}re.pop()}}return Q}}class u{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(B,Q,re){this.g=B,this.h=Q,this.j=re,this.e=new i.$Zcc("CodeLens"),this.f=new Map}async provideCodeLenses(B,Q){const re=this.g.getDocument(B),oe=await this.j.provideCodeLenses(re,Q);if(!oe||Q.isCancellationRequested)return;const _=this.e.add(oe),me=new w.$Qc;this.f.set(_,me);const ye={cacheId:_,lenses:[]};for(let ze=0;ze<oe.length;ze++)ye.lenses.push({cacheId:[_,ze],range:f.Range.from(oe[ze].range),command:this.h.toInternal(oe[ze].command,me)});return ye}async resolveCodeLens(B,Q){const re=B.cacheId&&this.e.get(...B.cacheId);if(!re)return;let oe;if(typeof this.j.resolveCodeLens!="function"||re.isResolved?oe=re:oe=await this.j.resolveCodeLens(re,Q),oe||(oe=re),Q.isCancellationRequested)return;const _=B.cacheId&&this.f.get(B.cacheId[0]);if(_)return B.command=this.h.toInternal(oe.command??u.d,_),B}releaseCodeLenses(B){this.f.get(B)?.dispose(),this.f.delete(B),this.e.delete(B)}}function l(Pe){return Array.isArray(Pe)?Pe.map(f.DefinitionLink.from):Pe?[f.DefinitionLink.from(Pe)]:[]}class h{constructor(B,Q){this.d=B,this.e=Q}async provideDefinition(B,Q,re){const oe=this.d.getDocument(B),_=f.Position.to(Q),me=await this.e.provideDefinition(oe,_,re);return l(me)}}class k{constructor(B,Q){this.d=B,this.e=Q}async provideDeclaration(B,Q,re){const oe=this.d.getDocument(B),_=f.Position.to(Q),me=await this.e.provideDeclaration(oe,_,re);return l(me)}}class D{constructor(B,Q){this.d=B,this.e=Q}async provideImplementation(B,Q,re){const oe=this.d.getDocument(B),_=f.Position.to(Q),me=await this.e.provideImplementation(oe,_,re);return l(me)}}class ${constructor(B,Q){this.d=B,this.e=Q}async provideTypeDefinition(B,Q,re){const oe=this.d.getDocument(B),_=f.Position.to(Q),me=await this.e.provideTypeDefinition(oe,_,re);return l(me)}}class b{constructor(B,Q){this.d=B,this.e=Q}async provideHover(B,Q,re){const oe=this.d.getDocument(B),_=f.Position.to(Q),me=await this.e.provideHover(oe,_,re);if(!(!me||(0,A.$Jb)(me.contents)))return me.range||(me.range=oe.getWordRangeAtPosition(_)),me.range||(me.range=new L.$zK(_,_)),f.Hover.from(me)}}class v{constructor(B,Q){this.d=B,this.e=Q}async provideEvaluatableExpression(B,Q,re){const oe=this.d.getDocument(B),_=f.Position.to(Q),me=await this.e.provideEvaluatableExpression(oe,_,re);if(me)return f.EvaluatableExpression.from(me)}}class C{constructor(B,Q){this.d=B,this.e=Q}async provideInlineValues(B,Q,re,oe){const _=this.d.getDocument(B),me=await this.e.provideInlineValues(_,f.Range.to(Q),f.InlineValueContext.to(re),oe);if(Array.isArray(me))return me.map(ye=>f.InlineValue.from(ye))}}class N{constructor(B,Q){this.d=B,this.e=Q}async provideDocumentHighlights(B,Q,re){const oe=this.d.getDocument(B),_=f.Position.to(Q),me=await this.e.provideDocumentHighlights(oe,_,re);if(Array.isArray(me))return me.map(f.DocumentHighlight.from)}}class z{constructor(B,Q){this.d=B,this.e=Q}async provideLinkedEditingRanges(B,Q,re){const oe=this.d.getDocument(B),_=f.Position.to(Q),me=await this.e.provideLinkedEditingRanges(oe,_,re);if(me&&Array.isArray(me.ranges))return{ranges:(0,A.$Gb)(me.ranges.map(f.Range.from)),wordPattern:me.wordPattern}}}class M{constructor(B,Q){this.d=B,this.e=Q}async provideReferences(B,Q,re,oe){const _=this.d.getDocument(B),me=f.Position.to(Q),ye=await this.e.provideReferences(_,me,re,oe);if(Array.isArray(ye))return ye.map(f.location.from)}}class O{static{this.d=1e3}constructor(B,Q,re,oe,_,me,ye){this.g=B,this.h=Q,this.j=re,this.k=oe,this.l=_,this.m=me,this.n=ye,this.e=new i.$Zcc("CodeAction"),this.f=new Map}async provideCodeActions(B,Q,re,oe){const _=this.g.getDocument(B),me=g.$zs.isISelection(Q)?f.Selection.to(Q):f.Range.to(Q),ye=[];for(const tt of this.j.getDiagnostics(B))if(me.intersection(tt.range)&&ye.push(tt)>O.d)break;const ze={diagnostics:ye,only:re.only?new L.$RK(re.only):void 0,triggerKind:f.CodeActionTriggerKind.to(re.trigger)},We=await this.k.provideCodeActions(_,me,ze,oe);if(!(0,A.$Kb)(We)||oe.isCancellationRequested)return;const _e=this.e.add(We),Ye=new w.$Qc;this.f.set(_e,Ye);const it=[];for(let tt=0;tt<We.length;tt++){const Ae=We[tt];Ae&&(O.o(Ae)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),it.push({_isSynthetic:!0,title:Ae.title,command:this.h.toInternal(Ae,Ye)})):(ze.only&&(Ae.kind?ze.only.contains(Ae.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ze.only.value} 'requested but returned code action is of kind '${Ae.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ze.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),it.push({cacheId:[_e,tt],title:Ae.title,command:Ae.command&&this.h.toInternal(Ae.command,Ye),diagnostics:Ae.diagnostics&&Ae.diagnostics.map(f.Diagnostic.from),edit:Ae.edit&&f.WorkspaceEdit.from(Ae.edit,void 0),kind:Ae.kind&&Ae.kind.value,isPreferred:Ae.isPreferred,isAI:(0,t.$uF)(this.m,"codeActionAI")?Ae.isAI:!1,disabled:Ae.disabled?.reason})))}return{cacheId:_e,actions:it}}async resolveCodeAction(B,Q){const[re,oe]=B,_=this.e.get(re,oe);if(!_||O.o(_))return{};if(!this.k.resolveCodeAction)return{};const me=await this.k.resolveCodeAction(_,Q)??_;let ye;me.edit&&(ye=f.WorkspaceEdit.from(me.edit,void 0));let ze;if(me.command){const We=this.f.get(re);We&&(ze=this.h.toInternal(me.command,We))}return{edit:ye,command:ze}}releaseCodeActions(B){this.f.get(B)?.dispose(),this.f.delete(B),this.e.delete(B)}static o(B){return typeof B.command=="string"&&typeof B.title=="string"}}class j{static toInternalProviderId(B,Q){return B+"."+Q}constructor(B,Q,re,oe,_){this.d=B,this.e=Q,this.f=re,this.g=oe,this.h=_}async prepareDocumentPaste(B,Q,re,oe){if(!this.f.prepareDocumentPaste)return;const _=this.e.getDocument(B),me=Q.map(We=>f.Range.to(We)),ye=f.DataTransfer.toDataTransfer(re,()=>{throw new o.$0});if(await this.f.prepareDocumentPaste(_,me,ye,oe),oe.isCancellationRequested)return;const ze=Array.from(ye).filter(([,We])=>!(We instanceof L.$lL));return f.DataTransfer.from(ze)}async providePasteEdits(B,Q,re,oe,_){if(!this.f.provideDocumentPasteEdits)return;const me=this.e.getDocument(Q),ye=re.map(_e=>f.Range.to(_e)),ze=f.DataTransfer.toDataTransfer(oe,async _e=>(await this.d.$resolvePasteFileData(this.g,B,_e)).buffer),We=await this.f.provideDocumentPasteEdits(me,ye,ze,_);if(We)return{label:We.label??(0,r.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:We.yieldTo?.map(_e=>"mimeType"in _e?_e:{providerId:j.toInternalProviderId(_e.extensionId,_e.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?f.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class T{constructor(B,Q){this.d=B,this.e=Q}async provideDocumentFormattingEdits(B,Q,re){const oe=this.d.getDocument(B),_=await this.e.provideDocumentFormattingEdits(oe,Q,re);if(Array.isArray(_))return _.map(f.TextEdit.from)}}class V{constructor(B,Q){this.d=B,this.e=Q}async provideDocumentRangeFormattingEdits(B,Q,re,oe){const _=this.d.getDocument(B),me=f.Range.to(Q),ye=await this.e.provideDocumentRangeFormattingEdits(_,me,re,oe);if(Array.isArray(ye))return ye.map(f.TextEdit.from)}async provideDocumentRangesFormattingEdits(B,Q,re,oe){(0,P.$Jf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const _=this.d.getDocument(B),me=Q.map(f.Range.to),ye=await this.e.provideDocumentRangesFormattingEdits(_,me,re,oe);if(Array.isArray(ye))return ye.map(f.TextEdit.from)}}class q{constructor(B,Q){this.d=B,this.e=Q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(B,Q,re,oe,_){const me=this.d.getDocument(B),ye=f.Position.to(Q),ze=await this.e.provideOnTypeFormattingEdits(me,ye,re,oe,_);if(Array.isArray(ze))return ze.map(f.TextEdit.from)}}class fe{constructor(B,Q){this.e=B,this.f=Q,this.d=new i.$Zcc("WorkspaceSymbols")}async provideWorkspaceSymbols(B,Q){const re=await this.e.provideWorkspaceSymbols(B,Q);if(!(0,A.$Kb)(re))return{symbols:[]};const oe=this.d.add(re),_={cacheId:oe,symbols:[]};for(let me=0;me<re.length;me++){const ye=re[me];if(!ye||!ye.name){this.f.warn("INVALID SymbolInformation",ye);continue}_.symbols.push({...f.WorkspaceSymbol.from(ye),cacheId:[oe,me]})}return _}async resolveWorkspaceSymbol(B,Q){if(typeof this.e.resolveWorkspaceSymbol!="function"||!B.cacheId)return B;const re=this.d.get(...B.cacheId);if(re){const oe=await this.e.resolveWorkspaceSymbol(re,Q);return oe&&(0,F.$bn)(B,f.WorkspaceSymbol.from(oe),!0)}}releaseWorkspaceSymbols(B){this.d.delete(B)}}class ee{static supportsResolving(B){return typeof B.prepareRename=="function"}constructor(B,Q,re){this.d=B,this.e=Q,this.f=re}async provideRenameEdits(B,Q,re,oe){const _=this.d.getDocument(B),me=f.Position.to(Q);try{const ye=await this.e.provideRenameEdits(_,me,re,oe);return ye?f.WorkspaceEdit.from(ye):void 0}catch(ye){const ze=ee.g(ye);return ze?{rejectReason:ze,edits:void 0}:Promise.reject(ye)}}async resolveRenameLocation(B,Q,re){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const oe=this.d.getDocument(B),_=f.Position.to(Q);try{const me=await this.e.prepareRename(oe,_,re);let ye,ze;if(L.$zK.isRange(me)?(ye=me,ze=oe.getText(me)):(0,P.$Bf)(me)&&(ye=me.range,ze=me.placeholder),!ye||!ze)return;if(ye.start.line>_.line||ye.end.line<_.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:f.Range.from(ye),text:ze}}catch(me){const ye=ee.g(me);return ye?{rejectReason:ye,range:void 0,text:void 0}:Promise.reject(me)}}static g(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class Y{constructor(B,Q){this.resultId=B,this.tokens=Q}}class X{constructor(B,Q){this.f=B,this.g=Q,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(B,Q,re){const oe=this.f.getDocument(B),_=Q!==0?this.d.get(Q):null;let me=typeof _?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(oe,_.resultId,re):await this.g.provideDocumentSemanticTokens(oe,re);return _&&this.d.delete(Q),me?(me=X.h(me),this.o(X.n(_,me),me)):null}async releaseDocumentSemanticColoring(B){this.d.delete(B)}static h(B){return X.j(B)?X.k(B)?B:new L.$OL(new Uint32Array(B.data),B.resultId):X.l(B)?X.m(B)?B:new L.$QL(B.edits.map(Q=>new L.$PL(Q.start,Q.deleteCount,Q.data?new Uint32Array(Q.data):Q.data)),B.resultId):B}static j(B){return B&&!!B.data}static k(B){return B.data instanceof Uint32Array}static l(B){return B&&Array.isArray(B.edits)}static m(B){for(const Q of B.edits)if(!(Q.data instanceof Uint32Array))return!1;return!0}static n(B,Q){if(!X.j(Q)||!B||!B.tokens)return Q;const re=B.tokens,oe=re.length,_=Q.data,me=_.length;let ye=0;const ze=Math.min(oe,me);for(;ye<ze&&re[ye]===_[ye];)ye++;if(ye===oe&&ye===me)return new L.$QL([],Q.resultId);let We=0;const _e=ze-ye;for(;We<_e&&re[oe-We-1]===_[me-We-1];)We++;return new L.$QL([{start:ye,deleteCount:oe-ye-We,data:_.subarray(ye,me-We)}],Q.resultId)}o(B,Q){if(X.j(B)){const re=this.e++;return this.d.set(re,new Y(B.resultId,B.data)),(0,c.$t$)({id:re,type:"full",data:B.data})}if(X.l(B)){const re=this.e++;return X.j(Q)?this.d.set(re,new Y(Q.resultId,Q.data)):this.d.set(re,new Y(B.resultId)),(0,c.$t$)({id:re,type:"delta",deltas:(B.edits||[]).map(oe=>({start:oe.start,deleteCount:oe.deleteCount,data:oe.data}))})}return null}}class ae{constructor(B,Q){this.d=B,this.e=Q}async provideDocumentRangeSemanticTokens(B,Q,re){const oe=this.d.getDocument(B),_=await this.e.provideDocumentRangeSemanticTokens(oe,f.Range.to(Q),re);return _?this.f(_):null}f(B){return(0,c.$t$)({id:0,type:"full",data:B.data})}}class Z{static supportsResolving(B){return typeof B.resolveCompletionItem=="function"}constructor(B,Q,re,oe,_){this.f=B,this.g=Q,this.h=re,this.j=oe,this.k=_,this.d=new i.$Zcc("CompletionItem"),this.e=new Map}async provideCompletionItems(B,Q,re,oe){const _=this.f.getDocument(B),me=f.Position.to(Q),ye=_.getWordRangeAtPosition(me)||new L.$zK(me,me),ze=ye.with({end:me}),We=new n.$Kd,_e=await this.h.provideCompletionItems(_,me,oe,f.CompletionContext.to(re));if(!_e||oe.isCancellationRequested)return;const Ye=Array.isArray(_e)?new L.$5K(_e):_e,it=Z.supportsResolving(this.h)?this.d.add(Ye.items):this.d.add([]),tt=new w.$Qc;this.e.set(it,tt);const Ae=[],Oe={x:it,b:Ae,a:{replace:f.Range.from(ye),insert:f.Range.from(ze)},c:Ye.isIncomplete||void 0,d:We.elapsed()};for(let Ve=0;Ve<Ye.items.length;Ve++){const Re=Ye.items[Ve],Xe=this.l(Re,[it,Ve],ze,ye);Ae.push(Xe)}return Oe}async resolveCompletionItem(B,Q){if(typeof this.h.resolveCompletionItem!="function")return;const re=this.d.get(...B);if(!re)return;const oe=this.l(re,B),_=await this.h.resolveCompletionItem(re,Q);if(!_)return;const me=this.l(_,B);return(oe.h!==me.h||oe.i!==me.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(oe.n!==me.n||oe.o!==me.o||!(0,F.$cn)(oe.p,me.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...oe,d:me.d,c:me.c,l:me.l,h:me.h,i:me.i,n:me.n,o:me.o,p:me.p}}releaseCompletionItems(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,Q,re,oe){const _=this.e.get(Q[0]);if(!_)throw Error("DisposableStore is missing...");const me=this.g.toInternal(B.command,_),ye={x:Q,a:B.label,b:B.kind!==void 0?f.CompletionItemKind.from(B.kind):void 0,m:B.tags&&B.tags.map(f.CompletionItemTag.from),c:B.detail,d:typeof B.documentation>"u"?void 0:f.MarkdownString.fromStrict(B.documentation),e:B.sortText!==B.label?B.sortText:void 0,f:B.filterText!==B.label?B.filterText:void 0,g:B.preselect||void 0,i:B.keepWhitespace?1:0,k:B.commitCharacters?.join(""),l:B.additionalTextEdits&&B.additionalTextEdits.map(f.TextEdit.from),n:me?.$ident,o:me?.id,p:me?.$ident?void 0:me?.arguments};B.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ye.h=B.textEdit.newText):typeof B.insertText=="string"?ye.h=B.insertText:B.insertText instanceof L.$IK&&(ye.h=B.insertText.value,ye.i|=4);let ze;return B.textEdit?ze=B.textEdit.range:B.range&&(ze=B.range),L.$zK.isRange(ze)?ye.j=f.Range.from(ze):ze&&(!re?.isEqual(ze.inserting)||!oe?.isEqual(ze.replacing))&&(ye.j={insert:f.Range.from(ze.inserting),replace:f.Range.from(ze.replacing)}),ye}}class se{async provideInlineCompletions(B,Q,re,oe){}disposeCompletions(B){}handleDidShowCompletionItem(B,Q,re){}handlePartialAccept(B,Q,re){}}class we extends se{constructor(B,Q,re,oe){super(),this.f=B,this.g=Q,this.h=re,this.j=oe,this.d=new H,this.e=(0,t.$uF)(this.f,"inlineCompletionsAdditions"),this.k={[R.InlineCompletionTriggerKind.Automatic]:L.InlineCompletionTriggerKind.Automatic,[R.InlineCompletionTriggerKind.Explicit]:L.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$uF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(B,Q,re,oe){const _=this.g.getDocument(B),me=f.Position.to(Q),ye=await this.h.provideInlineCompletionItems(_,me,{selectedCompletionInfo:re.selectedSuggestionInfo?{range:f.Range.to(re.selectedSuggestionInfo.range),text:re.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[re.triggerKind]},oe);if(!ye||oe.isCancellationRequested)return;const ze=Array.isArray(ye)?ye:ye.items,We=this.e?Array.isArray(ye)?[]:ye.commands||[]:[],_e=this.e&&!Array.isArray(ye)?ye.enableForwardStability:void 0;let Ye;return{pid:this.d.createReferenceId({dispose(){Ye?.dispose()},items:ze}),items:ze.map((tt,Ae)=>{let Oe;tt.command&&(Ye||(Ye=new w.$Qc),Oe=this.j.toInternal(tt.command,Ye));const Ve=tt.insertText;return{insertText:typeof Ve=="string"?Ve:{snippet:Ve.value},filterText:tt.filterText,range:tt.range?f.Range.from(tt.range):void 0,command:Oe,idx:Ae,completeBracketPairs:this.e?tt.completeBracketPairs:!1}}),commands:We.map(tt=>(Ye||(Ye=new w.$Qc),this.j.toInternal(tt,Ye))),suppressSuggestions:!1,enableForwardStability:_e}}disposeCompletions(B){this.d.disposeReferenceId(B)?.dispose()}handleDidShowCompletionItem(B,Q,re){const oe=this.d.get(B)?.items[Q];oe&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(oe,re)}handlePartialAccept(B,Q,re){const oe=this.d.get(B)?.items[Q];oe&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(oe,re)}}class H{constructor(){this.d=new Map,this.e=1}createReferenceId(B){const Q=this.e++;return this.d.set(Q,B),Q}disposeReferenceId(B){const Q=this.d.get(B);return this.d.delete(B),Q}get(B){return this.d.get(B)}}class U{constructor(B,Q){this.e=B,this.f=Q,this.d=new i.$Zcc("SignatureHelp")}async provideSignatureHelp(B,Q,re,oe){const _=this.e.getDocument(B),me=f.Position.to(Q),ye=this.g(re),ze=await this.f.provideSignatureHelp(_,me,oe,ye);if(ze){const We=this.d.add([ze]);return{...f.SignatureHelp.from(ze),id:We}}}g(B){let Q;if(B.activeSignatureHelp){const re=f.SignatureHelp.to(B.activeSignatureHelp),oe=this.d.get(B.activeSignatureHelp.id,0);oe?(Q=oe,Q.activeSignature=re.activeSignature,Q.activeParameter=re.activeParameter):Q=re}return{...B,activeSignatureHelp:Q}}releaseSignatureHelp(B){this.d.delete(B)}}class ce{constructor(B,Q,re,oe,_){this.f=B,this.g=Q,this.h=re,this.j=oe,this.k=_,this.d=new i.$Zcc("InlayHints"),this.e=new Map}async provideInlayHints(B,Q,re){const oe=this.f.getDocument(B),_=f.Range.to(Q),me=await this.h.provideInlayHints(oe,_,re);if(!Array.isArray(me)||me.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${Q}`);return}if(re.isCancellationRequested)return;const ye=this.d.add(me);this.e.set(ye,new w.$Qc);const ze={hints:[],cacheId:ye};for(let We=0;We<me.length;We++)this.l(me[We],_)&&ze.hints.push(this.m(me[We],[ye,We]));return this.j.trace(`[InlayHints] ${ze.hints.length} inlay hints from '${this.k.identifier.value}' for ${Q}`),ze}async resolveInlayHint(B,Q){if(typeof this.h.resolveInlayHint!="function")return;const re=this.d.get(...B);if(!re)return;const oe=await this.h.resolveInlayHint(re,Q);if(oe&&this.l(oe))return this.m(oe,B)}releaseHints(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,Q){return B.label.length===0||Array.isArray(B.label)&&B.label.every(re=>re.value.length===0)?(console.log("INVALID inlay hint, empty label",B),!1):!(Q&&!Q.contains(B.position))}m(B,Q){const re=this.e.get(Q[0]);if(!re)throw Error("DisposableStore is missing...");const oe={label:"",cacheId:Q,tooltip:f.MarkdownString.fromStrict(B.tooltip),position:f.Position.from(B.position),textEdits:B.textEdits&&B.textEdits.map(f.TextEdit.from),kind:B.kind&&f.InlayHintKind.from(B.kind),paddingLeft:B.paddingLeft,paddingRight:B.paddingRight};return typeof B.label=="string"?oe.label=B.label:oe.label=B.label.map(_=>{const me={label:_.value};return me.tooltip=f.MarkdownString.fromStrict(_.tooltip),L.$JK.isLocation(_.location)&&(me.location=f.location.from(_.location)),_.command&&(me.command=this.g.toInternal(_.command,re)),me}),oe}}class Ee{constructor(B,Q){this.e=B,this.f=Q,this.d=new i.$Zcc("DocumentLink")}async provideLinks(B,Q){const re=this.e.getDocument(B),oe=await this.f.provideDocumentLinks(re,Q);if(!(!Array.isArray(oe)||oe.length===0)&&!Q.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:oe.filter(Ee.g).map(f.DocumentLink.from)};{const _=this.d.add(oe),me={links:[],cacheId:_};for(let ye=0;ye<oe.length;ye++){if(!Ee.g(oe[ye]))continue;const ze=f.DocumentLink.from(oe[ye]);ze.cacheId=[_,ye],me.links.push(ze)}return me}}}static g(B){return B.target&&B.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(B,Q){if(typeof this.f.resolveDocumentLink!="function")return;const re=this.d.get(...B);if(!re)return;const oe=await this.f.resolveDocumentLink(re,Q);if(!(!oe||!Ee.g(oe)))return f.DocumentLink.from(oe)}releaseLinks(B){this.d.delete(B)}}class ne{constructor(B,Q){this.d=B,this.e=Q}async provideColors(B,Q){const re=this.d.getDocument(B),oe=await this.e.provideDocumentColors(re,Q);return Array.isArray(oe)?oe.map(me=>({color:f.Color.from(me.color),range:f.Range.from(me.range)})):[]}async provideColorPresentations(B,Q,re){const oe=this.d.getDocument(B),_=f.Range.to(Q.range),me=f.Color.to(Q.color),ye=await this.e.provideColorPresentations(me,{document:oe,range:_},re);if(Array.isArray(ye))return ye.map(f.ColorPresentation.from)}}class G{constructor(B,Q){this.d=B,this.e=Q}async provideFoldingRanges(B,Q,re){const oe=this.d.getDocument(B),_=await this.e.provideFoldingRanges(oe,Q,re);if(Array.isArray(_))return _.map(f.FoldingRange.from)}}class J{constructor(B,Q,re){this.d=B,this.e=Q,this.f=re}async provideSelectionRanges(B,Q,re){const oe=this.d.getDocument(B),_=Q.map(f.Position.to),me=await this.e.provideSelectionRanges(oe,_,re);if(!(0,A.$Kb)(me))return[];if(me.length!==_.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ye=[];for(let ze=0;ze<_.length;ze++){const We=[];ye.push(We);let _e=_[ze],Ye=me[ze];for(;;){if(!Ye.range.contains(_e))throw new Error("INVALID selection range, must contain the previous range");if(We.push(f.SelectionRange.from(Ye)),!Ye.parent)break;_e=Ye.range,Ye=Ye.parent}}return ye}}class ge{constructor(B,Q){this.f=B,this.g=Q,this.d=new s.$CM(""),this.e=new Map}async prepareSession(B,Q,re){const oe=this.f.getDocument(B),_=f.Position.to(Q),me=await this.g.prepareCallHierarchy(oe,_,re);if(!me)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(me)?me.map(ze=>this.h(ye,ze)):[this.h(ye,me)]}async provideCallsTo(B,Q,re){const oe=this.j(B,Q);if(!oe)throw new Error("missing call hierarchy item");const _=await this.g.provideCallHierarchyIncomingCalls(oe,re);if(_)return _.map(me=>({from:this.h(B,me.from),fromRanges:me.fromRanges.map(ye=>f.Range.from(ye))}))}async provideCallsFrom(B,Q,re){const oe=this.j(B,Q);if(!oe)throw new Error("missing call hierarchy item");const _=await this.g.provideCallHierarchyOutgoingCalls(oe,re);if(_)return _.map(me=>({to:this.h(B,me.to),fromRanges:me.fromRanges.map(ye=>f.Range.from(ye))}))}releaseSession(B){this.e.delete(B)}h(B,Q){const re=this.e.get(B),oe=f.CallHierarchyItem.from(Q,B,re.size.toString(36));return re.set(oe._itemId,Q),oe}j(B,Q){return this.e.get(B)?.get(Q)}}class x{constructor(B,Q){this.f=B,this.g=Q,this.d=new s.$CM(""),this.e=new Map}async prepareSession(B,Q,re){const oe=this.f.getDocument(B),_=f.Position.to(Q),me=await this.g.prepareTypeHierarchy(oe,_,re);if(!me)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(me)?me.map(ze=>this.h(ye,ze)):[this.h(ye,me)]}async provideSupertypes(B,Q,re){const oe=this.j(B,Q);if(!oe)throw new Error("missing type hierarchy item");const _=await this.g.provideTypeHierarchySupertypes(oe,re);if(_)return _.map(me=>this.h(B,me))}async provideSubtypes(B,Q,re){const oe=this.j(B,Q);if(!oe)throw new Error("missing type hierarchy item");const _=await this.g.provideTypeHierarchySubtypes(oe,re);if(_)return _.map(me=>this.h(B,me))}releaseSession(B){this.e.delete(B)}h(B,Q){const re=this.e.get(B),oe=f.TypeHierarchyItem.from(Q,B,re.size.toString(36));return re.set(oe._itemId,Q),oe}j(B,Q){return this.e.get(B)?.get(Q)}}class le{static toInternalProviderId(B,Q){return B+"."+Q}constructor(B,Q,re,oe,_){this.d=B,this.e=Q,this.f=re,this.g=oe,this.h=_}async provideDocumentOnDropEdits(B,Q,re,oe,_){const me=this.e.getDocument(Q),ye=f.Position.to(re),ze=f.DataTransfer.toDataTransfer(oe,async _e=>(await this.d.$resolveDocumentOnDropFileData(this.g,B,_e)).buffer),We=await this.f.provideDocumentDropEdits(me,ye,ze,_);if(We)return{label:We.label??(0,r.localize)(1,null,this.h.displayName||this.h.name),yieldTo:We.yieldTo?.map(_e=>"mimeType"in _e?_e:{providerId:le.toInternalProviderId(_e.extensionId,_e.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?f.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class te{constructor(B,Q){this.d=B,this.e=Q}async provideMappedEdits(B,Q,re,oe){const _=I.URI.revive(B),me=this.d.getDocument(_),ye=re.documents.map(_e=>_e.map(Ye=>({uri:I.URI.revive(Ye.uri),version:Ye.version,ranges:Ye.ranges.map(it=>f.Range.to(it))}))),ze={documents:ye,selections:ye[0]?.[0]?.ranges??[]},We=await this.e.provideMappedEdits(me,Q,ze,oe);return We?f.WorkspaceEdit.from(We):null}}class de{constructor(B,Q){this.adapter=B,this.extension=Q}}class be{static{this.d=0}constructor(B,Q,re,oe,_,me,ye,ze){this.g=Q,this.h=re,this.j=oe,this.k=_,this.l=me,this.m=ye,this.n=ze,this.f=new Map,this.e=B.getProxy(p.$vK.MainThreadLanguageFeatures)}o(B,Q){return f.DocumentSelector.from(B,this.g,Q)}p(B){return new L.$xK(()=>{this.f.delete(B),this.e.$unregister(B)})}q(){return be.d++}async s(B,Q,re,oe,_,me=!1){const ye=this.f.get(B);if(!ye||!(ye.adapter instanceof Q))return oe;const ze=Date.now();me||this.l.trace(`[${ye.extension.identifier.value}] INVOKE provider '${re.toString().replace(/[\r\n]/g,"")}'`);const We=re(ye.adapter,ye.extension);return Promise.resolve(We).catch(_e=>{(0,o.$3)(_e)||(this.l.error(`[${ye.extension.identifier.value}] provider FAILED`),this.l.error(_e),this.n.onExtensionError(ye.extension.identifier,_e))}).finally(()=>{me||this.l.trace(`[${ye.extension.identifier.value}] provider DONE after ${Date.now()-ze}ms`)}),y.CancellationToken.isCancellationToken(_)?(0,a.$Kg)(We,_):We}t(B,Q){const re=this.q();return this.f.set(re,new de(B,Q)),re}static u(B){return B.displayName||B.name}registerDocumentSymbolProvider(B,Q,re,oe){const _=this.t(new d(this.h,re),B),me=oe&&oe.label||be.u(B);return this.e.$registerDocumentSymbolProvider(_,this.o(Q,B),me),this.p(_)}$provideDocumentSymbols(B,Q,re){return this.s(B,d,oe=>oe.provideDocumentSymbols(I.URI.revive(Q),re),void 0,re)}registerCodeLensProvider(B,Q,re){const oe=this.q(),_=typeof re.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(oe,new de(new u(this.h,this.j.converter,re),B)),this.e.$registerCodeLensSupport(oe,this.o(Q,B),_);let me=this.p(oe);if(_!==void 0){const ye=re.onDidChangeCodeLenses(ze=>this.e.$emitCodeLensEvent(_));me=L.$xK.from(me,ye)}return me}$provideCodeLenses(B,Q,re){return this.s(B,u,oe=>oe.provideCodeLenses(I.URI.revive(Q),re),void 0,re)}$resolveCodeLens(B,Q,re){return this.s(B,u,oe=>oe.resolveCodeLens(Q,re),void 0,void 0)}$releaseCodeLenses(B,Q){this.s(B,u,re=>Promise.resolve(re.releaseCodeLenses(Q)),void 0,void 0)}registerDefinitionProvider(B,Q,re){const oe=this.t(new h(this.h,re),B);return this.e.$registerDefinitionSupport(oe,this.o(Q,B)),this.p(oe)}$provideDefinition(B,Q,re,oe){return this.s(B,h,_=>_.provideDefinition(I.URI.revive(Q),re,oe),[],oe)}registerDeclarationProvider(B,Q,re){const oe=this.t(new k(this.h,re),B);return this.e.$registerDeclarationSupport(oe,this.o(Q,B)),this.p(oe)}$provideDeclaration(B,Q,re,oe){return this.s(B,k,_=>_.provideDeclaration(I.URI.revive(Q),re,oe),[],oe)}registerImplementationProvider(B,Q,re){const oe=this.t(new D(this.h,re),B);return this.e.$registerImplementationSupport(oe,this.o(Q,B)),this.p(oe)}$provideImplementation(B,Q,re,oe){return this.s(B,D,_=>_.provideImplementation(I.URI.revive(Q),re,oe),[],oe)}registerTypeDefinitionProvider(B,Q,re){const oe=this.t(new $(this.h,re),B);return this.e.$registerTypeDefinitionSupport(oe,this.o(Q,B)),this.p(oe)}$provideTypeDefinition(B,Q,re,oe){return this.s(B,$,_=>_.provideTypeDefinition(I.URI.revive(Q),re,oe),[],oe)}registerHoverProvider(B,Q,re,oe){const _=this.t(new b(this.h,re),B);return this.e.$registerHoverProvider(_,this.o(Q,B)),this.p(_)}$provideHover(B,Q,re,oe){return this.s(B,b,_=>_.provideHover(I.URI.revive(Q),re,oe),void 0,oe)}registerEvaluatableExpressionProvider(B,Q,re,oe){const _=this.t(new v(this.h,re),B);return this.e.$registerEvaluatableExpressionProvider(_,this.o(Q,B)),this.p(_)}$provideEvaluatableExpression(B,Q,re,oe){return this.s(B,v,_=>_.provideEvaluatableExpression(I.URI.revive(Q),re,oe),void 0,oe)}registerInlineValuesProvider(B,Q,re,oe){const _=typeof re.onDidChangeInlineValues=="function"?this.q():void 0,me=this.t(new C(this.h,re),B);this.e.$registerInlineValuesProvider(me,this.o(Q,B),_);let ye=this.p(me);if(_!==void 0){const ze=re.onDidChangeInlineValues(We=>this.e.$emitInlineValuesEvent(_));ye=L.$xK.from(ye,ze)}return ye}$provideInlineValues(B,Q,re,oe,_){return this.s(B,C,me=>me.provideInlineValues(I.URI.revive(Q),re,oe,_),void 0,_)}registerDocumentHighlightProvider(B,Q,re){const oe=this.t(new N(this.h,re),B);return this.e.$registerDocumentHighlightProvider(oe,this.o(Q,B)),this.p(oe)}$provideDocumentHighlights(B,Q,re,oe){return this.s(B,N,_=>_.provideDocumentHighlights(I.URI.revive(Q),re,oe),void 0,oe)}registerLinkedEditingRangeProvider(B,Q,re){const oe=this.t(new z(this.h,re),B);return this.e.$registerLinkedEditingRangeProvider(oe,this.o(Q,B)),this.p(oe)}$provideLinkedEditingRanges(B,Q,re,oe){return this.s(B,z,async _=>{const me=await _.provideLinkedEditingRanges(I.URI.revive(Q),re,oe);if(me)return{ranges:me.ranges,wordPattern:me.wordPattern?be.w(me.wordPattern):void 0}},void 0,oe)}registerReferenceProvider(B,Q,re){const oe=this.t(new M(this.h,re),B);return this.e.$registerReferenceSupport(oe,this.o(Q,B)),this.p(oe)}$provideReferences(B,Q,re,oe,_){return this.s(B,M,me=>me.provideReferences(I.URI.revive(Q),re,oe,_),void 0,_)}registerCodeActionProvider(B,Q,re,oe){const _=new w.$Qc,me=this.t(new O(this.h,this.j.converter,this.k,re,this.l,B,this.m),B);return this.e.$registerQuickFixSupport(me,this.o(Q,B),{providedKinds:oe?.providedCodeActionKinds?.map(ye=>ye.value),documentation:oe?.documentation?.map(ye=>({kind:ye.kind.value,command:this.j.converter.toInternal(ye.command,_)}))},be.u(B),!!re.resolveCodeAction),_.add(this.p(me)),_}$provideCodeActions(B,Q,re,oe,_){return this.s(B,O,me=>me.provideCodeActions(I.URI.revive(Q),re,oe,_),void 0,_)}$resolveCodeAction(B,Q,re){return this.s(B,O,oe=>oe.resolveCodeAction(Q,re),{},void 0)}$releaseCodeActions(B,Q){this.s(B,O,re=>Promise.resolve(re.releaseCodeActions(Q)),void 0,void 0)}registerDocumentFormattingEditProvider(B,Q,re){const oe=this.t(new T(this.h,re),B);return this.e.$registerDocumentFormattingSupport(oe,this.o(Q,B),B.identifier,B.displayName||B.name),this.p(oe)}$provideDocumentFormattingEdits(B,Q,re,oe){return this.s(B,T,_=>_.provideDocumentFormattingEdits(I.URI.revive(Q),re,oe),void 0,oe)}registerDocumentRangeFormattingEditProvider(B,Q,re){const oe=typeof re.provideDocumentRangesFormattingEdits=="function",_=this.t(new V(this.h,re),B);return this.e.$registerRangeFormattingSupport(_,this.o(Q,B),B.identifier,B.displayName||B.name,oe),this.p(_)}$provideDocumentRangeFormattingEdits(B,Q,re,oe,_){return this.s(B,V,me=>me.provideDocumentRangeFormattingEdits(I.URI.revive(Q),re,oe,_),void 0,_)}$provideDocumentRangesFormattingEdits(B,Q,re,oe,_){return this.s(B,V,me=>me.provideDocumentRangesFormattingEdits(I.URI.revive(Q),re,oe,_),void 0,_)}registerOnTypeFormattingEditProvider(B,Q,re,oe){const _=this.t(new q(this.h,re),B);return this.e.$registerOnTypeFormattingSupport(_,this.o(Q,B),oe,B.identifier),this.p(_)}$provideOnTypeFormattingEdits(B,Q,re,oe,_,me){return this.s(B,q,ye=>ye.provideOnTypeFormattingEdits(I.URI.revive(Q),re,oe,_,me),void 0,me)}registerWorkspaceSymbolProvider(B,Q){const re=this.t(new fe(Q,this.l),B);return this.e.$registerNavigateTypeSupport(re,typeof Q.resolveWorkspaceSymbol=="function"),this.p(re)}$provideWorkspaceSymbols(B,Q,re){return this.s(B,fe,oe=>oe.provideWorkspaceSymbols(Q,re),{symbols:[]},re)}$resolveWorkspaceSymbol(B,Q,re){return this.s(B,fe,oe=>oe.resolveWorkspaceSymbol(Q,re),void 0,void 0)}$releaseWorkspaceSymbols(B,Q){this.s(B,fe,re=>re.releaseWorkspaceSymbols(Q),void 0,void 0)}registerRenameProvider(B,Q,re){const oe=this.t(new ee(this.h,re,this.l),B);return this.e.$registerRenameSupport(oe,this.o(Q,B),ee.supportsResolving(re)),this.p(oe)}$provideRenameEdits(B,Q,re,oe,_){return this.s(B,ee,me=>me.provideRenameEdits(I.URI.revive(Q),re,oe,_),void 0,_)}$resolveRenameLocation(B,Q,re,oe){return this.s(B,ee,_=>_.resolveRenameLocation(I.URI.revive(Q),re,oe),void 0,oe)}registerDocumentSemanticTokensProvider(B,Q,re,oe){const _=this.t(new X(this.h,re),B),me=typeof re.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(_,this.o(Q,B),oe,me);let ye=this.p(_);if(me){const ze=re.onDidChangeSemanticTokens(We=>this.e.$emitDocumentSemanticTokensEvent(me));ye=L.$xK.from(ye,ze)}return ye}$provideDocumentSemanticTokens(B,Q,re,oe){return this.s(B,X,_=>_.provideDocumentSemanticTokens(I.URI.revive(Q),re,oe),null,oe)}$releaseDocumentSemanticTokens(B,Q){this.s(B,X,re=>re.releaseDocumentSemanticColoring(Q),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(B,Q,re,oe){const _=this.t(new ae(this.h,re),B);return this.e.$registerDocumentRangeSemanticTokensProvider(_,this.o(Q,B),oe),this.p(_)}$provideDocumentRangeSemanticTokens(B,Q,re,oe){return this.s(B,ae,_=>_.provideDocumentRangeSemanticTokens(I.URI.revive(Q),re,oe),null,oe)}registerCompletionItemProvider(B,Q,re,oe){const _=this.t(new Z(this.h,this.j.converter,re,this.m,B),B);return this.e.$registerCompletionsProvider(_,this.o(Q,B),oe,Z.supportsResolving(re),B.identifier),this.p(_)}$provideCompletionItems(B,Q,re,oe,_){return this.s(B,Z,me=>me.provideCompletionItems(I.URI.revive(Q),re,oe,_),void 0,_)}$resolveCompletionItem(B,Q,re){return this.s(B,Z,oe=>oe.resolveCompletionItem(Q,re),void 0,re)}$releaseCompletionItems(B,Q){this.s(B,Z,re=>re.releaseCompletionItems(Q),void 0,void 0)}registerInlineCompletionsProvider(B,Q,re,oe){const _=new we(B,this.h,re,this.j.converter),me=this.t(_,B);return this.e.$registerInlineCompletionsSupport(me,this.o(Q,B),_.supportsHandleEvents,S.$0l.toKey(B.identifier.value),oe?.yieldTo?.map(ye=>S.$0l.toKey(ye))||[]),this.p(me)}$provideInlineCompletions(B,Q,re,oe,_){return this.s(B,se,me=>me.provideInlineCompletions(I.URI.revive(Q),re,oe,_),void 0,_)}$handleInlineCompletionDidShow(B,Q,re,oe){this.s(B,se,async _=>{_.handleDidShowCompletionItem(Q,re,oe)},void 0,void 0)}$handleInlineCompletionPartialAccept(B,Q,re,oe){this.s(B,se,async _=>{_.handlePartialAccept(Q,re,oe)},void 0,void 0)}$freeInlineCompletionsList(B,Q){this.s(B,se,async re=>{re.disposeCompletions(Q)},void 0,void 0)}registerSignatureHelpProvider(B,Q,re,oe){const _=Array.isArray(oe)?{triggerCharacters:oe,retriggerCharacters:[]}:oe,me=this.t(new U(this.h,re),B);return this.e.$registerSignatureHelpProvider(me,this.o(Q,B),_),this.p(me)}$provideSignatureHelp(B,Q,re,oe,_){return this.s(B,U,me=>me.provideSignatureHelp(I.URI.revive(Q),re,oe,_),void 0,_)}$releaseSignatureHelp(B,Q){this.s(B,U,re=>re.releaseSignatureHelp(Q),void 0,void 0)}registerInlayHintsProvider(B,Q,re){const oe=typeof re.onDidChangeInlayHints=="function"?this.q():void 0,_=this.t(new ce(this.h,this.j.converter,re,this.l,B),B);this.e.$registerInlayHintsProvider(_,this.o(Q,B),typeof re.resolveInlayHint=="function",oe,be.u(B));let me=this.p(_);if(oe!==void 0){const ye=re.onDidChangeInlayHints(ze=>this.e.$emitInlayHintsEvent(oe));me=L.$xK.from(me,ye)}return me}$provideInlayHints(B,Q,re,oe){return this.s(B,ce,_=>_.provideInlayHints(I.URI.revive(Q),re,oe),void 0,oe)}$resolveInlayHint(B,Q,re){return this.s(B,ce,oe=>oe.resolveInlayHint(Q,re),void 0,re)}$releaseInlayHints(B,Q){this.s(B,ce,re=>re.releaseHints(Q),void 0,void 0)}registerDocumentLinkProvider(B,Q,re){const oe=this.t(new Ee(this.h,re),B);return this.e.$registerDocumentLinkProvider(oe,this.o(Q,B),typeof re.resolveDocumentLink=="function"),this.p(oe)}$provideDocumentLinks(B,Q,re){return this.s(B,Ee,oe=>oe.provideLinks(I.URI.revive(Q),re),void 0,re,Q.scheme==="output")}$resolveDocumentLink(B,Q,re){return this.s(B,Ee,oe=>oe.resolveLink(Q,re),void 0,void 0,!0)}$releaseDocumentLinks(B,Q){this.s(B,Ee,re=>re.releaseLinks(Q),void 0,void 0,!0)}registerColorProvider(B,Q,re){const oe=this.t(new ne(this.h,re),B);return this.e.$registerDocumentColorProvider(oe,this.o(Q,B)),this.p(oe)}$provideDocumentColors(B,Q,re){return this.s(B,ne,oe=>oe.provideColors(I.URI.revive(Q),re),[],re)}$provideColorPresentations(B,Q,re,oe){return this.s(B,ne,_=>_.provideColorPresentations(I.URI.revive(Q),re,oe),void 0,oe)}registerFoldingRangeProvider(B,Q,re){const oe=this.q(),_=typeof re.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(oe,new de(new G(this.h,re),B)),this.e.$registerFoldingRangeProvider(oe,this.o(Q,B),B.identifier,_);let me=this.p(oe);if(_!==void 0){const ye=re.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(_));me=L.$xK.from(me,ye)}return me}$provideFoldingRanges(B,Q,re,oe){return this.s(B,G,_=>_.provideFoldingRanges(I.URI.revive(Q),re,oe),void 0,oe)}registerSelectionRangeProvider(B,Q,re){const oe=this.t(new J(this.h,re,this.l),B);return this.e.$registerSelectionRangeProvider(oe,this.o(Q,B)),this.p(oe)}$provideSelectionRanges(B,Q,re,oe){return this.s(B,J,_=>_.provideSelectionRanges(I.URI.revive(Q),re,oe),[],oe)}registerCallHierarchyProvider(B,Q,re){const oe=this.t(new ge(this.h,re),B);return this.e.$registerCallHierarchyProvider(oe,this.o(Q,B)),this.p(oe)}$prepareCallHierarchy(B,Q,re,oe){return this.s(B,ge,_=>Promise.resolve(_.prepareSession(I.URI.revive(Q),re,oe)),void 0,oe)}$provideCallHierarchyIncomingCalls(B,Q,re,oe){return this.s(B,ge,_=>_.provideCallsTo(Q,re,oe),void 0,oe)}$provideCallHierarchyOutgoingCalls(B,Q,re,oe){return this.s(B,ge,_=>_.provideCallsFrom(Q,re,oe),void 0,oe)}$releaseCallHierarchy(B,Q){this.s(B,ge,re=>Promise.resolve(re.releaseSession(Q)),void 0,void 0)}registerTypeHierarchyProvider(B,Q,re){const oe=this.t(new x(this.h,re),B);return this.e.$registerTypeHierarchyProvider(oe,this.o(Q,B)),this.p(oe)}$prepareTypeHierarchy(B,Q,re,oe){return this.s(B,x,_=>Promise.resolve(_.prepareSession(I.URI.revive(Q),re,oe)),void 0,oe)}$provideTypeHierarchySupertypes(B,Q,re,oe){return this.s(B,x,_=>_.provideSupertypes(Q,re,oe),void 0,oe)}$provideTypeHierarchySubtypes(B,Q,re,oe){return this.s(B,x,_=>_.provideSubtypes(Q,re,oe),void 0,oe)}$releaseTypeHierarchy(B,Q){this.s(B,x,re=>Promise.resolve(re.releaseSession(Q)),void 0,void 0)}registerDocumentOnDropEditProvider(B,Q,re,oe){const _=this.q();this.f.set(_,new de(new le(this.e,this.h,re,_,B),B));const me=(0,t.$uF)(B,"dropMetadata")&&oe?le.toInternalProviderId(B.identifier.value,oe.id):void 0;return this.e.$registerDocumentOnDropEditProvider(_,this.o(Q,B),me,(0,t.$uF)(B,"dropMetadata")?oe:void 0),this.p(_)}$provideDocumentOnDropEdits(B,Q,re,oe,_,me){return this.s(B,le,ye=>Promise.resolve(ye.provideDocumentOnDropEdits(Q,I.URI.revive(re),oe,_,me)),void 0,void 0)}registerMappedEditsProvider(B,Q,re){const oe=this.t(new te(this.h,re),B);return this.e.$registerMappedEditsProvider(oe,this.o(Q,B)),this.p(oe)}$provideMappedEdits(B,Q,re,oe,_){return this.s(B,te,me=>Promise.resolve(me.provideMappedEdits(Q,re,oe,_)),null,_)}registerDocumentPasteEditProvider(B,Q,re,oe){const _=this.q();this.f.set(_,new de(new j(this.e,this.h,re,_,B),B));const me=j.toInternalProviderId(B.identifier.value,oe.id);return this.e.$registerPasteEditProvider(_,this.o(Q,B),me,{supportsCopy:!!re.prepareDocumentPaste,supportsPaste:!!re.provideDocumentPasteEdits,copyMimeTypes:oe.copyMimeTypes,pasteMimeTypes:oe.pasteMimeTypes}),this.p(_)}$prepareDocumentPaste(B,Q,re,oe,_){return this.s(B,j,me=>me.prepareDocumentPaste(I.URI.revive(Q),re,oe,_),void 0,_)}$providePasteEdits(B,Q,re,oe,_,me){return this.s(B,j,ye=>ye.providePasteEdits(Q,I.URI.revive(re),oe,_,me),void 0,me)}static w(B){return{pattern:B.source,flags:B.flags}}static y(B){return{decreaseIndentPattern:be.w(B.decreaseIndentPattern),increaseIndentPattern:be.w(B.increaseIndentPattern),indentNextLinePattern:B.indentNextLinePattern?be.w(B.indentNextLinePattern):void 0,unIndentedLinePattern:B.unIndentedLinePattern?be.w(B.unIndentedLinePattern):void 0}}static z(B){return{beforeText:be.w(B.beforeText),afterText:B.afterText?be.w(B.afterText):void 0,previousLineText:B.previousLineText?be.w(B.previousLineText):void 0,action:B.action}}static B(B){return B.map(be.z)}static C(B){return{open:B.open,close:B.close,notIn:B.notIn?B.notIn.map(Q=>L.SyntaxTokenType.toString(Q)):void 0}}static D(B){return B.map(be.C)}setLanguageConfiguration(B,Q,re){const{wordPattern:oe}=re;if(oe&&(0,E.$Pe)(oe))throw new Error(`Invalid language configuration: wordPattern '${oe}' is not allowed to match the empty string.`);oe?this.h.setWordDefinitionFor(Q,oe):this.h.setWordDefinitionFor(Q,void 0),re.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",B,"Do not use."),re.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",B,"Do not use.");const _=this.q(),me={comments:re.comments,brackets:re.brackets,wordPattern:re.wordPattern?be.w(re.wordPattern):void 0,indentationRules:re.indentationRules?be.y(re.indentationRules):void 0,onEnterRules:re.onEnterRules?be.B(re.onEnterRules):void 0,__electricCharacterSupport:re.__electricCharacterSupport,__characterPairSupport:re.__characterPairSupport,autoClosingPairs:re.autoClosingPairs?be.D(re.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(_,Q,me),this.p(_)}$setWordDefinitions(B){for(const Q of B)this.h.setWordDefinitionFor(Q.languageId,new RegExp(Q.regexSource,Q.regexFlags))}}e.$9cc=be}),define(ke[330],Se([1,0,6,14,7,39,10,3,25]),function($e,e,I,F,f,L,R,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qdc=void 0;class m{constructor(P,g,y,S){this.c=g,this.d=y,this.e=S,this.b=[],this.f=0,this.g=new Set,this.a=P.getProxy(I.$vK.MainThreadLanguages)}$acceptLanguageIds(P){this.b=P}async getLanguages(){return this.b.slice(0)}async changeLanguage(P,g){await this.a.$changeLanguage(P,g);const y=this.c.getDocumentData(P);if(!y)throw new Error(`document '${P.toString()}' NOT found`);return y.document}async tokenAtPosition(P,g){const y=P.version,S=F.Position.from(g),w=await this.a.$tokensAtPosition(P.uri,S),c={type:f.StandardTokenType.Other,range:P.getWordRangeAtPosition(g)??new f.$zK(g.line,g.character,g.line,g.character)};if(!w)return c;const s={range:F.Range.to(w.range),type:F.TokenType.to(w.type)};return!s.range.contains(g)||y!==P.version?c:s}createLanguageStatusItem(P,g,y){const S=this.f++,w=this.a,c=this.g,s=`${P.identifier.value}/${g}`;if(c.has(s))throw new Error(`LanguageStatusItem with id '${g}' ALREADY exists`);c.add(s);const i={selector:y,id:g,name:P.displayName??P.name,severity:f.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let n;const o=new p.$Qc,a=()=>{if(n?.dispose(),!c.has(s)){console.warn(`LanguageStatusItem (${g}) from ${P.identifier.value} has been disposed and CANNOT be updated anymore`);return}n=(0,R.$Wg)(()=>{o.clear(),this.a.$setLanguageStatus(S,{id:s,name:i.name??P.displayName??P.name,source:P.displayName??P.name,selector:F.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===f.LanguageStatusSeverity.Error?L.default.Error:i.severity===f.LanguageStatusSeverity.Warning?L.default.Warning:L.default.Info,command:i.command&&this.d.toInternal(i.command,o),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},t={dispose(){o.dispose(),n?.dispose(),w.$removeLanguageStatus(S),c.delete(s)},get id(){return i.id},get name(){return i.name},set name(r){i.name=r,a()},get selector(){return i.selector},set selector(r){i.selector=r,a()},get text(){return i.text},set text(r){i.text=r,a()},set text2(r){(0,E.$vF)(P,"languageStatusText"),i.text=r,a()},get text2(){return(0,E.$vF)(P,"languageStatusText"),i.text},get detail(){return i.detail},set detail(r){i.detail=r,a()},get severity(){return i.severity},set severity(r){i.severity=r,a()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(r){i.accessibilityInformation=r,a()},get command(){return i.command},set command(r){i.command=r,a()},get busy(){return i.busy},set busy(r){i.busy=r,a()}};return a(),t}}e.$Qdc=m}),define(ke[115],Se([1,0,12,13,2,5,15,6,27,20]),function($e,e,I,F,f,L,R,p,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gdc=e.$Fdc=void 0;let A=class{constructor(g,y,S){this.f=S,this.d=new Map,this.a=y.getProxy(p.$vK.MainThreadLocalization),this.b=g.environment.appLanguage,this.c=this.b===I.$g}getMessage(g,y){const{message:S,args:w,comment:c}=y;if(this.c)return(0,F.$Ee)(S,w??{});let s=S;c&&c.length>0&&(s+=`/${Array.isArray(c)?c.join(""):c}`);const i=this.d.get(g)?.contents[s];return i||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${s}`),(0,F.$Ee)(i??S,w??{})}getBundle(g){return this.d.get(g)?.contents}getBundleUri(g){return this.d.get(g)?.uri}async initializeLocalizedMessages(g){if(this.c||!g.l10n&&!g.isBuiltin||this.d.has(g.identifier.value))return;let y;const S=await this.g(g);if(!S){this.f.error(`No bundle location found for extension ${g.identifier.value}`);return}try{const w=await this.a.$fetchBundleContents(S),c=JSON.parse(w);y=g.isBuiltin?c.contents?.bundle:c}catch(w){this.f.error(`Failed to load translations for ${g.identifier.value} from ${S}: ${w.message}`);return}y&&this.d.set(g.identifier.value,{contents:y,uri:S})}async g(g){if(g.isBuiltin){const y=await this.a.$fetchBuiltInBundleUri(g.identifier.value,this.b);return f.URI.revive(y)}return g.l10n?f.URI.joinPath(g.extensionLocation,g.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Fdc=A,e.$Fdc=A=He([Be(0,E.$NM),Be(1,m.$xM),Be(2,R.$bj)],A),e.$Gdc=(0,L.$Th)("IExtHostLocalizationService")}),define(ke[152],Se([1,0,15,6,27,20,2,54]),function($e,e,I,F,f,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ec=void 0;let E=class extends I.$mj{constructor(P,g){super(g.logLevel,g.logsLocation,g.loggers.map(y=>(0,p.$qh)(y))),this.r=P.getProxy(F.$vK.MainThreadLogger)}$setLogLevel(P,g){g?this.setLogLevel(R.URI.revive(g),P):this.setLogLevel(P)}setVisibility(P,g){super.setVisibility(P,g),this.r.$setVisibility(P,g)}s(P,g,y){return new m(this.r,P,g,y)}};e.$9ec=E,e.$9ec=E=He([Be(0,L.$xM),Be(1,f.$NM)],E);class m extends I.$hj{constructor(P,g,y,S){super(S?.logLevel==="always"),this.r=P,this.s=g,this.m=!1,this.n=[],this.setLevel(y),this.r.$createLogger(g,S).then(()=>{this.u(this.n),this.m=!0})}g(P,g){const y=[[P,g]];this.m?this.u(y):this.n.push(...y)}u(P){this.r.$log(this.s,P)}flush(){this.r.$flush(this.s)}}}),define(ke[116],Se([1,0,6,5,3,20,22]),function($e,e,I,F,f,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Idc=e.$Hdc=void 0,e.$Hdc=(0,F.$Th)("IExtHostManagedSockets");let p=class{constructor(P){this.b=0,this.c=null,this.d=new Map,this.a=P.getProxy(I.$vK.MainThreadManagedSockets)}setFactory(P,g){for(const y of this.d.values())y.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new E(P,g),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(P){if(!this.c||this.c.socketFactoryId!==P)throw new Error(`No socket factory with id ${P}`);const g=++this.b,y=await this.c.makeConnection(),S=new f.$Qc;return this.d.set(g,new m(g,y,S)),S.add((0,f.$Pc)(()=>this.d.delete(g))),S.add(y.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(g),S.dispose()})),S.add(y.onDidClose(w=>{this.a.$onDidManagedSocketClose(g,w?.stack??w?.message),S.dispose()})),S.add(y.onDidReceiveMessage(w=>this.a.$onDidManagedSocketHaveData(g,R.$ce.wrap(w)))),g}$remoteSocketWrite(P,g){this.d.get(P)?.actual.send(g.buffer)}$remoteSocketEnd(P){const g=this.d.get(P);g&&(g.actual.end(),g.dispose())}async $remoteSocketDrain(P){await this.d.get(P)?.actual.drain?.()}};e.$Idc=p,e.$Idc=p=He([Be(0,L.$xM)],p);class E{constructor(P,g){this.socketFactoryId=P,this.makeConnection=g}}class m extends f.$Rc{constructor(P,g,y){super(),this.socketId=P,this.actual=g,this.B(y)}}}),define(ke[331],Se([1,0,6,15,25]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rdc=void 0;function L(p){return p&&p.title}let R=class{constructor(E,m){this.b=m,this.a=E.getProxy(I.$vK.MainThreadMessageService)}showMessage(E,m,A,P,g){const y={source:{identifier:E.identifier,label:E.displayName||E.name}};let S;typeof P=="string"||L(P)?S=[P,...g]:(y.modal=P?.modal,y.useCustom=P?.useCustom,y.detail=P?.detail,S=g),y.useCustom&&(0,f.$vF)(E,"resolvers");const w=[];for(let c=0;c<S.length;c++){const s=S[c];if(typeof s=="string")w.push({title:s,handle:c,isCloseAffordance:!1});else if(typeof s=="object"){const{title:i,isCloseAffordance:n}=s;w.push({title:i,isCloseAffordance:!!n,handle:c})}else this.b.warn("Invalid message item:",s)}return this.a.$showMessage(m,A,y,w).then(c=>{if(typeof c=="number")return S[c]})}};e.$Rdc=R,e.$Rdc=R=He([Be(1,F.$bj)],R)}),define(ke[332],Se([1,0,19,10,21,4,3,28,2,26,15,6,35,14,7,113,287,25,69]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,S,w,c,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oec=e.$Nec=void 0;let n=class{constructor(h,k,D,$,b){this.l=k,this.m=D,this.n=$,this.o=b,this.b=new p.$zc,this.c=new p.$zc,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new Map,this.j=0,this.k=new L.$Od,this.onDidChangeNotebookCellExecutionState=this.k.event,this.a=h.getProxy(P.$vK.MainThreadNotebookKernels);const v=new g.$XM("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new g.$VM("options","Select kernel options",C=>!0,C=>{if(C&&"notebookEditor"in C&&"id"in C){const N=this.m.getIdByEditor(C.notebookEditor);return{id:C.id,extension:C.extension,notebookEditorId:N}}else if(C&&"notebookEditor"in C){const N=this.m.getIdByEditor(C.notebookEditor);if(N===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${C.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:N}}return C})],g.$WM.Void);this.n.registerApiCommand(v)}createNotebookController(h,k,D,$,b,v){for(const ae of this.i.values())if(ae.controller.id===k&&m.$0l.equals(h.identifier,ae.extensionId))throw new Error(`notebook controller with id '${k}' ALREADY exist`);const C=this.j++,N=this;this.o.trace(`NotebookController[${C}], CREATED by ${h.identifier.value}, ${k}`);const z=()=>console.warn(`NO execute handler from notebook controller '${T.id}' of extension: '${h.identifier}'`);let M=!1;const O=new L.$Od,j=new L.$Od,T={id:u(h.identifier,k),notebookType:D,extensionId:h.identifier,extensionLocation:h.extensionLocation,label:$||h.identifier.value,preloads:v?v.map(y.NotebookRendererScript.from):[]};let V=b??z,q;this.a.$addKernel(C,T).catch(ae=>{console.log(ae),M=!0});let fe=0;const ee=()=>{if(M)return;const ae=++fe;Promise.resolve().then(()=>{ae===fe&&this.a.$updateKernel(C,T)})},Y=new p.$zc,X={get id(){return k},get notebookType(){return T.notebookType},onDidChangeSelectedNotebooks:O.event,get label(){return T.label},set label(ae){T.label=ae??h.displayName??h.name,ee()},get detail(){return T.detail??""},set detail(ae){T.detail=ae,ee()},get description(){return T.description??""},set description(ae){T.description=ae,ee()},get supportedLanguages(){return T.supportedLanguages},set supportedLanguages(ae){T.supportedLanguages=ae,ee()},get supportsExecutionOrder(){return T.supportsExecutionOrder??!1},set supportsExecutionOrder(ae){T.supportsExecutionOrder=ae,ee()},get rendererScripts(){return T.preloads?T.preloads.map(y.NotebookRendererScript.to):[]},get executeHandler(){return V},set executeHandler(ae){V=ae??z},get interruptHandler(){return q},set interruptHandler(ae){q=ae,T.supportsInterrupt=!!ae,ee()},createNotebookCellExecution(ae){if(M)throw new Error("notebook controller is DISPOSED");if(!Y.has(ae.notebook.uri))throw N.o.trace(`NotebookController[${C}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Y.keys()).map(Z=>Z.toString())),new Error(`notebook controller is NOT associated to notebook: ${ae.notebook.uri.toString()}`);return N._createNotebookCellExecution(ae,u(h.identifier,this.id))},createNotebookExecution(ae){if((0,s.$vF)(h,"notebookExecution"),M)throw new Error("notebook controller is DISPOSED");if(!Y.has(ae.uri))throw N.o.trace(`NotebookController[${C}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Y.keys()).map(Z=>Z.toString())),new Error(`notebook controller is NOT associated to notebook: ${ae.uri.toString()}`);return N._createNotebookExecution(ae,u(h.identifier,this.id))},dispose:()=>{M||(this.o.trace(`NotebookController[${C}], DISPOSED`),M=!0,this.i.delete(C),O.dispose(),j.dispose(),this.a.$removeKernel(C))},updateNotebookAffinity(ae,Z){Z===S.NotebookControllerAffinity2.Hidden&&(0,s.$vF)(h,"notebookControllerAffinityHidden"),N.a.$updateNotebookPriority(C,ae.uri,Z)},onDidReceiveMessage:j.event,postMessage(ae,Z){return(0,s.$vF)(h,"notebookMessaging"),N.a.$postMessage(C,Z&&N.m.getIdByEditor(Z),ae)},asWebviewUri(ae){return(0,s.$vF)(h,"notebookMessaging"),(0,w.$2tb)(ae,N.l.remote)}};return this.i.set(C,{extensionId:h.identifier,controller:X,onDidReceiveMessage:j,onDidChangeSelection:O,associatedNotebooks:Y}),X}getIdByController(h){for(const[k,D]of this.i)if(D.controller===h)return u(D.extensionId,h.id);return null}createNotebookControllerDetectionTask(h,k){const D=this.f++,$=this;this.o.trace(`NotebookControllerDetectionTask[${D}], CREATED by ${h.identifier.value}`),this.a.$addKernelDetectionTask(D,k);const b={dispose:()=>{this.e.delete(D),$.a.$removeKernelDetectionTask(D)}};return this.e.set(D,b),b}registerKernelSourceActionProvider(h,k,D){const $=this.h++,b=typeof D.onDidChangeNotebookKernelSourceActions=="function"?$:void 0,v=this;this.g.set($,D),this.o.trace(`NotebookKernelSourceActionProvider[${$}], CREATED by ${h.identifier.value}`),this.a.$addKernelSourceActionProvider($,$,k);let C;return b!==void 0&&(C=D.onDidChangeNotebookKernelSourceActions(N=>this.a.$emitNotebookKernelSourceActionsChangeEvent(b))),{dispose:()=>{this.g.delete($),v.a.$removeKernelSourceActionProvider($,$),C?.dispose()}}}async $provideKernelSourceActions(h,k){const D=this.g.get(h);if(D){const $=new R.$Qc;return(await D.provideNotebookKernelSourceActions(k)??[]).map(v=>y.NotebookKernelSourceAction.from(v,this.n.converter,$))}return[]}$acceptNotebookAssociation(h,k,D){const $=this.i.get(h);if($){const b=this.m.getNotebookDocument(E.URI.revive(k));D?$.associatedNotebooks.set(b.uri,!0):$.associatedNotebooks.delete(b.uri),this.o.trace(`NotebookController[${h}] ASSOCIATE notebook`,b.uri.toString(),D),$.onDidChangeSelection.fire({selected:D,notebook:b.apiNotebook})}}async $executeCells(h,k,D){const $=this.i.get(h);if(!$)return;const b=this.m.getNotebookDocument(E.URI.revive(k)),v=[];for(const C of D){const N=b.getCell(C);N&&v.push(N.apiCell)}try{this.o.trace(`NotebookController[${h}] EXECUTE cells`,b.uri.toString(),v.length),await $.controller.executeHandler.call($.controller,v,b.apiNotebook,$.controller)}catch(C){this.o.error(`NotebookController[${h}] execute cells FAILED`,C),console.error(C)}}async $cancelCells(h,k,D){const $=this.i.get(h);if(!$)return;const b=this.m.getNotebookDocument(E.URI.revive(k));if($.controller.interruptHandler)await $.controller.interruptHandler.call($.controller,b.apiNotebook);else for(const v of D){const C=b.getCell(v);C&&this.b.get(C.uri)?.cancel()}if($.controller.interruptHandler){const v=this.c.get(b.uri);D.length&&Array.isArray(v)&&v.length&&v.forEach(C=>C.dispose())}}$acceptKernelMessageFromRenderer(h,k,D){const $=this.i.get(h);if(!$)return;const b=this.m.getEditorById(k);$.onDidReceiveMessage.fire(Object.freeze({editor:b.apiEditor,message:D}))}$cellExecutionChanged(h,k,D){const b=this.m.getNotebookDocument(E.URI.revive(h)).getCell(k);if(b){const v=D?y.NotebookCellExecutionState.to(D):S.NotebookCellExecutionState.Idle;v!==void 0&&this.k.fire({cell:b.apiCell,state:v})}}_createNotebookCellExecution(h,k){if(h.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const $=this.m.getNotebookDocument(h.notebook.uri).getCellFromApiCell(h);if(!$)throw new Error("invalid cell");if(this.b.has($.uri))throw new Error(`duplicate execution for ${$.uri}`);const b=new a(k,$,this.a);this.b.set($.uri,b);const v=b.onDidChangeState(()=>{b.state===o.Resolved&&(b.dispose(),v.dispose(),this.b.delete($.uri))});return b.asApiObject()}_createNotebookExecution(h,k){const D=this.m.getNotebookDocument(h.uri),$=h.getCells().find(C=>{const N=D.getCellFromApiCell(C);return N&&this.b.has(N.uri)});if($)throw new Error(`duplicate cell execution for ${$.document.uri}`);if(this.c.has(D.uri))throw new Error(`duplicate notebook execution for ${D.uri}`);const b=new r(k,D,this.a),v=b.onDidChangeState(()=>{b.state===t.Resolved&&(b.dispose(),v.dispose(),this.c.delete(D.uri))});return this.c.set(D.uri,[b,v]),b.asApiObject()}};e.$Nec=n,e.$Nec=n=He([Be(4,A.$bj)],n);var o;(function(l){l[l.Init=0]="Init",l[l.Started=1]="Started",l[l.Resolved=2]="Resolved"})(o||(o={}));class a extends R.$Rc{static{this.a=0}get state(){return this.f}constructor(h,k,D){super(),this.m=k,this.n=D,this.b=a.a++,this.c=new L.$Od,this.onDidChangeState=this.c.event,this.f=o.Init,this.g=this.B(new f.$Yd),this.h=new d(10,$=>this.s($)),this.j=k.internalMetadata.executionOrder,this.n.$createExecution(this.b,h,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(h){await this.h.addItem(h)}async s(h){const k=Array.isArray(h)?h:[h];return this.n.$updateExecution(this.b,new i.$uv(k))}t(){if(this.f===o.Init)throw new Error("Must call start before modifying cell output");if(this.f===o.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(h){let k=this.m;if(h&&(k=this.m.notebook.getCellFromApiCell(h)),!k)throw new Error("INVALID cell");return k.handle}y(h){return h.map(k=>{const D=S.$YL.ensureUniqueMimeTypes(k.items,!0);return D===k.items?y.NotebookCellOutput.from(k):y.NotebookCellOutput.from({items:D,id:k.id,metadata:k.metadata})})}async z(h,k,D){const $=this.w(k),b=this.y((0,I.$2b)(h));return this.r({editType:c.CellExecutionUpdateType.Output,cellHandle:$,append:D,outputs:b})}async C(h,k,D){return h=S.$YL.ensureUniqueMimeTypes((0,I.$2b)(h),!0),this.r({editType:c.CellExecutionUpdateType.OutputItems,items:h.map(y.NotebookCellOutputItem.from),outputId:k.id,append:D})}asApiObject(){const h=this;return Object.freeze({get token(){return h.g.token},get cell(){return h.m.apiCell},get executionOrder(){return h.j},set executionOrder(D){h.j=D,h.s([{editType:c.CellExecutionUpdateType.ExecutionState,executionOrder:h.j}])},start(D){if(h.f===o.Resolved||h.f===o.Started)throw new Error("Cannot call start again");h.f=o.Started,h.c.fire(),h.s({editType:c.CellExecutionUpdateType.ExecutionState,runStartTime:D})},end(D,$){if(h.f===o.Resolved)throw new Error("Cannot call resolve twice");h.f=o.Resolved,h.c.fire(),h.h.flush(),h.n.$completeExecution(h.b,new i.$uv({runEndTime:$,lastRunSuccess:D}))},clearOutput(D){return h.t(),h.z([],D,!1)},appendOutput(D,$){return h.t(),h.z(D,$,!0)},replaceOutput(D,$){return h.t(),h.z(D,$,!1)},appendOutputItems(D,$){return h.t(),h.C(D,$,!0)},replaceOutputItems(D,$){return h.t(),h.C(D,$,!1)}})}}var t;(function(l){l[l.Init=0]="Init",l[l.Started=1]="Started",l[l.Resolved=2]="Resolved"})(t||(t={}));class r extends R.$Rc{static{this.a=0}get state(){return this.f}constructor(h,k,D){super(),this.h=k,this.j=D,this.b=r.a++,this.c=new L.$Od,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new f.$Yd),this.j.$createNotebookExecution(this.b,h,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===t.Resolved||this.f===t.Started)throw new Error("Cannot call start again");this.f=t.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===t.Resolved)throw new Error("Cannot call resolve twice");this.f=t.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class d{constructor(h,k){this.e=h,this.f=k,this.a=[],this.b=Date.now()}addItem(h){return this.a.push(h),this.c||(this.c=new F.$gh,this.b=Date.now(),(0,F.$Vg)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const h=this.c;this.c=void 0;const k=this.a;return this.a=[],this.f(k).finally(()=>h.complete())}}function u(l,h){return`${l.value}/${h}`}e.$Oec=u}),define(ke[333],Se([1,0,4,6,148]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pec=void 0;class L{constructor(p,E){this.c=E,this.a=new Map,this.b=p.getProxy(F.$vK.MainThreadNotebookRenderers)}$postRendererMessage(p,E,m){const A=this.c.getEditorById(p);this.a.get(E)?.fire({editor:A.apiEditor,message:m})}createRendererMessaging(p,E){if(!p.contributes?.notebookRenderer?.some(A=>A.id===E))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${E})`);return{onDidReceiveMessage:(A,P,g)=>this.d(E).event(A,P,g),postMessage:(A,P)=>{f.$yec.apiEditorsToExtHost.has(A)&&([A,P]=[P,A]);const g=P&&f.$yec.apiEditorsToExtHost.get(P);return this.b.$postMessage(g?.id,E,A)}}}d(p){let E=this.a.get(p);return E||(E=new I.$Od({onDidRemoveLastListener:()=>{E?.dispose(),this.a.delete(p)}}),this.a.set(p,E),E)}}e.$Pec=L}),define(ke[334],Se([1,0,3,18,2,25,6]),function($e,e,I,F,f,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tec=void 0;class p{constructor(m){this.b=new Map,this.a=m.getProxy(R.$vK.MainThreadProfileContentHandlers)}registrProfileContentHandler(m,A,P){if((0,L.$vF)(m,"profileContentHandlers"),this.b.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.b.set(A,P),this.a.$registerProfileContentHandler(A,P.name,P.description,m.identifier.value),(0,I.$Pc)(()=>{this.b.delete(A),this.a.$unregisterProfileContentHandler(A)})}async $saveProfile(m,A,P,g){const y=this.b.get(m);if(!y)throw new Error(`Unknown handler with id: ${m}`);return y.saveProfile(A,P,g)}async $readProfile(m,A,P){const g=this.b.get(m);if(!g)throw new Error(`Unknown handler with id: ${m}`);return g.readProfile((0,F.$zf)(A)?A:f.URI.revive(A),P)}}e.$Tec=p}),define(ke[335],Se([1,0,2,6,10,14]),function($e,e,I,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uec=void 0;class R{static{this.a=0}constructor(E,m){this.d=m,this.c=new Map,this.b=E.getProxy(F.$vK.MainThreadQuickDiff)}$provideOriginalResource(E,m,A){const P=I.URI.revive(m),g=this.c.get(E);return g?(0,f.$Ng)(()=>g.provideOriginalResource(P,A)).then(y=>y||null):Promise.resolve(null)}registerQuickDiffProvider(E,m,A,P){const g=R.a++;return this.c.set(g,m),this.b.$registerQuickDiffProvider(g,L.DocumentSelector.from(E,this.d),A,P),{dispose:()=>{this.b.$unregisterQuickDiffProvider(g),this.c.delete(g)}}}}e.$Uec=R}),define(ke[336],Se([1,0,21,4,3,6,2,7,11,19,39,61,25,14]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vdc=void 0;function S(w,c,s){const i=w.getProxy(L.$vK.MainThreadQuickOpen);class n{constructor(k,D){this.e=new Map,this.f=0,this.a=k,this.b=D}showQuickPick(k,D,$,b=I.CancellationToken.None){this.c=void 0;const v=Promise.resolve(D),C=++this.f,N=i.$show(C,{title:$?.title,placeHolder:$?.placeHolder,matchOnDescription:$?.matchOnDescription,matchOnDetail:$?.matchOnDetail,ignoreFocusLost:$?.ignoreFocusOut,canPickMany:$?.canPickMany},b),z={},M=N.then(()=>z);return Promise.race([M,v]).then(O=>{if(O===z)return;const j=(0,g.$uF)(k,"quickPickItemTooltip");return v.then(T=>{const V=[];for(let q=0;q<T.length;q++){const fe=T[q];if(typeof fe=="string")V.push({label:fe,handle:q});else if(fe.kind===p.QuickPickItemKind.Separator)V.push({type:"separator",label:fe.label});else{fe.tooltip&&!j&&console.warn(`Extension '${k.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${k.identifier.value}`);const ee=fe.iconPath?d(fe.iconPath):void 0;V.push({label:fe.label,iconPath:ee?.iconPath,iconClass:ee?.iconClass,description:fe.description,detail:fe.detail,picked:fe.picked,alwaysShow:fe.alwaysShow,tooltip:j?y.MarkdownString.fromStrict(fe.tooltip):void 0,handle:q})}}return $&&typeof $.onDidSelectItem=="function"&&(this.c=q=>{$.onDidSelectItem(T[q])}),i.$setItems(C,V),N.then(q=>{if(typeof q=="number")return T[q];if(Array.isArray(q))return q.map(fe=>T[fe])})})}).then(void 0,O=>{if(!(0,E.$3)(O))return i.$setError(C,O),Promise.reject(O)})}$onItemSelected(k){this.c?.(k)}showInput(k,D=I.CancellationToken.None){return this.d=k?.validateInput,i.$input(k,typeof this.d=="function",D).then(void 0,$=>{if(!(0,E.$3)($))return Promise.reject($)})}async $validateInput(k){if(!this.d)return;const D=await this.d(k);if(!D||typeof D=="string")return D;let $;switch(D.severity){case p.InputBoxValidationSeverity.Info:$=A.default.Info;break;case p.InputBoxValidationSeverity.Warning:$=A.default.Warning;break;case p.InputBoxValidationSeverity.Error:$=A.default.Error;break;default:$=D.message?A.default.Error:A.default.Ignore;break}return{content:D.message,severity:$}}async showWorkspaceFolderPick(k,D=I.CancellationToken.None){const $=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[k]);if(!$)return;const b=await this.a.getWorkspaceFolders2();if(b)return b.find(v=>v.uri.toString()===$.uri.toString())}createQuickPick(k){const D=new u(k,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}createInputBox(k){const D=new l(k,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}$onDidChangeValue(k,D){this.e.get(k)?._fireDidChangeValue(D)}$onDidAccept(k){this.e.get(k)?._fireDidAccept()}$onDidChangeActive(k,D){const $=this.e.get(k);$ instanceof u&&$._fireDidChangeActive(D)}$onDidChangeSelection(k,D){const $=this.e.get(k);$ instanceof u&&$._fireDidChangeSelection(D)}$onDidTriggerButton(k,D){this.e.get(k)?._fireDidTriggerButton(D)}$onDidTriggerItemButton(k,D,$){const b=this.e.get(k);b instanceof u&&b._fireDidTriggerItemButton(D,$)}$onDidHide(k){this.e.get(k)?._fireDidHide()}}class o{static{this.a=1}constructor(k,D){this.x=k,this.y=D,this._id=u.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new F.$Od,this.q=new F.$Od,this.r=new F.$Od,this.s=new F.$Od,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(k){this.b=k,this.z({title:k})}get step(){return this.c}set step(k){this.c=k,this.z({step:k})}get totalSteps(){return this.d}set totalSteps(k){this.d=k,this.z({totalSteps:k})}get enabled(){return this.g}set enabled(k){this.g=k,this.z({enabled:k})}get busy(){return this.j}set busy(k){this.j=k,this.z({busy:k})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(k){this.k=k,this.z({ignoreFocusOut:k})}get value(){return this.l}set value(k){this.l=k,this.z({value:k})}get placeholder(){return this.m}set placeholder(k){this.m=k,this.z({placeholder:k})}get buttons(){return this.n}set buttons(k){this.n=k.slice(),this.o.clear(),k.forEach((D,$)=>{const b=D===p.$RL.Back?-1:$;this.o.set(b,D)}),this.z({buttons:k.map((D,$)=>({...d(D.iconPath),tooltip:D.tooltip,handle:D===p.$RL.Back?-1:$}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(k){this.l=k,this.q.fire(k)}_fireDidTriggerButton(k){const D=this.o.get(k);D&&this.r.fire(D)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,f.$Mc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),i.$dispose(this._id))}z(k){if(!this.v){for(const D of Object.keys(k)){const $=k[D];this.u[D]=$===void 0?null:$}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){i.$createOrUpdate(this.u),this.u={id:this._id}}}function a(h){if(h instanceof p.$rL)return{id:h.id};const k=r(h),D=t(h);return{dark:typeof k=="string"?R.URI.file(k):k,light:typeof D=="string"?R.URI.file(D):D}}function t(h){return typeof h=="object"&&"light"in h?h.light:h}function r(h){return typeof h=="object"&&"dark"in h?h.dark:h}function d(h){const k=a(h);let D,$;return"id"in k?$=P.ThemeIcon.asClassName(k):D=k,{iconPath:D,iconClass:$}}class u extends o{constructor(k,D){super(k.identifier,D),this.O=k,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new F.$Od,this.L=[],this.M=new F.$Od,this.N=new F.$Od,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(k){this.B=k.slice(),this.C.clear(),this.D.clear(),k.forEach((b,v)=>{this.C.set(v,b),this.D.set(b,v)});const D=(0,g.$uF)(this.O,"quickPickItemTooltip"),$=[];for(let b=0;b<k.length;b++){const v=k[b];if(v.kind===p.QuickPickItemKind.Separator)$.push({type:"separator",label:v.label});else{v.tooltip&&!D&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const C=v.iconPath?d(v.iconPath):void 0;$.push({handle:b,label:v.label,iconPath:C?.iconPath,iconClass:C?.iconClass,description:v.description,detail:v.detail,picked:v.picked,alwaysShow:v.alwaysShow,tooltip:D?y.MarkdownString.fromStrict(v.tooltip):void 0,buttons:v.buttons?.map((N,z)=>({...d(N.iconPath),tooltip:N.tooltip,handle:z}))})}}this.z({items:$})}get canSelectMany(){return this.E}set canSelectMany(k){this.E=k,this.z({canSelectMany:k})}get matchOnDescription(){return this.F}set matchOnDescription(k){this.F=k,this.z({matchOnDescription:k})}get matchOnDetail(){return this.G}set matchOnDetail(k){this.G=k,this.z({matchOnDetail:k})}get sortByLabel(){return this.H}set sortByLabel(k){this.H=k,this.z({sortByLabel:k})}get keepScrollPosition(){return this.I}set keepScrollPosition(k){this.I=k,this.z({keepScrollPosition:k})}get activeItems(){return this.J}set activeItems(k){this.J=k.filter(D=>this.D.has(D)),this.z({activeItems:this.J.map(D=>this.D.get(D))})}get selectedItems(){return this.L}set selectedItems(k){this.L=k.filter(D=>this.D.has(D)),this.z({selectedItems:this.L.map(D=>this.D.get(D))})}_fireDidChangeActive(k){const D=(0,m.$Gb)(k.map($=>this.C.get($)));this.J=D,this.K.fire(D)}_fireDidChangeSelection(k){const D=(0,m.$Gb)(k.map($=>this.C.get($)));this.L=D,this.M.fire(D)}_fireDidTriggerItemButton(k,D){const $=this.C.get(k);if(!$||!$.buttons||!$.buttons.length)return;const b=$.buttons[D];b&&this.N.fire({button:b,item:$})}}class l extends o{constructor(k,D){super(k.identifier,D),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(k){this.B=k,this.z({password:k})}get prompt(){return this.C}set prompt(k){this.C=k,this.z({prompt:k})}get valueSelection(){return this.D}set valueSelection(k){this.D=k,this.z({valueSelection:k})}get validationMessage(){return this.E}set validationMessage(k){this.E=k,k?typeof k=="string"?this.z({validationMessage:k,severity:A.default.Error}):this.z({validationMessage:k.message,severity:k.severity??A.default.Error}):this.z({validationMessage:void 0,severity:A.default.Ignore})}}return new n(c,s)}e.$Vdc=S}),define(ke[337],Se([1,0,2,4,59,3,10,6,19,129,15,26,61,14,25,17]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,S,w){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$Xdc=e.$Wdc=void 0;function s(v){if(v)return typeof v.iconPath=="string"?I.URI.file(v.iconPath):I.URI.isUri(v.iconPath)||g.ThemeIcon.isThemeIcon(v.iconPath)?v.iconPath:void 0}function i(v){if(v?.icon){if(I.URI.isUri(v.icon))return v.icon;if(g.ThemeIcon.isThemeIcon(v.icon))return v.icon;{const C=v.icon;return{light:C.light,dark:C.dark}}}else return}function n(v){if(v.icon){if(I.URI.isUri(v.icon))return v.icon;if(g.ThemeIcon.isThemeIcon(v.icon))return v.icon;{const C=v.icon;return{light:C.light,dark:C.dark}}}else return}function o(v,C){if(!v.iconPath&&!C.iconPath)return 0;if(v.iconPath){if(!C.iconPath)return 1}else return-1;const N=typeof v.iconPath=="string"?v.iconPath:I.URI.isUri(v.iconPath)?v.iconPath.fsPath:v.iconPath.id,z=typeof C.iconPath=="string"?C.iconPath:I.URI.isUri(C.iconPath)?C.iconPath.fsPath:C.iconPath.id;return(0,m.$vq)(N,z)}function a(v,C){let N=0;if(v.strikeThrough!==C.strikeThrough)return v.strikeThrough?1:-1;if(v.faded!==C.faded)return v.faded?1:-1;if(v.tooltip!==C.tooltip)return(v.tooltip||"").localeCompare(C.tooltip||"");if(N=o(v,C),N!==0)return N;if(v.light&&C.light)N=o(v.light,C.light);else{if(v.light)return 1;if(C.light)return-1}if(N!==0)return N;if(v.dark&&C.dark)N=o(v.dark,C.dark);else{if(v.dark)return 1;if(C.dark)return-1}return N}function t(v,C){if(v.command!==C.command)return v.command<C.command?-1:1;if(v.title!==C.title)return v.title<C.title?-1:1;if(v.tooltip!==C.tooltip){if(v.tooltip!==void 0&&C.tooltip!==void 0)return v.tooltip<C.tooltip?-1:1;if(v.tooltip!==void 0)return 1;if(C.tooltip!==void 0)return-1}if(v.arguments===C.arguments)return 0;if(v.arguments)if(C.arguments){if(v.arguments.length!==C.arguments.length)return v.arguments.length-C.arguments.length}else return 1;else return-1;for(let N=0;N<v.arguments.length;N++){const z=v.arguments[N],M=C.arguments[N];if(z!==M)return z<M?-1:1}return 0}function r(v,C){let N=(0,m.$vq)(v.resourceUri.fsPath,C.resourceUri.fsPath,!0);if(N!==0)return N;if(v.command&&C.command)N=t(v.command,C.command);else{if(v.command)return 1;if(C.command)return-1}if(N!==0)return N;if(v.decorations&&C.decorations)N=a(v.decorations,C.decorations);else{if(v.decorations)return 1;if(C.decorations)return-1}return N}function d(v,C){for(let N=0;N<v.length;N++)if(v[N]!==C[N])return!1;return!0}function u(v,C){return v.command===C.command&&v.title===C.title&&v.tooltip===C.tooltip&&(v.arguments&&C.arguments?d(v.arguments,C.arguments):v.arguments===C.arguments)}function l(v,C){return(0,E.$tb)(v,C,u)}function h(v,C){return v===C?!0:!v||!C?!1:v.id===C.id&&v.label===C.label&&v.upstream?.id===C.upstream?.id&&v.upstream?.label===C.upstream?.label}class k{#e;#t;get value(){return this.d}set value(C){C=C??"",this.#e.$setInputBoxValue(this.o,C),this.q(C)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(C){this.#e.$setInputBoxPlaceholder(this.o,C),this.f=C}get validateInput(){return(0,S.$vF)(this.m,"scmValidation"),this.g}set validateInput(C){if((0,S.$vF)(this.m,"scmValidation"),C&&typeof C!="function")throw new Error(`[${this.m.identifier.value}]: Invalid SCM input box validation function`);this.g=C,this.#e.$setValidationProviderIsEnabled(this.o,!!C)}get enabled(){return this.h}set enabled(C){C=!!C,this.h!==C&&(this.h=C,this.#e.$setInputBoxEnablement(this.o,C))}get visible(){return this.j}set visible(C){C=!!C,this.j!==C&&(this.j=C,this.#e.$setInputBoxVisibility(this.o,C))}get actionButton(){return(0,S.$vF)(this.m,"scmInputBoxActionButton"),this.k}set actionButton(C){(0,S.$vF)(this.m,"scmInputBoxActionButton"),this.l.value=new L.$Qc,this.k=C;const N=C!==void 0?{command:this.n.converter.toInternal(C.command,this.l.value),icon:i(C),enabled:C.enabled}:void 0;this.#e.$setInputBoxActionButton(this.o,N??null)}get document(){return(0,S.$vF)(this.m,"scmTextDocument"),this.#t.getDocument(this.p)}constructor(C,N,z,M,O,j){this.m=C,this.n=N,this.o=O,this.p=j,this.d="",this.e=new F.$Od,this.f="",this.h=!0,this.j=!0,this.l=new L.$Sc,this.#t=z,this.#e=M}showValidationMessage(C,N){(0,S.$vF)(this.m,"scmValidation"),this.#e.$showValidationMessage(this.o,C,N)}$onInputBoxValueChange(C){this.q(C)}q(C){this.d=C,this.e.fire(C)}}e.$Wdc=k;class D{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(C){this.v=C,this.q.$updateGroupLabel(this.t,this.handle,C)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(C){this.p=C,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(C){this.f=[...C],this.k.fire()}constructor(C,N,z,M,O){this.q=C,this.s=N,this.t=z,this.u=M,this.v=O,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new F.$Od,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new F.$Od,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=D.d++}getResourceState(C){return this.g.get(C)}$executeResourceCommand(C,N){const z=this.h.get(C);return z?(0,R.$Ng)(()=>this.s.executeCommand(z.command,...z.arguments||[],N)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const C=[...this.f].sort(r),z=(0,E.$Cb)(this.o,C,r).map(j=>{const T=j.toInsert.map(V=>{const q=this.e++;this.g.set(q,V);const fe=V.resourceUri;let ee;if(V.command)if(V.command.command==="vscode.open"||V.command.command==="vscode.diff"){const Ee=new L.$Qc;ee=this.s.converter.toInternal(V.command,Ee),this.j.set(q,Ee)}else this.h.set(q,V.command);const Y=s(V.decorations),X=V.decorations&&s(V.decorations.light)||Y,ae=V.decorations&&s(V.decorations.dark)||Y,Z=[X,ae],se=V.decorations&&V.decorations.tooltip||"",we=V.decorations&&!!V.decorations.strikeThrough,H=V.decorations&&!!V.decorations.faded,U=V.contextValue||"";return{rawResource:[q,fe,Z,se,we,H,U,ee],handle:q}});return{start:j.start,deleteCount:j.deleteCount,toInsert:T}}),M=z.map(({start:j,deleteCount:T,toInsert:V})=>[j,T,V.map(q=>q.rawResource)]),O=z.reverse();for(const{start:j,deleteCount:T,toInsert:V}of O){const q=V.map(ee=>ee.handle),fe=this.n.splice(j,T,...q);for(const ee of fe)this.g.delete(ee),this.h.delete(ee),this.j.get(ee)?.dispose(),this.j.delete(ee)}return this.o=C,M}dispose(){this.l=!0,this.m.fire()}}class ${static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(C){this.g!==C&&(this.g=C,this.#e.$updateSourceControl(this.x,{count:C}))}get quickDiffProvider(){return this.h}set quickDiffProvider(C){this.h=C;let N;(0,S.$uF)(this.y,"quickDiffProvider")&&(N=C?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!C,quickDiffLabel:N})}get historyProvider(){return(0,S.$vF)(this.y,"scmHistoryProvider"),this.j}set historyProvider(C){(0,S.$vF)(this.y,"scmHistoryProvider"),this.j=C,this.k.value=new L.$Qc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!C}),C&&(this.k.value.add(C.onDidChangeCurrentHistoryItemGroup(()=>{h(this.l,C?.currentHistoryItemGroup)||(this.l=C?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.l))})),this.k.value.add(C.onDidChangeActionButton(()=>{(0,S.$vF)(this.y,"scmActionButton"),this.m.value=new L.$Qc;const N=C.actionButton!==void 0?{command:this.z.converter.toInternal(C.actionButton.command,this.m.value),description:C.actionButton.description,enabled:C.actionButton.enabled}:void 0;this.#e.$onDidChangeHistoryProviderActionButton(this.x,N??null)})))}get commitTemplate(){return this.n}set commitTemplate(C){C!==this.n&&(this.n=C,this.#e.$updateSourceControl(this.x,{commitTemplate:C}))}get acceptInputCommand(){return this.p}set acceptInputCommand(C){this.o.value=new L.$Qc,this.p=C;const N=this.z.converter.toInternal(C,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:N})}get actionButton(){return(0,S.$vF)(this.y,"scmActionButton"),this.s}set actionButton(C){(0,S.$vF)(this.y,"scmActionButton"),this.q.value=new L.$Qc,this.s=C;const N=C!==void 0?{command:this.z.converter.toInternal(C.command,this.q.value),secondaryCommands:C.secondaryCommands?.map(z=>z.map(M=>this.z.converter.toInternal(M,this.q.value))),description:C.description,enabled:C.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:N??null})}get statusBarCommands(){return this.u}set statusBarCommands(C){if(this.u&&C&&l(this.u,C))return;this.t.value=new L.$Qc,this.u=C;const N=(C||[]).map(z=>this.z.converter.toInternal(z,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:N})}get selected(){return this.v}constructor(C,N,z,M,O,j,T){this.y=C,this.z=M,this.A=O,this.B=j,this.C=T,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new L.$Sc,this.m=new L.$Sc,this.n=void 0,this.o=new L.$Sc,this.p=void 0,this.q=new L.$Sc,this.t=new L.$Sc,this.u=void 0,this.v=!1,this.w=new F.$Od,this.onDidChangeSelection=this.w.event,this.x=$.d++,this.D=new Map,this.E=new Set,this.#e=z;const V=I.URI.from({scheme:w.Schemas.vscodeSourceControl,path:`${O}/scm${this.x}/input`,query:T?`rootUri=${encodeURIComponent(T.toString())}`:void 0});this.f=new k(C,M,N,this.#e,this.x,V),this.#e.$registerSourceControl(this.x,O,j,T,V)}createResourceGroup(C,N){const z=new D(this.#e,this.z,this.x,C,N),M=F.Event.once(z.onDidDispose)(()=>this.D.delete(z));return this.D.set(z,M),this.eventuallyAddResourceGroups(),z}eventuallyAddResourceGroups(){const C=[],N=[];for(const[z,M]of this.D){M.dispose();const O=z.onDidUpdateResourceStates(()=>{this.E.add(z),this.eventuallyUpdateResourceStates()});F.Event.once(z.onDidDispose)(()=>{this.E.delete(z),O.dispose(),this.e.delete(z.handle),this.#e.$unregisterGroup(this.x,z.handle)}),C.push([z.handle,z.id,z.label,z.features]);const j=z._takeResourceStateSnapshot();j.length>0&&N.push([z.handle,j]),this.e.set(z.handle,z)}this.#e.$registerGroups(this.x,C,N),this.D.clear()}eventuallyUpdateResourceStates(){const C=[];this.E.forEach(N=>{const z=N._takeResourceStateSnapshot();z.length!==0&&C.push([N.handle,z])}),C.length>0&&this.#e.$spliceResourceStates(this.x,C),this.E.clear()}getResourceGroup(C){return this.e.get(C)}setSelectionState(C){this.v=C,this.w.fire(C)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(C=>C.dispose()),this.#e.$unregisterSourceControl(this.x)}}He([(0,f.$mh)(100)],$.prototype,"eventuallyAddResourceGroups",null),He([(0,f.$mh)(100)],$.prototype,"eventuallyUpdateResourceStates",null);let b=class{static{c=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(C,N,z,M){this.l=N,this.m=z,this.n=M,this.g=new Map,this.h=new P.$_l,this.j=new F.$Od,this.e=C.getProxy(p.$vK.MainThreadSCM),this.f=C.getProxy(p.$vK.MainThreadTelemetry),N.registerArgumentProcessor({processArgument:O=>{if(O&&O.$mid===3){const j=this.g.get(O.sourceControlHandle);if(!j)return O;const T=j.getResourceGroup(O.groupHandle);return T?T.getResourceState(O.handle):O}else if(O&&O.$mid===4){const j=this.g.get(O.sourceControlHandle);return j?j.getResourceGroup(O.groupHandle):O}else if(O&&O.$mid===5){const j=this.g.get(O.handle);return j||O}return O}})}createSourceControl(C,N,z,M){this.n.trace("ExtHostSCM#createSourceControl",C.identifier.value,N,z,M),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:C.identifier.value});const O=c.d++,j=new $(C,this.m,this.e,this.l,N,z,M);this.g.set(O,j);const T=this.h.get(C.identifier)||[];return T.push(j),this.h.set(C.identifier,T),j}getLastInputBox(C){this.n.trace("ExtHostSCM#getLastInputBox",C.identifier.value);const N=this.h.get(C.identifier),z=N&&N[N.length-1];return z&&z.inputBox}$provideOriginalResource(C,N,z){const M=I.URI.revive(N);this.n.trace("ExtHostSCM#$provideOriginalResource",C,M.toString());const O=this.g.get(C);return!O||!O.quickDiffProvider||!O.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$Ng)(()=>O.quickDiffProvider.provideOriginalResource(M,z)).then(j=>j||null)}$onInputBoxValueChange(C,N){this.n.trace("ExtHostSCM#$onInputBoxValueChange",C);const z=this.g.get(C);return z&&z.inputBox.$onInputBoxValueChange(N),Promise.resolve(void 0)}$executeResourceCommand(C,N,z,M){this.n.trace("ExtHostSCM#$executeResourceCommand",C,N,z);const O=this.g.get(C);if(!O)return Promise.resolve(void 0);const j=O.getResourceGroup(N);return j?j.$executeResourceCommand(z,M):Promise.resolve(void 0)}$validateInput(C,N,z){this.n.trace("ExtHostSCM#$validateInput",C);const M=this.g.get(C);return!M||!M.inputBox.validateInput?Promise.resolve(void 0):(0,R.$Ng)(()=>M.inputBox.validateInput(N,z)).then(O=>{if(!O)return Promise.resolve(void 0);const j=y.MarkdownString.fromStrict(O.message);return j?Promise.resolve([j,O.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(C){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",C),C!==void 0&&this.g.get(C)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=C,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(C,N,z){return await this.g.get(C)?.historyProvider?.resolveHistoryItemGroupBase(N,z)??void 0}async $resolveHistoryItemGroupCommonAncestor(C,N,z,M){return await this.g.get(C)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(N,z,M)??void 0}async $provideHistoryItems(C,N,z,M){return(await this.g.get(C)?.historyProvider?.provideHistoryItems(N,z,M))?.map(T=>({id:T.id,parentIds:T.parentIds,label:T.label,description:T.description,icon:n(T),timestamp:T.timestamp}))??void 0}async $provideHistoryItemChanges(C,N,z){return await this.g.get(C)?.historyProvider?.provideHistoryItemChanges(N,z)??void 0}};e.$Xdc=b,e.$Xdc=b=c=He([Be(3,A.$bj)],b)}),define(ke[117],Se([1,0,6,4,5]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ddc=e.$Cdc=void 0;class L{constructor(p){this.b=new F.$Od,this.onDidChangePassword=this.b.event,this.a=p.getProxy(I.$vK.MainThreadSecretState)}async $onDidChangePassword(p){this.b.fire(p)}get(p,E){return this.a.$getPassword(p,E)}store(p,E,m){return this.a.$setPassword(p,E,m)}delete(p,E){return this.a.$deletePassword(p,E)}}e.$Cdc=L,e.$Ddc=(0,f.$Th)("IExtHostSecretState")}),define(ke[338],Se([1,0,6,14,2]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zec=void 0;class L{static{this.a=0}constructor(p,E){this.d=E,this.c=new Map,this.b=p.getProxy(I.$vK.MainThreadShare)}async $provideShare(p,E,m){return await this.c.get(p)?.provideShare({selection:F.Range.to(E.selection),resourceUri:f.URI.revive(E.resourceUri)},m)??void 0}registerShareProvider(p,E){const m=L.a++;return this.c.set(m,E),this.b.$registerShareProvider(m,F.DocumentSelector.from(p,this.d),E.id,E.label,E.priority),{dispose:()=>{this.b.$unregisterShareProvider(m),this.c.delete(m)}}}}e.$Zec=L}),define(ke[339],Se([1,0,21,3,6]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2ec=void 0;class L{static{this.a=1}constructor(p){this.c=new Map,this.d=new Map,this.b=p.getProxy(f.$vK.MainThreadSpeech)}async $createSpeechToTextSession(p,E){const m=this.c.get(p);if(!m)return;const A=new F.$Qc,P=new I.$Yd;this.d.set(E,P);const g=A.add(m.provideSpeechToTextSession(P.token));A.add(g.onDidChange(y=>{P.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(E,y)})),A.add(P.token.onCancellationRequested(()=>A.dispose()))}async $cancelSpeechToTextSession(p){this.d.get(p)?.dispose(!0),this.d.delete(p)}registerProvider(p,E,m){const A=L.a++;return this.c.set(A,m),this.b.$registerProvider(A,E,{extension:p,displayName:p.value}),(0,F.$Pc)(()=>{this.b.$unregisterProvider(A),this.c.delete(A)})}}e.$2ec=L}),define(ke[340],Se([1,0,7,6,218,3,14,18]),function($e,e,I,F,f,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zdc=e.$Ydc=void 0;class E{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new I.$sL("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new I.$sL("statusBarItem.warningForeground")]])}#e;#t;constructor(g,y,S,w,c,s=I.StatusBarAlignment.Left,i){if(this.i=!1,this.k="",this.q=new L.$Qc,this.#e=g,this.#t=y,c&&w){this.c=(0,I.$8K)(w.identifier,c);const n=S.get(this.c);n&&(s=n.alignLeft?I.StatusBarAlignment.Left:I.StatusBarAlignment.Right,i=n.priority,this.j=!0,this.name=n.name,this.text=n.text,this.tooltip=n.tooltip,this.command=n.command,this.accessibilityInformation=n.accessibilityInformation)}else this.c=String(E.a++);this.e=w,this.f=c,this.g=s,this.h=this.u(i)}u(g){if((0,p.$Df)(g))return g===Number.POSITIVE_INFINITY?Number.MAX_VALUE:g===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:g}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(g){this.k=g,this.v()}set name(g){this.m=g,this.v()}set tooltip(g){this.l=g,this.v()}set color(g){this.n=g,this.v()}set backgroundColor(g){g&&!E.b.has(g.id)&&(g=void 0),this.o=g,this.v()}set command(g){this.r?.fromApi!==g&&(this.p&&this.q.add(this.p),this.p=new L.$Qc,typeof g=="string"?this.r={fromApi:g,internal:this.#t.toInternal({title:"",command:g},this.p)}:g?this.r={fromApi:g,internal:this.#t.toInternal(g,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(g){this.t=g,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let g;this.e?this.f?g=`${this.e.identifier.value}.${this.f}`:g=this.e.identifier.value:g=this.f;let y;this.m?y=this.m:y=(0,f.localize)(0,null,this.e.displayName||this.e.name);let S=this.n;this.o&&(S=E.b.get(this.o.id));const w=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,g,this.e?.identifier.value,y,this.k,w,this.r?.internal,S,this.o,this.g===I.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Ydc=E;class m{constructor(g){this.b=[],this.a=g.createStatusBarEntry(void 0,"status.extensionMessage",I.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,f.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(g){const y={message:g};return this.b.unshift(y),this.c(),new I.$xK(()=>{const S=this.b.indexOf(y);S>=0&&(this.b.splice(S,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class A{constructor(g,y){this.e=new Map,this.a=g.getProxy(F.$vK.MainThreadStatusBar),this.b=y,this.c=new m(this)}$acceptStaticEntries(g){for(const y of g)this.e.set(y.entryId,y)}createStatusBarEntry(g,y,S,w){return new E(this.a,this.b,this.e,g,y,S,w)}setStatusBarMessage(g,y){const S=this.c.setMessage(g);let w;return typeof y=="number"?w=setTimeout(()=>S.dispose(),y):typeof y<"u"&&y.then(()=>S.dispose(),()=>S.dispose()),new I.$xK(()=>{S.dispose(),clearTimeout(w)})}}e.$Zdc=A}),define(ke[118],Se([1,0,6,4,5]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rdc=e.$qdc=void 0;class L{constructor(p,E){this.c=E,this.b=new F.$Od,this.onDidChangeStorage=this.b.event,this.a=p.getProxy(I.$vK.MainThreadStorage)}registerExtensionStorageKeysToSync(p,E){this.a.$registerExtensionStorageKeysToSync(p,E)}async initializeExtensionStorage(p,E,m){const A=await this.a.$initializeExtensionStorage(p,E);let P;return A&&(P=this.d(p,E,A)),P||m}setValue(p,E,m){return this.a.$setValue(p,E,m)}$acceptValue(p,E,m){const A=this.d(p,E,m);A&&this.b.fire({shared:p,key:E,value:A})}d(p,E,m){try{return JSON.parse(m)}catch(A){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${E}, global: ${p}): ${A}`)}}}e.$qdc=L,e.$rdc=(0,f.$Th)("IExtHostStorage")}),define(ke[92],Se([1,0,5,27,15,72,2]),function($e,e,I,F,f,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xdc=e.$wdc=void 0,e.$wdc=(0,I.$Th)("IExtensionStoragePaths");let p=class{constructor(m,A,P){this.d=A,this.f=P,this.a=m.workspace??void 0,this.b=m.environment,this.whenReady=this.h().then(g=>this.c=g)}async g(m){return R.URI.joinPath(this.b.workspaceStorageHome,m)}async h(){if(!this.a)return Promise.resolve(void 0);const m=this.a.id,A=await this.g(m);try{return await this.f.value.stat(A),this.d.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",A),await this.f.value.createDirectory(A),await this.f.value.writeFile(R.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),A}catch(P){this.d.error("[ExtHostStorage]",P);return}}workspaceValue(m){if(this.c)return R.URI.joinPath(this.c,m.identifier.value)}globalValue(m){return R.URI.joinPath(this.b.globalStorageHome,m.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$xdc=p,e.$xdc=p=He([Be(0,F.$NM),Be(1,f.$bj),Be(2,L.$vdc)],p)}),define(ke[46],Se([1,0,4,6,5,2,20,3,7,220,11,264,21,32,265,61,10,14,35]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,S,w,c,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bdc=e.$Adc=e.$zdc=e.$ydc=void 0,e.$ydc=(0,f.$Th)("IExtHostTerminalService");class n{constructor($,b,v,C){this.l=$,this._id=b,this.m=v,this.n=C,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(z=>this.f=z);const N=this;this.value={get name(){return N.n||""},get processId(){return N.b},get creationOptions(){return N.m},get exitStatus(){return N.h},get state(){return N.j},get selection(){return N.k},sendText(z,M=!0){N.q(),N.l.$sendText(N._id,z,M)},show(z){N.q(),N.l.$show(N._id,z)},hide(){N.q(),N.l.$hide(N._id)},dispose(){N.a||(N.a=!0,N.l.$dispose(N._id))},get dimensions(){if(!(N.d===void 0||N.g===void 0))return{columns:N.d,rows:N.g}}}}async create($,b){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:$.name,shellPath:$.shellPath??void 0,shellArgs:$.shellArgs??void 0,cwd:$.cwd??b?.cwd??void 0,env:$.env??void 0,icon:l($.iconPath)??void 0,color:w.ThemeColor.isThemeColor($.color)?$.color.id:void 0,initialText:$.message??void 0,strictEnv:$.strictEnv??void 0,hideFromUser:$.hideFromUser??void 0,isFeatureTerminal:b?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:b?.useShellEnvironment??void 0,location:b?.location||this.o($.location,b?.resolvedExtHostIdentifier),isTransient:$.isTransient??void 0})}async createExtensionTerminal($,b,v,C){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:v,color:w.ThemeColor.isThemeColor(C)?C.id:void 0,location:this.o($,b),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o($,b){return typeof $=="object"?"parentTerminal"in $&&$.parentTerminal&&b?{parentTerminal:b}:"viewColumn"in $?{viewColumn:s.ViewColumn.from($.viewColumn),preserveFocus:$.preserveFocus}:void 0:$}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name($){this.n=$}setExitStatus($,b){this.h=Object.freeze({code:$,reason:b})}setDimensions($,b){return $===this.d&&b===this.g||$===0||b===0?!1:(this.d=$,this.g=b,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection($){this.k=$}_setProcessId($){this.f?(this.f($),this.f=void 0):this.b.then(b=>{b!==$&&(this.b=Promise.resolve($))})}}e.$zdc=n;class o{get onProcessReady(){return this.b.event}constructor($){this.g=$,this.id=0,this.shouldPersist=!1,this.a=new I.$Od,this.onProcessData=this.a.event,this.b=new I.$Od,this.d=new I.$Od,this.onDidChangeProperty=this.d.event,this.f=new I.$Od,this.onProcessExit=this.f.event}refreshProperty($){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${$}`)}updateProperty($,b){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${$}, value: ${b}`)}async start(){}shutdown(){this.g.close()}input($){this.g.handleInput?.($)}resize($,b){this.g.setDimensions?.({columns:$,rows:b})}clearBuffer(){}async processBinary($){}acknowledgeDataEvent($){}async setUnicodeVersion($){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents($){this.g.onDidWrite(b=>this.a.fire(b)),this.g.onDidClose?.((b=void 0)=>{this.f.fire(b===void 0?void 0:b)}),this.g.onDidOverrideDimensions?.(b=>{b&&this.d.fire({type:"overrideDimensions",value:{cols:b.columns,rows:b.rows}})}),this.g.onDidChangeName?.(b=>{this.d.fire({type:"title",value:b})}),this.g.open($||void 0),$&&this.g.setDimensions?.($),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let a=1,t=class extends p.$Rc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map($=>$.value)}constructor($,b,v){super(),this.Q=b,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new p.$Sc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new I.$Od,this.onDidCloseTerminal=this.H.event,this.I=new I.$Od,this.onDidOpenTerminal=this.I.event,this.J=new I.$Od,this.onDidChangeActiveTerminal=this.J.event,this.L=new I.$Od,this.onDidChangeTerminalDimensions=this.L.event,this.M=new I.$Od,this.onDidChangeTerminalState=this.M.event,this.N=new I.$Od,this.onDidChangeShell=this.N.event,this.O=new I.$Od({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new I.$Od({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=v.getProxy(F.$vK.MainThreadTerminalService),this.y=new S.$eqb(this.a.$sendProcessData),this.a.$registerProcessSupport($),this.Q.registerArgumentProcessor({processArgument:C=>{const N=z=>{const M=z;return this.W(M.instanceId)?.value};switch(C?.$mid){case 15:return N(C);default:{if(Array.isArray(C))for(let z=0;z<C.length&&C[z].$mid===15;z++)C[z]=N(C[z]);return C}}}}),this.B({dispose:()=>{for(const[C,N]of this.g)N.shutdown(!0)}})}getDefaultShell($){return($?this.u:this.s)?.path||""}getDefaultShellArgs($){return($?this.u:this.s)?.args||[]}createExtensionTerminal($,b){const v=new n(this.a,(0,y.$fg)(),$,$.name),C=new o($.pty);return v.createExtensionTerminal($.location,this.R($,b).resolvedExtHostIdentifier,l($.iconPath),h($.color)).then(N=>{const z=this.S(N,C);this.h[N]=z}),this.f.push(v),v.value}R($,b){if(b=b||{},$.location&&typeof $.location=="object"&&"parentTerminal"in $.location){const v=$.location.parentTerminal;if(v){const C=this.f.find(N=>N.value===v);C&&(b.resolvedExtHostIdentifier=C._id)}}else $.location&&typeof $.location!="object"?b.location=$.location:b.location&&typeof b.location=="object"&&"splitActiveTerminal"in b.location&&(b.location={splitActiveTerminal:!0});return b}attachPtyToTerminal($,b){if(!this.W($))throw new Error(`Cannot resolve terminal with id ${$} for virtual process`);const C=new o(b),N=this.S($,C);this.h[$]=N}async $acceptActiveTerminalChanged($){const b=this.b;if($===null){this.b=void 0,b!==this.b&&this.J.fire(this.b);return}const v=this.W($);v&&(this.b=v,b!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData($,b){const v=this.W($);v&&this.O.fire({terminal:v.value,data:b})}async $acceptTerminalDimensions($,b,v){const C=this.W($);C&&C.setDimensions(b,v)&&this.L.fire({terminal:C.value,dimensions:C.value.dimensions})}async $acceptDidExecuteCommand($,b){const v=this.W($);v&&this.P.fire({terminal:v.value,...b})}async $acceptTerminalMaximumDimensions($,b,v){this.g.get($)?.resize(b,v)}async $acceptTerminalTitleChange($,b){const v=this.W($);v&&(v.name=b)}async $acceptTerminalClosed($,b,v){const C=this.Y(this.f,$);if(C!==null){const N=this.f.splice(C,1)[0];N.setExitStatus(b,v),this.H.fire(N.value)}}$acceptTerminalOpened($,b,v,C){if(b){const M=this.Y(this.f,b);if(M!==null){this.f[M]._id=$,this.I.fire(this.terminals[M]),this.f[M].isOpen=!0;return}}const N={name:C.name,shellPath:C.executable,shellArgs:C.args,cwd:typeof C.cwd=="string"?C.cwd:L.URI.revive(C.cwd),env:C.env,hideFromUser:C.hideFromUser},z=new n(this.a,$,N,v);this.f.push(z),this.I.fire(z.value),z.isOpen=!0}async $acceptTerminalProcessId($,b){this.W($)?._setProcessId(b)}async $startExtensionTerminal($,b){const v=this.W($);if(!v)return{message:(0,m.localize)(0,null,$)};v.isOpen||await new Promise(N=>{const z=this.onDidOpenTerminal(async M=>{M===v.value&&(z.dispose(),N())})});const C=this.g.get($);C?C.startSendingEvents(b):this.j[$]={initialDimensions:b}}S($,b){const v=new p.$Qc;v.add(b.onProcessReady(N=>this.a.$sendProcessReady($,N.pid,N.cwd,N.windowsPty))),v.add(b.onDidChangeProperty(N=>this.a.$sendProcessProperty($,N))),this.y.startBuffering($,b.onProcessData),v.add(b.onProcessExit(N=>this.U($,N))),this.g.set($,b);const C=this.j[$];return C&&b instanceof o&&(b.startSendingEvents(C.initialDimensions),delete this.j[$]),v}$acceptProcessAckDataEvent($,b){this.g.get($)?.acknowledgeDataEvent(b)}$acceptProcessInput($,b){this.g.get($)?.input(b)}$acceptTerminalInteraction($){const b=this.W($);b?.setInteractedWith()&&this.M.fire(b.value)}$acceptTerminalSelection($,b){this.W($)?.setSelection(b)}$acceptProcessResize($,b,v){try{this.g.get($)?.resize(b,v)}catch(C){if(C.code!=="EPIPE"&&C.code!=="ERR_IPC_CHANNEL_CLOSED")throw C}}$acceptProcessShutdown($,b){this.g.get($)?.shutdown(b)}$acceptProcessRequestInitialCwd($){this.g.get($)?.getInitialCwd().then(b=>this.a.$sendProcessProperty($,{type:"initialCwd",value:b}))}$acceptProcessRequestCwd($){this.g.get($)?.getCwd().then(b=>this.a.$sendProcessProperty($,{type:"cwd",value:b}))}$acceptProcessRequestLatency($){return Promise.resolve($)}registerLinkProvider($){return this.z.add($),this.z.size===1&&this.a.$startLinkProvider(),new E.$xK(()=>{this.z.delete($),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider($,b,v){if(this.C.has(b))throw new Error(`Terminal profile provider "${b}" already registered`);return this.C.set(b,v),this.a.$registerProfileProvider(b,$.identifier.value),new E.$xK(()=>{this.C.delete(b),this.a.$unregisterProfileProvider(b)})}registerTerminalQuickFixProvider($,b,v){if(this.D.has($))throw new Error(`Terminal quick fix provider "${$}" is already registered`);return this.D.set($,v),this.a.$registerQuickFixProvider($,b),new E.$xK(()=>{this.D.delete($),this.a.$unregisterQuickFixProvider($)})}async $provideTerminalQuickFixes($,b){const v=new g.$Yd().token;if(v.isCancellationRequested)return;const C=this.D.get($);if(!C)return;const N=await C.provideTerminalQuickFixes(b,v);if(N===null||Array.isArray(N)&&N.length===0)return;const z=new p.$Qc;if(this.w.value=z,!Array.isArray(N))return N?s.TerminalQuickFix.from(N,this.Q.converter,z):void 0;const M=[];for(const O of N){const j=s.TerminalQuickFix.from(O,this.Q.converter,z);j&&M.push(j)}return M}async $createContributedProfileTerminal($,b){const v=new g.$Yd().token;let C=await this.C.get($)?.provideTerminalProfile(v);if(!v.isCancellationRequested){if(C&&!("options"in C)&&(C={options:C}),!C||!("options"in C))throw new Error(`No terminal profile options provided for id "${$}"`);if("pty"in C.options){this.createExtensionTerminal(C.options,b);return}this.createTerminalFromOptions(C.options,b)}}async $provideLinks($,b){const v=this.W($);if(!v)return[];this.F.delete($),this.G.get($)?.dispose(!0);const N=new g.$Yd;this.G.set($,N);const z=[],M={terminal:v.value,line:b},O=[];for(const V of this.z)O.push(c.Promises.withAsyncBody(async q=>{N.token.onCancellationRequested(()=>q({provider:V,links:[]}));const fe=await V.provideTerminalLinks(M,N.token)||[];N.token.isCancellationRequested||q({provider:V,links:fe})}));const j=await Promise.all(O);if(N.token.isCancellationRequested)return[];const T=new Map;for(const V of j)V&&V.links.length>0&&z.push(...V.links.map(q=>{const fe={id:a++,startIndex:q.startIndex,length:q.length,label:q.tooltip};return T.set(fe.id,{provider:V.provider,link:q}),fe}));return this.F.set($,T),z}$activateLink($,b){const v=this.F.get($)?.get(b);v&&v.provider.handleTerminalLink(v.link)}U($,b){this.y.stopBuffering($),this.g.delete($),delete this.j[$];const v=this.h[$];v&&(v.dispose(),delete this.h[$]),this.a.$sendProcessExit($,b)}W($){return this.X(this.f,$)}X($,b){const v=this.Y($,b);return v!==null?$[v]:null}Y($,b){const v=$.findIndex(C=>C._id===b);return v===-1?null:v}getEnvironmentVariableCollection($){let b=this.n.get($.identifier.value);return b||(b=new r,this.$($.identifier.value,b)),b.getScopedEnvironmentVariableCollection(void 0)}Z($,b){const v=(0,P.$or)(b.map),C=(0,P.$pr)(b.descriptionMap);this.a.$setEnvironmentVariableCollection($,b.persistent,v.length===0?void 0:v,C)}$initEnvironmentVariableCollections($){$.forEach(b=>{const v=b[0],C=new r(b[1]);this.$(v,C)})}$acceptDefaultProfile($,b){const v=this.s;this.s=$,this.u=b,v?.path!==$.path&&this.N.fire($.path)}$($,b){this.n.set($,b),b.onDidChangeCollection(()=>{this.Z($,b)})}};e.$Adc=t,e.$Adc=t=He([Be(1,i.$TM),Be(2,R.$xM)],t);class r{get persistent(){return this.b}set persistent($){this.b=$,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor($){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new I.$Od,this.map=new Map($)}getScopedEnvironmentVariableCollection($){const b=this.h($);let v=this.a.get(b);return v||(v=new d(this,$),this.a.set(b,v),v.onDidChangeCollection(()=>this.d.fire())),v}replace($,b,v,C){this.f($,{value:b,type:E.EnvironmentVariableMutatorType.Replace,options:v??{applyAtProcessCreation:!0},scope:C})}append($,b,v,C){this.f($,{value:b,type:E.EnvironmentVariableMutatorType.Append,options:v??{applyAtProcessCreation:!0},scope:C})}prepend($,b,v,C){this.f($,{value:b,type:E.EnvironmentVariableMutatorType.Prepend,options:v??{applyAtProcessCreation:!0},scope:C})}f($,b){if(b.options&&b.options.applyAtProcessCreation===!1&&!b.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const v=this.g($,b.scope),C=this.map.get(v),N=b.options?{applyAtProcessCreation:b.options.applyAtProcessCreation??!1,applyAtShellIntegration:b.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!C||C.value!==b.value||C.type!==b.type||C.options?.applyAtProcessCreation!==N.applyAtProcessCreation||C.options?.applyAtShellIntegration!==N.applyAtShellIntegration||C.scope?.workspaceFolder?.index!==b.scope?.workspaceFolder?.index){const z=this.g($,b.scope),M={variable:$,...b,options:N};this.map.set(z,M),this.d.fire()}}get($,b){const v=this.g($,b),C=this.map.get(v);return C?k(C):void 0}g($,b){const v=this.h(b);return v.length?`${$}:::${v}`:$}h($){return this.j($?.workspaceFolder)??""}j($){return $?$.uri.toString():void 0}getVariableMap($){const b=new Map;for(const[v,C]of this.map)this.h(C.scope)===this.h($)&&b.set(C.variable,k(C));return b}delete($,b){const v=this.g($,b);this.map.delete(v),this.d.fire()}clear($){if($?.workspaceFolder){for(const[b,v]of this.map)v.scope?.workspaceFolder?.index===$.workspaceFolder.index&&this.map.delete(b);this.k($)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription($,b){const v=this.h(b),C=this.descriptionMap.get(v);if(!C||C.description!==$){let N;typeof $=="string"?N=$:N=$?.value.split(`

`)[0];const z={description:N,scope:b};this.descriptionMap.set(v,z),this.d.fire()}}getDescription($){const b=this.h($);return this.descriptionMap.get(b)?.description}k($){const b=this.h($);this.descriptionMap.delete(b)}}class d{get persistent(){return this.b.persistent}set persistent($){this.b.persistent=$}get onDidChangeCollection(){return this.a&&this.a.event}constructor($,b){this.b=$,this.d=b,this.a=new I.$Od}getScoped($){return this.b.getScopedEnvironmentVariableCollection($)}replace($,b,v){this.b.replace($,b,v,this.d)}append($,b,v){this.b.append($,b,v,this.d)}prepend($,b,v){this.b.prepend($,b,v,this.d)}get($){return this.b.get($,this.d)}forEach($,b){this.b.getVariableMap(this.d).forEach((v,C)=>$.call(b,C,v,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete($){this.b.delete($,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description($){this.b.setDescription($,this.d)}get description(){return this.b.getDescription(this.d)}}let u=class extends t{constructor($,b){super(!1,$,b)}createTerminal($,b,v){throw new A.$$}createTerminalFromOptions($,b){throw new A.$$}};e.$Bdc=u,e.$Bdc=u=He([Be(0,i.$TM),Be(1,R.$xM)],u);function l(D){if(!(!D||typeof D=="string"))return"id"in D?{id:D.id,color:D.color}:D}function h(D){return w.ThemeColor.isThemeColor(D)?D:void 0}function k(D){const $={...D};return delete $.scope,$.options=$.options??void 0,delete $.variable,$}}),define(ke[341],Se([1,0,121,10,22,21,4,75,52,3,24,18,32,6,20,149,14,7,68,112,89,25]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,S,w,c,s,i,n,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lec=e.$Kec=e.$Jec=e.$Iec=void 0;let t=class extends m.$Rc{constructor(M,O,j){super(),this.u=j,this.f=this.B(new R.$Od),this.g=new Map,this.s=this.B(new R.$Od),this.onResultsChanged=this.f.event,this.results=[],this.h=M.getProxy(y.$vK.MainThreadTesting),this.m=new v(this.h),this.j=new l(this.h),O.registerArgumentProcessor({processArgument:T=>{switch(T?.$mid){case 16:{const V=T,q=V.tests[V.tests.length-1].item.extId;return this.g.get(i.$lJ.root(q))?.collection.tree.get(q)?.actual??(0,w.$JM)(T)}case 18:{const{extId:V,message:q}=T;return{test:this.g.get(i.$lJ.root(V))?.collection.tree.get(V)?.actual,message:c.TestMessage.to(q)}}default:return T}}}),O.registerCommand(!1,"testing.getExplorerSelection",async()=>{const T=await O.executeCommand("_testing.getExplorerSelection"),V=q=>{const fe=this.g.get(i.$lJ.root(q));if(fe)return i.$lJ.isRoot(q)?fe.controller:fe.collection.tree.get(q)?.actual};return{include:T?.include.map(V).filter(P.$Hf)||[],exclude:T?.exclude.map(V).filter(P.$Hf)||[]}})}createTestController(M,O,j,T){if(this.g.has(O))throw new Error(`Attempt to insert a duplicate controller with ID "${O}"`);const V=new m.$Qc,q=V.add(new w.$MM(O,j,this.u));q.root.label=j;const fe=new Map,ee=new Set,Y=this.h,X={items:q.root.children,get label(){return j},set label(Z){j=Z,q.root.label=Z,Y.$updateController(O,{label:j})},get refreshHandler(){return T},set refreshHandler(Z){T=Z,Y.$updateController(O,{canRefresh:!!Z})},get id(){return O},createRunProfile:(Z,se,we,H,U,ce)=>{let Ee=(0,E.$Hi)(Z);for(;fe.has(Ee);)Ee++;return new C(this.h,fe,M,ee,this.s.event,O,Ee,Z,se,we,H,U,ce)},createTestItem(Z,se,we){return new w.$KM(O,Z,se,we)},createTestRun:(Z,se,we=!0)=>this.j.createTestRun(M,O,q,Z,se,we),invalidateTestResults:Z=>{if(Z===void 0)this.h.$markTestRetired(void 0);else{const se=Z instanceof Array?Z:[Z];this.h.$markTestRetired(se.map(we=>i.$lJ.fromExtHostTestItem(we,O).toString()))}},set resolveHandler(Z){q.resolveHandler=Z},get resolveHandler(){return q.resolveHandler},dispose:()=>{V.dispose()}};Y.$registerTestController(O,j,!!T),V.add((0,m.$Pc)(()=>Y.$unregisterTestController(O)));const ae={controller:X,collection:q,profiles:fe,extension:M,activeProfiles:ee};return this.g.set(O,ae),V.add((0,m.$Pc)(()=>this.g.delete(O))),V.add(q.onDidGenerateDiff(Z=>Y.$publishDiff(O,Z.map(o.TestsDiffOp.serialize)))),X}createTestObserver(){return this.m.checkout()}async runTests(M,O=L.CancellationToken.None){const j=h(M);if(!j)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const T=this.g.get(j.controllerId);if(!T)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:M.include?.map(V=>i.$lJ.fromExtHostTestItem(V,T.collection.root.id).toString())??[T.collection.root.id],profileGroup:N[j.kind],profileId:j.profileId,controllerId:j.controllerId}],exclude:M.exclude?.map(V=>V.id)},O)}$syncTests(){for(const{collection:M}of this.g.values())M.flushDiff();return Promise.resolve()}$provideFileCoverage(M,O,j){return(0,I.$qb)(this.j.trackers,V=>V.id===M?V.getCoverage(O):void 0)?.provideFileCoverage(j)??Promise.resolve([])}$resolveFileCoverage(M,O,j,T){return(0,I.$qb)(this.j.trackers,q=>q.id===M?q.getCoverage(O):void 0)?.resolveFileCoverage(j,T)??Promise.resolve([])}$configureRunProfile(M,O){this.g.get(M)?.profiles.get(O)?.configureHandler?.()}$setActiveRunProfiles(M){const O=new Map;for(const[j,T]of Object.entries(M)){const V=this.g.get(j);if(!V)continue;const q=new Map,fe=T.filter(Y=>!V.activeProfiles.has(Y)),ee=[...V.activeProfiles].filter(Y=>!T.includes(Y));for(const Y of fe)q.set(Y,!0),V.activeProfiles.add(Y);for(const Y of ee)q.set(Y,!1),V.activeProfiles.delete(Y);q.size&&O.set(j,q)}this.s.fire(O)}async $refreshTests(M,O){await this.g.get(M)?.controller.refreshHandler?.(O)}$publishTestResults(M){this.results=Object.freeze(M.map(O=>(0,A.$_m)(c.TestResults.to(O))).concat(this.results).sort((O,j)=>j.completedAt-O.completedAt).slice(0,32)),this.f.fire()}async $expandTest(M,O){const j=this.g.get(i.$lJ.fromString(M).controllerId)?.collection;j&&(await j.expand(M,O<0?1/0:O),j.flushDiff())}$acceptDiff(M){this.m.applyDiff(M.map(o.TestsDiffOp.deserialize))}async $runControllerTests(M,O){return Promise.all(M.map(j=>this.w(j,!1,O)))}async $startContinuousRun(M,O){const j=new L.$Yd(O),T=await Promise.all(M.map(V=>this.w(V,!0,j.token)));return!O.isCancellationRequested&&!T.some(V=>V.error)&&await new Promise(V=>O.onCancellationRequested(V)),j.dispose(!0),T}async w(M,O,j){const T=this.g.get(M.controllerId);if(!T)return{};const{collection:V,profiles:q,extension:fe}=T,ee=q.get(M.profileId);if(!ee)return{};const Y=M.testIds.map(se=>V.tree.get(se)).filter(P.$Hf),X=M.excludeExtIds.map(se=>T.collection.tree.get(se)).filter(P.$Hf).filter(se=>Y.some(we=>we.fullId.compare(se.fullId)===2));if(!Y.length)return{};const ae=new s.$6L(Y.some(se=>se.actual instanceof w.$LM)?void 0:Y.map(se=>se.actual),X.map(se=>se.actual),ee,O),Z=(0,o.$nJ)(M)&&this.j.prepareForMainThreadTestRun(ae,k.fromInternal(M,T.collection),fe,j);try{return await ee.runHandler(ae,j),{}}catch(se){return{error:String(se)}}finally{Z&&(Z.hasRunningTasks&&!j.isCancellationRequested&&await R.Event.toPromise(Z.onEnd),Z.dispose())}}$cancelExtensionTestRun(M){M===void 0?this.j.cancelAllRuns():this.j.cancelRunById(M)}};e.$Iec=t,e.$Iec=t=He([Be(0,S.$xM)],t);const r=1e4;var d;(function(z){z[z.Running=0]="Running",z[z.Cancelling=1]="Cancelling",z[z.Ended=2]="Ended"})(d||(d={}));class u extends m.$Rc{get hasRunningTasks(){return this.f.size>0}get id(){return this.m.id}constructor(M,O,j){super(),this.m=M,this.s=O,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new R.$Od),this.onEnd=this.j.event,this.h=this.B(new L.$Yd(j));const T=this.B(new F.$8g(()=>this.u(),r));this.B(this.h.token.onCancellationRequested(()=>T.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.u()}getCoverage(M){return this.f.get(M)?.coverage}createRun(M){const O=this.m.id,j=this.m.controllerId,T=(0,g.$fg)(),V=new D(this.s,O,T),q=X=>(ae,...Z)=>{if(ee){console.warn(`Setting the state of test "${ae.id}" is a no-op after the run ends.`);return}this.m.isIncluded(ae)&&(this.y(ae),X(ae,...Z))},fe=(X,ae)=>{const Z=ae instanceof Array?ae.map(c.TestMessage.from):[c.TestMessage.from(ae)];if(X.uri&&X.range){const se={range:c.Range.from(X.range),uri:X.uri};for(const we of Z)we.location=we.location||se}this.s.$appendTestMessagesInRun(O,T,i.$lJ.fromExtHostTestItem(X,j).toString(),Z)};let ee=!1;const Y={isPersisted:this.m.isPersisted,token:this.h.token,name:M,get coverageProvider(){return V.coverageProvider},set coverageProvider(X){V.coverageProvider=X},enqueued:q(X=>{this.s.$updateTestStateInRun(O,T,i.$lJ.fromExtHostTestItem(X,j).toString(),1)}),skipped:q(X=>{this.s.$updateTestStateInRun(O,T,i.$lJ.fromExtHostTestItem(X,j).toString(),5)}),started:q(X=>{this.s.$updateTestStateInRun(O,T,i.$lJ.fromExtHostTestItem(X,j).toString(),2)}),errored:q((X,ae,Z)=>{fe(X,ae),this.s.$updateTestStateInRun(O,T,i.$lJ.fromExtHostTestItem(X,j).toString(),6,Z)}),failed:q((X,ae,Z)=>{fe(X,ae),this.s.$updateTestStateInRun(O,T,i.$lJ.fromExtHostTestItem(X,j).toString(),4,Z)}),passed:q((X,ae)=>{this.s.$updateTestStateInRun(O,T,i.$lJ.fromExtHostTestItem(X,this.m.controllerId).toString(),3,ae)}),appendOutput:(X,ae,Z)=>{ee||(Z&&(this.m.isIncluded(Z)?this.y(Z):Z=void 0),this.s.$appendOutputToRun(O,T,f.$ce.fromString(X),ae&&c.location.from(ae),Z&&i.$lJ.fromExtHostTestItem(Z,j).toString()))},end:()=>{ee||(ee=!0,this.s.$finishedTestRunTask(O,T),this.f.delete(T),this.f.size||this.w())}};return this.f.set(T,{run:Y,coverage:V}),this.s.$startedTestRunTask(O,{id:T,name:M,running:!0}),Y}u(){for(const{run:M}of this.f.values())M.end()}w(){this.c!==2&&(this.c=2,this.j.fire())}y(M){if(!(M instanceof w.$KM))throw new n.$pM(M.id);if(this.g.has(i.$lJ.fromExtHostTestItem(M,this.m.controllerId).toString()))return;const O=[],j=this.m.colllection.root;for(;;){const T=c.TestItem.from(M);if(O.unshift(T),this.g.has(T.extId)||(this.g.add(T.extId),M===j))break;M=M.parent||j}this.s.$addTestsToRun(this.m.controllerId,this.m.id,O)}dispose(){this.w(),super.dispose()}}class l{get trackers(){return this.c.values()}constructor(M){this.d=M,this.c=new Map}prepareForMainThreadTestRun(M,O,j,T){return this.f(M,O,j,T)}cancelRunById(M){for(const O of this.c.values())if(O.id===M){O.cancel();return}}cancelAllRuns(){for(const M of this.c.values())M.cancel()}createTestRun(M,O,j,T,V,q){const fe=this.c.get(T);if(fe)return fe.createRun(V);const ee=k.fromPublic(O,j,T,q),Y=h(T);this.d.$startedExtensionTestRun({controllerId:O,continuous:!!T.continuous,profile:Y&&{group:N[Y.kind],id:Y.profileId},exclude:T.exclude?.map(ae=>i.$lJ.fromExtHostTestItem(ae,j.root.id).toString())??[],id:ee.id,include:T.include?.map(ae=>i.$lJ.fromExtHostTestItem(ae,j.root.id).toString())??[j.root.id],persist:q});const X=this.f(T,ee,M);return R.Event.once(X.onEnd)(()=>{this.d.$finishedExtensionTestRun(ee.id),X.dispose()}),X.createRun(V)}f(M,O,j,T){const V=new u(O,this.d,T);return this.c.set(M,V),R.Event.once(V.onEnd)(()=>this.c.delete(M)),V}}e.$Jec=l;const h=z=>{if(z.profile){if(!(z.profile instanceof C))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return z.profile}};class k{static fromPublic(M,O,j,T){return new k(M,(0,g.$fg)(),j.include?.map(V=>i.$lJ.fromExtHostTestItem(V,M).toString())??[M],j.exclude?.map(V=>i.$lJ.fromExtHostTestItem(V,M).toString())??[],T,O)}static fromInternal(M,O){return new k(M.controllerId,M.runId,M.testIds,M.excludeExtIds,!0,O)}constructor(M,O,j,T,V,q){this.controllerId=M,this.id=O,this.isPersisted=V,this.colllection=q,this.c=j.map(fe=>fe+"\0"),this.d=T.map(fe=>fe+"\0")}isIncluded(M){const O=i.$lJ.fromExtHostTestItem(M,this.controllerId).toString()+"\0";for(const j of this.d)if(O===j||O.startsWith(j))return!1;for(const j of this.c)if(O===j||O.startsWith(j))return!0;return!1}}e.$Kec=k;class D{set coverageProvider(M){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");M&&(this.c=M,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(M,O,j){this.f=M,this.g=O,this.h=j}async provideFileCoverage(M){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(M))());try{return(await this.d)?.map(c.TestCoverage.fromFile)??[]}catch(O){throw this.d=void 0,O}}async resolveFileCoverage(M,O){const j=await this.d;let T=j?.[M];return!this.c||!j||!T?[]:(T.detailedCoverage||(T=j[M]=await this.c.resolveFileCoverage?.(T,O)??T),T.detailedCoverage?.map(c.TestCoverage.fromDetailed)??[])}}class ${get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(M){this.h=M,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(M){this.c.add(M)}update(M){Object.assign(M.revived,c.TestItem.toPlain(M.item)),this.c.has(M)||this.d.add(M)}remove(M){if(this.c.has(M)){this.c.delete(M);return}this.d.delete(M);const O=i.$lJ.parentId(M.item.extId);if(O&&this.g.has(O.toString())){this.g.add(M.item.extId);return}this.f.add(M)}getChangeEvent(){const{c:M,d:O,f:j}=this;return{get added(){return[...M].map(T=>T.revived)},get updated(){return[...O].map(T=>T.revived)},get removed(){return[...j].map(T=>T.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class b extends o.$sJ{constructor(){super(...arguments),this.q=new R.$Od,this.onDidChangeTests=this.q.event}get rootTests(){return this.f}getMirroredTestDataById(M){return this.d.get(M)}getMirroredTestDataByReference(M){return this.d.get(M.id)}p(M,O){return{...M,revived:c.TestItem.toPlain(M.item),depth:O?O.depth+1:0,children:new Set}}o(){return new $(this.q)}}class v{constructor(M){this.d=M}checkout(){this.c||(this.c=this.f());const M=this.c;return M.observers++,{onDidChangeTest:M.tests.onDidChangeTests,get tests(){return[...M.tests.rootTests].map(O=>O.revived)},dispose:(0,p.$cb)(()=>{--M.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(M){return this.c?.tests.getMirroredTestDataByReference(M)}applyDiff(M){this.c?.tests.apply(M)}f(){const M=new b;return this.d.$subscribeToDiffs(),{observers:0,tests:M}}}class C{#e;#t;#i;#o;#r;get label(){return this.d}set label(M){M!==this.d&&(this.d=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:M}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(M){M!==this.g&&(this.g=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:M}))}get isDefault(){return this.f}set isDefault(M){M!==this.f&&(this.f=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:M}))}get tag(){return this._tag}set tag(M){M?.id!==this._tag?.id&&(this._tag=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:M?c.TestTag.namespace(this.controllerId,M.id):null}))}get configureHandler(){return this.c}set configureHandler(M){M!==this.c&&(this.c=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!M}))}get isSelected(){return(0,a.$vF)(this.#t,"testingActiveProfile"),this.#i.has(this.profileId)}get onDidChangeSelected(){return(0,a.$vF)(this.#t,"testingActiveProfile"),R.Event.chain(this.#o,M=>M.map(O=>O.get(this.controllerId)?.get(this.profileId)).filter(P.$Hf))}constructor(M,O,j,T,V,q,fe,ee,Y,X,ae=!1,Z=void 0,se=!1){this.controllerId=q,this.profileId=fe,this.d=ee,this.kind=Y,this.runHandler=X,this.f=ae,this._tag=Z,this.g=se,this.#e=M,this.#r=O,this.#t=j,this.#i=T,this.#o=V,O.set(fe,this);const we=N[Y];if(typeof we!="number")throw new Error(`Unknown TestRunProfile.group ${Y}`);this.#e.$publishTestRunProfile({profileId:fe,controllerId:q,tag:Z?c.TestTag.namespace(this.controllerId,Z.id):null,label:ee,group:we,isDefault:ae,hasConfigurationHandler:!1,supportsContinuousRun:se})}dispose(){this.#r?.delete(this.profileId)&&(this.#r=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$Lec=C;const N={[s.TestRunProfileKind.Coverage]:8,[s.TestRunProfileKind.Debug]:4,[s.TestRunProfileKind.Run]:2}}),define(ke[342],Se([1,0,19,11,4,6,150,14,7]),function($e,e,I,F,f,L,R,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1dc=void 0;class m{constructor(P,g){this.i=g,this.a=new f.$Od({onListenerError:F.$1}),this.b=new f.$Od({onListenerError:F.$1}),this.c=new f.$Od({onListenerError:F.$1}),this.d=new f.$Od({onListenerError:F.$1}),this.f=new f.$Od({onListenerError:F.$1}),this.g=new f.$Od({onListenerError:F.$1}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=P.getProxy(L.$vK.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(y=>this.g.fire(y)),this.i.onDidChangeActiveTextEditor(y=>this.f.fire(y))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(P){const g=this.i.allEditors();return P?g:g.map(y=>y.value)}async showTextDocument(P,g,y){let S;typeof g=="number"?S={position:p.ViewColumn.from(g),preserveFocus:y}:typeof g=="object"?S={position:p.ViewColumn.from(g.viewColumn),preserveFocus:g.preserveFocus,selection:typeof g.selection=="object"?p.Range.from(g.selection):void 0,pinned:typeof g.preview=="boolean"?!g.preview:void 0}:S={preserveFocus:!1};const w=await this.h.$tryShowTextDocument(P.uri,S),c=w&&this.i.getEditor(w);if(c)return c.value;throw w?new Error(`Could NOT open editor for "${P.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${P.uri.toString()}".`)}createTextEditorDecorationType(P,g){return new R.$EM(this.h,P,g).value}$acceptEditorPropertiesChanged(P,g){const y=this.i.getEditor(P);if(!y)throw new Error("unknown text editor");if(g.options&&y._acceptOptions(g.options),g.selections){const S=g.selections.selections.map(p.Selection.to);y._acceptSelections(S)}if(g.visibleRanges){const S=I.$Gb(g.visibleRanges.map(p.Range.to));y._acceptVisibleRanges(S)}if(g.options&&this.b.fire({textEditor:y.value,options:{...g.options,lineNumbers:p.TextEditorLineNumbersStyle.to(g.options.lineNumbers)}}),g.selections){const S=E.TextEditorSelectionChangeKind.fromValue(g.selections.source),w=g.selections.selections.map(p.Selection.to);this.a.fire({textEditor:y.value,selections:w,kind:S})}if(g.visibleRanges){const S=I.$Gb(g.visibleRanges.map(p.Range.to));this.c.fire({textEditor:y.value,visibleRanges:S})}}$acceptEditorPositionData(P){for(const g in P){const y=this.i.getEditor(g);if(!y)throw new Error("Unknown text editor");const S=p.ViewColumn.to(P[g]);y.value.viewColumn!==S&&(y._acceptViewColumn(S),this.d.fire({textEditor:y.value,viewColumn:S}))}}getDiffInformation(P){return Promise.resolve(this.h.$getDiffInformation(P))}}e.$1dc=m}),define(ke[343],Se([1,0,2,5,6,3,7,14,26,18]),function($e,e,I,F,f,L,R,p,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dec=e.$Cec=void 0,e.$Cec=(0,F.$Th)("IExtHostTimeline");class A{constructor(y,S){this.b=new Map,this.c=new Map,this.a=y.getProxy(f.$vK.MainThreadTimeline),S.registerArgumentProcessor({processArgument:(w,c)=>{if(w&&w.$mid===12)if(this.b.get(w.source)&&E.$0l.equals(c,this.b.get(w.source)?.extension)){const s=w.uri===void 0?void 0:I.URI.revive(w.uri);return this.c.get(w.source)?.get(P(s))?.get(w.handle)}else return;return w}})}async $getTimeline(y,S,w,c){return this.b.get(y)?.provider.provideTimeline(I.URI.revive(S),w,c)}registerTimelineProvider(y,S,w,c){const s=new L.$Qc,i=this.d(S.id,c,s).bind(this);let n;S.onDidChange&&(n=S.onDidChange(a=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...a,id:S.id}),this));const o=this.c;return this.f({...S,scheme:y,onDidChange:void 0,async provideTimeline(a,t,r){t?.resetCache&&(s.clear(),o.get(S.id)?.clear());const d=await S.provideTimeline(a,t,r);if(d==null)return;const u=i(a,t);return{...d,source:S.id,items:d.items.map(u)}},dispose(){for(const a of o.values())a.get(S.id)?.clear();n?.dispose(),s.dispose()}},w)}d(y,S,w){return(c,s)=>{let i;if(s?.cacheResults){let n=this.c.get(y);n===void 0&&(n=new Map,this.c.set(y,n));const o=P(c);i=n.get(o),i===void 0&&(i=new Map,n.set(o,i))}return n=>{const{iconPath:o,...a}=n,t=`${y}|${n.id??n.timestamp}`;i?.set(t,n);let r,d,u;n.iconPath&&(o instanceof R.$rL?u={id:o.id,color:o.color}:I.URI.isUri(o)?(r=o,d=o):{light:r,dark:d}=o);let l;return R.$XK.isMarkdownString(a.tooltip)?l=p.MarkdownString.from(a.tooltip):(0,m.$zf)(a.tooltip)?l=a.tooltip:R.$XK.isMarkdownString(a.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),l=p.MarkdownString.from(a.detail)):(0,m.$zf)(a.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),l=a.detail),{...a,id:a.id??void 0,handle:t,source:y,command:n.command?S.toInternal(n.command,w):void 0,icon:r,iconDark:d,themeIcon:u,tooltip:l,accessibilityInformation:n.accessibilityInformation}}}}f(y,S){if(this.b.get(y.id))throw new Error(`Timeline Provider ${y.id} already exists.`);return this.a.$registerTimelineProvider({id:y.id,label:y.label,scheme:y.scheme}),this.b.set(y.id,{provider:y,extension:S}),(0,L.$Pc)(()=>{for(const c of this.c.values())c.get(y.id)?.clear();this.b.delete(y.id),this.a.$unregisterTimelineProvider(y.id),y.dispose()})}}e.$Dec=A;function P(g){return g?.toString()}}),define(ke[73],Se([1,0,21,4,3,222,5,15,88,6,27,20,7]),function($e,e,I,F,f,L,R,p,E,m,A,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jwb=e.$Iwb=e.TunnelDtoConverter=void 0;class y extends E.$kv{}var S;(function(c){function s(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,privacy:n.privacy??(n.public?E.TunnelPrivacyId.Public:E.TunnelPrivacyId.Private),protocol:n.protocol}}c.fromApiTunnel=s;function i(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.privacy!==E.TunnelPrivacyId.ConstantPrivate&&n.privacy!==E.TunnelPrivacyId.ConstantPrivate,privacy:n.privacy,protocol:n.protocol}}c.fromServiceTunnel=i})(S||(e.TunnelDtoConverter=S={})),e.$Iwb=(0,R.$Th)("IExtHostTunnelService");let w=class extends f.$Rc{constructor(s,i,n){super(),this.s=n,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new F.$Od,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=s.getProxy(m.$vK.MainThreadTunnelService)}async openTunnel(s,i){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${s.identifier.value} called openTunnel API for ${i.remoteAddress.host}:${i.remoteAddress.port}.`);const n=await this.a.$openTunnel(i,s.displayName);if(n){const o=new y(n.remoteAddress,n.localAddress,()=>this.a.$closeTunnel(n.remoteAddress));return this.B(o),o}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(s,i){const n=this.u();return this.r.set(n,{selector:s,provider:i}),this.a.$registerPortsAttributesProvider(s,n),new g.$xK(()=>{this.r.delete(n),this.a.$unregisterPortsAttributesProvider(n)})}async $providePortAttributes(s,i,n,o,a){const t=[];for(const d of s){const u=this.r.get(d);if(!u)return[];t.push(...await Promise.all(i.map(async l=>{let h;try{h=await u.provider.providePortAttributes({port:l,pid:n,commandLine:o},a)}catch{h=await u.provider.providePortAttributes(l,n,o,a)}return{providedAttributes:h,port:l}})))}const r=t.filter(d=>!!d.providedAttributes);return r.length>0?r.map(d=>({autoForwardAction:d.providedAttributes.autoForwardAction,port:d.port})):[]}async $registerCandidateFinder(s){}registerTunnelProvider(s,i){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(o,a)=>await s.provideTunnel(o,a,new I.$Yd().token)??void 0;const n=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,privacyOptions:i.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(n),Promise.resolve((0,f.$Pc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(s,i){if(s){s.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(s.candidatePortSource),s.showCandidatePort&&(this.f=s.showCandidatePort,this.a.$setCandidateFilter());const n=s.tunnelFactory??(i?this.w(i):void 0);if(n){this.b=n;let o=s.tunnelFeatures?.privacyOptions??[];s.tunnelFeatures?.public&&o.length===0&&(o=[{id:"private",label:L.localize(0,null),themeIcon:"lock"},{id:"public",label:L.localize(1,null),themeIcon:"eye"}]);const a=s.tunnelFeatures?{elevation:!!s.tunnelFeatures?.elevation,public:!!s.tunnelFeatures?.public,privacyOptions:o}:void 0;this.a.$setTunnelProvider(a)}}else this.b=void 0;return(0,f.$Pc)(()=>{this.b=void 0})}w(s){}async $closeTunnel(s,i){if(this.g.has(s.host)){const n=this.g.get(s.host);n.has(s.port)&&(i&&n.get(s.port).disposeListener.dispose(),await n.get(s.port).tunnel.dispose(),n.delete(s.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(s,i){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const n=this.b(s,i);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),n!==void 0){const o=await n;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),o===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(s.remoteAddress.host)||this.g.set(s.remoteAddress.host,new Map);const a=this.B(o.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(o.remoteAddress))));return this.g.get(s.remoteAddress.host).set(s.remoteAddress.port,{tunnel:o,disposeListener:a}),S.fromApiTunnel(o)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(n){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),n instanceof Error)return n.message}}async $applyCandidateFilter(s){const i=await Promise.all(s.map(o=>this.f(o.host,o.port,o.detail??""))),n=s.filter((o,a)=>i[a]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${s.map(o=>o.port).join(", ")} to ${n.map(o=>o.port).join(", ")}`),n}};e.$Jwb=w,e.$Jwb=w=He([Be(0,P.$xM),Be(1,A.$NM),Be(2,p.$bj)],w)}),define(ke[344],Se([1,0,3,17,2,6]),function($e,e,I,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mec=void 0;class R{static{this.a=new Set([F.Schemas.http,F.Schemas.https])}constructor(E){this.c=new Map,this.b=E.getProxy(L.$vK.MainThreadUriOpeners)}registerExternalUriOpener(E,m,A,P){if(this.c.has(m))throw new Error(`Opener with id '${m}' already registered`);const g=P.schemes.find(y=>!R.a.has(y));if(g)throw new Error(`Scheme '${g}' is not supported. Only http and https are currently supported.`);return this.c.set(m,A),this.b.$registerUriOpener(m,P.schemes,E,P.label),(0,I.$Pc)(()=>{this.c.delete(m),this.b.$unregisterUriOpener(m)})}async $canOpenUri(E,m,A){const P=this.c.get(E);if(!P)throw new Error(`Unknown opener with id: ${E}`);const g=f.URI.revive(m);return P.canOpenExternalUri(g,A)}async $openUri(E,m,A){const P=this.c.get(E);if(!P)throw new Error(`Unknown opener id: '${E}'`);return P.openExternalUri(f.URI.revive(m.resolvedUri),{sourceUri:f.URI.revive(m.sourceUri)},A)}}e.$Mec=R}),define(ke[345],Se([1,0,6,2,3,11,26]),function($e,e,I,F,f,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3dc=void 0;class p{static{this.a=0}constructor(m){this.c=new R.$$l,this.d=new Map,this.b=m.getProxy(I.$vK.MainThreadUrls)}registerUriHandler(m,A){const P=m.identifier;if(this.c.has(P))throw new Error(`Protocol handler already registered for extension ${P}`);const g=p.a++;return this.c.add(P),this.d.set(g,A),this.b.$registerUriHandler(g,P,m.displayName||m.name),(0,f.$Pc)(()=>{this.c.delete(P),this.d.delete(g),this.b.$unregisterUriHandler(g)})}$handleExternalUri(m,A){const P=this.d.get(m);if(!P)return Promise.resolve(void 0);try{P.handleUri(F.URI.revive(A))}catch(g){(0,L.$Z)(g)}return Promise.resolve(void 0)}async createAppUri(m){return F.URI.revive(await this.b.$createAppUri(m))}}e.$3dc=p}),define(ke[93],Se([1,0,4,3,17,24,2,239,276,113,6]),function($e,e,I,F,f,L,R,p,E,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8dc=e.$7dc=e.$6dc=e.$5dc=e.$4dc=void 0;class P{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;constructor(o,a,t,r,d,u,l){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new I.$Od,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new I.$Od,this._onDidDispose=this.#h.event,this.#e=o,this.#t=a,this.#s=t,this.#o=r,this.#r=d,this.#n=u,this.#l=g(u),this.#d=y(u),this.#i=l}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(o){return this.#u=!0,(0,m.$2tb)(o,this.#o)}get cspSource(){const o=this.#n.extensionLocation;if(o.scheme===f.Schemas.https||o.scheme===f.Schemas.http){let a=o.toString();return a.endsWith("/")||(a+="/"),a+" "+m.$1tb}return m.$1tb}get html(){return this.a(),this.#a}set html(o){this.a(),this.#a!==o&&(this.#a=o,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(o)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(o)))}get options(){return this.a(),this.#s}set options(o){this.a(),L.$cn(this.#s,o)||this.#t.$setOptions(this.#e,c(this.#n,this.#r,o)),this.#s=o}async postMessage(o){if(this.#c)return!1;const a=(0,E.$0cb)(o,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,a.message,...a.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(o){if(!this.#d)return o;const a=this.#n.extensionLocation?.scheme===f.Schemas.vscodeRemote,t=this.#n.extensionLocation.scheme===f.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return o.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,d,u,l,h,k)=>{const D=R.URI.from({scheme:l||"file",path:decodeURIComponent(h)}),$=(0,m.$2tb)(D,{isRemote:a,authority:t}).toString();return`${d}${$}${k}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,d,u,l,h,k)=>{const D=R.URI.from({scheme:l||"file",path:decodeURIComponent(h)}),$=(0,m.$2tb)(D,{isRemote:a,authority:t}).toString();return`${d}${$}${k}`})}}e.$4dc=P;function g(n){try{const o=(0,p.$Ro)((0,p.$Qo)(n.engines.vscode));return!!o&&o.majorBase>=1&&o.minorBase>=57}catch{return!1}}e.$5dc=g;function y(n){try{const o=(0,p.$Ro)((0,p.$Qo)(n.engines.vscode));return o?o.majorBase<1||o.majorBase===1&&o.minorBase<60:!1}catch{return!1}}class S extends F.$Rc{constructor(o,a,t,r,d){super(),this.c=a,this.f=t,this.g=r,this.h=d,this.b=new Map,this.a=o.getProxy(A.$vK.MainThreadWebviews)}dispose(){super.dispose();for(const o of this.b.values())o.dispose();this.b.clear()}$onMessage(o,a,t){const r=this.j(o);if(r){const{message:d}=(0,E.$$cb)(a,t.value);r._onMessageEmitter.fire(d)}}$onMissingCsp(o,a){this.g.warn(`${a} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(o,a,t){const r=new P(o,this.a,s(a),this.c,this.f,t,this.h);this.b.set(o,r);const d=r._onDidDispose(()=>{d.dispose(),this.deleteWebview(o)});return r}deleteWebview(o){this.b.delete(o)}j(o){return this.b.get(o)}}e.$6dc=S;function w(n){return{id:n.identifier,location:n.extensionLocation}}e.$7dc=w;function c(n,o,a){return{enableCommandUris:a.enableCommandUris,enableScripts:a.enableScripts,enableForms:a.enableForms,portMapping:a.portMapping,localResourceRoots:a.localResourceRoots||i(n,o)}}e.$8dc=c;function s(n){return{enableCommandUris:n.enableCommandUris,enableScripts:n.enableScripts,enableForms:n.enableForms,portMapping:n.portMapping,localResourceRoots:n.localResourceRoots?.map(o=>R.URI.from(o))}}function i(n,o){return[...(o?.getWorkspaceFolders()||[]).map(a=>a.uri),n.extensionLocation]}}),define(ke[346],Se([1,0,21,52,3,17,23,2,14,93,110,6,7]),function($e,e,I,F,f,L,R,p,E,m,A,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gec=void 0;class y{constructor(r,d){this.document=r,this.b=d,this.a=1,this.c=new A.$Zcc("custom documents")}addEdit(r){return this.c.add([r])}async undo(r,d){await this.f(r).undo(),d||this.disposeBackup()}async redo(r,d){await this.f(r).redo(),d||this.disposeBackup()}disposeEdits(r){for(const d of r)this.c.delete(d)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const r=a(this.document.uri)+this.a++;return(0,R.$wg)(this.b,r)}updateBackup(r){this.d?.delete(),this.d=r}disposeBackup(){this.d?.delete(),this.d=void 0}f(r){const d=this.c.get(r,0);if(!d)throw new Error("No edit found");return d}}class S{constructor(){this.a=new Map}get(r,d){return this.a.get(this.b(r,d))}add(r,d,u){const l=this.b(r,d.uri);if(this.a.has(l))throw new Error(`Document already exists for viewType:${r} resource:${d.uri}`);const h=new y(d,u);return this.a.set(l,h),h}delete(r,d){const u=this.b(r,d.uri);this.a.delete(u)}b(r,d){return`${r}@@@${d}`}}var w;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(w||(w={}));class c{constructor(){this.a=new Map}addTextProvider(r,d,u){return this.b(0,r,d,u)}addCustomProvider(r,d,u){return this.b(1,r,d,u)}get(r){return this.a.get(r)}b(r,d,u,l){if(this.a.has(d))throw new Error(`Provider for viewType:${d} already registered`);return this.a.set(d,{type:r,extension:u,provider:l}),new g.$xK(()=>this.a.delete(d))}}class s{constructor(r,d,u,l,h){this.d=d,this.f=u,this.g=l,this.h=h,this.b=new c,this.c=new S,this.a=r.getProxy(P.$vK.MainThreadCustomEditors)}registerCustomEditorProvider(r,d,u,l){const h=new f.$Qc;return n(u)?(h.add(this.b.addTextProvider(d,r,u)),this.a.$registerTextEditorProvider((0,m.$7dc)(r),d,l.webviewOptions||{},{supportsMove:!!u.moveCustomTextEditor},(0,m.$5dc)(r))):(h.add(this.b.addCustomProvider(d,r,u)),i(u)&&h.add(u.onDidChangeCustomDocument(k=>{const D=this.i(d,k.document.uri);if(o(k)){const $=D.addEdit(k);this.a.$onDidEdit(k.document.uri,d,$,k.label)}else this.a.$onContentChange(k.document.uri,d)})),this.a.$registerCustomEditorProvider((0,m.$7dc)(r),d,l.webviewOptions||{},!!l.supportsMultipleEditorsPerDocument,(0,m.$5dc)(r))),g.$xK.from(h,new g.$xK(()=>{this.a.$unregisterEditorProvider(d)}))}async $createCustomDocument(r,d,u,l,h){const k=this.b.get(d);if(!k)throw new Error(`No provider found for '${d}'`);if(k.type!==1)throw new Error(`Invalid provide type for '${d}'`);const D=p.URI.revive(r),$=await k.provider.openCustomDocument(D,{backupId:u,untitledDocumentData:l?.buffer},h);let b;return i(k.provider)&&this.f&&(b=this.f.workspaceValue(k.extension)??this.f.globalValue(k.extension)),this.c.add(d,$,b),{editable:i(k.provider)}}async $disposeCustomDocument(r,d){const u=this.b.get(d);if(!u)throw new Error(`No provider found for '${d}'`);if(u.type!==1)throw new Error(`Invalid provider type for '${d}'`);const l=p.URI.revive(r),{document:h}=this.i(d,l);this.c.delete(d,h),h.dispose()}async $resolveCustomEditor(r,d,u,l,h,k){const D=this.b.get(u);if(!D)throw new Error(`No provider found for '${u}'`);const $=E.ViewColumn.to(h),b=this.g.createNewWebview(d,l.contentOptions,D.extension),v=this.h.createNewWebviewPanel(d,u,l.title,$,l.options,b,l.active),C=p.URI.revive(r);switch(D.type){case 1:{const{document:N}=this.i(u,C);return D.provider.resolveCustomEditor(N,v,k)}case 0:{const N=this.d.getDocument(C);return D.provider.resolveCustomTextEditor(N,v,k)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(r,d,u){this.i(d,r).disposeEdits(u)}async $onMoveCustomEditor(r,d,u){const l=this.b.get(u);if(!l)throw new Error(`No provider found for '${u}'`);if(!l.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${u}'`);const h=this.h.getWebviewPanel(r);if(!h)throw new Error("No webview found");const k=p.URI.revive(d),D=this.d.getDocument(k);await l.provider.moveCustomTextEditor(D,h,I.CancellationToken.None)}async $undo(r,d,u,l){return this.i(d,r).undo(u,l)}async $redo(r,d,u,l){return this.i(d,r).redo(u,l)}async $revert(r,d,u){const l=this.i(d,r);await this.j(d).revertCustomDocument(l.document,u),l.disposeBackup()}async $onSave(r,d,u){const l=this.i(d,r);await this.j(d).saveCustomDocument(l.document,u),l.disposeBackup()}async $onSaveAs(r,d,u,l){const h=this.i(d,r);return this.j(d).saveCustomDocumentAs(h.document,p.URI.revive(u),l)}async $backup(r,d,u){const l=this.i(d,r),k=await this.j(d).backupCustomDocument(l.document,{destination:l.getNewBackupUri()},u);return l.updateBackup(k),k.id}i(r,d){const u=this.c.get(r,p.URI.revive(d));if(!u)throw new Error("No custom document found");return u}j(r){const u=this.b.get(r)?.provider;if(!u||!i(u))throw new Error("Custom document is not editable");return u}}e.$Gec=s;function i(t){return!!t.onDidChangeCustomDocument}function n(t){return typeof t.resolveCustomTextEditor=="function"}function o(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function a(t){const r=t.scheme===L.Schemas.file||t.scheme===L.Schemas.untitled?t.fsPath:t.toString();return(0,F.$Hi)(r)+""}}),define(ke[347],Se([1,0,4,3,2,32,14,93,6,7]),function($e,e,I,F,f,L,R,p,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fec=void 0;class A extends F.$Rc{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;#h;constructor(S,w,c,s){super(),this.#s=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new I.$Od),this.onDidDispose=this.#d.event,this.#h=this.B(new I.$Od),this.onDidChangeViewState=this.#h.event,this.#e=S,this.#t=w,this.#o=c,this.#i=s.viewType,this.#r=s.panelOptions,this.#s=s.viewColumn,this.#n=s.title,this.#u=s.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#o.dispose(),super.dispose())}get webview(){return this.c(),this.#o}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(S){this.c(),this.#n!==S&&(this.#n=S,this.#t.$setTitle(this.#e,S))}get iconPath(){return this.c(),this.#a}set iconPath(S){this.c(),this.#a!==S&&(this.#a=S,this.#t.$setIconPath(this.#e,f.URI.isUri(S)?{light:S,dark:S}:S))}get options(){return this.#r}get viewColumn(){if(this.c(),!(typeof this.#s=="number"&&this.#s<0))return this.#s}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(S){this.#l||(this.active!==S.active||this.visible!==S.visible||this.viewColumn!==S.viewColumn)&&(this.#u=S.active,this.#c=S.visible,this.#s=S.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(S,w){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof S>"u"?void 0:R.ViewColumn.from(S),preserveFocus:!!w})}c(){if(this.#l)throw new Error("Webview is disposed")}}class P extends F.$Rc{static c(){return(0,L.$fg)()}constructor(S,w,c){super(),this.j=w,this.m=c,this.g=new Map,this.h=new Map,this.f=S.getProxy(E.$vK.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(S=>S.dispose()),this.g.clear()}createWebviewPanel(S,w,c,s,i={}){const n=typeof s=="object"?s.viewColumn:s,o={viewColumn:R.ViewColumn.from(n),preserveFocus:typeof s=="object"&&!!s.preserveFocus},a=(0,p.$5dc)(S),t=P.c();this.f.$createWebviewPanel((0,p.$7dc)(S),t,w,{title:c,panelOptions:g(i),webviewOptions:(0,p.$8dc)(S,this.m,i),serializeBuffersForPostMessage:a},o);const r=this.j.createNewWebview(t,i,S);return this.createNewWebviewPanel(t,w,c,n,i,r,!0)}$onDidChangeWebviewPanelViewStates(S){const w=Object.keys(S);w.sort((c,s)=>{const i=S[c],n=S[s];return i.active?1:n.active?-1:+i.visible-+n.visible});for(const c of w){const s=this.getWebviewPanel(c);if(!s)continue;const i=S[c];s._updateViewState({active:i.active,visible:i.visible,viewColumn:R.ViewColumn.to(i.position)})}}async $onDidDisposeWebviewPanel(S){this.getWebviewPanel(S)?.dispose(),this.g.delete(S),this.j.deleteWebview(S)}registerWebviewPanelSerializer(S,w,c){if(this.h.has(w))throw new Error(`Serializer for '${w}' already registered`);return this.h.set(w,{serializer:c,extension:S}),this.f.$registerSerializer(w,{serializeBuffersForPostMessage:(0,p.$5dc)(S)}),new m.$xK(()=>{this.h.delete(w),this.f.$unregisterSerializer(w)})}async $deserializeWebviewPanel(S,w,c,s){const i=this.h.get(w);if(!i)throw new Error(`No serializer found for '${w}'`);const{serializer:n,extension:o}=i,a=this.j.createNewWebview(S,c.webviewOptions,o),t=this.createNewWebviewPanel(S,w,c.title,s,c.panelOptions,a,c.active);await n.deserializeWebviewPanel(t,c.state)}createNewWebviewPanel(S,w,c,s,i,n,o){const a=new A(S,this.f,n,{viewType:w,title:c,viewColumn:s,panelOptions:i,active:o});return this.g.set(S,a),a}getWebviewPanel(S){return this.g.get(S)}}e.$Fec=P;function g(y){return{enableFindWidget:y.enableFindWidget,retainContextWhenHidden:y.retainContextWhenHidden}}}),define(ke[348],Se([1,0,4,3,93,14,6,7]),function($e,e,I,F,f,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eec=void 0;class E extends F.$Rc{#e;#t;#i;#o;#r;#n;#a;#s;#c;constructor(P,g,y,S,w,c){super(),this.#r=!1,this.#u=this.B(new I.$Od),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new I.$Od),this.onDidDispose=this.#l.event,this.#i=y,this.#a=S,this.#e=P,this.#t=g,this.#o=w,this.#n=c}dispose(){this.#r||(this.#r=!0,this.#l.fire(),this.#o.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(P){this.a(),this.#a!==P&&(this.#a=P,this.#t.$setWebviewViewTitle(this.#e,P))}get description(){return this.a(),this.#s}set description(P){this.a(),this.#s!==P&&(this.#s=P,this.#t.$setWebviewViewDescription(this.#e,P))}get visible(){return this.#n}get webview(){return this.#o}get viewType(){return this.#i}_setVisible(P){P===this.#n||this.#r||(this.#n=P,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(P){this.a(),!(P?.value===this.#c?.value&&P?.tooltip===this.#c?.tooltip)&&(this.#c=L.ViewBadge.from(P),this.#t.$setWebviewViewBadge(this.#e,P))}show(P){this.a(),this.#t.$show(this.#e,!!P)}a(){if(this.#r)throw new Error("Webview is disposed")}}class m{constructor(P,g){this.d=g,this.b=new Map,this.c=new Map,this.a=P.getProxy(R.$vK.MainThreadWebviewViews)}registerWebviewViewProvider(P,g,y,S){if(this.b.has(g))throw new Error(`View provider for '${g}' already registered`);return this.b.set(g,{provider:y,extension:P}),this.a.$registerWebviewViewProvider((0,f.$7dc)(P),g,{retainContextWhenHidden:S?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,f.$5dc)(P)}),new p.$xK(()=>{this.b.delete(g),this.a.$unregisterWebviewViewProvider(g)})}async $resolveWebviewView(P,g,y,S,w){const c=this.b.get(g);if(!c)throw new Error(`No view provider found for '${g}'`);const{provider:s,extension:i}=c,n=this.d.createNewWebview(P,{},i),o=new E(P,this.a,g,y,n,!0);this.c.set(P,o),await s.resolveWebviewView(o,{state:S},w)}async $onDidChangeWebviewViewVisibility(P,g){this.e(P)._setVisible(g)}async $disposeWebviewView(P){const g=this.e(P);this.c.delete(P),g.dispose(),this.d.deleteWebview(P)}e(P){const g=this.c.get(P);if(!g)throw new Error("No webview found");return g}}e.$Eec=m}),define(ke[153],Se([1,0,4,6,2,17,13,5,20,25]),function($e,e,I,F,f,L,R,p,E,m){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.$0dc=e.$9dc=void 0;let P=class{static{A=this}static{this.a={focused:!0,active:!0}}getState(y){const S=this.d;return{get focused(){return S.focused},get active(){return(0,m.$vF)(y,"windowActivity"),S.active}}}constructor(y){this.c=new I.$Od,this.onDidChangeWindowState=this.c.event,this.d=A.a,this.b=y.getProxy(F.$vK.MainThreadWindow),this.b.$getInitialState().then(({isFocused:S,isActive:w})=>{this.onDidChangeWindowProperty("focused",S),this.onDidChangeWindowProperty("active",w)})}$onDidChangeWindowFocus(y){this.onDidChangeWindowProperty("focused",y)}$onDidChangeWindowActive(y){this.onDidChangeWindowProperty("active",y)}onDidChangeWindowProperty(y,S){S!==this.d[y]&&(this.d={...this.d,[y]:S},this.c.fire(this.d))}openUri(y,S){let w;if(typeof y=="string"){w=y;try{y=f.URI.parse(y)}catch{return Promise.reject(`Invalid uri - '${y}'`)}}return(0,R.$Ce)(y.scheme)?Promise.reject("Invalid scheme - cannot be empty"):y.scheme===L.Schemas.command?Promise.reject(`Invalid scheme '${y.scheme}'`):this.b.$openUri(y,w,S)}async asExternalUri(y,S){if((0,R.$Ce)(y.scheme))return Promise.reject("Invalid scheme - cannot be empty");const w=await this.b.$asExternalUri(y,S);return f.URI.from(w)}};e.$9dc=P,e.$9dc=P=A=He([Be(0,E.$xM)],P),e.$0dc=(0,p.$Th)("IExtHostWindow")}),define(ke[349],Se([1,0,317,27,20]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ifc=void 0;const L=1024*1024;let R=class extends I.$0ec{constructor(E,m){super(E,m),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(E,m,A){const P=E==="error"||E==="warn"?process.stderr:process.stdout;this.g=!0,P.write(`
START_NATIVE_LOG
`),m.apply(console,A),P.write(`
END_NATIVE_LOG
`),this.g=!1}j(E,m){const A=process[E],P=A.write;let g="";Object.defineProperty(A,"write",{set:()=>{},get:()=>(y,S,w)=>{if(!this.g){g+=y.toString(S);const c=g.length>L?g.length:g.lastIndexOf(`
`);c!==-1&&(console[m](g.slice(0,c)),g=g.slice(c+1))}P.call(A,y,S,w)}})}};e.$Ifc=R,e.$Ifc=R=He([Be(0,f.$xM),Be(1,F.$NM)],R)}),define(ke[350],Se([1,0,72,17,15,251,31,12]),function($e,e,I,F,f,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jfc=void 0;let E=class{constructor(P,g){P.addFileSystemProvider(F.Schemas.file,new m(g),{isCaseSensitive:p.$l})}};e.$Jfc=E,e.$Jfc=E=He([Be(0,I.$vdc),Be(1,f.$bj)],E);class m{constructor(P){this.b=P,this.a=new L.$eq(this.b)}async stat(P){const g=await this.a.stat(P);return{type:g.type,ctime:g.ctime,mtime:g.mtime,size:g.size,permissions:g.permissions===R.FilePermission.Readonly?1:void 0}}readDirectory(P){return this.a.readdir(P)}createDirectory(P){return this.a.mkdir(P)}readFile(P){return this.a.readFile(P)}writeFile(P,g,y){return this.a.writeFile(P,g,{...y,unlock:!1,atomic:!1})}delete(P,g){return this.a.delete(P,{...g,useTrash:!1,atomic:!1})}rename(P,g,y){return this.a.rename(P,g,y)}copy(P,g,y){return this.a.copy(P,g,y)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(P,g){throw new Error("Method not implemented.")}}}),define(ke[351],Se([1,0,16,63,32,35,3,6,2,20]),function($e,e,I,F,f,L,R,p,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hfc=void 0;let A=class extends R.$Rc{constructor(g,y){super();const S=g.getProxy(p.$vK.MainThreadDownloadService);y.registerCommand(!1,"_workbench.downloadResource",async w=>{const c=E.URI.file((0,I.$ic)((0,F.tmpdir)(),(0,f.$fg)()));return await S.$download(w,c),c})}};e.$Hfc=A,e.$Hfc=A=He([Be(0,m.$xM),Be(1,L.$TM)],A)}),define(ke[352],Se([1,0,152,17,253,32]),function($e,e,I,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ufc=void 0;class R extends I.$9ec{s(E,m,A){return E.scheme===F.Schemas.file?new f.$JN(A?.name||(0,L.$fg)(),E.fsPath,!A?.donotRotate,!!A?.donotUseFormatters,m):super.s(E,m,A)}registerLogger(E){super.registerLogger(E),this.r.$registerLogger(E)}deregisterLogger(E){super.deregisterLogger(E),this.r.$deregisterLogger(E)}}e.$Ufc=R}),define(ke[353],Se([1,0,55,16,2,92,3,17,10,30]),function($e,e,I,F,f,L,R,p,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tfc=void 0;class A extends L.$xdc{constructor(){super(...arguments),this.i=null}async g(t){const r=await super.g(t);if(r.scheme!==p.Schemas.file)return r;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${r.fsPath}.`),r;const d=r.fsPath;let u=0;do{let l;u===0?l=d:l=/[/\\]$/.test(d)?`${d.substr(0,d.length-1)}-${u}`:`${d}-${u}`,await P(l);const h=F.$ic(l,"vscode.lock"),k=await w(this.d,h,!1);if(k)return this.i=k,process.on("exit",()=>{k.dispose()}),f.URI.file(l);u++}while(u<10);return r}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$Tfc=A;async function P(a){try{await m.Promises.stat(a);return}catch{}try{await m.Promises.mkdir(a,{recursive:!0})}catch{}}const g=1e3,y=10*60*1e3;class S extends R.$Rc{constructor(t,r){super(),this.b=t,this.c=r,this.a=this.B(new E.$7g),this.a.cancelAndSet(async()=>{const d=await c(t,r);(!d||d.pid!==process.pid)&&(t.info(`Lock '${r}': The lock was lost unexpectedly.`),this.a.cancel());try{await m.Promises.utimes(r,new Date,new Date)}catch(u){t.error(u),t.info(`Lock '${r}': Could not update mtime.`)}},g)}dispose(){super.dispose();try{I.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const r={pid:process.pid,willReleaseAt:Date.now()+t};await m.Promises.writeFile(this.c,JSON.stringify(r),{flag:"w"})}catch(r){this.b.error(r)}}}async function w(a,t,r){try{const u={pid:process.pid,willReleaseAt:0};await m.Promises.writeFile(t,JSON.stringify(u),{flag:"wx"})}catch(u){a.error(u)}const d=await c(a,t);return!d||d.pid!==process.pid?r?(a.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(a.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),n(a,t)):(a.info(`Lock '${t}': Lock acquired.`),new S(a,t))}async function c(a,t){let r;try{r=await m.Promises.readFile(t)}catch(d){return a.error(d),null}try{return JSON.parse(String(r))}catch(d){return a.error(d),null}}async function s(a,t){let r;try{r=await m.Promises.stat(t)}catch(d){return a.error(d),0}return r.mtime.getTime()}function i(a){try{return process.kill(a,0),!0}catch{return!1}}async function n(a,t){const r=await c(a,t);if(!r)return a.info(`Lock '${t}': Could not read pid of lock holder.`),o(a,t);if(r.willReleaseAt){let k=r.willReleaseAt-Date.now();if(k<5e3){for(k>0?a.info(`Lock '${t}': The lockfile is scheduled to be released in ${k} ms.`):a.info(`Lock '${t}': The lockfile is scheduled to have been released.`);k>0;){if(await(0,E.$Vg)(Math.min(100,k)),await s(a,t)===0)return o(a,t);k=r.willReleaseAt-Date.now()}return o(a,t)}}if(!i(r.pid))return a.info(`Lock '${t}': The pid ${r.pid} appears to be gone.`),o(a,t);const d=await s(a,t),u=Date.now()-d;if(u<=y)return a.info(`Lock '${t}': The lock does not look stale, elapsed: ${u} ms, giving up.`),null;a.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,E.$Vg)(2e3);const l=await s(a,t),h=Date.now()-l;return h<=y?(a.info(`Lock '${t}': The lock does not look stale, elapsed: ${h} ms, giving up.`),null):(a.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),o(a,t))}async function o(a,t){a.info(`Lock '${t}': Deleting a stale lock.`);try{await m.Promises.unlink(t)}catch{}return w(a,t,!0)}}),define(ke[354],Se([1,0,32,20,46,35]),function($e,e,I,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cfc=void 0;let R=class extends f.$Adc{constructor(E,m){super(!0,E,m)}createTerminal(E,m,A){return this.createTerminalFromOptions({name:E,shellPath:m,shellArgs:A})}createTerminalFromOptions(E,m){const A=new f.$zdc(this.a,(0,I.$fg)(),E,E.name);return this.f.push(A),A.create(E,this.R(E,m)),A.value}};e.$cfc=R,e.$cfc=R=He([Be(0,L.$TM),Be(1,F.$xM)],R)}),define(ke[355],Se([1,0,10,22,21,11,4,3,131,305,69]),function($e,e,I,F,f,L,R,p,E,m,A){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$m5b=e.ResponsiveState=e.RequestInitiator=e.$l5b=e.$k5b=void 0;function g(v,C){try{return JSON.stringify(v,C)}catch{return"null"}}const y="$$ref$$",S={[y]:-1};class w{constructor(C,N){this.jsonString=C,this.referencedBuffers=N}}function c(v,C=null,N=!1){const z=[];return{jsonString:(N?g:JSON.stringify)(v,(O,j)=>{if(typeof j>"u")return S;if(typeof j=="object"){if(j instanceof F.$ce){const T=z.push(j)-1;return{[y]:T}}if(C)return C(O,j)}return j}),referencedBuffers:z}}e.$k5b=c;function s(v,C,N){return JSON.parse(v,(z,M)=>{if(M){const O=M[y];if(typeof O=="number")return C[O];if(N&&M.$mid===1)return N.transformIncoming(M)}return M})}e.$l5b=s;function i(v,C){return JSON.stringify(v,C)}function n(v){return v?(C,N)=>N&&N.$mid===1?v.transformOutgoing(N):N:null}var o;(function(v){v[v.LocalSide=0]="LocalSide",v[v.OtherSide=1]="OtherSide"})(o||(e.RequestInitiator=o={}));var a;(function(v){v[v.Responsive=0]="Responsive",v[v.Unresponsive=1]="Unresponsive"})(a||(e.ResponsiveState=a={}));const t=()=>{},r=Symbol.for("rpcProtocol"),d=Symbol.for("rpcProxy");class u extends p.$Rc{static{P=r}static{this.a=3*1e3}constructor(C,N=null,z=null){super(),this[P]=!0,this.b=this.B(new R.$Od),this.onDidChangeResponsiveState=this.b.event,this.c=C,this.f=N,this.g=z,this.h=n(this.g),this.j=!1,this.m=[],this.s=[];for(let M=0,O=A.$rv.count;M<O;M++)this.m[M]=null,this.s[M]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new I.$8g(()=>this.H(),1e3)),this.c.onMessage(M=>this.L(M))}dispose(){this.j=!0,Object.keys(this.w).forEach(C=>{const N=this.w[C];delete this.w[C],N.resolveErr(L.$5())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(C){this.z===0&&(this.C=Date.now()+u.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(C){this.C=Date.now()+u.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(C){this.y!==C&&(this.y=C,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(C){return this.g?(0,E.$Sm)(C,this.g):C}getProxy(C){const{nid:N,sid:z}=C;return this.s[N]||(this.s[N]=this.J(N,z)),this.s[N]}J(C,N){const z={get:(M,O)=>(typeof O=="string"&&!M[O]&&O.charCodeAt(0)===36&&(M[O]=(...j)=>this.U(C,O,j)),O===d?N:M[O])};return new Proxy(Object.create(null),z)}set(C,N){return this.m[C.nid]=N,N}assertRegistered(C){for(let N=0,z=C.length;N<z;N++){const M=C[N];if(!this.m[M.nid])throw new Error(`Missing proxy instance ${M.sid}`)}}L(C){if(this.j)return;const N=C.byteLength,z=h.read(C,0),M=z.readUInt8(),O=z.readUInt32();switch(M){case 1:case 2:{let{rpcId:j,method:T,args:V}=D.deserializeRequestJSONArgs(z);this.g&&(V=(0,E.$Sm)(V,this.g)),this.M(N,O,j,T,V,M===2);break}case 3:case 4:{let{rpcId:j,method:T,args:V}=D.deserializeRequestMixedArgs(z);this.g&&(V=(0,E.$Sm)(V,this.g)),this.M(N,O,j,T,V,M===4);break}case 5:{this.f?.logIncoming(N,O,0,"ack"),this.G(O);break}case 6:{this.N(N,O);break}case 7:{this.O(N,O,void 0);break}case 9:{let j=D.deserializeReplyOKJSON(z);this.g&&(j=(0,E.$Sm)(j,this.g)),this.O(N,O,j);break}case 10:{const j=D.deserializeReplyOKJSONWithBuffers(z,this.g);this.O(N,O,j);break}case 8:{const j=D.deserializeReplyOKVSBuffer(z);this.O(N,O,j);break}case 11:{let j=D.deserializeReplyErrError(z);this.g&&(j=(0,E.$Sm)(j,this.g)),this.P(N,O,j);break}case 12:{this.P(N,O,void 0);break}default:console.error("received unexpected message"),console.error(C)}}M(C,N,z,M,O,j){this.f?.logIncoming(C,N,1,`receiveRequest ${(0,A.$tv)(z)}.${M}(`,O);const T=String(N);let V,q;if(j){const ee=new f.$Yd;O.push(ee.token),V=this.Q(z,M,O),q=()=>ee.cancel()}else V=this.Q(z,M,O),q=t;this.u[T]=q;const fe=D.serializeAcknowledged(N);this.f?.logOutgoing(fe.byteLength,N,1,"ack"),this.c.send(fe),V.then(ee=>{delete this.u[T];const Y=D.serializeReplyOK(N,ee,this.h);this.f?.logOutgoing(Y.byteLength,N,1,"reply:",ee),this.c.send(Y)},ee=>{delete this.u[T];const Y=D.serializeReplyErr(N,ee);this.f?.logOutgoing(Y.byteLength,N,1,"replyErr:",ee),this.c.send(Y)})}N(C,N){this.f?.logIncoming(C,N,1,"receiveCancel");const z=String(N);this.u[z]?.()}O(C,N,z){this.f?.logIncoming(C,N,0,"receiveReply:",z);const M=String(N);if(!this.w.hasOwnProperty(M))return;const O=this.w[M];delete this.w[M],O.resolveOk(z)}P(C,N,z){this.f?.logIncoming(C,N,0,"receiveReplyErr:",z);const M=String(N);if(!this.w.hasOwnProperty(M))return;const O=this.w[M];delete this.w[M];let j;z&&(z.$isError?(j=new Error,j.name=z.name,j.message=z.message,j.stack=z.stack):j=z),O.resolveErr(j)}Q(C,N,z){try{return Promise.resolve(this.S(C,N,z))}catch(M){return Promise.reject(M)}}S(C,N,z){const M=this.m[C];if(!M)throw new Error("Unknown actor "+(0,A.$tv)(C));const O=M[N];if(typeof O!="function")throw new Error("Unknown method "+N+" on actor "+(0,A.$tv)(C));return O.apply(M,z)}U(C,N,z){if(this.j)return new m.$j5b;let M=null;if(z.length>0&&f.CancellationToken.isCancellationToken(z[z.length-1])&&(M=z.pop()),M&&M.isCancellationRequested)return Promise.reject(L.$5());const O=D.serializeRequestArguments(z,this.h),j=++this.t,T=String(j),V=new m.$i5b,q=new p.$Qc;M&&q.add(M.onCancellationRequested(()=>{const ee=D.serializeCancel(j);this.f?.logOutgoing(ee.byteLength,j,0,"cancel"),this.c.send(D.serializeCancel(j))})),this.w[T]=new l(V,q),this.F(j);const fe=D.serializeRequest(j,C,N,O,!!M);return this.f?.logOutgoing(fe.byteLength,j,0,`request: ${(0,A.$tv)(C)}.${N}(`,z),this.c.send(fe),V}}e.$m5b=u;class l{constructor(C,N){this.a=C,this.b=N}resolveOk(C){this.a.resolveOk(C),this.b.dispose()}resolveErr(C){this.a.resolveErr(C),this.b.dispose()}}class h{static alloc(C,N,z){const M=new h(F.$ce.alloc(z+1+4),0);return M.writeUInt8(C),M.writeUInt32(N),M}static read(C,N){return new h(C,N)}get buffer(){return this.a}constructor(C,N){this.a=C,this.b=N}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(C){this.a.writeUInt8(C,this.b),this.b+=1}readUInt8(){const C=this.a.readUInt8(this.b);return this.b+=1,C}writeUInt32(C){this.a.writeUInt32BE(C,this.b),this.b+=4}readUInt32(){const C=this.a.readUInt32BE(this.b);return this.b+=4,C}static sizeShortString(C){return 1+C.byteLength}writeShortString(C){this.a.writeUInt8(C.byteLength,this.b),this.b+=1,this.a.set(C,this.b),this.b+=C.byteLength}readShortString(){const C=this.a.readUInt8(this.b);this.b+=1;const z=this.a.slice(this.b,this.b+C).toString();return this.b+=C,z}static sizeLongString(C){return 4+C.byteLength}writeLongString(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readLongString(){const C=this.a.readUInt32BE(this.b);this.b+=4;const z=this.a.slice(this.b,this.b+C).toString();return this.b+=C,z}writeBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}static sizeVSBuffer(C){return 4+C.byteLength}writeVSBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readVSBuffer(){const C=this.a.readUInt32BE(this.b);this.b+=4;const N=this.a.slice(this.b,this.b+C);return this.b+=C,N}static sizeMixedArray(C){let N=0;N+=1;for(let z=0,M=C.length;z<M;z++){const O=C[z];switch(N+=1,O.type){case 1:N+=this.sizeLongString(O.value);break;case 2:N+=this.sizeVSBuffer(O.value);break;case 3:N+=this.sizeUInt32,N+=this.sizeLongString(O.value);for(let j=0;j<O.buffers.length;++j)N+=this.sizeVSBuffer(O.buffers[j]);break;case 4:break}}return N}writeMixedArray(C){this.a.writeUInt8(C.length,this.b),this.b+=1;for(let N=0,z=C.length;N<z;N++){const M=C[N];switch(M.type){case 1:this.writeUInt8(1),this.writeLongString(M.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(M.value);break;case 3:this.writeUInt8(3),this.writeUInt32(M.buffers.length),this.writeLongString(M.value);for(let O=0;O<M.buffers.length;++O)this.writeBuffer(M.buffers[O]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const C=this.a.readUInt8(this.b);this.b+=1;const N=new Array(C);for(let z=0;z<C;z++)switch(this.readUInt8()){case 1:N[z]=this.readLongString();break;case 2:N[z]=this.readVSBuffer();break;case 3:{const O=this.readUInt32(),j=this.readLongString(),T=[];for(let V=0;V<O;++V)T.push(this.readVSBuffer());N[z]=new A.$uv(s(j,T,null));break}case 4:N[z]=void 0;break}return N}}var k;(function(v){v[v.Simple=0]="Simple",v[v.Mixed=1]="Mixed"})(k||(k={}));class D{static a(C){for(let N=0,z=C.length;N<z;N++)if(C[N]instanceof F.$ce||C[N]instanceof A.$uv||typeof C[N]>"u")return!0;return!1}static serializeRequestArguments(C,N){if(this.a(C)){const z=[];for(let M=0,O=C.length;M<O;M++){const j=C[M];if(j instanceof F.$ce)z[M]={type:2,value:j};else if(typeof j>"u")z[M]={type:4};else if(j instanceof A.$uv){const{jsonString:T,referencedBuffers:V}=c(j.value,N);z[M]={type:3,value:F.$ce.fromString(T),buffers:V}}else z[M]={type:1,value:F.$ce.fromString(i(j,N))}}return{type:1,args:z}}return{type:0,args:i(C,N)}}static serializeRequest(C,N,z,M,O){switch(M.type){case 0:return this.b(C,N,z,M.args,O);case 1:return this.c(C,N,z,M.args,O)}}static b(C,N,z,M,O){const j=F.$ce.fromString(z),T=F.$ce.fromString(M);let V=0;V+=h.sizeUInt8(),V+=h.sizeShortString(j),V+=h.sizeLongString(T);const q=h.alloc(O?2:1,C,V);return q.writeUInt8(N),q.writeShortString(j),q.writeLongString(T),q.buffer}static deserializeRequestJSONArgs(C){const N=C.readUInt8(),z=C.readShortString(),M=C.readLongString();return{rpcId:N,method:z,args:JSON.parse(M)}}static c(C,N,z,M,O){const j=F.$ce.fromString(z);let T=0;T+=h.sizeUInt8(),T+=h.sizeShortString(j),T+=h.sizeMixedArray(M);const V=h.alloc(O?4:3,C,T);return V.writeUInt8(N),V.writeShortString(j),V.writeMixedArray(M),V.buffer}static deserializeRequestMixedArgs(C){const N=C.readUInt8(),z=C.readShortString(),M=C.readMixedArray(),O=new Array(M.length);for(let j=0,T=M.length;j<T;j++){const V=M[j];typeof V=="string"?O[j]=JSON.parse(V):O[j]=V}return{rpcId:N,method:z,args:O}}static serializeAcknowledged(C){return h.alloc(5,C,0).buffer}static serializeCancel(C){return h.alloc(6,C,0).buffer}static serializeReplyOK(C,N,z){if(typeof N>"u")return this.d(C);if(N instanceof F.$ce)return this.e(C,N);if(N instanceof A.$uv){const{jsonString:M,referencedBuffers:O}=c(N.value,z,!0);return this.g(C,M,O)}else return this.f(C,g(N,z))}static d(C){return h.alloc(7,C,0).buffer}static e(C,N){let z=0;z+=h.sizeVSBuffer(N);const M=h.alloc(8,C,z);return M.writeVSBuffer(N),M.buffer}static deserializeReplyOKVSBuffer(C){return C.readVSBuffer()}static f(C,N){const z=F.$ce.fromString(N);let M=0;M+=h.sizeLongString(z);const O=h.alloc(9,C,M);return O.writeLongString(z),O.buffer}static g(C,N,z){const M=F.$ce.fromString(N);let O=0;O+=h.sizeUInt32,O+=h.sizeLongString(M);for(const T of z)O+=h.sizeVSBuffer(T);const j=h.alloc(10,C,O);j.writeUInt32(z.length),j.writeLongString(M);for(const T of z)j.writeBuffer(T);return j.buffer}static deserializeReplyOKJSON(C){const N=C.readLongString();return JSON.parse(N)}static deserializeReplyOKJSONWithBuffers(C,N){const z=C.readUInt32(),M=C.readLongString(),O=[];for(let j=0;j<z;++j)O.push(C.readVSBuffer());return new A.$uv(s(M,O,N))}static serializeReplyErr(C,N){const z=N?g(L.$2(N),null):void 0;if(typeof z!="string")return this.h(C);const M=F.$ce.fromString(z);let O=0;O+=h.sizeLongString(M);const j=h.alloc(11,C,O);return j.writeLongString(M),j.buffer}static deserializeReplyErrError(C){const N=C.readLongString();return JSON.parse(N)}static h(C){return h.alloc(12,C,0).buffer}}var $;(function(v){v[v.RequestJSONArgs=1]="RequestJSONArgs",v[v.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",v[v.RequestMixedArgs=3]="RequestMixedArgs",v[v.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",v[v.Acknowledged=5]="Acknowledged",v[v.Cancel=6]="Cancel",v[v.ReplyOKEmpty=7]="ReplyOKEmpty",v[v.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",v[v.ReplyOKJSON=9]="ReplyOKJSON",v[v.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",v[v.ReplyErrError=11]="ReplyErrError",v[v.ReplyErrEmpty=12]="ReplyErrEmpty"})($||($={}));var b;(function(v){v[v.String=1]="String",v[v.VSBuffer=2]="VSBuffer",v[v.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",v[v.Undefined=4]="Undefined"})(b||(b={}))}),define(ke[356],Se([1,0,4,38,45,5]),function($e,e,I,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OJ=e.$NJ=e.OutputChannelUpdateMode=e.$MJ=e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=void 0,e.$DJ="text/x-code-output",e.$EJ="output",e.$FJ="Log",e.$GJ="text/x-code-log-output",e.$HJ="log",e.$IJ="workbench.panel.output",e.$JJ=new f.$$i("inOutput",!1),e.$KJ=new f.$$i("activeLogOutput",!1),e.$LJ=new f.$$i("outputView.scrollLock",!1),e.$MJ=(0,L.$Th)("outputService");var R;(function(E){E[E.Append=1]="Append",E[E.Replace=2]="Replace",E[E.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$NJ={OutputChannels:"workbench.contributions.outputChannels"};class p{constructor(){this.a=new Map,this.b=new I.$Od,this.onDidRegisterChannel=this.b.event,this.c=new I.$Od,this.onDidRemoveChannel=this.c.event}registerChannel(m){this.a.has(m.id)||(this.a.set(m.id,m),this.b.fire(m.id))}getChannels(){const m=[];return this.a.forEach(A=>m.push(A)),m}getChannel(m){return this.a.get(m)}removeChannel(m){this.a.delete(m),this.c.fire(m)}}F.$kn.add(e.$NJ.OutputChannels,new p),e.$OJ=new f.$$i("activeOutputChannel","")}),define(ke[154],Se([1,0,6,5,20,26,15,356,72,27,57,182,22,18,31,4,3]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,S,w,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tdc=e.$Sdc=void 0;class s extends R.$hj{get disposed(){return this.n}constructor(a,t,r,d,u){super(),this.id=a,this.name=t,this.r=r,this.s=d,this.extension=u,this.m=0,this.n=!1,this.visible=!1,this.setLevel(r.getLevel()),this.B(r.onDidChangeLogLevel(l=>this.setLevel(l)))}get logLevel(){return this.getLevel()}appendLine(a){this.append(a+`
`)}append(a){this.info(a)}clear(){const a=this.m;this.r.flush(),this.s.$update(this.id,p.OutputChannelUpdateMode.Clear,a)}replace(a){const t=this.m;this.info(a),this.s.$update(this.id,p.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(a,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof a=="boolean"?a:t))}hide(){this.s.$close(this.id)}g(a,t){this.m+=g.$ce.fromString(t).byteLength,(0,R.log)(this.r,a,t),this.visible&&(this.r.flush(),this.s.$update(this.id,p.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class i extends s{appendLine(a){this.append(a)}}let n=class{constructor(a,t,r,d,u,l){this.i=t,this.j=r,this.k=d,this.l=u,this.m=l,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=a.getProxy(I.$vK.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,P.$im)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(a){this.h=a;for(const[t,r]of this.g)r.visible=t===this.h}createOutputChannel(a,t,r){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");const d=typeof t=="object"&&t.log,u=(0,y.$zf)(t)?t:void 0;if((0,y.$zf)(u)&&!u.trim())throw new Error("illegal argument `languageId`. must not be empty");let l;const h=this.i.environment.extensionLogLevel?.find(([D])=>L.$0l.equals(r.identifier,D))?.[1];h&&(l=(0,R.$rj)(h));const k=d?this.o(a,l,r):this.n(a,u,r);return k.then(D=>{this.g.set(D.id,D),D.visible=D.id===this.h}),d?this.r(a,l??this.m.getLevel(),k):this.q(a,k)}async n(a,t,r){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const d=await this.c,u=this.k.extUri.joinPath(d,`${this.f++}-${a.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),l=this.l.createLogger(u,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),h=await this.a.$register(a,u,t,r.identifier.value);return new s(h,a,l,this.a,r)}async o(a,t,r){const d=await this.p(r),u=a.replace(/[\\/:\*\?"<>\|]/g,""),l=this.k.extUri.joinPath(d,`${u}.log`),h=`${r.identifier.value}.${u}`,k=this.l.createLogger(l,{id:h,name:a,logLevel:t,extensionId:r.identifier.value});return new i(h,a,k,this.a,r)}p(a){let t=this.d.get(a.identifier.value);if(!t){const r=this.k.extUri.joinPath(this.i.logsLocation,a.identifier.value);this.d.set(a.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(r)}catch(d){if((0,S.$sk)(d)!==S.FileSystemProviderErrorCode.FileExists)throw d}return r})())}return t}q(a,t){let r=!1;const d=()=>{if(r)throw new Error("Channel has been closed")};return{get name(){return a},append(u){d(),t.then(l=>l.append(u))},appendLine(u){d(),t.then(l=>l.appendLine(u))},clear(){d(),t.then(u=>u.clear())},replace(u){d(),t.then(l=>l.replace(u))},show(u,l){d(),t.then(h=>h.show(u,l))},hide(){d(),t.then(u=>u.hide())},dispose(){r=!0,t.then(u=>u.dispose())}}}r(a,t,r){const d=new c.$Qc,u=()=>{if(d.isDisposed)throw new Error("Channel has been closed")},l=d.add(new w.$Od);function h(k){t=k,l.fire(k)}return r.then(k=>{d.add(k),k.logLevel!==t&&h(k.logLevel),d.add(k.onDidChangeLogLevel(D=>h(D)))}),{...this.q(a,r),get logLevel(){return t},onDidChangeLogLevel:l.event,trace(k,...D){u(),r.then($=>$.trace(k,...D))},debug(k,...D){u(),r.then($=>$.debug(k,...D))},info(k,...D){u(),r.then($=>$.info(k,...D))},warn(k,...D){u(),r.then($=>$.warn(k,...D))},error(k,...D){u(),r.then($=>$.error(k,...D))},dispose(){d.dispose()}}}};e.$Sdc=n,e.$Sdc=n=He([Be(0,f.$xM),Be(1,m.$NM),Be(2,E.$vdc),Be(3,A.$3cc),Be(4,R.$cj),Be(5,R.$bj)],n),e.$Tdc=(0,F.$Th)("IExtHostOutputService")}),define(ke[155],Se([1,0,5,10]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ym=e.$xm=void 0,e.$xm=(0,I.$Th)("remoteAgentService"),e.$ym=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(f){let L=1/0;for(let p=0;p<this.maxSampleCount;p++){const E=await f.getRoundTripTime();if(E===void 0)return;L=Math.min(L,E/2),await(0,F.$Vg)(this.sampleDelay)}this.average.push(L),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(L):R=this.initial.reduce((p,E)=>p+E,0)/this.initial.length,this.lastMeasurement={initial:R,current:L,average:this.average.reduce((p,E)=>p+E,0)/this.average.length,high:(()=>typeof R>"u"?!1:L>this.highLatencyMaxThreshold||L>this.highLatencyMinThreshold&&L>R*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(ke[357],Se([1,0,225,86,38,40,44,3,4,155,12]),function($e,e,I,F,f,L,R,p,E,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sH=e.$rH=e.$qH=e.$pH=e.$oH=e.$nH=void 0,e.$nH=Object.freeze({id:"application",order:100,title:(0,I.localize)(0,null),type:"object"}),e.$oH=Object.freeze({id:"workbench",order:7,title:(0,I.localize)(1,null),type:"object"}),e.$pH=Object.freeze({id:"security",scope:1,title:(0,I.localize)(2,null),type:"object",order:7}),e.$qH={ConfigurationMigration:"base.contributions.configuration.migration"};class P{constructor(){this.migrations=[],this.a=new E.$Od,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(c){this.migrations.push(...c)}}const g=new P;f.$kn.add(e.$qH.ConfigurationMigration,g);let y=class extends p.$Rc{constructor(c,s){super(),this.a=c,this.b=s,this.B(this.b.onDidChangeWorkspaceFolders(async i=>{for(const n of i.added)await this.f(n,g.migrations)})),this.c(g.migrations),this.B(g.onDidRegisterConfigurationMigration(i=>this.c(i)))}async c(c){await this.f(void 0,c);for(const s of this.b.getWorkspace().folders)await this.f(s,c)}async f(c,s){await Promise.all(s.map(i=>this.g(i,{resource:c?.uri})))}async g(c,s){const i=this.a.inspect(c.key,s);if(await this.h(c,s,i,"userValue",2),await this.h(c,s,i,"userLocalValue",3),await this.h(c,s,i,"userRemoteValue",4),await this.h(c,s,i,"workspaceFolderValue",6),await this.h(c,s,i,"workspaceValue",5),typeof s.overrideIdentifier>"u"&&typeof i.overrideIdentifiers<"u")for(const n of i.overrideIdentifiers)await this.g(c,{resource:s.resource,overrideIdentifier:n})}async h(c,s,i,n,o){const a=i[n];if(typeof a>"u")return;const t=u=>this.a.inspect(u,s)[n],r=await c.migrateFn(a,t),d=Array.isArray(r)?r:[[c.key,r]];await Promise.allSettled(d.map(async([u,l])=>this.a.updateValue(u,l.value,s,o)))}};e.$rH=y,e.$rH=y=He([Be(0,R.$ni),Be(1,L.$3h)],y);let S=class extends p.$Rc{constructor(c){super(),(async()=>{if(!A.$j&&(await c.getEnvironment())?.os!==1)return;f.$kn.as(F.$pn.Configuration).registerConfiguration({...e.$pH,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,I.localize)(3,null)},default:[],markdownDescription:(0,I.localize)(4,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,I.localize)(5,null),scope:2}}})})()}};e.$sH=S,e.$sH=S=He([Be(0,m.$xm)],S)}),define(ke[358],Se([1,0,34,17,16,23,234,357,86,5,38]),function($e,e,I,F,f,L,R,p,E,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rcb=e.$qcb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$pcb=e.$ocb=void 0,e.$ocb=(0,m.$Th)("editorResolverService"),e.$pcb="workbench.editorAssociations";const P=A.$kn.as(E.$pn.Configuration),g={...p.$oH,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,R.localize)(0,null),additionalProperties:{type:"string"}}}};P.registerConfiguration(g);var y;(function(s){s.builtin="builtin",s.option="option",s.exclusive="exclusive",s.default="default"})(y||(e.RegisteredEditorPriority=y={}));var S;(function(s){s[s.ABORT=1]="ABORT",s[s.NONE=2]="NONE"})(S||(e.ResolvedStatus=S={}));function w(s){switch(s){case y.exclusive:return 5;case y.default:return 4;case y.builtin:return 3;case y.option:default:return 1}}e.$qcb=w;function c(s,i){if(new Set([F.Schemas.extension,F.Schemas.webviewPanel,F.Schemas.vscodeWorkspaceTrust,F.Schemas.vscodeSettings]).has(i.scheme))return!1;const a=typeof s=="string"&&s.indexOf(f.$fc.sep)>=0?`${i.scheme}:${i.path}`:(0,L.$tg)(i);return I.$zj(typeof s=="string"?s.toLowerCase():s,a.toLowerCase())}e.$rcb=c}),define(ke[359],Se([1,0,33,17,16,12,23,2,5,269,40,146,155]),function($e,e,I,F,f,L,R,p,E,m,A,P,g){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$8J=e.$7J=void 0,e.$7J=(0,E.$Th)("pathService");let S=y=class{constructor(c,s,i,n){this.d=c,this.e=s,this.f=i,this.g=n,this.a=(async()=>(await this.e.getEnvironment())?.os||L.OS)(),this.b=(async()=>{const o=await this.e.getEnvironment();return this.c=o?.userHome??c})()}hasValidBasename(c,s,i){return typeof s=="string"||typeof s>"u"?this.a.then(n=>this.h(c,n,s)):this.h(c,s,i)}h(c,s,i){return c.scheme===F.Schemas.file||c.scheme===F.Schemas.vscodeRemote?(0,I.$Wf)(i??(0,R.$tg)(c),s===1):!0}get defaultUriScheme(){return y.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(c,s){if(c.remoteAuthority)return F.Schemas.vscodeRemote;const i=(0,m.$4J)(s.getWorkspace());if(i)return i;const n=s.getWorkspace().folders[0];if(n)return n.uri.scheme;const o=s.getWorkspace().configuration;return o?o.scheme:F.Schemas.file}userHome(c){return c?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(c=>c===1?f.$ec:f.$fc)}async fileURI(c){let s="";if(await this.a===1&&(c=c.replace(/\\/g,"/")),c[0]==="/"&&c[1]==="/"){const n=c.indexOf("/",2);n===-1?(s=c.substring(2),c="/"):(s=c.substring(2,n),c=c.substring(n)||"/")}return p.URI.from({scheme:F.Schemas.file,authority:s,path:c,query:"",fragment:""})}};e.$8J=S,e.$8J=S=y=He([Be(1,g.$xm),Be(2,P.$PJ),Be(3,A.$3h)],S)}),define(ke[360],Se([1,0,236,19,59,4,52,3,2,44,241,15,65,271,88,40,146,25,21,18,24,45]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,S,w,c,s,i,n,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1J=e.$ZJ=e.$YJ=e.OnPortForward=e.$XJ=e.$WJ=e.$VJ=e.$UJ=e.$TJ=e.TunnelSource=e.TunnelCloseReason=e.$SJ=e.$RJ=e.$QJ=void 0;const t=10*1e3,r="remote.tunnels.toRestore";e.$QJ="onTunnel",e.$RJ=new a.$$i("forwardedPortsViewEnabled",!1,I.localize(0,null));function d(N){const z=N.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(z)return{host:z[1]?.substring(0,z[1].length-1)||"localhost",port:Number(z[2])}}e.$SJ=d;var u;(function(N){N.Other="Other",N.User="User",N.AutoForwardEnd="AutoForwardEnd"})(u||(e.TunnelCloseReason=u={}));var l;(function(N){N[N.User=0]="User",N[N.Auto=1]="Auto",N[N.Extension=2]="Extension"})(l||(e.TunnelSource=l={})),e.$TJ={source:l.User,description:I.localize(1,null)},e.$UJ={source:l.Auto,description:I.localize(2,null)};function h(N,z,M){const O=N.get(D(z,M));if(O)return O;if((0,S.$gv)(z))for(const j of S.$fv){const T=D(j,M);if(N.has(T))return N.get(T)}else if((0,S.$iv)(z))for(const j of S.$hv){const T=D(j,M);if(N.has(T))return N.get(T)}}e.$VJ=h;function k(N,z,M){const O=h(N,z,M);if(O)return O;const j=(0,S.$iv)(z)?"localhost":(0,S.$gv)(z)?"0.0.0.0":void 0;if(j)return h(N,j,M)}e.$WJ=k;function D(N,z){return N+":"+z}e.$XJ=D;var $;(function(N){N.Notify="notify",N.OpenBrowser="openBrowser",N.OpenBrowserOnce="openBrowserOnce",N.OpenPreview="openPreview",N.Silent="silent",N.Ignore="ignore"})($||(e.OnPortForward=$={}));function b(N){return N&&"host"in N&&typeof N.host=="string"&&"port"in N&&typeof N.port=="number"&&(!("detail"in N)||typeof N.detail=="string")&&(!("pid"in N)||typeof N.pid=="string")}e.$YJ=b;class v extends p.$Rc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(z){super(),this.r=z,this.j=[],this.n=new L.$Od,this.onDidChangeAttributes=this.n.event,this.B(z.onDidChangeConfiguration(M=>{(M.affectsConfiguration(v.c)||M.affectsConfiguration(v.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(z,M,O){let j=this.w(z,M,O,this.j,0);const T={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;j>=0;){const V=this.j[j];V.key===z?(T.onAutoForward=V.onAutoForward??T.onAutoForward,T.elevateIfNeeded=V.elevateIfNeeded!==void 0?V.elevateIfNeeded:T.elevateIfNeeded,T.label=V.label??T.label,T.requireLocalPort=V.requireLocalPort,T.protocol=V.protocol):(T.onAutoForward=T.onAutoForward??V.onAutoForward,T.elevateIfNeeded=T.elevateIfNeeded!==void 0?T.elevateIfNeeded:V.elevateIfNeeded,T.label=T.label??V.label,T.requireLocalPort=T.requireLocalPort!==void 0?T.requireLocalPort:void 0,T.protocol=T.protocol??V.protocol),j=this.w(z,M,O,this.j,j+1)}return T.onAutoForward!==void 0||T.elevateIfNeeded!==void 0||T.label!==void 0||T.requireLocalPort!==void 0||T.protocol!==void 0?T:this.C()}t(z){return z.start!==void 0&&z.end!==void 0}u(z){return z.host!==void 0&&z.port!==void 0&&(0,n.$zf)(z.host)&&(0,n.$Df)(z.port)}w(z,M,O,j,T){if(T>=j.length)return-1;const V=!(0,S.$gv)(M)&&!(0,S.$iv)(M),fe=j.slice(T).findIndex(ee=>(0,n.$Df)(ee.key)?V?!1:ee.key===z:this.t(ee.key)?V?!1:z>=ee.key.start&&z<=ee.key.end:this.u(ee.key)?z===ee.key.port&&M===ee.key.host:O?ee.key.test(O):!1);return fe>=0?fe+T:-1}y(){const z=this.r.getValue(v.c);if(!z||!(0,n.$Bf)(z))return[];const M=[];for(const j in z){if(j===void 0)continue;const T=z[j];let V;if(Number(j))V=Number(j);else if((0,n.$zf)(j))if(v.g.test(j)){const q=j.match(v.g);V={start:Number(q[1]),end:Number(q[2])}}else if(v.h.test(j)){const q=j.match(v.h);V={host:q[1],port:Number(q[2])}}else{let q;try{q=RegExp(j)}catch{}q&&(V=q)}V&&M.push({key:V,elevateIfNeeded:T.elevateIfNeeded,onAutoForward:T.onAutoForward,label:T.label,requireLocalPort:T.requireLocalPort,protocol:T.protocol})}const O=this.r.getValue(v.f);return O&&(this.m={elevateIfNeeded:O.elevateIfNeeded,label:O.label,onAutoForward:O.onAutoForward,requireLocalPort:O.requireLocalPort,protocol:O.protocol}),this.z(M)}z(z){function M(O,j){return(0,n.$Df)(O.key)?O.key:j.t(O.key)?O.key.start:j.u(O.key)?O.key.port:Number.MAX_VALUE}return z.sort((O,j)=>M(O,this)-M(j,this))}C(){return this.m}static providedActionToAction(z){switch(z){case S.ProvidedOnAutoForward.Notify:return $.Notify;case S.ProvidedOnAutoForward.OpenBrowser:return $.OpenBrowser;case S.ProvidedOnAutoForward.OpenBrowserOnce:return $.OpenBrowserOnce;case S.ProvidedOnAutoForward.OpenPreview:return $.OpenPreview;case S.ProvidedOnAutoForward.Silent:return $.Silent;case S.ProvidedOnAutoForward.Ignore:return $.Ignore;default:return}}async addAttributes(z,M,O){const T=this.r.inspect(v.c).userRemoteValue;let V;!T||!(0,n.$Bf)(T)?V={}:V=(0,o.$$m)(T),V[`${z}`]||(V[`${z}`]={});for(const q in M)V[`${z}`][q]=M[q];return this.r.updateValue(v.c,V,O)}}e.$ZJ=v;let C=class extends p.$Rc{constructor(z,M,O,j,T,V,q,fe,ee,Y){super(),this.H=z,this.I=M,this.J=O,this.L=j,this.M=T,this.N=V,this.O=q,this.P=fe,this.Q=ee,this.R=Y,this.c=new Map,this.g=new L.$Od,this.onForwardPort=this.g.event,this.h=new L.$Od,this.onClosePort=this.h.event,this.j=new L.$Od,this.onPortName=this.j.event,this.n=new L.$Od,this.onCandidatesChanged=this.n.event,this.t=new L.$Od,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new L.$Od,this.D=new Map,this.F=new Map,this.G=[],this.ab=new Date,this.configPortsAttributes=new v(O),this.s=this.Z(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.gb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async X=>{const ae=await this.getAttributes(X.map(Z=>({port:Z.tunnelRemotePort,host:Z.tunnelRemoteHost})));for(const Z of X)if(Z.localAddress){const se=D(Z.tunnelRemoteHost,Z.tunnelRemotePort),we=k(this.m??new Map,Z.tunnelRemoteHost,Z.tunnelRemotePort);this.forwarded.set(se,{remotePort:Z.tunnelRemotePort,remoteHost:Z.tunnelRemoteHost,localAddress:Z.localAddress,protocol:ae?.get(Z.tunnelRemotePort)?.protocol??S.TunnelProtocol.Http,localUri:await this.X(Z.localAddress,ae?.get(Z.tunnelRemotePort)),localPort:Z.tunnelLocalPort,runningProcess:we?.detail,hasRunningProcess:!!we,pid:we?.pid,privacy:Z.privacy,source:e.$TJ}),this.f.set(se,Z)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async X=>{const ae=D(X.tunnelRemoteHost,X.tunnelRemotePort);if(!k(this.forwarded,X.tunnelRemoteHost,X.tunnelRemotePort)&&!k(this.detected,X.tunnelRemoteHost,X.tunnelRemotePort)&&!k(this.c,X.tunnelRemoteHost,X.tunnelRemotePort)&&X.localAddress){const Z=k(this.m??new Map,X.tunnelRemoteHost,X.tunnelRemotePort),se=(await this.getAttributes([{port:X.tunnelRemotePort,host:X.tunnelRemoteHost}]))?.get(X.tunnelRemotePort);this.forwarded.set(ae,{remoteHost:X.tunnelRemoteHost,remotePort:X.tunnelRemotePort,localAddress:X.localAddress,protocol:se?.protocol??S.TunnelProtocol.Http,localUri:await this.X(X.localAddress,se),localPort:X.tunnelLocalPort,closeable:!0,runningProcess:Z?.detail,hasRunningProcess:!!Z,pid:Z?.pid,privacy:X.privacy,source:e.$TJ})}await this.$(),this.f.set(ae,X),this.g.fire(this.forwarded.get(ae))})),this.B(this.H.onTunnelClosed(X=>this.W(X,u.Other))),this.U()}S(){return this.Q.extensions.find(z=>z.activationEvents?.includes(e.$QJ))?(this.R.createKey(e.$RJ.key,!0),!0):!1}U(){if(this.S())return;const z=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&z.dispose()}))}async W(z,M){const O=D(z.host,z.port);this.forwarded.has(O)&&(this.forwarded.delete(O),await this.$(),this.h.fire(z))}X(z,M){if(z.startsWith("http"))return E.URI.parse(z);const O=M?.protocol??"http";return E.URI.parse(`${O}://${z}`)}async Y(){const z=this.N.getWorkspace(),M=z.configuration?(0,R.$Hi)(z.configuration.path):z.folders.length>0?(0,R.$Hi)(z.folders[0].uri.path):void 0;if(M===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${r}.${this.L.remoteAuthority}.${M}`}async Z(){const z=this.I.get(r,1);if(z)return this.I.remove(r,1),await this.$(),z;const M=await this.Y();if(M)return this.I.get(M,0)}async restoreForwarded(){if(this.J.getValue("remote.restoreForwardedPorts")){const z=await this.s;if(z&&z!==this.y){const M=JSON.parse(z)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${M.map(O=>O.remotePort).join(", ")}`);for(const O of M){const j=k(this.detected,O.remoteHost,O.remotePort);O.source.source!==l.Extension&&!j||O.source.source===l.Extension&&j?await this.cb({remote:{host:O.remoteHost,port:O.remotePort},local:O.localPort,name:O.name,privacy:O.privacy,elevateIfNeeded:!0,source:O.source}):O.source.source===l.Extension&&!j&&this.D.set(D(O.remoteHost,O.remotePort),O)}}}if(this.z=!0,this.C.fire(),!this.w){const z=await this.Y();this.w=this.B(new p.$Qc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async M=>{M.key===z&&(this.s=Promise.resolve(this.I.get(z,0)),await this.restoreForwarded())}))}}async $(){if(this.J.getValue("remote.restoreForwardedPorts")){const z=JSON.stringify(Array.from(this.forwarded.values()));if(z!==this.y){this.y=z;const M=await this.Y();M&&this.I.store(M,this.y,0,0)}}}async bb(z,M,O){if(!z.tunnelLocalPort||!O?.requireLocalPort||z.tunnelLocalPort===M)return;const j=new Date;if(this.ab.getTime()+t>j.getTime())return;this.ab=j;const T=I.localize(3,null,M,z.tunnelRemotePort,z.tunnelLocalPort);return this.P.info(T)}async forward(z,M){return!this.z&&this.L.remoteAuthority&&await L.Event.toPromise(this.C.event),this.cb(z,M)}async cb(z,M){await this.Q.activateByEvent(e.$QJ);const O=k(this.forwarded,z.remote.host,z.remote.port);M=M??(M!==null?(await this.getAttributes([z.remote]))?.get(z.remote.port):void 0);const j=z.local!==void 0?z.local:z.remote.port;let T;if(O)return this.eb(O,z,M);{const V=this.L.remoteAuthority,q=V?{getAddress:async()=>(await this.M.resolveAuthority(V)).authority}:void 0,fe=D(z.remote.host,z.remote.port);this.c.set(fe,!0),z=this.db(fe,z);const ee=await this.H.openTunnel(q,z.remote.host,z.remote.port,void 0,j,z.elevateIfNeeded?z.elevateIfNeeded:M?.elevateIfNeeded,z.privacy,M?.protocol);if(typeof ee=="string")T=ee;else if(ee&&ee.localAddress){const Y=k(this.m??new Map,z.remote.host,z.remote.port),X=ee.protocol?ee.protocol===S.TunnelProtocol.Https?S.TunnelProtocol.Https:S.TunnelProtocol.Http:M?.protocol??S.TunnelProtocol.Http,ae={remoteHost:ee.tunnelRemoteHost,remotePort:ee.tunnelRemotePort,localPort:ee.tunnelLocalPort,name:M?.label??z.name,closeable:!0,localAddress:ee.localAddress,protocol:X,localUri:await this.X(ee.localAddress,M),runningProcess:Y?.detail,hasRunningProcess:!!Y,pid:Y?.pid,source:z.source??e.$TJ,privacy:ee.privacy};return this.forwarded.set(fe,ae),this.f.set(fe,ee),this.c.delete(fe),await this.$(),await this.bb(ee,j,M),this.g.fire(ae),ee}this.c.delete(fe)}return T}db(z,M){const O=this.D.has(z)?this.D:this.F.has(z)?this.F:void 0;if(O){const j=O.get(z);O.delete(z),j&&(M.name=j.name??M.name,M.local=("local"in j?j.local:"localPort"in j?j.localPort:void 0)??M.local,M.privacy=j.privacy??M.privacy)}return M}async eb(z,M,O){const j=O?.label??M.name;let T;(function(q){q[q.None=0]="None",q[q.Fire=1]="Fire",q[q.Reopen=2]="Reopen"})(T||(T={}));let V=T.None;switch(j!==z.name&&(z.name=j,V=T.Fire),(O?.protocol||z.protocol!==S.TunnelProtocol.Http)&&O?.protocol!==z.protocol&&(M.source=z.source,V=T.Reopen),M.privacy&&z.privacy!==M.privacy&&(V=T.Reopen),V){case T.Fire:{this.g.fire();break}case T.Reopen:await this.close(z.remoteHost,z.remotePort,u.User),await this.cb(M,O)}return k(this.f,M.remote.host,M.remote.port)}async name(z,M,O){const j=k(this.forwarded,z,M),T=D(z,M);if(j){j.name=O,await this.$(),this.j.fire({host:z,port:M});return}else this.detected.has(T)&&(this.detected.get(T).name=O,this.j.fire({host:z,port:M}))}async close(z,M,O){const j=D(z,M),T=this.forwarded.get(j);return O===u.AutoForwardEnd&&T&&T.source.source===l.Auto&&this.F.set(j,{local:T.localPort,name:T.name,privacy:T.privacy}),await this.H.closeTunnel(z,M),this.W({host:z,port:M},O)}address(z,M){const O=D(z,M);return(this.forwarded.get(O)||this.detected.get(O))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(z){if(z)for(const M of z){const O=k(this.m??new Map,M.remoteAddress.host,M.remoteAddress.port),j=typeof M.localAddress=="string"?M.localAddress:D(M.localAddress.host,M.localAddress.port);this.detected.set(D(M.remoteAddress.host,M.remoteAddress.port),{remoteHost:M.remoteAddress.host,remotePort:M.remoteAddress.port,localAddress:j,protocol:S.TunnelProtocol.Http,localUri:this.X(j),closeable:!1,runningProcess:O?.detail,hasRunningProcess:!!O,pid:O?.pid,privacy:S.TunnelPrivacyId.ConstantPrivate,source:{source:l.Extension,description:I.localize(4,null)}}),this.H.setEnvironmentTunnel(M.remoteAddress.host,M.remoteAddress.port,j,S.TunnelPrivacyId.ConstantPrivate,S.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(z){this.r=z}async setCandidates(z){let M=z;this.r&&(M=await this.r(z));const O=this.fb(M);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(O.values()).map(j=>j.port).join(", ")}`),this.n.fire(O)}fb(z){const M=this.m??new Map,O=new Map;return this.m=O,z.forEach(j=>{const T=D(j.host,j.port);O.set(T,{host:j.host,port:j.port,detail:j.detail,pid:j.pid}),M.has(T)&&M.delete(T);const V=k(this.forwarded,j.host,j.port);V&&(V.runningProcess=j.detail,V.hasRunningProcess=!0,V.pid=j.pid)}),M.forEach((j,T)=>{const V=d(T);if(!V)return;const q=k(this.forwarded,V.host,V.port);q&&(q.runningProcess=void 0,q.hasRunningProcess=!1,q.pid=void 0);const fe=k(this.detected,V.host,V.port);fe&&(fe.runningProcess=void 0,fe.hasRunningProcess=!1,fe.pid=void 0)}),M}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async gb(){const z=Array.from(this.forwarded.values()),M=await this.getAttributes(z.map(O=>({port:O.remotePort,host:O.remoteHost})),!1);if(M)for(const O of z){const j=M.get(O.remotePort);(j?.protocol||O.protocol!==S.TunnelProtocol.Http)&&j?.protocol!==O.protocol&&await this.cb({remote:{host:O.remoteHost,port:O.remotePort},local:O.localPort,name:O.name,source:O.source},j),j&&j.label&&j.label!==O.name&&await this.name(O.remoteHost,O.remotePort,j.label)}}async getAttributes(z,M=!0){const O=new Map,j=new Map;z.forEach(ee=>{const Y=k(this.m??new Map,S.$fv[0],ee.port)??ee;if(Y){O.set(ee.port,Y);const X=b(Y)?Y.pid:void 0;j.has(X)||j.set(X,[]),j.get(X)?.push(ee.port)}});const T=new Map;if(z.forEach(ee=>{const Y=this.configPortsAttributes.getAttributes(ee.port,ee.host,O.get(ee.port)?.detail);Y&&T.set(ee.port,Y)}),this.G.length===0||!M)return T.size>0?T:void 0;const V=await Promise.all((0,F.$Qb)(this.G.map(ee=>Array.from(j.entries()).map(Y=>{const X=Y[1],ae=O.get(X[0]);return ee.providePortAttributes(X,ae?.pid,ae?.detail,new i.$Yd().token)})))),q=new Map;if(V.forEach(ee=>ee.forEach(Y=>{Y&&q.set(Y.port,Y)})),!T&&!q)return;const fe=new Map;return z.forEach(ee=>{const Y=T.get(ee.port),X=q.get(ee.port);fe.set(ee.port,{elevateIfNeeded:Y?.elevateIfNeeded,label:Y?.label,onAutoForward:Y?.onAutoForward??v.providedActionToAction(X?.autoForwardAction),requireLocalPort:Y?.requireLocalPort,protocol:Y?.protocol})}),fe}addAttributesProvider(z){this.G.push(z)}};e.$1J=C,He([(0,f.$mh)(1e3)],C.prototype,"$",null),e.$1J=C=He([Be(0,S.$bv),Be(1,y.$0o),Be(2,m.$ni),Be(3,c.$PJ),Be(4,g.$Tk),Be(5,w.$3h),Be(6,P.$bj),Be(7,A.$Fv),Be(8,s.$rF),Be(9,a.$_i)],C)}),define(ke[94],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$NI=e.$MI=void 0;class I{constructor(R,p){this.line=R,this.character=p}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,p){return new I(0,0)}with(R){return new I(0,0)}}e.$MI=I;class F{constructor(R,p,E,m){this.isEmpty=!1,this.isSingleLine=!1,this.start=new I(R,p),this.end=new I(E,m)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new F(0,0,0,0)}with(R){return new F(0,0,0,0)}}e.$NI=F;var f;(function(L){L[L.Information=1]="Information",L[L.Warning=2]="Warning"})(f||(e.TextSearchCompleteMessageType=f={}))}),define(ke[36],Se([1,0,19,34,24,33,13,5,16,11,94,10]),function($e,e,I,F,f,L,R,p,E,m,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.SearchErrorCode=e.$3I=e.$2I=e.SearchSortOrder=e.ViewMode=e.$1I=e.$ZI=e.$YI=e.$XI=e.SearchCompletionExitCode=e.$WI=e.$VI=e.$UI=e.QueryType=e.SearchProviderType=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.$OI="workbench.view.search",e.$PI="workbench.panel.search",e.$QI="workbench.view.search",e.$RI="search-result",e.$SI="search.exclude";const g="\u27EA ",y=" characters skipped \u27EB",S=(g.length+y.length+5)*2;e.$TI=(0,p.$Th)("searchService");var w;(function(X){X[X.file=0]="file",X[X.text=1]="text"})(w||(e.SearchProviderType=w={}));var c;(function(X){X[X.File=1]="File",X[X.Text=2]="Text"})(c||(e.QueryType=c={}));function s(X){return!!X.preview}e.$UI=s;function i(X){return!!X.resource}e.$VI=i;function n(X){return!!X.message}e.$WI=n;var o;(function(X){X[X.Normal=0]="Normal",X[X.NewSearchStarted=1]="NewSearchStarted"})(o||(e.SearchCompletionExitCode=o={}));class a{constructor(ae){this.resource=ae,this.results=[]}}e.$XI=a;class t{constructor(ae,Z,se,we){this.ranges=Z,this.webviewIndex=we;const H=Array.isArray(Z)?Z:[Z];if(se&&se.matchLines===1&&r(H)){ae=(0,R.$sf)(ae,se.matchLines);let U="",ce=0,Ee=0;const ne=Math.floor(se.charsPerLine/5),G=[];for(const J of H){const ge=Math.max(J.startColumn-ne,0),x=J.startColumn+se.charsPerLine;if(ge>Ee+ne+S){const le=g+(ge-Ee)+y;U+=le+ae.slice(ge,x),ce+=ge-(Ee+le.length)}else U+=ae.slice(Ee,x);G.push(new u(0,J.startColumn-ce,J.endColumn-ce)),Ee=x}this.preview={text:U,matches:Array.isArray(this.ranges)?G:G[0]}}else{const U=Array.isArray(Z)?Z[0].startLineNumber:Z.startLineNumber;this.preview={text:ae,matches:(0,I.$1b)(Z,ce=>new d(ce.startLineNumber-U,ce.startColumn,ce.endLineNumber-U,ce.endColumn))}}}}e.$YI=t;function r(X){const ae=X[0].startLineNumber;for(const Z of X)if(Z.startLineNumber!==ae||Z.endLineNumber!==ae)return!1;return!0}class d{constructor(ae,Z,se,we){this.startLineNumber=ae,this.startColumn=Z,this.endLineNumber=se,this.endColumn=we}}e.$ZI=d;class u extends d{constructor(ae,Z,se){super(ae,Z,ae,se)}}e.$1I=u;var l;(function(X){X.List="list",X.Tree="tree"})(l||(e.ViewMode=l={}));var h;(function(X){X.Default="default",X.FileNames="fileNames",X.Type="type",X.Modified="modified",X.CountDescending="countDescending",X.CountAscending="countAscending"})(h||(e.SearchSortOrder=h={}));function k(X,ae=!0){const Z=X&&X.files&&X.files.exclude,se=ae&&X&&X.search&&X.search.exclude;if(!Z&&!se)return;if(!Z||!se)return Z||se;let we=Object.create(null);return we=f.$bn(we,f.$$m(Z)),we=f.$bn(we,f.$$m(se),!0),we}e.$2I=k;function D(X,ae){return X.excludePattern&&F.$zj(X.excludePattern,ae)?!1:X.includePattern||X.usingSearchPaths?X.includePattern&&F.$zj(X.includePattern,ae)?!0:X.usingSearchPaths?!!X.folderQueries&&X.folderQueries.some(Z=>{const se=Z.folder.fsPath;if(L.$Yf(ae,se)){const we=E.$kc(se,ae);return!Z.includePattern||!!F.$zj(Z.includePattern,we)}else return!1}):!1:!0}e.$3I=D;var $;(function(X){X[X.unknownEncoding=1]="unknownEncoding",X[X.regexParseError=2]="regexParseError",X[X.globParseError=3]="globParseError",X[X.invalidLiteral=4]="invalidLiteral",X[X.rgProcessError=5]="rgProcessError",X[X.other=6]="other",X[X.canceled=7]="canceled"})($||(e.SearchErrorCode=$={}));class b extends Error{constructor(ae,Z){super(ae),this.code=Z}}e.$4I=b;function v(X){const ae=X.message;if((0,m.$3)(X))return new b(ae,$.canceled);try{const Z=JSON.parse(ae);return new b(Z.message,Z.code)}catch{return new b(ae,$.other)}}e.$5I=v;function C(X){const ae={message:X.message,code:X.code};return new Error(JSON.stringify(ae))}e.$6I=C;function N(X){return X.type==="error"?!0:X.type==="success"}e.$7I=N;function z(X){return X.type==="success"}e.$8I=z;function M(X){return!!X.path}e.$9I=M;function O(X,ae){const Z=X.searchPath?X.searchPath:X.relativePath;return(0,R.$pf)(Z,ae)}e.$0I=O;class j{constructor(ae){this.path=ae,this.results=[]}addMatch(ae){this.results.push(ae)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$$I=j;function T(X,ae){const Z={...X||{},...ae||{}};return Object.keys(Z).filter(se=>{const we=Z[se];return typeof we=="boolean"&&we})}e.$_I=T;class V{constructor(ae,Z){this.c=null,this.a={...ae.excludePattern||{},...Z.excludePattern||{}},this.b=F.$Aj(this.a);let se=ae.includePattern;Z.includePattern&&(se?se={...se,...Z.includePattern}:se=Z.includePattern),se&&(this.c=F.$Aj(se))}matchesExcludesSync(ae,Z,se){return!!(this.b&&this.b(ae,Z,se))}includedInQuerySync(ae,Z,se){return!(this.b&&this.b(ae,Z,se)||this.c&&!this.c(ae,Z,se))}includedInQuery(ae,Z,se){const we=this.b(ae,Z,se),H=()=>this.c?!!this.c(ae,Z,se):!0;return(0,P.$Hg)(we)?we.then(U=>U?!1:H()):H()}hasSiblingExcludeClauses(){return q(this.a)}}e.$aJ=V;function q(X){for(const ae in X)if(typeof X[ae]!="boolean")return!0;return!1}function fe(X){if(!X)return;let ae;return Z=>(ae||(ae=(X()||Promise.resolve([])).then(se=>se?Y(se):{})),ae.then(se=>!!se[Z]))}e.$bJ=fe;function ee(X){if(!X)return;let ae;return Z=>{if(!ae){const se=X();ae=se?Y(se):{}}return!!ae[Z]}}e.$cJ=ee;function Y(X){const ae={};for(const Z of X)ae[Z]=!0;return ae}}),define(ke[41],Se([1,0,19,10,21,4,3,78,17,123,23,13,2,223,5,15,254,40,57,27,20,14,7,67,36,6,54]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,S,w,c,s,i,n,o,a,t,r,d,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ddc=e.$cdc=void 0;function h(z,M,O){return new A.$lg(j=>b(j,O)).isEqual(z,M)}function k(z,M,O){return h(z.uri,M.uri,O)?0:(0,P.$Ve)(z.uri.toString(),M.uri.toString())}function D(z,M,O){return z.index!==M.index?z.index<M.index?-1:1:h(z.uri,M.uri,O)?(0,P.$Ve)(z.name,M.name):(0,P.$Ve)(z.uri.toString(),M.uri.toString())}function $(z,M,O,j){const T=z.slice(0).sort((q,fe)=>O(q,fe,j)),V=M.slice(0).sort((q,fe)=>O(q,fe,j));return(0,I.$Db)(T,V,(q,fe)=>O(q,fe,j))}function b(z,M){const O=M.getCapabilities(z.scheme);return!(O&&O&1024)}class v extends s.$ai{static toExtHostWorkspace(M,O,j,T){if(!M)return{workspace:null,added:[],removed:[]};const{id:V,name:q,folders:fe,configuration:ee,transient:Y,isUntitled:X}=M,ae=[],Z=O;O?fe.forEach((U,ce)=>{const Ee=g.URI.revive(U.uri),ne=v.o(j||O,Ee,T);ne?(ne.name=U.name,ne.index=U.index,ae.push(ne)):ae.push({uri:Ee,name:U.name,index:ce})}):ae.push(...fe.map(({uri:U,name:ce,index:Ee})=>({uri:g.URI.revive(U),name:ce,index:Ee}))),ae.sort((U,ce)=>U.index<ce.index?-1:1);const se=new v(V,q,ae,!!Y,ee?g.URI.revive(ee):null,!!X,U=>b(U,T)),{added:we,removed:H}=$(Z?Z.workspaceFolders:[],se.workspaceFolders,k,T);return{workspace:se,added:we,removed:H}}static o(M,O,j){for(let T=0;T<M.folders.length;T++){const V=M.workspaceFolders[T];if(h(V.uri,O,j))return V}}constructor(M,O,j,T,V,q,fe){super(M,j.map(ee=>new s.$bi(ee)),T,V,fe),this.t=O,this.u=q,this.q=[],this.s=p.$Zh.forUris(fe),j.forEach(ee=>{this.q.push(ee),this.s.set(ee.uri,ee)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(M,O){return O&&this.s.get(M)&&(M=(0,A.$vg)(M)),this.s.findSubstr(M)}resolveWorkspaceFolder(M){return this.s.get(M)}}let C=class{constructor(M,O,j,T,V){this.c=new L.$Od,this.onDidChangeWorkspace=this.c.event,this.g=new L.$Od,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new L.$Qd,this.B=new Map,this.h=T,this.s=j,this.t=V,this.j=new m.$Ul,this.k=new F.$Tg,this.o=M.getProxy(u.$vK.MainThreadWorkspace),this.q=M.getProxy(u.$vK.MainThreadMessageService);const q=O.workspace;this.l=q?new v(q.id,q.name,[],!!q.transient,q.configuration?g.URI.revive(q.configuration):null,!!q.isUntitled,fe=>b(fe,j)):void 0}$initializeWorkspace(M,O){this.v=O,this.$acceptWorkspaceData(M),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?g.URI.from({scheme:E.Schemas.untitled,path:(0,A.$tg)((0,A.$vg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(M,O,j,...T){const V=[];if(Array.isArray(T)&&T.forEach(X=>{g.URI.isUri(X.uri)&&!V.some(ae=>h(ae.uri,X.uri,this.s))&&V.push({uri:X.uri,name:X.name||(0,A.$sg)(X.uri)})}),this.n||[O,j].some(X=>typeof X!="number"||X<0)||j===0&&V.length===0)return!1;const q=this.x?this.x.workspaceFolders:[];if(O+j>q.length)return!1;const fe=q.slice(0);fe.splice(O,j,...V.map(X=>({uri:X.uri,name:X.name||(0,A.$sg)(X.uri),index:void 0})));for(let X=0;X<fe.length;X++){const ae=fe[X];if(fe.some((Z,se)=>se!==X&&h(ae.uri,Z.uri,this.s)))return!1}fe.forEach((X,ae)=>X.index=ae);const{added:ee,removed:Y}=$(q,fe,D,this.s);if(ee.length===0&&Y.length===0)return!1;if(this.o){const X=M.displayName||M.name;this.o.$updateWorkspaceFolders(X,O,j,V).then(void 0,ae=>{this.n=void 0;const Z={source:{identifier:M.identifier,label:M.displayName||M.name}};this.q.$showMessage(c.Severity.Error,(0,y.localize)(0,null,X,ae.toString()),Z,[])})}return this.y(fe),!0}getWorkspaceFolder(M,O){if(this.x)return this.x.getWorkspaceFolder(M,O)}async getWorkspaceFolder2(M,O){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(M,O)}async resolveWorkspaceFolder(M){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(M)}getPath(){if(!this.x)return;const{folders:M}=this.x;if(M.length!==0)return M[0].uri.fsPath}getRelativePath(M,O){let j,T="";if(typeof M=="string"?(j=g.URI.file(M),T=M):typeof M<"u"&&(j=M,T=M.fsPath),!j)return T;const V=this.getWorkspaceFolder(j,!0);if(!V)return T;typeof O>"u"&&this.x&&(O=this.x.folders.length>1);let q=(0,A.$yg)(V.uri,j);return O&&V.name&&(q=`${V.name}/${q}`),q}y(M){this.x&&(this.n=v.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:M,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(M){const{workspace:O,added:j,removed:T}=v.toExtHostWorkspace(M,this.l,this.n,this.s);this.l=O||void 0,this.n=void 0,this.c.fire(Object.freeze({added:j,removed:T}))}findFiles(M,O,j,T,V=f.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${T.value}, entryPoint: findFiles`);let q;if(O===null?q=!1:O&&(typeof O=="string"?q=O:q=O.pattern),V&&V.isCancellationRequested)return Promise.resolve([]);const{includePattern:fe,folder:ee}=N(a.GlobPattern.from(M));return this.o.$startFileSearch(fe??null,ee??null,q??null,j??null,V).then(Y=>Array.isArray(Y)?Y.map(X=>g.URI.revive(X)):[])}async findTextInFiles(M,O,j,T,V=f.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${T.value}, entryPoint: findTextInFiles`);const q=this.j.getNext(),fe=typeof O.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:O.previewOptions,{includePattern:ee,folder:Y}=N(a.GlobPattern.from(O.include)),X=typeof O.exclude=="string"?O.exclude:O.exclude?O.exclude.pattern:void 0,ae={ignoreSymlinks:typeof O.followSymlinks=="boolean"?!O.followSymlinks:void 0,disregardIgnoreFiles:typeof O.useIgnoreFiles=="boolean"?!O.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof O.useGlobalIgnoreFiles=="boolean"?!O.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof O.useParentIgnoreFiles=="boolean"?!O.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof O.useDefaultExcludes=="boolean"?!O.useDefaultExcludes:!0,fileEncoding:O.encoding,maxResults:O.maxResults,previewOptions:fe,afterContext:O.afterContext,beforeContext:O.beforeContext,includePattern:ee,excludePattern:X},Z=!1;if(this.u[q]=se=>{if(Z)return;const we=g.URI.revive(se.resource);se.results.forEach(H=>{const U=(0,l.$qh)(H);(0,d.$UI)(U)?j({uri:we,preview:{text:U.preview.text,matches:(0,I.$1b)(U.preview.matches,ce=>new t.$zK(ce.startLineNumber,ce.startColumn,ce.endLineNumber,ce.endColumn))},ranges:(0,I.$1b)(U.ranges,ce=>new t.$zK(ce.startLineNumber,ce.startColumn,ce.endLineNumber,ce.endColumn))}):j({uri:we,text:U.text,lineNumber:U.lineNumber})})},V.isCancellationRequested)return{};try{const se=await this.o.$startTextSearch(M,Y??null,ae,q,V);return delete this.u[q],se||{}}catch(se){throw delete this.u[q],se}}$handleTextSearchResult(M,O){this.u[O]?.(M)}async save(M){const O=await this.o.$save(M,{saveAs:!1});return g.URI.revive(O)}async saveAs(M){const O=await this.o.$save(M,{saveAs:!0});return g.URI.revive(O)}saveAll(M){return this.o.$saveAll(M)}resolveProxy(M){return this.o.$resolveProxy(M)}get trusted(){return this.v}requestWorkspaceTrust(M){return this.o.$requestWorkspaceTrust(M)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(M,O){if(this.w.has(M))throw new Error(`A provider has already been registered for scheme ${M}`);this.w.set(M,O);const j=this.t.transformOutgoingScheme(M),T=this.z++;return this.o.$registerEditSessionIdentityProvider(T,j),(0,R.$Pc)(()=>{this.w.delete(M),this.o.$unregisterEditSessionIdentityProvider(T)})}async $getEditSessionIdentifier(M,O){this.h.info("Getting edit session identifier for workspaceFolder",M);const j=await this.resolveWorkspaceFolder(g.URI.revive(M));if(!j){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",j);const T=this.w.get(j.uri.scheme);if(this.h.info(`Provider for scheme ${j.uri.scheme} is defined: `,!!T),!T)return;const V=await T.provideEditSessionIdentity(j,O);if(this.h.info("Provider returned edit session identifier: ",V),!!V)return V}async $provideEditSessionIdentityMatch(M,O,j,T){this.h.info("Getting edit session identifier for workspaceFolder",M);const V=await this.resolveWorkspaceFolder(g.URI.revive(M));if(!V){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",V);const q=this.w.get(V.uri.scheme);if(this.h.info(`Provider for scheme ${V.uri.scheme} is defined: `,!!q),!q)return;const fe=await q.provideEditSessionIdentityMatch?.(O,j,T);if(this.h.info("Provider returned edit session identifier match result: ",fe),!!fe)return fe}getOnWillCreateEditSessionIdentityEvent(M){return(O,j,T)=>{const V=function(fe){O.call(j,fe)};return V.extension=M,this.A.event(V,void 0,T)}}async $onWillCreateEditSessionIdentity(M,O,j){const T=await this.resolveWorkspaceFolder(g.URI.revive(M));if(T===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:T},O,async(V,q)=>{const fe=Date.now();await Promise.resolve(V),Date.now()-fe>j&&this.h.warn("SLOW edit session create-participant",q.extension.identifier)}),O.isCancellationRequested}registerCanonicalUriProvider(M,O){if(this.B.has(M))throw new Error(`A provider has already been registered for scheme ${M}`);this.B.set(M,O);const j=this.t.transformOutgoingScheme(M),T=this.z++;return this.o.$registerCanonicalUriProvider(T,j),(0,R.$Pc)(()=>{this.B.delete(M),this.o.$unregisterCanonicalUriProvider(T)})}async provideCanonicalUri(M,O,j){const T=this.B.get(M.scheme);if(!T)return;const V=await T.provideCanonicalUri?.(g.URI.revive(M),O,j);if(V)return V}async $provideCanonicalUri(M,O,j){return this.provideCanonicalUri(g.URI.revive(M),{targetScheme:O},j)}};e.$cdc=C,e.$cdc=C=He([Be(0,o.$xM),Be(1,n.$NM),Be(2,i.$3cc),Be(3,w.$bj),Be(4,r.$adc)],C),e.$ddc=(0,S.$Th)("IExtHostWorkspace");function N(z){let M,O;return z&&(typeof z=="string"?M=z:(M=z.pattern,O=g.URI.revive(z.baseUri))),{includePattern:M,folder:O}}}),define(ke[42],Se([1,0,24,4,41,6,7,256,86,18,10,5,20,15,2]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gdc=e.$fdc=e.$edc=void 0;function w(r,d){if(d){const u=d.split(".");let l=r;for(let h=0;l&&h<u.length;h++)l=l[u[h]];return l}}function c(r){return r instanceof S.URI}function s(r){return r&&r.uri instanceof S.URI&&r.languageId&&typeof r.languageId=="string"}function i(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function n(r){return r&&r.uri instanceof S.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function o(r){if(c(r))return{resource:r};if(s(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(i(r))return{overrideIdentifier:r.languageId};if(n(r))return{resource:r.uri};if(r===null)return{resource:null}}let a=class{constructor(d,u,l){this.a=d.getProxy(L.$vK.MainThreadConfiguration),this.c=u,this.b=l,this.d=new A.$Tg,this.e=null}getConfigProvider(){return this.d.wait().then(d=>this.e)}$initializeConfiguration(d){this.e=new t(this.a,this.c,d,this.b),this.d.open()}$acceptConfigurationChanged(d,u){this.getConfigProvider().then(l=>l.$acceptConfigurationChanged(d,u))}};e.$edc=a,e.$edc=a=He([Be(0,g.$xM),Be(1,f.$ddc),Be(2,y.$bj)],a);class t{constructor(d,u,l,h){this.a=new F.$Od,this.b=d,this.f=h,this.c=u,this.e=p.$In.parse(l),this.d=this.k(l.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(d,u){const l={data:this.e.toData(),workspace:this.c.workspace};this.e=p.$In.parse(d),this.d=this.k(d.configurationScopes),this.a.fire(this.j(u,l))}getConfiguration(d,u,l){const h=o(u)||{},k=this.g(d?w(this.e.getValue(void 0,h,this.c.workspace),d):this.e.getValue(void 0,h,this.c.workspace));d&&this.h(d,h,l?.identifier);function D(b){if(b==null)return null;if(typeof b=="boolean")return b?2:5;switch(b){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const $={has(b){return typeof w(k,b)<"u"},get:(b,v)=>{this.h(d?`${d}.${b}`:b,h,l?.identifier);let C=w(k,b);if(typeof C>"u")C=v;else{let N;const z=(M,O)=>{if((0,m.$Bf)(M)){let j;const T=()=>{N=N||(0,I.$$m)(k),j=j||w(N,O)};return new Proxy(M,{get:(V,q)=>{if(typeof q=="string"&&q.toLowerCase()==="tojson")return T(),()=>j;if(N)return j=j||w(N,O),j[q];const fe=V[q];return typeof q=="string"?z(fe,`${O}.${q}`):fe},set:(V,q,fe)=>(T(),j&&(j[q]=fe),!0),deleteProperty:(V,q)=>(T(),j&&delete j[q],!0),defineProperty:(V,q,fe)=>(T(),j&&Object.defineProperty(j,q,fe),!0)})}return Array.isArray(M)?(0,I.$$m)(M):M};C=z(C,b)}return C},update:(b,v,C,N)=>{b=d?`${d}.${b}`:b;const z=D(C);return v!==void 0?this.b.$updateConfigurationOption(z,b,v,h,N):this.b.$removeConfigurationOption(z,b,h,N)},inspect:b=>{b=d?`${d}.${b}`:b;const v=this.e.inspect(b,h,this.c.workspace);if(v)return{key:b,defaultValue:(0,I.$$m)(v.policy?.value??v.default?.value),globalValue:(0,I.$$m)(v.user?.value??v.application?.value),workspaceValue:(0,I.$$m)(v.workspace?.value),workspaceFolderValue:(0,I.$$m)(v.workspaceFolder?.value),defaultLanguageValue:(0,I.$$m)(v.default?.override),globalLanguageValue:(0,I.$$m)(v.user?.override??v.application?.override),workspaceLanguageValue:(0,I.$$m)(v.workspace?.override),workspaceFolderLanguageValue:(0,I.$$m)(v.workspaceFolder?.override),languageIds:(0,I.$$m)(v.overrideIdentifiers)}}};return typeof k=="object"&&(0,I.$bn)($,k,!1),Object.freeze($)}g(d){const u=l=>(0,m.$Bf)(l)?new Proxy(l,{get:(h,k)=>u(h[k]),set:(h,k,D)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(k)}' of object`)},deleteProperty:(h,k)=>{throw new Error(`TypeError: Cannot delete read only property '${String(k)}' of object`)},defineProperty:(h,k)=>{throw new Error(`TypeError: Cannot define property '${String(k)}' for a readonly object`)},setPrototypeOf:h=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):l;return u(d)}h(d,u,l){const h=E.$zn.test(d)?4:this.d.get(d),k=l?`[${l.value}] `:"";if(h===4){typeof u?.resource>"u"&&this.f.warn(`${k}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${d}', provide the URI of a resource or 'null' for any resource.`);return}if(h===3){u?.resource&&this.f.warn(`${k}Accessing a window scoped configuration for a resource is not expected. To associate '${d}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(d,u){const l=new p.$Kn(d,u,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(h,k)=>l.affectsConfiguration(h,o(k))})}k(d){return d.reduce((u,l)=>(u.set(l[0],l[1]),u),new Map)}}e.$fdc=t,e.$gdc=(0,P.$Th)("IExtHostConfiguration")}),define(ke[95],Se([1,0,2,10,4,6,7,41,70,42,21,46,20,27,5,17,12,15,91,304,11]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,S,w,c,s,i,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eec=e.$dec=e.$cec=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var a;(function(z){function M(j){if(j!=null)return j}z.from=M;function O(j){if(j!=null)return j}z.to=O})(a||(a={}));var t;(function(z){function M(j){if(j!=null)return j}z.from=M;function O(j){if(j!=null)return j}z.to=O})(t||(t={}));var r;(function(z){function M(j){if(j!=null)return j}z.from=M;function O(j){if(j!=null)return j}z.to=O})(r||(r={}));var d;(function(z){function M(T){if(T){const V=T;return V&&!!V.process}else return!1}z.is=M;function O(T){if(T==null)return;const V={process:T.process,args:T.args};return T.options&&(V.options=r.from(T.options)),V}z.from=O;function j(T){if(T!=null)return new R.$fL(T.process,T.args,T.options)}z.to=j})(d||(d={}));var u;(function(z){function M(j){if(j!=null)return j}z.from=M;function O(j){if(j!=null)return j}z.to=O})(u||(u={}));var l;(function(z){function M(T){if(T){const V=T;return V&&(!!V.commandLine||!!V.command)}else return!1}z.is=M;function O(T){if(T==null)return;const V={};return T.commandLine!==void 0?V.commandLine=T.commandLine:(V.command=T.command,V.args=T.args),T.options&&(V.options=u.from(T.options)),V}z.from=O;function j(T){if(!(T==null||T.command===void 0&&T.commandLine===void 0))return T.commandLine?new R.$gL(T.commandLine,T.options):new R.$gL(T.command,T.args?T.args:[],T.options)}z.to=j})(l||(l={}));var h;(function(z){function M(T){if(T){const V=T;return V&&V.customExecution==="customExecution"}else return!1}z.is=M;function O(T){return{customExecution:"customExecution"}}z.from=O;function j(T,V){return V.get(T)}z.to=j})(h||(e.CustomExecutionDTO=h={}));var k;(function(z){function M(O,j){let T;return O.scope!==void 0&&typeof O.scope!="number"?T=O.scope.uri:O.scope!==void 0&&typeof O.scope=="number"&&(O.scope===R.TaskScope.Workspace&&j&&j.workspaceFile?T=j.workspaceFile:T=n.$7F),{id:O._id,workspaceFolder:T}}z.from=M})(k||(e.TaskHandleDTO=k={}));var D;(function(z){function M(O){if(O!=null)return{_id:O.id,isDefault:O.isDefault}}z.from=M})(D||(D={}));var $;(function(z){function M(T,V){if(T==null)return[];const q=[];for(const fe of T){const ee=O(fe,V);ee&&q.push(ee)}return q}z.fromMany=M;function O(T,V){if(T==null)return;let q;T.execution instanceof R.$fL?q=d.from(T.execution):T.execution instanceof R.$gL?q=l.from(T.execution):T.execution&&T.execution instanceof R.$hL&&(q=h.from(T.execution));const fe=a.from(T.definition);let ee;return T.scope?typeof T.scope=="number"?ee=T.scope:ee=T.scope.uri:ee=R.TaskScope.Workspace,!fe||!ee?void 0:{_id:T._id,definition:fe,name:T.name,source:{extensionId:V.identifier.value,label:T.source,scope:ee},execution:q,isBackground:T.isBackground,group:D.from(T.group),presentationOptions:t.from(T.presentationOptions),problemMatchers:T.problemMatchers,hasDefinedMatchers:T.hasDefinedMatchers,runOptions:T.runOptions?T.runOptions:{reevaluateOnRerun:!0},detail:T.detail}}z.from=O;async function j(T,V,q){if(T==null)return;let fe;d.is(T.execution)?fe=d.to(T.execution):l.is(T.execution)?fe=l.to(T.execution):h.is(T.execution)&&(fe=h.to(T._id,q));const ee=a.to(T.definition);let Y;if(T.source&&(T.source.scope!==void 0?typeof T.source.scope=="number"?Y=T.source.scope:Y=await V.resolveWorkspaceFolder(I.URI.revive(T.source.scope)):Y=R.TaskScope.Workspace),!ee||!Y)return;const X=new R.$iL(ee,Y,T.name,T.source.label,fe,T.problemMatchers);return T.isBackground!==void 0&&(X.isBackground=T.isBackground),T.group!==void 0&&(X.group=R.$eL.from(T.group._id),X.group&&T.group.isDefault&&(X.group=new R.$eL(X.group.id,X.group.label),T.group.isDefault===!0&&(X.group.isDefault=T.group.isDefault))),T.presentationOptions&&(X.presentationOptions=t.to(T.presentationOptions)),T._id&&(X._id=T._id),T.detail&&(X.detail=T.detail),X}z.to=j})($||(e.TaskDTO=$={}));var b;(function(z){function M(j){return j}z.from=M;function O(j){if(j)return Object.assign(Object.create(null),j)}z.to=O})(b||(b={}));class v{#e;constructor(M,O,j){this._id=O,this.a=j,this.#e=M}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(M){}fireDidEndProcess(M){}}let C=class{constructor(M,O,j,T,V,q,fe,ee){this.q=new f.$Od,this.r=new f.$Od,this.s=new f.$Od,this.t=new f.$Od,this.a=M.getProxy(L.$vK.MainThreadTask),this.b=j,this.c=T,this.d=V,this.e=q,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=fe,this.g=ee,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(M,O,j){if(!j)return new R.$xK(()=>{});const T=this.w();return this.j.set(T,{type:O,provider:j,extension:M}),this.a.$registerTaskProvider(T,O),new R.$xK(()=>{this.j.delete(T),this.a.$unregisterTaskProvider(T)})}registerTaskSystem(M,O){this.a.$registerTaskSystem(M,O)}fetchTasks(M){return this.a.$fetchTasks(b.from(M)).then(async O=>{const j=[];for(const T of O){const V=await $.to(T,this.b,this.m);V&&j.push(V)}return j})}get taskExecutions(){const M=[];return this.k.forEach(O=>M.push(O)),M}terminateTask(M){if(!(M instanceof v))throw new Error("No valid task execution provided");return this.a.$terminateTask(M._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(M,O,j){const T=this.m.get(M.id);T&&(this.o.set(M.id,T),this.e.attachPtyToTerminal(O,await T.callback(j))),this.p=M.id,this.q.fire({execution:await this.y(M)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(M){const O=await this.y(M);this.l.delete(M.id),this.k.delete(M.id),this.A(M),this.r.fire({execution:O})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(M){const O=await this.y(M.id);this.s.fire({execution:O,processId:M.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(M){const O=await this.y(M.id);this.t.fire({execution:O,exitCode:M.exitCode})}$provideTasks(M,O){const j=this.j.get(M);if(!j)return Promise.reject(new Error("no handler found"));const T=[],V=(0,F.$Ng)(()=>j.provider.provideTasks(A.CancellationToken.None)).then(q=>this.u(O,T,j,q));return new Promise(q=>{V.then(fe=>{Promise.all(T).then(()=>{q(fe)})})})}async $resolveTask(M,O){const j=this.j.get(M);if(!j)return Promise.reject(new Error("no handler found"));if(O.definition.type!==j.type)throw new Error(`Unexpected: Task of type [${O.definition.type}] cannot be resolved by provider of type [${j.type}].`);const T=await $.to(O,this.b,this.m);if(!T)throw new Error("Unexpected: Task cannot be resolved.");const V=await j.provider.resolveTask(T,A.CancellationToken.None);if(!V)return;this.z(V,j);const q=$.from(V,j.extension);if(!q)throw new Error("Unexpected: Task cannot be resolved.");if(V.definition!==T.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return h.is(q.execution)&&await this.x(q,V,!0),await this.v(q)}w(){return this.h++}async x(M,O,j){const T=await this.a.$createTaskId(M);!j&&!this.m.has(T)&&(this.n.add(T),this.o.set(T,O.execution)),this.m.set(T,O.execution)}async y(M,O){if(typeof M=="string"){const V=this.l.get(M);if(!V)throw new o.$ab("Unexpected: The specified task is missing an execution");return V}const j=this.l.get(M.id);if(j)return j;const T=new Promise((V,q)=>{function fe(ee,Y,X){X?V(new v(ee,Y.id,X)):q("Unexpected: Task does not exist.")}O?fe(this,M,O):$.to(M.task,this.b,this.m).then(ee=>fe(this,M,ee))});return this.l.set(M.id,T),T.then(V=>(this.k.set(M.id,V),V),V=>Promise.reject(V))}z(M,O){M._deprecated&&this.g.report("Task.constructor",O.extension,"Use the Task constructor that takes a `scope` instead.")}A(M){this.o.get(M.id)&&this.o.delete(M.id),this.n.has(M.id)&&this.p!==M.id&&(this.m.delete(M.id),this.n.delete(M.id));const j=this.n.values();let T=j.next();for(;!T.done;)!this.o.has(T.value)&&this.p!==T.value&&(this.m.delete(T.value),this.n.delete(T.value)),T=j.next()}};e.$cec=C,e.$cec=C=He([Be(0,g.$xM),Be(1,y.$NM),Be(2,p.$ddc),Be(3,E.$IM),Be(4,m.$gdc),Be(5,P.$ydc),Be(6,s.$bj),Be(7,i.$6cc)],C);let N=class extends C{constructor(M,O,j,T,V,q,fe,ee){super(M,O,j,T,V,q,fe,ee),this.registerTaskSystem(w.Schemas.vscodeRemote,{scheme:w.Schemas.vscodeRemote,authority:"",platform:c.$i(0)})}async executeTask(M,O){if(!O.execution)throw new Error("Tasks to execute must include an execution");const j=$.from(O,M);if(j===void 0)throw new Error("Task is not valid");if(h.is(j.execution))await this.x(j,O,!1);else throw new o.$$;const T=await this.y(await this.a.$getTaskExecution(j),O);return this.a.$executeTask(j).catch(V=>{throw new Error(V)}),T}u(M,O,j,T){const V=[];if(T)for(const q of T){this.z(q,j),(!q.definition||!M[q.definition.type])&&this.f.warn(`The task [${q.source}, ${q.name}] uses an undefined task type. The task will be ignored in the future.`);const fe=$.from(q,j.extension);fe&&h.is(fe.execution)?(V.push(fe),O.push(this.x(fe,q,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:V,extension:j.extension}}async v(M){if(h.is(M.execution))return M;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(M,O){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(M,O,j){}};e.$dec=N,e.$dec=N=He([Be(0,g.$xM),Be(1,y.$NM),Be(2,p.$ddc),Be(3,E.$IM),Be(4,m.$gdc),Be(5,P.$ydc),Be(6,s.$bj),Be(7,i.$6cc)],N),e.$eec=(0,S.$Th)("IExtHostTask")}),define(ke[361],Se([1,0,36,29]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tK=e.$sK=e.$rK=void 0;function f(R){return"cellResults"in R}e.$rK=f,e.$sK="rawCell#";function L(R,p){let E=-1;const m=[];let A=[];return R.forEach(g=>{g.range.startLineNumber!==E&&A.length>0&&(m.push([...A]),A=[]),A.push(g),E=g.range.endLineNumber}),A.length>0&&m.push([...A]),m.map(g=>{const y=[],S=g[0].range.startLineNumber,w=g[g.length-1].range.endLineNumber;for(let c=S;c<=w;c++)y.push(p.getLineContent(c));return new I.$YI(y.join(`
`)+`
`,g.map(c=>new F.$xs(c.range.startLineNumber-1,c.range.startColumn-1,c.range.endLineNumber-1,c.range.endColumn-1)))})}e.$tK=L}),define(ke[362],Se([1,0,216,22,4,3,28,13,18,2,31,110,6,35,14,7,69,296,148,11,24,17,288,361,358]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,S,w,c,s,i,n,o,a,t,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zec=void 0;class u{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(h=>h.apiEditor)}constructor(h,k,D,$,b,v){this.q=D,this.r=$,this.s=b,this.t=v,this.f=new Map,this.g=new R.$zc,this.h=new Map,this.j=new f.$Od({onListenerError:n.$1}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new f.$Od({onListenerError:n.$1}),this.onDidOpenNotebookDocument=this.m.event,this.n=new f.$Od({onListenerError:n.$1}),this.onDidCloseNotebookDocument=this.n.event,this.o=new f.$Od({onListenerError:n.$1}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new P.$Zcc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=h.getProxy(g.$vK.MainThreadNotebook),this.c=h.getProxy(g.$vK.MainThreadNotebookDocuments),this.d=h.getProxy(g.$vK.MainThreadNotebookEditors),this.i=k.converter,k.registerArgumentProcessor({processArgument:C=>{if(C&&C.$mid===13){const N=C.notebookEditor?.notebookUri,z=C.cell.handle,O=this.g.get(N)?.getCell(z);if(O)return O.apiCell}if(C&&C.$mid===14){const N=C.uri,z=this.g.get(N);if(z)return z.apiNotebook}return C}}),u.B(k)}getEditorById(h){const k=this.h.get(h);if(!k)throw new Error(`unknown text editor: ${h}. known editors: ${[...this.h.keys()]} `);return k}getIdByEditor(h){for(const[k,D]of this.h)if(D.apiEditor===h)return k}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(h,k){const D=this.g.get(h);if(!D&&!k)throw new Error(`NO notebook document for '${h}'`);return D}static u(h,k){if(!k)return;const D=k.filenamePattern.map($=>S.NotebookExclusiveDocumentPattern.from($)).filter($=>$!==void 0);if(k.filenamePattern&&!D){console.warn(`Notebook content provider view options file name pattern is invalid ${k.filenamePattern}`);return}return{extension:h.identifier,providerDisplayName:h.displayName||h.name,displayName:k.displayName,filenamePattern:D,exclusive:k.exclusive||!1}}registerNotebookCellStatusBarItemProvider(h,k,D){const $=u.a++,b=typeof D.onDidChangeCellStatusBarItems=="function"?u.a++:void 0;this.f.set($,D),this.b.$registerNotebookCellStatusBarItemProvider($,b,k);let v;return b!==void 0&&(v=D.onDidChangeCellStatusBarItems(C=>this.b.$emitCellStatusBarEvent(b))),new w.$xK(()=>{this.f.delete($),this.b.$unregisterNotebookCellStatusBarItemProvider($,b),v?.dispose()})}async createNotebookDocument(h){const k=await this.c.$tryCreateNotebook({viewType:h.viewType,content:h.content&&S.NotebookData.from(h.content)});return m.URI.revive(k)}async openNotebookDocument(h){const k=this.g.get(h);if(k)return k.apiNotebook;const D=await this.c.$tryOpenNotebook(h),$=this.g.get(m.URI.revive(D));return(0,E.$Kf)($?.apiNotebook)}async showNotebookDocument(h,k){m.URI.isUri(h)&&(h=await this.openNotebookDocument(h));let D;typeof k=="object"?D={position:S.ViewColumn.from(k.viewColumn),preserveFocus:k.preserveFocus,selections:k.selections&&k.selections.map(S.NotebookRange.from),pinned:typeof k.preview=="boolean"?!k.preview:void 0}:D={preserveFocus:!1};const $=await this.d.$tryShowNotebookDocument(h.uri,h.notebookType,D),b=$&&this.h.get($)?.apiEditor;if(b)return b;throw $?new Error(`Could NOT open editor for "${h.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${h.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(h,k,D,$){const b=this.f.get(h),v=m.URI.revive(k),C=this.g.get(v);if(!C||!b)return;const N=C.getCellFromIndex(D);if(!N)return;const z=await b.provideCellStatusBarItems(N.apiCell,$);if(!z)return;const M=new L.$Qc,O=this.p.add([M]),T=(Array.isArray(z)?z:[z]).map(V=>S.NotebookStatusBarItem.from(V,this.i,M));return{cacheId:O,items:T}}$releaseNotebookCellStatusBarItems(h){this.p.delete(h)}registerNotebookSerializer(h,k,D,$,b){if((0,p.$Ce)(k))throw new Error("viewType cannot be empty or just whitespace");const v=this.w++;return this.x.set(v,{viewType:k,serializer:D,options:$}),this.b.$registerNotebookSerializer(v,{id:h.identifier,location:h.extensionLocation},k,S.NotebookDocumentContentOptions.from($),u.u(h,b)),(0,L.$Pc)(()=>{this.b.$unregisterNotebookSerializer(v)})}async $dataToNotebook(h,k,D){const $=this.x.get(h);if(!$)throw new Error("NO serializer found");const b=await $.serializer.deserializeNotebook(k.buffer,D);return new c.$uv(S.NotebookData.from(b))}async $notebookToData(h,k,D){const $=this.x.get(h);if(!$)throw new Error("NO serializer found");const b=await $.serializer.serializeNotebook(S.NotebookData.to(k.value),D);return F.$ce.wrap(b)}async $saveNotebook(h,k,D,$,b){const v=m.URI.revive(k),C=this.x.get(h);if(!C)throw new Error("NO serializer found");const N=this.g.get(v);if(!N)throw new Error("Document NOT found");if(N.versionId!==D)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(v.scheme))throw new A.$xk((0,I.localize)(0,null,this.z(v)),6);await this.y(v,$);const z={metadata:(0,o.$gn)(N.apiNotebook.metadata,V=>!(C.options?.transientDocumentMetadata??{})[V]),cells:[]};for(const V of N.apiNotebook.getCells()){const q=new w.$VL(V.kind,V.document.getText(),V.document.languageId,V.mime,C.options?.transientOutputs?[]:[...V.outputs],V.metadata,V.executionSummary);q.metadata=(0,o.$gn)(V.metadata,fe=>!(C.options?.transientCellMetadata??{})[fe]),z.cells.push(q)}const M=await C.serializer.serializeNotebook(z,b);await this.s.value.writeFile(v,M);const O=this.s.getFileSystemProviderExtUri(v.scheme),j=await this.s.value.stat(v);return{name:O.basename(v),isFile:(j.type&A.FileType.File)!==0,isDirectory:(j.type&A.FileType.Directory)!==0,isSymbolicLink:(j.type&A.FileType.SymbolicLink)!==0,mtime:j.mtime,ctime:j.ctime,size:j.size,readonly:!!((j.permissions??0)&A.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(v.scheme),locked:!!((j.permissions??0)&A.FilePermission.Locked),etag:A.$Ik({mtime:j.mtime,size:j.size}),children:void 0}}async $searchInNotebooks(h,k,D,$,b){const v=this.x.get(h)?.serializer;if(!v)return{limitHit:!1,results:[]};const C=new R.$Ac;await(async(j,T,V)=>{await Promise.all(j.map(async q=>await Promise.all(q.filenamePatterns.map(fe=>{const ee={...V,type:1,filePattern:fe};return this.t.doInternalFileSearchWithCustomCallback(ee,T,Y=>{Y.forEach(X=>{C.has(X)||$.some(Z=>q.isFromSettings&&!Z.isFromSettings?!1:Z.filenamePatterns.some(se=>(0,d.$rcb)(se,X)))||C.add(X)})})}))))})(D,b,k);const z=new R.$zc;let M=!1;const O=Array.from(C).map(async j=>{const T=[];try{if(b.isCancellationRequested)return;if(k.maxResults&&[...z.values()].reduce((ee,Y)=>ee+Y.cellResults.length,0)>k.maxResults){M=!0;return}const V=[],q=this.g.get(j);if(q)q.apiNotebook.getCells().forEach(Y=>V.push({input:Y.document.getText(),outputs:Y.outputs.flatMap(X=>X.items.map(ae=>ae.data.toString()))}));else{const ee=await this.s.value.readFile(j),Y=F.$ce.fromString(ee.toString()),X=await v.deserializeNotebook(Y.buffer,b);if(b.isCancellationRequested)return;S.NotebookData.from(X).cells.forEach(Z=>V.push({input:Z.source,outputs:Z.outputs.flatMap(se=>se.items.map(we=>we.valueBytes.toString()))}))}if(b.isCancellationRequested)return;V.forEach((ee,Y)=>{const X=k.contentPattern.pattern,ae=new t.$yOb(ee.input,void 0,ee.outputs),Z=ae.findInInputs(X),se=ae.findInOutputs(X),we=se.flatMap(H=>(0,r.$tK)(H.matches,H.textBuffer)).map((H,U)=>(H.webviewIndex=U,H));if(Z.length>0||se.length>0){const H={index:Y,contentResults:(0,r.$tK)(Z,ae.inputTextBuffer),webviewResults:we};T.push(H)}});const fe={resource:j,cellResults:T};z.set(j,fe);return}catch{return}});return await Promise.all(O),{limitHit:M,results:[...z.values()]}}async y(h,k){const D=await this.s.value.stat(h);if(typeof k?.mtime=="number"&&typeof k.etag=="string"&&k.etag!==A.$Hk&&typeof D.mtime=="number"&&typeof D.size=="number"&&k.mtime<D.mtime&&k.etag!==A.$Ik({mtime:k.mtime,size:D.size}))throw new A.$xk((0,I.localize)(1,null),3,k)}z(h){return h.scheme===a.Schemas.file?h.fsPath:h.toString()}A(h,k,D){if(this.h.has(k))throw new Error(`editor with id ALREADY EXSIST: ${k}`);const $=new i.$yec(k,this.d,h,D.visibleRanges.map(S.NotebookRange.to),D.selections.map(S.NotebookRange.to),typeof D.viewColumn=="number"?S.ViewColumn.to(D.viewColumn):void 0);this.h.set(k,$)}$acceptDocumentAndEditorsDelta(h){if(h.value.removedDocuments)for(const D of h.value.removedDocuments){const $=m.URI.revive(D),b=this.g.get($);b&&(b.dispose(),this.g.delete($),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:b.apiNotebook.getCells().map(v=>v.document.uri)}),this.n.fire(b.apiNotebook));for(const v of this.h.values())v.notebookData.uri.toString()===$.toString()&&this.h.delete(v.id)}if(h.value.addedDocuments){const D=[];for(const $ of h.value.addedDocuments){const b=m.URI.revive($.uri);if(this.g.has(b))throw new Error(`adding EXISTING notebook ${b} `);const v=new s.$xec(this.c,this.q,this.r,b,$);D.push(...$.cells.map(C=>s.$wec.asModelAddData(v.apiNotebook,C))),this.g.get(b)?.dispose(),this.g.set(b,v),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:D}),this.m.fire(v.apiNotebook)}}if(h.value.addedEditors)for(const D of h.value.addedEditors){if(this.h.has(D.id))return;const $=m.URI.revive(D.documentUri),b=this.g.get($);b&&this.A(b,D.id,D)}const k=[];if(h.value.removedEditors)for(const D of h.value.removedEditors){const $=this.h.get(D);$&&(this.h.delete(D),this.k?.id===$.id&&(this.k=void 0),k.push($))}if(h.value.visibleEditors){this.l=h.value.visibleEditors.map($=>this.h.get($)).filter($=>!!$);const D=new Set;this.l.forEach($=>D.add($.id));for(const $ of this.h.values()){const b=D.has($.id);$._acceptVisibility(b)}this.l=[...this.h.values()].map($=>$).filter($=>$.visible),this.o.fire(this.visibleNotebookEditors)}h.value.newActiveEditor===null?this.k=void 0:h.value.newActiveEditor&&(this.h.get(h.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${h.value.newActiveEditor}`),this.k=this.h.get(h.value.newActiveEditor)),h.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(h){const k=y.$VM.String.with("notebookType","A notebook type"),D=new y.$XM("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[k,new y.$VM("data","Bytes to convert to data",b=>b instanceof Uint8Array,b=>F.$ce.wrap(b))],new y.$WM("Notebook Data",b=>S.NotebookData.to(b.value))),$=new y.$XM("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[k,new y.$VM("NotebookData","Notebook data to convert to bytes",b=>!0,b=>new c.$uv(S.NotebookData.from(b)))],new y.$WM("Bytes",b=>b.buffer));h.registerApiCommand(D),h.registerApiCommand($)}}e.$zec=u}),define(ke[363],Se([1,0,16,21,43,34,23,37,36]),function($e,e,I,F,f,L,R,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oec=void 0;class m{constructor(g,y,S){this.k=g,this.l=y,this.o=S,this.e=!1,this.f=0,this.g=!1,this.a=g.filePattern,this.b=g.includePattern&&L.$Aj(g.includePattern),this.c=g.maxResults||void 0,this.d=g.exists,this.h=new Set,this.j=g.excludePattern&&L.$Aj(g.excludePattern)}cancel(){this.g=!0,this.h.forEach(g=>g.cancel()),this.h=new Set}search(g){const y=this.k.folderQueries||[];return new Promise((S,w)=>{const c=s=>{this.f++,g(s)};if(this.g)return S({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(s=>{const i=s.toString(),n=I.$mc(i);this.j&&this.j(i,n)||this.v(c,{base:s,basename:n})}),Promise.all(y.map(s=>this.p(s,c))).then(s=>{S({limitHit:this.e,stats:s[0]||void 0})},s=>{w(new Error((0,f.$Ei)(s)))})})}async p(g,y){const S=new F.$Yd,w=this.q(g),c=this.r(),s=new E.$aJ(this.k,g),i=!s.hasSiblingExcludeClauses();let n;try{this.h.add(S),n=p.$Kd.create();const o=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},w,S.token),a=n.elapsed(),t=p.$Kd.create();return this.g&&!this.e||(o&&o.forEach(r=>{const d=I.$fc.relative(g.folder.path,r.path);if(i){const u=I.$mc(r.path);this.v(y,{base:g.folder,relativePath:d,basename:u});return}this.s(c,g.folder,d,y)}),this.g&&!this.e)?null:(this.u(c,s,y),{providerTime:a,postProcessTime:t.elapsed()})}finally{S.dispose(),this.h.delete(S)}}q(g){const y=(0,E.$_I)(this.k.includePattern,g.includePattern),S=(0,E.$_I)(this.k.excludePattern,g.excludePattern);return{folder:g.folder,excludes:S,includes:y,useIgnoreFiles:!g.disregardIgnoreFiles,useGlobalIgnoreFiles:!g.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!g.disregardParentIgnoreFiles,followSymlinks:!g.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const g={rootEntries:[],pathToEntries:Object.create(null)};return g.pathToEntries["."]=g.rootEntries,g}s({pathToEntries:g},y,S,w){if(S===this.a){const s=I.$mc(this.a);this.v(w,{base:y,relativePath:this.a,basename:s})}function c(s){const i=I.$mc(s),n=I.$lc(s);let o=g[n];o||(o=g[n]=[],c(n)),o.push({base:y,relativePath:s,basename:i})}c(S)}u({rootEntries:g,pathToEntries:y},S,w){const c=this,s=this.a;function i(n){const o=(0,E.$cJ)(()=>n.map(a=>a.basename));for(let a=0,t=n.length;a<t;a++){const r=n[a],{relativePath:d,basename:u}=r;if(S.matchesExcludesSync(d,u,s!==u?o:void 0))continue;const l=y[d];if(l)i(l);else{if(d===s)continue;c.v(w,r)}if(c.e)break}}i(g)}v(g,y){(!this.b||y.relativePath&&this.b(y.relativePath,y.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||g(y))}}class A{constructor(){this.b=new Map}static{this.a=512}fileSearch(g,y,S,w){const c=this.c(g.cacheKey),s=new m(g,y,c&&c.token);let i=0;const n=o=>{i+=o.length,S(o.map(a=>this.d(a)))};return this.e(s,A.a,n,w).then(o=>({limitHit:o.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:i,detailStats:o.stats}}))}clearCache(g){this.c(g)?.cancel()}c(g){if(g)return this.b.has(g)||this.b.set(g,new F.$Yd),this.b.get(g)}d(g){return g.relativePath?{resource:R.$wg(g.base,g.relativePath)}:{resource:g.base}}e(g,y,S,w){const c=w.onCancellationRequested(()=>{g.cancel()}),s=n=>{n&&(i.push(n),y>0&&i.length>=y&&(S(i),i=[]))};let i=[];return g.search(s).then(n=>(i.length&&S(i),c.dispose(),n),n=>(i.length&&S(i),c.dispose(),Promise.reject(n)))}}e.$oec=A}),define(ke[364],Se([1,0,19,74,34,102,28,17,16,23,13,18,2,99,237,44,15,40,145,359,36]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,S,w,c,s,i,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0J=e.$9J=void 0;let a=class{constructor(b,v,C,N,z){this.a=b,this.b=v,this.c=C,this.d=N,this.e=z}text(b,v,C={}){b=this.f(b,C);const N=this.a.getValue(),z=v&&v.some(O=>!this.a.getValue({resource:O}).search.useRipgrep);return{...this.h(v?.map(s.$ci),C),type:2,contentPattern:b,previewOptions:C.previewOptions,maxFileSize:C.maxFileSize,usePCRE2:N.search.usePCRE2||z||!1,beforeContext:C.beforeContext,afterContext:C.afterContext,userDisabledExcludesAndIgnoreFiles:C.disregardExcludeSettings&&C.disregardIgnoreFiles}}f(b,v){const C=this.a.getValue();b.isRegExp&&(b.pattern=b.pattern.replace(/\r?\n/g,"\\n"));const N={...b,wordSeparators:C.editor.wordSeparators};return this.j(b,v)&&(N.isCaseSensitive=!0),this.k(b)&&(N.isMultiline=!0),v.notebookSearchConfig?.includeMarkupInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownInput=v.notebookSearchConfig.includeMarkupInput),v.notebookSearchConfig?.includeMarkupPreview&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownPreview=v.notebookSearchConfig.includeMarkupPreview),v.notebookSearchConfig?.includeCodeInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellInput=v.notebookSearchConfig.includeCodeInput),v.notebookSearchConfig?.includeOutput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellOutput=v.notebookSearchConfig.includeOutput),N}file(b,v={}){return{...this.h(b,v),type:1,filePattern:v.filePattern?v.filePattern.trim():v.filePattern,exists:v.exists,sortByScore:v.sortByScore,cacheKey:v.cacheKey}}g(b,v){return b?(b=Array.isArray(b)?b.map(l):l(b),v?this.parseSearchPaths(b):{pattern:r(...Array.isArray(b)?b:[b])}):{}}h(b=[],v={}){const C=this.g(v.includePattern,v.expandPatterns),N=this.g(v.excludePattern,v.expandPatterns),z=b.length>1,M=(C.searchPaths&&C.searchPaths.length?C.searchPaths.map(T=>this.q(T,v,N)):b.map(T=>this.r(T,v,N,z))).filter(T=>!!T),O={_reason:v._reason,folderQueries:M,usingSearchPaths:!!(C.searchPaths&&C.searchPaths.length),extraFileResources:v.extraFileResources,excludePattern:N.pattern,includePattern:C.pattern,onlyOpenEditors:v.onlyOpenEditors,maxResults:v.maxResults};if(v.onlyOpenEditors){const T=I.$Gb(I.$Qb(this.c.groups.map(fe=>fe.editors.map(ee=>ee.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(T));const V=T.filter(fe=>(0,o.$3I)(O,fe.fsPath)),q=this.i(V);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(q)),{...O,...q}}const j=v.extraFileResources&&v.extraFileResources.filter(T=>(0,o.$3I)(O,T.fsPath));return O.extraFileResources=j&&j.length?j:void 0,O}i(b){const v=[],C=new R.$zc,N={};let z=!1;return b.forEach(M=>{if(M.scheme===p.Schemas.walkThrough)return;if((0,m.$Ag)(M)){const j=this.b.getWorkspaceFolder(M)?.uri??M.with({path:E.$lc(M.fsPath)});let T=C.get(j);T||(z=!0,T={folder:j,includePattern:{}},v.push(T),C.set(j,T));const V=E.$kc(j.fsPath,M.fsPath);(0,P.$Kf)(T.includePattern)[V.replace(/\\/g,"/")]=!0}else M.fsPath&&(z=!0,N[M.fsPath]=!0)}),{folderQueries:v,includePattern:N,usingSearchPaths:!0,excludePattern:z?void 0:{"**/*":!0}}}j(b,v){if(v.isSmartCase){if(b.isRegExp){if(A.$qf(b.pattern,!0))return!0}else if(A.$qf(b.pattern))return!0}return!!b.isCaseSensitive}k(b){return b.isMultiline||b.isRegExp&&(0,y.$zB)(b.pattern)||b.pattern.indexOf(`
`)>=0?!0:!!b.isMultiline}parseSearchPaths(b){const v=q=>E.$hc(q)||/^\.\.?([\/\\]|$)/.test(q),N=(Array.isArray(b)?b:d(b)).map(q=>{const fe=this.e.resolvedUserHome;return fe?(0,L.$yv)(q,fe.scheme===p.Schemas.file?fe.fsPath:fe.path):q}),z=F.$J(N,q=>v(q)?"searchPaths":"exprSegments"),M=(z.exprSegments||[]).map(q=>A.$Le(q,"/")).map(q=>A.$Le(q,"\\")).map(q=>(q[0]==="."&&(q="*"+q),u(q))),O={},j=this.m(z.searchPaths||[]);j&&j.length&&(O.searchPaths=j);const T=I.$Qb(M),V=r(...T);return V&&(O.pattern=V),O}l(b,v){return v.disregardExcludeSettings?void 0:(0,o.$2I)(b,!v.disregardSearchExcludeSettings)}m(b){if(!b||!b.length)return[];const v=b.flatMap(N=>{let{pathPortion:z,globPortion:M}=t(N);return M&&(M=h(M)),this.n(z).flatMap(j=>this.o(j,M))}),C=new Map;return v.forEach(N=>{const z=N.searchPath.toString(),M=C.get(z);M?N.pattern&&(M.pattern=M.pattern||{},M.pattern[N.pattern]=!0):C.set(z,{searchPath:N.searchPath,pattern:N.pattern?r(N.pattern):void 0})}),Array.from(C.values())}n(b){if(E.$hc(b)){const v=this.b.getWorkspace().folders;return v[0]&&v[0].uri.scheme!==p.Schemas.file?[{searchPath:v[0].uri.with({path:b})}]:[{searchPath:g.URI.file(E.$gc(b))}]}if(this.b.getWorkbenchState()===2){const v=this.b.getWorkspace().folders[0].uri;if(b=l(b),b.startsWith("../")||b===".."){const N=E.$fc.resolve(v.path,b);return[{searchPath:v.with({path:N})}]}const C=h(b);return[{searchPath:v,pattern:C}]}else{if(b==="./"||b===".\\")return[];{const v=b.replace(/^\.[\/\\]/,""),N=this.b.getWorkspace().folders.map(z=>{const M=v.match(new RegExp(`^${A.$Ge(z.name)}(?:/(.*)|$)`));return M?{match:M,folder:z}:null}).filter(P.$Hf);if(N.length)return N.map(z=>{const M=z.match[1];return{searchPath:z.folder.uri,pattern:M&&h(M)}});{const z=b.match(/\.[\/\\](.+)[\/\\]?/),M=z?z[1]:b,O=S.localize(0,null,M);throw new Error(O)}}}}o(b,v){const C=b.pattern&&v?`${b.pattern}/${v}`:b.pattern||v,N=[{searchPath:b.searchPath,pattern:C}];return C&&!C.endsWith("**")&&N.push({searchPath:b.searchPath,pattern:C+"/**"}),N}q(b,v,C){const N=this.r((0,s.$ci)(b.searchPath),v,C,!1);return N?{...N,includePattern:b.pattern}:null}r(b,v,C,N){let z;const M=g.URI.isUri(b)?b:b.uri;if(C.searchPaths){const q=C.searchPaths.filter(fe=>(0,m.$pg)(fe.searchPath,M))[0];if(q&&!q.pattern)return null;q&&(z=q.pattern)}const O=this.a.getValue({resource:M}),T={...this.l(O,v)||{},...z||{}},V=g.URI.isUri(b)?(0,m.$tg)(b):b.name;return{folder:M,folderName:N?V:void 0,excludePattern:Object.keys(T).length>0?T:void 0,fileEncoding:O.files&&O.files.encoding,disregardIgnoreFiles:typeof v.disregardIgnoreFiles=="boolean"?v.disregardIgnoreFiles:!O.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof v.disregardGlobalIgnoreFiles=="boolean"?v.disregardGlobalIgnoreFiles:!O.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof v.disregardParentIgnoreFiles=="boolean"?v.disregardParentIgnoreFiles:!O.search.useParentIgnoreFiles,ignoreSymlinks:typeof v.ignoreSymlinks=="boolean"?v.ignoreSymlinks:!O.search.followSymlinks}}};e.$9J=a,e.$9J=a=He([Be(0,w.$ni),Be(1,s.$3h),Be(2,i.$DC),Be(3,c.$bj),Be(4,n.$7J)],a);function t($){const b=$.match(/[\*\{\}\(\)\[\]\?]/);if(b){const v=b.index,C=$.substr(0,v).match(/[/|\\][^/\\]*$/);if(C){let N=$.substr(0,C.index);return N.match(/[/\\]/)||(N+="/"),{pathPortion:N,globPortion:$.substr((C.index||0)+1)}}}return{pathPortion:$}}function r(...$){return $.length?$.reduce((b,v)=>(b[v]=!0,b),Object.create(null)):void 0}function d($){return f.$yj($,",").map(b=>b.trim()).filter(b=>!!b.length)}function u($){return[`**/${$}/**`,`**/${$}`].map(v=>v.replace(/\*\*\/\*\*/g,"**"))}function l($){return $.replace(/\\/g,"/")}function h($){return l($).replace(/^\.\//,"").replace(/\/+$/g,"")}function k($){return $.replace(/([?*[\]])/g,"[$1]")}function D($,b){$=I.$Lb($,N=>N.toString());const v=[],C=b.getWorkspace();return $&&$.forEach(N=>{let z;if(b.getWorkbenchState()===2)z=(0,m.$yg)(C.folders[0].uri,N),z&&z!=="."&&(z="./"+z);else{const M=b.getWorkspaceFolder(N);if(M){const O=M.name;if(C.folders.filter(T=>T.name===O).length===1){const T=(0,m.$yg)(M.uri,N);T===""?z=`./${M.name}`:z=`./${M.name}/${T}`}else z=N.fsPath}}z&&v.push(k(z))}),v}e.$0J=D}),define(ke[365],Se([1,0,23,2,21,11,5,364,36,40]),function($e,e,I,F,f,L,R,p,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xqb=e.$Wqb=void 0;const A=7e3;function P(w,c){const s=c.activationEvents;if(!s)return Promise.resolve(void 0);const i=[],n=[];for(const u of s)if(/^workspaceContains:/.test(u)){const l=u.substr(18);l.indexOf("*")>=0||l.indexOf("?")>=0||w.forceUsingSearch?n.push(l):i.push(l)}if(i.length===0&&n.length===0)return Promise.resolve(void 0);let o;const a=new Promise((u,l)=>{o=u}),t=u=>o({activationEvent:u}),r=Promise.all(i.map(u=>g(w,u,t))).then(()=>{}),d=y(w,c.identifier,n,t);return Promise.all([r,d]).then(()=>{o(void 0)}),a}e.$Wqb=P;async function g(w,c,s){for(const i of w.folders)if(await w.exists(I.$wg(F.URI.revive(i),c))){s(`workspaceContains:${c}`);return}}async function y(w,c,s,i){if(s.length===0)return Promise.resolve(void 0);const n=new f.$Yd,o=w.checkExists(w.folders,s,n.token),a=setTimeout(async()=>{n.cancel(),w.logService.info(`Not activating extension '${c.value}': Timed out while searching for 'workspaceContains' pattern ${s.join(",")}`)},A);let t=!1;try{t=await o}catch(r){L.$3(r)||L.$Z(r)}n.dispose(),clearTimeout(a),t&&i(`workspaceContains:${s.join(",")}`)}function S(w,c,s,i){const n=w.get(R.$Sh),o=w.get(E.$TI),t=n.createInstance(p.$9J).file(c.map(r=>(0,m.$ci)(F.URI.revive(r))),{_reason:"checkExists",includePattern:s,exists:!0});return o.fileSearch(t,i).then(r=>!!r.limitHit,r=>L.$3(r)?!1:Promise.reject(r))}e.$Xqb=S}),define(ke[47],Se([1,0,213,16,56,23,10,3,78,2,15,6,42,294,118,41,25,147,11,26,22,273,7,65,5,27,92,20,107,73,46,4,365,117,275,17,115,37,12,116]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,S,w,c,s,i,n,o,a,t,r,d,u,l,h,k,D,$,b,v,C,N,z,M,O,j,T){"use strict";var V;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ndc=e.$Mdc=e.$Ldc=e.$Kdc=e.$Jdc=void 0,e.$Jdc=(0,d.$Th)("IHostUtils");let q=V=class extends p.$Rc{constructor(H,U,ce,Ee,ne,G,J,ge,x,le,te,de){super(),this.X=de,this.a=this.B(new b.$Od),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=U,this.g=ce,this.f=J,this.j=Ee,this.m=ne,this.s=G,this.t=x,this.u=le,this.w=te,this.y=this.g.getProxy(P.$vK.MainThreadWorkspace),this.z=this.g.getProxy(P.$vK.MainThreadTelemetry),this.C=this.g.getProxy(P.$vK.MainThreadExtensionService),this.D=new R.$Tg,this.F=new R.$Tg,this.G=new R.$Tg,this.H=new R.$Tg,this.I=new se(this.f.extensions.activationEvents),this.L=new s.$e5b(this.I,this.f.extensions.allExtensions);const be=new n.$$l(this.f.extensions.myExtensions);this.J=new s.$e5b(this.I,ae(this.L,be)),j.$t&&(this.s.info(`Creating extension host with the following global extensions: ${Y(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Y(this.J)}`)),this.M=new S.$qdc(this.g,this.s),this.N=new C.$Cdc(this.g),this.O=ge,this.h=H.createChild(new k.$Rh([S.$rdc,this.M],[C.$Ddc,this.N])),this.P=this.B(new y.$pdc(this.J,this.L,{onExtensionActivationError:(Pe,B,Q)=>{this.C.$onExtensionActivationError(Pe,i.$2(B),Q)},actualActivateExtension:async(Pe,B)=>{if(s.$e5b.isHostExtension(Pe,this.J,this.L))return await this.C.$activateExtension(Pe,B),new y.$odc;const Q=this.J.getExtensionDescription(Pe);return this.db(Q,B)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),f.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(H){i.$Z(H)}}async Y(){this.O.onWillDeactivateAll();let H=[];try{H=this.J.getAllExtensionDescriptions().map(ne=>ne.identifier).filter(ne=>this.isActivated(ne)).map(ne=>this.cb(ne))}catch{}await Promise.all(H)}terminate(H,U=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${H}`),this.s.flush(),this.u.dispose(),this.P.dispose(),i.setUnexpectedErrorHandler(Ee=>{this.s.error(Ee)}),this.g.dispose();const ce=this.Y();Promise.race([(0,R.$Vg)(5e3),ce]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${U}`):this.s.info(`Extension host exiting with code ${U}`),this.s.flush(),this.s.dispose(),this.c.exit(U)})}isActivated(H){return this.G.isOpen()?this.P.isActivated(H):!1}async getExtension(H){const U=await this.C.$getExtension(H);return U&&{...U,identifier:new n.$0l(U.identifier.value),extensionLocation:m.URI.revive(U.extensionLocation)}}Z(H,U){return this.P.activateByEvent(H,U)}$(H,U){return this.P.activateById(H,U)}activateByIdWithErrors(H,U){return this.$(H,U).then(()=>{const ce=this.P.getActivatedExtension(H);if(ce.activationFailed)return Promise.reject(ce.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(H=>this.J)}getExtensionExports(H){if(this.G.isOpen())return this.P.getActivatedExtension(H).exports;try{return this.P.getActivatedExtension(H).exports}catch{return null}}async ab(H){if(H.scheme===z.Schemas.file&&this.c.fsRealpath){const U=await this.c.fsRealpath(H.fsPath);return m.URI.file(U)}return H}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(H=>new Z(H))),this.Q}async bb(H){const U=E.$Zh.forUris(ce=>L.$ng.ignorePathCasing(ce));return await Promise.all(H.map(async ce=>{if(this.ub(ce)){const Ee=await this.ab(ce.extensionLocation);U.set(Ee,ce)}})),U}cb(H){let U=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(H))return U;const ce=this.P.getActivatedExtension(H);if(!ce)return U;try{typeof ce.module.deactivate=="function"&&(U=Promise.resolve(ce.module.deactivate()).then(void 0,Ee=>(this.s.error(Ee),Promise.resolve(void 0))))}catch(Ee){this.s.error(`An error occurred when deactivating the extension '${H.value}':`),this.s.error(Ee)}try{(0,p.$Mc)(ce.subscriptions)}catch(Ee){this.s.error(`An error occurred when deactivating the subscriptions for extension '${H.value}':`),this.s.error(Ee)}return U}async db(H,U){return this.f.remote.isRemote?this.C.$onWillActivateExtension(H.identifier):await this.C.$onWillActivateExtension(H.identifier),this.fb(H,U).then(ce=>{const Ee=ce.activationTimes;return this.C.$onDidActivateExtension(H.identifier,Ee.codeLoadingTime,Ee.activateCallTime,Ee.activateResolvedTime,U),this.eb(H,U,"success",Ee),ce},ce=>{throw this.eb(H,U,"failure"),ce})}eb(H,U,ce,Ee){const ne=ee(H,U);this.z.$publicLog2("extensionActivationTimes",{...ne,...Ee||{},outcome:ce})}fb(H,U){const ce=ee(H,U);this.z.$publicLog2("activatePlugin",ce);const Ee=this.ub(H);if(!Ee)return Promise.resolve(new y.$ndc(y.$kdc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${H.identifier.value}, startup: ${U.startup}, activationEvent: '${U.activationEvent}'${H.identifier.value!==U.extensionId.value?`, root cause: ${U.extensionId.value}`:""}`),this.s.flush();const ne=new y.$ldc(U.startup);return Promise.all([this.vb(H,(0,L.$wg)(H.extensionLocation,Ee),ne),this.gb(H)]).then(G=>(f.mark(`code/extHost/willActivateExtension/${H.identifier.value}`),V.hb(this.s,H.identifier,G[0],G[1],ne))).then(G=>(f.mark(`code/extHost/didActivateExtension/${H.identifier.value}`),G))}gb(H){const U=new a.$tdc(H,this.M),ce=new a.$sdc(H.identifier.value,!1,this.M),Ee=new N.$Edc(H,this.N),ne=H.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,G=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${H.identifier.value}`),Promise.all([U.whenReady,ce.whenReady,this.O.whenReady]).then(()=>{const J=this;let ge,x;const le=(0,c.$uF)(H,"ipc")?this.f.messagePorts?.get(n.$0l.toKey(H.identifier)):void 0;return Object.freeze({globalState:U,workspaceState:ce,secrets:Ee,subscriptions:[],get extensionUri(){return H.extensionLocation},get extensionPath(){return H.extensionLocation.fsPath},asAbsolutePath(te){return F.$ic(H.extensionLocation.fsPath,te)},get storagePath(){return J.O.workspaceValue(H)?.fsPath},get globalStoragePath(){return J.O.globalValue(H).fsPath},get logPath(){return F.$ic(J.f.logsLocation.fsPath,H.identifier.value)},get logUri(){return m.URI.joinPath(J.f.logsLocation,H.identifier.value)},get storageUri(){return J.O.workspaceValue(H)},get globalStorageUri(){return J.O.globalValue(H)},get extensionMode(){return ne},get extension(){return ge===void 0&&(ge=new X(J,H.identifier,H,G,!1)),ge},get extensionRuntime(){return(0,c.$vF)(H,"extensionRuntime"),J.extensionRuntime},get environmentVariableCollection(){return J.u.getEnvironmentVariableCollection(H)},get messagePassingProtocol(){if(!x){if(!le)return;const te=b.Event.buffer(b.Event.fromDOMEventEmitter(le,"message",de=>de.data));le.start(),x={onDidReceiveMessage:te,postMessage:le.postMessage.bind(le)}}return x}})})}static hb(H,U,ce,Ee,ne){return ce=ce||{activate:void 0,deactivate:void 0},this.ib(H,U,ce,Ee,ne).then(G=>new y.$mdc(!1,null,ne.build(),ce,G,Ee.subscriptions))}static ib(H,U,ce,Ee,ne){if(typeof ce.activate=="function")try{ne.activateCallStart(),H.trace(`ExtensionService#_callActivateOptional ${U.value}`);const G=typeof global=="object"?global:self,J=ce.activate.apply(G,[Ee]);return ne.activateCallStop(),ne.activateResolveStart(),Promise.resolve(J).then(ge=>(ne.activateResolveStop(),ge))}catch(G){return Promise.reject(G)}else return Promise.resolve(ce)}jb(H,U){this.$(H.identifier,{startup:!1,extensionId:H.identifier,activationEvent:U}).then(void 0,ce=>{this.s.error(ce)})}kb(H,U=0){const Ee=Date.now();(0,j.$B)(()=>{for(let ne=U;ne<H.length;ne+=1){const G=H[ne];for(const J of G.activationEvents??[])if(J==="onStartupFinished")if(Date.now()-Ee>50){this.kb(H,ne);break}else this.jb(G,J)}})}lb(){this.C.$setPerformanceMarks(f.getMarks()),this.m.getConfigProvider().then(H=>{const U=H.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ce=this.J.getAllExtensionDescriptions();if(U)this.kb(ce);else for(const Ee of ce)if(Ee.activationEvents)for(const ne of Ee.activationEvents)ne==="onStartupFinished"&&this.jb(Ee,ne)})}mb(){const H=this.Z("*",!0).then(void 0,G=>{this.s.error(G)});this.B(this.j.onDidChangeWorkspace(G=>this.nb(G.added)));const U=this.j.workspace?this.j.workspace.folders:[],ce=this.nb(U),Ee=this.pb(),ne=Promise.all([Ee,H,ce]).then(()=>{});return Promise.race([ne,(0,R.$Vg)(1e4)]).then(()=>{this.lb()}),ne}nb(H){return H.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(U=>this.ob(H,U))).then(()=>{})}async ob(H,U){if(this.isActivated(U.identifier))return;const ce=!this.f.remote.isRemote&&!!this.f.remote.authority,Ee={logService:this.s,folders:H.map(G=>G.uri),forceUsingSearch:ce||!this.c.fsExists,exists:G=>this.c.fsExists(G.fsPath),checkExists:(G,J,ge)=>this.y.$checkExists(G,J,ge)},ne=await(0,v.$Wqb)(Ee,U);if(ne)return this.$(U.identifier,{startup:!0,extensionId:U.identifier,activationEvent:ne.activationEvent}).then(void 0,G=>this.s.error(G))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(H){throw console.error(H),H}}async qb(){const{extensionDevelopmentLocationURI:H,extensionTestsLocationURI:U}=this.f.environment;if(!H||!U)throw new Error(I.localize(0,null));const ce=await this.vb(null,U,new y.$ldc(!1));if(!ce||typeof ce.run!="function")throw new Error(I.localize(1,null,U.toString()));return new Promise((Ee,ne)=>{const G=(x,le)=>{x?(j.$t&&this.s.error("Test runner called back with error",x),ne(x)):(j.$t&&(le?this.s.info(`Test runner called back with ${le} failures.`):this.s.info("Test runner called back with successful outcome.")),Ee(typeof le=="number"&&le>0?1:0))},J=(0,L.$kg)(U),ge=ce.run(J,G);ge&&ge.then&&ge.then(()=>{j.$t&&this.s.info("Test runner finished successfully."),Ee(0)}).catch(x=>{j.$t&&this.s.error("Test runner finished with error",x),ne(x instanceof Error&&x.stack?x.stack:String(x))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$Vg)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(H,U){return this.R[H]=U,(0,p.$Pc)(()=>{delete this.R[H]})}async getRemoteExecServer(H){const{resolver:U}=await this.sb(H);return U?.resolveExecServer?.(H,{resolveAttempt:0})}async sb(H){const U=H.indexOf("+");if(U===-1)throw new t.$DK("Not an authority that can be resolved!",r.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ce=H.substr(0,U);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${ce}`,!1),{authorityPrefix:ce,resolver:this.R[ce]}}async $resolveAuthority(H,U){const ce=O.$Kd.create(!1),Ee=()=>`[resolveAuthority(${(0,r.$Xk)(H)},${U})][${ce.elapsed()}ms] `,ne=oe=>this.s.info(`${Ee()}${oe}`),G=oe=>this.s.warn(`${Ee()}${oe}`),J=(oe,_=void 0)=>this.s.error(`${Ee()}${oe}`,_),ge=oe=>{if(oe instanceof t.$DK)return{type:"error",error:{code:oe._code,message:oe._message,detail:oe._detail}};throw oe},x=async oe=>{ne(`activating resolver for ${oe}...`);const{resolver:_,authorityPrefix:me}=await this.sb(oe);if(!_)throw J(`no resolver for ${me}`),new t.$DK(`No remote extension installed to resolve ${me}.`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:_,authorityPrefix:me,remoteAuthority:oe}},le=H.split(/@|%40/g).reverse();ne(`activating remote resolvers ${le.join(" -> ")}`);let te;try{te=await Promise.all(le.map(x)).catch(async oe=>{if(!(oe instanceof t.$DK)||oe._code!==r.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw oe;return G(`resolving nested authorities failed: ${oe.message}`),[await x(H)]})}catch(oe){return ge(oe)}const de=new R.$7g;de.cancelAndSet(()=>ne("waiting..."),1e3);let be,Pe;for(const[oe,{authorityPrefix:_,resolver:me,remoteAuthority:ye}]of te.entries())try{if(oe===te.length-1)ne("invoking final resolve()..."),f.mark(`code/extHost/willResolveAuthority/${_}`),be=await me.resolve(ye,{resolveAttempt:U,execServer:Pe}),f.mark(`code/extHost/didResolveAuthorityOK/${_}`),ne("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(me,t.$CK.isManagedResolvedAuthority(be)?be:void 0));else{if(ne(`invoking resolveExecServer() for ${ye}`),f.mark(`code/extHost/willResolveExecServer/${_}`),Pe=await me.resolveExecServer?.(ye,{resolveAttempt:U,execServer:Pe}),!Pe)throw new t.$DK(`Exec server was not available for ${ye}`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);f.mark(`code/extHost/didResolveExecServerOK/${_}`)}}catch(ze){return f.mark(`code/extHost/didResolveAuthorityError/${_}`),J("returned an error",ze),de.dispose(),ge(ze)}de.dispose();const B={environmentTunnels:be.environmentTunnels,features:be.tunnelFeatures},Q={extensionHostEnv:be.extensionHostEnv,isTrusted:be.isTrusted,authenticationSession:be.authenticationSessionForInitializingExtensions?{id:be.authenticationSessionForInitializingExtensions.id,providerId:be.authenticationSessionForInitializingExtensions.providerId}:void 0};ne(`returned ${t.$CK.isManagedResolvedAuthority(be)?"managed authority":`${be.host}:${be.port}`}`);let re;if(t.$CK.isManagedResolvedAuthority(be)){const oe=U;this.X.setFactory(oe,be.makeConnection),re={authority:H,connectTo:new r.$Uk(oe),connectionToken:be.connectionToken}}else re={authority:H,connectTo:new r.$Vk(be.host,be.port),connectionToken:be.connectionToken};return{type:"ok",value:{authority:re,options:Q,tunnelInformation:B}}}async $getCanonicalURI(H,U){this.s.info(`$getCanonicalURI invoked for authority (${(0,r.$Xk)(H)})`);const{resolver:ce}=await this.sb(H);if(!ce)return null;const Ee=m.URI.revive(U);if(typeof ce.getCanonicalURI>"u")return Ee;const ne=await(0,R.$Ng)(()=>ce.getCanonicalURI(Ee));return ne||Ee}$startExtensionHost(H){H.toAdd.forEach(Ee=>Ee.extensionLocation=m.URI.revive(Ee.extensionLocation));const{globalRegistry:U,myExtensions:ce}=fe(this.I,this.L,this.J,H);return this.L.set(U.getAllExtensionDescriptions()),this.J.set(ce),j.$t&&(this.s.info(`$startExtensionHost: global extensions: ${Y(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Y(this.J)}`)),this.rb()}$activateByEvent(H,U){return U===1?this.D.wait().then(ce=>this.Z(H,!1)):this.G.wait().then(ce=>this.Z(H,!1))}async $activate(H,U){return await this.G.wait(),this.J.getExtensionDescription(H)?(await this.$(H,U),!0):!1}async $deltaExtensions(H){H.toAdd.forEach(G=>G.extensionLocation=m.URI.revive(G.extensionLocation));const{globalRegistry:U,myExtensions:ce}=fe(this.I,this.L,this.J,H),Ee=await this.bb(ce);return(await this.getExtensionPathIndex()).setSearchTree(Ee),this.L.set(U.getAllExtensionDescriptions()),this.J.set(ce),j.$t&&(this.s.info(`$deltaExtensions: global extensions: ${Y(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Y(this.J)}`)),Promise.resolve(void 0)}async $test_latency(H){return H}async $test_up(H){return H.byteLength}async $test_down(H){const U=o.$ce.alloc(H),ce=Math.random()%256;for(let Ee=0;Ee<H;Ee++)U.writeUInt8(ce,Ee);return U}async $updateRemoteConnectionData(H){this.W=H,this.a.fire()}};e.$Kdc=q,e.$Kdc=q=V=He([Be(0,d.$Sh),Be(1,e.$Jdc),Be(2,h.$xM),Be(3,w.$ddc),Be(4,g.$gdc),Be(5,A.$bj),Be(6,u.$NM),Be(7,l.$wdc),Be(8,D.$Iwb),Be(9,$.$ydc),Be(10,M.$Gdc),Be(11,T.$Hdc)],q);function fe(we,H,U,ce){we.addActivationEvents(ce.addActivationEvents);const Ee=new s.$e5b(we,H.getAllExtensionDescriptions());Ee.deltaExtensions(ce.toAdd,ce.toRemove);const ne=new n.$$l(U.getAllExtensionDescriptions().map(J=>J.identifier));for(const J of ce.myToRemove)ne.delete(J);for(const J of ce.myToAdd)ne.add(J);const G=ae(Ee,ne);return{globalRegistry:Ee,myExtensions:G}}function ee(we,H){return{id:we.identifier.value,name:we.name,extensionVersion:we.version,publisherDisplayName:we.publisher,activationEvents:we.activationEvents?we.activationEvents.join(","):null,isBuiltin:we.isBuiltin,reason:H.activationEvent,reasonId:H.extensionId.value}}function Y(we){return we.getAllExtensionDescriptions().map(H=>H.identifier.value).join(",")}e.$Ldc=(0,d.$Th)("IExtHostExtensionService");class X{#e;#t;#i;constructor(H,U,ce,Ee,ne){this.#e=H,this.#t=U,this.#i=ce.identifier,this.id=ce.identifier.value,this.extensionUri=ce.extensionLocation,this.extensionPath=F.$gc((0,L.$kg)(ce.extensionLocation)),this.packageJSON=ce,this.extensionKind=Ee,this.isFromDifferentExtensionHost=ne}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Mdc=X;function ae(we,H){return we.getAllExtensionDescriptions().filter(U=>H.has(U.identifier))}class Z{constructor(H){this.a=H}setSearchTree(H){this.a=H}findSubstr(H){return this.a.findSubstr(H)}forEach(H){return this.a.forEach(H)}}e.$Ndc=Z;class se{constructor(H){this.a=new n.$_l,this.addActivationEvents(H)}readActivationEvents(H){return this.a.get(H.identifier)??[]}addActivationEvents(H){for(const U of Object.keys(H))this.a.set(U,H[U])}}}),define(ke[366],Se([1,0,56,2,6,42,25,26,20,27,5,47,15,13]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$_ec=void 0;let w=class{constructor(o,a,t,r,d,u,l){this.c=o,this.d=a,this.e=t,this.f=r,this.g=d,this.h=u,this.i=l,this.a=new Map,this.b=[]}async install(){this.j(),I.mark("code/extHost/willWaitForConfig");const o=await this.f.getConfigProvider();I.mark("code/extHost/didWaitForConfig");const a=await this.g.getExtensionPathIndex();this.register(new s(this.c,a,this.d,o,this.i)),this.register(this.e.createInstance(c)),this.h.remote.isRemote&&this.register(this.e.createInstance(i,a,this.h.environment.appUriScheme))}register(o){if("nodeModuleName"in o)if(Array.isArray(o.nodeModuleName))for(const a of o.nodeModuleName)this.a.set(a,o);else this.a.set(o.nodeModuleName,o);typeof o.alternativeModuleName=="function"&&this.b.push(a=>o.alternativeModuleName(a))}};e.$_ec=w,e.$_ec=w=He([Be(2,A.$Sh),Be(3,L.$gdc),Be(4,P.$Ldc),Be(5,m.$NM),Be(6,g.$bj)],w);let c=class{static{S=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(o){if(o.environment.appRoot&&S.a.size){const a=(0,y.$Ge)(this.c(o.environment.appRoot.fsPath)),t="[a-z0-9_.-]",r=`@${t}+\\/${t}+|${t}+`,d="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${a}/${d}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(o){if(!this.b)return;const a=this.b.exec(this.c(o));if(!a)return;const[,t,r,d]=a,u=S.a.get(r);if(u!==void 0)return console.warn(`${r} as been renamed to ${u}, please update your imports`),t+u+d}c(o){return o.replace(/\\/g,"/")}};c=S=He([Be(0,m.$NM)],c);class s{constructor(o,a,t,r,d){this.c=o,this.d=a,this.e=t,this.f=r,this.g=d,this.nodeModuleName="vscode",this.a=new p.$_l}load(o,a){const t=this.d.findSubstr(a);if(t){let r=this.a.get(t.identifier);return r||(r=this.c(t,this.e,this.f),this.a.set(t.identifier,r)),r}if(!this.b){let r="";this.d.forEach((d,u)=>r+=`	${u} -> ${d.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${a}. These are the extension path mappings: 
${r}`),this.b=this.c(R.$pF,this.e,this.f)}return this.b}}let i=class{constructor(o,a,t){this.e=o,this.f=a,this.nodeModuleName=["open","opn"],this.d=t.getProxy(f.$vK.MainThreadTelemetry);const r=t.getProxy(f.$vK.MainThreadWindow);this.c=(d,u)=>{const l=F.URI.parse(d);return u?this.g(d,u):l.scheme==="http"||l.scheme==="https"?r.$openUri(l,d,{allowTunneling:!0}):l.scheme==="mailto"||l.scheme===this.f?r.$openUri(l,d,{}):this.g(d,u)}}load(o,a,t){const r=this.e.findSubstr(a);return r&&(this.a=r.identifier.value,this.h()),this.b=t(o),this.c}g(o,a){return this.i(),this.b(o,a)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};i=He([Be(2,E.$xM)],i)}),define(ke[58],Se([1,0,48,3,16,49,5,70,71,47,7,41,291,42]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iec=e.$hec=void 0,e.$hec=(0,R.$Th)("IExtHostVariableResolverProvider");class S extends g.$yN{constructor(s,i,n,o,a,t,r){function d(){if(n){const u=n.activeEditor();if(u)return u.document.uri;const l=o.tabGroups.all.find(h=>h.isActive)?.activeTab;if(l!==void 0){if(l.input instanceof A.$dM||l.input instanceof A.$iM)return l.input.modified;if(l.input instanceof A.$cM||l.input instanceof A.$hM||l.input instanceof A.$fM)return l.input.uri}}}super({getFolderUri:u=>{const l=t.folders.filter(h=>h.name===u);if(l&&l.length>0)return l[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(u,l)=>a.getConfiguration(void 0,u).get(l),getAppRoot:()=>L.cwd(),getExecPath:()=>L.env.VSCODE_EXEC_PATH,getFilePath:()=>{const u=d();if(u)return f.$gc(u.fsPath)},getWorkspaceFolderPathForFile:()=>{if(i){const u=d();if(u){const l=i.getWorkspaceFolder(u);if(l)return f.$gc(l.uri.fsPath)}}},getSelectedText:()=>{if(n){const u=n.activeEditor();if(u&&!u.selection.isEmpty)return u.document.getText(u.selection)}},getLineNumber:()=>{if(n){const u=n.activeEditor();if(u)return String(u.selection.end.line+1)}},getExtension:u=>s.getExtension(u)},void 0,r?Promise.resolve(r):void 0,Promise.resolve(L.env))}}let w=class extends F.$Rc{constructor(s,i,n,o,a){super(),this.b=s,this.c=i,this.g=n,this.h=o,this.j=a,this.a=new I.$U(async()=>{const t=await this.h.getConfigProvider(),d={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async u=>{d.folders=await this.c.getWorkspaceFolders2()||[]})),new S(this.b,this.c,this.g,this.j,t,d,this.m())})}getResolver(){return this.a.value}m(){}};e.$iec=w,e.$iec=w=He([Be(0,m.$Ldc),Be(1,P.$ddc),Be(2,p.$IM),Be(3,y.$gdc),Be(4,E.$fec)],w)}),define(ke[96],Se([1,0,10,4,2,5,6,71,47,20,7,41,142,283,42,58]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nec=e.$mec=e.$lec=e.$kec=e.$jec=void 0,e.$jec=(0,L.$Th)("IExtHostDebugService");let c=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(r,d,u,l,h,k){this.E=d,this.F=u,this.G=l,this.H=h,this.I=k,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new F.$Od,this.n=new F.$Od,this.o=new F.$Od,this.u=new F.$Od,this.k=r.getProxy(R.$vK.MainThreadDebugService),this.y=new F.$Od,this.A=new F.$Od,this.v=new i(this.k),this.w=new Map,this.F.getExtensionRegistry().then(D=>{D.onDidChange($=>{this.J(D)}),this.J(D)})}asDebugSourceUri(r,d){const u=r;if(typeof u.sourceReference=="number"&&u.sourceReference>0){let l=`debug:${encodeURIComponent(u.path||"")}`,h="?";return d&&(l+=`${h}session=${encodeURIComponent(d.id)}`,h="&"),l+=`${h}ref=${u.sourceReference}`,f.URI.parse(l)}else{if(u.path)return f.URI.file(u.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(r){const d=[];for(const u of r.getAllExtensionDescriptions())if(u.contributes){const l=u.contributes.debuggers;if(l&&l.length>0)for(const h of l)(0,y.$JF)(h)&&d.push(h.type)}this.k.$registerDebugTypes(d)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const r=[];return this.w.forEach(d=>r.push(d)),r}addBreakpoints(r){const d=r.filter(h=>{const k=h.id;return this.w.has(k)?!1:(this.w.set(k,h),!0)});this.U(d,[],[]);const u=[],l=new Map;for(const h of d)if(h instanceof A.$wL){let k=l.get(h.location.uri.toString());k||(k={type:"sourceMulti",uri:h.location.uri,lines:[]},l.set(h.location.uri.toString(),k),u.push(k)),k.lines.push({id:h.id,enabled:h.enabled,condition:h.condition,hitCondition:h.hitCondition,logMessage:h.logMessage,line:h.location.range.start.line,character:h.location.range.start.character})}else h instanceof A.$xL&&u.push({type:"function",id:h.id,enabled:h.enabled,hitCondition:h.hitCondition,logMessage:h.logMessage,condition:h.condition,functionName:h.functionName});return this.k.$registerBreakpoints(u)}removeBreakpoints(r){const d=r.filter(k=>this.w.delete(k.id));this.U([],d,[]);const u=d.filter(k=>k instanceof A.$wL).map(k=>k.id),l=d.filter(k=>k instanceof A.$xL).map(k=>k.id),h=d.filter(k=>k instanceof A.$yL).map(k=>k.id);return this.k.$unregisterBreakpoints(u,l,h)}startDebugging(r,d,u){return this.k.$startDebugging(r?r.uri:void 0,d,{parentSessionID:u.parentSession?u.parentSession.id:void 0,lifecycleManagedByParent:u.lifecycleManagedByParent,repl:u.consoleMode===A.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:u.noDebug,compact:u.compact,suppressSaveBeforeStart:u.suppressSaveBeforeStart,suppressDebugStatusbar:u.suppressDebugStatusbar??u.debugUI?.simple,suppressDebugToolbar:u.suppressDebugToolbar??u.debugUI?.simple,suppressDebugView:u.suppressDebugView??u.debugUI?.simple})}stopDebugging(r){return this.k.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,d,u){if(!d)return new A.$xK(()=>{});const l=this.d++;return this.f.push({type:r,handle:l,provider:d}),this.k.$registerDebugConfigurationProvider(r,u,!!d.provideDebugConfigurations,!!d.resolveDebugConfiguration,!!d.resolveDebugConfigurationWithSubstitutedVariables,l),new A.$xK(()=>{this.f=this.f.filter(h=>h.provider!==d),this.k.$unregisterDebugConfigurationProvider(l)})}registerDebugAdapterDescriptorFactory(r,d,u){if(!u)return new A.$xK(()=>{});if(!this.Q(r,d))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${d}' debugger.`);if(this.N(d))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const l=this.g++;return this.h.push({type:d,handle:l,factory:u}),this.k.$registerDebugAdapterDescriptorFactory(d,l),new A.$xK(()=>{this.h=this.h.filter(h=>h.factory!==u),this.k.$unregisterDebugAdapterDescriptorFactory(l)})}registerDebugAdapterTrackerFactory(r,d){if(!d)return new A.$xK(()=>{});const u=this.i++;return this.j.push({type:r,handle:u,factory:d}),new A.$xK(()=>{this.j=this.j.filter(l=>l.factory!==d)})}async $runInTerminal(r,d){return Promise.resolve(void 0)}async $substituteVariables(r,d){let u;const l=await this.W(r);return l&&(u={uri:l.uri,name:l.name,index:l.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(u,d)}K(r,d){if(r.type==="implementation")return new o(r.implementation)}L(){}async $startDASession(r,d){const u=this,l=await this.V(d);return this.S(this.N(l.type),l).then(h=>{if(!h)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${l.type}' (extension might have failed to activate)`);const k=this.M(h),D=this.K(k,l);if(!D)throw new Error(`Couldn't create a debug adapter for type '${l.type}'.`);const $=D;return this.B.set(r,$),this.R(l).then(b=>(b&&this.C.set(r,b),$.onMessage(async v=>{if(v.type==="request"&&v.command==="handshake"){const C=v,N={type:"response",seq:0,command:C.command,request_seq:C.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const z=await this.D.sign(C.arguments.value);N.body={signature:z},$.sendResponse(N)}else throw new Error("no signer")}catch(z){N.success=!1,N.message=z.message,$.sendResponse(N)}}else b&&b.onDidSendMessage&&b.onDidSendMessage(v),v=(0,y.$OF)(v,!0),u.k.$acceptDAMessage(r,v)}),$.onError(v=>{b&&b.onError&&b.onError(v),this.k.$acceptDAError(r,v.name,v.message,v.stack)}),$.onExit(v=>{b&&b.onExit&&b.onExit(v??void 0,void 0),this.k.$acceptDAExit(r,v??void 0,void 0)}),b&&b.onWillStartSession&&b.onWillStartSession(),$.startSession()))})}$sendDAMessage(r,d){d=(0,y.$NF)(d,!1);const u=this.C.get(r);u&&u.onWillReceiveMessage&&u.onWillReceiveMessage(d),this.B.get(r)?.sendMessage(d)}$stopDASession(r){const d=this.C.get(r);this.C.delete(r),d&&d.onWillStopSession&&d.onWillStopSession();const u=this.B.get(r);return this.B.delete(r),u?u.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const d=[],u=[],l=[];if(r.added)for(const h of r.added){const k=h.id;if(k&&!this.w.has(k)){let D;if(h.type==="function")D=new A.$xL(h.functionName,h.enabled,h.condition,h.hitCondition,h.logMessage);else if(h.type==="data")D=new A.$yL(h.label,h.dataId,h.canPersist,h.enabled,h.hitCondition,h.condition,h.logMessage);else{const $=f.URI.revive(h.uri);D=new A.$wL(new A.$JK($,new A.$yK(h.line,h.character)),h.enabled,h.condition,h.hitCondition,h.logMessage)}(0,A.$uL)(D,k),this.w.set(k,D),d.push(D)}}if(r.removed)for(const h of r.removed){const k=this.w.get(h);k&&(this.w.delete(h),u.push(k))}if(r.changed){for(const h of r.changed)if(h.id){const k=this.w.get(h.id);if(k){if(k instanceof A.$xL&&h.type==="function"){const D=k;D.enabled=h.enabled,D.condition=h.condition,D.hitCondition=h.hitCondition,D.logMessage=h.logMessage,D.functionName=h.functionName}else if(k instanceof A.$wL&&h.type==="source"){const D=k;D.enabled=h.enabled,D.condition=h.condition,D.hitCondition=h.hitCondition,D.logMessage=h.logMessage,D.location=new A.$JK(f.URI.revive(h.uri),new A.$yK(h.line,h.character))}l.push(k)}}}this.U(d,u,l)}async $acceptStackFrameFocus(r){let d;const u=r.sessionId?await this.V(r.sessionId):void 0;if(!u)throw new Error("no DebugSession found for debug focus context");r.kind==="thread"?d=new A.$EL(u,r.threadId):d=new A.$DL(u,r.threadId,r.frameId),this.z=d,this.A.fire(this.z)}$provideDebugConfigurations(r,d,u){return(0,I.$Ng)(async()=>{const l=this.P(r);if(!l)throw new Error("no DebugConfigurationProvider found");if(!l.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const h=await this.W(d);return l.provideDebugConfigurations(h,u)}).then(l=>{if(!l)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return l})}$resolveDebugConfiguration(r,d,u,l){return(0,I.$Ng)(async()=>{const h=this.P(r);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const k=await this.W(d);return h.resolveDebugConfiguration(k,u,l)})}$resolveDebugConfigurationWithSubstitutedVariables(r,d,u,l){return(0,I.$Ng)(async()=>{const h=this.P(r);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const k=await this.W(d);return h.resolveDebugConfigurationWithSubstitutedVariables(k,u,l)})}async $provideDebugAdapter(r,d){const u=this.O(r);if(!u)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const l=await this.V(d);return this.S(u,l).then(h=>{if(!h)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${l.type}'`);return this.M(h)})}async $acceptDebugSessionStarted(r){const d=await this.V(r);this.m.fire(d)}async $acceptDebugSessionTerminated(r){const d=await this.V(r);d&&(this.n.fire(d),this.l.delete(d.id))}async $acceptDebugSessionActiveChanged(r){this.q=r?await this.V(r):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(r,d){(await this.V(r))?._acceptNameChanged(d)}async $acceptDebugSessionCustomEvent(r,d){const l={session:await this.V(r),event:d.event,body:d.body};this.u.fire(l)}M(r){if(r instanceof A.$zL)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof A.$AL)return{type:"server",port:r.port,host:r.host};if(r instanceof A.$BL)return{type:"pipeServer",path:r.path};if(r instanceof A.$CL)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}N(r){const d=this.h.filter(u=>u.type===r);if(d.length>0)return d[0].factory}O(r){const d=this.h.filter(u=>u.handle===r);if(d.length>0)return d[0].factory}P(r){const d=this.f.filter(u=>u.handle===r);if(d.length>0)return d[0].provider}Q(r,d){if(r.contributes){const u=r.contributes.debuggers;if(u&&u.length>0){for(const l of u)if(l.label&&l.type&&l.type===d)return!0}}return!1}R(r){const u=r.configuration.type,l=this.j.filter(h=>h.type===u||h.type==="*").map(h=>(0,I.$Ng)(()=>h.factory.createDebugAdapterTracker(r)).then(k=>k,k=>null));return Promise.race([Promise.all(l).then(h=>{const k=h.filter(D=>!!D);if(k.length>0)return new n(k)}),new Promise(h=>setTimeout(()=>h(void 0),1e3))]).catch(h=>{})}async S(r,d){const u=d.configuration.debugServer;if(typeof u=="number")return Promise.resolve(new A.$AL(u));if(r){const h=await this.F.getExtensionRegistry();return(0,I.$Ng)(()=>r.createDebugAdapterDescriptor(d,this.T(d,h))).then(k=>{if(k)return k})}const l=await this.F.getExtensionRegistry();return Promise.resolve(this.T(d,l))}T(r,d){}U(r,d,u){(r.length>0||d.length>0||u.length>0)&&this.y.fire(Object.freeze({added:r,removed:d,changed:u}))}async V(r){if(r)if(typeof r=="string"){const d=this.l.get(r);if(d)return d}else{let d=this.l.get(r.id);if(!d){const u=await this.W(r.folderUri),l=r.parent?this.l.get(r.parent):void 0;d=new s(this.k,r.id,r.type,r.name,u,r.configuration,l),this.l.set(d.id,d),this.k.$sessionCached(d.id)}return d}throw new Error("cannot find session")}W(r){if(r){const d=f.URI.revive(r);return this.E.resolveWorkspaceFolder(d)}return Promise.resolve(void 0)}};e.$kec=c,e.$kec=c=He([Be(0,m.$xM),Be(1,P.$ddc),Be(2,E.$Ldc),Be(3,S.$gdc),Be(4,p.$fec),Be(5,w.$hec)],c);class s{constructor(r,d,u,l,h,k,D){this.d=r,this.f=d,this.g=u,this.h=l,this.i=h,this.j=k,this.k=D}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(r){this.h=r,this.d.$setDebugSessionName(this.f,r)}get parentSession(){return this.k}_acceptNameChanged(r){this.h=r}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(r,d){return this.d.$customDebugAdapterRequest(this.f,r,d)}getDebugProtocolBreakpoint(r){return this.d.$getDebugProtocolBreakpoint(this.f,r.id)}}e.$lec=s;class i{constructor(r){this.value=Object.freeze({append(d){r.$appendDebugConsole(d)},appendLine(d){this.append(d+`
`)}})}}e.$mec=i;class n{constructor(r){this.d=r}onWillStartSession(){this.d.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.d.forEach(d=>d.onWillReceiveMessage?d.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.d.forEach(d=>d.onDidSendMessage?d.onDidSendMessage(r):void 0)}onWillStopSession(){this.d.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.d.forEach(d=>d.onError?d.onError(r):void 0)}onExit(r,d){this.d.forEach(u=>u.onExit?u.onExit(r,d):void 0)}}class o extends g.$Ddb{constructor(r){super(),this.h=r,r.onDidSendMessage(d=>{this.acceptMessage(d)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.h.handleMessage(r)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let a=class extends c{constructor(r,d,u,l,h,k){super(r,d,u,l,h,k)}};e.$nec=a,e.$nec=a=He([Be(0,m.$xM),Be(1,P.$ddc),Be(2,E.$Ldc),Be(3,S.$gdc),Be(4,p.$fec),Be(5,w.$hec)],a)}),define(ke[367],Se([1,0,11,56,2,6,355,15,106,107,27,249,20,67,47,90]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bfc=e.$afc=void 0;class c{static async installEarlyHandler(n){Error.stackTraceLimit=100;const o=n.get(p.$bj),t=n.get(g.$xM).getProxy(L.$vK.MainThreadErrors);I.setUnexpectedErrorHandler(r=>{o.error(r);const d=I.$2(r);t.$onUnexpectedError(d)})}static async installFullHandler(n){const o=n.get(p.$bj),a=n.get(g.$xM),t=n.get(S.$Ldc),r=n.get(w.$RM),d=a.getProxy(L.$vK.MainThreadExtensionService),u=a.getProxy(L.$vK.MainThreadErrors),l=await t.getExtensionPathIndex(),h=new WeakMap;function k(b,v){if(h.has(b))return h.get(b).stack;let C="",N,z;for(const O of v)C+=`
	at ${O.toString()}`,z=O.getFileName(),!N&&z&&(N=l.findSubstr(f.URI.file(z)));const M=`${b.name||"Error"}: ${b.message||""}${C}`;return h.set(b,{extensionIdentifier:N?.identifier,stack:M}),M}const D=Symbol("prepareStackTrace wrapped");let $=k;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return $},set(b){if(b===k||!b||b[D]){$=b||k;return}$=function(v,C){return k(v,C),b.call(Error,v,C)},Object.assign($,{[D]:!0})}}),I.setUnexpectedErrorHandler(b=>{o.error(b);const v=I.$2(b),C=h.get(b);if(!C?.extensionIdentifier){u.$onUnexpectedError(v);return}d.$onExtensionRuntimeError(C.extensionIdentifier,v);const N=r.onExtensionError(C.extensionIdentifier,b);o.trace("forwarded error to extension?",N,C)})}}e.$afc=c;class s{constructor(n,o,a,t,r){this.a=a,this.b=new R.$m5b(n,null,t),o=s.e(o,this.b);const d=new m.$Rh(...(0,E.$Br)());d.set(A.$NM,{_serviceBrand:void 0,...o,messagePorts:r}),d.set(g.$xM,new g.$yM(this.b)),d.set(y.$adc,new y.$bdc(t)),d.set(S.$Jdc,a);const u=new P.$hq(d,!0);u.invokeFunction(c.installEarlyHandler),this.d=u.invokeFunction(l=>l.get(p.$bj)),F.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",o),this.c=u.invokeFunction(l=>l.get(S.$Ldc)),this.c.initialize(),u.invokeFunction(c.installFullHandler)}async asBrowserUri(n){const o=this.b.getProxy(L.$vK.MainThreadExtensionService);return f.URI.revive(await o.$asBrowserUri(n))}terminate(n){this.c.terminate(n)}static e(n,o){n.extensions.allExtensions.forEach(t=>{t.extensionLocation=f.URI.revive(o.transformIncomingURIs(t.extensionLocation))}),n.environment.appRoot=f.URI.revive(o.transformIncomingURIs(n.environment.appRoot));const a=n.environment.extensionDevelopmentLocationURI;return a&&(n.environment.extensionDevelopmentLocationURI=a.map(t=>f.URI.revive(o.transformIncomingURIs(t)))),n.environment.extensionTestsLocationURI=f.URI.revive(o.transformIncomingURIs(n.environment.extensionTestsLocationURI)),n.environment.globalStorageHome=f.URI.revive(o.transformIncomingURIs(n.environment.globalStorageHome)),n.environment.workspaceStorageHome=f.URI.revive(o.transformIncomingURIs(n.environment.workspaceStorageHome)),n.environment.extensionTelemetryLogResource=f.URI.revive(o.transformIncomingURIs(n.environment.extensionTelemetryLogResource)),n.nlsBaseUrl=f.URI.revive(o.transformIncomingURIs(n.nlsBaseUrl)),n.logsLocation=f.URI.revive(o.transformIncomingURIs(n.logsLocation)),n.workspace=o.transformIncomingURIs(n.workspace),n}}e.$bfc=s}),define(ke[368],Se([1,0,10,12,224,243,140,96,71,47,20,46,7,58,41,284,285,42]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,S,w,c,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lfc=void 0;let i=class extends p.$kec{constructor(r,d,u,l,h,k,D){super(r,d,u,l,k,D),this.Z=h,this.X=new a}K(r,d){switch(r.type){case"server":return new w.$gfc(r);case"pipeServer":return new w.$hfc(r);case"executable":return new w.$ifc(r,d.type)}return super.K(r,d)}T(r,d){const u=w.$ifc.platformAdapterExecutable(d.getAllExtensionDescriptions(),r.type);if(u)return new g.$zL(u.command,u.args,u.options)}L(){return new R.$_8b}async $runInTerminal(r,d){if(r.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(M=>{this.X.onTerminalClosed(M)}));const u=await this.G.getConfigProvider(),l=this.Z.getDefaultShell(!0),h=this.Z.getDefaultShellArgs(!0),k=r.title||f.localize(0,null),D=JSON.stringify({shell:l,shellArgs:h});let $=await this.X.checkout(D,k),b,v=!1;if($)b=r.cwd;else{const M={shellPath:l,shellArgs:h,cwd:r.cwd,name:k,iconPath:new g.$rL("debug")};v=!0,$=this.Z.createTerminalFromOptions(M,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert($,D)}$.show(!0);const C=await $.processId;v?await new Promise(M=>setTimeout(M,1e3)):u.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(l.indexOf("powershell")>=0||l.indexOf("pwsh")>=0||l.indexOf("cmd.exe")>=0?$.sendText("cls"):l.indexOf("bash")>=0?$.sendText("clear"):F.$j?$.sendText("cls"):$.sendText("clear"));const N=(0,c.$kfc)(l,r.args,!!r.argsCanBeInterpretedByShell,b,r.env);$.sendText(N);const z=this.onDidTerminateDebugSession(M=>{M.id===d&&(this.X.free($),z.dispose())});return C}else if(r.kind==="external")return o(r,await this.G.getConfigProvider());return super.$runInTerminal(r,d)}};e.$lfc=i,e.$lfc=i=He([Be(0,A.$xM),Be(1,S.$ddc),Be(2,m.$Ldc),Be(3,s.$gdc),Be(4,P.$ydc),Be(5,E.$fec),Be(6,y.$hec)],i);let n;function o(t,r){if(!n)if(F.$j)n=new L.$X7b;else if(F.$k)n=new L.$Y7b;else if(F.$l)n=new L.$Z7b;else throw new Error("external terminals not supported on this platform");const d=r.getConfiguration("terminal");return n.runInTerminal(t.title,t.cwd,t.args,t.env||{},d.external||{})}class a{constructor(){this.b=new Map}static{this.a=1e3}async checkout(r,d){const l=[...this.b.entries()].map(([h,k])=>(0,I.$Ig)(async D=>{if(h.name!==d||k.lastUsedAt!==-1&&await(0,c.$jfc)(await h.processId))return null;const $=Date.now();return k.lastUsedAt+a.a>$||D.isCancellationRequested||k.config!==r?null:(k.lastUsedAt=$,h)}));return await(0,I.$1g)(l,h=>!!h)}insert(r,d){this.b.set(r,{lastUsedAt:Date.now(),config:d})}free(r){const d=this.b.get(r);d&&(d.lastUsedAt=-1)}onTerminalClosed(r){this.b.delete(r)}}}),define(ke[369],Se([1,0,16,2,104,41,70,42,40,46,20,27,95,17,15,91,23,63,58]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,S,w,c,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dfc=void 0;let n=class extends g.$cec{constructor(a,t,r,d,u,l,h,k,D){super(a,t,r,d,u,l,h,k),this.B=r,this.C=D,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(y.Schemas.vscodeRemote,{scheme:y.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(y.Schemas.file,{scheme:y.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(a,t){const r=t;if(!t.execution&&r._id===void 0)throw new Error("Tasks to execute must include an execution");if(r._id!==void 0){const d=g.TaskHandleDTO.from(r,this.B),u=await this.a.$getTaskExecution(d);if(u.task===void 0)throw new Error("Task from execution DTO is undefined");const l=await this.y(u,t);return this.a.$executeTask(d).catch(()=>{}),l}else{const d=g.TaskDTO.from(t,a);if(d===void 0)return Promise.reject(new Error("Task is not valid"));g.CustomExecutionDTO.is(d.execution)&&await this.x(d,t,!1);const u=await this.y(await this.a.$getTaskExecution(d),t);return this.a.$executeTask(d).catch(()=>{}),u}}u(a,t,r,d){const u=[];if(d)for(const l of d){this.z(l,r),(!l.definition||!a[l.definition.type])&&this.f.warn(`The task [${l.source}, ${l.name}] uses an undefined task type. The task will be ignored in the future.`);const h=g.TaskDTO.from(l,r.extension);h&&(u.push(h),g.CustomExecutionDTO.is(h.execution)&&t.push(this.x(h,l,!0)))}return{tasks:u,extension:r.extension}}async v(a){return a}async F(a){let t=a&&a.length>0?a[0]:void 0;if(!t){const r=F.URI.file((0,s.homedir)());t=new E.$bi({uri:r,name:c.$tg(r),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(a,t){const r=F.URI.revive(a),d={process:void 0,variables:Object.create(null)},u=await this.b.resolveWorkspaceFolder(r),l=await this.b.getWorkspaceFolders2()??[],h=await this.C.getResolver(),k=u?{uri:u.uri,name:u.name,index:u.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(l);for(const D of t.variables)d.variables[D]=await h.resolveAsync(k,D);if(t.process!==void 0){let D;if(t.process.path!==void 0){D=t.process.path.split(I.$sc);for(let $=0;$<D.length;$++)D[$]=await h.resolveAsync(k,D[$])}d.process=await f.win32.findExecutable(await h.resolveAsync(k,t.process.name),t.process.cwd!==void 0?await h.resolveAsync(k,t.process.cwd):void 0,D)}return d}async $jsonTasksSupported(){return!0}async $findExecutable(a,t,r){return f.win32.findExecutable(a,t,r)}};e.$dfc=n,e.$dfc=n=He([Be(0,A.$xM),Be(1,P.$NM),Be(2,L.$ddc),Be(3,R.$IM),Be(4,p.$gdc),Be(5,m.$ydc),Be(6,S.$bj),Be(7,w.$6cc),Be(8,i.$hec)],n)}),define(ke[370],Se([1,0,63,58]),function($e,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vfc=void 0;class f extends F.$iec{m(){return(0,I.homedir)()}}e.$Vfc=f}),define(ke[156],Se([1,0,19,10,21,43,17,16,23,2,36]),function($e,e,I,F,f,L,R,p,E,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sec=e.$rec=e.$qec=e.$pec=void 0;class P{constructor(i,n,o,a){this.d=i,this.e=n,this.f=o,this.g=a,this.a=null,this.b=!1,this.c=0}search(i,n){const o=this.d.folderQueries||[],a=new f.$Yd(n);return new Promise((t,r)=>{this.a=new y(i);let d=!1;const u=(l,h)=>{if(!d&&!this.b){const k=this.h(l);w(l)&&typeof this.d.maxResults=="number"&&this.c+k>this.d.maxResults&&(this.b=!0,d=!0,a.cancel(),l=this.j(l,this.d.maxResults-this.c));const D=this.h(l);this.c+=D,(D>0||!w(l))&&this.a.add(l,h)}};Promise.all(o.map((l,h)=>this.k(l,k=>u(k,h),a.token))).then(l=>{a.dispose(),this.a.flush();const h=l.some(k=>!!k&&!!k.limitHit);t({limitHit:this.b||h,messages:(0,I.$Qb)(l.map(k=>k?.message?Array.isArray(k.message)?k.message:[k.message]:[])),stats:{type:this.g}})},l=>{a.dispose();const h=(0,L.$Ei)(l);r(new Error(h))})})}h(i){return w(i)?Array.isArray(i.ranges)?i.ranges.length:1:0}j(i,n){const o=Array.isArray(i.ranges)?i.ranges:[i.ranges],a=Array.isArray(i.preview.matches)?i.preview.matches:[i.preview.matches];return{ranges:o.slice(0,n),preview:{matches:a.slice(0,n),text:i.preview.text},uri:i.uri}}async k(i,n,o){const a=new A.$aJ(this.d,i),t=[],r={report:l=>{if(!this.l(l))return;const h=i.folder.scheme===R.Schemas.file?(0,A.$bJ)(()=>this.f.readdir(E.$vg(l.uri))):void 0,k=E.$yg(i.folder,l.uri);if(k){const D=a.includedInQuery(k,p.$mc(k),h);(0,F.$Hg)(D)?t.push(D.then($=>{$&&n(l)})):D&&n(l)}}},d=this.n(i),u=await this.e.provideTextSearchResults(g(this.d.contentPattern),d,r,o);return t.length&&await Promise.all(t),u}l(i){if(w(i)){if(Array.isArray(i.ranges)){if(!Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(i.preview.matches.length!==i.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(i){const n=(0,A.$_I)(this.d.includePattern,i.includePattern),o=(0,A.$_I)(this.d.excludePattern,i.excludePattern),a={folder:m.URI.from(i.folder),excludes:o,includes:n,useIgnoreFiles:!i.disregardIgnoreFiles,useGlobalIgnoreFiles:!i.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!i.disregardParentIgnoreFiles,followSymlinks:!i.ignoreSymlinks,encoding:i.fileEncoding&&this.f.toCanonicalName(i.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return a.usePCRE2=this.d.usePCRE2,a}}e.$pec=P;function g(s){return{isCaseSensitive:s.isCaseSensitive||!1,isRegExp:s.isRegExp||!1,isWordMatch:s.isWordMatch||!1,isMultiline:s.isMultiline||!1,pattern:s.pattern}}class y{constructor(i){this.e=i,this.b=-1,this.d=null,this.a=new c(512,n=>this.g(n))}add(i,n){this.d&&(this.b!==n||!E.$pg(this.c,i.uri))&&(this.f(),this.d=null),this.d||(this.b=n,this.d={resource:i.uri,results:[]}),this.d.results.push(S(i))}f(){const i=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,i)}flush(){this.f(),this.a.flush()}g(i){this.e(i)}}e.$qec=y;function S(s){return w(s)?{preview:{matches:(0,I.$1b)(s.preview.matches,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character})),text:s.preview.text},ranges:(0,I.$1b)(s.ranges,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character}))}:{text:s.text,lineNumber:s.lineNumber}}function w(s){return!!s.preview}e.$rec=w;class c{static{this.a=4e3}static{this.b=50}constructor(i,n){this.g=i,this.h=n,this.c=0,this.d=[],this.e=0}addItem(i,n){i&&this.j(i,n)}addItems(i,n){i&&this.k(i,n)}j(i,n){this.d.push(i),this.e+=n,this.l()}k(i,n){this.d=this.d.concat(i),this.e+=n,this.l()}l(){this.c<c.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},c.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$sec=c}),define(ke[97],Se([1,0,3,6,5,363,20,67,15,2,156]),function($e,e,I,F,f,L,R,p,E,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vec=e.$uec=e.$tec=void 0,e.$tec=(0,f.$Th)("IExtHostSearch");let P=class{constructor(w,c,s){this.k=w,this.l=c,this.n=s,this.c=this.k.getProxy(F.$vK.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new L.$oec}o(w){return this.l.transformOutgoingScheme(w)}registerTextSearchProvider(w,c){if(this.g.has(w))throw new Error(`a text search provider for the scheme '${w}' is already registered`);this.g.add(w);const s=this.d++;return this.e.set(s,c),this.c.$registerTextSearchProvider(s,this.o(w)),(0,I.$Pc)(()=>{this.g.delete(w),this.e.delete(s),this.c.$unregisterProvider(s)})}registerFileSearchProvider(w,c){if(this.i.has(w))throw new Error(`a file search provider for the scheme '${w}' is already registered`);this.i.add(w);const s=this.d++;return this.h.set(s,c),this.c.$registerFileSearchProvider(s,this.o(w)),(0,I.$Pc)(()=>{this.i.delete(w),this.h.delete(s),this.c.$unregisterProvider(s)})}$provideFileSearchResults(w,c,s,i){const n=g(s),o=this.h.get(w);if(o)return this.j.fileSearch(n,o,a=>{this.c.$handleFileMatch(w,c,a.map(t=>t.resource))},i);throw new Error("unknown provider: "+w)}async doInternalFileSearchWithCustomCallback(w,c,s){return{messages:[]}}$clearCache(w){return this.j.clearCache(w),Promise.resolve(void 0)}$provideTextSearchResults(w,c,s,i){const n=this.e.get(w);if(!n||!n.provideTextSearchResults)throw new Error(`Unknown provider ${w}`);const o=g(s);return this.q(o,n).search(t=>this.c.$handleTextMatch(w,c,t),i)}$enableExtensionHostSearch(){}q(w,c){return new A.$pec(w,c,{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"textSearchProvider")}};e.$uec=P,e.$uec=P=He([Be(0,R.$xM),Be(1,p.$adc),Be(2,E.$bj)],P);function g(S){return{...S,folderQueries:S.folderQueries&&S.folderQueries.map(y),extraFileResources:S.extraFileResources&&S.extraFileResources.map(w=>m.URI.revive(w))}}e.$vec=g;function y(S){return{...S,folder:m.URI.revive(S.folder)}}}),define(ke[371],Se([1,0,21,11,4,39,2,133,80,172,191,31,6,114,315,314,35,316,42,318,319,320,295,321,70,47,323,324,329,330,331,154,299,336,337,340,118,46,342,300,14,7,87,345,93,153,41,26,289,328,66,151,95,96,97,15,67,20,27,362,286,73,91,307,343,92,72,348,346,347,308,57,341,344,117,71,90,332,94,333,17,137,298,274,326,3,25,282,115,268,334,335,309,325,297,327,116,338,312,339,313,306,322,310,311]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,S,w,c,s,i,n,o,a,t,r,d,u,l,h,k,D,$,b,v,C,N,z,M,O,j,T,V,q,fe,ee,Y,X,ae,Z,se,we,H,U,ce,Ee,ne,G,J,ge,x,le,te,de,be,Pe,B,Q,re,oe,_,me,ye,ze,We,_e,Ye,it,tt,Ae,Oe,Ve,Re,Xe,he,ue,Ie,Ke,Ue,Ze,nt,ct,bt,Et,Kt,Ht,wt,zt,Ot,Gt,Ut,Dt,Ft,Bt,Jt,Wt,Vt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8ec=void 0;function Nt(ut){const ft=ut.get(x.$NM),At=ut.get(ze.$3cc),qt=ut.get(re.$vdc),Lt=ut.get(u.$Ldc),at=ut.get(ae.$ddc),vt=ut.get(tt.$RM),Tt=ut.get(i.$gdc),Pt=ut.get(J.$adc),Ge=ut.get(ge.$xM),Qt=ut.get(M.$rdc),Me=ut.get(Q.$wdc),Te=ut.get(G.$cj),Ce=ut.get(G.$bj),ie=ut.get(de.$Iwb),Fe=ut.get(be.$6cc),qe=ut.get(X.$0dc),xe=ut.get(Ye.$Ddc),Je=ut.get(it.$fec),rt=ut.get(Ot.$Hdc);Ge.set(g.$wK.ExtHostFileSystemInfo,At),Ge.set(g.$wK.ExtHostLogLevelServiceShape,Te),Ge.set(g.$wK.ExtHostWorkspace,at),Ge.set(g.$wK.ExtHostConfiguration,Tt),Ge.set(g.$wK.ExtHostExtensionService,Lt),Ge.set(g.$wK.ExtHostStorage,Qt),Ge.set(g.$wK.ExtHostTunnelService,ie),Ge.set(g.$wK.ExtHostWindow,qe),Ge.set(g.$wK.ExtHostSecretState,xe),Ge.set(g.$wK.ExtHostTelemetry,vt),Ge.set(g.$wK.ExtHostEditorTabs,Je),Ge.set(g.$wK.ExtHostManagedSockets,rt);const kt=Ge.set(g.$wK.ExtHostDecorations,ut.get(U.$bec)),St=Ge.set(g.$wK.ExtHostDocumentsAndEditors,ut.get(d.$IM)),mt=Ge.set(g.$wK.ExtHostCommands,ut.get(c.$TM)),dt=Ge.set(g.$wK.ExtHostTerminalService,ut.get(O.$ydc)),gt=Ge.set(g.$wK.ExtHostDebugService,ut.get(Ee.$jec)),ui=Ge.set(g.$wK.ExtHostSearch,ut.get(ne.$tec)),Ct=Ge.set(g.$wK.ExtHostTask,ut.get(ce.$eec)),Di=Ge.set(g.$wK.ExtHostOutputService,ut.get(b.$Tdc)),li=Ge.set(g.$wK.ExtHostLocalization,ut.get(nt.$Gdc)),$i=Ge.set(g.$wK.ExtHostUrls,new ee.$3dc(Ge)),It=Ge.set(g.$wK.ExtHostDocuments,new r.$1cc(Ge,St)),gn=Ge.set(g.$wK.ExtHostDocumentContentProviders,new a.$idc(Ge,St,Ce)),ri=Ge.set(g.$wK.ExtHostDocumentSaveParticipant,new t.$jdc(Ce,It,Ge.getProxy(g.$vK.MainThreadBulkEdits))),yt=Ge.set(g.$wK.ExtHostNotebook,new le.$zec(Ge,mt,St,It,qt,ui)),bi=Ge.set(g.$wK.ExtHostNotebookDocuments,new ue.$Rec(yt)),pi=Ge.set(g.$wK.ExtHostNotebookEditors,new he.$Qec(Ce,yt)),si=Ge.set(g.$wK.ExtHostNotebookKernels,new Ae.$Nec(Ge,ft,yt,mt,Ce)),Ci=Ge.set(g.$wK.ExtHostNotebookRenderers,new Ve.$Pec(Ge,yt)),Ii=Ge.set(g.$wK.ExtHostNotebookDocumentSaveParticipant,new wt.$Xec(Ce,yt,Ge.getProxy(g.$vK.MainThreadBulkEdits))),Rt=Ge.set(g.$wK.ExtHostEditors,new j.$1dc(Ge,St)),wi=Ge.set(g.$wK.ExtHostTreeViews,new T.$2dc(Ge.getProxy(g.$vK.MainThreadTreeViews),mt,Ce)),Pi=Ge.set(g.$wK.ExtHostEditorInsets,new se.$$dc(Ge.getProxy(g.$vK.MainThreadEditorInsets),Rt,ft.remote)),oi=Ge.set(g.$wK.ExtHostDiagnostics,new n.$5cc(Ge,Ce,At,St)),hi=Ge.set(g.$wK.ExtHostLanguages,new D.$Qdc(Ge,It,mt.converter,Pt)),lt=Ge.set(g.$wK.ExtHostLanguageFeatures,new k.$9cc(Ge,Pt,It,mt,oi,Ce,Fe,vt)),Ai=Ge.set(g.$wK.ExtHostFileSystem,new l.$Odc(Ge,lt)),Zt=Ge.set(g.$wK.ExtHostFileSystemEventService,new h.$Pdc(Ge,Ce,St)),ii=Ge.set(g.$wK.ExtHostQuickOpen,(0,C.$Vdc)(Ge,at,mt)),Li=Ge.set(g.$wK.ExtHostSCM,new N.$Xdc(Ge,mt,It,Ce)),Ri=Ge.set(g.$wK.ExtHostQuickDiff,new Et.$Uec(Ge,Pt)),Mi=Ge.set(g.$wK.ExtHostShare,new Gt.$Zec(Ge,Pt)),Yi=Ge.set(g.$wK.ExtHostComments,(0,s.$_cc)(Ge,mt,It)),Fi=Ge.set(g.$wK.ExtHostProgress,new v.$Udc(Ge.getProxy(g.$vK.MainThreadProgress))),Xi=Ge.set(g.$wK.ExtHosLabelService,new we.$_dc(Ge)),Ti=Ge.set(g.$wK.ExtHostTheming,new te.$Aec(Ge)),ai=Ge.set(g.$wK.ExtHostAuthentication,new Pe.$Bec(Ge)),mn=Ge.set(g.$wK.ExtHostTimeline,new B.$Dec(Ge,mt)),Oi=Ge.set(g.$wK.ExtHostWebviews,new Y.$6dc(Ge,ft.remote,at,Ce,Fe)),di=Ge.set(g.$wK.ExtHostWebviewPanels,new me.$Fec(Ge,Oi,at)),Ni=Ge.set(g.$wK.ExtHostCustomEditors,new _.$Gec(Ge,It,Me,Oi,di)),$n=Ge.set(g.$wK.ExtHostWebviewViews,new oe.$Eec(Ge,Oi)),fi=Ge.set(g.$wK.ExtHostTesting,new We.$Iec(Ge,mt,St)),Zi=Ge.set(g.$wK.ExtHostUriOpeners,new _e.$Mec(Ge)),ji=Ge.set(g.$wK.ExtHostProfileContentHandlers,new bt.$Tec(Ge));Ge.set(g.$wK.ExtHostInteractive,new Ie.$Sec(Ge,yt,St,mt,Ce));const xi=Ge.set(g.$wK.ExtHostInlineChat,new Ht.$Wec(Ge,mt,It,Ce)),gi=Ge.set(g.$wK.ExtHostChatProvider,new Ut.$1ec(Ge,Ce)),_i=Ge.set(g.$wK.ExtHostChatAgents,new Wt.$6ec(Ge,gi,Ce)),bn=Ge.set(g.$wK.ExtHostChatAgents2,new Vt.$7ec(Ge,gi,Ce)),zi=Ge.set(g.$wK.ExtHostChatVariables,new Ft.$3ec(Ge)),mi=Ge.set(g.$wK.ExtHostChat,new Kt.$Vec(Ge,Ce)),xt=Ge.set(g.$wK.ExtHostAiRelatedInformation,new Bt.$4ec(Ge)),vi=Ge.set(g.$wK.ExtHostAiEmbeddingVector,new Jt.$5ec(Ge)),en=Ge.set(g.$wK.ExtHostIssueReporter,new zt.$Yec(Ge)),Yt=Ge.set(g.$wK.ExtHostStatusBar,new z.$Zdc(Ge,mt.converter)),yi=Ge.set(g.$wK.ExtHostSpeech,new Dt.$2ec(Ge)),tn=Object.values(g.$wK);Ge.assertRegistered(tn);const nn=new ye.$Hec(Ge,St),rn=new w.$$cc(Ge),Ei=new $.$Rdc(Ge,Ce),sn=new o.$hdc(Ge);return S.$0cc.register(mt),function(je,_t,on){const $t=function(){let pe=!je.isUnderDevelopment;function De(){pe||(Ce.info(`Extension '${je.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),pe=!0)}return function Ne(st){if(Array.isArray(st))st.forEach(Ne);else if(typeof st=="string")De();else{const pt=st;typeof pt.scheme>"u"&&De(),typeof pt.exclusive=="boolean"&&(0,Ue.$vF)(je,"documentFiltersExclusive")}return st}}(),Ui={getSession(pe,De,Ne){return ai.getSession(je,pe,De,Ne)},getSessions(pe,De){return(0,Ue.$vF)(je,"authGetSessions"),ai.getSessions(je,pe,De)},async hasSession(pe,De){return(0,Ue.$vF)(je,"authSession"),!!await ai.getSession(je,pe,De,{silent:!0})},get onDidChangeSessions(){return ai.onDidChangeSessions},registerAuthenticationProvider(pe,De,Ne,st){return ai.registerAuthenticationProvider(pe,De,Ne,st)}},an={registerCommand(pe,De,Ne){return mt.registerCommand(!0,pe,De,Ne,void 0,je)},registerTextEditorCommand(pe,De,Ne){return mt.registerCommand(!0,pe,(...st)=>{const pt=Rt.getActiveTextEditor();if(!pt){Ce.warn("Cannot execute "+pe+" because there is no active text editor.");return}return pt.edit(Mt=>{De.apply(Ne,[pt,Mt,...st])}).then(Mt=>{Mt||Ce.warn("Edits from command "+pe+" were not applied.")},Mt=>{Ce.warn("An error occurred while running command "+pe,Mt)})},void 0,void 0,je)},registerDiffInformationCommand:(pe,De,Ne)=>((0,Ue.$vF)(je,"diffCommand"),mt.registerCommand(!0,pe,async(...st)=>{const pt=St.activeEditor(!0);if(!pt){Ce.warn("Cannot execute "+pe+" because there is no active text editor.");return}const Mt=await Rt.getDiffInformation(pt.id);De.apply(Ne,[Mt,...st])},void 0,void 0,je)),executeCommand(pe,...De){return mt.executeCommand(pe,...De)},getCommands(pe=!1){return mt.getCommands(pe)}},Bi={get machineId(){return ft.telemetryInfo.machineId},get sessionId(){return ft.telemetryInfo.sessionId},get language(){return ft.environment.appLanguage},get appName(){return ft.environment.appName},get appRoot(){return ft.environment.appRoot?.fsPath??""},get appHost(){return ft.environment.appHost},get uriScheme(){return ft.environment.appUriScheme},get clipboard(){return rn.value},get shell(){return dt.getDefaultShell(!1)},get onDidChangeShell(){return dt.onDidChangeShell},get isTelemetryEnabled(){return vt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return vt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ue.$vF)(je,"telemetry"),vt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ue.$vF)(je,"telemetry"),vt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,tt.$QM)(ft.telemetryInfo.firstSessionDate)},createTelemetryLogger(pe,De){return tt.$PM.validateSender(pe),vt.instantiateLogger(je,pe,De)},openExternal(pe,De){return qe.openUri(pe,{allowTunneling:!!ft.remote.authority,allowContributedOpeners:De?.allowContributedOpeners})},async asExternalUri(pe){if(pe.scheme===ft.environment.appUriScheme)return $i.createAppUri(pe);try{return await qe.asExternalUri(pe,{allowTunneling:!!ft.remote.authority})}catch(De){if((0,Xe.$GU)(pe,Re.Schemas.http)||(0,Xe.$GU)(pe,Re.Schemas.https))return pe;throw De}},get remoteName(){return(0,H.$Zk)(ft.remote.authority)},get remoteAuthority(){return(0,Ue.$vF)(je,"resolvers"),ft.remote.authority},get uiKind(){return ft.uiKind},get logLevel(){return Ce.getLevel()},get onDidChangeLogLevel(){return Ce.onDidChangeLogLevel},registerIssueUriRequestHandler(pe){return(0,Ue.$vF)(je,"handleIssueUri"),en.registerIssueUriRequestHandler(je,pe)},registerIssueDataProvider(pe){return(0,Ue.$vF)(je,"handleIssueUri"),en.registerIssueDataProvider(je,pe)},get appQuality(){return(0,Ue.$vF)(je,"resolvers"),ft.quality},get appCommit(){return(0,Ue.$vF)(je,"resolvers"),ft.commit}};ft.environment.extensionTestsLocationURI||Object.freeze(Bi);const cn={createTestController(pe,De,Ne){return fi.createTestController(je,pe,De,Ne)},createTestObserver(){return(0,Ue.$vF)(je,"testObserver"),fi.createTestObserver()},runTests(pe){return(0,Ue.$vF)(je,"testObserver"),fi.runTests(pe)},get onDidChangeTestResults(){return(0,Ue.$vF)(je,"testObserver"),fi.onResultsChanged},get testResults(){return(0,Ue.$vF)(je,"testObserver"),fi.results}},ki=ft.remote.isRemote?q.ExtensionKind.Workspace:q.ExtensionKind.UI,pn={getExtension(pe,De){(0,Ue.$uF)(je,"extensionsAny")||(De=!1);const Ne=_t.mine.getExtensionDescription(pe);if(Ne)return new u.$Mdc(Lt,je.identifier,Ne,ki,!1);if(De){const st=_t.all.getExtensionDescription(pe);if(st)return new u.$Mdc(Lt,je.identifier,st,ki,!0)}},get all(){const pe=[];for(const De of _t.mine.getAllExtensionDescriptions())pe.push(new u.$Mdc(Lt,je.identifier,De,ki,!1));return pe},get allAcrossExtensionHosts(){(0,Ue.$vF)(je,"extensionsAny");const pe=new Z.$$l(_t.mine.getAllExtensionDescriptions().map(Ne=>Ne.identifier)),De=[];for(const Ne of _t.all.getAllExtensionDescriptions()){const st=!pe.has(Ne.identifier);De.push(new u.$Mdc(Lt,je.identifier,Ne,ki,st))}return De},get onDidChange(){return(0,Ue.$uF)(je,"extensionsAny")?f.Event.any(_t.mine.onDidChange,_t.all.onDidChange):_t.mine.onDidChange}},un={createDiagnosticCollection(pe){return oi.createDiagnosticCollection(je.identifier,pe)},get onDidChangeDiagnostics(){return oi.onDidChangeDiagnostics},getDiagnostics:pe=>oi.getDiagnostics(pe),getLanguages(){return hi.getLanguages()},setTextDocumentLanguage(pe,De){return hi.changeLanguage(pe.uri,De)},match(pe,De){const Ne=It.getDocumentData(De.uri)?.notebook;return(0,A.$HE)(V.LanguageSelector.from(pe),De.uri,De.languageId,!0,Ne?.uri,Ne?.notebookType)},registerCodeActionsProvider(pe,De,Ne){return lt.registerCodeActionProvider(je,$t(pe),De,Ne)},registerDocumentPasteEditProvider(pe,De,Ne){return(0,Ue.$vF)(je,"documentPaste"),lt.registerDocumentPasteEditProvider(je,$t(pe),De,Ne)},registerCodeLensProvider(pe,De){return lt.registerCodeLensProvider(je,$t(pe),De)},registerDefinitionProvider(pe,De){return lt.registerDefinitionProvider(je,$t(pe),De)},registerDeclarationProvider(pe,De){return lt.registerDeclarationProvider(je,$t(pe),De)},registerImplementationProvider(pe,De){return lt.registerImplementationProvider(je,$t(pe),De)},registerTypeDefinitionProvider(pe,De){return lt.registerTypeDefinitionProvider(je,$t(pe),De)},registerHoverProvider(pe,De){return lt.registerHoverProvider(je,$t(pe),De,je.identifier)},registerEvaluatableExpressionProvider(pe,De){return lt.registerEvaluatableExpressionProvider(je,$t(pe),De,je.identifier)},registerInlineValuesProvider(pe,De){return lt.registerInlineValuesProvider(je,$t(pe),De,je.identifier)},registerDocumentHighlightProvider(pe,De){return lt.registerDocumentHighlightProvider(je,$t(pe),De)},registerLinkedEditingRangeProvider(pe,De){return lt.registerLinkedEditingRangeProvider(je,$t(pe),De)},registerReferenceProvider(pe,De){return lt.registerReferenceProvider(je,$t(pe),De)},registerRenameProvider(pe,De){return lt.registerRenameProvider(je,$t(pe),De)},registerDocumentSymbolProvider(pe,De,Ne){return lt.registerDocumentSymbolProvider(je,$t(pe),De,Ne)},registerWorkspaceSymbolProvider(pe){return lt.registerWorkspaceSymbolProvider(je,pe)},registerDocumentFormattingEditProvider(pe,De){return lt.registerDocumentFormattingEditProvider(je,$t(pe),De)},registerDocumentRangeFormattingEditProvider(pe,De){return lt.registerDocumentRangeFormattingEditProvider(je,$t(pe),De)},registerOnTypeFormattingEditProvider(pe,De,Ne,...st){return lt.registerOnTypeFormattingEditProvider(je,$t(pe),De,[Ne].concat(st))},registerDocumentSemanticTokensProvider(pe,De,Ne){return lt.registerDocumentSemanticTokensProvider(je,$t(pe),De,Ne)},registerDocumentRangeSemanticTokensProvider(pe,De,Ne){return lt.registerDocumentRangeSemanticTokensProvider(je,$t(pe),De,Ne)},registerSignatureHelpProvider(pe,De,Ne,...st){return typeof Ne=="object"?lt.registerSignatureHelpProvider(je,$t(pe),De,Ne):lt.registerSignatureHelpProvider(je,$t(pe),De,typeof Ne>"u"?[]:[Ne,...st])},registerCompletionItemProvider(pe,De,...Ne){return lt.registerCompletionItemProvider(je,$t(pe),De,Ne)},registerInlineCompletionItemProvider(pe,De,Ne){return De.handleDidShowCompletionItem&&(0,Ue.$vF)(je,"inlineCompletionsAdditions"),De.handleDidPartiallyAcceptCompletionItem&&(0,Ue.$vF)(je,"inlineCompletionsAdditions"),Ne&&(0,Ue.$vF)(je,"inlineCompletionsAdditions"),lt.registerInlineCompletionsProvider(je,$t(pe),De,Ne)},registerDocumentLinkProvider(pe,De){return lt.registerDocumentLinkProvider(je,$t(pe),De)},registerColorProvider(pe,De){return lt.registerColorProvider(je,$t(pe),De)},registerFoldingRangeProvider(pe,De){return lt.registerFoldingRangeProvider(je,$t(pe),De)},registerSelectionRangeProvider(pe,De){return lt.registerSelectionRangeProvider(je,pe,De)},registerCallHierarchyProvider(pe,De){return lt.registerCallHierarchyProvider(je,pe,De)},registerTypeHierarchyProvider(pe,De){return lt.registerTypeHierarchyProvider(je,pe,De)},setLanguageConfiguration:(pe,De)=>lt.setLanguageConfiguration(je,pe,De),getTokenInformationAtPosition(pe,De){return(0,Ue.$vF)(je,"tokenInformation"),hi.tokenAtPosition(pe,De)},registerInlayHintsProvider(pe,De){return lt.registerInlayHintsProvider(je,pe,De)},createLanguageStatusItem(pe,De){return hi.createLanguageStatusItem(je,pe,De)},registerDocumentDropEditProvider(pe,De,Ne){return lt.registerDocumentOnDropEditProvider(je,pe,De,(0,Ue.$uF)(je,"dropMetadata")?Ne:void 0)}},ln={get activeTextEditor(){return Rt.getActiveTextEditor()},get visibleTextEditors(){return Rt.getVisibleTextEditors()},get activeTerminal(){return dt.activeTerminal},get terminals(){return dt.terminals},async showTextDocument(pe,De,Ne){const st=await(R.URI.isUri(pe)?Promise.resolve(Si.openTextDocument(pe)):Promise.resolve(pe));return Rt.showTextDocument(st,De,Ne)},createTextEditorDecorationType(pe){return Rt.createTextEditorDecorationType(je,pe)},onDidChangeActiveTextEditor(pe,De,Ne){return Rt.onDidChangeActiveTextEditor(pe,De,Ne)},onDidChangeVisibleTextEditors(pe,De,Ne){return Rt.onDidChangeVisibleTextEditors(pe,De,Ne)},onDidChangeTextEditorSelection(pe,De,Ne){return Rt.onDidChangeTextEditorSelection(pe,De,Ne)},onDidChangeTextEditorOptions(pe,De,Ne){return Rt.onDidChangeTextEditorOptions(pe,De,Ne)},onDidChangeTextEditorVisibleRanges(pe,De,Ne){return Rt.onDidChangeTextEditorVisibleRanges(pe,De,Ne)},onDidChangeTextEditorViewColumn(pe,De,Ne){return Rt.onDidChangeTextEditorViewColumn(pe,De,Ne)},onDidCloseTerminal(pe,De,Ne){return dt.onDidCloseTerminal(pe,De,Ne)},onDidOpenTerminal(pe,De,Ne){return dt.onDidOpenTerminal(pe,De,Ne)},onDidChangeActiveTerminal(pe,De,Ne){return dt.onDidChangeActiveTerminal(pe,De,Ne)},onDidChangeTerminalDimensions(pe,De,Ne){return(0,Ue.$vF)(je,"terminalDimensions"),dt.onDidChangeTerminalDimensions(pe,De,Ne)},onDidChangeTerminalState(pe,De,Ne){return dt.onDidChangeTerminalState(pe,De,Ne)},onDidWriteTerminalData(pe,De,Ne){return(0,Ue.$vF)(je,"terminalDataWriteEvent"),dt.onDidWriteTerminalData(pe,De,Ne)},onDidExecuteTerminalCommand(pe,De,Ne){return(0,Ue.$vF)(je,"terminalExecuteCommandEvent"),dt.onDidExecuteTerminalCommand(pe,De,Ne)},get state(){return qe.getState(je)},onDidChangeWindowState(pe,De,Ne){return qe.onDidChangeWindowState(pe,De,Ne)},showInformationMessage(pe,...De){return Ei.showMessage(je,L.default.Info,pe,De[0],De.slice(1))},showWarningMessage(pe,...De){return Ei.showMessage(je,L.default.Warning,pe,De[0],De.slice(1))},showErrorMessage(pe,...De){return Ei.showMessage(je,L.default.Error,pe,De[0],De.slice(1))},showQuickPick(pe,De,Ne){return ii.showQuickPick(je,pe,De,Ne)},showWorkspaceFolderPick(pe){return ii.showWorkspaceFolderPick(pe)},showInputBox(pe,De){return ii.showInput(pe,De)},showOpenDialog(pe){return sn.showOpenDialog(je,pe)},showSaveDialog(pe){return sn.showSaveDialog(pe)},createStatusBarItem(pe,De,Ne){let st,pt,Mt;return typeof pe=="string"?(st=pe,pt=De,Mt=Ne):(pt=pe,Mt=De),Yt.createStatusBarEntry(je,st,pt,Mt)},setStatusBarMessage(pe,De){return Yt.setStatusBarMessage(pe,De)},withScmProgress(pe){return Fe.report("window.withScmProgress",je,"Use 'withProgress' instead."),Fi.withProgress(je,{location:q.ProgressLocation.SourceControl},(De,Ne)=>pe({report(st){}}))},withProgress(pe,De){return Fi.withProgress(je,pe,De)},createOutputChannel(pe,De){return Di.createOutputChannel(pe,De,je)},createWebviewPanel(pe,De,Ne,st){return di.createWebviewPanel(je,pe,De,Ne,st)},createWebviewTextEditorInset(pe,De,Ne,st){return(0,Ue.$vF)(je,"editorInsets"),Pi.createWebviewEditorInset(pe,De,Ne,st,je)},createTerminal(pe,De,Ne){return typeof pe=="object"?"pty"in pe?dt.createExtensionTerminal(pe):dt.createTerminalFromOptions(pe):dt.createTerminal(pe,De,Ne)},registerTerminalLinkProvider(pe){return dt.registerLinkProvider(pe)},registerTerminalProfileProvider(pe,De){return dt.registerProfileProvider(je,pe,De)},registerTerminalQuickFixProvider(pe,De){return(0,Ue.$vF)(je,"terminalQuickFixProvider"),dt.registerTerminalQuickFixProvider(pe,je.identifier.value,De)},registerTreeDataProvider(pe,De){return wi.registerTreeDataProvider(pe,De,je)},createTreeView(pe,De){return wi.createTreeView(pe,De,je)},registerWebviewPanelSerializer:(pe,De)=>di.registerWebviewPanelSerializer(je,pe,De),registerCustomEditorProvider:(pe,De,Ne={})=>Ni.registerCustomEditorProvider(je,pe,De,Ne),registerFileDecorationProvider(pe){return kt.registerFileDecorationProvider(pe,je)},registerUriHandler(pe){return $i.registerUriHandler(je,pe)},createQuickPick(){return ii.createQuickPick(je)},createInputBox(){return ii.createInputBox(je)},get activeColorTheme(){return Ti.activeColorTheme},onDidChangeActiveColorTheme(pe,De,Ne){return Ti.onDidChangeActiveColorTheme(pe,De,Ne)},registerWebviewViewProvider(pe,De,Ne){return $n.registerWebviewViewProvider(je,pe,De,Ne?.webviewOptions)},get activeNotebookEditor(){return yt.activeNotebookEditor},onDidChangeActiveNotebookEditor(pe,De,Ne){return yt.onDidChangeActiveNotebookEditor(pe,De,Ne)},get visibleNotebookEditors(){return yt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return yt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(pe,De,Ne){return pi.onDidChangeNotebookEditorSelection(pe,De,Ne)},onDidChangeNotebookEditorVisibleRanges(pe,De,Ne){return pi.onDidChangeNotebookEditorVisibleRanges(pe,De,Ne)},showNotebookDocument(pe,De){return yt.showNotebookDocument(pe,De)},registerExternalUriOpener(pe,De,Ne){return(0,Ue.$vF)(je,"externalUriOpener"),Zi.registerExternalUriOpener(je.identifier,pe,De,Ne)},registerProfileContentHandler(pe,De){return(0,Ue.$vF)(je,"profileContentHandlers"),ji.registrProfileContentHandler(je,pe,De)},registerQuickDiffProvider(pe,De,Ne,st){return(0,Ue.$vF)(je,"quickDiffProvider"),Ri.registerQuickDiffProvider($t(pe),De,Ne,st)},get tabGroups(){return Je.tabGroups},registerShareProvider(pe,De){return(0,Ue.$vF)(je,"shareProvider"),Mi.registerShareProvider($t(pe),De)}},Si={get rootPath(){return Fe.report("workspace.rootPath",je,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),at.getPath()},set rootPath(pe){throw new F.$8("rootPath")},getWorkspaceFolder(pe){return at.getWorkspaceFolder(pe)},get workspaceFolders(){return at.getWorkspaceFolders()},get name(){return at.name},set name(pe){throw new F.$8("name")},get workspaceFile(){return at.workspaceFile},set workspaceFile(pe){throw new F.$8("workspaceFile")},updateWorkspaceFolders:(pe,De,...Ne)=>at.updateWorkspaceFolders(je,pe,De||0,...Ne),onDidChangeWorkspaceFolders:function(pe,De,Ne){return at.onDidChangeWorkspace(pe,De,Ne)},asRelativePath:(pe,De)=>at.getRelativePath(pe,De),findFiles:(pe,De,Ne,st)=>at.findFiles(pe,De,Ne,je.identifier,st),findTextInFiles:(pe,De,Ne,st)=>{(0,Ue.$vF)(je,"findTextInFiles");let pt,Mt;return typeof De=="object"?(pt=De,Mt=Ne):(pt={},Mt=De,st=Ne),at.findTextInFiles(pe,pt||{},Mt,je.identifier,st)},save:pe=>((0,Ue.$vF)(je,"saveEditor"),at.save(pe)),saveAs:pe=>((0,Ue.$vF)(je,"saveEditor"),at.saveAs(pe)),saveAll:pe=>at.saveAll(pe),applyEdit(pe,De){return nn.applyWorkspaceEdit(pe,je,De)},createFileSystemWatcher:(pe,De,Ne,st)=>{let pt;return typeof De=="boolean"?pt={ignoreCreateEvents:!!De,ignoreChangeEvents:!!Ne,ignoreDeleteEvents:!!st,correlate:!1}:De&&((0,Ue.$vF)(je,"createFileSystemWatcher"),pt={...De,correlate:!0}),Zt.createFileSystemWatcher(at,je,pe,pt)},get textDocuments(){return It.getAllDocumentData().map(pe=>pe.document)},set textDocuments(pe){throw new F.$8("textDocuments")},openTextDocument(pe){let De;const Ne=pe;if(typeof pe=="string")De=Promise.resolve(R.URI.file(pe));else if(R.URI.isUri(pe))De=Promise.resolve(pe);else if(!Ne||typeof Ne=="object")De=It.createDocumentData(Ne);else throw new Error("illegal argument - uriOrFileNameOrOptions");return De.then(st=>It.ensureDocumentData(st).then(pt=>pt.document))},onDidOpenTextDocument:(pe,De,Ne)=>It.onDidAddDocument(pe,De,Ne),onDidCloseTextDocument:(pe,De,Ne)=>It.onDidRemoveDocument(pe,De,Ne),onDidChangeTextDocument:(pe,De,Ne)=>It.onDidChangeDocument(pe,De,Ne),onDidSaveTextDocument:(pe,De,Ne)=>It.onDidSaveDocument(pe,De,Ne),onWillSaveTextDocument:(pe,De,Ne)=>ri.getOnWillSaveTextDocumentEvent(je)(pe,De,Ne),get notebookDocuments(){return yt.notebookDocuments.map(pe=>pe.apiNotebook)},async openNotebookDocument(pe,De){let Ne;if(R.URI.isUri(pe))Ne=pe,await yt.openNotebookDocument(pe);else if(typeof pe=="string")Ne=R.URI.revive(await yt.createNotebookDocument({viewType:pe,content:De}));else throw new Error("Invalid arguments");return yt.getNotebookDocument(Ne).apiNotebook},onDidSaveNotebookDocument(pe,De,Ne){return bi.onDidSaveNotebookDocument(pe,De,Ne)},onDidChangeNotebookDocument(pe,De,Ne){return bi.onDidChangeNotebookDocument(pe,De,Ne)},onWillSaveNotebookDocument(pe,De,Ne){return Ii.getOnWillSaveNotebookDocumentEvent(je)(pe,De,Ne)},get onDidOpenNotebookDocument(){return yt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return yt.onDidCloseNotebookDocument},registerNotebookSerializer(pe,De,Ne,st){return yt.registerNotebookSerializer(je,pe,De,Ne,(0,Ue.$uF)(je,"notebookLiveShare")?st:void 0)},onDidChangeConfiguration:(pe,De,Ne)=>on.onDidChangeConfiguration(pe,De,Ne),getConfiguration(pe,De){return De=arguments.length===1?void 0:De,on.getConfiguration(pe,De,je)},registerTextDocumentContentProvider(pe,De){return gn.registerTextDocumentContentProvider(pe,De)},registerTaskProvider:(pe,De)=>(Fe.report("window.registerTaskProvider",je,"Use the corresponding function on the 'tasks' namespace instead"),Ct.registerTaskProvider(je,pe,De)),registerFileSystemProvider(pe,De,Ne){return(0,Ke.$Oc)(Ai.registerFileSystemProvider(je,pe,De,Ne),qt.addFileSystemProvider(pe,De,Ne))},get fs(){return qt.value},registerFileSearchProvider:(pe,De)=>((0,Ue.$vF)(je,"fileSearchProvider"),ui.registerFileSearchProvider(pe,De)),registerTextSearchProvider:(pe,De)=>((0,Ue.$vF)(je,"textSearchProvider"),ui.registerTextSearchProvider(pe,De)),registerRemoteAuthorityResolver:(pe,De)=>((0,Ue.$vF)(je,"resolvers"),Lt.registerRemoteAuthorityResolver(pe,De)),registerResourceLabelFormatter:pe=>((0,Ue.$vF)(je,"resolvers"),Xi.$registerResourceLabelFormatter(pe)),getRemoteExecServer:pe=>((0,Ue.$vF)(je,"resolvers"),Lt.getRemoteExecServer(pe)),onDidCreateFiles:(pe,De,Ne)=>Zt.onDidCreateFile(pe,De,Ne),onDidDeleteFiles:(pe,De,Ne)=>Zt.onDidDeleteFile(pe,De,Ne),onDidRenameFiles:(pe,De,Ne)=>Zt.onDidRenameFile(pe,De,Ne),onWillCreateFiles:(pe,De,Ne)=>Zt.getOnWillCreateFileEvent(je)(pe,De,Ne),onWillDeleteFiles:(pe,De,Ne)=>Zt.getOnWillDeleteFileEvent(je)(pe,De,Ne),onWillRenameFiles:(pe,De,Ne)=>Zt.getOnWillRenameFileEvent(je)(pe,De,Ne),openTunnel:pe=>((0,Ue.$vF)(je,"tunnels"),ie.openTunnel(je,pe).then(De=>{if(!De)throw new Error("cannot open tunnel");return De})),get tunnels(){return(0,Ue.$vF)(je,"tunnels"),ie.getTunnels()},onDidChangeTunnels:(pe,De,Ne)=>((0,Ue.$vF)(je,"tunnels"),ie.onDidChangeTunnels(pe,De,Ne)),registerPortAttributesProvider:(pe,De)=>((0,Ue.$vF)(je,"portsAttributes"),ie.registerPortsAttributesProvider(pe,De)),registerTunnelProvider:(pe,De)=>((0,Ue.$vF)(je,"tunnelFactory"),ie.registerTunnelProvider(pe,De)),registerTimelineProvider:(pe,De)=>((0,Ue.$vF)(je,"timeline"),mn.registerTimelineProvider(pe,De,je.identifier,mt.converter)),get isTrusted(){return at.trusted},requestWorkspaceTrust:pe=>((0,Ue.$vF)(je,"workspaceTrust"),at.requestWorkspaceTrust(pe)),onDidGrantWorkspaceTrust:(pe,De,Ne)=>at.onDidGrantWorkspaceTrust(pe,De,Ne),registerEditSessionIdentityProvider:(pe,De)=>((0,Ue.$vF)(je,"editSessionIdentityProvider"),at.registerEditSessionIdentityProvider(pe,De)),onWillCreateEditSessionIdentity:(pe,De,Ne)=>((0,Ue.$vF)(je,"editSessionIdentityProvider"),at.getOnWillCreateEditSessionIdentityEvent(je)(pe,De,Ne)),registerCanonicalUriProvider:(pe,De)=>((0,Ue.$vF)(je,"canonicalUriProvider"),at.registerCanonicalUriProvider(pe,De)),getCanonicalUri:(pe,De,Ne)=>((0,Ue.$vF)(je,"canonicalUriProvider"),at.provideCanonicalUri(pe,De,Ne))},Wi={get inputBox(){return Fe.report("scm.inputBox",je,"Use 'SourceControl.inputBox' instead"),Li.getLastInputBox(je)},createSourceControl(pe,De,Ne){return Li.createSourceControl(je,pe,De,Ne)}},Vi={createCommentController(pe,De){return Yi.createCommentController(je,pe,De)}},ci={get activeDebugSession(){return gt.activeDebugSession},get activeDebugConsole(){return gt.activeDebugConsole},get breakpoints(){return gt.breakpoints},get stackFrameFocus(){return gt.stackFrameFocus},onDidStartDebugSession(pe,De,Ne){return gt.onDidStartDebugSession(pe,De,Ne)},onDidTerminateDebugSession(pe,De,Ne){return gt.onDidTerminateDebugSession(pe,De,Ne)},onDidChangeActiveDebugSession(pe,De,Ne){return gt.onDidChangeActiveDebugSession(pe,De,Ne)},onDidReceiveDebugSessionCustomEvent(pe,De,Ne){return gt.onDidReceiveDebugSessionCustomEvent(pe,De,Ne)},onDidChangeBreakpoints(pe,De,Ne){return gt.onDidChangeBreakpoints(pe,De,Ne)},onDidChangeStackFrameFocus(pe,De,Ne){return(0,Ue.$vF)(je,"debugFocus"),gt.onDidChangeStackFrameFocus(pe,De,Ne)},registerDebugConfigurationProvider(pe,De,Ne){return gt.registerDebugConfigurationProvider(pe,De,Ne||Ze.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(pe,De){return gt.registerDebugAdapterDescriptorFactory(je,pe,De)},registerDebugAdapterTrackerFactory(pe,De){return gt.registerDebugAdapterTrackerFactory(pe,De)},startDebugging(pe,De,Ne){return!Ne||typeof Ne=="object"&&"configuration"in Ne?gt.startDebugging(pe,De,{parentSession:Ne}):gt.startDebugging(pe,De,Ne||{})},stopDebugging(pe){return gt.stopDebugging(pe)},addBreakpoints(pe){return gt.addBreakpoints(pe)},removeBreakpoints(pe){return gt.removeBreakpoints(pe)},asDebugSourceUri(pe,De){return gt.asDebugSourceUri(pe,De)}},qi={registerTaskProvider:(pe,De)=>Ct.registerTaskProvider(je,pe,De),fetchTasks:pe=>Ct.fetchTasks(pe),executeTask:pe=>Ct.executeTask(je,pe),get taskExecutions(){return Ct.taskExecutions},onDidStartTask:(pe,De,Ne)=>Ct.onDidStartTask(pe,De,Ne),onDidEndTask:(pe,De,Ne)=>Ct.onDidEndTask(pe,De,Ne),onDidStartTaskProcess:(pe,De,Ne)=>Ct.onDidStartTaskProcess(pe,De,Ne),onDidEndTaskProcess:(pe,De,Ne)=>Ct.onDidEndTaskProcess(pe,De,Ne)},Ki={createNotebookController(pe,De,Ne,st,pt){return si.createNotebookController(je,pe,De,Ne,st,(0,Ue.$uF)(je,"notebookMessaging")?pt:void 0)},registerNotebookCellStatusBarItemProvider:(pe,De)=>yt.registerNotebookCellStatusBarItemProvider(je,pe,De),createRendererMessaging(pe){return Ci.createRendererMessaging(je,pe)},createNotebookControllerDetectionTask(pe){return(0,Ue.$vF)(je,"notebookKernelSource"),si.createNotebookControllerDetectionTask(je,pe)},registerKernelSourceActionProvider(pe,De){return(0,Ue.$vF)(je,"notebookKernelSource"),si.registerKernelSourceActionProvider(je,pe,De)},onDidChangeNotebookCellExecutionState(pe,De,Ne){return(0,Ue.$vF)(je,"notebookCellExecutionState"),si.onDidChangeNotebookCellExecutionState(pe,De,Ne)}},Hi={t(...pe){if(typeof pe[0]=="string"){const De=pe.shift(),Ne=!pe||typeof pe[0]!="object"?pe:pe[0];return li.getMessage(je.identifier.value,{message:De,args:Ne})}return li.getMessage(je.identifier.value,pe[0])},get bundle(){return li.getBundle(je.identifier.value)},get uri(){return li.getBundleUri(je.identifier.value)}},Gi={_version:1,registerInteractiveEditorSessionProvider(pe,De){return(0,Ue.$vF)(je,"interactive"),xi.registerProvider(je,pe,De={label:De?.label??je.displayName??je.name})},registerInteractiveSessionProvider(pe,De){return(0,Ue.$vF)(je,"interactive"),mi.registerChatProvider(je,pe,De)},sendInteractiveRequestToProvider(pe,De){return(0,Ue.$vF)(je,"interactive"),mi.sendInteractiveRequestToProvider(pe,De)},get onDidPerformUserAction(){return(0,Ue.$vF)(je,"interactiveUserActions"),mi.onDidPerformUserAction},transferChatSession(pe,De){return(0,Ue.$vF)(je,"interactive"),mi.transferChatSession(pe,De)}},hn={getRelatedInformation(pe,De){return(0,Ue.$vF)(je,"aiRelatedInformation"),xt.getRelatedInformation(je,pe,De)},registerRelatedInformationProvider(pe,De){return(0,Ue.$vF)(je,"aiRelatedInformation"),xt.registerRelatedInformationProvider(je,pe,De)},registerEmbeddingVectorProvider(pe,De){return(0,Ue.$vF)(je,"aiRelatedInformation"),vi.registerEmbeddingVectorProvider(je,pe,De)}},dn={registerChatResponseProvider(pe,De,Ne){return(0,Ue.$vF)(je,"chatProvider"),gi.registerProvider(je.identifier,pe,De,Ne)},requestChatAccess(pe){return(0,Ue.$vF)(je,"chatRequestAccess"),gi.requestChatResponseProvider(je.identifier,pe)},registerVariable(pe,De,Ne){return(0,Ue.$vF)(je,"chatVariables"),zi.registerVariableResolver(je,pe,De,Ne)},registerMappedEditsProvider(pe,De){return(0,Ue.$vF)(je,"mappedEditsProvider"),lt.registerMappedEditsProvider(je,pe,De)},createChatAgent(pe,De){return(0,Ue.$vF)(je,"chatAgents2"),bn.createChatAgent(je,pe,De)},registerAgent(pe,De,Ne){return(0,Ue.$vF)(je,"chatAgents"),_i.registerAgent(je.identifier,pe,De,Ne)}},fn={registerSpeechProvider(pe,De){return(0,Ue.$vF)(je,"speech"),yi.registerProvider(je.identifier,pe,De)}};return{version:ft.version,ai:hn,authentication:Ui,commands:an,comments:Vi,chat:dn,debug:ci,env:Bi,extensions:pn,interactive:Gi,l10n:Hi,languages:un,notebooks:Ki,scm:Wi,speech:fn,tasks:qi,tests:cn,window:ln,workspace:Si,Breakpoint:q.$vL,TerminalOutputAnchor:q.TerminalOutputAnchor,ChatAgentResultFeedbackKind:q.ChatAgentResultFeedbackKind,ChatMessage:q.$mM,ChatMessageRole:q.ChatMessageRole,ChatVariableLevel:q.ChatVariableLevel,CallHierarchyIncomingCall:q.$UK,CallHierarchyItem:q.$TK,CallHierarchyOutgoingCall:q.$VK,CancellationError:F.$4,CancellationTokenSource:I.$Yd,CandidatePortSource:g.CandidatePortSource,CodeAction:q.$QK,CodeActionKind:q.$RK,CodeActionTriggerKind:q.CodeActionTriggerKind,CodeLens:q.$WK,Color:q.$0K,ColorInformation:q.$$K,ColorPresentation:q.$_K,ColorThemeKind:q.ColorThemeKind,CommentMode:q.CommentMode,CommentState:q.CommentState,CommentThreadCollapsibleState:q.CommentThreadCollapsibleState,CommentThreadState:q.CommentThreadState,CompletionItem:q.$4K,CompletionItemKind:q.CompletionItemKind,CompletionItemTag:q.CompletionItemTag,CompletionList:q.$5K,CompletionTriggerKind:q.CompletionTriggerKind,ConfigurationTarget:q.ConfigurationTarget,CustomExecution:q.$hL,DebugAdapterExecutable:q.$zL,DebugAdapterInlineImplementation:q.$CL,DebugAdapterNamedPipeServer:q.$BL,DebugAdapterServer:q.$AL,DebugConfigurationProviderTriggerKind:Ze.DebugConfigurationProviderTriggerKind,DebugConsoleMode:q.DebugConsoleMode,DecorationRangeBehavior:q.DecorationRangeBehavior,Diagnostic:q.$LK,DiagnosticRelatedInformation:q.$KK,DiagnosticSeverity:q.DiagnosticSeverity,DiagnosticTag:q.DiagnosticTag,Disposable:q.$xK,DocumentHighlight:q.$NK,DocumentHighlightKind:q.DocumentHighlightKind,DocumentLink:q.$9K,DocumentSymbol:q.$PK,EndOfLine:q.EndOfLine,EnvironmentVariableMutatorType:q.EnvironmentVariableMutatorType,EvaluatableExpression:q.$FL,InlineValueText:q.$GL,InlineValueVariableLookup:q.$HL,InlineValueEvaluatableExpression:q.$IL,InlineCompletionTriggerKind:q.InlineCompletionTriggerKind,EventEmitter:f.$Od,ExtensionKind:q.ExtensionKind,ExtensionMode:q.ExtensionMode,ExternalUriOpenerPriority:q.ExternalUriOpenerPriority,FileChangeType:q.FileChangeType,FileDecoration:q.$SL,FileDecoration2:q.$SL,FileSystemError:q.$KL,FileType:P.FileType,FilePermission:P.FilePermission,FoldingRange:q.$LL,FoldingRangeKind:q.FoldingRangeKind,FunctionBreakpoint:q.$xL,InlineCompletionItem:q.$6K,InlineCompletionList:q.$7K,Hover:q.$MK,IndentAction:m.IndentAction,Location:q.$JK,MarkdownString:q.$XK,OverviewRulerLane:E.OverviewRulerLane,ParameterInformation:q.$YK,PortAutoForwardAction:q.PortAutoForwardAction,Position:q.$yK,ProcessExecution:q.$fL,ProgressLocation:q.ProgressLocation,QuickInputButtons:q.$RL,Range:q.$zK,RelativePattern:q.$tL,Selection:q.$AK,SelectionRange:q.$SK,SemanticTokens:q.$OL,SemanticTokensBuilder:q.$NL,SemanticTokensEdit:q.$PL,SemanticTokensEdits:q.$QL,SemanticTokensLegend:q.$ML,ShellExecution:q.$gL,ShellQuoting:q.ShellQuoting,SignatureHelp:q.$1K,SignatureHelpTriggerKind:q.SignatureHelpTriggerKind,SignatureInformation:q.$ZK,SnippetString:q.$IK,SourceBreakpoint:q.$wL,StandardTokenType:q.StandardTokenType,StatusBarAlignment:q.StatusBarAlignment,SymbolInformation:q.$OK,SymbolKind:q.SymbolKind,SymbolTag:q.SymbolTag,Task:q.$iL,TaskGroup:q.$eL,TaskPanelKind:q.TaskPanelKind,TaskRevealKind:q.TaskRevealKind,TaskScope:q.TaskScope,TerminalLink:q.$aL,TerminalQuickFixExecuteTerminalCommand:q.$cL,TerminalQuickFixOpener:q.$bL,TerminalLocation:q.TerminalLocation,TerminalProfile:q.$dL,TerminalExitReason:q.TerminalExitReason,TextDocumentSaveReason:q.TextDocumentSaveReason,TextEdit:q.$EK,SnippetTextEdit:q.$GK,TextEditorCursorStyle:p.TextEditorCursorStyle,TextEditorLineNumbersStyle:q.TextEditorLineNumbersStyle,TextEditorRevealType:q.TextEditorRevealType,TextEditorSelectionChangeKind:q.TextEditorSelectionChangeKind,SyntaxTokenType:q.SyntaxTokenType,TextDocumentChangeReason:q.TextDocumentChangeReason,ThemeColor:q.$sL,ThemeIcon:q.$rL,TreeItem:q.$jL,TreeItemCheckboxState:q.TreeItemCheckboxState,TreeItemCollapsibleState:q.TreeItemCollapsibleState,TypeHierarchyItem:q.$bM,UIKind:y.UIKind,Uri:R.URI,ViewColumn:q.ViewColumn,WorkspaceEdit:q.$HK,DocumentDropEdit:q.$pL,DocumentPasteEdit:q.$qL,InlayHint:q.$3K,InlayHintLabelPart:q.$2K,InlayHintKind:q.InlayHintKind,RemoteAuthorityResolverError:q.$DK,ResolvedAuthority:q.$BK,ManagedResolvedAuthority:q.$CK,SourceControlInputBoxValidationType:q.SourceControlInputBoxValidationType,ExtensionRuntime:q.ExtensionRuntime,TimelineItem:q.$3L,NotebookRange:q.$UL,NotebookCellKind:q.NotebookCellKind,NotebookCellExecutionState:q.NotebookCellExecutionState,NotebookCellData:q.$VL,NotebookData:q.$WL,NotebookRendererScript:q.$1L,NotebookCellStatusBarAlignment:q.NotebookCellStatusBarAlignment,NotebookEditorRevealType:q.NotebookEditorRevealType,NotebookCellOutput:q.$YL,NotebookCellOutputItem:q.$XL,NotebookCellStatusBarItem:q.$ZL,NotebookControllerAffinity:q.NotebookControllerAffinity,NotebookControllerAffinity2:q.NotebookControllerAffinity2,NotebookEdit:q.$FK,NotebookKernelSourceAction:q.$2L,PortAttributes:q.$5L,LinkedEditingRanges:q.$4L,TestResultState:q.TestResultState,TestRunRequest:q.$6L,TestMessage:q.$7L,TestMessage2:q.$7L,TestTag:q.$8L,TestRunProfileKind:q.TestRunProfileKind,TextSearchCompleteMessageType:Oe.TextSearchCompleteMessageType,DataTransfer:q.$oL,DataTransferItem:q.$kL,CoveredCount:q.$9L,FileCoverage:q.$0L,StatementCoverage:q.$$L,BranchCoverage:q.$_L,FunctionCoverage:q.$aM,WorkspaceTrustState:q.WorkspaceTrustState,LanguageStatusSeverity:q.LanguageStatusSeverity,QuickPickItemKind:q.QuickPickItemKind,InputBoxValidationSeverity:q.InputBoxValidationSeverity,TabInputText:q.$cM,TabInputTextDiff:q.$dM,TabInputTextMerge:q.$eM,TabInputCustom:q.$fM,TabInputNotebook:q.$hM,TabInputNotebookDiff:q.$iM,TabInputWebview:q.$gM,TabInputTerminal:q.$jM,TabInputInteractiveWindow:q.$kM,TabInputChat:q.$lM,TelemetryTrustedValue:fe.$no,LogLevel:G.LogLevel,EditSessionIdentityMatch:ct.EditSessionIdentityMatch,InteractiveSessionVoteDirection:q.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:q.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:q.InteractiveEditorResponseFeedbackKind,StackFrameFocus:q.$DL,ThreadFocus:q.$EL,RelatedInformationType:q.RelatedInformationType,SpeechToTextStatus:q.SpeechToTextStatus}}}e.$8ec=Nt}),define(ke[372],Se([1,0,106,154,41,151,42,35,70,46,95,96,97,118,73,91,153,72,57,117,90,71,152,15,58,115,116]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,S,w,c,s,i,n,o,a,t,r,d,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,I.$Ar)(u.$Gdc,u.$Fdc,1),(0,I.$Ar)(r.$cj,t.$9ec,1),(0,I.$Ar)(w.$6cc,w.$7cc,1),(0,I.$Ar)(p.$TM,p.$SM,0),(0,I.$Ar)(R.$gdc,R.$edc,0),(0,I.$Ar)(s.$vdc,s.$udc,0),(0,I.$Ar)(P.$jec,P.$nec,0),(0,I.$Ar)(L.$bec,L.$aec,0),(0,I.$Ar)(E.$IM,E.$HM,0),(0,I.$Ar)(l.$Hdc,l.$Idc,0),(0,I.$Ar)(i.$3cc,i.$2cc,0),(0,I.$Ar)(F.$Tdc,F.$Sdc,1),(0,I.$Ar)(g.$tec,g.$uec,0),(0,I.$Ar)(y.$rdc,y.$qdc,0),(0,I.$Ar)(A.$eec,A.$dec,0),(0,I.$Ar)(m.$ydc,m.$Bdc,0),(0,I.$Ar)(S.$Iwb,S.$Jwb,0),(0,I.$Ar)(c.$0dc,c.$9dc,0),(0,I.$Ar)(f.$ddc,f.$cdc,0),(0,I.$Ar)(n.$Ddc,n.$Cdc,0),(0,I.$Ar)(o.$RM,o.$OM,0),(0,I.$Ar)(a.$fec,a.$gec,0),(0,I.$Ar)(d.$hec,d.$iec,0)}),define(ke[119],Se([1,0,19,15,36,94]),function($e,e,I,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ofc=e.$nfc=e.$mfc=void 0;function R(P){return P.startsWith("**")||P.startsWith("/")?P:`/${P}`}e.$mfc=R;function p(P,g,y,S){const w=(0,I.$1b)(y,E),c=new f.$YI(g,w,S),s=c.preview.matches;return{ranges:(0,I.$1b)(w,m),uri:P,preview:{text:c.preview.text,matches:(0,I.$1b)(s,m)}}}e.$nfc=p;function E(P){return new f.$ZI(P.start.line,P.start.character,P.end.line,P.end.character)}function m(P){return new L.$NI(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn)}let A=class{constructor(g,y){this.a=g,this.b=y}appendLine(g){this.b.debug(`${this.a}#search`,g)}};e.$ofc=A,e.$ofc=A=He([Be(1,F.$bj)],A)}),define(ke[373],Se([1,0,50,16,77,33,12,13,119,374]),function($e,e,I,F,f,L,R,p,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rfc=e.$qfc=e.$pfc=void 0;const A=m.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function P(n,o,a,t){const r=g(n,o,a,t),d=o.folder.fsPath;return{cmd:I.spawn(A,r.args,{cwd:d}),rgDiskPath:A,siblingClauses:r.siblingClauses,rgArgs:r,cwd:d}}e.$pfc=P;function g(n,o,a,t){const r=["--files","--hidden","--case-sensitive","--no-require-git"];S([o],a,!1).forEach(u=>{const l=(0,E.$mfc)(u);if(r.push("-g",l),R.$k){const h=(0,f.$tl)(l);h!==l&&r.push("-g",h)}});const d=y([o],t,void 0,!1);return d.globArgs.forEach(u=>{const l=`!${(0,E.$mfc)(u)}`;if(r.push("-g",l),R.$k){const h=(0,f.$tl)(l);h!==l&&r.push("-g",h)}}),o.disregardIgnoreFiles!==!1?r.push("--no-ignore"):o.disregardParentIgnoreFiles!==!1&&r.push("--no-ignore-parent"),o.ignoreSymlinks||r.push("--follow"),n.exists&&r.push("--quiet"),r.push("--no-config"),o.disregardGlobalIgnoreFiles&&r.push("--no-ignore-global"),{args:r,siblingClauses:d.siblingClauses}}function y(n,o,a,t=!0){const r=[];let d={};return n.forEach(u=>{const l=Object.assign({},u.excludePattern||{},o||{}),h=w(l,t?u.folder.fsPath:void 0,a);r.push(...h.globArgs),h.siblingClauses&&(d=Object.assign(d,h.siblingClauses))}),{globArgs:r,siblingClauses:d}}function S(n,o,a=!0){const t=[];return n.forEach(r=>{const d=Object.assign({},o||{},r.includePattern||{}),u=w(d,a?r.folder.fsPath:void 0);t.push(...u.globArgs)}),t}function w(n,o,a){const t=[],r={};return Object.keys(n).forEach(d=>{if(a&&a.has(d)||!d)return;const u=n[d];d=s(o?c(o,d):d),d.startsWith("\\\\")?d="\\\\"+d.substr(2).replace(/\\/g,"/"):d=d.replace(/\\/g,"/"),typeof u=="boolean"&&u?(d.startsWith("\\\\")&&(d+="**"),t.push(i(d))):u&&u.when&&(r[d]=u)}),{globArgs:t,siblingClauses:r}}function c(n,o){return F.$hc(o)?o:F.$ic(n,o)}e.$qfc=c;function s(n){return n=p.$Le(n,"\\"),p.$Le(n,"/")}function i(n){return L.$Uf(n).toLowerCase()==="c:/"?n.replace(/^c:[/\\]/i,"/"):n}e.$rfc=i}),define(ke[375],Se([1,0,50,55,16,376,19,43,34,77,33,12,37,13,18,30,36,373,130]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,S,w,c,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tfc=e.$sfc=void 0;const n=new Set;process.on("exit",()=>{n.forEach(d=>d())});class o{constructor(u){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=u,this.b=u.filePattern||"",this.d=u.includePattern&&E.$Aj(u.includePattern),this.f=u.maxResults||null,this.g=!!u.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,i.$Cq)(this.b).normalizedLowercase),this.u=u.excludePattern&&E.$Aj(u.excludePattern),this.t=new Map,u.folderQueries.forEach(l=>{const h=Object.assign({},l.excludePattern||{},this.a.excludePattern||{}),k=l.folder.fsPath;u.folderQueries.map(D=>D.folder.fsPath).filter(D=>D!==k).forEach(D=>{(0,A.$Yf)(D,k)&&(h[f.$kc(k,D)]=!0)}),this.t.set(k,new t(h,k))})}cancel(){this.l=!0,n.forEach(u=>u())}walk(u,l,h,k,D){if(this.m=g.$Kd.create(!1),this.l)return D(null,this.j);l.forEach($=>{const b=f.$mc($.fsPath);this.u&&this.u($.fsPath,b)||this.J(h,{relativePath:$.fsPath,searchPath:void 0})}),this.r=g.$Kd.create(!1),this.w(u,($,b)=>{this.x(this.y,this,$,h,k,v=>{if(v){const C=(0,p.$Ei)(v);console.error(C),this.q.push(C),b(v,void 0)}else b(null,void 0)})},($,b)=>{this.m.stop();const v=$?R.$Gb($)[0]:null;D(v,this.j)})}w(u,l,h){const k=new Array(u.length),D=new Array(u.length);let $=!1,b=0;if(u.length===0)return h(null,[]);u.forEach((v,C)=>{l(v,(N,z)=>{if(N?($=!0,k[C]=null,D[C]=N):(k[C]=z,D[C]=null),++b===u.length)return h($?D:null,k)})})}x(u,l,...h){try{u.apply(l,h)}catch(k){h[h.length-1](k)}}y(u,l,h,k){const D=u.folder.fsPath,$=P.$k,b=()=>M&&M.kill();n.add(b);let v=V=>{n.delete(b),v=()=>{},k(V)},C="";const N=this.D(),z=(0,s.$pfc)(this.a,u,this.a.includePattern,this.t.get(u.folder.fsPath).expression),M=z.cmd,O=!Object.keys(z.siblingClauses).length,j=z.rgArgs.args.map(V=>V.match(/^-/)?V:`'${V}'`).join(" ");let T=`${z.rgDiskPath} ${j}
 - cwd: ${z.cwd}`;z.rgArgs.siblingClauses&&(T+=`
 - Sibling clauses: ${JSON.stringify(z.rgArgs.siblingClauses)}`),h({message:T}),this.s=0,this.z(M,"utf8",h,(V,q,fe)=>{if(V){v(V);return}if(this.j){v();return}const Y=(C+($?m.$sl(q||""):q)).split(`
`);if(fe){const X=Y.length;Y[X-1]=Y[X-1].trim(),Y[X-1]||Y.pop()}else C=Y.pop()||"";if(Y.length&&Y[0].indexOf(`
`)!==-1){v(new Error("Splitting up files failed"));return}if(this.s+=Y.length,O){for(const X of Y)if(this.J(l,{base:D,relativePath:X,searchPath:this.N(u,X)}),this.j){b();break}(fe||this.j)&&v();return}this.G(u,N,D,Y,l),fe&&(this.H(N,D,l),v())})}spawnFindCmd(u){const l=this.t.get(u.folder.fsPath),h=l.getBasenameTerms(),k=l.getPathTerms(),D=["-L","."];if(h.length||k.length){D.push("-not","(","(");for(const $ of h)D.push("-name",$),D.push("-o");for(const $ of k)D.push("-path",$),D.push("-o");D.pop(),D.push(")","-prune",")")}return D.push("-type","f"),I.spawn("find",D,{cwd:u.folder.fsPath})}readStdout(u,l,h){let k="";this.z(u,l,()=>{},(D,$,b)=>{if(D){h(D);return}k+=$,b&&h(null,k)})}z(u,l,h,k){let D=(v,C,N)=>{(v||N)&&(D=()=>{},this.r?.stop()),k(v,C,N)},$=!1;u.stdout?(this.A(u.stdout,l,D),u.stdout.once("data",()=>$=!0)):h({message:"stdout is null"});let b;u.stderr?b=this.B(u.stderr):h({message:"stderr is null"}),u.on("error",v=>{D(v)}),u.on("close",v=>{let C;!$&&(C=this.C(b,l))&&r(C)?D(new Error(`command failed with error code ${v}: ${this.C(b,l)}`)):(this.g&&v===0&&(this.j=!0),D(null,"",!0))})}A(u,l,h){const k=new L.StringDecoder(l);return u.on("data",D=>{h(null,k.write(D))}),k}B(u){const l=[];return u.on("data",h=>{l.push(h)}),l}C(u,l){const h=new L.StringDecoder(l);return u.map(k=>h.write(k)).join("")}D(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}G(u,{pathToEntries:l},h,k,D){k.indexOf(this.b)!==-1&&this.J(D,{base:h,relativePath:this.b,searchPath:this.N(u,this.b)});const $=b=>{const v=f.$mc(b),C=f.$lc(b);let N=l[C];N||(N=l[C]=[],$(C)),N.push({base:h,relativePath:b,basename:v,searchPath:this.N(u,b)})};k.forEach($)}H({rootEntries:u,pathToEntries:l},h,k){const D=this,$=this.t.get(h),b=this.b;function v(C){D.o++;const N=(0,c.$cJ)(()=>C.map(z=>z.basename));for(let z=0,M=C.length;z<M;z++){const O=C[z],{relativePath:j,basename:T}=O;if($.test(j,T,b!==T?N:void 0))continue;const V=l[j];if(V)v(V);else{if(D.p++,j===b)continue;D.J(k,O)}if(D.j)break}}v(u)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(u,l,h,k,D){const $=u.folder,b=(0,c.$cJ)(()=>h);this.w(h,(v,C)=>{if(this.l||this.j)return C(null);const N=l?[l,v].join(f.sep):v;if(this.t.get(u.folder.fsPath).test(N,v,this.a.filePattern!==v?b:void 0))return C(null);const z=[$.fsPath,N].join(f.sep);F.lstat(z,(M,O)=>{if(M||this.l||this.j)return C(null);this.L(z,O,(j,T)=>j||this.l||this.j?C(null):T.isDirectory()?(this.o++,this.M(z,O,(V,q)=>V||this.l||this.j||(q=q||"",this.v[q])?C(null):(this.v[q]=!0,w.Promises.readdir(z).then(fe=>{if(this.l||this.j)return C(null);this.I(u,N,fe,k,ee=>C(ee||null))},fe=>{C(null)})))):(this.p++,N===this.b||this.h&&S.$Df(T.size)&&T.size>this.h||this.J(k,{base:$.fsPath,relativePath:N,searchPath:this.N(u,N)}),C(null,void 0)))})},v=>{const C=v&&R.$Gb(v);return D(C&&C.length>0?C[0]:void 0)})}J(u,l){this.K(l)&&(!this.d||this.d(l.relativePath,f.$mc(l.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||u(l))}K(u){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,c.$0I)(u,this.c)}return!0}L(u,l,h){return l.isSymbolicLink()?F.stat(u,h):h(null,l)}M(u,l,h){return l.isSymbolicLink()?F.realpath(u,(k,D)=>k?h(k):h(null,D)):h(null,u)}N(u,l){return u.folderName?f.$ic(u.folderName,l):l}}e.$sfc=o;class a{constructor(u){this.a=u.folderQueries,this.b=u.extraFileResources||[],this.c=new o(u)}search(u,l,h){this.c.walk(this.a,this.b,u,l,(k,D)=>{h(k,{limitHit:D,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$tfc=a;class t{constructor(u,l){this.expression=u,this.c=l,this.d(u)}d(u){let l,h;Object.keys(u).filter(k=>u[k]).forEach(k=>{f.$hc(k)?(l=l||E.$vj(),l[k]=u[k]):(h=h||E.$vj(),h[k]=u[k])}),this.a=l&&E.$Aj(l,{trimForExclusions:!0}),this.b=h&&E.$Aj(h,{trimForExclusions:!0})}test(u,l,h){return this.b&&this.b(u,l,h)||this.a&&this.a(f.$ic(this.c,u),l,h)}getBasenameTerms(){const u=[];return this.a&&u.push(...E.$Cj(this.a)),this.b&&u.push(...E.$Cj(this.b)),u}getPathTerms(){const u=[];return this.a&&u.push(...E.$Dj(this.a)),this.b&&u.push(...E.$Dj(this.b)),u}}function r(d){const u=d.trim().split(`
`),l=u[0].trim();if(l.startsWith("Error parsing regex"))return l;if(l.startsWith("regex parse error"))return y.$rf(u[u.length-1].trim());if(l.startsWith("error parsing glob")||l.startsWith("unsupported encoding"))return l.charAt(0).toUpperCase()+l.substr(1);if(l==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(l.startsWith("Literal "))return l}}),define(ke[377],Se([1,0,98,22,186,21]),function($e,e,I,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3C=e.$2C=e.$1C=e.$ZC=e.$YC=e.$XC=e.$WC=e.$VC=e.$UC=e.DecodeStreamErrorKind=e.$TC=e.$SC=e.$RC=e.$QC=e.$PC=e.$OC=e.$NC=e.$MC=void 0,e.$MC="utf8",e.$NC="utf8bom",e.$OC="utf16be",e.$PC="utf16le";function R(l){return[e.$MC,e.$NC,e.$OC,e.$PC].some(h=>h===l)}e.$QC=R,e.$RC=[254,255],e.$SC=[255,254],e.$TC=[239,187,191];const p=512,E=512,m=512*8,A=512*128;var P;(function(l){l[l.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(P||(e.DecodeStreamErrorKind=P={}));class g extends Error{constructor(h,k){super(h),this.decodeStreamErrorKind=k}}e.$UC=g;class y{static async create(h){let k;if(h!==e.$MC)k=(await(0,f.$LC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(s(h));else{const D=new TextDecoder;k={write($){return D.decode($,{stream:!0})},end(){return D.decode()}}}return new y(k)}constructor(h){this.a=h}write(h){return this.a.write(h)}end(){return this.a.end()}}function S(l,h){const k=h.minBytesRequiredForDetection??h.guessEncoding?m:E;return new Promise((D,$)=>{const b=(0,I.$3d)(O=>O.join("")),v=[];let C=0,N;const z=new L.$Yd,M=async()=>{try{const O=await u({buffer:F.$ce.concat(v),bytesRead:C},h.guessEncoding);if(O.seemsBinary&&h.acceptTextOnly)throw new g("Stream is binary but only text is accepted for decoding",1);O.encoding=await h.overwriteEncoding(O.encoding),N=await y.create(O.encoding);const j=N.write(F.$ce.concat(v).buffer);b.write(j),v.length=0,C=0,D({stream:b,detected:O})}catch(O){z.cancel(),b.destroy(),$(O)}};(0,I.$7d)(l,{onData:async O=>{N?b.write(N.write(O.buffer)):(v.push(O),C+=O.byteLength,C>=k&&(l.pause(),await M(),setTimeout(()=>l.resume())))},onError:O=>b.error(O),onEnd:async()=>{N||await M(),b.end(N?.end())}},z.token)})}e.$VC=S;async function w(l,h,k){const $=(await(0,f.$LC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(s(h),k);let b=!1,v=!1;return{read(){if(v)return null;const C=l.read();if(typeof C!="string"){if(v=!0,!b&&k?.addBOM)switch(h){case e.$MC:case e.$NC:return F.$ce.wrap(Uint8Array.from(e.$TC));case e.$OC:return F.$ce.wrap(Uint8Array.from(e.$RC));case e.$PC:return F.$ce.wrap(Uint8Array.from(e.$SC))}const N=$.end();return N&&N.length>0?(b=!0,F.$ce.wrap(N)):null}return b=!0,F.$ce.wrap($.write(C))}}}e.$WC=w;async function c(l){return(await(0,f.$LC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(s(l))}e.$XC=c;function s(l){return l===e.$NC||l===null?e.$MC:l}e.$YC=s;function i(l,h){if(!l||h<e.$RC.length)return null;const k=l.readUInt8(0),D=l.readUInt8(1);if(k===e.$RC[0]&&D===e.$RC[1])return e.$OC;if(k===e.$SC[0]&&D===e.$SC[1])return e.$PC;if(h<e.$TC.length)return null;const $=l.readUInt8(2);return k===e.$TC[0]&&D===e.$TC[1]&&$===e.$TC[2]?e.$NC:null}e.$ZC=i;const n=["ascii","utf-16","utf-32"];async function o(l){const h=await(0,f.$LC)("jschardet","dist/jschardet.min.js"),k=l.slice(0,A),D=r(k.buffer),$=h.detect(D);if(!$||!$.encoding)return null;const b=$.encoding.toLowerCase();return 0<=n.indexOf(b)?null:t($.encoding)}const a={ibm866:"cp866",big5:"cp950"};function t(l){const h=l.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return a[h]||h}function r(l){let h="";for(let k=0;k<l.length;k++)h+=String.fromCharCode(l[k]);return h}function d(l){switch(l){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const h=l.match(/windows(\d+)/);return h?"windows-"+h[1]:l}}}e.$1C=d;function u({buffer:l,bytesRead:h},k){let D=i(l,h),$=!1;if(D!==e.$OC&&D!==e.$PC&&l){let b=!0,v=!0,C=!1;for(let N=0;N<h&&N<p;N++){const z=N%2===1,M=l.readUInt8(N)===0;if(M&&(C=!0),b&&(z&&!M||!z&&M)&&(b=!1),v&&(z&&M||!z&&!M)&&(v=!1),M&&!b&&!v)break}C&&(b?D=e.$PC:v?D=e.$OC:$=!0)}return k&&!$&&!D&&l?o(l.slice(0,h)).then(b=>({seemsBinary:!1,encoding:b})):{seemsBinary:$,encoding:D}}e.$2C=u,e.$3C={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ke[157],Se([1,0,377,30,156]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bfc=void 0;class L extends f.$pec{constructor(p,E,m=F,A="searchProcess"){super(p,E,{readdir:P=>m.Promises.readdir(P.fsPath),toCanonicalName:P=>(0,I.$1C)(P)},A)}}e.$Bfc=L}),define(ke[158],Se([1,0,50,393,376,19,74,34,16,13,2,36,94,394,374,119]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Afc=e.$zfc=e.$yfc=e.$xfc=e.$wfc=e.$vfc=e.$ufc=void 0;const c=S.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class s{constructor(v){this.a=v}provideTextSearchResults(v,C,N,z){return this.a.appendLine(`provideTextSearchResults ${v.pattern}, ${JSON.stringify({...C,folder:C.folder.toString()})}`),new Promise((M,O)=>{z.onCancellationRequested(()=>X());const j=r(v,C),T=C.folder.fsPath,V=j.map(H=>H.match(/^-/)?H:`'${H}'`).join(" ");this.a.appendLine(`${c} ${V}
 - cwd: ${T}`);let q=I.spawn(c,j,{cwd:T});q.on("error",H=>{console.error(H),this.a.appendLine("Error: "+(H&&H.message)),O((0,P.$6I)(new P.$4I(H&&H.message,P.SearchErrorCode.rgProcessError)))});let fe=!1;const ee=new o(C.maxResults,T,C.previewOptions);ee.on("result",H=>{fe=!0,Z="",N.report(H)});let Y=!1;const X=()=>{Y=!0,q?.kill(),ee?.cancel()};let ae=!1;ee.on("hitLimit",()=>{ae=!0,X()});let Z="";q.stdout.on("data",H=>{ee.handleData(H),fe||(Z+=H)});let se=!1;q.stdout.once("data",()=>se=!0);let we="";q.stderr.on("data",H=>{const U=H.toString();this.a.appendLine(U),we.length+U.length<1e6&&(we+=U)}),q.on("close",()=>{if(this.a.appendLine(se?"Got data from stdout":"No data from stdout"),this.a.appendLine(fe?"Got result from parser":"No result from parser"),Z&&this.a.appendLine(`Got data without result: ${Z}`),this.a.appendLine(""),Y)M({limitHit:ae});else{ee.flush(),q=null;let H;we&&!se&&(H=i(we))?O((0,P.$6I)(new P.$4I(H.message,H.code))):M({limitHit:ae})}})})}}e.$ufc=s;function i(b){const v=b.split(`
`),C=v[0].trim();if(v.some(z=>z.startsWith("regex parse error")))return new P.$4I(n(v),P.SearchErrorCode.regexParseError);const N=C.match(/grep config error: unknown encoding: (.*)/);if(N)return new P.$4I(`Unknown encoding: ${N[1]}`,P.SearchErrorCode.unknownEncoding);if(C.startsWith("error parsing glob"))return new P.$4I(C.charAt(0).toUpperCase()+C.substr(1),P.SearchErrorCode.globParseError);if(C.startsWith("the literal"))return new P.$4I(C.charAt(0).toUpperCase()+C.substr(1),P.SearchErrorCode.invalidLiteral);if(C.startsWith("PCRE2: error compiling pattern"))return new P.$4I(C,P.SearchErrorCode.regexParseError)}function n(b){const v=["Regex parse error"],C=b.filter(N=>N.startsWith("PCRE2:"));if(C.length>=1){const N=C[0].replace("PCRE2:","");if(N.indexOf(":")!==-1&&N.split(":").length>=2){const z=N.split(":")[1];v.push(":"+z)}}return v.join("")}class o extends F.EventEmitter{constructor(v,C,N){super(),this.g=v,this.h=C,this.j=N,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new f.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(v,C){return super.on(v,C),this}handleData(v){if(this.b)return;const C=typeof v=="string"?v:this.d.write(v);this.k(C)}k(v){let C=v.indexOf(`
`);const N=this.a+v;if(C>=0)C+=this.a.length;else{this.a=N;return}let z=0;for(;C>=0;)this.m(N.substring(z,C).trim()),z=C+1,C=N.indexOf(`
`,z);this.a=N.substring(z)}m(v){if(this.b||!v)return;let C;try{C=JSON.parse(v)}catch{throw new Error(`malformed line from rg: ${v}`)}if(C.type==="match"){const N=a(C.data.path),z=A.URI.file(E.$ic(this.h,N)),M=this.n(C.data,z);this.p(M),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(C.type==="context"){const N=a(C.data.path),z=A.URI.file(E.$ic(this.h,N));this.o(C.data,z).forEach(O=>this.p(O))}}n(v,C){const N=v.line_number-1,z=a(v.lines),M=Buffer.from(z);let O=0,j=0,T=N;v.submatches.length===0&&v.submatches.push(z.length?{start:0,end:1,match:{text:z[0]}}:{start:0,end:0,match:{text:""}});const V=(0,L.$Gb)(v.submatches.map((q,fe)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const ee=a(q.match),Y=M.slice(O,q.start).toString(),X=t(Y),ae=X.numLines>0?X.lastLineLength:X.lastLineLength+j,Z=t(ee),se=X.numLines+T,we=Z.numLines+se,H=Z.numLines>0?Z.lastLineLength:Z.lastLineLength+ae;return O=q.end,j=H,T=we,new g.$NI(se,ae,we,H)}));return(0,w.$nfc)(C,z,V,this.j)}o(v,C){const N=a(v.lines),z=v.line_number;return N.replace(/\r?\n$/,"").split(`
`).map((M,O)=>({text:M,uri:C,lineNumber:z+O}))}p(v){this.emit("result",v)}}e.$vfc=o;function a(b){return b.bytes?Buffer.from(b.bytes,"base64").toString():b.text}function t(b){const v=/\n/g;let C=0,N=-1,z;for(;z=v.exec(b);)C++,N=z.index;const M=N>=0?b.length-N-1:b.length;return{numLines:C,lastLineLength:M}}function r(b,v){const C=["--hidden","--no-require-git"];C.push(b.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:N,otherIncludes:z}=(0,R.$J)(v.includes,O=>O.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(z&&z.length){const O=new Set;z.forEach(j=>{O.add(j)}),C.push("-g","!*"),O.forEach(j=>{d(j).map(w.$mfc).forEach(T=>{C.push("-g",T)})})}N&&N.length&&N.forEach(O=>{C.push("-g",O)}),v.excludes.map(w.$mfc).forEach(O=>C.push("-g",`!${O}`)),v.maxFileSize&&C.push("--max-filesize",v.maxFileSize+""),v.useIgnoreFiles?v.useParentIgnoreFiles||C.push("--no-ignore-parent"):C.push("--no-ignore"),v.followSymlinks&&C.push("--follow"),v.encoding&&v.encoding!=="utf8"&&C.push("--encoding",v.encoding),b.pattern==="--"&&(b.isRegExp=!0,b.pattern="\\-\\-"),b.isMultiline&&!b.isRegExp&&(b.pattern=(0,m.$Ge)(b.pattern),b.isRegExp=!0),v.usePCRE2&&C.push("--pcre2"),C.push("--crlf"),b.isRegExp&&(b.pattern=u(b.pattern),C.push("--engine","auto"));let M;if(b.isWordMatch){const j=(0,m.$Oe)(b.pattern,!!b.isRegExp,{wholeWord:b.isWordMatch}).source.replace(/\\\//g,"/");C.push("--regexp",j)}else if(b.isRegExp){let O=h(b.pattern);O=k(O),C.push("--regexp",O)}else M=b.pattern,C.push("--fixed-strings");return C.push("--no-config"),v.useGlobalIgnoreFiles||C.push("--no-ignore-global"),C.push("--json"),b.isMultiline&&C.push("--multiline"),v.beforeContext&&C.push("--before-context",v.beforeContext+""),v.afterContext&&C.push("--after-context",v.afterContext+""),C.push("--"),M&&C.push(M),C.push("."),C}e.$wfc=r;function d(b){return $(b).flatMap(C=>{const N=(0,p.$yj)(C,"/");return N.map((z,M)=>N.slice(0,M+1).join("/"))})}function u(b){const v=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;b.match(v);)b=b.replace(v,"$1\\x{$2}");const C=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;b.match(C);)b=b.replace(C,"$1\\x{$2}");return b}e.$xfc=u;const l=b=>b.type==="Assertion"&&b.kind==="lookbehind";function h(b){let v;try{v=new y.RegExpParser().parsePattern(b)}catch{return b}let C="",N=0;const z=(j,T,V)=>{C+=b.slice(N,j)+V,N=T},M=[];return new y.RegExpVisitor({onCharacterEnter(j){if(j.raw!=="\\n")return;const T=M[0];if(!T)z(j.start,j.end,"\\r?\\n");else if(!M.some(l))if(T.type==="CharacterClass")if(T.negate){const V=b.slice(T.start+2,j.start)+b.slice(j.end,T.end-1);T.parent?.type==="Quantifier"?z(T.start,T.end,V?`[^${V}]`:"."):z(T.start,T.end,"(?!\\r?\\n"+(V?`|[${V}]`:"")+")")}else{const V=b.slice(T.start+1,j.start)+b.slice(j.end,T.end-1);z(T.start,T.end,V===""?"\\r?\\n":`(?:[${V}]|\\r?\\n)`)}else T.type==="Quantifier"&&z(j.start,j.end,"(?:\\r?\\n)")},onQuantifierEnter(j){M.unshift(j)},onQuantifierLeave(){M.shift()},onCharacterClassRangeEnter(j){M.unshift(j)},onCharacterClassRangeLeave(){M.shift()},onCharacterClassEnter(j){M.unshift(j)},onCharacterClassLeave(){M.shift()},onAssertionEnter(j){l(j)&&M.push(j)},onAssertionLeave(j){M[0]===j&&M.shift()}}).visit(v),C+=b.slice(N),C}e.$yfc=h;function k(b){return b.replace(/\n/g,"\\r?\\n")}e.$zfc=k;function D(b){let v=!1,C=!1,N="",z="";for(let M=0;M<b.length;M++){const O=b[M];switch(O){case"\\":C?(v?z+="\\"+O:N+="\\"+O,C=!1):C=!0;break;case"{":if(C)v?z+=O:N+=O,C=!1;else{if(v)return{strInBraces:N+"{"+z+"{"+b.substring(M+1)};v=!0}break;case"}":if(C)v?z+=O:N+=O,C=!1;else{if(v)return{fixedStart:N,strInBraces:z,fixedEnd:b.substring(M+1)};N+=O}break;default:v?z+=(C?"\\":"")+O:N+=(C?"\\":"")+O,C=!1;break}}return{strInBraces:N+(v?"{"+z:"")}}function $(b){const{fixedStart:v,strInBraces:C,fixedEnd:N}=D(b);if(v===void 0||N===void 0)return[C];let z=(0,p.$yj)(C,",");z.length||(z=[""]);const M=$(N);return z.flatMap(O=>{const j=v+O;return M.map(T=>j+T)})}e.$Afc=$}),define(ke[378],Se([1,0,21,158,64,17]),function($e,e,I,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Efc=void 0;class R{constructor(m){this.b=m,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(m,A,P,g){const y=new F.$ufc(this.b);if(A.folder.scheme===L.Schemas.vscodeUserData){const S={...A,folder:A.folder.with({scheme:L.Schemas.file})},w=new f.$9u(c=>P.report({...c,uri:c.uri.with({scheme:A.folder.scheme})}));return this.c(g,c=>y.provideTextSearchResults(m,S,w,c))}else return this.c(g,S=>y.provideTextSearchResults(m,A,P,S))}async c(m,A){const P=p(m);this.a.add(P);const g=await A(P.token);return this.a.delete(P),g}d(){this.a.forEach(m=>m.cancel())}}e.$Efc=R;function p(E){const m=new I.$Yd;return E.onCancellationRequested(()=>m.cancel()),m}}),define(ke[379],Se([1,0,30,158,157]),function($e,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cfc=void 0;class L{constructor(E){this.a=E}search(E,m,A){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const P={appendLine(y){A({message:y})}},g=new f.$Bfc(this.a,new F.$ufc(P),I);return new Promise((y,S)=>g.search(w=>{m(w.map(R))},E).then(w=>y({limitHit:w.limitHit,type:"success",stats:w.stats}),S))}}e.$Cfc=L;function R(p){return{path:p.resource&&p.resource.fsPath,results:p.results,numMatches:(p.results||[]).reduce((E,m)=>{if(m.ranges){const A=m;return E+(Array.isArray(A.ranges)?A.ranges.length:1)}else return E+1},0)}}}),define(ke[380],Se([1,0,19,10,11,4,130,16,37,2,31,36,375,379]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dfc=void 0;class S{static{this.a=512}constructor(o="searchProcess"){this.d=o,this.b=Object.create(null)}fileSearch(o){let a;const t=s(o),r=new L.$Od({onDidAddFirstListener:()=>{a=(0,F.$Ig)(d=>this.doFileSearchWithEngine(g.$tfc,t,u=>r.fire(u),d)),a.then(d=>r.fire(d),d=>r.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{a.cancel()}});return r.event}textSearch(o){let a;const t=s(o),r=new L.$Od({onDidAddFirstListener:()=>{a=(0,F.$Ig)(d=>this.f(t,u=>r.fire(u),d)),a.then(d=>r.fire(d),d=>r.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{a.cancel()}});return r.event}f(o,a,t){return o.maxFileSize=this.g().maxFileSize,new y.$Cfc(o).search(t,a,a)}g(){return{maxFileSize:16*A.$Kk.GB}}doFileSearch(o,a,t){return this.doFileSearchWithEngine(g.$tfc,o,a,t)}doFileSearchWithEngine(o,a,t,r,d=S.a){let u=0;const l=k=>{Array.isArray(k)?(u+=k.length,t(k.map(D=>this.h(D)))):k.relativePath?(u++,t(this.h(k))):t(k)};if(a.sortByScore){let k=this.l(a,l,r);if(!k){const D=a.maxResults?Object.assign({},a,{maxResults:null}):a,$=new o(D);k=this.j($,a,t,l,r)}return new Promise((D,$)=>{k.then(([b,v])=>{const C=v.map(N=>this.h(N));this.o(C,t,d),D(b)},$)})}const h=new o(a);return this.r(h,l,d,r).then(k=>({limitHit:k.limitHit,type:"success",stats:{detailStats:k.stats,type:this.d,fromCache:!1,resultCount:u,sortingTime:void 0}}))}h(o){return{path:o.base?(0,p.$ic)(o.base,o.relativePath):o.relativePath}}j(o,a,t,r,d){const u=new L.$Od;let l=(0,F.$Ig)(k=>{let D=[];const $=b=>{Array.isArray(b)?D=b:(r(b),u.fire(b))};return this.r(o,$,-1,k).then(b=>[b,D])}),h;if(a.cacheKey){h=this.k(a.cacheKey);const k={promise:l,event:u.event,resolved:!1};h.resultsToSearchCache[a.filePattern||""]=k,l.then(()=>{k.resolved=!0},D=>{delete h.resultsToSearchCache[a.filePattern||""]}),l=this.s(l)}return l.then(([k,D])=>{const $=h?h.scorerCache:Object.create(null),b=(typeof a.maxResults!="number"||a.maxResults>0)&&E.$Kd.create(!1);return this.n(a,D,$,d).then(v=>{const C=b?b.elapsed():-1;return[{type:"success",stats:{detailStats:k.stats,sortingTime:C,fromCache:!1,type:this.d,workspaceFolderCount:a.folderQueries.length,resultCount:v.length},messages:k.messages,limitHit:k.limitHit||typeof a.maxResults=="number"&&D.length>a.maxResults},v]})})}k(o){const a=this.b[o];return a||(this.b[o]=new w)}l(o,a,t){const r=o.cacheKey&&this.b[o.cacheKey];if(!r)return;const d=this.q(r,o.filePattern||"",a,t);if(d)return d.then(([u,l,h])=>{const k=E.$Kd.create(!1);return this.n(o,l,r.scorerCache,t).then(D=>{const $=k.elapsed(),b={fromCache:!0,detailStats:h,type:this.d,resultCount:l.length,sortingTime:$};return[{type:"success",limitHit:u.limitHit||typeof o.maxResults=="number"&&l.length>o.maxResults,stats:b},D]})})}n(o,a,t,r){const d=(0,R.$Cq)(o.filePattern||""),u=(h,k)=>(0,R.$Bq)(h,k,d,!0,c,t),l=typeof o.maxResults=="number"?o.maxResults:Number.MAX_VALUE;return I.$Fb(a,u,l,1e4,r)}o(o,a,t){if(t&&t>0)for(let r=0;r<o.length;r+=t)a(o.slice(r,r+t));else a(o)}q(o,a,t,r){const d=E.$Kd.create(!1),u=a.indexOf(p.sep)>=0;let l;for(const $ in o.resultsToSearchCache)if(a.startsWith($)){if(u&&$.indexOf(p.sep)<0&&$!=="")continue;const b=o.resultsToSearchCache[$];l={promise:this.s(b.promise),event:b.event,resolved:b.resolved};break}if(!l)return null;const h=d.elapsed(),k=E.$Kd.create(!1),D=l.event(t);return r&&r.onCancellationRequested(()=>{D.dispose()}),l.promise.then(([$,b])=>{if(r&&r.isCancellationRequested)throw(0,f.$5)();const v=[],C=(0,R.$Cq)(a).normalizedLowercase;for(const N of b)(0,P.$0I)(N,C)&&v.push(N);return[$,v,{cacheWasResolved:l.resolved,cacheLookupTime:h,cacheFilterTime:k.elapsed(),cacheEntryCount:b.length}]})}r(o,a,t,r){return new Promise((d,u)=>{let l=[];r?.onCancellationRequested(()=>o.cancel()),o.search(h=>{h&&(t?(l.push(h),t>0&&l.length>=t&&(a(l),l=[])):a(h))},h=>{a(h)},(h,k)=>{l.length&&a(l),h?u(h):d(k)})})}clearCache(o){return delete this.b[o],Promise.resolve(void 0)}s(o){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(a,t){return o.then(a,t)}catch(a){return this.then(void 0,a)}finally(a){return o.finally(a)}}}}e.$Dfc=S;class w{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const c=new class{getItemLabel(n){return(0,p.$mc)(n.relativePath)}getItemDescription(n){return(0,p.$lc)(n.relativePath)}getItemPath(n){return n.relativePath}};function s(n){return{...n,folderQueries:n.folderQueries&&n.folderQueries.map(i),extraFileResources:n.extraFileResources&&n.extraFileResources.map(o=>m.URI.revive(o))}}function i(n){return{...n,folder:m.URI.revive(n.folder)}}}),define(ke[381],Se([1,0,3,17,2,30,15,27,20,97,67,36,380,378,119,157]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ffc=void 0;let c=class extends m.$uec{constructor(i,n,o,a){super(i,o,a),this.s=L,this.t=-1,this.v=null,this.w=!1,this.x=new I.$Qc;const t=new S.$ofc("RipgrepSearchUD",this.n);this.x.add(this.registerTextSearchProvider(F.Schemas.vscodeUserData,new y.$Efc(t))),n.remote.isRemote&&n.remote.authority&&this.y()}dispose(){this.x.dispose()}$enableExtensionHostSearch(){this.y()}y(){if(this.w)return;this.w=!0;const i=new S.$ofc("RipgrepSearchEH",this.n);this.x.add(this.registerTextSearchProvider(F.Schemas.file,new y.$Efc(i))),this.x.add(this.z(F.Schemas.file,new g.$Dfc("fileSearchProvider")))}z(i,n){const o=this.d++;return this.v=n,this.t=o,this.c.$registerFileSearchProvider(o,this.o(i)),(0,I.$Pc)(()=>{this.v=null,this.c.$unregisterProvider(o)})}$provideFileSearchResults(i,n,o,a){const t=(0,m.$vec)(o);return i===this.t?this.A(i,n,t,a):super.$provideFileSearchResults(i,n,o,a)}doInternalFileSearchWithCustomCallback(i,n,o){const a=t=>{if((0,P.$9I)(t)&&(t=[t]),Array.isArray(t)){o(t.map(r=>f.URI.file(r.path)));return}t.message&&this.n.debug("ExtHostSearch",t.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(i,a,n)}async A(i,n,o,a){return this.doInternalFileSearchWithCustomCallback(o,a,t=>{this.c.$handleFileMatch(i,n,t)})}$clearCache(i){return this.v?.clearCache(i),super.$clearCache(i)}q(i,n){return new w.$Bfc(i,n,void 0,"textSearchProvider")}};e.$Ffc=c,e.$Ffc=c=He([Be(0,E.$xM),Be(1,p.$NM),Be(2,A.$adc),Be(3,R.$bj)],c)}),define(ke[120],Se([1,0,395,62,63,396,22,11,4,3,16,12,32,82,83]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=void 0;class w{traceSocketEvent(b,v){S.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,b,v)}constructor(b,v=""){this.f=!0,this.debugLabel=v,this.socket=b,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=C=>{if(this.traceSocketEvent("error",{code:C?.code,message:C?.message}),C){if(C.code==="EPIPE")return;(0,p.$Z)(C)}},this.socket.on("error",this.a),this.b=C=>{this.traceSocketEvent("close",{hadError:C}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(b){const v=C=>{this.traceSocketEvent("read",C),b(R.$ce.wrap(C))};return this.socket.on("data",v),{dispose:()=>this.socket.off("data",v)}}onClose(b){const v=C=>{b({type:0,hadError:C,error:void 0})};return this.socket.on("close",v),{dispose:()=>this.socket.off("close",v)}}onEnd(b){const v=()=>{b()};return this.socket.on("end",v),{dispose:()=>this.socket.off("end",v)}}write(b){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",b),this.socket.write(b.buffer,v=>{if(v){if(v.code==="EPIPE")return;(0,p.$Z)(v)}})}catch(v){if(v.code==="EPIPE")return;(0,p.$Z)(v)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((b,v)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),b();return}const C=()=>{this.socket.off("close",C),this.socket.off("end",C),this.socket.off("error",C),this.socket.off("timeout",C),this.socket.off("drain",C),this.traceSocketEvent("nodeDrainEnd"),b()};this.socket.on("close",C),this.socket.on("end",C),this.socket.on("error",C),this.socket.on("timeout",C),this.socket.on("drain",C)})}}e.$Ih=w;var c;(function($){$[$.MinHeaderByteSize=2]="MinHeaderByteSize",$[$.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(c||(c={}));var s;(function($){$[$.PeekHeader=1]="PeekHeader",$[$.ReadHeader=2]="ReadHeader",$[$.ReadBody=3]="ReadBody",$[$.Fin=4]="Fin"})(s||(s={}));class i extends m.$Rc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(b,v){this.socket.traceSocketEvent(b,v)}constructor(b,v,C,N){super(),this.f=this.B(new E.$Od),this.g=this.B(new E.$Od),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=b,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:v,inflateBytesLength:C?.byteLength||0,recordInflateBytes:N}),this.a=this.B(new n(this,v,C,N,this.f,(z,M)=>this.m(z,M))),this.B(this.a.onError(z=>{console.error(z),(0,p.$Z)(z),this.g.fire({type:0,hadError:!0,error:z})})),this.b=new S.$Dh,this.B(this.socket.onData(z=>this.n(z))),this.B(this.socket.onClose(async z=>{this.a.isProcessingReadQueue()&&await E.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(z)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(b){return this.f.event(b)}onClose(b){return this.g.event(b)}onEnd(b){return this.socket.onEnd(b)}write(b){let v=0;for(;v<b.byteLength;)this.a.writeMessage(b.slice(v,Math.min(v+262144,b.byteLength)),{compressed:!0,opcode:2}),v+=262144}m(b,{compressed:v,opcode:C}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",b);let N=2;b.byteLength<126?N+=0:b.byteLength<2**16?N+=2:N+=8;const z=R.$ce.alloc(N),M=v?64:0,O=C&15;if(z.writeUInt8(128|M|O,0),b.byteLength<126)z.writeUInt8(b.byteLength,1);else if(b.byteLength<2**16){z.writeUInt8(126,1);let j=1;z.writeUInt8(b.byteLength>>>8&255,++j),z.writeUInt8(b.byteLength>>>0&255,++j)}else{z.writeUInt8(127,1);let j=1;z.writeUInt8(0,++j),z.writeUInt8(0,++j),z.writeUInt8(0,++j),z.writeUInt8(0,++j),z.writeUInt8(b.byteLength>>>24&255,++j),z.writeUInt8(b.byteLength>>>16&255,++j),z.writeUInt8(b.byteLength>>>8&255,++j),z.writeUInt8(b.byteLength>>>0&255,++j)}this.socket.write(R.$ce.concat([z,b]))}end(){this.h=!0,this.socket.end()}n(b){if(b.byteLength!==0){for(this.b.acceptChunk(b);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const v=this.b.peek(this.j.readLen),C=v.readUInt8(0),N=(C&128)>>>7,z=(C&64)>>>6,M=C&15,O=v.readUInt8(1),j=(O&128)>>>7,T=O&127;this.j.state=2,this.j.readLen=2+(j?4:0)+(T===126?2:0)+(T===127?8:0),this.j.fin=N,this.j.firstFrameOfMessage&&(this.j.compressed=!!z),this.j.firstFrameOfMessage=!!N,this.j.mask=0,this.j.opcode=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const v=this.b.read(this.j.readLen),C=v.readUInt8(1),N=(C&128)>>>7;let z=C&127,M=1;z===126?z=v.readUInt8(++M)*2**8+v.readUInt8(++M):z===127&&(z=v.readUInt8(++M)*0+v.readUInt8(++M)*0+v.readUInt8(++M)*0+v.readUInt8(++M)*0+v.readUInt8(++M)*2**24+v.readUInt8(++M)*2**16+v.readUInt8(++M)*2**8+v.readUInt8(++M));let O=0;N&&(O=v.readUInt8(++M)*2**24+v.readUInt8(++M)*2**16+v.readUInt8(++M)*2**8+v.readUInt8(++M)),this.j.state=3,this.j.readLen=z,this.j.mask=O,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const v=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",v),t(v,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",v),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(v,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(v,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await E.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Jh=i;class n extends m.$Rc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:R.$ce.alloc(0)}constructor(b,v,C,N,z,M){super(),this.n=b,this.r=z,this.s=M,this.a=this.B(new E.$Od),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new E.$Od),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new E.$Od),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,v?(this.b=this.B(new o(this.n,N,C,{windowBits:15})),this.f=this.B(new a(this.n,{windowBits:15})),this.B(this.b.onError(O=>this.a.fire(O))),this.B(this.f.onError(O=>this.a.fire(O)))):(this.b=null,this.f=null)}writeMessage(b,v){this.g.push({data:b,options:v}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:b,options:v}=this.g.shift();if(this.f&&v.compressed){const C=await this.w(this.f,b);this.s(C,v)}else this.s(b,{...v,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(b,v){return new Promise((C,N)=>{b.write(v),b.flush(z=>C(z))})}acceptFrame(b,v,C){this.h.push({data:b,isCompressed:v,isLastFrameOfMessage:C}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const b=this.h.shift();if(this.b&&b.isCompressed){const v=await this.C(this.b,b.data,b.isLastFrameOfMessage);this.r.fire(v)}else this.r.fire(b.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(b,v,C){return new Promise((N,z)=>{b.write(v),C&&b.write(R.$ce.fromByteArray([0,0,255,255])),b.flush(M=>N(M))})}}class o extends m.$Rc{get recordedInflateBytes(){return this.j?R.$ce.concat(this.f):R.$ce.alloc(0)}constructor(b,v,C,N){super(),this.h=b,this.j=v,this.a=this.B(new E.$Od),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,L.createInflateRaw)(N),this.b.on("error",z=>{this.h.traceSocketEvent("zlibInflateError",{message:z?.message,code:z?.code}),this.a.fire(z)}),this.b.on("data",z=>{this.h.traceSocketEvent("zlibInflateData",z),this.g.push(R.$ce.wrap(z))}),C&&(this.h.traceSocketEvent("zlibInflateInitialWrite",C.buffer),this.b.write(C.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(b){this.j&&this.f.push(b.clone()),this.h.traceSocketEvent("zlibInflateWrite",b),this.b.write(b.buffer)}flush(b){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const v=R.$ce.concat(this.g);this.g.length=0,b(v)})}}class a extends m.$Rc{constructor(b,v){super(),this.g=b,this.a=this.B(new E.$Od),this.onError=this.a.event,this.f=[],this.b=(0,L.createDeflateRaw)({windowBits:15}),this.b.on("error",C=>{this.g.traceSocketEvent("zlibDeflateError",{message:C?.message,code:C?.code}),this.a.fire(C)}),this.b.on("data",C=>{this.g.traceSocketEvent("zlibDeflateData",C),this.f.push(R.$ce.wrap(C))})}write(b){this.g.traceSocketEvent("zlibDeflateWrite",b.buffer),this.b.write(b.buffer)}flush(b){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let v=R.$ce.concat(this.f);this.f.length=0,v=v.slice(0,v.byteLength-4),b(v)})}}function t($,b){if(b===0)return;const v=$.byteLength>>>2;for(let j=0;j<v;j++){const T=$.readUInt32BE(j*4);$.writeUInt32BE(T^b,j*4)}const C=v*4,N=$.byteLength-C,z=b>>>24&255,M=b>>>16&255,O=b>>>8&255;N>=1&&$.writeUInt8($.readUInt8(C)^z,C),N>=2&&$.writeUInt8($.readUInt8(C+1)^M,C+1),N>=3&&$.writeUInt8($.readUInt8(C+2)^O,C+2)}e.$Kh=process.env.XDG_RUNTIME_DIR;const r={[2]:107,[1]:103};function d(){const $=(0,g.$fg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${$}-sock`;const b=process.platform!=="darwin"&&e.$Kh?e.$Kh:(0,f.tmpdir)(),v=(0,A.$ic)(b,`vscode-ipc-${$}.sock`);return l(v),v}e.$Lh=d;function u($,b,v){const C=(0,I.createHash)("md5").update($).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${C}-${v}-${b}-sock`;const N=v.substr(0,4),z=b.substr(0,6),M=C.substr(0,8);let O;return process.platform!=="darwin"&&e.$Kh&&!process.env.VSCODE_PORTABLE?O=(0,A.$ic)(e.$Kh,`vscode-${M}-${N}-${z}.sock`):O=(0,A.$ic)($,`${N}-${z}.sock`),l(O),O}e.$Mh=u;function l($){const b=r[P.$u];typeof b=="number"&&$.length>=b&&console.warn(`WARNING: IPC handle "${$}" is longer than ${b} chars, try a shorter --user-data-dir`)}class h extends y.$xh{static b(b){const v=E.Event.fromNodeEventEmitter(b,"connection");return E.Event.map(v,C=>({protocol:new S.$Eh(new w(C,"ipc-server-connection")),onDidClientDisconnect:E.Event.once(E.Event.fromNodeEventEmitter(C,"close"))}))}constructor(b){super(h.b(b)),this.d=b}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Nh=h;function k($){return new Promise((b,v)=>{const C=(0,F.createServer)();C.on("error",v),C.listen($,()=>{C.removeListener("error",v),b(new h(C))})})}e.$Oh=k;function D($,b){return new Promise((v,C)=>{const N=(0,F.createConnection)($,()=>{N.removeListener("error",C),v(S.$Fh.fromSocket(new w(N,`ipc-client${b}`),b))});N.once("error",C)})}e.$Ph=D}),define(ke[382],Se([1,0,62,63,166,120,10,3,12,44,15,138,258,259,109,88,22]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,S,w,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$08b=e.$98b=e.$88b=e.$78b=void 0;async function s(t,r,d,u,l){let h;for(let k=3;k&&(h?.dispose(),h=await new i(t,r,d,u,l).waitForReady(),!(l&&f.$ig[l]||!f.$ig[h.tunnelLocalPort]));k--);return h}class i extends p.$Rc{constructor(r,d,u,l,h){super(),this.m=d,this.n=h,this.privacy=w.TunnelPrivacyId.Private,this.j=new Map,this.a=r,this.b=I.createServer(),this.c=new R.$Tg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=k=>this.r(k),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=l,this.tunnelRemoteHost=u}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(d=>{d()})}async waitForReady(){const r=this.n??this.tunnelRemotePort,d=(0,w.$iv)(this.m)?"0.0.0.0":"127.0.0.1";let u=await(0,f.$jg)(r,2,1e3,d),l=null;return this.b.listen(u,this.m),await this.c.wait(),l=this.b.address(),l||(u=0,this.b.listen(u,this.m),await this.c.wait(),l=this.b.address()),this.tunnelLocalPort=l.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${l.port}`,this}async r(r){r.pause();const d=(0,w.$gv)(this.tunnelRemoteHost)||(0,w.$iv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,u=await(0,g.$0k)(this.a,d,this.tunnelRemotePort),l=u.getSocket(),h=u.readEntireBuffer();u.dispose(),h.byteLength>0&&r.write(h.buffer),r.on("end",()=>{r.localAddress&&this.j.delete(r.localAddress),l.end()}),r.on("close",()=>l.end()),r.on("error",()=>{r.localAddress&&this.j.delete(r.localAddress),l instanceof L.$Ih?l.socket.destroy():l.end()}),l instanceof L.$Ih?this.t(r,l):this.s(r,l),r.localAddress&&this.j.set(r.localAddress,()=>{r.end(),l.end()})}s(r,d){d.onClose(()=>r.destroy()),d.onEnd(()=>r.end()),d.onData(u=>r.write(u.buffer)),r.on("data",u=>d.write(c.$ce.wrap(u))),r.resume()}t(r,d){const u=d.socket;u.on("end",()=>r.end()),u.on("close",()=>r.end()),u.on("error",()=>{r.destroy()}),u.pipe(r),r.pipe(u)}}e.$78b=i;let n=class extends w.$lv{constructor(r,d,u,l,h){super(d,h),this.u=r,this.v=u,this.w=l}isPortPrivileged(r){return(0,w.$jv)(r,this.l,E.OS,F.release())}s(r,d,u,l,h,k,D,$){const b=this.r(d,u);if(b)return++b.refcount,b.value;if((0,w.$dv)(r))return this.t(r,d,u,h,k,D,$);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${d}:${u} on local port ${h}.`);const v={commit:this.w.commit,quality:this.w.quality,addressProvider:r,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},C=s(v,l,d,u,h);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(d,u,C),C}}};e.$88b=n,e.$88b=n=He([Be(0,y.$4k),Be(1,A.$bj),Be(2,S.$7k),Be(3,P.$tj),Be(4,m.$ni)],n);let o=class extends n{constructor(r,d,u,l,h){super(r,d,u,l,h)}};e.$98b=o,e.$98b=o=He([Be(0,y.$4k),Be(1,A.$bj),Be(2,S.$7k),Be(3,P.$tj),Be(4,m.$ni)],o);let a=class extends p.$Rc{constructor(r,d,u,l,h){super(),this.b=r,this.c=d,this.f=u,this.g=l,this.h=h,this.a=new Map}async openTunnel(r,d,u,l,h,k,D,$,b){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${u}:${l} on local port ${k}.`),!this.a.has(r)){const v=new o(this.b,this.c,this.g,this.f,this.h);this.B(v),this.a.set(r,v),v.onTunnelClosed(async()=>{(await v.tunnels).length===0&&(v.dispose(),this.a.delete(r))})}return this.a.get(r).openTunnel(d,u,l,h,k,D,$,b)}};e.$08b=a,e.$08b=a=He([Be(0,y.$4k),Be(1,A.$bj),Be(2,P.$tj),Be(3,S.$7k),Be(4,m.$ni)],a)}),define(ke[383],Se([1,0,120,278,55,35,2,15,40]),function($e,e,I,F,f,L,R,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZM=e.$YM=void 0;class m{constructor(g,y,S){this.b=g,this.c=y,this.f=S,this.a=F.createServer((w,c)=>this.h(w,c)),this.g().catch(w=>(y.error(w),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",g=>this.c.error(g))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(g,y){const S=(c,s)=>{y.writeHead(c,{"content-type":"application/json"}),y.end(JSON.stringify(s||null),i=>i&&this.c.error(i))},w=[];g.setEncoding("utf8"),g.on("data",c=>w.push(c)),g.on("end",async()=>{try{const c=JSON.parse(w.join(""));let s;switch(c.type){case"open":s=await this.i(c);break;case"openExternal":s=await this.j(c);break;case"status":s=await this.l(c);break;case"extensionManagement":s=await this.k(c);break;default:S(404,`Unknown message type: ${c.type}`);break}S(200,s)}catch(c){const s=c instanceof Error?c.message:JSON.stringify(c);S(500,s),this.c.error("Error while processing pipe request",c)}})}async i(g){const{fileURIs:y,folderURIs:S,forceNewWindow:w,diffMode:c,mergeMode:s,addMode:i,forceReuseWindow:n,gotoLineMode:o,waitMarkerFilePath:a,remoteAuthority:t}=g,r=[];if(Array.isArray(S))for(const h of S)try{r.push({folderUri:R.URI.parse(h)})}catch{}if(Array.isArray(y))for(const h of y)try{(0,E.$mi)(h)?r.push({workspaceUri:R.URI.parse(h)}):r.push({fileUri:R.URI.parse(h)})}catch{}const d=a?R.URI.file(a):void 0,l={forceNewWindow:w,diffMode:c,mergeMode:s,addMode:i,gotoLineMode:o,forceReuseWindow:n,preferNewWindow:!n&&!d&&!i,waitMarkerFileURI:d,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",r,l)}async j(g){for(const y of g.uris){const S=R.URI.parse(y),w=S.scheme==="file"?S:y;await this.b.executeCommand("_remoteCLI.openExternal",w)}}async k(g){const y=w=>w?.map(c=>/\.vsix$/i.test(c)?R.URI.parse(c):c),S={list:g.list,install:y(g.install),uninstall:y(g.uninstall),force:g.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",S)}async l(g){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&f.existsSync(this.f)&&f.unlinkSync(this.f)}}e.$YM=m;let A=class extends m{constructor(g,y){super(g,y,(0,I.$Lh)())}};e.$ZM=A,e.$ZM=A=He([Be(0,L.$TM),Be(1,p.$bj)],A)}),define(ke[384],Se([1,0,56,371,366,277,47,351,2,17,7,383,103,349,350]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kfc=void 0;class w extends f.$_ec{j(){const i=this,n=globalThis._VSCODE_NODE_MODULES.module,o=n._load;n._load=function(d,u,l){return d=t(d),i.a.has(d)?i.a.get(d).load(d,E.URI.file((0,g.$_p)(u.filename)),h=>o.apply(this,[h,u,l])):o.apply(this,arguments)};const a=n._resolveLookupPaths;n._resolveLookupPaths=(r,d)=>a.call(this,t(r),d);const t=r=>{for(const d of i.b){const u=d(r);if(u){r=u;break}}return r}}}class c extends R.$Kdc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Node}async tb(){this.h.createInstance(y.$Ifc);const i=this.h.invokeFunction(F.$8ec);if(this.h.createInstance(p.$Hfc),this.f.remote.isRemote&&this.f.remote.authority){const a=this.h.createInstance(P.$ZM);process.env.VSCODE_IPC_HOOK_CLI=a.ipcHandlePath}this.h.createInstance(S.$Jfc),await this.h.createInstance(w,i,{mine:this.J,all:this.L}).install(),I.mark("code/extHost/didInitAPI");const o=await this.m.getConfigProvider();await(0,L.$Gfc)(this.j,o,this,this.s,this.z,this.f),I.mark("code/extHost/didInitProxyResolver")}ub(i){return i.main}async vb(i,n,o){if(n.scheme!==m.Schemas.file)throw new Error(`Cannot load URI: '${n}', must be of file-scheme`);let a=null;o.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${n.toString(!0)}`),this.s.flush();const t=i?.identifier.value;i&&await this.w.initializeLocalizedMessages(i);try{t&&I.mark(`code/extHost/willLoadExtensionCode/${t}`),a=$e.__$__nodeRequire(n.fsPath)}finally{t&&I.mark(`code/extHost/didLoadExtensionCode/${t}`),o.codeLoadingStop()}return a}async $setRemoteEnvironment(i){if(this.f.remote.isRemote)for(const n in i){const o=i[n];o===null?delete process.env[n]:process.env[n]=o}}}e.$Kfc=c}),define(ke[385],Se([1,0,50,22,4,3,123,12,23,2,30,15,257,65,109,88,382,27,20,73,360]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,S,w,c,s,i,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sfc=e.$Rfc=e.$Qfc=e.$Pfc=e.$Ofc=e.$Nfc=e.$Mfc=e.$Lfc=void 0;function a(b){const v=b.trim().split(`
`),C=[];return v.forEach(z=>{const M=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(z);M&&M.length>=3&&C.push({pid:parseInt(M[1],10),socket:parseInt(M[2],10)})}),C.reduce((z,M)=>(z[M.socket]=M,z),{})}e.$Lfc=a;function t(...b){const v=[].concat(...b.map(d));return[...new Map(v.filter(C=>C.st==="0A").map(C=>{const N=C.local_address.split(":");return{socket:parseInt(C.inode,10),ip:r(N[0]),port:parseInt(N[1],16)}}).map(C=>[C.ip+":"+C.port,C])).values()]}e.$Mfc=t;function r(b){let v="";if(b.length===8)for(let C=b.length-2;C>=0;C-=2)v+=parseInt(b.substr(C,2),16),C!==0&&(v+=".");else for(let C=0;C<b.length;C+=8){const N=b.substring(C,C+8);let z="";for(let M=8;M>=2;M-=2)z+=N.substring(M-2,M),(M===6||M===2)&&(z=parseInt(z,16).toString(16),v+=`${z}`,z="",C+M!==b.length-6&&(v+=":"))}return v}e.$Nfc=r;function d(b){const v=b.trim().split(`
`),C=v.shift().trim().split(/\s+/).filter(z=>z!=="rx_queue"&&z!=="tm->when");return v.map(z=>z.trim().split(/\s+/).reduce((M,O,j)=>(M[C[j]||j]=O,M),{}))}e.$Ofc=d;function u(b){return!!b.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||b.indexOf("out/server-main.js")!==-1||b.indexOf("_productName=VSCode")!==-1}function l(b){const v=b.trim().split(`
`),C=[];return v.forEach(N=>{const z=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(N);z&&z.length>=4&&C.push({pid:parseInt(z[1],10),ppid:parseInt(z[2]),cmd:z[3]})}),C}e.$Pfc=l;async function h(b,v,C){const N=C.reduce((M,O)=>(M[O.pid]=O,M),{}),z=[];return b.forEach(({socket:M,ip:O,port:j})=>{const T=v[M]?v[M].pid:void 0,V=T?N[T]?.cmd:void 0;T&&V&&!u(V)&&z.push({host:O,port:j,detail:V,pid:T})}),z}e.$Qfc=h;function k(b,v,C){const N=new Map,z=l(v);for(const M of b){const O=C.get(M.port);if(O){N.set(M.port,O);continue}const j=z.find(T=>T.cmd.includes(`${M.port}`));if(j){let T=j,V;do V=z.find(q=>q.ppid===T.pid),V&&(T=V);while(V);N.set(M.port,{host:M.ip,port:M.port,pid:T.pid,detail:T.cmd,ppid:T.ppid})}else N.set(M.port,{host:M.ip,port:M.port,ppid:Number.MAX_VALUE})}return N}e.$Rfc=k;let D=class extends n.$Jwb{constructor(v,C,N,z){super(v,C,N),this.D=C,this.F=z,this.y=void 0,this.z=new Map,this.C=!1,p.$l&&C.remote.isRemote&&C.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(v){if(v&&this.C)return;this.C=v;let C;this.y&&(C=this.y,await this.a.$onFoundNewCandidates(this.y));const N=new R.$Vl;let z=0;for(;this.C;){const M=new Date().getTime(),O=(await this.I()).filter(V=>(0,w.$gv)(V.host)||(0,w.$iv)(V.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${O.map(V=>V.port).join(", ")}`);const j=new Date().getTime()-M;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${j} ms.`),z++>3&&N.update(j),(!C||JSON.stringify(C)!==JSON.stringify(O))&&(C=O,await this.a.$onFoundNewCandidates(C));const T=this.G(N.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${T} ms.`),await new Promise(V=>setTimeout(()=>V(),T))}}G(v){return Math.max(v*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(v=>v.port).join(", ")}`)}async I(){let v="",C="";try{v=await A.Promises.readFile("/proc/net/tcp","utf8"),C=await A.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const N=t(v,C),z=await new Promise(ee=>{(0,I.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(Y,X,ae)=>{ee(X)})}),M=a(z),O=await A.Promises.readdir("/proc"),j=[];for(const ee of O)try{const Y=Number(ee),X=E.$wg(m.URI.file("/proc"),ee);if((await A.Promises.stat(X.fsPath)).isDirectory()&&!isNaN(Y)){const Z=await A.Promises.readlink(E.$wg(X,"cwd").fsPath),se=await A.Promises.readFile(E.$wg(X,"cmdline").fsPath,"utf8");j.push({pid:Y,cwd:Z,cmd:se})}}catch{}const T=[],V=N.filter(ee=>{const Y=M[ee.socket];return Y||T.push(ee),Y}),q=h(V,M,j);let fe;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${T.length}`),T.length>0){const ee=await new Promise(Y=>{(0,I.exec)("ps -F -A -l | grep root",(X,ae,Z)=>{Y(ae)})});this.z=k(T,ee,this.z),fe=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${fe.map(Y=>Y.port).join(", ")}`)}return q.then(ee=>fe?ee.concat(fe):ee)}w(v){return async C=>{const N=new c.$78b({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(M,O,j,T){const V=await v.makeConnection();return $.connect(V,O,j,T)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new y.$Uk(0),connectionToken:v.connectionToken})}},signService:this.F},"localhost",C.remoteAddress.host||"localhost",C.remoteAddress.port,C.localAddressPort);await N.waitForReady();const z=new f.$Od;return{localAddress:(0,o.$SJ)(N.localAddress)??N.localAddress,remoteAddress:{port:N.tunnelRemotePort,host:N.tunnelRemoteHost},onDidDispose:z.event,dispose:()=>{N.dispose(),z.fire(),z.dispose()}}}}};e.$Sfc=D,e.$Sfc=D=He([Be(0,i.$xM),Be(1,s.$NM),Be(2,P.$bj),Be(3,S.$7k)],D);class $ extends g.$Zpb{static connect(v,C,N,z){const M=new L.$Qc,O={onClose:M.add(new f.$Od),onData:M.add(new f.$Od),onEnd:M.add(new f.$Od)};M.add(v.onDidReceiveMessage(T=>O.onData.fire(F.$ce.wrap(T)))),M.add(v.onDidEnd(()=>O.onEnd.fire())),M.add(v.onDidClose(T=>O.onClose.fire({type:0,error:T,hadError:!!T})));const j=new $(v,z,O);return j.B(M),(0,g.$Ypb)(j,C,N,z,O)}constructor(v,C,N){super(C,N),this.n=v}write(v){this.n.send(v.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(ke[386],Se([1,0,106,354,369,368,381,384,385,96,47,97,95,46,73,92,353,352,15,370,58,272,105,109,140]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,S,w,c,s,i,n,o,a,t,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,I.$Ar)(A.$Ldc,p.$Kfc,0),(0,I.$Ar)(i.$cj,s.$Ufc,1),(0,I.$Ar)(i.$bj,new t.$Qh(a.$$ec,[!1],!0)),(0,I.$Ar)(r.$7k,d.$_8b,1),(0,I.$Ar)(w.$wdc,c.$Tfc,0),(0,I.$Ar)(m.$jec,L.$lfc,0),(0,I.$Ar)(P.$tec,R.$Ffc,0),(0,I.$Ar)(g.$eec,f.$dfc,0),(0,I.$Ar)(y.$ydc,F.$cfc,0),(0,I.$Ar)(S.$Iwb,E.$Sfc,0),(0,I.$Ar)(o.$hec,n.$Vfc,0)}),define(ke[397],Se([1,0,62,398,56,11,83,120,255,114,367,22,30,103,10,133,279,293,372,386]),function($e,e,I,F,f,L,R,p,E,m,A,P,g,y,S,w,c,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let h=0;h<process.execArgv.length;h++)process.execArgv[h]==="--inspect-port=0"&&(process.execArgv.splice(h,1),h--)}();const i=F(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const l=globalThis._VSCODE_NODE_MODULES.module,h=l._load;l._load=function(k){if(k==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return h.apply(this,arguments)}})();const n=process.exit.bind(process);function o(l){process.exit=function(h){if(l)n(h);else{const k=new Error("An extension called process.exit() and this was prevented.");console.warn(k.stack)}},process.crash=function(){const h=new Error("An extension called process.crash() and this was prevented.");console.warn(h.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let a=function(l){n()};function t(){const l=(0,s.$Fm)(process.env);if(l.type===3)return new Promise((h,k)=>{const D=$=>{const b=$[0],v=new R.$Gh;b.on("message",C=>v.fire(P.$ce.wrap(C.data))),b.on("close",()=>{a("renderer closed the MessagePort")}),b.start(),h({onMessage:v.event,send:C=>b.postMessage(C.buffer)})};process.parentPort.on("message",$=>D($.ports))});if(l.type===2)return new Promise((h,k)=>{let D=null;const $=setTimeout(()=>{a("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),b=108e5,v=3e5,C=new S.$9g(()=>a("renderer disconnected for too long (1)"),b),N=new S.$9g(()=>a("renderer disconnected for too long (2)"),v);process.on("message",(M,O)=>{if(M&&M.type==="VSCODE_EXTHOST_IPC_SOCKET"){O.setNoDelay(!0);const j=P.$ce.wrap(Buffer.from(M.initialDataChunk,"base64"));let T;if(M.skipWebSocketFrames)T=new p.$Ih(O,"extHost-socket");else{const V=P.$ce.wrap(Buffer.from(M.inflateBytes,"base64"));T=new p.$Jh(new p.$Ih(O,"extHost-socket"),M.permessageDeflate,V,!1)}D?(C.cancel(),N.cancel(),D.beginAcceptReconnection(T,j),D.endAcceptReconnection(),D.sendResume()):(clearTimeout($),D=new R.$Hh({socket:T,initialChunk:j}),D.sendResume(),D.onDidDispose(()=>a("renderer disconnected")),h(D),D.onSocketClose(()=>{C.schedule()}))}if(M&&M.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(N.isScheduled())return;C.isScheduled()&&N.schedule()}});const z={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(z)});{const h=l.pipeName;return new Promise((k,D)=>{const $=I.createConnection(h,()=>{$.removeListener("error",D);const b=new R.$Hh({socket:new p.$Ih($,"extHost-renderer")});b.sendResume(),k(b)});$.once("error",D),$.on("close",()=>{a("renderer closed the socket")})})}}async function r(){const l=await t();return new class{constructor(){this.a=new R.$Gh,this.onMessage=this.a.event,this.b=!1,l.onMessage(h=>{(0,m.$gm)(h,2)?(this.b=!0,a("received terminate message from renderer")):this.a.fire(h)})}send(h){this.b||l.send(h)}async drain(){if(l.drain)return l.drain()}}}function d(l){return new Promise(h=>{const k=l.onMessage(D=>{k.dispose();const $=JSON.parse(D.toString()),b=$.commit,v=E.default.commit;if(b&&v&&b!==v&&n(55),$.parentPid){let C=0;setInterval(function(){try{process.kill($.parentPid,0),C=0}catch(z){z&&z.code==="EPERM"?(C++,C>=3&&a(`parent process ${$.parentPid} does not exist anymore (3 x EPERM): ${z.message} (code: ${z.code}) (errno: ${z.errno})`)):a(`parent process ${$.parentPid} does not exist anymore: ${z.message} (code: ${z.code}) (errno: ${z.errno})`)}},1e3);let N;try{N=globalThis._VSCODE_NODE_MODULES["native-watchdog"],N.start($.parentPid)}catch(z){(0,L.$Z)(z)}}l.send((0,m.$fm)(0)),h({protocol:l,initData:$})});l.send((0,m.$fm)(1))})}async function u(){const l=[];process.on("unhandledRejection",(C,N)=>{l.push(N),setTimeout(()=>{const z=l.indexOf(N);z>=0&&N.catch(M=>{l.splice(z,1),(0,L.$3)(M)||(console.warn(`rejected promise not handled within 1 second: ${M}`),M&&M.stack&&console.warn(`stack trace: ${M.stack}`),C&&(0,L.$Z)(C))})},1e3)}),process.on("rejectionHandled",C=>{const N=l.indexOf(C);N>=0&&l.splice(N,1)}),process.on("uncaughtException",function(C){(0,L.$Y)(C)||(0,L.$Z)(C)}),f.mark("code/extHost/willConnectToRenderer");const h=await r();f.mark("code/extHost/didConnectToRenderer");const k=await d(h);f.mark("code/extHost/didWaitForInitData");const{initData:D}=k;o(!!D.environment.extensionTestsLocationURI),D.environment.useHostProxy=i.useHostProxy!==void 0?i.useHostProxy!=="false":void 0,D.environment.skipWorkspaceStorageLock=(0,w.boolean)(i.skipWorkspaceStorageLock,!1);const $=new class{constructor(){this.pid=process.pid}exit(N){n(N)}fsExists(N){return g.Promises.exists(N)}fsRealpath(N){return(0,y.$$p)(N)}};let b=null;D.remote.authority&&i.transformURIs&&(b=(0,c.$Er)(D.remote.authority));const v=new A.$bfc(k.protocol,D,$,b);a=C=>v.terminate(C)}u().catch(l=>console.log(l))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/072c6b950b8822560c55eff1474c30951e2ab9c9/core/vs/workbench/api/node/extensionHostProcess.js.map
