/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ae=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/errors","vs/base/common/async","vs/base/common/strings","vs/base/common/network","vs/platform/log/common/log","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/base/common/cancellation","vs/base/common/platform","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/base/common/severity","vs/workbench/api/common/extHostCommands","vs/base/common/glob","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/lazy","vs/base/common/themables","vs/base/common/extpath","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/stopwatch","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/base/common/htmlContent","vs/platform/progress/common/progress","vs/base/common/assert","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/core/position","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/base/common/arraysFind","vs/workbench/api/worker/extensionHostWorker"],Re=function(pe){for(var e=[],E=0,L=pe.length;E<L;E++)e[E]=Ae[pe[E]];return e};define(Ae[67],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nh=e.$mh=e.$lh=void 0;function E(R){return($,D,g)=>{let A=null,S=null;if(typeof g.value=="function"?(A="value",S=g.value):typeof g.get=="function"&&(A="get",S=g.get),!S)throw new Error("not supported");g[A]=R(S,D)}}function L(R,$,D){let g=null,A=null;if(typeof D.value=="function"?(g="value",A=D.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof D.get=="function"&&(g="get",A=D.get),!A)throw new Error("not supported");const S=`$memoize$${$}`;D[g]=function(...o){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,o)}),this[S]}}e.$lh=L;function P(R,$,D){return E((g,A)=>{const S=`$debounce$${A}`,o=`$debounce$result$${A}`;return function(...v){this[o]||(this[o]=D?D():void 0),clearTimeout(this[S]),$&&(this[o]=$(this[o],...v),v=[this[o]]),this[S]=setTimeout(()=>{g.apply(this,v),this[o]=D?D():void 0},R)}})}e.$mh=P;function M(R,$,D){return E((g,A)=>{const S=`$throttle$timer$${A}`,o=`$throttle$result$${A}`,v=`$throttle$lastRun$${A}`,p=`$throttle$pending$${A}`;return function(...f){if(this[o]||(this[o]=D?D():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),$&&(this[o]=$(this[o],...f)),this[p])return;const t=this[v]+R;t<=Date.now()?(this[v]=Date.now(),g.apply(this,[this[o]]),this[o]=D?D():void 0):(this[p]=!0,this[S]=setTimeout(()=>{this[p]=!1,this[v]=Date.now(),g.apply(this,[this[o]]),this[o]=D?D():void 0},t-Date.now()))}})}e.$nh=M}),define(Ae[89],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DM=e.$CM=void 0;class E{constructor(P){this.a=P,this.b=0}nextId(){return this.a+ ++this.b}}e.$CM=E,e.$DM=new E("id#")}),define(Ae[119],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var E;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(E||(e.ScanError=E={}));var L;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(L||(e.SyntaxKind=L={}));var P;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(P||(e.ParseErrorCode=P={}));var M;(function(r){r.DEFAULT={allowTrailingComma:!0}})(M||(e.ParseOptions=M={}));function R(r,s=!1){let c=0;const h=r.length;let w="",m=0,I=16,k=0;function d(z){let F=0,N=0;for(;F<z;){const x=r.charCodeAt(c);if(x>=48&&x<=57)N=N*16+x-48;else if(x>=65&&x<=70)N=N*16+x-65+10;else if(x>=97&&x<=102)N=N*16+x-97+10;else break;c++,F++}return F<z&&(N=-1),N}function b(z){c=z,w="",m=0,I=16,k=0}function y(){const z=c;if(r.charCodeAt(c)===48)c++;else for(c++;c<r.length&&g(r.charCodeAt(c));)c++;if(c<r.length&&r.charCodeAt(c)===46)if(c++,c<r.length&&g(r.charCodeAt(c)))for(c++;c<r.length&&g(r.charCodeAt(c));)c++;else return k=3,r.substring(z,c);let F=c;if(c<r.length&&(r.charCodeAt(c)===69||r.charCodeAt(c)===101))if(c++,(c<r.length&&r.charCodeAt(c)===43||r.charCodeAt(c)===45)&&c++,c<r.length&&g(r.charCodeAt(c))){for(c++;c<r.length&&g(r.charCodeAt(c));)c++;F=c}else k=3;return r.substring(z,F)}function C(){let z="",F=c;for(;;){if(c>=h){z+=r.substring(F,c),k=2;break}const N=r.charCodeAt(c);if(N===34){z+=r.substring(F,c),c++;break}if(N===92){if(z+=r.substring(F,c),c++,c>=h){k=2;break}switch(r.charCodeAt(c++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:{const J=d(4);J>=0?z+=String.fromCharCode(J):k=4;break}default:k=5}F=c;continue}if(N>=0&&N<=31)if(D(N)){z+=r.substring(F,c),k=2;break}else k=6;c++}return z}function B(){if(w="",k=0,m=c,c>=h)return m=h,I=17;let z=r.charCodeAt(c);if($(z)){do c++,w+=String.fromCharCode(z),z=r.charCodeAt(c);while($(z));return I=15}if(D(z))return c++,w+=String.fromCharCode(z),z===13&&r.charCodeAt(c)===10&&(c++,w+=`
`),I=14;switch(z){case 123:return c++,I=1;case 125:return c++,I=2;case 91:return c++,I=3;case 93:return c++,I=4;case 58:return c++,I=6;case 44:return c++,I=5;case 34:return c++,w=C(),I=10;case 47:{const F=c-1;if(r.charCodeAt(c+1)===47){for(c+=2;c<h&&!D(r.charCodeAt(c));)c++;return w=r.substring(F,c),I=12}if(r.charCodeAt(c+1)===42){c+=2;const N=h-1;let x=!1;for(;c<N;){if(r.charCodeAt(c)===42&&r.charCodeAt(c+1)===47){c+=2,x=!0;break}c++}return x||(c++,k=1),w=r.substring(F,c),I=13}return w+=String.fromCharCode(z),c++,I=16}case 45:if(w+=String.fromCharCode(z),c++,c===h||!g(r.charCodeAt(c)))return I=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return w+=y(),I=11;default:for(;c<h&&H(z);)c++,z=r.charCodeAt(c);if(m!==c){switch(w=r.substring(m,c),w){case"true":return I=8;case"false":return I=9;case"null":return I=7}return I=16}return w+=String.fromCharCode(z),c++,I=16}}function H(z){if($(z)||D(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function U(){let z;do z=B();while(z>=12&&z<=15);return z}return{setPosition:b,getPosition:()=>c,scan:s?U:B,getToken:()=>I,getTokenValue:()=>w,getTokenOffset:()=>m,getTokenLength:()=>c-m,getTokenError:()=>k}}e.$Ym=R;function $(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function D(r){return r===10||r===13||r===8232||r===8233}function g(r){return r>=48&&r<=57}var A;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(A||(A={}));function S(r,s){const c=[],h=new Object;let w;const m={value:{},offset:0,length:0,type:"object",parent:void 0};let I=!1;function k(d,b,y,C){m.value=d,m.offset=b,m.length=y,m.type=C,m.colonOffset=void 0,w=m}try{u(r,{onObjectBegin:(d,b)=>{if(s<=d)throw h;w=void 0,I=s>d,c.push("")},onObjectProperty:(d,b,y)=>{if(s<b||(k(d,b,y,"property"),c[c.length-1]=d,s<=b+y))throw h},onObjectEnd:(d,b)=>{if(s<=d)throw h;w=void 0,c.pop()},onArrayBegin:(d,b)=>{if(s<=d)throw h;w=void 0,c.push(0)},onArrayEnd:(d,b)=>{if(s<=d)throw h;w=void 0,c.pop()},onLiteralValue:(d,b,y)=>{if(s<b||(k(d,b,y,l(d)),s<=b+y))throw h},onSeparator:(d,b,y)=>{if(s<=b)throw h;if(d===":"&&w&&w.type==="property")w.colonOffset=b,I=!1,w=void 0;else if(d===","){const C=c[c.length-1];typeof C=="number"?c[c.length-1]=C+1:(I=!0,c[c.length-1]=""),w=void 0}}})}catch(d){if(d!==h)throw d}return{path:c,previousNode:w,isAtPropertyKey:I,matches:d=>{let b=0;for(let y=0;b<d.length&&y<c.length;y++)if(d[b]===c[y]||d[b]==="*")b++;else if(d[b]!=="**")return!1;return b===d.length}}}e.$Zm=S;function o(r,s=[],c=M.DEFAULT){let h=null,w=[];const m=[];function I(d){Array.isArray(w)?w.push(d):h!==null&&(w[h]=d)}return u(r,{onObjectBegin:()=>{const d={};I(d),m.push(w),w=d,h=null},onObjectProperty:d=>{h=d},onObjectEnd:()=>{w=m.pop()},onArrayBegin:()=>{const d=[];I(d),m.push(w),w=d,h=null},onArrayEnd:()=>{w=m.pop()},onLiteralValue:I,onError:(d,b,y)=>{s.push({error:d,offset:b,length:y})}},c),w[0]}e.$1m=o;function v(r,s=[],c=M.DEFAULT){let h={type:"array",offset:-1,length:-1,children:[],parent:void 0};function w(d){h.type==="property"&&(h.length=d-h.offset,h=h.parent)}function m(d){return h.children.push(d),d}u(r,{onObjectBegin:d=>{h=m({type:"object",offset:d,length:-1,parent:h,children:[]})},onObjectProperty:(d,b,y)=>{h=m({type:"property",offset:b,length:-1,parent:h,children:[]}),h.children.push({type:"string",value:d,offset:b,length:y,parent:h})},onObjectEnd:(d,b)=>{h.length=d+b-h.offset,h=h.parent,w(d+b)},onArrayBegin:(d,b)=>{h=m({type:"array",offset:d,length:-1,parent:h,children:[]})},onArrayEnd:(d,b)=>{h.length=d+b-h.offset,h=h.parent,w(d+b)},onLiteralValue:(d,b,y)=>{m({type:l(d),offset:b,length:y,parent:h,value:d}),w(b+y)},onSeparator:(d,b,y)=>{h.type==="property"&&(d===":"?h.colonOffset=b:d===","&&w(b))},onError:(d,b,y)=>{s.push({error:d,offset:b,length:y})}},c);const k=h.children[0];return k&&delete k.parent,k}e.$2m=v;function p(r,s){if(!r)return;let c=r;for(const h of s)if(typeof h=="string"){if(c.type!=="object"||!Array.isArray(c.children))return;let w=!1;for(const m of c.children)if(Array.isArray(m.children)&&m.children[0].value===h){c=m.children[1],w=!0;break}if(!w)return}else{const w=h;if(c.type!=="array"||w<0||!Array.isArray(c.children)||w>=c.children.length)return;c=c.children[w]}return c}e.$3m=p;function f(r){if(!r.parent||!r.parent.children)return[];const s=f(r.parent);if(r.parent.type==="property"){const c=r.parent.children[0].value;s.push(c)}else if(r.parent.type==="array"){const c=r.parent.children.indexOf(r);c!==-1&&s.push(c)}return s}e.$4m=f;function t(r){switch(r.type){case"array":return r.children.map(t);case"object":{const s=Object.create(null);for(const c of r.children){const h=c.children[1];h&&(s[c.children[0].value]=t(h))}return s}case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.$5m=t;function i(r,s,c=!1){return s>=r.offset&&s<r.offset+r.length||c&&s===r.offset+r.length}e.$6m=i;function n(r,s,c=!1){if(i(r,s,c)){const h=r.children;if(Array.isArray(h))for(let w=0;w<h.length&&h[w].offset<=s;w++){const m=n(h[w],s,c);if(m)return m}return r}}e.$7m=n;function u(r,s,c=M.DEFAULT){const h=R(r,!1);function w(re){return re?()=>re(h.getTokenOffset(),h.getTokenLength()):()=>!0}function m(re){return re?oe=>re(oe,h.getTokenOffset(),h.getTokenLength()):()=>!0}const I=w(s.onObjectBegin),k=m(s.onObjectProperty),d=w(s.onObjectEnd),b=w(s.onArrayBegin),y=w(s.onArrayEnd),C=m(s.onLiteralValue),B=m(s.onSeparator),H=w(s.onComment),U=m(s.onError),z=c&&c.disallowComments,F=c&&c.allowTrailingComma;function N(){for(;;){const re=h.scan();switch(h.getTokenError()){case 4:x(14);break;case 5:x(15);break;case 3:x(13);break;case 1:z||x(11);break;case 2:x(12);break;case 6:x(16);break}switch(re){case 12:case 13:z?x(10):H();break;case 16:x(1);break;case 15:case 14:break;default:return re}}}function x(re,oe=[],ve=[]){if(U(re),oe.length+ve.length>0){let ee=h.getToken();for(;ee!==17;){if(oe.indexOf(ee)!==-1){N();break}else if(ve.indexOf(ee)!==-1)break;ee=N()}}}function J(re){const oe=h.getTokenValue();return re?C(oe):k(oe),N(),!0}function ye(){switch(h.getToken()){case 11:{let re=0;try{re=JSON.parse(h.getTokenValue()),typeof re!="number"&&(x(2),re=0)}catch{x(2)}C(re);break}case 7:C(null);break;case 8:C(!0);break;case 9:C(!1);break;default:return!1}return N(),!0}function De(){return h.getToken()!==10?(x(3,[],[2,5]),!1):(J(!1),h.getToken()===6?(B(":"),N(),we()||x(4,[],[2,5])):x(5,[],[2,5]),!0)}function Ce(){I(),N();let re=!1;for(;h.getToken()!==2&&h.getToken()!==17;){if(h.getToken()===5){if(re||x(4,[],[]),B(","),N(),h.getToken()===2&&F)break}else re&&x(6,[],[]);De()||x(4,[],[2,5]),re=!0}return d(),h.getToken()!==2?x(7,[2],[]):N(),!0}function ge(){b(),N();let re=!1;for(;h.getToken()!==4&&h.getToken()!==17;){if(h.getToken()===5){if(re||x(4,[],[]),B(","),N(),h.getToken()===4&&F)break}else re&&x(6,[],[]);we()||x(4,[],[4,5]),re=!0}return y(),h.getToken()!==4?x(8,[4],[]):N(),!0}function we(){switch(h.getToken()){case 3:return ge();case 1:return Ce();case 10:return J(!0);default:return ye()}}return N(),h.getToken()===17?c.allowEmptyContent?!0:(x(4,[],[]),!1):we()?(h.getToken()!==17&&x(9,[],[]),!0):(x(4,[],[]),!1)}e.$8m=u;function a(r,s){const c=R(r),h=[];let w,m=0,I;do switch(I=c.getPosition(),w=c.scan(),w){case 12:case 13:case 17:m!==I&&h.push(r.substring(m,I)),s!==void 0&&h.push(c.getTokenValue().replace(/[^\r\n]/g,s)),m=c.getPosition();break}while(w!==17);return h.join("")}e.$9m=a;function l(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.$0m=l}),function(pe,e){typeof define=="function"&&define.amd?define(Ae[120],Re([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(pe=typeof globalThis<"u"?globalThis:pe||self,e(pe.marked={}))}(this,function(pe){"use strict";function e(te,se){for(var me=0;me<se.length;me++){var Z=se[me];Z.enumerable=Z.enumerable||!1,Z.configurable=!0,"value"in Z&&(Z.writable=!0),Object.defineProperty(te,Z.key,Z)}}function E(te,se,me){return se&&e(te.prototype,se),me&&e(te,me),Object.defineProperty(te,"prototype",{writable:!1}),te}function L(te,se){if(te){if(typeof te=="string")return P(te,se);var me=Object.prototype.toString.call(te).slice(8,-1);if(me==="Object"&&te.constructor&&(me=te.constructor.name),me==="Map"||me==="Set")return Array.from(te);if(me==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(me))return P(te,se)}}function P(te,se){(se==null||se>te.length)&&(se=te.length);for(var me=0,Z=new Array(se);me<se;me++)Z[me]=te[me];return Z}function M(te,se){var me=typeof Symbol<"u"&&te[Symbol.iterator]||te["@@iterator"];if(me)return(me=me.call(te)).next.bind(me);if(Array.isArray(te)||(me=L(te))||se&&te&&typeof te.length=="number"){me&&(te=me);var Z=0;return function(){return Z>=te.length?{done:!0}:{done:!1,value:te[Z++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}pe.defaults=R();function $(te){pe.defaults=te}var D=/[&<>"']/,g=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,S=/[<>"']|&(?!#?\w+;)/g,o={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},v=function(se){return o[se]};function p(te,se){if(se){if(D.test(te))return te.replace(g,v)}else if(A.test(te))return te.replace(S,v);return te}var f=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function t(te){return te.replace(f,function(se,me){return me=me.toLowerCase(),me==="colon"?":":me.charAt(0)==="#"?me.charAt(1)==="x"?String.fromCharCode(parseInt(me.substring(2),16)):String.fromCharCode(+me.substring(1)):""})}var i=/(^|[^\[])\^/g;function n(te,se){te=typeof te=="string"?te:te.source,se=se||"";var me={replace:function(le,ne){return ne=ne.source||ne,ne=ne.replace(i,"$1"),te=te.replace(le,ne),me},getRegex:function(){return new RegExp(te,se)}};return me}var u=/[^\w:]/g,a=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function l(te,se,me){if(te){var Z;try{Z=decodeURIComponent(t(me)).replace(u,"").toLowerCase()}catch{return null}if(Z.indexOf("javascript:")===0||Z.indexOf("vbscript:")===0||Z.indexOf("data:")===0)return null}se&&!a.test(me)&&(me=w(se,me));try{me=encodeURI(me).replace(/%25/g,"%")}catch{return null}return me}var r={},s=/^[^:]+:\/*[^/]*$/,c=/^([^:]+:)[\s\S]*$/,h=/^([^:]+:\/*[^/]*)[\s\S]*$/;function w(te,se){r[" "+te]||(s.test(te)?r[" "+te]=te+"/":r[" "+te]=d(te,"/",!0)),te=r[" "+te];var me=te.indexOf(":")===-1;return se.substring(0,2)==="//"?me?se:te.replace(c,"$1")+se:se.charAt(0)==="/"?me?se:te.replace(h,"$1")+se:te+se}var m={exec:function(){}};function I(te){for(var se=1,me,Z;se<arguments.length;se++){me=arguments[se];for(Z in me)Object.prototype.hasOwnProperty.call(me,Z)&&(te[Z]=me[Z])}return te}function k(te,se){var me=te.replace(/\|/g,function(ne,ae,de){for(var Ie=!1,T=ae;--T>=0&&de[T]==="\\";)Ie=!Ie;return Ie?"|":" |"}),Z=me.split(/ \|/),le=0;if(Z[0].trim()||Z.shift(),Z.length>0&&!Z[Z.length-1].trim()&&Z.pop(),Z.length>se)Z.splice(se);else for(;Z.length<se;)Z.push("");for(;le<Z.length;le++)Z[le]=Z[le].trim().replace(/\\\|/g,"|");return Z}function d(te,se,me){var Z=te.length;if(Z===0)return"";for(var le=0;le<Z;){var ne=te.charAt(Z-le-1);if(ne===se&&!me)le++;else if(ne!==se&&me)le++;else break}return te.slice(0,Z-le)}function b(te,se){if(te.indexOf(se[1])===-1)return-1;for(var me=te.length,Z=0,le=0;le<me;le++)if(te[le]==="\\")le++;else if(te[le]===se[0])Z++;else if(te[le]===se[1]&&(Z--,Z<0))return le;return-1}function y(te){te&&te.sanitize&&!te.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function C(te,se){if(se<1)return"";for(var me="";se>1;)se&1&&(me+=te),se>>=1,te+=te;return me+te}function B(te,se,me,Z){var le=se.href,ne=se.title?p(se.title):null,ae=te[1].replace(/\\([\[\]])/g,"$1");if(te[0].charAt(0)!=="!"){Z.state.inLink=!0;var de={type:"link",raw:me,href:le,title:ne,text:ae,tokens:Z.inlineTokens(ae)};return Z.state.inLink=!1,de}return{type:"image",raw:me,href:le,title:ne,text:p(ae)}}function H(te,se){var me=te.match(/^(\s+)(?:```)/);if(me===null)return se;var Z=me[1];return se.split(`
`).map(function(le){var ne=le.match(/^\s+/);if(ne===null)return le;var ae=ne[0];return ae.length>=Z.length?le.slice(Z.length):le}).join(`
`)}var U=function(){function te(me){this.options=me||pe.defaults}var se=te.prototype;return se.space=function(Z){var le=this.rules.block.newline.exec(Z);if(le&&le[0].length>0)return{type:"space",raw:le[0]}},se.code=function(Z){var le=this.rules.block.code.exec(Z);if(le){var ne=le[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:le[0],codeBlockStyle:"indented",text:this.options.pedantic?ne:d(ne,`
`)}}},se.fences=function(Z){var le=this.rules.block.fences.exec(Z);if(le){var ne=le[0],ae=H(ne,le[3]||"");return{type:"code",raw:ne,lang:le[2]?le[2].trim():le[2],text:ae}}},se.heading=function(Z){var le=this.rules.block.heading.exec(Z);if(le){var ne=le[2].trim();if(/#$/.test(ne)){var ae=d(ne,"#");(this.options.pedantic||!ae||/ $/.test(ae))&&(ne=ae.trim())}return{type:"heading",raw:le[0],depth:le[1].length,text:ne,tokens:this.lexer.inline(ne)}}},se.hr=function(Z){var le=this.rules.block.hr.exec(Z);if(le)return{type:"hr",raw:le[0]}},se.blockquote=function(Z){var le=this.rules.block.blockquote.exec(Z);if(le){var ne=le[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:le[0],tokens:this.lexer.blockTokens(ne,[]),text:ne}}},se.list=function(Z){var le=this.rules.block.list.exec(Z);if(le){var ne,ae,de,Ie,T,V,G,Q,q,_,he,Oe,je=le[1].trim(),Qe=je.length>1,Ge={type:"list",raw:"",ordered:Qe,start:Qe?+je.slice(0,-1):"",loose:!1,items:[]};je=Qe?"\\d{1,9}\\"+je.slice(-1):"\\"+je,this.options.pedantic&&(je=Qe?je:"[*+-]");for(var _e=new RegExp("^( {0,3}"+je+")((?:[	 ][^\\n]*)?(?:\\n|$))");Z&&(Oe=!1,!(!(le=_e.exec(Z))||this.rules.block.hr.test(Z)));){if(ne=le[0],Z=Z.substring(ne.length),Q=le[2].split(`
`,1)[0],q=Z.split(`
`,1)[0],this.options.pedantic?(Ie=2,he=Q.trimLeft()):(Ie=le[2].search(/[^ ]/),Ie=Ie>4?1:Ie,he=Q.slice(Ie),Ie+=le[1].length),V=!1,!Q&&/^ *$/.test(q)&&(ne+=q+`
`,Z=Z.substring(q.length+1),Oe=!0),!Oe)for(var Ye=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),xe=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),it=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:```|~~~)"),tt=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}#");Z&&(_=Z.split(`
`,1)[0],Q=_,this.options.pedantic&&(Q=Q.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(it.test(Q)||tt.test(Q)||Ye.test(Q)||xe.test(Z)));){if(Q.search(/[^ ]/)>=Ie||!Q.trim())he+=`
`+Q.slice(Ie);else if(!V)he+=`
`+Q;else break;!V&&!Q.trim()&&(V=!0),ne+=_+`
`,Z=Z.substring(_.length+1)}Ge.loose||(G?Ge.loose=!0:/\n *\n *$/.test(ne)&&(G=!0)),this.options.gfm&&(ae=/^\[[ xX]\] /.exec(he),ae&&(de=ae[0]!=="[ ] ",he=he.replace(/^\[[ xX]\] +/,""))),Ge.items.push({type:"list_item",raw:ne,task:!!ae,checked:de,loose:!1,text:he}),Ge.raw+=ne}Ge.items[Ge.items.length-1].raw=ne.trimRight(),Ge.items[Ge.items.length-1].text=he.trimRight(),Ge.raw=Ge.raw.trimRight();var ze=Ge.items.length;for(T=0;T<ze;T++){this.lexer.state.top=!1,Ge.items[T].tokens=this.lexer.blockTokens(Ge.items[T].text,[]);var ut=Ge.items[T].tokens.filter(function(X){return X.type==="space"}),Y=ut.every(function(X){for(var be=X.raw.split(""),Be=0,Ne=M(be),Xe;!(Xe=Ne()).done;){var nt=Xe.value;if(nt===`
`&&(Be+=1),Be>1)return!0}return!1});!Ge.loose&&ut.length&&Y&&(Ge.loose=!0,Ge.items[T].loose=!0)}return Ge}},se.html=function(Z){var le=this.rules.block.html.exec(Z);if(le){var ne={type:"html",raw:le[0],pre:!this.options.sanitizer&&(le[1]==="pre"||le[1]==="script"||le[1]==="style"),text:le[0]};if(this.options.sanitize){var ae=this.options.sanitizer?this.options.sanitizer(le[0]):p(le[0]);ne.type="paragraph",ne.text=ae,ne.tokens=this.lexer.inline(ae)}return ne}},se.def=function(Z){var le=this.rules.block.def.exec(Z);if(le){le[3]&&(le[3]=le[3].substring(1,le[3].length-1));var ne=le[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ne,raw:le[0],href:le[2],title:le[3]}}},se.table=function(Z){var le=this.rules.block.table.exec(Z);if(le){var ne={type:"table",header:k(le[1]).map(function(G){return{text:G}}),align:le[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:le[3]&&le[3].trim()?le[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ne.header.length===ne.align.length){ne.raw=le[0];var ae=ne.align.length,de,Ie,T,V;for(de=0;de<ae;de++)/^ *-+: *$/.test(ne.align[de])?ne.align[de]="right":/^ *:-+: *$/.test(ne.align[de])?ne.align[de]="center":/^ *:-+ *$/.test(ne.align[de])?ne.align[de]="left":ne.align[de]=null;for(ae=ne.rows.length,de=0;de<ae;de++)ne.rows[de]=k(ne.rows[de],ne.header.length).map(function(G){return{text:G}});for(ae=ne.header.length,Ie=0;Ie<ae;Ie++)ne.header[Ie].tokens=this.lexer.inline(ne.header[Ie].text);for(ae=ne.rows.length,Ie=0;Ie<ae;Ie++)for(V=ne.rows[Ie],T=0;T<V.length;T++)V[T].tokens=this.lexer.inline(V[T].text);return ne}}},se.lheading=function(Z){var le=this.rules.block.lheading.exec(Z);if(le)return{type:"heading",raw:le[0],depth:le[2].charAt(0)==="="?1:2,text:le[1],tokens:this.lexer.inline(le[1])}},se.paragraph=function(Z){var le=this.rules.block.paragraph.exec(Z);if(le){var ne=le[1].charAt(le[1].length-1)===`
`?le[1].slice(0,-1):le[1];return{type:"paragraph",raw:le[0],text:ne,tokens:this.lexer.inline(ne)}}},se.text=function(Z){var le=this.rules.block.text.exec(Z);if(le)return{type:"text",raw:le[0],text:le[0],tokens:this.lexer.inline(le[0])}},se.escape=function(Z){var le=this.rules.inline.escape.exec(Z);if(le)return{type:"escape",raw:le[0],text:p(le[1])}},se.tag=function(Z){var le=this.rules.inline.tag.exec(Z);if(le)return!this.lexer.state.inLink&&/^<a /i.test(le[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(le[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(le[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(le[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:le[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):p(le[0]):le[0]}},se.link=function(Z){var le=this.rules.inline.link.exec(Z);if(le){var ne=le[2].trim();if(!this.options.pedantic&&/^</.test(ne)){if(!/>$/.test(ne))return;var ae=d(ne.slice(0,-1),"\\");if((ne.length-ae.length)%2===0)return}else{var de=b(le[2],"()");if(de>-1){var Ie=le[0].indexOf("!")===0?5:4,T=Ie+le[1].length+de;le[2]=le[2].substring(0,de),le[0]=le[0].substring(0,T).trim(),le[3]=""}}var V=le[2],G="";if(this.options.pedantic){var Q=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(V);Q&&(V=Q[1],G=Q[3])}else G=le[3]?le[3].slice(1,-1):"";return V=V.trim(),/^</.test(V)&&(this.options.pedantic&&!/>$/.test(ne)?V=V.slice(1):V=V.slice(1,-1)),B(le,{href:V&&V.replace(this.rules.inline._escapes,"$1"),title:G&&G.replace(this.rules.inline._escapes,"$1")},le[0],this.lexer)}},se.reflink=function(Z,le){var ne;if((ne=this.rules.inline.reflink.exec(Z))||(ne=this.rules.inline.nolink.exec(Z))){var ae=(ne[2]||ne[1]).replace(/\s+/g," ");if(ae=le[ae.toLowerCase()],!ae||!ae.href){var de=ne[0].charAt(0);return{type:"text",raw:de,text:de}}return B(ne,ae,ne[0],this.lexer)}},se.emStrong=function(Z,le,ne){ne===void 0&&(ne="");var ae=this.rules.inline.emStrong.lDelim.exec(Z);if(ae&&!(ae[3]&&ne.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var de=ae[1]||ae[2]||"";if(!de||de&&(ne===""||this.rules.inline.punctuation.exec(ne))){var Ie=ae[0].length-1,T,V,G=Ie,Q=0,q=ae[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(q.lastIndex=0,le=le.slice(-1*Z.length+Ie);(ae=q.exec(le))!=null;)if(T=ae[1]||ae[2]||ae[3]||ae[4]||ae[5]||ae[6],!!T){if(V=T.length,ae[3]||ae[4]){G+=V;continue}else if((ae[5]||ae[6])&&Ie%3&&!((Ie+V)%3)){Q+=V;continue}if(G-=V,!(G>0)){if(V=Math.min(V,V+G+Q),Math.min(Ie,V)%2){var _=Z.slice(1,Ie+ae.index+V);return{type:"em",raw:Z.slice(0,Ie+ae.index+V+1),text:_,tokens:this.lexer.inlineTokens(_)}}var he=Z.slice(2,Ie+ae.index+V-1);return{type:"strong",raw:Z.slice(0,Ie+ae.index+V+1),text:he,tokens:this.lexer.inlineTokens(he)}}}}}},se.codespan=function(Z){var le=this.rules.inline.code.exec(Z);if(le){var ne=le[2].replace(/\n/g," "),ae=/[^ ]/.test(ne),de=/^ /.test(ne)&&/ $/.test(ne);return ae&&de&&(ne=ne.substring(1,ne.length-1)),ne=p(ne,!0),{type:"codespan",raw:le[0],text:ne}}},se.br=function(Z){var le=this.rules.inline.br.exec(Z);if(le)return{type:"br",raw:le[0]}},se.del=function(Z){var le=this.rules.inline.del.exec(Z);if(le)return{type:"del",raw:le[0],text:le[2],tokens:this.lexer.inlineTokens(le[2])}},se.autolink=function(Z,le){var ne=this.rules.inline.autolink.exec(Z);if(ne){var ae,de;return ne[2]==="@"?(ae=p(this.options.mangle?le(ne[1]):ne[1]),de="mailto:"+ae):(ae=p(ne[1]),de=ae),{type:"link",raw:ne[0],text:ae,href:de,tokens:[{type:"text",raw:ae,text:ae}]}}},se.url=function(Z,le){var ne;if(ne=this.rules.inline.url.exec(Z)){var ae,de;if(ne[2]==="@")ae=p(this.options.mangle?le(ne[0]):ne[0]),de="mailto:"+ae;else{var Ie;do Ie=ne[0],ne[0]=this.rules.inline._backpedal.exec(ne[0])[0];while(Ie!==ne[0]);ae=p(ne[0]),ne[1]==="www."?de="http://"+ae:de=ae}return{type:"link",raw:ne[0],text:ae,href:de,tokens:[{type:"text",raw:ae,text:ae}]}}},se.inlineText=function(Z,le){var ne=this.rules.inline.text.exec(Z);if(ne){var ae;return this.lexer.state.inRawBlock?ae=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ne[0]):p(ne[0]):ne[0]:ae=p(this.options.smartypants?le(ne[0]):ne[0]),{type:"text",raw:ne[0],text:ae}}},te}(),z={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:m,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};z._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,z._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,z.def=n(z.def).replace("label",z._label).replace("title",z._title).getRegex(),z.bullet=/(?:[*+-]|\d{1,9}[.)])/,z.listItemStart=n(/^( *)(bull) */).replace("bull",z.bullet).getRegex(),z.list=n(z.list).replace(/bull/g,z.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+z.def.source+")").getRegex(),z._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",z._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,z.html=n(z.html,"i").replace("comment",z._comment).replace("tag",z._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),z.paragraph=n(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.blockquote=n(z.blockquote).replace("paragraph",z.paragraph).getRegex(),z.normal=I({},z),z.gfm=I({},z.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),z.gfm.table=n(z.gfm.table).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.gfm.paragraph=n(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",z.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.pedantic=I({},z.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",z._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:m,paragraph:n(z.normal._paragraph).replace("hr",z.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",z.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var F={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:m,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:m,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};F._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",F.punctuation=n(F.punctuation).replace(/punctuation/g,F._punctuation).getRegex(),F.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,F.escapedEmSt=/\\\*|\\_/g,F._comment=n(z._comment).replace("(?:-->|$)","-->").getRegex(),F.emStrong.lDelim=n(F.emStrong.lDelim).replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimAst=n(F.emStrong.rDelimAst,"g").replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimUnd=n(F.emStrong.rDelimUnd,"g").replace(/punct/g,F._punctuation).getRegex(),F._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,F._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,F._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,F.autolink=n(F.autolink).replace("scheme",F._scheme).replace("email",F._email).getRegex(),F._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,F.tag=n(F.tag).replace("comment",F._comment).replace("attribute",F._attribute).getRegex(),F._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,F._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,F._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,F.link=n(F.link).replace("label",F._label).replace("href",F._href).replace("title",F._title).getRegex(),F.reflink=n(F.reflink).replace("label",F._label).replace("ref",z._label).getRegex(),F.nolink=n(F.nolink).replace("ref",z._label).getRegex(),F.reflinkSearch=n(F.reflinkSearch,"g").replace("reflink",F.reflink).replace("nolink",F.nolink).getRegex(),F.normal=I({},F),F.pedantic=I({},F.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",F._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",F._label).getRegex()}),F.gfm=I({},F.normal,{escape:n(F.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),F.gfm.url=n(F.gfm.url,"i").replace("email",F.gfm._extended_email).getRegex(),F.breaks=I({},F.gfm,{br:n(F.br).replace("{2,}","*").getRegex(),text:n(F.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function N(te){return te.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function x(te){var se="",me,Z,le=te.length;for(me=0;me<le;me++)Z=te.charCodeAt(me),Math.random()>.5&&(Z="x"+Z.toString(16)),se+="&#"+Z+";";return se}var J=function(){function te(me){this.tokens=[],this.tokens.links=Object.create(null),this.options=me||pe.defaults,this.options.tokenizer=this.options.tokenizer||new U,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Z={block:z.normal,inline:F.normal};this.options.pedantic?(Z.block=z.pedantic,Z.inline=F.pedantic):this.options.gfm&&(Z.block=z.gfm,this.options.breaks?Z.inline=F.breaks:Z.inline=F.gfm),this.tokenizer.rules=Z}te.lex=function(Z,le){var ne=new te(le);return ne.lex(Z)},te.lexInline=function(Z,le){var ne=new te(le);return ne.inlineTokens(Z)};var se=te.prototype;return se.lex=function(Z){Z=Z.replace(/\r\n|\r/g,`
`),this.blockTokens(Z,this.tokens);for(var le;le=this.inlineQueue.shift();)this.inlineTokens(le.src,le.tokens);return this.tokens},se.blockTokens=function(Z,le){var ne=this;le===void 0&&(le=[]),this.options.pedantic?Z=Z.replace(/\t/g,"    ").replace(/^ +$/gm,""):Z=Z.replace(/^( *)(\t+)/gm,function(G,Q,q){return Q+"    ".repeat(q.length)});for(var ae,de,Ie,T;Z;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(G){return(ae=G.call({lexer:ne},Z,le))?(Z=Z.substring(ae.raw.length),le.push(ae),!0):!1}))){if(ae=this.tokenizer.space(Z)){Z=Z.substring(ae.raw.length),ae.raw.length===1&&le.length>0?le[le.length-1].raw+=`
`:le.push(ae);continue}if(ae=this.tokenizer.code(Z)){Z=Z.substring(ae.raw.length),de=le[le.length-1],de&&(de.type==="paragraph"||de.type==="text")?(de.raw+=`
`+ae.raw,de.text+=`
`+ae.text,this.inlineQueue[this.inlineQueue.length-1].src=de.text):le.push(ae);continue}if(ae=this.tokenizer.fences(Z)){Z=Z.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.heading(Z)){Z=Z.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.hr(Z)){Z=Z.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.blockquote(Z)){Z=Z.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.list(Z)){Z=Z.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.html(Z)){Z=Z.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.def(Z)){Z=Z.substring(ae.raw.length),de=le[le.length-1],de&&(de.type==="paragraph"||de.type==="text")?(de.raw+=`
`+ae.raw,de.text+=`
`+ae.raw,this.inlineQueue[this.inlineQueue.length-1].src=de.text):this.tokens.links[ae.tag]||(this.tokens.links[ae.tag]={href:ae.href,title:ae.title});continue}if(ae=this.tokenizer.table(Z)){Z=Z.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.lheading(Z)){Z=Z.substring(ae.raw.length),le.push(ae);continue}if(Ie=Z,this.options.extensions&&this.options.extensions.startBlock&&function(){var G=1/0,Q=Z.slice(1),q=void 0;ne.options.extensions.startBlock.forEach(function(_){q=_.call({lexer:this},Q),typeof q=="number"&&q>=0&&(G=Math.min(G,q))}),G<1/0&&G>=0&&(Ie=Z.substring(0,G+1))}(),this.state.top&&(ae=this.tokenizer.paragraph(Ie))){de=le[le.length-1],T&&de.type==="paragraph"?(de.raw+=`
`+ae.raw,de.text+=`
`+ae.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=de.text):le.push(ae),T=Ie.length!==Z.length,Z=Z.substring(ae.raw.length);continue}if(ae=this.tokenizer.text(Z)){Z=Z.substring(ae.raw.length),de=le[le.length-1],de&&de.type==="text"?(de.raw+=`
`+ae.raw,de.text+=`
`+ae.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=de.text):le.push(ae);continue}if(Z){var V="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(V);break}else throw new Error(V)}}return this.state.top=!0,le},se.inline=function(Z,le){return le===void 0&&(le=[]),this.inlineQueue.push({src:Z,tokens:le}),le},se.inlineTokens=function(Z,le){var ne=this;le===void 0&&(le=[]);var ae,de,Ie,T=Z,V,G,Q;if(this.tokens.links){var q=Object.keys(this.tokens.links);if(q.length>0)for(;(V=this.tokenizer.rules.inline.reflinkSearch.exec(T))!=null;)q.includes(V[0].slice(V[0].lastIndexOf("[")+1,-1))&&(T=T.slice(0,V.index)+"["+C("a",V[0].length-2)+"]"+T.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(V=this.tokenizer.rules.inline.blockSkip.exec(T))!=null;)T=T.slice(0,V.index)+"["+C("a",V[0].length-2)+"]"+T.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(V=this.tokenizer.rules.inline.escapedEmSt.exec(T))!=null;)T=T.slice(0,V.index)+"++"+T.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Z;)if(G||(Q=""),G=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(he){return(ae=he.call({lexer:ne},Z,le))?(Z=Z.substring(ae.raw.length),le.push(ae),!0):!1}))){if(ae=this.tokenizer.escape(Z)){Z=Z.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.tag(Z)){Z=Z.substring(ae.raw.length),de=le[le.length-1],de&&ae.type==="text"&&de.type==="text"?(de.raw+=ae.raw,de.text+=ae.text):le.push(ae);continue}if(ae=this.tokenizer.link(Z)){Z=Z.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.reflink(Z,this.tokens.links)){Z=Z.substring(ae.raw.length),de=le[le.length-1],de&&ae.type==="text"&&de.type==="text"?(de.raw+=ae.raw,de.text+=ae.text):le.push(ae);continue}if(ae=this.tokenizer.emStrong(Z,T,Q)){Z=Z.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.codespan(Z)){Z=Z.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.br(Z)){Z=Z.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.del(Z)){Z=Z.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.autolink(Z,x)){Z=Z.substring(ae.raw.length),le.push(ae);continue}if(!this.state.inLink&&(ae=this.tokenizer.url(Z,x))){Z=Z.substring(ae.raw.length),le.push(ae);continue}if(Ie=Z,this.options.extensions&&this.options.extensions.startInline&&function(){var he=1/0,Oe=Z.slice(1),je=void 0;ne.options.extensions.startInline.forEach(function(Qe){je=Qe.call({lexer:this},Oe),typeof je=="number"&&je>=0&&(he=Math.min(he,je))}),he<1/0&&he>=0&&(Ie=Z.substring(0,he+1))}(),ae=this.tokenizer.inlineText(Ie,N)){Z=Z.substring(ae.raw.length),ae.raw.slice(-1)!=="_"&&(Q=ae.raw.slice(-1)),G=!0,de=le[le.length-1],de&&de.type==="text"?(de.raw+=ae.raw,de.text+=ae.text):le.push(ae);continue}if(Z){var _="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(_);break}else throw new Error(_)}}return le},E(te,null,[{key:"rules",get:function(){return{block:z,inline:F}}}]),te}(),ye=function(){function te(me){this.options=me||pe.defaults}var se=te.prototype;return se.code=function(Z,le,ne){var ae=(le||"").match(/\S*/)[0];if(this.options.highlight){var de=this.options.highlight(Z,ae);de!=null&&de!==Z&&(ne=!0,Z=de)}return Z=Z.replace(/\n$/,"")+`
`,ae?'<pre><code class="'+this.options.langPrefix+p(ae,!0)+'">'+(ne?Z:p(Z,!0))+`</code></pre>
`:"<pre><code>"+(ne?Z:p(Z,!0))+`</code></pre>
`},se.blockquote=function(Z){return`<blockquote>
`+Z+`</blockquote>
`},se.html=function(Z){return Z},se.heading=function(Z,le,ne,ae){if(this.options.headerIds){var de=this.options.headerPrefix+ae.slug(ne);return"<h"+le+' id="'+de+'">'+Z+"</h"+le+`>
`}return"<h"+le+">"+Z+"</h"+le+`>
`},se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},se.list=function(Z,le,ne){var ae=le?"ol":"ul",de=le&&ne!==1?' start="'+ne+'"':"";return"<"+ae+de+`>
`+Z+"</"+ae+`>
`},se.listitem=function(Z){return"<li>"+Z+`</li>
`},se.checkbox=function(Z){return"<input "+(Z?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},se.paragraph=function(Z){return"<p>"+Z+`</p>
`},se.table=function(Z,le){return le&&(le="<tbody>"+le+"</tbody>"),`<table>
<thead>
`+Z+`</thead>
`+le+`</table>
`},se.tablerow=function(Z){return`<tr>
`+Z+`</tr>
`},se.tablecell=function(Z,le){var ne=le.header?"th":"td",ae=le.align?"<"+ne+' align="'+le.align+'">':"<"+ne+">";return ae+Z+("</"+ne+`>
`)},se.strong=function(Z){return"<strong>"+Z+"</strong>"},se.em=function(Z){return"<em>"+Z+"</em>"},se.codespan=function(Z){return"<code>"+Z+"</code>"},se.br=function(){return this.options.xhtml?"<br/>":"<br>"},se.del=function(Z){return"<del>"+Z+"</del>"},se.link=function(Z,le,ne){if(Z=l(this.options.sanitize,this.options.baseUrl,Z),Z===null)return ne;var ae='<a href="'+p(Z)+'"';return le&&(ae+=' title="'+le+'"'),ae+=">"+ne+"</a>",ae},se.image=function(Z,le,ne){if(Z=l(this.options.sanitize,this.options.baseUrl,Z),Z===null)return ne;var ae='<img src="'+Z+'" alt="'+ne+'"';return le&&(ae+=' title="'+le+'"'),ae+=this.options.xhtml?"/>":">",ae},se.text=function(Z){return Z},te}(),De=function(){function te(){}var se=te.prototype;return se.strong=function(Z){return Z},se.em=function(Z){return Z},se.codespan=function(Z){return Z},se.del=function(Z){return Z},se.html=function(Z){return Z},se.text=function(Z){return Z},se.link=function(Z,le,ne){return""+ne},se.image=function(Z,le,ne){return""+ne},se.br=function(){return""},te}(),Ce=function(){function te(){this.seen={}}var se=te.prototype;return se.serialize=function(Z){return Z.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},se.getNextSafeSlug=function(Z,le){var ne=Z,ae=0;if(this.seen.hasOwnProperty(ne)){ae=this.seen[Z];do ae++,ne=Z+"-"+ae;while(this.seen.hasOwnProperty(ne))}return le||(this.seen[Z]=ae,this.seen[ne]=0),ne},se.slug=function(Z,le){le===void 0&&(le={});var ne=this.serialize(Z);return this.getNextSafeSlug(ne,le.dryrun)},te}(),ge=function(){function te(me){this.options=me||pe.defaults,this.options.renderer=this.options.renderer||new ye,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new De,this.slugger=new Ce}te.parse=function(Z,le){var ne=new te(le);return ne.parse(Z)},te.parseInline=function(Z,le){var ne=new te(le);return ne.parseInline(Z)};var se=te.prototype;return se.parse=function(Z,le){le===void 0&&(le=!0);var ne="",ae,de,Ie,T,V,G,Q,q,_,he,Oe,je,Qe,Ge,_e,Ye,xe,it,tt,ze=Z.length;for(ae=0;ae<ze;ae++){if(he=Z[ae],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[he.type]&&(tt=this.options.extensions.renderers[he.type].call({parser:this},he),tt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(he.type))){ne+=tt||"";continue}switch(he.type){case"space":continue;case"hr":{ne+=this.renderer.hr();continue}case"heading":{ne+=this.renderer.heading(this.parseInline(he.tokens),he.depth,t(this.parseInline(he.tokens,this.textRenderer)),this.slugger);continue}case"code":{ne+=this.renderer.code(he.text,he.lang,he.escaped);continue}case"table":{for(q="",Q="",T=he.header.length,de=0;de<T;de++)Q+=this.renderer.tablecell(this.parseInline(he.header[de].tokens),{header:!0,align:he.align[de]});for(q+=this.renderer.tablerow(Q),_="",T=he.rows.length,de=0;de<T;de++){for(G=he.rows[de],Q="",V=G.length,Ie=0;Ie<V;Ie++)Q+=this.renderer.tablecell(this.parseInline(G[Ie].tokens),{header:!1,align:he.align[Ie]});_+=this.renderer.tablerow(Q)}ne+=this.renderer.table(q,_);continue}case"blockquote":{_=this.parse(he.tokens),ne+=this.renderer.blockquote(_);continue}case"list":{for(Oe=he.ordered,je=he.start,Qe=he.loose,T=he.items.length,_="",de=0;de<T;de++)_e=he.items[de],Ye=_e.checked,xe=_e.task,Ge="",_e.task&&(it=this.renderer.checkbox(Ye),Qe?_e.tokens.length>0&&_e.tokens[0].type==="paragraph"?(_e.tokens[0].text=it+" "+_e.tokens[0].text,_e.tokens[0].tokens&&_e.tokens[0].tokens.length>0&&_e.tokens[0].tokens[0].type==="text"&&(_e.tokens[0].tokens[0].text=it+" "+_e.tokens[0].tokens[0].text)):_e.tokens.unshift({type:"text",text:it}):Ge+=it),Ge+=this.parse(_e.tokens,Qe),_+=this.renderer.listitem(Ge,xe,Ye);ne+=this.renderer.list(_,Oe,je);continue}case"html":{ne+=this.renderer.html(he.text);continue}case"paragraph":{ne+=this.renderer.paragraph(this.parseInline(he.tokens));continue}case"text":{for(_=he.tokens?this.parseInline(he.tokens):he.text;ae+1<ze&&Z[ae+1].type==="text";)he=Z[++ae],_+=`
`+(he.tokens?this.parseInline(he.tokens):he.text);ne+=le?this.renderer.paragraph(_):_;continue}default:{var ut='Token with "'+he.type+'" type was not found.';if(this.options.silent){console.error(ut);return}else throw new Error(ut)}}}return ne},se.parseInline=function(Z,le){le=le||this.renderer;var ne="",ae,de,Ie,T=Z.length;for(ae=0;ae<T;ae++){if(de=Z[ae],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[de.type]&&(Ie=this.options.extensions.renderers[de.type].call({parser:this},de),Ie!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(de.type))){ne+=Ie||"";continue}switch(de.type){case"escape":{ne+=le.text(de.text);break}case"html":{ne+=le.html(de.text);break}case"link":{ne+=le.link(de.href,de.title,this.parseInline(de.tokens,le));break}case"image":{ne+=le.image(de.href,de.title,de.text);break}case"strong":{ne+=le.strong(this.parseInline(de.tokens,le));break}case"em":{ne+=le.em(this.parseInline(de.tokens,le));break}case"codespan":{ne+=le.codespan(de.text);break}case"br":{ne+=le.br();break}case"del":{ne+=le.del(this.parseInline(de.tokens,le));break}case"text":{ne+=le.text(de.text);break}default:{var V='Token with "'+de.type+'" type was not found.';if(this.options.silent){console.error(V);return}else throw new Error(V)}}}return ne},te}();function we(te,se,me){if(typeof te>"u"||te===null)throw new Error("marked(): input parameter is undefined or null");if(typeof te!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(te)+", string expected");if(typeof se=="function"&&(me=se,se=null),se=I({},we.defaults,se||{}),y(se),me){var Z=se.highlight,le;try{le=J.lex(te,se)}catch(T){return me(T)}var ne=function(V){var G;if(!V)try{se.walkTokens&&we.walkTokens(le,se.walkTokens),G=ge.parse(le,se)}catch(Q){V=Q}return se.highlight=Z,V?me(V):me(null,G)};if(!Z||Z.length<3||(delete se.highlight,!le.length))return ne();var ae=0;we.walkTokens(le,function(T){T.type==="code"&&(ae++,setTimeout(function(){Z(T.text,T.lang,function(V,G){if(V)return ne(V);G!=null&&G!==T.text&&(T.text=G,T.escaped=!0),ae--,ae===0&&ne()})},0))}),ae===0&&ne();return}function de(T){if(T.message+=`
Please report this to https://github.com/markedjs/marked.`,se.silent)return"<p>An error occurred:</p><pre>"+p(T.message+"",!0)+"</pre>";throw T}try{var Ie=J.lex(te,se);if(se.walkTokens){if(se.async)return Promise.all(we.walkTokens(Ie,se.walkTokens)).then(function(){return ge.parse(Ie,se)}).catch(de);we.walkTokens(Ie,se.walkTokens)}return ge.parse(Ie,se)}catch(T){de(T)}}we.options=we.setOptions=function(te){return I(we.defaults,te),$(we.defaults),we},we.getDefaults=R,we.defaults=pe.defaults,we.use=function(){for(var te=arguments.length,se=new Array(te),me=0;me<te;me++)se[me]=arguments[me];var Z=I.apply(void 0,[{}].concat(se)),le=we.defaults.extensions||{renderers:{},childTokens:{}},ne;se.forEach(function(ae){if(ae.extensions&&(ne=!0,ae.extensions.forEach(function(Ie){if(!Ie.name)throw new Error("extension name required");if(Ie.renderer){var T=le.renderers?le.renderers[Ie.name]:null;T?le.renderers[Ie.name]=function(){for(var V=arguments.length,G=new Array(V),Q=0;Q<V;Q++)G[Q]=arguments[Q];var q=Ie.renderer.apply(this,G);return q===!1&&(q=T.apply(this,G)),q}:le.renderers[Ie.name]=Ie.renderer}if(Ie.tokenizer){if(!Ie.level||Ie.level!=="block"&&Ie.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");le[Ie.level]?le[Ie.level].unshift(Ie.tokenizer):le[Ie.level]=[Ie.tokenizer],Ie.start&&(Ie.level==="block"?le.startBlock?le.startBlock.push(Ie.start):le.startBlock=[Ie.start]:Ie.level==="inline"&&(le.startInline?le.startInline.push(Ie.start):le.startInline=[Ie.start]))}Ie.childTokens&&(le.childTokens[Ie.name]=Ie.childTokens)})),ae.renderer&&function(){var Ie=we.defaults.renderer||new ye,T=function(Q){var q=Ie[Q];Ie[Q]=function(){for(var _=arguments.length,he=new Array(_),Oe=0;Oe<_;Oe++)he[Oe]=arguments[Oe];var je=ae.renderer[Q].apply(Ie,he);return je===!1&&(je=q.apply(Ie,he)),je}};for(var V in ae.renderer)T(V);Z.renderer=Ie}(),ae.tokenizer&&function(){var Ie=we.defaults.tokenizer||new U,T=function(Q){var q=Ie[Q];Ie[Q]=function(){for(var _=arguments.length,he=new Array(_),Oe=0;Oe<_;Oe++)he[Oe]=arguments[Oe];var je=ae.tokenizer[Q].apply(Ie,he);return je===!1&&(je=q.apply(Ie,he)),je}};for(var V in ae.tokenizer)T(V);Z.tokenizer=Ie}(),ae.walkTokens){var de=we.defaults.walkTokens;Z.walkTokens=function(Ie){var T=[];return T.push(ae.walkTokens.call(this,Ie)),de&&(T=T.concat(de.call(this,Ie))),T}}ne&&(Z.extensions=le),we.setOptions(Z)})},we.walkTokens=function(te,se){for(var me=[],Z=function(){var de=ne.value;switch(me=me.concat(se.call(we,de)),de.type){case"table":{for(var Ie=M(de.header),T;!(T=Ie()).done;){var V=T.value;me=me.concat(we.walkTokens(V.tokens,se))}for(var G=M(de.rows),Q;!(Q=G()).done;)for(var q=Q.value,_=M(q),he;!(he=_()).done;){var Oe=he.value;me=me.concat(we.walkTokens(Oe.tokens,se))}break}case"list":{me=me.concat(we.walkTokens(de.items,se));break}default:we.defaults.extensions&&we.defaults.extensions.childTokens&&we.defaults.extensions.childTokens[de.type]?we.defaults.extensions.childTokens[de.type].forEach(function(je){me=me.concat(we.walkTokens(de[je],se))}):de.tokens&&(me=me.concat(we.walkTokens(de.tokens,se)))}},le=M(te),ne;!(ne=le()).done;)Z();return me},we.parseInline=function(te,se){if(typeof te>"u"||te===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof te!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(te)+", string expected");se=I({},we.defaults,se||{}),y(se);try{var me=J.lexInline(te,se);return se.walkTokens&&we.walkTokens(me,se.walkTokens),ge.parseInline(me,se)}catch(Z){if(Z.message+=`
Please report this to https://github.com/markedjs/marked.`,se.silent)return"<p>An error occurred:</p><pre>"+p(Z.message+"",!0)+"</pre>";throw Z}},we.Parser=ge,we.parser=ge.parse,we.Renderer=ye,we.TextRenderer=De,we.Lexer=J,we.lexer=J.lex,we.Tokenizer=U,we.Slugger=Ce,we.parse=we;var re=we.options,oe=we.setOptions,ve=we.use,ee=we.walkTokens,W=we.parseInline,ue=we,Pe=ge.parse,Ee=J.lex;pe.Lexer=J,pe.Parser=ge,pe.Renderer=ye,pe.Slugger=Ce,pe.TextRenderer=De,pe.Tokenizer=U,pe.getDefaults=R,pe.lexer=Ee,pe.marked=we,pe.options=re,pe.parse=ue,pe.parseInline=W,pe.parser=Pe,pe.setOptions=oe,pe.use=ve,pe.walkTokens=ee,Object.defineProperty(pe,"__esModule",{value:!0})}),define(Ae[121],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wl=e.$Vl=e.$Ul=e.rot=e.$Sl=void 0;function E($,D,g){return Math.min(Math.max($,D),g)}e.$Sl=E;function L($,D){return(D+$%D)%D}e.rot=L;class P{constructor(){this.a=0}getNext(){return this.a++}}e.$Ul=P;class M{constructor(){this.a=1,this.b=0}update(D){return this.b=this.b+(D-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Vl=M;class R{constructor(D){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(D),this.c.fill(0,0,D)}update(D){const g=this.c[this.d];return this.c[this.d]=D,this.d=(this.d+1)%this.c.length,this.e-=g,this.e+=D,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Wl=R}),function(){function pe(P){const M=[];typeof P=="number"&&M.push("code/timeOrigin",P);function R(D){M.push(D,Date.now())}function $(){const D=[];for(let g=0;g<M.length;g+=2)D.push({name:M[g],startTime:M[g+1]});return D}return{mark:R,getMarks:$}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?pe():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const R of performance.getEntriesByType("mark"))M.push({name:R.name,startTime:Math.round(P+R.startTime)});return M}};if(typeof process=="object"){const P=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return pe(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),pe()}function E(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=E(L))}(),function(pe,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var E=e();for(var L in E)(typeof exports=="object"?exports:pe)[L]=E[L]}}(typeof self<"u"?self:this,function(){return function(pe){var e={};function E(L){if(e[L])return e[L].exports;var P=e[L]={i:L,l:!1,exports:{}};return pe[L].call(P.exports,P,P.exports,E),P.l=!0,P.exports}return E.m=pe,E.c=e,E.d=function(L,P,M){E.o(L,P)||Object.defineProperty(L,P,{enumerable:!0,get:M})},E.r=function(L){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},E.t=function(L,P){if(1&P&&(L=E(L)),8&P||4&P&&typeof L=="object"&&L&&L.__esModule)return L;var M=Object.create(null);if(E.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:L}),2&P&&typeof L!="string")for(var R in L)E.d(M,R,function($){return L[$]}.bind(null,R));return M},E.n=function(L){var P=L&&L.__esModule?function(){return L.default}:function(){return L};return E.d(P,"a",P),P},E.o=function(L,P){return Object.prototype.hasOwnProperty.call(L,P)},E.p="",E(E.s=0)}([function(pe,e,E){(function(L){var P;e=pe.exports=ve,P=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var q=Array.prototype.slice.call(arguments,0);q.unshift("SEMVER"),console.log.apply(console,q)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,$=e.re=[],D=e.src=[],g=0,A=g++;D[A]="0|[1-9]\\d*";var S=g++;D[S]="[0-9]+";var o=g++;D[o]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=g++;D[v]="("+D[A]+")\\.("+D[A]+")\\.("+D[A]+")";var p=g++;D[p]="("+D[S]+")\\.("+D[S]+")\\.("+D[S]+")";var f=g++;D[f]="(?:"+D[A]+"|"+D[o]+")";var t=g++;D[t]="(?:"+D[S]+"|"+D[o]+")";var i=g++;D[i]="(?:-("+D[f]+"(?:\\."+D[f]+")*))";var n=g++;D[n]="(?:-?("+D[t]+"(?:\\."+D[t]+")*))";var u=g++;D[u]="[0-9A-Za-z-]+";var a=g++;D[a]="(?:\\+("+D[u]+"(?:\\."+D[u]+")*))";var l=g++,r="v?"+D[v]+D[i]+"?"+D[a]+"?";D[l]="^"+r+"$";var s="[v=\\s]*"+D[p]+D[n]+"?"+D[a]+"?",c=g++;D[c]="^"+s+"$";var h=g++;D[h]="((?:<|>)?=?)";var w=g++;D[w]=D[S]+"|x|X|\\*";var m=g++;D[m]=D[A]+"|x|X|\\*";var I=g++;D[I]="[v=\\s]*("+D[m]+")(?:\\.("+D[m]+")(?:\\.("+D[m]+")(?:"+D[i]+")?"+D[a]+"?)?)?";var k=g++;D[k]="[v=\\s]*("+D[w]+")(?:\\.("+D[w]+")(?:\\.("+D[w]+")(?:"+D[n]+")?"+D[a]+"?)?)?";var d=g++;D[d]="^"+D[h]+"\\s*"+D[I]+"$";var b=g++;D[b]="^"+D[h]+"\\s*"+D[k]+"$";var y=g++;D[y]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var C=g++;D[C]="(?:~>?)";var B=g++;D[B]="(\\s*)"+D[C]+"\\s+",$[B]=new RegExp(D[B],"g");var H=g++;D[H]="^"+D[C]+D[I]+"$";var U=g++;D[U]="^"+D[C]+D[k]+"$";var z=g++;D[z]="(?:\\^)";var F=g++;D[F]="(\\s*)"+D[z]+"\\s+",$[F]=new RegExp(D[F],"g");var N=g++;D[N]="^"+D[z]+D[I]+"$";var x=g++;D[x]="^"+D[z]+D[k]+"$";var J=g++;D[J]="^"+D[h]+"\\s*("+s+")$|^$";var ye=g++;D[ye]="^"+D[h]+"\\s*("+r+")$|^$";var De=g++;D[De]="(\\s*)"+D[h]+"\\s*("+s+"|"+D[I]+")",$[De]=new RegExp(D[De],"g");var Ce=g++;D[Ce]="^\\s*("+D[I]+")\\s+-\\s+("+D[I]+")\\s*$";var ge=g++;D[ge]="^\\s*("+D[k]+")\\s+-\\s+("+D[k]+")\\s*$";var we=g++;D[we]="(<|>)?=?\\s*\\*";for(var re=0;re<35;re++)P(re,D[re]),$[re]||($[re]=new RegExp(D[re]));function oe(q,_){if(q instanceof ve)return q;if(typeof q!="string"||q.length>M||!(_?$[c]:$[l]).test(q))return null;try{return new ve(q,_)}catch{return null}}function ve(q,_){if(q instanceof ve){if(q.loose===_)return q;q=q.version}else if(typeof q!="string")throw new TypeError("Invalid Version: "+q);if(q.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof ve))return new ve(q,_);P("SemVer",q,_),this.loose=_;var he=q.trim().match(_?$[c]:$[l]);if(!he)throw new TypeError("Invalid Version: "+q);if(this.raw=q,this.major=+he[1],this.minor=+he[2],this.patch=+he[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");he[4]?this.prerelease=he[4].split(".").map(function(Oe){if(/^[0-9]+$/.test(Oe)){var je=+Oe;if(je>=0&&je<R)return je}return Oe}):this.prerelease=[],this.build=he[5]?he[5].split("."):[],this.format()}e.parse=oe,e.valid=function(q,_){var he=oe(q,_);return he?he.version:null},e.clean=function(q,_){var he=oe(q.trim().replace(/^[=v]+/,""),_);return he?he.version:null},e.SemVer=ve,ve.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ve.prototype.toString=function(){return this.version},ve.prototype.compare=function(q){return P("SemVer.compare",this.version,this.loose,q),q instanceof ve||(q=new ve(q,this.loose)),this.compareMain(q)||this.comparePre(q)},ve.prototype.compareMain=function(q){return q instanceof ve||(q=new ve(q,this.loose)),W(this.major,q.major)||W(this.minor,q.minor)||W(this.patch,q.patch)},ve.prototype.comparePre=function(q){if(q instanceof ve||(q=new ve(q,this.loose)),this.prerelease.length&&!q.prerelease.length)return-1;if(!this.prerelease.length&&q.prerelease.length)return 1;if(!this.prerelease.length&&!q.prerelease.length)return 0;var _=0;do{var he=this.prerelease[_],Oe=q.prerelease[_];if(P("prerelease compare",_,he,Oe),he===void 0&&Oe===void 0)return 0;if(Oe===void 0)return 1;if(he===void 0)return-1;if(he!==Oe)return W(he,Oe)}while(++_)},ve.prototype.inc=function(q,_){switch(q){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",_);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",_);break;case"prepatch":this.prerelease.length=0,this.inc("patch",_),this.inc("pre",_);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",_),this.inc("pre",_);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var he=this.prerelease.length;--he>=0;)typeof this.prerelease[he]=="number"&&(this.prerelease[he]++,he=-2);he===-1&&this.prerelease.push(0)}_&&(this.prerelease[0]===_?isNaN(this.prerelease[1])&&(this.prerelease=[_,0]):this.prerelease=[_,0]);break;default:throw new Error("invalid increment argument: "+q)}return this.format(),this.raw=this.version,this},e.inc=function(q,_,he,Oe){typeof he=="string"&&(Oe=he,he=void 0);try{return new ve(q,he).inc(_,Oe).version}catch{return null}},e.diff=function(q,_){if(te(q,_))return null;var he=oe(q),Oe=oe(_);if(he.prerelease.length||Oe.prerelease.length){for(var je in he)if((je==="major"||je==="minor"||je==="patch")&&he[je]!==Oe[je])return"pre"+je;return"prerelease"}for(var je in he)if((je==="major"||je==="minor"||je==="patch")&&he[je]!==Oe[je])return je},e.compareIdentifiers=W;var ee=/^[0-9]+$/;function W(q,_){var he=ee.test(q),Oe=ee.test(_);return he&&Oe&&(q=+q,_=+_),he&&!Oe?-1:Oe&&!he?1:q<_?-1:q>_?1:0}function ue(q,_,he){return new ve(q,he).compare(new ve(_,he))}function Pe(q,_,he){return ue(q,_,he)>0}function Ee(q,_,he){return ue(q,_,he)<0}function te(q,_,he){return ue(q,_,he)===0}function se(q,_,he){return ue(q,_,he)!==0}function me(q,_,he){return ue(q,_,he)>=0}function Z(q,_,he){return ue(q,_,he)<=0}function le(q,_,he,Oe){var je;switch(_){case"===":typeof q=="object"&&(q=q.version),typeof he=="object"&&(he=he.version),je=q===he;break;case"!==":typeof q=="object"&&(q=q.version),typeof he=="object"&&(he=he.version),je=q!==he;break;case"":case"=":case"==":je=te(q,he,Oe);break;case"!=":je=se(q,he,Oe);break;case">":je=Pe(q,he,Oe);break;case">=":je=me(q,he,Oe);break;case"<":je=Ee(q,he,Oe);break;case"<=":je=Z(q,he,Oe);break;default:throw new TypeError("Invalid operator: "+_)}return je}function ne(q,_){if(q instanceof ne){if(q.loose===_)return q;q=q.value}if(!(this instanceof ne))return new ne(q,_);P("comparator",q,_),this.loose=_,this.parse(q),this.semver===ae?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(q,_){return W(_,q)},e.major=function(q,_){return new ve(q,_).major},e.minor=function(q,_){return new ve(q,_).minor},e.patch=function(q,_){return new ve(q,_).patch},e.compare=ue,e.compareLoose=function(q,_){return ue(q,_,!0)},e.rcompare=function(q,_,he){return ue(_,q,he)},e.sort=function(q,_){return q.sort(function(he,Oe){return e.compare(he,Oe,_)})},e.rsort=function(q,_){return q.sort(function(he,Oe){return e.rcompare(he,Oe,_)})},e.gt=Pe,e.lt=Ee,e.eq=te,e.neq=se,e.gte=me,e.lte=Z,e.cmp=le,e.Comparator=ne;var ae={};function de(q,_){if(q instanceof de)return q.loose===_?q:new de(q.raw,_);if(q instanceof ne)return new de(q.value,_);if(!(this instanceof de))return new de(q,_);if(this.loose=_,this.raw=q,this.set=q.split(/\s*\|\|\s*/).map(function(he){return this.parseRange(he.trim())},this).filter(function(he){return he.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+q);this.format()}function Ie(q){return!q||q.toLowerCase()==="x"||q==="*"}function T(q,_,he,Oe,je,Qe,Ge,_e,Ye,xe,it,tt,ze){return((_=Ie(he)?"":Ie(Oe)?">="+he+".0.0":Ie(je)?">="+he+"."+Oe+".0":">="+_)+" "+(_e=Ie(Ye)?"":Ie(xe)?"<"+(+Ye+1)+".0.0":Ie(it)?"<"+Ye+"."+(+xe+1)+".0":tt?"<="+Ye+"."+xe+"."+it+"-"+tt:"<="+_e)).trim()}function V(q,_){for(var he=0;he<q.length;he++)if(!q[he].test(_))return!1;if(_.prerelease.length){for(he=0;he<q.length;he++)if(P(q[he].semver),q[he].semver!==ae&&q[he].semver.prerelease.length>0){var Oe=q[he].semver;if(Oe.major===_.major&&Oe.minor===_.minor&&Oe.patch===_.patch)return!0}return!1}return!0}function G(q,_,he){try{_=new de(_,he)}catch{return!1}return _.test(q)}function Q(q,_,he,Oe){var je,Qe,Ge,_e,Ye;switch(q=new ve(q,Oe),_=new de(_,Oe),he){case">":je=Pe,Qe=Z,Ge=Ee,_e=">",Ye=">=";break;case"<":je=Ee,Qe=me,Ge=Pe,_e="<",Ye="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(G(q,_,Oe))return!1;for(var xe=0;xe<_.set.length;++xe){var it=_.set[xe],tt=null,ze=null;if(it.forEach(function(ut){ut.semver===ae&&(ut=new ne(">=0.0.0")),tt=tt||ut,ze=ze||ut,je(ut.semver,tt.semver,Oe)?tt=ut:Ge(ut.semver,ze.semver,Oe)&&(ze=ut)}),tt.operator===_e||tt.operator===Ye||(!ze.operator||ze.operator===_e)&&Qe(q,ze.semver)||ze.operator===Ye&&Ge(q,ze.semver))return!1}return!0}ne.prototype.parse=function(q){var _=this.loose?$[J]:$[ye],he=q.match(_);if(!he)throw new TypeError("Invalid comparator: "+q);this.operator=he[1],this.operator==="="&&(this.operator=""),he[2]?this.semver=new ve(he[2],this.loose):this.semver=ae},ne.prototype.toString=function(){return this.value},ne.prototype.test=function(q){return P("Comparator.test",q,this.loose),this.semver===ae||(typeof q=="string"&&(q=new ve(q,this.loose)),le(q,this.operator,this.semver,this.loose))},ne.prototype.intersects=function(q,_){if(!(q instanceof ne))throw new TypeError("a Comparator is required");var he;if(this.operator==="")return he=new de(q.value,_),G(this.value,he,_);if(q.operator==="")return he=new de(this.value,_),G(q.semver,he,_);var Oe=!(this.operator!==">="&&this.operator!==">"||q.operator!==">="&&q.operator!==">"),je=!(this.operator!=="<="&&this.operator!=="<"||q.operator!=="<="&&q.operator!=="<"),Qe=this.semver.version===q.semver.version,Ge=!(this.operator!==">="&&this.operator!=="<="||q.operator!==">="&&q.operator!=="<="),_e=le(this.semver,"<",q.semver,_)&&(this.operator===">="||this.operator===">")&&(q.operator==="<="||q.operator==="<"),Ye=le(this.semver,">",q.semver,_)&&(this.operator==="<="||this.operator==="<")&&(q.operator===">="||q.operator===">");return Oe||je||Qe&&Ge||_e||Ye},e.Range=de,de.prototype.format=function(){return this.range=this.set.map(function(q){return q.join(" ").trim()}).join("||").trim(),this.range},de.prototype.toString=function(){return this.range},de.prototype.parseRange=function(q){var _=this.loose;q=q.trim(),P("range",q,_);var he=_?$[ge]:$[Ce];q=q.replace(he,T),P("hyphen replace",q),q=q.replace($[De],"$1$2$3"),P("comparator trim",q,$[De]),q=(q=(q=q.replace($[B],"$1~")).replace($[F],"$1^")).split(/\s+/).join(" ");var Oe=_?$[J]:$[ye],je=q.split(" ").map(function(Qe){return function(Ge,_e){return P("comp",Ge),Ge=function(Ye,xe){return Ye.trim().split(/\s+/).map(function(it){return function(tt,ze){P("caret",tt,ze);var ut=ze?$[x]:$[N];return tt.replace(ut,function(Y,X,be,Be,Ne){var Xe;return P("caret",tt,Y,X,be,Be,Ne),Ie(X)?Xe="":Ie(be)?Xe=">="+X+".0.0 <"+(+X+1)+".0.0":Ie(Be)?Xe=X==="0"?">="+X+"."+be+".0 <"+X+"."+(+be+1)+".0":">="+X+"."+be+".0 <"+(+X+1)+".0.0":Ne?(P("replaceCaret pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),Xe=X==="0"?be==="0"?">="+X+"."+be+"."+Be+Ne+" <"+X+"."+be+"."+(+Be+1):">="+X+"."+be+"."+Be+Ne+" <"+X+"."+(+be+1)+".0":">="+X+"."+be+"."+Be+Ne+" <"+(+X+1)+".0.0"):(P("no pr"),Xe=X==="0"?be==="0"?">="+X+"."+be+"."+Be+" <"+X+"."+be+"."+(+Be+1):">="+X+"."+be+"."+Be+" <"+X+"."+(+be+1)+".0":">="+X+"."+be+"."+Be+" <"+(+X+1)+".0.0"),P("caret return",Xe),Xe})}(it,xe)}).join(" ")}(Ge,_e),P("caret",Ge),Ge=function(Ye,xe){return Ye.trim().split(/\s+/).map(function(it){return function(tt,ze){var ut=ze?$[U]:$[H];return tt.replace(ut,function(Y,X,be,Be,Ne){var Xe;return P("tilde",tt,Y,X,be,Be,Ne),Ie(X)?Xe="":Ie(be)?Xe=">="+X+".0.0 <"+(+X+1)+".0.0":Ie(Be)?Xe=">="+X+"."+be+".0 <"+X+"."+(+be+1)+".0":Ne?(P("replaceTilde pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),Xe=">="+X+"."+be+"."+Be+Ne+" <"+X+"."+(+be+1)+".0"):Xe=">="+X+"."+be+"."+Be+" <"+X+"."+(+be+1)+".0",P("tilde return",Xe),Xe})}(it,xe)}).join(" ")}(Ge,_e),P("tildes",Ge),Ge=function(Ye,xe){return P("replaceXRanges",Ye,xe),Ye.split(/\s+/).map(function(it){return function(tt,ze){tt=tt.trim();var ut=ze?$[b]:$[d];return tt.replace(ut,function(Y,X,be,Be,Ne,Xe){P("xRange",tt,Y,X,be,Be,Ne,Xe);var nt=Ie(be),$t=nt||Ie(Be),wt=$t||Ie(Ne);return X==="="&&wt&&(X=""),nt?Y=X===">"||X==="<"?"<0.0.0":"*":X&&wt?($t&&(Be=0),wt&&(Ne=0),X===">"?(X=">=",$t?(be=+be+1,Be=0,Ne=0):wt&&(Be=+Be+1,Ne=0)):X==="<="&&(X="<",$t?be=+be+1:Be=+Be+1),Y=X+be+"."+Be+"."+Ne):$t?Y=">="+be+".0.0 <"+(+be+1)+".0.0":wt&&(Y=">="+be+"."+Be+".0 <"+be+"."+(+Be+1)+".0"),P("xRange return",Y),Y})}(it,xe)}).join(" ")}(Ge,_e),P("xrange",Ge),Ge=function(Ye,xe){return P("replaceStars",Ye,xe),Ye.trim().replace($[we],"")}(Ge,_e),P("stars",Ge),Ge}(Qe,_)}).join(" ").split(/\s+/);return this.loose&&(je=je.filter(function(Qe){return!!Qe.match(Oe)})),je=je.map(function(Qe){return new ne(Qe,_)})},de.prototype.intersects=function(q,_){if(!(q instanceof de))throw new TypeError("a Range is required");return this.set.some(function(he){return he.every(function(Oe){return q.set.some(function(je){return je.every(function(Qe){return Oe.intersects(Qe,_)})})})})},e.toComparators=function(q,_){return new de(q,_).set.map(function(he){return he.map(function(Oe){return Oe.value}).join(" ").trim().split(" ")})},de.prototype.test=function(q){if(!q)return!1;typeof q=="string"&&(q=new ve(q,this.loose));for(var _=0;_<this.set.length;_++)if(V(this.set[_],q))return!0;return!1},e.satisfies=G,e.maxSatisfying=function(q,_,he){var Oe=null,je=null;try{var Qe=new de(_,he)}catch{return null}return q.forEach(function(Ge){Qe.test(Ge)&&(Oe&&je.compare(Ge)!==-1||(je=new ve(Oe=Ge,he)))}),Oe},e.minSatisfying=function(q,_,he){var Oe=null,je=null;try{var Qe=new de(_,he)}catch{return null}return q.forEach(function(Ge){Qe.test(Ge)&&(Oe&&je.compare(Ge)!==1||(je=new ve(Oe=Ge,he)))}),Oe},e.validRange=function(q,_){try{return new de(q,_).range||"*"}catch{return null}},e.ltr=function(q,_,he){return Q(q,_,"<",he)},e.gtr=function(q,_,he){return Q(q,_,">",he)},e.outside=Q,e.prerelease=function(q,_){var he=oe(q,_);return he&&he.prerelease.length?he.prerelease:null},e.intersects=function(q,_,he){return q=new de(q,he),_=new de(_,he),q.intersects(_)},e.coerce=function(q){if(q instanceof ve)return q;if(typeof q!="string")return null;var _=q.match($[y]);return _==null?null:oe((_[1]||"0")+"."+(_[2]||"0")+"."+(_[3]||"0"))}}).call(this,E(1))},function(pe,e){var E,L,P=pe.exports={};function M(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function $(t){if(E===setTimeout)return setTimeout(t,0);if((E===M||!E)&&setTimeout)return E=setTimeout,setTimeout(t,0);try{return E(t,0)}catch{try{return E.call(null,t,0)}catch{return E.call(this,t,0)}}}(function(){try{E=typeof setTimeout=="function"?setTimeout:M}catch{E=M}try{L=typeof clearTimeout=="function"?clearTimeout:R}catch{L=R}})();var D,g=[],A=!1,S=-1;function o(){A&&D&&(A=!1,D.length?g=D.concat(g):S=-1,g.length&&v())}function v(){if(!A){var t=$(o);A=!0;for(var i=g.length;i;){for(D=g,g=[];++S<i;)D&&D[S].run();S=-1,i=g.length}D=null,A=!1,function(n){if(L===clearTimeout)return clearTimeout(n);if((L===R||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(n);try{L(n)}catch{try{return L.call(null,n)}catch{return L.call(this,n)}}}(t)}}function p(t,i){this.fun=t,this.array=i}function f(){}P.nextTick=function(t){var i=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)i[n-1]=arguments[n];g.push(new p(t,i)),g.length!==1||A||$(v)},p.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=f,P.addListener=f,P.once=f,P.off=f,P.removeListener=f,P.removeAllListeners=f,P.emit=f,P.prependListener=f,P.prependOnceListener=f,P.listeners=function(t){return[]},P.binding=function(t){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(t){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(Ae[122],Re([1,0,11,6]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=void 0;function P(a){const l=a;return l?typeof l.read=="function":!1}e.$Zd=P;function M(a){const l=a;return l?[l.on,l.pause,l.resume,l.destroy].every(r=>typeof r=="function"):!1}e.$1d=M;function R(a){const l=a;return l?M(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.$2d=R;function $(a,l){return new D(a,l)}e.$3d=$;class D{constructor(l,r){this.e=l,this.f=r,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(l){if(!this.a.destroyed){if(this.a.flowing)this.g(l);else if(this.b.data.push(l),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(r=>this.d.push(r))}}error(l){this.a.destroyed||(this.a.flowing?this.h(l):this.b.error.push(l))}end(l){this.a.destroyed||(typeof l<"u"&&this.write(l),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(l){this.c.data.slice(0).forEach(r=>r(l))}h(l){this.c.error.length===0?(0,E.$Z)(l):this.c.error.slice(0).forEach(r=>r(l))}i(){this.c.end.slice(0).forEach(l=>l())}on(l,r){if(!this.a.destroyed)switch(l){case"data":this.c.data.push(r),this.resume();break;case"end":this.c.end.push(r),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(r),this.a.flowing&&this.k();break}}removeListener(l,r){if(this.a.destroyed)return;let s;switch(l){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const c=s.indexOf(r);c>=0&&s.splice(c,1)}}j(){if(this.b.data.length>0){const l=this.e(this.b.data);this.g(l),this.b.data.length=0;const r=[...this.d];this.d.length=0,r.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const l of this.b.error)this.h(l);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function g(a,l){const r=[];let s;for(;(s=a.read())!==null;)r.push(s);return l(r)}e.$4d=g;function A(a,l,r){const s=[];let c;for(;(c=a.read())!==null&&s.length<r;)s.push(c);return c===null&&s.length>0?l(s):{read:()=>{if(s.length>0)return s.shift();if(typeof c<"u"){const h=c;return c=void 0,h}return a.read()}}}e.$5d=A;function S(a,l){return new Promise((r,s)=>{const c=[];o(a,{onData:h=>{l&&c.push(h)},onError:h=>{l?s(h):r(void 0)},onEnd:()=>{r(l?l(c):void 0)}})})}e.$6d=S;function o(a,l,r){a.on("error",s=>{r?.isCancellationRequested||l.onError(s)}),a.on("end",()=>{r?.isCancellationRequested||l.onEnd()}),a.on("data",s=>{r?.isCancellationRequested||l.onData(s)})}e.$7d=o;function v(a,l){return new Promise((r,s)=>{const c=new L.$Qc,h=[],w=k=>{if(h.push(k),h.length>l)return c.dispose(),a.pause(),r({stream:a,buffer:h,ended:!1})},m=k=>(c.dispose(),s(k)),I=()=>(c.dispose(),r({stream:a,buffer:h,ended:!0}));c.add((0,L.$Pc)(()=>a.removeListener("error",m))),a.on("error",m),c.add((0,L.$Pc)(()=>a.removeListener("end",I))),a.on("end",I),c.add((0,L.$Pc)(()=>a.removeListener("data",w))),a.on("data",w)})}e.$8d=v;function p(a,l){const r=$(l);return r.end(a),r}e.$9d=p;function f(){const a=$(()=>{throw new Error("not supported")});return a.end(),a}e.$0d=f;function t(a){let l=!1;return{read:()=>l?null:(l=!0,a)}}e.$$d=t;function i(a,l,r){const s=$(r);return o(a,{onData:c=>s.write(l.data(c)),onError:c=>s.error(l.error?l.error(c):c),onEnd:()=>s.end()}),s}e.$_d=i;function n(a,l,r){let s=!1;return{read:()=>{const c=l.read();return s?c:(s=!0,c!==null?r([a,c]):a)}}}e.$ae=n;function u(a,l,r){let s=!1;const c=$(r);return o(l,{onData:h=>s?c.write(h):(s=!0,c.write(r([a,h]))),onError:h=>c.error(h),onEnd:()=>{s||(s=!0,c.write(a)),c.end()}}),c}e.$be=u}),define(Ae[24],Re([1,0,44,122]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=void 0;const P=typeof Buffer<"u",M=new E.$U(()=>new Uint8Array(256));let R,$;class D{static alloc(y){return P?new D(Buffer.allocUnsafe(y)):new D(new Uint8Array(y))}static wrap(y){return P&&!Buffer.isBuffer(y)&&(y=Buffer.from(y.buffer,y.byteOffset,y.byteLength)),new D(y)}static fromString(y,C){return!(C?.dontUseNodeBuffer||!1)&&P?new D(Buffer.from(y)):(R||(R=new TextEncoder),new D(R.encode(y)))}static fromByteArray(y){const C=D.alloc(y.length);for(let B=0,H=y.length;B<H;B++)C.buffer[B]=y[B];return C}static concat(y,C){if(typeof C>"u"){C=0;for(let U=0,z=y.length;U<z;U++)C+=y[U].byteLength}const B=D.alloc(C);let H=0;for(let U=0,z=y.length;U<z;U++){const F=y[U];B.set(F,H),H+=F.byteLength}return B}constructor(y){this.buffer=y,this.byteLength=this.buffer.byteLength}clone(){const y=D.alloc(this.byteLength);return y.set(this),y}toString(){return P?this.buffer.toString():($||($=new TextDecoder),$.decode(this.buffer))}slice(y,C){return new D(this.buffer.subarray(y,C))}set(y,C){if(y instanceof D)this.buffer.set(y.buffer,C);else if(y instanceof Uint8Array)this.buffer.set(y,C);else if(y instanceof ArrayBuffer)this.buffer.set(new Uint8Array(y),C);else if(ArrayBuffer.isView(y))this.buffer.set(new Uint8Array(y.buffer,y.byteOffset,y.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(y){return o(this.buffer,y)}writeUInt32BE(y,C){v(this.buffer,y,C)}readUInt32LE(y){return p(this.buffer,y)}writeUInt32LE(y,C){f(this.buffer,y,C)}readUInt8(y){return t(this.buffer,y)}writeUInt8(y,C){i(this.buffer,y,C)}indexOf(y,C=0){return g(this.buffer,y instanceof D?y.buffer:y,C)}}e.$ce=D;function g(b,y,C=0){const B=y.byteLength,H=b.byteLength;if(B===0)return 0;if(B===1)return b.indexOf(y[0]);if(B>H-C)return-1;const U=M.value;U.fill(y.length);for(let x=0;x<y.length;x++)U[y[x]]=y.length-x-1;let z=C+y.length-1,F=z,N=-1;for(;z<H;)if(b[z]===y[F]){if(F===0){N=z;break}z--,F--}else z+=Math.max(y.length-F,U[b[z]]),F=y.length-1;return N}e.$de=g;function A(b,y){return b[y+0]<<0>>>0|b[y+1]<<8>>>0}e.$ee=A;function S(b,y,C){b[C+0]=y&255,y=y>>>8,b[C+1]=y&255}e.$fe=S;function o(b,y){return b[y]*2**24+b[y+1]*2**16+b[y+2]*2**8+b[y+3]}e.$ge=o;function v(b,y,C){b[C+3]=y,y=y>>>8,b[C+2]=y,y=y>>>8,b[C+1]=y,y=y>>>8,b[C]=y}e.$he=v;function p(b,y){return b[y+0]<<0>>>0|b[y+1]<<8>>>0|b[y+2]<<16>>>0|b[y+3]<<24>>>0}e.$ie=p;function f(b,y,C){b[C+0]=y&255,y=y>>>8,b[C+1]=y&255,y=y>>>8,b[C+2]=y&255,y=y>>>8,b[C+3]=y&255}e.$je=f;function t(b,y){return b[y]}e.$ke=t;function i(b,y,C){b[C]=y}e.$le=i;function n(b){return L.$4d(b,y=>D.concat(y))}e.$me=n;function u(b){return L.$$d(b)}e.$ne=u;function a(b){return L.$6d(b,y=>D.concat(y))}e.$oe=a;async function l(b){return b.ended?D.concat(b.buffer):D.concat([...b.buffer,await a(b.stream)])}e.$pe=l;function r(b){return L.$9d(b,y=>D.concat(y))}e.$qe=r;function s(b){return L.$_d(b,{data:y=>typeof y=="string"?D.fromString(y):D.wrap(y)},y=>D.concat(y))}e.$re=s;function c(b){return L.$3d(y=>D.concat(y),b)}e.$se=c;function h(b,y){return L.$ae(b,y,C=>D.concat(C))}e.$te=h;function w(b,y){return L.$be(b,y,C=>D.concat(C))}e.$ue=w;function m(b){let y=0,C=0,B=0;const H=new Uint8Array(Math.floor(b.length/4*3)),U=F=>{switch(C){case 3:H[B++]=y|F,C=0;break;case 2:H[B++]=y|F>>>2,y=F<<6,C=3;break;case 1:H[B++]=y|F>>>4,y=F<<4,C=2;break;default:y=F<<2,C=1}};for(let F=0;F<b.length;F++){const N=b.charCodeAt(F);if(N>=65&&N<=90)U(N-65);else if(N>=97&&N<=122)U(N-97+26);else if(N>=48&&N<=57)U(N-48+52);else if(N===43||N===45)U(62);else if(N===47||N===95)U(63);else{if(N===61)break;throw new SyntaxError(`Unexpected base64 character ${b[F]}`)}}const z=B;for(;C>0;)U(0);return D.wrap(H).slice(0,z)}e.$ve=m;const I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function d({buffer:b},y=!0,C=!1){const B=C?k:I;let H="";const U=b.byteLength%3;let z=0;for(;z<b.byteLength-U;z+=3){const F=b[z+0],N=b[z+1],x=b[z+2];H+=B[F>>>2],H+=B[(F<<4|N>>>4)&63],H+=B[(N<<2|x>>>6)&63],H+=B[x&63]}if(U===1){const F=b[z+0];H+=B[F>>>2],H+=B[F<<4&63],y&&(H+="==")}else if(U===2){const F=b[z+0],N=b[z+1];H+=B[F>>>2],H+=B[(F<<4|N>>>4)&63],H+=B[N<<2&63],y&&(H+="=")}return H}e.$we=d}),define(Ae[123],Re([1,0,28,13]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.FuzzyScore=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.or=void 0;function P(...ne){return function(ae,de){for(let Ie=0,T=ne.length;Ie<T;Ie++){const V=ne[Ie](ae,de);if(V)return V}return null}}e.or=P,e.$Gj=M.bind(void 0,!1),e.$Hj=M.bind(void 0,!0);function M(ne,ae,de){if(!de||de.length<ae.length)return null;let Ie;return ne?Ie=L.$4e(de,ae):Ie=de.indexOf(ae)===0,Ie?ae.length>0?[{start:0,end:ae.length}]:[]:null}function R(ne,ae){const de=ae.toLowerCase().indexOf(ne.toLowerCase());return de===-1?null:[{start:de,end:de+ne.length}]}e.$Ij=R;function $(ne,ae){return D(ne.toLowerCase(),ae.toLowerCase(),0,0)}e.$Jj=$;function D(ne,ae,de,Ie){if(de===ne.length)return[];if(Ie===ae.length)return null;if(ne[de]===ae[Ie]){let T=null;return(T=D(ne,ae,de+1,Ie+1))?i({start:Ie,end:Ie+1},T):null}return D(ne,ae,de,Ie+1)}function g(ne){return 97<=ne&&ne<=122}function A(ne){return 65<=ne&&ne<=90}e.$Kj=A;function S(ne){return 48<=ne&&ne<=57}function o(ne){return ne===32||ne===9||ne===10||ne===13}const v=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ne=>v.add(ne.charCodeAt(0)));function p(ne){return o(ne)||v.has(ne)}function f(ne,ae){return ne===ae||p(ne)&&p(ae)}function t(ne){return g(ne)||A(ne)||S(ne)}function i(ne,ae){return ae.length===0?ae=[ne]:ne.end===ae[0].start?ae[0].start=ne.start:ae.unshift(ne),ae}function n(ne,ae){for(let de=ae;de<ne.length;de++){const Ie=ne.charCodeAt(de);if(A(Ie)||S(Ie)||de>0&&!t(ne.charCodeAt(de-1)))return de}return ne.length}function u(ne,ae,de,Ie){if(de===ne.length)return[];if(Ie===ae.length)return null;if(ne[de]!==ae[Ie].toLowerCase())return null;{let T=null,V=Ie+1;for(T=u(ne,ae,de+1,Ie+1);!T&&(V=n(ae,V))<ae.length;)T=u(ne,ae,de+1,V),V++;return T===null?null:i({start:Ie,end:Ie+1},T)}}function a(ne){let ae=0,de=0,Ie=0,T=0,V=0;for(let he=0;he<ne.length;he++)V=ne.charCodeAt(he),A(V)&&ae++,g(V)&&de++,t(V)&&Ie++,S(V)&&T++;const G=ae/ne.length,Q=de/ne.length,q=Ie/ne.length,_=T/ne.length;return{upperPercent:G,lowerPercent:Q,alphaPercent:q,numericPercent:_}}function l(ne){const{upperPercent:ae,lowerPercent:de}=ne;return de===0&&ae>.6}function r(ne){const{upperPercent:ae,lowerPercent:de,alphaPercent:Ie,numericPercent:T}=ne;return de>.2&&ae<.8&&Ie>.6&&T<.2}function s(ne){let ae=0,de=0,Ie=0,T=0;for(let V=0;V<ne.length;V++)Ie=ne.charCodeAt(V),A(Ie)&&ae++,g(Ie)&&de++,o(Ie)&&T++;return(ae===0||de===0)&&T===0?ne.length<=30:ae<=5}function c(ne,ae){if(!ae||(ae=ae.trim(),ae.length===0)||!s(ne)||ae.length>60)return null;const de=a(ae);if(!r(de)){if(!l(de))return null;ae=ae.toLowerCase()}let Ie=null,T=0;for(ne=ne.toLowerCase();T<ae.length&&(Ie=u(ne,ae,0,T))===null;)T=n(ae,T+1);return Ie}e.$Lj=c;function h(ne,ae,de=!1){if(!ae||ae.length===0)return null;let Ie=null,T=0;for(ne=ne.toLowerCase(),ae=ae.toLowerCase();T<ae.length&&(Ie=w(ne,ae,0,T,de))===null;)T=m(ae,T+1);return Ie}e.$Mj=h;function w(ne,ae,de,Ie,T){if(de===ne.length)return[];if(Ie===ae.length)return null;if(f(ne.charCodeAt(de),ae.charCodeAt(Ie))){let V=null,G=Ie+1;if(V=w(ne,ae,de+1,Ie+1,T),!T)for(;!V&&(G=m(ae,G))<ae.length;)V=w(ne,ae,de+1,G,T),G++;return V?ne.charCodeAt(de)!==ae.charCodeAt(Ie)?V:i({start:Ie,end:Ie+1},V):null}else return null}function m(ne,ae){for(let de=ae;de<ne.length;de++)if(p(ne.charCodeAt(de))||de>0&&p(ne.charCodeAt(de-1)))return de;return ne.length}const I=P(e.$Hj,c,R),k=P(e.$Hj,c,$),d=new E.$Cc(1e4);function b(ne,ae,de=!1){if(typeof ne!="string"||typeof ae!="string")return null;let Ie=d.get(ne);Ie||(Ie=new RegExp(L.$Me(ne),"i"),d.set(ne,Ie));const T=Ie.exec(ae);return T?[{start:T.index,end:T.index+T[0].length}]:de?k(ne,ae):I(ne,ae)}e.$Nj=b;function y(ne,ae){const de=Pe(ne,ne.toLowerCase(),0,ae,ae.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return de?B(de):null}e.$Oj=y;function C(ne,ae,de,Ie,T,V){const G=Math.min(13,ne.length);for(;de<G;de++){const Q=Pe(ne,ae,de,Ie,T,V,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Q)return Q}return[0,V]}e.$Pj=C;function B(ne){if(typeof ne>"u")return[];const ae=[],de=ne[1];for(let Ie=ne.length-1;Ie>1;Ie--){const T=ne[Ie]+de,V=ae[ae.length-1];V&&V.end===T?V.end=T+1:ae.push({start:T,end:T+1})}return ae}e.$Qj=B;const H=128;function U(){const ne=[],ae=[];for(let de=0;de<=H;de++)ae[de]=0;for(let de=0;de<=H;de++)ne.push(ae.slice(0));return ne}function z(ne){const ae=[];for(let de=0;de<=ne;de++)ae[de]=0;return ae}const F=z(2*H),N=z(2*H),x=U(),J=U(),ye=U(),De=!1;function Ce(ne,ae,de,Ie,T){function V(Q,q,_=" "){for(;Q.length<q;)Q=_+Q;return Q}let G=` |   |${Ie.split("").map(Q=>V(Q,3)).join("|")}
`;for(let Q=0;Q<=de;Q++)Q===0?G+=" |":G+=`${ae[Q-1]}|`,G+=ne[Q].slice(0,T+1).map(q=>V(q.toString(),3)).join("|")+`
`;return G}function ge(ne,ae,de,Ie){ne=ne.substr(ae),de=de.substr(Ie),console.log(Ce(J,ne,ne.length,de,de.length)),console.log(Ce(ye,ne,ne.length,de,de.length)),console.log(Ce(x,ne,ne.length,de,de.length))}function we(ne,ae){if(ae<0||ae>=ne.length)return!1;const de=ne.codePointAt(ae);switch(de){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!L.$jf(de)}}function re(ne,ae){if(ae<0||ae>=ne.length)return!1;switch(ne.charCodeAt(ae)){case 32:case 9:return!0;default:return!1}}function oe(ne,ae,de){return ae[ne]!==de[ne]}function ve(ne,ae,de,Ie,T,V,G=!1){for(;ae<de&&T<V;)ne[ae]===Ie[T]&&(G&&(F[ae]=T),ae+=1),T+=1;return ae===de}e.$Rj=ve;var ee;(function(ne){ne[ne.Diag=1]="Diag",ne[ne.Left=2]="Left",ne[ne.LeftLeft=3]="LeftLeft"})(ee||(ee={}));var W;(function(ne){ne.Default=[-100,0];function ae(de){return!de||de.length===2&&de[0]===-100&&de[1]===0}ne.isDefault=ae})(W||(e.FuzzyScore=W={}));class ue{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(ae,de){this.firstMatchCanBeWeak=ae,this.boostFullMatch=de}}e.$Sj=ue;function Pe(ne,ae,de,Ie,T,V,G=ue.default){const Q=ne.length>H?H:ne.length,q=Ie.length>H?H:Ie.length;if(de>=Q||V>=q||Q-de>q-V||!ve(ae,de,Q,T,V,q,!0))return;Ee(Q,q,de,V,ae,T);let _=1,he=1,Oe=de,je=V;const Qe=[!1];for(_=1,Oe=de;Oe<Q;_++,Oe++){const it=F[Oe],tt=N[Oe],ze=Oe+1<Q?N[Oe+1]:q;for(he=it-V+1,je=it;je<ze;he++,je++){let ut=Number.MIN_SAFE_INTEGER,Y=!1;je<=tt&&(ut=te(ne,ae,Oe,de,Ie,T,je,q,V,x[_-1][he-1]===0,Qe));let X=0;ut!==Number.MAX_SAFE_INTEGER&&(Y=!0,X=ut+J[_-1][he-1]);const be=je>it,Be=be?J[_][he-1]+(x[_][he-1]>0?-5:0):0,Ne=je>it+1&&x[_][he-1]>0,Xe=Ne?J[_][he-2]+(x[_][he-2]>0?-5:0):0;if(Ne&&(!be||Xe>=Be)&&(!Y||Xe>=X))J[_][he]=Xe,ye[_][he]=3,x[_][he]=0;else if(be&&(!Y||Be>=X))J[_][he]=Be,ye[_][he]=2,x[_][he]=0;else if(Y)J[_][he]=X,ye[_][he]=1,x[_][he]=x[_-1][he-1]+1;else throw new Error("not possible")}}if(De&&ge(ne,de,Ie,V),!Qe[0]&&!G.firstMatchCanBeWeak)return;_--,he--;const Ge=[J[_][he],V];let _e=0,Ye=0;for(;_>=1;){let it=he;do{const tt=ye[_][it];if(tt===3)it=it-2;else if(tt===2)it=it-1;else break}while(it>=1);_e>1&&ae[de+_-1]===T[V+he-1]&&!oe(it+V-1,Ie,T)&&_e+1>x[_][it]&&(it=he),it===he?_e++:_e=1,Ye||(Ye=it),_--,he=it-1,Ge.push(he)}q===Q&&G.boostFullMatch&&(Ge[0]+=2);const xe=Ye-Q;return Ge[0]-=xe,Ge}e.$Tj=Pe;function Ee(ne,ae,de,Ie,T,V){let G=ne-1,Q=ae-1;for(;G>=de&&Q>=Ie;)T[G]===V[Q]&&(N[G]=Q,G--),Q--}function te(ne,ae,de,Ie,T,V,G,Q,q,_,he){if(ae[de]!==V[G])return Number.MIN_SAFE_INTEGER;let Oe=1,je=!1;return G===de-Ie?Oe=ne[de]===T[G]?7:5:oe(G,T,V)&&(G===0||!oe(G-1,T,V))?(Oe=ne[de]===T[G]?7:5,je=!0):we(V,G)&&(G===0||!we(V,G-1))?Oe=5:(we(V,G-1)||re(V,G-1))&&(Oe=5,je=!0),Oe>1&&de===Ie&&(he[0]=!0),je||(je=oe(G,T,V)||we(V,G-1)||re(V,G-1)),de===Ie?G>q&&(Oe-=je?3:5):_?Oe+=je?2:0:Oe+=je?0:1,G+1===Q&&(Oe-=je?3:5),Oe}function se(ne,ae,de,Ie,T,V,G){return Z(ne,ae,de,Ie,T,V,!0,G)}e.$Uj=se;function me(ne,ae,de,Ie,T,V,G){return Z(ne,ae,de,Ie,T,V,!1,G)}e.$Vj=me;function Z(ne,ae,de,Ie,T,V,G,Q){let q=Pe(ne,ae,de,Ie,T,V,Q);if(q&&!G)return q;if(ne.length>=3){const _=Math.min(7,ne.length-1);for(let he=de+1;he<_;he++){const Oe=le(ne,he);if(Oe){const je=Pe(Oe,Oe.toLowerCase(),de,Ie,T,V,Q);je&&(je[0]-=3,(!q||je[0]>q[0])&&(q=je))}}}return q}function le(ne,ae){if(ae+1>=ne.length)return;const de=ne[ae],Ie=ne[ae+1];if(de!==Ie)return ne.slice(0,ae)+Ie+de+ne.slice(ae+2)}}),define(Ae[31],Re([1,0,13]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(L||(L={})),function(P){const M="error",R="warning",$="warn",D="info",g="ignore";function A(o){return o?E.$3e(M,o)?P.Error:E.$3e(R,o)||E.$3e($,o)?P.Warning:E.$3e(D,o)?P.Info:P.Ignore:P.Ignore}P.fromValue=A;function S(o){switch(o){case P.Error:return M;case P.Warning:return R;case P.Info:return D;default:return g}}P.toString=S}(L||(L={})),e.default=L}),define(Ae[124],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ld=void 0,e.$Ld=Symbol("MicrotaskDelay")}),define(Ae[51],Re([1,0,18,13]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=void 0;class P{constructor(){this.b="",this.c=0}reset(v){return this.b=v,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(v){const p=v.charCodeAt(0),f=this.b.charCodeAt(this.c);return p-f}value(){return this.b[this.c]}}e.$Vh=P;class M{constructor(v=!0){this.e=v}reset(v){return this.b=v,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let v=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(v)this.c++;else break;else v=!1;return this}cmp(v){return this.e?(0,L.$We)(v,this.b,0,v.length,this.c,this.d):(0,L.$Ye)(v,this.b,0,v.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Wh=M;class R{constructor(v=!0,p=!0){this.f=v,this.g=p}reset(v){this.d=0,this.e=0,this.b=v,this.c=v.length;for(let p=v.length-1;p>=0;p--,this.c--){const f=this.b.charCodeAt(p);if(!(f===47||this.f&&f===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let v=!0;for(;this.e<this.c;this.e++){const p=this.b.charCodeAt(this.e);if(p===47||this.f&&p===92)if(v)this.d++;else break;else v=!1}return this}cmp(v){return this.g?(0,L.$We)(v,this.b,0,v.length,this.d,this.e):(0,L.$Ye)(v,this.b,0,v.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Xh=R;var $;(function(o){o[o.Scheme=1]="Scheme",o[o.Authority=2]="Authority",o[o.Path=3]="Path",o[o.Query=4]="Query",o[o.Fragment=5]="Fragment"})($||($={}));class D{constructor(v,p){this.f=v,this.g=p,this.d=[],this.e=0}reset(v){return this.c=v,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(v)),this.b.reset(v.path),this.b.value()&&this.d.push(3)),this.g(v)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(v){if(this.d[this.e]===1)return(0,L.$Xe)(v,this.c.scheme);if(this.d[this.e]===2)return(0,L.$Xe)(v,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(v);if(this.d[this.e]===4)return(0,L.$Ve)(v,this.c.query);if(this.d[this.e]===5)return(0,L.$Ve)(v,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Yh=D;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const v=this.right;return this.right=v.left,v.left=this,this.updateHeight(),v.updateHeight(),v}rotateRight(){const v=this.left;return this.left=v.right,v.right=this,this.updateHeight(),v.updateHeight(),v}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function(o){o[o.Left=-1]="Left",o[o.Mid=0]="Mid",o[o.Right=1]="Right"})(A||(A={}));class S{static forUris(v=()=>!1,p=()=>!1){return new S(new D(v,p))}static forPaths(v=!1){return new S(new R(void 0,!v))}static forStrings(){return new S(new P)}static forConfigKeys(){return new S(new M)}constructor(v){this.b=v}clear(){this.c=void 0}fill(v,p){if(p){const f=p.slice(0);(0,E.$Wb)(f);for(const t of f)this.set(t,v)}else{const f=v.slice(0);(0,E.$Wb)(f);for(const t of f)this.set(t[0],t[1])}}set(v,p){const f=this.b.reset(v);let t;this.c||(this.c=new g,this.c.segment=f.value());const i=[];for(t=this.c;;){const u=f.cmp(t.segment);if(u>0)t.left||(t.left=new g,t.left.segment=f.value()),i.push([-1,t]),t=t.left;else if(u<0)t.right||(t.right=new g,t.right.segment=f.value()),i.push([1,t]),t=t.right;else if(f.hasNext())f.next(),t.mid||(t.mid=new g,t.mid.segment=f.value()),i.push([0,t]),t=t.mid;else break}const n=t.value;t.value=p,t.key=v;for(let u=i.length-1;u>=0;u--){const a=i[u][1];a.updateHeight();const l=a.balanceFactor();if(l<-1||l>1){const r=i[u][0],s=i[u+1][0];if(r===1&&s===1)i[u][1]=a.rotateLeft();else if(r===-1&&s===-1)i[u][1]=a.rotateRight();else if(r===1&&s===-1)a.right=i[u+1][1]=i[u+1][1].rotateRight(),i[u][1]=a.rotateLeft();else if(r===-1&&s===1)a.left=i[u+1][1]=i[u+1][1].rotateLeft(),i[u][1]=a.rotateRight();else throw new Error;if(u>0)switch(i[u-1][0]){case-1:i[u-1][1].left=i[u][1];break;case 1:i[u-1][1].right=i[u][1];break;case 0:i[u-1][1].mid=i[u][1];break}else this.c=i[0][1]}}return n}get(v){return this.d(v)?.value}d(v){const p=this.b.reset(v);let f=this.c;for(;f;){const t=p.cmp(f.segment);if(t>0)f=f.left;else if(t<0)f=f.right;else if(p.hasNext())p.next(),f=f.mid;else break}return f}has(v){const p=this.d(v);return!(p?.value===void 0&&p?.mid===void 0)}delete(v){return this.e(v,!1)}deleteSuperstr(v){return this.e(v,!0)}e(v,p){const f=this.b.reset(v),t=[];let i=this.c;for(;i;){const n=f.cmp(i.segment);if(n>0)t.push([-1,i]),i=i.left;else if(n<0)t.push([1,i]),i=i.right;else if(f.hasNext())f.next(),t.push([0,i]),i=i.mid;else break}if(i){if(p?(i.left=void 0,i.mid=void 0,i.right=void 0,i.height=1):(i.key=void 0,i.value=void 0),!i.mid&&!i.value)if(i.left&&i.right){const n=this.f(i.right);if(n.key){const{key:u,value:a,segment:l}=n;this.e(n.key,!1),i.key=u,i.value=a,i.segment=l}}else{const n=i.left??i.right;if(t.length>0){const[u,a]=t[t.length-1];switch(u){case-1:a.left=n;break;case 0:a.mid=n;break;case 1:a.right=n;break}}else this.c=n}for(let n=t.length-1;n>=0;n--){const u=t[n][1];u.updateHeight();const a=u.balanceFactor();if(a>1?(u.right.balanceFactor()>=0||(u.right=u.right.rotateRight()),t[n][1]=u.rotateLeft()):a<-1&&(u.left.balanceFactor()<=0||(u.left=u.left.rotateLeft()),t[n][1]=u.rotateRight()),n>0)switch(t[n-1][0]){case-1:t[n-1][1].left=t[n][1];break;case 1:t[n-1][1].right=t[n][1];break;case 0:t[n-1][1].mid=t[n][1];break}else this.c=t[0][1]}}}f(v){for(;v.left;)v=v.left;return v}findSubstr(v){const p=this.b.reset(v);let f=this.c,t;for(;f;){const i=p.cmp(f.segment);if(i>0)f=f.left;else if(i<0)f=f.right;else if(p.hasNext())p.next(),t=f.value||t,f=f.mid;else break}return f&&f.value||t}findSuperstr(v){return this.g(v,!1)}g(v,p){const f=this.b.reset(v);let t=this.c;for(;t;){const i=f.cmp(t.segment);if(i>0)t=t.left;else if(i<0)t=t.right;else if(f.hasNext())f.next(),t=t.mid;else return t.mid?this.h(t.mid):p?t.value:void 0}}hasElementOrSubtree(v){return this.g(v,!0)!==void 0}forEach(v){for(const[p,f]of this)v(f,p)}*[Symbol.iterator](){yield*this.h(this.c)}h(v){const p=[];return this.j(v,p),p[Symbol.iterator]()}j(v,p){v&&(v.left&&this.j(v.left,p),v.value&&p.push([v.key,v.value]),v.mid&&this.j(v.mid,p),v.right&&this.j(v.right,p))}_isBalanced(){const v=p=>{if(!p)return!0;const f=p.balanceFactor();return f<-1||f>1?!1:v(p.left)&&v(p.right)};return v(this.c)}}e.$Zh=S}),define(Ae[45],Re([1,0,90]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Zj=e.ThemeColor=void 0;var L;(function(R){function $(D){return D&&typeof D=="object"&&typeof D.id=="string"}R.isThemeColor=$})(L||(e.ThemeColor=L={}));function P(R){return{id:R}}e.$Zj=P;var M;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const $=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function D(n){const u=$.exec(n.id);if(!u)return D(E.$Yj.error);const[,a,l]=u,r=["codicon","codicon-"+a];return l&&r.push("codicon-modifier-"+l.substring(1)),r}R.asClassNameArray=D;function g(n){return D(n).join(" ")}R.asClassName=g;function A(n){return"."+D(n).join(".")}R.asCSSSelector=A;function S(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||L.isThemeColor(n.color))}R.isThemeIcon=S;const o=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function v(n){const u=o.exec(n);if(!u)return;const[,a]=u;return{id:a}}R.fromString=v;function p(n){return{id:n}}R.fromId=p;function f(n,u){let a=n.id;const l=a.lastIndexOf("~");return l!==-1&&(a=a.substring(0,l)),u&&(a=`${a}~${u}`),{id:a}}R.modify=f;function t(n){const u=n.id.lastIndexOf("~");if(u!==-1)return n.id.substring(u+1)}R.getModifier=t;function i(n,u){return n.id===u.id&&n.color?.id===u.color?.id}R.isEqual=i})(M||(e.ThemeIcon=M={}))}),define(Ae[125],Re([1,0,123,13,45]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6j=e.$5j=e.$4j=e.$3j=e.$2j=e.$1j=void 0;const M="$(",R=new RegExp(`\\$\\(${P.ThemeIcon.iconNameExpression}(?:${P.ThemeIcon.iconModifierExpression})?\\)`,"g"),$=new RegExp(`(\\\\)?${R.source}`,"g");function D(i){return i.replace($,(n,u)=>u?n:`\\${n}`)}e.$1j=D;const g=new RegExp(`\\\\${R.source}`,"g");function A(i){return i.replace(g,n=>`\\${n}`)}e.$2j=A;const S=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function o(i){return i.indexOf(M)===-1?i:i.replace(S,(n,u,a,l)=>a?n:u||l||"")}e.$3j=o;function v(i){return i?i.replace(/\$\((.*?)\)/g,(n,u)=>` ${u} `).trim():""}e.$4j=v;const p=new RegExp(`\\$\\(${P.ThemeIcon.iconNameCharacter}+\\)`,"g");function f(i){p.lastIndex=0;let n="";const u=[];let a=0;for(;;){const l=p.lastIndex,r=p.exec(i),s=i.substring(l,r?.index);if(s.length>0){n+=s;for(let c=0;c<s.length;c++)u.push(a)}if(!r)break;a+=r[0].length}return{text:n,iconOffsets:u}}e.$5j=f;function t(i,n,u=!1){const{text:a,iconOffsets:l}=n;if(!l||l.length===0)return(0,E.$Nj)(i,a,u);const r=(0,L.$Ke)(a," "),s=a.length-r.length,c=(0,E.$Nj)(i,r,u);if(c)for(const h of c){const w=l[h.start+s]+s;h.start+=w,h.end+=w}return c}e.$6j=t}),define(Ae[38],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fg=e.$eg=void 0;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(P){return E.test(P)}e.$eg=L,e.$fg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function($){for(let D=0;D<$.length;D++)$[D]=Math.floor(Math.random()*256);return $};const M=new Uint8Array(16),R=[];for(let $=0;$<256;$++)R.push($.toString(16).padStart(2,"0"));return function(){P(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let D=0,g="";return g+=R[M[D++]],g+=R[M[D++]],g+=R[M[D++]],g+=R[M[D++]],g+="-",g+=R[M[D++]],g+=R[M[D++]],g+="-",g+=R[M[D++]],g+=R[M[D++]],g+="-",g+=R[M[D++]],g+=R[M[D++]],g+="-",g+=R[M[D++]],g+=R[M[D++]],g+=R[M[D++]],g+=R[M[D++]],g+=R[M[D++]],g+=R[M[D++]],g}}()}),define(Ae[126],Re([1,0,18,68,38]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7s=e.$6s=e.$5s=e.$4s=e.$3s=void 0;function M(S){return{asString:async()=>S,asFile:()=>{},value:typeof S=="string"?S:void 0}}e.$3s=M;function R(S,o,v){const p={id:(0,P.$fg)(),name:S,uri:o,data:v};return{asString:async()=>"",asFile:()=>p,value:void 0}}e.$4s=R;class ${constructor(){this.a=new Map}get size(){let o=0;for(const v of this.a)o++;return o}has(o){return this.a.has(this.b(o))}matches(o){const v=[...this.a.keys()];return L.Iterable.some(this,([p,f])=>f.asFile())&&v.push("files"),A(D(o),v)}get(o){return this.a.get(this.b(o))?.[0]}append(o,v){const p=this.a.get(o);p?p.push(v):this.a.set(this.b(o),[v])}replace(o,v){this.a.set(this.b(o),[v])}delete(o){this.a.delete(this.b(o))}*[Symbol.iterator](){for(const[o,v]of this.a)for(const p of v)yield[o,p]}b(o){return D(o)}}e.$5s=$;function D(S){return S.toLowerCase()}function g(S,o){return A(D(S),o.map(D))}e.$6s=g;function A(S,o){if(S==="*/*")return o.length>0;if(o.includes(S))return!0;const v=S.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!v)return!1;const[p,f,t]=v;return t==="*"?o.some(i=>i.startsWith(f+"/")):!1}e.$7s=Object.freeze({create:S=>(0,E.$Lb)(S.map(o=>o.toString())).join(`\r
`),split:S=>S.split(`\r
`),parse:S=>e.$7s.split(S).filter(o=>!o.startsWith("#"))})}),define(Ae[127],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0s=e.StringEOL=void 0;var E;(function(P){P[P.Unknown=0]="Unknown",P[P.Invalid=3]="Invalid",P[P.LF=1]="LF",P[P.CRLF=2]="CRLF"})(E||(e.StringEOL=E={}));function L(P){let M=0,R=0,$=0,D=0;for(let g=0,A=P.length;g<A;g++){const S=P.charCodeAt(g);S===13?(M===0&&(R=g),M++,g+1<A&&P.charCodeAt(g+1)===10?(D|=2,g++):D|=3,$=g+1):S===10&&(D|=1,M===0&&(R=g),M++,$=g+1)}return M===0&&(R=P.length),[M,R,P.length-$,D]}e.$0s=L}),define(Ae[128],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7r=void 0,e.$7r={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ae[129],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ut=e.$tt=e.IndentAction=void 0;var E;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(E||(e.IndentAction=E={}));class L{constructor($){if(this.e=null,this.f=!1,this.open=$.open,this.close=$.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray($.notIn))for(let D=0,g=$.notIn.length;D<g;D++)switch($.notIn[D]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK($){switch($){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose($,D){if($.getTokenCount()===0)return!0;const g=$.findTokenIndexAtOffset(D-2),A=$.getStandardTokenType(g);return this.isOK(A)}g($,D){for(let g=$;g<=D;g++){const A=String.fromCharCode(g);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$tt=L;class P{constructor($){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of $)M(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),M(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),M(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),M(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&M(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.$ut=P;function M(R,$,D){R.has($)?R.get($).push(D):R.set($,[D])}}),define(Ae[130],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xB=e.$wB=e.$vB=e.$uB=e.$tB=e.$sB=e.$rB=e.$qB=e.$pB=e.NodeColor=e.$oB=void 0;class E{constructor(t,i){this.piece=t,this.color=i,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$pB)return P(this.right);let t=this;for(;t.parent!==e.$pB&&t.parent.left!==t;)t=t.parent;return t.parent===e.$pB?e.$pB:t.parent}prev(){if(this.left!==e.$pB)return M(this.left);let t=this;for(;t.parent!==e.$pB&&t.parent.right!==t;)t=t.parent;return t.parent===e.$pB?e.$pB:t.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$oB=E;var L;(function(f){f[f.Black=0]="Black",f[f.Red=1]="Red"})(L||(e.NodeColor=L={})),e.$pB=new E(null,0),e.$pB.parent=e.$pB,e.$pB.left=e.$pB,e.$pB.right=e.$pB,e.$pB.color=0;function P(f){for(;f.left!==e.$pB;)f=f.left;return f}e.$qB=P;function M(f){for(;f.right!==e.$pB;)f=f.right;return f}e.$rB=M;function R(f){return f===e.$pB?0:f.size_left+f.piece.length+R(f.right)}function $(f){return f===e.$pB?0:f.lf_left+f.piece.lineFeedCnt+$(f.right)}function D(){e.$pB.parent=e.$pB}function g(f,t){const i=t.right;i.size_left+=t.size_left+(t.piece?t.piece.length:0),i.lf_left+=t.lf_left+(t.piece?t.piece.lineFeedCnt:0),t.right=i.left,i.left!==e.$pB&&(i.left.parent=t),i.parent=t.parent,t.parent===e.$pB?f.root=i:t.parent.left===t?t.parent.left=i:t.parent.right=i,i.left=t,t.parent=i}e.$sB=g;function A(f,t){const i=t.left;t.left=i.right,i.right!==e.$pB&&(i.right.parent=t),i.parent=t.parent,t.size_left-=i.size_left+(i.piece?i.piece.length:0),t.lf_left-=i.lf_left+(i.piece?i.piece.lineFeedCnt:0),t.parent===e.$pB?f.root=i:t===t.parent.right?t.parent.right=i:t.parent.left=i,i.right=t,t.parent=i}e.$tB=A;function S(f,t){let i,n;if(t.left===e.$pB?(n=t,i=n.right):t.right===e.$pB?(n=t,i=n.left):(n=P(t.right),i=n.right),n===f.root){f.root=i,i.color=0,t.detach(),D(),f.root.parent=e.$pB;return}const u=n.color===1;if(n===n.parent.left?n.parent.left=i:n.parent.right=i,n===t?(i.parent=n.parent,p(f,i)):(n.parent===t?i.parent=n:i.parent=n.parent,p(f,i),n.left=t.left,n.right=t.right,n.parent=t.parent,n.color=t.color,t===f.root?f.root=n:t===t.parent.left?t.parent.left=n:t.parent.right=n,n.left!==e.$pB&&(n.left.parent=n),n.right!==e.$pB&&(n.right.parent=n),n.size_left=t.size_left,n.lf_left=t.lf_left,p(f,n)),t.detach(),i.parent.left===i){const l=R(i),r=$(i);if(l!==i.parent.size_left||r!==i.parent.lf_left){const s=l-i.parent.size_left,c=r-i.parent.lf_left;i.parent.size_left=l,i.parent.lf_left=r,v(f,i.parent,s,c)}}if(p(f,i.parent),u){D();return}let a;for(;i!==f.root&&i.color===0;)i===i.parent.left?(a=i.parent.right,a.color===1&&(a.color=0,i.parent.color=1,g(f,i.parent),a=i.parent.right),a.left.color===0&&a.right.color===0?(a.color=1,i=i.parent):(a.right.color===0&&(a.left.color=0,a.color=1,A(f,a),a=i.parent.right),a.color=i.parent.color,i.parent.color=0,a.right.color=0,g(f,i.parent),i=f.root)):(a=i.parent.left,a.color===1&&(a.color=0,i.parent.color=1,A(f,i.parent),a=i.parent.left),a.left.color===0&&a.right.color===0?(a.color=1,i=i.parent):(a.left.color===0&&(a.right.color=0,a.color=1,g(f,a),a=i.parent.left),a.color=i.parent.color,i.parent.color=0,a.left.color=0,A(f,i.parent),i=f.root));i.color=0,D()}e.$uB=S;function o(f,t){for(p(f,t);t!==f.root&&t.parent.color===1;)if(t.parent===t.parent.parent.left){const i=t.parent.parent.right;i.color===1?(t.parent.color=0,i.color=0,t.parent.parent.color=1,t=t.parent.parent):(t===t.parent.right&&(t=t.parent,g(f,t)),t.parent.color=0,t.parent.parent.color=1,A(f,t.parent.parent))}else{const i=t.parent.parent.left;i.color===1?(t.parent.color=0,i.color=0,t.parent.parent.color=1,t=t.parent.parent):(t===t.parent.left&&(t=t.parent,A(f,t)),t.parent.color=0,t.parent.parent.color=1,g(f,t.parent.parent))}f.root.color=0}e.$vB=o;function v(f,t,i,n){for(;t!==f.root&&t!==e.$pB;)t.parent.left===t&&(t.parent.size_left+=i,t.parent.lf_left+=n),t=t.parent}e.$wB=v;function p(f,t){let i=0,n=0;if(t!==f.root){for(;t!==f.root&&t===t.parent.right;)t=t.parent;if(t!==f.root)for(t=t.parent,i=R(t.left)-t.size_left,n=$(t.left)-t.lf_left,t.size_left+=i,t.lf_left+=n;t!==f.root&&(i!==0||n!==0);)t.parent.left===t&&(t.parent.size_left+=i,t.parent.lf_left+=n),t=t.parent}}e.$xB=p}),define(Ae[91],Re([1,0,131,29,92,130,93]),function(pe,e,E,L,P,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IB=e.$HB=e.$GB=e.$FB=e.$EB=void 0;const $=65535;function D(i){let n;return i[i.length-1]<65536?n=new Uint16Array(i.length):n=new Uint32Array(i.length),n.set(i,0),n}class g{constructor(n,u,a,l,r){this.lineStarts=n,this.cr=u,this.lf=a,this.crlf=l,this.isBasicASCII=r}}function A(i,n=!0){const u=[0];let a=1;for(let l=0,r=i.length;l<r;l++){const s=i.charCodeAt(l);s===13?l+1<r&&i.charCodeAt(l+1)===10?(u[a++]=l+2,l++):u[a++]=l+1:s===10&&(u[a++]=l+1)}return n?D(u):u}e.$EB=A;function S(i,n){i.length=0,i[0]=0;let u=1,a=0,l=0,r=0,s=!0;for(let h=0,w=n.length;h<w;h++){const m=n.charCodeAt(h);m===13?h+1<w&&n.charCodeAt(h+1)===10?(r++,i[u++]=h+2,h++):(a++,i[u++]=h+1):m===10?(l++,i[u++]=h+1):s&&m!==9&&(m<32||m>126)&&(s=!1)}const c=new g(D(i),a,l,r,s);return i.length=0,c}e.$FB=S;class o{constructor(n,u,a,l,r){this.bufferIndex=n,this.start=u,this.end=a,this.lineFeedCnt=l,this.length=r}}e.$GB=o;class v{constructor(n,u){this.buffer=n,this.lineStarts=u}}e.$HB=v;class p{constructor(n,u){this.a=[],this.c=n,this.d=u,this.b=0,n.root!==M.$pB&&n.iterate(n.root,a=>(a!==M.$pB&&this.a.push(a.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class f{constructor(n){this.a=n,this.b=[]}get(n){for(let u=this.b.length-1;u>=0;u--){const a=this.b[u];if(a.nodeStartOffset<=n&&a.nodeStartOffset+a.node.piece.length>=n)return a}return null}get2(n){for(let u=this.b.length-1;u>=0;u--){const a=this.b[u];if(a.nodeStartLineNumber&&a.nodeStartLineNumber<n&&a.nodeStartLineNumber+a.node.piece.lineFeedCnt>=n)return a}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let u=!1;const a=this.b;for(let l=0;l<a.length;l++){const r=a[l];if(r.node.parent===null||r.nodeStartOffset>=n){a[l]=null,u=!0;continue}}if(u){const l=[];for(const r of a)r!==null&&l.push(r);this.b=l}}}class t{constructor(n,u,a){this.create(n,u,a)}create(n,u,a){this.a=[new v("",[0])],this.g={line:0,column:0},this.root=M.$pB,this.b=1,this.c=0,this.d=u,this.e=u.length,this.f=a;let l=null;for(let r=0,s=n.length;r<s;r++)if(n[r].buffer.length>0){n[r].lineStarts||(n[r].lineStarts=A(n[r].buffer));const c=new o(r+1,{line:0,column:0},{line:n[r].lineStarts.length-1,column:n[r].buffer.length-n[r].lineStarts[n[r].lineStarts.length-1]},n[r].lineStarts.length-1,n[r].buffer.length);this.a.push(n[r]),l=this.S(l,c)}this.h=new f(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const u=$,a=u-Math.floor(u/3),l=a*2;let r="",s=0;const c=[];if(this.iterate(this.root,h=>{const w=this.R(h),m=w.length;if(s<=a||s+m<l)return r+=w,s+=m,!0;const I=r.replace(/\r\n|\r|\n/g,n);return c.push(new v(I,A(I))),r=w,s=m,!0}),s>0){const h=r.replace(/\r\n|\r|\n/g,n);c.push(new v(h,A(h)))}this.create(c,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new p(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let u=0;return this.iterate(this.root,l=>{if(l===M.$pB)return!0;const r=this.R(l),s=r.length,c=n.G(u),h=n.G(u+s),w=n.getValueInRange2(c,h);return u+=s,r===w})}getOffsetAt(n,u){let a=0,l=this.root;for(;l!==M.$pB;)if(l.left!==M.$pB&&l.lf_left+1>=n)l=l.left;else if(l.lf_left+l.piece.lineFeedCnt+1>=n){a+=l.size_left;const r=this.B(l,n-l.lf_left-2);return a+=r+u-1}else n-=l.lf_left+l.piece.lineFeedCnt,a+=l.size_left+l.piece.length,l=l.right;return a}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let u=this.root,a=0;const l=n;for(;u!==M.$pB;)if(u.size_left!==0&&u.size_left>=n)u=u.left;else if(u.size_left+u.piece.length>=n){const r=this.A(u,n-u.size_left);if(a+=u.lf_left+r.index,r.index===0){const s=this.getOffsetAt(a+1,1),c=l-s;return new E.$ws(a+1,c+1)}return new E.$ws(a+1,r.remainder+1)}else if(n-=u.size_left+u.piece.length,a+=u.lf_left+u.piece.lineFeedCnt,u.right===M.$pB){const r=this.getOffsetAt(a+1,1),s=l-n-r;return new E.$ws(a+1,s+1)}else u=u.right;return new E.$ws(1,1)}getValueInRange(n,u){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const a=this.H(n.startLineNumber,n.startColumn),l=this.H(n.endLineNumber,n.endColumn),r=this.getValueInRange2(a,l);return u?u!==this.d||!this.f?r.replace(/\r\n|\r|\n/g,u):u===this.getEOL()&&this.f?r:r.replace(/\r\n|\r|\n/g,u):r}getValueInRange2(n,u){if(n.node===u.node){const c=n.node,h=this.a[c.piece.bufferIndex].buffer,w=this.u(c.piece.bufferIndex,c.piece.start);return h.substring(w+n.remainder,w+u.remainder)}let a=n.node;const l=this.a[a.piece.bufferIndex].buffer,r=this.u(a.piece.bufferIndex,a.piece.start);let s=l.substring(r+n.remainder,r+a.piece.length);for(a=a.next();a!==M.$pB;){const c=this.a[a.piece.bufferIndex].buffer,h=this.u(a.piece.bufferIndex,a.piece.start);if(a===u.node){s+=c.substring(h,h+u.remainder);break}else s+=c.substr(h,a.piece.length);a=a.next()}return s}getLinesContent(){const n=[];let u=0,a="",l=!1;return this.iterate(this.root,r=>{if(r===M.$pB)return!0;const s=r.piece;let c=s.length;if(c===0)return!0;const h=this.a[s.bufferIndex].buffer,w=this.a[s.bufferIndex].lineStarts,m=s.start.line,I=s.end.line;let k=w[m]+s.start.column;if(l&&(h.charCodeAt(k)===10&&(k++,c--),n[u++]=a,a="",l=!1,c===0))return!0;if(m===I)return!this.f&&h.charCodeAt(k+c-1)===13?(l=!0,a+=h.substr(k,c-1)):a+=h.substr(k,c),!0;a+=this.f?h.substring(k,Math.max(k,w[m+1]-this.e)):h.substring(k,w[m+1]).replace(/(\r\n|\r|\n)$/,""),n[u++]=a;for(let d=m+1;d<I;d++)a=this.f?h.substring(w[d],w[d+1]-this.e):h.substring(w[d],w[d+1]).replace(/(\r\n|\r|\n)$/,""),n[u++]=a;return!this.f&&h.charCodeAt(w[I]+s.end.column-1)===13?(l=!0,s.end.column===0?u--:a=h.substr(w[I],s.end.column-1)):a=h.substr(w[I],s.end.column),!0}),l&&(n[u++]=a,a=""),n[u++]=a,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const u=n.node.next();if(!u)return 0;const a=this.a[u.piece.bufferIndex],l=this.u(u.piece.bufferIndex,u.piece.start);return a.buffer.charCodeAt(l)}else{const u=this.a[n.node.piece.bufferIndex],l=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return u.buffer.charCodeAt(l)}}getLineCharCode(n,u){const a=this.H(n,u+1);return this.l(a)}getLineLength(n){if(n===this.getLineCount()){const u=this.getOffsetAt(n,1);return this.getLength()-u}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const u=this.G(n);return this.l(u)}findMatchesInNode(n,u,a,l,r,s,c,h,w,m,I){const k=this.a[n.piece.bufferIndex],d=this.u(n.piece.bufferIndex,n.piece.start),b=this.u(n.piece.bufferIndex,r),y=this.u(n.piece.bufferIndex,s);let C;const B={line:0,column:0};let H,U;u._wordSeparators?(H=k.buffer.substring(b,y),U=z=>z+b,u.reset(0)):(H=k.buffer,U=z=>z,u.reset(b));do if(C=u.next(H),C){if(U(C.index)>=y)return m;this.s(n,U(C.index)-d,B);const z=this.t(n.piece.bufferIndex,r,B),F=B.line===r.line?B.column-r.column+l:B.column+1,N=F+C[0].length;if(I[m++]=(0,R.$AB)(new L.$xs(a+z,F,a+z,N),C,h),U(C.index)+C[0].length>=y||m>=w)return m}while(C);return m}findMatchesLineByLine(n,u,a,l){const r=[];let s=0;const c=new R.$DB(u.wordSeparators,u.regex);let h=this.H(n.startLineNumber,n.startColumn);if(h===null)return[];const w=this.H(n.endLineNumber,n.endColumn);if(w===null)return[];let m=this.s(h.node,h.remainder);const I=this.s(w.node,w.remainder);if(h.node===w.node)return this.findMatchesInNode(h.node,c,n.startLineNumber,n.startColumn,m,I,u,a,l,s,r),r;let k=n.startLineNumber,d=h.node;for(;d!==w.node;){const y=this.t(d.piece.bufferIndex,m,d.piece.end);if(y>=1){const B=this.a[d.piece.bufferIndex].lineStarts,H=this.u(d.piece.bufferIndex,d.piece.start),U=B[m.line+y],z=k===n.startLineNumber?n.startColumn:1;if(s=this.findMatchesInNode(d,c,k,z,m,this.s(d,U-H),u,a,l,s,r),s>=l)return r;k+=y}const C=k===n.startLineNumber?n.startColumn-1:0;if(k===n.endLineNumber){const B=this.getLineContent(k).substring(C,n.endColumn-1);return s=this.n(u,c,B,n.endLineNumber,C,s,r,a,l),r}if(s=this.n(u,c,this.getLineContent(k).substr(C),k,C,s,r,a,l),s>=l)return r;k++,h=this.H(k,1),d=h.node,m=this.s(h.node,h.remainder)}if(k===n.endLineNumber){const y=k===n.startLineNumber?n.startColumn-1:0,C=this.getLineContent(k).substring(y,n.endColumn-1);return s=this.n(u,c,C,n.endLineNumber,y,s,r,a,l),r}const b=k===n.startLineNumber?n.startColumn:1;return s=this.findMatchesInNode(w.node,c,k,b,m,I,u,a,l,s,r),r}n(n,u,a,l,r,s,c,h,w){const m=n.wordSeparators;if(!h&&n.simpleSearch){const k=n.simpleSearch,d=k.length,b=a.length;let y=-d;for(;(y=a.indexOf(k,y+d))!==-1;)if((!m||(0,R.$CB)(m,a,b,y,d))&&(c[s++]=new P.$Ou(new L.$xs(l,y+1+r,l,y+1+d+r),null),s>=w))return s;return s}let I;u.reset(0);do if(I=u.next(a),I&&(c[s++]=(0,R.$AB)(new L.$xs(l,I.index+1+r,l,I.index+1+I[0].length+r),I,h),s>=w))return s;while(I);return s}insert(n,u,a=!1){if(this.f=this.f&&a,this.j.lineNumber=0,this.j.value="",this.root!==M.$pB){const{node:l,remainder:r,nodeStartOffset:s}=this.G(n),c=l.piece,h=c.bufferIndex,w=this.s(l,r);if(l.piece.bufferIndex===0&&c.end.line===this.g.line&&c.end.column===this.g.column&&s+c.length===n&&u.length<$){this.F(l,u),this.y();return}if(s===n)this.o(u,l),this.h.validate(n);else if(s+l.piece.length>n){const m=[];let I=new o(c.bufferIndex,w,c.end,this.t(c.bufferIndex,w,c.end),this.u(h,c.end)-this.u(h,w));if(this.K()&&this.M(u)&&this.I(l,r)===10){const y={line:I.start.line+1,column:0};I=new o(I.bufferIndex,y,I.end,this.t(I.bufferIndex,y,I.end),I.length-1),u+=`
`}if(this.K()&&this.L(u))if(this.I(l,r-1)===13){const y=this.s(l,r-1);this.C(l,y),u="\r"+u,l.piece.length===0&&m.push(l)}else this.C(l,w);else this.C(l,w);const k=this.w(u);I.length>0&&this.S(l,I);let d=l;for(let b=0;b<k.length;b++)d=this.S(d,k[b]);this.v(m)}else this.q(u,l)}else{const l=this.w(u);let r=this.T(null,l[0]);for(let s=1;s<l.length;s++)r=this.S(r,l[s])}this.y()}delete(n,u){if(this.j.lineNumber=0,this.j.value="",u<=0||this.root===M.$pB)return;const a=this.G(n),l=this.G(n+u),r=a.node,s=l.node;if(r===s){const k=this.s(r,a.remainder),d=this.s(r,l.remainder);if(a.nodeStartOffset===n){if(u===r.piece.length){const b=r.next();(0,M.$uB)(this,r),this.N(b),this.y();return}this.D(r,d),this.h.validate(n),this.N(r),this.y();return}if(a.nodeStartOffset+r.piece.length===n+u){this.C(r,k),this.O(r),this.y();return}this.E(r,k,d),this.y();return}const c=[],h=this.s(r,a.remainder);this.C(r,h),this.h.validate(n),r.piece.length===0&&c.push(r);const w=this.s(s,l.remainder);this.D(s,w),s.piece.length===0&&c.push(s);const m=r.next();for(let k=m;k!==M.$pB&&k!==s;k=k.next())c.push(k);const I=r.piece.length===0?r.prev():r;this.v(c),this.O(I),this.y()}o(n,u){const a=[];if(this.K()&&this.M(n)&&this.L(u)){const s=u.piece,c={line:s.start.line+1,column:0},h=new o(s.bufferIndex,c,s.end,this.t(s.bufferIndex,c,s.end),s.length-1);u.piece=h,n+=`
`,(0,M.$wB)(this,u,-1,-1),u.piece.length===0&&a.push(u)}const l=this.w(n);let r=this.T(u,l[l.length-1]);for(let s=l.length-2;s>=0;s--)r=this.T(r,l[s]);this.N(r),this.v(a)}q(n,u){this.Q(n,u)&&(n+=`
`);const a=this.w(n),l=this.S(u,a[0]);let r=l;for(let s=1;s<a.length;s++)r=this.S(r,a[s]);this.N(l)}s(n,u,a){const l=n.piece,r=n.piece.bufferIndex,s=this.a[r].lineStarts,h=s[l.start.line]+l.start.column+u;let w=l.start.line,m=l.end.line,I=0,k=0,d=0;for(;w<=m&&(I=w+(m-w)/2|0,d=s[I],I!==m);)if(k=s[I+1],h<d)m=I-1;else if(h>=k)w=I+1;else break;return a?(a.line=I,a.column=h-d,null):{line:I,column:h-d}}t(n,u,a){if(a.column===0)return a.line-u.line;const l=this.a[n].lineStarts;if(a.line===l.length-1)return a.line-u.line;const r=l[a.line+1],s=l[a.line]+a.column;if(r>s+1)return a.line-u.line;const c=s-1;return this.a[n].buffer.charCodeAt(c)===13?a.line-u.line+1:a.line-u.line}u(n,u){return this.a[n].lineStarts[u.line]+u.column}v(n){for(let u=0;u<n.length;u++)(0,M.$uB)(this,n[u])}w(n){if(n.length>$){const m=[];for(;n.length>$;){const k=n.charCodeAt($-1);let d;k===13||k>=55296&&k<=56319?(d=n.substring(0,$-1),n=n.substring($-1)):(d=n.substring(0,$),n=n.substring($));const b=A(d);m.push(new o(this.a.length,{line:0,column:0},{line:b.length-1,column:d.length-b[b.length-1]},b.length-1,d.length)),this.a.push(new v(d,b))}const I=A(n);return m.push(new o(this.a.length,{line:0,column:0},{line:I.length-1,column:n.length-I[I.length-1]},I.length-1,n.length)),this.a.push(new v(n,I)),m}let u=this.a[0].buffer.length;const a=A(n,!1);let l=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===u&&u!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},l=this.g;for(let m=0;m<a.length;m++)a[m]+=u+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(a.slice(1)),this.a[0].buffer+="_"+n,u+=1}else{if(u!==0)for(let m=0;m<a.length;m++)a[m]+=u;this.a[0].lineStarts=this.a[0].lineStarts.concat(a.slice(1)),this.a[0].buffer+=n}const r=this.a[0].buffer.length,s=this.a[0].lineStarts.length-1,c=r-this.a[0].lineStarts[s],h={line:s,column:c},w=new o(0,l,h,this.t(0,l,h),r-u);return this.g=h,[w]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,u=0){let a=this.root,l="";const r=this.h.get2(n);if(r){a=r.node;const s=this.B(a,n-r.nodeStartLineNumber-1),c=this.a[a.piece.bufferIndex].buffer,h=this.u(a.piece.bufferIndex,a.piece.start);if(r.nodeStartLineNumber+a.piece.lineFeedCnt===n)l=c.substring(h+s,h+a.piece.length);else{const w=this.B(a,n-r.nodeStartLineNumber);return c.substring(h+s,h+w-u)}}else{let s=0;const c=n;for(;a!==M.$pB;)if(a.left!==M.$pB&&a.lf_left>=n-1)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt>n-1){const h=this.B(a,n-a.lf_left-2),w=this.B(a,n-a.lf_left-1),m=this.a[a.piece.bufferIndex].buffer,I=this.u(a.piece.bufferIndex,a.piece.start);return s+=a.size_left,this.h.set({node:a,nodeStartOffset:s,nodeStartLineNumber:c-(n-1-a.lf_left)}),m.substring(I+h,I+w-u)}else if(a.lf_left+a.piece.lineFeedCnt===n-1){const h=this.B(a,n-a.lf_left-2),w=this.a[a.piece.bufferIndex].buffer,m=this.u(a.piece.bufferIndex,a.piece.start);l=w.substring(m+h,m+a.piece.length);break}else n-=a.lf_left+a.piece.lineFeedCnt,s+=a.size_left+a.piece.length,a=a.right}for(a=a.next();a!==M.$pB;){const s=this.a[a.piece.bufferIndex].buffer;if(a.piece.lineFeedCnt>0){const c=this.B(a,0),h=this.u(a.piece.bufferIndex,a.piece.start);return l+=s.substring(h,h+c-u),l}else{const c=this.u(a.piece.bufferIndex,a.piece.start);l+=s.substr(c,a.piece.length)}a=a.next()}return l}y(){let n=this.root,u=1,a=0;for(;n!==M.$pB;)u+=n.lf_left+n.piece.lineFeedCnt,a+=n.size_left+n.piece.length,n=n.right;this.b=u,this.c=a,this.h.validate(this.c)}A(n,u){const a=n.piece,l=this.s(n,u),r=l.line-a.start.line;if(this.u(a.bufferIndex,a.end)-this.u(a.bufferIndex,a.start)===u){const s=this.t(n.piece.bufferIndex,a.start,l);if(s!==r)return{index:s,remainder:0}}return{index:r,remainder:l.column}}B(n,u){if(u<0)return 0;const a=n.piece,l=this.a[a.bufferIndex].lineStarts,r=a.start.line+u+1;return r>a.end.line?l[a.end.line]+a.end.column-l[a.start.line]-a.start.column:l[r]-l[a.start.line]-a.start.column}C(n,u){const a=n.piece,l=a.lineFeedCnt,r=this.u(a.bufferIndex,a.end),s=u,c=this.u(a.bufferIndex,s),h=this.t(a.bufferIndex,a.start,s),w=h-l,m=c-r,I=a.length+m;n.piece=new o(a.bufferIndex,a.start,s,h,I),(0,M.$wB)(this,n,m,w)}D(n,u){const a=n.piece,l=a.lineFeedCnt,r=this.u(a.bufferIndex,a.start),s=u,c=this.t(a.bufferIndex,s,a.end),h=this.u(a.bufferIndex,s),w=c-l,m=r-h,I=a.length+m;n.piece=new o(a.bufferIndex,s,a.end,c,I),(0,M.$wB)(this,n,m,w)}E(n,u,a){const l=n.piece,r=l.start,s=l.end,c=l.length,h=l.lineFeedCnt,w=u,m=this.t(l.bufferIndex,l.start,w),I=this.u(l.bufferIndex,u)-this.u(l.bufferIndex,r);n.piece=new o(l.bufferIndex,l.start,w,m,I),(0,M.$wB)(this,n,I-c,m-h);const k=new o(l.bufferIndex,a,s,this.t(l.bufferIndex,a,s),this.u(l.bufferIndex,s)-this.u(l.bufferIndex,a)),d=this.S(n,k);this.N(d)}F(n,u){this.Q(u,n)&&(u+=`
`);const a=this.K()&&this.L(u)&&this.M(n),l=this.a[0].buffer.length;this.a[0].buffer+=u;const r=A(u,!1);for(let d=0;d<r.length;d++)r[d]+=l;if(a){const d=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:l-d}}this.a[0].lineStarts=this.a[0].lineStarts.concat(r.slice(1));const s=this.a[0].lineStarts.length-1,c=this.a[0].buffer.length-this.a[0].lineStarts[s],h={line:s,column:c},w=n.piece.length+u.length,m=n.piece.lineFeedCnt,I=this.t(0,n.piece.start,h),k=I-m;n.piece=new o(n.piece.bufferIndex,n.piece.start,h,I,w),this.g=h,(0,M.$wB)(this,n,u.length,k)}G(n){let u=this.root;const a=this.h.get(n);if(a)return{node:a.node,nodeStartOffset:a.nodeStartOffset,remainder:n-a.nodeStartOffset};let l=0;for(;u!==M.$pB;)if(u.size_left>n)u=u.left;else if(u.size_left+u.piece.length>=n){l+=u.size_left;const r={node:u,remainder:n-u.size_left,nodeStartOffset:l};return this.h.set(r),r}else n-=u.size_left+u.piece.length,l+=u.size_left+u.piece.length,u=u.right;return null}H(n,u){let a=this.root,l=0;for(;a!==M.$pB;)if(a.left!==M.$pB&&a.lf_left>=n-1)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt>n-1){const r=this.B(a,n-a.lf_left-2),s=this.B(a,n-a.lf_left-1);return l+=a.size_left,{node:a,remainder:Math.min(r+u-1,s),nodeStartOffset:l}}else if(a.lf_left+a.piece.lineFeedCnt===n-1){const r=this.B(a,n-a.lf_left-2);if(r+u-1<=a.piece.length)return{node:a,remainder:r+u-1,nodeStartOffset:l};u-=a.piece.length-r;break}else n-=a.lf_left+a.piece.lineFeedCnt,l+=a.size_left+a.piece.length,a=a.right;for(a=a.next();a!==M.$pB;){if(a.piece.lineFeedCnt>0){const r=this.B(a,0),s=this.J(a);return{node:a,remainder:Math.min(u-1,r),nodeStartOffset:s}}else if(a.piece.length>=u-1){const r=this.J(a);return{node:a,remainder:u-1,nodeStartOffset:r}}else u-=a.piece.length;a=a.next()}return null}I(n,u){if(n.piece.lineFeedCnt<1)return-1;const a=this.a[n.piece.bufferIndex],l=this.u(n.piece.bufferIndex,n.piece.start)+u;return a.buffer.charCodeAt(l)}J(n){if(!n)return 0;let u=n.size_left;for(;n!==this.root;)n.parent.right===n&&(u+=n.parent.size_left+n.parent.piece.length),n=n.parent;return u}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===M.$pB||n.piece.lineFeedCnt===0)return!1;const u=n.piece,a=this.a[u.bufferIndex].lineStarts,l=u.start.line,r=a[l]+u.start.column;return l===a.length-1||a[l+1]>r+1?!1:this.a[u.bufferIndex].buffer.charCodeAt(r)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===M.$pB||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const u=n.prev();this.M(u)&&this.P(u,n)}}O(n){if(this.K()&&this.M(n)){const u=n.next();this.L(u)&&this.P(n,u)}}P(n,u){const a=[],l=this.a[n.piece.bufferIndex].lineStarts;let r;n.piece.end.column===0?r={line:n.piece.end.line-1,column:l[n.piece.end.line]-l[n.piece.end.line-1]-1}:r={line:n.piece.end.line,column:n.piece.end.column-1};const s=n.piece.length-1,c=n.piece.lineFeedCnt-1;n.piece=new o(n.piece.bufferIndex,n.piece.start,r,c,s),(0,M.$wB)(this,n,-1,-1),n.piece.length===0&&a.push(n);const h={line:u.piece.start.line+1,column:0},w=u.piece.length-1,m=this.t(u.piece.bufferIndex,h,u.piece.end);u.piece=new o(u.piece.bufferIndex,h,u.piece.end,m,w),(0,M.$wB)(this,u,-1,-1),u.piece.length===0&&a.push(u);const I=this.w(`\r
`);this.S(n,I[0]);for(let k=0;k<a.length;k++)(0,M.$uB)(this,a[k])}Q(n,u){if(this.K()&&this.M(n)){const a=u.next();if(this.L(a)){if(n+=`
`,a.piece.length===1)(0,M.$uB)(this,a);else{const l=a.piece,r={line:l.start.line+1,column:0},s=l.length-1,c=this.t(l.bufferIndex,r,l.end);a.piece=new o(l.bufferIndex,r,l.end,c,s),(0,M.$wB)(this,a,-1,-1)}return!0}}return!1}iterate(n,u){if(n===M.$pB)return u(M.$pB);const a=this.iterate(n.left,u);return a&&u(n)&&this.iterate(n.right,u)}R(n){if(n===M.$pB)return"";const u=this.a[n.piece.bufferIndex],a=n.piece,l=this.u(a.bufferIndex,a.start),r=this.u(a.bufferIndex,a.end);return u.buffer.substring(l,r)}getPieceContent(n){const u=this.a[n.bufferIndex],a=this.u(n.bufferIndex,n.start),l=this.u(n.bufferIndex,n.end);return u.buffer.substring(a,l)}S(n,u){const a=new M.$oB(u,1);if(a.left=M.$pB,a.right=M.$pB,a.parent=M.$pB,a.size_left=0,a.lf_left=0,this.root===M.$pB)this.root=a,a.color=0;else if(n.right===M.$pB)n.right=a,a.parent=n;else{const r=(0,M.$qB)(n.right);r.left=a,a.parent=r}return(0,M.$vB)(this,a),a}T(n,u){const a=new M.$oB(u,1);if(a.left=M.$pB,a.right=M.$pB,a.parent=M.$pB,a.size_left=0,a.lf_left=0,this.root===M.$pB)this.root=a,a.color=0;else if(n.left===M.$pB)n.left=a,a.parent=n;else{const l=(0,M.$rB)(n.left);l.right=a,a.parent=l}return(0,M.$vB)(this,a),a}U(n){let u="";return this.iterate(n,a=>(u+=this.R(a),!0)),u}}e.$IB=t}),define(Ae[132],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l8=e.$k8=void 0;class E{constructor(){this.a=new Map}removeDragOperationTransfer(M){if(M&&this.a.has(M)){const R=this.a.get(M);return this.a.delete(M),R}}addDragOperationTransfer(M,R){this.a.set(M,R)}}e.$k8=E;class L{constructor(M){this.identifier=M}}e.$l8=L}),define(Ae[133],Re([9,10]),function(pe,e){return pe.create("vs/base/common/actions",e)}),define(Ae[134],Re([1,0,5,6,133]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=void 0;class M extends L.$Rc{constructor(o,v="",p="",f=!0,t){super(),this.h=this.B(new E.$Od),this.onDidChange=this.h.event,this.w=!0,this.j=o,this.m=v,this.u=p,this.w=f,this.C=t}get id(){return this.j}get label(){return this.m}set label(o){this.D(o)}D(o){this.m!==o&&(this.m=o,this.h.fire({label:o}))}get tooltip(){return this.n||""}set tooltip(o){this.F(o)}F(o){this.n!==o&&(this.n=o,this.h.fire({tooltip:o}))}get class(){return this.u}set class(o){this.G(o)}G(o){this.u!==o&&(this.u=o,this.h.fire({class:o}))}get enabled(){return this.w}set enabled(o){this.H(o)}H(o){this.w!==o&&(this.w=o,this.h.fire({enabled:o}))}get checked(){return this.z}set checked(o){this.I(o)}I(o){this.z!==o&&(this.z=o,this.h.fire({checked:o}))}async run(o,v){this.C&&await this.C(o)}}e.$yi=M;class R extends L.$Rc{constructor(){super(...arguments),this.f=this.B(new E.$Od),this.onWillRun=this.f.event,this.m=this.B(new E.$Od),this.onDidRun=this.m.event}async run(o,v){if(!o.enabled)return;this.f.fire({action:o});let p;try{await this.u(o,v)}catch(f){p=f}this.m.fire({action:o,error:p})}async u(o,v){await o.run(v)}}e.$zi=R;class ${constructor(){this.id=$.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...o){let v=[];for(const p of o)p.length&&(v.length?v=[...v,new $,...p]:v=p);return v}static{this.ID="vs.actions.separator"}async run(){}}e.$Ai=$;class D{get actions(){return this.a}constructor(o,v,p,f){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=o,this.label=v,this.class=f,this.a=p}async run(){}}e.$Bi=D;class g extends M{static{this.ID="vs.actions.empty"}constructor(){super(g.ID,P.localize(0,null),void 0,!1)}}e.$Ci=g;function A(S){return{id:S.id,label:S.label,class:void 0,enabled:S.enabled??!0,checked:S.checked??!1,run:async(...o)=>S.run(...o),tooltip:S.label}}e.$Di=A}),define(Ae[135],Re([9,10]),function(pe,e){return pe.create("vs/base/common/date",e)}),define(Ae[136],Re([1,0,135]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$im=e.$hm=void 0;const L=60,P=L*60,M=P*24,R=M*7,$=M*30,D=M*365;function g(S,o,v,p){typeof S!="number"&&(S=S.getTime());const f=Math.round((new Date().getTime()-S)/1e3);if(f<-30)return(0,E.localize)(0,null,g(new Date().getTime()+f*1e3,!1));if(!p&&f<30)return(0,E.localize)(1,null);let t;return f<L?(t=f,o?t===1?v?(0,E.localize)(2,null,t):(0,E.localize)(3,null,t):v?(0,E.localize)(4,null,t):(0,E.localize)(5,null,t):t===1?v?(0,E.localize)(6,null,t):(0,E.localize)(7,null,t):v?(0,E.localize)(8,null,t):(0,E.localize)(9,null,t)):f<P?(t=Math.floor(f/L),o?t===1?v?(0,E.localize)(10,null,t):(0,E.localize)(11,null,t):v?(0,E.localize)(12,null,t):(0,E.localize)(13,null,t):t===1?v?(0,E.localize)(14,null,t):(0,E.localize)(15,null,t):v?(0,E.localize)(16,null,t):(0,E.localize)(17,null,t)):f<M?(t=Math.floor(f/P),o?t===1?v?(0,E.localize)(18,null,t):(0,E.localize)(19,null,t):v?(0,E.localize)(20,null,t):(0,E.localize)(21,null,t):t===1?v?(0,E.localize)(22,null,t):(0,E.localize)(23,null,t):v?(0,E.localize)(24,null,t):(0,E.localize)(25,null,t)):f<R?(t=Math.floor(f/M),o?t===1?(0,E.localize)(26,null,t):(0,E.localize)(27,null,t):t===1?(0,E.localize)(28,null,t):(0,E.localize)(29,null,t)):f<$?(t=Math.floor(f/R),o?t===1?v?(0,E.localize)(30,null,t):(0,E.localize)(31,null,t):v?(0,E.localize)(32,null,t):(0,E.localize)(33,null,t):t===1?v?(0,E.localize)(34,null,t):(0,E.localize)(35,null,t):v?(0,E.localize)(36,null,t):(0,E.localize)(37,null,t)):f<D?(t=Math.floor(f/$),o?t===1?v?(0,E.localize)(38,null,t):(0,E.localize)(39,null,t):v?(0,E.localize)(40,null,t):(0,E.localize)(41,null,t):t===1?v?(0,E.localize)(42,null,t):(0,E.localize)(43,null,t):v?(0,E.localize)(44,null,t):(0,E.localize)(45,null,t)):(t=Math.floor(f/D),o?t===1?v?(0,E.localize)(46,null,t):(0,E.localize)(47,null,t):v?(0,E.localize)(48,null,t):(0,E.localize)(49,null,t):t===1?v?(0,E.localize)(50,null,t):(0,E.localize)(51,null,t):v?(0,E.localize)(52,null,t):(0,E.localize)(53,null,t))}e.$hm=g;function A(S){return S.getFullYear()+"-"+String(S.getMonth()+1).padStart(2,"0")+"-"+String(S.getDate()).padStart(2,"0")+"T"+String(S.getHours()).padStart(2,"0")+":"+String(S.getMinutes()).padStart(2,"0")+":"+String(S.getSeconds()).padStart(2,"0")+"."+(S.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$im=A}),define(Ae[137],Re([9,10]),function(pe,e){return pe.create("vs/base/common/errorMessage",e)}),define(Ae[39],Re([1,0,18,16,137]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gi=e.$Fi=e.$Ei=void 0;function M(S,o){return o&&(S.stack||S.stacktrace)?P.localize(0,null,$(S),R(S.stack)||R(S.stacktrace)):$(S)}function R(S){return Array.isArray(S)?S.join(`
`):S}function $(S){return S.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${S.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?P.localize(1,null,S.message):S.message||P.localize(2,null)}function D(S=null,o=!1){if(!S)return P.localize(3,null);if(Array.isArray(S)){const v=E.$Gb(S),p=D(v[0],o);return v.length>1?P.localize(4,null,p,v.length):p}if(L.$zf(S))return S;if(S.detail){const v=S.detail;if(v.error)return M(v.error,o);if(v.exception)return M(v.exception,o)}return S.stack?M(S,o):S.message?S.message:P.localize(5,null)}e.$Ei=D;function g(S){const o=S;return o instanceof Error&&Array.isArray(o.actions)}e.$Fi=g;function A(S,o){let v;return typeof S=="string"?v=new Error(S):v=S,v.actions=o,v}e.$Gi=A}),define(Ae[138],Re([1,0,44,19]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xq=e.$wq=e.$vq=e.$uq=e.$tq=e.$sq=e.$rq=e.$qq=e.$pq=e.$oq=e.$nq=e.$mq=e.$lq=void 0;const P=new E.$U(()=>{const k=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:k,collatorIsNumeric:k.resolvedOptions().numeric}}),M=new E.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new E.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function $(k,d,b=!1){const y=k||"",C=d||"",B=P.value.collator.compare(y,C);return P.value.collatorIsNumeric&&B===0&&y!==C?y<C?-1:1:B}e.$lq=$;function D(k,d){const b=M.value.collator;return k=k||"",d=d||"",a(b,k,d)}e.$mq=D;function g(k,d){const b=M.value.collator;return k=k||"",d=d||"",c(k,d)||a(b,k,d)}e.$nq=g;function A(k,d){const b=M.value.collator;return k=k||"",d=d||"",s(k,d)||a(b,k,d)}e.$oq=A;function S(k,d){return k=k||"",d=d||"",k===d?0:k<d?-1:1}e.$pq=S;function o(k,d){const[b,y]=n(k),[C,B]=n(d);let H=P.value.collator.compare(y,B);if(H===0){if(P.value.collatorIsNumeric&&y!==B)return y<B?-1:1;if(H=P.value.collator.compare(b,C),P.value.collatorIsNumeric&&H===0&&b!==C)return b<C?-1:1}return H}e.$qq=o;function v(k,d){k=k||"",d=d||"";const b=u(k),y=u(d),C=M.value.collator,B=R.value.collator;return a(B,b,y)||a(C,k,d)}e.$rq=v;function p(k,d){k=k||"",d=d||"";const b=u(k),y=u(d),C=M.value.collator,B=R.value.collator;return a(B,b,y)||c(k,d)||a(C,k,d)}e.$sq=p;function f(k,d){k=k||"",d=d||"";const b=u(k),y=u(d),C=M.value.collator,B=R.value.collator;return a(B,b,y)||s(k,d)||a(C,k,d)}e.$tq=f;function t(k,d){k=k||"",d=d||"";const b=u(k).toLowerCase(),y=u(d).toLowerCase();return b!==y?b<y?-1:1:k!==d?k<d?-1:1:0}e.$uq=t;const i=/^(.*?)(\.([^.]*))?$/;function n(k,d=!1){const b=k?i.exec(k):[];let y=[b&&b[1]||"",b&&b[3]||""];return d&&(!y[0]&&y[1]||y[0]&&y[0].charAt(0)===".")&&(y=[y[0]+"."+y[1],""]),y}function u(k){const d=k?i.exec(k):[];return d&&d[1]&&d[1].charAt(0)!=="."&&d[3]||""}function a(k,d,b){const y=k.compare(d,b);return y!==0?y:d.length!==b.length?d.length<b.length?-1:1:0}function l(k){const d=k.charAt(0);return d.toLocaleUpperCase()!==d}function r(k){const d=k.charAt(0);return d.toLocaleLowerCase()!==d}function s(k,d){return l(k)&&r(d)?-1:r(k)&&l(d)?1:0}function c(k,d){return r(k)&&l(d)?-1:l(k)&&r(d)?1:0}function h(k,d,b=!1){return b||(k=k&&k.toLowerCase(),d=d&&d.toLowerCase()),k===d?0:k<d?-1:1}function w(k,d,b=!1){const y=k.split(L.sep),C=d.split(L.sep),B=y.length-1,H=C.length-1;let U,z;for(let F=0;;F++){if(U=B===F,z=H===F,U&&z)return $(y[F],C[F],b);if(U)return-1;if(z)return 1;const N=h(y[F],C[F],b);if(N!==0)return N}}e.$vq=w;function m(k,d,b){const y=k.toLowerCase(),C=d.toLowerCase(),B=I(k,d,b);if(B)return B;const H=y.endsWith(b),U=C.endsWith(b);if(H!==U)return H?-1:1;const z=$(y,C);return z!==0?z:y.localeCompare(C)}e.$wq=m;function I(k,d,b){const y=k.toLowerCase(),C=d.toLowerCase(),B=y.startsWith(b),H=C.startsWith(b);if(B!==H)return B?-1:1;if(B&&H){if(y.length<C.length)return-1;if(y.length>C.length)return 1}return 0}e.$xq=I}),define(Ae[46],Re([1,0,19,21,13,16]),function(pe,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=void 0;function R(m){return m===47||m===92}e.$Rf=R;function $(m){return m.replace(/[\\/]/g,E.$fc.sep)}e.$Sf=$;function D(m){return m.indexOf("/")===-1&&(m=$(m)),/^[a-zA-Z]:(\/|$)/.test(m)&&(m="/"+m),m}e.$Tf=D;function g(m,I=E.$fc.sep){if(!m)return"";const k=m.length,d=m.charCodeAt(0);if(R(d)){if(R(m.charCodeAt(1))&&!R(m.charCodeAt(2))){let y=3;const C=y;for(;y<k&&!R(m.charCodeAt(y));y++);if(C!==y&&!R(m.charCodeAt(y+1))){for(y+=1;y<k;y++)if(R(m.charCodeAt(y)))return m.slice(0,y+1).replace(/[\\/]/g,I)}}return I}else if(i(d)&&m.charCodeAt(1)===58)return R(m.charCodeAt(2))?m.slice(0,2)+I:m.slice(0,2);let b=m.indexOf("://");if(b!==-1){for(b+=3;b<k;b++)if(R(m.charCodeAt(b)))return m.slice(0,b+1)}return""}e.$Uf=g;function A(m){if(!L.$j||!m||m.length<5)return!1;let I=m.charCodeAt(0);if(I!==92||(I=m.charCodeAt(1),I!==92))return!1;let k=2;const d=k;for(;k<m.length&&(I=m.charCodeAt(k),I!==92);k++);return!(d===k||(I=m.charCodeAt(k+1),isNaN(I)||I===92))}e.$Vf=A;const S=/[\\/:\*\?"<>\|]/g,o=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(m,I=L.$j){const k=I?S:o;return!(!m||m.length===0||/^\s+$/.test(m)||(k.lastIndex=0,k.test(m))||I&&v.test(m)||m==="."||m===".."||I&&m[m.length-1]==="."||I&&m.length!==m.trim().length||m.length>255)}e.$Wf=p;function f(m,I,k){const d=m===I;return!k||d?d:!m||!I?!1:(0,P.$3e)(m,I)}e.$Xf=f;function t(m,I,k,d=E.sep){if(m===I)return!0;if(!m||!I||I.length>m.length)return!1;if(k){if(!(0,P.$4e)(m,I))return!1;if(I.length===m.length)return!0;let y=I.length;return I.charAt(I.length-1)===d&&y--,m.charAt(y)===d}return I.charAt(I.length-1)!==d&&(I+=d),m.indexOf(I)===0}e.$Yf=t;function i(m){return m>=65&&m<=90||m>=97&&m<=122}e.$Zf=i;function n(m,I){return L.$j&&m.endsWith(":")&&(m+=E.sep),(0,E.$hc)(m)||(m=(0,E.$ic)(I,m)),m=(0,E.$gc)(m),L.$j?(m=(0,P.$Le)(m,E.sep),m.endsWith(":")&&(m+=E.sep)):(m=(0,P.$Le)(m,E.sep),m||(m=E.sep)),m}e.$1f=n;function u(m){const I=(0,E.$gc)(m);return L.$j?m.length>3?!1:a(I)&&(m.length===2||I.charCodeAt(2)===92):I===E.$fc.sep}e.$2f=u;function a(m,I=L.$j){return I?i(m.charCodeAt(0))&&m.charCodeAt(1)===58:!1}e.$3f=a;function l(m,I=L.$j){return a(m,I)?m[0]:void 0}e.$4f=l;function r(m,I,k){return I.length>m.length?-1:m===I?0:(k&&(m=m.toLowerCase(),I=I.toLowerCase()),m.indexOf(I))}e.$5f=r;function s(m){const I=m.split(":");let k,d,b;for(const y of I){const C=Number(y);(0,M.$Df)(C)?d===void 0?d=C:b===void 0&&(b=C):k=k?[k,y].join(":"):y}if(!k)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:k,line:d!==void 0?d:void 0,column:b!==void 0?b:d!==void 0?1:void 0}}e.$6f=s;const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",h="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function w(m,I,k=8){let d="";for(let y=0;y<k;y++){let C;y===0&&L.$j&&!I&&(k===3||k===4)?C=h:C=c,d+=C.charAt(Math.floor(Math.random()*C.length))}let b;return I?b=`${I}-${d}`:b=d,m?(0,E.$ic)(m,b):b}e.$7f=w}),define(Ae[69],Re([1,0,19]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xr=e.$Wr=e.$Vr=e.$Ur=e.$Tr=void 0,e.$Tr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const L={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function M(A){const S=(0,E.$nc)(A),o=L[S.toLowerCase()];return o!==void 0?o:R(A)}e.$Ur=M;function R(A){const S=(0,E.$nc)(A);return P[S.toLowerCase()]}e.$Vr=R;function $(A){for(const S in P)if(P[S]===A)return S}e.$Wr=$;const D=/^(.+)\/(.+?)(;.+)?$/;function g(A,S){const o=D.exec(A);return o?`${o[1].toLowerCase()}/${o[2].toLowerCase()}${o[3]??""}`:S?void 0:A}e.$Xr=g}),define(Ae[52],Re([1,0,24,2]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qh=e.$ph=e.$oh=void 0;function P(D){return JSON.stringify(D,R)}e.$oh=P;function M(D){let g=JSON.parse(D);return g=$(g),g}e.$ph=M;function R(D,g){return g instanceof RegExp?{$mid:2,source:g.source,flags:g.flags}:g}function $(D,g=0){if(!D||g>200)return D;if(typeof D=="object"){switch(D.$mid){case 1:return L.URI.revive(D);case 2:return new RegExp(D.source,D.flags);case 17:return new Date(D.source)}if(D instanceof E.$ce||D instanceof Uint8Array)return D;if(Array.isArray(D))for(let A=0;A<D.length;++A)D[A]=$(D[A],g+1);else for(const A in D)Object.hasOwnProperty.call(D,A)&&(D[A]=$(D[A],g+1))}return D}e.$qh=$}),define(Ae[14],Re([1,0,11,21,2]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.Schemas=void 0;var M;(function(g){g.inMemory="inmemory",g.vscode="vscode",g.internal="private",g.walkThrough="walkThrough",g.walkThroughSnippet="walkThroughSnippet",g.http="http",g.https="https",g.file="file",g.mailto="mailto",g.untitled="untitled",g.data="data",g.command="command",g.vscodeRemote="vscode-remote",g.vscodeRemoteResource="vscode-remote-resource",g.vscodeManagedRemoteResource="vscode-managed-remote-resource",g.vscodeUserData="vscode-userdata",g.vscodeCustomEditor="vscode-custom-editor",g.vscodeNotebookCell="vscode-notebook-cell",g.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",g.vscodeNotebookCellOutput="vscode-notebook-cell-output",g.vscodeInteractiveInput="vscode-interactive-input",g.vscodeSettings="vscode-settings",g.vscodeWorkspaceTrust="vscode-workspace-trust",g.vscodeTerminal="vscode-terminal",g.vscodeChatSesssion="vscode-chat-editor",g.webviewPanel="webview-panel",g.vscodeWebview="vscode-webview",g.extension="extension",g.vscodeFileResource="vscode-file",g.tmp="tmp",g.vsls="vsls",g.vscodeSourceControl="vscode-scm"})(M||(e.Schemas=M={})),e.$8f="vscode-tkn",e.$9f="tkn";class R{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${M.vscodeRemoteResource}`}setPreferredWebSchema(A){this.d=A}setDelegate(A){this.e=A}setServerRootPath(A){this.f=`${A}/${M.vscodeRemoteResource}`}set(A,S,o){this.a[A]=S,this.b[A]=o}setConnectionToken(A,S){this.c[A]=S}getPreferredWebSchema(){return this.d}rewrite(A){if(this.e)try{return this.e(A)}catch(t){return E.$Z(t),A}const S=A.authority;let o=this.a[S];o&&o.indexOf(":")!==-1&&o.indexOf("[")===-1&&(o=`[${o}]`);const v=this.b[S],p=this.c[S];let f=`path=${encodeURIComponent(A.path)}`;return typeof p=="string"&&(f+=`&${e.$9f}=${encodeURIComponent(p)}`),P.URI.from({scheme:L.$p?this.d:M.vscodeRemoteResource,authority:`${o}:${v}`,path:this.f,query:f})}}e.$0f=new R,e.$$f="vs/../../extensions",e.$_f="vs/../../node_modules",e.$ag="vs/../../node_modules.asar",e.$bg="vs/../../node_modules.asar.unpacked",e.$cg="vscode-app";class ${static{this.a=e.$cg}asBrowserUri(A){const S=this.b(A,pe);return this.uriToBrowserUri(S)}uriToBrowserUri(A){return A.scheme===M.vscodeRemote?e.$0f.rewrite(A):A.scheme===M.file&&(L.$n||L.$q&&L.$h.origin===`${M.vscodeFileResource}://${$.a}`)?A.with({scheme:M.vscodeFileResource,authority:A.authority||$.a,query:null,fragment:null}):A}asFileUri(A){const S=this.b(A,pe);return this.uriToFileUri(S)}uriToFileUri(A){return A.scheme===M.vscodeFileResource?A.with({scheme:M.file,authority:A.authority!==$.a?A.authority:null,query:null,fragment:null}):A}b(A,S){return P.URI.isUri(A)?A:P.URI.parse(S.toUrl(A))}}e.$dg=new $;var D;(function(g){const A=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);g.CoopAndCoep=Object.freeze(A.get("3"));const S="vscode-coi";function o(p){let f;typeof p=="string"?f=new URL(p).searchParams:p instanceof URL?f=p.searchParams:P.URI.isUri(p)&&(f=new URL(p.toString(!0)).searchParams);const t=f?.get(S);if(t)return A.get(t)}g.getHeadersFromQuery=o;function v(p,f,t){if(!globalThis.crossOriginIsolated)return;const i=f&&t?"3":t?"2":"1";p instanceof URLSearchParams?p.set(S,i):p[S]=i}g.addSearchParam=v})(D||(e.COI=D={}))}),define(Ae[25],Re([1,0,46,14,19,21,13,2]),function(pe,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gg=e.DataUri=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=void 0;function D(v){return(0,$.$vc)(v,!0)}e.$kg=D;class g{constructor(p){this.a=p}compare(p,f,t=!1){return p===f?0:(0,R.$Ve)(this.getComparisonKey(p,t),this.getComparisonKey(f,t))}isEqual(p,f,t=!1){return p===f?!0:!p||!f?!1:this.getComparisonKey(p,t)===this.getComparisonKey(f,t)}getComparisonKey(p,f=!1){return p.with({path:this.a(p)?p.path.toLowerCase():void 0,fragment:f?null:void 0}).toString()}ignorePathCasing(p){return this.a(p)}isEqualOrParent(p,f,t=!1){if(p.scheme===f.scheme){if(p.scheme===L.Schemas.file)return E.$Yf(D(p),D(f),this.a(p))&&p.query===f.query&&(t||p.fragment===f.fragment);if((0,e.$Bg)(p.authority,f.authority))return E.$Yf(p.path,f.path,this.a(p),"/")&&p.query===f.query&&(t||p.fragment===f.fragment)}return!1}joinPath(p,...f){return $.URI.joinPath(p,...f)}basenameOrAuthority(p){return(0,e.$tg)(p)||p.authority}basename(p){return P.$fc.basename(p.path)}extname(p){return P.$fc.extname(p.path)}dirname(p){if(p.path.length===0)return p;let f;return p.scheme===L.Schemas.file?f=$.URI.file(P.$lc(D(p))).path:(f=P.$fc.dirname(p.path),p.authority&&f.length&&f.charCodeAt(0)!==47&&(console.error(`dirname("${p.toString})) resulted in a relative path`),f="/")),p.with({path:f})}normalizePath(p){if(!p.path.length)return p;let f;return p.scheme===L.Schemas.file?f=$.URI.file(P.$gc(D(p))).path:f=P.$fc.normalize(p.path),p.with({path:f})}relativePath(p,f){if(p.scheme!==f.scheme||!(0,e.$Bg)(p.authority,f.authority))return;if(p.scheme===L.Schemas.file){const n=P.$kc(D(p),D(f));return M.$j?E.$Sf(n):n}let t=p.path||"/";const i=f.path||"/";if(this.a(p)){let n=0;for(const u=Math.min(t.length,i.length);n<u&&!(t.charCodeAt(n)!==i.charCodeAt(n)&&t.charAt(n).toLowerCase()!==i.charAt(n).toLowerCase());n++);t=i.substr(0,n)+t.substr(n)}return P.$fc.relative(t,i)}resolvePath(p,f){if(p.scheme===L.Schemas.file){const t=$.URI.file(P.$jc(D(p),f));return p.with({authority:t.authority,path:t.path})}return f=E.$Tf(f),p.with({path:P.$fc.resolve(p.path,f)})}isAbsolutePath(p){return!!p.path&&p.path[0]==="/"}isEqualAuthority(p,f){return p===f||p!==void 0&&f!==void 0&&(0,R.$3e)(p,f)}hasTrailingPathSeparator(p,f=P.sep){if(p.scheme===L.Schemas.file){const t=D(p);return t.length>E.$Uf(t).length&&t[t.length-1]===f}else{const t=p.path;return t.length>1&&t.charCodeAt(t.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(p.fsPath)}}removeTrailingPathSeparator(p,f=P.sep){return(0,e.$Cg)(p,f)?p.with({path:p.path.substr(0,p.path.length-1)}):p}addTrailingPathSeparator(p,f=P.sep){let t=!1;if(p.scheme===L.Schemas.file){const i=D(p);t=i!==void 0&&i.length===E.$Uf(i).length&&i[i.length-1]===f}else{f="/";const i=p.path;t=i.length===1&&i.charCodeAt(i.length-1)===47}return!t&&!(0,e.$Cg)(p,f)?p.with({path:p.path+"/"}):p}}e.$lg=g,e.$mg=new g(()=>!1),e.$ng=new g(v=>v.scheme===L.Schemas.file?!M.$l:!0),e.$og=new g(v=>!0),e.$pg=e.$mg.isEqual.bind(e.$mg),e.$qg=e.$mg.isEqualOrParent.bind(e.$mg),e.$rg=e.$mg.getComparisonKey.bind(e.$mg),e.$sg=e.$mg.basenameOrAuthority.bind(e.$mg),e.$tg=e.$mg.basename.bind(e.$mg),e.$ug=e.$mg.extname.bind(e.$mg),e.$vg=e.$mg.dirname.bind(e.$mg),e.$wg=e.$mg.joinPath.bind(e.$mg),e.$xg=e.$mg.normalizePath.bind(e.$mg),e.$yg=e.$mg.relativePath.bind(e.$mg),e.$zg=e.$mg.resolvePath.bind(e.$mg),e.$Ag=e.$mg.isAbsolutePath.bind(e.$mg),e.$Bg=e.$mg.isEqualAuthority.bind(e.$mg),e.$Cg=e.$mg.hasTrailingPathSeparator.bind(e.$mg),e.$Dg=e.$mg.removeTrailingPathSeparator.bind(e.$mg),e.$Eg=e.$mg.addTrailingPathSeparator.bind(e.$mg);function A(v,p){const f=[];for(let t=0;t<v.length;t++){const i=p(v[t]);v.some((n,u)=>u===t?!1:(0,e.$qg)(i,p(n)))||f.push(v[t])}return f}e.$Fg=A;var S;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function p(f){const t=new Map;f.path.substring(f.path.indexOf(";")+1,f.path.lastIndexOf(";")).split(";").forEach(u=>{const[a,l]=u.split(":");a&&l&&t.set(a,l)});const n=f.path.substring(0,f.path.indexOf(";"));return n&&t.set(v.META_DATA_MIME,n),t}v.parseMetaData=p})(S||(e.DataUri=S={}));function o(v,p,f){if(p){let t=v.path;return t&&t[0]!==P.$fc.sep&&(t=P.$fc.sep+t),v.with({scheme:f,authority:p,path:t})}return v.with({scheme:f})}e.$Gg=o}),define(Ae[12],Re([1,0,20,11,5,6,25,21,124]),function(pe,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kh=e.$jh=e.$ih=e.$hh=e.Promises=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=void 0;function g(Ee){return!!Ee&&typeof Ee.then=="function"}e.$Hg=g;function A(Ee){const te=new E.$Yd,se=Ee(te.token),me=new Promise((Z,le)=>{const ne=te.token.onCancellationRequested(()=>{ne.dispose(),te.dispose(),le(new L.$4)});Promise.resolve(se).then(ae=>{ne.dispose(),te.dispose(),Z(ae)},ae=>{ne.dispose(),te.dispose(),le(ae)})});return new class{cancel(){te.cancel()}then(Z,le){return me.then(Z,le)}catch(Z){return this.then(void 0,Z)}finally(Z){return me.finally(Z)}}}e.$Ig=A;function S(Ee,te,se){return new Promise((me,Z)=>{const le=te.onCancellationRequested(()=>{le.dispose(),me(se)});Ee.then(me,Z).finally(()=>le.dispose())})}e.$Jg=S;function o(Ee,te){return new Promise((se,me)=>{const Z=te.onCancellationRequested(()=>{Z.dispose(),me(new L.$4)});Ee.then(se,me).finally(()=>Z.dispose())})}e.$Kg=o;async function v(Ee){let te=-1;const se=Ee.map((me,Z)=>me.then(le=>(te=Z,le)));try{return await Promise.race(se)}finally{Ee.forEach((me,Z)=>{Z!==te&&me.cancel()})}}e.$Lg=v;function p(Ee,te,se){let me;const Z=setTimeout(()=>{me?.(void 0),se?.()},te);return Promise.race([Ee.finally(()=>clearTimeout(Z)),new Promise(le=>me=le)])}e.$Mg=p;function f(Ee){return new Promise((te,se)=>{const me=Ee();g(me)?me.then(te,se):te(me)})}e.$Ng=f;class t{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(te){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=te,!this.b){const se=()=>{if(this.b=null,this.f)return;const me=this.queue(this.d);return this.d=null,me};this.b=new Promise(me=>{this.a.then(se,se).then(me)})}return new Promise((se,me)=>{this.b.then(se,me)})}return this.a=te(),new Promise((se,me)=>{this.a.then(Z=>{this.a=null,se(Z)},Z=>{this.a=null,me(Z)})})}dispose(){this.f=!0}}e.$Og=t;class i{constructor(){this.a=Promise.resolve(null)}queue(te){return this.a=this.a.then(()=>te(),()=>te())}}e.$Pg=i;class n{constructor(){this.a=new Map}queue(te,se){const Z=(this.a.get(te)??Promise.resolve()).catch(()=>{}).then(se).finally(()=>{this.a.get(te)===Z&&this.a.delete(te)});return this.a.set(te,Z),Z}}e.$Qg=n;const u=(Ee,te)=>{let se=!0;const me=setTimeout(()=>{se=!1,te()},Ee);return{isTriggered:()=>se,dispose:()=>{clearTimeout(me),se=!1}}},a=Ee=>{let te=!0;return queueMicrotask(()=>{te&&(te=!1,Ee())}),{isTriggered:()=>te,dispose:()=>{te=!1}}};class l{constructor(te){this.defaultDelay=te,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(te,se=this.defaultDelay){this.g=te,this.h(),this.b||(this.b=new Promise((Z,le)=>{this.d=Z,this.f=le}).then(()=>{if(this.b=null,this.d=null,this.g){const Z=this.g;return this.g=null,Z()}}));const me=()=>{this.a=null,this.d?.(null)};return this.a=se===D.$Ld?a(me):u(se,me),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new L.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Rg=l;class r{constructor(te){this.a=new l(te),this.b=new t}trigger(te,se){return this.a.trigger(()=>this.b.queue(te),se)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Sg=r;class s{constructor(){this.a=!1,this.b=new Promise((te,se)=>{this.d=te})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Tg=s;class c extends s{constructor(te){super(),this.f=setTimeout(()=>this.open(),te)}open(){clearTimeout(this.f),super.open()}}e.$Ug=c;function h(Ee,te){return te?new Promise((se,me)=>{const Z=setTimeout(()=>{le.dispose(),se()},Ee),le=te.onCancellationRequested(()=>{clearTimeout(Z),le.dispose(),me(new L.$4)})}):A(se=>h(Ee,se))}e.$Vg=h;function w(Ee,te=0,se){const me=setTimeout(()=>{Ee(),se&&Z.dispose()},te),Z=(0,M.$Pc)(()=>{clearTimeout(me),se?.deleteAndLeak(Z)});return se?.add(Z),Z}e.$Wg=w;function m(Ee,te,se){let me=0;const Z=setInterval(()=>{me++,(me>=se||Ee())&&le.dispose()},te),le=(0,M.$Pc)(()=>{clearInterval(Z)});return le}e.$Xg=m;function I(Ee){const te=[];let se=0;const me=Ee.length;function Z(){return se<me?Ee[se++]():null}function le(ne){ne!=null&&te.push(ne);const ae=Z();return ae?ae.then(le):Promise.resolve(te)}return Promise.resolve(null).then(le)}e.$Yg=I;function k(Ee,te=me=>!!me,se=null){let me=0;const Z=Ee.length,le=()=>{if(me>=Z)return Promise.resolve(se);const ne=Ee[me++];return Promise.resolve(ne()).then(de=>te(de)?Promise.resolve(de):le())};return le()}e.$Zg=k;function d(Ee,te=me=>!!me,se=null){if(Ee.length===0)return Promise.resolve(se);let me=Ee.length;const Z=()=>{me=-1;for(const le of Ee)le.cancel?.()};return new Promise((le,ne)=>{for(const ae of Ee)ae.then(de=>{--me>=0&&te(de)?(Z(),le(de)):me===0&&le(se)}).catch(de=>{--me>=0&&(Z(),ne(de))})})}e.$1g=d;class b{constructor(te){this.a=0,this.d=te,this.f=[],this.b=0,this.g=new P.$Od}get onDrained(){return this.g.event}get size(){return this.a}queue(te){return this.a++,new Promise((se,me)=>{this.f.push({factory:te,c:se,e:me}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const te=this.f.shift();this.b++;const se=te.factory();se.then(te.c,te.e),se.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$2g=b;class y extends b{constructor(){super(1)}}e.$3g=y;class C{constructor(){this.a=new Ce,this.b=0}queue(te){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,te())):this.a.run(this.b++,te())}}e.$4g=C;class B{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const te=new re;return this.b.add(te),te.p}g(){for(const[,te]of this.a)if(te.size>0)return!1;return!0}queueFor(te,se=R.$mg){const me=se.getComparisonKey(te);let Z=this.a.get(me);if(!Z){Z=new y;const le=this.f++,ne=P.Event.once(Z.onDrained)(()=>{Z?.dispose(),this.a.delete(me),this.h(),this.d?.deleteAndDispose(le),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new M.$Zc),this.d.set(le,ne),this.a.set(me,Z)}return Z}h(){this.g()&&this.j()}j(){for(const te of this.b)te.complete();this.b.clear()}dispose(){for(const[,te]of this.a)te.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$5g=B;class H{constructor(te,se){this.a=-1,typeof te=="function"&&typeof se=="number"&&this.setIfNotSet(te,se)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(te,se){this.cancel(),this.a=setTimeout(()=>{this.a=-1,te()},se)}setIfNotSet(te,se){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,te()},se))}}e.$6g=H;class U{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(te,se){this.cancel(),this.a=setInterval(()=>{te()},se)}}e.$7g=U;class z{constructor(te,se){this.b=-1,this.a=te,this.d=se,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(te=this.d){this.cancel(),this.b=setTimeout(this.f,te)}get delay(){return this.d}set delay(te){this.d=te}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$8g=z;class F{constructor(te,se){se%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${se}ms is not a multiple of 1000ms.`),this.a=te,this.b=se,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(te=this.b){te%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${te}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(te/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$9g=F;class N extends z{constructor(te,se){super(te,se),this.j=[]}work(te){this.j.push(te),this.isScheduled()||this.schedule()}h(){const te=this.j;this.j=[],this.a?.(te)}dispose(){this.j=[],super.dispose()}}e.$0g=N;class x extends M.$Rc{constructor(te,se){super(),this.g=te,this.h=se,this.a=[],this.b=this.B(new M.$Sc),this.f=!1}get pending(){return this.a.length}work(te){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+te.length>this.g.maxBufferedWork)return!1}else if(this.pending+te.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const se of te)this.a.push(se);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new z(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$$g=x,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$_g=(Ee,te)=>{(0,$.$B)(()=>{if(se)return;const me=Date.now()+15;te(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,me-Date.now())}}))});let se=!1;return{dispose(){se||(se=!0)}}}:e.$_g=(Ee,te,se)=>{const me=Ee.requestIdleCallback(te,typeof se=="number"?{timeout:se}:void 0);let Z=!1;return{dispose(){Z||(Z=!0,Ee.cancelIdleCallback(me))}}},e.$ah=Ee=>(0,e.$_g)(globalThis,Ee)}();class J{constructor(te,se){this.d=!1,this.a=()=>{try{this.f=se()}catch(me){this.g=me}finally{this.d=!0}},this.b=(0,e.$_g)(te,()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$bh=J;class ye extends J{constructor(te){super(globalThis,te)}}e.$ch=ye;async function De(Ee,te,se){let me;for(let Z=0;Z<se;Z++)try{return await Ee()}catch(le){me=le,await h(te)}throw me}e.$dh=De;class Ce{isRunning(te){return typeof te=="number"?this.a?.taskId===te:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(te,se,me){return this.a={taskId:te,cancel:()=>me?.(),promise:se},se.then(()=>this.d(te),()=>this.d(te)),se}d(te){this.a&&te===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const te=this.b;this.b=void 0,te.run().then(te.promiseResolve,te.promiseReject)}}queue(te){if(this.b)this.b.run=te;else{let se,me;const Z=new Promise((le,ne)=>{se=le,me=ne});this.b={run:te,promise:Z,promiseResolve:se,promiseReject:me}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$eh=Ce;class ge{constructor(te,se=()=>Date.now()){this.d=te,this.f=se,this.a=0,this.b=0}increment(){const te=this.f();return te-this.a>this.d&&(this.a=te,this.b=0),this.b++,this.b}}e.$fh=ge;var we;(function(Ee){Ee[Ee.Resolved=0]="Resolved",Ee[Ee.Rejected=1]="Rejected"})(we||(we={}));class re{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((te,se)=>{this.a=te,this.b=se})}complete(te){return new Promise(se=>{this.a(te),this.d={outcome:0,value:te},se()})}error(te){return new Promise(se=>{this.b(te),this.d={outcome:1,value:te},se()})}cancel(){return this.error(new L.$4)}}e.$gh=re;var oe;(function(Ee){async function te(me){let Z;const le=await Promise.all(me.map(ne=>ne.then(ae=>ae,ae=>{Z||(Z=ae)})));if(typeof Z<"u")throw Z;return le}Ee.settled=te;function se(me){return new Promise(async(Z,le)=>{try{await me(Z,le)}catch(ne){le(ne)}})}Ee.withAsyncBody=se})(oe||(e.Promises=oe={}));var ve;(function(Ee){Ee[Ee.Initial=0]="Initial",Ee[Ee.DoneOK=1]="DoneOK",Ee[Ee.DoneError=2]="DoneError"})(ve||(ve={}));class ee{static fromArray(te){return new ee(se=>{se.emitMany(te)})}static fromPromise(te){return new ee(async se=>{se.emitMany(await te)})}static fromPromises(te){return new ee(async se=>{await Promise.all(te.map(async me=>se.emitOne(await me)))})}static merge(te){return new ee(async se=>{await Promise.all(te.map(async me=>{for await(const Z of me)se.emitOne(Z)}))})}static{this.EMPTY=ee.fromArray([])}constructor(te){this.a=0,this.b=[],this.d=null,this.f=new P.$Od,queueMicrotask(async()=>{const se={emitOne:me=>this.g(me),emitMany:me=>this.h(me),reject:me=>this.k(me)};try{await Promise.resolve(te(se)),this.j()}catch(me){this.k(me)}finally{se.emitOne=void 0,se.emitMany=void 0,se.reject=void 0}})}[Symbol.asyncIterator](){let te=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(te<this.b.length)return{done:!1,value:this.b[te++]};if(this.a===1)return{done:!0,value:void 0};await P.Event.toPromise(this.f.event)}while(!0)}}}static map(te,se){return new ee(async me=>{for await(const Z of te)me.emitOne(se(Z))})}map(te){return ee.map(this,te)}static filter(te,se){return new ee(async me=>{for await(const Z of te)se(Z)&&me.emitOne(Z)})}filter(te){return ee.filter(this,te)}static coalesce(te){return ee.filter(te,se=>!!se)}coalesce(){return ee.coalesce(this)}static async toPromise(te){const se=[];for await(const me of te)se.push(me);return se}toPromise(){return ee.toPromise(this)}g(te){this.a===0&&(this.b.push(te),this.f.fire())}h(te){this.a===0&&(this.b=this.b.concat(te),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(te){this.a===0&&(this.a=2,this.d=te,this.f.fire())}}e.$hh=ee;class W extends ee{constructor(te,se){super(se),this.l=te}cancel(){this.l.cancel()}}e.$ih=W;function ue(Ee){const te=new E.$Yd,se=Ee(te.token);return new W(te,async me=>{const Z=te.token.onCancellationRequested(()=>{Z.dispose(),te.dispose(),me.reject(new L.$4)});try{for await(const le of se){if(te.token.isCancellationRequested)return;me.emitOne(le)}Z.dispose(),te.dispose()}catch(le){Z.dispose(),te.dispose(),me.reject(le)}})}e.$jh=ue;class Pe{constructor(){this.a=new re,this.b=new ee(me=>{if(te){me.reject(te);return}return se&&me.emitMany(se),this.d=Z=>me.reject(Z),this.f=Z=>me.emitOne(Z),this.a.p});let te,se;this.f=me=>{se||(se=[]),se.push(me)},this.d=me=>{te||(te=me)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(te){this.d(te),this.a.complete()}emitOne(te){this.f(te)}}e.$kh=Pe}),define(Ae[33],Re([1,0,18,12,46,28,19,21,13]),function(pe,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=void 0;function g(){return Object.create(null)}e.$vj=g,e.$wj="**",e.$xj="/";const A="[/\\\\]",S="[^/\\\\]",o=/\//g;function v(ye,De){switch(ye){case 0:return"";case 1:return`${S}*?`;default:return`(?:${A}|${S}+${A}${De?`|${A}${S}+`:""})*?`}}function p(ye,De){if(!ye)return[];const Ce=[];let ge=!1,we=!1,re="";for(const oe of ye){switch(oe){case De:if(!ge&&!we){Ce.push(re),re="";continue}break;case"{":ge=!0;break;case"}":ge=!1;break;case"[":we=!0;break;case"]":we=!1;break}re+=oe}return re&&Ce.push(re),Ce}e.$yj=p;function f(ye){if(!ye)return"";let De="";const Ce=p(ye,e.$xj);if(Ce.every(ge=>ge===e.$wj))De=".*";else{let ge=!1;Ce.forEach((we,re)=>{if(we===e.$wj){if(ge)return;De+=v(2,re===Ce.length-1)}else{let oe=!1,ve="",ee=!1,W="";for(const ue of we){if(ue!=="}"&&oe){ve+=ue;continue}if(ee&&(ue!=="]"||!W)){let Pe;ue==="-"?Pe=ue:(ue==="^"||ue==="!")&&!W?Pe="^":ue===e.$xj?Pe="":Pe=(0,D.$Ge)(ue),W+=Pe;continue}switch(ue){case"{":oe=!0;continue;case"[":ee=!0;continue;case"}":{const Ee=`(?:${p(ve,",").map(te=>f(te)).join("|")})`;De+=Ee,oe=!1,ve="";break}case"]":{De+="["+W+"]",ee=!1,W="";break}case"?":De+=S;continue;case"*":De+=v(1);continue;default:De+=(0,D.$Ge)(ue)}}re<Ce.length-1&&(Ce[re+1]!==e.$wj||re+2<Ce.length)&&(De+=A)}ge=we===e.$wj})}return De}const t=/^\*\*\/\*\.[\w\.-]+$/,i=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,u=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new M.$Cc(1e4),s=function(){return!1},c=function(){return null};function h(ye,De){if(!ye)return c;let Ce;typeof ye!="string"?Ce=ye.pattern:Ce=ye,Ce=Ce.trim();const ge=`${Ce}_${!!De.trimForExclusions}`;let we=r.get(ge);if(we)return w(we,ye);let re;return t.test(Ce)?we=I(Ce.substr(4),Ce):(re=i.exec(m(Ce,De)))?we=k(re[1],Ce):(De.trimForExclusions?u:n).test(Ce)?we=d(Ce,De):(re=a.exec(m(Ce,De)))?we=b(re[1].substr(1),Ce,!0):(re=l.exec(m(Ce,De)))?we=b(re[1],Ce,!1):we=y(Ce),r.set(ge,we),w(we,ye)}function w(ye,De){if(typeof De=="string")return ye;const Ce=function(ge,we){return(0,P.$Yf)(ge,De.base,!$.$l)?ye((0,D.$Ke)(ge.substr(De.base.length),R.sep),we):null};return Ce.allBasenames=ye.allBasenames,Ce.allPaths=ye.allPaths,Ce.basenames=ye.basenames,Ce.patterns=ye.patterns,Ce}function m(ye,De){return De.trimForExclusions&&ye.endsWith("/**")?ye.substr(0,ye.length-2):ye}function I(ye,De){return function(Ce,ge){return typeof Ce=="string"&&Ce.endsWith(ye)?De:null}}function k(ye,De){const Ce=`/${ye}`,ge=`\\${ye}`,we=function(oe,ve){return typeof oe!="string"?null:ve?ve===ye?De:null:oe===ye||oe.endsWith(Ce)||oe.endsWith(ge)?De:null},re=[ye];return we.basenames=re,we.patterns=[De],we.allBasenames=re,we}function d(ye,De){const Ce=x(ye.slice(1,-1).split(",").map(ve=>h(ve,De)).filter(ve=>ve!==c),ye),ge=Ce.length;if(!ge)return c;if(ge===1)return Ce[0];const we=function(ve,ee){for(let W=0,ue=Ce.length;W<ue;W++)if(Ce[W](ve,ee))return ye;return null},re=Ce.find(ve=>!!ve.allBasenames);re&&(we.allBasenames=re.allBasenames);const oe=Ce.reduce((ve,ee)=>ee.allPaths?ve.concat(ee.allPaths):ve,[]);return oe.length&&(we.allPaths=oe),we}function b(ye,De,Ce){const ge=R.sep===R.$fc.sep,we=ge?ye:ye.replace(o,R.sep),re=R.sep+we,oe=R.$fc.sep+ye;let ve;return Ce?ve=function(ee,W){return typeof ee=="string"&&(ee===we||ee.endsWith(re)||!ge&&(ee===ye||ee.endsWith(oe)))?De:null}:ve=function(ee,W){return typeof ee=="string"&&(ee===we||!ge&&ee===ye)?De:null},ve.allPaths=[(Ce?"*/":"./")+ye],ve}function y(ye){try{const De=new RegExp(`^${f(ye)}$`);return function(Ce){return De.lastIndex=0,typeof Ce=="string"&&De.test(Ce)?ye:null}}catch{return c}}function C(ye,De,Ce){return!ye||typeof De!="string"?!1:B(ye)(De,void 0,Ce)}e.$zj=C;function B(ye,De={}){if(!ye)return s;if(typeof ye=="string"||H(ye)){const Ce=h(ye,De);if(Ce===c)return s;const ge=function(we,re){return!!Ce(we,re)};return Ce.allBasenames&&(ge.allBasenames=Ce.allBasenames),Ce.allPaths&&(ge.allPaths=Ce.allPaths),ge}return F(ye,De)}e.$Aj=B;function H(ye){const De=ye;return De?typeof De.base=="string"&&typeof De.pattern=="string":!1}e.$Bj=H;function U(ye){return ye.allBasenames||[]}e.$Cj=U;function z(ye){return ye.allPaths||[]}e.$Dj=z;function F(ye,De){const Ce=x(Object.getOwnPropertyNames(ye).map(ve=>N(ve,ye[ve],De)).filter(ve=>ve!==c)),ge=Ce.length;if(!ge)return c;if(!Ce.some(ve=>!!ve.requiresSiblings)){if(ge===1)return Ce[0];const ve=function(ue,Pe){let Ee;for(let te=0,se=Ce.length;te<se;te++){const me=Ce[te](ue,Pe);if(typeof me=="string")return me;(0,L.$Hg)(me)&&(Ee||(Ee=[]),Ee.push(me))}return Ee?(async()=>{for(const te of Ee){const se=await te;if(typeof se=="string")return se}return null})():null},ee=Ce.find(ue=>!!ue.allBasenames);ee&&(ve.allBasenames=ee.allBasenames);const W=Ce.reduce((ue,Pe)=>Pe.allPaths?ue.concat(Pe.allPaths):ue,[]);return W.length&&(ve.allPaths=W),ve}const we=function(ve,ee,W){let ue,Pe;for(let Ee=0,te=Ce.length;Ee<te;Ee++){const se=Ce[Ee];se.requiresSiblings&&W&&(ee||(ee=(0,R.$mc)(ve)),ue||(ue=ee.substr(0,ee.length-(0,R.$nc)(ve).length)));const me=se(ve,ee,ue,W);if(typeof me=="string")return me;(0,L.$Hg)(me)&&(Pe||(Pe=[]),Pe.push(me))}return Pe?(async()=>{for(const Ee of Pe){const te=await Ee;if(typeof te=="string")return te}return null})():null},re=Ce.find(ve=>!!ve.allBasenames);re&&(we.allBasenames=re.allBasenames);const oe=Ce.reduce((ve,ee)=>ee.allPaths?ve.concat(ee.allPaths):ve,[]);return oe.length&&(we.allPaths=oe),we}function N(ye,De,Ce){if(De===!1)return c;const ge=h(ye,Ce);if(ge===c)return c;if(typeof De=="boolean")return ge;if(De){const we=De.when;if(typeof we=="string"){const re=(oe,ve,ee,W)=>{if(!W||!ge(oe,ve))return null;const ue=we.replace("$(basename)",()=>ee),Pe=W(ue);return(0,L.$Hg)(Pe)?Pe.then(Ee=>Ee?ye:null):Pe?ye:null};return re.requiresSiblings=!0,re}}return ge}function x(ye,De){const Ce=ye.filter(ve=>!!ve.basenames);if(Ce.length<2)return ye;const ge=Ce.reduce((ve,ee)=>{const W=ee.basenames;return W?ve.concat(W):ve},[]);let we;if(De){we=[];for(let ve=0,ee=ge.length;ve<ee;ve++)we.push(De)}else we=Ce.reduce((ve,ee)=>{const W=ee.patterns;return W?ve.concat(W):ve},[]);const re=function(ve,ee){if(typeof ve!="string")return null;if(!ee){let ue;for(ue=ve.length;ue>0;ue--){const Pe=ve.charCodeAt(ue-1);if(Pe===47||Pe===92)break}ee=ve.substr(ue)}const W=ge.indexOf(ee);return W!==-1?we[W]:null};re.basenames=ge,re.patterns=we,re.allBasenames=ge;const oe=ye.filter(ve=>!ve.basenames);return oe.push(re),oe}function J(ye,De){return(0,E.$tb)(ye,De,(Ce,ge)=>typeof Ce=="string"&&typeof ge=="string"?Ce===ge:typeof Ce!="string"&&typeof ge!="string"?Ce.base===ge.base&&Ce.pattern===ge.pattern:!1)}e.$Ej=J}),define(Ae[53],Re([1,0,11,125,25,13,2]),function(pe,e,E,L,P,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=e.MarkdownStringTextNewlineStyle=void 0;var $;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})($||(e.MarkdownStringTextNewlineStyle=$={}));class D{constructor(i="",n=!1){if(this.value=i,typeof this.value!="string")throw(0,E.$6)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(i,n=0){return this.value+=o(this.supportThemeIcons?(0,L.$1j)(i):i).replace(/([ \t]+)/g,(u,a)=>"&nbsp;".repeat(a.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,n){return this.value+="\n```",this.value+=i,this.value+=`
`,this.value+=n,this.value+="\n```\n",this}appendLink(i,n,u){return this.value+="[",this.value+=this.c(n,"]"),this.value+="](",this.value+=this.c(String(i),")"),u&&(this.value+=` "${this.c(this.c(u,'"'),")")}"`),this.value+=")",this}c(i,n){const u=new RegExp((0,M.$Ge)(n),"g");return i.replace(u,(a,l)=>i.charAt(l-1)!=="\\"?`\\${a}`:a)}}e.$7j=D;function g(t){return A(t)?!t.value:Array.isArray(t)?t.every(g):!0}e.$8j=g;function A(t){return t instanceof D?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||typeof t.isTrusted=="object"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.$9j=A;function S(t,i){return t===i?!0:!t||!i?!1:t.value===i.value&&t.isTrusted===i.isTrusted&&t.supportThemeIcons===i.supportThemeIcons&&t.supportHtml===i.supportHtml&&(t.baseUri===i.baseUri||!!t.baseUri&&!!i.baseUri&&(0,P.$pg)(R.URI.from(t.baseUri),R.URI.from(i.baseUri)))}e.$0j=S;function o(t){return t.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$$j=o;function v(t){return t.replace(/"/g,"&quot;")}e.$_j=v;function p(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$ak=p;function f(t){const i=[],n=t.split("|").map(a=>a.trim());t=n[0];const u=n[1];if(u){const a=/height=(\d+)/.exec(u),l=/width=(\d+)/.exec(u),r=a?a[1]:"",s=l?l[1]:"",c=isFinite(parseInt(s)),h=isFinite(parseInt(r));c&&i.push(`width="${s}"`),h&&i.push(`height="${r}"`)}return{href:t,dimensions:i}}e.$bk=f}),define(Ae[94],Re([1,0,18,46,19,21,25,13]),function(pe,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ev=e.$Dv=e.$Cv=e.$Bv=e.$Av=e.$zv=e.$yv=e.$xv=e.$wv=e.$vv=void 0;function D(h,w){const{os:m,tildify:I,relative:k}=w;if(k){const y=g(h,k,m);if(typeof y=="string")return y}let d=h.fsPath;if(m===1&&!M.$j?d=d.replace(/\//g,"\\"):m!==1&&M.$j&&(d=d.replace(/\\/g,"/")),m!==1&&I?.userHome){const y=I.userHome.fsPath;let C;h.scheme!==I.userHome.scheme&&h.path[0]===P.$fc.sep&&h.path[1]!==P.$fc.sep?C=I.userHome.with({path:h.path}).fsPath:C=d,d=o(C,y,m)}return(m===1?P.$ec:P.$fc).normalize(A(d,m===1))}e.$vv=D;function g(h,w,m){const I=m===1?P.$ec:P.$fc,k=m===3?R.$mg:R.$og,d=w.getWorkspace(),b=(0,E.$Nb)(d.folders);if(!b)return;h.scheme!==b.uri.scheme&&h.path[0]===P.$fc.sep&&h.path[1]!==P.$fc.sep&&(h=b.uri.with({path:h.path}));const y=w.getWorkspaceFolder(h);if(!y)return;let C;if(k.isEqual(y.uri,h)?C="":C=k.relativePath(y.uri,h)??"",C&&(C=I.normalize(C)),d.folders.length>1&&!w.noPrefix){const B=y.name?y.name:k.basenameOrAuthority(y.uri);C=C?`${B} \u2022 ${C}`:B}return C}function A(h,w=M.$j){return(0,L.$3f)(h,w)?h.charAt(0).toUpperCase()+h.slice(1):h}e.$wv=A;let S=Object.create(null);function o(h,w,m=M.OS){if(m===1||!h||!w)return h;let I=S.original===w?S.normalized:void 0;I||(I=w,M.$j&&(I=(0,L.$Sf)(I)),I=`${(0,$.$Le)(I,P.$fc.sep)}${P.$fc.sep}`,S={original:w,normalized:I});let k=h;return M.$j&&(k=(0,L.$Sf)(k)),(m===3?k.startsWith(I):(0,$.$4e)(k,I))?`~/${k.substr(I.length)}`:h}e.$xv=o;function v(h,w){return h.replace(/^~($|\/|\\)/,`${w}$1`)}e.$yv=v;const p="\u2026",f="\\\\",t="~";function i(h,w=P.sep){const m=new Array(h.length);let I=!1;for(let k=0;k<h.length;k++){const d=h[k];if(d===""){m[k]=`.${w}`;continue}if(!d){m[k]=d;continue}I=!0;let b="",y=d;y.indexOf(f)===0?(b=y.substr(0,y.indexOf(f)+f.length),y=y.substr(y.indexOf(f)+f.length)):y.indexOf(w)===0?(b=y.substr(0,y.indexOf(w)+w.length),y=y.substr(y.indexOf(w)+w.length)):y.indexOf(t)===0&&(b=y.substr(0,y.indexOf(t)+t.length),y=y.substr(y.indexOf(t)+t.length));const C=y.split(w);for(let B=1;I&&B<=C.length;B++)for(let H=C.length-B;I&&H>=0;H--){I=!1;let U=C.slice(H,H+B).join(w);for(let z=0;!I&&z<h.length;z++)if(z!==k&&h[z]&&h[z].indexOf(U)>-1){const F=H+B===C.length,N=H>0&&h[z].indexOf(w)>-1?w+U:U,x=h[z].endsWith(N);I=!F||x}if(!I){let z="";(C[0].endsWith(":")||b!=="")&&(H===1&&(H=0,B++,U=C[0]+w+U),H>0&&(z=C[0]+w),z=b+z),H>0&&(z=z+p+w),z=z+U,H+B<C.length&&(z=z+w+p),m[k]=z}}I&&(m[k]=d)}return m}e.$zv=i;var n;(function(h){h[h.TEXT=0]="TEXT",h[h.VARIABLE=1]="VARIABLE",h[h.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function u(h,w=Object.create(null)){const m=[];let I=!1,k="";for(const d of h)if(d==="$"||I&&d==="{")k&&m.push({value:k,type:n.TEXT}),k="",I=!0;else if(d==="}"&&I){const b=w[k];if(typeof b=="string")b.length&&m.push({value:b,type:n.VARIABLE});else if(b){const y=m[m.length-1];(!y||y.type!==n.SEPARATOR)&&m.push({value:b.label,type:n.SEPARATOR})}k="",I=!1}else k+=d;return k&&!I&&m.push({value:k,type:n.TEXT}),m.filter((d,b)=>{if(d.type===n.SEPARATOR){const y=m[b-1],C=m[b+1];return[y,C].every(B=>B&&(B.type===n.VARIABLE||B.type===n.TEXT)&&B.value.length>0)}return!0}).map(d=>d.value).join("")}e.$Av=u;function a(h,w){return M.$k||w?h.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.$k?"&":"&&"):h.replace(/&&|&/g,m=>m==="&"?"&&":"&")}e.$Bv=a;function l(h,w){return M.$k||w?h.replace(/\(&&\w\)|&&/g,""):M.$j?h.replace(/&&|&/g,m=>m==="&"?"&&":"&"):h.replace(/&&/g,"_")}e.$Cv=l;function r(h){return h.replace(/&/g,"&&")}e.$Dv=r;function s(h){if(h.endsWith("]")){const w=h.lastIndexOf(" [",h.length-2);if(w!==-1){const m=c(h.substring(0,w));return{name:m.name,parentPath:m.parentPath+h.substring(w)}}}return c(h)}e.$Ev=s;function c(h){const w=h.indexOf("/")!==-1?P.$fc:P.$ec,m=w.basename(h),I=w.dirname(h);return m.length?{name:m,parentPath:I}:{name:I,parentPath:""}}}),define(Ae[139],Re([1,0,24,2]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.$Pm=void 0;function P(S){return S.toJSON()}class M{constructor(o){this.a=o}transformIncoming(o){const v=this.a.transformIncoming(o);return v===o?o:P(L.URI.from(v))}transformOutgoing(o){const v=this.a.transformOutgoing(o);return v===o?o:P(L.URI.from(v))}transformOutgoingURI(o){const v=this.a.transformOutgoing(o);return v===o?o:L.URI.from(v)}transformOutgoingScheme(o){return this.a.transformOutgoingScheme(o)}}e.$Pm=M,e.$Qm=new class{transformIncoming(S){return S}transformOutgoing(S){return S}transformOutgoingURI(S){return S}transformOutgoingScheme(S){return S}};function R(S,o,v){if(!S||v>200)return null;if(typeof S=="object"){if(S instanceof L.URI)return o.transformOutgoing(S);for(const p in S)if(Object.hasOwnProperty.call(S,p)){const f=R(S[p],o,v+1);f!==null&&(S[p]=f)}}return null}function $(S,o){const v=R(S,o,0);return v===null?S:v}e.$Rm=$;function D(S,o,v,p){if(!S||p>200)return null;if(typeof S=="object"){if(S.$mid===1)return v?L.URI.revive(o.transformIncoming(S)):o.transformIncoming(S);if(S instanceof E.$ce)return null;for(const f in S)if(Object.hasOwnProperty.call(S,f)){const t=D(S[f],o,v,p+1);t!==null&&(S[f]=t)}}return null}function g(S,o){const v=D(S,o,!1,0);return v===null?S:v}e.$Sm=g;function A(S,o){const v=D(S,o,!0,0);return v===null?S:v}e.$Tm=A}),define(Ae[140],Re([1,0,13,21,24]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rs=e.$Qs=e.$Ps=void 0;let M;function R(){return M||(M=new TextDecoder("UTF-16LE")),M}let $;function D(){return $||($=new TextDecoder("UTF-16BE")),$}let g;function A(){return g||(g=L.$D()?R():D()),g}e.$Ps=A;function S(p,f,t){const i=new Uint16Array(p.buffer,f,t);return t>0&&(i[0]===65279||i[0]===65534)?o(p,f,t):R().decode(i)}e.$Qs=S;function o(p,f,t){const i=[];let n=0;for(let u=0;u<t;u++){const a=P.$ee(p,f);f+=2,i[n++]=String.fromCharCode(a)}return i.join("")}class v{constructor(f){this.a=f|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const f=new Uint16Array(this.b.buffer,0,this.d);return A().decode(f)}f(){const f=this.e();this.d=0,this.c===null?this.c=[f]:this.c[this.c.length]=f}appendCharCode(f){const t=this.a-this.d;t<=1&&(t===0||E.$7e(f))&&this.f(),this.b[this.d++]=f}appendASCIICharCode(f){this.d===this.a&&this.f(),this.b[this.d++]=f}appendString(f){const t=f.length;if(this.d+t>=this.a){this.f(),this.c[this.c.length]=f;return}for(let i=0;i<t;i++)this.b[this.d++]=f.charCodeAt(i)}}e.$Rs=v}),define(Ae[141],Re([1,0,24,140]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ts=e.$Ss=void 0;function P(D){return D.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class M{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(g,A,S,o){this.oldPosition=g,this.oldText=A,this.newPosition=S,this.newText=o}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${P(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${P(this.oldText)}")`:`(replace@${this.oldPosition} "${P(this.oldText)}" with "${P(this.newText)}")`}static a(g){return 4+2*g.length}static c(g,A,S){const o=A.length;E.$he(g,o,S),S+=4;for(let v=0;v<o;v++)E.$fe(g,A.charCodeAt(v),S),S+=2;return S}static d(g,A){const S=E.$ge(g,A);return A+=4,(0,L.$Qs)(g,A,S)}writeSize(){return 4+4+M.a(this.oldText)+M.a(this.newText)}write(g,A){return E.$he(g,this.oldPosition,A),A+=4,E.$he(g,this.newPosition,A),A+=4,A=M.c(g,this.oldText,A),A=M.c(g,this.newText,A),A}static read(g,A,S){const o=E.$ge(g,A);A+=4;const v=E.$ge(g,A);A+=4;const p=M.d(g,A);A+=M.a(p);const f=M.d(g,A);return A+=M.a(f),S.push(new M(o,p,v,f)),A}}e.$Ss=M;function R(D,g){return D===null||D.length===0?g:new $(D,g).compress()}e.$Ts=R;class ${constructor(g,A){this.a=g,this.c=A,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let g=0,A=0,S=this.n(g),o=this.l(A);for(;g<this.f||A<this.h;){if(S===null){this.k(o),o=this.l(++A);continue}if(o===null){this.m(S),S=this.n(++g);continue}if(o.oldEnd<=S.newPosition){this.k(o),o=this.l(++A);continue}if(S.newEnd<=o.oldPosition){this.m(S),S=this.n(++g);continue}if(o.oldPosition<S.newPosition){const[i,n]=$.r(o,S.newPosition-o.oldPosition);this.k(i),o=n;continue}if(S.newPosition<o.oldPosition){const[i,n]=$.q(S,o.oldPosition-S.newPosition);this.m(i),S=n;continue}let f,t;if(o.oldEnd===S.newEnd)f=S,t=o,S=this.n(++g),o=this.l(++A);else if(o.oldEnd<S.newEnd){const[i,n]=$.q(S,o.oldLength);f=i,t=o,S=n,o=this.l(++A)}else{const[i,n]=$.r(o,S.newLength);f=S,t=i,S=this.n(++g),o=n}this.d[this.e++]=new M(f.oldPosition,f.oldText,t.newPosition,t.newText),this.g+=f.newLength-f.oldLength,this.j+=t.newLength-t.oldLength}const v=$.s(this.d);return $.t(v)}k(g){this.d[this.e++]=$.o(this.g,g),this.j+=g.newLength-g.oldLength}l(g){return g<this.h?this.c[g]:null}m(g){this.d[this.e++]=$.p(this.j,g),this.g+=g.newLength-g.oldLength}n(g){return g<this.f?this.a[g]:null}static o(g,A){return new M(A.oldPosition-g,A.oldText,A.newPosition,A.newText)}static p(g,A){return new M(A.oldPosition,A.oldText,A.newPosition+g,A.newText)}static q(g,A){const S=g.newText.substr(0,A),o=g.newText.substr(A);return[new M(g.oldPosition,g.oldText,g.newPosition,S),new M(g.oldEnd,"",g.newPosition+A,o)]}static r(g,A){const S=g.oldText.substr(0,A),o=g.oldText.substr(A);return[new M(g.oldPosition,S,g.newPosition,g.newText),new M(g.oldPosition+A,o,g.newEnd,"")]}static s(g){if(g.length===0)return g;const A=[];let S=0,o=g[0];for(let v=1;v<g.length;v++){const p=g[v];o.oldEnd===p.oldPosition?o=new M(o.oldPosition,o.oldText+p.oldText,o.newPosition,o.newText+p.newText):(A[S++]=o,o=p)}return A[S++]=o,A}static t(g){if(g.length===0)return g;const A=[];let S=0;for(let o=0;o<g.length;o++){const v=g[o];v.oldText!==v.newText&&(A[S++]=v)}return A}}}),define(Ae[142],Re([1,0,33,19]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HE=void 0;function P(M,R,$,D,g,A){if(Array.isArray(M)){let S=0;for(const o of M){const v=P(o,R,$,D,g,A);if(v===10)return v;v>S&&(S=v)}return S}else{if(typeof M=="string")return D?M==="*"?5:M===$?10:0:0;if(M){const{language:S,pattern:o,scheme:v,hasAccessToAllModels:p,notebookType:f}=M;if(!D&&!p)return 0;f&&g&&(R=g);let t=0;if(v)if(v===R.scheme)t=10;else if(v==="*")t=5;else return 0;if(S)if(S===$)t=10;else if(S==="*")t=Math.max(t,5);else return 0;if(f)if(f===A)t=10;else if(f==="*"&&A!==void 0)t=Math.max(t,5);else return 0;if(o){let i;if(typeof o=="string"?i=o:i={...o,base:(0,L.$gc)(o.base)},i===R.fsPath||(0,E.$zj)(i,R.fsPath))t=10;else return 0}return t}else return 0}}e.$HE=P}),define(Ae[143],Re([1,0,5,13,29,92,91,127,141,6]),function(pe,e,E,L,P,M,R,$,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JB=void 0;class A extends g.$Rc{constructor(o,v,p,f,t,i,n){super(),this.m=this.B(new E.$Od),this.onDidChangeContent=this.m.event,this.f=v,this.j=!i,this.g=f,this.h=t,this.c=new R.$IB(o,p,n)}equals(o){return!(o instanceof A)||this.f!==o.f||this.getEOL()!==o.getEOL()?!1:this.c.equal(o.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(o){return this.c.createSnapshot(o?this.f:"")}getOffsetAt(o,v){return this.c.getOffsetAt(o,v)}getPositionAt(o){return this.c.getPositionAt(o)}getRangeAt(o,v){const p=o+v,f=this.getPositionAt(o),t=this.getPositionAt(p);return new P.$xs(f.lineNumber,f.column,t.lineNumber,t.column)}getValueInRange(o,v=0){if(o.isEmpty())return"";const p=this.n(v);return this.c.getValueInRange(o,p)}getValueLengthInRange(o,v=0){if(o.isEmpty())return 0;if(o.startLineNumber===o.endLineNumber)return o.endColumn-o.startColumn;const p=this.getOffsetAt(o.startLineNumber,o.startColumn),f=this.getOffsetAt(o.endLineNumber,o.endColumn);let t=0;const i=this.n(v),n=this.getEOL();if(i.length!==n.length){const u=i.length-n.length,a=o.endLineNumber-o.startLineNumber;t=u*a}return f-p+t}getCharacterCountInRange(o,v=0){if(this.j){let p=0;const f=o.startLineNumber,t=o.endLineNumber;for(let i=f;i<=t;i++){const n=this.getLineContent(i),u=i===f?o.startColumn-1:0,a=i===t?o.endColumn-1:n.length;for(let l=u;l<a;l++)L.$7e(n.charCodeAt(l))?(p=p+1,l=l+1):p=p+1}return p+=this.n(v).length*(t-f),p}return this.getValueLengthInRange(o,v)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(o){return this.c.getLineContent(o)}getLineCharCode(o,v){return this.c.getLineCharCode(o,v)}getCharCode(o){return this.c.getCharCode(o)}getLineLength(o){return this.c.getLineLength(o)}getLineMinColumn(o){return 1}getLineMaxColumn(o){return this.getLineLength(o)+1}getLineFirstNonWhitespaceColumn(o){const v=L.$Re(this.getLineContent(o));return v===-1?0:v+1}getLineLastNonWhitespaceColumn(o){const v=L.$Te(this.getLineContent(o));return v===-1?0:v+2}n(o){switch(o){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(o){this.c.setEOL(o)}applyEdits(o,v,p){let f=this.g,t=this.h,i=this.j,n=!0,u=[];for(let w=0;w<o.length;w++){const m=o[w];n&&m._isTracked&&(n=!1);const I=m.range;if(m.text){let C=!0;i||(C=!L.$ff(m.text),i=C),!f&&C&&(f=L.$ef(m.text)),!t&&C&&(t=L.$hf(m.text))}let k="",d=0,b=0,y=0;if(m.text){let C;[d,b,y,C]=(0,$.$0s)(m.text);const B=this.getEOL();C===0||C===(B===`\r
`?2:1)?k=m.text:k=m.text.replace(/\r\n|\r|\n/g,B)}u[w]={sortIndex:w,identifier:m.identifier||null,range:I,rangeOffset:this.getOffsetAt(I.startLineNumber,I.startColumn),rangeLength:this.getValueLengthInRange(I),text:k,eolCount:d,firstLineLength:b,lastLineLength:y,forceMoveMarkers:!!m.forceMoveMarkers,isAutoWhitespaceEdit:m.isAutoWhitespaceEdit||!1}}u.sort(A.u);let a=!1;for(let w=0,m=u.length-1;w<m;w++){const I=u[w].range.getEndPosition(),k=u[w+1].range.getStartPosition();if(k.isBeforeOrEqual(I)){if(k.isBefore(I))throw new Error("Overlapping ranges are not allowed!");a=!0}}n&&(u=this.s(u));const l=p||v?A._getInverseEditRanges(u):[],r=[];if(v)for(let w=0;w<u.length;w++){const m=u[w],I=l[w];if(m.isAutoWhitespaceEdit&&m.range.isEmpty())for(let k=I.startLineNumber;k<=I.endLineNumber;k++){let d="";k===I.startLineNumber&&(d=this.getLineContent(m.range.startLineNumber),L.$Re(d)!==-1)||r.push({lineNumber:k,oldContent:d})}}let s=null;if(p){let w=0;s=[];for(let m=0;m<u.length;m++){const I=u[m],k=l[m],d=this.getValueInRange(I.range),b=I.rangeOffset+w;w+=I.text.length-d.length,s[m]={sortIndex:I.sortIndex,identifier:I.identifier,range:k,text:d,textChange:new D.$Ss(I.rangeOffset,d,b,I.text)}}a||s.sort((m,I)=>m.sortIndex-I.sortIndex)}this.g=f,this.h=t,this.j=i;const c=this.t(u);let h=null;if(v&&r.length>0){r.sort((w,m)=>m.lineNumber-w.lineNumber),h=[];for(let w=0,m=r.length;w<m;w++){const I=r[w].lineNumber;if(w>0&&r[w-1].lineNumber===I)continue;const k=r[w].oldContent,d=this.getLineContent(I);d.length===0||d===k||L.$Re(d)!==-1||h.push(I)}}return this.m.fire(),new M.$Su(s,c,h)}s(o){return o.length<1e3?o:[this._toSingleEditOperation(o)]}_toSingleEditOperation(o){let v=!1;const p=o[0].range,f=o[o.length-1].range,t=new P.$xs(p.startLineNumber,p.startColumn,f.endLineNumber,f.endColumn);let i=p.startLineNumber,n=p.startColumn;const u=[];for(let c=0,h=o.length;c<h;c++){const w=o[c],m=w.range;v=v||w.forceMoveMarkers,u.push(this.getValueInRange(new P.$xs(i,n,m.startLineNumber,m.startColumn))),w.text.length>0&&u.push(w.text),i=m.endLineNumber,n=m.endColumn}const a=u.join(""),[l,r,s]=(0,$.$0s)(a);return{sortIndex:0,identifier:o[0].identifier,range:t,rangeOffset:this.getOffsetAt(t.startLineNumber,t.startColumn),rangeLength:this.getValueLengthInRange(t,0),text:a,eolCount:l,firstLineLength:r,lastLineLength:s,forceMoveMarkers:v,isAutoWhitespaceEdit:!1}}t(o){o.sort(A.w);const v=[];for(let p=0;p<o.length;p++){const f=o[p],t=f.range.startLineNumber,i=f.range.startColumn,n=f.range.endLineNumber,u=f.range.endColumn;if(t===n&&i===u&&f.text.length===0)continue;f.text?(this.c.delete(f.rangeOffset,f.rangeLength),this.c.insert(f.rangeOffset,f.text,!0)):this.c.delete(f.rangeOffset,f.rangeLength);const a=new P.$xs(t,i,n,u);v.push({range:a,rangeLength:f.rangeLength,text:f.text,rangeOffset:f.rangeOffset,forceMoveMarkers:f.forceMoveMarkers})}return v}findMatchesLineByLine(o,v,p,f){return this.c.findMatchesLineByLine(o,v,p,f)}getPieceTree(){return this.c}static _getInverseEditRange(o,v){const p=o.startLineNumber,f=o.startColumn,[t,i,n]=(0,$.$0s)(v);let u;if(v.length>0){const a=t+1;a===1?u=new P.$xs(p,f,p,f+i):u=new P.$xs(p,f,p+a-1,n+1)}else u=new P.$xs(p,f,p,f);return u}static _getInverseEditRanges(o){const v=[];let p=0,f=0,t=null;for(let i=0,n=o.length;i<n;i++){const u=o[i];let a,l;t?t.range.endLineNumber===u.range.startLineNumber?(a=p,l=f+(u.range.startColumn-t.range.endColumn)):(a=p+(u.range.startLineNumber-t.range.endLineNumber),l=u.range.startColumn):(a=u.range.startLineNumber,l=u.range.startColumn);let r;if(u.text.length>0){const s=u.eolCount+1;s===1?r=new P.$xs(a,l,a,l+u.firstLineLength):r=new P.$xs(a,l,a+s-1,u.lastLineLength+1)}else r=new P.$xs(a,l,a,l);p=r.endLineNumber,f=r.endColumn,v.push(r),t=u}return v}static u(o,v){const p=P.$xs.compareRangesUsingEnds(o.range,v.range);return p===0?o.sortIndex-v.sortIndex:p}static w(o,v){const p=P.$xs.compareRangesUsingEnds(o.range,v.range);return p===0?v.sortIndex-o.sortIndex:-p}}e.$JB=A}),define(Ae[144],Re([1,0,13,91,143]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KB=void 0;class M{constructor(D,g,A,S,o,v,p,f,t){this.a=D,this.b=g,this.c=A,this.d=S,this.e=o,this.f=v,this.g=p,this.h=f,this.j=t}k(D){const g=this.c+this.d+this.e,A=this.c+this.e;return g===0?D===1?`
`:`\r
`:A>g/2?`\r
`:`
`}create(D){const g=this.k(D),A=this.a;if(this.j&&(g===`\r
`&&(this.c>0||this.d>0)||g===`
`&&(this.c>0||this.e>0)))for(let o=0,v=A.length;o<v;o++){const p=A[o].buffer.replace(/\r\n|\r|\n/g,g),f=(0,L.$EB)(p);A[o]=new L.$HB(p,f)}const S=new P.$JB(A,this.b,g,this.f,this.g,this.h,this.j);return{textBuffer:S,disposable:S}}getFirstLineText(D){return this.a[0].buffer.substr(0,D).split(/\r\n|\r|\n/)[0]}}class R{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(D){if(D.length===0)return;this.a.length===0&&E.$nf(D)&&(this.b=E.$mf,D=D.substr(1));const g=D.charCodeAt(D.length-1);g===13||g>=55296&&g<=56319?(this.m(D.substr(0,D.length-1),!1),this.c=!0,this.d=g):(this.m(D,!1),this.c=!1,this.d=g)}m(D,g){!g&&D.length===0||(this.c?this.n(String.fromCharCode(this.d)+D):this.n(D))}n(D){const g=(0,L.$FB)(this.e,D);this.a.push(new L.$HB(D,g.lineStarts)),this.f+=g.cr,this.g+=g.lf,this.h+=g.crlf,g.isBasicASCII||(this.l=!1,this.j||(this.j=E.$ef(D)),this.k||(this.k=E.$hf(D)))}finish(D=!0){return this.o(),new M(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,D)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const D=this.a[this.a.length-1];D.buffer+=String.fromCharCode(this.d);const g=(0,L.$EB)(D.buffer);D.lineStarts=g,this.d===13&&this.f++}}}e.$KB=R}),define(Ae[95],Re([1,0,24,21]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u$=e.$t$=void 0;var P;(function(S){S[S.Full=1]="Full",S[S.Delta=2]="Delta"})(P||(P={}));function M(S){for(let o=0,v=S.length;o<v;o+=4){const p=S[o+0],f=S[o+1],t=S[o+2],i=S[o+3];S[o+0]=i,S[o+1]=t,S[o+2]=f,S[o+3]=p}}function R(S){const o=new Uint8Array(S.buffer,S.byteOffset,S.length*4);return L.$D()||M(o),E.$ce.wrap(o)}function $(S){const o=S.buffer;if(L.$D()||M(o),o.byteOffset%4===0)return new Uint32Array(o.buffer,o.byteOffset,o.length/4);{const v=new Uint8Array(o.byteLength);return v.set(o),new Uint32Array(v.buffer,v.byteOffset,v.length/4)}}function D(S){const o=new Uint32Array(g(S));let v=0;if(o[v++]=S.id,S.type==="full")o[v++]=1,o[v++]=S.data.length,o.set(S.data,v),v+=S.data.length;else{o[v++]=2,o[v++]=S.deltas.length;for(const p of S.deltas)o[v++]=p.start,o[v++]=p.deleteCount,p.data?(o[v++]=p.data.length,o.set(p.data,v),v+=p.data.length):o[v++]=0}return R(o)}e.$t$=D;function g(S){let o=0;if(o+=1+1,S.type==="full")o+=1+S.data.length;else{o+=1,o+=(1+1+1)*S.deltas.length;for(const v of S.deltas)v.data&&(o+=v.data.length)}return o}function A(S){const o=$(S);let v=0;const p=o[v++];if(o[v++]===1){const n=o[v++],u=o.subarray(v,v+n);return v+=n,{id:p,type:"full",data:u}}const t=o[v++],i=[];for(let n=0;n<t;n++){const u=o[v++],a=o[v++],l=o[v++];let r;l>0&&(r=o.subarray(v,v+l),v+=l),i[n]={start:u,deleteCount:a,data:r}}return{id:p,type:"delta",deltas:i}}e.$u$=A}),define(Ae[145],Re([9,10]),function(pe,e){return pe.create("vs/editor/common/config/editorOptions",e)}),define(Ae[146],Re([1,0,18,26,21,128,147,145]),function(pe,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var D;(function(Y){Y[Y.None=0]="None",Y[Y.Keep=1]="Keep",Y[Y.Brackets=2]="Brackets",Y[Y.Advanced=3]="Advanced",Y[Y.Full=4]="Full"})(D||(e.EditorAutoIndentStrategy=D={})),e.MINIMAP_GUTTER_WIDTH=8;class g{constructor(X){this.c=X}hasChanged(X){return this.c[X]}}e.ConfigurationChangedEvent=g;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class S{constructor(X,be,Be,Ne){this.id=X,this.name=be,this.defaultValue=Be,this.schema=Ne}applyUpdate(X,be){return v(X,be)}compute(X,be,Be){return Be}}class o{constructor(X,be){this.newValue=X,this.didChange=be}}e.ApplyUpdateResult=o;function v(Y,X){if(typeof Y!="object"||typeof X!="object"||!Y||!X)return new o(X,Y!==X);if(Array.isArray(Y)||Array.isArray(X)){const Be=Array.isArray(Y)&&Array.isArray(X)&&E.$tb(Y,X);return new o(X,!Be)}let be=!1;for(const Be in X)if(X.hasOwnProperty(Be)){const Ne=v(Y[Be],X[Be]);Ne.didChange&&(Y[Be]=Ne.newValue,be=!0)}return new o(Y,be)}class p{constructor(X){this.schema=void 0,this.id=X,this.name="_never_",this.defaultValue=void 0}applyUpdate(X,be){return v(X,be)}validate(X){return this.defaultValue}}class f{constructor(X,be,Be,Ne){this.id=X,this.name=be,this.defaultValue=Be,this.schema=Ne}applyUpdate(X,be){return v(X,be)}validate(X){return typeof X>"u"?this.defaultValue:X}compute(X,be,Be){return Be}}function t(Y,X){return typeof Y>"u"?X:Y==="false"?!1:!!Y}e.boolean=t;class i extends f{constructor(X,be,Be,Ne=void 0){typeof Ne<"u"&&(Ne.type="boolean",Ne.default=Be),super(X,be,Be,Ne)}validate(X){return t(X,this.defaultValue)}}function n(Y,X,be,Be){if(typeof Y>"u")return X;let Ne=parseInt(Y,10);return isNaN(Ne)?X:(Ne=Math.max(be,Ne),Ne=Math.min(Be,Ne),Ne|0)}e.clampedInt=n;class u extends f{static clampedInt(X,be,Be,Ne){return n(X,be,Be,Ne)}constructor(X,be,Be,Ne,Xe,nt=void 0){typeof nt<"u"&&(nt.type="integer",nt.default=Be,nt.minimum=Ne,nt.maximum=Xe),super(X,be,Be,nt),this.minimum=Ne,this.maximum=Xe}validate(X){return u.clampedInt(X,this.defaultValue,this.minimum,this.maximum)}}function a(Y,X,be,Be){if(typeof Y>"u")return X;const Ne=l.float(Y,X);return l.clamp(Ne,be,Be)}e.clampedFloat=a;class l extends f{static clamp(X,be,Be){return X<be?be:X>Be?Be:X}static float(X,be){if(typeof X=="number")return X;if(typeof X>"u")return be;const Be=parseFloat(X);return isNaN(Be)?be:Be}constructor(X,be,Be,Ne,Xe){typeof Xe<"u"&&(Xe.type="number",Xe.default=Be),super(X,be,Be,Xe),this.validationFn=Ne}validate(X){return this.validationFn(l.float(X,this.defaultValue))}}class r extends f{static string(X,be){return typeof X!="string"?be:X}constructor(X,be,Be,Ne=void 0){typeof Ne<"u"&&(Ne.type="string",Ne.default=Be),super(X,be,Be,Ne)}validate(X){return r.string(X,this.defaultValue)}}function s(Y,X,be,Be){return typeof Y!="string"?X:Be&&Y in Be?Be[Y]:be.indexOf(Y)===-1?X:Y}e.stringSet=s;class c extends f{constructor(X,be,Be,Ne,Xe=void 0){typeof Xe<"u"&&(Xe.type="string",Xe.enum=Ne,Xe.default=Be),super(X,be,Be,Xe),this.c=Ne}validate(X){return s(X,this.defaultValue,this.c)}}class h extends S{constructor(X,be,Be,Ne,Xe,nt,$t=void 0){typeof $t<"u"&&($t.type="string",$t.enum=Xe,$t.default=Ne),super(X,be,Be,$t),this.c=Xe,this.d=nt}validate(X){return typeof X!="string"?this.defaultValue:this.c.indexOf(X)===-1?this.defaultValue:this.d(X)}}function w(Y){switch(Y){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class m extends S{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[$.localize(0,null),$.localize(1,null),$.localize(2,null)],default:"auto",tags:["accessibility"],description:$.localize(3,null)})}validate(X){switch(X){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(X,be,Be){return Be===0?X.accessibilitySupport:Be}}class I extends S{constructor(){const X={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",X,{"editor.comments.insertSpace":{type:"boolean",default:X.insertSpace,description:$.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:X.ignoreEmptyLines,description:$.localize(5,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const be=X;return{insertSpace:t(be.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:t(be.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var k;(function(Y){Y[Y.Hidden=0]="Hidden",Y[Y.Blink=1]="Blink",Y[Y.Smooth=2]="Smooth",Y[Y.Phase=3]="Phase",Y[Y.Expand=4]="Expand",Y[Y.Solid=5]="Solid"})(k||(e.TextEditorCursorBlinkingStyle=k={}));function d(Y){switch(Y){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var b;(function(Y){Y[Y.Line=1]="Line",Y[Y.Block=2]="Block",Y[Y.Underline=3]="Underline",Y[Y.LineThin=4]="LineThin",Y[Y.BlockOutline=5]="BlockOutline",Y[Y.UnderlineThin=6]="UnderlineThin"})(b||(e.TextEditorCursorStyle=b={}));function y(Y){switch(Y){case b.Line:return"line";case b.Block:return"block";case b.Underline:return"underline";case b.LineThin:return"line-thin";case b.BlockOutline:return"block-outline";case b.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=y;function C(Y){switch(Y){case"line":return b.Line;case"block":return b.Block;case"underline":return b.Underline;case"line-thin":return b.LineThin;case"block-outline":return b.BlockOutline;case"underline-thin":return b.UnderlineThin}}class B extends p{constructor(){super(141)}compute(X,be,Be){const Ne=["monaco-editor"];return be.get(39)&&Ne.push(be.get(39)),X.extraEditorClassName&&Ne.push(X.extraEditorClassName),be.get(73)==="default"?Ne.push("mouse-default"):be.get(73)==="copy"&&Ne.push("mouse-copy"),be.get(111)&&Ne.push("showUnused"),be.get(139)&&Ne.push("showDeprecated"),Ne.join(" ")}}class H extends i{constructor(){super(37,"emptySelectionClipboard",!0,{description:$.localize(6,null)})}compute(X,be,Be){return Be&&X.emptySelectionClipboard}}class U extends S{constructor(){const X={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",X,{"editor.find.cursorMoveOnType":{type:"boolean",default:X.cursorMoveOnType,description:$.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:X.seedSearchStringFromSelection,enumDescriptions:[$.localize(8,null),$.localize(9,null),$.localize(10,null)],description:$.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:X.autoFindInSelection,enumDescriptions:[$.localize(12,null),$.localize(13,null),$.localize(14,null)],description:$.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:X.globalFindClipboard,description:$.localize(16,null),included:P.$k},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:X.addExtraSpaceOnTop,description:$.localize(17,null)},"editor.find.loop":{type:"boolean",default:X.loop,description:$.localize(18,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const be=X;return{cursorMoveOnType:t(be.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof X.seedSearchStringFromSelection=="boolean"?X.seedSearchStringFromSelection?"always":"never":s(be.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof X.autoFindInSelection=="boolean"?X.autoFindInSelection?"always":"never":s(be.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:t(be.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:t(be.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:t(be.loop,this.defaultValue.loop)}}}class z extends S{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",z.OFF,{anyOf:[{type:"boolean",description:$.localize(19,null)},{type:"string",description:$.localize(20,null)}],description:$.localize(21,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?z.OFF:X==="true"?z.ON:X:X?z.ON:z.OFF}}e.EditorFontLigatures=z;class F extends S{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",F.OFF,{anyOf:[{type:"boolean",description:$.localize(22,null)},{type:"string",description:$.localize(23,null)}],description:$.localize(24,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?F.OFF:X==="true"?F.TRANSLATE:X:X?F.TRANSLATE:F.OFF}compute(X,be,Be){return X.fontInfo.fontVariationSettings}}e.EditorFontVariations=F;class N extends p{constructor(){super(50)}compute(X,be,Be){return X.fontInfo}}class x extends f{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:$.localize(25,null)})}validate(X){const be=l.float(X,this.defaultValue);return be===0?e.EDITOR_FONT_DEFAULTS.fontSize:l.clamp(be,6,100)}compute(X,be,Be){return X.fontInfo.fontSize}}class J extends S{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:J.d,maximum:J.e,errorMessage:$.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:J.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:$.localize(27,null)})}validate(X){return X==="normal"||X==="bold"?X:String(u.clampedInt(X,e.EDITOR_FONT_DEFAULTS.fontWeight,J.d,J.e))}}class ye extends S{constructor(){const X={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},be={type:"string",enum:["peek","gotoAndPeek","goto"],default:X.multiple,enumDescriptions:[$.localize(28,null),$.localize(29,null),$.localize(30,null)]},Be=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",X,{"editor.gotoLocation.multiple":{deprecationMessage:$.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:$.localize(32,null),...be},"editor.gotoLocation.multipleTypeDefinitions":{description:$.localize(33,null),...be},"editor.gotoLocation.multipleDeclarations":{description:$.localize(34,null),...be},"editor.gotoLocation.multipleImplementations":{description:$.localize(35,null),...be},"editor.gotoLocation.multipleReferences":{description:$.localize(36,null),...be},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:X.alternativeDefinitionCommand,enum:Be,description:$.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:X.alternativeTypeDefinitionCommand,enum:Be,description:$.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:X.alternativeDeclarationCommand,enum:Be,description:$.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:X.alternativeImplementationCommand,enum:Be,description:$.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:X.alternativeReferenceCommand,enum:Be,description:$.localize(41,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const be=X;return{multiple:s(be.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:be.multipleDefinitions??s(be.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:be.multipleTypeDefinitions??s(be.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:be.multipleDeclarations??s(be.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:be.multipleImplementations??s(be.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:be.multipleReferences??s(be.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:r.string(be.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:r.string(be.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:r.string(be.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:r.string(be.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:r.string(be.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class De extends S{constructor(){const X={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",X,{"editor.hover.enabled":{type:"boolean",default:X.enabled,description:$.localize(42,null)},"editor.hover.delay":{type:"number",default:X.delay,minimum:0,maximum:1e4,description:$.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:X.sticky,description:$.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:X.hidingDelay,description:$.localize(45,null)},"editor.hover.above":{type:"boolean",default:X.above,description:$.localize(46,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const be=X;return{enabled:t(be.enabled,this.defaultValue.enabled),delay:u.clampedInt(be.delay,this.defaultValue.delay,0,1e4),sticky:t(be.sticky,this.defaultValue.sticky),hidingDelay:u.clampedInt(be.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:t(be.above,this.defaultValue.above)}}}var Ce;(function(Y){Y[Y.None=0]="None",Y[Y.Text=1]="Text",Y[Y.Blocks=2]="Blocks"})(Ce||(e.RenderMinimap=Ce={}));class ge extends p{constructor(){super(144)}compute(X,be,Be){return ge.computeLayout(be,{memory:X.memory,outerWidth:X.outerWidth,outerHeight:X.outerHeight,isDominatedByLongLines:X.isDominatedByLongLines,lineHeight:X.fontInfo.lineHeight,viewLineCount:X.viewLineCount,lineNumbersDigitCount:X.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,pixelRatio:X.pixelRatio,glyphMarginDecorationLaneCount:X.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(X){const be=X.height/X.lineHeight,Be=Math.floor(X.paddingTop/X.lineHeight);let Ne=Math.floor(X.paddingBottom/X.lineHeight);X.scrollBeyondLastLine&&(Ne=Math.max(Ne,be-1));const Xe=(Be+X.viewLineCount+Ne)/(X.pixelRatio*X.height),nt=Math.floor(X.viewLineCount/Xe);return{typicalViewportLineCount:be,extraLinesBeforeFirstLine:Be,extraLinesBeyondLastLine:Ne,desiredRatio:Xe,minimapLineCount:nt}}static c(X,be){const Be=X.outerWidth,Ne=X.outerHeight,Xe=X.pixelRatio;if(!X.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Xe*Ne),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ne};const nt=be.stableMinimapLayoutInput,$t=nt&&X.outerHeight===nt.outerHeight&&X.lineHeight===nt.lineHeight&&X.typicalHalfwidthCharacterWidth===nt.typicalHalfwidthCharacterWidth&&X.pixelRatio===nt.pixelRatio&&X.scrollBeyondLastLine===nt.scrollBeyondLastLine&&X.paddingTop===nt.paddingTop&&X.paddingBottom===nt.paddingBottom&&X.minimap.enabled===nt.minimap.enabled&&X.minimap.side===nt.minimap.side&&X.minimap.size===nt.minimap.size&&X.minimap.showSlider===nt.minimap.showSlider&&X.minimap.renderCharacters===nt.minimap.renderCharacters&&X.minimap.maxColumn===nt.minimap.maxColumn&&X.minimap.scale===nt.minimap.scale&&X.verticalScrollbarWidth===nt.verticalScrollbarWidth&&X.isViewportWrapping===nt.isViewportWrapping,wt=X.lineHeight,Pt=X.typicalHalfwidthCharacterWidth,Kt=X.scrollBeyondLastLine,Ht=X.minimap.renderCharacters;let vt=Xe>=2?Math.round(X.minimap.scale*2):X.minimap.scale;const Ut=X.minimap.maxColumn,Ot=X.minimap.size,Gt=X.minimap.side,jt=X.verticalScrollbarWidth,kt=X.viewLineCount,Ft=X.remainingWidth,Bt=X.isViewportWrapping,Jt=Ht?2:3;let Wt=Math.floor(Xe*Ne);const Vt=Wt/Xe;let Nt=!1,at=!1,dt=Jt*vt,At=vt/Xe,qt=1;if(Ot==="fill"||Ot==="fit"){const{typicalViewportLineCount:Qt,extraLinesBeforeFirstLine:Se,extraLinesBeyondLastLine:Le,desiredRatio:$e,minimapLineCount:K}=ge.computeContainedMinimapLineCount({viewLineCount:kt,scrollBeyondLastLine:Kt,paddingTop:X.paddingTop,paddingBottom:X.paddingBottom,height:Ne,lineHeight:wt,pixelRatio:Xe});if(kt/K>1)Nt=!0,at=!0,vt=1,dt=1,At=vt/Xe;else{let Ue=!1,Je=vt+1;if(Ot==="fit"){const qe=Math.ceil((Se+kt+Le)*dt);Bt&&$t&&Ft<=be.stableFitRemainingWidth?(Ue=!0,Je=be.stableFitMaxMinimapScale):Ue=qe>Wt}if(Ot==="fill"||Ue){Nt=!0;const qe=vt;dt=Math.min(wt*Xe,Math.max(1,Math.floor(1/$e))),Bt&&$t&&Ft<=be.stableFitRemainingWidth&&(Je=be.stableFitMaxMinimapScale),vt=Math.min(Je,Math.max(1,Math.floor(dt/Jt))),vt>qe&&(qt=Math.min(2,vt/qe)),At=vt/Xe/qt,Wt=Math.ceil(Math.max(Qt,Se+kt+Le)*dt),Bt?(be.stableMinimapLayoutInput=X,be.stableFitRemainingWidth=Ft,be.stableFitMaxMinimapScale=vt):(be.stableMinimapLayoutInput=null,be.stableFitRemainingWidth=0)}}}const Rt=Math.floor(Ut*At),ot=Math.min(Rt,Math.max(0,Math.floor((Ft-jt-2)*At/(Pt+At)))+e.MINIMAP_GUTTER_WIDTH);let bt=Math.floor(Xe*ot);const Tt=bt/Xe;bt=Math.floor(bt*qt);const Ct=Ht?1:2,We=Gt==="left"?0:Be-ot-jt;return{renderMinimap:Ct,minimapLeft:We,minimapWidth:ot,minimapHeightIsEditorHeight:Nt,minimapIsSampling:at,minimapScale:vt,minimapLineHeight:dt,minimapCanvasInnerWidth:bt,minimapCanvasInnerHeight:Wt,minimapCanvasOuterWidth:Tt,minimapCanvasOuterHeight:Vt}}static computeLayout(X,be){const Be=be.outerWidth|0,Ne=be.outerHeight|0,Xe=be.lineHeight|0,nt=be.lineNumbersDigitCount|0,$t=be.typicalHalfwidthCharacterWidth,wt=be.maxDigitWidth,Pt=be.pixelRatio,Kt=be.viewLineCount,Ht=X.get(136),vt=Ht==="inherit"?X.get(135):Ht,Ut=vt==="inherit"?X.get(131):vt,Ot=X.get(134),Gt=be.isDominatedByLongLines,jt=X.get(57),kt=X.get(67).renderType!==0,Ft=X.get(68),Bt=X.get(105),Jt=X.get(84),Wt=X.get(72),Vt=X.get(103),Nt=Vt.verticalScrollbarSize,at=Vt.verticalHasArrows,dt=Vt.arrowSize,At=Vt.horizontalScrollbarSize,qt=X.get(43),Rt=X.get(110)!=="never";let ot=X.get(65);qt&&Rt&&(ot+=16);let bt=0;if(kt){const Et=Math.max(nt,Ft);bt=Math.round(Et*wt)}let Tt=0;jt&&(Tt=Xe*be.glyphMarginDecorationLaneCount);let Ct=0,We=Ct+Tt,Qt=We+bt,Se=Qt+ot;const Le=Be-Tt-bt-ot;let $e=!1,K=!1,Me=-1;vt==="inherit"&&Gt?($e=!0,K=!0):Ut==="on"||Ut==="bounded"?K=!0:Ut==="wordWrapColumn"&&(Me=Ot);const Ue=ge.c({outerWidth:Be,outerHeight:Ne,lineHeight:Xe,typicalHalfwidthCharacterWidth:$t,pixelRatio:Pt,scrollBeyondLastLine:Bt,paddingTop:Jt.top,paddingBottom:Jt.bottom,minimap:Wt,verticalScrollbarWidth:Nt,viewLineCount:Kt,remainingWidth:Le,isViewportWrapping:K},be.memory||new A);Ue.renderMinimap!==0&&Ue.minimapLeft===0&&(Ct+=Ue.minimapWidth,We+=Ue.minimapWidth,Qt+=Ue.minimapWidth,Se+=Ue.minimapWidth);const Je=Le-Ue.minimapWidth,qe=Math.max(1,Math.floor((Je-Nt-2)/$t)),et=at?dt:0;return K&&(Me=Math.max(1,qe),Ut==="bounded"&&(Me=Math.min(Me,Ot))),{width:Be,height:Ne,glyphMarginLeft:Ct,glyphMarginWidth:Tt,glyphMarginDecorationLaneCount:be.glyphMarginDecorationLaneCount,lineNumbersLeft:We,lineNumbersWidth:bt,decorationsLeft:Qt,decorationsWidth:ot,contentLeft:Se,contentWidth:Je,minimap:Ue,viewportColumn:qe,isWordWrapMinified:$e,isViewportWrapping:K,wrappingColumn:Me,verticalScrollbarWidth:Nt,horizontalScrollbarHeight:At,overviewRuler:{top:et,width:Nt,height:Ne-2*et,right:0}}}}e.EditorLayoutInfoComputer=ge;class we extends S{constructor(){super(138,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[$.localize(47,null),$.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:$.localize(49,null)}})}validate(X){return s(X,"simple",["simple","advanced"])}compute(X,be,Be){return be.get(2)===2?"advanced":Be}}class re extends S{constructor(){const X={enabled:!0};super(64,"lightbulb",X,{"editor.lightbulb.enabled":{type:"boolean",default:X.enabled,description:$.localize(50,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:t(X.enabled,this.defaultValue.enabled)}}}class oe extends S{constructor(){const X={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",X,{"editor.stickyScroll.enabled":{type:"boolean",default:X.enabled,description:$.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:X.maxLineCount,minimum:1,maximum:10,description:$.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:X.defaultModel,description:$.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:X.scrollWithEditor,description:$.localize(54,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const be=X;return{enabled:t(be.enabled,this.defaultValue.enabled),maxLineCount:u.clampedInt(be.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:s(be.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:t(be.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ve extends S{constructor(){const X={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(140,"inlayHints",X,{"editor.inlayHints.enabled":{type:"string",default:X.enabled,description:$.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[$.localize(56,null),$.localize(57,null,P.$k?"Ctrl+Option":"Ctrl+Alt"),$.localize(58,null,P.$k?"Ctrl+Option":"Ctrl+Alt"),$.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:X.fontSize,markdownDescription:$.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:X.fontFamily,markdownDescription:$.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:X.padding,description:$.localize(62,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const be=X;return typeof be.enabled=="boolean"&&(be.enabled=be.enabled?"on":"off"),{enabled:s(be.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:u.clampedInt(be.fontSize,this.defaultValue.fontSize,0,100),fontFamily:r.string(be.fontFamily,this.defaultValue.fontFamily),padding:t(be.padding,this.defaultValue.padding)}}}class ee extends S{constructor(){super(65,"lineDecorationsWidth",10)}validate(X){return typeof X=="string"&&/^\d+(\.\d+)?ch$/.test(X)?-parseFloat(X.substring(0,X.length-2)):u.clampedInt(X,this.defaultValue,0,1e3)}compute(X,be,Be){return Be<0?u.clampedInt(-Be*X.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Be}}class W extends l{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,X=>l.clamp(X,0,150),{markdownDescription:$.localize(63,null)})}compute(X,be,Be){return X.fontInfo.lineHeight}}class ue extends S{constructor(){const X={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",X,{"editor.minimap.enabled":{type:"boolean",default:X.enabled,description:$.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:X.autohide,description:$.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[$.localize(66,null),$.localize(67,null),$.localize(68,null)],default:X.size,description:$.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:X.side,description:$.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:X.showSlider,description:$.localize(71,null)},"editor.minimap.scale":{type:"number",default:X.scale,minimum:1,maximum:3,enum:[1,2,3],description:$.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:X.renderCharacters,description:$.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:X.maxColumn,description:$.localize(74,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const be=X;return{enabled:t(be.enabled,this.defaultValue.enabled),autohide:t(be.autohide,this.defaultValue.autohide),size:s(be.size,this.defaultValue.size,["proportional","fill","fit"]),side:s(be.side,this.defaultValue.side,["right","left"]),showSlider:s(be.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:t(be.renderCharacters,this.defaultValue.renderCharacters),scale:u.clampedInt(be.scale,1,1,3),maxColumn:u.clampedInt(be.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Pe(Y){return Y==="ctrlCmd"?P.$k?"metaKey":"ctrlKey":"altKey"}class Ee extends S{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:$.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:$.localize(76,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const be=X;return{top:u.clampedInt(be.top,0,0,1e3),bottom:u.clampedInt(be.bottom,0,0,1e3)}}}class te extends S{constructor(){const X={enabled:!0,cycle:!0};super(86,"parameterHints",X,{"editor.parameterHints.enabled":{type:"boolean",default:X.enabled,description:$.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:X.cycle,description:$.localize(78,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const be=X;return{enabled:t(be.enabled,this.defaultValue.enabled),cycle:t(be.cycle,this.defaultValue.cycle)}}}class se extends p{constructor(){super(142)}compute(X,be,Be){return X.pixelRatio}}class me extends S{constructor(){const X={other:"on",comments:"off",strings:"off"},be=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[$.localize(79,null),$.localize(80,null),$.localize(81,null)]}];super(89,"quickSuggestions",X,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:be,default:X.strings,description:$.localize(82,null)},comments:{anyOf:be,default:X.comments,description:$.localize(83,null)},other:{anyOf:be,default:X.other,description:$.localize(84,null)}},default:X,markdownDescription:$.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=X}validate(X){if(typeof X=="boolean"){const Pt=X?"on":"off";return{comments:Pt,strings:Pt,other:Pt}}if(!X||typeof X!="object")return this.defaultValue;const{other:be,comments:Be,strings:Ne}=X,Xe=["on","inline","off"];let nt,$t,wt;return typeof be=="boolean"?nt=be?"on":"off":nt=s(be,this.defaultValue.other,Xe),typeof Be=="boolean"?$t=Be?"on":"off":$t=s(Be,this.defaultValue.comments,Xe),typeof Ne=="boolean"?wt=Ne?"on":"off":wt=s(Ne,this.defaultValue.strings,Xe),{other:nt,comments:$t,strings:wt}}}var Z;(function(Y){Y[Y.Off=0]="Off",Y[Y.On=1]="On",Y[Y.Relative=2]="Relative",Y[Y.Interval=3]="Interval",Y[Y.Custom=4]="Custom"})(Z||(e.RenderLineNumbersType=Z={}));class le extends S{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[$.localize(86,null),$.localize(87,null),$.localize(88,null),$.localize(89,null)],default:"on",description:$.localize(90,null)})}validate(X){let be=this.defaultValue.renderType,Be=this.defaultValue.renderFn;return typeof X<"u"&&(typeof X=="function"?(be=4,Be=X):X==="interval"?be=3:X==="relative"?be=2:X==="on"?be=1:be=0),{renderType:be,renderFn:Be}}}function ne(Y){const X=Y.get(98);return X==="editable"?Y.get(91):X!=="on"}e.filterValidationDecorations=ne;class ae extends S{constructor(){const X=[],be={type:"number",description:$.localize(91,null)};super(102,"rulers",X,{type:"array",items:{anyOf:[be,{type:["object"],properties:{column:be,color:{type:"string",description:$.localize(92,null),format:"color-hex"}}}]},default:X,description:$.localize(93,null)})}validate(X){if(Array.isArray(X)){const be=[];for(const Be of X)if(typeof Be=="number")be.push({column:u.clampedInt(Be,0,0,1e4),color:null});else if(Be&&typeof Be=="object"){const Ne=Be;be.push({column:u.clampedInt(Ne.column,0,0,1e4),color:Ne.color})}return be.sort((Be,Ne)=>Be.column-Ne.column),be}return this.defaultValue}}class de extends S{constructor(){super(92,"readOnlyMessage",void 0)}validate(X){return!X||typeof X!="object"?this.defaultValue:X}}function Ie(Y,X){if(typeof Y!="string")return X;switch(Y){case"hidden":return 2;case"visible":return 3;default:return 1}}class T extends S{constructor(){const X={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",X,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[$.localize(94,null),$.localize(95,null),$.localize(96,null)],default:"auto",description:$.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[$.localize(98,null),$.localize(99,null),$.localize(100,null)],default:"auto",description:$.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:X.verticalScrollbarSize,description:$.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:X.horizontalScrollbarSize,description:$.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:X.scrollByPage,description:$.localize(104,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:X.ignoreHorizontalScrollbarInContentHeight,description:$.localize(105,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const be=X,Be=u.clampedInt(be.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ne=u.clampedInt(be.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:u.clampedInt(be.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ie(be.vertical,this.defaultValue.vertical),horizontal:Ie(be.horizontal,this.defaultValue.horizontal),useShadows:t(be.useShadows,this.defaultValue.useShadows),verticalHasArrows:t(be.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:t(be.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:t(be.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:t(be.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Be,horizontalSliderSize:u.clampedInt(be.horizontalSliderSize,Be,0,1e3),verticalScrollbarSize:Ne,verticalSliderSize:u.clampedInt(be.verticalSliderSize,Ne,0,1e3),scrollByPage:t(be.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:t(be.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class V extends S{constructor(){const X={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",X,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.nonBasicASCII,description:$.localize(106,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:X.invisibleCharacters,description:$.localize(107,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:X.ambiguousCharacters,description:$.localize(108,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeComments,description:$.localize(109,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeStrings,description:$.localize(110,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:X.allowedCharacters,description:$.localize(111,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:X.allowedLocales,description:$.localize(112,null)}})}applyUpdate(X,be){let Be=!1;be.allowedCharacters&&X&&(L.$cn(X.allowedCharacters,be.allowedCharacters)||(X={...X,allowedCharacters:be.allowedCharacters},Be=!0)),be.allowedLocales&&X&&(L.$cn(X.allowedLocales,be.allowedLocales)||(X={...X,allowedLocales:be.allowedLocales},Be=!0));const Ne=super.applyUpdate(X,be);return Be?new o(Ne.newValue,!0):Ne}validate(X){if(!X||typeof X!="object")return this.defaultValue;const be=X;return{nonBasicASCII:_(be.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:t(be.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:t(be.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:_(be.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:_(be.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(X.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(X.allowedLocales,this.defaultValue.allowedLocales)}}c(X,be){if(typeof X!="object"||!X)return be;const Be={};for(const[Ne,Xe]of Object.entries(X))Xe===!0&&(Be[Ne]=!0);return Be}}class G extends S{constructor(){const X={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",X,{"editor.inlineSuggest.enabled":{type:"boolean",default:X.enabled,description:$.localize(113,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:X.showToolbar,enum:["always","onHover"],enumDescriptions:[$.localize(114,null),$.localize(115,null)],description:$.localize(116,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:X.suppressSuggestions,description:$.localize(117,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const be=X;return{enabled:t(be.enabled,this.defaultValue.enabled),mode:s(be.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:s(be.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:t(be.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:t(be.keepOnBlur,this.defaultValue.keepOnBlur)}}}class Q extends S{constructor(){const X={enabled:M.$7r.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:M.$7r.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",X,{"editor.bracketPairColorization.enabled":{type:"boolean",default:X.enabled,markdownDescription:$.localize(118,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:X.independentColorPoolPerBracketType,description:$.localize(119,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const be=X;return{enabled:t(be.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:t(be.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class q extends S{constructor(){const X={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",X,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[$.localize(120,null),$.localize(121,null),$.localize(122,null)],default:X.bracketPairs,description:$.localize(123,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[$.localize(124,null),$.localize(125,null),$.localize(126,null)],default:X.bracketPairsHorizontal,description:$.localize(127,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:X.highlightActiveBracketPair,description:$.localize(128,null)},"editor.guides.indentation":{type:"boolean",default:X.indentation,description:$.localize(129,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[$.localize(130,null),$.localize(131,null),$.localize(132,null)],default:X.highlightActiveIndentation,description:$.localize(133,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const be=X;return{bracketPairs:_(be.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:_(be.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:t(be.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:t(be.indentation,this.defaultValue.indentation),highlightActiveIndentation:_(be.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function _(Y,X,be){const Be=be.indexOf(Y);return Be===-1?X:be[Be]}class he extends S{constructor(){const X={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",X,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[$.localize(134,null),$.localize(135,null)],default:X.insertMode,description:$.localize(136,null)},"editor.suggest.filterGraceful":{type:"boolean",default:X.filterGraceful,description:$.localize(137,null)},"editor.suggest.localityBonus":{type:"boolean",default:X.localityBonus,description:$.localize(138,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:X.shareSuggestSelections,markdownDescription:$.localize(139,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[$.localize(140,null),$.localize(141,null),$.localize(142,null),$.localize(143,null)],default:X.selectionMode,markdownDescription:$.localize(144,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:X.snippetsPreventQuickSuggestions,description:$.localize(145,null)},"editor.suggest.showIcons":{type:"boolean",default:X.showIcons,description:$.localize(146,null)},"editor.suggest.showStatusBar":{type:"boolean",default:X.showStatusBar,description:$.localize(147,null)},"editor.suggest.preview":{type:"boolean",default:X.preview,description:$.localize(148,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:X.showInlineDetails,description:$.localize(149,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:$.localize(150,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:$.localize(151,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:$.localize(152,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:$.localize(153,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:$.localize(154,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:$.localize(155,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:$.localize(156,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:$.localize(157,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:$.localize(158,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:$.localize(159,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:$.localize(160,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:$.localize(161,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:$.localize(162,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:$.localize(163,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:$.localize(164,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:$.localize(165,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:$.localize(166,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:$.localize(167,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:$.localize(168,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:$.localize(169,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:$.localize(170,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:$.localize(171,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:$.localize(172,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:$.localize(173,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:$.localize(174,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:$.localize(175,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:$.localize(176,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:$.localize(177,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:$.localize(178,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:$.localize(179,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:$.localize(180,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:$.localize(181,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const be=X;return{insertMode:s(be.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:t(be.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:t(be.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:t(be.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:t(be.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:s(be.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:t(be.showIcons,this.defaultValue.showIcons),showStatusBar:t(be.showStatusBar,this.defaultValue.showStatusBar),preview:t(be.preview,this.defaultValue.preview),previewMode:s(be.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:t(be.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:t(be.showMethods,this.defaultValue.showMethods),showFunctions:t(be.showFunctions,this.defaultValue.showFunctions),showConstructors:t(be.showConstructors,this.defaultValue.showConstructors),showDeprecated:t(be.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:t(be.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:t(be.showFields,this.defaultValue.showFields),showVariables:t(be.showVariables,this.defaultValue.showVariables),showClasses:t(be.showClasses,this.defaultValue.showClasses),showStructs:t(be.showStructs,this.defaultValue.showStructs),showInterfaces:t(be.showInterfaces,this.defaultValue.showInterfaces),showModules:t(be.showModules,this.defaultValue.showModules),showProperties:t(be.showProperties,this.defaultValue.showProperties),showEvents:t(be.showEvents,this.defaultValue.showEvents),showOperators:t(be.showOperators,this.defaultValue.showOperators),showUnits:t(be.showUnits,this.defaultValue.showUnits),showValues:t(be.showValues,this.defaultValue.showValues),showConstants:t(be.showConstants,this.defaultValue.showConstants),showEnums:t(be.showEnums,this.defaultValue.showEnums),showEnumMembers:t(be.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:t(be.showKeywords,this.defaultValue.showKeywords),showWords:t(be.showWords,this.defaultValue.showWords),showColors:t(be.showColors,this.defaultValue.showColors),showFiles:t(be.showFiles,this.defaultValue.showFiles),showReferences:t(be.showReferences,this.defaultValue.showReferences),showFolders:t(be.showFolders,this.defaultValue.showFolders),showTypeParameters:t(be.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:t(be.showSnippets,this.defaultValue.showSnippets),showUsers:t(be.showUsers,this.defaultValue.showUsers),showIssues:t(be.showIssues,this.defaultValue.showIssues)}}}class Oe extends S{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:$.localize(182,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:$.localize(183,null),default:!0,type:"boolean"}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:t(X.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:t(X.selectSubwords,this.defaultValue.selectSubwords)}}}var je;(function(Y){Y[Y.None=0]="None",Y[Y.Same=1]="Same",Y[Y.Indent=2]="Indent",Y[Y.DeepIndent=3]="DeepIndent"})(je||(e.WrappingIndent=je={}));class Qe extends S{constructor(){super(137,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[$.localize(184,null),$.localize(185,null),$.localize(186,null),$.localize(187,null)],description:$.localize(188,null),default:"same"}})}validate(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(X,be,Be){return be.get(2)===2?0:Be}}class Ge extends p{constructor(){super(145)}compute(X,be,Be){const Ne=be.get(144);return{isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:Ne.isWordWrapMinified,isViewportWrapping:Ne.isViewportWrapping,wrappingColumn:Ne.wrappingColumn}}}class _e extends S{constructor(){const X={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",X,{"editor.dropIntoEditor.enabled":{type:"boolean",default:X.enabled,markdownDescription:$.localize(189,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:$.localize(190,null),enum:["afterDrop","never"],enumDescriptions:[$.localize(191,null),$.localize(192,null)],default:"afterDrop"}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const be=X;return{enabled:t(be.enabled,this.defaultValue.enabled),showDropSelector:s(be.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class Ye extends S{constructor(){const X={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",X,{"editor.pasteAs.enabled":{type:"boolean",default:X.enabled,markdownDescription:$.localize(193,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:$.localize(194,null),enum:["afterPaste","never"],enumDescriptions:[$.localize(195,null),$.localize(196,null)],default:"afterPaste"}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const be=X;return{enabled:t(be.enabled,this.defaultValue.enabled),showPasteSelector:s(be.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const xe="Consolas, 'Courier New', monospace",it="Menlo, Monaco, 'Courier New', monospace",tt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:P.$k?it:P.$l?tt:xe,fontWeight:"normal",fontSize:P.$k?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function ze(Y){return e.editorOptionsRegistry[Y.id]=Y,Y}var ut;(function(Y){Y[Y.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Y[Y.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Y[Y.accessibilitySupport=2]="accessibilitySupport",Y[Y.accessibilityPageSize=3]="accessibilityPageSize",Y[Y.ariaLabel=4]="ariaLabel",Y[Y.ariaRequired=5]="ariaRequired",Y[Y.autoClosingBrackets=6]="autoClosingBrackets",Y[Y.autoClosingComments=7]="autoClosingComments",Y[Y.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Y[Y.autoClosingDelete=9]="autoClosingDelete",Y[Y.autoClosingOvertype=10]="autoClosingOvertype",Y[Y.autoClosingQuotes=11]="autoClosingQuotes",Y[Y.autoIndent=12]="autoIndent",Y[Y.automaticLayout=13]="automaticLayout",Y[Y.autoSurround=14]="autoSurround",Y[Y.bracketPairColorization=15]="bracketPairColorization",Y[Y.guides=16]="guides",Y[Y.codeLens=17]="codeLens",Y[Y.codeLensFontFamily=18]="codeLensFontFamily",Y[Y.codeLensFontSize=19]="codeLensFontSize",Y[Y.colorDecorators=20]="colorDecorators",Y[Y.colorDecoratorsLimit=21]="colorDecoratorsLimit",Y[Y.columnSelection=22]="columnSelection",Y[Y.comments=23]="comments",Y[Y.contextmenu=24]="contextmenu",Y[Y.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Y[Y.cursorBlinking=26]="cursorBlinking",Y[Y.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Y[Y.cursorStyle=28]="cursorStyle",Y[Y.cursorSurroundingLines=29]="cursorSurroundingLines",Y[Y.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Y[Y.cursorWidth=31]="cursorWidth",Y[Y.disableLayerHinting=32]="disableLayerHinting",Y[Y.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Y[Y.domReadOnly=34]="domReadOnly",Y[Y.dragAndDrop=35]="dragAndDrop",Y[Y.dropIntoEditor=36]="dropIntoEditor",Y[Y.emptySelectionClipboard=37]="emptySelectionClipboard",Y[Y.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Y[Y.extraEditorClassName=39]="extraEditorClassName",Y[Y.fastScrollSensitivity=40]="fastScrollSensitivity",Y[Y.find=41]="find",Y[Y.fixedOverflowWidgets=42]="fixedOverflowWidgets",Y[Y.folding=43]="folding",Y[Y.foldingStrategy=44]="foldingStrategy",Y[Y.foldingHighlight=45]="foldingHighlight",Y[Y.foldingImportsByDefault=46]="foldingImportsByDefault",Y[Y.foldingMaximumRegions=47]="foldingMaximumRegions",Y[Y.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Y[Y.fontFamily=49]="fontFamily",Y[Y.fontInfo=50]="fontInfo",Y[Y.fontLigatures=51]="fontLigatures",Y[Y.fontSize=52]="fontSize",Y[Y.fontWeight=53]="fontWeight",Y[Y.fontVariations=54]="fontVariations",Y[Y.formatOnPaste=55]="formatOnPaste",Y[Y.formatOnType=56]="formatOnType",Y[Y.glyphMargin=57]="glyphMargin",Y[Y.gotoLocation=58]="gotoLocation",Y[Y.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Y[Y.hover=60]="hover",Y[Y.inDiffEditor=61]="inDiffEditor",Y[Y.inlineSuggest=62]="inlineSuggest",Y[Y.letterSpacing=63]="letterSpacing",Y[Y.lightbulb=64]="lightbulb",Y[Y.lineDecorationsWidth=65]="lineDecorationsWidth",Y[Y.lineHeight=66]="lineHeight",Y[Y.lineNumbers=67]="lineNumbers",Y[Y.lineNumbersMinChars=68]="lineNumbersMinChars",Y[Y.linkedEditing=69]="linkedEditing",Y[Y.links=70]="links",Y[Y.matchBrackets=71]="matchBrackets",Y[Y.minimap=72]="minimap",Y[Y.mouseStyle=73]="mouseStyle",Y[Y.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",Y[Y.mouseWheelZoom=75]="mouseWheelZoom",Y[Y.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",Y[Y.multiCursorModifier=77]="multiCursorModifier",Y[Y.multiCursorPaste=78]="multiCursorPaste",Y[Y.multiCursorLimit=79]="multiCursorLimit",Y[Y.multiDocumentOccurrencesHighlight=80]="multiDocumentOccurrencesHighlight",Y[Y.occurrencesHighlight=81]="occurrencesHighlight",Y[Y.overviewRulerBorder=82]="overviewRulerBorder",Y[Y.overviewRulerLanes=83]="overviewRulerLanes",Y[Y.padding=84]="padding",Y[Y.pasteAs=85]="pasteAs",Y[Y.parameterHints=86]="parameterHints",Y[Y.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",Y[Y.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",Y[Y.quickSuggestions=89]="quickSuggestions",Y[Y.quickSuggestionsDelay=90]="quickSuggestionsDelay",Y[Y.readOnly=91]="readOnly",Y[Y.readOnlyMessage=92]="readOnlyMessage",Y[Y.renameOnType=93]="renameOnType",Y[Y.renderControlCharacters=94]="renderControlCharacters",Y[Y.renderFinalNewline=95]="renderFinalNewline",Y[Y.renderLineHighlight=96]="renderLineHighlight",Y[Y.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",Y[Y.renderValidationDecorations=98]="renderValidationDecorations",Y[Y.renderWhitespace=99]="renderWhitespace",Y[Y.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",Y[Y.roundedSelection=101]="roundedSelection",Y[Y.rulers=102]="rulers",Y[Y.scrollbar=103]="scrollbar",Y[Y.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",Y[Y.scrollBeyondLastLine=105]="scrollBeyondLastLine",Y[Y.scrollPredominantAxis=106]="scrollPredominantAxis",Y[Y.selectionClipboard=107]="selectionClipboard",Y[Y.selectionHighlight=108]="selectionHighlight",Y[Y.selectOnLineNumbers=109]="selectOnLineNumbers",Y[Y.showFoldingControls=110]="showFoldingControls",Y[Y.showUnused=111]="showUnused",Y[Y.snippetSuggestions=112]="snippetSuggestions",Y[Y.smartSelect=113]="smartSelect",Y[Y.smoothScrolling=114]="smoothScrolling",Y[Y.stickyScroll=115]="stickyScroll",Y[Y.stickyTabStops=116]="stickyTabStops",Y[Y.stopRenderingLineAfter=117]="stopRenderingLineAfter",Y[Y.suggest=118]="suggest",Y[Y.suggestFontSize=119]="suggestFontSize",Y[Y.suggestLineHeight=120]="suggestLineHeight",Y[Y.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",Y[Y.suggestSelection=122]="suggestSelection",Y[Y.tabCompletion=123]="tabCompletion",Y[Y.tabIndex=124]="tabIndex",Y[Y.unicodeHighlighting=125]="unicodeHighlighting",Y[Y.unusualLineTerminators=126]="unusualLineTerminators",Y[Y.useShadowDOM=127]="useShadowDOM",Y[Y.useTabStops=128]="useTabStops",Y[Y.wordBreak=129]="wordBreak",Y[Y.wordSeparators=130]="wordSeparators",Y[Y.wordWrap=131]="wordWrap",Y[Y.wordWrapBreakAfterCharacters=132]="wordWrapBreakAfterCharacters",Y[Y.wordWrapBreakBeforeCharacters=133]="wordWrapBreakBeforeCharacters",Y[Y.wordWrapColumn=134]="wordWrapColumn",Y[Y.wordWrapOverride1=135]="wordWrapOverride1",Y[Y.wordWrapOverride2=136]="wordWrapOverride2",Y[Y.wrappingIndent=137]="wrappingIndent",Y[Y.wrappingStrategy=138]="wrappingStrategy",Y[Y.showDeprecated=139]="showDeprecated",Y[Y.inlayHints=140]="inlayHints",Y[Y.editorClassName=141]="editorClassName",Y[Y.pixelRatio=142]="pixelRatio",Y[Y.tabFocusMode=143]="tabFocusMode",Y[Y.layoutInfo=144]="layoutInfo",Y[Y.wrappingInfo=145]="wrappingInfo",Y[Y.defaultColorDecorators=146]="defaultColorDecorators",Y[Y.colorDecoratorsActivatedOn=147]="colorDecoratorsActivatedOn",Y[Y.inlineCompletionsAccessibilityVerbose=148]="inlineCompletionsAccessibilityVerbose"})(ut||(e.EditorOption=ut={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ze(new i(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:$.localize(197,null)})),acceptSuggestionOnEnter:ze(new c(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",$.localize(198,null),""],markdownDescription:$.localize(199,null)})),accessibilitySupport:ze(new m),accessibilityPageSize:ze(new u(3,"accessibilityPageSize",10,1,1073741824,{description:$.localize(200,null),tags:["accessibility"]})),ariaLabel:ze(new r(4,"ariaLabel",$.localize(201,null))),ariaRequired:ze(new i(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:ze(new i(8,"screenReaderAnnounceInlineSuggestion",!0,{description:$.localize(202,null),tags:["accessibility"]})),autoClosingBrackets:ze(new c(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(203,null),$.localize(204,null),""],description:$.localize(205,null)})),autoClosingComments:ze(new c(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(206,null),$.localize(207,null),""],description:$.localize(208,null)})),autoClosingDelete:ze(new c(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",$.localize(209,null),""],description:$.localize(210,null)})),autoClosingOvertype:ze(new c(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",$.localize(211,null),""],description:$.localize(212,null)})),autoClosingQuotes:ze(new c(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(213,null),$.localize(214,null),""],description:$.localize(215,null)})),autoIndent:ze(new h(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],w,{enumDescriptions:[$.localize(216,null),$.localize(217,null),$.localize(218,null),$.localize(219,null),$.localize(220,null)],description:$.localize(221,null)})),automaticLayout:ze(new i(13,"automaticLayout",!1)),autoSurround:ze(new c(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[$.localize(222,null),$.localize(223,null),$.localize(224,null),""],description:$.localize(225,null)})),bracketPairColorization:ze(new Q),bracketPairGuides:ze(new q),stickyTabStops:ze(new i(116,"stickyTabStops",!1,{description:$.localize(226,null)})),codeLens:ze(new i(17,"codeLens",!0,{description:$.localize(227,null)})),codeLensFontFamily:ze(new r(18,"codeLensFontFamily","",{description:$.localize(228,null)})),codeLensFontSize:ze(new u(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:$.localize(229,null)})),colorDecorators:ze(new i(20,"colorDecorators",!0,{description:$.localize(230,null)})),colorDecoratorActivatedOn:ze(new c(147,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[$.localize(231,null),$.localize(232,null),$.localize(233,null)],description:$.localize(234,null)})),colorDecoratorsLimit:ze(new u(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:$.localize(235,null)})),columnSelection:ze(new i(22,"columnSelection",!1,{description:$.localize(236,null)})),comments:ze(new I),contextmenu:ze(new i(24,"contextmenu",!0)),copyWithSyntaxHighlighting:ze(new i(25,"copyWithSyntaxHighlighting",!0,{description:$.localize(237,null)})),cursorBlinking:ze(new h(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],d,{description:$.localize(238,null)})),cursorSmoothCaretAnimation:ze(new c(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[$.localize(239,null),$.localize(240,null),$.localize(241,null)],description:$.localize(242,null)})),cursorStyle:ze(new h(28,"cursorStyle",b.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],C,{description:$.localize(243,null)})),cursorSurroundingLines:ze(new u(29,"cursorSurroundingLines",0,0,1073741824,{description:$.localize(244,null)})),cursorSurroundingLinesStyle:ze(new c(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[$.localize(245,null),$.localize(246,null)],markdownDescription:$.localize(247,null)})),cursorWidth:ze(new u(31,"cursorWidth",0,0,1073741824,{markdownDescription:$.localize(248,null)})),disableLayerHinting:ze(new i(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:ze(new i(33,"disableMonospaceOptimizations",!1)),domReadOnly:ze(new i(34,"domReadOnly",!1)),dragAndDrop:ze(new i(35,"dragAndDrop",!0,{description:$.localize(249,null)})),emptySelectionClipboard:ze(new H),dropIntoEditor:ze(new _e),stickyScroll:ze(new oe),experimentalWhitespaceRendering:ze(new c(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[$.localize(250,null),$.localize(251,null),$.localize(252,null)],description:$.localize(253,null)})),extraEditorClassName:ze(new r(39,"extraEditorClassName","")),fastScrollSensitivity:ze(new l(40,"fastScrollSensitivity",5,Y=>Y<=0?5:Y,{markdownDescription:$.localize(254,null)})),find:ze(new U),fixedOverflowWidgets:ze(new i(42,"fixedOverflowWidgets",!1)),folding:ze(new i(43,"folding",!0,{description:$.localize(255,null)})),foldingStrategy:ze(new c(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[$.localize(256,null),$.localize(257,null)],description:$.localize(258,null)})),foldingHighlight:ze(new i(45,"foldingHighlight",!0,{description:$.localize(259,null)})),foldingImportsByDefault:ze(new i(46,"foldingImportsByDefault",!1,{description:$.localize(260,null)})),foldingMaximumRegions:ze(new u(47,"foldingMaximumRegions",5e3,10,65e3,{description:$.localize(261,null)})),unfoldOnClickAfterEndOfLine:ze(new i(48,"unfoldOnClickAfterEndOfLine",!1,{description:$.localize(262,null)})),fontFamily:ze(new r(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:$.localize(263,null)})),fontInfo:ze(new N),fontLigatures2:ze(new z),fontSize:ze(new x),fontWeight:ze(new J),fontVariations:ze(new F),formatOnPaste:ze(new i(55,"formatOnPaste",!1,{description:$.localize(264,null)})),formatOnType:ze(new i(56,"formatOnType",!1,{description:$.localize(265,null)})),glyphMargin:ze(new i(57,"glyphMargin",!0,{description:$.localize(266,null)})),gotoLocation:ze(new ye),hideCursorInOverviewRuler:ze(new i(59,"hideCursorInOverviewRuler",!1,{description:$.localize(267,null)})),hover:ze(new De),inDiffEditor:ze(new i(61,"inDiffEditor",!1)),letterSpacing:ze(new l(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Y=>l.clamp(Y,-5,20),{description:$.localize(268,null)})),lightbulb:ze(new re),lineDecorationsWidth:ze(new ee),lineHeight:ze(new W),lineNumbers:ze(new le),lineNumbersMinChars:ze(new u(68,"lineNumbersMinChars",5,1,300)),linkedEditing:ze(new i(69,"linkedEditing",!1,{description:$.localize(269,null)})),links:ze(new i(70,"links",!0,{description:$.localize(270,null)})),matchBrackets:ze(new c(71,"matchBrackets","always",["always","near","never"],{description:$.localize(271,null)})),minimap:ze(new ue),mouseStyle:ze(new c(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ze(new l(74,"mouseWheelScrollSensitivity",1,Y=>Y===0?1:Y,{markdownDescription:$.localize(272,null)})),mouseWheelZoom:ze(new i(75,"mouseWheelZoom",!1,{markdownDescription:$.localize(273,null)})),multiCursorMergeOverlapping:ze(new i(76,"multiCursorMergeOverlapping",!0,{description:$.localize(274,null)})),multiCursorModifier:ze(new h(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Pe,{markdownEnumDescriptions:[$.localize(275,null),$.localize(276,null)],markdownDescription:$.localize(277,null)})),multiCursorPaste:ze(new c(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[$.localize(278,null),$.localize(279,null)],markdownDescription:$.localize(280,null)})),multiCursorLimit:ze(new u(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:$.localize(281,null)})),occurrencesHighlight:ze(new i(81,"occurrencesHighlight",!0,{description:$.localize(282,null)})),multiDocumentOccurrencesHighlight:ze(new i(80,"multiDocumentOccurrencesHighlight",!1,{description:$.localize(283,null)})),overviewRulerBorder:ze(new i(82,"overviewRulerBorder",!0,{description:$.localize(284,null)})),overviewRulerLanes:ze(new u(83,"overviewRulerLanes",3,0,3)),padding:ze(new Ee),pasteAs:ze(new Ye),parameterHints:ze(new te),peekWidgetDefaultFocus:ze(new c(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[$.localize(285,null),$.localize(286,null)],description:$.localize(287,null)})),definitionLinkOpensInPeek:ze(new i(88,"definitionLinkOpensInPeek",!1,{description:$.localize(288,null)})),quickSuggestions:ze(new me),quickSuggestionsDelay:ze(new u(90,"quickSuggestionsDelay",10,0,1073741824,{description:$.localize(289,null)})),readOnly:ze(new i(91,"readOnly",!1)),readOnlyMessage:ze(new de),renameOnType:ze(new i(93,"renameOnType",!1,{description:$.localize(290,null),markdownDeprecationMessage:$.localize(291,null)})),renderControlCharacters:ze(new i(94,"renderControlCharacters",!0,{description:$.localize(292,null),restricted:!0})),renderFinalNewline:ze(new c(95,"renderFinalNewline",P.$l?"dimmed":"on",["off","on","dimmed"],{description:$.localize(293,null)})),renderLineHighlight:ze(new c(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",$.localize(294,null)],description:$.localize(295,null)})),renderLineHighlightOnlyWhenFocus:ze(new i(97,"renderLineHighlightOnlyWhenFocus",!1,{description:$.localize(296,null)})),renderValidationDecorations:ze(new c(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ze(new c(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",$.localize(297,null),$.localize(298,null),$.localize(299,null),""],description:$.localize(300,null)})),revealHorizontalRightPadding:ze(new u(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:ze(new i(101,"roundedSelection",!0,{description:$.localize(301,null)})),rulers:ze(new ae),scrollbar:ze(new T),scrollBeyondLastColumn:ze(new u(104,"scrollBeyondLastColumn",4,0,1073741824,{description:$.localize(302,null)})),scrollBeyondLastLine:ze(new i(105,"scrollBeyondLastLine",!0,{description:$.localize(303,null)})),scrollPredominantAxis:ze(new i(106,"scrollPredominantAxis",!0,{description:$.localize(304,null)})),selectionClipboard:ze(new i(107,"selectionClipboard",!0,{description:$.localize(305,null),included:P.$l})),selectionHighlight:ze(new i(108,"selectionHighlight",!0,{description:$.localize(306,null)})),selectOnLineNumbers:ze(new i(109,"selectOnLineNumbers",!0)),showFoldingControls:ze(new c(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[$.localize(307,null),$.localize(308,null),$.localize(309,null)],description:$.localize(310,null)})),showUnused:ze(new i(111,"showUnused",!0,{description:$.localize(311,null)})),showDeprecated:ze(new i(139,"showDeprecated",!0,{description:$.localize(312,null)})),inlayHints:ze(new ve),snippetSuggestions:ze(new c(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[$.localize(313,null),$.localize(314,null),$.localize(315,null),$.localize(316,null)],description:$.localize(317,null)})),smartSelect:ze(new Oe),smoothScrolling:ze(new i(114,"smoothScrolling",!1,{description:$.localize(318,null)})),stopRenderingLineAfter:ze(new u(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ze(new he),inlineSuggest:ze(new G),inlineCompletionsAccessibilityVerbose:ze(new i(148,"inlineCompletionsAccessibilityVerbose",!1,{description:$.localize(319,null)})),suggestFontSize:ze(new u(119,"suggestFontSize",0,0,1e3,{markdownDescription:$.localize(320,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:ze(new u(120,"suggestLineHeight",0,0,1e3,{markdownDescription:$.localize(321,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:ze(new i(121,"suggestOnTriggerCharacters",!0,{description:$.localize(322,null)})),suggestSelection:ze(new c(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[$.localize(323,null),$.localize(324,null),$.localize(325,null)],description:$.localize(326,null)})),tabCompletion:ze(new c(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[$.localize(327,null),$.localize(328,null),$.localize(329,null)],description:$.localize(330,null)})),tabIndex:ze(new u(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:ze(new V),unusualLineTerminators:ze(new c(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[$.localize(331,null),$.localize(332,null),$.localize(333,null)],description:$.localize(334,null)})),useShadowDOM:ze(new i(127,"useShadowDOM",!0)),useTabStops:ze(new i(128,"useTabStops",!0,{description:$.localize(335,null)})),wordBreak:ze(new c(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[$.localize(336,null),$.localize(337,null)],description:$.localize(338,null)})),wordSeparators:ze(new r(130,"wordSeparators",R.$8r,{description:$.localize(339,null)})),wordWrap:ze(new c(131,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[$.localize(340,null),$.localize(341,null),$.localize(342,null),$.localize(343,null)],description:$.localize(344,null)})),wordWrapBreakAfterCharacters:ze(new r(132,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ze(new r(133,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ze(new u(134,"wordWrapColumn",80,1,1073741824,{markdownDescription:$.localize(345,null)})),wordWrapOverride1:ze(new c(135,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ze(new c(136,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:ze(new B),defaultColorDecorators:ze(new i(146,"defaultColorDecorators",!1,{markdownDescription:$.localize(346,null)})),pixelRatio:ze(new se),tabFocusMode:ze(new i(143,"tabFocusMode",!1,{markdownDescription:$.localize(347,null)})),layoutInfo:ze(new ge),wrappingInfo:ze(new Ge),wrappingIndent:ze(new Qe),wrappingStrategy:ze(new we)}}),define(Ae[148],Re([9,10]),function(pe,e){return pe.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ae[149],Re([9,10]),function(pe,e){return pe.create("vs/platform/contextkey/common/contextkey",e)}),define(Ae[150],Re([9,10]),function(pe,e){return pe.create("vs/platform/contextkey/common/scanner",e)}),define(Ae[151],Re([9,10]),function(pe,e){return pe.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ae[152],Re([9,10]),function(pe,e){return pe.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ae[153],Re([9,10]),function(pe,e){return pe.create("vs/platform/files/common/files",e)}),define(Ae[154],Re([9,10]),function(pe,e){return pe.create("vs/platform/markers/common/markers",e)}),define(Ae[155],Re([9,10]),function(pe,e){return pe.create("vs/platform/theme/common/iconRegistry",e)}),define(Ae[156],Re([9,10]),function(pe,e){return pe.create("vs/platform/workspace/common/workspace",e)}),define(Ae[157],Re([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostChat",e)}),define(Ae[158],Re([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Ae[159],Re([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ae[160],Re([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ae[161],Re([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ae[162],Re([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostLogService",e)}),define(Ae[163],Re([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ae[164],Re([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostProgress",e)}),define(Ae[165],Re([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ae[166],Re([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ae[167],Re([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ae[168],Re([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ae[169],Re([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ae[170],Re([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ae[171],Re([9,10]),function(pe,e){return pe.create("vs/workbench/common/configuration",e)}),define(Ae[172],Re([9,10]),function(pe,e){return pe.create("vs/workbench/common/editor",e)}),define(Ae[173],Re([9,10]),function(pe,e){return pe.create("vs/workbench/common/views",e)}),define(Ae[174],Re([9,10]),function(pe,e){return pe.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ae[175],Re([9,10]),function(pe,e){return pe.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ae[176],Re([9,10]),function(pe,e){return pe.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ae[177],Re([9,10]),function(pe,e){return pe.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ae[178],Re([9,10]),function(pe,e){return pe.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ae[179],Re([9,10]),function(pe,e){return pe.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Ae[180],Re([9,10]),function(pe,e){return pe.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ae[181],Re([9,10]),function(pe,e){return pe.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ae[182],Re([1,0,11,150]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oi=e.TokenType=void 0;var P;(function(g){g[g.LParen=0]="LParen",g[g.RParen=1]="RParen",g[g.Neg=2]="Neg",g[g.Eq=3]="Eq",g[g.NotEq=4]="NotEq",g[g.Lt=5]="Lt",g[g.LtEq=6]="LtEq",g[g.Gt=7]="Gt",g[g.GtEq=8]="GtEq",g[g.RegexOp=9]="RegexOp",g[g.RegexStr=10]="RegexStr",g[g.True=11]="True",g[g.False=12]="False",g[g.In=13]="In",g[g.Not=14]="Not",g[g.And=15]="And",g[g.Or=16]="Or",g[g.Str=17]="Str",g[g.QuotedStr=18]="QuotedStr",g[g.Error=19]="Error",g[g.EOF=20]="EOF"})(P||(e.TokenType=P={}));function M(...g){switch(g.length){case 1:return(0,L.localize)(0,null,g[0]);case 2:return(0,L.localize)(1,null,g[0],g[1]);case 3:return(0,L.localize)(2,null,g[0],g[1],g[2]);default:return}}const R=(0,L.localize)(3,null),$=(0,L.localize)(4,null);class D{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,E.$7)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(A=>A.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(A){return this.c=A,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const S=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:S})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const S=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:S})}else this.h(126)?this.k(9):this.l(M("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(M("&&"));break;case 124:this.h(124)?this.k(16):this.l(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(A){return this.r()||this.c.charCodeAt(this.e)!==A?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(A){this.f.push({type:A,offset:this.d})}l(A){const S=this.d,o=this.c.substring(this.d,this.e),v={type:19,offset:this.d,lexeme:o};this.g.push({offset:S,lexeme:o,additionalInfo:A}),this.f.push(v)}n(){this.m.lastIndex=this.d;const A=this.m.exec(this.c);if(A){this.e=this.d+A[0].length;const S=this.c.substring(this.d,this.e),o=D.b.get(S);o?this.k(o):this.f.push({type:17,lexeme:S,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let A=this.e,S=!1,o=!1;for(;;){if(A>=this.c.length){this.e=A,this.l($);return}const p=this.c.charCodeAt(A);if(S)S=!1;else if(p===47&&!o){A++;break}else p===91?o=!0:p===92?S=!0:p===93&&(o=!1);A++}for(;A<this.c.length&&D.a.has(this.c.charCodeAt(A));)A++;this.e=A;const v=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:v,offset:this.d})}r(){return this.e>=this.c.length}}e.$Oi=D}),define(Ae[183],Re([1,0,25,31,152,296]),function(pe,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,$=/^-(\d{4})(\d{2})(\d{2})$/;function D(i){return i=i.trim(),i==="*"||R.test(i)}e.$Po=D;function g(i){if(!D(i))return null;if(i=i.trim(),i==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=i.match(R);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}e.$Qo=g;function A(i){if(!i)return null;const n=i.majorBase,u=i.majorMustEqual,a=i.minorBase;let l=i.minorMustEqual;const r=i.patchBase;let s=i.patchMustEqual;i.hasCaret&&(n===0||(l=!1),s=!1);let c=0;if(i.preRelease){const h=$.exec(i.preRelease);if(h){const[,w,m,I]=h;c=Date.UTC(Number(w),Number(m)-1,Number(I))}}return{majorBase:n,majorMustEqual:u,minorBase:a,minorMustEqual:l,patchBase:r,patchMustEqual:s,isMinimum:i.hasGreaterEquals,notBefore:c}}e.$Ro=A;function S(i,n,u){let a;typeof i=="string"?a=A(g(i)):a=i;let l;n instanceof Date?l=n.getTime():typeof n=="string"&&(l=new Date(n).getTime());let r;if(typeof u=="string"?r=A(g(u)):r=u,!a||!r)return!1;const s=a.majorBase,c=a.minorBase,h=a.patchBase;let w=r.majorBase,m=r.minorBase,I=r.patchBase;const k=r.notBefore;let d=r.majorMustEqual,b=r.minorMustEqual,y=r.patchMustEqual;return r.isMinimum?s>w?!0:s<w?!1:c>m?!0:c<m||l&&l<k?!1:h>=I:(s===1&&w===0&&(!d||!b||!y)&&(w=1,m=0,I=0,d=!0,b=!1,y=!1),s<w?!1:s>w?!d:c<m?!1:c>m?!b:h<I?!1:h>I?!y:!(l&&l<k))}e.$So=S;function o(i,n,u,a,l){const r=[];if(typeof a.publisher<"u"&&typeof a.publisher!="string")return r.push([L.default.Error,P.localize(0,null)]),r;if(typeof a.name!="string")return r.push([L.default.Error,P.localize(1,null,"name")]),r;if(typeof a.version!="string")return r.push([L.default.Error,P.localize(2,null,"version")]),r;if(!a.engines)return r.push([L.default.Error,P.localize(3,null,"engines")]),r;if(typeof a.engines.vscode!="string")return r.push([L.default.Error,P.localize(4,null,"engines.vscode")]),r;if(typeof a.extensionDependencies<"u"&&!t(a.extensionDependencies))return r.push([L.default.Error,P.localize(5,null,"extensionDependencies")]),r;if(typeof a.activationEvents<"u"){if(!t(a.activationEvents))return r.push([L.default.Error,P.localize(6,null,"activationEvents")]),r;if(typeof a.main>"u"&&typeof a.browser>"u")return r.push([L.default.Error,P.localize(7,null,"activationEvents","main","browser")]),r}if(typeof a.extensionKind<"u"&&typeof a.main>"u"&&r.push([L.default.Warning,P.localize(8,null,"extensionKind")]),typeof a.main<"u"){if(typeof a.main!="string")return r.push([L.default.Error,P.localize(9,null,"main")]),r;{const h=(0,E.$wg)(u,a.main);(0,E.$qg)(h,u)||r.push([L.default.Warning,P.localize(10,null,h.path,u.path)])}}if(typeof a.browser<"u"){if(typeof a.browser!="string")return r.push([L.default.Error,P.localize(11,null,"browser")]),r;{const h=(0,E.$wg)(u,a.browser);(0,E.$qg)(h,u)||r.push([L.default.Warning,P.localize(12,null,h.path,u.path)])}}if(!M.valid(a.version))return r.push([L.default.Error,P.localize(13,null)]),r;const s=[];if(!v(i,n,a,l,s))for(const h of s)r.push([L.default.Error,h]);return r}e.$To=o;function v(i,n,u,a,l){return a||typeof u.main>"u"&&typeof u.browser>"u"?!0:f(i,n,u.engines.vscode,l)}e.$Uo=v;function p(i,n,u){return i==="*"||f(n,u,i)}e.$Vo=p;function f(i,n,u,a=[]){const l=A(g(u));if(!l)return a.push(P.localize(14,null,u)),!1;if(l.majorBase===0){if(!l.majorMustEqual||!l.minorMustEqual)return a.push(P.localize(15,null,u)),!1}else if(!l.majorMustEqual)return a.push(P.localize(16,null,u)),!1;return S(i,n,l)?!0:(a.push(P.localize(17,null,i,u)),!1)}function t(i){if(!Array.isArray(i))return!1;for(let n=0,u=i.length;n<u;n++)if(typeof i[n]!="string")return!1;return!0}}),define(Ae[70],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qh=void 0;class E{constructor(P,M=[],R=!1){this.ctor=P,this.staticArguments=M,this.supportsDelayedInstantiation=R}}e.$Qh=E}),define(Ae[71],Re([1,0,70]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Br=e.$Ar=e.InstantiationType=void 0;const L=[];var P;(function($){$[$.Eager=0]="Eager",$[$.Delayed=1]="Delayed"})(P||(e.InstantiationType=P={}));function M($,D,g){D instanceof E.$Qh||(D=new E.$Qh(D,[],!!g)),L.push([$,D])}e.$Ar=M;function R(){return L}e.$Br=R}),define(Ae[184],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gq=e.$fq=void 0;class E{constructor(M,R){this.key=M,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$fq=E;class L{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const R of this.a.values())R.outgoing.size===0&&M.push(R);return M}insertEdge(M,R){const $=this.lookupOrInsertNode(M),D=this.lookupOrInsertNode(R);$.outgoing.set(D.key,D),D.incoming.set($.key,$)}removeNode(M){const R=this.b(M);this.a.delete(R);for(const $ of this.a.values())$.outgoing.delete(R),$.incoming.delete(R)}lookupOrInsertNode(M){const R=this.b(M);let $=this.a.get(R);return $||($=new E(R,M),this.a.set(R,$)),$}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[R,$]of this.a)M.push(`${R}
	(-> incoming)[${[...$.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...$.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,R]of this.a){const $=new Set([M]),D=this.c(R,$);if(D)return D}}c(M,R){for(const[$,D]of M.outgoing){if(R.has($))return[...R,$].join(" -> ");R.add($);const g=this.c(D,R);if(g)return g;R.delete($)}}}e.$gq=L}),define(Ae[4],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uh=e.$Th=e.$Sh=e._util=void 0;var E;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function $(D){return D[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=$})(E||(e._util=E={})),e.$Sh=P("instantiationService");function L(R,$,D){$[E.DI_TARGET]===$?$[E.DI_DEPENDENCIES].push({id:R,index:D}):($[E.DI_DEPENDENCIES]=[{id:R,index:D}],$[E.DI_TARGET]=$)}function P(R){if(E.serviceIds.has(R))return E.serviceIds.get(R);const $=function(D,g,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L($,D,A)};return $.toString=()=>R,E.serviceIds.set(R,$),$}e.$Th=P;function M(R){return R}e.$Uh=M}),define(Ae[40],Re([1,0,16,2,4]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.ConfigurationTarget=e.$pi=e.$oi=e.$ni=void 0,e.$ni=(0,P.$Th)("configurationService");function M(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof L.URI)}e.$oi=M;function R(i){return i&&typeof i=="object"&&(!i.overrideIdentifiers||Array.isArray(i.overrideIdentifiers))&&!i.overrideIdentifier&&(!i.resource||i.resource instanceof L.URI)}e.$pi=R;var $;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.USER=2]="USER",i[i.USER_LOCAL=3]="USER_LOCAL",i[i.USER_REMOTE=4]="USER_REMOTE",i[i.WORKSPACE=5]="WORKSPACE",i[i.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",i[i.DEFAULT=7]="DEFAULT",i[i.MEMORY=8]="MEMORY"})($||(e.ConfigurationTarget=$={}));function D(i){switch(i){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$qi=D;function g(i){return i.applicationValue!==void 0||i.userValue!==void 0||i.userLocalValue!==void 0||i.userRemoteValue!==void 0||i.workspaceValue!==void 0||i.workspaceFolderValue!==void 0}e.$ri=g;function A(i,n){const u=Object.create(null);for(const a in i)S(u,a,i[a],n);return u}e.$si=A;function S(i,n,u,a){const l=n.split("."),r=l.pop();let s=i;for(let c=0;c<l.length;c++){const h=l[c];let w=s[h];switch(typeof w){case"undefined":w=s[h]=Object.create(null);break;case"object":break;default:a(`Ignoring ${n} as ${l.slice(0,c+1).join(".")} is ${JSON.stringify(w)}`);return}s=w}if(typeof s=="object"&&s!==null)try{s[r]=u}catch{a(`Ignoring ${n} as ${l.join(".")} is ${JSON.stringify(s)}`)}else a(`Ignoring ${n} as ${l.join(".")} is ${JSON.stringify(s)}`)}e.$ti=S;function o(i,n){const u=n.split(".");v(i,u)}e.$ui=o;function v(i,n){const u=n.shift();if(n.length===0){delete i[u];return}if(Object.keys(i).indexOf(u)!==-1){const a=i[u];typeof a=="object"&&!Array.isArray(a)&&(v(a,n),Object.keys(a).length===0&&delete i[u])}}function p(i,n,u){function a(s,c){let h=s;for(const w of c){if(typeof h!="object"||h===null)return;h=h[w]}return h}const l=n.split("."),r=a(i,l);return typeof r>"u"?u:r}e.$vi=p;function f(i,n,u){Object.keys(n).forEach(a=>{a!=="__proto__"&&(a in i?E.$Bf(i[a])&&E.$Bf(n[a])?f(i[a],n[a],u):u&&(i[a]=n[a]):i[a]=n[a])})}e.$wi=f;function t(i){return i.replace(/[\[\]]/g,"")}e.$xi=t}),define(Ae[34],Re([1,0,21,13,182,4,149,11]),function(pe,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.ContextKeyExprType=e.$Pi=void 0;const D=new Map;D.set("false",!1),D.set("true",!0),D.set("isMac",E.$k),D.set("isLinux",E.$l),D.set("isWindows",E.$j),D.set("isWeb",E.$p),D.set("isMacNative",E.$k&&!E.$p),D.set("isEdge",E.$H),D.set("isFirefox",E.$F),D.set("isChrome",E.$E),D.set("isSafari",E.$G);function g(ee,W){if(D.get(ee)!==void 0)throw(0,$.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");D.set(ee,W)}e.$Pi=g;const A=Object.prototype.hasOwnProperty;var S;(function(ee){ee[ee.False=0]="False",ee[ee.True=1]="True",ee[ee.Defined=2]="Defined",ee[ee.Not=3]="Not",ee[ee.Equals=4]="Equals",ee[ee.NotEquals=5]="NotEquals",ee[ee.And=6]="And",ee[ee.Regex=7]="Regex",ee[ee.NotRegex=8]="NotRegex",ee[ee.Or=9]="Or",ee[ee.In=10]="In",ee[ee.NotIn=11]="NotIn",ee[ee.Greater=12]="Greater",ee[ee.GreaterEquals=13]="GreaterEquals",ee[ee.Smaller=14]="Smaller",ee[ee.SmallerEquals=15]="SmallerEquals"})(S||(e.ContextKeyExprType=S={}));const o={regexParsingWithErrorRecovery:!0},v=(0,R.localize)(0,null),p=(0,R.localize)(1,null),f=(0,R.localize)(2,null),t=(0,R.localize)(3,null),i=(0,R.localize)(4,null),n=(0,R.localize)(5,null),u=(0,R.localize)(6,null),a=(0,R.localize)(7,null);class l{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(W=o){this.k=W,this.d=new P.$Oi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(W){if(W===""){this.h.push({message:v,offset:0,lexeme:"",additionalInfo:p});return}this.f=this.d.reset(W).scan(),this.g=0,this.h=[];try{const ue=this.l();if(!this.E()){const Pe=this.D(),Ee=Pe.type===17?n:void 0;throw this.h.push({message:i,offset:Pe.offset,lexeme:P.$Oi.getLexeme(Pe),additionalInfo:Ee}),l.c}return ue}catch(ue){if(ue!==l.c)throw ue;return}}l(){return this.m()}m(){const W=[this.o()];for(;this.y(16);){const ue=this.o();W.push(ue)}return W.length===1?W[0]:r.or(...W)}o(){const W=[this.s()];for(;this.y(15);){const ue=this.s();W.push(ue)}return W.length===1?W[0]:r.and(...W)}s(){if(this.y(2)){const W=this.D();switch(W.type){case 11:return this.z(),w.INSTANCE;case 12:return this.z(),m.INSTANCE;case 0:{this.z();const ue=this.l();return this.A(1,t),ue?.negate()}case 17:return this.z(),C.create(W.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",W)}}return this.t()}t(){const W=this.D();switch(W.type){case 11:return this.z(),r.true();case 12:return this.z(),r.false();case 0:{this.z();const ue=this.l();return this.A(1,t),ue}case 17:{const ue=W.lexeme;if(this.z(),this.y(9)){const Ee=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Ee.type!==10)throw this.B("REGEX",Ee);const te=Ee.lexeme,se=te.lastIndexOf("/"),me=se===te.length-1?void 0:this.w(te.substring(se+1));let Z;try{Z=new RegExp(te.substring(1,se),me)}catch{throw this.B("REGEX",Ee)}return N.create(ue,Z)}switch(Ee.type){case 10:case 19:{const te=[Ee.lexeme];this.z();let se=this.D(),me=0;for(let de=0;de<Ee.lexeme.length;de++)Ee.lexeme.charCodeAt(de)===40?me++:Ee.lexeme.charCodeAt(de)===41&&me--;for(;!this.E()&&se.type!==15&&se.type!==16;){switch(se.type){case 0:me++;break;case 1:me--;break;case 10:case 18:for(let de=0;de<se.lexeme.length;de++)se.lexeme.charCodeAt(de)===40?me++:Ee.lexeme.charCodeAt(de)===41&&me--}if(me<0)break;te.push(P.$Oi.getLexeme(se)),this.z(),se=this.D()}const Z=te.join(""),le=Z.lastIndexOf("/"),ne=le===Z.length-1?void 0:this.w(Z.substring(le+1));let ae;try{ae=new RegExp(Z.substring(1,le),ne)}catch{throw this.B("REGEX",Ee)}return r.regex(ue,ae)}case 18:{const te=Ee.lexeme;this.z();let se=null;if(!(0,L.$Ce)(te)){const me=te.indexOf("/"),Z=te.lastIndexOf("/");if(me!==Z&&me>=0){const le=te.slice(me+1,Z),ne=te[Z+1]==="i"?"i":"";try{se=new RegExp(le,ne)}catch{throw this.B("REGEX",Ee)}}}if(se===null)throw this.B("REGEX",Ee);return N.create(ue,se)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,f);const Ee=this.u();return r.notIn(ue,Ee)}switch(this.D().type){case 3:{this.z();const Ee=this.u();if(this.x().type===18)return r.equals(ue,Ee);switch(Ee){case"true":return r.has(ue);case"false":return r.not(ue);default:return r.equals(ue,Ee)}}case 4:{this.z();const Ee=this.u();if(this.x().type===18)return r.notEquals(ue,Ee);switch(Ee){case"true":return r.not(ue);case"false":return r.has(ue);default:return r.notEquals(ue,Ee)}}case 5:return this.z(),z.create(ue,this.u());case 6:return this.z(),F.create(ue,this.u());case 7:return this.z(),H.create(ue,this.u());case 8:return this.z(),U.create(ue,this.u());case 13:return this.z(),r.in(ue,this.u());default:return r.has(ue)}}case 20:throw this.h.push({message:u,offset:W.offset,lexeme:"",additionalInfo:a}),l.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const W=this.D();switch(W.type){case 17:case 18:return this.z(),W.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(W){return W.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(W){return this.C(W)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(W,ue){if(this.C(W))return this.z();throw this.B(ue,this.D())}B(W,ue,Pe){const Ee=(0,R.localize)(8,null,W,P.$Oi.getLexeme(ue)),te=ue.offset,se=P.$Oi.getLexeme(ue);return this.h.push({message:Ee,offset:te,lexeme:se,additionalInfo:Pe}),l.c}C(W){return this.D().type===W}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Qi=l;class r{static false(){return w.INSTANCE}static true(){return m.INSTANCE}static has(W){return I.create(W)}static equals(W,ue){return k.create(W,ue)}static notEquals(W,ue){return y.create(W,ue)}static regex(W,ue){return N.create(W,ue)}static in(W,ue){return d.create(W,ue)}static notIn(W,ue){return b.create(W,ue)}static not(W){return C.create(W)}static and(...W){return ye.create(W,null,!0)}static or(...W){return De.create(W,null,!0)}static greater(W,ue){return H.create(W,ue)}static greaterEquals(W,ue){return U.create(W,ue)}static smaller(W,ue){return z.create(W,ue)}static smallerEquals(W,ue){return F.create(W,ue)}static{this.c=new l({regexParsingWithErrorRecovery:!1})}static deserialize(W){return W==null?void 0:this.c.parse(W)}}e.$Ri=r;function s(ee){const W=new l({regexParsingWithErrorRecovery:!1});return ee.map(ue=>(W.parse(ue),W.lexingErrors.length>0?W.lexingErrors.map(Pe=>({errorMessage:Pe.additionalInfo?(0,R.localize)(9,null,Pe.additionalInfo):(0,R.localize)(10,null),offset:Pe.offset,length:Pe.lexeme.length})):W.parsingErrors.length>0?W.parsingErrors.map(Pe=>({errorMessage:Pe.additionalInfo?`${Pe.message}. ${Pe.additionalInfo}`:Pe.message,offset:Pe.offset,length:Pe.lexeme.length})):[]))}e.$Si=s;function c(ee,W){const ue=ee?ee.substituteConstants():void 0,Pe=W?W.substituteConstants():void 0;return!ue&&!Pe?!0:!ue||!Pe?!1:ue.equals(Pe)}e.$Ti=c;function h(ee,W){return ee.cmp(W)}class w{static{this.INSTANCE=new w}constructor(){this.type=0}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!1}serialize(){return"false"}keys(){return[]}map(W){return this}negate(){return m.INSTANCE}}e.$Ui=w;class m{static{this.INSTANCE=new m}constructor(){this.type=1}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!0}serialize(){return"true"}keys(){return[]}map(W){return this}negate(){return w.INSTANCE}}e.$Vi=m;class I{static create(W,ue=null){const Pe=D.get(W);return typeof Pe=="boolean"?Pe?m.INSTANCE:w.INSTANCE:new I(W,ue)}constructor(W,ue){this.key=W,this.c=ue,this.type=2}cmp(W){return W.type!==this.type?this.type-W.type:ge(this.key,W.key)}equals(W){return W.type===this.type?this.key===W.key:!1}substituteConstants(){const W=D.get(this.key);return typeof W=="boolean"?W?m.INSTANCE:w.INSTANCE:this}evaluate(W){return!!W.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(W){return W.mapDefined(this.key)}negate(){return this.c||(this.c=C.create(this.key,this)),this.c}}e.$Wi=I;class k{static create(W,ue,Pe=null){if(typeof ue=="boolean")return ue?I.create(W,Pe):C.create(W,Pe);const Ee=D.get(W);return typeof Ee=="boolean"?ue===(Ee?"true":"false")?m.INSTANCE:w.INSTANCE:new k(W,ue,Pe)}constructor(W,ue,Pe){this.c=W,this.d=ue,this.f=Pe,this.type=4}cmp(W){return W.type!==this.type?this.type-W.type:we(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){const W=D.get(this.c);if(typeof W=="boolean"){const ue=W?"true":"false";return this.d===ue?m.INSTANCE:w.INSTANCE}return this}evaluate(W){return W.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(W){return W.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$Xi=k;class d{static create(W,ue){return new d(W,ue)}constructor(W,ue){this.d=W,this.f=ue,this.type=10,this.c=null}cmp(W){return W.type!==this.type?this.type-W.type:we(this.d,this.f,W.d,W.f)}equals(W){return W.type===this.type?this.d===W.d&&this.f===W.f:!1}substituteConstants(){return this}evaluate(W){const ue=W.getValue(this.f),Pe=W.getValue(this.d);return Array.isArray(ue)?ue.includes(Pe):typeof Pe=="string"&&typeof ue=="object"&&ue!==null?A.call(ue,Pe):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(W){return W.mapIn(this.d,this.f)}negate(){return this.c||(this.c=b.create(this.d,this.f)),this.c}}e.$Yi=d;class b{static create(W,ue){return new b(W,ue)}constructor(W,ue){this.d=W,this.f=ue,this.type=11,this.c=d.create(W,ue)}cmp(W){return W.type!==this.type?this.type-W.type:this.c.cmp(W.c)}equals(W){return W.type===this.type?this.c.equals(W.c):!1}substituteConstants(){return this}evaluate(W){return!this.c.evaluate(W)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(W){return W.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Zi=b;class y{static create(W,ue,Pe=null){if(typeof ue=="boolean")return ue?C.create(W,Pe):I.create(W,Pe);const Ee=D.get(W);return typeof Ee=="boolean"?ue===(Ee?"true":"false")?w.INSTANCE:m.INSTANCE:new y(W,ue,Pe)}constructor(W,ue,Pe){this.c=W,this.d=ue,this.f=Pe,this.type=5}cmp(W){return W.type!==this.type?this.type-W.type:we(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){const W=D.get(this.c);if(typeof W=="boolean"){const ue=W?"true":"false";return this.d===ue?w.INSTANCE:m.INSTANCE}return this}evaluate(W){return W.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(W){return W.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$1i=y;class C{static create(W,ue=null){const Pe=D.get(W);return typeof Pe=="boolean"?Pe?w.INSTANCE:m.INSTANCE:new C(W,ue)}constructor(W,ue){this.c=W,this.d=ue,this.type=3}cmp(W){return W.type!==this.type?this.type-W.type:ge(this.c,W.c)}equals(W){return W.type===this.type?this.c===W.c:!1}substituteConstants(){const W=D.get(this.c);return typeof W=="boolean"?W?w.INSTANCE:m.INSTANCE:this}evaluate(W){return!W.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(W){return W.mapNot(this.c)}negate(){return this.d||(this.d=I.create(this.c,this)),this.d}}e.$2i=C;function B(ee,W){if(typeof ee=="string"){const ue=parseFloat(ee);isNaN(ue)||(ee=ue)}return typeof ee=="string"||typeof ee=="number"?W(ee):w.INSTANCE}class H{static create(W,ue,Pe=null){return B(ue,Ee=>new H(W,Ee,Pe))}constructor(W,ue,Pe){this.c=W,this.d=ue,this.f=Pe,this.type=12}cmp(W){return W.type!==this.type?this.type-W.type:we(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(W){return W.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$3i=H;class U{static create(W,ue,Pe=null){return B(ue,Ee=>new U(W,Ee,Pe))}constructor(W,ue,Pe){this.c=W,this.d=ue,this.f=Pe,this.type=13}cmp(W){return W.type!==this.type?this.type-W.type:we(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(W){return W.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$4i=U;class z{static create(W,ue,Pe=null){return B(ue,Ee=>new z(W,Ee,Pe))}constructor(W,ue,Pe){this.c=W,this.d=ue,this.f=Pe,this.type=14}cmp(W){return W.type!==this.type?this.type-W.type:we(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(W){return W.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$5i=z;class F{static create(W,ue,Pe=null){return B(ue,Ee=>new F(W,Ee,Pe))}constructor(W,ue,Pe){this.c=W,this.d=ue,this.f=Pe,this.type=15}cmp(W){return W.type!==this.type?this.type-W.type:we(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(W){return W.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=H.create(this.c,this.d,this)),this.f}}e.$6i=F;class N{static create(W,ue){return new N(W,ue)}constructor(W,ue){this.d=W,this.f=ue,this.type=7,this.c=null}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.d<W.d)return-1;if(this.d>W.d)return 1;const ue=this.f?this.f.source:"",Pe=W.f?W.f.source:"";return ue<Pe?-1:ue>Pe?1:0}equals(W){if(W.type===this.type){const ue=this.f?this.f.source:"",Pe=W.f?W.f.source:"";return this.d===W.d&&ue===Pe}return!1}substituteConstants(){return this}evaluate(W){const ue=W.getValue(this.d);return this.f?this.f.test(ue):!1}serialize(){const W=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${W}`}keys(){return[this.d]}map(W){return W.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=x.create(this)),this.c}}e.$7i=N;class x{static create(W){return new x(W)}constructor(W){this.c=W,this.type=8}cmp(W){return W.type!==this.type?this.type-W.type:this.c.cmp(W.c)}equals(W){return W.type===this.type?this.c.equals(W.c):!1}substituteConstants(){return this}evaluate(W){return!this.c.evaluate(W)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(W){return new x(this.c.map(W))}negate(){return this.c}}e.$8i=x;function J(ee){let W=null;for(let ue=0,Pe=ee.length;ue<Pe;ue++){const Ee=ee[ue].substituteConstants();if(ee[ue]!==Ee&&W===null){W=[];for(let te=0;te<ue;te++)W[te]=ee[te]}W!==null&&(W[ue]=Ee)}return W===null?ee:W}class ye{static create(W,ue,Pe){return ye.d(W,ue,Pe)}constructor(W,ue){this.expr=W,this.c=ue,this.type=6}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let ue=0,Pe=this.expr.length;ue<Pe;ue++){const Ee=h(this.expr[ue],W.expr[ue]);if(Ee!==0)return Ee}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let ue=0,Pe=this.expr.length;ue<Pe;ue++)if(!this.expr[ue].equals(W.expr[ue]))return!1;return!0}return!1}substituteConstants(){const W=J(this.expr);return W===this.expr?this:ye.create(W,this.c,!1)}evaluate(W){for(let ue=0,Pe=this.expr.length;ue<Pe;ue++)if(!this.expr[ue].evaluate(W))return!1;return!0}static d(W,ue,Pe){const Ee=[];let te=!1;for(const se of W)if(se){if(se.type===1){te=!0;continue}if(se.type===0)return w.INSTANCE;if(se.type===6){Ee.push(...se.expr);continue}Ee.push(se)}if(Ee.length===0&&te)return m.INSTANCE;if(Ee.length!==0){if(Ee.length===1)return Ee[0];Ee.sort(h);for(let se=1;se<Ee.length;se++)Ee[se-1].equals(Ee[se])&&(Ee.splice(se,1),se--);if(Ee.length===1)return Ee[0];for(;Ee.length>1;){const se=Ee[Ee.length-1];if(se.type!==9)break;Ee.pop();const me=Ee.pop(),Z=Ee.length===0,le=De.create(se.expr.map(ne=>ye.create([ne,me],null,Pe)),null,Z);le&&(Ee.push(le),Ee.sort(h))}if(Ee.length===1)return Ee[0];if(Pe){for(let se=0;se<Ee.length;se++)for(let me=se+1;me<Ee.length;me++)if(Ee[se].negate().equals(Ee[me]))return w.INSTANCE;if(Ee.length===1)return Ee[0]}return new ye(Ee,ue)}}serialize(){return this.expr.map(W=>W.serialize()).join(" && ")}keys(){const W=[];for(const ue of this.expr)W.push(...ue.keys());return W}map(W){return new ye(this.expr.map(ue=>ue.map(W)),null)}negate(){if(!this.c){const W=[];for(const ue of this.expr)W.push(ue.negate());this.c=De.create(W,this,!0)}return this.c}}e.$9i=ye;class De{static create(W,ue,Pe){return De.d(W,ue,Pe)}constructor(W,ue){this.expr=W,this.c=ue,this.type=9}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let ue=0,Pe=this.expr.length;ue<Pe;ue++){const Ee=h(this.expr[ue],W.expr[ue]);if(Ee!==0)return Ee}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let ue=0,Pe=this.expr.length;ue<Pe;ue++)if(!this.expr[ue].equals(W.expr[ue]))return!1;return!0}return!1}substituteConstants(){const W=J(this.expr);return W===this.expr?this:De.create(W,this.c,!1)}evaluate(W){for(let ue=0,Pe=this.expr.length;ue<Pe;ue++)if(this.expr[ue].evaluate(W))return!0;return!1}static d(W,ue,Pe){let Ee=[],te=!1;if(W){for(let se=0,me=W.length;se<me;se++){const Z=W[se];if(Z){if(Z.type===0){te=!0;continue}if(Z.type===1)return m.INSTANCE;if(Z.type===9){Ee=Ee.concat(Z.expr);continue}Ee.push(Z)}}if(Ee.length===0&&te)return w.INSTANCE;Ee.sort(h)}if(Ee.length!==0){if(Ee.length===1)return Ee[0];for(let se=1;se<Ee.length;se++)Ee[se-1].equals(Ee[se])&&(Ee.splice(se,1),se--);if(Ee.length===1)return Ee[0];if(Pe){for(let se=0;se<Ee.length;se++)for(let me=se+1;me<Ee.length;me++)if(Ee[se].negate().equals(Ee[me]))return m.INSTANCE;if(Ee.length===1)return Ee[0]}return new De(Ee,ue)}}serialize(){return this.expr.map(W=>W.serialize()).join(" || ")}keys(){const W=[];for(const ue of this.expr)W.push(...ue.keys());return W}map(W){return new De(this.expr.map(ue=>ue.map(W)),null)}negate(){if(!this.c){const W=[];for(const ue of this.expr)W.push(ue.negate());for(;W.length>1;){const ue=W.shift(),Pe=W.shift(),Ee=[];for(const te of ve(ue))for(const se of ve(Pe))Ee.push(ye.create([te,se],null,!1));W.unshift(De.create(Ee,null,!1))}this.c=De.create(W,this,!0)}return this.c}}e.$0i=De;class Ce extends I{static{this.d=[]}static all(){return Ce.d.values()}constructor(W,ue,Pe){super(W,null),this.f=ue,typeof Pe=="object"?Ce.d.push({...Pe,key:W}):Pe!==!0&&Ce.d.push({key:W,description:Pe,type:ue!=null?typeof ue:void 0})}bindTo(W){return W.createKey(this.key,this.f)}getValue(W){return W.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(W){return k.create(this.key,W)}notEqualsTo(W){return y.create(this.key,W)}}e.$$i=Ce,e.$_i=(0,M.$Th)("contextKeyService");function ge(ee,W){return ee<W?-1:ee>W?1:0}function we(ee,W,ue,Pe){return ee<ue?-1:ee>ue?1:W<Pe?-1:W>Pe?1:0}function re(ee,W){if(ee.type===0||W.type===1)return!0;if(ee.type===9)return W.type===9?oe(ee.expr,W.expr):!1;if(W.type===9){for(const ue of W.expr)if(re(ee,ue))return!0;return!1}if(ee.type===6){if(W.type===6)return oe(W.expr,ee.expr);for(const ue of ee.expr)if(re(ue,W))return!0;return!1}return ee.equals(W)}e.$aj=re;function oe(ee,W){let ue=0,Pe=0;for(;ue<ee.length&&Pe<W.length;){const Ee=ee[ue].cmp(W[Pe]);if(Ee<0)return!1;Ee===0&&ue++,Pe++}return ue===ee.length}function ve(ee){return ee.type===9?ee.expr:[ee]}}),define(Ae[185],Re([1,0,4]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=e.$1h=void 0,e.$1h=(0,E.$Th)("environmentService"),e.$2h=(0,E.$Uh)(e.$1h)}),define(Ae[96],Re([1,0,151,4]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$bo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=void 0,e.$2n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$3n=new RegExp(e.$2n),e.$4n="__web_extension",e.$5n="skipWalkthrough",e.$6n="extensionsSync",e.$7n="dependecyOrPackExtensionInstall";function P(i){switch(i){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$8n=P;function M(i){switch(i){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$9n=M;function R(i,n){switch(i){case 3:return n==="x64"?"win32-x64":n==="arm64"?"win32-arm64":"unknown";case 2:return n==="x64"?"linux-x64":n==="arm64"?"linux-arm64":n==="arm"?"linux-armhf":"unknown";case"alpine":return n==="x64"?"alpine-x64":n==="arm64"?"alpine-arm64":"unknown";case 1:return n==="x64"?"darwin-x64":n==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$0n=R;function $(i,n){return n==="web"&&!i.includes("web")}e.$$n=$;function D(i,n,u){return $(n,u)?!1:i==="undefined"||i==="universal"?!0:i==="unknown"?!1:i===u}e.$_n=D;function g(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.$ao=g;var A;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(A||(e.SortBy=A={}));var S;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(S||(e.SortOrder=S={}));var o;(function(i){i.Install="install",i.Uninstall="uninstall"})(o||(e.StatisticType=o={}));var v;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(v||(e.InstallOperation=v={})),e.$bo=(0,L.$Th)("extensionGalleryService");var p;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.Extract="Extract",i.Delete="Delete",i.Rename="Rename",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.Internal="Internal"})(p||(e.ExtensionManagementErrorCode=p={}));var f;(function(i){i.UnknownError="UnknownError",i.PackageIsInvalidZip="PackageIsInvalidZip",i.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(f||(e.ExtensionSignaturetErrorCode=f={}));class t extends Error{constructor(n,u){super(n),this.code=u,this.name=u}}e.$co=t,e.$do=(0,L.$Th)("extensionManagementService"),e.$eo="extensionsIdentifiers/disabled",e.$fo="extensionsIdentifiers/enabled",e.$go=(0,L.$Th)("IGlobalExtensionEnablementService"),e.$ho=(0,L.$Th)("IExtensionTipsService"),e.$io=(0,E.localize)(0,null),e.$jo={value:e.$io,original:"Extensions"},e.$ko={value:(0,E.localize)(1,null),original:"Preferences"}}),define(Ae[41],Re([1,0,51,19,13,16,2,153,4,21,14,44]),function(pe,e,E,L,P,M,R,$,D,g,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lk=e.$Kk=e.$Jk=e.$Ik=e.$Hk=e.FileKind=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.FileOperationResult=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.FileChangeType=e.$uk=e.FileOperation=e.$tk=e.$sk=e.$rk=e.$qk=e.$pk=e.$ok=e.FileSystemProviderErrorCode=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.FileSystemProviderCapabilities=e.$ek=e.FilePermission=e.FileType=e.$dk=e.$ck=void 0,e.$ck=(0,D.$Th)("fileService");function o(re){return re.create===!0}e.$dk=o;var v;(function(re){re[re.Unknown=0]="Unknown",re[re.File=1]="File",re[re.Directory=2]="Directory",re[re.SymbolicLink=64]="SymbolicLink"})(v||(e.FileType=v={}));var p;(function(re){re[re.Readonly=1]="Readonly",re[re.Locked=2]="Locked"})(p||(e.FilePermission=p={}));function f(re){const oe=re;return!!oe&&typeof oe.onDidChange=="function"}e.$ek=f;var t;(function(re){re[re.None=0]="None",re[re.FileReadWrite=2]="FileReadWrite",re[re.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",re[re.FileReadStream=16]="FileReadStream",re[re.FileFolderCopy=8]="FileFolderCopy",re[re.PathCaseSensitive=1024]="PathCaseSensitive",re[re.Readonly=2048]="Readonly",re[re.Trash=4096]="Trash",re[re.FileWriteUnlock=8192]="FileWriteUnlock",re[re.FileAtomicRead=16384]="FileAtomicRead",re[re.FileAtomicWrite=32768]="FileAtomicWrite",re[re.FileAtomicDelete=65536]="FileAtomicDelete",re[re.FileClone=131072]="FileClone"})(t||(e.FileSystemProviderCapabilities=t={}));function i(re){return!!(re.capabilities&2)}e.$fk=i;function n(re){return!!(re.capabilities&8)}e.$gk=n;function u(re){return!!(re.capabilities&131072)}e.$hk=u;function a(re){return!!(re.capabilities&4)}e.$ik=a;function l(re){return!!(re.capabilities&16)}e.$jk=l;function r(re){return i(re)?!!(re.capabilities&16384):!1}e.$kk=r;function s(re){return i(re)?!!(re.capabilities&32768):!1}e.$lk=s;function c(re){return!!(re.capabilities&65536)}e.$mk=c;function h(re){return!!(re.capabilities&2048)}e.$nk=h;var w;(function(re){re.FileExists="EntryExists",re.FileNotFound="EntryNotFound",re.FileNotADirectory="EntryNotADirectory",re.FileIsADirectory="EntryIsADirectory",re.FileExceedsStorageQuota="EntryExceedsStorageQuota",re.FileTooLarge="EntryTooLarge",re.FileWriteLocked="EntryWriteLocked",re.NoPermissions="NoPermissions",re.Unavailable="Unavailable",re.Unknown="Unknown"})(w||(e.FileSystemProviderErrorCode=w={}));class m extends Error{static create(oe,ve){const ee=new m(oe.toString(),ve);return d(ee,ve),ee}constructor(oe,ve){super(oe),this.code=ve}}e.$ok=m;function I(re,oe){return m.create(re,oe)}e.$pk=I;function k(re){return re||I((0,$.localize)(0,null),w.Unknown)}e.$qk=k;function d(re,oe){return re.name=oe?`${oe} (FileSystemError)`:"FileSystemError",re}e.$rk=d;function b(re){if(!re)return w.Unknown;if(re instanceof m)return re.code;const oe=/^(.+) \(FileSystemError\)$/.exec(re.name);if(!oe)return w.Unknown;switch(oe[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}e.$sk=b;function y(re){if(re instanceof F)return re.fileOperationResult;switch(b(re)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 9;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileTooLarge:return 7;default:return 10}}e.$tk=y;var C;(function(re){re[re.CREATE=0]="CREATE",re[re.DELETE=1]="DELETE",re[re.MOVE=2]="MOVE",re[re.COPY=3]="COPY",re[re.WRITE=4]="WRITE"})(C||(e.FileOperation=C={}));class B{constructor(oe,ve,ee){this.resource=oe,this.operation=ve,this.target=ee}isOperation(oe){return this.operation===oe}}e.$uk=B;var H;(function(re){re[re.UPDATED=0]="UPDATED",re[re.ADDED=1]="ADDED",re[re.DELETED=2]="DELETED"})(H||(e.FileChangeType=H={}));class U{static{this.a=null}constructor(oe,ve){this.c=ve,this.b=void 0,this.d=new S.$U(()=>{const ee=E.$Zh.forUris(()=>this.c);return ee.fill(this.rawAdded.map(W=>[W,!0])),ee}),this.f=new S.$U(()=>{const ee=E.$Zh.forUris(()=>this.c);return ee.fill(this.rawUpdated.map(W=>[W,!0])),ee}),this.g=new S.$U(()=>{const ee=E.$Zh.forUris(()=>this.c);return ee.fill(this.rawDeleted.map(W=>[W,!0])),ee}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const ee of oe){switch(ee.type){case 1:this.rawAdded.push(ee.resource);break;case 0:this.rawUpdated.push(ee.resource);break;case 2:this.rawDeleted.push(ee.resource);break}this.b!==U.a&&(typeof ee.cId=="number"?this.b===void 0?this.b=ee.cId:this.b!==ee.cId&&(this.b=U.a):this.b!==void 0&&(this.b=U.a))}}contains(oe,...ve){return this.h(oe,{includeChildren:!1},...ve)}affects(oe,...ve){return this.h(oe,{includeChildren:!0},...ve)}h(oe,ve,...ee){if(!oe)return!1;const W=ee.length>0;return!!((!W||ee.includes(1))&&(this.d.value.get(oe)||ve.includeChildren&&this.d.value.findSuperstr(oe))||(!W||ee.includes(0))&&(this.f.value.get(oe)||ve.includeChildren&&this.f.value.findSuperstr(oe))||(!W||ee.includes(2))&&(this.g.value.findSubstr(oe)||ve.includeChildren&&this.g.value.findSuperstr(oe)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(oe){return this.b===oe}hasCorrelation(){return typeof this.b=="number"}}e.$vk=U;function z(re,oe,ve){return!re||!oe||re===oe||oe.length>re.length?!1:(oe.charAt(oe.length-1)!==L.sep&&(oe+=L.sep),ve?(0,P.$4e)(re,oe):re.indexOf(oe)===0)}e.$wk=z;class F extends Error{constructor(oe,ve,ee){super(oe),this.fileOperationResult=ve,this.options=ee}}e.$xk=F;class N extends F{constructor(oe,ve,ee,W){super(oe,ve,W),this.fileOperationResult=ve,this.size=ee}}e.$yk=N;class x extends F{constructor(oe,ve,ee){super(oe,2,ee),this.stat=ve}}e.$zk=x;var J;(function(re){re[re.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",re[re.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",re[re.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",re[re.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",re[re.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",re[re.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",re[re.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",re[re.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",re[re.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",re[re.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",re[re.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(J||(e.FileOperationResult=J={})),e.$Ak={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Bk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Ck="files.associations",e.$Dk="files.exclude",e.$Ek="files.readonlyInclude",e.$Fk="files.readonlyExclude",e.$Gk="files.readonlyFromPermissions";var ye;(function(re){re[re.FILE=0]="FILE",re[re.FOLDER=1]="FOLDER",re[re.ROOT_FOLDER=2]="ROOT_FOLDER"})(ye||(e.FileKind=ye={})),e.$Hk="";function De(re){if(!(typeof re.size!="number"||typeof re.mtime!="number"))return re.mtime.toString(29)+re.size.toString(31)}e.$Ik=De;async function Ce(re,oe){if(!oe.hasProvider(R.URI.from({scheme:re.scheme})))return new Promise(ve=>{const ee=oe.onDidChangeFileSystemProviderRegistrations(W=>{W.scheme===re.scheme&&W.added&&(ee.dispose(),ve())})})}e.$Jk=Ce;class ge{static{this.KB=1024}static{this.MB=ge.KB*ge.KB}static{this.GB=ge.MB*ge.KB}static{this.TB=ge.GB*ge.KB}static formatSize(oe){return(0,M.$Df)(oe)||(oe=0),oe<ge.KB?(0,$.localize)(1,null,oe.toFixed(0)):oe<ge.MB?(0,$.localize)(2,null,(oe/ge.KB).toFixed(2)):oe<ge.GB?(0,$.localize)(3,null,(oe/ge.MB).toFixed(2)):oe<ge.TB?(0,$.localize)(4,null,(oe/ge.GB).toFixed(2)):(0,$.localize)(5,null,(oe/ge.TB).toFixed(2))}}e.$Kk=ge;function we(re){const oe=typeof re=="string"||re?.scheme===A.Schemas.vscodeRemote;return typeof re!="string"&&re?.scheme===A.Schemas.file?1024*ge.MB:oe?10*ge.MB:g.$p?50*ge.MB:1024*ge.MB}e.$Lk=we}),define(Ae[72],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rh=void 0;class E{constructor(...P){this.a=new Map;for(const[M,R]of P)this.set(M,R)}set(P,M){const R=this.a.get(P);return this.a.set(P,M),R}has(P){return this.a.has(P)}get(P){return this.a.get(P)}}e.$Rh=E}),define(Ae[186],Re([1,0,12,11,6,70,184,4,72,187]),function(pe,e,E,L,P,M,R,$,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=e.$hq=void 0;const A=!1;class S extends Error{constructor(t){super("cyclic dependency between services"),this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class o{constructor(t=new D.$Rh,i=!1,n,u=A){this.f=t,this.g=i,this.h=n,this.i=u,this.o=new Set,this.f.set($.$Sh,this),this._globalGraph=u?n?._globalGraph??new R.$gq(a=>a):void 0}createChild(t){return new o(t,this.g,this,this.i)}invokeFunction(t,...i){const n=p.traceInvocation(this.i,t);let u=!1;try{return t({get:l=>{if(u)throw(0,L.$7)("service accessor is only valid during the invocation of its target method");const r=this.m(l,n);if(!r)throw new Error(`[invokeFunction] unknown service '${l}'`);return r}},...i)}finally{u=!0,n.stop()}}createInstance(t,...i){let n,u;return t instanceof M.$Qh?(n=p.traceCreation(this.i,t.ctor),u=this.j(t.ctor,t.staticArguments.concat(i),n)):(n=p.traceCreation(this.i,t),u=this.j(t,i,n)),n.stop(),u}j(t,i=[],n){const u=$._util.getServiceDependencies(t).sort((r,s)=>r.index-s.index),a=[];for(const r of u){const s=this.m(r.id,n);s||this.u(`[createInstance] ${t.name} depends on UNKNOWN service ${r.id}.`,!1),a.push(s)}const l=u.length>0?u[0].index:i.length;if(i.length!==l){console.trace(`[createInstance] First service dependency of ${t.name} at position ${l+1} conflicts with ${i.length} static arguments`);const r=l-i.length;r>0?i=i.concat(new Array(r)):i=i.slice(0,l)}return Reflect.construct(t,i.concat(a))}k(t,i){if(this.f.get(t)instanceof M.$Qh)this.f.set(t,i);else if(this.h)this.h.k(t,i);else throw new Error("illegalState - setting UNKNOWN service instance")}l(t){const i=this.f.get(t);return!i&&this.h?this.h.l(t):i}m(t,i){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(t));const n=this.l(t);return n instanceof M.$Qh?this.q(t,n,i.branch(t,!0)):(i.branch(t,!1),n)}q(t,i,n){if(this.o.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this.o.add(t);try{return this.r(t,i,n)}finally{this.o.delete(t)}}r(t,i,n){const u=new R.$gq(r=>r.id.toString());let a=0;const l=[{id:t,desc:i,_trace:n}];for(;l.length;){const r=l.pop();if(u.lookupOrInsertNode(r),a++>1e3)throw new S(u);for(const s of $._util.getServiceDependencies(r.desc.ctor)){const c=this.l(s.id);if(c||this.u(`[createInstance] ${t} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(r.id),String(s.id)),c instanceof M.$Qh){const h={id:s.id,desc:c,_trace:r._trace.branch(s.id,!0)};u.insertEdge(r,h),l.push(h)}}}for(;;){const r=u.roots();if(r.length===0){if(!u.isEmpty())throw new S(u);break}for(const{data:s}of r){if(this.l(s.id)instanceof M.$Qh){const h=this.s(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.k(s.id,h)}u.removeNode(s)}}return this.l(t)}s(t,i,n=[],u,a){if(this.f.get(t)instanceof M.$Qh)return this.t(t,i,n,u,a);if(this.h)return this.h.s(t,i,n,u,a);throw new Error(`illegalState - creating UNKNOWN service instance ${i.name}`)}t(t,i,n=[],u,a){if(u){const l=new o(void 0,this.g,this,this.i);l.c=String(t);const r=new Map,s=new E.$ch(()=>{const c=l.j(i,n,a);for(const[h,w]of r){const m=c[h];if(typeof m=="function")for(const I of w)m.apply(c,I)}return r.clear(),c});return new Proxy(Object.create(null),{get(c,h){if(!s.isInitialized&&typeof h=="string"&&(h.startsWith("onDid")||h.startsWith("onWill"))){let I=r.get(h);return I||(I=new g.$1c,r.set(h,I)),(d,b,y)=>{const C=I.push([d,b,y]);return(0,P.$Pc)(C)}}if(h in c)return c[h];const w=s.value;let m=w[h];return typeof m!="function"||(m=m.bind(w),c[h]=m),m},set(c,h,w){return s.value[h]=w,!0},getPrototypeOf(c){return i.prototype}})}else return this.j(i,n,a)}u(t,i){if(i&&console.warn(t),this.g)throw new Error(t)}}e.$hq=o;var v;(function(f){f[f.None=0]="None",f[f.Creation=1]="Creation",f[f.Invocation=2]="Invocation",f[f.Branch=3]="Branch"})(v||(v={}));class p{static{this.all=new Set}static{this.c=new class extends p{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(t,i){return t?new p(2,i.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p.c}static traceCreation(t,i){return t?new p(1,i.name):p.c}static{this.f=0}constructor(t,i){this.type=t,this.name=i,this.g=Date.now(),this.h=[]}branch(t,i){const n=new p(3,t.toString());return this.h.push([t,i,n]),n}stop(){const t=Date.now()-this.g;p.f+=t;let i=!1;function n(a,l){const r=[],s=new Array(a+1).join("	");for(const[c,h,w]of l.h)if(h&&w){i=!0,r.push(`${s}CREATES -> ${c}`);const m=n(a+1,w);m&&r.push(m)}else r.push(`${s}uses -> ${c}`);return r.join(`
`)}const u=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${p.f.toFixed(2)}ms)`];(t>2||i)&&p.all.add(u.join(`
`))}}e.$iq=p}),define(Ae[15],Re([1,0,39,5,97,6,28,21,25,16,2,34,4]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.log=e.$ej=e.LogLevel=e.$dj=e.$cj=e.$bj=void 0,e.$bj=(0,o.$Th)("logService"),e.$cj=(0,o.$Th)("loggerService");function v(){return new Date().toISOString()}function p(d){return(0,g.$Df)(d)}e.$dj=p;var f;(function(d){d[d.Off=0]="Off",d[d.Trace=1]="Trace",d[d.Debug=2]="Debug",d[d.Info=3]="Info",d[d.Warning=4]="Warning",d[d.Error=5]="Error"})(f||(e.LogLevel=f={})),e.$ej=f.Info;function t(d,b,y){switch(b){case f.Trace:d.trace(y);break;case f.Debug:d.debug(y);break;case f.Info:d.info(y);break;case f.Warning:d.warn(y);break;case f.Error:d.error(y);break;case f.Off:break;default:throw new Error(`Invalid log level ${b}`)}}e.log=t;function i(d,b=!1){let y="";for(let C=0;C<d.length;C++){let B=d[C];if(B instanceof Error&&(B=(0,E.$Ei)(B,b)),typeof B=="object")try{B=JSON.stringify(B)}catch{}y+=(C>0?" ":"")+B}return y}class n extends M.$Rc{constructor(){super(...arguments),this.b=e.$ej,this.c=this.B(new L.$Od),this.onDidChangeLogLevel=this.c.event}setLevel(b){this.b!==b&&(this.b=b,this.c.fire(this.b))}getLevel(){return this.b}f(b){return this.b!==f.Off&&this.b<=b}}e.$gj=n;class u extends n{constructor(b){super(),this.h=b}f(b){return this.h||super.f(b)}trace(b,...y){this.f(f.Trace)&&this.g(f.Trace,i([b,...y],!0))}debug(b,...y){this.f(f.Debug)&&this.g(f.Debug,i([b,...y]))}info(b,...y){this.f(f.Info)&&this.g(f.Info,i([b,...y]))}warn(b,...y){this.f(f.Warning)&&this.g(f.Warning,i([b,...y]))}error(b,...y){if(this.f(f.Error))if(b instanceof Error){const C=Array.prototype.slice.call(arguments);C[0]=b.stack,this.g(f.Error,i(C))}else this.g(f.Error,i([b,...y]))}flush(){}}e.$hj=u;class a extends n{constructor(b=e.$ej){super(),this.setLevel(b),this.g=!$.$j}trace(b,...y){this.f(f.Trace)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,b,...y):console.log(`[main ${v()}]`,b,...y))}debug(b,...y){this.f(f.Debug)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,b,...y):console.log(`[main ${v()}]`,b,...y))}info(b,...y){this.f(f.Info)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,b,...y):console.log(`[main ${v()}]`,b,...y))}warn(b,...y){this.f(f.Warning)&&(this.g?console.warn(`\x1B[93m[main ${v()}]\x1B[0m`,b,...y):console.warn(`[main ${v()}]`,b,...y))}error(b,...y){this.f(f.Error)&&(this.g?console.error(`\x1B[91m[main ${v()}]\x1B[0m`,b,...y):console.error(`[main ${v()}]`,b,...y))}dispose(){}flush(){}}e.$ij=a;class l extends n{constructor(b=e.$ej,y=!0){super(),this.g=y,this.setLevel(b)}trace(b,...y){this.f(f.Trace)&&(this.g?console.log("%cTRACE","color: #888",b,...y):console.log(b,...y))}debug(b,...y){this.f(f.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",b,...y):console.log(b,...y))}info(b,...y){this.f(f.Info)&&(this.g?console.log("%c INFO","color: #33f",b,...y):console.log(b,...y))}warn(b,...y){this.f(f.Warning)&&(this.g?console.log("%c WARN","color: #993",b,...y):console.log(b,...y))}error(b,...y){this.f(f.Error)&&(this.g?console.log("%c  ERR","color: #f33",b,...y):console.error(b,...y))}dispose(){}flush(){}}e.$jj=l;class r extends n{constructor(b,y=e.$ej){super(),this.g=b,this.setLevel(y)}trace(b,...y){this.f(f.Trace)&&this.g.log(f.Trace,[this.h(b),...y])}debug(b,...y){this.f(f.Debug)&&this.g.log(f.Debug,[this.h(b),...y])}info(b,...y){this.f(f.Info)&&this.g.log(f.Info,[this.h(b),...y])}warn(b,...y){this.f(f.Warning)&&this.g.log(f.Warning,[this.h(b),...y])}error(b,...y){this.f(f.Error)&&this.g.log(f.Error,[this.h(b),...y])}h(b){return typeof b=="string"?b:(0,E.$Ei)(b,this.f(f.Trace))}dispose(){}flush(){}}e.$kj=r;class s extends n{constructor(b){super(),this.g=b,b.length&&this.setLevel(b[0].getLevel())}setLevel(b){for(const y of this.g)y.setLevel(b);super.setLevel(b)}trace(b,...y){for(const C of this.g)C.trace(b,...y)}debug(b,...y){for(const C of this.g)C.debug(b,...y)}info(b,...y){for(const C of this.g)C.info(b,...y)}warn(b,...y){for(const C of this.g)C.warn(b,...y)}error(b,...y){for(const C of this.g)C.error(b,...y)}flush(){for(const b of this.g)b.flush()}dispose(){for(const b of this.g)b.dispose()}}e.$lj=s;class c extends M.$Rc{constructor(b,y,C){if(super(),this.h=b,this.j=y,this.b=new R.$zc,this.c=this.B(new L.$Od),this.onDidChangeLoggers=this.c.event,this.f=this.B(new L.$Od),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new L.$Od),this.onDidChangeVisibility=this.g.event,C)for(const B of C)this.b.set(B.resource,{logger:void 0,info:B})}m(b){return(0,g.$zf)(b)?[...this.b.values()].find(y=>y.info.id===b):this.b.get(b)}getLogger(b){return this.m(b)?.logger}createLogger(b,y){const C=this.n(b),B=(0,g.$zf)(b)?b:y?.id??(0,P.$Hi)(C.toString()).toString(16);let H=this.b.get(C)?.logger;const U=y?.logLevel==="always"?f.Trace:y?.logLevel;H||(H=this.s(C,U??this.getLogLevel(C)??this.h,{...y,id:B}));const z={logger:H,info:{resource:C,id:B,logLevel:U,name:y?.name,hidden:y?.hidden,extensionId:y?.extensionId,when:y?.when}};return this.registerLogger(z.info),this.b.set(C,z),H}n(b){return(0,g.$zf)(b)?(0,D.$wg)(this.j,`${b}.log`):b}setLogLevel(b,y){if(A.URI.isUri(b)){const C=b,B=y,H=this.b.get(C);H&&B!==H.info.logLevel&&(H.info.logLevel=B===this.h?void 0:B,H.logger?.setLevel(B),this.b.set(H.info.resource,H),this.f.fire([C,B]))}else{this.h=b;for(const[C,B]of this.b.entries())this.b.get(C)?.info.logLevel===void 0&&B.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(b,y){const C=this.m(b);C&&y!==!C.info.hidden&&(C.info.hidden=!y,this.b.set(C.info.resource,C),this.g.fire([C.info.resource,y]))}getLogLevel(b){let y;return b&&(y=this.b.get(b)?.info.logLevel),y??this.h}registerLogger(b){const y=this.b.get(b.resource);y?y.info.hidden!==b.hidden&&this.setVisibility(b.resource,!b.hidden):(this.b.set(b.resource,{info:b,logger:void 0}),this.c.fire({added:[b],removed:[]}))}deregisterLogger(b){const y=this.b.get(b);y&&(y.logger&&y.logger.dispose(),this.b.delete(b),this.c.fire({added:[],removed:[y.info]}))}*getRegisteredLoggers(){for(const b of this.b.values())yield b.info}getRegisteredLogger(b){return this.b.get(b)?.info}dispose(){this.b.forEach(b=>b.logger?.dispose()),this.b.clear(),super.dispose()}}e.$mj=c;class h{constructor(){this.onDidChangeLogLevel=new L.$Od().event}setLevel(b){}getLevel(){return f.Info}trace(b,...y){}debug(b,...y){}info(b,...y){}warn(b,...y){}error(b,...y){}critical(b,...y){}dispose(){}flush(){}}e.$nj=h;class w extends h{}e.$oj=w;function m(d){if(d.verbose)return f.Trace;if(typeof d.logLevel=="string"){const b=k(d.logLevel.toLowerCase());if(b!==void 0)return b}return e.$ej}e.$pj=m;function I(d){switch(d){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Off:return"off"}}e.$qj=I;function k(d){switch(d){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Error;case"off":return f.Off}}e.$rj=k,e.$sj=new S.$$i("logLevel",I(f.Info))}),define(Ae[188],Re([1,0,6,15]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UN=void 0;class P extends E.$Rc{constructor(R,$=[]){super(),this.a=new L.$lj([R,...$]),this.B(R.onDidChangeLogLevel(D=>this.setLevel(D)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...$){this.a.trace(R,...$)}debug(R,...$){this.a.debug(R,...$)}info(R,...$){this.a.info(R,...$)}warn(R,...$){this.a.warn(R,...$)}error(R,...$){this.a.error(R,...$)}flush(){this.a.flush()}}e.$UN=P}),define(Ae[98],Re([1,0,31,154,4]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var M;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(M||(e.MarkerTag=M={}));var R;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(D){function g(p,f){return f-p}D.compare=g;const A=Object.create(null);A[D.Error]=(0,L.localize)(0,null),A[D.Warning]=(0,L.localize)(1,null),A[D.Info]=(0,L.localize)(2,null);function S(p){return A[p]||""}D.toString=S;function o(p){switch(p){case E.default.Error:return D.Error;case E.default.Warning:return D.Warning;case E.default.Info:return D.Info;case E.default.Ignore:return D.Hint}}D.fromSeverity=o;function v(p){switch(p){case D.Error:return E.default.Error;case D.Warning:return E.default.Warning;case D.Info:return E.default.Info;case D.Hint:return E.default.Ignore}}D.toSeverity=v}(R||(e.MarkerSeverity=R={}));var $;(function(D){const g="";function A(o){return S(o,!0)}D.makeKey=A;function S(o,v){const p=[g];return o.source?p.push(o.source.replace("\xA6","\\\xA6")):p.push(g),o.code?typeof o.code=="string"?p.push(o.code.replace("\xA6","\\\xA6")):p.push(o.code.value.replace("\xA6","\\\xA6")):p.push(g),o.severity!==void 0&&o.severity!==null?p.push(R.toString(o.severity)):p.push(g),o.message&&v?p.push(o.message.replace("\xA6","\\\xA6")):p.push(g),o.startLineNumber!==void 0&&o.startLineNumber!==null?p.push(o.startLineNumber.toString()):p.push(g),o.startColumn!==void 0&&o.startColumn!==null?p.push(o.startColumn.toString()):p.push(g),o.endLineNumber!==void 0&&o.endLineNumber!==null?p.push(o.endLineNumber.toString()):p.push(g),o.endColumn!==void 0&&o.endColumn!==null?p.push(o.endColumn.toString()):p.push(g),p.push(g),p.join("\xA6")}D.makeKeyOptionalMessage=S})($||(e.IMarkerData=$={})),e.$dt=(0,P.$Th)("markerService")}),define(Ae[189],Re([1,0,5,31,4]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6u=e.$5u=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$4u=e.Severity=void 0,e.Severity=L.default,e.$4u=(0,P.$Th)("notificationService");var M;(function(A){A[A.DEFAULT=0]="DEFAULT",A[A.SILENT=1]="SILENT",A[A.URGENT=2]="URGENT"})(M||(e.NotificationPriority=M={}));var R;(function(A){A[A.WORKSPACE=0]="WORKSPACE",A[A.PROFILE=1]="PROFILE",A[A.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));var $;(function(A){A[A.OFF=0]="OFF",A[A.SILENT=1]="SILENT",A[A.ERROR=2]="ERROR"})($||(e.NotificationsFilter=$={}));class D{constructor(){this.progress=new g,this.onDidClose=E.Event.None,this.onDidChangeVisibility=E.Event.None}updateSeverity(S){}updateMessage(S){}updateActions(S){}close(){}}e.$5u=D;class g{infinite(){}done(){}total(S){}worked(S){}}e.$6u=g}),define(Ae[99],Re([1,0,13,2,4]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JU=e.$IU=e.$HU=e.$GU=e.$FU=void 0,e.$FU=(0,P.$Th)("openerService");function M(g,A){return L.URI.isUri(g)?(0,E.$3e)(g.scheme,A):(0,E.$4e)(g,A+":")}e.$GU=M;function R(g,...A){return A.some(S=>M(g,S))}e.$HU=R;function $(g,A){return g.with({fragment:`${A.startLineNumber},${A.startColumn}${A.endLineNumber?`-${A.endLineNumber}${A.endColumn?`,${A.endColumn}`:""}`:""}`})}e.$IU=$;function D(g){let A;const S=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(g.fragment);return S&&(A={startLineNumber:parseInt(S[1]),startColumn:S[2]?parseInt(S[2]):1,endLineNumber:S[4]?parseInt(S[4]):void 0,endColumn:S[4]?S[5]?parseInt(S[5]):1:void 0},g=g.with({fragment:""})),{selection:A,uri:g}}e.$JU=D}),define(Ae[190],Re([1,0,4]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uj=e.$tj=void 0,e.$tj=(0,E.$Th)("productService"),e.$uj="vscode://schemas/vscode-product"});var Ke=this&&this.__decorate||function(pe,e,E,L){var P=arguments.length,M=P<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,E):L,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(pe,e,E,L);else for(var $=pe.length-1;$>=0;$--)(R=pe[$])&&(M=(P<3?R(M):P>3?R(e,E,M):R(e,E))||M);return P>3&&M&&Object.defineProperty(e,E,M),M},Ve=this&&this.__param||function(pe,e){return function(E,L){e(E,L,pe)}};define(Ae[54],Re([1,0,12,20,6,4]),function(pe,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$av=e.$_u=e.$$u=e.$0u=e.$9u=e.$8u=e.ProgressLocation=e.$7u=void 0,e.$7u=(0,M.$Th)("progressService");var R;(function(S){S[S.Explorer=1]="Explorer",S[S.Scm=3]="Scm",S[S.Extensions=5]="Extensions",S[S.Window=10]="Window",S[S.Notification=15]="Notification",S[S.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$8u=Object.freeze({total(){},worked(){},done(){}});class ${static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(o){this.b=o}report(o){this.a=o,this.b(this.a)}}e.$9u=$;class D{get value(){return this.a}constructor(o){this.e=o}report(o){this.b?this.b.push(o):this.b=[o],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const o=this.b.shift();this.a=o,await this.e(this.a)}}finally{this.c=!1;const o=this.d;this.d=void 0,o?.()}}drain(){return this.c?new Promise(o=>{const v=this.d;this.d=()=>{v?.(),o()}}):Promise.resolve()}}e.$0u=D;let g=class extends P.$Rc{constructor(o,v){super(),this.a=new E.$gh,v.withProgress(o,p=>(this.b=p,this.c&&p.report(this.c),this.a.p)),this.B((0,P.$Pc)(()=>this.a.complete()))}report(o){this.b?this.b.report(o):this.c=o}};e.$$u=g,e.$$u=g=Ke([Ve(1,e.$7u)],g);class A extends P.$Rc{constructor(o){super(),this.g=o,this.a=0,this.b=this.B(new P.$Qc)}start(o){this.stop();const v=++this.a,p=new L.$Yd;return this.f=setTimeout(()=>{v===this.a&&(this.c=this.g.show(!0))},o),this.b.add((0,P.$Pc)(()=>clearTimeout(this.f))),this.b.add((0,P.$Pc)(()=>p.cancel())),this.b.add((0,P.$Pc)(()=>this.c?this.c.done():void 0)),{id:v,token:p.token,stop:()=>this.h(v),isCurrent:()=>this.a===v}}stop(){this.h(this.a)}h(o){this.a===o&&this.b.clear()}}e.$_u=A,e.$av=(0,M.$Th)("editorProgressService")}),define(Ae[30],Re([1,0,55,16]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kn=void 0;class P{constructor(){this.a=new Map}add(R,$){E.ok(L.$zf(R)),E.ok(L.$Bf($)),E.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,$)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$kn=new P}),define(Ae[73],Re([1,0,5,30]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=void 0,e.$ln={JSONContribution:"base.contributions.json"};function P($){return $.length>0&&$.charAt($.length-1)==="#"?$.substring(0,$.length-1):$}class M{constructor(){this.b=new E.$Od,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(D,g){this.a[P(D)]=g,this.b.fire(D)}notifySchemaChanged(D){this.b.fire(D)}getSchemaContributions(){return{schemas:this.a}}}const R=new M;L.$kn.add(e.$ln.JSONContribution,R)}),define(Ae[56],Re([1,0,18,5,16,148,40,73,30]),function(pe,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.ConfigurationScope=e.$pn=e.EditPresentationTypes=void 0;var g;(function(l){l.Multiline="multilineText",l.Singleline="singlelineText"})(g||(e.EditPresentationTypes=g={})),e.$pn={Configuration:"base.contributions.configuration"};var A;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.MACHINE=2]="MACHINE",l[l.WINDOW=3]="WINDOW",l[l.RESOURCE=4]="RESOURCE",l[l.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",l[l.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.$qn={properties:{},patternProperties:{}},e.$rn={properties:{},patternProperties:{}},e.$sn={properties:{},patternProperties:{}},e.$tn={properties:{},patternProperties:{}},e.$un={properties:{},patternProperties:{}},e.$vn={properties:{},patternProperties:{}},e.$wn="vscode://schemas/settings/resourceLanguage",e.$xn="vscode://schemas/settings/configurationDefaults";const S=D.$kn.as($.$ln.JSONContribution);class o{constructor(){this.h=new Set,this.i=new L.$Od,this.onDidSchemaChange=this.i.event,this.j=new L.$Od,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},S.registerSchema(e.$wn,this.g),this.v()}registerConfiguration(r,s=!0){this.registerConfigurations([r],s)}registerConfigurations(r,s=!0){const c=new Set;this.n(r,s,c),S.registerSchema(e.$wn,this.g),this.i.fire(),this.j.fire({properties:c})}deregisterConfigurations(r){const s=new Set;this.o(r,s),S.registerSchema(e.$wn,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:r,remove:s}){const c=new Set;this.o(s,c),this.n(r,!1,c),S.registerSchema(e.$wn,this.g),this.i.fire(),this.j.fire({properties:c})}registerDefaultConfigurations(r){const s=new Set;this.k(r,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(r,s){const c=[];for(const{overrides:h,source:w}of r)for(const m in h)if(s.add(m),e.$zn.test(m)){const I=this.a.get(m),k=I?.valuesSources??new Map;if(w)for(const C of Object.keys(h[m]))k.set(C,w);const d={...I?.value||{},...h[m]};this.a.set(m,{source:w,value:d,valuesSources:k});const b=(0,R.$xi)(m),y={type:"object",default:d,description:M.localize(1,null,b),$ref:e.$wn,defaultDefaultValue:d,source:P.$zf(w)?void 0:w,defaultValueSource:w};c.push(...f(m)),this.d[m]=y,this.b.properties[m]=y}else{this.a.set(m,{value:h[m],source:w});const I=this.d[m];I&&(this.w(m,I),this.r(m,I))}this.m(c)}deregisterDefaultConfigurations(r){const s=new Set;this.l(r,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(r,s){for(const{overrides:c,source:h}of r)for(const w in c){const m=this.a.get(w),I=P.$zf(h)?h:h?.id,k=P.$zf(m?.source)?m?.source:m?.source?.id;if(I===k)if(s.add(w),this.a.delete(w),e.$zn.test(w))delete this.d[w],delete this.b.properties[w];else{const d=this.d[w];d&&(this.w(w,d),this.r(w,d))}}this.u()}deltaConfiguration(r){let s=!1;const c=new Set;r.removedDefaults&&(this.l(r.removedDefaults,c),s=!0),r.addedDefaults&&(this.k(r.addedDefaults,c),s=!0),r.removedConfigurations&&this.o(r.removedConfigurations,c),r.addedConfigurations&&this.n(r.addedConfigurations,!1,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...r){this.i.fire()}registerOverrideIdentifiers(r){this.m(r),this.i.fire()}m(r){for(const s of r)this.h.add(s);this.u()}n(r,s,c){r.forEach(h=>{this.p(h,s,h.extensionInfo,h.restrictedProperties,void 0,c),this.c.push(h),this.q(h)})}o(r,s){const c=h=>{if(h.properties)for(const w in h.properties){s.add(w);const m=this.d[w];m?.policy?.name&&this.e.delete(m.policy.name),delete this.d[w],this.s(w,h.properties[w])}h.allOf?.forEach(w=>c(w))};for(const h of r){c(h);const w=this.c.indexOf(h);w!==-1&&this.c.splice(w,1)}}p(r,s=!0,c,h,w=3,m){w=P.$If(r.scope)?w:r.scope;const I=r.properties;if(I)for(const d in I){const b=I[d];if(s&&u(d,b)){delete I[d];continue}if(b.source=c,b.defaultDefaultValue=I[d].default,this.w(d,b),e.$zn.test(d)?b.scope=void 0:(b.scope=P.$If(b.scope)?w:b.scope,b.restricted=P.$If(b.restricted)?!!h?.includes(d):b.restricted),I[d].hasOwnProperty("included")&&!I[d].included){this.f[d]=I[d],delete I[d];continue}else this.d[d]=I[d],I[d].policy?.name&&this.e.set(I[d].policy.name,d);!I[d].deprecationMessage&&I[d].markdownDeprecationMessage&&(I[d].deprecationMessage=I[d].markdownDeprecationMessage),m.add(d)}const k=r.allOf;if(k)for(const d of k)this.p(d,s,c,h,w,m)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(r){const s=c=>{const h=c.properties;if(h)for(const m in h)this.r(m,h[m]);c.allOf?.forEach(s)};s(r)}r(r,s){switch(e.$qn.properties[r]=s,s.scope){case 1:e.$rn.properties[r]=s;break;case 2:e.$sn.properties[r]=s;break;case 6:e.$tn.properties[r]=s;break;case 3:e.$un.properties[r]=s;break;case 4:e.$vn.properties[r]=s;break;case 5:e.$vn.properties[r]=s,this.g.properties[r]=s;break}}s(r,s){switch(delete e.$qn.properties[r],s.scope){case 1:delete e.$rn.properties[r];break;case 2:delete e.$sn.properties[r];break;case 6:delete e.$tn.properties[r];break;case 3:delete e.$un.properties[r];break;case 4:case 5:delete e.$vn.properties[r],delete this.g.properties[r];break}}u(){for(const r of this.h.values()){const s=`[${r}]`,c={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.$wn};this.w(s,c),e.$qn.properties[s]=c,e.$rn.properties[s]=c,e.$sn.properties[s]=c,e.$tn.properties[s]=c,e.$un.properties[s]=c,e.$vn.properties[s]=c}}v(){const r={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.$wn};e.$qn.patternProperties[e.$yn]=r,e.$rn.patternProperties[e.$yn]=r,e.$sn.patternProperties[e.$yn]=r,e.$tn.patternProperties[e.$yn]=r,e.$un.patternProperties[e.$yn]=r,e.$vn.patternProperties[e.$yn]=r,this.i.fire()}w(r,s){const c=this.a.get(r);let h=c?.value,w=c?.source;P.$Gf(h)&&(h=s.defaultDefaultValue,w=void 0),P.$Gf(h)&&(h=i(s.type)),s.default=h,s.defaultValueSource=w}}const v="\\[([^\\]]+)\\]",p=new RegExp(v,"g");e.$yn=`^(${v})+$`,e.$zn=new RegExp(e.$yn);function f(l){const r=[];if(e.$zn.test(l)){let s=p.exec(l);for(;s?.length;){const c=s[1].trim();c&&r.push(c),s=p.exec(l)}}return(0,E.$Lb)(r)}e.$An=f;function t(l){return l.reduce((r,s)=>`${r}[${s}]`,"")}e.$Bn=t;function i(l){switch(Array.isArray(l)?l[0]:l){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Cn=i;const n=new o;D.$kn.add(e.$pn.Configuration,n);function u(l,r){return l.trim()?e.$zn.test(l)?M.localize(7,null,l):n.getConfigurationProperties()[l]!==void 0?M.localize(8,null,l):r.policy?.name&&n.getPolicyConfigurations().get(r.policy?.name)!==void 0?M.localize(9,null,l,r.policy?.name,n.getPolicyConfigurations().get(r.policy?.name)):null:M.localize(6,null)}e.$Dn=u;function a(){const l=[],r=n.getConfigurationProperties();for(const s of Object.keys(r))l.push([s,r[s].scope]);return l.push(["launch",4]),l.push(["task",4]),l}e.$En=a}),define(Ae[191],Re([1,0,18,5,119,6,28,26,16,2,40,56,30]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=void 0;function v(s){return Object.isFrozen(s)?s:$.$_m(s)}class p{constructor(c={},h=[],w=[],m){this.b=c,this.c=h,this.d=w,this.raw=m,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const c=this.raw.map(h=>{if(h instanceof p)return h;const w=new f("");return w.parseRaw(h),w.configurationModel});this.f=c.reduce((h,w)=>w===h?w:h.merge(w),c[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(c){return c?(0,A.$vi)(this.contents,c):this.contents}inspect(c,h){const w=this.rawConfiguration.getValue(c),m=h?this.rawConfiguration.getOverrideValue(c,h):void 0,I=h?this.rawConfiguration.override(h).getValue(c):w;return{value:w,override:m,merged:I}}getOverrideValue(c,h){const w=this.i(h);return w?c?(0,A.$vi)(w,c):w:void 0}getKeysForOverrideIdentifier(c){const h=[];for(const w of this.overrides)w.identifiers.includes(c)&&h.push(...w.keys);return E.$Lb(h)}getAllOverrideIdentifiers(){const c=[];for(const h of this.overrides)c.push(...h.identifiers);return E.$Lb(c)}override(c){let h=this.a.get(c);return h||(h=this.g(c),this.a.set(c,h)),h}merge(...c){const h=$.$$m(this.contents),w=$.$$m(this.overrides),m=[...this.keys],I=this.raw?.length?[...this.raw]:[this];for(const k of c)if(I.push(...k.raw?.length?k.raw:[k]),!k.isEmpty()){this.h(h,k.contents);for(const d of k.overrides){const[b]=w.filter(y=>E.$tb(y.identifiers,d.identifiers));b?(this.h(b.contents,d.contents),b.keys.push(...d.keys),b.keys=E.$Lb(b.keys)):w.push($.$$m(d))}for(const d of k.keys)m.indexOf(d)===-1&&m.push(d)}return new p(h,m,w,I.every(k=>k instanceof p)?void 0:I)}g(c){const h=this.i(c);if(!h||typeof h!="object"||!Object.keys(h).length)return this;const w={};for(const m of E.$Lb([...Object.keys(this.contents),...Object.keys(h)])){let I=this.contents[m];const k=h[m];k&&(typeof I=="object"&&typeof k=="object"?(I=$.$$m(I),this.h(I,k)):I=k),w[m]=I}return new p(w,this.keys,this.overrides)}h(c,h){for(const w of Object.keys(h)){if(w in c&&D.$Bf(c[w])&&D.$Bf(h[w])){this.h(c[w],h[w]);continue}c[w]=$.$$m(h[w])}}i(c){let h=null,w=null;const m=I=>{I&&(w?this.h(w,I):w=$.$$m(I))};for(const I of this.overrides)I.identifiers.length===1&&I.identifiers[0]===c?h=I.contents:I.identifiers.includes(c)&&m(I.contents);return m(h),w}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(c,h){this.j(c,h,!0)}setValue(c,h){this.j(c,h,!1)}removeValue(c){const h=this.keys.indexOf(c);h!==-1&&(this.keys.splice(h,1),(0,A.$ui)(this.contents,c),S.$zn.test(c)&&this.overrides.splice(this.overrides.findIndex(w=>E.$tb(w.identifiers,(0,S.$An)(c))),1))}j(c,h,w){(0,A.$ti)(this.contents,c,h,m=>console.error(m)),w=w||this.keys.indexOf(c)===-1,w&&this.keys.push(c),S.$zn.test(c)&&this.overrides.push({identifiers:(0,S.$An)(c),keys:Object.keys(this.contents[c]),contents:(0,A.$si)(this.contents[c],m=>console.error(m))})}}e.$Fn=p;class f{constructor(c){this.f=c,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new p}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(c,h){if(!D.$If(c)){const w=this.g(c);this.parseRaw(w,h)}}reparse(c){this.a&&this.parseRaw(this.a,c)}parseRaw(c,h){this.a=c;const{contents:w,keys:m,overrides:I,restricted:k,hasExcludedProperties:d}=this.h(c,h);this.b=new p(w,m,I,d?[c]:void 0),this.c=k||[]}g(c){let h={},w=null,m=[];const I=[],k=[];function d(y){Array.isArray(m)?m.push(y):w!==null&&(m[w]=y)}const b={onObjectBegin:()=>{const y={};d(y),I.push(m),m=y,w=null},onObjectProperty:y=>{w=y},onObjectEnd:()=>{m=I.pop()},onArrayBegin:()=>{const y=[];d(y),I.push(m),m=y,w=null},onArrayEnd:()=>{m=I.pop()},onLiteralValue:d,onError:(y,C,B)=>{k.push({error:y,offset:C,length:B})}};if(c)try{P.$8m(c,b),h=m[0]||{}}catch(y){console.error(`Error while parsing settings file ${this.f}: ${y}`),this.d=[y]}return h}h(c,h){const w=o.$kn.as(S.$pn.Configuration).getConfigurationProperties(),m=this.i(c,w,!0,h);c=m.raw;const I=(0,A.$si)(c,b=>console.error(`Conflict in settings file ${this.f}: ${b}`)),k=Object.keys(c),d=this.j(c,b=>console.error(`Conflict in settings file ${this.f}: ${b}`));return{contents:I,keys:k,overrides:d,restricted:m.restricted,hasExcludedProperties:m.hasExcludedProperties}}i(c,h,w,m){let I=!1;if(!m?.scopes&&!m?.skipRestricted&&!m?.exclude?.length)return{raw:c,restricted:[],hasExcludedProperties:I};const k={},d=[];for(const b in c)if(S.$zn.test(b)&&w){const y=this.i(c[b],h,!1,m);k[b]=y.raw,I=I||y.hasExcludedProperties,d.push(...y.restricted)}else{const y=h[b],C=y?typeof y.scope<"u"?y.scope:3:void 0;y?.restricted&&d.push(b),!m.exclude?.includes(b)&&(m.include?.includes(b)||(C===void 0||m.scopes===void 0||m.scopes.includes(C))&&!(m.skipRestricted&&y?.restricted))?k[b]=c[b]:I=!0}return{raw:k,restricted:d,hasExcludedProperties:I}}j(c,h){const w=[];for(const m of Object.keys(c))if(S.$zn.test(m)){const I={};for(const k in c[m])I[k]=c[m][k];w.push({identifiers:(0,S.$An)(m),keys:Object.keys(I),contents:(0,A.$si)(I,h)})}return w}}e.$Gn=f;class t extends M.$Rc{constructor(c,h,w,m){super(),this.c=c,this.f=h,this.g=m,this.b=this.B(new L.$Od),this.onDidChange=this.b.event,this.a=new f(this.c.toString()),this.B(this.g.watch(w.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(L.Event.any(L.Event.filter(this.g.onDidFilesChange,I=>I.contains(this.c)),L.Event.filter(this.g.onDidRunOperation,I=>(I.isOperation(0)||I.isOperation(3)||I.isOperation(1)||I.isOperation(4))&&w.isEqual(I.resource,c)))(()=>this.b.fire()))}async loadConfiguration(){try{const c=await this.g.readFile(this.c);return this.a.parse(c.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new p}}reparse(c){return c&&(this.f=c),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Hn=t;class i{constructor(c,h,w,m,I,k,d,b,y,C,B,H,U){this.a=c,this.b=h,this.c=w,this.overrideIdentifiers=m,this.d=I,this.f=k,this.g=d,this.h=b,this.i=y,this.j=C,this.k=B,this.l=H,this.m=U}get value(){return v(this.c)}n(c,h,w){const m=c.inspect(h,w);return{get value(){return v(m.value)},get override(){return v(m.override)},get merged(){return v(m.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class n{constructor(c,h,w,m,I=new p,k=new p,d=new R.$zc,b=new p,y=new R.$zc){this.c=c,this.d=h,this.f=w,this.g=m,this.h=I,this.i=k,this.j=d,this.l=b,this.m=y,this.a=null,this.b=new R.$zc,this.n=null}getValue(c,h,w){return this.q(c,h,w).getValue(c)}updateValue(c,h,w={}){let m;w.resource?(m=this.m.get(w.resource),m||(m=new p,this.m.set(w.resource,m))):m=this.l,h===void 0?m.removeValue(c):m.setValue(c,h),w.resource||(this.a=null)}inspect(c,h,w){const m=this.q(c,h,w),I=this.u(h.resource,w),k=h.resource?this.m.get(h.resource)||this.l:this.l,d=new Set;for(const b of m.overrides)for(const y of b.identifiers)m.getOverrideValue(c,y)!==void 0&&d.add(y);return new i(c,h,m.getValue(c),d.size?[...d]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,w?this.i:void 0,I||void 0,k)}keys(c){const h=this.u(void 0,c);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:h?h.keys.slice(0):[]}}updateDefaultConfiguration(c){this.c=c,this.a=null,this.b.clear()}updatePolicyConfiguration(c){this.d=c}updateApplicationConfiguration(c){this.f=c,this.a=null,this.b.clear()}updateLocalUserConfiguration(c){this.g=c,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(c){this.h=c,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(c){this.i=c,this.a=null,this.b.clear()}updateFolderConfiguration(c,h){this.j.set(c,h),this.b.delete(c)}deleteFolderConfiguration(c){this.p.delete(c),this.b.delete(c)}compareAndUpdateDefaultConfiguration(c,h){const w=[];if(!h){const{added:m,updated:I,removed:k}=l(this.c,c);h=[...m,...I,...k]}for(const m of h)for(const I of(0,S.$An)(m)){const k=this.c.getKeysForOverrideIdentifier(I),d=c.getKeysForOverrideIdentifier(I),b=[...d.filter(y=>k.indexOf(y)===-1),...k.filter(y=>d.indexOf(y)===-1),...k.filter(y=>!$.$cn(this.c.override(I).getValue(y),c.override(I).getValue(y)))];w.push([I,b])}return this.updateDefaultConfiguration(c),{keys:h,overrides:w}}compareAndUpdatePolicyConfiguration(c){const{added:h,updated:w,removed:m}=l(this.d,c),I=[...h,...w,...m];return I.length&&this.updatePolicyConfiguration(c),{keys:I,overrides:[]}}compareAndUpdateApplicationConfiguration(c){const{added:h,updated:w,removed:m,overrides:I}=l(this.applicationConfiguration,c),k=[...h,...w,...m];return k.length&&this.updateApplicationConfiguration(c),{keys:k,overrides:I}}compareAndUpdateLocalUserConfiguration(c){const{added:h,updated:w,removed:m,overrides:I}=l(this.localUserConfiguration,c),k=[...h,...w,...m];return k.length&&this.updateLocalUserConfiguration(c),{keys:k,overrides:I}}compareAndUpdateRemoteUserConfiguration(c){const{added:h,updated:w,removed:m,overrides:I}=l(this.remoteUserConfiguration,c),k=[...h,...w,...m];return k.length&&this.updateRemoteUserConfiguration(c),{keys:k,overrides:I}}compareAndUpdateWorkspaceConfiguration(c){const{added:h,updated:w,removed:m,overrides:I}=l(this.workspaceConfiguration,c),k=[...h,...w,...m];return k.length&&this.updateWorkspaceConfiguration(c),{keys:k,overrides:I}}compareAndUpdateFolderConfiguration(c,h){const w=this.p.get(c),{added:m,updated:I,removed:k,overrides:d}=l(w,h),b=[...m,...I,...k];return(b.length||!w)&&this.updateFolderConfiguration(c,h),{keys:b,overrides:d}}compareAndDeleteFolderConfiguration(c){const h=this.p.get(c);if(!h)throw new Error("Unknown folder");this.deleteFolderConfiguration(c);const{added:w,updated:m,removed:I,overrides:k}=l(h,void 0);return{keys:[...w,...m,...I],overrides:k}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(c,h,w){let m=this.r(h,w);return h.overrideIdentifier&&(m=m.override(h.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(c)!==void 0&&(m=m.merge(this.d)),m}r({resource:c},h){let w=this.s();if(h&&c){const m=h.getFolder(c);m&&(w=this.t(m.uri)||w);const I=this.m.get(c);I&&(w=w.merge(I))}return w}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(c){let h=this.b.get(c);if(!h){const w=this.s(),m=this.j.get(c);m?(h=w.merge(m),this.b.set(c,h)):h=w}return h}u(c,h){if(h&&c){const w=h.getFolder(c);if(w)return this.j.get(w.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((c,h)=>{const{contents:w,overrides:m,keys:I}=this.j.get(h);return c.push([h,{contents:w,overrides:m,keys:I}]),c},[])}}allKeys(){const c=new Set;return this.c.keys.forEach(h=>c.add(h)),this.userConfiguration.keys.forEach(h=>c.add(h)),this.i.keys.forEach(h=>c.add(h)),this.j.forEach(h=>h.keys.forEach(w=>c.add(w))),[...c.values()]}v(){const c=new Set;return this.c.getAllOverrideIdentifiers().forEach(h=>c.add(h)),this.userConfiguration.getAllOverrideIdentifiers().forEach(h=>c.add(h)),this.i.getAllOverrideIdentifiers().forEach(h=>c.add(h)),this.j.forEach(h=>h.getAllOverrideIdentifiers().forEach(w=>c.add(w))),[...c.values()]}w(c){const h=new Set;return this.c.getKeysForOverrideIdentifier(c).forEach(w=>h.add(w)),this.userConfiguration.getKeysForOverrideIdentifier(c).forEach(w=>h.add(w)),this.i.getKeysForOverrideIdentifier(c).forEach(w=>h.add(w)),this.j.forEach(w=>w.getKeysForOverrideIdentifier(c).forEach(m=>h.add(m))),[...h.values()]}static parse(c){const h=this.x(c.defaults),w=this.x(c.policy),m=this.x(c.application),I=this.x(c.user),k=this.x(c.workspace),d=c.folders.reduce((b,y)=>(b.set(g.URI.revive(y[0]),this.x(y[1])),b),new R.$zc);return new n(h,w,m,I,new p,k,d,new p,new R.$zc)}static x(c){return new p(c.contents,c.keys,c.overrides)}}e.$In=n;function u(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const c=new Set,h=new Map;for(const m of s)m.keys.forEach(I=>c.add(I)),m.overrides.forEach(([I,k])=>{const d=(0,R.$wc)(h,I,new Set);k.forEach(b=>d.add(b))});const w=[];return h.forEach((m,I)=>w.push([I,[...m.values()]])),{keys:[...c.values()],overrides:w}}e.$Jn=u;class a{constructor(c,h,w,m){this.change=c,this.f=h,this.g=w,this.h=m,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const I of c.keys)this.affectedKeys.add(I);for(const[,I]of c.overrides)for(const k of I)this.affectedKeys.add(k);this.d=this.a;for(const I of this.affectedKeys)this.d+=I+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=n.parse(this.f.data)),this.i}affectsConfiguration(c,h){const w=this.a+c,m=this.d.indexOf(w);if(m<0)return!1;const I=m+w.length;if(I>=this.d.length)return!1;const k=this.d.charCodeAt(I);if(k!==this.b&&k!==this.c)return!1;if(h){const d=this.previousConfiguration?this.previousConfiguration.getValue(c,h,this.f?.workspace):void 0,b=this.g.getValue(c,h,this.h);return!$.$cn(d,b)}return!0}}e.$Kn=a;function l(s,c){const{added:h,removed:w,updated:m}=r(c?.rawConfiguration,s?.rawConfiguration),I=[],k=s?.getAllOverrideIdentifiers()||[],d=c?.getAllOverrideIdentifiers()||[];if(c){const b=d.filter(y=>!k.includes(y));for(const y of b)I.push([y,c.getKeysForOverrideIdentifier(y)])}if(s){const b=k.filter(y=>!d.includes(y));for(const y of b)I.push([y,s.getKeysForOverrideIdentifier(y)])}if(c&&s){for(const b of k)if(d.includes(b)){const y=r({contents:s.getOverrideValue(void 0,b)||{},keys:s.getKeysForOverrideIdentifier(b)},{contents:c.getOverrideValue(void 0,b)||{},keys:c.getKeysForOverrideIdentifier(b)});I.push([b,[...y.added,...y.removed,...y.updated]])}}return{added:h,removed:w,updated:m,overrides:I}}function r(s,c){const h=s?c?s.keys.filter(I=>c.keys.indexOf(I)===-1):[...s.keys]:[],w=c?s?c.keys.filter(I=>s.keys.indexOf(I)===-1):[...c.keys]:[],m=[];if(s&&c){for(const I of c.keys)if(s.keys.indexOf(I)!==-1){const k=(0,A.$vi)(c.contents,I),d=(0,A.$vi)(s.contents,I);$.$cn(k,d)||m.push(I)}}return{added:h,removed:w,updated:m}}}),define(Ae[100],Re([1,0,11,4]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xk=e.$Wk=e.RemoteAuthorityResolverErrorCode=e.$Vk=e.$Uk=e.RemoteConnectionType=e.$Tk=void 0,e.$Tk=(0,L.$Th)("remoteAuthorityResolverService");var P;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(P||(e.RemoteConnectionType=P={}));class M{constructor(S){this.id=S,this.type=1}toString(){return`Managed(${this.id})`}}e.$Uk=M;class R{constructor(S,o){this.host=S,this.port=o,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Vk=R;var $;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})($||(e.RemoteAuthorityResolverErrorCode=$={}));class D extends E.$ab{static isNotAvailable(S){return S instanceof D&&S._code===$.NotAvailable}static isTemporarilyNotAvailable(S){return S instanceof D&&S._code===$.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof D&&S._code===$.NoResolverFound}static isInvalidAuthority(S){return S instanceof D&&S._code===$.InvalidAuthority}static isHandled(S){return S instanceof D&&S.isHandled}constructor(S,o=$.Unknown,v){super(S),this._message=S,this._code=o,this._detail=v,this.isHandled=o===$.NotAvailable&&v===!0,Object.setPrototypeOf(this,D.prototype)}}e.$Wk=D;function g(A){const S=A.indexOf("+");return S===-1?A:A.substring(0,S)}e.$Xk=g}),define(Ae[57],Re([1,0,14]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3k=e.$2k=e.$1k=e.$Zk=e.$Yk=void 0;function L(g){return g.scheme===E.Schemas.vscodeRemote?g.authority:void 0}e.$Yk=L;function P(g){if(!g)return;const A=g.indexOf("+");return A<0?g:g.substr(0,A)}e.$Zk=P;function M(g){return`/${g.quality??"oss"}-${g.commit??"dev"}`}e.$1k=M;function R(g){const{host:A,port:S}=D(g);if(typeof S>"u")throw new Error("Remote authority doesn't contain a port!");return{host:A,port:S}}e.$2k=R;function $(g,A){let{host:S,port:o}=D(g);return typeof o>"u"&&(o=A),{host:S,port:o}}e.$3k=$;function D(g){const A=g.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(A)return{host:A[1],port:parseInt(A[2],10)};const S=g.match(/^(\[[0-9a-z:]+\])$/);if(S)return{host:S[1],port:void 0};const o=g.match(/(.*):(\d+)$/);return o?{host:o[1],port:parseInt(o[2],10)}:{host:g,port:void 0}}}),define(Ae[22],Re([1,0,13,4,57]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.TargetPlatform=e.ExtensionType=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=void 0,e.$4l="extensions.user.cache",e.$5l="extensions.builtin.cache",e.$6l="undefined_publisher",e.$7l=["ui","workspace","web"];function M(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.$8l=M,e.$9l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(R||(e.ExtensionType=R={}));var $;(function(f){f.WIN32_X64="win32-x64",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})($||(e.TargetPlatform=$={}));class D{constructor(t){this.value=t,this._lower=t.toLowerCase()}static equals(t,i){if(typeof t>"u"||t===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof t=="string"||typeof i=="string"){const n=typeof t=="string"?t:t.value,u=typeof i=="string"?i:i.value;return E.$3e(n,u)}return t._lower===i._lower}static toKey(t){return typeof t=="string"?t.toLowerCase():t._lower}}e.$0l=D;class g{get size(){return this.c.size}constructor(t){if(this.c=new Set,t)for(const i of t)this.add(i)}add(t){this.c.add(D.toKey(t))}delete(t){return this.c.delete(D.toKey(t))}has(t){return this.c.has(D.toKey(t))}}e.$$l=g;class A{constructor(){this.c=new Map}clear(){this.c.clear()}delete(t){this.c.delete(D.toKey(t))}get(t){return this.c.get(D.toKey(t))}has(t){return this.c.has(D.toKey(t))}set(t,i){this.c.set(D.toKey(t),i)}values(){return this.c.values()}forEach(t){this.c.forEach(t)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$_l=A;function S(f){return o(f)}e.$am=S;function o(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.$bm=o;function v(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.$cm=v;function p(f,t){if(t){const i=`onResolveRemoteAuthority:${(0,P.$Zk)(t)}`;return!!f.activationEvents?.includes(i)}return!1}e.$dm=p,e.$em=(0,L.$Th)("IBuiltinExtensionsScannerService")}),define(Ae[101],Re([1,0,11,22]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aF=e.$_E=void 0;class P{constructor(){this.a=new Map,this.b=new WeakMap}register(R,$){this.a.set(R,$)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const $=Object.create(null);for(const D of R){const g=this.readActivationEvents(D);g.length>0&&($[L.$0l.toKey(D.identifier)]=g)}return $}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const $=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let D=0;D<$.length;D++)$[D]==="onUri"&&($[D]=`onUri:${L.$0l.toKey(R.identifier)}`);if(!R.contributes)return $;for(const D in R.contributes){const g=this.a.get(D);if(!g)continue;const A=R.contributes[D],S=Array.isArray(A)?A:[A];try{g(S,$)}catch(o){(0,E.$Z)(o)}}return $}}e.$_E=P,e.$aF=new P}),define(Ae[192],Re([1,0,21,74,38]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mo=e.$lo=void 0;function M(D){if(E.$u===2&&/^penguin(\.|$)/i.test(D))return"chromebook"}function R(D,g,A,S,o,v,p,f,t){const i=Object.create(null);i["common.machineId"]=v,i["common.sqmId"]=p,i.sessionID=(0,P.$fg)()+Date.now(),i.commitHash=S,i.version=o,i["common.platformVersion"]=(D||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),i["common.platform"]=(0,E.$i)(E.$u),i["common.nodePlatform"]=L.$cc,i["common.nodeArch"]=A,i["common.product"]=t||"desktop",f&&(i["common.msftInternal"]=f);let n=0;const u=Date.now();Object.defineProperties(i,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-u,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),E.$m&&(i["common.snap"]="true");const a=M(g);return a&&(i["common.platformDetail"]=a),i}e.$lo=R;function $(D){const g=L.env.USERDNSDOMAIN;if(!g)return!1;const A=g.toLowerCase();return D.some(S=>A===S)}e.$mo=$}),define(Ae[193],Re([1,0,4]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$ql=e.$pl=e.$ol=e.$nl=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=e.$hl=e.$gl=void 0,e.$gl=(0,E.$Th)("telemetryService"),e.$hl=(0,E.$Th)("customEndpointTelemetryService"),e.$il="telemetry.currentSessionDate",e.$jl="telemetry.firstSessionDate",e.$kl="telemetry.lastSessionDate",e.$ll="telemetry.machineId",e.$ml="telemetry.sqmId",e.$nl="telemetry",e.$ol="telemetry.telemetryLevel",e.$pl="telemetry.enableCrashReporter",e.$ql="telemetry.enableTelemetry";var L;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(L||(e.TelemetryLevel=L={}));var P;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(P||(e.TelemetryConfiguration=P={}))}),define(Ae[58],Re([1,0,26,16,5,40,57,192,193]),function(pe,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=void 0;class g{constructor(w){this.value=w,this.isTrustedTelemetryValue=!0}}e.$no=g;class A{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$oo=A,e.$po=new A;class S{async publicLog(w,m,I){}async publicLogError(w,m,I){}}e.$qo=S,e.$ro="telemetry",e.$so="extensionTelemetryLog",e.$to={log:()=>null,flush:()=>Promise.resolve(null)};function o(h,w){return P.Event.debounce(w.onDidChangeConfiguration,(I,k)=>{const d=I?new Set([...I.affectedKeys,...k.affectedKeys]):k.affectedKeys;return{...k,affectedKeys:d}},1e3,!0)(I=>{I.source!==7&&h.publicLog2("updateConfiguration",{configurationSource:(0,M.$qi)(I.source),configurationKeys:Array.from(I.affectedKeys)})})}e.$uo=o;function v(h,w){return!w.isBuilt&&!w.disableTelemetry?!0:!(w.disableTelemetry||!h.enableTelemetry)}e.$vo=v;function p(h,w){return w.extensionTestsLocationURI?!0:!(w.isBuilt||w.disableTelemetry||h.enableTelemetry&&h.aiConfig?.ariaKey)}e.$wo=p;function f(h){const w=h.getValue(D.$ol),m=h.getValue(D.$pl);if(h.getValue(D.$ql)===!1||m===!1)return 0;switch(w??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$xo=f;function t(h){const w={},m={},I={};u(h,I);for(let k in I){k=k.length>150?k.substr(k.length-149):k;const d=I[k];typeof d=="number"?m[k]=d:typeof d=="boolean"?m[k]=d?1:0:typeof d=="string"?(d.length>8192&&console.warn(`Telemetry property: ${k} has been trimmed to 8192, the original length is ${d.length}`),w[k]=d.substring(0,8191)):typeof d<"u"&&d!==null&&(w[k]=d)}return{properties:w,measurements:m}}e.$yo=t;const i=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function n(h){if(!h)return"none";const w=(0,R.$Zk)(h);return i.has(w)?w:"other"}e.$zo=n;function u(h,w,m=0,I){if(h)for(const k of Object.getOwnPropertyNames(h)){const d=h[k],b=I?I+k:k;Array.isArray(d)?w[b]=(0,E.$dn)(d):d instanceof Date?w[b]=d.toISOString():(0,L.$Bf)(d)?m<2?u(d,w,m+1,b+"."):w[b]=(0,E.$dn)(d):w[b]=d}}function a(h,w){const m=h.msftInternalDomains||[],I=w.getValue("telemetry.internalTesting");return(0,$.$mo)(m)||I}e.$Ao=a;function l(h){return[h.appRoot,h.extensionsPath,h.userHome.fsPath,h.tmpDir.fsPath,h.userDataPath]}e.$Bo=l;function r(h,w){if(!h||!h.includes("/")&&!h.includes("\\"))return h;let m=h;const I=[];for(const y of w)for(;;){const C=y.exec(h);if(!C)break;I.push([C.index,y.lastIndex])}const k=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,d=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let b=0;for(m="";;){const y=d.exec(h);if(!y)break;const C=I.some(([B,H])=>y.index<H&&B<d.lastIndex);!k.test(y[0])&&!C&&(m+=h.substring(b,y.index)+"<REDACTED: user-file-path>",b=d.lastIndex)}return b<h.length&&(m+=h.substr(b)),m}function s(h){if(!h)return h;const w=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const m of w)if(m.regex.test(h))return`<REDACTED: ${m.label}>`;return h}function c(h,w){return(0,E.$an)(h,m=>{if(m instanceof g||Object.hasOwnProperty.call(m,"isTrustedTelemetryValue"))return m.value;if(typeof m=="string"){let I=m.replaceAll("%20"," ");I=r(I,w);for(const k of w)I=I.replace(k,"");return I=s(I),I}})}e.$Co=c}),define(Ae[194],Re([1,0,13,96,22,21,2,11,74,58]),function(pe,e,E,L,P,M,R,$,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=void 0;function A(c,h){return c.uuid&&h.uuid?c.uuid===h.uuid:c.id===h.id?!0:(0,E.$Xe)(c.id,h.id)===0}e.$Do=A;const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class o{static create(h){const w=h.manifest?h.manifest.version:h.version,m=h.manifest?h.targetPlatform:h.properties.targetPlatform;return new o(h.identifier,w,m)}static parse(h){const w=S.exec(h);return w&&w[1]&&w[2]?new o({id:w[1]},w[2],w[4]||void 0):null}constructor(h,w,m="undefined"){this.version=w,this.targetPlatform=m,this.id=h.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(h){return h instanceof o?A(this,h)&&this.version===h.version&&this.targetPlatform===h.targetPlatform:!1}}e.$Eo=o;const v=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function p(c){const h=v.exec(c);return h&&h[1]?[t(h[1]),h[2]]:[t(c),void 0]}e.$Fo=p;function f(c,h){return`${c}.${h}`}e.$Go=f;function t(c){return c.toLowerCase()}e.$Ho=t;function i(c,h){return t(f(c??P.$6l,h))}e.$Io=i;function n(c,h){const w=[],m=I=>{for(const k of w)if(k.some(d=>A(h(d),h(I))))return k;return null};for(const I of c){const k=m(I);k?k.push(I):w.push([I])}return w}e.$Jo=n;function u(c){return{id:c.identifier.id,name:c.manifest.name,galleryId:null,publisherId:c.publisherId,publisherName:c.manifest.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:c.manifest.extensionDependencies&&c.manifest.extensionDependencies.length>0}}e.$Ko=u;function a(c){return{id:new g.$no(c.identifier.id),name:new g.$no(c.name),galleryId:c.identifier.uuid,publisherId:c.publisherId,publisherName:c.publisher,publisherDisplayName:c.publisherDisplayName,isPreReleaseVersion:c.properties.isPreReleaseVersion,dependencies:!!(c.properties.dependencies&&c.properties.dependencies.length>0),isSigned:c.isSigned,...c.telemetryData}}e.$Lo=a,e.$Mo=new P.$0l("pprice.better-merge");function l(c,h){const w=[],m=h.manifest.extensionDependencies?.slice(0)??[];for(;m.length;){const I=m.shift();if(I&&w.every(k=>!A(k.identifier,{id:I}))){const k=c.filter(d=>A(d.identifier,{id:I}));k.length===1&&(w.push(k[0]),m.push(...k[0].manifest.extensionDependencies?.slice(0)??[]))}}return w}e.$No=l;async function r(c,h){if(!M.$l)return!1;let w;try{w=(await c.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{w=(await c.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(I){h.debug("Error while getting the os-release file.",(0,$.$9)(I))}}return!!w&&(w.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(c,h){const w=await r(c,h),m=(0,L.$0n)(w?"alpine":M.$u,D.$dc);return h.debug("ComputeTargetPlatform:",m),m}e.$Oo=s}),define(Ae[195],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tr=e.$sr=e.$rr=e.$qr=e.$pr=e.$or=void 0;function E(D){return[...D.entries()]}e.$or=E;function L(D){return D?[...D.entries()]:[]}e.$pr=L;function P(D){return new Map(D)}e.$qr=P;function M(D){return new Map(D??[])}e.$rr=M;function R(D){return Array.from(D.entries()).map(g=>[g[0],E(g[1].map),L(g[1].descriptionMap)])}e.$sr=R;function $(D){return new Map(D.map(g=>[g[0],{map:P(g[1]),descriptionMap:M(g[2])}]))}e.$tr=$}),define(Ae[196],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eqb=void 0;class E{constructor(P){this.b=P,this.a=new Map}dispose(){for(const P of this.a.values())P.dispose()}startBuffering(P,M,R=5){const $=M(D=>{const g=typeof D=="string"?D:D.data;let A=this.a.get(P);if(A){A.data.push(g);return}const S=setTimeout(()=>this.flushBuffer(P),R);A={data:[g],timeoutId:S,dispose:()=>{clearTimeout(S),this.flushBuffer(P),$.dispose()}},this.a.set(P,A)});return $}stopBuffering(P){this.a.get(P)?.dispose()}flushBuffer(P){const M=this.a.get(P);M&&(this.a.delete(P),this.b(P,M.data.join("")))}}e.$eqb=E}),define(Ae[197],Re([1,0,12,90,45,5,16,2,155,73,30]),function(pe,e,E,L,P,M,R,$,D,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ew=e.$dw=e.$cw=e.$bw=e.$aw=e.$_v=e.$$v=e.$0v=e.IconFontDefinition=e.IconContribution=e.$9v=void 0,e.$9v={IconContribution:"base.contributions.icons"};var S;(function(a){function l(r,s){let c=r.defaults;for(;P.ThemeIcon.isThemeIcon(c);){const h=p.getIcon(c.id);if(!h)return;c=h.defaults}return c}a.getDefinition=l})(S||(e.IconContribution=S={}));var o;(function(a){function l(s){return{weight:s.weight,style:s.style,src:s.src.map(c=>({format:c.format,location:c.location.toString()}))}}a.toJSONObject=l;function r(s){const c=h=>(0,R.$zf)(h)?h:void 0;if(s&&Array.isArray(s.src)&&s.src.every(h=>(0,R.$zf)(h.format)&&(0,R.$zf)(h.location)))return{weight:c(s.weight),style:c(s.style),src:s.src.map(h=>({format:h.format,location:$.URI.parse(h.location)}))}}a.fromJSONObject=r})(o||(e.IconFontDefinition=o={}));class v{constructor(){this.a=new M.$Od,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,D.localize)(0,null)},fontCharacter:{type:"string",description:(0,D.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${P.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(l,r,s,c){const h=this.b[l];if(h){if(s&&!h.description){h.description=s,this.d.properties[l].markdownDescription=`${s} $(${l})`;const I=this.e.enum.indexOf(l);I!==-1&&(this.e.enumDescriptions[I]=s),this.a.fire()}return h}const w={id:l,description:s,defaults:r,deprecationMessage:c};this.b[l]=w;const m={$ref:"#/definitions/icons"};return c&&(m.deprecationMessage=c),s&&(m.markdownDescription=`${s}: $(${l})`),this.d.properties[l]=m,this.e.enum.push(l),this.e.enumDescriptions.push(s||""),this.a.fire(),{id:l}}deregisterIcon(l){delete this.b[l],delete this.d.properties[l];const r=this.e.enum.indexOf(l);r!==-1&&(this.e.enum.splice(r,1),this.e.enumDescriptions.splice(r,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(l=>this.b[l])}getIcon(l){return this.b[l]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(l,r){const s=this.f[l];return s||(this.f[l]=r,this.a.fire(),r)}deregisterIconFont(l){delete this.f[l]}getIconFont(l){return this.f[l]}toString(){const l=(h,w)=>h.id.localeCompare(w.id),r=h=>{for(;P.ThemeIcon.isThemeIcon(h.defaults);)h=this.b[h.defaults.id];return`codicon codicon-${h?h.id:""}`},s=[];s.push("| preview     | identifier                        | default codicon ID                | description"),s.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const c=Object.keys(this.b).map(h=>this.b[h]);for(const h of c.filter(w=>!!w.description).sort(l))s.push(`|<i class="${r(h)}"></i>|${h.id}|${P.ThemeIcon.isThemeIcon(h.defaults)?h.defaults.id:h.id}|${h.description||""}|`);s.push("| preview     | identifier                        "),s.push("| ----------- | --------------------------------- |");for(const h of c.filter(w=>!P.ThemeIcon.isThemeIcon(w.defaults)).sort(l))s.push(`|<i class="${r(h)}"></i>|${h.id}|`);return s.join(`
`)}}const p=new v;A.$kn.add(e.$9v.IconContribution,p);function f(a,l,r,s){return p.registerIcon(a,l,r,s)}e.$0v=f;function t(){return p}e.$$v=t;function i(){const a=(0,L.$Wj)();for(const l in a){const r="\\"+a[l].toString(16);p.registerIcon(l,{fontCharacter:r})}}i(),e.$_v="vscode://schemas/icons";const n=A.$kn.as(g.$ln.JSONContribution);n.registerSchema(e.$_v,p.getIconSchema());const u=new E.$8g(()=>n.notifySchemaChanged(e.$_v),200);p.onDidChange(()=>{u.isScheduled()||u.schedule()}),e.$aw=f("widget-close",L.$Yj.close,(0,D.localize)(2,null)),e.$bw=f("goto-previous-location",L.$Yj.arrowUp,(0,D.localize)(3,null)),e.$cw=f("goto-next-location",L.$Yj.arrowDown,(0,D.localize)(4,null)),e.$dw=P.ThemeIcon.modify(L.$Yj.sync,"spin"),e.$ew=P.ThemeIcon.modify(L.$Yj.loading,"spin")}),define(Ae[198],Re([1,0,5,40,4,15]),function(pe,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lv=e.$kv=e.$jv=e.$iv=e.$hv=e.$gv=e.$fv=e.$ev=e.ProvidedOnAutoForward=e.$dv=e.TunnelPrivacyId=e.TunnelProtocol=e.$cv=e.$bv=void 0,e.$bv=(0,P.$Th)("tunnelService"),e.$cv=(0,P.$Th)("sharedTunnelsService");var R;(function(t){t.Http="http",t.Https="https"})(R||(e.TunnelProtocol=R={}));var $;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})($||(e.TunnelPrivacyId=$={}));function D(t){return!!t.forwardPort}e.$dv=D;var g;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(g||(e.ProvidedOnAutoForward=g={}));function A(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(i)return{address:i[1],port:+i[2]}}e.$ev=A,e.$fv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function S(t){return e.$fv.indexOf(t)>=0}e.$gv=S,e.$hv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function o(t){return e.$hv.indexOf(t)>=0}e.$iv=o;function v(t,i,n,u){if(n===1)return!1;if(n===2&&o(i)){const a=/(\d+)\.(\d+)\.(\d+)/g.exec(u);if(a?.length===4&&parseInt(a[1])>=18)return!1}return t<1024}e.$jv=v;class p{constructor(i,n,u){this.remoteAddress=i,this.localAddress=n,this.b=u,this.a=new E.$Od,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$kv=p;let f=class{constructor(i,n){this.j=i,this.k=n,this.a=new E.$Od,this.onTunnelOpened=this.a.event,this.b=new E.$Od,this.onTunnelClosed=this.b.event,this.c=new E.$Od,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const i=this.k.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.h=i.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const i=[],n=Array.from(this.e.values());for(const u of n){const a=Array.from(u.values());for(const l of a){const r=await l.value;r&&typeof r!="string"&&i.push(r)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:n}of i.values())await n.then(u=>typeof u!="string"?u?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,n,u,a,l){this.p(i,n,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:n,localAddress:u,privacy:a,protocol:l,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,n){(o(i)||S(i))&&(i=e.$fv[0]);const u=this.r(i,n);if(u)return++u.refcount,u.value}openTunnel(i,n,u,a,l,r=!1,s,c){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${n}:${u} on local port ${l}.`);const h=this.f??i;if(!h)return;if(n||(n="localhost"),a||(a=this.l),this.f&&this.i.has(u)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const w=this.s(h,n,u,a,l,r,s,c);return w?w.then(m=>{if(m){if(typeof m=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(n,u),m}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(n,u);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const I=this.n(m);return(m.tunnelRemoteHost!==n||m.tunnelRemotePort!==u)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),s&&m.privacy!==s&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(I),I}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),w)}n(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const n=this.e.get(i.tunnelRemoteHost);if(n){const u=n.get(i.tunnelRemotePort);u&&(u.refcount--,await this.o(i.tunnelRemoteHost,i.tunnelRemotePort,u))}}}}async o(i,n,u){if(u.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${n}.`);const a=u.value.then(async l=>{l&&typeof l!="string"&&(await l.dispose(!0),this.b.fire({host:l.tunnelRemoteHost,port:l.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(n),a}}async closeTunnel(i,n){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${n} `);const u=this.e.get(i);if(u&&u.has(n)){const a=u.get(n);a.refcount=0,await this.o(i,n,a)}}p(i,n,u){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(n,{refcount:1,value:u})}async q(i,n){const u=this.e.get(i);if(u){const a=u.get(n),l=a?await a.value:void 0;(!l||typeof l=="string")&&u.delete(n),u.size===0&&this.e.delete(i)}}r(i,n){const u=[i];S(i)?(u.push(...e.$fv),u.push(...e.$hv)):o(i)&&u.push(...e.$hv);const a=u.map(l=>this.e.get(l));for(const l of a){const r=l?.get(n);if(r)return r}}canTunnel(i){return!!A(i)}t(i,n,u,a,l,r,s){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${n}:${u} on local port ${a}.`);const c=u;this.i.add(c);const h=a===void 0?u:a,w={elevationRequired:l?this.isPortPrivileged(h):!1},m={remoteAddress:{host:n,port:u},localAddressPort:a,privacy:r,public:r?r!==$.Private:void 0,protocol:s},I=i.forwardPort(m,w);return I?(this.p(n,u,I),I.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(c)})):this.i.delete(c),I}};e.$lv=f,e.$lv=f=Ke([Ve(0,M.$bj),Ve(1,L.$ni)],f)}),define(Ae[199],Re([1,0,4]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$mv=void 0,e.$mv=(0,E.$Th)("editSessionIdentityService");var L;(function(P){P[P.Complete=100]="Complete",P[P.Partial=50]="Partial",P[P.None=0]="None"})(L||(e.EditSessionIdentityMatch=L={}))}),define(Ae[200],Re([1,0,14]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=void 0;function L(D){return D.scheme!==E.Schemas.file&&D.scheme!==E.Schemas.vscodeRemote}e.$2J=L;function P(D){if(D.folders.length)return D.folders.every(g=>L(g.uri))?D.folders[0].uri:void 0;if(D.configuration&&L(D.configuration))return D.configuration}e.$3J=P;function M(D){return P(D)?.scheme}e.$4J=M;function R(D){return P(D)?.authority}e.$5J=R;function $(D){return P(D)!==void 0}e.$6J=$}),define(Ae[47],Re([1,0,156,19,51,25,2,4,14]),function(pe,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.WorkbenchState=e.$0h=e.$9h=e.$8h=e.$7h=e.$6h=e.$5h=e.$4h=e.$3h=void 0,e.$3h=(0,$.$Th)("contextService");function g(h){const w=h;return typeof w?.id=="string"&&R.URI.isUri(w.uri)}e.$4h=g;function A(h){return typeof h?.id=="string"&&!g(h)&&!o(h)}e.$5h=A,e.$6h={id:"ext-dev"},e.$7h={id:"empty-window"};function S(h,w){if(typeof h=="string"||typeof h>"u")return typeof h=="string"?{id:(0,L.$mc)(h)}:w?e.$6h:e.$7h;const m=h;return m.configuration?{id:m.id,configPath:m.configuration}:m.folders.length===1?{id:m.id,uri:m.folders[0].uri}:{id:m.id}}e.$8h=S;function o(h){const w=h;return typeof w?.id=="string"&&R.URI.isUri(w.configPath)}e.$9h=o;function v(h){const w=h;if(w?.uri)return{id:w.id,uri:R.URI.revive(w.uri)};const m=h;if(m?.configPath)return{id:m.id,configPath:R.URI.revive(m.configPath)};if(h?.id)return{id:h.id}}e.$0h=v;var p;(function(h){h[h.EMPTY=1]="EMPTY",h[h.FOLDER=2]="FOLDER",h[h.WORKSPACE=3]="WORKSPACE"})(p||(e.WorkbenchState=p={}));function f(h){const w=h;return!!(w&&typeof w=="object"&&typeof w.id=="string"&&Array.isArray(w.folders))}e.$$h=f;function t(h){const w=h;return!!(w&&typeof w=="object"&&R.URI.isUri(w.uri)&&typeof w.name=="string"&&typeof w.toResource=="function")}e.$_h=t;class i{constructor(w,m,I,k,d){this.h=w,this.j=I,this.k=k,this.l=d,this.c=P.$Zh.forUris(this.l,()=>!0),this.folders=m}update(w){this.h=w.id,this.k=w.configuration,this.j=w.transient,this.l=w.l,this.folders=w.folders}get folders(){return this.g}set folders(w){this.g=w,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(w){this.k=w}getFolder(w){return w&&this.c.findSubstr(w)||null}n(){this.c=P.$Zh.forUris(this.l,()=>!0);for(const w of this.folders)this.c.set(w.uri,w)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$ai=i;class n{constructor(w,m){this.raw=m,this.uri=w.uri,this.index=w.index,this.name=w.name}toResource(w){return(0,M.$wg)(this.uri,w)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$bi=n;function u(h){return new n({uri:h,index:0,name:(0,M.$sg)(h)},{uri:h.toString()})}e.$ci=u,e.$di="code-workspace",e.$ei=`.${e.$di}`,e.$fi=[{name:(0,E.localize)(0,null),extensions:[e.$di]}],e.$gi="workspace.json";function a(h,w){return M.$ng.isEqualOrParent(h,w.untitledWorkspacesHome)}e.$hi=a;function l(h){let w;return R.URI.isUri(h)?w=h:w=h.configuration,w?.scheme===D.Schemas.tmp}e.$ii=l,e.$ji="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function r(h){return h.id===e.$ji}e.$ki=r;function s(h,w){return!a(h,w)&&!l(h)}e.$li=s;function c(h){return(typeof h=="string"?(0,L.$nc)(h):(0,M.$ug)(h))===e.$ei}e.$mi=c}),define(Ae[75],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zcc=void 0;class E{static{this.a=!1}constructor(P){this.d=P,this.b=new Map,this.c=1}add(P){const M=this.c++;return this.b.set(M,P),this.e(),M}get(P,M){return this.b.has(P)?this.b.get(P)[M]:void 0}delete(P){this.b.delete(P),this.e()}e(){E.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Zcc=E}),define(Ae[42],Re([1,0,14,25,4]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3cc=e.$2cc=void 0;class M{constructor(){this.a=new Set(Object.keys(E.Schemas)),this.b=new Map,this.extUri=new L.$lg($=>{const D=this.b.get($.scheme);return!(D===void 0||D&1024)})}$acceptProviderInfos($,D){D===null?this.b.delete($.scheme):this.b.set($.scheme,D)}isFreeScheme($){return!this.b.has($)&&!this.a.has($)}getCapabilities($){return this.b.get($)}}e.$2cc=M,e.$3cc=(0,P.$Th)("IExtHostFileSystemInfo")}),define(Ae[27],Re([1,0,4]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NM=void 0,e.$NM=(0,E.$Th)("IExtHostInitDataService")}),define(Ae[201],Re([1,0,162,15,188,27]),function(pe,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ec=void 0;let R=class extends P.$UN{constructor(D,g,A){const S=A.remote.isRemote?"remoteexthost":D?"workerexthost":"exthost",o=A.remote.isRemote?(0,E.localize)(0,null):D?(0,E.localize)(1,null):(0,E.localize)(2,null);super(g.createLogger(S,{name:o}))}};e.$$ec=R,e.$$ec=R=Ke([Ve(1,L.$cj),Ve(2,M.$NM)],R)}),define(Ae[202],Re([1,0,12]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tdc=e.$sdc=void 0;class L{constructor(R,$,D){this.h=new Map,this.a=R,this.b=$,this.c=D,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(g=>(this.f=g,this)),this.g=this.c.onDidChangeStorage(g=>{g.shared===this.b&&g.key===this.a&&(this.f=g.value)}),this.i=new E.$8g(()=>{const g=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const A of g.values())A.complete()}catch(A){for(const S of g.values())S.error(A)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,$){let D=this.f[R];return typeof D>"u"&&(D=$),D}update(R,$){this.f[R]=$;const D=this.h.get(R);if(D!==void 0)return D.p;const g=new E.$gh;return this.h.set(R,g),this.i.isScheduled()||this.i.schedule(),g.p}dispose(){this.g.dispose()}}e.$sdc=L;class P extends L{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,$){super(R.identifier.value,!0,$),this.j=R}}e.$tdc=P}),define(Ae[203],Re([1,0,5,2]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rec=void 0;class P{constructor(R){this.c=R,this.a=new E.$Od,this.onDidSaveNotebookDocument=this.a.event,this.b=new E.$Od,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,$,D,g){const S=this.c.getNotebookDocument(L.URI.revive(R)).acceptModelChanged($.value,D,g);this.b.fire(S)}$acceptDirtyStateChanged(R,$){this.c.getNotebookDocument(L.URI.revive(R)).acceptDirty($)}$acceptModelSaved(R){const $=this.c.getNotebookDocument(L.URI.revive(R));this.a.fire($.apiNotebook)}}e.$Rec=P}),define(Ae[17],Re([1,0,4]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yM=e.$xM=void 0,e.$xM=(0,E.$Th)("IExtHostRpcService");class L{constructor(M){this.getProxy=M.getProxy.bind(M),this.set=M.set.bind(M),this.dispose=M.dispose.bind(M),this.assertRegistered=M.assertRegistered.bind(M),this.drain=M.drain.bind(M)}}e.$yM=L}),define(Ae[204],Re([1,0,22,5]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Edc=void 0;class P{#e;constructor(R,$){this.b=new L.$Od,this.onDidChange=this.b.event,this.a=E.$0l.toKey(R.identifier),this.#e=$,this.#e.onDidChangePassword(D=>{D.extensionId===this.a&&this.b.fire({key:D.key})})}get(R){return this.#e.get(this.a,R)}store(R,$){return this.#e.store(this.a,R,$)}delete(R){return this.#e.delete(this.a,R)}}e.$Edc=P}),define(Ae[59],Re([1,0,4]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bdc=e.$adc=void 0,e.$adc=(0,E.$Th)("IURITransformerService");class L{constructor(M){M?(this.transformIncoming=M.transformIncoming.bind(M),this.transformOutgoing=M.transformOutgoing.bind(M),this.transformOutgoingURI=M.transformOutgoingURI.bind(M),this.transformOutgoingScheme=M.transformOutgoingScheme.bind(M)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$bdc=L}),define(Ae[205],Re([1,0,24]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$cb=e.$0cb=void 0;class L{constructor(){this.buffers=[]}add(D){let g=this.buffers.indexOf(D);return g<0&&(g=this.buffers.length,this.buffers.push(D)),g}}function P($,D){if(D.serializeBuffersForPostMessage){const g=new L,S=JSON.stringify($,(v,p)=>{if(p instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:g.add(p)};if(ArrayBuffer.isView(p)){const f=M(p);if(f)return{$$vscode_array_buffer_reference$$:!0,index:g.add(p.buffer),view:{type:f,byteLength:p.byteLength,byteOffset:p.byteOffset}}}return p}),o=g.buffers.map(v=>{const p=new Uint8Array(v);return E.$ce.wrap(p)});return{message:S,buffers:o}}else return{message:JSON.stringify($),buffers:[]}}e.$0cb=P;function M($){switch($.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R($,D){const g=D.map(o=>{const v=new ArrayBuffer(o.byteLength);return new Uint8Array(v).set(o.buffer),v}),A=D.length?(o,v)=>{if(v&&typeof v=="object"&&v.$$vscode_array_buffer_reference$$){const p=v,{index:f}=p,t=g[f];if(p.view)switch(p.view.type){case 1:return new Int8Array(t,p.view.byteOffset,p.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(t,p.view.byteOffset,p.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(t,p.view.byteOffset,p.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(t,p.view.byteOffset,p.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(t,p.view.byteOffset,p.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(t,p.view.byteOffset,p.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(t,p.view.byteOffset,p.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(t,p.view.byteOffset,p.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(t,p.view.byteOffset,p.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(t,p.view.byteOffset,p.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(t,p.view.byteOffset,p.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return t}return v}:void 0;return{message:JSON.parse($,A),arrayBuffers:g}}e.$$cb=R}),define(Ae[102],Re([1,0,172,16,2,6,4,30,41,14,39,134,31]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xE=e.$wE=e.$vE=e.EditorsOrder=e.$uE=e.CloseDirection=e.$tE=e.$sE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$rE=e.$qE=e.$pE=e.$oE=e.$nE=e.$mE=e.$lE=e.$kE=e.EditorInputCapabilities=e.$jE=e.SaveReason=e.Verbosity=e.$iE=e.$hE=e.$gE=e.$fE=e.$eE=e.$dE=e.$cE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$bE=e.$aE=e.$_D=e.$$D=e.$0D=void 0,e.$0D={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$$D={id:"default",displayName:(0,E.localize)(0,null),providerDisplayName:(0,E.localize)(1,null)},e.$_D="workbench.editor.sidebysideEditor",e.$aE="workbench.editors.textDiffEditor",e.$bE="workbench.editors.binaryResourceDiffEditor";var v;(function(oe){oe[oe.PROGRAMMATIC=1]="PROGRAMMATIC",oe[oe.USER=2]="USER",oe[oe.EDIT=3]="EDIT",oe[oe.NAVIGATION=4]="NAVIGATION",oe[oe.JUMP=5]="JUMP"})(v||(e.EditorPaneSelectionChangeReason=v={}));var p;(function(oe){oe[oe.IDENTICAL=1]="IDENTICAL",oe[oe.SIMILAR=2]="SIMILAR",oe[oe.DIFFERENT=3]="DIFFERENT"})(p||(e.EditorPaneSelectionCompareResult=p={}));function f(oe){const ve=oe;return!!ve&&typeof ve.getSelection=="function"&&!!ve.onDidChangeSelection}e.$cE=f;function t(oe,ve,ee){for(const W of ee.visibleEditorPanes)if(W.group.id===ve&&oe.matches(W.input))return W.getViewState()}e.$dE=t;function i(oe){if(m(oe))return!1;const ve=oe;return P.URI.isUri(ve?.resource)}e.$eE=i;function n(oe){if(m(oe))return!1;const ve=oe;return ve?.original!==void 0&&ve.modified!==void 0}e.$fE=n;function u(oe){if(m(oe)||n(oe))return!1;const ve=oe;return ve?.primary!==void 0&&ve.secondary!==void 0}e.$gE=u;function a(oe){if(m(oe))return!1;const ve=oe;return ve?ve.resource===void 0||ve.resource.scheme===g.Schemas.untitled||ve.forceUntitled===!0:!1}e.$hE=a;function l(oe){if(m(oe))return!1;const ve=oe;return P.URI.isUri(ve?.base?.resource)&&P.URI.isUri(ve?.input1?.resource)&&P.URI.isUri(ve?.input2?.resource)&&P.URI.isUri(ve?.result?.resource)}e.$iE=l;var r;(function(oe){oe[oe.SHORT=0]="SHORT",oe[oe.MEDIUM=1]="MEDIUM",oe[oe.LONG=2]="LONG"})(r||(e.Verbosity=r={}));var s;(function(oe){oe[oe.EXPLICIT=1]="EXPLICIT",oe[oe.AUTO=2]="AUTO",oe[oe.FOCUS_CHANGE=3]="FOCUS_CHANGE",oe[oe.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(s||(e.SaveReason=s={}));class c{constructor(){this.a=new Map}registerSource(ve,ee){let W=this.a.get(ve);return W||(W={source:ve,label:ee},this.a.set(ve,W)),W.source}getSourceLabel(ve){return this.a.get(ve)?.label??ve}}e.$jE=new c;var h;(function(oe){oe[oe.None=0]="None",oe[oe.Readonly=2]="Readonly",oe[oe.Untitled=4]="Untitled",oe[oe.Singleton=8]="Singleton",oe[oe.RequiresTrust=16]="RequiresTrust",oe[oe.CanSplitInGroup=32]="CanSplitInGroup",oe[oe.ForceDescription=64]="ForceDescription",oe[oe.CanDropIntoEditor=128]="CanDropIntoEditor",oe[oe.MultipleEditors=256]="MultipleEditors",oe[oe.Scratchpad=512]="Scratchpad",oe[oe.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(h||(e.EditorInputCapabilities=h={}));class w extends M.$Rc{}e.$kE=w;function m(oe){return oe instanceof w}e.$lE=m;function I(oe){const ve=oe;return P.URI.isUri(ve?.preferredResource)}function k(oe){const ve=oe;return m(ve?.primary)&&m(ve?.secondary)}e.$mE=k;function d(oe){const ve=oe;return m(ve?.modified)&&m(ve?.original)}e.$nE=d;function b(oe,ve,ee,W,ue){return re(W,[(0,S.$Di)({id:"workbench.action.openLargeFile",label:(0,E.localize)(2,null),run:()=>{const Pe={...ee,limits:{size:Number.MAX_VALUE}};oe.openEditor(ve,Pe)}}),(0,S.$Di)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,E.localize)(3,null),run:()=>ue.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:o.default.Warning})}e.$oE=b;function y(oe){return m(oe?.editor)}e.$pE=y;function C(oe){const ve=oe;return y(oe)&&ve?.group!==void 0}e.$qE=C;function B(oe){const ve=oe;return typeof ve?.groupId=="number"&&m(ve.editor)}e.$rE=B;var H;(function(oe){oe[oe.UNKNOWN=0]="UNKNOWN",oe[oe.REPLACE=1]="REPLACE",oe[oe.MOVE=2]="MOVE",oe[oe.UNPIN=3]="UNPIN"})(H||(e.EditorCloseContext=H={}));var U;(function(oe){oe[oe.GROUP_ACTIVE=0]="GROUP_ACTIVE",oe[oe.GROUP_INDEX=1]="GROUP_INDEX",oe[oe.GROUP_LABEL=2]="GROUP_LABEL",oe[oe.GROUP_LOCKED=3]="GROUP_LOCKED",oe[oe.EDITOR_OPEN=4]="EDITOR_OPEN",oe[oe.EDITOR_CLOSE=5]="EDITOR_CLOSE",oe[oe.EDITOR_MOVE=6]="EDITOR_MOVE",oe[oe.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",oe[oe.EDITOR_LABEL=8]="EDITOR_LABEL",oe[oe.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",oe[oe.EDITOR_PIN=10]="EDITOR_PIN",oe[oe.EDITOR_STICKY=11]="EDITOR_STICKY",oe[oe.EDITOR_DIRTY=12]="EDITOR_DIRTY",oe[oe.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(U||(e.GroupModelChangeKind=U={}));var z;(function(oe){oe[oe.PRIMARY=1]="PRIMARY",oe[oe.SECONDARY=2]="SECONDARY",oe[oe.BOTH=3]="BOTH",oe[oe.ANY=4]="ANY"})(z||(e.SideBySideEditor=z={}));class F{getOriginalUri(ve,ee){if(!ve)return;if(l(ve))return e.$tE.getOriginalUri(ve.result,ee);if(ee?.supportSideBySide){const{primary:ue,secondary:Pe}=this.a(ve);if(ue&&Pe){if(ee?.supportSideBySide===z.BOTH)return{primary:this.getOriginalUri(ue,{filterByScheme:ee.filterByScheme}),secondary:this.getOriginalUri(Pe,{filterByScheme:ee.filterByScheme})};if(ee?.supportSideBySide===z.ANY)return this.getOriginalUri(ue,{filterByScheme:ee.filterByScheme})??this.getOriginalUri(Pe,{filterByScheme:ee.filterByScheme});ve=ee.supportSideBySide===z.PRIMARY?ue:Pe}}if(n(ve)||u(ve)||l(ve))return;const W=I(ve)?ve.preferredResource:ve.resource;return!W||!ee||!ee.filterByScheme?W:this.b(W,ee.filterByScheme)}a(ve){return k(ve)||u(ve)?{primary:ve.primary,secondary:ve.secondary}:d(ve)||n(ve)?{primary:ve.modified,secondary:ve.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(ve,ee){if(!ve)return;if(l(ve))return e.$tE.getCanonicalUri(ve.result,ee);if(ee?.supportSideBySide){const{primary:ue,secondary:Pe}=this.a(ve);if(ue&&Pe){if(ee?.supportSideBySide===z.BOTH)return{primary:this.getCanonicalUri(ue,{filterByScheme:ee.filterByScheme}),secondary:this.getCanonicalUri(Pe,{filterByScheme:ee.filterByScheme})};if(ee?.supportSideBySide===z.ANY)return this.getCanonicalUri(ue,{filterByScheme:ee.filterByScheme})??this.getCanonicalUri(Pe,{filterByScheme:ee.filterByScheme});ve=ee.supportSideBySide===z.PRIMARY?ue:Pe}}if(n(ve)||u(ve)||l(ve))return;const W=ve.resource;return!W||!ee||!ee.filterByScheme?W:this.b(W,ee.filterByScheme)}b(ve,ee){if(Array.isArray(ee)){if(ee.some(W=>ve.scheme===W))return ve}else if(ee===ve.scheme)return ve}}var N;(function(oe){oe[oe.UNKNOWN=0]="UNKNOWN",oe[oe.KEYBOARD=1]="KEYBOARD",oe[oe.MOUSE=2]="MOUSE"})(N||(e.EditorCloseMethod=N={}));function x(oe,ve,ee,W){if(!oe.isSticky(ve))return!1;switch(W.preventPinnedEditorClose){case"keyboardAndMouse":return ee===N.MOUSE||ee===N.KEYBOARD;case"mouse":return ee===N.MOUSE;case"keyboard":return ee===N.KEYBOARD}return!1}e.$sE=x,e.$tE=new F;var J;(function(oe){oe[oe.LEFT=0]="LEFT",oe[oe.RIGHT=1]="RIGHT"})(J||(e.CloseDirection=J={}));class ye{constructor(){this.c=new Map,this.d=new Map}start(ve){const ee=this.a=ve.get(R.$Sh);for(const[W,ue]of this.c)this.e(W,ue,ee);this.c.clear()}e(ve,ee,W){const ue=W.createInstance(ee);this.d.set(ve,ue)}registerFileEditorFactory(ve){if(this.b)throw new Error("Can only register one file editor factory.");this.b=ve}getFileEditorFactory(){return(0,L.$Kf)(this.b)}registerEditorSerializer(ve,ee){if(this.c.has(ve)||this.d.has(ve))throw new Error(`A editor serializer with type ID '${ve}' was already registered.`);return this.a?this.e(ve,ee,this.a):this.c.set(ve,ee),(0,M.$Pc)(()=>{this.c.delete(ve),this.d.delete(ve)})}getEditorSerializer(ve){return this.d.get(typeof ve=="string"?ve:ve.typeId)}}$.$kn.add(e.$0D.EditorFactory,new ye);async function De(oe,ve,ee){return!oe||!oe.length?[]:await Promise.all(oe.map(async W=>{const ue=P.URI.revive(W.fileUri);if(!ue){ee.info("Cannot resolve the path because it is not valid.",W);return}if(!await ve.canHandleResource(ue)){ee.info("Cannot resolve the path because it cannot be handled",W);return}let Ee=W.exists,te=W.type;if(typeof Ee!="boolean"||typeof te!="number")try{te=(await ve.stat(ue)).isDirectory?D.FileType.Directory:D.FileType.Unknown,Ee=!0}catch(me){ee.error(me),Ee=!1}if(!Ee&&W.openOnlyIfExists){ee.info("Cannot resolve the path because it does not exist",W);return}if(te===D.FileType.Directory){ee.info("Cannot resolve the path because it is a directory",W);return}const se={...W.options,pinned:!0};return Ee?{resource:ue,options:se}:{resource:ue,options:se,forceUntitled:!0}}))}e.$uE=De;var Ce;(function(oe){oe[oe.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",oe[oe.SEQUENTIAL=1]="SEQUENTIAL"})(Ce||(e.EditorsOrder=Ce={}));function ge(oe){const ve=oe;if(!ve)return!1;const ee=ve;if(ee.modified)return ge(ee.modified);const W=ve;return!!(W.contributionsState&&W.viewState&&Array.isArray(W.cursorState))}e.$vE=ge;function we(oe){return(0,A.$Fi)(oe)}e.$wE=we;function re(oe,ve,ee){const W=(0,A.$Gi)(oe,ve);return W.forceMessage=ee?.forceMessage,W.forceSeverity=ee?.forceSeverity,W.allowDialog=ee?.allowDialog,W}e.$xE=re}),define(Ae[206],Re([1,0,5,173,4,6,28,30,18,26,90,197]),function(pe,e,E,L,P,M,R,$,D,g,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GE=e.$FE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$EE=e.$DE=e.ViewContentGroups=e.$CE=e.$BE=e.ViewContainerLocation=e.Extensions=e.$AE=e.$zE=e.$yE=void 0,e.$yE="views",e.$zE=(0,L.localize)(0,null),e.$AE=(0,S.$0v)("default-view-icon",A.$Yj.window,(0,L.localize)(1,null));var o;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})(o||(e.Extensions=o={}));var v;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel",s[s.AuxiliaryBar=2]="AuxiliaryBar"})(v||(e.ViewContainerLocation=v={})),e.$BE=[0,1,2];function p(s){switch(s){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$CE=p;class f extends M.$Rc{constructor(){super(...arguments),this.c=this.B(new E.$Od),this.onDidRegister=this.c.event,this.f=this.B(new E.$Od),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,D.$Qb)([...this.g.values()])}registerViewContainer(c,h,w){const m=this.get(c.id);if(m)return m;const I=c;return I.openCommandActionDescriptor=w?.doNotRegisterOpenCommand?void 0:I.openCommandActionDescriptor??{id:I.id},(0,R.$wc)(this.g,h,[]).push(I),w?.isDefault&&this.h.push(I),this.c.fire({viewContainer:I,viewContainerLocation:h}),I}deregisterViewContainer(c){for(const h of this.g.keys()){const w=this.g.get(h),m=w?.indexOf(c);if(m!==-1){w?.splice(m,1),w.length===0&&this.g.delete(h),this.f.fire({viewContainer:c,viewContainerLocation:h});return}}}get(c){return this.all.filter(h=>h.id===c)[0]}getViewContainers(c){return[...this.g.get(c)||[]]}getViewContainerLocation(c){return[...this.g.keys()].filter(h=>this.getViewContainers(h).filter(w=>w?.id===c.id).length>0)[0]}getDefaultViewContainer(c){return this.h.find(h=>this.getViewContainerLocation(h)===c)}}$.$kn.add(o.ViewContainersRegistry,new f);var t;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(t||(e.ViewContentGroups=t={}));function i(s,c){const h=s.group??t.More,w=c.group??t.More;return h!==w?h.localeCompare(w):(s.order??5)-(c.order??5)}class n extends M.$Rc{constructor(){super(...arguments),this.c=this.B(new E.$Od),this.onViewsRegistered=this.c.event,this.f=this.B(new E.$Od),this.onViewsDeregistered=this.f.event,this.g=this.B(new E.$Od),this.onDidChangeContainer=this.g.event,this.h=this.B(new E.$Od),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Fc}registerViews(c,h){this.registerViews2([{views:c,viewContainer:h}])}registerViews2(c){c.forEach(({views:h,viewContainer:w})=>this.r(h,w)),this.c.fire(c)}deregisterViews(c,h){const w=this.s(c,h);w.length&&this.f.fire({views:w,viewContainer:h})}moveViews(c,h){for(const w of this.m.keys())if(w!==h){const m=this.s(c,w);m.length&&(this.r(m,h),this.g.fire({views:m,from:w,to:h}))}}getViews(c){return this.m.get(c)||[]}getView(c){for(const h of this.j){const w=(this.m.get(h)||[]).filter(m=>m.id===c)[0];if(w)return w}return null}getViewContainer(c){for(const h of this.j)if((this.m.get(h)||[]).filter(m=>m.id===c)[0])return h;return null}registerViewWelcomeContent(c,h){return this.n.add(c,h),this.h.fire(c),(0,M.$Pc)(()=>{this.n.delete(c,h),this.h.fire(c)})}registerViewWelcomeContent2(c,h){const w=new Map;for(const[m,I]of h)this.n.add(c,I),w.set(m,(0,M.$Pc)(()=>{this.n.delete(c,I),this.h.fire(c)}));return this.h.fire(c),w}getViewWelcomeContent(c){const h=[];return this.n.forEach(c,w=>h.push(w)),h.sort(i)}r(c,h){let w=this.m.get(h);w||(w=[],this.m.set(h,w),this.j.push(h));for(const m of c){if(this.getView(m.id)!==null)throw new Error((0,L.localize)(2,null,m.id));w.push(m)}}s(c,h){const w=this.m.get(h);if(!w)return[];const m=[],I=[];for(const k of w)c.includes(k)?m.push(k):I.push(k);return m.length&&(I.length?this.m.set(h,I):(this.m.delete(h),this.j.splice(this.j.indexOf(h),1))),m}}$.$kn.add(o.ViewsRegistry,new n),e.$DE=(0,P.$Th)("viewsService"),e.$EE=(0,P.$Th)("viewDescriptorService");var u;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(u||(e.ViewVisibilityState=u={}));var a;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(a||(e.TreeItemCollapsibleState=a={}));class l{constructor(c,h){this.c=!1,this.d=!1,(0,g.$bn)(this,c),this.d=!!h,this.resolve=async w=>{if(h&&!this.c){const m=await h(w);m&&(this.tooltip=this.tooltip??m.tooltip,this.command=this.command??m.command)}w.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$FE=l;class r extends Error{constructor(c){super((0,L.localize)(3,null,c)),this.name="NoTreeViewError"}static is(c){return c.name==="NoTreeViewError"}}e.$GE=r}),define(Ae[207],Re([1,0,2,29,4]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9E=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$8E=e.$7E=void 0;function M(g){return!!g&&typeof g=="object"&&"uri"in g&&g.uri instanceof E.URI&&"version"in g&&typeof g.version=="number"&&"ranges"in g&&Array.isArray(g.ranges)&&g.ranges.every(L.$xs.isIRange)}e.$7E=M;function R(g){return!!g&&typeof g=="object"&&"documents"in g&&Array.isArray(g.documents)&&g.documents.every(M)}e.$8E=R;var $;(function(g){g[g.Down=0]="Down",g[g.Up=1]="Up"})($||(e.InteractiveSessionVoteDirection=$={}));var D;(function(g){g[g.Action=1]="Action",g[g.Toolbar=2]="Toolbar"})(D||(e.InteractiveSessionCopyKind=D={})),e.$9E=(0,P.$Th)("IChatService")}),define(Ae[208],Re([1,0,5,12,174]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ddb=void 0;class M{constructor(){this.f=new Map,this.k=[],this.m=new E.$Od,this.n=new E.$Od,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage($){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=$}onEvent($){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=$}onRequest($){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=$}sendResponse($){$.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${$.command}`)):this.s("response",$)}sendRequest($,D,g,A){const S={command:$};if(D&&Object.keys(D).length>0&&(S.arguments=D),this.s("request",S),typeof A=="number"){const o=setTimeout(()=>{clearTimeout(o);const v=this.f.get(S.seq);if(v){this.f.delete(S.seq);const p={type:"response",seq:0,request_seq:S.seq,success:!1,command:$,message:(0,P.localize)(0,null,A,$)};v(p)}},A)}return g&&this.f.set(S.seq,g),S.seq}acceptMessage($){this.j?this.j($):(this.k.push($),this.k.length===1&&this.q())}o($,D){return $.type!=="event"||D.type!=="event"}async q(){let $;for(;this.k.length;){if((!$||this.o(this.k[0],$))&&await(0,L.$Vg)(0),$=this.k.shift(),!$)return;switch($.type){case"event":this.i?.($);break;case"request":this.g?.($);break;case"response":{const D=$,g=this.f.get(D.request_seq);g&&(this.f.delete(D.request_seq),g(D));break}}}}s($,D){D.type=$,D.seq=this.d++,this.sendMessage(D)}async u(){if(this.f.size===0)return Promise.resolve();const $=new Map;this.f.forEach((D,g)=>$.set(g,D)),await(0,L.$Vg)(500),$.forEach((D,g)=>{D({type:"response",seq:0,request_seq:g,success:!1,command:"canceled",message:"canceled"}),this.f.delete(g)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$Ddb=M}),define(Ae[209],Re([1,0,175,34,4]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$jH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$iH=e.MemoryRangeType=e.$hH=e.State=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=void 0,e.$eG="workbench.view.debug",e.$fG="workbench.debug.variablesView",e.$gG="workbench.debug.watchExpressionsView",e.$hG="workbench.debug.callStackView",e.$iG="workbench.debug.loadedScriptsView",e.$jG="workbench.debug.breakPointsView",e.$kG="workbench.debug.disassemblyView",e.$lG="workbench.panel.repl",e.$mG="workbench.panel.repl.view",e.$nG=new L.$$i("debugType",void 0,{type:"string",description:E.localize(0,null)}),e.$oG=new L.$$i("debugConfigurationType",void 0,{type:"string",description:E.localize(1,null)}),e.$pG=new L.$$i("debugState","inactive",{type:"string",description:E.localize(2,null)}),e.$qG="debugUx",e.$rG=new L.$$i(e.$qG,"default",{type:"string",description:E.localize(3,null)}),e.$sG=new L.$$i("hasDebugged",!1,{type:"boolean",description:E.localize(4,null)}),e.$tG=new L.$$i("inDebugMode",!1,{type:"boolean",description:E.localize(5,null)}),e.$uG=new L.$$i("inDebugRepl",!1,{type:"boolean",description:E.localize(6,null)}),e.$vG=new L.$$i("breakpointWidgetVisible",!1,{type:"boolean",description:E.localize(7,null)}),e.$wG=new L.$$i("inBreakpointWidget",!1,{type:"boolean",description:E.localize(8,null)}),e.$xG=new L.$$i("breakpointsFocused",!0,{type:"boolean",description:E.localize(9,null)}),e.$yG=new L.$$i("watchExpressionsFocused",!0,{type:"boolean",description:E.localize(10,null)}),e.$zG=new L.$$i("watchExpressionsExist",!1,{type:"boolean",description:E.localize(11,null)}),e.$AG=new L.$$i("variablesFocused",!0,{type:"boolean",description:E.localize(12,null)}),e.$BG=new L.$$i("expressionSelected",!1,{type:"boolean",description:E.localize(13,null)}),e.$CG=new L.$$i("breakpointInputFocused",!1,{type:"boolean",description:E.localize(14,null)}),e.$DG=new L.$$i("callStackItemType",void 0,{type:"string",description:E.localize(15,null)}),e.$EG=new L.$$i("callStackSessionIsAttach",!1,{type:"boolean",description:E.localize(16,null)}),e.$FG=new L.$$i("callStackItemStopped",!1,{type:"boolean",description:E.localize(17,null)}),e.$GG=new L.$$i("callStackSessionHasOneThread",!1,{type:"boolean",description:E.localize(18,null)}),e.$HG=new L.$$i("watchItemType",void 0,{type:"string",description:E.localize(19,null)}),e.$IG=new L.$$i("canViewMemory",void 0,{type:"boolean",description:E.localize(20,null)}),e.$JG=new L.$$i("breakpointItemType",void 0,{type:"string",description:E.localize(21,null)}),e.$KG=new L.$$i("breakpointSupportsCondition",!1,{type:"boolean",description:E.localize(22,null)}),e.$LG=new L.$$i("loadedScriptsSupported",!1,{type:"boolean",description:E.localize(23,null)}),e.$MG=new L.$$i("loadedScriptsItemType",void 0,{type:"string",description:E.localize(24,null)}),e.$NG=new L.$$i("focusedSessionIsAttach",!1,{type:"boolean",description:E.localize(25,null)}),e.$OG=new L.$$i("focusedSessionIsNoDebug",!1,{type:"boolean",description:E.localize(26,null)}),e.$PG=new L.$$i("stepBackSupported",!1,{type:"boolean",description:E.localize(27,null)}),e.$QG=new L.$$i("restartFrameSupported",!1,{type:"boolean",description:E.localize(28,null)}),e.$RG=new L.$$i("stackFrameSupportsRestart",!1,{type:"boolean",description:E.localize(29,null)}),e.$SG=new L.$$i("jumpToCursorSupported",!1,{type:"boolean",description:E.localize(30,null)}),e.$TG=new L.$$i("stepIntoTargetsSupported",!1,{type:"boolean",description:E.localize(31,null)}),e.$UG=new L.$$i("breakpointsExist",!1,{type:"boolean",description:E.localize(32,null)}),e.$VG=new L.$$i("debuggersAvailable",!1,{type:"boolean",description:E.localize(33,null)}),e.$WG=new L.$$i("debugExtensionAvailable",!0,{type:"boolean",description:E.localize(34,null)}),e.$XG=new L.$$i("debugProtocolVariableMenuContext",void 0,{type:"string",description:E.localize(35,null)}),e.$YG=new L.$$i("debugSetVariableSupported",!1,{type:"boolean",description:E.localize(36,null)}),e.$ZG=new L.$$i("debugSetExpressionSupported",!1,{type:"boolean",description:E.localize(37,null)}),e.$1G=new L.$$i("breakWhenValueChangesSupported",!1,{type:"boolean",description:E.localize(38,null)}),e.$2G=new L.$$i("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:E.localize(39,null)}),e.$3G=new L.$$i("breakWhenValueIsReadSupported",!1,{type:"boolean",description:E.localize(40,null)}),e.$4G=new L.$$i("terminateDebuggeeSupported",!1,{type:"boolean",description:E.localize(41,null)}),e.$5G=new L.$$i("suspendDebuggeeSupported",!1,{type:"boolean",description:E.localize(42,null)}),e.$6G=new L.$$i("variableEvaluateNamePresent",!1,{type:"boolean",description:E.localize(43,null)}),e.$7G=new L.$$i("variableIsReadonly",!1,{type:"boolean",description:E.localize(44,null)}),e.$8G=new L.$$i("exceptionWidgetVisible",!1,{type:"boolean",description:E.localize(45,null)}),e.$9G=new L.$$i("multiSessionRepl",!1,{type:"boolean",description:E.localize(46,null)}),e.$0G=new L.$$i("multiSessionDebug",!1,{type:"boolean",description:E.localize(47,null)}),e.$$G=new L.$$i("disassembleRequestSupported",!1,{type:"boolean",description:E.localize(48,null)}),e.$_G=new L.$$i("disassemblyViewFocus",!1,{type:"boolean",description:E.localize(49,null)}),e.$aH=new L.$$i("languageSupportsDisassembleRequest",!1,{type:"boolean",description:E.localize(50,null)}),e.$bH=new L.$$i("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:E.localize(51,null)});const M=o=>E.localize(52,null,o);e.$cH=M,e.$dH="editor.contrib.debug",e.$eH="editor.contrib.breakpoint",e.$fH="debug",e.$gH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:E.localize(53,null)};var R;(function(o){o[o.Inactive=0]="Inactive",o[o.Initializing=1]="Initializing",o[o.Stopped=2]="Stopped",o[o.Running=3]="Running"})(R||(e.State=R={}));function $(o){switch(o){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$hH=$;var D;(function(o){o[o.Valid=0]="Valid",o[o.Unreadable=1]="Unreadable",o[o.Error=2]="Error"})(D||(e.MemoryRangeType=D={})),e.$iH="vscode-debug-memory";var g;(function(o){o[o.Initial=1]="Initial",o[o.Dynamic=2]="Dynamic"})(g||(e.DebugConfigurationProviderTriggerKind=g={}));var A;(function(o){o.UnverifiedBreakpoints="unverifiedBreakpoints"})(A||(e.DebuggerString=A={})),e.$jH=(0,P.$Th)("debugService");var S;(function(o){o[o.CONDITION=0]="CONDITION",o[o.HIT_COUNT=1]="HIT_COUNT",o[o.LOG_MESSAGE=2]="LOG_MESSAGE"})(S||(e.BreakpointWidgetContext=S={}))}),define(Ae[210],Re([1,0,13,2,19,26,14,29,20,18]),function(pe,e,E,L,P,M,R,$,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RF=e.$QF=e.$PF=e.$OF=e.$NF=e.$MF=e.$LF=e.$KF=e.$JF=e.$IF=e.$HF=e.$GF=e.$FF=void 0;const A=/{([^}]+)}/g;function S(k,d,b){return k.replace(A,function(y,C){return d&&C.length>0&&C[0]!=="_"?y:b&&b.hasOwnProperty(C)?b[C]:y})}e.$FF=S;function o(k){const d={};for(const b of Object.keys(k))b.startsWith("!")||(d[b]=k[b]);return d}e.$GF=o;function v(k){return k.configuration.request==="attach"&&!p(k)&&(!k.parentSession||v(k.parentSession))}e.$HF=v;function p(k){let d=k.configuration.type;if(d)return d==="vslsShare"&&(d=k.configuration.adapterProxy.configuration.type),(0,E.$3e)(d,"extensionhost")||(0,E.$3e)(d,"pwa-extensionhost")?k:k.parentSession?p(k.parentSession):void 0}e.$IF=p;function f(k){return k.type&&(k.label||k.program||k.runtime)}e.$JF=f;function t(k,d,b){let y,C=0;const B=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let H=null;for(;H=B.exec(k);){const U=H.index+1,z=U+H[0].length;if(U<=d&&z>=b){y=H[0],C=U;break}}if(y){const U=/\w+/g;let z=null;for(;(z=U.exec(y))&&!(z.index+1+C+z[0].length>=b););z&&(y=y.substring(0,U.lastIndex))}return y?{start:C,end:C+y.length-1}:{start:0,end:0}}e.$KF=t;async function i(k,d,b,y){if(k.evaluatableExpressionProvider.has(d)){const C=k.evaluatableExpressionProvider.ordered(d),B=(0,g.$Gb)(await Promise.all(C.map(async H=>{try{return await H.provideEvaluatableExpression(d,b,y??D.CancellationToken.None)}catch{return}})));if(B.length>0){let H=B[0].expression;const U=B[0].range;return H||(H=d.getLineContent(b.lineNumber).substring(U.startColumn-1,U.endColumn-1)),{range:U,matchingExpression:H}}}else{const C=d.getLineContent(b.lineNumber),{start:B,end:H}=t(C,b.column,b.column),U=C.substring(B-1,H);return{matchingExpression:U,range:new $.$xs(b.lineNumber,B,b.lineNumber,B+U.length)}}return null}e.$LF=i;const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function u(k){return!!(k&&k.match(n))}e.$MF=u;function a(k){if(typeof k.path=="string"&&!(typeof k.sourceReference=="number"&&k.sourceReference>0)){if(u(k.path))return L.URI.parse(k.path);if((0,P.$hc)(k.path))return L.URI.file(k.path)}return k.path}function l(k){if(typeof k.path=="object"){const d=L.URI.revive(k.path);if(d)return d.scheme===R.Schemas.file?d.fsPath:d.toString()}return k.path}function r(k,d){const b=d?a:l,y=(0,M.$$m)(k);return c(y,(C,B)=>{C&&B&&(B.path=b(B))}),y}e.$NF=r;function s(k,d){const b=d?a:l,y=(0,M.$$m)(k);return c(y,(C,B)=>{!C&&B&&(B.path=b(B))}),y}e.$OF=s;function c(k,d){switch(k.type){case"event":{const b=k;switch(b.event){case"output":d(!1,b.body.source);break;case"loadedSource":d(!1,b.body.source);break;case"breakpoint":d(!1,b.body.breakpoint.source);break;default:break}break}case"request":{const b=k;switch(b.command){case"setBreakpoints":d(!0,b.arguments.source);break;case"breakpointLocations":d(!0,b.arguments.source);break;case"source":d(!0,b.arguments.source);break;case"gotoTargets":d(!0,b.arguments.source);break;case"launchVSCode":b.arguments.args.forEach(y=>d(!1,y));break;default:break}break}case"response":{const b=k;if(b.success&&b.body)switch(b.command){case"stackTrace":b.body.stackFrames.forEach(y=>d(!1,y.source));break;case"loadedSources":b.body.sources.forEach(y=>d(!1,y));break;case"scopes":b.body.scopes.forEach(y=>d(!1,y.source));break;case"setFunctionBreakpoints":b.body.breakpoints.forEach(y=>d(!1,y.source));break;case"setBreakpoints":b.body.breakpoints.forEach(y=>d(!1,y.source));break;case"disassemble":b.body?.instructions.forEach(C=>d(!1,C.location));break;default:break}break}}}function h(k){return k.filter(d=>!d.presentation?.hidden).sort((d,b)=>d.presentation?b.presentation?d.presentation.group?b.presentation.group?d.presentation.group!==b.presentation.group?d.presentation.group.localeCompare(b.presentation.group):w(d.presentation.order,b.presentation.order):-1:b.presentation.group?1:w(d.presentation.order,b.presentation.order):-1:b.presentation?1:0)}e.$PF=h;function w(k,d){return typeof k!="number"?typeof d!="number"?0:1:typeof d!="number"?-1:k-d}async function m(k,d){const b=k.getValue("debug.saveBeforeStart",{overrideIdentifier:d.activeTextEditorLanguageId});if(b!=="none"&&(await d.saveAll(),b==="allEditorsInActiveGroup")){const y=d.activeEditorPane;y&&y.input.resource?.scheme===R.Schemas.untitled&&await d.save({editor:y.input,groupId:y.group.id})}await k.reloadConfiguration()}e.$QF=m;const I=(k,d)=>!k||!d?k===d:k.name===d.name&&k.path===d.path&&k.sourceReference===d.sourceReference;e.$RF=I}),define(Ae[76],Re([1,0,24,33,68,69,14,19,21,34]),function(pe,e,E,L,P,M,R,$,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CI=e.$BI=e.$AI=e.$zI=e.CellStatusbarAlignment=e.$yI=e.$xI=e.$wI=e.NotebookEditorPriority=e.$vI=e.$uI=e.$tI=e.$sI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$rI=e.$qI=e.$pI=e.$oI=e.CellKind=e.$nI=e.$mI=e.$lI=void 0,e.$lI="workbench.editor.notebook",e.$mI="workbench.editor.notebookTextDiffEditor",e.$nI="workbench.editor.interactive";var A;(function(N){N[N.Markup=1]="Markup",N[N.Code=2]="Code"})(A||(e.CellKind=A={})),e.$oI=["application/json","application/javascript","text/html","image/svg+xml",M.$Tr.latex,M.$Tr.markdown,"image/png","image/jpeg",M.$Tr.text],e.$pI=[M.$Tr.latex,M.$Tr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",M.$Tr.text],e.$qI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$rI="_notAvailable";var S;(function(N){N[N.Running=1]="Running",N[N.Idle=2]="Idle"})(S||(e.NotebookRunState=S={}));var o;(function(N){N[N.Unconfirmed=1]="Unconfirmed",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(o||(e.NotebookCellExecutionState=o={}));var v;(function(N){N[N.Unconfirmed=1]="Unconfirmed",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(v||(e.NotebookExecutionState=v={}));var p;(function(N){N[N.WithHardKernelDependency=0]="WithHardKernelDependency",N[N.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",N[N.Pure=2]="Pure",N[N.Never=3]="Never"})(p||(e.NotebookRendererMatch=p={}));var f;(function(N){N.Always="always",N.Never="never",N.Optional="optional"})(f||(e.RendererMessagingSpec=f={}));var t;(function(N){N[N.ModelChange=1]="ModelChange",N[N.Move=2]="Move",N[N.ChangeCellLanguage=5]="ChangeCellLanguage",N[N.Initialize=6]="Initialize",N[N.ChangeCellMetadata=7]="ChangeCellMetadata",N[N.Output=8]="Output",N[N.OutputItem=9]="OutputItem",N[N.ChangeCellContent=10]="ChangeCellContent",N[N.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",N[N.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",N[N.ChangeCellMime=13]="ChangeCellMime",N[N.Unknown=100]="Unknown"})(t||(e.NotebookCellsChangeType=t={}));var i;(function(N){N[N.Handle=0]="Handle",N[N.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var n;(function(N){N[N.Replace=1]="Replace",N[N.Output=2]="Output",N[N.Metadata=3]="Metadata",N[N.CellLanguage=4]="CellLanguage",N[N.DocumentMetadata=5]="DocumentMetadata",N[N.Move=6]="Move",N[N.OutputItems=7]="OutputItems",N[N.PartialMetadata=8]="PartialMetadata",N[N.PartialInternalMetadata=9]="PartialInternalMetadata"})(n||(e.CellEditType=n={}));var u;(function(N){N.scheme=R.Schemas.vscodeNotebookCell;const x=["W","X","Y","Z","a","b","c","d","e","f"],J=new RegExp(`^[${x.join("")}]+`),ye=7;function De(ve,ee){const W=ee.toString(ye),Pe=`${W.length<x.length?x[W.length-1]:"z"}${W}s${(0,E.$we)(E.$ce.fromString(ve.scheme),!0,!0)}`;return ve.with({scheme:N.scheme,fragment:Pe})}N.generate=De;function Ce(ve){if(ve.scheme!==N.scheme)return;const ee=ve.fragment.indexOf("s");if(ee<0)return;const W=parseInt(ve.fragment.substring(0,ee).replace(J,""),ye),ue=(0,E.$ve)(ve.fragment.substring(ee+1)).toString();if(!isNaN(W))return{handle:W,notebook:ve.with({scheme:ue,fragment:null})}}N.parse=Ce;function ge(ve,ee){return ve.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${ee??""},${ve.scheme!==R.Schemas.file?ve.scheme:""}`})}N.generateCellOutputUri=ge;function we(ve){if(ve.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const ee=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ve.fragment);if(!ee)return;const W=ee[1]&&ee[1]!==""?ee[1]:void 0,ue=ee[2];return{outputId:W,notebook:ve.with({scheme:ue||R.Schemas.file,fragment:null})}}N.parseCellOutputUri=we;function re(ve,ee,W){return N.generate(ve,ee).with({scheme:W})}N.generateCellPropertyUri=re;function oe(ve,ee){if(ve.scheme===ee)return N.parse(ve.with({scheme:N.scheme}))}N.parseCellPropertyUri=oe})(u||(e.CellUri=u={}));const a=N=>D.$j?N.replace(/\//g,"\\"):N;class l{constructor(x=[],J=e.$oI){this.e=J,this.d=[...new Set(x)].map(ye=>({pattern:ye,matches:L.$Aj(a(ye))}))}sort(x){const J=new Map(P.Iterable.map(x,De=>[De,a(De)]));let ye=[];for(const{matches:De}of this.d)for(const[Ce,ge]of J)if(De(ge)){ye.push(Ce),J.delete(Ce);break}return J.size&&(ye=ye.concat([...J.keys()].sort((De,Ce)=>this.e.indexOf(De)-this.e.indexOf(Ce)))),ye}prioritize(x,J){const ye=this.f(x);if(ye===-1){this.d.unshift({pattern:x,matches:L.$Aj(a(x))});return}const De=new Set(J.map(ge=>this.f(ge,ye)));De.delete(-1);const Ce=Array.from(De).sort();this.d.splice(ye+1,0,...Ce.map(ge=>this.d[ge]));for(let ge=Ce.length-1;ge>=0;ge--)this.d.splice(Ce[ge],1)}toArray(){return this.d.map(x=>x.pattern)}f(x,J=this.d.length){const ye=a(x);for(let De=0;De<J;De++)if(this.d[De].matches(ye))return De;return-1}}e.$sI=l;function r(N,x,J,ye=(De,Ce)=>De===Ce){const De=[];function Ce(re,oe,ve){if(oe===0&&ve.length===0)return;const ee=De[De.length-1];ee&&ee.start+ee.deleteCount===re?(ee.deleteCount+=oe,ee.toInsert.push(...ve)):De.push({start:re,deleteCount:oe,toInsert:ve})}let ge=0,we=0;for(;;){if(ge===N.length){Ce(ge,0,x.slice(we));break}if(we===x.length){Ce(ge,N.length-ge,[]);break}const re=N[ge],oe=x[we];if(ye(re,oe)){ge+=1,we+=1;continue}J(oe)?(Ce(ge,1,[]),ge+=1):(Ce(ge,0,[oe]),we+=1)}return De}e.$tI=r,e.$uI=new g.$$i("notebookEditorCursorAtBoundary","none"),e.$vI=new g.$$i("notebookEditorCursorAtLineBoundary","none");var s;(function(N){N.default="default",N.option="option"})(s||(e.NotebookEditorPriority=s={}));function c(N){const x=N;return!!((typeof x.include=="string"||L.$Bj(x.include))&&(typeof x.exclude=="string"||L.$Bj(x.exclude)))}e.$wI=c;function h(N,x,J){if(Array.isArray(N.viewType)&&N.viewType.indexOf(x)>=0||N.viewType===x)return!0;if(N.filenamePattern){const ye=c(N.filenamePattern)?N.filenamePattern.include:N.filenamePattern,De=c(N.filenamePattern)?N.filenamePattern.exclude:void 0;if(L.$zj(ye,(0,$.$mc)(J.fsPath).toLowerCase()))return!(De&&L.$zj(De,(0,$.$mc)(J.fsPath).toLowerCase()))}return!1}e.$xI=h,e.$yI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell"};var w;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(w||(e.CellStatusbarAlignment=w={}));class m{static{this.d="notebook/"}static create(x){return`${m.d}${x}`}static parse(x){if(x.startsWith(m.d))return x.substring(m.d.length)}}e.$zI=m;function I(N){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(N)}e.$AI=I;const k=new TextDecoder;function d(N){const x=[];let J=!1;for(const ge of N)(x.length===0||J)&&(x.push(ge),J=!0);let ye=C(x);const De=E.$ce.concat(x.map(ge=>E.$ce.wrap(ge))),Ce=F(De);return ye=ye||Ce.byteLength!==De.byteLength,{data:Ce,didCompression:ye}}e.$BI=d,e.$CI=`${String.fromCharCode(27)}[A`;const b=e.$CI.split("").map(N=>N.charCodeAt(0)),y=10;function C(N){let x=!1;return N.forEach((J,ye)=>{if(ye===0||J.length<e.$CI.length)return;const De=N[ye-1],Ce=J.subarray(0,e.$CI.length);if(Ce[0]===b[0]&&Ce[1]===b[1]&&Ce[2]===b[2]){const ge=De.lastIndexOf(y);if(ge===-1)return;x=!0,N[ye-1]=De.subarray(0,ge),N[ye]=J.subarray(e.$CI.length)}}),x}function B(N){let x=N;do N=x,x=N.replace(/[^\n]\x08/gm,"");while(x.length<N.length);return N}function H(N){for(N=N.replace(/\r+\n/gm,`
`);N.search(/\r[^$]/g)>-1;){const x=N.match(/^(.*)\r+/m)[1];let J=N.match(/\r+(.*)$/m)[1];J=J+x.slice(J.length,x.length),N=N.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,J)}return N}const U="\b".charCodeAt(0),z="\r".charCodeAt(0);function F(N){return!N.buffer.includes(U)&&!N.buffer.includes(z)?N:E.$ce.fromString(H(B(k.decode(N.buffer))))}}),define(Ae[7],Re([1,0,18,11,53,28,69,13,16,2,38,22,41,100,76]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o,v,p){"use strict";var f,t,i,n,u,a,l,r,s,c,h,w,m,I,k,d,b,y;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$mM=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$lM=e.$kM=e.$jM=e.$iM=e.$hM=e.$gM=e.$fM=e.$eM=e.$dM=e.$cM=e.$bM=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$aM=e.$_L=e.$$L=e.$0L=e.$9L=e.$8L=e.$7L=e.$6L=e.TestRunProfileKind=e.TestResultState=e.$5L=e.$4L=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$3L=e.$2L=e.$1L=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$ZL=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$YL=e.$XL=e.$WL=e.$VL=e.$UL=e.ColorThemeKind=e.$TL=e.$SL=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$RL=e.DebugConsoleMode=e.$QL=e.$PL=e.$OL=e.$NL=e.$ML=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$LL=e.$KL=e.FileChangeType=e.$JL=e.$IL=e.$HL=e.$GL=e.InlineCompletionTriggerKind=e.$FL=e.$EL=e.$DL=e.$CL=e.$BL=e.$AL=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=e.$uL=e.$tL=e.ConfigurationTarget=e.$sL=e.$rL=e.$qL=e.$pL=e.$oL=e.$nL=e.$mL=e.$lL=e.$kL=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$jL=e.ViewBadge=e.ProgressLocation=e.$iL=e.$hL=e.TaskScope=e.ShellQuoting=e.$gL=e.$fL=e.$eL=e.TaskPanelKind=e.TaskRevealKind=e.$dL=e.TerminalLocation=e.$cL=e.$bL=e.$aL=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$_K=e.$$K=e.$0K=e.$9K=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$8K=e.StatusBarAlignment=e.ViewColumn=e.$7K=e.$6K=e.$5K=e.$4K=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$3K=e.$2K=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$1K=e.$ZK=e.$YK=e.$XK=e.$WK=e.LanguageStatusSeverity=e.$VK=e.$UK=e.$TK=e.$SK=e.$RK=e.$QK=e.CodeActionTriggerKind=e.$PK=e.$OK=e.SymbolTag=e.SymbolKind=e.$NK=e.DocumentHighlightKind=e.$MK=e.$LK=e.$KK=e.$JK=e.DiagnosticSeverity=e.DiagnosticTag=e.$IK=e.$HK=e.FileEditType=e.$GK=e.$FK=e.$EK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$DK=e.$CK=e.$BK=e.$AK=e.$zK=e.$yK=e.$xK=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function C(j){return Object.assign(j,{apply:function(...ce){if(ce.length===0)return Reflect.construct(j,[]);{const ke=ce.length===1?[]:ce[1];return Reflect.construct(j,ke,ce[0].constructor)}},call:function(...ce){if(ce.length===0)return Reflect.construct(j,[]);{const[ke,...He]=ce;return Reflect.construct(j,He,ke.constructor)}}})}var B;(function(j){j[j.Top=0]="Top",j[j.Bottom=1]="Bottom"})(B||(e.TerminalOutputAnchor=B={}));var H;(function(j){j[j.TerminalCommand=0]="TerminalCommand",j[j.Opener=1]="Opener",j[j.Command=3]="Command"})(H||(e.TerminalQuickFixType=H={}));let U=f=class{static from(...O){let ce=O;return new f(function(){if(ce){for(const ke of ce)ke&&typeof ke.dispose=="function"&&ke.dispose();ce=void 0}})}#e;constructor(O){this.#e=O}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$xK=U,e.$xK=U=f=Ke([C],U);let z=t=class{static Min(...O){if(O.length===0)throw new TypeError;let ce=O[0];for(let ke=1;ke<O.length;ke++){const He=O[ke];He.isBefore(ce)&&(ce=He)}return ce}static Max(...O){if(O.length===0)throw new TypeError;let ce=O[0];for(let ke=1;ke<O.length;ke++){const He=O[ke];He.isAfter(ce)&&(ce=He)}return ce}static isPosition(O){if(!O)return!1;if(O instanceof t)return!0;const{line:ce,character:ke}=O;return typeof ce=="number"&&typeof ke=="number"}static of(O){if(O instanceof t)return O;if(this.isPosition(O))return new t(O.line,O.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(O,ce){if(O<0)throw(0,L.$6)("line must be non-negative");if(ce<0)throw(0,L.$6)("character must be non-negative");this.c=O,this.e=ce}isBefore(O){return this.c<O.c?!0:O.c<this.c?!1:this.e<O.e}isBeforeOrEqual(O){return this.c<O.c?!0:O.c<this.c?!1:this.e<=O.e}isAfter(O){return!this.isBeforeOrEqual(O)}isAfterOrEqual(O){return!this.isBefore(O)}isEqual(O){return this.c===O.c&&this.e===O.e}compareTo(O){return this.c<O.c?-1:this.c>O.line?1:this.e<O.e?-1:this.e>O.e?1:0}translate(O,ce=0){if(O===null||ce===null)throw(0,L.$6)();let ke;return typeof O>"u"?ke=0:typeof O=="number"?ke=O:(ke=typeof O.lineDelta=="number"?O.lineDelta:0,ce=typeof O.characterDelta=="number"?O.characterDelta:0),ke===0&&ce===0?this:new t(this.line+ke,this.character+ce)}with(O,ce=this.character){if(O===null||ce===null)throw(0,L.$6)();let ke;return typeof O>"u"?ke=this.line:typeof O=="number"?ke=O:(ke=typeof O.line=="number"?O.line:this.line,ce=typeof O.character=="number"?O.character:this.character),ke===this.line&&ce===this.character?this:new t(ke,ce)}toJSON(){return{line:this.line,character:this.character}}};e.$yK=z,e.$yK=z=t=Ke([C],z);let F=i=class{static isRange(O){return O instanceof i?!0:O?z.isPosition(O.start)&&z.isPosition(O.end):!1}static of(O){if(O instanceof i)return O;if(this.isRange(O))return new i(O.start,O.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(O,ce,ke,He){let Ze,st;if(typeof O=="number"&&typeof ce=="number"&&typeof ke=="number"&&typeof He=="number"?(Ze=new z(O,ce),st=new z(ke,He)):z.isPosition(O)&&z.isPosition(ce)&&(Ze=z.of(O),st=z.of(ce)),!Ze||!st)throw new Error("Invalid arguments");Ze.isBefore(st)?(this.c=Ze,this.e=st):(this.c=st,this.e=Ze)}contains(O){return i.isRange(O)?this.contains(O.start)&&this.contains(O.end):z.isPosition(O)?!(z.of(O).isBefore(this.c)||this.e.isBefore(O)):!1}isEqual(O){return this.c.isEqual(O.c)&&this.e.isEqual(O.e)}intersection(O){const ce=z.Max(O.start,this.c),ke=z.Min(O.end,this.e);if(!ce.isAfter(ke))return new i(ce,ke)}union(O){if(this.contains(O))return this;if(O.contains(this))return O;const ce=z.Min(O.start,this.c),ke=z.Max(O.end,this.end);return new i(ce,ke)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(O,ce=this.end){if(O===null||ce===null)throw(0,L.$6)();let ke;return O?z.isPosition(O)?ke=O:(ke=O.start||this.start,ce=O.end||this.end):ke=this.start,ke.isEqual(this.c)&&ce.isEqual(this.end)?this:new i(ke,ce)}toJSON(){return[this.start,this.end]}};e.$zK=F,e.$zK=F=i=Ke([C],F);let N=n=class extends F{static isSelection(O){return O instanceof n?!0:O?F.isRange(O)&&z.isPosition(O.anchor)&&z.isPosition(O.active)&&typeof O.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(O,ce,ke,He){let Ze,st;if(typeof O=="number"&&typeof ce=="number"&&typeof ke=="number"&&typeof He=="number"?(Ze=new z(O,ce),st=new z(ke,He)):z.isPosition(O)&&z.isPosition(ce)&&(Ze=z.of(O),st=z.of(ce)),!Ze||!st)throw new Error("Invalid arguments");super(Ze,st),this.f=Ze,this.g=st}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$AK=N,e.$AK=N=n=Ke([C],N);const x=j=>{if(typeof j!="string"||j.length===0||!/^[0-9A-Za-z_\-]+$/.test(j))throw(0,L.$6)("connectionToken")};class J{static isResolvedAuthority(O){return O&&typeof O=="object"&&typeof O.host=="string"&&typeof O.port=="number"&&(O.connectionToken===void 0||typeof O.connectionToken=="string")}constructor(O,ce,ke){if(typeof O!="string"||O.length===0)throw(0,L.$6)("host");if(typeof ce!="number"||ce===0||Math.round(ce)!==ce)throw(0,L.$6)("port");typeof ke<"u"&&x(ke),this.host=O,this.port=Math.round(ce),this.connectionToken=ke}}e.$BK=J;class ye{static isManagedResolvedAuthority(O){return O&&typeof O=="object"&&typeof O.makeConnection=="function"&&(O.connectionToken===void 0||typeof O.connectionToken=="string")}constructor(O,ce){this.makeConnection=O,this.connectionToken=ce,typeof ce<"u"&&x(ce)}}e.$CK=ye;class De extends Error{static NotAvailable(O,ce){return new De(O,v.RemoteAuthorityResolverErrorCode.NotAvailable,ce)}static TemporarilyNotAvailable(O){return new De(O,v.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(O,ce=v.RemoteAuthorityResolverErrorCode.Unknown,ke){super(O),this._message=O,this._code=ce,this._detail=ke,Object.setPrototypeOf(this,De.prototype)}}e.$DK=De;var Ce;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(Ce||(e.EndOfLine=Ce={}));var ge;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(ge||(e.EnvironmentVariableMutatorType=ge={}));let we=u=class{static isTextEdit(O){return O instanceof u?!0:O?F.isRange(O)&&typeof O.newText=="string":!1}static replace(O,ce){return new u(O,ce)}static insert(O,ce){return u.replace(new F(O,O),ce)}static delete(O){return u.replace(O,"")}static setEndOfLine(O){const ce=new u(new F(new z(0,0),new z(0,0)),"");return ce.newEol=O,ce}get range(){return this.c}set range(O){if(O&&!F.isRange(O))throw(0,L.$6)("range");this.c=O}get newText(){return this.e||""}set newText(O){if(O&&typeof O!="string")throw(0,L.$6)("newText");this.e=O}get newEol(){return this.f}set newEol(O){if(O&&typeof O!="number")throw(0,L.$6)("newEol");this.f=O}constructor(O,ce){this.c=O,this.e=ce}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$EK=we,e.$EK=we=u=Ke([C],we);let re=a=class{static isNotebookCellEdit(O){return O instanceof a?!0:O?xt.isNotebookRange(O)&&Array.isArray(O.newCells):!1}static replaceCells(O,ce){return new a(O,ce)}static insertCells(O,ce){return new a(new xt(O,O),ce)}static deleteCells(O){return new a(O,[])}static updateCellMetadata(O,ce){const ke=new a(new xt(O,O),[]);return ke.newCellMetadata=ce,ke}static updateNotebookMetadata(O){const ce=new a(new xt(0,0),[]);return ce.newNotebookMetadata=O,ce}constructor(O,ce){this.range=O,this.newCells=ce}};e.$FK=re,e.$FK=re=a=Ke([C],re);class oe{static isSnippetTextEdit(O){return O instanceof oe?!0:O?F.isRange(O.range)&&W.isSnippetString(O.snippet):!1}static replace(O,ce){return new oe(O,ce)}static insert(O,ce){return oe.replace(new F(O,O),ce)}constructor(O,ce){this.range=O,this.snippet=ce}}e.$GK=oe;var ve;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace",j[j.Snippet=6]="Snippet"})(ve||(e.FileEditType=ve={}));let ee=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(O,ce,ke,He){this.c.push({_type:1,from:O,to:ce,options:ke,metadata:He})}createFile(O,ce,ke){this.c.push({_type:1,from:void 0,to:O,options:ce,metadata:ke})}deleteFile(O,ce,ke){this.c.push({_type:1,from:O,to:void 0,options:ce,metadata:ke})}e(O,ce,ke){this.c.push({_type:3,metadata:ke,uri:O,edit:{editType:5,metadata:ce},notebookMetadata:ce})}f(O,ce,ke,He){const Ze=ce.start,st=ce.end;(Ze!==st||ke.length>0)&&this.c.push({_type:5,uri:O,index:Ze,count:st-Ze,cells:ke,metadata:He})}g(O,ce,ke,He){this.c.push({_type:3,metadata:He,uri:O,edit:{editType:3,index:ce,metadata:ke}})}replace(O,ce,ke,He){this.c.push({_type:2,uri:O,edit:new we(ce,ke),metadata:He})}insert(O,ce,ke,He){this.replace(O,new F(ce,ce),ke,He)}delete(O,ce,ke){this.replace(O,ce,"",ke)}has(O){return this.c.some(ce=>ce._type===2&&ce.uri.toString()===O.toString())}set(O,ce){if(ce)for(const ke of ce){if(!ke)continue;let He,Ze;Array.isArray(ke)?(He=ke[0],Ze=ke[1]):He=ke,re.isNotebookCellEdit(He)?He.newCellMetadata?this.g(O,He.range.start,He.newCellMetadata,Ze):He.newNotebookMetadata?this.e(O,He.newNotebookMetadata,Ze):this.f(O,He.range,He.newCells,Ze):oe.isSnippetTextEdit(He)?this.c.push({_type:6,uri:O,range:He.range,edit:He.snippet,metadata:Ze}):this.c.push({_type:2,uri:O,edit:He,metadata:Ze})}else{for(let ke=0;ke<this.c.length;ke++){const He=this.c[ke];switch(He._type){case 2:case 6:case 3:case 5:He.uri.toString()===O.toString()&&(this.c[ke]=void 0);break}}(0,E.$Hb)(this.c)}}get(O){const ce=[];for(const ke of this.c)ke._type===2&&ke.uri.toString()===O.toString()&&ce.push(ke.edit);return ce}entries(){const O=new M.$zc;for(const ce of this.c)if(ce._type===2){let ke=O.get(ce.uri);ke||(ke=[ce.uri,[]],O.set(ce.uri,ke)),ke[1].push(ce.edit)}return[...O.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$HK=ee,e.$HK=ee=Ke([C],ee);let W=l=class{static isSnippetString(O){return O instanceof l?!0:O?typeof O.value=="string":!1}static c(O){return O.replace(/\$|}|\\/g,"\\$&")}constructor(O){this.e=1,this.value=O||""}appendText(O){return this.value+=l.c(O),this}appendTabstop(O=this.e++){return this.value+="$",this.value+=O,this}appendPlaceholder(O,ce=this.e++){if(typeof O=="function"){const ke=new l;ke.e=this.e,O(ke),this.e=ke.e,O=ke.value}else O=l.c(O);return this.value+="${",this.value+=ce,this.value+=":",this.value+=O,this.value+="}",this}appendChoice(O,ce=this.e++){const ke=O.map(He=>He.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ce,this.value+="|",this.value+=ke,this.value+="|}",this}appendVariable(O,ce){if(typeof ce=="function"){const ke=new l;ke.e=this.e,ce(ke),this.e=ke.e,ce=ke.value}else typeof ce=="string"&&(ce=ce.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=O,ce&&(this.value+=":",this.value+=ce),this.value+="}",this}};e.$IK=W,e.$IK=W=l=Ke([C],W);var ue;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(ue||(e.DiagnosticTag=ue={}));var Pe;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(Pe||(e.DiagnosticSeverity=Pe={}));let Ee=r=class{static isLocation(O){return O instanceof r?!0:O?F.isRange(O.range)&&g.URI.isUri(O.uri):!1}constructor(O,ce){if(this.uri=O,ce)if(F.isRange(ce))this.range=F.of(ce);else if(z.isPosition(ce))this.range=new F(ce,ce);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$JK=Ee,e.$JK=Ee=r=Ke([C],Ee);let te=class{static is(O){return O?typeof O.message=="string"&&O.location&&F.isRange(O.location.range)&&g.URI.isUri(O.location.uri):!1}constructor(O,ce){this.location=O,this.message=ce}static isEqual(O,ce){return O===ce?!0:!O||!ce?!1:O.message===ce.message&&O.location.range.isEqual(ce.location.range)&&O.location.uri.toString()===ce.location.uri.toString()}};e.$KK=te,e.$KK=te=Ke([C],te);let se=class{constructor(O,ce,ke=Pe.Error){if(!F.isRange(O))throw new TypeError("range must be set");if(!ce)throw new TypeError("message must be set");this.range=O,this.message=ce,this.severity=ke}toJSON(){return{severity:Pe[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(O,ce){return O===ce?!0:!O||!ce?!1:O.message===ce.message&&O.severity===ce.severity&&O.code===ce.code&&O.severity===ce.severity&&O.source===ce.source&&O.range.isEqual(ce.range)&&(0,E.$tb)(O.tags,ce.tags)&&(0,E.$tb)(O.relatedInformation,ce.relatedInformation,te.isEqual)}};e.$LK=se,e.$LK=se=Ke([C],se);let me=class{constructor(O,ce){if(!O)throw new Error("Illegal argument, contents must be defined");Array.isArray(O)?this.contents=O:this.contents=[O],this.range=ce}};e.$MK=me,e.$MK=me=Ke([C],me);var Z;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(Z||(e.DocumentHighlightKind=Z={}));let le=class{constructor(O,ce=Z.Text){this.range=O,this.kind=ce}toJSON(){return{range:this.range,kind:Z[this.kind]}}};e.$NK=le,e.$NK=le=Ke([C],le);var ne;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(ne||(e.SymbolKind=ne={}));var ae;(function(j){j[j.Deprecated=1]="Deprecated"})(ae||(e.SymbolTag=ae={}));let de=s=class{static validate(O){if(!O.name)throw new Error("name must not be falsy")}constructor(O,ce,ke,He,Ze){this.name=O,this.kind=ce,this.containerName=Ze,typeof ke=="string"&&(this.containerName=ke),He instanceof Ee?this.location=He:ke instanceof F&&(this.location=new Ee(He,ke)),s.validate(this)}toJSON(){return{name:this.name,kind:ne[this.kind],location:this.location,containerName:this.containerName}}};e.$OK=de,e.$OK=de=s=Ke([C],de);let Ie=c=class{static validate(O){if(!O.name)throw new Error("name must not be falsy");if(!O.range.contains(O.selectionRange))throw new Error("selectionRange must be contained in fullRange");O.children?.forEach(c.validate)}constructor(O,ce,ke,He,Ze){this.name=O,this.detail=ce,this.kind=ke,this.range=He,this.selectionRange=Ze,this.children=[],c.validate(this)}};e.$PK=Ie,e.$PK=Ie=c=Ke([C],Ie);var T;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(T||(e.CodeActionTriggerKind=T={}));let V=class{constructor(O,ce){this.title=O,this.kind=ce}};e.$QK=V,e.$QK=V=Ke([C],V);let G=class{static{h=this}static{this.c="."}constructor(O){this.value=O}append(O){return new h(this.value?this.value+h.c+O:O)}intersects(O){return this.contains(O)||O.contains(this)}contains(O){return this.value===O.value||O.value.startsWith(this.value+h.c)}};e.$RK=G,e.$RK=G=h=Ke([C],G),G.Empty=new G(""),G.QuickFix=G.Empty.append("quickfix"),G.Refactor=G.Empty.append("refactor"),G.RefactorExtract=G.Refactor.append("extract"),G.RefactorInline=G.Refactor.append("inline"),G.RefactorMove=G.Refactor.append("move"),G.RefactorRewrite=G.Refactor.append("rewrite"),G.Source=G.Empty.append("source"),G.SourceOrganizeImports=G.Source.append("organizeImports"),G.SourceFixAll=G.Source.append("fixAll"),G.Notebook=G.Empty.append("notebook");let Q=class{constructor(O,ce){if(this.range=O,this.parent=ce,ce&&!ce.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$SK=Q,e.$SK=Q=Ke([C],Q);class q{constructor(O,ce,ke,He,Ze,st){this.kind=O,this.name=ce,this.detail=ke,this.uri=He,this.range=Ze,this.selectionRange=st}}e.$TK=q;class _{constructor(O,ce){this.fromRanges=ce,this.from=O}}e.$UK=_;class he{constructor(O,ce){this.fromRanges=ce,this.to=O}}e.$VK=he;var Oe;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(Oe||(e.LanguageStatusSeverity=Oe={}));let je=class{constructor(O,ce){this.range=O,this.command=ce}get isResolved(){return!!this.command}};e.$WK=je,e.$WK=je=Ke([C],je);let Qe=w=class{#e;static isMarkdownString(O){return O instanceof w?!0:O&&O.appendCodeblock&&O.appendMarkdown&&O.appendText&&O.value!==void 0}constructor(O,ce=!1){this.#e=new P.$7j(O,{supportThemeIcons:ce})}get value(){return this.#e.value}set value(O){this.#e.value=O}get isTrusted(){return this.#e.isTrusted}set isTrusted(O){this.#e.isTrusted=O}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(O){this.#e.supportThemeIcons=O}get supportHtml(){return this.#e.supportHtml}set supportHtml(O){this.#e.supportHtml=O}get baseUri(){return this.#e.baseUri}set baseUri(O){this.#e.baseUri=O}appendText(O){return this.#e.appendText(O),this}appendMarkdown(O){return this.#e.appendMarkdown(O),this}appendCodeblock(O,ce){return this.#e.appendCodeblock(ce??"",O),this}};e.$XK=Qe,e.$XK=Qe=w=Ke([C],Qe);let Ge=class{constructor(O,ce){this.label=O,this.documentation=ce}};e.$YK=Ge,e.$YK=Ge=Ke([C],Ge);let _e=class{constructor(O,ce){this.label=O,this.documentation=ce,this.parameters=[]}};e.$ZK=_e,e.$ZK=_e=Ke([C],_e);let Ye=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$1K=Ye,e.$1K=Ye=Ke([C],Ye);var xe;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(xe||(e.SignatureHelpTriggerKind=xe={}));var it;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(it||(e.InlayHintKind=it={}));let tt=class{constructor(O){this.value=O}};e.$2K=tt,e.$2K=tt=Ke([C],tt);let ze=class{constructor(O,ce,ke){this.position=O,this.label=ce,this.kind=ke}};e.$3K=ze,e.$3K=ze=Ke([C],ze);var ut;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ut||(e.CompletionTriggerKind=ut={}));var Y;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(Y||(e.CompletionItemKind=Y={}));var X;(function(j){j[j.Deprecated=1]="Deprecated"})(X||(e.CompletionItemTag=X={}));let be=class{constructor(O,ce){this.label=O,this.kind=ce}toJSON(){return{label:this.label,kind:this.kind&&Y[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$4K=be,e.$4K=be=Ke([C],be);let Be=class{constructor(O=[],ce=!1){this.items=O,this.isIncomplete=ce}};e.$5K=Be,e.$5K=Be=Ke([C],Be);let Ne=class{constructor(O,ce,ke){this.insertText=O,this.range=ce,this.command=ke}};e.$6K=Ne,e.$6K=Ne=Ke([C],Ne);let Xe=class{constructor(O){this.commands=void 0,this.suppressSuggestions=void 0,this.items=O}};e.$7K=Xe,e.$7K=Xe=Ke([C],Xe);var nt;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(nt||(e.ViewColumn=nt={}));var $t;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})($t||(e.StatusBarAlignment=$t={}));function wt(j,O){return`${S.$0l.toKey(j)}.${O}`}e.$8K=wt;var Pt;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative"})(Pt||(e.TextEditorLineNumbersStyle=Pt={}));var Kt;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(Kt||(e.TextDocumentSaveReason=Kt={}));var Ht;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Ht||(e.TextEditorRevealType=Ht={}));var vt;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(vt||(e.TextEditorSelectionChangeKind=vt={}));var Ut;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(Ut||(e.TextDocumentChangeReason=Ut={}));var Ot;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(Ot||(e.DecorationRangeBehavior=Ot={})),function(j){function O(ce){switch(ce){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=O}(vt||(e.TextEditorSelectionChangeKind=vt={}));var Gt;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(Gt||(e.SyntaxTokenType=Gt={})),function(j){function O(ce){switch(ce){case j.Other:return"other";case j.Comment:return"comment";case j.String:return"string";case j.RegEx:return"regex"}return"other"}j.toString=O}(Gt||(e.SyntaxTokenType=Gt={}));let jt=class{constructor(O,ce){if(ce&&!g.URI.isUri(ce))throw(0,L.$6)("target");if(!F.isRange(O)||O.isEmpty)throw(0,L.$6)("range");this.range=O,this.target=ce}};e.$9K=jt,e.$9K=jt=Ke([C],jt);let kt=class{constructor(O,ce,ke,He){this.red=O,this.green=ce,this.blue=ke,this.alpha=He}};e.$0K=kt,e.$0K=kt=Ke([C],kt);let Ft=class{constructor(O,ce){if(ce&&!(ce instanceof kt))throw(0,L.$6)("color");if(!F.isRange(O)||O.isEmpty)throw(0,L.$6)("range");this.range=O,this.color=ce}};e.$$K=Ft,e.$$K=Ft=Ke([C],Ft);let Bt=class{constructor(O){if(!O||typeof O!="string")throw(0,L.$6)("label");this.label=O}};e.$_K=Bt,e.$_K=Bt=Ke([C],Bt);var Jt;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(Jt||(e.ColorFormat=Jt={}));var Wt;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(Wt||(e.SourceControlInputBoxValidationType=Wt={}));var Vt;(function(j){j[j.Unknown=0]="Unknown",j[j.Shutdown=1]="Shutdown",j[j.Process=2]="Process",j[j.User=3]="User",j[j.Extension=4]="Extension"})(Vt||(e.TerminalExitReason=Vt={}));class Nt{constructor(O,ce,ke){if(this.startIndex=O,this.length=ce,this.tooltip=ke,typeof O!="number"||O<0)throw(0,L.$6)("startIndex");if(typeof ce!="number"||ce<1)throw(0,L.$6)("length");if(ke!==void 0&&typeof ke!="string")throw(0,L.$6)("tooltip")}}e.$aL=Nt;class at{constructor(O){this.uri=O}}e.$bL=at;class dt{constructor(O){this.terminalCommand=O}}e.$cL=dt;var At;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(At||(e.TerminalLocation=At={}));class qt{constructor(O){if(this.options=O,typeof O!="object")throw(0,L.$6)("options")}}e.$dL=qt;var Rt;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(Rt||(e.TaskRevealKind=Rt={}));var ot;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(ot||(e.TaskPanelKind=ot={}));let bt=class{static{m=this}static{this.Clean=new m("clean","Clean")}static{this.Build=new m("build","Build")}static{this.Rebuild=new m("rebuild","Rebuild")}static{this.Test=new m("test","Test")}static from(O){switch(O){case"clean":return m.Clean;case"build":return m.Build;case"rebuild":return m.Rebuild;case"test":return m.Test;default:return}}constructor(O,ce){if(this.label=ce,typeof O!="string"||typeof ce!="string")throw(0,L.$6)("name");this.c=O}get id(){return this.c}};e.$eL=bt,e.$eL=bt=m=Ke([C],bt);function Tt(j){let O="";for(let ce=0;ce<j.length;ce++)O+=j[ce].replace(/,/g,",,")+",";return O}let Ct=class{constructor(O,ce,ke){if(typeof O!="string")throw(0,L.$6)("process");this.e=[],this.c=O,ce!==void 0&&(Array.isArray(ce)?(this.e=ce,this.f=ke):this.f=ce)}get process(){return this.c}set process(O){if(typeof O!="string")throw(0,L.$6)("process");this.c=O}get args(){return this.e}set args(O){Array.isArray(O)||(O=[]),this.e=O}get options(){return this.f}set options(O){this.f=O}computeId(){const O=[];if(O.push("process"),this.c!==void 0&&O.push(this.c),this.e&&this.e.length>0)for(const ce of this.e)O.push(ce);return Tt(O)}};e.$fL=Ct,e.$fL=Ct=Ke([C],Ct);let We=class{constructor(O,ce,ke){if(this.f=[],Array.isArray(ce)){if(!O)throw(0,L.$6)("command can't be undefined or null");if(typeof O!="string"&&typeof O.value!="string")throw(0,L.$6)("command");this.e=O,this.f=ce,this.g=ke}else{if(typeof O!="string")throw(0,L.$6)("commandLine");this.c=O,this.g=ce}}get commandLine(){return this.c}set commandLine(O){if(typeof O!="string")throw(0,L.$6)("commandLine");this.c=O}get command(){return this.e?this.e:""}set command(O){if(typeof O!="string"&&typeof O.value!="string")throw(0,L.$6)("command");this.e=O}get args(){return this.f}set args(O){this.f=O||[]}get options(){return this.g}set options(O){this.g=O}computeId(){const O=[];if(O.push("shell"),this.c!==void 0&&O.push(this.c),this.e!==void 0&&O.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ce of this.f)O.push(typeof ce=="string"?ce:ce.value);return Tt(O)}};e.$gL=We,e.$gL=We=Ke([C],We);var Qt;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(Qt||(e.ShellQuoting=Qt={}));var Se;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(Se||(e.TaskScope=Se={}));class Le{constructor(O){this.c=O}computeId(){return"customExecution"+(0,A.$fg)()}set callback(O){this.c=O}get callback(){return this.c}}e.$hL=Le;let $e=class{static{I=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(O,ce,ke,He,Ze,st){this.j=!1,this.k=this.definition=O;let lt;typeof ce=="string"?(this.m=this.name=ce,this.t=this.source=ke,this.execution=He,lt=Ze,this.j=!0):ce===Se.Global||ce===Se.Workspace?(this.target=ce,this.m=this.name=ke,this.t=this.source=He,this.execution=Ze,lt=st):(this.target=ce,this.m=this.name=ke,this.t=this.source=He,this.execution=Ze,lt=st),typeof lt=="string"?(this.o=[lt],this.q=!0):Array.isArray(lt)?(this.o=lt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.w=Object.create(null),this.x=Object.create(null)}get _id(){return this.h}set _id(O){this.h=O}get _deprecated(){return this.j}z(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.A())}A(){this.n instanceof Ct?this.k={type:I.e,id:this.n.computeId()}:this.n instanceof We?this.k={type:I.f,id:this.n.computeId()}:this.n instanceof Le?this.k={type:I.c,id:this.n.computeId()}:this.k={type:I.g,id:(0,A.$fg)()}}get definition(){return this.k}set definition(O){if(O==null)throw(0,L.$6)("Kind can't be undefined or null");this.z(),this.k=O}get scope(){return this.l}set target(O){this.z(),this.l=O}get name(){return this.m}set name(O){if(typeof O!="string")throw(0,L.$6)("name");this.z(),this.m=O}get execution(){return this.n}set execution(O){O===null&&(O=void 0),this.z(),this.n=O;const ce=this.k.type;(I.g===ce||I.e===ce||I.f===ce||I.c===ce)&&this.A()}get problemMatchers(){return this.o}set problemMatchers(O){if(Array.isArray(O))this.z(),this.o=O,this.q=!0;else{this.z(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(O){O!==!0&&O!==!1&&(O=!1),this.z(),this.r=O}get source(){return this.t}set source(O){if(typeof O!="string"||O.length===0)throw(0,L.$6)("source must be a string of length > 0");this.z(),this.t=O}get group(){return this.u}set group(O){O===null&&(O=void 0),this.z(),this.u=O}get detail(){return this.y}set detail(O){O===null&&(O=void 0),this.y=O}get presentationOptions(){return this.w}set presentationOptions(O){O==null&&(O=Object.create(null)),this.z(),this.w=O}get runOptions(){return this.x}set runOptions(O){O==null&&(O=Object.create(null)),this.z(),this.x=O}};e.$iL=$e,e.$iL=$e=I=Ke([C],$e);var K;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(K||(e.ProgressLocation=K={}));var Me;(function(j){function O(ce){const ke=ce;return(0,D.$Df)(ke.value)?ke.tooltip&&!(0,D.$zf)(ke.tooltip)?(console.log("INVALID view badge, invalid tooltip",ke.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",ke.value),!1)}j.isViewBadge=O})(Me||(e.ViewBadge=Me={}));let Ue=k=class{static isTreeItem(O,ce){const ke=O;if(ke.checkboxState!==void 0){const He=(0,D.$Df)(ke.checkboxState)?ke.checkboxState:(0,D.$Bf)(ke.checkboxState)&&(0,D.$Df)(ke.checkboxState.state)?ke.checkboxState.state:void 0,Ze=!(0,D.$Df)(ke.checkboxState)&&(0,D.$Bf)(ke.checkboxState)?ke.checkboxState.tooltip:void 0;if(He===void 0||He!==qe.Checked&&He!==qe.Unchecked||Ze!==void 0&&!(0,D.$zf)(Ze))return console.log("INVALID tree item, invalid checkboxState",ke.checkboxState),!1}if(O instanceof k)return!0;if(ke.label!==void 0&&!(0,D.$zf)(ke.label)&&!ke.label?.label)return console.log("INVALID tree item, invalid label",ke.label),!1;if(ke.id!==void 0&&!(0,D.$zf)(ke.id))return console.log("INVALID tree item, invalid id",ke.id),!1;if(ke.iconPath!==void 0&&!(0,D.$zf)(ke.iconPath)&&!g.URI.isUri(ke.iconPath)&&(!ke.iconPath||!(0,D.$zf)(ke.iconPath.id))){const He=ke.iconPath;if(!He||!(0,D.$zf)(He.light)&&!g.URI.isUri(He.light)&&!(0,D.$zf)(He.dark)&&!g.URI.isUri(He.dark))return console.log("INVALID tree item, invalid iconPath",ke.iconPath),!1}return ke.description!==void 0&&!(0,D.$zf)(ke.description)&&typeof ke.description!="boolean"?(console.log("INVALID tree item, invalid description",ke.description),!1):ke.resourceUri!==void 0&&!g.URI.isUri(ke.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",ke.resourceUri),!1):ke.tooltip!==void 0&&!(0,D.$zf)(ke.tooltip)&&!(ke.tooltip instanceof Qe)?(console.log("INVALID tree item, invalid tooltip",ke.tooltip),!1):ke.command!==void 0&&!ke.command.command?(console.log("INVALID tree item, invalid command",ke.command),!1):ke.collapsibleState!==void 0&&ke.collapsibleState<Je.None&&ke.collapsibleState>Je.Expanded?(console.log("INVALID tree item, invalid collapsibleState",ke.collapsibleState),!1):ke.contextValue!==void 0&&!(0,D.$zf)(ke.contextValue)?(console.log("INVALID tree item, invalid contextValue",ke.contextValue),!1):ke.accessibilityInformation!==void 0&&!ke.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",ke.accessibilityInformation),!1):!0}constructor(O,ce=Je.None){this.collapsibleState=ce,g.URI.isUri(O)?this.resourceUri=O:this.label=O}};e.$jL=Ue,e.$jL=Ue=k=Ke([C],Ue);var Je;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(Je||(e.TreeItemCollapsibleState=Je={}));var qe;(function(j){j[j.Unchecked=0]="Unchecked",j[j.Checked=1]="Checked"})(qe||(e.TreeItemCheckboxState=qe={}));let et=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(O){this.value=O}};e.$kL=et,e.$kL=et=Ke([C],et);class Et extends et{}e.$lL=Et;class Dt extends Et{#e;constructor(O){super(""),this.#e=O}asFile(){return this.#e}}e.$mL=Dt;class gt{constructor(O,ce,ke,He){this.name=O,this.uri=ce,this._itemId=ke,this.c=He}data(){return this.c()}}e.$nL=gt;let ht=class{#e=new Map;constructor(O){for(const[ce,ke]of O??[]){const He=this.#e.get(this.#t(ce));He?He.push(ke):this.#e.set(this.#t(ce),[ke])}}get(O){return this.#e.get(this.#t(O))?.[0]}set(O,ce){this.#e.set(this.#t(O),[ce])}forEach(O,ce){for(const[ke,He]of this.#e)for(const Ze of He)O.call(ce,Ze,ke,this)}*[Symbol.iterator](){for(const[O,ce]of this.#e)for(const ke of ce)yield[O,ke]}#t(O){return O.toLowerCase()}};e.$oL=ht,e.$oL=ht=Ke([C],ht);let ft=class{constructor(O){this.insertText=O}};e.$pL=ft,e.$pL=ft=Ke([C],ft);let ui=class{constructor(O,ce){this.label=ce,this.insertText=O}};e.$qL=ui,e.$qL=ui=Ke([C],ui);let St=class{constructor(O,ce){this.id=O,this.color=ce}static isThemeIcon(O){return typeof O.id!="string"?(console.log("INVALID ThemeIcon, invalid id",O.id),!1):!0}};e.$rL=St,e.$rL=St=Ke([C],St),St.File=new St("file"),St.Folder=new St("folder");let Si=class{constructor(O){this.id=O}};e.$sL=Si,e.$sL=Si=Ke([C],Si);var li;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(li||(e.ConfigurationTarget=li={}));let $i=class{get base(){return this.c}set base(O){this.c=O,this.e=g.URI.file(O)}get baseUri(){return this.e}set baseUri(O){this.e=O,this.c=O.fsPath}constructor(O,ce){if(typeof O!="string"&&(!O||!g.URI.isUri(O)&&!g.URI.isUri(O.uri)))throw(0,L.$6)("base");if(typeof ce!="string")throw(0,L.$6)("pattern");typeof O=="string"?this.baseUri=g.URI.file(O):g.URI.isUri(O)?this.baseUri=O:this.baseUri=O.uri,this.pattern=ce}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$tL=$i,e.$tL=$i=Ke([C],$i);const It=new WeakMap;function gn(j,O){It.set(j,O)}e.$uL=gn;let ri=class{constructor(O,ce,ke,He){this.enabled=typeof O=="boolean"?O:!0,typeof ce=="string"&&(this.condition=ce),typeof ke=="string"&&(this.hitCondition=ke),typeof He=="string"&&(this.logMessage=He)}get id(){return this.c||(this.c=It.get(this)??(0,A.$fg)()),this.c}};e.$vL=ri,e.$vL=ri=Ke([C],ri);let yt=class extends ri{constructor(O,ce,ke,He,Ze){if(super(ce,ke,He,Ze),O===null)throw(0,L.$6)("location");this.location=O}};e.$wL=yt,e.$wL=yt=Ke([C],yt);let pi=class extends ri{constructor(O,ce,ke,He,Ze){super(ce,ke,He,Ze),this.functionName=O}};e.$xL=pi,e.$xL=pi=Ke([C],pi);let vi=class extends ri{constructor(O,ce,ke,He,Ze,st,lt){if(super(He,Ze,st,lt),!ce)throw(0,L.$6)("dataId");this.label=O,this.dataId=ce,this.canPersist=ke}};e.$yL=vi,e.$yL=vi=Ke([C],vi);let si=class{constructor(O,ce,ke){this.command=O,this.args=ce||[],this.options=ke}};e.$zL=si,e.$zL=si=Ke([C],si);let Ii=class{constructor(O,ce){this.port=O,this.host=ce}};e.$AL=Ii,e.$AL=Ii=Ke([C],Ii);let Ci=class{constructor(O){this.path=O}};e.$BL=Ci,e.$BL=Ci=Ke([C],Ci);let Mt=class{constructor(O){this.implementation=O}};e.$CL=Mt,e.$CL=Mt=Ke([C],Mt);let wi=class{constructor(O,ce,ke){this.session=O,this.threadId=ce,this.frameId=ke}};e.$DL=wi,e.$DL=wi=Ke([C],wi);let Pi=class{constructor(O,ce){this.session=O,this.threadId=ce}};e.$EL=Pi,e.$EL=Pi=Ke([C],Pi);let oi=class{constructor(O,ce){this.range=O,this.expression=ce}};e.$FL=oi,e.$FL=oi=Ke([C],oi);var hi;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(hi||(e.InlineCompletionTriggerKind=hi={}));let ct=class{constructor(O,ce){this.range=O,this.text=ce}};e.$GL=ct,e.$GL=ct=Ke([C],ct);let Ai=class{constructor(O,ce,ke=!0){this.range=O,this.variableName=ce,this.caseSensitiveLookup=ke}};e.$HL=Ai,e.$HL=Ai=Ke([C],Ai);let Yt=class{constructor(O,ce){this.range=O,this.expression=ce}};e.$IL=Yt,e.$IL=Yt=Ke([C],Yt);let ii=class{constructor(O,ce){this.frameId=O,this.stoppedLocation=ce}};e.$JL=ii,e.$JL=ii=Ke([C],ii);var Ri;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(Ri||(e.FileChangeType=Ri={}));let Mi=d=class extends Error{static FileExists(O){return new d(O,o.FileSystemProviderErrorCode.FileExists,d.FileExists)}static FileNotFound(O){return new d(O,o.FileSystemProviderErrorCode.FileNotFound,d.FileNotFound)}static FileNotADirectory(O){return new d(O,o.FileSystemProviderErrorCode.FileNotADirectory,d.FileNotADirectory)}static FileIsADirectory(O){return new d(O,o.FileSystemProviderErrorCode.FileIsADirectory,d.FileIsADirectory)}static NoPermissions(O){return new d(O,o.FileSystemProviderErrorCode.NoPermissions,d.NoPermissions)}static Unavailable(O){return new d(O,o.FileSystemProviderErrorCode.Unavailable,d.Unavailable)}constructor(O,ce=o.FileSystemProviderErrorCode.Unknown,ke){super(g.URI.isUri(O)?O.toString(!0):O),this.code=ke?.name??"Unknown",(0,o.$rk)(this,ce),Object.setPrototypeOf(this,d.prototype),typeof Error.captureStackTrace=="function"&&typeof ke=="function"&&Error.captureStackTrace(this,ke)}};e.$KL=Mi,e.$KL=Mi=d=Ke([C],Mi);let Li=class{constructor(O,ce,ke){this.start=O,this.end=ce,this.kind=ke}};e.$LL=Li,e.$LL=Li=Ke([C],Li);var Xi;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(Xi||(e.FoldingRangeKind=Xi={}));var Fi;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(Fi||(e.CommentThreadCollapsibleState=Fi={}));var Zi;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(Zi||(e.CommentMode=Zi={}));var Ti;(function(j){j[j.Published=0]="Published",j[j.Draft=1]="Draft"})(Ti||(e.CommentState=Ti={}));var ai;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})(ai||(e.CommentThreadState=ai={}));class mn{constructor(O,ce=[]){this.tokenTypes=O,this.tokenModifiers=ce}}e.$ML=mn;function Oi(j){return typeof j>"u"||(0,D.$Af)(j)}class di{constructor(O){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,O){this.l=!0;for(let ce=0,ke=O.tokenTypes.length;ce<ke;ce++)this.j.set(O.tokenTypes[ce],ce);for(let ce=0,ke=O.tokenModifiers.length;ce<ke;ce++)this.k.set(O.tokenModifiers[ce],ce)}}push(O,ce,ke,He,Ze){if(typeof O=="number"&&typeof ce=="number"&&typeof ke=="number"&&typeof He=="number"&&(typeof Ze=="number"||typeof Ze>"u"))return typeof Ze>"u"&&(Ze=0),this.n(O,ce,ke,He,Ze);if(F.isRange(O)&&typeof ce=="string"&&Oi(ke))return this.m(O,ce,ke);throw(0,L.$6)()}m(O,ce,ke){if(!this.l)throw new Error("Legend must be provided in constructor");if(O.start.line!==O.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(ce))throw new Error("`tokenType` is not in the provided legend");const He=O.start.line,Ze=O.start.character,st=O.end.character-O.start.character,lt=this.j.get(ce);let zt=0;if(ke)for(const Zt of ke){if(!this.k.has(Zt))throw new Error("`tokenModifier` is not in the provided legend");const ei=this.k.get(Zt);zt|=1<<ei>>>0}this.n(He,Ze,st,lt,zt)}n(O,ce,ke,He,Ze){if(this.f&&(O<this.c||O===this.c&&ce<this.e)){this.f=!1;const zt=this.g.length/5|0;let Zt=0,ei=0;for(let ti=0;ti<zt;ti++){let ni=this.g[5*ti],Ji=this.g[5*ti+1];ni===0?(ni=Zt,Ji+=ei):ni+=Zt,this.g[5*ti]=ni,this.g[5*ti+1]=Ji,Zt=ni,ei=Ji}}let st=O,lt=ce;this.f&&this.h>0&&(st-=this.c,st===0&&(lt-=this.e)),this.g[this.h++]=st,this.g[this.h++]=lt,this.g[this.h++]=ke,this.g[this.h++]=He,this.g[this.h++]=Ze,this.c=O,this.e=ce}static o(O){const ce=[],ke=O.length/5|0;for(let lt=0;lt<ke;lt++)ce[lt]=lt;ce.sort((lt,zt)=>{const Zt=O[5*lt],ei=O[5*zt];if(Zt===ei){const ti=O[5*lt+1],ni=O[5*zt+1];return ti-ni}return Zt-ei});const He=new Uint32Array(O.length);let Ze=0,st=0;for(let lt=0;lt<ke;lt++){const zt=5*ce[lt],Zt=O[zt+0],ei=O[zt+1],ti=O[zt+2],ni=O[zt+3],Ji=O[zt+4],Cn=Zt-Ze,Tn=Cn===0?ei-st:ei,Qi=5*lt;He[Qi+0]=Cn,He[Qi+1]=Tn,He[Qi+2]=ti,He[Qi+3]=ni,He[Qi+4]=Ji,Ze=Zt,st=ei}return He}build(O){return this.f?new Ni(new Uint32Array(this.g),O):new Ni(di.o(this.g),O)}}e.$NL=di;class Ni{constructor(O,ce){this.resultId=ce,this.data=O}}e.$OL=Ni;class $n{constructor(O,ce,ke){this.start=O,this.deleteCount=ce,this.data=ke}}e.$PL=$n;class fi{constructor(O,ce){this.resultId=ce,this.edits=O}}e.$QL=fi;var Yi;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(Yi||(e.DebugConsoleMode=Yi={}));let zi=class{static{this.Back={iconPath:new St("arrow-left")}}constructor(){}};e.$RL=zi,e.$RL=zi=Ke([C],zi);var xi;(function(j){j[j.Separator=-1]="Separator",j[j.Default=0]="Default"})(xi||(e.QuickPickItemKind=xi={}));var gi;(function(j){j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(gi||(e.InputBoxValidationSeverity=gi={}));var _i;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(_i||(e.ExtensionKind=_i={}));class pn{static validate(O){if(typeof O.badge=="string"){let ce=(0,$.$af)(O.badge,0);if(ce<O.badge.length&&(ce+=(0,$.$af)(O.badge,ce)),O.badge.length>ce)throw new Error("The 'badge'-property must be undefined or a short character")}else if(O.badge&&!St.isThemeIcon(O.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!O.color&&!O.badge&&!O.tooltip)throw new Error("The decoration is empty");return!0}constructor(O,ce,ke){this.badge=O,this.tooltip=ce,this.color=ke}}e.$SL=pn;let Ui=class{constructor(O){this.kind=O}};e.$TL=Ui,e.$TL=Ui=Ke([C],Ui);var mi;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast",j[j.HighContrastLight=4]="HighContrastLight"})(mi||(e.ColorThemeKind=mi={}));class xt{static isNotebookRange(O){return O instanceof xt?!0:O?typeof O.start=="number"&&typeof O.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(O,ce){if(O<0)throw(0,L.$6)("start must be positive");if(ce<0)throw(0,L.$6)("end must be positive");O<=ce?(this.c=O,this.e=ce):(this.c=ce,this.e=O)}with(O){let ce=this.c,ke=this.e;return O.start!==void 0&&(ce=O.start),O.end!==void 0&&(ke=O.end),ce===this.c&&ke===this.e?this:new xt(ce,ke)}}e.$UL=xt;class bi{static validate(O){if(typeof O.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof O.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof O.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(O){return Array.isArray(O)&&O.every(ce=>bi.isNotebookCellData(ce))}static isNotebookCellData(O){return!0}constructor(O,ce,ke,He,Ze,st,lt){this.kind=O,this.value=ce,this.languageId=ke,this.mime=He,this.outputs=Ze??[],this.metadata=st,this.executionSummary=lt,bi.validate(this)}}e.$VL=bi;class en{constructor(O){this.cells=O}}e.$WL=en;class Xt{static isNotebookCellOutputItem(O){return O instanceof Xt?!0:O?typeof O.mime=="string"&&O.data instanceof Uint8Array:!1}static error(O){const ce={name:O.name,message:O.message,stack:O.stack};return Xt.json(ce,"application/vnd.code.notebook.error")}static stdout(O){return Xt.text(O,"application/vnd.code.notebook.stdout")}static stderr(O){return Xt.text(O,"application/vnd.code.notebook.stderr")}static bytes(O,ce="application/octet-stream"){return new Xt(O,ce)}static#e=new TextEncoder;static text(O,ce=R.$Tr.text){const ke=Xt.#e.encode(String(O));return new Xt(ke,ce)}static json(O,ce="text/x-json"){const ke=JSON.stringify(O,void 0,"	");return Xt.text(ke,ce)}constructor(O,ce){this.data=O,this.mime=ce;const ke=(0,R.$Xr)(ce,!0);if(!ke)throw new Error(`INVALID mime type: ${ce}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ke}}e.$XL=Xt;class yi{static isNotebookCellOutput(O){return O instanceof yi?!0:!O||typeof O!="object"?!1:typeof O.id=="string"&&Array.isArray(O.items)}static ensureUniqueMimeTypes(O,ce=!1){const ke=new Set,He=new Set;for(let Ze=0;Ze<O.length;Ze++){const st=O[Ze],lt=(0,R.$Xr)(st.mime);if(!ke.has(lt)||(0,p.$AI)(lt)){ke.add(lt);continue}He.add(Ze),ce&&console.warn(`DUPLICATED mime type '${st.mime}' will be dropped`)}return He.size===0?O:O.filter((Ze,st)=>!He.has(st))}constructor(O,ce,ke){this.items=yi.ensureUniqueMimeTypes(O,!0),typeof ce=="string"?(this.id=ce,this.metadata=ke):(this.id=(0,A.$fg)(),this.metadata=ce??ke)}}e.$YL=yi;var tn;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(tn||(e.NotebookCellKind=tn={}));var nn;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(nn||(e.NotebookCellExecutionState=nn={}));var rn;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(rn||(e.NotebookCellStatusBarAlignment=rn={}));var Ei;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Ei||(e.NotebookEditorRevealType=Ei={}));class sn{constructor(O,ce){this.text=O,this.alignment=ce}}e.$ZL=sn;var Te;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(Te||(e.NotebookControllerAffinity=Te={}));var _t;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred",j[j.Hidden=-1]="Hidden"})(_t||(e.NotebookControllerAffinity2=_t={}));class on{constructor(O,ce=[]){this.uri=O,this.provides=(0,E.$2b)(ce)}}e.$1L=on;class mt{constructor(O){this.label=O}}e.$2L=mt;let ji=class{constructor(O,ce){this.label=O,this.timestamp=ce}};e.$3L=ji,e.$3L=ji=Ke([C],ji);var an;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(an||(e.ExtensionMode=an={}));var Bi;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(Bi||(e.ExtensionRuntime=Bi={}));var cn;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(cn||(e.StandardTokenType=cn={}));class Di{constructor(O,ce){this.ranges=O,this.wordPattern=ce}}e.$4L=Di;class vn{constructor(O){this.c=O}get autoForwardAction(){return this.c}}e.$5L=vn;var un;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(un||(e.TestResultState=un={}));var ln;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(ln||(e.TestRunProfileKind=ln={}));let ki=class{constructor(O=void 0,ce=void 0,ke=void 0,He=!1){this.include=O,this.exclude=ce,this.profile=ke,this.continuous=He}};e.$6L=ki,e.$6L=ki=Ke([C],ki);let Wi=b=class{static diff(O,ce,ke){const He=new b(O);return He.expectedOutput=ce,He.actualOutput=ke,He}constructor(O){this.message=O}};e.$7L=Wi,e.$7L=Wi=b=Ke([C],Wi);let Vi=class{constructor(O){this.id=O}};e.$8L=Vi,e.$8L=Vi=Ke([C],Vi);let ci=class{constructor(O,ce){this.covered=O,this.total=ce}};e.$9L=ci,e.$9L=ci=Ke([C],ci);let qi=y=class{static fromDetails(O,ce){const ke=new ci(0,0),He=new ci(0,0),Ze=new ci(0,0);for(const lt of ce)if("branches"in lt){ke.total+=1,ke.covered+=lt.executionCount>0?1:0;for(const zt of lt.branches)He.total+=1,He.covered+=zt.executionCount>0?1:0}else Ze.total+=1,Ze.covered+=lt.executionCount>0?1:0;const st=new y(O,ke,He.total>0?He:void 0,Ze.total>0?Ze:void 0);return st.detailedCoverage=ce,st}constructor(O,ce,ke,He){this.uri=O,this.statementCoverage=ce,this.branchCoverage=ke,this.functionCoverage=He}};e.$0L=qi,e.$0L=qi=y=Ke([C],qi);let Ki=class{constructor(O,ce,ke=[]){this.executionCount=O,this.location=ce,this.branches=ke}};e.$$L=Ki,e.$$L=Ki=Ke([C],Ki);let Hi=class{constructor(O,ce){this.executionCount=O,this.location=ce}};e.$_L=Hi,e.$_L=Hi=Ke([C],Hi);let Gi=class{constructor(O,ce){this.executionCount=O,this.location=ce}};e.$aM=Gi,e.$aM=Gi=Ke([C],Gi);var hn;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(hn||(e.ExternalUriOpenerPriority=hn={}));var dn;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(dn||(e.WorkspaceTrustState=dn={}));var fn;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(fn||(e.PortAutoForwardAction=fn={}));class ie{constructor(O,ce,ke,He,Ze,st){this.kind=O,this.name=ce,this.detail=ke,this.uri=He,this.range=Ze,this.selectionRange=st}}e.$bM=ie;class fe{constructor(O){this.uri=O}}e.$cM=fe;class Fe{constructor(O,ce){this.original=O,this.modified=ce}}e.$dM=Fe;class rt{constructor(O,ce,ke,He){this.base=O,this.input1=ce,this.input2=ke,this.result=He}}e.$eM=rt;class pt{constructor(O,ce){this.uri=O,this.viewType=ce}}e.$fM=pt;class Lt{constructor(O){this.viewType=O}}e.$gM=Lt;class Pn{constructor(O,ce){this.uri=O,this.notebookType=ce}}e.$hM=Pn;class An{constructor(O,ce,ke){this.original=O,this.modified=ce,this.notebookType=ke}}e.$iM=An;class Rn{constructor(){}}e.$jM=Rn;class Mn{constructor(O,ce){this.uri=O,this.inputBoxUri=ce}}e.$kM=Mn;class Ln{constructor(O){this.providerId=O}}e.$lM=Ln;var wn;(function(j){j[j.Down=0]="Down",j[j.Up=1]="Up"})(wn||(e.InteractiveSessionVoteDirection=wn={}));var bn;(function(j){j[j.Action=1]="Action",j[j.Toolbar=2]="Toolbar"})(bn||(e.InteractiveSessionCopyKind=bn={}));var yn;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful",j[j.Undone=2]="Undone",j[j.Accepted=3]="Accepted"})(yn||(e.InteractiveEditorResponseFeedbackKind=yn={}));var En;(function(j){j[j.System=0]="System",j[j.User=1]="User",j[j.Assistant=2]="Assistant",j[j.Function=3]="Function"})(En||(e.ChatMessageRole=En={}));var Dn;(function(j){j[j.Short=1]="Short",j[j.Medium=2]="Medium",j[j.Full=3]="Full"})(Dn||(e.ChatVariableLevel=Dn={}));class Fn{constructor(O,ce){this.role=O,this.content=ce}}e.$mM=Fn;var kn;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful"})(kn||(e.ChatAgentResultFeedbackKind=kn={}));var Sn;(function(j){j[j.SymbolInformation=1]="SymbolInformation",j[j.CommandInformation=2]="CommandInformation",j[j.SearchInformation=3]="SearchInformation",j[j.SettingInformation=4]="SettingInformation"})(Sn||(e.RelatedInformationType=Sn={}));var In;(function(j){j[j.Started=1]="Started",j[j.Recognizing=2]="Recognizing",j[j.Recognized=3]="Recognized",j[j.Stopped=4]="Stopped"})(In||(e.SpeechToTextStatus=In={}))}),define(Ae[103],Re([1,0,55,14,13,297,147,7,18]),function(pe,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BM=e.$AM=e.$zM=void 0;const g=new Map;function A(p,f){f?g.set(p,f):g.delete(p)}e.$zM=A;function S(p){return g.get(p)}class o extends M.$Zu{constructor(f,t,i,n,u,a,l,r){super(t,i,n,u),this.c=f,this.m=a,this.q=l,this.notebook=r,this.b=!1}dispose(){(0,E.ok)(!this.b),this.b=!0,this.q=!1}equalLines(f){return(0,D.$tb)(this.f,f)}get document(){if(!this.a){const f=this;this.a={get uri(){return f.d},get fileName(){return f.d.fsPath},get isUntitled(){return f.d.scheme===L.Schemas.untitled},get languageId(){return f.m},get version(){return f.h},get isClosed(){return f.b},get isDirty(){return f.q},save(){return f.r()},getText(t){return t?f.s(t):f.getText()},get eol(){return f.g===`
`?$.EndOfLine.LF:$.EndOfLine.CRLF},get lineCount(){return f.f.length},lineAt(t){return f.t(t)},offsetAt(t){return f.u(t)},positionAt(t){return f.v(t)},validateRange(t){return f.w(t)},validatePosition(t){return f.x(t)},getWordRangeAtPosition(t,i){return f.y(t,i)}}}return Object.freeze(this.a)}_acceptLanguageId(f){(0,E.ok)(!this.b),this.m=f}_acceptIsDirty(f){(0,E.ok)(!this.b),this.q=f}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(f){const t=this.w(f);if(t.isEmpty)return"";if(t.isSingleLine)return this.f[t.start.line].substring(t.start.character,t.end.character);const i=this.g,n=t.start.line,u=t.end.line,a=[];a.push(this.f[n].substring(t.start.character));for(let l=n+1;l<u;l++)a.push(this.f[l]);return a.push(this.f[u].substring(0,t.end.character)),a.join(i)}t(f){let t;if(f instanceof $.$yK?t=f.line:typeof f=="number"&&(t=f),typeof t!="number"||t<0||t>=this.f.length||Math.floor(t)!==t)throw new Error("Illegal value for `line`");return new v(t,this.f[t],t===this.f.length-1)}u(f){return f=this.x(f),this.l(),this.j.getPrefixSum(f.line-1)+f.character}v(f){f=Math.floor(f),f=Math.max(0,f),this.l();const t=this.j.getIndexOf(f),i=this.f[t.index].length;return new $.$yK(t.index,Math.min(t.remainder,i))}w(f){if(!(f instanceof $.$zK))throw new Error("Invalid argument");const t=this.x(f.start),i=this.x(f.end);return t===f.start&&i===f.end?f:new $.$zK(t.line,t.character,i.line,i.character)}x(f){if(!(f instanceof $.$yK))throw new Error("Invalid argument");if(this.f.length===0)return f.with(0,0);let{line:t,character:i}=f,n=!1;if(t<0)t=0,i=0,n=!0;else if(t>=this.f.length)t=this.f.length-1,i=this.f[t].length,n=!0;else{const u=this.f[t].length;i<0?(i=0,n=!0):i>u&&(i=u,n=!0)}return n?new $.$yK(t,i):f}y(f,t){const i=this.x(f);if(!t)t=S(this.m);else if((0,P.$Pe)(t))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${t.source}' because it matches the empty string.`);const n=(0,R.$_r)(i.character+1,(0,R.$0r)(t),this.f[i.line],0);if(n)return new $.$zK(i.line,n.startColumn-1,i.line,n.endColumn-1)}}e.$AM=o;class v{constructor(f,t,i){this.a=f,this.b=t,this.c=i}get lineNumber(){return this.a}get text(){return this.b}get range(){return new $.$zK(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new $.$zK(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$BM=v}),define(Ae[211],Re([1,0,7,17,5]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aec=void 0;let M=class{constructor($){this.a=new E.$TL(E.ColorThemeKind.Dark),this.b=new P.$Od}get activeColorTheme(){return this.a}$onColorThemeChange($){let D;switch($){case"light":D=E.ColorThemeKind.Light;break;case"hcDark":D=E.ColorThemeKind.HighContrast;break;case"hcLight":D=E.ColorThemeKind.HighContrastLight;break;default:D=E.ColorThemeKind.Dark}this.a=new E.$TL(D),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Aec=M,e.$Aec=M=Ke([Ve(0,L.$xM)],M)}),define(Ae[212],Re([1,0,4]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EI=e.CellExecutionUpdateType=void 0;var L;(function(P){P[P.Output=1]="Output",P[P.OutputItems=2]="OutputItems",P[P.ExecutionState=3]="ExecutionState"})(L||(e.CellExecutionUpdateType=L={})),e.$EI=(0,E.$Th)("INotebookExecutionService")}),define(Ae[213],Re([1,0,6,29,144,93]),function(pe,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yOb=void 0;class R extends E.$Rc{constructor(D,g,A){super(),this._source=D,this.b=g,this.c=A,this.a=void 0}f(D){const g=D.getLineCount();return new L.$xs(1,1,g,this.g(D,g))}g(D,g){if(g<1||g>D.getLineCount())throw new Error("Illegal value for lineNumber");return D.getLineLength(g)+1}get inputTextBuffer(){if(!this.b){const D=new P.$KB;D.acceptChunk(this._source);const g=D.finish(!0),{textBuffer:A,disposable:S}=g.create(1);this.b=A,this.B(S)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(D=>{const g=new P.$KB;g.acceptChunk(D);const A=g.finish(!0),{textBuffer:S,disposable:o}=A.create(1);return this.B(o),S})),this.a}findInInputs(D){const A=new M.$yB(D,!1,!1,null).parseSearchRequest();if(!A)return[];const S=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(S,A,!0,5e3)}findInOutputs(D){const A=new M.$yB(D,!1,!1,null).parseSearchRequest();return A?this.outputTextBuffers.map(S=>{const o=S.findMatchesLineByLine(this.f(S),A,!0,5e3);if(o.length!==0)return{textBuffer:S,matches:o}}).filter(S=>!!S):[]}}e.$yOb=R}),define(Ae[48],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lJ=e.TestPosition=e.TestIdPathParts=void 0;var E;(function(M){M.Delimiter="\0"})(E||(e.TestIdPathParts=E={}));var L;(function(M){M[M.IsSame=0]="IsSame",M[M.Disconnected=1]="Disconnected",M[M.IsChild=2]="IsChild",M[M.IsParent=3]="IsParent"})(L||(e.TestPosition=L={}));class P{static fromExtHostTestItem(R,$,D=R.parent){if(R._isRoot)return new P([$]);const g=[R.id];for(let A=D;A&&A.id!==$;A=A.parent)g.push(A.id);return g.push($),new P(g.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const $=R.indexOf("\0");return $===-1?R:R.slice(0,$)}static fromString(R){return new P(R.split("\0"))}static join(R,$){return new P([...R.path,$])}static joinToString(R,$){return R.toString()+"\0"+$}static parentId(R){const $=R.lastIndexOf("\0");return $===-1?void 0:R.slice(0,$)}static localId(R){const $=R.lastIndexOf("\0");return $===-1?R:R.slice($+1)}static isChild(R,$){return $.startsWith(R)&&$[R.length]==="\0"}static compare(R,$){return R===$?0:P.isChild(R,$)?2:P.isChild($,R)?3:1}constructor(R,$=R.length){if(this.path=R,this.d=$,R.length===0||$<1)throw new Error("cannot create test with empty path")}get rootId(){return new P(this.path,1)}get parentId(){return this.d>1?new P(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new P(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new P(this.path,R)}compare(R){if(typeof R=="string")return P.compare(this.toString(),R);for(let $=0;$<R.d&&$<this.d;$++)if(R.path[$]!==this.path[$])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.$lJ=P}),define(Ae[60],Re([1,0,2,29,48]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sJ=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$rJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$qJ=e.$pJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$oJ=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$nJ=e.$mJ=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var M;(function(k){k[k.Unset=0]="Unset",k[k.Queued=1]="Queued",k[k.Running=2]="Running",k[k.Passed=3]="Passed",k[k.Failed=4]="Failed",k[k.Skipped=5]="Skipped",k[k.Errored=6]="Errored"})(M||(e.TestResultState=M={}));var R;(function(k){k[k.Run=1]="Run",k[k.Debug=2]="Debug",k[k.Coverage=3]="Coverage"})(R||(e.ExtTestRunProfileKind=R={}));var $;(function(k){k[k.Run=2]="Run",k[k.Debug=4]="Debug",k[k.Coverage=8]="Coverage",k[k.HasNonDefaultProfile=16]="HasNonDefaultProfile",k[k.HasConfigurable=32]="HasConfigurable",k[k.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$mJ=[2,4,8,16,32,64];const D=k=>"runId"in k;e.$nJ=D;var g;(function(k){k.serialize=d=>({range:d.range.toJSON(),uri:d.uri.toJSON()}),k.deserialize=d=>({range:L.$xs.lift(d.range),uri:E.URI.revive(d.uri)})})(g||(e.IRichLocation=g={}));var A;(function(k){k[k.Error=0]="Error",k[k.Output=1]="Output"})(A||(e.TestMessageType=A={}));var S;(function(k){k.serialize=d=>({message:d.message,type:0,expected:d.expected,actual:d.actual,contextValue:d.contextValue,location:d.location&&g.serialize(d.location)}),k.deserialize=d=>({message:d.message,type:0,expected:d.expected,actual:d.actual,contextValue:d.contextValue,location:d.location&&g.deserialize(d.location)})})(S||(e.ITestErrorMessage=S={}));const o=(k,d)=>`${d?"s":"e"}${k}`;e.$oJ=o;var v;(function(k){k.serialize=d=>({message:d.message,type:1,offset:d.offset,length:d.length,location:d.location&&g.serialize(d.location)}),k.deserialize=d=>({message:d.message,type:1,offset:d.offset,length:d.length,location:d.location&&g.deserialize(d.location)})})(v||(e.ITestOutputMessage=v={}));var p;(function(k){k.serialize=d=>d.type===0?S.serialize(d):v.serialize(d),k.deserialize=d=>d.type===0?S.deserialize(d):v.deserialize(d)})(p||(e.ITestMessage=p={}));var f;(function(k){k.serializeWithoutMessages=d=>({state:d.state,duration:d.duration,messages:[]}),k.serialize=d=>({state:d.state,duration:d.duration,messages:d.messages.map(p.serialize)}),k.deserialize=d=>({state:d.state,duration:d.duration,messages:d.messages.map(p.deserialize)})})(f||(e.ITestTaskState=f={}));const t="\0",i=(k,d)=>k+t+d;e.$pJ=i;const n=k=>{const d=k.indexOf(t);return{ctrlId:k.slice(0,d),tagId:k.slice(d+1)}};e.$qJ=n;var u;(function(k){k.serialize=d=>({extId:d.extId,label:d.label,tags:d.tags,busy:d.busy,children:void 0,uri:d.uri?.toJSON(),range:d.range?.toJSON()||null,description:d.description,error:d.error,sortText:d.sortText}),k.deserialize=d=>({extId:d.extId,label:d.label,tags:d.tags,busy:d.busy,children:void 0,uri:d.uri?E.URI.revive(d.uri):void 0,range:d.range?L.$xs.lift(d.range):null,description:d.description,error:d.error,sortText:d.sortText})})(u||(e.ITestItem=u={}));var a;(function(k){k[k.NotExpandable=0]="NotExpandable",k[k.Expandable=1]="Expandable",k[k.BusyExpanding=2]="BusyExpanding",k[k.Expanded=3]="Expanded"})(a||(e.TestItemExpandState=a={}));var l;(function(k){k.serialize=d=>({expand:d.expand,item:u.serialize(d.item)}),k.deserialize=d=>({controllerId:P.$lJ.root(d.item.extId),expand:d.expand,item:u.deserialize(d.item)})})(l||(e.InternalTestItem=l={}));var r;(function(k){k.serialize=d=>{let b;return d.item&&(b={},d.item.label!==void 0&&(b.label=d.item.label),d.item.tags!==void 0&&(b.tags=d.item.tags),d.item.busy!==void 0&&(b.busy=d.item.busy),d.item.uri!==void 0&&(b.uri=d.item.uri?.toJSON()),d.item.range!==void 0&&(b.range=d.item.range?.toJSON()),d.item.description!==void 0&&(b.description=d.item.description),d.item.error!==void 0&&(b.error=d.item.error),d.item.sortText!==void 0&&(b.sortText=d.item.sortText)),{extId:d.extId,expand:d.expand,item:b}},k.deserialize=d=>{let b;return d.item&&(b={},d.item.label!==void 0&&(b.label=d.item.label),d.item.tags!==void 0&&(b.tags=d.item.tags),d.item.busy!==void 0&&(b.busy=d.item.busy),d.item.range!==void 0&&(b.range=d.item.range?L.$xs.lift(d.item.range):null),d.item.description!==void 0&&(b.description=d.item.description),d.item.error!==void 0&&(b.error=d.item.error),d.item.sortText!==void 0&&(b.sortText=d.item.sortText)),{extId:d.extId,expand:d.expand,item:b}}})(r||(e.ITestItemUpdate=r={}));const s=(k,d)=>{d.expand!==void 0&&(k.expand=d.expand),d.item!==void 0&&(k.item=k.item?Object.assign(k.item,d.item):d.item)};e.$rJ=s;var c;(function(k){k.serializeWithoutMessages=d=>({...l.serialize(d),ownComputedState:d.ownComputedState,computedState:d.computedState,tasks:d.tasks.map(f.serializeWithoutMessages)}),k.serialize=d=>({...l.serialize(d),ownComputedState:d.ownComputedState,computedState:d.computedState,tasks:d.tasks.map(f.serialize)}),k.deserialize=d=>({...l.deserialize(d),ownComputedState:d.ownComputedState,computedState:d.computedState,tasks:d.tasks.map(f.deserialize),retired:!0})})(c||(e.TestResultItem=c={}));var h;(function(k){k[k.Function=0]="Function",k[k.Statement=1]="Statement"})(h||(e.DetailType=h={}));var w;(function(k){k[k.Add=0]="Add",k[k.Update=1]="Update",k[k.DocumentSynced=2]="DocumentSynced",k[k.Remove=3]="Remove",k[k.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",k[k.Retire=5]="Retire",k[k.AddTag=6]="AddTag",k[k.RemoveTag=7]="RemoveTag"})(w||(e.TestDiffOpType=w={}));var m;(function(k){k.deserialize=d=>d.op===0?{op:d.op,item:l.deserialize(d.item)}:d.op===1?{op:d.op,item:r.deserialize(d.item)}:d.op===2?{op:d.op,uri:E.URI.revive(d.uri),docv:d.docv}:d,k.serialize=d=>d.op===0?{op:d.op,item:l.serialize(d.item)}:d.op===1?{op:d.op,item:r.serialize(d.item)}:d})(m||(e.TestsDiffOp=m={}));class I{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(d){const b=this.o();for(const y of d)switch(y.op){case 0:this.j(l.deserialize(y.item),b);break;case 1:this.k(r.deserialize(y.item),b);break;case 3:this.l(y.itemId,b);break;case 5:this.m(y.itemId);break;case 4:this.updatePendingRoots(y.amount);break;case 6:this.c.set(y.tag.id,y.tag);break;case 7:this.c.delete(y.id);break}b.complete?.()}j(d,b){const y=P.$lJ.parentId(d.item.extId)?.toString();let C;if(!y)C=this.p(d),this.f.add(C),this.d.set(d.item.extId,C);else if(this.d.has(y)){const B=this.d.get(y);B.children.add(d.item.extId),C=this.p(d,B),this.d.set(d.item.extId,C)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(d)}`);return}return b.add?.(C),d.expand===2&&this.g++,C}k(d,b){const y=this.d.get(d.extId);if(y)return d.expand!==void 0&&(y.expand===2&&this.g--,d.expand===2&&this.g++),(0,e.$rJ)(y,d),b.update?.(y),y}l(d,b){const y=this.d.get(d);if(!y)return;const C=P.$lJ.parentId(y.item.extId)?.toString();C?this.d.get(C).children.delete(y.item.extId):this.f.delete(y);const B=[[d]];for(;B.length;)for(const H of B.pop()){const U=this.d.get(H);U&&(B.push(U.children),this.d.delete(H),b.remove?.(U,U!==y),U.expand===2&&this.g--)}}m(d){}updatePendingRoots(d){this.h+=d}o(){return{}}}e.$sJ=I}),define(Ae[77],Re([1,0,12,5,6,55,60,48]),function(pe,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rM=e.$qM=e.$pM=e.$oM=e.$nM=e.TestItemEventOp=void 0;var D;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})(D||(e.TestItemEventOp=D={}));const g=(n,u)=>n===u,S=Object.entries({range:(n,u)=>n===u?!0:!n||!u?!1:n.equalsRange(u),busy:g,label:g,description:g,error:g,sortText:g,tags:(n,u)=>!(n.length!==u.length||n.some(a=>!u.includes(a)))}),o=(n,u)=>{let a;for(const[l,r]of S)r(n[l],u[l])||(a?a[l]=u[l]:a={[l]:u[l]});return a};class v extends P.$Rc{get root(){return this.s.root}constructor(u){super(),this.s=u,this.f=this.B(new E.$8g(()=>this.flushDiff(),200)),this.g=this.B(new L.$Od),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(u){this.h=u;for(const a of this.tree.values())this.I(a)}get resolveHandler(){return this.h}collectDiff(){const u=this.m;return this.m=[],u}pushDiff(u){switch(u.op){case 2:{for(const a of this.m)if(a.op===2&&a.uri===u.uri){a.docv=u.docv;return}break}case 1:{const a=this.m[this.m.length-1];if(a){if(a.op===1&&a.item.extId===u.item.extId){(0,R.$rJ)(a.item,u.item);return}if(a.op===0&&a.item.item.extId===u.item.extId){(0,R.$rJ)(a.item,u.item);return}}break}}this.m.push(u),this.f.isScheduled()||this.f.schedule()}expand(u,a){const l=this.tree.get(u);if(l){if((l.expandLevels===void 0||a>l.expandLevels)&&(l.expandLevels=a),l.expand===1){const r=this.L(l);return r.isOpen()?this.J(l,a-1):r.wait().then(()=>this.J(l,a-1))}else if(l.expand===3)return l.resolveBarrier?.isOpen()===!1?l.resolveBarrier.wait().then(()=>this.J(l,a-1)):this.J(l,a-1)}}dispose(){for(const u of this.tree.values())this.s.getApiFor(u.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(u,a){switch(a.op){case 3:this.N($.$lJ.joinToString(u.fullId,a.id));break;case 0:this.y(a.item,u);break;case 5:for(const l of a.ops)this.u(u,l);break;case 1:this.z(a.new,a.old,u.fullId.toString());break;case 2:this.I(u);break;case 4:this.pushDiff({op:1,item:{extId:u.fullId.toString(),item:a.update}});break;case 6:this.w(u.actual.uri);break;default:(0,M.$3c)(a)}}w(u){u&&this.pushDiff({op:2,uri:u,docv:this.s.getDocumentVersion(u)})}y(u,a){const l=$.$lJ.fromExtHostTestItem(u,this.root.id,a?.actual),r=this.s.getApiFor(u);r.parent&&r.parent!==a?.actual&&this.s.getChildren(r.parent).delete(u.id);let s=this.tree.get(l.toString());if(!s){s={fullId:l,actual:u,expandLevels:a?.expandLevels?a.expandLevels-1:void 0,expand:0},u.tags.forEach(this.C,this),this.tree.set(s.fullId.toString(),s),this.F(u,a),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:s.expand,item:this.s.toITestItem(u)}}),this.H(u,s,a);return}if(s.actual===u){this.G(u,s,a);return}if(s.actual.uri?.toString()!==u.uri?.toString())return this.N(l.toString()),this.y(u,a);const c=this.s.getChildren(s.actual),h=s.actual,w=o(this.s.toITestItem(h),this.s.toITestItem(u));this.s.getApiFor(h).listener=void 0,s.actual=u,s.expand=0,w&&(w.hasOwnProperty("tags")&&(this.z(u.tags,h.tags,l.toString()),delete w.tags),this.u(s,{op:4,update:w})),this.H(u,s,a);for(const[m,I]of c)this.s.getChildren(u).get(I.id)||this.N($.$lJ.joinToString(l,I.id));this.w(s.actual.uri)}z(u,a,l){const r=new Set(a.map(s=>s.id));for(const s of u)r.delete(s.id)||this.C(s);this.pushDiff({op:1,item:{extId:l,item:{tags:u.map(s=>(0,R.$pJ)(this.s.controllerId,s.id))}}}),r.forEach(this.D,this)}C(u){const a=this.j.get(u.id);a?a.refCount++:(this.j.set(u.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.$pJ)(this.s.controllerId,u.id)}}))}D(u){const a=this.j.get(u);a&&!--a.refCount&&(this.j.delete(u),this.pushDiff({op:7,id:(0,R.$pJ)(this.s.controllerId,u)}))}F(u,a){this.s.getApiFor(u).parent=a&&a.actual!==this.root?a.actual:void 0}G(u,a,l){this.F(u,l);const r=this.s.getApiFor(u);r.parent=l?.actual,r.listener=s=>this.u(a,s),this.I(a)}H(u,a,l){this.G(u,a,l);for(const[r,s]of this.s.getChildren(u))this.y(s,a)}I(u){let a;this.h?u.resolveBarrier?a=u.resolveBarrier.isOpen()?3:2:a=u.actual.canResolveChildren?1:0:a=0,a!==u.expand&&(u.expand=a,this.pushDiff({op:1,item:{extId:u.fullId.toString(),expand:a}}),a===1&&u.expandLevels!==void 0&&this.L(u))}J(u,a){if(a<0)return;const l=[];for(const[r,s]of this.s.getChildren(u.actual)){const c=this.expand($.$lJ.joinToString(u.fullId,s.id),a);(0,E.$Hg)(c)&&l.push(c)}if(l.length)return Promise.all(l).then(()=>{})}L(u){if(u.resolveBarrier)return u.resolveBarrier;if(!this.h){const s=new E.$Tg;return s.open(),s}u.expand=2,this.M(u);const a=u.resolveBarrier=new E.$Tg,l=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,s)};let r;try{r=this.h(u.actual===this.root?void 0:u.actual)}catch(s){l(s)}return(0,E.$Hg)(r)?r.catch(l).then(()=>{a.open(),this.I(u)}):(a.open(),this.I(u)),u.resolveBarrier}M(u){this.pushDiff({op:1,item:{extId:u.fullId.toString(),expand:u.expand}})}N(u){const a=this.tree.get(u);if(!a)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:u});const l=[a];for(;l.length;){const r=l.pop();if(r){this.s.getApiFor(r.actual).listener=void 0;for(const s of r.actual.tags)this.D(s.id);this.tree.delete(r.fullId.toString());for(const[s,c]of this.s.getChildren(r.actual))l.push(this.tree.get($.$lJ.joinToString(r.fullId,c.id)))}}}flushDiff(){const u=this.collectDiff();u.length&&this.g.fire(u)}}e.$nM=v;class p extends Error{constructor(u){super(`Attempted to insert a duplicate test item ID ${u}`)}}e.$oM=p;class f extends Error{constructor(u){super(`TestItem with ID "${u}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$pM=f;class t extends Error{constructor(u,a,l){super(`TestItem with ID "${u}" is from controller "${a}" and cannot be added as a child of an item from controller "${l}".`)}}e.$qM=t;const i=(n,u,a)=>{let l=new Map;return{get size(){return l.size},forEach(r,s){for(const c of l.values())r.call(s,c,this)},[Symbol.iterator](){return l.entries()},replace(r){const s=new Map,c=new Set(l.keys()),h={op:5,ops:[]};for(const w of r){if(!(w instanceof a))throw new f(w.id);const m=u(w).controllerId;if(m!==n.controllerId)throw new t(w.id,m,n.controllerId);if(s.has(w.id))throw new p(w.id);s.set(w.id,w),c.delete(w.id),h.ops.push({op:0,item:w})}for(const w of c.keys())h.ops.push({op:3,id:w});n.listener?.(h),l=s},add(r){if(!(r instanceof a))throw new f(r.id);l.set(r.id,r),n.listener?.({op:0,item:r})},delete(r){l.delete(r)&&n.listener?.({op:3,id:r})},get(r){return l.get(r)},toJSON(){return Array.from(l.values())}}};e.$rM=i}),define(Ae[104],Re([1,0,77]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tM=e.$sM=void 0;const L=new WeakMap,P=(R,$)=>{const D={controllerId:$};return L.set(R,D),D};e.$sM=P;const M=R=>{const $=L.get(R);if(!$)throw new E.$pM(R?.id||"<unknown>");return $};e.$tM=M}),define(Ae[78],Re([1,0,14,2]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3tb=e.$2tb=e.$1tb=e.$Ztb=e.$Ytb=void 0,e.$Ytb="vscode-cdn.net",e.$Ztb=`vscode-resource.${e.$Ytb}`,e.$1tb=`'self' https://*.${e.$Ytb}`;function P($,D){return $.scheme===E.Schemas.http||$.scheme===E.Schemas.https?$:(D&&D.authority&&D.isRemote&&$.scheme===E.Schemas.file&&($=L.URI.from({scheme:E.Schemas.vscodeRemote,authority:D.authority,path:$.path})),L.URI.from({scheme:E.Schemas.https,authority:`${$.scheme}+${M($.authority)}.${e.$Ztb}`,path:$.path,fragment:$.fragment,query:$.query}))}e.$2tb=P;function M($){return $.replace(/./g,D=>{const g=D.charCodeAt(0);return g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57?D:"-"+g.toString(16).padStart(4,"0")})}function R($){return $.replace(/-([0-9a-f]{4})/g,(D,g)=>String.fromCharCode(parseInt(g,16)))}e.$3tb=R}),define(Ae[214],Re([1,0,5,6,78]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$dc=void 0;class M{constructor($,D,g){this.d=$,this.e=D,this.f=g,this.a=0,this.b=new L.$Qc,this.c=new Map,this.b.add(D.onDidChangeVisibleTextEditors(()=>{const A=D.getVisibleTextEditors();for(const S of this.c.values())A.indexOf(S.editor)<0&&S.inset.dispose()}))}dispose(){this.c.forEach($=>$.inset.dispose()),this.b.dispose()}createWebviewEditorInset($,D,g,A,S){let o;for(const u of this.e.getVisibleTextEditors(!0))if(u.value===$){o=u;break}if(!o)throw new Error("not a visible editor");const v=this,p=this.a++,f=new E.$Od,t=new E.$Od,i=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(u){return(0,P.$2tb)(u,v.f)}get cspSource(){return P.$1tb}set options(u){this.b=u,v.d.$setOptions(p,u)}get options(){return this.b}set html(u){this.a=u,v.d.$setHtml(p,u)}get html(){return this.a}get onDidReceiveMessage(){return f.event}postMessage(u){return v.d.$postMessage(p,u)}},n=new class{constructor(){this.editor=$,this.line=D,this.height=g,this.webview=i,this.onDidDispose=t.event}dispose(){v.c.has(p)&&(v.c.delete(p),v.d.$disposeEditorInset(p),t.fire(),t.dispose(),f.dispose())}};return this.d.$createEditorInset(p,o.id,o.value.document.uri,D+1,g,A||{},S.identifier,S.extensionLocation),this.c.set(p,{editor:$,inset:n,onDidReceiveMessage:f}),n}$onDidDispose($){const D=this.c.get($);D&&D.inset.dispose()}$onDidReceiveMessage($,D){this.c.get($)?.onDidReceiveMessage.fire(D)}}e.$$dc=M}),define(Ae[215],Re([1,0,4]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kN=e.VariableKind=e.$jN=void 0,e.$jN=(0,E.$Th)("configurationResolverService");var L;(function(M){M.Unknown="unknown",M.Env="env",M.Config="config",M.Command="command",M.Input="input",M.ExtensionInstallFolder="extensionInstallFolder",M.WorkspaceFolder="workspaceFolder",M.Cwd="cwd",M.WorkspaceFolderBasename="workspaceFolderBasename",M.UserHome="userHome",M.LineNumber="lineNumber",M.SelectedText="selectedText",M.File="file",M.FileWorkspaceFolder="fileWorkspaceFolder",M.RelativeFile="relativeFile",M.RelativeFileDirname="relativeFileDirname",M.FileDirname="fileDirname",M.FileExtname="fileExtname",M.FileBasename="fileBasename",M.FileBasenameNoExtension="fileBasenameNoExtension",M.FileDirnameBasename="fileDirnameBasename",M.ExecPath="execPath",M.ExecInstallFolder="execInstallFolder",M.PathSeparator="pathSeparator"})(L||(e.VariableKind=L={}));class P extends Error{constructor(R,$){super($),this.variable=R}}e.$kN=P}),define(Ae[216],Re([1,0,19,74,16,26,21,94,178,215,13]),function(pe,e,E,L,P,M,R,$,D,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yN=void 0;class S{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(v,p,f,t){this.h=new Map,this.a=v,this.b=p,this.g=f,t&&(this.c=t.then(i=>this.i(i)))}i(v){if(R.$j){const p=Object.create(null);return Object.keys(v).forEach(f=>{p[f.toLowerCase()]=v[f]}),p}return v}resolveWithEnvironment(v,p,f){return this.l({env:this.i(v),userHome:void 0},p?p.uri:void 0,f)}async resolveAsync(v,p){const f={env:await this.c,userHome:await this.g};return this.l(f,v?v.uri:void 0,p)}async j(v,p,f,t){const i=M.$$m(p);R.$j&&i.windows?Object.keys(i.windows).forEach(u=>i[u]=i.windows[u]):R.$k&&i.osx?Object.keys(i.osx).forEach(u=>i[u]=i.osx[u]):R.$l&&i.linux&&Object.keys(i.linux).forEach(u=>i[u]=i.linux[u]),delete i.windows,delete i.osx,delete i.linux;const n={env:await this.c,userHome:await this.g};return this.l(n,v?v.uri:void 0,i,f,t)}async resolveAnyAsync(v,p,f){return this.j(v,p,f)}async resolveAnyMap(v,p,f){const t=new Map;return{newConfig:await this.j(v,p,f,t),resolvedVariables:t}}resolveWithInteractionReplace(v,p,f,t){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(v,p,f,t){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(v,p){if(this.h.has(v))throw new Error("Variable "+v+" is contributed twice.");this.h.set(v,p)}async l(v,p,f,t,i){if(P.$zf(f))return this.m(v,p,f,t,i);if(Array.isArray(f))return Promise.all(f.map(n=>this.l(v,p,n,t,i)));if(P.$Bf(f)){const n=Object.create(null),u=await Promise.all(Object.keys(f).map(async a=>[await this.m(v,p,a,t,i),await this.l(v,p,f[a],t,i)]));for(const[a,l]of u)n[a]=l;return n}return f}m(v,p,f,t,i){return(0,A.$Ue)(f,S.VARIABLE_REGEXP,async(n,u)=>{if(u.includes(S.VARIABLE_LHS))return n;let a=await this.o(v,n,u,p,t);return i?.set(u,a),a!==n&&P.$zf(a)&&a.match(S.VARIABLE_REGEXP)&&(a=await this.m(v,p,a,t,i)),a})}n(v){return this.b?this.b.getUriLabel(v,{noPrefix:!0}):v.fsPath}async o(v,p,f,t,i){let n;const u=f.split(":");u.length>1&&(f=u[0],n=u[1]);const a=s=>{const c=this.a.getFilePath();if(c)return(0,$.$wv)(c);throw new g.$kN(s,(0,D.localize)(0,null,p))},l=s=>{const c=a(s);if(this.a.getWorkspaceFolderPathForFile){const h=this.a.getWorkspaceFolderPathForFile();if(h)return(0,$.$wv)(h)}throw new g.$kN(s,(0,D.localize)(1,null,p,E.$mc(c)))},r=s=>{if(n){const c=this.a.getFolderUri(n);if(c)return c;throw new g.$kN(s,(0,D.localize)(2,null,p,n))}if(t)return t;throw this.a.getWorkspaceFolderCount()>1?new g.$kN(s,(0,D.localize)(3,null,p)):new g.$kN(s,(0,D.localize)(4,null,p))};switch(f){case"env":if(n){if(v.env){const s=v.env[R.$j?n.toLowerCase():n];if(P.$zf(s))return s}return""}throw new g.$kN(g.VariableKind.Env,(0,D.localize)(5,null,p));case"config":if(n){const s=this.a.getConfigurationValue(t,n);if(P.$If(s))throw new g.$kN(g.VariableKind.Config,(0,D.localize)(6,null,p,n));if(P.$Bf(s))throw new g.$kN(g.VariableKind.Config,(0,D.localize)(7,null,p,n));return s}throw new g.$kN(g.VariableKind.Config,(0,D.localize)(8,null,p));case"command":return this.p(g.VariableKind.Command,p,n,i,"command");case"input":return this.p(g.VariableKind.Input,p,n,i,"input");case"extensionInstallFolder":if(n){const s=await this.a.getExtension(n);if(!s)throw new g.$kN(g.VariableKind.ExtensionInstallFolder,(0,D.localize)(9,null,p,n));return this.n(s.extensionLocation)}throw new g.$kN(g.VariableKind.ExtensionInstallFolder,(0,D.localize)(10,null,p));default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,$.$wv)(this.n(r(g.VariableKind.WorkspaceFolder)));case"cwd":return t||n?(0,$.$wv)(this.n(r(g.VariableKind.Cwd))):L.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,$.$wv)(E.$mc(this.n(r(g.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(v.userHome)return v.userHome;throw new g.$kN(g.VariableKind.UserHome,(0,D.localize)(11,null,p))}case"lineNumber":{const s=this.a.getLineNumber();if(s)return s;throw new g.$kN(g.VariableKind.LineNumber,(0,D.localize)(12,null,p))}case"selectedText":{const s=this.a.getSelectedText();if(s)return s;throw new g.$kN(g.VariableKind.SelectedText,(0,D.localize)(13,null,p))}case"file":return a(g.VariableKind.File);case"fileWorkspaceFolder":return l(g.VariableKind.FileWorkspaceFolder);case"relativeFile":return t||n?E.$kc(this.n(r(g.VariableKind.RelativeFile)),a(g.VariableKind.RelativeFile)):a(g.VariableKind.RelativeFile);case"relativeFileDirname":{const s=E.$lc(a(g.VariableKind.RelativeFileDirname));if(t||n){const c=E.$kc(this.n(r(g.VariableKind.RelativeFileDirname)),s);return c.length===0?".":c}return s}case"fileDirname":return E.$lc(a(g.VariableKind.FileDirname));case"fileExtname":return E.$nc(a(g.VariableKind.FileExtname));case"fileBasename":return E.$mc(a(g.VariableKind.FileBasename));case"fileBasenameNoExtension":{const s=E.$mc(a(g.VariableKind.FileBasenameNoExtension));return s.slice(0,s.length-E.$nc(s).length)}case"fileDirnameBasename":return E.$mc(E.$lc(a(g.VariableKind.FileDirnameBasename)));case"execPath":{const s=this.a.getExecPath();return s||p}case"execInstallFolder":{const s=this.a.getAppRoot();return s||p}case"pathSeparator":return E.sep;default:try{const s=n?`${f}:${n}`:f;return this.p(g.VariableKind.Unknown,p,s,i,void 0)}catch{return p}}}}p(v,p,f,t,i){if(f&&t){const n=i===void 0?t[f]:t[i+":"+f];if(typeof n=="string")return n;throw new g.$kN(v,(0,D.localize)(14,null,p))}return p}}e.$yN=S}),define(Ae[105],Re([1,0,4,102]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GC=e.$FC=e.OpenEditorContext=e.GroupsOrder=e.$EC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$DC=void 0,e.$DC=(0,E.$Th)("editorGroupsService");var P;(function(p){p[p.UP=0]="UP",p[p.DOWN=1]="DOWN",p[p.LEFT=2]="LEFT",p[p.RIGHT=3]="RIGHT"})(P||(e.GroupDirection=P={}));var M;(function(p){p[p.HORIZONTAL=0]="HORIZONTAL",p[p.VERTICAL=1]="VERTICAL"})(M||(e.GroupOrientation=M={}));var R;(function(p){p[p.FIRST=0]="FIRST",p[p.LAST=1]="LAST",p[p.NEXT=2]="NEXT",p[p.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var $;(function(p){p[p.MAXIMIZE=0]="MAXIMIZE",p[p.EXPAND=1]="EXPAND",p[p.EVEN=2]="EVEN"})($||(e.GroupsArrangement=$={}));var D;(function(p){p[p.COPY_EDITORS=0]="COPY_EDITORS",p[p.MOVE_EDITORS=1]="MOVE_EDITORS"})(D||(e.MergeGroupMode=D={}));function g(p){const f=p;return(0,L.$lE)(f?.editor)&&(0,L.$lE)(f?.replacement)}e.$EC=g;var A;(function(p){p[p.CREATION_TIME=0]="CREATION_TIME",p[p.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",p[p.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var S;(function(p){p[p.NEW_EDITOR=1]="NEW_EDITOR",p[p.MOVE_EDITOR=2]="MOVE_EDITOR",p[p.COPY_EDITOR=3]="COPY_EDITOR"})(S||(e.OpenEditorContext=S={}));function o(p){const f=p;return!!f&&typeof f.id=="number"&&Array.isArray(f.editors)}e.$FC=o;function v(p){return p.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$GC=v}),define(Ae[217],Re([1,0,4,105]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KC=e.$JC=e.$IC=e.$HC=void 0,e.$HC=(0,E.$Th)("editorService"),e.$IC=-1,e.$JC=-2;function P(M){const R=M;return typeof M=="number"||(0,L.$FC)(R)}e.$KC=P}),define(Ae[218],Re([1,0,4,185]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PJ=void 0,e.$PJ=(0,E.$Uh)(L.$1h)}),define(Ae[106],Re([1,0,22,5,19,6]),function(pe,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h5b=e.$g5b=e.$f5b=e.$e5b=e.$d5b=void 0;class R{constructor(i,n){this.versionId=i,this.removedDueToLooping=n}}e.$d5b=R;class ${static isHostExtension(i,n,u){if(n.getExtensionDescription(i))return!1;const a=u.getExtensionDescription(i);return a?!!((a.main||a.browser)&&a.api==="none"):!1}constructor(i,n){this.j=i,this.c=new L.$Od,this.onDidChange=this.c.event,this.d=0,this.e=n,this.k()}k(){this.e.sort(p),this.f=new E.$_l,this.g=[],this.h=new Map;for(const i of this.e){if(this.f.has(i.identifier)){console.error("Extension `"+i.identifier.value+"` is already registered");continue}this.f.set(i.identifier,i),this.g.push(i);const n=this.j.readActivationEvents(i);for(const u of n)this.h.has(u)||this.h.set(u,[]),this.h.get(u).push(i)}}set(i){return this.e=i,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(i,n){this.e=f(this.e,n),this.e=this.e.concat(i);const u=$.l(this.e);return this.e=f(this.e,u.map(a=>a.identifier)),this.k(),this.d++,this.c.fire(void 0),new R(this.d,u)}static l(i){const n=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(s){this.d.has(s)||(this.d.add(s),this.e.push(s))}addArc(s,c){this.addNode(s),this.addNode(c),this.c.has(s)?this.c.get(s).push(c):this.c.set(s,[c])}getArcs(s){return this.c.has(s)?this.c.get(s):[]}hasOnlyGoodArcs(s,c){const h=n.getArcs(s);for(let w=0;w<h.length;w++)if(!c.has(h[w]))return!1;return!0}getNodes(){return this.e}},u=new E.$_l;for(const s of i)if(u.set(s.identifier,s),s.extensionDependencies)for(const c of s.extensionDependencies)n.addArc(E.$0l.toKey(s.identifier),E.$0l.toKey(c));const a=new Set;n.getNodes().filter(s=>n.getArcs(s).length===0).forEach(s=>a.add(s));const l=n.getNodes().filter(s=>!a.has(s));let r;do{r=!1;for(let s=0;s<l.length;s++){const c=l[s];n.hasOnlyGoodArcs(c,a)&&(l.splice(s,1),s--,a.add(c),r=!0)}}while(r);return l.map(s=>u.get(s))}containsActivationEvent(i){return this.h.has(i)}containsExtension(i){return this.f.has(i)}getExtensionDescriptionsForActivationEvent(i){const n=this.h.get(i);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new D(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(i){const n=this.f.get(i);return n||void 0}getExtensionDescriptionByUUID(i){for(const n of this.g)if(n.uuid===i)return n}getExtensionDescriptionByIdOrUUID(i,n){return this.getExtensionDescription(i)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.$e5b=$;class D{constructor(i,n){this.versionId=i,this.extensions=n}}e.$f5b=D;class g{constructor(i){this.d=new o,this.c=new $(i,[])}async acquireLock(i){const n=await this.d.acquire(i);return new A(this,n)}deltaExtensions(i,n,u){if(!i.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(n,u)}containsActivationEvent(i){return this.c.containsActivationEvent(i)}containsExtension(i){return this.c.containsExtension(i)}getExtensionDescriptionsForActivationEvent(i){return this.c.getExtensionDescriptionsForActivationEvent(i)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(i){return this.c.getExtensionDescription(i)}getExtensionDescriptionByUUID(i){return this.c.getExtensionDescriptionByUUID(i)}getExtensionDescriptionByIdOrUUID(i,n){return this.c.getExtensionDescriptionByIdOrUUID(i,n)}}e.$g5b=g;class A extends M.$Rc{constructor(i,n){super(),this.f=i,this.c=!1,this.B(n)}isAcquiredFor(i){return!this.c&&this.f===i}}e.$h5b=A;class S{constructor(i){this.name=i,this.promise=new Promise((n,u)=>{this.c=n})}resolve(i){this.c(i)}}class o{constructor(){this.c=[],this.d=!1}async acquire(i){const n=new S(i);return this.c.push(n),this.e(),n.promise}e(){if(this.d||this.c.length===0)return;const i=this.c.shift();this.d=!0;let n=!0;const u=setTimeout(()=>{n&&console.warn(`The customer named ${i.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),a=()=>{n&&(clearTimeout(u),n=!1,this.d=!1,this.e())};i.resolve((0,M.$Pc)(a))}}var v;(function(t){t[t.Builtin=0]="Builtin",t[t.User=1]="User",t[t.Dev=2]="Dev"})(v||(v={}));function p(t,i){const n=t.isBuiltin?0:t.isUnderDevelopment?2:1,u=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(n!==u)return n-u;const a=P.$fc.basename(t.extensionLocation.path),l=P.$fc.basename(i.extensionLocation.path);return a<l?-1:a>l?1:0}function f(t,i){const n=new E.$$l(i);return t.filter(u=>!n.has(u.identifier))}}),define(Ae[79],Re([1,0,24]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$gm=e.$fm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var L;(function(g){g[g.Desktop=1]="Desktop",g[g.Web=2]="Web"})(L||(e.UIKind=L={}));var P;(function(g){g[g.VersionMismatch=55]="VersionMismatch",g[g.UnexpectedError=81]="UnexpectedError"})(P||(e.ExtensionHostExitCode=P={}));var M;(function(g){g[g.Initialized=0]="Initialized",g[g.Ready=1]="Ready",g[g.Terminate=2]="Terminate"})(M||(e.MessageType=M={}));function R(g){const A=E.$ce.alloc(1);switch(g){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}e.$fm=R;function $(g,A){if(g.byteLength!==1)return!1;switch(g.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}e.$gm=$;var D;(function(g){g.Start="START_NATIVE_LOG",g.End="END_NATIVE_LOG"})(D||(e.NativeLogMarkers=D={}))}),define(Ae[61],Re([1,0,4,5,15,27,79,57,58,26,2,6,166]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RM=e.$QM=e.$PM=e.$OM=void 0;let v=class extends S.$Rc{constructor(i,n){super(),this.s=i,this.t=n,this.a=this.B(new L.$Od),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new L.$Od),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=A.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:D.$so,name:(0,o.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(n.onDidChangeLogLevel(u=>{(0,P.$dj)(u)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===P.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(i,n,u){const a=this.getTelemetryDetails(),l=new p(n,u,i,this.n,this.j,this.getBuiltInCommonProperties(i),{isUsageEnabled:a.isUsageEnabled,isErrorsEnabled:a.isErrorsEnabled}),r=this.r.get(i.identifier.value)??[];return this.r.set(i.identifier.value,[...r,l]),l.apiTelemetryLogger}$initializeTelemetryLevel(i,n,u){this.f=i,this.g=n,this.c=u??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(i){const n=Object.create(null);switch(n["common.extname"]=`${i.publisher}.${i.name}`,n["common.extversion"]=i.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=f(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:n["common.uikind"]="web";break;case R.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,$.$Zk)((0,D.$zo)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(i){this.h=this.getTelemetryConfiguration(),this.f=i;const n=this.getTelemetryDetails();this.r.forEach((u,a)=>{const l=u.filter(r=>!r.isDisposed);l.length===0?this.r.delete(a):this.r.set(a,l)}),this.r.forEach(u=>{for(const a of u)a.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(i,n){const a=this.r.get(i.value)?.filter(r=>!r.isDisposed);if(!a)return this.r.delete(i.value),!1;let l=!1;for(const r of a)r.ignoreUnhandledExtHostErrors||(r.logError(n),l=!0);return l}};e.$OM=v,e.$OM=v=Ke([Ve(0,M.$NM),Ve(1,P.$cj)],v);class p{static validateSender(i){if(typeof i!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof i.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof i.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof i.flush<"u"&&typeof i.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(i,n,u,a,l,r,s){this.g=u,this.h=a,this.i=l,this.j=r,this.a=new L.$Od,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=i,this.d={isUsageEnabled:s.isUsageEnabled,isErrorsEnabled:s.isErrorsEnabled}}updateTelemetryEnablements(i,n){this.e&&(this.d={isUsageEnabled:i,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(i){let n="properties"in i?i.properties??{}:i;return n=(0,D.$Co)(n,[]),this.c&&(n=(0,g.$bn)(n,this.c)),this.b||(n=(0,g.$bn)(n,this.j)),"properties"in i?i.properties=n:i=n,i}k(i,n){this.f&&(this.g.publisher==="vscode"?i=this.g.name+"/"+i:i=this.g.identifier.value+"/"+i,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(i,n),this.h.trace(i,n))}logUsage(i,n){this.d.isUsageEnabled&&this.k(i,n)}logError(i,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof i=="string")this.k(i,n);else{const u={name:i.name,message:i.message,stack:i.stack,cause:i.cause},a=(0,D.$Co)(u,[]),l=new Error(a.message,{cause:a.cause});l.stack=a.stack,l.name=a.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(l,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const i=this,n={logUsage:i.logUsage.bind(i),get isUsageEnabled(){return i.d.isUsageEnabled},get isErrorsEnabled(){return i.d.isErrorsEnabled},logError:i.logError.bind(i),dispose:i.dispose.bind(i),onDidChangeEnableStates:i.a.event.bind(i)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let i=this.f;this.f=void 0,Promise.resolve(i.flush()).then(i=void 0),this.e=void 0}else this.f=void 0}}e.$PM=p;function f(t){const i=Date.now()-new Date(t).getTime();return isNaN(i)?!1:i<1e3*60*60*24}e.$QM=f,e.$RM=(0,E.$Th)("IExtHostTelemetry")}),define(Ae[23],Re([1,0,5,2,194,101,22,4]),function(pe,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AF=e.$zF=e.$yF=e.ActivationKind=e.$xF=e.$wF=e.$vF=e.$uF=e.$tF=e.ExtensionHostStartup=e.$sF=e.$rF=e.$qF=e.$pF=void 0,e.$pF=Object.freeze({identifier:new R.$0l("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:L.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$qF="extensions.webWorker",e.$rF=(0,$.$Th)("extensionService");class D{constructor(l){this.dependency=l}}e.$sF=D;var g;(function(a){a[a.EagerAutoStart=1]="EagerAutoStart",a[a.EagerManualStart=2]="EagerManualStart",a[a.Lazy=3]="Lazy"})(g||(e.ExtensionHostStartup=g={}));class A{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(l,r,s){this.c=l,this.d=r.slice(0),this.e=s.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:M.$aF.createActivationEventsMap(this.d)}}set(l,r,s){if(this.c>l)throw new Error(`ExtensionHostExtensions: invalid versionId ${l} (current: ${this.c})`);const c=[],h=[],w=[],m=[],I=S(this.d),k=S(r),d=(H,U)=>H.extensionLocation.toString()===U.extensionLocation.toString()||H.isBuiltin===U.isBuiltin||H.isUserBuiltin===U.isUserBuiltin||H.isUnderDevelopment===U.isUnderDevelopment;for(const H of this.d){const U=k.get(H.identifier);if(!U){c.push(H.identifier),I.delete(H.identifier);continue}if(!d(H,U)){c.push(H.identifier),I.delete(H.identifier);continue}}for(const H of r){const U=I.get(H.identifier);if(!U){h.push(H);continue}if(!d(U,H)){c.push(U.identifier),I.delete(U.identifier);continue}}const b=new R.$$l(this.e),y=new R.$$l(s);for(const H of this.e)y.has(H)||w.push(H);for(const H of s)b.has(H)||m.push(H);const C=M.$aF.createActivationEventsMap(h),B={versionId:l,toRemove:c,toAdd:h,addActivationEvents:C,myToRemove:w,myToAdd:m};return this.delta(B),B}delta(l){if(this.c>=l.versionId)return null;const{toRemove:r,toAdd:s,myToRemove:c,myToAdd:h}=l,w=new R.$$l(r),m=new R.$$l(c);for(let I=0;I<this.d.length;I++)w.has(this.d[I].identifier)&&(this.d.splice(I,1),I--);for(let I=0;I<this.e.length;I++)m.has(this.e[I])&&(this.e.splice(I,1),I--);for(const I of s)this.d.push(I);for(const I of h)this.e.push(I);return this.f=null,l}containsExtension(l){for(const r of this.e)if(R.$0l.equals(r,l))return!0;return!1}containsActivationEvent(l){return this.f||(this.f=this.g()),this.f.has(l)}g(){const l=new Set;for(const r of this.d){if(!this.containsExtension(r.identifier))continue;const s=M.$aF.readActivationEvents(r);for(const c of s)l.add(c)}return l}}e.$tF=A;function S(a){const l=new R.$_l;for(const r of a)l.set(r.identifier,r);return l}function o(a,l){return a.enabledApiProposals?a.enabledApiProposals.includes(l):!1}e.$uF=o;function v(a,l){if(!o(a,l))throw new Error(`Extension '${a.identifier.value}' CANNOT use API proposal: ${l}.
Its package.json#enabledApiProposals-property declares: ${a.enabledApiProposals?.join(", ")??"[]"} but NOT ${l}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${a.identifier.value}`)}e.$vF=v;class p{constructor(l,r,s,c){this.codeLoadingTime=l,this.activateCallTime=r,this.activateResolvedTime=s,this.activationReason=c}}e.$wF=p;class f{constructor(l,r){this.description=l,this.value=r}}e.$xF=f;var t;(function(a){a[a.Normal=0]="Normal",a[a.Immediate=1]="Immediate"})(t||(e.ActivationKind=t={}));function i(a){return{type:a.isBuiltin?0:1,isBuiltin:a.isBuiltin||a.isUserBuiltin,identifier:{id:(0,P.$Io)(a.publisher,a.name),uuid:a.uuid},manifest:a,location:a.extensionLocation,targetPlatform:a.targetPlatform,validations:[],isValid:!0}}e.$yF=i;function n(a,l){return{identifier:new R.$0l((0,P.$Go)(a.manifest.publisher,a.manifest.name)),isBuiltin:a.type===0,isUserBuiltin:a.type===1&&a.isBuiltin,isUnderDevelopment:!!l,extensionLocation:a.location,...a.manifest,uuid:a.identifier.uuid,targetPlatform:a.targetPlatform}}e.$zF=n;class u{constructor(){this.onDidRegisterExtensions=E.Event.None,this.onDidChangeExtensionsStatus=E.Event.None,this.onDidChangeExtensions=E.Event.None,this.onWillActivateByEvent=E.Event.None,this.onDidChangeResponsiveChange=E.Event.None,this.onWillStop=E.Event.None,this.extensions=[]}activateByEvent(l){return Promise.resolve(void 0)}activationEventIsDone(l){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(l){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(l,r){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(l){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$AF=u}),define(Ae[219],Re([1,0,11,106,22,23,15,12]),function(pe,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pdc=e.$odc=e.$ndc=e.$mdc=e.$ldc=e.$kdc=void 0;class D{static{this.NONE=new D(!1,-1,-1,-1)}constructor(i,n,u,a){this.startup=i,this.codeLoadingTime=n,this.activateCallTime=u,this.activateResolvedTime=a}}e.$kdc=D;class g{constructor(i){this.a=i,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(i,n){return i===-1||n===-1?-1:n-i}build(){return new D(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$ldc=g;class A{constructor(i,n,u,a,l,r){this.activationFailed=i,this.activationFailedError=n,this.activationTimes=u,this.module=a,this.exports=l,this.subscriptions=r}}e.$mdc=A;class S extends A{constructor(i){super(!1,null,i,{activate:void 0,deactivate:void 0},void 0,[])}}e.$ndc=S;class o extends A{constructor(){super(!1,null,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$odc=o;class v extends A{constructor(i){super(!0,i,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let p=class{constructor(i,n,u,a){this.g=a,this.a=i,this.b=n,this.c=u,this.d=new P.$_l,this.f=Object.create(null)}dispose(){for(const[i,n]of this.d)n.dispose()}async waitForActivatingExtensions(){const i=[];for(const[n,u]of this.d)i.push(u.wait());await Promise.all(i)}isActivated(i){const n=this.d.get(i);return!!(n&&n.value)}getActivatedExtension(i){const n=this.d.get(i);if(!n||!n.value)throw new Error(`Extension '${i.value}' is not known or not activated`);return n.value}async activateByEvent(i,n){if(this.f[i])return;const u=this.a.getExtensionDescriptionsForActivationEvent(i);await this.h(u.map(a=>({id:a.identifier,reason:{startup:n,extensionId:a.identifier,activationEvent:i}}))),this.f[i]=!0}activateById(i,n){const u=this.a.getExtensionDescription(i);if(!u)throw new Error(`Extension '${i}' is not known`);return this.h([{id:u.identifier,reason:n}])}async h(i){const n=i.filter(u=>!this.isActivated(u.id)).map(u=>this.j(u));await Promise.all(n.map(u=>u.wait()))}j(i){if(this.d.has(i.id))return this.d.get(i.id);if(this.l(i.id))return this.k(i,null,[],null);const n=this.a.getExtensionDescription(i.id);if(!n){const l=new Error(`Cannot activate unknown extension '${i.id.value}'`),r=this.k(i,null,[],new v(l));return this.c.onExtensionActivationError(i.id,l,new M.$sF(i.id.value)),r}const u=[],a=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const l of a){if(this.m(l))continue;const r=this.d.get(l);if(r){u.push(r);continue}if(this.l(l)){u.push(this.j({id:this.b.getExtensionDescription(l).identifier,reason:i.reason}));continue}const s=this.a.getExtensionDescription(l);if(s){if(!s.main&&!s.browser)continue;u.push(this.j({id:s.identifier,reason:i.reason}));continue}const c=n.displayName||n.identifier.value,h=new Error(`Cannot activate the '${c}' extension because it depends on unknown extension '${l}'`),w=this.k(i,n.displayName,[],new v(h));return this.c.onExtensionActivationError(n.identifier,h,new M.$sF(l)),w}return this.k(i,n.displayName,u,null)}k(i,n,u,a){const l=new f(i.id,n,i.reason,u,a,this.c,this.g);return this.d.set(i.id,l),l}l(i){return L.$e5b.isHostExtension(i,this.a,this.b)}m(i){const n=this.b.getExtensionDescription(i);return n?!n.main&&!n.browser:!1}};e.$pdc=p,e.$pdc=p=Ke([Ve(3,R.$bj)],p);let f=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(i,n,u,a,l,r,s){this.c=i,this.d=n,this.f=u,this.g=a,this.h=l,this.j=r,this.k=s,this.a=new $.$Tg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let i=0;i<this.g.length;i++){const n=this.g[i];if(n.value&&!n.value.activationFailed){this.g.splice(i,1),i--;continue}if(n.value&&n.value.activationFailed){const u=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);u.detail=n.value.activationFailedError,this.h=new v(u),this.j.onExtensionActivationError(this.c,u,null);return}}this.g.length>0&&await Promise.race(this.g.map(i=>i.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(i){const n=new Error;if(i&&i.name&&(n.name=i.name),i&&i.message?n.message=`Activating extension '${this.c.value}' failed: ${i.message}.`:n.message=`Activating extension '${this.c.value}' failed: ${i}.`,i&&i.stack&&(n.stack=i.stack),this.h=new v(n),this.b&&E.$3(i))return;this.j.onExtensionActivationError(this.c,n,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(i)}}};f=Ke([Ve(6,R.$bj)],f)}),define(Ae[8],Re([1,0,18,24,126,220,53,28,120,52,69,26,16,2,29,80,98,104,102,76,48,60,217,7,23]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f,t,i,n,u,a,l,r,s,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$wM=e.$vM=e.MarkdownString=e.$uM=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var h;(function(Se){function Le(K){const{selectionStartLineNumber:Me,selectionStartColumn:Ue,positionLineNumber:Je,positionColumn:qe}=K,et=new s.$yK(Me-1,Ue-1),Et=new s.$yK(Je-1,qe-1);return new s.$AK(et,Et)}Se.to=Le;function $e(K){const{anchor:Me,active:Ue}=K;return{selectionStartLineNumber:Me.line+1,selectionStartColumn:Me.character+1,positionLineNumber:Ue.line+1,positionColumn:Ue.character+1}}Se.from=$e})(h||(e.Selection=h={}));var w;(function(Se){function Le(K){if(!K)return;const{start:Me,end:Ue}=K;return{startLineNumber:Me.line+1,startColumn:Me.character+1,endLineNumber:Ue.line+1,endColumn:Ue.character+1}}Se.from=Le;function $e(K){if(!K)return;const{startLineNumber:Me,startColumn:Ue,endLineNumber:Je,endColumn:qe}=K;return new s.$zK(Me-1,Ue-1,Je-1,qe-1)}Se.to=$e})(w||(e.Range=w={}));var m;(function(Se){function Le($e){switch($e){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Se.to=Le})(m||(e.TokenType=m={}));var I;(function(Se){function Le(K){return new s.$yK(K.lineNumber-1,K.column-1)}Se.to=Le;function $e(K){return{lineNumber:K.line+1,column:K.character+1}}Se.from=$e})(I||(e.Position=I={}));var k;(function(Se){function Le(Me,Ue,Je){return(0,E.$Gb)((0,E.$2b)(Me).map(qe=>$e(qe,Ue,Je)))}Se.from=Le;function $e(Me,Ue,Je){if(typeof Me=="string")return{$serialized:!0,language:Me,isBuiltin:Je?.isBuiltin};if(Me)return{$serialized:!0,language:Me.language,scheme:K(Me.scheme,Ue),pattern:Y.from(Me.pattern)??void 0,exclusive:Me.exclusive,notebookType:Me.notebookType,isBuiltin:Je?.isBuiltin}}function K(Me,Ue){return Ue&&typeof Me=="string"?Ue.transformOutgoingScheme(Me):Me}})(k||(e.DocumentSelector=k={}));var d;(function(Se){function Le(K){switch(K){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Se.from=Le;function $e(K){switch(K){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Se.to=$e})(d||(e.DiagnosticTag=d={}));var b;(function(Se){function Le(K){let Me;return K.code&&((0,o.$zf)(K.code)||(0,o.$Df)(K.code)?Me=String(K.code):Me={value:String(K.code.value),target:K.code.target}),{...w.from(K.range),message:K.message,source:K.source,code:Me,severity:C.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(y.from),tags:Array.isArray(K.tags)?(0,E.$Gb)(K.tags.map(d.from)):void 0}}Se.from=Le;function $e(K){const Me=new s.$LK(w.to(K),K.message,C.to(K.severity));return Me.source=K.source,Me.code=(0,o.$zf)(K.code)?K.code:K.code?.value,Me.relatedInformation=K.relatedInformation&&K.relatedInformation.map(y.to),Me.tags=K.tags&&(0,E.$Gb)(K.tags.map(d.to)),Me}Se.to=$e})(b||(e.Diagnostic=b={}));var y;(function(Se){function Le(K){return{...w.from(K.location.range),message:K.message,resource:K.location.uri}}Se.from=Le;function $e(K){return new s.$KK(new s.$JK(K.resource,w.to(K)),K.message)}Se.to=$e})(y||(e.DiagnosticRelatedInformation=y={}));var C;(function(Se){function Le(K){switch(K){case s.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}Se.from=Le;function $e(K){switch(K){case t.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Se.to=$e})(C||(e.DiagnosticSeverity=C={}));var B;(function(Se){function Le(K){return typeof K=="number"&&K>=s.ViewColumn.One?K-1:K===s.ViewColumn.Beside?r.$JC:r.$IC}Se.from=Le;function $e(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}Se.to=$e})(B||(e.ViewColumn=B={}));function H(Se){return typeof Se.range<"u"}function U(Se){return Se.length===0?!0:!!H(Se[0])}e.$uM=U;var z;(function(Se){function Le(qe){return qe.map(Se.from)}Se.fromMany=Le;function $e(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function K(qe){let et;if($e(qe)){const{language:ht,value:ft}=qe;et={value:"```"+ht+`
`+ft+"\n```\n"}}else s.$XK.isMarkdownString(qe)?et={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons,supportHtml:qe.supportHtml,baseUri:qe.baseUri}:typeof qe=="string"?et={value:qe}:et={value:""};const Et=Object.create(null);et.uris=Et;const Dt=ht=>{try{let ft=v.URI.parse(ht,!0);ft=ft.with({query:Me(ft.query,Et)}),Et[ht]=ft}catch{}return""},gt=new D.marked.Renderer;return gt.link=Dt,gt.image=ht=>typeof ht=="string"?Dt(R.$bk(ht).href):"",(0,D.marked)(et.value,{renderer:gt}),et}Se.from=K;function Me(qe,et){if(!qe)return qe;let Et;try{Et=(0,g.$ph)(qe)}catch{}if(!Et)return qe;let Dt=!1;return Et=(0,S.$an)(Et,gt=>{if(v.URI.isUri(gt)){const ht=`__uri_${Math.random().toString(16).slice(2,8)}`;return et[ht]=gt,Dt=!0,ht}else return}),Dt?JSON.stringify(Et):qe}function Ue(qe){const et=new s.$XK(qe.value,qe.supportThemeIcons);return et.isTrusted=qe.isTrusted,et.supportHtml=qe.supportHtml,et.baseUri=qe.baseUri?v.URI.from(qe.baseUri):void 0,et}Se.to=Ue;function Je(qe){if(qe)return typeof qe=="string"?qe:Se.from(qe)}Se.fromStrict=Je})(z||(e.MarkdownString=z={}));function F(Se){return U(Se)?Se.map(Le=>({range:w.from(Le.range),hoverMessage:Array.isArray(Le.hoverMessage)?z.fromMany(Le.hoverMessage):Le.hoverMessage?z.from(Le.hoverMessage):void 0,renderOptions:Le.renderOptions})):Se.map(Le=>({range:w.from(Le)}))}e.$vM=F;function N(Se){return typeof Se>"u"?Se:typeof Se=="string"?v.URI.file(Se):Se}e.$wM=N;var x;(function(Se){function Le($e){return typeof $e>"u"?$e:{contentText:$e.contentText,contentIconPath:$e.contentIconPath?N($e.contentIconPath):void 0,border:$e.border,borderColor:$e.borderColor,fontStyle:$e.fontStyle,fontWeight:$e.fontWeight,textDecoration:$e.textDecoration,color:$e.color,backgroundColor:$e.backgroundColor,margin:$e.margin,width:$e.width,height:$e.height}}Se.from=Le})(x||(e.ThemableDecorationAttachmentRenderOptions=x={}));var J;(function(Se){function Le($e){return typeof $e>"u"?$e:{backgroundColor:$e.backgroundColor,outline:$e.outline,outlineColor:$e.outlineColor,outlineStyle:$e.outlineStyle,outlineWidth:$e.outlineWidth,border:$e.border,borderColor:$e.borderColor,borderRadius:$e.borderRadius,borderSpacing:$e.borderSpacing,borderStyle:$e.borderStyle,borderWidth:$e.borderWidth,fontStyle:$e.fontStyle,fontWeight:$e.fontWeight,textDecoration:$e.textDecoration,cursor:$e.cursor,color:$e.color,opacity:$e.opacity,letterSpacing:$e.letterSpacing,gutterIconPath:$e.gutterIconPath?N($e.gutterIconPath):void 0,gutterIconSize:$e.gutterIconSize,overviewRulerColor:$e.overviewRulerColor,before:$e.before?x.from($e.before):void 0,after:$e.after?x.from($e.after):void 0}}Se.from=Le})(J||(e.ThemableDecorationRenderOptions=J={}));var ye;(function(Se){function Le($e){if(typeof $e>"u")return $e;switch($e){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Se.from=Le})(ye||(e.DecorationRangeBehavior=ye={}));var De;(function(Se){function Le($e){return{isWholeLine:$e.isWholeLine,rangeBehavior:$e.rangeBehavior?ye.from($e.rangeBehavior):void 0,overviewRulerLane:$e.overviewRulerLane,light:$e.light?J.from($e.light):void 0,dark:$e.dark?J.from($e.dark):void 0,backgroundColor:$e.backgroundColor,outline:$e.outline,outlineColor:$e.outlineColor,outlineStyle:$e.outlineStyle,outlineWidth:$e.outlineWidth,border:$e.border,borderColor:$e.borderColor,borderRadius:$e.borderRadius,borderSpacing:$e.borderSpacing,borderStyle:$e.borderStyle,borderWidth:$e.borderWidth,fontStyle:$e.fontStyle,fontWeight:$e.fontWeight,textDecoration:$e.textDecoration,cursor:$e.cursor,color:$e.color,opacity:$e.opacity,letterSpacing:$e.letterSpacing,gutterIconPath:$e.gutterIconPath?N($e.gutterIconPath):void 0,gutterIconSize:$e.gutterIconSize,overviewRulerColor:$e.overviewRulerColor,before:$e.before?x.from($e.before):void 0,after:$e.after?x.from($e.after):void 0}}Se.from=Le})(De||(e.DecorationRenderOptions=De={}));var Ce;(function(Se){function Le(K){return{text:K.newText,eol:K.newEol&&xe.from(K.newEol),range:w.from(K.range)}}Se.from=Le;function $e(K){const Me=new s.$EK(w.to(K.range),K.text);return Me.newEol=typeof K.eol>"u"?void 0:xe.to(K.eol),Me}Se.to=$e})(Ce||(e.TextEdit=Ce={}));var ge;(function(Se){function Le(K,Me){const Ue={edits:[]};if(K instanceof s.$HK){const Je=new $.$Ac;for(const qe of K._allEntries())qe._type===1&&v.URI.isUri(qe.to)&&qe.from===void 0&&Je.add(qe.to);for(const qe of K._allEntries())if(qe._type===1){let et;qe.options?.contents&&(ArrayBuffer.isView(qe.options.contents)?et={type:"base64",value:(0,L.$we)(L.$ce.wrap(qe.options.contents))}:et={type:"dataTransferItem",id:qe.options.contents._itemId}),Ue.edits.push({oldResource:qe.from,newResource:qe.to,options:{...qe.options,contents:et},metadata:qe.metadata})}else qe._type===2?Ue.edits.push({resource:qe.uri,textEdit:Ce.from(qe.edit),versionId:Je.has(qe.uri)?void 0:Me?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===6?Ue.edits.push({resource:qe.uri,textEdit:{range:w.from(qe.range),text:qe.edit.value,insertAsSnippet:!0},versionId:Je.has(qe.uri)?void 0:Me?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===3?Ue.edits.push({metadata:qe.metadata,resource:qe.uri,cellEdit:qe.edit,notebookMetadata:qe.notebookMetadata,notebookVersionId:Me?.getNotebookDocumentVersion(qe.uri)}):qe._type===5&&Ue.edits.push({metadata:qe.metadata,resource:qe.uri,notebookVersionId:Me?.getNotebookDocumentVersion(qe.uri),cellEdit:{editType:1,index:qe.index,count:qe.count,cells:qe.cells.map(wt.from)}})}return Ue}Se.from=Le;function $e(K){const Me=new s.$HK,Ue=new $.$zc;for(const Je of K.edits)if(Je.textEdit){const qe=Je,et=v.URI.revive(qe.resource),Et=w.to(qe.textEdit.range),Dt=qe.textEdit.text,gt=qe.textEdit.insertAsSnippet;let ht;gt?ht=s.$GK.replace(Et,new s.$IK(Dt)):ht=s.$EK.replace(Et,Dt);const ft=Ue.get(et);ft?ft.push(ht):Ue.set(et,[ht])}else Me.renameFile(v.URI.revive(Je.oldResource),v.URI.revive(Je.newResource),Je.options);for(const[Je,qe]of Ue)Me.set(Je,qe);return Me}Se.to=$e})(ge||(e.WorkspaceEdit=ge={}));var we;(function(Se){const Le=Object.create(null);Le[s.SymbolKind.File]=0,Le[s.SymbolKind.Module]=1,Le[s.SymbolKind.Namespace]=2,Le[s.SymbolKind.Package]=3,Le[s.SymbolKind.Class]=4,Le[s.SymbolKind.Method]=5,Le[s.SymbolKind.Property]=6,Le[s.SymbolKind.Field]=7,Le[s.SymbolKind.Constructor]=8,Le[s.SymbolKind.Enum]=9,Le[s.SymbolKind.Interface]=10,Le[s.SymbolKind.Function]=11,Le[s.SymbolKind.Variable]=12,Le[s.SymbolKind.Constant]=13,Le[s.SymbolKind.String]=14,Le[s.SymbolKind.Number]=15,Le[s.SymbolKind.Boolean]=16,Le[s.SymbolKind.Array]=17,Le[s.SymbolKind.Object]=18,Le[s.SymbolKind.Key]=19,Le[s.SymbolKind.Null]=20,Le[s.SymbolKind.EnumMember]=21,Le[s.SymbolKind.Struct]=22,Le[s.SymbolKind.Event]=23,Le[s.SymbolKind.Operator]=24,Le[s.SymbolKind.TypeParameter]=25;function $e(Me){return typeof Le[Me]=="number"?Le[Me]:6}Se.from=$e;function K(Me){for(const Ue in Le)if(Le[Ue]===Me)return Number(Ue);return s.SymbolKind.Property}Se.to=K})(we||(e.SymbolKind=we={}));var re;(function(Se){function Le(K){switch(K){case s.SymbolTag.Deprecated:return 1}}Se.from=Le;function $e(K){switch(K){case 1:return s.SymbolTag.Deprecated}}Se.to=$e})(re||(e.SymbolTag=re={}));var oe;(function(Se){function Le(K){return{name:K.name,kind:we.from(K.kind),tags:K.tags&&K.tags.map(re.from),containerName:K.containerName,location:Pe.from(K.location)}}Se.from=Le;function $e(K){const Me=new s.$OK(K.name,we.to(K.kind),K.containerName,Pe.to(K.location));return Me.tags=K.tags&&K.tags.map(re.to),Me}Se.to=$e})(oe||(e.WorkspaceSymbol=oe={}));var ve;(function(Se){function Le(K){const Me={name:K.name||"!!MISSING: name!!",detail:K.detail,range:w.from(K.range),selectionRange:w.from(K.selectionRange),kind:we.from(K.kind),tags:K.tags?.map(re.from)??[]};return K.children&&(Me.children=K.children.map(Le)),Me}Se.from=Le;function $e(K){const Me=new s.$PK(K.name,K.detail,we.to(K.kind),w.to(K.range),w.to(K.selectionRange));return(0,E.$Kb)(K.tags)&&(Me.tags=K.tags.map(re.to)),K.children&&(Me.children=K.children.map($e)),Me}Se.to=$e})(ve||(e.DocumentSymbol=ve={}));var ee;(function(Se){function Le(K){const Me=new s.$TK(we.to(K.kind),K.name,K.detail||"",v.URI.revive(K.uri),w.to(K.range),w.to(K.selectionRange));return Me._sessionId=K._sessionId,Me._itemId=K._itemId,Me}Se.to=Le;function $e(K,Me,Ue){if(Me=Me??K._sessionId,Ue=Ue??K._itemId,Me===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:Ue,name:K.name,detail:K.detail,kind:we.from(K.kind),uri:K.uri,range:w.from(K.range),selectionRange:w.from(K.selectionRange),tags:K.tags?.map(re.from)}}Se.from=$e})(ee||(e.CallHierarchyItem=ee={}));var W;(function(Se){function Le($e){return new s.$UK(ee.to($e.from),$e.fromRanges.map(K=>w.to(K)))}Se.to=Le})(W||(e.CallHierarchyIncomingCall=W={}));var ue;(function(Se){function Le($e){return new s.$VK(ee.to($e.to),$e.fromRanges.map(K=>w.to(K)))}Se.to=Le})(ue||(e.CallHierarchyOutgoingCall=ue={}));var Pe;(function(Se){function Le(K){return{range:K.range&&w.from(K.range),uri:K.uri}}Se.from=Le;function $e(K){return new s.$JK(v.URI.revive(K.uri),w.to(K.range))}Se.to=$e})(Pe||(e.location=Pe={}));var Ee;(function(Se){function Le(K){const Me=K,Ue=K;return{originSelectionRange:Me.originSelectionRange?w.from(Me.originSelectionRange):void 0,uri:Me.targetUri?Me.targetUri:Ue.uri,range:w.from(Me.targetRange?Me.targetRange:Ue.range),targetSelectionRange:Me.targetSelectionRange?w.from(Me.targetSelectionRange):void 0}}Se.from=Le;function $e(K){return{targetUri:v.URI.revive(K.uri),targetRange:w.to(K.range),targetSelectionRange:K.targetSelectionRange?w.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?w.to(K.originSelectionRange):void 0}}Se.to=$e})(Ee||(e.DefinitionLink=Ee={}));var te;(function(Se){function Le(K){return{range:w.from(K.range),contents:z.fromMany(K.contents)}}Se.from=Le;function $e(K){return new s.$MK(K.contents.map(z.to),w.to(K.range))}Se.to=$e})(te||(e.Hover=te={}));var se;(function(Se){function Le(K){return{range:w.from(K.range),expression:K.expression}}Se.from=Le;function $e(K){return new s.$FL(w.to(K.range),K.expression)}Se.to=$e})(se||(e.EvaluatableExpression=se={}));var me;(function(Se){function Le(K){if(K instanceof s.$GL)return{type:"text",range:w.from(K.range),text:K.text};if(K instanceof s.$HL)return{type:"variable",range:w.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof s.$IL)return{type:"expression",range:w.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}Se.from=Le;function $e(K){switch(K.type){case"text":return{range:w.to(K.range),text:K.text};case"variable":return{range:w.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:w.to(K.range),expression:K.expression}}}Se.to=$e})(me||(e.InlineValue=me={}));var Z;(function(Se){function Le(K){return{frameId:K.frameId,stoppedLocation:w.from(K.stoppedLocation)}}Se.from=Le;function $e(K){return new s.$JL(K.frameId,w.to(K.stoppedLocation))}Se.to=$e})(Z||(e.InlineValueContext=Z={}));var le;(function(Se){function Le(K){return{range:w.from(K.range),kind:K.kind}}Se.from=Le;function $e(K){return new s.$NK(w.to(K.range),K.kind)}Se.to=$e})(le||(e.DocumentHighlight=le={}));var ne;(function(Se){function Le($e){switch($e){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Se.to=Le})(ne||(e.CompletionTriggerKind=ne={}));var ae;(function(Se){function Le($e){return{triggerKind:ne.to($e.triggerKind),triggerCharacter:$e.triggerCharacter}}Se.to=Le})(ae||(e.CompletionContext=ae={}));var de;(function(Se){function Le(K){switch(K){case s.CompletionItemTag.Deprecated:return 1}}Se.from=Le;function $e(K){switch(K){case 1:return s.CompletionItemTag.Deprecated}}Se.to=$e})(de||(e.CompletionItemTag=de={}));var Ie;(function(Se){const Le=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function $e(Ue){return Le.get(Ue)??9}Se.from=$e;const K=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Me(Ue){return K.get(Ue)??s.CompletionItemKind.Property}Se.to=Me})(Ie||(e.CompletionItemKind=Ie={}));var T;(function(Se){function Le($e,K){const Me=new s.$4K($e.label);return Me.insertText=$e.insertText,Me.kind=Ie.to($e.kind),Me.tags=$e.tags?.map(de.to),Me.detail=$e.detail,Me.documentation=R.$9j($e.documentation)?z.to($e.documentation):$e.documentation,Me.sortText=$e.sortText,Me.filterText=$e.filterText,Me.preselect=$e.preselect,Me.commitCharacters=$e.commitCharacters,p.$xs.isIRange($e.range)?Me.range=w.to($e.range):typeof $e.range=="object"&&(Me.range={inserting:w.to($e.range.insert),replacing:w.to($e.range.replace)}),Me.keepWhitespace=typeof $e.insertTextRules>"u"?!1:!!($e.insertTextRules&1),typeof $e.insertTextRules<"u"&&$e.insertTextRules&4?Me.insertText=new s.$IK($e.insertText):(Me.insertText=$e.insertText,Me.textEdit=Me.range instanceof s.$zK?new s.$EK(Me.range,Me.insertText):void 0),$e.additionalTextEdits&&$e.additionalTextEdits.length>0&&(Me.additionalTextEdits=$e.additionalTextEdits.map(Ue=>Ce.to(Ue))),Me.command=K&&$e.command?K.fromInternal($e.command):void 0,Me}Se.to=Le})(T||(e.CompletionItem=T={}));var V;(function(Se){function Le(K){if(typeof K.label!="string"&&!Array.isArray(K.label))throw new TypeError("Invalid label");return{label:K.label,documentation:z.fromStrict(K.documentation)}}Se.from=Le;function $e(K){return{label:K.label,documentation:R.$9j(K.documentation)?z.to(K.documentation):K.documentation}}Se.to=$e})(V||(e.ParameterInformation=V={}));var G;(function(Se){function Le(K){return{label:K.label,documentation:z.fromStrict(K.documentation),parameters:Array.isArray(K.parameters)?K.parameters.map(V.from):[],activeParameter:K.activeParameter}}Se.from=Le;function $e(K){return{label:K.label,documentation:R.$9j(K.documentation)?z.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(V.to):[],activeParameter:K.activeParameter}}Se.to=$e})(G||(e.SignatureInformation=G={}));var Q;(function(Se){function Le(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(G.from):[]}}Se.from=Le;function $e(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(G.to):[]}}Se.to=$e})(Q||(e.SignatureHelp=Q={}));var q;(function(Se){function Le($e,K){const Me=new s.$3K(I.to(K.position),typeof K.label=="string"?K.label:K.label.map(_.to.bind(void 0,$e)),K.kind&&he.to(K.kind));return Me.textEdits=K.textEdits&&K.textEdits.map(Ce.to),Me.tooltip=R.$9j(K.tooltip)?z.to(K.tooltip):K.tooltip,Me.paddingLeft=K.paddingLeft,Me.paddingRight=K.paddingRight,Me}Se.to=Le})(q||(e.InlayHint=q={}));var _;(function(Se){function Le($e,K){const Me=new s.$2K(K.label);return Me.tooltip=R.$9j(K.tooltip)?z.to(K.tooltip):K.tooltip,f.Command.is(K.command)&&(Me.command=$e.fromInternal(K.command)),K.location&&(Me.location=Pe.to(K.location)),Me}Se.to=Le})(_||(e.InlayHintLabelPart=_={}));var he;(function(Se){function Le(K){return K}Se.from=Le;function $e(K){return K}Se.to=$e})(he||(e.InlayHintKind=he={}));var Oe;(function(Se){function Le(K){return{range:w.from(K.range),url:K.target,tooltip:K.tooltip}}Se.from=Le;function $e(K){let Me;if(K.url)try{Me=typeof K.url=="string"?v.URI.parse(K.url,!0):v.URI.revive(K.url)}catch{}return new s.$9K(w.to(K.range),Me)}Se.to=$e})(Oe||(e.DocumentLink=Oe={}));var je;(function(Se){function Le(K){const Me=new s.$_K(K.label);return K.textEdit&&(Me.textEdit=Ce.to(K.textEdit)),K.additionalTextEdits&&(Me.additionalTextEdits=K.additionalTextEdits.map(Ue=>Ce.to(Ue))),Me}Se.to=Le;function $e(K){return{label:K.label,textEdit:K.textEdit?Ce.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(Me=>Ce.from(Me)):void 0}}Se.from=$e})(je||(e.ColorPresentation=je={}));var Qe;(function(Se){function Le(K){return new s.$0K(K[0],K[1],K[2],K[3])}Se.to=Le;function $e(K){return[K.red,K.green,K.blue,K.alpha]}Se.from=$e})(Qe||(e.Color=Qe={}));var Ge;(function(Se){function Le(K){return{range:w.from(K.range)}}Se.from=Le;function $e(K){return new s.$SK(w.to(K.range))}Se.to=$e})(Ge||(e.SelectionRange=Ge={}));var _e;(function(Se){function Le($e){switch($e){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Se.to=Le})(_e||(e.TextDocumentSaveReason=_e={}));var Ye;(function(Se){function Le(K){switch(K){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}Se.from=Le;function $e(K){switch(K){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}Se.to=$e})(Ye||(e.TextEditorLineNumbersStyle=Ye={}));var xe;(function(Se){function Le(K){if(K===s.EndOfLine.CRLF)return 1;if(K===s.EndOfLine.LF)return 0}Se.from=Le;function $e(K){if(K===1)return s.EndOfLine.CRLF;if(K===0)return s.EndOfLine.LF}Se.to=$e})(xe||(e.EndOfLine=xe={}));var it;(function(Se){function Le($e){if(typeof $e=="object")return $e.viewId;switch($e){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Se.from=Le})(it||(e.ProgressLocation=it={}));var tt;(function(Se){function Le(K){const Me={start:K.start+1,end:K.end+1};return K.kind&&(Me.kind=ze.from(K.kind)),Me}Se.from=Le;function $e(K){const Me={start:K.start-1,end:K.end-1};return K.kind&&(Me.kind=ze.to(K.kind)),Me}Se.to=$e})(tt||(e.FoldingRange=tt={}));var ze;(function(Se){function Le(K){if(K)switch(K){case s.FoldingRangeKind.Comment:return f.$mt.Comment;case s.FoldingRangeKind.Imports:return f.$mt.Imports;case s.FoldingRangeKind.Region:return f.$mt.Region}}Se.from=Le;function $e(K){if(K)switch(K.value){case f.$mt.Comment.value:return s.FoldingRangeKind.Comment;case f.$mt.Imports.value:return s.FoldingRangeKind.Imports;case f.$mt.Region.value:return s.FoldingRangeKind.Region}}Se.to=$e})(ze||(e.FoldingRangeKind=ze={}));var ut;(function(Se){function Le($e){if($e)return{pinned:typeof $e.preview=="boolean"?!$e.preview:void 0,inactive:$e.background,preserveFocus:$e.preserveFocus,selection:typeof $e.selection=="object"?w.from($e.selection):void 0,override:typeof $e.override=="boolean"?n.$$D.id:void 0}}Se.from=Le})(ut||(e.TextEditorOpenOptions=ut={}));var Y;(function(Se){function Le(Ue){return Ue instanceof s.$tL?Ue.toJSON():typeof Ue=="string"?Ue:$e(Ue)||K(Ue)?new s.$tL(Ue.baseUri??Ue.base,Ue.pattern).toJSON():Ue}Se.from=Le;function $e(Ue){const Je=Ue;return Je?v.URI.isUri(Je.baseUri)&&typeof Je.pattern=="string":!1}function K(Ue){const Je=Ue;return Je?typeof Je.base=="string"&&typeof Je.pattern=="string":!1}function Me(Ue){return typeof Ue=="string"?Ue:new s.$tL(v.URI.revive(Ue.baseUri),Ue.pattern)}Se.to=Me})(Y||(e.GlobPattern=Y={}));var X;(function(Se){function Le($e){if($e){if(Array.isArray($e))return $e.map(Le);if(typeof $e=="string")return $e;{const K=$e;return{language:K.language,scheme:K.scheme,pattern:Y.from(K.pattern),exclusive:K.exclusive,notebookType:K.notebookType}}}else return}Se.from=Le})(X||(e.LanguageSelector=X={}));var be;(function(Se){function Le(K){return!!K&&typeof K=="object"&&"documents"in K&&Array.isArray(K.documents)&&K.documents.every(Me=>Array.isArray(Me)&&Me.every(Ue=>Ue&&typeof Ue=="object"&&"uri"in Ue&&v.URI.isUri(Ue.uri)&&"version"in Ue&&typeof Ue.version=="number"&&"ranges"in Ue&&Array.isArray(Ue.ranges)&&Ue.ranges.every(Je=>Je instanceof s.$zK)))}Se.is=Le;function $e(K){return{documents:K.documents.map(Me=>Me.map(Ue=>({uri:v.URI.from(Ue.uri),version:Ue.version,ranges:Ue.ranges.map(Je=>w.from(Je))})))}}Se.from=$e})(be||(e.MappedEditsContext=be={}));var Be;(function(Se){function Le(K){return{start:K.start,end:K.end}}Se.from=Le;function $e(K){return new s.$UL(K.start,K.end)}Se.to=$e})(Be||(e.NotebookRange=Be={}));var Ne;(function(Se){function Le(K){return{timing:typeof K.runStartTime=="number"&&typeof K.runEndTime=="number"?{startTime:K.runStartTime,endTime:K.runEndTime}:void 0,executionOrder:K.executionOrder,success:K.lastRunSuccess}}Se.to=Le;function $e(K){return{lastRunSuccess:K.success,runStartTime:K.timing?.startTime,runEndTime:K.timing?.endTime,executionOrder:K.executionOrder}}Se.from=$e})(Ne||(e.NotebookCellExecutionSummary=Ne={}));var Xe;(function(Se){function Le($e){if($e===u.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if($e===u.NotebookCellExecutionState.Pending)return;if($e===u.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${$e}`)}Se.to=Le})(Xe||(e.NotebookCellExecutionState=Xe={}));var nt;(function(Se){function Le(K){switch(K){case s.NotebookCellKind.Markup:return u.CellKind.Markup;case s.NotebookCellKind.Code:default:return u.CellKind.Code}}Se.from=Le;function $e(K){switch(K){case u.CellKind.Markup:return s.NotebookCellKind.Markup;case u.CellKind.Code:default:return s.NotebookCellKind.Code}}Se.to=$e})(nt||(e.NotebookCellKind=nt={}));var $t;(function(Se){function Le(K){const Me={metadata:K.metadata??Object.create(null),cells:[]};for(const Ue of K.cells)s.$VL.validate(Ue),Me.cells.push(wt.from(Ue));return Me}Se.from=Le;function $e(K){const Me=new s.$WL(K.cells.map(wt.to));return(0,o.$Mf)(K.metadata)||(Me.metadata=K.metadata),Me}Se.to=$e})($t||(e.NotebookData=$t={}));var wt;(function(Se){function Le(K){return{cellKind:nt.from(K.kind),language:K.languageId,mime:K.mime,source:K.value,metadata:K.metadata,internalMetadata:Ne.from(K.executionSummary??{}),outputs:K.outputs?K.outputs.map(Kt.from):[]}}Se.from=Le;function $e(K){return new s.$VL(nt.to(K.cellKind),K.source,K.language,K.mime,K.outputs?K.outputs.map(Kt.to):void 0,K.metadata,K.internalMetadata?Ne.to(K.internalMetadata):void 0)}Se.to=$e})(wt||(e.NotebookCellData=wt={}));var Pt;(function(Se){function Le(K){return{mime:K.mime,valueBytes:L.$ce.wrap(K.data)}}Se.from=Le;function $e(K){return new s.$XL(K.valueBytes.buffer,K.mime)}Se.to=$e})(Pt||(e.NotebookCellOutputItem=Pt={}));var Kt;(function(Se){function Le(K){return{outputId:K.id,items:K.items.map(Pt.from),metadata:K.metadata}}Se.from=Le;function $e(K){const Me=K.items.map(Pt.to);return new s.$YL(Me,K.outputId,K.metadata)}Se.to=$e})(Kt||(e.NotebookCellOutput=Kt={}));var Ht;(function(Se){function Le(Me){return K(Me)?{include:Y.from(Me.include)??void 0,exclude:Y.from(Me.exclude)??void 0}:Y.from(Me)??void 0}Se.from=Le;function $e(Me){return K(Me)?{include:Y.to(Me.include),exclude:Y.to(Me.exclude)}:Y.to(Me)}Se.to=$e;function K(Me){const Ue=Me;return Ue?!(0,o.$If)(Ue.include)&&!(0,o.$If)(Ue.exclude):!1}})(Ht||(e.NotebookExclusiveDocumentPattern=Ht={}));var vt;(function(Se){function Le($e,K,Me){const Ue=typeof $e.command=="string"?{title:"",command:$e.command}:$e.command;return{alignment:$e.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:K.toInternal(Ue,Me),text:$e.text,tooltip:$e.tooltip,accessibilityInformation:$e.accessibilityInformation,priority:$e.priority}}Se.from=Le})(vt||(e.NotebookStatusBarItem=vt={}));var Ut;(function(Se){function Le($e,K,Me){const Ue=typeof $e.command=="string"?{title:"",command:$e.command}:$e.command;return{command:K.toInternal(Ue,Me),label:$e.label,description:$e.description,detail:$e.detail,documentation:$e.documentation}}Se.from=Le})(Ut||(e.NotebookKernelSourceAction=Ut={}));var Ot;(function(Se){function Le($e){return{transientOutputs:$e?.transientOutputs??!1,transientCellMetadata:$e?.transientCellMetadata??{},transientDocumentMetadata:$e?.transientDocumentMetadata??{},cellContentMetadata:$e?.cellContentMetadata??{}}}Se.from=Le})(Ot||(e.NotebookDocumentContentOptions=Ot={}));var Gt;(function(Se){function Le(K){return{uri:K.uri,provides:K.provides}}Se.from=Le;function $e(K){return new s.$1L(v.URI.revive(K.uri),K.provides)}Se.to=$e})(Gt||(e.NotebookRendererScript=Gt={}));var jt;(function(Se){function Le(K){return{message:z.fromStrict(K.message)||"",type:0,expected:K.expectedOutput,actual:K.actualOutput,contextValue:K.contextValue,location:K.location&&{range:w.from(K.location.range),uri:K.location.uri}}}Se.from=Le;function $e(K){const Me=new s.$7L(typeof K.message=="string"?K.message:z.to(K.message));return Me.actualOutput=K.actual,Me.expectedOutput=K.expected,Me.contextValue=K.contextValue,Me.location=K.location?Pe.to(K.location):void 0,Me}Se.to=$e})(jt||(e.TestMessage=jt={}));var kt;(function(Se){Se.namespace=l.$pJ,Se.denamespace=l.$qJ})(kt||(e.TestTag=kt={}));var Ft;(function(Se){function Le(K){const Me=(0,i.$tM)(K).controllerId;return{extId:a.$lJ.fromExtHostTestItem(K,Me).toString(),label:K.label,uri:v.URI.revive(K.uri),busy:K.busy,tags:K.tags.map(Ue=>kt.namespace(Me,Ue.id)),range:p.$xs.lift(w.from(K.range)),description:K.description||null,sortText:K.sortText||null,error:K.error&&z.fromStrict(K.error)||null}}Se.from=Le;function $e(K){return{parent:void 0,error:void 0,id:a.$lJ.fromString(K.extId).localId,label:K.label,uri:v.URI.revive(K.uri),tags:(K.tags||[]).map(Me=>{const{tagId:Ue}=kt.denamespace(Me);return new s.$8L(Ue)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:w.to(K.range||void 0),canResolveChildren:!1,busy:K.busy,description:K.description||void 0,sortText:K.sortText||void 0}}Se.toPlain=$e})(Ft||(e.TestItem=Ft={})),function(Se){function Le(K){return{id:K.id}}Se.from=Le;function $e(K){return new s.$8L(K.id)}Se.to=$e}(kt||(e.TestTag=kt={}));var Bt;(function(Se){const Le=(K,Me)=>{const Ue=[];for(const[qe,et]of Me)a.$lJ.compare(et.item.extId,qe)===2&&(Me.delete(qe),Ue.push(et));const Je={...Ft.toPlain(K.item),parent:void 0,taskStates:K.tasks.map(qe=>({state:qe.state,duration:qe.duration,messages:qe.messages.filter(et=>et.type===0).map(jt.to)})),children:Ue.map(qe=>Le(qe,Me))};for(const qe of Je.children)qe.parent=Je;return Je};function $e(K){const Me=[],Ue=new Map;for(const Je of K.items){Ue.set(Je.item.extId,Je);const qe=a.$lJ.root(Je.item.extId);K.request.targets.some(et=>et.controllerId===qe&&et.testIds.includes(Je.item.extId))&&Me.push(Je)}return{completedAt:K.completedAt,results:Me.map(Je=>Le(Je,Ue))}}Se.to=$e})(Bt||(e.TestResults=Bt={}));var Jt;(function(Se){function Le(Ue){return{covered:Ue.covered,total:Ue.covered}}function $e(Ue){return"line"in Ue?I.from(Ue):w.from(Ue)}function K(Ue){return"branches"in Ue?{count:Ue.executionCount,location:$e(Ue.location),type:1,branches:Ue.branches.length?Ue.branches.map(Je=>({count:Je.executionCount,location:Je.location&&$e(Je.location)})):void 0}:{type:0,count:Ue.executionCount,location:$e(Ue.location)}}Se.fromDetailed=K;function Me(Ue){return{uri:Ue.uri,statement:Le(Ue.statementCoverage),branch:Ue.branchCoverage&&Le(Ue.branchCoverage),function:Ue.functionCoverage&&Le(Ue.functionCoverage),details:Ue.detailedCoverage?.map(K)}}Se.fromFile=Me})(Jt||(e.TestCoverage=Jt={}));var Wt;(function(Se){function Le($e){switch($e){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Se.to=Le})(Wt||(e.CodeActionTriggerKind=Wt={}));var Vt;(function(Se){function Le(K){const Me=new s.$bM(we.to(K.kind),K.name,K.detail||"",v.URI.revive(K.uri),w.to(K.range),w.to(K.selectionRange));return Me._sessionId=K._sessionId,Me._itemId=K._itemId,Me}Se.to=Le;function $e(K,Me,Ue){if(Me=Me??K._sessionId,Ue=Ue??K._itemId,Me===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:Ue,kind:we.from(K.kind),name:K.name,detail:K.detail??"",uri:K.uri,range:w.from(K.range),selectionRange:w.from(K.selectionRange),tags:K.tags?.map(re.from)}}Se.from=$e})(Vt||(e.TypeHierarchyItem=Vt={}));var Nt;(function(Se){function Le($e){if($e)return{value:$e.value,tooltip:$e.tooltip}}Se.from=Le})(Nt||(e.ViewBadge=Nt={}));var at;(function(Se){function Le(Ue,Je,qe){const et=Je.fileData;return et?new s.$mL(new s.$nL(et.name,v.URI.revive(et.uri),et.id,(0,M.$cb)(()=>qe(et.id)))):Ue===A.$Tr.uriList&&Je.uriListData?new s.$lL(Me(Je.uriListData)):new s.$lL(Je.asString)}Se.to=Le;async function $e(Ue,Je){const qe=await Je.asString();if(Ue===A.$Tr.uriList)return{asString:qe,fileData:void 0,uriListData:K(qe)};const et=Je.asFile();return{asString:qe,fileData:et?{name:et.name,uri:et.uri,id:et._itemId??et.id}:void 0}}Se.from=$e;function K(Ue){return P.$7s.split(Ue).map(Je=>{if(Je.startsWith("#"))return Je;try{return v.URI.parse(Je)}catch{}return Je})}function Me(Ue){return P.$7s.create(Ue.map(Je=>typeof Je=="string"?Je:v.URI.revive(Je)))}})(at||(e.DataTransferItem=at={}));var dt;(function(Se){function Le(K,Me){const Ue=K.items.map(([Je,qe])=>[Je,at.to(Je,qe,Me)]);return new s.$oL(Ue)}Se.toDataTransfer=Le;async function $e(K){const Me={items:[]},Ue=[];for(const[Je,qe]of K)Ue.push((async()=>{Me.items.push([Je,await at.from(Je,qe)])})());return await Promise.all(Ue),Me}Se.from=$e})(dt||(e.DataTransfer=dt={}));var At;(function(Se){function Le(K){return{message:K.message,metadata:K.metadata,title:K.title,tooltip:K.tooltip}}Se.to=Le;function $e(K){return{kind:"reply",message:K.message,metadata:K.metadata,title:K.title,tooltip:K.tooltip}}Se.from=$e})(At||(e.ChatReplyFollowup=At={}));var qt;(function(Se){function Le($e){return typeof $e=="string"?{title:$e,message:$e,kind:"reply"}:"commandId"in $e?{kind:"command",title:$e.title??"",commandId:$e.commandId??"",when:$e.when??"",args:$e.args}:At.from($e)}Se.from=Le})(qt||(e.ChatFollowup=qt={}));var Rt;(function(Se){function Le(K){const Me=new s.$mM(ot.to(K.role),K.content);return Me.name=K.name,Me}Se.to=Le;function $e(K){return{role:ot.from(K.role),content:K.content,name:K.name}}Se.from=$e})(Rt||(e.ChatMessage=Rt={}));var ot;(function(Se){function Le(K){switch(K){case 0:return s.ChatMessageRole.System;case 1:return s.ChatMessageRole.User;case 2:return s.ChatMessageRole.Assistant;case 3:return s.ChatMessageRole.Function}}Se.to=Le;function $e(K){switch(K){case s.ChatMessageRole.System:return 0;case s.ChatMessageRole.Assistant:return 2;case s.ChatMessageRole.Function:return 3;case s.ChatMessageRole.User:default:return 1}}Se.from=$e})(ot||(e.ChatMessageRole=ot={}));var bt;(function(Se){function Le(Me){const Ue={};for(const Je of Object.keys(Me))Ue[Je]=Me[Je].map(Se.to);return Ue}Se.objectTo=Le;function $e(Me){return{level:Tt.to(Me.level),value:Me.value,description:Me.description}}Se.to=$e;function K(Me){return{level:Tt.from(Me.level),value:Me.value,description:Me.description}}Se.from=K})(bt||(e.ChatVariable=bt={}));var Tt;(function(Se){function Le(K){switch(K){case"short":return s.ChatVariableLevel.Short;case"medium":return s.ChatVariableLevel.Medium;case"full":default:return s.ChatVariableLevel.Full}}Se.to=Le;function $e(K){switch(K){case s.ChatVariableLevel.Short:return"short";case s.ChatVariableLevel.Medium:return"medium";case s.ChatVariableLevel.Full:default:return"full"}}Se.from=$e})(Tt||(e.ChatVariableLevel=Tt={}));var Ct;(function(Se){function Le($e){switch($e){case 1:return s.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return s.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return s.InteractiveEditorResponseFeedbackKind.Undone;case 3:return s.InteractiveEditorResponseFeedbackKind.Accepted}}Se.to=Le})(Ct||(e.InteractiveEditorResponseFeedbackKind=Ct={}));var We;(function(Se){function Le($e,K){return"placeholder"in K&&"resolvedContent"in K?{placeholder:K.placeholder}:"responseId"in K?{requestId:K.responseId}:"markdownContent"in K?((0,c.$vF)($e,"chatAgents2Additions"),{content:z.from(K.markdownContent)}):"content"in K?typeof K.content=="string"?K:((0,c.$vF)($e,"chatAgents2Additions"),{content:z.from(K.content)}):"documents"in K?{documents:K.documents.map(Me=>({uri:Me.uri,version:Me.version,ranges:Me.ranges.map(Ue=>w.from(Ue))}))}:"reference"in K?{reference:"uri"in K.reference?{uri:K.reference.uri,range:w.from(K.reference.range)}:K.reference}:"inlineReference"in K?{inlineReference:"uri"in K.inlineReference?{uri:K.inlineReference.uri,range:w.from(K.inlineReference.range)}:K.inlineReference,title:K.title}:("agentName"in K&&(0,c.$vF)($e,"chatAgents2Additions"),K)}Se.from=Le})(We||(e.ChatResponseProgress=We={}));var Qt;(function(Se){function Le($e,K,Me){return"terminalCommand"in $e?{terminalCommand:$e.terminalCommand}:"uri"in $e?{uri:$e.uri}:K.toInternal($e,Me)}Se.from=Le})(Qt||(e.TerminalQuickFix=Qt={}))}),define(Ae[221],Re([1,0,2,11,7,8,187]),function(pe,e,E,L,P,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jdc=void 0;class ${constructor(g,A,S,o={timeout:1500,errors:3}){this.c=g,this.d=A,this.f=S,this.g=o,this.a=new R.$1c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(g){return(A,S,o)=>{const p={dispose:this.a.push([A,S,g])};return Array.isArray(o)&&o.push(p),p}}async $participateInSave(g,A){const S=E.URI.revive(g);let o=!1;const v=setTimeout(()=>o=!0,this.g.timeout),p=[];try{for(const f of[...this.a]){if(o)break;const t=this.d.getDocument(S),i=await this.h(f,{document:t,reason:M.TextDocumentSaveReason.to(A)});p.push(i)}}finally{clearTimeout(v)}return p}h([g,A,S],o){const v=this.b.get(g);return typeof v=="number"&&v>this.g.errors?Promise.resolve(!1):this.i(S,g,A,o).then(()=>!0,p=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${S.identifier.value}' threw ERROR`),this.c.error(p),!(p instanceof Error)||p.message!=="concurrent_edits"){const f=this.b.get(g);this.b.set(g,f?f+1:1),typeof f=="number"&&f>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${S.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(g,A,S,o){const v=[],p=Date.now(),{document:f,reason:t}=o,{version:i}=f,n=Object.freeze({document:f,reason:t,waitUntil(u){if(Object.isFrozen(v))throw(0,L.$7)("waitUntil can not be called async");v.push(Promise.resolve(u))}});try{A.apply(S,[n])}catch(u){return Promise.reject(u)}return Object.freeze(v),new Promise((u,a)=>{const l=setTimeout(()=>a(new Error("timeout")),this.g.timeout);return Promise.all(v).then(r=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${g.identifier.value}' finished after ${Date.now()-p}ms`),clearTimeout(l),u(r)}).catch(r=>{clearTimeout(l),a(r)})}).then(u=>{const a={edits:[]};for(const l of u)if(Array.isArray(l)&&l.every(r=>r instanceof P.$EK))for(const{newText:r,newEol:s,range:c}of l)a.edits.push({resource:f.uri,versionId:void 0,textEdit:{range:c&&M.Range.from(c),text:r,eol:s&&M.EndOfLine.from(s)}});if(a.edits.length!==0)return i===f.version?this.f.$tryApplyWorkspaceEdit(a):Promise.reject(new Error("concurrent_edits"))})}}e.$jdc=$}),define(Ae[222],Re([1,0,14,2,8,7,76]),function(pe,e,E,L,P,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xec=e.$wec=void 0;class ${constructor(S,o,v,p){this.start=S,this.deletedCount=o,this.deletedItems=v,this.items=p}asApiEvent(){return{range:new M.$UL(this.start,this.start+this.deletedCount),addedCells:this.items.map(S=>S.apiCell),removedCells:this.deletedItems}}}class D{static asModelAddData(S,o){return{EOL:o.eol,lines:o.source,languageId:o.language,uri:o.uri,isDirty:!1,versionId:1,notebook:S}}constructor(S,o,v){this.notebook=S,this.h=o,this.j=v,this.handle=v.handle,this.uri=L.URI.revive(v.uri),this.cellKind=v.cellKind,this.a=v.outputs.map(P.NotebookCellOutput.to),this.e=v.internalMetadata??{},this.b=Object.freeze(v.metadata??{}),this.d=Object.freeze(P.NotebookCellExecutionSummary.to(v.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const S=this,o=this.h.getDocument(this.uri);if(!o)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const v={get index(){return S.notebook.getCellIndex(S)},notebook:S.notebook.apiNotebook,kind:P.NotebookCellKind.to(this.j.cellKind),document:o.document,get mime(){return S.g},set mime(p){S.g=p},get outputs(){return S.a.slice(0)},get metadata(){return S.b},get executionSummary(){return S.d}};this.f=Object.freeze(v)}return this.f}setOutputs(S){this.a=S.map(P.NotebookCellOutput.to)}setOutputItems(S,o,v){const p=v.map(P.NotebookCellOutputItem.to),f=this.a.find(t=>t.id===S);if(f&&(o||(f.items.length=0),f.items.push(...p),f.items.length>1&&f.items.every(t=>R.$AI(t.mime)))){const t=new Map,i=[];f.items.forEach(n=>{let u;t.has(n.mime)?u=t.get(n.mime):(u=[],t.set(n.mime,u),i.push(n.mime)),u.push(n.data)}),f.items.length=0,i.forEach(n=>{const u=R.$BI(t.get(n));f.items.push({mime:n,data:u.data.buffer})})}}setMetadata(S){this.b=Object.freeze(S)}setInternalMetadata(S){this.e=S,this.d=Object.freeze(P.NotebookCellExecutionSummary.to(S))}setMime(S){}}e.$wec=D;class g{static{this.a=0}constructor(S,o,v,p,f){this.k=S,this.l=o,this.m=v,this.uri=p,this.handle=g.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=f.viewType,this.f=Object.freeze(f.metadata??Object.create(null)),this.r([[0,0,f.cells]],!0,void 0),this.g=f.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const S=this,o={get uri(){return S.uri},get version(){return S.g},get notebookType(){return S.d},get isDirty(){return S.h},get isUntitled(){return S.uri.scheme===E.Schemas.untitled},get isClosed(){return S.j},get metadata(){return S.f},get cellCount(){return S.b.length},cellAt(v){return v=S.n(v),S.b[v].apiCell},getCells(v){return(v?S.p(v):S.b).map(f=>f.apiCell)},save(){return S.q()}};this.e=Object.freeze(o)}return this.e}acceptDocumentPropertiesChanged(S){S.metadata&&(this.f=Object.freeze({...this.f,...S.metadata}))}acceptDirty(S){this.h=S}acceptModelChanged(S,o,v){this.g=S.versionId,this.h=o,this.acceptDocumentPropertiesChanged({metadata:v});const p={notebook:this.apiNotebook,metadata:v,cellChanges:[],contentChanges:[]},f=[];for(const i of S.rawEvents)i.kind===R.NotebookCellsChangeType.ModelChange?this.r(i.changes,!1,p.contentChanges):i.kind===R.NotebookCellsChangeType.Move?this.s(i.index,i.length,i.newIdx,p.contentChanges):i.kind===R.NotebookCellsChangeType.Output?(this.t(i.index,i.outputs),f.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===R.NotebookCellsChangeType.OutputItem?(this.u(i.index,i.outputId,i.append,i.outputItems),f.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(i.index,i.language),f.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document})):i.kind===R.NotebookCellsChangeType.ChangeCellContent?f.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document}):i.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(i.index,i.mime):i.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(i.index,i.metadata),f.push({cell:this.b[i.index].apiCell,metadata:this.b[i.index].apiCell.metadata})):i.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(i.index,i.internalMetadata),f.push({cell:this.b[i.index].apiCell,executionSummary:this.b[i.index].apiCell.executionSummary}));const t=new Map;for(let i=0;i<f.length;i++){const n=f[i],u=t.get(n.cell);if(u===void 0){const a=p.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});t.set(n.cell,a-1)}else p.cellChanges[u]={...p.cellChanges[u],...n}}return Object.freeze(p),Object.freeze(p.cellChanges),Object.freeze(p.contentChanges),p}n(S){return S=S|0,S<0?0:S>=this.b.length?this.b.length-1:S}o(S){let o=S.start|0,v=S.end|0;return o<0&&(o=0),v>this.b.length&&(v=this.b.length),S.with({start:o,end:v})}p(S){S=this.o(S);const o=[];for(let v=S.start;v<S.end;v++)o.push(this.b[v]);return o}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(S,o,v){if(this.j)return;const p=[],f=[],t=[];if(S.reverse().forEach(i=>{const u=i[2].map(r=>{const s=new D(this,this.l,r);return o||f.push(D.asModelAddData(this.apiNotebook,r)),s}),a=new $(i[0],i[1],[],u),l=this.b.splice(i[0],i[1],...u);for(const r of l)t.push(r.uri),a.deletedItems.push(r.apiCell);p.push(a)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:f,removedDocuments:t}),v)for(const i of p)v.push(i.asApiEvent())}s(S,o,v,p){const f=this.b.splice(S,o);this.b.splice(v,0,...f);const t=[new $(S,o,f.map(i=>i.apiCell),[]),new $(v,0,[],f)];for(const i of t)p.push(i.asApiEvent())}t(S,o){this.b[S].setOutputs(o)}u(S,o,v,p){this.b[S].setOutputItems(o,v,p)}v(S,o){const v=this.b[S];v.apiCell.document.languageId!==o&&this.m.$acceptModelLanguageChanged(v.uri,o)}w(S,o){const v=this.b[S];v.apiCell.mime=o}x(S,o){this.b[S].setMetadata(o)}y(S,o){this.b[S].setInternalMetadata(o)}getCellFromApiCell(S){return this.b.find(o=>o.apiCell===S)}getCellFromIndex(S){return this.b[S]}getCell(S){return this.b.find(o=>o.handle===S)}getCellIndex(S){return this.b.indexOf(S)}}e.$xec=g}),define(Ae[223],Re([1,0,5,2,8,7]),function(pe,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xec=void 0;class R{constructor(D,g,A,S={timeout:1500,errors:3}){this.b=D,this.c=g,this.d=A,this.f=S,this.a=new E.$Qd}dispose(){}getOnWillSaveNotebookDocumentEvent(D){return(g,A,S)=>{const o=function(p){g.call(A,p)};return o.extension=D,this.a.event(o,void 0,S)}}async $participateInSave(D,g,A){const S=L.URI.revive(D),o=this.c.getNotebookDocument(S);if(!o)throw new Error("Unable to resolve notebook document");const v=[];if(await this.a.fireAsync({notebook:o.apiNotebook,reason:P.TextDocumentSaveReason.to(g)},A,async(f,t)=>{const i=Date.now(),n=await await Promise.resolve(f);Date.now()-i>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier),!A.isCancellationRequested&&n&&(n instanceof M.$HK?v.push(n):this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier,"ignored due to invalid data"))}),A.isCancellationRequested)return!1;if(v.length===0)return!0;const p={edits:[]};for(const f of v){const{edits:t}=P.WorkspaceEdit.from(f);p.edits=p.edits.concat(t)}return this.d.$tryApplyWorkspaceEdit(p)}}e.$Xec=R}),define(Ae[107],Re([1,0,11,8,7]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yec=void 0;class M{static{this.apiEditorsToExtHost=new WeakMap}constructor($,D,g,A,S,o){this.id=$,this.f=D,this.notebookData=g,this.a=[],this.b=[],this.d=!1,this.a=S,this.b=A,this.c=o}get apiEditor(){if(!this.e){const $=this;this.e={get notebook(){return $.notebookData.apiNotebook},get selection(){return $.a[0]},set selection(D){this.selections=[D]},get selections(){return $.a},set selections(D){if(!Array.isArray(D)||!D.every(P.$UL.isNotebookRange))throw(0,E.$6)("selections");$.a=D,$.g(D)},get visibleRanges(){return $.b},revealRange(D,g){$.f.$tryRevealRange($.id,L.NotebookRange.from(D),g??P.NotebookEditorRevealType.Default)},get viewColumn(){return $.c}},M.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility($){this.d=$}_acceptVisibleRanges($){this.b=$}_acceptSelections($){this.a=$}g($){this.f.$trySetSelections(this.id,$.map(L.NotebookRange.from))}_acceptViewColumn($){this.c=$}}e.$yec=M}),define(Ae[224],Re([1,0,11,5,15,8]),function(pe,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qec=void 0;let R=class{constructor(D,g){this.c=D,this.d=g,this.a=new L.$Od({onListenerError:E.$1}),this.b=new L.$Od({onListenerError:E.$1}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(D,g){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",D,g);const A=this.d.getEditorById(D);g.visibleRanges&&A._acceptVisibleRanges(g.visibleRanges.ranges.map(M.NotebookRange.to)),g.selections&&A._acceptSelections(g.selections.selections.map(M.NotebookRange.to)),g.visibleRanges&&this.b.fire({notebookEditor:A.apiEditor,visibleRanges:A.apiEditor.visibleRanges}),g.selections&&this.a.fire(Object.freeze({notebookEditor:A.apiEditor,selections:A.apiEditor.selections}))}$acceptEditorViewColumns(D){for(const g in D)this.d.getEditorById(g)._acceptViewColumn(M.ViewColumn.to(D[g]))}};e.$Qec=R,e.$Qec=R=Ke([Ve(0,P.$bj)],R)}),define(Ae[225],Re([1,0,8,54,164,20,67,11]),function(pe,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Udc=void 0;class D{constructor(o){this.b=0,this.c=new Map,this.a=o}async withProgress(o,v,p){const f=this.b++,{title:t,location:i,cancellable:n}=v,u={label:(0,P.localize)(0,null,o.displayName||o.name),id:o.identifier.value};return this.a.$startProgress(f,{location:E.ProgressLocation.from(i),title:t,source:u,cancellable:n},o.isUnderDevelopment?void 0:o.identifier.value).catch($.$1),this.d(f,p,!!n)}d(o,v,p){let f;p&&(f=new M.$Yd,this.c.set(o,f));const t=n=>{this.a.$progressEnd(n),this.c.delete(n),f?.dispose()};let i;try{i=v(new A(this.a,o),p&&f?f.token:M.CancellationToken.None)}catch(n){throw t(o),n}return i.then(n=>t(o),n=>t(o)),i}$acceptProgressCanceled(o){const v=this.c.get(o);v&&(v.cancel(),this.c.delete(o))}}e.$Udc=D;function g(S,o){return S.message=o.message,typeof o.increment=="number"&&(typeof S.increment=="number"?S.increment+=o.increment:S.increment=o.increment),S}class A extends L.$9u{constructor(o,v){super(p=>this.throttledReport(p)),this.c=o,this.d=v}throttledReport(o){this.c.$progressReport(this.d,o)}}Ke([(0,R.$nh)(100,(S,o)=>g(S,o),()=>Object.create(null))],A.prototype,"throttledReport",null)}),define(Ae[108],Re([1,0,29,104,48,77,60,8,2]),function(pe,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MM=e.$LM=e.$KM=e.$JM=void 0;const g=(u,a,l,r)=>{let s=a;return{enumerable:!0,configurable:!1,get(){return s},set(c){if(!l(s,c)){const h=s;s=c,u.listener?.(r(c,h))}}}},A=(u,a)=>u===a,S={range:(u,a)=>u===a?!0:!u||!a?!1:u.isEqual(a),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(u,a)=>!(u.length!==a.length||u.some(l=>!a.find(r=>l.id===r.id)))},o=u=>a=>({op:4,update:u(a)}),v=(u,a)=>({range:(()=>{let l;const r=o(s=>({range:E.$xs.lift($.Range.from(s))}));return{enumerable:!0,configurable:!1,get(){return l},set(s){u.listener?.({op:6}),S.range(l,s)||(l=s,u.listener?.(r(s)))}}})(),label:g(u,a,S.label,o(l=>({label:l}))),description:g(u,void 0,S.description,o(l=>({description:l}))),sortText:g(u,void 0,S.sortText,o(l=>({sortText:l}))),canResolveChildren:g(u,!1,S.canResolveChildren,l=>({op:2,state:l})),busy:g(u,!1,S.busy,o(l=>({busy:l}))),error:g(u,void 0,S.error,o(l=>({error:$.MarkdownString.fromStrict(l)||null}))),tags:g(u,[],S.tags,(l,r)=>({op:1,new:l.map($.TestTag.from),old:r.map($.TestTag.from)}))}),p=u=>{const a=P.$lJ.fromString(u.extId),l=new t(a.controllerId,a.localId,u.label,D.URI.revive(u.uri)||void 0);return l.range=$.Range.to(u.range||void 0),l.description=u.description||void 0,l.sortText=u.sortText||void 0,l.tags=u.tags.map(r=>$.TestTag.to({id:(0,R.$qJ)(r).tagId})),l},f=u=>{let a;for(const l of u.tests){const r=p(l.item);(0,L.$tM)(r).parent=a,a=r}return a};e.$JM=f;class t{constructor(a,l,r,s){if(l.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(l)} symbol`);const c=(0,L.$sM)(this,a);Object.defineProperties(this,{id:{value:l,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return c.parent instanceof i?void 0:c.parent}},children:{value:(0,M.$rM)(c,L.$tM,t),enumerable:!0,writable:!1},...v(c,r)})}}e.$KM=t;class i extends t{constructor(a,l){super(a,a,l,void 0),this._isRoot=!0}}e.$LM=i;class n extends M.$nM{constructor(a,l,r){super({controllerId:a,getDocumentVersion:s=>s&&r.getDocument(s)?.version,getApiFor:L.$tM,getChildren:s=>s.children,root:new i(a,l),toITestItem:$.TestItem.from})}}e.$MM=n}),define(Ae[109],Re([1,0,55,11,89,8,7]),function(pe,e,E,L,P,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GM=e.$FM=e.$EM=void 0;class ${static{this.c=new P.$CM("TextEditorDecorationType")}constructor(o,v,p){const f=$.c.nextId();o.$registerTextEditorDecorationType(v.identifier,f,M.DecorationRenderOptions.from(p)),this.value=Object.freeze({key:f,dispose(){o.$removeTextEditorDecorationType(f)}})}}e.$EM=$;class D{constructor(o,v){this.g=[],this.h=void 0,this.j=!1,this.c=o,this.d=o.version,this.e=v.undoStopBefore,this.f=v.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(o,v){this.k();let p=null;if(o instanceof R.$yK)p=new R.$zK(o,o);else if(o instanceof R.$zK)p=o;else throw new Error("Unrecognized location");this.l(p,v,!1)}insert(o,v){this.k(),this.l(new R.$zK(o,o),v,!0)}delete(o){this.k();let v=null;if(o instanceof R.$zK)v=o;else throw new Error("Unrecognized location");this.l(v,null,!0)}l(o,v,p){const f=this.c.validateRange(o);this.g.push({range:f,text:v,forceMoveMarkers:p})}setEndOfLine(o){if(this.k(),o!==R.EndOfLine.LF&&o!==R.EndOfLine.CRLF)throw(0,L.$6)("endOfLine");this.h=o}}class g{constructor(o,v,p,f){this.c=o,this.d=v,this._accept(p),this.e=f;const t=this;this.value={get tabSize(){return t.f},set tabSize(i){t.m(i)},get indentSize(){return t.g},set indentSize(i){t.o(i)},get insertSpaces(){return t.h},set insertSpaces(i){t.q(i)},get cursorStyle(){return t.j},set cursorStyle(i){t.s(i)},get lineNumbers(){return t.k},set lineNumbers(i){t.t(i)}}}_accept(o){this.f=o.tabSize,this.g=o.indentSize,this.h=o.insertSpaces,this.j=o.cursorStyle,this.k=M.TextEditorLineNumbersStyle.to(o.lineNumbers)}l(o){if(o==="auto")return"auto";if(typeof o=="number"){const v=Math.floor(o);return v>0?v:null}if(typeof o=="string"){const v=parseInt(o,10);return isNaN(v)?null:v>0?v:null}return null}m(o){const v=this.l(o);if(v!==null){if(typeof v=="number"){if(this.f===v)return;this.f=v}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:v}))}}n(o){if(o==="tabSize")return"tabSize";if(typeof o=="number"){const v=Math.floor(o);return v>0?v:null}if(typeof o=="string"){const v=parseInt(o,10);return isNaN(v)?null:v>0?v:null}return null}o(o){const v=this.n(o);if(v!==null){if(typeof v=="number"){if(this.g===v)return;this.g=v}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:v}))}}p(o){return o==="auto"?"auto":o==="false"?!1:!!o}q(o){const v=this.p(o);if(typeof v=="boolean"){if(this.h===v)return;this.h=v}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:v}))}s(o){this.j!==o&&(this.j=o,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:o})))}t(o){this.k!==o&&(this.k=o,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:M.TextEditorLineNumbersStyle.from(o)})))}assign(o){const v={};let p=!1;if(typeof o.tabSize<"u"){const f=this.l(o.tabSize);f==="auto"?(p=!0,v.tabSize=f):typeof f=="number"&&this.f!==f&&(this.f=f,p=!0,v.tabSize=f)}if(typeof o.indentSize<"u"){const f=this.n(o.indentSize);f==="tabSize"?(p=!0,v.indentSize=f):typeof f=="number"&&this.g!==f&&(this.g=f,p=!0,v.indentSize=f)}if(typeof o.insertSpaces<"u"){const f=this.p(o.insertSpaces);f==="auto"?(p=!0,v.insertSpaces=f):this.h!==f&&(this.h=f,p=!0,v.insertSpaces=f)}typeof o.cursorStyle<"u"&&this.j!==o.cursorStyle&&(this.j=o.cursorStyle,p=!0,v.cursorStyle=o.cursorStyle),typeof o.lineNumbers<"u"&&this.k!==o.lineNumbers&&(this.k=o.lineNumbers,p=!0,v.lineNumbers=M.TextEditorLineNumbersStyle.from(o.lineNumbers)),p&&this.u("setOptions",this.c.$trySetOptions(this.d,v))}u(o,v){v.catch(p=>{this.e.warn(`ExtHostTextEditorOptions '${o}' failed:'`),this.e.warn(p)})}}e.$FM=g;class A{constructor(o,v,p,f,t,i,n,u){this.id=o,this.j=v,this.k=p,this.g=!1,this.h=new Set,this.c=t,this.d=new g(this.j,this.id,i,p),this.e=n,this.f=u;const a=this;this.value=Object.freeze({get document(){return f.value},set document(l){throw new L.$8("document")},get selection(){return a.c&&a.c[0]},set selection(l){if(!(l instanceof R.$AK))throw(0,L.$6)("selection");a.c=[l],a.l()},get selections(){return a.c},set selections(l){if(!Array.isArray(l)||l.some(r=>!(r instanceof R.$AK)))throw(0,L.$6)("selections");a.c=l,a.l()},get visibleRanges(){return a.e},set visibleRanges(l){throw new L.$8("visibleRanges")},get options(){return a.d.value},set options(l){a.g||a.d.assign(l)},get viewColumn(){return a.f},set viewColumn(l){throw new L.$8("viewColumn")},edit(l,r={undoStopBefore:!0,undoStopAfter:!0}){if(a.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new D(f.value,r);return l(s),a.m(s)},insertSnippet(l,r,s={undoStopBefore:!0,undoStopAfter:!0}){if(a.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let c;if(!r||Array.isArray(r)&&r.length===0)c=a.c.map(h=>M.Range.from(h));else if(r instanceof R.$yK){const{lineNumber:h,column:w}=M.Position.from(r);c=[{startLineNumber:h,startColumn:w,endLineNumber:h,endColumn:w}]}else if(r instanceof R.$zK)c=[M.Range.from(r)];else{c=[];for(const h of r)if(h instanceof R.$zK)c.push(M.Range.from(h));else{const{lineNumber:w,column:m}=M.Position.from(h);c.push({startLineNumber:w,startColumn:m,endLineNumber:w,endColumn:m})}}return v.$tryInsertSnippet(o,f.value.version,l.value,c,s)},setDecorations(l,r){const s=r.length===0;s&&!a.h.has(l.key)||(s?a.h.delete(l.key):a.h.add(l.key),a.n(()=>{if(M.$uM(r))return v.$trySetDecorations(o,l.key,M.$vM(r));{const c=new Array(4*r.length);for(let h=0,w=r.length;h<w;h++){const m=r[h];c[4*h]=m.start.line+1,c[4*h+1]=m.start.character+1,c[4*h+2]=m.end.line+1,c[4*h+3]=m.end.character+1}return v.$trySetDecorationsFast(o,l.key,c)}}))},revealRange(l,r){a.n(()=>v.$tryRevealRange(o,M.Range.from(l),r||R.TextEditorRevealType.Default))},show(l){v.$tryShowEditor(o,M.ViewColumn.from(l))},hide(){v.$tryHideEditor(o)}})}dispose(){(0,E.ok)(!this.g),this.g=!0}_acceptOptions(o){(0,E.ok)(!this.g),this.d._accept(o)}_acceptVisibleRanges(o){(0,E.ok)(!this.g),this.e=o}_acceptViewColumn(o){(0,E.ok)(!this.g),this.f=o}_acceptSelections(o){(0,E.ok)(!this.g),this.c=o}async l(){const o=this.c.map(M.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,o)),this.value}m(o){const v=o.finalize();if(v.edits.length===0&&!v.setEndOfLine)return Promise.resolve(!0);const p=v.edits.map(t=>t.range);p.sort((t,i)=>t.end.line===i.end.line?t.end.character===i.end.character?t.start.line===i.start.line?t.start.character-i.start.character:t.start.line-i.start.line:t.end.character-i.end.character:t.end.line-i.end.line);for(let t=0,i=p.length-1;t<i;t++){const n=p[t].end;if(p[t+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const f=v.edits.map(t=>({range:M.Range.from(t.range),text:t.text,forceMoveMarkers:t.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,v.documentVersionId,f,{setEndOfLine:typeof v.setEndOfLine=="number"?M.EndOfLine.from(v.setEndOfLine):void 0,undoStopBefore:v.undoStopBefore,undoStopAfter:v.undoStopAfter})}n(o){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):o().then(()=>this,v=>(v instanceof Error&&v.name==="DISPOSED"||this.k.warn(v),null))}}e.$GM=A}),define(Ae[226],Re([1,0,168,25,2,5,6,206,12,7,16,18,8,53,20,132,23]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2dc=void 0;function i(a,l){if((0,A.$zf)(a))return{label:a};if(a&&typeof a=="object"&&typeof a.label=="string"){let r;return Array.isArray(a.highlights)&&(r=a.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),r=r.length?r:void 0),{label:a.label,highlights:r}}}class n extends R.$Rc{constructor(l,r,s){super(),this.f=l,this.g=r,this.h=s,this.a=new Map,this.b=new f.$k8;function c(h){return h&&h.$treeViewId&&(h.$treeItemHandle||h.$selectedTreeItems||h.$focusedTreeItem)}r.registerArgumentProcessor({processArgument:h=>c(h)?this.r(h):Array.isArray(h)&&h.length>0?h.map(w=>c(w)?this.r(w):w):h})}registerTreeDataProvider(l,r,s){const c=this.createTreeView(l,{treeDataProvider:r},s);return{dispose:()=>c.dispose()}}createTreeView(l,r,s){if(!r||!r.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const c=r.dragAndDropController?.dropMimeTypes??[],h=r.dragAndDropController?.dragMimeTypes??[],w=!!r.dragAndDropController?.handleDrag,m=!!r.dragAndDropController?.handleDrop,I=this.m(l,r,s),k={showCollapseAll:!!r.showCollapseAll,canSelectMany:!!r.canSelectMany,dropMimeTypes:c,dragMimeTypes:h,hasHandleDrag:w,hasHandleDrop:m,manuallyManageCheckboxes:!!r.manageCheckboxStateManually},d=this.f.$registerTreeViewDataProvider(l,k),b={get onDidCollapseElement(){return I.onDidCollapseElement},get onDidExpandElement(){return I.onDidExpandElement},get selection(){return I.selectedElements},get onDidChangeSelection(){return I.onDidChangeSelection},get activeItem(){return(0,t.$vF)(s,"treeViewActiveItem"),I.focusedElement},get onDidChangeActiveItem(){return(0,t.$vF)(s,"treeViewActiveItem"),I.onDidChangeActiveItem},get visible(){return I.visible},get onDidChangeVisibility(){return I.onDidChangeVisibility},get onDidChangeCheckboxState(){return I.onDidChangeCheckboxState},get message(){return I.message},set message(y){(0,v.$9j)(y)&&(0,t.$vF)(s,"treeViewMarkdownMessage"),I.message=y},get title(){return I.title},set title(y){I.title=y},get description(){return I.description},set description(y){I.description=y},get badge(){return I.badge},set badge(y){y!==void 0&&g.ViewBadge.isViewBadge(y)?I.badge={value:Math.floor(Math.abs(y.value)),tooltip:y.tooltip}:y===void 0&&(I.badge=void 0)},reveal:(y,C)=>I.reveal(y,C),dispose:async()=>{await d,this.a.delete(l),I.dispose()}};return this.B(b),b}$getChildren(l,r){const s=this.a.get(l);return s?s.getChildren(r):Promise.reject(new $.$GE(l))}async $handleDrop(l,r,s,c,h,w,m,I){const k=this.a.get(l);if(!k)return Promise.reject(new $.$GE(l));const d=o.DataTransfer.toDataTransfer(s,async b=>(await this.f.$resolveDropFileData(l,r,b)).buffer);return m===l&&I&&await this.j(d,k,I,h,w),k.onDrop(d,c,h)}async j(l,r,s,c,h){const w=this.b.removeDragOperationTransfer(h);if(w)(await w)?.forEach((m,I)=>{m&&l.set(I,m)});else if(h&&r.handleDrag){const m=r.handleDrag(s,l,c);this.b.addDragOperationTransfer(h,m),await m}return l}async $handleDrag(l,r,s,c){const h=this.a.get(l);if(!h)return Promise.reject(new $.$GE(l));const w=await this.j(new g.$oL,h,r,c,s);if(!(!w||c.isCancellationRequested))return o.DataTransfer.from(w)}async $hasResolve(l){const r=this.a.get(l);if(!r)throw new $.$GE(l);return r.hasResolve}$resolve(l,r,s){const c=this.a.get(l);if(!c)throw new $.$GE(l);return c.resolveTreeItem(r,s)}$setExpanded(l,r,s){const c=this.a.get(l);if(!c)throw new $.$GE(l);c.setExpanded(r,s)}$setSelectionAndFocus(l,r,s){const c=this.a.get(l);if(!c)throw new $.$GE(l);c.setSelectionAndFocus(r,s)}$setVisible(l,r){const s=this.a.get(l);if(!s){if(!r)return;throw new $.$GE(l)}s.setVisible(r)}$changeCheckboxState(l,r){const s=this.a.get(l);if(!s)throw new $.$GE(l);s.setCheckboxState(r)}m(l,r,s){const c=this.B(new u(l,r,this.f,this.g.converter,this.h,s));return this.a.set(l,c),c}r(l){const r=this.a.get(l.$treeViewId);return r&&"$treeItemHandle"in l?r.getExtensionElement(l.$treeItemHandle):r&&"$focusedTreeItem"in l&&l.$focusedTreeItem?r.focusedElement:null}}e.$2dc=n;class u extends R.$Rc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(l=>this.getExtensionElement(l)).filter(l=>!(0,A.$If)(l))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(l,r,s,c,h,w){if(super(),this.I=l,this.J=s,this.L=c,this.M=h,this.N=w,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new M.$Od),this.onDidExpandElement=this.u.event,this.w=this.B(new M.$Od),this.onDidCollapseElement=this.w.event,this.y=this.B(new M.$Od),this.onDidChangeSelection=this.y.event,this.z=this.B(new M.$Od),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new M.$Od),this.onDidChangeVisibility=this.C.event,this.D=this.B(new M.$Od),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new M.$Od),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new p.$Yd,w.contributes&&w.contributes.views)for(const d in w.contributes.views)for(const b of w.contributes.views[d])b.id===l&&(this.P=b.name);this.f=r.treeDataProvider,this.g=r.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(d=>this.F.fire({message:!1,element:d})));let m,I;const k=M.Event.debounce(this.F.event,(d,b)=>(d||(d={message:!1,elements:[]}),b.element!==!1&&(m||(m=new Promise(y=>I=y),this.G=this.G.then(()=>m)),Array.isArray(b.element)?d.elements.push(...b.element):d.elements.push(b.element)),b.message&&(d.message=!0),d),200,!0);this.B(k(({message:d,elements:b})=>{b.length&&(this.H=this.H.then(()=>{const y=I;return m=null,this.$(b).then(()=>y())})),d&&this.J.$setMessage(this.I,o.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(l){const r=l?this.getExtensionElement(l):void 0;if(l&&!r)return this.M.error(`No tree item with id '${l}' found.`),Promise.resolve([]);let s=this.X(l);return s||(s=await this.Y(r)),s?s.map(c=>c.item):void 0}getExtensionElement(l){return this.j.get(l)}reveal(l,r){r=r||{select:!0,focus:!1};const s=(0,A.$If)(r.select)?!0:r.select,c=(0,A.$If)(r.focus)?!1:r.focus,h=(0,A.$If)(r.expand)?!1:r.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):l?this.G.then(()=>this.S(l)).then(w=>this.W(l,w[w.length-1]).then(m=>this.J.$reveal(this.I,{item:m.item,parentChain:w.map(I=>I.item)},{select:s,focus:c,expand:h})),w=>this.M.error(w)):this.J.$reveal(this.I,void 0,{select:s,focus:c,expand:h})}get message(){return this.O}set message(l){this.O=l,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(l){this.P=l,this.J.$setTitle(this.I,l,this.Q)}get description(){return this.Q}set description(l){this.Q=l,this.J.$setTitle(this.I,this.P,l)}get badge(){return this.R}set badge(l){this.R?.value===l?.value&&this.R?.tooltip===l?.tooltip||(this.R=o.ViewBadge.from(l),this.J.$setBadge(this.I,l))}setExpanded(l,r){const s=this.getExtensionElement(l);s&&(r?this.u.fire(Object.freeze({element:s})):this.w.fire(Object.freeze({element:s})))}setSelectionAndFocus(l,r){const s=!(0,S.$tb)(this.s,l);this.s=l;const c=this.t!==r;this.t=r,s&&this.y.fire(Object.freeze({selection:this.selectedElements})),c&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(l){l!==this.r&&(this.r=l,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(l){const r=(await Promise.all(l.map(async s=>{const c=this.getExtensionElement(s.treeItemHandle);return c?{extensionItem:c,treeItem:await this.f.getTreeItem(c),newState:s.newState?g.TreeItemCheckboxState.Checked:g.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);r.forEach(s=>{s.treeItem.checkboxState=s.newState?g.TreeItemCheckboxState.Checked:g.TreeItemCheckboxState.Unchecked}),this.D.fire({items:r.map(s=>[s.extensionItem,s.newState])})}async handleDrag(l,r,s){const c=[];for(const h of l){const w=this.getExtensionElement(h);w&&c.push(w)}if(!(!this.g?.handleDrag||c.length===0))return await this.g.handleDrag(c,r,s),r}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(l,r,s){const c=r?this.getExtensionElement(r):void 0;if(!(!c&&r||!this.g?.handleDrop))return(0,D.$Ng)(()=>this.g?.handleDrop?this.g.handleDrop(c,l,s):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(l,r){if(!this.f.resolveTreeItem)return;const s=this.j.get(l);if(s){const c=this.m.get(s);if(c){const h=await this.f.resolveTreeItem(c.extensionItem,s,r)??c.extensionItem;return this.hb(h),c.item.tooltip=this.eb(h.tooltip),c.item.command=this.fb(c.disposableStore,h.command),c.item}}}S(l){return this.U(l).then(r=>r?this.S(r).then(s=>this.W(r,s[s.length-1]).then(c=>(s.push(c),s))):Promise.resolve([]))}U(l){const r=this.m.get(l);return r?Promise.resolve(r.parent?this.j.get(r.parent.item.handle):void 0):(0,D.$Ng)(()=>this.f.getParent(l))}W(l,r){const s=this.m.get(l);return s?Promise.resolve(s):(0,D.$Ng)(()=>this.f.getTreeItem(l)).then(c=>this.kb(l,c,r,!0)).then(c=>this.getChildren(r?r.item.handle:void 0).then(()=>{const h=this.getExtensionElement(c);if(h){const w=this.m.get(h);if(w)return Promise.resolve(w)}throw new Error(`Cannot resolve tree item for element ${c} from extension ${this.N.identifier.value}`)}))}X(l){if(l){let r;if(typeof l=="string"){const s=this.getExtensionElement(l);r=s?this.m.get(s):void 0}else r=l;return r&&r.children||void 0}return this.h}async Y(l){this.rb(l);const r=new p.$Yd(this.Z.token);try{const s=l?this.m.get(l):void 0,c=await this.f.getChildren(l);if(r.token.isCancellationRequested)return;const h=await Promise.all((0,S.$Gb)(c||[]).map(async w=>{const m=await this.f.getTreeItem(w);return m&&!r.token.isCancellationRequested?this.db(w,m,s):null}));return r.token.isCancellationRequested?void 0:(0,S.$Gb)(h)}finally{r.dispose()}}$(l){if(l.some(s=>!s))return this.Z.dispose(!0),this.Z=new p.$Yd,this.tb(),this.J.$refresh(this.I);{const s=this.ab(l);if(s.length)return this.bb(s)}return Promise.resolve(void 0)}ab(l){const r=new Set,s=l.map(h=>this.m.get(h));for(const h of s)if(h&&!r.has(h.item.handle)){let w=h;for(;w&&w.parent&&s.findIndex(m=>w&&w.parent&&m&&m.item.handle===w.parent.item.handle)===-1;){const m=this.j.get(w.parent.item.handle);w=m?this.m.get(m):void 0}w&&!w.parent&&r.add(h.item.handle)}const c=[];return r.forEach(h=>{const w=this.j.get(h);if(w){const m=this.m.get(w);m&&(!m.parent||!r.has(m.parent.item.handle))&&c.push(h)}}),c}bb(l){const r={};return Promise.all(l.map(s=>this.cb(s).then(c=>{c&&(r[s]=c.item)}))).then(()=>Object.keys(r).length?this.J.$refresh(this.I,r):void 0)}cb(l){const r=this.getExtensionElement(l);if(r){const s=this.m.get(r);if(s)return this.rb(r),(0,D.$Ng)(()=>this.f.getTreeItem(r)).then(c=>{if(c){const h=this.ib(r,c,s.parent);return this.pb(r,h,s,s.parent),s.dispose(),h}return null})}return Promise.resolve(null)}db(l,r,s){const c=this.ib(l,r,s);if(r.id&&this.j.has(c.item.handle))throw new Error((0,E.localize)(0,null,r.id));return this.ob(l,c),this.qb(c,s),c}eb(l){return g.$XK.isMarkdownString(l)?o.MarkdownString.from(l):l}fb(l,r){return r?{...this.L.toInternal(r,l),originalId:r.command}:void 0}gb(l){if(l.checkboxState===void 0)return;let r,s,c;return typeof l.checkboxState=="number"?r=l.checkboxState:(r=l.checkboxState.state,s=l.checkboxState.tooltip,c=l.checkboxState.accessibilityInformation),{isChecked:r===g.TreeItemCheckboxState.Checked,tooltip:s,accessibilityInformation:c}}hb(l){if(!g.$jL.isTreeItem(l,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(l,r,s){this.hb(r);const c=this.B(new R.$Qc),h=this.kb(l,r,s),w=this.lb(r);return{item:{handle:h,parentHandle:s?s.item.handle:void 0,label:i(r.label,this.N),description:r.description,resourceUri:r.resourceUri,tooltip:this.eb(r.tooltip),command:this.fb(c,r.command),contextValue:r.contextValue,icon:w,iconDark:this.mb(r)||w,themeIcon:this.jb(r),collapsibleState:(0,A.$If)(r.collapsibleState)?g.TreeItemCollapsibleState.None:r.collapsibleState,accessibilityInformation:r.accessibilityInformation,checkbox:this.gb(r)},extensionItem:r,parent:s,children:void 0,disposableStore:c,dispose(){c.dispose()}}}jb(l){return l.iconPath instanceof g.$rL?l.iconPath:void 0}kb(l,{id:r,label:s,resourceUri:c},h,w){if(r)return`${u.b}/${r}`;const m=i(s,this.N),I=h?h.item.handle:u.a;let k=m?m.label:c?(0,L.$tg)(c):"";k=k.indexOf("/")!==-1?k.replace("/","//"):k;const d=this.m.has(l)?this.m.get(l).item.handle:void 0,b=this.X(h)||[];let y,C=0;do{if(y=`${I}/${C}:${k}`,w||!this.j.has(y)||d===y)break;C++}while(C<=b.length);return y}lb(l){if(l.iconPath&&!(l.iconPath instanceof g.$rL))return typeof l.iconPath=="string"||P.URI.isUri(l.iconPath)?this.nb(l.iconPath):this.nb(l.iconPath.light)}mb(l){if(l.iconPath&&!(l.iconPath instanceof g.$rL)&&l.iconPath.dark)return this.nb(l.iconPath.dark)}nb(l){return P.URI.isUri(l)?l:P.URI.file(l)}ob(l,r){this.j.set(r.item.handle,l),this.m.set(l,r)}pb(l,r,s,c){this.j.delete(r.item.handle),this.m.delete(l),r.item.handle!==s.item.handle&&this.j.delete(s.item.handle),this.ob(l,r);const h=this.X(c)||[],w=h.filter(m=>m.item.handle===s.item.handle)[0];w&&h.splice(h.indexOf(w),1,r)}qb(l,r){r?(r.children||(r.children=[]),r.children.push(l)):(this.h||(this.h=[]),this.h.push(l))}rb(l){if(l){const r=this.m.get(l);if(r){if(r.children)for(const s of r.children){const c=this.j.get(s.item.handle);c&&this.sb(c)}r.children=void 0}}else this.tb()}sb(l){const r=this.m.get(l);if(r){if(r.children)for(const s of r.children){const c=this.j.get(s.item.handle);c&&this.sb(c)}this.m.delete(l),this.j.delete(r.item.handle),r.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(l=>l.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Ae[227],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmInputBoxActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testingActiveProfile:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testingActiveProfile.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ae[228],Re([1,0,180,11,31,96,73,30,22,227,190,101]),function(pe,e,E,L,P,M,R,$,D,g,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oF=e.$nF=e.$mF=e.$lF=e.$kF=e.$jF=void 0;const o=$.$kn.as(R.$ln.JSONContribution);class v{constructor(l,r,s){this.a=l,this.b=r,this.c=s}d(l,r){this.a({type:l,message:r,extensionId:this.b.identifier,extensionPointId:this.c})}error(l){this.d(P.default.Error,l)}warn(l){this.d(P.default.Warning,l)}info(l){this.d(P.default.Info,l)}}e.$jF=v;class p{static a(l){const r=new D.$$l;for(let s=0,c=l.length;s<c;s++)r.add(l[s].description.identifier);return r}static compute(l,r){if(!l||!l.length)return new p(r,[]);if(!r||!r.length)return new p([],l);const s=this.a(l),c=this.a(r),h=r.filter(m=>!s.has(m.description.identifier)),w=l.filter(m=>!c.has(m.description.identifier));return new p(h,w)}constructor(l,r){this.added=l,this.removed=r}}e.$kF=p;class f{constructor(l,r){this.name=l,this.defaultExtensionKind=r,this.a=null,this.b=null,this.c=null}setHandler(l){if(this.a!==null)throw new Error("Handler already set!");this.a=l,this.d()}acceptUsers(l){this.c=p.compute(this.b,l),this.b=l,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(l){(0,L.$Z)(l)}}}e.$lF=f;const t={type:"string",enum:["ui","workspace"],enumDescriptions:[E.localize(0,null),E.localize(1,null)]},i="vscode://schemas/vscode-extensions";e.$mF={properties:{engines:{type:"object",description:E.localize(2,null),properties:{vscode:{type:"string",description:E.localize(3,null),default:"^1.22.0"}}},publisher:{description:E.localize(4,null),type:"string"},displayName:{description:E.localize(5,null),type:"string"},categories:{description:E.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:D.$9l},{type:"string",const:"Languages",deprecationMessage:E.localize(7,null)}]}},galleryBanner:{type:"object",description:E.localize(8,null),properties:{color:{description:E.localize(9,null),type:"string"},theme:{description:E.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:E.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:E.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:E.localize(13,null)},enabledApiProposals:{markdownDescription:E.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(g.allApiProposals),markdownEnumDescriptions:Object.values(g.allApiProposals)}},api:{markdownDescription:E.localize(15,null),type:"string",enum:["none"],enumDescriptions:[E.localize(16,null)]},activationEvents:{description:E.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:E.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:E.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:E.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:E.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:E.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:E.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:E.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:E.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:E.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:E.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:E.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:E.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:E.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:E.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:E.localize(32,null)},{label:"onUri",body:"onUri",description:E.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:E.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:E.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:E.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:E.localize(37,null)},{label:"onRenderer",description:E.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:E.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:E.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:E.localize(41,null)},{label:"*",description:E.localize(42,null),body:"*"}]}},badges:{type:"array",description:E.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:E.localize(44,null)},href:{type:"string",description:E.localize(45,null)},description:{type:"string",description:E.localize(46,null)}}}},markdown:{type:"string",description:E.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:E.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:E.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.$2n}},extensionPack:{description:E.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.$2n}},extensionKind:{description:E.localize(51,null),type:"array",items:t,default:["workspace"],defaultSnippets:[{body:["ui"],description:E.localize(52,null)},{body:["workspace"],description:E.localize(53,null)},{body:["ui","workspace"],description:E.localize(54,null)},{body:["workspace","ui"],description:E.localize(55,null)},{body:[],description:E.localize(56,null)}]},capabilities:{description:E.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:E.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:E.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[E.localize(60,null),E.localize(61,null),E.localize(62,null)]},description:{type:"string",markdownDescription:E.localize(63,null)}}},untrustedWorkspaces:{description:E.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:E.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[E.localize(66,null),E.localize(67,null),E.localize(68,null)]},restrictedConfigurations:{description:E.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:E.localize(70,null)}}}}},sponsor:{description:E.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:E.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:E.localize(73,null),type:"string"},"vscode:uninstall":{description:E.localize(74,null),type:"string"}}},icon:{type:"string",description:E.localize(75,null)},l10n:{type:"string",description:E.localize(76,null)},pricing:{type:"string",markdownDescription:E.localize(77,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this.a=new Map}registerExtensionPoint(l){if(this.a.has(l.extensionPoint))throw new Error("Duplicate extension point: "+l.extensionPoint);const r=new f(l.extensionPoint,l.defaultExtensionKind);return this.a.set(l.extensionPoint,r),l.activationEventsGenerator&&S.$aF.register(l.extensionPoint,l.activationEventsGenerator),e.$mF.properties.contributes.properties[l.extensionPoint]=l.jsonSchema,o.registerSchema(i,e.$mF),r}getExtensionPoints(){return Array.from(this.a.values())}}e.$nF=n;const u={ExtensionsRegistry:"ExtensionsRegistry"};$.$kn.add(u.ExtensionsRegistry,new n),e.$oF=$.$kn.as(u.ExtensionsRegistry),o.registerSchema(i,e.$mF),o.registerSchema(A.$uj,{properties:{extensionEnabledApiProposals:{description:E.localize(78,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(g.allApiProposals),markdownEnumDescriptions:Object.values(g.allApiProposals)}}]}}}})}),define(Ae[229],Re([1,0,176,16,26,228,34,5]),function(pe,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6F=void 0;const D={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:E.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:E.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:E.localize(2,null),default:""}}};var g;(function(o){function v(p,f,t){if(!p)return;const i=L.$zf(p.type)?p.type:void 0;if(!i||i.length===0){t.error(E.localize(3,null));return}const n=[];if(Array.isArray(p.required))for(const u of p.required)L.$zf(u)&&n.push(u);return{extensionId:f.value,taskType:i,required:n,properties:p.properties?P.$$m(p.properties):{},when:p.when?R.$Ri.deserialize(p.when):void 0}}o.from=v})(g||(g={}));const A=M.$oF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(o,v)=>{for(const p of o)p.type&&v.push(`onTaskType:${p.type}`)},jsonSchema:{description:E.localize(4,null),type:"array",items:D}});class S{constructor(){this.d=new $.$Od,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((v,p)=>{A.setHandler((f,t)=>{this.c=void 0;try{for(const i of t.removed){const n=i.value;for(const u of n)this.a&&u.type&&this.a[u.type]&&delete this.a[u.type]}for(const i of t.added){const n=i.value;for(const u of n){const a=g.from(u,i.description.identifier,i.collector);a&&(this.a[a.taskType]=a)}}(t.removed.length>0||t.added.length>0)&&this.d.fire()}catch{}v(void 0)})})}onReady(){return this.b}get(v){return this.a[v]}all(){return Object.keys(this.a).map(v=>this.a[v])}getJsonSchema(){if(this.c===void 0){const v=[];for(const p of this.all()){const f={type:"object",additionalProperties:!1};p.required.length>0&&(f.required=p.required.slice(0)),p.properties!==void 0?f.properties=P.$$m(p.properties):f.properties=Object.create(null),f.properties.type={type:"string",enum:[p.taskType]},v.push(f)}this.c={oneOf:v}}return this.c}}e.$6F=new S}),define(Ae[230],Re([1,0,177,16,25,26,34,229]),function(pe,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$dG=e.JsonSchemaVersion=e.ExecutionEngine=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$0F=e.ShellQuoting=e.$9F=e.$8F=e.$7F=void 0,e.$7F="settings",e.$8F=new R.$$i("taskRunning",!1,E.localize(0,null)),e.$9F={value:E.localize(1,null),original:"Tasks"};var D;(function(F){F[F.Escape=1]="Escape",F[F.Strong=2]="Strong",F[F.Weak=3]="Weak"})(D||(e.ShellQuoting=D={})),e.$0F="$customized",function(F){function N(x){if(!x)return F.Strong;switch(x.toLowerCase()){case"escape":return F.Escape;case"strong":return F.Strong;case"weak":return F.Weak;default:return F.Strong}}F.from=N}(D||(e.ShellQuoting=D={}));var g;(function(F){F.defaults={cwd:"${workspaceFolder}"}})(g||(e.CommandOptions=g={}));var A;(function(F){F[F.Always=1]="Always",F[F.Silent=2]="Silent",F[F.Never=3]="Never"})(A||(e.RevealKind=A={})),function(F){function N(x){switch(x.toLowerCase()){case"always":return F.Always;case"silent":return F.Silent;case"never":return F.Never;default:return F.Always}}F.fromString=N}(A||(e.RevealKind=A={}));var S;(function(F){F[F.Never=1]="Never",F[F.OnProblem=2]="OnProblem",F[F.Always=3]="Always"})(S||(e.RevealProblemKind=S={})),function(F){function N(x){switch(x.toLowerCase()){case"always":return F.Always;case"never":return F.Never;case"onproblem":return F.OnProblem;default:return F.OnProblem}}F.fromString=N}(S||(e.RevealProblemKind=S={}));var o;(function(F){F[F.Shared=1]="Shared",F[F.Dedicated=2]="Dedicated",F[F.New=3]="New"})(o||(e.PanelKind=o={})),function(F){function N(x){switch(x.toLowerCase()){case"shared":return F.Shared;case"dedicated":return F.Dedicated;case"new":return F.New;default:return F.Shared}}F.fromString=N}(o||(e.PanelKind=o={}));var v;(function(F){F.defaults={echo:!0,reveal:A.Always,revealProblems:S.Never,focus:!1,panel:o.Shared,showReuseMessage:!0,clear:!1}})(v||(e.PresentationOptions=v={}));var p;(function(F){F[F.Shell=1]="Shell",F[F.Process=2]="Process",F[F.CustomExecution=3]="CustomExecution"})(p||(e.RuntimeType=p={})),function(F){function N(J){switch(J.toLowerCase()){case"shell":return F.Shell;case"process":return F.Process;case"customExecution":return F.CustomExecution;default:return F.Process}}F.fromString=N;function x(J){switch(J){case F.Shell:return"shell";case F.Process:return"process";case F.CustomExecution:return"customExecution";default:return"process"}}F.toString=x}(p||(e.RuntimeType=p={}));var f;(function(F){function N(x){return L.$zf(x)?x:x.value}F.value=N})(f||(e.CommandString=f={}));var t;(function(F){F.Clean={_id:"clean",isDefault:!1},F.Build={_id:"build",isDefault:!1},F.Rebuild={_id:"rebuild",isDefault:!1},F.Test={_id:"test",isDefault:!1};function N(J){return J===F.Clean._id||J===F.Build._id||J===F.Rebuild._id||J===F.Test._id}F.is=N;function x(J){if(J!==void 0)return L.$zf(J)?N(J)?{_id:J,isDefault:!1}:void 0:J}F.from=x})(t||(e.TaskGroup=t={}));var i;(function(F){F[F.Global=1]="Global",F[F.Workspace=2]="Workspace",F[F.Folder=3]="Folder"})(i||(e.TaskScope=i={}));var n;(function(F){F.Workspace="workspace",F.Extension="extension",F.InMemory="inMemory",F.WorkspaceFile="workspaceFile",F.User="user";function N(x){switch(x){case F.User:return 2;case F.WorkspaceFile:return 5;default:return 6}}F.toConfigurationTarget=N})(n||(e.TaskSourceKind=n={}));var u;(function(F){F.parallel="parallel",F.sequence="sequence"})(u||(e.DependsOrder=u={}));var a;(function(F){F[F.default=1]="default",F[F.folderOpen=2]="folderOpen"})(a||(e.RunOnOptions=a={}));var l;(function(F){F.defaults={reevaluateOnRerun:!0,runOn:a.default,instanceLimit:1}})(l||(e.RunOptions=l={}));class r{constructor(N,x,J,ye,De,Ce){this._label="",this._id=N,x&&(this._label=x),J&&(this.type=J),this.runOptions=ye,this.configurationProperties=De,this._source=Ce}getDefinition(N){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const N={folder:this.d(),id:this._id};return JSON.stringify(N)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(N,x=!1){if(N===void 0)return!1;if(L.$zf(N))return N===this._label||N===this.configurationProperties.identifier||x&&N===this._id;const J=this.getDefinition(!0);return J!==void 0&&J._key===N._key}getQualifiedLabel(){const N=this.getWorkspaceFolder();return N?`${this._label} (${N.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(N){this.c===void 0&&(this.c=[]),N&&(this.c=this.c.concat(N))}get taskLoadMessages(){return this.c}}e.$$F=r;class s extends r{constructor(N,x,J,ye,De,Ce,ge,we){super(N,J,void 0,ge,we,x),this.command={},this._source=x,this.hasDefinedMatchers=Ce,De&&(this.command=De)}clone(){return new s(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(N=!1){if(N&&this._source.customizes!==void 0)return this._source.customizes;{let x;switch(this.command?this.command.runtime:void 0){case p.Shell:x="shell";break;case p.Process:x="process";break;case p.CustomExecution:x="customExecution";break;case void 0:x="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:x,_key:this._id,id:this._id}}}static is(N){return N instanceof s}getMapKey(){const N=this._source.config.workspaceFolder;return N?`${N.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$7F:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const N=this.d();if(!N)return;let x=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(x+=this._source.kind);const J={type:e.$0F,folder:N,id:x};return JSON.stringify(J)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$tg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(N){return new s(N._id,N._source,N._label,N.type,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.$_F=s;class c extends r{constructor(N,x,J,ye,De,Ce,ge){super(N,J,ye,Ce,ge,x),this._source=x,this.configures=De}static is(N){return N instanceof c}f(N){return N}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$tg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$7F:this._source.config.workspaceFolder?.uri.toString()}getKey(){const N=this.d();if(!N)return;let x=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(x+=this._source.kind);const J={type:e.$0F,folder:N,id:x};return JSON.stringify(J)}}e.$aG=c;class h extends r{constructor(N,x,J,ye,De,Ce,ge,we,re){super(N,J,ye,we,re,x),this.defines=De,this.hasDefinedMatchers=ge,this.command=Ce,this.icon=re.icon,this.hide=re.hide}clone(){return new h(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(N){return N instanceof h}getMapKey(){const N=this._source.workspaceFolder;return N?`${this._source.scope.toString()}|${N.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const N={type:"contributed",scope:this._source.scope,id:this._id};return N.folder=this.d(),JSON.stringify(N)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(N){return new h(N._id,N._source,N._label,N.type,N.defines,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.$bG=h;class w extends r{constructor(N,x,J,ye,De,Ce){super(N,J,ye,De,Ce,x),this._source=x}clone(){return new w(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(N){return N instanceof w}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(N){return new w(N._id,N._source,N._label,N.type,N.runOptions,N.configurationProperties)}}e.$cG=w;var m;(function(F){F[F.Process=1]="Process",F[F.Terminal=2]="Terminal"})(m||(e.ExecutionEngine=m={})),function(F){F._default=F.Terminal}(m||(e.ExecutionEngine=m={}));var I;(function(F){F[F.V0_1_0=1]="V0_1_0",F[F.V2_0_0=2]="V2_0_0"})(I||(e.JsonSchemaVersion=I={}));class k{constructor(N){this.c=new Map;for(let x=0;x<N.length;x++)this.c.set(N[x].uri.toString(),x)}compare(N,x){const J=N.getWorkspaceFolder(),ye=x.getWorkspaceFolder();if(J&&ye){let De=this.c.get(J.uri.toString());De=De===void 0?0:De+1;let Ce=this.c.get(ye.uri.toString());return Ce=Ce===void 0?0:Ce+1,De===Ce?N._label.localeCompare(x._label):De-Ce}else return!J&&ye?-1:J&&!ye?1:0}}e.$dG=k;var d;(function(F){F.DependsOnStarted="dependsOnStarted",F.AcquiredInput="acquiredInput",F.Start="start",F.ProcessStarted="processStarted",F.Active="active",F.Inactive="inactive",F.Changed="changed",F.Terminated="terminated",F.ProcessEnded="processEnded",F.End="end"})(d||(e.TaskEventKind=d={}));var b;(function(F){F.SingleRun="singleRun",F.Background="background"})(b||(e.TaskRunType=b={}));var y;(function(F){F[F.System=0]="System",F[F.User=1]="User",F[F.FolderOpen=2]="FolderOpen",F[F.ConfigurationChange=3]="ConfigurationChange",F[F.Reconnect=4]="Reconnect"})(y||(e.TaskRunSource=y={}));var C;(function(F){function N(we){return{taskId:we._id,taskName:we.configurationProperties.name,runType:we.configurationProperties.isBackground?"background":"singleRun",group:we.configurationProperties.group,__task:we}}function x(we,re,oe){return{...N(we),kind:"start",terminalId:re,resolvedVariables:oe}}F.start=x;function J(we,re,oe){return{...N(we),kind:"processStarted",terminalId:re,processId:oe}}F.processStarted=J;function ye(we,re,oe){return{...N(we),kind:"processEnded",terminalId:re,exitCode:oe}}F.processEnded=ye;function De(we,re,oe){return{...N(we),kind:"terminated",exitReason:oe,terminalId:re}}F.terminated=De;function Ce(we,re,oe){return{...N(re),kind:we,terminalId:oe}}F.general=Ce;function ge(){return{kind:"changed"}}F.changed=ge})(C||(e.TaskEvent=C={}));var B;(function(F){function N(J){const ye=Object.keys(J).sort();let De="";for(const Ce of ye){let ge=J[Ce];ge instanceof Object?ge=N(ge):typeof ge=="string"&&(ge=ge.replace(/,/g,",,")),De+=Ce+","+ge+","}return De}function x(J){const De={_key:N(J),type:J.taskType};return Object.assign(De,J),De}F.create=x})(B||(e.KeyedTaskIdentifier=B={}));var H;(function(F){F.AutoDetect="task.autoDetect",F.SaveBeforeRun="task.saveBeforeRun",F.ShowDecorations="task.showDecorations",F.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",F.SlowProviderWarning="task.slowProviderWarning",F.QuickOpenHistory="task.quickOpen.history",F.QuickOpenDetail="task.quickOpen.detail",F.QuickOpenSkip="task.quickOpen.skip",F.QuickOpenShowAll="task.quickOpen.showAll",F.AllowAutomaticTasks="task.allowAutomaticTasks",F.Reconnection="task.reconnection",F.VerboseLogging="task.verboseLogging"})(H||(e.TaskSettingId=H={}));var U;(function(F){F.Tasks="tasks",F.SuppressTaskName="tasks.suppressTaskName",F.Windows="tasks.windows",F.Osx="tasks.osx",F.Linux="tasks.linux",F.ShowOutput="tasks.showOutput",F.IsShellCommand="tasks.isShellCommand",F.ServiceTestSetting="tasks.service.testSetting"})(U||(e.TasksSchemaProperties=U={}));var z;(function(F){function N(x,J){const ye=$.$6F.get(x.type);if(ye===void 0){const we=M.$$m(x);return delete we._key,B.create(we)}const De=Object.create(null);De.type=ye.taskType;const Ce=new Set;ye.required.forEach(we=>Ce.add(we));const ge=ye.properties;for(const we of Object.keys(ge)){const re=x[we];if(re!=null)De[we]=re;else if(Ce.has(we)){const oe=ge[we];if(oe.default!==void 0)De[we]=M.$$m(oe.default);else switch(oe.type){case"boolean":De[we]=!1;break;case"number":case"integer":De[we]=0;break;case"string":De[we]="";break;default:J.error(E.localize(2,null,JSON.stringify(x,void 0,0),we));return}}}return B.create(De)}F.createTaskIdentifier=N})(z||(e.TaskDefinition=z={}))}),define(Ae[231],Re([1,0,11]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j5b=e.$i5b=void 0;class L{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,$)=>{this.b=R,this.d=$,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,E.$Z)(R))}then(R,$){return this.j().then(R,$)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$i5b=L;class P extends L{constructor(){super(),this.h=!0,this.i=new E.$4}}e.$j5b=P}),define(Ae[49],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uv=e.$tv=e.$sv=e.$rv=void 0;class E{static{this.count=0}constructor(D){this._proxyIdentifierBrand=void 0,this.sid=D,this.nid=++E.count}}e.$rv=E;const L=[];function P($){const D=new E($);return L[D.nid]=D,D}e.$sv=P;function M($){return L[$].sid}e.$tv=M;class R{constructor(D){this.value=D}}e.$uv=R}),define(Ae[3],Re([1,0,49]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wK=e.$vK=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$uK=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var L;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(L||(e.TextEditorRevealType=L={}));var P;(function(f){f[f.UnknownInput=0]="UnknownInput",f[f.TextInput=1]="TextInput",f[f.TextDiffInput=2]="TextDiffInput",f[f.TextMergeInput=3]="TextMergeInput",f[f.NotebookInput=4]="NotebookInput",f[f.NotebookDiffInput=5]="NotebookDiffInput",f[f.CustomEditorInput=6]="CustomEditorInput",f[f.WebviewEditorInput=7]="WebviewEditorInput",f[f.TerminalEditorInput=8]="TerminalEditorInput",f[f.InteractiveEditorInput=9]="InteractiveEditorInput",f[f.ChatEditorInput=10]="ChatEditorInput"})(P||(e.TabInputKind=P={}));var M;(function(f){f[f.TAB_OPEN=0]="TAB_OPEN",f[f.TAB_CLOSE=1]="TAB_CLOSE",f[f.TAB_UPDATE=2]="TAB_UPDATE",f[f.TAB_MOVE=3]="TAB_MOVE"})(M||(e.TabModelOperationKind=M={}));var R;(function(f){f[f.Editable=0]="Editable",f[f.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var $;(function(f){f[f.Int8Array=1]="Int8Array",f[f.Uint8Array=2]="Uint8Array",f[f.Uint8ClampedArray=3]="Uint8ClampedArray",f[f.Int16Array=4]="Int16Array",f[f.Uint16Array=5]="Uint16Array",f[f.Int32Array=6]="Int32Array",f[f.Uint32Array=7]="Uint32Array",f[f.Float32Array=8]="Float32Array",f[f.Float64Array=9]="Float64Array",f[f.BigInt64Array=10]="BigInt64Array",f[f.BigUint64Array=11]="BigUint64Array"})($||(e.WebviewMessageArrayBufferViewType=$={}));var D;(function(f){f[f.Text=1]="Text",f[f.Error=2]="Error",f[f.Rich=3]="Rich"})(D||(e.CellOutputKind=D={}));var g;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(g||(e.NotebookEditorRevealType=g={}));var A;(function(f){f[f.None=0]="None",f[f.Process=1]="Process",f[f.Output=2]="Output"})(A||(e.CandidatePortSource=A={}));class S{static{this.a=0}static mixin(t){return t._id=S.a++,t}}e.$uK=S;var o;(function(f){f.label="a",f.kind="b",f.detail="c",f.documentation="d",f.sortText="e",f.filterText="f",f.preselect="g",f.insertText="h",f.insertTextRules="i",f.range="j",f.commitCharacters="k",f.additionalTextEdits="l",f.kindModifier="m",f.commandIdent="n",f.commandId="o",f.commandArguments="p"})(o||(e.ISuggestDataDtoField=o={}));var v;(function(f){f.defaultRanges="a",f.completions="b",f.isIncomplete="c",f.duration="d"})(v||(e.ISuggestResultDtoField=v={}));var p;(function(f){f[f.Workspace=0]="Workspace",f[f.TextDocument=1]="TextDocument"})(p||(e.ExtHostTestingResource=p={})),e.$vK={MainThreadAuthentication:(0,E.$sv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,E.$sv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,E.$sv)("MainThreadChatProvider"),MainThreadChatAgents:(0,E.$sv)("MainThreadChatAgents"),MainThreadChatAgents2:(0,E.$sv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,E.$sv)("MainThreadChatVariables"),MainThreadClipboard:(0,E.$sv)("MainThreadClipboard"),MainThreadCommands:(0,E.$sv)("MainThreadCommands"),MainThreadComments:(0,E.$sv)("MainThreadComments"),MainThreadConfiguration:(0,E.$sv)("MainThreadConfiguration"),MainThreadConsole:(0,E.$sv)("MainThreadConsole"),MainThreadDebugService:(0,E.$sv)("MainThreadDebugService"),MainThreadDecorations:(0,E.$sv)("MainThreadDecorations"),MainThreadDiagnostics:(0,E.$sv)("MainThreadDiagnostics"),MainThreadDialogs:(0,E.$sv)("MainThreadDiaglogs"),MainThreadDocuments:(0,E.$sv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,E.$sv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,E.$sv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,E.$sv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,E.$sv)("MainThreadEditorTabs"),MainThreadErrors:(0,E.$sv)("MainThreadErrors"),MainThreadTreeViews:(0,E.$sv)("MainThreadTreeViews"),MainThreadDownloadService:(0,E.$sv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,E.$sv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,E.$sv)("MainThreadLanguages"),MainThreadLogger:(0,E.$sv)("MainThreadLogger"),MainThreadMessageService:(0,E.$sv)("MainThreadMessageService"),MainThreadOutputService:(0,E.$sv)("MainThreadOutputService"),MainThreadProgress:(0,E.$sv)("MainThreadProgress"),MainThreadQuickDiff:(0,E.$sv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,E.$sv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,E.$sv)("MainThreadStatusBar"),MainThreadSecretState:(0,E.$sv)("MainThreadSecretState"),MainThreadStorage:(0,E.$sv)("MainThreadStorage"),MainThreadSpeech:(0,E.$sv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,E.$sv)("MainThreadTelemetry"),MainThreadTerminalService:(0,E.$sv)("MainThreadTerminalService"),MainThreadWebviews:(0,E.$sv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,E.$sv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,E.$sv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,E.$sv)("MainThreadCustomEditors"),MainThreadUrls:(0,E.$sv)("MainThreadUrls"),MainThreadUriOpeners:(0,E.$sv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,E.$sv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,E.$sv)("MainThreadWorkspace"),MainThreadFileSystem:(0,E.$sv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,E.$sv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,E.$sv)("MainThreadExtensionService"),MainThreadSCM:(0,E.$sv)("MainThreadSCM"),MainThreadSearch:(0,E.$sv)("MainThreadSearch"),MainThreadShare:(0,E.$sv)("MainThreadShare"),MainThreadTask:(0,E.$sv)("MainThreadTask"),MainThreadWindow:(0,E.$sv)("MainThreadWindow"),MainThreadLabelService:(0,E.$sv)("MainThreadLabelService"),MainThreadNotebook:(0,E.$sv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,E.$sv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,E.$sv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,E.$sv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,E.$sv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,E.$sv)("MainThreadInteractive"),MainThreadChat:(0,E.$sv)("MainThreadChat"),MainThreadInlineChat:(0,E.$sv)("MainThreadInlineChatShape"),MainThreadTheming:(0,E.$sv)("MainThreadTheming"),MainThreadTunnelService:(0,E.$sv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,E.$sv)("MainThreadManagedSockets"),MainThreadTimeline:(0,E.$sv)("MainThreadTimeline"),MainThreadTesting:(0,E.$sv)("MainThreadTesting"),MainThreadLocalization:(0,E.$sv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,E.$sv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,E.$sv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,E.$sv)("MainThreadIssueReporter")},e.$wK={ExtHostCommands:(0,E.$sv)("ExtHostCommands"),ExtHostConfiguration:(0,E.$sv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,E.$sv)("ExtHostDiagnostics"),ExtHostDebugService:(0,E.$sv)("ExtHostDebugService"),ExtHostDecorations:(0,E.$sv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,E.$sv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,E.$sv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,E.$sv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,E.$sv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,E.$sv)("ExtHostEditors"),ExtHostTreeViews:(0,E.$sv)("ExtHostTreeViews"),ExtHostFileSystem:(0,E.$sv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,E.$sv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,E.$sv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,E.$sv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,E.$sv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,E.$sv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,E.$sv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,E.$sv)("ExtHostStatusBar"),ExtHostShare:(0,E.$sv)("ExtHostShare"),ExtHostExtensionService:(0,E.$sv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,E.$sv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,E.$sv)("ExtHostTerminalService"),ExtHostSCM:(0,E.$sv)("ExtHostSCM"),ExtHostSearch:(0,E.$sv)("ExtHostSearch"),ExtHostTask:(0,E.$sv)("ExtHostTask"),ExtHostWorkspace:(0,E.$sv)("ExtHostWorkspace"),ExtHostWindow:(0,E.$sv)("ExtHostWindow"),ExtHostWebviews:(0,E.$sv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,E.$sv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,E.$sv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,E.$sv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,E.$sv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,E.$sv)("ExtHostEditorTabs"),ExtHostProgress:(0,E.$sv)("ExtHostProgress"),ExtHostComments:(0,E.$sv)("ExtHostComments"),ExtHostSecretState:(0,E.$sv)("ExtHostSecretState"),ExtHostStorage:(0,E.$sv)("ExtHostStorage"),ExtHostUrls:(0,E.$sv)("ExtHostUrls"),ExtHostUriOpeners:(0,E.$sv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,E.$sv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,E.$sv)("ExtHostOutputService"),ExtHosLabelService:(0,E.$sv)("ExtHostLabelService"),ExtHostNotebook:(0,E.$sv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,E.$sv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,E.$sv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,E.$sv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,E.$sv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,E.$sv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,E.$sv)("ExtHostInteractive"),ExtHostInlineChat:(0,E.$sv)("ExtHostInlineChatShape"),ExtHostChat:(0,E.$sv)("ExtHostChat"),ExtHostChatAgents:(0,E.$sv)("ExtHostChatAgents"),ExtHostChatAgents2:(0,E.$sv)("ExtHostChatAgents"),ExtHostChatVariables:(0,E.$sv)("ExtHostChatVariables"),ExtHostChatProvider:(0,E.$sv)("ExtHostChatProvider"),ExtHostSpeech:(0,E.$sv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,E.$sv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,E.$sv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,E.$sv)("ExtHostTheming"),ExtHostTunnelService:(0,E.$sv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,E.$sv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,E.$sv)("ExtHostAuthentication"),ExtHostTimeline:(0,E.$sv)("ExtHostTimeline"),ExtHostTesting:(0,E.$sv)("ExtHostTesting"),ExtHostTelemetry:(0,E.$sv)("ExtHostTelemetry"),ExtHostLocalization:(0,E.$sv)("ExtHostLocalization"),ExtHostIssueReporter:(0,E.$sv)("ExtHostIssueReporter")}}),define(Ae[232],Re([1,0,3,7]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4ec=void 0;class P{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(E.$vK.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,$,D){if(this.a.size===0)throw new Error("No related information providers registered");const g=this.a.get(R);if(!g)throw new Error("related information provider not found");return await g.provideRelatedInformation($,D)??[]}getRelatedInformation(R,$,D){return this.c.$getAiRelatedInformation($,D)}registerRelatedInformationProvider(R,$,D){const g=this.b;return this.b++,this.a.set(g,D),this.c.$registerAiRelatedInformationProvider(g,$),new L.$xK(()=>{this.c.$unregisterAiRelatedInformationProvider(g),this.a.delete(g)})}}e.$4ec=P}),define(Ae[81],Re([1,0,4,15,3,17]),function(pe,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8cc=e.$7cc=e.$6cc=void 0,e.$6cc=(0,E.$Th)("IExtHostApiDeprecationService");let R=class{constructor(D,g){this.c=g,this.a=new Set,this.b=D.getProxy(P.$vK.MainThreadTelemetry)}report(D,g,A){const S=this.d(D,g);this.a.has(S)||(this.a.add(S),g.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${D}' is deprecated. ${A}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:g.identifier.value,apiId:D}))}d(D,g){return`${D}-${g.identifier.value}`}};e.$7cc=R,e.$7cc=R=Ke([Ve(0,M.$xM),Ve(1,L.$bj)],R),e.$8cc=Object.freeze(new class{report($,D,g){}})}),define(Ae[233],Re([1,0,5,3,7,22]),function(pe,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bec=void 0;class R{constructor(g){this.b=new Map,this.c=[],this.d=new E.$Od,this.onDidChangeSessions=this.d.event,this.f=new $,this.g=new $,this.a=g.getProxy(L.$vK.MainThreadAuthentication)}$setProviders(g){return this.c=g,Promise.resolve()}async getSession(g,A,S,o={}){const v=M.$0l.toKey(g.identifier),p=[...S].sort().join(" ");return await this.f.getOrCreate(`${v} ${A} ${p}`,async()=>{await this.a.$ensureProvider(A);const f=g.displayName||g.name;return this.a.$getSession(A,S,v,f,o)})}async getSessions(g,A,S){const o=M.$0l.toKey(g.identifier),v=[...S].sort().join(" ");return await this.g.getOrCreate(`${o} ${v}`,async()=>{await this.a.$ensureProvider(A);const p=g.displayName||g.name;return this.a.$getSessions(A,S,o,p)})}async removeSession(g,A){const S=this.b.get(g);return S?S.provider.removeSession(A):this.a.$removeSession(g,A)}registerAuthenticationProvider(g,A,S,o){if(this.b.get(g))throw new Error(`An authentication provider with id '${g}' is already registered.`);this.b.set(g,{label:A,provider:S,options:o??{supportsMultipleAccounts:!1}}),this.c.find(p=>p.id===g)||this.c.push({id:g,label:A});const v=S.onDidChangeSessions(p=>{this.a.$sendDidChangeSessions(g,{added:p.added??[],changed:p.changed??[],removed:p.removed??[]})});return this.a.$registerAuthenticationProvider(g,A,o?.supportsMultipleAccounts??!1),new P.$xK(()=>{v.dispose(),this.b.delete(g);const p=this.c.findIndex(f=>f.id===g);p>-1&&this.c.splice(p),this.a.$unregisterAuthenticationProvider(g)})}$createSession(g,A,S){const o=this.b.get(g);if(o)return Promise.resolve(o.provider.createSession(A,S));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$removeSession(g,A){const S=this.b.get(g);if(S)return Promise.resolve(S.provider.removeSession(A));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$getSessions(g,A){const S=this.b.get(g);if(S)return Promise.resolve(S.provider.getSessions(A));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$onDidChangeAuthenticationSessions(g,A){return this.d.fire({provider:{id:g,label:A}}),Promise.resolve()}}e.$Bec=R;class ${constructor(){this.a=new Map}getOrCreate(g,A){const S=this.a.get(g);if(S)return S;const o=A().finally(()=>this.a.delete(g));return this.a.set(g,o),o}}}),define(Ae[234],Re([1,0,3,17,8]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hec=void 0;let M=class{constructor($,D){this.a=$.getProxy(E.$vK.MainThreadBulkEdits),this.b={getTextDocumentVersion:g=>D.getDocument(g)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit($,D,g){const A=P.WorkspaceEdit.from($,this.b);return this.a.$tryApplyWorkspaceEdit(A,void 0,g?.isRefactoring??!1)}};e.$Hec=M,e.$Hec=M=Ke([Ve(0,L.$xM)],M)}),define(Ae[235],Re([1,0,12,5,68,6,50,157,3,8]),function(pe,e,E,L,P,M,R,$,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vec=void 0;class A{static{this.a=0}constructor(v,p){this.extension=v,this.provider=p,this.handle=A.a++}}class S{static{this.a=0}constructor(v,p){this.h=p,this.b=new Map,this.d=new Map,this.e=new L.$Od,this.onDidPerformUserAction=this.e.event,this.g=v.getProxy(D.$vK.MainThreadChat)}registerChatProvider(v,p,f){const t=new A(v,f);return this.b.set(t.handle,t),this.g.$registerChatProvider(t.handle,p),(0,M.$Pc)(()=>{this.g.$unregisterChatProvider(t.handle),this.b.delete(t.handle)})}transferChatSession(v,p){const f=P.Iterable.find(this.d.keys(),t=>this.d.get(t)===v)??0;typeof f=="number"&&this.g.$transferChatSession(f,p)}sendInteractiveRequestToProvider(v,p){this.g.$sendRequestToProvider(v,p)}async $prepareChat(v,p,f){const t=this.b.get(v);if(!t)return;const i=await t.provider.prepareSession(p,f);if(!i)return;const n=S.a++;return this.d.set(n,i),{id:n,requesterUsername:i.requester?.name,requesterAvatarIconUri:i.requester?.icon,responderUsername:i.responder?.name,responderAvatarIconUri:i.responder?.icon,inputPlaceholder:i.inputPlaceholder}}async $provideWelcomeMessage(v,p){const f=this.b.get(v);if(!f||!f.provider.provideWelcomeMessage)return;const t=await f.provider.provideWelcomeMessage(p);if(t)return t.map(i=>typeof i=="string"?i:Array.isArray(i)?i.map(n=>g.ChatReplyFollowup.from(n)):g.MarkdownString.from(i))}async $provideFollowups(v,p,f){const t=this.b.get(v);if(!t)return;const i=this.d.get(p);return!i||!t.provider.provideFollowups?void 0:(await t.provider.provideFollowups(i,f))?.map(u=>g.ChatFollowup.from(u))}async $provideSampleQuestions(v,p){const f=this.b.get(v);if(!f||!f.provider.provideSampleQuestions)return;const t=await f.provider.provideSampleQuestions(p);if(t)return t?.map(i=>g.ChatReplyFollowup.from(i))}$removeRequest(v,p,f){const t=this.b.get(v);if(!t)return;const i=this.d.get(p);i&&t.provider.removeRequest&&t.provider.removeRequest(i,f)}async $provideReply(v,p,f,t){const i=this.b.get(v);if(!i)return;const n=this.d.get(p);if(!n)return;const u={session:n,message:f.message,variables:{}};if(f.variables)for(const h of Object.keys(f.variables))u.variables[h]=f.variables[h].map(g.ChatVariable.to);const a=R.$Kd.create(!1);let l;const r={report:h=>{if(t.isCancellationRequested)return;typeof l>"u"&&(l=a.elapsed());const w=g.ChatResponseProgress.from(i.extension,h);if("placeholder"in h&&"resolvedContent"in h){const m=Promise.all([this.g.$acceptResponseProgress(v,p,w),h.resolvedContent]);(0,E.$Jg)(m,t).then(I=>{if(!I)return;const[k,d]=I;this.g.$acceptResponseProgress(v,p,d,k??void 0)})}else this.g.$acceptResponseProgress(v,p,w)}};let s;try{s=await i.provider.provideResponseWithProgress(u,r,t),s||(s={errorDetails:{message:(0,$.localize)(0,null)}})}catch(h){s={errorDetails:{message:(0,$.localize)(1,null,h.message),responseIsIncomplete:!0}},this.h.error(h)}try{if(n.saveState&&this.d.has(p)){const h=n.saveState();this.g.$acceptChatState(p,h)}}catch(h){this.h.warn(h)}const c={firstProgress:l??0,totalElapsed:a.elapsed()};return{errorDetails:s.errorDetails,timings:c}}async $provideSlashCommands(v,p,f){const t=this.b.get(v);if(!t)return;const i=this.d.get(p);return!i||!t.provider.provideSlashCommands?void 0:(await t.provider.provideSlashCommands(i,f))?.map(u=>({...u,kind:g.CompletionItemKind.from(u.kind)}))}$releaseSession(v){this.d.delete(v)}async $onDidPerformUserAction(v){this.e.fire(v)}}e.$Vec=S}),define(Ae[236],Re([1,0,12,6,54,3,8,7]),function(pe,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6ec=void 0;class D{static{this.a=0}constructor(S,o,v){this.d=o,this.e=v,this.b=new Map,this.c=S.getProxy(M.$vK.MainThreadChatAgents)}registerAgent(S,o,v,p){const f=D.a++;return this.b.set(f,{extension:S,agent:v}),this.c.$registerAgent(f,o,p),(0,L.$Pc)(()=>{this.c.$unregisterAgent(f),this.b.delete(f)})}async $invokeAgent(S,o,v,p,f){const t=this.b.get(S);if(!t){this.e.warn(`[CHAT](${S}) CANNOT invoke agent because the agent is not registered`);return}let i=!1;function n(){if(i)throw new Error("Only valid while executing the command")}const u=new E.$gh;f.onCancellationRequested(()=>u.complete()),setTimeout(()=>u.complete(),10*1e3),this.d.allowListExtensionWhile(t.extension,u.p);const a=t.agent({role:$.ChatMessageRole.User,content:v},{history:p.history.map(R.ChatMessage.to)},new P.$9u(l=>{n(),this.c.$handleProgressChunk(o,{content:g(l.message)?l.message:l.message.value})}),f);try{return await(0,E.$Jg)(Promise.resolve(a).then(l=>{if(l&&"followUp"in l)return{followUp:l?.followUp?.map(s=>R.ChatFollowup.from(s))}}),f)}finally{i=!0,u.complete()}}}e.$6ec=D;function g(A){return!!A&&typeof A=="object"&&"treeData"in A}}),define(Ae[237],Re([1,0,12,20,39,5,50,16,2,158,54,3,8,7,207,23]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7ec=void 0;class t{static{this.a=0}constructor(u,a,l){this.i=a,this.j=l,this.b=new Map,this.g=new Map,this.h=new Map,this.d=u.getProxy(S.$vK.MainThreadChatAgents2)}createChatAgent(u,a,l){const r=t.a++,s=new i(u,a,this.d,r,l);return this.b.set(r,s),this.d.$registerAgent(r,a,{}),s.apiAgent}async $invokeAgent(u,a,l,r,s,c){this.g.delete(a);const h=this.b.get(u);if(!h)throw new Error(`[CHAT](${u}) CANNOT invoke agent because the agent is not registered`);let w=!1;function m(){if(w)throw new Error("Only valid while executing the command")}const I=new E.$gh;c.onCancellationRequested(()=>I.complete()),setTimeout(()=>I.complete(),10*1e3),this.i.allowListExtensionWhile(h.extension.identifier,I.p);const k=r.command?await h.validateSlashCommand(r.command):void 0,d=R.$Kd.create(!1);let b;try{const y=h.invoke({prompt:r.message,variables:o.ChatVariable.objectTo(r.variables),slashCommand:k},{history:s.history.map(o.ChatMessage.to)},new A.$9u(C=>{m(),typeof b>"u"&&"content"in C&&(b=d.elapsed());const B=o.ChatResponseProgress.from(h.extension,C);if("placeholder"in C&&"resolvedContent"in C){const H=Promise.all([this.d.$handleProgressChunk(l,B),C.resolvedContent]);(0,E.$Jg)(H,c).then(U=>{if(!U)return;const[z,F]=U;this.d.$handleProgressChunk(l,F,z??void 0)})}else this.d.$handleProgressChunk(l,B)}),c);return await(0,E.$Jg)(Promise.resolve(y).then(C=>{if(C){this.g.set(a,C);let B=this.h.get(a);B||(B=new Map,this.h.set(a,B)),B.set(l,C);const H={firstProgress:b,totalElapsed:d.elapsed()};return{errorDetails:C.errorDetails,timings:H}}else this.g.delete(a)}),c)}catch(y){return this.j.error(y,h.extension),{errorDetails:{message:(0,g.localize)(0,null,(0,P.$Ei)(y)),responseIsIncomplete:!0}}}finally{w=!0,I.complete()}}$releaseSession(u){this.g.delete(u),this.h.delete(u)}async $provideSlashCommands(u,a){const l=this.b.get(u);return l?l.provideSlashCommand(a):[]}$provideFollowups(u,a,l){const r=this.b.get(u);if(!r)return Promise.resolve([]);const s=this.g.get(a);return s?r.provideFollowups(s,l):Promise.resolve([])}$acceptFeedback(u,a,l,r){const s=this.b.get(u);if(!s)return;const c=this.h.get(a)?.get(l);if(!c)return;let h;switch(r){case p.InteractiveSessionVoteDirection.Down:h=v.ChatAgentResultFeedbackKind.Unhelpful;break;case p.InteractiveSessionVoteDirection.Up:h=v.ChatAgentResultFeedbackKind.Helpful;break}s.acceptFeedback(Object.freeze({result:c,kind:h}))}$acceptAction(u,a,l,r){const s=this.b.get(u);if(!s)return;const c=this.h.get(a)?.get(l);c&&r.action.kind!=="vote"&&s.acceptAction(Object.freeze({action:r.action,result:c}))}}e.$7ec=t;class i{constructor(u,a,l,r,s){this.extension=u,this.n=a,this.o=l,this.q=r,this.r=s,this.l=new M.$Od,this.m=new M.$Od}acceptFeedback(u){this.l.fire(u)}acceptAction(u){this.m.fire(u)}async validateSlashCommand(u){this.b||(await this.provideSlashCommand(L.CancellationToken.None),(0,$.$Jf)(this.b));const a=this.b.find(l=>l.name===u);if(!a)throw new Error(`Unknown slashCommand: ${u}`);return a}async provideSlashCommand(u){if(!this.a)return[];const a=await this.a.provideSlashCommands(u);return a?(this.b=a,a.map(l=>({name:l.name,description:l.description,followupPlaceholder:l.followupPlaceholder,shouldRepopulate:l.shouldRepopulate}))):[]}async provideFollowups(u,a){if(!this.d)return[];const l=await this.d.provideFollowups(u,a);return l?l.map(r=>o.ChatFollowup.from(r)):[]}get apiAgent(){let u=!1,a=!1;const l=()=>{u||a||(a=!0,queueMicrotask(()=>{this.o.$updateAgent(this.q,{description:this.g??"",fullName:this.h,icon:this.i?this.i instanceof D.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof v.$rL?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowup:this.d!==void 0,isDefault:this.j,isSecondary:this.k}),a=!1}))},r=this;return{get name(){return r.n},get description(){return r.g??""},set description(s){r.g=s,l()},get fullName(){return r.h??r.extension.displayName??r.extension.name},set fullName(s){r.h=s,l()},get iconPath(){return r.i},set iconPath(s){r.i=s,l()},get slashCommandProvider(){return r.a},set slashCommandProvider(s){r.a=s,l()},get followupProvider(){return r.d},set followupProvider(s){r.d=s,l()},get isDefault(){return(0,f.$vF)(r.extension,"defaultChatAgent"),r.j},set isDefault(s){(0,f.$vF)(r.extension,"defaultChatAgent"),r.j=s,l()},get isSecondary(){return(0,f.$vF)(r.extension,"defaultChatAgent"),r.k},set isSecondary(s){(0,f.$vF)(r.extension,"defaultChatAgent"),r.k=s,l()},get onDidReceiveFeedback(){return r.l.event},onDidPerformAction:(0,f.$uF)(this.extension,"chatAgents2Additions")?this.m.event:void 0,dispose(){u=!0,r.a=void 0,r.d=void 0,r.l.dispose(),r.o.$unregisterAgent(r.q)}}}invoke(u,a,l,r){return this.r(u,a,l,r)}}}),define(Ae[238],Re([1,0,20,6,3,8,54,22,12,5]),function(pe,e,E,L,P,M,R,$,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1ec=void 0;class A{constructor(p,f){this.stream=new D.$kh,this.stream=f??new D.$kh;const t=this;this.apiObj={option:p,response:t.stream.asyncIterable}}}class S{constructor(p,f){this.a=new g.$Od,this.b=new Map,this.c=new D.$kh,this.d=!1;const t=this;this.apiObject={result:p,response:t.c.asyncIterable,onDidStartResponseStream:t.a.event,cancel(){f.cancel()}},p.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,i]of this.b)i.stream.resolve();else this.c.resolve()})}handleFragment(p){if(this.d)return;let f=this.b.get(p.index);f||(this.b.size===0?f=new A(p.index,this.c):f=new A(p.index),this.b.set(p.index,f),this.a.fire(f.apiObj)),f.stream.emitOne(p.part)}}class o{static{this.a=1}constructor(p,f){this.d=f,this.c=new Map,this.e=new Map,this.f=new $.$_l,this.b=p.getProxy(P.$vK.MainThreadChatProvider)}registerProvider(p,f,t,i){const n=o.a++;return this.c.set(n,{extension:p,provider:t}),this.b.$registerProvider(n,f,{extension:p,displayName:i.name??p.value}),(0,L.$Pc)(()=>{this.b.$unregisterProvider(n),this.c.delete(n)})}async $provideChatResponse(p,f,t,i,n){const u=this.c.get(p);if(!u)return;const a=new R.$9u(async l=>{if(n.isCancellationRequested){this.d.warn(`[CHAT](${u.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(f,{index:l.index,part:l.part})});return u.provider.provideChatResponse(t.map(M.ChatMessage.to),i,a,n)}allowListExtensionWhile(p,f){this.f.set(p,f),f.finally(()=>this.f.delete(p))}async requestChatResponseProvider(p,f){if(!this.f.has(p))throw new Error("Extension is NOT allowed to make chat requests");const t=this;return{get isRevoked(){return!t.f.has(p)},makeRequest(i,n,u){if(!t.f.has(p))throw new Error("Access to chat has been revoked");const a=new E.$Yd(u),l=Math.random()*1e6|0,r=t.b.$fetchResponse(p,f,l,i.map(M.ChatMessage.from),n??{},a.token),s=new S(r,a);return t.e.set(l,{res:s}),r.finally(()=>{t.e.delete(l)}),s.apiObject}}}async $handleResponseFragment(p,f){const t=this.e.get(p);t&&t.res.handleFragment(f)}}e.$1ec=o}),define(Ae[239],Re([1,0,6,3,11,8]),function(pe,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3ec=void 0;class R{static{this.a=0}constructor(D){this.b=new Map,this.c=D.getProxy(L.$vK.MainThreadChatVariables)}async $resolveVariable(D,g,A){const S=this.b.get(D);if(S)try{const o=await S.resolver.resolve(S.data.name,{message:g},A);if(o)return o.map(M.ChatVariable.from)}catch(o){(0,P.$1)(o)}}registerVariableResolver(D,g,A,S){const o=R.a++;return this.b.set(o,{extension:D.identifier,data:{name:g,description:A},resolver:S}),this.c.$registerVariable(o,{name:g,description:A}),(0,E.$Pc)(()=>{this.b.delete(o),this.c.$unregisterVariable(o)})}}e.$3ec=R}),define(Ae[240],Re([1,0,3]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$cc=void 0;class L{constructor(M){const R=M.getProxy(E.$vK.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText($){return R.$writeText($)}})}}e.$$cc=L}),define(Ae[32],Re([1,0,16,7,8,26,3,18,15,52,29,131,2,6,4,17,108,24,49,39,50,58,61]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f,t,i,n,u,a,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XM=e.$WM=e.$VM=e.$UM=e.$TM=e.$SM=void 0;let s=class{#e;#t;#i;constructor(k,d,b){this.b=new Map,this.c=new Map,this.#e=k.getProxy(R.$vK.MainThreadCommands),this.d=d,this.#i=b,this.#t=k.getProxy(R.$vK.MainThreadTelemetry),this.converter=new c(this,y=>{const C=this.c.get(y);return C?.result===w.Void?C:void 0},d),this.f=[{processArgument(y){return(0,g.$qh)(y)}},{processArgument(y){return(0,M.$an)(y,function(C){if(A.$xs.isIRange(C))return P.Range.to(C);if(S.$ws.isIPosition(C))return P.Position.to(C);if(A.$xs.isIRange(C.range)&&o.URI.isUri(C.uri))return P.location.to(C);if(C instanceof i.$ce)return C.buffer.buffer;if(!Array.isArray(C))return C})}}]}registerArgumentProcessor(k){this.f.push(k)}registerApiCommand(k){const d=this.registerCommand(!1,k.id,async(...b)=>{const y=k.args.map((B,H)=>{if(!B.validate(b[H]))throw new Error(`Invalid argument '${B.name}' when running '${k.id}', received: ${typeof b[H]=="object"?JSON.stringify(b[H],null,"	"):b[H]} `);return B.convert(b[H])}),C=await this.executeCommand(k.internalId,...y);return k.result.convert(C,b,this.converter)},void 0,{description:k.description,args:k.args,returns:k.result.description});return this.c.set(k.id,k),new L.$xK(()=>{d.dispose(),this.c.delete(k.id)})}registerCommand(k,d,b,y,C,B){if(this.d.trace("ExtHostCommands#registerCommand",d),!d.trim().length)throw new Error("invalid id");if(this.b.has(d))throw new Error(`command '${d}' already exists`);return this.b.set(d,{callback:b,thisArg:y,metadata:C,extension:B}),k&&this.#e.$registerCommand(d),new L.$xK(()=>{this.b.delete(d)&&k&&this.#e.$unregisterCommand(d)})}executeCommand(k,...d){return this.d.trace("ExtHostCommands#executeCommand",k),this.g(k,d,!0)}async g(k,d,b){if(this.b.has(k))return this.#e.$fireCommandActivationEvent(k),this.h(k,d,!1);{let y=!1;const C=(0,M.$an)(d,function(B){if(B instanceof L.$yK)return P.Position.from(B);if(B instanceof L.$zK)return P.Range.from(B);if(B instanceof L.$JK)return P.location.from(B);if(L.$UL.isNotebookRange(B))return P.NotebookRange.from(B);if(B instanceof ArrayBuffer)return y=!0,i.$ce.wrap(new Uint8Array(B));if(B instanceof Uint8Array)return y=!0,i.$ce.wrap(B);if(B instanceof i.$ce)return y=!0,B;if(!Array.isArray(B))return B});try{const B=await this.#e.$executeCommand(k,y?new n.$uv(C):C,b);return(0,g.$qh)(B)}catch(B){if(B instanceof Error&&B.message==="$executeCommand:retry")return this.g(k,d,!1);throw B}}}async h(k,d,b){const y=this.b.get(k);if(!y)throw new Error("Unknown command");const{callback:C,thisArg:B,metadata:H}=y;if(H?.args)for(let z=0;z<H.args.length;z++)try{(0,E.$Qf)(d[z],H.args[z].constraint)}catch{throw new Error(`Running the contributed command: '${k}' failed. Illegal argument '${H.args[z].name}' - ${H.args[z].description}`)}const U=a.$Kd.create();try{return await C.apply(B,d)}catch(z){if(k===this.converter.delegatingCommandId){const F=this.converter.getActualCommand(...d);F&&(k=F.command)}if(this.d.error(z,k,y.extension?.identifier),!b)throw z;if(y.extension?.identifier){const F=this.#i.onExtensionError(y.extension.identifier,z);this.d.trace("forwarded error to extension?",F,y.extension?.identifier)}throw new class extends Error{constructor(){super((0,u.$Ei)(z)),this.id=k,this.source=y.extension?.displayName??y.extension?.name}}}finally{this.j(y,k,U.elapsed())}}j(k,d,b){k.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:k.extension.identifier.value,id:new l.$no(d),duration:b})}$executeContributedCommand(k,...d){this.d.trace("ExtHostCommands#$executeContributedCommand",k);const b=this.b.get(k);return b?(d=d.map(y=>this.f.reduce((C,B)=>B.processArgument(C,b.extension?.identifier),y)),this.h(k,d,!0)):Promise.reject(new Error(`Contributed command '${k}' does not exist.`))}getCommands(k=!1){return this.d.trace("ExtHostCommands#getCommands",k),this.#e.$getCommands().then(d=>(k&&(d=d.filter(b=>b[0]!=="_")),d))}$getContributedCommandMetadata(){const k=Object.create(null);for(const[d,b]of this.b){const{metadata:y}=b;y&&(k[d]=y)}return Promise.resolve(k)}};e.$SM=s,e.$SM=s=Ke([Ve(0,f.$xM),Ve(1,D.$bj),Ve(2,r.$RM)],s),e.$TM=(0,p.$Th)("IExtHostCommands");class c{constructor(k,d,b){this.d=k,this.f=d,this.g=b,this.delegatingCommandId=`__vsc${Date.now().toString(36)} `,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(k,d){if(!k)return;const b={$ident:void 0,id:k.command,title:k.title,tooltip:k.tooltip};if(!k.command)return b;const y=this.f(k.command);if(y)b.id=y.internalId,b.arguments=y.args.map((C,B)=>C.convert(k.arguments&&k.arguments[B]));else if((0,$.$Kb)(k.arguments)){const C=`${k.command} /${++this.c}`;this.b.set(C,k),d.add((0,v.$Pc)(()=>{this.b.delete(C),this.g.trace("CommandsConverter#DISPOSE",C)})),b.$ident=C,b.id=this.delegatingCommandId,b.arguments=[C],this.g.trace("CommandsConverter#CREATE",k.command,C)}return b}fromInternal(k){return typeof k.$ident=="string"?this.b.get(k.$ident):{command:k.id,title:k.title,arguments:k.arguments}}getActualCommand(...k){return this.b.get(k[0])}h(...k){const d=this.getActualCommand(...k);return this.g.trace("CommandsConverter#EXECUTE",k[0],d?d.command:"MISSING"),d?this.d.executeCommand(d.command,...d.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${k[0]}`)}}e.$UM=c;class h{static{this.Uri=new h("uri","Uri of a text document",k=>o.URI.isUri(k),k=>k)}static{this.Position=new h("position","A position in a text document",k=>L.$yK.isPosition(k),P.Position.from)}static{this.Range=new h("range","A range in a text document",k=>L.$zK.isRange(k),P.Range.from)}static{this.Selection=new h("selection","A selection in a text document",k=>L.$AK.isSelection(k),P.Selection.from)}static{this.Number=new h("number","",k=>typeof k=="number",k=>k)}static{this.String=new h("string","",k=>typeof k=="string",k=>k)}static{this.StringArray=h.Arr(h.String)}static Arr(k){return new h(`${k.name}_array`,`Array of ${k.name}, ${k.description}`,d=>Array.isArray(d)&&d.every(b=>k.validate(b)),d=>d.map(b=>k.convert(b)))}static{this.CallHierarchyItem=new h("item","A call hierarchy item",k=>k instanceof L.$TK,P.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new h("item","A type hierarchy item",k=>k instanceof L.$bM,P.TypeHierarchyItem.from)}static{this.TestItem=new h("testItem","A VS Code TestItem",k=>k instanceof t.$KM,P.TestItem.from)}constructor(k,d,b,y){this.name=k,this.description=d,this.validate=b,this.convert=y}optional(){return new h(this.name,`(optional) ${this.description}`,k=>k==null||this.validate(k),k=>k===void 0?void 0:k===null?null:this.convert(k))}with(k,d){return new h(k??this.name,d??this.description,this.validate,this.convert)}}e.$VM=h;class w{static{this.Void=new w("no result",k=>k)}constructor(k,d){this.description=k,this.convert=d}}e.$WM=w;class m{constructor(k,d,b,y,C){this.id=k,this.internalId=d,this.description=b,this.args=y,this.result=C}}e.$XM=m}),define(Ae[241],Re([1,0,18,14,2,80,95,34,99,32,8,7]),function(pe,e,E,L,P,M,R,$,D,g,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0cc=void 0;const o=[new g.$XM("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[g.$VM.Uri,g.$VM.Position],new g.$WM("A promise that resolves to an array of DocumentHighlight-instances.",p(A.DocumentHighlight.to))),new g.$XM("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[g.$VM.Uri],new g.$WM("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,i)=>{if((0,E.$Jb)(t))return;class n extends S.$OK{static to(a){const l=new n(a.name,A.SymbolKind.to(a.kind),a.containerName||"",new S.$JK(i[0],A.Range.to(a.range)));return l.detail=a.detail,l.range=l.location.range,l.selectionRange=A.Range.to(a.selectionRange),l.children=a.children?a.children.map(n.to):[],l}}return t.map(n.to)})),new g.$XM("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[g.$VM.Uri,new g.$VM("options","Formatting options",t=>!0,t=>t)],new g.$WM("A promise that resolves to an array of TextEdits.",p(A.TextEdit.to))),new g.$XM("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[g.$VM.Uri,g.$VM.Range,new g.$VM("options","Formatting options",t=>!0,t=>t)],new g.$WM("A promise that resolves to an array of TextEdits.",p(A.TextEdit.to))),new g.$XM("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[g.$VM.Uri,g.$VM.Position,new g.$VM("ch","Trigger character",t=>typeof t=="string",t=>t),new g.$VM("options","Formatting options",t=>!0,t=>t)],new g.$WM("A promise that resolves to an array of TextEdits.",p(A.TextEdit.to))),new g.$XM("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[g.$VM.Uri,g.$VM.Position],new g.$WM("A promise that resolves to an array of Location or LocationLink instances.",f)),new g.$XM("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[g.$VM.Uri,g.$VM.Position],new g.$WM("A promise that resolves to an array of Location or LocationLink instances.",f)),new g.$XM("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[g.$VM.Uri,g.$VM.Position],new g.$WM("A promise that resolves to an array of Location or LocationLink instances.",f)),new g.$XM("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[g.$VM.Uri,g.$VM.Position],new g.$WM("A promise that resolves to an array of Location or LocationLink instances.",f)),new g.$XM("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[g.$VM.Uri,g.$VM.Position],new g.$WM("A promise that resolves to an array of Location-instances.",p(A.location.to))),new g.$XM("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[g.$VM.Uri,g.$VM.Position],new g.$WM("A promise that resolves to an array of Hover-instances.",p(A.Hover.to))),new g.$XM("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[g.$VM.Uri,new g.$VM("position","A position in a text document",t=>Array.isArray(t)&&t.every(i=>S.$yK.isPosition(i)),t=>t.map(A.Position.from))],new g.$WM("A promise that resolves to an array of ranges.",t=>t.map(i=>{let n;for(const u of i.reverse())n=new S.$SK(A.Range.to(u),n);return n}))),new g.$XM("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[g.$VM.String.with("query","Search string")],new g.$WM("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(A.WorkspaceSymbol.to))),new g.$XM("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[g.$VM.Uri,g.$VM.Position],new g.$WM("A promise that resolves to an array of CallHierarchyItem-instances",t=>t.map(A.CallHierarchyItem.to))),new g.$XM("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[g.$VM.CallHierarchyItem],new g.$WM("A promise that resolves to an array of CallHierarchyIncomingCall-instances",t=>t.map(A.CallHierarchyIncomingCall.to))),new g.$XM("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[g.$VM.CallHierarchyItem],new g.$WM("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",t=>t.map(A.CallHierarchyOutgoingCall.to))),new g.$XM("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[g.$VM.Uri,g.$VM.Position],new g.$WM("A promise that resolves to a range and placeholder text.",t=>{if(t)return{range:A.Range.to(t.range),placeholder:t.text}})),new g.$XM("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[g.$VM.Uri,g.$VM.Position,g.$VM.String.with("newName","The new symbol name")],new g.$WM("A promise that resolves to a WorkspaceEdit.",t=>{if(t){if(t.rejectReason)throw new Error(t.rejectReason);return A.WorkspaceEdit.to(t)}})),new g.$XM("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[g.$VM.Uri,g.$VM.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new g.$WM("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(A.DocumentLink.to))),new g.$XM("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[g.$VM.Uri],new g.$WM("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new S.$ML(t.tokenTypes,t.tokenModifiers)})),new g.$XM("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[g.$VM.Uri],new g.$WM("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,R.$u$)(t);if(i.type==="full")return new S.$OL(i.data,void 0)})),new g.$XM("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[g.$VM.Uri,g.$VM.Range.optional()],new g.$WM("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new S.$ML(t.tokenTypes,t.tokenModifiers)})),new g.$XM("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[g.$VM.Uri,g.$VM.Range],new g.$WM("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,R.$u$)(t);if(i.type==="full")return new S.$OL(i.data,void 0)})),new g.$XM("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[g.$VM.Uri,g.$VM.Position,g.$VM.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),g.$VM.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new g.$WM("A promise that resolves to a CompletionList-instance.",(t,i,n)=>{if(!t)return new S.$5K([]);const u=t.suggestions.map(a=>A.CompletionItem.to(a,n));return new S.$5K(u,t.incomplete)})),new g.$XM("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[g.$VM.Uri,g.$VM.Position,g.$VM.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new g.$WM("A promise that resolves to SignatureHelp.",t=>{if(t)return A.SignatureHelp.to(t)})),new g.$XM("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[g.$VM.Uri,g.$VM.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new g.$WM("A promise that resolves to an array of CodeLens-instances.",(t,i,n)=>p(u=>new S.$WK(A.Range.to(u.range),u.command&&n.fromInternal(u.command)))(t))),new g.$XM("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[g.$VM.Uri,new g.$VM("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>S.$zK.isRange(t),t=>S.$AK.isSelection(t)?A.Selection.from(t):A.Range.from(t)),g.$VM.String.with("kind","Code action kind to return code actions for").optional(),g.$VM.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new g.$WM("A promise that resolves to an array of Command-instances.",(t,i,n)=>p(u=>{if(u._isSynthetic){if(!u.command)throw new Error("Synthetic code actions must have a command");return n.fromInternal(u.command)}else{const a=new S.$QK(u.title,u.kind?new S.$RK(u.kind):void 0);return u.edit&&(a.edit=A.WorkspaceEdit.to(u.edit)),u.command&&(a.command=n.fromInternal(u.command)),a.isPreferred=u.isPreferred,a}})(t))),new g.$XM("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[g.$VM.Uri],new g.$WM("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(i=>new S.$$K(A.Range.to(i.range),A.Color.to(i.color))):[])),new g.$XM("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new g.$VM("color","The color to show and insert",t=>t instanceof S.$0K,A.Color.from),new g.$VM("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:A.Range.from(t.range)}))],new g.$WM("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(A.ColorPresentation.to):[])),new g.$XM("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[g.$VM.Uri,g.$VM.Range],new g.$WM("A promise that resolves to an array of Inlay objects",(t,i,n)=>t.map(A.InlayHint.to.bind(void 0,n)))),new g.$XM("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[g.$VM.Uri],new g.$WM("A promise that resolves to an array of FoldingRange objects",(t,i)=>{if(t)return t.map(A.FoldingRange.to)})),new g.$XM("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new g.$WM("A promise that resolves to an array of NotebookContentProvider static info objects.",p(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(i=>A.NotebookExclusiveDocumentPattern.to(i))})))),new g.$XM("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[g.$VM.Uri,g.$VM.Range,new g.$VM("context","An InlineValueContext",t=>t&&typeof t.frameId=="number"&&t.stoppedLocation instanceof S.$zK,t=>A.InlineValueContext.from(t))],new g.$WM("A promise that resolves to an array of InlineValue objects",t=>t.map(A.InlineValue.to))),new g.$XM("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new g.$VM("uriOrString","Uri-instance or string (only http/https)",t=>P.URI.isUri(t)||typeof t=="string"&&(0,D.$HU)(t,L.Schemas.http,L.Schemas.https),t=>t),new g.$VM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[A.ViewColumn.from(t),void 0]:[A.ViewColumn.from(t.viewColumn),A.TextEditorOpenOptions.from(t)])).optional(),g.$VM.String.with("label","").optional()],g.$WM.Void),new g.$XM("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[g.$VM.Uri.with("resource","Resource to open"),g.$VM.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new g.$VM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[A.ViewColumn.from(t),void 0]:[A.ViewColumn.from(t.viewColumn),A.TextEditorOpenOptions.from(t)])).optional()],g.$WM.Void),new g.$XM("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[g.$VM.Uri.with("left","Left-hand side resource of the diff editor"),g.$VM.Uri.with("right","Right-hand side resource of the diff editor"),g.$VM.String.with("title","Human readable title for the diff editor").optional(),new g.$VM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[A.ViewColumn.from(t.viewColumn),A.TextEditorOpenOptions.from(t)]).optional()],g.$WM.Void),new g.$XM("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[g.$VM.Uri,g.$VM.Position],new g.$WM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(A.TypeHierarchyItem.to))),new g.$XM("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[g.$VM.TypeHierarchyItem],new g.$WM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(A.TypeHierarchyItem.to))),new g.$XM("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[g.$VM.TypeHierarchyItem],new g.$WM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(A.TypeHierarchyItem.to))),new g.$XM("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[g.$VM.TestItem],g.$WM.Void),new g.$XM("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[g.$VM.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],g.$WM.Void),new g.$XM("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[g.$VM.String.with("name","The context key name"),new g.$VM("value","The context key value",()=>!0,t=>t)],g.$WM.Void),new g.$XM("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[g.$VM.Uri,g.$VM.StringArray,new g.$VM("MappedEditsContext","Mapped Edits Context",t=>A.MappedEditsContext.is(t),t=>A.MappedEditsContext.from(t))],new g.$WM("A promise that resolves to a workspace edit or null",t=>t?A.WorkspaceEdit.to(t):null))];class v{static register(i){o.forEach(i.registerApiCommand,i),this.a(i)}static a(i){i.registerCommand(!1,"_validateWhenClauses",$.$Si)}}e.$0cc=v;function p(t){return i=>{if(Array.isArray(i))return i.map(t)}}function f(t){if(!Array.isArray(t))return;const i=[];for(const n of t)M.$it(n)?i.push(A.DefinitionLink.to(n)):i.push(A.location.to(n));return i}}),define(Ae[242],Re([1,0,12,67,5,6,2,80,22,8,7,3,23]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_cc=void 0;function v(p,f,t){const i=p.getProxy(S.$vK.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new D.$_l,f.registerArgumentProcessor({processArgument:m=>{if(m&&m.$mid===6){const I=this.b.get(m.handle);return I?I.value:m}else if(m&&m.$mid===7){const I=this.b.get(m.commentControlHandle);if(!I)return m;const k=I.getCommentThread(m.commentThreadHandle);return k?k.value:m}else if(m&&(m.$mid===9||m.$mid===8)){const I=this.b.get(m.thread.commentControlHandle);if(!I)return m;const k=I.getCommentThread(m.thread.commentThreadHandle);return k?m.$mid===8?k.value:{thread:k.value,text:m.text}:m}else if(m&&m.$mid===10){const I=this.b.get(m.thread.commentControlHandle);if(!I)return m;const k=I.getCommentThread(m.thread.commentThreadHandle);if(!k)return m;const d=m.commentUniqueId,b=k.getCommentByUniqueId(d);return b||m}else if(m&&m.$mid===11){const I=this.b.get(m.thread.commentControlHandle);if(!I)return m;const k=I.getCommentThread(m.thread.commentThreadHandle);if(!k)return m;const d=m.text,b=m.commentUniqueId,y=k.getCommentByUniqueId(b);return y?(typeof y.body=="string"?y.body=d:y.body=new A.$XK(d),y):m}return m}})}createCommentController(m,I,k){const d=n.a++,b=new a(m,d,I,k);this.b.set(b.handle,b);const y=this.c.get(m.identifier)||[];return y.push(b),this.c.set(m.identifier,y),b.value}async $createCommentThreadTemplate(m,I,k){const d=this.b.get(m);d&&d.$createCommentThreadTemplate(I,k)}async $updateCommentThreadTemplate(m,I,k){const d=this.b.get(m);d&&d.$updateCommentThreadTemplate(I,k)}$deleteCommentThread(m,I){this.b.get(m)?.$deleteCommentThread(I)}$provideCommentingRanges(m,I,k){const d=this.b.get(m);if(!d||!d.commentingRangeProvider)return Promise.resolve(void 0);const b=t.getDocument(R.URI.revive(I));return(0,E.$Ng)(async()=>{const y=await d.commentingRangeProvider.provideCommentingRanges(b,k);let C;return Array.isArray(y)?C={ranges:y,fileComments:!1}:y?C={ranges:y.ranges||[],fileComments:y.fileComments||!1}:C=y??void 0,C}).then(y=>{let C;return y&&(C={ranges:y.ranges.map(B=>g.Range.from(B)),fileComments:y.fileComments}),C})}$toggleReaction(m,I,k,d,b){const y=this.b.get(m);return!y||!y.reactionHandler?Promise.resolve(void 0):(0,E.$Ng)(()=>{const C=y.getCommentThread(I);if(C){const B=C.getCommentByUniqueId(d.uniqueIdInThread);if(y!==void 0&&B&&y.reactionHandler)return y.reactionHandler(B,s(b))}return Promise.resolve(void 0)})}}class u{static{this.a=0}set threadId(m){this.n=m}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(m){(m===void 0!=(this.p===void 0)||!m||!this.p||!m.isEqual(this.p))&&(this.p=m,this.b.range=m,this.c.fire())}get range(){return this.p}set canReply(m){this.d!==m&&(this.d=m,this.b.canReply=m,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(m){this.e=m,this.b.label=m,this.c.fire()}get contextValue(){return this.f}set contextValue(m){this.f=m,this.b.contextValue=m,this.c.fire()}get comments(){return this.q}set comments(m){this.q=m,this.b.comments=m,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(m){this.g=m,this.b.collapsibleState=m,this.c.fire()}get state(){return this.h}set state(m){this.h=m,this.b.state=m,this.c.fire()}get isDisposed(){return this.j}constructor(m,I,k,d,b,y,C,B){this.m=I,this.n=k,this.o=d,this.p=b,this.q=y,this.extensionDescription=C,this.r=B,this.handle=u.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new P.$Od,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new M.$Sc,this.l.value=new M.$Qc,this.n===void 0&&(this.n=`${m}.${this.handle}`),i.$createCommentThread(I,this.handle,this.n,this.o,g.Range.from(this.p),C.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=y,this.i.push({dispose:()=>{i.$deleteCommentThread(I,this.handle)}});const H=this;this.value={get uri(){return H.uri},get range(){return H.range},set range(U){H.range=U},get comments(){return H.comments},set comments(U){H.comments=U},get collapsibleState(){return H.collapsibleState},set collapsibleState(U){H.collapsibleState=U},get canReply(){return H.canReply},set canReply(U){H.canReply=U},get contextValue(){return H.contextValue},set contextValue(U){H.contextValue=U},get label(){return H.label},set label(U){H.label=U},get state(){return H.state},set state(U){H.state=U},dispose:()=>{H.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new M.$Qc);const m=k=>Object.prototype.hasOwnProperty.call(this.b,k),I={};m("range")&&(I.range=g.Range.from(this.p)),m("label")&&(I.label=this.label),m("contextValue")&&(I.contextValue=this.contextValue??null),m("comments")&&(I.comments=this.q.map(k=>l(this,k,this.k,this.extensionDescription))),m("collapsibleState")&&(I.collapseState=c(this.g)),m("canReply")&&(I.canReply=this.canReply),m("state")&&(I.state=h(this.h)),m("isTemplate")&&(I.isTemplate=this.r),this.b={},i.$updateCommentThread(this.m,this.handle,this.n,this.o,I)}getCommentByUniqueId(m){for(const I of this.k){const k=I[0],d=I[1];if(m===d)return k}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(m=>m.dispose())}}Ke([(0,L.$mh)(100)],u.prototype,"eventuallyUpdateCommentThread",null);class a{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(m){this.b=m,i.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(m){this.c=m,i.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!m})}get options(){return this.d}set options(m){this.d=m,i.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(m,I,k,d){this.f=m,this.g=I,this.h=k,this.i=d,this.a=new Map,i.$registerCommentController(this.handle,k,d,this.f.identifier.value);const b=this;this.value=Object.freeze({id:b.id,label:b.label,get options(){return b.options},set options(y){b.options=y},get commentingRangeProvider(){return b.commentingRangeProvider},set commentingRangeProvider(y){b.commentingRangeProvider=y},get reactionHandler(){return b.reactionHandler},set reactionHandler(y){b.reactionHandler=y},createCommentThread(y,C,B){return b.createCommentThread(y,C,B).value},dispose:()=>{b.dispose()}}),this.e=[],this.e.push({dispose:()=>{i.$unregisterCommentController(this.handle)}})}createCommentThread(m,I,k){I===void 0&&(0,o.$vF)(this.f,"fileComments");const d=new u(this.id,this.handle,void 0,m,I,k,this.f,!1);return this.a.set(d.handle,d),d}$createCommentThreadTemplate(m,I){const k=new u(this.id,this.handle,void 0,R.URI.revive(m),g.Range.to(I),[],this.f,!0);return k.collapsibleState=$.CommentThreadCollapsibleState.Expanded,this.a.set(k.handle,k),k}$updateCommentThreadTemplate(m,I){const k=this.a.get(m);k&&(k.range=g.Range.to(I))}$deleteCommentThread(m){this.a.get(m)?.dispose(),this.a.delete(m)}getCommentThread(m){return this.a.get(m)}dispose(){this.a.forEach(m=>{m.dispose()}),this.e.forEach(m=>m.dispose())}}function l(w,m,I,k){let d=I.get(m);return d||(d=++w.commentHandle,I.set(m,d)),m.state!==void 0&&(0,o.$vF)(k,"commentsDraftState"),{mode:m.mode,contextValue:m.contextValue,uniqueIdInThread:d,body:typeof m.body=="string"?m.body:g.MarkdownString.from(m.body),userName:m.author.name,userIconPath:m.author.iconPath,label:m.label,commentReactions:m.reactions?m.reactions.map(b=>r(b)):void 0,state:m.state,timestamp:m.timestamp?.toJSON()}}function r(w){return{label:w.label,iconPath:w.iconPath?g.$wM(w.iconPath):void 0,count:w.count,hasReacted:w.authorHasReacted}}function s(w){return{label:w.label||"",count:w.count||0,iconPath:w.iconPath?R.URI.revive(w.iconPath):"",authorHasReacted:w.hasReacted||!1}}function c(w){if(w!==void 0)switch(w){case A.CommentThreadCollapsibleState.Expanded:return $.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return $.CommentThreadCollapsibleState.Collapsed}return $.CommentThreadCollapsibleState.Collapsed}function h(w){if(w!==void 0)switch(w){case A.CommentThreadState.Unresolved:return $.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return $.CommentThreadState.Resolved}return $.CommentThreadState.Unresolved}return new n}e.$_cc=v}),define(Ae[243],Re([1,0,26,3,27,17]),function(pe,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0ec=void 0;let R=class{constructor(A,S){this.a=A.getProxy(L.$vK.MainThreadConsole),this.b=S.consoleForward.includeStack,this.c=S.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(A,S){const o=this,v=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){o.e(A,S,v,arguments)}})}e(A,S,o,v){this.a.$logExtensionHostMessage({type:"__$console",severity:S,arguments:D(v,this.b)}),this.c&&this.f(A,o,v)}};e.$0ec=R,e.$0ec=R=Ke([Ve(0,M.$xM),Ve(1,P.$NM)],R);const $=1e5;function D(g,A){const S=[];if(g.length)for(let o=0;o<g.length;o++){let v=g[o];if(typeof v>"u")v="undefined";else if(v instanceof Error){const p=v;p.stack?v=p.stack:v=p.toString()}S.push(v)}if(A){const o=new Error().stack;o&&S.push({__$stack:o.split(`
`).slice(3).join(`
`)})}try{const o=(0,E.$dn)(S);return o.length>$?"Output omitted for a large object that exceeds the limits":o}catch(o){return`Output omitted for an object that cannot be inspected ('${o.toString()}')`}}}),define(Ae[110],Re([1,0,2,3,7,4,17,15,18,13,19,23]),function(pe,e,E,L,P,M,R,$,D,g,A,S){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$bec=e.$aec=void 0;let v=class{static{o=this}static{this.c=0}static{this.d=250}constructor(f,t){this.h=t,this.f=new Map,this.g=f.getProxy(L.$vK.MainThreadDecorations)}registerFileDecorationProvider(f,t){const i=o.c++;this.f.set(i,{provider:f,extensionDescription:t}),this.g.$registerDecorationProvider(i,t.identifier.value);const n=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(u=>{if(!u){this.g.$onDidChange(i,null);return}const a=(0,D.$2b)(u);if(a.length<=o.d){this.g.$onDidChange(i,a);return}this.h.warn("[Decorations] CAPPING events from decorations provider",t.identifier.value,a.length);const l=a.map(c=>({uri:c,rank:(0,g.$He)(c.path,"/")})),r=(0,D.$yb)(l,(c,h)=>c.rank-h.rank||(0,g.$Ve)(c.uri.path,h.uri.path)),s=[];e:for(const c of r){let h;for(const w of c){const m=(0,A.$lc)(w.uri.path);if(h!==m&&(h=m,s.push(w.uri)>=o.d))break e}}this.g.$onDidChange(i,s)});return new P.$xK(()=>{n?.dispose(),this.g.$unregisterDecorationProvider(i),this.f.delete(i)})}async $provideDecorations(f,t,i){if(!this.f.has(f))return Object.create(null);const n=Object.create(null),{provider:u,extensionDescription:a}=this.f.get(f);return await Promise.all(t.map(async l=>{try{const{uri:r,id:s}=l,c=await Promise.resolve(u.provideFileDecoration(E.URI.revive(r),i));if(!c)return;try{P.$SL.validate(c),c.badge&&typeof c.badge!="string"&&(0,S.$vF)(a,"codiconDecoration"),n[s]=[c.propagate,c.tooltip,c.badge,c.color]}catch(h){this.h.warn(`INVALID decoration from extension '${a.identifier.value}': ${h}`)}}catch(r){this.h.error(r)}})),n}};e.$aec=v,e.$aec=v=o=Ke([Ve(0,R.$xM),Ve(1,$.$bj)],v),e.$bec=(0,M.$Th)("IExtHostDecorations")}),define(Ae[244],Re([1,0,159,98,2,3,7,8,5,15,28,42]),function(pe,e,E,L,P,M,R,$,D,g,A,S){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$5cc=e.$4cc=void 0;class v{#e;#t;#i;constructor(t,i,n,u,a,l,r,s){this.d=t,this.e=i,this.f=n,this.g=u,this.h=a,this.c=!1,this.f=Math.max(u,n),this.#i=new A.$zc(c=>l.getComparisonKey(c)),this.#e=r,this.#t=s}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(t,i){if(!t){this.clear();return}this.j();let n=[];if(P.URI.isUri(t)){if(!i){this.delete(t);return}this.#i.set(t,i.slice()),n=[t]}else if(Array.isArray(t)){n=[];let l;t=[...t].sort(v.k);for(const r of t){const[s,c]=r;if((!l||s.toString()!==l.toString())&&(l&&this.#i.get(l).length===0&&this.#i.delete(l),l=s,n.push(s),this.#i.set(s,[])),c)this.#i.get(s)?.push(...c);else{const h=this.#i.get(s);h&&(h.length=0)}}}if(this.#t.fire(n),!this.#e)return;const u=[];let a=0;for(const l of n){let r=[];const s=this.#i.get(l);if(s)if(s.length>this.g){r=[];const c=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let h=0;h<4;h++)for(const w of s)if(w.severity===c[h]&&r.push({...$.Diagnostic.from(w),modelVersionId:this.h(l)})===this.g)break e;r.push({severity:L.MarkerSeverity.Info,message:(0,E.localize)(0,null,s.length-this.g),startLineNumber:r[r.length-1].startLineNumber,startColumn:r[r.length-1].startColumn,endLineNumber:r[r.length-1].endLineNumber,endColumn:r[r.length-1].endColumn})}else r=s.map(c=>({...$.Diagnostic.from(c),modelVersionId:this.h(l)}));if(u.push([l,r]),a+=r.length,a>this.f)break}this.#e.$changeMany(this.e,u)}delete(t){this.j(),this.#t.fire([t]),this.#i.delete(t),this.#e?.$changeMany(this.e,[[t,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(t,i){this.j();for(const[n,u]of this)t.call(i,n,u,this)}*[Symbol.iterator](){this.j();for(const t of this.#i.keys())yield[t,this.get(t)]}get(t){this.j();const i=this.#i.get(t);return Array.isArray(i)?Object.freeze(i.slice(0)):[]}has(t){return this.j(),Array.isArray(this.#i.get(t))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(t,i){return t[0].toString()<i[0].toString()?-1:t[0].toString()>i[0].toString()?1:0}}e.$4cc=v;let p=class{static{o=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*o.d}static _mapper(t){const i=new A.$zc;for(const n of t)i.set(n,n);return{uris:Object.freeze(Array.from(i.values()))}}constructor(t,i,n,u){this.j=i,this.k=n,this.l=u,this.g=new Map,this.h=new D.$Sd({merge:a=>a.flat(),delay:50}),this.onDidChangeDiagnostics=D.Event.map(this.h.event,o._mapper),this.f=t.getProxy(M.$vK.MainThreadDiagnostics)}createDiagnosticCollection(t,i){const{g:n,f:u,h:a,j:l,k:r,l:s}=this,c=new class{$changeMany(m,I){u.$changeMany(m,I),l.trace("[DiagnosticCollection] change many (extension, owner, uris)",t.value,m,I.length===0?"CLEARING":I)}$clear(m){u.$clear(m),l.trace("[DiagnosticCollection] remove all (extension, owner)",t.value,m)}dispose(){u.dispose()}};let h;if(!i)i="_generated_diagnostic_collection_name_#"+o.c++,h=i;else if(!n.has(i))h=i;else{this.j.warn(`DiagnosticCollection with name '${i}' does already exist.`);do h=i+o.c++;while(n.has(h))}return new class extends v{constructor(){super(i,h,o.e,o.d,m=>s.getDocument(m)?.version,r.extUri,c,a),n.set(h,this)}dispose(){super.dispose(),n.delete(h)}}}getDiagnostics(t){if(t)return this.m(t);{const i=new Map,n=[];for(const u of this.g.values())u.forEach((a,l)=>{let r=i.get(a.toString());typeof r>"u"&&(r=n.length,i.set(a.toString(),r),n.push([a,[]])),n[r][1]=n[r][1].concat(...l)});return n}}m(t){let i=[];for(const n of this.g.values())n.has(t)&&(i=i.concat(n.get(t)));return i}$acceptMarkersChange(t){if(!this.n){const i="_generated_mirror",n=new v(i,i,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,u=>{},this.k.extUri,void 0,this.h);this.g.set(i,n),this.n=n}for(const[i,n]of t)this.n.set(P.URI.revive(i),n.map($.Diagnostic.to))}};e.$5cc=p,e.$5cc=p=o=Ke([Ve(1,g.$bj),Ve(2,S.$3cc)],p)}),define(Ae[245],Re([1,0,2,3,23]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hdc=void 0;class M{constructor($){this.a=$.getProxy(L.$vK.MainThreadDialogs)}showOpenDialog($,D){return D?.allowUIResources&&(0,P.$vF)($,"showLocal"),this.a.$showOpenDialog(D).then(g=>g?g.map(A=>E.URI.revive(A)):void 0)}showSaveDialog($){return this.a.$showSaveDialog($).then(D=>D?E.URI.revive(D):void 0)}}e.$hdc=M}),define(Ae[246],Re([1,0,11,2,7,3,14,20,13]),function(pe,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$idc=void 0;class g{static{this.a=0}constructor(S,o,v){this.d=o,this.e=v,this.b=new Map,this.c=S.getProxy(M.$vK.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(S,o){if(Object.keys(R.Schemas).indexOf(S)>=0)throw new Error(`scheme '${S}' already registered`);const v=g.a++;this.b.set(v,o),this.c.$registerTextContentProvider(v,S);let p;return typeof o.onDidChange=="function"&&(p=o.onDidChange(f=>{if(f.scheme!==S){this.e.warn(`Provider for scheme '${S}' is firing event for schema '${f.scheme}' which will be IGNORED`);return}this.d.getDocument(f)&&this.$provideTextDocumentContent(v,f).then(t=>{if(!t&&typeof t!="string")return;const i=this.d.getDocument(f);if(!i)return;const n=(0,D.$Qe)(t);if(!i.equalLines(n))return this.c.$onVirtualDocumentChange(f,t)},E.$Z)})),new P.$xK(()=>{this.b.delete(v)&&this.c.$unregisterTextContentProvider(v),p&&(p.dispose(),p=void 0)})}$provideTextDocumentContent(S,o){const v=this.b.get(S);return v?Promise.resolve(v.provideTextDocumentContent(L.URI.revive(o),$.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${o.scheme}`))}}e.$idc=g}),define(Ae[247],Re([1,0,5,6,2,3,103,8,16,26,7,11]),function(pe,e,E,L,P,M,R,$,D,g,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1cc=void 0;class o{constructor(p,f){this.a=new E.$Od({onListenerError:S.$1}),this.b=new E.$Od({onListenerError:S.$1}),this.c=new E.$Od({onListenerError:S.$1}),this.d=new E.$Od({onListenerError:S.$1}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new L.$Qc,this.h=new Map,this.f=p.getProxy(M.$vK.MainThreadDocuments),this.g=f,this.g.onDidRemoveDocuments(t=>{for(const i of t)this.b.fire(i.document)},void 0,this.e),this.g.onDidAddDocuments(t=>{for(const i of t)this.a.fire(i.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(p){if(!p)return;const f=this.g.getDocument(p);if(f)return f}getDocument(p){const f=this.getDocumentData(p);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${p}'`);return f.document}ensureDocumentData(p){const f=this.g.getDocument(p);if(f)return Promise.resolve(f);let t=this.h.get(p.toString());return t||(t=this.f.$tryOpenDocument(p).then(i=>{this.h.delete(p.toString());const n=P.URI.revive(i);return(0,D.$Kf)(this.g.getDocument(n))},i=>(this.h.delete(p.toString()),Promise.reject(i))),this.h.set(p.toString(),t)),t}createDocumentData(p){return this.f.$tryCreateDocument(p).then(f=>P.URI.revive(f))}$acceptModelLanguageChanged(p,f){const t=P.URI.revive(p),i=this.g.getDocument(t);if(!i)throw new Error("unknown document");this.b.fire(i.document),i._acceptLanguageId(f),this.a.fire(i.document)}$acceptModelSaved(p){const f=P.URI.revive(p),t=this.g.getDocument(f);if(!t)throw new Error("unknown document");this.$acceptDirtyStateChanged(p,!1),this.d.fire(t.document)}$acceptDirtyStateChanged(p,f){const t=P.URI.revive(p),i=this.g.getDocument(t);if(!i)throw new Error("unknown document");i._acceptIsDirty(f),this.c.fire({document:i.document,contentChanges:[],reason:void 0})}$acceptModelChanged(p,f,t){const i=P.URI.revive(p),n=this.g.getDocument(i);if(!n)throw new Error("unknown document");n._acceptIsDirty(t),n.onEvents(f);let u;f.isUndoing?u=A.TextDocumentChangeReason.Undo:f.isRedoing&&(u=A.TextDocumentChangeReason.Redo),this.c.fire((0,g.$_m)({document:n.document,contentChanges:f.changes.map(a=>({range:$.Range.to(a.range),rangeOffset:a.rangeOffset,rangeLength:a.rangeLength,text:a.text})),reason:u}))}setWordDefinitionFor(p,f){(0,R.$zM)(p,f)}}e.$1cc=o}),define(Ae[62],Re([1,0,55,5,6,2,4,3,103,17,109,8,15,28,14,68,44]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IM=e.$HM=void 0;class i{constructor(a){this.value=a,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let n=class{constructor(a,l){this.h=a,this.i=l,this.a=null,this.b=new Map,this.c=new v.$zc,this.d=new L.$Od,this.e=new L.$Od,this.f=new L.$Od,this.g=new L.$Od,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(a){this.acceptDocumentsAndEditorsDelta(a)}acceptDocumentsAndEditorsDelta(a){const l=[],r=[],s=[];if(a.removedDocuments)for(const c of a.removedDocuments){const h=M.URI.revive(c),w=this.c.get(h);w?.unref()&&(this.c.delete(h),l.push(w.value))}if(a.addedDocuments)for(const c of a.addedDocuments){const h=M.URI.revive(c.uri);let w=this.c.get(h);if(w&&h.scheme!==p.Schemas.vscodeNotebookCell&&h.scheme!==p.Schemas.vscodeInteractiveInput)throw new Error(`document '${h} already exists!'`);w||(w=new i(new D.$AM(this.h.getProxy($.$vK.MainThreadDocuments),h,c.lines,c.EOL,c.versionId,c.languageId,c.isDirty,c.notebook)),this.c.set(h,w),r.push(w.value)),w.ref()}if(a.removedEditors)for(const c of a.removedEditors){const h=this.b.get(c);this.b.delete(c),h&&s.push(h)}if(a.addedEditors)for(const c of a.addedEditors){const h=M.URI.revive(c.documentUri);E.ok(this.c.has(h),`document '${h}' does not exist`),E.ok(!this.b.has(c.id),`editor '${c.id}' already exists!`);const w=this.c.get(h).value,m=new A.$GM(c.id,this.h.getProxy($.$vK.MainThreadTextEditors),this.i,new t.$U(()=>w.document),c.selections.map(S.Selection.to),c.options,c.visibleRanges.map(I=>S.Range.to(I)),typeof c.editorPosition=="number"?S.ViewColumn.to(c.editorPosition):void 0);this.b.set(c.id,m)}a.newActiveEditor!==void 0&&(E.ok(a.newActiveEditor===null||this.b.has(a.newActiveEditor),`active editor '${a.newActiveEditor}' does not exist`),this.a=a.newActiveEditor),(0,P.$Mc)(l),(0,P.$Mc)(s),a.removedDocuments&&this.e.fire(l),a.addedDocuments&&this.d.fire(r),(a.removedEditors||a.addedEditors)&&this.f.fire(this.allEditors().map(c=>c.value)),a.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(a){return this.c.get(a)?.value}allDocuments(){return f.Iterable.map(this.c.values(),a=>a.value)}getEditor(a){return this.b.get(a)}activeEditor(a){if(!this.a)return;const l=this.b.get(this.a);return a?l:l?.value}allEditors(){return[...this.b.values()]}};e.$HM=n,e.$HM=n=Ke([Ve(0,g.$xM),Ve(1,o.$bj)],n),e.$IM=(0,R.$Th)("IExtHostDocumentsAndEditors")}),define(Ae[63],Re([1,0,248,5,16,2,4,3,17,8,7]),function(pe,e,E,L,P,M,R,$,D,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gec=e.$fec=void 0,e.$fec=(0,R.$Th)("IExtHostEditorTabs");class S{constructor(t,i,n){this.e=n,this.d=i,this.acceptDtoUpdate(t)}get apiObject(){if(!this.a){const t=this,i={get isActive(){return t.b.id===t.e()},get label(){return t.b.label},get input(){return t.c},get isDirty(){return t.b.isDirty},get isPinned(){return t.b.isPinned},get isPreview(){return t.b.isPreview},get group(){return t.d.apiObject}};this.a=Object.freeze(i)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(t){this.b=t,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.$cM(M.URI.revive(this.b.input.uri));case 2:return new A.$dM(M.URI.revive(this.b.input.original),M.URI.revive(this.b.input.modified));case 3:return new A.$eM(M.URI.revive(this.b.input.base),M.URI.revive(this.b.input.input1),M.URI.revive(this.b.input.input2),M.URI.revive(this.b.input.result));case 6:return new A.$fM(M.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.$gM(this.b.input.viewType);case 4:return new A.$hM(M.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.$iM(M.URI.revive(this.b.input.original),M.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.$jM;case 9:return new A.$kM(M.URI.revive(this.b.input.uri),M.URI.revive(this.b.input.inputBoxUri));case 10:return new A.$lM(this.b.input.providerId);default:return}}}class o{constructor(t,i){this.c=[],this.d="",this.b=t,this.e=i;for(const n of t.tabs)n.isActive&&(this.d=n.id),this.c.push(new S(n,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const t=this,i={get isActive(){return t.b.groupId===t.e()},get viewColumn(){return g.ViewColumn.to(t.b.viewColumn)},get activeTab(){return t.c.find(n=>n.tabId===t.d)?.apiObject},get tabs(){return Object.freeze(t.c.map(n=>n.apiObject))}};this.a=Object.freeze(i)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(t){this.b=t}acceptTabOperation(t){if(t.kind===0){const n=new S(t.tabDto,this,()=>this.activeTabId());return this.c.splice(t.index,0,n),t.tabDto.isActive&&(this.d=n.tabId),n}else if(t.kind===1){const n=this.c.splice(t.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${t.index} which does not exist`);return n.tabId===this.d&&(this.d=""),n}else if(t.kind===3){if(t.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this.c.splice(t.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${t.oldIndex} which does not exist`);return this.c.splice(t.index,0,n),n}const i=this.c.find(n=>n.tabId===t.tabDto.id);if(!i)throw new Error("INVALID tab");return t.tabDto.isActive?this.d=t.tabDto.id:this.d===t.tabDto.id&&!t.tabDto.isActive&&(this.d=""),i.acceptDtoUpdate(t.tabDto),i}activeTabId(){return this.d}}let v=class{constructor(t){this.b=new L.$Od,this.c=new L.$Od,this.e=[],this.a=t.getProxy($.$vK.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const t=this,i={onDidChangeTabGroups:t.c.event,onDidChangeTabs:t.b.event,get all(){return Object.freeze(t.e.map(n=>n.apiObject))},get activeTabGroup(){const n=t.d;return(0,P.$Kf)(t.e.find(a=>a.groupId===n)?.apiObject)},close:async(n,u)=>{const a=Array.isArray(n)?n:[n];return a.length?p(a[0])?this.j(a,u):this.i(a,u):!0}};this.f=Object.freeze(i)}return this.f}$acceptEditorTabModel(t){const i=new Set(this.e.map(c=>c.groupId)),n=new Set(t.map(c=>c.groupId)),u=(0,E.$K)(i,n),a=this.e.filter(c=>u.removed.includes(c.groupId)).map(c=>c.apiObject),l=[],r=[];this.e=t.map(c=>{const h=new o(c,()=>this.d);return u.added.includes(h.groupId)?l.push(h.apiObject):r.push(h.apiObject),h});const s=(0,P.$Kf)(t.find(c=>c.isActive===!0)?.groupId);s!==void 0&&this.d!==s&&(this.d=s),this.c.fire(Object.freeze({opened:l,closed:a,changed:r}))}$acceptTabGroupUpdate(t){const i=this.e.find(n=>n.groupId===t.groupId);if(!i)throw new Error("Update Group IPC call received before group creation.");i.acceptGroupDtoUpdate(t),t.isActive&&(this.d=t.groupId),this.c.fire(Object.freeze({changed:[i.apiObject],opened:[],closed:[]}))}$acceptTabOperation(t){const i=this.e.find(u=>u.groupId===t.groupId);if(!i)throw new Error("Update Tabs IPC call received before group creation.");const n=i.acceptTabOperation(t);switch(t.kind){case 0:this.b.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}g(t){for(const i of this.e)for(const n of i.tabs)if(n.apiObject===t)return n}h(t){return this.e.find(i=>i.apiObject===t)}async i(t,i){const n=[];for(const u of t){const a=this.g(u);if(!a)throw new Error("Tab close: Invalid tab not found!");n.push(a.tabId)}return this.a.$closeTab(n,i)}async j(t,i){const n=[];for(const u of t){const a=this.h(u);if(!a)throw new Error("Group close: Invalid group not found!");n.push(a.groupId)}return this.a.$closeGroup(n,i)}};e.$gec=v,e.$gec=v=Ke([Ve(0,D.$xM)],v);function p(f){return f.tabs!==void 0}}),define(Ae[249],Re([1,0,3,7]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ec=void 0;class P{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(E.$vK.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,$,D){if(this.a.size===0)throw new Error("No embedding vector providers registered");const g=this.a.get(R);if(!g)throw new Error("Embedding vector provider not found");const A=await g.provideEmbeddingVector($,D);if(!A)throw new Error("Embedding vector provider returned undefined");return A}registerEmbeddingVectorProvider(R,$,D){const g=this.b;return this.b++,this.a.set(g,D),this.c.$registerAiEmbeddingVectorProvider($,g),new L.$xK(()=>{this.c.$unregisterAiEmbeddingVectorProvider(g),this.a.delete(g)})}}e.$5ec=P}),define(Ae[250],Re([1,0,2,3,6,7,8,298,13,24,23,53]),function(pe,e,E,L,P,M,R,$,D,g,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Odc=void 0;class o{constructor(){this.a=[]}add(f){this.b=void 0,this.a.push(f)}delete(f){const t=this.a.indexOf(f);t>=0&&(this.a.splice(t,1),this.b=void 0)}c(){if(!this.b){const f=this.a.sort(),t=[];let i,n,u=14,a=14;for(const l of f){let r=i?(0,D.$5e)(i,l):0;for(r===0?n=1:n=a;r<l.length;r++)r+1===l.length?(u=a,a=9):a+=1,t.push([n,l.toUpperCase().charCodeAt(r),a]),t.push([n,l.toLowerCase().charCodeAt(r),a]),n=a;i=l,a=u}t.push([9,58,10]),t.push([10,47,12]),this.b=new $.$yZ(t)}}provideDocumentLinks(f){this.c();const t=[],i=$.$zZ.computeLinks({getLineContent(n){return f.lineAt(n-1).text},getLineCount(){return f.lineCount}},this.b);for(const n of i){const u=R.DocumentLink.to(n);u.target&&t.push(u)}return t}}class v{constructor(f,t){this.i=t,this.b=new o,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=f.getProxy(L.$vK.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(f,t,i,n={}){if(v.j(i),this.d.has(t))throw new Error(`a provider for the scheme '${t}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(f,"*",this.b));const u=this.h++;this.b.add(t),this.d.add(t),this.c.set(u,i);let a=2;n.isCaseSensitive&&(a+=1024),n.isReadonly&&(a+=2048),typeof i.copy=="function"&&(a+=8),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,A.$vF)(f,"fsChunks"),a+=4);let l;n.isReadonly&&(0,S.$9j)(n.isReadonly)&&((0,A.$vF)(f,"readonlyMessage"),l={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(u,t,a,l).catch(s=>{console.error(`FAILED to register filesystem provider of ${f.identifier.value}-extension for the scheme ${t}`),console.error(s)});const r=i.onDidChangeFile(s=>{const c=[];for(const h of s){const{uri:w,type:m}=h;if(w.scheme!==t)continue;let I;switch(m){case M.FileChangeType.Changed:I=0;break;case M.FileChangeType.Created:I=1;break;case M.FileChangeType.Deleted:I=2;break;default:throw new Error("Unknown FileChangeType")}c.push({resource:w,type:I})}this.a.$onFileSystemChange(u,c)});return(0,P.$Pc)(()=>{r.dispose(),this.b.delete(t),this.d.delete(t),this.c.delete(u),this.a.$unregisterProvider(u)})}static j(f){if(!f)throw new Error("MISSING provider");if(typeof f.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof f.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof f.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof f.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof f.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof f.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof f.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof f.rename!="function")throw new Error("Provider does NOT implement rename")}static k(f){const{type:t,ctime:i,mtime:n,size:u,permissions:a}=f;return{type:t,ctime:i,mtime:n,size:u,permissions:a}}$stat(f,t){return Promise.resolve(this.l(f).stat(E.URI.revive(t))).then(i=>v.k(i))}$readdir(f,t){return Promise.resolve(this.l(f).readDirectory(E.URI.revive(t)))}$readFile(f,t){return Promise.resolve(this.l(f).readFile(E.URI.revive(t))).then(i=>g.$ce.wrap(i))}$writeFile(f,t,i,n){return Promise.resolve(this.l(f).writeFile(E.URI.revive(t),i.buffer,n))}$delete(f,t,i){return Promise.resolve(this.l(f).delete(E.URI.revive(t),i))}$rename(f,t,i,n){return Promise.resolve(this.l(f).rename(E.URI.revive(t),E.URI.revive(i),n))}$copy(f,t,i,n){const u=this.l(f);if(!u.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(u.copy(E.URI.revive(t),E.URI.revive(i),n))}$mkdir(f,t){return Promise.resolve(this.l(f).createDirectory(E.URI.revive(t)))}$watch(f,t,i,n){const u=this.l(f).watch(E.URI.revive(i),n);this.f.set(t,u)}$unwatch(f,t){const i=this.f.get(t);i&&(i.dispose(),this.f.delete(t))}$open(f,t,i){const n=this.l(f);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(E.URI.revive(t),i))}$close(f,t){const i=this.l(f);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(t))}$read(f,t,i,n){const u=this.l(f);if(!u.read)throw new Error('FileSystemProvider does not implement "read"');const a=g.$ce.alloc(n);return Promise.resolve(u.read(t,i,a.buffer,0,n)).then(l=>a.slice(0,l))}$write(f,t,i,n){const u=this.l(f);if(!u.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(u.write(t,i,n.buffer,0,n.byteLength))}l(f){const t=this.c.get(f);if(!t){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return t}}e.$Odc=v}),define(Ae[64],Re([1,0,3,41,7,24,4,17,42,6,12,25,14]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$vdc=e.$udc=void 0;let p=v=class{constructor(t,i){this.b=new Map,this.c=new A.$5g,this.a=t.getProxy(E.$vK.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(u){try{let a;const l=n.b.get(u.scheme);return l?(await n.a.$ensureActivation(u.scheme),a=await l.impl.stat(u)):a=await n.a.$stat(u),{type:a.type,ctime:a.ctime,mtime:a.mtime,size:a.size,permissions:a.permissions===L.FilePermission.Readonly?1:void 0}}catch(a){v.e(a)}},async readDirectory(u){try{const a=n.b.get(u.scheme);return a?(await n.a.$ensureActivation(u.scheme),(await a.impl.readDirectory(u)).slice()):await n.a.$readdir(u)}catch(a){return v.e(a)}},async createDirectory(u){try{const a=n.b.get(u.scheme);return a&&!a.isReadonly?(await n.a.$ensureActivation(u.scheme),await n.d(a.impl,a.extUri,u)):await n.a.$mkdir(u)}catch(a){return v.e(a)}},async readFile(u){try{const a=n.b.get(u.scheme);return a?(await n.a.$ensureActivation(u.scheme),(await a.impl.readFile(u)).slice()):(await n.a.$readFile(u)).buffer}catch(a){return v.e(a)}},async writeFile(u,a){try{const l=n.b.get(u.scheme);return l&&!l.isReadonly?(await n.a.$ensureActivation(u.scheme),await n.d(l.impl,l.extUri,l.extUri.dirname(u)),await n.c.queueFor(u).queue(()=>Promise.resolve(l.impl.writeFile(u,a,{create:!0,overwrite:!0})))):await n.a.$writeFile(u,M.$ce.wrap(a))}catch(l){return v.e(l)}},async delete(u,a){try{const l=n.b.get(u.scheme);return l&&!l.isReadonly?(await n.a.$ensureActivation(u.scheme),await l.impl.delete(u,{recursive:!1,...a})):await n.a.$delete(u,{recursive:!1,useTrash:!1,atomic:!1,...a})}catch(l){return v.e(l)}},async rename(u,a,l){try{return await n.a.$rename(u,a,{overwrite:!1,...l})}catch(r){return v.e(r)}},async copy(u,a,l){try{return await n.a.$copy(u,a,{overwrite:!1,...l})}catch(r){return v.e(r)}},isWritableFileSystem(u){const a=i.getCapabilities(u);if(typeof a=="number")return!(a&2048)}})}async d(t,i,n){const u=[];for(;!i.isEqual(n,i.dirname(n));)try{if(!((await t.stat(n)).type&L.FileType.Directory))throw P.$KL.FileExists(`Unable to create folder '${n.scheme===o.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(a){if(L.$sk(a)!==L.FileSystemProviderErrorCode.FileNotFound)throw a;u.push(i.basename(n)),n=i.dirname(n)}for(let a=u.length-1;a>=0;a--){n=i.joinPath(n,u[a]);try{await t.createDirectory(n)}catch(l){if(L.$sk(l)!==L.FileSystemProviderErrorCode.FileExists)throw l}}}static e(t){if(t instanceof P.$KL)throw t;if(t instanceof L.$ok)switch(t.code){case L.FileSystemProviderErrorCode.FileExists:throw P.$KL.FileExists(t.message);case L.FileSystemProviderErrorCode.FileNotFound:throw P.$KL.FileNotFound(t.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw P.$KL.FileNotADirectory(t.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw P.$KL.FileIsADirectory(t.message);case L.FileSystemProviderErrorCode.NoPermissions:throw P.$KL.NoPermissions(t.message);case L.FileSystemProviderErrorCode.Unavailable:throw P.$KL.Unavailable(t.message);default:throw new P.$KL(t.message,t.name)}if(!(t instanceof Error))throw new P.$KL(String(t));if(t.name==="ENOPRO"||t.message.includes("ENOPRO"))throw P.$KL.Unavailable(t.message);switch(t.name){case L.FileSystemProviderErrorCode.FileExists:throw P.$KL.FileExists(t.message);case L.FileSystemProviderErrorCode.FileNotFound:throw P.$KL.FileNotFound(t.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw P.$KL.FileNotADirectory(t.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw P.$KL.FileIsADirectory(t.message);case L.FileSystemProviderErrorCode.NoPermissions:throw P.$KL.NoPermissions(t.message);case L.FileSystemProviderErrorCode.Unavailable:throw P.$KL.Unavailable(t.message);default:throw new P.$KL(t.message,t.name)}}addFileSystemProvider(t,i,n){return this.b.set(t,{impl:i,extUri:n?.isCaseSensitive?S.$mg:S.$og,isReadonly:!!n?.isReadonly}),(0,g.$Pc)(()=>this.b.delete(t))}getFileSystemProviderExtUri(t){return this.b.get(t)?.extUri??S.$mg}};e.$udc=p,e.$udc=p=v=Ke([Ve(0,$.$xM),Ve(1,D.$3cc)],p),e.$vdc=(0,R.$Th)("IExtHostConsumerFileSystem")}),define(Ae[251],Re([1,0,5,33,2,3,8,7,44]),function(pe,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pdc=void 0;class g{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(v,p,f,t,i,n){this.a=Math.random(),this.b=new E.$Od,this.c=new E.$Od,this.d=new E.$Od,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const u=(0,L.$Aj)(i),a=typeof i=="string",l=n?.correlate,r=t(s=>{if(!(typeof s.session=="number"&&s.session!==this.a)&&!(l&&typeof s.session>"u")){if(!n?.ignoreCreateEvents)for(const c of s.created){const h=P.URI.revive(c);u(h.fsPath)&&(!a||p.getWorkspaceFolder(h))&&this.b.fire(h)}if(!n?.ignoreChangeEvents)for(const c of s.changed){const h=P.URI.revive(c);u(h.fsPath)&&(!a||p.getWorkspaceFolder(h))&&this.c.fire(h)}if(!n?.ignoreDeleteEvents)for(const c of s.deleted){const h=P.URI.revive(c);u(h.fsPath)&&(!a||p.getWorkspaceFolder(h))&&this.d.fire(h)}}});this.g=$.$xK.from(this.i(v,f,i,n,n?.correlate),this.b,this.c,this.d,r)}i(v,p,f,t,i){const n=$.$xK.from();if(typeof f=="string")return n;const u=v.getProxy(M.$vK.MainThreadFileSystemEventService);let a=!1;return(f.pattern.includes(L.$wj)||f.pattern.includes(L.$xj))&&(a=!0),u.$watch(p.identifier.value,this.a,f.baseUri,{recursive:a,excludes:t?.excludes??[]},!!i),$.$xK.from({dispose:()=>u.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class A{constructor(v){this.a=v,this.session=this.a.session,this.b=new D.$U(()=>this.a.created.map(P.URI.revive)),this.c=new D.$U(()=>this.a.changed.map(P.URI.revive)),this.d=new D.$U(()=>this.a.deleted.map(P.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class S{constructor(v,p,f){this.j=v,this.k=p,this.l=f,this.a=new E.$Od,this.b=new E.$Od,this.c=new E.$Od,this.d=new E.$Od,this.g=new E.$Qd,this.h=new E.$Qd,this.i=new E.$Qd,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(v,p,f,t){return new g(this.j,v,p,this.a.event,R.GlobPattern.from(f),t)}$onFileEvent(v){this.a.fire(new A(v))}$onDidRunFileOperation(v,p){switch(v){case 2:this.b.fire(Object.freeze({files:p.map(f=>({oldUri:P.URI.revive(f.source),newUri:P.URI.revive(f.target)}))}));break;case 1:this.d.fire(Object.freeze({files:p.map(f=>P.URI.revive(f.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:p.map(f=>P.URI.revive(f.target))}));break;default:}}getOnWillRenameFileEvent(v){return this.m(v,this.g)}getOnWillCreateFileEvent(v){return this.m(v,this.h)}getOnWillDeleteFileEvent(v){return this.m(v,this.i)}m(v,p){return(f,t,i)=>{const n=function(a){f.call(t,a)};return n.extension=v,p.event(n,void 0,i)}}async $onWillRunFileOperation(v,p,f,t){switch(v){case 2:return await this.n(this.g,{files:p.map(i=>({oldUri:P.URI.revive(i.source),newUri:P.URI.revive(i.target)}))},f,t);case 1:return await this.n(this.i,{files:p.map(i=>P.URI.revive(i.target))},f,t);case 0:case 3:return await this.n(this.h,{files:p.map(i=>P.URI.revive(i.target))},f,t)}}async n(v,p,f,t){const i=new Set,n=[];if(await v.fireAsync(p,t,async(a,l)=>{const r=Date.now(),s=await Promise.resolve(a);s instanceof $.$HK&&(n.push([l.extension,s]),i.add(l.extension.displayName??l.extension.identifier.value)),Date.now()-r>f&&this.k.warn("SLOW file-participant",l.extension.identifier)}),t.isCancellationRequested||n.length===0)return;const u={edits:[]};for(const[,a]of n){const{edits:l}=R.WorkspaceEdit.from(a,{getTextDocumentVersion:r=>this.l.getDocument(r)?.version,getNotebookDocumentVersion:()=>{}});u.edits=u.edits.concat(l)}return{edit:u,extensionNames:Array.from(i)}}}e.$Pdc=S}),define(Ae[252],Re([1,0,6,2,3,8,7,32,12]),function(pe,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wec=void 0;class g{static{this.a=0}constructor(v,p){this.extension=v,this.provider=p,this.handle=g.a++}}class A{constructor(v){this.session=v,this.responses=[]}}class S{static{this.a=0}constructor(v,p,f,t){this.f=f,this.g=t,this.b=new Map,this.d=new Map,this.e=v.getProxy(P.$vK.MainThreadInlineChat),p.registerApiCommand(new $.$XM("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new $.$VM("Run arguments","",i=>!0,i=>{if(i)return{initialRange:i.initialRange?M.Range.from(i.initialRange):void 0,initialSelection:i.initialSelection?M.Selection.from(i.initialSelection):void 0,message:i.message,autoSend:i.autoSend,position:i.position?M.Position.from(i.position):void 0}})],$.$WM.Void))}registerProvider(v,p,f){const t=new g(v,p);return this.b.set(t.handle,t),this.e.$registerInteractiveEditorProvider(t.handle,f.label,v.identifier.value,typeof p.handleInteractiveEditorResponseFeedback=="function"),(0,E.$Pc)(()=>{this.e.$unregisterInteractiveEditorProvider(t.handle),this.b.delete(t.handle)})}async $prepareSession(v,p,f,t){const i=this.b.get(v);if(!i){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const n=this.f.getDocument(L.URI.revive(p)),u=M.Selection.to(f),a=await i.provider.prepareInteractiveEditorSession({document:n,selection:u},t);if(!a)return;if(a.wholeRange&&!a.wholeRange.contains(u))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const l=S.a++;return this.d.set(l,new A(a)),{id:l,placeholder:a.placeholder,input:a.input,slashCommands:a.slashCommands?.map(r=>({command:r.command,detail:r.detail,refer:r.refer,executeImmediately:r.executeImmediately})),wholeRange:M.Range.from(a.wholeRange),message:a.message}}async $provideResponse(v,p,f,t){const i=this.b.get(v);if(!i)return;const n=this.d.get(p.id);if(!n)return;const u={prompt:f.prompt,selection:M.Selection.to(f.selection),wholeRange:M.Range.to(f.wholeRange),attempt:f.attempt,live:f.live};let a=!1;const l={report:async m=>{if(!f.live&&m.edits?.length)throw new Error("Progress reporting is only supported for live sessions");a||t.isCancellationRequested||await this.e.$handleProgressChunk(f.requestId,{message:m.message,edits:m.edits?.map(M.TextEdit.from),editsShouldBeInstant:m.editsShouldBeInstant,slashCommand:m.slashCommand?.command,markdownFragment:R.$XK.isMarkdownString(m.content)?m.content.value:m.content})}},r=Promise.resolve(i.provider.provideInteractiveEditorResponse(n.session,u,l,t));let s;try{s=await(0,D.$Jg)(r,t)}finally{a=!0}if(!s)return;const c=n.responses.push(s)-1,h={wholeRange:M.Range.from(s.wholeRange),placeholder:s.placeholder};if(S.h(s))return{...h,id:c,type:"message",message:M.MarkdownString.from(s.contents)};const{edits:w}=s;return w instanceof R.$HK?{...h,id:c,type:"bulkEdit",edits:M.WorkspaceEdit.from(w)}:{...h,id:c,type:"editorEdit",edits:w.map(M.TextEdit.from)}}$handleFeedback(v,p,f,t){const i=this.b.get(v),n=this.d.get(p),u=n?.responses[f];if(i&&u){const a=M.InteractiveEditorResponseFeedbackKind.to(t);i.provider.handleInteractiveEditorResponseFeedback?.(n.session,u,a)}}$releaseSession(v,p){}static h(v){return typeof v=="object"&&typeof v.contents=="object"}}e.$Wec=S}),define(Ae[253],Re([1,0,2,32]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sec=void 0;class P{constructor(R,$,D,g,A){this.a=$,this.b=D,this.c=g;const S=new L.$XM("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new L.$VM("showOptions","Show Options",o=>!0,o=>o),new L.$VM("resource","Interactive resource Uri",o=>!0,o=>o),new L.$VM("controllerId","Notebook controller Id",o=>!0,o=>o),new L.$VM("title","Interactive editor title",o=>!0,o=>o)],new L.$WM("Notebook and input URI",o=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",o.notebookEditorId),o.notebookEditorId!==void 0){const v=this.a.getEditorById(o.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",v.id),{notebookUri:E.URI.revive(o.notebookUri),inputUri:E.URI.revive(o.inputUri),notebookEditor:v.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",o.notebookUri,o.inputUri),{notebookUri:E.URI.revive(o.notebookUri),inputUri:E.URI.revive(o.inputUri)}}));this.c.registerApiCommand(S)}$willAddInteractiveDocument(R,$,D,g){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:$,lines:[""],languageId:D,uri:R,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(E.URI.revive(g))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,$){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$Sec=P}),define(Ae[254],Re([1,0,3,7]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yec=void 0;class P{constructor(R){this.a=new Map,this.b=new Map,this.c=R.getProxy(E.$vK.MainThreadIssueReporter)}async $getIssueReporterUri(R,$){if(this.a.size===0)throw new Error("No issue request handlers registered");const D=this.a.get(R);if(!D)throw new Error("Issue request handler not found");const g=await D.handleIssueUrlRequest();if(!g)throw new Error("Issue request handler returned no result");return g}async $getIssueReporterData(R,$){if(this.b.size===0)throw new Error("No issue request handlers registered");const D=this.b.get(R);if(!D)throw new Error("Issue data provider not found");const g=await D.provideIssueData($);if(!g)throw new Error("Issue data provider returned no result");return g}async $getIssueReporterTemplate(R,$){if(this.b.size===0)throw new Error("No issue request handlers registered");const D=this.b.get(R);if(!D)throw new Error("Issue data provider not found");const g=await D.provideIssueTemplate($);if(!g)throw new Error("Issue template provider returned no result");return g}registerIssueUriRequestHandler(R,$){const D=R.identifier.value;return this.a.set(D,$),this.c.$registerIssueUriRequestHandler(D),new L.$xK(()=>{this.c.$unregisterIssueUriRequestHandler(D),this.a.delete(D)})}registerIssueDataProvider(R,$){const D=R.identifier.value;return this.b.set(D,$),this.c.$registerIssueDataProvider(D),new L.$xK(()=>{this.c.$unregisterIssueDataProvider(D),this.b.delete(D)})}}e.$Yec=P}),define(Ae[255],Re([1,0,6,3]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_dc=void 0;class P{constructor(R){this.b=0,this.a=R.getProxy(L.$vK.MainThreadLabelService)}$registerResourceLabelFormatter(R){const $=this.b++;return this.a.$registerResourceLabelFormatter($,R),(0,E.$Pc)(()=>{this.a.$unregisterResourceLabelFormatter($)})}}e.$_dc=P}),define(Ae[256],Re([1,0,2,26,8,7,80,3,13,29,18,16,299,20,22,6,95,89,75,50,11,12,23,161]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f,t,i,n,u,a,l,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9cc=void 0;class c{constructor(T,V){this.d=T,this.e=V}async provideDocumentSymbols(T,V){const G=this.d.getDocument(T),Q=await this.e.provideDocumentSymbols(G,V);if(!(0,A.$Jb)(Q))return Q[0]instanceof M.$PK?Q.map(P.DocumentSymbol.from):c.f(Q)}static f(T){T=T.slice(0).sort((Q,q)=>{let _=Q.location.range.start.compareTo(q.location.range.start);return _===0&&(_=q.location.range.end.compareTo(Q.location.range.end)),_});const V=[],G=[];for(const Q of T){const q={name:Q.name||"!!MISSING: name!!",kind:P.SymbolKind.from(Q.kind),tags:Q.tags?.map(P.SymbolTag.from)||[],detail:"",containerName:Q.containerName,range:P.Range.from(Q.location.range),selectionRange:P.Range.from(Q.location.range),children:[]};for(;;){if(G.length===0){G.push(q),V.push(q);break}const _=G[G.length-1];if(g.$xs.containsRange(_.range,q.range)&&!g.$xs.equalsRange(_.range,q.range)){_.children?.push(q),G.push(q);break}G.pop()}}return V}}class h{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(T,V,G){this.g=T,this.h=V,this.j=G,this.e=new n.$Zcc("CodeLens"),this.f=new Map}async provideCodeLenses(T,V){const G=this.g.getDocument(T),Q=await this.j.provideCodeLenses(G,V);if(!Q||V.isCancellationRequested)return;const q=this.e.add(Q),_=new f.$Qc;this.f.set(q,_);const he={cacheId:q,lenses:[]};for(let Oe=0;Oe<Q.length;Oe++)he.lenses.push({cacheId:[q,Oe],range:P.Range.from(Q[Oe].range),command:this.h.toInternal(Q[Oe].command,_)});return he}async resolveCodeLens(T,V){const G=T.cacheId&&this.e.get(...T.cacheId);if(!G)return;let Q;if(typeof this.j.resolveCodeLens!="function"||G.isResolved?Q=G:Q=await this.j.resolveCodeLens(G,V),Q||(Q=G),V.isCancellationRequested)return;const q=T.cacheId&&this.f.get(T.cacheId[0]);if(q)return T.command=this.h.toInternal(Q.command??h.d,q),T}releaseCodeLenses(T){this.f.get(T)?.dispose(),this.f.delete(T),this.e.delete(T)}}function w(Ie){return Array.isArray(Ie)?Ie.map(P.DefinitionLink.from):Ie?[P.DefinitionLink.from(Ie)]:[]}class m{constructor(T,V){this.d=T,this.e=V}async provideDefinition(T,V,G){const Q=this.d.getDocument(T),q=P.Position.to(V),_=await this.e.provideDefinition(Q,q,G);return w(_)}}class I{constructor(T,V){this.d=T,this.e=V}async provideDeclaration(T,V,G){const Q=this.d.getDocument(T),q=P.Position.to(V),_=await this.e.provideDeclaration(Q,q,G);return w(_)}}class k{constructor(T,V){this.d=T,this.e=V}async provideImplementation(T,V,G){const Q=this.d.getDocument(T),q=P.Position.to(V),_=await this.e.provideImplementation(Q,q,G);return w(_)}}class d{constructor(T,V){this.d=T,this.e=V}async provideTypeDefinition(T,V,G){const Q=this.d.getDocument(T),q=P.Position.to(V),_=await this.e.provideTypeDefinition(Q,q,G);return w(_)}}class b{constructor(T,V){this.d=T,this.e=V}async provideHover(T,V,G){const Q=this.d.getDocument(T),q=P.Position.to(V),_=await this.e.provideHover(Q,q,G);if(!(!_||(0,A.$Jb)(_.contents)))return _.range||(_.range=Q.getWordRangeAtPosition(q)),_.range||(_.range=new M.$zK(q,q)),P.Hover.from(_)}}class y{constructor(T,V){this.d=T,this.e=V}async provideEvaluatableExpression(T,V,G){const Q=this.d.getDocument(T),q=P.Position.to(V),_=await this.e.provideEvaluatableExpression(Q,q,G);if(_)return P.EvaluatableExpression.from(_)}}class C{constructor(T,V){this.d=T,this.e=V}async provideInlineValues(T,V,G,Q){const q=this.d.getDocument(T),_=await this.e.provideInlineValues(q,P.Range.to(V),P.InlineValueContext.to(G),Q);if(Array.isArray(_))return _.map(he=>P.InlineValue.from(he))}}class B{constructor(T,V){this.d=T,this.e=V}async provideDocumentHighlights(T,V,G){const Q=this.d.getDocument(T),q=P.Position.to(V),_=await this.e.provideDocumentHighlights(Q,q,G);if(Array.isArray(_))return _.map(P.DocumentHighlight.from)}}class H{constructor(T,V){this.d=T,this.e=V}async provideLinkedEditingRanges(T,V,G){const Q=this.d.getDocument(T),q=P.Position.to(V),_=await this.e.provideLinkedEditingRanges(Q,q,G);if(_&&Array.isArray(_.ranges))return{ranges:(0,A.$Gb)(_.ranges.map(P.Range.from)),wordPattern:_.wordPattern}}}class U{constructor(T,V){this.d=T,this.e=V}async provideReferences(T,V,G,Q){const q=this.d.getDocument(T),_=P.Position.to(V),he=await this.e.provideReferences(q,_,G,Q);if(Array.isArray(he))return he.map(P.location.from)}}class z{static{this.d=1e3}constructor(T,V,G,Q,q,_,he){this.g=T,this.h=V,this.j=G,this.k=Q,this.l=q,this.m=_,this.n=he,this.e=new n.$Zcc("CodeAction"),this.f=new Map}async provideCodeActions(T,V,G,Q){const q=this.g.getDocument(T),_=o.$zs.isISelection(V)?P.Selection.to(V):P.Range.to(V),he=[];for(const Ye of this.j.getDiagnostics(T))if(_.intersection(Ye.range)&&he.push(Ye)>z.d)break;const Oe={diagnostics:he,only:G.only?new M.$RK(G.only):void 0,triggerKind:P.CodeActionTriggerKind.to(G.trigger)},je=await this.k.provideCodeActions(q,_,Oe,Q);if(!(0,A.$Kb)(je)||Q.isCancellationRequested)return;const Qe=this.e.add(je),Ge=new f.$Qc;this.f.set(Qe,Ge);const _e=[];for(let Ye=0;Ye<je.length;Ye++){const xe=je[Ye];xe&&(z.o(xe)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),_e.push({_isSynthetic:!0,title:xe.title,command:this.h.toInternal(xe,Ge)})):(Oe.only&&(xe.kind?Oe.only.contains(xe.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Oe.only.value} 'requested but returned code action is of kind '${xe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Oe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),_e.push({cacheId:[Qe,Ye],title:xe.title,command:xe.command&&this.h.toInternal(xe.command,Ge),diagnostics:xe.diagnostics&&xe.diagnostics.map(P.Diagnostic.from),edit:xe.edit&&P.WorkspaceEdit.from(xe.edit,void 0),kind:xe.kind&&xe.kind.value,isPreferred:xe.isPreferred,isAI:(0,r.$uF)(this.m,"codeActionAI")?xe.isAI:!1,disabled:xe.disabled?.reason})))}return{cacheId:Qe,actions:_e}}async resolveCodeAction(T,V){const[G,Q]=T,q=this.e.get(G,Q);if(!q||z.o(q))return{};if(!this.k.resolveCodeAction)return{};const _=await this.k.resolveCodeAction(q,V)??q;let he;_.edit&&(he=P.WorkspaceEdit.from(_.edit,void 0));let Oe;if(_.command){const je=this.f.get(G);je&&(Oe=this.h.toInternal(_.command,je))}return{edit:he,command:Oe}}releaseCodeActions(T){this.f.get(T)?.dispose(),this.f.delete(T),this.e.delete(T)}static o(T){return typeof T.command=="string"&&typeof T.title=="string"}}class F{static toInternalProviderId(T,V){return T+"."+V}constructor(T,V,G,Q,q){this.d=T,this.e=V,this.f=G,this.g=Q,this.h=q}async prepareDocumentPaste(T,V,G,Q){if(!this.f.prepareDocumentPaste)return;const q=this.e.getDocument(T),_=V.map(je=>P.Range.to(je)),he=P.DataTransfer.toDataTransfer(G,()=>{throw new a.$0});if(await this.f.prepareDocumentPaste(q,_,he,Q),Q.isCancellationRequested)return;const Oe=Array.from(he).filter(([,je])=>!(je instanceof M.$lL));return P.DataTransfer.from(Oe)}async providePasteEdits(T,V,G,Q,q){if(!this.f.provideDocumentPasteEdits)return;const _=this.e.getDocument(V),he=G.map(Qe=>P.Range.to(Qe)),Oe=P.DataTransfer.toDataTransfer(Q,async Qe=>(await this.d.$resolvePasteFileData(this.g,T,Qe)).buffer),je=await this.f.provideDocumentPasteEdits(_,he,Oe,q);if(je)return{label:je.label??(0,s.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:je.yieldTo?.map(Qe=>"mimeType"in Qe?Qe:{providerId:F.toInternalProviderId(Qe.extensionId,Qe.providerId)}),insertText:typeof je.insertText=="string"?je.insertText:{snippet:je.insertText.value},additionalEdit:je.additionalEdit?P.WorkspaceEdit.from(je.additionalEdit,void 0):void 0}}}class N{constructor(T,V){this.d=T,this.e=V}async provideDocumentFormattingEdits(T,V,G){const Q=this.d.getDocument(T),q=await this.e.provideDocumentFormattingEdits(Q,V,G);if(Array.isArray(q))return q.map(P.TextEdit.from)}}class x{constructor(T,V){this.d=T,this.e=V}async provideDocumentRangeFormattingEdits(T,V,G,Q){const q=this.d.getDocument(T),_=P.Range.to(V),he=await this.e.provideDocumentRangeFormattingEdits(q,_,G,Q);if(Array.isArray(he))return he.map(P.TextEdit.from)}async provideDocumentRangesFormattingEdits(T,V,G,Q){(0,S.$Jf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const q=this.d.getDocument(T),_=V.map(P.Range.to),he=await this.e.provideDocumentRangesFormattingEdits(q,_,G,Q);if(Array.isArray(he))return he.map(P.TextEdit.from)}}class J{constructor(T,V){this.d=T,this.e=V,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(T,V,G,Q,q){const _=this.d.getDocument(T),he=P.Position.to(V),Oe=await this.e.provideOnTypeFormattingEdits(_,he,G,Q,q);if(Array.isArray(Oe))return Oe.map(P.TextEdit.from)}}class ye{constructor(T,V){this.e=T,this.f=V,this.d=new n.$Zcc("WorkspaceSymbols")}async provideWorkspaceSymbols(T,V){const G=await this.e.provideWorkspaceSymbols(T,V);if(!(0,A.$Kb)(G))return{symbols:[]};const Q=this.d.add(G),q={cacheId:Q,symbols:[]};for(let _=0;_<G.length;_++){const he=G[_];if(!he||!he.name){this.f.warn("INVALID SymbolInformation",he);continue}q.symbols.push({...P.WorkspaceSymbol.from(he),cacheId:[Q,_]})}return q}async resolveWorkspaceSymbol(T,V){if(typeof this.e.resolveWorkspaceSymbol!="function"||!T.cacheId)return T;const G=this.d.get(...T.cacheId);if(G){const Q=await this.e.resolveWorkspaceSymbol(G,V);return Q&&(0,L.$bn)(T,P.WorkspaceSymbol.from(Q),!0)}}releaseWorkspaceSymbols(T){this.d.delete(T)}}class De{static supportsResolving(T){return typeof T.prepareRename=="function"}constructor(T,V,G){this.d=T,this.e=V,this.f=G}async provideRenameEdits(T,V,G,Q){const q=this.d.getDocument(T),_=P.Position.to(V);try{const he=await this.e.provideRenameEdits(q,_,G,Q);return he?P.WorkspaceEdit.from(he):void 0}catch(he){const Oe=De.g(he);return Oe?{rejectReason:Oe,edits:void 0}:Promise.reject(he)}}async resolveRenameLocation(T,V,G){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const Q=this.d.getDocument(T),q=P.Position.to(V);try{const _=await this.e.prepareRename(Q,q,G);let he,Oe;if(M.$zK.isRange(_)?(he=_,Oe=Q.getText(_)):(0,S.$Bf)(_)&&(he=_.range,Oe=_.placeholder),!he||!Oe)return;if(he.start.line>q.line||he.end.line<q.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:P.Range.from(he),text:Oe}}catch(_){const he=De.g(_);return he?{rejectReason:he,range:void 0,text:void 0}:Promise.reject(_)}}static g(T){return typeof T=="string"?T:T instanceof Error&&typeof T.message=="string"?T.message:void 0}}class Ce{constructor(T,V){this.resultId=T,this.tokens=V}}class ge{constructor(T,V){this.f=T,this.g=V,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(T,V,G){const Q=this.f.getDocument(T),q=V!==0?this.d.get(V):null;let _=typeof q?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(Q,q.resultId,G):await this.g.provideDocumentSemanticTokens(Q,G);return q&&this.d.delete(V),_?(_=ge.h(_),this.o(ge.n(q,_),_)):null}async releaseDocumentSemanticColoring(T){this.d.delete(T)}static h(T){return ge.j(T)?ge.k(T)?T:new M.$OL(new Uint32Array(T.data),T.resultId):ge.l(T)?ge.m(T)?T:new M.$QL(T.edits.map(V=>new M.$PL(V.start,V.deleteCount,V.data?new Uint32Array(V.data):V.data)),T.resultId):T}static j(T){return T&&!!T.data}static k(T){return T.data instanceof Uint32Array}static l(T){return T&&Array.isArray(T.edits)}static m(T){for(const V of T.edits)if(!(V.data instanceof Uint32Array))return!1;return!0}static n(T,V){if(!ge.j(V)||!T||!T.tokens)return V;const G=T.tokens,Q=G.length,q=V.data,_=q.length;let he=0;const Oe=Math.min(Q,_);for(;he<Oe&&G[he]===q[he];)he++;if(he===Q&&he===_)return new M.$QL([],V.resultId);let je=0;const Qe=Oe-he;for(;je<Qe&&G[Q-je-1]===q[_-je-1];)je++;return new M.$QL([{start:he,deleteCount:Q-he-je,data:q.subarray(he,_-je)}],V.resultId)}o(T,V){if(ge.j(T)){const G=this.e++;return this.d.set(G,new Ce(T.resultId,T.data)),(0,t.$t$)({id:G,type:"full",data:T.data})}if(ge.l(T)){const G=this.e++;return ge.j(V)?this.d.set(G,new Ce(V.resultId,V.data)):this.d.set(G,new Ce(T.resultId)),(0,t.$t$)({id:G,type:"delta",deltas:(T.edits||[]).map(Q=>({start:Q.start,deleteCount:Q.deleteCount,data:Q.data}))})}return null}}class we{constructor(T,V){this.d=T,this.e=V}async provideDocumentRangeSemanticTokens(T,V,G){const Q=this.d.getDocument(T),q=await this.e.provideDocumentRangeSemanticTokens(Q,P.Range.to(V),G);return q?this.f(q):null}f(T){return(0,t.$t$)({id:0,type:"full",data:T.data})}}class re{static supportsResolving(T){return typeof T.resolveCompletionItem=="function"}constructor(T,V,G,Q,q){this.f=T,this.g=V,this.h=G,this.j=Q,this.k=q,this.d=new n.$Zcc("CompletionItem"),this.e=new Map}async provideCompletionItems(T,V,G,Q){const q=this.f.getDocument(T),_=P.Position.to(V),he=q.getWordRangeAtPosition(_)||new M.$zK(_,_),Oe=he.with({end:_}),je=new u.$Kd,Qe=await this.h.provideCompletionItems(q,_,Q,P.CompletionContext.to(G));if(!Qe||Q.isCancellationRequested)return;const Ge=Array.isArray(Qe)?new M.$5K(Qe):Qe,_e=re.supportsResolving(this.h)?this.d.add(Ge.items):this.d.add([]),Ye=new f.$Qc;this.e.set(_e,Ye);const xe=[],it={x:_e,b:xe,a:{replace:P.Range.from(he),insert:P.Range.from(Oe)},c:Ge.isIncomplete||void 0,d:je.elapsed()};for(let tt=0;tt<Ge.items.length;tt++){const ze=Ge.items[tt],ut=this.l(ze,[_e,tt],Oe,he);xe.push(ut)}return it}async resolveCompletionItem(T,V){if(typeof this.h.resolveCompletionItem!="function")return;const G=this.d.get(...T);if(!G)return;const Q=this.l(G,T),q=await this.h.resolveCompletionItem(G,V);if(!q)return;const _=this.l(q,T);return(Q.h!==_.h||Q.i!==_.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(Q.n!==_.n||Q.o!==_.o||!(0,L.$cn)(Q.p,_.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...Q,d:_.d,c:_.c,l:_.l,h:_.h,i:_.i,n:_.n,o:_.o,p:_.p}}releaseCompletionItems(T){this.e.get(T)?.dispose(),this.e.delete(T),this.d.delete(T)}l(T,V,G,Q){const q=this.e.get(V[0]);if(!q)throw Error("DisposableStore is missing...");const _=this.g.toInternal(T.command,q),he={x:V,a:T.label,b:T.kind!==void 0?P.CompletionItemKind.from(T.kind):void 0,m:T.tags&&T.tags.map(P.CompletionItemTag.from),c:T.detail,d:typeof T.documentation>"u"?void 0:P.MarkdownString.fromStrict(T.documentation),e:T.sortText!==T.label?T.sortText:void 0,f:T.filterText!==T.label?T.filterText:void 0,g:T.preselect||void 0,i:T.keepWhitespace?1:0,k:T.commitCharacters?.join(""),l:T.additionalTextEdits&&T.additionalTextEdits.map(P.TextEdit.from),n:_?.$ident,o:_?.id,p:_?.$ident?void 0:_?.arguments};T.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),he.h=T.textEdit.newText):typeof T.insertText=="string"?he.h=T.insertText:T.insertText instanceof M.$IK&&(he.h=T.insertText.value,he.i|=4);let Oe;return T.textEdit?Oe=T.textEdit.range:T.range&&(Oe=T.range),M.$zK.isRange(Oe)?he.j=P.Range.from(Oe):Oe&&(!G?.isEqual(Oe.inserting)||!Q?.isEqual(Oe.replacing))&&(he.j={insert:P.Range.from(Oe.inserting),replace:P.Range.from(Oe.replacing)}),he}}class oe{async provideInlineCompletions(T,V,G,Q){}disposeCompletions(T){}handleDidShowCompletionItem(T,V,G){}handlePartialAccept(T,V,G){}}class ve extends oe{constructor(T,V,G,Q){super(),this.f=T,this.g=V,this.h=G,this.j=Q,this.d=new ee,this.e=(0,r.$uF)(this.f,"inlineCompletionsAdditions"),this.k={[R.InlineCompletionTriggerKind.Automatic]:M.InlineCompletionTriggerKind.Automatic,[R.InlineCompletionTriggerKind.Explicit]:M.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,r.$uF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(T,V,G,Q){const q=this.g.getDocument(T),_=P.Position.to(V),he=await this.h.provideInlineCompletionItems(q,_,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:P.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[G.triggerKind]},Q);if(!he||Q.isCancellationRequested)return;const Oe=Array.isArray(he)?he:he.items,je=this.e?Array.isArray(he)?[]:he.commands||[]:[],Qe=this.e&&!Array.isArray(he)?he.enableForwardStability:void 0;let Ge;return{pid:this.d.createReferenceId({dispose(){Ge?.dispose()},items:Oe}),items:Oe.map((Ye,xe)=>{let it;Ye.command&&(Ge||(Ge=new f.$Qc),it=this.j.toInternal(Ye.command,Ge));const tt=Ye.insertText;return{insertText:typeof tt=="string"?tt:{snippet:tt.value},filterText:Ye.filterText,range:Ye.range?P.Range.from(Ye.range):void 0,command:it,idx:xe,completeBracketPairs:this.e?Ye.completeBracketPairs:!1}}),commands:je.map(Ye=>(Ge||(Ge=new f.$Qc),this.j.toInternal(Ye,Ge))),suppressSuggestions:!1,enableForwardStability:Qe}}disposeCompletions(T){this.d.disposeReferenceId(T)?.dispose()}handleDidShowCompletionItem(T,V,G){const Q=this.d.get(T)?.items[V];Q&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(Q,G)}handlePartialAccept(T,V,G){const Q=this.d.get(T)?.items[V];Q&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(Q,G)}}class ee{constructor(){this.d=new Map,this.e=1}createReferenceId(T){const V=this.e++;return this.d.set(V,T),V}disposeReferenceId(T){const V=this.d.get(T);return this.d.delete(T),V}get(T){return this.d.get(T)}}class W{constructor(T,V){this.e=T,this.f=V,this.d=new n.$Zcc("SignatureHelp")}async provideSignatureHelp(T,V,G,Q){const q=this.e.getDocument(T),_=P.Position.to(V),he=this.g(G),Oe=await this.f.provideSignatureHelp(q,_,Q,he);if(Oe){const je=this.d.add([Oe]);return{...P.SignatureHelp.from(Oe),id:je}}}g(T){let V;if(T.activeSignatureHelp){const G=P.SignatureHelp.to(T.activeSignatureHelp),Q=this.d.get(T.activeSignatureHelp.id,0);Q?(V=Q,V.activeSignature=G.activeSignature,V.activeParameter=G.activeParameter):V=G}return{...T,activeSignatureHelp:V}}releaseSignatureHelp(T){this.d.delete(T)}}class ue{constructor(T,V,G,Q,q){this.f=T,this.g=V,this.h=G,this.j=Q,this.k=q,this.d=new n.$Zcc("InlayHints"),this.e=new Map}async provideInlayHints(T,V,G){const Q=this.f.getDocument(T),q=P.Range.to(V),_=await this.h.provideInlayHints(Q,q,G);if(!Array.isArray(_)||_.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${V}`);return}if(G.isCancellationRequested)return;const he=this.d.add(_);this.e.set(he,new f.$Qc);const Oe={hints:[],cacheId:he};for(let je=0;je<_.length;je++)this.l(_[je],q)&&Oe.hints.push(this.m(_[je],[he,je]));return this.j.trace(`[InlayHints] ${Oe.hints.length} inlay hints from '${this.k.identifier.value}' for ${V}`),Oe}async resolveInlayHint(T,V){if(typeof this.h.resolveInlayHint!="function")return;const G=this.d.get(...T);if(!G)return;const Q=await this.h.resolveInlayHint(G,V);if(Q&&this.l(Q))return this.m(Q,T)}releaseHints(T){this.e.get(T)?.dispose(),this.e.delete(T),this.d.delete(T)}l(T,V){return T.label.length===0||Array.isArray(T.label)&&T.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",T),!1):!(V&&!V.contains(T.position))}m(T,V){const G=this.e.get(V[0]);if(!G)throw Error("DisposableStore is missing...");const Q={label:"",cacheId:V,tooltip:P.MarkdownString.fromStrict(T.tooltip),position:P.Position.from(T.position),textEdits:T.textEdits&&T.textEdits.map(P.TextEdit.from),kind:T.kind&&P.InlayHintKind.from(T.kind),paddingLeft:T.paddingLeft,paddingRight:T.paddingRight};return typeof T.label=="string"?Q.label=T.label:Q.label=T.label.map(q=>{const _={label:q.value};return _.tooltip=P.MarkdownString.fromStrict(q.tooltip),M.$JK.isLocation(q.location)&&(_.location=P.location.from(q.location)),q.command&&(_.command=this.g.toInternal(q.command,G)),_}),Q}}class Pe{constructor(T,V){this.e=T,this.f=V,this.d=new n.$Zcc("DocumentLink")}async provideLinks(T,V){const G=this.e.getDocument(T),Q=await this.f.provideDocumentLinks(G,V);if(!(!Array.isArray(Q)||Q.length===0)&&!V.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:Q.filter(Pe.g).map(P.DocumentLink.from)};{const q=this.d.add(Q),_={links:[],cacheId:q};for(let he=0;he<Q.length;he++){if(!Pe.g(Q[he]))continue;const Oe=P.DocumentLink.from(Q[he]);Oe.cacheId=[q,he],_.links.push(Oe)}return _}}}static g(T){return T.target&&T.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(T,V){if(typeof this.f.resolveDocumentLink!="function")return;const G=this.d.get(...T);if(!G)return;const Q=await this.f.resolveDocumentLink(G,V);if(!(!Q||!Pe.g(Q)))return P.DocumentLink.from(Q)}releaseLinks(T){this.d.delete(T)}}class Ee{constructor(T,V){this.d=T,this.e=V}async provideColors(T,V){const G=this.d.getDocument(T),Q=await this.e.provideDocumentColors(G,V);return Array.isArray(Q)?Q.map(_=>({color:P.Color.from(_.color),range:P.Range.from(_.range)})):[]}async provideColorPresentations(T,V,G){const Q=this.d.getDocument(T),q=P.Range.to(V.range),_=P.Color.to(V.color),he=await this.e.provideColorPresentations(_,{document:Q,range:q},G);if(Array.isArray(he))return he.map(P.ColorPresentation.from)}}class te{constructor(T,V){this.d=T,this.e=V}async provideFoldingRanges(T,V,G){const Q=this.d.getDocument(T),q=await this.e.provideFoldingRanges(Q,V,G);if(Array.isArray(q))return q.map(P.FoldingRange.from)}}class se{constructor(T,V,G){this.d=T,this.e=V,this.f=G}async provideSelectionRanges(T,V,G){const Q=this.d.getDocument(T),q=V.map(P.Position.to),_=await this.e.provideSelectionRanges(Q,q,G);if(!(0,A.$Kb)(_))return[];if(_.length!==q.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const he=[];for(let Oe=0;Oe<q.length;Oe++){const je=[];he.push(je);let Qe=q[Oe],Ge=_[Oe];for(;;){if(!Ge.range.contains(Qe))throw new Error("INVALID selection range, must contain the previous range");if(je.push(P.SelectionRange.from(Ge)),!Ge.parent)break;Qe=Ge.range,Ge=Ge.parent}}return he}}class me{constructor(T,V){this.f=T,this.g=V,this.d=new i.$CM(""),this.e=new Map}async prepareSession(T,V,G){const Q=this.f.getDocument(T),q=P.Position.to(V),_=await this.g.prepareCallHierarchy(Q,q,G);if(!_)return;const he=this.d.nextId();return this.e.set(he,new Map),Array.isArray(_)?_.map(Oe=>this.h(he,Oe)):[this.h(he,_)]}async provideCallsTo(T,V,G){const Q=this.j(T,V);if(!Q)throw new Error("missing call hierarchy item");const q=await this.g.provideCallHierarchyIncomingCalls(Q,G);if(q)return q.map(_=>({from:this.h(T,_.from),fromRanges:_.fromRanges.map(he=>P.Range.from(he))}))}async provideCallsFrom(T,V,G){const Q=this.j(T,V);if(!Q)throw new Error("missing call hierarchy item");const q=await this.g.provideCallHierarchyOutgoingCalls(Q,G);if(q)return q.map(_=>({to:this.h(T,_.to),fromRanges:_.fromRanges.map(he=>P.Range.from(he))}))}releaseSession(T){this.e.delete(T)}h(T,V){const G=this.e.get(T),Q=P.CallHierarchyItem.from(V,T,G.size.toString(36));return G.set(Q._itemId,V),Q}j(T,V){return this.e.get(T)?.get(V)}}class Z{constructor(T,V){this.f=T,this.g=V,this.d=new i.$CM(""),this.e=new Map}async prepareSession(T,V,G){const Q=this.f.getDocument(T),q=P.Position.to(V),_=await this.g.prepareTypeHierarchy(Q,q,G);if(!_)return;const he=this.d.nextId();return this.e.set(he,new Map),Array.isArray(_)?_.map(Oe=>this.h(he,Oe)):[this.h(he,_)]}async provideSupertypes(T,V,G){const Q=this.j(T,V);if(!Q)throw new Error("missing type hierarchy item");const q=await this.g.provideTypeHierarchySupertypes(Q,G);if(q)return q.map(_=>this.h(T,_))}async provideSubtypes(T,V,G){const Q=this.j(T,V);if(!Q)throw new Error("missing type hierarchy item");const q=await this.g.provideTypeHierarchySubtypes(Q,G);if(q)return q.map(_=>this.h(T,_))}releaseSession(T){this.e.delete(T)}h(T,V){const G=this.e.get(T),Q=P.TypeHierarchyItem.from(V,T,G.size.toString(36));return G.set(Q._itemId,V),Q}j(T,V){return this.e.get(T)?.get(V)}}class le{static toInternalProviderId(T,V){return T+"."+V}constructor(T,V,G,Q,q){this.d=T,this.e=V,this.f=G,this.g=Q,this.h=q}async provideDocumentOnDropEdits(T,V,G,Q,q){const _=this.e.getDocument(V),he=P.Position.to(G),Oe=P.DataTransfer.toDataTransfer(Q,async Qe=>(await this.d.$resolveDocumentOnDropFileData(this.g,T,Qe)).buffer),je=await this.f.provideDocumentDropEdits(_,he,Oe,q);if(je)return{label:je.label??(0,s.localize)(1,null,this.h.displayName||this.h.name),yieldTo:je.yieldTo?.map(Qe=>"mimeType"in Qe?Qe:{providerId:le.toInternalProviderId(Qe.extensionId,Qe.providerId)}),insertText:typeof je.insertText=="string"?je.insertText:{snippet:je.insertText.value},additionalEdit:je.additionalEdit?P.WorkspaceEdit.from(je.additionalEdit,void 0):void 0}}}class ne{constructor(T,V){this.d=T,this.e=V}async provideMappedEdits(T,V,G,Q){const q=E.URI.revive(T),_=this.d.getDocument(q),he=G.documents.map(Qe=>Qe.map(Ge=>({uri:E.URI.revive(Ge.uri),version:Ge.version,ranges:Ge.ranges.map(_e=>P.Range.to(_e))}))),Oe={documents:he,selections:he[0]?.[0]?.ranges??[]},je=await this.e.provideMappedEdits(_,V,Oe,Q);return je?P.WorkspaceEdit.from(je):null}}class ae{constructor(T,V){this.adapter=T,this.extension=V}}class de{static{this.d=0}constructor(T,V,G,Q,q,_,he,Oe){this.g=V,this.h=G,this.j=Q,this.k=q,this.l=_,this.m=he,this.n=Oe,this.f=new Map,this.e=T.getProxy($.$vK.MainThreadLanguageFeatures)}o(T,V){return P.DocumentSelector.from(T,this.g,V)}p(T){return new M.$xK(()=>{this.f.delete(T),this.e.$unregister(T)})}q(){return de.d++}async s(T,V,G,Q,q,_=!1){const he=this.f.get(T);if(!he||!(he.adapter instanceof V))return Q;const Oe=Date.now();_||this.l.trace(`[${he.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const je=G(he.adapter,he.extension);return Promise.resolve(je).catch(Qe=>{(0,a.$3)(Qe)||(this.l.error(`[${he.extension.identifier.value}] provider FAILED`),this.l.error(Qe),this.n.onExtensionError(he.extension.identifier,Qe))}).finally(()=>{_||this.l.trace(`[${he.extension.identifier.value}] provider DONE after ${Date.now()-Oe}ms`)}),v.CancellationToken.isCancellationToken(q)?(0,l.$Kg)(je,q):je}t(T,V){const G=this.q();return this.f.set(G,new ae(T,V)),G}static u(T){return T.displayName||T.name}registerDocumentSymbolProvider(T,V,G,Q){const q=this.t(new c(this.h,G),T),_=Q&&Q.label||de.u(T);return this.e.$registerDocumentSymbolProvider(q,this.o(V,T),_),this.p(q)}$provideDocumentSymbols(T,V,G){return this.s(T,c,Q=>Q.provideDocumentSymbols(E.URI.revive(V),G),void 0,G)}registerCodeLensProvider(T,V,G){const Q=this.q(),q=typeof G.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(Q,new ae(new h(this.h,this.j.converter,G),T)),this.e.$registerCodeLensSupport(Q,this.o(V,T),q);let _=this.p(Q);if(q!==void 0){const he=G.onDidChangeCodeLenses(Oe=>this.e.$emitCodeLensEvent(q));_=M.$xK.from(_,he)}return _}$provideCodeLenses(T,V,G){return this.s(T,h,Q=>Q.provideCodeLenses(E.URI.revive(V),G),void 0,G)}$resolveCodeLens(T,V,G){return this.s(T,h,Q=>Q.resolveCodeLens(V,G),void 0,void 0)}$releaseCodeLenses(T,V){this.s(T,h,G=>Promise.resolve(G.releaseCodeLenses(V)),void 0,void 0)}registerDefinitionProvider(T,V,G){const Q=this.t(new m(this.h,G),T);return this.e.$registerDefinitionSupport(Q,this.o(V,T)),this.p(Q)}$provideDefinition(T,V,G,Q){return this.s(T,m,q=>q.provideDefinition(E.URI.revive(V),G,Q),[],Q)}registerDeclarationProvider(T,V,G){const Q=this.t(new I(this.h,G),T);return this.e.$registerDeclarationSupport(Q,this.o(V,T)),this.p(Q)}$provideDeclaration(T,V,G,Q){return this.s(T,I,q=>q.provideDeclaration(E.URI.revive(V),G,Q),[],Q)}registerImplementationProvider(T,V,G){const Q=this.t(new k(this.h,G),T);return this.e.$registerImplementationSupport(Q,this.o(V,T)),this.p(Q)}$provideImplementation(T,V,G,Q){return this.s(T,k,q=>q.provideImplementation(E.URI.revive(V),G,Q),[],Q)}registerTypeDefinitionProvider(T,V,G){const Q=this.t(new d(this.h,G),T);return this.e.$registerTypeDefinitionSupport(Q,this.o(V,T)),this.p(Q)}$provideTypeDefinition(T,V,G,Q){return this.s(T,d,q=>q.provideTypeDefinition(E.URI.revive(V),G,Q),[],Q)}registerHoverProvider(T,V,G,Q){const q=this.t(new b(this.h,G),T);return this.e.$registerHoverProvider(q,this.o(V,T)),this.p(q)}$provideHover(T,V,G,Q){return this.s(T,b,q=>q.provideHover(E.URI.revive(V),G,Q),void 0,Q)}registerEvaluatableExpressionProvider(T,V,G,Q){const q=this.t(new y(this.h,G),T);return this.e.$registerEvaluatableExpressionProvider(q,this.o(V,T)),this.p(q)}$provideEvaluatableExpression(T,V,G,Q){return this.s(T,y,q=>q.provideEvaluatableExpression(E.URI.revive(V),G,Q),void 0,Q)}registerInlineValuesProvider(T,V,G,Q){const q=typeof G.onDidChangeInlineValues=="function"?this.q():void 0,_=this.t(new C(this.h,G),T);this.e.$registerInlineValuesProvider(_,this.o(V,T),q);let he=this.p(_);if(q!==void 0){const Oe=G.onDidChangeInlineValues(je=>this.e.$emitInlineValuesEvent(q));he=M.$xK.from(he,Oe)}return he}$provideInlineValues(T,V,G,Q,q){return this.s(T,C,_=>_.provideInlineValues(E.URI.revive(V),G,Q,q),void 0,q)}registerDocumentHighlightProvider(T,V,G){const Q=this.t(new B(this.h,G),T);return this.e.$registerDocumentHighlightProvider(Q,this.o(V,T)),this.p(Q)}$provideDocumentHighlights(T,V,G,Q){return this.s(T,B,q=>q.provideDocumentHighlights(E.URI.revive(V),G,Q),void 0,Q)}registerLinkedEditingRangeProvider(T,V,G){const Q=this.t(new H(this.h,G),T);return this.e.$registerLinkedEditingRangeProvider(Q,this.o(V,T)),this.p(Q)}$provideLinkedEditingRanges(T,V,G,Q){return this.s(T,H,async q=>{const _=await q.provideLinkedEditingRanges(E.URI.revive(V),G,Q);if(_)return{ranges:_.ranges,wordPattern:_.wordPattern?de.w(_.wordPattern):void 0}},void 0,Q)}registerReferenceProvider(T,V,G){const Q=this.t(new U(this.h,G),T);return this.e.$registerReferenceSupport(Q,this.o(V,T)),this.p(Q)}$provideReferences(T,V,G,Q,q){return this.s(T,U,_=>_.provideReferences(E.URI.revive(V),G,Q,q),void 0,q)}registerCodeActionProvider(T,V,G,Q){const q=new f.$Qc,_=this.t(new z(this.h,this.j.converter,this.k,G,this.l,T,this.m),T);return this.e.$registerQuickFixSupport(_,this.o(V,T),{providedKinds:Q?.providedCodeActionKinds?.map(he=>he.value),documentation:Q?.documentation?.map(he=>({kind:he.kind.value,command:this.j.converter.toInternal(he.command,q)}))},de.u(T),!!G.resolveCodeAction),q.add(this.p(_)),q}$provideCodeActions(T,V,G,Q,q){return this.s(T,z,_=>_.provideCodeActions(E.URI.revive(V),G,Q,q),void 0,q)}$resolveCodeAction(T,V,G){return this.s(T,z,Q=>Q.resolveCodeAction(V,G),{},void 0)}$releaseCodeActions(T,V){this.s(T,z,G=>Promise.resolve(G.releaseCodeActions(V)),void 0,void 0)}registerDocumentFormattingEditProvider(T,V,G){const Q=this.t(new N(this.h,G),T);return this.e.$registerDocumentFormattingSupport(Q,this.o(V,T),T.identifier,T.displayName||T.name),this.p(Q)}$provideDocumentFormattingEdits(T,V,G,Q){return this.s(T,N,q=>q.provideDocumentFormattingEdits(E.URI.revive(V),G,Q),void 0,Q)}registerDocumentRangeFormattingEditProvider(T,V,G){const Q=typeof G.provideDocumentRangesFormattingEdits=="function",q=this.t(new x(this.h,G),T);return this.e.$registerRangeFormattingSupport(q,this.o(V,T),T.identifier,T.displayName||T.name,Q),this.p(q)}$provideDocumentRangeFormattingEdits(T,V,G,Q,q){return this.s(T,x,_=>_.provideDocumentRangeFormattingEdits(E.URI.revive(V),G,Q,q),void 0,q)}$provideDocumentRangesFormattingEdits(T,V,G,Q,q){return this.s(T,x,_=>_.provideDocumentRangesFormattingEdits(E.URI.revive(V),G,Q,q),void 0,q)}registerOnTypeFormattingEditProvider(T,V,G,Q){const q=this.t(new J(this.h,G),T);return this.e.$registerOnTypeFormattingSupport(q,this.o(V,T),Q,T.identifier),this.p(q)}$provideOnTypeFormattingEdits(T,V,G,Q,q,_){return this.s(T,J,he=>he.provideOnTypeFormattingEdits(E.URI.revive(V),G,Q,q,_),void 0,_)}registerWorkspaceSymbolProvider(T,V){const G=this.t(new ye(V,this.l),T);return this.e.$registerNavigateTypeSupport(G,typeof V.resolveWorkspaceSymbol=="function"),this.p(G)}$provideWorkspaceSymbols(T,V,G){return this.s(T,ye,Q=>Q.provideWorkspaceSymbols(V,G),{symbols:[]},G)}$resolveWorkspaceSymbol(T,V,G){return this.s(T,ye,Q=>Q.resolveWorkspaceSymbol(V,G),void 0,void 0)}$releaseWorkspaceSymbols(T,V){this.s(T,ye,G=>G.releaseWorkspaceSymbols(V),void 0,void 0)}registerRenameProvider(T,V,G){const Q=this.t(new De(this.h,G,this.l),T);return this.e.$registerRenameSupport(Q,this.o(V,T),De.supportsResolving(G)),this.p(Q)}$provideRenameEdits(T,V,G,Q,q){return this.s(T,De,_=>_.provideRenameEdits(E.URI.revive(V),G,Q,q),void 0,q)}$resolveRenameLocation(T,V,G,Q){return this.s(T,De,q=>q.resolveRenameLocation(E.URI.revive(V),G,Q),void 0,Q)}registerDocumentSemanticTokensProvider(T,V,G,Q){const q=this.t(new ge(this.h,G),T),_=typeof G.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(q,this.o(V,T),Q,_);let he=this.p(q);if(_){const Oe=G.onDidChangeSemanticTokens(je=>this.e.$emitDocumentSemanticTokensEvent(_));he=M.$xK.from(he,Oe)}return he}$provideDocumentSemanticTokens(T,V,G,Q){return this.s(T,ge,q=>q.provideDocumentSemanticTokens(E.URI.revive(V),G,Q),null,Q)}$releaseDocumentSemanticTokens(T,V){this.s(T,ge,G=>G.releaseDocumentSemanticColoring(V),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(T,V,G,Q){const q=this.t(new we(this.h,G),T);return this.e.$registerDocumentRangeSemanticTokensProvider(q,this.o(V,T),Q),this.p(q)}$provideDocumentRangeSemanticTokens(T,V,G,Q){return this.s(T,we,q=>q.provideDocumentRangeSemanticTokens(E.URI.revive(V),G,Q),null,Q)}registerCompletionItemProvider(T,V,G,Q){const q=this.t(new re(this.h,this.j.converter,G,this.m,T),T);return this.e.$registerCompletionsProvider(q,this.o(V,T),Q,re.supportsResolving(G),T.identifier),this.p(q)}$provideCompletionItems(T,V,G,Q,q){return this.s(T,re,_=>_.provideCompletionItems(E.URI.revive(V),G,Q,q),void 0,q)}$resolveCompletionItem(T,V,G){return this.s(T,re,Q=>Q.resolveCompletionItem(V,G),void 0,G)}$releaseCompletionItems(T,V){this.s(T,re,G=>G.releaseCompletionItems(V),void 0,void 0)}registerInlineCompletionsProvider(T,V,G,Q){const q=new ve(T,this.h,G,this.j.converter),_=this.t(q,T);return this.e.$registerInlineCompletionsSupport(_,this.o(V,T),q.supportsHandleEvents,p.$0l.toKey(T.identifier.value),Q?.yieldTo?.map(he=>p.$0l.toKey(he))||[]),this.p(_)}$provideInlineCompletions(T,V,G,Q,q){return this.s(T,oe,_=>_.provideInlineCompletions(E.URI.revive(V),G,Q,q),void 0,q)}$handleInlineCompletionDidShow(T,V,G,Q){this.s(T,oe,async q=>{q.handleDidShowCompletionItem(V,G,Q)},void 0,void 0)}$handleInlineCompletionPartialAccept(T,V,G,Q){this.s(T,oe,async q=>{q.handlePartialAccept(V,G,Q)},void 0,void 0)}$freeInlineCompletionsList(T,V){this.s(T,oe,async G=>{G.disposeCompletions(V)},void 0,void 0)}registerSignatureHelpProvider(T,V,G,Q){const q=Array.isArray(Q)?{triggerCharacters:Q,retriggerCharacters:[]}:Q,_=this.t(new W(this.h,G),T);return this.e.$registerSignatureHelpProvider(_,this.o(V,T),q),this.p(_)}$provideSignatureHelp(T,V,G,Q,q){return this.s(T,W,_=>_.provideSignatureHelp(E.URI.revive(V),G,Q,q),void 0,q)}$releaseSignatureHelp(T,V){this.s(T,W,G=>G.releaseSignatureHelp(V),void 0,void 0)}registerInlayHintsProvider(T,V,G){const Q=typeof G.onDidChangeInlayHints=="function"?this.q():void 0,q=this.t(new ue(this.h,this.j.converter,G,this.l,T),T);this.e.$registerInlayHintsProvider(q,this.o(V,T),typeof G.resolveInlayHint=="function",Q,de.u(T));let _=this.p(q);if(Q!==void 0){const he=G.onDidChangeInlayHints(Oe=>this.e.$emitInlayHintsEvent(Q));_=M.$xK.from(_,he)}return _}$provideInlayHints(T,V,G,Q){return this.s(T,ue,q=>q.provideInlayHints(E.URI.revive(V),G,Q),void 0,Q)}$resolveInlayHint(T,V,G){return this.s(T,ue,Q=>Q.resolveInlayHint(V,G),void 0,G)}$releaseInlayHints(T,V){this.s(T,ue,G=>G.releaseHints(V),void 0,void 0)}registerDocumentLinkProvider(T,V,G){const Q=this.t(new Pe(this.h,G),T);return this.e.$registerDocumentLinkProvider(Q,this.o(V,T),typeof G.resolveDocumentLink=="function"),this.p(Q)}$provideDocumentLinks(T,V,G){return this.s(T,Pe,Q=>Q.provideLinks(E.URI.revive(V),G),void 0,G,V.scheme==="output")}$resolveDocumentLink(T,V,G){return this.s(T,Pe,Q=>Q.resolveLink(V,G),void 0,void 0,!0)}$releaseDocumentLinks(T,V){this.s(T,Pe,G=>G.releaseLinks(V),void 0,void 0,!0)}registerColorProvider(T,V,G){const Q=this.t(new Ee(this.h,G),T);return this.e.$registerDocumentColorProvider(Q,this.o(V,T)),this.p(Q)}$provideDocumentColors(T,V,G){return this.s(T,Ee,Q=>Q.provideColors(E.URI.revive(V),G),[],G)}$provideColorPresentations(T,V,G,Q){return this.s(T,Ee,q=>q.provideColorPresentations(E.URI.revive(V),G,Q),void 0,Q)}registerFoldingRangeProvider(T,V,G){const Q=this.q(),q=typeof G.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(Q,new ae(new te(this.h,G),T)),this.e.$registerFoldingRangeProvider(Q,this.o(V,T),T.identifier,q);let _=this.p(Q);if(q!==void 0){const he=G.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(q));_=M.$xK.from(_,he)}return _}$provideFoldingRanges(T,V,G,Q){return this.s(T,te,q=>q.provideFoldingRanges(E.URI.revive(V),G,Q),void 0,Q)}registerSelectionRangeProvider(T,V,G){const Q=this.t(new se(this.h,G,this.l),T);return this.e.$registerSelectionRangeProvider(Q,this.o(V,T)),this.p(Q)}$provideSelectionRanges(T,V,G,Q){return this.s(T,se,q=>q.provideSelectionRanges(E.URI.revive(V),G,Q),[],Q)}registerCallHierarchyProvider(T,V,G){const Q=this.t(new me(this.h,G),T);return this.e.$registerCallHierarchyProvider(Q,this.o(V,T)),this.p(Q)}$prepareCallHierarchy(T,V,G,Q){return this.s(T,me,q=>Promise.resolve(q.prepareSession(E.URI.revive(V),G,Q)),void 0,Q)}$provideCallHierarchyIncomingCalls(T,V,G,Q){return this.s(T,me,q=>q.provideCallsTo(V,G,Q),void 0,Q)}$provideCallHierarchyOutgoingCalls(T,V,G,Q){return this.s(T,me,q=>q.provideCallsFrom(V,G,Q),void 0,Q)}$releaseCallHierarchy(T,V){this.s(T,me,G=>Promise.resolve(G.releaseSession(V)),void 0,void 0)}registerTypeHierarchyProvider(T,V,G){const Q=this.t(new Z(this.h,G),T);return this.e.$registerTypeHierarchyProvider(Q,this.o(V,T)),this.p(Q)}$prepareTypeHierarchy(T,V,G,Q){return this.s(T,Z,q=>Promise.resolve(q.prepareSession(E.URI.revive(V),G,Q)),void 0,Q)}$provideTypeHierarchySupertypes(T,V,G,Q){return this.s(T,Z,q=>q.provideSupertypes(V,G,Q),void 0,Q)}$provideTypeHierarchySubtypes(T,V,G,Q){return this.s(T,Z,q=>q.provideSubtypes(V,G,Q),void 0,Q)}$releaseTypeHierarchy(T,V){this.s(T,Z,G=>Promise.resolve(G.releaseSession(V)),void 0,void 0)}registerDocumentOnDropEditProvider(T,V,G,Q){const q=this.q();this.f.set(q,new ae(new le(this.e,this.h,G,q,T),T));const _=(0,r.$uF)(T,"dropMetadata")&&Q?le.toInternalProviderId(T.identifier.value,Q.id):void 0;return this.e.$registerDocumentOnDropEditProvider(q,this.o(V,T),_,(0,r.$uF)(T,"dropMetadata")?Q:void 0),this.p(q)}$provideDocumentOnDropEdits(T,V,G,Q,q,_){return this.s(T,le,he=>Promise.resolve(he.provideDocumentOnDropEdits(V,E.URI.revive(G),Q,q,_)),void 0,void 0)}registerMappedEditsProvider(T,V,G){const Q=this.t(new ne(this.h,G),T);return this.e.$registerMappedEditsProvider(Q,this.o(V,T)),this.p(Q)}$provideMappedEdits(T,V,G,Q,q){return this.s(T,ne,_=>Promise.resolve(_.provideMappedEdits(V,G,Q,q)),null,q)}registerDocumentPasteEditProvider(T,V,G,Q){const q=this.q();this.f.set(q,new ae(new F(this.e,this.h,G,q,T),T));const _=F.toInternalProviderId(T.identifier.value,Q.id);return this.e.$registerPasteEditProvider(q,this.o(V,T),_,{supportsCopy:!!G.prepareDocumentPaste,supportsPaste:!!G.provideDocumentPasteEdits,copyMimeTypes:Q.copyMimeTypes,pasteMimeTypes:Q.pasteMimeTypes}),this.p(q)}$prepareDocumentPaste(T,V,G,Q,q){return this.s(T,F,_=>_.prepareDocumentPaste(E.URI.revive(V),G,Q,q),void 0,q)}$providePasteEdits(T,V,G,Q,q,_){return this.s(T,F,he=>he.providePasteEdits(V,E.URI.revive(G),Q,q,_),void 0,_)}static w(T){return{pattern:T.source,flags:T.flags}}static y(T){return{decreaseIndentPattern:de.w(T.decreaseIndentPattern),increaseIndentPattern:de.w(T.increaseIndentPattern),indentNextLinePattern:T.indentNextLinePattern?de.w(T.indentNextLinePattern):void 0,unIndentedLinePattern:T.unIndentedLinePattern?de.w(T.unIndentedLinePattern):void 0}}static z(T){return{beforeText:de.w(T.beforeText),afterText:T.afterText?de.w(T.afterText):void 0,previousLineText:T.previousLineText?de.w(T.previousLineText):void 0,action:T.action}}static B(T){return T.map(de.z)}static C(T){return{open:T.open,close:T.close,notIn:T.notIn?T.notIn.map(V=>M.SyntaxTokenType.toString(V)):void 0}}static D(T){return T.map(de.C)}setLanguageConfiguration(T,V,G){const{wordPattern:Q}=G;if(Q&&(0,D.$Pe)(Q))throw new Error(`Invalid language configuration: wordPattern '${Q}' is not allowed to match the empty string.`);Q?this.h.setWordDefinitionFor(V,Q):this.h.setWordDefinitionFor(V,void 0),G.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",T,"Do not use."),G.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",T,"Do not use.");const q=this.q(),_={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?de.w(G.wordPattern):void 0,indentationRules:G.indentationRules?de.y(G.indentationRules):void 0,onEnterRules:G.onEnterRules?de.B(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport,autoClosingPairs:G.autoClosingPairs?de.D(G.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(q,V,_),this.p(q)}$setWordDefinitions(T){for(const V of T)this.h.setWordDefinitionFor(V.languageId,new RegExp(V.regexSource,V.regexFlags))}}e.$9cc=de}),define(Ae[257],Re([1,0,3,8,7,31,12,6,23]),function(pe,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qdc=void 0;class g{constructor(S,o,v,p){this.c=o,this.d=v,this.e=p,this.b=[],this.f=0,this.g=new Set,this.a=S.getProxy(E.$vK.MainThreadLanguages)}$acceptLanguageIds(S){this.b=S}async getLanguages(){return this.b.slice(0)}async changeLanguage(S,o){await this.a.$changeLanguage(S,o);const v=this.c.getDocumentData(S);if(!v)throw new Error(`document '${S.toString()}' NOT found`);return v.document}async tokenAtPosition(S,o){const v=S.version,p=L.Position.from(o),f=await this.a.$tokensAtPosition(S.uri,p),t={type:P.StandardTokenType.Other,range:S.getWordRangeAtPosition(o)??new P.$zK(o.line,o.character,o.line,o.character)};if(!f)return t;const i={range:L.Range.to(f.range),type:L.TokenType.to(f.type)};return!i.range.contains(o)||v!==S.version?t:i}createLanguageStatusItem(S,o,v){const p=this.f++,f=this.a,t=this.g,i=`${S.identifier.value}/${o}`;if(t.has(i))throw new Error(`LanguageStatusItem with id '${o}' ALREADY exists`);t.add(i);const n={selector:v,id:o,name:S.displayName??S.name,severity:P.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let u;const a=new $.$Qc,l=()=>{if(u?.dispose(),!t.has(i)){console.warn(`LanguageStatusItem (${o}) from ${S.identifier.value} has been disposed and CANNOT be updated anymore`);return}u=(0,R.$Wg)(()=>{a.clear(),this.a.$setLanguageStatus(p,{id:i,name:n.name??S.displayName??S.name,source:S.displayName??S.name,selector:L.DocumentSelector.from(n.selector,this.e),label:n.text,detail:n.detail??"",severity:n.severity===P.LanguageStatusSeverity.Error?M.default.Error:n.severity===P.LanguageStatusSeverity.Warning?M.default.Warning:M.default.Info,command:n.command&&this.d.toInternal(n.command,a),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},r={dispose(){a.dispose(),u?.dispose(),f.$removeLanguageStatus(p),t.delete(i)},get id(){return n.id},get name(){return n.name},set name(s){n.name=s,l()},get selector(){return n.selector},set selector(s){n.selector=s,l()},get text(){return n.text},set text(s){n.text=s,l()},set text2(s){(0,D.$vF)(S,"languageStatusText"),n.text=s,l()},get text2(){return(0,D.$vF)(S,"languageStatusText"),n.text},get detail(){return n.detail},set detail(s){n.detail=s,l()},get severity(){return n.severity},set severity(s){n.severity=s,l()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(s){n.accessibilityInformation=s,l()},get command(){return n.command},set command(s){n.command=s,l()},get busy(){return n.busy},set busy(s){n.busy=s,l()}};return l(),r}}e.$Qdc=g}),define(Ae[82],Re([1,0,21,13,2,4,15,3,27,17]),function(pe,e,E,L,P,M,R,$,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gdc=e.$Fdc=void 0;let A=class{constructor(o,v,p){this.f=p,this.d=new Map,this.a=v.getProxy($.$vK.MainThreadLocalization),this.b=o.environment.appLanguage,this.c=this.b===E.$g}getMessage(o,v){const{message:p,args:f,comment:t}=v;if(this.c)return(0,L.$Ee)(p,f??{});let i=p;t&&t.length>0&&(i+=`/${Array.isArray(t)?t.join(""):t}`);const n=this.d.get(o)?.contents[i];return n||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${i}`),(0,L.$Ee)(n??p,f??{})}getBundle(o){return this.d.get(o)?.contents}getBundleUri(o){return this.d.get(o)?.uri}async initializeLocalizedMessages(o){if(this.c||!o.l10n&&!o.isBuiltin||this.d.has(o.identifier.value))return;let v;const p=await this.g(o);if(!p){this.f.error(`No bundle location found for extension ${o.identifier.value}`);return}try{const f=await this.a.$fetchBundleContents(p),t=JSON.parse(f);v=o.isBuiltin?t.contents?.bundle:t}catch(f){this.f.error(`Failed to load translations for ${o.identifier.value} from ${p}: ${f.message}`);return}v&&this.d.set(o.identifier.value,{contents:v,uri:p})}async g(o){if(o.isBuiltin){const v=await this.a.$fetchBuiltInBundleUri(o.identifier.value,this.b);return P.URI.revive(v)}return o.l10n?P.URI.joinPath(o.extensionLocation,o.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Fdc=A,e.$Fdc=A=Ke([Ve(0,D.$NM),Ve(1,g.$xM),Ve(2,R.$bj)],A),e.$Gdc=(0,M.$Th)("IExtHostLocalizationService")}),define(Ae[258],Re([1,0,15,3,27,17,2,52]),function(pe,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ec=void 0;let D=class extends E.$mj{constructor(S,o){super(o.logLevel,o.logsLocation,o.loggers.map(v=>(0,$.$qh)(v))),this.r=S.getProxy(L.$vK.MainThreadLogger)}$setLogLevel(S,o){o?this.setLogLevel(R.URI.revive(o),S):this.setLogLevel(S)}setVisibility(S,o){super.setVisibility(S,o),this.r.$setVisibility(S,o)}s(S,o,v){return new g(this.r,S,o,v)}};e.$9ec=D,e.$9ec=D=Ke([Ve(0,M.$xM),Ve(1,P.$NM)],D);class g extends E.$hj{constructor(S,o,v,p){super(p?.logLevel==="always"),this.r=S,this.s=o,this.m=!1,this.n=[],this.setLevel(v),this.r.$createLogger(o,p).then(()=>{this.u(this.n),this.m=!0})}g(S,o){const v=[[S,o]];this.m?this.u(v):this.n.push(...v)}u(S){this.r.$log(this.s,S)}flush(){this.r.$flush(this.s)}}}),define(Ae[83],Re([1,0,3,4,6,17,24]),function(pe,e,E,L,P,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Idc=e.$Hdc=void 0,e.$Hdc=(0,L.$Th)("IExtHostManagedSockets");let $=class{constructor(S){this.b=0,this.c=null,this.d=new Map,this.a=S.getProxy(E.$vK.MainThreadManagedSockets)}setFactory(S,o){for(const v of this.d.values())v.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new D(S,o),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(S){if(!this.c||this.c.socketFactoryId!==S)throw new Error(`No socket factory with id ${S}`);const o=++this.b,v=await this.c.makeConnection(),p=new P.$Qc;return this.d.set(o,new g(o,v,p)),p.add((0,P.$Pc)(()=>this.d.delete(o))),p.add(v.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(o),p.dispose()})),p.add(v.onDidClose(f=>{this.a.$onDidManagedSocketClose(o,f?.stack??f?.message),p.dispose()})),p.add(v.onDidReceiveMessage(f=>this.a.$onDidManagedSocketHaveData(o,R.$ce.wrap(f)))),o}$remoteSocketWrite(S,o){this.d.get(S)?.actual.send(o.buffer)}$remoteSocketEnd(S){const o=this.d.get(S);o&&(o.actual.end(),o.dispose())}async $remoteSocketDrain(S){await this.d.get(S)?.actual.drain?.()}};e.$Idc=$,e.$Idc=$=Ke([Ve(0,M.$xM)],$);class D{constructor(S,o){this.socketFactoryId=S,this.makeConnection=o}}class g extends P.$Rc{constructor(S,o,v){super(),this.socketId=S,this.actual=o,this.B(v)}}}),define(Ae[259],Re([1,0,3,15,23]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rdc=void 0;function M($){return $&&$.title}let R=class{constructor(D,g){this.b=g,this.a=D.getProxy(E.$vK.MainThreadMessageService)}showMessage(D,g,A,S,o){const v={source:{identifier:D.identifier,label:D.displayName||D.name}};let p;typeof S=="string"||M(S)?p=[S,...o]:(v.modal=S?.modal,v.useCustom=S?.useCustom,v.detail=S?.detail,p=o),v.useCustom&&(0,P.$vF)(D,"resolvers");const f=[];for(let t=0;t<p.length;t++){const i=p[t];if(typeof i=="string")f.push({title:i,handle:t,isCloseAffordance:!1});else if(typeof i=="object"){const{title:n,isCloseAffordance:u}=i;f.push({title:n,isCloseAffordance:!!u,handle:t})}else this.b.warn("Invalid message item:",i)}return this.a.$showMessage(g,A,v,f).then(t=>{if(typeof t=="number")return p[t]})}};e.$Rdc=R,e.$Rdc=R=Ke([Ve(1,L.$bj)],R)}),define(Ae[260],Re([1,0,18,12,20,5,6,28,2,22,15,3,32,8,7,78,212,23,49]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f,t,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oec=e.$Nec=void 0;let u=class{constructor(m,I,k,d,b){this.l=I,this.m=k,this.n=d,this.o=b,this.b=new $.$zc,this.c=new $.$zc,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new Map,this.j=0,this.k=new M.$Od,this.onDidChangeNotebookCellExecutionState=this.k.event,this.a=m.getProxy(S.$vK.MainThreadNotebookKernels);const y=new o.$XM("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new o.$VM("options","Select kernel options",C=>!0,C=>{if(C&&"notebookEditor"in C&&"id"in C){const B=this.m.getIdByEditor(C.notebookEditor);return{id:C.id,extension:C.extension,notebookEditorId:B}}else if(C&&"notebookEditor"in C){const B=this.m.getIdByEditor(C.notebookEditor);if(B===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${C.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:B}}return C})],o.$WM.Void);this.n.registerApiCommand(y)}createNotebookController(m,I,k,d,b,y){for(const we of this.i.values())if(we.controller.id===I&&g.$0l.equals(m.identifier,we.extensionId))throw new Error(`notebook controller with id '${I}' ALREADY exist`);const C=this.j++,B=this;this.o.trace(`NotebookController[${C}], CREATED by ${m.identifier.value}, ${I}`);const H=()=>console.warn(`NO execute handler from notebook controller '${N.id}' of extension: '${m.identifier}'`);let U=!1;const z=new M.$Od,F=new M.$Od,N={id:h(m.identifier,I),notebookType:k,extensionId:m.identifier,extensionLocation:m.extensionLocation,label:d||m.identifier.value,preloads:y?y.map(v.NotebookRendererScript.from):[]};let x=b??H,J;this.a.$addKernel(C,N).catch(we=>{console.log(we),U=!0});let ye=0;const De=()=>{if(U)return;const we=++ye;Promise.resolve().then(()=>{we===ye&&this.a.$updateKernel(C,N)})},Ce=new $.$zc,ge={get id(){return I},get notebookType(){return N.notebookType},onDidChangeSelectedNotebooks:z.event,get label(){return N.label},set label(we){N.label=we??m.displayName??m.name,De()},get detail(){return N.detail??""},set detail(we){N.detail=we,De()},get description(){return N.description??""},set description(we){N.description=we,De()},get supportedLanguages(){return N.supportedLanguages},set supportedLanguages(we){N.supportedLanguages=we,De()},get supportsExecutionOrder(){return N.supportsExecutionOrder??!1},set supportsExecutionOrder(we){N.supportsExecutionOrder=we,De()},get rendererScripts(){return N.preloads?N.preloads.map(v.NotebookRendererScript.to):[]},get executeHandler(){return x},set executeHandler(we){x=we??H},get interruptHandler(){return J},set interruptHandler(we){J=we,N.supportsInterrupt=!!we,De()},createNotebookCellExecution(we){if(U)throw new Error("notebook controller is DISPOSED");if(!Ce.has(we.notebook.uri))throw B.o.trace(`NotebookController[${C}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Ce.keys()).map(re=>re.toString())),new Error(`notebook controller is NOT associated to notebook: ${we.notebook.uri.toString()}`);return B._createNotebookCellExecution(we,h(m.identifier,this.id))},createNotebookExecution(we){if((0,i.$vF)(m,"notebookExecution"),U)throw new Error("notebook controller is DISPOSED");if(!Ce.has(we.uri))throw B.o.trace(`NotebookController[${C}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Ce.keys()).map(re=>re.toString())),new Error(`notebook controller is NOT associated to notebook: ${we.uri.toString()}`);return B._createNotebookExecution(we,h(m.identifier,this.id))},dispose:()=>{U||(this.o.trace(`NotebookController[${C}], DISPOSED`),U=!0,this.i.delete(C),z.dispose(),F.dispose(),this.a.$removeKernel(C))},updateNotebookAffinity(we,re){re===p.NotebookControllerAffinity2.Hidden&&(0,i.$vF)(m,"notebookControllerAffinityHidden"),B.a.$updateNotebookPriority(C,we.uri,re)},onDidReceiveMessage:F.event,postMessage(we,re){return(0,i.$vF)(m,"notebookMessaging"),B.a.$postMessage(C,re&&B.m.getIdByEditor(re),we)},asWebviewUri(we){return(0,i.$vF)(m,"notebookMessaging"),(0,f.$2tb)(we,B.l.remote)}};return this.i.set(C,{extensionId:m.identifier,controller:ge,onDidReceiveMessage:F,onDidChangeSelection:z,associatedNotebooks:Ce}),ge}getIdByController(m){for(const[I,k]of this.i)if(k.controller===m)return h(k.extensionId,m.id);return null}createNotebookControllerDetectionTask(m,I){const k=this.f++,d=this;this.o.trace(`NotebookControllerDetectionTask[${k}], CREATED by ${m.identifier.value}`),this.a.$addKernelDetectionTask(k,I);const b={dispose:()=>{this.e.delete(k),d.a.$removeKernelDetectionTask(k)}};return this.e.set(k,b),b}registerKernelSourceActionProvider(m,I,k){const d=this.h++,b=typeof k.onDidChangeNotebookKernelSourceActions=="function"?d:void 0,y=this;this.g.set(d,k),this.o.trace(`NotebookKernelSourceActionProvider[${d}], CREATED by ${m.identifier.value}`),this.a.$addKernelSourceActionProvider(d,d,I);let C;return b!==void 0&&(C=k.onDidChangeNotebookKernelSourceActions(B=>this.a.$emitNotebookKernelSourceActionsChangeEvent(b))),{dispose:()=>{this.g.delete(d),y.a.$removeKernelSourceActionProvider(d,d),C?.dispose()}}}async $provideKernelSourceActions(m,I){const k=this.g.get(m);if(k){const d=new R.$Qc;return(await k.provideNotebookKernelSourceActions(I)??[]).map(y=>v.NotebookKernelSourceAction.from(y,this.n.converter,d))}return[]}$acceptNotebookAssociation(m,I,k){const d=this.i.get(m);if(d){const b=this.m.getNotebookDocument(D.URI.revive(I));k?d.associatedNotebooks.set(b.uri,!0):d.associatedNotebooks.delete(b.uri),this.o.trace(`NotebookController[${m}] ASSOCIATE notebook`,b.uri.toString(),k),d.onDidChangeSelection.fire({selected:k,notebook:b.apiNotebook})}}async $executeCells(m,I,k){const d=this.i.get(m);if(!d)return;const b=this.m.getNotebookDocument(D.URI.revive(I)),y=[];for(const C of k){const B=b.getCell(C);B&&y.push(B.apiCell)}try{this.o.trace(`NotebookController[${m}] EXECUTE cells`,b.uri.toString(),y.length),await d.controller.executeHandler.call(d.controller,y,b.apiNotebook,d.controller)}catch(C){this.o.error(`NotebookController[${m}] execute cells FAILED`,C),console.error(C)}}async $cancelCells(m,I,k){const d=this.i.get(m);if(!d)return;const b=this.m.getNotebookDocument(D.URI.revive(I));if(d.controller.interruptHandler)await d.controller.interruptHandler.call(d.controller,b.apiNotebook);else for(const y of k){const C=b.getCell(y);C&&this.b.get(C.uri)?.cancel()}if(d.controller.interruptHandler){const y=this.c.get(b.uri);k.length&&Array.isArray(y)&&y.length&&y.forEach(C=>C.dispose())}}$acceptKernelMessageFromRenderer(m,I,k){const d=this.i.get(m);if(!d)return;const b=this.m.getEditorById(I);d.onDidReceiveMessage.fire(Object.freeze({editor:b.apiEditor,message:k}))}$cellExecutionChanged(m,I,k){const b=this.m.getNotebookDocument(D.URI.revive(m)).getCell(I);if(b){const y=k?v.NotebookCellExecutionState.to(k):p.NotebookCellExecutionState.Idle;y!==void 0&&this.k.fire({cell:b.apiCell,state:y})}}_createNotebookCellExecution(m,I){if(m.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const d=this.m.getNotebookDocument(m.notebook.uri).getCellFromApiCell(m);if(!d)throw new Error("invalid cell");if(this.b.has(d.uri))throw new Error(`duplicate execution for ${d.uri}`);const b=new l(I,d,this.a);this.b.set(d.uri,b);const y=b.onDidChangeState(()=>{b.state===a.Resolved&&(b.dispose(),y.dispose(),this.b.delete(d.uri))});return b.asApiObject()}_createNotebookExecution(m,I){const k=this.m.getNotebookDocument(m.uri),d=m.getCells().find(C=>{const B=k.getCellFromApiCell(C);return B&&this.b.has(B.uri)});if(d)throw new Error(`duplicate cell execution for ${d.document.uri}`);if(this.c.has(k.uri))throw new Error(`duplicate notebook execution for ${k.uri}`);const b=new s(I,k,this.a),y=b.onDidChangeState(()=>{b.state===r.Resolved&&(b.dispose(),y.dispose(),this.c.delete(k.uri))});return this.c.set(k.uri,[b,y]),b.asApiObject()}};e.$Nec=u,e.$Nec=u=Ke([Ve(4,A.$bj)],u);var a;(function(w){w[w.Init=0]="Init",w[w.Started=1]="Started",w[w.Resolved=2]="Resolved"})(a||(a={}));class l extends R.$Rc{static{this.a=0}get state(){return this.f}constructor(m,I,k){super(),this.m=I,this.n=k,this.b=l.a++,this.c=new M.$Od,this.onDidChangeState=this.c.event,this.f=a.Init,this.g=this.B(new P.$Yd),this.h=new c(10,d=>this.s(d)),this.j=I.internalMetadata.executionOrder,this.n.$createExecution(this.b,m,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(m){await this.h.addItem(m)}async s(m){const I=Array.isArray(m)?m:[m];return this.n.$updateExecution(this.b,new n.$uv(I))}t(){if(this.f===a.Init)throw new Error("Must call start before modifying cell output");if(this.f===a.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(m){let I=this.m;if(m&&(I=this.m.notebook.getCellFromApiCell(m)),!I)throw new Error("INVALID cell");return I.handle}y(m){return m.map(I=>{const k=p.$YL.ensureUniqueMimeTypes(I.items,!0);return k===I.items?v.NotebookCellOutput.from(I):v.NotebookCellOutput.from({items:k,id:I.id,metadata:I.metadata})})}async z(m,I,k){const d=this.w(I),b=this.y((0,E.$2b)(m));return this.r({editType:t.CellExecutionUpdateType.Output,cellHandle:d,append:k,outputs:b})}async C(m,I,k){return m=p.$YL.ensureUniqueMimeTypes((0,E.$2b)(m),!0),this.r({editType:t.CellExecutionUpdateType.OutputItems,items:m.map(v.NotebookCellOutputItem.from),outputId:I.id,append:k})}asApiObject(){const m=this;return Object.freeze({get token(){return m.g.token},get cell(){return m.m.apiCell},get executionOrder(){return m.j},set executionOrder(k){m.j=k,m.s([{editType:t.CellExecutionUpdateType.ExecutionState,executionOrder:m.j}])},start(k){if(m.f===a.Resolved||m.f===a.Started)throw new Error("Cannot call start again");m.f=a.Started,m.c.fire(),m.s({editType:t.CellExecutionUpdateType.ExecutionState,runStartTime:k})},end(k,d){if(m.f===a.Resolved)throw new Error("Cannot call resolve twice");m.f=a.Resolved,m.c.fire(),m.h.flush(),m.n.$completeExecution(m.b,new n.$uv({runEndTime:d,lastRunSuccess:k}))},clearOutput(k){return m.t(),m.z([],k,!1)},appendOutput(k,d){return m.t(),m.z(k,d,!0)},replaceOutput(k,d){return m.t(),m.z(k,d,!1)},appendOutputItems(k,d){return m.t(),m.C(k,d,!0)},replaceOutputItems(k,d){return m.t(),m.C(k,d,!1)}})}}var r;(function(w){w[w.Init=0]="Init",w[w.Started=1]="Started",w[w.Resolved=2]="Resolved"})(r||(r={}));class s extends R.$Rc{static{this.a=0}get state(){return this.f}constructor(m,I,k){super(),this.h=I,this.j=k,this.b=s.a++,this.c=new M.$Od,this.onDidChangeState=this.c.event,this.f=r.Init,this.g=this.B(new P.$Yd),this.j.$createNotebookExecution(this.b,m,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===r.Resolved||this.f===r.Started)throw new Error("Cannot call start again");this.f=r.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===r.Resolved)throw new Error("Cannot call resolve twice");this.f=r.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class c{constructor(m,I){this.e=m,this.f=I,this.a=[],this.b=Date.now()}addItem(m){return this.a.push(m),this.c||(this.c=new L.$gh,this.b=Date.now(),(0,L.$Vg)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const m=this.c;this.c=void 0;const I=this.a;return this.a=[],this.f(I).finally(()=>m.complete())}}function h(w,m){return`${w.value}/${m}`}e.$Oec=h}),define(Ae[261],Re([1,0,5,3,107]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pec=void 0;class M{constructor($,D){this.c=D,this.a=new Map,this.b=$.getProxy(L.$vK.MainThreadNotebookRenderers)}$postRendererMessage($,D,g){const A=this.c.getEditorById($);this.a.get(D)?.fire({editor:A.apiEditor,message:g})}createRendererMessaging($,D){if(!$.contributes?.notebookRenderer?.some(A=>A.id===D))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${D})`);return{onDidReceiveMessage:(A,S,o)=>this.d(D).event(A,S,o),postMessage:(A,S)=>{P.$yec.apiEditorsToExtHost.has(A)&&([A,S]=[S,A]);const o=S&&P.$yec.apiEditorsToExtHost.get(S);return this.b.$postMessage(o?.id,D,A)}}}d($){let D=this.a.get($);return D||(D=new E.$Od({onDidRemoveLastListener:()=>{D?.dispose(),this.a.delete($)}}),this.a.set($,D),D)}}e.$Pec=M}),define(Ae[262],Re([1,0,6,16,2,23,3]),function(pe,e,E,L,P,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tec=void 0;class ${constructor(g){this.b=new Map,this.a=g.getProxy(R.$vK.MainThreadProfileContentHandlers)}registrProfileContentHandler(g,A,S){if((0,M.$vF)(g,"profileContentHandlers"),this.b.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.b.set(A,S),this.a.$registerProfileContentHandler(A,S.name,S.description,g.identifier.value),(0,E.$Pc)(()=>{this.b.delete(A),this.a.$unregisterProfileContentHandler(A)})}async $saveProfile(g,A,S,o){const v=this.b.get(g);if(!v)throw new Error(`Unknown handler with id: ${g}`);return v.saveProfile(A,S,o)}async $readProfile(g,A,S){const o=this.b.get(g);if(!o)throw new Error(`Unknown handler with id: ${g}`);return o.readProfile((0,L.$zf)(A)?A:P.URI.revive(A),S)}}e.$Tec=$}),define(Ae[263],Re([1,0,2,3,12,8]),function(pe,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uec=void 0;class R{static{this.a=0}constructor(D,g){this.d=g,this.c=new Map,this.b=D.getProxy(L.$vK.MainThreadQuickDiff)}$provideOriginalResource(D,g,A){const S=E.URI.revive(g),o=this.c.get(D);return o?(0,P.$Ng)(()=>o.provideOriginalResource(S,A)).then(v=>v||null):Promise.resolve(null)}registerQuickDiffProvider(D,g,A,S){const o=R.a++;return this.c.set(o,g),this.b.$registerQuickDiffProvider(o,M.DocumentSelector.from(D,this.d),A,S),{dispose:()=>{this.b.$unregisterQuickDiffProvider(o),this.c.delete(o)}}}}e.$Uec=R}),define(Ae[264],Re([1,0,20,5,6,3,2,7,11,18,31,45,23,8]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vdc=void 0;function p(f,t,i){const n=f.getProxy(M.$vK.MainThreadQuickOpen);class u{constructor(I,k){this.e=new Map,this.f=0,this.a=I,this.b=k}showQuickPick(I,k,d,b=E.CancellationToken.None){this.c=void 0;const y=Promise.resolve(k),C=++this.f,B=n.$show(C,{title:d?.title,placeHolder:d?.placeHolder,matchOnDescription:d?.matchOnDescription,matchOnDetail:d?.matchOnDetail,ignoreFocusLost:d?.ignoreFocusOut,canPickMany:d?.canPickMany},b),H={},U=B.then(()=>H);return Promise.race([U,y]).then(z=>{if(z===H)return;const F=(0,o.$uF)(I,"quickPickItemTooltip");return y.then(N=>{const x=[];for(let J=0;J<N.length;J++){const ye=N[J];if(typeof ye=="string")x.push({label:ye,handle:J});else if(ye.kind===$.QuickPickItemKind.Separator)x.push({type:"separator",label:ye.label});else{ye.tooltip&&!F&&console.warn(`Extension '${I.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${I.identifier.value}`);const De=ye.iconPath?c(ye.iconPath):void 0;x.push({label:ye.label,iconPath:De?.iconPath,iconClass:De?.iconClass,description:ye.description,detail:ye.detail,picked:ye.picked,alwaysShow:ye.alwaysShow,tooltip:F?v.MarkdownString.fromStrict(ye.tooltip):void 0,handle:J})}}return d&&typeof d.onDidSelectItem=="function"&&(this.c=J=>{d.onDidSelectItem(N[J])}),n.$setItems(C,x),B.then(J=>{if(typeof J=="number")return N[J];if(Array.isArray(J))return J.map(ye=>N[ye])})})}).then(void 0,z=>{if(!(0,D.$3)(z))return n.$setError(C,z),Promise.reject(z)})}$onItemSelected(I){this.c?.(I)}showInput(I,k=E.CancellationToken.None){return this.d=I?.validateInput,n.$input(I,typeof this.d=="function",k).then(void 0,d=>{if(!(0,D.$3)(d))return Promise.reject(d)})}async $validateInput(I){if(!this.d)return;const k=await this.d(I);if(!k||typeof k=="string")return k;let d;switch(k.severity){case $.InputBoxValidationSeverity.Info:d=A.default.Info;break;case $.InputBoxValidationSeverity.Warning:d=A.default.Warning;break;case $.InputBoxValidationSeverity.Error:d=A.default.Error;break;default:d=k.message?A.default.Error:A.default.Ignore;break}return{content:k.message,severity:d}}async showWorkspaceFolderPick(I,k=E.CancellationToken.None){const d=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[I]);if(!d)return;const b=await this.a.getWorkspaceFolders2();if(b)return b.find(y=>y.uri.toString()===d.uri.toString())}createQuickPick(I){const k=new h(I,()=>this.e.delete(k._id));return this.e.set(k._id,k),k}createInputBox(I){const k=new w(I,()=>this.e.delete(k._id));return this.e.set(k._id,k),k}$onDidChangeValue(I,k){this.e.get(I)?._fireDidChangeValue(k)}$onDidAccept(I){this.e.get(I)?._fireDidAccept()}$onDidChangeActive(I,k){const d=this.e.get(I);d instanceof h&&d._fireDidChangeActive(k)}$onDidChangeSelection(I,k){const d=this.e.get(I);d instanceof h&&d._fireDidChangeSelection(k)}$onDidTriggerButton(I,k){this.e.get(I)?._fireDidTriggerButton(k)}$onDidTriggerItemButton(I,k,d){const b=this.e.get(I);b instanceof h&&b._fireDidTriggerItemButton(k,d)}$onDidHide(I){this.e.get(I)?._fireDidHide()}}class a{static{this.a=1}constructor(I,k){this.x=I,this.y=k,this._id=h.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new L.$Od,this.q=new L.$Od,this.r=new L.$Od,this.s=new L.$Od,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(I){this.b=I,this.z({title:I})}get step(){return this.c}set step(I){this.c=I,this.z({step:I})}get totalSteps(){return this.d}set totalSteps(I){this.d=I,this.z({totalSteps:I})}get enabled(){return this.g}set enabled(I){this.g=I,this.z({enabled:I})}get busy(){return this.j}set busy(I){this.j=I,this.z({busy:I})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(I){this.k=I,this.z({ignoreFocusOut:I})}get value(){return this.l}set value(I){this.l=I,this.z({value:I})}get placeholder(){return this.m}set placeholder(I){this.m=I,this.z({placeholder:I})}get buttons(){return this.n}set buttons(I){this.n=I.slice(),this.o.clear(),I.forEach((k,d)=>{const b=k===$.$RL.Back?-1:d;this.o.set(b,k)}),this.z({buttons:I.map((k,d)=>({...c(k.iconPath),tooltip:k.tooltip,handle:k===$.$RL.Back?-1:d}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(I){this.l=I,this.q.fire(I)}_fireDidTriggerButton(I){const k=this.o.get(I);k&&this.r.fire(k)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,P.$Mc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),n.$dispose(this._id))}z(I){if(!this.v){for(const k of Object.keys(I)){const d=I[k];this.u[k]=d===void 0?null:d}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){n.$createOrUpdate(this.u),this.u={id:this._id}}}function l(m){if(m instanceof $.$rL)return{id:m.id};const I=s(m),k=r(m);return{dark:typeof I=="string"?R.URI.file(I):I,light:typeof k=="string"?R.URI.file(k):k}}function r(m){return typeof m=="object"&&"light"in m?m.light:m}function s(m){return typeof m=="object"&&"dark"in m?m.dark:m}function c(m){const I=l(m);let k,d;return"id"in I?d=S.ThemeIcon.asClassName(I):k=I,{iconPath:k,iconClass:d}}class h extends a{constructor(I,k){super(I.identifier,k),this.O=I,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new L.$Od,this.L=[],this.M=new L.$Od,this.N=new L.$Od,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(I){this.B=I.slice(),this.C.clear(),this.D.clear(),I.forEach((b,y)=>{this.C.set(y,b),this.D.set(b,y)});const k=(0,o.$uF)(this.O,"quickPickItemTooltip"),d=[];for(let b=0;b<I.length;b++){const y=I[b];if(y.kind===$.QuickPickItemKind.Separator)d.push({type:"separator",label:y.label});else{y.tooltip&&!k&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const C=y.iconPath?c(y.iconPath):void 0;d.push({handle:b,label:y.label,iconPath:C?.iconPath,iconClass:C?.iconClass,description:y.description,detail:y.detail,picked:y.picked,alwaysShow:y.alwaysShow,tooltip:k?v.MarkdownString.fromStrict(y.tooltip):void 0,buttons:y.buttons?.map((B,H)=>({...c(B.iconPath),tooltip:B.tooltip,handle:H}))})}}this.z({items:d})}get canSelectMany(){return this.E}set canSelectMany(I){this.E=I,this.z({canSelectMany:I})}get matchOnDescription(){return this.F}set matchOnDescription(I){this.F=I,this.z({matchOnDescription:I})}get matchOnDetail(){return this.G}set matchOnDetail(I){this.G=I,this.z({matchOnDetail:I})}get sortByLabel(){return this.H}set sortByLabel(I){this.H=I,this.z({sortByLabel:I})}get keepScrollPosition(){return this.I}set keepScrollPosition(I){this.I=I,this.z({keepScrollPosition:I})}get activeItems(){return this.J}set activeItems(I){this.J=I.filter(k=>this.D.has(k)),this.z({activeItems:this.J.map(k=>this.D.get(k))})}get selectedItems(){return this.L}set selectedItems(I){this.L=I.filter(k=>this.D.has(k)),this.z({selectedItems:this.L.map(k=>this.D.get(k))})}_fireDidChangeActive(I){const k=(0,g.$Gb)(I.map(d=>this.C.get(d)));this.J=k,this.K.fire(k)}_fireDidChangeSelection(I){const k=(0,g.$Gb)(I.map(d=>this.C.get(d)));this.L=k,this.M.fire(k)}_fireDidTriggerItemButton(I,k){const d=this.C.get(I);if(!d||!d.buttons||!d.buttons.length)return;const b=d.buttons[k];b&&this.N.fire({button:b,item:d})}}class w extends a{constructor(I,k){super(I.identifier,k),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(I){this.B=I,this.z({password:I})}get prompt(){return this.C}set prompt(I){this.C=I,this.z({prompt:I})}get valueSelection(){return this.D}set valueSelection(I){this.D=I,this.z({valueSelection:I})}get validationMessage(){return this.E}set validationMessage(I){this.E=I,I?typeof I=="string"?this.z({validationMessage:I,severity:A.default.Error}):this.z({validationMessage:I.message,severity:I.severity??A.default.Error}):this.z({validationMessage:void 0,severity:A.default.Ignore})}}return new u(t,i)}e.$Vdc=p}),define(Ae[265],Re([1,0,2,5,67,6,12,3,18,138,15,22,45,8,23,14]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$Xdc=e.$Wdc=void 0;function i(y){if(y)return typeof y.iconPath=="string"?E.URI.file(y.iconPath):E.URI.isUri(y.iconPath)||o.ThemeIcon.isThemeIcon(y.iconPath)?y.iconPath:void 0}function n(y){if(y?.icon){if(E.URI.isUri(y.icon))return y.icon;if(o.ThemeIcon.isThemeIcon(y.icon))return y.icon;{const C=y.icon;return{light:C.light,dark:C.dark}}}else return}function u(y){if(y.icon){if(E.URI.isUri(y.icon))return y.icon;if(o.ThemeIcon.isThemeIcon(y.icon))return y.icon;{const C=y.icon;return{light:C.light,dark:C.dark}}}else return}function a(y,C){if(!y.iconPath&&!C.iconPath)return 0;if(y.iconPath){if(!C.iconPath)return 1}else return-1;const B=typeof y.iconPath=="string"?y.iconPath:E.URI.isUri(y.iconPath)?y.iconPath.fsPath:y.iconPath.id,H=typeof C.iconPath=="string"?C.iconPath:E.URI.isUri(C.iconPath)?C.iconPath.fsPath:C.iconPath.id;return(0,g.$vq)(B,H)}function l(y,C){let B=0;if(y.strikeThrough!==C.strikeThrough)return y.strikeThrough?1:-1;if(y.faded!==C.faded)return y.faded?1:-1;if(y.tooltip!==C.tooltip)return(y.tooltip||"").localeCompare(C.tooltip||"");if(B=a(y,C),B!==0)return B;if(y.light&&C.light)B=a(y.light,C.light);else{if(y.light)return 1;if(C.light)return-1}if(B!==0)return B;if(y.dark&&C.dark)B=a(y.dark,C.dark);else{if(y.dark)return 1;if(C.dark)return-1}return B}function r(y,C){if(y.command!==C.command)return y.command<C.command?-1:1;if(y.title!==C.title)return y.title<C.title?-1:1;if(y.tooltip!==C.tooltip){if(y.tooltip!==void 0&&C.tooltip!==void 0)return y.tooltip<C.tooltip?-1:1;if(y.tooltip!==void 0)return 1;if(C.tooltip!==void 0)return-1}if(y.arguments===C.arguments)return 0;if(y.arguments)if(C.arguments){if(y.arguments.length!==C.arguments.length)return y.arguments.length-C.arguments.length}else return 1;else return-1;for(let B=0;B<y.arguments.length;B++){const H=y.arguments[B],U=C.arguments[B];if(H!==U)return H<U?-1:1}return 0}function s(y,C){let B=(0,g.$vq)(y.resourceUri.fsPath,C.resourceUri.fsPath,!0);if(B!==0)return B;if(y.command&&C.command)B=r(y.command,C.command);else{if(y.command)return 1;if(C.command)return-1}if(B!==0)return B;if(y.decorations&&C.decorations)B=l(y.decorations,C.decorations);else{if(y.decorations)return 1;if(C.decorations)return-1}return B}function c(y,C){for(let B=0;B<y.length;B++)if(y[B]!==C[B])return!1;return!0}function h(y,C){return y.command===C.command&&y.title===C.title&&y.tooltip===C.tooltip&&(y.arguments&&C.arguments?c(y.arguments,C.arguments):y.arguments===C.arguments)}function w(y,C){return(0,D.$tb)(y,C,h)}function m(y,C){return y===C?!0:!y||!C?!1:y.id===C.id&&y.label===C.label&&y.upstream?.id===C.upstream?.id&&y.upstream?.label===C.upstream?.label}class I{#e;#t;get value(){return this.d}set value(C){C=C??"",this.#e.$setInputBoxValue(this.o,C),this.q(C)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(C){this.#e.$setInputBoxPlaceholder(this.o,C),this.f=C}get validateInput(){return(0,p.$vF)(this.m,"scmValidation"),this.g}set validateInput(C){if((0,p.$vF)(this.m,"scmValidation"),C&&typeof C!="function")throw new Error(`[${this.m.identifier.value}]: Invalid SCM input box validation function`);this.g=C,this.#e.$setValidationProviderIsEnabled(this.o,!!C)}get enabled(){return this.h}set enabled(C){C=!!C,this.h!==C&&(this.h=C,this.#e.$setInputBoxEnablement(this.o,C))}get visible(){return this.j}set visible(C){C=!!C,this.j!==C&&(this.j=C,this.#e.$setInputBoxVisibility(this.o,C))}get actionButton(){return(0,p.$vF)(this.m,"scmInputBoxActionButton"),this.k}set actionButton(C){(0,p.$vF)(this.m,"scmInputBoxActionButton"),this.l.value=new M.$Qc,this.k=C;const B=C!==void 0?{command:this.n.converter.toInternal(C.command,this.l.value),icon:n(C),enabled:C.enabled}:void 0;this.#e.$setInputBoxActionButton(this.o,B??null)}get document(){return(0,p.$vF)(this.m,"scmTextDocument"),this.#t.getDocument(this.p)}constructor(C,B,H,U,z,F){this.m=C,this.n=B,this.o=z,this.p=F,this.d="",this.e=new L.$Od,this.f="",this.h=!0,this.j=!0,this.l=new M.$Sc,this.#t=H,this.#e=U}showValidationMessage(C,B){(0,p.$vF)(this.m,"scmValidation"),this.#e.$showValidationMessage(this.o,C,B)}$onInputBoxValueChange(C){this.q(C)}q(C){this.d=C,this.e.fire(C)}}e.$Wdc=I;class k{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(C){this.v=C,this.q.$updateGroupLabel(this.t,this.handle,C)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(C){this.p=C,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(C){this.f=[...C],this.k.fire()}constructor(C,B,H,U,z){this.q=C,this.s=B,this.t=H,this.u=U,this.v=z,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new L.$Od,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new L.$Od,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=k.d++}getResourceState(C){return this.g.get(C)}$executeResourceCommand(C,B){const H=this.h.get(C);return H?(0,R.$Ng)(()=>this.s.executeCommand(H.command,...H.arguments||[],B)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const C=[...this.f].sort(s),H=(0,D.$Cb)(this.o,C,s).map(F=>{const N=F.toInsert.map(x=>{const J=this.e++;this.g.set(J,x);const ye=x.resourceUri;let De;if(x.command)if(x.command.command==="vscode.open"||x.command.command==="vscode.diff"){const Pe=new M.$Qc;De=this.s.converter.toInternal(x.command,Pe),this.j.set(J,Pe)}else this.h.set(J,x.command);const Ce=i(x.decorations),ge=x.decorations&&i(x.decorations.light)||Ce,we=x.decorations&&i(x.decorations.dark)||Ce,re=[ge,we],oe=x.decorations&&x.decorations.tooltip||"",ve=x.decorations&&!!x.decorations.strikeThrough,ee=x.decorations&&!!x.decorations.faded,W=x.contextValue||"";return{rawResource:[J,ye,re,oe,ve,ee,W,De],handle:J}});return{start:F.start,deleteCount:F.deleteCount,toInsert:N}}),U=H.map(({start:F,deleteCount:N,toInsert:x})=>[F,N,x.map(J=>J.rawResource)]),z=H.reverse();for(const{start:F,deleteCount:N,toInsert:x}of z){const J=x.map(De=>De.handle),ye=this.n.splice(F,N,...J);for(const De of ye)this.g.delete(De),this.h.delete(De),this.j.get(De)?.dispose(),this.j.delete(De)}return this.o=C,U}dispose(){this.l=!0,this.m.fire()}}class d{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(C){this.g!==C&&(this.g=C,this.#e.$updateSourceControl(this.x,{count:C}))}get quickDiffProvider(){return this.h}set quickDiffProvider(C){this.h=C;let B;(0,p.$uF)(this.y,"quickDiffProvider")&&(B=C?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!C,quickDiffLabel:B})}get historyProvider(){return(0,p.$vF)(this.y,"scmHistoryProvider"),this.j}set historyProvider(C){(0,p.$vF)(this.y,"scmHistoryProvider"),this.j=C,this.k.value=new M.$Qc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!C}),C&&(this.k.value.add(C.onDidChangeCurrentHistoryItemGroup(()=>{m(this.l,C?.currentHistoryItemGroup)||(this.l=C?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.l))})),this.k.value.add(C.onDidChangeActionButton(()=>{(0,p.$vF)(this.y,"scmActionButton"),this.m.value=new M.$Qc;const B=C.actionButton!==void 0?{command:this.z.converter.toInternal(C.actionButton.command,this.m.value),description:C.actionButton.description,enabled:C.actionButton.enabled}:void 0;this.#e.$onDidChangeHistoryProviderActionButton(this.x,B??null)})))}get commitTemplate(){return this.n}set commitTemplate(C){C!==this.n&&(this.n=C,this.#e.$updateSourceControl(this.x,{commitTemplate:C}))}get acceptInputCommand(){return this.p}set acceptInputCommand(C){this.o.value=new M.$Qc,this.p=C;const B=this.z.converter.toInternal(C,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:B})}get actionButton(){return(0,p.$vF)(this.y,"scmActionButton"),this.s}set actionButton(C){(0,p.$vF)(this.y,"scmActionButton"),this.q.value=new M.$Qc,this.s=C;const B=C!==void 0?{command:this.z.converter.toInternal(C.command,this.q.value),secondaryCommands:C.secondaryCommands?.map(H=>H.map(U=>this.z.converter.toInternal(U,this.q.value))),description:C.description,enabled:C.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:B??null})}get statusBarCommands(){return this.u}set statusBarCommands(C){if(this.u&&C&&w(this.u,C))return;this.t.value=new M.$Qc,this.u=C;const B=(C||[]).map(H=>this.z.converter.toInternal(H,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:B})}get selected(){return this.v}constructor(C,B,H,U,z,F,N){this.y=C,this.z=U,this.A=z,this.B=F,this.C=N,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new M.$Sc,this.m=new M.$Sc,this.n=void 0,this.o=new M.$Sc,this.p=void 0,this.q=new M.$Sc,this.t=new M.$Sc,this.u=void 0,this.v=!1,this.w=new L.$Od,this.onDidChangeSelection=this.w.event,this.x=d.d++,this.D=new Map,this.E=new Set,this.#e=H;const x=E.URI.from({scheme:f.Schemas.vscodeSourceControl,path:`${z}/scm${this.x}/input`,query:N?`rootUri=${encodeURIComponent(N.toString())}`:void 0});this.f=new I(C,U,B,this.#e,this.x,x),this.#e.$registerSourceControl(this.x,z,F,N,x)}createResourceGroup(C,B){const H=new k(this.#e,this.z,this.x,C,B),U=L.Event.once(H.onDidDispose)(()=>this.D.delete(H));return this.D.set(H,U),this.eventuallyAddResourceGroups(),H}eventuallyAddResourceGroups(){const C=[],B=[];for(const[H,U]of this.D){U.dispose();const z=H.onDidUpdateResourceStates(()=>{this.E.add(H),this.eventuallyUpdateResourceStates()});L.Event.once(H.onDidDispose)(()=>{this.E.delete(H),z.dispose(),this.e.delete(H.handle),this.#e.$unregisterGroup(this.x,H.handle)}),C.push([H.handle,H.id,H.label,H.features]);const F=H._takeResourceStateSnapshot();F.length>0&&B.push([H.handle,F]),this.e.set(H.handle,H)}this.#e.$registerGroups(this.x,C,B),this.D.clear()}eventuallyUpdateResourceStates(){const C=[];this.E.forEach(B=>{const H=B._takeResourceStateSnapshot();H.length!==0&&C.push([B.handle,H])}),C.length>0&&this.#e.$spliceResourceStates(this.x,C),this.E.clear()}getResourceGroup(C){return this.e.get(C)}setSelectionState(C){this.v=C,this.w.fire(C)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(C=>C.dispose()),this.#e.$unregisterSourceControl(this.x)}}Ke([(0,P.$mh)(100)],d.prototype,"eventuallyAddResourceGroups",null),Ke([(0,P.$mh)(100)],d.prototype,"eventuallyUpdateResourceStates",null);let b=class{static{t=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(C,B,H,U){this.l=B,this.m=H,this.n=U,this.g=new Map,this.h=new S.$_l,this.j=new L.$Od,this.e=C.getProxy($.$vK.MainThreadSCM),this.f=C.getProxy($.$vK.MainThreadTelemetry),B.registerArgumentProcessor({processArgument:z=>{if(z&&z.$mid===3){const F=this.g.get(z.sourceControlHandle);if(!F)return z;const N=F.getResourceGroup(z.groupHandle);return N?N.getResourceState(z.handle):z}else if(z&&z.$mid===4){const F=this.g.get(z.sourceControlHandle);return F?F.getResourceGroup(z.groupHandle):z}else if(z&&z.$mid===5){const F=this.g.get(z.handle);return F||z}return z}})}createSourceControl(C,B,H,U){this.n.trace("ExtHostSCM#createSourceControl",C.identifier.value,B,H,U),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:C.identifier.value});const z=t.d++,F=new d(C,this.m,this.e,this.l,B,H,U);this.g.set(z,F);const N=this.h.get(C.identifier)||[];return N.push(F),this.h.set(C.identifier,N),F}getLastInputBox(C){this.n.trace("ExtHostSCM#getLastInputBox",C.identifier.value);const B=this.h.get(C.identifier),H=B&&B[B.length-1];return H&&H.inputBox}$provideOriginalResource(C,B,H){const U=E.URI.revive(B);this.n.trace("ExtHostSCM#$provideOriginalResource",C,U.toString());const z=this.g.get(C);return!z||!z.quickDiffProvider||!z.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$Ng)(()=>z.quickDiffProvider.provideOriginalResource(U,H)).then(F=>F||null)}$onInputBoxValueChange(C,B){this.n.trace("ExtHostSCM#$onInputBoxValueChange",C);const H=this.g.get(C);return H&&H.inputBox.$onInputBoxValueChange(B),Promise.resolve(void 0)}$executeResourceCommand(C,B,H,U){this.n.trace("ExtHostSCM#$executeResourceCommand",C,B,H);const z=this.g.get(C);if(!z)return Promise.resolve(void 0);const F=z.getResourceGroup(B);return F?F.$executeResourceCommand(H,U):Promise.resolve(void 0)}$validateInput(C,B,H){this.n.trace("ExtHostSCM#$validateInput",C);const U=this.g.get(C);return!U||!U.inputBox.validateInput?Promise.resolve(void 0):(0,R.$Ng)(()=>U.inputBox.validateInput(B,H)).then(z=>{if(!z)return Promise.resolve(void 0);const F=v.MarkdownString.fromStrict(z.message);return F?Promise.resolve([F,z.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(C){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",C),C!==void 0&&this.g.get(C)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=C,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(C,B,H){return await this.g.get(C)?.historyProvider?.resolveHistoryItemGroupBase(B,H)??void 0}async $resolveHistoryItemGroupCommonAncestor(C,B,H,U){return await this.g.get(C)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(B,H,U)??void 0}async $provideHistoryItems(C,B,H,U){return(await this.g.get(C)?.historyProvider?.provideHistoryItems(B,H,U))?.map(N=>({id:N.id,parentIds:N.parentIds,label:N.label,description:N.description,icon:u(N),timestamp:N.timestamp}))??void 0}async $provideHistoryItemChanges(C,B,H){return await this.g.get(C)?.historyProvider?.provideHistoryItemChanges(B,H)??void 0}};e.$Xdc=b,e.$Xdc=b=t=Ke([Ve(3,A.$bj)],b)}),define(Ae[84],Re([1,0,3,5,4]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ddc=e.$Cdc=void 0;class M{constructor($){this.b=new L.$Od,this.onDidChangePassword=this.b.event,this.a=$.getProxy(E.$vK.MainThreadSecretState)}async $onDidChangePassword($){this.b.fire($)}get($,D){return this.a.$getPassword($,D)}store($,D,g){return this.a.$setPassword($,D,g)}delete($,D){return this.a.$deletePassword($,D)}}e.$Cdc=M,e.$Ddc=(0,P.$Th)("IExtHostSecretState")}),define(Ae[266],Re([1,0,3,8,2]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zec=void 0;class M{static{this.a=0}constructor($,D){this.d=D,this.c=new Map,this.b=$.getProxy(E.$vK.MainThreadShare)}async $provideShare($,D,g){return await this.c.get($)?.provideShare({selection:L.Range.to(D.selection),resourceUri:P.URI.revive(D.resourceUri)},g)??void 0}registerShareProvider($,D){const g=M.a++;return this.c.set(g,D),this.b.$registerShareProvider(g,L.DocumentSelector.from($,this.d),D.id,D.label,D.priority),{dispose:()=>{this.b.$unregisterShareProvider(g),this.c.delete(g)}}}}e.$Zec=M}),define(Ae[267],Re([1,0,20,6,3]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2ec=void 0;class M{static{this.a=1}constructor($){this.c=new Map,this.d=new Map,this.b=$.getProxy(P.$vK.MainThreadSpeech)}async $createSpeechToTextSession($,D){const g=this.c.get($);if(!g)return;const A=new L.$Qc,S=new E.$Yd;this.d.set(D,S);const o=A.add(g.provideSpeechToTextSession(S.token));A.add(o.onDidChange(v=>{S.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(D,v)})),A.add(S.token.onCancellationRequested(()=>A.dispose()))}async $cancelSpeechToTextSession($){this.d.get($)?.dispose(!0),this.d.delete($)}registerProvider($,D,g){const A=M.a++;return this.c.set(A,g),this.b.$registerProvider(A,D,{extension:$,displayName:$.value}),(0,L.$Pc)(()=>{this.b.$unregisterProvider(A),this.c.delete(A)})}}e.$2ec=M}),define(Ae[268],Re([1,0,7,3,165,6,8,16]),function(pe,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zdc=e.$Ydc=void 0;class D{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new E.$sL("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new E.$sL("statusBarItem.warningForeground")]])}#e;#t;constructor(o,v,p,f,t,i=E.StatusBarAlignment.Left,n){if(this.i=!1,this.k="",this.q=new M.$Qc,this.#e=o,this.#t=v,t&&f){this.c=(0,E.$8K)(f.identifier,t);const u=p.get(this.c);u&&(i=u.alignLeft?E.StatusBarAlignment.Left:E.StatusBarAlignment.Right,n=u.priority,this.j=!0,this.name=u.name,this.text=u.text,this.tooltip=u.tooltip,this.command=u.command,this.accessibilityInformation=u.accessibilityInformation)}else this.c=String(D.a++);this.e=f,this.f=t,this.g=i,this.h=this.u(n)}u(o){if((0,$.$Df)(o))return o===Number.POSITIVE_INFINITY?Number.MAX_VALUE:o===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:o}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(o){this.k=o,this.v()}set name(o){this.m=o,this.v()}set tooltip(o){this.l=o,this.v()}set color(o){this.n=o,this.v()}set backgroundColor(o){o&&!D.b.has(o.id)&&(o=void 0),this.o=o,this.v()}set command(o){this.r?.fromApi!==o&&(this.p&&this.q.add(this.p),this.p=new M.$Qc,typeof o=="string"?this.r={fromApi:o,internal:this.#t.toInternal({title:"",command:o},this.p)}:o?this.r={fromApi:o,internal:this.#t.toInternal(o,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(o){this.t=o,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let o;this.e?this.f?o=`${this.e.identifier.value}.${this.f}`:o=this.e.identifier.value:o=this.f;let v;this.m?v=this.m:v=(0,P.localize)(0,null,this.e.displayName||this.e.name);let p=this.n;this.o&&(p=D.b.get(this.o.id));const f=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,o,this.e?.identifier.value,v,this.k,f,this.r?.internal,p,this.o,this.g===E.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Ydc=D;class g{constructor(o){this.b=[],this.a=o.createStatusBarEntry(void 0,"status.extensionMessage",E.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,P.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(o){const v={message:o};return this.b.unshift(v),this.c(),new E.$xK(()=>{const p=this.b.indexOf(v);p>=0&&(this.b.splice(p,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class A{constructor(o,v){this.e=new Map,this.a=o.getProxy(L.$vK.MainThreadStatusBar),this.b=v,this.c=new g(this)}$acceptStaticEntries(o){for(const v of o)this.e.set(v.entryId,v)}createStatusBarEntry(o,v,p,f){return new D(this.a,this.b,this.e,o,v,p,f)}setStatusBarMessage(o,v){const p=this.c.setMessage(o);let f;return typeof v=="number"?f=setTimeout(()=>p.dispose(),v):typeof v<"u"&&v.then(()=>p.dispose(),()=>p.dispose()),new E.$xK(()=>{p.dispose(),clearTimeout(f)})}}e.$Zdc=A}),define(Ae[85],Re([1,0,3,5,4]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rdc=e.$qdc=void 0;class M{constructor($,D){this.c=D,this.b=new L.$Od,this.onDidChangeStorage=this.b.event,this.a=$.getProxy(E.$vK.MainThreadStorage)}registerExtensionStorageKeysToSync($,D){this.a.$registerExtensionStorageKeysToSync($,D)}async initializeExtensionStorage($,D,g){const A=await this.a.$initializeExtensionStorage($,D);let S;return A&&(S=this.d($,D,A)),S||g}setValue($,D,g){return this.a.$setValue($,D,g)}$acceptValue($,D,g){const A=this.d($,D,g);A&&this.b.fire({shared:$,key:D,value:A})}d($,D,g){try{return JSON.parse(g)}catch(A){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${D}, global: ${$}): ${A}`)}}}e.$qdc=M,e.$rdc=(0,P.$Th)("IExtHostStorage")}),define(Ae[86],Re([1,0,4,27,15,64,2]),function(pe,e,E,L,P,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xdc=e.$wdc=void 0,e.$wdc=(0,E.$Th)("IExtensionStoragePaths");let $=class{constructor(g,A,S){this.d=A,this.f=S,this.a=g.workspace??void 0,this.b=g.environment,this.whenReady=this.h().then(o=>this.c=o)}async g(g){return R.URI.joinPath(this.b.workspaceStorageHome,g)}async h(){if(!this.a)return Promise.resolve(void 0);const g=this.a.id,A=await this.g(g);try{return await this.f.value.stat(A),this.d.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",A),await this.f.value.createDirectory(A),await this.f.value.writeFile(R.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),A}catch(S){this.d.error("[ExtHostStorage]",S);return}}workspaceValue(g){if(this.c)return R.URI.joinPath(this.c,g.identifier.value)}globalValue(g){return R.URI.joinPath(this.b.globalStorageHome,g.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$xdc=$,e.$xdc=$=Ke([Ve(0,L.$NM),Ve(1,P.$bj),Ve(2,M.$vdc)],$)}),define(Ae[65],Re([1,0,5,3,4,2,17,6,7,167,11,195,20,38,196,45,12,8,32]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f,t,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bdc=e.$Adc=e.$zdc=e.$ydc=void 0,e.$ydc=(0,P.$Th)("IExtHostTerminalService");class u{constructor(d,b,y,C){this.l=d,this._id=b,this.m=y,this.n=C,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(H=>this.f=H);const B=this;this.value={get name(){return B.n||""},get processId(){return B.b},get creationOptions(){return B.m},get exitStatus(){return B.h},get state(){return B.j},get selection(){return B.k},sendText(H,U=!0){B.q(),B.l.$sendText(B._id,H,U)},show(H){B.q(),B.l.$show(B._id,H)},hide(){B.q(),B.l.$hide(B._id)},dispose(){B.a||(B.a=!0,B.l.$dispose(B._id))},get dimensions(){if(!(B.d===void 0||B.g===void 0))return{columns:B.d,rows:B.g}}}}async create(d,b){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:d.name,shellPath:d.shellPath??void 0,shellArgs:d.shellArgs??void 0,cwd:d.cwd??b?.cwd??void 0,env:d.env??void 0,icon:w(d.iconPath)??void 0,color:f.ThemeColor.isThemeColor(d.color)?d.color.id:void 0,initialText:d.message??void 0,strictEnv:d.strictEnv??void 0,hideFromUser:d.hideFromUser??void 0,isFeatureTerminal:b?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:b?.useShellEnvironment??void 0,location:b?.location||this.o(d.location,b?.resolvedExtHostIdentifier),isTransient:d.isTransient??void 0})}async createExtensionTerminal(d,b,y,C){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:y,color:f.ThemeColor.isThemeColor(C)?C.id:void 0,location:this.o(d,b),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(d,b){return typeof d=="object"?"parentTerminal"in d&&d.parentTerminal&&b?{parentTerminal:b}:"viewColumn"in d?{viewColumn:i.ViewColumn.from(d.viewColumn),preserveFocus:d.preserveFocus}:void 0:d}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(d){this.n=d}setExitStatus(d,b){this.h=Object.freeze({code:d,reason:b})}setDimensions(d,b){return d===this.d&&b===this.g||d===0||b===0?!1:(this.d=d,this.g=b,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(d){this.k=d}_setProcessId(d){this.f?(this.f(d),this.f=void 0):this.b.then(b=>{b!==d&&(this.b=Promise.resolve(d))})}}e.$zdc=u;class a{get onProcessReady(){return this.b.event}constructor(d){this.g=d,this.id=0,this.shouldPersist=!1,this.a=new E.$Od,this.onProcessData=this.a.event,this.b=new E.$Od,this.d=new E.$Od,this.onDidChangeProperty=this.d.event,this.f=new E.$Od,this.onProcessExit=this.f.event}refreshProperty(d){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${d}`)}updateProperty(d,b){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${d}, value: ${b}`)}async start(){}shutdown(){this.g.close()}input(d){this.g.handleInput?.(d)}resize(d,b){this.g.setDimensions?.({columns:d,rows:b})}clearBuffer(){}async processBinary(d){}acknowledgeDataEvent(d){}async setUnicodeVersion(d){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(d){this.g.onDidWrite(b=>this.a.fire(b)),this.g.onDidClose?.((b=void 0)=>{this.f.fire(b===void 0?void 0:b)}),this.g.onDidOverrideDimensions?.(b=>{b&&this.d.fire({type:"overrideDimensions",value:{cols:b.columns,rows:b.rows}})}),this.g.onDidChangeName?.(b=>{this.d.fire({type:"title",value:b})}),this.g.open(d||void 0),d&&this.g.setDimensions?.(d),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let l=1,r=class extends $.$Rc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(d=>d.value)}constructor(d,b,y){super(),this.Q=b,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new $.$Sc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new E.$Od,this.onDidCloseTerminal=this.H.event,this.I=new E.$Od,this.onDidOpenTerminal=this.I.event,this.J=new E.$Od,this.onDidChangeActiveTerminal=this.J.event,this.L=new E.$Od,this.onDidChangeTerminalDimensions=this.L.event,this.M=new E.$Od,this.onDidChangeTerminalState=this.M.event,this.N=new E.$Od,this.onDidChangeShell=this.N.event,this.O=new E.$Od({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new E.$Od({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=y.getProxy(L.$vK.MainThreadTerminalService),this.y=new p.$eqb(this.a.$sendProcessData),this.a.$registerProcessSupport(d),this.Q.registerArgumentProcessor({processArgument:C=>{const B=H=>{const U=H;return this.W(U.instanceId)?.value};switch(C?.$mid){case 15:return B(C);default:{if(Array.isArray(C))for(let H=0;H<C.length&&C[H].$mid===15;H++)C[H]=B(C[H]);return C}}}}),this.B({dispose:()=>{for(const[C,B]of this.g)B.shutdown(!0)}})}getDefaultShell(d){return(d?this.u:this.s)?.path||""}getDefaultShellArgs(d){return(d?this.u:this.s)?.args||[]}createExtensionTerminal(d,b){const y=new u(this.a,(0,v.$fg)(),d,d.name),C=new a(d.pty);return y.createExtensionTerminal(d.location,this.R(d,b).resolvedExtHostIdentifier,w(d.iconPath),m(d.color)).then(B=>{const H=this.S(B,C);this.h[B]=H}),this.f.push(y),y.value}R(d,b){if(b=b||{},d.location&&typeof d.location=="object"&&"parentTerminal"in d.location){const y=d.location.parentTerminal;if(y){const C=this.f.find(B=>B.value===y);C&&(b.resolvedExtHostIdentifier=C._id)}}else d.location&&typeof d.location!="object"?b.location=d.location:b.location&&typeof b.location=="object"&&"splitActiveTerminal"in b.location&&(b.location={splitActiveTerminal:!0});return b}attachPtyToTerminal(d,b){if(!this.W(d))throw new Error(`Cannot resolve terminal with id ${d} for virtual process`);const C=new a(b),B=this.S(d,C);this.h[d]=B}async $acceptActiveTerminalChanged(d){const b=this.b;if(d===null){this.b=void 0,b!==this.b&&this.J.fire(this.b);return}const y=this.W(d);y&&(this.b=y,b!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(d,b){const y=this.W(d);y&&this.O.fire({terminal:y.value,data:b})}async $acceptTerminalDimensions(d,b,y){const C=this.W(d);C&&C.setDimensions(b,y)&&this.L.fire({terminal:C.value,dimensions:C.value.dimensions})}async $acceptDidExecuteCommand(d,b){const y=this.W(d);y&&this.P.fire({terminal:y.value,...b})}async $acceptTerminalMaximumDimensions(d,b,y){this.g.get(d)?.resize(b,y)}async $acceptTerminalTitleChange(d,b){const y=this.W(d);y&&(y.name=b)}async $acceptTerminalClosed(d,b,y){const C=this.Y(this.f,d);if(C!==null){const B=this.f.splice(C,1)[0];B.setExitStatus(b,y),this.H.fire(B.value)}}$acceptTerminalOpened(d,b,y,C){if(b){const U=this.Y(this.f,b);if(U!==null){this.f[U]._id=d,this.I.fire(this.terminals[U]),this.f[U].isOpen=!0;return}}const B={name:C.name,shellPath:C.executable,shellArgs:C.args,cwd:typeof C.cwd=="string"?C.cwd:M.URI.revive(C.cwd),env:C.env,hideFromUser:C.hideFromUser},H=new u(this.a,d,B,y);this.f.push(H),this.I.fire(H.value),H.isOpen=!0}async $acceptTerminalProcessId(d,b){this.W(d)?._setProcessId(b)}async $startExtensionTerminal(d,b){const y=this.W(d);if(!y)return{message:(0,g.localize)(0,null,d)};y.isOpen||await new Promise(B=>{const H=this.onDidOpenTerminal(async U=>{U===y.value&&(H.dispose(),B())})});const C=this.g.get(d);C?C.startSendingEvents(b):this.j[d]={initialDimensions:b}}S(d,b){const y=new $.$Qc;y.add(b.onProcessReady(B=>this.a.$sendProcessReady(d,B.pid,B.cwd,B.windowsPty))),y.add(b.onDidChangeProperty(B=>this.a.$sendProcessProperty(d,B))),this.y.startBuffering(d,b.onProcessData),y.add(b.onProcessExit(B=>this.U(d,B))),this.g.set(d,b);const C=this.j[d];return C&&b instanceof a&&(b.startSendingEvents(C.initialDimensions),delete this.j[d]),y}$acceptProcessAckDataEvent(d,b){this.g.get(d)?.acknowledgeDataEvent(b)}$acceptProcessInput(d,b){this.g.get(d)?.input(b)}$acceptTerminalInteraction(d){const b=this.W(d);b?.setInteractedWith()&&this.M.fire(b.value)}$acceptTerminalSelection(d,b){this.W(d)?.setSelection(b)}$acceptProcessResize(d,b,y){try{this.g.get(d)?.resize(b,y)}catch(C){if(C.code!=="EPIPE"&&C.code!=="ERR_IPC_CHANNEL_CLOSED")throw C}}$acceptProcessShutdown(d,b){this.g.get(d)?.shutdown(b)}$acceptProcessRequestInitialCwd(d){this.g.get(d)?.getInitialCwd().then(b=>this.a.$sendProcessProperty(d,{type:"initialCwd",value:b}))}$acceptProcessRequestCwd(d){this.g.get(d)?.getCwd().then(b=>this.a.$sendProcessProperty(d,{type:"cwd",value:b}))}$acceptProcessRequestLatency(d){return Promise.resolve(d)}registerLinkProvider(d){return this.z.add(d),this.z.size===1&&this.a.$startLinkProvider(),new D.$xK(()=>{this.z.delete(d),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(d,b,y){if(this.C.has(b))throw new Error(`Terminal profile provider "${b}" already registered`);return this.C.set(b,y),this.a.$registerProfileProvider(b,d.identifier.value),new D.$xK(()=>{this.C.delete(b),this.a.$unregisterProfileProvider(b)})}registerTerminalQuickFixProvider(d,b,y){if(this.D.has(d))throw new Error(`Terminal quick fix provider "${d}" is already registered`);return this.D.set(d,y),this.a.$registerQuickFixProvider(d,b),new D.$xK(()=>{this.D.delete(d),this.a.$unregisterQuickFixProvider(d)})}async $provideTerminalQuickFixes(d,b){const y=new o.$Yd().token;if(y.isCancellationRequested)return;const C=this.D.get(d);if(!C)return;const B=await C.provideTerminalQuickFixes(b,y);if(B===null||Array.isArray(B)&&B.length===0)return;const H=new $.$Qc;if(this.w.value=H,!Array.isArray(B))return B?i.TerminalQuickFix.from(B,this.Q.converter,H):void 0;const U=[];for(const z of B){const F=i.TerminalQuickFix.from(z,this.Q.converter,H);F&&U.push(F)}return U}async $createContributedProfileTerminal(d,b){const y=new o.$Yd().token;let C=await this.C.get(d)?.provideTerminalProfile(y);if(!y.isCancellationRequested){if(C&&!("options"in C)&&(C={options:C}),!C||!("options"in C))throw new Error(`No terminal profile options provided for id "${d}"`);if("pty"in C.options){this.createExtensionTerminal(C.options,b);return}this.createTerminalFromOptions(C.options,b)}}async $provideLinks(d,b){const y=this.W(d);if(!y)return[];this.F.delete(d),this.G.get(d)?.dispose(!0);const B=new o.$Yd;this.G.set(d,B);const H=[],U={terminal:y.value,line:b},z=[];for(const x of this.z)z.push(t.Promises.withAsyncBody(async J=>{B.token.onCancellationRequested(()=>J({provider:x,links:[]}));const ye=await x.provideTerminalLinks(U,B.token)||[];B.token.isCancellationRequested||J({provider:x,links:ye})}));const F=await Promise.all(z);if(B.token.isCancellationRequested)return[];const N=new Map;for(const x of F)x&&x.links.length>0&&H.push(...x.links.map(J=>{const ye={id:l++,startIndex:J.startIndex,length:J.length,label:J.tooltip};return N.set(ye.id,{provider:x.provider,link:J}),ye}));return this.F.set(d,N),H}$activateLink(d,b){const y=this.F.get(d)?.get(b);y&&y.provider.handleTerminalLink(y.link)}U(d,b){this.y.stopBuffering(d),this.g.delete(d),delete this.j[d];const y=this.h[d];y&&(y.dispose(),delete this.h[d]),this.a.$sendProcessExit(d,b)}W(d){return this.X(this.f,d)}X(d,b){const y=this.Y(d,b);return y!==null?d[y]:null}Y(d,b){const y=d.findIndex(C=>C._id===b);return y===-1?null:y}getEnvironmentVariableCollection(d){let b=this.n.get(d.identifier.value);return b||(b=new s,this.$(d.identifier.value,b)),b.getScopedEnvironmentVariableCollection(void 0)}Z(d,b){const y=(0,S.$or)(b.map),C=(0,S.$pr)(b.descriptionMap);this.a.$setEnvironmentVariableCollection(d,b.persistent,y.length===0?void 0:y,C)}$initEnvironmentVariableCollections(d){d.forEach(b=>{const y=b[0],C=new s(b[1]);this.$(y,C)})}$acceptDefaultProfile(d,b){const y=this.s;this.s=d,this.u=b,y?.path!==d.path&&this.N.fire(d.path)}$(d,b){this.n.set(d,b),b.onDidChangeCollection(()=>{this.Z(d,b)})}};e.$Adc=r,e.$Adc=r=Ke([Ve(1,n.$TM),Ve(2,R.$xM)],r);class s{get persistent(){return this.b}set persistent(d){this.b=d,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(d){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new E.$Od,this.map=new Map(d)}getScopedEnvironmentVariableCollection(d){const b=this.h(d);let y=this.a.get(b);return y||(y=new c(this,d),this.a.set(b,y),y.onDidChangeCollection(()=>this.d.fire())),y}replace(d,b,y,C){this.f(d,{value:b,type:D.EnvironmentVariableMutatorType.Replace,options:y??{applyAtProcessCreation:!0},scope:C})}append(d,b,y,C){this.f(d,{value:b,type:D.EnvironmentVariableMutatorType.Append,options:y??{applyAtProcessCreation:!0},scope:C})}prepend(d,b,y,C){this.f(d,{value:b,type:D.EnvironmentVariableMutatorType.Prepend,options:y??{applyAtProcessCreation:!0},scope:C})}f(d,b){if(b.options&&b.options.applyAtProcessCreation===!1&&!b.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const y=this.g(d,b.scope),C=this.map.get(y),B=b.options?{applyAtProcessCreation:b.options.applyAtProcessCreation??!1,applyAtShellIntegration:b.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!C||C.value!==b.value||C.type!==b.type||C.options?.applyAtProcessCreation!==B.applyAtProcessCreation||C.options?.applyAtShellIntegration!==B.applyAtShellIntegration||C.scope?.workspaceFolder?.index!==b.scope?.workspaceFolder?.index){const H=this.g(d,b.scope),U={variable:d,...b,options:B};this.map.set(H,U),this.d.fire()}}get(d,b){const y=this.g(d,b),C=this.map.get(y);return C?I(C):void 0}g(d,b){const y=this.h(b);return y.length?`${d}:::${y}`:d}h(d){return this.j(d?.workspaceFolder)??""}j(d){return d?d.uri.toString():void 0}getVariableMap(d){const b=new Map;for(const[y,C]of this.map)this.h(C.scope)===this.h(d)&&b.set(C.variable,I(C));return b}delete(d,b){const y=this.g(d,b);this.map.delete(y),this.d.fire()}clear(d){if(d?.workspaceFolder){for(const[b,y]of this.map)y.scope?.workspaceFolder?.index===d.workspaceFolder.index&&this.map.delete(b);this.k(d)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(d,b){const y=this.h(b),C=this.descriptionMap.get(y);if(!C||C.description!==d){let B;typeof d=="string"?B=d:B=d?.value.split(`

`)[0];const H={description:B,scope:b};this.descriptionMap.set(y,H),this.d.fire()}}getDescription(d){const b=this.h(d);return this.descriptionMap.get(b)?.description}k(d){const b=this.h(d);this.descriptionMap.delete(b)}}class c{get persistent(){return this.b.persistent}set persistent(d){this.b.persistent=d}get onDidChangeCollection(){return this.a&&this.a.event}constructor(d,b){this.b=d,this.d=b,this.a=new E.$Od}getScoped(d){return this.b.getScopedEnvironmentVariableCollection(d)}replace(d,b,y){this.b.replace(d,b,y,this.d)}append(d,b,y){this.b.append(d,b,y,this.d)}prepend(d,b,y){this.b.prepend(d,b,y,this.d)}get(d){return this.b.get(d,this.d)}forEach(d,b){this.b.getVariableMap(this.d).forEach((y,C)=>d.call(b,C,y,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(d){this.b.delete(d,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(d){this.b.setDescription(d,this.d)}get description(){return this.b.getDescription(this.d)}}let h=class extends r{constructor(d,b){super(!1,d,b)}createTerminal(d,b,y){throw new A.$$}createTerminalFromOptions(d,b){throw new A.$$}};e.$Bdc=h,e.$Bdc=h=Ke([Ve(0,n.$TM),Ve(1,R.$xM)],h);function w(k){if(!(!k||typeof k=="string"))return"id"in k?{id:k.id,color:k.color}:k}function m(k){return f.ThemeColor.isThemeColor(k)?k:void 0}function I(k){const d={...k};return delete d.scope,d.options=d.options??void 0,delete d.variable,d}}),define(Ae[269],Re([1,0,300,12,24,20,5,220,97,6,26,16,38,3,17,108,8,7,48,77,60,23]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f,t,i,n,u,a,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lec=e.$Kec=e.$Jec=e.$Iec=void 0;let r=class extends g.$Rc{constructor(U,z,F){super(),this.u=F,this.f=this.B(new R.$Od),this.g=new Map,this.s=this.B(new R.$Od),this.onResultsChanged=this.f.event,this.results=[],this.h=U.getProxy(v.$vK.MainThreadTesting),this.m=new y(this.h),this.j=new w(this.h),z.registerArgumentProcessor({processArgument:N=>{switch(N?.$mid){case 16:{const x=N,J=x.tests[x.tests.length-1].item.extId;return this.g.get(n.$lJ.root(J))?.collection.tree.get(J)?.actual??(0,f.$JM)(N)}case 18:{const{extId:x,message:J}=N;return{test:this.g.get(n.$lJ.root(x))?.collection.tree.get(x)?.actual,message:t.TestMessage.to(J)}}default:return N}}}),z.registerCommand(!1,"testing.getExplorerSelection",async()=>{const N=await z.executeCommand("_testing.getExplorerSelection"),x=J=>{const ye=this.g.get(n.$lJ.root(J));if(ye)return n.$lJ.isRoot(J)?ye.controller:ye.collection.tree.get(J)?.actual};return{include:N?.include.map(x).filter(S.$Hf)||[],exclude:N?.exclude.map(x).filter(S.$Hf)||[]}})}createTestController(U,z,F,N){if(this.g.has(z))throw new Error(`Attempt to insert a duplicate controller with ID "${z}"`);const x=new g.$Qc,J=x.add(new f.$MM(z,F,this.u));J.root.label=F;const ye=new Map,De=new Set,Ce=this.h,ge={items:J.root.children,get label(){return F},set label(re){F=re,J.root.label=re,Ce.$updateController(z,{label:F})},get refreshHandler(){return N},set refreshHandler(re){N=re,Ce.$updateController(z,{canRefresh:!!re})},get id(){return z},createRunProfile:(re,oe,ve,ee,W,ue)=>{let Pe=(0,D.$Hi)(re);for(;ye.has(Pe);)Pe++;return new C(this.h,ye,U,De,this.s.event,z,Pe,re,oe,ve,ee,W,ue)},createTestItem(re,oe,ve){return new f.$KM(z,re,oe,ve)},createTestRun:(re,oe,ve=!0)=>this.j.createTestRun(U,z,J,re,oe,ve),invalidateTestResults:re=>{if(re===void 0)this.h.$markTestRetired(void 0);else{const oe=re instanceof Array?re:[re];this.h.$markTestRetired(oe.map(ve=>n.$lJ.fromExtHostTestItem(ve,z).toString()))}},set resolveHandler(re){J.resolveHandler=re},get resolveHandler(){return J.resolveHandler},dispose:()=>{x.dispose()}};Ce.$registerTestController(z,F,!!N),x.add((0,g.$Pc)(()=>Ce.$unregisterTestController(z)));const we={controller:ge,collection:J,profiles:ye,extension:U,activeProfiles:De};return this.g.set(z,we),x.add((0,g.$Pc)(()=>this.g.delete(z))),x.add(J.onDidGenerateDiff(re=>Ce.$publishDiff(z,re.map(a.TestsDiffOp.serialize)))),ge}createTestObserver(){return this.m.checkout()}async runTests(U,z=M.CancellationToken.None){const F=m(U);if(!F)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const N=this.g.get(F.controllerId);if(!N)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:U.include?.map(x=>n.$lJ.fromExtHostTestItem(x,N.collection.root.id).toString())??[N.collection.root.id],profileGroup:B[F.kind],profileId:F.profileId,controllerId:F.controllerId}],exclude:U.exclude?.map(x=>x.id)},z)}$syncTests(){for(const{collection:U}of this.g.values())U.flushDiff();return Promise.resolve()}$provideFileCoverage(U,z,F){return(0,E.$qb)(this.j.trackers,x=>x.id===U?x.getCoverage(z):void 0)?.provideFileCoverage(F)??Promise.resolve([])}$resolveFileCoverage(U,z,F,N){return(0,E.$qb)(this.j.trackers,J=>J.id===U?J.getCoverage(z):void 0)?.resolveFileCoverage(F,N)??Promise.resolve([])}$configureRunProfile(U,z){this.g.get(U)?.profiles.get(z)?.configureHandler?.()}$setActiveRunProfiles(U){const z=new Map;for(const[F,N]of Object.entries(U)){const x=this.g.get(F);if(!x)continue;const J=new Map,ye=N.filter(Ce=>!x.activeProfiles.has(Ce)),De=[...x.activeProfiles].filter(Ce=>!N.includes(Ce));for(const Ce of ye)J.set(Ce,!0),x.activeProfiles.add(Ce);for(const Ce of De)J.set(Ce,!1),x.activeProfiles.delete(Ce);J.size&&z.set(F,J)}this.s.fire(z)}async $refreshTests(U,z){await this.g.get(U)?.controller.refreshHandler?.(z)}$publishTestResults(U){this.results=Object.freeze(U.map(z=>(0,A.$_m)(t.TestResults.to(z))).concat(this.results).sort((z,F)=>F.completedAt-z.completedAt).slice(0,32)),this.f.fire()}async $expandTest(U,z){const F=this.g.get(n.$lJ.fromString(U).controllerId)?.collection;F&&(await F.expand(U,z<0?1/0:z),F.flushDiff())}$acceptDiff(U){this.m.applyDiff(U.map(a.TestsDiffOp.deserialize))}async $runControllerTests(U,z){return Promise.all(U.map(F=>this.w(F,!1,z)))}async $startContinuousRun(U,z){const F=new M.$Yd(z),N=await Promise.all(U.map(x=>this.w(x,!0,F.token)));return!z.isCancellationRequested&&!N.some(x=>x.error)&&await new Promise(x=>z.onCancellationRequested(x)),F.dispose(!0),N}async w(U,z,F){const N=this.g.get(U.controllerId);if(!N)return{};const{collection:x,profiles:J,extension:ye}=N,De=J.get(U.profileId);if(!De)return{};const Ce=U.testIds.map(oe=>x.tree.get(oe)).filter(S.$Hf),ge=U.excludeExtIds.map(oe=>N.collection.tree.get(oe)).filter(S.$Hf).filter(oe=>Ce.some(ve=>ve.fullId.compare(oe.fullId)===2));if(!Ce.length)return{};const we=new i.$6L(Ce.some(oe=>oe.actual instanceof f.$LM)?void 0:Ce.map(oe=>oe.actual),ge.map(oe=>oe.actual),De,z),re=(0,a.$nJ)(U)&&this.j.prepareForMainThreadTestRun(we,I.fromInternal(U,N.collection),ye,F);try{return await De.runHandler(we,F),{}}catch(oe){return{error:String(oe)}}finally{re&&(re.hasRunningTasks&&!F.isCancellationRequested&&await R.Event.toPromise(re.onEnd),re.dispose())}}$cancelExtensionTestRun(U){U===void 0?this.j.cancelAllRuns():this.j.cancelRunById(U)}};e.$Iec=r,e.$Iec=r=Ke([Ve(0,p.$xM)],r);const s=1e4;var c;(function(H){H[H.Running=0]="Running",H[H.Cancelling=1]="Cancelling",H[H.Ended=2]="Ended"})(c||(c={}));class h extends g.$Rc{get hasRunningTasks(){return this.f.size>0}get id(){return this.m.id}constructor(U,z,F){super(),this.m=U,this.s=z,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new R.$Od),this.onEnd=this.j.event,this.h=this.B(new M.$Yd(F));const N=this.B(new L.$8g(()=>this.u(),s));this.B(this.h.token.onCancellationRequested(()=>N.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.u()}getCoverage(U){return this.f.get(U)?.coverage}createRun(U){const z=this.m.id,F=this.m.controllerId,N=(0,o.$fg)(),x=new k(this.s,z,N),J=ge=>(we,...re)=>{if(De){console.warn(`Setting the state of test "${we.id}" is a no-op after the run ends.`);return}this.m.isIncluded(we)&&(this.y(we),ge(we,...re))},ye=(ge,we)=>{const re=we instanceof Array?we.map(t.TestMessage.from):[t.TestMessage.from(we)];if(ge.uri&&ge.range){const oe={range:t.Range.from(ge.range),uri:ge.uri};for(const ve of re)ve.location=ve.location||oe}this.s.$appendTestMessagesInRun(z,N,n.$lJ.fromExtHostTestItem(ge,F).toString(),re)};let De=!1;const Ce={isPersisted:this.m.isPersisted,token:this.h.token,name:U,get coverageProvider(){return x.coverageProvider},set coverageProvider(ge){x.coverageProvider=ge},enqueued:J(ge=>{this.s.$updateTestStateInRun(z,N,n.$lJ.fromExtHostTestItem(ge,F).toString(),1)}),skipped:J(ge=>{this.s.$updateTestStateInRun(z,N,n.$lJ.fromExtHostTestItem(ge,F).toString(),5)}),started:J(ge=>{this.s.$updateTestStateInRun(z,N,n.$lJ.fromExtHostTestItem(ge,F).toString(),2)}),errored:J((ge,we,re)=>{ye(ge,we),this.s.$updateTestStateInRun(z,N,n.$lJ.fromExtHostTestItem(ge,F).toString(),6,re)}),failed:J((ge,we,re)=>{ye(ge,we),this.s.$updateTestStateInRun(z,N,n.$lJ.fromExtHostTestItem(ge,F).toString(),4,re)}),passed:J((ge,we)=>{this.s.$updateTestStateInRun(z,N,n.$lJ.fromExtHostTestItem(ge,this.m.controllerId).toString(),3,we)}),appendOutput:(ge,we,re)=>{De||(re&&(this.m.isIncluded(re)?this.y(re):re=void 0),this.s.$appendOutputToRun(z,N,P.$ce.fromString(ge),we&&t.location.from(we),re&&n.$lJ.fromExtHostTestItem(re,F).toString()))},end:()=>{De||(De=!0,this.s.$finishedTestRunTask(z,N),this.f.delete(N),this.f.size||this.w())}};return this.f.set(N,{run:Ce,coverage:x}),this.s.$startedTestRunTask(z,{id:N,name:U,running:!0}),Ce}u(){for(const{run:U}of this.f.values())U.end()}w(){this.c!==2&&(this.c=2,this.j.fire())}y(U){if(!(U instanceof f.$KM))throw new u.$pM(U.id);if(this.g.has(n.$lJ.fromExtHostTestItem(U,this.m.controllerId).toString()))return;const z=[],F=this.m.colllection.root;for(;;){const N=t.TestItem.from(U);if(z.unshift(N),this.g.has(N.extId)||(this.g.add(N.extId),U===F))break;U=U.parent||F}this.s.$addTestsToRun(this.m.controllerId,this.m.id,z)}dispose(){this.w(),super.dispose()}}class w{get trackers(){return this.c.values()}constructor(U){this.d=U,this.c=new Map}prepareForMainThreadTestRun(U,z,F,N){return this.f(U,z,F,N)}cancelRunById(U){for(const z of this.c.values())if(z.id===U){z.cancel();return}}cancelAllRuns(){for(const U of this.c.values())U.cancel()}createTestRun(U,z,F,N,x,J){const ye=this.c.get(N);if(ye)return ye.createRun(x);const De=I.fromPublic(z,F,N,J),Ce=m(N);this.d.$startedExtensionTestRun({controllerId:z,continuous:!!N.continuous,profile:Ce&&{group:B[Ce.kind],id:Ce.profileId},exclude:N.exclude?.map(we=>n.$lJ.fromExtHostTestItem(we,F.root.id).toString())??[],id:De.id,include:N.include?.map(we=>n.$lJ.fromExtHostTestItem(we,F.root.id).toString())??[F.root.id],persist:J});const ge=this.f(N,De,U);return R.Event.once(ge.onEnd)(()=>{this.d.$finishedExtensionTestRun(De.id),ge.dispose()}),ge.createRun(x)}f(U,z,F,N){const x=new h(z,this.d,N);return this.c.set(U,x),R.Event.once(x.onEnd)(()=>this.c.delete(U)),x}}e.$Jec=w;const m=H=>{if(H.profile){if(!(H.profile instanceof C))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return H.profile}};class I{static fromPublic(U,z,F,N){return new I(U,(0,o.$fg)(),F.include?.map(x=>n.$lJ.fromExtHostTestItem(x,U).toString())??[U],F.exclude?.map(x=>n.$lJ.fromExtHostTestItem(x,U).toString())??[],N,z)}static fromInternal(U,z){return new I(U.controllerId,U.runId,U.testIds,U.excludeExtIds,!0,z)}constructor(U,z,F,N,x,J){this.controllerId=U,this.id=z,this.isPersisted=x,this.colllection=J,this.c=F.map(ye=>ye+"\0"),this.d=N.map(ye=>ye+"\0")}isIncluded(U){const z=n.$lJ.fromExtHostTestItem(U,this.controllerId).toString()+"\0";for(const F of this.d)if(z===F||z.startsWith(F))return!1;for(const F of this.c)if(z===F||z.startsWith(F))return!0;return!1}}e.$Kec=I;class k{set coverageProvider(U){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");U&&(this.c=U,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(U,z,F){this.f=U,this.g=z,this.h=F}async provideFileCoverage(U){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(U))());try{return(await this.d)?.map(t.TestCoverage.fromFile)??[]}catch(z){throw this.d=void 0,z}}async resolveFileCoverage(U,z){const F=await this.d;let N=F?.[U];return!this.c||!F||!N?[]:(N.detailedCoverage||(N=F[U]=await this.c.resolveFileCoverage?.(N,z)??N),N.detailedCoverage?.map(t.TestCoverage.fromDetailed)??[])}}class d{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(U){this.h=U,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(U){this.c.add(U)}update(U){Object.assign(U.revived,t.TestItem.toPlain(U.item)),this.c.has(U)||this.d.add(U)}remove(U){if(this.c.has(U)){this.c.delete(U);return}this.d.delete(U);const z=n.$lJ.parentId(U.item.extId);if(z&&this.g.has(z.toString())){this.g.add(U.item.extId);return}this.f.add(U)}getChangeEvent(){const{c:U,d:z,f:F}=this;return{get added(){return[...U].map(N=>N.revived)},get updated(){return[...z].map(N=>N.revived)},get removed(){return[...F].map(N=>N.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class b extends a.$sJ{constructor(){super(...arguments),this.q=new R.$Od,this.onDidChangeTests=this.q.event}get rootTests(){return this.f}getMirroredTestDataById(U){return this.d.get(U)}getMirroredTestDataByReference(U){return this.d.get(U.id)}p(U,z){return{...U,revived:t.TestItem.toPlain(U.item),depth:z?z.depth+1:0,children:new Set}}o(){return new d(this.q)}}class y{constructor(U){this.d=U}checkout(){this.c||(this.c=this.f());const U=this.c;return U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,get tests(){return[...U.tests.rootTests].map(z=>z.revived)},dispose:(0,$.$cb)(()=>{--U.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(U){return this.c?.tests.getMirroredTestDataByReference(U)}applyDiff(U){this.c?.tests.apply(U)}f(){const U=new b;return this.d.$subscribeToDiffs(),{observers:0,tests:U}}}class C{#e;#t;#i;#o;#r;get label(){return this.d}set label(U){U!==this.d&&(this.d=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:U}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(U){U!==this.g&&(this.g=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:U}))}get isDefault(){return this.f}set isDefault(U){U!==this.f&&(this.f=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:U}))}get tag(){return this._tag}set tag(U){U?.id!==this._tag?.id&&(this._tag=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:U?t.TestTag.namespace(this.controllerId,U.id):null}))}get configureHandler(){return this.c}set configureHandler(U){U!==this.c&&(this.c=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!U}))}get isSelected(){return(0,l.$vF)(this.#t,"testingActiveProfile"),this.#i.has(this.profileId)}get onDidChangeSelected(){return(0,l.$vF)(this.#t,"testingActiveProfile"),R.Event.chain(this.#o,U=>U.map(z=>z.get(this.controllerId)?.get(this.profileId)).filter(S.$Hf))}constructor(U,z,F,N,x,J,ye,De,Ce,ge,we=!1,re=void 0,oe=!1){this.controllerId=J,this.profileId=ye,this.d=De,this.kind=Ce,this.runHandler=ge,this.f=we,this._tag=re,this.g=oe,this.#e=U,this.#r=z,this.#t=F,this.#i=N,this.#o=x,z.set(ye,this);const ve=B[Ce];if(typeof ve!="number")throw new Error(`Unknown TestRunProfile.group ${Ce}`);this.#e.$publishTestRunProfile({profileId:ye,controllerId:J,tag:re?t.TestTag.namespace(this.controllerId,re.id):null,label:De,group:ve,isDefault:we,hasConfigurationHandler:!1,supportsContinuousRun:oe})}dispose(){this.#r?.delete(this.profileId)&&(this.#r=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$Lec=C;const B={[i.TestRunProfileKind.Coverage]:8,[i.TestRunProfileKind.Debug]:4,[i.TestRunProfileKind.Run]:2}}),define(Ae[270],Re([1,0,18,11,5,3,109,8,7]),function(pe,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1dc=void 0;class g{constructor(S,o){this.i=o,this.a=new P.$Od({onListenerError:L.$1}),this.b=new P.$Od({onListenerError:L.$1}),this.c=new P.$Od({onListenerError:L.$1}),this.d=new P.$Od({onListenerError:L.$1}),this.f=new P.$Od({onListenerError:L.$1}),this.g=new P.$Od({onListenerError:L.$1}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=S.getProxy(M.$vK.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(v=>this.g.fire(v)),this.i.onDidChangeActiveTextEditor(v=>this.f.fire(v))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(S){const o=this.i.allEditors();return S?o:o.map(v=>v.value)}async showTextDocument(S,o,v){let p;typeof o=="number"?p={position:$.ViewColumn.from(o),preserveFocus:v}:typeof o=="object"?p={position:$.ViewColumn.from(o.viewColumn),preserveFocus:o.preserveFocus,selection:typeof o.selection=="object"?$.Range.from(o.selection):void 0,pinned:typeof o.preview=="boolean"?!o.preview:void 0}:p={preserveFocus:!1};const f=await this.h.$tryShowTextDocument(S.uri,p),t=f&&this.i.getEditor(f);if(t)return t.value;throw f?new Error(`Could NOT open editor for "${S.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${S.uri.toString()}".`)}createTextEditorDecorationType(S,o){return new R.$EM(this.h,S,o).value}$acceptEditorPropertiesChanged(S,o){const v=this.i.getEditor(S);if(!v)throw new Error("unknown text editor");if(o.options&&v._acceptOptions(o.options),o.selections){const p=o.selections.selections.map($.Selection.to);v._acceptSelections(p)}if(o.visibleRanges){const p=E.$Gb(o.visibleRanges.map($.Range.to));v._acceptVisibleRanges(p)}if(o.options&&this.b.fire({textEditor:v.value,options:{...o.options,lineNumbers:$.TextEditorLineNumbersStyle.to(o.options.lineNumbers)}}),o.selections){const p=D.TextEditorSelectionChangeKind.fromValue(o.selections.source),f=o.selections.selections.map($.Selection.to);this.a.fire({textEditor:v.value,selections:f,kind:p})}if(o.visibleRanges){const p=E.$Gb(o.visibleRanges.map($.Range.to));this.c.fire({textEditor:v.value,visibleRanges:p})}}$acceptEditorPositionData(S){for(const o in S){const v=this.i.getEditor(o);if(!v)throw new Error("Unknown text editor");const p=$.ViewColumn.to(S[o]);v.value.viewColumn!==p&&(v._acceptViewColumn(p),this.d.fire({textEditor:v.value,viewColumn:p}))}}getDiffInformation(S){return Promise.resolve(this.h.$getDiffInformation(S))}}e.$1dc=g}),define(Ae[271],Re([1,0,2,4,3,6,7,8,22,16]),function(pe,e,E,L,P,M,R,$,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dec=e.$Cec=void 0,e.$Cec=(0,L.$Th)("IExtHostTimeline");class A{constructor(v,p){this.b=new Map,this.c=new Map,this.a=v.getProxy(P.$vK.MainThreadTimeline),p.registerArgumentProcessor({processArgument:(f,t)=>{if(f&&f.$mid===12)if(this.b.get(f.source)&&D.$0l.equals(t,this.b.get(f.source)?.extension)){const i=f.uri===void 0?void 0:E.URI.revive(f.uri);return this.c.get(f.source)?.get(S(i))?.get(f.handle)}else return;return f}})}async $getTimeline(v,p,f,t){return this.b.get(v)?.provider.provideTimeline(E.URI.revive(p),f,t)}registerTimelineProvider(v,p,f,t){const i=new M.$Qc,n=this.d(p.id,t,i).bind(this);let u;p.onDidChange&&(u=p.onDidChange(l=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...l,id:p.id}),this));const a=this.c;return this.f({...p,scheme:v,onDidChange:void 0,async provideTimeline(l,r,s){r?.resetCache&&(i.clear(),a.get(p.id)?.clear());const c=await p.provideTimeline(l,r,s);if(c==null)return;const h=n(l,r);return{...c,source:p.id,items:c.items.map(h)}},dispose(){for(const l of a.values())l.get(p.id)?.clear();u?.dispose(),i.dispose()}},f)}d(v,p,f){return(t,i)=>{let n;if(i?.cacheResults){let u=this.c.get(v);u===void 0&&(u=new Map,this.c.set(v,u));const a=S(t);n=u.get(a),n===void 0&&(n=new Map,u.set(a,n))}return u=>{const{iconPath:a,...l}=u,r=`${v}|${u.id??u.timestamp}`;n?.set(r,u);let s,c,h;u.iconPath&&(a instanceof R.$rL?h={id:a.id,color:a.color}:E.URI.isUri(a)?(s=a,c=a):{light:s,dark:c}=a);let w;return R.$XK.isMarkdownString(l.tooltip)?w=$.MarkdownString.from(l.tooltip):(0,g.$zf)(l.tooltip)?w=l.tooltip:R.$XK.isMarkdownString(l.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),w=$.MarkdownString.from(l.detail)):(0,g.$zf)(l.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),w=l.detail),{...l,id:l.id??void 0,handle:r,source:v,command:u.command?p.toInternal(u.command,f):void 0,icon:s,iconDark:c,themeIcon:h,tooltip:w,accessibilityInformation:u.accessibilityInformation}}}}f(v,p){if(this.b.get(v.id))throw new Error(`Timeline Provider ${v.id} already exists.`);return this.a.$registerTimelineProvider({id:v.id,label:v.label,scheme:v.scheme}),this.b.set(v.id,{provider:v,extension:p}),(0,M.$Pc)(()=>{for(const t of this.c.values())t.get(v.id)?.clear();this.b.delete(v.id),this.a.$unregisterTimelineProvider(v.id),v.dispose()})}}e.$Dec=A;function S(o){return o?.toString()}}),define(Ae[87],Re([1,0,20,5,6,169,4,15,198,3,27,17,7]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jwb=e.$Iwb=e.TunnelDtoConverter=void 0;class v extends D.$kv{}var p;(function(t){function i(u){return{remoteAddress:u.remoteAddress,localAddress:u.localAddress,public:!!u.public,privacy:u.privacy??(u.public?D.TunnelPrivacyId.Public:D.TunnelPrivacyId.Private),protocol:u.protocol}}t.fromApiTunnel=i;function n(u){return{remoteAddress:{host:u.tunnelRemoteHost,port:u.tunnelRemotePort},localAddress:u.localAddress,public:u.privacy!==D.TunnelPrivacyId.ConstantPrivate&&u.privacy!==D.TunnelPrivacyId.ConstantPrivate,privacy:u.privacy,protocol:u.protocol}}t.fromServiceTunnel=n})(p||(e.TunnelDtoConverter=p={})),e.$Iwb=(0,R.$Th)("IExtHostTunnelService");let f=class extends P.$Rc{constructor(i,n,u){super(),this.s=u,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new L.$Od,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=i.getProxy(g.$vK.MainThreadTunnelService)}async openTunnel(i,n){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${i.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const u=await this.a.$openTunnel(n,i.displayName);if(u){const a=new v(u.remoteAddress,u.localAddress,()=>this.a.$closeTunnel(u.remoteAddress));return this.B(a),a}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(i,n){const u=this.u();return this.r.set(u,{selector:i,provider:n}),this.a.$registerPortsAttributesProvider(i,u),new o.$xK(()=>{this.r.delete(u),this.a.$unregisterPortsAttributesProvider(u)})}async $providePortAttributes(i,n,u,a,l){const r=[];for(const c of i){const h=this.r.get(c);if(!h)return[];r.push(...await Promise.all(n.map(async w=>{let m;try{m=await h.provider.providePortAttributes({port:w,pid:u,commandLine:a},l)}catch{m=await h.provider.providePortAttributes(w,u,a,l)}return{providedAttributes:m,port:w}})))}const s=r.filter(c=>!!c.providedAttributes);return s.length>0?s.map(c=>({autoForwardAction:c.providedAttributes.autoForwardAction,port:c.port})):[]}async $registerCandidateFinder(i){}registerTunnelProvider(i,n){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(a,l)=>await i.provideTunnel(a,l,new E.$Yd().token)??void 0;const u=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(u),Promise.resolve((0,P.$Pc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(i,n){if(i){i.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(i.candidatePortSource),i.showCandidatePort&&(this.f=i.showCandidatePort,this.a.$setCandidateFilter());const u=i.tunnelFactory??(n?this.w(n):void 0);if(u){this.b=u;let a=i.tunnelFeatures?.privacyOptions??[];i.tunnelFeatures?.public&&a.length===0&&(a=[{id:"private",label:M.localize(0,null),themeIcon:"lock"},{id:"public",label:M.localize(1,null),themeIcon:"eye"}]);const l=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,public:!!i.tunnelFeatures?.public,privacyOptions:a}:void 0;this.a.$setTunnelProvider(l)}}else this.b=void 0;return(0,P.$Pc)(()=>{this.b=void 0})}w(i){}async $closeTunnel(i,n){if(this.g.has(i.host)){const u=this.g.get(i.host);u.has(i.port)&&(n&&u.get(i.port).disposeListener.dispose(),await u.get(i.port).tunnel.dispose(),u.delete(i.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(i,n){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const u=this.b(i,n);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),u!==void 0){const a=await u;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),a===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(i.remoteAddress.host)||this.g.set(i.remoteAddress.host,new Map);const l=this.B(a.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(a.remoteAddress))));return this.g.get(i.remoteAddress.host).set(i.remoteAddress.port,{tunnel:a,disposeListener:l}),p.fromApiTunnel(a)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(u){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),u instanceof Error)return u.message}}async $applyCandidateFilter(i){const n=await Promise.all(i.map(a=>this.f(a.host,a.port,a.detail??""))),u=i.filter((a,l)=>n[l]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${i.map(a=>a.port).join(", ")} to ${u.map(a=>a.port).join(", ")}`),u}};e.$Jwb=f,e.$Jwb=f=Ke([Ve(0,S.$xM),Ve(1,A.$NM),Ve(2,$.$bj)],f)}),define(Ae[272],Re([1,0,6,14,2,3]),function(pe,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mec=void 0;class R{static{this.a=new Set([L.Schemas.http,L.Schemas.https])}constructor(D){this.c=new Map,this.b=D.getProxy(M.$vK.MainThreadUriOpeners)}registerExternalUriOpener(D,g,A,S){if(this.c.has(g))throw new Error(`Opener with id '${g}' already registered`);const o=S.schemes.find(v=>!R.a.has(v));if(o)throw new Error(`Scheme '${o}' is not supported. Only http and https are currently supported.`);return this.c.set(g,A),this.b.$registerUriOpener(g,S.schemes,D,S.label),(0,E.$Pc)(()=>{this.c.delete(g),this.b.$unregisterUriOpener(g)})}async $canOpenUri(D,g,A){const S=this.c.get(D);if(!S)throw new Error(`Unknown opener with id: ${D}`);const o=P.URI.revive(g);return S.canOpenExternalUri(o,A)}async $openUri(D,g,A){const S=this.c.get(D);if(!S)throw new Error(`Unknown opener id: '${D}'`);return S.openExternalUri(P.URI.revive(g.resolvedUri),{sourceUri:P.URI.revive(g.sourceUri)},A)}}e.$Mec=R}),define(Ae[273],Re([1,0,3,2,6,11,22]),function(pe,e,E,L,P,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3dc=void 0;class ${static{this.a=0}constructor(g){this.c=new R.$$l,this.d=new Map,this.b=g.getProxy(E.$vK.MainThreadUrls)}registerUriHandler(g,A){const S=g.identifier;if(this.c.has(S))throw new Error(`Protocol handler already registered for extension ${S}`);const o=$.a++;return this.c.add(S),this.d.set(o,A),this.b.$registerUriHandler(o,S,g.displayName||g.name),(0,P.$Pc)(()=>{this.c.delete(S),this.d.delete(o),this.b.$unregisterUriHandler(o)})}$handleExternalUri(g,A){const S=this.d.get(g);if(!S)return Promise.resolve(void 0);try{S.handleUri(L.URI.revive(A))}catch(o){(0,M.$Z)(o)}return Promise.resolve(void 0)}async createAppUri(g){return L.URI.revive(await this.b.$createAppUri(g))}}e.$3dc=$}),define(Ae[66],Re([1,0,5,6,14,26,2,183,205,78,3]),function(pe,e,E,L,P,M,R,$,D,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8dc=e.$7dc=e.$6dc=e.$5dc=e.$4dc=void 0;class S{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;constructor(a,l,r,s,c,h,w){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new E.$Od,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new E.$Od,this._onDidDispose=this.#h.event,this.#e=a,this.#t=l,this.#s=r,this.#o=s,this.#r=c,this.#n=h,this.#l=o(h),this.#d=v(h),this.#i=w}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(a){return this.#u=!0,(0,g.$2tb)(a,this.#o)}get cspSource(){const a=this.#n.extensionLocation;if(a.scheme===P.Schemas.https||a.scheme===P.Schemas.http){let l=a.toString();return l.endsWith("/")||(l+="/"),l+" "+g.$1tb}return g.$1tb}get html(){return this.a(),this.#a}set html(a){this.a(),this.#a!==a&&(this.#a=a,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(a)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(a)))}get options(){return this.a(),this.#s}set options(a){this.a(),M.$cn(this.#s,a)||this.#t.$setOptions(this.#e,t(this.#n,this.#r,a)),this.#s=a}async postMessage(a){if(this.#c)return!1;const l=(0,D.$0cb)(a,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,l.message,...l.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(a){if(!this.#d)return a;const l=this.#n.extensionLocation?.scheme===P.Schemas.vscodeRemote,r=this.#n.extensionLocation.scheme===P.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return a.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,c,h,w,m,I)=>{const k=R.URI.from({scheme:w||"file",path:decodeURIComponent(m)}),d=(0,g.$2tb)(k,{isRemote:l,authority:r}).toString();return`${c}${d}${I}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,c,h,w,m,I)=>{const k=R.URI.from({scheme:w||"file",path:decodeURIComponent(m)}),d=(0,g.$2tb)(k,{isRemote:l,authority:r}).toString();return`${c}${d}${I}`})}}e.$4dc=S;function o(u){try{const a=(0,$.$Ro)((0,$.$Qo)(u.engines.vscode));return!!a&&a.majorBase>=1&&a.minorBase>=57}catch{return!1}}e.$5dc=o;function v(u){try{const a=(0,$.$Ro)((0,$.$Qo)(u.engines.vscode));return a?a.majorBase<1||a.majorBase===1&&a.minorBase<60:!1}catch{return!1}}class p extends L.$Rc{constructor(a,l,r,s,c){super(),this.c=l,this.f=r,this.g=s,this.h=c,this.b=new Map,this.a=a.getProxy(A.$vK.MainThreadWebviews)}dispose(){super.dispose();for(const a of this.b.values())a.dispose();this.b.clear()}$onMessage(a,l,r){const s=this.j(a);if(s){const{message:c}=(0,D.$$cb)(l,r.value);s._onMessageEmitter.fire(c)}}$onMissingCsp(a,l){this.g.warn(`${l} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(a,l,r){const s=new S(a,this.a,i(l),this.c,this.f,r,this.h);this.b.set(a,s);const c=s._onDidDispose(()=>{c.dispose(),this.deleteWebview(a)});return s}deleteWebview(a){this.b.delete(a)}j(a){return this.b.get(a)}}e.$6dc=p;function f(u){return{id:u.identifier,location:u.extensionLocation}}e.$7dc=f;function t(u,a,l){return{enableCommandUris:l.enableCommandUris,enableScripts:l.enableScripts,enableForms:l.enableForms,portMapping:l.portMapping,localResourceRoots:l.localResourceRoots||n(u,a)}}e.$8dc=t;function i(u){return{enableCommandUris:u.enableCommandUris,enableScripts:u.enableScripts,enableForms:u.enableForms,portMapping:u.portMapping,localResourceRoots:u.localResourceRoots?.map(a=>R.URI.from(a))}}function n(u,a){return[...(a?.getWorkspaceFolders()||[]).map(l=>l.uri),u.extensionLocation]}}),define(Ae[274],Re([1,0,20,97,6,14,25,2,8,66,75,3,7]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gec=void 0;class v{constructor(s,c){this.document=s,this.b=c,this.a=1,this.c=new A.$Zcc("custom documents")}addEdit(s){return this.c.add([s])}async undo(s,c){await this.f(s).undo(),c||this.disposeBackup()}async redo(s,c){await this.f(s).redo(),c||this.disposeBackup()}disposeEdits(s){for(const c of s)this.c.delete(c)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const s=l(this.document.uri)+this.a++;return(0,R.$wg)(this.b,s)}updateBackup(s){this.d?.delete(),this.d=s}disposeBackup(){this.d?.delete(),this.d=void 0}f(s){const c=this.c.get(s,0);if(!c)throw new Error("No edit found");return c}}class p{constructor(){this.a=new Map}get(s,c){return this.a.get(this.b(s,c))}add(s,c,h){const w=this.b(s,c.uri);if(this.a.has(w))throw new Error(`Document already exists for viewType:${s} resource:${c.uri}`);const m=new v(c,h);return this.a.set(w,m),m}delete(s,c){const h=this.b(s,c.uri);this.a.delete(h)}b(s,c){return`${s}@@@${c}`}}var f;(function(r){r[r.Text=0]="Text",r[r.Custom=1]="Custom"})(f||(f={}));class t{constructor(){this.a=new Map}addTextProvider(s,c,h){return this.b(0,s,c,h)}addCustomProvider(s,c,h){return this.b(1,s,c,h)}get(s){return this.a.get(s)}b(s,c,h,w){if(this.a.has(c))throw new Error(`Provider for viewType:${c} already registered`);return this.a.set(c,{type:s,extension:h,provider:w}),new o.$xK(()=>this.a.delete(c))}}class i{constructor(s,c,h,w,m){this.d=c,this.f=h,this.g=w,this.h=m,this.b=new t,this.c=new p,this.a=s.getProxy(S.$vK.MainThreadCustomEditors)}registerCustomEditorProvider(s,c,h,w){const m=new P.$Qc;return u(h)?(m.add(this.b.addTextProvider(c,s,h)),this.a.$registerTextEditorProvider((0,g.$7dc)(s),c,w.webviewOptions||{},{supportsMove:!!h.moveCustomTextEditor},(0,g.$5dc)(s))):(m.add(this.b.addCustomProvider(c,s,h)),n(h)&&m.add(h.onDidChangeCustomDocument(I=>{const k=this.i(c,I.document.uri);if(a(I)){const d=k.addEdit(I);this.a.$onDidEdit(I.document.uri,c,d,I.label)}else this.a.$onContentChange(I.document.uri,c)})),this.a.$registerCustomEditorProvider((0,g.$7dc)(s),c,w.webviewOptions||{},!!w.supportsMultipleEditorsPerDocument,(0,g.$5dc)(s))),o.$xK.from(m,new o.$xK(()=>{this.a.$unregisterEditorProvider(c)}))}async $createCustomDocument(s,c,h,w,m){const I=this.b.get(c);if(!I)throw new Error(`No provider found for '${c}'`);if(I.type!==1)throw new Error(`Invalid provide type for '${c}'`);const k=$.URI.revive(s),d=await I.provider.openCustomDocument(k,{backupId:h,untitledDocumentData:w?.buffer},m);let b;return n(I.provider)&&this.f&&(b=this.f.workspaceValue(I.extension)??this.f.globalValue(I.extension)),this.c.add(c,d,b),{editable:n(I.provider)}}async $disposeCustomDocument(s,c){const h=this.b.get(c);if(!h)throw new Error(`No provider found for '${c}'`);if(h.type!==1)throw new Error(`Invalid provider type for '${c}'`);const w=$.URI.revive(s),{document:m}=this.i(c,w);this.c.delete(c,m),m.dispose()}async $resolveCustomEditor(s,c,h,w,m,I){const k=this.b.get(h);if(!k)throw new Error(`No provider found for '${h}'`);const d=D.ViewColumn.to(m),b=this.g.createNewWebview(c,w.contentOptions,k.extension),y=this.h.createNewWebviewPanel(c,h,w.title,d,w.options,b,w.active),C=$.URI.revive(s);switch(k.type){case 1:{const{document:B}=this.i(h,C);return k.provider.resolveCustomEditor(B,y,I)}case 0:{const B=this.d.getDocument(C);return k.provider.resolveCustomTextEditor(B,y,I)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,c,h){this.i(c,s).disposeEdits(h)}async $onMoveCustomEditor(s,c,h){const w=this.b.get(h);if(!w)throw new Error(`No provider found for '${h}'`);if(!w.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${h}'`);const m=this.h.getWebviewPanel(s);if(!m)throw new Error("No webview found");const I=$.URI.revive(c),k=this.d.getDocument(I);await w.provider.moveCustomTextEditor(k,m,E.CancellationToken.None)}async $undo(s,c,h,w){return this.i(c,s).undo(h,w)}async $redo(s,c,h,w){return this.i(c,s).redo(h,w)}async $revert(s,c,h){const w=this.i(c,s);await this.j(c).revertCustomDocument(w.document,h),w.disposeBackup()}async $onSave(s,c,h){const w=this.i(c,s);await this.j(c).saveCustomDocument(w.document,h),w.disposeBackup()}async $onSaveAs(s,c,h,w){const m=this.i(c,s);return this.j(c).saveCustomDocumentAs(m.document,$.URI.revive(h),w)}async $backup(s,c,h){const w=this.i(c,s),I=await this.j(c).backupCustomDocument(w.document,{destination:w.getNewBackupUri()},h);return w.updateBackup(I),I.id}i(s,c){const h=this.c.get(s,$.URI.revive(c));if(!h)throw new Error("No custom document found");return h}j(s){const h=this.b.get(s)?.provider;if(!h||!n(h))throw new Error("Custom document is not editable");return h}}e.$Gec=i;function n(r){return!!r.onDidChangeCustomDocument}function u(r){return typeof r.resolveCustomTextEditor=="function"}function a(r){return typeof r.undo=="function"&&typeof r.redo=="function"}function l(r){const s=r.scheme===M.Schemas.file||r.scheme===M.Schemas.untitled?r.fsPath:r.toString();return(0,L.$Hi)(s)+""}}),define(Ae[275],Re([1,0,5,6,2,38,8,66,3,7]),function(pe,e,E,L,P,M,R,$,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fec=void 0;class A extends L.$Rc{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;#h;constructor(p,f,t,i){super(),this.#s=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new E.$Od),this.onDidDispose=this.#d.event,this.#h=this.B(new E.$Od),this.onDidChangeViewState=this.#h.event,this.#e=p,this.#t=f,this.#o=t,this.#i=i.viewType,this.#r=i.panelOptions,this.#s=i.viewColumn,this.#n=i.title,this.#u=i.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#o.dispose(),super.dispose())}get webview(){return this.c(),this.#o}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(p){this.c(),this.#n!==p&&(this.#n=p,this.#t.$setTitle(this.#e,p))}get iconPath(){return this.c(),this.#a}set iconPath(p){this.c(),this.#a!==p&&(this.#a=p,this.#t.$setIconPath(this.#e,P.URI.isUri(p)?{light:p,dark:p}:p))}get options(){return this.#r}get viewColumn(){if(this.c(),!(typeof this.#s=="number"&&this.#s<0))return this.#s}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(p){this.#l||(this.active!==p.active||this.visible!==p.visible||this.viewColumn!==p.viewColumn)&&(this.#u=p.active,this.#c=p.visible,this.#s=p.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(p,f){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof p>"u"?void 0:R.ViewColumn.from(p),preserveFocus:!!f})}c(){if(this.#l)throw new Error("Webview is disposed")}}class S extends L.$Rc{static c(){return(0,M.$fg)()}constructor(p,f,t){super(),this.j=f,this.m=t,this.g=new Map,this.h=new Map,this.f=p.getProxy(D.$vK.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(p=>p.dispose()),this.g.clear()}createWebviewPanel(p,f,t,i,n={}){const u=typeof i=="object"?i.viewColumn:i,a={viewColumn:R.ViewColumn.from(u),preserveFocus:typeof i=="object"&&!!i.preserveFocus},l=(0,$.$5dc)(p),r=S.c();this.f.$createWebviewPanel((0,$.$7dc)(p),r,f,{title:t,panelOptions:o(n),webviewOptions:(0,$.$8dc)(p,this.m,n),serializeBuffersForPostMessage:l},a);const s=this.j.createNewWebview(r,n,p);return this.createNewWebviewPanel(r,f,t,u,n,s,!0)}$onDidChangeWebviewPanelViewStates(p){const f=Object.keys(p);f.sort((t,i)=>{const n=p[t],u=p[i];return n.active?1:u.active?-1:+n.visible-+u.visible});for(const t of f){const i=this.getWebviewPanel(t);if(!i)continue;const n=p[t];i._updateViewState({active:n.active,visible:n.visible,viewColumn:R.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(p){this.getWebviewPanel(p)?.dispose(),this.g.delete(p),this.j.deleteWebview(p)}registerWebviewPanelSerializer(p,f,t){if(this.h.has(f))throw new Error(`Serializer for '${f}' already registered`);return this.h.set(f,{serializer:t,extension:p}),this.f.$registerSerializer(f,{serializeBuffersForPostMessage:(0,$.$5dc)(p)}),new g.$xK(()=>{this.h.delete(f),this.f.$unregisterSerializer(f)})}async $deserializeWebviewPanel(p,f,t,i){const n=this.h.get(f);if(!n)throw new Error(`No serializer found for '${f}'`);const{serializer:u,extension:a}=n,l=this.j.createNewWebview(p,t.webviewOptions,a),r=this.createNewWebviewPanel(p,f,t.title,i,t.panelOptions,l,t.active);await u.deserializeWebviewPanel(r,t.state)}createNewWebviewPanel(p,f,t,i,n,u,a){const l=new A(p,this.f,u,{viewType:f,title:t,viewColumn:i,panelOptions:n,active:a});return this.g.set(p,l),l}getWebviewPanel(p){return this.g.get(p)}}e.$Fec=S;function o(v){return{enableFindWidget:v.enableFindWidget,retainContextWhenHidden:v.retainContextWhenHidden}}}),define(Ae[276],Re([1,0,5,6,66,8,3,7]),function(pe,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eec=void 0;class D extends L.$Rc{#e;#t;#i;#o;#r;#n;#a;#s;#c;constructor(S,o,v,p,f,t){super(),this.#r=!1,this.#u=this.B(new E.$Od),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new E.$Od),this.onDidDispose=this.#l.event,this.#i=v,this.#a=p,this.#e=S,this.#t=o,this.#o=f,this.#n=t}dispose(){this.#r||(this.#r=!0,this.#l.fire(),this.#o.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(S){this.a(),this.#a!==S&&(this.#a=S,this.#t.$setWebviewViewTitle(this.#e,S))}get description(){return this.a(),this.#s}set description(S){this.a(),this.#s!==S&&(this.#s=S,this.#t.$setWebviewViewDescription(this.#e,S))}get visible(){return this.#n}get webview(){return this.#o}get viewType(){return this.#i}_setVisible(S){S===this.#n||this.#r||(this.#n=S,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(S){this.a(),!(S?.value===this.#c?.value&&S?.tooltip===this.#c?.tooltip)&&(this.#c=M.ViewBadge.from(S),this.#t.$setWebviewViewBadge(this.#e,S))}show(S){this.a(),this.#t.$show(this.#e,!!S)}a(){if(this.#r)throw new Error("Webview is disposed")}}class g{constructor(S,o){this.d=o,this.b=new Map,this.c=new Map,this.a=S.getProxy(R.$vK.MainThreadWebviewViews)}registerWebviewViewProvider(S,o,v,p){if(this.b.has(o))throw new Error(`View provider for '${o}' already registered`);return this.b.set(o,{provider:v,extension:S}),this.a.$registerWebviewViewProvider((0,P.$7dc)(S),o,{retainContextWhenHidden:p?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,P.$5dc)(S)}),new $.$xK(()=>{this.b.delete(o),this.a.$unregisterWebviewViewProvider(o)})}async $resolveWebviewView(S,o,v,p,f){const t=this.b.get(o);if(!t)throw new Error(`No view provider found for '${o}'`);const{provider:i,extension:n}=t,u=this.d.createNewWebview(S,{},n),a=new D(S,this.a,o,v,u,!0);this.c.set(S,a),await i.resolveWebviewView(a,{state:p},f)}async $onDidChangeWebviewViewVisibility(S,o){this.e(S)._setVisible(o)}async $disposeWebviewView(S){const o=this.e(S);this.c.delete(S),o.dispose(),this.d.deleteWebview(S)}e(S){const o=this.c.get(S);if(!o)throw new Error("No webview found");return o}}e.$Eec=g}),define(Ae[111],Re([1,0,5,3,2,14,13,4,17,23]),function(pe,e,E,L,P,M,R,$,D,g){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.$0dc=e.$9dc=void 0;let S=class{static{A=this}static{this.a={focused:!0,active:!0}}getState(v){const p=this.d;return{get focused(){return p.focused},get active(){return(0,g.$vF)(v,"windowActivity"),p.active}}}constructor(v){this.c=new E.$Od,this.onDidChangeWindowState=this.c.event,this.d=A.a,this.b=v.getProxy(L.$vK.MainThreadWindow),this.b.$getInitialState().then(({isFocused:p,isActive:f})=>{this.onDidChangeWindowProperty("focused",p),this.onDidChangeWindowProperty("active",f)})}$onDidChangeWindowFocus(v){this.onDidChangeWindowProperty("focused",v)}$onDidChangeWindowActive(v){this.onDidChangeWindowProperty("active",v)}onDidChangeWindowProperty(v,p){p!==this.d[v]&&(this.d={...this.d,[v]:p},this.c.fire(this.d))}openUri(v,p){let f;if(typeof v=="string"){f=v;try{v=P.URI.parse(v)}catch{return Promise.reject(`Invalid uri - '${v}'`)}}return(0,R.$Ce)(v.scheme)?Promise.reject("Invalid scheme - cannot be empty"):v.scheme===M.Schemas.command?Promise.reject(`Invalid scheme '${v.scheme}'`):this.b.$openUri(v,f,p)}async asExternalUri(v,p){if((0,R.$Ce)(v.scheme))return Promise.reject("Invalid scheme - cannot be empty");const f=await this.b.$asExternalUri(v,p);return P.URI.from(f)}};e.$9dc=S,e.$9dc=S=A=Ke([Ve(0,D.$xM)],S),e.$0dc=(0,$.$Th)("IExtHostWindow")}),define(Ae[277],Re([1,0,243,27,17]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fhc=void 0;let M=class extends E.$0ec{constructor($,D){super($,D)}f($,D,g){D.apply(console,g)}};e.$fhc=M,e.$fhc=M=Ke([Ve(0,P.$xM),Ve(1,L.$NM)],M)}),define(Ae[278],Re([1,0,12,24,20,11,5,6,139,231,49]),function(pe,e,E,L,P,M,R,$,D,g,A){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$m5b=e.ResponsiveState=e.RequestInitiator=e.$l5b=e.$k5b=void 0;function o(y,C){try{return JSON.stringify(y,C)}catch{return"null"}}const v="$$ref$$",p={[v]:-1};class f{constructor(C,B){this.jsonString=C,this.referencedBuffers=B}}function t(y,C=null,B=!1){const H=[];return{jsonString:(B?o:JSON.stringify)(y,(z,F)=>{if(typeof F>"u")return p;if(typeof F=="object"){if(F instanceof L.$ce){const N=H.push(F)-1;return{[v]:N}}if(C)return C(z,F)}return F}),referencedBuffers:H}}e.$k5b=t;function i(y,C,B){return JSON.parse(y,(H,U)=>{if(U){const z=U[v];if(typeof z=="number")return C[z];if(B&&U.$mid===1)return B.transformIncoming(U)}return U})}e.$l5b=i;function n(y,C){return JSON.stringify(y,C)}function u(y){return y?(C,B)=>B&&B.$mid===1?y.transformOutgoing(B):B:null}var a;(function(y){y[y.LocalSide=0]="LocalSide",y[y.OtherSide=1]="OtherSide"})(a||(e.RequestInitiator=a={}));var l;(function(y){y[y.Responsive=0]="Responsive",y[y.Unresponsive=1]="Unresponsive"})(l||(e.ResponsiveState=l={}));const r=()=>{},s=Symbol.for("rpcProtocol"),c=Symbol.for("rpcProxy");class h extends $.$Rc{static{S=s}static{this.a=3*1e3}constructor(C,B=null,H=null){super(),this[S]=!0,this.b=this.B(new R.$Od),this.onDidChangeResponsiveState=this.b.event,this.c=C,this.f=B,this.g=H,this.h=u(this.g),this.j=!1,this.m=[],this.s=[];for(let U=0,z=A.$rv.count;U<z;U++)this.m[U]=null,this.s[U]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new E.$8g(()=>this.H(),1e3)),this.c.onMessage(U=>this.L(U))}dispose(){this.j=!0,Object.keys(this.w).forEach(C=>{const B=this.w[C];delete this.w[C],B.resolveErr(M.$5())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(C){this.z===0&&(this.C=Date.now()+h.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(C){this.C=Date.now()+h.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(C){this.y!==C&&(this.y=C,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(C){return this.g?(0,D.$Sm)(C,this.g):C}getProxy(C){const{nid:B,sid:H}=C;return this.s[B]||(this.s[B]=this.J(B,H)),this.s[B]}J(C,B){const H={get:(U,z)=>(typeof z=="string"&&!U[z]&&z.charCodeAt(0)===36&&(U[z]=(...F)=>this.U(C,z,F)),z===c?B:U[z])};return new Proxy(Object.create(null),H)}set(C,B){return this.m[C.nid]=B,B}assertRegistered(C){for(let B=0,H=C.length;B<H;B++){const U=C[B];if(!this.m[U.nid])throw new Error(`Missing proxy instance ${U.sid}`)}}L(C){if(this.j)return;const B=C.byteLength,H=m.read(C,0),U=H.readUInt8(),z=H.readUInt32();switch(U){case 1:case 2:{let{rpcId:F,method:N,args:x}=k.deserializeRequestJSONArgs(H);this.g&&(x=(0,D.$Sm)(x,this.g)),this.M(B,z,F,N,x,U===2);break}case 3:case 4:{let{rpcId:F,method:N,args:x}=k.deserializeRequestMixedArgs(H);this.g&&(x=(0,D.$Sm)(x,this.g)),this.M(B,z,F,N,x,U===4);break}case 5:{this.f?.logIncoming(B,z,0,"ack"),this.G(z);break}case 6:{this.N(B,z);break}case 7:{this.O(B,z,void 0);break}case 9:{let F=k.deserializeReplyOKJSON(H);this.g&&(F=(0,D.$Sm)(F,this.g)),this.O(B,z,F);break}case 10:{const F=k.deserializeReplyOKJSONWithBuffers(H,this.g);this.O(B,z,F);break}case 8:{const F=k.deserializeReplyOKVSBuffer(H);this.O(B,z,F);break}case 11:{let F=k.deserializeReplyErrError(H);this.g&&(F=(0,D.$Sm)(F,this.g)),this.P(B,z,F);break}case 12:{this.P(B,z,void 0);break}default:console.error("received unexpected message"),console.error(C)}}M(C,B,H,U,z,F){this.f?.logIncoming(C,B,1,`receiveRequest ${(0,A.$tv)(H)}.${U}(`,z);const N=String(B);let x,J;if(F){const De=new P.$Yd;z.push(De.token),x=this.Q(H,U,z),J=()=>De.cancel()}else x=this.Q(H,U,z),J=r;this.u[N]=J;const ye=k.serializeAcknowledged(B);this.f?.logOutgoing(ye.byteLength,B,1,"ack"),this.c.send(ye),x.then(De=>{delete this.u[N];const Ce=k.serializeReplyOK(B,De,this.h);this.f?.logOutgoing(Ce.byteLength,B,1,"reply:",De),this.c.send(Ce)},De=>{delete this.u[N];const Ce=k.serializeReplyErr(B,De);this.f?.logOutgoing(Ce.byteLength,B,1,"replyErr:",De),this.c.send(Ce)})}N(C,B){this.f?.logIncoming(C,B,1,"receiveCancel");const H=String(B);this.u[H]?.()}O(C,B,H){this.f?.logIncoming(C,B,0,"receiveReply:",H);const U=String(B);if(!this.w.hasOwnProperty(U))return;const z=this.w[U];delete this.w[U],z.resolveOk(H)}P(C,B,H){this.f?.logIncoming(C,B,0,"receiveReplyErr:",H);const U=String(B);if(!this.w.hasOwnProperty(U))return;const z=this.w[U];delete this.w[U];let F;H&&(H.$isError?(F=new Error,F.name=H.name,F.message=H.message,F.stack=H.stack):F=H),z.resolveErr(F)}Q(C,B,H){try{return Promise.resolve(this.S(C,B,H))}catch(U){return Promise.reject(U)}}S(C,B,H){const U=this.m[C];if(!U)throw new Error("Unknown actor "+(0,A.$tv)(C));const z=U[B];if(typeof z!="function")throw new Error("Unknown method "+B+" on actor "+(0,A.$tv)(C));return z.apply(U,H)}U(C,B,H){if(this.j)return new g.$j5b;let U=null;if(H.length>0&&P.CancellationToken.isCancellationToken(H[H.length-1])&&(U=H.pop()),U&&U.isCancellationRequested)return Promise.reject(M.$5());const z=k.serializeRequestArguments(H,this.h),F=++this.t,N=String(F),x=new g.$i5b,J=new $.$Qc;U&&J.add(U.onCancellationRequested(()=>{const De=k.serializeCancel(F);this.f?.logOutgoing(De.byteLength,F,0,"cancel"),this.c.send(k.serializeCancel(F))})),this.w[N]=new w(x,J),this.F(F);const ye=k.serializeRequest(F,C,B,z,!!U);return this.f?.logOutgoing(ye.byteLength,F,0,`request: ${(0,A.$tv)(C)}.${B}(`,H),this.c.send(ye),x}}e.$m5b=h;class w{constructor(C,B){this.a=C,this.b=B}resolveOk(C){this.a.resolveOk(C),this.b.dispose()}resolveErr(C){this.a.resolveErr(C),this.b.dispose()}}class m{static alloc(C,B,H){const U=new m(L.$ce.alloc(H+1+4),0);return U.writeUInt8(C),U.writeUInt32(B),U}static read(C,B){return new m(C,B)}get buffer(){return this.a}constructor(C,B){this.a=C,this.b=B}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(C){this.a.writeUInt8(C,this.b),this.b+=1}readUInt8(){const C=this.a.readUInt8(this.b);return this.b+=1,C}writeUInt32(C){this.a.writeUInt32BE(C,this.b),this.b+=4}readUInt32(){const C=this.a.readUInt32BE(this.b);return this.b+=4,C}static sizeShortString(C){return 1+C.byteLength}writeShortString(C){this.a.writeUInt8(C.byteLength,this.b),this.b+=1,this.a.set(C,this.b),this.b+=C.byteLength}readShortString(){const C=this.a.readUInt8(this.b);this.b+=1;const H=this.a.slice(this.b,this.b+C).toString();return this.b+=C,H}static sizeLongString(C){return 4+C.byteLength}writeLongString(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readLongString(){const C=this.a.readUInt32BE(this.b);this.b+=4;const H=this.a.slice(this.b,this.b+C).toString();return this.b+=C,H}writeBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}static sizeVSBuffer(C){return 4+C.byteLength}writeVSBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readVSBuffer(){const C=this.a.readUInt32BE(this.b);this.b+=4;const B=this.a.slice(this.b,this.b+C);return this.b+=C,B}static sizeMixedArray(C){let B=0;B+=1;for(let H=0,U=C.length;H<U;H++){const z=C[H];switch(B+=1,z.type){case 1:B+=this.sizeLongString(z.value);break;case 2:B+=this.sizeVSBuffer(z.value);break;case 3:B+=this.sizeUInt32,B+=this.sizeLongString(z.value);for(let F=0;F<z.buffers.length;++F)B+=this.sizeVSBuffer(z.buffers[F]);break;case 4:break}}return B}writeMixedArray(C){this.a.writeUInt8(C.length,this.b),this.b+=1;for(let B=0,H=C.length;B<H;B++){const U=C[B];switch(U.type){case 1:this.writeUInt8(1),this.writeLongString(U.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(U.value);break;case 3:this.writeUInt8(3),this.writeUInt32(U.buffers.length),this.writeLongString(U.value);for(let z=0;z<U.buffers.length;++z)this.writeBuffer(U.buffers[z]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const C=this.a.readUInt8(this.b);this.b+=1;const B=new Array(C);for(let H=0;H<C;H++)switch(this.readUInt8()){case 1:B[H]=this.readLongString();break;case 2:B[H]=this.readVSBuffer();break;case 3:{const z=this.readUInt32(),F=this.readLongString(),N=[];for(let x=0;x<z;++x)N.push(this.readVSBuffer());B[H]=new A.$uv(i(F,N,null));break}case 4:B[H]=void 0;break}return B}}var I;(function(y){y[y.Simple=0]="Simple",y[y.Mixed=1]="Mixed"})(I||(I={}));class k{static a(C){for(let B=0,H=C.length;B<H;B++)if(C[B]instanceof L.$ce||C[B]instanceof A.$uv||typeof C[B]>"u")return!0;return!1}static serializeRequestArguments(C,B){if(this.a(C)){const H=[];for(let U=0,z=C.length;U<z;U++){const F=C[U];if(F instanceof L.$ce)H[U]={type:2,value:F};else if(typeof F>"u")H[U]={type:4};else if(F instanceof A.$uv){const{jsonString:N,referencedBuffers:x}=t(F.value,B);H[U]={type:3,value:L.$ce.fromString(N),buffers:x}}else H[U]={type:1,value:L.$ce.fromString(n(F,B))}}return{type:1,args:H}}return{type:0,args:n(C,B)}}static serializeRequest(C,B,H,U,z){switch(U.type){case 0:return this.b(C,B,H,U.args,z);case 1:return this.c(C,B,H,U.args,z)}}static b(C,B,H,U,z){const F=L.$ce.fromString(H),N=L.$ce.fromString(U);let x=0;x+=m.sizeUInt8(),x+=m.sizeShortString(F),x+=m.sizeLongString(N);const J=m.alloc(z?2:1,C,x);return J.writeUInt8(B),J.writeShortString(F),J.writeLongString(N),J.buffer}static deserializeRequestJSONArgs(C){const B=C.readUInt8(),H=C.readShortString(),U=C.readLongString();return{rpcId:B,method:H,args:JSON.parse(U)}}static c(C,B,H,U,z){const F=L.$ce.fromString(H);let N=0;N+=m.sizeUInt8(),N+=m.sizeShortString(F),N+=m.sizeMixedArray(U);const x=m.alloc(z?4:3,C,N);return x.writeUInt8(B),x.writeShortString(F),x.writeMixedArray(U),x.buffer}static deserializeRequestMixedArgs(C){const B=C.readUInt8(),H=C.readShortString(),U=C.readMixedArray(),z=new Array(U.length);for(let F=0,N=U.length;F<N;F++){const x=U[F];typeof x=="string"?z[F]=JSON.parse(x):z[F]=x}return{rpcId:B,method:H,args:z}}static serializeAcknowledged(C){return m.alloc(5,C,0).buffer}static serializeCancel(C){return m.alloc(6,C,0).buffer}static serializeReplyOK(C,B,H){if(typeof B>"u")return this.d(C);if(B instanceof L.$ce)return this.e(C,B);if(B instanceof A.$uv){const{jsonString:U,referencedBuffers:z}=t(B.value,H,!0);return this.g(C,U,z)}else return this.f(C,o(B,H))}static d(C){return m.alloc(7,C,0).buffer}static e(C,B){let H=0;H+=m.sizeVSBuffer(B);const U=m.alloc(8,C,H);return U.writeVSBuffer(B),U.buffer}static deserializeReplyOKVSBuffer(C){return C.readVSBuffer()}static f(C,B){const H=L.$ce.fromString(B);let U=0;U+=m.sizeLongString(H);const z=m.alloc(9,C,U);return z.writeLongString(H),z.buffer}static g(C,B,H){const U=L.$ce.fromString(B);let z=0;z+=m.sizeUInt32,z+=m.sizeLongString(U);for(const N of H)z+=m.sizeVSBuffer(N);const F=m.alloc(10,C,z);F.writeUInt32(H.length),F.writeLongString(U);for(const N of H)F.writeBuffer(N);return F.buffer}static deserializeReplyOKJSON(C){const B=C.readLongString();return JSON.parse(B)}static deserializeReplyOKJSONWithBuffers(C,B){const H=C.readUInt32(),U=C.readLongString(),z=[];for(let F=0;F<H;++F)z.push(C.readVSBuffer());return new A.$uv(i(U,z,B))}static serializeReplyErr(C,B){const H=B?o(M.$2(B),null):void 0;if(typeof H!="string")return this.h(C);const U=L.$ce.fromString(H);let z=0;z+=m.sizeLongString(U);const F=m.alloc(11,C,z);return F.writeLongString(U),F.buffer}static deserializeReplyErrError(C){const B=C.readLongString();return JSON.parse(B)}static h(C){return m.alloc(12,C,0).buffer}}var d;(function(y){y[y.RequestJSONArgs=1]="RequestJSONArgs",y[y.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",y[y.RequestMixedArgs=3]="RequestMixedArgs",y[y.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",y[y.Acknowledged=5]="Acknowledged",y[y.Cancel=6]="Cancel",y[y.ReplyOKEmpty=7]="ReplyOKEmpty",y[y.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",y[y.ReplyOKJSON=9]="ReplyOKJSON",y[y.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",y[y.ReplyErrError=11]="ReplyErrError",y[y.ReplyErrEmpty=12]="ReplyErrEmpty"})(d||(d={}));var b;(function(y){y[y.String=1]="String",y[y.VSBuffer=2]="VSBuffer",y[y.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",y[y.Undefined=4]="Undefined"})(b||(b={}))}),define(Ae[279],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hhc=void 0;const E=function(M){const R=$=>{globalThis.removeEventListener("message",R);const D=$.data;Object.defineProperties(globalThis,{postMessage:{value(g,A){D.postMessage(g,A)}},onmessage:{get(){return D.onmessage},set(g){D.onmessage=g}}}),D.addEventListener("message",g=>{globalThis.dispatchEvent(new MessageEvent("message",{data:g.data,ports:g.ports?[...g.ports]:void 0}))}),D.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(M)};globalThis.addEventListener("message",R)}.toString();class L extends EventTarget{constructor(M,R,$){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const D=`((${E})('${R}'))`,g=new Blob([D],{type:"application/javascript"}),A=URL.createObjectURL(g),S=new MessageChannel,o=A,v={type:"_newWorker",id:o,port:S.port2,url:A,options:$};M(v,[S.port2]),this.postMessage=S.port1.postMessage.bind(S.port1),this.terminate=()=>{M({type:"_terminateWorker",id:o}),URL.revokeObjectURL(A),S.port1.close(),S.port2.close()},Object.defineProperties(this,{onmessage:{get(){return S.port1.onmessage},set(p){S.port1.onmessage=p}},onmessageerror:{get(){return S.port1.onmessageerror},set(p){S.port1.onmessageerror=p}}}),S.port1.addEventListener("messageerror",p=>{const f=new MessageEvent("messageerror",{data:p.data});this.dispatchEvent(f)}),S.port1.addEventListener("message",p=>{const f=new MessageEvent("message",{data:p.data});this.dispatchEvent(f)}),S.port1.start()}}e.$hhc=L}),define(Ae[280],Re([1,0,5,30,34,4]),function(pe,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OJ=e.$NJ=e.OutputChannelUpdateMode=e.$MJ=e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=void 0,e.$DJ="text/x-code-output",e.$EJ="output",e.$FJ="Log",e.$GJ="text/x-code-log-output",e.$HJ="log",e.$IJ="workbench.panel.output",e.$JJ=new P.$$i("inOutput",!1),e.$KJ=new P.$$i("activeLogOutput",!1),e.$LJ=new P.$$i("outputView.scrollLock",!1),e.$MJ=(0,M.$Th)("outputService");var R;(function(D){D[D.Append=1]="Append",D[D.Replace=2]="Replace",D[D.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$NJ={OutputChannels:"workbench.contributions.outputChannels"};class ${constructor(){this.a=new Map,this.b=new E.$Od,this.onDidRegisterChannel=this.b.event,this.c=new E.$Od,this.onDidRemoveChannel=this.c.event}registerChannel(g){this.a.has(g.id)||(this.a.set(g.id,g),this.b.fire(g.id))}getChannels(){const g=[];return this.a.forEach(A=>g.push(A)),g}getChannel(g){return this.a.get(g)}removeChannel(g){this.a.delete(g),this.c.fire(g)}}L.$kn.add(e.$NJ.OutputChannels,new $),e.$OJ=new P.$$i("activeOutputChannel","")}),define(Ae[112],Re([1,0,3,4,17,22,15,280,64,27,42,136,24,16,41,5,6]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tdc=e.$Sdc=void 0;class i extends R.$hj{get disposed(){return this.n}constructor(l,r,s,c,h){super(),this.id=l,this.name=r,this.r=s,this.s=c,this.extension=h,this.m=0,this.n=!1,this.visible=!1,this.setLevel(s.getLevel()),this.B(s.onDidChangeLogLevel(w=>this.setLevel(w)))}get logLevel(){return this.getLevel()}appendLine(l){this.append(l+`
`)}append(l){this.info(l)}clear(){const l=this.m;this.r.flush(),this.s.$update(this.id,$.OutputChannelUpdateMode.Clear,l)}replace(l){const r=this.m;this.info(l),this.s.$update(this.id,$.OutputChannelUpdateMode.Replace,r),this.visible&&this.r.flush()}show(l,r){this.r.flush(),this.s.$reveal(this.id,!!(typeof l=="boolean"?l:r))}hide(){this.s.$close(this.id)}g(l,r){this.m+=o.$ce.fromString(r).byteLength,(0,R.log)(this.r,l,r),this.visible&&(this.r.flush(),this.s.$update(this.id,$.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class n extends i{appendLine(l){this.append(l)}}let u=class{constructor(l,r,s,c,h,w){this.i=r,this.j=s,this.k=c,this.l=h,this.m=w,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=l.getProxy(E.$vK.MainThreadOutputService),this.b=this.k.extUri.joinPath(r.logsLocation,`output_logging_${(0,S.$im)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(l){this.h=l;for(const[r,s]of this.g)s.visible=r===this.h}createOutputChannel(l,r,s){if(l=l.trim(),!l)throw new Error("illegal argument `name`. must not be falsy");const c=typeof r=="object"&&r.log,h=(0,v.$zf)(r)?r:void 0;if((0,v.$zf)(h)&&!h.trim())throw new Error("illegal argument `languageId`. must not be empty");let w;const m=this.i.environment.extensionLogLevel?.find(([k])=>M.$0l.equals(s.identifier,k))?.[1];m&&(w=(0,R.$rj)(m));const I=c?this.o(l,w,s):this.n(l,h,s);return I.then(k=>{this.g.set(k.id,k),k.visible=k.id===this.h}),c?this.r(l,w??this.m.getLevel(),I):this.q(l,I)}async n(l,r,s){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const c=await this.c,h=this.k.extUri.joinPath(c,`${this.f++}-${l.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),w=this.l.createLogger(h,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),m=await this.a.$register(l,h,r,s.identifier.value);return new i(m,l,w,this.a,s)}async o(l,r,s){const c=await this.p(s),h=l.replace(/[\\/:\*\?"<>\|]/g,""),w=this.k.extUri.joinPath(c,`${h}.log`),m=`${s.identifier.value}.${h}`,I=this.l.createLogger(w,{id:m,name:l,logLevel:r,extensionId:s.identifier.value});return new n(m,l,I,this.a,s)}p(l){let r=this.d.get(l.identifier.value);if(!r){const s=this.k.extUri.joinPath(this.i.logsLocation,l.identifier.value);this.d.set(l.identifier.value,r=(async()=>{try{await this.j.value.createDirectory(s)}catch(c){if((0,p.$sk)(c)!==p.FileSystemProviderErrorCode.FileExists)throw c}return s})())}return r}q(l,r){let s=!1;const c=()=>{if(s)throw new Error("Channel has been closed")};return{get name(){return l},append(h){c(),r.then(w=>w.append(h))},appendLine(h){c(),r.then(w=>w.appendLine(h))},clear(){c(),r.then(h=>h.clear())},replace(h){c(),r.then(w=>w.replace(h))},show(h,w){c(),r.then(m=>m.show(h,w))},hide(){c(),r.then(h=>h.hide())},dispose(){s=!0,r.then(h=>h.dispose())}}}r(l,r,s){const c=new t.$Qc,h=()=>{if(c.isDisposed)throw new Error("Channel has been closed")},w=c.add(new f.$Od);function m(I){r=I,w.fire(I)}return s.then(I=>{c.add(I),I.logLevel!==r&&m(I.logLevel),c.add(I.onDidChangeLogLevel(k=>m(k)))}),{...this.q(l,s),get logLevel(){return r},onDidChangeLogLevel:w.event,trace(I,...k){h(),s.then(d=>d.trace(I,...k))},debug(I,...k){h(),s.then(d=>d.debug(I,...k))},info(I,...k){h(),s.then(d=>d.info(I,...k))},warn(I,...k){h(),s.then(d=>d.warn(I,...k))},error(I,...k){h(),s.then(d=>d.error(I,...k))},dispose(){c.dispose()}}}};e.$Sdc=u,e.$Sdc=u=Ke([Ve(0,P.$xM),Ve(1,g.$NM),Ve(2,D.$vdc),Ve(3,A.$3cc),Ve(4,R.$cj),Ve(5,R.$bj)],u),e.$Tdc=(0,L.$Th)("IExtHostOutputService")}),define(Ae[113],Re([1,0,4,12]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ym=e.$xm=void 0,e.$xm=(0,E.$Th)("remoteAgentService"),e.$ym=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(P){let M=1/0;for(let $=0;$<this.maxSampleCount;$++){const D=await P.getRoundTripTime();if(D===void 0)return;M=Math.min(M,D/2),await(0,L.$Vg)(this.sampleDelay)}this.average.push(M),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(M):R=this.initial.reduce(($,D)=>$+D,0)/this.initial.length,this.lastMeasurement={initial:R,current:M,average:this.average.reduce(($,D)=>$+D,0)/this.average.length,high:(()=>typeof R>"u"?!1:M>this.highLatencyMaxThreshold||M>this.highLatencyMinThreshold&&M>R*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Ae[281],Re([1,0,171,56,30,47,40,6,5,113,21]),function(pe,e,E,L,P,M,R,$,D,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sH=e.$rH=e.$qH=e.$pH=e.$oH=e.$nH=void 0,e.$nH=Object.freeze({id:"application",order:100,title:(0,E.localize)(0,null),type:"object"}),e.$oH=Object.freeze({id:"workbench",order:7,title:(0,E.localize)(1,null),type:"object"}),e.$pH=Object.freeze({id:"security",scope:1,title:(0,E.localize)(2,null),type:"object",order:7}),e.$qH={ConfigurationMigration:"base.contributions.configuration.migration"};class S{constructor(){this.migrations=[],this.a=new D.$Od,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(t){this.migrations.push(...t)}}const o=new S;P.$kn.add(e.$qH.ConfigurationMigration,o);let v=class extends $.$Rc{constructor(t,i){super(),this.a=t,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async n=>{for(const u of n.added)await this.f(u,o.migrations)})),this.c(o.migrations),this.B(o.onDidRegisterConfigurationMigration(n=>this.c(n)))}async c(t){await this.f(void 0,t);for(const i of this.b.getWorkspace().folders)await this.f(i,t)}async f(t,i){await Promise.all(i.map(n=>this.g(n,{resource:t?.uri})))}async g(t,i){const n=this.a.inspect(t.key,i);if(await this.h(t,i,n,"userValue",2),await this.h(t,i,n,"userLocalValue",3),await this.h(t,i,n,"userRemoteValue",4),await this.h(t,i,n,"workspaceFolderValue",6),await this.h(t,i,n,"workspaceValue",5),typeof i.overrideIdentifier>"u"&&typeof n.overrideIdentifiers<"u")for(const u of n.overrideIdentifiers)await this.g(t,{resource:i.resource,overrideIdentifier:u})}async h(t,i,n,u,a){const l=n[u];if(typeof l>"u")return;const r=h=>this.a.inspect(h,i)[u],s=await t.migrateFn(l,r),c=Array.isArray(s)?s:[[t.key,s]];await Promise.allSettled(c.map(async([h,w])=>this.a.updateValue(h,w.value,i,a)))}};e.$rH=v,e.$rH=v=Ke([Ve(0,R.$ni),Ve(1,M.$3h)],v);let p=class extends $.$Rc{constructor(t){super(),(async()=>{if(!A.$j&&(await t.getEnvironment())?.os!==1)return;P.$kn.as(L.$pn.Configuration).registerConfiguration({...e.$pH,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,E.localize)(3,null)},default:[],markdownDescription:(0,E.localize)(4,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,E.localize)(5,null),scope:2}}})})()}};e.$sH=p,e.$sH=p=Ke([Ve(0,g.$xm)],p)}),define(Ae[282],Re([1,0,33,14,19,25,179,281,56,4,30]),function(pe,e,E,L,P,M,R,$,D,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rcb=e.$qcb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$pcb=e.$ocb=void 0,e.$ocb=(0,g.$Th)("editorResolverService"),e.$pcb="workbench.editorAssociations";const S=A.$kn.as(D.$pn.Configuration),o={...$.$oH,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,R.localize)(0,null),additionalProperties:{type:"string"}}}};S.registerConfiguration(o);var v;(function(i){i.builtin="builtin",i.option="option",i.exclusive="exclusive",i.default="default"})(v||(e.RegisteredEditorPriority=v={}));var p;(function(i){i[i.ABORT=1]="ABORT",i[i.NONE=2]="NONE"})(p||(e.ResolvedStatus=p={}));function f(i){switch(i){case v.exclusive:return 5;case v.default:return 4;case v.builtin:return 3;case v.option:default:return 1}}e.$qcb=f;function t(i,n){if(new Set([L.Schemas.extension,L.Schemas.webviewPanel,L.Schemas.vscodeWorkspaceTrust,L.Schemas.vscodeSettings]).has(n.scheme))return!1;const l=typeof i=="string"&&i.indexOf(P.$fc.sep)>=0?`${n.scheme}:${n.path}`:(0,M.$tg)(n);return E.$zj(typeof i=="string"?i.toLowerCase():i,l.toLowerCase())}e.$rcb=t}),define(Ae[283],Re([1,0,46,14,19,21,25,2,4,200,47,218,113]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$8J=e.$7J=void 0,e.$7J=(0,D.$Th)("pathService");let p=v=class{constructor(t,i,n,u){this.d=t,this.e=i,this.f=n,this.g=u,this.a=(async()=>(await this.e.getEnvironment())?.os||M.OS)(),this.b=(async()=>{const a=await this.e.getEnvironment();return this.c=a?.userHome??t})()}hasValidBasename(t,i,n){return typeof i=="string"||typeof i>"u"?this.a.then(u=>this.h(t,u,i)):this.h(t,i,n)}h(t,i,n){return t.scheme===L.Schemas.file||t.scheme===L.Schemas.vscodeRemote?(0,E.$Wf)(n??(0,R.$tg)(t),i===1):!0}get defaultUriScheme(){return v.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(t,i){if(t.remoteAuthority)return L.Schemas.vscodeRemote;const n=(0,g.$4J)(i.getWorkspace());if(n)return n;const u=i.getWorkspace().folders[0];if(u)return u.uri.scheme;const a=i.getWorkspace().configuration;return a?a.scheme:L.Schemas.file}userHome(t){return t?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(t=>t===1?P.$ec:P.$fc)}async fileURI(t){let i="";if(await this.a===1&&(t=t.replace(/\\/g,"/")),t[0]==="/"&&t[1]==="/"){const u=t.indexOf("/",2);u===-1?(i=t.substring(2),t="/"):(i=t.substring(2,u),t=t.substring(u)||"/")}return $.URI.from({scheme:L.Schemas.file,authority:i,path:t,query:"",fragment:""})}};e.$8J=p,e.$8J=p=v=Ke([Ve(1,o.$xm),Ve(2,S.$PJ),Ve(3,A.$3h)],p)}),define(Ae[114],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$NI=e.$MI=void 0;class E{constructor(R,$){this.line=R,this.character=$}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,$){return new E(0,0)}with(R){return new E(0,0)}}e.$MI=E;class L{constructor(R,$,D,g){this.isEmpty=!1,this.isSingleLine=!1,this.start=new E(R,$),this.end=new E(D,g)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new L(0,0,0,0)}with(R){return new L(0,0,0,0)}}e.$NI=L;var P;(function(M){M[M.Information=1]="Information",M[M.Warning=2]="Warning"})(P||(e.TextSearchCompleteMessageType=P={}))}),define(Ae[43],Re([1,0,18,33,26,46,13,4,19,11,114,12]),function(pe,e,E,L,P,M,R,$,D,g,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.SearchErrorCode=e.$3I=e.$2I=e.SearchSortOrder=e.ViewMode=e.$1I=e.$ZI=e.$YI=e.$XI=e.SearchCompletionExitCode=e.$WI=e.$VI=e.$UI=e.QueryType=e.SearchProviderType=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.$OI="workbench.view.search",e.$PI="workbench.panel.search",e.$QI="workbench.view.search",e.$RI="search-result",e.$SI="search.exclude";const o="\u27EA ",v=" characters skipped \u27EB",p=(o.length+v.length+5)*2;e.$TI=(0,$.$Th)("searchService");var f;(function(ge){ge[ge.file=0]="file",ge[ge.text=1]="text"})(f||(e.SearchProviderType=f={}));var t;(function(ge){ge[ge.File=1]="File",ge[ge.Text=2]="Text"})(t||(e.QueryType=t={}));function i(ge){return!!ge.preview}e.$UI=i;function n(ge){return!!ge.resource}e.$VI=n;function u(ge){return!!ge.message}e.$WI=u;var a;(function(ge){ge[ge.Normal=0]="Normal",ge[ge.NewSearchStarted=1]="NewSearchStarted"})(a||(e.SearchCompletionExitCode=a={}));class l{constructor(we){this.resource=we,this.results=[]}}e.$XI=l;class r{constructor(we,re,oe,ve){this.ranges=re,this.webviewIndex=ve;const ee=Array.isArray(re)?re:[re];if(oe&&oe.matchLines===1&&s(ee)){we=(0,R.$sf)(we,oe.matchLines);let W="",ue=0,Pe=0;const Ee=Math.floor(oe.charsPerLine/5),te=[];for(const se of ee){const me=Math.max(se.startColumn-Ee,0),Z=se.startColumn+oe.charsPerLine;if(me>Pe+Ee+p){const le=o+(me-Pe)+v;W+=le+we.slice(me,Z),ue+=me-(Pe+le.length)}else W+=we.slice(Pe,Z);te.push(new h(0,se.startColumn-ue,se.endColumn-ue)),Pe=Z}this.preview={text:W,matches:Array.isArray(this.ranges)?te:te[0]}}else{const W=Array.isArray(re)?re[0].startLineNumber:re.startLineNumber;this.preview={text:we,matches:(0,E.$1b)(re,ue=>new c(ue.startLineNumber-W,ue.startColumn,ue.endLineNumber-W,ue.endColumn))}}}}e.$YI=r;function s(ge){const we=ge[0].startLineNumber;for(const re of ge)if(re.startLineNumber!==we||re.endLineNumber!==we)return!1;return!0}class c{constructor(we,re,oe,ve){this.startLineNumber=we,this.startColumn=re,this.endLineNumber=oe,this.endColumn=ve}}e.$ZI=c;class h extends c{constructor(we,re,oe){super(we,re,we,oe)}}e.$1I=h;var w;(function(ge){ge.List="list",ge.Tree="tree"})(w||(e.ViewMode=w={}));var m;(function(ge){ge.Default="default",ge.FileNames="fileNames",ge.Type="type",ge.Modified="modified",ge.CountDescending="countDescending",ge.CountAscending="countAscending"})(m||(e.SearchSortOrder=m={}));function I(ge,we=!0){const re=ge&&ge.files&&ge.files.exclude,oe=we&&ge&&ge.search&&ge.search.exclude;if(!re&&!oe)return;if(!re||!oe)return re||oe;let ve=Object.create(null);return ve=P.$bn(ve,P.$$m(re)),ve=P.$bn(ve,P.$$m(oe),!0),ve}e.$2I=I;function k(ge,we){return ge.excludePattern&&L.$zj(ge.excludePattern,we)?!1:ge.includePattern||ge.usingSearchPaths?ge.includePattern&&L.$zj(ge.includePattern,we)?!0:ge.usingSearchPaths?!!ge.folderQueries&&ge.folderQueries.some(re=>{const oe=re.folder.fsPath;if(M.$Yf(we,oe)){const ve=D.$kc(oe,we);return!re.includePattern||!!L.$zj(re.includePattern,ve)}else return!1}):!1:!0}e.$3I=k;var d;(function(ge){ge[ge.unknownEncoding=1]="unknownEncoding",ge[ge.regexParseError=2]="regexParseError",ge[ge.globParseError=3]="globParseError",ge[ge.invalidLiteral=4]="invalidLiteral",ge[ge.rgProcessError=5]="rgProcessError",ge[ge.other=6]="other",ge[ge.canceled=7]="canceled"})(d||(e.SearchErrorCode=d={}));class b extends Error{constructor(we,re){super(we),this.code=re}}e.$4I=b;function y(ge){const we=ge.message;if((0,g.$3)(ge))return new b(we,d.canceled);try{const re=JSON.parse(we);return new b(re.message,re.code)}catch{return new b(we,d.other)}}e.$5I=y;function C(ge){const we={message:ge.message,code:ge.code};return new Error(JSON.stringify(we))}e.$6I=C;function B(ge){return ge.type==="error"?!0:ge.type==="success"}e.$7I=B;function H(ge){return ge.type==="success"}e.$8I=H;function U(ge){return!!ge.path}e.$9I=U;function z(ge,we){const re=ge.searchPath?ge.searchPath:ge.relativePath;return(0,R.$pf)(re,we)}e.$0I=z;class F{constructor(we){this.path=we,this.results=[]}addMatch(we){this.results.push(we)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$$I=F;function N(ge,we){const re={...ge||{},...we||{}};return Object.keys(re).filter(oe=>{const ve=re[oe];return typeof ve=="boolean"&&ve})}e.$_I=N;class x{constructor(we,re){this.c=null,this.a={...we.excludePattern||{},...re.excludePattern||{}},this.b=L.$Aj(this.a);let oe=we.includePattern;re.includePattern&&(oe?oe={...oe,...re.includePattern}:oe=re.includePattern),oe&&(this.c=L.$Aj(oe))}matchesExcludesSync(we,re,oe){return!!(this.b&&this.b(we,re,oe))}includedInQuerySync(we,re,oe){return!(this.b&&this.b(we,re,oe)||this.c&&!this.c(we,re,oe))}includedInQuery(we,re,oe){const ve=this.b(we,re,oe),ee=()=>this.c?!!this.c(we,re,oe):!0;return(0,S.$Hg)(ve)?ve.then(W=>W?!1:ee()):ee()}hasSiblingExcludeClauses(){return J(this.a)}}e.$aJ=x;function J(ge){for(const we in ge)if(typeof ge[we]!="boolean")return!0;return!1}function ye(ge){if(!ge)return;let we;return re=>(we||(we=(ge()||Promise.resolve([])).then(oe=>oe?Ce(oe):{})),we.then(oe=>!!oe[re]))}e.$bJ=ye;function De(ge){if(!ge)return;let we;return re=>{if(!we){const oe=ge();we=oe?Ce(oe):{}}return!!we[re]}}e.$cJ=De;function Ce(ge){const we={};for(const re of ge)we[re]=!0;return we}}),define(Ae[35],Re([1,0,18,12,20,5,6,51,14,121,25,13,2,170,4,15,189,47,42,27,17,8,7,59,43,3,52]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f,t,i,n,u,a,l,r,s,c,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ddc=e.$cdc=void 0;function m(H,U,z){return new A.$lg(F=>b(F,z)).isEqual(H,U)}function I(H,U,z){return m(H.uri,U.uri,z)?0:(0,S.$Ve)(H.uri.toString(),U.uri.toString())}function k(H,U,z){return H.index!==U.index?H.index<U.index?-1:1:m(H.uri,U.uri,z)?(0,S.$Ve)(H.name,U.name):(0,S.$Ve)(H.uri.toString(),U.uri.toString())}function d(H,U,z,F){const N=H.slice(0).sort((J,ye)=>z(J,ye,F)),x=U.slice(0).sort((J,ye)=>z(J,ye,F));return(0,E.$Db)(N,x,(J,ye)=>z(J,ye,F))}function b(H,U){const z=U.getCapabilities(H.scheme);return!(z&&z&1024)}class y extends i.$ai{static toExtHostWorkspace(U,z,F,N){if(!U)return{workspace:null,added:[],removed:[]};const{id:x,name:J,folders:ye,configuration:De,transient:Ce,isUntitled:ge}=U,we=[],re=z;z?ye.forEach((W,ue)=>{const Pe=o.URI.revive(W.uri),Ee=y.o(F||z,Pe,N);Ee?(Ee.name=W.name,Ee.index=W.index,we.push(Ee)):we.push({uri:Pe,name:W.name,index:ue})}):we.push(...ye.map(({uri:W,name:ue,index:Pe})=>({uri:o.URI.revive(W),name:ue,index:Pe}))),we.sort((W,ue)=>W.index<ue.index?-1:1);const oe=new y(x,J,we,!!Ce,De?o.URI.revive(De):null,!!ge,W=>b(W,N)),{added:ve,removed:ee}=d(re?re.workspaceFolders:[],oe.workspaceFolders,I,N);return{workspace:oe,added:ve,removed:ee}}static o(U,z,F){for(let N=0;N<U.folders.length;N++){const x=U.workspaceFolders[N];if(m(x.uri,z,F))return x}}constructor(U,z,F,N,x,J,ye){super(U,F.map(De=>new i.$bi(De)),N,x,ye),this.t=z,this.u=J,this.q=[],this.s=$.$Zh.forUris(ye),F.forEach(De=>{this.q.push(De),this.s.set(De.uri,De)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(U,z){return z&&this.s.get(U)&&(U=(0,A.$vg)(U)),this.s.findSubstr(U)}resolveWorkspaceFolder(U){return this.s.get(U)}}let C=class{constructor(U,z,F,N,x){this.c=new M.$Od,this.onDidChangeWorkspace=this.c.event,this.g=new M.$Od,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new M.$Qd,this.B=new Map,this.h=N,this.s=F,this.t=x,this.j=new g.$Ul,this.k=new L.$Tg,this.o=U.getProxy(h.$vK.MainThreadWorkspace),this.q=U.getProxy(h.$vK.MainThreadMessageService);const J=z.workspace;this.l=J?new y(J.id,J.name,[],!!J.transient,J.configuration?o.URI.revive(J.configuration):null,!!J.isUntitled,ye=>b(ye,F)):void 0}$initializeWorkspace(U,z){this.v=z,this.$acceptWorkspaceData(U),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?o.URI.from({scheme:D.Schemas.untitled,path:(0,A.$tg)((0,A.$vg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(U,z,F,...N){const x=[];if(Array.isArray(N)&&N.forEach(ge=>{o.URI.isUri(ge.uri)&&!x.some(we=>m(we.uri,ge.uri,this.s))&&x.push({uri:ge.uri,name:ge.name||(0,A.$sg)(ge.uri)})}),this.n||[z,F].some(ge=>typeof ge!="number"||ge<0)||F===0&&x.length===0)return!1;const J=this.x?this.x.workspaceFolders:[];if(z+F>J.length)return!1;const ye=J.slice(0);ye.splice(z,F,...x.map(ge=>({uri:ge.uri,name:ge.name||(0,A.$sg)(ge.uri),index:void 0})));for(let ge=0;ge<ye.length;ge++){const we=ye[ge];if(ye.some((re,oe)=>oe!==ge&&m(we.uri,re.uri,this.s)))return!1}ye.forEach((ge,we)=>ge.index=we);const{added:De,removed:Ce}=d(J,ye,k,this.s);if(De.length===0&&Ce.length===0)return!1;if(this.o){const ge=U.displayName||U.name;this.o.$updateWorkspaceFolders(ge,z,F,x).then(void 0,we=>{this.n=void 0;const re={source:{identifier:U.identifier,label:U.displayName||U.name}};this.q.$showMessage(t.Severity.Error,(0,v.localize)(0,null,ge,we.toString()),re,[])})}return this.y(ye),!0}getWorkspaceFolder(U,z){if(this.x)return this.x.getWorkspaceFolder(U,z)}async getWorkspaceFolder2(U,z){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(U,z)}async resolveWorkspaceFolder(U){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(U)}getPath(){if(!this.x)return;const{folders:U}=this.x;if(U.length!==0)return U[0].uri.fsPath}getRelativePath(U,z){let F,N="";if(typeof U=="string"?(F=o.URI.file(U),N=U):typeof U<"u"&&(F=U,N=U.fsPath),!F)return N;const x=this.getWorkspaceFolder(F,!0);if(!x)return N;typeof z>"u"&&this.x&&(z=this.x.folders.length>1);let J=(0,A.$yg)(x.uri,F);return z&&x.name&&(J=`${x.name}/${J}`),J}y(U){this.x&&(this.n=y.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:U,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(U){const{workspace:z,added:F,removed:N}=y.toExtHostWorkspace(U,this.l,this.n,this.s);this.l=z||void 0,this.n=void 0,this.c.fire(Object.freeze({added:F,removed:N}))}findFiles(U,z,F,N,x=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${N.value}, entryPoint: findFiles`);let J;if(z===null?J=!1:z&&(typeof z=="string"?J=z:J=z.pattern),x&&x.isCancellationRequested)return Promise.resolve([]);const{includePattern:ye,folder:De}=B(l.GlobPattern.from(U));return this.o.$startFileSearch(ye??null,De??null,J??null,F??null,x).then(Ce=>Array.isArray(Ce)?Ce.map(ge=>o.URI.revive(ge)):[])}async findTextInFiles(U,z,F,N,x=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${N.value}, entryPoint: findTextInFiles`);const J=this.j.getNext(),ye=typeof z.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:z.previewOptions,{includePattern:De,folder:Ce}=B(l.GlobPattern.from(z.include)),ge=typeof z.exclude=="string"?z.exclude:z.exclude?z.exclude.pattern:void 0,we={ignoreSymlinks:typeof z.followSymlinks=="boolean"?!z.followSymlinks:void 0,disregardIgnoreFiles:typeof z.useIgnoreFiles=="boolean"?!z.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof z.useGlobalIgnoreFiles=="boolean"?!z.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof z.useParentIgnoreFiles=="boolean"?!z.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof z.useDefaultExcludes=="boolean"?!z.useDefaultExcludes:!0,fileEncoding:z.encoding,maxResults:z.maxResults,previewOptions:ye,afterContext:z.afterContext,beforeContext:z.beforeContext,includePattern:De,excludePattern:ge},re=!1;if(this.u[J]=oe=>{if(re)return;const ve=o.URI.revive(oe.resource);oe.results.forEach(ee=>{const W=(0,w.$qh)(ee);(0,c.$UI)(W)?F({uri:ve,preview:{text:W.preview.text,matches:(0,E.$1b)(W.preview.matches,ue=>new r.$zK(ue.startLineNumber,ue.startColumn,ue.endLineNumber,ue.endColumn))},ranges:(0,E.$1b)(W.ranges,ue=>new r.$zK(ue.startLineNumber,ue.startColumn,ue.endLineNumber,ue.endColumn))}):F({uri:ve,text:W.text,lineNumber:W.lineNumber})})},x.isCancellationRequested)return{};try{const oe=await this.o.$startTextSearch(U,Ce??null,we,J,x);return delete this.u[J],oe||{}}catch(oe){throw delete this.u[J],oe}}$handleTextSearchResult(U,z){this.u[z]?.(U)}async save(U){const z=await this.o.$save(U,{saveAs:!1});return o.URI.revive(z)}async saveAs(U){const z=await this.o.$save(U,{saveAs:!0});return o.URI.revive(z)}saveAll(U){return this.o.$saveAll(U)}resolveProxy(U){return this.o.$resolveProxy(U)}get trusted(){return this.v}requestWorkspaceTrust(U){return this.o.$requestWorkspaceTrust(U)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(U,z){if(this.w.has(U))throw new Error(`A provider has already been registered for scheme ${U}`);this.w.set(U,z);const F=this.t.transformOutgoingScheme(U),N=this.z++;return this.o.$registerEditSessionIdentityProvider(N,F),(0,R.$Pc)(()=>{this.w.delete(U),this.o.$unregisterEditSessionIdentityProvider(N)})}async $getEditSessionIdentifier(U,z){this.h.info("Getting edit session identifier for workspaceFolder",U);const F=await this.resolveWorkspaceFolder(o.URI.revive(U));if(!F){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",F);const N=this.w.get(F.uri.scheme);if(this.h.info(`Provider for scheme ${F.uri.scheme} is defined: `,!!N),!N)return;const x=await N.provideEditSessionIdentity(F,z);if(this.h.info("Provider returned edit session identifier: ",x),!!x)return x}async $provideEditSessionIdentityMatch(U,z,F,N){this.h.info("Getting edit session identifier for workspaceFolder",U);const x=await this.resolveWorkspaceFolder(o.URI.revive(U));if(!x){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",x);const J=this.w.get(x.uri.scheme);if(this.h.info(`Provider for scheme ${x.uri.scheme} is defined: `,!!J),!J)return;const ye=await J.provideEditSessionIdentityMatch?.(z,F,N);if(this.h.info("Provider returned edit session identifier match result: ",ye),!!ye)return ye}getOnWillCreateEditSessionIdentityEvent(U){return(z,F,N)=>{const x=function(ye){z.call(F,ye)};return x.extension=U,this.A.event(x,void 0,N)}}async $onWillCreateEditSessionIdentity(U,z,F){const N=await this.resolveWorkspaceFolder(o.URI.revive(U));if(N===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:N},z,async(x,J)=>{const ye=Date.now();await Promise.resolve(x),Date.now()-ye>F&&this.h.warn("SLOW edit session create-participant",J.extension.identifier)}),z.isCancellationRequested}registerCanonicalUriProvider(U,z){if(this.B.has(U))throw new Error(`A provider has already been registered for scheme ${U}`);this.B.set(U,z);const F=this.t.transformOutgoingScheme(U),N=this.z++;return this.o.$registerCanonicalUriProvider(N,F),(0,R.$Pc)(()=>{this.B.delete(U),this.o.$unregisterCanonicalUriProvider(N)})}async provideCanonicalUri(U,z,F){const N=this.B.get(U.scheme);if(!N)return;const x=await N.provideCanonicalUri?.(o.URI.revive(U),z,F);if(x)return x}async $provideCanonicalUri(U,z,F){return this.provideCanonicalUri(o.URI.revive(U),{targetScheme:z},F)}};e.$cdc=C,e.$cdc=C=Ke([Ve(0,a.$xM),Ve(1,u.$NM),Ve(2,n.$3cc),Ve(3,f.$bj),Ve(4,s.$adc)],C),e.$ddc=(0,p.$Th)("IExtHostWorkspace");function B(H){let U,z;return H&&(typeof H=="string"?U=H:(U=H.pattern,z=o.URI.revive(H.baseUri))),{includePattern:U,folder:z}}}),define(Ae[36],Re([1,0,26,5,35,3,7,191,56,16,12,4,17,15,2]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gdc=e.$fdc=e.$edc=void 0;function f(s,c){if(c){const h=c.split(".");let w=s;for(let m=0;w&&m<h.length;m++)w=w[h[m]];return w}}function t(s){return s instanceof p.URI}function i(s){return s&&s.uri instanceof p.URI&&s.languageId&&typeof s.languageId=="string"}function n(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function u(s){return s&&s.uri instanceof p.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function a(s){if(t(s))return{resource:s};if(i(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(n(s))return{overrideIdentifier:s.languageId};if(u(s))return{resource:s.uri};if(s===null)return{resource:null}}let l=class{constructor(c,h,w){this.a=c.getProxy(M.$vK.MainThreadConfiguration),this.c=h,this.b=w,this.d=new A.$Tg,this.e=null}getConfigProvider(){return this.d.wait().then(c=>this.e)}$initializeConfiguration(c){this.e=new r(this.a,this.c,c,this.b),this.d.open()}$acceptConfigurationChanged(c,h){this.getConfigProvider().then(w=>w.$acceptConfigurationChanged(c,h))}};e.$edc=l,e.$edc=l=Ke([Ve(0,o.$xM),Ve(1,P.$ddc),Ve(2,v.$bj)],l);class r{constructor(c,h,w,m){this.a=new L.$Od,this.b=c,this.f=m,this.c=h,this.e=$.$In.parse(w),this.d=this.k(w.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(c,h){const w={data:this.e.toData(),workspace:this.c.workspace};this.e=$.$In.parse(c),this.d=this.k(c.configurationScopes),this.a.fire(this.j(h,w))}getConfiguration(c,h,w){const m=a(h)||{},I=this.g(c?f(this.e.getValue(void 0,m,this.c.workspace),c):this.e.getValue(void 0,m,this.c.workspace));c&&this.h(c,m,w?.identifier);function k(b){if(b==null)return null;if(typeof b=="boolean")return b?2:5;switch(b){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const d={has(b){return typeof f(I,b)<"u"},get:(b,y)=>{this.h(c?`${c}.${b}`:b,m,w?.identifier);let C=f(I,b);if(typeof C>"u")C=y;else{let B;const H=(U,z)=>{if((0,g.$Bf)(U)){let F;const N=()=>{B=B||(0,E.$$m)(I),F=F||f(B,z)};return new Proxy(U,{get:(x,J)=>{if(typeof J=="string"&&J.toLowerCase()==="tojson")return N(),()=>F;if(B)return F=F||f(B,z),F[J];const ye=x[J];return typeof J=="string"?H(ye,`${z}.${J}`):ye},set:(x,J,ye)=>(N(),F&&(F[J]=ye),!0),deleteProperty:(x,J)=>(N(),F&&delete F[J],!0),defineProperty:(x,J,ye)=>(N(),F&&Object.defineProperty(F,J,ye),!0)})}return Array.isArray(U)?(0,E.$$m)(U):U};C=H(C,b)}return C},update:(b,y,C,B)=>{b=c?`${c}.${b}`:b;const H=k(C);return y!==void 0?this.b.$updateConfigurationOption(H,b,y,m,B):this.b.$removeConfigurationOption(H,b,m,B)},inspect:b=>{b=c?`${c}.${b}`:b;const y=this.e.inspect(b,m,this.c.workspace);if(y)return{key:b,defaultValue:(0,E.$$m)(y.policy?.value??y.default?.value),globalValue:(0,E.$$m)(y.user?.value??y.application?.value),workspaceValue:(0,E.$$m)(y.workspace?.value),workspaceFolderValue:(0,E.$$m)(y.workspaceFolder?.value),defaultLanguageValue:(0,E.$$m)(y.default?.override),globalLanguageValue:(0,E.$$m)(y.user?.override??y.application?.override),workspaceLanguageValue:(0,E.$$m)(y.workspace?.override),workspaceFolderLanguageValue:(0,E.$$m)(y.workspaceFolder?.override),languageIds:(0,E.$$m)(y.overrideIdentifiers)}}};return typeof I=="object"&&(0,E.$bn)(d,I,!1),Object.freeze(d)}g(c){const h=w=>(0,g.$Bf)(w)?new Proxy(w,{get:(m,I)=>h(m[I]),set:(m,I,k)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(I)}' of object`)},deleteProperty:(m,I)=>{throw new Error(`TypeError: Cannot delete read only property '${String(I)}' of object`)},defineProperty:(m,I)=>{throw new Error(`TypeError: Cannot define property '${String(I)}' for a readonly object`)},setPrototypeOf:m=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):w;return h(c)}h(c,h,w){const m=D.$zn.test(c)?4:this.d.get(c),I=w?`[${w.value}] `:"";if(m===4){typeof h?.resource>"u"&&this.f.warn(`${I}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${c}', provide the URI of a resource or 'null' for any resource.`);return}if(m===3){h?.resource&&this.f.warn(`${I}Accessing a window scoped configuration for a resource is not expected. To associate '${c}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(c,h){const w=new $.$Kn(c,h,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(m,I)=>w.affectsConfiguration(m,a(I))})}k(c){return c.reduce((h,w)=>(h.set(w[0],w[1]),h),new Map)}}e.$fdc=r,e.$gdc=(0,S.$Th)("IExtHostConfiguration")}),define(Ae[115],Re([1,0,2,12,5,3,7,35,62,36,20,65,17,27,4,14,21,15,81,230,11]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f,t,i,n,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eec=e.$dec=e.$cec=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var l;(function(H){function U(F){if(F!=null)return F}H.from=U;function z(F){if(F!=null)return F}H.to=z})(l||(l={}));var r;(function(H){function U(F){if(F!=null)return F}H.from=U;function z(F){if(F!=null)return F}H.to=z})(r||(r={}));var s;(function(H){function U(F){if(F!=null)return F}H.from=U;function z(F){if(F!=null)return F}H.to=z})(s||(s={}));var c;(function(H){function U(N){if(N){const x=N;return x&&!!x.process}else return!1}H.is=U;function z(N){if(N==null)return;const x={process:N.process,args:N.args};return N.options&&(x.options=s.from(N.options)),x}H.from=z;function F(N){if(N!=null)return new R.$fL(N.process,N.args,N.options)}H.to=F})(c||(c={}));var h;(function(H){function U(F){if(F!=null)return F}H.from=U;function z(F){if(F!=null)return F}H.to=z})(h||(h={}));var w;(function(H){function U(N){if(N){const x=N;return x&&(!!x.commandLine||!!x.command)}else return!1}H.is=U;function z(N){if(N==null)return;const x={};return N.commandLine!==void 0?x.commandLine=N.commandLine:(x.command=N.command,x.args=N.args),N.options&&(x.options=h.from(N.options)),x}H.from=z;function F(N){if(!(N==null||N.command===void 0&&N.commandLine===void 0))return N.commandLine?new R.$gL(N.commandLine,N.options):new R.$gL(N.command,N.args?N.args:[],N.options)}H.to=F})(w||(w={}));var m;(function(H){function U(N){if(N){const x=N;return x&&x.customExecution==="customExecution"}else return!1}H.is=U;function z(N){return{customExecution:"customExecution"}}H.from=z;function F(N,x){return x.get(N)}H.to=F})(m||(e.CustomExecutionDTO=m={}));var I;(function(H){function U(z,F){let N;return z.scope!==void 0&&typeof z.scope!="number"?N=z.scope.uri:z.scope!==void 0&&typeof z.scope=="number"&&(z.scope===R.TaskScope.Workspace&&F&&F.workspaceFile?N=F.workspaceFile:N=u.$7F),{id:z._id,workspaceFolder:N}}H.from=U})(I||(e.TaskHandleDTO=I={}));var k;(function(H){function U(z){if(z!=null)return{_id:z.id,isDefault:z.isDefault}}H.from=U})(k||(k={}));var d;(function(H){function U(N,x){if(N==null)return[];const J=[];for(const ye of N){const De=z(ye,x);De&&J.push(De)}return J}H.fromMany=U;function z(N,x){if(N==null)return;let J;N.execution instanceof R.$fL?J=c.from(N.execution):N.execution instanceof R.$gL?J=w.from(N.execution):N.execution&&N.execution instanceof R.$hL&&(J=m.from(N.execution));const ye=l.from(N.definition);let De;return N.scope?typeof N.scope=="number"?De=N.scope:De=N.scope.uri:De=R.TaskScope.Workspace,!ye||!De?void 0:{_id:N._id,definition:ye,name:N.name,source:{extensionId:x.identifier.value,label:N.source,scope:De},execution:J,isBackground:N.isBackground,group:k.from(N.group),presentationOptions:r.from(N.presentationOptions),problemMatchers:N.problemMatchers,hasDefinedMatchers:N.hasDefinedMatchers,runOptions:N.runOptions?N.runOptions:{reevaluateOnRerun:!0},detail:N.detail}}H.from=z;async function F(N,x,J){if(N==null)return;let ye;c.is(N.execution)?ye=c.to(N.execution):w.is(N.execution)?ye=w.to(N.execution):m.is(N.execution)&&(ye=m.to(N._id,J));const De=l.to(N.definition);let Ce;if(N.source&&(N.source.scope!==void 0?typeof N.source.scope=="number"?Ce=N.source.scope:Ce=await x.resolveWorkspaceFolder(E.URI.revive(N.source.scope)):Ce=R.TaskScope.Workspace),!De||!Ce)return;const ge=new R.$iL(De,Ce,N.name,N.source.label,ye,N.problemMatchers);return N.isBackground!==void 0&&(ge.isBackground=N.isBackground),N.group!==void 0&&(ge.group=R.$eL.from(N.group._id),ge.group&&N.group.isDefault&&(ge.group=new R.$eL(ge.group.id,ge.group.label),N.group.isDefault===!0&&(ge.group.isDefault=N.group.isDefault))),N.presentationOptions&&(ge.presentationOptions=r.to(N.presentationOptions)),N._id&&(ge._id=N._id),N.detail&&(ge.detail=N.detail),ge}H.to=F})(d||(e.TaskDTO=d={}));var b;(function(H){function U(F){return F}H.from=U;function z(F){if(F)return Object.assign(Object.create(null),F)}H.to=z})(b||(b={}));class y{#e;constructor(U,z,F){this._id=z,this.a=F,this.#e=U}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(U){}fireDidEndProcess(U){}}let C=class{constructor(U,z,F,N,x,J,ye,De){this.q=new P.$Od,this.r=new P.$Od,this.s=new P.$Od,this.t=new P.$Od,this.a=U.getProxy(M.$vK.MainThreadTask),this.b=F,this.c=N,this.d=x,this.e=J,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ye,this.g=De,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(U,z,F){if(!F)return new R.$xK(()=>{});const N=this.w();return this.j.set(N,{type:z,provider:F,extension:U}),this.a.$registerTaskProvider(N,z),new R.$xK(()=>{this.j.delete(N),this.a.$unregisterTaskProvider(N)})}registerTaskSystem(U,z){this.a.$registerTaskSystem(U,z)}fetchTasks(U){return this.a.$fetchTasks(b.from(U)).then(async z=>{const F=[];for(const N of z){const x=await d.to(N,this.b,this.m);x&&F.push(x)}return F})}get taskExecutions(){const U=[];return this.k.forEach(z=>U.push(z)),U}terminateTask(U){if(!(U instanceof y))throw new Error("No valid task execution provided");return this.a.$terminateTask(U._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(U,z,F){const N=this.m.get(U.id);N&&(this.o.set(U.id,N),this.e.attachPtyToTerminal(z,await N.callback(F))),this.p=U.id,this.q.fire({execution:await this.y(U)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(U){const z=await this.y(U);this.l.delete(U.id),this.k.delete(U.id),this.A(U),this.r.fire({execution:z})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(U){const z=await this.y(U.id);this.s.fire({execution:z,processId:U.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(U){const z=await this.y(U.id);this.t.fire({execution:z,exitCode:U.exitCode})}$provideTasks(U,z){const F=this.j.get(U);if(!F)return Promise.reject(new Error("no handler found"));const N=[],x=(0,L.$Ng)(()=>F.provider.provideTasks(A.CancellationToken.None)).then(J=>this.u(z,N,F,J));return new Promise(J=>{x.then(ye=>{Promise.all(N).then(()=>{J(ye)})})})}async $resolveTask(U,z){const F=this.j.get(U);if(!F)return Promise.reject(new Error("no handler found"));if(z.definition.type!==F.type)throw new Error(`Unexpected: Task of type [${z.definition.type}] cannot be resolved by provider of type [${F.type}].`);const N=await d.to(z,this.b,this.m);if(!N)throw new Error("Unexpected: Task cannot be resolved.");const x=await F.provider.resolveTask(N,A.CancellationToken.None);if(!x)return;this.z(x,F);const J=d.from(x,F.extension);if(!J)throw new Error("Unexpected: Task cannot be resolved.");if(x.definition!==N.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return m.is(J.execution)&&await this.x(J,x,!0),await this.v(J)}w(){return this.h++}async x(U,z,F){const N=await this.a.$createTaskId(U);!F&&!this.m.has(N)&&(this.n.add(N),this.o.set(N,z.execution)),this.m.set(N,z.execution)}async y(U,z){if(typeof U=="string"){const x=this.l.get(U);if(!x)throw new a.$ab("Unexpected: The specified task is missing an execution");return x}const F=this.l.get(U.id);if(F)return F;const N=new Promise((x,J)=>{function ye(De,Ce,ge){ge?x(new y(De,Ce.id,ge)):J("Unexpected: Task does not exist.")}z?ye(this,U,z):d.to(U.task,this.b,this.m).then(De=>ye(this,U,De))});return this.l.set(U.id,N),N.then(x=>(this.k.set(U.id,x),x),x=>Promise.reject(x))}z(U,z){U._deprecated&&this.g.report("Task.constructor",z.extension,"Use the Task constructor that takes a `scope` instead.")}A(U){this.o.get(U.id)&&this.o.delete(U.id),this.n.has(U.id)&&this.p!==U.id&&(this.m.delete(U.id),this.n.delete(U.id));const F=this.n.values();let N=F.next();for(;!N.done;)!this.o.has(N.value)&&this.p!==N.value&&(this.m.delete(N.value),this.n.delete(N.value)),N=F.next()}};e.$cec=C,e.$cec=C=Ke([Ve(0,o.$xM),Ve(1,v.$NM),Ve(2,$.$ddc),Ve(3,D.$IM),Ve(4,g.$gdc),Ve(5,S.$ydc),Ve(6,i.$bj),Ve(7,n.$6cc)],C);let B=class extends C{constructor(U,z,F,N,x,J,ye,De){super(U,z,F,N,x,J,ye,De),this.registerTaskSystem(f.Schemas.vscodeRemote,{scheme:f.Schemas.vscodeRemote,authority:"",platform:t.$i(0)})}async executeTask(U,z){if(!z.execution)throw new Error("Tasks to execute must include an execution");const F=d.from(z,U);if(F===void 0)throw new Error("Task is not valid");if(m.is(F.execution))await this.x(F,z,!1);else throw new a.$$;const N=await this.y(await this.a.$getTaskExecution(F),z);return this.a.$executeTask(F).catch(x=>{throw new Error(x)}),N}u(U,z,F,N){const x=[];if(N)for(const J of N){this.z(J,F),(!J.definition||!U[J.definition.type])&&this.f.warn(`The task [${J.source}, ${J.name}] uses an undefined task type. The task will be ignored in the future.`);const ye=d.from(J,F.extension);ye&&m.is(ye.execution)?(x.push(ye),z.push(this.x(ye,J,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:x,extension:F.extension}}async v(U){if(m.is(U.execution))return U;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(U,z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(U,z,F){}};e.$dec=B,e.$dec=B=Ke([Ve(0,o.$xM),Ve(1,v.$NM),Ve(2,$.$ddc),Ve(3,D.$IM),Ve(4,g.$gdc),Ve(5,S.$ydc),Ve(6,i.$bj),Ve(7,n.$6cc)],B),e.$eec=(0,p.$Th)("IExtHostTask")}),define(Ae[284],Re([1,0,43,29]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tK=e.$sK=e.$rK=void 0;function P(R){return"cellResults"in R}e.$rK=P,e.$sK="rawCell#";function M(R,$){let D=-1;const g=[];let A=[];return R.forEach(o=>{o.range.startLineNumber!==D&&A.length>0&&(g.push([...A]),A=[]),A.push(o),D=o.range.endLineNumber}),A.length>0&&g.push([...A]),g.map(o=>{const v=[],p=o[0].range.startLineNumber,f=o[o.length-1].range.endLineNumber;for(let t=p;t<=f;t++)v.push($.getLineContent(t));return new E.$YI(v.join(`
`)+`
`,o.map(t=>new L.$xs(t.range.startLineNumber-1,t.range.startColumn-1,t.range.endLineNumber-1,t.range.endColumn-1)))})}e.$tK=M}),define(Ae[285],Re([1,0,163,24,5,6,28,13,16,2,41,75,3,32,8,7,49,222,107,11,26,14,213,284,282]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f,t,i,n,u,a,l,r,s,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zec=void 0;class h{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(m=>m.apiEditor)}constructor(m,I,k,d,b,y){this.q=k,this.r=d,this.s=b,this.t=y,this.f=new Map,this.g=new R.$zc,this.h=new Map,this.j=new P.$Od({onListenerError:u.$1}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new P.$Od({onListenerError:u.$1}),this.onDidOpenNotebookDocument=this.m.event,this.n=new P.$Od({onListenerError:u.$1}),this.onDidCloseNotebookDocument=this.n.event,this.o=new P.$Od({onListenerError:u.$1}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new S.$Zcc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=m.getProxy(o.$vK.MainThreadNotebook),this.c=m.getProxy(o.$vK.MainThreadNotebookDocuments),this.d=m.getProxy(o.$vK.MainThreadNotebookEditors),this.i=I.converter,I.registerArgumentProcessor({processArgument:C=>{if(C&&C.$mid===13){const B=C.notebookEditor?.notebookUri,H=C.cell.handle,z=this.g.get(B)?.getCell(H);if(z)return z.apiCell}if(C&&C.$mid===14){const B=C.uri,H=this.g.get(B);if(H)return H.apiNotebook}return C}}),h.B(I)}getEditorById(m){const I=this.h.get(m);if(!I)throw new Error(`unknown text editor: ${m}. known editors: ${[...this.h.keys()]} `);return I}getIdByEditor(m){for(const[I,k]of this.h)if(k.apiEditor===m)return I}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(m,I){const k=this.g.get(m);if(!k&&!I)throw new Error(`NO notebook document for '${m}'`);return k}static u(m,I){if(!I)return;const k=I.filenamePattern.map(d=>p.NotebookExclusiveDocumentPattern.from(d)).filter(d=>d!==void 0);if(I.filenamePattern&&!k){console.warn(`Notebook content provider view options file name pattern is invalid ${I.filenamePattern}`);return}return{extension:m.identifier,providerDisplayName:m.displayName||m.name,displayName:I.displayName,filenamePattern:k,exclusive:I.exclusive||!1}}registerNotebookCellStatusBarItemProvider(m,I,k){const d=h.a++,b=typeof k.onDidChangeCellStatusBarItems=="function"?h.a++:void 0;this.f.set(d,k),this.b.$registerNotebookCellStatusBarItemProvider(d,b,I);let y;return b!==void 0&&(y=k.onDidChangeCellStatusBarItems(C=>this.b.$emitCellStatusBarEvent(b))),new f.$xK(()=>{this.f.delete(d),this.b.$unregisterNotebookCellStatusBarItemProvider(d,b),y?.dispose()})}async createNotebookDocument(m){const I=await this.c.$tryCreateNotebook({viewType:m.viewType,content:m.content&&p.NotebookData.from(m.content)});return g.URI.revive(I)}async openNotebookDocument(m){const I=this.g.get(m);if(I)return I.apiNotebook;const k=await this.c.$tryOpenNotebook(m),d=this.g.get(g.URI.revive(k));return(0,D.$Kf)(d?.apiNotebook)}async showNotebookDocument(m,I){g.URI.isUri(m)&&(m=await this.openNotebookDocument(m));let k;typeof I=="object"?k={position:p.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selections:I.selections&&I.selections.map(p.NotebookRange.from),pinned:typeof I.preview=="boolean"?!I.preview:void 0}:k={preserveFocus:!1};const d=await this.d.$tryShowNotebookDocument(m.uri,m.notebookType,k),b=d&&this.h.get(d)?.apiEditor;if(b)return b;throw d?new Error(`Could NOT open editor for "${m.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${m.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(m,I,k,d){const b=this.f.get(m),y=g.URI.revive(I),C=this.g.get(y);if(!C||!b)return;const B=C.getCellFromIndex(k);if(!B)return;const H=await b.provideCellStatusBarItems(B.apiCell,d);if(!H)return;const U=new M.$Qc,z=this.p.add([U]),N=(Array.isArray(H)?H:[H]).map(x=>p.NotebookStatusBarItem.from(x,this.i,U));return{cacheId:z,items:N}}$releaseNotebookCellStatusBarItems(m){this.p.delete(m)}registerNotebookSerializer(m,I,k,d,b){if((0,$.$Ce)(I))throw new Error("viewType cannot be empty or just whitespace");const y=this.w++;return this.x.set(y,{viewType:I,serializer:k,options:d}),this.b.$registerNotebookSerializer(y,{id:m.identifier,location:m.extensionLocation},I,p.NotebookDocumentContentOptions.from(d),h.u(m,b)),(0,M.$Pc)(()=>{this.b.$unregisterNotebookSerializer(y)})}async $dataToNotebook(m,I,k){const d=this.x.get(m);if(!d)throw new Error("NO serializer found");const b=await d.serializer.deserializeNotebook(I.buffer,k);return new t.$uv(p.NotebookData.from(b))}async $notebookToData(m,I,k){const d=this.x.get(m);if(!d)throw new Error("NO serializer found");const b=await d.serializer.serializeNotebook(p.NotebookData.to(I.value),k);return L.$ce.wrap(b)}async $saveNotebook(m,I,k,d,b){const y=g.URI.revive(I),C=this.x.get(m);if(!C)throw new Error("NO serializer found");const B=this.g.get(y);if(!B)throw new Error("Document NOT found");if(B.versionId!==k)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(y.scheme))throw new A.$xk((0,E.localize)(0,null,this.z(y)),6);await this.y(y,d);const H={metadata:(0,a.$gn)(B.apiNotebook.metadata,x=>!(C.options?.transientDocumentMetadata??{})[x]),cells:[]};for(const x of B.apiNotebook.getCells()){const J=new f.$VL(x.kind,x.document.getText(),x.document.languageId,x.mime,C.options?.transientOutputs?[]:[...x.outputs],x.metadata,x.executionSummary);J.metadata=(0,a.$gn)(x.metadata,ye=>!(C.options?.transientCellMetadata??{})[ye]),H.cells.push(J)}const U=await C.serializer.serializeNotebook(H,b);await this.s.value.writeFile(y,U);const z=this.s.getFileSystemProviderExtUri(y.scheme),F=await this.s.value.stat(y);return{name:z.basename(y),isFile:(F.type&A.FileType.File)!==0,isDirectory:(F.type&A.FileType.Directory)!==0,isSymbolicLink:(F.type&A.FileType.SymbolicLink)!==0,mtime:F.mtime,ctime:F.ctime,size:F.size,readonly:!!((F.permissions??0)&A.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(y.scheme),locked:!!((F.permissions??0)&A.FilePermission.Locked),etag:A.$Ik({mtime:F.mtime,size:F.size}),children:void 0}}async $searchInNotebooks(m,I,k,d,b){const y=this.x.get(m)?.serializer;if(!y)return{limitHit:!1,results:[]};const C=new R.$Ac;await(async(F,N,x)=>{await Promise.all(F.map(async J=>await Promise.all(J.filenamePatterns.map(ye=>{const De={...x,type:1,filePattern:ye};return this.t.doInternalFileSearchWithCustomCallback(De,N,Ce=>{Ce.forEach(ge=>{C.has(ge)||d.some(re=>J.isFromSettings&&!re.isFromSettings?!1:re.filenamePatterns.some(oe=>(0,c.$rcb)(oe,ge)))||C.add(ge)})})}))))})(k,b,I);const H=new R.$zc;let U=!1;const z=Array.from(C).map(async F=>{const N=[];try{if(b.isCancellationRequested)return;if(I.maxResults&&[...H.values()].reduce((De,Ce)=>De+Ce.cellResults.length,0)>I.maxResults){U=!0;return}const x=[],J=this.g.get(F);if(J)J.apiNotebook.getCells().forEach(Ce=>x.push({input:Ce.document.getText(),outputs:Ce.outputs.flatMap(ge=>ge.items.map(we=>we.data.toString()))}));else{const De=await this.s.value.readFile(F),Ce=L.$ce.fromString(De.toString()),ge=await y.deserializeNotebook(Ce.buffer,b);if(b.isCancellationRequested)return;p.NotebookData.from(ge).cells.forEach(re=>x.push({input:re.source,outputs:re.outputs.flatMap(oe=>oe.items.map(ve=>ve.valueBytes.toString()))}))}if(b.isCancellationRequested)return;x.forEach((De,Ce)=>{const ge=I.contentPattern.pattern,we=new r.$yOb(De.input,void 0,De.outputs),re=we.findInInputs(ge),oe=we.findInOutputs(ge),ve=oe.flatMap(ee=>(0,s.$tK)(ee.matches,ee.textBuffer)).map((ee,W)=>(ee.webviewIndex=W,ee));if(re.length>0||oe.length>0){const ee={index:Ce,contentResults:(0,s.$tK)(re,we.inputTextBuffer),webviewResults:ve};N.push(ee)}});const ye={resource:F,cellResults:N};H.set(F,ye);return}catch{return}});return await Promise.all(z),{limitHit:U,results:[...H.values()]}}async y(m,I){const k=await this.s.value.stat(m);if(typeof I?.mtime=="number"&&typeof I.etag=="string"&&I.etag!==A.$Hk&&typeof k.mtime=="number"&&typeof k.size=="number"&&I.mtime<k.mtime&&I.etag!==A.$Ik({mtime:I.mtime,size:k.size}))throw new A.$xk((0,E.localize)(1,null),3,I)}z(m){return m.scheme===l.Schemas.file?m.fsPath:m.toString()}A(m,I,k){if(this.h.has(I))throw new Error(`editor with id ALREADY EXSIST: ${I}`);const d=new n.$yec(I,this.d,m,k.visibleRanges.map(p.NotebookRange.to),k.selections.map(p.NotebookRange.to),typeof k.viewColumn=="number"?p.ViewColumn.to(k.viewColumn):void 0);this.h.set(I,d)}$acceptDocumentAndEditorsDelta(m){if(m.value.removedDocuments)for(const k of m.value.removedDocuments){const d=g.URI.revive(k),b=this.g.get(d);b&&(b.dispose(),this.g.delete(d),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:b.apiNotebook.getCells().map(y=>y.document.uri)}),this.n.fire(b.apiNotebook));for(const y of this.h.values())y.notebookData.uri.toString()===d.toString()&&this.h.delete(y.id)}if(m.value.addedDocuments){const k=[];for(const d of m.value.addedDocuments){const b=g.URI.revive(d.uri);if(this.g.has(b))throw new Error(`adding EXISTING notebook ${b} `);const y=new i.$xec(this.c,this.q,this.r,b,d);k.push(...d.cells.map(C=>i.$wec.asModelAddData(y.apiNotebook,C))),this.g.get(b)?.dispose(),this.g.set(b,y),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:k}),this.m.fire(y.apiNotebook)}}if(m.value.addedEditors)for(const k of m.value.addedEditors){if(this.h.has(k.id))return;const d=g.URI.revive(k.documentUri),b=this.g.get(d);b&&this.A(b,k.id,k)}const I=[];if(m.value.removedEditors)for(const k of m.value.removedEditors){const d=this.h.get(k);d&&(this.h.delete(k),this.k?.id===d.id&&(this.k=void 0),I.push(d))}if(m.value.visibleEditors){this.l=m.value.visibleEditors.map(d=>this.h.get(d)).filter(d=>!!d);const k=new Set;this.l.forEach(d=>k.add(d.id));for(const d of this.h.values()){const b=k.has(d.id);d._acceptVisibility(b)}this.l=[...this.h.values()].map(d=>d).filter(d=>d.visible),this.o.fire(this.visibleNotebookEditors)}m.value.newActiveEditor===null?this.k=void 0:m.value.newActiveEditor&&(this.h.get(m.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${m.value.newActiveEditor}`),this.k=this.h.get(m.value.newActiveEditor)),m.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(m){const I=v.$VM.String.with("notebookType","A notebook type"),k=new v.$XM("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[I,new v.$VM("data","Bytes to convert to data",b=>b instanceof Uint8Array,b=>L.$ce.wrap(b))],new v.$WM("Notebook Data",b=>p.NotebookData.to(b.value))),d=new v.$XM("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[I,new v.$VM("NotebookData","Notebook data to convert to bytes",b=>!0,b=>new t.$uv(p.NotebookData.from(b)))],new v.$WM("Bytes",b=>b.buffer));m.registerApiCommand(k),m.registerApiCommand(d)}}e.$zec=h}),define(Ae[286],Re([1,0,19,20,39,33,25,50,43]),function(pe,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oec=void 0;class g{constructor(o,v,p){this.k=o,this.l=v,this.o=p,this.e=!1,this.f=0,this.g=!1,this.a=o.filePattern,this.b=o.includePattern&&M.$Aj(o.includePattern),this.c=o.maxResults||void 0,this.d=o.exists,this.h=new Set,this.j=o.excludePattern&&M.$Aj(o.excludePattern)}cancel(){this.g=!0,this.h.forEach(o=>o.cancel()),this.h=new Set}search(o){const v=this.k.folderQueries||[];return new Promise((p,f)=>{const t=i=>{this.f++,o(i)};if(this.g)return p({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(i=>{const n=i.toString(),u=E.$mc(n);this.j&&this.j(n,u)||this.v(t,{base:i,basename:u})}),Promise.all(v.map(i=>this.p(i,t))).then(i=>{p({limitHit:this.e,stats:i[0]||void 0})},i=>{f(new Error((0,P.$Ei)(i)))})})}async p(o,v){const p=new L.$Yd,f=this.q(o),t=this.r(),i=new D.$aJ(this.k,o),n=!i.hasSiblingExcludeClauses();let u;try{this.h.add(p),u=$.$Kd.create();const a=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},f,p.token),l=u.elapsed(),r=$.$Kd.create();return this.g&&!this.e||(a&&a.forEach(s=>{const c=E.$fc.relative(o.folder.path,s.path);if(n){const h=E.$mc(s.path);this.v(v,{base:o.folder,relativePath:c,basename:h});return}this.s(t,o.folder,c,v)}),this.g&&!this.e)?null:(this.u(t,i,v),{providerTime:l,postProcessTime:r.elapsed()})}finally{p.dispose(),this.h.delete(p)}}q(o){const v=(0,D.$_I)(this.k.includePattern,o.includePattern),p=(0,D.$_I)(this.k.excludePattern,o.excludePattern);return{folder:o.folder,excludes:p,includes:v,useIgnoreFiles:!o.disregardIgnoreFiles,useGlobalIgnoreFiles:!o.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!o.disregardParentIgnoreFiles,followSymlinks:!o.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const o={rootEntries:[],pathToEntries:Object.create(null)};return o.pathToEntries["."]=o.rootEntries,o}s({pathToEntries:o},v,p,f){if(p===this.a){const i=E.$mc(this.a);this.v(f,{base:v,relativePath:this.a,basename:i})}function t(i){const n=E.$mc(i),u=E.$lc(i);let a=o[u];a||(a=o[u]=[],t(u)),a.push({base:v,relativePath:i,basename:n})}t(p)}u({rootEntries:o,pathToEntries:v},p,f){const t=this,i=this.a;function n(u){const a=(0,D.$cJ)(()=>u.map(l=>l.basename));for(let l=0,r=u.length;l<r;l++){const s=u[l],{relativePath:c,basename:h}=s;if(p.matchesExcludesSync(c,h,i!==h?a:void 0))continue;const w=v[c];if(w)n(w);else{if(c===i)continue;t.v(f,s)}if(t.e)break}}n(o)}v(o,v){(!this.b||v.relativePath&&this.b(v.relativePath,v.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||o(v))}}class A{constructor(){this.b=new Map}static{this.a=512}fileSearch(o,v,p,f){const t=this.c(o.cacheKey),i=new g(o,v,t&&t.token);let n=0;const u=a=>{n+=a.length,p(a.map(l=>this.d(l)))};return this.e(i,A.a,u,f).then(a=>({limitHit:a.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:a.stats}}))}clearCache(o){this.c(o)?.cancel()}c(o){if(o)return this.b.has(o)||this.b.set(o,new L.$Yd),this.b.get(o)}d(o){return o.relativePath?{resource:R.$wg(o.base,o.relativePath)}:{resource:o.base}}e(o,v,p,f){const t=f.onCancellationRequested(()=>{o.cancel()}),i=u=>{u&&(n.push(u),v>0&&n.length>=v&&(p(n),n=[]))};let n=[];return o.search(i).then(u=>(n.length&&p(n),t.dispose(),u),u=>(n.length&&p(n),t.dispose(),Promise.reject(u)))}}e.$oec=A}),define(Ae[287],Re([1,0,18,248,33,94,28,14,19,25,13,16,2,93,181,40,15,47,105,283,43]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f,t,i,n,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0J=e.$9J=void 0;let l=class{constructor(b,y,C,B,H){this.a=b,this.b=y,this.c=C,this.d=B,this.e=H}text(b,y,C={}){b=this.f(b,C);const B=this.a.getValue(),H=y&&y.some(z=>!this.a.getValue({resource:z}).search.useRipgrep);return{...this.h(y?.map(i.$ci),C),type:2,contentPattern:b,previewOptions:C.previewOptions,maxFileSize:C.maxFileSize,usePCRE2:B.search.usePCRE2||H||!1,beforeContext:C.beforeContext,afterContext:C.afterContext,userDisabledExcludesAndIgnoreFiles:C.disregardExcludeSettings&&C.disregardIgnoreFiles}}f(b,y){const C=this.a.getValue();b.isRegExp&&(b.pattern=b.pattern.replace(/\r?\n/g,"\\n"));const B={...b,wordSeparators:C.editor.wordSeparators};return this.j(b,y)&&(B.isCaseSensitive=!0),this.k(b)&&(B.isMultiline=!0),y.notebookSearchConfig?.includeMarkupInput&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookMarkdownInput=y.notebookSearchConfig.includeMarkupInput),y.notebookSearchConfig?.includeMarkupPreview&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookMarkdownPreview=y.notebookSearchConfig.includeMarkupPreview),y.notebookSearchConfig?.includeCodeInput&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookCellInput=y.notebookSearchConfig.includeCodeInput),y.notebookSearchConfig?.includeOutput&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookCellOutput=y.notebookSearchConfig.includeOutput),B}file(b,y={}){return{...this.h(b,y),type:1,filePattern:y.filePattern?y.filePattern.trim():y.filePattern,exists:y.exists,sortByScore:y.sortByScore,cacheKey:y.cacheKey}}g(b,y){return b?(b=Array.isArray(b)?b.map(w):w(b),y?this.parseSearchPaths(b):{pattern:s(...Array.isArray(b)?b:[b])}):{}}h(b=[],y={}){const C=this.g(y.includePattern,y.expandPatterns),B=this.g(y.excludePattern,y.expandPatterns),H=b.length>1,U=(C.searchPaths&&C.searchPaths.length?C.searchPaths.map(N=>this.q(N,y,B)):b.map(N=>this.r(N,y,B,H))).filter(N=>!!N),z={_reason:y._reason,folderQueries:U,usingSearchPaths:!!(C.searchPaths&&C.searchPaths.length),extraFileResources:y.extraFileResources,excludePattern:B.pattern,includePattern:C.pattern,onlyOpenEditors:y.onlyOpenEditors,maxResults:y.maxResults};if(y.onlyOpenEditors){const N=E.$Gb(E.$Qb(this.c.groups.map(ye=>ye.editors.map(De=>De.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(N));const x=N.filter(ye=>(0,a.$3I)(z,ye.fsPath)),J=this.i(x);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(J)),{...z,...J}}const F=y.extraFileResources&&y.extraFileResources.filter(N=>(0,a.$3I)(z,N.fsPath));return z.extraFileResources=F&&F.length?F:void 0,z}i(b){const y=[],C=new R.$zc,B={};let H=!1;return b.forEach(U=>{if(U.scheme===$.Schemas.walkThrough)return;if((0,g.$Ag)(U)){const F=this.b.getWorkspaceFolder(U)?.uri??U.with({path:D.$lc(U.fsPath)});let N=C.get(F);N||(H=!0,N={folder:F,includePattern:{}},y.push(N),C.set(F,N));const x=D.$kc(F.fsPath,U.fsPath);(0,S.$Kf)(N.includePattern)[x.replace(/\\/g,"/")]=!0}else U.fsPath&&(H=!0,B[U.fsPath]=!0)}),{folderQueries:y,includePattern:B,usingSearchPaths:!0,excludePattern:H?void 0:{"**/*":!0}}}j(b,y){if(y.isSmartCase){if(b.isRegExp){if(A.$qf(b.pattern,!0))return!0}else if(A.$qf(b.pattern))return!0}return!!b.isCaseSensitive}k(b){return b.isMultiline||b.isRegExp&&(0,v.$zB)(b.pattern)||b.pattern.indexOf(`
`)>=0?!0:!!b.isMultiline}parseSearchPaths(b){const y=J=>D.$hc(J)||/^\.\.?([\/\\]|$)/.test(J),B=(Array.isArray(b)?b:c(b)).map(J=>{const ye=this.e.resolvedUserHome;return ye?(0,M.$yv)(J,ye.scheme===$.Schemas.file?ye.fsPath:ye.path):J}),H=L.$J(B,J=>y(J)?"searchPaths":"exprSegments"),U=(H.exprSegments||[]).map(J=>A.$Le(J,"/")).map(J=>A.$Le(J,"\\")).map(J=>(J[0]==="."&&(J="*"+J),h(J))),z={},F=this.m(H.searchPaths||[]);F&&F.length&&(z.searchPaths=F);const N=E.$Qb(U),x=s(...N);return x&&(z.pattern=x),z}l(b,y){return y.disregardExcludeSettings?void 0:(0,a.$2I)(b,!y.disregardSearchExcludeSettings)}m(b){if(!b||!b.length)return[];const y=b.flatMap(B=>{let{pathPortion:H,globPortion:U}=r(B);return U&&(U=m(U)),this.n(H).flatMap(F=>this.o(F,U))}),C=new Map;return y.forEach(B=>{const H=B.searchPath.toString(),U=C.get(H);U?B.pattern&&(U.pattern=U.pattern||{},U.pattern[B.pattern]=!0):C.set(H,{searchPath:B.searchPath,pattern:B.pattern?s(B.pattern):void 0})}),Array.from(C.values())}n(b){if(D.$hc(b)){const y=this.b.getWorkspace().folders;return y[0]&&y[0].uri.scheme!==$.Schemas.file?[{searchPath:y[0].uri.with({path:b})}]:[{searchPath:o.URI.file(D.$gc(b))}]}if(this.b.getWorkbenchState()===2){const y=this.b.getWorkspace().folders[0].uri;if(b=w(b),b.startsWith("../")||b===".."){const B=D.$fc.resolve(y.path,b);return[{searchPath:y.with({path:B})}]}const C=m(b);return[{searchPath:y,pattern:C}]}else{if(b==="./"||b===".\\")return[];{const y=b.replace(/^\.[\/\\]/,""),B=this.b.getWorkspace().folders.map(H=>{const U=y.match(new RegExp(`^${A.$Ge(H.name)}(?:/(.*)|$)`));return U?{match:U,folder:H}:null}).filter(S.$Hf);if(B.length)return B.map(H=>{const U=H.match[1];return{searchPath:H.folder.uri,pattern:U&&m(U)}});{const H=b.match(/\.[\/\\](.+)[\/\\]?/),U=H?H[1]:b,z=p.localize(0,null,U);throw new Error(z)}}}}o(b,y){const C=b.pattern&&y?`${b.pattern}/${y}`:b.pattern||y,B=[{searchPath:b.searchPath,pattern:C}];return C&&!C.endsWith("**")&&B.push({searchPath:b.searchPath,pattern:C+"/**"}),B}q(b,y,C){const B=this.r((0,i.$ci)(b.searchPath),y,C,!1);return B?{...B,includePattern:b.pattern}:null}r(b,y,C,B){let H;const U=o.URI.isUri(b)?b:b.uri;if(C.searchPaths){const J=C.searchPaths.filter(ye=>(0,g.$pg)(ye.searchPath,U))[0];if(J&&!J.pattern)return null;J&&(H=J.pattern)}const z=this.a.getValue({resource:U}),N={...this.l(z,y)||{},...H||{}},x=o.URI.isUri(b)?(0,g.$tg)(b):b.name;return{folder:U,folderName:B?x:void 0,excludePattern:Object.keys(N).length>0?N:void 0,fileEncoding:z.files&&z.files.encoding,disregardIgnoreFiles:typeof y.disregardIgnoreFiles=="boolean"?y.disregardIgnoreFiles:!z.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof y.disregardGlobalIgnoreFiles=="boolean"?y.disregardGlobalIgnoreFiles:!z.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof y.disregardParentIgnoreFiles=="boolean"?y.disregardParentIgnoreFiles:!z.search.useParentIgnoreFiles,ignoreSymlinks:typeof y.ignoreSymlinks=="boolean"?y.ignoreSymlinks:!z.search.followSymlinks}}};e.$9J=l,e.$9J=l=Ke([Ve(0,f.$ni),Ve(1,i.$3h),Ve(2,n.$DC),Ve(3,t.$bj),Ve(4,u.$7J)],l);function r(d){const b=d.match(/[\*\{\}\(\)\[\]\?]/);if(b){const y=b.index,C=d.substr(0,y).match(/[/|\\][^/\\]*$/);if(C){let B=d.substr(0,C.index);return B.match(/[/\\]/)||(B+="/"),{pathPortion:B,globPortion:d.substr((C.index||0)+1)}}}return{pathPortion:d}}function s(...d){return d.length?d.reduce((b,y)=>(b[y]=!0,b),Object.create(null)):void 0}function c(d){return P.$yj(d,",").map(b=>b.trim()).filter(b=>!!b.length)}function h(d){return[`**/${d}/**`,`**/${d}`].map(y=>y.replace(/\*\*\/\*\*/g,"**"))}function w(d){return d.replace(/\\/g,"/")}function m(d){return w(d).replace(/^\.\//,"").replace(/\/+$/g,"")}function I(d){return d.replace(/([?*[\]])/g,"[$1]")}function k(d,b){d=E.$Lb(d,B=>B.toString());const y=[],C=b.getWorkspace();return d&&d.forEach(B=>{let H;if(b.getWorkbenchState()===2)H=(0,g.$yg)(C.folders[0].uri,B),H&&H!=="."&&(H="./"+H);else{const U=b.getWorkspaceFolder(B);if(U){const z=U.name;if(C.folders.filter(N=>N.name===z).length===1){const N=(0,g.$yg)(U.uri,B);N===""?H=`./${U.name}`:H=`./${U.name}/${N}`}else H=B.fsPath}}H&&y.push(I(H))}),y}e.$0J=k}),define(Ae[288],Re([1,0,25,2,20,11,4,287,43,47]),function(pe,e,E,L,P,M,R,$,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xqb=e.$Wqb=void 0;const A=7e3;function S(f,t){const i=t.activationEvents;if(!i)return Promise.resolve(void 0);const n=[],u=[];for(const h of i)if(/^workspaceContains:/.test(h)){const w=h.substr(18);w.indexOf("*")>=0||w.indexOf("?")>=0||f.forceUsingSearch?u.push(w):n.push(w)}if(n.length===0&&u.length===0)return Promise.resolve(void 0);let a;const l=new Promise((h,w)=>{a=h}),r=h=>a({activationEvent:h}),s=Promise.all(n.map(h=>o(f,h,r))).then(()=>{}),c=v(f,t.identifier,u,r);return Promise.all([s,c]).then(()=>{a(void 0)}),l}e.$Wqb=S;async function o(f,t,i){for(const n of f.folders)if(await f.exists(E.$wg(L.URI.revive(n),t))){i(`workspaceContains:${t}`);return}}async function v(f,t,i,n){if(i.length===0)return Promise.resolve(void 0);const u=new P.$Yd,a=f.checkExists(f.folders,i,u.token),l=setTimeout(async()=>{u.cancel(),f.logService.info(`Not activating extension '${t.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},A);let r=!1;try{r=await a}catch(s){M.$3(s)||M.$Z(s)}u.dispose(),clearTimeout(l),r&&n(`workspaceContains:${i.join(",")}`)}function p(f,t,i,n){const u=f.get(R.$Sh),a=f.get(D.$TI),r=u.createInstance($.$9J).file(t.map(s=>(0,g.$ci)(L.URI.revive(s))),{_reason:"checkExists",includePattern:i,exists:!0});return a.fileSearch(r,n).then(s=>!!s.limitHit,s=>M.$3(s)?!1:Promise.reject(s))}e.$Xqb=p}),define(Ae[37],Re([1,0,160,19,88,25,12,6,51,2,15,3,36,219,85,35,23,106,11,22,24,202,7,100,4,27,86,17,72,87,65,5,288,84,204,14,82,50,21,83]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f,t,i,n,u,a,l,r,s,c,h,w,m,I,k,d,b,y,C,B,H,U,z,F,N){"use strict";var x;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ndc=e.$Mdc=e.$Ldc=e.$Kdc=e.$Jdc=void 0,e.$Jdc=(0,c.$Th)("IHostUtils");let J=x=class extends $.$Rc{constructor(ee,W,ue,Pe,Ee,te,se,me,Z,le,ne,ae){super(),this.X=ae,this.a=this.B(new b.$Od),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=W,this.g=ue,this.f=se,this.j=Pe,this.m=Ee,this.s=te,this.t=Z,this.u=le,this.w=ne,this.y=this.g.getProxy(S.$vK.MainThreadWorkspace),this.z=this.g.getProxy(S.$vK.MainThreadTelemetry),this.C=this.g.getProxy(S.$vK.MainThreadExtensionService),this.D=new R.$Tg,this.F=new R.$Tg,this.G=new R.$Tg,this.H=new R.$Tg,this.I=new oe(this.f.extensions.activationEvents),this.L=new i.$e5b(this.I,this.f.extensions.allExtensions);const de=new u.$$l(this.f.extensions.myExtensions);this.J=new i.$e5b(this.I,we(this.L,de)),F.$t&&(this.s.info(`Creating extension host with the following global extensions: ${Ce(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Ce(this.J)}`)),this.M=new p.$qdc(this.g,this.s),this.N=new C.$Cdc(this.g),this.O=me,this.h=ee.createChild(new I.$Rh([p.$rdc,this.M],[C.$Ddc,this.N])),this.P=this.B(new v.$pdc(this.J,this.L,{onExtensionActivationError:(Ie,T,V)=>{this.C.$onExtensionActivationError(Ie,n.$2(T),V)},actualActivateExtension:async(Ie,T)=>{if(i.$e5b.isHostExtension(Ie,this.J,this.L))return await this.C.$activateExtension(Ie,T),new v.$odc;const V=this.J.getExtensionDescription(Ie);return this.db(V,T)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),P.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(ee){n.$Z(ee)}}async Y(){this.O.onWillDeactivateAll();let ee=[];try{ee=this.J.getAllExtensionDescriptions().map(Ee=>Ee.identifier).filter(Ee=>this.isActivated(Ee)).map(Ee=>this.cb(Ee))}catch{}await Promise.all(ee)}terminate(ee,W=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${ee}`),this.s.flush(),this.u.dispose(),this.P.dispose(),n.setUnexpectedErrorHandler(Pe=>{this.s.error(Pe)}),this.g.dispose();const ue=this.Y();Promise.race([(0,R.$Vg)(5e3),ue]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${W}`):this.s.info(`Extension host exiting with code ${W}`),this.s.flush(),this.s.dispose(),this.c.exit(W)})}isActivated(ee){return this.G.isOpen()?this.P.isActivated(ee):!1}async getExtension(ee){const W=await this.C.$getExtension(ee);return W&&{...W,identifier:new u.$0l(W.identifier.value),extensionLocation:g.URI.revive(W.extensionLocation)}}Z(ee,W){return this.P.activateByEvent(ee,W)}$(ee,W){return this.P.activateById(ee,W)}activateByIdWithErrors(ee,W){return this.$(ee,W).then(()=>{const ue=this.P.getActivatedExtension(ee);if(ue.activationFailed)return Promise.reject(ue.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(ee=>this.J)}getExtensionExports(ee){if(this.G.isOpen())return this.P.getActivatedExtension(ee).exports;try{return this.P.getActivatedExtension(ee).exports}catch{return null}}async ab(ee){if(ee.scheme===H.Schemas.file&&this.c.fsRealpath){const W=await this.c.fsRealpath(ee.fsPath);return g.URI.file(W)}return ee}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(ee=>new re(ee))),this.Q}async bb(ee){const W=D.$Zh.forUris(ue=>M.$ng.ignorePathCasing(ue));return await Promise.all(ee.map(async ue=>{if(this.ub(ue)){const Pe=await this.ab(ue.extensionLocation);W.set(Pe,ue)}})),W}cb(ee){let W=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(ee))return W;const ue=this.P.getActivatedExtension(ee);if(!ue)return W;try{typeof ue.module.deactivate=="function"&&(W=Promise.resolve(ue.module.deactivate()).then(void 0,Pe=>(this.s.error(Pe),Promise.resolve(void 0))))}catch(Pe){this.s.error(`An error occurred when deactivating the extension '${ee.value}':`),this.s.error(Pe)}try{(0,$.$Mc)(ue.subscriptions)}catch(Pe){this.s.error(`An error occurred when deactivating the subscriptions for extension '${ee.value}':`),this.s.error(Pe)}return W}async db(ee,W){return this.f.remote.isRemote?this.C.$onWillActivateExtension(ee.identifier):await this.C.$onWillActivateExtension(ee.identifier),this.fb(ee,W).then(ue=>{const Pe=ue.activationTimes;return this.C.$onDidActivateExtension(ee.identifier,Pe.codeLoadingTime,Pe.activateCallTime,Pe.activateResolvedTime,W),this.eb(ee,W,"success",Pe),ue},ue=>{throw this.eb(ee,W,"failure"),ue})}eb(ee,W,ue,Pe){const Ee=De(ee,W);this.z.$publicLog2("extensionActivationTimes",{...Ee,...Pe||{},outcome:ue})}fb(ee,W){const ue=De(ee,W);this.z.$publicLog2("activatePlugin",ue);const Pe=this.ub(ee);if(!Pe)return Promise.resolve(new v.$ndc(v.$kdc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${ee.identifier.value}, startup: ${W.startup}, activationEvent: '${W.activationEvent}'${ee.identifier.value!==W.extensionId.value?`, root cause: ${W.extensionId.value}`:""}`),this.s.flush();const Ee=new v.$ldc(W.startup);return Promise.all([this.vb(ee,(0,M.$wg)(ee.extensionLocation,Pe),Ee),this.gb(ee)]).then(te=>(P.mark(`code/extHost/willActivateExtension/${ee.identifier.value}`),x.hb(this.s,ee.identifier,te[0],te[1],Ee))).then(te=>(P.mark(`code/extHost/didActivateExtension/${ee.identifier.value}`),te))}gb(ee){const W=new l.$tdc(ee,this.M),ue=new l.$sdc(ee.identifier.value,!1,this.M),Pe=new B.$Edc(ee,this.N),Ee=ee.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?r.ExtensionMode.Test:r.ExtensionMode.Development:r.ExtensionMode.Production,te=this.f.remote.isRemote?r.ExtensionKind.Workspace:r.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${ee.identifier.value}`),Promise.all([W.whenReady,ue.whenReady,this.O.whenReady]).then(()=>{const se=this;let me,Z;const le=(0,t.$uF)(ee,"ipc")?this.f.messagePorts?.get(u.$0l.toKey(ee.identifier)):void 0;return Object.freeze({globalState:W,workspaceState:ue,secrets:Pe,subscriptions:[],get extensionUri(){return ee.extensionLocation},get extensionPath(){return ee.extensionLocation.fsPath},asAbsolutePath(ne){return L.$ic(ee.extensionLocation.fsPath,ne)},get storagePath(){return se.O.workspaceValue(ee)?.fsPath},get globalStoragePath(){return se.O.globalValue(ee).fsPath},get logPath(){return L.$ic(se.f.logsLocation.fsPath,ee.identifier.value)},get logUri(){return g.URI.joinPath(se.f.logsLocation,ee.identifier.value)},get storageUri(){return se.O.workspaceValue(ee)},get globalStorageUri(){return se.O.globalValue(ee)},get extensionMode(){return Ee},get extension(){return me===void 0&&(me=new ge(se,ee.identifier,ee,te,!1)),me},get extensionRuntime(){return(0,t.$vF)(ee,"extensionRuntime"),se.extensionRuntime},get environmentVariableCollection(){return se.u.getEnvironmentVariableCollection(ee)},get messagePassingProtocol(){if(!Z){if(!le)return;const ne=b.Event.buffer(b.Event.fromDOMEventEmitter(le,"message",ae=>ae.data));le.start(),Z={onDidReceiveMessage:ne,postMessage:le.postMessage.bind(le)}}return Z}})})}static hb(ee,W,ue,Pe,Ee){return ue=ue||{activate:void 0,deactivate:void 0},this.ib(ee,W,ue,Pe,Ee).then(te=>new v.$mdc(!1,null,Ee.build(),ue,te,Pe.subscriptions))}static ib(ee,W,ue,Pe,Ee){if(typeof ue.activate=="function")try{Ee.activateCallStart(),ee.trace(`ExtensionService#_callActivateOptional ${W.value}`);const te=typeof global=="object"?global:self,se=ue.activate.apply(te,[Pe]);return Ee.activateCallStop(),Ee.activateResolveStart(),Promise.resolve(se).then(me=>(Ee.activateResolveStop(),me))}catch(te){return Promise.reject(te)}else return Promise.resolve(ue)}jb(ee,W){this.$(ee.identifier,{startup:!1,extensionId:ee.identifier,activationEvent:W}).then(void 0,ue=>{this.s.error(ue)})}kb(ee,W=0){const Pe=Date.now();(0,F.$B)(()=>{for(let Ee=W;Ee<ee.length;Ee+=1){const te=ee[Ee];for(const se of te.activationEvents??[])if(se==="onStartupFinished")if(Date.now()-Pe>50){this.kb(ee,Ee);break}else this.jb(te,se)}})}lb(){this.C.$setPerformanceMarks(P.getMarks()),this.m.getConfigProvider().then(ee=>{const W=ee.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ue=this.J.getAllExtensionDescriptions();if(W)this.kb(ue);else for(const Pe of ue)if(Pe.activationEvents)for(const Ee of Pe.activationEvents)Ee==="onStartupFinished"&&this.jb(Pe,Ee)})}mb(){const ee=this.Z("*",!0).then(void 0,te=>{this.s.error(te)});this.B(this.j.onDidChangeWorkspace(te=>this.nb(te.added)));const W=this.j.workspace?this.j.workspace.folders:[],ue=this.nb(W),Pe=this.pb(),Ee=Promise.all([Pe,ee,ue]).then(()=>{});return Promise.race([Ee,(0,R.$Vg)(1e4)]).then(()=>{this.lb()}),Ee}nb(ee){return ee.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(W=>this.ob(ee,W))).then(()=>{})}async ob(ee,W){if(this.isActivated(W.identifier))return;const ue=!this.f.remote.isRemote&&!!this.f.remote.authority,Pe={logService:this.s,folders:ee.map(te=>te.uri),forceUsingSearch:ue||!this.c.fsExists,exists:te=>this.c.fsExists(te.fsPath),checkExists:(te,se,me)=>this.y.$checkExists(te,se,me)},Ee=await(0,y.$Wqb)(Pe,W);if(Ee)return this.$(W.identifier,{startup:!0,extensionId:W.identifier,activationEvent:Ee.activationEvent}).then(void 0,te=>this.s.error(te))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(ee){throw console.error(ee),ee}}async qb(){const{extensionDevelopmentLocationURI:ee,extensionTestsLocationURI:W}=this.f.environment;if(!ee||!W)throw new Error(E.localize(0,null));const ue=await this.vb(null,W,new v.$ldc(!1));if(!ue||typeof ue.run!="function")throw new Error(E.localize(1,null,W.toString()));return new Promise((Pe,Ee)=>{const te=(Z,le)=>{Z?(F.$t&&this.s.error("Test runner called back with error",Z),Ee(Z)):(F.$t&&(le?this.s.info(`Test runner called back with ${le} failures.`):this.s.info("Test runner called back with successful outcome.")),Pe(typeof le=="number"&&le>0?1:0))},se=(0,M.$kg)(W),me=ue.run(se,te);me&&me.then&&me.then(()=>{F.$t&&this.s.info("Test runner finished successfully."),Pe(0)}).catch(Z=>{F.$t&&this.s.error("Test runner finished with error",Z),Ee(Z instanceof Error&&Z.stack?Z.stack:String(Z))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$Vg)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(ee,W){return this.R[ee]=W,(0,$.$Pc)(()=>{delete this.R[ee]})}async getRemoteExecServer(ee){const{resolver:W}=await this.sb(ee);return W?.resolveExecServer?.(ee,{resolveAttempt:0})}async sb(ee){const W=ee.indexOf("+");if(W===-1)throw new r.$DK("Not an authority that can be resolved!",s.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ue=ee.substr(0,W);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${ue}`,!1),{authorityPrefix:ue,resolver:this.R[ue]}}async $resolveAuthority(ee,W){const ue=z.$Kd.create(!1),Pe=()=>`[resolveAuthority(${(0,s.$Xk)(ee)},${W})][${ue.elapsed()}ms] `,Ee=Q=>this.s.info(`${Pe()}${Q}`),te=Q=>this.s.warn(`${Pe()}${Q}`),se=(Q,q=void 0)=>this.s.error(`${Pe()}${Q}`,q),me=Q=>{if(Q instanceof r.$DK)return{type:"error",error:{code:Q._code,message:Q._message,detail:Q._detail}};throw Q},Z=async Q=>{Ee(`activating resolver for ${Q}...`);const{resolver:q,authorityPrefix:_}=await this.sb(Q);if(!q)throw se(`no resolver for ${_}`),new r.$DK(`No remote extension installed to resolve ${_}.`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:q,authorityPrefix:_,remoteAuthority:Q}},le=ee.split(/@|%40/g).reverse();Ee(`activating remote resolvers ${le.join(" -> ")}`);let ne;try{ne=await Promise.all(le.map(Z)).catch(async Q=>{if(!(Q instanceof r.$DK)||Q._code!==s.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw Q;return te(`resolving nested authorities failed: ${Q.message}`),[await Z(ee)]})}catch(Q){return me(Q)}const ae=new R.$7g;ae.cancelAndSet(()=>Ee("waiting..."),1e3);let de,Ie;for(const[Q,{authorityPrefix:q,resolver:_,remoteAuthority:he}]of ne.entries())try{if(Q===ne.length-1)Ee("invoking final resolve()..."),P.mark(`code/extHost/willResolveAuthority/${q}`),de=await _.resolve(he,{resolveAttempt:W,execServer:Ie}),P.mark(`code/extHost/didResolveAuthorityOK/${q}`),Ee("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(_,r.$CK.isManagedResolvedAuthority(de)?de:void 0));else{if(Ee(`invoking resolveExecServer() for ${he}`),P.mark(`code/extHost/willResolveExecServer/${q}`),Ie=await _.resolveExecServer?.(he,{resolveAttempt:W,execServer:Ie}),!Ie)throw new r.$DK(`Exec server was not available for ${he}`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);P.mark(`code/extHost/didResolveExecServerOK/${q}`)}}catch(Oe){return P.mark(`code/extHost/didResolveAuthorityError/${q}`),se("returned an error",Oe),ae.dispose(),me(Oe)}ae.dispose();const T={environmentTunnels:de.environmentTunnels,features:de.tunnelFeatures},V={extensionHostEnv:de.extensionHostEnv,isTrusted:de.isTrusted,authenticationSession:de.authenticationSessionForInitializingExtensions?{id:de.authenticationSessionForInitializingExtensions.id,providerId:de.authenticationSessionForInitializingExtensions.providerId}:void 0};Ee(`returned ${r.$CK.isManagedResolvedAuthority(de)?"managed authority":`${de.host}:${de.port}`}`);let G;if(r.$CK.isManagedResolvedAuthority(de)){const Q=W;this.X.setFactory(Q,de.makeConnection),G={authority:ee,connectTo:new s.$Uk(Q),connectionToken:de.connectionToken}}else G={authority:ee,connectTo:new s.$Vk(de.host,de.port),connectionToken:de.connectionToken};return{type:"ok",value:{authority:G,options:V,tunnelInformation:T}}}async $getCanonicalURI(ee,W){this.s.info(`$getCanonicalURI invoked for authority (${(0,s.$Xk)(ee)})`);const{resolver:ue}=await this.sb(ee);if(!ue)return null;const Pe=g.URI.revive(W);if(typeof ue.getCanonicalURI>"u")return Pe;const Ee=await(0,R.$Ng)(()=>ue.getCanonicalURI(Pe));return Ee||Pe}$startExtensionHost(ee){ee.toAdd.forEach(Pe=>Pe.extensionLocation=g.URI.revive(Pe.extensionLocation));const{globalRegistry:W,myExtensions:ue}=ye(this.I,this.L,this.J,ee);return this.L.set(W.getAllExtensionDescriptions()),this.J.set(ue),F.$t&&(this.s.info(`$startExtensionHost: global extensions: ${Ce(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Ce(this.J)}`)),this.rb()}$activateByEvent(ee,W){return W===1?this.D.wait().then(ue=>this.Z(ee,!1)):this.G.wait().then(ue=>this.Z(ee,!1))}async $activate(ee,W){return await this.G.wait(),this.J.getExtensionDescription(ee)?(await this.$(ee,W),!0):!1}async $deltaExtensions(ee){ee.toAdd.forEach(te=>te.extensionLocation=g.URI.revive(te.extensionLocation));const{globalRegistry:W,myExtensions:ue}=ye(this.I,this.L,this.J,ee),Pe=await this.bb(ue);return(await this.getExtensionPathIndex()).setSearchTree(Pe),this.L.set(W.getAllExtensionDescriptions()),this.J.set(ue),F.$t&&(this.s.info(`$deltaExtensions: global extensions: ${Ce(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Ce(this.J)}`)),Promise.resolve(void 0)}async $test_latency(ee){return ee}async $test_up(ee){return ee.byteLength}async $test_down(ee){const W=a.$ce.alloc(ee),ue=Math.random()%256;for(let Pe=0;Pe<ee;Pe++)W.writeUInt8(ue,Pe);return W}async $updateRemoteConnectionData(ee){this.W=ee,this.a.fire()}};e.$Kdc=J,e.$Kdc=J=x=Ke([Ve(0,c.$Sh),Ve(1,e.$Jdc),Ve(2,m.$xM),Ve(3,f.$ddc),Ve(4,o.$gdc),Ve(5,A.$bj),Ve(6,h.$NM),Ve(7,w.$wdc),Ve(8,k.$Iwb),Ve(9,d.$ydc),Ve(10,U.$Gdc),Ve(11,N.$Hdc)],J);function ye(ve,ee,W,ue){ve.addActivationEvents(ue.addActivationEvents);const Pe=new i.$e5b(ve,ee.getAllExtensionDescriptions());Pe.deltaExtensions(ue.toAdd,ue.toRemove);const Ee=new u.$$l(W.getAllExtensionDescriptions().map(se=>se.identifier));for(const se of ue.myToRemove)Ee.delete(se);for(const se of ue.myToAdd)Ee.add(se);const te=we(Pe,Ee);return{globalRegistry:Pe,myExtensions:te}}function De(ve,ee){return{id:ve.identifier.value,name:ve.name,extensionVersion:ve.version,publisherDisplayName:ve.publisher,activationEvents:ve.activationEvents?ve.activationEvents.join(","):null,isBuiltin:ve.isBuiltin,reason:ee.activationEvent,reasonId:ee.extensionId.value}}function Ce(ve){return ve.getAllExtensionDescriptions().map(ee=>ee.identifier.value).join(",")}e.$Ldc=(0,c.$Th)("IExtHostExtensionService");class ge{#e;#t;#i;constructor(ee,W,ue,Pe,Ee){this.#e=ee,this.#t=W,this.#i=ue.identifier,this.id=ue.identifier.value,this.extensionUri=ue.extensionLocation,this.extensionPath=L.$gc((0,M.$kg)(ue.extensionLocation)),this.packageJSON=ue,this.extensionKind=Pe,this.isFromDifferentExtensionHost=Ee}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Mdc=ge;function we(ve,ee){return ve.getAllExtensionDescriptions().filter(W=>ee.has(W.identifier))}class re{constructor(ee){this.a=ee}setSearchTree(ee){this.a=ee}findSubstr(ee){return this.a.findSubstr(ee)}forEach(ee){return this.a.forEach(ee)}}e.$Ndc=re;class oe{constructor(ee){this.a=new u.$_l,this.addActivationEvents(ee)}readActivationEvents(ee){return this.a.get(ee.identifier)??[]}addActivationEvents(ee){for(const W of Object.keys(ee))this.a.set(W,ee[W])}}}),define(Ae[289],Re([1,0,88,2,3,36,23,22,17,27,4,37,15,13]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o,v){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$_ec=void 0;let f=class{constructor(a,l,r,s,c,h,w){this.c=a,this.d=l,this.e=r,this.f=s,this.g=c,this.h=h,this.i=w,this.a=new Map,this.b=[]}async install(){this.j(),E.mark("code/extHost/willWaitForConfig");const a=await this.f.getConfigProvider();E.mark("code/extHost/didWaitForConfig");const l=await this.g.getExtensionPathIndex();this.register(new i(this.c,l,this.d,a,this.i)),this.register(this.e.createInstance(t)),this.h.remote.isRemote&&this.register(this.e.createInstance(n,l,this.h.environment.appUriScheme))}register(a){if("nodeModuleName"in a)if(Array.isArray(a.nodeModuleName))for(const l of a.nodeModuleName)this.a.set(l,a);else this.a.set(a.nodeModuleName,a);typeof a.alternativeModuleName=="function"&&this.b.push(l=>a.alternativeModuleName(l))}};e.$_ec=f,e.$_ec=f=Ke([Ve(2,A.$Sh),Ve(3,M.$gdc),Ve(4,S.$Ldc),Ve(5,g.$NM),Ve(6,o.$bj)],f);let t=class{static{p=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(a){if(a.environment.appRoot&&p.a.size){const l=(0,v.$Ge)(this.c(a.environment.appRoot.fsPath)),r="[a-z0-9_.-]",s=`@${r}+\\/${r}+|${r}+`,c="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${l}/${c}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(a){if(!this.b)return;const l=this.b.exec(this.c(a));if(!l)return;const[,r,s,c]=l,h=p.a.get(s);if(h!==void 0)return console.warn(`${s} as been renamed to ${h}, please update your imports`),r+h+c}c(a){return a.replace(/\\/g,"/")}};t=p=Ke([Ve(0,g.$NM)],t);class i{constructor(a,l,r,s,c){this.c=a,this.d=l,this.e=r,this.f=s,this.g=c,this.nodeModuleName="vscode",this.a=new $.$_l}load(a,l){const r=this.d.findSubstr(l);if(r){let s=this.a.get(r.identifier);return s||(s=this.c(r,this.e,this.f),this.a.set(r.identifier,s)),s}if(!this.b){let s="";this.d.forEach((c,h)=>s+=`	${h} -> ${c.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${l}. These are the extension path mappings: 
${s}`),this.b=this.c(R.$pF,this.e,this.f)}return this.b}}let n=class{constructor(a,l,r){this.e=a,this.f=l,this.nodeModuleName=["open","opn"],this.d=r.getProxy(P.$vK.MainThreadTelemetry);const s=r.getProxy(P.$vK.MainThreadWindow);this.c=(c,h)=>{const w=L.URI.parse(c);return h?this.g(c,h):w.scheme==="http"||w.scheme==="https"?s.$openUri(w,c,{allowTunneling:!0}):w.scheme==="mailto"||w.scheme===this.f?s.$openUri(w,c,{}):this.g(c,h)}}load(a,l,r){const s=this.e.findSubstr(l);return s&&(this.a=s.identifier.value,this.h()),this.b=r(a),this.c}g(a,l){return this.i(),this.b(a,l)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};n=Ke([Ve(2,D.$xM)],n)}),define(Ae[116],Re([1,0,44,6,19,74,4,62,63,37,7,35,216,36]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iec=e.$hec=void 0,e.$hec=(0,R.$Th)("IExtHostVariableResolverProvider");class p extends o.$yN{constructor(i,n,u,a,l,r,s){function c(){if(u){const h=u.activeEditor();if(h)return h.document.uri;const w=a.tabGroups.all.find(m=>m.isActive)?.activeTab;if(w!==void 0){if(w.input instanceof A.$dM||w.input instanceof A.$iM)return w.input.modified;if(w.input instanceof A.$cM||w.input instanceof A.$hM||w.input instanceof A.$fM)return w.input.uri}}}super({getFolderUri:h=>{const w=r.folders.filter(m=>m.name===h);if(w&&w.length>0)return w[0].uri},getWorkspaceFolderCount:()=>r.folders.length,getConfigurationValue:(h,w)=>l.getConfiguration(void 0,h).get(w),getAppRoot:()=>M.cwd(),getExecPath:()=>M.env.VSCODE_EXEC_PATH,getFilePath:()=>{const h=c();if(h)return P.$gc(h.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const h=c();if(h){const w=n.getWorkspaceFolder(h);if(w)return P.$gc(w.uri.fsPath)}}},getSelectedText:()=>{if(u){const h=u.activeEditor();if(h&&!h.selection.isEmpty)return h.document.getText(h.selection)}},getLineNumber:()=>{if(u){const h=u.activeEditor();if(h)return String(h.selection.end.line+1)}},getExtension:h=>i.getExtension(h)},void 0,s?Promise.resolve(s):void 0,Promise.resolve(M.env))}}let f=class extends L.$Rc{constructor(i,n,u,a,l){super(),this.b=i,this.c=n,this.g=u,this.h=a,this.j=l,this.a=new E.$U(async()=>{const r=await this.h.getConfigProvider(),c={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async h=>{c.folders=await this.c.getWorkspaceFolders2()||[]})),new p(this.b,this.c,this.g,this.j,r,c,this.m())})}getResolver(){return this.a.value}m(){}};e.$iec=f,e.$iec=f=Ke([Ve(0,g.$Ldc),Ve(1,S.$ddc),Ve(2,$.$IM),Ve(3,v.$gdc),Ve(4,D.$fec)],f)}),define(Ae[117],Re([1,0,12,5,2,4,3,63,37,17,7,35,208,210,36,116]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nec=e.$mec=e.$lec=e.$kec=e.$jec=void 0,e.$jec=(0,M.$Th)("IExtHostDebugService");let t=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(s,c,h,w,m,I){this.E=c,this.F=h,this.G=w,this.H=m,this.I=I,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new L.$Od,this.n=new L.$Od,this.o=new L.$Od,this.u=new L.$Od,this.k=s.getProxy(R.$vK.MainThreadDebugService),this.y=new L.$Od,this.A=new L.$Od,this.v=new n(this.k),this.w=new Map,this.F.getExtensionRegistry().then(k=>{k.onDidChange(d=>{this.J(k)}),this.J(k)})}asDebugSourceUri(s,c){const h=s;if(typeof h.sourceReference=="number"&&h.sourceReference>0){let w=`debug:${encodeURIComponent(h.path||"")}`,m="?";return c&&(w+=`${m}session=${encodeURIComponent(c.id)}`,m="&"),w+=`${m}ref=${h.sourceReference}`,P.URI.parse(w)}else{if(h.path)return P.URI.file(h.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(s){const c=[];for(const h of s.getAllExtensionDescriptions())if(h.contributes){const w=h.contributes.debuggers;if(w&&w.length>0)for(const m of w)(0,v.$JF)(m)&&c.push(m.type)}this.k.$registerDebugTypes(c)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const s=[];return this.w.forEach(c=>s.push(c)),s}addBreakpoints(s){const c=s.filter(m=>{const I=m.id;return this.w.has(I)?!1:(this.w.set(I,m),!0)});this.U(c,[],[]);const h=[],w=new Map;for(const m of c)if(m instanceof A.$wL){let I=w.get(m.location.uri.toString());I||(I={type:"sourceMulti",uri:m.location.uri,lines:[]},w.set(m.location.uri.toString(),I),h.push(I)),I.lines.push({id:m.id,enabled:m.enabled,condition:m.condition,hitCondition:m.hitCondition,logMessage:m.logMessage,line:m.location.range.start.line,character:m.location.range.start.character})}else m instanceof A.$xL&&h.push({type:"function",id:m.id,enabled:m.enabled,hitCondition:m.hitCondition,logMessage:m.logMessage,condition:m.condition,functionName:m.functionName});return this.k.$registerBreakpoints(h)}removeBreakpoints(s){const c=s.filter(I=>this.w.delete(I.id));this.U([],c,[]);const h=c.filter(I=>I instanceof A.$wL).map(I=>I.id),w=c.filter(I=>I instanceof A.$xL).map(I=>I.id),m=c.filter(I=>I instanceof A.$yL).map(I=>I.id);return this.k.$unregisterBreakpoints(h,w,m)}startDebugging(s,c,h){return this.k.$startDebugging(s?s.uri:void 0,c,{parentSessionID:h.parentSession?h.parentSession.id:void 0,lifecycleManagedByParent:h.lifecycleManagedByParent,repl:h.consoleMode===A.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:h.noDebug,compact:h.compact,suppressSaveBeforeStart:h.suppressSaveBeforeStart,suppressDebugStatusbar:h.suppressDebugStatusbar??h.debugUI?.simple,suppressDebugToolbar:h.suppressDebugToolbar??h.debugUI?.simple,suppressDebugView:h.suppressDebugView??h.debugUI?.simple})}stopDebugging(s){return this.k.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,c,h){if(!c)return new A.$xK(()=>{});const w=this.d++;return this.f.push({type:s,handle:w,provider:c}),this.k.$registerDebugConfigurationProvider(s,h,!!c.provideDebugConfigurations,!!c.resolveDebugConfiguration,!!c.resolveDebugConfigurationWithSubstitutedVariables,w),new A.$xK(()=>{this.f=this.f.filter(m=>m.provider!==c),this.k.$unregisterDebugConfigurationProvider(w)})}registerDebugAdapterDescriptorFactory(s,c,h){if(!h)return new A.$xK(()=>{});if(!this.Q(s,c))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${c}' debugger.`);if(this.N(c))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const w=this.g++;return this.h.push({type:c,handle:w,factory:h}),this.k.$registerDebugAdapterDescriptorFactory(c,w),new A.$xK(()=>{this.h=this.h.filter(m=>m.factory!==h),this.k.$unregisterDebugAdapterDescriptorFactory(w)})}registerDebugAdapterTrackerFactory(s,c){if(!c)return new A.$xK(()=>{});const h=this.i++;return this.j.push({type:s,handle:h,factory:c}),new A.$xK(()=>{this.j=this.j.filter(w=>w.factory!==c)})}async $runInTerminal(s,c){return Promise.resolve(void 0)}async $substituteVariables(s,c){let h;const w=await this.W(s);return w&&(h={uri:w.uri,name:w.name,index:w.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(h,c)}K(s,c){if(s.type==="implementation")return new a(s.implementation)}L(){}async $startDASession(s,c){const h=this,w=await this.V(c);return this.S(this.N(w.type),w).then(m=>{if(!m)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}' (extension might have failed to activate)`);const I=this.M(m),k=this.K(I,w);if(!k)throw new Error(`Couldn't create a debug adapter for type '${w.type}'.`);const d=k;return this.B.set(s,d),this.R(w).then(b=>(b&&this.C.set(s,b),d.onMessage(async y=>{if(y.type==="request"&&y.command==="handshake"){const C=y,B={type:"response",seq:0,command:C.command,request_seq:C.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const H=await this.D.sign(C.arguments.value);B.body={signature:H},d.sendResponse(B)}else throw new Error("no signer")}catch(H){B.success=!1,B.message=H.message,d.sendResponse(B)}}else b&&b.onDidSendMessage&&b.onDidSendMessage(y),y=(0,v.$OF)(y,!0),h.k.$acceptDAMessage(s,y)}),d.onError(y=>{b&&b.onError&&b.onError(y),this.k.$acceptDAError(s,y.name,y.message,y.stack)}),d.onExit(y=>{b&&b.onExit&&b.onExit(y??void 0,void 0),this.k.$acceptDAExit(s,y??void 0,void 0)}),b&&b.onWillStartSession&&b.onWillStartSession(),d.startSession()))})}$sendDAMessage(s,c){c=(0,v.$NF)(c,!1);const h=this.C.get(s);h&&h.onWillReceiveMessage&&h.onWillReceiveMessage(c),this.B.get(s)?.sendMessage(c)}$stopDASession(s){const c=this.C.get(s);this.C.delete(s),c&&c.onWillStopSession&&c.onWillStopSession();const h=this.B.get(s);return this.B.delete(s),h?h.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const c=[],h=[],w=[];if(s.added)for(const m of s.added){const I=m.id;if(I&&!this.w.has(I)){let k;if(m.type==="function")k=new A.$xL(m.functionName,m.enabled,m.condition,m.hitCondition,m.logMessage);else if(m.type==="data")k=new A.$yL(m.label,m.dataId,m.canPersist,m.enabled,m.hitCondition,m.condition,m.logMessage);else{const d=P.URI.revive(m.uri);k=new A.$wL(new A.$JK(d,new A.$yK(m.line,m.character)),m.enabled,m.condition,m.hitCondition,m.logMessage)}(0,A.$uL)(k,I),this.w.set(I,k),c.push(k)}}if(s.removed)for(const m of s.removed){const I=this.w.get(m);I&&(this.w.delete(m),h.push(I))}if(s.changed){for(const m of s.changed)if(m.id){const I=this.w.get(m.id);if(I){if(I instanceof A.$xL&&m.type==="function"){const k=I;k.enabled=m.enabled,k.condition=m.condition,k.hitCondition=m.hitCondition,k.logMessage=m.logMessage,k.functionName=m.functionName}else if(I instanceof A.$wL&&m.type==="source"){const k=I;k.enabled=m.enabled,k.condition=m.condition,k.hitCondition=m.hitCondition,k.logMessage=m.logMessage,k.location=new A.$JK(P.URI.revive(m.uri),new A.$yK(m.line,m.character))}w.push(I)}}}this.U(c,h,w)}async $acceptStackFrameFocus(s){let c;const h=s.sessionId?await this.V(s.sessionId):void 0;if(!h)throw new Error("no DebugSession found for debug focus context");s.kind==="thread"?c=new A.$EL(h,s.threadId):c=new A.$DL(h,s.threadId,s.frameId),this.z=c,this.A.fire(this.z)}$provideDebugConfigurations(s,c,h){return(0,E.$Ng)(async()=>{const w=this.P(s);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const m=await this.W(c);return w.provideDebugConfigurations(m,h)}).then(w=>{if(!w)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return w})}$resolveDebugConfiguration(s,c,h,w){return(0,E.$Ng)(async()=>{const m=this.P(s);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const I=await this.W(c);return m.resolveDebugConfiguration(I,h,w)})}$resolveDebugConfigurationWithSubstitutedVariables(s,c,h,w){return(0,E.$Ng)(async()=>{const m=this.P(s);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const I=await this.W(c);return m.resolveDebugConfigurationWithSubstitutedVariables(I,h,w)})}async $provideDebugAdapter(s,c){const h=this.O(s);if(!h)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const w=await this.V(c);return this.S(h,w).then(m=>{if(!m)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}'`);return this.M(m)})}async $acceptDebugSessionStarted(s){const c=await this.V(s);this.m.fire(c)}async $acceptDebugSessionTerminated(s){const c=await this.V(s);c&&(this.n.fire(c),this.l.delete(c.id))}async $acceptDebugSessionActiveChanged(s){this.q=s?await this.V(s):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(s,c){(await this.V(s))?._acceptNameChanged(c)}async $acceptDebugSessionCustomEvent(s,c){const w={session:await this.V(s),event:c.event,body:c.body};this.u.fire(w)}M(s){if(s instanceof A.$zL)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof A.$AL)return{type:"server",port:s.port,host:s.host};if(s instanceof A.$BL)return{type:"pipeServer",path:s.path};if(s instanceof A.$CL)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}N(s){const c=this.h.filter(h=>h.type===s);if(c.length>0)return c[0].factory}O(s){const c=this.h.filter(h=>h.handle===s);if(c.length>0)return c[0].factory}P(s){const c=this.f.filter(h=>h.handle===s);if(c.length>0)return c[0].provider}Q(s,c){if(s.contributes){const h=s.contributes.debuggers;if(h&&h.length>0){for(const w of h)if(w.label&&w.type&&w.type===c)return!0}}return!1}R(s){const h=s.configuration.type,w=this.j.filter(m=>m.type===h||m.type==="*").map(m=>(0,E.$Ng)(()=>m.factory.createDebugAdapterTracker(s)).then(I=>I,I=>null));return Promise.race([Promise.all(w).then(m=>{const I=m.filter(k=>!!k);if(I.length>0)return new u(I)}),new Promise(m=>setTimeout(()=>m(void 0),1e3))]).catch(m=>{})}async S(s,c){const h=c.configuration.debugServer;if(typeof h=="number")return Promise.resolve(new A.$AL(h));if(s){const m=await this.F.getExtensionRegistry();return(0,E.$Ng)(()=>s.createDebugAdapterDescriptor(c,this.T(c,m))).then(I=>{if(I)return I})}const w=await this.F.getExtensionRegistry();return Promise.resolve(this.T(c,w))}T(s,c){}U(s,c,h){(s.length>0||c.length>0||h.length>0)&&this.y.fire(Object.freeze({added:s,removed:c,changed:h}))}async V(s){if(s)if(typeof s=="string"){const c=this.l.get(s);if(c)return c}else{let c=this.l.get(s.id);if(!c){const h=await this.W(s.folderUri),w=s.parent?this.l.get(s.parent):void 0;c=new i(this.k,s.id,s.type,s.name,h,s.configuration,w),this.l.set(c.id,c),this.k.$sessionCached(c.id)}return c}throw new Error("cannot find session")}W(s){if(s){const c=P.URI.revive(s);return this.E.resolveWorkspaceFolder(c)}return Promise.resolve(void 0)}};e.$kec=t,e.$kec=t=Ke([Ve(0,g.$xM),Ve(1,S.$ddc),Ve(2,D.$Ldc),Ve(3,p.$gdc),Ve(4,$.$fec),Ve(5,f.$hec)],t);class i{constructor(s,c,h,w,m,I,k){this.d=s,this.f=c,this.g=h,this.h=w,this.i=m,this.j=I,this.k=k}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(s){this.h=s,this.d.$setDebugSessionName(this.f,s)}get parentSession(){return this.k}_acceptNameChanged(s){this.h=s}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(s,c){return this.d.$customDebugAdapterRequest(this.f,s,c)}getDebugProtocolBreakpoint(s){return this.d.$getDebugProtocolBreakpoint(this.f,s.id)}}e.$lec=i;class n{constructor(s){this.value=Object.freeze({append(c){s.$appendDebugConsole(c)},appendLine(c){this.append(c+`
`)}})}}e.$mec=n;class u{constructor(s){this.d=s}onWillStartSession(){this.d.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.d.forEach(c=>c.onWillReceiveMessage?c.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.d.forEach(c=>c.onDidSendMessage?c.onDidSendMessage(s):void 0)}onWillStopSession(){this.d.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.d.forEach(c=>c.onError?c.onError(s):void 0)}onExit(s,c){this.d.forEach(h=>h.onExit?h.onExit(s,c):void 0)}}class a extends o.$Ddb{constructor(s){super(),this.h=s,s.onDidSendMessage(c=>{this.acceptMessage(c)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.h.handleMessage(s)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let l=class extends t{constructor(s,c,h,w,m,I){super(s,c,h,w,m,I)}};e.$nec=l,e.$nec=l=Ke([Ve(0,g.$xM),Ve(1,S.$ddc),Ve(2,D.$Ldc),Ve(3,p.$gdc),Ve(4,$.$fec),Ve(5,f.$hec)],l)}),define(Ae[290],Re([1,0,11,88,2,3,278,15,71,72,27,186,17,59,37,61]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bfc=e.$afc=void 0;class t{static async installEarlyHandler(u){Error.stackTraceLimit=100;const a=u.get($.$bj),r=u.get(o.$xM).getProxy(M.$vK.MainThreadErrors);E.setUnexpectedErrorHandler(s=>{a.error(s);const c=E.$2(s);r.$onUnexpectedError(c)})}static async installFullHandler(u){const a=u.get($.$bj),l=u.get(o.$xM),r=u.get(p.$Ldc),s=u.get(f.$RM),c=l.getProxy(M.$vK.MainThreadExtensionService),h=l.getProxy(M.$vK.MainThreadErrors),w=await r.getExtensionPathIndex(),m=new WeakMap;function I(b,y){if(m.has(b))return m.get(b).stack;let C="",B,H;for(const z of y)C+=`
	at ${z.toString()}`,H=z.getFileName(),!B&&H&&(B=w.findSubstr(P.URI.file(H)));const U=`${b.name||"Error"}: ${b.message||""}${C}`;return m.set(b,{extensionIdentifier:B?.identifier,stack:U}),U}const k=Symbol("prepareStackTrace wrapped");let d=I;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return d},set(b){if(b===I||!b||b[k]){d=b||I;return}d=function(y,C){return I(y,C),b.call(Error,y,C)},Object.assign(d,{[k]:!0})}}),E.setUnexpectedErrorHandler(b=>{a.error(b);const y=E.$2(b),C=m.get(b);if(!C?.extensionIdentifier){h.$onUnexpectedError(y);return}c.$onExtensionRuntimeError(C.extensionIdentifier,y);const B=s.onExtensionError(C.extensionIdentifier,b);a.trace("forwarded error to extension?",B,C)})}}e.$afc=t;class i{constructor(u,a,l,r,s){this.a=l,this.b=new R.$m5b(u,null,r),a=i.e(a,this.b);const c=new g.$Rh(...(0,D.$Br)());c.set(A.$NM,{_serviceBrand:void 0,...a,messagePorts:s}),c.set(o.$xM,new o.$yM(this.b)),c.set(v.$adc,new v.$bdc(r)),c.set(p.$Jdc,l);const h=new S.$hq(c,!0);h.invokeFunction(t.installEarlyHandler),this.d=h.invokeFunction(w=>w.get($.$bj)),L.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",a),this.c=h.invokeFunction(w=>w.get(p.$Ldc)),this.c.initialize(),h.invokeFunction(t.installFullHandler)}async asBrowserUri(u){const a=this.b.getProxy(M.$vK.MainThreadExtensionService);return P.URI.revive(await a.$asBrowserUri(u))}terminate(u){this.c.terminate(u)}static e(u,a){u.extensions.allExtensions.forEach(r=>{r.extensionLocation=P.URI.revive(a.transformIncomingURIs(r.extensionLocation))}),u.environment.appRoot=P.URI.revive(a.transformIncomingURIs(u.environment.appRoot));const l=u.environment.extensionDevelopmentLocationURI;return l&&(u.environment.extensionDevelopmentLocationURI=l.map(r=>P.URI.revive(a.transformIncomingURIs(r)))),u.environment.extensionTestsLocationURI=P.URI.revive(a.transformIncomingURIs(u.environment.extensionTestsLocationURI)),u.environment.globalStorageHome=P.URI.revive(a.transformIncomingURIs(u.environment.globalStorageHome)),u.environment.workspaceStorageHome=P.URI.revive(a.transformIncomingURIs(u.environment.workspaceStorageHome)),u.environment.extensionTelemetryLogResource=P.URI.revive(a.transformIncomingURIs(u.environment.extensionTelemetryLogResource)),u.nlsBaseUrl=P.URI.revive(a.transformIncomingURIs(u.nlsBaseUrl)),u.logsLocation=P.URI.revive(a.transformIncomingURIs(u.logsLocation)),u.workspace=a.transformIncomingURIs(u.workspace),u}}e.$bfc=i}),define(Ae[291],Re([1,0,18,12,20,39,14,19,25,2,43]),function(pe,e,E,L,P,M,R,$,D,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sec=e.$rec=e.$qec=e.$pec=void 0;class S{constructor(n,u,a,l){this.d=n,this.e=u,this.f=a,this.g=l,this.a=null,this.b=!1,this.c=0}search(n,u){const a=this.d.folderQueries||[],l=new P.$Yd(u);return new Promise((r,s)=>{this.a=new v(n);let c=!1;const h=(w,m)=>{if(!c&&!this.b){const I=this.h(w);f(w)&&typeof this.d.maxResults=="number"&&this.c+I>this.d.maxResults&&(this.b=!0,c=!0,l.cancel(),w=this.j(w,this.d.maxResults-this.c));const k=this.h(w);this.c+=k,(k>0||!f(w))&&this.a.add(w,m)}};Promise.all(a.map((w,m)=>this.k(w,I=>h(I,m),l.token))).then(w=>{l.dispose(),this.a.flush();const m=w.some(I=>!!I&&!!I.limitHit);r({limitHit:this.b||m,messages:(0,E.$Qb)(w.map(I=>I?.message?Array.isArray(I.message)?I.message:[I.message]:[])),stats:{type:this.g}})},w=>{l.dispose();const m=(0,M.$Ei)(w);s(new Error(m))})})}h(n){return f(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}j(n,u){const a=Array.isArray(n.ranges)?n.ranges:[n.ranges],l=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:a.slice(0,u),preview:{matches:l.slice(0,u),text:n.preview.text},uri:n.uri}}async k(n,u,a){const l=new A.$aJ(this.d,n),r=[],s={report:w=>{if(!this.l(w))return;const m=n.folder.scheme===R.Schemas.file?(0,A.$bJ)(()=>this.f.readdir(D.$vg(w.uri))):void 0,I=D.$yg(n.folder,w.uri);if(I){const k=l.includedInQuery(I,$.$mc(I),m);(0,L.$Hg)(k)?r.push(k.then(d=>{d&&u(w)})):k&&u(w)}}},c=this.n(n),h=await this.e.provideTextSearchResults(o(this.d.contentPattern),c,s,a);return r.length&&await Promise.all(r),h}l(n){if(f(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(n){const u=(0,A.$_I)(this.d.includePattern,n.includePattern),a=(0,A.$_I)(this.d.excludePattern,n.excludePattern),l={folder:g.URI.from(n.folder),excludes:a,includes:u,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.f.toCanonicalName(n.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return l.usePCRE2=this.d.usePCRE2,l}}e.$pec=S;function o(i){return{isCaseSensitive:i.isCaseSensitive||!1,isRegExp:i.isRegExp||!1,isWordMatch:i.isWordMatch||!1,isMultiline:i.isMultiline||!1,pattern:i.pattern}}class v{constructor(n){this.e=n,this.b=-1,this.d=null,this.a=new t(512,u=>this.g(u))}add(n,u){this.d&&(this.b!==u||!D.$pg(this.c,n.uri))&&(this.f(),this.d=null),this.d||(this.b=u,this.d={resource:n.uri,results:[]}),this.d.results.push(p(n))}f(){const n=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,n)}flush(){this.f(),this.a.flush()}g(n){this.e(n)}}e.$qec=v;function p(i){return f(i)?{preview:{matches:(0,E.$1b)(i.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:i.preview.text},ranges:(0,E.$1b)(i.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:i.text,lineNumber:i.lineNumber}}function f(i){return!!i.preview}e.$rec=f;class t{static{this.a=4e3}static{this.b=50}constructor(n,u){this.g=n,this.h=u,this.c=0,this.d=[],this.e=0}addItem(n,u){n&&this.j(n,u)}addItems(n,u){n&&this.k(n,u)}j(n,u){this.d.push(n),this.e+=u,this.l()}k(n,u){this.d=this.d.concat(n),this.e+=u,this.l()}l(){this.c<t.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},t.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$sec=t}),define(Ae[118],Re([1,0,6,3,4,286,17,59,15,2,291]),function(pe,e,E,L,P,M,R,$,D,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vec=e.$uec=e.$tec=void 0,e.$tec=(0,P.$Th)("IExtHostSearch");let S=class{constructor(f,t,i){this.k=f,this.l=t,this.n=i,this.c=this.k.getProxy(L.$vK.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new M.$oec}o(f){return this.l.transformOutgoingScheme(f)}registerTextSearchProvider(f,t){if(this.g.has(f))throw new Error(`a text search provider for the scheme '${f}' is already registered`);this.g.add(f);const i=this.d++;return this.e.set(i,t),this.c.$registerTextSearchProvider(i,this.o(f)),(0,E.$Pc)(()=>{this.g.delete(f),this.e.delete(i),this.c.$unregisterProvider(i)})}registerFileSearchProvider(f,t){if(this.i.has(f))throw new Error(`a file search provider for the scheme '${f}' is already registered`);this.i.add(f);const i=this.d++;return this.h.set(i,t),this.c.$registerFileSearchProvider(i,this.o(f)),(0,E.$Pc)(()=>{this.i.delete(f),this.h.delete(i),this.c.$unregisterProvider(i)})}$provideFileSearchResults(f,t,i,n){const u=o(i),a=this.h.get(f);if(a)return this.j.fileSearch(u,a,l=>{this.c.$handleFileMatch(f,t,l.map(r=>r.resource))},n);throw new Error("unknown provider: "+f)}async doInternalFileSearchWithCustomCallback(f,t,i){return{messages:[]}}$clearCache(f){return this.j.clearCache(f),Promise.resolve(void 0)}$provideTextSearchResults(f,t,i,n){const u=this.e.get(f);if(!u||!u.provideTextSearchResults)throw new Error(`Unknown provider ${f}`);const a=o(i);return this.q(a,u).search(r=>this.c.$handleTextMatch(f,t,r),n)}$enableExtensionHostSearch(){}q(f,t){return new A.$pec(f,t,{readdir:i=>Promise.resolve([]),toCanonicalName:i=>i},"textSearchProvider")}};e.$uec=S,e.$uec=S=Ke([Ve(0,R.$xM),Ve(1,$.$adc),Ve(2,D.$bj)],S);function o(p){return{...p,folderQueries:p.folderQueries&&p.folderQueries.map(v),extraFileResources:p.extraFileResources&&p.extraFileResources.map(f=>g.URI.revive(f))}}e.$vec=o;function v(p){return{...p,folder:g.URI.revive(p.folder)}}}),define(Ae[292],Re([1,0,20,11,5,31,2,146,92,129,142,41,3,79,241,240,32,242,36,244,245,246,221,247,62,37,250,251,256,257,259,112,225,264,265,268,85,65,270,226,8,7,58,273,66,111,35,22,214,255,57,110,115,117,118,15,59,17,27,285,211,87,81,233,271,86,64,276,274,275,234,42,269,272,84,63,61,260,114,261,14,99,224,203,253,6,23,209,82,199,262,263,235,252,223,254,83,266,238,267,239,232,249,236,237]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f,t,i,n,u,a,l,r,s,c,h,w,m,I,k,d,b,y,C,B,H,U,z,F,N,x,J,ye,De,Ce,ge,we,re,oe,ve,ee,W,ue,Pe,Ee,te,se,me,Z,le,ne,ae,de,Ie,T,V,G,Q,q,_,he,Oe,je,Qe,Ge,_e,Ye,xe,it,tt,ze,ut,Y,X,be,Be,Ne,Xe,nt,$t,wt,Pt,Kt,Ht,vt,Ut,Ot,Gt,jt,kt,Ft,Bt,Jt,Wt,Vt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8ec=void 0;function Nt(at){const dt=at.get(Z.$NM),At=at.get(Oe.$3cc),qt=at.get(G.$vdc),Rt=at.get(h.$Ldc),ot=at.get(we.$ddc),bt=at.get(Ye.$RM),Tt=at.get(n.$gdc),Ct=at.get(se.$adc),We=at.get(me.$xM),Qt=at.get(U.$rdc),Se=at.get(V.$wdc),Le=at.get(te.$cj),$e=at.get(te.$bj),K=at.get(ae.$Iwb),Me=at.get(de.$6cc),Ue=at.get(ge.$0dc),Je=at.get(Ge.$Ddc),qe=at.get(_e.$fec),et=at.get(Ot.$Hdc);We.set(o.$wK.ExtHostFileSystemInfo,At),We.set(o.$wK.ExtHostLogLevelServiceShape,Le),We.set(o.$wK.ExtHostWorkspace,ot),We.set(o.$wK.ExtHostConfiguration,Tt),We.set(o.$wK.ExtHostExtensionService,Rt),We.set(o.$wK.ExtHostStorage,Qt),We.set(o.$wK.ExtHostTunnelService,K),We.set(o.$wK.ExtHostWindow,Ue),We.set(o.$wK.ExtHostSecretState,Je),We.set(o.$wK.ExtHostTelemetry,bt),We.set(o.$wK.ExtHostEditorTabs,qe),We.set(o.$wK.ExtHostManagedSockets,et);const Et=We.set(o.$wK.ExtHostDecorations,at.get(W.$bec)),Dt=We.set(o.$wK.ExtHostDocumentsAndEditors,at.get(c.$IM)),gt=We.set(o.$wK.ExtHostCommands,at.get(t.$TM)),ht=We.set(o.$wK.ExtHostTerminalService,at.get(z.$ydc)),ft=We.set(o.$wK.ExtHostDebugService,at.get(Pe.$jec)),ui=We.set(o.$wK.ExtHostSearch,at.get(Ee.$tec)),St=We.set(o.$wK.ExtHostTask,at.get(ue.$eec)),Si=We.set(o.$wK.ExtHostOutputService,at.get(b.$Tdc)),li=We.set(o.$wK.ExtHostLocalization,at.get(nt.$Gdc)),$i=We.set(o.$wK.ExtHostUrls,new De.$3dc(We)),It=We.set(o.$wK.ExtHostDocuments,new s.$1cc(We,Dt)),gn=We.set(o.$wK.ExtHostDocumentContentProviders,new l.$idc(We,Dt,$e)),ri=We.set(o.$wK.ExtHostDocumentSaveParticipant,new r.$jdc($e,It,We.getProxy(o.$vK.MainThreadBulkEdits))),yt=We.set(o.$wK.ExtHostNotebook,new le.$zec(We,gt,Dt,It,qt,ui)),pi=We.set(o.$wK.ExtHostNotebookDocuments,new X.$Rec(yt)),vi=We.set(o.$wK.ExtHostNotebookEditors,new Y.$Qec($e,yt)),si=We.set(o.$wK.ExtHostNotebookKernels,new xe.$Nec(We,dt,yt,gt,$e)),Ii=We.set(o.$wK.ExtHostNotebookRenderers,new tt.$Pec(We,yt)),Ci=We.set(o.$wK.ExtHostNotebookDocumentSaveParticipant,new vt.$Xec($e,yt,We.getProxy(o.$vK.MainThreadBulkEdits))),Mt=We.set(o.$wK.ExtHostEditors,new F.$1dc(We,Dt)),wi=We.set(o.$wK.ExtHostTreeViews,new N.$2dc(We.getProxy(o.$vK.MainThreadTreeViews),gt,$e)),Pi=We.set(o.$wK.ExtHostEditorInsets,new oe.$$dc(We.getProxy(o.$vK.MainThreadEditorInsets),Mt,dt.remote)),oi=We.set(o.$wK.ExtHostDiagnostics,new u.$5cc(We,$e,At,Dt)),hi=We.set(o.$wK.ExtHostLanguages,new k.$Qdc(We,It,gt.converter,Ct)),ct=We.set(o.$wK.ExtHostLanguageFeatures,new I.$9cc(We,Ct,It,gt,oi,$e,Me,bt)),Ai=We.set(o.$wK.ExtHostFileSystem,new w.$Odc(We,ct)),Yt=We.set(o.$wK.ExtHostFileSystemEventService,new m.$Pdc(We,$e,Dt)),ii=We.set(o.$wK.ExtHostQuickOpen,(0,C.$Vdc)(We,ot,gt)),Ri=We.set(o.$wK.ExtHostSCM,new B.$Xdc(We,gt,It,$e)),Mi=We.set(o.$wK.ExtHostQuickDiff,new Pt.$Uec(We,Ct)),Li=We.set(o.$wK.ExtHostShare,new Gt.$Zec(We,Ct)),Xi=We.set(o.$wK.ExtHostComments,(0,i.$_cc)(We,gt,It)),Fi=We.set(o.$wK.ExtHostProgress,new y.$Udc(We.getProxy(o.$vK.MainThreadProgress))),Zi=We.set(o.$wK.ExtHosLabelService,new ve.$_dc(We)),Ti=We.set(o.$wK.ExtHostTheming,new ne.$Aec(We)),ai=We.set(o.$wK.ExtHostAuthentication,new Ie.$Bec(We)),mn=We.set(o.$wK.ExtHostTimeline,new T.$Dec(We,gt)),Oi=We.set(o.$wK.ExtHostWebviews,new Ce.$6dc(We,dt.remote,ot,$e,Me)),di=We.set(o.$wK.ExtHostWebviewPanels,new _.$Fec(We,Oi,ot)),Ni=We.set(o.$wK.ExtHostCustomEditors,new q.$Gec(We,It,Se,Oi,di)),$n=We.set(o.$wK.ExtHostWebviewViews,new Q.$Eec(We,Oi)),fi=We.set(o.$wK.ExtHostTesting,new je.$Iec(We,gt,Dt)),Yi=We.set(o.$wK.ExtHostUriOpeners,new Qe.$Mec(We)),zi=We.set(o.$wK.ExtHostProfileContentHandlers,new wt.$Tec(We));We.set(o.$wK.ExtHostInteractive,new be.$Sec(We,yt,Dt,gt,$e));const xi=We.set(o.$wK.ExtHostInlineChat,new Ht.$Wec(We,gt,It,$e)),gi=We.set(o.$wK.ExtHostChatProvider,new jt.$1ec(We,$e)),_i=We.set(o.$wK.ExtHostChatAgents,new Wt.$6ec(We,gi,$e)),pn=We.set(o.$wK.ExtHostChatAgents2,new Vt.$7ec(We,gi,$e)),Ui=We.set(o.$wK.ExtHostChatVariables,new Ft.$3ec(We)),mi=We.set(o.$wK.ExtHostChat,new Kt.$Vec(We,$e)),xt=We.set(o.$wK.ExtHostAiRelatedInformation,new Bt.$4ec(We)),bi=We.set(o.$wK.ExtHostAiEmbeddingVector,new Jt.$5ec(We)),en=We.set(o.$wK.ExtHostIssueReporter,new Ut.$Yec(We)),Xt=We.set(o.$wK.ExtHostStatusBar,new H.$Zdc(We,gt.converter)),yi=We.set(o.$wK.ExtHostSpeech,new kt.$2ec(We)),tn=Object.values(o.$wK);We.assertRegistered(tn);const nn=new he.$Hec(We,Dt),rn=new f.$$cc(We),Ei=new d.$Rdc(We,$e),sn=new a.$hdc(We);return p.$0cc.register(gt),function(Te,_t,on){const mt=function(){let ie=!Te.isUnderDevelopment;function fe(){ie||($e.info(`Extension '${Te.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ie=!0)}return function Fe(rt){if(Array.isArray(rt))rt.forEach(Fe);else if(typeof rt=="string")fe();else{const pt=rt;typeof pt.scheme>"u"&&fe(),typeof pt.exclusive=="boolean"&&(0,Ne.$vF)(Te,"documentFiltersExclusive")}return rt}}(),ji={getSession(ie,fe,Fe){return ai.getSession(Te,ie,fe,Fe)},getSessions(ie,fe){return(0,Ne.$vF)(Te,"authGetSessions"),ai.getSessions(Te,ie,fe)},async hasSession(ie,fe){return(0,Ne.$vF)(Te,"authSession"),!!await ai.getSession(Te,ie,fe,{silent:!0})},get onDidChangeSessions(){return ai.onDidChangeSessions},registerAuthenticationProvider(ie,fe,Fe,rt){return ai.registerAuthenticationProvider(ie,fe,Fe,rt)}},an={registerCommand(ie,fe,Fe){return gt.registerCommand(!0,ie,fe,Fe,void 0,Te)},registerTextEditorCommand(ie,fe,Fe){return gt.registerCommand(!0,ie,(...rt)=>{const pt=Mt.getActiveTextEditor();if(!pt){$e.warn("Cannot execute "+ie+" because there is no active text editor.");return}return pt.edit(Lt=>{fe.apply(Fe,[pt,Lt,...rt])}).then(Lt=>{Lt||$e.warn("Edits from command "+ie+" were not applied.")},Lt=>{$e.warn("An error occurred while running command "+ie,Lt)})},void 0,void 0,Te)},registerDiffInformationCommand:(ie,fe,Fe)=>((0,Ne.$vF)(Te,"diffCommand"),gt.registerCommand(!0,ie,async(...rt)=>{const pt=Dt.activeEditor(!0);if(!pt){$e.warn("Cannot execute "+ie+" because there is no active text editor.");return}const Lt=await Mt.getDiffInformation(pt.id);fe.apply(Fe,[Lt,...rt])},void 0,void 0,Te)),executeCommand(ie,...fe){return gt.executeCommand(ie,...fe)},getCommands(ie=!1){return gt.getCommands(ie)}},Bi={get machineId(){return dt.telemetryInfo.machineId},get sessionId(){return dt.telemetryInfo.sessionId},get language(){return dt.environment.appLanguage},get appName(){return dt.environment.appName},get appRoot(){return dt.environment.appRoot?.fsPath??""},get appHost(){return dt.environment.appHost},get uriScheme(){return dt.environment.appUriScheme},get clipboard(){return rn.value},get shell(){return ht.getDefaultShell(!1)},get onDidChangeShell(){return ht.onDidChangeShell},get isTelemetryEnabled(){return bt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return bt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ne.$vF)(Te,"telemetry"),bt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ne.$vF)(Te,"telemetry"),bt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,Ye.$QM)(dt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ie,fe){return Ye.$PM.validateSender(ie),bt.instantiateLogger(Te,ie,fe)},openExternal(ie,fe){return Ue.openUri(ie,{allowTunneling:!!dt.remote.authority,allowContributedOpeners:fe?.allowContributedOpeners})},async asExternalUri(ie){if(ie.scheme===dt.environment.appUriScheme)return $i.createAppUri(ie);try{return await Ue.asExternalUri(ie,{allowTunneling:!!dt.remote.authority})}catch(fe){if((0,ut.$GU)(ie,ze.Schemas.http)||(0,ut.$GU)(ie,ze.Schemas.https))return ie;throw fe}},get remoteName(){return(0,ee.$Zk)(dt.remote.authority)},get remoteAuthority(){return(0,Ne.$vF)(Te,"resolvers"),dt.remote.authority},get uiKind(){return dt.uiKind},get logLevel(){return $e.getLevel()},get onDidChangeLogLevel(){return $e.onDidChangeLogLevel},registerIssueUriRequestHandler(ie){return(0,Ne.$vF)(Te,"handleIssueUri"),en.registerIssueUriRequestHandler(Te,ie)},registerIssueDataProvider(ie){return(0,Ne.$vF)(Te,"handleIssueUri"),en.registerIssueDataProvider(Te,ie)},get appQuality(){return(0,Ne.$vF)(Te,"resolvers"),dt.quality},get appCommit(){return(0,Ne.$vF)(Te,"resolvers"),dt.commit}};dt.environment.extensionTestsLocationURI||Object.freeze(Bi);const cn={createTestController(ie,fe,Fe){return fi.createTestController(Te,ie,fe,Fe)},createTestObserver(){return(0,Ne.$vF)(Te,"testObserver"),fi.createTestObserver()},runTests(ie){return(0,Ne.$vF)(Te,"testObserver"),fi.runTests(ie)},get onDidChangeTestResults(){return(0,Ne.$vF)(Te,"testObserver"),fi.onResultsChanged},get testResults(){return(0,Ne.$vF)(Te,"testObserver"),fi.results}},Di=dt.remote.isRemote?J.ExtensionKind.Workspace:J.ExtensionKind.UI,vn={getExtension(ie,fe){(0,Ne.$uF)(Te,"extensionsAny")||(fe=!1);const Fe=_t.mine.getExtensionDescription(ie);if(Fe)return new h.$Mdc(Rt,Te.identifier,Fe,Di,!1);if(fe){const rt=_t.all.getExtensionDescription(ie);if(rt)return new h.$Mdc(Rt,Te.identifier,rt,Di,!0)}},get all(){const ie=[];for(const fe of _t.mine.getAllExtensionDescriptions())ie.push(new h.$Mdc(Rt,Te.identifier,fe,Di,!1));return ie},get allAcrossExtensionHosts(){(0,Ne.$vF)(Te,"extensionsAny");const ie=new re.$$l(_t.mine.getAllExtensionDescriptions().map(Fe=>Fe.identifier)),fe=[];for(const Fe of _t.all.getAllExtensionDescriptions()){const rt=!ie.has(Fe.identifier);fe.push(new h.$Mdc(Rt,Te.identifier,Fe,Di,rt))}return fe},get onDidChange(){return(0,Ne.$uF)(Te,"extensionsAny")?P.Event.any(_t.mine.onDidChange,_t.all.onDidChange):_t.mine.onDidChange}},un={createDiagnosticCollection(ie){return oi.createDiagnosticCollection(Te.identifier,ie)},get onDidChangeDiagnostics(){return oi.onDidChangeDiagnostics},getDiagnostics:ie=>oi.getDiagnostics(ie),getLanguages(){return hi.getLanguages()},setTextDocumentLanguage(ie,fe){return hi.changeLanguage(ie.uri,fe)},match(ie,fe){const Fe=It.getDocumentData(fe.uri)?.notebook;return(0,A.$HE)(x.LanguageSelector.from(ie),fe.uri,fe.languageId,!0,Fe?.uri,Fe?.notebookType)},registerCodeActionsProvider(ie,fe,Fe){return ct.registerCodeActionProvider(Te,mt(ie),fe,Fe)},registerDocumentPasteEditProvider(ie,fe,Fe){return(0,Ne.$vF)(Te,"documentPaste"),ct.registerDocumentPasteEditProvider(Te,mt(ie),fe,Fe)},registerCodeLensProvider(ie,fe){return ct.registerCodeLensProvider(Te,mt(ie),fe)},registerDefinitionProvider(ie,fe){return ct.registerDefinitionProvider(Te,mt(ie),fe)},registerDeclarationProvider(ie,fe){return ct.registerDeclarationProvider(Te,mt(ie),fe)},registerImplementationProvider(ie,fe){return ct.registerImplementationProvider(Te,mt(ie),fe)},registerTypeDefinitionProvider(ie,fe){return ct.registerTypeDefinitionProvider(Te,mt(ie),fe)},registerHoverProvider(ie,fe){return ct.registerHoverProvider(Te,mt(ie),fe,Te.identifier)},registerEvaluatableExpressionProvider(ie,fe){return ct.registerEvaluatableExpressionProvider(Te,mt(ie),fe,Te.identifier)},registerInlineValuesProvider(ie,fe){return ct.registerInlineValuesProvider(Te,mt(ie),fe,Te.identifier)},registerDocumentHighlightProvider(ie,fe){return ct.registerDocumentHighlightProvider(Te,mt(ie),fe)},registerLinkedEditingRangeProvider(ie,fe){return ct.registerLinkedEditingRangeProvider(Te,mt(ie),fe)},registerReferenceProvider(ie,fe){return ct.registerReferenceProvider(Te,mt(ie),fe)},registerRenameProvider(ie,fe){return ct.registerRenameProvider(Te,mt(ie),fe)},registerDocumentSymbolProvider(ie,fe,Fe){return ct.registerDocumentSymbolProvider(Te,mt(ie),fe,Fe)},registerWorkspaceSymbolProvider(ie){return ct.registerWorkspaceSymbolProvider(Te,ie)},registerDocumentFormattingEditProvider(ie,fe){return ct.registerDocumentFormattingEditProvider(Te,mt(ie),fe)},registerDocumentRangeFormattingEditProvider(ie,fe){return ct.registerDocumentRangeFormattingEditProvider(Te,mt(ie),fe)},registerOnTypeFormattingEditProvider(ie,fe,Fe,...rt){return ct.registerOnTypeFormattingEditProvider(Te,mt(ie),fe,[Fe].concat(rt))},registerDocumentSemanticTokensProvider(ie,fe,Fe){return ct.registerDocumentSemanticTokensProvider(Te,mt(ie),fe,Fe)},registerDocumentRangeSemanticTokensProvider(ie,fe,Fe){return ct.registerDocumentRangeSemanticTokensProvider(Te,mt(ie),fe,Fe)},registerSignatureHelpProvider(ie,fe,Fe,...rt){return typeof Fe=="object"?ct.registerSignatureHelpProvider(Te,mt(ie),fe,Fe):ct.registerSignatureHelpProvider(Te,mt(ie),fe,typeof Fe>"u"?[]:[Fe,...rt])},registerCompletionItemProvider(ie,fe,...Fe){return ct.registerCompletionItemProvider(Te,mt(ie),fe,Fe)},registerInlineCompletionItemProvider(ie,fe,Fe){return fe.handleDidShowCompletionItem&&(0,Ne.$vF)(Te,"inlineCompletionsAdditions"),fe.handleDidPartiallyAcceptCompletionItem&&(0,Ne.$vF)(Te,"inlineCompletionsAdditions"),Fe&&(0,Ne.$vF)(Te,"inlineCompletionsAdditions"),ct.registerInlineCompletionsProvider(Te,mt(ie),fe,Fe)},registerDocumentLinkProvider(ie,fe){return ct.registerDocumentLinkProvider(Te,mt(ie),fe)},registerColorProvider(ie,fe){return ct.registerColorProvider(Te,mt(ie),fe)},registerFoldingRangeProvider(ie,fe){return ct.registerFoldingRangeProvider(Te,mt(ie),fe)},registerSelectionRangeProvider(ie,fe){return ct.registerSelectionRangeProvider(Te,ie,fe)},registerCallHierarchyProvider(ie,fe){return ct.registerCallHierarchyProvider(Te,ie,fe)},registerTypeHierarchyProvider(ie,fe){return ct.registerTypeHierarchyProvider(Te,ie,fe)},setLanguageConfiguration:(ie,fe)=>ct.setLanguageConfiguration(Te,ie,fe),getTokenInformationAtPosition(ie,fe){return(0,Ne.$vF)(Te,"tokenInformation"),hi.tokenAtPosition(ie,fe)},registerInlayHintsProvider(ie,fe){return ct.registerInlayHintsProvider(Te,ie,fe)},createLanguageStatusItem(ie,fe){return hi.createLanguageStatusItem(Te,ie,fe)},registerDocumentDropEditProvider(ie,fe,Fe){return ct.registerDocumentOnDropEditProvider(Te,ie,fe,(0,Ne.$uF)(Te,"dropMetadata")?Fe:void 0)}},ln={get activeTextEditor(){return Mt.getActiveTextEditor()},get visibleTextEditors(){return Mt.getVisibleTextEditors()},get activeTerminal(){return ht.activeTerminal},get terminals(){return ht.terminals},async showTextDocument(ie,fe,Fe){const rt=await(R.URI.isUri(ie)?Promise.resolve(ki.openTextDocument(ie)):Promise.resolve(ie));return Mt.showTextDocument(rt,fe,Fe)},createTextEditorDecorationType(ie){return Mt.createTextEditorDecorationType(Te,ie)},onDidChangeActiveTextEditor(ie,fe,Fe){return Mt.onDidChangeActiveTextEditor(ie,fe,Fe)},onDidChangeVisibleTextEditors(ie,fe,Fe){return Mt.onDidChangeVisibleTextEditors(ie,fe,Fe)},onDidChangeTextEditorSelection(ie,fe,Fe){return Mt.onDidChangeTextEditorSelection(ie,fe,Fe)},onDidChangeTextEditorOptions(ie,fe,Fe){return Mt.onDidChangeTextEditorOptions(ie,fe,Fe)},onDidChangeTextEditorVisibleRanges(ie,fe,Fe){return Mt.onDidChangeTextEditorVisibleRanges(ie,fe,Fe)},onDidChangeTextEditorViewColumn(ie,fe,Fe){return Mt.onDidChangeTextEditorViewColumn(ie,fe,Fe)},onDidCloseTerminal(ie,fe,Fe){return ht.onDidCloseTerminal(ie,fe,Fe)},onDidOpenTerminal(ie,fe,Fe){return ht.onDidOpenTerminal(ie,fe,Fe)},onDidChangeActiveTerminal(ie,fe,Fe){return ht.onDidChangeActiveTerminal(ie,fe,Fe)},onDidChangeTerminalDimensions(ie,fe,Fe){return(0,Ne.$vF)(Te,"terminalDimensions"),ht.onDidChangeTerminalDimensions(ie,fe,Fe)},onDidChangeTerminalState(ie,fe,Fe){return ht.onDidChangeTerminalState(ie,fe,Fe)},onDidWriteTerminalData(ie,fe,Fe){return(0,Ne.$vF)(Te,"terminalDataWriteEvent"),ht.onDidWriteTerminalData(ie,fe,Fe)},onDidExecuteTerminalCommand(ie,fe,Fe){return(0,Ne.$vF)(Te,"terminalExecuteCommandEvent"),ht.onDidExecuteTerminalCommand(ie,fe,Fe)},get state(){return Ue.getState(Te)},onDidChangeWindowState(ie,fe,Fe){return Ue.onDidChangeWindowState(ie,fe,Fe)},showInformationMessage(ie,...fe){return Ei.showMessage(Te,M.default.Info,ie,fe[0],fe.slice(1))},showWarningMessage(ie,...fe){return Ei.showMessage(Te,M.default.Warning,ie,fe[0],fe.slice(1))},showErrorMessage(ie,...fe){return Ei.showMessage(Te,M.default.Error,ie,fe[0],fe.slice(1))},showQuickPick(ie,fe,Fe){return ii.showQuickPick(Te,ie,fe,Fe)},showWorkspaceFolderPick(ie){return ii.showWorkspaceFolderPick(ie)},showInputBox(ie,fe){return ii.showInput(ie,fe)},showOpenDialog(ie){return sn.showOpenDialog(Te,ie)},showSaveDialog(ie){return sn.showSaveDialog(ie)},createStatusBarItem(ie,fe,Fe){let rt,pt,Lt;return typeof ie=="string"?(rt=ie,pt=fe,Lt=Fe):(pt=ie,Lt=fe),Xt.createStatusBarEntry(Te,rt,pt,Lt)},setStatusBarMessage(ie,fe){return Xt.setStatusBarMessage(ie,fe)},withScmProgress(ie){return Me.report("window.withScmProgress",Te,"Use 'withProgress' instead."),Fi.withProgress(Te,{location:J.ProgressLocation.SourceControl},(fe,Fe)=>ie({report(rt){}}))},withProgress(ie,fe){return Fi.withProgress(Te,ie,fe)},createOutputChannel(ie,fe){return Si.createOutputChannel(ie,fe,Te)},createWebviewPanel(ie,fe,Fe,rt){return di.createWebviewPanel(Te,ie,fe,Fe,rt)},createWebviewTextEditorInset(ie,fe,Fe,rt){return(0,Ne.$vF)(Te,"editorInsets"),Pi.createWebviewEditorInset(ie,fe,Fe,rt,Te)},createTerminal(ie,fe,Fe){return typeof ie=="object"?"pty"in ie?ht.createExtensionTerminal(ie):ht.createTerminalFromOptions(ie):ht.createTerminal(ie,fe,Fe)},registerTerminalLinkProvider(ie){return ht.registerLinkProvider(ie)},registerTerminalProfileProvider(ie,fe){return ht.registerProfileProvider(Te,ie,fe)},registerTerminalQuickFixProvider(ie,fe){return(0,Ne.$vF)(Te,"terminalQuickFixProvider"),ht.registerTerminalQuickFixProvider(ie,Te.identifier.value,fe)},registerTreeDataProvider(ie,fe){return wi.registerTreeDataProvider(ie,fe,Te)},createTreeView(ie,fe){return wi.createTreeView(ie,fe,Te)},registerWebviewPanelSerializer:(ie,fe)=>di.registerWebviewPanelSerializer(Te,ie,fe),registerCustomEditorProvider:(ie,fe,Fe={})=>Ni.registerCustomEditorProvider(Te,ie,fe,Fe),registerFileDecorationProvider(ie){return Et.registerFileDecorationProvider(ie,Te)},registerUriHandler(ie){return $i.registerUriHandler(Te,ie)},createQuickPick(){return ii.createQuickPick(Te)},createInputBox(){return ii.createInputBox(Te)},get activeColorTheme(){return Ti.activeColorTheme},onDidChangeActiveColorTheme(ie,fe,Fe){return Ti.onDidChangeActiveColorTheme(ie,fe,Fe)},registerWebviewViewProvider(ie,fe,Fe){return $n.registerWebviewViewProvider(Te,ie,fe,Fe?.webviewOptions)},get activeNotebookEditor(){return yt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ie,fe,Fe){return yt.onDidChangeActiveNotebookEditor(ie,fe,Fe)},get visibleNotebookEditors(){return yt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return yt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ie,fe,Fe){return vi.onDidChangeNotebookEditorSelection(ie,fe,Fe)},onDidChangeNotebookEditorVisibleRanges(ie,fe,Fe){return vi.onDidChangeNotebookEditorVisibleRanges(ie,fe,Fe)},showNotebookDocument(ie,fe){return yt.showNotebookDocument(ie,fe)},registerExternalUriOpener(ie,fe,Fe){return(0,Ne.$vF)(Te,"externalUriOpener"),Yi.registerExternalUriOpener(Te.identifier,ie,fe,Fe)},registerProfileContentHandler(ie,fe){return(0,Ne.$vF)(Te,"profileContentHandlers"),zi.registrProfileContentHandler(Te,ie,fe)},registerQuickDiffProvider(ie,fe,Fe,rt){return(0,Ne.$vF)(Te,"quickDiffProvider"),Mi.registerQuickDiffProvider(mt(ie),fe,Fe,rt)},get tabGroups(){return qe.tabGroups},registerShareProvider(ie,fe){return(0,Ne.$vF)(Te,"shareProvider"),Li.registerShareProvider(mt(ie),fe)}},ki={get rootPath(){return Me.report("workspace.rootPath",Te,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ot.getPath()},set rootPath(ie){throw new L.$8("rootPath")},getWorkspaceFolder(ie){return ot.getWorkspaceFolder(ie)},get workspaceFolders(){return ot.getWorkspaceFolders()},get name(){return ot.name},set name(ie){throw new L.$8("name")},get workspaceFile(){return ot.workspaceFile},set workspaceFile(ie){throw new L.$8("workspaceFile")},updateWorkspaceFolders:(ie,fe,...Fe)=>ot.updateWorkspaceFolders(Te,ie,fe||0,...Fe),onDidChangeWorkspaceFolders:function(ie,fe,Fe){return ot.onDidChangeWorkspace(ie,fe,Fe)},asRelativePath:(ie,fe)=>ot.getRelativePath(ie,fe),findFiles:(ie,fe,Fe,rt)=>ot.findFiles(ie,fe,Fe,Te.identifier,rt),findTextInFiles:(ie,fe,Fe,rt)=>{(0,Ne.$vF)(Te,"findTextInFiles");let pt,Lt;return typeof fe=="object"?(pt=fe,Lt=Fe):(pt={},Lt=fe,rt=Fe),ot.findTextInFiles(ie,pt||{},Lt,Te.identifier,rt)},save:ie=>((0,Ne.$vF)(Te,"saveEditor"),ot.save(ie)),saveAs:ie=>((0,Ne.$vF)(Te,"saveEditor"),ot.saveAs(ie)),saveAll:ie=>ot.saveAll(ie),applyEdit(ie,fe){return nn.applyWorkspaceEdit(ie,Te,fe)},createFileSystemWatcher:(ie,fe,Fe,rt)=>{let pt;return typeof fe=="boolean"?pt={ignoreCreateEvents:!!fe,ignoreChangeEvents:!!Fe,ignoreDeleteEvents:!!rt,correlate:!1}:fe&&((0,Ne.$vF)(Te,"createFileSystemWatcher"),pt={...fe,correlate:!0}),Yt.createFileSystemWatcher(ot,Te,ie,pt)},get textDocuments(){return It.getAllDocumentData().map(ie=>ie.document)},set textDocuments(ie){throw new L.$8("textDocuments")},openTextDocument(ie){let fe;const Fe=ie;if(typeof ie=="string")fe=Promise.resolve(R.URI.file(ie));else if(R.URI.isUri(ie))fe=Promise.resolve(ie);else if(!Fe||typeof Fe=="object")fe=It.createDocumentData(Fe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return fe.then(rt=>It.ensureDocumentData(rt).then(pt=>pt.document))},onDidOpenTextDocument:(ie,fe,Fe)=>It.onDidAddDocument(ie,fe,Fe),onDidCloseTextDocument:(ie,fe,Fe)=>It.onDidRemoveDocument(ie,fe,Fe),onDidChangeTextDocument:(ie,fe,Fe)=>It.onDidChangeDocument(ie,fe,Fe),onDidSaveTextDocument:(ie,fe,Fe)=>It.onDidSaveDocument(ie,fe,Fe),onWillSaveTextDocument:(ie,fe,Fe)=>ri.getOnWillSaveTextDocumentEvent(Te)(ie,fe,Fe),get notebookDocuments(){return yt.notebookDocuments.map(ie=>ie.apiNotebook)},async openNotebookDocument(ie,fe){let Fe;if(R.URI.isUri(ie))Fe=ie,await yt.openNotebookDocument(ie);else if(typeof ie=="string")Fe=R.URI.revive(await yt.createNotebookDocument({viewType:ie,content:fe}));else throw new Error("Invalid arguments");return yt.getNotebookDocument(Fe).apiNotebook},onDidSaveNotebookDocument(ie,fe,Fe){return pi.onDidSaveNotebookDocument(ie,fe,Fe)},onDidChangeNotebookDocument(ie,fe,Fe){return pi.onDidChangeNotebookDocument(ie,fe,Fe)},onWillSaveNotebookDocument(ie,fe,Fe){return Ci.getOnWillSaveNotebookDocumentEvent(Te)(ie,fe,Fe)},get onDidOpenNotebookDocument(){return yt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return yt.onDidCloseNotebookDocument},registerNotebookSerializer(ie,fe,Fe,rt){return yt.registerNotebookSerializer(Te,ie,fe,Fe,(0,Ne.$uF)(Te,"notebookLiveShare")?rt:void 0)},onDidChangeConfiguration:(ie,fe,Fe)=>on.onDidChangeConfiguration(ie,fe,Fe),getConfiguration(ie,fe){return fe=arguments.length===1?void 0:fe,on.getConfiguration(ie,fe,Te)},registerTextDocumentContentProvider(ie,fe){return gn.registerTextDocumentContentProvider(ie,fe)},registerTaskProvider:(ie,fe)=>(Me.report("window.registerTaskProvider",Te,"Use the corresponding function on the 'tasks' namespace instead"),St.registerTaskProvider(Te,ie,fe)),registerFileSystemProvider(ie,fe,Fe){return(0,Be.$Oc)(Ai.registerFileSystemProvider(Te,ie,fe,Fe),qt.addFileSystemProvider(ie,fe,Fe))},get fs(){return qt.value},registerFileSearchProvider:(ie,fe)=>((0,Ne.$vF)(Te,"fileSearchProvider"),ui.registerFileSearchProvider(ie,fe)),registerTextSearchProvider:(ie,fe)=>((0,Ne.$vF)(Te,"textSearchProvider"),ui.registerTextSearchProvider(ie,fe)),registerRemoteAuthorityResolver:(ie,fe)=>((0,Ne.$vF)(Te,"resolvers"),Rt.registerRemoteAuthorityResolver(ie,fe)),registerResourceLabelFormatter:ie=>((0,Ne.$vF)(Te,"resolvers"),Zi.$registerResourceLabelFormatter(ie)),getRemoteExecServer:ie=>((0,Ne.$vF)(Te,"resolvers"),Rt.getRemoteExecServer(ie)),onDidCreateFiles:(ie,fe,Fe)=>Yt.onDidCreateFile(ie,fe,Fe),onDidDeleteFiles:(ie,fe,Fe)=>Yt.onDidDeleteFile(ie,fe,Fe),onDidRenameFiles:(ie,fe,Fe)=>Yt.onDidRenameFile(ie,fe,Fe),onWillCreateFiles:(ie,fe,Fe)=>Yt.getOnWillCreateFileEvent(Te)(ie,fe,Fe),onWillDeleteFiles:(ie,fe,Fe)=>Yt.getOnWillDeleteFileEvent(Te)(ie,fe,Fe),onWillRenameFiles:(ie,fe,Fe)=>Yt.getOnWillRenameFileEvent(Te)(ie,fe,Fe),openTunnel:ie=>((0,Ne.$vF)(Te,"tunnels"),K.openTunnel(Te,ie).then(fe=>{if(!fe)throw new Error("cannot open tunnel");return fe})),get tunnels(){return(0,Ne.$vF)(Te,"tunnels"),K.getTunnels()},onDidChangeTunnels:(ie,fe,Fe)=>((0,Ne.$vF)(Te,"tunnels"),K.onDidChangeTunnels(ie,fe,Fe)),registerPortAttributesProvider:(ie,fe)=>((0,Ne.$vF)(Te,"portsAttributes"),K.registerPortsAttributesProvider(ie,fe)),registerTunnelProvider:(ie,fe)=>((0,Ne.$vF)(Te,"tunnelFactory"),K.registerTunnelProvider(ie,fe)),registerTimelineProvider:(ie,fe)=>((0,Ne.$vF)(Te,"timeline"),mn.registerTimelineProvider(ie,fe,Te.identifier,gt.converter)),get isTrusted(){return ot.trusted},requestWorkspaceTrust:ie=>((0,Ne.$vF)(Te,"workspaceTrust"),ot.requestWorkspaceTrust(ie)),onDidGrantWorkspaceTrust:(ie,fe,Fe)=>ot.onDidGrantWorkspaceTrust(ie,fe,Fe),registerEditSessionIdentityProvider:(ie,fe)=>((0,Ne.$vF)(Te,"editSessionIdentityProvider"),ot.registerEditSessionIdentityProvider(ie,fe)),onWillCreateEditSessionIdentity:(ie,fe,Fe)=>((0,Ne.$vF)(Te,"editSessionIdentityProvider"),ot.getOnWillCreateEditSessionIdentityEvent(Te)(ie,fe,Fe)),registerCanonicalUriProvider:(ie,fe)=>((0,Ne.$vF)(Te,"canonicalUriProvider"),ot.registerCanonicalUriProvider(ie,fe)),getCanonicalUri:(ie,fe,Fe)=>((0,Ne.$vF)(Te,"canonicalUriProvider"),ot.provideCanonicalUri(ie,fe,Fe))},Wi={get inputBox(){return Me.report("scm.inputBox",Te,"Use 'SourceControl.inputBox' instead"),Ri.getLastInputBox(Te)},createSourceControl(ie,fe,Fe){return Ri.createSourceControl(Te,ie,fe,Fe)}},Vi={createCommentController(ie,fe){return Xi.createCommentController(Te,ie,fe)}},ci={get activeDebugSession(){return ft.activeDebugSession},get activeDebugConsole(){return ft.activeDebugConsole},get breakpoints(){return ft.breakpoints},get stackFrameFocus(){return ft.stackFrameFocus},onDidStartDebugSession(ie,fe,Fe){return ft.onDidStartDebugSession(ie,fe,Fe)},onDidTerminateDebugSession(ie,fe,Fe){return ft.onDidTerminateDebugSession(ie,fe,Fe)},onDidChangeActiveDebugSession(ie,fe,Fe){return ft.onDidChangeActiveDebugSession(ie,fe,Fe)},onDidReceiveDebugSessionCustomEvent(ie,fe,Fe){return ft.onDidReceiveDebugSessionCustomEvent(ie,fe,Fe)},onDidChangeBreakpoints(ie,fe,Fe){return ft.onDidChangeBreakpoints(ie,fe,Fe)},onDidChangeStackFrameFocus(ie,fe,Fe){return(0,Ne.$vF)(Te,"debugFocus"),ft.onDidChangeStackFrameFocus(ie,fe,Fe)},registerDebugConfigurationProvider(ie,fe,Fe){return ft.registerDebugConfigurationProvider(ie,fe,Fe||Xe.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ie,fe){return ft.registerDebugAdapterDescriptorFactory(Te,ie,fe)},registerDebugAdapterTrackerFactory(ie,fe){return ft.registerDebugAdapterTrackerFactory(ie,fe)},startDebugging(ie,fe,Fe){return!Fe||typeof Fe=="object"&&"configuration"in Fe?ft.startDebugging(ie,fe,{parentSession:Fe}):ft.startDebugging(ie,fe,Fe||{})},stopDebugging(ie){return ft.stopDebugging(ie)},addBreakpoints(ie){return ft.addBreakpoints(ie)},removeBreakpoints(ie){return ft.removeBreakpoints(ie)},asDebugSourceUri(ie,fe){return ft.asDebugSourceUri(ie,fe)}},qi={registerTaskProvider:(ie,fe)=>St.registerTaskProvider(Te,ie,fe),fetchTasks:ie=>St.fetchTasks(ie),executeTask:ie=>St.executeTask(Te,ie),get taskExecutions(){return St.taskExecutions},onDidStartTask:(ie,fe,Fe)=>St.onDidStartTask(ie,fe,Fe),onDidEndTask:(ie,fe,Fe)=>St.onDidEndTask(ie,fe,Fe),onDidStartTaskProcess:(ie,fe,Fe)=>St.onDidStartTaskProcess(ie,fe,Fe),onDidEndTaskProcess:(ie,fe,Fe)=>St.onDidEndTaskProcess(ie,fe,Fe)},Ki={createNotebookController(ie,fe,Fe,rt,pt){return si.createNotebookController(Te,ie,fe,Fe,rt,(0,Ne.$uF)(Te,"notebookMessaging")?pt:void 0)},registerNotebookCellStatusBarItemProvider:(ie,fe)=>yt.registerNotebookCellStatusBarItemProvider(Te,ie,fe),createRendererMessaging(ie){return Ii.createRendererMessaging(Te,ie)},createNotebookControllerDetectionTask(ie){return(0,Ne.$vF)(Te,"notebookKernelSource"),si.createNotebookControllerDetectionTask(Te,ie)},registerKernelSourceActionProvider(ie,fe){return(0,Ne.$vF)(Te,"notebookKernelSource"),si.registerKernelSourceActionProvider(Te,ie,fe)},onDidChangeNotebookCellExecutionState(ie,fe,Fe){return(0,Ne.$vF)(Te,"notebookCellExecutionState"),si.onDidChangeNotebookCellExecutionState(ie,fe,Fe)}},Hi={t(...ie){if(typeof ie[0]=="string"){const fe=ie.shift(),Fe=!ie||typeof ie[0]!="object"?ie:ie[0];return li.getMessage(Te.identifier.value,{message:fe,args:Fe})}return li.getMessage(Te.identifier.value,ie[0])},get bundle(){return li.getBundle(Te.identifier.value)},get uri(){return li.getBundleUri(Te.identifier.value)}},Gi={_version:1,registerInteractiveEditorSessionProvider(ie,fe){return(0,Ne.$vF)(Te,"interactive"),xi.registerProvider(Te,ie,fe={label:fe?.label??Te.displayName??Te.name})},registerInteractiveSessionProvider(ie,fe){return(0,Ne.$vF)(Te,"interactive"),mi.registerChatProvider(Te,ie,fe)},sendInteractiveRequestToProvider(ie,fe){return(0,Ne.$vF)(Te,"interactive"),mi.sendInteractiveRequestToProvider(ie,fe)},get onDidPerformUserAction(){return(0,Ne.$vF)(Te,"interactiveUserActions"),mi.onDidPerformUserAction},transferChatSession(ie,fe){return(0,Ne.$vF)(Te,"interactive"),mi.transferChatSession(ie,fe)}},hn={getRelatedInformation(ie,fe){return(0,Ne.$vF)(Te,"aiRelatedInformation"),xt.getRelatedInformation(Te,ie,fe)},registerRelatedInformationProvider(ie,fe){return(0,Ne.$vF)(Te,"aiRelatedInformation"),xt.registerRelatedInformationProvider(Te,ie,fe)},registerEmbeddingVectorProvider(ie,fe){return(0,Ne.$vF)(Te,"aiRelatedInformation"),bi.registerEmbeddingVectorProvider(Te,ie,fe)}},dn={registerChatResponseProvider(ie,fe,Fe){return(0,Ne.$vF)(Te,"chatProvider"),gi.registerProvider(Te.identifier,ie,fe,Fe)},requestChatAccess(ie){return(0,Ne.$vF)(Te,"chatRequestAccess"),gi.requestChatResponseProvider(Te.identifier,ie)},registerVariable(ie,fe,Fe){return(0,Ne.$vF)(Te,"chatVariables"),Ui.registerVariableResolver(Te,ie,fe,Fe)},registerMappedEditsProvider(ie,fe){return(0,Ne.$vF)(Te,"mappedEditsProvider"),ct.registerMappedEditsProvider(Te,ie,fe)},createChatAgent(ie,fe){return(0,Ne.$vF)(Te,"chatAgents2"),pn.createChatAgent(Te,ie,fe)},registerAgent(ie,fe,Fe){return(0,Ne.$vF)(Te,"chatAgents"),_i.registerAgent(Te.identifier,ie,fe,Fe)}},fn={registerSpeechProvider(ie,fe){return(0,Ne.$vF)(Te,"speech"),yi.registerProvider(Te.identifier,ie,fe)}};return{version:dt.version,ai:hn,authentication:ji,commands:an,comments:Vi,chat:dn,debug:ci,env:Bi,extensions:vn,interactive:Gi,l10n:Hi,languages:un,notebooks:Ki,scm:Wi,speech:fn,tasks:qi,tests:cn,window:ln,workspace:ki,Breakpoint:J.$vL,TerminalOutputAnchor:J.TerminalOutputAnchor,ChatAgentResultFeedbackKind:J.ChatAgentResultFeedbackKind,ChatMessage:J.$mM,ChatMessageRole:J.ChatMessageRole,ChatVariableLevel:J.ChatVariableLevel,CallHierarchyIncomingCall:J.$UK,CallHierarchyItem:J.$TK,CallHierarchyOutgoingCall:J.$VK,CancellationError:L.$4,CancellationTokenSource:E.$Yd,CandidatePortSource:o.CandidatePortSource,CodeAction:J.$QK,CodeActionKind:J.$RK,CodeActionTriggerKind:J.CodeActionTriggerKind,CodeLens:J.$WK,Color:J.$0K,ColorInformation:J.$$K,ColorPresentation:J.$_K,ColorThemeKind:J.ColorThemeKind,CommentMode:J.CommentMode,CommentState:J.CommentState,CommentThreadCollapsibleState:J.CommentThreadCollapsibleState,CommentThreadState:J.CommentThreadState,CompletionItem:J.$4K,CompletionItemKind:J.CompletionItemKind,CompletionItemTag:J.CompletionItemTag,CompletionList:J.$5K,CompletionTriggerKind:J.CompletionTriggerKind,ConfigurationTarget:J.ConfigurationTarget,CustomExecution:J.$hL,DebugAdapterExecutable:J.$zL,DebugAdapterInlineImplementation:J.$CL,DebugAdapterNamedPipeServer:J.$BL,DebugAdapterServer:J.$AL,DebugConfigurationProviderTriggerKind:Xe.DebugConfigurationProviderTriggerKind,DebugConsoleMode:J.DebugConsoleMode,DecorationRangeBehavior:J.DecorationRangeBehavior,Diagnostic:J.$LK,DiagnosticRelatedInformation:J.$KK,DiagnosticSeverity:J.DiagnosticSeverity,DiagnosticTag:J.DiagnosticTag,Disposable:J.$xK,DocumentHighlight:J.$NK,DocumentHighlightKind:J.DocumentHighlightKind,DocumentLink:J.$9K,DocumentSymbol:J.$PK,EndOfLine:J.EndOfLine,EnvironmentVariableMutatorType:J.EnvironmentVariableMutatorType,EvaluatableExpression:J.$FL,InlineValueText:J.$GL,InlineValueVariableLookup:J.$HL,InlineValueEvaluatableExpression:J.$IL,InlineCompletionTriggerKind:J.InlineCompletionTriggerKind,EventEmitter:P.$Od,ExtensionKind:J.ExtensionKind,ExtensionMode:J.ExtensionMode,ExternalUriOpenerPriority:J.ExternalUriOpenerPriority,FileChangeType:J.FileChangeType,FileDecoration:J.$SL,FileDecoration2:J.$SL,FileSystemError:J.$KL,FileType:S.FileType,FilePermission:S.FilePermission,FoldingRange:J.$LL,FoldingRangeKind:J.FoldingRangeKind,FunctionBreakpoint:J.$xL,InlineCompletionItem:J.$6K,InlineCompletionList:J.$7K,Hover:J.$MK,IndentAction:g.IndentAction,Location:J.$JK,MarkdownString:J.$XK,OverviewRulerLane:D.OverviewRulerLane,ParameterInformation:J.$YK,PortAutoForwardAction:J.PortAutoForwardAction,Position:J.$yK,ProcessExecution:J.$fL,ProgressLocation:J.ProgressLocation,QuickInputButtons:J.$RL,Range:J.$zK,RelativePattern:J.$tL,Selection:J.$AK,SelectionRange:J.$SK,SemanticTokens:J.$OL,SemanticTokensBuilder:J.$NL,SemanticTokensEdit:J.$PL,SemanticTokensEdits:J.$QL,SemanticTokensLegend:J.$ML,ShellExecution:J.$gL,ShellQuoting:J.ShellQuoting,SignatureHelp:J.$1K,SignatureHelpTriggerKind:J.SignatureHelpTriggerKind,SignatureInformation:J.$ZK,SnippetString:J.$IK,SourceBreakpoint:J.$wL,StandardTokenType:J.StandardTokenType,StatusBarAlignment:J.StatusBarAlignment,SymbolInformation:J.$OK,SymbolKind:J.SymbolKind,SymbolTag:J.SymbolTag,Task:J.$iL,TaskGroup:J.$eL,TaskPanelKind:J.TaskPanelKind,TaskRevealKind:J.TaskRevealKind,TaskScope:J.TaskScope,TerminalLink:J.$aL,TerminalQuickFixExecuteTerminalCommand:J.$cL,TerminalQuickFixOpener:J.$bL,TerminalLocation:J.TerminalLocation,TerminalProfile:J.$dL,TerminalExitReason:J.TerminalExitReason,TextDocumentSaveReason:J.TextDocumentSaveReason,TextEdit:J.$EK,SnippetTextEdit:J.$GK,TextEditorCursorStyle:$.TextEditorCursorStyle,TextEditorLineNumbersStyle:J.TextEditorLineNumbersStyle,TextEditorRevealType:J.TextEditorRevealType,TextEditorSelectionChangeKind:J.TextEditorSelectionChangeKind,SyntaxTokenType:J.SyntaxTokenType,TextDocumentChangeReason:J.TextDocumentChangeReason,ThemeColor:J.$sL,ThemeIcon:J.$rL,TreeItem:J.$jL,TreeItemCheckboxState:J.TreeItemCheckboxState,TreeItemCollapsibleState:J.TreeItemCollapsibleState,TypeHierarchyItem:J.$bM,UIKind:v.UIKind,Uri:R.URI,ViewColumn:J.ViewColumn,WorkspaceEdit:J.$HK,DocumentDropEdit:J.$pL,DocumentPasteEdit:J.$qL,InlayHint:J.$3K,InlayHintLabelPart:J.$2K,InlayHintKind:J.InlayHintKind,RemoteAuthorityResolverError:J.$DK,ResolvedAuthority:J.$BK,ManagedResolvedAuthority:J.$CK,SourceControlInputBoxValidationType:J.SourceControlInputBoxValidationType,ExtensionRuntime:J.ExtensionRuntime,TimelineItem:J.$3L,NotebookRange:J.$UL,NotebookCellKind:J.NotebookCellKind,NotebookCellExecutionState:J.NotebookCellExecutionState,NotebookCellData:J.$VL,NotebookData:J.$WL,NotebookRendererScript:J.$1L,NotebookCellStatusBarAlignment:J.NotebookCellStatusBarAlignment,NotebookEditorRevealType:J.NotebookEditorRevealType,NotebookCellOutput:J.$YL,NotebookCellOutputItem:J.$XL,NotebookCellStatusBarItem:J.$ZL,NotebookControllerAffinity:J.NotebookControllerAffinity,NotebookControllerAffinity2:J.NotebookControllerAffinity2,NotebookEdit:J.$FK,NotebookKernelSourceAction:J.$2L,PortAttributes:J.$5L,LinkedEditingRanges:J.$4L,TestResultState:J.TestResultState,TestRunRequest:J.$6L,TestMessage:J.$7L,TestMessage2:J.$7L,TestTag:J.$8L,TestRunProfileKind:J.TestRunProfileKind,TextSearchCompleteMessageType:it.TextSearchCompleteMessageType,DataTransfer:J.$oL,DataTransferItem:J.$kL,CoveredCount:J.$9L,FileCoverage:J.$0L,StatementCoverage:J.$$L,BranchCoverage:J.$_L,FunctionCoverage:J.$aM,WorkspaceTrustState:J.WorkspaceTrustState,LanguageStatusSeverity:J.LanguageStatusSeverity,QuickPickItemKind:J.QuickPickItemKind,InputBoxValidationSeverity:J.InputBoxValidationSeverity,TabInputText:J.$cM,TabInputTextDiff:J.$dM,TabInputTextMerge:J.$eM,TabInputCustom:J.$fM,TabInputNotebook:J.$hM,TabInputNotebookDiff:J.$iM,TabInputWebview:J.$gM,TabInputTerminal:J.$jM,TabInputInteractiveWindow:J.$kM,TabInputChat:J.$lM,TelemetryTrustedValue:ye.$no,LogLevel:te.LogLevel,EditSessionIdentityMatch:$t.EditSessionIdentityMatch,InteractiveSessionVoteDirection:J.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:J.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:J.InteractiveEditorResponseFeedbackKind,StackFrameFocus:J.$DL,ThreadFocus:J.$EL,RelatedInformationType:J.RelatedInformationType,SpeechToTextStatus:J.SpeechToTextStatus}}}e.$8ec=Nt}),define(Ae[293],Re([1,0,71,112,35,110,36,32,62,65,115,117,118,85,87,81,111,64,42,84,61,63,258,15,116,82,83]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f,t,i,n,u,a,l,r,s,c,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,E.$Ar)(h.$Gdc,h.$Fdc,1),(0,E.$Ar)(s.$cj,r.$9ec,1),(0,E.$Ar)(f.$6cc,f.$7cc,1),(0,E.$Ar)($.$TM,$.$SM,0),(0,E.$Ar)(R.$gdc,R.$edc,0),(0,E.$Ar)(i.$vdc,i.$udc,0),(0,E.$Ar)(S.$jec,S.$nec,0),(0,E.$Ar)(M.$bec,M.$aec,0),(0,E.$Ar)(D.$IM,D.$HM,0),(0,E.$Ar)(w.$Hdc,w.$Idc,0),(0,E.$Ar)(n.$3cc,n.$2cc,0),(0,E.$Ar)(L.$Tdc,L.$Sdc,1),(0,E.$Ar)(o.$tec,o.$uec,0),(0,E.$Ar)(v.$rdc,v.$qdc,0),(0,E.$Ar)(A.$eec,A.$dec,0),(0,E.$Ar)(g.$ydc,g.$Bdc,0),(0,E.$Ar)(p.$Iwb,p.$Jwb,0),(0,E.$Ar)(t.$0dc,t.$9dc,0),(0,E.$Ar)(P.$ddc,P.$cdc,0),(0,E.$Ar)(u.$Ddc,u.$Cdc,0),(0,E.$Ar)(a.$RM,a.$OM,0),(0,E.$Ar)(l.$fec,l.$gec,0),(0,E.$Ar)(c.$hec,c.$iec,0)}),define(Ae[294],Re([1,0,292,37,2,289,7,12,277]),function(pe,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ghc=void 0;class g extends M.$_ec{j(){}getModule(v,p){for(const f of this.b){const t=f(v);if(t){v=t;break}}if(this.a.has(v))return this.a.get(v).load(v,p,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class A extends L.$Kdc{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Webworker}async tb(){this.h.createInstance(D.$fhc);const v=this.h.invokeFunction(E.$8ec);this.r=this.h.createInstance(g,v,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.zb()}ub(v){return v.browser}async vb(v,p,f){p=p.with({path:S(p.path,".js")});const t=v?.identifier.value;t&&performance.mark(`code/extHost/willFetchExtensionCode/${t}`);const i=P.URI.revive(await this.C.$asBrowserUri(p)),n=await fetch(i.toString(!0));if(t&&performance.mark(`code/extHost/didFetchExtensionCode/${t}`),n.status!==200)throw new Error(n.statusText);const u=await n.text(),a=`${p.toString(!0)}#vscode-extension`,l=`${u}
//# sourceURL=${a}`;let r;try{r=new Function("module","exports","require",l)}catch(w){throw console.error(t?`Loading code for extension ${t} failed: ${w.message}`:`Loading code failed: ${w.message}`),console.error(`${p.toString(!0)}${typeof w.line=="number"?` line ${w.line}`:""}${typeof w.column=="number"?` column ${w.column}`:""}`),console.error(w),w}v&&await this.w.initializeLocalizedMessages(v);const s={},c={exports:s},h=w=>{const m=this.r.getModule(w,p);if(m===void 0)throw new Error(`Cannot load module '${w}'`);return m};try{return f.codeLoadingStart(),t&&performance.mark(`code/extHost/willLoadExtensionCode/${t}`),r(c,s,h),c.exports!==s?c.exports:s}finally{t&&performance.mark(`code/extHost/didLoadExtensionCode/${t}`),f.codeLoadingStop()}}async $setRemoteEnvironment(v){}async zb(v=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const p=Date.now()+v;for(;Date.now()<p&&!("__jsDebugIsReady"in globalThis);)await(0,$.$Vg)(10)}}e.$ghc=A;function S(o,v){return o.endsWith(v)?o:o+v}}),define(Ae[295],Re([1,0,70,71,15,37,201,86,294]),function(pe,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,L.$Ar)(P.$bj,new E.$Qh(R.$$ec,[!0],!0)),(0,L.$Ar)(M.$Ldc,D.$ghc,0),(0,L.$Ar)($.$wdc,$.$xdc,0)}),define(Ae[301],Re([1,0,24,5,79,290,279,19,88,14,2,293,295]),function(pe,e,E,L,P,M,R,$,D,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const S=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const o=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function v(r){return/^(file|vscode-remote):/i.test(r)}const p=fetch.bind(self);function f(r){self.fetch=async function(s,c){return s instanceof Request||v(String(s))&&(s=(await r(A.URI.parse(String(s)))).toString(!0)),p(s,c)},self.XMLHttpRequest=class extends XMLHttpRequest{open(s,c,h,w,m){(async()=>(v(c.toString())&&(c=(await r(A.URI.parse(c.toString()))).toString(!0)),super.open(s,c,h??!0,w,m)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const r=self.Worker;Worker=function(s,c){if(/^file:/i.test(s.toString()))s=g.$dg.uriToBrowserUri(A.URI.parse(s.toString())).toString(!0);else if(/^vscode-remote:/i.test(s.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const w=`(${function(d){function b(B){return typeof B=="string"||B instanceof URL?String(B).replace(/^file:\/\//i,"vscode-file://vscode-app"):B}const y=fetch.bind(self);self.fetch=function(B,H){return B instanceof Request?y(B,H):y(b(B),H)},self.XMLHttpRequest=class extends XMLHttpRequest{open(B,H,U,z,F){return super.open(B,b(H),U??!0,z,F)}};const C=importScripts.bind(self);self.importScripts=(...B)=>{C(...B.map(b))},C(d)}.toString()}('${s}'))`;c=c||{},c.name=c.name||$.$mc(s.toString());const m=new Blob([w],{type:"application/javascript"}),I=URL.createObjectURL(m);return new r(I,c)}}else self.Worker=class extends R.$hhc{constructor(r,s){super(o,r,{name:$.$mc(r.toString()),...s})}};const t=new class{constructor(){this.pid=void 0}exit(r){S()}};class i{constructor(){const s=new MessageChannel,c=new L.$Od;let h=!1;o(s.port2,[s.port2]),s.port1.onmessage=w=>{const{data:m}=w;if(!(m instanceof ArrayBuffer)){console.warn("UNKNOWN data received",m);return}const I=E.$ce.wrap(new Uint8Array(m,0,m.byteLength));if((0,P.$gm)(I,2)){h=!0,u("received terminate message from renderer");return}c.fire(I)},this.protocol={onMessage:c.event,send:w=>{if(!h){const m=w.buffer.buffer.slice(w.buffer.byteOffset,w.buffer.byteOffset+w.buffer.byteLength);s.port1.postMessage(m,[m])}}}}}function n(r){return new Promise(s=>{const c=r.onMessage(h=>{c.dispose();const w=JSON.parse(h.toString());r.send((0,P.$fm)(0)),s({protocol:r,initData:w})});r.send((0,P.$fm)(1))})}let u=r=>S();function a(r){return!!r&&typeof r=="object"&&r.type==="vscode.init"&&r.data instanceof Map}function l(){D.mark("code/extHost/willConnectToRenderer");const r=new i;return{onmessage(s){a(s)&&n(r.protocol).then(c=>{D.mark("code/extHost/didWaitForInitData");const h=new M.$bfc(c.protocol,c.initData,t,null,s.data);f(w=>h.asBrowserUri(w)),u=w=>h.terminate(w)})}}}e.create=l})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/072c6b950b8822560c55eff1474c30951e2ab9c9/core/vs/workbench/api/worker/extensionHostWorker.js.map
