/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var p=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/errors","vs/editor/common/tokens/lineTokens","vs/base/common/uri","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/base/common/observable","vs/base/common/buffer","vs/editor/common/core/eolCounter","vs/editor/common/encodedTokenAttributes","vs/editor/common/core/lineRange","vs/editor/common/tokens/contiguousMultilineTokensBuilder","vs/base/common/network","vs/base/common/resources","vs/base/common/async","vs/editor/common/languages/nullTokenize","vs/base/common/amd","vs/base/common/observableInternal/utils","vs/base/common/stream","vs/base/common/symbols","vs/editor/common/model/fixedArray","vs/base/common/arrays","vs/editor/common/tokens/contiguousTokensEditing","vs/editor/common/tokens/contiguousMultilineTokens","vs/base/common/extpath","vs/base/common/path","vs/base/common/strings","vs/amdX","vs/base/common/event","vs/editor/common/languages","vs/editor/common/model/textModelTokens","vs/base/common/stopwatch","vs/workbench/services/textMate/browser/tokenizationSupport/textMateTokenizationSupport","vs/workbench/services/textMate/browser/tokenizationSupport/tokenizationSupportWithLineLimit","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateWorkerTokenizer","vs/workbench/services/textMate/common/TMScopeRegistry","vs/workbench/services/textMate/common/TMGrammarFactory","vs/base/common/assert","vs/base/common/lazy","vs/editor/common/core/position","vs/base/common/types","vs/base/common/cancellation","vs/editor/common/core/offsetRange","vs/editor/common/model/mirrorTextModel","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker"],_=function(z){for(var e=[],P=0,k=z.length;P<k;P++)e[P]=p[z[P]];return e};define(p[21],_([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=e.$S=void 0,e.$S=!1;class P{static get(){const y=new Map,A=new Map,s=new Map,l=new Map;function t(d,n){d.has(n.detail)||d.set(n.detail,-n.timestamp)}function r(d,n){const i=d.get(n.detail);i&&(i>=0||d.set(n.detail,i+n.timestamp))}let o=[];typeof z=="function"&&typeof z.getStats=="function"&&(o=z.getStats().slice(0).sort((d,n)=>d.timestamp-n.timestamp));for(const d of o)switch(d.type){case 10:t(y,d);break;case 11:case 12:r(y,d);break;case 21:t(A,d);break;case 22:r(A,d);break;case 33:t(s,d);break;case 34:r(s,d);break;case 31:t(l,d);break;case 32:r(l,d);break}let u=0;s.forEach(d=>u+=d);function f(d){const n=[];return d.forEach((i,h)=>n.push([h,i])),n}return{amdLoad:f(y),amdInvoke:f(A),nodeRequire:f(s),nodeEval:f(l),nodeRequireTotal:u}}static toMarkdownTable(y,A){let s="";const l=[];return y.forEach((t,r)=>{l[r]=t.length}),A.forEach(t=>{t.forEach((r,o)=>{typeof r>"u"&&(r=t[o]="-");const u=r.toString().length;l[o]=Math.max(u,l[o])})}),y.forEach((t,r)=>{s+=`| ${t+" ".repeat(l[r]-t.toString().length)} `}),s+=`|
`,y.forEach((t,r)=>{s+=`| ${"-".repeat(l[r])} `}),s+=`|
`,A.forEach(t=>{t.forEach((r,o)=>{typeof r<"u"&&(s+=`| ${r+" ".repeat(l[o]-r.toString().length)} `)}),s+=`|
`}),s}}e.$T=P}),define(p[4],_([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qd=e.$pd=e.$od=void 0;let P;function k(i){P=i}e.$od=k;function y(){return P}e.$pd=y;class A{constructor(){this.a=0,this.d=new WeakMap}b(h){return s([l(d("|  ",this.a)),h])}c(h){return h.hadValue?h.didChange?[l(" "),r(o(h.oldValue,70),{color:"red",strikeThrough:!0}),l(" "),r(o(h.newValue,60),{color:"green"})]:[l(" (unchanged)")]:[l(" "),r(o(h.newValue,60),{color:"green"}),l(" (initial)")]}handleObservableChanged(h,w){console.log(...this.b([t("observable value changed"),r(h.debugName,{color:"BlueViolet"}),...this.c(w)]))}formatChanges(h){if(h.size!==0)return r(" (changed deps: "+[...h].map(w=>w.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(h){const w=h.handleChange;this.d.set(h,new Set),h.handleChange=(C,B)=>(this.d.get(h).add(C),w.apply(h,[C,B]))}handleDerivedRecomputed(h,w){const C=this.d.get(h);console.log(...this.b([t("derived recomputed"),r(h.debugName,{color:"BlueViolet"}),...this.c(w),this.formatChanges(C),{data:[{fn:h._computeFn}]}])),C.clear()}handleFromEventObservableTriggered(h,w){console.log(...this.b([t("observable from event triggered"),r(h.debugName,{color:"BlueViolet"}),...this.c(w),{data:[{fn:h._getValue}]}]))}handleAutorunCreated(h){const w=h.handleChange;this.d.set(h,new Set),h.handleChange=(C,B)=>(this.d.get(h).add(C),w.apply(h,[C,B]))}handleAutorunTriggered(h){const w=this.d.get(h);console.log(...this.b([t("autorun"),r(h.debugName,{color:"BlueViolet"}),this.formatChanges(w),{data:[{fn:h._runFn}]}])),w.clear(),this.a++}handleAutorunFinished(h){this.a--}handleBeginTransaction(h){let w=h.getDebugName();w===void 0&&(w=""),console.log(...this.b([t("transaction"),r(w,{color:"BlueViolet"}),{data:[{fn:h._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$qd=A;function s(i){const h=new Array,w=[];let C="";function B(S){if("length"in S)for(const $ of S)$&&B($);else"text"in S?(C+=`%c${S.text}`,h.push(S.style),S.data&&w.push(...S.data)):"data"in S&&w.push(...S.data)}B(i);const F=[C,...h];return F.push(...w),F}function l(i){return r(i,{color:"black"})}function t(i){return r(n(`${i}: `,10),{color:"black",bold:!0})}function r(i,h={color:"black"}){function w(B){return Object.entries(B).reduce((F,[S,$])=>`${F}${S}:${$};`,"")}const C={color:h.color};return h.strikeThrough&&(C["text-decoration"]="line-through"),h.bold&&(C["font-weight"]="bold"),{text:i,style:w(C)}}function o(i,h){switch(typeof i){case"number":return""+i;case"string":return i.length+2<=h?`"${i}"`:`"${i.substr(0,h-7)}"+...`;case"boolean":return i?"true":"false";case"undefined":return"undefined";case"object":return i===null?"null":Array.isArray(i)?u(i,h):f(i,h);case"symbol":return i.toString();case"function":return`[[Function${i.name?" "+i.name:""}]]`;default:return""+i}}function u(i,h){let w="[ ",C=!0;for(const B of i){if(C||(w+=", "),w.length-5>h){w+="...";break}C=!1,w+=`${o(B,h-w.length)}`}return w+=" ]",w}function f(i,h){let w="{ ",C=!0;for(const[B,F]of Object.entries(i)){if(C||(w+=", "),w.length-5>h){w+="...";break}C=!1,w+=`${B}: ${o(F,h-w.length)}`}return w+=" }",w}function d(i,h){let w="";for(let C=1;C<=h;C++)w+=i;return w}function n(i,h){for(;i.length<h;)i+=" ";return i}}),define(p[5],_([0,1,4]),function(z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jd=e.$Id=e.$Hd=e.$Gd=e.$Fd=e.$Ed=e.$Dd=e.$Cd=e.$Bd=e.$Ad=e.$zd=e.$yd=e.$xd=e.$wd=void 0;let k;function y(L){k=L}e.$wd=y;class A{get TChange(){return null}reportChanges(){this.get()}read(a){return a?a.readObservable(this):this.get()}map(a,m){const N=m===void 0?void 0:a,U=m===void 0?a:m;return k({owner:N,debugName:()=>{const T=S(U);if(T!==void 0)return T;const j=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(U.toString());if(j)return`${this.debugName}.${j[2]}`;if(!N)return`${this.debugName} (mapped)`}},T=>U(this.read(T),T))}}e.$xd=A;class s extends A{constructor(){super(...arguments),this.c=new Set}addObserver(a){const m=this.c.size;this.c.add(a),m===0&&this.f()}removeObserver(a){this.c.delete(a)&&this.c.size===0&&this.g()}f(){}g(){}}e.$yd=s;function l(L,a){const m=new f(L,a);try{L(m)}finally{m.finish()}}e.$zd=l;let t;function r(L){if(t)L(t);else{const a=new f(L,void 0);t=a;try{L(a)}finally{a.finish(),t=void 0}}}e.$Ad=r;async function o(L,a){const m=new f(L,a);try{await L(m)}finally{m.finish()}}e.$Bd=o;function u(L,a,m){L?a(L):l(a,m)}e.$Cd=u;class f{constructor(a,m){this._fn=a,this.b=m,this.a=[],(0,P.$pd)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():S(this._fn)}updateObserver(a,m){this.a.push({observer:a,observable:m}),a.beginUpdate(m)}finish(){const a=this.a;for(let m=0;m<a.length;m++){const{observer:N,observable:U}=a[m];N.endUpdate(U)}this.a=null,(0,P.$pd)()?.handleEndTransaction()}}e.$Dd=f;const d=new Map,n=new WeakMap;function i(L,a,m,N,U){const T=n.get(L);if(T)return T;const g=h(L,a,m,N,U);if(g){let j=d.get(g)??0;j++,d.set(g,j);const q=j===1?g:`${g}#${j}`;return n.set(L,q),q}}e.$Ed=i;function h(L,a,m,N,U){const T=n.get(L);if(T)return T;const g=N?B(N)+".":"";let j;if(a!==void 0)if(typeof a=="function"){if(j=a(),j!==void 0)return g+j}else return g+a;if(m!==void 0&&(j=S(m),j!==void 0))return g+j;if(N!==void 0){for(const q in N)if(N[q]===U)return g+q}}const w=new Map,C=new WeakMap;function B(L){const a=C.get(L);if(a)return a;const m=F(L);let N=w.get(m)??0;N++,w.set(m,N);const U=N===1?m:`${m}#${N}`;return C.set(L,U),U}function F(L){const a=L.constructor;return a?a.name:"Object"}function S(L){const a=L.toString(),N=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(a);return(N?N[1]:void 0)?.trim()}e.$Fd=S;function $(L,a){return typeof L=="string"?new E(void 0,L,a):new E(L,void 0,a)}e.$Gd=$;class E extends s{get debugName(){return i(this,this.d,void 0,this.b,this)??"ObservableValue"}constructor(a,m,N){super(),this.b=a,this.d=m,this.a=N}get(){return this.a}set(a,m,N){if(this.a===a)return;let U;m||(m=U=new f(()=>{},()=>`Setting ${this.debugName}`));try{const T=this.a;this.e(a),(0,P.$pd)()?.handleObservableChanged(this,{oldValue:T,newValue:a,change:N,didChange:!0,hadValue:!0});for(const g of this.c)m.updateObserver(g,this),g.handleChange(this,N)}finally{U&&U.finish()}}toString(){return`${this.debugName}: ${this.a}`}e(a){this.a=a}}e.$Hd=E;function b(L,a){return typeof L=="string"?new O(void 0,L,a):new O(L,void 0,a)}e.$Id=b;class O extends E{e(a){this.a!==a&&(this.a&&this.a.dispose(),this.a=a)}dispose(){this.a?.dispose()}}e.$Jd=O}),define(p[9],_([0,1,42,2,5,4]),function(z,e,P,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=e.$_c=e.$$c=e.$0c=e.$9c=e.$8c=e.$7c=void 0;function s(n,i){return new f(n.debugName,i,void 0,void 0)}e.$7c=s;function l(n){return new f(void 0,n,void 0,void 0)}e.$8c=l;function t(n,i){return new f(n.debugName,i,n.createEmptyChangeSummary,n.handleChange)}e.$9c=t;function r(n,i){const h=new k.$Qc,w=t({debugName:n.debugName??(()=>(0,y.$Fd)(i)),createEmptyChangeSummary:n.createEmptyChangeSummary,handleChange:n.handleChange},(C,B)=>{h.clear(),i(C,B,h)});return(0,k.$Pc)(()=>{w.dispose(),h.dispose()})}e.$0c=r;function o(n){const i=new k.$Qc,h=s({debugName:()=>(0,y.$Fd)(n)||"(anonymous)"},w=>{i.clear(),n(w,i)});return(0,k.$Pc)(()=>{h.dispose(),i.dispose()})}e.$$c=o;var u;(function(n){n[n.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",n[n.stale=2]="stale",n[n.upToDate=3]="upToDate"})(u||(u={}));class f{get debugName(){if(typeof this.h=="string")return this.h;if(typeof this.h=="function"){const h=this.h();if(h!==void 0)return h}const i=(0,y.$Fd)(this._runFn);return i!==void 0?i:"(anonymous)"}constructor(i,h,w,C){this.h=i,this._runFn=h,this.i=w,this.j=C,this.a=2,this.b=0,this.c=!1,this.e=new Set,this.f=new Set,this.g=this.i?.(),(0,A.$pd)()?.handleAutorunCreated(this),this.k(),(0,k.$Ic)(this)}dispose(){this.c=!0;for(const i of this.e)i.removeObserver(this);this.e.clear(),(0,k.$Jc)(this)}k(){if(this.a===3)return;const i=this.f;this.f=this.e,this.e=i,this.a=3;const h=this.c;try{if(!h){(0,A.$pd)()?.handleAutorunTriggered(this);const w=this.g;this.g=this.i?.(),this._runFn(this,w)}}finally{h||(0,A.$pd)()?.handleAutorunFinished(this);for(const w of this.f)w.removeObserver(this);this.f.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.a===3&&(this.a=1),this.b++}endUpdate(){if(this.b===1)do{if(this.a===1){this.a=3;for(const i of this.e)if(i.reportChanges(),this.a===2)break}this.k()}while(this.a!==3);this.b--,(0,P.$5c)(()=>this.b>=0)}handlePossibleChange(i){this.a===3&&this.e.has(i)&&!this.f.has(i)&&(this.a=1)}handleChange(i,h){this.e.has(i)&&!this.f.has(i)&&(!this.j||this.j({changedObservable:i,change:h,didChange:C=>C===i},this.g))&&(this.a=2)}readObservable(i){if(this.c)return i.get();i.addObserver(this);const h=i.get();return this.e.add(i),this.f.delete(i),h}}e.$_c=f,function(n){n.Observer=f}(l||(e.$8c=l={}));function d(n,i){let h;return s({debugName:()=>(0,y.$Fd)(i)},w=>{const C=n.read(w),B=h;h=C,i({lastValue:B,newValue:C})})}e.$ad=d}),define(p[10],_([0,1,6,2,5,4]),function(z,e,P,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vd=e.$ud=e.$td=e.$sd=e.$rd=void 0;const s=(d,n)=>d===n;function l(d,n){return n!==void 0?new f(d,void 0,n,void 0,void 0,void 0,s):new f(void 0,void 0,d,void 0,void 0,void 0,s)}e.$rd=l;function t(d,n){return new f(d.owner,d.debugName,n,void 0,void 0,void 0,d.equalityComparer??s)}e.$sd=t;function r(d,n){return new f(d.owner,d.debugName,n,d.createEmptyChangeSummary,d.handleChange,void 0,d.equalityComparer??s)}e.$td=r;function o(d,n){let i,h;n===void 0?(i=d,h=void 0):(h=d,i=n);const w=new k.$Qc;return new f(h,()=>(0,y.$Fd)(i)??"(anonymous)",C=>(w.clear(),i(C,w)),void 0,void 0,()=>w.dispose(),s)}e.$ud=o,(0,y.$wd)(t);var u;(function(d){d[d.initial=0]="initial",d[d.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",d[d.stale=2]="stale",d[d.upToDate=3]="upToDate"})(u||(u={}));class f extends y.$yd{get debugName(){return(0,y.$Ed)(this,this.p,this._computeFn,this.n,this)??"(anonymous)"}constructor(n,i,h,w,C,B=void 0,F){super(),this.n=n,this.p=i,this._computeFn=h,this.q=w,this.s=C,this.t=B,this.u=F,this.e=0,this.h=void 0,this.j=0,this.k=new Set,this.l=new Set,this.m=void 0,this.m=this.q?.(),(0,A.$pd)()?.handleDerivedCreated(this)}g(){this.e=0,this.h=void 0;for(const n of this.k)n.removeObserver(this);this.k.clear(),this.t?.()}get(){if(this.c.size===0){const n=this._computeFn(this,this.q?.());return this.g(),n}else{do{if(this.e===1){for(const n of this.k)if(n.reportChanges(),this.e===2)break}this.e===1&&(this.e=3),this.w()}while(this.e!==3);return this.h}}w(){if(this.e===3)return;const n=this.l;this.l=this.k,this.k=n;const i=this.e!==0,h=this.h;this.e=3;const w=this.m;this.m=this.q?.();try{this.h=this._computeFn(this,w)}finally{for(const B of this.l)B.removeObserver(this);this.l.clear()}const C=i&&!this.u(h,this.h);if((0,A.$pd)()?.handleDerivedRecomputed(this,{oldValue:h,newValue:this.h,change:void 0,didChange:C,hadValue:i}),C)for(const B of this.c)B.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(n){this.j++;const i=this.j===1;if(this.e===3&&(this.e=1,!i))for(const h of this.c)h.handlePossibleChange(this);if(i)for(const h of this.c)h.beginUpdate(this)}endUpdate(n){if(this.j--,this.j===0){const i=[...this.c];for(const h of i)h.endUpdate(this)}if(this.j<0)throw new P.$bb}handlePossibleChange(n){if(this.e===3&&this.k.has(n)&&!this.l.has(n)){this.e=1;for(const i of this.c)i.handlePossibleChange(this)}}handleChange(n,i){if(this.k.has(n)&&!this.l.has(n)){const h=this.s?this.s({changedObservable:n,change:i,didChange:C=>C===n},this.m):!0,w=this.e===3;if(h&&(this.e===1||w)&&(this.e=2,w))for(const C of this.c)C.handlePossibleChange(this)}}readObservable(n){n.addObserver(this);const i=n.get();return this.k.add(n),this.l.delete(n),i}addObserver(n){const i=!this.c.has(n)&&this.j>0;super.addObserver(n),i&&n.beginUpdate(this)}removeObserver(n){const i=this.c.has(n)&&this.j>0;super.removeObserver(n),i&&n.endUpdate(this)}}e.$vd=f}),define(p[22],_([0,1,2,9,5,10,4]),function(z,e,P,k,y,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nd=e.$md=e.$ld=e.$kd=e.$jd=e.$id=e.$hd=e.$gd=e.$fd=e.$ed=e.$dd=e.$cd=e.$bd=void 0;function l(b){return new t(b)}e.$bd=l;class t extends y.$xd{constructor(O){super(),this.a=O}get debugName(){return this.toString()}get(){return this.a}addObserver(O){}removeObserver(O){}toString(){return`Const: ${this.a}`}}function r(b){const O=(0,y.$Gd)("promiseValue",{});return b.then(L=>{O.set({value:L},void 0)}),O}e.$cd=r;function o(b,O){return new Promise(L=>{let a=!1,m=!1;const N=b.map(T=>({isFinished:O(T),state:T})),U=(0,k.$8c)(T=>{const{isFinished:g,state:j}=N.read(T);g&&(a?U.dispose():m=!0,L(j))});a=!0,m&&U.dispose()})}e.$dd=o;function u(b,O){return new f(b,O)}e.$ed=u;class f extends y.$yd{constructor(O,L){super(),this.h=O,this._getValue=L,this.b=!1,this.l=a=>{const m=this._getValue(a),N=this.a,U=!this.b||N!==m;let T=!1;U&&(this.a=m,this.b&&(T=!0,(0,y.$Cd)(f.globalTransaction,g=>{(0,s.$pd)()?.handleFromEventObservableTriggered(this,{oldValue:N,newValue:m,change:void 0,didChange:U,hadValue:this.b});for(const j of this.c)g.updateObserver(j,this),j.handleChange(this,void 0)},()=>{const g=this.j();return"Event fired"+(g?`: ${g}`:"")})),this.b=!0),T||(0,s.$pd)()?.handleFromEventObservableTriggered(this,{oldValue:N,newValue:m,change:void 0,didChange:U,hadValue:this.b})}}j(){return(0,y.$Fd)(this._getValue)}get debugName(){const O=this.j();return"From Event"+(O?`: ${O}`:"")}f(){this.e=this.h(this.l)}g(){this.e.dispose(),this.e=void 0,this.b=!1,this.a=void 0}get(){return this.e?(this.b||this.l(void 0),this.a):this._getValue(void 0)}}e.$fd=f,function(b){b.Observer=f;function O(L,a){let m=!1;f.globalTransaction===void 0&&(f.globalTransaction=L,m=!0);try{a()}finally{m&&(f.globalTransaction=void 0)}}b.batchEventsGlobally=O}(u||(e.$ed=u={}));function d(b,O){return new n(b,O)}e.$gd=d;class n extends y.$yd{constructor(O,L){super(),this.debugName=O,this.b=L,this.h=()=>{(0,y.$zd)(a=>{for(const m of this.c)a.updateObserver(m,this),m.handleChange(this,void 0)},()=>this.debugName)}}f(){this.a=this.b(this.h)}g(){this.a.dispose(),this.a=void 0}get(){}}function i(b){return typeof b=="string"?new h(b):new h(void 0,b)}e.$hd=i;class h extends y.$yd{get debugName(){return(0,y.$Ed)(this,this.a,void 0,this.b,this)??"Observable Signal"}constructor(O,L){super(),this.a=O,this.b=L}trigger(O,L){if(!O){(0,y.$zd)(a=>{this.trigger(a,L)},()=>`Trigger signal ${this.debugName}`);return}for(const a of this.c)O.updateObserver(a,this),a.handleChange(this,L)}get(){}}function w(b,O,L){const a=(0,y.$Gd)("debounced",void 0);let m;return L.add((0,k.$8c)(N=>{const U=b.read(N);m&&clearTimeout(m),m=setTimeout(()=>{(0,y.$zd)(T=>{a.set(U,T)})},O)})),a}e.$id=w;function C(b,O,L){const a=(0,y.$Gd)("triggeredRecently",!1);let m;return L.add(b(()=>{a.set(!0,void 0),m&&clearTimeout(m),m=setTimeout(()=>{a.set(!1,void 0)},O)})),a}e.$jd=C;function B(b){const O=new S(!1);return b.addObserver(O),(0,P.$Pc)(()=>{b.removeObserver(O)})}e.$kd=B;function F(b){const O=new S(!0);return b.addObserver(O),b.reportChanges(),(0,P.$Pc)(()=>{b.removeObserver(O)})}e.$ld=F;class S{constructor(O){this.b=O,this.a=0}beginUpdate(O){this.a++}endUpdate(O){this.a--,this.a===0&&this.b&&O.reportChanges()}handlePossibleChange(O){}handleChange(O,L){}}function $(b){let O;return(0,A.$rd)(a=>(O=b(a,O),O))}e.$md=$;function E(b,O){let L;const a=(0,y.$Gd)("derivedObservableWithWritableCache.counter",0),m=(0,A.$rd)(b,N=>(a.read(N),L=O(N,L),L));return Object.assign(m,{clearCache:N=>{L=void 0,a.set(a.get()+1,N)}})}e.$nd=E}),define(p[11],_([0,1,5,10,9,22,4]),function(z,e,P,k,y,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.wasEventTriggeredRecently=e.waitForState=e.observableSignalFromEvent=e.observableSignal=e.observableFromPromise=e.observableFromEvent=e.recomputeInitiallyAndOnChange=e.keepObserved=e.derivedObservableWithWritableCache=e.derivedObservableWithCache=e.debouncedObservable=e.constObservable=e.autorunWithStoreHandleChanges=e.autorunOpts=e.autorunWithStore=e.autorunHandleChanges=e.autorunDelta=e.autorun=e.derivedWithStore=e.derivedHandleChanges=e.derivedOpts=e.derived=e.subtransaction=e.transaction=e.disposableObservableValue=e.observableValue=void 0,Object.defineProperty(e,"observableValue",{enumerable:!0,get:function(){return P.$Gd}}),Object.defineProperty(e,"disposableObservableValue",{enumerable:!0,get:function(){return P.$Id}}),Object.defineProperty(e,"transaction",{enumerable:!0,get:function(){return P.$zd}}),Object.defineProperty(e,"subtransaction",{enumerable:!0,get:function(){return P.$Cd}}),Object.defineProperty(e,"derived",{enumerable:!0,get:function(){return k.$rd}}),Object.defineProperty(e,"derivedOpts",{enumerable:!0,get:function(){return k.$sd}}),Object.defineProperty(e,"derivedHandleChanges",{enumerable:!0,get:function(){return k.$td}}),Object.defineProperty(e,"derivedWithStore",{enumerable:!0,get:function(){return k.$ud}}),Object.defineProperty(e,"autorun",{enumerable:!0,get:function(){return y.$8c}}),Object.defineProperty(e,"autorunDelta",{enumerable:!0,get:function(){return y.$ad}}),Object.defineProperty(e,"autorunHandleChanges",{enumerable:!0,get:function(){return y.$9c}}),Object.defineProperty(e,"autorunWithStore",{enumerable:!0,get:function(){return y.$$c}}),Object.defineProperty(e,"autorunOpts",{enumerable:!0,get:function(){return y.$7c}}),Object.defineProperty(e,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return y.$0c}}),Object.defineProperty(e,"constObservable",{enumerable:!0,get:function(){return A.$bd}}),Object.defineProperty(e,"debouncedObservable",{enumerable:!0,get:function(){return A.$id}}),Object.defineProperty(e,"derivedObservableWithCache",{enumerable:!0,get:function(){return A.$md}}),Object.defineProperty(e,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return A.$nd}}),Object.defineProperty(e,"keepObserved",{enumerable:!0,get:function(){return A.$kd}}),Object.defineProperty(e,"recomputeInitiallyAndOnChange",{enumerable:!0,get:function(){return A.$ld}}),Object.defineProperty(e,"observableFromEvent",{enumerable:!0,get:function(){return A.$ed}}),Object.defineProperty(e,"observableFromPromise",{enumerable:!0,get:function(){return A.$cd}}),Object.defineProperty(e,"observableSignal",{enumerable:!0,get:function(){return A.$hd}}),Object.defineProperty(e,"observableSignalFromEvent",{enumerable:!0,get:function(){return A.$gd}}),Object.defineProperty(e,"waitForState",{enumerable:!0,get:function(){return A.$dd}}),Object.defineProperty(e,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return A.$jd}}),!1&&(0,s.$od)(new s.$qd)}),define(p[23],_([0,1,6,2]),function(z,e,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=void 0;function y(F){const S=F;return S?typeof S.read=="function":!1}e.$Zd=y;function A(F){const S=F;return S?[S.on,S.pause,S.resume,S.destroy].every($=>typeof $=="function"):!1}e.$1d=A;function s(F){const S=F;return S?A(S.stream)&&Array.isArray(S.buffer)&&typeof S.ended=="boolean":!1}e.$2d=s;function l(F,S){return new t(F,S)}e.$3d=l;class t{constructor(S,$){this.e=S,this.f=$,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(S){if(!this.a.destroyed){if(this.a.flowing)this.g(S);else if(this.b.data.push(S),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise($=>this.d.push($))}}error(S){this.a.destroyed||(this.a.flowing?this.h(S):this.b.error.push(S))}end(S){this.a.destroyed||(typeof S<"u"&&this.write(S),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(S){this.c.data.slice(0).forEach($=>$(S))}h(S){this.c.error.length===0?(0,P.$Z)(S):this.c.error.slice(0).forEach($=>$(S))}i(){this.c.end.slice(0).forEach(S=>S())}on(S,$){if(!this.a.destroyed)switch(S){case"data":this.c.data.push($),this.resume();break;case"end":this.c.end.push($),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push($),this.a.flowing&&this.k();break}}removeListener(S,$){if(this.a.destroyed)return;let E;switch(S){case"data":E=this.c.data;break;case"end":E=this.c.end;break;case"error":E=this.c.error;break}if(E){const b=E.indexOf($);b>=0&&E.splice(b,1)}}j(){if(this.b.data.length>0){const S=this.e(this.b.data);this.g(S),this.b.data.length=0;const $=[...this.d];this.d.length=0,$.forEach(E=>E())}}k(){if(this.c.error.length>0){for(const S of this.b.error)this.h(S);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function r(F,S){const $=[];let E;for(;(E=F.read())!==null;)$.push(E);return S($)}e.$4d=r;function o(F,S,$){const E=[];let b;for(;(b=F.read())!==null&&E.length<$;)E.push(b);return b===null&&E.length>0?S(E):{read:()=>{if(E.length>0)return E.shift();if(typeof b<"u"){const O=b;return b=void 0,O}return F.read()}}}e.$5d=o;function u(F,S){return new Promise(($,E)=>{const b=[];f(F,{onData:O=>{S&&b.push(O)},onError:O=>{S?E(O):$(void 0)},onEnd:()=>{$(S?S(b):void 0)}})})}e.$6d=u;function f(F,S,$){F.on("error",E=>{$?.isCancellationRequested||S.onError(E)}),F.on("end",()=>{$?.isCancellationRequested||S.onEnd()}),F.on("data",E=>{$?.isCancellationRequested||S.onData(E)})}e.$7d=f;function d(F,S){return new Promise(($,E)=>{const b=new k.$Qc,O=[],L=N=>{if(O.push(N),O.length>S)return b.dispose(),F.pause(),$({stream:F,buffer:O,ended:!1})},a=N=>(b.dispose(),E(N)),m=()=>(b.dispose(),$({stream:F,buffer:O,ended:!0}));b.add((0,k.$Pc)(()=>F.removeListener("error",a))),F.on("error",a),b.add((0,k.$Pc)(()=>F.removeListener("end",m))),F.on("end",m),b.add((0,k.$Pc)(()=>F.removeListener("data",L))),F.on("data",L)})}e.$8d=d;function n(F,S){const $=l(S);return $.end(F),$}e.$9d=n;function i(){const F=l(()=>{throw new Error("not supported")});return F.end(),F}e.$0d=i;function h(F){let S=!1;return{read:()=>S?null:(S=!0,F)}}e.$$d=h;function w(F,S,$){const E=l($);return f(F,{onData:b=>E.write(S.data(b)),onError:b=>E.error(S.error?S.error(b):b),onEnd:()=>E.end()}),E}e.$_d=w;function C(F,S,$){let E=!1;return{read:()=>{const b=S.read();return E?b:(E=!0,b!==null?$([F,b]):F)}}}e.$ae=C;function B(F,S,$){let E=!1;const b=l($);return f(S,{onData:O=>E?b.write(O):(E=!0,b.write($([F,O]))),onError:O=>b.error(O),onEnd:()=>{E||(E=!0,b.write(F)),b.end()}}),b}e.$be=B}),define(p[12],_([0,1,43,23]),function(z,e,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=void 0;const y=typeof Buffer<"u",A=new P.$U(()=>new Uint8Array(256));let s,l;class t{static alloc(g){return y?new t(Buffer.allocUnsafe(g)):new t(new Uint8Array(g))}static wrap(g){return y&&!Buffer.isBuffer(g)&&(g=Buffer.from(g.buffer,g.byteOffset,g.byteLength)),new t(g)}static fromString(g,j){return!(j?.dontUseNodeBuffer||!1)&&y?new t(Buffer.from(g)):(s||(s=new TextEncoder),new t(s.encode(g)))}static fromByteArray(g){const j=t.alloc(g.length);for(let q=0,G=g.length;q<G;q++)j.buffer[q]=g[q];return j}static concat(g,j){if(typeof j>"u"){j=0;for(let H=0,V=g.length;H<V;H++)j+=g[H].byteLength}const q=t.alloc(j);let G=0;for(let H=0,V=g.length;H<V;H++){const W=g[H];q.set(W,G),G+=W.byteLength}return q}constructor(g){this.buffer=g,this.byteLength=this.buffer.byteLength}clone(){const g=t.alloc(this.byteLength);return g.set(this),g}toString(){return y?this.buffer.toString():(l||(l=new TextDecoder),l.decode(this.buffer))}slice(g,j){return new t(this.buffer.subarray(g,j))}set(g,j){if(g instanceof t)this.buffer.set(g.buffer,j);else if(g instanceof Uint8Array)this.buffer.set(g,j);else if(g instanceof ArrayBuffer)this.buffer.set(new Uint8Array(g),j);else if(ArrayBuffer.isView(g))this.buffer.set(new Uint8Array(g.buffer,g.byteOffset,g.byteLength),j);else throw new Error("Unknown argument 'array'")}readUInt32BE(g){return f(this.buffer,g)}writeUInt32BE(g,j){d(this.buffer,g,j)}readUInt32LE(g){return n(this.buffer,g)}writeUInt32LE(g,j){i(this.buffer,g,j)}readUInt8(g){return h(this.buffer,g)}writeUInt8(g,j){w(this.buffer,g,j)}indexOf(g,j=0){return r(this.buffer,g instanceof t?g.buffer:g,j)}}e.$ce=t;function r(T,g,j=0){const q=g.byteLength,G=T.byteLength;if(q===0)return 0;if(q===1)return T.indexOf(g[0]);if(q>G-j)return-1;const H=A.value;H.fill(g.length);for(let X=0;X<g.length;X++)H[g[X]]=g.length-X-1;let V=j+g.length-1,W=V,K=-1;for(;V<G;)if(T[V]===g[W]){if(W===0){K=V;break}V--,W--}else V+=Math.max(g.length-W,H[T[V]]),W=g.length-1;return K}e.$de=r;function o(T,g){return T[g+0]<<0>>>0|T[g+1]<<8>>>0}e.$ee=o;function u(T,g,j){T[j+0]=g&255,g=g>>>8,T[j+1]=g&255}e.$fe=u;function f(T,g){return T[g]*2**24+T[g+1]*2**16+T[g+2]*2**8+T[g+3]}e.$ge=f;function d(T,g,j){T[j+3]=g,g=g>>>8,T[j+2]=g,g=g>>>8,T[j+1]=g,g=g>>>8,T[j]=g}e.$he=d;function n(T,g){return T[g+0]<<0>>>0|T[g+1]<<8>>>0|T[g+2]<<16>>>0|T[g+3]<<24>>>0}e.$ie=n;function i(T,g,j){T[j+0]=g&255,g=g>>>8,T[j+1]=g&255,g=g>>>8,T[j+2]=g&255,g=g>>>8,T[j+3]=g&255}e.$je=i;function h(T,g){return T[g]}e.$ke=h;function w(T,g,j){T[j]=g}e.$le=w;function C(T){return k.$4d(T,g=>t.concat(g))}e.$me=C;function B(T){return k.$$d(T)}e.$ne=B;function F(T){return k.$6d(T,g=>t.concat(g))}e.$oe=F;async function S(T){return T.ended?t.concat(T.buffer):t.concat([...T.buffer,await F(T.stream)])}e.$pe=S;function $(T){return k.$9d(T,g=>t.concat(g))}e.$qe=$;function E(T){return k.$_d(T,{data:g=>typeof g=="string"?t.fromString(g):t.wrap(g)},g=>t.concat(g))}e.$re=E;function b(T){return k.$3d(g=>t.concat(g),T)}e.$se=b;function O(T,g){return k.$ae(T,g,j=>t.concat(j))}e.$te=O;function L(T,g){return k.$be(T,g,j=>t.concat(j))}e.$ue=L;function a(T){let g=0,j=0,q=0;const G=new Uint8Array(Math.floor(T.length/4*3)),H=W=>{switch(j){case 3:G[q++]=g|W,j=0;break;case 2:G[q++]=g|W>>>2,g=W<<6,j=3;break;case 1:G[q++]=g|W>>>4,g=W<<4,j=2;break;default:g=W<<2,j=1}};for(let W=0;W<T.length;W++){const K=T.charCodeAt(W);if(K>=65&&K<=90)H(K-65);else if(K>=97&&K<=122)H(K-97+26);else if(K>=48&&K<=57)H(K-48+52);else if(K===43||K===45)H(62);else if(K===47||K===95)H(63);else{if(K===61)break;throw new SyntaxError(`Unexpected base64 character ${T[W]}`)}}const V=q;for(;j>0;)H(0);return t.wrap(G).slice(0,V)}e.$ve=a;const m="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",N="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function U({buffer:T},g=!0,j=!1){const q=j?N:m;let G="";const H=T.byteLength%3;let V=0;for(;V<T.byteLength-H;V+=3){const W=T[V+0],K=T[V+1],X=T[V+2];G+=q[W>>>2],G+=q[(W<<4|K>>>4)&63],G+=q[(K<<2|X>>>6)&63],G+=q[X&63]}if(H===1){const W=T[V+0];G+=q[W>>>2],G+=q[W<<4&63],g&&(G+="==")}else if(H===2){const W=T[V+0],K=T[V+1];G+=q[W>>>2],G+=q[(W<<4|K>>>4)&63],G+=q[K<<2&63],g&&(G+="=")}return G}e.$we=U}),define(p[24],_([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ld=void 0,e.$Ld=Symbol("MicrotaskDelay")}),define(p[13],_([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0s=e.StringEOL=void 0;var P;(function(y){y[y.Unknown=0]="Unknown",y[y.Invalid=3]="Invalid",y[y.LF=1]="LF",y[y.CRLF=2]="CRLF"})(P||(e.StringEOL=P={}));function k(y){let A=0,s=0,l=0,t=0;for(let r=0,o=y.length;r<o;r++){const u=y.charCodeAt(r);u===13?(A===0&&(s=r),A++,r+1<o&&y.charCodeAt(r+1)===10?(t|=2,r++):t|=3,l=r+1):u===10&&(t|=1,A===0&&(s=r),A++,l=r+1)}return A===0&&(s=y.length),[A,s,y.length-l,t]}e.$0s=k}),define(p[14],_([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8s=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var P;(function(t){t[t.Null=0]="Null",t[t.PlainText=1]="PlainText"})(P||(e.LanguageId=P={}));var k;(function(t){t[t.NotSet=-1]="NotSet",t[t.None=0]="None",t[t.Italic=1]="Italic",t[t.Bold=2]="Bold",t[t.Underline=4]="Underline",t[t.Strikethrough=8]="Strikethrough"})(k||(e.FontStyle=k={}));var y;(function(t){t[t.None=0]="None",t[t.DefaultForeground=1]="DefaultForeground",t[t.DefaultBackground=2]="DefaultBackground"})(y||(e.ColorId=y={}));var A;(function(t){t[t.Other=0]="Other",t[t.Comment=1]="Comment",t[t.String=2]="String",t[t.RegEx=3]="RegEx"})(A||(e.StandardTokenType=A={}));var s;(function(t){t[t.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",t[t.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",t[t.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",t[t.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",t[t.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",t[t.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",t[t.ITALIC_MASK=2048]="ITALIC_MASK",t[t.BOLD_MASK=4096]="BOLD_MASK",t[t.UNDERLINE_MASK=8192]="UNDERLINE_MASK",t[t.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",t[t.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",t[t.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",t[t.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",t[t.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",t[t.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",t[t.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",t[t.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",t[t.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",t[t.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",t[t.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",t[t.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",t[t.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(s||(e.MetadataConsts=s={}));class l{static getLanguageId(r){return(r&255)>>>0}static getTokenType(r){return(r&768)>>>8}static containsBalancedBrackets(r){return(r&1024)!==0}static getFontStyle(r){return(r&30720)>>>11}static getForeground(r){return(r&16744448)>>>15}static getBackground(r){return(r&4278190080)>>>24}static getClassNameFromMetadata(r){let u="mtk"+this.getForeground(r);const f=this.getFontStyle(r);return f&1&&(u+=" mtki"),f&2&&(u+=" mtkb"),f&4&&(u+=" mtku"),f&8&&(u+=" mtks"),u}static getInlineStyleFromMetadata(r,o){const u=this.getForeground(r),f=this.getFontStyle(r);let d=`color: ${o[u]};`;f&1&&(d+="font-style: italic;"),f&2&&(d+="font-weight: bold;");let n="";return f&4&&(n+=" underline"),f&8&&(n+=" line-through"),n&&(d+=`text-decoration:${n};`),d}static getPresentationFromMetadata(r){const o=this.getForeground(r),u=this.getFontStyle(r);return{foreground:o,italic:!!(u&1),bold:!!(u&2),underline:!!(u&4),strikethrough:!!(u&8)}}}e.$8s=l}),define(p[25],_([0,1,26]),function(z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OB=void 0;class k{constructor(s){this.b=s,this.a=[]}get(s){return s<this.a.length?this.a[s]:this.b}set(s,l){for(;s>=this.a.length;)this.a[this.a.length]=this.b;this.a[s]=l}replace(s,l,t){if(s>=this.a.length)return;if(l===0){this.insert(s,t);return}else if(t===0){this.delete(s,l);return}const r=this.a.slice(0,s),o=this.a.slice(s+l),u=y(t,this.b);this.a=r.concat(u,o)}delete(s,l){l===0||s>=this.a.length||this.a.splice(s,l)}insert(s,l){if(l===0||s>=this.a.length)return;const t=[];for(let r=0;r<l;r++)t[r]=this.b;this.a=(0,P.$Vb)(this.a,s,t)}}e.$OB=k;function y(A,s){const l=[];for(let t=0;t<A;t++)l[t]=s;return l}}),define(p[7],_([0,1,14]),function(z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$s=void 0;class k{static{this.defaultTokenMetadata=(0<<11|1<<15|2<<24)>>>0}static createEmpty(s,l){const t=k.defaultTokenMetadata,r=new Uint32Array(2);return r[0]=s.length,r[1]=t,new k(r,s,l)}constructor(s,l,t){this._lineTokensBrand=void 0,this.a=s,this.b=this.a.length>>>1,this.c=l,this.d=t}equals(s){return s instanceof k?this.slicedEquals(s,0,this.b):!1}slicedEquals(s,l,t){if(this.c!==s.c||this.b!==s.b)return!1;const r=l<<1,o=r+(t<<1);for(let u=r;u<o;u++)if(this.a[u]!==s.a[u])return!1;return!0}getLineContent(){return this.c}getCount(){return this.b}getStartOffset(s){return s>0?this.a[s-1<<1]:0}getMetadata(s){return this.a[(s<<1)+1]}getLanguageId(s){const l=this.a[(s<<1)+1],t=P.$8s.getLanguageId(l);return this.d.decodeLanguageId(t)}getStandardTokenType(s){const l=this.a[(s<<1)+1];return P.$8s.getTokenType(l)}getForeground(s){const l=this.a[(s<<1)+1];return P.$8s.getForeground(l)}getClassName(s){const l=this.a[(s<<1)+1];return P.$8s.getClassNameFromMetadata(l)}getInlineStyle(s,l){const t=this.a[(s<<1)+1];return P.$8s.getInlineStyleFromMetadata(t,l)}getPresentation(s){const l=this.a[(s<<1)+1];return P.$8s.getPresentationFromMetadata(l)}getEndOffset(s){return this.a[s<<1]}findTokenIndexAtOffset(s){return k.findIndexInTokensArray(this.a,s)}inflate(){return this}sliceAndInflate(s,l,t){return new y(this,s,l,t)}static convertToEndOffset(s,l){const r=(s.length>>>1)-1;for(let o=0;o<r;o++)s[o<<1]=s[o+1<<1];s[r<<1]=l}static findIndexInTokensArray(s,l){if(s.length<=2)return 0;let t=0,r=(s.length>>>1)-1;for(;t<r;){const o=t+Math.floor((r-t)/2),u=s[o<<1];if(u===l)return o+1;u<l?t=o+1:u>l&&(r=o)}return t}withInserted(s){if(s.length===0)return this;let l=0,t=0,r="";const o=new Array;let u=0;for(;;){const f=l<this.b?this.a[l<<1]:-1,d=t<s.length?s[t]:null;if(f!==-1&&(d===null||f<=d.offset)){r+=this.c.substring(u,f);const n=this.a[(l<<1)+1];o.push(r.length,n),l++,u=f}else if(d){if(d.offset>u){r+=this.c.substring(u,d.offset);const n=this.a[(l<<1)+1];o.push(r.length,n),u=d.offset}r+=d.text,o.push(r.length,d.tokenMetadata),t++}else break}return new k(new Uint32Array(o),r,this.d)}}e.$$s=k;class y{constructor(s,l,t,r){this.a=s,this.b=l,this.c=t,this.d=r,this.e=s.findTokenIndexAtOffset(l),this.f=0;for(let o=this.e,u=s.getCount();o<u&&!(s.getStartOffset(o)>=t);o++)this.f++}getMetadata(s){return this.a.getMetadata(this.e+s)}getLanguageId(s){return this.a.getLanguageId(this.e+s)}getLineContent(){return this.a.getLineContent().substring(this.b,this.c)}equals(s){return s instanceof y?this.b===s.b&&this.c===s.c&&this.d===s.d&&this.a.slicedEquals(s.a,this.e,this.f):!1}getCount(){return this.f}getForeground(s){return this.a.getForeground(this.e+s)}getEndOffset(s){const l=this.a.getEndOffset(this.e+s);return Math.min(this.c,l)-this.b+this.d}getClassName(s){return this.a.getClassName(this.e+s)}getInlineStyle(s,l){return this.a.getInlineStyle(this.e+s,l)}getPresentation(s){return this.a.getPresentation(this.e+s)}findTokenIndexAtOffset(s){return this.a.findTokenIndexAtOffset(s+this.b-this.d)-this.e}}}),define(p[27],_([0,1,7]),function(z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bt=e.$at=e.$_s=void 0,e.$_s=new Uint32Array(0).buffer;class k{static deleteBeginning(s,l){return s===null||s===e.$_s?s:k.delete(s,0,l)}static deleteEnding(s,l){if(s===null||s===e.$_s)return s;const t=y(s),r=t[t.length-2];return k.delete(s,l,r)}static delete(s,l,t){if(s===null||s===e.$_s||l===t)return s;const r=y(s),o=r.length>>>1;if(l===0&&r[r.length-2]===t)return e.$_s;const u=P.$$s.findIndexInTokensArray(r,l),f=u>0?r[u-1<<1]:0,d=r[u<<1];if(t<d){const C=t-l;for(let B=u;B<o;B++)r[B<<1]-=C;return s}let n,i;f!==l?(r[u<<1]=l,n=u+1<<1,i=l):(n=u<<1,i=f);const h=t-l;for(let C=u+1;C<o;C++){const B=r[C<<1]-h;B>i&&(r[n++]=B,r[n++]=r[(C<<1)+1],i=B)}if(n===r.length)return s;const w=new Uint32Array(n);return w.set(r.subarray(0,n),0),w.buffer}static append(s,l){if(l===e.$_s)return s;if(s===e.$_s)return l;if(s===null)return s;if(l===null)return null;const t=y(s),r=y(l),o=r.length>>>1,u=new Uint32Array(t.length+r.length);u.set(t,0);let f=t.length;const d=t[t.length-2];for(let n=0;n<o;n++)u[f++]=r[n<<1]+d,u[f++]=r[(n<<1)+1];return u.buffer}static insert(s,l,t){if(s===null||s===e.$_s)return s;const r=y(s),o=r.length>>>1;let u=P.$$s.findIndexInTokensArray(r,l);u>0&&r[u-1<<1]===l&&u--;for(let f=u;f<o;f++)r[f<<1]+=t;return s}}e.$at=k;function y(A){return A instanceof Uint32Array?A:new Uint32Array(A)}e.$bt=y}),define(p[28],_([0,1,26,12,44,13,27,15]),function(z,e,P,k,y,A,s,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ct=void 0;class t{static deserialize(o,u,f){const d=new Uint32Array(o.buffer),n=(0,k.$ge)(o,u);u+=4;const i=(0,k.$ge)(o,u);u+=4;const h=[];for(let w=0;w<i;w++){const C=(0,k.$ge)(o,u);u+=4,h.push(d.subarray(u/4,u/4+C/4)),u+=C}return f.push(new t(n,h)),u}get startLineNumber(){return this.a}get endLineNumber(){return this.a+this.b.length-1}constructor(o,u){this.a=o,this.b=u}getLineRange(){return new l.$Gs(this.a,this.a+this.b.length)}getLineTokens(o){return this.b[o-this.a]}appendLineTokens(o){this.b.push(o)}serializeSize(){let o=0;o+=4,o+=4;for(let u=0;u<this.b.length;u++){const f=this.b[u];if(!(f instanceof Uint32Array))throw new Error("Not supported!");o+=4,o+=f.byteLength}return o}serialize(o,u){(0,k.$he)(o,this.a,u),u+=4,(0,k.$he)(o,this.b.length,u),u+=4;for(let f=0;f<this.b.length;f++){const d=this.b[f];if(!(d instanceof Uint32Array))throw new Error("Not supported!");(0,k.$he)(o,d.byteLength,u),u+=4,o.set(new Uint8Array(d.buffer),u),u+=d.byteLength}return u}applyEdit(o,u){const[f,d]=(0,A.$0s)(u);this.c(o),this.d(new y.$ws(o.startLineNumber,o.startColumn),f,d)}c(o){if(o.startLineNumber===o.endLineNumber&&o.startColumn===o.endColumn)return;const u=o.startLineNumber-this.a,f=o.endLineNumber-this.a;if(f<0){const d=f-u;this.a-=d;return}if(!(u>=this.b.length)){if(u<0&&f>=this.b.length){this.a=0,this.b=[];return}if(u===f){this.b[u]=s.$at.delete(this.b[u],o.startColumn-1,o.endColumn-1);return}if(u>=0)if(this.b[u]=s.$at.deleteEnding(this.b[u],o.startColumn-1),f<this.b.length){const d=s.$at.deleteBeginning(this.b[f],o.endColumn-1);this.b[u]=s.$at.append(this.b[u],d),this.b.splice(u+1,f-u)}else this.b[u]=s.$at.append(this.b[u],null),this.b=this.b.slice(0,u+1);else{const d=-u;this.a-=d,this.b[f]=s.$at.deleteBeginning(this.b[f],o.endColumn-1),this.b=this.b.slice(f)}}}d(o,u,f){if(u===0&&f===0)return;const d=o.lineNumber-this.a;if(d<0){this.a+=u;return}if(!(d>=this.b.length)){if(u===0){this.b[d]=s.$at.insert(this.b[d],o.column-1,f);return}this.b[d]=s.$at.deleteEnding(this.b[d],o.column-1),this.b[d]=s.$at.insert(this.b[d],o.column-1,f),this.e(o.lineNumber,u)}}e(o,u){if(u===0)return;const f=[];for(let d=0;d<u;d++)f[d]=null;this.b=P.$Vb(this.b,o,f)}}e.$ct=t}),define(p[16],_([0,1,12,28]),function(z,e,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PB=void 0;class y{static deserialize(s){let l=0;const t=(0,P.$ge)(s,l);l+=4;const r=[];for(let o=0;o<t;o++)l=k.$ct.deserialize(s,l,r);return r}constructor(){this.a=[]}add(s,l){if(this.a.length>0){const t=this.a[this.a.length-1];if(t.endLineNumber+1===s){t.appendLineTokens(l);return}}this.a.push(new k.$ct(s,[l]))}finalize(){return this.a}serialize(){const s=this.b(),l=new Uint8Array(s);return this.c(l),l}b(){let s=0;s+=4;for(let l=0;l<this.a.length;l++)s+=this.a[l].serializeSize();return s}c(s){let l=0;(0,P.$he)(s,this.a.length,l),l+=4;for(let t=0;t<this.a.length;t++)l=this.a[t].serialize(s,l)}}e.$PB=y}),define(p[29],_([0,1,30,3,31,45]),function(z,e,P,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=void 0;function s(a){return a===47||a===92}e.$Rf=s;function l(a){return a.replace(/[\\/]/g,P.$fc.sep)}e.$Sf=l;function t(a){return a.indexOf("/")===-1&&(a=l(a)),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a),a}e.$Tf=t;function r(a,m=P.$fc.sep){if(!a)return"";const N=a.length,U=a.charCodeAt(0);if(s(U)){if(s(a.charCodeAt(1))&&!s(a.charCodeAt(2))){let g=3;const j=g;for(;g<N&&!s(a.charCodeAt(g));g++);if(j!==g&&!s(a.charCodeAt(g+1))){for(g+=1;g<N;g++)if(s(a.charCodeAt(g)))return a.slice(0,g+1).replace(/[\\/]/g,m)}}return m}else if(w(U)&&a.charCodeAt(1)===58)return s(a.charCodeAt(2))?a.slice(0,2)+m:a.slice(0,2);let T=a.indexOf("://");if(T!==-1){for(T+=3;T<N;T++)if(s(a.charCodeAt(T)))return a.slice(0,T+1)}return""}e.$Uf=r;function o(a){if(!k.$j||!a||a.length<5)return!1;let m=a.charCodeAt(0);if(m!==92||(m=a.charCodeAt(1),m!==92))return!1;let N=2;const U=N;for(;N<a.length&&(m=a.charCodeAt(N),m!==92);N++);return!(U===N||(m=a.charCodeAt(N+1),isNaN(m)||m===92))}e.$Vf=o;const u=/[\\/:\*\?"<>\|]/g,f=/[\\/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function n(a,m=k.$j){const N=m?u:f;return!(!a||a.length===0||/^\s+$/.test(a)||(N.lastIndex=0,N.test(a))||m&&d.test(a)||a==="."||a===".."||m&&a[a.length-1]==="."||m&&a.length!==a.trim().length||a.length>255)}e.$Wf=n;function i(a,m,N){const U=a===m;return!N||U?U:!a||!m?!1:(0,y.$3e)(a,m)}e.$Xf=i;function h(a,m,N,U=P.sep){if(a===m)return!0;if(!a||!m||m.length>a.length)return!1;if(N){if(!(0,y.$4e)(a,m))return!1;if(m.length===a.length)return!0;let g=m.length;return m.charAt(m.length-1)===U&&g--,a.charAt(g)===U}return m.charAt(m.length-1)!==U&&(m+=U),a.indexOf(m)===0}e.$Yf=h;function w(a){return a>=65&&a<=90||a>=97&&a<=122}e.$Zf=w;function C(a,m){return k.$j&&a.endsWith(":")&&(a+=P.sep),(0,P.$hc)(a)||(a=(0,P.$ic)(m,a)),a=(0,P.$gc)(a),k.$j?(a=(0,y.$Le)(a,P.sep),a.endsWith(":")&&(a+=P.sep)):(a=(0,y.$Le)(a,P.sep),a||(a=P.sep)),a}e.$1f=C;function B(a){const m=(0,P.$gc)(a);return k.$j?a.length>3?!1:F(m)&&(a.length===2||m.charCodeAt(2)===92):m===P.$fc.sep}e.$2f=B;function F(a,m=k.$j){return m?w(a.charCodeAt(0))&&a.charCodeAt(1)===58:!1}e.$3f=F;function S(a,m=k.$j){return F(a,m)?a[0]:void 0}e.$4f=S;function $(a,m,N){return m.length>a.length?-1:a===m?0:(N&&(a=a.toLowerCase(),m=m.toLowerCase()),a.indexOf(m))}e.$5f=$;function E(a){const m=a.split(":");let N,U,T;for(const g of m){const j=Number(g);(0,A.$Df)(j)?U===void 0?U=j:T===void 0&&(T=j):N=N?[N,g].join(":"):g}if(!N)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:N,line:U!==void 0?U:void 0,column:T!==void 0?T:U!==void 0?1:void 0}}e.$6f=E;const b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",O="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function L(a,m,N=8){let U="";for(let g=0;g<N;g++){let j;g===0&&k.$j&&!m&&(N===3||N===4)?j=O:j=b,U+=j.charAt(Math.floor(Math.random()*j.length))}let T;return m?T=`${m}-${U}`:T=U,a?(0,P.$ic)(a,T):T}e.$7f=L}),define(p[17],_([0,1,6,3,8]),function(z,e,P,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.Schemas=void 0;var A;(function(r){r.inMemory="inmemory",r.vscode="vscode",r.internal="private",r.walkThrough="walkThrough",r.walkThroughSnippet="walkThroughSnippet",r.http="http",r.https="https",r.file="file",r.mailto="mailto",r.untitled="untitled",r.data="data",r.command="command",r.vscodeRemote="vscode-remote",r.vscodeRemoteResource="vscode-remote-resource",r.vscodeManagedRemoteResource="vscode-managed-remote-resource",r.vscodeUserData="vscode-userdata",r.vscodeCustomEditor="vscode-custom-editor",r.vscodeNotebookCell="vscode-notebook-cell",r.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",r.vscodeNotebookCellOutput="vscode-notebook-cell-output",r.vscodeInteractiveInput="vscode-interactive-input",r.vscodeSettings="vscode-settings",r.vscodeWorkspaceTrust="vscode-workspace-trust",r.vscodeTerminal="vscode-terminal",r.vscodeChatSesssion="vscode-chat-editor",r.webviewPanel="webview-panel",r.vscodeWebview="vscode-webview",r.extension="extension",r.vscodeFileResource="vscode-file",r.tmp="tmp",r.vsls="vsls",r.vscodeSourceControl="vscode-scm"})(A||(e.Schemas=A={})),e.$8f="vscode-tkn",e.$9f="tkn";class s{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${A.vscodeRemoteResource}`}setPreferredWebSchema(o){this.d=o}setDelegate(o){this.e=o}setServerRootPath(o){this.f=`${o}/${A.vscodeRemoteResource}`}set(o,u,f){this.a[o]=u,this.b[o]=f}setConnectionToken(o,u){this.c[o]=u}getPreferredWebSchema(){return this.d}rewrite(o){if(this.e)try{return this.e(o)}catch(h){return P.$Z(h),o}const u=o.authority;let f=this.a[u];f&&f.indexOf(":")!==-1&&f.indexOf("[")===-1&&(f=`[${f}]`);const d=this.b[u],n=this.c[u];let i=`path=${encodeURIComponent(o.path)}`;return typeof n=="string"&&(i+=`&${e.$9f}=${encodeURIComponent(n)}`),y.URI.from({scheme:k.$p?this.d:A.vscodeRemoteResource,authority:`${f}:${d}`,path:this.f,query:i})}}e.$0f=new s,e.$$f="vs/../../extensions",e.$_f="vs/../../node_modules",e.$ag="vs/../../node_modules.asar",e.$bg="vs/../../node_modules.asar.unpacked",e.$cg="vscode-app";class l{static{this.a=e.$cg}asBrowserUri(o){const u=this.b(o,z);return this.uriToBrowserUri(u)}uriToBrowserUri(o){return o.scheme===A.vscodeRemote?e.$0f.rewrite(o):o.scheme===A.file&&(k.$n||k.$q&&k.$h.origin===`${A.vscodeFileResource}://${l.a}`)?o.with({scheme:A.vscodeFileResource,authority:o.authority||l.a,query:null,fragment:null}):o}asFileUri(o){const u=this.b(o,z);return this.uriToFileUri(u)}uriToFileUri(o){return o.scheme===A.vscodeFileResource?o.with({scheme:A.file,authority:o.authority!==l.a?o.authority:null,query:null,fragment:null}):o}b(o,u){return y.URI.isUri(o)?o:y.URI.parse(u.toUrl(o))}}e.$dg=new l;var t;(function(r){const o=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);r.CoopAndCoep=Object.freeze(o.get("3"));const u="vscode-coi";function f(n){let i;typeof n=="string"?i=new URL(n).searchParams:n instanceof URL?i=n.searchParams:y.URI.isUri(n)&&(i=new URL(n.toString(!0)).searchParams);const h=i?.get(u);if(h)return o.get(h)}r.getHeadersFromQuery=f;function d(n,i,h){if(!globalThis.crossOriginIsolated)return;const w=i&&h?"3":h?"2":"1";n instanceof URLSearchParams?n.set(u,w):n[u]=w}r.addSearchParam=d})(t||(e.COI=t={}))}),define(p[32],_([0,1,21,17,3,8]),function(z,e,P,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LC=void 0;class s{constructor(f,d,n){this.id=f,this.dependencies=d,this.callback=n}}class l{static{this.INSTANCE=new l}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(f,d,n)=>{typeof f!="string"&&(n=d,d=f,f=null),(typeof d!="object"||!Array.isArray(d))&&(n=d,d=null),this.c.push(new s(f,d,n))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(f){if(f.startsWith(window.location.origin)||f.startsWith("vscode-file://vscode-app"))return f;throw new Error(`[trusted_script_src] Invalid script url: ${f}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(f){return f}})))}async load(f){this.g();const d=await(this.a?this.i(f):this.b?this.h(f):this.j(f));if(!d)throw new Error(`Did not receive a define call from script ${f}`);if(Array.isArray(d.dependencies)&&d.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${f}. The dependencies are: ${d.dependencies.join(", ")}`);return typeof d.callback=="function"?d.callback([]):d.callback}h(f){return new Promise((d,n)=>{const i=document.createElement("script");i.setAttribute("async","async"),i.setAttribute("type","text/javascript");const h=()=>{i.removeEventListener("load",w),i.removeEventListener("error",C)},w=B=>{h(),d(this.c.pop())},C=B=>{h(),n(B)};i.addEventListener("load",w),i.addEventListener("error",C),this.f&&(f=this.f.createScriptURL(f)),i.setAttribute("src",f),document.getElementsByTagName("head")[0].appendChild(i)})}i(f){return new Promise((d,n)=>{try{this.f&&(f=this.f.createScriptURL(f)),importScripts(f),d(this.c.pop())}catch(i){n(i)}})}async j(f){try{const d=globalThis._VSCODE_NODE_MODULES.fs,n=globalThis._VSCODE_NODE_MODULES.vm,i=globalThis._VSCODE_NODE_MODULES.module,h=A.URI.parse(f).fsPath,w=d.readFileSync(h).toString(),C=i.wrap(w.replace(/^#!.*/,""));return new n.Script(C).runInThisContext().apply(),this.c.pop()}catch(d){throw d}}}const t=new Map;let r={};typeof globalThis.require=="object"&&(r=globalThis.require.paths??{});async function o(u,f,d){if(P.$S){d===void 0&&(d=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),r[u]&&(u=r[u]);const n=`${u}/${f}`;if(t.has(n))return t.get(n);let i;if(/^\w[\w\d+.-]*:\/\//.test(n))i=n;else{const B=`${d&&!y.$p?k.$ag:k.$_f}/${n}`;i=k.$dg.asBrowserUri(B).toString(!0)}const h=l.INSTANCE.load(i);return t.set(n,h),h}else return await new Promise((n,i)=>{z([u],n,i)})}e.$LC=o}),define(p[18],_([0,1,29,17,30,3,31,8]),function(z,e,P,k,y,A,s,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gg=e.DataUri=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=void 0;function t(d){return(0,l.$vc)(d,!0)}e.$kg=t;class r{constructor(n){this.a=n}compare(n,i,h=!1){return n===i?0:(0,s.$Ve)(this.getComparisonKey(n,h),this.getComparisonKey(i,h))}isEqual(n,i,h=!1){return n===i?!0:!n||!i?!1:this.getComparisonKey(n,h)===this.getComparisonKey(i,h)}getComparisonKey(n,i=!1){return n.with({path:this.a(n)?n.path.toLowerCase():void 0,fragment:i?null:void 0}).toString()}ignorePathCasing(n){return this.a(n)}isEqualOrParent(n,i,h=!1){if(n.scheme===i.scheme){if(n.scheme===k.Schemas.file)return P.$Yf(t(n),t(i),this.a(n))&&n.query===i.query&&(h||n.fragment===i.fragment);if((0,e.$Bg)(n.authority,i.authority))return P.$Yf(n.path,i.path,this.a(n),"/")&&n.query===i.query&&(h||n.fragment===i.fragment)}return!1}joinPath(n,...i){return l.URI.joinPath(n,...i)}basenameOrAuthority(n){return(0,e.$tg)(n)||n.authority}basename(n){return y.$fc.basename(n.path)}extname(n){return y.$fc.extname(n.path)}dirname(n){if(n.path.length===0)return n;let i;return n.scheme===k.Schemas.file?i=l.URI.file(y.$lc(t(n))).path:(i=y.$fc.dirname(n.path),n.authority&&i.length&&i.charCodeAt(0)!==47&&(console.error(`dirname("${n.toString})) resulted in a relative path`),i="/")),n.with({path:i})}normalizePath(n){if(!n.path.length)return n;let i;return n.scheme===k.Schemas.file?i=l.URI.file(y.$gc(t(n))).path:i=y.$fc.normalize(n.path),n.with({path:i})}relativePath(n,i){if(n.scheme!==i.scheme||!(0,e.$Bg)(n.authority,i.authority))return;if(n.scheme===k.Schemas.file){const C=y.$kc(t(n),t(i));return A.$j?P.$Sf(C):C}let h=n.path||"/";const w=i.path||"/";if(this.a(n)){let C=0;for(const B=Math.min(h.length,w.length);C<B&&!(h.charCodeAt(C)!==w.charCodeAt(C)&&h.charAt(C).toLowerCase()!==w.charAt(C).toLowerCase());C++);h=w.substr(0,C)+h.substr(C)}return y.$fc.relative(h,w)}resolvePath(n,i){if(n.scheme===k.Schemas.file){const h=l.URI.file(y.$jc(t(n),i));return n.with({authority:h.authority,path:h.path})}return i=P.$Tf(i),n.with({path:y.$fc.resolve(n.path,i)})}isAbsolutePath(n){return!!n.path&&n.path[0]==="/"}isEqualAuthority(n,i){return n===i||n!==void 0&&i!==void 0&&(0,s.$3e)(n,i)}hasTrailingPathSeparator(n,i=y.sep){if(n.scheme===k.Schemas.file){const h=t(n);return h.length>P.$Uf(h).length&&h[h.length-1]===i}else{const h=n.path;return h.length>1&&h.charCodeAt(h.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(n.fsPath)}}removeTrailingPathSeparator(n,i=y.sep){return(0,e.$Cg)(n,i)?n.with({path:n.path.substr(0,n.path.length-1)}):n}addTrailingPathSeparator(n,i=y.sep){let h=!1;if(n.scheme===k.Schemas.file){const w=t(n);h=w!==void 0&&w.length===P.$Uf(w).length&&w[w.length-1]===i}else{i="/";const w=n.path;h=w.length===1&&w.charCodeAt(w.length-1)===47}return!h&&!(0,e.$Cg)(n,i)?n.with({path:n.path+"/"}):n}}e.$lg=r,e.$mg=new r(()=>!1),e.$ng=new r(d=>d.scheme===k.Schemas.file?!A.$l:!0),e.$og=new r(d=>!0),e.$pg=e.$mg.isEqual.bind(e.$mg),e.$qg=e.$mg.isEqualOrParent.bind(e.$mg),e.$rg=e.$mg.getComparisonKey.bind(e.$mg),e.$sg=e.$mg.basenameOrAuthority.bind(e.$mg),e.$tg=e.$mg.basename.bind(e.$mg),e.$ug=e.$mg.extname.bind(e.$mg),e.$vg=e.$mg.dirname.bind(e.$mg),e.$wg=e.$mg.joinPath.bind(e.$mg),e.$xg=e.$mg.normalizePath.bind(e.$mg),e.$yg=e.$mg.relativePath.bind(e.$mg),e.$zg=e.$mg.resolvePath.bind(e.$mg),e.$Ag=e.$mg.isAbsolutePath.bind(e.$mg),e.$Bg=e.$mg.isEqualAuthority.bind(e.$mg),e.$Cg=e.$mg.hasTrailingPathSeparator.bind(e.$mg),e.$Dg=e.$mg.removeTrailingPathSeparator.bind(e.$mg),e.$Eg=e.$mg.addTrailingPathSeparator.bind(e.$mg);function o(d,n){const i=[];for(let h=0;h<d.length;h++){const w=n(d[h]);d.some((C,B)=>B===h?!1:(0,e.$qg)(w,n(C)))||i.push(d[h])}return i}e.$Fg=o;var u;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function n(i){const h=new Map;i.path.substring(i.path.indexOf(";")+1,i.path.lastIndexOf(";")).split(";").forEach(B=>{const[F,S]=B.split(":");F&&S&&h.set(F,S)});const C=i.path.substring(0,i.path.indexOf(";"));return C&&h.set(d.META_DATA_MIME,C),h}d.parseMetaData=n})(u||(e.DataUri=u={}));function f(d,n,i){if(n){let h=d.path;return h&&h[0]!==y.$fc.sep&&(h=y.$fc.sep+h),d.with({scheme:i,authority:n,path:h})}return d.with({scheme:i})}e.$Gg=f}),define(p[19],_([0,1,46,6,33,2,18,3,24]),function(z,e,P,k,y,A,s,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kh=e.$jh=e.$ih=e.$hh=e.Promises=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=void 0;function r(M){return!!M&&typeof M.then=="function"}e.$Hg=r;function o(M){const c=new P.$Yd,v=M(c.token),I=new Promise((R,D)=>{const Z=c.token.onCancellationRequested(()=>{Z.dispose(),c.dispose(),D(new k.$4)});Promise.resolve(v).then(Q=>{Z.dispose(),c.dispose(),R(Q)},Q=>{Z.dispose(),c.dispose(),D(Q)})});return new class{cancel(){c.cancel()}then(R,D){return I.then(R,D)}catch(R){return this.then(void 0,R)}finally(R){return I.finally(R)}}}e.$Ig=o;function u(M,c,v){return new Promise((I,R)=>{const D=c.onCancellationRequested(()=>{D.dispose(),I(v)});M.then(I,R).finally(()=>D.dispose())})}e.$Jg=u;function f(M,c){return new Promise((v,I)=>{const R=c.onCancellationRequested(()=>{R.dispose(),I(new k.$4)});M.then(v,I).finally(()=>R.dispose())})}e.$Kg=f;async function d(M){let c=-1;const v=M.map((I,R)=>I.then(D=>(c=R,D)));try{return await Promise.race(v)}finally{M.forEach((I,R)=>{R!==c&&I.cancel()})}}e.$Lg=d;function n(M,c,v){let I;const R=setTimeout(()=>{I?.(void 0),v?.()},c);return Promise.race([M.finally(()=>clearTimeout(R)),new Promise(D=>I=D)])}e.$Mg=n;function i(M){return new Promise((c,v)=>{const I=M();r(I)?I.then(c,v):c(I)})}e.$Ng=i;class h{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(c){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=c,!this.b){const v=()=>{if(this.b=null,this.f)return;const I=this.queue(this.d);return this.d=null,I};this.b=new Promise(I=>{this.a.then(v,v).then(I)})}return new Promise((v,I)=>{this.b.then(v,I)})}return this.a=c(),new Promise((v,I)=>{this.a.then(R=>{this.a=null,v(R)},R=>{this.a=null,I(R)})})}dispose(){this.f=!0}}e.$Og=h;class w{constructor(){this.a=Promise.resolve(null)}queue(c){return this.a=this.a.then(()=>c(),()=>c())}}e.$Pg=w;class C{constructor(){this.a=new Map}queue(c,v){const R=(this.a.get(c)??Promise.resolve()).catch(()=>{}).then(v).finally(()=>{this.a.get(c)===R&&this.a.delete(c)});return this.a.set(c,R),R}}e.$Qg=C;const B=(M,c)=>{let v=!0;const I=setTimeout(()=>{v=!1,c()},M);return{isTriggered:()=>v,dispose:()=>{clearTimeout(I),v=!1}}},F=M=>{let c=!0;return queueMicrotask(()=>{c&&(c=!1,M())}),{isTriggered:()=>c,dispose:()=>{c=!1}}};class S{constructor(c){this.defaultDelay=c,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(c,v=this.defaultDelay){this.g=c,this.h(),this.b||(this.b=new Promise((R,D)=>{this.d=R,this.f=D}).then(()=>{if(this.b=null,this.d=null,this.g){const R=this.g;return this.g=null,R()}}));const I=()=>{this.a=null,this.d?.(null)};return this.a=v===t.$Ld?F(I):B(v,I),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new k.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Rg=S;class ${constructor(c){this.a=new S(c),this.b=new h}trigger(c,v){return this.a.trigger(()=>this.b.queue(c),v)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Sg=$;class E{constructor(){this.a=!1,this.b=new Promise((c,v)=>{this.d=c})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Tg=E;class b extends E{constructor(c){super(),this.f=setTimeout(()=>this.open(),c)}open(){clearTimeout(this.f),super.open()}}e.$Ug=b;function O(M,c){return c?new Promise((v,I)=>{const R=setTimeout(()=>{D.dispose(),v()},M),D=c.onCancellationRequested(()=>{clearTimeout(R),D.dispose(),I(new k.$4)})}):o(v=>O(M,v))}e.$Vg=O;function L(M,c=0,v){const I=setTimeout(()=>{M(),v&&R.dispose()},c),R=(0,A.$Pc)(()=>{clearTimeout(I),v?.deleteAndLeak(R)});return v?.add(R),R}e.$Wg=L;function a(M,c,v){let I=0;const R=setInterval(()=>{I++,(I>=v||M())&&D.dispose()},c),D=(0,A.$Pc)(()=>{clearInterval(R)});return D}e.$Xg=a;function m(M){const c=[];let v=0;const I=M.length;function R(){return v<I?M[v++]():null}function D(Z){Z!=null&&c.push(Z);const Q=R();return Q?Q.then(D):Promise.resolve(c)}return Promise.resolve(null).then(D)}e.$Yg=m;function N(M,c=I=>!!I,v=null){let I=0;const R=M.length,D=()=>{if(I>=R)return Promise.resolve(v);const Z=M[I++];return Promise.resolve(Z()).then(J=>c(J)?Promise.resolve(J):D())};return D()}e.$Zg=N;function U(M,c=I=>!!I,v=null){if(M.length===0)return Promise.resolve(v);let I=M.length;const R=()=>{I=-1;for(const D of M)D.cancel?.()};return new Promise((D,Z)=>{for(const Q of M)Q.then(J=>{--I>=0&&c(J)?(R(),D(J)):I===0&&D(v)}).catch(J=>{--I>=0&&(R(),Z(J))})})}e.$1g=U;class T{constructor(c){this.a=0,this.d=c,this.f=[],this.b=0,this.g=new y.$Od}get onDrained(){return this.g.event}get size(){return this.a}queue(c){return this.a++,new Promise((v,I)=>{this.f.push({factory:c,c:v,e:I}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const c=this.f.shift();this.b++;const v=c.factory();v.then(c.c,c.e),v.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$2g=T;class g extends T{constructor(){super(1)}}e.$3g=g;class j{constructor(){this.a=new te,this.b=0}queue(c){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,c())):this.a.run(this.b++,c())}}e.$4g=j;class q{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const c=new x;return this.b.add(c),c.p}g(){for(const[,c]of this.a)if(c.size>0)return!1;return!0}queueFor(c,v=s.$mg){const I=v.getComparisonKey(c);let R=this.a.get(I);if(!R){R=new g;const D=this.f++,Z=y.Event.once(R.onDrained)(()=>{R?.dispose(),this.a.delete(I),this.h(),this.d?.deleteAndDispose(D),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new A.$Zc),this.d.set(D,Z),this.a.set(I,R)}return R}h(){this.g()&&this.j()}j(){for(const c of this.b)c.complete();this.b.clear()}dispose(){for(const[,c]of this.a)c.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$5g=q;class G{constructor(c,v){this.a=-1,typeof c=="function"&&typeof v=="number"&&this.setIfNotSet(c,v)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(c,v){this.cancel(),this.a=setTimeout(()=>{this.a=-1,c()},v)}setIfNotSet(c,v){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,c()},v))}}e.$6g=G;class H{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(c,v){this.cancel(),this.a=setInterval(()=>{c()},v)}}e.$7g=H;class V{constructor(c,v){this.b=-1,this.a=c,this.d=v,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(c=this.d){this.cancel(),this.b=setTimeout(this.f,c)}get delay(){return this.d}set delay(c){this.d=c}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$8g=V;class W{constructor(c,v){v%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${v}ms is not a multiple of 1000ms.`),this.a=c,this.b=v,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(c=this.b){c%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${c}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(c/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$9g=W;class K extends V{constructor(c,v){super(c,v),this.j=[]}work(c){this.j.push(c),this.isScheduled()||this.schedule()}h(){const c=this.j;this.j=[],this.a?.(c)}dispose(){this.j=[],super.dispose()}}e.$0g=K;class X extends A.$Rc{constructor(c,v){super(),this.g=c,this.h=v,this.a=[],this.b=this.B(new A.$Sc),this.f=!1}get pending(){return this.a.length}work(c){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+c.length>this.g.maxBufferedWork)return!1}else if(this.pending+c.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const v of c)this.a.push(v);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new V(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$$g=X,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$_g=(M,c)=>{(0,l.$B)(()=>{if(v)return;const I=Date.now()+15;c(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,I-Date.now())}}))});let v=!1;return{dispose(){v||(v=!0)}}}:e.$_g=(M,c,v)=>{const I=M.requestIdleCallback(c,typeof v=="number"?{timeout:v}:void 0);let R=!1;return{dispose(){R||(R=!0,M.cancelIdleCallback(I))}}},e.$ah=M=>(0,e.$_g)(globalThis,M)}();class ee{constructor(c,v){this.d=!1,this.a=()=>{try{this.f=v()}catch(I){this.g=I}finally{this.d=!0}},this.b=(0,e.$_g)(c,()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$bh=ee;class ae extends ee{constructor(c){super(globalThis,c)}}e.$ch=ae;async function he(M,c,v){let I;for(let R=0;R<v;R++)try{return await M()}catch(D){I=D,await O(c)}throw I}e.$dh=he;class te{isRunning(c){return typeof c=="number"?this.a?.taskId===c:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(c,v,I){return this.a={taskId:c,cancel:()=>I?.(),promise:v},v.then(()=>this.d(c),()=>this.d(c)),v}d(c){this.a&&c===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const c=this.b;this.b=void 0,c.run().then(c.promiseResolve,c.promiseReject)}}queue(c){if(this.b)this.b.run=c;else{let v,I;const R=new Promise((D,Z)=>{v=D,I=Z});this.b={run:c,promise:R,promiseResolve:v,promiseReject:I}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$eh=te;class oe{constructor(c,v=()=>Date.now()){this.d=c,this.f=v,this.a=0,this.b=0}increment(){const c=this.f();return c-this.a>this.d&&(this.a=c,this.b=0),this.b++,this.b}}e.$fh=oe;var ne;(function(M){M[M.Resolved=0]="Resolved",M[M.Rejected=1]="Rejected"})(ne||(ne={}));class x{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((c,v)=>{this.a=c,this.b=v})}complete(c){return new Promise(v=>{this.a(c),this.d={outcome:0,value:c},v()})}error(c){return new Promise(v=>{this.b(c),this.d={outcome:1,value:c},v()})}cancel(){return this.error(new k.$4)}}e.$gh=x;var ie;(function(M){async function c(I){let R;const D=await Promise.all(I.map(Z=>Z.then(Q=>Q,Q=>{R||(R=Q)})));if(typeof R<"u")throw R;return D}M.settled=c;function v(I){return new Promise(async(R,D)=>{try{await I(R,D)}catch(Z){D(Z)}})}M.withAsyncBody=v})(ie||(e.Promises=ie={}));var se;(function(M){M[M.Initial=0]="Initial",M[M.DoneOK=1]="DoneOK",M[M.DoneError=2]="DoneError"})(se||(se={}));class Y{static fromArray(c){return new Y(v=>{v.emitMany(c)})}static fromPromise(c){return new Y(async v=>{v.emitMany(await c)})}static fromPromises(c){return new Y(async v=>{await Promise.all(c.map(async I=>v.emitOne(await I)))})}static merge(c){return new Y(async v=>{await Promise.all(c.map(async I=>{for await(const R of I)v.emitOne(R)}))})}static{this.EMPTY=Y.fromArray([])}constructor(c){this.a=0,this.b=[],this.d=null,this.f=new y.$Od,queueMicrotask(async()=>{const v={emitOne:I=>this.g(I),emitMany:I=>this.h(I),reject:I=>this.k(I)};try{await Promise.resolve(c(v)),this.j()}catch(I){this.k(I)}finally{v.emitOne=void 0,v.emitMany=void 0,v.reject=void 0}})}[Symbol.asyncIterator](){let c=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(c<this.b.length)return{done:!1,value:this.b[c++]};if(this.a===1)return{done:!0,value:void 0};await y.Event.toPromise(this.f.event)}while(!0)}}}static map(c,v){return new Y(async I=>{for await(const R of c)I.emitOne(v(R))})}map(c){return Y.map(this,c)}static filter(c,v){return new Y(async I=>{for await(const R of c)v(R)&&I.emitOne(R)})}filter(c){return Y.filter(this,c)}static coalesce(c){return Y.filter(c,v=>!!v)}coalesce(){return Y.coalesce(this)}static async toPromise(c){const v=[];for await(const I of c)v.push(I);return v}toPromise(){return Y.toPromise(this)}g(c){this.a===0&&(this.b.push(c),this.f.fire())}h(c){this.a===0&&(this.b=this.b.concat(c),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(c){this.a===0&&(this.a=2,this.d=c,this.f.fire())}}e.$hh=Y;class re extends Y{constructor(c,v){super(v),this.l=c}cancel(){this.l.cancel()}}e.$ih=re;function ue(M){const c=new P.$Yd,v=M(c.token);return new re(c,async I=>{const R=c.token.onCancellationRequested(()=>{R.dispose(),c.dispose(),I.reject(new k.$4)});try{for await(const D of v){if(c.token.isCancellationRequested)return;I.emitOne(D)}R.dispose(),c.dispose()}catch(D){R.dispose(),c.dispose(),I.reject(D)}})}e.$jh=ue;class ce{constructor(){this.a=new x,this.b=new Y(I=>{if(c){I.reject(c);return}return v&&I.emitMany(v),this.d=R=>I.reject(R),this.f=R=>I.emitOne(R),this.a.p});let c,v;this.f=I=>{v||(v=[]),v.push(I)},this.d=I=>{c||(c=I)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(c){this.d(c),this.a.complete()}emitOne(c){this.f(c)}}e.$kh=ce}),define(p[20],_([0,1,34]),function(z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NB=e.$MB=e.$LB=void 0,e.$LB=new class{clone(){return this}equals(A){return this===A}};function k(A,s){return new P.$ft([new P.$et(0,"",A)],s)}e.$MB=k;function y(A,s){const l=new Uint32Array(2);return l[0]=0,l[1]=(A<<0|0<<8|0<<11|1<<15|2<<24)>>>0,new P.$gt(l,s===null?e.$LB:s)}e.$NB=y}),define(p[35],_([0,1,19,6,3,36,13,15,47,20,25,16,7]),function(z,e,P,k,y,A,s,l,t,r,o,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VB=e.$UB=e.$TB=e.$SB=e.$RB=e.$QB=void 0;var d;(function(S){S[S.CHEAP_TOKENIZATION_LENGTH_LIMIT=2048]="CHEAP_TOKENIZATION_LENGTH_LIMIT"})(d||(d={}));class n{constructor($,E){this.tokenizationSupport=E,this.a=this.tokenizationSupport.getInitialState(),this.store=new h($)}getStartState($){return this.store.getStartState($,this.a)}getFirstInvalidLine(){return this.store.getFirstInvalidLine(this.a)}}e.$QB=n;class i extends n{constructor($,E,b,O){super($,E),this._textModel=b,this._languageIdCodec=O}updateTokensUntilLine($,E){const b=this._textModel.getLanguageId();for(;;){const O=this.getFirstInvalidLine();if(!O||O.lineNumber>E)break;const L=this._textModel.getLineContent(O.lineNumber),a=B(this._languageIdCodec,b,this.tokenizationSupport,L,!0,O.startState);$.add(O.lineNumber,a.tokens),this.store.setEndState(O.lineNumber,a.endState)}}getTokenTypeIfInsertingCharacter($,E){const b=this.getStartState($.lineNumber);if(!b)return 0;const O=this._textModel.getLanguageId(),L=this._textModel.getLineContent($.lineNumber),a=L.substring(0,$.column-1)+E+L.substring($.column-1),m=B(this._languageIdCodec,O,this.tokenizationSupport,a,!0,b),N=new f.$$s(m.tokens,a,this._languageIdCodec);if(N.getCount()===0)return 0;const U=N.findTokenIndexAtOffset($.column-1);return N.getStandardTokenType(U)}tokenizeLineWithEdit($,E,b){const O=$.lineNumber,L=$.column,a=this.getStartState(O);if(!a)return null;const m=this._textModel.getLineContent(O),N=m.substring(0,L-1)+b+m.substring(L-1+E),U=this._textModel.getLanguageIdAtPosition(O,0),T=B(this._languageIdCodec,U,this.tokenizationSupport,N,!0,a);return new f.$$s(T.tokens,N,this._languageIdCodec)}isCheapToTokenize($){const E=this.store.getFirstInvalidEndStateLineNumberOrMax();return $<E||$===E&&this._textModel.getLineLength($)<2048}tokenizeHeuristically($,E,b){if(b<=this.store.getFirstInvalidEndStateLineNumberOrMax())return{heuristicTokens:!1};if(E<=this.store.getFirstInvalidEndStateLineNumberOrMax())return this.updateTokensUntilLine($,b),{heuristicTokens:!1};let O=this.b(E);const L=this._textModel.getLanguageId();for(let a=E;a<=b;a++){const m=this._textModel.getLineContent(a),N=B(this._languageIdCodec,L,this.tokenizationSupport,m,!0,O);$.add(a,N.tokens),O=N.endState}return{heuristicTokens:!0}}b($){let E=this._textModel.getLineFirstNonWhitespaceColumn($);const b=[];let O=null;for(let m=$-1;E>1&&m>=1;m--){const N=this._textModel.getLineFirstNonWhitespaceColumn(m);if(N!==0&&N<E&&(b.push(this._textModel.getLineContent(m)),E=N,O=this.getStartState(m),O))break}O||(O=this.tokenizationSupport.getInitialState()),b.reverse();const L=this._textModel.getLanguageId();let a=O;for(const m of b)a=B(this._languageIdCodec,L,this.tokenizationSupport,m,!1,a).endState;return a}}e.$RB=i;class h{constructor($){this.d=$,this.a=new w,this.b=new C,this.b.addRange(new t.$Es(1,$+1))}getEndState($){return this.a.getEndState($)}setEndState($,E){if(!E)throw new k.$bb("Cannot set null/undefined state");this.b.delete($);const b=this.a.setEndState($,E);return b&&$<this.d&&this.b.addRange(new t.$Es($+1,$+2)),b}acceptChange($,E){this.d+=E-$.length,this.a.acceptChange($,E),this.b.addRangeAndResize(new t.$Es($.startLineNumber,$.endLineNumberExclusive),E)}acceptChanges($){for(const E of $){const[b]=(0,s.$0s)(E.text);this.acceptChange(new l.$Gs(E.range.startLineNumber,E.range.endLineNumber+1),b+1)}}invalidateEndStateRange($){this.b.addRange(new t.$Es($.startLineNumber,$.endLineNumberExclusive))}getFirstInvalidEndStateLineNumber(){return this.b.min}getFirstInvalidEndStateLineNumberOrMax(){return this.getFirstInvalidEndStateLineNumber()||Number.MAX_SAFE_INTEGER}allStatesValid(){return this.b.min===null}getStartState($,E){return $===1?E:this.getEndState($-1)}getFirstInvalidLine($){const E=this.getFirstInvalidEndStateLineNumber();if(E===null)return null;const b=this.getStartState(E,$);if(!b)throw new k.$bb("Start state must be defined");return{lineNumber:E,startState:b}}}e.$SB=h;class w{constructor(){this.a=new o.$OB(null)}getEndState($){return this.a.get($)}setEndState($,E){const b=this.a.get($);return b&&b.equals(E)?!1:(this.a.set($,E),!0)}acceptChange($,E){let b=$.length;E>0&&b>0&&(b--,E--),this.a.replace($.startLineNumber,b,E)}acceptChanges($){for(const E of $){const[b]=(0,s.$0s)(E.text);this.acceptChange(new l.$Gs(E.range.startLineNumber,E.range.endLineNumber+1),b+1)}}}e.$TB=w;class C{constructor(){this.a=[]}getRanges(){return this.a}get min(){return this.a.length===0?null:this.a[0].start}removeMin(){if(this.a.length===0)return null;const $=this.a[0];return $.start+1===$.endExclusive?this.a.shift():this.a[0]=new t.$Es($.start+1,$.endExclusive),$.start}delete($){const E=this.a.findIndex(b=>b.contains($));if(E!==-1){const b=this.a[E];b.start===$?b.endExclusive===$+1?this.a.splice(E,1):this.a[E]=new t.$Es($+1,b.endExclusive):b.endExclusive===$+1?this.a[E]=new t.$Es(b.start,$):this.a.splice(E,1,new t.$Es(b.start,$),new t.$Es($+1,b.endExclusive))}}addRange($){t.$Es.addRange($,this.a)}addRangeAndResize($,E){let b=0;for(;!(b>=this.a.length||$.start<=this.a[b].endExclusive);)b++;let O=b;for(;!(O>=this.a.length||$.endExclusive<this.a[O].start);)O++;const L=E-$.length;for(let a=O;a<this.a.length;a++)this.a[a]=this.a[a].delta(L);if(b===O){const a=new t.$Es($.start,$.start+E);a.isEmpty||this.a.splice(b,0,a)}else{const a=Math.min($.start,this.a[b].start),m=Math.max($.endExclusive,this.a[O-1].endExclusive),N=new t.$Es(a,m+L);N.isEmpty?this.a.splice(b,O-b):this.a.splice(b,O-b,N)}}toString(){return this.a.map($=>$.toString()).join(" + ")}}e.$UB=C;function B(S,$,E,b,O,L){let a=null;if(E)try{a=E.tokenizeEncoded(b,O,L.clone())}catch(m){(0,k.$Z)(m)}return a||(a=(0,r.$NB)(S.encodeLanguageId($),L)),f.$$s.convertToEndOffset(a.tokens,b.length),a}class F{constructor($,E){this.b=$,this.d=E,this.a=!1,this.f=!1}dispose(){this.a=!0}handleChanges(){this.g()}g(){this.f||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.f=!0,(0,P.$ah)($=>{this.f=!1,this.h($)}))}h($){const E=Date.now()+$.timeRemaining(),b=()=>{this.a||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.j(),Date.now()<E?(0,y.$B)(b):this.g())};b()}j(){const $=this.b._textModel.getLineCount(),E=new u.$PB,b=A.$Kd.create(!1);do if(b.elapsed()>1||this.l(E)>=$)break;while(this.k());this.d.setTokens(E.finalize()),this.checkFinished()}k(){return this.b?!this.b.store.allStatesValid():!1}l($){const E=this.b?.getFirstInvalidLine();return E?(this.b.updateTokensUntilLine($,E.lineNumber),E.lineNumber):this.b._textModel.getLineCount()+1}checkFinished(){this.a||this.b.store.allStatesValid()&&this.d.backgroundTokenizationFinished()}requestTokens($,E){this.b.store.invalidateEndStateRange(new l.$Gs($,E))}}e.$VB=F}),define(p[37],_([0,1,33,2,36,14,34]),function(z,e,P,k,y,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_Eb=void 0;class l extends k.$Rc{constructor(r,o,u,f,d,n,i){super(),this.c=r,this.f=o,this.g=u,this.h=f,this.j=d,this.m=n,this.n=i,this.a=[],this.b=this.B(new P.$Od),this.onDidEncounterLanguage=this.b.event}get backgroundTokenizerShouldOnlyVerifyTokens(){return this.j()}getInitialState(){return this.f}tokenize(r,o,u){throw new Error("Not supported!")}createBackgroundTokenizer(r,o){if(this.h)return this.h(r,o)}tokenizeEncoded(r,o,u){const f=Math.random()*1e4<1,d=this.n||f,n=d?new y.$Kd(!0):void 0,i=this.c.tokenizeLine2(r,u,500);if(d){const w=n.elapsed();(f||w>32)&&this.m(w,r.length,f)}if(i.stoppedEarly)return console.warn(`Time limit reached when tokenizing line: ${r.substring(0,100)}`),new s.$gt(i.tokens,u);if(this.g){const w=this.a,C=i.tokens;for(let B=0,F=C.length>>>1;B<F;B++){const S=C[(B<<1)+1],$=A.$8s.getLanguageId(S);w[$]||(w[$]=!0,this.b.fire($))}}let h;return u.equals(i.ruleStack)?h=u:h=i.ruleStack,new s.$gt(i.tokens,h)}}e.$_Eb=l}),define(p[38],_([0,1,20,2,11]),function(z,e,P,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aFb=void 0;class A extends k.$Rc{get backgroundTokenizerShouldOnlyVerifyTokens(){return this.b.backgroundTokenizerShouldOnlyVerifyTokens}constructor(l,t,r){super(),this.a=l,this.b=t,this.c=r,this.B((0,y.keepObserved)(this.c))}getInitialState(){return this.b.getInitialState()}tokenize(l,t,r){throw new Error("Not supported!")}tokenizeEncoded(l,t,r){return l.length>=this.c.get()?(0,P.$NB)(this.a,r):this.b.tokenizeEncoded(l,t,r)}createBackgroundTokenizer(l,t){if(this.b.createBackgroundTokenizer)return this.b.createBackgroundTokenizer(l,t)}}e.$aFb=A}),define(p[39],_([0,1,32,19,11,3,15,48,35,16,7,37,38]),function(z,e,P,k,y,A,s,l,t,r,o,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fFb=void 0;class d extends l.$Zu{constructor(h,w,C,B,F,S,$,E){super(h,w,C,B),this.s=F,this.t=S,this.u=$,this.a=null,this.b=!1,this.c=(0,y.observableValue)(this,-1),this.q=new k.$8g(()=>this.w(),10),this.c.set(E,void 0),this.v()}dispose(){this.b=!0,super.dispose()}onLanguageId(h,w){this.t=h,this.u=w,this.v()}onEvents(h){super.onEvents(h),this.a?.store.acceptChanges(h.changes),this.q.schedule()}acceptMaxTokenizationLineLength(h){this.c.set(h,void 0)}retokenize(h,w){this.a&&(this.a.store.invalidateEndStateRange(new s.$Gs(h,w)),this.q.schedule())}async v(){this.a=null;const h=this.t,w=this.u,C=await this.s.getOrCreateGrammar(h,w);if(!(this.b||h!==this.t||w!==this.u||!C)){if(C.grammar){const B=new f.$aFb(this.u,new u.$_Eb(C.grammar,C.initialState,!1,void 0,()=>!1,(F,S,$)=>{this.s.reportTokenizationTime(F,h,C.sourceExtensionId,S,$)},!1),this.c);this.a=new t.$QB(this.f.length,B)}else this.a=null;this.w()}}async w(){if(this.b||!this.a)return;if(!this.m){const{diffStateStacksRefEq:w}=await(0,P.$LC)("vscode-textmate","release/main.js");this.m=w}const h=new Date().getTime();for(;;){let w=0;const C=new r.$PB,B=new n;for(;;){const $=this.a.getFirstInvalidLine();if($===null||w>200)break;w++;const E=this.f[$.lineNumber-1],b=this.a.tokenizationSupport.tokenizeEncoded(E,!0,$.startState);if(this.a.store.setEndState($.lineNumber,b.endState)){const L=this.m($.startState,b.endState);B.setState($.lineNumber,L)}else B.setState($.lineNumber,null);if(o.$$s.convertToEndOffset(b.tokens,E.length),C.add($.lineNumber,b.tokens),new Date().getTime()-h>20)break}if(w===0)break;const F=B.getStateDeltas();if(this.s.setTokensAndStates(this.h,C.serialize(),F),new Date().getTime()-h>20){(0,A.$B)(()=>this.w());return}}}}e.$fFb=d;class n{constructor(){this.a=-1,this.b=[]}setState(h,w){h===this.a+1?this.b[this.b.length-1].stateDeltas.push(w):this.b.push({startLineNumber:h,stateDeltas:[w]}),this.a=h}getStateDeltas(){return this.b}}}),define(p[40],_([0,1,18]),function(z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cFb=void 0;class k{constructor(){this.a=Object.create(null)}reset(){this.a=Object.create(null)}register(A){if(this.a[A.scopeName]){const s=this.a[A.scopeName];P.$pg(s.location,A.location)||console.warn(`Overwriting grammar scope name to file mapping for scope ${A.scopeName}.
Old grammar file: ${s.location.toString()}.
New grammar file: ${A.location.toString()}`)}this.a[A.scopeName]=A}getGrammarDefinition(A){return this.a[A]||null}}e.$cFb=k}),define(p[41],_([0,1,2,40]),function(z,e,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eFb=e.$dFb=void 0,e.$dFb="No TM Grammar registered for this language.";class y extends P.$Rc{constructor(s,l,t,r){super(),this.a=s,this.b=t.INITIAL,this.c=new k.$cFb,this.f={},this.g={},this.h=new Map,this.j=this.B(new t.Registry({onigLib:r,loadGrammar:async o=>{const u=this.c.getGrammarDefinition(o);if(!u)return this.a.logTrace(`No grammar found for scope ${o}`),null;const f=u.location;try{const d=await this.a.readFile(f);return t.parseRawGrammar(d,f.path)}catch(d){return this.a.logError(`Unable to load and parse grammar for scope ${o} from ${f}`,d),null}},getInjections:o=>{const u=o.split(".");let f=[];for(let d=1;d<=u.length;d++){const n=u.slice(0,d).join(".");f=[...f,...this.f[n]||[]]}return f}}));for(const o of l){if(this.c.register(o),o.injectTo){for(const u of o.injectTo){let f=this.f[u];f||(this.f[u]=f=[]),f.push(o.scopeName)}if(o.embeddedLanguages)for(const u of o.injectTo){let f=this.g[u];f||(this.g[u]=f=[]),f.push(o.embeddedLanguages)}}o.language&&this.h.set(o.language,o.scopeName)}}has(s){return this.h.has(s)}setTheme(s,l){this.j.setTheme(s,l)}getColorMap(){return this.j.getColorMap()}async createGrammar(s,l){const t=this.h.get(s);if(typeof t!="string")throw new Error(e.$dFb);const r=this.c.getGrammarDefinition(t);if(!r)throw new Error(e.$dFb);const o=r.embeddedLanguages;if(this.g[t]){const d=this.g[t];for(const n of d)for(const i of Object.keys(n))o[i]=n[i]}const u=Object.keys(o).length>0;let f;try{f=await this.j.loadGrammarWithConfiguration(t,l,{embeddedLanguages:o,tokenTypes:r.tokenTypes,balancedBracketSelectors:r.balancedBracketSelectors,unbalancedBracketSelectors:r.unbalancedBracketSelectors})}catch(d){throw d.message&&d.message.startsWith("No grammar provided for")?new Error(e.$dFb):d}return{languageId:s,grammar:f,initialState:this.b,containsEmbeddedLanguages:u,sourceExtensionId:r.sourceExtensionId}}}e.$eFb=y}),define(p[49],_([0,1,8,41,39]),function(z,e,P,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationWorker=e.create=void 0;function A(l,t){return new s(l,t)}e.create=A;class s{constructor(t,r){this.f=r,this.b=new Map,this.c=[],this.a=t.host;const o=r.grammarDefinitions.map(u=>({location:P.URI.revive(u.location),language:u.language,scopeName:u.scopeName,embeddedLanguages:u.embeddedLanguages,tokenTypes:u.tokenTypes,injectTo:u.injectTo,balancedBracketSelectors:u.balancedBracketSelectors,unbalancedBracketSelectors:u.unbalancedBracketSelectors,sourceExtensionId:u.sourceExtensionId}));this.d=this.g(o)}async g(t){const r=this.f.textmateMainUri,o=await new Promise((i,h)=>{z([r],i,h)}),u=await new Promise((i,h)=>{z([this.f.onigurumaMainUri],i,h)}),d=await(await fetch(this.f.onigurumaWASMUri)).arrayBuffer();await u.loadWASM(d);const n=Promise.resolve({createOnigScanner:i=>u.createOnigScanner(i),createOnigString:i=>u.createOnigString(i)});return new k.$eFb({logTrace:i=>{},logError:(i,h)=>console.error(i,h),readFile:i=>this.a.readFile(i)},t,o,n)}acceptNewModel(t){const r=P.URI.revive(t.uri),o=this;this.b.set(t.controllerId,new y.$fFb(r,t.lines,t.EOL,t.versionId,{async getOrCreateGrammar(u,f){const d=await o.d;return d?(o.c[f]||(o.c[f]=d.createGrammar(u,f)),o.c[f]):Promise.resolve(null)},setTokensAndStates(u,f,d){o.a.setTokensAndStates(t.controllerId,u,f,d)},reportTokenizationTime(u,f,d,n,i){o.a.reportTokenizationTime(u,f,d,n,i)}},t.languageId,t.encodedLanguageId,t.maxTokenizationLineLength))}acceptModelChanged(t,r){this.b.get(t).onEvents(r)}retokenize(t,r,o){this.b.get(t).retokenize(r,o)}acceptModelLanguageChanged(t,r,o){this.b.get(t).onLanguageId(r,o)}acceptRemovedModel(t){const r=this.b.get(t);r&&(r.dispose(),this.b.delete(t))}async acceptTheme(t,r){(await this.d)?.setTheme(t,r)}acceptMaxTokenizationLineLength(t,r){this.b.get(t).acceptMaxTokenizationLineLength(r)}}e.TextMateTokenizationWorker=s})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/072c6b950b8822560c55eff1474c30951e2ab9c9/core/vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker.js.map
